# Revised NGC and IC Catalog, Wolfgang Steinicke, April 5, 2005
# http://www.ngcic.org/steinicke/default.htm
#
# Augmented by
# Revised 3rd Reference Catalog of Bright Galaxies (RC3,VII/155)
# http://cdsweb.u-strasbg.fr/viz-bin/Cat?VII/155
#
# Augmented by
# Mark III Catalog of Galaxy Peculiar Velocities (Willick+ 1997,VII/198)
# http://cdsweb.u-strasbg.fr/viz-bin/Cat?VII/198#sRM2.18
#
# Augmented by distances from
# The SBF Survey of Galaxy Distances. IV.
# SBF Magnitudes, Colors, and Distances, 
# J.L. Tonry et al., Astrophys J 546, 681 (2001)
#
# Augmented by distances from
# Compilation of "200 Brightest Galaxies"
# http://www.anzwers.org/free/universe/galax200.html
#
# Using today's Hubble constant = 72 [km/sec/Mpc]  (WMAP 2005)
#
# Abreviations for various distance methods used:
# S= SBF (Surface Brightness Fluctuations), T-F= Tully-Fischer
# V = rad. velocity in CMB frame & Hubble law 
# C=Cepheids, P=photometric, N(G)=planetary nebula (globular cluster) luminosity function
#
# Adapted for Celestia with Perl script: deepsky.pl Revision: 1.20 
# Processed 2006-1-3 2 2 0 21:19:26 UTC
#
# by Dr. Fridger Schrempp, fridger.schrempp@desy.de
# ------------------------------------------------------ 


Galaxy "NGC 1:UGC 57:MCG 4-1-25:ZWG 477.54"
{
        Type  "Sb"
        RA            0.1208
        Dec          27.7089
        Distance   2.073e+08  # method: T-F
        Radius     5.127e+04
        AbsMag        -20.42
        Axis    [  0.0781   0.9082  -0.4112]
        Angle    197.1490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1"
}

Galaxy "NGC 2:UGC 59:MCG 4-1-26:ZWG 477.55"
{
        Type  "Sb"
        RA            0.1214
        Dec          27.6786
        Distance   3.376e+08  # method: T-F
        Radius     4.911e+04
        AbsMag        -20.07
        Axis    [  0.0198   0.9315  -0.3633]
        Angle    189.8103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2"
}

Galaxy "NGC 3:UGC 58:MCG 1-1-37:ZWG 408.35"
{
        Type  "S0"
        RA            0.1211
        Dec           8.3014
        Distance   1.608e+08  # method: V
        Radius     2.572e+04
        AbsMag        -19.06
        Axis    [  0.1555   0.9159  -0.3700]
        Angle    188.5756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3"
}

Galaxy "NGC 4"
{
        Type  "S0"
        RA            0.1233
        Dec           8.3739
        Distance   5.098e+08  # distance uncertain!
        Radius     4.449e+04
        AbsMag        -19.07
        Axis    [  0.1625   0.9532   0.2550]
        Angle    166.6854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4"
}

Galaxy "NGC 5:UGC 62:MCG 6-1-13:ZWG 517.17"
{
        Type  "E0"
        RA            0.1300
        Dec          35.3628
        Distance   3.163e+08  # distance uncertain!
        Radius      5.52e+04
        AbsMag        -20.13
        Axis    [  0.4157   0.8614  -0.2919]
        Angle    210.6705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5"
}

Galaxy "NGC 7:ESO 409-22:MCG 5-1-37:AM 0005-301"
{
        Type  "SBc"
        RA            0.1389
        Dec         -29.9164
        Distance   7.765e+07  # method: T-F
        Radius     2.484e+04
        AbsMag        -17.78
        Axis    [  0.2321   0.9204   0.3147]
        Angle    197.4218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7"
}

Galaxy "NGC 9:UGC 78:MCG 4-1-30:ZWG 477.59"
{
        Type  "Sb"
        RA            0.1483
        Dec          23.8178
        Distance   1.538e+08  # method: T-F
        Radius     2.461e+04
        AbsMag        -18.87
        Axis    [  0.0225   0.7569  -0.6532]
        Angle    209.8479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 9"
}

Galaxy "NGC 10:ESO 349-32:MCG 6-1-24:AM 0006-340"
{
        Type  "SBc"
        RA            0.1428
        Dec         -33.8578
        Distance   2.909e+08  # method: T-F
        Radius     1.015e+05
        AbsMag        -21.65
        Axis    [  0.4139   0.8354   0.3617]
        Angle    193.0380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 10"
}

Galaxy "NGC 11:UGC 73:MCG 6-1-15:ZWG 517.20"
{
        Type  "Sa"
        RA            0.1450
        Dec          37.4481
        Distance   1.768e+08  # distance uncertain!
        Radius     3.857e+04
        AbsMag        -19.07
        Axis    [ -0.3206   0.8792  -0.3525]
        Angle    177.1576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 11"
}

Galaxy "NGC 12:UGC 74:MCG 1-1-40:ZWG 408.38"
{
        Type  "SBc"
        RA            0.1456
        Dec           4.6122
        Distance   1.626e+08  # method: V
        Radius     2.601e+04
        AbsMag        -19.49
        Axis    [  0.4243   0.7925  -0.4380]
        Angle    207.4736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 12"
}

Galaxy "NGC 13:UGC 77:MCG 5-1-34:ZWG 498.81"
{
        Type  "Sb"
        RA            0.1464
        Dec          33.4331
        Distance   2.153e+08  # method: T-F
        Radius     7.203e+04
        AbsMag           -20
        Axis    [ -0.1847   0.9766   0.1103]
        Angle    160.7278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 13"
}

Galaxy "NGC 14:UGC 75:MCG 3-1-26:ZWG 456.34"
{
        Type  "Irr"
        RA            0.1461
        Dec          15.8158
        Distance   2.351e+07  # method: V
        Radius          9575
        AbsMag        -16.49
        Axis    [  0.2794   0.9140   0.2942]
        Angle    152.7668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 14"
}

Galaxy "NGC 15:UGC 82:MCG 3-1-27:ZWG 456.35"
{
        Type  "Sa"
        RA            0.1506
        Dec          21.6250
        Distance   2.715e+08  # method: V
        Radius     3.949e+04
        AbsMag         -19.8
        Axis    [  0.1401   0.9534   0.2672]
        Angle    154.5411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 15"
}

Galaxy "NGC 16:UGC 80:MCG 4-1-32:ZWG 477.61"
{
        Type  "S0"
        RA            0.1511
        Dec          27.7300
        Distance   1.237e+08  # method: V
        Radius     3.238e+04
        AbsMag        -19.89
        Axis    [  0.0833   0.9239   0.3736]
        Angle    146.1349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 16"
}

Galaxy "NGC 17:NGC 34:MCG 2-1-32:MK 938"
{
        Type  "S0"
        RA            0.1850
        Dec         -12.1078
        Distance   2.525e+08  # method: V
        Radius     7.711e+04
        AbsMag        -19.14
        Axis    [  0.2279   0.9218   0.3137]
        Angle    180.8864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 17"
}

Galaxy "NGC 19:UGC 98:MCG 5-1-46:ZWG 499.65"
{
        Type  "SBc"
        RA            0.1778
        Dec          32.9828
        Distance   2.181e+08  # method: T-F
        Radius      3.49e+04
        AbsMag        -20.03
        Axis    [  0.0174   0.9864   0.1636]
        Angle    153.4652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 19"
}

Galaxy "NGC 20:NGC 6:UGC 84:MCG 5-1-36"
{
        Type  "S0"
        RA            0.1589
        Dec          33.3089
        Distance    2.15e+08  # method: V
        Radius     5.316e+04
        AbsMag        -19.99
        Axis    [  0.2010   0.8545  -0.4791]
        Angle    221.1568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 20"
}

Galaxy "NGC 22:UGC 86:MCG 5-1-39:ZWG 499.55"
{
        Type  "Sb"
        RA            0.1633
        Dec          27.8328
        Distance   3.618e+08  # method: V
        Radius      6.84e+04
        AbsMag        -20.62
        Axis    [  0.0558   0.7517  -0.6571]
        Angle    220.5093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 22"
}

Galaxy "NGC 23:UGC 89:MCG 4-1-33:MK 545"
{
        Type  "SBa"
        RA            0.1647
        Dec          25.9239
        Distance   2.128e+08  # method: T-F
        Radius     6.499e+04
        AbsMag        -21.27
        Axis    [  0.1392   0.8933   0.4274]
        Angle    142.3865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 23"
}

Galaxy "NGC 24:ESO 472-16:MCG 4-1-18:UGCA 2"
{
        Type  "Sc"
        RA            0.1656
        Dec         -24.9644
        Distance   3.633e+07  # method: T-F
        Radius     3.065e+04
        AbsMag        -18.03
        Axis    [  0.2170   0.9607   0.1730]
        Angle    191.2471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 24"
}

Galaxy "NGC 25:ESO 149-19:FAIR 1:AM 0007-571"
{
        Type  "S0"
        RA            0.1664
        Dec         -57.0203
        Distance   4.199e+08  # method: V
        Radius     8.551e+04
        AbsMag        -21.95
        Axis    [  0.6830   0.7156  -0.1464]
        Angle    194.7706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 25"
}

Galaxy "NGC 26:UGC 94:MCG 4-1-34:ZWG 477.64"
{
        Type  "Sb"
        RA            0.1736
        Dec          25.8322
        Distance   2.155e+08  # method: T-F
        Radius     6.582e+04
        AbsMag         -20.4
        Axis    [  0.0926   0.9565  -0.2766]
        Angle    184.9164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 26"
}

Galaxy "NGC 27:UGC 96:MCG 5-1-44:ZWG 499.63"
{
        Type  "Sb"
        RA            0.1756
        Dec          28.9969
        Distance   3.154e+08  # method: T-F
        Radius     5.505e+04
        AbsMag        -20.43
        Axis    [ -0.1034   0.9086  -0.4046]
        Angle    186.0316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 27"
}

Galaxy "NGC 28:AM 0007-571"
{
        Type  "E1"
        RA            0.1736
        Dec         -56.9889
        Distance   3.163e+08  # distance uncertain!
        Radius      3.68e+04
        AbsMag        -20.13
        Axis    [  0.9196   0.2250  -0.3221]
        Angle    209.0624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 28"
}

Galaxy "NGC 29:NGC 21:UGC 100:MCG 5-1-48"
{
        Type  "SBc"
        RA            0.1797
        Dec          33.3519
        Distance   2.387e+08  # method: T-F
        Radius     5.208e+04
        AbsMag        -20.72
        Axis    [ -0.1387   0.7534  -0.6428]
        Angle    203.6481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 29"
}

Galaxy "NGC 31:ESO 149-20:AM 0007-571"
{
        Type  "Sc"
        RA            0.1772
        Dec         -56.9861
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [  0.4853   0.6913   0.5353]
        Angle    209.9998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 31"
}

Galaxy "NGC 35:MCG 2-1-33:NPM 1:IRAS 00086-1217"
{
        Type  "Sb"
        RA            0.1861
        Dec         -12.0206
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.3870   0.7422  -0.5472]
        Angle    198.1668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 35"
}

Galaxy "NGC 36:UGC 106:MCG 1-1-43:ZWG 408.40"
{
        Type  "SBb"
        RA            0.1894
        Dec           6.3889
        Distance   2.608e+08  # method: V
        Radius     8.343e+04
        AbsMag        -20.41
        Axis    [  0.1797   0.9115   0.3699]
        Angle    163.9564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 36"
}

Galaxy "NGC 37:ESO 149-22:AM 0007-571"
{
        Type  "S0"
        RA            0.1897
        Dec         -56.9569
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.6342   0.7087   0.3091]
        Angle    203.3918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 37"
}

Galaxy "NGC 38:MCG 1-1-47"
{
        Type  "Sa"
        RA            0.1964
        Dec          -5.5864
        Distance    1.47e+08  # distance uncertain!
        Radius     2.994e+04
        AbsMag        -19.07
        Axis    [  0.5773   0.8097  -0.1055]
        Angle    186.2238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 38"
}

Galaxy "NGC 39:UGC 114:MCG 5-1-52:ZWG 499.76"
{
        Type  "Sc"
        RA            0.2050
        Dec          31.0608
        Distance   2.057e+08  # method: V
        Radius      3.29e+04
        AbsMag         -19.7
        Axis    [  0.2181   0.8990  -0.3799]
        Angle    204.2696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 39"
}

Galaxy "NGC 41:MCG 4-1-39:ZWG 478.42:KUG 0010+217"
{
        Type  "Sc"
        RA            0.2133
        Dec          22.0239
        Distance   2.813e+08  # method: T-F
        Radius     3.273e+04
        AbsMag        -20.08
        Axis    [  0.0713   0.8923  -0.4458]
        Angle    194.2548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 41"
}

Galaxy "NGC 42:UGC 118:MCG 4-1-41:ZWG 478.43"
{
        Type  "S0"
        RA            0.2156
        Dec          22.1008
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.0324   0.9191  -0.3927]
        Angle    188.3154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 42"
}

Galaxy "NGC 43:UGC 120:MCG 5-1-54:ZWG 499.79"
{
        Type  "S0"
        RA            0.2167
        Dec          30.9156
        Distance   2.024e+08  # method: V
        Radius      4.71e+04
        AbsMag        -20.26
        Axis    [  0.3778   0.8885   0.2605]
        Angle    130.7731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 43"
}

Galaxy "NGC 45:ESO 473-1:MCG 4-1-21:UGCA 4"
{
        Type  "SBc"
        RA            0.2344
        Dec         -23.1814
        Distance   4.725e+07  # method: T-F
        Radius     5.841e+04
        AbsMag         -19.5
        Axis    [  0.4417   0.6671  -0.5999]
        Angle    195.0738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 45"
}

Galaxy "NGC 47:NGC 58:MCG 1-1-55:IRAS 00119-0726"
{
        Type  "SBc"
        RA            0.2417
        Dec          -7.1678
        Distance   2.429e+08  # method: V
        Radius     8.126e+04
        AbsMag        -20.46
        Axis    [  0.5723   0.8119  -0.1157]
        Angle    186.3011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 47"
}

Galaxy "NGC 48:UGC 133:MCG 8-1-31:ZWG 549.27"
{
        Type  "SBc"
        RA            0.2339
        Dec          48.2350
        Distance   6.872e+07  # method: V
        Radius     1.599e+04
        AbsMag        -16.92
        Axis    [  0.0056   0.9454   0.3259]
        Angle    128.6883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 48"
}

Galaxy "NGC 49:UGC 136:MCG 8-1-33:ZWG 549.29"
{
        Type  "S0"
        RA            0.2394
        Dec          48.2472
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.0172   0.8154  -0.5787]
        Angle    237.4948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 49"
}

Galaxy "NGC 50:MCG 1-1-58"
{
        Type  "S0"
        RA            0.2456
        Dec          -7.3450
        Distance   9.715e+07  # distance uncertain!
        Radius     3.391e+04
        AbsMag        -19.07
        Axis    [  0.2801   0.5719  -0.7711]
        Angle    208.1274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 50"
}

Galaxy "NGC 51:UGC 138:MCG 8-1-35:ZWG 549.31"
{
        Type  "S0"
        RA            0.2428
        Dec          48.2561
        Distance    1.47e+08  # distance uncertain!
        Radius      2.78e+04
        AbsMag        -19.07
        Axis    [  0.0993   0.9651   0.2422]
        Angle    128.0231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 51"
}

Galaxy "NGC 52:UGC 140:MCG 3-1-30:ZWG 456.42"
{
        Type  "Sc"
        RA            0.2444
        Dec          18.5817
        Distance   2.288e+08  # method: V
        Radius     7.322e+04
        AbsMag        -19.83
        Axis    [ -0.1640   0.8550  -0.4920]
        Angle    178.5904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 52"
}

Galaxy "NGC 53:ESO 111-20:FAIR 3:AM 0012-603"
{
        Type  "SBb"
        RA            0.2453
        Dec         -60.3286
        Distance   2.006e+08  # method: V
        Radius     5.836e+04
        AbsMag        -20.44
        Axis    [  0.5742   0.3336  -0.7477]
        Angle    178.4305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 53"
}

Galaxy "NGC 54:MCG 1-1-60"
{
        Type  "Sa"
        RA            0.2519
        Dec          -7.1067
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.2062   0.9509  -0.2308]
        Angle    181.3781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 54"
}

Galaxy "NGC 55:ESO 293-50:MCG 7-1-13"
{
        Type  "Irr"
        RA            0.2522
        Dec         -39.2194
        Distance     4.9e+06  # method: P
        Radius     2.224e+04
        AbsMag        -17.47
        Axis    [  0.3366   0.8768  -0.3435]
        Angle    178.2645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 55"
}

Galaxy "NGC 57:UGC 145:MCG 3-1-31:ZWG 456.46"
{
        Type  "E0"
        RA            0.2583
        Dec          17.3292
        Distance   2.309e+08  # method: V
        Radius      7.39e+04
        AbsMag        -21.45
        Axis    [  0.6273   0.7742   0.0840]
        Angle    151.4480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 57"
}

Galaxy "NGC 59:ESO 539-4:MCG 4-1-26:KDWG 2"
{
        Type  "S0"
        RA            0.2569
        Dec         -21.4447
        Distance    8.86e+07  # distance uncertain!
        Radius      3.35e+04
        AbsMag        -19.07
        Axis    [  0.3592   0.7877  -0.5005]
        Angle    186.2118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 59"
}

Galaxy "NGC 60:UGC 150:MCG 0-1-48:ZWG 382.37"
{
        Type  "Sc"
        RA            0.2661
        Dec          -0.3036
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.3941   0.6519  -0.6479]
        Angle    219.7989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 60"
}

Galaxy "NGC 61-1:NGC 61A:MCG 1-1-62:VV 742"
{
        Type  "S0"
        RA            0.2733
        Dec          -6.3172
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.3432   0.8719   0.3492]
        Angle    169.0051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 61-1"
}

Galaxy "NGC 61-2:NGC 61B:MCG 1-1-63:VV 742"
{
        Type  "S0"
        RA            0.2733
        Dec          -6.3222
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.2449   0.9692   0.0269]
        Angle    178.4015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 61-2"
}

Galaxy "NGC 62:MCG 2-1-43:IRAS 00145-1345"
{
        Type  "Sa"
        RA            0.2847
        Dec         -13.4864
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.4127   0.7518  -0.5142]
        Angle    196.1794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 62"
}

Galaxy "NGC 63:UGC 167:MCG 2-1-30:ZWG 433.42"
{
        Type  "S0"
        RA            0.2958
        Dec          11.4500
        Distance   6.102e+07  # method: S
        Radius     1.509e+04
        AbsMag        -18.66
        Axis    [  0.2330   0.9101  -0.3426]
        Angle    189.2425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 63"
}

Galaxy "NGC 64:MCG 1-1-68:IRAS 00149-0706"
{
        Type  "SBc"
        RA            0.2917
        Dec          -6.8250
        Distance   1.341e+08  # distance uncertain!
        Radius     3.121e+04
        AbsMag        -19.07
        Axis    [  0.3923   0.8921   0.2243]
        Angle    171.5589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 64"
}

Galaxy "NGC 65:ESO 473-10A:MCG 4-2-1"
{
        Type  "S0"
        RA            0.3161
        Dec         -22.8800
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.4891   0.7091   0.5080]
        Angle    170.6811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 65"
}

Galaxy "NGC 66:ESO 473-10:MCG 4-2-2:AM 0016-231"
{
        Type  "SBb"
        RA            0.3178
        Dec         -22.9364
        Distance   3.291e+08  # method: V
        Radius     5.743e+04
        AbsMag        -20.82
        Axis    [  0.4213   0.8562   0.2991]
        Angle    182.2322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 66"
}

Galaxy "NGC 67:MCG 5-1-64:ZWG 499.104:ARAK 4"
{
        Type  "E0"
        RA            0.3039
        Dec          30.0633
        Distance   2.956e+08  # method: V
        Radius      1.29e+04
        AbsMag        -18.99
        Axis    [  0.5456   0.8378  -0.0191]
        Angle    154.8394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 67"
}

Galaxy "NGC 67A:ARP 113:VV 166"
{
        Type  "E5"
        RA            0.3033
        Dec          30.0553
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.4817   0.8428  -0.2401]
        Angle    196.2098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 67A"
}

Galaxy "NGC 68:UGC 170:MCG 5-1-65:ZWG 499.106"
{
        Type  "S0"
        RA            0.3050
        Dec          30.0725
        Distance   2.485e+08  # method: V
        Radius     4.338e+04
        AbsMag        -20.21
        Axis    [  0.3705   0.8463   0.3827]
        Angle    122.1325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 68"
}

Galaxy "NGC 69:MCG 5-1-66:ZWG 499.105:ARAK 5"
{
        Type  "S0"
        RA            0.3056
        Dec          30.0406
        Distance   2.916e+08  # method: V
        Radius      2.12e+04
        AbsMag        -18.96
        Axis    [  0.0934   0.9685   0.2310]
        Angle    148.7753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 69"
}

Galaxy "NGC 70:IC 1539:UGC 174:MCG 5-1-67"
{
        Type  "Sc"
        RA            0.3061
        Dec          30.0789
        Distance   3.104e+08  # method: V
        Radius     7.223e+04
        AbsMag        -20.69
        Axis    [  0.3259   0.8544   0.4047]
        Angle    124.2985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 70"
}

Galaxy "NGC 71:UGC 173:MCG 5-1-68:ZWG 499.107"
{
        Type  "S0"
        RA            0.3064
        Dec          30.0631
        Distance   2.899e+08  # method: V
        Radius     5.059e+04
        AbsMag        -20.44
        Axis    [  0.0736   0.8829  -0.4637]
        Angle    201.1059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 71"
}

Galaxy "NGC 72:UGC 176:MCG 5-1-69:ZWG 499.109"
{
        Type  "SBb"
        RA            0.3078
        Dec          30.0406
        Distance    3.14e+08  # method: V
        Radius     5.024e+04
        AbsMag        -20.32
        Axis    [  0.2672   0.9103   0.3161]
        Angle    134.7335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 72"
}

Galaxy "NGC 72A:MCG 5-1-70:ZWG 499.110:ARAK 6"
{
        Type  "E3"
        RA            0.3094
        Dec          30.0361
        Distance    2.94e+08  # method: V
        Radius     1.283e+04
        AbsMag        -19.07
        Axis    [  0.5851   0.7701   0.2541]
        Angle    113.4188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 72A"
}

Galaxy "NGC 73:MCG 3-1-26:NPM 1"
{
        Type  "Sc"
        RA            0.3106
        Dec         -15.3217
        Distance   3.348e+08  # method: V
        Radius     8.279e+04
        AbsMag        -20.56
        Axis    [  0.3798   0.6829  -0.6240]
        Angle    197.1277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 73"
}

Galaxy "NGC 74:MCG 5-1-71"
{
        Type  "Sb"
        RA            0.3136
        Dec          30.0614
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [ -0.1463   0.8525  -0.5018]
        Angle    188.0566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 74"
}

Galaxy "NGC 75:UGC 182:MCG 1-1-51:ZWG 408.48"
{
        Type  "S0"
        RA            0.3239
        Dec           6.4497
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.6382   0.6652   0.3877]
        Angle    129.1808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 75"
}

Galaxy "NGC 76:UGC 185:MCG 5-1-72:ZWG 499.111"
{
        Type  "E0"
        RA            0.3269
        Dec          29.9342
        Distance   3.204e+08  # method: V
        Radius      4.66e+04
        AbsMag        -20.96
        Axis    [  0.5317   0.8427  -0.0850]
        Angle    166.3762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 76"
}

Galaxy "NGC 77:ESO 473-15:NPM 1"
{
        Type  "S0"
        RA            0.3336
        Dec         -22.5322
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.6954   0.5175   0.4986]
        Angle    149.4006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 77"
}

Galaxy "NGC 78-1:NGC 78A:UGC 193:MCG 0-2-4"
{
        Type  "SBa"
        RA            0.3403
        Dec           0.8264
        Distance   2.132e+08  # method: V
        Radius     3.411e+04
        AbsMag        -19.88
        Axis    [  0.3045   0.9443  -0.1246]
        Angle    179.1382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 78-1"
}

Galaxy "NGC 78-2:NGC 78B:UGC 194:MCG 0-2-5"
{
        Type  "S0"
        RA            0.3408
        Dec           0.8333
        Distance   2.309e+08  # method: V
        Radius     3.359e+04
        AbsMag        -19.85
        Axis    [  0.2746   0.7947  -0.5413]
        Angle    197.3158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 78-2"
}

Galaxy "NGC 79:MCG 4-2-3:ZWG 479.3:NPM 1"
{
        Type  "S0"
        RA            0.3506
        Dec          22.5672
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.5934   0.7431   0.3095]
        Angle    118.4546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 79"
}

Galaxy "NGC 80:UGC 203:MCG 4-2-4:ZWG 479.6"
{
        Type  "S0"
        RA            0.3528
        Dec          22.3578
        Distance   3.437e+08  # method: T-F
        Radius     7.997e+04
        AbsMag        -21.91
        Axis    [  0.5943   0.7419   0.3105]
        Angle    118.5684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 80"
}

Galaxy "NGC 81:NPM 1"
{
        Type  "S0"
        RA            0.3536
        Dec          22.3833
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.0372   0.9869  -0.1568]
        Angle    173.0193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 81"
}

Galaxy "NGC 83:UGC 206:MCG 4-2-5:ZWG 479.8"
{
        Type  "E0"
        RA            0.3561
        Dec          22.4342
        Distance   3.437e+08  # method: T-F
        Radius     7.498e+04
        AbsMag        -21.51
        Axis    [  0.6165   0.7297   0.2957]
        Angle    117.5835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 83"
}

Galaxy "NGC 85:NGC 85A:MCG 4-2-7:ZWG 479.9"
{
        Type  "S0"
        RA            0.3569
        Dec          22.5122
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.0837   0.8024  -0.5910]
        Angle    206.4637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 85"
}

Galaxy "NGC 86:MCG 4-2-9:ZWG 479.11"
{
        Type  "S0"
        RA            0.3578
        Dec          22.5564
        Distance   3.126e+08  # method: T-F
        Radius     3.182e+04
        AbsMag        -19.21
        Axis    [  0.0667   0.8868   0.4572]
        Angle    149.6077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 86"
}

Galaxy "NGC 87:ESO 194-8:AM 0018-485"
{
        Type  "Irr"
        RA            0.3539
        Dec         -48.6289
        Distance   1.491e+08  # method: V
        Radius     1.952e+04
        AbsMag         -18.6
        Axis    [  0.5302   0.3626  -0.7664]
        Angle    188.7950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 87"
}

Galaxy "NGC 88:ESO 194-10:AM 0018-485"
{
        Type  "SBa"
        RA            0.3561
        Dec         -48.6397
        Distance   1.465e+08  # method: V
        Radius     1.704e+04
        AbsMag        -18.26
        Axis    [  0.5713   0.5497  -0.6095]
        Angle    183.1547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 88"
}

Galaxy "NGC 89:ESO 194-11:AM 0018-485"
{
        Type  "SBa"
        RA            0.3567
        Dec         -48.6653
        Distance   1.397e+08  # method: V
        Radius     2.438e+04
        AbsMag        -18.96
        Axis    [  0.5176   0.5796  -0.6294]
        Angle    176.7950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 89"
}

Galaxy "NGC 90:UGC 208:MCG 4-2-11:ZWG 479.13"
{
        Type  "SBc"
        RA            0.3642
        Dec          22.4006
        Distance   2.271e+08  # method: V
        Radius     6.277e+04
        AbsMag        -19.71
        Axis    [ -0.0579   0.8532  -0.5184]
        Angle    188.3130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 90"
}

Galaxy "NGC 92:ESO 194-12:AM 0018-485"
{
        Type  "Sa"
        RA            0.3586
        Dec         -48.6247
        Distance   1.438e+08  # method: V
        Radius     3.975e+04
        AbsMag        -19.42
        Axis    [  0.5077   0.5884  -0.6292]
        Angle    175.5924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 92"
}

Galaxy "NGC 93:UGC 209:MCG 4-2-12:ZWG 479.15"
{
        Type  "Sb"
        RA            0.3675
        Dec          22.4089
        Distance    3.08e+08  # method: T-F
        Radius     6.272e+04
        AbsMag        -20.48
        Axis    [  0.0304   0.9894   0.1420]
        Angle    160.2914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 93"
}

Galaxy "NGC 94-1:ZWG 479.17"
{
        Type  "S0"
        RA            0.3703
        Dec          22.4833
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.0912   0.9554   0.2807]
        Angle    153.4862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 94-1"
}

Galaxy "NGC 94-2:NPM 1"
{
        Type  "S0"
        RA            0.3703
        Dec          22.4739
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.0366   0.7725  -0.6339]
        Angle    197.7768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 94-2"
}

Galaxy "NGC 95:UGC 214:MCG 2-2-3:ZWG 434.3"
{
        Type  "SBc"
        RA            0.3703
        Dec          10.4919
        Distance   2.284e+08  # method: V
        Radius     4.983e+04
        AbsMag        -21.03
        Axis    [  0.2837   0.9361  -0.2081]
        Angle    181.3011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 95"
}

Galaxy "NGC 96:MCG 4-2-14"
{
        Type  "S0"
        RA            0.3714
        Dec          22.5467
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.5956   0.7415   0.3090]
        Angle    118.2932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 96"
}

Galaxy "NGC 97:UGC 216:MCG 5-2-7:ZWG 500.9"
{
        Type  "E0"
        RA            0.3750
        Dec          29.7456
        Distance   2.022e+08  # method: V
        Radius     3.823e+04
        AbsMag        -20.56
        Axis    [  0.5928   0.7641   0.2543]
        Angle    112.9972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 97"
}

Galaxy "NGC 98:ESO 242-5"
{
        Type  "SBc"
        RA            0.3803
        Dec         -45.2683
        Distance   2.687e+08  # method: V
        Radius     6.254e+04
        AbsMag        -21.18
        Axis    [  0.5596   0.6013   0.5703]
        Angle    186.7583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 98"
}

Galaxy "NGC 99:UGC 230:MCG 2-2-6:ZWG 434.6"
{
        Type  "Sc"
        RA            0.3997
        Dec          15.7700
        Distance   2.256e+08  # method: V
        Radius     3.281e+04
        AbsMag         -20.2
        Axis    [  0.4268   0.8951   0.1292]
        Angle    155.1642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 99"
}

Galaxy "NGC 100:UGC 231:MCG 3-2-9:ZWG 457.12"
{
        Type  "Sc"
        RA            0.4006
        Dec          16.4864
        Distance   7.162e+07  # method: T-F
        Radius     4.375e+04
        AbsMag        -17.81
        Axis    [ -0.1013   0.9899   0.0991]
        Angle    166.8750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 100"
}

Galaxy "NGC 101:ESO 350-14:MCG 5-2-3:IRAS 00214-3248"
{
        Type  "SBc"
        RA            0.3983
        Dec         -32.5364
        Distance   1.418e+08  # method: V
        Radius     4.331e+04
        AbsMag        -19.79
        Axis    [  0.7701   0.6172  -0.1610]
        Angle    194.0242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 101"
}

Galaxy "NGC 102:MCG 2-2-11"
{
        Type  "SBa"
        RA            0.4100
        Dec         -13.9561
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.3743   0.7121  -0.5939]
        Angle    195.0155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 102"
}

Galaxy "NGC 105:UGC 241:MCG 2-2-8:ZWG 434.9"
{
        Type  "Sb"
        RA            0.4211
        Dec          12.8836
        Distance   2.241e+08  # method: V
        Radius     3.586e+04
        AbsMag        -20.29
        Axis    [  0.0758   0.6653  -0.7427]
        Angle    206.5989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 105"
}

Galaxy "NGC 106"
{
        Type  "Sc"
        RA            0.4119
        Dec          -5.1489
        Distance   1.612e+08  # distance uncertain!
        Radius      2.11e+04
        AbsMag        -19.07
        Axis    [  0.4291   0.8570  -0.2852]
        Angle    188.1856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 106"
}

Galaxy "NGC 107:MCG 2-2-14"
{
        Type  "Sc"
        RA            0.4283
        Dec          -8.2833
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [  0.3079   0.7317  -0.6081]
        Angle    194.7751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 107"
}

Galaxy "NGC 108:UGC 246:MCG 5-2-12:ZWG 500.20"
{
        Type  "SBa"
        RA            0.4331
        Dec          29.2119
        Distance   2.008e+08  # method: V
        Radius     6.716e+04
        AbsMag        -20.85
        Axis    [  0.0565   0.7910  -0.6092]
        Angle    214.1117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 108"
}

Galaxy "NGC 109:UGC 251:MCG 4-2-20:ZWG 479.31"
{
        Type  "SBa"
        RA            0.4372
        Dec          21.8078
        Distance   2.347e+08  # method: V
        Radius     3.755e+04
        AbsMag        -19.29
        Axis    [  0.3639   0.9230  -0.1252]
        Angle    173.5637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 109"
}

Galaxy "NGC 112:UGC 255:MCG 5-2-13:ZWG 500.21"
{
        Type  "Sc"
        RA            0.4467
        Dec          31.7028
        Distance    2.78e+08  # method: T-F
        Radius     4.043e+04
        AbsMag        -20.15
        Axis    [ -0.0686   0.9407  -0.3321]
        Angle    180.2893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 112"
}

Galaxy "NGC 113:MCG 1-2-16"
{
        Type  "S0"
        RA            0.4483
        Dec          -2.5006
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.3044   0.7754  -0.5533]
        Angle    196.2281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 113"
}

Galaxy "NGC 114:UGC 259:MCG 0-2-27:MK 946"
{
        Type  "S0"
        RA            0.4494
        Dec          -1.7858
        Distance    1.54e+08  # distance uncertain!
        Radius     1.792e+04
        AbsMag        -19.07
        Axis    [  0.3183   0.6069  -0.7283]
        Angle    216.2165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 114"
}

Galaxy "NGC 115:ESO 350-17:MCG 6-2-6"
{
        Type  "SBc"
        RA            0.4461
        Dec         -33.6761
        Distance   1.098e+08  # method: T-F
        Radius     3.033e+04
        AbsMag        -18.93
        Axis    [  0.4378   0.7449  -0.5035]
        Angle    181.2542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 115"
}

Galaxy "NGC 117:MCG 0-2-29:ZWG 383.15"
{
        Type  "Sa"
        RA            0.4528
        Dec           1.3342
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.2440   0.9247  -0.2923]
        Angle    181.8696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 117"
}

Galaxy "NGC 118:UGC 264:MCG 0-2-32:MK 947"
{
        Type  "E0"
        RA            0.4544
        Dec          -1.7797
        Distance   4.942e+08  # method: V
        Radius     5.032e+04
        AbsMag         -21.3
        Axis    [  0.7341   0.6651   0.1368]
        Angle    158.2543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 118"
}

Galaxy "NGC 119:ESO 150-8"
{
        Type  "S0"
        RA            0.4492
        Dec         -56.9778
        Distance   3.255e+08  # method: V
        Radius     4.734e+04
        AbsMag         -20.9
        Axis    [  0.7372   0.3340   0.5874]
        Angle    174.6019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 119"
}

Galaxy "NGC 120:UGC 267:MCG 0-2-33:ZWG 383.17"
{
        Type  "S0"
        RA            0.4583
        Dec          -1.5136
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [  0.1862   0.9804  -0.0642]
        Angle    175.1469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 120"
}

Galaxy "NGC 124:UGC 271:MCG 0-2-38:ZWG 383.18"
{
        Type  "Sc"
        RA            0.4644
        Dec          -1.8103
        Distance   1.678e+08  # method: V
        Radius     3.417e+04
        AbsMag        -19.76
        Axis    [  0.1521   0.6193  -0.7703]
        Angle    196.2965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 124"
}

Galaxy "NGC 125:UGC 286:MCG 0-2-48:ZWG 383.27"
{
        Type  "Sa"
        RA            0.4806
        Dec           2.8386
        Distance   2.248e+08  # method: V
        Radius     5.886e+04
        AbsMag        -20.89
        Axis    [  0.4787   0.8612  -0.1708]
        Angle    182.2733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 125"
}

Galaxy "NGC 126:MCG 0-2-49:ZWG 383.28"
{
        Type  "S0"
        RA            0.4856
        Dec           2.8111
        Distance   1.771e+08  # method: V
        Radius     2.061e+04
        AbsMag        -18.27
        Axis    [  0.1778   0.9106  -0.3730]
        Angle    181.8959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 126"
}

Galaxy "NGC 127:MCG 0-2-50:ZWG 383.29:NPM 1"
{
        Type  "S0"
        RA            0.4867
        Dec           2.8733
        Distance    1.68e+08  # method: V
        Radius     1.954e+04
        AbsMag        -17.76
        Axis    [  0.2939   0.9547  -0.0473]
        Angle    173.4609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 127"
}

Galaxy "NGC 128:UGC 292:MCG 0-2-51:ZWG 383.29"
{
        Type  "S0"
        RA            0.4872
        Dec           2.8650
        Distance   1.766e+08  # method: V
        Radius     6.422e+04
        AbsMag        -20.87
        Axis    [  0.1018   0.8366   0.5383]
        Angle    168.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 128"
}

Galaxy "NGC 130:MCG 0-2-52:ZWG 383.29"
{
        Type  "S0"
        RA            0.4883
        Dec           2.8711
        Distance   1.853e+08  # method: V
        Radius     1.887e+04
        AbsMag        -18.37
        Axis    [  0.2691   0.9572   0.1066]
        Angle    168.6825
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 130"
}

Galaxy "NGC 131:ESO 350-21:MCG 6-2-10:IRAS 00271-3332"
{
        Type  "SBb"
        RA            0.4939
        Dec         -33.2603
        Distance   5.196e+07  # method: V
        Radius      1.36e+04
        AbsMag        -17.21
        Axis    [  0.3903   0.9205   0.0185]
        Angle    187.3420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 131"
}

Galaxy "NGC 132:UGC 301:MCG 0-2-63:ZWG 383.32"
{
        Type  "SBc"
        RA            0.5028
        Dec           2.0931
        Distance   2.273e+08  # method: V
        Radius     6.282e+04
        AbsMag        -20.72
        Axis    [  0.4237   0.8986   0.1143]
        Angle    165.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 132"
}

Galaxy "NGC 134:ESO 350-23:MCG 6-2-12:AM 0027-333"
{
        Type  "SBc"
        RA            0.5058
        Dec         -33.2450
        Distance   6.541e+07  # method: T-F
        Radius     7.992e+04
        AbsMag        -20.31
        Axis    [  0.2899   0.9494   0.1208]
        Angle    190.8536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 134"
}

Galaxy "NGC 135:IC 26"
{
        Type  "S0"
        RA            0.5292
        Dec         -13.3378
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.6994   0.5510   0.4552]
        Angle    141.8564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 135"
}

Galaxy "NGC 137:UGC 309:MCG 2-2-17:ZWG 434.19"
{
        Type  "S0"
        RA            0.5161
        Dec          10.2086
        Distance   2.236e+08  # method: V
        Radius     3.902e+04
        AbsMag        -20.38
        Axis    [  0.6474   0.6700   0.3633]
        Angle    125.3009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 137"
}

Galaxy "NGC 138:UGC 308:MCG 1-2-16:ZWG 409.23"
{
        Type  "Sa"
        RA            0.5164
        Dec           5.1597
        Distance   5.288e+08  # method: V
        Radius     9.998e+04
        AbsMag        -21.45
        Axis    [  0.0408   0.5927  -0.8044]
        Angle    193.8356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 138"
}

Galaxy "NGC 139:ZWG 409.22"
{
        Type  "SBb"
        RA            0.5183
        Dec           5.0783
        Distance   6.063e+08  # method: V
        Radius     7.054e+04
        AbsMag        -20.95
        Axis    [  0.1141   0.6187  -0.7773]
        Angle    202.4397
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 139"
}

Galaxy "NGC 140:UGC 311:MCG 5-2-21:ZWG 500.38"
{
        Type  "Sc"
        RA            0.5222
        Dec          30.7919
        Distance   2.774e+08  # method: V
        Radius     6.051e+04
        AbsMag        -20.65
        Axis    [  0.2236   0.9741   0.0344]
        Angle    154.2635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 140"
}

Galaxy "NGC 141:ZWG 409.27"
{
        Type  "S0"
        RA            0.5214
        Dec           5.1794
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.3420   0.9152  -0.2133]
        Angle    180.6156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 141"
}

Galaxy "NGC 142:ESO 473-21:MCG 4-2-14:AM 0028-225"
{
        Type  "SBb"
        RA            0.5186
        Dec         -22.6194
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.4225   0.8538  -0.3043]
        Angle    183.4451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 142"
}

Galaxy "NGC 143:ESO 473-22:MCG 4-2-15:AM 0028-225"
{
        Type  "SBb"
        RA            0.5208
        Dec         -22.5600
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.1833   0.9082   0.3762]
        Angle    191.0487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 143"
}

Galaxy "NGC 144:ESO 473-23:MCG 4-2-16:AM 0028-225"
{
        Type  "Sc"
        RA            0.5222
        Dec         -22.6461
        Distance   1.612e+08  # distance uncertain!
        Radius     1.876e+04
        AbsMag        -19.07
        Axis    [  0.7130   0.5047   0.4867]
        Angle    148.7114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 144"
}

Galaxy "NGC 145:MCG 1-2-27:ARP 19:IRAS 00292-0525"
{
        Type  "Irr"
        RA            0.5292
        Dec          -5.1539
        Distance   1.724e+08  # method: V
        Radius     4.514e+04
        AbsMag        -20.32
        Axis    [  0.5066   0.8605   0.0542]
        Angle    171.8509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 145"
}

Galaxy "NGC 147:UGC 326:MCG 8-2-5:DDO 3"
{
        Type  "E5"
        RA            0.5531
        Dec          48.5072
        Distance    2.52e+06  # method: S
        Radius          4838
        AbsMag        -14.04
        Axis    [  0.4782   0.8782   0.0141]
        Angle    122.2064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 147"
}

Galaxy "NGC 148:ESO 410-20:MCG 5-2-17:AM 0031-320"
{
        Type  "S0"
        RA            0.5708
        Dec         -31.7861
        Distance   5.712e+07  # method: V
        Radius     1.662e+04
        AbsMag        -18.12
        Axis    [  0.4226   0.8806  -0.2146]
        Angle    182.1090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 148"
}

Galaxy "NGC 149:UGC 332:MCG 5-2-24:ZWG 500.44"
{
        Type  "S0"
        RA            0.5639
        Dec          30.7236
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.0760   0.7658  -0.6386]
        Angle    203.2812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 149"
}

Galaxy "NGC 150:ESO 410-19:MCG 5-2-18:UGCA 7"
{
        Type  "SBb"
        RA            0.5708
        Dec         -27.8050
        Distance   7.135e+07  # method: T-F
        Radius     4.047e+04
        AbsMag         -19.7
        Axis    [  0.4108   0.7964  -0.4438]
        Angle    181.1918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 150"
}

Galaxy "NGC 151:NGC 153:MCG 2-2-54:IRAS 00315-0958"
{
        Type  "SBc"
        RA            0.5672
        Dec          -9.7050
        Distance   1.655e+08  # method: T-F
        Radius     9.146e+04
        AbsMag        -21.13
        Axis    [  0.2680   0.9596  -0.0853]
        Angle    176.7698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 151"
}

Galaxy "NGC 154:MCG 2-2-53:NPM 1"
{
        Type  "E0"
        RA            0.5719
        Dec         -12.6558
        Distance   3.468e+08  # distance uncertain!
        Radius     5.548e+04
        AbsMag        -20.13
        Axis    [  0.7863   0.6069  -0.1160]
        Angle    186.8576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 154"
}

Galaxy "NGC 155:MCG 2-2-55:NPM 1"
{
        Type  "S0"
        RA            0.5778
        Dec         -10.7661
        Distance    1.54e+08  # distance uncertain!
        Radius     3.807e+04
        AbsMag        -19.07
        Axis    [  0.2686   0.5248  -0.8077]
        Angle    204.4682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 155"
}

Galaxy "NGC 157:MCG 2-2-56"
{
        Type  "SBc"
        RA            0.5794
        Dec          -8.3961
        Distance    7.04e+07  # method: T-F
        Radius     3.584e+04
        AbsMag        -20.47
        Axis    [  0.4212   0.8750   0.2387]
        Angle    168.7190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 157"
}

Galaxy "NGC 159:ESO 150-11"
{
        Type  "SBa"
        RA            0.5764
        Dec         -55.7897
        Distance    2.03e+08  # distance uncertain!
        Radius     4.133e+04
        AbsMag        -19.07
        Axis    [  0.5364   0.8063  -0.2493]
        Angle    183.2857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 159"
}

Galaxy "NGC 160:UGC 356:MCG 4-2-33:ZWG 479.43"
{
        Type  "Sa"
        RA            0.6011
        Dec          23.9581
        Distance   2.796e+08  # method: T-F
        Radius     9.355e+04
        AbsMag        -21.17
        Axis    [  0.0965   0.9831   0.1558]
        Angle    154.5139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 160"
}

Galaxy "NGC 161:MCG 1-2-36:NPM 1"
{
        Type  "S0"
        RA            0.5925
        Dec          -2.8483
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.3412   0.8864   0.3128]
        Angle    164.5610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 161"
}

Galaxy "NGC 163:MCG 2-2-66:NPM 1"
{
        Type  "E0"
        RA            0.5997
        Dec         -10.1214
        Distance   1.906e+08  # distance uncertain!
        Radius     4.435e+04
        AbsMag        -20.13
        Axis    [  0.7686   0.6204  -0.1561]
        Angle    189.0692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 163"
}

Galaxy "NGC 164:MCG 0-2-89"
{
        Type  "S0"
        RA            0.6089
        Dec           2.7500
        Distance   4.441e+08  # distance uncertain!
        Radius     2.583e+04
        AbsMag        -19.07
        Axis    [  0.6751   0.6257   0.3908]
        Angle    129.8626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 164"
}

Galaxy "NGC 165:MCG 2-2-69:IRAS 00339-1022"
{
        Type  "SBc"
        RA            0.6078
        Dec         -10.1064
        Distance   2.515e+08  # method: V
        Radius     5.852e+04
        AbsMag        -20.53
        Axis    [  0.5193   0.8477  -0.1084]
        Angle    179.8068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 165"
}

Galaxy "NGC 166:MCG 2-2-63"
{
        Type  "Sa"
        RA            0.5967
        Dec         -13.6106
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.1769   0.7465  -0.6414]
        Angle    175.9329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 166"
}

Galaxy "NGC 167:ESO 473-29:MCG 4-2-22:IRAS 00328-2339"
{
        Type  "SBc"
        RA            0.5894
        Dec         -23.3747
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.3357   0.5051  -0.7951]
        Angle    193.2180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 167"
}

Galaxy "NGC 168:ESO 474-4:MCG 4-2-26:AM 0034-225"
{
        Type  "Sa"
        RA            0.6106
        Dec         -22.5936
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.2422   0.9130   0.3283]
        Angle    187.0925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 168"
}

Galaxy "NGC 169:UGC 365:MCG 4-2-35:ZWG 479.44"
{
        Type  "Sb"
        RA            0.6142
        Dec          23.9914
        Distance   2.799e+08  # method: T-F
        Radius     1.058e+05
        AbsMag        -21.47
        Axis    [ -0.1543   0.9733  -0.1700]
        Angle    166.5873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 169"
}

Galaxy "NGC 170:MCG 0-2-91:ZWG 383.42"
{
        Type  "S0"
        RA            0.6125
        Dec           1.8864
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.3832   0.9145  -0.1296]
        Angle    176.0050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 170"
}

Galaxy "NGC 171:NGC 175:ESO 540-6:MCG 3-2-24"
{
        Type  "SBb"
        RA            0.6225
        Dec         -19.9344
        Distance   1.595e+08  # method: V
        Radius     4.872e+04
        AbsMag        -20.45
        Axis    [  0.5706   0.6413   0.5131]
        Angle    159.0177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 171"
}

Galaxy "NGC 172:ESO 474-5:MCG 4-2-27:AM 0034-225"
{
        Type  "SBc"
        RA            0.6203
        Dec         -22.5867
        Distance   1.471e+08  # method: T-F
        Radius      4.28e+04
        AbsMag        -18.87
        Axis    [  0.1861   0.8805   0.4361]
        Angle    191.5626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 172"
}

Galaxy "NGC 173:UGC 369:MCG 0-2-92:ZWG 383.43"
{
        Type  "Sc"
        RA            0.6200
        Dec           1.9422
        Distance   1.825e+08  # method: V
        Radius     8.493e+04
        AbsMag        -20.74
        Axis    [  0.4162   0.8829  -0.2172]
        Angle    181.2451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 173"
}

Galaxy "NGC 174:ESO 411-1:MCG 5-2-28:AM 0034-294"
{
        Type  "SBa"
        RA            0.6161
        Dec         -29.4778
        Distance   1.447e+08  # method: V
        Radius     2.947e+04
        AbsMag        -19.44
        Axis    [  0.3299   0.6479  -0.6866]
        Angle    175.3976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 174"
}

Galaxy "NGC 177:ESO 474-6:MCG 4-2-28:AM 0035-224"
{
        Type  "Sb"
        RA            0.6261
        Dec         -22.5492
        Distance   1.629e+08  # method: V
        Radius     5.211e+04
        AbsMag        -19.39
        Axis    [  0.2107   0.8699   0.4459]
        Angle    190.1850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 177"
}

Galaxy "NGC 178:IC 39:MCG 2-2-78:ZW 34"
{
        Type  "Sb"
        RA            0.6522
        Dec         -14.1722
        Distance   5.151e+07  # method: V
        Radius     1.573e+04
        AbsMag        -17.59
        Axis    [  0.1519   0.5300  -0.8343]
        Angle    180.6927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 178"
}

Galaxy "NGC 179:ESO 540-7:MCG 3-2-26"
{
        Type  "S0"
        RA            0.6294
        Dec         -17.8500
        Distance   3.208e+08  # method: T-F
        Radius     4.199e+04
        AbsMag        -20.76
        Axis    [  0.5034   0.7658  -0.4003]
        Angle    189.8413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 179"
}

Galaxy "NGC 180:UGC 380:MCG 1-2-39:ZWG 409.50"
{
        Type  "SBc"
        RA            0.6325
        Dec           8.6347
        Distance   2.231e+08  # method: V
        Radius     6.165e+04
        AbsMag        -20.37
        Axis    [  0.1353   0.6939  -0.7072]
        Angle    202.6067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 180"
}

Galaxy "NGC 181:MCG 5-2-32:ZWG 500.55"
{
        Type  "S0"
        RA            0.6397
        Dec          29.4733
        Distance   2.367e+08  # method: V
        Radius     2.409e+04
        AbsMag         -18.5
        Axis    [ -0.2065   0.7689  -0.6051]
        Angle    184.9752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 181"
}

Galaxy "NGC 182:UGC 382:MCG 0-2-95:ZWG 383.45"
{
        Type  "SBa"
        RA            0.6367
        Dec           2.7286
        Distance   2.229e+08  # method: V
        Radius      6.16e+04
        AbsMag        -20.77
        Axis    [  0.4530   0.8856  -0.1027]
        Angle    174.8475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 182"
}

Galaxy "NGC 183:UGC 387:MCG 5-2-35:ZWG 500.57"
{
        Type  "E0"
        RA            0.6414
        Dec          29.5117
        Distance   2.258e+08  # method: V
        Radius     5.584e+04
        AbsMag         -20.6
        Axis    [  0.4232   0.8147  -0.3964]
        Angle    216.6611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 183"
}

Galaxy "NGC 184:ZWG 500.59"
{
        Type  "S0"
        RA            0.6431
        Dec          29.4475
        Distance   2.255e+08  # method: V
        Radius     2.296e+04
        AbsMag         -18.6
        Axis    [ -0.0184   0.8585   0.5125]
        Angle    145.9914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 184"
}

Galaxy "NGC 185:UGC 396:MCG 8-2-10:ZWG 550.9"
{
        Type  "E3"
        RA            0.6492
        Dec          48.3372
        Distance   2.077e+06  # method: S
        Radius          2417
        AbsMag        -13.72
        Axis    [  0.4669   0.8838  -0.0291]
        Angle    129.9180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 185"
}

Galaxy "NGC 186:UGC 390:MCG 0-2-98:ZWG 383.47"
{
        Type  "SBa"
        RA            0.6403
        Dec           3.1661
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.2830   0.8954   0.3437]
        Angle    160.1489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 186"
}

Galaxy "NGC 187:MCG 3-2-34:IRAS 00369-1455"
{
        Type  "Sc"
        RA            0.6583
        Dec         -14.6564
        Distance   1.645e+08  # method: V
        Radius     3.111e+04
        AbsMag        -19.61
        Axis    [  0.2021   0.7204  -0.6635]
        Angle    177.2715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 187"
}

Galaxy "NGC 190:UGC 397:MCG 1-2-41:ZWG 409.51"
{
        Type  "Sb"
        RA            0.6483
        Dec           7.0622
        Distance   4.918e+08  # method: V
        Radius     6.438e+04
        AbsMag        -21.09
        Axis    [  0.3489   0.7729  -0.5301]
        Angle    204.4192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 190"
}

Galaxy "NGC 190A:MCG 1-2-42:ZWG 409.51:ZW 10"
{
        Type  "E0"
        RA            0.6483
        Dec           7.0564
        Distance   5.335e+08  # method: V
        Radius     4.656e+04
        AbsMag        -20.27
        Axis    [  0.6886   0.6296   0.3599]
        Angle    125.4780
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 190A"
}

Galaxy "NGC 191:MCG 2-2-77:ARP 127"
{
        Type  "SBc"
        RA            0.6497
        Dec          -9.0028
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.4594   0.7313  -0.5042]
        Angle    197.8203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 191"
}

Galaxy "NGC 192:UGC 401:MCG 0-2-104:ZWG 383.51"
{
        Type  "SBa"
        RA            0.6536
        Dec           0.8642
        Distance   1.755e+08  # method: V
        Radius      4.85e+04
        AbsMag        -20.15
        Axis    [  0.0831   0.6363  -0.7670]
        Angle    189.3011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 192"
}

Galaxy "NGC 193:UGC 408:MCG 0-2-103:ZWG 383.55"
{
        Type  "S0"
        RA            0.6550
        Dec           3.3311
        Distance   1.807e+08  # method: V
        Radius      3.68e+04
        AbsMag        -20.32
        Axis    [  0.4780   0.8769   0.0502]
        Angle    165.4783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 193"
}

Galaxy "NGC 194:UGC 407:MCG 0-2-105:ZWG 383.54"
{
        Type  "E0"
        RA            0.6550
        Dec           3.0375
        Distance   1.842e+08  # method: T-F
        Radius     4.285e+04
        AbsMag        -20.56
        Axis    [  0.7235   0.6686   0.1717]
        Angle    147.4754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 194"
}

Galaxy "NGC 195:MCG 2-2-79:NPM 1:IRAS 00370-0928"
{
        Type  "SBa"
        RA            0.6597
        Dec          -9.1942
        Distance   2.081e+08  # method: V
        Radius     3.631e+04
        AbsMag        -19.42
        Axis    [  0.4781   0.8643   0.1563]
        Angle    169.4367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 195"
}

Galaxy "NGC 196:UGC 405:MCG 0-2-110:ZWG 383.53"
{
        Type  "S0"
        RA            0.6547
        Dec           0.9131
        Distance   1.768e+08  # method: V
        Radius     3.342e+04
        AbsMag        -19.07
        Axis    [  0.3131   0.8089   0.4976]
        Angle    156.4428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 196"
}

Galaxy "NGC 197:UGC 406:MCG 0-2-107:ZWG 383.53"
{
        Type  "S0"
        RA            0.6550
        Dec           0.8925
        Distance   1.747e+08  # method: V
        Radius     1.778e+04
        AbsMag        -18.94
        Axis    [  0.6837   0.6130   0.3960]
        Angle    130.8983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 197"
}

Galaxy "NGC 198:UGC 414:MCG 0-2-109:ZWG 383.57"
{
        Type  "Sc"
        RA            0.6561
        Dec           2.7983
        Distance   2.231e+08  # method: V
        Radius     3.894e+04
        AbsMag        -20.67
        Axis    [  0.6795   0.6224   0.3884]
        Angle    129.5326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 198"
}

Galaxy "NGC 199:UGC 415:MCG 0-2-111:ZWG 383.58"
{
        Type  "S0"
        RA            0.6592
        Dec           3.1381
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.1270   0.6809  -0.7212]
        Angle    194.6497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 199"
}

Galaxy "NGC 200:UGC 420:MCG 0-2-112:ZWG 383.60"
{
        Type  "SBc"
        RA            0.6594
        Dec           2.8869
        Distance   2.468e+08  # method: T-F
        Radius     6.101e+04
        AbsMag        -20.89
        Axis    [  0.1289   0.6742  -0.7272]
        Angle    195.0622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 200"
}

Galaxy "NGC 201:UGC 419:MCG 0-2-115:ZWG 383.59"
{
        Type  "SBc"
        RA            0.6594
        Dec           0.8603
        Distance   1.826e+08  # method: V
        Radius     4.779e+04
        AbsMag        -20.14
        Axis    [  0.2916   0.6764  -0.6763]
        Angle    207.5459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 201"
}

Galaxy "NGC 202:UGC 421:MCG 0-2-113:ZWG 383.62"
{
        Type  "Sa"
        RA            0.6608
        Dec           3.5356
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.0233   0.7294  -0.6836]
        Angle    180.6117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 202"
}

Galaxy "NGC 203:NGC 211:MCG 0-2-114:ZWG 383.61"
{
        Type  "S0"
        RA            0.6608
        Dec           3.4425
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.1021   0.9807  -0.1666]
        Angle    171.6269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 203"
}

Galaxy "NGC 204:UGC 423:MCG 0-2-116:ZWG 383.63"
{
        Type  "S0"
        RA            0.6622
        Dec           3.3000
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [  0.5392   0.8098   0.2313]
        Angle    152.7396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 204"
}

Galaxy "M 110:NGC 205:UGC 426:MCG 7-2-14"
{
        Type  "E5"
        RA            0.6728
        Dec          41.6853
        Distance     2.7e+06  # method: PN
        Radius          7658
        AbsMag        -15.68
        Axis    [  0.2155   0.8200  -0.5303]
        Angle    249.5817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 110"
}

Galaxy "NGC 207:MCG 3-2-35:IRAS 00371-1430"
{
        Type  "Sa"
        RA            0.6611
        Dec         -14.2364
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.3151   0.9326  -0.1758]
        Angle    177.5595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 207"
}

Galaxy "NGC 208:MCG 0-2-118:ZWG 383.64"
{
        Type  "Sa"
        RA            0.6714
        Dec           2.7558
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.6811   0.6210   0.3878]
        Angle    129.4675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 208"
}

Galaxy "NGC 209:ESO 540-8:MCG 3-2-31:NPM 1"
{
        Type  "S0"
        RA            0.6508
        Dec         -18.6083
        Distance   1.642e+08  # method: V
        Radius     2.627e+04
        AbsMag        -19.51
        Axis    [  0.7190   0.5162   0.4653]
        Angle    145.1779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 209"
}

Galaxy "NGC 210:MCG 2-2-81:IRAS 00380-1408"
{
        Type  "SBb"
        RA            0.6761
        Dec         -13.8725
        Distance   5.975e+07  # method: V
        Radius     4.345e+04
        AbsMag        -19.61
        Axis    [  0.2859   0.6152  -0.7347]
        Angle    192.4935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 210"
}

Galaxy "NGC 212:ESO 150-18:AM 0038-562"
{
        Type  "S0"
        RA            0.6703
        Dec         -56.1525
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.7599   0.3985  -0.5135]
        Angle    194.5004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 212"
}

Galaxy "NGC 213:UGC 436:MCG 3-2-23:ZWG 457.26"
{
        Type  "SBa"
        RA            0.6858
        Dec          16.4697
        Distance   2.318e+08  # method: V
        Radius     5.057e+04
        AbsMag        -19.86
        Axis    [  0.2719   0.9129  -0.3044]
        Angle    183.0596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 213"
}

Galaxy "NGC 214:UGC 438:MCG 4-2-44:ZWG 479.59"
{
        Type  "SBc"
        RA            0.6911
        Dec          25.4994
        Distance   1.909e+08  # method: V
        Radius     5.277e+04
        AbsMag        -20.84
        Axis    [  0.2887   0.9398   0.1827]
        Angle    144.4968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 214"
}

Galaxy "NGC 215:ESO 150-19:AM 0038-562"
{
        Type  "S0"
        RA            0.6800
        Dec         -56.2142
        Distance   3.657e+08  # method: V
        Radius     5.851e+04
        AbsMag        -21.15
        Axis    [  0.7520   0.4932  -0.4374]
        Angle    190.5042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 215"
}

Galaxy "NGC 216:ESO 540-15:MCG 4-2-35:HARO 13"
{
        Type  "S0"
        RA            0.6908
        Dec         -21.0453
        Distance   5.703e+07  # method: V
        Radius     1.659e+04
        AbsMag        -17.51
        Axis    [  0.3053   0.8966   0.3209]
        Angle    182.3811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 216"
}

Galaxy "NGC 217:MCG 2-2-85:IRAS 00390-1017"
{
        Type  "Sa"
        RA            0.6925
        Dec         -10.0217
        Distance   1.666e+08  # method: V
        Radius     6.543e+04
        AbsMag        -20.04
        Axis    [  0.1071   0.9023  -0.4176]
        Angle    170.6313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 217"
}

Galaxy "NGC 218:UGC 440:MCG 6-2-13:ZWG 519.17"
{
        Type  "S0"
        RA            0.6956
        Dec          36.3592
        Distance   2.085e+08  # method: V
        Radius      2.73e+04
        AbsMag        -18.83
        Axis    [  0.0425   0.9010  -0.4318]
        Angle    194.9391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 218"
}

Galaxy "NGC 219:MCG 0-2-128:ZWG 383.73"
{
        Type  "E0"
        RA            0.7031
        Dec           0.9044
        Distance   2.336e+08  # method: V
        Radius     1.699e+04
        AbsMag        -18.78
        Axis    [  0.4623   0.5445  -0.6999]
        Angle    239.7085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 219"
}

Galaxy "M 32:NGC 221:UGC 452:MCG 7-2-15"
{
        Type  "E2"
        RA            0.7114
        Dec          40.8658
        Distance   2.651e+06  # method: S
        Radius          3278
        AbsMag        -15.45
        Axis    [  0.1854   0.7953  -0.5772]
        Angle    256.1765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 32"
}

Galaxy "NGC 223:IC 44:UGC 450:MCG 0-2-129"
{
        Type  "Sa"
        RA            0.7042
        Dec           0.8461
        Distance   2.275e+08  # method: V
        Radius     4.301e+04
        AbsMag        -19.92
        Axis    [  0.3698   0.9291   0.0088]
        Angle    169.1352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 223"
}

Galaxy "M 31:NGC 224:UGC 454:MCG 7-2-16"
{
        Type  "Sb"
        RA            0.7122
        Dec          41.2689
        Distance   2.474e+06  # method: S
        Radius     6.805e+04
        AbsMag        -20.04
        Axis    [ -0.1274   0.9554   0.2663]
        Angle    142.9019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 31"
}

Galaxy "NGC 226:UGC 459:ZWG 500.76:IRAS 00402+3218"
{
        Type  "Irr"
        RA            0.7147
        Dec          32.5803
        Distance   2.051e+08  # method: V
        Radius     2.685e+04
        AbsMag        -19.59
        Axis    [  0.0351   0.9501  -0.3098]
        Angle    178.7341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 226"
}

Galaxy "NGC 227:UGC 456:MCG 0-2-135:ZWG 383.76"
{
        Type  "S0"
        RA            0.7100
        Dec          -1.5281
        Distance   2.228e+08  # method: T-F
        Radius      4.86e+04
        AbsMag        -21.07
        Axis    [  0.2844   0.6709  -0.6849]
        Angle    203.8309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 227"
}

Galaxy "NGC 228:UGC 458:MCG 4-2-48:ZWG 479.62"
{
        Type  "SBb"
        RA            0.7150
        Dec          23.5033
        Distance   3.168e+08  # method: V
        Radius     5.529e+04
        AbsMag        -20.24
        Axis    [  0.2710   0.8553  -0.4416]
        Angle    201.3162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 228"
}

Galaxy "NGC 229:MCG 4-2-49:ZWG 479.64"
{
        Type  "S0"
        RA            0.7178
        Dec          23.5094
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [ -0.0386   0.9685  -0.2460]
        Angle    170.2684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 229"
}

Galaxy "NGC 230:ESO 474-14:MCG 4-2-37:AM 0040-234"
{
        Type  "Sa"
        RA            0.7075
        Dec         -23.6289
        Distance   2.802e+08  # distance uncertain!
        Radius     4.483e+04
        AbsMag        -19.07
        Axis    [  0.2193   0.9603   0.1722]
        Angle    184.7811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 230"
}

Galaxy "NGC 232:ESO 474-15:MCG 4-2-40:VV 830"
{
        Type  "SBa"
        RA            0.7125
        Dec         -23.5617
        Distance   2.891e+08  # method: V
        Radius     3.784e+04
        AbsMag        -20.34
        Axis    [  0.6627   0.7253   0.1865]
        Angle    173.7786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 232"
}

Galaxy "NGC 233:UGC 464:MCG 5-2-41:ZWG 500.78"
{
        Type  "E0"
        RA            0.7267
        Dec          30.5869
        Distance   2.331e+08  # method: V
        Radius     4.068e+04
        AbsMag        -20.47
        Axis    [  0.6253   0.7423   0.2410]
        Angle    109.3583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 233"
}

Galaxy "NGC 234:UGC 463:MCG 2-2-28:ZWG 434.32"
{
        Type  "SBc"
        RA            0.7256
        Dec          14.3425
        Distance   1.866e+08  # method: V
        Radius     4.072e+04
        AbsMag        -20.49
        Axis    [  0.3586   0.9321   0.0500]
        Angle    159.2362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 234"
}

Galaxy "NGC 235A:ESO 474-16:MCG 4-2-41:AM 0040-234"
{
        Type  "S0"
        RA            0.7144
        Dec         -23.5411
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.4034   0.8005  -0.4434]
        Angle    180.9878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 235A"
}

Galaxy "NGC 235B:ESO 474-17:MCG 4-2-42:AM 0040-234"
{
        Type  "S0"
        RA            0.7147
        Dec         -23.5453
        Distance   2.948e+08  # method: V
        Radius     1.715e+04
        AbsMag        -20.28
        Axis    [  0.7317   0.4874   0.4765]
        Angle    148.6223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 235B"
}

Galaxy "NGC 236:UGC 462:MCG 0-3-1:ZWG 383.80"
{
        Type  "Sc"
        RA            0.7242
        Dec           2.9581
        Distance   2.405e+08  # method: V
        Radius     4.198e+04
        AbsMag        -20.04
        Axis    [  0.2570   0.6614  -0.7046]
        Angle    209.1654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 236"
}

Galaxy "NGC 237:UGC 461:MCG 0-2-136:ZWG 383.79"
{
        Type  "SBc"
        RA            0.7242
        Dec          -0.1253
        Distance   1.934e+08  # method: T-F
        Radius     4.501e+04
        AbsMag        -20.26
        Axis    [  0.1028   0.5796  -0.8084]
        Angle    194.4909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 237"
}

Galaxy "NGC 238:ESO 194-31:FAIR 663:AM 0041-502"
{
        Type  "SBb"
        RA            0.7236
        Dec         -50.1828
        Distance   3.822e+08  # method: V
        Radius     1.112e+05
        AbsMag        -22.14
        Axis    [  0.7534   0.6068  -0.2532]
        Angle    190.6502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 238"
}

Galaxy "NGC 239:MCG 1-3-7:IRAS 00420-0401"
{
        Type  "Sb"
        RA            0.7436
        Dec          -3.7600
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.2924   0.9049   0.3094]
        Angle    166.4263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 239"
}

Galaxy "NGC 240:UGC 473:MCG 1-3-1:ZWG 410.3"
{
        Type  "Sa"
        RA            0.7503
        Dec           6.1128
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.6808   0.6317   0.3708]
        Angle    126.5730
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 240"
}

Galaxy "NGC 243:MCG 5-2-43:ZWG 500.82:ZWG 501.1"
{
        Type  "S0"
        RA            0.7667
        Dec          29.9597
        Distance    2.03e+08  # method: V
        Radius     2.657e+04
        AbsMag        -19.37
        Axis    [ -0.1364   0.7813  -0.6091]
        Angle    191.2393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 243"
}

Galaxy "NGC 244:MCG 3-3-3:UGCA 10:VV 728"
{
        Type  "S0"
        RA            0.7628
        Dec         -15.5972
        Distance   2.877e+07  # method: V
        Radius          5021
        AbsMag        -15.83
        Axis    [  0.5844   0.8040   0.1097]
        Angle    172.1213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 244"
}

Galaxy "NGC 245:UGC 476:MCG 0-3-5:MK 555"
{
        Type  "Sb"
        RA            0.7681
        Dec          -1.7233
        Distance   1.697e+08  # method: V
        Radius     3.209e+04
        AbsMag        -20.48
        Axis    [  0.3450   0.7054  -0.6192]
        Angle    202.6866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 245"
}

Galaxy "NGC 247:ESO 540-22:MCG 4-3-5:UGCA 11"
{
        Type  "SBc"
        RA            0.7856
        Dec         -20.7600
        Distance   1.318e+07  # method: T-F
        Radius     3.681e+04
        AbsMag        -18.43
        Axis    [  0.1533   0.5713  -0.8063]
        Angle    167.0641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 247"
}

Galaxy "NGC 250:UGC 487:MCG 1-3-2:ZWG 410.5"
{
        Type  "Sa"
        RA            0.7878
        Dec           7.9100
        Distance   2.232e+08  # method: V
        Radius      3.57e+04
        AbsMag        -19.48
        Axis    [  0.0813   0.7334  -0.6749]
        Angle    190.6774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 250"
}

Galaxy "NGC 251:UGC 490:MCG 3-3-3:ZWG 458.5"
{
        Type  "Sc"
        RA            0.7981
        Dec          19.5969
        Distance   1.936e+08  # method: V
        Radius     6.757e+04
        AbsMag        -19.77
        Axis    [  0.2523   0.9310  -0.2637]
        Angle    177.5994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 251"
}

Galaxy "NGC 252:UGC 491:MCG 4-3-4:ZWG 480.7"
{
        Type  "Sa"
        RA            0.8003
        Dec          27.6233
        Distance   2.135e+08  # method: V
        Radius     4.347e+04
        AbsMag        -20.68
        Axis    [  0.1560   0.9775  -0.1421]
        Angle    165.7927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 252"
}

Galaxy "NGC 253:ESO 474-29:MCG 4-3-9:UGCA 13"
{
        Type  "SBc"
        RA            0.7925
        Dec         -25.2875
        Distance    1.21e+07  # method: T-F
        Radius     5.102e+04
        AbsMag        -19.84
        Axis    [  0.2739   0.9564   0.1013]
        Angle    182.3693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 253"
}

Galaxy "NGC 254:ESO 411-15:MCG 5-3-5:AM 0045-314"
{
        Type  "S0"
        RA            0.7908
        Dec         -31.4219
        Distance   6.156e+07  # method: V
        Radius     2.328e+04
        AbsMag        -18.78
        Axis    [  0.4710   0.6520  -0.5942]
        Angle    184.0231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 254"
}

Galaxy "NGC 255:MCG 2-3-17:IRAS 00452-1144"
{
        Type  "SBc"
        RA            0.7964
        Dec         -11.4683
        Distance    5.83e+07  # method: V
        Radius     2.629e+04
        AbsMag        -18.56
        Axis    [  0.5634   0.7331   0.3810]
        Angle    157.6405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 255"
}

Galaxy "NGC 257:UGC 493:MCG 1-3-3:ZWG 410.6"
{
        Type  "Sc"
        RA            0.8003
        Dec           8.2967
        Distance   2.703e+08  # method: T-F
        Radius     7.469e+04
        AbsMag        -21.19
        Axis    [  0.2523   0.9069  -0.3376]
        Angle    180.3763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 257"
}

Galaxy "NGC 258:MCG 4-3-5:NPM 1"
{
        Type  "Sb"
        RA            0.8033
        Dec          27.6578
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [  0.1686   0.9265  -0.3365]
        Angle    183.4090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 258"
}

Galaxy "NGC 259:MCG 1-3-15:IRAS 00455-0302"
{
        Type  "Sc"
        RA            0.8008
        Dec          -2.7758
        Distance   1.777e+08  # method: T-F
        Radius     7.496e+04
        AbsMag        -20.08
        Axis    [  0.0011   0.8052  -0.5930]
        Angle    167.7345
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 259"
}

Galaxy "NGC 260:UGC 497:MCG 4-3-6:ZWG 480.9"
{
        Type  "Sc"
        RA            0.8094
        Dec          27.6919
        Distance   2.219e+08  # method: V
        Radius     2.582e+04
        AbsMag        -19.86
        Axis    [  0.6222   0.7344   0.2713]
        Angle    111.2736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 260"
}

Galaxy "NGC 262:UGC 499:MCG 5-3-8:MK 348"
{
        Type  "Sa"
        RA            0.8131
        Dec          31.9575
        Distance   1.907e+08  # method: V
        Radius     3.051e+04
        AbsMag        -19.83
        Axis    [  0.6064   0.7551   0.2491]
        Angle    108.4587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 262"
}

Galaxy "NGC 263:MCG 2-3-21"
{
        Type  "Sc"
        RA            0.8133
        Dec         -13.1072
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.3183   0.9333   0.1665]
        Angle    173.9487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 263"
}

Galaxy "NGC 264:ESO 295-6:MCG 7-2-16"
{
        Type  "S0"
        RA            0.8056
        Dec         -38.2344
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.3848   0.8274  -0.4089]
        Angle    171.9452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 264"
}

Galaxy "NGC 266:UGC 508:MCG 5-3-9:ZWG 501.22"
{
        Type  "SBb"
        RA            0.8297
        Dec          32.2775
        Distance   1.977e+08  # method: V
        Radius     8.626e+04
        AbsMag        -21.31
        Axis    [  0.3317   0.9028  -0.2737]
        Angle    183.1810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 266"
}

Galaxy "NGC 268:MCG 1-3-17:IRAS 00476-0527"
{
        Type  "SBc"
        RA            0.8358
        Dec          -5.1939
        Distance   2.338e+08  # method: V
        Radius      5.44e+04
        AbsMag        -20.38
        Axis    [  0.4064   0.9079  -0.1032]
        Angle    173.4731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 268"
}

Galaxy "NGC 270:MCG 2-3-27"
{
        Type  "Sa"
        RA            0.8422
        Dec          -8.6517
        Distance   1.223e+08  # distance uncertain!
        Radius     3.024e+04
        AbsMag        -19.07
        Axis    [  0.4501   0.8350   0.3166]
        Angle    163.4082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 270"
}

Galaxy "NGC 271:UGC 519:MCG 0-3-12:ZWG 384.13"
{
        Type  "SBb"
        RA            0.8447
        Dec          -1.9106
        Distance   1.708e+08  # method: V
        Radius     5.465e+04
        AbsMag        -20.59
        Axis    [  0.3365   0.7795  -0.5283]
        Angle    192.0444
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 271"
}

Galaxy "NGC 273:MCG 1-3-19"
{
        Type  "S0"
        RA            0.8467
        Dec          -6.8856
        Distance   1.281e+08  # distance uncertain!
        Radius     3.912e+04
        AbsMag        -19.07
        Axis    [  0.1448   0.9375  -0.3165]
        Angle    170.8984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 273"
}

Galaxy "NGC 274:MCG 1-3-21:VV 81:ARP 140"
{
        Type  "S0"
        RA            0.8503
        Dec          -7.0567
        Distance    6.36e+07  # method: S
        Radius     1.295e+04
        AbsMag        -18.65
        Axis    [  0.5490   0.7822   0.2946]
        Angle    157.7551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 274"
}

Galaxy "NGC 275:MCG 1-3-22:VV 81:ARP 140"
{
        Type  "SBc"
        RA            0.8511
        Dec          -7.0653
        Distance   6.446e+07  # method: V
        Radius     1.406e+04
        AbsMag        -18.28
        Axis    [  0.4038   0.7636  -0.5038]
        Angle    191.5900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 275"
}

Galaxy "NGC 276:IC 1591:ESO 474-34:MCG 4-3-21"
{
        Type  "SBb"
        RA            0.8683
        Dec         -22.6803
        Distance   6.142e+08  # method: V
        Radius     8.933e+04
        AbsMag        -20.57
        Axis    [  0.3576   0.9056  -0.2279]
        Angle    176.0379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 276"
}

Galaxy "NGC 277:MCG 2-3-28:NPM 1"
{
        Type  "S0"
        RA            0.8547
        Dec          -8.5964
        Distance   1.854e+08  # method: V
        Radius     3.775e+04
        AbsMag        -19.07
        Axis    [  0.5670   0.8183   0.0939]
        Angle    167.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 277"
}

Galaxy "NGC 278:UGC 528:MCG 8-2-16:ZWG 550.16"
{
        Type  "SBb"
        RA            0.8678
        Dec          47.5508
        Distance   1.771e+07  # method: V
        Radius          5410
        AbsMag        -17.17
        Axis    [  0.3673   0.9083   0.2003]
        Angle    110.7079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 278"
}

Galaxy "NGC 279:UGC 532:MCG 0-3-19A:MK 558"
{
        Type  "Sa"
        RA            0.8689
        Dec          -2.2183
        Distance   1.614e+08  # method: V
        Radius     3.755e+04
        AbsMag        -19.67
        Axis    [  0.2423   0.6591  -0.7120]
        Angle    199.1316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 279"
}

Galaxy "NGC 280:UGC 534:MCG 4-3-13:ZWG 480.17"
{
        Type  "SBa"
        RA            0.8750
        Dec          24.3508
        Distance   4.057e+08  # method: T-F
        Radius     1.003e+05
        AbsMag        -21.17
        Axis    [  0.1126   0.9618  -0.2497]
        Angle    171.9133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 280"
}

Galaxy "NGC 282:MCG 5-3-15:ZWG 501.30"
{
        Type  "E0"
        RA            0.8783
        Dec          30.6389
        Distance    3.02e+08  # distance uncertain!
        Radius     4.393e+04
        AbsMag        -20.13
        Axis    [  0.5741   0.8175  -0.0473]
        Angle    147.1331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 282"
}

Galaxy "NGC 283:MCG 2-3-31:NPM 1:IRAS 00507-1326"
{
        Type  "Sc"
        RA            0.8869
        Dec         -13.1633
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [  0.2714   0.6545  -0.7057]
        Angle    187.1487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 283"
}

Galaxy "NGC 284:MCG 2-3-33:NPM 1"
{
        Type  "E0"
        RA            0.8900
        Dec         -13.1583
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.7583   0.5181   0.3957]
        Angle    140.7722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 284"
}

Galaxy "NGC 285:KAZ 377:NPM 1"
{
        Type  "S0"
        RA            0.8914
        Dec         -13.1603
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.3851   0.8074   0.4470]
        Angle    168.3716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 285"
}

Galaxy "NGC 286:MCG 2-3-34:NPM 1:AM 0051-132"
{
        Type  "S0"
        RA            0.8917
        Dec         -13.1122
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [  0.4521   0.7765   0.4389]
        Angle    164.1420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 286"
}

Galaxy "NGC 287:ZWG 501.33"
{
        Type  "Sa"
        RA            0.8911
        Dec          32.4825
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.0833   0.9318   0.3533]
        Angle    138.1234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 287"
}

Galaxy "NGC 289:ESO 411-25:MCG 5-3-10:VV 484"
{
        Type  "SBc"
        RA            0.8783
        Dec         -31.2056
        Distance   6.211e+07  # method: V
        Radius     4.607e+04
        AbsMag         -19.7
        Axis    [  0.5109   0.6621  -0.5482]
        Angle    185.2136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 289"
}

Galaxy "NGC 291:MCG 2-3-35:IRAS 00510-0901"
{
        Type  "Sa"
        RA            0.8914
        Dec          -8.7675
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.3632   0.9181   0.1589]
        Angle    169.1353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 291"
}

Galaxy "NGC 293:MCG 1-3-30:IRAS 00517-0730"
{
        Type  "SBb"
        RA            0.9044
        Dec          -7.2356
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.5192   0.7812   0.3467]
        Angle    156.9192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 293"
}

Galaxy "NGC 296:UGC 562:MCG 5-3-24:ZWG 501.42"
{
        Type  "SBb"
        RA            0.9186
        Dec          31.5422
        Distance    1.95e+08  # method: T-F
        Radius     6.239e+04
        AbsMag        -20.68
        Axis    [ -0.1669   0.7053  -0.6890]
        Angle    196.2437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 296"
}

Galaxy "NGC 297"
{
        Type  "E0"
        RA            0.9161
        Dec          -7.3503
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.7395   0.6230  -0.2548]
        Angle    191.6200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 297"
}

Galaxy "NGC 298:MCG 1-3-33"
{
        Type  "Sc"
        RA            0.9172
        Dec          -7.3336
        Distance   6.514e+07  # method: V
        Radius     1.611e+04
        AbsMag           -17
        Axis    [  0.1230   0.9692  -0.2135]
        Angle    168.9480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 298"
}

Galaxy "NGC 300:ESO 295-20:MCG 6-3-5:AM 0052-375"
{
        Type  "Sc"
        RA            0.9147
        Dec         -37.6842
        Distance     7.1e+06  # method: CN
        Radius     1.962e+04
        AbsMag        -17.88
        Axis    [  0.5869   0.7014  -0.4044]
        Angle    183.2719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 300"
}

Galaxy "NGC 301"
{
        Type  "S0"
        RA            0.9383
        Dec         -10.6733
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.4724   0.8789  -0.0665]
        Angle    173.1732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 301"
}

Galaxy "NGC 303"
{
        Type  "Sa"
        RA            0.9150
        Dec         -16.6550
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.2026   0.6488  -0.7335]
        Angle    175.5594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 303"
}

Galaxy "NGC 304:UGC 573:MCG 4-3-18:ZWG 480.23"
{
        Type  "S0"
        RA            0.9350
        Dec          24.1272
        Distance   2.114e+08  # method: V
        Radius     3.382e+04
        AbsMag        -20.06
        Axis    [ -0.0525   0.6514  -0.7569]
        Angle    207.3173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 304"
}

Galaxy "NGC 307:UGC 584:MCG 0-3-35:ZWG 384.39"
{
        Type  "S0"
        RA            0.9422
        Dec          -1.7722
        Distance   1.666e+08  # method: V
        Radius     3.877e+04
        AbsMag        -19.74
        Axis    [  0.2186   0.9592  -0.1794]
        Angle    170.2294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 307"
}

Galaxy "NGC 309:MCG 2-3-50:IRAS 00542-1010"
{
        Type  "SBc"
        RA            0.9450
        Dec          -9.9142
        Distance   2.423e+08  # method: V
        Radius     1.057e+05
        AbsMag        -21.75
        Axis    [  0.2521   0.5238  -0.8137]
        Angle    203.1701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 309"
}

Galaxy "NGC 311:UGC 592:MCG 5-3-28:ZWG 501.49"
{
        Type  "S0"
        RA            0.9589
        Dec          30.2803
        Distance   2.158e+08  # method: V
        Radius     4.708e+04
        AbsMag         -20.1
        Axis    [ -0.0527   0.9083  -0.4150]
        Angle    179.0737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 311"
}

Galaxy "NGC 312:ESO 151-6:AM 0054-530"
{
        Type  "E2"
        RA            0.9375
        Dec         -52.7831
        Distance    3.63e+08  # method: T-F
        Radius     7.392e+04
        AbsMag        -21.83
        Axis    [  0.9473   0.3160   0.0523]
        Angle    189.0566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 312"
}

Galaxy "NGC 314:ESO 411-32:MCG 5-3-15:IRAS 00544-3214"
{
        Type  "S0"
        RA            0.9478
        Dec         -31.9631
        Distance    1.47e+08  # distance uncertain!
        Radius     1.925e+04
        AbsMag        -19.07
        Axis    [  0.4557   0.4159  -0.7870]
        Angle    200.0477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 314"
}

Galaxy "NGC 315:UGC 597:MCG 5-3-31:ZWG 501.52"
{
        Type  "E0"
        RA            0.9636
        Dec          30.3519
        Distance   2.184e+08  # method: T-F
        Radius      9.53e+04
        AbsMag        -21.93
        Axis    [  0.5922   0.8057  -0.0160]
        Angle    140.6039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 315"
}

Galaxy "NGC 317-2:NGC 317B:UGC 594:MCG 7-3-10"
{
        Type  "SBc"
        RA            0.9611
        Dec          43.7919
        Distance   2.296e+08  # method: V
        Radius     3.674e+04
        AbsMag        -20.34
        Axis    [ -0.1889   0.9405  -0.2823]
        Angle    169.4147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 317-2"
}

Galaxy "NGC 317A:NGC 317-1:UGC 593:MCG 7-3-9"
{
        Type  "S0"
        RA            0.9608
        Dec          43.8014
        Distance    2.28e+08  # method: V
        Radius     4.643e+04
        AbsMag        -19.72
        Axis    [  0.1556   0.9330  -0.3245]
        Angle    186.6778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 317A"
}

Galaxy "NGC 318:ZWG 501.54:NPM 1"
{
        Type  "S0"
        RA            0.9681
        Dec          30.4261
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.1824   0.8882   0.4217]
        Angle    132.4693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 318"
}

Galaxy "NGC 319:ESO 243-13:MCG 7-3-1"
{
        Type  "SBa"
        RA            0.9492
        Dec         -43.8386
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.5616   0.4661  -0.6836]
        Angle    187.4222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 319"
}

Galaxy "NGC 320:ESO 541-3:MCG 4-3-37:IRAS 00563-2106"
{
        Type  "SBa"
        RA            0.9794
        Dec         -20.8403
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.3052   0.5952  -0.7434]
        Angle    183.9505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 320"
}

Galaxy "NGC 321:MCG 1-3-43:NPM 1"
{
        Type  "SBc"
        RA            0.9608
        Dec          -5.0858
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.4224   0.8638  -0.2745]
        Angle    178.4372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 321"
}

Galaxy "NGC 322-1:ESO 243-15:MCG 7-3-3:AM 0054-435"
{
        Type  "S0"
        RA            0.9528
        Dec         -43.7269
        Distance   3.119e+08  # method: V
        Radius     4.082e+04
        AbsMag         -20.6
        Axis    [  0.4220   0.5762  -0.6999]
        Angle    167.4470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 322-1"
}

Galaxy "NGC 322-2"
{
        Type  "S0"
        RA            0.9525
        Dec         -43.7300
        Distance    6.13e+08  # distance uncertain!
        Radius     1.337e+04
        AbsMag        -19.07
        Axis    [  0.6599   0.7513   0.0090]
        Angle    186.4770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 322-2"
}

Galaxy "NGC 323:ESO 151-9:AM 0054-531"
{
        Type  "E0"
        RA            0.9447
        Dec         -52.9758
        Distance    3.63e+08  # method: T-F
        Radius     6.864e+04
        AbsMag        -21.63
        Axis    [  0.5928   0.1121  -0.7975]
        Angle    215.5197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 323"
}

Galaxy "NGC 324:ESO 295-25:MCG 7-3-2:AM 0054-411"
{
        Type  "Sa"
        RA            0.9539
        Dec         -40.9594
        Distance   1.461e+08  # method: V
        Radius     2.974e+04
        AbsMag        -19.25
        Axis    [  0.4715   0.8375  -0.2760]
        Angle    177.1654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 324"
}

Galaxy "NGC 325:MCG 1-3-45:FGC 111"
{
        Type  "Sc"
        RA            0.9631
        Dec          -5.1125
        Distance   2.676e+08  # distance uncertain!
        Radius     5.059e+04
        AbsMag        -19.07
        Axis    [  0.0683   0.9739  -0.2167]
        Angle    166.8394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 325"
}

Galaxy "NGC 326:UGC 601:MCG 4-3-25:ZWG 480.26"
{
        Type  "E0"
        RA            0.9728
        Dec          26.8658
        Distance   6.266e+08  # method: V
        Radius     1.276e+05
        AbsMag        -22.12
        Axis    [  0.6636   0.7037   0.2540]
        Angle    109.6712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 326"
}

Galaxy "NGC 327:MCG 1-3-47"
{
        Type  "Sc"
        RA            0.9653
        Dec          -5.1308
        Distance   2.845e+08  # method: T-F
        Radius     6.207e+04
        AbsMag         -20.4
        Axis    [  0.0625   0.5721  -0.8178]
        Angle    179.4168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 327"
}

Galaxy "NGC 328:ESO 151-13:AM 0054-531"
{
        Type  "SBa"
        RA            0.9492
        Dec         -52.9236
        Distance   2.103e+08  # method: V
        Radius     7.954e+04
        AbsMag        -19.75
        Axis    [  0.4529   0.8363  -0.3090]
        Angle    173.2992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 328"
}

Galaxy "NGC 329:MCG 1-3-48"
{
        Type  "Sb"
        RA            0.9669
        Dec          -5.0706
        Distance    1.54e+08  # distance uncertain!
        Radius     3.359e+04
        AbsMag        -19.07
        Axis    [  0.2626   0.8886   0.3760]
        Angle    166.9830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 329"
}

Galaxy "NGC 331:MCG 1-3-12"
{
        Type  "Sa"
        RA            0.7850
        Dec          -2.7311
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.2457   0.7851  -0.5686]
        Angle    187.3874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 331"
}

Galaxy "NGC 332:UGC 609:ZWG 410.21"
{
        Type  "E0"
        RA            0.9803
        Dec           7.1111
        Distance   2.754e+08  # distance uncertain!
        Radius     4.006e+04
        AbsMag        -20.13
        Axis    [  0.4323   0.6094  -0.6646]
        Angle    235.2830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 332"
}

Galaxy "NGC 333:NGC 333A:MCG 3-3-13"
{
        Type  "E0"
        RA            0.9808
        Dec         -16.4689
        Distance   3.312e+08  # distance uncertain!
        Radius     7.706e+04
        AbsMag        -20.13
        Axis    [  0.7315   0.5345  -0.4234]
        Angle    205.8772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 333"
}

Galaxy "NGC 333B"
{
        Type  "S0"
        RA            0.9806
        Dec         -16.4719
        Distance   2.802e+08  # distance uncertain!
        Radius     1.223e+04
        AbsMag        -19.07
        Axis    [  0.4862   0.8725  -0.0490]
        Angle    174.4003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 333B"
}

Galaxy "NGC 334:ESO 351-26:MCG 6-3-12:IRAS 00564-3523"
{
        Type  "SBb"
        RA            0.9803
        Dec         -35.1156
        Distance   4.059e+08  # method: V
        Radius     7.085e+04
        AbsMag        -20.87
        Axis    [  0.4384   0.7410   0.5086]
        Angle    188.4047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 334"
}

Galaxy "NGC 335:ESO 541-6:MCG 3-3-15:IRAS 00568-1830"
{
        Type  "Sc"
        RA            0.9886
        Dec         -18.2342
        Distance   2.366e+08  # method: V
        Radius     3.785e+04
        AbsMag         -19.2
        Axis    [  0.1831   0.7827  -0.5948]
        Angle    166.6372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 335"
}

Galaxy "NGC 336:ESO 541-2:IRAS 00555-1839"
{
        Type  "S0"
        RA            0.9675
        Dec         -18.3858
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.3073   0.9314   0.1950]
        Angle    176.6940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 336"
}

Galaxy "NGC 337:MCG 1-3-53:IRAS 00573-0750"
{
        Type  "SBc"
        RA            0.9969
        Dec          -7.5781
        Distance   6.048e+07  # method: V
        Radius     2.639e+04
        AbsMag        -19.04
        Axis    [  0.2490   0.7431  -0.6211]
        Angle    183.6723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 337"
}

Galaxy "NGC 337A:MCG 1-3-65:IRAS 00589-0751"
{
        Type  "Irr"
        RA            1.0258
        Dec          -7.5883
        Distance   3.438e+07  # method: V
        Radius     3.301e+04
        AbsMag        -17.31
        Axis    [  0.4811   0.7683   0.4223]
        Angle    156.2228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 337A"
}

Galaxy "NGC 338:UGC 624:MCG 5-3-34:ZWG 501.61"
{
        Type  "Sb"
        RA            1.0100
        Dec          30.6692
        Distance   2.546e+08  # method: T-F
        Radius     6.666e+04
        AbsMag        -20.76
        Axis    [ -0.1555   0.9316  -0.3285]
        Angle    168.3597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 338"
}

Galaxy "NGC 340:MCG 1-3-55:IRAS 00580-0708"
{
        Type  "Sb"
        RA            1.0094
        Dec          -6.8661
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.2870   0.9578  -0.0119]
        Angle    169.0955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 340"
}

Galaxy "NGC 341:NGC 341A:MCG 2-3-63:MK 968"
{
        Type  "SBc"
        RA            1.0125
        Dec          -9.1861
        Distance   1.894e+08  # method: V
        Radius     3.307e+04
        AbsMag        -20.02
        Axis    [  0.6315   0.7745   0.0363]
        Angle    167.2017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 341"
}

Galaxy "NGC 341B:MCG 2-3-64:MK 968:ARP 59"
{
        Type  "E0"
        RA            1.0131
        Dec          -9.1872
        Distance   7.245e+08  # distance uncertain!
        Radius     3.161e+04
        AbsMag        -20.13
        Axis    [  0.7538   0.5187   0.4034]
        Angle    135.1685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 341B"
}

Galaxy "NGC 342:MCG 1-3-58:NPM 1"
{
        Type  "E0"
        RA            1.0136
        Dec          -6.7722
        Distance   4.169e+08  # distance uncertain!
        Radius     4.851e+04
        AbsMag        -20.13
        Axis    [  0.7099   0.6156  -0.3421]
        Angle    197.9606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 342"
}

Galaxy "NGC 343:AM 0055-232"
{
        Type  "S0"
        RA            0.9731
        Dec         -23.2244
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [  0.3670   0.8169   0.4450]
        Angle    180.3831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 343"
}

Galaxy "NGC 344:AM 0055-232"
{
        Type  "S0"
        RA            0.9736
        Dec         -23.2289
        Distance   5.098e+08  # distance uncertain!
        Radius     2.966e+04
        AbsMag        -19.07
        Axis    [  0.4364   0.8863   0.1550]
        Angle    177.1801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 344"
}

Galaxy "NGC 345:MCG 1-3-64"
{
        Type  "Sa"
        RA            1.0228
        Dec          -6.8842
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.2851   0.7476  -0.5998]
        Angle    185.9987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 345"
}

Galaxy "NGC 347:MCG 1-3-63"
{
        Type  "S0"
        RA            1.0264
        Dec          -6.7336
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.3352   0.8239  -0.4570]
        Angle    181.3120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 347"
}

Galaxy "NGC 348:ESO 151-17"
{
        Type  "Sb"
        RA            1.0142
        Dec         -53.2450
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.8116   0.5252  -0.2560]
        Angle    190.5622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 348"
}

Galaxy "NGC 349:MCG 1-3-68"
{
        Type  "S0"
        RA            1.0306
        Dec          -6.7997
        Distance   1.404e+08  # distance uncertain!
        Radius     2.655e+04
        AbsMag        -19.07
        Axis    [  0.6275   0.7746   0.0788]
        Angle    163.2662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 349"
}

Galaxy "NGC 350:MCG 1-3-69:NPM 1"
{
        Type  "S0"
        RA            1.0322
        Dec          -6.7953
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.4339   0.8844  -0.1721]
        Angle    173.5317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 350"
}

Galaxy "NGC 351:UGC 639:MCG 0-3-57:ZWG 384.57"
{
        Type  "SBa"
        RA            1.0325
        Dec          -1.9364
        Distance   1.755e+08  # method: V
        Radius     3.829e+04
        AbsMag        -19.55
        Axis    [  0.1681   0.7643  -0.6226]
        Angle    181.4449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 351"
}

Galaxy "NGC 352:MCG 1-3-71:IRAS 00596-0430"
{
        Type  "SBb"
        RA            1.0358
        Dec          -4.2453
        Distance   2.249e+08  # method: V
        Radius      7.85e+04
        AbsMag        -20.69
        Axis    [  0.0461   0.6427  -0.7647]
        Angle    173.9413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 352"
}

Galaxy "NGC 353:UGC 641:MCG 0-3-58:ZWG 384.58"
{
        Type  "SBa"
        RA            1.0400
        Dec          -1.9569
        Distance   1.748e+08  # method: V
        Radius     3.305e+04
        AbsMag        -19.04
        Axis    [  0.1945   0.9223   0.3339]
        Angle    166.4325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 353"
}

Galaxy "NGC 354:UGC 645:MCG 4-3-37:MK 353"
{
        Type  "SBa"
        RA            1.0544
        Dec          22.3428
        Distance   1.547e+08  # method: T-F
        Radius       1.8e+04
        AbsMag        -19.08
        Axis    [  0.1530   0.9435   0.2940]
        Angle    145.5190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 354"
}

Galaxy "NGC 355:MCG 1-3-77:NPM 1"
{
        Type  "S0"
        RA            1.0517
        Dec          -6.3236
        Distance   3.868e+08  # distance uncertain!
        Radius     5.625e+04
        AbsMag        -19.07
        Axis    [  0.2609   0.9652   0.0161]
        Angle    168.1255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 355"
}

Galaxy "NGC 356:MCG 1-3-78:VV 486:IRAS 01005-0715"
{
        Type  "Sc"
        RA            1.0519
        Dec          -6.9881
        Distance   2.527e+08  # method: V
        Radius     6.615e+04
        AbsMag        -20.55
        Axis    [  0.4334   0.8981   0.0749]
        Angle    166.4272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 356"
}

Galaxy "NGC 357:MCG 1-3-81"
{
        Type  "SBa"
        RA            1.0558
        Dec          -6.3392
        Distance   1.008e+08  # method: V
        Radius     3.667e+04
        AbsMag        -19.35
        Axis    [  0.4422   0.8635   0.2427]
        Angle    161.8628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 357"
}

Galaxy "NGC 359:UGC 662:MCG 0-3-66:ZWG 384.66"
{
        Type  "S0"
        RA            1.0711
        Dec          -0.7644
        Distance   1.612e+08  # distance uncertain!
        Radius     3.517e+04
        AbsMag        -19.07
        Axis    [  0.2828   0.7706  -0.5712]
        Angle    188.6934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 359"
}

Galaxy "NGC 360:ESO 79-14:FGCE 119"
{
        Type  "Sc"
        RA            1.0475
        Dec         -65.6089
        Distance   1.071e+08  # method: T-F
        Radius      5.61e+04
        AbsMag        -19.18
        Axis    [  0.5037   0.6235  -0.5979]
        Angle    150.7764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 360"
}

Galaxy "NGC 363:MCG 3-3-23:NPM 1"
{
        Type  "S0"
        RA            1.1042
        Dec         -16.5422
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6096   0.7869   0.0963]
        Angle    168.8366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 363"
}

Galaxy "NGC 364:UGC 666:MCG 0-3-69:ZWG 384.67"
{
        Type  "S0"
        RA            1.0778
        Dec          -0.8028
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [  0.5385   0.8094   0.2341]
        Angle    153.1082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 364"
}

Galaxy "NGC 365:ESO 352-1:MCG 6-3-17:IRAS 01019-3523"
{
        Type  "SBc"
        RA            1.0717
        Dec         -35.1222
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.5033   0.7217   0.4752]
        Angle    183.8733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 365"
}

Galaxy "NGC 367"
{
        Type  "S0"
        RA            1.0967
        Dec         -12.1283
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [  0.3962   0.8262   0.4006]
        Angle    166.5784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 367"
}

Galaxy "NGC 368:ESO 243-23"
{
        Type  "SBa"
        RA            1.0725
        Dec         -43.2761
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [  0.4834   0.3549  -0.8002]
        Angle    190.9235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 368"
}

Galaxy "NGC 369:ESO 541-17:MCG 3-3-22"
{
        Type  "SBb"
        RA            1.0856
        Dec         -17.7592
        Distance    2.67e+08  # method: V
        Radius     3.883e+04
        AbsMag        -19.97
        Axis    [  0.5917   0.8026   0.0756]
        Angle    170.7087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 369"
}

Galaxy "NGC 373"
{
        Type  "E0"
        RA            1.1161
        Dec          32.3089
        Distance   5.249e+08  # distance uncertain!
        Radius     3.053e+04
        AbsMag        -20.13
        Axis    [  0.6584   0.7193   0.2216]
        Angle    104.8726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 373"
}

Galaxy "NGC 374:UGC 680:MCG 5-3-48:ZWG 501.80"
{
        Type  "Sa"
        RA            1.1181
        Dec          32.7947
        Distance   2.165e+08  # method: V
        Radius     3.464e+04
        AbsMag        -19.71
        Axis    [ -0.1983   0.6448  -0.7382]
        Angle    198.6711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 374"
}

Galaxy "NGC 375:ARP 331:NPM 1"
{
        Type  "E2"
        RA            1.1181
        Dec          32.3486
        Distance   2.593e+08  # method: V
        Radius     1.885e+04
        AbsMag           -19
        Axis    [  0.6584   0.7193   0.2214]
        Angle    104.8298
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 375"
}

Galaxy "NGC 377:ESO 541-19:MCG 4-3-53:IRAS 01041-2036"
{
        Type  "Sc"
        RA            1.1097
        Dec         -20.3314
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.2721   0.9202   0.2814]
        Angle    179.4974
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 377"
}

Galaxy "NGC 378:ESO 412-5:MCG 5-3-24:AM 0103-302"
{
        Type  "SBc"
        RA            1.1033
        Dec         -30.1781
        Distance   4.242e+08  # method: V
        Radius     9.254e+04
        AbsMag        -21.77
        Axis    [  0.5752   0.7299  -0.3695]
        Angle    181.9634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 378"
}

Galaxy "NGC 379:UGC 683:MCG 5-3-50:ZWG 501.82"
{
        Type  "S0"
        RA            1.1208
        Dec          32.5203
        Distance   2.228e+08  # method: T-F
        Radius     4.537e+04
        AbsMag        -20.27
        Axis    [  0.1459   0.8388   0.5246]
        Angle    130.2065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 379"
}

Galaxy "NGC 380:UGC 682:MCG 5-3-51:ZWG 501.81"
{
        Type  "E2"
        RA            1.1214
        Dec          32.4828
        Distance   2.228e+08  # method: T-F
        Radius     4.213e+04
        AbsMag        -20.57
        Axis    [  0.6583   0.7197   0.2206]
        Angle    104.7129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 380"
}

Galaxy "NGC 382:UGC 688:MCG 5-3-52:ZWG 501.86"
{
        Type  "E0"
        RA            1.1231
        Dec          32.4033
        Distance   2.228e+08  # method: T-F
        Radius     2.268e+04
        AbsMag        -19.97
        Axis    [  0.6587   0.7192   0.2210]
        Angle    104.7509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 382"
}

Galaxy "NGC 383:UGC 689:MCG 5-3-53:ZWG 501.87"
{
        Type  "S0"
        RA            1.1233
        Dec          32.4122
        Distance   2.228e+08  # method: T-F
        Radius     6.481e+04
        AbsMag        -20.97
        Axis    [  0.3367   0.9236   0.1835]
        Angle    131.4815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 383"
}

Galaxy "NGC 384:UGC 686:MCG 5-3-55:ZWG 501.84"
{
        Type  "E3"
        RA            1.1236
        Dec          32.2928
        Distance   1.862e+08  # method: V
        Radius     2.979e+04
        AbsMag        -19.78
        Axis    [  0.3786   0.8173  -0.4344]
        Angle    214.0292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 384"
}

Galaxy "NGC 385:UGC 687:MCG 5-3-56:ZWG 501.85"
{
        Type  "S0"
        RA            1.1242
        Dec          32.3194
        Distance   2.228e+08  # method: T-F
        Radius     3.564e+04
        AbsMag        -20.17
        Axis    [  0.1295   0.8280  -0.5456]
        Angle    209.1605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 385"
}

Galaxy "NGC 386:MCG 5-3-57:ZWG 501.88:ARAK 27"
{
        Type  "E3"
        RA            1.1253
        Dec          32.3625
        Distance   2.386e+08  # method: V
        Radius     1.388e+04
        AbsMag        -18.82
        Axis    [  0.6468   0.7453   0.1618]
        Angle    111.3510
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 386"
}

Galaxy "NGC 387"
{
        Type  "E0"
        RA            1.1258
        Dec          32.3908
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.6591   0.7189   0.2210]
        Angle    104.7353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 387"
}

Galaxy "NGC 388:MCG 5-3-59:ZWG 501.90:ARAK 28"
{
        Type  "E1"
        RA            1.1297
        Dec          32.3106
        Distance   2.186e+08  # method: V
        Radius     1.908e+04
        AbsMag        -18.53
        Axis    [  0.2766   0.7766  -0.5660]
        Angle    237.9289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 388"
}

Galaxy "NGC 389:UGC 703:MCG 6-3-14:ZWG 520.17"
{
        Type  "Sa"
        RA            1.1414
        Dec          39.6950
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [ -0.1412   0.9814   0.1302]
        Angle    144.9564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 389"
}

Galaxy "NGC 391:UGC 693:MCG 0-3-75:ZWG 384.77"
{
        Type  "S0"
        RA            1.1228
        Dec           0.9258
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.4660   0.8762   0.1227]
        Angle    158.1518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 391"
}

Galaxy "NGC 392:UGC 700:MCG 5-3-62:ZWG 501.94"
{
        Type  "S0"
        RA            1.1397
        Dec          33.1333
        Distance   2.228e+08  # method: T-F
        Radius     3.889e+04
        AbsMag        -20.47
        Axis    [  0.2114   0.9751   0.0665]
        Angle    143.0416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 392"
}

Galaxy "NGC 393:UGC 707:MCG 6-3-15:ZWG 520.18"
{
        Type  "S0"
        RA            1.1433
        Dec          39.6439
        Distance   1.017e+08  # distance uncertain!
        Radius     2.515e+04
        AbsMag        -19.07
        Axis    [  0.2658   0.9452   0.1894]
        Angle    126.8213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 393"
}

Galaxy "NGC 394:MCG 5-3-63:ZWG 501.95:ARAK 30"
{
        Type  "S0"
        RA            1.1406
        Dec          33.1478
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [ -0.1124   0.8774  -0.4665]
        Angle    179.7005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 394"
}

Galaxy "NGC 396"
{
        Type  "S0"
        RA            1.1356
        Dec           4.5308
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.3949   0.9152  -0.0803]
        Angle    164.8773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 396"
}

Galaxy "NGC 397:MCG 5-3-64:ZWG 501.96:NPM 1"
{
        Type  "E0"
        RA            1.1419
        Dec          33.1097
        Distance   5.012e+08  # distance uncertain!
        Radius     5.103e+04
        AbsMag        -20.13
        Axis    [  0.5641   0.8211  -0.0870]
        Angle    146.3347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 397"
}

Galaxy "NGC 398:MCG 5-3-65:ZWG 501.100:ARAK 31"
{
        Type  "S0"
        RA            1.1481
        Dec          32.5150
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.0664   0.8269  -0.5585]
        Angle    191.7182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 398"
}

Galaxy "NGC 399:UGC 712:MCG 5-3-67:ZWG 501.101"
{
        Type  "SBa"
        RA            1.1497
        Dec          32.6336
        Distance   2.233e+08  # method: V
        Radius     2.923e+04
        AbsMag        -19.68
        Axis    [  0.2572   0.9570   0.1340]
        Angle    137.6218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 399"
}

Galaxy "NGC 403:UGC 715:MCG 5-3-68:ZWG 501.104"
{
        Type  "Sa"
        RA            1.1539
        Dec          32.7517
        Distance   2.164e+08  # method: V
        Radius     5.665e+04
        AbsMag        -20.71
        Axis    [ -0.1326   0.9808  -0.1432]
        Angle    157.8742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 403"
}

Galaxy "NGC 404:UGC 718:MCG 6-3-18:ZWG 520.20"
{
        Type  "S0"
        RA            1.1572
        Dec          35.7183
        Distance   1.065e+07  # method: S
        Radius          5423
        AbsMag        -16.57
        Axis    [  0.6270   0.7467   0.2223]
        Angle    102.9214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 404"
}

Galaxy "NGC 406:ESO 51-18:IRAS 01057-7008"
{
        Type  "Sc"
        RA            1.1233
        Dec         -69.8761
        Distance   7.651e+07  # method: T-F
        Radius     2.893e+04
        AbsMag        -18.85
        Axis    [  0.5552   0.4338  -0.7096]
        Angle    152.5502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 406"
}

Galaxy "NGC 407:UGC 730:MCG 5-3-77:ZWG 501.115"
{
        Type  "Sa"
        RA            1.1767
        Dec          33.1253
        Distance   2.413e+08  # method: V
        Radius     6.317e+04
        AbsMag        -19.94
        Axis    [ -0.0145   0.8137   0.5811]
        Angle    141.5747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 407"
}

Galaxy "NGC 409:ESO 352-12:MCG 6-3-23"
{
        Type  "E0"
        RA            1.1592
        Dec         -35.8056
        Distance   2.861e+08  # method: V
        Radius     5.409e+04
        AbsMag        -20.71
        Axis    [  0.5373   0.2495  -0.8057]
        Angle    222.1336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 409"
}

Galaxy "NGC 410:UGC 735:MCG 5-3-80:ZWG 501.118"
{
        Type  "E0"
        RA            1.1828
        Dec          33.1525
        Distance   2.228e+08  # method: T-F
        Radius     7.777e+04
        AbsMag        -21.67
        Axis    [  0.6124   0.7899   0.0324]
        Angle    126.4838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 410"
}

Galaxy "NGC 413:MCG 1-4-13"
{
        Type  "Sc"
        RA            1.2086
        Dec          -2.7933
        Distance    2.49e+08  # method: V
        Radius     4.345e+04
        AbsMag        -19.51
        Axis    [  0.1679   0.7097  -0.6842]
        Angle    183.0848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 413"
}

Galaxy "NGC 414:UGC 744:ZWG 501.123:ZW 39"
{
        Type  "S0"
        RA            1.1881
        Dec          33.1136
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [  0.1219   0.9658   0.2290]
        Angle    137.6882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 414"
}

Galaxy "NGC 415:ESO 352-14:MCG 6-3-24:IRAS 01077-3545"
{
        Type  "SBb"
        RA            1.1681
        Dec         -35.4903
        Distance   2.761e+08  # method: T-F
        Radius     6.024e+04
        AbsMag        -20.34
        Axis    [  0.5465   0.8359   0.0521]
        Angle    180.9619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 415"
}

Galaxy "NGC 417:ESO 541-24:MCG 3-4-19:NPM 1"
{
        Type  "S0"
        RA            1.1847
        Dec         -18.1486
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.6224   0.7816   0.0412]
        Angle    170.3671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 417"
}

Galaxy "NGC 418:ESO 412-9:MCG 5-4-2:AM 0108-302"
{
        Type  "SBc"
        RA            1.1764
        Dec         -30.2211
        Distance   2.471e+08  # method: V
        Radius     7.187e+04
        AbsMag         -21.3
        Axis    [  0.6460   0.6457   0.4072]
        Angle    169.6802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 418"
}

Galaxy "NGC 420:UGC 752:MCG 5-3-83:ZWG 501.127"
{
        Type  "S0"
        RA            1.2025
        Dec          32.1231
        Distance   2.124e+08  # method: V
        Radius     6.179e+04
        AbsMag        -20.87
        Axis    [  0.0341   0.7269  -0.6859]
        Angle    224.6198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 420"
}

Galaxy "NGC 423:ESO 412-11:MCG 5-4-4:IRAS 01090-2929"
{
        Type  "Sa"
        RA            1.1894
        Dec         -29.2344
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.3792   0.8139  -0.4402]
        Angle    170.2735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 423"
}

Galaxy "NGC 424:ESO 296-4:MCG 6-3-26:AM 0109-382"
{
        Type  "SBa"
        RA            1.1908
        Dec         -38.0836
        Distance   1.461e+08  # method: V
        Radius     4.887e+04
        AbsMag        -19.46
        Axis    [  0.4644   0.8856   0.0045]
        Angle    181.5337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 424"
}

Galaxy "NGC 425:UGC 758:MCG 6-3-23:ZWG 520.26"
{
        Type  "S0"
        RA            1.2172
        Dec          38.7692
        Distance   2.759e+08  # method: V
        Radius     4.013e+04
        AbsMag        -21.04
        Axis    [  0.2034   0.9789   0.0195]
        Angle    141.4495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 425"
}

Galaxy "NGC 426:UGC 760:MCG 0-4-35:ZWG 385.26"
{
        Type  "E0"
        RA            1.2133
        Dec          -0.2897
        Distance   2.242e+08  # method: V
        Radius     4.566e+04
        AbsMag        -20.39
        Axis    [  0.5630   0.6134  -0.5539]
        Angle    215.9298
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 426"
}

Galaxy "NGC 427:ESO 412-14:MCG 5-4-7"
{
        Type  "SBa"
        RA            1.2053
        Dec         -32.0611
        Distance   4.424e+08  # method: V
        Radius     6.434e+04
        AbsMag        -20.56
        Axis    [  0.4921   0.7085   0.5058]
        Angle    180.5470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 427"
}

Galaxy "NGC 428:UGC 763:MCG 0-4-36:ZWG 385.28"
{
        Type  "Irr"
        RA            1.2153
        Dec           0.9814
        Distance   3.837e+07  # method: V
        Radius     2.232e+04
        AbsMag        -18.45
        Axis    [  0.3024   0.8294  -0.4698]
        Angle    181.4719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 428"
}

Galaxy "NGC 429:UGC 762:MCG 0-4-37:ZWG 385.27"
{
        Type  "S0"
        RA            1.2158
        Dec          -0.3450
        Distance   2.415e+08  # method: V
        Radius     4.917e+04
        AbsMag        -19.95
        Axis    [  0.1310   0.9077   0.3987]
        Angle    167.2927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 429"
}

Galaxy "NGC 430:UGC 765:MCG 0-4-39:ZWG 385.29"
{
        Type  "E0"
        RA            1.2164
        Dec          -0.2525
        Distance   2.251e+08  # method: V
        Radius     4.257e+04
        AbsMag        -20.69
        Axis    [  0.4997   0.5826  -0.6410]
        Angle    224.8800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 430"
}

Galaxy "NGC 431:UGC 776:MCG 5-4-2:ZWG 502.8"
{
        Type  "S0"
        RA            1.2344
        Dec          33.7053
        Distance   4.195e+08  # method: T-F
        Radius     8.543e+04
        AbsMag        -21.65
        Axis    [  0.1983   0.9222   0.3320]
        Angle    129.5715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 431"
}

Galaxy "NGC 432:ESO 113-22"
{
        Type  "S0"
        RA            1.1961
        Dec         -61.5275
        Distance   3.607e+08  # method: V
        Radius      6.82e+04
        AbsMag        -21.22
        Axis    [  0.8176   0.3597  -0.4497]
        Angle    191.7728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 432"
}

Galaxy "NGC 434:ESO 113-23:AM 0110-583"
{
        Type  "SBb"
        RA            1.2039
        Dec         -58.2472
        Distance    2.17e+08  # method: V
        Radius     6.943e+04
        AbsMag        -21.31
        Axis    [  0.5866   0.6785   0.4422]
        Angle    203.9212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 434"
}

Galaxy "NGC 434A:ESO 113-24"
{
        Type  "SBa"
        RA            1.2083
        Dec         -58.2078
        Distance   2.126e+08  # method: V
        Radius     3.711e+04
        AbsMag        -18.27
        Axis    [  0.5297   0.8468   0.0479]
        Angle    194.8267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 434A"
}

Galaxy "NGC 435:UGC 779:MCG 0-4-46:ZWG 385.35"
{
        Type  "Sc"
        RA            1.2331
        Dec           2.0711
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.2304   0.8666   0.4426]
        Angle    159.9428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 435"
}

Galaxy "NGC 437:UGC 788:MCG 1-4-5:ZWG 411.9"
{
        Type  "Sa"
        RA            1.2394
        Dec           5.9264
        Distance   2.254e+08  # method: V
        Radius     4.262e+04
        AbsMag         -20.3
        Axis    [  0.2640   0.8054  -0.5308]
        Angle    186.9803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 437"
}

Galaxy "NGC 438:ESO 296-7:MCG 6-3-29:IRAS 01112-3810"
{
        Type  "SBb"
        RA            1.2261
        Dec         -37.9014
        Distance   1.464e+08  # method: V
        Radius     2.981e+04
        AbsMag        -19.66
        Axis    [  0.6859   0.6960   0.2126]
        Angle    179.5438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 438"
}

Galaxy "NGC 439:ESO 412-18:MCG 5-4-15:AM 0111-320"
{
        Type  "S0"
        RA            1.2297
        Dec         -31.7472
        Distance   2.499e+08  # method: V
        Radius     9.086e+04
        AbsMag        -21.92
        Axis    [  0.3671   0.5645  -0.7393]
        Angle    175.6623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 439"
}

Galaxy "NGC 440:ESO 113-25:AM 0110-583"
{
        Type  "Sc"
        RA            1.2133
        Dec         -58.2828
        Distance   2.211e+08  # method: V
        Radius     3.859e+04
        AbsMag        -20.46
        Axis    [  0.6940   0.7090   0.1253]
        Angle    194.6625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 440"
}

Galaxy "NGC 441:ESO 412-19:MCG 5-4-16"
{
        Type  "SBa"
        RA            1.2308
        Dec         -31.7889
        Distance   2.452e+08  # method: V
        Radius     4.992e+04
        AbsMag        -20.58
        Axis    [  0.5252   0.5996  -0.6038]
        Angle    185.3281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 441"
}

Galaxy "NGC 442:UGC 789:MCG 0-4-54:ZWG 385.41"
{
        Type  "Sa"
        RA            1.2439
        Dec          -1.0206
        Distance   2.405e+08  # method: V
        Radius     3.497e+04
        AbsMag        -19.84
        Axis    [  0.0988   0.6889  -0.7181]
        Angle    180.1092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 442"
}

Galaxy "NGC 443:IC 1653:UGC 796:MCG 5-4-5"
{
        Type  "S0"
        RA            1.2519
        Dec          33.3778
        Distance   2.091e+08  # method: V
        Radius     2.433e+04
        AbsMag        -19.53
        Axis    [  0.3103   0.9504  -0.0214]
        Angle    145.2602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 443"
}

Galaxy "NGC 444:IC 1658:UGC 810:MCG 5-4-7"
{
        Type  "Sc"
        RA            1.2636
        Dec          31.0806
        Distance   1.865e+08  # method: T-F
        Radius     5.153e+04
        AbsMag        -18.89
        Axis    [ -0.2994   0.7036  -0.6444]
        Angle    174.8991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 444"
}

Galaxy "NGC 445:ZWG 385.47"
{
        Type  "S0"
        RA            1.2478
        Dec           1.9175
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.2387   0.6921  -0.6811]
        Angle    196.8611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 445"
}

Galaxy "NGC 446:IC 89:UGC 818:MCG 1-4-12"
{
        Type  "S0"
        RA            1.2675
        Dec           4.2944
        Distance   2.323e+08  # method: V
        Radius     6.759e+04
        AbsMag        -20.46
        Axis    [  0.4619   0.8862   0.0370]
        Angle    157.5769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 446"
}

Galaxy "NGC 447:IC 1656:UGC 804:MCG 5-4-6"
{
        Type  "SBa"
        RA            1.2603
        Dec          33.0664
        Distance   2.408e+08  # method: V
        Radius     7.706e+04
        AbsMag        -19.84
        Axis    [  0.6484   0.7246   0.2335]
        Angle    103.8092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 447"
}

Galaxy "NGC 448:UGC 801:MCG 0-4-60:ZWG 385.51"
{
        Type  "S0"
        RA            1.2544
        Dec          -1.6253
        Distance   9.896e+07  # method: S
        Radius     2.303e+04
        AbsMag        -19.21
        Axis    [  0.2035   0.8740  -0.4413]
        Angle    171.9096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 448"
}

Galaxy "NGC 449:MCG 5-4-9:MK 1:ZWG 502.18"
{
        Type  "Sb"
        RA            1.2686
        Dec          33.0889
        Distance   2.057e+08  # method: V
        Radius     2.394e+04
        AbsMag           -19
        Axis    [  0.0853   0.9942  -0.0653]
        Angle    152.0603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 449"
}

Galaxy "NGC 450:UGC 806:MCG 0-4-62:ZWG 385.52"
{
        Type  "SBc"
        RA            1.2583
        Dec          -0.8614
        Distance   7.203e+07  # method: T-F
        Radius     3.143e+04
        AbsMag        -19.42
        Axis    [  0.4727   0.8747  -0.1072]
        Angle    166.5592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 450"
}

Galaxy "NGC 451:IC 1661:MCG 5-4-11:MK 976"
{
        Type  "Sc"
        RA            1.2700
        Dec          33.0636
        Distance   2.085e+08  # method: V
        Radius     2.123e+04
        AbsMag        -19.13
        Axis    [  0.2253   0.9552   0.1917]
        Angle    134.3555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 451"
}

Galaxy "NGC 452:UGC 820:MCG 5-4-10:ZWG 502.20"
{
        Type  "SBb"
        RA            1.2708
        Dec          31.0333
        Distance   2.149e+08  # method: T-F
        Radius     7.813e+04
        AbsMag        -19.79
        Axis    [ -0.0298   0.9756   0.2175]
        Angle    144.4420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 452"
}

Galaxy "NGC 454-1:ESO 151-36:AM 0112-554"
{
        Type  "S0"
        RA            1.2392
        Dec         -55.4006
        Distance    8.86e+07  # distance uncertain!
        Radius     2.191e+04
        AbsMag        -19.07
        Axis    [  0.7572   0.5183   0.3975]
        Angle    187.9872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 454-1"
}

Galaxy "NGC 454-2:ESO 151-36:AM 0112-554"
{
        Type  "S0"
        RA            1.2400
        Dec         -55.3972
        Distance   1.584e+08  # method: V
        Radius     2.304e+04
        AbsMag        -18.93
        Axis    [  0.6481   0.7175  -0.2553]
        Angle    180.9470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 454-2"
}

Galaxy "NGC 455:UGC 815:MCG 1-4-11:ZWG 411.15"
{
        Type  "Irr"
        RA            1.2658
        Dec           5.1783
        Distance   2.245e+08  # method: V
        Radius     6.531e+04
        AbsMag        -20.59
        Axis    [  0.1072   0.7227  -0.6827]
        Angle    185.9050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 455"
}

Galaxy "NGC 459:UGC 832:MCG 3-4-17:ZWG 459.24"
{
        Type  "Sc"
        RA            1.3022
        Dec          17.5625
        Distance   5.617e+08  # method: V
        Radius     5.719e+04
        AbsMag        -20.68
        Axis    [  0.4503   0.8751   0.1772]
        Angle    140.0733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 459"
}

Galaxy "NGC 461:ESO 352-33:MCG 6-4-2:AM 0115-340"
{
        Type  "SBc"
        RA            1.2889
        Dec         -33.8411
        Distance    2.29e+08  # method: T-F
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.6316   0.7078   0.3163]
        Angle    176.3698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 461"
}

Galaxy "NGC 462:NPM 1"
{
        Type  "E0"
        RA            1.3028
        Dec           4.2264
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.7558   0.5603   0.3389]
        Angle    123.5271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 462"
}

Galaxy "NGC 463:UGC 840:MCG 3-4-19:ZWG 459.25"
{
        Type  "Sa"
        RA            1.3161
        Dec          16.3253
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.1916   0.8384   0.5103]
        Angle    146.1887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 463"
}

Galaxy "NGC 466:ESO 113-34:AM 0115-591"
{
        Type  "Sa"
        RA            1.2869
        Dec         -58.9097
        Distance   2.347e+08  # method: V
        Radius     5.804e+04
        AbsMag        -20.69
        Axis    [  0.8205   0.4495  -0.3533]
        Angle    189.2241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 466"
}

Galaxy "NGC 467:UGC 848:MCG 0-4-79:ZWG 385.65"
{
        Type  "S0"
        RA            1.3194
        Dec           3.3014
        Distance   2.349e+08  # method: V
        Radius     5.808e+04
        AbsMag        -21.19
        Axis    [  0.7409   0.5712   0.3534]
        Angle    125.1760
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 467"
}

Galaxy "NGC 468:IC 92:MCG 5-4-20:ZWG 502.29"
{
        Type  "Sa"
        RA            1.3300
        Dec          32.7672
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.1543   0.6910  -0.7062]
        Angle    200.1269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 468"
}

Galaxy "NGC 469:MCG 2-4-23:ZWG 436.24"
{
        Type  "S0"
        RA            1.3258
        Dec          14.8719
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.0127   0.6845  -0.7289]
        Angle    190.6709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 469"
}

Galaxy "NGC 470:UGC 858:MCG 0-4-84:ZWG 385.70"
{
        Type  "Sb"
        RA            1.3289
        Dec           3.4092
        Distance   9.355e+07  # method: V
        Radius     3.946e+04
        AbsMag        -19.79
        Axis    [  0.1054   0.7074  -0.6989]
        Angle    184.3556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 470"
}

Galaxy "NGC 471:UGC 861:MCG 2-4-24:ZWG 436.29"
{
        Type  "S0"
        RA            1.3331
        Dec          14.7858
        Distance   1.735e+08  # method: V
        Radius     2.524e+04
        AbsMag        -19.43
        Axis    [  0.2595   0.9456  -0.1962]
        Angle    163.9332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 471"
}

Galaxy "NGC 472:UGC 870:MCG 5-4-22:ZWG 502.34"
{
        Type  "Sa"
        RA            1.3411
        Dec          32.7083
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.1385   0.9022  -0.4084]
        Angle    184.3726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 472"
}

Galaxy "NGC 473:UGC 859:MCG 3-4-22:ZWG 459.30"
{
        Type  "SBa"
        RA            1.3317
        Dec          16.5450
        Distance   8.281e+07  # method: V
        Radius     2.288e+04
        AbsMag        -18.72
        Axis    [  0.0343   0.7540  -0.6559]
        Angle    189.7727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 473"
}

Galaxy "NGC 474:UGC 864:MCG 0-4-85:ZWG 385.71"
{
        Type  "S0"
        RA            1.3350
        Dec           3.4161
        Distance   9.305e+07  # method: V
        Radius     9.609e+04
        AbsMag        -19.97
        Axis    [  0.5123   0.8465  -0.1450]
        Angle    166.4222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 474"
}

Galaxy "NGC 475:IC 97:NPM 1"
{
        Type  "E0"
        RA            1.3336
        Dec          14.8617
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.7346   0.6106   0.2958]
        Angle    115.4067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 475"
}

Galaxy "NGC 476:MCG 3-4-23:ZWG 459.33:NPM 1"
{
        Type  "S0"
        RA            1.3386
        Dec          16.0206
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.2820   0.9022  -0.3265]
        Angle    173.7410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 476"
}

Galaxy "NGC 477:UGC 886:MCG 7-3-32:ZWG 536.32"
{
        Type  "SBc"
        RA            1.3556
        Dec          40.4886
        Distance   2.538e+08  # method: V
        Radius     5.537e+04
        AbsMag        -20.65
        Axis    [ -0.1587   0.8104  -0.5640]
        Angle    192.5916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 477"
}

Galaxy "NGC 478:ESO 476-3:MCG 4-4-5:VV 398"
{
        Type  "S0"
        RA            1.3356
        Dec         -22.3781
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.5905   0.7810  -0.2031]
        Angle    175.8255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 478"
}

Galaxy "NGC 479:UGC 893:MCG 1-4-31:ZWG 411.31"
{
        Type  "Sc"
        RA            1.3542
        Dec           3.8628
        Distance   2.233e+08  # method: V
        Radius     3.572e+04
        AbsMag        -19.38
        Axis    [  0.2203   0.6842  -0.6953]
        Angle    198.3266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 479"
}

Galaxy "NGC 480"
{
        Type  "Sa"
        RA            1.3428
        Dec          -9.8803
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.3003   0.9536  -0.0209]
        Angle    165.9435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 480"
}

Galaxy "NGC 481:MCG 2-4-30"
{
        Type  "S0"
        RA            1.3533
        Dec          -9.2111
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.4413   0.8717  -0.2129]
        Angle    170.3607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 481"
}

Galaxy "NGC 482:ESO 296-13:MCG 7-3-17:AM 0118-411"
{
        Type  "Sb"
        RA            1.3389
        Dec         -40.9661
        Distance   2.885e+08  # method: V
        Radius     9.231e+04
        AbsMag        -20.23
        Axis    [  0.4016   0.8931  -0.2025]
        Angle    172.5933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 482"
}

Galaxy "NGC 483:UGC 906:MCG 5-4-29:ZWG 502.50"
{
        Type  "S0"
        RA            1.3656
        Dec          33.5206
        Distance   2.024e+08  # method: V
        Radius     2.061e+04
        AbsMag        -19.96
        Axis    [  0.6575   0.7178   0.2288]
        Angle    102.5961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 483"
}

Galaxy "NGC 484:ESO 113-36"
{
        Type  "S0"
        RA            1.3261
        Dec         -58.5244
        Distance   2.297e+08  # method: V
        Radius     6.347e+04
        AbsMag        -22.04
        Axis    [  0.7664   0.5729  -0.2907]
        Angle    184.9445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 484"
}

Galaxy "NGC 485:UGC 895:MCG 1-4-32:ZWG 411.32"
{
        Type  "S0"
        RA            1.3575
        Dec           7.0181
        Distance   8.797e+07  # method: V
        Radius     2.303e+04
        AbsMag        -18.05
        Axis    [  0.2068   0.8301   0.5179]
        Angle    156.0067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 485"
}

Galaxy "NGC 487:MCG 3-4-56"
{
        Type  "Sa"
        RA            1.3653
        Dec         -16.3700
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.4038   0.8054  -0.4339]
        Angle    174.7588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 487"
}

Galaxy "NGC 488:UGC 907:MCG 1-4-33:ZWG 411.33"
{
        Type  "Sb"
        RA            1.3628
        Dec           5.2558
        Distance   8.874e+07  # method: V
        Radius      6.97e+04
        AbsMag        -20.97
        Axis    [  0.4339   0.8221   0.3686]
        Angle    145.5491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 488"
}

Galaxy "NGC 489:UGC 908:MCG 1-4-34:ZWG 411.34"
{
        Type  "S0"
        RA            1.3647
        Dec           9.2064
        Distance   1.005e+08  # method: V
        Radius     2.484e+04
        AbsMag        -18.94
        Axis    [ -0.0568   0.8963  -0.4398]
        Angle    162.0221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 489"
}

Galaxy "NGC 490:MCG 1-4-35:ZWG 411.35:NPM 1"
{
        Type  "S0"
        RA            1.3672
        Dec           5.3678
        Distance    8.68e+07  # method: V
        Radius          8837
        AbsMag        -16.93
        Axis    [  0.5313   0.7558   0.3827]
        Angle    138.8152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 490"
}

Galaxy "NGC 491:ESO 352-53:MCG 6-4-11:IRAS 01190-3419"
{
        Type  "SBb"
        RA            1.3556
        Dec         -34.0636
        Distance   2.367e+08  # method: T-F
        Radius      4.82e+04
        AbsMag         -21.1
        Axis    [  0.6132   0.7351  -0.2891]
        Angle    178.4396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 491"
}

Galaxy "NGC 491A:ESO 352-46:MCG 6-4-8:AM 0117-340"
{
        Type  "SBc"
        RA            1.3347
        Dec         -33.9006
        Distance   1.734e+08  # method: T-F
        Radius     4.792e+04
        AbsMag        -19.33
        Axis    [  0.4466   0.8216  -0.3542]
        Angle    170.9385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 491A"
}

Galaxy "NGC 492:MCG 1-4-38:ZWG 411.36"
{
        Type  "SBa"
        RA            1.3703
        Dec           5.4169
        Distance    4.05e+08  # distance uncertain!
        Radius     4.123e+04
        AbsMag        -19.07
        Axis    [  0.3593   0.8082  -0.4666]
        Angle    185.3053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 492"
}

Galaxy "NGC 493:UGC 914:MCG 0-4-99:ZWG 385.84"
{
        Type  "SBc"
        RA            1.3692
        Dec           0.9464
        Distance   9.722e+07  # method: T-F
        Radius     4.807e+04
        AbsMag        -19.47
        Axis    [  0.1808   0.9818   0.0584]
        Angle    160.5932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 493"
}

Galaxy "NGC 494:UGC 919:MCG 5-4-34:ZWG 502.57"
{
        Type  "Sb"
        RA            1.3819
        Dec          33.1728
        Distance   2.263e+08  # method: T-F
        Radius     6.583e+04
        AbsMag        -20.41
        Axis    [ -0.1160   0.9601  -0.2544]
        Angle    160.7152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 494"
}

Galaxy "NGC 495:UGC 920:MCG 5-4-35:ZWG 502.58"
{
        Type  "SBa"
        RA            1.3822
        Dec          33.4708
        Distance   1.739e+08  # method: V
        Radius     3.035e+04
        AbsMag        -19.73
        Axis    [ -0.1156   0.7135  -0.6910]
        Angle    204.3134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 495"
}

Galaxy "NGC 496:UGC 927:MCG 5-4-36:ZWG 502.60"
{
        Type  "Sc"
        RA            1.3864
        Dec          33.5281
        Distance   2.033e+08  # method: T-F
        Radius      4.73e+04
        AbsMag        -19.77
        Axis    [  0.1456   0.9454   0.2915]
        Angle    132.7852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 496"
}

Galaxy "NGC 497:UGC 915:MCG 0-4-100:ZWG 385.85"
{
        Type  "SBc"
        RA            1.3731
        Dec          -0.8747
        Distance   3.538e+08  # method: V
        Radius      1.08e+05
        AbsMag        -21.38
        Axis    [  0.1212   0.8213  -0.5575]
        Angle    170.4141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 497"
}

Galaxy "NGC 498:MCG 5-4-37:NPM 1"
{
        Type  "S0"
        RA            1.3864
        Dec          33.4900
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.6598   0.7158   0.2284]
        Angle    102.4402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 498"
}

Galaxy "NGC 499:IC 1686:UGC 926:MCG 5-4-38"
{
        Type  "S0"
        RA            1.3864
        Dec          33.4597
        Distance     2.5e+08  # method: T-F
        Radius     6.181e+04
        AbsMag        -21.22
        Axis    [  0.1569   0.9710  -0.1805]
        Angle    158.7287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 499"
}

Galaxy "NGC 500:MCG 1-4-40:ZWG 411.39:NPM 1"
{
        Type  "S0"
        RA            1.3775
        Dec           5.3878
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.3302   0.8808  -0.3392]
        Angle    173.2452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 500"
}

Galaxy "NGC 501:ZWG 502.62:NPM 1"
{
        Type  "E0"
        RA            1.3894
        Dec          33.4336
        Distance   2.089e+08  # method: V
        Radius     1.519e+04
        AbsMag        -18.53
        Axis    [  0.6820   0.7010   0.2085]
        Angle    101.7978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 501"
}

Galaxy "NGC 502:UGC 922:MCG 1-4-43:ZWG 411.40"
{
        Type  "S0"
        RA            1.3819
        Dec           9.0494
        Distance   9.935e+07  # method: V
        Radius     1.589e+04
        AbsMag        -18.72
        Axis    [  0.5129   0.8542  -0.0855]
        Angle    159.5627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 502"
}

Galaxy "NGC 503:MCG 5-4-40:ZWG 502.65:NPM 1"
{
        Type  "S0"
        RA            1.3911
        Dec          33.3322
        Distance   2.584e+08  # method: V
        Radius     3.382e+04
        AbsMag        -19.39
        Axis    [  0.2980   0.9256   0.2332]
        Angle    127.8092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 503"
}

Galaxy "NGC 504:UGC 935:MCG 5-4-41:ZWG 502.64"
{
        Type  "S0"
        RA            1.3911
        Dec          33.2039
        Distance   1.728e+08  # method: V
        Radius     4.272e+04
        AbsMag        -19.62
        Axis    [ -0.1110   0.9714   0.2099]
        Angle    144.2697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 504"
}

Galaxy "NGC 505:UGC 924:MCG 1-4-41:ZWG 411.41"
{
        Type  "S0"
        RA            1.3825
        Dec           9.4689
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.3339   0.9422   0.0290]
        Angle    154.9311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 505"
}

Galaxy "NGC 507:UGC 938:MCG 5-4-44:ZWG 502.67"
{
        Type  "S0"
        RA            1.3944
        Dec          33.2567
        Distance     2.5e+08  # method: T-F
        Radius      9.09e+04
        AbsMag        -22.12
        Axis    [  0.6616   0.7139   0.2294]
        Angle    102.5346
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 507"
}

Galaxy "NGC 508:UGC 939:MCG 5-4-45:ZWG 502.68"
{
        Type  "E0"
        RA            1.3944
        Dec          33.2803
        Distance    2.38e+08  # method: V
        Radius     3.808e+04
        AbsMag        -20.22
        Axis    [  0.6831   0.6997   0.2091]
        Angle    101.8605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 508"
}

Galaxy "NGC 509:UGC 932:MCG 1-4-45:ZWG 411.43"
{
        Type  "SBa"
        RA            1.3900
        Dec           9.4333
        Distance   8.911e+07  # method: V
        Radius     2.074e+04
        AbsMag        -17.58
        Axis    [  0.1018   0.9801  -0.1705]
        Angle    160.0603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 509"
}

Galaxy "NGC 511:UGC 936:MCG 2-4-33:ZWG 436.37"
{
        Type  "E0"
        RA            1.3917
        Dec          11.2908
        Distance   3.312e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -20.13
        Axis    [  0.7487   0.5873   0.3075]
        Angle    117.6812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 511"
}

Galaxy "NGC 512:UGC 944:MCG 6-4-13:ZWG 521.18"
{
        Type  "Sb"
        RA            1.3997
        Dec          33.9072
        Distance   2.727e+08  # method: T-F
        Radius     6.346e+04
        AbsMag        -20.51
        Axis    [ -0.2486   0.9004  -0.3572]
        Angle    162.7299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 512"
}

Galaxy "NGC 513:UGC 953:MCG 6-4-16:ZWG 521.20"
{
        Type  "Sc"
        RA            1.4072
        Dec          33.7989
        Distance   2.571e+08  # method: V
        Radius     3.366e+04
        AbsMag        -20.88
        Axis    [  0.1047   0.9893  -0.1016]
        Angle    152.1523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 513"
}

Galaxy "NGC 514:UGC 947:MCG 2-4-35:ZWG 436.38"
{
        Type  "SBc"
        RA            1.4008
        Dec          12.9172
        Distance   9.808e+07  # method: V
        Radius     5.278e+04
        AbsMag        -20.09
        Axis    [  0.2940   0.8733  -0.3885]
        Angle    177.5565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 514"
}

Galaxy "NGC 515:UGC 956:MCG 5-4-52:ZWG 502.77"
{
        Type  "S0"
        RA            1.4106
        Dec          33.4722
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.0675   0.8938  -0.4433]
        Angle    184.4934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 515"
}

Galaxy "NGC 516:UGC 946:MCG 1-4-48:ZWG 411.46"
{
        Type  "SBa"
        RA            1.4022
        Dec           9.5519
        Distance   9.626e+07  # method: V
        Radius      1.96e+04
        AbsMag        -18.15
        Axis    [  0.1615   0.9695   0.1846]
        Angle    154.4940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 516"
}

Galaxy "NGC 517:UGC 960:MCG 5-4-54:ZWG 502.79"
{
        Type  "S0"
        RA            1.4119
        Dec          33.4289
        Distance   1.806e+08  # method: V
        Radius     3.677e+04
        AbsMag        -20.22
        Axis    [  0.0453   0.9128   0.4058]
        Angle    135.6789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 517"
}

Galaxy "NGC 518:UGC 952:MCG 1-4-49:ZWG 411.47"
{
        Type  "Sa"
        RA            1.4047
        Dec           9.3308
        Distance   1.086e+08  # method: V
        Radius     2.527e+04
        AbsMag        -18.31
        Axis    [  0.0776   0.9573  -0.2786]
        Angle    162.1927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 518"
}

Galaxy "NGC 519:ZWG 385.103:DRCG 7-19"
{
        Type  "E0"
        RA            1.4078
        Dec          -1.6414
        Distance   2.278e+08  # method: V
        Radius     1.657e+04
        AbsMag        -18.82
        Axis    [  0.5598   0.6017  -0.5697]
        Angle    213.5590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 519"
}

Galaxy "NGC 520:UGC 966:MCG 1-4-52:ZWG 411.50"
{
        Type  "Sa"
        RA            1.4094
        Dec           3.7942
        Distance   8.652e+07  # method: V
        Radius     4.279e+04
        AbsMag        -19.92
        Axis    [  0.1238   0.8335  -0.5385]
        Angle    172.8432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 520"
}

Galaxy "NGC 521:UGC 962:MCG 0-4-118:ZWG 385.106"
{
        Type  "SBc"
        RA            1.4092
        Dec           1.7314
        Distance   2.145e+08  # method: V
        Radius     8.422e+04
        AbsMag        -21.59
        Axis    [  0.5760   0.8050   0.1419]
        Angle    150.4493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 521"
}

Galaxy "NGC 522:UGC 970:MCG 2-4-38:ZWG 436.43"
{
        Type  "Sc"
        RA            1.4125
        Dec           9.9950
        Distance   1.133e+08  # method: V
        Radius     4.612e+04
        AbsMag         -18.7
        Axis    [  0.0539   0.9512   0.3039]
        Angle    157.4946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 522"
}

Galaxy "NGC 524:UGC 968:MCG 1-4-53:ZWG 411.51"
{
        Type  "Sa"
        RA            1.4131
        Dec           9.5386
        Distance   7.824e+07  # method: S
        Radius     3.186e+04
        AbsMag         -20.6
        Axis    [  0.7356   0.5932   0.3270]
        Angle    119.8269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 524"
}

Galaxy "NGC 525:UGC 972:MCG 1-4-54:ZWG 411.53"
{
        Type  "S0"
        RA            1.4144
        Dec           9.7039
        Distance   8.335e+07  # method: V
        Radius     1.818e+04
        AbsMag        -17.74
        Axis    [  0.2688   0.8430   0.4659]
        Angle    148.6826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 525"
}

Galaxy "NGC 526A:ESO 352-66:MCG 6-4-19:AM 0121-351"
{
        Type  "S0"
        RA            1.3983
        Dec         -35.0656
        Distance   2.507e+08  # method: V
        Radius     4.375e+04
        AbsMag        -20.03
        Axis    [  0.5321   0.8396  -0.1094]
        Angle    176.0114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 526A"
}

Galaxy "NGC 526B:ESO 352-66:MCG 6-4-20:AM 0121-351"
{
        Type  "S0"
        RA            1.3989
        Dec         -35.0692
        Distance   1.341e+08  # distance uncertain!
        Radius      1.56e+04
        AbsMag        -19.07
        Axis    [  0.3233   0.5372  -0.7791]
        Angle    166.6667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 526B"
}

Galaxy "NGC 527-1:ESO 352-68:MCG 6-4-21:PGC 5141"
{
        Type  "SBa"
        RA            1.3994
        Dec         -35.1153
        Distance   2.506e+08  # method: V
        Radius     5.831e+04
        AbsMag        -20.33
        Axis    [  0.3264   0.8706   0.3682]
        Angle    193.0918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 527-1"
}

Galaxy "NGC 527-2:MCG 6-4-22"
{
        Type  "S0"
        RA            1.3997
        Dec         -35.1281
        Distance   2.226e+08  # distance uncertain!
        Radius     1.942e+04
        AbsMag        -19.07
        Axis    [  0.3431   0.9314   0.1214]
        Angle    182.6623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 527-2"
}

Galaxy "NGC 528:UGC 988:MCG 5-4-57:ZWG 502.83"
{
        Type  "S0"
        RA            1.4258
        Dec          33.6706
        Distance   2.047e+08  # method: V
        Radius     3.573e+04
        AbsMag        -20.39
        Axis    [  0.1541   0.9869   0.0486]
        Angle    141.9528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 528"
}

Galaxy "NGC 529:UGC 995:MCG 6-4-19:ZWG 521.23"
{
        Type  "S0"
        RA            1.4278
        Dec          34.7131
        Distance   2.052e+08  # method: V
        Radius     7.162e+04
        AbsMag        -20.79
        Axis    [  0.0316   0.7913  -0.6106]
        Angle    211.1256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 529"
}

Galaxy "NGC 530:IC 106:UGC 965:MCG 0-4-119"
{
        Type  "Sa"
        RA            1.4114
        Dec          -1.5869
        Distance   2.131e+08  # method: V
        Radius      4.65e+04
        AbsMag        -20.08
        Axis    [  0.0335   0.8247  -0.5646]
        Angle    163.0270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 530"
}

Galaxy "NGC 531:UGC 1012:MCG 6-4-20:ZWG 521.24"
{
        Type  "SBa"
        RA            1.4383
        Dec          34.7542
        Distance   2.227e+08  # method: V
        Radius     5.829e+04
        AbsMag        -19.27
        Axis    [ -0.0500   0.9490   0.3113]
        Angle    139.3867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 531"
}

Galaxy "NGC 532:UGC 982:MCG 1-4-56:ZWG 411.55"
{
        Type  "Sb"
        RA            1.4214
        Dec           9.2642
        Distance   9.368e+07  # method: V
        Radius     4.224e+04
        AbsMag        -18.39
        Axis    [  0.1665   0.9312   0.3242]
        Angle    154.1745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 532"
}

Galaxy "NGC 533:UGC 992:MCG 0-4-131:ZWG 385.121"
{
        Type  "E3"
        RA            1.4253
        Dec           1.7592
        Distance   2.113e+08  # method: T-F
        Radius     1.168e+05
        AbsMag        -21.66
        Axis    [  0.7657   0.6430  -0.0155]
        Angle    154.6745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 533"
}

Galaxy "NGC 534:ESO 296-21:MCG 6-4-26"
{
        Type  "S0"
        RA            1.4122
        Dec         -38.1289
        Distance   2.541e+08  # method: V
        Radius     3.696e+04
        AbsMag        -20.06
        Axis    [  0.5866   0.4697  -0.6598]
        Angle    191.1216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 534"
}

Galaxy "NGC 535:UGC 997:MCG 0-4-133:ZWG 385.124"
{
        Type  "Sa"
        RA            1.4253
        Dec          -1.4089
        Distance     2.1e+08  # method: V
        Radius     3.055e+04
        AbsMag        -19.14
        Axis    [  0.1862   0.9808   0.0575]
        Angle    161.0922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 535"
}

Galaxy "NGC 536:UGC 1013:MCG 6-4-21:ZWG 521.25"
{
        Type  "SBb"
        RA            1.4392
        Dec          34.7033
        Distance   2.071e+08  # method: T-F
        Radius     9.939e+04
        AbsMag        -20.81
        Axis    [ -0.0798   0.9968   0.0076]
        Angle    147.3117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 536"
}

Galaxy "NGC 537:NGC 523:UGC 979:MCG 6-4-18"
{
        Type  "Sc"
        RA            1.4222
        Dec          34.0253
        Distance   2.035e+08  # method: V
        Radius     7.401e+04
        AbsMag        -20.48
        Axis    [ -0.2143   0.9297  -0.2995]
        Angle    160.5482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 537"
}

Galaxy "NGC 538:UGC 991:MCG 0-4-130:ZWG 385.120"
{
        Type  "Sb"
        RA            1.4239
        Dec          -1.5508
        Distance   2.113e+08  # method: T-F
        Radius     3.995e+04
        AbsMag        -19.46
        Axis    [  0.3078   0.9312   0.1954]
        Angle    159.1676
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 538"
}

Galaxy "NGC 539:NGC 563:ESO 542-10:MCG 3-4-63"
{
        Type  "SBc"
        RA            1.4225
        Dec         -18.1644
        Distance   4.249e+08  # method: V
        Radius     9.888e+04
        AbsMag        -21.37
        Axis    [  0.4039   0.6225  -0.6703]
        Angle    188.4940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 539"
}

Galaxy "NGC 540:ESO 542-12:NPM 1"
{
        Type  "S0"
        RA            1.4522
        Dec         -20.0367
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.1388   0.5031  -0.8530]
        Angle    168.9632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 540"
}

Galaxy "NGC 541:UGC 1004:MCG 0-4-137:ZWG 385.128"
{
        Type  "S0"
        RA            1.4289
        Dec          -1.3794
        Distance   2.113e+08  # method: T-F
        Radius     5.531e+04
        AbsMag        -20.86
        Axis    [  0.6386   0.7695   0.0012]
        Angle    158.3435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 541"
}

Galaxy "NGC 542:MCG 6-4-22:ZWG 521.26:HCG 10"
{
        Type  "Sb"
        RA            1.4417
        Dec          34.6761
        Distance   1.989e+08  # method: V
        Radius     2.892e+04
        AbsMag        -18.33
        Axis    [ -0.3325   0.7600  -0.5584]
        Angle    169.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 542"
}

Galaxy "NGC 543:MCG 0-4-138:ZWG 385.130:DRCG 7-53"
{
        Type  "S0"
        RA            1.4306
        Dec          -1.2925
        Distance   2.236e+08  # method: V
        Radius     1.951e+04
        AbsMag        -19.88
        Axis    [  0.2570   0.9367  -0.2378]
        Angle    164.7887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 543"
}

Galaxy "NGC 544:ESO 296-24:MCG 6-4-28:AM 0122-381"
{
        Type  "S0"
        RA            1.4197
        Dec         -38.0944
        Distance   2.616e+08  # method: V
        Radius     5.708e+04
        AbsMag        -20.12
        Axis    [  0.6024   0.6413   0.4753]
        Angle    179.0424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 544"
}

Galaxy "NGC 545:UGC 1007:MCG 0-4-142:ZWG 385.132"
{
        Type  "S0"
        RA            1.4331
        Dec          -1.3406
        Distance   2.113e+08  # method: T-F
        Radius      7.99e+04
        AbsMag        -20.76
        Axis    [  0.3842   0.9220   0.0482]
        Angle    159.4545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 545"
}

Galaxy "NGC 546:ESO 296-25:MCG 6-4-29:AM 0122-381"
{
        Type  "SBb"
        RA            1.4200
        Dec         -38.0692
        Distance   3.016e+08  # method: T-F
        Radius     6.141e+04
        AbsMag        -20.33
        Axis    [  0.4718   0.8583   0.2018]
        Angle    184.8231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 546"
}

Galaxy "NGC 547:UGC 1009:MCG 0-4-143:ZWG 385.133"
{
        Type  "E1"
        RA            1.4333
        Dec          -1.3450
        Distance   2.113e+08  # method: T-F
        Radius     5.839e+04
        AbsMag        -20.76
        Axis    [  0.7258   0.6452  -0.2387]
        Angle    178.5085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 547"
}

Galaxy "NGC 548:UGC 1010:MCG 0-4-141:ZWG 385.134"
{
        Type  "E0"
        RA            1.4339
        Dec          -1.2253
        Distance   2.113e+08  # method: T-F
        Radius     2.458e+04
        AbsMag        -19.36
        Axis    [  0.5762   0.6122  -0.5416]
        Angle    210.2371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 548"
}

Galaxy "NGC 549:ESO 296-22"
{
        Type  "Sa"
        RA            1.4186
        Dec         -38.0072
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.6301   0.6026   0.4897]
        Angle    175.9489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 549"
}

Galaxy "NGC 550:UGC 1021:MCG 0-4-146:ZWG 385.139"
{
        Type  "Sa"
        RA            1.4450
        Dec           2.0222
        Distance   2.522e+08  # method: V
        Radius     5.136e+04
        AbsMag        -20.84
        Axis    [  0.1238   0.8756  -0.4669]
        Angle    167.5219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 550"
}

Galaxy "NGC 551:UGC 1034:MCG 6-4-27:ZWG 521.30"
{
        Type  "SBc"
        RA            1.4611
        Dec          37.1831
        Distance   2.121e+08  # method: T-F
        Radius     5.554e+04
        AbsMag        -20.57
        Axis    [ -0.1985   0.8319  -0.5182]
        Angle    178.8938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 551"
}

Galaxy "NGC 553:ZWG 502.84:MK 1155"
{
        Type  "S0"
        RA            1.4367
        Dec          33.4047
        Distance   2.128e+08  # method: V
        Radius     1.857e+04
        AbsMag        -18.97
        Axis    [  0.1432   0.8988   0.4142]
        Angle    130.1317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 553"
}

Galaxy "NGC 554A:ESO 476-11:MCG 4-4-13:AM 0124-225"
{
        Type  "S0"
        RA            1.4525
        Dec         -22.7256
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.1946   0.4860  -0.8520]
        Angle    174.4633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 554A"
}

Galaxy "NGC 554B:ESO 476-11A"
{
        Type  "S0"
        RA            1.4525
        Dec         -22.7236
        Distance   1.938e+08  # distance uncertain!
        Radius          8458
        AbsMag        -19.07
        Axis    [  0.7937   0.4390   0.4212]
        Angle    145.2454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 554B"
}

Galaxy "NGC 555:ESO 476-12:MCG 4-4-14:NPM 1"
{
        Type  "SBa"
        RA            1.4531
        Dec         -22.7617
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6508   0.6610   0.3736]
        Angle    161.7113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 555"
}

Galaxy "NGC 556:ESO 476-13:NPM 1"
{
        Type  "S0"
        RA            1.4533
        Dec         -22.6972
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.4337   0.6547  -0.6191]
        Angle    181.8526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 556"
}

Galaxy "NGC 557:IC 1703:UGC 1016:MCG 0-4-144"
{
        Type  "SBa"
        RA            1.4403
        Dec          -1.6383
        Distance    2.44e+08  # method: V
        Radius     6.388e+04
        AbsMag        -19.77
        Axis    [  0.0955   0.8669  -0.4893]
        Angle    164.5126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 557"
}

Galaxy "NGC 558:ZWG 385.143:NPM 1:DRCG 7-5"
{
        Type  "E0"
        RA            1.4544
        Dec          -1.9706
        Distance   2.137e+08  # method: V
        Radius     1.243e+04
        AbsMag        -19.08
        Axis    [  0.6653   0.6332  -0.3956]
        Angle    194.4393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 558"
}

Galaxy "NGC 560:UGC 1036:MCG 0-4-151:ZWG 385.145"
{
        Type  "S0"
        RA            1.4569
        Dec          -1.9125
        Distance   2.347e+08  # method: V
        Radius     6.487e+04
        AbsMag        -20.39
        Axis    [ -0.0322   0.5584  -0.8289]
        Angle    170.0066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 560"
}

Galaxy "NGC 561:UGC 1048:MCG 6-4-29:ZWG 521.32"
{
        Type  "SBa"
        RA            1.4717
        Dec          34.3083
        Distance   1.993e+08  # method: V
        Radius     4.638e+04
        AbsMag        -20.03
        Axis    [  0.4158   0.9092   0.0238]
        Angle    134.1923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 561"
}

Galaxy "NGC 562:UGC 1049:MCG 8-3-25:ZWG 551.20"
{
        Type  "Sc"
        RA            1.4747
        Dec          48.3869
        Distance   4.542e+08  # method: V
        Radius     8.589e+04
        AbsMag        -21.42
        Axis    [  0.2747   0.9331   0.2320]
        Angle    111.7100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 562"
}

Galaxy "NGC 564:UGC 1044:MCG 0-4-154:ZWG 385.148"
{
        Type  "E0"
        RA            1.4633
        Dec          -1.8786
        Distance   2.113e+08  # method: T-F
        Radius     3.995e+04
        AbsMag        -20.56
        Axis    [  0.5368   0.5907  -0.6025]
        Angle    215.8715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 564"
}

Galaxy "NGC 565:UGC 1052:MCG 0-4-158:ZWG 385.153"
{
        Type  "Sa"
        RA            1.4694
        Dec          -1.3058
        Distance   1.901e+08  # method: V
        Radius     3.595e+04
        AbsMag        -19.33
        Axis    [  0.2200   0.9441   0.2454]
        Angle    160.9274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 565"
}

Galaxy "NGC 566:UGC 1058:MCG 5-4-62:ZWG 502.92"
{
        Type  "S0"
        RA            1.4839
        Dec          32.3322
        Distance   1.688e+08  # distance uncertain!
        Radius     3.929e+04
        AbsMag        -19.07
        Axis    [ -0.3005   0.5914  -0.7483]
        Angle    183.1038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 566"
}

Galaxy "NGC 567:MCG 2-4-53:NPM 1"
{
        Type  "S0"
        RA            1.4506
        Dec         -10.2647
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.2744   0.7584  -0.5913]
        Angle    175.6475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 567"
}

Galaxy "NGC 568:IC 1709:ESO 353-3:MCG 6-4-37"
{
        Type  "S0"
        RA            1.4656
        Dec         -35.7175
        Distance   2.446e+08  # method: V
        Radius     7.827e+04
        AbsMag        -20.77
        Axis    [  0.4372   0.6203  -0.6512]
        Angle    171.7699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 568"
}

Galaxy "NGC 569:UGC 1063:MCG 2-4-53:MK 997"
{
        Type  "Sc"
        RA            1.4853
        Dec          11.1317
        Distance   2.478e+08  # method: V
        Radius     3.604e+04
        AbsMag         -19.7
        Axis    [ -0.0199   0.6852  -0.7281]
        Angle    182.5991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 569"
}

Galaxy "NGC 570:UGC 1061:MCG 0-4-162:ZWG 385.159"
{
        Type  "SBa"
        RA            1.4828
        Dec          -0.9486
        Distance   2.352e+08  # method: V
        Radius     5.474e+04
        AbsMag        -20.59
        Axis    [  0.1640   0.5668  -0.8074]
        Angle    201.4668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 570"
}

Galaxy "NGC 571:UGC 1069:MCG 5-4-63:ZWG 502.98"
{
        Type  "S0"
        RA            1.4989
        Dec          32.5008
        Distance   1.986e+08  # method: V
        Radius     3.756e+04
        AbsMag        -19.22
        Axis    [  0.6753   0.7007   0.2303]
        Angle    102.1937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 571"
}

Galaxy "NGC 572:ESO 296-31:MCG 7-4-9"
{
        Type  "S0"
        RA            1.4767
        Dec         -39.3072
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.6490   0.5348  -0.5412]
        Angle    186.3950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 572"
}

Galaxy "NGC 573:UGC 1078:ZWG 537.10:IRAS 01278+4100"
{
        Type  "S0"
        RA            1.5136
        Dec          41.2572
        Distance   1.168e+08  # distance uncertain!
        Radius          6795
        AbsMag        -19.07
        Axis    [  0.6407   0.7447   0.1870]
        Angle     95.9759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 573"
}

Galaxy "NGC 574:ESO 353-6:MCG 6-4-39:IRAS 01268-3551"
{
        Type  "SBb"
        RA            1.4842
        Dec         -35.5986
        Distance   2.485e+08  # method: V
        Radius     3.976e+04
        AbsMag        -20.21
        Axis    [  0.5534   0.6865   0.4717]
        Angle    180.2656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 574"
}

Galaxy "NGC 575:IC 1710:UGC 1081:MCG 3-4-51"
{
        Type  "SBc"
        RA            1.5128
        Dec          21.4403
        Distance   1.294e+08  # method: V
        Radius       3.2e+04
        AbsMag        -19.39
        Axis    [  0.4687   0.8770  -0.1063]
        Angle    153.2051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 575"
}

Galaxy "NGC 576:ESO 196-7:FAIR 295:AM 0126-515"
{
        Type  "SBa"
        RA            1.4825
        Dec         -51.5981
        Distance   1.355e+08  # method: V
        Radius     1.971e+04
        AbsMag        -18.69
        Axis    [  0.7292   0.5914   0.3443]
        Angle    187.0615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 576"
}

Galaxy "NGC 577:NGC 580:UGC 1080:MCG 0-4-165"
{
        Type  "SBa"
        RA            1.5111
        Dec          -1.9942
        Distance   2.561e+08  # method: V
        Radius     7.078e+04
        AbsMag        -20.57
        Axis    [  0.2946   0.7285  -0.6184]
        Angle    187.1536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 577"
}

Galaxy "NGC 578:ESO 476-15:MCG 4-4-20:UGCA 18"
{
        Type  "SBc"
        RA            1.5078
        Dec         -22.6667
        Distance   9.223e+07  # method: T-F
        Radius     6.439e+04
        AbsMag        -20.76
        Axis    [  0.4488   0.7834  -0.4299]
        Angle    172.7672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 578"
}

Galaxy "NGC 579:UGC 1089:MCG 5-4-64:ZWG 502.103"
{
        Type  "Sc"
        RA            1.5294
        Dec          33.6144
        Distance    2.14e+08  # method: V
        Radius      4.67e+04
        AbsMag        -20.18
        Axis    [  0.0603   0.8218  -0.5666]
        Angle    202.3410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 579"
}

Galaxy "NGC 582:UGC 1094:MCG 5-4-65:ZWG 502.105"
{
        Type  "SBb"
        RA            1.5328
        Dec          33.4756
        Distance     2.3e+08  # method: T-F
        Radius     7.359e+04
        AbsMag        -20.14
        Axis    [ -0.1014   0.9886   0.1117]
        Angle    144.0884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 582"
}

Galaxy "NGC 583:ESO 542-20:MCG 3-4-77:NPM 1"
{
        Type  "S0"
        RA            1.4956
        Dec         -18.3394
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.6600   0.7374   0.1438]
        Angle    163.5832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 583"
}

Galaxy "NGC 584:IC 1712:MCG 1-4-60"
{
        Type  "E4"
        RA            1.5222
        Dec          -6.8672
        Distance   6.568e+07  # method: S
        Radius     3.917e+04
        AbsMag        -20.02
        Axis    [  0.7811   0.6041  -0.1576]
        Angle    171.4217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 584"
}

Galaxy "NGC 585:UGC 1092:MCG 0-5-1:ZWG 386.1"
{
        Type  "Sa"
        RA            1.5283
        Dec          -0.9328
        Distance   2.294e+08  # method: V
        Radius     7.339e+04
        AbsMag        -20.13
        Axis    [  0.0844   0.9808  -0.1756]
        Angle    158.5342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 585"
}

Galaxy "NGC 586:MCG 1-5-1"
{
        Type  "Sa"
        RA            1.5267
        Dec          -6.8931
        Distance   7.692e+07  # method: V
        Radius     1.902e+04
        AbsMag        -17.76
        Axis    [  0.3916   0.7680   0.5068]
        Angle    159.1544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 586"
}

Galaxy "NGC 587:UGC 1100:MCG 6-4-37:ZWG 521.45"
{
        Type  "SBb"
        RA            1.5425
        Dec          35.3583
        Distance   2.132e+08  # method: T-F
        Radius     6.821e+04
        AbsMag        -20.48
        Axis    [ -0.0776   0.9968   0.0193]
        Angle    145.3394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 587"
}

Galaxy "NGC 589:MCG 2-5-4:MK 999:NPM 1"
{
        Type  "Sa"
        RA            1.5442
        Dec         -12.0422
        Distance   2.217e+08  # method: V
        Radius     3.547e+04
        AbsMag        -19.16
        Axis    [  0.5378   0.7976  -0.2730]
        Angle    172.7333
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 589"
}

Galaxy "NGC 590:UGC 1109:MCG 7-4-3:ZWG 537.13"
{
        Type  "SBa"
        RA            1.5611
        Dec          44.9292
        Distance   2.184e+08  # method: V
        Radius      8.26e+04
        AbsMag        -20.23
        Axis    [ -0.2481   0.8005  -0.5455]
        Angle    186.6502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 590"
}

Galaxy "NGC 591:UGC 1111:MCG 6-4-38:MK 1157"
{
        Type  "SBa"
        RA            1.5586
        Dec          35.6683
        Distance   1.943e+08  # method: V
        Radius     3.673e+04
        AbsMag        -19.97
        Axis    [  0.3376   0.8464   0.4118]
        Angle    115.1900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 591"
}

Galaxy "NGC 593:MCG 2-5-3"
{
        Type  "S0"
        RA            1.5389
        Dec         -12.3544
        Distance   2.802e+08  # distance uncertain!
        Radius      4.89e+04
        AbsMag        -19.07
        Axis    [  0.2209   0.8765   0.4278]
        Angle    174.9184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 593"
}

Galaxy "NGC 594:MCG 3-5-5:IRAS 01305-1647"
{
        Type  "Sc"
        RA            1.5492
        Dec         -16.5353
        Distance   2.331e+08  # method: V
        Radius     4.746e+04
        AbsMag        -19.97
        Axis    [  0.3956   0.8844   0.2476]
        Angle    168.1816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 594"
}

Galaxy "NGC 596:MCG 1-5-5"
{
        Type  "E0"
        RA            1.5478
        Dec          -7.0319
        Distance   7.103e+07  # method: S
        Radius     3.306e+04
        AbsMag        -19.79
        Axis    [  0.8175   0.5725   0.0637]
        Angle    152.3735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 596"
}

Galaxy "NGC 597:ESO 353-11:MCG 6-4-44:IRAS 01299-3345"
{
        Type  "SBc"
        RA            1.5372
        Dec         -33.4969
        Distance   2.194e+08  # method: V
        Radius     4.468e+04
        AbsMag        -20.14
        Axis    [  0.7647   0.5778   0.2855]
        Angle    168.2519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 597"
}

Galaxy "M 33:NGC 598:UGC 1117:MCG 5-4-69"
{
        Type  "Sc"
        RA            1.5642
        Dec          30.6581
        Distance   3.262e+06  # method: T-F
        Radius     3.259e+04
        AbsMag        -18.78
        Axis    [  0.2202   0.9202   0.3237]
        Angle    130.1439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 33"
}

Galaxy "NGC 599:MCG 2-5-5:MK 1000"
{
        Type  "S0"
        RA            1.5481
        Dec         -12.1908
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.4829   0.6401  -0.5976]
        Angle    193.8126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 599"
}

Galaxy "NGC 600:MCG 1-5-7:IRAS 01305-0733"
{
        Type  "SBc"
        RA            1.5514
        Dec          -7.3122
        Distance   7.031e+07  # method: V
        Radius     2.863e+04
        AbsMag        -18.57
        Axis    [  0.5306   0.7780   0.3364]
        Angle    153.3561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 600"
}

Galaxy "NGC 601:MK 1000:NPM 1"
{
        Type  "E0"
        RA            1.5517
        Dec         -12.2083
        Distance   5.755e+08  # distance uncertain!
        Radius     3.348e+04
        AbsMag        -20.13
        Axis    [  0.8038   0.4598   0.3775]
        Angle    135.1513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 601"
}

Galaxy "NGC 605:UGC 1128:MCG 7-4-4:ZWG 537.14"
{
        Type  "S0"
        RA            1.5839
        Dec          41.2478
        Distance   1.341e+08  # distance uncertain!
        Radius     4.291e+04
        AbsMag        -19.07
        Axis    [ -0.2124   0.8206  -0.5305]
        Angle    182.6551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 605"
}

Galaxy "NGC 606:UGC 1126:MCG 3-5-10:ZWG 460.11"
{
        Type  "SBc"
        RA            1.5806
        Dec          21.4181
        Distance   4.386e+08  # method: V
        Radius     8.931e+04
        AbsMag        -21.44
        Axis    [  0.2536   0.8784  -0.4050]
        Angle    178.3085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 606"
}

Galaxy "NGC 608:NGC 618:UGC 1135:MCG 5-4-73"
{
        Type  "Sb"
        RA            1.5911
        Dec          33.6564
        Distance   2.191e+08  # method: V
        Radius     6.054e+04
        AbsMag        -19.94
        Axis    [  0.3121   0.9311   0.1889]
        Angle    127.4667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 608"
}

Galaxy "NGC 612:ESO 353-15:MCG 6-4-46:AM 0131-364"
{
        Type  "Sa"
        RA            1.5658
        Dec         -36.4931
        Distance   3.945e+08  # method: V
        Radius     8.607e+04
        AbsMag        -21.51
        Axis    [  0.3097   0.4461  -0.8397]
        Angle    169.7081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 612"
}

Galaxy "NGC 613:ESO 413-11:MCG 5-4-44:VV 824"
{
        Type  "SBc"
        RA            1.5717
        Dec         -29.4186
        Distance   1.079e+08  # method: T-F
        Radius     8.628e+04
        AbsMag         -21.9
        Axis    [  0.5381   0.6656  -0.5172]
        Angle    178.7136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 613"
}

Galaxy "NGC 614:NGC 627:UGC 1140:MCG 5-4-75"
{
        Type  "S0"
        RA            1.5978
        Dec          33.6819
        Distance   2.217e+08  # method: V
        Radius     4.515e+04
        AbsMag        -20.46
        Axis    [  0.6811   0.6976   0.2224]
        Angle    100.5326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 614"
}

Galaxy "NGC 615:MCG 1-5-8:IRAS 01325-0735"
{
        Type  "Sb"
        RA            1.5847
        Dec          -7.3403
        Distance   1.012e+08  # method: T-F
        Radius     3.976e+04
        AbsMag        -19.96
        Axis    [  0.0633   0.6944  -0.7168]
        Angle    164.3530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 615"
}

Galaxy "NGC 617:MCG 2-5-7:NPM 1"
{
        Type  "Sb"
        RA            1.5672
        Dec          -9.7736
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.7860   0.4886   0.3789]
        Angle    134.2540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 617"
}

Galaxy "NGC 619:ESO 353-21:MCG 6-4-51:AM 0132-364"
{
        Type  "SBb"
        RA            1.5808
        Dec         -36.4894
        Distance   3.758e+08  # method: V
        Radius     8.199e+04
        AbsMag        -21.01
        Axis    [  0.5043   0.6291  -0.5915]
        Angle    174.2556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 619"
}

Galaxy "NGC 620:UGC 1150:MCG 7-4-6:ZWG 537.16"
{
        Type  "E0"
        RA            1.6164
        Dec          42.3228
        Distance   2.089e+08  # distance uncertain!
        Radius     3.039e+04
        AbsMag        -20.13
        Axis    [  0.6610   0.7380   0.1361]
        Angle     96.0046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 620"
}

Galaxy "NGC 621:UGC 1147:MCG 6-4-45:ZWG 521.55"
{
        Type  "S0"
        RA            1.6133
        Dec          35.5125
        Distance   1.379e+08  # method: V
        Radius     2.407e+04
        AbsMag        -19.33
        Axis    [  0.3566   0.9055   0.2300]
        Angle    121.1216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 621"
}

Galaxy "NGC 622:UGC 1143:MCG 0-5-14:MK 571"
{
        Type  "SBc"
        RA            1.6000
        Dec           0.6636
        Distance   2.202e+08  # method: V
        Radius     5.124e+04
        AbsMag        -20.35
        Axis    [  0.3995   0.9078   0.1277]
        Angle    154.4074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 622"
}

Galaxy "NGC 623:ESO 353-23:MCG 6-4-52"
{
        Type  "E0"
        RA            1.5850
        Dec         -36.4900
        Distance   3.959e+08  # method: V
        Radius     1.152e+05
        AbsMag        -21.82
        Axis    [  0.8689   0.3927  -0.3015]
        Angle    191.5226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 623"
}

Galaxy "NGC 624:MCG 2-5-10:IRAS 01333-1015"
{
        Type  "Sb"
        RA            1.5975
        Dec         -10.0031
        Distance   2.531e+08  # method: V
        Radius     5.521e+04
        AbsMag        -20.35
        Axis    [  0.4028   0.8473  -0.3461]
        Angle    169.7385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 624"
}

Galaxy "NGC 625:ESO 297-5:MCG 7-4-17:AM 0132-414"
{
        Type  "Irr"
        RA            1.5844
        Dec         -41.4375
        Distance   8.562e+06  # method: V
        Radius          7223
        AbsMag        -15.39
        Axis    [  0.4703   0.8350  -0.2857]
        Angle    169.1216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 625"
}

Galaxy "NGC 626:ESO 297-6:MCG 7-4-18"
{
        Type  "SBc"
        RA            1.5864
        Dec         -39.1461
        Distance   2.454e+08  # method: V
        Radius     7.852e+04
        AbsMag        -20.98
        Axis    [  0.6457   0.6191   0.4470]
        Angle    177.3232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 626"
}

Galaxy "M 74:NGC 628:UGC 1149:MCG 3-5-11"
{
        Type  "Sc"
        RA            1.6114
        Dec          15.7833
        Distance   1.644e+07  # method: V
        Radius     2.511e+04
        AbsMag        -18.71
        Axis    [  0.5423   0.8127   0.2130]
        Angle    133.1949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 74"
}

Galaxy "NGC 630:ESO 297-9:MCG 7-4-20:AM 0133-393"
{
        Type  "S0"
        RA            1.5933
        Dec         -39.3578
        Distance   2.591e+08  # method: V
        Radius      6.03e+04
        AbsMag         -21.6
        Axis    [  0.7786   0.6269  -0.0273]
        Angle    178.3146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 630"
}

Galaxy "NGC 631:UGC 1153:MCG 1-5-7:ZWG 412.6"
{
        Type  "E0"
        RA            1.6131
        Dec           5.8358
        Distance   2.418e+08  # method: V
        Radius     3.517e+04
        AbsMag        -19.35
        Axis    [  0.5735   0.6698  -0.4717]
        Angle    200.1926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 631"
}

Galaxy "NGC 632:UGC 1157:MCG 1-5-10:MK 1002"
{
        Type  "S0"
        RA            1.6214
        Dec           5.8772
        Distance   1.301e+08  # method: V
        Radius     1.892e+04
        AbsMag         -19.6
        Axis    [  0.1266   0.6265  -0.7691]
        Angle    199.5334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 632"
}

Galaxy "NGC 633:ESO 297-11:MCG 6-4-56:AM 0134-373"
{
        Type  "SBb"
        RA            1.6064
        Dec         -37.3208
        Distance   2.241e+08  # method: V
        Radius     4.564e+04
        AbsMag        -20.69
        Axis    [  0.5190   0.4728  -0.7121]
        Angle    186.2255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 633"
}

Galaxy "NGC 634:UGC 1164:MCG 6-4-48:ZWG 521.60"
{
        Type  "Sa"
        RA            1.6383
        Dec          35.3647
        Distance   2.548e+08  # method: T-F
        Radius     7.782e+04
        AbsMag        -20.56
        Axis    [ -0.3045   0.6714  -0.6757]
        Angle    180.6710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 634"
}

Galaxy "NGC 635:MCG 4-5-2:IRAS 01359-2310"
{
        Type  "Sb"
        RA            1.6381
        Dec         -22.9289
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.8087   0.4241   0.4076]
        Angle    144.7712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 635"
}

Galaxy "NGC 636:MCG 1-5-13"
{
        Type  "E3"
        RA            1.6517
        Dec          -7.5122
        Distance   9.715e+07  # method: S
        Radius     3.956e+04
        AbsMag        -19.87
        Axis    [  0.8245   0.5631   0.0560]
        Angle    151.8824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 636"
}

Galaxy "NGC 638:UGC 1170:MCG 1-5-14:MK 1003"
{
        Type  "Sb"
        RA            1.6603
        Dec           7.2372
        Distance   1.508e+08  # method: V
        Radius     1.754e+04
        AbsMag        -18.82
        Axis    [  0.3889   0.8565   0.3393]
        Angle    144.9923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 638"
}

Galaxy "NGC 639:ESO 413-13:MCG 5-5-2:IRAS 01367-3010"
{
        Type  "Sa"
        RA            1.6497
        Dec         -29.9250
        Distance   2.533e+08  # method: V
        Radius     3.684e+04
        AbsMag        -19.75
        Axis    [  0.3261   0.9155   0.2355]
        Angle    181.1998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 639"
}

Galaxy "NGC 640:MCG 2-5-31"
{
        Type  "Sa"
        RA            1.6567
        Dec          -9.4011
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.2802   0.6883  -0.6691]
        Angle    181.0378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 640"
}

Galaxy "NGC 641:ESO 244-42:MCG 7-4-26:AM 0136-424"
{
        Type  "S0"
        RA            1.6442
        Dec         -42.5275
        Distance   2.309e+08  # method: T-F
        Radius     4.702e+04
        AbsMag        -21.15
        Axis    [  0.7500   0.4958   0.4377]
        Angle    171.9198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 641"
}

Galaxy "NGC 642:ESO 413-14:MCG 5-5-3:VV 419"
{
        Type  "SBc"
        RA            1.6517
        Dec         -29.9153
        Distance   2.838e+08  # method: T-F
        Radius     8.256e+04
        AbsMag         -21.7
        Axis    [  0.5423   0.8078   0.2310]
        Angle    174.4862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 642"
}

Galaxy "NGC 643B:ESO 29-53:IRAS 01384-7515"
{
        Type  "S0"
        RA            1.6536
        Dec         -75.0114
        Distance   1.779e+08  # method: V
        Radius      3.88e+04
        AbsMag        -19.18
        Axis    [  0.6039   0.6700  -0.4318]
        Angle    160.6458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 643B"
}

Galaxy "NGC 643C:ESO 30-1:FGCE 186"
{
        Type  "Sc"
        RA            1.6967
        Dec         -75.2675
        Distance   2.934e+08  # distance uncertain!
        Radius     5.547e+04
        AbsMag        -19.07
        Axis    [  0.5459   0.5205  -0.6566]
        Angle    138.7242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 643C"
}

Galaxy "NGC 644:ESO 244-43:MCG 7-4-27:FAIR 706"
{
        Type  "SBc"
        RA            1.6478
        Dec         -42.5856
        Distance   2.527e+08  # method: T-F
        Radius     4.779e+04
        AbsMag        -19.65
        Axis    [  0.3765   0.5452  -0.7490]
        Angle    159.9553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 644"
}

Galaxy "NGC 645:UGC 1177:MCG 1-5-16:ZWG 412.13"
{
        Type  "SBb"
        RA            1.6689
        Dec           5.7261
        Distance   1.366e+08  # method: V
        Radius     5.165e+04
        AbsMag        -19.61
        Axis    [  0.0959   0.8597  -0.5017]
        Angle    166.5581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 645"
}

Galaxy "NGC 646-1:ESO 80-2:VV 443:AM 0135-650"
{
        Type  "SBc"
        RA            1.6225
        Dec         -64.8953
        Distance   3.687e+08  # method: V
        Radius     1.073e+05
        AbsMag        -21.07
        Axis    [  0.8209   0.5404  -0.1843]
        Angle    187.4215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 646-1"
}

Galaxy "NGC 646-2:ESO 80-2:VV 443:AM 0135-650"
{
        Type  "S0"
        RA            1.6250
        Dec         -64.8958
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8342   0.2447   0.4941]
        Angle    180.0831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 646-2"
}

Galaxy "NGC 647:MCG 2-5-33:NPM 1"
{
        Type  "S0"
        RA            1.6656
        Dec          -9.2419
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [  0.5285   0.7170   0.4545]
        Angle    152.5852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 647"
}

Galaxy "NGC 648:IC 146:ESO 543-6:MCG 3-5-11"
{
        Type  "S0"
        RA            1.6442
        Dec         -17.8311
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.3730   0.8050  -0.4613]
        Angle    169.0144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 648"
}

Galaxy "NGC 649:MCG 2-5-34"
{
        Type  "Sa"
        RA            1.6686
        Dec          -9.2717
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.3131   0.8792   0.3592]
        Angle    164.9318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 649"
}

Galaxy "NGC 652:UGC 1184:MCG 1-5-17:ZWG 412.14"
{
        Type  "S0"
        RA            1.6786
        Dec           7.9833
        Distance   2.281e+08  # method: V
        Radius     3.317e+04
        AbsMag        -19.52
        Axis    [  0.3236   0.9450   0.0482]
        Angle    151.5660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 652"
}

Galaxy "NGC 653:UGC 1193:MCG 6-4-58:ZWG 521.70"
{
        Type  "Sb"
        RA            1.7069
        Dec          35.6386
        Distance    1.54e+08  # distance uncertain!
        Radius     3.359e+04
        AbsMag        -19.07
        Axis    [ -0.1174   0.9447   0.3062]
        Angle    139.2105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 653"
}

Galaxy "NGC 655:MCG 2-5-37"
{
        Type  "S0"
        RA            1.6986
        Dec         -13.0825
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.4620   0.8703  -0.1706]
        Angle    165.1333
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 655"
}

Galaxy "NGC 656:UGC 1194:MCG 4-5-2:ZWG 482.4"
{
        Type  "S0"
        RA            1.7075
        Dec          26.1433
        Distance   1.661e+08  # method: V
        Radius     3.623e+04
        AbsMag        -20.13
        Axis    [  0.4344   0.8901   0.1377]
        Angle    130.9402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 656"
}

Galaxy "NGC 658:UGC 1192:MCG 2-5-9:ZWG 437.9"
{
        Type  "Sb"
        RA            1.7025
        Dec          12.6014
        Distance   1.258e+08  # method: T-F
        Radius     5.489e+04
        AbsMag        -19.83
        Axis    [  0.3040   0.8922   0.3339]
        Angle    143.3495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 658"
}

Galaxy "NGC 660:UGC 1201:MCG 2-5-13:ZWG 437.12"
{
        Type  "SBa"
        RA            1.7169
        Dec          13.6436
        Distance   2.555e+07  # method: V
        Radius     3.084e+04
        AbsMag        -17.77
        Axis    [ -0.1148   0.6442  -0.7562]
        Angle    176.4655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 660"
}

Galaxy "NGC 661:UGC 1215:MCG 5-5-5:ZWG 503.14"
{
        Type  "E0"
        RA            1.7372
        Dec          28.7067
        Distance   9.948e+07  # method: T-F
        Radius     2.315e+04
        AbsMag        -19.22
        Axis    [  0.6075   0.7813  -0.1434]
        Angle    145.9992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 661"
}

Galaxy "NGC 662:UGC 1220:MCG 6-4-60:ZWG 521.73"
{
        Type  "Sc"
        RA            1.7431
        Dec          37.6964
        Distance   2.499e+08  # method: T-F
        Radius     2.907e+04
        AbsMag        -20.02
        Axis    [  0.2095   0.9147   0.3455]
        Angle    121.8366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 662"
}

Galaxy "NGC 664:UGC 1210:MCG 1-5-29:ZWG 412.23"
{
        Type  "Sb"
        RA            1.7292
        Dec           4.2225
        Distance   2.326e+08  # method: V
        Radius     3.722e+04
        AbsMag        -20.57
        Axis    [  0.4836   0.8719  -0.0767]
        Angle    156.0927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 664"
}

Galaxy "NGC 665:UGC 1223:MCG 2-5-19:ZWG 437.19"
{
        Type  "S0"
        RA            1.7489
        Dec          10.4231
        Distance   2.324e+08  # method: V
        Radius     8.112e+04
        AbsMag        -21.06
        Axis    [  0.1705   0.8482  -0.5015]
        Angle    173.3274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 665"
}

Galaxy "NGC 666:UGC 1236:MCG 6-5-2:ZWG 521.79"
{
        Type  "S0"
        RA            1.7683
        Dec          34.3747
        Distance   2.063e+08  # method: V
        Radius     2.101e+04
        AbsMag        -19.81
        Axis    [  0.1353   0.9798  -0.1473]
        Angle    149.9698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 666"
}

Galaxy "NGC 667:ESO 477-2"
{
        Type  "S0"
        RA            1.7489
        Dec         -22.9192
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.6308   0.7310  -0.2602]
        Angle    172.9660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 667"
}

Galaxy "NGC 668:UGC 1238:MCG 6-5-3:ZWG 521.80"
{
        Type  "Sb"
        RA            1.7728
        Dec          36.4600
        Distance   1.224e+08  # method: T-F
        Radius     3.203e+04
        AbsMag        -19.17
        Axis    [  0.2222   0.9424   0.2500]
        Angle    125.0522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 668"
}

Galaxy "NGC 669:UGC 1248:MCG 6-5-4:ZWG 522.4"
{
        Type  "Sb"
        RA            1.7878
        Dec          35.5631
        Distance   2.655e+08  # method: T-F
        Radius     1.197e+05
        AbsMag        -21.25
        Axis    [ -0.1003   0.9370   0.3346]
        Angle    138.0332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 669"
}

Galaxy "NGC 670:UGC 1250:MCG 5-5-12:ZWG 503.24"
{
        Type  "S0"
        RA            1.7900
        Dec          27.8861
        Distance   1.559e+08  # method: V
        Radius     4.761e+04
        AbsMag         -19.8
        Axis    [ -0.2044   0.6618  -0.7213]
        Angle    184.8561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 670"
}

Galaxy "NGC 671:UGC 1247:MCG 2-5-29:ZWG 437.27"
{
        Type  "S0"
        RA            1.7831
        Dec          13.1253
        Distance   2.344e+08  # method: V
        Radius     5.114e+04
        AbsMag        -20.08
        Axis    [  0.1265   0.9871   0.0980]
        Angle    149.0281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 671"
}

Galaxy "NGC 672:UGC 1256:MCG 4-5-11:ZWG 482.16"
{
        Type  "SBc"
        RA            1.7983
        Dec          27.4328
        Distance   6.886e+06  # method: V
        Radius          6009
        AbsMag        -15.22
        Axis    [  0.0308   0.9993   0.0221]
        Angle    144.1068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 672"
}

Galaxy "NGC 673:UGC 1259:MCG 2-5-33:ZWG 437.30"
{
        Type  "Sc"
        RA            1.8061
        Dec          11.5214
        Distance    2.63e+08  # method: T-F
        Radius     8.032e+04
        AbsMag        -21.33
        Axis    [  0.5137   0.7292   0.4521]
        Angle    129.9358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 673"
}

Galaxy "NGC 675:UGC 1273:MCG 2-5-41:MK 1166"
{
        Type  "S0"
        RA            1.8189
        Dec          13.0597
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.0660   0.9562  -0.2850]
        Angle    156.2383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 675"
}

Galaxy "NGC 676:UGC 1270:MCG 1-5-34:ZWG 412.28"
{
        Type  "Sa"
        RA            1.8158
        Dec           5.9061
        Distance   5.549e+07  # method: V
        Radius     3.228e+04
        AbsMag        -18.35
        Axis    [ -0.1295   0.6110  -0.7810]
        Angle    163.7142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 676"
}

Galaxy "NGC 677:UGC 1275:MCG 2-5-42:ZWG 437.39"
{
        Type  "E0"
        RA            1.8206
        Dec          13.0558
        Distance   2.182e+08  # method: V
        Radius     6.346e+04
        AbsMag        -20.93
        Axis    [  0.7836   0.5548   0.2797]
        Angle    113.7078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 677"
}

Galaxy "NGC 678:UGC 1280:MCG 4-5-14:ZWG 482.18"
{
        Type  "SBb"
        RA            1.8233
        Dec          21.9969
        Distance   8.988e+07  # method: T-F
        Radius     5.882e+04
        AbsMag         -18.9
        Axis    [ -0.1103   0.9925  -0.0522]
        Angle    147.7800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 678"
}

Galaxy "NGC 679:UGC 1283:MCG 6-5-12:ZWG 522.15"
{
        Type  "S0"
        RA            1.8286
        Dec          35.7861
        Distance   1.903e+08  # method: T-F
        Radius     5.257e+04
        AbsMag        -20.53
        Axis    [  0.6971   0.6865   0.2070]
        Angle     97.1053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 679"
}

Galaxy "NGC 680:UGC 1286:MCG 4-5-15:ZWG 482.19"
{
        Type  "E0"
        RA            1.8297
        Dec          21.9711
        Distance   1.161e+08  # method: T-F
        Radius      3.04e+04
        AbsMag        -19.86
        Axis    [  0.3409   0.7283  -0.5944]
        Angle    220.4661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 680"
}

Galaxy "NGC 681:MCG 2-5-52:IRAS 01467-1040"
{
        Type  "SBb"
        RA            1.8194
        Dec         -10.4272
        Distance   6.727e+07  # method: V
        Radius     2.642e+04
        AbsMag        -18.77
        Axis    [  0.4928   0.8698  -0.0228]
        Angle    160.1862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 681"
}

Galaxy "NGC 682:MCG 3-5-22"
{
        Type  "S0"
        RA            1.8178
        Dec         -14.9744
        Distance   1.612e+08  # distance uncertain!
        Radius     3.283e+04
        AbsMag        -19.07
        Axis    [  0.5261   0.7838  -0.3301]
        Angle    170.3340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 682"
}

Galaxy "NGC 683:UGC 1288:MCG 2-5-47:ZWG 437.43"
{
        Type  "S0"
        RA            1.8294
        Dec          11.7019
        Distance   2.256e+08  # method: V
        Radius     3.281e+04
        AbsMag         -19.6
        Axis    [  0.7690   0.5649   0.2992]
        Angle    115.5937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 683"
}

Galaxy "NGC 684:IC 165:UGC 1292:MCG 4-5-17"
{
        Type  "Sb"
        RA            1.8372
        Dec          27.6461
        Distance   1.538e+08  # method: T-F
        Radius     2.685e+04
        AbsMag        -20.07
        Axis    [  0.0343   0.9841  -0.1741]
        Angle    151.3173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 684"
}

Galaxy "NGC 685:ESO 152-24:AM 0145-530:IRAS 01458-5300"
{
        Type  "SBc"
        RA            1.7950
        Dec         -52.7619
        Distance     5.5e+07  # method: V
        Radius      2.88e+04
        AbsMag        -19.23
        Axis    [  0.8255   0.5398  -0.1649]
        Angle    183.4400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 685"
}

Galaxy "NGC 686:ESO 477-6:MCG 4-5-8"
{
        Type  "S0"
        RA            1.8156
        Dec         -23.7981
        Distance   1.999e+08  # method: V
        Radius     4.943e+04
        AbsMag        -20.54
        Axis    [  0.6641   0.6627   0.3461]
        Angle    161.4888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 686"
}

Galaxy "NGC 687:UGC 1298:MCG 6-5-14:ZWG 522.17"
{
        Type  "S0"
        RA            1.8425
        Dec          36.3708
        Distance   1.903e+08  # method: T-F
        Radius     3.874e+04
        AbsMag        -20.53
        Axis    [  0.6963   0.6882   0.2040]
        Angle     96.5631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 687"
}

Galaxy "NGC 688:UGC 1302:MCG 6-5-15:MK 1009"
{
        Type  "SBb"
        RA            1.8456
        Dec          35.2847
        Distance   2.288e+08  # method: T-F
        Radius     7.986e+04
        AbsMag        -20.93
        Axis    [ -0.1058   0.8307  -0.5466]
        Angle    182.5465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 688"
}

Galaxy "NGC 689:ESO 414-5:MCG 5-5-19:AM 0147-274"
{
        Type  "Sb"
        RA            1.8308
        Dec         -27.4664
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.5546   0.8260  -0.1004]
        Angle    168.5442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 689"
}

Galaxy "NGC 690:MCG 3-5-21:A 0145-16"
{
        Type  "SBc"
        RA            1.7967
        Dec         -16.7214
        Distance    2.22e+08  # method: V
        Radius     3.875e+04
        AbsMag        -18.96
        Axis    [  0.3023   0.6626  -0.6852]
        Angle    175.1081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 690"
}

Galaxy "NGC 691:UGC 1305:MCG 4-5-19:ZWG 482.23"
{
        Type  "Sc"
        RA            1.8447
        Dec          21.7603
        Distance   1.083e+08  # method: V
        Radius     5.354e+04
        AbsMag         -20.3
        Axis    [  0.2146   0.9365  -0.2775]
        Angle    160.1185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 691"
}

Galaxy "NGC 692:ESO 197-3:FAIR 712:IRAS 01467-4853"
{
        Type  "SBc"
        RA            1.8117
        Dec         -48.6481
        Distance   2.762e+08  # method: V
        Radius     8.436e+04
        AbsMag        -21.54
        Axis    [  0.8011   0.5709   0.1800]
        Angle    180.9938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 692"
}

Galaxy "NGC 693:UGC 1304:MCG 1-5-35:ZWG 412.33"
{
        Type  "Sa"
        RA            1.8417
        Dec           6.1447
        Distance   5.799e+07  # method: V
        Radius     1.855e+04
        AbsMag        -18.05
        Axis    [  0.1643   0.9164  -0.3649]
        Angle    160.6910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 693"
}

Galaxy "NGC 694:UGC 1310:MCG 4-5-20:MK 363"
{
        Type  "S0"
        RA            1.8494
        Dec          21.9969
        Distance   1.212e+08  # method: V
        Radius     1.057e+04
        AbsMag        -18.55
        Axis    [ -0.0287   0.7370  -0.6753]
        Angle    188.8771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 694"
}

Galaxy "NGC 695:UGC 1315:ZWG 482.26:ZW 123"
{
        Type  "S0"
        RA            1.8539
        Dec          22.5828
        Distance   4.286e+08  # method: V
        Radius     4.987e+04
        AbsMag        -21.69
        Axis    [  0.4670   0.8792   0.0943]
        Angle    133.7982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 695"
}

Galaxy "NGC 696:ESO 353-50:MCG 6-5-4"
{
        Type  "SBa"
        RA            1.8253
        Dec         -34.9050
        Distance   3.541e+08  # method: V
        Radius     8.756e+04
        AbsMag        -20.78
        Axis    [  0.4742   0.8394   0.2656]
        Angle    180.9751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 696"
}

Galaxy "NGC 697:NGC 674:UGC 1317:MCG 4-5-22"
{
        Type  "SBc"
        RA            1.8547
        Dec          22.3575
        Distance   1.277e+08  # method: T-F
        Radius     7.429e+04
        AbsMag        -20.16
        Axis    [ -0.0743   0.9505  -0.3017]
        Angle    154.6855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 697"
}

Galaxy "NGC 698:ESO 353-51:MCG 6-5-5:AM 0147-350"
{
        Type  "SBb"
        RA            1.8286
        Dec         -34.8314
        Distance   3.696e+08  # method: V
        Radius     4.838e+04
        AbsMag        -20.47
        Axis    [  0.4215   0.4048  -0.8115]
        Angle    189.2734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 698"
}

Galaxy "NGC 699:MCG 2-5-59:IRAS 01482-1217"
{
        Type  "Sc"
        RA            1.8453
        Dec         -12.0356
        Distance   2.408e+08  # method: T-F
        Radius     5.604e+04
        AbsMag        -19.44
        Axis    [  0.0574   0.8107  -0.5827]
        Angle    150.7220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 699"
}

Galaxy "NGC 700:ZWG 522.30"
{
        Type  "S0"
        RA            1.8711
        Dec          36.0367
        Distance   2.012e+08  # method: V
        Radius     2.341e+04
        AbsMag        -18.35
        Axis    [  0.4709   0.7868   0.3989]
        Angle    105.6518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 700"
}

Galaxy "NGC 701:MCG 2-5-60:IRAS 01485-0957"
{
        Type  "SBc"
        RA            1.8508
        Dec          -9.7033
        Distance   7.792e+07  # method: T-F
        Radius     2.946e+04
        AbsMag        -18.99
        Axis    [  0.4367   0.8843   0.1654]
        Angle    158.4657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 701"
}

Galaxy "NGC 702:MCG 1-5-43:ARP 75"
{
        Type  "SBc"
        RA            1.8553
        Dec          -4.0556
        Distance    4.68e+08  # method: V
        Radius     8.167e+04
        AbsMag        -21.88
        Axis    [  0.2277   0.7391  -0.6339]
        Angle    175.3592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 702"
}

Galaxy "NGC 703:UGC 1346:MCG 6-5-29:ZWG 522.37"
{
        Type  "S0"
        RA            1.8775
        Dec          36.1722
        Distance   2.041e+08  # method: V
        Radius     2.671e+04
        AbsMag        -19.68
        Axis    [  0.2595   0.9643   0.0530]
        Angle    131.7921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 703"
}

Galaxy "NGC 704-1:UGC 1343:MCG 6-5-28:ZWG 522.34"
{
        Type  "S0"
        RA            1.8769
        Dec          36.1269
        Distance   1.281e+08  # distance uncertain!
        Radius     1.118e+04
        AbsMag        -19.07
        Axis    [  0.0623   0.9767  -0.2056]
        Angle    152.7191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 704-1"
}

Galaxy "NGC 704-2:ZWG 522.33"
{
        Type  "E0"
        RA            1.8772
        Dec          36.1244
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.7218   0.6678   0.1817]
        Angle     95.8794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 704-2"
}

Galaxy "NGC 705:UGC 1345:MCG 6-5-30:ZWG 522.36"
{
        Type  "Sa"
        RA            1.8781
        Dec          36.1444
        Distance   1.945e+08  # method: V
        Radius     3.395e+04
        AbsMag        -19.28
        Axis    [ -0.2635   0.9099  -0.3205]
        Angle    155.2503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 705"
}

Galaxy "NGC 706:UGC 1334:MCG 1-5-40:ZWG 412.37"
{
        Type  "Sc"
        RA            1.8639
        Dec           6.2961
        Distance    2.13e+08  # method: V
        Radius     5.885e+04
        AbsMag        -20.87
        Axis    [  0.1958   0.7335  -0.6508]
        Angle    186.2648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 706"
}

Galaxy "NGC 707-1:MCG 2-5-63"
{
        Type  "S0"
        RA            1.8575
        Dec          -8.5061
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.4225   0.8484  -0.3189]
        Angle    165.5437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 707-1"
}

Galaxy "NGC 707-2:MCG 2-5-63"
{
        Type  "E0"
        RA            1.8575
        Dec          -8.5069
        Distance   3.468e+08  # distance uncertain!
        Radius     1.513e+04
        AbsMag        -20.13
        Axis    [  0.8234   0.4499   0.3457]
        Angle    130.8840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 707-2"
}

Galaxy "NGC 708:UGC 1348:MCG 6-5-31:ZWG 522.39"
{
        Type  "E0"
        RA            1.8794
        Dec          36.1522
        Distance   1.903e+08  # method: T-F
        Radius     8.301e+04
        AbsMag        -20.93
        Axis    [  0.6327   0.7735  -0.0375]
        Angle    121.3051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 708"
}

Galaxy "NGC 709:ZWG 522.40"
{
        Type  "S0"
        RA            1.8806
        Dec          36.2231
        Distance    1.41e+08  # method: V
        Radius      2.05e+04
        AbsMag        -17.98
        Axis    [ -0.1585   0.8611  -0.4831]
        Angle    172.0969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 709"
}

Galaxy "NGC 710:UGC 1349:MCG 6-5-33:ZWG 522.41"
{
        Type  "Sc"
        RA            1.8817
        Dec          36.0533
        Distance   2.654e+08  # method: V
        Radius     5.018e+04
        AbsMag        -20.35
        Axis    [  0.4133   0.9103   0.0206]
        Angle    128.2526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 710"
}

Galaxy "NGC 711:UGC 1342:MCG 3-5-24:ZWG 460.38"
{
        Type  "S0"
        RA            1.8742
        Dec          17.5131
        Distance   2.107e+08  # method: V
        Radius     4.903e+04
        AbsMag        -19.75
        Axis    [  0.2492   0.8720   0.4213]
        Angle    139.7463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 711"
}

Galaxy "NGC 712:UGC 1352:MCG 6-5-35:ZWG 522.43"
{
        Type  "S0"
        RA            1.8856
        Dec          36.8197
        Distance   2.271e+08  # method: V
        Radius     3.303e+04
        AbsMag        -20.41
        Axis    [  0.0263   0.9872  -0.1576]
        Angle    148.8700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 712"
}

Galaxy "NGC 713:MCG 2-5-75"
{
        Type  "Sb"
        RA            1.9225
        Dec          -9.0833
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.2022   0.9378  -0.2822]
        Angle    155.8669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 713"
}

Galaxy "NGC 714:UGC 1358:MCG 6-5-37:ZWG 522.47"
{
        Type  "Sa"
        RA            1.8914
        Dec          36.2214
        Distance   1.908e+08  # method: V
        Radius     4.162e+04
        AbsMag        -19.73
        Axis    [ -0.2472   0.9188  -0.3076]
        Angle    154.8359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 714"
}

Galaxy "NGC 715:MCG 2-5-69"
{
        Type  "Sb"
        RA            1.8867
        Dec         -12.8733
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.0867   0.5371  -0.8391]
        Angle    170.1051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 715"
}

Galaxy "NGC 716:IC 1743:UGC 1351:MCG 2-5-54"
{
        Type  "SBa"
        RA            1.8831
        Dec          12.7083
        Distance   2.107e+08  # method: T-F
        Radius     5.516e+04
        AbsMag        -20.15
        Axis    [  0.2016   0.9776   0.0599]
        Angle    147.5401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 716"
}

Galaxy "NGC 717:UGC 1363:MCG 6-5-41:ZWG 522.52"
{
        Type  "Sa"
        RA            1.8986
        Dec          36.2297
        Distance   2.139e+08  # method: V
        Radius     4.045e+04
        AbsMag        -19.18
        Axis    [ -0.3166   0.8887  -0.3318]
        Angle    154.0755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 717"
}

Galaxy "NGC 718:UGC 1356:MCG 1-5-41:ZWG 412.39"
{
        Type  "SBa"
        RA            1.8869
        Dec           4.1956
        Distance   6.587e+07  # method: V
        Radius     2.203e+04
        AbsMag        -18.93
        Axis    [  0.6601   0.7506   0.0305]
        Angle    146.1918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 718"
}

Galaxy "NGC 719:IC 1744:UGC 1360:MCG 3-5-26"
{
        Type  "S0"
        RA            1.8939
        Dec          19.8408
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.0865   0.7750  -0.6260]
        Angle    189.5244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 719"
}

Galaxy "NGC 720:MCG 2-5-68"
{
        Type  "E5"
        RA            1.8833
        Dec         -13.7386
        Distance   9.025e+07  # method: S
        Radius     6.169e+04
        AbsMag        -21.01
        Axis    [  0.5908   0.5075  -0.6272]
        Angle    207.5389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 720"
}

Galaxy "NGC 721:UGC 1376:MCG 6-5-43:ZWG 522.56"
{
        Type  "SBc"
        RA            1.9125
        Dec          39.3831
        Distance   2.426e+08  # method: V
        Radius     5.998e+04
        AbsMag        -20.26
        Axis    [ -0.1342   0.8706  -0.4733]
        Angle    175.2114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 721"
}

Galaxy "NGC 722:UGC 1379:MCG 3-5-32:ZWG 460.46"
{
        Type  "Sc"
        RA            1.9128
        Dec          20.6983
        Distance   2.097e+08  # method: V
        Radius     5.185e+04
        AbsMag        -19.64
        Axis    [ -0.1553   0.8258  -0.5421]
        Angle    162.0074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 722"
}

Galaxy "NGC 723:NGC 724:ESO 477-13:MCG 4-5-16"
{
        Type  "Sc"
        RA            1.8958
        Dec         -23.7572
        Distance   5.667e+07  # method: V
        Radius     1.236e+04
        AbsMag         -17.9
        Axis    [  0.3368   0.4742  -0.8135]
        Angle    190.2768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 723"
}

Galaxy "NGC 725:MCG 3-5-25"
{
        Type  "Sc"
        RA            1.8764
        Dec         -16.5175
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.4813   0.8576  -0.1814]
        Angle    163.8774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 725"
}

Galaxy "NGC 726:MCG 2-6-3:KUG 0153-110"
{
        Type  "Irr"
        RA            1.9253
        Dec         -10.7994
        Distance   2.308e+08  # method: V
        Radius     4.028e+04
        AbsMag        -19.35
        Axis    [  0.3186   0.8815  -0.3484]
        Angle    160.9197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 726"
}

Galaxy "NGC 727:NGC 729:ESO 354-10:MCG 6-5-12"
{
        Type  "SBb"
        RA            1.8969
        Dec         -35.8558
        Distance   4.463e+08  # method: V
        Radius      7.14e+04
        AbsMag        -20.78
        Axis    [  0.5713   0.8012  -0.1780]
        Angle    170.2398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 727"
}

Galaxy "NGC 731:NGC 757:MCG 2-5-73"
{
        Type  "E0"
        RA            1.9153
        Dec          -9.0114
        Distance   1.446e+08  # distance uncertain!
        Radius     3.574e+04
        AbsMag        -20.13
        Axis    [  0.8286   0.4425   0.3430]
        Angle    131.0646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 731"
}

Galaxy "NGC 732:UGC 1406:MCG 6-5-57:MK 1011"
{
        Type  "S0"
        RA            1.9408
        Dec          36.8022
        Distance   2.558e+08  # method: V
        Radius     5.209e+04
        AbsMag        -19.87
        Axis    [  0.2740   0.9284   0.2509]
        Angle    121.1235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 732"
}

Galaxy "NGC 734"
{
        Type  "SBa"
        RA            1.9158
        Dec         -17.0797
        Distance   4.869e+08  # distance uncertain!
        Radius     4.957e+04
        AbsMag        -19.07
        Axis    [  0.5067   0.8130   0.2869]
        Angle    162.5086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 734"
}

Galaxy "NGC 735:UGC 1411:MCG 6-5-58:ZWG 522.78"
{
        Type  "Sb"
        RA            1.9439
        Dec          34.1775
        Distance   2.366e+08  # method: T-F
        Radius     6.194e+04
        AbsMag         -20.2
        Axis    [ -0.1802   0.8438  -0.5055]
        Angle    170.2866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 735"
}

Galaxy "NGC 736:UGC 1414:MCG 5-5-28:ZWG 503.55"
{
        Type  "E0"
        RA            1.9447
        Dec          33.0444
        Distance   1.903e+08  # method: T-F
        Radius     4.151e+04
        AbsMag        -20.63
        Axis    [  0.7398   0.6443   0.1940]
        Angle     97.5967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 736"
}

Galaxy "NGC 738:ZWG 503.57:ZW 113:NPM 1"
{
        Type  "S0"
        RA            1.9458
        Dec          33.0589
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.1810   0.7720  -0.6093]
        Angle    180.3662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 738"
}

Galaxy "NGC 739:MCG 5-5-30:ZWG 503.59:ARAK 67"
{
        Type  "Sa"
        RA            1.9483
        Dec          33.2672
        Distance   1.885e+08  # method: V
        Radius     2.467e+04
        AbsMag        -18.81
        Axis    [ -0.0185   0.8926  -0.4504]
        Angle    172.3746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 739"
}

Galaxy "NGC 740:UGC 1421:MCG 5-5-31:ZWG 503.58"
{
        Type  "SBb"
        RA            1.9486
        Dec          33.0156
        Distance   2.242e+08  # method: T-F
        Radius     4.566e+04
        AbsMag        -19.29
        Axis    [ -0.3128   0.8159  -0.4863]
        Angle    159.9102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 740"
}

Galaxy "NGC 741:IC 1751:UGC 1413:MCG 1-6-3"
{
        Type  "E0"
        RA            1.9389
        Dec           5.6286
        Distance   2.296e+08  # method: T-F
        Radius     1.002e+05
        AbsMag        -21.94
        Axis    [  0.6751   0.6689  -0.3112]
        Angle    174.2528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 741"
}

Galaxy "NGC 742:MCG 1-6-4:ZWG 413.9:VV 175"
{
        Type  "S0"
        RA            1.9400
        Dec           5.6258
        Distance   2.324e+08  # method: V
        Radius     1.014e+04
        AbsMag        -18.96
        Axis    [  0.7914   0.5256   0.3122]
        Angle    119.8746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 742"
}

Galaxy "NGC 745-1:ESO 152-32:AM 0152-565"
{
        Type  "Sa"
        RA            1.9019
        Dec         -56.6936
        Distance   2.641e+08  # method: V
        Radius     4.994e+04
        AbsMag        -21.24
        Axis    [  0.7328   0.6801   0.0233]
        Angle    186.0778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 745-1"
}

Galaxy "NGC 745-2:ESO 152-32:AM 0152-565"
{
        Type  "S0"
        RA            1.9031
        Dec         -56.6853
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.6237   0.7095  -0.3280]
        Angle    171.1746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 745-2"
}

Galaxy "NGC 745-3:ESO 152-32:AM 0152-565"
{
        Type  "E0"
        RA            1.9019
        Dec         -56.6875
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.8587   0.2436   0.4509]
        Angle    171.5164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 745-3"
}

Galaxy "NGC 746:UGC 1438:MCG 7-5-3:ZWG 538.4"
{
        Type  "Irr"
        RA            1.9642
        Dec          44.9183
        Distance   2.211e+07  # method: V
        Radius          5466
        AbsMag        -15.55
        Axis    [ -0.0627   0.9831  -0.1721]
        Angle    148.6224
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 746"
}

Galaxy "NGC 747:MCG 2-6-7"
{
        Type  "Sb"
        RA            1.9583
        Dec          -9.4628
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.0586   0.5487  -0.8339]
        Angle    170.7404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 747"
}

Galaxy "NGC 748:MCG 1-6-4:IRAS 01538-0442"
{
        Type  "Sb"
        RA            1.9392
        Dec          -4.4672
        Distance   2.288e+08  # method: V
        Radius     7.653e+04
        AbsMag        -20.83
        Axis    [  0.1426   0.7736  -0.6174]
        Angle    164.8005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 748"
}

Galaxy "NGC 749:ESO 414-11:MCG 5-5-23:IRAS 01534-3009"
{
        Type  "SBa"
        RA            1.9278
        Dec         -29.9222
        Distance    1.89e+08  # method: V
        Radius     5.224e+04
        AbsMag        -20.41
        Axis    [  0.5492   0.6894  -0.4724]
        Angle    172.3877
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 749"
}

Galaxy "NGC 750:UGC 1430:MCG 5-5-34:ZWG 503.62"
{
        Type  "E0"
        RA            1.9589
        Dec          33.2097
        Distance   1.903e+08  # method: T-F
        Radius     4.427e+04
        AbsMag        -20.83
        Axis    [  0.2481   0.7847  -0.5680]
        Angle    223.9492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 750"
}

Galaxy "NGC 751:UGC 1431:MCG 5-5-35:ZWG 503.62"
{
        Type  "E0"
        RA            1.9592
        Dec          33.2025
        Distance   2.226e+08  # method: V
        Radius     3.884e+04
        AbsMag        -20.97
        Axis    [  0.7407   0.6436   0.1928]
        Angle     97.3684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 751"
}

Galaxy "NGC 753:UGC 1437:MCG 6-5-66:ZWG 522.86"
{
        Type  "SBc"
        RA            1.9617
        Dec          35.9158
        Distance    2.02e+08  # method: T-F
        Radius     8.812e+04
        AbsMag        -20.96
        Axis    [ -0.0547   0.9022  -0.4279]
        Angle    170.0501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 753"
}

Galaxy "NGC 754:ESO 152-33"
{
        Type  "E0"
        RA            1.9056
        Dec         -56.7611
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.9230   0.2219  -0.3145]
        Angle    194.3946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 754"
}

Galaxy "NGC 755:NGC 763:MCG 2-6-5:KUG 0153-093"
{
        Type  "SBb"
        RA            1.9394
        Dec          -9.0625
        Distance   7.461e+07  # method: T-F
        Radius     3.581e+04
        AbsMag         -18.4
        Axis    [  0.3140   0.9384   0.1441]
        Angle    159.1512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 755"
}

Galaxy "NGC 756:MCG 3-5-29"
{
        Type  "S0"
        RA            1.9081
        Dec         -16.7075
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.5338   0.8179   0.2148]
        Angle    161.2381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 756"
}

Galaxy "NGC 758:NPM 1"
{
        Type  "S0"
        RA            1.9283
        Dec          -3.0661
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.4659   0.8502  -0.2452]
        Angle    162.5809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 758"
}

Galaxy "NGC 759:UGC 1440:MCG 6-5-67:ZWG 522.87"
{
        Type  "E0"
        RA            1.9639
        Dec          36.3431
        Distance     2.1e+08  # method: V
        Radius     4.276e+04
        AbsMag        -20.24
        Axis    [  0.7299   0.6600   0.1782]
        Angle     95.0219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 759"
}

Galaxy "NGC 761:UGC 1439:MCG 5-5-36:ZWG 503.64"
{
        Type  "SBa"
        RA            1.9636
        Dec          33.3764
        Distance   2.165e+08  # method: V
        Radius     4.409e+04
        AbsMag        -19.61
        Axis    [ -0.2310   0.8126  -0.5351]
        Angle    168.7716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 761"
}

Galaxy "NGC 762:MCG 1-6-6:MK 1012:IRAS 01544-0538"
{
        Type  "SBa"
        RA            1.9492
        Dec          -5.4022
        Distance   2.061e+08  # method: V
        Radius     4.197e+04
        AbsMag         -20.1
        Axis    [  0.6323   0.7383   0.2346]
        Angle    146.7842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 762"
}

Galaxy "NGC 765:UGC 1455:MCG 4-5-25:ZWG 482.33"
{
        Type  "SBc"
        RA            1.9800
        Dec          24.8922
        Distance   2.199e+08  # method: V
        Radius     8.955e+04
        AbsMag        -20.34
        Axis    [  0.7491   0.6147   0.2468]
        Angle    104.2037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 765"
}

Galaxy "NGC 766:UGC 1458:MCG 1-6-19:ZWG 413.19"
{
        Type  "E0"
        RA            1.9783
        Dec           8.3472
        Distance   3.546e+08  # method: V
        Radius     1.032e+05
        AbsMag        -21.28
        Axis    [  0.8069   0.5161   0.2873]
        Angle    116.5576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 766"
}

Galaxy "NGC 767:MCG 2-6-10:KUG 0156-098:IRAS 01563-0949"
{
        Type  "Sb"
        RA            1.9806
        Dec          -9.5872
        Distance   2.323e+08  # method: V
        Radius     3.716e+04
        AbsMag        -18.96
        Axis    [  0.0429   0.6212  -0.7825]
        Angle    160.9486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 767"
}

Galaxy "NGC 768:UGC 1457:MCG 0-6-16:ZWG 387.18"
{
        Type  "Sc"
        RA            1.9778
        Dec           0.5289
        Distance   3.221e+08  # method: T-F
        Radius     7.965e+04
        AbsMag        -20.87
        Axis    [  0.3562   0.8950   0.2686]
        Angle    151.0082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 768"
}

Galaxy "NGC 769:UGC 1467:MCG 5-5-37:ZWG 503.66"
{
        Type  "Sc"
        RA            1.9931
        Dec          30.9097
        Distance   1.912e+08  # method: V
        Radius     2.224e+04
        AbsMag        -20.24
        Axis    [  0.1322   0.9877  -0.0833]
        Angle    143.5387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 769"
}

Galaxy "NGC 770:UGC 1463:MCG 3-6-10:ZWG 461.16"
{
        Type  "E1"
        RA            1.9869
        Dec          18.9550
        Distance   9.839e+07  # method: V
        Radius     1.574e+04
        AbsMag         -18.4
        Axis    [  0.7696   0.6234   0.1381]
        Angle    117.0063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 770"
}

Galaxy "NGC 772:UGC 1466:MCG 3-6-11:ZWG 461.18"
{
        Type  "Sb"
        RA            1.9886
        Dec          19.0075
        Distance    1.25e+08  # method: T-F
        Radius     1.309e+05
        AbsMag        -21.81
        Axis    [  0.0433   0.8579  -0.5120]
        Angle    169.5588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 772"
}

Galaxy "NGC 773:MCG 2-6-11"
{
        Type  "Sa"
        RA            1.9808
        Dec         -11.5153
        Distance   2.422e+08  # method: V
        Radius     4.931e+04
        AbsMag        -20.35
        Axis    [  0.0788   0.5110  -0.8560]
        Angle    174.6770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 773"
}

Galaxy "NGC 774:UGC 1469:MCG 2-6-8:ZWG 438.10"
{
        Type  "S0"
        RA            1.9928
        Dec          14.0083
        Distance   1.958e+08  # method: V
        Radius     4.271e+04
        AbsMag        -19.79
        Axis    [  0.0738   0.6876  -0.7224]
        Angle    195.0523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 774"
}

Galaxy "NGC 775:ESO 477-18:MCG 5-5-24:IRAS 01562-2632"
{
        Type  "SBc"
        RA            1.9756
        Dec         -26.2939
        Distance   1.863e+08  # method: T-F
        Radius     4.607e+04
        AbsMag        -20.38
        Axis    [  0.2730   0.4939  -0.8255]
        Angle    175.7848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 775"
}

Galaxy "NGC 776:UGC 1471:MCG 4-5-28:ZWG 482.37"
{
        Type  "SBb"
        RA            1.9983
        Dec          23.6442
        Distance    2.11e+08  # method: V
        Radius     5.216e+04
        AbsMag        -20.75
        Axis    [  0.7545   0.6065   0.2507]
        Angle    105.0538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 776"
}

Galaxy "NGC 777:UGC 1476:MCG 5-5-38:ZWG 503.67"
{
        Type  "E1"
        RA            2.0039
        Dec          31.4297
        Distance   1.903e+08  # method: T-F
        Radius     6.918e+04
        AbsMag        -21.33
        Axis    [  0.2856   0.7835  -0.5520]
        Angle    217.7471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 777"
}

Galaxy "NGC 778:UGC 1480:MCG 5-5-39:ZWG 503.69"
{
        Type  "S0"
        RA            2.0053
        Dec          31.3131
        Distance    1.47e+08  # distance uncertain!
        Radius     2.352e+04
        AbsMag        -19.07
        Axis    [ -0.1813   0.7895  -0.5863]
        Angle    174.6722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 778"
}

Galaxy "NGC 779:MCG 1-6-16:IRAS 01571-0612"
{
        Type  "SBb"
        RA            1.9950
        Dec          -5.9642
        Distance   6.831e+07  # method: T-F
        Radius     4.074e+04
        AbsMag         -19.6
        Axis    [ -0.0010   0.6670  -0.7451]
        Angle    157.3607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 779"
}

Galaxy "NGC 780:UGC 1488:MCG 5-5-41:ZWG 503.72"
{
        Type  "Sb"
        RA            2.0097
        Dec          28.2258
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [ -0.1134   0.6787  -0.7256]
        Angle    198.2475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 780"
}

Galaxy "NGC 781:UGC 1482:MCG 2-6-10:ZWG 438.11"
{
        Type  "Sb"
        RA            2.0022
        Dec          12.6556
        Distance   1.454e+08  # method: V
        Radius     3.172e+04
        AbsMag        -19.15
        Axis    [  0.1912   0.8676   0.4590]
        Angle    148.0146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 781"
}

Galaxy "NGC 782:ESO 114-15:AM 0155-580:IRAS 01559-5801"
{
        Type  "SBb"
        RA            1.9611
        Dec         -57.7908
        Distance   2.666e+08  # method: V
        Radius     9.306e+04
        AbsMag        -22.06
        Axis    [  0.8280   0.4967   0.2602]
        Angle    186.5922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 782"
}

Galaxy "NGC 783:IC 1765:UGC 1497:MCG 5-5-42"
{
        Type  "Sc"
        RA            2.0183
        Dec          31.8819
        Distance   2.238e+08  # method: V
        Radius     5.208e+04
        AbsMag        -21.28
        Axis    [  0.4294   0.8947   0.1226]
        Angle    123.6690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 783"
}

Galaxy "NGC 784:UGC 1501:MCG 5-5-45:ZWG 503.74"
{
        Type  "SBc"
        RA            2.0214
        Dec          28.8381
        Distance   1.522e+07  # method: T-F
        Radius     1.461e+04
        AbsMag        -16.24
        Axis    [  0.1209   0.7963   0.5927]
        Angle    137.2436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 784"
}

Galaxy "NGC 785:IC 1766:UGC 1509:MCG 5-5-46"
{
        Type  "S0"
        RA            2.0278
        Dec          31.8267
        Distance   2.162e+08  # method: V
        Radius     4.717e+04
        AbsMag        -20.31
        Axis    [  0.1713   0.9689  -0.1786]
        Angle    148.8514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 785"
}

Galaxy "NGC 786:UGC 1506:MCG 2-6-12:ZWG 438.13"
{
        Type  "S0"
        RA            2.0233
        Dec          15.6461
        Distance   1.925e+08  # method: V
        Radius      1.96e+04
        AbsMag        -19.46
        Axis    [  0.2075   0.7921  -0.5741]
        Angle    185.2549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 786"
}

Galaxy "NGC 787:MCG 2-6-15"
{
        Type  "Sb"
        RA            2.0133
        Dec          -9.0025
        Distance   1.168e+08  # distance uncertain!
        Radius     4.247e+04
        AbsMag        -19.07
        Axis    [  0.4841   0.8242  -0.2938]
        Angle    164.2396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 787"
}

Galaxy "NGC 788:MCG 1-6-25"
{
        Type  "Sa"
        RA            2.0183
        Dec          -6.8156
        Distance   1.742e+08  # method: V
        Radius     4.053e+04
        AbsMag        -20.64
        Axis    [  0.4812   0.7479  -0.4573]
        Angle    174.7637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 788"
}

Galaxy "NGC 789:UGC 1520:MCG 5-5-47:ZWG 503.77"
{
        Type  "Irr"
        RA            2.0406
        Dec          32.0722
        Distance    2.27e+08  # method: V
        Radius     3.962e+04
        AbsMag        -20.01
        Axis    [  0.3446   0.8105   0.4736]
        Angle    117.1997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 789"
}

Galaxy "NGC 790:MCG 1-6-26"
{
        Type  "S0"
        RA            2.0225
        Dec          -5.3706
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.8168   0.4684   0.3370]
        Angle    128.5913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 790"
}

Galaxy "NGC 791:UGC 1511:MCG 1-6-31:ZWG 413.28"
{
        Type  "E0"
        RA            2.0289
        Dec           8.4997
        Distance   2.512e+08  # distance uncertain!
        Radius     5.846e+04
        AbsMag        -20.13
        Axis    [  0.8109   0.5117   0.2840]
        Angle    116.1629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 791"
}

Galaxy "NGC 792:UGC 1517:MCG 2-6-15:ZWG 438.14"
{
        Type  "S0"
        RA            2.0375
        Dec          15.7122
        Distance   1.968e+08  # method: V
        Radius     4.867e+04
        AbsMag         -19.7
        Axis    [  0.0968   0.8460  -0.5244]
        Angle    170.5591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 792"
}

Galaxy "NGC 794:IC 191:UGC 1528:MCG 3-6-24"
{
        Type  "S0"
        RA            2.0414
        Dec          18.3728
        Distance   3.605e+08  # method: V
        Radius     6.815e+04
        AbsMag        -21.42
        Axis    [  0.4718   0.8795   0.0627]
        Angle    136.7071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 794"
}

Galaxy "NGC 795:ESO 153-8:AM 0158-560"
{
        Type  "S0"
        RA            1.9969
        Dec         -55.8244
        Distance    1.47e+08  # distance uncertain!
        Radius     2.566e+04
        AbsMag        -19.07
        Axis    [  0.5394   0.4875  -0.6866]
        Angle    162.3100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 795"
}

Galaxy "NGC 797:UGC 1541:MCG 6-5-78:ZWG 522.105"
{
        Type  "SBa"
        RA            2.0575
        Dec          38.1175
        Distance   2.455e+08  # method: V
        Radius     5.714e+04
        AbsMag        -20.78
        Axis    [  0.2383   0.9688  -0.0678]
        Angle    136.9885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 797"
}

Galaxy "NGC 798:UGC 1539:MCG 5-5-48:ZWG 503.78"
{
        Type  "E0"
        RA            2.0553
        Dec          32.0775
        Distance   2.884e+08  # distance uncertain!
        Radius     5.034e+04
        AbsMag        -20.13
        Axis    [  0.3508   0.8021  -0.4833]
        Angle    202.7260
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 798"
}

Galaxy "NGC 799:UGC 1527:MCG 0-6-23:ZWG 387.29"
{
        Type  "SBa"
        RA            2.0367
        Dec          -0.1003
        Distance    2.52e+08  # method: V
        Radius     7.329e+04
        AbsMag        -20.14
        Axis    [  0.4535   0.8114  -0.3687]
        Angle    167.8974
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 799"
}

Galaxy "NGC 800:UGC 1526:MCG 0-6-24:ZWG 387.28"
{
        Type  "Sc"
        RA            2.0364
        Dec          -0.1308
        Distance   2.573e+08  # method: V
        Radius     3.742e+04
        AbsMag        -20.68
        Axis    [  0.6543   0.6772   0.3365]
        Angle    136.4984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 800"
}

Galaxy "NGC 801:UGC 1550:MCG 6-5-79:ZWG 522.106"
{
        Type  "Sc"
        RA            2.0622
        Dec          38.2594
        Distance   1.902e+08  # method: T-F
        Radius     8.577e+04
        AbsMag        -19.93
        Axis    [ -0.3614   0.7539  -0.5487]
        Angle    165.6048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 801"
}

Galaxy "NGC 802:ESO 52-13:AM 0157-680"
{
        Type  "SBa"
        RA            1.9850
        Dec         -67.8703
        Distance   6.505e+07  # method: V
        Radius          8515
        AbsMag         -17.8
        Axis    [  0.5802   0.3285  -0.7453]
        Angle    162.6679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 802"
}

Galaxy "NGC 803:UGC 1554:MCG 3-6-28:ZWG 461.38"
{
        Type  "Sc"
        RA            2.0622
        Dec          16.0311
        Distance   7.031e+07  # method: T-F
        Radius     3.068e+04
        AbsMag        -18.47
        Axis    [  0.2870   0.8319   0.4750]
        Angle    139.0367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 803"
}

Galaxy "NGC 804:IC 1773:UGC 1557:MCG 5-5-49"
{
        Type  "S0"
        RA            2.0672
        Dec          30.8325
        Distance   1.851e+08  # distance uncertain!
        Radius     3.769e+04
        AbsMag        -19.07
        Axis    [  0.0678   0.8277   0.5570]
        Angle    137.0263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 804"
}

Galaxy "NGC 805:UGC 1566:MCG 5-5-50:ZWG 503.82"
{
        Type  "S0"
        RA            2.0747
        Dec          28.8128
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.0331   0.9209  -0.3885]
        Angle    163.0201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 805"
}

Galaxy "NGC 806-1:MCG 2-6-21:KUG 0201-101:IRAS 02010-1010"
{
        Type  "Sc"
        RA            2.0586
        Dec          -9.9328
        Distance   1.668e+08  # method: V
        Radius      2.91e+04
        AbsMag        -18.74
        Axis    [  0.3058   0.9520   0.0097]
        Angle    156.7274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 806-1"
}

Galaxy "NGC 806-2:MCG 2-6-21"
{
        Type  "S0"
        RA            2.0589
        Dec          -9.9294
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.4044   0.9145  -0.0120]
        Angle    156.7360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 806-2"
}

Galaxy "NGC 807:UGC 1571:MCG 5-6-1:ZWG 503.84"
{
        Type  "E0"
        RA            2.0819
        Dec          28.9878
        Distance   2.029e+08  # method: V
        Radius     5.312e+04
        AbsMag        -20.47
        Axis    [  0.3374   0.7796  -0.5276]
        Angle    208.8387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 807"
}

Galaxy "NGC 808:ESO 478-1:MCG 4-6-3:AM 0201-233"
{
        Type  "SBc"
        RA            2.0656
        Dec         -23.3122
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [  0.5028   0.7590   0.4136]
        Angle    169.4909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 808"
}

Galaxy "NGC 809:MCG 2-6-23"
{
        Type  "S0"
        RA            2.0717
        Dec          -8.7350
        Distance   2.337e+08  # method: V
        Radius     4.079e+04
        AbsMag        -19.48
        Axis    [  0.1195   0.5110  -0.8512]
        Angle    187.1469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 809"
}

Galaxy "NGC 810-1:UGC 1583:MCG 2-6-26:ZWG 438.24"
{
        Type  "E0"
        RA            2.0911
        Dec          13.2511
        Distance   3.312e+08  # distance uncertain!
        Radius     8.188e+04
        AbsMag        -20.13
        Axis    [  0.7851   0.6145   0.0781]
        Angle    126.3338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 810-1"
}

Galaxy "NGC 810-2:UGC 1583:MCG 2-6-26:ZWG 438.24"
{
        Type  "E0"
        RA            2.0914
        Dec          13.2511
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6148   0.7091  -0.3453]
        Angle    173.6601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 810-2"
}

Galaxy "NGC 811:MCG 2-6-24:KUG 0202-103"
{
        Type  "Sc"
        RA            2.0761
        Dec         -10.1083
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.5165   0.8360   0.1854]
        Angle    154.8028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 811"
}

Galaxy "NGC 812:UGC 1598:MCG 7-5-14:ZWG 538.19"
{
        Type  "Sc"
        RA            2.1142
        Dec          44.5725
        Distance   2.245e+08  # method: V
        Radius     7.184e+04
        AbsMag        -21.79
        Axis    [ -0.3415   0.7368  -0.5836]
        Angle    178.6594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 812"
}

Galaxy "NGC 813:ESO 52-16"
{
        Type  "SBa"
        RA            2.0267
        Dec         -68.4392
        Distance   3.667e+08  # method: V
        Radius     6.934e+04
        AbsMag        -21.45
        Axis    [  0.7777   0.4908  -0.3927]
        Angle    178.2982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 813"
}

Galaxy "NGC 814:MCG 3-6-10:IRAS 02082-1600"
{
        Type  "S0"
        RA            2.1769
        Dec         -15.7733
        Distance   6.098e+07  # method: V
        Radius     1.242e+04
        AbsMag        -16.56
        Axis    [  0.4456   0.7748   0.4485]
        Angle    164.8786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 814"
}

Galaxy "NGC 815"
{
        Type  "E0"
        RA            2.1775
        Dec         -15.8128
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.6063   0.4945  -0.6228]
        Angle    201.8673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 815"
}

Galaxy "NGC 816:ZWG 504.16:NPM 1:KUG 0205+290"
{
        Type  "E0"
        RA            2.1356
        Dec          29.2564
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.7709   0.6036   0.2037]
        Angle     99.0466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 816"
}

Galaxy "NGC 817:UGC 1611:MCG 3-6-33:ZWG 461.47"
{
        Type  "S0"
        RA            2.1258
        Dec          17.2019
        Distance   1.928e+08  # method: V
        Radius     1.963e+04
        AbsMag        -19.76
        Axis    [  0.2471   0.9128   0.3252]
        Angle    138.5552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 817"
}

Galaxy "NGC 818:UGC 1633:MCG 6-5-86:ZWG 522.116"
{
        Type  "SBc"
        RA            2.1456
        Dec          38.7772
        Distance       2e+08  # method: T-F
        Radius     8.436e+04
        AbsMag        -20.74
        Axis    [ -0.1767   0.9311  -0.3193]
        Angle    155.1834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 818"
}

Galaxy "NGC 819:UGC 1632:ZWG 504.17:KUG 0205+289"
{
        Type  "S0"
        RA            2.1428
        Dec          29.2347
        Distance   2.867e+08  # method: V
        Radius     2.502e+04
        AbsMag        -20.42
        Axis    [  0.3568   0.8362   0.4165]
        Angle    120.1735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 819"
}

Galaxy "NGC 820:UGC 1629:MCG 2-6-36:ZWG 438.31"
{
        Type  "Sb"
        RA            2.1400
        Dec          14.3497
        Distance   1.884e+08  # method: V
        Radius     3.835e+04
        AbsMag        -20.11
        Axis    [  0.2433   0.9656  -0.0919]
        Angle    146.7657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 820"
}

Galaxy "NGC 821:UGC 1631:MCG 2-6-34:ZWG 438.33"
{
        Type  "E6"
        RA            2.1392
        Dec          10.9942
        Distance    7.86e+07  # method: S
        Radius     2.744e+04
        AbsMag        -20.11
        Axis    [  0.7970   0.5985   0.0810]
        Angle    127.4978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 821"
}

Galaxy "NGC 822:ESO 298-9:MCG 7-5-8"
{
        Type  "E0"
        RA            2.1108
        Dec         -41.1569
        Distance   1.864e+08  # method: T-F
        Radius     2.982e+04
        AbsMag        -19.68
        Axis    [  0.9120   0.3446  -0.2223]
        Angle    183.2873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 822"
}

Galaxy "NGC 823:IC 1782:ESO 478-2:MCG 4-6-5"
{
        Type  "S0"
        RA            2.1222
        Dec         -25.4417
        Distance   1.906e+08  # method: V
        Radius     4.713e+04
        AbsMag        -20.03
        Axis    [  0.5621   0.7165  -0.4132]
        Angle    169.4431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 823"
}

Galaxy "NGC 824:ESO 354-37:MCG 6-5-28"
{
        Type  "SBc"
        RA            2.1147
        Dec         -36.4533
        Distance   2.557e+08  # method: V
        Radius     5.207e+04
        AbsMag        -20.37
        Axis    [  0.7662   0.6039   0.2199]
        Angle    169.4752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 824"
}

Galaxy "NGC 825:UGC 1636:MCG 1-6-45:ZWG 413.46"
{
        Type  "Sa"
        RA            2.1422
        Dec           6.3233
        Distance   1.415e+08  # method: V
        Radius     4.115e+04
        AbsMag        -18.99
        Axis    [  0.1469   0.9819   0.1193]
        Angle    148.4785
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 825"
}

Galaxy "NGC 826-1:ZWG 504.19"
{
        Type  "S0"
        RA            2.1569
        Dec          30.7394
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.3753   0.9247  -0.0636]
        Angle    136.3559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 826-1"
}

Galaxy "NGC 826-2:ZWG 504.19"
{
        Type  "S0"
        RA            2.1567
        Dec          30.7436
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.2223   0.8249  -0.5196]
        Angle    163.1419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 826-2"
}

Galaxy "NGC 827:UGC 1640:MCG 1-6-46:ZWG 413.47"
{
        Type  "Sc"
        RA            2.1489
        Dec           7.9717
        Distance   1.446e+08  # method: V
        Radius     4.206e+04
        AbsMag        -19.43
        Axis    [  0.0910   0.9820  -0.1655]
        Angle    148.4610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 827"
}

Galaxy "NGC 828:UGC 1655:MCG 6-5-92:ZWG 522.125"
{
        Type  "Sa"
        RA            2.1692
        Dec          39.1911
        Distance   2.329e+08  # method: V
        Radius     8.468e+04
        AbsMag        -21.17
        Axis    [ -0.1219   0.8547  -0.5046]
        Angle    176.8165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 828"
}

Galaxy "NGC 829:MCG 1-6-49:KUG 0206-080A:IRAS 02062-0801"
{
        Type  "Sc"
        RA            2.1450
        Dec          -7.7903
        Distance   1.722e+08  # method: V
        Radius     2.755e+04
        AbsMag        -19.21
        Axis    [  0.4208   0.9070  -0.0185]
        Angle    154.6023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 829"
}

Galaxy "NGC 830:MCG 1-6-50:MK 1020"
{
        Type  "S0"
        RA            2.1494
        Dec          -7.7675
        Distance   1.646e+08  # method: V
        Radius     3.351e+04
        AbsMag        -19.21
        Axis    [  0.4531   0.8810  -0.1362]
        Angle    156.3212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 830"
}

Galaxy "NGC 831:ZWG 413.49:KUG 0206+058"
{
        Type  "S0"
        RA            2.1594
        Dec           6.0967
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.3306   0.8689  -0.3685]
        Angle    162.0593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 831"
}

Galaxy "NGC 833:MCG 2-6-30:ARP 318:MCG 2-6-30"
{
        Type  "Sa"
        RA            2.1556
        Dec         -10.1328
        Distance   1.668e+08  # method: V
        Radius     3.639e+04
        AbsMag        -19.84
        Axis    [  0.3383   0.9131  -0.2275]
        Angle    155.9158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 833"
}

Galaxy "NGC 834:UGC 1672:MCG 6-5-99:ZWG 522.128"
{
        Type  "Sc"
        RA            2.1836
        Dec          37.6661
        Distance   1.842e+08  # method: T-F
        Radius     2.948e+04
        AbsMag        -19.96
        Axis    [  0.1508   0.8999   0.4092]
        Angle    122.0835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 834"
}

Galaxy "NGC 835:MCG 2-6-31:MK 1021:ARP 318"
{
        Type  "SBb"
        RA            2.1567
        Dec         -10.1353
        Distance   1.752e+08  # method: V
        Radius     3.312e+04
        AbsMag        -20.65
        Axis    [  0.6598   0.6843   0.3105]
        Angle    147.0962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 835"
}

Galaxy "NGC 836:ESO 544-17:MCG 4-6-12:NPM 1"
{
        Type  "Sa"
        RA            2.1733
        Dec         -22.0550
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.5041   0.7224  -0.4734]
        Angle    168.6714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 836"
}

Galaxy "NGC 837:ESO 478-10:MCG 4-6-11:AM 0207-224"
{
        Type  "Sb"
        RA            2.1711
        Dec         -22.4314
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.4843   0.7913   0.3732]
        Angle    168.6839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 837"
}

Galaxy "NGC 838:MCG 2-6-33:MK 1022:ARP 318"
{
        Type  "S0"
        RA            2.1606
        Dec         -10.1458
        Distance   1.626e+08  # method: V
        Radius     2.838e+04
        AbsMag        -19.49
        Axis    [  0.5024   0.8240  -0.2621]
        Angle    161.2678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 838"
}

Galaxy "NGC 839:MCG 2-6-34:ARP 318:HCG 16"
{
        Type  "S0"
        RA            2.1617
        Dec         -10.1833
        Distance   1.623e+08  # method: V
        Radius     3.305e+04
        AbsMag        -19.38
        Axis    [  0.3600   0.9058  -0.2235]
        Angle    156.3421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 839"
}

Galaxy "NGC 840:UGC 1664:MCG 1-6-49:ZWG 413.53"
{
        Type  "SBb"
        RA            2.1711
        Dec           7.8458
        Distance   3.803e+08  # method: T-F
        Radius     9.957e+04
        AbsMag        -21.03
        Axis    [  0.2834   0.9528  -0.1088]
        Angle    148.9700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 840"
}

Galaxy "NGC 841:UGC 1676:MCG 6-5-101:ZWG 522.131"
{
        Type  "SBb"
        RA            2.1881
        Dec          37.4975
        Distance   1.946e+08  # method: T-F
        Radius     5.095e+04
        AbsMag        -20.48
        Axis    [ -0.1419   0.8684  -0.4751]
        Angle    169.7010
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 841"
}

Galaxy "NGC 842:MCG 1-6-55"
{
        Type  "S0"
        RA            2.1639
        Dec          -7.7625
        Distance   1.562e+08  # method: V
        Radius     3.636e+04
        AbsMag         -19.7
        Axis    [  0.1274   0.6982  -0.7045]
        Angle    164.1296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 842"
}

Galaxy "NGC 844:ZWG 413.52"
{
        Type  "E0"
        RA            2.1706
        Dec           6.0500
        Distance   3.468e+08  # distance uncertain!
        Radius     2.017e+04
        AbsMag        -20.13
        Axis    [  0.8269   0.4857   0.2833]
        Angle    117.4368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 844"
}

Galaxy "NGC 845:UGC 1695:MCG 6-5-104:ZWG 522.135"
{
        Type  "Sb"
        RA            2.2053
        Dec          37.4775
        Distance   1.612e+08  # distance uncertain!
        Radius     3.986e+04
        AbsMag        -19.07
        Axis    [ -0.3512   0.7644  -0.5406]
        Angle    163.5751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 845"
}

Galaxy "NGC 846:NGC 847:UGC 1688:MCG 7-5-24"
{
        Type  "SBb"
        RA            2.2033
        Dec          44.5681
        Distance   2.219e+08  # method: V
        Radius     6.132e+04
        AbsMag        -21.06
        Axis    [  0.0282   0.8811  -0.4721]
        Angle    188.2552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 846"
}

Galaxy "NGC 848:MCG 2-6-36:MK 1026:ARP 318"
{
        Type  "SBb"
        RA            2.1714
        Dec         -10.3206
        Distance   1.649e+08  # method: V
        Radius     3.597e+04
        AbsMag        -19.72
        Axis    [  0.2815   0.7281  -0.6251]
        Angle    169.0137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 848"
}

Galaxy "NGC 849:ESO 478-9:NPM 1"
{
        Type  "S0"
        RA            2.1697
        Dec         -22.3231
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.4048   0.7549  -0.5160]
        Angle    163.3981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 849"
}

Galaxy "NGC 850:UGC 1679:MCG 0-6-49:ZWG 387.53"
{
        Type  "Sa"
        RA            2.1869
        Dec          -1.4850
        Distance    3.58e+08  # method: V
        Radius     6.248e+04
        AbsMag         -21.3
        Axis    [  0.5697   0.7732  -0.2785]
        Angle    162.8908
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 850"
}

Galaxy "NGC 851:UGC 1680:MCG 1-6-54:MK 588"
{
        Type  "Sa"
        RA            2.1867
        Dec           3.7797
        Distance   1.291e+08  # method: V
        Radius     1.877e+04
        AbsMag        -18.39
        Axis    [  0.1421   0.7950  -0.5897]
        Angle    167.0315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 851"
}

Galaxy "NGC 852:ESO 153-26"
{
        Type  "SBc"
        RA            2.1486
        Dec         -56.7367
        Distance   2.773e+08  # method: T-F
        Radius     5.243e+04
        AbsMag        -20.45
        Axis    [  0.8357   0.5112  -0.2006]
        Angle    181.9613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 852"
}

Galaxy "NGC 853:MCG 2-6-38:KUG 0209-095:IRAS 02092-0932"
{
        Type  "Irr"
        RA            2.1947
        Dec          -9.3053
        Distance   5.567e+07  # method: V
        Radius     1.296e+04
        AbsMag        -17.66
        Axis    [  0.6260   0.7649  -0.1520]
        Angle    158.9420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 853"
}

Galaxy "NGC 854:ESO 354-47:MCG 6-5-38:AM 0209-360"
{
        Type  "SBc"
        RA            2.1917
        Dec         -35.8356
        Distance   2.338e+08  # method: T-F
        Radius     6.121e+04
        AbsMag        -20.48
        Axis    [  0.4755   0.7635   0.4369]
        Angle    185.8053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 854"
}

Galaxy "NGC 855:UGC 1718:MCG 5-6-16:ZWG 504.35"
{
        Type  "E0"
        RA            2.2342
        Dec          27.8778
        Distance   3.173e+07  # method: S
        Radius       1.2e+04
        AbsMag        -16.64
        Axis    [  0.6245   0.7579  -0.1888]
        Angle    142.9170
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 855"
}

Galaxy "NGC 856:NGC 859:UGC 1713:MCG 0-6-54"
{
        Type  "Sa"
        RA            2.2272
        Dec          -0.7167
        Distance   2.599e+08  # method: V
        Radius     4.915e+04
        AbsMag        -20.31
        Axis    [  0.5244   0.7952   0.3043]
        Angle    144.0162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 856"
}

Galaxy "NGC 857:ESO 415-6:MCG 5-6-8"
{
        Type  "S0"
        RA            2.2103
        Dec         -31.9444
        Distance   1.492e+08  # method: V
        Radius     3.255e+04
        AbsMag         -19.9
        Axis    [  0.6912   0.6316  -0.3511]
        Angle    172.8622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 857"
}

Galaxy "NGC 858-1:ESO 478-13:MCG 4-6-16:AM 0210-224"
{
        Type  "SBc"
        RA            2.2083
        Dec         -22.4714
        Distance   5.495e+08  # method: V
        Radius     1.039e+05
        AbsMag        -21.93
        Axis    [  0.6859   0.5877   0.4291]
        Angle    155.6505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 858-1"
}

Galaxy "NGC 858-2:ESO 478-13:MCG 4-6-16:AM 0210-224"
{
        Type  "S0"
        RA            2.2092
        Dec         -22.4694
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.1320   0.6127  -0.7792]
        Angle    151.2602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 858-2"
}

Galaxy "NGC 860:ZWG 504.37:NPM 1"
{
        Type  "E0"
        RA            2.2500
        Dec          30.7794
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.3497   0.7922  -0.5001]
        Angle    200.9115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 860"
}

Galaxy "NGC 861:UGC 1737:MCG 6-6-3:ZWG 523.5"
{
        Type  "Sb"
        RA            2.2642
        Dec          35.9139
        Distance    3.52e+08  # method: T-F
        Radius     7.679e+04
        AbsMag        -20.46
        Axis    [  0.0365   0.9551   0.2941]
        Angle    128.7604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 861"
}

Galaxy "NGC 862:ESO 298-20:MCG 7-5-12:AM 0211-421"
{
        Type  "E0"
        RA            2.2172
        Dec         -42.0336
        Distance   2.329e+08  # method: V
        Radius      2.71e+04
        AbsMag        -21.37
        Axis    [  0.8752   0.2823   0.3928]
        Angle    158.4566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 862"
}

Galaxy "NGC 863:NGC 866:NGC 885:UGC 1727"
{
        Type  "Sa"
        RA            2.2425
        Dec          -0.7661
        Distance    3.47e+08  # method: V
        Radius     5.552e+04
        AbsMag        -21.23
        Axis    [  0.6050   0.7802  -0.1593]
        Angle    155.0221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 863"
}

Galaxy "NGC 864:UGC 1736:MCG 1-6-61:ZWG 413.66"
{
        Type  "SBc"
        RA            2.2575
        Dec           6.0019
        Distance   5.898e+07  # method: V
        Radius     4.032e+04
        AbsMag        -19.58
        Axis    [  0.5279   0.7965   0.2949]
        Angle    137.1218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 864"
}

Galaxy "NGC 865:UGC 1747:MCG 5-6-20:ZWG 504.42"
{
        Type  "S0"
        RA            2.2708
        Dec          28.6008
        Distance   1.436e+08  # method: T-F
        Radius     3.134e+04
        AbsMag        -19.12
        Axis    [ -0.2948   0.6844  -0.6669]
        Angle    167.3145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 865"
}

Galaxy "NGC 867:NGC 875:UGC 1760:MCG 0-6-60"
{
        Type  "Sa"
        RA            2.2844
        Dec           1.2447
        Distance   2.797e+08  # method: V
        Radius     4.882e+04
        AbsMag        -20.67
        Axis    [  0.4831   0.7676  -0.4211]
        Angle    169.8309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 867"
}

Galaxy "NGC 868:UGC 1748:ZWG 387.63"
{
        Type  "S0"
        RA            2.2661
        Dec          -0.7128
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [  0.4189   0.8437  -0.3356]
        Angle    160.2640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 868"
}

Galaxy "NGC 870:MCG 2-6-52"
{
        Type  "E0"
        RA            2.2858
        Dec          14.5228
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.8210   0.5131   0.2505]
        Angle    109.8454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 870"
}

Galaxy "NGC 871:UGC 1759:MCG 2-6-53:ZWG 438.46"
{
        Type  "SBc"
        RA            2.2861
        Dec          14.5475
        Distance   1.577e+08  # method: V
        Radius     2.524e+04
        AbsMag        -19.32
        Axis    [  0.3369   0.7989   0.4982]
        Angle    137.6517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 871"
}

Galaxy "NGC 872:ESO 544-32:MCG 3-6-19"
{
        Type  "Sc"
        RA            2.2569
        Dec         -17.7819
        Distance   1.704e+08  # method: T-F
        Radius     3.718e+04
        AbsMag        -19.09
        Axis    [  0.0422   0.5365  -0.8429]
        Angle    153.0406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 872"
}

Galaxy "NGC 873:MCG 2-6-48:IRAS 02140-1134"
{
        Type  "Sc"
        RA            2.2756
        Dec         -11.3486
        Distance   1.709e+08  # method: V
        Radius     3.976e+04
        AbsMag         -20.3
        Axis    [  0.3169   0.6451  -0.6952]
        Angle    178.7006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 873"
}

Galaxy "NGC 874:ESO 478-18:MCG 4-6-19"
{
        Type  "Sb"
        RA            2.2672
        Dec         -23.3058
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.1543   0.4955  -0.8548]
        Angle    164.2125
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 874"
}

Galaxy "NGC 876:UGC 1766:MCG 2-6-57"
{
        Type  "Sc"
        RA            2.2981
        Dec          14.5211
        Distance   1.634e+08  # method: V
        Radius     4.752e+04
        AbsMag           -19
        Axis    [  0.1371   0.8937   0.4271]
        Angle    146.3584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 876"
}

Galaxy "NGC 877:UGC 1768:MCG 2-6-58:ZWG 438.52"
{
        Type  "SBc"
        RA            2.2997
        Dec          14.5439
        Distance   1.658e+08  # method: V
        Radius     5.786e+04
        AbsMag        -20.93
        Axis    [  0.1517   0.7891  -0.5952]
        Angle    178.1906
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 877"
}

Galaxy "NGC 878:ESO 478-22:MCG 4-6-21:IRAS 02156-2336"
{
        Type  "Sa"
        RA            2.2983
        Dec         -23.3844
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.4404   0.7533  -0.4885]
        Angle    162.4464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 878"
}

Galaxy "NGC 879:KUG 0214-091"
{
        Type  "Irr"
        RA            2.2808
        Dec          -8.9636
        Distance   3.981e+08  # distance uncertain!
        Radius     4.054e+04
        AbsMag        -20.13
        Axis    [  0.6688   0.6375   0.3825]
        Angle    143.2449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 879"
}

Galaxy "NGC 880"
{
        Type  "S0"
        RA            2.3075
        Dec          -4.2053
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.5856   0.7378   0.3356]
        Angle    143.9401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 880"
}

Galaxy "NGC 881:MCG 1-6-89:IRAS 02160-0650"
{
        Type  "Sc"
        RA            2.3125
        Dec          -6.6394
        Distance   9.278e+07  # distance uncertain!
        Radius     3.104e+04
        AbsMag        -19.07
        Axis    [  0.2429   0.7450  -0.6213]
        Angle    166.6566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 881"
}

Galaxy "NGC 882:UGC 1789:MCG 3-6-52:ZWG 462.1"
{
        Type  "S0"
        RA            2.3275
        Dec          15.8147
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.1656   0.9731  -0.1605]
        Angle    145.6274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 882"
}

Galaxy "NGC 883:MCG 1-6-90"
{
        Type  "S0"
        RA            2.3181
        Dec          -6.7906
        Distance   1.115e+08  # distance uncertain!
        Radius     1.947e+04
        AbsMag        -19.07
        Axis    [  0.6203   0.7420  -0.2541]
        Angle    161.3031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 883"
}

Galaxy "NGC 887:MCG 3-7-1:IRAS 02171-1617"
{
        Type  "SBc"
        RA            2.3256
        Dec         -16.0692
        Distance   1.848e+08  # method: V
        Radius     5.375e+04
        AbsMag        -20.37
        Axis    [  0.6570   0.6443   0.3915]
        Angle    151.5411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 887"
}

Galaxy "NGC 888:ESO 115-2:AM 0215-600"
{
        Type  "E1"
        RA            2.2908
        Dec         -59.8606
        Distance   2.754e+08  # distance uncertain!
        Radius     3.205e+04
        AbsMag        -20.13
        Axis    [  0.8841   0.2106   0.4171]
        Angle    174.0749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 888"
}

Galaxy "NGC 889:ESO 298-27:MCG 7-5-16"
{
        Type  "E0"
        RA            2.3183
        Dec         -41.7492
        Distance   2.308e+08  # method: V
        Radius     3.357e+04
        AbsMag        -19.85
        Axis    [  0.8365   0.3194  -0.4454]
        Angle    190.7770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 889"
}

Galaxy "NGC 890:UGC 1823:MCG 5-6-30:ZWG 504.64"
{
        Type  "S0"
        RA            2.3669
        Dec          33.2664
        Distance   1.711e+08  # method: V
        Radius     6.223e+04
        AbsMag         -21.3
        Axis    [  0.2319   0.9713   0.0528]
        Angle    129.2353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 890"
}

Galaxy "NGC 891:UGC 1831:MCG 7-5-46:ZWG 538.52"
{
        Type  "Sb"
        RA            2.3758
        Dec          42.3472
        Distance   2.725e+07  # method: S
        Radius     4.638e+04
        AbsMag        -18.71
        Axis    [ -0.0400   0.8707   0.4902]
        Angle    127.1011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 891"
}

Galaxy "NGC 892:ESO 478-26"
{
        Type  "Sb"
        RA            2.3478
        Dec         -23.1136
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6094   0.6879   0.3942]
        Angle    162.1965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 892"
}

Galaxy "NGC 893:ESO 298-29:MCG 7-5-17:AM 0217-413"
{
        Type  "Sc"
        RA            2.3328
        Dec         -41.4028
        Distance   2.497e+08  # method: T-F
        Radius     4.721e+04
        AbsMag        -20.82
        Axis    [  0.6307   0.5248  -0.5716]
        Angle    175.1425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 893"
}

Galaxy "NGC 895:MCG 1-7-2:IRAS 02191-0544"
{
        Type  "Sc"
        RA            2.3600
        Dec          -5.5211
        Distance   9.386e+07  # method: T-F
        Radius     4.915e+04
        AbsMag        -19.89
        Axis    [  0.3077   0.7649  -0.5659]
        Angle    167.0914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 895"
}

Galaxy "NGC 897:ESO 355-7:MCG 6-6-3:AM 0218-335"
{
        Type  "Sa"
        RA            2.3517
        Dec         -33.7208
        Distance   2.091e+08  # method: V
        Radius     6.385e+04
        AbsMag        -21.13
        Axis    [  0.6359   0.7136   0.2941]
        Angle    171.3549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 897"
}

Galaxy "NGC 898:UGC 1842:MCG 7-6-4:ZWG 538.58"
{
        Type  "Sb"
        RA            2.3889
        Dec          41.9517
        Distance   2.352e+08  # method: V
        Radius     6.158e+04
        AbsMag        -20.39
        Axis    [ -0.4223   0.6488  -0.6330]
        Angle    171.1816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 898"
}

Galaxy "NGC 899:ESO 545-7:MCG 4-6-30:UGCA 26"
{
        Type  "Irr"
        RA            2.3647
        Dec         -20.8231
        Distance   6.138e+07  # method: V
        Radius     1.607e+04
        AbsMag        -18.27
        Axis    [  0.4552   0.7189  -0.5253]
        Angle    165.6983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 899"
}

Galaxy "NGC 900:UGC 1843:MCG 4-6-20:ZWG 483.23"
{
        Type  "S0"
        RA            2.3922
        Dec          26.5119
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.3301   0.9078   0.2587]
        Angle    125.2840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 900"
}

Galaxy "NGC 901"
{
        Type  "E0"
        RA            2.3928
        Dec          26.5567
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.8028   0.5603   0.2040]
        Angle     99.4241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 901"
}

Galaxy "NGC 902:MCG 3-7-5"
{
        Type  "SBc"
        RA            2.3725
        Dec         -16.6789
        Distance   1.938e+08  # distance uncertain!
        Radius     1.692e+04
        AbsMag        -19.07
        Axis    [  0.6923   0.6565   0.2996]
        Angle    151.3644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 902"
}

Galaxy "NGC 903:NPM 1"
{
        Type  "S0"
        RA            2.4000
        Dec          27.3569
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [ -0.1669   0.6735  -0.7201]
        Angle    186.7865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 903"
}

Galaxy "NGC 904:UGC 1852:MCG 4-6-24:ZWG 483.28"
{
        Type  "E0"
        RA            2.4014
        Dec          27.3431
        Distance   3.631e+08  # distance uncertain!
        Radius     6.337e+04
        AbsMag        -20.13
        Axis    [  0.3976   0.7758  -0.4900]
        Angle    192.8900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 904"
}

Galaxy "NGC 905:NPM 1"
{
        Type  "Sa"
        RA            2.3786
        Dec          -8.7186
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.3084   0.8168  -0.4876]
        Angle    159.2295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 905"
}

Galaxy "NGC 906:UGC 1868:MCG 7-6-12:ZWG 539.14"
{
        Type  "SBb"
        RA            2.4211
        Dec          42.0903
        Distance   2.024e+08  # method: V
        Radius     5.298e+04
        AbsMag        -20.16
        Axis    [  0.0264   0.8671  -0.4974]
        Angle    186.6962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 906"
}

Galaxy "NGC 907:ESO 545-10:MCG 4-6-34:UGCA 28"
{
        Type  "SBc"
        RA            2.3836
        Dec         -20.7114
        Distance   7.298e+07  # method: T-F
        Radius     1.911e+04
        AbsMag        -18.55
        Axis    [  0.3448   0.9036  -0.2542]
        Angle    153.5580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 907"
}

Galaxy "NGC 908:ESO 545-11:MCG 4-6-35:UGCA 29"
{
        Type  "SBc"
        RA            2.3844
        Dec         -21.2333
        Distance   6.587e+07  # method: T-F
        Radius     5.844e+04
        AbsMag        -20.62
        Axis    [  0.4369   0.8838  -0.1676]
        Angle    156.8107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 908"
}

Galaxy "NGC 909:UGC 1872:MCG 7-6-13:ZWG 539.16"
{
        Type  "E0"
        RA            2.4228
        Dec          42.0361
        Distance   2.126e+08  # method: V
        Radius     2.783e+04
        AbsMag        -19.37
        Axis    [  0.7557   0.6400   0.1391]
        Angle     87.1200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 909"
}

Galaxy "NGC 910:UGC 1875:MCG 7-6-14:ZWG 539.17"
{
        Type  "E0"
        RA            2.4239
        Dec          41.8242
        Distance   2.228e+08  # method: V
        Radius     5.186e+04
        AbsMag        -20.97
        Axis    [  0.7566   0.6387   0.1401]
        Angle     87.2714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 910"
}

Galaxy "NGC 911:UGC 1878:MCG 7-6-16:ZWG 539.21"
{
        Type  "E0"
        RA            2.4283
        Dec          41.9567
        Distance   2.445e+08  # method: V
        Radius     4.624e+04
        AbsMag        -20.57
        Axis    [  0.3612   0.8478  -0.3882]
        Angle    177.9452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 911"
}

Galaxy "NGC 912:MCG 7-6-15:ZWG 539.20:NPM 1"
{
        Type  "S0"
        RA            2.4283
        Dec          41.7781
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.0065   0.8410  -0.5409]
        Angle    193.8378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 912"
}

Galaxy "NGC 913"
{
        Type  "S0"
        RA            2.4289
        Dec          41.7992
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.0999   0.9073   0.4085]
        Angle    119.1800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 913"
}

Galaxy "NGC 914:UGC 1887:MCG 7-6-17:ZWG 539.23"
{
        Type  "Sc"
        RA            2.4347
        Dec          42.1447
        Distance   2.417e+08  # method: V
        Radius     5.274e+04
        AbsMag        -20.65
        Axis    [ -0.0143   0.9311  -0.3645]
        Angle    161.4913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 914"
}

Galaxy "NGC 915:MCG 4-6-33:ZWG 483.41:NPM 1"
{
        Type  "S0"
        RA            2.4292
        Dec          27.2217
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.7858   0.5776   0.2214]
        Angle     99.2853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 915"
}

Galaxy "NGC 916:MCG 4-6-34:ZWG 483.43:NPM 1"
{
        Type  "S0"
        RA            2.4297
        Dec          27.2431
        Distance   3.527e+08  # distance uncertain!
        Radius     4.617e+04
        AbsMag        -19.07
        Axis    [  0.2330   0.7827   0.5772]
        Angle    130.9775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 916"
}

Galaxy "NGC 917:UGC 1890:MCG 5-6-39:ZWG 504.79"
{
        Type  "Sb"
        RA            2.4353
        Dec          31.9122
        Distance   2.625e+08  # method: T-F
        Radius     9.544e+04
        AbsMag        -20.03
        Axis    [  0.1392   0.9859   0.0927]
        Angle    130.2512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 917"
}

Galaxy "NGC 918:UGC 1888:MCG 3-7-11:ZWG 462.11"
{
        Type  "SBc"
        RA            2.4306
        Dec          18.4958
        Distance   7.121e+07  # method: T-F
        Radius     3.625e+04
        AbsMag        -18.59
        Axis    [ -0.0702   0.7350  -0.6744]
        Angle    173.7214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 918"
}

Galaxy "NGC 919:UGC 1894:MCG 4-6-39:ZWG 483.49"
{
        Type  "Sb"
        RA            2.4378
        Dec          27.2114
        Distance   5.064e+08  # method: T-F
        Radius     8.839e+04
        AbsMag        -20.55
        Axis    [ -0.2490   0.8270  -0.5040]
        Angle    153.8940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 919"
}

Galaxy "NGC 920:UGC 1920:MCG 8-5-11:ZWG 553.12"
{
        Type  "SBb"
        RA            2.4642
        Dec          45.9469
        Distance   2.719e+08  # method: V
        Radius     5.932e+04
        AbsMag         -19.4
        Axis    [ -0.1543   0.8323  -0.5323]
        Angle    186.1180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 920"
}

Galaxy "NGC 921:MCG 3-7-15"
{
        Type  "Sc"
        RA            2.4425
        Dec         -15.8475
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.3711   0.8984  -0.2350]
        Angle    153.1637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 921"
}

Galaxy "NGC 922:ESO 478-28:MCG 4-6-37:UGCA 30"
{
        Type  "SBc"
        RA            2.4175
        Dec         -24.7892
        Distance   1.307e+08  # method: V
        Radius     3.802e+04
        AbsMag        -20.51
        Axis    [  0.2387   0.4506  -0.8602]
        Angle    179.1771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 922"
}

Galaxy "NGC 923:UGC 1915:MCG 7-6-22:ZWG 539.30"
{
        Type  "Sb"
        RA            2.4594
        Dec          41.9781
        Distance   2.456e+08  # method: V
        Radius     2.857e+04
        AbsMag        -19.88
        Axis    [  0.0722   0.9680  -0.2404]
        Angle    147.5497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 923"
}

Galaxy "NGC 924:UGC 1912:MCG 3-7-12:ZWG 462.12"
{
        Type  "S0"
        RA            2.4461
        Dec          20.4972
        Distance   2.003e+08  # method: V
        Radius       6.7e+04
        AbsMag        -20.44
        Axis    [  0.2656   0.9611   0.0759]
        Angle    134.9180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 924"
}

Galaxy "NGC 925:UGC 1913:MCG 5-6-45:ZWG 504.85"
{
        Type  "SBc"
        RA            2.4544
        Dec          33.5789
        Distance   2.727e+07  # method: T-F
        Radius     4.165e+04
        AbsMag        -19.01
        Axis    [ -0.0083   0.9609  -0.2769]
        Angle    148.7585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 925"
}

Galaxy "NGC 926:UGC 1901:MCG 0-7-11:ZWG 388.14"
{
        Type  "SBc"
        RA            2.4350
        Dec          -0.3325
        Distance   2.828e+08  # method: V
        Radius     7.403e+04
        AbsMag        -20.69
        Axis    [  0.4408   0.8774   0.1894]
        Angle    145.3990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 926"
}

Galaxy "NGC 927:UGC 1908:MCG 2-7-9:MK 593"
{
        Type  "SBc"
        RA            2.4436
        Dec          12.1553
        Distance   3.631e+08  # method: V
        Radius     6.337e+04
        AbsMag        -21.03
        Axis    [  0.8218   0.5040   0.2658]
        Angle    111.7345
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 927"
}

Galaxy "NGC 928:MCG 4-6-50:ZWG 483.60"
{
        Type  "S0"
        RA            2.4611
        Dec          27.2208
        Distance   2.216e+08  # method: V
        Radius     2.256e+04
        AbsMag        -19.36
        Axis    [  0.1883   0.9415   0.2796]
        Angle    129.1627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 928"
}

Galaxy "NGC 929:MCG 2-7-9"
{
        Type  "Sa"
        RA            2.4550
        Dec         -12.0872
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.0972   0.5561  -0.8254]
        Angle    168.5606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 929"
}

Galaxy "NGC 931:UGC 1935:MCG 5-6-49:MK 1040"
{
        Type  "Sc"
        RA            2.4706
        Dec          31.3111
        Distance   1.743e+08  # method: T-F
        Radius     9.888e+04
        AbsMag        -19.34
        Axis    [ -0.1443   0.9884   0.0469]
        Angle    135.7528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 931"
}

Galaxy "NGC 932:UGC 1931:MCG 3-7-14:ZWG 462.14"
{
        Type  "Sa"
        RA            2.4650
        Dec          20.3331
        Distance   1.739e+08  # method: V
        Radius     4.806e+04
        AbsMag        -20.23
        Axis    [  0.4948   0.8658   0.0749]
        Angle    129.3691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 932"
}

Galaxy "NGC 933:UGC 1956:MCG 8-5-13:ZWG 553.16"
{
        Type  "S0"
        RA            2.4881
        Dec          45.9119
        Distance   2.225e+08  # method: V
        Radius     4.207e+04
        AbsMag        -19.07
        Axis    [  0.2148   0.9524   0.2164]
        Angle    112.4984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 933"
}

Galaxy "NGC 934:UGC 1926:MCG 0-7-16:ZWG 388.17"
{
        Type  "S0"
        RA            2.4589
        Dec          -0.2442
        Distance   2.768e+08  # method: V
        Radius     5.234e+04
        AbsMag        -20.54
        Axis    [  0.2339   0.7799  -0.5805]
        Angle    165.5429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 934"
}

Galaxy "NGC 935:UGC 1937:MCG 3-7-15:ZWG 462.16"
{
        Type  "Sc"
        RA            2.4697
        Dec          19.5992
        Distance   1.771e+08  # method: V
        Radius     4.378e+04
        AbsMag        -19.97
        Axis    [ -0.0312   0.7541  -0.6560]
        Angle    175.9836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 935"
}

Galaxy "NGC 936:UGC 1929:MCG 0-7-17:ZWG 388.18"
{
        Type  "SBa"
        RA            2.4603
        Dec          -1.1564
        Distance   7.507e+07  # method: S
        Radius     5.131e+04
        AbsMag        -20.71
        Axis    [  0.3301   0.7114  -0.6204]
        Angle    177.8626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 936"
}

Galaxy "NGC 937:UGC 1961:MCG 7-6-24:ZWG 539.32"
{
        Type  "SBc"
        RA            2.4911
        Dec          42.2497
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.1903   0.9245  -0.3303]
        Angle    153.1797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 937"
}

Galaxy "NGC 938:UGC 1947:MCG 3-7-17:ZWG 462.17"
{
        Type  "E0"
        RA            2.4758
        Dec          20.2839
        Distance   1.744e+08  # method: V
        Radius     4.059e+04
        AbsMag        -20.14
        Axis    [  0.5539   0.7371  -0.3871]
        Angle    170.5823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 938"
}

Galaxy "NGC 939:ESO 246-11:MCG 7-6-4"
{
        Type  "E0"
        RA            2.4392
        Dec         -44.4464
        Distance   2.298e+08  # method: V
        Radius      4.01e+04
        AbsMag        -20.14
        Axis    [  0.8112   0.2881  -0.5088]
        Angle    192.6569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 939"
}

Galaxy "NGC 940:UGC 1964:MCG 5-6-50:ZWG 504.95"
{
        Type  "S0"
        RA            2.4908
        Dec          31.6414
        Distance   2.203e+08  # method: V
        Radius     3.846e+04
        AbsMag        -20.65
        Axis    [  0.4411   0.8056   0.3956]
        Angle    112.0388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 940"
}

Galaxy "NGC 941:UGC 1954:MCG 0-7-22:ZWG 388.23"
{
        Type  "SBc"
        RA            2.4742
        Dec          -1.1511
        Distance   6.197e+07  # method: V
        Radius     2.434e+04
        AbsMag        -18.49
        Axis    [  0.0530   0.5998  -0.7984]
        Angle    176.5617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 941"
}

Galaxy "NGC 942:MCG 2-7-18:VV 217:ARP 309"
{
        Type  "Sa"
        RA            2.4861
        Dec         -10.8356
        Distance   1.281e+08  # distance uncertain!
        Radius     5.215e+04
        AbsMag        -19.07
        Axis    [  0.4550   0.8697   0.1916]
        Angle    153.3526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 942"
}

Galaxy "NGC 943:MCG 2-7-19:VV 217:ARP 309"
{
        Type  "E0"
        RA            2.4858
        Dec         -10.8281
        Distance   2.089e+08  # distance uncertain!
        Radius     8.509e+04
        AbsMag        -20.13
        Axis    [  0.8844   0.4286   0.1849]
        Angle    136.5672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 943"
}

Galaxy "NGC 944:IC 228:MCG 3-7-16:IRAS 02242-1444"
{
        Type  "Sa"
        RA            2.4447
        Dec         -14.5158
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.4309   0.8273   0.3604]
        Angle    161.4689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 944"
}

Galaxy "NGC 945:MCG 2-7-13:IRAS 02261-1045"
{
        Type  "SBc"
        RA            2.4769
        Dec         -10.5389
        Distance   1.927e+08  # method: V
        Radius     6.447e+04
        AbsMag        -21.06
        Axis    [  0.7796   0.5548   0.2906]
        Angle    139.5168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 945"
}

Galaxy "NGC 946:UGC 1979:MCG 7-6-26:ZWG 539.34"
{
        Type  "S0"
        RA            2.5106
        Dec          42.2331
        Distance   2.471e+08  # method: V
        Radius      5.39e+04
        AbsMag         -19.7
        Axis    [  0.1171   0.9930  -0.0129]
        Angle    128.5943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 946"
}

Galaxy "NGC 947:ESO 545-21:MCG 3-7-22:IRAS 02262-1915"
{
        Type  "SBc"
        RA            2.4758
        Dec         -19.0422
        Distance   2.017e+08  # method: T-F
        Radius      6.16e+04
        AbsMag        -20.66
        Axis    [  0.5154   0.8561   0.0386]
        Angle    157.0737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 947"
}

Galaxy "NGC 948:MCG 2-7-15"
{
        Type  "SBc"
        RA            2.4792
        Dec         -10.5139
        Distance   1.939e+08  # method: V
        Radius     3.949e+04
        AbsMag        -19.47
        Axis    [  0.6478   0.6859   0.3314]
        Angle    146.6176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 948"
}

Galaxy "NGC 949:UGC 1983:MCG 6-6-48:ZWG 523.53"
{
        Type  "Sb"
        RA            2.5133
        Dec          37.1358
        Distance   3.677e+07  # method: S
        Radius     1.604e+04
        AbsMag        -17.86
        Axis    [ -0.1923   0.8178  -0.5425]
        Angle    171.1139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 949"
}

Galaxy "NGC 950:MCG 2-7-21"
{
        Type  "Sb"
        RA            2.4864
        Dec         -11.0250
        Distance   2.024e+08  # method: V
        Radius     3.826e+04
        AbsMag        -19.36
        Axis    [  0.5346   0.8358   0.1250]
        Angle    151.5251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 950"
}

Galaxy "NGC 951:ESO 479-8:MCG 4-7-1:AM 0226-223"
{
        Type  "SBb"
        RA            2.4822
        Dec         -22.3492
        Distance   2.692e+08  # method: V
        Radius     3.915e+04
        AbsMag        -19.08
        Axis    [  0.5785   0.8147   0.0404]
        Angle    158.9758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 951"
}

Galaxy "NGC 953:UGC 1991:MCG 5-7-1:ZWG 504.104"
{
        Type  "E0"
        RA            2.5192
        Dec          29.5889
        Distance   2.754e+08  # distance uncertain!
        Radius     5.208e+04
        AbsMag        -20.13
        Axis    [  0.8064   0.5609   0.1875]
        Angle     96.1569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 953"
}

Galaxy "NGC 954:ESO 299-4:MCG 7-6-6:IRAS 02268-4137"
{
        Type  "SBc"
        RA            2.4808
        Dec         -41.4025
        Distance   2.179e+08  # method: T-F
        Radius     5.071e+04
        AbsMag        -20.42
        Axis    [  0.6208   0.7405   0.2576]
        Angle    178.5536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 954"
}

Galaxy "NGC 955:UGC 1986:MCG 0-7-27A:ZWG 388.29"
{
        Type  "Sb"
        RA            2.5092
        Dec          -1.1083
        Distance   5.735e+07  # method: V
        Radius     2.419e+04
        AbsMag        -18.32
        Axis    [  0.3356   0.8671   0.3681]
        Angle    151.3123
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 955"
}

Galaxy "NGC 958:MCG 1-7-19:IRAS 02281-0309"
{
        Type  "SBc"
        RA            2.5117
        Dec          -2.9408
        Distance   2.492e+08  # method: V
        Radius     1.051e+05
        AbsMag        -21.52
        Axis    [  0.3565   0.8282   0.4324]
        Angle    154.3008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 958"
}

Galaxy "NGC 959:UGC 2002:MCG 6-6-51:ZWG 523.55"
{
        Type  "Irr"
        RA            2.5400
        Dec          35.4950
        Distance    5.83e+07  # method: T-F
        Radius      1.95e+04
        AbsMag        -18.36
        Axis    [  0.1376   0.9905  -0.0074]
        Angle    130.7222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 959"
}

Galaxy "NGC 960:MCG 2-7-28"
{
        Type  "Sb"
        RA            2.5281
        Dec          -9.3003
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.0889   0.8469  -0.5242]
        Angle    144.4804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 960"
}

Galaxy "NGC 961:NGC 1051:IC 249:MCG 1-7-33"
{
        Type  "Irr"
        RA            2.6839
        Dec          -6.9356
        Distance   4.893e+07  # method: V
        Radius     1.352e+04
        AbsMag        -17.48
        Axis    [  0.5828   0.8124   0.0184]
        Angle    146.6231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 961"
}

Galaxy "NGC 962:UGC 2013:MCG 5-7-4:ZWG 505.3"
{
        Type  "E0"
        RA            2.5442
        Dec          28.0708
        Distance   2.188e+08  # distance uncertain!
        Radius     4.455e+04
        AbsMag        -20.13
        Axis    [  0.1846   0.7347  -0.6528]
        Angle    225.0936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 962"
}

Galaxy "NGC 963:IC 1808:MCG 1-7-17:KUG 0228-044"
{
        Type  "Irr"
        RA            2.5086
        Dec          -4.2156
        Distance   2.754e+08  # distance uncertain!
        Radius     2.804e+04
        AbsMag        -20.13
        Axis    [  0.8527   0.4271   0.3010]
        Angle    125.5294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 963"
}

Galaxy "NGC 964:IC 1814:ESO 355-24:MCG 6-6-10"
{
        Type  "Sb"
        RA            2.5181
        Dec         -36.0347
        Distance   2.088e+08  # method: V
        Radius     6.377e+04
        AbsMag        -20.53
        Axis    [  0.4585   0.8707   0.1779]
        Angle    174.7480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 964"
}

Galaxy "NGC 965:ESO 545-32:MCG 3-7-31"
{
        Type  "Sc"
        RA            2.5403
        Dec         -18.6403
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.6883   0.6430   0.3359]
        Angle    152.5953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 965"
}

Galaxy "NGC 966:ESO 545-30:MCG 3-7-29"
{
        Type  "S0"
        RA            2.5297
        Dec         -19.8817
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.5682   0.6402  -0.5170]
        Angle    172.3000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 966"
}

Galaxy "NGC 967:ESO 545-31:MCG 3-7-30:NPM 1"
{
        Type  "S0"
        RA            2.5367
        Dec         -17.2164
        Distance   1.115e+08  # distance uncertain!
        Radius     2.596e+04
        AbsMag        -19.07
        Axis    [  0.5828   0.7943   0.1718]
        Angle    155.3469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 967"
}

Galaxy "NGC 968:UGC 2040:MCG 6-6-56:ZWG 523.61"
{
        Type  "E0"
        RA            2.5683
        Dec          34.4806
        Distance   1.551e+08  # method: V
        Radius     6.089e+04
        AbsMag        -19.78
        Axis    [  0.6048   0.7713  -0.1985]
        Angle    133.6602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 968"
}

Galaxy "NGC 969:UGC 2039:MCG 5-7-8:ZWG 505.10"
{
        Type  "S0"
        RA            2.5689
        Dec          32.9464
        Distance   1.949e+08  # method: V
        Radius      4.82e+04
        AbsMag        -20.58
        Axis    [  0.3529   0.7870   0.5061]
        Angle    115.1953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 969"
}

Galaxy "NGC 970:MCG 5-7-9:ZWG 505.11"
{
        Type  "S0"
        RA            2.5697
        Dec          32.9764
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.0099   0.9859   0.1673]
        Angle    130.3002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 970"
}

Galaxy "NGC 972:UGC 2045:MCG 5-7-10:ZWG 505.12"
{
        Type  "Sb"
        RA            2.5703
        Dec          29.3103
        Distance   6.238e+07  # method: T-F
        Radius     2.994e+04
        AbsMag        -19.31
        Axis    [ -0.1747   0.7843  -0.5952]
        Angle    168.2019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 972"
}

Galaxy "NGC 973:UGC 2048:MCG 5-7-13:ZWG 505.14"
{
        Type  "Sb"
        RA            2.5722
        Dec          32.5056
        Distance   2.151e+08  # method: T-F
        Radius     1.157e+05
        AbsMag        -20.49
        Axis    [ -0.0557   0.9639   0.2602]
        Angle    131.6365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 973"
}

Galaxy "NGC 974:UGC 2049:MCG 5-7-12:ZWG 505.15"
{
        Type  "Sb"
        RA            2.5736
        Dec          32.9550
        Distance   1.948e+08  # method: V
        Radius     4.818e+04
        AbsMag        -20.28
        Axis    [  0.2347   0.9717  -0.0277]
        Angle    130.5617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 974"
}

Galaxy "NGC 975:UGC 2030:MCG 1-7-9:ZWG 414.17"
{
        Type  "Sa"
        RA            2.5561
        Dec           9.6019
        Distance   2.661e+08  # method: V
        Radius     4.257e+04
        AbsMag        -20.46
        Axis    [  0.5461   0.7022   0.4569]
        Angle    129.7504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 975"
}

Galaxy "NGC 976:UGC 2042:MCG 3-7-27:ZWG 462.27"
{
        Type  "Sc"
        RA            2.5664
        Dec          20.9772
        Distance   1.842e+08  # method: V
        Radius     4.286e+04
        AbsMag        -20.46
        Axis    [  0.0231   0.7306  -0.6824]
        Angle    188.2999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 976"
}

Galaxy "NGC 977:MCG 2-7-31"
{
        Type  "Sa"
        RA            2.5508
        Dec         -10.7594
        Distance   1.958e+08  # method: V
        Radius     5.695e+04
        AbsMag        -19.49
        Axis    [  0.6622   0.7205   0.2058]
        Angle    147.1761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 977"
}

Galaxy "NGC 978A:NGC 978:UGC 2057:MCG 5-7-16"
{
        Type  "S0"
        RA            2.5797
        Dec          32.8450
        Distance   2.034e+08  # method: V
        Radius     3.847e+04
        AbsMag        -20.77
        Axis    [  0.2864   0.9571  -0.0429]
        Angle    130.2496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 978A"
}

Galaxy "NGC 978B:MCG 5-7-17:KCPG 71B"
{
        Type  "S0"
        RA            2.5800
        Dec          32.8425
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.2296   0.7233  -0.6513]
        Angle    176.8783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 978B"
}

Galaxy "NGC 979:ESO 246-23:MCG 7-6-14:AM 0229-444"
{
        Type  "S0"
        RA            2.5272
        Dec         -44.5242
        Distance   1.223e+08  # distance uncertain!
        Radius     1.601e+04
        AbsMag        -19.07
        Axis    [  0.7302   0.5540   0.3999]
        Angle    176.8589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 979"
}

Galaxy "NGC 980:UGC 2063:MCG 7-6-38:ZWG 539.54"
{
        Type  "S0"
        RA            2.5883
        Dec          40.9269
        Distance   1.404e+08  # distance uncertain!
        Radius     3.472e+04
        AbsMag        -19.07
        Axis    [ -0.1135   0.9477  -0.2984]
        Angle    149.7305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 980"
}

Galaxy "NGC 981:MCG 2-7-30:KUG 0230-111:IRAS 02305-1111"
{
        Type  "Sc"
        RA            2.5497
        Dec         -10.9736
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.5498   0.7244   0.4159]
        Angle    152.3447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 981"
}

Galaxy "NGC 982:UGC 2066:MCG 7-6-39:ZWG 539.56"
{
        Type  "Sa"
        RA            2.5900
        Dec          40.8694
        Distance   2.511e+08  # method: V
        Radius     5.478e+04
        AbsMag        -21.03
        Axis    [ -0.2514   0.8708  -0.4226]
        Angle    157.7491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 982"
}

Galaxy "NGC 983:NGC 1002:UGC 2133:MCG 6-6-70"
{
        Type  "SBb"
        RA            2.6486
        Dec          34.6219
        Distance   2.072e+08  # method: V
        Radius     3.616e+04
        AbsMag        -20.01
        Axis    [ -0.0466   0.8355  -0.5475]
        Angle    176.8374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 983"
}

Galaxy "NGC 984:UGC 2059:MCG 4-7-12:ZWG 484.10"
{
        Type  "Sa"
        RA            2.5786
        Dec          23.4136
        Distance   1.869e+08  # method: V
        Radius     5.436e+04
        AbsMag        -19.29
        Axis    [  0.0370   0.8985  -0.4373]
        Angle    156.7246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 984"
}

Galaxy "NGC 985:MCG 2-7-35:MK 1048:VV 285"
{
        Type  "S0"
        RA            2.5769
        Dec          -8.7850
        Distance   5.755e+08  # method: V
        Radius      8.37e+04
        AbsMag        -21.73
        Axis    [  0.6554   0.7326  -0.1839]
        Angle    154.9001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 985"
}

Galaxy "NGC 986:ESO 299-7:MCG 7-6-15:AM 0231-391"
{
        Type  "SBb"
        RA            2.5594
        Dec         -39.0458
        Distance   8.358e+07  # method: V
        Radius     4.863e+04
        AbsMag        -20.44
        Axis    [  0.4316   0.4545  -0.7792]
        Angle    171.2174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 986"
}

Galaxy "NGC 986A:MCG 7-6-14A:ESO 299-6A:AM 0230-393"
{
        Type  "Irr"
        RA            2.5450
        Dec         -39.2953
        Distance   5.649e+07  # method: V
        Radius     1.479e+04
        AbsMag        -16.59
        Axis    [  0.5330   0.8213  -0.2032]
        Angle    161.7664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 986A"
}

Galaxy "NGC 987:UGC 2093:MCG 5-7-21:MK 1180"
{
        Type  "SBa"
        RA            2.6136
        Dec          33.3272
        Distance   1.957e+08  # method: V
        Radius     4.555e+04
        AbsMag        -20.49
        Axis    [  0.3075   0.9357   0.1730]
        Angle    120.2050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 987"
}

Galaxy "NGC 988:MCG 2-7-37:UGCA 35:IRAS 02330-0934"
{
        Type  "SBc"
        RA            2.5908
        Dec          -9.3550
        Distance   5.799e+07  # method: V
        Radius     3.458e+04
        AbsMag        -19.55
        Axis    [  0.2077   0.8608  -0.4647]
        Angle    148.8213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 988"
}

Galaxy "NGC 989:MCG 3-7-34:NPM 1"
{
        Type  "S0"
        RA            2.5628
        Dec         -16.5114
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6479   0.7116  -0.2719]
        Angle    161.0697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 989"
}

Galaxy "NGC 990:UGC 2089:MCG 2-7-18:ZWG 439.19"
{
        Type  "E0"
        RA            2.6050
        Dec          11.6422
        Distance   1.483e+08  # method: V
        Radius     3.883e+04
        AbsMag        -19.79
        Axis    [  0.7893   0.6098  -0.0719]
        Angle    133.4804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 990"
}

Galaxy "NGC 991:MCG 1-7-23:IRAS 02330-0722:KUG 0233-073"
{
        Type  "SBc"
        RA            2.5922
        Dec          -7.1550
        Distance   5.925e+07  # method: V
        Radius     2.585e+04
        AbsMag         -18.9
        Axis    [  0.6702   0.7338  -0.1113]
        Angle    151.0363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 991"
}

Galaxy "NGC 992:UGC 2103:MCG 3-7-35:ZWG 462.35"
{
        Type  "Sc"
        RA            2.6236
        Dec          21.1003
        Distance   1.772e+08  # method: V
        Radius      2.32e+04
        AbsMag        -18.78
        Axis    [  0.5327   0.7502   0.3917]
        Angle    118.2261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 992"
}

Galaxy "NGC 993:NGC 994:UGC 2095:MCG 0-7-52"
{
        Type  "S0"
        RA            2.6128
        Dec           2.0503
        Distance   3.063e+08  # method: V
        Radius     4.009e+04
        AbsMag        -20.16
        Axis    [  0.4302   0.7723  -0.4675]
        Angle    165.8968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 993"
}

Galaxy "NGC 995:UGC 2118:MCG 7-6-44:ZWG 539.63"
{
        Type  "S0"
        RA            2.6419
        Dec          41.5289
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.1158   0.9455   0.3044]
        Angle    117.8641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 995"
}

Galaxy "NGC 996:UGC 2123:MCG 7-6-45:ZWG 539.64"
{
        Type  "E0"
        RA            2.6442
        Dec          41.6472
        Distance   2.291e+08  # distance uncertain!
        Radius     3.999e+04
        AbsMag        -20.13
        Axis    [  0.7803   0.6107   0.1349]
        Angle     85.6940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 996"
}

Galaxy "NGC 997:UGC 2102:MCG 1-7-16:ZWG 414.27"
{
        Type  "E0"
        RA            2.6206
        Dec           7.3061
        Distance   2.631e+08  # distance uncertain!
        Radius     4.209e+04
        AbsMag        -20.13
        Axis    [  0.8603   0.4431   0.2520]
        Angle    114.2176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 997"
}

Galaxy "NGC 998:MCG 1-7-15:ZWG 414.28"
{
        Type  "S0"
        RA            2.6211
        Dec           7.3358
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [ -0.0552   0.5964  -0.8008]
        Angle    177.7979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 998"
}

Galaxy "NGC 999:UGC 2127:MCG 7-6-47:NPM 1"
{
        Type  "SBa"
        RA            2.6464
        Dec          41.6711
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.1954   0.9734   0.1199]
        Angle    118.9522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 999"
}

Galaxy "NGC 1000:MCG 7-6-48:ZWG 539.67:NPM 1"
{
        Type  "E0"
        RA            2.6469
        Dec          41.4603
        Distance   4.571e+08  # distance uncertain!
        Radius     4.654e+04
        AbsMag        -20.13
        Axis    [  0.7813   0.6092   0.1356]
        Angle     85.8189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1000"
}

Galaxy "NGC 1001:MCG 7-6-50:ZWG 539.69"
{
        Type  "Sc"
        RA            2.6533
        Dec          41.6717
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.2421   0.8746  -0.4201]
        Angle    157.8447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1001"
}

Galaxy "NGC 1003:UGC 2137:MCG 7-6-51:ZWG 539.70"
{
        Type  "Sc"
        RA            2.6544
        Dec          40.8728
        Distance    4.43e+07  # method: T-F
        Radius     2.771e+04
        AbsMag        -18.66
        Axis    [ -0.2119   0.9643  -0.1590]
        Angle    138.9382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1003"
}

Galaxy "NGC 1004:UGC 2112:MCG 0-7-57:ZWG 388.68"
{
        Type  "E0"
        RA            2.6281
        Dec           1.9756
        Distance    2.83e+08  # method: V
        Radius     5.763e+04
        AbsMag        -20.89
        Axis    [  0.5942   0.6237  -0.5078]
        Angle    183.5558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1004"
}

Galaxy "NGC 1005:MCG 7-6-52:ZWG 539.71"
{
        Type  "S0"
        RA            2.6575
        Dec          41.4933
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.2325   0.9705  -0.0640]
        Angle    127.3087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1005"
}

Galaxy "NGC 1006:NGC 1010:MCG 2-7-44:IRAS 02351-1114"
{
        Type  "Sc"
        RA            2.6261
        Dec         -11.0253
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.8689   0.3889   0.3062]
        Angle    131.0832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1006"
}

Galaxy "NGC 1007:MCG 0-7-59:ZWG 388.69"
{
        Type  "Irr"
        RA            2.6311
        Dec           2.1556
        Distance   7.944e+08  # distance uncertain!
        Radius     6.932e+04
        AbsMag        -20.13
        Axis    [  0.2838   0.9499   0.1308]
        Angle    143.9579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1007"
}

Galaxy "NGC 1008:UGC 2114:MCG 0-7-60:ZWG 388.70"
{
        Type  "E0"
        RA            2.6319
        Dec           2.0803
        Distance   2.882e+08  # method: V
        Radius     3.353e+04
        AbsMag        -19.83
        Axis    [  0.7107   0.6160  -0.3398]
        Angle    164.8185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1008"
}

Galaxy "NGC 1009:UGC 2129:MCG 0-7-65:ZWG 388.77"
{
        Type  "Sb"
        RA            2.6383
        Dec           2.3100
        Distance   2.536e+08  # method: V
        Radius     5.165e+04
        AbsMag        -19.15
        Axis    [ -0.0531   0.8792  -0.4735]
        Angle    140.8206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1009"
}

Galaxy "NGC 1011:MCG 2-7-45:NPM 1"
{
        Type  "Sa"
        RA            2.6272
        Dec         -11.0050
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.8690   0.3888   0.3061]
        Angle    131.0612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1011"
}

Galaxy "NGC 1012:UGC 2141:MCG 5-7-27:ZWG 505.30"
{
        Type  "Sa"
        RA            2.6539
        Dec          30.1514
        Distance    6.27e+07  # method: T-F
        Radius      2.28e+04
        AbsMag        -18.32
        Axis    [  0.2292   0.8971   0.3778]
        Angle    123.5765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1012"
}

Galaxy "NGC 1013:MCG 2-7-46:NPM 1"
{
        Type  "Sa"
        RA            2.6306
        Dec         -11.5067
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.5521   0.8072  -0.2088]
        Angle    153.8948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1013"
}

Galaxy "NGC 1015:UGC 2124:MCG 0-7-66:ZWG 388.75"
{
        Type  "SBa"
        RA            2.6364
        Dec          -1.3183
        Distance   1.089e+08  # method: V
        Radius     3.167e+04
        AbsMag        -19.52
        Axis    [  0.6711   0.6882   0.2757]
        Angle    136.1366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1015"
}

Galaxy "NGC 1016:UGC 2128:MCG 0-7-67:ZWG 388.76"
{
        Type  "E0"
        RA            2.6386
        Dec           2.1192
        Distance   2.298e+08  # method: T-F
        Radius     6.686e+04
        AbsMag        -21.64
        Axis    [  0.8687   0.4190   0.2641]
        Angle    118.6229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1016"
}

Galaxy "NGC 1017:MCG 2-7-47:KUG 0235-112B"
{
        Type  "Irr"
        RA            2.6303
        Dec         -11.0106
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.6801   0.7329  -0.0201]
        Angle    149.9958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1017"
}

Galaxy "NGC 1018:MCG 2-7-48"
{
        Type  "SBa"
        RA            2.6361
        Dec          -9.5442
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [  0.0685   0.5656  -0.8218]
        Angle    167.2073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1018"
}

Galaxy "NGC 1019:UGC 2132:MCG 0-7-68:ZWG 388.79"
{
        Type  "SBc"
        RA            2.6408
        Dec           1.9081
        Distance   3.181e+08  # method: V
        Radius     4.626e+04
        AbsMag        -20.55
        Axis    [  0.6686   0.7417   0.0531]
        Angle    138.4931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1019"
}

Galaxy "NGC 1020:ZWG 388.81"
{
        Type  "S0"
        RA            2.6456
        Dec           2.2311
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.2881   0.8797   0.3783]
        Angle    149.2896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1020"
}

Galaxy "NGC 1021:ZWG 388.84"
{
        Type  "Sc"
        RA            2.6464
        Dec           2.2172
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.0886   0.6616  -0.7446]
        Angle    174.9040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1021"
}

Galaxy "NGC 1022:MCG 1-7-25:IRAS 02360-0653"
{
        Type  "SBa"
        RA            2.6422
        Dec          -6.6775
        Distance   5.776e+07  # method: V
        Radius     2.016e+04
        AbsMag        -19.04
        Axis    [  0.7439   0.6060   0.2816]
        Angle    137.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1022"
}

Galaxy "NGC 1023:UGC 2154:MCG 6-6-73:ZWG 523.83"
{
        Type  "S0"
        RA            2.6733
        Dec          39.0633
        Distance   3.728e+07  # method: S
        Radius     4.012e+04
        AbsMag        -19.79
        Axis    [ -0.1387   0.9857  -0.0953]
        Angle    135.4846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1023"
}

Galaxy "NGC 1023A"
{
        Type  "Irr"
        RA            2.6767
        Dec          39.0603
        Distance   2.464e+07  # method: V
        Radius          4660
        AbsMag        -15.19
        Axis    [  0.2645   0.8539   0.4482]
        Angle    112.7112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1023A"
}

Galaxy "NGC 1024:UGC 2142:MCG 2-7-20:ZWG 439.22"
{
        Type  "Sb"
        RA            2.6531
        Dec          10.8478
        Distance   1.494e+08  # method: V
        Radius     8.475e+04
        AbsMag         -20.2
        Axis    [ -0.1031   0.7289  -0.6769]
        Angle    157.9311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1024"
}

Galaxy "NGC 1025:ESO 154-4:IRAS 02347-5504"
{
        Type  "SBb"
        RA            2.6053
        Dec         -54.8636
        Distance   2.828e+08  # method: V
        Radius     3.702e+04
        AbsMag        -20.79
        Axis    [  0.6836   0.6537   0.3246]
        Angle    191.0950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1025"
}

Galaxy "NGC 1026:UGC 2145:MCG 1-7-18:ZWG 414.33"
{
        Type  "S0"
        RA            2.6553
        Dec           6.5444
        Distance   1.788e+08  # method: V
        Radius     4.422e+04
        AbsMag        -19.99
        Axis    [  0.2914   0.8327  -0.4708]
        Angle    160.1106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1026"
}

Galaxy "NGC 1028:MCG 2-7-23:ZWG 439.25"
{
        Type  "SBc"
        RA            2.6603
        Dec          10.8433
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.3082   0.8507   0.4258]
        Angle    140.7440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1028"
}

Galaxy "NGC 1029:UGC 2149:MCG 2-7-24:ZWG 439.24"
{
        Type  "Sa"
        RA            2.6600
        Dec          10.7933
        Distance   1.532e+08  # method: V
        Radius     3.119e+04
        AbsMag        -19.26
        Axis    [  0.1249   0.9919  -0.0250]
        Angle    139.3282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1029"
}

Galaxy "NGC 1030:UGC 2153:MCG 3-7-39:ZWG 462.39"
{
        Type  "Sc"
        RA            2.6639
        Dec          18.0239
        Distance   3.771e+08  # method: V
        Radius     8.776e+04
        AbsMag        -21.01
        Axis    [  0.3448   0.8086   0.4767]
        Angle    132.2035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1030"
}

Galaxy "NGC 1031:ESO 154-5:AM 0235-550"
{
        Type  "SBa"
        RA            2.6106
        Dec         -54.8589
        Distance   2.496e+08  # method: V
        Radius     6.898e+04
        AbsMag        -21.02
        Axis    [  0.7199   0.6683   0.1873]
        Angle    185.8343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1031"
}

Galaxy "NGC 1032:UGC 2147:MCG 0-7-73:ZWG 388.86"
{
        Type  "Sa"
        RA            2.6564
        Dec           1.0939
        Distance   1.098e+08  # method: V
        Radius     5.428e+04
        AbsMag        -19.93
        Axis    [  0.2331   0.9714  -0.0441]
        Angle    143.2644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1032"
}

Galaxy "NGC 1033:MCG 2-7-53:NPM 1"
{
        Type  "Sc"
        RA            2.6711
        Dec          -8.7764
        Distance   3.307e+08  # method: V
        Radius     5.771e+04
        AbsMag        -20.53
        Axis    [  0.6839   0.6050   0.4078]
        Angle    141.1736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1033"
}

Galaxy "NGC 1034:MCG 3-7-43:IRAS 02358-1601"
{
        Type  "Irr"
        RA            2.6369
        Dec         -15.8092
        Distance   2.884e+08  # distance uncertain!
        Radius     3.356e+04
        AbsMag        -20.13
        Axis    [  0.3779   0.6014  -0.7039]
        Angle    177.5435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1034"
}

Galaxy "NGC 1035:MCG 1-7-27:IRAS 02370-0820"
{
        Type  "Sc"
        RA            2.6581
        Dec          -8.1325
        Distance   7.783e+07  # method: T-F
        Radius      2.49e+04
        AbsMag        -18.99
        Axis    [  0.0041   0.7180  -0.6961]
        Angle    145.2348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1035"
}

Galaxy "NGC 1036:IC 1828:UGC 2160:MCG 3-7-41"
{
        Type  "Irr"
        RA            2.6747
        Dec          19.2969
        Distance   2.519e+07  # method: V
        Radius          5495
        AbsMag        -15.74
        Axis    [  0.5228   0.7260   0.4469]
        Angle    120.3269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1036"
}

Galaxy "NGC 1038:UGC 2158:MCG 0-7-76:ZWG 388.90"
{
        Type  "Sa"
        RA            2.6683
        Dec           1.5094
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.2569   0.9663   0.0158]
        Angle    143.1470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1038"
}

Galaxy "NGC 1040-1:NGC 1053-1:UGC 2187:MCG 7-6-60"
{
        Type  "S0"
        RA            2.7200
        Dec          41.5003
        Distance   2.093e+08  # method: V
        Radius     5.176e+04
        AbsMag        -20.14
        Axis    [  0.1083   0.9591   0.2617]
        Angle    118.1052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1040-1"
}

Galaxy "NGC 1040-2:NGC 1053-2:NPM 1"
{
        Type  "S0"
        RA            2.7200
        Dec          41.5150
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.0857   0.9822   0.1672]
        Angle    120.6825
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1040-2"
}

Galaxy "NGC 1041:MCG 1-7-30:NPM 1"
{
        Type  "S0"
        RA            2.6736
        Dec          -5.4400
        Distance    1.54e+08  # distance uncertain!
        Radius     3.807e+04
        AbsMag        -19.07
        Axis    [  0.5737   0.8173  -0.0545]
        Angle    147.1618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1041"
}

Galaxy "NGC 1042:MCG 2-7-54:IRAS 02379-0838"
{
        Type  "SBc"
        RA            2.6731
        Dec          -8.4342
        Distance   5.232e+07  # method: V
        Radius     3.272e+04
        AbsMag        -19.32
        Axis    [  0.6908   0.6755   0.2579]
        Angle    142.4456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1042"
}

Galaxy "NGC 1043:ZWG 388.94"
{
        Type  "Sb"
        RA            2.6794
        Dec           1.3431
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.0209   0.9275  -0.3734]
        Angle    140.7783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1043"
}

Galaxy "NGC 1044:MCG 1-7-23:ZWG 414.38:NPM 1"
{
        Type  "S0"
        RA            2.6850
        Dec           8.7386
        Distance   2.805e+08  # method: V
        Radius      2.04e+04
        AbsMag        -20.27
        Axis    [  0.8475   0.4626   0.2604]
        Angle    113.4431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1044"
}

Galaxy "NGC 1045:MCG 2-7-59"
{
        Type  "S0"
        RA            2.6747
        Dec         -11.2778
        Distance   1.017e+08  # distance uncertain!
        Radius     2.367e+04
        AbsMag        -19.07
        Axis    [  0.6286   0.7726   0.0889]
        Angle    148.5421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1045"
}

Galaxy "NGC 1046:MCG 1-7-24:ZWG 414.39:NPM 1"
{
        Type  "S0"
        RA            2.6867
        Dec           8.7200
        Distance   1.938e+08  # distance uncertain!
        Radius     1.128e+04
        AbsMag        -19.07
        Axis    [  0.8476   0.4623   0.2603]
        Angle    113.4513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1046"
}

Galaxy "NGC 1047:MCG 1-7-32"
{
        Type  "Sa"
        RA            2.6756
        Dec          -8.1472
        Distance   5.078e+07  # method: V
        Radius          9602
        AbsMag        -16.56
        Axis    [  0.3262   0.9071  -0.2660]
        Angle    148.0521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1047"
}

Galaxy "NGC 1048:NGC 1048B:MCG 2-7-62"
{
        Type  "SBa"
        RA            2.6769
        Dec          -8.5336
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.1942   0.9177  -0.3465]
        Angle    144.5276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1048"
}

Galaxy "NGC 1048A:MCG 2-7-58"
{
        Type  "SBc"
        RA            2.6764
        Dec          -8.5478
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.5379   0.7084   0.4569]
        Angle    150.7107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1048A"
}

Galaxy "NGC 1050:UGC 2178:MCG 6-6-78:ZWG 523.92"
{
        Type  "SBa"
        RA            2.7097
        Dec          34.7642
        Distance   1.667e+08  # method: V
        Radius     4.121e+04
        AbsMag        -20.04
        Axis    [  0.0009   0.9339  -0.3576]
        Angle    152.5853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1050"
}

Galaxy "NGC 1052:MCG 1-7-34:IRAS 02386-0828"
{
        Type  "E4"
        RA            2.6844
        Dec          -8.2547
        Distance   6.331e+07  # method: S
        Radius     2.578e+04
        AbsMag        -19.94
        Axis    [  0.5901   0.5480  -0.5928]
        Angle    191.1286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1052"
}

Galaxy "NGC 1054:MCG 3-7-46:ZWG 462.45:IRAS 02394+1800"
{
        Type  "Sc"
        RA            2.7042
        Dec          18.2175
        Distance   4.319e+08  # method: V
        Radius     5.654e+04
        AbsMag        -20.91
        Axis    [  0.3557   0.9023   0.2437]
        Angle    129.5936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1054"
}

Galaxy "NGC 1055:UGC 2173:MCG 0-7-81:ZWG 388.95"
{
        Type  "SBb"
        RA            2.6958
        Dec           0.4428
        Distance   5.536e+07  # method: T-F
        Radius     6.119e+04
        AbsMag        -19.75
        Axis    [  0.1396   0.9202  -0.3658]
        Angle    144.6594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1055"
}

Galaxy "NGC 1056:UGC 2183:MCG 5-7-32:MK 1183"
{
        Type  "Sa"
        RA            2.7133
        Dec          28.5744
        Distance   6.034e+07  # method: V
        Radius     2.106e+04
        AbsMag        -17.94
        Axis    [ -0.2104   0.7423  -0.6362]
        Angle    168.5540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1056"
}

Galaxy "NGC 1057:UGC 2184:MCG 5-7-33:ZWG 505.37"
{
        Type  "S0"
        RA            2.7172
        Dec          32.4917
        Distance   3.217e+08  # distance uncertain!
        Radius     5.615e+04
        AbsMag        -19.07
        Axis    [  0.0244   0.9241  -0.3813]
        Angle    154.2122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1057"
}

Galaxy "NGC 1058:UGC 2193:MCG 6-7-1:ZWG 524.5"
{
        Type  "Sc"
        RA            2.7247
        Dec          37.3414
        Distance   1.441e+07  # method: V
        Radius          5238
        AbsMag        -16.32
        Axis    [  0.7844   0.5946   0.1763]
        Angle     89.0047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1058"
}

Galaxy "NGC 1060:UGC 2191:MCG 5-7-35:ZWG 505.38"
{
        Type  "S0"
        RA            2.7208
        Dec          32.4247
        Distance    2.43e+08  # method: T-F
        Radius      8.13e+04
        AbsMag        -21.36
        Axis    [  0.2261   0.9653  -0.1307]
        Angle    134.7110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1060"
}

Galaxy "NGC 1061:MCG 5-7-36:ZWG 505.39:KUG 0240+322"
{
        Type  "Irr"
        RA            2.7208
        Dec          32.4672
        Distance    1.73e+08  # method: V
        Radius     2.264e+04
        AbsMag        -18.52
        Axis    [  0.2984   0.9417   0.1553]
        Angle    120.7494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1061"
}

Galaxy "NGC 1063:MCG 1-7-36:IRAS 02396-0546"
{
        Type  "SBc"
        RA            2.7025
        Dec          -5.5683
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.1905   0.9041  -0.3824]
        Angle    145.3471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1063"
}

Galaxy "NGC 1064:MCG 2-7-71"
{
        Type  "Sc"
        RA            2.7064
        Dec          -9.3628
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.7448   0.6547   0.1286]
        Angle    143.3344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1064"
}

Galaxy "NGC 1065:MCG 3-7-59:NPM 1"
{
        Type  "S0"
        RA            2.7017
        Dec         -15.0917
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.2122   0.5006  -0.8392]
        Angle    185.4605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1065"
}

Galaxy "NGC 1066:UGC 2203:MCG 5-7-42:ZWG 505.44"
{
        Type  "E0"
        RA            2.7303
        Dec          32.4756
        Distance   3.163e+08  # distance uncertain!
        Radius      7.82e+04
        AbsMag        -20.13
        Axis    [  0.6355   0.7477  -0.1926]
        Angle    130.4835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1066"
}

Galaxy "NGC 1067:UGC 2204:MCG 5-7-43:ZWG 505.45"
{
        Type  "Sc"
        RA            2.7306
        Dec          32.5117
        Distance   1.959e+08  # method: V
        Radius     3.135e+04
        AbsMag        -19.39
        Axis    [  0.0122   0.7734  -0.6339]
        Angle    197.8824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1067"
}

Galaxy "M 77:NGC 1068:UGC 2188:MCG 0-7-83"
{
        Type  "Sb"
        RA            2.7111
        Dec          -0.0128
        Distance   4.127e+07  # method: V
        Radius     4.262e+04
        AbsMag        -20.81
        Axis    [  0.5613   0.8082  -0.1783]
        Angle    148.0870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 77"
}

Galaxy "NGC 1069:MCG 1-7-38:IRAS 02405-0829"
{
        Type  "Sc"
        RA            2.7164
        Dec          -8.2889
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.1907   0.6912  -0.6970]
        Angle    162.8457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1069"
}

Galaxy "NGC 1070:UGC 2200:MCG 1-7-26:ZWG 414.45"
{
        Type  "Sb"
        RA            2.7228
        Dec           4.9686
        Distance    1.75e+08  # method: V
        Radius     5.854e+04
        AbsMag        -20.85
        Axis    [  0.0532   0.5984  -0.7994]
        Angle    188.9283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1070"
}

Galaxy "NGC 1071:MCG 2-7-77"
{
        Type  "Sa"
        RA            2.7186
        Dec          -8.7742
        Distance    2.44e+08  # distance uncertain!
        Radius     4.259e+04
        AbsMag        -19.07
        Axis    [  0.0324   0.6415  -0.7664]
        Angle    153.6439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1071"
}

Galaxy "NGC 1072:IC 1837:UGC 2208:MCG 0-7-88"
{
        Type  "SBb"
        RA            2.7253
        Dec           0.3069
        Distance   3.533e+08  # method: V
        Radius     7.707e+04
        AbsMag        -20.97
        Axis    [  0.3750   0.8234   0.4258]
        Angle    148.9023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1072"
}

Galaxy "NGC 1073:UGC 2210:MCG 0-8-1:ZWG 389.2"
{
        Type  "SBc"
        RA            2.7278
        Dec           1.3761
        Distance   4.476e+07  # method: V
        Radius      3.19e+04
        AbsMag        -19.19
        Axis    [  0.6910   0.6709   0.2691]
        Angle    132.1121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1073"
}

Galaxy "NGC 1074:MCG 3-8-1"
{
        Type  "Sb"
        RA            2.7267
        Dec         -16.2969
        Distance   2.226e+08  # distance uncertain!
        Radius     6.474e+04
        AbsMag        -19.07
        Axis    [  0.1378   0.5435  -0.8280]
        Angle    166.2736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1074"
}

Galaxy "NGC 1075:MCG 3-8-2:NPM 1:IRAS 02412-1624"
{
        Type  "SBa"
        RA            2.7258
        Dec         -16.2011
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.3577   0.6751  -0.6452]
        Angle    165.0834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1075"
}

Galaxy "NGC 1076:MCG 3-8-3:IRAS 02411-1457"
{
        Type  "Sa"
        RA            2.7247
        Dec         -14.7550
        Distance   8.589e+07  # method: V
        Radius     2.498e+04
        AbsMag         -18.5
        Axis    [  0.3863   0.8378  -0.3858]
        Angle    151.7891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1076"
}

Galaxy "NGC 1077A:NGC 1077-1:UGC 2230:MCG 7-6-69"
{
        Type  "Sb"
        RA            2.7667
        Dec          40.0900
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.1627   0.7792  -0.6053]
        Angle    187.2381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1077A"
}

Galaxy "NGC 1077B:NGC 1077-2:MCG 7-6-68:ZWG 539.95"
{
        Type  "SBb"
        RA            2.7672
        Dec          40.0933
        Distance    5.59e+08  # distance uncertain!
        Radius     4.065e+04
        AbsMag        -19.07
        Axis    [  0.3882   0.8995   0.2005]
        Angle    108.7262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1077B"
}

Galaxy "NGC 1078:MCG 2-8-1:NPM 1"
{
        Type  "S0"
        RA            2.7356
        Dec          -9.4519
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.7371   0.6330   0.2365]
        Angle    141.3278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1078"
}

Galaxy "NGC 1079:ESO 416-13:MCG 5-7-17:IRAS 02415-2913"
{
        Type  "SBa"
        RA            2.7289
        Dec         -29.0028
        Distance   5.812e+07  # method: V
        Radius     4.649e+04
        AbsMag        -18.85
        Axis    [  0.5304   0.7867  -0.3159]
        Angle    156.4810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1079"
}

Galaxy "NGC 1080:MCG 1-8-3:IRAS 02426-0455:KUG 0242-049"
{
        Type  "SBc"
        RA            2.7528
        Dec          -4.7108
        Distance   3.457e+08  # method: V
        Radius     5.531e+04
        AbsMag        -20.93
        Axis    [  0.0619   0.5573  -0.8280]
        Angle    177.1240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1080"
}

Galaxy "NGC 1081:MCG 3-8-10:IRAS 02427-1547"
{
        Type  "Sb"
        RA            2.7514
        Dec         -15.5875
        Distance    1.72e+08  # method: V
        Radius     4.003e+04
        AbsMag        -19.51
        Axis    [  0.4608   0.8521   0.2482]
        Angle    156.5646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1081"
}

Galaxy "NGC 1082-1:MCG 1-8-4:NPM 1"
{
        Type  "S0"
        RA            2.7614
        Dec          -8.1800
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.3752   0.7434  -0.5537]
        Angle    162.7763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1082-1"
}

Galaxy "NGC 1082-2:MCG 1-8-4"
{
        Type  "E0"
        RA            2.7617
        Dec          -8.1831
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.8883   0.3649   0.2787]
        Angle    127.2140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1082-2"
}

Galaxy "NGC 1083:MCG 3-8-15:IRAS 02433-1534"
{
        Type  "Sb"
        RA            2.7611
        Dec         -15.3572
        Distance    2.33e+08  # distance uncertain!
        Radius     5.423e+04
        AbsMag        -19.07
        Axis    [  0.3480   0.8701   0.3491]
        Angle    163.8708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1083"
}

Galaxy "NGC 1084:MCG 1-8-7:IRAS 02435-0747:KUG 0243-077"
{
        Type  "Sc"
        RA            2.7664
        Dec          -7.5778
        Distance   8.961e+07  # method: T-F
        Radius     3.649e+04
        AbsMag        -20.79
        Axis    [  0.4861   0.8445   0.2248]
        Angle    147.9852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1084"
}

Galaxy "NGC 1085:UGC 2241:MCG 0-8-10:ZWG 389.8"
{
        Type  "Sc"
        RA            2.7736
        Dec           3.6078
        Distance   2.976e+08  # method: V
        Radius     7.791e+04
        AbsMag         -21.6
        Axis    [  0.5783   0.7494   0.3225]
        Angle    134.4966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1085"
}

Galaxy "NGC 1086:UGC 2258:MCG 7-6-71:ZWG 539.101"
{
        Type  "Sc"
        RA            2.7989
        Dec          41.2467
        Distance   1.747e+08  # method: V
        Radius     3.811e+04
        AbsMag        -20.04
        Axis    [  0.2634   0.9372   0.2288]
        Angle    112.1341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1086"
}

Galaxy "NGC 1087:UGC 2245:MCG 0-8-9:ZWG 389.10"
{
        Type  "SBc"
        RA            2.7736
        Dec          -0.4992
        Distance   5.889e+07  # method: V
        Radius     3.341e+04
        AbsMag        -19.78
        Axis    [  0.5265   0.7351   0.4271]
        Angle    141.9335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1087"
}

Galaxy "NGC 1088:UGC 2253:MCG 3-8-9:ZWG 463.11"
{
        Type  "Sa"
        RA            2.7842
        Dec          16.2003
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.1756   0.9318  -0.3178]
        Angle    145.8292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1088"
}

Galaxy "NGC 1089:MCG 3-8-20:NPM 1"
{
        Type  "E0"
        RA            2.7694
        Dec         -15.0736
        Distance   2.884e+08  # distance uncertain!
        Radius     3.776e+04
        AbsMag        -20.13
        Axis    [  0.9075   0.3842   0.1696]
        Angle    138.7616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1089"
}

Galaxy "NGC 1090:UGC 2247:MCG 0-8-11:ZWG 389.11"
{
        Type  "SBc"
        RA            2.7761
        Dec          -0.2478
        Distance   9.835e+07  # method: T-F
        Radius     5.579e+04
        AbsMag         -19.8
        Axis    [  0.2170   0.9059  -0.3636]
        Angle    146.0215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1090"
}

Galaxy "NGC 1091:ESO 546-16:MCG 3-8-13:HCG 21"
{
        Type  "SBa"
        RA            2.7561
        Dec         -17.5333
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.5399   0.8101  -0.2285]
        Angle    153.7154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1091"
}

Galaxy "NGC 1092:ESO 546-17:MCG 3-8-14:HCG 21"
{
        Type  "E0"
        RA            2.7581
        Dec         -17.5425
        Distance   3.912e+08  # method: V
        Radius     5.121e+04
        AbsMag        -20.39
        Axis    [  0.3606   0.4190  -0.8333]
        Angle    211.5222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1092"
}

Galaxy "NGC 1093:UGC 2274:MCG 6-7-11:ZWG 524.22"
{
        Type  "Sb"
        RA            2.8044
        Dec          34.4200
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.0980   0.9522  -0.2894]
        Angle    145.8071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1093"
}

Galaxy "NGC 1094:UGC 2262:MCG 0-8-15:ZWG 389.16"
{
        Type  "SBb"
        RA            2.7908
        Dec          -0.2853
        Distance   2.825e+08  # method: V
        Radius     5.341e+04
        AbsMag        -21.19
        Axis    [  0.4608   0.8408  -0.2840]
        Angle    150.0114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1094"
}

Galaxy "NGC 1095:UGC 2264:MCG 1-8-1:ZWG 415.8"
{
        Type  "SBc"
        RA            2.7936
        Dec           4.6381
        Distance   2.783e+08  # method: V
        Radius     5.263e+04
        AbsMag        -20.56
        Axis    [  0.4556   0.8850   0.0960]
        Angle    138.0936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1095"
}

Galaxy "NGC 1096:ESO 115-28:AM 0242-600:IRAS 02425-6007"
{
        Type  "SBc"
        RA            2.7303
        Dec         -59.9139
        Distance   2.991e+08  # method: V
        Radius     8.265e+04
        AbsMag        -21.21
        Axis    [  0.9252   0.3758  -0.0531]
        Angle    182.4554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1096"
}

Galaxy "NGC 1097:ESO 416-20:MCG 5-7-24:UGCA 41"
{
        Type  "SBb"
        RA            2.7719
        Dec         -30.2756
        Distance   6.487e+07  # method: T-F
        Radius     8.869e+04
        AbsMag        -21.19
        Axis    [  0.4342   0.6163  -0.6570]
        Angle    161.5621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1097"
}

Galaxy "NGC 1097A:ESO 416-19:MCG 5-7-22"
{
        Type  "E0"
        RA            2.7692
        Dec         -30.2286
        Distance   5.278e+07  # method: V
        Radius          6141
        AbsMag        -16.94
        Axis    [  0.7716   0.3918  -0.5010]
        Angle    184.9438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1097A"
}

Galaxy "NGC 1098:ESO 546-14:MCG 3-8-8:HCG 21"
{
        Type  "S0"
        RA            2.7481
        Dec         -17.6594
        Distance   3.256e+08  # method: V
        Radius      8.05e+04
        AbsMag         -21.3
        Axis    [  0.5085   0.7385  -0.4429]
        Angle    159.7524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1098"
}

Galaxy "NGC 1099:ESO 546-15:MCG 3-8-11:HCG 21A"
{
        Type  "SBb"
        RA            2.7547
        Dec         -17.7086
        Distance   3.099e+08  # method: T-F
        Radius     8.564e+04
        AbsMag        -20.79
        Axis    [  0.4493   0.8077   0.3818]
        Angle    163.7529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1099"
}

Galaxy "NGC 1100:ESO 546-18:MCG 3-8-16:HCG 21B"
{
        Type  "SBa"
        RA            2.7597
        Dec         -17.6886
        Distance   3.332e+08  # method: V
        Radius     8.239e+04
        AbsMag        -21.05
        Axis    [  0.4809   0.8761  -0.0343]
        Angle    152.1783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1100"
}

Galaxy "NGC 1101:UGC 2278:MCG 1-8-3:ZWG 415.11"
{
        Type  "S0"
        RA            2.8039
        Dec           4.5786
        Distance   2.713e+08  # method: V
        Radius     5.129e+04
        AbsMag         -20.6
        Axis    [  0.2809   0.8060  -0.5210]
        Angle    160.7298
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1101"
}

Galaxy "NGC 1102:ESO 546-19:MCG 4-7-40:AM 0245-222"
{
        Type  "SBb"
        RA            2.7867
        Dec         -22.2089
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.5739   0.7371  -0.3569]
        Angle    158.4081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1102"
}

Galaxy "NGC 1103:MCG 2-8-5"
{
        Type  "SBb"
        RA            2.8017
        Dec         -13.9594
        Distance    1.79e+08  # method: V
        Radius     5.729e+04
        AbsMag           -20
        Axis    [  0.3672   0.9227   0.1177]
        Angle    152.3498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1103"
}

Galaxy "NGC 1104:UGC 2287:MCG 0-8-19:ZWG 389.20"
{
        Type  "SBa"
        RA            2.8106
        Dec          -0.2714
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.5012   0.8504  -0.1603]
        Angle    145.3839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1104"
}

Galaxy "NGC 1105:IC 1840:MCG 3-8-4:NPM 1"
{
        Type  "Sb"
        RA            2.7281
        Dec         -15.7058
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.8803   0.3618   0.3068]
        Angle    134.9236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1105"
}

Galaxy "NGC 1106:UGC 2322:MCG 7-6-76:ZWG 539.112"
{
        Type  "S0"
        RA            2.8444
        Dec          41.6722
        Distance   1.821e+08  # method: V
        Radius     3.443e+04
        AbsMag        -20.23
        Axis    [  0.3712   0.8956   0.2454]
        Angle    106.2419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1106"
}

Galaxy "NGC 1107:UGC 2307:MCG 1-8-6:ZWG 415.13"
{
        Type  "S0"
        RA            2.8219
        Dec           8.0933
        Distance   1.452e+08  # method: V
        Radius     3.801e+04
        AbsMag        -19.74
        Axis    [  0.2063   0.7485  -0.6302]
        Angle    172.7761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1107"
}

Galaxy "NGC 1108"
{
        Type  "S0"
        RA            2.8106
        Dec          -7.9506
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.3595   0.8985  -0.2518]
        Angle    146.6818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1108"
}

Galaxy "NGC 1109:IC 1846:UGC 2265:MCG 2-8-6"
{
        Type  "E0"
        RA            2.7953
        Dec          13.2556
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.3652   0.6738  -0.6424]
        Angle    203.0703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1109"
}

Galaxy "NGC 1110:MCG 1-8-10:UGCA 43:FGC 346"
{
        Type  "Irr"
        RA            2.8192
        Dec          -7.8381
        Distance   5.087e+07  # method: V
        Radius     2.146e+04
        AbsMag        -16.46
        Axis    [  0.3152   0.8751   0.3672]
        Angle    157.5176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1110"
}

Galaxy "NGC 1111:IC 1850"
{
        Type  "S0"
        RA            2.8108
        Dec          13.2592
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.3699   0.7871   0.4936]
        Angle    136.4156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1111"
}

Galaxy "NGC 1112:IC 1852:UGC 2293:MCG 2-8-11"
{
        Type  "SBc"
        RA            2.8167
        Dec          13.2236
        Distance   3.721e+08  # method: V
        Radius     6.495e+04
        AbsMag        -20.69
        Axis    [  0.5725   0.7025   0.4228]
        Angle    124.0705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1112"
}

Galaxy "NGC 1114:MCG 3-8-29:IRAS 02467-1712"
{
        Type  "Sc"
        RA            2.8186
        Dec         -16.9939
        Distance   1.842e+08  # method: T-F
        Radius     4.822e+04
        AbsMag        -20.16
        Axis    [  0.5200   0.7664   0.3771]
        Angle    159.2782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1114"
}

Galaxy "NGC 1115:MCG 2-8-16:ZWG 440.20"
{
        Type  "S0"
        RA            2.8403
        Dec          13.2669
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.2918   0.8362   0.4644]
        Angle    139.3811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1115"
}

Galaxy "NGC 1116:UGC 2326:MCG 2-8-17:ZWG 440.21"
{
        Type  "Sb"
        RA            2.8431
        Dec          13.3350
        Distance    3.39e+08  # method: V
        Radius     6.903e+04
        AbsMag        -19.78
        Axis    [  0.1912   0.9088   0.3707]
        Angle    140.0195
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1116"
}

Galaxy "NGC 1117-1:UGC 2337:MCG 2-8-20:ZWG 440.22"
{
        Type  "E0"
        RA            2.8536
        Dec          13.1858
        Distance   3.981e+08  # distance uncertain!
        Radius     4.054e+04
        AbsMag        -20.13
        Axis    [  0.8178   0.5747  -0.0308]
        Angle    125.0056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1117-1"
}

Galaxy "NGC 1117-2:UGC 2337:ZWG 440.22"
{
        Type  "E0"
        RA            2.8536
        Dec          13.1878
        Distance   6.919e+08  # distance uncertain!
        Radius     1.006e+04
        AbsMag        -20.13
        Axis    [  0.8691   0.4420   0.2222]
        Angle    108.0413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1117-2"
}

Galaxy "NGC 1117A:UGC 2337:MCG 2-8-19:ZWG 440.22"
{
        Type  "S0"
        RA            2.8533
        Dec          13.1925
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.4357   0.8662   0.2446]
        Angle    130.3396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1117A"
}

Galaxy "NGC 1118:MCG 2-8-11:IRAS 02475-1222"
{
        Type  "S0"
        RA            2.8328
        Dec         -12.1639
        Distance    1.47e+08  # distance uncertain!
        Radius     4.705e+04
        AbsMag        -19.07
        Axis    [  0.2735   0.9227  -0.2716]
        Angle    144.1024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1118"
}

Galaxy "NGC 1119:ESO 546-24:IRAS 02459-1811"
{
        Type  "S0"
        RA            2.8047
        Dec         -17.9881
        Distance   1.938e+08  # distance uncertain!
        Radius      1.41e+04
        AbsMag        -19.07
        Axis    [  0.6997   0.5917   0.4005]
        Angle    150.1965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1119"
}

Galaxy "NGC 1120:IC 261:MCG 3-8-28:NPM 1"
{
        Type  "S0"
        RA            2.8178
        Dec         -14.4703
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.5762   0.8108   0.1024]
        Angle    150.3642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1120"
}

Galaxy "NGC 1121:UGC 2332:MCG 0-8-30:ZWG 389.32"
{
        Type  "S0"
        RA            2.8442
        Dec          -1.7342
        Distance    1.08e+08  # method: V
        Radius     1.414e+04
        AbsMag         -18.7
        Axis    [  0.4583   0.7897   0.4078]
        Angle    146.3015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1121"
}

Galaxy "NGC 1123:NGC 1122:UGC 2353:MCG 7-6-83"
{
        Type  "SBb"
        RA            2.8808
        Dec          42.2053
        Distance   1.549e+08  # method: V
        Radius     4.055e+04
        AbsMag        -20.38
        Axis    [  0.2823   0.9452   0.1639]
        Angle    111.6554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1123"
}

Galaxy "NGC 1124:ESO 480-7:MCG 4-7-47"
{
        Type  "S0"
        RA            2.8600
        Dec         -25.7014
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.2563   0.4752  -0.8417]
        Angle    172.3155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1124"
}

Galaxy "NGC 1125:MCG 3-8-35"
{
        Type  "SBa"
        RA            2.8611
        Dec         -16.6508
        Distance   1.065e+08  # distance uncertain!
        Radius     2.789e+04
        AbsMag        -19.07
        Axis    [  0.5100   0.8599   0.0195]
        Angle    151.0893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1125"
}

Galaxy "NGC 1126:MCG 0-8-38:ZWG 389.38"
{
        Type  "Sb"
        RA            2.8717
        Dec          -1.2964
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.0206   0.8160  -0.5777]
        Angle    140.8008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1126"
}

Galaxy "NGC 1127:UGC 2356:MCG 2-8-24:ZWG 440.24"
{
        Type  "SBb"
        RA            2.8808
        Dec          13.2569
        Distance   4.331e+08  # method: V
        Radius      4.41e+04
        AbsMag        -20.12
        Axis    [  0.4869   0.8636   0.1309]
        Angle    129.6285
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1127"
}

Galaxy "NGC 1128-1:MCG 1-8-27:ZWG 415.41:DRCG 9-43"
{
        Type  "E0"
        RA            2.9614
        Dec           6.0267
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.8868   0.3992   0.2330]
        Angle    113.8529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1128-1"
}

Galaxy "NGC 1128-2:MCG 1-8-27:ZWG 415.41:DRCG 9-42"
{
        Type  "E0"
        RA            2.9614
        Dec           6.0225
        Distance    3.05e+08  # method: V
        Radius     2.218e+04
        AbsMag        -19.35
        Axis    [  0.8868   0.3992   0.2330]
        Angle    113.8566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1128-2"
}

Galaxy "NGC 1129:UGC 2373:MCG 7-7-4:ZWG 539.124"
{
        Type  "E0"
        RA            2.9075
        Dec          41.5797
        Distance   2.275e+08  # method: V
        Radius     9.594e+04
        AbsMag        -21.32
        Axis    [  0.4566   0.8253  -0.3321]
        Angle    150.5242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1129"
}

Galaxy "NGC 1130:MCG 7-7-2:ZWG 539.122:ZWG 540.4"
{
        Type  "E0"
        RA            2.9067
        Dec          41.6061
        Distance   5.755e+08  # distance uncertain!
        Radius     4.185e+04
        AbsMag        -20.13
        Axis    [  0.6671   0.7374  -0.1060]
        Angle    107.8151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1130"
}

Galaxy "NGC 1131:MCG 7-7-5:ZWG 539.125:ZWG 540.7"
{
        Type  "E0"
        RA            2.9094
        Dec          41.5592
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.8079   0.5754   0.1276]
        Angle     83.8060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1131"
}

Galaxy "NGC 1132:UGC 2359:MCG 0-8-40:ZWG 389.40"
{
        Type  "E0"
        RA            2.8808
        Dec          -1.2744
        Distance   3.053e+08  # method: V
        Radius      1.11e+05
        AbsMag        -21.56
        Axis    [  0.4772   0.5837  -0.6569]
        Angle    196.1297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1132"
}

Galaxy "NGC 1133:MCG 2-8-15:IRAS 02502-0900"
{
        Type  "Sa"
        RA            2.8783
        Dec          -8.8044
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.1384   0.6272  -0.7665]
        Angle    165.0713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1133"
}

Galaxy "NGC 1134:UGC 2365:MCG 2-8-27:ZWG 440.27"
{
        Type  "Sb"
        RA            2.8947
        Dec          13.0147
        Distance   1.554e+08  # method: V
        Radius     5.652e+04
        AbsMag        -20.29
        Axis    [ -0.1180   0.7711  -0.6256]
        Angle    151.8019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1134"
}

Galaxy "NGC 1135:ESO 154-18"
{
        Type  "Sc"
        RA            2.8464
        Dec         -54.9294
        Distance   3.694e+08  # distance uncertain!
        Radius      3.76e+04
        AbsMag        -19.07
        Axis    [  0.6528   0.7214  -0.2311]
        Angle    167.0918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1135"
}

Galaxy "NGC 1136:ESO 154-19:FAIR 732:AM 0249-551"
{
        Type  "SBa"
        RA            2.8481
        Dec         -54.9761
        Distance   2.483e+08  # method: V
        Radius     5.057e+04
        AbsMag        -20.61
        Axis    [  0.8193   0.4757  -0.3200]
        Angle    175.1547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1136"
}

Galaxy "NGC 1137:UGC 2374:MCG 0-8-43:ZWG 389.42"
{
        Type  "Sb"
        RA            2.9006
        Dec           2.9619
        Distance   1.282e+08  # method: V
        Radius     4.101e+04
        AbsMag        -19.67
        Axis    [  0.5096   0.8031   0.3088]
        Angle    137.3726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1137"
}

Galaxy "NGC 1138:UGC 2408:MCG 7-7-12:ZWG 540.15"
{
        Type  "S0"
        RA            2.9433
        Dec          43.0472
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [  0.7876   0.5977   0.1498]
        Angle     82.7665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1138"
}

Galaxy "NGC 1139:MCG 3-8-38:NPM 1"
{
        Type  "SBa"
        RA            2.8794
        Dec         -14.5289
        Distance   3.217e+08  # distance uncertain!
        Radius     5.615e+04
        AbsMag        -19.07
        Axis    [  0.6146   0.7790   0.1242]
        Angle    149.4117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1139"
}

Galaxy "NGC 1140:MCG 2-8-19:MK 1063:VV 482"
{
        Type  "Irr"
        RA            2.9092
        Dec         -10.0281
        Distance    5.93e+07  # method: V
        Radius     1.552e+04
        AbsMag         -18.2
        Axis    [  0.0414   0.5697  -0.8208]
        Angle    160.5881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1140"
}

Galaxy "NGC 1141:NGC 1143:UGC 2388:MCG 0-8-47"
{
        Type  "S0"
        RA            2.9192
        Dec          -0.1781
        Distance   3.738e+08  # method: V
        Radius     4.893e+04
        AbsMag         -21.2
        Axis    [  0.3635   0.8019  -0.4742]
        Angle    156.4299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1141"
}

Galaxy "NGC 1142:NGC 1144:UGC 2389:MCG 0-8-48"
{
        Type  "S0"
        RA            2.9200
        Dec          -0.1839
        Distance   3.822e+08  # method: V
        Radius     5.004e+04
        AbsMag        -21.54
        Axis    [  0.1508   0.7995  -0.5815]
        Angle    152.7472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1142"
}

Galaxy "NGC 1145:ESO 546-29:MCG 3-8-42:UGCA 45"
{
        Type  "Sc"
        RA            2.9092
        Dec         -18.6358
        Distance   9.907e+07  # method: T-F
        Radius     4.611e+04
        AbsMag        -18.81
        Axis    [  0.3098   0.9508  -0.0079]
        Angle    149.8577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1145"
}

Galaxy "NGC 1148:MCG 1-8-18"
{
        Type  "Irr"
        RA            2.9511
        Dec          -7.6856
        Distance   4.366e+08  # distance uncertain!
        Radius     8.889e+04
        AbsMag        -20.13
        Axis    [  0.4043   0.8765  -0.2612]
        Angle    145.9272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1148"
}

Galaxy "NGC 1149:MCG 0-8-58:ZWG 389.54:NPM 1"
{
        Type  "S0"
        RA            2.9564
        Dec          -0.3089
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.3048   0.7337  -0.6072]
        Angle    166.3620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1149"
}

Galaxy "NGC 1150:MCG 3-8-48:NPM 1"
{
        Type  "S0"
        RA            2.9503
        Dec         -15.0486
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.5423   0.8157  -0.2015]
        Angle    149.8895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1150"
}

Galaxy "NGC 1151:NPM 1"
{
        Type  "E0"
        RA            2.9511
        Dec         -15.0133
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.9149   0.3536   0.1946]
        Angle    136.1394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1151"
}

Galaxy "NGC 1152:MCG 1-8-19"
{
        Type  "S0"
        RA            2.9592
        Dec          -7.7597
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.5972   0.7787   0.1922]
        Angle    143.6163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1152"
}

Galaxy "NGC 1153:UGC 2439:MCG 0-8-59:ZWG 389.55"
{
        Type  "Sa"
        RA            2.9694
        Dec           3.3619
        Distance   1.323e+08  # method: V
        Radius     2.309e+04
        AbsMag        -19.64
        Axis    [  0.4577   0.8839   0.0961]
        Angle    137.0960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1153"
}

Galaxy "NGC 1154:MCG 2-8-34"
{
        Type  "Sc"
        RA            2.9686
        Dec         -10.3636
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.3783   0.7078  -0.5965]
        Angle    162.5641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1154"
}

Galaxy "NGC 1155:MCG 2-8-35:MK 1064:IRAS 02557-1033"
{
        Type  "S0"
        RA            2.9703
        Dec         -10.3503
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.1592   0.5613  -0.8122]
        Angle    175.1808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1155"
}

Galaxy "NGC 1156:UGC 2455:MCG 4-8-6:ZWG 485.6"
{
        Type  "Irr"
        RA            2.9950
        Dec          25.2372
        Distance    8.29e+06  # method: V
        Radius          3135
        AbsMag        -14.72
        Axis    [  0.3949   0.8932   0.2149]
        Angle    120.1245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1156"
}

Galaxy "NGC 1157"
{
        Type  "Sb"
        RA            2.9683
        Dec         -15.1181
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.0509   0.5511  -0.8329]
        Angle    154.6928
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1157"
}

Galaxy "NGC 1158:MCG 3-8-49:NPM 1"
{
        Type  "S0"
        RA            2.9531
        Dec         -14.3950
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.2217   0.6438  -0.7324]
        Angle    160.5782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1158"
}

Galaxy "NGC 1159:UGC 2467:ZWG 540.23:IRAS 02575+4257"
{
        Type  "S0"
        RA            3.0128
        Dec          43.1628
        Distance   1.612e+08  # distance uncertain!
        Radius     1.172e+04
        AbsMag        -19.07
        Axis    [  0.0084   0.9169  -0.3989]
        Angle    159.1768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1159"
}

Galaxy "NGC 1160:UGC 2475:MCG 7-7-14:ZWG 540.27"
{
        Type  "Sc"
        RA            3.0203
        Dec          44.9556
        Distance   1.024e+08  # method: V
        Radius     2.235e+04
        AbsMag        -18.98
        Axis    [  0.0585   0.9784   0.1985]
        Angle    115.8251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1160"
}

Galaxy "NGC 1161:UGC 2474:MCG 7-7-15:ZWG 540.26"
{
        Type  "S0"
        RA            3.0206
        Dec          44.8975
        Distance   8.027e+07  # method: V
        Radius     3.269e+04
        AbsMag        -19.85
        Axis    [  0.3407   0.8850   0.3172]
        Angle    102.0878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1161"
}

Galaxy "NGC 1162:MCG 2-8-36"
{
        Type  "E0"
        RA            2.9819
        Dec         -12.3983
        Distance   1.347e+08  # method: S
        Radius     2.743e+04
        AbsMag        -19.58
        Axis    [  0.9056   0.3274   0.2697]
        Angle    130.3074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1162"
}

Galaxy "NGC 1163:MCG 3-8-56:FGC 373:IRAS 02580-1720"
{
        Type  "SBc"
        RA            3.0061
        Dec         -17.1528
        Distance   9.939e+07  # method: T-F
        Radius      3.18e+04
        AbsMag        -17.72
        Axis    [  0.0474   0.7561  -0.6527]
        Angle    132.7149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1163"
}

Galaxy "NGC 1164:UGC 2490:MCG 7-7-16:MK 1067"
{
        Type  "SBb"
        RA            3.0331
        Dec          42.5856
        Distance   1.812e+08  # method: V
        Radius     3.427e+04
        AbsMag        -19.32
        Axis    [ -0.0316   0.8634  -0.5035]
        Angle    176.5290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1164"
}

Galaxy "NGC 1165:ESO 417-8:MCG 5-8-9:AM 0256-321"
{
        Type  "SBa"
        RA            2.9797
        Dec         -32.0994
        Distance   2.147e+08  # method: V
        Radius     7.808e+04
        AbsMag        -20.39
        Axis    [  0.3650   0.7657  -0.5296]
        Angle    144.3001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1165"
}

Galaxy "NGC 1166:UGC 2471:MCG 2-8-46:ZWG 440.41"
{
        Type  "Sb"
        RA            3.0094
        Dec          11.8428
        Distance   3.392e+08  # method: V
        Radius     4.934e+04
        AbsMag        -20.08
        Axis    [  0.8677   0.4386   0.2338]
        Angle    109.1764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1166"
}

Galaxy "NGC 1167:UGC 2487:MCG 6-7-33:ZWG 524.45"
{
        Type  "S0"
        RA            3.0283
        Dec          35.2058
        Distance    2.16e+08  # method: V
        Radius     1.037e+05
        AbsMag         -20.7
        Axis    [  0.2081   0.9752  -0.0752]
        Angle    126.6138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1167"
}

Galaxy "NGC 1168:UGC 2476:MCG 2-8-47:ZWG 440.42"
{
        Type  "Sb"
        RA            3.0131
        Dec          11.7722
        Distance   3.362e+08  # method: V
        Radius     5.379e+04
        AbsMag        -19.97
        Axis    [  0.4540   0.8177   0.3538]
        Angle    130.5741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1168"
}

Galaxy "NGC 1169:UGC 2503:MCG 8-6-25:ZWG 554.20"
{
        Type  "SBb"
        RA            3.0594
        Dec          46.3864
        Distance   1.687e+08  # method: T-F
        Radius     9.817e+04
        AbsMag        -21.17
        Axis    [  0.2664   0.9121   0.3116]
        Angle    103.9739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1169"
}

Galaxy "NGC 1171:UGC 2510:MCG 7-7-18:ZWG 540.31"
{
        Type  "Sc"
        RA            3.0661
        Dec          43.3978
        Distance   8.154e+07  # method: T-F
        Radius     2.253e+04
        AbsMag        -18.59
        Axis    [ -0.2485   0.8340  -0.4926]
        Angle    163.8955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1171"
}

Galaxy "NGC 1172:MCG 3-8-59"
{
        Type  "E0"
        RA            3.0267
        Dec         -14.8367
        Distance   7.006e+07  # method: S
        Radius     2.343e+04
        AbsMag        -18.76
        Axis    [  0.9172   0.3955   0.0489]
        Angle    142.0359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1172"
}

Galaxy "NGC 1175:UGC 2515:MCG 7-7-19:ZWG 540.32"
{
        Type  "Sa"
        RA            3.0756
        Dec          42.3403
        Distance   2.433e+08  # method: V
        Radius     6.723e+04
        AbsMag        -20.56
        Axis    [ -0.3402   0.7848  -0.5181]
        Angle    161.0834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1175"
}

Galaxy "NGC 1177:IC 281:MCG 7-7-20:ZWG 540.33"
{
        Type  "S0"
        RA            3.0769
        Dec          42.3628
        Distance   2.453e+08  # method: V
        Radius     1.427e+04
        AbsMag        -18.98
        Axis    [  0.8041   0.5756   0.1488]
        Angle     82.3717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1177"
}

Galaxy "NGC 1179:ESO 547-1:MCG 3-8-60:UGCA 48"
{
        Type  "SBc"
        RA            3.0439
        Dec         -18.8978
        Distance   5.409e+07  # method: T-F
        Radius     3.697e+04
        AbsMag         -18.5
        Axis    [  0.7283   0.6798   0.0864]
        Angle    149.7808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1179"
}

Galaxy "NGC 1180:NPM 1"
{
        Type  "S0"
        RA            3.0308
        Dec         -15.0303
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [  0.7358   0.5854   0.3404]
        Angle    144.9263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1180"
}

Galaxy "NGC 1181"
{
        Type  "Sb"
        RA            3.0283
        Dec         -15.0528
        Distance   3.694e+08  # distance uncertain!
        Radius     4.298e+04
        AbsMag        -19.07
        Axis    [  0.2222   0.9093  -0.3519]
        Angle    139.0540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1181"
}

Galaxy "NGC 1182:NGC 1205"
{
        Type  "Sa"
        RA            3.0578
        Dec          -9.6706
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [  0.2318   0.8377  -0.4945]
        Angle    143.9856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1182"
}

Galaxy "NGC 1184:UGC 2583:MCG 13-3-2:ZWG 346.2"
{
        Type  "Sa"
        RA            3.2792
        Dec          80.7931
        Distance   1.017e+08  # distance uncertain!
        Radius     4.143e+04
        AbsMag        -19.07
        Axis    [ -0.6600   0.6655  -0.3487]
        Angle    177.1870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1184"
}

Galaxy "NGC 1185:MCG 2-8-41:IRAS 03005-0919"
{
        Type  "Sb"
        RA            3.0497
        Dec          -9.1331
        Distance   2.094e+08  # method: V
        Radius     3.654e+04
        AbsMag        -18.44
        Axis    [  0.4244   0.8734   0.2390]
        Angle    148.9442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1185"
}

Galaxy "NGC 1186:NGC 1174:UGC 2521:MCG 7-7-21"
{
        Type  "SBc"
        RA            3.0917
        Dec          42.8356
        Distance   1.128e+08  # method: V
        Radius      5.25e+04
        AbsMag        -20.19
        Axis    [ -0.2565   0.9083  -0.3304]
        Angle    145.1112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1186"
}

Galaxy "NGC 1187:ESO 480-23:MCG 4-8-16:UGCA 49"
{
        Type  "SBc"
        RA            3.0436
        Dec         -22.8672
        Distance   5.563e+07  # method: V
        Radius     3.398e+04
        AbsMag        -19.86
        Axis    [  0.4037   0.6305  -0.6629]
        Angle    161.3983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1187"
}

Galaxy "NGC 1188:MCG 3-8-68"
{
        Type  "S0"
        RA            3.0619
        Dec         -15.4847
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.0418   0.5419  -0.8394]
        Angle    153.5797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1188"
}

Galaxy "NGC 1189:MCG 3-8-61:HCG 22"
{
        Type  "SBc"
        RA            3.0567
        Dec         -15.6231
        Distance   1.154e+08  # method: V
        Radius     2.853e+04
        AbsMag        -18.24
        Axis    [  0.5920   0.6812  -0.4307]
        Angle    159.4111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1189"
}

Galaxy "NGC 1190:MCG 3-8-62:HCG 22B"
{
        Type  "S0"
        RA            3.0572
        Dec         -15.6622
        Distance   1.107e+08  # method: V
        Radius     1.449e+04
        AbsMag        -17.45
        Axis    [  0.2981   0.8948  -0.3324]
        Angle    141.7149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1190"
}

Galaxy "NGC 1191:MCG 3-8-64:HCG 22:NPM 1"
{
        Type  "S0"
        RA            3.0583
        Dec         -15.6856
        Distance    4.15e+08  # method: V
        Radius     3.622e+04
        AbsMag        -20.22
        Axis    [  0.6847   0.7166  -0.1332]
        Angle    150.0915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1191"
}

Galaxy "NGC 1192:MCG 3-8-65:HCG 22:NPM 1"
{
        Type  "E0"
        RA            3.0594
        Dec         -15.6789
        Distance   4.225e+08  # method: V
        Radius     4.301e+04
        AbsMag        -19.76
        Axis    [  0.7190   0.4877  -0.4953]
        Angle    176.4775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1192"
}

Galaxy "NGC 1194:UGC 2514:MCG 0-8-78:ZWG 389.68"
{
        Type  "Sa"
        RA            3.0636
        Dec          -1.1033
        Distance   1.281e+08  # distance uncertain!
        Radius     3.353e+04
        AbsMag        -19.07
        Axis    [  0.1083   0.7531  -0.6490]
        Angle    153.2236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1194"
}

Galaxy "NGC 1195:MCG 2-8-42A:NPM 1"
{
        Type  "S0"
        RA            3.0589
        Dec         -12.0392
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.7272   0.5702   0.3821]
        Angle    141.9458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1195"
}

Galaxy "NGC 1196:MCG 2-8-42B"
{
        Type  "S0"
        RA            3.0597
        Dec         -12.0758
        Distance    1.47e+08  # distance uncertain!
        Radius     2.994e+04
        AbsMag        -19.07
        Axis    [  0.8984   0.3434   0.2740]
        Angle    130.5964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1196"
}

Galaxy "NGC 1198:IC 282:UGC 2533:MCG 7-7-24"
{
        Type  "S0"
        RA            3.1036
        Dec          41.8489
        Distance   6.474e+07  # method: V
        Radius     1.318e+04
        AbsMag        -17.69
        Axis    [ -0.1258   0.9264  -0.3549]
        Angle    148.6409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1198"
}

Galaxy "NGC 1199:MCG 3-8-67:HCG 22A"
{
        Type  "E3"
        RA            3.0606
        Dec         -15.6133
        Distance    1.08e+08  # method: S
        Radius     3.613e+04
        AbsMag         -20.2
        Axis    [  0.8583   0.4580  -0.2312]
        Angle    157.8507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1199"
}

Galaxy "NGC 1200:MCG 2-8-43"
{
        Type  "S0"
        RA            3.0650
        Dec         -11.9914
        Distance   1.065e+08  # distance uncertain!
        Radius     4.493e+04
        AbsMag        -19.07
        Axis    [  0.5259   0.7571  -0.3876]
        Angle    153.3544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1200"
}

Galaxy "NGC 1201:ESO 480-28:MCG 4-8-23"
{
        Type  "S0"
        RA            3.0686
        Dec         -26.0689
        Distance   6.598e+07  # method: S
        Radius     3.455e+04
        AbsMag        -19.83
        Axis    [  0.6415   0.6860   0.3432]
        Angle    161.8030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1201"
}

Galaxy "NGC 1202:KUG 0302-066"
{
        Type  "Sb"
        RA            3.0839
        Dec          -6.4919
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.5126   0.7635  -0.3928]
        Angle    153.1218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1202"
}

Galaxy "NGC 1203-1:MCG 3-8-70"
{
        Type  "E0"
        RA            3.0872
        Dec         -14.3808
        Distance   3.163e+08  # distance uncertain!
        Radius      3.22e+04
        AbsMag        -20.13
        Axis    [  0.9132   0.3101   0.2646]
        Angle    131.8164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1203-1"
}

Galaxy "NGC 1203-2:MCG 3-8-71"
{
        Type  "E0"
        RA            3.0872
        Dec         -14.3772
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.9132   0.3101   0.2646]
        Angle    131.8131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1203-2"
}

Galaxy "NGC 1204:MCG 2-8-45:IRAS 03022-1232"
{
        Type  "Sa"
        RA            3.0775
        Dec         -12.3417
        Distance    1.47e+08  # distance uncertain!
        Radius     2.566e+04
        AbsMag        -19.07
        Axis    [  0.3007   0.9502  -0.0822]
        Angle    142.6874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1204"
}

Galaxy "NGC 1206:NPM 1"
{
        Type  "E0"
        RA            3.1025
        Dec          -8.8328
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.9102   0.3278   0.2533]
        Angle    126.7147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1206"
}

Galaxy "NGC 1207:UGC 2548:MCG 6-7-43:ZWG 524.55"
{
        Type  "Sb"
        RA            3.1375
        Dec          38.3822
        Distance    2.09e+08  # method: V
        Radius     6.992e+04
        AbsMag        -20.53
        Axis    [ -0.0316   0.9131  -0.4065]
        Angle    153.4602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1207"
}

Galaxy "NGC 1208:MCG 2-8-47:IRAS 03037-0943"
{
        Type  "Sa"
        RA            3.1031
        Dec          -9.5408
        Distance   2.003e+08  # method: V
        Radius     5.536e+04
        AbsMag        -20.54
        Axis    [  0.3833   0.8972  -0.2193]
        Angle    142.6570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1208"
}

Galaxy "NGC 1209:MCG 3-8-73"
{
        Type  "E6"
        RA            3.1006
        Dec         -15.6111
        Distance   1.168e+08  # method: S
        Radius     3.737e+04
        AbsMag        -20.37
        Axis    [  0.7871   0.4785  -0.3892]
        Angle    167.8432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1209"
}

Galaxy "NGC 1210:ESO 480-31:AM 0304-255"
{
        Type  "S0"
        RA            3.1125
        Dec         -25.7164
        Distance   1.708e+08  # method: V
        Radius     2.484e+04
        AbsMag        -19.99
        Axis    [  0.3330   0.4705  -0.8172]
        Angle    177.0721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1210"
}

Galaxy "NGC 1211:UGC 2545:MCG 0-8-93:ZWG 389.81"
{
        Type  "SBa"
        RA            3.1144
        Dec          -0.7942
        Distance   1.362e+08  # method: V
        Radius     4.159e+04
        AbsMag         -19.8
        Axis    [  0.7358   0.6689   0.1057]
        Angle    133.2990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1211"
}

Galaxy "NGC 1212:IC 1883:UGC 2560"
{
        Type  "Sa"
        RA            3.1617
        Dec          40.8931
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.2513   0.8744   0.4151]
        Angle    109.2962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1212"
}

Galaxy "NGC 1213:IC 1881:UGC 2557:MCG 6-7-45"
{
        Type  "Irr"
        RA            3.1547
        Dec          38.6492
        Distance   1.475e+08  # method: V
        Radius     3.862e+04
        AbsMag        -17.98
        Axis    [  0.3163   0.9485   0.0192]
        Angle    116.0204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1213"
}

Galaxy "NGC 1214:MCG 2-8-51:HCG 23A"
{
        Type  "Sa"
        RA            3.1156
        Dec          -9.5442
        Distance    2.11e+08  # method: V
        Radius     3.989e+04
        AbsMag        -19.05
        Axis    [  0.3400   0.9238   0.1759]
        Angle    147.8581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1214"
}

Galaxy "NGC 1215:MCG 2-8-55:HCG 23B"
{
        Type  "Sa"
        RA            3.1192
        Dec          -9.5928
        Distance   2.151e+08  # method: V
        Radius     5.632e+04
        AbsMag         -19.1
        Axis    [  0.5396   0.8315  -0.1317]
        Angle    144.4554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1215"
}

Galaxy "NGC 1216:MCG 2-8-56:HCG 23"
{
        Type  "Sa"
        RA            3.1217
        Dec          -9.6125
        Distance   2.189e+08  # method: V
        Radius     2.547e+04
        AbsMag        -18.13
        Axis    [  0.2949   0.9547  -0.0397]
        Angle    141.6956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1216"
}

Galaxy "NGC 1217-1:ESO 300-10:MCG 7-7-3:AM 0304-391"
{
        Type  "Sa"
        RA            3.1017
        Dec         -39.0358
        Distance   2.767e+08  # method: V
        Radius     7.244e+04
        AbsMag        -21.34
        Axis    [  0.7486   0.6602  -0.0619]
        Angle    163.5801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1217-1"
}

Galaxy "NGC 1217-2:ESO 300-10:MCG 7-7-2:AM 0304-391"
{
        Type  "Sb"
        RA            3.1014
        Dec         -39.0206
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [  0.7719   0.5270   0.3555]
        Angle    168.0004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1217-2"
}

Galaxy "NGC 1218:UGC 2555:MCG 1-9-1:ZWG 416.2"
{
        Type  "Sa"
        RA            3.1406
        Dec           4.1114
        Distance   3.828e+08  # method: V
        Radius     7.239e+04
        AbsMag        -21.05
        Axis    [  0.1039   0.6832  -0.7228]
        Angle    170.1933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1218"
}

Galaxy "NGC 1219:UGC 2556:MCG 0-9-6:ZWG 390.6"
{
        Type  "Sc"
        RA            3.1411
        Dec           2.1081
        Distance   2.677e+08  # method: V
        Radius     3.893e+04
        AbsMag        -20.77
        Axis    [  0.6471   0.7472   0.1517]
        Angle    132.3392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1219"
}

Galaxy "NGC 1221:MCG 1-9-2"
{
        Type  "Sa"
        RA            3.1375
        Dec          -4.2597
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.0760   0.6334  -0.7701]
        Angle    145.6634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1221"
}

Galaxy "NGC 1222:MCG 1-9-5:MK 603:KUG 0306-031"
{
        Type  "S0"
        RA            3.1489
        Dec          -2.9556
        Distance   1.031e+08  # method: V
        Radius      1.65e+04
        AbsMag           -19
        Axis    [  0.0943   0.5819  -0.8077]
        Angle    177.8132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1222"
}

Galaxy "NGC 1223:MCG 1-9-3"
{
        Type  "E0"
        RA            3.1386
        Dec          -4.1386
        Distance   3.468e+08  # distance uncertain!
        Radius     6.052e+04
        AbsMag        -20.13
        Axis    [  0.9105   0.3573   0.2084]
        Angle    123.7291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1223"
}

Galaxy "NGC 1224:UGC 2578:MCG 7-7-34:ZWG 540.55"
{
        Type  "S0"
        RA            3.1869
        Dec          41.3633
        Distance   2.213e+08  # method: V
        Radius     3.219e+04
        AbsMag        -19.16
        Axis    [  0.5348   0.7097   0.4586]
        Angle     94.3359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1224"
}

Galaxy "NGC 1225:MCG 1-9-4"
{
        Type  "Sb"
        RA            3.1464
        Dec          -4.1017
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.1380   0.7240  -0.6758]
        Angle    154.4201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1225"
}

Galaxy "NGC 1226:UGC 2575:MCG 6-8-1:ZWG 525.2"
{
        Type  "E0"
        RA            3.1847
        Dec          35.3864
        Distance   2.188e+08  # distance uncertain!
        Radius     5.092e+04
        AbsMag        -20.13
        Axis    [  0.4816   0.7906  -0.3782]
        Angle    152.9612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1226"
}

Galaxy "NGC 1227:UGC 2577:ZWG 525.3:ZWG 524.62"
{
        Type  "SBa"
        RA            3.1853
        Dec          35.3253
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.4131   0.9026  -0.1211]
        Angle    122.7460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1227"
}

Galaxy "NGC 1228:ESO 480-32:MCG 4-8-26:UGCA 54"
{
        Type  "SBa"
        RA            3.1364
        Dec         -22.9225
        Distance   4.631e+08  # method: V
        Radius     1.078e+05
        AbsMag        -21.56
        Axis    [  0.5300   0.8121  -0.2440]
        Angle    149.4570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1228"
}

Galaxy "NGC 1229:ESO 480-33:MCG 4-8-25:UGCA 53"
{
        Type  "SBb"
        RA            3.1361
        Dec         -22.9606
        Distance   4.725e+08  # method: V
        Radius     9.621e+04
        AbsMag         -20.9
        Axis    [  0.5800   0.7809  -0.2320]
        Angle    151.0562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1229"
}

Galaxy "NGC 1230:ESO 480-34:MCG 4-8-27:ARP 332"
{
        Type  "S0"
        RA            3.1378
        Dec         -22.9839
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.3120   0.8361  -0.4512]
        Angle    140.8401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1230"
}

Galaxy "NGC 1231:MCG 3-8-74"
{
        Type  "Sc"
        RA            3.1081
        Dec         -15.5692
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.9041   0.3269   0.2754]
        Angle    133.6580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1231"
}

Galaxy "NGC 1232:ESO 547-14:MCG 4-8-32:ARP 41"
{
        Type  "SBc"
        RA            3.1625
        Dec         -20.5792
        Distance    6.36e+07  # method: T-F
        Radius     6.845e+04
        AbsMag        -20.95
        Axis    [  0.5610   0.6348  -0.5314]
        Angle    162.4223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1232"
}

Galaxy "NGC 1232A:ESO 547-16:MCG 4-8-32:ARP 41"
{
        Type  "Irr"
        RA            3.1669
        Dec         -20.5994
        Distance   2.868e+08  # method: V
        Radius     3.755e+04
        AbsMag        -19.42
        Axis    [  0.7294   0.5953   0.3369]
        Angle    151.0333
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1232A"
}

Galaxy "NGC 1233:NGC 1235:UGC 2586:MCG 6-8-3"
{
        Type  "Sb"
        RA            3.2092
        Dec          39.3192
        Distance   1.947e+08  # method: V
        Radius     5.097e+04
        AbsMag        -19.98
        Axis    [  0.1465   0.8913   0.4292]
        Angle    115.4500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1233"
}

Galaxy "NGC 1234:MCG 1-9-11"
{
        Type  "SBc"
        RA            3.1608
        Dec          -7.8458
        Distance    2.03e+08  # distance uncertain!
        Radius     5.314e+04
        AbsMag        -19.07
        Axis    [  0.1239   0.7289  -0.6733]
        Angle    148.5275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1234"
}

Galaxy "NGC 1236:ZWG 441.3:NPM 1"
{
        Type  "S0"
        RA            3.1908
        Dec          10.8089
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.5286   0.8151   0.2370]
        Angle    127.1550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1236"
}

Galaxy "NGC 1238:MCG 2-9-10:NPM 1"
{
        Type  "E0"
        RA            3.1811
        Dec         -10.7475
        Distance   2.512e+08  # distance uncertain!
        Radius     5.846e+04
        AbsMag        -20.13
        Axis    [  0.6574   0.5192  -0.5461]
        Angle    177.7472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1238"
}

Galaxy "NGC 1239:MCG 1-9-12:NPM 1"
{
        Type  "S0"
        RA            3.1814
        Dec          -2.5525
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.4642   0.8797   0.1034]
        Angle    139.0378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1239"
}

Galaxy "NGC 1241:MCG 2-9-11:VV 334:ARP 304"
{
        Type  "SBb"
        RA            3.1872
        Dec          -8.9222
        Distance   1.786e+08  # method: T-F
        Radius     8.831e+04
        AbsMag        -20.69
        Axis    [  0.0988   0.7096  -0.6977]
        Angle    147.3028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1241"
}

Galaxy "NGC 1242:MCG 2-9-12:VV 334:ARP 304"
{
        Type  "SBc"
        RA            3.1886
        Dec          -8.9031
        Distance   1.702e+08  # method: V
        Radius     2.971e+04
        AbsMag        -19.19
        Axis    [  0.1832   0.7718  -0.6089]
        Angle    146.1032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1242"
}

Galaxy "NGC 1244:ESO 82-8:AM 0305-665:IRAS 03058-6657"
{
        Type  "Sb"
        RA            3.1086
        Dec         -66.7758
        Distance   2.559e+08  # method: T-F
        Radius     7.071e+04
        AbsMag        -20.57
        Axis    [  0.5788   0.7814   0.2333]
        Angle    206.5683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1244"
}

Galaxy "NGC 1246:ESO 82-9:FAIR 229"
{
        Type  "E5"
        RA            3.1172
        Dec         -66.9383
        Distance   2.386e+08  # method: V
        Radius     4.512e+04
        AbsMag        -20.42
        Axis    [  0.9872   0.1395   0.0779]
        Angle    184.7939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1246"
}

Galaxy "NGC 1247:MCG 2-9-14:UGCA 58:FGC 396"
{
        Type  "Sc"
        RA            3.2039
        Dec         -10.4811
        Distance   2.353e+08  # method: T-F
        Radius     1.164e+05
        AbsMag        -20.79
        Axis    [  0.2455   0.9675  -0.0602]
        Angle    139.7779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1247"
}

Galaxy "NGC 1248:MCG 1-9-16"
{
        Type  "S0"
        RA            3.2133
        Dec          -5.2247
        Distance   9.341e+07  # method: V
        Radius      1.63e+04
        AbsMag        -18.78
        Axis    [  0.5231   0.7685  -0.3684]
        Angle    149.8398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1248"
}

Galaxy "NGC 1249:ESO 155-6:IRAS 03085-5331"
{
        Type  "SBc"
        RA            3.1669
        Dec         -53.3361
        Distance   5.889e+07  # method: T-F
        Radius     4.026e+04
        AbsMag        -19.08
        Axis    [  0.6630   0.6495  -0.3722]
        Angle    160.3330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1249"
}

Galaxy "NGC 1250:UGC 2613:MCG 7-7-40:ZWG 540.66"
{
        Type  "S0"
        RA            3.2558
        Dec          41.3556
        Distance   2.716e+08  # method: V
        Radius     8.295e+04
        AbsMag         -20.6
        Axis    [ -0.3975   0.7414  -0.5407]
        Angle    157.9815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1250"
}

Galaxy "NGC 1253:MCG 1-9-18:UGCA 62:ARP 279"
{
        Type  "SBc"
        RA            3.2358
        Dec          -2.8231
        Distance   9.568e+07  # method: T-F
        Radius     7.375e+04
        AbsMag        -19.94
        Axis    [  0.3132   0.9275  -0.2043]
        Angle    137.7391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1253"
}

Galaxy "NGC 1253A:MCG 1-9-19:DDO 31:VV 587"
{
        Type  "Irr"
        RA            3.2397
        Dec          -2.8011
        Distance   7.475e+07  # method: V
        Radius     1.413e+04
        AbsMag         -17.3
        Axis    [  0.4183   0.8768  -0.2371]
        Angle    140.5351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1253A"
}

Galaxy "NGC 1254:MCG 0-9-33:ZWG 390.32"
{
        Type  "S0"
        RA            3.2397
        Dec           2.6778
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.6791   0.7339   0.0130]
        Angle    132.6640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1254"
}

Galaxy "NGC 1255:ESO 481-13:MCG 4-8-50:UGCA 60"
{
        Type  "SBc"
        RA            3.2256
        Dec         -25.7244
        Distance   7.814e+07  # method: T-F
        Radius     4.774e+04
        AbsMag         -20.4
        Axis    [  0.3991   0.6735  -0.6223]
        Angle    151.9695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1255"
}

Galaxy "NGC 1256:ESO 547-23:MCG 4-8-52"
{
        Type  "S0"
        RA            3.2328
        Dec         -21.9864
        Distance   1.882e+08  # method: V
        Radius     3.011e+04
        AbsMag        -19.21
        Axis    [  0.3160   0.8264  -0.4660]
        Angle    140.2550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1256"
}

Galaxy "NGC 1258:ESO 547-24:MCG 4-8-53"
{
        Type  "SBc"
        RA            3.2347
        Dec         -21.7744
        Distance   9.871e+07  # method: T-F
        Radius     1.866e+04
        AbsMag         -18.4
        Axis    [  0.6968   0.6737   0.2462]
        Angle    152.7813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1258"
}

Galaxy "NGC 1259:MCG 7-7-46:ARP 310"
{
        Type  "S0"
        RA            3.2881
        Dec          41.3856
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.8288   0.5402   0.1460]
        Angle     81.7616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1259"
}

Galaxy "NGC 1260:UGC 2634:MCG 7-7-47:ZWG 540.81"
{
        Type  "Sa"
        RA            3.2908
        Dec          41.4053
        Distance   2.617e+08  # method: T-F
        Radius     4.187e+04
        AbsMag        -20.32
        Axis    [ -0.0601   0.9938  -0.0934]
        Angle    126.7773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1260"
}

Galaxy "NGC 1262:MCG 3-9-14:IRAS 03132-1604"
{
        Type  "Sc"
        RA            3.2592
        Dec         -15.8800
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.3328   0.6446  -0.6883]
        Angle    160.5202
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1262"
}

Galaxy "NGC 1263:MCG 3-9-15"
{
        Type  "SBa"
        RA            3.2608
        Dec         -15.0983
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.7661   0.5331   0.3591]
        Angle    142.7253
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1263"
}

Galaxy "NGC 1264:UGC 2643:MCG 7-7-50"
{
        Type  "SBb"
        RA            3.2997
        Dec          41.5203
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.2257   0.9072   0.3550]
        Angle    108.7811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1264"
}

Galaxy "NGC 1265:UGC 2651:MCG 7-7-52:ZWG 540.88"
{
        Type  "E0"
        RA            3.3042
        Dec          41.8578
        Distance   3.343e+08  # method: V
        Radius     8.751e+04
        AbsMag        -21.85
        Axis    [  0.1491   0.8218  -0.5499]
        Angle    207.2262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1265"
}

Galaxy "NGC 1266:MCG 1-9-23:IRAS 03134-0236"
{
        Type  "S0"
        RA            3.2667
        Dec          -2.4267
        Distance   1.341e+08  # distance uncertain!
        Radius     3.121e+04
        AbsMag        -19.07
        Axis    [  0.2668   0.8195  -0.5073]
        Angle    146.9459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1266"
}

Galaxy "NGC 1267:UGC 2657:MCG 7-7-55:ZWG 540.92"
{
        Type  "E0"
        RA            3.3122
        Dec          41.4675
        Distance   2.221e+08  # method: V
        Radius     3.553e+04
        AbsMag        -20.06
        Axis    [  0.7239   0.6837  -0.0924]
        Angle     99.4210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1267"
}

Galaxy "NGC 1268:UGC 2658:MCG 7-7-56:ZWG 540.93"
{
        Type  "Sb"
        RA            3.3125
        Dec          41.4892
        Distance   1.344e+08  # method: V
        Radius     1.759e+04
        AbsMag        -18.47
        Axis    [ -0.0626   0.9270  -0.3697]
        Angle    148.1719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1268"
}

Galaxy "NGC 1269:NGC 1291:ESO 301-2:MCG 7-7-8"
{
        Type  "SBa"
        RA            3.2883
        Dec         -41.1072
        Distance   3.289e+07  # method: V
        Radius     5.262e+04
        AbsMag        -20.61
        Axis    [  0.7887   0.5441  -0.2861]
        Angle    164.4533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1269"
}

Galaxy "NGC 1270:UGC 2660:MCG 7-7-57:ZWG 540.95"
{
        Type  "E0"
        RA            3.3161
        Dec          41.4703
        Distance   2.617e+08  # method: T-F
        Radius     3.426e+04
        AbsMag        -20.22
        Axis    [  0.7899   0.6132   0.0030]
        Angle     89.6270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1270"
}

Galaxy "NGC 1271:ZWG 540.96"
{
        Type  "S0"
        RA            3.3197
        Dec          41.3536
        Distance   2.528e+08  # method: V
        Radius     1.838e+04
        AbsMag        -19.25
        Axis    [ -0.2475   0.8968  -0.3667]
        Angle    144.7069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1271"
}

Galaxy "NGC 1272:UGC 2662:MCG 7-7-58:ZWG 540.98"
{
        Type  "E0"
        RA            3.3225
        Dec          41.4906
        Distance   2.617e+08  # method: T-F
        Radius     8.375e+04
        AbsMag        -21.52
        Axis    [  0.8490   0.5158   0.1147]
        Angle     81.0573
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1272"
}

Galaxy "NGC 1273:MCG 7-7-59:ZWG 540.99"
{
        Type  "S0"
        RA            3.3239
        Dec          41.5400
        Distance   2.617e+08  # method: T-F
        Radius     3.045e+04
        AbsMag        -20.22
        Axis    [ -0.0007   0.8627  -0.5057]
        Angle    173.0647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1273"
}

Galaxy "NGC 1274:MCG 7-7-62:ZWG 540.102"
{
        Type  "E3"
        RA            3.3278
        Dec          41.5494
        Distance   2.617e+08  # method: T-F
        Radius     3.045e+04
        AbsMag        -19.42
        Axis    [  0.6886   0.7118  -0.1381]
        Angle    104.7929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1274"
}

Galaxy "NGC 1275:UGC 2669:MCG 7-7-63:ZWG 540.103"
{
        Type  "S0"
        RA            3.3300
        Dec          41.5114
        Distance   2.312e+08  # method: V
        Radius     7.735e+04
        AbsMag        -21.55
        Axis    [ -0.0037   0.9478  -0.3188]
        Angle    142.6059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1275"
}

Galaxy "NGC 1277:MCG 7-7-64:ZWG 540.104"
{
        Type  "Sa"
        RA            3.3308
        Dec          41.5742
        Distance   2.186e+08  # method: V
        Radius     2.544e+04
        AbsMag        -19.43
        Axis    [ -0.1351   0.9843  -0.1133]
        Angle    128.0605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1277"
}

Galaxy "NGC 1278:IC 1907:UGC 2670:MCG 7-7-65"
{
        Type  "E0"
        RA            3.3317
        Dec          41.5636
        Distance   2.617e+08  # method: T-F
        Radius     5.329e+04
        AbsMag        -20.92
        Axis    [  0.4147   0.8215  -0.3915]
        Angle    154.6866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1278"
}

Galaxy "NGC 1279:PGC 12449"
{
        Type  "S0"
        RA            3.3331
        Dec          41.4797
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.4565   0.7147   0.5299]
        Angle     99.0608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1279"
}

Galaxy "NGC 1280:UGC 2652:MCG 0-9-50:ZWG 390.51"
{
        Type  "SBc"
        RA            3.2992
        Dec          -0.1689
        Distance   3.032e+08  # method: V
        Radius     3.968e+04
        AbsMag        -20.74
        Axis    [  0.6700   0.7344  -0.1082]
        Angle    137.5535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1280"
}

Galaxy "NGC 1281:MCG 7-7-67:ZWG 540.108"
{
        Type  "E5"
        RA            3.3350
        Dec          41.6297
        Distance   1.832e+08  # method: V
        Radius     2.399e+04
        AbsMag        -18.95
        Axis    [  0.5647   0.7806  -0.2678]
        Angle    125.6612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1281"
}

Galaxy "NGC 1282:UGC 2675:MCG 7-7-68:ZWG 540.109"
{
        Type  "E0"
        RA            3.3367
        Dec          41.3669
        Distance   2.617e+08  # method: T-F
        Radius     4.568e+04
        AbsMag        -20.82
        Axis    [  0.7487   0.6599  -0.0632]
        Angle     95.8927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1282"
}

Galaxy "NGC 1283:UGC 2676:MCG 7-7-69:ZWG 540.110"
{
        Type  "E1"
        RA            3.3375
        Dec          41.3986
        Distance   2.617e+08  # method: T-F
        Radius     2.665e+04
        AbsMag        -19.72
        Axis    [  0.5364   0.7906  -0.2953]
        Angle    131.2360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1283"
}

Galaxy "NGC 1284:MCG 2-9-22:NPM 1"
{
        Type  "S0"
        RA            3.2958
        Dec         -10.2886
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.6480   0.7456   0.1551]
        Angle    142.0067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1284"
}

Galaxy "NGC 1285:MCG 1-9-26:IRAS 03154-0728"
{
        Type  "SBb"
        RA            3.2981
        Dec          -7.2975
        Distance   2.297e+08  # method: V
        Radius     5.012e+04
        AbsMag        -20.64
        Axis    [  0.6525   0.7489   0.1155]
        Angle    139.2336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1285"
}

Galaxy "NGC 1286:MCG 1-9-25:NPM 1"
{
        Type  "S0"
        RA            3.2967
        Dec          -7.6164
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.1971   0.6381  -0.7443]
        Angle    164.9020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1286"
}

Galaxy "NGC 1287:KUG 0316-029"
{
        Type  "Sa"
        RA            3.3092
        Dec          -2.7306
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.3369   0.6975  -0.6325]
        Angle    164.6162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1287"
}

Galaxy "NGC 1288:ESO 357-13:MCG 5-8-25:AM 0315-324"
{
        Type  "SBc"
        RA            3.2869
        Dec         -32.5764
        Distance   1.996e+08  # method: V
        Radius     6.675e+04
        AbsMag        -21.13
        Axis    [  0.2551   0.4065  -0.8773]
        Angle    168.5177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1288"
}

Galaxy "NGC 1289:IC 314:UGC 2666:MCG 0-9-54"
{
        Type  "S0"
        RA            3.3136
        Dec          -1.9731
        Distance   1.205e+08  # method: V
        Radius     3.154e+04
        AbsMag        -19.34
        Axis    [  0.3264   0.8581  -0.3963]
        Angle    142.4413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1289"
}

Galaxy "NGC 1290:NPM 1"
{
        Type  "E0"
        RA            3.3236
        Dec         -13.9892
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.7774   0.4781  -0.4088]
        Angle    165.0884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1290"
}

Galaxy "NGC 1292:ESO 418-1:MCG 5-8-26:IRAS 03161-2747"
{
        Type  "Sc"
        RA            3.3039
        Dec         -27.6106
        Distance   7.543e+07  # method: T-F
        Radius     3.291e+04
        AbsMag        -19.12
        Axis    [  0.6117   0.7172   0.3339]
        Angle    164.2176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1292"
}

Galaxy "NGC 1293:MCG 7-7-75:ZWG 540.116:NPM 1"
{
        Type  "E0"
        RA            3.3600
        Dec          41.3933
        Distance   2.617e+08  # method: T-F
        Radius     3.426e+04
        AbsMag        -20.02
        Axis    [  0.8529   0.5096   0.1137]
        Angle     80.9010
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1293"
}

Galaxy "NGC 1294:UGC 2694:MCG 7-7-76:ZWG 540.117"
{
        Type  "S0"
        RA            3.3611
        Dec          41.3606
        Distance   2.902e+08  # method: V
        Radius     4.643e+04
        AbsMag        -20.35
        Axis    [  0.5015   0.7049   0.5016]
        Angle     96.3633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1294"
}

Galaxy "NGC 1295:MCG 2-9-30:NPM 1:IRAS 03177-1410"
{
        Type  "S0"
        RA            3.3342
        Dec         -13.9978
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.0050   0.5105  -0.8598]
        Angle    155.2980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1295"
}

Galaxy "NGC 1296:MCG 2-9-25:IRAS 03164-1314"
{
        Type  "Sb"
        RA            3.3136
        Dec         -13.0622
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.7425   0.5592   0.3687]
        Angle    142.0809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1296"
}

Galaxy "NGC 1297:ESO 547-30:MCG 3-9-17"
{
        Type  "S0"
        RA            3.3206
        Dec         -19.1000
        Distance   9.321e+07  # method: S
        Radius     3.118e+04
        AbsMag        -19.48
        Axis    [  0.7636   0.5524   0.3342]
        Angle    147.2434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1297"
}

Galaxy "NGC 1298:UGC 2683:MCG 0-9-62:ZWG 390.63"
{
        Type  "E0"
        RA            3.3369
        Dec          -2.1136
        Distance   2.878e+08  # method: V
        Radius     4.605e+04
        AbsMag        -19.93
        Axis    [  0.7865   0.5353  -0.3079]
        Angle    151.1937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1298"
}

Galaxy "NGC 1299:MCG 1-9-28:KUG 0317-064:IRAS 03176-0626"
{
        Type  "Sb"
        RA            3.3358
        Dec          -6.2619
        Distance   1.223e+08  # distance uncertain!
        Radius     2.135e+04
        AbsMag        -19.07
        Axis    [  0.4948   0.8655   0.0787]
        Angle    139.5905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1299"
}

Galaxy "NGC 1300:ESO 547-31:MCG 3-9-18:UGCA 66"
{
        Type  "SBc"
        RA            3.3278
        Dec         -19.4114
        Distance   6.804e+07  # method: T-F
        Radius     6.136e+04
        AbsMag        -20.49
        Axis    [  0.4460   0.7450  -0.4961]
        Angle    149.0163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1300"
}

Galaxy "NGC 1301:ESO 547-32:MCG 3-9-22:IRAS 03183-1853"
{
        Type  "SBc"
        RA            3.3431
        Dec         -18.7158
        Distance   1.895e+08  # method: T-F
        Radius     6.065e+04
        AbsMag        -19.72
        Axis    [  0.0738   0.7435  -0.6647]
        Angle    129.8898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1301"
}

Galaxy "NGC 1302:ESO 481-20:MCG 4-8-58:IRAS 03177-2614"
{
        Type  "SBa"
        RA            3.3308
        Dec         -26.0606
        Distance   7.076e+07  # method: V
        Radius     4.014e+04
        AbsMag        -20.08
        Axis    [  0.8531   0.4147   0.3166]
        Angle    148.3773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1302"
}

Galaxy "NGC 1303:MCG 1-9-29:NPM 1"
{
        Type  "S0"
        RA            3.3444
        Dec          -7.3942
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.6759   0.7195   0.1599]
        Angle    138.5014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1303"
}

Galaxy "NGC 1304:NGC 1307:MCG 1-9-30:NPM 1"
{
        Type  "S0"
        RA            3.3533
        Dec          -4.5836
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.5184   0.8542   0.0396]
        Angle    137.8434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1304"
}

Galaxy "NGC 1305:UGC 2697:MCG 0-9-69:ZWG 390.72"
{
        Type  "S0"
        RA            3.3561
        Dec          -2.3164
        Distance   1.017e+08  # distance uncertain!
        Radius     2.219e+04
        AbsMag        -19.07
        Axis    [  0.2114   0.7619  -0.6123]
        Angle    151.5376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1305"
}

Galaxy "NGC 1306:ESO 481-23:IRAS 03188-2541"
{
        Type  "Sb"
        RA            3.3508
        Dec         -25.5122
        Distance   1.115e+08  # distance uncertain!
        Radius     1.298e+04
        AbsMag        -19.07
        Axis    [  0.9239   0.2736   0.2675]
        Angle    142.2848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1306"
}

Galaxy "NGC 1308:MCG 1-9-32"
{
        Type  "Sa"
        RA            3.3744
        Dec          -2.7572
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.5865   0.8055  -0.0844]
        Angle    137.3544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1308"
}

Galaxy "NGC 1309:MCG 3-9-28:IRAS 03197-1534"
{
        Type  "Sc"
        RA            3.3683
        Dec         -15.4000
        Distance   8.965e+07  # method: V
        Radius     2.999e+04
        AbsMag        -19.89
        Axis    [  0.8231   0.5633  -0.0726]
        Angle    145.7129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1309"
}

Galaxy "NGC 1310:ESO 357-19:MCG 6-8-4:IRAS 03191-3716"
{
        Type  "SBc"
        RA            3.3508
        Dec         -37.1022
        Distance    6.84e+07  # method: T-F
        Radius      1.89e+04
        AbsMag        -18.81
        Axis    [  0.6555   0.5965  -0.4631]
        Angle    159.1395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1310"
}

Galaxy "NGC 1311:ESO 200-7:IRAS 03186-5222"
{
        Type  "Irr"
        RA            3.3350
        Dec         -52.1872
        Distance   1.853e+07  # method: T-F
        Radius          8084
        AbsMag        -15.37
        Axis    [  0.6004   0.7997   0.0017]
        Angle    172.3966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1311"
}

Galaxy "NGC 1313:ESO 82-11:VV 436:AM 0317-664"
{
        Type  "SBc"
        RA            3.3044
        Dec         -66.4953
        Distance   1.898e+07  # method: V
        Radius      2.54e+04
        AbsMag        -19.02
        Axis    [  0.8768   0.4804  -0.0215]
        Angle    184.4931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1313"
}

Galaxy "NGC 1313A:ESO 83-1:IRAS 03195-6652"
{
        Type  "SBb"
        RA            3.3347
        Dec         -66.7019
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.6477   0.7617   0.0202]
        Angle    187.6856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1313A"
}

Galaxy "NGC 1314:MCG 1-9-33"
{
        Type  "Sc"
        RA            3.3781
        Dec          -4.1864
        Distance   1.645e+08  # method: V
        Radius      3.59e+04
        AbsMag        -18.61
        Axis    [  0.5942   0.6968  -0.4017]
        Angle    152.3484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1314"
}

Galaxy "NGC 1315:ESO 548-3:MCG 4-9-2:NPM 1"
{
        Type  "SBa"
        RA            3.3850
        Dec         -21.3747
        Distance   7.067e+07  # method: V
        Radius     1.645e+04
        AbsMag        -18.18
        Axis    [  0.7619   0.6339  -0.1326]
        Angle    150.3648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1315"
}

Galaxy "NGC 1316:ESO 357-22:MCG 6-8-8:ARP 154"
{
        Type  "S0"
        RA            3.3781
        Dec         -37.2078
        Distance   7.006e+07  # method: S
        Radius     1.121e+05
        AbsMag        -22.26
        Axis    [  0.7188   0.6914  -0.0729]
        Angle    159.2628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1316"
}

Galaxy "NGC 1316A:MCG 6-8-8:FCC 192:IRAS 03217-3704"
{
        Type  "Sa"
        RA            3.3936
        Dec         -36.9039
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.5943   0.7938  -0.1290]
        Angle    154.9052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1316A"
}

Galaxy "NGC 1316B:MCG 6-8-9"
{
        Type  "Sb"
        RA            3.3942
        Dec         -36.9086
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [  0.7723   0.5613   0.2974]
        Angle    165.3114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1316B"
}

Galaxy "NGC 1316C:ESO 357-27:MCG 6-8-12:FCC 33"
{
        Type  "S0"
        RA            3.4161
        Dec         -37.0092
        Distance   8.435e+07  # method: V
        Radius     1.963e+04
        AbsMag        -17.66
        Axis    [  0.5383   0.7716  -0.3391]
        Angle    148.2214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1316C"
}

Galaxy "NGC 1317:NGC 1318:ESO 357-23:MCG 6-8-6"
{
        Type  "SBa"
        RA            3.3789
        Dec         -37.1033
        Distance   8.272e+07  # method: V
        Radius     3.369e+04
        AbsMag        -20.02
        Axis    [  0.7513   0.5664  -0.3389]
        Angle    161.3079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1317"
}

Galaxy "NGC 1319:ESO 548-6:MCG 4-9-3"
{
        Type  "S0"
        RA            3.3989
        Dec         -21.5272
        Distance   1.773e+08  # method: V
        Radius     3.352e+04
        AbsMag        -19.78
        Axis    [  0.6249   0.7603   0.1771]
        Angle    152.1355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1319"
}

Galaxy "NGC 1320:MCG 1-9-36:MK 607:KUG 0322-032"
{
        Type  "Sa"
        RA            3.4133
        Dec          -3.0425
        Distance   1.017e+08  # distance uncertain!
        Radius     2.811e+04
        AbsMag        -19.07
        Axis    [  0.0453   0.7918  -0.6091]
        Angle    138.3297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1320"
}

Galaxy "NGC 1321:MCG 1-9-35:MK 608:KUG 0322-031"
{
        Type  "Sa"
        RA            3.4133
        Dec          -3.0153
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.3720   0.8874  -0.2722]
        Angle    137.6907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1321"
}

Galaxy "NGC 1322:MCG 1-9-37:NPM 1"
{
        Type  "S0"
        RA            3.4150
        Dec          -2.9186
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.3664   0.7573  -0.5406]
        Angle    152.8324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1322"
}

Galaxy "NGC 1323:NPM 1"
{
        Type  "S0"
        RA            3.4156
        Dec          -2.8217
        Distance   3.527e+08  # distance uncertain!
        Radius     4.617e+04
        AbsMag        -19.07
        Axis    [  0.2416   0.9437  -0.2261]
        Angle    133.6034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1323"
}

Galaxy "NGC 1324:MCG 1-9-38:IRAS 03225-0555"
{
        Type  "Sb"
        RA            3.4169
        Dec          -5.7453
        Distance     2.5e+08  # method: V
        Radius     7.636e+04
        AbsMag        -20.92
        Axis    [  0.0726   0.7807  -0.6207]
        Angle    138.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1324"
}

Galaxy "NGC 1325:ESO 548-7:MCG 4-9-4:UGCA 70"
{
        Type  "SBc"
        RA            3.4069
        Dec         -21.5431
        Distance   8.064e+07  # method: T-F
        Radius     5.629e+04
        AbsMag        -19.76
        Axis    [  0.4684   0.8829  -0.0325]
        Angle    146.4138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1325"
}

Galaxy "NGC 1325A:ESO 548-10:MCG 4-9-6:"
{
        Type  "SBb"
        RA            3.4133
        Dec         -21.3364
        Distance   1.017e+08  # distance uncertain!
        Radius     3.107e+04
        AbsMag        -19.07
        Axis    [  0.3700   0.5285  -0.7640]
        Angle    171.2535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1325A"
}

Galaxy "NGC 1326:ESO 357-26:MCG 6-8-11:IRAS 03220-3638"
{
        Type  "S0"
        RA            3.3989
        Dec         -36.4642
        Distance   5.817e+07  # method: T-F
        Radius     3.299e+04
        AbsMag        -19.75
        Axis    [  0.6962   0.6450  -0.3153]
        Angle    157.0689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1326"
}

Galaxy "NGC 1326A:ESO 357-28:MCG 6-8-13:AM 0323-363"
{
        Type  "Irr"
        RA            3.4189
        Dec         -36.3644
        Distance   7.792e+07  # method: V
        Radius     2.153e+04
        AbsMag        -18.09
        Axis    [  0.8396   0.5317  -0.1113]
        Angle    160.4526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1326A"
}

Galaxy "NGC 1326B:ESO 357-29:MCG 6-8-14:AM 0323-363"
{
        Type  "SBc"
        RA            3.4219
        Dec         -36.3844
        Distance   4.023e+07  # method: V
        Radius     2.106e+04
        AbsMag        -17.15
        Axis    [  0.3037   0.6898  -0.6573]
        Angle    133.6711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1326B"
}

Galaxy "NGC 1327:ESO 481-26:MCG 4-9-8:IRAS 03232-2551"
{
        Type  "SBb"
        RA            3.4231
        Dec         -25.6794
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [ -0.0107   0.4696  -0.8828]
        Angle    133.5309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1327"
}

Galaxy "NGC 1328:NPM 1"
{
        Type  "S0"
        RA            3.4275
        Dec          -4.1244
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.1684   0.7523  -0.6369]
        Angle    148.3400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1328"
}

Galaxy "NGC 1329:ESO 548-15:MCG 3-9-42"
{
        Type  "Sa"
        RA            3.4339
        Dec         -17.5917
        Distance    1.87e+08  # method: V
        Radius     3.808e+04
        AbsMag        -20.29
        Axis    [  0.7766   0.6283   0.0460]
        Angle    145.0616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1329"
}

Galaxy "NGC 1331:IC 324:ESO 548-19:MCG 4-9-12"
{
        Type  "E2"
        RA            3.4411
        Dec         -21.3556
        Distance   7.472e+07  # method: S
        Radius          9781
        AbsMag         -17.4
        Axis    [  0.9393   0.2634   0.2197]
        Angle    138.2098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1331"
}

Galaxy "NGC 1332:ESO 548-18:MCG 4-9-11:UGCA 72"
{
        Type  "S0"
        RA            3.4381
        Dec         -21.3344
        Distance   7.472e+07  # method: S
        Radius      4.89e+04
        AbsMag         -20.5
        Axis    [  0.2545   0.8181  -0.5158]
        Angle    134.6396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1332"
}

Galaxy "NGC 1334:UGC 2759:MCG 7-8-18:ZWG 541.17"
{
        Type  "Sc"
        RA            3.5003
        Dec          41.8325
        Distance   1.852e+08  # method: V
        Radius      4.04e+04
        AbsMag        -19.17
        Axis    [ -0.1694   0.9402  -0.2956]
        Angle    137.5545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1334"
}

Galaxy "NGC 1335:UGC 2762:MCG 7-8-19:ZWG 541.18"
{
        Type  "S0"
        RA            3.5053
        Dec          41.5733
        Distance     2.4e+08  # method: V
        Radius     3.839e+04
        AbsMag        -18.93
        Axis    [ -0.3177   0.7226  -0.6139]
        Angle    174.3495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1335"
}

Galaxy "NGC 1336:ESO 358-2:MCG 6-8-16:FCC 47"
{
        Type  "S0"
        RA            3.4422
        Dec         -35.7133
        Distance   6.158e+07  # method: S
        Radius     1.881e+04
        AbsMag        -18.28
        Axis    [  0.7656   0.6236   0.1578]
        Angle    161.9313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1336"
}

Galaxy "NGC 1337:MCG 2-9-42"
{
        Type  "SBc"
        RA            3.4681
        Dec          -8.3883
        Distance   6.265e+07  # method: T-F
        Radius     5.194e+04
        AbsMag        -18.82
        Axis    [ -0.0109   0.7440  -0.6680]
        Angle    132.5479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1337"
}

Galaxy "NGC 1338:MCG 2-9-44:IRAS 03265-1219"
{
        Type  "Sb"
        RA            3.4817
        Dec         -12.1531
        Distance   1.064e+08  # method: V
        Radius     2.166e+04
        AbsMag        -18.87
        Axis    [  0.7655   0.6256  -0.1501]
        Angle    144.2725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1338"
}

Galaxy "NGC 1339:ESO 418-4:MCG 5-9-4:FCC 63"
{
        Type  "E0"
        RA            3.4683
        Dec         -32.2856
        Distance   6.846e+07  # method: S
        Radius     1.494e+04
        AbsMag        -19.11
        Axis    [  0.3154   0.2982  -0.9009]
        Angle    202.1023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1339"
}

Galaxy "NGC 1341:ESO 358-8:MCG 6-8-20:IRAS 03260-3719"
{
        Type  "SBb"
        RA            3.4661
        Dec         -37.1494
        Distance   7.928e+07  # method: V
        Radius     1.384e+04
        AbsMag        -19.63
        Axis    [  0.7427   0.5024  -0.4427]
        Angle    164.2911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1341"
}

Galaxy "NGC 1343:UGC 2792:MCG 12-4-1:ZWG 327.5"
{
        Type  "SBb"
        RA            3.6303
        Dec          72.5714
        Distance   9.663e+07  # method: V
        Radius     3.654e+04
        AbsMag        -18.76
        Axis    [ -0.1981   0.9794   0.0380]
        Angle    115.1090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1343"
}

Galaxy "NGC 1344:NGC 1340:ESO 418-5:MCG 5-9-5"
{
        Type  "E5"
        RA            3.4719
        Dec         -31.0681
        Distance   6.448e+07  # method: S
        Radius     4.502e+04
        AbsMag        -20.08
        Axis    [  0.3656   0.3186  -0.8745]
        Angle    200.0991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1344"
}

Galaxy "NGC 1345:ESO 548-26:MCG 3-9-46:UGCA 74"
{
        Type  "SBc"
        RA            3.4919
        Dec         -17.7792
        Distance   6.279e+07  # method: V
        Radius      1.37e+04
        AbsMag        -17.22
        Axis    [  0.4594   0.7152  -0.5267]
        Angle    149.7989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1345"
}

Galaxy "NGC 1346:MCG 1-9-42:KUG 0327-057:IRAS 03277-0542"
{
        Type  "Sb"
        RA            3.5036
        Dec          -5.5431
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.4716   0.8230  -0.3167]
        Angle    140.7404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1346"
}

Galaxy "NGC 1347-1:ESO 548-27:MCG 4-9-17:VV 23"
{
        Type  "SBc"
        RA            3.4947
        Dec         -22.2792
        Distance   7.425e+07  # method: V
        Radius      1.62e+04
        AbsMag        -18.09
        Axis    [  0.8126   0.5348   0.2317]
        Angle    147.6762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1347-1"
}

Galaxy "NGC 1347-2:ESO 548-27:MCG 4-9-17:VV 23"
{
        Type  "S0"
        RA            3.4947
        Dec         -22.2908
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.7040   0.6795   0.2068]
        Angle    151.2419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1347-2"
}

Galaxy "NGC 1349:UGC 2774:MCG 1-9-6:ZWG 416.13"
{
        Type  "S0"
        RA            3.5242
        Dec           4.3814
        Distance   2.914e+08  # method: V
        Radius      3.39e+04
        AbsMag        -20.55
        Axis    [  0.9124   0.3494   0.2133]
        Angle    113.8700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1349"
}

Galaxy "NGC 1350:ESO 358-13:MCG 6-8-23:AM 0329-334"
{
        Type  "SBb"
        RA            3.5186
        Dec         -33.6272
        Distance   7.846e+07  # method: T-F
        Radius     6.733e+04
        AbsMag         -20.7
        Axis    [  0.1318   0.4339  -0.8913]
        Angle    143.8833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1350"
}

Galaxy "NGC 1351:ESO 358-12:MCG 6-8-22:FCC 83"
{
        Type  "S0"
        RA            3.5094
        Dec         -34.8533
        Distance   6.846e+07  # method: S
        Radius     2.788e+04
        AbsMag        -19.11
        Axis    [  0.3422   0.5573  -0.7565]
        Angle    147.5197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1351"
}

Galaxy "NGC 1351A:ESO 358-9:MCG 6-8-21:FCC 67"
{
        Type  "SBc"
        RA            3.4800
        Dec         -35.1778
        Distance   7.864e+07  # method: T-F
        Radius     2.974e+04
        AbsMag        -17.71
        Axis    [  0.2251   0.7292  -0.6462]
        Angle    125.5295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1351A"
}

Galaxy "NGC 1352:ESO 548-30:MCG 3-10-2:NPM 1"
{
        Type  "S0"
        RA            3.5256
        Dec         -19.2778
        Distance   1.916e+08  # method: V
        Radius     2.786e+04
        AbsMag        -19.54
        Axis    [  0.4112   0.7006  -0.5831]
        Angle    149.2507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1352"
}

Galaxy "NGC 1353:ESO 548-31:MCG 4-9-22:UGCA 76"
{
        Type  "SBb"
        RA            3.5342
        Dec         -20.8189
        Distance   9.115e+07  # method: T-F
        Radius     4.507e+04
        AbsMag        -19.93
        Axis    [  0.1840   0.6961  -0.6940]
        Angle    137.3257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1353"
}

Galaxy "NGC 1354:MCG 3-10-4:IRAS 03301-1523"
{
        Type  "Sa"
        RA            3.5414
        Dec         -15.2208
        Distance   7.524e+07  # method: V
        Radius     2.517e+04
        AbsMag        -18.61
        Axis    [  0.0528   0.6708  -0.7398]
        Angle    135.5830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1354"
}

Galaxy "NGC 1355:MCG 1-10-2"
{
        Type  "S0"
        RA            3.5564
        Dec          -4.9983
        Distance    1.54e+08  # distance uncertain!
        Radius     3.359e+04
        AbsMag        -19.07
        Axis    [  0.2521   0.9564  -0.1477]
        Angle    131.9037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1355"
}

Galaxy "NGC 1356:ESO 200-31:AM 0329-502:IRAS 03291-5028"
{
        Type  "SBc"
        RA            3.5111
        Dec         -50.3092
        Distance   5.162e+08  # method: V
        Radius     1.276e+05
        AbsMag         -22.2
        Axis    [  0.2192   0.3140  -0.9238]
        Angle    139.6766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1356"
}

Galaxy "NGC 1357:MCG 2-10-1:IRAS 03309-1349"
{
        Type  "Sb"
        RA            3.5547
        Dec         -13.6644
        Distance   8.421e+07  # method: V
        Radius      3.92e+04
        AbsMag        -19.66
        Axis    [  0.5510   0.7574  -0.3504]
        Angle    144.8878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1357"
}

Galaxy "NGC 1358:MCG 1-10-3"
{
        Type  "SBa"
        RA            3.5608
        Dec          -5.0889
        Distance   1.752e+08  # method: V
        Radius     5.352e+04
        AbsMag        -20.65
        Axis    [  0.6613   0.6452   0.3825]
        Angle    138.1415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1358"
}

Galaxy "NGC 1359:ESO 548-39:MCG 3-10-7:IRAS 03315-1939"
{
        Type  "Irr"
        RA            3.5631
        Dec         -19.4908
        Distance   1.538e+08  # method: T-F
        Radius     5.591e+04
        AbsMag        -20.77
        Axis    [  0.2424   0.6525  -0.7180]
        Angle    146.7954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1359"
}

Galaxy "NGC 1361:MCG 1-10-5:NPM 1"
{
        Type  "E0"
        RA            3.5714
        Dec          -6.2644
        Distance   3.312e+08  # distance uncertain!
        Radius     7.706e+04
        AbsMag        -20.13
        Axis    [  0.8985   0.4259  -0.1067]
        Angle    137.0940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1361"
}

Galaxy "NGC 1362:ESO 548-41:MCG 3-10-8:NPM 1"
{
        Type  "S0"
        RA            3.5647
        Dec         -20.2822
        Distance   4.979e+07  # method: V
        Radius          8689
        AbsMag        -17.22
        Axis    [  0.8434   0.4736   0.2537]
        Angle    143.7893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1362"
}

Galaxy "NGC 1363:IRAS 03324-1000"
{
        Type  "Sc"
        RA            3.5803
        Dec          -9.8422
        Distance   1.281e+08  # distance uncertain!
        Radius     1.676e+04
        AbsMag        -19.07
        Axis    [  0.6104   0.7609  -0.2203]
        Angle    141.1777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1363"
}

Galaxy "NGC 1364"
{
        Type  "Sc"
        RA            3.5831
        Dec          -9.8389
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.9270   0.2976   0.2281]
        Angle    126.9925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1364"
}

Galaxy "NGC 1365:ESO 358-17:MCG 6-8-26:VV 825"
{
        Type  "SBb"
        RA            3.5600
        Dec         -36.1408
        Distance   4.657e+07  # method: T-F
        Radius     7.451e+04
        AbsMag        -20.47
        Axis    [  0.6998   0.7098   0.0800]
        Angle    160.5832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1365"
}

Galaxy "NGC 1366:ESO 418-10:MCG 5-9-13"
{
        Type  "S0"
        RA            3.5647
        Dec         -31.1933
        Distance   6.878e+07  # method: S
        Radius     2.101e+04
        AbsMag        -19.62
        Axis    [  0.6254   0.6994   0.3460]
        Angle    167.8018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1366"
}

Galaxy "NGC 1368:MCG 3-10-12:NPM 1"
{
        Type  "Sa"
        RA            3.5828
        Dec         -15.6556
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.3158   0.8180  -0.4807]
        Angle    137.5204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1368"
}

Galaxy "NGC 1369:ESO 358-34:MCG 6-9-4:FCC 176"
{
        Type  "SBa"
        RA            3.6125
        Dec         -36.2556
        Distance   5.948e+07  # method: V
        Radius     1.298e+04
        AbsMag         -17.5
        Axis    [  0.8877   0.4187   0.1915]
        Angle    157.8828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1369"
}

Galaxy "NGC 1370:ESO 548-48:MCG 3-10-13:IRAS 03330-2032"
{
        Type  "E0"
        RA            3.5872
        Dec         -20.3733
        Distance   4.263e+07  # method: V
        Radius          9300
        AbsMag        -17.18
        Axis    [  0.9099   0.3730  -0.1813]
        Angle    151.9160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1370"
}

Galaxy "NGC 1371:NGC 1367:ESO 482-10:MCG 4-9-29"
{
        Type  "SBa"
        RA            3.5836
        Dec         -24.9333
        Distance   6.093e+07  # method: V
        Radius     4.963e+04
        AbsMag        -19.76
        Axis    [  0.3377   0.6078  -0.7187]
        Angle    151.4295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1371"
}

Galaxy "NGC 1372:NPM 1"
{
        Type  "E0"
        RA            3.6164
        Dec         -15.8817
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.9418   0.2528   0.2215]
        Angle    131.9272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1372"
}

Galaxy "NGC 1373:ESO 358-21:MCG 6-8-28:FCC 143"
{
        Type  "E0"
        RA            3.5831
        Dec         -35.1711
        Distance   7.404e+07  # method: S
        Radius     1.292e+04
        AbsMag        -18.38
        Axis    [  0.6006   0.3162  -0.7344]
        Angle    188.2658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1373"
}

Galaxy "NGC 1374:ESO 358-23:MCG 6-8-29:AM 0333-352"
{
        Type  "E0"
        RA            3.5878
        Dec         -35.2258
        Distance   6.448e+07  # method: S
        Radius     2.532e+04
        AbsMag        -19.48
        Axis    [  0.6433   0.3191  -0.6959]
        Angle    186.0114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1374"
}

Galaxy "NGC 1375:ESO 358-24:MCG 6-8-30:AM 0333-352"
{
        Type  "S0"
        RA            3.5878
        Dec         -35.2658
        Distance   6.752e+07  # method: S
        Radius     2.259e+04
        AbsMag        -18.38
        Axis    [  0.4897   0.7819  -0.3856]
        Angle    142.6986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1375"
}

Galaxy "NGC 1376:MCG 1-10-11:IRAS 03346-0512"
{
        Type  "Sc"
        RA            3.6183
        Dec          -5.0428
        Distance   1.819e+08  # method: V
        Radius     5.555e+04
        AbsMag        -20.93
        Axis    [  0.5515   0.7049  -0.4460]
        Angle    149.7927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1376"
}

Galaxy "NGC 1377:ESO 548-51:MCG 4-9-33:IRAS 03344-2103"
{
        Type  "S0"
        RA            3.6108
        Dec         -20.9014
        Distance   7.534e+07  # method: V
        Radius     1.972e+04
        AbsMag        -18.42
        Axis    [  0.4430   0.8130  -0.3779]
        Angle    140.0845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1377"
}

Galaxy "NGC 1379:ESO 358-27:MCG 6-9-1:FCC 161"
{
        Type  "E0"
        RA            3.6008
        Dec         -35.4408
        Distance   6.538e+07  # method: S
        Radius     2.282e+04
        AbsMag        -19.81
        Axis    [  0.9661   0.2360   0.1047]
        Angle    154.1601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1379"
}

Galaxy "NGC 1380:ESO 358-28:MCG 6-9-2:AM 0334-350"
{
        Type  "S0"
        RA            3.6075
        Dec         -34.9753
        Distance   5.747e+07  # method: S
        Radius     3.343e+04
        AbsMag        -20.33
        Axis    [  0.7173   0.6376   0.2810]
        Angle    165.3047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1380"
}

Galaxy "NGC 1380A:ESO 358-33:MCG 6-9-6:FCC 177"
{
        Type  "S0"
        RA            3.6131
        Dec         -34.7397
        Distance   5.169e+07  # method: S
        Radius     1.804e+04
        AbsMag         -17.7
        Axis    [  0.0200   0.4005  -0.9161]
        Angle    127.4330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1380A"
}

Galaxy "NGC 1381:ESO 358-29:MCG 6-9-3:FCC 170"
{
        Type  "S0"
        RA            3.6086
        Dec         -35.2953
        Distance   5.881e+07  # method: S
        Radius     2.224e+04
        AbsMag        -18.78
        Axis    [  0.2465   0.6451  -0.7232]
        Angle    129.9871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1381"
}

Galaxy "NGC 1382:NGC 1380B:ESO 358-37:MCG 6-9-9"
{
        Type  "S0"
        RA            3.6192
        Dec         -35.1956
        Distance    7.37e+07  # method: S
        Radius     1.608e+04
        AbsMag        -17.87
        Axis    [  0.8504   0.5190   0.0860]
        Angle    157.9883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1382"
}

Galaxy "NGC 1383:ESO 548-53:MCG 3-10-15"
{
        Type  "S0"
        RA            3.6275
        Dec         -18.3394
        Distance   8.363e+07  # method: V
        Radius     2.311e+04
        AbsMag        -18.54
        Axis    [  0.3916   0.8523  -0.3469]
        Angle    137.0108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1383"
}

Galaxy "NGC 1384:MCG 3-10-3:ZWG 465.4"
{
        Type  "Sc"
        RA            3.6536
        Dec          15.8194
        Distance   4.376e+08  # method: V
        Radius     5.728e+04
        AbsMag        -20.14
        Axis    [ -0.0086   0.8283  -0.5603]
        Angle    144.9638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1384"
}

Galaxy "NGC 1385:ESO 482-16:MCG 4-9-36:AM 0335-244"
{
        Type  "SBc"
        RA            3.6244
        Dec         -24.5028
        Distance   4.779e+07  # method: T-F
        Radius     2.502e+04
        AbsMag        -19.23
        Axis    [  0.0852   0.4659  -0.8807]
        Angle    151.1068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1385"
}

Galaxy "NGC 1386:ESO 358-35:MCG 6-9-5:IRAS 03348-3609"
{
        Type  "Sa"
        RA            3.6128
        Dec         -35.9989
        Distance   5.388e+07  # method: S
        Radius     2.664e+04
        AbsMag        -18.99
        Axis    [  0.6206   0.7693   0.1517]
        Angle    163.7308
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1386"
}

Galaxy "NGC 1387:ESO 358-36:MCG 6-9-7:IRAS 03350-3540"
{
        Type  "S0"
        RA            3.6158
        Dec         -35.5058
        Distance   6.629e+07  # method: S
        Radius       2.7e+04
        AbsMag        -19.74
        Axis    [  0.5890   0.4594  -0.6649]
        Angle    167.3591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1387"
}

Galaxy "NGC 1388:NPM 1"
{
        Type  "E0"
        RA            3.6367
        Dec         -15.8994
        Distance   3.163e+08  # distance uncertain!
        Radius      3.22e+04
        AbsMag        -20.13
        Axis    [  0.9428   0.2507   0.2197]
        Angle    131.9003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1388"
}

Galaxy "NGC 1389:ESO 358-38:MCG 6-9-10:FCC 193"
{
        Type  "S0"
        RA            3.6197
        Dec         -35.7456
        Distance    7.07e+07  # method: S
        Radius     2.365e+04
        AbsMag        -19.28
        Axis    [  0.6837   0.7232   0.0980]
        Angle    160.5422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1389"
}

Galaxy "NGC 1390:ESO 548-54:MCG 3-10-17"
{
        Type  "SBa"
        RA            3.6311
        Dec         -19.0075
        Distance   4.911e+07  # method: V
        Radius          9999
        AbsMag        -15.99
        Axis    [  0.5853   0.7701   0.2539]
        Angle    151.6777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1390"
}

Galaxy "NGC 1391:ESO 548-59:MCG 3-10-20:NPM 1"
{
        Type  "S0"
        RA            3.6478
        Dec         -18.3544
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.4841   0.8658  -0.1265]
        Angle    140.1578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1391"
}

Galaxy "NGC 1393:ESO 548-58:MCG 3-10-19"
{
        Type  "S0"
        RA            3.6439
        Dec         -18.4286
        Distance   9.309e+07  # method: V
        Radius     2.302e+04
        AbsMag        -19.28
        Axis    [  0.1080   0.4871  -0.8667]
        Angle    163.4931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1393"
}

Galaxy "NGC 1394:ESO 548-60:MCG 3-10-21"
{
        Type  "S0"
        RA            3.6517
        Dec         -18.2922
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [  0.5328   0.7579   0.3765]
        Angle    158.4800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1394"
}

Galaxy "NGC 1395:ESO 482-19:MCG 4-9-39:AM 0336-231"
{
        Type  "E2"
        RA            3.6414
        Dec         -23.0272
        Distance    7.86e+07  # method: S
        Radius     5.716e+04
        AbsMag        -21.11
        Axis    [  0.6278   0.4138  -0.6592]
        Angle    181.1569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1395"
}

Galaxy "NGC 1396:FCC 202"
{
        Type  "S0"
        RA            3.6350
        Dec         -35.4397
        Distance   3.592e+07  # method: V
        Radius          3657
        AbsMag        -15.41
        Axis    [  0.5722   0.7097  -0.4110]
        Angle    147.5566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1396"
}

Galaxy "NGC 1397:MCG 1-10-17"
{
        Type  "SBa"
        RA            3.6631
        Dec          -4.6697
        Distance   1.768e+08  # distance uncertain!
        Radius     4.371e+04
        AbsMag        -19.07
        Axis    [  0.3744   0.7968  -0.4743]
        Angle    142.5718
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1397"
}

Galaxy "NGC 1398:ESO 482-22:MCG 4-9-40:AM 0336-263"
{
        Type  "SBb"
        RA            3.6478
        Dec         -26.3372
        Distance   5.844e+07  # method: V
        Radius      6.12e+04
        AbsMag        -20.66
        Axis    [  0.5428   0.6786  -0.4949]
        Angle    148.9944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1398"
}

Galaxy "NGC 1399:ESO 358-45:MCG 6-9-12:AM 0336-353"
{
        Type  "E1"
        RA            3.6411
        Dec         -35.4497
        Distance   6.508e+07  # method: S
        Radius     6.531e+04
        AbsMag         -21.1
        Axis    [  0.8717   0.3091  -0.3803]
        Angle    170.4092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1399"
}

Galaxy "NGC 1400:ESO 548-62:MCG 3-10-22:IRAS 03372-1850"
{
        Type  "S0"
        RA            3.6583
        Dec         -18.6881
        Distance   8.619e+07  # method: S
        Radius     3.134e+04
        AbsMag        -20.21
        Axis    [  0.7738   0.6334  -0.0108]
        Angle    144.3280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1400"
}

Galaxy "NGC 1401:ESO 482-26:MCG 4-9-42"
{
        Type  "S0"
        RA            3.6558
        Dec         -22.7244
        Distance   6.455e+07  # method: V
        Radius     2.253e+04
        AbsMag        -18.38
        Axis    [  0.1596   0.7660  -0.6228]
        Angle    127.2484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1401"
}

Galaxy "NGC 1402:ESO 548-61:MCG 3-10-23:IRAS 03372-1841"
{
        Type  "S0"
        RA            3.6583
        Dec         -18.5269
        Distance    1.54e+08  # distance uncertain!
        Radius     1.792e+04
        AbsMag        -19.07
        Axis    [  0.5673   0.7245  -0.3915]
        Angle    146.0389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1402"
}

Galaxy "NGC 1403:ESO 482-25:MCG 4-9-41:NPM 1"
{
        Type  "S0"
        RA            3.6528
        Dec         -22.3889
        Distance   1.648e+08  # method: T-F
        Radius     2.157e+04
        AbsMag        -19.82
        Axis    [  0.1775   0.4902  -0.8534]
        Angle    161.7414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1403"
}

Galaxy "NGC 1404:ESO 358-46:MCG 6-9-13:FCC 219"
{
        Type  "E1"
        RA            3.6475
        Dec         -35.5928
        Distance   6.846e+07  # method: S
        Radius     3.286e+04
        AbsMag        -20.61
        Axis    [  0.3732   0.2830  -0.8835]
        Angle    197.3389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1404"
}

Galaxy "NGC 1405:MCG 3-10-28"
{
        Type  "S0"
        RA            3.6719
        Dec         -15.5308
        Distance   2.226e+08  # distance uncertain!
        Radius     4.855e+04
        AbsMag        -19.07
        Axis    [  0.0267   0.6519  -0.7578]
        Angle    133.2685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1405"
}

Galaxy "NGC 1406:ESO 418-15:MCG 5-9-20:UGCA 83"
{
        Type  "SBc"
        RA            3.6564
        Dec         -31.3222
        Distance   6.985e+07  # method: T-F
        Radius     3.962e+04
        AbsMag        -19.15
        Axis    [  0.4952   0.8285   0.2613]
        Angle    167.5758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1406"
}

Galaxy "NGC 1407:ESO 548-67:MCG 3-10-30"
{
        Type  "E0"
        RA            3.6697
        Dec         -18.5803
        Distance   9.407e+07  # method: S
        Radius     6.294e+04
        AbsMag         -21.6
        Axis    [  0.9363   0.3438  -0.0717]
        Angle    144.6816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1407"
}

Galaxy "NGC 1409:UGC 2821:MCG 0-10-11:ZWG 391.28"
{
        Type  "S0"
        RA            3.6861
        Dec          -1.3019
        Distance   3.336e+08  # method: V
        Radius     4.853e+04
        AbsMag        -20.35
        Axis    [  0.2678   0.7244  -0.6353]
        Angle    154.2481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1409"
}

Galaxy "NGC 1410:UGC 2821:MCG 0-10-12:ZWG 391.28"
{
        Type  "E0"
        RA            3.6861
        Dec          -1.2986
        Distance   3.344e+08  # method: V
        Radius     3.404e+04
        AbsMag        -20.05
        Axis    [  0.5466   0.5700  -0.6135]
        Angle    175.0699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1410"
}

Galaxy "NGC 1411:IC 1943:MCG 7-8-4:ESO 249-11"
{
        Type  "S0"
        RA            3.6456
        Dec         -44.1006
        Distance   6.448e+07  # method: S
        Radius     1.688e+04
        AbsMag        -19.18
        Axis    [  0.8177   0.5177   0.2519]
        Angle    169.5750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1411"
}

Galaxy "NGC 1412:IC 1981:ESO 482-29:MCG 5-9-21"
{
        Type  "S0"
        RA            3.6747
        Dec         -26.8619
        Distance   7.588e+07  # method: V
        Radius     1.987e+04
        AbsMag        -18.33
        Axis    [  0.2521   0.7006  -0.6675]
        Angle    134.0790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1412"
}

Galaxy "NGC 1413:NPM 1"
{
        Type  "E0"
        RA            3.6697
        Dec         -15.6103
        Distance   3.981e+08  # distance uncertain!
        Radius     5.791e+04
        AbsMag        -20.13
        Axis    [  0.8794   0.4079  -0.2454]
        Angle    150.7447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1413"
}

Galaxy "NGC 1414:ESO 548-71:MCG 4-9-45"
{
        Type  "SBc"
        RA            3.6825
        Dec         -21.7133
        Distance   7.629e+07  # method: T-F
        Radius     1.664e+04
        AbsMag        -17.24
        Axis    [ -0.0878   0.5212  -0.8489]
        Angle    122.7934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1414"
}

Galaxy "NGC 1415:IC 1983:ESO 482-33:MCG 4-9-47"
{
        Type  "Sa"
        RA            3.6822
        Dec         -22.5642
        Distance   6.628e+07  # method: V
        Radius      3.47e+04
        AbsMag        -18.74
        Axis    [  0.1588   0.6207  -0.7678]
        Angle    139.0482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1415"
}

Galaxy "NGC 1416:ESO 482-34:MCG 4-9-48:NPM 1"
{
        Type  "E1"
        RA            3.6839
        Dec         -22.7192
        Distance   9.269e+07  # method: V
        Radius     1.618e+04
        AbsMag        -18.17
        Axis    [  0.9476   0.2274   0.2245]
        Angle    138.2540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1416"
}

Galaxy "NGC 1417:MCG 1-10-21:IRAS 03394-0451"
{
        Type  "SBb"
        RA            3.6992
        Dec          -4.7053
        Distance   1.878e+08  # method: T-F
        Radius     6.281e+04
        AbsMag         -20.9
        Axis    [  0.6025   0.6731   0.4288]
        Angle    141.9126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1417"
}

Galaxy "NGC 1418:MCG 1-10-22"
{
        Type  "SBb"
        RA            3.7044
        Dec          -4.7317
        Distance   1.832e+08  # method: V
        Radius     2.664e+04
        AbsMag        -19.35
        Axis    [  0.6293   0.7184   0.2966]
        Angle    136.8569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1418"
}

Galaxy "NGC 1419:ESO 301-23:MCG 6-9-17:AM 0338-374"
{
        Type  "E0"
        RA            3.6783
        Dec         -37.5111
        Distance   6.272e+07  # method: S
        Radius          8211
        AbsMag        -17.92
        Axis    [  0.9513   0.1896   0.2430]
        Angle    152.3088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1419"
}

Galaxy "NGC 1421:MCG 2-10-8:IRAS 03401-1338"
{
        Type  "SBc"
        RA            3.7081
        Dec         -13.4878
        Distance   9.273e+07  # method: T-F
        Radius     4.586e+04
        AbsMag        -20.07
        Axis    [  0.4806   0.7602   0.4371]
        Angle    158.8489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1421"
}

Galaxy "NGC 1422:ESO 548-77:MCG 4-9-51:IRAS 03393-2150"
{
        Type  "SBb"
        RA            3.6919
        Dec         -21.6808
        Distance   5.731e+07  # method: T-F
        Radius     1.917e+04
        AbsMag        -17.22
        Axis    [  0.4156   0.9037  -0.1024]
        Angle    139.9085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1422"
}

Galaxy "NGC 1423:MCG 1-10-25"
{
        Type  "SBa"
        RA            3.7111
        Dec          -6.3817
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.6625   0.7170   0.2168]
        Angle    135.9943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1423"
}

Galaxy "NGC 1424:MCG 1-10-26:IRAS 03407-0453"
{
        Type  "SBb"
        RA            3.7206
        Dec          -4.7303
        Distance   2.492e+08  # method: V
        Radius     5.798e+04
        AbsMag        -19.81
        Axis    [  0.5196   0.7686   0.3733]
        Angle    143.1060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1424"
}

Galaxy "NGC 1425:ESO 419-4:MCG 5-9-23:UGCA 84"
{
        Type  "Sb"
        RA            3.7031
        Dec         -29.8942
        Distance    7.37e+07  # method: T-F
        Radius     6.218e+04
        AbsMag        -20.37
        Axis    [  0.3004   0.6798  -0.6691]
        Angle    135.9187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1425"
}

Galaxy "NGC 1426:ESO 549-1:MCG 4-9-54:AM 0340-221"
{
        Type  "E4"
        RA            3.7136
        Dec         -22.1078
        Distance    7.86e+07  # method: S
        Radius     2.972e+04
        AbsMag        -19.61
        Axis    [  0.6711   0.4175  -0.6126]
        Angle    176.4553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1426"
}

Galaxy "NGC 1427:ESO 358-52:MCG 6-9-21:FCC 276"
{
        Type  "E0"
        RA            3.7053
        Dec         -35.3928
        Distance   7.681e+07  # method: S
        Radius     4.245e+04
        AbsMag        -20.06
        Axis    [  0.8699   0.3060  -0.3868]
        Angle    169.9576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1427"
}

Galaxy "NGC 1427A:ESO 358-49:MCG 6-9-16:AM 0338-354"
{
        Type  "Irr"
        RA            3.6692
        Dec         -35.6233
        Distance   8.739e+07  # method: V
        Radius     2.923e+04
        AbsMag        -18.74
        Axis    [  0.6573   0.6858  -0.3123]
        Angle    151.3279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1427A"
}

Galaxy "NGC 1428:ESO 358-53:MCG 6-9-22:FCC 277"
{
        Type  "S0"
        RA            3.7061
        Dec         -35.1539
        Distance   6.945e+07  # method: V
        Radius     1.111e+04
        AbsMag        -17.84
        Axis    [  0.4349   0.6514  -0.6217]
        Angle    142.5417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1428"
}

Galaxy "NGC 1431:UGC 2845:MCG 0-10-17:ZWG 391.33"
{
        Type  "S0"
        RA            3.7444
        Dec           2.8356
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.0686   0.6480  -0.7585]
        Angle    166.1015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1431"
}

Galaxy "NGC 1433:ESO 249-14:AM 0340-472:IRAS 03404-4722"
{
        Type  "SBa"
        RA            3.7003
        Dec         -47.2219
        Distance   4.517e+07  # method: V
        Radius      4.27e+04
        AbsMag           -20
        Axis    [  0.7253   0.4192  -0.5461]
        Angle    166.5096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1433"
}

Galaxy "NGC 1434"
{
        Type  "Sa"
        RA            3.7700
        Dec          -9.6831
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.0281   0.5756  -0.8173]
        Angle    152.9107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1434"
}

Galaxy "NGC 1436:NGC 1437:ESO 358-58:MCG 6-9-25"
{
        Type  "SBb"
        RA            3.7269
        Dec         -35.8542
        Distance   6.999e+07  # method: T-F
        Radius     3.156e+04
        AbsMag        -19.16
        Axis    [  0.2871   0.4888  -0.8238]
        Angle    147.5497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1436"
}

Galaxy "NGC 1437A:ESO 358-54:MCG 6-9-24:FCC 285"
{
        Type  "SBc"
        RA            3.7172
        Dec         -36.2731
        Distance   3.629e+07  # method: V
        Radius          9500
        AbsMag        -16.23
        Axis    [  0.7169   0.5688  -0.4032]
        Angle    156.6434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1437A"
}

Galaxy "NGC 1437B:ESO 358-61:MCG 6-9-29:IRAS 03440-3630"
{
        Type  "Sc"
        RA            3.7650
        Dec         -36.3586
        Distance   6.356e+07  # method: V
        Radius     2.403e+04
        AbsMag        -17.65
        Axis    [  0.5993   0.7434   0.2971]
        Angle    172.1960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1437B"
}

Galaxy "NGC 1438:ESO 482-41:MCG 4-9-58"
{
        Type  "SBa"
        RA            3.7547
        Dec         -23.0022
        Distance   1.147e+08  # method: T-F
        Radius     3.337e+04
        AbsMag        -19.53
        Axis    [  0.5211   0.8325  -0.1882]
        Angle    140.8984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1438"
}

Galaxy "NGC 1439:ESO 549-9:MCG 4-9-56"
{
        Type  "E1"
        RA            3.7469
        Dec         -21.9203
        Distance   8.698e+07  # method: S
        Radius     3.036e+04
        AbsMag        -19.83
        Axis    [  0.9534   0.3017  -0.0099]
        Angle    144.5159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1439"
}

Galaxy "NGC 1440:NGC 1442:ESO 549-10:MCG 3-10-43"
{
        Type  "S0"
        RA            3.7506
        Dec         -18.2664
        Distance   6.261e+07  # method: V
        Radius     2.003e+04
        AbsMag        -18.82
        Axis    [  0.7330   0.6698   0.1183]
        Angle    144.0198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1440"
}

Galaxy "NGC 1441:MCG 1-10-29"
{
        Type  "SBb"
        RA            3.7619
        Dec          -4.0917
        Distance   1.853e+08  # method: V
        Radius     4.581e+04
        AbsMag        -19.87
        Axis    [  0.2902   0.9109  -0.2933]
        Angle    130.4860
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1441"
}

Galaxy "NGC 1445"
{
        Type  "E0"
        RA            3.7489
        Dec          -9.8558
        Distance   3.468e+08  # distance uncertain!
        Radius     4.539e+04
        AbsMag        -20.13
        Axis    [  0.9467   0.3111   0.0835]
        Angle    129.9231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1445"
}

Galaxy "NGC 1447:NPM 1"
{
        Type  "S0"
        RA            3.7631
        Dec          -9.0183
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [  0.3005   0.8401  -0.4515]
        Angle    134.8027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1447"
}

Galaxy "NGC 1448:NGC 1457:ESO 249-16:MCG 7-8-5"
{
        Type  "Sc"
        RA            3.7419
        Dec         -44.6458
        Distance   6.242e+07  # method: T-F
        Radius       6.9e+04
        AbsMag        -20.01
        Axis    [  0.5548   0.8319   0.0025]
        Angle    162.3781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1448"
}

Galaxy "NGC 1449:MCG 1-10-32"
{
        Type  "S0"
        RA            3.7675
        Dec          -4.1381
        Distance     1.8e+08  # method: V
        Radius     2.095e+04
        AbsMag        -19.21
        Axis    [  0.6359   0.7362   0.2316]
        Angle    134.4149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1449"
}

Galaxy "NGC 1450-1"
{
        Type  "S0"
        RA            3.7600
        Dec          -9.2347
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6903   0.7230   0.0274]
        Angle    136.2504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1450-1"
}

Galaxy "NGC 1450-2"
{
        Type  "E0"
        RA            3.7600
        Dec          -9.2328
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.9456   0.2568   0.1999]
        Angle    125.3291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1450-2"
}

Galaxy "NGC 1451:MCG 1-10-33"
{
        Type  "S0"
        RA            3.7686
        Dec          -4.0692
        Distance   1.717e+08  # method: V
        Radius     1.998e+04
        AbsMag        -19.21
        Axis    [  0.6142   0.7769   0.1386]
        Angle    133.3366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1451"
}

Galaxy "NGC 1452:NGC 1455:ESO 549-12:MCG 3-10-44"
{
        Type  "SBa"
        RA            3.7561
        Dec         -18.6331
        Distance   7.334e+07  # method: V
        Radius     2.987e+04
        AbsMag        -18.96
        Axis    [  0.3454   0.7623  -0.5473]
        Angle    138.5519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1452"
}

Galaxy "NGC 1453:MCG 1-10-34"
{
        Type  "E2"
        RA            3.7742
        Dec          -3.9689
        Distance   1.892e+08  # method: T-F
        Radius     6.606e+04
        AbsMag        -21.22
        Axis    [  0.8822   0.4382  -0.1722]
        Angle    136.5768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1453"
}

Galaxy "NGC 1459:ESO 482-43:MCG 4-10-1:IRAS 03448-2540"
{
        Type  "SBc"
        RA            3.7825
        Dec         -25.5214
        Distance   1.752e+08  # method: T-F
        Radius     4.331e+04
        AbsMag        -20.05
        Axis    [  0.1145   0.4718  -0.8742]
        Angle    150.7049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1459"
}

Galaxy "NGC 1460:ESO 358-62:MCG 6-9-31:AM 0344-365"
{
        Type  "S0"
        RA            3.7703
        Dec         -36.6967
        Distance   5.676e+07  # method: V
        Radius     1.156e+04
        AbsMag         -17.7
        Axis    [  0.7298   0.6462  -0.2230]
        Angle    153.8184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1460"
}

Galaxy "NGC 1461:MCG 3-10-47"
{
        Type  "S0"
        RA            3.8075
        Dec         -16.3928
        Distance   5.857e+07  # method: V
        Radius     2.556e+04
        AbsMag        -18.47
        Axis    [  0.0006   0.6388  -0.7693]
        Angle    129.4874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1461"
}

Galaxy "NGC 1462:MCG 1-10-10:ZWG 417.7"
{
        Type  "S0"
        RA            3.8397
        Dec           6.9731
        Distance   3.663e+08  # method: V
        Radius     4.795e+04
        AbsMag        -20.05
        Axis    [  0.4767   0.8768   0.0635]
        Angle    124.9592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1462"
}

Galaxy "NGC 1463:ESO 117-9:IRAS 03453-5957"
{
        Type  "Sa"
        RA            3.7708
        Dec         -59.8103
        Distance    1.47e+08  # distance uncertain!
        Radius      2.78e+04
        AbsMag        -19.07
        Axis    [  0.9247   0.3597  -0.1249]
        Angle    176.3968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1463"
}

Galaxy "NGC 1464:NGC 1471:IRAS 03491-1533"
{
        Type  "S0"
        RA            3.8567
        Dec         -15.4022
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.7122   0.7014  -0.0275]
        Angle    139.8847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1464"
}

Galaxy "NGC 1465:UGC 2891:MCG 5-10-3:ZWG 508.4"
{
        Type  "Sa"
        RA            3.8919
        Dec          32.4928
        Distance   9.762e+07  # method: V
        Radius     2.414e+04
        AbsMag        -17.68
        Axis    [ -0.3809   0.7103  -0.5920]
        Angle    148.9012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1465"
}

Galaxy "NGC 1467:MCG 2-10-15:NPM 1"
{
        Type  "Sa"
        RA            3.8644
        Dec          -8.8378
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.5892   0.8046  -0.0745]
        Angle    134.5943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1467"
}

Galaxy "NGC 1468:MCG 1-10-45:NPM 1"
{
        Type  "S0"
        RA            3.8700
        Dec          -6.3486
        Distance    2.33e+08  # distance uncertain!
        Radius     4.067e+04
        AbsMag        -19.07
        Axis    [  0.1949   0.7149  -0.6715]
        Angle    145.7554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1468"
}

Galaxy "NGC 1469:UGC 2909:MCG 11-5-4:ZWG 305.3"
{
        Type  "S0"
        RA            4.0075
        Dec          68.5775
        Distance    1.47e+08  # distance uncertain!
        Radius     4.063e+04
        AbsMag        -19.07
        Axis    [ -0.4785   0.8167  -0.3225]
        Angle    159.9821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1469"
}

Galaxy "NGC 1470:MCG 2-10-16:IRAS 03497-0908"
{
        Type  "Sb"
        RA            3.8692
        Dec          -9.0000
        Distance   2.873e+08  # method: V
        Radius     5.431e+04
        AbsMag        -19.72
        Axis    [ -0.1642   0.5796  -0.7982]
        Angle    128.2270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1470"
}

Galaxy "NGC 1472:NPM 1"
{
        Type  "S0"
        RA            3.8964
        Dec          -8.5681
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.6580   0.7024  -0.2713]
        Angle    138.9939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1472"
}

Galaxy "NGC 1473:ESO 54-19:AM 0347-682:IRAS 03472-6822"
{
        Type  "Irr"
        RA            3.7906
        Dec         -68.2206
        Distance   6.637e+07  # method: T-F
        Radius     1.448e+04
        AbsMag        -17.94
        Axis    [  0.7960   0.6020  -0.0636]
        Angle    181.8804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1473"
}

Galaxy "NGC 1474:IC 2002:UGC 2898:MCG 2-10-3"
{
        Type  "SBa"
        RA            3.9083
        Dec          10.7069
        Distance   2.309e+08  # method: V
        Radius     3.693e+04
        AbsMag        -19.45
        Axis    [  0.8052   0.4974   0.3227]
        Angle    112.9621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1474"
}

Galaxy "NGC 1476:ESO 249-24:MCG 7-9-1:AM 0350-444"
{
        Type  "Sa"
        RA            3.8689
        Dec         -44.5322
        Distance   1.341e+08  # distance uncertain!
        Radius     2.731e+04
        AbsMag        -19.07
        Axis    [  0.5798   0.7141  -0.3922]
        Angle    145.3641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1476"
}

Galaxy "NGC 1477:NPM 1"
{
        Type  "E0"
        RA            3.9006
        Dec          -8.5744
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.2419   0.4909  -0.8369]
        Angle    199.9967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1477"
}

Galaxy "NGC 1478:NPM 1"
{
        Type  "S0"
        RA            3.9019
        Dec          -8.5550
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.5271   0.8497  -0.0117]
        Angle    133.7503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1478"
}

Galaxy "NGC 1481:ESO 549-32:MCG 3-10-53:NPM 1"
{
        Type  "S0"
        RA            3.9078
        Dec         -20.4267
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.3094   0.6313  -0.7112]
        Angle    147.0108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1481"
}

Galaxy "NGC 1482:ESO 549-33:MCG 3-10-54:IRAS 03524-2038"
{
        Type  "Sa"
        RA            3.9106
        Dec         -20.5019
        Distance   7.515e+07  # method: V
        Radius     2.623e+04
        AbsMag        -18.71
        Axis    [  0.4297   0.7552  -0.4951]
        Angle    138.3987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1482"
}

Galaxy "NGC 1483:ESO 201-7:IRAS 03512-4737"
{
        Type  "SBc"
        RA            3.8797
        Dec         -47.4783
        Distance   4.883e+07  # method: V
        Radius     1.136e+04
        AbsMag        -17.78
        Axis    [  0.5633   0.3864  -0.7303]
        Angle    162.7384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1483"
}

Galaxy "NGC 1484:ESO 359-6:MCG 6-9-36:AM 0352-370"
{
        Type  "Sb"
        RA            3.9047
        Dec         -36.9708
        Distance   6.868e+07  # method: T-F
        Radius     2.497e+04
        AbsMag        -18.02
        Axis    [  0.4614   0.8405  -0.2842]
        Angle    138.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1484"
}

Galaxy "NGC 1485:UGC 2933:MCG 12-4-10:ZWG 327.14"
{
        Type  "Sb"
        RA            4.0842
        Dec          70.9967
        Distance   4.584e+07  # method: V
        Radius       1.4e+04
        AbsMag        -17.14
        Axis    [  0.0115   0.7576   0.6526]
        Angle     90.6013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1485"
}

Galaxy "NGC 1486:ESO 549-37:MCG 4-10-8"
{
        Type  "SBc"
        RA            3.9383
        Dec         -21.8208
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.6879   0.6412   0.3401]
        Angle    153.8131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1486"
}

Galaxy "NGC 1487:ESO 249-31:MCG 7-9-2:VV 78"
{
        Type  "Irr"
        RA            3.9292
        Dec         -42.3678
        Distance   3.452e+07  # method: V
        Radius     1.205e+04
        AbsMag        -17.92
        Axis    [  0.7708   0.6114  -0.1789]
        Angle    157.1644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1487"
}

Galaxy "NGC 1489:ESO 549-42:MCG 3-11-3"
{
        Type  "SBb"
        RA            3.9606
        Dec         -19.2172
        Distance   5.142e+08  # method: V
        Radius     1.047e+05
        AbsMag        -21.39
        Axis    [  0.6196   0.7295   0.2896]
        Angle    151.1740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1489"
}

Galaxy "NGC 1490:ESO 83-11:AM 0353-661"
{
        Type  "E1"
        RA            3.8928
        Dec         -66.0181
        Distance   2.437e+08  # method: V
        Radius     4.607e+04
        AbsMag        -20.97
        Axis    [  0.5519   0.0402  -0.8329]
        Angle    191.7164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1490"
}

Galaxy "NGC 1492:ESO 359-12:IRAS 03563-3535"
{
        Type  "Sa"
        RA            3.9703
        Dec         -35.4458
        Distance   2.036e+08  # method: V
        Radius     2.665e+04
        AbsMag        -19.68
        Axis    [  0.8237   0.5282   0.2063]
        Angle    159.0476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1492"
}

Galaxy "NGC 1493:ESO 249-33:AM 0355-462:IRAS 03558-4621"
{
        Type  "SBc"
        RA            3.9575
        Dec         -46.2117
        Distance   4.507e+07  # method: V
        Radius     1.836e+04
        AbsMag         -18.9
        Axis    [  0.9582   0.1734   0.2275]
        Angle    161.0574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1493"
}

Galaxy "NGC 1494:ESO 201-12:IRAS 03562-4902"
{
        Type  "SBc"
        RA            3.9617
        Dec         -48.9094
        Distance   6.596e+07  # method: T-F
        Radius     3.166e+04
        AbsMag        -19.23
        Axis    [  0.1394   0.2565  -0.9564]
        Angle    141.0395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1494"
}

Galaxy "NGC 1495:ESO 249-34:MCG 7-9-4:AM 0356-443"
{
        Type  "Sc"
        RA            3.9725
        Dec         -44.4658
        Distance    6.22e+07  # method: T-F
        Radius     2.714e+04
        AbsMag         -18.1
        Axis    [  0.4012   0.7735  -0.4907]
        Angle    128.4892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1495"
}

Galaxy "NGC 1497:UGC 2929:MCG 4-10-8:ZWG 487.9"
{
        Type  "S0"
        RA            4.0350
        Dec          23.1333
        Distance    2.74e+08  # method: V
        Radius     5.978e+04
        AbsMag        -20.32
        Axis    [  0.2724   0.9607   0.0537]
        Angle    114.9011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1497"
}

Galaxy "NGC 1500:ESO 201-13:AM 0356-522"
{
        Type  "S0"
        RA            3.9706
        Dec         -52.3283
        Distance   4.499e+08  # method: V
        Radius     7.198e+04
        AbsMag           -21
        Axis    [  0.6901   0.4346  -0.5787]
        Angle    160.0903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1500"
}

Galaxy "NGC 1503:ESO 83-13:IRAS 03561-6611"
{
        Type  "SBa"
        RA            3.9425
        Dec         -66.0406
        Distance   1.612e+08  # distance uncertain!
        Radius      2.11e+04
        AbsMag        -19.07
        Axis    [  0.5164   0.2476  -0.8197]
        Angle    155.9132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1503"
}

Galaxy "NGC 1504:MCG 2-11-8:NPM 1"
{
        Type  "S0"
        RA            4.0414
        Dec          -9.3350
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.7279   0.6578   0.1936]
        Angle    135.1291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1504"
}

Galaxy "NGC 1505:MCG 2-11-9:NPM 1"
{
        Type  "S0"
        RA            4.0433
        Dec          -9.3219
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.5737   0.7462  -0.3377]
        Angle    136.9597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1505"
}

Galaxy "NGC 1506:ESO 156-27"
{
        Type  "S0"
        RA            4.0058
        Dec         -52.5733
        Distance    5.13e+08  # method: V
        Radius     8.953e+04
        AbsMag        -21.58
        Axis    [  0.7536   0.5093  -0.4156]
        Angle    159.5034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1506"
}

Galaxy "NGC 1507:UGC 2947:MCG 0-11-9:MK 1080"
{
        Type  "Irr"
        RA            4.0742
        Dec          -2.1886
        Distance   4.444e+07  # method: T-F
        Radius     2.327e+04
        AbsMag        -17.77
        Axis    [  0.4892   0.7792   0.3918]
        Angle    141.0605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1507"
}

Galaxy "NGC 1508:MCG 4-10-21:ZWG 487.21:NPM 1"
{
        Type  "Sc"
        RA            4.0964
        Dec          25.4092
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6831   0.7093   0.1740]
        Angle    103.1732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1508"
}

Galaxy "NGC 1509:IC 2026:MCG 2-11-13:MK 1079"
{
        Type  "Sa"
        RA            4.0653
        Dec         -11.1786
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.7045   0.7036  -0.0927]
        Angle    134.9448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1509"
}

Galaxy "NGC 1510:ESO 250-3:MCG 7-9-6:IRAS 04019-4332"
{
        Type  "S0"
        RA            4.0589
        Dec         -43.3997
        Distance   4.222e+07  # method: V
        Radius     1.965e+04
        AbsMag        -17.16
        Axis    [  0.6113   0.6470  -0.4558]
        Angle    145.6619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1510"
}

Galaxy "NGC 1511:ESO 55-4:AM 0359-674:IRAS 03594-6746"
{
        Type  "Sa"
        RA            3.9933
        Dec         -67.6347
        Distance   5.771e+07  # method: T-F
        Radius     2.938e+04
        AbsMag        -19.34
        Axis    [  0.5406   0.4625  -0.7027]
        Angle    135.8025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1511"
}

Galaxy "NGC 1511A:ESO 55-5:IRAS 04001-6756"
{
        Type  "SBa"
        RA            4.0053
        Dec         -67.8072
        Distance   5.857e+07  # method: T-F
        Radius     1.533e+04
        AbsMag        -16.97
        Axis    [  0.5515   0.5995  -0.5801]
        Angle    134.2847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1511A"
}

Galaxy "NGC 1511B:ESO 55-6:FGCE 368"
{
        Type  "SBc"
        RA            4.0150
        Dec         -67.6119
        Distance    2.33e+08  # distance uncertain!
        Radius     6.101e+04
        AbsMag        -19.07
        Axis    [  0.5810   0.6752  -0.4545]
        Angle    142.6647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1511B"
}

Galaxy "NGC 1512:ESO 250-4:MCG 7-9-7:AM 0402-433"
{
        Type  "SBa"
        RA            4.0650
        Dec         -43.3489
        Distance   4.874e+07  # method: T-F
        Radius      6.31e+04
        AbsMag        -19.77
        Axis    [  0.6351   0.6156  -0.4665]
        Angle    147.9011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1512"
}

Galaxy "NGC 1515:ESO 156-36:AM 0402-541:IRAS 04028-5414"
{
        Type  "SBc"
        RA            4.0672
        Dec         -54.1000
        Distance   6.695e+07  # method: T-F
        Radius     5.259e+04
        AbsMag        -19.46
        Axis    [  0.6313   0.7674   0.1116]
        Angle    178.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1515"
}

Galaxy "NGC 1515A:ESO 156-34:FAIR 397"
{
        Type  "SBb"
        RA            4.0639
        Dec         -54.1131
        Distance   5.993e+08  # method: V
        Radius     8.716e+04
        AbsMag        -20.92
        Axis    [  0.4214   0.3058  -0.8537]
        Angle    155.0701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1515A"
}

Galaxy "NGC 1516-1:NGC 1524:NGC 1516A:MCG 2-11-17"
{
        Type  "SBc"
        RA            4.1353
        Dec          -8.8294
        Distance   7.038e+07  # distance uncertain!
        Radius     1.433e+04
        AbsMag        -19.07
        Axis    [  0.6082   0.7886  -0.0908]
        Angle    131.5281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1516-1"
}

Galaxy "NGC 1517:UGC 2970:ZWG 418.13:IRAS 04064+0831"
{
        Type  "Sc"
        RA            4.1531
        Dec           8.6489
        Distance   1.529e+08  # method: V
        Radius     2.447e+04
        AbsMag        -19.16
        Axis    [  0.8300   0.4661   0.3064]
        Angle    113.7508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1517"
}

Galaxy "NGC 1518:ESO 550-7:MCG 4-10-13:IRAS 04046-2118"
{
        Type  "SBc"
        RA            4.1136
        Dec         -21.1794
        Distance   3.244e+07  # method: T-F
        Radius     1.368e+04
        AbsMag        -17.69
        Axis    [  0.6352   0.7682   0.0803]
        Angle    143.5146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1518"
}

Galaxy "NGC 1519:ESO 550-9:MCG 3-11-13:IRAS 04058-1719"
{
        Type  "SBb"
        RA            4.1353
        Dec         -17.1928
        Distance   8.598e+07  # method: T-F
        Radius     2.626e+04
        AbsMag         -18.5
        Axis    [  0.2403   0.8519  -0.4653]
        Angle    123.6690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1519"
}

Galaxy "NGC 1521:ESO 550-11:MCG 4-10-15"
{
        Type  "E0"
        RA            4.1383
        Dec         -21.0517
        Distance   2.195e+08  # method: S
        Radius      8.62e+04
        AbsMag        -21.54
        Axis    [  0.9707   0.2209   0.0947]
        Angle    137.9530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1521"
}

Galaxy "NGC 1522:ESO 156-38:FAIR 301:AM 0404-524"
{
        Type  "S0"
        RA            4.1019
        Dec         -52.6694
        Distance   4.417e+07  # method: V
        Radius          7709
        AbsMag        -16.76
        Axis    [  0.8099   0.5773  -0.1037]
        Angle    165.8570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1522"
}

Galaxy "NGC 1525:NGC 1516B:NGC 1516-2:MCG 2-11-18"
{
        Type  "Sc"
        RA            4.1356
        Dec          -8.8347
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.3108   0.6884  -0.6554]
        Angle    146.0738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1525"
}

Galaxy "NGC 1526:ESO 84-3:IRAS 04048-6558"
{
        Type  "SBc"
        RA            4.0867
        Dec         -65.8400
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.8770   0.4726  -0.0869]
        Angle    178.9481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1526"
}

Galaxy "NGC 1527:ESO 201-20"
{
        Type  "S0"
        RA            4.1400
        Dec         -47.8967
        Distance   5.881e+07  # method: S
        Radius     3.336e+04
        AbsMag        -19.58
        Axis    [  0.6068   0.7143  -0.3487]
        Angle    145.2922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1527"
}

Galaxy "NGC 1529:ESO 84-4:DRCG 46-18"
{
        Type  "S0"
        RA            4.1219
        Dec         -62.8994
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.2772   0.3233  -0.9048]
        Angle    113.2793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1529"
}

Galaxy "NGC 1530:UGC 3013:MCG 13-4-4:ZWG 327.17"
{
        Type  "SBb"
        RA            4.3906
        Dec          75.2944
        Distance   1.089e+08  # method: V
        Radius     6.969e+04
        AbsMag        -20.32
        Axis    [  0.1119   0.8050   0.5826]
        Angle     76.3804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1530"
}

Galaxy "NGC 1531:ESO 359-26:MCG 5-11-1:AM 0410-325"
{
        Type  "S0"
        RA            4.1997
        Dec         -32.8508
        Distance   5.096e+07  # method: V
        Radius          8895
        AbsMag        -18.27
        Axis    [  0.4551   0.5524  -0.6983]
        Angle    146.8355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1531"
}

Galaxy "NGC 1532:ESO 359-27:MCG 5-11-2:AM 0410-330"
{
        Type  "SBb"
        RA            4.2008
        Dec         -32.8731
        Distance   6.206e+07  # method: T-F
        Radius     1.047e+05
        AbsMag        -20.79
        Axis    [  0.5918   0.8024   0.0773]
        Angle    152.9240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1532"
}

Galaxy "NGC 1533:ESO 157-3:AM 0408-561:IRAS 04088-5614"
{
        Type  "S0"
        RA            4.1642
        Dec         -56.1178
        Distance   6.973e+07  # method: S
        Radius      2.84e+04
        AbsMag        -19.95
        Axis    [  0.3903   0.2603  -0.8831]
        Angle    155.8989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1533"
}

Galaxy "NGC 1534:ESO 84-6:AM 0408-625:DRCG 46-23"
{
        Type  "Sa"
        RA            4.1461
        Dec         -62.7972
        Distance   2.409e+08  # method: V
        Radius     5.956e+04
        AbsMag        -20.54
        Axis    [  0.7072   0.5936  -0.3841]
        Angle    156.4420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1534"
}

Galaxy "NGC 1536:ESO 157-5:AM 0409-563:IRAS 04099-5636"
{
        Type  "SBc"
        RA            4.1833
        Dec         -56.4825
        Distance   6.972e+07  # method: V
        Radius     2.129e+04
        AbsMag        -18.35
        Axis    [  0.3455   0.2793  -0.8959]
        Angle    146.6096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1536"
}

Galaxy "NGC 1537:ESO 420-12:MCG 5-11-5:AM 0411-314"
{
        Type  "S0"
        RA            4.2278
        Dec         -31.6456
        Distance   7.576e+07  # method: S
        Radius     4.297e+04
        AbsMag        -20.33
        Axis    [  0.5535   0.6500  -0.5207]
        Angle    141.5236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1537"
}

Galaxy "NGC 1538:IC 2047:NPM 1"
{
        Type  "S0"
        RA            4.2489
        Dec         -13.1914
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.8264   0.4772   0.2990]
        Angle    136.8553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1538"
}

Galaxy "NGC 1539-1:ZWG 488.1:ZW 373"
{
        Type  "E0"
        RA            4.3169
        Dec          26.8275
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.9506   0.2919   0.1055]
        Angle     89.5117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1539-1"
}

Galaxy "NGC 1539-2:ZWG 488.1:ZW 373"
{
        Type  "E0"
        RA            4.3172
        Dec          26.8294
        Distance   1.148e+09  # distance uncertain!
        Radius      5.01e+04
        AbsMag        -20.13
        Axis    [  0.9506   0.2919   0.1055]
        Angle     89.5090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1539-2"
}

Galaxy "NGC 1540:ESO 420-14:AM 0413-283:IRAS 04131-2836"
{
        Type  "Sa"
        RA            4.2528
        Dec         -28.4828
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.2469   0.5468  -0.8000]
        Angle    140.4966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1540"
}

Galaxy "NGC 1540A:ESO 420-14A"
{
        Type  "Sb"
        RA            4.2528
        Dec         -28.4794
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.6371   0.7109  -0.2980]
        Angle    140.5371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1540A"
}

Galaxy "NGC 1541:UGC 3001:MCG 0-11-40:ZWG 392.13"
{
        Type  "Sa"
        RA            4.2833
        Dec           0.8353
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.2910   0.9314  -0.2186]
        Angle    120.9999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1541"
}

Galaxy "NGC 1542:UGC 3003:MCG 1-11-16:ZWG 418.17"
{
        Type  "Sb"
        RA            4.2872
        Dec           4.7819
        Distance   1.639e+08  # method: V
        Radius     3.098e+04
        AbsMag         -18.6
        Axis    [  0.0059   0.8387  -0.5446]
        Angle    125.4951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1542"
}

Galaxy "NGC 1543:ESO 118-10:AM 0411-575:IRAS 04117-5751"
{
        Type  "S0"
        RA            4.2119
        Dec         -57.7372
        Distance   6.538e+07  # method: S
        Radius     3.613e+04
        AbsMag        -20.21
        Axis    [  0.7128   0.4503  -0.5378]
        Angle    157.1952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1543"
}

Galaxy "NGC 1544:UGC 3160:MCG 14-3-6:ZWG 361.11"
{
        Type  "S0"
        RA            5.0433
        Dec          86.2228
        Distance   2.029e+08  # method: V
        Radius     3.836e+04
        AbsMag        -19.47
        Axis    [ -0.3462   0.9349  -0.0788]
        Angle    137.5821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1544"
}

Galaxy "NGC 1546:ESO 157-12:AM 0413-561:IRAS 04134-5611"
{
        Type  "Sa"
        RA            4.2433
        Dec         -56.0603
        Distance   5.146e+07  # method: V
        Radius     2.395e+04
        AbsMag        -19.09
        Axis    [  0.3759   0.3519  -0.8572]
        Angle    138.4110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1546"
}

Galaxy "NGC 1547:ESO 550-18:MCG 3-11-20:PGC 14794"
{
        Type  "SBc"
        RA            4.2867
        Dec         -17.8575
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.1827   0.7026  -0.6877]
        Angle    129.1701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1547"
}

Galaxy "NGC 1549:ESO 157-16:AM 0414-554"
{
        Type  "E0"
        RA            4.2625
        Dec         -55.5914
        Distance   6.419e+07  # method: S
        Radius     4.574e+04
        AbsMag        -20.87
        Axis    [  0.5546   0.1280  -0.8222]
        Angle    187.4673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1549"
}

Galaxy "NGC 1551:NGC 1550:UGC 3012:MCG 0-11-55"
{
        Type  "S0"
        RA            4.3272
        Dec           2.4094
        Distance    1.63e+08  # method: V
        Radius     5.215e+04
        AbsMag        -20.39
        Axis    [  0.7796   0.6237   0.0568]
        Angle    120.8872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1551"
}

Galaxy "NGC 1552:UGC 3015:MCG 0-12-7:ZWG 393.5"
{
        Type  "Sa"
        RA            4.3381
        Dec          -0.6925
        Distance   2.191e+08  # method: V
        Radius     5.735e+04
        AbsMag        -20.14
        Axis    [  0.2971   0.8036  -0.5158]
        Angle    131.8719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1552"
}

Galaxy "NGC 1553:ESO 157-17:AM 0415-555:IRAS 04150-5554"
{
        Type  "S0"
        RA            4.2694
        Dec         -55.7794
        Distance   6.046e+07  # method: S
        Radius     3.957e+04
        AbsMag        -21.34
        Axis    [  0.3566   0.3303  -0.8739]
        Angle    139.6587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1553"
}

Galaxy "NGC 1556:ESO 202-4:AM 0416-501:IRAS 04163-5017"
{
        Type  "Sb"
        RA            4.2956
        Dec         -50.1642
        Distance   6.677e+07  # method: T-F
        Radius     1.651e+04
        AbsMag        -18.06
        Axis    [  0.1520   0.3613  -0.9200]
        Angle    116.2024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1556"
}

Galaxy "NGC 1558:ESO 250-17:AM 0418-450:IRAS 04187-4508"
{
        Type  "SBc"
        RA            4.3375
        Dec         -45.0311
        Distance   2.298e+08  # method: T-F
        Radius     8.356e+04
        AbsMag        -20.94
        Axis    [  0.6206   0.7208  -0.3088]
        Angle    144.0140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1558"
}

Galaxy "NGC 1559:ESO 84-10:AM 0417-625"
{
        Type  "SBc"
        RA            4.2933
        Dec         -62.7839
        Distance   6.002e+07  # method: T-F
        Radius     3.056e+04
        AbsMag        -20.22
        Axis    [  0.7686   0.5565  -0.3156]
        Angle    162.3851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1559"
}

Galaxy "NGC 1560:UGC 3060:MCG 12-5-5:ZWG 328.6"
{
        Type  "Sc"
        RA            4.5464
        Dec          71.8794
        Distance   1.468e+07  # method: T-F
        Radius     2.092e+04
        AbsMag        -16.16
        Axis    [ -0.0270   0.6699   0.7420]
        Angle     96.6808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1560"
}

Galaxy "NGC 1561:MCG 3-12-6:NPM 1"
{
        Type  "S0"
        RA            4.3836
        Dec         -15.8453
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.0096   0.4725  -0.8813]
        Angle    153.9894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1561"
}

Galaxy "NGC 1562:NPM 1"
{
        Type  "S0"
        RA            4.3631
        Dec         -15.7553
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.9654   0.2013   0.1659]
        Angle    130.9160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1562"
}

Galaxy "NGC 1563:MCG 3-12-5:NPM 1:IRAS 04204-1546"
{
        Type  "E0"
        RA            4.3814
        Dec         -15.7328
        Distance   5.496e+08  # distance uncertain!
        Radius     5.595e+04
        AbsMag        -20.13
        Axis    [  0.7845   0.4008  -0.4732]
        Angle    154.6277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1563"
}

Galaxy "NGC 1564:NPM 1"
{
        Type  "S0"
        RA            4.3833
        Dec         -15.7389
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.7719   0.6171   0.1532]
        Angle    137.9672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1564"
}

Galaxy "NGC 1565:MCG 3-12-7"
{
        Type  "Sc"
        RA            4.3897
        Dec         -15.7447
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.0921   0.4763  -0.8745]
        Angle    166.7913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1565"
}

Galaxy "NGC 1566:ESO 157-20:IRAS 04189-5503"
{
        Type  "SBc"
        RA            4.3333
        Dec         -54.9372
        Distance   3.013e+07  # method: T-F
        Radius     3.593e+04
        AbsMag        -19.62
        Axis    [  0.8338   0.4681  -0.2927]
        Angle    163.3636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1566"
}

Galaxy "NGC 1567:ESO 202-10:AM 0419-482"
{
        Type  "E0"
        RA            4.3522
        Dec         -48.2547
        Distance   2.045e+08  # method: V
        Radius     3.867e+04
        AbsMag        -21.49
        Axis    [  0.9762   0.1167   0.1825]
        Angle    162.1217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1567"
}

Galaxy "NGC 1568-1:UGC 3031:MCG 0-12-26:ZWG 393.16"
{
        Type  "Sa"
        RA            4.4056
        Dec          -0.7381
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.2090   0.6987  -0.6842]
        Angle    146.2541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1568-1"
}

Galaxy "NGC 1568-2:UGC 3032:MCG 0-12-27:ZWG 393.16"
{
        Type  "Sa"
        RA            4.4069
        Dec          -0.7461
        Distance   2.107e+08  # method: V
        Radius     3.372e+04
        AbsMag        -18.05
        Axis    [  0.1700   0.7189  -0.6740]
        Angle    141.6802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1568-2"
}

Galaxy "NGC 1569:UGC 3056:MCG 11-6-1:ZWG 306.1"
{
        Type  "Irr"
        RA            4.5136
        Dec          64.8481
        Distance   7.944e+07  # distance uncertain!
        Radius     4.275e+04
        AbsMag        -20.13
        Axis    [ -0.3354   0.9294  -0.1539]
        Angle    129.7873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1569"
}

Galaxy "NGC 1570:NGC 1571:ESO 250-19:MCG 7-10-1"
{
        Type  "E0"
        RA            4.3689
        Dec         -43.6300
        Distance   1.975e+08  # method: V
        Radius     4.309e+04
        AbsMag        -20.61
        Axis    [  0.2416   0.2034  -0.9488]
        Angle    192.3311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1570"
}

Galaxy "NGC 1572:ESO 303-14:MCG 7-10-3:AM 0421-404"
{
        Type  "SBa"
        RA            4.3783
        Dec         -40.6011
        Distance   2.287e+08  # method: T-F
        Radius     7.984e+04
        AbsMag        -20.83
        Axis    [  0.7388   0.6208   0.2622]
        Angle    169.2324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1572"
}

Galaxy "NGC 1573:UGC 3077:MCG 12-5-8:ZWG 328.9"
{
        Type  "E0"
        RA            4.5844
        Dec          73.2631
        Distance    2.02e+08  # method: T-F
        Radius     5.581e+04
        AbsMag        -21.06
        Axis    [  0.5641   0.8017  -0.1978]
        Angle     68.8111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1573"
}

Galaxy "NGC 1573A:UGC 3150:MCG 12-5-20:ZWG 328.21"
{
        Type  "SBc"
        RA            4.8072
        Dec          73.4694
        Distance   2.017e+08  # method: V
        Radius     4.694e+04
        AbsMag        -19.16
        Axis    [ -0.2862   0.9001  -0.3284]
        Angle    170.5051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1573A"
}

Galaxy "NGC 1574:ESO 157-22:AM 0421-570"
{
        Type  "S0"
        RA            4.3661
        Dec         -56.9744
        Distance   6.478e+07  # method: S
        Radius     3.769e+04
        AbsMag        -20.19
        Axis    [  0.5113   0.2538  -0.8211]
        Angle    162.6885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1574"
}

Galaxy "NGC 1575:NGC 1577:MCG 2-12-14:IRAS 04239-1012"
{
        Type  "SBa"
        RA            4.4389
        Dec         -10.0989
        Distance   1.065e+08  # distance uncertain!
        Radius     2.324e+04
        AbsMag        -19.07
        Axis    [  0.3287   0.6262  -0.7070]
        Angle    149.8659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1575"
}

Galaxy "NGC 1576:MCG 1-12-7"
{
        Type  "S0"
        RA            4.4383
        Dec          -3.6208
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.1935   0.7516  -0.6306]
        Angle    133.9422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1576"
}

Galaxy "NGC 1578:ESO 202-14:FAIR 771:AM 0422-514"
{
        Type  "Sa"
        RA            4.3961
        Dec         -51.5994
        Distance   2.757e+08  # method: V
        Radius     4.811e+04
        AbsMag        -20.73
        Axis    [  0.1693   0.1756  -0.9698]
        Angle    165.6429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1578"
}

Galaxy "NGC 1580:MCG 1-12-11:IRAS 04258-0517"
{
        Type  "Sc"
        RA            4.4717
        Dec          -5.1792
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.5398   0.6792  -0.4973]
        Angle    138.3183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1580"
}

Galaxy "NGC 1581:ESO 157-26:IRAS 04236-5503"
{
        Type  "S0"
        RA            4.4122
        Dec         -54.9422
        Distance    6.84e+07  # method: V
        Radius     1.791e+04
        AbsMag        -18.11
        Axis    [  0.6374   0.6563  -0.4038]
        Angle    145.1589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1581"
}

Galaxy "NGC 1583:ESO 551-8:MCG 3-12-10:NPM 1"
{
        Type  "S0"
        RA            4.4722
        Dec         -17.5961
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [  0.9698   0.1865   0.1570]
        Angle    132.5273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1583"
}

Galaxy "NGC 1584:ESO 551-6:NPM 1"
{
        Type  "S0"
        RA            4.4694
        Dec         -17.5239
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.9697   0.1869   0.1572]
        Angle    132.4612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1584"
}

Galaxy "NGC 1585:ESO 303-18:MCG 7-10-6:IRAS 04259-4216"
{
        Type  "Sc"
        RA            4.4592
        Dec         -42.1650
        Distance   2.088e+08  # method: V
        Radius     3.644e+04
        AbsMag        -19.83
        Axis    [  0.0794   0.3074  -0.9483]
        Angle    136.0842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1585"
}

Galaxy "NGC 1586:UGC 3062:MCG 0-12-36:ZWG 393.27"
{
        Type  "Sc"
        RA            4.5106
        Dec          -0.3053
        Distance   1.761e+08  # method: T-F
        Radius     4.355e+04
        AbsMag        -19.56
        Axis    [ -0.0551   0.6715  -0.7389]
        Angle    136.4113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1586"
}

Galaxy "NGC 1587:UGC 3063:MCG 0-12-35:ZWG 393.28"
{
        Type  "E0"
        RA            4.5111
        Dec           0.6625
        Distance   1.226e+08  # method: T-F
        Radius     3.032e+04
        AbsMag        -20.17
        Axis    [  0.7795   0.4750  -0.4084]
        Angle    138.8233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1587"
}

Galaxy "NGC 1588:UGC 3064:MCG 0-12-37:ZWG 393.29"
{
        Type  "E0"
        RA            4.5119
        Dec           0.6653
        Distance   1.226e+08  # method: T-F
        Radius     1.962e+04
        AbsMag        -18.68
        Axis    [  0.1422   0.5550  -0.8196]
        Angle    195.9316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1588"
}

Galaxy "NGC 1589:UGC 3065:MCG 0-12-38:ZWG 393.30"
{
        Type  "Sb"
        RA            4.5125
        Dec           0.8633
        Distance   1.686e+08  # method: V
        Radius     7.847e+04
        AbsMag        -20.77
        Axis    [ -0.1890   0.6619  -0.7254]
        Angle    126.7657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1589"
}

Galaxy "NGC 1590:UGC 3071:MCG 1-12-8:ZWG 419.14"
{
        Type  "S0"
        RA            4.5194
        Dec           7.6308
        Distance    1.73e+08  # method: V
        Radius     2.265e+04
        AbsMag        -19.12
        Axis    [  0.3976   0.8156  -0.4204]
        Angle    127.1884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1590"
}

Galaxy "NGC 1591:ESO 484-25:MCG 4-11-15:IRAS 04274-2649"
{
        Type  "SBb"
        RA            4.4917
        Dec         -26.7128
        Distance   1.801e+08  # method: T-F
        Radius     3.143e+04
        AbsMag        -19.91
        Axis    [  0.7720   0.6344   0.0388]
        Angle    144.7470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1591"
}

Galaxy "NGC 1592:ESO 421-2:MCG 5-11-11:VV 647"
{
        Type  "S0"
        RA            4.4944
        Dec         -27.4081
        Distance   3.977e+07  # method: V
        Radius          9834
        AbsMag        -15.93
        Axis    [  0.5099   0.7026  -0.4964]
        Angle    133.5411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1592"
}

Galaxy "NGC 1593:NGC 1608:IC 2077:UGC 3082"
{
        Type  "S0"
        RA            4.5350
        Dec           0.5678
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [  0.0159   0.8150  -0.5793]
        Angle    121.6179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1593"
}

Galaxy "NGC 1594:IC 2075:MCG 1-12-14:NPM 1"
{
        Type  "SBc"
        RA            4.5142
        Dec          -5.7978
        Distance   1.929e+08  # method: V
        Radius     5.051e+04
        AbsMag        -20.06
        Axis    [  0.6354   0.7527  -0.1724]
        Angle    126.1088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1594"
}

Galaxy "NGC 1595:ESO 202-25:AM 0426-475"
{
        Type  "E3"
        RA            4.4725
        Dec         -47.8153
        Distance    1.12e+08  # method: T-F
        Radius     2.117e+04
        AbsMag        -18.98
        Axis    [  0.9911   0.1314   0.0224]
        Angle    163.6786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1595"
}

Galaxy "NGC 1596:ESO 157-31:AM 0426-550"
{
        Type  "S0"
        RA            4.4606
        Dec         -55.0264
        Distance   4.982e+07  # method: S
        Radius     2.681e+04
        AbsMag        -18.82
        Axis    [  0.6555   0.7531   0.0561]
        Angle    173.4460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1596"
}

Galaxy "NGC 1597:MCG 2-12-32:NPM 1:IRAS 04287-1124"
{
        Type  "S0"
        RA            4.5203
        Dec         -11.2900
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.5098   0.7095  -0.4865]
        Angle    134.3429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1597"
}

Galaxy "NGC 1598:ESO 202-26:AM 0427-475:IRAS 04271-4753"
{
        Type  "SBc"
        RA            4.4758
        Dec         -47.7825
        Distance    1.87e+08  # method: T-F
        Radius     3.809e+04
        AbsMag        -19.99
        Axis    [  0.4636   0.5052  -0.7279]
        Angle    136.7152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1598"
}

Galaxy "NGC 1599:MCG 1-12-16:IRAS 04292-0441"
{
        Type  "Sc"
        RA            4.5272
        Dec          -4.5886
        Distance   1.612e+08  # distance uncertain!
        Radius      2.11e+04
        AbsMag        -19.07
        Axis    [  0.0133   0.5382  -0.8427]
        Angle    168.7970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1599"
}

Galaxy "NGC 1600:MCG 1-12-17"
{
        Type  "E3"
        RA            4.5275
        Dec          -5.0872
        Distance   1.739e+08  # method: T-F
        Radius     6.322e+04
        AbsMag        -21.63
        Axis    [  0.9683   0.2497   0.0012]
        Angle    123.0123
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1600"
}

Galaxy "NGC 1601:MCG 1-12-18:NPM 1"
{
        Type  "S0"
        RA            4.5281
        Dec          -5.0597
        Distance   1.739e+08  # method: T-F
        Radius     1.517e+04
        AbsMag        -18.83
        Axis    [  0.3652   0.8635  -0.3477]
        Angle    121.9911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1601"
}

Galaxy "NGC 1602:ESO 157-32:AM 0426-550:IRAS 04267-5510"
{
        Type  "Irr"
        RA            4.4650
        Dec         -55.0567
        Distance   7.085e+07  # method: V
        Radius     1.958e+04
        AbsMag        -18.18
        Axis    [  0.6909   0.5580  -0.4597]
        Angle    149.5052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1602"
}

Galaxy "NGC 1603:MCG 1-12-19:NPM 1"
{
        Type  "S0"
        RA            4.5303
        Dec          -5.0939
        Distance   1.739e+08  # method: T-F
        Radius     2.023e+04
        AbsMag        -18.83
        Axis    [  0.6673   0.7420   0.0638]
        Angle    126.1883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1603"
}

Galaxy "NGC 1604:MCG 1-12-20:NPM 1"
{
        Type  "S0"
        RA            4.5328
        Dec          -5.3694
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.5706   0.7799  -0.2571]
        Angle    125.7791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1604"
}

Galaxy "NGC 1606:MCG 1-12-22:NPM 1"
{
        Type  "SBa"
        RA            4.5342
        Dec          -5.0319
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.9684   0.2039   0.1438]
        Angle    120.1284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1606"
}

Galaxy "NGC 1607:MCG 1-12-23:IRAS 04295-0433"
{
        Type  "Sa"
        RA            4.5342
        Dec          -4.4606
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.5025   0.8641   0.0295]
        Angle    124.1902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1607"
}

Galaxy "NGC 1609:MCG 1-12-25:NPM 1"
{
        Type  "Sa"
        RA            4.5458
        Dec          -4.3719
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.3991   0.8124  -0.4252]
        Angle    125.8816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1609"
}

Galaxy "NGC 1611:MCG 1-12-29:IRAS 04306-0424"
{
        Type  "Sa"
        RA            4.5514
        Dec          -4.2969
        Distance    1.54e+08  # distance uncertain!
        Radius     4.479e+04
        AbsMag        -19.07
        Axis    [  0.1478   0.8931  -0.4249]
        Angle    116.1643
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1611"
}

Galaxy "NGC 1612:MCG 1-12-30:NPM 1:IRAS 04307-0416"
{
        Type  "Sa"
        RA            4.5536
        Dec          -4.1719
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [  0.1593   0.6638  -0.7307]
        Angle    144.9054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1612"
}

Galaxy "NGC 1613:MCG 1-12-31:NPM 1"
{
        Type  "Sa"
        RA            4.5569
        Dec          -4.2650
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.7331   0.6763  -0.0725]
        Angle    124.9527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1613"
}

Galaxy "NGC 1614:MCG 1-12-32:MK 617:ZW 15"
{
        Type  "SBc"
        RA            4.5664
        Dec          -8.5792
        Distance   2.134e+08  # method: V
        Radius     4.034e+04
        AbsMag        -20.48
        Axis    [  0.1471   0.6560  -0.7403]
        Angle    139.7405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1614"
}

Galaxy "NGC 1615:UGC 3096:MCG 3-12-5:ZWG 467.3"
{
        Type  "S0"
        RA            4.6003
        Dec          19.9508
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [  0.1212   0.8808  -0.4577]
        Angle    126.7419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1615"
}

Galaxy "NGC 1616:ESO 251-10:MCG 7-10-13:AM 0431-434"
{
        Type  "Sc"
        RA            4.5447
        Dec         -43.7150
        Distance   2.118e+08  # method: T-F
        Radius     5.544e+04
        AbsMag        -20.76
        Axis    [  0.7405   0.6705  -0.0456]
        Angle    155.9625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1616"
}

Galaxy "NGC 1617:ESO 157-41:AM 0430-544:IRAS 04305-5442"
{
        Type  "SBa"
        RA            4.5275
        Dec         -54.6019
        Distance   4.766e+07  # method: V
        Radius      2.98e+04
        AbsMag        -19.42
        Axis    [  0.5623   0.5414  -0.6251]
        Angle    137.7211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1617"
}

Galaxy "NGC 1618:MCG 1-12-34:IRAS 04336-0314"
{
        Type  "SBb"
        RA            4.6017
        Dec          -3.1486
        Distance   1.065e+08  # distance uncertain!
        Radius     3.718e+04
        AbsMag        -19.07
        Axis    [  0.5425   0.8025   0.2485]
        Angle    130.1516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1618"
}

Galaxy "NGC 1620:UGC 3103:MCG 0-12-52:ZWG 393.46"
{
        Type  "Sc"
        RA            4.6103
        Dec          -0.1442
        Distance   1.494e+08  # method: T-F
        Radius     6.304e+04
        AbsMag         -20.2
        Axis    [  0.5398   0.7980   0.2682]
        Angle    128.0756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1620"
}

Galaxy "NGC 1621:NGC 1626:MCG 1-12-35:NPM 1"
{
        Type  "E0"
        RA            4.6069
        Dec          -4.9867
        Distance   2.884e+08  # distance uncertain!
        Radius     5.873e+04
        AbsMag        -20.13
        Axis    [  0.6095   0.4980  -0.6169]
        Angle    158.1291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1621"
}

Galaxy "NGC 1622:MCG 1-12-36:NPM 1"
{
        Type  "SBb"
        RA            4.6100
        Dec          -3.1883
        Distance   1.281e+08  # distance uncertain!
        Radius     6.892e+04
        AbsMag        -19.07
        Axis    [  0.4225   0.8726   0.2450]
        Angle    130.5381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1622"
}

Galaxy "NGC 1623:DRCG 10-7"
{
        Type  "SBa"
        RA            4.5922
        Dec         -13.5564
        Distance   4.241e+08  # distance uncertain!
        Radius     4.934e+04
        AbsMag        -19.07
        Axis    [  0.7445   0.6332   0.2116]
        Angle    136.9157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1623"
}

Galaxy "NGC 1625:MCG 1-12-38:IRAS 04346-0324"
{
        Type  "SBb"
        RA            4.6183
        Dec          -3.3039
        Distance   2.102e+08  # method: V
        Radius     6.419e+04
        AbsMag        -20.94
        Axis    [ -0.0428   0.8228  -0.5667]
        Angle    113.7323
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1625"
}

Galaxy "NGC 1627:MCG 1-12-40:IRAS 04351-0459"
{
        Type  "Sc"
        RA            4.6269
        Dec          -4.8881
        Distance   1.725e+08  # method: V
        Radius     4.013e+04
        AbsMag        -19.92
        Axis    [  0.2896   0.6063  -0.7406]
        Angle    157.0181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1627"
}

Galaxy "NGC 1628:MCG 1-12-39:IRAS 04351-0448"
{
        Type  "Sb"
        RA            4.6267
        Dec          -4.7158
        Distance   1.647e+08  # method: V
        Radius     4.552e+04
        AbsMag        -19.32
        Axis    [  0.5093   0.7554   0.4123]
        Angle    143.6145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1628"
}

Galaxy "NGC 1630-1:ESO 551-19:NPM 1"
{
        Type  "Sa"
        RA            4.6208
        Dec         -18.9019
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.2263   0.5908  -0.7744]
        Angle    140.0422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1630-1"
}

Galaxy "NGC 1630-2"
{
        Type  "S0"
        RA            4.6206
        Dec         -18.9061
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.5323   0.7980  -0.2827]
        Angle    127.6856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1630-2"
}

Galaxy "NGC 1631:ESO 551-21:MCG 3-12-17:IRAS 04362-2045"
{
        Type  "SBa"
        RA            4.6400
        Dec         -20.6503
        Distance    4.24e+08  # method: V
        Radius     9.251e+04
        AbsMag        -21.27
        Axis    [  0.7014   0.7108  -0.0535]
        Angle    135.4766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1631"
}

Galaxy "NGC 1632:IC 386:NPM 1"
{
        Type  "Sa"
        RA            4.6661
        Dec          -9.4558
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.6729   0.7394   0.0221]
        Angle    127.7087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1632"
}

Galaxy "NGC 1633:UGC 3125:MCG 1-12-14:ZWG 419.23"
{
        Type  "SBb"
        RA            4.6692
        Dec           7.3497
        Distance    2.23e+08  # method: V
        Radius     3.243e+04
        AbsMag        -19.77
        Axis    [  0.7302   0.6650  -0.1566]
        Angle    117.2616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1633"
}

Galaxy "NGC 1634:MCG 1-12-15:ZWG 419.22:ARAK 109"
{
        Type  "S0"
        RA            4.6692
        Dec           7.3389
        Distance   3.369e+08  # method: V
        Radius      1.96e+04
        AbsMag        -19.97
        Axis    [  0.2948   0.8082  -0.5098]
        Angle    128.7723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1634"
}

Galaxy "NGC 1635:UGC 3126:MCG 0-12-63:ZWG 393.60"
{
        Type  "SBa"
        RA            4.6686
        Dec          -0.5472
        Distance   1.017e+08  # distance uncertain!
        Radius     2.071e+04
        AbsMag        -19.07
        Axis    [  0.8943   0.3994   0.2015]
        Angle    119.4970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1635"
}

Galaxy "NGC 1636:MCG 1-12-42:IRAS 04382-0842"
{
        Type  "Sb"
        RA            4.6778
        Dec          -8.6078
        Distance   1.223e+08  # distance uncertain!
        Radius     2.135e+04
        AbsMag        -19.07
        Axis    [  0.8095   0.5005   0.3068]
        Angle    132.8982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1636"
}

Galaxy "NGC 1637:MCG 0-12-68:UGCA 93:ZWG 393.66"
{
        Type  "SBc"
        RA            4.6911
        Dec          -2.8578
        Distance   3.003e+07  # method: V
        Radius     1.442e+04
        AbsMag        -18.32
        Axis    [  0.8076   0.5816   0.0971]
        Angle    122.8345
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1637"
}

Galaxy "NGC 1638:UGC 3133:MCG 0-12-69:ZWG 393.68"
{
        Type  "S0"
        RA            4.6933
        Dec          -1.8083
        Distance   1.478e+08  # method: V
        Radius      3.87e+04
        AbsMag        -20.28
        Axis    [  0.5462   0.8048  -0.2323]
        Angle    121.0882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1638"
}

Galaxy "NGC 1640:ESO 551-27:MCG 3-12-18:IRAS 04400-2031"
{
        Type  "SBb"
        RA            4.7039
        Dec         -20.4347
        Distance    7.09e+07  # method: V
        Radius     2.784e+04
        AbsMag        -19.29
        Axis    [  0.8191   0.5552  -0.1445]
        Angle    136.8210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1640"
}

Galaxy "NGC 1642:UGC 3140:MCG 0-12-72:ZWG 393.73"
{
        Type  "Sc"
        RA            4.7150
        Dec           0.6189
        Distance   2.074e+08  # method: V
        Radius     5.128e+04
        AbsMag        -20.72
        Axis    [ -0.1178   0.5696  -0.8134]
        Angle    152.8618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1642"
}

Galaxy "NGC 1643:MCG 1-13-1:IRAS 04412-0524"
{
        Type  "Sc"
        RA            4.7286
        Dec          -5.3189
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [  0.2074   0.5953  -0.7763]
        Angle    157.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1643"
}

Galaxy "NGC 1645:MCG 1-13-2:NPM 1"
{
        Type  "Sa"
        RA            4.7350
        Dec          -5.4650
        Distance   2.154e+08  # method: V
        Radius     6.578e+04
        AbsMag         -20.2
        Axis    [  0.3675   0.8829  -0.2924]
        Angle    117.6478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1645"
}

Galaxy "NGC 1646-1:MCG 1-13-3:ZW 22"
{
        Type  "S0"
        RA            4.7397
        Dec          -8.5314
        Distance   1.341e+08  # distance uncertain!
        Radius     4.291e+04
        AbsMag        -19.07
        Axis    [ -0.0587   0.5688  -0.8204]
        Angle    138.6762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1646-1"
}

Galaxy "NGC 1646-2:ZW 22"
{
        Type  "E0"
        RA            4.7397
        Dec          -8.5350
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.9824   0.1483   0.1140]
        Angle    122.8353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1646-2"
}

Galaxy "NGC 1646-3:ZW 22"
{
        Type  "E0"
        RA            4.7406
        Dec          -8.5353
        Distance   7.944e+08  # distance uncertain!
        Radius     4.622e+04
        AbsMag        -20.13
        Axis    [  0.2341   0.4936  -0.8376]
        Angle    186.1534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1646-3"
}

Galaxy "NGC 1648:MCG 1-13-4:Z 0441.2:NPM 1"
{
        Type  "S0"
        RA            4.7428
        Dec          -8.4783
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8547   0.4599   0.2408]
        Angle    129.4690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1648"
}

Galaxy "NGC 1650:MCG 3-13-1"
{
        Type  "E0"
        RA            4.7531
        Dec         -15.8700
        Distance   1.906e+08  # distance uncertain!
        Radius     6.375e+04
        AbsMag        -20.13
        Axis    [  0.1851   0.4330  -0.8822]
        Angle    189.7476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1650"
}

Galaxy "NGC 1653:UGC 3153:MCG 0-13-3:ZWG 394.2"
{
        Type  "E0"
        RA            4.7631
        Dec          -2.3928
        Distance   1.358e+08  # method: T-F
        Radius     2.963e+04
        AbsMag         -20.2
        Axis    [  0.9819   0.1561   0.1072]
        Angle    116.7693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1653"
}

Galaxy "NGC 1654:UGC 3154:ZWG 394.3:IRAS 04433-0210"
{
        Type  "Sa"
        RA            4.7633
        Dec          -2.0833
        Distance   2.052e+08  # method: V
        Radius     2.387e+04
        AbsMag        -19.59
        Axis    [  0.9756   0.1819   0.1228]
        Angle    116.8097
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1654"
}

Galaxy "NGC 1656:MCG 1-13-5"
{
        Type  "Sa"
        RA            4.7647
        Dec          -5.1364
        Distance   1.223e+08  # distance uncertain!
        Radius     2.668e+04
        AbsMag        -19.07
        Axis    [  0.2360   0.7382  -0.6320]
        Angle    129.9622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1656"
}

Galaxy "NGC 1657:UGC 3156:MCG 0-13-4:ZWG 394.5"
{
        Type  "SBc"
        RA            4.7686
        Dec          -2.0769
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.0341   0.6642  -0.7468]
        Angle    138.5510
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1657"
}

Galaxy "NGC 1658:ESO 304-16:MCG 7-10-20:AM 0442-413"
{
        Type  "Sc"
        RA            4.7336
        Dec         -41.4636
        Distance   2.458e+08  # method: T-F
        Radius     5.363e+04
        AbsMag        -19.99
        Axis    [  0.3458   0.6236  -0.7011]
        Angle    119.6070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1658"
}

Galaxy "NGC 1659:IC 4099:MCG 1-13-6:IRAS 04440-0452"
{
        Type  "Sc"
        RA            4.7750
        Dec          -4.7886
        Distance   2.054e+08  # method: V
        Radius     4.481e+04
        AbsMag         -20.7
        Axis    [  0.6934   0.7133  -0.1025]
        Angle    122.6324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1659"
}

Galaxy "NGC 1660:ESO 304-18:MCG 7-10-21:AM 0442-413"
{
        Type  "Sa"
        RA            4.7364
        Dec         -41.4978
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.7485   0.6629  -0.0199]
        Angle    154.0159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1660"
}

Galaxy "NGC 1661:UGC 3166:MCG 0-13-8:ZWG 394.9"
{
        Type  "Sc"
        RA            4.7853
        Dec          -2.0550
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.6903   0.7197   0.0735]
        Angle    121.6023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1661"
}

Galaxy "NGC 1665:MCG 1-13-9:NPM 1"
{
        Type  "S0"
        RA            4.8047
        Dec          -5.4272
        Distance    1.22e+08  # method: V
        Radius     3.195e+04
        AbsMag        -19.06
        Axis    [  0.6361   0.7693  -0.0590]
        Angle    121.9580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1665"
}

Galaxy "NGC 1666:MCG 1-13-10:NPM 1"
{
        Type  "SBa"
        RA            4.8089
        Dec          -6.5694
        Distance   1.115e+08  # distance uncertain!
        Radius     2.271e+04
        AbsMag        -19.07
        Axis    [  0.1608   0.6359  -0.7548]
        Angle    143.0305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1666"
}

Galaxy "NGC 1667:NGC 1689:MCG 1-13-13:IRAS 04461-0624"
{
        Type  "SBc"
        RA            4.8103
        Dec          -6.3203
        Distance   2.044e+08  # method: V
        Radius     4.161e+04
        AbsMag        -21.18
        Axis    [  0.7785   0.6080   0.1560]
        Angle    126.6469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1667"
}

Galaxy "NGC 1668:ESO 251-30:MCG 7-10-23:AM 0444-444"
{
        Type  "S0"
        RA            4.7681
        Dec         -44.7328
        Distance   4.559e+08  # method: V
        Radius     1.061e+05
        AbsMag        -21.93
        Axis    [  0.5279   0.5644  -0.6346]
        Angle    134.5744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1668"
}

Galaxy "NGC 1669:ESO 84-38:IRAS 04428-6553"
{
        Type  "Sa"
        RA            4.7167
        Dec         -65.8142
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.6513   0.4775  -0.5897]
        Angle    144.6292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1669"
}

Galaxy "NGC 1670:MCG 0-13-16:ZWG 394.17"
{
        Type  "S0"
        RA            4.8283
        Dec          -2.7600
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [  0.4827   0.8498  -0.2120]
        Angle    117.7184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1670"
}

Galaxy "NGC 1671:IC 395:UGC 3178:MCG 0-13-15"
{
        Type  "S0"
        RA            4.8258
        Dec           0.2533
        Distance   1.281e+08  # distance uncertain!
        Radius     1.676e+04
        AbsMag        -19.07
        Axis    [  0.1524   0.7467  -0.6474]
        Angle    130.6817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1671"
}

Galaxy "NGC 1672:ESO 118-43:VV 826:AM 0444-592"
{
        Type  "SBb"
        RA            4.7617
        Dec         -59.2478
        Distance   6.098e+07  # method: V
        Radius     5.942e+04
        AbsMag        -20.86
        Axis    [  0.2012   0.1426  -0.9691]
        Angle    151.7849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1672"
}

Galaxy "NGC 1678:MCG 0-13-19:ZWG 394.20"
{
        Type  "S0"
        RA            4.8597
        Dec          -2.6228
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.5781   0.7649  -0.2843]
        Angle    120.9428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1678"
}

Galaxy "NGC 1679:ESO 422-1:MCG 5-12-4:UGCA 96"
{
        Type  "Irr"
        RA            4.8319
        Dec         -31.9672
        Distance   4.449e+07  # method: T-F
        Radius     1.747e+04
        AbsMag        -18.67
        Axis    [  0.2175   0.4493  -0.8665]
        Angle    141.6859
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1679"
}

Galaxy "NGC 1680:ESO 203-4:IRAS 04471-4754"
{
        Type  "SBb"
        RA            4.8092
        Dec         -47.8167
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.5273   0.6180  -0.5831]
        Angle    130.1011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1680"
}

Galaxy "NGC 1681:MCG 1-13-26:IRAS 04493-0553"
{
        Type  "Sb"
        RA            4.8639
        Dec          -5.8031
        Distance   1.168e+08  # distance uncertain!
        Radius     2.208e+04
        AbsMag        -19.07
        Axis    [  0.2417   0.5952  -0.7664]
        Angle    154.0799
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1681"
}

Galaxy "NGC 1682:MCG 1-13-28:NPM 1"
{
        Type  "S0"
        RA            4.8719
        Dec          -3.1053
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.9794   0.1669   0.1141]
        Angle    117.6328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1682"
}

Galaxy "NGC 1683:NPM 1"
{
        Type  "Sa"
        RA            4.8714
        Dec          -3.0242
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [ -0.1584   0.6244  -0.7649]
        Angle    126.3141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1683"
}

Galaxy "NGC 1684:MCG 1-13-31:IRAS 04500-0311"
{
        Type  "E0"
        RA            4.8753
        Dec          -3.1056
        Distance   1.381e+08  # distance uncertain!
        Radius     4.417e+04
        AbsMag        -20.13
        Axis    [  0.6648   0.4781  -0.5741]
        Angle    148.5840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1684"
}

Galaxy "NGC 1685:MCG 1-13-32:IRAS 04500-0301"
{
        Type  "SBa"
        RA            4.8761
        Dec          -2.9497
        Distance   2.034e+08  # method: V
        Radius     3.846e+04
        AbsMag        -18.97
        Axis    [  0.1482   0.7054  -0.6931]
        Angle    133.2060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1685"
}

Galaxy "NGC 1686:MCG 3-13-19"
{
        Type  "Sc"
        RA            4.8817
        Dec         -15.3464
        Distance   1.688e+08  # distance uncertain!
        Radius     4.174e+04
        AbsMag        -19.07
        Axis    [  0.5170   0.8303   0.2080]
        Angle    138.1273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1686"
}

Galaxy "NGC 1687:ESO 361-13:MCG 6-11-5"
{
        Type  "SBb"
        RA            4.8558
        Dec         -33.9392
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.6696   0.7417  -0.0393]
        Angle    143.5658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1687"
}

Galaxy "NGC 1688:ESO 119-6:AM 0447-595:IRAS 04476-5953"
{
        Type  "SBc"
        RA            4.8064
        Dec         -59.8000
        Distance   4.825e+07  # method: T-F
        Radius     1.684e+04
        AbsMag        -18.55
        Axis    [  0.1383   0.1195  -0.9832]
        Angle    146.9567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1688"
}

Galaxy "NGC 1690:UGC 3198:MCG 0-13-27:ZWG 394.30"
{
        Type  "E0"
        RA            4.9053
        Dec           1.6406
        Distance   3.953e+08  # method: V
        Radius     5.749e+04
        AbsMag        -20.12
        Axis    [  0.9852   0.1448   0.0921]
        Angle    112.5921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1690"
}

Galaxy "NGC 1691:UGC 3201:MCG 1-13-9:MK 1088"
{
        Type  "SBa"
        RA            4.9106
        Dec           3.2678
        Distance   2.058e+08  # method: V
        Radius     6.885e+04
        AbsMag         -20.9
        Axis    [  0.7479   0.6637   0.0076]
        Angle    115.6277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1691"
}

Galaxy "NGC 1692:ESO 552-21:MCG 3-13-29:NPM 1"
{
        Type  "S0"
        RA            4.9231
        Dec         -20.5711
        Distance   4.694e+08  # method: V
        Radius     8.875e+04
        AbsMag        -21.79
        Axis    [  0.9261   0.3452   0.1519]
        Angle    137.8961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1692"
}

Galaxy "NGC 1694:MCG 1-13-35A:NPM 1"
{
        Type  "Sc"
        RA            4.9211
        Dec          -4.6522
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.6837   0.7247   0.0859]
        Angle    122.8413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1694"
}

Galaxy "NGC 1699:MCG 1-13-39:IRAS 04545-0449"
{
        Type  "Sb"
        RA            4.9497
        Dec          -4.7572
        Distance   1.754e+08  # method: V
        Radius     2.296e+04
        AbsMag        -18.95
        Axis    [ -0.0427   0.6390  -0.7681]
        Angle    131.0917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1699"
}

Galaxy "NGC 1700:MCG 1-13-38"
{
        Type  "E4"
        RA            4.9489
        Dec          -4.8653
        Distance   1.444e+08  # method: S
        Radius     6.929e+04
        AbsMag        -21.03
        Axis    [  0.5008   0.5018  -0.7053]
        Angle    161.8750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1700"
}

Galaxy "NGC 1701:ESO 422-11:MCG 5-12-10:IRAS 04539-2957"
{
        Type  "Sb"
        RA            4.9308
        Dec         -29.8836
        Distance   2.626e+08  # method: V
        Radius     4.583e+04
        AbsMag        -20.93
        Axis    [  0.3007   0.5007  -0.8117]
        Angle    139.1796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1701"
}

Galaxy "NGC 1703:ESO 119-19:AM 0452-594:IRAS 04521-5949"
{
        Type  "SBb"
        RA            4.8808
        Dec         -59.7428
        Distance   6.967e+07  # method: V
        Radius     2.939e+04
        AbsMag        -19.65
        Axis    [  0.9422   0.3227   0.0900]
        Angle    176.1924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1703"
}

Galaxy "NGC 1705:ESO 158-13:AM 0453-532:IRAS 04531-5326"
{
        Type  "S0"
        RA            4.9036
        Dec         -53.3606
        Distance   3.085e+07  # method: V
        Radius          8525
        AbsMag        -17.08
        Axis    [  0.8364   0.4857  -0.2542]
        Angle    158.4526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1705"
}

Galaxy "NGC 1706:ESO 85-7:FAIR 240:AM 0452-630"
{
        Type  "Sb"
        RA            4.8753
        Dec         -62.9861
        Distance   2.222e+08  # method: V
        Radius     4.524e+04
        AbsMag        -20.57
        Axis    [  0.5304   0.3044  -0.7912]
        Angle    145.5182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1706"
}

Galaxy "NGC 1709:NGC 1717:MCG 0-13-54:ZWG 394.58"
{
        Type  "S0"
        RA            4.9789
        Dec          -0.4778
        Distance    2.13e+08  # method: V
        Radius     2.788e+04
        AbsMag        -18.87
        Axis    [  0.7159   0.6893  -0.1113]
        Angle    117.8325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1709"
}

Galaxy "NGC 1710:IC 2108:MCG 3-13-37"
{
        Type  "S0"
        RA            4.9544
        Dec         -15.2889
        Distance   2.367e+08  # method: V
        Radius     4.475e+04
        AbsMag         -20.3
        Axis    [  0.8413   0.5226   0.1383]
        Angle    133.8013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1710"
}

Galaxy "NGC 1713:UGC 3222:MCG 0-13-56:ZWG 394.59"
{
        Type  "E0"
        RA            4.9817
        Dec          -0.4886
        Distance   2.916e+08  # method: T-F
        Radius     5.938e+04
        AbsMag        -20.86
        Axis    [  0.8945   0.3475  -0.2812]
        Angle    125.6383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1713"
}

Galaxy "NGC 1716:ESO 552-34:MCG 3-13-38:IRAS 04560-2026"
{
        Type  "SBc"
        RA            4.9703
        Dec         -20.3633
        Distance   3.082e+08  # method: V
        Radius     6.275e+04
        AbsMag        -20.98
        Axis    [  0.8859   0.4613   0.0484]
        Angle    136.6536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1716"
}

Galaxy "NGC 1719:UGC 3226:MCG 0-13-60:ZWG 394.63"
{
        Type  "Sa"
        RA            4.9928
        Dec          -0.2606
        Distance   1.874e+08  # method: V
        Radius     2.998e+04
        AbsMag         -19.3
        Axis    [  0.1412   0.9257  -0.3508]
        Angle    108.1666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1719"
}

Galaxy "NGC 1720:MCG 1-13-41:IRAS 04569-0756"
{
        Type  "SBb"
        RA            4.9889
        Dec          -7.8592
        Distance   1.883e+08  # method: V
        Radius     5.478e+04
        AbsMag        -19.91
        Axis    [  0.5156   0.7970  -0.3146]
        Angle    119.2955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1720"
}

Galaxy "NGC 1721:MCG 2-13-27:VV 699:IRAS 04569-1111"
{
        Type  "S0"
        RA            4.9881
        Dec         -11.1183
        Distance    2.06e+08  # method: V
        Radius     5.693e+04
        AbsMag         -20.2
        Axis    [  0.1435   0.7089  -0.6905]
        Angle    122.3544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1721"
}

Galaxy "NGC 1723:MCG 2-13-29:IRAS 04571-1103"
{
        Type  "SBa"
        RA            4.9903
        Dec         -10.9806
        Distance    7.37e+07  # distance uncertain!
        Radius     2.787e+04
        AbsMag        -19.07
        Axis    [  0.1250   0.6234  -0.7718]
        Angle    134.6802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1723"
}

Galaxy "NGC 1725:MCG 2-13-28:VV 699"
{
        Type  "S0"
        RA            4.9894
        Dec         -11.1319
        Distance   1.223e+08  # distance uncertain!
        Radius     2.135e+04
        AbsMag        -19.07
        Axis    [  0.8604   0.5033   0.0805]
        Angle    128.3142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1725"
}

Galaxy "NGC 1726:MCG 1-13-42"
{
        Type  "S0"
        RA            4.9947
        Dec          -7.7550
        Distance   1.352e+08  # method: T-F
        Radius     3.344e+04
        AbsMag        -20.39
        Axis    [  0.8671   0.4246   0.2606]
        Angle    128.6061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1726"
}

Galaxy "NGC 1728:MCG 2-13-30:VV 699"
{
        Type  "Sa"
        RA            4.9908
        Dec         -11.1233
        Distance   2.032e+08  # method: V
        Radius     5.911e+04
        AbsMag        -19.17
        Axis    [ -0.2285   0.4868  -0.8431]
        Angle    124.3028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1728"
}

Galaxy "NGC 1729:MCG 1-13-43:IRAS 04577-0325"
{
        Type  "Sc"
        RA            5.0042
        Dec          -3.3531
        Distance   1.639e+08  # method: V
        Radius     4.054e+04
        AbsMag        -19.91
        Axis    [  0.8184   0.5743   0.0201]
        Angle    120.5076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1729"
}

Galaxy "NGC 1730:IC 2113:MCG 3-13-43:IRAS 04573-1553"
{
        Type  "SBa"
        RA            4.9919
        Dec         -15.8233
        Distance   1.788e+08  # method: V
        Radius     5.981e+04
        AbsMag        -20.49
        Axis    [  0.3566   0.8050  -0.4741]
        Angle    117.0135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1730"
}

Galaxy "NGC 1738:ESO 552-49:MCG 3-13-54:IRAS 04595-1813"
{
        Type  "SBc"
        RA            5.0294
        Dec         -18.1575
        Distance   1.797e+08  # method: V
        Radius     3.397e+04
        AbsMag           -20
        Axis    [  0.7046   0.7096   0.0002]
        Angle    131.1399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1738"
}

Galaxy "NGC 1739:ESO 552-50:MCG 3-13-55"
{
        Type  "Sc"
        RA            5.0297
        Dec         -18.1672
        Distance   1.758e+08  # method: V
        Radius     3.579e+04
        AbsMag        -19.46
        Axis    [  0.3956   0.7279  -0.5600]
        Angle    122.3050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1739"
}

Galaxy "NGC 1740:MCG 1-13-46:NPM 1"
{
        Type  "S0"
        RA            5.0317
        Dec          -3.2958
        Distance   1.281e+08  # distance uncertain!
        Radius     2.794e+04
        AbsMag        -19.07
        Axis    [  0.7141   0.6748  -0.1865]
        Angle    119.8431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1740"
}

Galaxy "NGC 1741A:MCG 1-13-45:MK 1089:ARP 259"
{
        Type  "Irr"
        RA            5.0272
        Dec          -4.2589
        Distance   1.825e+08  # method: V
        Radius     2.389e+04
        AbsMag        -18.74
        Axis    [  0.4426   0.8940  -0.0692]
        Angle    115.0105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1741A"
}

Galaxy "NGC 1741B:MCG 1-13-45:ARP 259:VV 524"
{
        Type  "Irr"
        RA            5.0264
        Dec          -4.2633
        Distance   3.802e+08  # distance uncertain!
        Radius     4.977e+04
        AbsMag        -20.13
        Axis    [  0.7017   0.6928   0.1662]
        Angle    124.0672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1741B"
}

Galaxy "NGC 1744:ESO 486-5:MCG 4-12-29:IRAS 04579-2605"
{
        Type  "SBc"
        RA            4.9992
        Dec         -26.0228
        Distance   4.693e+07  # method: T-F
        Radius     5.051e+04
        AbsMag        -18.99
        Axis    [ -0.0389   0.4486  -0.8929]
        Angle    125.1550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1744"
}

Galaxy "NGC 1752:MCG 1-13-47:IRAS 04597-0818"
{
        Type  "SBc"
        RA            5.0358
        Dec          -8.2408
        Distance   1.672e+08  # method: T-F
        Radius     6.321e+04
        AbsMag        -20.25
        Axis    [  0.4171   0.8979  -0.1409]
        Angle    114.9449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1752"
}

Galaxy "NGC 1753:MCG 1-13-48:IRAS 05000-0324"
{
        Type  "Sa"
        RA            5.0422
        Dec          -3.3447
        Distance   2.676e+08  # distance uncertain!
        Radius     5.448e+04
        AbsMag        -19.07
        Axis    [ -0.1746   0.6009  -0.7800]
        Angle    126.6445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1753"
}

Galaxy "NGC 1759:ESO 305-1:MCG 6-12-2:AM 0459-384"
{
        Type  "E0"
        RA            5.0136
        Dec         -38.6736
        Distance   2.291e+08  # distance uncertain!
        Radius     3.999e+04
        AbsMag        -20.13
        Axis    [  0.9912   0.0805   0.1054]
        Angle    152.3497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1759"
}

Galaxy "NGC 1762:UGC 3238:MCG 0-13-67:ZWG 394.73"
{
        Type  "Sc"
        RA            5.0603
        Dec           1.5733
        Distance   2.088e+08  # method: V
        Radius     5.164e+04
        AbsMag        -20.63
        Axis    [ -0.1720   0.5716  -0.8023]
        Angle    144.8833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1762"
}

Galaxy "NGC 1765:ESO 119-24:AM 0457-620"
{
        Type  "S0"
        RA            4.9733
        Dec         -62.0278
        Distance   1.281e+08  # distance uncertain!
        Radius     2.235e+04
        AbsMag        -19.07
        Axis    [  0.3476   0.1752  -0.9211]
        Angle    150.7321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1765"
}

Galaxy "NGC 1771:ESO 85-27:IRAS 04585-6322"
{
        Type  "Sc"
        RA            4.9819
        Dec         -63.2983
        Distance   2.159e+08  # method: T-F
        Radius     5.654e+04
        AbsMag         -19.9
        Axis    [  0.3972   0.4173  -0.8174]
        Angle    114.6910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1771"
}

Galaxy "NGC 1779:MCG 2-13-41:IRAS 05029-0912"
{
        Type  "SBa"
        RA            5.0883
        Dec          -9.1478
        Distance   1.607e+08  # method: V
        Radius     5.844e+04
        AbsMag        -20.46
        Axis    [  0.3137   0.7784  -0.5438]
        Angle    118.5786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1779"
}

Galaxy "NGC 1780:ESO 553-1:ESO 552-71:MCG 3-13-70"
{
        Type  "S0"
        RA            5.1056
        Dec         -19.4669
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.5276   0.7476  -0.4034]
        Angle    122.0870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1780"
}

Galaxy "NGC 1781:NGC 1794:ESO 553-7:MCG 3-14-2"
{
        Type  "S0"
        RA            5.1319
        Dec         -18.1900
        Distance   2.259e+08  # method: V
        Radius     4.272e+04
        AbsMag         -20.5
        Axis    [  0.8259   0.5370  -0.1719]
        Angle    131.2800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1781"
}

Galaxy "NGC 1784:MCG 2-13-42:IRAS 05030-1156"
{
        Type  "SBc"
        RA            5.0908
        Dec         -11.8711
        Distance   1.145e+08  # method: T-F
        Radius     6.829e+04
        AbsMag        -20.33
        Axis    [  0.3834   0.7386  -0.5544]
        Angle    122.1068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1784"
}

Galaxy "NGC 1792:ESO 305-6:MCG 6-12-4:AM 0503-380"
{
        Type  "SBc"
        RA            5.0869
        Dec         -37.9797
        Distance   4.412e+07  # method: T-F
        Radius     3.337e+04
        AbsMag        -19.85
        Axis    [  0.2671   0.5154  -0.8142]
        Angle    122.4162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1792"
}

Galaxy "NGC 1796:ESO 119-30:AM 0507-611:IRAS 05021-6112"
{
        Type  "SBb"
        RA            5.0450
        Dec         -61.1397
        Distance   4.476e+07  # method: V
        Radius     1.172e+04
        AbsMag        -17.79
        Axis    [  0.6135   0.4497  -0.6491]
        Angle    139.7406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1796"
}

Galaxy "NGC 1796A:ESO 119-35"
{
        Type  "Sb"
        RA            5.0842
        Dec         -61.4839
        Distance   3.952e+08  # method: V
        Radius     9.771e+04
        AbsMag        -20.52
        Axis    [  0.2914   0.3350  -0.8960]
        Angle    110.5374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1796A"
}

Galaxy "NGC 1796B1:ESO 119-37:IRAS 05073-6115"
{
        Type  "Sc"
        RA            5.1314
        Dec         -61.1906
        Distance    2.62e+08  # method: V
        Radius     4.191e+04
        AbsMag        -18.72
        Axis    [  0.7145   0.6987  -0.0369]
        Angle    170.7491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1796B1"
}

Galaxy "NGC 1796B2:ESO 119-37A"
{
        Type  "S0"
        RA            5.1319
        Dec         -61.1936
        Distance   4.241e+08  # distance uncertain!
        Radius     3.701e+04
        AbsMag        -19.07
        Axis    [  0.7401   0.6673  -0.0832]
        Angle    167.4808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1796B2"
}

Galaxy "NGC 1797:MCG 1-14-2:MK 1093:IRAS 05053-0805"
{
        Type  "Sa"
        RA            5.1289
        Dec          -8.0189
        Distance   2.007e+08  # method: V
        Radius     4.671e+04
        AbsMag        -19.55
        Axis    [  0.4582   0.7792  -0.4277]
        Angle    118.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1797"
}

Galaxy "NGC 1799:MCG 1-14-1"
{
        Type  "S0"
        RA            5.1289
        Dec          -7.9689
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.1767   0.7432  -0.6453]
        Angle    119.7263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1799"
}

Galaxy "NGC 1800:ESO 422-30:MCG 5-13-4:AM 0504-320"
{
        Type  "Irr"
        RA            5.1069
        Dec         -31.9544
        Distance   3.642e+07  # method: V
        Radius     1.059e+04
        AbsMag        -17.14
        Axis    [  0.4132   0.6245  -0.6628]
        Angle    124.6091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1800"
}

Galaxy "NGC 1803:ESO 203-18:IRAS 05041-4938"
{
        Type  "SBc"
        RA            5.0906
        Dec         -49.5675
        Distance   1.877e+08  # method: V
        Radius     3.549e+04
        AbsMag         -20.4
        Axis    [  0.7561   0.5599  -0.3387]
        Angle    147.3667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1803"
}

Galaxy "NGC 1808:ESO 305-8:MCG 6-12-5:AM 0505-373"
{
        Type  "SBa"
        RA            5.1283
        Dec         -37.5133
        Distance   4.607e+07  # method: V
        Radius     4.355e+04
        AbsMag        -19.95
        Axis    [  0.3163   0.5003  -0.8060]
        Angle    127.8831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1808"
}

Galaxy "NGC 1809:ESO 56-48:IRAS 05023-6937"
{
        Type  "Sc"
        RA            5.0347
        Dec         -69.5683
        Distance   6.011e+07  # method: V
        Radius     2.798e+04
        AbsMag        -18.13
        Axis    [  0.3910   0.3373  -0.8563]
        Angle    111.0096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1809"
}

Galaxy "NGC 1811:ESO 422-37:MCG 5-13-8:AM 0506-292"
{
        Type  "Sa"
        RA            5.1450
        Dec         -29.2764
        Distance   1.792e+08  # method: V
        Radius      4.43e+04
        AbsMag         -19.2
        Axis    [  0.5316   0.8343  -0.1461]
        Angle    127.0705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1811"
}

Galaxy "NGC 1812:ESO 422-39:MCG 5-13-9:AM 0506-291"
{
        Type  "Sa"
        RA            5.1478
        Dec         -29.2517
        Distance   1.776e+08  # method: V
        Radius       3.1e+04
        AbsMag        -20.08
        Axis    [  0.8694   0.4734   0.1417]
        Angle    147.3355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1812"
}

Galaxy "NGC 1819:UGC 3265:MCG 1-14-2:MK 1194"
{
        Type  "S0"
        RA            5.1961
        Dec           5.2008
        Distance    2.02e+08  # method: V
        Radius     3.819e+04
        AbsMag        -20.46
        Axis    [  0.2374   0.7578  -0.6077]
        Angle    126.8159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1819"
}

Galaxy "NGC 1821:MCG 3-14-7:IRAS 05095-1511"
{
        Type  "Irr"
        RA            5.1961
        Dec         -15.1344
        Distance   2.754e+08  # distance uncertain!
        Radius     4.807e+04
        AbsMag        -20.13
        Axis    [  0.2693   0.6575  -0.7037]
        Angle    126.1131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1821"
}

Galaxy "NGC 1824:ESO 119-36:AM 0506-594:IRAS 05061-5947"
{
        Type  "Irr"
        RA            5.1156
        Dec         -59.7253
        Distance    4.92e+07  # method: T-F
        Radius      2.29e+04
        AbsMag        -17.79
        Axis    [  0.1997   0.2952  -0.9343]
        Angle    104.5149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1824"
}

Galaxy "NGC 1827:ESO 362-6:MCG 6-12-8:AM 0508-370"
{
        Type  "SBc"
        RA            5.1678
        Dec         -36.9603
        Distance   4.815e+07  # method: V
        Radius     2.101e+04
        AbsMag        -17.55
        Axis    [  0.2880   0.6970  -0.6567]
        Angle    107.8913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1827"
}

Galaxy "NGC 1832:MCG 3-14-10:IRAS 05098-1544"
{
        Type  "SBc"
        RA            5.2008
        Dec         -15.6889
        Distance   1.133e+08  # method: T-F
        Radius     4.283e+04
        AbsMag         -20.6
        Axis    [  0.8104   0.5580   0.1785]
        Angle    134.9059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1832"
}

Galaxy "NGC 1843:MCG 2-14-8:UGCA 107:IRAS 05117-1041"
{
        Type  "Sc"
        RA            5.2350
        Dec         -10.6267
        Distance   1.184e+08  # method: V
        Radius     3.615e+04
        AbsMag         -19.4
        Axis    [  0.3273   0.6360  -0.6988]
        Angle    132.8626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1843"
}

Galaxy "NGC 1853:ESO 158-22:AM 0511-572:IRAS 05114-5727"
{
        Type  "SBc"
        RA            5.2044
        Dec         -57.3994
        Distance   1.183e+08  # method: T-F
        Radius     3.442e+04
        AbsMag         -19.2
        Axis    [  0.7247   0.6626  -0.1891]
        Angle    155.1462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1853"
}

Galaxy "NGC 1875:MCG 1-14-31:ZWG 421.39:ARP 327"
{
        Type  "S0"
        RA            5.3625
        Dec           6.6889
        Distance   4.077e+08  # method: V
        Radius     4.743e+04
        AbsMag        -20.78
        Axis    [  0.8744   0.4783   0.0819]
        Angle    109.4687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1875"
}

Galaxy "NGC 1879:ESO 423-6:MCG 5-13-16:UGCA 110"
{
        Type  "Irr"
        RA            5.3300
        Dec         -32.1425
        Distance   8.811e+07  # method: T-F
        Radius     3.204e+04
        AbsMag        -18.96
        Axis    [  0.7446   0.5955  -0.3017]
        Angle    134.6179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1879"
}

Galaxy "NGC 1886:ESO 487-2:MCG 4-13-13:FGCE 485"
{
        Type  "Sc"
        RA            5.3633
        Dec         -23.8100
        Distance   1.026e+08  # method: T-F
        Radius     4.624e+04
        AbsMag        -18.89
        Axis    [  0.4885   0.8664  -0.1038]
        Angle    120.8442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1886"
}

Galaxy "NGC 1888:MCG 2-14-13:ARP 123:IRAS 05202-1132"
{
        Type  "SBc"
        RA            5.3761
        Dec         -11.5003
        Distance   1.109e+08  # method: V
        Radius     4.841e+04
        AbsMag        -19.86
        Axis    [ -0.0832   0.6934  -0.7158]
        Angle    105.5515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1888"
}

Galaxy "NGC 1889:MCG 2-14-14:ARP 123"
{
        Type  "E0"
        RA            5.3764
        Dec         -11.4969
        Distance   1.131e+08  # method: V
        Radius          9871
        AbsMag         -18.6
        Axis    [  0.1663   0.4650  -0.8695]
        Angle    180.3056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1889"
}

Galaxy "NGC 1892:ESO 85-61:IRAS 05169-6500"
{
        Type  "Sc"
        RA            5.2858
        Dec         -64.9603
        Distance   5.912e+07  # method: T-F
        Radius     2.494e+04
        AbsMag        -18.49
        Axis    [  0.6527   0.6204  -0.4350]
        Angle    140.3933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1892"
}

Galaxy "NGC 1906:MCG 3-14-15:IRAS 05224-1559"
{
        Type  "Sc"
        RA            5.4131
        Dec         -15.9428
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.0686   0.6057  -0.7928]
        Angle    121.0604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1906"
}

Galaxy "NGC 1924:MCG 1-14-11:NPM 1:IRAS 05255-0521"
{
        Type  "SBc"
        RA            5.4669
        Dec          -5.3103
        Distance   1.159e+08  # method: V
        Radius     2.697e+04
        AbsMag        -19.45
        Axis    [  0.1258   0.6456  -0.7533]
        Angle    130.6263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1924"
}

Galaxy "NGC 1930:ESO 253-4"
{
        Type  "S0"
        RA            5.4322
        Dec         -46.7283
        Distance   1.732e+08  # method: T-F
        Radius     4.787e+04
        AbsMag        -20.23
        Axis    [  0.8346   0.5379  -0.1189]
        Angle    152.9046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1930"
}

Galaxy "NGC 1947:ESO 85-87:AM 0526-634:IRAS 05264-6347"
{
        Type  "S0"
        RA            5.4464
        Dec         -63.7608
        Distance   5.423e+07  # method: V
        Radius     2.366e+04
        AbsMag         -19.3
        Axis    [  0.5421   0.2028  -0.8155]
        Angle    153.9372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1947"
}

Galaxy "NGC 1954:MCG 2-15-3:NPM 1:IRAS 05305-1405"
{
        Type  "Sc"
        RA            5.5467
        Dec         -14.0622
        Distance   1.432e+08  # method: V
        Radius      8.75e+04
        AbsMag        -20.61
        Axis    [ -0.0200   0.6057  -0.7954]
        Angle    116.0324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1954"
}

Galaxy "NGC 1956:ESO 16-2:AM 0522-774"
{
        Type  "Sa"
        RA            5.3264
        Dec         -77.7297
        Distance   2.211e+08  # method: V
        Radius      6.11e+04
        AbsMag        -20.16
        Axis    [  0.7421   0.4873  -0.4602]
        Angle    156.5757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1956"
}

Galaxy "NGC 1957:NPM 1"
{
        Type  "E0"
        RA            5.5486
        Dec         -14.1325
        Distance   3.312e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -20.13
        Axis    [  0.1239   0.4432  -0.8878]
        Angle    180.2905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1957"
}

Galaxy "NGC 1961:IC 2133:UGC 3334:MCG 12-6-7"
{
        Type  "SBc"
        RA            5.7008
        Dec          69.3786
        Distance   1.772e+08  # method: V
        Radius      1.16e+05
        AbsMag        -21.97
        Axis    [ -0.0439   0.9964   0.0726]
        Angle     90.8282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1961"
}

Galaxy "NGC 1964:ESO 554-10:MCG 4-14-3:IRAS 05312-2158"
{
        Type  "SBb"
        RA            5.5558
        Dec         -21.9453
        Distance   7.108e+07  # method: T-F
        Radius     5.789e+04
        AbsMag        -20.09
        Axis    [  0.6655   0.7440   0.0602]
        Angle    131.6166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1964"
}

Galaxy "NGC 1979:ESO 487-24:MCG 4-14-4:AM 0531-232"
{
        Type  "S0"
        RA            5.5669
        Dec         -23.3103
        Distance   7.717e+07  # distance uncertain!
        Radius      2.02e+04
        AbsMag        -19.07
        Axis    [  0.9962   0.0692   0.0534]
        Angle    136.9671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1979"
}

Galaxy "NGC 1989:ESO 423-21:MCG 5-14-4:AM 0532-304"
{
        Type  "S0"
        RA            5.5731
        Dec         -30.8006
        Distance   4.903e+08  # method: V
        Radius     9.983e+04
        AbsMag        -21.78
        Axis    [  0.5137   0.5114  -0.6889]
        Angle    131.7834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1989"
}

Galaxy "NGC 1992:ESO 423-23:MCG 5-14-7:AM 0532-305"
{
        Type  "Sa"
        RA            5.5753
        Dec         -30.8969
        Distance    4.81e+08  # method: V
        Radius     7.696e+04
        AbsMag        -21.14
        Axis    [  0.7853   0.5927  -0.1787]
        Angle    134.3197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1992"
}

Galaxy "NGC 1993:ESO 554-14:MCG 3-15-3"
{
        Type  "S0"
        RA            5.5903
        Dec         -17.8150
        Distance   1.017e+08  # distance uncertain!
        Radius     2.219e+04
        AbsMag        -19.07
        Axis    [  0.6998   0.4819  -0.5273]
        Angle    132.6296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1993"
}

Galaxy "NGC 1998:ESO 204-15"
{
        Type  "S0"
        RA            5.5542
        Dec         -48.6953
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.8296   0.5575  -0.0315]
        Angle    158.1913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 1998"
}

Galaxy "NGC 2007:ESO 204-19:AM 0533-505"
{
        Type  "Sc"
        RA            5.5828
        Dec         -50.9217
        Distance   1.932e+08  # method: T-F
        Radius     4.777e+04
        AbsMag        -19.76
        Axis    [  0.6046   0.6276  -0.4905]
        Angle    126.9731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2007"
}

Galaxy "NGC 2008:ESO 204-20:AM 0533-505:IRAS 05338-5059"
{
        Type  "Sc"
        RA            5.5842
        Dec         -50.9661
        Distance   4.705e+08  # method: V
        Radius     9.581e+04
        AbsMag         -21.9
        Axis    [  0.5305   0.5050  -0.6808]
        Angle    125.5140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2008"
}

Galaxy "NGC 2012:ESO 16-5"
{
        Type  "S0"
        RA            5.3764
        Dec         -79.8519
        Distance    2.22e+08  # method: V
        Radius     3.551e+04
        AbsMag        -20.06
        Axis    [  0.5805   0.2407  -0.7779]
        Angle    139.8045
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2012"
}

Galaxy "NGC 2049:ESO 424-11:MCG 5-14-11:AM 0541-300"
{
        Type  "Sa"
        RA            5.7208
        Dec         -30.0781
        Distance   1.168e+08  # distance uncertain!
        Radius     3.398e+04
        AbsMag        -19.07
        Axis    [ -0.0726   0.3873  -0.9191]
        Angle    118.1897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2049"
}

Galaxy "NGC 2073:ESO 554-31:MCG 4-14-24"
{
        Type  "S0"
        RA            5.7647
        Dec         -21.9992
        Distance   1.017e+08  # distance uncertain!
        Radius     2.219e+04
        AbsMag        -19.07
        Axis    [  0.9661   0.2340   0.1090]
        Angle    137.0888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2073"
}

Galaxy "NGC 2076:MCG 3-15-12:IRAS 05445-1648"
{
        Type  "Sa"
        RA            5.7797
        Dec         -16.7828
        Distance   1.001e+08  # method: V
        Radius     3.203e+04
        AbsMag        -18.53
        Axis    [  0.7462   0.6554  -0.1169]
        Angle    120.9575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2076"
}

Galaxy "NGC 2082:ESO 86-21:IRAS 05415-6419"
{
        Type  "SBb"
        RA            5.6972
        Dec         -64.3014
        Distance   5.848e+07  # method: V
        Radius     1.106e+04
        AbsMag        -18.67
        Axis    [  0.9319   0.2386  -0.2733]
        Angle    171.1679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2082"
}

Galaxy "NGC 2087:ESO 159-26:IRAS 05433-5533"
{
        Type  "SBa"
        RA            5.7378
        Dec         -55.5331
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.3581   0.2613  -0.8964]
        Angle    136.4438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2087"
}

Galaxy "NGC 2089:ESO 554-36:MCG 3-15-16:IRAS 05456-1738"
{
        Type  "S0"
        RA            5.7975
        Dec         -17.6028
        Distance   8.081e+07  # distance uncertain!
        Radius     2.233e+04
        AbsMag        -19.07
        Axis    [  0.7857   0.6126  -0.0863]
        Angle    123.5132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2089"
}

Galaxy "NGC 2090:ESO 363-23:MCG 6-13-9:AM 0545-341"
{
        Type  "Sc"
        RA            5.7836
        Dec         -34.2508
        Distance   4.811e+07  # method: T-F
        Radius     3.429e+04
        AbsMag        -18.84
        Axis    [  0.8077   0.5843   0.0792]
        Angle    147.7745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2090"
}

Galaxy "NGC 2101:ESO 205-1:AM 0545-520:IRAS 05451-5206"
{
        Type  "Irr"
        RA            5.7728
        Dec         -52.0900
        Distance   5.658e+07  # method: V
        Radius     1.646e+04
        AbsMag         -17.5
        Axis    [  0.6708   0.4569  -0.5842]
        Angle    136.7567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2101"
}

Galaxy "NGC 2104:ESO 205-2:AM 0545-513:IRAS 05459-5133"
{
        Type  "Irr"
        RA            5.7844
        Dec         -51.5531
        Distance   4.236e+07  # method: T-F
        Radius     1.232e+04
        AbsMag        -17.37
        Axis    [  0.1056   0.2631  -0.9590]
        Angle    112.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2104"
}

Galaxy "NGC 2106:ESO 555-3:MCG 4-14-40"
{
        Type  "S0"
        RA            5.8461
        Dec         -21.5669
        Distance    8.86e+07  # distance uncertain!
        Radius     3.479e+04
        AbsMag        -19.07
        Axis    [  0.4072   0.6954  -0.5921]
        Angle    110.5199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2106"
}

Galaxy "NGC 2110:MCG 1-15-4:IRAS 05497-0728"
{
        Type  "S0"
        RA            5.8697
        Dec          -7.4564
        Distance   1.061e+08  # method: V
        Radius     2.623e+04
        AbsMag        -19.06
        Axis    [ -0.1598   0.5123  -0.8438]
        Angle    135.7268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2110"
}

Galaxy "NGC 2115:ESO 205-6:AM 0550-503:IRAS 05501-5036"
{
        Type  "Sa"
        RA            5.8553
        Dec         -50.5833
        Distance   1.404e+08  # distance uncertain!
        Radius     1.634e+04
        AbsMag        -19.07
        Axis    [  0.8722   0.3276  -0.3631]
        Angle    153.3788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2115"
}

Galaxy "NGC 2115A:ESO 205-6A"
{
        Type  "Sa"
        RA            5.8558
        Dec         -50.5922
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.8397   0.3645  -0.4025]
        Angle    150.3273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2115A"
}

Galaxy "NGC 2119:UGC 3380"
{
        Type  "E0"
        RA            5.9572
        Dec          11.9489
        Distance   2.884e+08  # distance uncertain!
        Radius     5.034e+04
        AbsMag        -20.13
        Axis    [  0.2395   0.6157  -0.7508]
        Angle    158.6160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2119"
}

Galaxy "NGC 2124:ESO 555-16:MCG 3-16-3:IRAS 05557-2005"
{
        Type  "Sb"
        RA            5.9644
        Dec         -20.0850
        Distance   1.525e+08  # method: T-F
        Radius      5.99e+04
        AbsMag        -19.95
        Axis    [  0.7467   0.6241   0.2300]
        Angle    141.3486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2124"
}

Galaxy "NGC 2128:UGC 3392:MCG 10-9-10:ZWG 284.6"
{
        Type  "S0"
        RA            6.0761
        Dec          57.6275
        Distance   1.427e+08  # method: V
        Radius     3.113e+04
        AbsMag         -19.6
        Axis    [  0.3314   0.9311   0.1525]
        Angle     73.7418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2128"
}

Galaxy "NGC 2131:ESO 488-50"
{
        Type  "Irr"
        RA            5.9797
        Dec         -26.6531
        Distance    7.91e+07  # method: V
        Radius     1.265e+04
        AbsMag        -17.32
        Axis    [  0.2951   0.6424  -0.7072]
        Angle    106.7901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2131"
}

Galaxy "NGC 2139:IC 2154:ESO 488-54:MCG 4-15-5"
{
        Type  "SBc"
        RA            6.0189
        Dec         -23.6728
        Distance   9.069e+07  # method: T-F
        Radius     3.166e+04
        AbsMag        -19.92
        Axis    [  0.1930   0.4794  -0.8561]
        Angle    129.1837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2139"
}

Galaxy "NGC 2144:ESO 16-10:AM 0546-820:IRAS 05464-8208"
{
        Type  "Sa"
        RA            5.6822
        Dec         -82.1189
        Distance   1.281e+08  # distance uncertain!
        Radius     2.608e+04
        AbsMag        -19.07
        Axis    [  0.7038   0.1732  -0.6889]
        Angle    162.3013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2144"
}

Galaxy "NGC 2146:UGC 3429:MCG 13-5-22:ZWG 348.17"
{
        Type  "SBb"
        RA            6.3106
        Dec          78.3558
        Distance   3.959e+07  # method: V
        Radius      3.11e+04
        AbsMag        -19.12
        Axis    [  0.0268   0.8311   0.5554]
        Angle     72.3881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2146"
}

Galaxy "NGC 2146A:UGC 3439:MCG 13-5-25:ZWG 348.19"
{
        Type  "SBc"
        RA            6.3983
        Dec          78.5300
        Distance   8.707e+07  # method: T-F
        Radius     3.799e+04
        AbsMag        -18.63
        Axis    [  0.1966   0.5461   0.8143]
        Angle     74.4005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2146A"
}

Galaxy "NGC 2148:ESO 120-24:IRAS 05581-5907"
{
        Type  "Sb"
        RA            5.9792
        Dec         -59.1264
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.2329   0.1775  -0.9562]
        Angle    132.5987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2148"
}

Galaxy "NGC 2150:ESO 57-55:IRAS 05562-6933"
{
        Type  "SBb"
        RA            5.9294
        Dec         -69.5608
        Distance   2.036e+08  # method: V
        Radius     3.554e+04
        AbsMag        -19.98
        Axis    [  0.3307   0.1110  -0.9372]
        Angle    138.4680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2150"
}

Galaxy "NGC 2152:ESO 205-15"
{
        Type  "SBa"
        RA            6.0153
        Dec         -50.7408
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.7580   0.4225  -0.4969]
        Angle    141.3741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2152"
}

Galaxy "NGC 2178:ESO 86-53"
{
        Type  "E1"
        RA            6.0464
        Dec         -63.7639
        Distance    1.82e+08  # distance uncertain!
        Radius     2.382e+04
        AbsMag        -20.13
        Axis    [  1.0000  -0.0026  -0.0055]
        Angle    177.2032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2178"
}

Galaxy "NGC 2179:ESO 555-38:MCG 4-15-11:IRAS 06059-2144"
{
        Type  "SBa"
        RA            6.1339
        Dec         -21.7461
        Distance   1.306e+08  # method: V
        Radius     2.089e+04
        AbsMag        -19.81
        Axis    [ -0.0658   0.4054  -0.9117]
        Angle    138.9831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2179"
}

Galaxy "NGC 2187:ESO 57-68:AM 0604-693:IRAS 06041-6934"
{
        Type  "Sa"
        RA            6.0644
        Dec         -69.5778
        Distance   9.278e+07  # distance uncertain!
        Radius     1.754e+04
        AbsMag        -19.07
        Axis    [  0.6226   0.2675  -0.7354]
        Angle    143.5557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2187"
}

Galaxy "NGC 2187A:ESO 57-68A"
{
        Type  "Sa"
        RA            6.0622
        Dec         -69.5881
        Distance   8.081e+07  # distance uncertain!
        Radius     1.998e+04
        AbsMag        -19.07
        Axis    [  0.6075   0.3441  -0.7159]
        Angle    134.4693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2187A"
}

Galaxy "NGC 2188:ESO 364-37:MCG 6-14-8:AM 0608-340"
{
        Type  "Irr"
        RA            6.1692
        Dec         -34.1050
        Distance   3.783e+07  # method: V
        Radius     2.311e+04
        AbsMag        -18.22
        Axis    [ -0.2200   0.2981  -0.9288]
        Angle     98.0040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2188"
}

Galaxy "NGC 2191:ESO 160-14"
{
        Type  "S0"
        RA            6.1397
        Dec         -52.5122
        Distance    2.08e+08  # method: V
        Radius     5.142e+04
        AbsMag        -21.62
        Axis    [  0.4322   0.4011  -0.8077]
        Angle    118.8016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2191"
}

Galaxy "NGC 2196:ESO 556-4:MCG 4-15-14:UGCA 121"
{
        Type  "Sa"
        RA            6.2025
        Dec         -21.8061
        Distance   1.093e+08  # method: V
        Radius      4.45e+04
        AbsMag        -20.82
        Axis    [  0.8767   0.4535  -0.1604]
        Angle    126.4743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2196"
}

Galaxy "NGC 2199:ESO 34-3:FAIR 247:IRAS 06060-7323"
{
        Type  "Sa"
        RA            6.0789
        Dec         -73.4000
        Distance    2.65e+08  # method: T-F
        Radius     7.709e+04
        AbsMag        -20.75
        Axis    [  0.7836   0.5445  -0.2992]
        Angle    163.0378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2199"
}

Galaxy "NGC 2200:ESO 254-39:MCG 7-13-6:AM 0611-433"
{
        Type  "SBc"
        RA            6.2214
        Dec         -43.6631
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.0438   0.2659  -0.9630]
        Angle    123.4976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2200"
}

Galaxy "NGC 2201:ESO 254-40:MCG 7-13-7:AM 0611-433"
{
        Type  "SBb"
        RA            6.2253
        Dec         -43.7050
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.4170   0.5124  -0.7507]
        Angle    110.6874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2201"
}

Galaxy "NGC 2205:ESO 86-63:AM 0610-623"
{
        Type  "S0"
        RA            6.1756
        Dec         -62.5386
        Distance   3.831e+08  # method: V
        Radius       7.8e+04
        AbsMag        -21.65
        Axis    [  0.7014   0.3785  -0.6040]
        Angle    141.4028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2205"
}

Galaxy "NGC 2206:ESO 489-26:MCG 4-15-19:UGCA 123"
{
        Type  "SBc"
        RA            6.2664
        Dec         -26.7653
        Distance   2.682e+08  # method: T-F
        Radius     9.363e+04
        AbsMag        -21.67
        Axis    [  0.1338   0.5235  -0.8415]
        Angle    109.0052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2206"
}

Galaxy "NGC 2207:ESO 556-8:MCG 4-15-20:UGCA 124"
{
        Type  "SBc"
        RA            6.2725
        Dec         -21.3728
        Distance   1.288e+08  # method: V
        Radius     7.305e+04
        AbsMag        -21.18
        Axis    [  0.0832   0.5476  -0.8326]
        Angle    110.0088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2207"
}

Galaxy "NGC 2208:UGC 3452:MCG 9-11-10:ZWG 260.7"
{
        Type  "S0"
        RA            6.3761
        Dec          51.9100
        Distance   2.563e+08  # method: V
        Radius     5.965e+04
        AbsMag        -20.18
        Axis    [ -0.0396   0.9782  -0.2039]
        Angle     97.1116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2208"
}

Galaxy "NGC 2211:ESO 556-13:MCG 3-16-21"
{
        Type  "S0"
        RA            6.3083
        Dec         -18.5378
        Distance   1.168e+08  # distance uncertain!
        Radius     2.378e+04
        AbsMag        -19.07
        Axis    [  0.8112   0.5822   0.0543]
        Angle    126.6008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2211"
}

Galaxy "NGC 2212:ESO 556-14:MCG 3-16-22"
{
        Type  "SBa"
        RA            6.3097
        Dec         -18.5200
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [  0.0998   0.5961  -0.7967]
        Angle    106.3574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2212"
}

Galaxy "NGC 2216:ESO 556-17:MCG 4-15-27:IRAS 06194-2203"
{
        Type  "SBb"
        RA            6.3583
        Dec         -22.0872
        Distance   1.168e+08  # distance uncertain!
        Radius     2.378e+04
        AbsMag        -19.07
        Axis    [  0.9185   0.3925  -0.0485]
        Angle    130.0598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2216"
}

Galaxy "NGC 2217:ESO 489-42:MCG 5-15-10:AM 0619-271"
{
        Type  "SBa"
        RA            6.3608
        Dec         -27.2342
        Distance   7.805e+07  # method: V
        Radius     5.336e+04
        AbsMag        -20.29
        Axis    [  0.9555   0.2651  -0.1295]
        Angle    135.9078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2217"
}

Galaxy "NGC 2221:ESO 121-24:AM 0619-573:IRAS 06194-5733"
{
        Type  "Sa"
        RA            6.3375
        Dec         -57.5786
        Distance   1.145e+08  # method: V
        Radius      3.33e+04
        AbsMag        -18.83
        Axis    [  0.7556   0.6547   0.0236]
        Angle    170.3395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2221"
}

Galaxy "NGC 2222:ESO 121-25:AM 0619-573"
{
        Type  "SBa"
        RA            6.3378
        Dec         -57.5333
        Distance   1.216e+08  # method: V
        Radius     2.123e+04
        AbsMag        -18.66
        Axis    [  0.1585   0.2732  -0.9488]
        Angle     94.0581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2222"
}

Galaxy "NGC 2223:ESO 489-49:MCG 4-16-2:UGCA 129"
{
        Type  "SBb"
        RA            6.4097
        Dec         -22.8386
        Distance   1.282e+08  # method: V
        Radius     5.592e+04
        AbsMag        -20.67
        Axis    [ -0.1101   0.3745  -0.9207]
        Angle    142.6597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2223"
}

Galaxy "NGC 2227:ESO 556-23:MCG 4-16-4:IRAS 06238-2158"
{
        Type  "SBc"
        RA            6.4325
        Dec         -22.0047
        Distance   1.072e+08  # method: T-F
        Radius     3.274e+04
        AbsMag        -19.28
        Axis    [  0.8535   0.5204   0.0263]
        Angle    129.7205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2227"
}

Galaxy "NGC 2228:ESO 87-7:FAIR 249:DRCG 50-89"
{
        Type  "S0"
        RA            6.3542
        Dec         -64.4592
        Distance   3.323e+08  # method: V
        Radius     3.867e+04
        AbsMag        -20.44
        Axis    [  0.9644   0.2621  -0.0354]
        Angle    176.6279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2228"
}

Galaxy "NGC 2229:ESO 87-8:AM 0621-645:DRCG 50-55"
{
        Type  "SBa"
        RA            6.3564
        Dec         -64.9567
        Distance   1.612e+08  # distance uncertain!
        Radius     3.517e+04
        AbsMag        -19.07
        Axis    [  0.3443   0.3115  -0.8857]
        Angle    101.4137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2229"
}

Galaxy "NGC 2230:ESO 87-9:AM 0621-645:DRCG 50-42"
{
        Type  "S0"
        RA            6.3575
        Dec         -64.9928
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [  0.7268   0.2971  -0.6192]
        Angle    148.1911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2230"
}

Galaxy "NGC 2233:ESO 87-11:AM 0621-645:DRCG 50-41"
{
        Type  "S0"
        RA            6.3611
        Dec         -65.0333
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.7069   0.6548  -0.2675]
        Angle    148.4341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2233"
}

Galaxy "NGC 2235:ESO 87-13:AM 0621-645:DRCG 50-52"
{
        Type  "E2"
        RA            6.3728
        Dec         -64.9347
        Distance   2.188e+08  # distance uncertain!
        Radius     4.455e+04
        AbsMag        -20.13
        Axis    [  0.8033  -0.0087  -0.5955]
        Angle    177.3696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2235"
}

Galaxy "NGC 2255:ESO 365-31:MCG 6-15-10:IRAS 06321-3446"
{
        Type  "SBc"
        RA            6.5661
        Dec         -34.8117
        Distance   3.004e+08  # method: T-F
        Radius     6.554e+04
        AbsMag        -20.62
        Axis    [  0.0076   0.3925  -0.9197]
        Angle    103.7222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2255"
}

Galaxy "NGC 2256:UGC 3519:MCG 12-7-15:ZWG 330.14"
{
        Type  "S0"
        RA            6.7872
        Dec          74.2369
        Distance   1.115e+08  # distance uncertain!
        Radius     3.731e+04
        AbsMag        -19.07
        Axis    [  0.2363   0.9670   0.0949]
        Angle     65.9889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2256"
}

Galaxy "NGC 2258:UGC 3523:MCG 12-7-16:ZWG 330.15"
{
        Type  "S0"
        RA            6.7961
        Dec          74.4814
        Distance   8.461e+07  # distance uncertain!
        Radius     2.831e+04
        AbsMag        -19.07
        Axis    [ -0.3516   0.9249  -0.1448]
        Angle    126.5403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2258"
}

Galaxy "NGC 2263:ESO 490-19:MCG 4-16-14:IRAS 06364-2448"
{
        Type  "SBb"
        RA            6.6411
        Dec         -24.8486
        Distance   8.081e+07  # distance uncertain!
        Radius     3.056e+04
        AbsMag        -19.07
        Axis    [  0.1184   0.4408  -0.8898]
        Angle    121.0851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2263"
}

Galaxy "NGC 2267:ESO 426-29:MCG 5-16-15:AM 0638-322"
{
        Type  "S0"
        RA            6.6808
        Dec         -32.4822
        Distance   9.278e+07  # distance uncertain!
        Radius     2.294e+04
        AbsMag        -19.07
        Axis    [  0.3507   0.4218  -0.8361]
        Angle    119.4572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2267"
}

Galaxy "NGC 2268:UGC 3653:MCG 14-4-22:ZWG 362.36"
{
        Type  "SBc"
        RA            7.2381
        Dec          84.3822
        Distance    1.43e+08  # method: T-F
        Radius     5.616e+04
        AbsMag        -21.01
        Axis    [  0.0152   0.7616   0.6479]
        Angle     68.1605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2268"
}

Galaxy "NGC 2271:ESO 490-34:MCG 4-16-17"
{
        Type  "S0"
        RA            6.7144
        Dec         -23.4758
        Distance   1.036e+08  # method: S
        Radius     3.165e+04
        AbsMag        -19.51
        Axis    [  0.6916   0.5552  -0.4620]
        Angle    111.4665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2271"
}

Galaxy "NGC 2272:ESO 490-33:MCG 5-16-17"
{
        Type  "S0"
        RA            6.7114
        Dec         -27.4597
        Distance   7.717e+07  # distance uncertain!
        Radius     2.694e+04
        AbsMag        -19.07
        Axis    [  0.2824   0.4962  -0.8210]
        Angle    110.2515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2272"
}

Galaxy "NGC 2273:UGC 3546:MCG 10-10-15:MK 620"
{
        Type  "SBa"
        RA            6.8356
        Dec          60.8458
        Distance   8.503e+07  # method: V
        Radius     4.452e+04
        AbsMag        -19.58
        Axis    [  0.3621   0.7956   0.4857]
        Angle     67.3044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2273"
}

Galaxy "NGC 2273A:UGC 3504:MCG 10-10-9:ZWG 285.3"
{
        Type  "Sc"
        RA            6.6686
        Dec          60.0806
        Distance   9.672e+07  # method: V
        Radius     3.798e+04
        AbsMag        -19.06
        Axis    [ -0.1282   0.9467  -0.2955]
        Angle    115.1401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2273A"
}

Galaxy "NGC 2273B:UGC 3530:MCG 10-10-13:ZWG 285.5"
{
        Type  "SBc"
        RA            6.7753
        Dec          60.3403
        Distance   1.158e+08  # method: T-F
        Radius     4.547e+04
        AbsMag        -19.55
        Axis    [  0.3520   0.7204   0.5976]
        Angle     72.2298
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2273B"
}

Galaxy "NGC 2274:UGC 3541:MCG 6-15-8:ZWG 175.15"
{
        Type  "E0"
        RA            6.7881
        Dec          33.5675
        Distance   2.338e+08  # method: V
        Radius      4.08e+04
        AbsMag        -20.88
        Axis    [  0.0326   0.7610  -0.6480]
        Angle    160.2638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2274"
}

Galaxy "NGC 2275:UGC 3542:MCG 6-15-7:ZWG 175.16"
{
        Type  "Sb"
        RA            6.7881
        Dec          33.5992
        Distance   2.243e+08  # method: V
        Radius     4.242e+04
        AbsMag        -20.09
        Axis    [ -0.2540   0.8057  -0.5350]
        Angle    120.7790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2275"
}

Galaxy "NGC 2276:UGC 3740:MCG 14-4-28:ZWG 362.42"
{
        Type  "SBc"
        RA            7.4536
        Dec          85.7550
        Distance   1.085e+08  # method: V
        Radius     3.628e+04
        AbsMag        -20.61
        Axis    [  0.5908   0.1549   0.7918]
        Angle     45.7702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2276"
}

Galaxy "NGC 2280:ESO 427-2:MCG 5-16-20:UGCA 131"
{
        Type  "Sc"
        RA            6.7467
        Dec         -27.6389
        Distance   8.168e+07  # method: T-F
        Radius     7.484e+04
        AbsMag        -20.79
        Axis    [ -0.1498   0.3833  -0.9114]
        Angle    104.4393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2280"
}

Galaxy "NGC 2283:ESO 557-13:MCG 3-18-2:IRAS 06436-1809"
{
        Type  "SBc"
        RA            6.7644
        Dec         -18.2103
        Distance   4.353e+07  # method: V
        Radius     2.279e+04
        AbsMag        -17.73
        Axis    [  0.9444   0.3164   0.0890]
        Angle    131.7032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2283"
}

Galaxy "NGC 2288:MCG 6-15-11:ZWG 175.17"
{
        Type  "E0"
        RA            6.8478
        Dec          33.4622
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.5215   0.5997  -0.6069]
        Angle    106.0941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2288"
}

Galaxy "NGC 2289:UGC 3560:MCG 6-15-10:ZWG 175.18"
{
        Type  "S0"
        RA            6.8481
        Dec          33.4792
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.1833   0.9701  -0.1589]
        Angle     79.8953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2289"
}

Galaxy "NGC 2290:UGC 3562:MCG 6-15-12:ZWG 175.19"
{
        Type  "Sa"
        RA            6.8489
        Dec          33.4381
        Distance   2.329e+08  # method: V
        Radius     4.065e+04
        AbsMag        -20.07
        Axis    [  0.6177   0.7689   0.1651]
        Angle     76.2464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2290"
}

Galaxy "NGC 2291:ZWG 175.20:MCG 6-15-13:NPM 1"
{
        Type  "S0"
        RA            6.8494
        Dec          33.5256
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.0326   0.8660  -0.4990]
        Angle    103.9383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2291"
}

Galaxy "NGC 2292:ESO 490-48:MCG 4-16-22:VV 178"
{
        Type  "S0"
        RA            6.7942
        Dec         -26.7464
        Distance   1.075e+08  # method: T-F
        Radius     6.253e+04
        AbsMag        -20.79
        Axis    [  0.3176   0.4036  -0.8580]
        Angle    125.9054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2292"
}

Galaxy "NGC 2293:ESO 490-49:MCG 4-16-23:VV 178"
{
        Type  "SBa"
        RA            6.7950
        Dec         -26.7547
        Distance   5.565e+07  # method: S
        Radius     3.237e+04
        AbsMag        -19.06
        Axis    [  0.2887   0.4382  -0.8513]
        Angle    119.0889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2293"
}

Galaxy "NGC 2294:MCG 6-15-14:ZWG 175.21:IRAS 06478+3335"
{
        Type  "E6"
        RA            6.8531
        Dec          33.5269
        Distance   3.312e+08  # distance uncertain!
        Radius     3.853e+04
        AbsMag        -20.13
        Axis    [  0.9894  -0.1040  -0.1012]
        Angle     79.9528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2294"
}

Galaxy "NGC 2295:ESO 490-47:MCG 4-16-21:VV 178"
{
        Type  "Sb"
        RA            6.7897
        Dec         -26.7361
        Distance   1.115e+08  # distance uncertain!
        Radius     3.407e+04
        AbsMag        -19.07
        Axis    [  0.6997   0.7024  -0.1307]
        Angle    114.5891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2295"
}

Galaxy "NGC 2297:ESO 87-40:FAIR 256:IRAS 06440-6339"
{
        Type  "SBc"
        RA            6.7400
        Dec         -63.7175
        Distance    1.58e+08  # method: V
        Radius     4.365e+04
        AbsMag        -20.02
        Axis    [  0.5636   0.2074  -0.7996]
        Angle    140.5252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2297"
}

Galaxy "NGC 2300:UGC 3798:MCG 14-4-31:ZWG 362.43"
{
        Type  "S0"
        RA            7.5389
        Dec          85.7092
        Distance     1.4e+08  # method: T-F
        Radius     5.702e+04
        AbsMag        -21.06
        Axis    [  0.0040   0.8949   0.4462]
        Angle     66.3284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2300"
}

Galaxy "NGC 2303:UGC 3603:MCG 8-13-31:ZWG 234.30"
{
        Type  "E0"
        RA            6.9381
        Dec          45.4933
        Distance    2.87e+08  # method: V
        Radius     6.261e+04
        AbsMag        -20.82
        Axis    [  0.9765  -0.2120  -0.0394]
        Angle     69.2160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2303"
}

Galaxy "NGC 2305:ESO 87-44:AM 0648-641"
{
        Type  "E2"
        RA            6.8103
        Dec         -64.2728
        Distance   1.289e+08  # method: T-F
        Radius     3.939e+04
        AbsMag        -20.18
        Axis    [  0.2329   0.0044  -0.9725]
        Angle    174.4853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2305"
}

Galaxy "NGC 2307:ESO 87-45:AM 0648-641:IRAS 06485-6416"
{
        Type  "SBb"
        RA            6.8142
        Dec         -64.3350
        Distance   2.107e+08  # method: V
        Radius      5.21e+04
        AbsMag        -20.95
        Axis    [  0.2077   0.0480  -0.9770]
        Angle    151.8407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2307"
}

Galaxy "NGC 2308:UGC 3618:MCG 8-13-37:ZWG 234.37"
{
        Type  "Sb"
        RA            6.9769
        Dec          45.2111
        Distance   2.689e+08  # method: V
        Radius     7.039e+04
        AbsMag        -20.38
        Axis    [ -0.3693   0.8106  -0.4544]
        Angle    130.0444
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2308"
}

Galaxy "NGC 2310:ESO 309-7:MCG 7-15-1:AM 0652-405"
{
        Type  "S0"
        RA            6.8981
        Dec         -40.8636
        Distance   5.989e+07  # method: V
        Radius     3.745e+04
        AbsMag        -18.62
        Axis    [  0.6730   0.7128  -0.1977]
        Angle    120.3857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2310"
}

Galaxy "NGC 2314:UGC 3677:MCG 13-6-3:ZWG 348.32"
{
        Type  "E3"
        RA            7.1753
        Dec          75.3278
        Distance   2.186e+08  # method: T-F
        Radius     3.498e+04
        AbsMag        -20.93
        Axis    [  0.9705   0.1620  -0.1785]
        Angle     38.1936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2314"
}

Galaxy "NGC 2315:UGC 3633:MCG 8-13-45:ZWG 234.41"
{
        Type  "Sa"
        RA            7.0425
        Dec          50.5908
        Distance   2.823e+08  # method: V
        Radius     5.337e+04
        AbsMag        -20.19
        Axis    [ -0.3631   0.9281   0.0822]
        Angle     88.4439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2315"
}

Galaxy "NGC 2320:UGC 3659:MCG 8-13-51:ZWG 234.47"
{
        Type  "E0"
        RA            7.0947
        Dec          50.5808
        Distance   3.008e+08  # method: T-F
        Radius     6.125e+04
        AbsMag        -21.72
        Axis    [  0.1741   0.8219  -0.5424]
        Angle    130.1106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2320"
}

Galaxy "NGC 2321:UGC 3663:MCG 8-13-53:ZWG 234.51"
{
        Type  "SBa"
        RA            7.0994
        Dec          50.7567
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [ -0.1178   0.9261  -0.3585]
        Angle    106.5438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2321"
}

Galaxy "NGC 2322:UGC 3662:MCG 8-13-54:ZWG 234.50"
{
        Type  "SBa"
        RA            7.1000
        Dec          50.5106
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [ -0.4019   0.9034  -0.1497]
        Angle     98.6948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2322"
}

Galaxy "NGC 2325:ESO 427-28:MCG 5-17-5"
{
        Type  "E4"
        RA            7.0444
        Dec         -28.6978
        Distance   8.345e+07  # method: S
        Radius     3.641e+04
        AbsMag        -20.04
        Axis    [  0.9842  -0.0792  -0.1582]
        Angle    141.9748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2325"
}

Galaxy "NGC 2326:UGC 3681:MCG 8-13-62:ZWG 234.60"
{
        Type  "SBb"
        RA            7.1361
        Dec          50.6822
        Distance   2.746e+08  # method: V
        Radius     7.589e+04
        AbsMag        -20.63
        Axis    [  0.1403   0.8872  -0.4395]
        Angle    102.4276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2326"
}

Galaxy "NGC 2326A:UGC 3687:MCG 8-13-67:ZWG 234.66"
{
        Type  "Irr"
        RA            7.1428
        Dec          50.6317
        Distance   3.981e+08  # distance uncertain!
        Radius     5.791e+04
        AbsMag        -20.13
        Axis    [  0.7575   0.3500   0.5511]
        Angle     75.2527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2326A"
}

Galaxy "NGC 2328:ESO 309-16:MCG 7-15-2:IRAS 07010-4159"
{
        Type  "S0"
        RA            7.0433
        Dec         -42.0681
        Distance   5.894e+07  # method: V
        Radius     1.114e+04
        AbsMag        -18.48
        Axis    [  0.3811   0.3915  -0.8375]
        Angle    110.0213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2328"
}

Galaxy "NGC 2329:UGC 3695:MCG 8-13-73:ZWG 234.70"
{
        Type  "S0"
        RA            7.1519
        Dec          48.6158
        Distance   3.008e+08  # method: T-F
        Radius     5.687e+04
        AbsMag        -21.32
        Axis    [ -0.2717   0.8365  -0.4758]
        Angle    140.3276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2329"
}

Galaxy "NGC 2330:IC 457:MCG 8-13-78:ZWG 234.74"
{
        Type  "E0"
        RA            7.1578
        Dec          50.1531
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.9449   0.1402  -0.2957]
        Angle     63.2336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2330"
}

Galaxy "NGC 2332:UGC 3699:MCG 8-13-79:ZWG 234.75"
{
        Type  "S0"
        RA            7.1592
        Dec          50.1819
        Distance   2.666e+08  # method: V
        Radius     5.816e+04
        AbsMag        -20.76
        Axis    [  0.4919   0.8478   0.1984]
        Angle     64.9348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2332"
}

Galaxy "NGC 2333:UGC 3689:MCG 6-16-20:ZWG 176.18"
{
        Type  "Sa"
        RA            7.1392
        Dec          35.1700
        Distance   2.194e+08  # method: V
        Radius     3.192e+04
        AbsMag        -19.94
        Axis    [  0.8114   0.5489   0.2008]
        Angle     74.1719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2333"
}

Galaxy "NGC 2334:IC 465:MCG 8-13-98:ZWG 234.95"
{
        Type  "E0"
        RA            7.1925
        Dec          50.2489
        Distance   2.877e+08  # method: V
        Radius     3.766e+04
        AbsMag        -20.03
        Axis    [  0.5716   0.6325  -0.5227]
        Angle     83.9424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2334"
}

Galaxy "NGC 2336:UGC 3809:MCG 13-6-6:ZWG 348.34"
{
        Type  "SBc"
        RA            7.4508
        Dec          80.1778
        Distance   1.292e+08  # method: T-F
        Radius     1.334e+05
        AbsMag        -21.89
        Axis    [ -0.4812   0.8647  -0.1444]
        Angle    142.8329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2336"
}

Galaxy "NGC 2336A:UGC 4066:MCG 13-6-12:ZWG 349.11"
{
        Type  "Sc"
        RA            7.9375
        Dec          78.0131
        Distance   1.046e+08  # method: V
        Radius     2.587e+04
        AbsMag        -18.13
        Axis    [  0.7732  -0.6214   0.1263]
        Angle     45.8110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2336A"
}

Galaxy "NGC 2337:UGC 3711:MCG 7-15-10:ZWG 205.23"
{
        Type  "Irr"
        RA            7.1703
        Dec          44.4569
        Distance   2.396e+07  # method: V
        Radius          7319
        AbsMag        -16.33
        Axis    [ -0.0714   0.9527  -0.2953]
        Angle     90.7466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2337"
}

Galaxy "NGC 2339:UGC 3693:MCG 3-19-2:ZWG 85.40"
{
        Type  "SBc"
        RA            7.1389
        Dec          18.7794
        Distance   1.066e+08  # method: V
        Radius     4.186e+04
        AbsMag        -20.07
        Axis    [ -0.3192   0.6665  -0.6737]
        Angle    128.0250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2339"
}

Galaxy "NGC 2340:UGC 3720:MCG 8-13-96:ZWG 234.91"
{
        Type  "E0"
        RA            7.1861
        Dec          50.1747
        Distance   3.008e+08  # method: T-F
        Radius     7.875e+04
        AbsMag        -21.92
        Axis    [  0.5398   0.6546  -0.5292]
        Angle     86.6384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2340"
}

Galaxy "NGC 2341:UGC 3708:MCG 3-19-3:ZWG 86.6"
{
        Type  "Sc"
        RA            7.1533
        Dec          20.6033
        Distance   2.433e+08  # method: V
        Radius     2.831e+04
        AbsMag        -20.46
        Axis    [  0.9849  -0.1638  -0.0559]
        Angle     93.8658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2341"
}

Galaxy "NGC 2342:UGC 3709:MCG 3-19-4:ZWG 86.7"
{
        Type  "Sc"
        RA            7.1550
        Dec          20.6369
        Distance   2.454e+08  # method: V
        Radius     4.996e+04
        AbsMag        -21.18
        Axis    [  0.1786   0.7179  -0.6728]
        Angle    110.7924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2342"
}

Galaxy "NGC 2344:UGC 3734:MCG 8-13-103:ZWG 234.100"
{
        Type  "SBc"
        RA            7.2078
        Dec          47.1672
        Distance   4.815e+07  # method: V
        Radius     1.051e+04
        AbsMag        -18.05
        Axis    [ -0.2630   0.8486  -0.4590]
        Angle    128.6838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2344"
}

Galaxy "NGC 2347:UGC 3759:MCG 11-9-39:ZWG 309.26"
{
        Type  "Sb"
        RA            7.2678
        Dec          64.7114
        Distance   2.023e+08  # method: V
        Radius     5.295e+04
        AbsMag        -20.76
        Axis    [  0.7689   0.0774   0.6346]
        Angle     67.2511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2347"
}

Galaxy "NGC 2350:UGC 3747:MCG 2-19-1:ZWG 57.5"
{
        Type  "Sa"
        RA            7.2200
        Dec          12.2664
        Distance   9.232e+07  # method: V
        Radius      1.88e+04
        AbsMag        -18.26
        Axis    [  0.1322   0.8727  -0.4700]
        Angle     81.1833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2350"
}

Galaxy "NGC 2357:UGC 3782:MCG 4-17-14:ZWG 116.46"
{
        Type  "Sc"
        RA            7.2944
        Dec          23.3564
        Distance   1.297e+08  # method: T-F
        Radius     6.793e+04
        AbsMag         -18.6
        Axis    [ -0.2865   0.9390  -0.1900]
        Angle     75.9335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2357"
}

Galaxy "NGC 2363:UGC 3847:MCG 12-7-39:KCPG 133A"
{
        Type  "Irr"
        RA            7.4747
        Dec          69.1928
        Distance   4.366e+08  # distance uncertain!
        Radius     1.016e+05
        AbsMag        -20.13
        Axis    [  0.6368   0.2710   0.7218]
        Angle     63.8675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2363"
}

Galaxy "NGC 2365:UGC 3821:MCG 4-18-8:ZWG 117.20"
{
        Type  "SBa"
        RA            7.3728
        Dec          22.0833
        Distance   1.104e+08  # method: V
        Radius     4.494e+04
        AbsMag        -19.05
        Axis    [ -0.4453   0.6837  -0.5782]
        Angle    110.5082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2365"
}

Galaxy "NGC 2366:UGC 3851:MCG 12-7-40:DDO 42"
{
        Type  "Irr"
        RA            7.4817
        Dec          69.2161
        Distance   1.672e+07  # method: T-F
        Radius     1.969e+04
        AbsMag        -17.05
        Axis    [  0.4569   0.3647   0.8113]
        Angle     76.4383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2366"
}

Galaxy "NGC 2369:ESO 122-18:AM 0716-621:IRAS 07160-6215"
{
        Type  "SBa"
        RA            7.2769
        Dec         -62.3439
        Distance   1.536e+08  # method: V
        Radius     7.818e+04
        AbsMag        -20.16
        Axis    [ -0.1614  -0.0714  -0.9843]
        Angle     93.8256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2369"
}

Galaxy "NGC 2369A:ESO 88-8:AM 0718-625:IRAS 07182-6250"
{
        Type  "SBc"
        RA            7.3119
        Dec         -62.9367
        Distance   1.586e+08  # method: T-F
        Radius     4.152e+04
        AbsMag        -19.73
        Axis    [  0.8584   0.3535  -0.3717]
        Angle    152.8518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2369A"
}

Galaxy "NGC 2369B:ESO 123-5:IRAS 07199-6157"
{
        Type  "SBc"
        RA            7.3414
        Dec         -62.0539
        Distance   1.341e+08  # distance uncertain!
        Radius     2.926e+04
        AbsMag        -19.07
        Axis    [  0.9558   0.1350  -0.2612]
        Angle    167.9283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2369B"
}

Galaxy "NGC 2370:UGC 3835:MCG 4-18-15:ZWG 117.36"
{
        Type  "SBc"
        RA            7.4169
        Dec          23.7836
        Distance   2.563e+08  # method: V
        Radius     2.982e+04
        AbsMag        -20.08
        Axis    [  0.7991   0.5953   0.0847]
        Angle     78.0458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2370"
}

Galaxy "NGC 2373:UGC 3848:MCG 6-17-4:ZWG 177.14"
{
        Type  "Sc"
        RA            7.4433
        Dec          33.8242
        Distance   3.588e+08  # method: V
        Radius     3.131e+04
        AbsMag        -20.41
        Axis    [ -0.1936   0.7983  -0.5703]
        Angle    120.1117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2373"
}

Galaxy "NGC 2375:UGC 3854:MCG 6-17-5:ZWG 177.17"
{
        Type  "SBb"
        RA            7.4525
        Dec          33.8325
        Distance   3.623e+08  # method: V
        Radius     6.851e+04
        AbsMag        -20.63
        Axis    [ -0.3072   0.7714  -0.5573]
        Angle    124.7732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2375"
}

Galaxy "NGC 2376:MCG 4-18-17:ZWG 117.39:IRAS 07235+2310"
{
        Type  "Sc"
        RA            7.4431
        Dec          23.0733
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.9736  -0.2168  -0.0714]
        Angle     92.1222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2376"
}

Galaxy "NGC 2377:UGCA 132:C 178:IRAS 07225-0933"
{
        Type  "Sc"
        RA            7.4156
        Dec          -9.6606
        Distance     1.2e+08  # method: V
        Radius     2.966e+04
        AbsMag        -19.33
        Axis    [ -0.2372   0.4688  -0.8508]
        Angle    120.1682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2377"
}

Galaxy "NGC 2379:UGC 3857:MCG 6-17-6:ZWG 177.18"
{
        Type  "S0"
        RA            7.4572
        Dec          33.8119
        Distance   1.889e+08  # method: V
        Radius     2.472e+04
        AbsMag        -19.31
        Axis    [  0.0859   0.8232  -0.5612]
        Angle    100.8007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2379"
}

Galaxy "NGC 2380:NGC 2382:ESO 492-12:MCG 5-18-5"
{
        Type  "S0"
        RA            7.3983
        Dec         -27.5286
        Distance   8.384e+07  # method: S
        Radius     2.561e+04
        AbsMag        -19.75
        Axis    [ -0.0979   0.3194  -0.9426]
        Angle    141.8771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2380"
}

Galaxy "NGC 2381:ESO 88-10:FAIR 266:AM 0719-625"
{
        Type  "SBa"
        RA            7.3325
        Dec         -63.0669
        Distance   1.438e+08  # method: V
        Radius     2.929e+04
        AbsMag        -19.82
        Axis    [  0.9865  -0.0481  -0.1563]
        Angle    176.0891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2381"
}

Galaxy "NGC 2385:MCG 6-17-8:ZWG 177.20"
{
        Type  "S0"
        RA            7.4744
        Dec          33.8381
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7272   0.6859   0.0277]
        Angle     68.7176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2385"
}

Galaxy "NGC 2387:ZWG 177.23"
{
        Type  "S0"
        RA            7.4825
        Dec          36.8797
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.8907   0.4537   0.0285]
        Angle     68.4812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2387"
}

Galaxy "NGC 2388:UGC 3870:MCG 6-17-10:ZWG 177.22"
{
        Type  "S0"
        RA            7.4814
        Dec          33.8189
        Distance   1.936e+08  # method: V
        Radius     2.816e+04
        AbsMag        -19.17
        Axis    [  0.5687   0.8218   0.0342]
        Angle     68.0471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2388"
}

Galaxy "NGC 2389:UGC 3872:MCG 6-17-11:ZWG 177.24"
{
        Type  "SBc"
        RA            7.4844
        Dec          33.8608
        Distance   1.856e+08  # method: V
        Radius     5.399e+04
        AbsMag        -20.38
        Axis    [  0.4185   0.8821  -0.2161]
        Angle     70.6562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2389"
}

Galaxy "NGC 2393:UGC 3884:MCG 6-17-14:ZWG 177.27"
{
        Type  "Sc"
        RA            7.5011
        Dec          34.0278
        Distance   2.278e+08  # method: V
        Radius     3.975e+04
        AbsMag        -19.52
        Axis    [  0.1641   0.9335  -0.3187]
        Angle     76.5966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2393"
}

Galaxy "NGC 2397:ESO 58-30:IRAS 07214-6854"
{
        Type  "Sb"
        RA            7.3553
        Dec         -69.0014
        Distance   8.825e+07  # method: T-F
        Radius     3.209e+04
        AbsMag        -19.46
        Axis    [  0.3616   0.1649  -0.9176]
        Angle    112.1698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2397"
}

Galaxy "NGC 2397A:ESO 58-29:AM 0721-685:IRAS 07212-6901"
{
        Type  "Sc"
        RA            7.3519
        Dec         -69.1153
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.8685   0.2319  -0.4382]
        Angle    162.4344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2397A"
}

Galaxy "NGC 2397B:ESO 58-31:AM 0722-684"
{
        Type  "Irr"
        RA            7.3653
        Dec         -68.8458
        Distance   3.468e+08  # distance uncertain!
        Radius     4.539e+04
        AbsMag        -20.13
        Axis    [  0.5476   0.2452  -0.8000]
        Angle    124.9655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2397B"
}

Galaxy "NGC 2398-1:MCG 4-18-23:ZWG 117.48"
{
        Type  "S0"
        RA            7.5044
        Dec          24.4881
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.1757   0.7730  -0.6096]
        Angle    107.2318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2398-1"
}

Galaxy "NGC 2398-2:MCG 4-18-22:ZWG 117.46"
{
        Type  "E0"
        RA            7.5036
        Dec          24.4914
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.9618  -0.2555  -0.0983]
        Angle     91.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2398-2"
}

Galaxy "NGC 2402-1:UGC 3891:MCG 2-19-4:ZWG 57.15"
{
        Type  "E0"
        RA            7.5128
        Dec           9.6475
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [  0.9690  -0.2172  -0.1177]
        Angle    105.5376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2402-1"
}

Galaxy "NGC 2402-2:UGC 3891:MCG 2-19-4:ZWG 57.15"
{
        Type  "S0"
        RA            7.5131
        Dec           9.6539
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.4174   0.7335  -0.5365]
        Angle     83.0110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2402-2"
}

Galaxy "NGC 2403:UGC 3918:MCG 11-10-7:ZWG 309.40"
{
        Type  "SBc"
        RA            7.6139
        Dec          65.6017
        Distance   1.413e+07  # method: T-F
        Radius      4.81e+04
        AbsMag        -19.28
        Axis    [ -0.3166   0.9483   0.0193]
        Angle     93.4210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2403"
}

Galaxy "NGC 2405-1:MCG 4-18-26:ZWG 117.51:VV 643"
{
        Type  "S0"
        RA            7.5369
        Dec          25.9061
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.1576   0.9155  -0.3701]
        Angle     76.1090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2405-1"
}

Galaxy "NGC 2405-2:MCG 4-18-26:ZWG 117.51:VV 643"
{
        Type  "E0"
        RA            7.5375
        Dec          25.9058
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.9592  -0.2653  -0.0983]
        Angle     89.9223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2405-2"
}

Galaxy "NGC 2406:MCG 3-19-21:ZWG 86.41:ZWG 87.2"
{
        Type  "E0"
        RA            7.5297
        Dec          18.2886
        Distance   3.802e+08  # distance uncertain!
        Radius     3.871e+04
        AbsMag        -20.13
        Axis    [  0.8374   0.1637  -0.5215]
        Angle     95.1103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2406"
}

Galaxy "NGC 2407:UGC 3896:MCG 3-20-1:ZWG 86.42"
{
        Type  "S0"
        RA            7.5322
        Dec          18.3336
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.9126   0.3326  -0.2378]
        Angle     83.9149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2407"
}

Galaxy "NGC 2410:UGC 3917:MCG 5-18-23:ZWG 147.43"
{
        Type  "SBb"
        RA            7.5839
        Dec          32.8225
        Distance   2.187e+08  # method: V
        Radius     7.633e+04
        AbsMag        -20.33
        Axis    [  0.6602   0.5773   0.4805]
        Angle     85.2909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2410"
}

Galaxy "NGC 2411:UGC 3914:MCG 3-20-5:ZWG 87.13"
{
        Type  "E0"
        RA            7.5767
        Dec          18.2819
        Distance   2.884e+08  # distance uncertain!
        Radius     3.776e+04
        AbsMag        -20.13
        Axis    [  0.8421   0.1489  -0.5184]
        Angle     94.7136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2411"
}

Galaxy "NGC 2415:UGC 3930:MCG 6-17-21:ZWG 177.38"
{
        Type  "Irr"
        RA            7.6156
        Dec          35.2419
        Distance    1.78e+08  # method: V
        Radius      2.33e+04
        AbsMag        -20.89
        Axis    [  0.9565  -0.2860  -0.0566]
        Angle     81.0725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2415"
}

Galaxy "NGC 2416:UGC 3925:MCG 2-20-2:ZWG 58.8"
{
        Type  "Sc"
        RA            7.5947
        Dec          11.6125
        Distance   2.397e+08  # method: V
        Radius     3.487e+04
        AbsMag        -20.03
        Axis    [  0.2325   0.7658  -0.5995]
        Angle     84.1167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2416"
}

Galaxy "NGC 2417:ESO 123-15:AM 0729-620:IRAS 07295-6208"
{
        Type  "Sc"
        RA            7.5033
        Dec         -62.2525
        Distance   1.529e+08  # method: T-F
        Radius     6.226e+04
        AbsMag        -20.45
        Axis    [  0.6418   0.2609  -0.7211]
        Angle    131.6187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2417"
}

Galaxy "NGC 2418:UGC 3931:MCG 3-20-8:ZWG 87.17"
{
        Type  "E0"
        RA            7.6103
        Dec          17.8839
        Distance   2.374e+08  # method: V
        Radius     6.215e+04
        AbsMag        -20.91
        Axis    [  0.9607  -0.2529  -0.1144]
        Angle     97.8365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2418"
}

Galaxy "NGC 2424:UGC 3959:MCG 7-16-9:ZWG 206.15"
{
        Type  "SBb"
        RA            7.6775
        Dec          39.2333
        Distance   1.476e+08  # method: V
        Radius     7.728e+04
        AbsMag        -19.68
        Axis    [  0.0848   0.9233   0.3746]
        Angle     71.0658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2424"
}

Galaxy "NGC 2426:UGC 3977:MCG 9-13-38:ZWG 262.22"
{
        Type  "E0"
        RA            7.7217
        Dec          52.3181
        Distance   2.699e+08  # method: V
        Radius     4.319e+04
        AbsMag        -20.39
        Axis    [  0.9116  -0.4079  -0.0510]
        Angle     65.8639
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2426"
}

Galaxy "NGC 2427:ESO 208-27:IRAS 07350-4731"
{
        Type  "Irr"
        RA            7.6075
        Dec         -47.6358
        Distance   4.358e+07  # method: T-F
        Radius     3.106e+04
        AbsMag        -18.43
        Axis    [  0.2818   0.3491  -0.8937]
        Angle     93.1247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2427"
}

Galaxy "NGC 2429:NGC 2429A:UGC 3983:MCG 9-13-39"
{
        Type  "Sc"
        RA            7.7297
        Dec          52.3575
        Distance   2.515e+08  # method: V
        Radius     5.487e+04
        AbsMag        -19.84
        Axis    [ -0.5261   0.8473  -0.0726]
        Angle     96.4155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2429"
}

Galaxy "NGC 2429B:MCG 9-13-40:VV 284:KCPG 138A"
{
        Type  "S0"
        RA            7.7308
        Dec          52.3481
        Distance   6.721e+08  # distance uncertain!
        Radius     2.933e+04
        AbsMag        -19.07
        Axis    [  0.3551   0.7433   0.5670]
        Angle     69.3984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2429B"
}

Galaxy "NGC 2431:NGC 2436:UGC 3999:MCG 9-13-42"
{
        Type  "SBa"
        RA            7.7536
        Dec          53.0756
        Distance   2.618e+08  # method: V
        Radius     3.427e+04
        AbsMag        -20.12
        Axis    [  0.9186  -0.3952  -0.0087]
        Angle     65.2600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2431"
}

Galaxy "NGC 2434:ESO 59-5"
{
        Type  "E0"
        RA            7.5808
        Dec         -69.2844
        Distance   7.038e+07  # method: S
        Radius     2.457e+04
        AbsMag        -19.37
        Axis    [  0.2159  -0.0522  -0.9750]
        Angle    172.9432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2434"
}

Galaxy "NGC 2435:UGC 3996:MCG 5-19-2:ZWG 147.62"
{
        Type  "Sa"
        RA            7.7369
        Dec          31.6506
        Distance   1.971e+08  # method: V
        Radius     6.308e+04
        AbsMag        -20.31
        Axis    [  0.6070   0.6197   0.4975]
        Angle     85.0199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2435"
}

Galaxy "NGC 2441:UGC 4036:MCG 12-8-15:ZWG 331.17"
{
        Type  "SBb"
        RA            7.8650
        Dec          73.0153
        Distance    1.59e+08  # method: V
        Radius     4.625e+04
        AbsMag        -20.54
        Axis    [  0.7548   0.5572   0.3462]
        Angle     42.3693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2441"
}

Galaxy "NGC 2442:NGC 2443:ESO 59-8:AM 0736-692"
{
        Type  "SBc"
        RA            7.6053
        Dec         -69.5247
        Distance    7.04e+07  # method: V
        Radius     6.143e+04
        AbsMag        -20.47
        Axis    [  0.8913   0.2142  -0.3997]
        Angle    165.3793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2442"
}

Galaxy "NGC 2444:UGC 4016:MCG 7-16-16:ZWG 206.24"
{
        Type  "S0"
        RA            7.7814
        Dec          39.0325
        Distance   1.892e+08  # method: V
        Radius     4.403e+04
        AbsMag        -19.92
        Axis    [  0.8222   0.4091   0.3958]
        Angle     75.2175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2444"
}

Galaxy "NGC 2445:UGC 4017:MCG 7-16-17:ZWG 206.24"
{
        Type  "S0"
        RA            7.7819
        Dec          39.0156
        Distance   1.877e+08  # method: V
        Radius     4.641e+04
        AbsMag         -19.9
        Axis    [  0.9406   0.2017   0.2730]
        Angle     74.3490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2445"
}

Galaxy "NGC 2446:UGC 4027:MCG 9-13-58:ZWG 262.30"
{
        Type  "Sb"
        RA            7.8108
        Dec          54.6117
        Distance   2.613e+08  # method: T-F
        Radius     7.221e+04
        AbsMag        -20.82
        Axis    [ -0.2410   0.9674  -0.0780]
        Angle     84.3512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2446"
}

Galaxy "NGC 2449:UGC 4026:MCG 5-19-7:ZWG 148.20"
{
        Type  "Sb"
        RA            7.7889
        Dec          26.9306
        Distance   2.246e+08  # method: V
        Radius     4.246e+04
        AbsMag        -19.89
        Axis    [ -0.2725   0.8653  -0.4207]
        Angle     83.4672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2449"
}

Galaxy "NGC 2450:MCG 5-19-8:ZWG 148.22"
{
        Type  "Sc"
        RA            7.7922
        Dec          27.0194
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.5825   0.7393  -0.3378]
        Angle     87.4920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2450"
}

Galaxy "NGC 2454:UGC 4053:MCG 3-20-15:ZWG 87.44"
{
        Type  "S0"
        RA            7.8428
        Dec          16.3692
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.1798   0.9458  -0.2705]
        Angle     66.3013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2454"
}

Galaxy "NGC 2456:UGC 4073:MCG 9-13-82:ZWG 262.44"
{
        Type  "E0"
        RA            7.9028
        Dec          55.4953
        Distance   3.475e+08  # method: V
        Radius     5.559e+04
        AbsMag        -20.94
        Axis    [  0.9509  -0.0373  -0.3071]
        Angle     56.1158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2456"
}

Galaxy "NGC 2457:MCG 9-13-86:ZWG 262.46:NPM 1"
{
        Type  "Sc"
        RA            7.9125
        Dec          55.5472
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.0769   0.9265   0.3685]
        Angle     66.2479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2457"
}

Galaxy "NGC 2458:MCG 10-12-16:ZWG 287.9"
{
        Type  "S0"
        RA            7.9308
        Dec          56.7108
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.3436   0.8751  -0.3407]
        Angle    123.2574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2458"
}

Galaxy "NGC 2460:UGC 4097:MCG 10-12-21:ZWG 287.10"
{
        Type  "Sb"
        RA            7.9478
        Dec          60.3494
        Distance    6.94e+07  # method: V
        Radius     2.523e+04
        AbsMag        -18.94
        Axis    [  0.7772   0.4613   0.4279]
        Angle     53.3963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2460"
}

Galaxy "NGC 2462:MCG 10-12-24:ZWG 287.9"
{
        Type  "S0"
        RA            7.9419
        Dec          56.6867
        Distance   1.404e+08  # distance uncertain!
        Radius          8170
        AbsMag        -19.07
        Axis    [ -0.3099   0.8939  -0.3239]
        Angle    116.2647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2462"
}

Galaxy "NGC 2463:MCG 10-12-31:ZWG 287.13:ARAK 145"
{
        Type  "E0"
        RA            7.9533
        Dec          56.6769
        Distance   3.796e+08  # method: V
        Radius     3.312e+04
        AbsMag        -20.13
        Axis    [  0.8762  -0.4801  -0.0415]
        Angle     63.3149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2463"
}

Galaxy "NGC 2466:ESO 59-18:IRAS 07456-7117"
{
        Type  "Sc"
        RA            7.7542
        Dec         -71.4108
        Distance   2.474e+08  # method: V
        Radius     5.758e+04
        AbsMag         -20.9
        Axis    [  0.9440   0.1885  -0.2709]
        Angle    175.2400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2466"
}

Galaxy "NGC 2468:UGC 4110:MCG 9-13-95:ZWG 287.16"
{
        Type  "S0"
        RA            7.9672
        Dec          56.3592
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [  0.5493   0.5724   0.6088]
        Angle     65.2828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2468"
}

Galaxy "NGC 2469:UGC 4111:MCG 10-12-35:ZWG 287.17"
{
        Type  "Sb"
        RA            7.9675
        Dec          56.6800
        Distance   1.501e+08  # method: V
        Radius     2.183e+04
        AbsMag        -19.91
        Axis    [ -0.3377   0.8935  -0.2960]
        Angle    112.8744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2469"
}

Galaxy "NGC 2470:UGC 4091:MCG 1-20-9:ZWG 30.29"
{
        Type  "Sb"
        RA            7.9056
        Dec           4.4600
        Distance   1.965e+08  # method: V
        Radius     5.715e+04
        AbsMag         -20.2
        Axis    [ -0.1553   0.8250  -0.5433]
        Angle     68.6761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2470"
}

Galaxy "NGC 2472:MCG 10-12-39:ZWG 287.19"
{
        Type  "S0"
        RA            7.9781
        Dec          56.7011
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.8866  -0.4625   0.0005]
        Angle     63.3897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2472"
}

Galaxy "NGC 2473"
{
        Type  "S0"
        RA            7.9264
        Dec          56.7364
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.1827   0.9646   0.1900]
        Angle     62.4999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2473"
}

Galaxy "NGC 2474:UGC 4114:MCG 9-13-97:ZWG 262.52"
{
        Type  "E0"
        RA            7.9667
        Dec          52.8622
        Distance   2.579e+08  # method: V
        Radius         3e+04
        AbsMag        -20.39
        Axis    [  0.8865  -0.4595  -0.0552]
        Angle     66.7598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2474"
}

Galaxy "NGC 2475:UGC 4114:MCG 9-13-96:ZWG 262.52"
{
        Type  "E0"
        RA            7.9661
        Dec          52.8572
        Distance     2.6e+08  # method: V
        Radius     2.269e+04
        AbsMag        -20.21
        Axis    [  0.8866  -0.4593  -0.0552]
        Angle     66.7609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2475"
}

Galaxy "NGC 2476:UGC 4106:MCG 7-17-3:ZWG 207.8"
{
        Type  "E0"
        RA            7.9458
        Dec          39.9278
        Distance   1.759e+08  # method: V
        Radius     3.581e+04
        AbsMag        -20.06
        Axis    [  0.0868   0.7674  -0.6352]
        Angle    130.4047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2476"
}

Galaxy "NGC 2480:UGC 4116:MCG 4-19-9:ZWG 118.26"
{
        Type  "SBc"
        RA            7.9528
        Dec          23.7797
        Distance   1.142e+08  # method: V
        Radius     2.159e+04
        AbsMag        -17.72
        Axis    [ -0.4040   0.7389  -0.5393]
        Angle     97.9757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2480"
}

Galaxy "NGC 2481:UGC 4118:MCG 4-19-10:ZWG 118.27"
{
        Type  "Sa"
        RA            7.9536
        Dec          23.7675
        Distance    1.14e+08  # method: V
        Radius     2.321e+04
        AbsMag        -19.12
        Axis    [  0.8224   0.4182   0.3856]
        Angle     93.3336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2481"
}

Galaxy "NGC 2484:UGC 4125:MCG 6-18-4:ZWG 178.11"
{
        Type  "S0"
        RA            7.9744
        Dec          37.7867
        Distance   5.957e+08  # method: V
        Radius     7.798e+04
        AbsMag        -22.01
        Axis    [ -0.0761   0.8306  -0.5517]
        Angle    105.6074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2484"
}

Galaxy "NGC 2485:UGC 4112:MCG 1-21-1:ZWG 31.3"
{
        Type  "Sa"
        RA            7.9467
        Dec           7.4775
        Distance   2.189e+08  # method: V
        Radius     5.094e+04
        AbsMag        -20.93
        Axis    [ -0.1052   0.6143  -0.7820]
        Angle    112.6767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2485"
}

Galaxy "NGC 2486:UGC 4123:MCG 4-19-11:ZWG 118.29"
{
        Type  "Sa"
        RA            7.9656
        Dec          25.1611
        Distance   2.193e+08  # method: V
        Radius     5.422e+04
        AbsMag        -19.94
        Axis    [  0.2460   0.9306  -0.2711]
        Angle     65.9762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2486"
}

Galaxy "NGC 2487:UGC 4126:MCG 4-19-12:ZWG 118.30"
{
        Type  "SBb"
        RA            7.9722
        Dec          25.1492
        Distance   2.278e+08  # method: V
        Radius     8.945e+04
        AbsMag        -21.02
        Axis    [  0.1520   0.8148  -0.5595]
        Angle     81.0966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2487"
}

Galaxy "NGC 2488:UGC 4161:MCG 9-13-109:ZWG 287.29"
{
        Type  "S0"
        RA            8.0292
        Dec          56.5528
        Distance    3.94e+08  # method: V
        Radius     8.022e+04
        AbsMag        -21.81
        Axis    [  0.0005   0.9953   0.0973]
        Angle     67.9586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2488"
}

Galaxy "NGC 2490:MCG 5-19-27:ZWG 148.78"
{
        Type  "E0"
        RA            7.9881
        Dec          27.0778
        Distance   4.571e+08  # distance uncertain!
        Radius     3.989e+04
        AbsMag        -20.13
        Axis    [  0.8641   0.0687  -0.4986]
        Angle     83.9069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2490"
}

Galaxy "NGC 2491:ZWG 31.7:NPM 1"
{
        Type  "S0"
        RA            7.9742
        Dec           7.9844
        Distance   2.802e+08  # distance uncertain!
        Radius     1.223e+04
        AbsMag        -19.07
        Axis    [  0.4475   0.7157  -0.5362]
        Angle     75.3605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2491"
}

Galaxy "NGC 2492:UGC 4138:MCG 5-19-28:ZWG 148.80"
{
        Type  "S0"
        RA            7.9914
        Dec          27.0264
        Distance   3.104e+08  # method: V
        Radius     4.515e+04
        AbsMag        -21.09
        Axis    [  0.9431  -0.3180  -0.0970]
        Angle     90.1294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2492"
}

Galaxy "NGC 2493:UGC 4150:MCG 7-17-7:ZWG 207.14"
{
        Type  "S0"
        RA            8.0064
        Dec          39.8308
        Distance   1.853e+08  # method: V
        Radius      5.12e+04
        AbsMag        -20.77
        Axis    [  0.9248  -0.3753  -0.0628]
        Angle     78.4739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2493"
}

Galaxy "NGC 2494:IC 487:UGC 4141:MCG 0-21-1"
{
        Type  "SBa"
        RA            7.9853
        Dec          -0.6375
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [  0.4741   0.5692  -0.6718]
        Angle     86.0158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2494"
}

Galaxy "NGC 2495:MCG 7-17-8:MK 383:ZWG 207.16"
{
        Type  "Irr"
        RA            8.0092
        Dec          39.8406
        Distance   3.874e+08  # method: V
        Radius     2.254e+04
        AbsMag        -19.57
        Axis    [  0.8379   0.2677   0.4757]
        Angle     83.4013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2495"
}

Galaxy "NGC 2496:UGC 4127:MCG 1-21-2:ZWG 31.9"
{
        Type  "E0"
        RA            7.9769
        Dec           8.0281
        Distance   2.188e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -20.13
        Axis    [ -0.0389   0.5813  -0.8127]
        Angle    146.5103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2496"
}

Galaxy "NGC 2497:UGC 4168:MCG 10-12-61:ZWG 287.32"
{
        Type  "S0"
        RA            8.0364
        Dec          56.9422
        Distance   3.747e+08  # method: V
        Radius     7.629e+04
        AbsMag         -21.1
        Axis    [  0.9393   0.1168   0.3225]
        Angle     56.6615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2497"
}

Galaxy "NGC 2498:UGC 4142:MCG 4-19-15:ZWG 118.34"
{
        Type  "SBa"
        RA            7.9939
        Dec          24.9833
        Distance   2.227e+08  # method: V
        Radius     3.562e+04
        AbsMag        -19.77
        Axis    [  0.1469   0.8406  -0.5213]
        Angle     77.3926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2498"
}

Galaxy "NGC 2499:MCG 1-21-3:ZWG 31.11"
{
        Type  "SBa"
        RA            7.9808
        Dec           7.4928
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.9470   0.3083   0.0904]
        Angle     98.3428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2499"
}

Galaxy "NGC 2500:UGC 4165:MCG 9-13-110:ZWG 262.62"
{
        Type  "SBc"
        RA            8.0314
        Dec          50.7367
        Distance   2.881e+07  # method: V
        Radius     1.215e+04
        AbsMag        -17.53
        Axis    [  0.9030   0.4173  -0.1024]
        Angle     54.3669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2500"
}

Galaxy "NGC 2501:MCG 2-21-2:IRAS 07561-1413"
{
        Type  "S0"
        RA            7.9750
        Dec         -14.3542
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.2118   0.5070  -0.8355]
        Angle     92.6084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2501"
}

Galaxy "NGC 2502:ESO 209-8:AM 0754-521"
{
        Type  "S0"
        RA            7.9308
        Dec         -52.3069
        Distance   5.726e+07  # method: V
        Radius     1.749e+04
        AbsMag        -18.02
        Axis    [  0.2398   0.1980  -0.9504]
        Angle    106.5720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2502"
}

Galaxy "NGC 2503:UGC 4158:MCG 4-19-19:ZWG 118.41"
{
        Type  "SBc"
        RA            8.0100
        Dec          22.4000
        Distance   2.586e+08  # method: V
        Radius     3.761e+04
        AbsMag         -19.7
        Axis    [  0.9466  -0.3036  -0.1090]
        Angle     94.4877
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2503"
}

Galaxy "NGC 2504:UGC 4152:MCG 1-21-4:ZWG 31.15"
{
        Type  "Irr"
        RA            7.9978
        Dec           5.6078
        Distance   1.288e+08  # method: V
        Radius          9369
        AbsMag        -18.98
        Axis    [  0.4540   0.6062  -0.6530]
        Angle     83.7354
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2504"
}

Galaxy "NGC 2505:UGC 4193:MCG 9-13-115:ZWG 262.66"
{
        Type  "SBa"
        RA            8.0683
        Dec          53.5497
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [  0.7903   0.0502   0.6107]
        Angle     87.8843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2505"
}

Galaxy "NGC 2507:UGC 4172:MCG 3-21-10:ZWG 88.20"
{
        Type  "Sa"
        RA            8.0269
        Dec          15.7103
        Distance   2.164e+08  # method: V
        Radius      7.87e+04
        AbsMag        -20.51
        Axis    [  0.0343   0.7619  -0.6468]
        Angle     84.4340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2507"
}

Galaxy "NGC 2508:UGC 4174:MCG 2-21-4:ZWG 59.18"
{
        Type  "E0"
        RA            8.0325
        Dec           8.5519
        Distance   2.086e+08  # method: V
        Radius     4.248e+04
        AbsMag        -20.13
        Axis    [  0.2335   0.4900  -0.8399]
        Angle    125.6196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2508"
}

Galaxy "NGC 2510:UGC 4178:MCG 2-21-7:ZWG 59.23"
{
        Type  "S0"
        RA            8.0361
        Dec           9.4861
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.2287   0.7281  -0.6462]
        Angle     78.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2510"
}

Galaxy "NGC 2511:MCG 2-21-8:MK 1207:ZWG 59.24"
{
        Type  "S0"
        RA            8.0375
        Dec           9.3953
        Distance   2.126e+08  # method: V
        Radius     2.783e+04
        AbsMag        -18.97
        Axis    [ -0.0675   0.8823  -0.4658]
        Angle     65.9783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2511"
}

Galaxy "NGC 2512:UGC 4191:MCG 4-19-21:MK 384"
{
        Type  "SBb"
        RA            8.0519
        Dec          23.3917
        Distance   2.221e+08  # method: V
        Radius     4.523e+04
        AbsMag        -20.27
        Axis    [  0.1085   0.8696  -0.4817]
        Angle     73.3152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2512"
}

Galaxy "NGC 2513:UGC 4184:MCG 2-21-9:ZWG 59.25"
{
        Type  "E0"
        RA            8.0400
        Dec           9.4139
        Distance   2.016e+08  # method: T-F
        Radius      7.33e+04
        AbsMag        -21.35
        Axis    [ -0.0620   0.5955  -0.8010]
        Angle    147.1697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2513"
}

Galaxy "NGC 2514:UGC 4189:MCG 3-21-11:ZWG 88.22"
{
        Type  "SBc"
        RA            8.0469
        Dec          15.8078
        Distance   2.299e+08  # method: V
        Radius     4.346e+04
        AbsMag        -20.24
        Axis    [  0.9909   0.0567  -0.1223]
        Angle     90.2183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2514"
}

Galaxy "NGC 2517:MCG 2-21-3:NPM 1:CGMW 1-2065"
{
        Type  "S0"
        RA            8.0464
        Dec         -12.3172
        Distance   7.717e+07  # distance uncertain!
        Radius     1.571e+04
        AbsMag        -19.07
        Axis    [  0.7429   0.4447  -0.5003]
        Angle     92.8127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2517"
}

Galaxy "NGC 2518:UGC 4221:MCG 9-14-6:ZWG 263.9"
{
        Type  "S0"
        RA            8.1222
        Dec          51.1322
        Distance   2.441e+08  # method: V
        Radius     4.261e+04
        AbsMag        -19.77
        Axis    [  0.9326   0.2892   0.2158]
        Angle     56.6849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2518"
}

Galaxy "NGC 2521:UGC 4235:MCG 10-12-77:ZWG 287.42"
{
        Type  "S0"
        RA            8.1469
        Dec          57.7697
        Distance   2.438e+08  # method: V
        Radius     4.255e+04
        AbsMag        -20.27
        Axis    [  0.6466   0.5278   0.5508]
        Angle     59.1996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2521"
}

Galaxy "NGC 2522:UGC 4218:MCG 3-21-14:ZWG 88.31"
{
        Type  "Sa"
        RA            8.1036
        Dec          17.7067
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.7842   0.5423   0.3016]
        Angle     87.2404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2522"
}

Galaxy "NGC 2523:UGC 4271:MCG 12-8-31:ZWG 331.32"
{
        Type  "SBc"
        RA            8.2500
        Dec          73.5789
        Distance   1.563e+08  # method: V
        Radius     6.592e+04
        AbsMag         -20.8
        Axis    [  0.3835   0.6305   0.6748]
        Angle     55.3829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2523"
}

Galaxy "NGC 2523A:UGC 4166:MCG 12-8-24:ZWG 331.26"
{
        Type  "SBc"
        RA            8.0689
        Dec          74.0481
        Distance   1.737e+08  # method: V
        Radius     2.526e+04
        AbsMag        -19.13
        Axis    [  0.0090   0.9705   0.2411]
        Angle     67.7453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2523A"
}

Galaxy "NGC 2523B:UGC 4259:MCG 12-8-30:ZWG 331.30"
{
        Type  "Sb"
        RA            8.2156
        Dec          73.5636
        Distance   1.752e+08  # method: V
        Radius     5.097e+04
        AbsMag        -18.85
        Axis    [ -0.2229   0.7310   0.6450]
        Angle     83.6325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2523B"
}

Galaxy "NGC 2523C:UGC 4290:MCG 12-8-32:ZWG 331.33"
{
        Type  "E0"
        RA            8.2956
        Dec          73.3181
        Distance   1.563e+08  # method: V
        Radius      3.41e+04
        AbsMag         -19.1
        Axis    [  0.4134   0.8152  -0.4056]
        Angle     69.0232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2523C"
}

Galaxy "NGC 2524:UGC 4234:MCG 7-17-16:ZWG 207.34"
{
        Type  "Sa"
        RA            8.1358
        Dec          39.1578
        Distance     1.9e+08  # method: V
        Radius      3.87e+04
        AbsMag        -20.23
        Axis    [ -0.0577   0.9181  -0.3922]
        Angle     80.4697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2524"
}

Galaxy "NGC 2525:MCG 2-21-4:UGCA 135:IRAS 08032-1117"
{
        Type  "SBc"
        RA            8.0939
        Dec         -11.4275
        Distance   8.276e+07  # method: V
        Radius     3.611e+04
        AbsMag        -19.72
        Axis    [  0.6759   0.5015  -0.5401]
        Angle     87.6469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2525"
}

Galaxy "NGC 2526:UGC 4231:MCG 1-21-12:ZWG 31.47"
{
        Type  "Sb"
        RA            8.1161
        Dec           8.0042
        Distance   2.193e+08  # method: V
        Radius     3.827e+04
        AbsMag        -19.44
        Axis    [ -0.0658   0.7385  -0.6710]
        Angle     79.3931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2526"
}

Galaxy "NGC 2528:UGC 4227:MCG 7-17-15:ZWG 207.32"
{
        Type  "Sb"
        RA            8.1236
        Dec          39.1947
        Distance   1.854e+08  # method: V
        Radius     4.044e+04
        AbsMag        -20.37
        Axis    [  0.9171  -0.3926  -0.0700]
        Angle     79.6191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2528"
}

Galaxy "NGC 2530:UGC 4237:MCG 3-21-20:ZWG 88.38"
{
        Type  "SBc"
        RA            8.1319
        Dec          17.8183
        Distance   2.377e+08  # method: V
        Radius     4.841e+04
        AbsMag        -19.81
        Axis    [ -0.4125   0.6622  -0.6255]
        Angle    106.0691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2530"
}

Galaxy "NGC 2532:UGC 4256:MCG 6-18-13:ZWG 178.32"
{
        Type  "SBc"
        RA            8.1708
        Dec          33.9561
        Distance   2.465e+08  # method: V
        Radius     6.813e+04
        AbsMag        -21.39
        Axis    [  0.9595   0.0787   0.2704]
        Angle     82.9954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2532"
}

Galaxy "NGC 2534:UGC 4268:MCG 9-14-14:MK 85"
{
        Type  "E1"
        RA            8.2150
        Dec          55.6719
        Distance   1.715e+08  # method: V
        Radius     2.494e+04
        AbsMag           -20
        Axis    [  0.8508  -0.5231  -0.0499]
        Angle     65.9191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2534"
}

Galaxy "NGC 2535:UGC 4264:MCG 4-20-4:ZWG 119.8"
{
        Type  "Sc"
        RA            8.1869
        Dec          25.2072
        Distance   1.951e+08  # method: V
        Radius     7.093e+04
        AbsMag        -20.58
        Axis    [  0.8978   0.2747   0.3443]
        Angle     92.9891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2535"
}

Galaxy "NGC 2536:MCG 4-20-5:ZWG 119.9:VV 9"
{
        Type  "SBc"
        RA            8.1878
        Dec          25.1797
        Distance    1.97e+08  # method: V
        Radius     2.292e+04
        AbsMag        -19.11
        Axis    [  0.7885   0.5965   0.1499]
        Angle     70.1546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2536"
}

Galaxy "NGC 2537:UGC 4274:MCG 8-15-50:MK 86"
{
        Type  "Irr"
        RA            8.2206
        Dec          45.9914
        Distance   2.686e+07  # method: V
        Radius          6642
        AbsMag        -17.28
        Axis    [ -0.2028   0.8555  -0.4764]
        Angle    115.5117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2537"
}

Galaxy "NGC 2537A:MCG 8-15-51"
{
        Type  "SBc"
        RA            8.2281
        Dec          45.9933
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [  0.8937  -0.4459  -0.0505]
        Angle     74.1820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2537A"
}

Galaxy "NGC 2538:UGC 4266:MCG 1-21-19:ZWG 31.67"
{
        Type  "SBa"
        RA            8.1897
        Dec           3.6331
        Distance   1.897e+08  # method: V
        Radius     4.138e+04
        AbsMag        -20.22
        Axis    [  0.9734   0.1962  -0.1183]
        Angle     96.9446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2538"
}

Galaxy "NGC 2540:UGC 4275:MCG 5-20-4:ZWG 149.4"
{
        Type  "SBc"
        RA            8.2128
        Dec          26.3614
        Distance   2.948e+08  # method: V
        Radius     5.573e+04
        AbsMag        -20.38
        Axis    [ -0.0202   0.8504  -0.5257]
        Angle     78.5281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2540"
}

Galaxy "NGC 2541:UGC 4284:MCG 8-15-54:ZWG 236.37"
{
        Type  "SBc"
        RA            8.2444
        Dec          49.0619
        Distance   5.237e+07  # method: T-F
        Radius     4.798e+04
        AbsMag        -18.83
        Axis    [ -0.4879   0.8264  -0.2810]
        Angle    105.9285
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2541"
}

Galaxy "NGC 2543:IC 2232:UGC 4273:MCG 6-18-14"
{
        Type  "SBb"
        RA            8.2158
        Dec          36.2536
        Distance     1.2e+08  # method: V
        Radius     4.014e+04
        AbsMag        -20.13
        Axis    [  0.7786   0.5496   0.3029]
        Angle     66.7931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2543"
}

Galaxy "NGC 2544:UGC 4327:MCG 12-8-34:MK 87"
{
        Type  "SBa"
        RA            8.3611
        Dec          73.9883
        Distance   1.297e+08  # method: V
        Radius     2.075e+04
        AbsMag         -19.1
        Axis    [  0.3308   0.8098   0.4845]
        Angle     51.8073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2544"
}

Galaxy "NGC 2545:UGC 4287:MCG 4-20-7:ZWG 119.16"
{
        Type  "SBb"
        RA            8.2372
        Dec          21.3561
        Distance   2.277e+08  # method: T-F
        Radius     7.287e+04
        AbsMag        -21.02
        Axis    [ -0.4808   0.6761  -0.5584]
        Angle    101.1468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2545"
}

Galaxy "NGC 2549:UGC 4313:MCG 10-12-124:ZWG 287.69"
{
        Type  "S0"
        RA            8.3161
        Dec          57.8031
        Distance   4.125e+07  # method: S
        Radius      2.28e+04
        AbsMag        -18.31
        Axis    [ -0.6342   0.7547  -0.1683]
        Angle    116.0291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2549"
}

Galaxy "NGC 2550:UGC 4359:MCG 12-8-37:ZWG 331.39"
{
        Type  "Sb"
        RA            8.4092
        Dec          74.0119
        Distance   1.017e+08  # distance uncertain!
        Radius      1.48e+04
        AbsMag        -19.07
        Axis    [ -0.2031   0.8689   0.4514]
        Angle     76.3526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2550"
}

Galaxy "NGC 2550A:UGC 4397:MCG 12-8-43:ZWG 331.43"
{
        Type  "Sc"
        RA            8.4775
        Dec          73.7481
        Distance   1.667e+08  # method: V
        Radius     3.879e+04
        AbsMag        -20.14
        Axis    [  0.7560  -0.4081   0.5117]
        Angle     63.5524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2550A"
}

Galaxy "NGC 2551:UGC 4362:MCG 12-8-38:ZWG 331.40"
{
        Type  "Sa"
        RA            8.4139
        Dec          73.4125
        Distance   1.043e+08  # method: V
        Radius     2.427e+04
        AbsMag        -19.42
        Axis    [  0.4335   0.5691   0.6987]
        Angle     54.4504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2551"
}

Galaxy "NGC 2552:UGC 4325:MCG 8-15-62:ZWG 236.42"
{
        Type  "Irr"
        RA            8.3219
        Dec          50.0069
        Distance   2.963e+07  # method: V
        Radius     1.551e+04
        AbsMag        -17.19
        Axis    [  0.6393   0.6693   0.3785]
        Angle     56.6315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2552"
}

Galaxy "NGC 2553:MCG 4-20-14:ZWG 119.31"
{
        Type  "S0"
        RA            8.2931
        Dec          20.9033
        Distance    2.24e+08  # method: V
        Radius     5.539e+04
        AbsMag        -19.28
        Axis    [  0.6081   0.7917  -0.0591]
        Angle     62.6337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2553"
}

Galaxy "NGC 2554:UGC 4312:MCG 4-20-15:ZWG 119.33"
{
        Type  "Sa"
        RA            8.2981
        Dec          23.4722
        Distance    1.98e+08  # method: V
        Radius     9.214e+04
        AbsMag        -21.01
        Axis    [ -0.1908   0.7651  -0.6150]
        Angle     93.8801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2554"
}

Galaxy "NGC 2555:UGC 4319:MCG 0-21-12:ZWG 3.28"
{
        Type  "SBb"
        RA            8.2989
        Dec           0.7450
        Distance   2.108e+08  # method: V
        Radius     5.826e+04
        AbsMag        -20.75
        Axis    [  0.2187   0.6121  -0.7599]
        Angle     82.2101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2555"
}

Galaxy "NGC 2556:ZWG 119.45:NPM 1"
{
        Type  "S0"
        RA            8.3167
        Dec          20.9375
        Distance   2.202e+08  # method: V
        Radius     1.281e+04
        AbsMag        -18.85
        Axis    [ -0.2602   0.8241  -0.5031]
        Angle     76.6275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2556"
}

Galaxy "NGC 2557:UGC 4330:MCG 4-20-21:ZWG 119.48"
{
        Type  "S0"
        RA            8.3194
        Dec          21.4361
        Distance   2.305e+08  # method: V
        Radius     4.024e+04
        AbsMag        -19.85
        Axis    [  0.8685   0.4041  -0.2871]
        Angle     71.4455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2557"
}

Galaxy "NGC 2558:UGC 4331:MCG 4-20-22:ZWG 119.50"
{
        Type  "Sb"
        RA            8.3200
        Dec          20.5114
        Distance   2.363e+08  # method: V
        Radius     6.186e+04
        AbsMag         -20.5
        Axis    [ -0.3098   0.7132  -0.6288]
        Angle    100.8893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2558"
}

Galaxy "NGC 2559:ESO 494-41:MCG 4-20-3:UGCA 136"
{
        Type  "SBc"
        RA            8.2850
        Dec         -27.4569
        Distance   8.159e+07  # method: V
        Radius      3.56e+04
        AbsMag        -20.29
        Axis    [  0.9261   0.3752  -0.0384]
        Angle    130.3242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2559"
}

Galaxy "NGC 2560:UGC 4337:MCG 4-20-27:ZWG 119.58"
{
        Type  "Sa"
        RA            8.3308
        Dec          20.9847
        Distance   2.333e+08  # method: V
        Radius     4.751e+04
        AbsMag        -19.67
        Axis    [  0.1608   0.9832   0.0861]
        Angle     58.2056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2560"
}

Galaxy "NGC 2561:UGC 4336:MCG 1-22-1:ZWG 31.81"
{
        Type  "SBc"
        RA            8.3267
        Dec           4.6567
        Distance   1.959e+08  # method: V
        Radius     3.135e+04
        AbsMag        -19.79
        Axis    [ -0.1653   0.6906  -0.7041]
        Angle     78.0137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2561"
}

Galaxy "NGC 2562:UGC 4345:MCG 4-20-31:ZWG 119.63"
{
        Type  "Sa"
        RA            8.3397
        Dec          21.1317
        Distance   2.367e+08  # method: V
        Radius     3.443e+04
        AbsMag         -20.4
        Axis    [  0.9748   0.0688   0.2123]
        Angle     97.0822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2562"
}

Galaxy "NGC 2563:UGC 4347:MCG 4-20-33:ZWG 119.65"
{
        Type  "S0"
        RA            8.3431
        Dec          21.0681
        Distance   2.541e+08  # method: T-F
        Radius     7.392e+04
        AbsMag        -21.16
        Axis    [  0.6303   0.5834  -0.5122]
        Angle     70.9994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2563"
}

Galaxy "NGC 2564:ESO 562-1:NPM 1:CGMW 2-3167"
{
        Type  "S0"
        RA            8.3083
        Dec         -21.8161
        Distance   1.065e+08  # distance uncertain!
        Radius     1.859e+04
        AbsMag        -19.07
        Axis    [  0.6244   0.4225  -0.6570]
        Angle     91.8539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2564"
}

Galaxy "NGC 2565:UGC 4334:MCG 4-20-26:MK 386"
{
        Type  "SBc"
        RA            8.3300
        Dec          22.0314
        Distance    1.99e+08  # method: T-F
        Radius     5.499e+04
        AbsMag        -20.53
        Axis    [ -0.5118   0.6854  -0.5179]
        Angle     95.1452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2565"
}

Galaxy "NGC 2566:ESO 495-3:MCG 4-20-8:UGCA 138"
{
        Type  "SBb"
        RA            8.3125
        Dec         -25.5006
        Distance   8.585e+07  # method: V
        Radius     3.621e+04
        AbsMag         -20.3
        Axis    [  0.7629   0.4221  -0.4897]
        Angle     97.5415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2566"
}

Galaxy "NGC 2569:MCG 4-20-35:ZWG 119.67:NPM 1"
{
        Type  "S0"
        RA            8.3558
        Dec          20.8681
        Distance   2.415e+08  # method: V
        Radius     2.107e+04
        AbsMag        -19.05
        Axis    [  0.1734   0.7326  -0.6583]
        Angle     81.1452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2569"
}

Galaxy "NGC 2570:UGC 4354:MCG 4-20-36:ZWG 119.68"
{
        Type  "Sb"
        RA            8.3561
        Dec          20.9106
        Distance    3.29e+08  # method: T-F
        Radius     5.263e+04
        AbsMag        -19.92
        Axis    [  0.6132   0.7729  -0.1632]
        Angle     61.8668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2570"
}

Galaxy "NGC 2572:UGC 4355:MCG 3-22-4:ZWG 89.7"
{
        Type  "Sa"
        RA            8.3567
        Dec          19.1478
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.2739   0.8587  -0.4332]
        Angle     69.1263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2572"
}

Galaxy "NGC 2573:ESO 1-1:IRAS 02425-8934"
{
        Type  "SBc"
        RA            1.6981
        Dec         -89.3342
        Distance   1.404e+08  # distance uncertain!
        Radius     3.881e+04
        AbsMag        -19.07
        Axis    [  0.7864   0.5604  -0.2599]
        Angle    185.9283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2573"
}

Galaxy "NGC 2573A:ESO 1-9:AM 2247-892:IRAS 22443-8923"
{
        Type  "SBb"
        RA           23.2039
        Dec         -89.1242
        Distance   1.851e+08  # distance uncertain!
        Radius     5.654e+04
        AbsMag        -19.07
        Axis    [ -0.5472  -0.6889  -0.4755]
        Angle    115.1363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2573A"
}

Galaxy "NGC 2573B:ESO 1-8:AM 2240-892"
{
        Type  "Irr"
        RA           23.1256
        Dec         -89.1153
        Distance   3.631e+08  # distance uncertain!
        Radius     7.922e+04
        AbsMag        -20.13
        Axis    [ -0.7725  -0.5875   0.2411]
        Angle    172.1338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2573B"
}

Galaxy "NGC 2574:MCG 1-22-3:IRAS 08183-0845"
{
        Type  "Sb"
        RA            8.3467
        Dec          -8.9183
        Distance   1.417e+08  # method: V
        Radius      4.74e+04
        AbsMag        -19.49
        Axis    [ -0.2867   0.5053  -0.8139]
        Angle     84.6794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2574"
}

Galaxy "NGC 2575:UGC 4368:MCG 4-20-40:ZWG 119.75"
{
        Type  "Sc"
        RA            8.3792
        Dec          24.2969
        Distance   1.853e+08  # method: V
        Radius     4.582e+04
        AbsMag        -20.27
        Axis    [ -0.1694   0.7711  -0.6138]
        Angle     92.2024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2575"
}

Galaxy "NGC 2576:UGC 4371:MCG 4-20-41:ZWG 119.76"
{
        Type  "Sb"
        RA            8.3825
        Dec          25.7394
        Distance   3.882e+08  # method: V
        Radius     9.599e+04
        AbsMag        -20.08
        Axis    [  0.6627   0.5996   0.4487]
        Angle     81.0774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2576"
}

Galaxy "NGC 2577:UGC 4367:MCG 4-20-42:ZWG 119.74"
{
        Type  "S0"
        RA            8.3786
        Dec          22.5536
        Distance   1.074e+08  # method: V
        Radius     2.811e+04
        AbsMag        -19.09
        Axis    [  0.2114   0.8742  -0.4372]
        Angle     64.6068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2577"
}

Galaxy "NGC 2578:MCG 2-22-2:IRAS 08191-1310"
{
        Type  "SBa"
        RA            8.3567
        Dec         -13.3181
        Distance   1.065e+08  # distance uncertain!
        Radius     3.408e+04
        AbsMag        -19.07
        Axis    [  0.6315   0.5214  -0.5739]
        Angle     81.7486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2578"
}

Galaxy "NGC 2581:UGC 4388:MCG 3-22-10:ZWG 89.19"
{
        Type  "SBa"
        RA            8.4083
        Dec          18.5969
        Distance   2.785e+08  # method: V
        Radius     4.455e+04
        AbsMag        -20.36
        Axis    [  0.9865   0.0950   0.1331]
        Angle     93.6381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2581"
}

Galaxy "NGC 2582:IC 2359:UGC 4391:MCG 4-20-50"
{
        Type  "SBb"
        RA            8.4200
        Dec          20.3342
        Distance   2.116e+08  # method: V
        Radius     3.693e+04
        AbsMag        -20.16
        Axis    [  0.9241  -0.3557  -0.1394]
        Angle     97.9407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2582"
}

Galaxy "NGC 2583:MCG 1-22-8"
{
        Type  "E0"
        RA            8.3853
        Dec          -5.0025
        Distance   2.796e+08  # method: V
        Radius      3.66e+04
        AbsMag        -20.27
        Axis    [  0.9361  -0.2853  -0.2056]
        Angle    121.7144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2583"
}

Galaxy "NGC 2584:MCG 1-22-9"
{
        Type  "Sc"
        RA            8.3875
        Dec          -4.9708
        Distance   2.614e+08  # method: T-F
        Radius     4.563e+04
        AbsMag        -19.92
        Axis    [  0.9542   0.2749   0.1181]
        Angle    117.5251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2584"
}

Galaxy "NGC 2585:MCG 1-22-10:IRAS 08209-0445"
{
        Type  "Sb"
        RA            8.3906
        Dec          -4.9153
        Distance   1.688e+08  # distance uncertain!
        Radius      4.42e+04
        AbsMag        -19.07
        Axis    [  0.4296   0.7147  -0.5519]
        Angle     67.0735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2585"
}

Galaxy "NGC 2590:IC 507:UGC 4392:MCG 0-22-10"
{
        Type  "Sc"
        RA            8.4172
        Dec          -0.5911
        Distance   2.382e+08  # method: V
        Radius     7.622e+04
        AbsMag        -20.42
        Axis    [  0.5953   0.7668  -0.2402]
        Angle     66.2292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2590"
}

Galaxy "NGC 2591:UGC 4472:MCG 13-7-1:ZWG 349.29"
{
        Type  "Sc"
        RA            8.6236
        Dec          78.0256
        Distance   7.683e+07  # method: T-F
        Radius     3.352e+04
        AbsMag        -18.96
        Axis    [  0.3598   0.2100   0.9091]
        Angle     89.8617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2591"
}

Galaxy "NGC 2592:UGC 4411:MCG 4-20-55:ZWG 119.102"
{
        Type  "E0"
        RA            8.4522
        Dec          25.9708
        Distance   8.384e+07  # method: S
        Radius     2.073e+04
        AbsMag        -18.65
        Axis    [  0.8482  -0.0166  -0.5294]
        Angle     83.3892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2592"
}

Galaxy "NGC 2593:UGC 4408:MCG 3-22-12:ZWG 89.29"
{
        Type  "Sa"
        RA            8.4464
        Dec          17.3744
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.5002   0.6380  -0.5855]
        Angle     99.4639
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2593"
}

Galaxy "NGC 2594:MCG 4-20-56:ZWG 119.106"
{
        Type  "S0"
        RA            8.4547
        Dec          25.8786
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.9451   0.2729   0.1798]
        Angle     79.0351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2594"
}

Galaxy "NGC 2595:UGC 4422:MCG 4-20-62:ZWG 119.109"
{
        Type  "SBc"
        RA            8.4614
        Dec          21.4794
        Distance   2.068e+08  # method: V
        Radius     9.623e+04
        AbsMag        -21.01
        Axis    [  0.9279   0.3556  -0.1117]
        Angle     71.9842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2595"
}

Galaxy "NGC 2596:UGC 4419:MCG 3-22-13:ZWG 89.30"
{
        Type  "Sb"
        RA            8.4572
        Dec          17.2844
        Distance   3.109e+08  # method: T-F
        Radius     6.783e+04
        AbsMag         -20.7
        Axis    [  0.6850   0.7283   0.0195]
        Angle     64.5182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2596"
}

Galaxy "NGC 2598:UGC 4443:MCG 4-20-65:ZWG 119.116"
{
        Type  "SBa"
        RA            8.5006
        Dec          21.4883
        Distance   2.192e+08  # method: V
        Radius     4.145e+04
        AbsMag        -19.24
        Axis    [  0.9256   0.1885   0.3282]
        Angle    101.7612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2598"
}

Galaxy "NGC 2599:UGC 4458:MCG 4-20-67:MK 389"
{
        Type  "Sa"
        RA            8.5364
        Dec          22.5608
        Distance   2.257e+08  # method: V
        Radius     6.238e+04
        AbsMag         -21.1
        Axis    [  0.3409   0.6577  -0.6717]
        Angle     77.5465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2599"
}

Galaxy "NGC 2600:UGC 4475:MCG 9-14-68:ZWG 263.55"
{
        Type  "Sb"
        RA            8.5789
        Dec          52.7153
        Distance   5.375e+08  # method: T-F
        Radius     9.381e+04
        AbsMag        -21.08
        Axis    [  0.2171   0.8234   0.5243]
        Angle     60.7403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2600"
}

Galaxy "NGC 2601:ESO 60-5:IRAS 08251-6757"
{
        Type  "SBa"
        RA            8.4250
        Dec         -68.1178
        Distance   1.529e+08  # method: V
        Radius     3.559e+04
        AbsMag        -19.95
        Axis    [  0.2711   0.0375  -0.9618]
        Angle    119.5872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2601"
}

Galaxy "NGC 2602:MCG 9-14-69:ZWG 263-56:ARAK 169"
{
        Type  "S0"
        RA            8.5844
        Dec          52.8314
        Distance   2.555e+08  # distance uncertain!
        Radius     1.115e+04
        AbsMag        -19.07
        Axis    [  0.8646   0.1967   0.4624]
        Angle     62.8311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2602"
}

Galaxy "NGC 2603"
{
        Type  "E0"
        RA            8.5753
        Dec          52.8403
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.8213  -0.5664  -0.0681]
        Angle     70.8638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2603"
}

Galaxy "NGC 2604:NGC 2604A:UGC 4469:MCG 5-20-22"
{
        Type  "SBc"
        RA            8.5561
        Dec          29.5386
        Distance   1.046e+08  # method: V
        Radius     2.587e+04
        AbsMag        -19.23
        Axis    [  0.9015  -0.4156  -0.1210]
        Angle     90.3460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2604"
}

Galaxy "NGC 2604B:MCG 5-20-23:ZWG 149.49:KUG 0830+296"
{
        Type  "Sc"
        RA            8.5597
        Dec          29.4994
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.9099   0.4094   0.0670]
        Angle     66.0567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2604B"
}

Galaxy "NGC 2605"
{
        Type  "S0"
        RA            8.5814
        Dec          52.8044
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [  0.9144   0.0185   0.4043]
        Angle     65.8174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2605"
}

Galaxy "NGC 2606:MCG 9-14-72:ZWG 263.59"
{
        Type  "Sc"
        RA            8.5928
        Dec          52.7886
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.6420   0.4655   0.6092]
        Angle     64.7494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2606"
}

Galaxy "NGC 2607:UGC 4473:MCG 5-20-25:ZWG 149.51"
{
        Type  "Sc"
        RA            8.5656
        Dec          26.9731
        Distance     1.7e+08  # method: V
        Radius     2.225e+04
        AbsMag        -18.88
        Axis    [  0.8719   0.3454  -0.3470]
        Angle     67.0648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2607"
}

Galaxy "NGC 2608:UGC 4484:MCG 5-20-27:ZWG 149.55"
{
        Type  "SBb"
        RA            8.5881
        Dec          28.4733
        Distance   1.066e+08  # method: V
        Radius     2.947e+04
        AbsMag        -19.57
        Axis    [  0.8056   0.5920  -0.0255]
        Angle     60.4399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2608"
}

Galaxy "NGC 2611:ZWG 119.127"
{
        Type  "S0"
        RA            8.5914
        Dec          25.0278
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.7589   0.5447   0.3570]
        Angle     75.7655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2611"
}

Galaxy "NGC 2612:MCG 2-22-20"
{
        Type  "S0"
        RA            8.5639
        Dec         -13.1742
        Distance   1.168e+08  # distance uncertain!
        Radius     4.757e+04
        AbsMag        -19.07
        Axis    [  0.0068   0.7511  -0.6601]
        Angle     53.7111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2612"
}

Galaxy "NGC 2613:ESO 495-18:MCG 4-21-3:UGCA 141"
{
        Type  "Sb"
        RA            8.5561
        Dec         -22.9728
        Distance   1.106e+08  # method: T-F
        Radius     1.045e+05
        AbsMag        -21.45
        Axis    [  0.1972   0.6661  -0.7193]
        Angle     57.4936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2613"
}

Galaxy "NGC 2614:UGC 4523:MCG 12-9-5:ZWG 331.58"
{
        Type  "Sc"
        RA            8.7131
        Dec          72.9767
        Distance   1.587e+08  # method: V
        Radius     4.617e+04
        AbsMag        -19.74
        Axis    [ -0.2180   0.9685  -0.1201]
        Angle    101.1438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2614"
}

Galaxy "NGC 2615:UGC 4481:MCG 0-22-19:ZWG 4.59"
{
        Type  "SBb"
        RA            8.5758
        Dec          -2.5472
        Distance   1.017e+08  # distance uncertain!
        Radius     2.811e+04
        AbsMag        -19.07
        Axis    [  0.9112   0.3797  -0.1600]
        Angle     89.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2615"
}

Galaxy "NGC 2616:UGC 4489:MCG 0-22-21:ZWG 4.69"
{
        Type  "S0"
        RA            8.5928
        Dec          -1.8508
        Distance   4.201e+08  # method: V
        Radius     6.721e+04
        AbsMag        -21.85
        Axis    [ -0.2700   0.5116  -0.8157]
        Angle    106.4295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2616"
}

Galaxy "NGC 2617:MCG 1-22-27"
{
        Type  "Sa"
        RA            8.5939
        Dec          -4.0878
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.1929   0.5496  -0.8129]
        Angle     80.5154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2617"
}

Galaxy "NGC 2618:UGC 4492:MCG 0-22-23:ZWG 4.74"
{
        Type  "Sb"
        RA            8.5981
        Dec           0.7078
        Distance   1.065e+08  # distance uncertain!
        Radius     3.873e+04
        AbsMag        -19.07
        Axis    [ -0.0632   0.5605  -0.8257]
        Angle     92.3433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2618"
}

Galaxy "NGC 2619:UGC 4503:MCG 5-21-2:ZWG 150.8"
{
        Type  "SBc"
        RA            8.6256
        Dec          28.7050
        Distance   1.675e+08  # method: V
        Radius     4.385e+04
        AbsMag        -20.15
        Axis    [  0.9310   0.3212   0.1736]
        Angle     72.1690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2619"
}

Galaxy "NGC 2620:UGC 4501:MCG 4-21-1:ZWG 120.6"
{
        Type  "S0"
        RA            8.6244
        Dec          24.9469
        Distance   3.656e+08  # method: V
        Radius     1.064e+05
        AbsMag        -20.65
        Axis    [  0.1929   0.9752   0.1083]
        Angle     54.5893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2620"
}

Galaxy "NGC 2621:MCG 4-21-3:ZWG 120.7:NPM 1"
{
        Type  "S0"
        RA            8.6267
        Dec          25.0003
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [ -0.5444   0.6838  -0.4858]
        Angle     96.3683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2621"
}

Galaxy "NGC 2622:MCG 4-21-8:MK 1218:ZWG 120.13"
{
        Type  "Sb"
        RA            8.6361
        Dec          24.8953
        Distance   3.981e+08  # method: V
        Radius     4.632e+04
        AbsMag        -20.53
        Axis    [  0.8619   0.4791   0.1659]
        Angle     69.4751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2622"
}

Galaxy "NGC 2623:UGC 4509:MCG 4-21-9:ZWG 120.15"
{
        Type  "Sb"
        RA            8.6400
        Dec          25.7547
        Distance    2.61e+08  # method: V
        Radius      9.11e+04
        AbsMag        -20.52
        Axis    [  0.6462   0.7052   0.2918]
        Angle     64.3663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2623"
}

Galaxy "NGC 2624:UGC 4506:MCG 3-22-19:ZWG 89.55"
{
        Type  "S0"
        RA            8.6358
        Dec          19.7261
        Distance   1.851e+08  # distance uncertain!
        Radius     1.615e+04
        AbsMag        -19.07
        Axis    [  1.0000   0.0006   0.0087]
        Angle     88.8483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2624"
}

Galaxy "NGC 2625:MK 625:ZWG 89.57"
{
        Type  "E0"
        RA            8.6397
        Dec          19.7161
        Distance   2.155e+08  # method: V
        Radius     2.194e+04
        AbsMag         -18.8
        Axis    [  0.8315  -0.0584  -0.5524]
        Angle     88.9899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2625"
}

Galaxy "NGC 2628:UGC 4519:MCG 4-21-12:ZWG 120.20"
{
        Type  "Sc"
        RA            8.6728
        Dec          23.5397
        Distance   1.749e+08  # method: V
        Radius     2.798e+04
        AbsMag        -19.65
        Axis    [  0.9027  -0.4050  -0.1454]
        Angle     96.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2628"
}

Galaxy "NGC 2629:UGC 4569:MCG 12-9-10:ZWG 331.62"
{
        Type  "S0"
        RA            8.7875
        Dec          72.9856
        Distance   1.675e+08  # method: V
        Radius     3.655e+04
        AbsMag        -20.25
        Axis    [  0.1243   0.9922   0.0045]
        Angle     63.1465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2629"
}

Galaxy "NGC 2633:UGC 4574:MCG 12-9-13:VV 519"
{
        Type  "SBb"
        RA            8.8011
        Dec          74.0992
        Distance    9.98e+07  # method: V
        Radius     3.338e+04
        AbsMag        -19.63
        Axis    [ -0.4099   0.9048  -0.1156]
        Angle    120.7421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2633"
}

Galaxy "NGC 2634:UGC 4581:MCG 12-9-15:ZWG 331.66"
{
        Type  "E1"
        RA            8.8069
        Dec          73.9672
        Distance    1.09e+08  # method: S
        Radius     2.695e+04
        AbsMag        -19.82
        Axis    [  0.9181   0.1703  -0.3578]
        Angle     37.4091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2634"
}

Galaxy "NGC 2634A:UGC 4585:MCG 12-9-16:ZWG 331.68"
{
        Type  "SBc"
        RA            8.8106
        Dec          73.9386
        Distance   9.649e+07  # method: V
        Radius     2.526e+04
        AbsMag        -18.05
        Axis    [  0.0511   0.5672   0.8220]
        Angle     77.1533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2634A"
}

Galaxy "NGC 2636:UGC 4583:ZWG 331.67:ZWG 332.14"
{
        Type  "E0"
        RA            8.8067
        Dec          73.6717
        Distance   8.793e+07  # method: V
        Radius          5116
        AbsMag        -17.45
        Axis    [  0.6622  -0.7479   0.0465]
        Angle     57.2845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2636"
}

Galaxy "NGC 2638:UGC 4534:MCG 6-19-16:ZWG 179.18"
{
        Type  "Sa"
        RA            8.7069
        Dec          37.2208
        Distance    1.78e+08  # method: V
        Radius     4.402e+04
        AbsMag        -19.98
        Axis    [  0.4820   0.8066   0.3423]
        Angle     56.8272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2638"
}

Galaxy "NGC 2639:UGC 4544:MCG 8-16-24:ZWG 237.14"
{
        Type  "Sa"
        RA            8.7269
        Dec          50.2061
        Distance   1.556e+08  # method: V
        Radius     4.073e+04
        AbsMag        -20.79
        Axis    [ -0.2954   0.9327  -0.2069]
        Angle     82.1812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2639"
}

Galaxy "NGC 2640:ESO 165-2:IRAS 08360-5456"
{
        Type  "S0"
        RA            8.6233
        Dec         -55.1236
        Distance   5.608e+07  # method: V
        Radius     1.795e+04
        AbsMag        -18.48
        Axis    [  0.3779   0.0838  -0.9220]
        Angle    126.8475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2640"
}

Galaxy "NGC 2641:UGC 4577:MCG 12-9-12:ZWG 331.65"
{
        Type  "S0"
        RA            8.7992
        Dec          72.8964
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [  0.7613  -0.3811   0.5246]
        Angle     64.5828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2641"
}

Galaxy "NGC 2642:MCG 1-22-33:IRAS 08382-0356"
{
        Type  "SBc"
        RA            8.6789
        Dec          -4.1222
        Distance   2.096e+08  # method: V
        Radius     6.097e+04
        AbsMag        -20.64
        Axis    [  0.5302   0.3519  -0.7714]
        Angle     90.4324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2642"
}

Galaxy "NGC 2644:UGC 4533:MCG 1-22-16:ZWG 32.52"
{
        Type  "Sc"
        RA            8.6922
        Dec           4.9808
        Distance   1.003e+08  # method: V
        Radius     3.063e+04
        AbsMag        -19.04
        Axis    [  0.9280   0.3310   0.1711]
        Angle    102.5606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2644"
}

Galaxy "NGC 2646:UGC 4604:MCG 12-9-19:ZWG 332.19"
{
        Type  "S0"
        RA            8.8392
        Dec          73.4628
        Distance   1.688e+08  # method: V
        Radius     3.191e+04
        AbsMag        -20.37
        Axis    [  0.6766  -0.7306   0.0924]
        Angle     57.9731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2646"
}

Galaxy "NGC 2647:ZWG 89.68:NPM 1"
{
        Type  "E0"
        RA            8.7119
        Dec          19.6511
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [  0.8958  -0.2938  -0.3336]
        Angle     93.8846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2647"
}

Galaxy "NGC 2648:UGC 4541:MCG 2-22-5:ZWG 60.35"
{
        Type  "Sa"
        RA            8.7108
        Dec          14.2850
        Distance    1.05e+08  # method: V
        Radius     4.887e+04
        AbsMag        -19.64
        Axis    [ -0.4680   0.7340  -0.4921]
        Angle     70.2650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2648"
}

Galaxy "NGC 2649:UGC 4555:MCG 6-19-18:ZWG 179.22"
{
        Type  "SBc"
        RA            8.7356
        Dec          34.7175
        Distance   2.017e+08  # method: V
        Radius     4.401e+04
        AbsMag        -20.86
        Axis    [  0.5223   0.6249  -0.5803]
        Angle     66.3938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2649"
}

Galaxy "NGC 2650:UGC 4603:MCG 12-9-20:ZWG 332.18"
{
        Type  "SBb"
        RA            8.8328
        Dec          70.2994
        Distance   1.761e+08  # method: V
        Radius     4.099e+04
        AbsMag        -19.56
        Axis    [  0.6520   0.4922   0.5767]
        Angle     46.0169
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2650"
}

Galaxy "NGC 2651:ZWG 61.1:KARA 282"
{
        Type  "S0"
        RA            8.7319
        Dec          11.7711
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.2250   0.6223  -0.7497]
        Angle     78.3407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2651"
}

Galaxy "NGC 2654:UGC 4605:MCG 10-13-17:ZWG 288.6"
{
        Type  "SBb"
        RA            8.8200
        Dec          60.2208
        Distance   6.573e+07  # method: V
        Radius     4.015e+04
        AbsMag        -18.82
        Axis    [  0.2573   0.5617   0.7863]
        Angle     73.3175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2654"
}

Galaxy "NGC 2655:UGC 4637:MCG 13-7-10:ZWG 349.33"
{
        Type  "SBa"
        RA            8.9269
        Dec          78.2236
        Distance   6.464e+07  # method: V
        Radius     4.607e+04
        AbsMag        -20.48
        Axis    [  0.2813   0.9056   0.3173]
        Angle     49.6344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2655"
}

Galaxy "NGC 2656:MCG 9-15-25:ZWG 264.15:VV 703"
{
        Type  "S0"
        RA            8.7981
        Dec          53.8761
        Distance   6.204e+08  # method: V
        Radius     9.023e+04
        AbsMag         -21.5
        Axis    [  0.8085  -0.5876  -0.0313]
        Angle     71.5900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2656"
}

Galaxy "NGC 2657:UGC 4573:MCG 2-23-2:ZWG 61.6"
{
        Type  "Irr"
        RA            8.7542
        Dec           9.6458
        Distance   1.999e+08  # method: V
        Radius     2.908e+04
        AbsMag        -20.14
        Axis    [ -0.1469   0.6019  -0.7849]
        Angle    104.2700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2657"
}

Galaxy "NGC 2661:UGC 4584:MCG 2-23-4:ZWG 61.8"
{
        Type  "Sc"
        RA            8.7664
        Dec          12.6197
        Distance   1.984e+08  # method: V
        Radius     4.039e+04
        AbsMag        -20.22
        Axis    [  0.8184   0.2226  -0.5298]
        Angle     79.8503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2661"
}

Galaxy "NGC 2662:MCG 2-23-2:NPM 1"
{
        Type  "E0"
        RA            8.7589
        Dec         -15.1211
        Distance   1.995e+08  # distance uncertain!
        Radius     3.483e+04
        AbsMag        -20.13
        Axis    [  0.9222  -0.2925  -0.2528]
        Angle    132.0952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2662"
}

Galaxy "NGC 2663:ESO 371-14:MCG 6-20-1"
{
        Type  "E0"
        RA            8.7522
        Dec         -33.7950
        Distance   9.674e+07  # method: T-F
        Radius     4.924e+04
        AbsMag        -20.46
        Axis    [  0.3113   0.0921  -0.9458]
        Angle    140.6939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2663"
}

Galaxy "NGC 2665:ESO 563-19:MCG 3-23-4:UGCA 144"
{
        Type  "SBa"
        RA            8.7667
        Dec         -19.3033
        Distance   1.065e+08  # distance uncertain!
        Radius     3.099e+04
        AbsMag        -19.07
        Axis    [ -0.1010   0.3652  -0.9254]
        Angle     94.6224
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2665"
}

Galaxy "NGC 2667:NGC 2667A:IC 2410:MCG 3-23-7"
{
        Type  "S0"
        RA            8.8075
        Dec          19.0197
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.5724   0.8196  -0.0263]
        Angle     55.2889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2667"
}

Galaxy "NGC 2668:UGC 4616:MCG 6-20-7:ZWG 180.13"
{
        Type  "SBb"
        RA            8.8228
        Dec          36.7108
        Distance   3.504e+08  # method: V
        Radius     7.646e+04
        AbsMag        -20.26
        Axis    [ -0.4003   0.8288  -0.3910]
        Angle     87.9792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2668"
}

Galaxy "NGC 2672:UGC 4619:MCG 3-23-10:ZWG 90.19"
{
        Type  "E1"
        RA            8.8225
        Dec          19.0744
        Distance   1.746e+08  # method: T-F
        Radius     7.619e+04
        AbsMag        -21.04
        Axis    [  0.2954   0.4654  -0.8343]
        Angle    104.3862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2672"
}

Galaxy "NGC 2673:UGC 4620:MCG 3-23-11:ZWG 90.19"
{
        Type  "E0"
        RA            8.8233
        Dec          19.0747
        Distance   1.746e+08  # method: T-F
        Radius     3.048e+04
        AbsMag        -19.64
        Axis    [  0.8843  -0.4275  -0.1880]
        Angle    101.3412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2673"
}

Galaxy "NGC 2674:NPM 1"
{
        Type  "Sa"
        RA            8.8203
        Dec         -14.2936
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.7684   0.4704  -0.4340]
        Angle     80.2381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2674"
}

Galaxy "NGC 2675:UGC 4629:MCG 9-15-37:ZWG 264.21"
{
        Type  "E0"
        RA            8.8681
        Dec          53.6172
        Distance   4.246e+08  # method: V
        Radius     9.262e+04
        AbsMag        -21.37
        Axis    [  0.6280   0.4569  -0.6300]
        Angle     63.1513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2675"
}

Galaxy "NGC 2676:UGC 4627:MCG 8-16-32:ZWG 237.22"
{
        Type  "S0"
        RA            8.8597
        Dec          47.5583
        Distance   2.798e+08  # method: V
        Radius     4.884e+04
        AbsMag        -20.27
        Axis    [  0.8276  -0.5576  -0.0641]
        Angle     77.0325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2676"
}

Galaxy "NGC 2677:MCG 3-23-12:ZWG 90.21:NPM 1"
{
        Type  "S0"
        RA            8.8336
        Dec          19.0103
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.5598   0.6393  -0.5272]
        Angle     92.1516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2677"
}

Galaxy "NGC 2679:UGC 4632:MCG 5-21-14:ZWG 150.41"
{
        Type  "S0"
        RA            8.8589
        Dec          30.8650
        Distance   1.007e+08  # method: V
        Radius     2.343e+04
        AbsMag        -18.35
        Axis    [  0.9746  -0.1471   0.1688]
        Angle     89.5497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2679"
}

Galaxy "NGC 2680:UGC 4632:MCG 5-21-14:ZWG 150.41"
{
        Type  "E0"
        RA            8.8592
        Dec          30.8658
        Distance   4.366e+08  # distance uncertain!
        Radius      1.27e+04
        AbsMag        -20.13
        Axis    [  0.8593  -0.4869  -0.1568]
        Angle     91.2420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2680"
}

Galaxy "NGC 2681:UGC 4645:MCG 9-15-41:ZWG 264.26"
{
        Type  "SBa"
        RA            8.8922
        Dec          51.3131
        Distance   5.616e+07  # method: S
        Radius     2.941e+04
        AbsMag        -20.08
        Axis    [  0.9995   0.0079   0.0316]
        Angle     53.8470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2681"
}

Galaxy "NGC 2683:UGC 4641:MCG 6-20-11:ZWG 180.17"
{
        Type  "Sb"
        RA            8.8781
        Dec          33.4200
        Distance    2.52e+07  # method: S
        Radius     3.409e+04
        AbsMag        -18.94
        Axis    [  0.6867   0.5131   0.5150]
        Angle     74.4381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2683"
}

Galaxy "NGC 2684:UGC 4662:MCG 8-16-35:ZWG 237.24"
{
        Type  "Sc"
        RA            8.9147
        Dec          49.1603
        Distance   1.369e+08  # method: V
        Radius     1.793e+04
        AbsMag        -19.32
        Axis    [  0.9560   0.0161   0.2928]
        Angle     62.8398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2684"
}

Galaxy "NGC 2685:UGC 4666:MCG 10-13-39:ZWG 288.12"
{
        Type  "SBa"
        RA            8.9261
        Dec          58.7347
        Distance   4.544e+07  # method: V
        Radius      3.04e+04
        AbsMag        -18.62
        Axis    [  0.7379   0.2528   0.6258]
        Angle     62.3120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2685"
}

Galaxy "NGC 2686-1:NGC 2686A:MCG 8-16-36:VV 765"
{
        Type  "E0"
        RA            8.9161
        Dec          49.1425
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [  0.8323   0.0575  -0.5513]
        Angle     59.7158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2686-1"
}

Galaxy "NGC 2686-2:NGC 2686B:MCG 8-16-37:VV 765"
{
        Type  "E0"
        RA            8.9167
        Dec          49.1422
        Distance   9.551e+08  # distance uncertain!
        Radius     4.167e+04
        AbsMag        -20.13
        Axis    [  0.8858  -0.1684  -0.4324]
        Angle     60.5582
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2686-2"
}

Galaxy "NGC 2687-1:NGC 2687A:MCG 8-16-38:VV 765"
{
        Type  "S0"
        RA            8.9181
        Dec          49.1561
        Distance   8.081e+08  # distance uncertain!
        Radius     2.351e+04
        AbsMag        -19.07
        Axis    [  0.7899   0.3155   0.5259]
        Angle     64.6105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2687-1"
}

Galaxy "NGC 2687-2:NGC 2687B:MCG 8-16-39:VV 765"
{
        Type  "S0"
        RA            8.9181
        Dec          49.1561
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9079   0.0911   0.4093]
        Angle     66.2396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2687-2"
}

Galaxy "NGC 2688:MCG 8-16-40:NPM 1"
{
        Type  "S0"
        RA            8.9197
        Dec          49.1225
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [  0.2468   0.9688  -0.0208]
        Angle     52.6846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2688"
}

Galaxy "NGC 2689"
{
        Type  "S0"
        RA            8.9236
        Dec          49.1153
        Distance    6.13e+08  # distance uncertain!
        Radius     2.675e+04
        AbsMag        -19.07
        Axis    [  0.1552   0.9857  -0.0657]
        Angle     55.2467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2689"
}

Galaxy "NGC 2690:UGC 4647:MCG 0-23-8:ZWG 5.20"
{
        Type  "Sb"
        RA            8.8772
        Dec          -2.6036
        Distance   1.404e+08  # distance uncertain!
        Radius     3.881e+04
        AbsMag        -19.07
        Axis    [  0.8971   0.4217   0.1318]
        Angle    102.7885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2690"
}

Galaxy "NGC 2691:UGC 4664:MCG 7-18-64:MK 391"
{
        Type  "Sa"
        RA            8.9128
        Dec          39.5392
        Distance   1.894e+08  # method: V
        Radius     2.479e+04
        AbsMag        -19.92
        Axis    [ -0.4920   0.7984  -0.3472]
        Angle     94.4436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2691"
}

Galaxy "NGC 2692:UGC 4675:MCG 9-15-57:ZWG 264.36"
{
        Type  "SBb"
        RA            8.9492
        Dec          52.0658
        Distance    1.89e+08  # method: V
        Radius     3.573e+04
        AbsMag        -19.71
        Axis    [ -0.5768   0.8064  -0.1301]
        Angle     96.7679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2692"
}

Galaxy "NGC 2693:UGC 4674:MCG 9-15-55:ZWG 264.35"
{
        Type  "E1"
        RA            8.9497
        Dec          51.3478
        Distance   2.127e+08  # method: T-F
        Radius     8.044e+04
        AbsMag        -21.37
        Axis    [  0.0393   0.8307  -0.5553]
        Angle    119.2801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2693"
}

Galaxy "NGC 2694:MCG 9-15-56:ZWG 264.34:NPM 1"
{
        Type  "E1"
        RA            8.9497
        Dec          51.3325
        Distance   2.391e+08  # method: V
        Radius     4.172e+04
        AbsMag        -18.62
        Axis    [  0.7854  -0.6135  -0.0820]
        Angle     74.9505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2694"
}

Galaxy "NGC 2695:MCG 0-23-10:ZWG 5.25"
{
        Type  "S0"
        RA            8.9075
        Dec          -3.0669
        Distance   1.055e+08  # method: S
        Radius      2.61e+04
        AbsMag        -19.65
        Axis    [ -0.4622   0.4599  -0.7582]
        Angle    102.0301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2695"
}

Galaxy "NGC 2696:MCG 1-23-4:NPM 1"
{
        Type  "E0"
        RA            8.8450
        Dec          -5.0094
        Distance   2.512e+08  # distance uncertain!
        Radius      4.75e+04
        AbsMag        -20.13
        Axis    [  0.9103  -0.3358  -0.2420]
        Angle    123.0724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2696"
}

Galaxy "NGC 2697:MCG 0-23-11:ZWG 5.27:IRAS 08524-0247"
{
        Type  "Sa"
        RA            8.9164
        Dec          -2.9878
        Distance   1.065e+08  # distance uncertain!
        Radius     2.789e+04
        AbsMag        -19.07
        Axis    [ -0.0298   0.5849  -0.8106]
        Angle     71.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2697"
}

Galaxy "NGC 2698:MCG 0-23-12:ZWG 5.30"
{
        Type  "Sa"
        RA            8.9267
        Dec          -3.1842
        Distance   1.065e+08  # distance uncertain!
        Radius     2.324e+04
        AbsMag        -19.07
        Axis    [  0.4148   0.7678  -0.4883]
        Angle     54.7430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2698"
}

Galaxy "NGC 2699:MCG 0-23-14:ZWG 5.33:ARAK 187"
{
        Type  "E0"
        RA            8.9300
        Dec          -3.1272
        Distance   8.779e+07  # method: S
        Radius     1.405e+04
        AbsMag        -18.55
        Axis    [  0.7861  -0.1181  -0.6068]
        Angle    110.7864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2699"
}

Galaxy "NGC 2701:UGC 4695:MCG 9-15-63:ZWG 264.43"
{
        Type  "SBc"
        RA            8.9847
        Dec          53.7706
        Distance   1.653e+08  # method: T-F
        Radius     5.289e+04
        AbsMag        -20.82
        Axis    [  0.9086  -0.0280   0.4168]
        Angle     65.2461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2701"
}

Galaxy "NGC 2704:IC 2424:UGC 4678:MCG 7-19-5"
{
        Type  "SBb"
        RA            8.9464
        Dec          39.3825
        Distance   3.316e+08  # method: V
        Radius     4.823e+04
        AbsMag        -20.74
        Axis    [  0.8459  -0.5232  -0.1029]
        Angle     84.2380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2704"
}

Galaxy "NGC 2706:UGC 4680:MCG 0-23-17:ZWG 5.36"
{
        Type  "Sc"
        RA            8.9367
        Dec          -2.5633
        Distance   1.223e+08  # distance uncertain!
        Radius     3.202e+04
        AbsMag        -19.07
        Axis    [ -0.6115   0.4489  -0.6515]
        Angle     76.4415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2706"
}

Galaxy "NGC 2708:NGC 2727:MCG 0-23-15:ZWG 5.34"
{
        Type  "Sb"
        RA            8.9353
        Dec          -3.3606
        Distance   1.043e+08  # method: V
        Radius     4.095e+04
        AbsMag        -19.72
        Axis    [  0.9559   0.2893  -0.0500]
        Angle     97.3689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2708"
}

Galaxy "NGC 2709:MCG 0-23-16:ZWG 5.35:NPM 1"
{
        Type  "S0"
        RA            8.9367
        Dec          -3.2425
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.6366   0.4109  -0.6526]
        Angle     76.2749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2709"
}

Galaxy "NGC 2710:UGC 4705:MCG 9-15-66:ZWG 264.46"
{
        Type  "SBb"
        RA            8.9967
        Dec          55.7058
        Distance   1.211e+08  # method: V
        Radius     3.524e+04
        AbsMag        -19.15
        Axis    [ -0.2544   0.9651   0.0616]
        Angle     69.5520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2710"
}

Galaxy "NGC 2711:UGC 4688:MCG 3-23-20:ZWG 90.42"
{
        Type  "SBc"
        RA            8.9564
        Dec          17.2881
        Distance   2.907e+08  # method: V
        Radius     3.805e+04
        AbsMag        -20.15
        Axis    [ -0.4634   0.6466  -0.6059]
        Angle     96.6934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2711"
}

Galaxy "NGC 2712:UGC 4708:MCG 8-17-3:ZWG 238.1"
{
        Type  "SBb"
        RA            8.9917
        Dec          44.9139
        Distance   9.078e+07  # method: V
        Radius     3.697e+04
        AbsMag        -19.52
        Axis    [ -0.5593   0.7703  -0.3062]
        Angle    105.9092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2712"
}

Galaxy "NGC 2713:UGC 4691:MCG 1-23-6:ZWG 33.28"
{
        Type  "SBb"
        RA            8.9556
        Dec           2.9214
        Distance   1.909e+08  # method: V
        Radius     9.998e+04
        AbsMag        -21.14
        Axis    [  0.2242   0.7885  -0.5728]
        Angle     54.3681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2713"
}

Galaxy "NGC 2714:ESO 125-7"
{
        Type  "E0"
        RA            8.8914
        Dec         -59.2175
        Distance   2.188e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -20.13
        Axis    [  0.9290  -0.1687  -0.3295]
        Angle    173.1771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2714"
}

Galaxy "NGC 2715:UGC 4759:MCG 13-7-15:ZWG 350.12"
{
        Type  "SBc"
        RA            9.1347
        Dec          78.0858
        Distance   6.098e+07  # method: V
        Radius     4.257e+04
        AbsMag        -19.56
        Axis    [  0.5315   0.0016   0.8471]
        Angle     84.8720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2715"
}

Galaxy "NGC 2716:UGC 4692:MCG 1-23-7:ZWG 33.29"
{
        Type  "SBa"
        RA            8.9597
        Dec           3.0903
        Distance   1.734e+08  # method: V
        Radius     3.279e+04
        AbsMag        -20.53
        Axis    [  0.9723   0.1296  -0.1945]
        Angle     91.8030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2716"
}

Galaxy "NGC 2717:ESO 496-21:MCG 4-21-15:AM 0854-242"
{
        Type  "S0"
        RA            8.9503
        Dec         -24.6739
        Distance   9.715e+07  # distance uncertain!
        Radius     2.967e+04
        AbsMag        -19.07
        Axis    [  0.9688   0.1511  -0.1967]
        Angle    124.2200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2717"
}

Galaxy "NGC 2718:UGC 4707:MCG 1-23-15:MK 703"
{
        Type  "SBb"
        RA            8.9806
        Dec           6.2939
        Distance   1.871e+08  # method: V
        Radius     5.716e+04
        AbsMag        -20.79
        Axis    [  0.9039  -0.3716  -0.2120]
        Angle    112.7179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2718"
}

Galaxy "NGC 2719:UGC 4718:MCG 6-20-17:ZWG 180.25"
{
        Type  "Irr"
        RA            9.0042
        Dec          35.7278
        Distance   1.531e+08  # method: V
        Radius     2.449e+04
        AbsMag        -19.46
        Axis    [ -0.4381   0.8981  -0.0389]
        Angle     64.1329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2719"
}

Galaxy "NGC 2719A:MCG 6-20-18:ARP 202:KCPG 181B"
{
        Type  "Irr"
        RA            9.0042
        Dec          35.7206
        Distance   1.495e+08  # method: V
        Radius          8697
        AbsMag        -18.81
        Axis    [ -0.1378   0.8685  -0.4761]
        Angle     75.5204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2719A"
}

Galaxy "NGC 2720:UGC 4710:MCG 2-23-16:ZWG 61.34"
{
        Type  "S0"
        RA            8.9856
        Dec          11.1497
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [  0.8980  -0.3923  -0.1995]
        Angle    108.4660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2720"
}

Galaxy "NGC 2721:MCG 1-23-15"
{
        Type  "Sc"
        RA            8.9822
        Dec          -4.9014
        Distance   2.098e+08  # method: T-F
        Radius     7.323e+04
        AbsMag        -21.04
        Axis    [ -0.2935   0.4927  -0.8192]
        Angle     85.6866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2721"
}

Galaxy "NGC 2722:NGC 2733:MCG 1-23-14:IRAS 08562-0330"
{
        Type  "Sc"
        RA            8.9794
        Dec          -3.7097
        Distance   1.507e+08  # method: T-F
        Radius     4.384e+04
        AbsMag        -19.82
        Axis    [  0.8023   0.3928  -0.4495]
        Angle     76.5648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2722"
}

Galaxy "NGC 2723:UGC 4723:MCG 1-23-17:ZWG 33.39"
{
        Type  "S0"
        RA            9.0039
        Dec           3.1783
        Distance    1.82e+08  # method: V
        Radius     2.118e+04
        AbsMag        -19.53
        Axis    [  0.9056  -0.3618  -0.2215]
        Angle    115.5606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2723"
}

Galaxy "NGC 2724:UGC 4726:MCG 6-20-19:ZWG 180.27"
{
        Type  "SBc"
        RA            9.0169
        Dec          35.7625
        Distance   1.558e+08  # method: V
        Radius     4.079e+04
        AbsMag        -18.99
        Axis    [  0.9519  -0.2802   0.1240]
        Angle     86.3886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2724"
}

Galaxy "NGC 2725:UGC 4732:MCG 2-23-18:ZWG 61.38"
{
        Type  "Irr"
        RA            9.0175
        Dec          11.0975
        Distance   1.068e+08  # method: V
        Radius     1.088e+04
        AbsMag        -18.28
        Axis    [  0.8810   0.2065  -0.4257]
        Angle     76.6078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2725"
}

Galaxy "NGC 2726:UGC 4750:MCG 10-13-54:ZWG 288.18"
{
        Type  "Sa"
        RA            9.0822
        Dec          59.9333
        Distance   7.402e+07  # method: V
        Radius     1.723e+04
        AbsMag        -18.48
        Axis    [  0.0815   0.7799   0.6205]
        Angle     61.3421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2726"
}

Galaxy "NGC 2728:UGC 4738:MCG 2-23-20:ZWG 61.42"
{
        Type  "Sb"
        RA            9.0278
        Dec          11.0836
        Distance   2.733e+08  # method: V
        Radius     4.372e+04
        AbsMag        -20.02
        Axis    [  0.8611   0.3657  -0.3532]
        Angle     69.4038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2728"
}

Galaxy "NGC 2729:UGC 4737:MCG 1-23-18:ZWG 33.46"
{
        Type  "S0"
        RA            9.0244
        Dec           3.7211
        Distance   1.281e+08  # distance uncertain!
        Radius      1.49e+04
        AbsMag        -19.07
        Axis    [  0.9933   0.1020   0.0548]
        Angle    106.7852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2729"
}

Galaxy "NGC 2730:UGC 4743:MCG 3-23-28:ZWG 90.57"
{
        Type  "Irr"
        RA            9.0375
        Dec          16.8383
        Distance   1.859e+08  # method: V
        Radius     4.597e+04
        AbsMag        -20.18
        Axis    [  0.6707   0.5344  -0.5143]
        Angle     61.8653
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2730"
}

Galaxy "NGC 2731:UGC 4741:MCG 2-23-21:ZWG 33.48"
{
        Type  "Sc"
        RA            9.0356
        Dec           8.3006
        Distance   1.301e+08  # method: V
        Radius     1.514e+04
        AbsMag         -18.6
        Axis    [  0.7755   0.5053  -0.3784]
        Angle     64.4755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2731"
}

Galaxy "NGC 2732:UGC 4818:MCG 13-7-16:ZWG 350.13"
{
        Type  "S0"
        RA            9.2236
        Dec          79.1878
        Distance   9.038e+07  # method: V
        Radius      2.76e+04
        AbsMag        -19.31
        Axis    [  0.2263   0.4805   0.8473]
        Angle     65.2699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2732"
}

Galaxy "NGC 2734:NPM 1"
{
        Type  "E0"
        RA            9.0503
        Dec          16.8642
        Distance   6.919e+08  # distance uncertain!
        Radius     6.038e+04
        AbsMag        -20.13
        Axis    [  0.5563   0.2050  -0.8053]
        Angle     92.4808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2734"
}

Galaxy "NGC 2735:UGC 4744:MCG 4-22-2:ZWG 121.3"
{
        Type  "SBb"
        RA            9.0439
        Dec          25.9347
        Distance   1.224e+08  # method: V
        Radius     2.136e+04
        AbsMag        -18.77
        Axis    [  0.2757   0.9607   0.0321]
        Angle     48.7299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2735"
}

Galaxy "NGC 2735A:MCG 4-22-3:ZWG 121.3:VV 40"
{
        Type  "Irr"
        RA            9.0447
        Dec          25.9389
        Distance   5.249e+08  # distance uncertain!
        Radius     3.053e+04
        AbsMag        -20.13
        Axis    [  0.9475   0.0468   0.3163]
        Angle    101.3647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2735A"
}

Galaxy "NGC 2737:UGC 4751:MCG 4-22-5:ZWG 121.9"
{
        Type  "Sb"
        RA            9.0664
        Dec          21.9064
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.8043   0.5895   0.0744]
        Angle     59.2794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2737"
}

Galaxy "NGC 2738:UGC 4752:MCG 4-22-6:ZWG 121.10"
{
        Type  "Sc"
        RA            9.0667
        Dec          21.9683
        Distance   1.527e+08  # method: V
        Radius     3.109e+04
        AbsMag        -19.45
        Axis    [  0.8367   0.5322   0.1293]
        Angle     62.8248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2738"
}

Galaxy "NGC 2739:MCG 9-15-85:ZWG 264.59:KCPG 185A"
{
        Type  "Sb"
        RA            9.1006
        Dec          51.7444
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.0450   0.8282   0.5586]
        Angle     61.9201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2739"
}

Galaxy "NGC 2740:MCG 9-15-86:ZWG 264.60:KCPG 185B"
{
        Type  "Sb"
        RA            9.1014
        Dec          51.7356
        Distance   4.104e+08  # method: V
        Radius     5.969e+04
        AbsMag         -20.5
        Axis    [  0.9935   0.1132   0.0075]
        Angle     49.6808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2740"
}

Galaxy "NGC 2741:MK 1221:IRAS 09004+1827"
{
        Type  "S0"
        RA            9.0544
        Dec          18.2606
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.6359   0.7436  -0.2065]
        Angle     53.1233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2741"
}

Galaxy "NGC 2742:NGC 2816:UGC 4779:MCG 10-13-57"
{
        Type  "Sc"
        RA            9.1258
        Dec          60.4794
        Distance   8.625e+07  # method: T-F
        Radius     3.763e+04
        AbsMag        -20.01
        Axis    [  0.1966   0.8539   0.4818]
        Angle     53.6615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2742"
}

Galaxy "NGC 2742A:UGC 4803:MCG 10-13-60:ZWG 288.22"
{
        Type  "SBb"
        RA            9.1658
        Dec          62.2469
        Distance   3.493e+08  # method: V
        Radius     8.129e+04
        AbsMag        -21.15
        Axis    [  0.0691   0.8068   0.5867]
        Angle     59.5764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2742A"
}

Galaxy "NGC 2743:UGC 4760:MCG 4-22-9:ZWG 121.13"
{
        Type  "Irr"
        RA            9.0817
        Dec          25.0042
        Distance   1.475e+08  # method: V
        Radius     2.361e+04
        AbsMag        -18.98
        Axis    [  0.2781   0.7927  -0.5424]
        Angle     58.4258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2743"
}

Galaxy "NGC 2744:UGC 4757:MCG 3-23-31:ZWG 90.65"
{
        Type  "SBb"
        RA            9.0775
        Dec          18.4642
        Distance   1.676e+08  # method: V
        Radius     3.899e+04
        AbsMag        -19.65
        Axis    [  0.0830   0.7341  -0.6739]
        Angle     67.7135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2744"
}

Galaxy "NGC 2744A:VV 612"
{
        Type  "Irr"
        RA            9.0772
        Dec          18.4561
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.8810  -0.4359  -0.1839]
        Angle    102.5494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2744A"
}

Galaxy "NGC 2745:ZWG 90.64:NPM 1"
{
        Type  "S0"
        RA            9.0775
        Dec          18.2578
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.9647   0.0807   0.2506]
        Angle    104.9288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2745"
}

Galaxy "NGC 2746:UGC 4770:MCG 6-20-23:ZWG 180.32"
{
        Type  "SBa"
        RA            9.0997
        Dec          35.3772
        Distance   3.302e+08  # method: V
        Radius     7.683e+04
        AbsMag        -20.93
        Axis    [  0.1378   0.7507  -0.6461]
        Angle     78.3026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2746"
}

Galaxy "NGC 2747:ZWG 90.70:NPM 1"
{
        Type  "S0"
        RA            9.0883
        Dec          18.4428
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.5762   0.6337  -0.5162]
        Angle     88.2033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2747"
}

Galaxy "NGC 2748:UGC 4825:MCG 13-7-19:ZWG 350.14"
{
        Type  "Sc"
        RA            9.2286
        Dec          76.4758
        Distance    7.42e+07  # method: T-F
        Radius     3.346e+04
        AbsMag        -19.48
        Axis    [  0.4704   0.1493   0.8697]
        Angle     75.9037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2748"
}

Galaxy "NGC 2749:UGC 4763:MCG 3-23-36:ZWG 90.69"
{
        Type  "E3"
        RA            9.0892
        Dec          18.3136
        Distance   2.027e+08  # method: T-F
        Radius     5.012e+04
        AbsMag        -21.27
        Axis    [  0.6692   0.0793  -0.7389]
        Angle     88.7726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2749"
}

Galaxy "NGC 2750:UGC 4769:MCG 4-22-12:ZWG 121.17"
{
        Type  "Sc"
        RA            9.0967
        Dec          25.4375
        Distance   1.326e+08  # method: V
        Radius     4.244e+04
        AbsMag        -20.35
        Axis    [  0.6604   0.5080  -0.5530]
        Angle     60.9331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2750"
}

Galaxy "NGC 2751:MCG 3-23-37:ZWG 90.71"
{
        Type  "Sc"
        RA            9.0922
        Dec          18.2619
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.0844   0.6710  -0.7367]
        Angle     88.1490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2751"
}

Galaxy "NGC 2752:UGC 4772:MCG 3-23-38:ZWG 90.72"
{
        Type  "SBb"
        RA            9.0950
        Dec          18.3397
        Distance   1.851e+08  # distance uncertain!
        Radius     4.846e+04
        AbsMag        -19.07
        Axis    [  0.7102   0.6421   0.2886]
        Angle     65.1133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2752"
}

Galaxy "NGC 2753-1:MCG 4-22-15:ZWG 121.20:KCPG 187"
{
        Type  "E0"
        RA            9.1189
        Dec          25.3411
        Distance   1.399e+08  # method: V
        Radius     1.628e+04
        AbsMag        -17.66
        Axis    [  0.8634  -0.3967  -0.3117]
        Angle     90.7388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2753-1"
}

Galaxy "NGC 2753-2:MCG 4-22-15:ZWG 121.20"
{
        Type  "E0"
        RA            9.1189
        Dec          25.3442
        Distance   3.468e+08  # distance uncertain!
        Radius     1.513e+04
        AbsMag        -20.13
        Axis    [  0.8491  -0.4945  -0.1859]
        Angle     97.4476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2753-2"
}

Galaxy "NGC 2754:ESO 564-16:NPM 1"
{
        Type  "S0"
        RA            9.0864
        Dec         -19.0847
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.3897   0.3123  -0.8664]
        Angle     89.7779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2754"
}

Galaxy "NGC 2755:UGC 4789:MCG 7-19-34:ZWG 209.30"
{
        Type  "Sb"
        RA            9.1328
        Dec          41.7086
        Distance    3.51e+08  # method: V
        Radius     6.126e+04
        AbsMag        -20.96
        Axis    [ -0.1636   0.9360  -0.3118]
        Angle     67.8779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2755"
}

Galaxy "NGC 2756:UGC 4796:MCG 9-15-98:ZWG 264.67"
{
        Type  "Sb"
        RA            9.1500
        Dec          53.8486
        Distance   1.888e+08  # method: V
        Radius     4.669e+04
        AbsMag        -20.61
        Axis    [  0.8637  -0.2564   0.4338]
        Angle     84.3444
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2756"
}

Galaxy "NGC 2758:ESO 564-20:MCG 3-23-19:IRAS 09032-1850"
{
        Type  "Sc"
        RA            9.0919
        Dec         -19.0428
        Distance   1.007e+08  # method: T-F
        Radius     2.783e+04
        AbsMag        -18.45
        Axis    [  0.9015   0.4314  -0.0346]
        Angle    109.6425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2758"
}

Galaxy "NGC 2759:UGC 4795:MCG 6-20-33:ZWG 180.42"
{
        Type  "S0"
        RA            9.1436
        Dec          37.6214
        Distance   3.244e+08  # method: V
        Radius     4.718e+04
        AbsMag        -20.99
        Axis    [  0.9388   0.3298   0.0989]
        Angle     56.4113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2759"
}

Galaxy "NGC 2761:MCG 3-23-41:ZWG 91.1:ZWG 90.77"
{
        Type  "S0"
        RA            9.1250
        Dec          18.4350
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.4434   0.6687  -0.5968]
        Angle     90.8880
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2761"
}

Galaxy "NGC 2762:MCG 8-17-45:ZWG 264.72"
{
        Type  "S0"
        RA            9.1650
        Dec          50.4183
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.8940  -0.1357   0.4269]
        Angle     78.9854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2762"
}

Galaxy "NGC 2763:MCG 2-23-10:IRAS 09044-1517"
{
        Type  "SBc"
        RA            9.1136
        Dec         -15.4992
        Distance   1.126e+08  # method: T-F
        Radius     3.766e+04
        AbsMag        -19.99
        Axis    [  0.1715   0.3263  -0.9296]
        Angle     94.2681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2763"
}

Galaxy "NGC 2764:UGC 4794:MCG 4-22-17:ZWG 121.24"
{
        Type  "S0"
        RA            9.1381
        Dec          21.4431
        Distance   1.353e+08  # method: V
        Radius     2.951e+04
        AbsMag        -19.49
        Axis    [  0.9914   0.0388   0.1249]
        Angle     88.7594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2764"
}

Galaxy "NGC 2765:UGC 4791:MCG 1-24-1:ZWG 33.61"
{
        Type  "S0"
        RA            9.1267
        Dec           3.3928
        Distance   1.869e+08  # method: V
        Radius     5.709e+04
        AbsMag        -20.59
        Axis    [  0.2569   0.7071  -0.6588]
        Angle     56.5600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2765"
}

Galaxy "NGC 2766:UGC 4801:MCG 5-22-9:ZWG 151.14"
{
        Type  "Sb"
        RA            9.1464
        Dec          29.8653
        Distance   2.007e+08  # method: V
        Radius     4.086e+04
        AbsMag        -19.44
        Axis    [ -0.3650   0.9093  -0.1998]
        Angle     59.7672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2766"
}

Galaxy "NGC 2767:UGC 4813:MCG 8-17-46:ZWG 264.75"
{
        Type  "S0"
        RA            9.1697
        Dec          50.4019
        Distance   2.314e+08  # method: V
        Radius      3.03e+04
        AbsMag        -19.65
        Axis    [ -0.3598   0.8647  -0.3505]
        Angle    104.9019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2767"
}

Galaxy "NGC 2768:UGC 4821:MCG 10-13-65:ZWG 288.26"
{
        Type  "E6"
        RA            9.1936
        Dec          60.0364
        Distance   7.302e+07  # method: S
        Radius     6.797e+04
        AbsMag        -20.85
        Axis    [  0.4949   0.6236  -0.6051]
        Angle     63.4895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2768"
}

Galaxy "NGC 2769:UGC 4816:MCG 8-17-50:ZWG 264.76"
{
        Type  "Sa"
        RA            9.1756
        Dec          50.4336
        Distance   2.259e+08  # method: V
        Radius     5.913e+04
        AbsMag         -20.3
        Axis    [ -0.5821   0.8037   0.1231]
        Angle     79.5376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2769"
}

Galaxy "NGC 2770:UGC 4806:MCG 6-20-38:ZWG 180.47"
{
        Type  "Sc"
        RA            9.1592
        Dec          33.1242
        Distance   1.222e+08  # method: T-F
        Radius     6.575e+04
        AbsMag        -20.17
        Axis    [ -0.5626   0.8094  -0.1685]
        Angle     70.5162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2770"
}

Galaxy "NGC 2770A:MCG 6-20-36:KUG 0906+333"
{
        Type  "Sa"
        RA            9.1553
        Dec          33.1222
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.9561  -0.2452   0.1607]
        Angle     91.1266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2770A"
}

Galaxy "NGC 2771:UGC 4817:MCG 8-17-51:ZWG 264.77"
{
        Type  "SBb"
        RA            9.1775
        Dec          50.3792
        Distance   2.364e+08  # method: V
        Radius     7.909e+04
        AbsMag         -20.6
        Axis    [ -0.1157   0.9272  -0.3563]
        Angle     78.5699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2771"
}

Galaxy "NGC 2772:ESO 497-14:MCG 4-22-2:AM 0905-232"
{
        Type  "Sb"
        RA            9.1281
        Dec         -23.6194
        Distance   2.171e+08  # method: T-F
        Radius     4.737e+04
        AbsMag        -19.92
        Axis    [ -0.5758   0.1841  -0.7966]
        Angle     76.0728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2772"
}

Galaxy "NGC 2773:UGC 4815:MCG 1-24-4:ZWG 34.5"
{
        Type  "S0"
        RA            9.1622
        Dec           7.1742
        Distance   2.625e+08  # method: V
        Radius     2.672e+04
        AbsMag        -20.03
        Axis    [  0.6207   0.7119  -0.3285]
        Angle     54.0184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2773"
}

Galaxy "NGC 2774:MCG 3-24-4:ZWG 91.15"
{
        Type  "S0"
        RA            9.1775
        Dec          18.6967
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.8730  -0.4497  -0.1888]
        Angle    102.8439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2774"
}

Galaxy "NGC 2775:UGC 4820:MCG 1-24-5:ZWG 34.6"
{
        Type  "Sb"
        RA            9.1722
        Dec           7.0372
        Distance   7.475e+07  # method: V
        Radius     4.675e+04
        AbsMag         -20.6
        Axis    [ -0.2925   0.5859  -0.7557]
        Angle     89.4334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2775"
}

Galaxy "NGC 2776:UGC 4838:MCG 8-17-56:ZWG 238.20"
{
        Type  "SBc"
        RA            9.2039
        Dec          44.9547
        Distance   1.276e+08  # method: V
        Radius     5.195e+04
        AbsMag        -20.86
        Axis    [  0.9062  -0.3793   0.1871]
        Angle     83.0506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2776"
}

Galaxy "NGC 2777:UGC 4823:MCG 1-24-6:ZWG 34.8"
{
        Type  "Sb"
        RA            9.1781
        Dec           7.2072
        Distance   8.091e+07  # method: V
        Radius          8237
        AbsMag        -18.07
        Axis    [ -0.3162   0.5701  -0.7583]
        Angle    102.6589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2777"
}

Galaxy "NGC 2778:UGC 4840:MCG 6-20-43:ZWG 180.54"
{
        Type  "E0"
        RA            9.2067
        Dec          35.0278
        Distance   7.472e+07  # method: S
        Radius     1.521e+04
        AbsMag         -18.5
        Axis    [  0.8392  -0.2105  -0.5014]
        Angle     73.9153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2778"
}

Galaxy "NGC 2779:MCG 6-20-44:ZWG 180.55"
{
        Type  "SBa"
        RA            9.2078
        Dec          35.0539
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [ -0.2679   0.7953  -0.5437]
        Angle     97.9975
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2779"
}

Galaxy "NGC 2780:UGC 4843:MCG 6-20-47:ZWG 180.57"
{
        Type  "SBa"
        RA            9.2122
        Dec          34.9256
        Distance   1.001e+08  # method: V
        Radius     1.311e+04
        AbsMag        -18.14
        Axis    [ -0.2570   0.8243  -0.5045]
        Angle     84.8847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2780"
}

Galaxy "NGC 2781:MCG 2-24-2:IRAS 09091-1436"
{
        Type  "SBa"
        RA            9.1908
        Dec         -14.8172
        Distance   1.055e+08  # method: V
        Radius     4.604e+04
        AbsMag        -20.05
        Axis    [  0.6642   0.4576  -0.5911]
        Angle     70.7013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2781"
}

Galaxy "NGC 2782:UGC 4862:MCG 7-19-36:ZWG 209.31"
{
        Type  "SBa"
        RA            9.2347
        Dec          40.1136
        Distance   1.255e+08  # method: V
        Radius     6.753e+04
        AbsMag        -20.62
        Axis    [  0.7105   0.7026   0.0387]
        Angle     46.8159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2782"
}

Galaxy "NGC 2783:NGC 2783A:UGC 4859:MCG 5-22-19"
{
        Type  "E0"
        RA            9.2275
        Dec          29.9931
        Distance   3.146e+08  # method: V
        Radius     1.007e+05
        AbsMag        -21.72
        Axis    [ -0.0725   0.7160  -0.6944]
        Angle    125.4391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2783"
}

Galaxy "NGC 2783B:UGC 4856:MCG 5-22-17:ZWG 151.26"
{
        Type  "Sb"
        RA            9.2256
        Dec          29.9997
        Distance   3.157e+08  # method: V
        Radius     7.347e+04
        AbsMag        -19.83
        Axis    [  0.4212   0.7857   0.4530]
        Angle     55.1510
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2783B"
}

Galaxy "NGC 2784:ESO 497-23:MCG 4-22-5:UGCA 152"
{
        Type  "S0"
        RA            9.2053
        Dec         -24.1725
        Distance   3.202e+07  # method: S
        Radius     2.562e+04
        AbsMag        -18.66
        Axis    [  0.7039   0.4464  -0.5525]
        Angle     76.0011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2784"
}

Galaxy "NGC 2785:UGC 4876:MCG 7-19-42:ZWG 209.35"
{
        Type  "Irr"
        RA            9.2542
        Dec          40.9181
        Distance   1.335e+08  # method: V
        Radius     2.912e+04
        AbsMag        -18.26
        Axis    [ -0.2575   0.9614   0.0974]
        Angle     56.9022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2785"
}

Galaxy "NGC 2786:UGC 4861:MCG 2-24-2:ZWG 62.8"
{
        Type  "Sa"
        RA            9.2264
        Dec          12.4406
        Distance   2.354e+08  # method: V
        Radius     3.082e+04
        AbsMag        -20.59
        Axis    [  0.7214   0.5264  -0.4499]
        Angle     59.2177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2786"
}

Galaxy "NGC 2787:UGC 4914:MCG 12-9-39:ZWG 332.41"
{
        Type  "SBa"
        RA            9.3217
        Dec          69.2036
        Distance    2.44e+07  # method: S
        Radius       1.1e+04
        AbsMag        -17.57
        Axis    [ -0.0937   0.9435   0.3180]
        Angle     63.1727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2787"
}

Galaxy "NGC 2788:ESO 61-2:AM 0908-674:IRAS 09083-6743"
{
        Type  "Sb"
        RA            9.1508
        Dec         -67.9325
        Distance   6.664e+07  # method: T-F
        Radius     1.745e+04
        AbsMag        -18.25
        Axis    [  0.3093   0.0963  -0.9461]
        Angle     81.2162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2788"
}

Galaxy "NGC 2788A:ESO 60-24:IRAS 09020-6801"
{
        Type  "Sb"
        RA            9.0444
        Dec         -68.2267
        Distance   2.267e+08  # method: T-F
        Radius     9.561e+04
        AbsMag        -20.31
        Axis    [  0.6780   0.4404  -0.5886]
        Angle    111.0734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2788A"
}

Galaxy "NGC 2788B:ESO 60-25"
{
        Type  "Sb"
        RA            9.0597
        Dec         -67.9664
        Distance   4.285e+07  # method: T-F
        Radius          9349
        AbsMag        -16.09
        Axis    [ -0.2355  -0.2686  -0.9340]
        Angle     83.7173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2788B"
}

Galaxy "NGC 2789:UGC 4875:MCG 5-22-26:ZWG 151.35"
{
        Type  "SBa"
        RA            9.2497
        Dec          29.7303
        Distance   2.969e+08  # method: V
        Radius     6.476e+04
        AbsMag         -21.3
        Axis    [  0.9898  -0.1414  -0.0175]
        Angle     78.8716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2789"
}

Galaxy "NGC 2790:MCG 3-24-16:MK 1228:ZWG 91.34"
{
        Type  "Sc"
        RA            9.2506
        Dec          19.6975
        Distance    3.68e+08  # method: V
        Radius     3.211e+04
        AbsMag        -20.06
        Axis    [  0.9415   0.3119  -0.1274]
        Angle     65.2074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2790"
}

Galaxy "NGC 2791:ZWG 91.33:NPM 1"
{
        Type  "S0"
        RA            9.2503
        Dec          17.5928
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.5757   0.6859  -0.4451]
        Angle     70.9407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2791"
}

Galaxy "NGC 2793:UGC 4894:MCG 6-21-2:ZWG 181.6"
{
        Type  "Irr"
        RA            9.2794
        Dec          34.4322
        Distance   8.675e+07  # method: V
        Radius     1.514e+04
        AbsMag        -18.52
        Axis    [  0.8928   0.3616  -0.2685]
        Angle     53.5245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2793"
}

Galaxy "NGC 2794:UGC 4885:MCG 3-24-18:ZWG 91.37"
{
        Type  "SBa"
        RA            9.2669
        Dec          17.5894
        Distance   4.097e+08  # method: V
        Radius      7.15e+04
        AbsMag        -21.49
        Axis    [  0.8680  -0.4556  -0.1975]
        Angle    104.2343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2794"
}

Galaxy "NGC 2795:UGC 4887:MCG 3-24-20:ZWG 91.39"
{
        Type  "E0"
        RA            9.2675
        Dec          17.6283
        Distance   4.006e+08  # method: V
        Radius     8.158e+04
        AbsMag        -21.55
        Axis    [ -0.1243   0.6364  -0.7613]
        Angle    129.1573
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2795"
}

Galaxy "NGC 2796:UGC 4893:MCG 5-22-29:ZWG 151.42"
{
        Type  "Sa"
        RA            9.2781
        Dec          30.9161
        Distance   3.261e+08  # method: V
        Radius     5.217e+04
        AbsMag         -20.6
        Axis    [  0.6685   0.7238  -0.1710]
        Angle     48.0689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2796"
}

Galaxy "NGC 2797:UGC 4891:MCG 3-24-23:ZWG 91.42"
{
        Type  "Irr"
        RA            9.2725
        Dec          17.7272
        Distance   2.754e+08  # distance uncertain!
        Radius     2.404e+04
        AbsMag        -20.13
        Axis    [  0.9938  -0.0651  -0.0906]
        Angle     86.6853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2797"
}

Galaxy "NGC 2798:UGC 4905:MCG 7-19-55:ZWG 209.45"
{
        Type  "SBa"
        RA            9.2894
        Dec          42.0000
        Distance   8.811e+07  # method: V
        Radius     3.588e+04
        AbsMag        -19.16
        Axis    [ -0.6195   0.7747  -0.1268]
        Angle     82.7674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2798"
}

Galaxy "NGC 2799:UGC 4909:MCG 7-19-56:ZWG 209.46"
{
        Type  "Irr"
        RA            9.2919
        Dec          41.9939
        Distance   9.056e+07  # method: V
        Radius     2.502e+04
        AbsMag        -17.92
        Axis    [ -0.3671   0.9157   0.1636]
        Angle     60.1754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2799"
}

Galaxy "NGC 2800:UGC 4920:MCG 9-15-117:ZWG 264.94"
{
        Type  "E0"
        RA            9.3097
        Dec          52.5147
        Distance   3.525e+08  # method: V
        Radius     7.178e+04
        AbsMag        -21.37
        Axis    [  0.8059  -0.5576  -0.1989]
        Angle     67.7987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2800"
}

Galaxy "NGC 2801:UGC 4899:MCG 3-24-25:ZWG 91.46"
{
        Type  "Sc"
        RA            9.2789
        Dec          19.9353
        Distance    3.62e+08  # method: V
        Radius     5.792e+04
        AbsMag        -20.13
        Axis    [  0.8344   0.1970  -0.5148]
        Angle     68.5715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2801"
}

Galaxy "NGC 2802:UGC 4897:MCG 3-24-26:ZWG 91.44"
{
        Type  "S0"
        RA            9.2781
        Dec          18.9639
        Distance   4.092e+08  # method: V
        Radius     6.547e+04
        AbsMag        -20.39
        Axis    [ -0.2147   0.8128  -0.5415]
        Angle     60.8773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2802"
}

Galaxy "NGC 2803:UGC 4898:MCG 3-24-27:ZWG 91.44"
{
        Type  "S0"
        RA            9.2786
        Dec          18.9544
        Distance    4.14e+08  # method: V
        Radius     6.624e+04
        AbsMag        -20.42
        Axis    [  0.9584   0.1289  -0.2545]
        Angle     71.4255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2803"
}

Galaxy "NGC 2804:IC 2455:UGC 4901:MCG 3-24-28"
{
        Type  "S0"
        RA            9.2803
        Dec          20.1983
        Distance   3.803e+08  # method: V
        Radius     7.743e+04
        AbsMag        -21.53
        Axis    [  0.8725   0.2357  -0.4280]
        Angle     65.7747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2804"
}

Galaxy "NGC 2805:UGC 4936:MCG 11-12-3:ZWG 312.2"
{
        Type  "SBc"
        RA            9.3389
        Dec          64.1028
        Distance   8.322e+07  # method: V
        Radius     7.625e+04
        AbsMag        -20.53
        Axis    [ -0.1949   0.9738  -0.1168]
        Angle     80.3078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2805"
}

Galaxy "NGC 2807:MCG 3-24-31:ZWG 91.51"
{
        Type  "S0"
        RA            9.2833
        Dec          20.0361
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.3368   0.7267  -0.5988]
        Angle     77.8585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2807"
}

Galaxy "NGC 2807A:MCG 3-24-30"
{
        Type  "S0"
        RA            9.2825
        Dec          20.0292
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.6722   0.6698  -0.3154]
        Angle     51.5053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2807A"
}

Galaxy "NGC 2809:UGC 4910:MCG 3-24-33:ZWG 91.54"
{
        Type  "S0"
        RA            9.2850
        Dec          20.0692
        Distance   3.742e+08  # method: V
        Radius     7.076e+04
        AbsMag         -21.4
        Axis    [ -0.2960   0.6714  -0.6794]
        Angle    110.2896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2809"
}

Galaxy "NGC 2810:NGC 2810A:UGC 4954:MCG 12-9-42"
{
        Type  "E0"
        RA            9.3678
        Dec          71.8439
        Distance   1.877e+08  # method: T-F
        Radius      4.64e+04
        AbsMag         -20.6
        Axis    [  0.6013  -0.7982   0.0368]
        Angle     64.5569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2810"
}

Galaxy "NGC 2810B"
{
        Type  "S0"
        RA            9.3661
        Dec          71.8667
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.2125   0.6776   0.7041]
        Angle     56.7879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2810B"
}

Galaxy "NGC 2811:MCG 3-24-3:UGCA 155:IRAS 09138-1606"
{
        Type  "SBa"
        RA            9.2697
        Dec         -16.3125
        Distance   1.278e+08  # method: V
        Radius     4.647e+04
        AbsMag        -20.66
        Axis    [  0.9326   0.3499  -0.0888]
        Angle    105.1264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2811"
}

Galaxy "NGC 2812:ZWG 91.60"
{
        Type  "S0"
        RA            9.2944
        Dec          19.9192
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [ -0.6758   0.7074  -0.2071]
        Angle     61.7320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2812"
}

Galaxy "NGC 2813:UGC 4916:MCG 3-24-37:ZWG 91.61"
{
        Type  "S0"
        RA            9.2958
        Dec          19.9069
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [ -0.1603   0.6908  -0.7051]
        Angle     85.1381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2813"
}

Galaxy "NGC 2814:UGC 4952:MCG 11-12-4:ZWG 312.3"
{
        Type  "Sb"
        RA            9.3531
        Dec          64.2519
        Distance   7.878e+07  # method: V
        Radius      1.26e+04
        AbsMag        -17.61
        Axis    [ -0.6615   0.7499  -0.0006]
        Angle    110.0441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2814"
}

Galaxy "NGC 2815:ESO 497-32:MCG 4-22-6:UGCA 156"
{
        Type  "SBb"
        RA            9.2719
        Dec         -23.6339
        Distance   1.319e+08  # method: T-F
        Radius     6.715e+04
        AbsMag        -20.23
        Axis    [  0.9283   0.3658  -0.0666]
        Angle    118.8377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2815"
}

Galaxy "NGC 2817:MCG 1-24-6:IRAS 09146-0432"
{
        Type  "SBc"
        RA            9.2861
        Dec          -4.7528
        Distance   1.168e+08  # distance uncertain!
        Radius     3.398e+04
        AbsMag        -19.07
        Axis    [  0.9869  -0.0816  -0.1392]
        Angle    114.2680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2817"
}

Galaxy "NGC 2819:UGC 4924:MCG 3-24-40:ZWG 91.62"
{
        Type  "E0"
        RA            9.3025
        Dec          16.1981
        Distance   2.188e+08  # distance uncertain!
        Radius     4.455e+04
        AbsMag        -20.13
        Axis    [  0.7107  -0.0401  -0.7024]
        Angle     89.6301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2819"
}

Galaxy "NGC 2820:UGC 4961:MCG 11-12-6:ZWG 312.5"
{
        Type  "SBc"
        RA            9.3628
        Dec          64.2586
        Distance    7.62e+07  # method: V
        Radius     4.544e+04
        AbsMag        -18.64
        Axis    [  0.3035   0.4402   0.8451]
        Angle     74.4926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2820"
}

Galaxy "NGC 2821:ESO 497-34:MCG 4-22-7:IRAS 09145-2636"
{
        Type  "Sc"
        RA            9.2797
        Dec         -26.8167
        Distance    1.61e+08  # method: T-F
        Radius     4.685e+04
        AbsMag        -19.57
        Axis    [  0.4201   0.5302  -0.7365]
        Angle     56.8680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2821"
}

Galaxy "NGC 2822:ESO 61-4:IRAS 09132-6926"
{
        Type  "E0"
        RA            9.2303
        Dec         -69.6442
        Distance   7.245e+07  # distance uncertain!
        Radius     3.477e+04
        AbsMag        -20.13
        Axis    [  0.3769  -0.1261  -0.9176]
        Angle    169.5730
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2822"
}

Galaxy "NGC 2823:UGC 4935:MCG 6-21-8:ZWG 181.16"
{
        Type  "SBa"
        RA            9.3214
        Dec          34.0083
        Distance    3.32e+08  # method: V
        Radius     4.346e+04
        AbsMag        -19.54
        Axis    [  0.9476   0.1482   0.2831]
        Angle     72.8337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2823"
}

Galaxy "NGC 2824:UGC 4933:MCG 4-22-31:MK 394"
{
        Type  "S0"
        RA            9.3172
        Dec          26.2703
        Distance   1.369e+08  # method: V
        Radius     1.792e+04
        AbsMag        -18.91
        Axis    [ -0.4225   0.7427  -0.5194]
        Angle     85.4133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2824"
}

Galaxy "NGC 2825:MCG 6-21-10:ZWG 181.17"
{
        Type  "Sa"
        RA            9.3228
        Dec          33.7431
        Distance   3.663e+08  # method: V
        Radius     4.795e+04
        AbsMag        -19.95
        Axis    [  0.4288   0.8974   0.1037]
        Angle     45.7774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2825"
}

Galaxy "NGC 2826:UGC 4939:MCG 6-21-11:ZWG 181.18"
{
        Type  "Sa"
        RA            9.3233
        Dec          33.6236
        Distance   2.945e+08  # method: V
        Radius     6.854e+04
        AbsMag        -20.18
        Axis    [ -0.6067   0.7947   0.0189]
        Angle     64.8652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2826"
}

Galaxy "NGC 2827:IC 2460:MCG 6-21-9:ZWG 181.15"
{
        Type  "Sb"
        RA            9.3217
        Dec          33.8808
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.9056   0.0699   0.4183]
        Angle     97.0969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2827"
}

Galaxy "NGC 2828:ZWG 181.21:NPM 1"
{
        Type  "S0"
        RA            9.3261
        Dec          33.8886
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.8884   0.3662   0.2768]
        Angle     61.2290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2828"
}

Galaxy "NGC 2829:NPM 1"
{
        Type  "S0"
        RA            9.3311
        Dec          33.6494
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.8268  -0.5444  -0.1417]
        Angle     91.4141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2829"
}

Galaxy "NGC 2830:UGC 4941:MCG 6-21-14:ZWG 181.23"
{
        Type  "SBa"
        RA            9.3281
        Dec          33.7381
        Distance   3.432e+08  # method: T-F
        Radius     5.991e+04
        AbsMag        -20.31
        Axis    [ -0.1587   0.9696   0.1862]
        Angle     50.2521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2830"
}

Galaxy "NGC 2831:UGC 4942:MCG 6-21-13:ZWG 181.24"
{
        Type  "E0"
        RA            9.3292
        Dec          33.7447
        Distance   2.426e+08  # method: V
        Radius     1.764e+04
        AbsMag        -19.96
        Axis    [  0.8089  -0.5639  -0.1661]
        Angle     91.7862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2831"
}

Galaxy "NGC 2832:UGC 4942:MCG 6-21-15:ZWG 181.24"
{
        Type  "E2"
        RA            9.3294
        Dec          33.7497
        Distance   3.402e+08  # method: T-F
        Radius     1.485e+05
        AbsMag        -22.29
        Axis    [ -0.0194   0.7200  -0.6937]
        Angle    117.3786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2832"
}

Galaxy "NGC 2833:ZWG 181.27"
{
        Type  "S0"
        RA            9.3325
        Dec          33.9275
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.6697   0.7020  -0.2423]
        Angle     84.6254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2833"
}

Galaxy "NGC 2834:MCG 6-21-21:ZWG 181.29"
{
        Type  "E0"
        RA            9.3339
        Dec          33.7106
        Distance   4.366e+08  # distance uncertain!
        Radius      3.81e+04
        AbsMag        -20.13
        Axis    [  0.7168   0.0536  -0.6952]
        Angle     72.8713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2834"
}

Galaxy "NGC 2835:ESO 564-35:MCG 4-22-8:UGCA 157"
{
        Type  "SBc"
        RA            9.2978
        Dec         -22.3553
        Distance   4.304e+07  # method: T-F
        Radius     4.131e+04
        AbsMag         -19.6
        Axis    [  0.9753   0.1329  -0.1763]
        Angle    122.6635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2835"
}

Galaxy "NGC 2836:ESO 61-3:IRAS 09131-6907"
{
        Type  "Sc"
        RA            9.2292
        Dec         -69.3331
        Distance   7.038e+07  # distance uncertain!
        Radius     2.764e+04
        AbsMag        -19.07
        Axis    [  0.2518  -0.0224  -0.9675]
        Angle    121.7515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2836"
}

Galaxy "NGC 2838:MCG 7-19-61:ZWG 209.55:NPM 1"
{
        Type  "E0"
        RA            9.3453
        Dec          39.3164
        Distance   3.163e+08  # distance uncertain!
        Radius      4.14e+04
        AbsMag        -20.13
        Axis    [  0.7897  -0.5962  -0.1445]
        Angle     87.4450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2838"
}

Galaxy "NGC 2839:MCG 6-21-23:ZWG 181.31"
{
        Type  "S0"
        RA            9.3433
        Dec          33.6511
        Distance   3.707e+08  # method: V
        Radius     4.852e+04
        AbsMag        -20.08
        Axis    [  0.8256  -0.5460  -0.1421]
        Angle     91.4942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2839"
}

Galaxy "NGC 2840:UGC 4960:MCG 6-21-25:ZWG 181.32"
{
        Type  "SBc"
        RA            9.3478
        Dec          35.3683
        Distance   3.493e+08  # method: V
        Radius     5.081e+04
        AbsMag        -20.55
        Axis    [  0.2637   0.7384  -0.6207]
        Angle     63.7390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2840"
}

Galaxy "NGC 2841:UGC 4966:MCG 9-16-5:ZWG 265.6"
{
        Type  "Sb"
        RA            9.3672
        Dec          50.9764
        Distance   8.684e+07  # method: T-F
        Radius     1.023e+05
        AbsMag        -22.02
        Axis    [ -0.4671   0.8834  -0.0373]
        Angle     77.6193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2841"
}

Galaxy "NGC 2842:ESO 91-4:FAIR 282:IRAS 09144-6251"
{
        Type  "SBa"
        RA            9.2600
        Dec         -63.0694
        Distance   1.372e+08  # method: V
        Radius     3.193e+04
        AbsMag        -19.72
        Axis    [  0.1654  -0.0185  -0.9861]
        Angle    121.8102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2842"
}

Galaxy "NGC 2843"
{
        Type  "S0"
        RA            9.3411
        Dec          18.9261
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8894   0.4571  -0.0079]
        Angle     60.6980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2843"
}

Galaxy "NGC 2844:UGC 4971:MCG 7-19-64:ZWG 209.57"
{
        Type  "Sa"
        RA            9.3633
        Dec          40.1519
        Distance   7.724e+07  # method: V
        Radius      1.91e+04
        AbsMag        -18.17
        Axis    [  0.9035   0.0233   0.4280]
        Angle     86.7151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2844"
}

Galaxy "NGC 2845:ESO 314-10:MCG 6-21-2:IRAS 09166-3747"
{
        Type  "Sa"
        RA            9.3100
        Dec         -38.0097
        Distance   9.278e+07  # distance uncertain!
        Radius     3.104e+04
        AbsMag        -19.07
        Axis    [  0.6822   0.2892  -0.6716]
        Angle     92.7451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2845"
}

Galaxy "NGC 2848:MCG 3-24-7:UGCA 160:IRAS 09178-1618"
{
        Type  "SBc"
        RA            9.3358
        Dec         -16.5256
        Distance   1.069e+08  # method: V
        Radius     3.887e+04
        AbsMag        -20.08
        Axis    [  0.9086   0.2441  -0.3389]
        Angle     95.4021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2848"
}

Galaxy "NGC 2850:NPM 1"
{
        Type  "S0"
        RA            9.3489
        Dec          -4.9394
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.9559   0.0710  -0.2850]
        Angle     97.2274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2850"
}

Galaxy "NGC 2851:MCG 3-24-8"
{
        Type  "S0"
        RA            9.3417
        Dec         -16.4953
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.9595   0.2810  -0.0192]
        Angle    119.0459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2851"
}

Galaxy "NGC 2852:UGC 4986:MCG 7-19-65:ZWG 209.59"
{
        Type  "SBa"
        RA            9.3872
        Dec          40.1644
        Distance   9.296e+07  # method: V
        Radius     1.352e+04
        AbsMag        -18.07
        Axis    [ -0.4884   0.8072  -0.3316]
        Angle     89.5815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2852"
}

Galaxy "NGC 2853:UGC 4987:MCG 7-19-66:ZWG 209.60"
{
        Type  "SBa"
        RA            9.3881
        Dec          40.2003
        Distance   9.028e+07  # method: V
        Radius     1.313e+04
        AbsMag        -17.91
        Axis    [  0.9418   0.0400   0.3337]
        Angle     73.4644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2853"
}

Galaxy "NGC 2854:UGC 4995:MCG 8-17-92:ZWG 238.46"
{
        Type  "SBb"
        RA            9.4006
        Dec          49.2039
        Distance   1.322e+08  # method: V
        Radius     3.077e+04
        AbsMag        -19.24
        Axis    [  0.6979   0.3759   0.6096]
        Angle     62.6705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2854"
}

Galaxy "NGC 2855:MCG 2-24-15:UGCA 161:IRAS 09190-1141"
{
        Type  "Sa"
        RA            9.3575
        Dec         -11.9103
        Distance   1.007e+08  # method: V
        Radius     3.663e+04
        AbsMag        -19.85
        Axis    [  0.0142   0.3543  -0.9350]
        Angle     93.6186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2855"
}

Galaxy "NGC 2856:UGC 4997:MCG 8-17-93:ZWG 238.47"
{
        Type  "Sc"
        RA            9.4044
        Dec          49.2492
        Distance   1.276e+08  # method: V
        Radius     2.041e+04
        AbsMag        -18.96
        Axis    [ -0.3555   0.9347   0.0041]
        Angle     67.0245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2856"
}

Galaxy "NGC 2857:UGC 5000:MCG 8-17-95:ZWG 238.49"
{
        Type  "Sc"
        RA            9.4103
        Dec          49.3572
        Distance   2.294e+08  # method: V
        Radius     7.342e+04
        AbsMag        -21.04
        Axis    [ -0.0445   0.8894  -0.4550]
        Angle     79.8936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2857"
}

Galaxy "NGC 2858:UGC 4989:MCG 1-24-17:ZWG 34.40"
{
        Type  "Sa"
        RA            9.3817
        Dec           3.1575
        Distance   1.065e+08  # distance uncertain!
        Radius     2.634e+04
        AbsMag        -19.07
        Axis    [  0.0782   0.6820  -0.7271]
        Angle     55.0637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2858"
}

Galaxy "NGC 2859:UGC 5001:MCG 6-21-30:ZWG 181.40"
{
        Type  "SBa"
        RA            9.4050
        Dec          34.5133
        Distance   8.702e+07  # method: V
        Radius     5.822e+04
        AbsMag        -20.33
        Axis    [  0.6309   0.5490  -0.5483]
        Angle     54.0741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2859"
}

Galaxy "NGC 2860:UGC 5007:MCG 7-20-3:ZWG 209.65"
{
        Type  "SBa"
        RA            9.4147
        Dec          41.0600
        Distance   2.021e+08  # method: V
        Radius     4.409e+04
        AbsMag        -19.36
        Axis    [ -0.0256   0.9892   0.1442]
        Angle     49.5352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2860"
}

Galaxy "NGC 2861:UGC 4999:MCG 0-24-10:ZWG 6.38"
{
        Type  "SBc"
        RA            9.3933
        Dec           2.1361
        Distance   2.468e+08  # method: V
        Radius     5.383e+04
        AbsMag        -20.59
        Axis    [  0.9602  -0.2115  -0.1826]
        Angle    110.1376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2861"
}

Galaxy "NGC 2862:UGC 5010:MCG 5-22-45:ZWG 151.76"
{
        Type  "SBc"
        RA            9.4153
        Dec          26.7753
        Distance   1.976e+08  # method: V
        Radius     7.185e+04
        AbsMag        -20.11
        Axis    [ -0.2043   0.9630   0.1760]
        Angle     46.9349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2862"
}

Galaxy "NGC 2863:NGC 2869:MCG 2-24-18:IRAS 09211-1012"
{
        Type  "Irr"
        RA            9.3933
        Dec         -10.4331
        Distance   1.738e+08  # distance uncertain!
        Radius     2.528e+04
        AbsMag        -20.13
        Axis    [  0.1541   0.3281  -0.9320]
        Angle     91.7366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2863"
}

Galaxy "NGC 2864:MCG 1-24-20:ZWG 34.44:IRAS 09216+0609"
{
        Type  "S0"
        RA            9.4042
        Dec           5.9400
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.9994   0.0130  -0.0331]
        Angle    100.4600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2864"
}

Galaxy "NGC 2865:ESO 498-1:MCG 4-22-11:AM 0921-225"
{
        Type  "E3"
        RA            9.3917
        Dec         -23.1614
        Distance   1.234e+08  # method: S
        Radius     4.488e+04
        AbsMag        -20.39
        Axis    [ -0.1796   0.3016  -0.9364]
        Angle    138.6654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2865"
}

Galaxy "NGC 2868:NPM 1"
{
        Type  "S0"
        RA            9.3908
        Dec         -10.4289
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.7467   0.1685  -0.6435]
        Angle     87.9192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2868"
}

Galaxy "NGC 2870:UGC 5034:MCG 10-14-13:ZWG 289.8"
{
        Type  "SBc"
        RA            9.4647
        Dec          57.3758
        Distance    1.52e+08  # method: V
        Radius     5.526e+04
        AbsMag        -19.54
        Axis    [ -0.3622   0.8387   0.4068]
        Angle     69.0662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2870"
}

Galaxy "NGC 2872:UGC 5018:MCG 2-24-8:ZWG 62.33"
{
        Type  "E2"
        RA            9.4283
        Dec          11.4328
        Distance   2.043e+08  # method: T-F
        Radius     6.239e+04
        AbsMag        -21.08
        Axis    [ -0.1607   0.5920  -0.7898]
        Angle    129.3302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2872"
}

Galaxy "NGC 2873:MCG 2-24-9:NPM 1"
{
        Type  "Sb"
        RA            9.4300
        Dec          11.4547
        Distance   3.694e+08  # distance uncertain!
        Radius      3.76e+04
        AbsMag        -19.07
        Axis    [ -0.0967   0.9316  -0.3504]
        Angle     42.9588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2873"
}

Galaxy "NGC 2874:UGC 5021:MCG 2-24-10:KCPG 202B"
{
        Type  "SBc"
        RA            9.4297
        Dec          11.4258
        Distance   1.847e+08  # method: V
        Radius      5.91e+04
        AbsMag        -20.36
        Axis    [  0.9014   0.4129   0.1305]
        Angle     74.0574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2874"
}

Galaxy "NGC 2876:MCG 1-24-16"
{
        Type  "S0"
        RA            9.4203
        Dec          -6.7167
        Distance   1.404e+08  # distance uncertain!
        Radius     3.472e+04
        AbsMag        -19.07
        Axis    [  0.4725   0.4416  -0.7627]
        Angle     65.7310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2876"
}

Galaxy "NGC 2877:MCG 0-24-15:ZWG 6.43:ARAK 201"
{
        Type  "Irr"
        RA            9.4297
        Dec           2.2286
        Distance   3.295e+08  # method: V
        Radius     3.355e+04
        AbsMag        -19.72
        Axis    [ -0.1947   0.5518  -0.8109]
        Angle     75.5325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2877"
}

Galaxy "NGC 2878:UGC 5022:MCG 0-24-14:ZWG 6.42"
{
        Type  "Sa"
        RA            9.4297
        Dec           2.0900
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [ -0.6999   0.4280  -0.5718]
        Angle     79.5051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2878"
}

Galaxy "NGC 2880:UGC 5051:MCG 10-14-15:ZWG 312.11"
{
        Type  "S0"
        RA            9.4928
        Dec          62.4911
        Distance   7.136e+07  # method: S
        Radius     2.076e+04
        AbsMag         -19.2
        Axis    [ -0.3088   0.9509   0.0187]
        Angle     76.8646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2880"
}

Galaxy "NGC 2881-1:MCG 2-24-21:VV 293:ARP 275"
{
        Type  "S0"
        RA            9.4317
        Dec         -11.9956
        Distance   2.056e+08  # method: V
        Radius     3.289e+04
        AbsMag         -19.9
        Axis    [ -0.0505   0.3705  -0.9275]
        Angle     87.3405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2881-1"
}

Galaxy "NGC 2881-2:MCG 2-24-21:VV 293:ARP 275"
{
        Type  "S0"
        RA            9.4314
        Dec         -11.9925
        Distance   1.404e+08  # distance uncertain!
        Radius     1.634e+04
        AbsMag        -19.07
        Axis    [  0.9795  -0.1111  -0.1679]
        Angle    123.4764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2881-2"
}

Galaxy "NGC 2882:UGC 5030:MCG 1-24-21:ZWG 34.46"
{
        Type  "S0"
        RA            9.4431
        Dec           7.9542
        Distance   1.113e+08  # method: V
        Radius     2.429e+04
        AbsMag        -19.17
        Axis    [  0.7024   0.5799  -0.4129]
        Angle     54.3599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2882"
}

Galaxy "NGC 2883:ESO 372-24:MCG 6-21-5:VV 768"
{
        Type  "Irr"
        RA            9.4217
        Dec         -34.1022
        Distance   6.637e+07  # method: V
        Radius     2.124e+04
        AbsMag        -16.54
        Axis    [ -0.5961   0.0121  -0.8029]
        Angle     81.1575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2883"
}

Galaxy "NGC 2884:MCG 2-24-22:IRAS 09239-1120"
{
        Type  "Sa"
        RA            9.4400
        Dec         -11.5556
        Distance   2.588e+08  # method: V
        Radius     7.903e+04
        AbsMag           -21
        Axis    [ -0.6206   0.3068  -0.7216]
        Angle     83.3481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2884"
}

Galaxy "NGC 2885:IC 538:UGC 5037:MCG 4-22-58"
{
        Type  "Sa"
        RA            9.4550
        Dec          23.0200
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.8212   0.5554  -0.1312]
        Angle     51.5462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2885"
}

Galaxy "NGC 2887:ESO 91-9:AM 0922-633"
{
        Type  "S0"
        RA            9.3900
        Dec         -63.8122
        Distance   1.269e+08  # method: T-F
        Radius     3.876e+04
        AbsMag        -20.25
        Axis    [  0.5266   0.0620  -0.8479]
        Angle    126.5700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2887"
}

Galaxy "NGC 2888:ESO 434-2:MCG 5-23-1"
{
        Type  "E0"
        RA            9.4386
        Dec         -28.0361
        Distance   1.133e+08  # method: V
        Radius     2.471e+04
        AbsMag         -19.1
        Axis    [ -0.1617   0.2508  -0.9544]
        Angle    139.4764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2888"
}

Galaxy "NGC 2889:MCG 2-24-26:IRAS 09247-1125"
{
        Type  "SBc"
        RA            9.4533
        Dec         -11.6433
        Distance   1.656e+08  # method: V
        Radius      5.54e+04
        AbsMag        -21.13
        Axis    [  0.9815  -0.0511  -0.1845]
        Angle    118.4384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2889"
}

Galaxy "NGC 2890:MCG 2-24-24"
{
        Type  "S0"
        RA            9.4414
        Dec         -14.5289
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.7632   0.3011  -0.5718]
        Angle     78.9644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2890"
}

Galaxy "NGC 2891:ESO 498-8:MCG 4-23-3"
{
        Type  "S0"
        RA            9.4489
        Dec         -24.7828
        Distance   1.065e+08  # distance uncertain!
        Radius     2.324e+04
        AbsMag        -19.07
        Axis    [ -0.1085   0.2430  -0.9639]
        Angle    110.7227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2891"
}

Galaxy "NGC 2892:UGC 5073:MCG 11-12-15:ZWG 312.15"
{
        Type  "E0"
        RA            9.5478
        Dec          67.6175
        Distance   2.291e+08  # distance uncertain!
        Radius     4.665e+04
        AbsMag        -20.13
        Axis    [  0.6136  -0.7896   0.0073]
        Angle     69.1153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2892"
}

Galaxy "NGC 2893:UGC 5060:MCG 5-23-5:MK 401"
{
        Type  "SBa"
        RA            9.5044
        Dec          29.5403
        Distance    8.87e+07  # method: V
        Radius     1.419e+04
        AbsMag        -18.37
        Axis    [  0.7032   0.3915  -0.5935]
        Angle     57.3623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2893"
}

Galaxy "NGC 2894:UGC 5056:MCG 1-24-24:ZWG 34.51"
{
        Type  "Sa"
        RA            9.4917
        Dec           7.7183
        Distance   1.113e+08  # method: V
        Radius     3.076e+04
        AbsMag        -19.36
        Axis    [  0.9829   0.1844   0.0019]
        Angle     87.3800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2894"
}

Galaxy "NGC 2895:MCG 10-14-18:ZWG 289.9"
{
        Type  "SBc"
        RA            9.5400
        Dec          57.4831
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.9665   0.2396   0.0921]
        Angle     41.4320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2895"
}

Galaxy "NGC 2896:MCG 4-23-7:ZWG 122.9:NPM 1"
{
        Type  "S0"
        RA            9.5044
        Dec          23.6636
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.8366  -0.5142  -0.1889]
        Angle    100.5262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2896"
}

Galaxy "NGC 2897:NPM 1"
{
        Type  "S0"
        RA            9.4958
        Dec           2.2075
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.5686   0.4817  -0.6668]
        Angle     84.6348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2897"
}

Galaxy "NGC 2898:MCG 0-24-18:ZWG 6.48:NPM 1"
{
        Type  "Sa"
        RA            9.4961
        Dec           2.0650
        Distance   2.324e+08  # method: T-F
        Radius     3.381e+04
        AbsMag        -19.66
        Axis    [  0.0473   0.5044  -0.8622]
        Angle     74.4244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2898"
}

Galaxy "NGC 2900:UGC 5065:MCG 1-24-26:ZWG 34.55"
{
        Type  "SBc"
        RA            9.5042
        Dec           4.1436
        Distance   2.565e+08  # method: V
        Radius      4.85e+04
        AbsMag        -20.28
        Axis    [ -0.2210   0.5318  -0.8175]
        Angle     89.2064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2900"
}

Galaxy "NGC 2902:MCG 2-24-30"
{
        Type  "S0"
        RA            9.5147
        Dec         -14.7356
        Distance   1.046e+08  # method: V
        Radius     2.435e+04
        AbsMag        -19.33
        Axis    [  0.9764  -0.0297  -0.2139]
        Angle    119.1697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2902"
}

Galaxy "NGC 2903:UGC 5079:MCG 4-23-9:KARA 347"
{
        Type  "SBc"
        RA            9.5358
        Dec          21.4992
        Distance   3.429e+07  # method: T-F
        Radius     6.284e+04
        AbsMag         -20.5
        Axis    [  0.9711   0.1032   0.2153]
        Angle     89.5561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2903"
}

Galaxy "NGC 2904:ESO 434-6:MCG 5-23-3:AM 0928-300"
{
        Type  "S0"
        RA            9.5044
        Dec         -30.3850
        Distance   7.681e+07  # method: S
        Radius     1.341e+04
        AbsMag        -18.36
        Axis    [  0.5547   0.2222  -0.8018]
        Angle     87.3852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2904"
}

Galaxy "NGC 2906:UGC 5081:MCG 2-25-1:ZWG 63.1"
{
        Type  "Sc"
        RA            9.5350
        Dec           8.4422
        Distance   1.111e+08  # method: V
        Radius     2.262e+04
        AbsMag        -19.46
        Axis    [  0.7625   0.4427  -0.4718]
        Angle     58.6437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2906"
}

Galaxy "NGC 2907:MCG 3-25-2:IRAS 09292-1630"
{
        Type  "Sa"
        RA            9.5267
        Dec         -16.7336
        Distance    1.09e+08  # method: V
        Radius     3.171e+04
        AbsMag        -19.92
        Axis    [  0.1728   0.3809  -0.9083]
        Angle     67.6562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2907"
}

Galaxy "NGC 2908:UGC 5152:MCG 13-7-34:ZWG 350.29"
{
        Type  "S0"
        RA            9.7253
        Dec          79.7014
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [  0.5001  -0.8544   0.1411]
        Angle     64.9266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2908"
}

Galaxy "NGC 2911:UGC 5092:MCG 2-25-3:ZWG 63.7"
{
        Type  "S0"
        RA            9.5628
        Dec          10.1528
        Distance   1.582e+08  # method: V
        Radius     9.206e+04
        AbsMag        -20.93
        Axis    [ -0.1712   0.6101  -0.7736]
        Angle     75.3706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2911"
}

Galaxy "NGC 2913:UGC 5095:MCG 2-25-5:ZWG 63.9"
{
        Type  "Sc"
        RA            9.5672
        Dec           9.4783
        Distance   1.527e+08  # method: V
        Radius     2.442e+04
        AbsMag        -19.25
        Axis    [ -0.2581   0.6483  -0.7163]
        Angle     66.6750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2913"
}

Galaxy "NGC 2914:UGC 5096:MCG 2-25-6:ZWG 63.10"
{
        Type  "SBb"
        RA            9.5672
        Dec          10.1092
        Distance   1.576e+08  # method: V
        Radius     2.064e+04
        AbsMag        -19.32
        Axis    [  1.0000  -0.0045   0.0087]
        Angle     97.8219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2914"
}

Galaxy "NGC 2915:ESO 37-3:AM 0926-762:IRAS 09265-7624"
{
        Type  "SBa"
        RA            9.4369
        Dec         -76.6267
        Distance   2.578e+07  # method: V
        Radius          7123
        AbsMag        -16.29
        Axis    [  0.1064  -0.1289  -0.9859]
        Angle    103.3741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2915"
}

Galaxy "NGC 2916:UGC 5103:MCG 4-23-11:ZWG 122.21"
{
        Type  "Sb"
        RA            9.5825
        Dec          21.7044
        Distance   1.819e+08  # method: V
        Radius     6.613e+04
        AbsMag        -21.03
        Axis    [  0.9977  -0.0190   0.0650]
        Angle     84.8090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2916"
}

Galaxy "NGC 2917:UGC 5098:MCG 0-25-2:ZWG 7.3"
{
        Type  "Sa"
        RA            9.5742
        Dec          -2.5039
        Distance   1.812e+08  # method: V
        Radius     3.425e+04
        AbsMag        -19.22
        Axis    [ -0.7221   0.3796  -0.5783]
        Angle     70.7063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2917"
}

Galaxy "NGC 2918:UGC 5112:MCG 5-23-19:ZWG 152.32"
{
        Type  "E0"
        RA            9.5956
        Dec          31.7053
        Distance   3.191e+08  # method: V
        Radius     6.498e+04
        AbsMag        -21.45
        Axis    [  0.6995  -0.0046  -0.7146]
        Angle     73.5646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2918"
}

Galaxy "NGC 2919:UGC 5102:MCG 2-25-7:ZWG 63.13"
{
        Type  "SBc"
        RA            9.5797
        Dec          10.2839
        Distance    1.41e+08  # method: T-F
        Radius     3.281e+04
        AbsMag        -19.48
        Axis    [ -0.6728   0.5796  -0.4597]
        Angle     65.3852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2919"
}

Galaxy "NGC 2930:MCG 4-23-18:ZWG 122.35:WAS 1"
{
        Type  "S0"
        RA            9.6256
        Dec          23.2036
        Distance   3.118e+08  # method: V
        Radius     3.175e+04
        AbsMag         -19.8
        Axis    [ -0.2737   0.8227  -0.4983]
        Angle     58.8568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2930"
}

Galaxy "NGC 2931:MCG 4-23-19:ZWG 122.36"
{
        Type  "S0"
        RA            9.6269
        Dec          23.2406
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.8551   0.3713  -0.3619]
        Angle     54.0610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2931"
}

Galaxy "NGC 2933:UGC 5132:MCG 3-25-8:ZWG 92.15"
{
        Type  "S0"
        RA            9.6319
        Dec          17.0147
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.9582   0.2277   0.1735]
        Angle     81.1663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2933"
}

Galaxy "NGC 2934:NPM 1"
{
        Type  "E0"
        RA            9.6319
        Dec          17.0550
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.8228  -0.5161  -0.2379]
        Angle    107.3016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2934"
}

Galaxy "NGC 2935:ESO 565-23:MCG 3-25-11:UGCA 169"
{
        Type  "SBb"
        RA            9.6122
        Dec         -21.1278
        Distance   1.008e+08  # method: T-F
        Radius     5.424e+04
        AbsMag        -20.25
        Axis    [  0.9839   0.0107  -0.1785]
        Angle    128.0291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2935"
}

Galaxy "NGC 2936:UGC 5130:MCG 1-25-5:ZWG 35.15"
{
        Type  "E0"
        RA            9.6289
        Dec           2.7606
        Distance   3.312e+08  # method: V
        Radius     6.263e+04
        AbsMag        -21.13
        Axis    [  0.7805  -0.2726  -0.5626]
        Angle    106.3891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2936"
}

Galaxy "NGC 2937:UGC 5131:MCG 1-25-6:ZWG 35.15"
{
        Type  "E0"
        RA            9.6292
        Dec           2.7481
        Distance   3.244e+08  # method: V
        Radius     3.775e+04
        AbsMag        -20.39
        Axis    [  0.8479  -0.4501  -0.2802]
        Angle    119.2498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2937"
}

Galaxy "NGC 2938:UGC 5115:MCG 13-7-32:ZWG 350.27"
{
        Type  "SBc"
        RA            9.6400
        Dec          76.3192
        Distance   1.054e+08  # method: V
        Radius     2.759e+04
        AbsMag        -18.35
        Axis    [ -0.0449   0.8494   0.5258]
        Angle     62.2734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2938"
}

Galaxy "NGC 2939:UGC 5134:MCG 2-25-11:ZWG 63.22"
{
        Type  "Sc"
        RA            9.6353
        Dec           9.5236
        Distance   1.821e+08  # method: T-F
        Radius     6.357e+04
        AbsMag        -20.33
        Axis    [ -0.7152   0.5710  -0.4031]
        Angle     60.7280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2939"
}

Galaxy "NGC 2940:MCG 2-25-12:ZWG 63.23:NPM 1"
{
        Type  "S0"
        RA            9.6347
        Dec           9.6172
        Distance   4.048e+08  # method: V
        Radius     5.299e+04
        AbsMag        -20.87
        Axis    [  0.5529   0.4366  -0.7097]
        Angle     60.6274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2940"
}

Galaxy "NGC 2941:MCG 3-25-9:ZWG 92.17"
{
        Type  "S0"
        RA            9.6400
        Dec          17.0444
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [ -0.5039   0.6481  -0.5710]
        Angle     80.8393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2941"
}

Galaxy "NGC 2942:UGC 5140:MCG 6-21-65:ZWG 181.76"
{
        Type  "Sc"
        RA            9.6522
        Dec          34.0061
        Distance   2.118e+08  # method: V
        Radius     5.852e+04
        AbsMag        -20.86
        Axis    [ -0.3792   0.7824  -0.4940]
        Angle     91.3138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2942"
}

Galaxy "NGC 2943:UGC 5136:MCG 3-25-11:ZWG 92.19"
{
        Type  "E0"
        RA            9.6422
        Dec          17.0311
        Distance   3.931e+08  # method: V
        Radius     1.258e+05
        AbsMag         -21.7
        Axis    [  0.1358   0.4633  -0.8757]
        Angle    102.2066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2943"
}

Galaxy "NGC 2944-1:UGC 5144:MCG 6-21-67:ZWG 181.78"
{
        Type  "Sc"
        RA            9.6550
        Dec          32.3106
        Distance   3.189e+08  # method: V
        Radius     4.638e+04
        AbsMag        -20.15
        Axis    [  0.3277   0.9372   0.1196]
        Angle     41.5681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2944-1"
}

Galaxy "NGC 2944-2:UGC 5144:MCG 6-21-67:ZWG 181.78"
{
        Type  "SBc"
        RA            9.6544
        Dec          32.3106
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [ -0.2224   0.8676  -0.4448]
        Angle     62.5062
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2944-2"
}

Galaxy "NGC 2945:ESO 565-28:MCG 4-23-10:IRAS 09354-2148"
{
        Type  "S0"
        RA            9.6281
        Dec         -22.0344
        Distance    2.24e+08  # method: V
        Radius     5.213e+04
        AbsMag        -20.98
        Axis    [ -0.4400   0.2508  -0.8623]
        Angle     97.1173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2945"
}

Galaxy "NGC 2946:UGC 5143:MCG 3-25-13:ZWG 92.20"
{
        Type  "SBa"
        RA            9.6503
        Dec          17.0256
        Distance   4.192e+08  # method: V
        Radius     7.316e+04
        AbsMag        -20.74
        Axis    [  0.9534   0.1668   0.2513]
        Angle     96.9978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2946"
}

Galaxy "NGC 2947:IC 547:IC 2494:MCG 2-25-4"
{
        Type  "SBc"
        RA            9.6014
        Dec         -12.4367
        Distance   1.422e+08  # method: V
        Radius     3.102e+04
        AbsMag           -20
        Axis    [  0.9029  -0.1175  -0.4135]
        Angle    112.2902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2947"
}

Galaxy "NGC 2948:UGC 5141:MCG 1-25-7:ZWG 35.20"
{
        Type  "SBc"
        RA            9.6497
        Dec           6.9558
        Distance   2.401e+08  # method: V
        Radius      4.89e+04
        AbsMag        -20.53
        Axis    [  0.9998  -0.0088   0.0155]
        Angle    103.7239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2948"
}

Galaxy "NGC 2949-1:ZWG 92.25"
{
        Type  "S0"
        RA            9.6653
        Dec          16.7844
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.7903   0.5811  -0.1944]
        Angle     49.1971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2949-1"
}

Galaxy "NGC 2949-2:ZWG 92.25"
{
        Type  "S0"
        RA            9.6658
        Dec          16.7869
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.8375  -0.4991  -0.2224]
        Angle    107.0202
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2949-2"
}

Galaxy "NGC 2950:UGC 5176:MCG 10-14-32:ZWG 289.16"
{
        Type  "S0"
        RA            9.7094
        Dec          58.8514
        Distance   4.869e+07  # method: S
        Radius     1.912e+04
        AbsMag        -18.97
        Axis    [ -0.3025   0.9491  -0.0876]
        Angle     76.4619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2950"
}

Galaxy "NGC 2951-1:MCG 0-25-6:ZWG 7.17"
{
        Type  "E0"
        RA            9.6608
        Dec          -0.2356
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [  0.4387   0.0901  -0.8941]
        Angle    104.0352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2951-1"
}

Galaxy "NGC 2951-2:MCG 0-25-6:ZWG 7.17:NPM 1"
{
        Type  "E0"
        RA            9.6611
        Dec          -0.2344
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.8496  -0.4403  -0.2903]
        Angle    121.9226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2951-2"
}

Galaxy "NGC 2952"
{
        Type  "Irr"
        RA            9.6269
        Dec         -10.1844
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [  0.9847   0.1635  -0.0602]
        Angle    111.6046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2952"
}

Galaxy "NGC 2954:UGC 5155:MCG 3-25-19:ZWG 92.26"
{
        Type  "E0"
        RA            9.6733
        Dec          14.9225
        Distance    1.87e+08  # method: V
        Radius     3.263e+04
        AbsMag        -20.49
        Axis    [ -0.0951   0.5786  -0.8100]
        Angle    118.6050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2954"
}

Galaxy "NGC 2955:UGC 5166:MCG 6-21-73:ZWG 181.82"
{
        Type  "Sb"
        RA            9.6878
        Dec          35.8828
        Distance   3.308e+08  # method: T-F
        Radius     7.217e+04
        AbsMag        -21.43
        Axis    [ -0.5807   0.7711  -0.2611]
        Angle     78.8350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2955"
}

Galaxy "NGC 2956:ESO 565-34:IRAS 09369-1852"
{
        Type  "Sb"
        RA            9.6544
        Dec         -19.1011
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.8485   0.4041  -0.3417]
        Angle     78.0651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2956"
}

Galaxy "NGC 2957A:MCG 12-10-1:MK 121:NPM 1"
{
        Type  "E1"
        RA            9.7875
        Dec          72.9867
        Distance   3.064e+08  # method: V
        Radius     1.337e+04
        AbsMag        -19.06
        Axis    [  0.6201  -0.7844  -0.0107]
        Angle     58.9705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2957A"
}

Galaxy "NGC 2957B:MCG 12-10-2:ZWG 332.64:ZWG 333.2"
{
        Type  "E0"
        RA            9.7881
        Dec          72.9839
        Distance   3.132e+08  # method: V
        Radius     3.189e+04
        AbsMag        -19.21
        Axis    [  0.8653  -0.4356  -0.2480]
        Angle     39.6487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2957B"
}

Galaxy "NGC 2958:UGC 5160:MCG 2-25-15:ZWG 63.33"
{
        Type  "Sc"
        RA            9.6781
        Dec          11.8886
        Distance   3.159e+08  # method: V
        Radius     4.595e+04
        AbsMag        -21.03
        Axis    [  0.9881  -0.1405  -0.0629]
        Angle     98.6734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2958"
}

Galaxy "NGC 2959:UGC 5202:MCG 12-9-62:ZWG 332.61"
{
        Type  "SBb"
        RA            9.7522
        Dec          68.5950
        Distance   2.047e+08  # method: V
        Radius      3.87e+04
        AbsMag        -20.29
        Axis    [  0.6010  -0.7976   0.0512]
        Angle     70.9001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2959"
}

Galaxy "NGC 2960:UGC 5159:MCG 1-25-9:MK 1419"
{
        Type  "Sa"
        RA            9.6767
        Dec           3.5772
        Distance   2.377e+08  # method: V
        Radius     4.841e+04
        AbsMag        -20.91
        Axis    [  0.9558   0.1023  -0.2757]
        Angle     81.9810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2960"
}

Galaxy "NGC 2961:NGC 2959A:MCG 12-9-63:ZWG 332.63"
{
        Type  "Sb"
        RA            9.7561
        Dec          68.6092
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [ -0.4501   0.7964   0.4040]
        Angle     81.9330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2961"
}

Galaxy "NGC 2962:UGC 5167:MCG 1-25-11:ZWG 35.28"
{
        Type  "S0"
        RA            9.6817
        Dec           5.1658
        Distance   1.037e+08  # method: V
        Radius     3.921e+04
        AbsMag        -19.61
        Axis    [  0.9923  -0.1139  -0.0493]
        Angle    108.1989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2962"
}

Galaxy "NGC 2963:UGC 5222:MCG 12-10-3:MK 122"
{
        Type  "SBb"
        RA            9.7969
        Dec          72.9644
        Distance    2.99e+08  # method: V
        Radius     5.218e+04
        AbsMag        -20.51
        Axis    [ -0.4612   0.8837   0.0799]
        Angle     99.0812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2963"
}

Galaxy "NGC 2964:UGC 5183:MCG 5-23-27:ZWG 152.56"
{
        Type  "SBc"
        RA            9.7150
        Dec          31.8469
        Distance   7.819e+07  # method: T-F
        Radius     3.412e+04
        AbsMag         -19.9
        Axis    [  0.3908   0.9024  -0.1816]
        Angle     41.2113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2964"
}

Galaxy "NGC 2965:UGC 5191:MCG 6-22-3:ZWG 181.86"
{
        Type  "S0"
        RA            9.7219
        Dec          36.2483
        Distance    3.16e+08  # method: V
        Radius     5.516e+04
        AbsMag        -20.43
        Axis    [  0.9319   0.3443  -0.1142]
        Angle     47.8619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2965"
}

Galaxy "NGC 2966:UGC 5181:MCG 1-25-13:MK 708"
{
        Type  "SBc"
        RA            9.7031
        Dec           4.6736
        Distance   1.071e+08  # method: V
        Radius     3.427e+04
        AbsMag        -18.78
        Axis    [  0.8085   0.5283  -0.2593]
        Angle     54.4114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2966"
}

Galaxy "NGC 2967:UGC 5180:MCG 0-25-7:ZWG 7.20"
{
        Type  "Sc"
        RA            9.7008
        Dec           0.3361
        Distance   1.007e+08  # method: V
        Radius     4.392e+04
        AbsMag        -20.15
        Axis    [  0.7232   0.0558  -0.6884]
        Angle     85.1302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2967"
}

Galaxy "NGC 2968:UGC 5190:MCG 5-23-29:ZWG 152.58"
{
        Type  "Sa"
        RA            9.7197
        Dec          31.9286
        Distance   7.733e+07  # method: V
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.9961   0.0718  -0.0503]
        Angle     60.6980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2968"
}

Galaxy "NGC 2969:MCG 1-25-21:MK 1235:IRAS 09394-0822"
{
        Type  "Sc"
        RA            9.6983
        Dec          -8.6033
        Distance   2.396e+08  # method: V
        Radius     4.879e+04
        AbsMag        -20.53
        Axis    [ -0.1763   0.3850  -0.9059]
        Angle     90.4071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2969"
}

Galaxy "NGC 2970:MCG 5-23-30:MK 405:ZWG 152.59"
{
        Type  "E1"
        RA            9.7253
        Dec          31.9775
        Distance   8.711e+07  # method: V
        Radius          5068
        AbsMag        -17.43
        Axis    [  0.7500  -0.1577  -0.6424]
        Angle     73.8181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2970"
}

Galaxy "NGC 2971:UGC 5197:MCG 6-22-5:ZWG 181.87"
{
        Type  "SBb"
        RA            9.7294
        Dec          36.1797
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.1845   0.8770  -0.4436]
        Angle     63.9101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2971"
}

Galaxy "NGC 2974:MCG 0-25-8:UGCA 172:ZWG 7.22"
{
        Type  "E4"
        RA            9.7092
        Dec          -3.6992
        Distance   7.006e+07  # method: S
        Radius     3.464e+04
        AbsMag        -19.76
        Axis    [  0.7475  -0.2433  -0.6181]
        Angle    111.3445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2974"
}

Galaxy "NGC 2975:NPM 1"
{
        Type  "S0"
        RA            9.6878
        Dec         -16.6739
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.9696  -0.1202  -0.2133]
        Angle    127.1449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2975"
}

Galaxy "NGC 2976:UGC 5221:MCG 11-12-25:ZWG 312.23"
{
        Type  "Sc"
        RA            9.7872
        Dec          67.9175
        Distance   4.213e+06  # method: V
        Radius          3615
        AbsMag        -14.75
        Axis    [ -0.3934   0.8964   0.2043]
        Angle     79.8987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2976"
}

Galaxy "NGC 2977:UGC 5175:MCG 13-7-35:ZWG 350.30"
{
        Type  "Sb"
        RA            9.7294
        Dec          74.8606
        Distance   1.414e+08  # method: V
        Radius     3.703e+04
        AbsMag        -19.88
        Axis    [ -0.3958   0.8826   0.2536]
        Angle     86.9085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2977"
}

Galaxy "NGC 2978:MCG 1-25-29:IRAS 09408-0931"
{
        Type  "Sc"
        RA            9.7211
        Dec          -9.7461
        Distance   9.658e+07  # method: V
        Radius     1.545e+04
        AbsMag        -18.76
        Axis    [  0.5544   0.2171  -0.8034]
        Angle     78.8018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2978"
}

Galaxy "NGC 2979:NGC 3050:MCG 2-25-12:IRAS 09407-1009"
{
        Type  "Sa"
        RA            9.7189
        Dec         -10.3831
        Distance   1.115e+08  # distance uncertain!
        Radius     2.433e+04
        AbsMag        -19.07
        Axis    [  0.9531   0.1054  -0.2836]
        Angle     97.5264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2979"
}

Galaxy "NGC 2980:MCG 1-25-28:IRAS 09407-0923"
{
        Type  "SBc"
        RA            9.7197
        Dec          -9.6125
        Distance   2.697e+08  # method: T-F
        Radius     6.276e+04
        AbsMag        -20.89
        Axis    [ -0.5684   0.3490  -0.7451]
        Angle     75.1753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2980"
}

Galaxy "NGC 2981:UGC 5208:MCG 5-23-32:ZWG 152.62"
{
        Type  "SBc"
        RA            9.7489
        Dec          31.0981
        Distance   4.833e+08  # method: V
        Radius     8.435e+04
        AbsMag        -21.05
        Axis    [  0.7807   0.4206  -0.4622]
        Angle     49.3619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2981"
}

Galaxy "NGC 2983:ESO 566-3:MCG 3-25-17:UGCA 176"
{
        Type  "SBa"
        RA            9.7281
        Dec         -20.4775
        Distance   1.058e+08  # method: V
        Radius     3.848e+04
        AbsMag        -19.75
        Axis    [  0.4596   0.3218  -0.8278]
        Angle     67.5947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2983"
}

Galaxy "NGC 2984:IC 556:UGC 5200:MCG 2-25-25"
{
        Type  "S0"
        RA            9.7278
        Dec          11.0614
        Distance   2.951e+08  # method: V
        Radius     3.005e+04
        AbsMag        -20.38
        Axis    [  0.8430  -0.4785  -0.2457]
        Angle    112.0088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2984"
}

Galaxy "NGC 2985:UGC 5253:MCG 12-10-6:ZWG 333.4"
{
        Type  "Sb"
        RA            9.8392
        Dec          72.2786
        Distance    6.27e+07  # method: V
        Radius     4.195e+04
        AbsMag        -20.22
        Axis    [  0.7081  -0.4804   0.5175]
        Angle     83.7615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2985"
}

Galaxy "NGC 2986:ESO 566-5:MCG 3-25-19:UGCA 178"
{
        Type  "E2"
        RA            9.7375
        Dec         -21.2781
        Distance   1.349e+08  # method: T-F
        Radius     6.277e+04
        AbsMag        -21.38
        Axis    [  0.2698   0.0722  -0.9602]
        Angle    123.2266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2986"
}

Galaxy "NGC 2987:UGC 5220:MCG 1-25-17:ZWG 35.47"
{
        Type  "Sb"
        RA            9.7614
        Dec           4.9414
        Distance   1.842e+08  # method: V
        Radius     4.019e+04
        AbsMag        -19.86
        Axis    [ -0.5919   0.5251  -0.6114]
        Angle     69.5366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2987"
}

Galaxy "NGC 2988:ZWG 122.78:KCPG 214A"
{
        Type  "Sc"
        RA            9.7797
        Dec          22.0122
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.8830   0.2935   0.3663]
        Angle     83.8069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2988"
}

Galaxy "NGC 2989:ESO 566-9:MCG 3-25-20:IRAS 09430-1808"
{
        Type  "Sc"
        RA            9.7569
        Dec         -18.3744
        Distance   1.915e+08  # method: T-F
        Radius     4.735e+04
        AbsMag        -20.24
        Axis    [  0.9167   0.2216  -0.3326]
        Angle     94.1338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2989"
}

Galaxy "NGC 2990:UGC 5229:MCG 1-25-21:ZWG 35.51"
{
        Type  "Sc"
        RA            9.7714
        Dec           5.7089
        Distance   1.547e+08  # method: V
        Radius     2.474e+04
        AbsMag        -20.08
        Axis    [  0.6642   0.5320  -0.5253]
        Angle     50.8897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2990"
}

Galaxy "NGC 2991:UGC 5233:MCG 4-23-33:ZWG 122.78"
{
        Type  "S0"
        RA            9.7803
        Dec          22.0133
        Distance   3.509e+08  # method: V
        Radius     7.146e+04
        AbsMag        -21.66
        Axis    [ -0.1686   0.7202  -0.6730]
        Angle     69.2294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2991"
}

Galaxy "NGC 2992:MCG 2-25-14:ARP 245:IRAS 09432-1405"
{
        Type  "Sa"
        RA            9.7614
        Dec         -14.3269
        Distance   1.198e+08  # method: V
        Radius     6.446e+04
        AbsMag        -19.72
        Axis    [  0.9391   0.3435  -0.0117]
        Angle    107.2119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2992"
}

Galaxy "NGC 2993:MCG 2-25-15:ARP 245:IRAS 09434-1408"
{
        Type  "Sa"
        RA            9.7633
        Dec         -14.3689
        Distance   1.242e+08  # method: V
        Radius     2.349e+04
        AbsMag         -19.4
        Axis    [  0.4486   0.2924  -0.8445]
        Angle     71.0668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2993"
}

Galaxy "NGC 2994:UGC 5239:MCG 4-23-35:ZWG 122.82"
{
        Type  "S0"
        RA            9.7878
        Dec          22.0892
        Distance   3.479e+08  # method: V
        Radius     6.577e+04
        AbsMag        -21.14
        Axis    [ -0.0115   0.7284  -0.6851]
        Angle     60.3189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2994"
}

Galaxy "NGC 2996:ESO 566-12:MCG 3-25-22"
{
        Type  "Sa"
        RA            9.7750
        Dec         -21.5711
        Distance   4.121e+08  # method: V
        Radius      8.99e+04
        AbsMag        -21.91
        Axis    [  0.1716   0.1991  -0.9648]
        Angle     91.4724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2996"
}

Galaxy "NGC 2997:ESO 434-35:MCG 5-23-12:UGCA 181"
{
        Type  "SBc"
        RA            9.7606
        Dec         -31.1906
        Distance   6.288e+07  # method: V
        Radius     8.139e+04
        AbsMag        -21.32
        Axis    [  0.2293   0.1562  -0.9607]
        Angle     88.9309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2997"
}

Galaxy "NGC 2998:UGC 5250:MCG 7-20-51:ZWG 210.36"
{
        Type  "SBc"
        RA            9.8119
        Dec          44.0817
        Distance   2.091e+08  # method: T-F
        Radius     8.212e+04
        AbsMag        -20.93
        Axis    [  0.8152   0.3127   0.4875]
        Angle     57.0784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 2998"
}

Galaxy "NGC 3001:ESO 434-38:MCG 5-23-14:UGCA 183"
{
        Type  "SBc"
        RA            9.7717
        Dec         -30.4369
        Distance   1.356e+08  # method: T-F
        Radius     5.721e+04
        AbsMag        -20.49
        Axis    [  0.9611   0.0877  -0.2620]
        Angle    128.8548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3001"
}

Galaxy "NGC 3003:UGC 5251:MCG 6-22-13:ZWG 182.21"
{
        Type  "SBc"
        RA            9.8097
        Dec          33.4219
        Distance   8.163e+07  # method: T-F
        Radius     6.768e+04
        AbsMag        -19.69
        Axis    [  0.5074   0.7064   0.4934]
        Angle     48.4222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3003"
}

Galaxy "NGC 3005:MCG 7-20-54:IRAS 09461+4421"
{
        Type  "S0"
        RA            9.8206
        Dec          44.1306
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.6488   0.7433   0.1633]
        Angle     71.5625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3005"
}

Galaxy "NGC 3006:MCG 7-20-55:ZWG 210.37:NPM 1"
{
        Type  "S0"
        RA            9.8214
        Dec          44.0256
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.4042   0.6901   0.6004]
        Angle     49.9634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3006"
}

Galaxy "NGC 3007:MCG 1-25-38:IRAS 09452-0612"
{
        Type  "Sa"
        RA            9.7958
        Dec          -6.4378
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.5889   0.5596  -0.5832]
        Angle     49.4702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3007"
}

Galaxy "NGC 3008:MCG 7-20-59:ZWG 210.39"
{
        Type  "S0"
        RA            9.8261
        Dec          44.1028
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.2831   0.9418  -0.1812]
        Angle     60.7673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3008"
}

Galaxy "NGC 3009:UGC 5264:MCG 7-20-62:ZWG 239.33"
{
        Type  "Sc"
        RA            9.8364
        Dec          44.2953
        Distance   2.209e+08  # method: V
        Radius      2.57e+04
        AbsMag        -20.75
        Axis    [ -0.2633   0.8522  -0.4521]
        Angle     90.5933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3009"
}

Galaxy "NGC 3010A:UGC 5273:MCG 7-20-66:ZWG 239.35"
{
        Type  "S0"
        RA            9.8428
        Dec          44.3236
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [ -0.2815   0.9590  -0.0319]
        Angle     55.5962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3010A"
}

Galaxy "NGC 3010B:UGC 5273:MCG 7-30-65:ZWG 239.35"
{
        Type  "S0"
        RA            9.8425
        Dec          44.3147
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.7851   0.5338   0.3141]
        Angle     43.8886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3010B"
}

Galaxy "NGC 3010C:UGC 5273:MCG 7-20-67:ZWG 239.35"
{
        Type  "S0"
        RA            9.8442
        Dec          44.3308
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.9015  -0.0122   0.4326]
        Angle     76.2357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3010C"
}

Galaxy "NGC 3011:UGC 5259:MCG 5-23-38:MK 409"
{
        Type  "S0"
        RA            9.8281
        Dec          32.2217
        Distance   8.086e+07  # method: V
        Radius     1.058e+04
        AbsMag        -17.37
        Axis    [  0.8503   0.2322  -0.4723]
        Angle     52.5432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3011"
}

Galaxy "NGC 3012:UGC 5262:MCG 6-22-17:ZWG 182.23"
{
        Type  "E0"
        RA            9.8311
        Dec          34.7147
        Distance   3.312e+08  # distance uncertain!
        Radius     4.817e+04
        AbsMag        -20.13
        Axis    [  0.7565  -0.6289  -0.1794]
        Angle     94.6326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3012"
}

Galaxy "NGC 3013:MCG 6-22-18:ZWG 182.24:NPM 1"
{
        Type  "S0"
        RA            9.8358
        Dec          33.5697
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.5545   0.8103  -0.1895]
        Angle     39.9456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3013"
}

Galaxy "NGC 3014:MCG 1-25-43"
{
        Type  "Sc"
        RA            9.8186
        Dec          -4.7428
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.2722   0.4245  -0.8635]
        Angle     97.2654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3014"
}

Galaxy "NGC 3015:UGC 5261:MCG 0-25-20:ZWG 7.41"
{
        Type  "S0"
        RA            9.8228
        Dec           1.1453
        Distance   3.574e+08  # method: V
        Radius     2.599e+04
        AbsMag         -20.7
        Axis    [  0.4596   0.3414  -0.8199]
        Angle     66.4294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3015"
}

Galaxy "NGC 3016:UGC 5266:MCG 2-25-40:ZWG 63.77"
{
        Type  "Sb"
        RA            9.8306
        Dec          12.6953
        Distance   4.206e+08  # method: V
        Radius     7.341e+04
        AbsMag        -21.85
        Axis    [  0.8188   0.2770  -0.5028]
        Angle     59.5777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3016"
}

Galaxy "NGC 3017:MCG 0-25-19:ZWG 7.40:NPM 1"
{
        Type  "E0"
        RA            9.8175
        Dec          -2.8214
        Distance   2.754e+08  # distance uncertain!
        Radius     4.006e+04
        AbsMag        -20.13
        Axis    [  0.8412  -0.4446  -0.3078]
        Angle    124.7830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3017"
}

Galaxy "NGC 3018:UGC 5265:MCG 0-25-21:ZWG 7.42"
{
        Type  "Sb"
        RA            9.8281
        Dec           0.6228
        Distance   9.939e+07  # method: V
        Radius     1.735e+04
        AbsMag        -18.32
        Axis    [  0.9859   0.1084  -0.1278]
        Angle     90.8713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3018"
}

Galaxy "NGC 3019:MCG 2-25-44:ZWG 63.81"
{
        Type  "Sc"
        RA            9.8353
        Dec          12.7461
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.9701   0.2401  -0.0364]
        Angle     69.5753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3019"
}

Galaxy "NGC 3020:UGC 5271:MCG 2-25-45:ZWG 63.82"
{
        Type  "SBc"
        RA            9.8350
        Dec          12.8136
        Distance   7.955e+07  # method: V
        Radius     3.471e+04
        AbsMag        -19.04
        Axis    [  0.2928   0.7575  -0.5835]
        Angle     43.3912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3020"
}

Galaxy "NGC 3021:UGC 5280:MCG 6-22-19:ZWG 182.25"
{
        Type  "Sc"
        RA            9.8492
        Dec          33.5542
        Distance   8.141e+07  # method: V
        Radius     1.776e+04
        AbsMag        -18.99
        Axis    [  0.1267   0.9516  -0.2802]
        Angle     43.2367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3021"
}

Galaxy "NGC 3022:MCG 1-25-46"
{
        Type  "S0"
        RA            9.8275
        Dec          -5.1664
        Distance    1.47e+08  # distance uncertain!
        Radius     3.422e+04
        AbsMag        -19.07
        Axis    [  0.8581  -0.4148  -0.3027]
        Angle    125.8741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3022"
}

Galaxy "NGC 3023-1:UGC 5269:MCG 0-25-22:ZWG 7.43"
{
        Type  "SBc"
        RA            9.8311
        Dec           0.6189
        Distance   1.001e+08  # method: V
        Radius     4.368e+04
        AbsMag        -19.43
        Axis    [  0.8285   0.4244  -0.3654]
        Angle     58.0034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3023-1"
}

Galaxy "NGC 3023-2:MK 1236:NPM 1"
{
        Type  "E0"
        RA            9.8317
        Dec           0.6169
        Distance   3.468e+08  # distance uncertain!
        Radius     1.513e+04
        AbsMag        -20.13
        Axis    [  0.5044   0.0036  -0.8635]
        Angle    101.7708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3023-2"
}

Galaxy "NGC 3024:UGC 5275:MCG 2-25-46:ZWG 63.84"
{
        Type  "Sc"
        RA            9.8408
        Dec          12.7656
        Distance   7.846e+07  # method: V
        Radius     2.282e+04
        AbsMag        -18.11
        Axis    [ -0.3931   0.9102  -0.1304]
        Angle     37.6899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3024"
}

Galaxy "NGC 3025:ESO 566-15:MCG 4-23-18"
{
        Type  "S0"
        RA            9.8247
        Dec         -21.7414
        Distance   1.281e+08  # distance uncertain!
        Radius     2.794e+04
        AbsMag        -19.07
        Axis    [  0.2280   0.2064  -0.9516]
        Angle     84.1235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3025"
}

Galaxy "NGC 3026:UGC 5279:MCG 5-23-43:ZWG 152.74"
{
        Type  "Irr"
        RA            9.8483
        Dec          28.5514
        Distance   9.278e+07  # method: T-F
        Radius     3.643e+04
        AbsMag        -18.57
        Axis    [  0.5687   0.7577   0.3201]
        Angle     43.6272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3026"
}

Galaxy "NGC 3027:UGC 5316:MCG 12-10-9:ZWG 332.68"
{
        Type  "SBc"
        RA            9.9278
        Dec          72.2042
        Distance   8.503e+07  # method: T-F
        Radius     4.823e+04
        AbsMag        -19.88
        Axis    [ -0.3324   0.8344   0.4397]
        Angle     75.8761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3027"
}

Galaxy "NGC 3028:ESO 566-16:IRAS 09475-1856"
{
        Type  "Sb"
        RA            9.8317
        Dec         -19.1844
        Distance   1.065e+08  # distance uncertain!
        Radius     1.394e+04
        AbsMag        -19.07
        Axis    [  0.2503   0.1820  -0.9509]
        Angle     91.3896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3028"
}

Galaxy "NGC 3029:MCG 1-25-47:A 0946-07"
{
        Type  "Sc"
        RA            9.8147
        Dec          -8.0511
        Distance   2.595e+08  # method: T-F
        Radius     5.284e+04
        AbsMag         -19.8
        Axis    [  0.8972   0.1119  -0.4272]
        Angle     86.4589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3029"
}

Galaxy "NGC 3030:MCG 2-25-21:NPM 1"
{
        Type  "S0"
        RA            9.8361
        Dec         -12.2258
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.1152   0.2679  -0.9565]
        Angle     88.6527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3030"
}

Galaxy "M 81:NGC 3031:UGC 5318:MCG 12-10-10"
{
        Type  "Sb"
        RA            9.9258
        Dec          69.0672
        Distance   1.275e+07  # method: S
        Radius     4.617e+04
        AbsMag        -20.15
        Axis    [ -0.4601   0.8780   0.1323]
        Angle     89.2624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 81"
}

Galaxy "NGC 3032:UGC 5292:MCG 5-23-46:ZWG 152.77"
{
        Type  "S0"
        RA            9.8689
        Dec          29.2367
        Distance   7.169e+07  # method: S
        Radius     1.772e+04
        AbsMag        -18.21
        Axis    [  0.5113   0.6751  -0.5318]
        Angle     45.5584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3032"
}

Galaxy "M 82:NGC 3034:UGC 5322:MCG 12-10-11"
{
        Type  "Irr"
        RA            9.9317
        Dec          69.6831
        Distance   1.341e+07  # method: V
        Radius     2.184e+04
        AbsMag        -18.87
        Axis    [  0.4124   0.3536   0.8396]
        Angle     62.3995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 82"
}

Galaxy "NGC 3035:MCG 1-25-52:IRAS 09494-0635"
{
        Type  "SBc"
        RA            9.8650
        Dec          -6.8228
        Distance   1.065e+08  # distance uncertain!
        Radius     2.634e+04
        AbsMag        -19.07
        Axis    [ -0.2988   0.4021  -0.8655]
        Angle     88.2931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3035"
}

Galaxy "NGC 3037:ESO 499-10:MCG 4-24-2:AM 0949-264"
{
        Type  "Irr"
        RA            9.8567
        Dec         -27.0108
        Distance    5.45e+07  # method: V
        Radius      1.03e+04
        AbsMag        -17.41
        Axis    [  0.8139   0.0083  -0.5810]
        Angle    110.2350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3037"
}

Galaxy "NGC 3038:ESO 374-2:MCG 5-24-1:AM 0949-323"
{
        Type  "Sb"
        RA            9.8542
        Dec         -32.7536
        Distance    1.27e+08  # method: T-F
        Radius     4.619e+04
        AbsMag        -20.45
        Axis    [ -0.0541   0.1585  -0.9859]
        Angle     73.7439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3038"
}

Galaxy "NGC 3039:UGC 5297:MCG 0-25-27:ZWG 7.51"
{
        Type  "SBb"
        RA            9.8747
        Dec           2.1536
        Distance   2.432e+08  # method: V
        Radius     4.244e+04
        AbsMag        -19.96
        Axis    [  0.9958   0.0908   0.0085]
        Angle    102.0698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3039"
}

Galaxy "NGC 3040A:UGC 5300:MCG 3-25-37:ZWG 92.67"
{
        Type  "Sb"
        RA            9.8847
        Dec          19.4328
        Distance    1.47e+08  # distance uncertain!
        Radius     1.497e+04
        AbsMag        -19.07
        Axis    [ -0.5175   0.6452  -0.5621]
        Angle     88.4844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3040A"
}

Galaxy "NGC 3040B:UGC 5300:MCG 3-25-37:ZWG 92.67"
{
        Type  "S0"
        RA            9.8842
        Dec          19.4422
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.5098   0.7182  -0.4736]
        Angle     63.0478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3040B"
}

Galaxy "NGC 3041:UGC 5303:MCG 3-25-39:ZWG 92.68"
{
        Type  "SBc"
        RA            9.8853
        Dec          16.6775
        Distance   7.801e+07  # method: V
        Radius     4.198e+04
        AbsMag        -19.49
        Axis    [  0.5112   0.6324  -0.5820]
        Angle     45.9365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3041"
}

Galaxy "NGC 3042:UGC 5307:MCG 0-25-30:ZWG 7.54"
{
        Type  "S0"
        RA            9.8889
        Dec           0.6978
        Distance   1.223e+08  # distance uncertain!
        Radius     2.135e+04
        AbsMag        -19.07
        Axis    [  0.1985   0.5537  -0.8087]
        Angle     51.4900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3042"
}

Galaxy "NGC 3043:UGC 5327:MCG 10-14-52:ZWG 289.23"
{
        Type  "Sb"
        RA            9.9372
        Dec          59.3072
        Distance    1.42e+08  # method: V
        Radius      3.51e+04
        AbsMag        -19.59
        Axis    [  0.2688   0.6361   0.7233]
        Angle     53.9458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3043"
}

Galaxy "NGC 3044:UGC 5311:MCG 0-25-31:ZWG 7.56"
{
        Type  "SBc"
        RA            9.8944
        Dec           1.5794
        Distance    7.37e+07  # method: V
        Radius     5.038e+04
        AbsMag        -19.27
        Axis    [ -0.0617   0.9291  -0.3647]
        Angle     31.6808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3044"
}

Galaxy "NGC 3045:ESO 566-22:MCG 3-25-28"
{
        Type  "Sb"
        RA            9.8881
        Dec         -18.6439
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.9575   0.2265  -0.1784]
        Angle    105.8053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3045"
}

Galaxy "NGC 3047:UGC 5323:MCG 0-25-33:ZWG 7.59"
{
        Type  "S0"
        RA            9.9089
        Dec          -1.2911
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.8474  -0.4403  -0.2969]
        Angle    122.9937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3047"
}

Galaxy "NGC 3047A:UGC 5323:MCG 0-25-32:ZWG 7.59"
{
        Type  "E0"
        RA            9.9081
        Dec          -1.2878
        Distance   2.399e+08  # distance uncertain!
        Radius     1.396e+04
        AbsMag        -20.13
        Axis    [  0.7704  -0.3265  -0.5476]
        Angle    111.9747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3047A"
}

Galaxy "NGC 3048-1:ZWG 92.71"
{
        Type  "S0"
        RA            9.9156
        Dec          16.4561
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [ -0.1313   0.8294  -0.5430]
        Angle     45.1663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3048-1"
}

Galaxy "NGC 3048-2:ZWG 92.71"
{
        Type  "Sa"
        RA            9.9161
        Dec          16.4592
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9916   0.0604   0.1141]
        Angle     88.6352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3048-2"
}

Galaxy "NGC 3049:UGC 5325:MCG 2-25-55:MK 710"
{
        Type  "SBb"
        RA            9.9136
        Dec           9.2719
        Distance   8.236e+07  # method: V
        Radius     2.635e+04
        AbsMag        -18.71
        Axis    [  0.9942  -0.0079  -0.1069]
        Angle     88.0472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3049"
}

Galaxy "NGC 3051:ESO 499-16:MCG 4-24-4"
{
        Type  "S0"
        RA            9.8994
        Dec         -27.2861
        Distance   1.298e+08  # method: V
        Radius     3.966e+04
        AbsMag         -20.2
        Axis    [  0.8922  -0.0938  -0.4417]
        Angle    125.4072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3051"
}

Galaxy "NGC 3052:ESO 566-26:MCG 3-25-30:IRAS 09521-1824"
{
        Type  "SBc"
        RA            9.9078
        Dec         -18.6389
        Distance   1.783e+08  # method: T-F
        Radius     5.447e+04
        AbsMag        -20.89
        Axis    [  0.3484   0.2858  -0.8927]
        Angle     67.0085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3052"
}

Galaxy "NGC 3053:UGC 5329:MCG 3-25-40:ZWG 92.74"
{
        Type  "SBa"
        RA            9.9258
        Dec          16.4333
        Distance   1.831e+08  # method: V
        Radius     4.794e+04
        AbsMag        -20.05
        Axis    [ -0.3224   0.7774  -0.5401]
        Angle     51.0541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3053"
}

Galaxy "NGC 3054:ESO 499-18:MCG 4-24-5:UGCA 187"
{
        Type  "SBb"
        RA            9.9078
        Dec         -25.7036
        Distance   1.276e+08  # method: T-F
        Radius      7.05e+04
        AbsMag        -20.76
        Axis    [  0.1095   0.2217  -0.9689]
        Angle     72.6128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3054"
}

Galaxy "NGC 3055:UGC 5328:MCG 1-25-34:ZWG 35.87"
{
        Type  "SBc"
        RA            9.9214
        Dec           4.2694
        Distance   9.817e+07  # method: V
        Radius     2.998e+04
        AbsMag        -19.79
        Axis    [  0.8765   0.2650  -0.4018]
        Angle     63.5192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3055"
}

Galaxy "NGC 3056:ESO 435-7:MCG 5-24-3:AM 0952-280"
{
        Type  "SBa"
        RA            9.9089
        Dec         -28.2983
        Distance   3.976e+07  # method: S
        Radius     1.041e+04
        AbsMag        -17.83
        Axis    [  0.9448   0.1296  -0.3008]
        Angle    118.1340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3056"
}

Galaxy "NGC 3057:UGC 5404:MCG 14-5-10:DDO 67"
{
        Type  "Irr"
        RA           10.0942
        Dec          80.2853
        Distance   7.022e+07  # method: V
        Radius     2.247e+04
        AbsMag        -18.16
        Axis    [  0.6362  -0.4135   0.6513]
        Angle     88.9841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3057"
}

Galaxy "NGC 3058:IC 573:MCG 2-25-26:VV 741"
{
        Type  "Sc"
        RA            9.8933
        Dec         -12.4822
        Distance    3.56e+08  # method: V
        Radius     6.732e+04
        AbsMag        -20.99
        Axis    [  0.9556   0.1670  -0.2428]
        Angle     95.7661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3058"
}

Galaxy "NGC 3058A:MCG 2-25-26:VV 741"
{
        Type  "E0"
        RA            9.8931
        Dec         -12.4794
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [  0.8471  -0.4100  -0.3382]
        Angle    133.2362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3058A"
}

Galaxy "NGC 3059:ESO 37-7:IRAS 09496-7341"
{
        Type  "SBc"
        RA            9.8356
        Dec         -73.9214
        Distance   6.301e+07  # method: V
        Radius     3.299e+04
        AbsMag        -19.83
        Axis    [  0.5042  -0.0395  -0.8627]
        Angle    147.7364
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3059"
}

Galaxy "NGC 3060:UGC 5338:MCG 3-26-2:ZWG 93.3"
{
        Type  "Sb"
        RA            9.9386
        Dec          16.8314
        Distance   1.813e+08  # method: V
        Radius     5.802e+04
        AbsMag        -19.92
        Axis    [  0.7180   0.6832   0.1332]
        Angle     44.4355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3060"
}

Galaxy "NGC 3061:UGC 5319:MCG 13-7-40:ZWG 350.36"
{
        Type  "SBc"
        RA            9.9364
        Dec          75.8664
        Distance   1.134e+08  # method: V
        Radius     2.804e+04
        AbsMag        -19.01
        Axis    [  0.6696  -0.6014   0.4358]
        Angle     71.9614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3061"
}

Galaxy "NGC 3062:ZWG 8.2:NPM 1"
{
        Type  "Sb"
        RA            9.9431
        Dec           1.4292
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.8721   0.3465  -0.3454]
        Angle     60.6661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3062"
}

Galaxy "NGC 3064:MCG 1-26-1"
{
        Type  "Sc"
        RA            9.9281
        Dec          -6.3642
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.9441   0.3297   0.0035]
        Angle     91.5195
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3064"
}

Galaxy "NGC 3065:UGC 5375:MCG 12-10-14:ZWG 333.10"
{
        Type  "S0"
        RA           10.0319
        Dec          72.1700
        Distance   9.373e+07  # method: V
        Radius     2.317e+04
        AbsMag        -19.69
        Axis    [  0.7623  -0.4943   0.4177]
        Angle     61.0406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3065"
}

Galaxy "NGC 3066:UGC 5379:MCG 12-10-15:MK 133"
{
        Type  "SBb"
        RA           10.0361
        Dec          72.1256
        Distance   9.586e+07  # method: V
        Radius     1.534e+04
        AbsMag        -18.84
        Axis    [ -0.1304   0.9748  -0.1807]
        Angle     91.9725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3066"
}

Galaxy "NGC 3067:UGC 5351:MCG 6-22-46:ZWG 182.51"
{
        Type  "SBb"
        RA            9.9725
        Dec          32.3700
        Distance   7.887e+07  # method: V
        Radius     2.753e+04
        AbsMag        -19.12
        Axis    [  0.1229   0.9846   0.1244]
        Angle     38.4155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3067"
}

Galaxy "NGC 3068:NGC 3068A:UGC 5353:MCG 5-24-6"
{
        Type  "S0"
        RA            9.9778
        Dec          28.8781
        Distance    2.99e+08  # method: V
        Radius     4.783e+04
        AbsMag        -19.41
        Axis    [  0.9680   0.0472  -0.2465]
        Angle     58.0732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3068"
}

Galaxy "NGC 3068B:NPM 1:ARP 174"
{
        Type  "E0"
        RA            9.9772
        Dec          28.8711
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.7611  -0.6139  -0.2095]
        Angle    100.1475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3068B"
}

Galaxy "NGC 3069:IC 580:MCG 2-26-5:ZWG 64.10"
{
        Type  "S0"
        RA            9.9656
        Dec          10.4328
        Distance   2.546e+08  # method: V
        Radius     2.962e+04
        AbsMag        -19.36
        Axis    [ -0.6358   0.5497  -0.5418]
        Angle     72.9281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3069"
}

Galaxy "NGC 3070:UGC 5350:MCG 2-26-6:ZWG 64.11"
{
        Type  "E0"
        RA            9.9683
        Dec          10.3603
        Distance   1.795e+08  # method: T-F
        Radius     3.656e+04
        AbsMag         -20.5
        Axis    [  0.8076  -0.5202  -0.2778]
        Angle    114.6422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3070"
}

Galaxy "NGC 3071:ZWG 153.8:NPM 1"
{
        Type  "S0"
        RA            9.9811
        Dec          31.6208
        Distance   3.029e+08  # method: V
        Radius     2.203e+04
        AbsMag        -19.34
        Axis    [ -0.6052   0.7038  -0.3719]
        Angle     90.0574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3071"
}

Galaxy "NGC 3072:ESO 566-33:MCG 3-26-1"
{
        Type  "Sa"
        RA            9.9564
        Dec         -19.3547
        Distance   1.168e+08  # distance uncertain!
        Radius     3.228e+04
        AbsMag        -19.07
        Axis    [  0.7732   0.4053  -0.4878]
        Angle     63.8641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3072"
}

Galaxy "NGC 3073:UGC 5374:MCG 9-17-7:MK 131"
{
        Type  "S0"
        RA           10.0144
        Dec          55.6183
        Distance     1.1e+08  # method: S
        Radius      1.92e+04
        AbsMag        -18.64
        Axis    [ -0.1600   0.9141  -0.3726]
        Angle     86.8926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3073"
}

Galaxy "NGC 3074:UGC 5366:MCG 6-22-47:ZWG 182.54"
{
        Type  "Sc"
        RA            9.9947
        Dec          35.3933
        Distance   2.445e+08  # method: V
        Radius     8.179e+04
        AbsMag        -20.97
        Axis    [ -0.2853   0.7819  -0.5542]
        Angle     94.8768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3074"
}

Galaxy "NGC 3075:UGC 5360:MCG 3-26-9:ZWG 93.12"
{
        Type  "Sc"
        RA            9.9822
        Dec          14.4194
        Distance   1.766e+08  # method: V
        Radius     3.083e+04
        AbsMag        -19.27
        Axis    [ -0.2224   0.6811  -0.6976]
        Angle     58.9612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3075"
}

Galaxy "NGC 3076:ESO 566-34:MCG 3-26-2:PGC 28769"
{
        Type  "Sb"
        RA            9.9603
        Dec         -18.1783
        Distance   1.341e+08  # distance uncertain!
        Radius      1.95e+04
        AbsMag        -19.07
        Axis    [  0.9513  -0.1693  -0.2575]
        Angle    129.1845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3076"
}

Galaxy "NGC 3077:UGC 5398:MCG 12-10-17:ZWG 333.13"
{
        Type  "Irr"
        RA           10.0556
        Dec          68.7350
        Distance   1.317e+07  # method: S
        Radius          9957
        AbsMag        -17.43
        Axis    [  0.9198  -0.2202   0.3249]
        Angle     43.0539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3077"
}

Galaxy "NGC 3078:ESO 499-27:MCG 4-24-9:AM 0956-264"
{
        Type  "E3"
        RA            9.9733
        Dec         -26.9261
        Distance   1.147e+08  # method: S
        Radius     4.503e+04
        AbsMag        -20.63
        Axis    [ -0.3632   0.3042  -0.8807]
        Angle    139.2523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3078"
}

Galaxy "NGC 3079:UGC 5387:MCG 9-17-10:ZWG 266.8"
{
        Type  "SBc"
        RA           10.0325
        Dec          55.6814
        Distance    6.94e+07  # method: T-F
        Radius     8.176e+04
        AbsMag        -20.14
        Axis    [ -0.6884   0.7029   0.1788]
        Angle     88.1809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3079"
}

Galaxy "NGC 3080:UGC 5372:MCG 2-26-15:MK 1243"
{
        Type  "Sa"
        RA            9.9986
        Dec          13.0442
        Distance   4.961e+08  # method: V
        Radius     6.494e+04
        AbsMag        -21.41
        Axis    [  0.7609   0.1091  -0.6397]
        Angle     67.0152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3080"
}

Galaxy "NGC 3081:IC 2529:ESO 499-31:MCG 4-24-12"
{
        Type  "SBa"
        RA            9.9914
        Dec         -22.8261
        Distance    1.22e+08  # method: V
        Radius     3.905e+04
        AbsMag        -19.96
        Axis    [  0.6099   0.0835  -0.7881]
        Angle     91.3023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3081"
}

Galaxy "NGC 3082:ESO 435-18:MCG 5-24-11:AM 0956-300"
{
        Type  "S0"
        RA            9.9811
        Dec         -30.3575
        Distance   1.065e+08  # distance uncertain!
        Radius     2.789e+04
        AbsMag        -19.07
        Axis    [  0.9144   0.2726  -0.2993]
        Angle    106.6553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3082"
}

Galaxy "NGC 3083:MCG 0-26-2:ZWG 8.11"
{
        Type  "Sa"
        RA            9.9969
        Dec          -2.8775
        Distance   3.027e+08  # method: V
        Radius     4.842e+04
        AbsMag        -20.24
        Axis    [  0.9313   0.3267  -0.1612]
        Angle     71.3039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3083"
}

Galaxy "NGC 3084:IC 2528:ESO 499-29:MCG 4-24-10"
{
        Type  "SBb"
        RA            9.9850
        Dec         -27.1283
        Distance    1.26e+08  # method: V
        Radius     3.298e+04
        AbsMag        -19.73
        Axis    [  0.9439  -0.1172  -0.3089]
        Angle    134.3181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3084"
}

Galaxy "NGC 3085:ESO 566-38:MCG 3-26-3"
{
        Type  "S0"
        RA            9.9914
        Dec         -19.4928
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [  0.0387   0.3951  -0.9178]
        Angle     46.7776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3085"
}

Galaxy "NGC 3086:MCG 0-26-3:ZWG 8.12"
{
        Type  "Sb"
        RA           10.0028
        Dec          -2.9758
        Distance   4.578e+08  # method: V
        Radius      7.99e+04
        AbsMag        -21.04
        Axis    [ -0.5500   0.4976  -0.6708]
        Angle     50.3641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3086"
}

Galaxy "NGC 3087:ESO 374-15:MCG 6-22-5:AM 0956-335"
{
        Type  "E0"
        RA            9.9856
        Dec         -34.2256
        Distance   1.141e+08  # method: S
        Radius      3.32e+04
        AbsMag        -20.92
        Axis    [  0.8581  -0.3274  -0.3957]
        Angle    152.0610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3087"
}

Galaxy "NGC 3088:NGC 3088A:UGC 5384:MCG 4-24-10"
{
        Type  "S0"
        RA           10.0189
        Dec          22.4061
        Distance   1.851e+08  # distance uncertain!
        Radius     1.346e+04
        AbsMag        -19.07
        Axis    [  0.9045   0.3866  -0.1801]
        Angle     48.4472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3088"
}

Galaxy "NGC 3088B:UGC 5384:MCG 4-24-11:ZWG 123.13"
{
        Type  "Sc"
        RA           10.0192
        Dec          22.4017
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.5848   0.8104   0.0357]
        Angle     45.5264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3088B"
}

Galaxy "NGC 3089:ESO 435-24:MCG 5-24-14:AM 0957-280"
{
        Type  "SBb"
        RA            9.9933
        Dec         -28.3311
        Distance   1.311e+08  # method: T-F
        Radius     3.432e+04
        AbsMag        -19.72
        Axis    [ -0.2141   0.1678  -0.9623]
        Angle     71.2234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3089"
}

Galaxy "NGC 3090:MCG 0-26-5:ZWG 8.16:IRAS 09579-0243"
{
        Type  "E0"
        RA           10.0083
        Dec          -2.9686
        Distance   3.076e+08  # method: T-F
        Radius     7.606e+04
        AbsMag        -21.27
        Axis    [  0.4029   0.0398  -0.9144]
        Angle    104.3217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3090"
}

Galaxy "NGC 3091:ESO 566-41:MCG 3-26-7:HCG 42A"
{
        Type  "E1"
        RA           10.0039
        Dec         -19.6367
        Distance   1.769e+08  # method: T-F
        Radius     7.717e+04
        AbsMag        -21.47
        Axis    [ -0.1309   0.2618  -0.9562]
        Angle    127.2508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3091"
}

Galaxy "NGC 3092:MCG 0-26-8:ZWG 8.19"
{
        Type  "Sa"
        RA           10.0131
        Dec          -3.0122
        Distance   2.805e+08  # method: V
        Radius     5.305e+04
        AbsMag        -20.27
        Axis    [  0.9774   0.1758  -0.1171]
        Angle     88.8624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3092"
}

Galaxy "NGC 3093:MCG 0-26-7:ZWG 8.21:NPM 1"
{
        Type  "E0"
        RA           10.0147
        Dec          -2.9714
        Distance   2.917e+08  # method: V
        Radius      2.97e+04
        AbsMag        -19.56
        Axis    [  0.6739  -0.2235  -0.7042]
        Angle    108.0767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3093"
}

Galaxy "NGC 3094:UGC 5390:MCG 3-26-15:ZWG 93.23"
{
        Type  "SBa"
        RA           10.0236
        Dec          15.7700
        Distance   1.233e+08  # method: V
        Radius      2.87e+04
        AbsMag        -19.49
        Axis    [  0.7924   0.2989  -0.5317]
        Angle     54.1249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3094"
}

Galaxy "NGC 3095:ESO 435-26:MCG 5-24-16:UGCA 192"
{
        Type  "SBc"
        RA           10.0014
        Dec         -31.5533
        Distance   1.166e+08  # method: T-F
        Radius     6.105e+04
        AbsMag        -20.47
        Axis    [ -0.0160   0.1571  -0.9875]
        Angle     70.9579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3095"
}

Galaxy "NGC 3096:ESO 566-42:MCG 3-26-8:HCG 42B"
{
        Type  "S0"
        RA           10.0092
        Dec         -19.6622
        Distance   2.052e+08  # method: V
        Radius     2.984e+04
        AbsMag        -19.19
        Axis    [ -0.4811   0.2609  -0.8370]
        Angle     98.0782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3096"
}

Galaxy "NGC 3098:UGC 5397:MCG 4-24-12:ZWG 123.14"
{
        Type  "Sa"
        RA           10.0378
        Dec          24.7114
        Distance   7.375e+07  # method: V
        Radius      2.36e+04
        AbsMag        -18.77
        Axis    [  0.4806   0.8358   0.2656]
        Angle     38.3891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3098"
}

Galaxy "NGC 3099A:MCG 6-22-59:ZWG 182.64:NPM 1"
{
        Type  "E0"
        RA           10.0433
        Dec          32.7072
        Distance   2.754e+08  # distance uncertain!
        Radius     2.404e+04
        AbsMag        -20.13
        Axis    [  0.7421  -0.6412  -0.1951]
        Angle     97.7548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3099A"
}

Galaxy "NGC 3099B:MCG 6-22-58"
{
        Type  "E0"
        RA           10.0417
        Dec          32.7144
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [  0.7423  -0.6411  -0.1951]
        Angle     97.7366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3099B"
}

Galaxy "NGC 3100:NGC 3103:ESO 435-30:MCG 5-24-18"
{
        Type  "S0"
        RA           10.0111
        Dec         -31.6642
        Distance    5.59e+07  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.4046   0.0924  -0.9098]
        Angle     76.2984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3100"
}

Galaxy "NGC 3101:MCG 0-26-11:ZWG 8.24"
{
        Type  "Sa"
        RA           10.0264
        Dec          -2.9947
        Distance   2.555e+08  # distance uncertain!
        Radius      4.46e+04
        AbsMag        -19.07
        Axis    [ -0.6903   0.4527  -0.5644]
        Angle     49.2487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3101"
}

Galaxy "NGC 3102:UGC 5418:MCG 10-15-7:ZWG 289.30"
{
        Type  "S0"
        RA           10.0753
        Dec          60.1078
        Distance   1.451e+08  # method: V
        Radius     1.899e+04
        AbsMag        -18.94
        Axis    [  0.6262  -0.7795  -0.0133]
        Angle     79.2994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3102"
}

Galaxy "NGC 3104:UGC 5414:MCG 7-21-7:ZWG 211.6"
{
        Type  "Irr"
        RA           10.0658
        Dec          40.7572
        Distance   3.828e+07  # method: V
        Radius     1.837e+04
        AbsMag        -16.55
        Axis    [  0.9708  -0.0659   0.2306]
        Angle     65.1315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3104"
}

Galaxy "NGC 3106:UGC 5419:MCG 5-24-9:ZWG 153.13"
{
        Type  "S0"
        RA           10.0681
        Dec          31.1858
        Distance   2.933e+08  # method: V
        Radius     7.679e+04
        AbsMag        -21.47
        Axis    [  0.7645  -0.6187  -0.1811]
        Angle     98.4979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3106"
}

Galaxy "NGC 3107:UGC 5425:MCG 2-26-22:ZWG 64.48"
{
        Type  "Sc"
        RA           10.0728
        Dec          13.6219
        Distance    1.41e+08  # method: V
        Radius     1.435e+04
        AbsMag        -19.38
        Axis    [ -0.1608   0.5838  -0.7958]
        Angle     74.3255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3107"
}

Galaxy "NGC 3108:ESO 435-32:MCG 5-24-19:AM 1000-312"
{
        Type  "Sa"
        RA           10.0414
        Dec         -31.6758
        Distance   1.411e+08  # method: T-F
        Radius     5.129e+04
        AbsMag        -20.48
        Axis    [  0.2057   0.1288  -0.9701]
        Angle     83.3814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3108"
}

Galaxy "NGC 3109:ESO 499-36:MCG 4-24-13:UGCA 194"
{
        Type  "Irr"
        RA           10.0517
        Dec         -26.1583
        Distance   3.284e+07  # method: V
        Radius     9.124e+04
        AbsMag        -19.61
        Axis    [  0.5616   0.4755  -0.6771]
        Angle     46.8824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3109"
}

Galaxy "NGC 3111:UGC 5441:MCG 8-19-2:ZWG 240.7"
{
        Type  "S0"
        RA           10.1019
        Dec          47.2631
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [ -0.1335   0.8828  -0.4504]
        Angle     73.2515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3111"
}

Galaxy "NGC 3112:ESO 567-11"
{
        Type  "Sc"
        RA           10.0664
        Dec         -20.7822
        Distance   3.369e+08  # distance uncertain!
        Radius     4.899e+04
        AbsMag        -19.07
        Axis    [  0.8800   0.4285  -0.2049]
        Angle     78.9514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3112"
}

Galaxy "NGC 3113:ESO 435-35:MCG 5-24-21:UGCA 198"
{
        Type  "SBc"
        RA           10.0739
        Dec         -28.4447
        Distance   6.279e+07  # method: T-F
        Radius     3.014e+04
        AbsMag        -18.12
        Axis    [  0.5835   0.3250  -0.7443]
        Angle     60.6117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3113"
}

Galaxy "NGC 3115:MCG 1-26-18:UGCA 199"
{
        Type  "S0"
        RA           10.0872
        Dec          -7.7181
        Distance   3.158e+07  # method: S
        Radius     3.307e+04
        AbsMag        -19.83
        Axis    [  0.9468   0.2891  -0.1411]
        Angle     81.1879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3115"
}

Galaxy "NGC 3116:MCG 5-24-12:ZWG 153.17:ARAK 230"
{
        Type  "E0"
        RA           10.1125
        Dec          31.0983
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.7407  -0.6400  -0.2046]
        Angle     99.4749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3116"
}

Galaxy "NGC 3117:UGC 5445:MCG 1-26-14:ZWG 36.38"
{
        Type  "E0"
        RA           10.1028
        Dec           2.9133
        Distance   2.512e+08  # distance uncertain!
        Radius     3.654e+04
        AbsMag        -20.13
        Axis    [  0.8098  -0.4985  -0.3094]
        Angle    121.3723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3117"
}

Galaxy "NGC 3118:UGC 5452:MCG 6-22-74:ZWG 182.75"
{
        Type  "Sc"
        RA           10.1197
        Dec          33.0272
        Distance   7.284e+07  # method: V
        Radius     2.649e+04
        AbsMag        -17.44
        Axis    [  0.8069   0.2727   0.5240]
        Angle     75.4245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3118"
}

Galaxy "NGC 3119:ZWG 93.45:NPM 1"
{
        Type  "E0"
        RA           10.1131
        Dec          14.3056
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.7867  -0.5542  -0.2718]
        Angle    112.3292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3119"
}

Galaxy "NGC 3120:ESO 374-29:MCG 6-22-17:IRAS 10031-3358"
{
        Type  "SBc"
        RA           10.0894
        Dec         -34.2208
        Distance   9.853e+07  # method: T-F
        Radius     2.579e+04
        AbsMag         -18.9
        Axis    [  0.9584   0.0808  -0.2738]
        Angle    133.5399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3120"
}

Galaxy "NGC 3121:UGC 5450:MCG 3-26-27:ZWG 93.46"
{
        Type  "E0"
        RA           10.1142
        Dec          14.3739
        Distance   4.247e+08  # method: V
        Radius      1.05e+05
        AbsMag        -21.67
        Axis    [  0.7767  -0.4589  -0.4315]
        Angle    102.0958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3121"
}

Galaxy "NGC 3122:NGC 3110:NGC 3518:MCG 1-26-14"
{
        Type  "Sb"
        RA           10.0669
        Dec          -6.4747
        Distance   2.456e+08  # method: V
        Radius     5.716e+04
        AbsMag        -20.88
        Axis    [ -0.6055   0.3611  -0.7092]
        Angle     70.1660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3122"
}

Galaxy "NGC 3124:ESO 567-17:MCG 3-26-24:UGCA 202"
{
        Type  "SBc"
        RA           10.1111
        Dec         -19.2217
        Distance   1.764e+08  # method: V
        Radius     7.442e+04
        AbsMag        -20.86
        Axis    [  0.9389  -0.1250  -0.3207]
        Angle    123.0344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3124"
}

Galaxy "NGC 3125:ESO 435-41:MCG 5-24-22:AM 1004-294"
{
        Type  "E0"
        RA           10.1092
        Dec         -29.9356
        Distance   6.315e+07  # method: V
        Radius      1.01e+04
        AbsMag        -17.93
        Axis    [  0.1370   0.0449  -0.9896]
        Angle    128.6733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3125"
}

Galaxy "NGC 3126:UGC 5466:MCG 5-24-19:ZWG 153.23"
{
        Type  "Sb"
        RA           10.1389
        Dec          31.8636
        Distance   2.468e+08  # method: V
        Radius     1.005e+05
        AbsMag        -20.89
        Axis    [ -0.3692   0.8799   0.2991]
        Angle     44.3633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3126"
}

Galaxy "NGC 3127:MCG 3-26-22"
{
        Type  "Sb"
        RA           10.1067
        Dec         -16.1261
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.8731   0.4472  -0.1941]
        Angle     69.6445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3127"
}

Galaxy "NGC 3128:MCG 3-26-20"
{
        Type  "Sb"
        RA           10.1003
        Dec         -16.1228
        Distance   2.253e+08  # method: V
        Radius     5.243e+04
        AbsMag         -19.9
        Axis    [ -0.7163   0.1811  -0.6739]
        Angle     77.5238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3128"
}

Galaxy "NGC 3130:UGC 5468:MCG 2-26-26:ZWG 64.72"
{
        Type  "Sa"
        RA           10.1367
        Dec           9.9767
        Distance   3.867e+08  # method: V
        Radius     5.624e+04
        AbsMag        -21.07
        Axis    [  0.9961   0.0297  -0.0830]
        Angle     82.8514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3130"
}

Galaxy "NGC 3131:UGC 5471:MCG 3-26-33:ZWG 93.60"
{
        Type  "SBb"
        RA           10.1433
        Dec          18.2311
        Distance   2.454e+08  # method: V
        Radius     8.564e+04
        AbsMag        -20.48
        Axis    [  0.9082   0.3603   0.2131]
        Angle     60.6686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3131"
}

Galaxy "NGC 3133"
{
        Type  "Sb"
        RA           10.1200
        Dec         -11.9653
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.9657   0.0970  -0.2407]
        Angle     99.1824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3133"
}

Galaxy "NGC 3134:MCG 2-26-31:ZWG 64.88:"
{
        Type  "S0"
        RA           10.2081
        Dec          12.3769
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.9182   0.3563   0.1732]
        Angle     64.5114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3134"
}

Galaxy "NGC 3135:UGC 5486:MCG 8-19-7:ZWG 240.15"
{
        Type  "Sc"
        RA           10.1817
        Dec          45.9506
        Distance   3.389e+08  # method: V
        Radius     4.437e+04
        AbsMag        -20.68
        Axis    [  0.5903   0.8038   0.0741]
        Angle     35.4666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3135"
}

Galaxy "NGC 3136:ESO 92-8"
{
        Type  "E0"
        RA           10.0967
        Dec         -67.3775
        Distance   8.006e+07  # method: S
        Radius      3.61e+04
        AbsMag        -20.25
        Axis    [  0.7094  -0.1949  -0.6774]
        Angle    174.7481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3136"
}

Galaxy "NGC 3136A:ESO 92-7:FGCE 794:AM 1002-671"
{
        Type  "Irr"
        RA           10.0592
        Dec         -67.4489
        Distance   4.571e+08  # distance uncertain!
        Radius      1.33e+05
        AbsMag        -20.13
        Axis    [  0.5145   0.1934  -0.8354]
        Angle     84.5110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3136A"
}

Galaxy "NGC 3136B:ESO 92-13:AM 1007-664"
{
        Type  "E0"
        RA           10.1703
        Dec         -67.0050
        Distance   6.941e+07  # method: S
        Radius     1.413e+04
        AbsMag        -18.84
        Axis    [  0.7029  -0.1988  -0.6829]
        Angle    174.2943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3136B"
}

Galaxy "NGC 3137:ESO 435-47:MCG 5-24-24:UGCA 203"
{
        Type  "SBc"
        RA           10.1519
        Dec         -29.0636
        Distance   5.649e+07  # method: T-F
        Radius     5.094e+04
        AbsMag        -18.99
        Axis    [  0.9557   0.2500  -0.1552]
        Angle    125.3650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3137"
}

Galaxy "NGC 3138:MCG 2-26-32"
{
        Type  "Sc"
        RA           10.1544
        Dec         -11.9572
        Distance   3.722e+08  # method: T-F
        Radius     6.497e+04
        AbsMag        -19.69
        Axis    [  0.7371   0.4300  -0.5213]
        Angle     52.2902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3138"
}

Galaxy "NGC 3139:MCG 2-26-34:NPM 1"
{
        Type  "S0"
        RA           10.1681
        Dec         -11.7778
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [  0.6092   0.0597  -0.7908]
        Angle     84.2143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3139"
}

Galaxy "NGC 3140:MCG 3-26-28"
{
        Type  "Sc"
        RA           10.1575
        Dec         -16.6278
        Distance   3.985e+08  # method: V
        Radius     5.217e+04
        AbsMag        -20.53
        Axis    [  0.8205  -0.0841  -0.5655]
        Angle    104.1322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3140"
}

Galaxy "NGC 3141:NPM 1"
{
        Type  "Sc"
        RA           10.1553
        Dec         -16.6531
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.9557   0.1514  -0.2525]
        Angle     99.8283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3141"
}

Galaxy "NGC 3142:MCG 1-26-28"
{
        Type  "S0"
        RA           10.1683
        Dec          -8.4794
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.9406  -0.2303  -0.2494]
        Angle    120.4206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3142"
}

Galaxy "NGC 3143:MCG 2-26-33"
{
        Type  "SBb"
        RA           10.1675
        Dec         -12.5819
        Distance   1.757e+08  # method: V
        Radius       2.3e+04
        AbsMag        -18.56
        Axis    [  0.2795   0.2276  -0.9328]
        Angle     71.8575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3143"
}

Galaxy "NGC 3145:MCG 2-26-36"
{
        Type  "SBc"
        RA           10.1692
        Dec         -12.4344
        Distance   1.797e+08  # method: T-F
        Radius     7.841e+04
        AbsMag         -21.2
        Axis    [  0.9773   0.0992  -0.1870]
        Angle    104.3697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3145"
}

Galaxy "NGC 3146:ESO 567-23:MCG 3-26-29"
{
        Type  "SBb"
        RA           10.1858
        Dec         -20.8708
        Distance   1.341e+08  # distance uncertain!
        Radius      1.95e+04
        AbsMag        -19.07
        Axis    [  0.3058   0.0974  -0.9471]
        Angle     91.6651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3146"
}

Galaxy "NGC 3147:UGC 5532:MCG 12-10-25:ZWG 333.22"
{
        Type  "Sc"
        RA           10.2814
        Dec          73.4003
        Distance   1.302e+08  # method: V
        Radius     7.388e+04
        AbsMag        -21.61
        Axis    [ -0.1178   0.9841  -0.1330]
        Angle     84.8658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3147"
}

Galaxy "NGC 3149:ESO 19-1:IRAS 10043-8010"
{
        Type  "Sb"
        RA           10.0619
        Dec         -80.4222
        Distance    8.86e+07  # distance uncertain!
        Radius     2.577e+04
        AbsMag        -19.07
        Axis    [  0.8675   0.0187  -0.4970]
        Angle    181.2779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3149"
}

Galaxy "NGC 3150:MCG 7-21-17:ZWG 211.19"
{
        Type  "S0"
        RA           10.2239
        Dec          38.6581
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.3683   0.8012  -0.4717]
        Angle     95.1133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3150"
}

Galaxy "NGC 3151:MCG 7-21-18:ZWG 211.20"
{
        Type  "S0"
        RA           10.2247
        Dec          38.6203
        Distance   3.346e+08  # method: V
        Radius     3.893e+04
        AbsMag        -19.96
        Axis    [ -0.6180   0.7577  -0.2098]
        Angle     79.1809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3151"
}

Galaxy "NGC 3152:MCG 7-21-18A:ZWG 211.21"
{
        Type  "S0"
        RA           10.2261
        Dec          38.8436
        Distance   3.042e+08  # method: V
        Radius      3.54e+04
        AbsMag        -19.25
        Axis    [  0.8600   0.2723  -0.4317]
        Angle     43.2608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3152"
}

Galaxy "NGC 3153:UGC 5505:MCG 2-26-32:ZWG 64.90"
{
        Type  "Sc"
        RA           10.2139
        Dec          12.6667
        Distance    1.16e+08  # method: T-F
        Radius     3.542e+04
        AbsMag        -19.25
        Axis    [ -0.7363   0.5185  -0.4348]
        Angle     72.3362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3153"
}

Galaxy "NGC 3154:UGC 5507:MCG 3-26-40:ZWG 93.71"
{
        Type  "Sb"
        RA           10.2169
        Dec          17.0344
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [ -0.2137   0.8575  -0.4681]
        Angle     39.1957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3154"
}

Galaxy "NGC 3155:NGC 3194:UGC 5538:MCG 12-10-26"
{
        Type  "S0"
        RA           10.2942
        Dec          74.3478
        Distance    1.36e+08  # method: V
        Radius     1.978e+04
        AbsMag         -19.3
        Axis    [  0.6173  -0.0613   0.7843]
        Angle     69.5146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3155"
}

Galaxy "NGC 3156:UGC 5503:MCG 1-26-19:ZWG 36.57"
{
        Type  "S0"
        RA           10.2114
        Dec           3.1297
        Distance   7.302e+07  # method: S
        Radius     2.018e+04
        AbsMag        -18.65
        Axis    [  0.9657   0.1968  -0.1695]
        Angle     71.1018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3156"
}

Galaxy "NGC 3157:IC 2555:ESO 435-51:MCG 5-24-26"
{
        Type  "SBc"
        RA           10.1950
        Dec         -31.6428
        Distance   1.191e+08  # method: T-F
        Radius     4.329e+04
        AbsMag        -18.91
        Axis    [  0.8731   0.3976  -0.2822]
        Angle     91.0082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3157"
}

Galaxy "NGC 3158:UGC 5511:MCG 7-21-20:ZWG 211.22"
{
        Type  "E3"
        RA           10.2306
        Dec          38.7656
        Distance   2.705e+08  # method: T-F
        Radius     7.869e+04
        AbsMag        -21.69
        Axis    [  0.7003  -0.6930  -0.1715]
        Angle     94.8969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3158"
}

Galaxy "NGC 3159:MCG 7-21-21:ZWG 211.23:NPM 1"
{
        Type  "E2"
        RA           10.2311
        Dec          38.6550
        Distance   3.245e+08  # method: V
        Radius     5.663e+04
        AbsMag        -20.39
        Axis    [ -0.0217   0.7219  -0.6916]
        Angle    100.4485
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3159"
}

Galaxy "NGC 3160:UGC 5513:MCG 7-21-23:ZWG 211.24"
{
        Type  "S0"
        RA           10.2319
        Dec          38.8428
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [ -0.5739   0.7907   0.2132]
        Angle     56.7949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3160"
}

Galaxy "NGC 3161:MCG 7-21-22:ZWG 211.25:ARAK 234"
{
        Type  "E2"
        RA           10.2331
        Dec          38.6578
        Distance   2.907e+08  # method: V
        Radius     3.382e+04
        AbsMag        -19.25
        Axis    [  0.7051  -0.6841  -0.1863]
        Angle     93.6168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3161"
}

Galaxy "NGC 3162:NGC 3575:UGC 5510:MCG 4-24-19"
{
        Type  "SBc"
        RA           10.2253
        Dec          22.7372
        Distance   7.266e+07  # method: V
        Radius     3.276e+04
        AbsMag        -19.54
        Axis    [  0.9484  -0.2189  -0.2295]
        Angle     76.5948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3162"
}

Galaxy "NGC 3163:UGC 5517:MCG 7-21-26:ZWG 211.27"
{
        Type  "S0"
        RA           10.2353
        Dec          38.6528
        Distance    2.92e+08  # method: V
        Radius     5.096e+04
        AbsMag        -20.46
        Axis    [  0.9284  -0.3533  -0.1152]
        Angle     69.2516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3163"
}

Galaxy "NGC 3164:UGC 5527:MCG 10-15-36:ZWG 290.18"
{
        Type  "S0"
        RA           10.2531
        Dec          56.6722
        Distance   3.598e+08  # method: V
        Radius      4.71e+04
        AbsMag        -20.71
        Axis    [  0.8089  -0.4875   0.3286]
        Angle     89.2301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3164"
}

Galaxy "NGC 3165:UGC 5512:MCG 1-26-23:ZWG 36.63"
{
        Type  "Irr"
        RA           10.2253
        Dec           3.3750
        Distance   7.579e+07  # method: V
        Radius     1.433e+04
        AbsMag        -17.33
        Axis    [ -0.7145   0.4205  -0.5591]
        Angle     81.4060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3165"
}

Galaxy "NGC 3166:UGC 5516:MCG 1-26-24:ZWG 36.64"
{
        Type  "SBa"
        RA           10.2292
        Dec           3.4258
        Distance   7.638e+07  # method: V
        Radius     5.332e+04
        AbsMag        -20.45
        Axis    [  0.6859   0.4852  -0.5423]
        Angle     44.2177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3166"
}

Galaxy "NGC 3168:UGC 5536:MCG 10-15-52:ZWG 290.23"
{
        Type  "E0"
        RA           10.2731
        Dec          60.2350
        Distance   4.319e+08  # method: V
        Radius     6.282e+04
        AbsMag        -21.21
        Axis    [  0.7899  -0.4641  -0.4009]
        Angle     50.9059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3168"
}

Galaxy "NGC 3169:UGC 5525:MCG 1-26-26:ZWG 36.66"
{
        Type  "Sa"
        RA           10.2372
        Dec           3.4669
        Distance   7.135e+07  # method: V
        Radius     4.358e+04
        AbsMag         -20.5
        Axis    [  0.9427   0.0382  -0.3314]
        Angle     76.5011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3169"
}

Galaxy "NGC 3171:ESO 567-31:MCG 3-26-32:NPM 1"
{
        Type  "S0"
        RA           10.2600
        Dec         -20.6475
        Distance   1.724e+08  # method: V
        Radius     4.012e+04
        AbsMag        -19.72
        Axis    [ -0.6149   0.1978  -0.7634]
        Angle     91.6414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3171"
}

Galaxy "NGC 3172:MCG 15-1-11:ZWG 370.8:ZWG 370.2"
{
        Type  "S0"
        RA           11.7872
        Dec          89.0936
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.5417  -0.4495   0.7103]
        Angle     77.5616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3172"
}

Galaxy "NGC 3173:ESO 500-16:MCG 4-24-22:AM 1012-272"
{
        Type  "Sc"
        RA           10.2431
        Dec         -27.6933
        Distance   1.279e+08  # method: V
        Radius     3.907e+04
        AbsMag        -19.37
        Axis    [  0.9388  -0.0624  -0.3387]
        Angle    128.5704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3173"
}

Galaxy "NGC 3174:NGC 3144:UGC 5519:MCG 12-10-23"
{
        Type  "SBa"
        RA           10.2589
        Dec          74.2206
        Distance   2.946e+08  # method: V
        Radius     5.142e+04
        AbsMag        -20.48
        Axis    [  0.6919  -0.4052   0.5976]
        Angle     90.5235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3174"
}

Galaxy "NGC 3175:ESO 436-3:MCG 5-24-28:UGCA 207"
{
        Type  "SBb"
        RA           10.2450
        Dec         -28.8711
        Distance   5.037e+07  # method: T-F
        Radius     3.737e+04
        AbsMag        -18.84
        Axis    [  0.8343   0.3464  -0.4288]
        Angle     76.3049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3175"
}

Galaxy "NGC 3177:UGC 5544:MCG 4-24-23:ZWG 123.32"
{
        Type  "Sc"
        RA           10.2761
        Dec          21.1231
        Distance   7.293e+07  # method: V
        Radius     1.591e+04
        AbsMag        -18.75
        Axis    [ -0.1599   0.6793  -0.7163]
        Angle     61.6585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3177"
}

Galaxy "NGC 3178:MCG 3-26-34"
{
        Type  "Sc"
        RA           10.2692
        Dec         -15.7911
        Distance   1.731e+08  # method: V
        Radius     3.526e+04
        AbsMag        -20.22
        Axis    [  0.7686   0.2360  -0.5946]
        Angle     66.9343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3178"
}

Galaxy "NGC 3179:UGC 5555:MCG 7-21-36:ZWG 211.37"
{
        Type  "S0"
        RA           10.2992
        Dec          41.1147
        Distance   3.395e+08  # method: V
        Radius     8.889e+04
        AbsMag        -20.99
        Axis    [  0.7963   0.2131   0.5660]
        Angle     66.7490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3179"
}

Galaxy "NGC 3182:UGC 5568:MCG 10-15-62:ZWG 290.27"
{
        Type  "Sa"
        RA           10.3258
        Dec          58.2061
        Distance   1.033e+08  # method: V
        Radius     2.705e+04
        AbsMag         -19.6
        Axis    [ -0.2406   0.9411  -0.2378]
        Angle     78.7191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3182"
}

Galaxy "NGC 3184:UGC 5557:MCG 7-21-37:ZWG 211.38"
{
        Type  "SBc"
        RA           10.3047
        Dec          41.4233
        Distance   3.742e+07  # method: V
        Radius     4.027e+04
        AbsMag           -20
        Axis    [ -0.0205   0.7968  -0.6038]
        Angle     67.0365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3184"
}

Galaxy "NGC 3185:UGC 5554:MCG 4-24-24:ZWG 123.34"
{
        Type  "SBa"
        RA           10.2939
        Dec          21.6886
        Distance   6.972e+07  # method: V
        Radius     2.129e+04
        AbsMag        -18.75
        Axis    [ -0.1865   0.7629  -0.6190]
        Angle     50.2848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3185"
}

Galaxy "NGC 3186-1:MCG 1-26-28:ZWG 36.74:NPM 1"
{
        Type  "E0"
        RA           10.2647
        Dec           6.9644
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.7887  -0.5335  -0.3055]
        Angle    118.9868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3186-1"
}

Galaxy "NGC 3186-2"
{
        Type  "E0"
        RA           10.2644
        Dec           6.9594
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.7887  -0.5335  -0.3055]
        Angle    118.9892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3186-2"
}

Galaxy "NGC 3187:UGC 5556:MCG 4-24-25:ZWG 123.36"
{
        Type  "SBc"
        RA           10.2964
        Dec          21.8739
        Distance   8.544e+07  # method: V
        Radius     4.474e+04
        AbsMag        -18.49
        Axis    [  0.9603   0.2636   0.0917]
        Angle     55.2611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3187"
}

Galaxy "NGC 3188:UGC 5569:MCG 10-15-65:MK 31"
{
        Type  "SBb"
        RA           10.3283
        Dec          57.4231
        Distance    3.59e+08  # method: V
        Radius     4.177e+04
        AbsMag        -20.61
        Axis    [ -0.3809   0.9051  -0.1891]
        Angle     88.4533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3188"
}

Galaxy "NGC 3188A:MCG 10-15-64:MK 30:KUG 1016+576"
{
        Type  "S0"
        RA           10.3272
        Dec          57.4186
        Distance   3.674e+08  # method: V
        Radius     2.137e+04
        AbsMag        -17.76
        Axis    [  0.5441   0.5120   0.6647]
        Angle     45.0229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3188A"
}

Galaxy "NGC 3190:UGC 5559:MCG 4-24-26:ARP 316"
{
        Type  "Sa"
        RA           10.3014
        Dec          21.8328
        Distance   7.434e+07  # method: V
        Radius     4.757e+04
        AbsMag        -19.79
        Axis    [ -0.3307   0.9274  -0.1748]
        Angle     36.8744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3190"
}

Galaxy "NGC 3192:NGC 3191:UGC 5565:MCG 8-19-18"
{
        Type  "SBc"
        RA           10.3181
        Dec          46.4550
        Distance   4.239e+08  # method: V
        Radius     4.932e+04
        AbsMag        -21.57
        Axis    [  0.8819  -0.3990   0.2512]
        Angle     88.8611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3192"
}

Galaxy "NGC 3193:UGC 5562:MCG 4-24-27:ZWG 123.38"
{
        Type  "E2"
        RA           10.3067
        Dec          21.8939
        Distance    1.11e+08  # method: S
        Radius      3.23e+04
        AbsMag        -20.86
        Axis    [  0.7499  -0.6119  -0.2514]
        Angle    107.7462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3193"
}

Galaxy "NGC 3196:ZWG 153.35:ZWG 154.1:NPM 1"
{
        Type  "S0"
        RA           10.3136
        Dec          27.6694
        Distance   3.217e+08  # distance uncertain!
        Radius     1.404e+04
        AbsMag        -19.07
        Axis    [  0.0892   0.8438  -0.5292]
        Angle     40.9595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3196"
}

Galaxy "NGC 3197:UGC 5500:MCG 13-8-9:ZWG 351.10"
{
        Type  "Sc"
        RA           10.2408
        Dec          77.8203
        Distance    3.68e+08  # method: V
        Radius     6.959e+04
        AbsMag        -20.96
        Axis    [ -0.2228   0.9738   0.0447]
        Angle     86.5438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3197"
}

Galaxy "NGC 3198:UGC 5572:MCG 8-19-20:ZWG 240.30"
{
        Type  "SBc"
        RA           10.3317
        Dec          45.5500
        Distance   5.151e+07  # method: T-F
        Radius     6.368e+04
        AbsMag        -20.09
        Axis    [  0.8599   0.0245   0.5099]
        Angle     73.0605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3198"
}

Galaxy "NGC 3200:ESO 567-45:MCG 3-26-37:UGCA 210"
{
        Type  "SBc"
        RA           10.3100
        Dec         -17.9822
        Distance   1.847e+08  # method: T-F
        Radius     1.128e+05
        AbsMag        -20.86
        Axis    [ -0.7640   0.1044  -0.6367]
        Angle     65.8553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3200"
}

Galaxy "NGC 3202:UGC 5581:MCG 7-21-41:ZWG 211.44"
{
        Type  "SBa"
        RA           10.3419
        Dec          43.0214
        Distance   3.146e+08  # method: V
        Radius      5.49e+04
        AbsMag        -20.82
        Axis    [  0.9323  -0.2451   0.2659]
        Angle     78.3228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3202"
}

Galaxy "NGC 3203:ESO 500-24:MCG 4-25-2"
{
        Type  "Sa"
        RA           10.3258
        Dec         -26.6989
        Distance   1.232e+08  # method: V
        Radius     5.018e+04
        AbsMag        -19.79
        Axis    [  0.8432   0.3816  -0.3787]
        Angle     70.9131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3203"
}

Galaxy "NGC 3204:UGC 5580:MCG 5-25-1:ZWG 154.3"
{
        Type  "SBb"
        RA           10.3364
        Dec          27.8172
        Distance   2.382e+08  # method: V
        Radius     4.504e+04
        AbsMag        -19.72
        Axis    [  0.2154   0.8028  -0.5559]
        Angle     39.7586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3204"
}

Galaxy "NGC 3205:UGC 5585:MCG 7-21-42:ZWG 211.46"
{
        Type  "Irr"
        RA           10.3472
        Dec          42.9717
        Distance   3.291e+08  # method: V
        Radius     6.701e+04
        AbsMag        -20.82
        Axis    [ -0.4036   0.8385  -0.3662]
        Angle     83.6755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3205"
}

Galaxy "NGC 3206:UGC 5589:MCG 10-15-69:ZWG 290.30"
{
        Type  "SBc"
        RA           10.3631
        Dec          56.9308
        Distance   5.971e+07  # method: V
        Radius     2.518e+04
        AbsMag        -18.71
        Axis    [  0.8179  -0.4131   0.4004]
        Angle     93.9521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3206"
}

Galaxy "NGC 3207:UGC 5587:MCG 7-21-43:ZWG 211.47"
{
        Type  "Irr"
        RA           10.3500
        Dec          42.9858
        Distance   3.271e+08  # method: V
        Radius     6.185e+04
        AbsMag        -20.31
        Axis    [  0.4539   0.8888   0.0637]
        Angle     33.9167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3207"
}

Galaxy "NGC 3208:ESO 500-25:MCG 4-25-3:AM 1017-253"
{
        Type  "SBc"
        RA           10.3281
        Dec         -25.8144
        Distance   1.461e+08  # method: V
        Radius     3.826e+04
        AbsMag        -19.86
        Axis    [  0.8771  -0.1300  -0.4624]
        Angle    122.7426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3208"
}

Galaxy "NGC 3209:UGC 5584:MCG 4-25-2:ZWG 124.3"
{
        Type  "E0"
        RA           10.3439
        Dec          25.5047
        Distance   2.942e+08  # method: V
        Radius     5.562e+04
        AbsMag        -21.08
        Axis    [  0.5316   0.0058  -0.8470]
        Angle     75.8652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3209"
}

Galaxy "NGC 3212:UGC 5643:MCG 13-8-21:ZWG 350.54"
{
        Type  "SBb"
        RA           10.4711
        Dec          79.8239
        Distance   4.437e+08  # method: V
        Radius     9.681e+04
        AbsMag        -21.17
        Axis    [  0.3069   0.6759   0.6701]
        Angle     45.5834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3212"
}

Galaxy "NGC 3213:UGC 5590:MCG 3-27-4:ZWG 94.8"
{
        Type  "Sc"
        RA           10.3547
        Dec          19.6517
        Distance   7.538e+07  # method: V
        Radius     1.096e+04
        AbsMag        -17.52
        Axis    [ -0.1401   0.6542  -0.7432]
        Angle     59.8318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3213"
}

Galaxy "NGC 3214:MCG 10-15-71:ZWG 290.32"
{
        Type  "Sa"
        RA           10.3856
        Dec          57.0389
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.7755  -0.0151   0.6311]
        Angle     70.0328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3214"
}

Galaxy "NGC 3215:UGC 5659:MCG 13-8-22:ZWG 351.24"
{
        Type  "Sc"
        RA           10.4778
        Dec          79.8125
        Distance     4.3e+08  # method: V
        Radius      6.88e+04
        AbsMag         -21.6
        Axis    [  0.8020  -0.2369   0.5483]
        Angle     39.6967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3215"
}

Galaxy "NGC 3216:UGC 5593:MCG 4-25-7:ZWG 124.8"
{
        Type  "E0"
        RA           10.3614
        Dec          23.9233
        Distance    3.02e+08  # distance uncertain!
        Radius     5.711e+04
        AbsMag        -20.13
        Axis    [  0.7388  -0.6278  -0.2450]
        Angle    106.6213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3216"
}

Galaxy "NGC 3217:IC 606:MCG 2-27-6:MK 721"
{
        Type  "Sc"
        RA           10.3922
        Dec          10.9597
        Distance   4.439e+08  # method: V
        Radius     3.228e+04
        AbsMag        -20.37
        Axis    [  0.9959  -0.0218  -0.0878]
        Angle     82.2093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3217"
}

Galaxy "NGC 3218:NGC 3183:UGC 5582:MCG 12-10-28"
{
        Type  "SBc"
        RA           10.3633
        Dec          74.1772
        Distance   1.426e+08  # method: V
        Radius     4.771e+04
        AbsMag         -20.6
        Axis    [ -0.3688   0.9230   0.1097]
        Angle     89.1042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3218"
}

Galaxy "NGC 3219:MCG 7-21-51:ZWG 211.49:NPM 1"
{
        Type  "S0"
        RA           10.3769
        Dec          38.5797
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [  0.9708   0.1708   0.1684]
        Angle     47.3742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3219"
}

Galaxy "NGC 3220:IC 604:UGC 5614:MCG 10-15-73"
{
        Type  "Sb"
        RA           10.3956
        Dec          57.0267
        Distance    6.12e+07  # method: V
        Radius     1.157e+04
        AbsMag        -17.47
        Axis    [  0.1657   0.7206   0.6732]
        Angle     47.9261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3220"
}

Galaxy "NGC 3221:UGC 5601:MCG 4-25-13:ZWG 124.17"
{
        Type  "SBc"
        RA           10.3722
        Dec          21.5689
        Distance       2e+08  # method: V
        Radius     9.018e+04
        AbsMag        -19.84
        Axis    [ -0.8431   0.5242  -0.1202]
        Angle     66.1771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3221"
}

Galaxy "NGC 3222:UGC 5610:MCG 3-27-11:ZWG 94.18"
{
        Type  "S0"
        RA           10.3761
        Dec          19.8867
        Distance   2.672e+08  # method: V
        Radius     4.664e+04
        AbsMag        -20.57
        Axis    [  0.9266  -0.0805  -0.3674]
        Angle     65.3932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3222"
}

Galaxy "NGC 3223:IC 2571:ESO 375-12:MCG 6-23-23"
{
        Type  "Sb"
        RA           10.3594
        Dec         -34.2669
        Distance   1.223e+08  # method: T-F
        Radius     7.294e+04
        AbsMag        -21.07
        Axis    [ -0.1648   0.0656  -0.9841]
        Angle     79.2809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3223"
}

Galaxy "NGC 3224:ESO 375-13:MCG 6-23-24"
{
        Type  "E0"
        RA           10.3614
        Dec         -34.6961
        Distance   1.538e+08  # method: V
        Radius     4.249e+04
        AbsMag        -21.07
        Axis    [ -0.0662   0.0822  -0.9944]
        Angle    132.0342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3224"
}

Galaxy "NGC 3225:UGC 5631:MCG 10-15-77:ZWG 290.37"
{
        Type  "Sc"
        RA           10.4192
        Dec          58.1497
        Distance   1.411e+08  # method: T-F
        Radius     4.103e+04
        AbsMag        -19.88
        Axis    [ -0.4730   0.8778   0.0753]
        Angle     75.1080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3225"
}

Galaxy "NGC 3226:UGC 5617:MCG 3-27-15:ZWG 94.26"
{
        Type  "E2"
        RA           10.3906
        Dec          19.8975
        Distance   7.681e+07  # method: S
        Radius     3.128e+04
        AbsMag        -19.46
        Axis    [  0.7354  -0.4637  -0.4941]
        Angle     94.0707
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3226"
}

Galaxy "NGC 3227:UGC 5620:MCG 3-27-16:ZWG 94.28"
{
        Type  "SBa"
        RA           10.3917
        Dec          19.8653
        Distance   6.668e+07  # method: V
        Radius     3.976e+04
        AbsMag        -20.25
        Axis    [ -0.1900   0.6083  -0.7706]
        Angle     84.5723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3227"
}

Galaxy "NGC 3230:UGC 5624:MCG 2-27-7:ZWG 65.20"
{
        Type  "S0"
        RA           10.3956
        Dec          12.5675
        Distance    1.54e+08  # distance uncertain!
        Radius     5.151e+04
        AbsMag        -19.07
        Axis    [  0.0393   0.7872  -0.6155]
        Angle     34.7983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3230"
}

Galaxy "NGC 3232:MCG 5-25-4:ZWG 154.8"
{
        Type  "SBa"
        RA           10.4067
        Dec          28.0283
        Distance   2.959e+08  # method: V
        Radius     3.443e+04
        AbsMag        -19.49
        Axis    [  0.7418  -0.6373  -0.2088]
        Angle    103.3025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3232"
}

Galaxy "NGC 3233:ESO 568-1:MCG 4-25-4:AM 1019-220"
{
        Type  "SBa"
        RA           10.3658
        Dec         -22.2678
        Distance   1.828e+08  # method: V
        Radius     4.787e+04
        AbsMag        -20.24
        Axis    [ -0.3234   0.1804  -0.9289]
        Angle     61.1357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3233"
}

Galaxy "NGC 3234:NGC 3235:UGC 5635:MCG 5-25-7"
{
        Type  "S0"
        RA           10.4164
        Dec          28.0242
        Distance   3.035e+08  # method: V
        Radius     5.297e+04
        AbsMag        -20.34
        Axis    [  0.7601   0.4307  -0.4866]
        Angle     40.0420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3234"
}

Galaxy "NGC 3236:MCG 10-15-81:ZWG 290.40:NPM 1"
{
        Type  "E0"
        RA           10.4467
        Dec          61.2733
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.7793  -0.4709  -0.4135]
        Angle     49.3309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3236"
}

Galaxy "NGC 3237:UGC 5640:MCG 7-22-3:ZWG 212.7"
{
        Type  "S0"
        RA           10.4286
        Dec          39.6472
        Distance   3.318e+08  # method: V
        Radius     6.273e+04
        AbsMag        -21.04
        Axis    [  0.6970  -0.7015  -0.1485]
        Angle     95.5292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3237"
}

Galaxy "NGC 3238:UGC 5649:MCG 10-15-80:ZWG 290.41"
{
        Type  "S0"
        RA           10.4450
        Dec          57.2261
        Distance    3.41e+08  # method: V
        Radius     6.943e+04
        AbsMag         -20.9
        Axis    [  0.0354   0.9227  -0.3838]
        Angle     60.6075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3238"
}

Galaxy "NGC 3239:UGC 5637:MCG 3-27-25:ZWG 94.38"
{
        Type  "Irr"
        RA           10.4181
        Dec          17.1603
        Distance    4.87e+07  # method: V
        Radius     3.187e+04
        AbsMag        -19.17
        Axis    [  0.8342   0.4579  -0.3075]
        Angle     40.0986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3239"
}

Galaxy "NGC 3240:ESO 568-3:MCG 4-25-7:IRAS 10221-2132"
{
        Type  "Sc"
        RA           10.4083
        Dec         -21.7914
        Distance   1.951e+08  # method: V
        Radius     3.122e+04
        AbsMag        -19.98
        Axis    [  0.5081  -0.0159  -0.8612]
        Angle     95.8735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3240"
}

Galaxy "NGC 3241:ESO 436-16:MCG 5-25-2:IRAS 10220-3213"
{
        Type  "SBb"
        RA           10.4047
        Dec         -32.4833
        Distance   1.431e+08  # method: V
        Radius     4.994e+04
        AbsMag        -20.31
        Axis    [ -0.0075   0.0807  -0.9967]
        Angle     76.8772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3241"
}

Galaxy "NGC 3243:UGC 5652:MCG 0-27-12:ZWG 9.33"
{
        Type  "S0"
        RA           10.4392
        Dec          -2.6222
        Distance   2.669e+08  # method: V
        Radius     5.434e+04
        AbsMag        -20.76
        Axis    [ -0.0344   0.3527  -0.9351]
        Angle     65.1645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3243"
}

Galaxy "NGC 3244:ESO 317-24:MCG 7-22-5:IRAS 10232-3934"
{
        Type  "Sc"
        RA           10.4244
        Dec         -39.8278
        Distance   8.702e+07  # method: T-F
        Radius     2.658e+04
        AbsMag        -19.13
        Axis    [ -0.4890   0.0585  -0.8703]
        Angle    108.9210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3244"
}

Galaxy "NGC 3245:UGC 5663:MCG 5-25-13:ZWG 154.17"
{
        Type  "S0"
        RA           10.4550
        Dec          28.5078
        Distance   6.815e+07  # method: S
        Radius     3.172e+04
        AbsMag         -19.9
        Axis    [ -0.6735   0.6601  -0.3326]
        Angle     82.8646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3245"
}

Galaxy "NGC 3245A:UGC 5662:MCG 5-25-12:ZWG 154.16"
{
        Type  "SBb"
        RA           10.4503
        Dec          28.6392
        Distance   7.316e+07  # method: V
        Radius     3.724e+04
        AbsMag        -16.65
        Axis    [ -0.7426   0.6607   0.1096]
        Angle     55.3647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3245A"
}

Galaxy "NGC 3246:UGC 5661:MCG 1-27-9:ZWG 37.37"
{
        Type  "Irr"
        RA           10.4447
        Dec           3.8625
        Distance   1.131e+08  # method: V
        Radius     3.947e+04
        AbsMag         -19.2
        Axis    [  0.4313   0.4551  -0.7790]
        Angle     43.0117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3246"
}

Galaxy "NGC 3248:UGC 5669:MCG 4-25-20:ZWG 124.24"
{
        Type  "S0"
        RA           10.4625
        Dec          22.8475
        Distance   1.115e+08  # distance uncertain!
        Radius     4.056e+04
        AbsMag        -19.07
        Axis    [ -0.4532   0.8319  -0.3202]
        Angle     43.1374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3248"
}

Galaxy "NGC 3249:ESO 375-24:MCG 6-23-28:IRAS 10240-3442"
{
        Type  "SBc"
        RA           10.4394
        Dec         -34.9639
        Distance   1.719e+08  # method: V
        Radius         4e+04
        AbsMag        -19.71
        Axis    [ -0.1934   0.0643  -0.9790]
        Angle     93.3592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3249"
}

Galaxy "NGC 3250:ESO 317-26:MCG 7-22-7"
{
        Type  "E4"
        RA           10.4422
        Dec         -39.9436
        Distance   1.391e+08  # method: S
        Radius     5.464e+04
        AbsMag        -20.95
        Axis    [ -0.2140   0.1015  -0.9715]
        Angle    136.7026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250"
}

Galaxy "NGC 3250A:ESO 317-30:IRAS 10257-3949"
{
        Type  "Sb"
        RA           10.4647
        Dec         -40.0811
        Distance   2.934e+08  # distance uncertain!
        Radius     4.694e+04
        AbsMag        -19.07
        Axis    [  0.5626   0.2550  -0.7865]
        Angle     55.4458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250A"
}

Galaxy "NGC 3250B:ESO 317-29:MCG 7-22-9:AM 1025-401"
{
        Type  "SBa"
        RA           10.4622
        Dec         -40.4356
        Distance   1.273e+08  # method: V
        Radius     4.073e+04
        AbsMag        -19.16
        Axis    [  0.9119   0.3157  -0.2623]
        Angle    123.4686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250B"
}

Galaxy "NGC 3250C:ESO 317-28:MCG 7-22-8:IRAS 10255-3944"
{
        Type  "Sb"
        RA           10.4617
        Dec         -40.0025
        Distance   1.389e+08  # method: V
        Radius     3.434e+04
        AbsMag        -18.85
        Axis    [  0.7781   0.2618  -0.5709]
        Angle     83.6839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250C"
}

Galaxy "NGC 3250D:ESO 317-31:MCG 7-22-11"
{
        Type  "S0"
        RA           10.4658
        Dec         -39.8153
        Distance   1.389e+08  # method: V
        Radius     3.434e+04
        AbsMag        -18.85
        Axis    [  0.8681   0.3696  -0.3314]
        Angle    100.9101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250D"
}

Galaxy "NGC 3250E:ESO 317-34:MCG 7-22-13:IRAS 10268-3949"
{
        Type  "SBc"
        RA           10.4833
        Dec         -40.0825
        Distance   1.389e+08  # method: V
        Radius     4.242e+04
        AbsMag        -19.95
        Axis    [ -0.2555  -0.0058  -0.9668]
        Angle     84.6641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3250E"
}

Galaxy "NGC 3251:IC 2579:UGC 5684:MCG 4-25-23"
{
        Type  "SBc"
        RA           10.4878
        Dec          26.0989
        Distance    2.44e+08  # method: V
        Radius     7.099e+04
        AbsMag        -20.17
        Axis    [  0.8251   0.3248   0.4623]
        Angle     62.4165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3251"
}

Galaxy "NGC 3252:UGC 5732:MCG 12-10-49:ZWG 333.39"
{
        Type  "SBc"
        RA           10.5728
        Dec          73.7639
        Distance   5.432e+07  # method: V
        Radius     1.501e+04
        AbsMag        -17.01
        Axis    [  0.6015  -0.0861   0.7942]
        Angle     85.1137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3252"
}

Galaxy "NGC 3253:UGC 5674:MCG 2-27-21:ZWG 65.43"
{
        Type  "SBc"
        RA           10.4742
        Dec          12.7039
        Distance    4.54e+08  # method: V
        Radius     7.924e+04
        AbsMag        -21.42
        Axis    [  0.8539  -0.2024  -0.4795]
        Angle     78.8554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3253"
}

Galaxy "NGC 3254:UGC 5685:MCG 5-25-18:ZWG 154.20"
{
        Type  "Sc"
        RA           10.4886
        Dec          29.4922
        Distance   1.208e+08  # method: T-F
        Radius     7.907e+04
        AbsMag        -20.44
        Axis    [  0.9136   0.1750   0.3671]
        Angle     65.8014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3254"
}

Galaxy "NGC 3256:ESO 263-38:MCG 7-22-10:VV 65"
{
        Type  "Sb"
        RA           10.4642
        Dec         -43.9053
        Distance   1.281e+08  # method: V
        Radius     7.081e+04
        AbsMag        -20.87
        Axis    [  0.4705   0.0696  -0.8797]
        Angle     84.7696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3256"
}

Galaxy "NGC 3256A:ESO 263-34:AM 1023-432"
{
        Type  "Irr"
        RA           10.4308
        Dec         -43.7475
        Distance   1.376e+08  # method: T-F
        Radius     2.601e+04
        AbsMag        -18.13
        Axis    [  0.4962   0.1085  -0.8614]
        Angle     79.0944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3256A"
}

Galaxy "NGC 3256B:ESO 263-39:MCG 7-22-14:IRAS 10268-4408"
{
        Type  "SBc"
        RA           10.4836
        Dec         -44.4033
        Distance    1.22e+08  # method: T-F
        Radius      3.37e+04
        AbsMag        -19.06
        Axis    [ -0.2093  -0.1075  -0.9719]
        Angle     57.0219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3256B"
}

Galaxy "NGC 3256C:ESO 263-41:MCG 7-22-16:FAIR 431"
{
        Type  "SBc"
        RA           10.4847
        Dec         -43.8503
        Distance   1.281e+08  # method: V
        Radius     3.168e+04
        AbsMag        -19.67
        Axis    [ -0.4283  -0.0413  -0.9027]
        Angle     94.4811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3256C"
}

Galaxy "NGC 3257:ESO 375-36:MCG 6-23-31"
{
        Type  "S0"
        RA           10.4797
        Dec         -35.6581
        Distance   1.121e+08  # method: S
        Radius      1.63e+04
        AbsMag        -18.58
        Axis    [  0.9140  -0.1397  -0.3808]
        Angle    142.1909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3257"
}

Galaxy "NGC 3258:ESO 375-37:MCG 6-23-32"
{
        Type  "E1"
        RA           10.4814
        Dec         -35.6050
        Distance   1.046e+08  # method: S
        Radius     4.411e+04
        AbsMag        -20.03
        Axis    [  0.4064  -0.1525  -0.9009]
        Angle    134.3385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258"
}

Galaxy "NGC 3258A:ESO 375-32:MCG 6-23-30"
{
        Type  "SBa"
        RA           10.4719
        Dec         -35.4547
        Distance   1.466e+08  # method: V
        Radius     2.345e+04
        AbsMag        -18.76
        Axis    [ -0.6285  -0.0642  -0.7752]
        Angle     78.1644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258A"
}

Galaxy "NGC 3258B"
{
        Type  "S0"
        RA           10.5069
        Dec         -35.5636
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.8310   0.2625  -0.4904]
        Angle     85.9172
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258B"
}

Galaxy "NGC 3258C:ESO 375-53:MCG 6-23-48"
{
        Type  "SBa"
        RA           10.5233
        Dec         -35.2200
        Distance   1.372e+08  # method: V
        Radius     2.195e+04
        AbsMag        -18.52
        Axis    [  0.7557   0.0150  -0.6548]
        Angle    105.0329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258C"
}

Galaxy "NGC 3258D:ESO 375-58:MCG 6-23-51"
{
        Type  "SBb"
        RA           10.5319
        Dec         -35.4103
        Distance   1.372e+08  # method: V
        Radius     3.193e+04
        AbsMag        -19.12
        Axis    [  0.9420   0.1086  -0.3177]
        Angle    127.5782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258D"
}

Galaxy "NGC 3258E:ESO 375-60:MCG 6-23-51B"
{
        Type  "Sb"
        RA           10.5400
        Dec         -34.9981
        Distance     8.1e+07  # method: T-F
        Radius     1.767e+04
        AbsMag        -16.57
        Axis    [  0.8918   0.3531  -0.2827]
        Angle     99.9319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3258E"
}

Galaxy "NGC 3259:UGC 5717:MCG 11-13-27:ZWG 313.21"
{
        Type  "SBc"
        RA           10.5428
        Dec          65.0411
        Distance   1.407e+08  # method: T-F
        Radius     3.479e+04
        AbsMag        -20.17
        Axis    [  0.7642  -0.2800   0.5811]
        Angle     82.4613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3259"
}

Galaxy "NGC 3260:ESO 375-40:MCG 6-23-33"
{
        Type  "E0"
        RA           10.4850
        Dec         -35.5958
        Distance   1.509e+08  # method: T-F
        Radius     2.634e+04
        AbsMag        -19.63
        Axis    [  0.8163  -0.3534  -0.4570]
        Angle    153.6077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3260"
}

Galaxy "NGC 3261:ESO 263-40:MCG 7-22-15:AM 1026-442"
{
        Type  "SBc"
        RA           10.4836
        Dec         -44.6575
        Distance   1.281e+08  # method: V
        Radius     6.522e+04
        AbsMag        -20.97
        Axis    [  0.4050  -0.0173  -0.9142]
        Angle    103.7912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3261"
}

Galaxy "NGC 3262:ESO 263-42:MCG 7-22-17"
{
        Type  "S0"
        RA           10.4850
        Dec         -44.1600
        Distance   1.409e+08  # method: V
        Radius     2.255e+04
        AbsMag        -18.98
        Axis    [  0.1837   0.0048  -0.9830]
        Angle     84.7648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3262"
}

Galaxy "NGC 3263:ESO 263-43:MCG 7-22-18:AM 1027-435"
{
        Type  "SBc"
        RA           10.4869
        Dec         -44.1228
        Distance   1.491e+08  # method: V
        Radius     6.507e+04
        AbsMag         -21.5
        Axis    [  0.3374   0.1120  -0.9347]
        Angle     55.9255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3263"
}

Galaxy "NGC 3264:UGC 5719:MCG 9-17-69:ZWG 266.54"
{
        Type  "Irr"
        RA           10.5386
        Dec          56.0839
        Distance   8.526e+07  # method: T-F
        Radius     3.596e+04
        AbsMag        -19.59
        Axis    [ -0.6282   0.7779   0.0165]
        Angle     91.0277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3264"
}

Galaxy "NGC 3265:UGC 5705:MCG 5-25-19:ZWG 154.23"
{
        Type  "E0"
        RA           10.5183
        Dec          28.7969
        Distance    7.86e+07  # method: V
        Radius     1.029e+04
        AbsMag        -17.81
        Axis    [  0.5793  -0.0999  -0.8089]
        Angle     72.3532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3265"
}

Galaxy "NGC 3266:UGC 5725:MCG 11-13-30:ZWG 313.22"
{
        Type  "S0"
        RA           10.5547
        Dec          64.7497
        Distance   1.065e+08  # distance uncertain!
        Radius     2.169e+04
        AbsMag        -19.07
        Axis    [  0.3533   0.9353   0.0195]
        Angle     37.9981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3266"
}

Galaxy "NGC 3267:ESO 375-42:MCG 6-23-36:AM 1027-350"
{
        Type  "S0"
        RA           10.4967
        Dec         -35.3228
        Distance   1.836e+08  # method: V
        Radius     4.539e+04
        AbsMag        -20.25
        Axis    [ -0.3644   0.0141  -0.9311]
        Angle     77.0771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3267"
}

Galaxy "NGC 3268:ESO 375-45:MCG 6-23-41:AM 1027-350"
{
        Type  "E2"
        RA           10.5000
        Dec         -35.3256
        Distance   1.136e+08  # method: S
        Radius     4.957e+04
        AbsMag        -20.21
        Axis    [  0.6052  -0.2499  -0.7558]
        Angle    139.9013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3268"
}

Galaxy "NGC 3269:ESO 375-44:MCG 6-23-40:AM 1027-350"
{
        Type  "SBa"
        RA           10.4992
        Dec         -35.2239
        Distance    1.86e+08  # method: V
        Radius     6.493e+04
        AbsMag        -20.58
        Axis    [  0.9378   0.1751  -0.2998]
        Angle    122.9020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3269"
}

Galaxy "NGC 3270:UGC 5711:MCG 4-25-29:ZWG 124.34"
{
        Type  "SBb"
        RA           10.5250
        Dec          24.8694
        Distance   2.975e+08  # method: V
        Radius     1.341e+05
        AbsMag           -21
        Axis    [  0.9500   0.0300   0.3107]
        Angle    100.2797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3270"
}

Galaxy "NGC 3271:IC 2585:ESO 375-48:MCG 6-23-44"
{
        Type  "S0"
        RA           10.5072
        Dec         -35.3600
        Distance   1.858e+08  # method: V
        Radius     8.917e+04
        AbsMag        -20.98
        Axis    [  0.2323   0.0734  -0.9699]
        Angle     70.3570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3271"
}

Galaxy "NGC 3273:ESO 375-49:MCG 6-23-45:AM 1027-350"
{
        Type  "S0"
        RA           10.5081
        Dec         -35.6111
        Distance   1.239e+08  # method: V
        Radius     2.883e+04
        AbsMag         -19.4
        Axis    [  0.3830   0.1183  -0.9161]
        Angle     65.3803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3273"
}

Galaxy "NGC 3274:UGC 5721:MCG 5-25-20:ZWG 154.24"
{
        Type  "SBc"
        RA           10.5381
        Dec          27.6689
        Distance   3.765e+07  # method: V
        Radius     1.095e+04
        AbsMag        -17.11
        Axis    [  0.4749   0.8408  -0.2599]
        Angle     30.4106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3274"
}

Galaxy "NGC 3275:ESO 375-50:MCG 6-23-46:AM 1028-362"
{
        Type  "SBb"
        RA           10.5142
        Dec         -36.7369
        Distance   1.592e+08  # method: V
        Radius     6.483e+04
        AbsMag        -21.24
        Axis    [  0.0111   0.0296  -0.9995]
        Angle     86.6374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3275"
}

Galaxy "NGC 3275A:ESO 375-46"
{
        Type  "Sa"
        RA           10.5011
        Dec         -36.6947
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.9147   0.2779  -0.2934]
        Angle    114.3833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3275A"
}

Galaxy "NGC 3276:ESO 317-40"
{
        Type  "S0"
        RA           10.5192
        Dec         -39.9450
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.5771   0.0702  -0.8137]
        Angle     88.4740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3276"
}

Galaxy "NGC 3277:UGC 5731:MCG 5-25-22:ZWG 154.26"
{
        Type  "Sb"
        RA           10.5486
        Dec          28.5122
        Distance   7.701e+07  # method: V
        Radius     2.352e+04
        AbsMag        -19.36
        Axis    [ -0.4289   0.7223  -0.5425]
        Angle     86.9250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3277"
}

Galaxy "NGC 3278:ESO 317-43:MCG 7-22-21:IRAS 10293-3941"
{
        Type  "Sc"
        RA           10.5264
        Dec         -39.9558
        Distance   8.461e+07  # distance uncertain!
        Radius       1.6e+04
        AbsMag        -19.07
        Axis    [  0.6507   0.0346  -0.7586]
        Angle     99.7831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3278"
}

Galaxy "NGC 3279:IC 622:UGC 5741:MCG 2-27-27"
{
        Type  "Sc"
        RA           10.5783
        Dec          11.1969
        Distance   7.842e+07  # method: V
        Radius     3.307e+04
        AbsMag         -17.9
        Axis    [ -0.8535   0.5029  -0.1368]
        Angle     46.9506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3279"
}

Galaxy "NGC 3280A:NGC 3295A:IC 617:MCG 2-27-6"
{
        Type  "S0"
        RA           10.5453
        Dec         -12.6367
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.1390   0.2552  -0.9569]
        Angle     65.9893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3280A"
}

Galaxy "NGC 3280B:NGC 3295B:MCG 2-27-7:NPM 1"
{
        Type  "S0"
        RA           10.5458
        Dec         -12.6367
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.6617   0.2436  -0.7091]
        Angle     78.2999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3280B"
}

Galaxy "NGC 3280C:NGC 3295:MCG 2-27-8:NPM 1"
{
        Type  "S0"
        RA           10.5461
        Dec         -12.6339
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8116  -0.4469  -0.3763]
        Angle    134.7494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3280C"
}

Galaxy "NGC 3281:ESO 375-55:MCG 6-23-50:AM 1029-343"
{
        Type  "Sb"
        RA           10.5311
        Dec         -34.8544
        Distance   2.572e+08  # method: V
        Radius     1.197e+05
        AbsMag        -21.78
        Axis    [ -0.2895   0.0097  -0.9571]
        Angle     68.0814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3281"
}

Galaxy "NGC 3281A:ESO 375-59:MCG 6-23-49"
{
        Type  "S0"
        RA           10.5328
        Dec         -35.1986
        Distance   1.176e+08  # method: V
        Radius     2.053e+04
        AbsMag        -18.39
        Axis    [ -0.0130   0.0371  -0.9992]
        Angle     93.3927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3281A"
}

Galaxy "NGC 3281B"
{
        Type  "S0"
        RA           10.5311
        Dec         -35.2053
        Distance   1.768e+08  # distance uncertain!
        Radius       1.8e+04
        AbsMag        -19.07
        Axis    [  0.7611  -0.0744  -0.6444]
        Angle    117.4526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3281B"
}

Galaxy "NGC 3281C:ESO 375-63:MCG 6-23-53"
{
        Type  "S0"
        RA           10.5497
        Dec         -34.8864
        Distance   2.572e+08  # method: V
        Radius     5.237e+04
        AbsMag        -20.18
        Axis    [ -0.6688  -0.1815  -0.7210]
        Angle     57.0737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3281C"
}

Galaxy "NGC 3281D:ESO 375-68:MCG 6-23-55"
{
        Type  "SBc"
        RA           10.5717
        Dec         -34.4031
        Distance   2.572e+08  # method: V
        Radius     7.481e+04
        AbsMag        -19.78
        Axis    [ -0.6853  -0.1921  -0.7025]
        Angle     55.7603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3281D"
}

Galaxy "NGC 3282:ESO 568-16:MCG 4-25-13"
{
        Type  "S0"
        RA           10.5392
        Dec         -22.3019
        Distance   1.911e+08  # method: V
        Radius     5.282e+04
        AbsMag        -19.84
        Axis    [  0.6857   0.2845  -0.6699]
        Angle     53.8934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3282"
}

Galaxy "NGC 3283:ESO 263-48:IRAS 10290-4559"
{
        Type  "S0"
        RA           10.5197
        Dec         -46.2506
        Distance   1.431e+08  # method: V
        Radius     6.658e+04
        AbsMag        -20.61
        Axis    [ -0.5646  -0.1720  -0.8072]
        Angle     83.5687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3283"
}

Galaxy "NGC 3284:NGC 3286:MCG 10-15-112:ZWG 290.56"
{
        Type  "E0"
        RA           10.6058
        Dec          58.6203
        Distance   3.751e+08  # method: V
        Radius      4.91e+04
        AbsMag         -20.7
        Axis    [  0.6225   0.2562  -0.7395]
        Angle     46.4540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3284"
}

Galaxy "NGC 3285:ESO 501-15:MCG 4-25-19:AM 1031-271"
{
        Type  "SBa"
        RA           10.5597
        Dec         -27.4544
        Distance   1.687e+08  # method: V
        Radius     6.627e+04
        AbsMag        -20.57
        Axis    [  0.2067   0.1190  -0.9711]
        Angle     63.5095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3285"
}

Galaxy "NGC 3285A:ESO 501-8:MCG 4-25-15:AM 1030-271"
{
        Type  "SBc"
        RA           10.5467
        Dec         -27.5219
        Distance   2.097e+08  # method: V
        Radius      3.66e+04
        AbsMag        -19.54
        Axis    [ -0.6058   0.0959  -0.7898]
        Angle     87.9614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3285A"
}

Galaxy "NGC 3285B:ESO 501-18:MCG 4-25-22:AM 1032-272"
{
        Type  "SBb"
        RA           10.5767
        Dec         -27.6533
        Distance   1.488e+08  # method: V
        Radius     3.246e+04
        AbsMag        -19.39
        Axis    [  0.7868  -0.0511  -0.6151]
        Angle    105.5430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3285B"
}

Galaxy "NGC 3287:UGC 5742:MCG 4-25-32:ZWG 124.38"
{
        Type  "SBc"
        RA           10.5797
        Dec          21.6478
        Distance   7.325e+07  # method: V
        Radius     2.131e+04
        AbsMag        -18.76
        Axis    [  0.9862  -0.0479   0.1587]
        Angle     87.9256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3287"
}

Galaxy "NGC 3288:UGC 5752:MCG 10-15-114:ZWG 290.57"
{
        Type  "SBc"
        RA           10.6069
        Dec          58.5561
        Distance   3.767e+08  # method: V
        Radius     4.931e+04
        AbsMag        -20.41
        Axis    [ -0.3887   0.9017  -0.1894]
        Angle     91.9357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3288"
}

Galaxy "NGC 3289:ESO 375-65:MCG 6-23-54"
{
        Type  "SBa"
        RA           10.5686
        Dec         -35.3231
        Distance   1.364e+08  # method: V
        Radius     4.363e+04
        AbsMag        -19.61
        Axis    [ -0.5530  -0.1164  -0.8250]
        Angle     58.0115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3289"
}

Galaxy "NGC 3290:MCG 3-27-20:ARP 53:PGC 31347"
{
        Type  "SBc"
        RA           10.5881
        Dec         -17.2767
        Distance   4.949e+08  # method: V
        Radius     7.198e+04
        AbsMag         -21.6
        Axis    [  0.8307   0.1452  -0.5375]
        Angle     72.5826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3290"
}

Galaxy "NGC 3292-1:MCG 1-27-23"
{
        Type  "S0"
        RA           10.5928
        Dec          -6.1794
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.5763   0.3730  -0.7272]
        Angle     93.0175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3292-1"
}

Galaxy "NGC 3292-2:MCG 1-27-22:NPM 1"
{
        Type  "S0"
        RA           10.5917
        Dec          -6.1842
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [  0.0662   0.4428  -0.8942]
        Angle     37.8553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3292-2"
}

Galaxy "NGC 3294:UGC 5753:MCG 6-23-21:ZWG 183.30"
{
        Type  "Sc"
        RA           10.6044
        Dec          37.3247
        Distance   1.161e+08  # method: T-F
        Radius     5.739e+04
        AbsMag        -20.86
        Axis    [ -0.1664   0.9835  -0.0707]
        Angle     38.0054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3294"
}

Galaxy "NGC 3296:IC 618:NPM 1"
{
        Type  "E0"
        RA           10.5458
        Dec         -12.7167
        Distance   3.312e+08  # distance uncertain!
        Radius     3.372e+04
        AbsMag        -20.13
        Axis    [  0.7965  -0.4656  -0.3857]
        Angle    135.9570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3296"
}

Galaxy "NGC 3297:NPM 1"
{
        Type  "S0"
        RA           10.5531
        Dec         -12.6711
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.5638   0.2601  -0.7839]
        Angle     73.1600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3297"
}

Galaxy "NGC 3298:MCG 8-19-43:ZWG 241.1:ZWG 240.65"
{
        Type  "S0"
        RA           10.6200
        Dec          50.1203
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.2806   0.9551  -0.0957]
        Angle     54.9015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3298"
}

Galaxy "NGC 3299:UGC 5761:MCG 2-27-29:ZWG 65.64"
{
        Type  "Irr"
        RA           10.6064
        Dec          12.7072
        Distance   4.426e+07  # method: V
        Radius     1.416e+04
        AbsMag        -16.96
        Axis    [  0.9571  -0.2816  -0.0688]
        Angle    106.0682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3299"
}

Galaxy "NGC 3300:UGC 5766:MCG 2-27-30:ZWG 65.66"
{
        Type  "S0"
        RA           10.6106
        Dec          14.1711
        Distance    1.53e+08  # method: V
        Radius     3.783e+04
        AbsMag        -20.06
        Axis    [ -0.7313   0.5236  -0.4372]
        Angle     74.4489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3300"
}

Galaxy "NGC 3301:NGC 3760:UGC 5767:MCG 4-25-35"
{
        Type  "SBa"
        RA           10.6153
        Dec          21.8817
        Distance   7.407e+07  # method: V
        Radius     3.555e+04
        AbsMag        -19.48
        Axis    [  0.9420   0.2160   0.2567]
        Angle     60.6741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3301"
}

Galaxy "NGC 3302:ESO 437-7:MCG 5-25-20:AM 1033-320"
{
        Type  "S0"
        RA           10.5964
        Dec         -32.3583
        Distance    1.99e+08  # method: V
        Radius      4.63e+04
        AbsMag        -20.43
        Axis    [  0.0412   0.0474  -0.9980]
        Angle     82.3695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3302"
}

Galaxy "NGC 3303:UGC 5773:MCG 3-27-66:ZWG 94.96"
{
        Type  "Sc"
        RA           10.6164
        Dec          18.1369
        Distance    2.94e+08  # method: V
        Radius     7.268e+04
        AbsMag        -20.47
        Axis    [ -0.5150   0.6242  -0.5876]
        Angle     77.2769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3303"
}

Galaxy "NGC 3304:UGC 5777:MCG 6-23-26:ZWG 183.32"
{
        Type  "SBa"
        RA           10.6269
        Dec          37.4564
        Distance   3.241e+08  # method: V
        Radius     8.013e+04
        AbsMag        -20.29
        Axis    [ -0.6767   0.7362  -0.0109]
        Angle     64.3773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3304"
}

Galaxy "NGC 3305:ESO 501-30:MCG 4-25-31"
{
        Type  "E0"
        RA           10.6031
        Dec         -27.1622
        Distance   1.883e+08  # method: T-F
        Radius     3.012e+04
        AbsMag        -20.01
        Axis    [  0.8074  -0.4034  -0.4305]
        Angle    147.7514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3305"
}

Galaxy "NGC 3306:UGC 5774:MCG 2-27-32:ZWG 65.68"
{
        Type  "Irr"
        RA           10.6194
        Dec          12.6525
        Distance    1.75e+08  # method: T-F
        Radius     3.563e+04
        AbsMag        -19.85
        Axis    [ -0.6284   0.6688  -0.3972]
        Angle     41.7138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3306"
}

Galaxy "NGC 3307:ESO 501-31:MCG 4-25-29"
{
        Type  "SBa"
        RA           10.6047
        Dec         -27.5289
        Distance   1.914e+08  # method: V
        Radius     2.506e+04
        AbsMag        -19.24
        Axis    [  0.9247   0.2192  -0.3112]
        Angle     98.9023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3307"
}

Galaxy "NGC 3308:ESO 501-34:MCG 4-25-32"
{
        Type  "S0"
        RA           10.6061
        Dec         -27.4372
        Distance   1.883e+08  # method: T-F
        Radius     4.655e+04
        AbsMag        -20.81
        Axis    [  0.8511  -0.0450  -0.5231]
        Angle    109.8608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3308"
}

Galaxy "NGC 3309:ESO 501-36:MCG 4-25-34:AM 1034-271"
{
        Type  "E3"
        RA           10.6097
        Dec         -27.5175
        Distance   1.883e+08  # method: T-F
        Radius     5.203e+04
        AbsMag        -21.21
        Axis    [  0.6851  -0.3218  -0.6536]
        Angle    136.7550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3309"
}

Galaxy "NGC 3310:UGC 5786:MCG 9-18-8:ZWG 267.4"
{
        Type  "SBc"
        RA           10.6458
        Dec          53.5033
        Distance   5.296e+07  # method: V
        Radius     2.388e+04
        AbsMag        -19.65
        Axis    [ -0.3256   0.9211  -0.2135]
        Angle     72.5245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3310"
}

Galaxy "NGC 3311:ESO 501-38:MCG 4-25-36:AM 1034-271"
{
        Type  "S0"
        RA           10.6117
        Dec         -27.5286
        Distance   1.883e+08  # method: T-F
        Radius     6.299e+04
        AbsMag        -21.21
        Axis    [  0.8493  -0.1798  -0.4964]
        Angle    126.0352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3311"
}

Galaxy "NGC 3312:IC 629:ESO 501-43:MCG 4-25-39"
{
        Type  "Sb"
        RA           10.6172
        Dec         -27.5656
        Distance   1.447e+08  # method: V
        Radius     6.947e+04
        AbsMag        -20.53
        Axis    [ -0.7643  -0.0464  -0.6432]
        Angle     73.9468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3312"
}

Galaxy "NGC 3313:ESO 501-50:MCG 4-25-44:UGCA 213"
{
        Type  "SBb"
        RA           10.6236
        Dec         -25.3189
        Distance   1.846e+08  # method: V
        Radius     1.047e+05
        AbsMag        -21.36
        Axis    [  0.7101  -0.0546  -0.7020]
        Angle     98.5179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3313"
}

Galaxy "NGC 3314A:ESO 501-46:MCG 4-25-41:AM 1034-272"
{
        Type  "SBa"
        RA           10.6200
        Dec         -27.6833
        Distance   1.451e+08  # method: V
        Radius     3.166e+04
        AbsMag        -19.74
        Axis    [ -0.4546   0.0316  -0.8901]
        Angle     52.7049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3314A"
}

Galaxy "NGC 3314B"
{
        Type  "S0"
        RA           10.6192
        Dec         -27.6575
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.3080   0.0495  -0.9501]
        Angle     79.8477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3314B"
}

Galaxy "NGC 3315:ESO 501-48:MCG 4-25-42"
{
        Type  "S0"
        RA           10.6219
        Dec         -27.1917
        Distance   1.883e+08  # method: T-F
        Radius     3.012e+04
        AbsMag        -19.51
        Axis    [  0.4533  -0.0482  -0.8901]
        Angle     99.4067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3315"
}

Galaxy "NGC 3316-1:ESO 501-54:MCG 4-25-46:AM 1035-271"
{
        Type  "S0"
        RA           10.6269
        Dec         -27.5942
        Distance   2.039e+08  # method: V
        Radius     4.151e+04
        AbsMag        -20.28
        Axis    [  0.7985  -0.1075  -0.5923]
        Angle    112.8541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3316-1"
}

Galaxy "NGC 3316-2:ESO 501-54:MCG 4-25-46:AM 1035-271"
{
        Type  "S0"
        RA           10.6272
        Dec         -27.5997
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.5453   0.0565  -0.8363]
        Angle     78.6423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3316-2"
}

Galaxy "NGC 3318:ESO 317-52:MCG 7-22-26:AM 1035-412"
{
        Type  "SBc"
        RA           10.6208
        Dec         -41.6272
        Distance   1.131e+08  # method: S
        Radius     3.783e+04
        AbsMag         -20.4
        Axis    [  0.5474   0.0767  -0.8334]
        Angle     82.7598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3318"
}

Galaxy "NGC 3318A:ESO 317-50"
{
        Type  "SBc"
        RA           10.5919
        Dec         -41.7403
        Distance   3.072e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -19.07
        Axis    [  0.9167   0.2842  -0.2807]
        Angle    126.6768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3318A"
}

Galaxy "NGC 3318B:ESO 317-53:MCG 7-22-27:AM 1035-411"
{
        Type  "SBc"
        RA           10.6258
        Dec         -41.4661
        Distance   1.055e+08  # method: T-F
        Radius     2.302e+04
        AbsMag        -18.65
        Axis    [  0.1344  -0.0124  -0.9909]
        Angle     89.1531
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3318B"
}

Galaxy "NGC 3319:UGC 5789:MCG 7-22-36:ZWG 212.33"
{
        Type  "SBc"
        RA           10.6525
        Dec          41.6872
        Distance    6.99e+07  # method: T-F
        Radius     6.202e+04
        AbsMag        -20.15
        Axis    [  0.9404  -0.1148   0.3200]
        Angle     67.2661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3319"
}

Galaxy "NGC 3320:UGC 5794:MCG 8-20-10:ZWG 241.5"
{
        Type  "SBc"
        RA           10.6600
        Dec          47.3972
        Distance   1.276e+08  # method: T-F
        Radius     4.082e+04
        AbsMag        -19.86
        Axis    [  0.8818  -0.1829   0.4346]
        Angle     84.9898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3320"
}

Galaxy "NGC 3321:NGC 3322:MCG 2-27-10:UGCA 214"
{
        Type  "Sc"
        RA           10.6472
        Dec         -11.6489
        Distance   1.499e+08  # method: T-F
        Radius     5.452e+04
        AbsMag        -19.11
        Axis    [  0.9512   0.0932  -0.2943]
        Angle     86.7339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3321"
}

Galaxy "NGC 3323:UGC 5800:MCG 4-25-36:ZWG 124.49"
{
        Type  "SBa"
        RA           10.6608
        Dec          25.3225
        Distance   2.477e+08  # method: V
        Radius     3.603e+04
        AbsMag         -20.1
        Axis    [ -0.6669   0.6461  -0.3713]
        Angle     78.2368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3323"
}

Galaxy "NGC 3325:UGC 5795:MCG 0-27-36:ZWG 9.93"
{
        Type  "E0"
        RA           10.6556
        Dec          -0.1997
        Distance   2.729e+08  # method: V
        Radius     4.764e+04
        AbsMag        -21.21
        Axis    [  0.5898  -0.2759  -0.7590]
        Angle    103.5496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3325"
}

Galaxy "NGC 3326:UGC 5799:MCG 1-27-25:MK 1260"
{
        Type  "Sa"
        RA           10.6586
        Dec           5.1072
        Distance   3.718e+08  # method: V
        Radius     3.245e+04
        AbsMag        -20.88
        Axis    [  0.7756  -0.5437  -0.3206]
        Angle    121.6587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3326"
}

Galaxy "NGC 3327:UGC 5803:MCG 4-25-38:ZWG 124.51"
{
        Type  "Sb"
        RA           10.6658
        Dec          24.0917
        Distance   2.988e+08  # method: V
        Radius      4.78e+04
        AbsMag        -20.61
        Axis    [  0.7763   0.3396  -0.5310]
        Angle     39.2101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3327"
}

Galaxy "NGC 3331:ESO 501-72:MCG 4-25-56:AM 1037-233"
{
        Type  "SBc"
        RA           10.6692
        Dec         -23.8206
        Distance   1.843e+08  # method: V
        Radius     3.216e+04
        AbsMag        -19.86
        Axis    [  0.8828  -0.0595  -0.4659]
        Angle    109.5947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3331"
}

Galaxy "NGC 3333:ESO 376-2:MCG 6-24-1:IRAS 10375-3546"
{
        Type  "SBc"
        RA           10.6636
        Dec         -36.0361
        Distance   1.518e+08  # method: T-F
        Radius     4.635e+04
        AbsMag        -19.44
        Axis    [ -0.6790  -0.2293  -0.6974]
        Angle     56.3574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3333"
}

Galaxy "NGC 3334:UGC 5817:MCG 6-24-4:ZWG 184.5"
{
        Type  "S0"
        RA           10.6919
        Dec          37.3125
        Distance    3.38e+08  # method: V
        Radius     5.407e+04
        AbsMag        -21.18
        Axis    [  0.8306  -0.5564   0.0205]
        Angle     97.4751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3334"
}

Galaxy "NGC 3335:ESO 501-71:MCG 4-25-55:AM 1037-233"
{
        Type  "SBa"
        RA           10.6594
        Dec         -23.9219
        Distance   1.843e+08  # method: V
        Radius     2.948e+04
        AbsMag        -19.76
        Axis    [ -0.1159   0.1192  -0.9861]
        Angle     82.5951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3335"
}

Galaxy "NGC 3336:ESO 437-36:MCG 5-25-36:AM 1037-273"
{
        Type  "SBc"
        RA           10.6711
        Dec         -27.7772
        Distance   1.961e+08  # method: V
        Radius     5.703e+04
        AbsMag        -20.89
        Axis    [ -0.0297   0.0739  -0.9968]
        Angle     82.9153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3336"
}

Galaxy "NGC 3337:ZWG 37.119:NPM 1"
{
        Type  "S0"
        RA           10.6964
        Dec           4.9889
        Distance   1.938e+08  # distance uncertain!
        Radius     1.692e+04
        AbsMag        -19.07
        Axis    [  0.9816   0.0637  -0.1798]
        Angle     70.8336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3337"
}

Galaxy "NGC 3338:UGC 5826:MCG 2-27-41:ZWG 65.87"
{
        Type  "Sc"
        RA           10.7019
        Dec          13.7467
        Distance   9.459e+07  # method: T-F
        Radius     7.842e+04
        AbsMag        -20.71
        Axis    [  0.4830   0.5390  -0.6901]
        Angle     34.7954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3338"
}

Galaxy "NGC 3340:UGC 5827:MCG 0-27-42:ZWG 9.101"
{
        Type  "Sc"
        RA           10.7047
        Dec          -0.3769
        Distance   2.682e+08  # method: V
        Radius     3.901e+04
        AbsMag        -20.87
        Axis    [ -0.2574   0.3814  -0.8879]
        Angle     80.3553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3340"
}

Galaxy "NGC 3341:UGC 5831:MCG 1-27-31:ZWG 37.124"
{
        Type  "Irr"
        RA           10.7086
        Dec           5.0442
        Distance   3.163e+08  # distance uncertain!
        Radius      5.52e+04
        AbsMag        -20.13
        Axis    [  0.9954   0.0902   0.0317]
        Angle     89.2252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3341"
}

Galaxy "NGC 3342:NGC 3332:UGC 5807:MCG 2-27-38"
{
        Type  "S0"
        RA           10.6744
        Dec           9.1825
        Distance    2.75e+08  # method: V
        Radius     5.599e+04
        AbsMag        -21.13
        Axis    [  0.7661  -0.5658  -0.3051]
        Angle    118.7310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3342"
}

Galaxy "NGC 3343:UGC 5863:MCG 12-10-73:ZWG 333.51"
{
        Type  "E0"
        RA           10.7694
        Dec          73.3533
        Distance   2.631e+08  # distance uncertain!
        Radius     4.974e+04
        AbsMag        -20.13
        Axis    [  0.8069  -0.5088  -0.3001]
        Angle     37.9932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3343"
}

Galaxy "NGC 3344:UGC 5840:MCG 4-25-46:ZWG 124.60"
{
        Type  "SBc"
        RA           10.7250
        Dec          24.9228
        Distance   4.036e+07  # method: V
        Radius     4.168e+04
        AbsMag        -19.96
        Axis    [  0.8809  -0.4366  -0.1829]
        Angle     89.3005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3344"
}

Galaxy "NGC 3346:UGC 5842:MCG 3-28-1:ZWG 94.116"
{
        Type  "SBc"
        RA           10.7272
        Dec          14.8722
        Distance   7.212e+07  # method: V
        Radius     2.832e+04
        AbsMag        -19.22
        Axis    [  0.4615   0.0893  -0.8826]
        Angle     66.5379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3346"
}

Galaxy "NGC 3347:ESO 376-13:MCG 6-24-7"
{
        Type  "SBb"
        RA           10.7128
        Dec         -36.3533
        Distance   1.042e+08  # method: T-F
        Radius     5.155e+04
        AbsMag        -20.32
        Axis    [ -0.6353  -0.0329  -0.7715]
        Angle     89.0486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3347"
}

Galaxy "NGC 3347A:ESO 376-4:MCG 6-24-2:AM 1038-360"
{
        Type  "SBc"
        RA           10.6722
        Dec         -36.4125
        Distance   1.253e+08  # method: T-F
        Radius     3.645e+04
        AbsMag        -19.42
        Axis    [  0.9368   0.1964  -0.2895]
        Angle    124.0008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3347A"
}

Galaxy "NGC 3347B:ESO 376-10:MCG 6-24-5:IRAS 10397-3640"
{
        Type  "SBc"
        RA           10.7000
        Dec         -36.9364
        Distance   1.509e+08  # method: T-F
        Radius     7.021e+04
        AbsMag        -19.62
        Axis    [  0.4642   0.1543  -0.8722]
        Angle     52.8214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3347B"
}

Galaxy "NGC 3347C:ESO 376-5:MCG 6-24-3"
{
        Type  "SBc"
        RA           10.6814
        Dec         -36.2886
        Distance   1.502e+08  # method: V
        Radius     3.058e+04
        AbsMag        -18.52
        Axis    [  0.8647  -0.0490  -0.4999]
        Angle    124.8467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3347C"
}

Galaxy "NGC 3348:UGC 5875:MCG 12-10-77:ZWG 333.54"
{
        Type  "E0"
        RA           10.7861
        Dec          72.8389
        Distance   1.179e+08  # method: T-F
        Radius     3.429e+04
        AbsMag        -20.69
        Axis    [  0.4323  -0.9004   0.0494]
        Angle     81.1125
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3348"
}

Galaxy "NGC 3349-1:MCG 1-28-2:ZWG 38.2:VV 514"
{
        Type  "Sc"
        RA           10.7306
        Dec           6.7631
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.7660  -0.5587  -0.3179]
        Angle    120.8405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3349-1"
}

Galaxy "NGC 3349-2:MCG 1-28-2:ZWG 38.2:VV 514"
{
        Type  "Irr"
        RA           10.7311
        Dec           6.7572
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.9899  -0.1156  -0.0818]
        Angle     97.5061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3349-2"
}

Galaxy "NGC 3350:ZWG 155.2:ZWG 154.44:NPM 1"
{
        Type  "S0"
        RA           10.7394
        Dec          30.7253
        Distance   4.839e+08  # method: V
        Radius     4.222e+04
        AbsMag        -20.36
        Axis    [  0.7001  -0.6836  -0.2065]
        Angle    104.0664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3350"
}

Galaxy "M 95:NGC 3351:UGC 5850:MCG 2-28-1"
{
        Type  "SBb"
        RA           10.7325
        Dec          11.7033
        Distance    5.06e+07  # method: V
        Radius     5.446e+04
        AbsMag        -20.35
        Axis    [  0.9779  -0.1960  -0.0730]
        Angle     97.5473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 95"
}

Galaxy "NGC 3352:UGC 5851:MCG 4-25-48:ZWG 124.61"
{
        Type  "S0"
        RA           10.7372
        Dec          22.3714
        Distance   2.744e+08  # method: V
        Radius     6.386e+04
        AbsMag        -21.02
        Axis    [  0.9388  -0.3436   0.0236]
        Angle    104.7844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3352"
}

Galaxy "NGC 3353:UGC 5860:MCG 9-18-22:MK 35"
{
        Type  "Sb"
        RA           10.7561
        Dec          55.9597
        Distance   5.037e+07  # method: V
        Radius     1.026e+04
        AbsMag        -17.74
        Axis    [  0.9140  -0.0149   0.4055]
        Angle     44.2366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3353"
}

Galaxy "NGC 3354:ESO 376-14:MCG 6-24-8:AM 1040-360"
{
        Type  "S0"
        RA           10.7172
        Dec         -36.3628
        Distance   1.413e+08  # method: V
        Radius     1.439e+04
        AbsMag        -19.48
        Axis    [  0.8172  -0.3489  -0.4588]
        Angle    154.0922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3354"
}

Galaxy "NGC 3355:ESO 501-80:MCG 4-26-1:IRAS 10402-2340"
{
        Type  "Sb"
        RA           10.7103
        Dec         -23.9344
        Distance   4.911e+07  # method: T-F
        Radius     2.143e+04
        AbsMag        -17.09
        Axis    [  0.3478   0.2691  -0.8981]
        Angle     36.4412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3355"
}

Galaxy "NGC 3356:UGC 5852:MCG 1-28-4:ZWG 38.5"
{
        Type  "Sc"
        RA           10.7367
        Dec           6.7589
        Distance   2.275e+08  # method: T-F
        Radius     5.624e+04
        AbsMag        -20.52
        Axis    [  0.4463   0.5650  -0.6939]
        Angle     31.4937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3356"
}

Galaxy "NGC 3357:UGC 5206:UGC 5854A:MCG 2-28-2"
{
        Type  "E0"
        RA           10.7389
        Dec          14.0844
        Distance   4.595e+08  # method: V
        Radius     8.689e+04
        AbsMag        -21.74
        Axis    [  0.3826   0.0054  -0.9239]
        Angle     84.3665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3357"
}

Galaxy "NGC 3358:ESO 376-17:MCG 6-24-9:IRAS 10412-3609"
{
        Type  "SBa"
        RA           10.7258
        Dec         -36.4108
        Distance   1.492e+08  # method: V
        Radius     6.945e+04
        AbsMag         -20.9
        Axis    [ -0.3079  -0.0251  -0.9511]
        Angle     72.7309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3358"
}

Galaxy "NGC 3359:UGC 5873:MCG 11-13-37:ZWG 313.33"
{
        Type  "SBc"
        RA           10.7767
        Dec          63.2233
        Distance    5.83e+07  # method: T-F
        Radius     6.105e+04
        AbsMag        -20.26
        Axis    [ -0.4594   0.8882   0.0080]
        Angle     85.7741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3359"
}

Galaxy "NGC 3360:MCG 2-28-3"
{
        Type  "Sc"
        RA           10.7378
        Dec         -11.2425
        Distance   3.985e+08  # method: V
        Radius     6.955e+04
        AbsMag        -21.03
        Axis    [  0.7964  -0.0415  -0.6034]
        Angle     81.8854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3360"
}

Galaxy "NGC 3361:MCG 2-28-4:IRAS 10419-1056"
{
        Type  "SBc"
        RA           10.7414
        Dec         -11.2081
        Distance   1.133e+08  # method: T-F
        Radius     3.462e+04
        AbsMag         -19.2
        Axis    [ -0.7029   0.2103  -0.6795]
        Angle     54.6935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3361"
}

Galaxy "NGC 3362:UGC 5857:MCG 1-28-5:ZWG 38.7"
{
        Type  "Sc"
        RA           10.7475
        Dec           6.5972
        Distance   3.926e+08  # method: V
        Radius     7.994e+04
        AbsMag         -21.9
        Axis    [  0.8691  -0.0906  -0.4863]
        Angle     70.5747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3362"
}

Galaxy "NGC 3363:UGC 5866:MCG 4-26-2:ZWG 125.3"
{
        Type  "Sc"
        RA           10.7525
        Dec          22.0786
        Distance   2.755e+08  # method: V
        Radius     5.209e+04
        AbsMag        -20.13
        Axis    [  0.9636  -0.2505   0.0938]
        Angle    105.6135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3363"
}

Galaxy "NGC 3364:UGC 5890:MCG 12-10-82:ZWG 333.56"
{
        Type  "SBc"
        RA           10.8081
        Dec          72.4250
        Distance   1.262e+08  # method: V
        Radius     2.752e+04
        AbsMag        -19.24
        Axis    [  0.4561  -0.8866   0.0763]
        Angle     81.7534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3364"
}

Galaxy "NGC 3365:UGC 5878:MCG 0-28-6:ZWG 10.8"
{
        Type  "Sc"
        RA           10.7700
        Dec           1.8128
        Distance   7.746e+07  # method: T-F
        Radius      5.07e+04
        AbsMag        -18.68
        Axis    [ -0.9224   0.2931  -0.2517]
        Angle     49.2717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3365"
}

Galaxy "NGC 3366:IC 2592:ESO 264-7:MCG 7-22-24"
{
        Type  "SBb"
        RA           10.5856
        Dec         -43.6936
        Distance   1.506e+08  # method: T-F
        Radius     3.942e+04
        AbsMag        -21.12
        Axis    [  0.8240   0.1788  -0.5376]
        Angle    105.2596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3366"
}

Galaxy "NGC 3367:UGC 5880:MCG 2-28-5:ZWG 66.11"
{
        Type  "SBc"
        RA           10.7761
        Dec          13.7503
        Distance    1.53e+08  # method: V
        Radius     5.563e+04
        AbsMag        -21.26
        Axis    [  0.7322  -0.2220  -0.6439]
        Angle     75.8950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3367"
}

Galaxy "M 96:NGC 3368:UGC 5882:MCG 2-28-6"
{
        Type  "SBb"
        RA           10.7792
        Dec          11.8200
        Distance   3.384e+07  # method: S
        Radius     3.839e+04
        AbsMag        -19.98
        Axis    [ -0.6822   0.5169  -0.5171]
        Angle     80.3481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 96"
}

Galaxy "NGC 3369:ESO 501-95:MCG 4-26-9"
{
        Type  "S0"
        RA           10.7789
        Dec         -25.2442
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.0859   0.0904  -0.9922]
        Angle     60.7065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3369"
}

Galaxy "NGC 3370:UGC 5887:MCG 3-28-8:ZWG 95.19"
{
        Type  "Sc"
        RA           10.7844
        Dec          17.2739
        Distance   7.289e+07  # method: V
        Radius     2.756e+04
        AbsMag        -19.35
        Axis    [ -0.5494   0.6508  -0.5241]
        Angle     52.9584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3370"
}

Galaxy "NGC 3374:UGC 5901:MCG 7-22-66:ZWG 212.57"
{
        Type  "SBc"
        RA           10.8003
        Dec          43.1861
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [ -0.3340   0.9110  -0.2417]
        Angle     53.9221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3374"
}

Galaxy "NGC 3375:MCG 2-28-8:MCG 1-28-2"
{
        Type  "S0"
        RA           10.7833
        Dec          -9.9419
        Distance   1.471e+08  # method: T-F
        Radius     3.424e+04
        AbsMag        -19.67
        Axis    [ -0.4540   0.2869  -0.8436]
        Angle     74.4574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3375"
}

Galaxy "NGC 3376:UGC 5891:MCG 1-28-7:ZWG 38.13"
{
        Type  "S0"
        RA           10.7906
        Dec           6.0486
        Distance   2.802e+08  # method: V
        Radius     3.261e+04
        AbsMag        -20.37
        Axis    [ -0.7510   0.4292  -0.5018]
        Angle     66.3247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3376"
}

Galaxy "NGC 3377:UGC 5899:MCG 2-28-9:ZWG 66.16"
{
        Type  "E5"
        RA           10.7950
        Dec          13.9858
        Distance    3.66e+07  # method: S
        Radius     2.661e+04
        AbsMag        -19.05
        Axis    [  0.6778  -0.4576  -0.5756]
        Angle     97.8058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3377"
}

Galaxy "NGC 3377A:UGC 5889:MCG 2-28-7:DDO 88"
{
        Type  "Irr"
        RA           10.7894
        Dec          14.0700
        Distance   4.113e+07  # method: V
        Radius     1.316e+04
        AbsMag         -16.2
        Axis    [  0.4621   0.0815  -0.8831]
        Angle     65.3115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3377A"
}

Galaxy "NGC 3378:ESO 318-12:MCG 7-22-29:IRAS 10444-3945"
{
        Type  "SBc"
        RA           10.7786
        Dec         -40.0156
        Distance   2.483e+08  # method: V
        Radius     5.417e+04
        AbsMag        -20.91
        Axis    [  0.8404  -0.1758  -0.5126]
        Angle    141.5863
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3378"
}

Galaxy "M 105:NGC 3379:UGC 5902:MCG 2-28-11"
{
        Type  "E1"
        RA           10.7969
        Dec          12.5811
        Distance   3.447e+07  # method: S
        Radius     2.657e+04
        AbsMag        -19.62
        Axis    [  0.5115  -0.1837  -0.8394]
        Angle     87.2819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 105"
}

Galaxy "NGC 3380:UGC 5906:MCG 5-26-12:ZWG 155.15"
{
        Type  "SBa"
        RA           10.8033
        Dec          28.6019
        Distance   8.607e+07  # method: V
        Radius     2.003e+04
        AbsMag        -18.61
        Axis    [  0.8893  -0.4511  -0.0755]
        Angle     91.9268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3380"
}

Galaxy "NGC 3381:UGC 5909:MCG 6-24-15:ZWG 184.16"
{
        Type  "SBa"
        RA           10.8067
        Dec          34.7114
        Distance    8.58e+07  # method: V
        Radius     2.496e+04
        AbsMag         -19.4
        Axis    [  0.9007  -0.1805  -0.3952]
        Angle     52.2390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3381"
}

Galaxy "NGC 3383:ESO 501-97:MCG 4-26-10:AM 1044-241"
{
        Type  "SBc"
        RA           10.7886
        Dec         -24.4378
        Distance   1.815e+08  # method: T-F
        Radius     3.695e+04
        AbsMag        -20.23
        Axis    [  0.8752  -0.1008  -0.4731]
        Angle    113.3937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3383"
}

Galaxy "NGC 3384:NGC 3371:UGC 5911:MCG 2-28-12"
{
        Type  "S0"
        RA           10.8044
        Dec          12.6286
        Distance    3.78e+07  # method: S
        Radius     2.968e+04
        AbsMag        -19.42
        Axis    [  0.9902   0.0684  -0.1221]
        Angle     60.4518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3384"
}

Galaxy "NGC 3385:UGC 5908:MCG 1-28-9:ZWG 38.15"
{
        Type  "S0"
        RA           10.8031
        Dec           4.9283
        Distance   3.701e+08  # method: V
        Radius     8.074e+04
        AbsMag        -21.87
        Axis    [  0.5068   0.3432  -0.7908]
        Angle     40.1725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3385"
}

Galaxy "NGC 3386:MCG 1-28-10:ZWG 38.16:NPM 1"
{
        Type  "E0"
        RA           10.8031
        Dec           4.9992
        Distance   3.163e+08  # distance uncertain!
        Radius       2.3e+04
        AbsMag        -20.13
        Axis    [  0.7447  -0.5734  -0.3416]
        Angle    123.5580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3386"
}

Galaxy "NGC 3387"
{
        Type  "E0"
        RA           10.8044
        Dec           4.9669
        Distance   5.496e+08  # distance uncertain!
        Radius     1.998e+04
        AbsMag        -20.13
        Axis    [  0.4253  -0.1146  -0.8978]
        Angle     93.2365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3387"
}

Galaxy "NGC 3389:NGC 3373:UGC 5914:MCG 2-28-13"
{
        Type  "Sc"
        RA           10.8078
        Dec          12.5331
        Distance    7.42e+07  # method: V
        Radius      3.13e+04
        AbsMag        -19.28
        Axis    [  0.1261   0.7834  -0.6086]
        Angle     26.8491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3389"
}

Galaxy "NGC 3390:ESO 437-62:MCG 5-26-7:IRAS 10457-3116"
{
        Type  "Sb"
        RA           10.8011
        Dec         -31.5333
        Distance   1.423e+08  # method: V
        Radius     7.246e+04
        AbsMag         -20.3
        Axis    [ -0.8337  -0.2416  -0.4965]
        Angle     67.7197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3390"
}

Galaxy "NGC 3391:UGC 5920:MCG 2-28-14:ZWG 66.27"
{
        Type  "Sc"
        RA           10.8156
        Dec          14.2194
        Distance   1.492e+08  # method: V
        Radius      2.17e+04
        AbsMag         -19.6
        Axis    [  0.9696  -0.1608  -0.1845]
        Angle     77.5904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3391"
}

Galaxy "NGC 3392:MCG 11-13-42:ZWG 313.37"
{
        Type  "E0"
        RA           10.8506
        Dec          65.7814
        Distance   1.534e+08  # method: V
        Radius     1.785e+04
        AbsMag        -18.36
        Axis    [  0.3376   0.7238  -0.6018]
        Angle     56.2577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3392"
}

Galaxy "NGC 3393:ESO 501-100:MCG 4-26-11:AM 1045-245"
{
        Type  "SBa"
        RA           10.8064
        Dec         -25.1617
        Distance   1.842e+08  # method: V
        Radius     4.823e+04
        AbsMag        -20.66
        Axis    [  0.7376  -0.1006  -0.6677]
        Angle    102.3047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3393"
}

Galaxy "NGC 3394:UGC 5937:MCG 11-13-41:ZWG 313.36"
{
        Type  "Sc"
        RA           10.8442
        Dec          65.7278
        Distance   1.593e+08  # method: V
        Radius     4.402e+04
        AbsMag        -20.34
        Axis    [  0.7958  -0.3655   0.4828]
        Angle     63.7280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3394"
}

Galaxy "NGC 3395:IC 2613:UGC 5931:MCG 6-24-17"
{
        Type  "SBc"
        RA           10.8303
        Dec          32.9814
        Distance   8.603e+07  # method: V
        Radius     2.628e+04
        AbsMag        -19.61
        Axis    [  0.9784  -0.0097   0.2066]
        Angle     57.8273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3395"
}

Galaxy "NGC 3396:UGC 5935:MCG 6-24-18:ZWG 184.19"
{
        Type  "Irr"
        RA           10.8319
        Dec          32.9906
        Distance   8.657e+07  # method: V
        Radius     3.651e+04
        AbsMag        -19.52
        Axis    [  0.4265   0.8566   0.2903]
        Angle     27.9155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3396"
}

Galaxy "NGC 3397:NGC 3329:UGC 5837:MCG 13-8-33"
{
        Type  "Sb"
        RA           10.7442
        Dec          76.8097
        Distance   8.412e+07  # method: V
        Radius     2.325e+04
        AbsMag        -19.06
        Axis    [ -0.2447   0.9022   0.3552]
        Angle     71.2711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3397"
}

Galaxy "NGC 3398:IC 644:UGC 5954:MCG 9-18-38"
{
        Type  "Sa"
        RA           10.8586
        Dec          55.3911
        Distance   1.377e+08  # method: V
        Radius     2.002e+04
        AbsMag        -18.63
        Axis    [  0.4750   0.3492   0.8077]
        Angle     53.9621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3398"
}

Galaxy "NGC 3399:MCG 3-28-12:ZWG 95.31"
{
        Type  "S0"
        RA           10.8242
        Dec          16.2189
        Distance   3.242e+08  # method: V
        Radius     3.772e+04
        AbsMag        -20.69
        Axis    [  0.7359  -0.6158  -0.2816]
        Angle    114.6243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3399"
}

Galaxy "NGC 3400:UGC 5949:MCG 5-26-20:ZWG 155.25"
{
        Type  "SBa"
        RA           10.8458
        Dec          28.4689
        Distance   7.715e+07  # method: V
        Radius     1.234e+04
        AbsMag        -17.57
        Axis    [  0.5473   0.7182  -0.4297]
        Angle     28.5685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3400"
}

Galaxy "NGC 3403:UGC 5997:MCG 12-10-89:ZWG 333.62"
{
        Type  "Sc"
        RA           10.8983
        Dec          73.6900
        Distance   9.925e+07  # method: T-F
        Radius     4.331e+04
        AbsMag        -19.42
        Axis    [  0.4275   0.2224   0.8762]
        Angle     60.6121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3403"
}

Galaxy "NGC 3404:IC 2609:MCG 2-28-11:IRAS 10477-1150"
{
        Type  "SBb"
        RA           10.8381
        Dec         -12.1081
        Distance   1.341e+08  # distance uncertain!
        Radius     4.096e+04
        AbsMag        -19.07
        Axis    [  0.7977   0.3613  -0.4828]
        Angle     39.6132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3404"
}

Galaxy "NGC 3405-1:UGC 5933:MCG 3-28-14:ZWG 95.33"
{
        Type  "S0"
        RA           10.8286
        Dec          16.2392
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.7354  -0.6163  -0.2817]
        Angle    114.6402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3405-1"
}

Galaxy "NGC 3405-2:UGC 5933:MCG 3-28-15:ZWG 95.33"
{
        Type  "S0"
        RA           10.8289
        Dec          16.2425
        Distance    1.54e+08  # distance uncertain!
        Radius     1.792e+04
        AbsMag        -19.07
        Axis    [  0.7354  -0.6163  -0.2817]
        Angle    114.6398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3405-2"
}

Galaxy "NGC 3406-1:UGC 5970:MCG 9-18-40:ZWG 267.20"
{
        Type  "S0"
        RA           10.8619
        Dec          51.0228
        Distance   1.168e+08  # distance uncertain!
        Radius     1.529e+04
        AbsMag        -19.07
        Axis    [  0.9093  -0.2238   0.3507]
        Angle     60.3754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3406-1"
}

Galaxy "NGC 3406-2:UGC 5970:MCG 9-18-40:ZWG 267.20"
{
        Type  "Irr"
        RA           10.8622
        Dec          51.0258
        Distance   1.906e+08  # distance uncertain!
        Radius     1.386e+04
        AbsMag        -20.13
        Axis    [  0.8698  -0.3237   0.3723]
        Angle     81.7932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3406-2"
}

Galaxy "NGC 3407:UGC 5978:MCG 10-16-17:ZWG 291.7"
{
        Type  "S0"
        RA           10.8714
        Dec          61.3794
        Distance   2.325e+08  # method: V
        Radius     4.734e+04
        AbsMag        -19.66
        Axis    [  0.7904  -0.3275   0.5177]
        Angle     89.8755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3407"
}

Galaxy "NGC 3408:UGC 5977:MCG 10-16-16:ZWG 291.6"
{
        Type  "Sc"
        RA           10.8697
        Dec          58.4386
        Distance   4.386e+08  # method: V
        Radius     5.103e+04
        AbsMag        -21.44
        Axis    [  0.0442   0.9693  -0.2419]
        Angle     47.9594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3408"
}

Galaxy "NGC 3409:MCG 3-28-12"
{
        Type  "Sc"
        RA           10.8389
        Dec         -17.0447
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.9659   0.2488  -0.0718]
        Angle    107.9705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3409"
}

Galaxy "NGC 3410:MCG 9-18-42:ZWG 267.21:ARAK 261"
{
        Type  "S0"
        RA           10.8647
        Dec          51.0064
        Distance   3.307e+08  # method: V
        Radius     3.848e+04
        AbsMag        -20.03
        Axis    [  0.8760  -0.3195   0.3612]
        Angle     77.4818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3410"
}

Galaxy "NGC 3411:NGC 3402:MCG 2-28-12"
{
        Type  "E0"
        RA           10.8406
        Dec         -12.8450
        Distance   3.038e+08  # method: T-F
        Radius      9.28e+04
        AbsMag        -21.95
        Axis    [  0.7719  -0.4891  -0.4061]
        Angle    137.2978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3411"
}

Galaxy "NGC 3412:UGC 5952:MCG 2-28-16:ZWG 66.38"
{
        Type  "S0"
        RA           10.8481
        Dec          13.4128
        Distance   3.694e+07  # method: S
        Radius     1.988e+04
        AbsMag        -18.87
        Axis    [ -0.6091   0.5705  -0.5509]
        Angle     58.8637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3412"
}

Galaxy "NGC 3413:UGC 5960:MCG 6-24-24:ZWG 184.27"
{
        Type  "S0"
        RA           10.8556
        Dec          32.7661
        Distance    5.29e+07  # method: S
        Radius     1.385e+04
        AbsMag        -17.95
        Axis    [ -0.7526   0.6381  -0.1629]
        Angle     78.6332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3413"
}

Galaxy "NGC 3414:UGC 5959:MCG 5-26-21:ZWG 155.29"
{
        Type  "S0"
        RA           10.8544
        Dec          27.9750
        Distance   8.231e+07  # method: S
        Radius      4.19e+04
        AbsMag        -20.11
        Axis    [  0.9539  -0.2997  -0.0178]
        Angle     80.3852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3414"
}

Galaxy "NGC 3415:UGC 5969:MCG 7-22-72:ZWG 212.62"
{
        Type  "Sa"
        RA           10.8617
        Dec          43.7128
        Distance     1.6e+08  # method: V
        Radius     4.887e+04
        AbsMag        -20.15
        Axis    [  0.8964  -0.3492   0.2729]
        Angle     91.3614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3415"
}

Galaxy "NGC 3416:MCG 7-22-73:ZWG 213.2:ZWG 212.63"
{
        Type  "S0"
        RA           10.8633
        Dec          43.7647
        Distance   1.589e+08  # method: V
        Radius     1.387e+04
        AbsMag        -17.64
        Axis    [  0.8785  -0.0914   0.4689]
        Angle     83.5062
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3416"
}

Galaxy "NGC 3417:ZWG 66.39"
{
        Type  "S0"
        RA           10.8503
        Dec           8.4736
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8511   0.2816  -0.4430]
        Angle     40.1986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3417"
}

Galaxy "NGC 3418:UGC 5963:MCG 5-26-23:ZWG 155.30"
{
        Type  "SBa"
        RA           10.8564
        Dec          28.1122
        Distance   7.013e+07  # method: V
        Radius     1.428e+04
        AbsMag        -17.26
        Axis    [  0.8889   0.0932  -0.4484]
        Angle     42.6185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3418"
}

Galaxy "NGC 3419:UGC 5964:MCG 2-28-18:ZWG 66.41"
{
        Type  "SBa"
        RA           10.8547
        Dec          13.9456
        Distance   1.527e+08  # method: V
        Radius     2.665e+04
        AbsMag        -19.55
        Axis    [  0.1235   0.4131  -0.9023]
        Angle     51.4363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3419"
}

Galaxy "NGC 3419A:UGC 5965:MCG 2-28-19:ZWG 66.42"
{
        Type  "SBc"
        RA           10.8553
        Dec          14.0233
        Distance   1.545e+08  # method: V
        Radius     3.595e+04
        AbsMag        -18.48
        Axis    [ -0.7523   0.6573   0.0454]
        Angle     33.7232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3419A"
}

Galaxy "NGC 3420:MCG 3-28-11:NPM 1"
{
        Type  "SBa"
        RA           10.8358
        Dec         -17.2431
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.8455  -0.1676  -0.5070]
        Angle    107.1522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3420"
}

Galaxy "NGC 3421:IC 652:MCG 2-28-13:NPM 1"
{
        Type  "Sa"
        RA           10.8492
        Dec         -12.4478
        Distance   1.768e+08  # distance uncertain!
        Radius     4.628e+04
        AbsMag        -19.07
        Axis    [ -0.5997   0.2972  -0.7430]
        Angle     93.8741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3421"
}

Galaxy "NGC 3422:MCG 2-28-15"
{
        Type  "Sa"
        RA           10.8547
        Dec         -12.4019
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [  0.9393   0.2649  -0.2180]
        Angle     65.2312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3422"
}

Galaxy "NGC 3423:UGC 5962:MCG 1-28-12:ZWG 38.29"
{
        Type  "Sc"
        RA           10.8539
        Dec           5.8400
        Distance   6.156e+07  # method: V
        Radius     3.492e+04
        AbsMag        -19.78
        Axis    [  0.9212  -0.3186  -0.2232]
        Angle    105.8912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3423"
}

Galaxy "NGC 3424:UGC 5972:MCG 6-24-25:ZWG 184.28"
{
        Type  "SBb"
        RA           10.8628
        Dec          32.9003
        Distance   8.045e+07  # method: V
        Radius     3.159e+04
        AbsMag        -18.76
        Axis    [ -0.0346   0.8935   0.4478]
        Angle     31.3056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3424"
}

Galaxy "NGC 3425:NGC 3388:UGC 5967:MCG 2-28-21"
{
        Type  "S0"
        RA           10.8569
        Dec           8.5675
        Distance   3.159e+08  # method: V
        Radius     4.594e+04
        AbsMag        -20.63
        Axis    [  0.7509  -0.5794  -0.3170]
        Angle    120.2779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3425"
}

Galaxy "NGC 3426:UGC 5975:MCG 3-28-20:ZWG 95.46"
{
        Type  "S0"
        RA           10.8614
        Dec          18.4811
        Distance   2.915e+08  # method: V
        Radius     4.664e+04
        AbsMag        -20.76
        Axis    [  0.1333   0.5754  -0.8070]
        Angle     39.6134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3426"
}

Galaxy "NGC 3427:UGC 5966:MCG 2-28-20:ZWG 66.43"
{
        Type  "Sa"
        RA           10.8572
        Dec           8.2983
        Distance   2.994e+08  # method: V
        Radius     4.791e+04
        AbsMag        -20.71
        Axis    [  0.9028   0.2690  -0.3356]
        Angle     41.7661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3427"
}

Galaxy "NGC 3428:NGC 3429:UGC 5968:MCG 2-28-22"
{
        Type  "SBb"
        RA           10.8581
        Dec           9.2792
        Distance   3.759e+08  # method: V
        Radius     8.201e+04
        AbsMag        -21.31
        Axis    [ -0.7913   0.4422  -0.4222]
        Angle     67.2564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3428"
}

Galaxy "NGC 3430:UGC 5982:MCG 6-24-26:ZWG 184.29"
{
        Type  "SBc"
        RA           10.8697
        Dec          32.9508
        Distance   9.577e+07  # method: T-F
        Radius     5.711e+04
        AbsMag        -20.14
        Axis    [  0.9655  -0.1592   0.2059]
        Angle     75.8950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3430"
}

Galaxy "NGC 3431:MCG 3-28-14:IRAS 10487-1644"
{
        Type  "Sb"
        RA           10.8542
        Dec         -17.0083
        Distance   2.594e+08  # method: V
        Radius     4.905e+04
        AbsMag         -20.1
        Axis    [ -0.5546   0.1569  -0.8172]
        Angle     33.4933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3431"
}

Galaxy "NGC 3432:UGC 5986:MCG 6-24-28:ZWG 184.30"
{
        Type  "Irr"
        RA           10.8753
        Dec          36.6189
        Distance   5.703e+07  # method: T-F
        Radius     5.475e+04
        AbsMag        -19.51
        Axis    [  0.8720   0.0559   0.4864]
        Angle     76.5517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3432"
}

Galaxy "NGC 3433:UGC 5981:MCG 2-28-23:ZWG 66.48"
{
        Type  "Sc"
        RA           10.8678
        Dec          10.1478
        Distance   1.387e+08  # method: V
        Radius     7.061e+04
        AbsMag        -20.64
        Axis    [  0.8482  -0.1949  -0.4925]
        Angle     74.0393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3433"
}

Galaxy "NGC 3434:UGC 5980:MCG 1-28-15:ZWG 38.36"
{
        Type  "Sb"
        RA           10.8661
        Dec           3.7919
        Distance   1.805e+08  # method: V
        Radius     5.514e+04
        AbsMag        -20.61
        Axis    [  0.8219  -0.2566  -0.5085]
        Angle     87.6147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3434"
}

Galaxy "NGC 3435:UGC 6025:MCG 10-16-22:ZWG 291.12"
{
        Type  "Sb"
        RA           10.9133
        Dec          61.2889
        Distance   2.399e+08  # method: V
        Radius      6.28e+04
        AbsMag        -20.33
        Axis    [  0.8182  -0.3156   0.4805]
        Angle     66.8263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3435"
}

Galaxy "NGC 3436:MCG 1-28-16:ZWG 38.39:MK 1266"
{
        Type  "S0"
        RA           10.8742
        Dec           8.0942
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.5939   0.2037  -0.7783]
        Angle     46.3436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3436"
}

Galaxy "NGC 3437:UGC 5995:MCG 4-26-16:ZWG 125.13"
{
        Type  "SBc"
        RA           10.8764
        Dec          22.9350
        Distance   7.833e+07  # method: T-F
        Radius     2.962e+04
        AbsMag         -19.1
        Axis    [ -0.3328   0.9407   0.0662]
        Angle     27.9532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3437"
}

Galaxy "NGC 3438:UGC 5988:MCG 2-28-25:ZWG 66.52"
{
        Type  "S0"
        RA           10.8736
        Dec          10.5475
        Distance   3.094e+08  # method: V
        Radius       3.6e+04
        AbsMag        -20.58
        Axis    [  0.7450  -0.5911  -0.3093]
        Angle    118.9628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3438"
}

Galaxy "NGC 3439:ZWG 66.50"
{
        Type  "E0"
        RA           10.8736
        Dec           8.5578
        Distance   3.312e+08  # distance uncertain!
        Radius     1.927e+04
        AbsMag        -20.13
        Axis    [ -0.1469   0.4354  -0.8882]
        Angle    101.9194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3439"
}

Galaxy "NGC 3440:UGC 6009:MCG 10-16-19:ZWG 291.9"
{
        Type  "SBb"
        RA           10.8969
        Dec          57.1189
        Distance   9.395e+07  # method: V
        Radius      2.87e+04
        AbsMag         -18.3
        Axis    [  0.6707   0.0518   0.7399]
        Angle     76.1340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3440"
}

Galaxy "NGC 3441:UGC 5993:MCG 1-28-17:ZWG 38.40"
{
        Type  "Sc"
        RA           10.8753
        Dec           7.2250
        Distance   3.175e+08  # method: V
        Radius     3.232e+04
        AbsMag        -20.74
        Axis    [  0.9889  -0.1447  -0.0347]
        Angle    106.5460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3441"
}

Galaxy "NGC 3442:UGC 6001:MK 418:ZWG 184.34"
{
        Type  "Sa"
        RA           10.8856
        Dec          33.9100
        Distance   9.096e+07  # method: V
        Radius          7938
        AbsMag        -18.43
        Axis    [  0.9227  -0.3795  -0.0685]
        Angle     73.8844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3442"
}

Galaxy "NGC 3443:UGC 6000:MCG 3-28-25:ZWG 95.56"
{
        Type  "Sc"
        RA           10.8833
        Dec          17.5739
        Distance   8.884e+07  # method: T-F
        Radius     3.618e+04
        AbsMag        -17.87
        Axis    [ -0.5966   0.6679  -0.4450]
        Angle     46.5890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3443"
}

Galaxy "NGC 3444:UGC 6004:ZWG 66.55:FGC 1148"
{
        Type  "Sc"
        RA           10.8831
        Dec          10.2106
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.9729   0.1325   0.1894]
        Angle     94.5013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3444"
}

Galaxy "NGC 3445:UGC 6021:MCG 10-16-23:ZWG 291.11"
{
        Type  "Irr"
        RA           10.9097
        Dec          56.9900
        Distance   9.894e+07  # method: V
        Radius     2.302e+04
        AbsMag        -19.51
        Axis    [  0.4561   0.8604  -0.2275]
        Angle     32.6253
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3445"
}

Galaxy "NGC 3447:UGC 6006:MCG 3-28-27:ZWG 95.58"
{
        Type  "Irr"
        RA           10.8900
        Dec          16.7719
        Distance   6.338e+07  # method: V
        Radius     3.503e+04
        AbsMag        -17.54
        Axis    [  0.9749  -0.2154   0.0561]
        Angle    108.0061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3447"
}

Galaxy "NGC 3447A:UGC 6007:MCG 3-28-28:VV 252"
{
        Type  "Irr"
        RA           10.8917
        Dec          16.7847
        Distance   6.396e+07  # method: V
        Radius     1.395e+04
        AbsMag        -18.36
        Axis    [  0.2162   0.7441  -0.6322]
        Angle     27.8551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3447A"
}

Galaxy "NGC 3448:UGC 6024:MCG 9-18-55:ZWG 267.27"
{
        Type  "Sa"
        RA           10.9106
        Dec          54.3053
        Distance   6.949e+07  # method: V
        Radius      5.66e+04
        AbsMag        -19.14
        Axis    [  0.6276   0.1855   0.7561]
        Angle     59.5963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3448"
}

Galaxy "NGC 3449:ESO 376-25:MCG 5-26-10:IRAS 10505-3240"
{
        Type  "SBb"
        RA           10.8814
        Dec         -32.9278
        Distance   1.527e+08  # method: T-F
        Radius     7.327e+04
        AbsMag        -20.85
        Axis    [ -0.5372  -0.1179  -0.8351]
        Angle     55.0610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3449"
}

Galaxy "NGC 3450:ESO 569-6:MCG 3-28-4:UGCA 218"
{
        Type  "SBb"
        RA           10.8008
        Dec         -20.8489
        Distance   1.932e+08  # method: V
        Radius     7.306e+04
        AbsMag        -21.16
        Axis    [ -0.0920   0.1202  -0.9885]
        Angle     86.2399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3450"
}

Galaxy "NGC 3451:UGC 6023:MCG 5-26-28:ZWG 155.35"
{
        Type  "SBc"
        RA           10.9058
        Dec          27.2397
        Distance   1.257e+08  # method: T-F
        Radius     3.107e+04
        AbsMag        -19.43
        Axis    [  0.9865   0.0151   0.1630]
        Angle     59.3284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3451"
}

Galaxy "NGC 3452:MCG 2-28-19"
{
        Type  "Sa"
        RA           10.9039
        Dec         -11.4050
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.9093   0.2445  -0.3367]
        Angle     55.8549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3452"
}

Galaxy "NGC 3453:ESO 569-17:MCG 4-26-13:IRAS 10512-2131"
{
        Type  "SBb"
        RA           10.8944
        Dec         -21.7933
        Distance   1.945e+08  # method: V
        Radius     3.112e+04
        AbsMag        -19.98
        Axis    [  0.9685   0.0168  -0.2486]
        Angle    119.7722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3453"
}

Galaxy "NGC 3454:UGC 6026:MCG 3-28-30:ZWG 95.60"
{
        Type  "SBc"
        RA           10.9081
        Dec          17.3436
        Distance   6.514e+07  # method: V
        Radius      1.99e+04
        AbsMag         -17.5
        Axis    [ -0.2066   0.9075   0.3656]
        Angle     24.2112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3454"
}

Galaxy "NGC 3455:UGC 6028:MCG 3-28-31:ZWG 95.62"
{
        Type  "SBb"
        RA           10.9083
        Dec          17.2844
        Distance    6.51e+07  # method: V
        Radius     2.462e+04
        AbsMag         -18.4
        Axis    [  0.8956  -0.0746  -0.4385]
        Angle     56.7621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3455"
}

Galaxy "NGC 3456:MCG 3-28-18:IRAS 10515-1545"
{
        Type  "SBc"
        RA           10.9008
        Dec         -16.0275
        Distance    1.63e+08  # method: T-F
        Radius      4.03e+04
        AbsMag        -20.19
        Axis    [  0.2722   0.0888  -0.9581]
        Angle     63.2165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3456"
}

Galaxy "NGC 3457:NGC 3460:UGC 6030:MCG 3-28-32"
{
        Type  "S0"
        RA           10.9133
        Dec          17.6214
        Distance   6.752e+07  # method: S
        Radius          8839
        AbsMag        -18.38
        Axis    [  0.7238  -0.6312  -0.2789]
        Angle    114.2638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3457"
}

Galaxy "NGC 3458:UGC 6037:MCG 10-16-26:ZWG 291.14"
{
        Type  "S0"
        RA           10.9336
        Dec          57.1172
        Distance    8.97e+07  # method: V
        Radius     1.826e+04
        AbsMag         -18.9
        Axis    [  0.8144  -0.4095   0.4111]
        Angle     96.6196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3458"
}

Galaxy "NGC 3459:MCG 3-28-22:IRAS 10522-1646"
{
        Type  "Sb"
        RA           10.9122
        Dec         -17.0417
        Distance   1.365e+08  # method: V
        Radius     3.177e+04
        AbsMag        -18.91
        Axis    [ -0.7434   0.0689  -0.6652]
        Angle     52.0628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3459"
}

Galaxy "NGC 3461"
{
        Type  "E0"
        RA           10.9153
        Dec          17.7083
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.7032  -0.6474  -0.2940]
        Angle    115.0765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3461"
}

Galaxy "NGC 3462:UGC 6034:MCG 1-28-19:ZWG 38.49"
{
        Type  "S0"
        RA           10.9225
        Dec           7.6969
        Distance   9.715e+07  # distance uncertain!
        Radius     2.402e+04
        AbsMag        -19.07
        Axis    [  0.8850  -0.0462  -0.4632]
        Angle     62.0114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3462"
}

Galaxy "NGC 3463:ESO 502-2:MCG 4-26-14:IRAS 10528-2552"
{
        Type  "Sb"
        RA           10.9203
        Dec         -26.1403
        Distance   2.039e+08  # method: T-F
        Radius     4.448e+04
        AbsMag        -20.18
        Axis    [  0.6467   0.0917  -0.7572]
        Angle     65.1325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3463"
}

Galaxy "NGC 3464:ESO 569-22:MCG 3-28-21:UGCA 222"
{
        Type  "SBc"
        RA           10.9108
        Dec         -21.0664
        Distance   1.759e+08  # method: T-F
        Radius     6.398e+04
        AbsMag        -20.46
        Axis    [  0.1039   0.0806  -0.9913]
        Angle     64.5882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3464"
}

Galaxy "NGC 3465:UGC 6056:MCG 13-8-48:ZWG 351.50"
{
        Type  "Sb"
        RA           10.9919
        Dec          75.1917
        Distance   3.273e+08  # method: V
        Radius     5.713e+04
        AbsMag        -20.61
        Axis    [ -0.2296   0.9723  -0.0425]
        Angle     89.5047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3465"
}

Galaxy "NGC 3466:UGC 6042:MCG 2-28-28:ZWG 66.65"
{
        Type  "SBb"
        RA           10.9375
        Dec           9.7542
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.9575  -0.0139  -0.2881]
        Angle     61.3770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3466"
}

Galaxy "NGC 3467:UGC 6045:MCG 2-28-30:ZWG 66.67"
{
        Type  "S0"
        RA           10.9456
        Dec           9.7589
        Distance   4.449e+08  # method: V
        Radius     5.177e+04
        AbsMag        -21.27
        Axis    [  0.7401  -0.5935  -0.3163]
        Angle    119.9753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3467"
}

Galaxy "NGC 3468:UGC 6048:MCG 7-23-6:ZWG 213.10"
{
        Type  "S0"
        RA           10.9586
        Dec          40.9464
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.9092  -0.3050   0.2834]
        Angle     95.8983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3468"
}

Galaxy "NGC 3469:MCG 2-28-24:NPM 1"
{
        Type  "SBb"
        RA           10.9492
        Dec         -14.3003
        Distance   2.266e+08  # method: V
        Radius     5.602e+04
        AbsMag        -20.31
        Axis    [  0.0574   0.1339  -0.9893]
        Angle     60.6633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3469"
}

Galaxy "NGC 3470:UGC 6060:MCG 10-16-38:ZWG 291.16"
{
        Type  "Sb"
        RA           10.9789
        Dec          59.5106
        Distance    3.08e+08  # method: V
        Radius     6.721e+04
        AbsMag        -20.78
        Axis    [ -0.3517   0.9218  -0.1633]
        Angle     82.9141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3470"
}

Galaxy "NGC 3471:UGC 6064:MCG 10-16-39:MK 158"
{
        Type  "Sa"
        RA           10.9856
        Dec          61.5303
        Distance   1.026e+08  # method: V
        Radius     2.537e+04
        AbsMag        -19.29
        Axis    [  0.7875  -0.3312   0.5198]
        Angle     92.7159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3471"
}

Galaxy "NGC 3473:UGC 6052:MCG 3-28-41:ZWG 95.79"
{
        Type  "SBb"
        RA           10.9681
        Dec          17.1250
        Distance   4.279e+08  # method: V
        Radius     6.845e+04
        AbsMag        -20.99
        Axis    [  0.8490  -0.3324  -0.4108]
        Angle     78.6458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3473"
}

Galaxy "NGC 3474:MCG 3-28-42:ZWG 95.81:NPM 1"
{
        Type  "S0"
        RA           10.9689
        Dec          17.0961
        Distance   4.279e+08  # method: V
        Radius     4.978e+04
        AbsMag        -20.79
        Axis    [ -0.2068   0.5414  -0.8149]
        Angle     62.1988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3474"
}

Galaxy "NGC 3475:UGC 6058:MCG 4-26-22:ZWG 125.17"
{
        Type  "Sa"
        RA           10.9736
        Dec          24.2269
        Distance   3.053e+08  # method: V
        Radius     7.548e+04
        AbsMag        -20.56
        Axis    [  0.9815   0.0181  -0.1907]
        Angle     47.2391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3475"
}

Galaxy "NGC 3476:NGC 3480:MCG 2-28-32:ZWG 66.73"
{
        Type  "E0"
        RA           10.9686
        Dec           9.2761
        Distance   3.468e+08  # distance uncertain!
        Radius     4.035e+04
        AbsMag        -20.13
        Axis    [  0.1142   0.1975  -0.9736]
        Angle     89.7517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3476"
}

Galaxy "NGC 3477:ZWG 66.74"
{
        Type  "Sa"
        RA           10.9700
        Dec           9.2178
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.9509   0.2055  -0.2313]
        Angle     44.2216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3477"
}

Galaxy "NGC 3478:UGC 6069:MCG 8-20-59:ZWG 241.51"
{
        Type  "SBc"
        RA           10.9908
        Dec          46.1231
        Distance    3.12e+08  # method: V
        Radius      1.18e+05
        AbsMag         -21.4
        Axis    [ -0.3548   0.9075   0.2249]
        Angle     44.5570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3478"
}

Galaxy "NGC 3479:NGC 3502:MCG 2-28-27:IRAS 10563-1441"
{
        Type  "SBc"
        RA           10.9819
        Dec         -14.9611
        Distance   2.219e+08  # method: V
        Radius      5.81e+04
        AbsMag        -20.36
        Axis    [ -0.6748   0.2185  -0.7049]
        Angle     85.4559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3479"
}

Galaxy "NGC 3481:MCG 1-28-16:IRAS 10569-0716"
{
        Type  "Sb"
        RA           10.9906
        Dec          -7.5442
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.2599   0.2556  -0.9312]
        Angle     65.8313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3481"
}

Galaxy "NGC 3482:ESO 264-56"
{
        Type  "SBa"
        RA           10.9761
        Dec         -46.5842
        Distance   1.423e+08  # method: V
        Radius     3.933e+04
        AbsMag         -19.7
        Axis    [  0.8529  -0.0062  -0.5221]
        Angle    132.8867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3482"
}

Galaxy "NGC 3483:ESO 438-1:MCG 5-26-16:AM 1056-281"
{
        Type  "Sa"
        RA           10.9833
        Dec         -28.4778
        Distance    1.84e+08  # method: V
        Radius     4.816e+04
        AbsMag        -20.66
        Axis    [  0.1927   0.0102  -0.9812]
        Angle     70.3259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3483"
}

Galaxy "NGC 3485:UGC 6077:MCG 3-28-44:ZWG 95.85"
{
        Type  "SBb"
        RA           11.0006
        Dec          14.8411
        Distance   8.023e+07  # method: V
        Radius       2.8e+04
        AbsMag        -19.25
        Axis    [  0.2784   0.2325  -0.9319]
        Angle     57.1321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3485"
}

Galaxy "NGC 3486:UGC 6079:MCG 5-26-32:ZWG 155.41"
{
        Type  "SBc"
        RA           11.0067
        Dec          28.9756
        Distance   4.421e+07  # method: V
        Radius     4.566e+04
        AbsMag        -19.66
        Axis    [  0.9027   0.1689  -0.3957]
        Angle     36.7271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3486"
}

Galaxy "NGC 3487:UGC 6092:MCG 3-28-47:ZWG 95.89"
{
        Type  "Sc"
        RA           11.0128
        Dec          17.5875
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.7241   0.6025  -0.3357]
        Angle     50.4735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3487"
}

Galaxy "NGC 3488:UGC 6096:MCG 10-16-45:ZWG 291.22"
{
        Type  "SBc"
        RA           11.0231
        Dec          57.6775
        Distance   1.428e+08  # method: V
        Radius     3.739e+04
        AbsMag        -19.61
        Axis    [ -0.4822   0.8729  -0.0749]
        Angle     84.9098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3488"
}

Galaxy "NGC 3489:UGC 6082:MCG 2-28-39:ZWG 66.84"
{
        Type  "SBa"
        RA           11.0050
        Dec          13.9008
        Distance   3.939e+07  # method: S
        Radius     2.063e+04
        AbsMag        -19.31
        Axis    [  0.9248   0.0678  -0.3744]
        Angle     47.5581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3489"
}

Galaxy "NGC 3490:MCG 2-28-36:ZWG 66.80:NPM 1"
{
        Type  "E0"
        RA           10.9983
        Dec           9.3622
        Distance   3.468e+08  # distance uncertain!
        Radius     2.522e+04
        AbsMag        -20.13
        Axis    [  0.7168  -0.6122  -0.3338]
        Angle    121.5687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3490"
}

Galaxy "NGC 3491:UGC 6088:MCG 2-28-41:ZWG 66.89"
{
        Type  "S0"
        RA           11.0097
        Dec          12.1617
        Distance   3.047e+08  # method: V
        Radius     3.989e+04
        AbsMag        -20.55
        Axis    [  0.7286  -0.6115  -0.3086]
        Angle    118.7013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3491"
}

Galaxy "NGC 3492-1:UGC 6094:MCG 2-28-45:ZWG 66.93"
{
        Type  "E0"
        RA           11.0158
        Dec          10.5064
        Distance   5.082e+08  # method: V
        Radius      8.13e+04
        AbsMag        -21.76
        Axis    [  0.2612   0.0463  -0.9642]
        Angle     86.2367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3492-1"
}

Galaxy "NGC 3492-2:UGC 6094:MCG 2-28-45:ZWG 66.93"
{
        Type  "E0"
        RA           11.0156
        Dec          10.5044
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.7124  -0.6195  -0.3298]
        Angle    120.8643
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3492-2"
}

Galaxy "NGC 3493:UGC 6099:MCG 5-26-36:ZWG 155.44"
{
        Type  "SBc"
        RA           11.0242
        Dec          27.7200
        Distance   4.196e+08  # method: V
        Radius     6.713e+04
        AbsMag        -20.25
        Axis    [  0.7354   0.4664   0.4917]
        Angle     35.7268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3493"
}

Galaxy "NGC 3495:UGC 6098:MCG 1-28-27:ZWG 38.88"
{
        Type  "Sc"
        RA           11.0208
        Dec           3.6269
        Distance   6.682e+07  # method: T-F
        Radius     4.762e+04
        AbsMag        -18.86
        Axis    [  0.9894   0.1183   0.0845]
        Angle     93.6267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3495"
}

Galaxy "NGC 3497:NGC 3525:NGC 3528:IC 2624"
{
        Type  "S0"
        RA           11.1217
        Dec         -19.4714
        Distance   1.838e+08  # method: V
        Radius      6.95e+04
        AbsMag        -21.15
        Axis    [  0.7838  -0.0047  -0.6210]
        Angle     75.7721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3497"
}

Galaxy "NGC 3499:UGC 6115:MCG 9-18-80:ZWG 267.37"
{
        Type  "Sa"
        RA           11.0528
        Dec          56.2222
        Distance   7.823e+07  # method: V
        Radius     1.024e+04
        AbsMag         -17.5
        Axis    [  0.7835  -0.5580   0.2733]
        Angle     90.9613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3499"
}

Galaxy "NGC 3500:UGC 6090:MCG 13-8-52:ZWG 351.52"
{
        Type  "Sb"
        RA           11.0308
        Dec          75.2011
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [  0.5715  -0.0514   0.8190]
        Angle     68.8347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3500"
}

Galaxy "NGC 3501:UGC 6116:MCG 3-28-51:ZWG 95.97"
{
        Type  "Sc"
        RA           11.0464
        Dec          17.9897
        Distance   8.775e+07  # method: T-F
        Radius     4.977e+04
        AbsMag        -18.45
        Axis    [  0.9575   0.0921   0.2734]
        Angle     86.6453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3501"
}

Galaxy "NGC 3504:UGC 6118:MCG 5-26-39:ZWG 155.49"
{
        Type  "SBb"
        RA           11.0531
        Dec          27.9731
        Distance   8.322e+07  # method: V
        Radius     3.268e+04
        AbsMag        -20.33
        Axis    [ -0.4810   0.7174  -0.5040]
        Angle     66.7787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3504"
}

Galaxy "NGC 3506:UGC 6120:MCG 2-28-47:ZWG 66.105"
{
        Type  "Sc"
        RA           11.0533
        Dec          11.0769
        Distance   3.055e+08  # method: V
        Radius     4.888e+04
        AbsMag        -21.56
        Axis    [  0.8113  -0.2990  -0.5024]
        Angle     79.9045
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3506"
}

Galaxy "NGC 3507:UGC 6123:MCG 3-28-53:ZWG 95.100"
{
        Type  "SBb"
        RA           11.0569
        Dec          18.1347
        Distance   5.921e+07  # method: V
        Radius     2.928e+04
        AbsMag        -18.59
        Axis    [  0.2185   0.3672  -0.9041]
        Angle     47.2157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3507"
}

Galaxy "NGC 3508:NGC 3505:IC 2622:MCG 3-28-31"
{
        Type  "Sb"
        RA           11.0497
        Dec         -16.2886
        Distance   1.922e+08  # method: V
        Radius     3.074e+04
        AbsMag        -19.85
        Axis    [  0.8945  -0.2020  -0.3988]
        Angle    115.2625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3508"
}

Galaxy "NGC 3509:UGC 6134:MCG 1-28-33:ZWG 38.109"
{
        Type  "SBc"
        RA           11.0733
        Dec           4.8283
        Distance   3.648e+08  # method: V
        Radius     1.114e+05
        AbsMag        -21.44
        Axis    [  0.9879  -0.0205  -0.1538]
        Angle     74.5926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3509"
}

Galaxy "NGC 3510:UGC 6126:MCG 5-26-40:ZWG 155.50"
{
        Type  "Irr"
        RA           11.0619
        Dec          28.8847
        Distance    6.36e+07  # method: T-F
        Radius     3.793e+04
        AbsMag        -18.25
        Axis    [ -0.8432   0.5163   0.1498]
        Angle     61.4104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3510"
}

Galaxy "NGC 3511:ESO 502-13:MCG 4-26-20:UGCA 223"
{
        Type  "SBc"
        RA           11.0564
        Dec         -23.0864
        Distance   5.269e+07  # method: T-F
        Radius     4.598e+04
        AbsMag        -19.54
        Axis    [  0.7296   0.1313  -0.6712]
        Angle     56.5466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3511"
}

Galaxy "NGC 3512:UGC 6128:MCG 5-26-41:ZWG 155.51"
{
        Type  "SBc"
        RA           11.0672
        Dec          28.0375
        Distance   7.583e+07  # method: V
        Radius     1.765e+04
        AbsMag        -18.83
        Axis    [ -0.0588   0.5893  -0.8058]
        Angle     59.5988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3512"
}

Galaxy "NGC 3513:ESO 502-14:MCG 4-26-21:UGCA 224"
{
        Type  "SBb"
        RA           11.0625
        Dec         -23.2442
        Distance   6.963e+07  # method: V
        Radius     2.937e+04
        AbsMag        -19.75
        Axis    [  0.5157  -0.0820  -0.8528]
        Angle     86.8566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3513"
}

Galaxy "NGC 3514:ESO 570-1:MCG 3-28-35:IRAS 11015-1830"
{
        Type  "SBc"
        RA           11.0664
        Dec         -18.7806
        Distance   1.065e+08  # distance uncertain!
        Radius     1.704e+04
        AbsMag        -19.07
        Axis    [  0.0408   0.0602  -0.9974]
        Angle     73.9630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3514"
}

Galaxy "NGC 3515:UGC 6139:MCG 5-26-44:ZWG 155.55"
{
        Type  "Sc"
        RA           11.0769
        Dec          28.2281
        Distance    4.12e+08  # method: V
        Radius     5.393e+04
        AbsMag        -20.81
        Axis    [  0.9512  -0.1997  -0.2353]
        Angle     55.6579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3515"
}

Galaxy "NGC 3516:UGC 6153:MCG 12-11-9:ZWG 334.11"
{
        Type  "S0"
        RA           11.1131
        Dec          72.5692
        Distance   1.221e+08  # method: V
        Radius     3.375e+04
        AbsMag        -20.37
        Axis    [  0.7110  -0.4604   0.5316]
        Angle     70.8691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3516"
}

Galaxy "NGC 3517-1:UGC 6144:MCG 10-16-55:ZWG 291.27"
{
        Type  "Sb"
        RA           11.0933
        Dec          56.5253
        Distance   1.223e+08  # distance uncertain!
        Radius     1.779e+04
        AbsMag        -19.07
        Axis    [  0.0943   0.9929  -0.0719]
        Angle     37.7277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3517-1"
}

Galaxy "NGC 3517-2:MCG 10-16-57:KCPG 266B"
{
        Type  "Sb"
        RA           11.0936
        Dec          56.5344
        Distance   3.829e+08  # method: V
        Radius     2.785e+04
        AbsMag        -18.85
        Axis    [ -0.5868   0.7904   0.1759]
        Angle     75.7861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3517-2"
}

Galaxy "NGC 3520:ESO 570-4"
{
        Type  "E1"
        RA           11.1189
        Dec         -18.0247
        Distance   2.512e+08  # distance uncertain!
        Radius      4.75e+04
        AbsMag        -20.13
        Axis    [ -0.3701   0.2991  -0.8795]
        Angle    120.3297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3520"
}

Galaxy "NGC 3521:UGC 6150:MCG 0-28-30:ZWG 10.74"
{
        Type  "SBc"
        RA           11.0967
        Dec          -0.0369
        Distance   4.227e+07  # method: T-F
        Radius     6.885e+04
        AbsMag        -20.56
        Axis    [ -0.7787   0.3219  -0.5386]
        Angle     60.3460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3521"
}

Galaxy "NGC 3522:UGC 6159:MCG 3-28-60:ZWG 95.113"
{
        Type  "E0"
        RA           11.1111
        Dec          20.0861
        Distance   8.307e+07  # method: S
        Radius      1.45e+04
        AbsMag        -17.93
        Axis    [  0.1396   0.2512  -0.9578]
        Angle     79.8034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3522"
}

Galaxy "NGC 3523:UGC 6105:MCG 13-8-53:ZWG 351.54"
{
        Type  "Sc"
        RA           11.0517
        Dec          75.1158
        Distance   3.242e+08  # method: V
        Radius     6.129e+04
        AbsMag        -21.39
        Axis    [  0.4116  -0.9061   0.0977]
        Angle     83.8470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3523"
}

Galaxy "NGC 3524:UGC 6158:MCG 2-28-50:ZWG 66.112"
{
        Type  "Sa"
        RA           11.1089
        Dec          11.3850
        Distance   7.538e+07  # method: V
        Radius     1.754e+04
        AbsMag        -18.32
        Axis    [  0.9948  -0.0170   0.1007]
        Angle     97.6597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3524"
}

Galaxy "NGC 3526:NGC 3531:UGC 6167:MCG 1-28-39"
{
        Type  "Sc"
        RA           11.1156
        Dec           7.1733
        Distance   8.009e+07  # method: V
        Radius     2.213e+04
        AbsMag        -18.15
        Axis    [  0.9678   0.2122   0.1356]
        Angle     59.2543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3526"
}

Galaxy "NGC 3527:UGC 6170:MCG 5-26-59:ZWG 155.66"
{
        Type  "SBa"
        RA           11.1217
        Dec          28.5278
        Distance   4.707e+08  # method: V
        Radius     6.846e+04
        AbsMag         -20.9
        Axis    [ -0.3623   0.7034  -0.6115]
        Angle     73.3659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3527"
}

Galaxy "NGC 3529:IC 2625:ESO 570-7:MCG 3-28-38"
{
        Type  "SBb"
        RA           11.1219
        Dec         -19.5561
        Distance   1.281e+08  # distance uncertain!
        Radius     1.863e+04
        AbsMag        -19.07
        Axis    [  0.7083  -0.1244  -0.6948]
        Angle     90.6790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3529"
}

Galaxy "NGC 3530:UGC 6188:MCG 10-16-64:ZWG 291.30"
{
        Type  "S0"
        RA           11.1444
        Dec          57.2303
        Distance   9.518e+07  # method: V
        Radius          9690
        AbsMag        -17.73
        Axis    [  0.2629   0.5946   0.7598]
        Angle     42.2044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3530"
}

Galaxy "NGC 3533:NGC 3557A:ESO 377-11:MCG 6-25-2"
{
        Type  "Sb"
        RA           11.1186
        Dec         -37.1731
        Distance     1.3e+08  # method: T-F
        Radius     5.293e+04
        AbsMag         -19.2
        Axis    [  0.7749   0.1985  -0.6001]
        Angle     65.8446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3533"
}

Galaxy "NGC 3534A:UGC 6190:MCG 5-26-62:ZWG 155.72"
{
        Type  "Sb"
        RA           11.1486
        Dec          26.6103
        Distance   3.116e+08  # method: V
        Radius     5.892e+04
        AbsMag         -19.6
        Axis    [  0.5778   0.5453   0.6073]
        Angle     32.1044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3534A"
}

Galaxy "NGC 3534B:UGC 6193:MCG 5-26-63:ZWG 155.74"
{
        Type  "Sb"
        RA           11.1492
        Dec          26.5967
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.7800   0.6005  -0.1758]
        Angle     66.5668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3534B"
}

Galaxy "NGC 3535:UGC 6189:MCG 1-29-4:ZWG 39.10"
{
        Type  "Sa"
        RA           11.1425
        Dec           4.8325
        Distance   3.314e+08  # method: V
        Radius     8.193e+04
        AbsMag        -20.63
        Axis    [ -0.8538   0.3405  -0.3939]
        Angle     72.4324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3535"
}

Galaxy "NGC 3536:UGC 6191:MCG 5-26-61:ZWG 155.73"
{
        Type  "SBa"
        RA           11.1475
        Dec          28.4761
        Distance   5.084e+08  # method: V
        Radius     8.133e+04
        AbsMag        -20.96
        Axis    [ -0.5056   0.7294  -0.4607]
        Angle     59.9049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3536"
}

Galaxy "NGC 3537-1"
{
        Type  "Sb"
        RA           11.1406
        Dec         -10.2567
        Distance   1.115e+08  # distance uncertain!
        Radius     2.271e+04
        AbsMag        -19.07
        Axis    [  0.6644  -0.2257  -0.7125]
        Angle     94.1512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3537-1"
}

Galaxy "NGC 3537-2"
{
        Type  "S0"
        RA           11.1408
        Dec         -10.2589
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.9134   0.0690  -0.4011]
        Angle     65.8520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3537-2"
}

Galaxy "NGC 3539:MCG 5-26-65:ZWG 155.77:DRCG 23-38"
{
        Type  "S0"
        RA           11.1522
        Dec          28.6725
        Distance   4.544e+08  # method: V
        Radius      7.27e+04
        AbsMag        -20.12
        Axis    [  0.9468  -0.0543   0.3172]
        Angle    113.0872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3539"
}

Galaxy "NGC 3540:NGC 3548:UGC 6196:MCG 6-25-11"
{
        Type  "S0"
        RA           11.1544
        Dec          36.0214
        Distance   3.015e+08  # method: V
        Radius     6.139e+04
        AbsMag        -20.03
        Axis    [  0.9231  -0.2173  -0.3174]
        Angle     47.7595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3540"
}

Galaxy "NGC 3541:MCG 2-29-3"
{
        Type  "Sc"
        RA           11.1422
        Dec         -10.4919
        Distance   3.005e+08  # method: V
        Radius     6.118e+04
        AbsMag        -19.62
        Axis    [ -0.2234   0.2081  -0.9523]
        Angle     83.8325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3541"
}

Galaxy "NGC 3542:MCG 6-25-13:ZWG 185.13:IRAS 11071+3712"
{
        Type  "SBc"
        RA           11.1653
        Dec          36.9464
        Distance   4.241e+08  # method: V
        Radius     4.935e+04
        AbsMag        -20.47
        Axis    [  0.9182  -0.0494   0.3930]
        Angle     66.3911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3542"
}

Galaxy "NGC 3543:UGC 6213:MCG 10-16-75:ZWG 291.34"
{
        Type  "Sc"
        RA           11.1822
        Dec          61.3469
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.7855  -0.2314   0.5739]
        Angle    109.5214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3543"
}

Galaxy "NGC 3545:NGC 3545A:MCG 6-25-17:ZWG 185.15"
{
        Type  "E0"
        RA           11.1703
        Dec          36.9669
        Distance   3.312e+08  # distance uncertain!
        Radius     2.408e+04
        AbsMag        -20.13
        Axis    [  0.6103  -0.7659  -0.2023]
        Angle    104.4821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3545"
}

Galaxy "NGC 3545B:MCG 6-25-16:ZWG 185.15:VV 182"
{
        Type  "S0"
        RA           11.1700
        Dec          36.9647
        Distance   1.938e+08  # distance uncertain!
        Radius      1.41e+04
        AbsMag        -19.07
        Axis    [  0.6326  -0.7526  -0.1827]
        Angle    103.9033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3545B"
}

Galaxy "NGC 3546:MCG 2-29-7:NPM 1"
{
        Type  "S0"
        RA           11.1628
        Dec         -13.3803
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [  0.3436   0.0867  -0.9351]
        Angle     48.8039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3546"
}

Galaxy "NGC 3547:UGC 6209:MCG 2-29-7:ZWG 67.19"
{
        Type  "Sb"
        RA           11.1653
        Dec          10.7208
        Distance   8.865e+07  # method: V
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.9919  -0.1244   0.0269]
        Angle    104.0602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3547"
}

Galaxy "NGC 3549:UGC 6215:MCG 9-18-97:ZWG 267.47"
{
        Type  "Sc"
        RA           11.1822
        Dec          53.3881
        Distance   1.508e+08  # method: T-F
        Radius     6.797e+04
        AbsMag        -20.52
        Axis    [  0.7936  -0.1113   0.5982]
        Angle     78.2768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3549"
}

Galaxy "NGC 3550:UGC 6214:MCG 5-27-2:ZWG 155.82"
{
        Type  "S0"
        RA           11.1772
        Dec          28.7678
        Distance   4.811e+08  # method: V
        Radius     6.998e+04
        AbsMag        -21.64
        Axis    [  0.6635  -0.7117  -0.2309]
        Angle    108.9614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3550"
}

Galaxy "NGC 3551:UGC 6203:MCG 4-26-35:ZWG 125.33"
{
        Type  "E0"
        RA           11.1622
        Dec          21.7592
        Distance   2.754e+08  # distance uncertain!
        Radius     7.211e+04
        AbsMag        -20.13
        Axis    [  0.6490  -0.5662  -0.5082]
        Angle     95.1357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3551"
}

Galaxy "NGC 3552:MCG 5-27-3:ZWG 155.85:ZWG 156.6"
{
        Type  "S0"
        RA           11.1783
        Dec          28.6931
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.6636  -0.7114  -0.2313]
        Angle    109.0174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3552"
}

Galaxy "NGC 3553:MCG 5-27-4:ZWG 156.6:ZWG 155.85"
{
        Type  "S0"
        RA           11.1778
        Dec          28.6858
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [  0.9206  -0.3905  -0.0049]
        Angle     88.9525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3553"
}

Galaxy "NGC 3554:MCG 5-27-7:ZWG 155.86:ZWG 156.7"
{
        Type  "E0"
        RA           11.1797
        Dec          28.6606
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.6419  -0.7253  -0.2490]
        Angle    109.7704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3554"
}

Galaxy "NGC 3555:ZWG 125.34"
{
        Type  "S0"
        RA           11.1639
        Dec          21.8106
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.9309  -0.3593  -0.0655]
        Angle     93.3231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3555"
}

Galaxy "M 108:NGC 3556:UGC 6225:MCG 9-18-98"
{
        Type  "Sc"
        RA           11.1914
        Dec          55.6728
        Distance   3.923e+07  # method: V
        Radius     4.907e+04
        AbsMag         -19.8
        Axis    [  0.4682   0.2851   0.8363]
        Angle     54.9480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 108"
}

Galaxy "NGC 3557:ESO 377-16:MCG 6-25-5:AM 1107-371"
{
        Type  "E3"
        RA           11.1658
        Dec         -37.5394
        Distance   1.491e+08  # method: S
        Radius     8.674e+04
        AbsMag         -21.7
        Axis    [  0.6762  -0.3553  -0.6454]
        Angle    149.5880
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3557"
}

Galaxy "NGC 3557B:ESO 377-15:MCG 6-25-4"
{
        Type  "E5"
        RA           11.1586
        Dec         -37.3497
        Distance   1.432e+08  # method: V
        Radius     4.167e+04
        AbsMag        -19.71
        Axis    [  0.0332  -0.0661  -0.9973]
        Angle    129.2603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3557B"
}

Galaxy "NGC 3558:MCG 5-27-8:MK 422:ZWG 155.89"
{
        Type  "E0"
        RA           11.1819
        Dec          28.5436
        Distance   4.445e+08  # method: V
        Radius     5.818e+04
        AbsMag        -20.87
        Axis    [ -0.0038   0.4980  -0.8672]
        Angle     81.1140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3558"
}

Galaxy "NGC 3559:NGC 3560:UGC 6217:MCG 2-29-8"
{
        Type  "S0"
        RA           11.1792
        Dec          12.0164
        Distance   1.624e+08  # method: V
        Radius     3.071e+04
        AbsMag        -19.79
        Axis    [  0.9229  -0.1355  -0.3604]
        Angle     62.2908
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3559"
}

Galaxy "NGC 3561:NGC 3561A:UGC 6224:MCG 5-27-10"
{
        Type  "SBa"
        RA           11.1869
        Dec          28.6967
        Distance   4.007e+08  # method: V
        Radius     4.662e+04
        AbsMag        -20.75
        Axis    [  0.6627  -0.7121  -0.2316]
        Angle    109.0876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3561"
}

Galaxy "NGC 3561B:UGC 6224:MCG 5-27-11:ZWG 155.90"
{
        Type  "Sa"
        RA           11.1869
        Dec          28.7119
        Distance   4.126e+08  # method: V
        Radius       5.4e+04
        AbsMag        -21.21
        Axis    [  0.6627  -0.7122  -0.2315]
        Angle    109.0781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3561B"
}

Galaxy "NGC 3562:UGC 6242:MCG 12-11-11:ZWG 334.13"
{
        Type  "E0"
        RA           11.2161
        Dec          72.8792
        Distance   2.742e+08  # method: T-F
        Radius     6.779e+04
        AbsMag        -21.42
        Axis    [  0.4605  -0.8876  -0.0051]
        Angle     72.1357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3562"
}

Galaxy "NGC 3563:NGC 3563A:UGC 6234:MCG 5-27-14"
{
        Type  "S0"
        RA           11.1903
        Dec          26.9642
        Distance   4.631e+08  # method: V
        Radius     7.409e+04
        AbsMag        -21.26
        Axis    [ -0.6221   0.6724  -0.4011]
        Angle     76.3213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3563"
}

Galaxy "NGC 3563B:MCG 5-27-13:NPM 1:KCPG 277A"
{
        Type  "Sa"
        RA           11.1897
        Dec          26.9622
        Distance   1.768e+08  # distance uncertain!
        Radius       1.8e+04
        AbsMag        -19.07
        Axis    [  0.9513  -0.3039  -0.0516]
        Angle     74.7729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3563B"
}

Galaxy "NGC 3564:ESO 377-18:MCG 6-25-6:AM 1108-371"
{
        Type  "S0"
        RA           11.1767
        Dec         -37.5483
        Distance   1.421e+08  # method: V
        Radius     3.514e+04
        AbsMag           -20
        Axis    [  0.8973   0.0615  -0.4371]
        Angle    117.9569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3564"
}

Galaxy "NGC 3565:NGC 3566:ESO 570-8:NPM 1"
{
        Type  "S0"
        RA           11.1297
        Dec         -20.0225
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.1573   0.0889  -0.9835]
        Angle     77.4808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3565"
}

Galaxy "NGC 3567-1:UGC 6230:MCG 1-29-11:ZWG 39.51"
{
        Type  "S0"
        RA           11.1883
        Dec           5.8364
        Distance   3.031e+08  # method: V
        Radius     3.967e+04
        AbsMag        -20.54
        Axis    [ -0.1615   0.3416  -0.9259]
        Angle     64.7623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3567-1"
}

Galaxy "NGC 3567-2:MCG 1-29-12:ZWG 39.55:NPM 1"
{
        Type  "S0"
        RA           11.1889
        Dec           5.8308
        Distance   2.993e+08  # method: V
        Radius     3.048e+04
        AbsMag        -19.91
        Axis    [ -0.4798   0.4533  -0.7512]
        Angle     75.6208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3567-2"
}

Galaxy "NGC 3568:ESO 377-20:MCG 6-25-9:IRAS 11084-3710"
{
        Type  "SBc"
        RA           11.1800
        Dec         -37.4489
        Distance   8.476e+07  # method: T-F
        Radius     3.082e+04
        AbsMag        -19.07
        Axis    [  0.9255   0.1675  -0.3398]
        Angle    119.6523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3568"
}

Galaxy "NGC 3569:UGC 6238:MCG 6-25-20:ZWG 185.18"
{
        Type  "S0"
        RA           11.2022
        Dec          35.4519
        Distance   3.505e+08  # method: V
        Radius     5.607e+04
        AbsMag        -20.86
        Axis    [  0.7947  -0.0607  -0.6040]
        Angle     42.4474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3569"
}

Galaxy "NGC 3570:UGC 6240:MCG 5-27-19:ZWG 156.18"
{
        Type  "S0"
        RA           11.2008
        Dec          27.5903
        Distance   4.897e+08  # method: V
        Radius     7.123e+04
        AbsMag        -21.08
        Axis    [  0.6652  -0.7076  -0.2382]
        Angle    109.8964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3570"
}

Galaxy "NGC 3571:NGC 3544:ESO 570-11:MCG 3-29-1"
{
        Type  "SBa"
        RA           11.1917
        Dec         -18.2900
        Distance   1.795e+08  # method: V
        Radius     7.833e+04
        AbsMag         -20.6
        Axis    [  0.5735   0.1451  -0.8063]
        Angle     38.1146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3571"
}

Galaxy "NGC 3573:ESO 377-22:MCG 6-25-11:AM 1108-363"
{
        Type  "Sa"
        RA           11.1883
        Dec         -36.8756
        Distance   1.465e+08  # method: T-F
        Radius     7.673e+04
        AbsMag        -19.96
        Axis    [  0.9303   0.2208  -0.2929]
        Angle    119.9565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3573"
}

Galaxy "NGC 3574:MCG 5-27-22:ZWG 156.20:NPM 1"
{
        Type  "S0"
        RA           11.2033
        Dec          27.6253
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.6648  -0.7080  -0.2381]
        Angle    109.8952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3574"
}

Galaxy "NGC 3577:UGC 6257:MCG 8-21-6:ZWG 242.10"
{
        Type  "SBa"
        RA           11.2289
        Dec          48.2733
        Distance   2.512e+08  # method: V
        Radius     5.116e+04
        AbsMag        -19.73
        Axis    [ -0.4789   0.8437  -0.2425]
        Angle     84.8606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3577"
}

Galaxy "NGC 3580:MCG 1-29-18:ZWG 39.75"
{
        Type  "S0"
        RA           11.2211
        Dec           3.6575
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.9235   0.2557  -0.2858]
        Angle     67.6019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3580"
}

Galaxy "NGC 3583:UGC 6263:MCG 8-21-8:ZWG 242.12"
{
        Type  "SBb"
        RA           11.2364
        Dec          48.3183
        Distance   1.062e+08  # method: V
        Radius     4.326e+04
        AbsMag        -20.56
        Axis    [ -0.1320   0.9888   0.0694]
        Angle     35.9681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3583"
}

Galaxy "NGC 3585:ESO 502-25:MCG 4-27-4:AM 1110-262"
{
        Type  "E6"
        RA           11.2214
        Dec         -26.7550
        Distance   6.538e+07  # method: S
        Radius     4.374e+04
        AbsMag        -20.61
        Axis    [  0.0747  -0.0529  -0.9958]
        Angle    119.2811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3585"
}

Galaxy "NGC 3588-1:UGC 6264:MCG 4-27-9:ZWG 126.11"
{
        Type  "S0"
        RA           11.2339
        Dec          20.3864
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.6107   0.6462  -0.4577]
        Angle     50.0305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3588-1"
}

Galaxy "NGC 3588-2:UGC 6264:MCG 4-27-9:ZWG 126.11"
{
        Type  "S0"
        RA           11.2339
        Dec          20.3889
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.2458   0.5791  -0.7773]
        Angle     28.9312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3588-2"
}

Galaxy "NGC 3589:UGC 6275:MCG 10-16-96:ZWG 291.46"
{
        Type  "SBc"
        RA           11.2536
        Dec          60.7006
        Distance   9.568e+07  # method: V
        Radius     2.087e+04
        AbsMag        -17.94
        Axis    [  0.7769  -0.1849   0.6019]
        Angle     63.9279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3589"
}

Galaxy "NGC 3591:MCG 2-29-12:NPM 1"
{
        Type  "Sa"
        RA           11.2342
        Dec         -14.0867
        Distance    1.47e+08  # distance uncertain!
        Radius      2.78e+04
        AbsMag        -19.07
        Axis    [ -0.5109   0.1702  -0.8426]
        Angle     67.2414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3591"
}

Galaxy "NGC 3592:UGC 6267:MCG 3-29-11:ZWG 96.11"
{
        Type  "Sc"
        RA           11.2408
        Dec          17.2594
        Distance    7.38e+07  # method: V
        Radius     1.932e+04
        AbsMag        -17.17
        Axis    [ -0.3117   0.9426  -0.1202]
        Angle     19.7579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3592"
}

Galaxy "NGC 3593:UGC 6272:MCG 2-29-14:ZWG 67.40"
{
        Type  "Sa"
        RA           11.2436
        Dec          12.8183
        Distance   4.385e+07  # method: V
        Radius     3.317e+04
        AbsMag        -18.74
        Axis    [  0.8717   0.4480  -0.1985]
        Angle     24.8380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3593"
}

Galaxy "NGC 3594:UGC 6286:MCG 9-19-22:ZWG 267.58"
{
        Type  "S0"
        RA           11.2703
        Dec          55.7047
        Distance   2.912e+08  # method: V
        Radius     5.506e+04
        AbsMag        -19.45
        Axis    [  0.7107  -0.6950   0.1090]
        Angle     86.1958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3594"
}

Galaxy "NGC 3595:UGC 6280:MCG 8-21-9:ZWG 242.14"
{
        Type  "S0"
        RA           11.2569
        Dec          47.4469
        Distance   1.116e+08  # method: V
        Radius     2.596e+04
        AbsMag        -19.57
        Axis    [ -0.6822   0.7303   0.0346]
        Angle     78.4715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3595"
}

Galaxy "NGC 3596:UGC 6277:MCG 3-29-13:ZWG 96.13"
{
        Type  "SBc"
        RA           11.2517
        Dec          14.7869
        Distance   6.922e+07  # method: V
        Radius     4.027e+04
        AbsMag        -20.03
        Axis    [ -0.1711   0.4422  -0.8804]
        Angle     69.4442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3596"
}

Galaxy "NGC 3597:ESO 503-3:MCG 4-27-5:AM 1112-232"
{
        Type  "Sa"
        RA           11.2450
        Dec         -23.7272
        Distance   1.747e+08  # method: V
        Radius     4.573e+04
        AbsMag        -20.04
        Axis    [  0.6227  -0.1119  -0.7744]
        Angle     87.5057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3597"
}

Galaxy "NGC 3598:UGC 6278:MCG 3-29-14:ZWG 96.14"
{
        Type  "S0"
        RA           11.2531
        Dec          17.2625
        Distance   2.912e+08  # method: V
        Radius     7.623e+04
        AbsMag        -21.45
        Axis    [  0.9431  -0.2732  -0.1897]
        Angle     77.2722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3598"
}

Galaxy "NGC 3599:UGC 6281:MCG 3-29-15:ZWG 96.15"
{
        Type  "S0"
        RA           11.2572
        Dec          18.1103
        Distance   6.629e+07  # method: S
        Radius     2.603e+04
        AbsMag        -18.74
        Axis    [  0.4697   0.2483  -0.8471]
        Angle     38.1705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3599"
}

Galaxy "NGC 3600:UGC 6283:MCG 7-23-38:MK 1443"
{
        Type  "Sa"
        RA           11.2644
        Dec          41.5911
        Distance     5.5e+07  # method: T-F
        Radius     3.279e+04
        AbsMag        -18.53
        Axis    [  0.8981  -0.1323   0.4193]
        Angle    112.0496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3600"
}

Galaxy "NGC 3601:UGC 6282:MCG 1-29-24:ZWG 39.91"
{
        Type  "Sb"
        RA           11.2592
        Dec           5.1156
        Distance    3.72e+08  # method: V
        Radius     2.705e+04
        AbsMag        -20.89
        Axis    [  0.7211  -0.5966  -0.3522]
        Angle    125.1624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3601"
}

Galaxy "NGC 3602:MCG 3-29-17:ZWG 96.17"
{
        Type  "Sb"
        RA           11.2633
        Dec          17.4161
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.9708   0.0803   0.2259]
        Angle     65.1090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3602"
}

Galaxy "NGC 3605:UGC 6295:MCG 3-29-19:ZWG 96.19"
{
        Type  "E4"
        RA           11.2794
        Dec          18.0175
        Distance   6.752e+07  # method: S
        Radius     1.375e+04
        AbsMag        -18.48
        Axis    [  0.6602  -0.6408  -0.3918]
        Angle    109.6071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3605"
}

Galaxy "NGC 3606:ESO 377-32:MCG 5-27-4:AM 1113-333"
{
        Type  "E0"
        RA           11.2708
        Dec         -33.8275
        Distance   1.995e+08  # method: T-F
        Radius     4.352e+04
        AbsMag        -20.53
        Axis    [ -0.4525   0.1920  -0.8709]
        Angle    129.3231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3606"
}

Galaxy "NGC 3607:UGC 6297:MCG 3-29-20:ZWG 96.21"
{
        Type  "S0"
        RA           11.2817
        Dec          18.0522
        Distance   7.438e+07  # method: S
        Radius     4.976e+04
        AbsMag        -20.89
        Axis    [  0.0247   0.4051  -0.9139]
        Angle     49.1271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3607"
}

Galaxy "NGC 3608:UGC 6299:MCG 3-29-22:ZWG 96.22"
{
        Type  "E2"
        RA           11.2831
        Dec          18.1481
        Distance   7.472e+07  # method: S
        Radius     3.478e+04
        AbsMag         -20.1
        Axis    [  0.4547  -0.2263  -0.8614]
        Angle     80.0454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3608"
}

Galaxy "NGC 3609:UGC 6310:MCG 5-27-43:ZWG 156.50"
{
        Type  "Sb"
        RA           11.2972
        Dec          26.6253
        Distance   3.802e+08  # method: V
        Radius     6.636e+04
        AbsMag        -21.23
        Axis    [  0.8970  -0.3246  -0.3001]
        Angle     62.4625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3609"
}

Galaxy "NGC 3610:UGC 6319:MCG 10-16-107:ZWG 291.48"
{
        Type  "E5"
        RA           11.3067
        Dec          58.7867
        Distance   6.973e+07  # method: S
        Radius     2.738e+04
        AbsMag        -19.95
        Axis    [  0.1178   0.7860  -0.6069]
        Angle     70.1702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3610"
}

Galaxy "NGC 3611:NGC 3604:UGC 6305:MCG 1-29-26"
{
        Type  "Sa"
        RA           11.2917
        Dec           4.5553
        Distance   8.788e+07  # method: V
        Radius     2.556e+04
        AbsMag        -19.35
        Axis    [  0.8992  -0.3050  -0.3136]
        Angle     95.1873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3611"
}

Galaxy "NGC 3612:UGC 6321:MCG 5-27-51:ZWG 156.56"
{
        Type  "Sc"
        RA           11.3039
        Dec          26.6206
        Distance   3.921e+08  # method: V
        Radius     5.703e+04
        AbsMag         -20.5
        Axis    [ -0.4998   0.6910  -0.5223]
        Angle     65.6412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3612"
}

Galaxy "NGC 3613:UGC 6323:MCG 10-16-109:ZWG 291.49"
{
        Type  "E6"
        RA           11.3097
        Dec          58.0006
        Distance   9.494e+07  # method: S
        Radius     5.385e+04
        AbsMag        -20.52
        Axis    [  0.4913   0.3311  -0.8056]
        Angle     44.9113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3613"
}

Galaxy "NGC 3614:UGC 6318:MCG 8-21-15:ZWG 242.19"
{
        Type  "Sc"
        RA           11.3058
        Dec          45.7486
        Distance   1.158e+08  # method: V
        Radius     7.747e+04
        AbsMag        -20.45
        Axis    [  0.4001   0.8187   0.4119]
        Angle     26.3097
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3614"
}

Galaxy "NGC 3614A:MCG 8-21-14"
{
        Type  "Irr"
        RA           11.3031
        Dec          45.7169
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.5792  -0.8049  -0.1290]
        Angle    100.2616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3614A"
}

Galaxy "NGC 3615:UGC 6313:MCG 4-27-12:ZWG 126.21"
{
        Type  "E0"
        RA           11.3017
        Dec          23.3975
        Distance    3.17e+08  # method: V
        Radius     6.455e+04
        AbsMag        -21.14
        Axis    [  0.6149  -0.5328  -0.5814]
        Angle     88.8757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3615"
}

Galaxy "NGC 3617:ESO 503-12:MCG 4-27-8:UGCA 231"
{
        Type  "E0"
        RA           11.2972
        Dec         -26.1339
        Distance   1.149e+08  # method: V
        Radius     3.009e+04
        AbsMag        -19.13
        Axis    [ -0.2750   0.1494  -0.9498]
        Angle    120.1978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3617"
}

Galaxy "NGC 3618:UGC 6327:MCG 4-27-14:MK 1288"
{
        Type  "SBb"
        RA           11.3089
        Dec          23.4689
        Distance   3.225e+08  # method: V
        Radius     4.222e+04
        AbsMag        -20.58
        Axis    [ -0.5102   0.6608  -0.5504]
        Angle     83.9339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3618"
}

Galaxy "NGC 3619:UGC 6330:MCG 10-16-115:ZWG 291.54"
{
        Type  "Sa"
        RA           11.3225
        Dec          57.7583
        Distance   7.724e+07  # method: V
        Radius     3.033e+04
        AbsMag        -19.47
        Axis    [  0.9140  -0.3632   0.1810]
        Angle     45.0262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3619"
}

Galaxy "NGC 3620:ESO 38-10:IRAS 11143-7556"
{
        Type  "SBb"
        RA           11.2681
        Dec         -76.2172
        Distance    1.54e+08  # distance uncertain!
        Radius     6.046e+04
        AbsMag        -19.07
        Axis    [  0.3738  -0.0423  -0.9265]
        Angle    103.2462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3620"
}

Galaxy "NGC 3621:ESO 377-37:MCG 5-27-8:UGCA 232"
{
        Type  "SBc"
        RA           11.3042
        Dec         -32.8111
        Distance    2.22e+07  # method: T-F
        Radius     3.971e+04
        AbsMag        -19.06
        Axis    [ -0.6165  -0.0870  -0.7825]
        Angle     73.9404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3621"
}

Galaxy "NGC 3622:UGC 6339:ZWG 314.20:IRAS 11171+6730"
{
        Type  "S0"
        RA           11.3367
        Dec          67.2419
        Distance   6.401e+07  # method: V
        Radius     1.117e+04
        AbsMag        -17.76
        Axis    [  0.7493  -0.3957   0.5310]
        Angle    104.4706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3622"
}

Galaxy "M 65:NGC 3623:UGC 6328:MCG 2-29-18"
{
        Type  "Sa"
        RA           11.3153
        Dec          13.0908
        Distance   5.219e+07  # method: T-F
        Radius     7.438e+04
        AbsMag        -20.92
        Axis    [ -0.9250   0.3510  -0.1453]
        Angle     64.4801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 65"
}

Galaxy "NGC 3624:MCG 1-29-29:ZWG 39.114"
{
        Type  "SBb"
        RA           11.3139
        Dec           7.5208
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [ -0.6750   0.4455  -0.5882]
        Angle     63.9095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3624"
}

Galaxy "NGC 3625:UGC 6348:MCG 10-16-120:ZWG 291.57"
{
        Type  "SBb"
        RA           11.3419
        Dec          57.7811
        Distance   9.631e+07  # method: V
        Radius     2.802e+04
        AbsMag        -18.45
        Axis    [ -0.4955   0.7417   0.4522]
        Angle     64.5758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3625"
}

Galaxy "M 66:NGC 3627:UGC 6346:MCG 2-29-19"
{
        Type  "Sb"
        RA           11.3375
        Dec          12.9900
        Distance   3.171e+07  # method: T-F
        Radius     4.197e+04
        AbsMag        -20.24
        Axis    [ -0.8556   0.4265  -0.2934]
        Angle     65.8826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 66"
}

Galaxy "NGC 3628:UGC 6350:MCG 2-29-20:ZWG 67.58"
{
        Type  "Sb"
        RA           11.3378
        Dec          13.5900
        Distance   4.684e+07  # method: T-F
        Radius     8.925e+04
        AbsMag        -20.38
        Axis    [  0.5177   0.7958   0.3142]
        Angle     16.8238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3628"
}

Galaxy "NGC 3629:UGC 6352:MCG 5-27-58:ZWG 156.64"
{
        Type  "SBc"
        RA           11.3419
        Dec          26.9628
        Distance   8.245e+07  # method: V
        Radius     2.758e+04
        AbsMag        -19.11
        Axis    [  0.9432  -0.3308  -0.0301]
        Angle     78.1148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3629"
}

Galaxy "NGC 3631:UGC 6360:MCG 9-19-47:ZWG 268.21"
{
        Type  "Sc"
        RA           11.3506
        Dec          53.1697
        Distance   6.084e+07  # method: V
        Radius     4.424e+04
        AbsMag        -20.55
        Axis    [  0.2101   0.9747   0.0768]
        Angle     29.3358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3631"
}

Galaxy "NGC 3632:NGC 3626:UGC 6343:MCG 3-29-32"
{
        Type  "Sa"
        RA           11.3342
        Dec          18.3567
        Distance   6.538e+07  # method: S
        Radius     2.567e+04
        AbsMag        -19.71
        Axis    [ -0.5962   0.5942  -0.5400]
        Angle     59.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3632"
}

Galaxy "NGC 3633:UGC 6351:MCG 1-29-32:ZWG 39.126"
{
        Type  "Sa"
        RA           11.3406
        Dec           3.5856
        Distance   1.338e+08  # method: V
        Radius      2.14e+04
        AbsMag        -18.66
        Axis    [  0.9605   0.1099  -0.2556]
        Angle     43.7973
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3633"
}

Galaxy "NGC 3634:MCG 1-29-8:VV 724"
{
        Type  "E0"
        RA           11.3417
        Dec          -9.0136
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [  0.1656  -0.0574  -0.9845]
        Angle    102.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3634"
}

Galaxy "NGC 3635:MCG 1-29-9:VV 724:NPM 1"
{
        Type  "Sc"
        RA           11.3419
        Dec          -9.0131
        Distance    2.44e+08  # distance uncertain!
        Radius     6.034e+04
        AbsMag        -19.07
        Axis    [  0.9875   0.0234  -0.1561]
        Angle     98.3763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3635"
}

Galaxy "NGC 3636:MCG 2-29-19"
{
        Type  "E0"
        RA           11.3403
        Dec         -10.2819
        Distance   9.395e+07  # method: V
        Radius     1.776e+04
        AbsMag         -18.9
        Axis    [  0.7238  -0.5406  -0.4288]
        Angle    137.6762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3636"
}

Galaxy "NGC 3637:MCG 2-29-20"
{
        Type  "S0"
        RA           11.3442
        Dec         -10.2569
        Distance    9.98e+07  # method: V
        Radius     2.613e+04
        AbsMag        -18.73
        Axis    [ -0.1026   0.1235  -0.9870]
        Angle     81.9652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3637"
}

Galaxy "NGC 3638:MCG 1-29-7:IRAS 11176-0749"
{
        Type  "Sb"
        RA           11.3358
        Dec          -8.1056
        Distance   2.125e+08  # distance uncertain!
        Radius      7.11e+04
        AbsMag        -19.07
        Axis    [ -0.7469   0.1559  -0.6465]
        Angle     35.4453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3638"
}

Galaxy "NGC 3639:UGC 6374:MCG 3-29-36:ZWG 96.32"
{
        Type  "S0"
        RA           11.3597
        Dec          18.4586
        Distance   2.613e+08  # method: V
        Radius     2.281e+04
        AbsMag        -20.32
        Axis    [  0.8788  -0.3586  -0.3147]
        Angle     76.2140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3639"
}

Galaxy "NGC 3640:UGC 6368:MCG 1-29-33:ZWG 39.130"
{
        Type  "E3"
        RA           11.3517
        Dec           3.2347
        Distance   8.819e+07  # method: S
        Radius     5.131e+04
        AbsMag        -20.86
        Axis    [  0.2018  -0.0247  -0.9791]
        Angle     90.9131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3640"
}

Galaxy "NGC 3641:UGC 6370:MCG 1-29-34"
{
        Type  "E0"
        RA           11.3522
        Dec           3.1947
        Distance   8.698e+07  # method: S
        Radius     1.139e+04
        AbsMag        -18.03
        Axis    [  0.6973  -0.6100  -0.3765]
        Angle    128.1576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3641"
}

Galaxy "NGC 3642:UGC 6385:MCG 10-16-128:ZWG 291.62"
{
        Type  "Sc"
        RA           11.3714
        Dec          59.0750
        Distance   7.887e+07  # method: V
        Radius     6.309e+04
        AbsMag        -20.32
        Axis    [  0.5488   0.8348  -0.0431]
        Angle     26.6728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3642"
}

Galaxy "NGC 3643:MCG 1-29-36:ZWG 39.136"
{
        Type  "SBa"
        RA           11.3567
        Dec           3.0142
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.4133   0.1253  -0.9019]
        Angle     41.0072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3643"
}

Galaxy "NGC 3644:IC 684:UGC 6373:MCG 1-29-37"
{
        Type  "Sa"
        RA           11.3589
        Dec           2.8103
        Distance   2.226e+08  # distance uncertain!
        Radius     4.855e+04
        AbsMag        -19.07
        Axis    [  0.9448  -0.0022  -0.3277]
        Angle     54.2395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3644"
}

Galaxy "NGC 3645:NGC 3630:UGC 6349:MCG 1-29-31"
{
        Type  "Sa"
        RA           11.3378
        Dec           2.9644
        Distance   8.444e+07  # method: V
        Radius     2.456e+04
        AbsMag        -19.06
        Axis    [  0.9925  -0.0294  -0.1190]
        Angle     77.1645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3645"
}

Galaxy "NGC 3646:UGC 6376:MCG 3-29-37:ZWG 96.34"
{
        Type  "S0"
        RA           11.3619
        Dec          20.1692
        Distance   2.071e+08  # method: T-F
        Radius     1.175e+05
        AbsMag        -22.21
        Axis    [  0.9867  -0.1461  -0.0720]
        Angle     61.0413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3646"
}

Galaxy "NGC 3647:ZWG 39.142:"
{
        Type  "E0"
        RA           11.3606
        Dec           2.8914
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.6972  -0.6091  -0.3782]
        Angle    128.4202
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3647"
}

Galaxy "NGC 3648:UGC 6389:MCG 7-23-43:ZWG 213.43"
{
        Type  "S0"
        RA           11.3753
        Dec          39.8769
        Distance    1.07e+08  # method: V
        Radius     2.023e+04
        AbsMag        -19.08
        Axis    [  0.9778   0.0527   0.2026]
        Angle     35.6616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3648"
}

Galaxy "NGC 3649:IC 684:UGC 6386:MCG 3-29-38"
{
        Type  "SBa"
        RA           11.3706
        Dec          20.2086
        Distance   2.352e+08  # method: V
        Radius     4.788e+04
        AbsMag        -19.69
        Axis    [ -0.6842   0.6883  -0.2413]
        Angle     35.1896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3649"
}

Galaxy "NGC 3650:UGC 6391:MCG 4-27-31:ZWG 126.43"
{
        Type  "Sb"
        RA           11.3764
        Dec          20.7047
        Distance   1.851e+08  # distance uncertain!
        Radius     4.308e+04
        AbsMag        -19.07
        Axis    [  0.9238   0.1174   0.3646]
        Angle     61.6484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3650"
}

Galaxy "NGC 3651-1:UGC 6388:MCG 4-27-28:ZWG 126.42"
{
        Type  "E0"
        RA           11.3739
        Dec          24.2989
        Distance   3.627e+08  # method: V
        Radius     5.803e+04
        AbsMag        -20.63
        Axis    [  0.6375  -0.7187  -0.2778]
        Angle    114.1850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3651-1"
}

Galaxy "NGC 3651-2:UGC 6388:MCG 4-27-28:ZWG 126.42"
{
        Type  "S0"
        RA           11.3739
        Dec          24.2961
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.7829   0.5822  -0.2195]
        Angle     64.7921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3651-2"
}

Galaxy "NGC 3652:UGC 6392:MCG 6-25-55:ZWG 185.49"
{
        Type  "SBc"
        RA           11.3775
        Dec          37.7650
        Distance   1.067e+08  # method: V
        Radius     4.036e+04
        AbsMag        -19.77
        Axis    [ -0.6859   0.6648   0.2958]
        Angle     52.2596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3652"
}

Galaxy "NGC 3653:MCG 4-27-29:ZWG 126.44:HCG 51"
{
        Type  "S0"
        RA           11.3750
        Dec          24.2797
        Distance   4.174e+08  # method: V
        Radius     3.642e+04
        AbsMag        -20.84
        Axis    [  0.9332   0.0300  -0.3581]
        Angle     36.2648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3653"
}

Galaxy "NGC 3654:UGC 6407:MCG 12-11-22:ZWG 334.29"
{
        Type  "S0"
        RA           11.4028
        Dec          69.4128
        Distance   7.565e+07  # method: V
        Radius      1.32e+04
        AbsMag        -18.23
        Axis    [  0.7218  -0.3906   0.5714]
        Angle     90.6300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3654"
}

Galaxy "NGC 3655:UGC 6396:MCG 3-29-39:ZWG 96.37"
{
        Type  "Sc"
        RA           11.3817
        Dec          16.5897
        Distance   8.181e+07  # method: V
        Radius     1.785e+04
        AbsMag         -19.7
        Axis    [  0.9529  -0.2734  -0.1313]
        Angle     81.6971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3655"
}

Galaxy "NGC 3656:UGC 6403:MCG 9-19-63:ZWG 268.29"
{
        Type  "E0"
        RA           11.3939
        Dec          53.8422
        Distance   1.398e+08  # method: V
        Radius     3.253e+04
        AbsMag        -19.86
        Axis    [  0.5035  -0.8587  -0.0957]
        Angle     97.3523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3656"
}

Galaxy "NGC 3657:UGC 6406:MCG 9-19-65:ZWG 268.30"
{
        Type  "SBc"
        RA           11.3986
        Dec          52.9211
        Distance   6.351e+07  # method: V
        Radius     1.016e+04
        AbsMag        -18.45
        Axis    [ -0.5154   0.8564  -0.0305]
        Angle     71.9361
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3657"
}

Galaxy "NGC 3658:UGC 6409:MCG 7-24-2:ZWG 214.3"
{
        Type  "S0"
        RA           11.3994
        Dec          38.5636
        Distance   1.042e+08  # method: V
        Radius     2.728e+04
        AbsMag        -19.42
        Axis    [  0.7809  -0.5994  -0.1755]
        Angle     79.1008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3658"
}

Galaxy "NGC 3659:UGC 6405:MCG 3-29-40:ZWG 96.38"
{
        Type  "Irr"
        RA           11.3958
        Dec          17.8169
        Distance   7.298e+07  # method: V
        Radius     2.441e+04
        AbsMag        -18.95
        Axis    [  0.9813  -0.0986  -0.1651]
        Angle     52.6498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3659"
}

Galaxy "NGC 3660:MCG 1-29-16:UGCA 234:MK 1291"
{
        Type  "SBc"
        RA           11.3922
        Dec          -8.6586
        Distance   1.829e+08  # method: V
        Radius     7.448e+04
        AbsMag        -20.74
        Axis    [  0.0996   0.0491  -0.9938]
        Angle     63.1297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3660"
}

Galaxy "NGC 3661:IC 689:MCG 2-29-22"
{
        Type  "Sa"
        RA           11.3939
        Dec         -13.8308
        Distance   3.196e+08  # method: V
        Radius     7.438e+04
        AbsMag        -20.96
        Axis    [ -0.5686   0.0645  -0.8201]
        Angle     39.3684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3661"
}

Galaxy "NGC 3662:UGC 6408:MCG 0-29-25:ZWG 11.86"
{
        Type  "SBb"
        RA           11.3961
        Dec          -1.1053
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [  0.9502  -0.1741  -0.2583]
        Angle     92.8724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3662"
}

Galaxy "NGC 3663:MCG 2-29-23:IRAS 11214-1200"
{
        Type  "Sc"
        RA           11.3997
        Dec         -12.2967
        Distance   2.445e+08  # method: V
        Radius     7.113e+04
        AbsMag        -21.07
        Axis    [  0.5031  -0.0592  -0.8622]
        Angle     61.4107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3663"
}

Galaxy "NGC 3664:UGC 6419:MCG 1-29-41:DDO 95"
{
        Type  "Irr"
        RA           11.4067
        Dec           3.3264
        Distance   7.864e+07  # method: V
        Radius     2.288e+04
        AbsMag        -18.71
        Axis    [  0.7219  -0.3736  -0.5825]
        Angle     91.8851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3664"
}

Galaxy "NGC 3664A:UGC 6418:ZWG 39.169:KCPG 283A"
{
        Type  "Irr"
        RA           11.4069
        Dec           3.2219
        Distance   7.611e+07  # method: V
        Radius     1.218e+04
        AbsMag        -16.74
        Axis    [  0.8371  -0.4182  -0.3527]
        Angle    107.6654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3664A"
}

Galaxy "NGC 3665:UGC 6426:MCG 7-24-3:ZWG 214.4"
{
        Type  "S0"
        RA           11.4119
        Dec          38.7631
        Distance    1.05e+08  # method: V
        Radius     6.564e+04
        AbsMag        -20.84
        Axis    [  0.8728  -0.4827   0.0726]
        Angle     86.3290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3665"
}

Galaxy "NGC 3666:UGC 6420:MCG 2-29-25:ZWG 67.71"
{
        Type  "SBc"
        RA           11.4072
        Dec          11.3422
        Distance   5.812e+07  # method: T-F
        Radius     3.719e+04
        AbsMag        -18.85
        Axis    [  0.7174   0.6378   0.2803]
        Angle     17.8657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3666"
}

Galaxy "NGC 3667:NGC 3667A:MCG 2-29-25:NPM 1"
{
        Type  "Sb"
        RA           11.4044
        Dec         -13.8567
        Distance   2.585e+08  # method: V
        Radius      5.64e+04
        AbsMag        -20.69
        Axis    [  0.4739  -0.0732  -0.8775]
        Angle     65.2623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3667"
}

Galaxy "NGC 3667B:MCG 2-29-26"
{
        Type  "Sb"
        RA           11.4058
        Dec         -13.8558
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [  0.9338  -0.0025  -0.3579]
        Angle     81.2502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3667B"
}

Galaxy "NGC 3668:UGC 6430:MCG 11-14-23:ZWG 314.26"
{
        Type  "Sc"
        RA           11.4250
        Dec          63.4464
        Distance   1.653e+08  # method: V
        Radius     4.087e+04
        AbsMag        -20.42
        Axis    [ -0.1152   0.9872   0.1101]
        Angle     47.4520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3668"
}

Galaxy "NGC 3669:UGC 6431:MCG 10-16-135:ZWG 291.67"
{
        Type  "SBc"
        RA           11.4239
        Dec          57.7214
        Distance   9.513e+07  # method: V
        Radius     2.767e+04
        AbsMag        -19.22
        Axis    [ -0.5474   0.6951   0.4661]
        Angle     69.0439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3669"
}

Galaxy "NGC 3670:UGC 6427:MCG 4-27-33:ZWG 126.48"
{
        Type  "SBa"
        RA           11.4136
        Dec          23.9456
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.9605  -0.2758  -0.0354]
        Angle     74.4555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3670"
}

Galaxy "NGC 3671:ZWG 291.68:NPM 1"
{
        Type  "E0"
        RA           11.4311
        Dec          60.4800
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.4900  -0.8667  -0.0939]
        Angle     85.8119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3671"
}

Galaxy "NGC 3672:MCG 2-29-28:UGCA 235:IRAS 11225-0931"
{
        Type  "Sc"
        RA           11.4172
        Dec          -9.7947
        Distance   1.006e+08  # method: V
        Radius     5.853e+04
        AbsMag        -20.34
        Axis    [  0.9796  -0.0480  -0.1953]
        Angle    105.4497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3672"
}

Galaxy "NGC 3673:ESO 503-16:MCG 4-27-10:UGCA 236"
{
        Type  "SBb"
        RA           11.4200
        Dec         -26.7367
        Distance   1.033e+08  # method: V
        Radius     5.558e+04
        AbsMag         -20.2
        Axis    [  0.5731  -0.0828  -0.8153]
        Angle     76.1054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3673"
}

Galaxy "NGC 3674:UGC 6444:MCG 10-16-138:ZWG 291.69"
{
        Type  "S0"
        RA           11.4406
        Dec          57.0486
        Distance   9.282e+07  # method: V
        Radius     2.295e+04
        AbsMag        -19.07
        Axis    [  0.7881  -0.2134   0.5773]
        Angle     83.6440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3674"
}

Galaxy "NGC 3675:UGC 6439:MCG 7-24-4:ZWG 214.5"
{
        Type  "Sb"
        RA           11.4356
        Dec          43.5864
        Distance   6.868e+07  # method: T-F
        Radius     5.893e+04
        AbsMag        -20.81
        Axis    [ -0.6811   0.7306  -0.0478]
        Angle     77.0107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3675"
}

Galaxy "NGC 3676:MCG 2-29-29:NPM 1"
{
        Type  "S0"
        RA           11.4269
        Dec         -11.1392
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [ -0.3146   0.1758  -0.9328]
        Angle     75.6068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3676"
}

Galaxy "NGC 3677:UGC 6441:MCG 8-21-35:ZWG 242.35"
{
        Type  "Sa"
        RA           11.4381
        Dec          46.9744
        Distance   3.485e+08  # method: V
        Radius     9.629e+04
        AbsMag        -21.64
        Axis    [ -0.1170   0.9520  -0.2828]
        Angle     37.8437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3677"
}

Galaxy "NGC 3678:UGC 6443:MCG 5-27-71:ZWG 156.75"
{
        Type  "Sc"
        RA           11.4375
        Dec          27.8669
        Distance   3.401e+08  # method: V
        Radius     3.957e+04
        AbsMag        -20.79
        Axis    [  0.6407  -0.7281  -0.2438]
        Angle    111.7244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3678"
}

Galaxy "NGC 3679:MCG 1-29-12"
{
        Type  "E0"
        RA           11.3631
        Dec          -5.7578
        Distance   2.884e+08  # distance uncertain!
        Radius     4.195e+04
        AbsMag        -20.13
        Axis    [  0.3346  -0.1947  -0.9220]
        Angle    101.7332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3679"
}

Galaxy "NGC 3681:UGC 6445:MCG 3-29-48:ZWG 96.45"
{
        Type  "SBc"
        RA           11.4414
        Dec          16.8639
        Distance   7.117e+07  # method: V
        Radius     3.105e+04
        AbsMag        -19.29
        Axis    [ -0.6659   0.5594  -0.4937]
        Angle     70.6513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3681"
}

Galaxy "NGC 3682:UGC 6459:MCG 11-14-27:ZWG 314.29"
{
        Type  "Sa"
        RA           11.4614
        Dec          66.5908
        Distance   7.484e+07  # method: V
        Radius      1.85e+04
        AbsMag         -18.5
        Axis    [  0.4707   0.4802   0.7402]
        Angle     37.1215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3682"
}

Galaxy "NGC 3683:UGC 6458:MCG 10-16-143:ZWG 291.72"
{
        Type  "SBc"
        RA           11.4586
        Dec          56.8778
        Distance   8.249e+07  # method: V
        Radius      2.16e+04
        AbsMag        -18.81
        Axis    [ -0.2422   0.7648   0.5969]
        Angle     48.5140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3683"
}

Galaxy "NGC 3683A:UGC 6484:MCG 10-17-6:ZWG 291.75"
{
        Type  "SBc"
        RA           11.4864
        Dec          57.1331
        Distance   1.175e+08  # method: V
        Radius       4.1e+04
        AbsMag        -20.18
        Axis    [  0.8791  -0.0070   0.4765]
        Angle     36.4131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3683A"
}

Galaxy "NGC 3684:UGC 6453:MCG 3-29-50:ZWG 96.47"
{
        Type  "Sc"
        RA           11.4531
        Dec          17.0308
        Distance   6.777e+07  # method: V
        Radius     3.056e+04
        AbsMag        -19.29
        Axis    [ -0.3153   0.5753  -0.7547]
        Angle     36.5278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3684"
}

Galaxy "NGC 3685:MCG 1-29-45:ZWG 39.192:KCPG 287B"
{
        Type  "S0"
        RA           11.4711
        Dec           4.3275
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.5669   0.3775  -0.7322]
        Angle     42.0424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3685"
}

Galaxy "NGC 3686:UGC 6460:MCG 3-29-51:ZWG 96.49"
{
        Type  "SBc"
        RA           11.4622
        Dec          17.2233
        Distance   6.736e+07  # method: V
        Radius     3.037e+04
        AbsMag        -19.57
        Axis    [  0.9071  -0.3956  -0.1439]
        Angle     96.7885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3686"
}

Galaxy "NGC 3687:UGC 6463:MCG 5-27-73:MK 736"
{
        Type  "SBc"
        RA           11.4667
        Dec          29.5111
        Distance   1.268e+08  # method: V
        Radius     3.505e+04
        AbsMag        -20.05
        Axis    [  0.6319  -0.7386  -0.2350]
        Angle    110.9955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3687"
}

Galaxy "NGC 3688:MCG 1-29-24:NPM 1"
{
        Type  "Sb"
        RA           11.4622
        Dec          -9.1650
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.8956  -0.2360  -0.3771]
        Angle    104.8486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3688"
}

Galaxy "NGC 3689:UGC 6467:MCG 4-27-37:ZWG 126.57"
{
        Type  "SBc"
        RA           11.4694
        Dec          25.6614
        Distance   1.379e+08  # method: V
        Radius     3.411e+04
        AbsMag        -20.13
        Axis    [  0.7525   0.3828  -0.5359]
        Angle     23.9024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3689"
}

Galaxy "NGC 3690A:UGC 6472:MCG 10-17-2:MK 171"
{
        Type  "Sb"
        RA           11.4750
        Dec          58.5611
        Distance   1.489e+08  # method: V
        Radius     3.465e+04
        AbsMag         -21.3
        Axis    [ -0.0970   0.9715  -0.2164]
        Angle     49.8866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3690A"
}

Galaxy "NGC 3690B:UGC 6472:MCG 10-17-3:KCPG 288B"
{
        Type  "Sb"
        RA           11.4756
        Dec          58.5644
        Distance   1.444e+08  # method: V
        Radius     4.201e+04
        AbsMag        -21.53
        Axis    [ -0.1226   0.9746   0.1872]
        Angle     41.2355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3690B"
}

Galaxy "NGC 3691:UGC 6464:MCG 3-29-53:ZWG 96.50"
{
        Type  "SBa"
        RA           11.4692
        Dec          16.9200
        Distance   6.419e+07  # method: V
        Radius     1.307e+04
        AbsMag        -18.17
        Axis    [  0.9292  -0.3541  -0.1062]
        Angle     96.2689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3691"
}

Galaxy "NGC 3692:UGC 6474:MCG 2-29-32:ZWG 67.84"
{
        Type  "Sb"
        RA           11.4731
        Dec           9.4078
        Distance   9.391e+07  # method: V
        Radius     4.234e+04
        AbsMag         -19.4
        Axis    [  0.8669   0.4580   0.1971]
        Angle     20.7404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3692"
}

Galaxy "NGC 3693:MCG 2-29-32:NPM 1:IRAS 11256-1255"
{
        Type  "Sb"
        RA           11.4697
        Dec         -13.1942
        Distance   2.405e+08  # method: V
        Radius      1.19e+05
        AbsMag        -20.84
        Axis    [  0.8902   0.1752  -0.4205]
        Angle     33.8879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3693"
}

Galaxy "NGC 3694:UGC 6480:MCG 6-25-76:ZWG 185.70"
{
        Type  "E0"
        RA           11.4817
        Dec          35.4139
        Distance   1.143e+08  # method: V
        Radius     1.663e+04
        AbsMag        -19.02
        Axis    [  0.6002  -0.7181  -0.3524]
        Angle     93.2915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3694"
}

Galaxy "NGC 3695:NGC 3698:UGC 6490:MCG 6-25-78"
{
        Type  "SBc"
        RA           11.4881
        Dec          35.5756
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.3840   0.8087  -0.4456]
        Angle     48.6419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3695"
}

Galaxy "NGC 3696"
{
        Type  "Sc"
        RA           11.4786
        Dec         -11.2831
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.3811  -0.0812  -0.9209]
        Angle     66.3959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3696"
}

Galaxy "NGC 3697:NGC 3697A:UGC 6479:MCG 4-27-42"
{
        Type  "SBb"
        RA           11.4806
        Dec          20.7950
        Distance   3.093e+08  # method: T-F
        Radius      1.08e+05
        AbsMag        -20.78
        Axis    [  0.8136   0.4416   0.3783]
        Angle     24.1643
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3697"
}

Galaxy "NGC 3697B:MCG 4-27-45:ZWG 126.64:HCG 53"
{
        Type  "Sb"
        RA           11.4828
        Dec          20.7500
        Distance   3.101e+08  # method: T-F
        Radius     3.157e+04
        AbsMag        -19.69
        Axis    [  0.7419   0.1012  -0.6628]
        Angle     33.0875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3697B"
}

Galaxy "NGC 3697C:MCG 4-27-44:ZWG 126.63:HCG 53B"
{
        Type  "Sa"
        RA           11.4831
        Dec          20.7394
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [ -0.2088   0.5487  -0.8095]
        Angle     43.0127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3697C"
}

Galaxy "NGC 3700:UGC 6494:MCG 6-25-79:ZWG 185.73"
{
        Type  "SBb"
        RA           11.4939
        Dec          35.5150
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.8756  -0.4709   0.1074]
        Angle    104.5890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3700"
}

Galaxy "NGC 3701:UGC 6493:MCG 4-27-48:ZWG 126.68"
{
        Type  "Sc"
        RA           11.4911
        Dec          24.0936
        Distance   1.866e+08  # method: T-F
        Radius     5.158e+04
        AbsMag        -20.29
        Axis    [ -0.6967   0.6883  -0.2019]
        Angle     39.7483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3701"
}

Galaxy "NGC 3702:MCG 1-29-26:NPM 1"
{
        Type  "Sa"
        RA           11.5036
        Dec          -8.8622
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [ -0.7269   0.1613  -0.6675]
        Angle     57.2150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3702"
}

Galaxy "NGC 3703"
{
        Type  "S0"
        RA           11.4858
        Dec          -8.4464
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.3881   0.1415  -0.9107]
        Angle     39.5061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3703"
}

Galaxy "NGC 3704:MCG 2-29-37:NPM 1"
{
        Type  "E0"
        RA           11.5011
        Dec         -11.5458
        Distance   2.089e+08  # distance uncertain!
        Radius     4.862e+04
        AbsMag        -20.13
        Axis    [ -0.2819   0.2500  -0.9263]
        Angle    108.4618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3704"
}

Galaxy "NGC 3705:UGC 6498:MCG 2-29-39:ZWG 67.93"
{
        Type  "SBb"
        RA           11.5019
        Dec           9.2761
        Distance   6.283e+07  # method: T-F
        Radius     4.478e+04
        AbsMag        -19.62
        Axis    [ -0.3721   0.6249  -0.6863]
        Angle     19.6140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3705"
}

Galaxy "NGC 3705B"
{
        Type  "S0"
        RA           11.4953
        Dec           9.2056
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.9481  -0.0300  -0.3165]
        Angle     45.8486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3705B"
}

Galaxy "NGC 3706:ESO 378-6:MCG 6-25-22"
{
        Type  "S0"
        RA           11.4956
        Dec         -36.3914
        Distance   1.314e+08  # method: T-F
        Radius     5.924e+04
        AbsMag        -20.62
        Axis    [  0.4885  -0.0826  -0.8687]
        Angle     77.3913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3706"
}

Galaxy "NGC 3707:NPM 1"
{
        Type  "E0"
        RA           11.5031
        Dec         -11.5428
        Distance   4.787e+08  # distance uncertain!
        Radius     4.177e+04
        AbsMag        -20.13
        Axis    [  0.2639  -0.1793  -0.9477]
        Angle    105.9701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3707"
}

Galaxy "NGC 3710:UGC 6504:MCG 4-27-52:ZWG 126.78"
{
        Type  "E0"
        RA           11.5183
        Dec          22.7686
        Distance   3.083e+08  # method: V
        Radius     4.484e+04
        AbsMag        -20.78
        Axis    [  0.2192   0.0763  -0.9727]
        Angle     72.2477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3710"
}

Galaxy "NGC 3711-1:MCG 2-29-35"
{
        Type  "SBc"
        RA           11.4903
        Dec         -11.0797
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.8814   0.0922  -0.4634]
        Angle     69.3614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3711-1"
}

Galaxy "NGC 3711-2:MCG 2-29-35"
{
        Type  "E0"
        RA           11.4906
        Dec         -11.0739
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.7112  -0.5477  -0.4407]
        Angle    138.9801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3711-2"
}

Galaxy "NGC 3713:UGC 6511:MCG 5-27-84:ZWG 156.94"
{
        Type  "S0"
        RA           11.5281
        Dec          28.1539
        Distance   3.301e+08  # method: V
        Radius     5.761e+04
        AbsMag        -20.73
        Axis    [ -0.2103   0.8058  -0.5537]
        Angle     28.4265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3713"
}

Galaxy "NGC 3714:NGC 3712:UGC 6516:MCG 5-27-85"
{
        Type  "Sa"
        RA           11.5314
        Dec          28.3586
        Distance   3.294e+08  # method: V
        Radius     6.228e+04
        AbsMag        -20.82
        Axis    [  0.9905  -0.1193  -0.0684]
        Angle     42.9560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3714"
}

Galaxy "NGC 3715:MCG 2-29-41:IRAS 11290-1357"
{
        Type  "Sc"
        RA           11.5256
        Dec         -14.2311
        Distance   1.812e+08  # method: T-F
        Radius      3.69e+04
        AbsMag        -20.42
        Axis    [ -0.5216   0.1029  -0.8470]
        Angle     59.4697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3715"
}

Galaxy "NGC 3716:UGC 6513:MCG 1-30-1:ZWG 40.1"
{
        Type  "S0"
        RA           11.5281
        Dec           3.4881
        Distance   3.163e+08  # method: V
        Radius     3.221e+04
        AbsMag        -20.43
        Axis    [ -0.4448   0.3671  -0.8169]
        Angle     67.7809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3716"
}

Galaxy "NGC 3717:ESO 439-15:MCG 5-27-15:UGCA 238"
{
        Type  "Sb"
        RA           11.5256
        Dec         -30.3083
        Distance   5.975e+07  # method: T-F
        Radius     5.388e+04
        AbsMag        -19.11
        Axis    [  0.9213   0.1927  -0.3376]
        Angle     87.0416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3717"
}

Galaxy "NGC 3718:UGC 6524:MCG 9-19-114:ZWG 268.48"
{
        Type  "SBa"
        RA           11.5428
        Dec          53.0672
        Distance   5.346e+07  # method: V
        Radius     6.298e+04
        AbsMag        -19.47
        Axis    [  0.8359  -0.3844   0.3919]
        Angle     94.3445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3718"
}

Galaxy "NGC 3719:UGC 6521:MCG 0-30-5:ZWG 12.8"
{
        Type  "Sc"
        RA           11.5369
        Dec           0.8192
        Distance   2.829e+08  # method: V
        Radius     6.996e+04
        AbsMag        -21.09
        Axis    [  0.9064  -0.3129  -0.2837]
        Angle    104.3192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3719"
}

Galaxy "NGC 3720:UGC 6523:MCG 0-30-6:ZWG 12.10"
{
        Type  "Sa"
        RA           11.5392
        Dec           0.8039
        Distance   2.813e+08  # method: V
        Radius     4.091e+04
        AbsMag        -20.98
        Axis    [  0.5188  -0.0981  -0.8493]
        Angle     57.0600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3720"
}

Galaxy "NGC 3721:NPM 1"
{
        Type  "Sa"
        RA           11.5686
        Dec          -9.4667
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [ -0.5938   0.1176  -0.7959]
        Angle     45.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3721"
}

Galaxy "NGC 3722:MCG 1-30-5:NPM 1"
{
        Type  "E0"
        RA           11.5731
        Dec          -9.6794
        Distance   3.631e+08  # distance uncertain!
        Radius     4.753e+04
        AbsMag        -20.13
        Axis    [  0.7012  -0.5609  -0.4401]
        Angle    138.4078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3722"
}

Galaxy "NGC 3723:MCG 2-30-2:NPM 1"
{
        Type  "S0"
        RA           11.5417
        Dec          -9.9689
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.3828  -0.1397  -0.9132]
        Angle     76.8857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3723"
}

Galaxy "NGC 3724:MCG 1-30-7:IRAS 11319-0922"
{
        Type  "Sa"
        RA           11.5744
        Dec          -9.6594
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.9215   0.0213  -0.3879]
        Angle     55.9107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3724"
}

Galaxy "NGC 3725:UGC 6542:MCG 10-17-15:MK 179"
{
        Type  "SBc"
        RA           11.5611
        Dec          61.8889
        Distance   1.571e+08  # method: V
        Radius     2.741e+04
        AbsMag        -19.61
        Axis    [ -0.2328   0.9702   0.0670]
        Angle     53.2371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3725"
}

Galaxy "NGC 3726:UGC 6537:MCG 8-21-51:ZWG 242.45"
{
        Type  "SBc"
        RA           11.5556
        Dec          47.0278
        Distance   7.416e+07  # method: T-F
        Radius     6.471e+04
        AbsMag        -20.88
        Axis    [  0.8384  -0.4997   0.2175]
        Angle     94.7776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3726"
}

Galaxy "NGC 3727:NPM 1"
{
        Type  "S0"
        RA           11.5611
        Dec         -13.8783
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.5843  -0.1081  -0.8043]
        Angle     63.2231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3727"
}

Galaxy "NGC 3728:UGC 6536:MCG 4-27-61:ZWG 126.87"
{
        Type  "Sb"
        RA           11.5542
        Dec          24.4475
        Distance   3.302e+08  # method: V
        Radius     9.605e+04
        AbsMag        -20.23
        Axis    [  0.9082  -0.4067  -0.0987]
        Angle     84.9451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3728"
}

Galaxy "NGC 3729:UGC 6547:MCG 9-19-117:ZWG 268.51"
{
        Type  "SBa"
        RA           11.5636
        Dec          53.1264
        Distance   7.235e+07  # method: T-F
        Radius     3.051e+04
        AbsMag        -19.73
        Axis    [ -0.4946   0.8690  -0.0153]
        Angle     67.3249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3729"
}

Galaxy "NGC 3730:MCG 1-30-3:NPM 1"
{
        Type  "E0"
        RA           11.5711
        Dec          -9.5761
        Distance   2.188e+08  # distance uncertain!
        Radius     3.182e+04
        AbsMag        -20.13
        Axis    [  0.7012  -0.5613  -0.4396]
        Angle    138.3255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3730"
}

Galaxy "NGC 3731:UGC 6553:MCG 2-30-1:ZWG 68.3"
{
        Type  "E0"
        RA           11.5697
        Dec          12.5128
        Distance    1.61e+08  # method: V
        Radius     2.341e+04
        AbsMag        -19.37
        Axis    [  0.5372  -0.4605  -0.7066]
        Angle     94.1453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3731"
}

Galaxy "NGC 3732:MCG 2-30-5:IRAS 11316-0934"
{
        Type  "SBa"
        RA           11.5703
        Dec          -9.8453
        Distance   9.291e+07  # method: V
        Radius     1.892e+04
        AbsMag        -18.87
        Axis    [  0.4088  -0.1341  -0.9027]
        Angle     71.8570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3732"
}

Galaxy "NGC 3733:UGC 6554:MCG 9-19-123:ZWG 268.55"
{
        Type  "SBc"
        RA           11.5836
        Dec          54.8503
        Distance    1.06e+08  # method: T-F
        Radius     7.558e+04
        AbsMag        -20.06
        Axis    [ -0.6054   0.7778   0.1690]
        Angle     73.5583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3733"
}

Galaxy "NGC 3734:MCG 2-30-6:NPM 1"
{
        Type  "Sc"
        RA           11.5778
        Dec         -14.0811
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.8734  -0.2406  -0.4235]
        Angle    109.2468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3734"
}

Galaxy "NGC 3735:UGC 6567:MCG 12-11-36:ZWG 334.42"
{
        Type  "Sc"
        RA           11.5992
        Dec          70.5356
        Distance   1.399e+08  # method: T-F
        Radius     8.138e+04
        AbsMag        -20.56
        Axis    [ -0.2580   0.5742   0.7770]
        Angle     73.5177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3735"
}

Galaxy "NGC 3736:UGC 6560:MCG 12-11-35:ZWG 334.41"
{
        Type  "S0"
        RA           11.5947
        Dec          73.4525
        Distance   3.072e+08  # distance uncertain!
        Radius     4.915e+04
        AbsMag        -19.07
        Axis    [ -0.2893   0.9161   0.2776]
        Angle     69.2651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3736"
}

Galaxy "NGC 3737:UGC 6563:MCG 9-19-128:ZWG 268.58"
{
        Type  "S0"
        RA           11.5933
        Dec          54.9489
        Distance   2.607e+08  # method: V
        Radius     3.033e+04
        AbsMag        -20.71
        Axis    [  0.9959  -0.0631  -0.0647]
        Angle     28.6828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3737"
}

Galaxy "NGC 3737A"
{
        Type  "S0"
        RA           11.5919
        Dec          54.9311
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.3532   0.9355  -0.0059]
        Angle     54.2183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3737A"
}

Galaxy "NGC 3738:UGC 6565:MCG 9-19-130:ZWG 268.60"
{
        Type  "Irr"
        RA           11.5967
        Dec          54.5239
        Distance   1.839e+07  # method: V
        Radius          6688
        AbsMag        -16.66
        Axis    [ -0.3572   0.9295  -0.0919]
        Angle     58.7094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3738"
}

Galaxy "NGC 3739:UGC 6564:MCG 4-27-71:ZWG 126.105"
{
        Type  "Sc"
        RA           11.5936
        Dec          25.0886
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.9643  -0.1259   0.2332]
        Angle     95.6223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3739"
}

Galaxy "NGC 3740:UGC 6573:MCG 10-17-23:ZWG 292.8"
{
        Type  "S0"
        RA           11.6033
        Dec          59.9767
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.1134   0.6148   0.7805]
        Angle     42.4781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3740"
}

Galaxy "NGC 3741:UGC 6572:MCG 8-21-68:ZWG 242.57"
{
        Type  "Irr"
        RA           11.6017
        Dec          45.2842
        Distance   1.975e+07  # method: V
        Radius          4022
        AbsMag        -14.71
        Axis    [  0.8617  -0.4387   0.2552]
        Angle    102.1501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3741"
}

Galaxy "NGC 3742:ESO 320-6:MCG 6-26-1:AM 1133-374"
{
        Type  "SBb"
        RA           11.5922
        Dec         -37.9561
        Distance   1.402e+08  # method: V
        Radius     4.893e+04
        AbsMag        -20.17
        Axis    [ -0.0553  -0.1312  -0.9898]
        Angle     78.4919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3742"
}

Galaxy "NGC 3743:ZWG 126.106:NPM 1"
{
        Type  "S0"
        RA           11.5992
        Dec          21.7231
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.6450  -0.7096  -0.2836]
        Angle    116.7837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3743"
}

Galaxy "NGC 3744:ZWG 126.107:NPM 1"
{
        Type  "S0"
        RA           11.5992
        Dec          23.0122
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.9704  -0.1744   0.1672]
        Angle    102.4608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3744"
}

Galaxy "NGC 3745:MCG 4-28-4:VV 282:ARP 320"
{
        Type  "S0"
        RA           11.6289
        Dec          22.0211
        Distance   4.408e+08  # method: V
        Radius     2.564e+04
        AbsMag        -19.45
        Axis    [  0.7545   0.5690  -0.3271]
        Angle     16.5661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3745"
}

Galaxy "NGC 3746:UGC 6597:MCG 4-28-5:ZWG 127.6"
{
        Type  "SBb"
        RA           11.6286
        Dec          22.0097
        Distance   4.232e+08  # method: V
        Radius     6.771e+04
        AbsMag        -20.77
        Axis    [ -0.4828   0.8438  -0.2344]
        Angle     21.2238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3746"
}

Galaxy "NGC 3747:IRAS 11294+7439"
{
        Type  "S0"
        RA           11.5419
        Dec          74.3789
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.1968   0.4326   0.8799]
        Angle     56.9555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3747"
}

Galaxy "NGC 3748:MCG 4-28-7:ZWG 127.7:VV 282"
{
        Type  "S0"
        RA           11.6303
        Dec          22.0264
        Distance   4.216e+08  # method: V
        Radius     4.292e+04
        AbsMag        -19.76
        Axis    [ -0.4952   0.7235  -0.4810]
        Angle     29.0783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3748"
}

Galaxy "NGC 3749:ESO 320-8:MCG 6-26-2:AM 1133-374"
{
        Type  "Sa"
        RA           11.5981
        Dec         -37.9975
        Distance   1.306e+08  # method: V
        Radius     7.981e+04
        AbsMag        -19.21
        Axis    [  0.1591  -0.1746  -0.9717]
        Angle     48.0098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3749"
}

Galaxy "NGC 3750:MCG 4-28-8:ZWG 127.9:VV 282"
{
        Type  "S0"
        RA           11.6308
        Dec          21.9747
        Distance    4.25e+08  # method: V
        Radius      3.09e+04
        AbsMag        -20.67
        Axis    [ -0.2598   0.5600  -0.7867]
        Angle     41.7319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3750"
}

Galaxy "NGC 3751:UGC 6601:MCG 4-28-9:HCG 57"
{
        Type  "S0"
        RA           11.6314
        Dec          21.9369
        Distance   4.489e+08  # method: V
        Radius     3.264e+04
        AbsMag        -20.39
        Axis    [  0.9689  -0.2161   0.1204]
        Angle    101.9149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3751"
}

Galaxy "NGC 3752:UGC 6515:MCG 13-8-64:ZWG 351.63"
{
        Type  "Sb"
        RA           11.5422
        Dec          74.6286
        Distance   8.951e+07  # method: V
        Radius     2.213e+04
        AbsMag        -18.49
        Axis    [ -0.3836   0.8078   0.4476]
        Angle     76.6732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3752"
}

Galaxy "NGC 3753:UGC 6602:MCG 4-28-10:ZWG 127.12"
{
        Type  "Sb"
        RA           11.6314
        Dec          21.9814
        Distance   4.092e+08  # method: V
        Radius     1.012e+05
        AbsMag        -20.99
        Axis    [ -0.1972   0.8624   0.4662]
        Angle     16.9212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3753"
}

Galaxy "NGC 3754:MCG 4-28-11:ZWG 127.12:VV 282"
{
        Type  "Sb"
        RA           11.6319
        Dec          21.9856
        Distance   4.226e+08  # method: V
        Radius     2.459e+04
        AbsMag        -20.46
        Axis    [  0.9010  -0.4216  -0.1021]
        Angle     92.7565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3754"
}

Galaxy "NGC 3755:UGC 6577:MCG 6-26-8:ZWG 186.12"
{
        Type  "SBc"
        RA           11.6092
        Dec          36.4103
        Distance   1.354e+08  # method: T-F
        Radius     6.694e+04
        AbsMag        -19.49
        Axis    [ -0.4887   0.8256   0.2821]
        Angle     33.4115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3755"
}

Galaxy "NGC 3756:UGC 6579:MCG 9-19-134:ZWG 268.63"
{
        Type  "SBc"
        RA           11.6131
        Dec          54.2942
        Distance   8.471e+07  # method: T-F
        Radius     5.175e+04
        AbsMag        -20.07
        Axis    [ -0.6158   0.7826   0.0909]
        Angle     78.5950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3756"
}

Galaxy "NGC 3757:UGC 6584:MCG 10-17-26:ZWG 292.10"
{
        Type  "S0"
        RA           11.6172
        Dec          58.4161
        Distance   6.446e+07  # method: V
        Radius     1.031e+04
        AbsMag        -17.98
        Axis    [  0.4785  -0.8772  -0.0404]
        Angle     97.5847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3757"
}

Galaxy "NGC 3758:MCG 4-27-73:MK 739:ZWG 126.110"
{
        Type  "S0"
        RA           11.6081
        Dec          21.5969
        Distance   4.181e+08  # method: V
        Radius     3.041e+04
        AbsMag        -20.34
        Axis    [  0.6446  -0.7096  -0.2846]
        Angle    116.9320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3758"
}

Galaxy "NGC 3759:UGC 6581:MCG 9-19-136:ZWG 268.64"
{
        Type  "S0"
        RA           11.6147
        Dec          54.8231
        Distance   1.495e+08  # method: T-F
        Radius     2.392e+04
        AbsMag        -19.11
        Axis    [  0.4998  -0.8635  -0.0678]
        Angle     99.1473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3759"
}

Galaxy "NGC 3759A:UGC 6582:MCG 9-19-135:ZWG 268.65"
{
        Type  "SBc"
        RA           11.6161
        Dec          55.1622
        Distance   2.699e+08  # method: V
        Radius     4.711e+04
        AbsMag        -20.29
        Axis    [  0.1704   0.8884  -0.4263]
        Angle     35.4648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3759A"
}

Galaxy "NGC 3761:ZWG 127.1:NPM 1"
{
        Type  "E0"
        RA           11.6122
        Dec          22.9925
        Distance   3.981e+08  # distance uncertain!
        Radius     5.212e+04
        AbsMag        -20.13
        Axis    [  0.5011  -0.4045  -0.7651]
        Angle     79.1334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3761"
}

Galaxy "NGC 3762:UGC 6591:MCG 10-17-27:ZWG 292.11"
{
        Type  "Sa"
        RA           11.6231
        Dec          61.7592
        Distance    1.63e+08  # method: V
        Radius     4.268e+04
        AbsMag        -19.99
        Axis    [ -0.5948   0.7093   0.3783]
        Angle     78.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3762"
}

Galaxy "NGC 3763:IC 714:MCG 2-30-9:IRAS 11339-0934"
{
        Type  "SBc"
        RA           11.6083
        Dec          -9.8472
        Distance   1.065e+08  # distance uncertain!
        Radius     1.704e+04
        AbsMag        -19.07
        Axis    [  0.7158  -0.5465  -0.4347]
        Angle    137.3888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3763"
}

Galaxy "NGC 3764:MCG 3-30-20:ZWG 97.25:ZW 52"
{
        Type  "Irr"
        RA           11.6150
        Dec          17.8892
        Distance   4.787e+08  # distance uncertain!
        Radius     6.266e+04
        AbsMag        -20.13
        Axis    [ -0.1316   0.4510  -0.8828]
        Angle     38.2587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3764"
}

Galaxy "NGC 3765:MCG 4-28-1:ZWG 127.3"
{
        Type  "Sc"
        RA           11.6178
        Dec          24.0964
        Distance   4.772e+08  # method: V
        Radius     5.552e+04
        AbsMag        -20.83
        Axis    [  0.9116  -0.3016  -0.2794]
        Angle     56.4010
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3765"
}

Galaxy "NGC 3767:UGC 6590:MCG 3-30-23:ZWG 97.31"
{
        Type  "S0"
        RA           11.6208
        Dec          16.8775
        Distance   3.032e+08  # method: V
        Radius      4.41e+04
        AbsMag        -20.04
        Axis    [  0.6409  -0.2291  -0.7326]
        Angle     56.8366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3767"
}

Galaxy "NGC 3768:UGC 6589:MCG 3-30-24:ZWG 97.30"
{
        Type  "S0"
        RA           11.6206
        Dec          17.8394
        Distance   1.668e+08  # method: V
        Radius     3.883e+04
        AbsMag        -20.04
        Axis    [ -0.7420   0.5503  -0.3829]
        Angle     49.2442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3768"
}

Galaxy "NGC 3769:UGC 6595:MCG 8-21-76:ZWG 242.65"
{
        Type  "SBb"
        RA           11.6289
        Dec          47.8933
        Distance   5.531e+07  # method: T-F
        Radius     2.333e+04
        AbsMag        -18.85
        Axis    [ -0.5941   0.7258   0.3468]
        Angle     56.4948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3769"
}

Galaxy "NGC 3769A:MCG 8-21-77:ZWG 242.66:ARP 280"
{
        Type  "Irr"
        RA           11.6306
        Dec          47.8817
        Distance   4.408e+07  # method: V
        Radius          5770
        AbsMag        -15.85
        Axis    [  0.0196   0.6246   0.7807]
        Angle     37.5323
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3769A"
}

Galaxy "NGC 3770:UGC 6600:MCG 10-17-28:ZWG 292.12"
{
        Type  "SBa"
        RA           11.6328
        Dec          59.6172
        Distance   1.523e+08  # method: V
        Radius     2.216e+04
        AbsMag        -19.65
        Axis    [  0.3879   0.7671   0.5109]
        Angle     28.5812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3770"
}

Galaxy "NGC 3771"
{
        Type  "E0"
        RA           11.6514
        Dec          -9.3478
        Distance    1.82e+08  # distance uncertain!
        Radius     3.441e+04
        AbsMag        -20.13
        Axis    [  0.6933  -0.5683  -0.4432]
        Angle    138.5788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3771"
}

Galaxy "NGC 3772:UGC 6598:MCG 4-28-6:ZWG 127.8"
{
        Type  "SBa"
        RA           11.6300
        Dec          22.6906
        Distance   1.718e+08  # method: V
        Radius     2.749e+04
        AbsMag        -19.21
        Axis    [  0.9537  -0.2973   0.0449]
        Angle     94.0326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3772"
}

Galaxy "NGC 3773:UGC 6605:MCG 2-30-5:MK 743"
{
        Type  "S0"
        RA           11.6369
        Dec          12.1125
        Distance   6.016e+07  # method: V
        Radius      1.05e+04
        AbsMag        -18.03
        Axis    [ -0.5896   0.5045  -0.6308]
        Angle     70.9511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3773"
}

Galaxy "NGC 3774:MCG 1-30-16"
{
        Type  "SBb"
        RA           11.6417
        Dec          -8.9764
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.8766  -0.0933  -0.4721]
        Angle     66.7159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3774"
}

Galaxy "NGC 3775:MCG 2-30-12"
{
        Type  "Sa"
        RA           11.6406
        Dec         -10.6381
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.9553  -0.0755  -0.2859]
        Angle     91.8454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3775"
}

Galaxy "NGC 3776:ZWG 12.45:NPM 1"
{
        Type  "Sb"
        RA           11.6381
        Dec          -3.3539
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [ -0.6624   0.2534  -0.7050]
        Angle     59.7387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3776"
}

Galaxy "NGC 3777:MCG 2-30-8"
{
        Type  "Sb"
        RA           11.6017
        Dec         -12.5692
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.8804  -0.1609  -0.4460]
        Angle     90.7585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3777"
}

Galaxy "NGC 3778:ESO 216-26:AM 1135-502"
{
        Type  "S0"
        RA           11.6392
        Dec         -50.7156
        Distance   2.149e+08  # method: V
        Radius     3.751e+04
        AbsMag        -19.99
        Axis    [  0.7497  -0.0729  -0.6578]
        Angle    128.4072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3778"
}

Galaxy "NGC 3779:IC 717:MCG 2-30-13"
{
        Type  "Sc"
        RA           11.6472
        Dec         -10.5842
        Distance   9.318e+07  # method: V
        Radius     2.575e+04
        AbsMag        -17.78
        Axis    [  0.6138  -0.0686  -0.7865]
        Angle     47.8241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3779"
}

Galaxy "NGC 3780:UGC 6615:MCG 9-19-150:ZWG 292.14"
{
        Type  "Sc"
        RA           11.6558
        Dec          56.2706
        Distance   1.162e+08  # method: V
        Radius     5.072e+04
        AbsMag        -20.56
        Axis    [  0.9347   0.2641   0.2379]
        Angle     24.6891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3780"
}

Galaxy "NGC 3781:MCG 5-28-4:ZWG 157.5"
{
        Type  "S0"
        RA           11.6508
        Dec          26.3625
        Distance   3.217e+08  # method: V
        Radius     2.339e+04
        AbsMag        -20.17
        Axis    [  0.9466  -0.3213   0.0274]
        Angle     79.6443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3781"
}

Galaxy "NGC 3782:UGC 6618:MCG 8-21-87:ZWG 242.71"
{
        Type  "SBc"
        RA           11.6556
        Dec          46.5131
        Distance     5.4e+07  # method: T-F
        Radius     1.257e+04
        AbsMag        -17.99
        Axis    [  0.8211  -0.5349   0.1991]
        Angle    105.3019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3782"
}

Galaxy "NGC 3783:ESO 378-14:MCG 6-26-4:TOL 55"
{
        Type  "SBa"
        RA           11.6503
        Dec         -37.7383
        Distance   1.464e+08  # method: V
        Radius     4.045e+04
        AbsMag        -20.76
        Axis    [ -0.5345   0.0021  -0.8452]
        Angle    101.7222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3783"
}

Galaxy "NGC 3784:MCG 5-28-6:ZWG 157.6"
{
        Type  "SBa"
        RA           11.6581
        Dec          26.3097
        Distance   3.242e+08  # method: V
        Radius     4.244e+04
        AbsMag        -19.69
        Axis    [ -0.6671   0.7125   0.2174]
        Angle     29.9725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3784"
}

Galaxy "NGC 3785:UGC 6620:MCG 5-28-7:ZWG 157.8"
{
        Type  "S0"
        RA           11.6589
        Dec          26.3028
        Distance   4.285e+08  # method: V
        Radius     6.233e+04
        AbsMag        -20.39
        Axis    [  0.9628  -0.2093   0.1712]
        Angle     86.0679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3785"
}

Galaxy "NGC 3786:UGC 6621:MCG 5-28-8:MK 744"
{
        Type  "SBa"
        RA           11.6617
        Dec          31.9086
        Distance   1.362e+08  # method: V
        Radius     4.159e+04
        AbsMag         -19.7
        Axis    [  0.9852  -0.0030   0.1711]
        Angle     35.0303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3786"
}

Galaxy "NGC 3787:MCG 4-28-15:ZWG 127.17:ARAK 306"
{
        Type  "S0"
        RA           11.6606
        Dec          20.4550
        Distance    2.03e+08  # distance uncertain!
        Radius     1.181e+04
        AbsMag        -19.07
        Axis    [  0.9016  -0.4124  -0.1307]
        Angle     90.6389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3787"
}

Galaxy "NGC 3788:UGC 6623:MCG 5-28-9:ZWG 157.10"
{
        Type  "SBb"
        RA           11.6622
        Dec          31.9306
        Distance   1.347e+08  # method: V
        Radius     4.114e+04
        AbsMag        -19.68
        Axis    [ -0.8468   0.5296   0.0502]
        Angle     71.0497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3788"
}

Galaxy "NGC 3789:MCG 1-30-15"
{
        Type  "Sa"
        RA           11.6358
        Dec          -9.6067
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [ -0.8725   0.1419  -0.4675]
        Angle     74.8626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3789"
}

Galaxy "NGC 3790:UGC 6624:MCG 3-30-32:ZWG 97.43"
{
        Type  "Sa"
        RA           11.6631
        Dec          17.7122
        Distance   1.704e+08  # method: V
        Radius     2.727e+04
        AbsMag        -18.99
        Axis    [ -0.9014   0.4305   0.0458]
        Angle     44.0680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3790"
}

Galaxy "NGC 3791:MCG 1-30-20:NPM 1"
{
        Type  "S0"
        RA           11.6614
        Dec          -9.3667
        Distance   1.612e+08  # distance uncertain!
        Radius     3.283e+04
        AbsMag        -19.07
        Axis    [ -0.6971   0.2045  -0.6872]
        Angle     71.2508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3791"
}

Galaxy "NGC 3795:UGC 6629:MCG 10-17-38:ZWG 292.17"
{
        Type  "Sc"
        RA           11.6683
        Dec          58.6125
        Distance    5.64e+07  # method: V
        Radius     1.723e+04
        AbsMag        -17.19
        Axis    [  0.6728  -0.0593   0.7374]
        Angle     77.0288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3795"
}

Galaxy "NGC 3795A:UGC 6616:MCG 10-17-35:ZWG 292.15"
{
        Type  "Sc"
        RA           11.6558
        Dec          58.2686
        Distance   5.934e+07  # method: V
        Radius     2.072e+04
        AbsMag         -17.1
        Axis    [  0.9804  -0.1521  -0.1251]
        Angle     29.1004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3795A"
}

Galaxy "NGC 3795B:UGC 6604:MCG 10-17-29:ZWG 292.13"
{
        Type  "S0"
        RA           11.6356
        Dec          58.7581
        Distance   6.686e+07  # method: V
        Radius          8753
        AbsMag        -17.36
        Axis    [  0.4747  -0.8793  -0.0379]
        Angle     97.6549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3795B"
}

Galaxy "NGC 3796:UGC 6638:MCG 10-17-39:ZWG 292.18"
{
        Type  "S0"
        RA           11.6753
        Dec          60.2989
        Distance   6.392e+07  # method: V
        Radius     1.209e+04
        AbsMag        -17.96
        Axis    [ -0.0604   0.9488   0.3102]
        Angle     38.0443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3796"
}

Galaxy "NGC 3798:UGC 6632:MCG 4-28-18:ZWG 127.22"
{
        Type  "S0"
        RA           11.6703
        Dec          24.6969
        Distance   1.729e+08  # method: V
        Radius     5.784e+04
        AbsMag        -20.02
        Axis    [  0.9867  -0.1609   0.0221]
        Angle     51.1524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3798"
}

Galaxy "NGC 3799:UGC 6630:MCG 3-30-37:ZWG 97.47"
{
        Type  "SBb"
        RA           11.6692
        Dec          15.3275
        Distance   1.656e+08  # method: V
        Radius     1.686e+04
        AbsMag        -19.03
        Axis    [  0.0852   0.3370  -0.9376]
        Angle     31.1994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3799"
}

Galaxy "NGC 3800:UGC 6634:MCG 3-30-39:ZWG 97.49"
{
        Type  "SBb"
        RA           11.6703
        Dec          15.3422
        Distance   1.648e+08  # method: V
        Radius     4.793e+04
        AbsMag        -20.22
        Axis    [  0.9919  -0.0378   0.1213]
        Angle     60.6925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3800"
}

Galaxy "NGC 3801:UGC 6635:MCG 3-30-40:ZWG 97.51"
{
        Type  "S0"
        RA           11.6711
        Dec          17.7275
        Distance   1.684e+08  # method: V
        Radius     6.123e+04
        AbsMag        -20.56
        Axis    [ -0.1231   0.5414  -0.8317]
        Angle     25.8921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3801"
}

Galaxy "NGC 3802:UGC 6636:MCG 3-30-41:ZWG 97.52"
{
        Type  "Sc"
        RA           11.6717
        Dec          17.7653
        Distance   1.653e+08  # method: V
        Radius     2.645e+04
        AbsMag        -19.22
        Axis    [  0.9317   0.1947   0.3067]
        Angle     29.8647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3802"
}

Galaxy "NGC 3803"
{
        Type  "E0"
        RA           11.6714
        Dec          17.8017
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.6283  -0.7086  -0.3211]
        Angle    120.6889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3803"
}

Galaxy "NGC 3804:NGC 3794:UGC 6640:MCG 9-19-153"
{
        Type  "SBc"
        RA           11.6817
        Dec          56.2017
        Distance   7.022e+07  # method: V
        Radius     2.247e+04
        AbsMag        -18.06
        Axis    [  0.0554   0.9413   0.3331]
        Angle     31.2878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3804"
}

Galaxy "NGC 3805:UGC 6642:MCG 4-28-19:ZWG 127.24"
{
        Type  "S0"
        RA           11.6781
        Dec          20.3436
        Distance   3.102e+08  # method: V
        Radius     6.316e+04
        AbsMag        -21.19
        Axis    [  0.8595  -0.3097  -0.4067]
        Angle     57.1048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3805"
}

Galaxy "NGC 3806:UGC 6641:MCG 3-30-42:ZWG 97.54"
{
        Type  "SBb"
        RA           11.6794
        Dec          17.7956
        Distance   1.732e+08  # method: V
        Radius     5.542e+04
        AbsMag        -19.42
        Axis    [ -0.6136   0.5719  -0.5445]
        Angle     71.2018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3806"
}

Galaxy "NGC 3808:UGC 6643:MCG 4-28-21:ZWG 127.25"
{
        Type  "SBc"
        RA           11.6789
        Dec          22.4297
        Distance   3.348e+08  # method: V
        Radius     7.792e+04
        AbsMag        -20.96
        Axis    [  0.9398  -0.3381   0.0495]
        Angle    109.9731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3808"
}

Galaxy "NGC 3808A:UGC 6643:MCG 4-28-20:ZWG 127.25"
{
        Type  "Sc"
        RA           11.6789
        Dec          22.4467
        Distance     3.4e+08  # method: V
        Radius      4.45e+04
        AbsMag        -20.69
        Axis    [  0.9756  -0.0558   0.2125]
        Angle     55.7507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3808A"
}

Galaxy "NGC 3809:UGC 6649:MCG 10-17-40:ZWG 292.20"
{
        Type  "S0"
        RA           11.6875
        Dec          59.8861
        Distance   1.626e+08  # method: V
        Radius     2.365e+04
        AbsMag        -19.79
        Axis    [  0.0957   0.9913   0.0900]
        Angle     32.9698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3809"
}

Galaxy "NGC 3810:UGC 6644:MCG 2-30-10:ZWG 68.24"
{
        Type  "Sc"
        RA           11.6828
        Dec          11.4703
        Distance   6.048e+07  # method: V
        Radius     3.782e+04
        AbsMag        -20.04
        Axis    [  0.9247  -0.3454  -0.1604]
        Angle     98.9164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3810"
}

Galaxy "NGC 3811:UGC 6650:MCG 8-21-91:MK 185"
{
        Type  "SBc"
        RA           11.6878
        Dec          47.6911
        Distance   1.503e+08  # method: V
        Radius     4.808e+04
        AbsMag        -20.42
        Axis    [ -0.4349   0.8782  -0.1990]
        Angle     60.5155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3811"
}

Galaxy "NGC 3812:UGC 6648:MCG 4-28-23:ZWG 127.27"
{
        Type  "E0"
        RA           11.6853
        Dec          24.8225
        Distance   1.785e+08  # method: V
        Radius     4.413e+04
        AbsMag        -20.09
        Axis    [  0.4982  -0.4225  -0.7572]
        Angle     77.5611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3812"
}

Galaxy "NGC 3813:UGC 6651:MCG 6-26-19:ZWG 186.24"
{
        Type  "Sb"
        RA           11.6883
        Dec          36.5467
        Distance    9.06e+07  # method: T-F
        Radius     2.636e+04
        AbsMag        -19.92
        Axis    [  0.9009   0.1943   0.3881]
        Angle     28.2566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3813"
}

Galaxy "NGC 3814:MCG 4-28-24:ZWG 127.28"
{
        Type  "S0"
        RA           11.6908
        Dec          24.8056
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [ -0.8841   0.4673   0.0021]
        Angle     64.9294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3814"
}

Galaxy "NGC 3815:UGC 6654:MCG 4-28-25:ZWG 127.30"
{
        Type  "Sb"
        RA           11.6942
        Dec          24.8003
        Distance   1.821e+08  # method: V
        Radius     4.502e+04
        AbsMag        -19.63
        Axis    [  0.9956  -0.0907  -0.0216]
        Angle     39.8610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3815"
}

Galaxy "NGC 3816:UGC 6656:MCG 3-30-46:ZWG 97.60"
{
        Type  "S0"
        RA           11.6964
        Dec          20.1036
        Distance   2.681e+08  # method: V
        Radius     7.409e+04
        AbsMag        -21.07
        Axis    [  0.9686  -0.1408  -0.2050]
        Angle     43.2107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3816"
}

Galaxy "NGC 3817:UGC 6657:MCG 2-30-12:ZWG 68.28"
{
        Type  "SBa"
        RA           11.6978
        Dec          10.3044
        Distance    2.92e+08  # method: V
        Radius     4.247e+04
        AbsMag        -20.56
        Axis    [ -0.3085   0.3736  -0.8748]
        Angle     61.3626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3817"
}

Galaxy "NGC 3818:MCG 1-30-23:UGCA 243"
{
        Type  "E6"
        RA           11.6992
        Dec          -6.1556
        Distance   1.184e+08  # method: S
        Radius     3.445e+04
        AbsMag         -20.1
        Axis    [  0.1065  -0.0679  -0.9920]
        Angle     97.7427
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3818"
}

Galaxy "NGC 3819:MCG 2-30-13:ZWG 68.30:HCG 58"
{
        Type  "E0"
        RA           11.7014
        Dec          10.3517
        Distance   2.996e+08  # method: V
        Radius     3.486e+04
        AbsMag        -19.82
        Axis    [ -0.1181   0.2895  -0.9499]
        Angle     86.8422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3819"
}

Galaxy "NGC 3820:MCG 2-30-14:ZWG 68.31:HCG 58"
{
        Type  "Sc"
        RA           11.7011
        Dec          10.3844
        Distance   2.897e+08  # method: V
        Radius      2.95e+04
        AbsMag        -19.44
        Axis    [  0.9571  -0.2365  -0.1677]
        Angle     78.9309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3820"
}

Galaxy "NGC 3821:UGC 6663:MCG 4-28-30:ZWG 127.32"
{
        Type  "SBb"
        RA           11.7025
        Dec          20.3153
        Distance   2.661e+08  # method: V
        Radius     5.417e+04
        AbsMag        -20.86
        Axis    [ -0.4610   0.5993  -0.6544]
        Angle     75.3257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3821"
}

Galaxy "NGC 3823-1:MCG 2-30-17"
{
        Type  "E0"
        RA           11.7042
        Dec         -13.8667
        Distance   1.906e+08  # distance uncertain!
        Radius     4.157e+04
        AbsMag        -20.13
        Axis    [  0.2096  -0.1826  -0.9606]
        Angle    107.0305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3823-1"
}

Galaxy "NGC 3823-2:NPM 1"
{
        Type  "S0"
        RA           11.7050
        Dec         -13.8617
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.6541  -0.1558  -0.7402]
        Angle     67.3944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3823-2"
}

Galaxy "NGC 3824:UGC 6676:MCG 9-19-161:ZWG 268.73"
{
        Type  "Sa"
        RA           11.7122
        Dec          52.7800
        Distance   2.663e+08  # method: V
        Radius     5.036e+04
        AbsMag        -20.06
        Axis    [  0.0091   0.8191   0.5736]
        Angle     32.4993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3824"
}

Galaxy "NGC 3826:NGC 3830:UGC 6671:MCG 5-28-18"
{
        Type  "E0"
        RA           11.7089
        Dec          26.4892
        Distance   4.236e+08  # method: V
        Radius     5.544e+04
        AbsMag        -21.27
        Axis    [  0.4923  -0.4136  -0.7659]
        Angle     75.2508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3826"
}

Galaxy "NGC 3827:UGC 6673:MCG 3-30-54:ZWG 97.70"
{
        Type  "Irr"
        RA           11.7100
        Dec          18.8453
        Distance   1.569e+08  # method: V
        Radius     2.054e+04
        AbsMag        -19.61
        Axis    [  0.7263  -0.3312  -0.6024]
        Angle     60.1958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3827"
}

Galaxy "NGC 3828:MCG 3-30-57:ZWG 97.75"
{
        Type  "S0"
        RA           11.7161
        Dec          16.4878
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.9447  -0.3064  -0.1168]
        Angle     82.4109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3828"
}

Galaxy "NGC 3829:UGC 6690:MCG 9-19-164:ZWG 268.74"
{
        Type  "SBb"
        RA           11.7242
        Dec          52.7114
        Distance    2.63e+08  # method: V
        Radius     3.825e+04
        AbsMag        -19.63
        Axis    [  0.1841   0.8231   0.5372]
        Angle     28.1370
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3829"
}

Galaxy "NGC 3831:MCG 2-30-23"
{
        Type  "Sa"
        RA           11.7217
        Dec         -12.8781
        Distance   1.115e+08  # distance uncertain!
        Radius      4.38e+04
        AbsMag        -19.07
        Axis    [  0.9855   0.0815  -0.1485]
        Angle     92.0604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3831"
}

Galaxy "NGC 3832:UGC 6693:MCG 4-28-40:ZWG 127.38"
{
        Type  "SBc"
        RA           11.7253
        Dec          22.7253
        Distance   3.272e+08  # method: V
        Radius     9.042e+04
        AbsMag        -21.51
        Axis    [ -0.0068   0.4141  -0.9102]
        Angle     38.2274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3832"
}

Galaxy "NGC 3833:UGC 6692:MCG 2-30-20:ZWG 68.43"
{
        Type  "Sc"
        RA           11.7244
        Dec          10.1614
        Distance   3.053e+08  # method: T-F
        Radius     6.217e+04
        AbsMag        -20.36
        Axis    [  0.9735  -0.2090  -0.0932]
        Angle     86.0496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3833"
}

Galaxy "NGC 3834:MCG 3-30-65:ZWG 97.84"
{
        Type  "S0"
        RA           11.7269
        Dec          19.0906
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [ -0.3052   0.5395  -0.7847]
        Angle     34.0119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3834"
}

Galaxy "NGC 3835:UGC 6703:MCG 10-17-55:ZWG 292.21"
{
        Type  "Sb"
        RA           11.7347
        Dec          60.1203
        Distance   1.176e+08  # method: V
        Radius      3.08e+04
        AbsMag        -19.69
        Axis    [  0.6924  -0.1003   0.7146]
        Angle     64.5149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3835"
}

Galaxy "NGC 3835A:UGC 6762:MCG 10-17-68:ZWG 292.29"
{
        Type  "Sb"
        RA           11.7894
        Dec          60.3006
        Distance   1.684e+08  # method: V
        Radius      2.45e+04
        AbsMag        -19.66
        Axis    [  0.4512  -0.8920  -0.0270]
        Angle     98.8595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3835A"
}

Galaxy "NGC 3836:MCG 3-30-10:VV 477:IRAS 11409-1631"
{
        Type  "Sb"
        RA           11.7247
        Dec         -16.7975
        Distance   1.817e+08  # method: V
        Radius     3.701e+04
        AbsMag        -20.03
        Axis    [  0.7073  -0.3389  -0.6204]
        Angle    111.1387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3836"
}

Galaxy "NGC 3837:UGC 6701:MCG 3-30-68:ZWG 97.89"
{
        Type  "E0"
        RA           11.7322
        Dec          19.8947
        Distance   3.102e+08  # method: T-F
        Radius     3.609e+04
        AbsMag        -20.59
        Axis    [  0.6158  -0.7235  -0.3121]
        Angle    119.8714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3837"
}

Galaxy "NGC 3838:UGC 6707:MCG 10-17-56:ZWG 292.22"
{
        Type  "Sa"
        RA           11.7369
        Dec          57.9486
        Distance     6.6e+07  # method: V
        Radius     1.344e+04
        AbsMag        -18.33
        Axis    [ -0.3750   0.7884   0.4876]
        Angle     52.8113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3838"
}

Galaxy "NGC 3839:UGC 6700:MCG 2-30-24:ZWG 68.48"
{
        Type  "Irr"
        RA           11.7317
        Dec          10.7844
        Distance   2.833e+08  # method: V
        Radius     4.121e+04
        AbsMag        -20.89
        Axis    [  0.8792   0.0059  -0.4764]
        Angle     30.3377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3839"
}

Galaxy "NGC 3840:UGC 6702:MCG 3-30-70:ZWG 97.91"
{
        Type  "Sa"
        RA           11.7331
        Dec          20.0769
        Distance   3.181e+08  # method: T-F
        Radius     5.089e+04
        AbsMag        -20.35
        Axis    [  0.8817  -0.2533  -0.3982]
        Angle     49.4933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3840"
}

Galaxy "NGC 3841:MCG 3-30-73:ZWG 97.96"
{
        Type  "S0"
        RA           11.7339
        Dec          19.9722
        Distance   2.962e+08  # method: V
        Radius     3.015e+04
        AbsMag        -20.19
        Axis    [  0.6536   0.0669  -0.7539]
        Angle     29.9221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3841"
}

Galaxy "NGC 3842:UGC 6704:MCG 3-30-72:ZWG 97.95"
{
        Type  "E0"
        RA           11.7339
        Dec          19.9500
        Distance   3.102e+08  # method: T-F
        Radius     6.316e+04
        AbsMag        -22.09
        Axis    [  0.6127  -0.7111  -0.3448]
        Angle    116.2628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3842"
}

Galaxy "NGC 3843:UGC 6699:MCG 1-30-11:ZWG 40.34"
{
        Type  "Sa"
        RA           11.7317
        Dec           7.9261
        Distance   2.834e+08  # method: V
        Radius     3.709e+04
        AbsMag        -20.39
        Axis    [  0.9812  -0.1470  -0.1254]
        Angle     71.6115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3843"
}

Galaxy "NGC 3844:UGC 6705:MCG 3-30-69:ZWG 97.97"
{
        Type  "Sa"
        RA           11.7333
        Dec          20.0294
        Distance   3.239e+08  # method: V
        Radius     5.654e+04
        AbsMag        -20.08
        Axis    [  0.9661  -0.0363   0.2555]
        Angle     86.7016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3844"
}

Galaxy "NGC 3845:MCG 3-30-74:ZWG 97.100"
{
        Type  "Sb"
        RA           11.7347
        Dec          19.9961
        Distance   2.702e+08  # method: V
        Radius     3.144e+04
        AbsMag        -19.59
        Axis    [ -0.7486   0.6614  -0.0457]
        Angle     26.3762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3845"
}

Galaxy "NGC 3846:UGC 6710:MCG 9-19-171:ZWG 268.78"
{
        Type  "Sc"
        RA           11.7411
        Dec          55.6522
        Distance   7.094e+07  # method: V
        Radius     1.032e+04
        AbsMag        -17.49
        Axis    [ -0.2075   0.9677   0.1429]
        Angle     40.1031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3846"
}

Galaxy "NGC 3846A:UGC 6706:MCG 9-19-169:ZWG 268.76"
{
        Type  "Irr"
        RA           11.7372
        Dec          55.0350
        Distance   7.325e+07  # method: V
        Radius     2.024e+04
        AbsMag        -17.86
        Axis    [  0.8211  -0.5232   0.2282]
        Angle     64.9580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3846A"
}

Galaxy "NGC 3847:NGC 3856:UGC 6708:MCG 6-26-23"
{
        Type  "E0"
        RA           11.7372
        Dec          33.5144
        Distance   4.448e+08  # method: V
        Radius     7.116e+04
        AbsMag        -21.37
        Axis    [  0.5668  -0.7898  -0.2343]
        Angle    111.8481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3847"
}

Galaxy "NGC 3848:NGC 3822:UGC 6661:MCG 2-30-15"
{
        Type  "S0"
        RA           11.7031
        Dec          10.2781
        Distance   2.934e+08  # method: V
        Radius     5.974e+04
        AbsMag        -20.97
        Axis    [ -0.8488   0.3997  -0.3461]
        Angle     70.7235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3848"
}

Galaxy "NGC 3849:IC 730:NPM 1:IRAS 11430+0330"
{
        Type  "Sa"
        RA           11.7597
        Dec           3.2322
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.9219  -0.2469  -0.2985]
        Angle     81.7652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3849"
}

Galaxy "NGC 3850:UGC 6733:MCG 9-19-174:ZWG 268.79"
{
        Type  "SBc"
        RA           11.7597
        Dec          55.8867
        Distance   5.998e+07  # method: V
        Radius     1.832e+04
        AbsMag        -17.22
        Axis    [ -0.0092   0.7211   0.6928]
        Angle     37.8128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3850"
}

Galaxy "NGC 3851:MCG 3-30-77:ZWG 97.106:ARAK 316"
{
        Type  "E0"
        RA           11.7389
        Dec          19.9811
        Distance   4.787e+08  # distance uncertain!
        Radius     4.177e+04
        AbsMag        -20.13
        Axis    [  0.4350  -0.3452  -0.8316]
        Angle     78.9512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3851"
}

Galaxy "NGC 3852:NGC 3825:UGC 6668:MCG 2-30-18"
{
        Type  "SBa"
        RA           11.7064
        Dec          10.2647
        Distance   3.104e+08  # method: V
        Radius      5.87e+04
        AbsMag        -21.19
        Axis    [ -0.6288   0.4588  -0.6277]
        Angle     63.0285
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3852"
}

Galaxy "NGC 3853:UGC 6712:MCG 3-30-81:ZWG 97.107"
{
        Type  "E0"
        RA           11.7411
        Dec          16.5583
        Distance   1.667e+08  # method: V
        Radius     3.878e+04
        AbsMag        -20.14
        Axis    [ -0.1266   0.3669  -0.9216]
        Angle     83.2970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3853"
}

Galaxy "NGC 3854:NGC 3865:MCG 1-30-28"
{
        Type  "SBb"
        RA           11.7475
        Dec          -9.2331
        Distance   2.745e+08  # method: V
        Radius     7.585e+04
        AbsMag        -21.62
        Axis    [  0.7482  -0.2620  -0.6096]
        Angle     84.9461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3854"
}

Galaxy "NGC 3855:IC 2953:UGC 6709:MCG 6-26-25"
{
        Type  "SBb"
        RA           11.7403
        Dec          33.3558
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.9441  -0.2407  -0.2253]
        Angle     39.9473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3855"
}

Galaxy "NGC 3857:MCG 3-30-84:ZWG 97.117"
{
        Type  "S0"
        RA           11.7472
        Dec          19.5331
        Distance    2.98e+08  # method: V
        Radius     4.334e+04
        AbsMag         -19.7
        Axis    [  0.9538  -0.2835  -0.0999]
        Angle     69.9716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3857"
}

Galaxy "NGC 3858:NGC 3866:MCG 1-30-29"
{
        Type  "Sa"
        RA           11.7531
        Dec          -9.3144
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [  0.8340  -0.1524  -0.5302]
        Angle     69.3902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3858"
}

Galaxy "NGC 3859:UGC 6721:MCG 3-30-91:ZWG 97.122"
{
        Type  "S0"
        RA           11.7478
        Dec          19.4547
        Distance   2.622e+08  # method: V
        Radius     4.577e+04
        AbsMag        -19.83
        Axis    [  0.9633  -0.0067   0.2682]
        Angle     56.1931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3859"
}

Galaxy "NGC 3860A:UGC 6718:MCG 3-30-88:ZWG 97.120"
{
        Type  "Sb"
        RA           11.7469
        Dec          19.7950
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.9522  -0.2941  -0.0828]
        Angle     73.7424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3860A"
}

Galaxy "NGC 3860B:MCG 3-30-87:ZWG 97.114"
{
        Type  "E0"
        RA           11.7464
        Dec          19.7733
        Distance   4.006e+08  # method: V
        Radius      2.33e+04
        AbsMag        -20.25
        Axis    [  0.6148  -0.7239  -0.3132]
        Angle    120.0607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3860B"
}

Galaxy "NGC 3861A:UGC 6724:MCG 3-30-93:ZWG 97.129"
{
        Type  "Sb"
        RA           11.7508
        Dec          19.9736
        Distance   2.991e+08  # method: T-F
        Radius     1.001e+05
        AbsMag        -21.31
        Axis    [  0.9657  -0.0990  -0.2399]
        Angle     36.7636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3861A"
}

Galaxy "NGC 3861B:MCG 3-30-94:ZWG 97.129:KCPG 299B"
{
        Type  "Sc"
        RA           11.7519
        Dec          19.9669
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.8198   0.4713   0.3254]
        Angle     16.5340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3861B"
}

Galaxy "NGC 3862:UGC 6723:MCG 3-30-95:ZWG 97.127"
{
        Type  "E0"
        RA           11.7514
        Dec          19.6064
        Distance   3.102e+08  # method: T-F
        Radius     6.767e+04
        AbsMag        -21.19
        Axis    [  0.6148  -0.7234  -0.3142]
        Angle    120.2038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3862"
}

Galaxy "NGC 3863:UGC 6722:MCG 2-30-28:ZWG 68.54"
{
        Type  "Sc"
        RA           11.7514
        Dec           8.4700
        Distance   2.192e+08  # method: V
        Radius     8.927e+04
        AbsMag        -20.34
        Axis    [  0.9791   0.1006   0.1766]
        Angle     38.9349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3863"
}

Galaxy "NGC 3864:MCG 3-30-97:ZWG 97.130"
{
        Type  "E0"
        RA           11.7542
        Dec          19.3922
        Distance   3.316e+08  # method: V
        Radius     4.341e+04
        AbsMag        -19.64
        Axis    [  0.4581  -0.3911  -0.7982]
        Angle     81.3399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3864"
}

Galaxy "NGC 3867:UGC 6731:MCG 3-30-103:ZWG 97.134"
{
        Type  "S0"
        RA           11.7581
        Dec          19.4003
        Distance   3.524e+08  # method: V
        Radius     7.689e+04
        AbsMag        -20.97
        Axis    [ -0.8926   0.4377  -0.1081]
        Angle     62.7091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3867"
}

Galaxy "NGC 3868:MCG 3-30-104:ZWG 97.135"
{
        Type  "S0"
        RA           11.7583
        Dec          19.4447
        Distance    3.16e+08  # method: V
        Radius     3.677e+04
        AbsMag        -19.73
        Axis    [  0.9885   0.1000   0.1136]
        Angle     28.4060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3868"
}

Galaxy "NGC 3869:UGC 6737:MCG 2-30-32:ZWG 68.59"
{
        Type  "Sa"
        RA           11.7625
        Dec          10.8247
        Distance   1.526e+08  # method: V
        Radius     4.216e+04
        AbsMag        -19.75
        Axis    [ -0.8980   0.4401   0.0017]
        Angle     23.6234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3869"
}

Galaxy "NGC 3870:UGC 6742:MCG 8-22-1:MK 186"
{
        Type  "S0"
        RA           11.7656
        Dec          50.2006
        Distance   4.317e+07  # method: V
        Radius          6279
        AbsMag        -17.21
        Axis    [  0.8007  -0.5804   0.1486]
        Angle     79.7896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3870"
}

Galaxy "NGC 3871:IC 2959:UGC 6744:MCG 6-26-31"
{
        Type  "Sb"
        RA           11.7694
        Dec          33.1094
        Distance   2.676e+08  # distance uncertain!
        Radius     5.448e+04
        AbsMag        -19.07
        Axis    [  0.5035   0.5113   0.6964]
        Angle     23.0778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3871"
}

Galaxy "NGC 3872:UGC 6738:MCG 2-30-33:ZWG 68.60"
{
        Type  "E5"
        RA           11.7633
        Dec          13.7667
        Distance   1.559e+08  # method: T-F
        Radius     4.309e+04
        AbsMag         -20.7
        Axis    [  0.5926  -0.6167  -0.5182]
        Angle    107.4575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3872"
}

Galaxy "NGC 3873:UGC 6735:MCG 3-30-106:ZWG 97.137"
{
        Type  "E0"
        RA           11.7628
        Dec          19.7739
        Distance   3.102e+08  # method: T-F
        Radius     6.767e+04
        AbsMag        -20.99
        Axis    [  0.2645  -0.0951  -0.9597]
        Angle     73.7011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3873"
}

Galaxy "NGC 3875:UGC 6739:MCG 3-30-105:ZWG 97.139"
{
        Type  "Sa"
        RA           11.7636
        Dec          19.7675
        Distance   3.298e+08  # method: V
        Radius     4.797e+04
        AbsMag        -20.42
        Axis    [  0.9317   0.1687   0.3218]
        Angle     27.8884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3875"
}

Galaxy "NGC 3876:UGC 6730:MCG 2-30-29:ZWG 68.55"
{
        Type  "Sb"
        RA           11.7572
        Dec           9.1608
        Distance   1.469e+08  # method: V
        Radius      2.35e+04
        AbsMag        -19.77
        Axis    [  0.3322   0.1269  -0.9346]
        Angle     29.4376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3876"
}

Galaxy "NGC 3877:UGC 6745:MCG 8-22-2:ZWG 243.4"
{
        Type  "Sc"
        RA           11.7686
        Dec          47.4944
        Distance   5.373e+07  # method: T-F
        Radius     4.142e+04
        AbsMag        -19.18
        Axis    [  0.8254  -0.1439   0.5458]
        Angle     86.6748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3877"
}

Galaxy "NGC 3878:MCG 6-26-32:ZWG 186.42:NPM 1"
{
        Type  "E0"
        RA           11.7714
        Dec          33.2050
        Distance   2.512e+08  # distance uncertain!
        Radius     1.827e+04
        AbsMag        -20.13
        Axis    [  0.5646  -0.7906  -0.2369]
        Angle    112.3467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3878"
}

Galaxy "NGC 3879:UGC 6752:MCG 12-11-40:ZWG 334.51"
{
        Type  "Irr"
        RA           11.7803
        Dec          69.3833
        Distance   1.073e+08  # method: T-F
        Radius     4.214e+04
        AbsMag        -18.99
        Axis    [ -0.2300   0.5456   0.8059]
        Angle     71.6200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3879"
}

Galaxy "NGC 3880:MCG 6-26-33:ZWG 186.43:NPM 1"
{
        Type  "E0"
        RA           11.7728
        Dec          33.1622
        Distance   4.679e+08  # method: V
        Radius     4.764e+04
        AbsMag        -20.88
        Axis    [  0.5647  -0.7905  -0.2372]
        Angle    112.3840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3880"
}

Galaxy "NGC 3881:MCG 6-26-34:ZWG 186.46:NPM 1"
{
        Type  "Sa"
        RA           11.7761
        Dec          33.1069
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.5874  -0.7786  -0.2209]
        Angle    111.7590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3881"
}

Galaxy "NGC 3882:ESO 170-11:IRAS 11436-5606"
{
        Type  "SBc"
        RA           11.7683
        Dec         -56.3889
        Distance    9.26e+07  # method: V
        Radius     3.098e+04
        AbsMag        -18.97
        Axis    [ -0.2000  -0.2584  -0.9451]
        Angle     87.6810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3882"
}

Galaxy "NGC 3883:UGC 6754:MCG 4-28-53:ZWG 127.54"
{
        Type  "Sb"
        RA           11.7797
        Dec          20.6758
        Distance   3.327e+08  # method: V
        Radius     1.355e+05
        AbsMag        -21.64
        Axis    [ -0.5542   0.5912  -0.5860]
        Angle     61.3466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3883"
}

Galaxy "NGC 3884:UGC 6746:MCG 4-28-51:ZWG 127.52"
{
        Type  "Sa"
        RA           11.7700
        Dec          20.3914
        Distance   3.291e+08  # method: V
        Radius     1.005e+05
        AbsMag        -21.52
        Axis    [  0.9193  -0.3908  -0.0470]
        Angle    101.0601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3884"
}

Galaxy "NGC 3885:ESO 440-7:MCG 5-28-6:AM 1144-273"
{
        Type  "SBa"
        RA           11.7794
        Dec         -27.9222
        Distance   9.676e+07  # method: V
        Radius     3.378e+04
        AbsMag        -20.36
        Axis    [ -0.2196  -0.1906  -0.9568]
        Angle     47.0016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3885"
}

Galaxy "NGC 3886:UGC 6760:MCG 3-30-111:ZWG 97.147"
{
        Type  "S0"
        RA           11.7847
        Dec          19.8372
        Distance   2.735e+08  # method: V
        Radius     4.774e+04
        AbsMag        -20.42
        Axis    [ -0.3363   0.5322  -0.7770]
        Angle     37.1972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3886"
}

Galaxy "NGC 3887:MCG 3-30-12:UGCA 246:IRAS 11445-1634"
{
        Type  "SBc"
        RA           11.7844
        Dec         -16.8539
        Distance   7.067e+07  # method: V
        Radius     3.597e+04
        AbsMag        -20.28
        Axis    [  0.8492  -0.2541  -0.4629]
        Angle    110.3162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3887"
}

Galaxy "NGC 3888:UGC 6765:MCG 9-19-189:MK 188"
{
        Type  "SBc"
        RA           11.7928
        Dec          55.9661
        Distance   1.167e+08  # method: V
        Radius     3.055e+04
        AbsMag        -20.07
        Axis    [  0.1441   0.9852   0.0926]
        Angle     27.9823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3888"
}

Galaxy "NGC 3889:MCG 9-19-191:DRCG 24-45"
{
        Type  "S0"
        RA           11.7967
        Dec          56.0186
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.1248   0.8628   0.4900]
        Angle     36.8599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3889"
}

Galaxy "NGC 3890:NGC 3939:UGC 6788:MCG 13-9-3"
{
        Type  "Sc"
        RA           11.8219
        Dec          74.3019
        Distance   3.114e+08  # method: V
        Radius     4.077e+04
        AbsMag         -20.8
        Axis    [  0.3550  -0.9307   0.0879]
        Angle     94.2881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3890"
}

Galaxy "NGC 3891:UGC 6772:MCG 5-28-31:ZWG 157.35"
{
        Type  "Sc"
        RA           11.8008
        Dec          30.3597
        Distance   3.014e+08  # method: V
        Radius     8.768e+04
        AbsMag        -21.33
        Axis    [  0.8270  -0.3318  -0.4539]
        Angle     46.5698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3891"
}

Galaxy "NGC 3892:MCG 2-30-30"
{
        Type  "SBa"
        RA           11.8003
        Dec         -10.9622
        Distance   9.296e+07  # method: V
        Radius     4.191e+04
        AbsMag        -19.87
        Axis    [  0.3105  -0.1209  -0.9429]
        Angle     58.1478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3892"
}

Galaxy "NGC 3893:UGC 6778:MCG 8-22-7:ZWG 243.8"
{
        Type  "SBc"
        RA           11.8106
        Dec          48.7114
        Distance   6.782e+07  # method: T-F
        Radius     4.439e+04
        AbsMag        -20.69
        Axis    [ -0.5610   0.8278   0.0056]
        Angle     62.7631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3893"
}

Galaxy "NGC 3894:UGC 6779:MCG 10-17-78:ZWG 292.33"
{
        Type  "E4"
        RA           11.8139
        Dec          59.4164
        Distance   1.528e+08  # method: V
        Radius     6.221e+04
        AbsMag        -20.75
        Axis    [  0.4824  -0.8627  -0.1516]
        Angle     81.9741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3894"
}

Galaxy "NGC 3895:UGC 6785:MCG 10-17-80:ZWG 292.35"
{
        Type  "SBa"
        RA           11.8175
        Dec          59.4331
        Distance   1.499e+08  # method: V
        Radius     2.398e+04
        AbsMag        -19.31
        Axis    [  0.2134   0.8957   0.3901]
        Angle     28.7019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3895"
}

Galaxy "NGC 3896:UGC 6781:MCG 8-22-8:ZWG 243.9"
{
        Type  "SBa"
        RA           11.8156
        Dec          48.6747
        Distance   4.874e+07  # method: V
        Radius     1.063e+04
        AbsMag        -17.17
        Axis    [ -0.1271   0.9803   0.1512]
        Angle     29.1506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3896"
}

Galaxy "NGC 3897:UGC 6784:MCG 6-26-41:ZWG 186.54"
{
        Type  "SBc"
        RA           11.8164
        Dec          35.0158
        Distance   3.027e+08  # method: V
        Radius     8.364e+04
        AbsMag        -21.24
        Axis    [  0.5758  -0.7903  -0.2095]
        Angle    111.1118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3897"
}

Galaxy "NGC 3898:UGC 6787:MCG 9-19-204:ZWG 268.88"
{
        Type  "Sb"
        RA           11.8208
        Dec          56.0847
        Distance   6.079e+07  # method: V
        Radius     3.891e+04
        AbsMag        -19.75
        Axis    [  0.3367   0.6398   0.6909]
        Angle     29.8004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3898"
}

Galaxy "NGC 3900:UGC 6786:MCG 5-28-34:ZWG 157.38"
{
        Type  "Sa"
        RA           11.8192
        Dec          27.0217
        Distance   9.495e+07  # method: V
        Radius     4.419e+04
        AbsMag        -20.02
        Axis    [  0.9292  -0.3580   0.0917]
        Angle    108.2691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3900"
}

Galaxy "NGC 3901:UGC 6675:MCG 13-9-1:ZWG 351.68"
{
        Type  "Sc"
        RA           11.7136
        Dec          77.3728
        Distance   7.928e+07  # method: V
        Radius     2.075e+04
        AbsMag        -17.53
        Axis    [ -0.4013   0.8314   0.3843]
        Angle     82.6989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3901"
}

Galaxy "NGC 3902:UGC 6790:MCG 4-28-55:ZWG 127.60"
{
        Type  "SBc"
        RA           11.8217
        Dec          26.1217
        Distance   1.769e+08  # method: V
        Radius     4.116e+04
        AbsMag        -19.87
        Axis    [  0.7481  -0.1479  -0.6469]
        Angle     36.9017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3902"
}

Galaxy "NGC 3903:ESO 378-24:MCG 6-26-8:AM 1146-371"
{
        Type  "SBc"
        RA           11.8175
        Dec         -37.5172
        Distance   1.633e+08  # method: V
        Radius     2.612e+04
        AbsMag           -20
        Axis    [ -0.0930  -0.1204  -0.9884]
        Angle     97.8375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3903"
}

Galaxy "NGC 3904:ESO 440-13:MCG 5-28-9"
{
        Type  "E2"
        RA           11.8203
        Dec         -29.2769
        Distance   9.235e+07  # method: S
        Radius     3.627e+04
        AbsMag        -20.46
        Axis    [  0.6718  -0.4616  -0.5793]
        Angle    149.5050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3904"
}

Galaxy "NGC 3905:MCG 1-30-35:IRAS 11465-0927"
{
        Type  "SBc"
        RA           11.8178
        Dec          -9.7289
        Distance   2.776e+08  # method: V
        Radius     7.673e+04
        AbsMag        -21.05
        Axis    [  0.1314  -0.0670  -0.9891]
        Angle     53.9766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3905"
}

Galaxy "NGC 3906:UGC 6797:MCG 8-22-12:ZWG 243.11"
{
        Type  "SBc"
        RA           11.8278
        Dec          48.4256
        Distance   5.291e+07  # method: V
        Radius     1.385e+04
        AbsMag        -17.25
        Axis    [  0.6554  -0.7551   0.0161]
        Angle    103.4942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3906"
}

Galaxy "NGC 3907:NGC 3907A:UGC 6796:MCG 0-30-28"
{
        Type  "S0"
        RA           11.8250
        Dec          -1.0861
        Distance   2.894e+08  # method: V
        Radius     5.051e+04
        AbsMag        -20.64
        Axis    [  0.8793  -0.2587  -0.3999]
        Angle     81.5173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3907"
}

Galaxy "NGC 3907B:UGC 6793:MCG 0-30-26:IRAS 11468-0048"
{
        Type  "Sb"
        RA           11.8231
        Dec          -1.0842
        Distance   3.063e+08  # method: V
        Radius       4.9e+04
        AbsMag        -20.26
        Axis    [  0.9728   0.0003  -0.2315]
        Angle     38.6356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3907B"
}

Galaxy "NGC 3908:NPM 1"
{
        Type  "E0"
        RA           11.8311
        Dec          12.1864
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [  0.6285  -0.6919  -0.3554]
        Angle    125.4352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3908"
}

Galaxy "NGC 3910:UGC 6800:MCG 4-28-58:ZWG 127.63"
{
        Type  "S0"
        RA           11.8331
        Dec          21.3339
        Distance   3.692e+08  # method: V
        Radius     8.592e+04
        AbsMag        -21.17
        Axis    [ -0.5664   0.5929  -0.5723]
        Angle     49.2451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3910"
}

Galaxy "NGC 3911:UGC 6803:MCG 4-28-59:IRAS 11475+2511"
{
        Type  "SBc"
        RA           11.8347
        Dec          24.9203
        Distance   1.774e+08  # method: V
        Radius     2.579e+04
        AbsMag        -18.38
        Axis    [  0.2521   0.3166  -0.9144]
        Angle     29.3273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3911"
}

Galaxy "NGC 3912:NGC 3899:UGC 6801:MCG 5-28-37"
{
        Type  "SBb"
        RA           11.8344
        Dec          26.4803
        Distance   9.463e+07  # method: V
        Radius     2.065e+04
        AbsMag        -18.91
        Axis    [  0.9172  -0.3952   0.0505]
        Angle    105.0917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3912"
}

Galaxy "NGC 3913:IC 740:UGC 6813:MCG 9-20-1"
{
        Type  "Irr"
        RA           11.8439
        Dec          55.3539
        Distance   5.096e+07  # method: V
        Radius     1.927e+04
        AbsMag        -17.47
        Axis    [  0.4752  -0.8774  -0.0659]
        Angle    101.5673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3913"
}

Galaxy "NGC 3914:UGC 6809:MCG 1-30-17:ZWG 40.50"
{
        Type  "SBb"
        RA           11.8422
        Dec           6.5675
        Distance    2.94e+08  # method: V
        Radius     4.703e+04
        AbsMag        -20.87
        Axis    [  0.9481  -0.2264  -0.2231]
        Angle     75.3660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3914"
}

Galaxy "NGC 3915:IC 2963:MCG 1-30-36:IRAS 11468-0450"
{
        Type  "Sa"
        RA           11.8233
        Dec          -5.1181
        Distance   9.228e+07  # method: V
        Radius     2.013e+04
        AbsMag        -17.46
        Axis    [  0.7471   0.0092  -0.6646]
        Angle     19.5588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3915"
}

Galaxy "NGC 3916:UGC 6819:MCG 9-20-5:ZWG 269.6"
{
        Type  "Sb"
        RA           11.8475
        Dec          55.1436
        Distance   1.851e+08  # distance uncertain!
        Radius     4.039e+04
        AbsMag        -19.07
        Axis    [  0.7548  -0.1564   0.6370]
        Angle     80.0192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3916"
}

Galaxy "NGC 3917:UGC 6815:MCG 9-20-8:ZWG 269.5"
{
        Type  "Sc"
        RA           11.8458
        Dec          51.8247
        Distance   6.655e+07  # method: T-F
        Radius     4.839e+04
        AbsMag        -19.05
        Axis    [  0.5473   0.1042   0.8304]
        Angle     60.0693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3917"
}

Galaxy "NGC 3919:UGC 6810:MCG 3-30-119:ZWG 97.161"
{
        Type  "E0"
        RA           11.8447
        Dec          20.0156
        Distance   2.938e+08  # method: V
        Radius     3.846e+04
        AbsMag        -20.37
        Axis    [  0.6041  -0.7320  -0.3149]
        Angle    120.7140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3919"
}

Galaxy "NGC 3920:UGC 6795:MCG 4-28-56:ZWG 127.61"
{
        Type  "SBc"
        RA           11.8228
        Dec          24.9386
        Distance   2.837e+08  # method: V
        Radius     4.126e+04
        AbsMag         -20.6
        Axis    [  0.6124  -0.7423  -0.2721]
        Angle    116.7502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3920"
}

Galaxy "NGC 3921:UGC 6823:MCG 9-20-9:MK 430"
{
        Type  "Sa"
        RA           11.8517
        Dec          55.0794
        Distance    2.73e+08  # method: V
        Radius     8.338e+04
        AbsMag        -21.51
        Axis    [  0.8035  -0.4923   0.3348]
        Angle     89.0344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3921"
}

Galaxy "NGC 3922:NGC 3924:UGC 6824:MCG 8-22-17"
{
        Type  "Sa"
        RA           11.8536
        Dec          50.1567
        Distance   5.445e+07  # method: V
        Radius     1.346e+04
        AbsMag        -17.31
        Axis    [  0.8456  -0.3159   0.4304]
        Angle     75.8152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3922"
}

Galaxy "NGC 3923:ESO 440-17:MCG 5-28-12:AM 1148-283"
{
        Type  "E4"
        RA           11.8503
        Dec         -28.8058
        Distance   7.472e+07  # method: S
        Radius     6.412e+04
        AbsMag         -21.2
        Axis    [  0.4400  -0.3554  -0.8247]
        Angle    131.7695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3923"
}

Galaxy "NGC 3925:MCG 4-28-71:ZWG 127.75"
{
        Type  "Sb"
        RA           11.8556
        Dec          21.8886
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.8925  -0.4486  -0.0481]
        Angle    108.1035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3925"
}

Galaxy "NGC 3926-1:NGC 3926A:UGC 6829:MCG 4-28-74"
{
        Type  "S0"
        RA           11.8572
        Dec          22.0283
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.0354   0.3706  -0.9281]
        Angle     32.3575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3926-1"
}

Galaxy "NGC 3926-2:NGC 3926B:UGC 6829:MCG 4-28-73"
{
        Type  "S0"
        RA           11.8578
        Dec          22.0264
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [  0.6184  -0.7303  -0.2902]
        Angle    118.7238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3926-2"
}

Galaxy "NGC 3928:UGC 6834:MCG 8-22-19:MK 190"
{
        Type  "E0"
        RA           11.8631
        Dec          48.6831
        Distance   5.514e+07  # method: S
        Radius     1.203e+04
        AbsMag        -17.94
        Axis    [  0.4853  -0.8637  -0.1359]
        Angle    105.1412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3928"
}

Galaxy "NGC 3929:UGC 6832:MCG 4-28-76:ZWG 127.80"
{
        Type  "E0"
        RA           11.8617
        Dec          21.0033
        Distance   3.366e+08  # method: V
        Radius     2.938e+04
        AbsMag        -20.17
        Axis    [  0.3698  -0.2793  -0.8861]
        Angle     75.0792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3929"
}

Galaxy "NGC 3930:UGC 6833:MCG 6-26-45:ZWG 186.59"
{
        Type  "SBc"
        RA           11.8625
        Dec          38.0144
        Distance   5.309e+07  # method: V
        Radius     2.317e+04
        AbsMag        -17.86
        Axis    [  0.8582  -0.5129   0.0189]
        Angle     78.2076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3930"
}

Galaxy "NGC 3930A"
{
        Type  "S0"
        RA           11.8672
        Dec          38.0197
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9961   0.0883   0.0056]
        Angle     23.5194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3930A"
}

Galaxy "NGC 3931:NGC 3917A:UGC 6925:MCG 9-20-11"
{
        Type  "S0"
        RA           11.8536
        Dec          52.0014
        Distance   4.684e+07  # method: V
        Radius          7494
        AbsMag        -15.89
        Axis    [ -0.3695   0.9098  -0.1891]
        Angle     60.0151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3931"
}

Galaxy "NGC 3933:UGC 6839:MCG 3-30-122:ZWG 97.170"
{
        Type  "S0"
        RA           11.8669
        Dec          16.8100
        Distance   2.792e+08  # method: T-F
        Radius     4.467e+04
        AbsMag        -20.36
        Axis    [  0.9349  -0.0934  -0.3423]
        Angle     32.1274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3933"
}

Galaxy "NGC 3934:UGC 6841:MCG 3-30-123:ZWG 97.171"
{
        Type  "Sb"
        RA           11.8700
        Dec          16.8517
        Distance   1.858e+08  # method: V
        Radius     2.973e+04
        AbsMag        -18.98
        Axis    [  0.6661  -0.3630  -0.6515]
        Angle     62.9174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3934"
}

Galaxy "NGC 3935:UGC 6843:MCG 6-26-49:ZWG 186.61"
{
        Type  "Sb"
        RA           11.8731
        Dec          32.4044
        Distance   1.516e+08  # method: V
        Radius     2.425e+04
        AbsMag        -19.24
        Axis    [  0.1025   0.8859   0.4524]
        Angle     16.3972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3935"
}

Galaxy "NGC 3936:ESO 504-20:MCG 4-28-4:UGCA 248"
{
        Type  "SBc"
        RA           11.8722
        Dec         -26.9058
        Distance   8.693e+07  # method: T-F
        Radius     4.931e+04
        AbsMag        -19.43
        Axis    [  0.8732   0.0491  -0.4848]
        Angle     57.1775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3936"
}

Galaxy "NGC 3937:UGC 6851:MCG 4-28-81:ZWG 127.88"
{
        Type  "S0"
        RA           11.8783
        Dec          20.6317
        Distance   3.142e+08  # method: V
        Radius     8.225e+04
        AbsMag        -21.42
        Axis    [  0.8034  -0.5515  -0.2246]
        Angle     99.8685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3937"
}

Galaxy "NGC 3938:UGC 6856:MCG 7-25-1:ZWG 214.34"
{
        Type  "Sc"
        RA           11.8803
        Dec          44.1214
        Distance   4.693e+07  # method: V
        Radius     3.686e+04
        AbsMag        -19.99
        Axis    [  0.7081  -0.7059   0.0171]
        Angle    105.4207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3938"
}

Galaxy "NGC 3940:UGC 6852:MCG 4-28-82:ZWG 127.89"
{
        Type  "E0"
        RA           11.8794
        Dec          20.9897
        Distance   3.102e+08  # method: T-F
        Radius     7.669e+04
        AbsMag        -21.09
        Axis    [  0.2251  -0.0663  -0.9721]
        Angle     71.7053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3940"
}

Galaxy "NGC 3941:UGC 6857:MCG 6-26-51:ZWG 186.62"
{
        Type  "S0"
        RA           11.8819
        Dec          36.9869
        Distance   3.976e+07  # method: S
        Radius     2.024e+04
        AbsMag        -19.13
        Axis    [  0.8527  -0.5165   0.0776]
        Angle     98.2649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3941"
}

Galaxy "NGC 3942:MCG 2-30-35:IRAS 11489-1108"
{
        Type  "Sc"
        RA           11.8583
        Dec         -11.4247
        Distance   1.835e+08  # method: V
        Radius     4.003e+04
        AbsMag        -19.25
        Axis    [ -0.3128  -0.0017  -0.9498]
        Angle     45.3400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3942"
}

Galaxy "NGC 3943:MCG 4-28-84:ZWG 127.90"
{
        Type  "S0"
        RA           11.8822
        Dec          20.4792
        Distance   3.108e+08  # method: V
        Radius     4.973e+04
        AbsMag        -20.39
        Axis    [  0.6208  -0.7243  -0.2998]
        Angle    119.8240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3943"
}

Galaxy "NGC 3944:UGC 6859:MCG 4-28-85:ZWG 127.91"
{
        Type  "S0"
        RA           11.8847
        Dec          26.2075
        Distance   1.784e+08  # method: V
        Radius     3.633e+04
        AbsMag        -19.59
        Axis    [  0.8631  -0.4894  -0.1248]
        Angle     86.5271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3944"
}

Galaxy "NGC 3945:UGC 6860:MCG 10-17-96:ZWG 292.42"
{
        Type  "S0"
        RA           11.8869
        Dec          60.6753
        Distance   6.165e+07  # method: V
        Radius     4.663e+04
        AbsMag        -19.98
        Axis    [ -0.3999   0.9088   0.1192]
        Angle     62.1663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3945"
}

Galaxy "NGC 3946:MCG 4-28-89:ZWG 127.96"
{
        Type  "Sa"
        RA           11.8889
        Dec          21.0214
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.6345  -0.1130  -0.7646]
        Angle     36.8288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3946"
}

Galaxy "NGC 3947:UGC 6863:MCG 4-28-88:ZWG 127.95"
{
        Type  "SBb"
        RA           11.8889
        Dec          20.7517
        Distance   2.951e+08  # method: V
        Radius      6.01e+04
        AbsMag        -20.88
        Axis    [  0.5549  -0.1307  -0.8216]
        Angle     41.8491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3947"
}

Galaxy "NGC 3949:UGC 6869:MCG 8-22-29:ZWG 243.25"
{
        Type  "Sc"
        RA           11.8947
        Dec          47.8600
        Distance   7.053e+07  # method: T-F
        Radius     2.975e+04
        AbsMag        -20.27
        Axis    [ -0.0162   0.8996   0.4363]
        Angle     25.9569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3949"
}

Galaxy "NGC 3950:MCG 8-22-30"
{
        Type  "E0"
        RA           11.8947
        Dec          47.8850
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [  0.4863  -0.8622  -0.1418]
        Angle    105.8788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3950"
}

Galaxy "NGC 3951:UGC 6867:MCG 4-28-90:ZWG 127.99"
{
        Type  "S0"
        RA           11.8947
        Dec          23.3822
        Distance   3.243e+08  # method: T-F
        Radius     5.189e+04
        AbsMag        -20.69
        Axis    [ -0.8602   0.5006  -0.0974]
        Angle     61.6877
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3951"
}

Galaxy "NGC 3952:IC 2972:MCG 1-30-44:IRAS 11510-0342"
{
        Type  "Irr"
        RA           11.8944
        Dec          -3.9972
        Distance   8.752e+07  # method: V
        Radius     2.037e+04
        AbsMag        -18.44
        Axis    [  0.8718  -0.0919  -0.4812]
        Angle     40.6894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3952"
}

Galaxy "NGC 3953:UGC 6870:MCG 9-20-26:ZWG 269.13"
{
        Type  "SBc"
        RA           11.8967
        Dec          52.3250
        Distance   7.135e+07  # method: T-F
        Radius      7.16e+04
        AbsMag         -21.1
        Axis    [  0.8265  -0.4496   0.3387]
        Angle     98.1925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3953"
}

Galaxy "NGC 3954:UGC 6866:MCG 4-28-91:ZWG 127.98"
{
        Type  "E0"
        RA           11.8947
        Dec          20.8825
        Distance   3.271e+08  # method: V
        Radius      3.33e+04
        AbsMag        -20.61
        Axis    [  0.5963  -0.7398  -0.3116]
        Angle    120.6066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3954"
}

Galaxy "NGC 3955:ESO 504-26:MCG 4-28-5:AM 1151-225"
{
        Type  "Sa"
        RA           11.8992
        Dec         -23.1644
        Distance   8.299e+07  # method: V
        Radius     3.742e+04
        AbsMag        -19.43
        Axis    [ -0.8657  -0.1957  -0.4608]
        Angle     60.5308
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3955"
}

Galaxy "NGC 3956:ESO 572-13:MCG 3-30-16:UGCA 251"
{
        Type  "SBc"
        RA           11.9000
        Dec         -20.5667
        Distance   1.181e+08  # method: T-F
        Radius     5.666e+04
        AbsMag        -19.89
        Axis    [  0.8740  -0.0299  -0.4851]
        Angle     63.5444
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3956"
}

Galaxy "NGC 3957:IC 2965:ESO 572-14:MCG 3-30-17"
{
        Type  "Sa"
        RA           11.9003
        Dec         -19.5689
        Distance   9.278e+07  # method: V
        Radius     3.913e+04
        AbsMag        -19.27
        Axis    [ -0.9371  -0.2042  -0.2830]
        Angle     63.4175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3957"
}

Galaxy "NGC 3958:UGC 6880:MCG 10-17-98:ZWG 292.43"
{
        Type  "SBa"
        RA           11.9092
        Dec          58.3667
        Distance   1.595e+08  # method: V
        Radius     3.015e+04
        AbsMag        -19.95
        Axis    [  0.7902  -0.3308   0.5160]
        Angle     90.2674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3958"
}

Galaxy "NGC 3959:MCG 1-30-46"
{
        Type  "SBa"
        RA           11.9103
        Dec          -7.7564
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.7850  -0.3307  -0.5239]
        Angle     95.8233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3959"
}

Galaxy "NGC 3961:UGC 6885:ZWG 334.55"
{
        Type  "SBa"
        RA           11.9158
        Dec          69.3297
        Distance   3.085e+08  # method: V
        Radius     5.833e+04
        AbsMag        -20.48
        Axis    [  0.3824  -0.9229   0.0457]
        Angle     97.1139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3961"
}

Galaxy "NGC 3962:MCG 2-30-40:UGCA 253"
{
        Type  "E1"
        RA           11.9108
        Dec         -13.9747
        Distance   1.152e+08  # method: S
        Radius     4.356e+04
        AbsMag        -21.04
        Axis    [  0.6431  -0.5402  -0.5427]
        Angle    137.5388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3962"
}

Galaxy "NGC 3963:UGC 6884:MCG 10-17-100:ZWG 292.44"
{
        Type  "SBc"
        RA           11.9161
        Dec          58.4933
        Distance   1.513e+08  # method: V
        Radius     5.942e+04
        AbsMag        -20.83
        Axis    [  0.7364  -0.6632   0.1334]
        Angle     68.0538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3963"
}

Galaxy "NGC 3964:MCG 5-28-43:ZWG 157.50"
{
        Type  "S0"
        RA           11.9147
        Dec          28.2628
        Distance   4.015e+08  # method: V
        Radius     5.256e+04
        AbsMag        -20.35
        Axis    [  0.8623  -0.2774  -0.4236]
        Angle     40.0463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3964"
}

Galaxy "NGC 3966:NGC 3986:UGC 6920:MCG 5-28-53"
{
        Type  "Sa"
        RA           11.9456
        Dec          32.0214
        Distance   1.605e+08  # method: V
        Radius     7.235e+04
        AbsMag        -19.66
        Axis    [  0.1178   0.4251   0.8974]
        Angle     29.3378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3966"
}

Galaxy "NGC 3967:MCG 1-30-47:NPM 1"
{
        Type  "S0"
        RA           11.9194
        Dec          -7.8431
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [ -0.1475  -0.0017  -0.9891]
        Angle     48.2376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3967"
}

Galaxy "NGC 3968:UGC 6895:MCG 2-30-45:ZWG 68.92"
{
        Type  "SBc"
        RA           11.9244
        Dec          11.9686
        Distance   3.049e+08  # method: V
        Radius     1.197e+05
        AbsMag        -22.15
        Axis    [  0.9076  -0.3899  -0.1557]
        Angle    104.5096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3968"
}

Galaxy "NGC 3969:ESO 572-17:MCG 3-30-20"
{
        Type  "SBa"
        RA           11.9192
        Dec         -18.9272
        Distance   3.187e+08  # method: V
        Radius     6.489e+04
        AbsMag        -20.95
        Axis    [  0.6677  -0.1894  -0.7200]
        Angle     73.3026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3969"
}

Galaxy "NGC 3970:MCG 2-30-41"
{
        Type  "S0"
        RA           11.9244
        Dec         -12.0614
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.4364  -0.1375  -0.8892]
        Angle     34.5686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3970"
}

Galaxy "NGC 3971:NGC 3984:UGC 6899:MCG 5-28-47"
{
        Type  "S0"
        RA           11.9267
        Dec          29.9958
        Distance   3.247e+08  # method: V
        Radius     6.611e+04
        AbsMag        -21.19
        Axis    [  0.8154  -0.5517  -0.1755]
        Angle     81.8663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3971"
}

Galaxy "NGC 3972:UGC 6904:MCG 9-20-32:ZWG 269.16"
{
        Type  "SBc"
        RA           11.9292
        Dec          55.3200
        Distance   7.303e+07  # method: T-F
        Radius      3.93e+04
        AbsMag        -18.85
        Axis    [ -0.0971   0.5276   0.8439]
        Angle     49.1118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3972"
}

Galaxy "NGC 3973:MCG 2-31-1:ZWG 68.93:ZWG 69.5"
{
        Type  "S0"
        RA           11.9269
        Dec          11.9972
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.8883  -0.4181  -0.1898]
        Angle    103.3354
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3973"
}

Galaxy "NGC 3974:MCG 2-31-1"
{
        Type  "SBa"
        RA           11.9278
        Dec         -12.0272
        Distance    1.54e+08  # distance uncertain!
        Radius     2.687e+04
        AbsMag        -19.07
        Axis    [  0.7936  -0.4083  -0.4512]
        Angle    122.7597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3974"
}

Galaxy "NGC 3975:MCG 10-17-103"
{
        Type  "Sb"
        RA           11.9314
        Dec          60.5297
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [  0.4041   0.2784   0.8713]
        Angle     44.9399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3975"
}

Galaxy "NGC 3976:UGC 6906:MCG 1-31-1:ZWG 41.6"
{
        Type  "SBb"
        RA           11.9325
        Dec           6.7483
        Distance   1.114e+08  # method: T-F
        Radius     6.157e+04
        AbsMag        -20.17
        Axis    [  0.9940  -0.0960  -0.0534]
        Angle     60.3569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3976"
}

Galaxy "NGC 3976A:MCG 1-31-1A:ZWG 41.7:ARAK 333"
{
        Type  "Sa"
        RA           11.9339
        Dec           6.6775
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.9010   0.2792  -0.3320]
        Angle     38.1919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3976A"
}

Galaxy "NGC 3977:NGC 3980:UGC 6909:MCG 9-20-34"
{
        Type  "Sb"
        RA           11.9353
        Dec          55.3908
        Distance   2.669e+08  # method: V
        Radius     5.823e+04
        AbsMag        -20.16
        Axis    [  0.6406  -0.7648   0.0689]
        Angle     94.1346
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3977"
}

Galaxy "NGC 3978:UGC 6910:MCG 10-17-105:ZWG 292.47"
{
        Type  "SBc"
        RA           11.9361
        Dec          60.5228
        Distance   4.586e+08  # method: V
        Radius     1.134e+05
        AbsMag        -22.54
        Axis    [  0.6999  -0.6926   0.1746]
        Angle     76.6731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3978"
}

Galaxy "NGC 3979:IC 2976:UGC 6907:MCG 0-31-3"
{
        Type  "S0"
        RA           11.9336
        Dec          -2.7206
        Distance   1.168e+08  # distance uncertain!
        Radius     1.869e+04
        AbsMag        -19.07
        Axis    [  0.0243  -0.0144  -0.9996]
        Angle     53.9813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3979"
}

Galaxy "NGC 3981:ESO 572-20:MCG 3-31-1:UGCA 255"
{
        Type  "SBc"
        RA           11.9353
        Dec         -19.8972
        Distance   9.368e+07  # method: V
        Radius     7.222e+04
        AbsMag        -20.49
        Axis    [  0.9349  -0.0836  -0.3450]
        Angle    106.3478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3981"
}

Galaxy "NGC 3982:UGC 6918:MCG 9-20-36:ZWG 269.19"
{
        Type  "SBb"
        RA           11.9411
        Dec          55.1250
        Distance   5.785e+07  # method: V
        Radius     1.935e+04
        AbsMag        -19.34
        Axis    [  0.8002  -0.5917   0.0983]
        Angle     57.8050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3982"
}

Galaxy "NGC 3983:UGC 6914:MCG 4-28-98:ZWG 127.108"
{
        Type  "Sa"
        RA           11.9397
        Dec          23.8681
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.0012   0.6075   0.7943]
        Angle     17.1296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3983"
}

Galaxy "NGC 3985:UGC 6921:MCG 8-22-45:ZWG 243.31"
{
        Type  "Irr"
        RA           11.9447
        Dec          48.3356
        Distance   5.259e+07  # method: V
        Radius          9944
        AbsMag        -17.84
        Axis    [  0.8907  -0.1782   0.4182]
        Angle     40.4376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3985"
}

Galaxy "NGC 3987:UGC 6928:MCG 4-28-99:ZWG 127.110"
{
        Type  "Sb"
        RA           11.9556
        Dec          25.1953
        Distance   2.176e+08  # method: V
        Radius     6.964e+04
        AbsMag        -20.22
        Axis    [  0.9009  -0.0211   0.4335]
        Angle     60.3490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3987"
}

Galaxy "NGC 3988:MCG 5-28-57:ZWG 157.61:NPM 1"
{
        Type  "E0"
        RA           11.9567
        Dec          27.8781
        Distance   3.106e+08  # method: V
        Radius     4.066e+04
        AbsMag        -20.29
        Axis    [  0.5335  -0.6277  -0.5669]
        Angle     87.0623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3988"
}

Galaxy "NGC 3989:MCG 4-28-100:ZWG 127.111:KUG 1154+255"
{
        Type  "Sb"
        RA           11.9572
        Dec          25.2328
        Distance   2.272e+08  # method: V
        Radius     1.983e+04
        AbsMag        -18.51
        Axis    [ -0.6725   0.7255  -0.1466]
        Angle     26.1222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3989"
}

Galaxy "NGC 3990:UGC 6938:MCG 9-20-43:ZWG 269.24"
{
        Type  "S0"
        RA           11.9597
        Dec          55.4586
        Distance   3.353e+07  # method: S
        Radius          6828
        AbsMag        -16.56
        Axis    [  0.8124  -0.3970   0.4270]
        Angle     72.8791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3990"
}

Galaxy "NGC 3991:UGC 6933:MCG 6-26-60:ZWG 186.73"
{
        Type  "Irr"
        RA           11.9583
        Dec          32.3356
        Distance   1.573e+08  # method: V
        Radius     2.974e+04
        AbsMag        -19.82
        Axis    [  0.9203  -0.1427   0.3643]
        Angle     84.0727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3991"
}

Galaxy "M 109:NGC 3992:UGC 6937:MCG 9-20-44"
{
        Type  "SBc"
        RA           11.9597
        Dec          53.3736
        Distance    1.23e+08  # method: T-F
        Radius     1.342e+05
        AbsMag        -22.28
        Axis    [  0.8278  -0.2048   0.5224]
        Angle     47.4439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 109"
}

Galaxy "NGC 3993:UGC 6935:MCG 4-28-101:ZWG 127.112"
{
        Type  "Sb"
        RA           11.9603
        Dec          25.2403
        Distance   2.324e+08  # method: V
        Radius     5.409e+04
        AbsMag        -19.56
        Axis    [ -0.7624   0.4980   0.4133]
        Angle     34.5431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3993"
}

Galaxy "NGC 3994:UGC 6936:MCG 6-26-59:ZWG 186.74"
{
        Type  "Sc"
        RA           11.9600
        Dec          32.2775
        Distance   1.528e+08  # method: V
        Radius     2.001e+04
        AbsMag        -19.95
        Axis    [  0.9068  -0.4049   0.1175]
        Angle    100.5542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3994"
}

Galaxy "NGC 3995:UGC 6944:MCG 6-26-61:ZWG 186.75"
{
        Type  "Irr"
        RA           11.9622
        Dec          32.2931
        Distance   1.602e+08  # method: V
        Radius     6.057e+04
        AbsMag        -20.76
        Axis    [  0.9338  -0.2303   0.2740]
        Angle     80.8769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3995"
}

Galaxy "NGC 3996:UGC 6941:MCG 3-31-4:ZWG 98.11"
{
        Type  "Sc"
        RA           11.9628
        Dec          14.2975
        Distance   3.317e+08  # method: V
        Radius     4.342e+04
        AbsMag        -20.44
        Axis    [  0.8329  -0.3882  -0.3945]
        Angle     69.1279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3996"
}

Galaxy "NGC 3997:UGC 6942:MCG 4-28-102:ZWG 127.114"
{
        Type  "SBb"
        RA           11.9633
        Dec          25.2708
        Distance   2.297e+08  # method: V
        Radius     5.345e+04
        AbsMag        -20.24
        Axis    [ -0.7612   0.6485   0.0033]
        Angle     31.3520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3997"
}

Galaxy "NGC 3998:UGC 6946:MCG 9-20-46:ZWG 269.25"
{
        Type  "S0"
        RA           11.9653
        Dec          55.4539
        Distance   4.607e+07  # method: S
        Radius     1.809e+04
        AbsMag        -19.15
        Axis    [ -0.1500   0.9708  -0.1870]
        Angle     41.5433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3998"
}

Galaxy "NGC 3999:ZWG 127.117"
{
        Type  "S0"
        RA           11.9656
        Dec          25.0683
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.9945  -0.1010   0.0281]
        Angle     31.7649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 3999"
}

Galaxy "NGC 4000:UGC 6949:MCG 4-28-103:ZWG 127.118"
{
        Type  "Sc"
        RA           11.9658
        Dec          25.1439
        Distance   2.202e+08  # method: V
        Radius     3.202e+04
        AbsMag        -18.85
        Axis    [  0.9650  -0.1336   0.2257]
        Angle    112.2271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4000"
}

Galaxy "NGC 4001:MCG 8-22-47:ZWG 243.33:NPM 1"
{
        Type  "E4"
        RA           11.9683
        Dec          47.3353
        Distance   5.249e+08  # distance uncertain!
        Radius     5.344e+04
        AbsMag        -20.13
        Axis    [ -0.0886   0.7640  -0.6391]
        Angle     77.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4001"
}

Galaxy "NGC 4002:MCG 4-28-104:ZWG 127.116:KCPG 312A"
{
        Type  "Sb"
        RA           11.9664
        Dec          23.2028
        Distance   3.118e+08  # method: V
        Radius     4.988e+04
        AbsMag           -20
        Axis    [  0.3819   0.7152  -0.5853]
        Angle     11.6788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4002"
}

Galaxy "NGC 4003:UGC 6948:MCG 4-28-105:ZWG 127.115"
{
        Type  "S0"
        RA           11.9664
        Dec          23.1253
        Distance   3.089e+08  # method: V
        Radius     6.738e+04
        AbsMag        -20.38
        Axis    [ -0.7282   0.6043  -0.3232]
        Angle     42.7608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4003"
}

Galaxy "NGC 4004:NGC 4004A:UGC 6950:MCG 5-28-60"
{
        Type  "Irr"
        RA           11.9681
        Dec          27.8786
        Distance   1.663e+08  # method: V
        Radius     4.354e+04
        AbsMag        -19.54
        Axis    [  0.9504  -0.2515   0.1830]
        Angle    105.0176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4004"
}

Galaxy "NGC 4006:UGC 6951:MCG 0-31-6:ZWG 13.15"
{
        Type  "E0"
        RA           11.9681
        Dec          -2.1203
        Distance   1.995e+08  # distance uncertain!
        Radius     4.644e+04
        AbsMag        -20.13
        Axis    [  0.5934  -0.5755  -0.5627]
        Angle    123.4383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4006"
}

Galaxy "NGC 4007:NGC 4005:UGC 6952:MCG 4-28-107"
{
        Type  "S0"
        RA           11.9694
        Dec          25.1222
        Distance   2.159e+08  # method: V
        Radius     3.768e+04
        AbsMag         -20.2
        Axis    [  0.9627   0.0078  -0.2704]
        Angle     22.5146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4007"
}

Galaxy "NGC 4008:UGC 6953:MCG 5-28-61:ZWG 157.66"
{
        Type  "E5"
        RA           11.9714
        Dec          28.1928
        Distance   1.599e+08  # method: T-F
        Radius     5.583e+04
        AbsMag        -20.55
        Axis    [ -0.2531   0.6394  -0.7261]
        Angle     87.8617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4008"
}

Galaxy "NGC 4010:UGC 6964:MCG 8-22-49:ZWG 243.34"
{
        Type  "SBc"
        RA           11.9769
        Dec          47.2603
        Distance   6.655e+07  # method: T-F
        Radius     4.065e+04
        AbsMag        -18.55
        Axis    [  0.6859  -0.0075   0.7277]
        Angle     64.7784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4010"
}

Galaxy "NGC 4011:ZWG 127.121"
{
        Type  "S0"
        RA           11.9736
        Dec          25.0978
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.9535  -0.2941   0.0662]
        Angle     72.7562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4011"
}

Galaxy "NGC 4012:UGC 6960:MCG 2-31-6:ZWG 69.9"
{
        Type  "Sb"
        RA           11.9742
        Dec          10.0217
        Distance    1.54e+08  # distance uncertain!
        Radius     4.255e+04
        AbsMag        -19.07
        Axis    [ -0.9561   0.2774  -0.0940]
        Angle     40.3175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4012"
}

Galaxy "NGC 4013:UGC 6963:MCG 7-25-9:ZWG 215.10"
{
        Type  "Sb"
        RA           11.9753
        Dec          43.9472
        Distance   6.347e+07  # method: T-F
        Radius       4.8e+04
        AbsMag        -19.14
        Axis    [  0.7050   0.0022   0.7092]
        Angle     63.6853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4013"
}

Galaxy "NGC 4015-1:UGC 6965:MCG 4-28-109:ZWG 127.122"
{
        Type  "Sc"
        RA           11.9783
        Dec          25.0367
        Distance   2.107e+08  # method: V
        Radius     6.129e+04
        AbsMag        -19.85
        Axis    [ -0.3420   0.6047  -0.7193]
        Angle     31.8320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4015-1"
}

Galaxy "NGC 4015-2:UGC 6965:MCG 4-28-110:ZWG 127.122"
{
        Type  "Sb"
        RA           11.9786
        Dec          25.0425
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.9572  -0.2498   0.1463]
        Angle     92.5892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4015-2"
}

Galaxy "NGC 4016:UGC 6954:MCG 5-28-63:ZWG 157.68"
{
        Type  "SBc"
        RA           11.9747
        Dec          27.5289
        Distance   1.696e+08  # method: V
        Radius     3.699e+04
        AbsMag        -19.18
        Axis    [ -0.8129   0.5700  -0.1193]
        Angle     65.1455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4016"
}

Galaxy "NGC 4017:UGC 6967:MCG 5-28-65:ZWG 157.69"
{
        Type  "SBc"
        RA           11.9792
        Dec          27.4531
        Distance   1.697e+08  # method: V
        Radius     4.444e+04
        AbsMag        -20.18
        Axis    [  0.8579  -0.3332  -0.3911]
        Angle     43.8126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4017"
}

Galaxy "NGC 4018:UGC 6966:MCG 4-28-108:ZWG 127.123"
{
        Type  "Sb"
        RA           11.9778
        Dec          25.3172
        Distance   2.167e+08  # method: V
        Radius     5.357e+04
        AbsMag        -20.11
        Axis    [ -0.8817   0.3559   0.3098]
        Angle     55.3537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4018"
}

Galaxy "NGC 4019:IC 755:UGC 7001:MCG 2-31-14"
{
        Type  "SBb"
        RA           12.0194
        Dec          14.1042
        Distance   8.331e+07  # method: V
        Radius     2.908e+04
        AbsMag        -18.04
        Axis    [ -0.9100   0.2554   0.3265]
        Angle     34.4639
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4019"
}

Galaxy "NGC 4020:UGC 6971:MCG 5-28-66:ZWG 157.72"
{
        Type  "SBc"
        RA           11.9822
        Dec          30.4136
        Distance   4.729e+07  # method: V
        Radius     1.307e+04
        AbsMag        -17.61
        Axis    [  0.9204  -0.3741   0.1137]
        Angle     96.0912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4020"
}

Galaxy "NGC 4021:MCG 4-28-112:ZWG 127.124:ARAK 339"
{
        Type  "E0"
        RA           11.9839
        Dec          25.0836
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.3416  -0.2505  -0.9059]
        Angle     69.7310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4021"
}

Galaxy "NGC 4022:UGC 6975:MCG 4-28-111:ZWG 127.125"
{
        Type  "S0"
        RA           11.9836
        Dec          25.2225
        Distance   2.103e+08  # method: V
        Radius     3.671e+04
        AbsMag        -19.85
        Axis    [  0.5954  -0.7549  -0.2749]
        Angle    117.9846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4022"
}

Galaxy "NGC 4023:UGC 6977:MCG 4-28-113:ZWG 127.127"
{
        Type  "S0"
        RA           11.9847
        Dec          24.9892
        Distance   2.139e+08  # method: V
        Radius       2.8e+04
        AbsMag        -19.48
        Axis    [  0.8595  -0.4929  -0.1354]
        Angle     87.4286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4023"
}

Galaxy "NGC 4024:ESO 572-31:MCG 3-31-4"
{
        Type  "S0"
        RA           11.9753
        Dec         -18.3467
        Distance   7.466e+07  # method: T-F
        Radius     2.063e+04
        AbsMag         -19.1
        Axis    [  0.4897  -0.2500  -0.8353]
        Angle     83.4183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4024"
}

Galaxy "NGC 4025:UGC 6982:MCG 6-26-64:DDO 107"
{
        Type  "SBc"
        RA           11.9861
        Dec          37.7922
        Distance   1.572e+08  # method: V
        Radius     5.717e+04
        AbsMag        -19.41
        Axis    [  0.9011  -0.3919   0.1855]
        Angle     79.8328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4025"
}

Galaxy "NGC 4026:UGC 6985:MCG 9-20-52:ZWG 269.29"
{
        Type  "S0"
        RA           11.9903
        Dec          50.9619
        Distance   4.441e+07  # method: S
        Radius     3.358e+04
        AbsMag        -18.97
        Axis    [ -0.7329   0.6005   0.3198]
        Angle     78.5423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4026"
}

Galaxy "NGC 4027:ESO 572-37:MCG 3-31-8:UGCA 260"
{
        Type  "SBc"
        RA           11.9917
        Dec         -19.2658
        Distance   9.115e+07  # method: V
        Radius     4.375e+04
        AbsMag        -20.63
        Axis    [ -0.7371   0.0671  -0.6724]
        Angle     77.2661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4027"
}

Galaxy "NGC 4027A:ESO 572-36:MCG 3-31-7:VV 66"
{
        Type  "Irr"
        RA           11.9914
        Dec         -19.3319
        Distance   9.472e+07  # method: V
        Radius      1.24e+04
        AbsMag        -17.31
        Axis    [ -0.7046   0.0149  -0.7094]
        Angle     69.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4027A"
}

Galaxy "NGC 4028:NGC 4014:UGC 6961:MCG 3-31-5"
{
        Type  "Sa"
        RA           11.9764
        Dec          16.1772
        Distance   1.852e+08  # method: V
        Radius     3.771e+04
        AbsMag        -20.47
        Axis    [ -0.1682   0.3949  -0.9032]
        Angle     23.4570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4028"
}

Galaxy "NGC 4029:UGC 6990:MCG 1-31-8:ZWG 41.17"
{
        Type  "SBb"
        RA           12.0008
        Dec           8.1822
        Distance   2.936e+08  # method: V
        Radius     5.123e+04
        AbsMag        -20.47
        Axis    [ -0.7696   0.3445  -0.5376]
        Angle     44.0838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4029"
}

Galaxy "NGC 4030:UGC 6993:MCG 0-31-16:ZWG 13.33"
{
        Type  "Sc"
        RA           12.0064
        Dec          -1.1006
        Distance   7.529e+07  # method: T-F
        Radius     4.599e+04
        AbsMag        -20.42
        Axis    [  0.8496  -0.3537  -0.3912]
        Angle     96.1583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4030"
}

Galaxy "NGC 4031:MCG 5-28-75:ZWG 157.82:ARAK 341"
{
        Type  "Sb"
        RA           12.0086
        Dec          31.9467
        Distance   3.667e+08  # method: V
        Radius     3.733e+04
        AbsMag        -20.05
        Axis    [  0.9503  -0.2957   0.0970]
        Angle     51.5605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4031"
}

Galaxy "NGC 4032:UGC 6995:MCG 3-31-10:ZWG 98.19"
{
        Type  "Irr"
        RA           12.0089
        Dec          20.0747
        Distance    7.18e+07  # method: V
        Radius     1.671e+04
        AbsMag        -18.91
        Axis    [ -0.7117   0.5641  -0.4187]
        Angle     65.8087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4032"
}

Galaxy "NGC 4033:ESO 572-42:MCG 3-31-11"
{
        Type  "E6"
        RA           12.0094
        Dec         -17.8433
        Distance   6.878e+07  # method: S
        Radius     2.401e+04
        AbsMag        -19.02
        Axis    [  0.4553  -0.4149  -0.7878]
        Angle    123.1182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4033"
}

Galaxy "NGC 4034:UGC 7006:MCG 12-11-44:ZWG 335.2"
{
        Type  "Sc"
        RA           12.0247
        Dec          69.3239
        Distance   1.121e+08  # method: V
        Radius     2.771e+04
        AbsMag        -18.38
        Axis    [  0.6679  -0.6461   0.3694]
        Angle    103.5217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4034"
}

Galaxy "NGC 4035:MCG 3-31-10:SZ 122:IRAS 11579-1540"
{
        Type  "SBc"
        RA           12.0081
        Dec         -15.9492
        Distance   8.693e+07  # method: V
        Radius     1.391e+04
        AbsMag        -17.93
        Axis    [  0.8196  -0.3949  -0.4151]
        Angle    132.0393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4035"
}

Galaxy "NGC 4036:UGC 7005:MCG 10-17-125:ZWG 292.59"
{
        Type  "S0"
        RA           12.0242
        Dec          61.8961
        Distance   6.931e+07  # method: V
        Radius     4.335e+04
        AbsMag        -20.14
        Axis    [  0.5045   0.1063   0.8568]
        Angle     52.1714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4036"
}

Galaxy "NGC 4037:UGC 7002:MCG 2-31-15:ZWG 69.27"
{
        Type  "SBb"
        RA           12.0231
        Dec          13.4006
        Distance   5.731e+07  # method: V
        Radius         2e+04
        AbsMag        -18.42
        Axis    [  0.7787  -0.5605  -0.2820]
        Angle    110.3076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4037"
}

Galaxy "NGC 4038:ESO 572-47:MCG 3-31-14:UGCA 264"
{
        Type  "Irr"
        RA           12.0311
        Dec         -18.8644
        Distance   8.929e+07  # method: V
        Radius     4.415e+04
        AbsMag        -21.29
        Axis    [  0.3797  -0.1926  -0.9048]
        Angle     47.4502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4038"
}

Galaxy "NGC 4039:ESO 572-48:MCG 3-31-15:UGCA 265"
{
        Type  "Irr"
        RA           12.0314
        Dec         -18.8856
        Distance   9.056e+07  # method: V
        Radius     4.346e+04
        AbsMag        -21.22
        Axis    [  0.7900  -0.1608  -0.5916]
        Angle     73.2758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4039"
}

Galaxy "NGC 4040:UGC 7013:MCG 3-31-18:ZWG 98.28"
{
        Type  "E0"
        RA           12.0347
        Dec          17.8239
        Distance   3.163e+08  # distance uncertain!
        Radius      8.74e+04
        AbsMag        -20.13
        Axis    [ -0.1885   0.3938  -0.8996]
        Angle     81.2050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4040"
}

Galaxy "NGC 4041:UGC 7014:MCG 10-17-129:ZWG 292.61"
{
        Type  "Sc"
        RA           12.0364
        Dec          62.1369
        Distance   6.179e+07  # method: V
        Radius     2.427e+04
        AbsMag        -19.49
        Axis    [  0.8418  -0.5197  -0.1459]
        Angle     36.0378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4041"
}

Galaxy "NGC 4042"
{
        Type  "E0"
        RA           12.0461
        Dec          20.1642
        Distance   1.047e+09  # distance uncertain!
        Radius     3.046e+04
        AbsMag        -20.13
        Axis    [  0.5834  -0.7465  -0.3199]
        Angle    122.2935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4042"
}

Galaxy "NGC 4043:UGC 7015:MCG 1-31-12:ZWG 41.26"
{
        Type  "S0"
        RA           12.0397
        Dec           4.3300
        Distance   3.085e+08  # method: V
        Radius     2.692e+04
        AbsMag        -20.28
        Axis    [ -0.3583   0.2197  -0.9074]
        Angle     52.9840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4043"
}

Galaxy "NGC 4044:UGC 7018:MCG 0-31-20:ZWG 13.43"
{
        Type  "E0"
        RA           12.0414
        Dec          -0.2125
        Distance   2.512e+08  # distance uncertain!
        Radius     4.384e+04
        AbsMag        -20.13
        Axis    [  0.4548  -0.4639  -0.7602]
        Angle    105.8465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4044"
}

Galaxy "NGC 4045:NGC 4046:UGC 7021:MCG 0-31-22"
{
        Type  "SBa"
        RA           12.0450
        Dec           1.9769
        Distance   1.054e+08  # method: V
        Radius      4.14e+04
        AbsMag        -19.75
        Axis    [  0.4787  -0.1536  -0.8645]
        Angle     37.1890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4045"
}

Galaxy "NGC 4045A:MCG 0-31-21:ZWG 13.45:ARAK 343"
{
        Type  "S0"
        RA           12.0450
        Dec           1.9522
        Distance   2.414e+08  # method: V
        Radius     2.107e+04
        AbsMag        -18.95
        Axis    [ -0.7171   0.2608  -0.6464]
        Angle     52.6474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4045A"
}

Galaxy "NGC 4047:UGC 7025:MCG 8-22-58:ZWG 243.37"
{
        Type  "Sb"
        RA           12.0472
        Dec          48.6367
        Distance   1.635e+08  # method: V
        Radius     3.806e+04
        AbsMag         -20.4
        Axis    [  0.7818   0.5815  -0.2251]
        Angle     17.4341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4047"
}

Galaxy "NGC 4048:UGC 7023:MCG 3-31-20:ZWG 98.30"
{
        Type  "S0"
        RA           12.0472
        Dec          18.0156
        Distance   2.327e+08  # method: V
        Radius      2.03e+04
        AbsMag        -19.37
        Axis    [  0.5136  -0.1624  -0.8425]
        Angle     40.5890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4048"
}

Galaxy "NGC 4049:UGC 7027:MCG 3-31-21:ZWG 98.31"
{
        Type  "Irr"
        RA           12.0483
        Dec          18.7525
        Distance    5.21e+07  # method: V
        Radius          6819
        AbsMag        -16.52
        Axis    [  0.9035  -0.3610  -0.2309]
        Angle     62.6166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4049"
}

Galaxy "NGC 4050:MCG 3-31-16:IRAS 12003-1605"
{
        Type  "SBb"
        RA           12.0481
        Dec         -16.3742
        Distance   9.581e+07  # method: V
        Radius     4.181e+04
        AbsMag        -19.34
        Axis    [  0.4372  -0.2090  -0.8747]
        Angle     60.4628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4050"
}

Galaxy "NGC 4051:UGC 7030:MCG 8-22-59:ZWG 243.38"
{
        Type  "SBc"
        RA           12.0525
        Dec          44.5319
        Distance   4.281e+07  # method: V
        Radius     3.238e+04
        AbsMag        -19.79
        Axis    [ -0.2888   0.9387  -0.1880]
        Angle     31.7708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4051"
}

Galaxy "NGC 4053:UGC 7029:MCG 3-31-24:ZWG 98.32"
{
        Type  "S0"
        RA           12.0531
        Dec          19.7292
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.7035   0.7103  -0.0248]
        Angle      7.8164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4053"
}

Galaxy "NGC 4054-1:MCG 10-17-131:ZWG 292.62:VV 136"
{
        Type  "S0"
        RA           12.0533
        Dec          57.8933
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.7148   0.0251   0.6989]
        Angle     37.4564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4054-1"
}

Galaxy "NGC 4054-2:MCG 10-17-131:ZWG 292.62:VV 136"
{
        Type  "E0"
        RA           12.0536
        Dec          57.8914
        Distance   5.496e+08  # distance uncertain!
        Radius     6.395e+04
        AbsMag        -20.13
        Axis    [  0.1003   0.7460  -0.6584]
        Angle     59.7217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4054-2"
}

Galaxy "NGC 4056"
{
        Type  "E0"
        RA           12.0658
        Dec          20.3131
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.5809  -0.7486  -0.3197]
        Angle    122.3721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4056"
}

Galaxy "NGC 4058:UGC 7036:MCG 1-31-17:ZWG 41.32"
{
        Type  "Sa"
        RA           12.0633
        Dec           3.5481
        Distance   2.785e+08  # method: V
        Radius     4.861e+04
        AbsMag        -20.56
        Axis    [ -0.9017   0.2386  -0.3605]
        Angle     55.5748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4058"
}

Galaxy "NGC 4060:ZWG 128.6"
{
        Type  "S0"
        RA           12.0669
        Dec          20.3381
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.8642  -0.0884  -0.4953]
        Angle     23.7857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4060"
}

Galaxy "NGC 4061:NGC 4055:UGC 7044:MCG 4-29-6"
{
        Type  "E0"
        RA           12.0669
        Dec          20.2328
        Distance   3.406e+08  # method: V
        Radius     5.945e+04
        AbsMag        -20.89
        Axis    [ -0.3319   0.5934  -0.7333]
        Angle     92.4968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4061"
}

Galaxy "NGC 4062:UGC 7045:MCG 5-29-4:ZWG 158.8"
{
        Type  "SBc"
        RA           12.0675
        Dec          31.8953
        Distance   6.261e+07  # method: T-F
        Radius     3.642e+04
        AbsMag        -19.51
        Axis    [  0.7909   0.3040   0.5311]
        Angle     18.3396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4062"
}

Galaxy "NGC 4063:UGC 7042:MCG 0-31-26:ZWG 13.55"
{
        Type  "S0"
        RA           12.0681
        Dec           1.8469
        Distance   2.413e+08  # method: V
        Radius     3.861e+04
        AbsMag        -19.45
        Axis    [  0.9952  -0.0885  -0.0417]
        Angle    103.5858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4063"
}

Galaxy "NGC 4064:UGC 7054:MCG 3-31-33:ZWG 98.44"
{
        Type  "SBa"
        RA           12.0697
        Dec          18.4433
        Distance   5.599e+07  # method: V
        Radius     3.746e+04
        AbsMag        -19.57
        Axis    [ -0.9010   0.4338  -0.0059]
        Angle     37.8111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4064"
}

Galaxy "NGC 4065:NGC 4057:UGC 7050:MCG 4-29-7"
{
        Type  "E0"
        RA           12.0683
        Dec          20.2358
        Distance   3.001e+08  # method: V
        Radius     4.801e+04
        AbsMag        -21.12
        Axis    [ -0.0567   0.2532  -0.9657]
        Angle     73.8773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4065"
}

Galaxy "NGC 4066:UGC 7051:MCG 4-29-8:ZWG 128.8"
{
        Type  "E0"
        RA           12.0692
        Dec          20.3478
        Distance    3.48e+08  # method: V
        Radius     6.073e+04
        AbsMag        -21.04
        Axis    [  0.5805  -0.7489  -0.3196]
        Angle    122.3799
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4066"
}

Galaxy "NGC 4067:UGC 7048:MCG 2-31-19:ZWG 69.36"
{
        Type  "Sb"
        RA           12.0697
        Dec          10.8544
        Distance   1.251e+08  # method: V
        Radius     2.366e+04
        AbsMag        -19.52
        Axis    [  0.8867  -0.3748  -0.2708]
        Angle     81.9216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4067"
}

Galaxy "NGC 4068:IC 757:UGC 7047:MCG 9-20-79"
{
        Type  "Irr"
        RA           12.0672
        Dec          52.5906
        Distance   1.785e+07  # method: V
        Radius          6490
        AbsMag        -15.59
        Axis    [  0.8135  -0.4966   0.3027]
        Angle     80.7098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4068"
}

Galaxy "NGC 4069"
{
        Type  "S0"
        RA           12.0683
        Dec          20.3244
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.9058  -0.4001  -0.1397]
        Angle     77.4353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4069"
}

Galaxy "NGC 4070:NGC 4059:UGC 7052:MCG 4-29-9"
{
        Type  "E0"
        RA           12.0697
        Dec          20.4097
        Distance   3.411e+08  # method: V
        Radius     4.961e+04
        AbsMag         -20.9
        Axis    [  0.5802  -0.7493  -0.3192]
        Angle    122.3486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4070"
}

Galaxy "NGC 4072:ZWG 98.45:ZWG 128.10"
{
        Type  "S0"
        RA           12.0703
        Dec          20.2103
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.9660  -0.2478   0.0739]
        Angle     82.7870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4072"
}

Galaxy "NGC 4073:UGC 7060:MCG 0-31-29:ZWG 13.59"
{
        Type  "E0"
        RA           12.0742
        Dec           1.8964
        Distance   2.802e+08  # method: T-F
        Radius     1.304e+05
        AbsMag        -22.27
        Axis    [  0.0712  -0.0787  -0.9944]
        Angle     88.1615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4073"
}

Galaxy "NGC 4074:MCG 4-29-11:ZWG 128.13:ARAK 347"
{
        Type  "S0"
        RA           12.0747
        Dec          20.3169
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.2933   0.3814  -0.8766]
        Angle     14.8230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4074"
}

Galaxy "NGC 4075:MCG 0-31-32:ZWG 13.64:"
{
        Type  "Sa"
        RA           12.0769
        Dec           2.0728
        Distance   3.116e+08  # method: V
        Radius     5.439e+04
        AbsMag         -20.3
        Axis    [ -0.5590   0.1267  -0.8194]
        Angle     27.2802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4075"
}

Galaxy "NGC 4076:UGC 7061:MCG 3-31-34:ZWG 98.46"
{
        Type  "Sb"
        RA           12.0756
        Dec          20.2044
        Distance   2.959e+08  # method: V
        Radius     3.873e+04
        AbsMag        -20.49
        Axis    [  0.6379  -0.3536  -0.6842]
        Angle     53.0533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4076"
}

Galaxy "NGC 4077:NGC 4140:UGC 7063:MCG 0-31-31"
{
        Type  "S0"
        RA           12.0772
        Dec           1.7883
        Distance   3.336e+08  # method: V
        Radius     5.822e+04
        AbsMag        -20.75
        Axis    [  0.8749  -0.3799  -0.3004]
        Angle    105.1265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4077"
}

Galaxy "NGC 4079:UGC 7067:MCG 0-31-34:ZWG 13.67"
{
        Type  "Sc"
        RA           12.0803
        Dec          -2.3831
        Distance   2.917e+08  # method: V
        Radius     9.758e+04
        AbsMag        -21.16
        Axis    [ -0.2773   0.0443  -0.9598]
        Angle     42.9234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4079"
}

Galaxy "NGC 4080:UGC 7068:MCG 5-29-6:ZWG 158.12"
{
        Type  "Irr"
        RA           12.0808
        Dec          26.9922
        Distance   4.498e+07  # method: V
        Radius          7851
        AbsMag         -16.6
        Axis    [ -0.4025   0.8351   0.3751]
        Angle     15.0841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4080"
}

Galaxy "NGC 4081:UGC 7062:MCG 11-15-15:ZWG 315.10"
{
        Type  "Sa"
        RA           12.0758
        Dec          64.4372
        Distance   6.596e+07  # method: V
        Radius     1.439e+04
        AbsMag        -17.83
        Axis    [ -0.2335   0.6884   0.6868]
        Angle     54.0790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4081"
}

Galaxy "NGC 4082:MCG 2-31-26:ZWG 69.46"
{
        Type  "S0"
        RA           12.0864
        Dec          10.6708
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.9904  -0.1357  -0.0265]
        Angle     44.3846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4082"
}

Galaxy "NGC 4083:MCG 2-31-24:ZWG 69.44:NPM 1"
{
        Type  "S0"
        RA           12.0872
        Dec          10.6136
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.9549  -0.2699  -0.1237]
        Angle     81.0539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4083"
}

Galaxy "NGC 4084:MCG 4-29-14:ZWG 128.17"
{
        Type  "E0"
        RA           12.0875
        Dec          21.2150
        Distance   3.166e+08  # method: V
        Radius     2.763e+04
        AbsMag        -19.43
        Axis    [  0.5759  -0.7544  -0.3151]
        Angle    122.0334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4084"
}

Galaxy "NGC 4085:UGC 7075:MCG 9-20-86:ZWG 269.32"
{
        Type  "SBc"
        RA           12.0894
        Dec          50.3533
        Distance    4.29e+07  # method: V
        Radius     1.747e+04
        AbsMag        -17.89
        Axis    [  0.6212   0.0214   0.7833]
        Angle     53.9537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4085"
}

Galaxy "NGC 4086:UGC 7076:MCG 4-29-16:ZWG 128.18"
{
        Type  "S0"
        RA           12.0914
        Dec          20.2472
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.6346  -0.3754  -0.6755]
        Angle     55.2993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4086"
}

Galaxy "NGC 4087:ESO 505-10:MCG 4-29-5"
{
        Type  "S0"
        RA           12.0931
        Dec         -26.5222
        Distance   1.643e+08  # method: V
        Radius     5.017e+04
        AbsMag        -20.41
        Axis    [  0.6918  -0.2640  -0.6721]
        Angle    105.1483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4087"
}

Galaxy "NGC 4088:UGC 7081:MCG 9-20-89:ZWG 269.33"
{
        Type  "SBc"
        RA           12.0928
        Dec          50.5406
        Distance   6.383e+07  # method: T-F
        Radius     5.199e+04
        AbsMag        -20.36
        Axis    [  0.8205  -0.2744   0.5015]
        Angle     76.3528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4088"
}

Galaxy "NGC 4089:MCG 4-29-17:ZWG 128.20"
{
        Type  "E0"
        RA           12.0936
        Dec          20.5564
        Distance   3.297e+08  # method: V
        Radius     3.836e+04
        AbsMag        -20.32
        Axis    [  0.5774  -0.7516  -0.3191]
        Angle    122.4650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4089"
}

Galaxy "NGC 4090:UGC 7077:MCG 4-29-15:ZWG 128.19"
{
        Type  "Sb"
        RA           12.0911
        Dec          20.3092
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.9656  -0.2523   0.0626]
        Angle     74.8198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4090"
}

Galaxy "NGC 4091:UGC 7083:MCG 4-29-19:ZWG 128.22"
{
        Type  "Sc"
        RA           12.0944
        Dec          20.5564
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.9709  -0.1931   0.1416]
        Angle     70.4904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4091"
}

Galaxy "NGC 4092:UGC 7087:MCG 4-29-20:ZWG 128.23"
{
        Type  "Sb"
        RA           12.0972
        Dec          20.4775
        Distance   3.188e+08  # method: V
        Radius     4.637e+04
        AbsMag        -20.65
        Axis    [  0.5994  -0.7394  -0.3065]
        Angle    121.6017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4092"
}

Galaxy "NGC 4093:MCG 4-29-21:ZWG 128.24:NPM 1"
{
        Type  "E0"
        RA           12.0975
        Dec          20.5222
        Distance   4.169e+08  # distance uncertain!
        Radius     4.245e+04
        AbsMag        -20.13
        Axis    [  0.5021  -0.5921  -0.6303]
        Angle     91.7124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4093"
}

Galaxy "NGC 4094:MCG 2-31-16:UGCA 269:IRAS 12033-1414"
{
        Type  "SBc"
        RA           12.0981
        Dec         -14.5261
        Distance   6.985e+07  # method: T-F
        Radius     4.166e+04
        AbsMag        -18.95
        Axis    [  0.8593  -0.1305  -0.4946]
        Angle     59.1620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4094"
}

Galaxy "NGC 4095:MCG 4-29-22:ZWG 128.25"
{
        Type  "E0"
        RA           12.0983
        Dec          20.5736
        Distance   3.365e+08  # method: V
        Radius     6.362e+04
        AbsMag        -20.47
        Axis    [ -0.2341   0.4772  -0.8470]
        Angle     82.2408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4095"
}

Galaxy "NGC 4096:UGC 7090:MCG 8-22-67:ZWG 243.43"
{
        Type  "SBc"
        RA           12.1000
        Dec          47.4758
        Distance   5.595e+07  # method: T-F
        Radius     5.289e+04
        AbsMag        -19.67
        Axis    [  0.8616  -0.2863   0.4191]
        Angle     99.1605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4096"
}

Galaxy "NGC 4097:UGC 7092:MCG 6-27-4:ZWG 187.4"
{
        Type  "S0"
        RA           12.1006
        Dec          36.8639
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.9301   0.2273   0.2884]
        Angle     18.1172
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4097"
}

Galaxy "NGC 4098-1:NGC 4099-1:UGC 7091:MCG 4-29-23"
{
        Type  "S0"
        RA           12.1008
        Dec          20.6078
        Distance    3.45e+08  # method: V
        Radius     6.021e+04
        AbsMag        -20.62
        Axis    [ -0.6543   0.5581  -0.5104]
        Angle     51.4870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4098-1"
}

Galaxy "NGC 4098-2:NGC 4099-2:UGC 7091:MCG 4-29-24"
{
        Type  "S0"
        RA           12.1008
        Dec          20.6053
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.9246  -0.3751  -0.0671]
        Angle     82.8301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4098-2"
}

Galaxy "NGC 4100:UGC 7095:MCG 8-22-68:ZWG 243.44"
{
        Type  "Sc"
        RA           12.1022
        Dec          49.5828
        Distance   8.657e+07  # method: T-F
        Radius     6.799e+04
        AbsMag        -20.22
        Axis    [ -0.6767   0.6439   0.3571]
        Angle     66.4725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4100"
}

Galaxy "NGC 4101:UGC 7093:MCG 4-29-25:ZWG 128.27"
{
        Type  "Sa"
        RA           12.1028
        Dec          25.5569
        Distance   2.909e+08  # method: V
        Radius     4.231e+04
        AbsMag        -20.15
        Axis    [  0.8291  -0.4401  -0.3447]
        Angle     56.1604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4101"
}

Galaxy "NGC 4102:UGC 7096:MCG 9-20-94:ZWG 269.36"
{
        Type  "SBb"
        RA           12.1064
        Dec          52.7108
        Distance   9.894e+07  # method: T-F
        Radius     4.461e+04
        AbsMag        -20.31
        Axis    [  0.8227  -0.4120   0.3917]
        Angle     75.9659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4102"
}

Galaxy "NGC 4104:UGC 7099:MCG 5-29-16:ZWG 158.24"
{
        Type  "S0"
        RA           12.1106
        Dec          28.1736
        Distance    3.85e+08  # method: V
        Radius     1.456e+05
        AbsMag        -22.26
        Axis    [  0.9129  -0.4082   0.0082]
        Angle     76.7930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4104"
}

Galaxy "NGC 4105:ESO 440-54:MCG 5-29-13:AM 1204-292"
{
        Type  "E3"
        RA           12.1111
        Dec         -29.7600
        Distance   8.658e+07  # method: S
        Radius     3.526e+04
        AbsMag        -20.62
        Axis    [ -0.4114   0.1089  -0.9049]
        Angle    117.5621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4105"
}

Galaxy "NGC 4106:ESO 440-56:MCG 5-29-14:AM 1204-292"
{
        Type  "SBa"
        RA           12.1125
        Dec         -29.7683
        Distance   1.124e+08  # method: V
        Radius     2.615e+04
        AbsMag        -20.39
        Axis    [  0.3676  -0.2334  -0.9002]
        Angle     87.4321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4106"
}

Galaxy "NGC 4107:NGC 4078:UGC 7066:MCG 2-31-23"
{
        Type  "S0"
        RA           12.0797
        Dec          10.5958
        Distance   1.299e+08  # method: V
        Radius     2.456e+04
        AbsMag         -18.8
        Axis    [  0.9780  -0.2075  -0.0237]
        Angle     95.2995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4107"
}

Galaxy "NGC 4108:UGC 7101:MCG 11-15-23:ZWG 315.15"
{
        Type  "Sc"
        RA           12.1122
        Dec          67.1633
        Distance    1.18e+08  # method: V
        Radius     2.917e+04
        AbsMag        -19.79
        Axis    [  0.6340   0.5717   0.5208]
        Angle     24.9069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4108"
}

Galaxy "NGC 4108A:UGC 7088:MCG 11-15-21:ZWG 315.13"
{
        Type  "SBc"
        RA           12.0969
        Dec          67.2525
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.7534  -0.4392   0.4894]
        Angle    113.3737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4108A"
}

Galaxy "NGC 4108B:UGC 7106:MCG 11-15-25:ZWG 315.16"
{
        Type  "SBc"
        RA           12.1197
        Dec          67.2356
        Distance   1.212e+08  # method: V
        Radius     2.292e+04
        AbsMag        -18.55
        Axis    [  0.1833   0.9593   0.2147]
        Angle     32.0426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4108B"
}

Galaxy "NGC 4109:MCG 7-25-24:ZWG 215.27:NPM 1"
{
        Type  "Sa"
        RA           12.1142
        Dec          42.9961
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.4026   0.8385  -0.3673]
        Angle     52.9717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4109"
}

Galaxy "NGC 4110:UGC 7102:MCG 3-31-40:ZWG 98.58"
{
        Type  "SBb"
        RA           12.1175
        Dec          18.5319
        Distance    3.41e+08  # method: V
        Radius     6.447e+04
        AbsMag         -20.5
        Axis    [ -0.6088   0.5733  -0.5484]
        Angle     19.3838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4110"
}

Galaxy "NGC 4111:UGC 7103:MCG 7-25-26:ZWG 215.28"
{
        Type  "Sa"
        RA           12.1172
        Dec          43.0667
        Distance   4.891e+07  # method: S
        Radius     3.273e+04
        AbsMag        -19.18
        Axis    [ -0.6183   0.5224   0.5871]
        Angle     54.3271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4111"
}

Galaxy "NGC 4112:ESO 321-6:MCG 7-25-3:AM 1204-395"
{
        Type  "SBb"
        RA           12.1192
        Dec         -40.2078
        Distance   1.332e+08  # method: V
        Radius       3.1e+04
        AbsMag        -20.26
        Axis    [  0.8721  -0.0393  -0.4877]
        Angle    125.4576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4112"
}

Galaxy "NGC 4113:NGC 4122:MCG 6-27-11:ZWG 187.9"
{
        Type  "SBb"
        RA           12.1189
        Dec          32.9961
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.9505  -0.2869   0.1195]
        Angle     44.3240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4113"
}

Galaxy "NGC 4114:MCG 2-31-18:NPM 1"
{
        Type  "SBa"
        RA           12.1200
        Dec         -14.1847
        Distance   1.341e+08  # distance uncertain!
        Radius     3.511e+04
        AbsMag        -19.07
        Axis    [ -0.6079  -0.1352  -0.7824]
        Angle     39.9778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4114"
}

Galaxy "NGC 4116:UGC 7111:MCG 1-31-22:ZWG 41.41"
{
        Type  "SBc"
        RA           12.1269
        Dec           2.6911
        Distance   7.964e+07  # method: T-F
        Radius     4.402e+04
        AbsMag        -19.64
        Axis    [ -0.7961   0.2442  -0.5537]
        Angle     50.3616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4116"
}

Galaxy "NGC 4117:UGC 7112:MCG 7-25-27:ZWG 215.29"
{
        Type  "S0"
        RA           12.1294
        Dec          43.1264
        Distance   4.988e+07  # method: V
        Radius     1.306e+04
        AbsMag        -16.92
        Axis    [  0.8701  -0.4223   0.2541]
        Angle     94.7543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4117"
}

Galaxy "NGC 4118:MCG 7-25-28:ZWG 215.30"
{
        Type  "Sa"
        RA           12.1311
        Dec          43.1114
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.4233   0.8725   0.2439]
        Angle     30.6115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4118"
}

Galaxy "NGC 4119:NGC 4124:IC 3011:UGC 7117"
{
        Type  "Sa"
        RA           12.1358
        Dec          10.3789
        Distance   8.915e+07  # method: V
        Radius     5.576e+04
        AbsMag        -19.98
        Axis    [ -0.0421   0.7785  -0.6263]
        Angle      3.0033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4119"
}

Galaxy "NGC 4120:UGC 7121:MCG 12-12-1:ZWG 335.4"
{
        Type  "Sc"
        RA           12.1419
        Dec          69.5444
        Distance    1.06e+08  # method: V
        Radius      2.62e+04
        AbsMag        -18.36
        Axis    [ -0.5153   0.6677   0.5372]
        Angle     81.9960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4120"
}

Galaxy "NGC 4121:MCG 11-15-26:ZWG 315.18:NPM 1"
{
        Type  "E0"
        RA           12.1322
        Dec          65.1144
        Distance   8.595e+07  # method: T-F
        Radius          5000
        AbsMag         -17.6
        Axis    [  0.3677  -0.9299  -0.0117]
        Angle    101.3240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4121"
}

Galaxy "NGC 4123:UGC 7116:MCG 1-31-23:MK 1466"
{
        Type  "SBb"
        RA           12.1364
        Dec           2.8783
        Distance   7.588e+07  # method: V
        Radius     4.746e+04
        AbsMag        -20.03
        Axis    [ -0.4471   0.1789  -0.8764]
        Angle     45.5756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4123"
}

Galaxy "NGC 4125:UGC 7118:MCG 11-15-27:ZWG 315.19"
{
        Type  "E6"
        RA           12.1347
        Dec          65.1744
        Distance   7.788e+07  # method: S
        Radius      6.57e+04
        AbsMag        -21.29
        Axis    [  0.6681  -0.4303  -0.6070]
        Angle     36.6865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4125"
}

Galaxy "NGC 4126:UGC 7123:MCG 3-31-47:ZWG 98.65"
{
        Type  "S0"
        RA           12.1436
        Dec          16.1431
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.8800  -0.4608  -0.1148]
        Angle    114.2209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4126"
}

Galaxy "NGC 4127:UGC 7122:MCG 13-9-12:ZWG 352.19"
{
        Type  "Sc"
        RA           12.1403
        Dec          76.8044
        Distance    1.05e+08  # method: T-F
        Radius     3.817e+04
        AbsMag        -19.14
        Axis    [ -0.1763   0.7388   0.6505]
        Angle     63.1098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4127"
}

Galaxy "NGC 4128:UGC 7120:MCG 12-12-2A:ZWG 335.3"
{
        Type  "S0"
        RA           12.1422
        Dec          68.7681
        Distance   1.095e+08  # method: V
        Radius     3.824e+04
        AbsMag        -19.73
        Axis    [  0.5838  -0.1051   0.8051]
        Angle     68.8305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4128"
}

Galaxy "NGC 4128A:NPM 1"
{
        Type  "S0"
        RA           12.1372
        Dec          68.7858
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.7377  -0.1371   0.6610]
        Angle     39.3052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4128A"
}

Galaxy "NGC 4129:NGC 4130:MCG 1-31-6:IRAS 12063-0845"
{
        Type  "SBb"
        RA           12.1481
        Dec          -9.0367
        Distance   6.913e+07  # method: V
        Radius     2.313e+04
        AbsMag        -18.33
        Axis    [  0.7793  -0.2129  -0.5893]
        Angle     25.6245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4129"
}

Galaxy "NGC 4131:UGC 7126:MCG 5-29-19:ZWG 158.29"
{
        Type  "SBa"
        RA           12.1464
        Dec          29.3047
        Distance   1.865e+08  # method: V
        Radius     3.797e+04
        AbsMag        -19.69
        Axis    [  0.9623  -0.2252   0.1527]
        Angle     40.1095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4131"
}

Galaxy "NGC 4132:MCG 5-29-20:ZWG 158.30:KUG 1206+295"
{
        Type  "Sa"
        RA           12.1503
        Dec          29.2503
        Distance   1.973e+08  # method: V
        Radius     3.157e+04
        AbsMag        -19.01
        Axis    [  0.9438  -0.2228   0.2440]
        Angle     94.3565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4132"
}

Galaxy "NGC 4133:UGC 7127:MCG 13-9-13:ZWG 352.20"
{
        Type  "SBb"
        RA           12.1469
        Dec          74.9044
        Distance   6.102e+07  # method: V
        Radius     1.598e+04
        AbsMag        -18.26
        Axis    [  0.1045   0.7939   0.5990]
        Angle     42.7106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4133"
}

Galaxy "NGC 4134:UGC 7130:MCG 5-29-23:ZWG 158.31"
{
        Type  "Sb"
        RA           12.1525
        Dec          29.1769
        Distance   1.901e+08  # method: T-F
        Radius     6.082e+04
        AbsMag        -20.13
        Axis    [ -0.7964   0.5856   0.1514]
        Angle     39.7068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4134"
}

Galaxy "NGC 4135:MCG 7-25-32:ZWG 215.34"
{
        Type  "SBc"
        RA           12.1522
        Dec          44.0036
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.9008  -0.0585   0.4302]
        Angle     28.8005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4135"
}

Galaxy "NGC 4136:UGC 7134:MCG 5-29-25:ZWG 158.34"
{
        Type  "SBc"
        RA           12.1547
        Dec          29.9278
        Distance   4.036e+07  # method: V
        Radius      2.29e+04
        AbsMag        -18.66
        Axis    [  0.5414  -0.2249  -0.8101]
        Angle     40.7348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4136"
}

Galaxy "NGC 4137:UGC 7135:MCG 7-25-33:ZWG 215.36"
{
        Type  "SBc"
        RA           12.1547
        Dec          44.0900
        Distance   4.315e+08  # method: V
        Radius     6.903e+04
        AbsMag        -20.81
        Axis    [  0.8826  -0.4085   0.2327]
        Angle     57.7743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4137"
}

Galaxy "NGC 4138:UGC 7139:MCG 7-25-35:ZWG 215.37"
{
        Type  "Sa"
        RA           12.1581
        Dec          43.6856
        Distance   4.502e+07  # method: S
        Radius     1.703e+04
        AbsMag         -18.5
        Axis    [ -0.5353   0.8447  -0.0012]
        Angle     43.1000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4138"
}

Galaxy "NGC 4139:IC 2989:MCG 0-31-30:ZWG 13.61"
{
        Type  "S0"
        RA           12.0761
        Dec           1.8014
        Distance   2.702e+08  # method: V
        Radius      3.93e+04
        AbsMag        -19.89
        Axis    [ -0.8549   0.1979  -0.4796]
        Angle     45.3445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4139"
}

Galaxy "NGC 4141:UGC 7147:MCG 10-17-152:ZWG 292.74"
{
        Type  "SBc"
        RA           12.1631
        Dec          58.8494
        Distance   9.645e+07  # method: V
        Radius     1.824e+04
        AbsMag        -17.95
        Axis    [  0.8143  -0.2395   0.5287]
        Angle     40.9760
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4141"
}

Galaxy "NGC 4142:UGC 7140:MCG 9-20-102:ZWG 269.37"
{
        Type  "SBc"
        RA           12.1583
        Dec          53.1039
        Distance   1.074e+08  # method: T-F
        Radius     3.435e+04
        AbsMag        -18.59
        Axis    [ -0.6080   0.7818   0.1383]
        Angle     70.4046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4142"
}

Galaxy "NGC 4143:UGC 7142:MCG 7-25-36:ZWG 215.39"
{
        Type  "S0"
        RA           12.1600
        Dec          42.5344
        Distance   5.193e+07  # method: S
        Radius     1.737e+04
        AbsMag        -19.21
        Axis    [ -0.5268   0.8456   0.0868]
        Angle     37.3058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4143"
}

Galaxy "NGC 4144:UGC 7151:MCG 8-22-77:ZWG 243.48"
{
        Type  "SBc"
        RA           12.1664
        Dec          46.4572
        Distance   2.768e+07  # method: T-F
        Radius     2.456e+04
        AbsMag        -17.64
        Axis    [  0.2455   0.2851   0.9265]
        Angle     42.5765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4144"
}

Galaxy "NGC 4145:UGC 7154:MCG 7-25-40:ZWG 215.42"
{
        Type  "SBc"
        RA           12.1669
        Dec          39.8828
        Distance   7.588e+07  # method: T-F
        Radius     6.511e+04
        AbsMag        -20.33
        Axis    [  0.9704   0.2394  -0.0329]
        Angle     16.2387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4145"
}

Galaxy "NGC 4145A1:MCG 7-25-46:ZWG 215.48:KUG 1208+400"
{
        Type  "Irr"
        RA           12.1817
        Dec          39.7572
        Distance   6.351e+07  # method: V
        Radius     1.755e+04
        AbsMag        -16.35
        Axis    [  0.7421  -0.0394   0.6692]
        Angle     50.5242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4145A1"
}

Galaxy "NGC 4145A2:A 1208+40:VV 814"
{
        Type  "S0"
        RA           12.1814
        Dec          39.7486
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.5201  -0.8340  -0.1845]
        Angle    112.3751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4145A2"
}

Galaxy "NGC 4146:UGC 7163:MCG 5-29-28:ZWG 158.36"
{
        Type  "SBb"
        RA           12.1717
        Dec          26.4311
        Distance    3.09e+08  # method: V
        Radius     6.292e+04
        AbsMag        -21.18
        Axis    [  0.7579  -0.4547  -0.4678]
        Angle     53.3652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4146"
}

Galaxy "NGC 4148:UGC 7158:MCG 6-27-18:ZWG 187.16"
{
        Type  "Sa"
        RA           12.1686
        Dec          35.8783
        Distance   2.372e+08  # method: V
        Radius     5.175e+04
        AbsMag        -20.01
        Axis    [ -0.6737   0.7234  -0.1506]
        Angle     55.8388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4148"
}

Galaxy "NGC 4149:NGC 4154:UGC 7167:ZWG 292.76"
{
        Type  "S0"
        RA           12.1756
        Dec          58.3039
        Distance   1.453e+08  # method: V
        Radius     2.748e+04
        AbsMag        -19.14
        Axis    [  0.4205   0.1181   0.8996]
        Angle     60.7487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4149"
}

Galaxy "NGC 4150:UGC 7165:MCG 5-29-29:ZWG 158.37"
{
        Type  "S0"
        RA           12.1758
        Dec          30.4019
        Distance   4.482e+07  # method: S
        Radius     1.499e+04
        AbsMag        -18.29
        Axis    [ -0.6152   0.7103  -0.3419]
        Angle     38.8332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4150"
}

Galaxy "NGC 4151:UGC 7166:MCG 7-25-44:ZWG 215.45"
{
        Type  "SBb"
        RA           12.1756
        Dec          39.4067
        Distance   5.608e+07  # method: V
        Radius     5.139e+04
        AbsMag        -20.07
        Axis    [ -0.5126   0.8360  -0.1958]
        Angle     38.6387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4151"
}

Galaxy "NGC 4152:UGC 7169:MCG 3-31-52:MK 759"
{
        Type  "SBc"
        RA           12.1769
        Dec          16.0331
        Distance   1.127e+08  # method: V
        Radius      3.77e+04
        AbsMag        -20.09
        Axis    [  0.0213   0.1187  -0.9927]
        Angle     36.4289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4152"
}

Galaxy "NGC 4155:UGC 7172:MCG 3-31-58:ZWG 98.82"
{
        Type  "E0"
        RA           12.1792
        Dec          19.0411
        Distance   2.631e+08  # distance uncertain!
        Radius     4.209e+04
        AbsMag        -20.13
        Axis    [  0.3172  -0.3222  -0.8919]
        Angle     76.2412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4155"
}

Galaxy "NGC 4156:UGC 7173:MCG 7-25-45:ZWG 215.47"
{
        Type  "SBb"
        RA           12.1803
        Dec          39.4731
        Distance    3.17e+08  # method: V
        Radius     5.994e+04
        AbsMag        -21.04
        Axis    [  0.7368  -0.6265  -0.2541]
        Angle     65.1837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4156"
}

Galaxy "NGC 4157:UGC 7183:MCG 9-20-106:ZWG 269.38"
{
        Type  "SBb"
        RA           12.1844
        Dec          50.4847
        Distance   6.831e+07  # method: T-F
        Radius     6.657e+04
        AbsMag         -19.5
        Axis    [  0.6582  -0.0422   0.7517]
        Angle     69.0820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4157"
}

Galaxy "NGC 4158:UGC 7182:MCG 3-31-60:ZWG 98.84"
{
        Type  "Sb"
        RA           12.1861
        Dec          20.1758
        Distance   1.255e+08  # method: V
        Radius     3.651e+04
        AbsMag        -20.03
        Axis    [  0.5872  -0.3599  -0.7251]
        Angle     52.3338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4158"
}

Galaxy "NGC 4159:UGC 7174:MCG 13-9-15:ZWG 352.22"
{
        Type  "Sc"
        RA           12.1814
        Dec          76.1264
        Distance   8.195e+07  # method: V
        Radius     1.549e+04
        AbsMag         -17.7
        Axis    [  0.6497  -0.3503   0.6747]
        Angle     94.4536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4159"
}

Galaxy "NGC 4161:UGC 7191:MCG 10-18-2:ZWG 292.78"
{
        Type  "Sc"
        RA           12.1922
        Dec          57.7375
        Distance   2.309e+08  # method: V
        Radius     3.693e+04
        AbsMag        -20.45
        Axis    [  0.7922  -0.4304   0.4325]
        Angle     64.2412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4161"
}

Galaxy "NGC 4162:UGC 7193:MCG 4-29-46:ZWG 128.51"
{
        Type  "Sc"
        RA           12.1978
        Dec          24.1239
        Distance   1.301e+08  # method: V
        Radius     4.351e+04
        AbsMag         -20.2
        Axis    [ -0.8140   0.5471  -0.1953]
        Angle     62.9125
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4162"
}

Galaxy "NGC 4163:NGC 4167:UGC 7199:MCG 6-27-26"
{
        Type  "Irr"
        RA           12.2025
        Dec          36.1686
        Distance   1.916e+07  # method: V
        Radius          5295
        AbsMag        -14.84
        Axis    [  0.7629  -0.6463  -0.0156]
        Angle    110.4958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4163"
}

Galaxy "NGC 4164:ZWG 69.76:VCC 43"
{
        Type  "E3"
        RA           12.2014
        Dec          13.2058
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.0495  -0.0056  -0.9988]
        Angle     76.7040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4164"
}

Galaxy "NGC 4165:IC 3035:UGC 7201:MCG 2-31-45"
{
        Type  "SBa"
        RA           12.2031
        Dec          13.2461
        Distance   9.912e+07  # method: V
        Radius      1.73e+04
        AbsMag        -18.11
        Axis    [ -0.7851   0.4232  -0.4521]
        Angle     52.5952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4165"
}

Galaxy "NGC 4166:UGC 7198:MCG 3-31-68:ZWG 98.96"
{
        Type  "S0"
        RA           12.2025
        Dec          17.7572
        Distance   3.295e+08  # method: V
        Radius     5.751e+04
        AbsMag        -20.82
        Axis    [  0.8133  -0.5291  -0.2419]
        Angle     97.0219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4166"
}

Galaxy "NGC 4168:UGC 7203:MCG 2-31-46:ZWG 69.81"
{
        Type  "E2"
        RA           12.2047
        Dec          13.2044
        Distance   1.008e+08  # method: S
        Radius     4.105e+04
        AbsMag        -20.25
        Axis    [ -0.0293   0.0927  -0.9953]
        Angle     77.0761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4168"
}

Galaxy "NGC 4169:UGC 7202:MCG 5-29-32:ZWG 158.41"
{
        Type  "S0"
        RA           12.2050
        Dec          29.1794
        Distance   1.854e+08  # method: V
        Radius     4.854e+04
        AbsMag        -20.57
        Axis    [ -0.7880   0.6157  -0.0002]
        Angle     41.6901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4169"
}

Galaxy "NGC 4172:UGC 7205:MCG 9-20-109:ZWG 269.39"
{
        Type  "S0"
        RA           12.2039
        Dec          56.1764
        Distance   4.275e+08  # method: V
        Radius     8.083e+04
        AbsMag        -21.39
        Axis    [  0.6769  -0.7197   0.1540]
        Angle    101.1393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4172"
}

Galaxy "NGC 4173:UGC 7204:MCG 5-29-33:ZWG 158.43"
{
        Type  "Sc"
        RA           12.2058
        Dec          29.2072
        Distance   6.301e+07  # method: V
        Radius     4.582e+04
        AbsMag        -18.03
        Axis    [ -0.5479   0.3903   0.7399]
        Angle     35.2628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4173"
}

Galaxy "NGC 4174:UGC 7206:MCG 5-29-34:ZWG 158.44"
{
        Type  "Sa"
        RA           12.2072
        Dec          29.1492
        Distance   1.933e+08  # method: V
        Radius     2.249e+04
        AbsMag        -19.46
        Axis    [  0.9378  -0.2485   0.2425]
        Angle     64.5732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4174"
}

Galaxy "NGC 4175:UGC 7211:MCG 5-29-36:ZWG 158.45"
{
        Type  "Sc"
        RA           12.2086
        Dec          29.1686
        Distance   1.914e+08  # method: V
        Radius      5.01e+04
        AbsMag        -19.64
        Axis    [ -0.4845   0.4211   0.7667]
        Angle     31.1068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4175"
}

Galaxy "NGC 4176"
{
        Type  "Sb"
        RA           12.2100
        Dec          -9.1603
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.7212  -0.3058  -0.6216]
        Angle     76.4842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4176"
}

Galaxy "NGC 4177:MCG 2-31-21:IRAS 12101-1344"
{
        Type  "Sc"
        RA           12.2114
        Dec         -14.0139
        Distance   2.006e+08  # method: V
        Radius     4.961e+04
        AbsMag        -20.74
        Axis    [  0.5914  -0.2754  -0.7579]
        Angle     69.8018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4177"
}

Galaxy "NGC 4178:IC 3042:UGC 7215:MCG 2-31-50"
{
        Type  "SBc"
        RA           12.2128
        Dec          10.8642
        Distance   7.076e+07  # method: T-F
        Radius     5.146e+04
        AbsMag        -19.68
        Axis    [  0.9800  -0.1988  -0.0078]
        Angle     83.6082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4178"
}

Galaxy "NGC 4179:UGC 7214:MCG 0-31-38:ZWG 13.104"
{
        Type  "S0"
        RA           12.2144
        Dec           1.2997
        Distance   7.262e+07  # method: V
        Radius     4.436e+04
        AbsMag        -19.84
        Axis    [ -0.9674   0.0354  -0.2507]
        Angle     30.5619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4179"
}

Galaxy "NGC 4180:NGC 4182:UGC 7219:MCG 1-31-25"
{
        Type  "Sb"
        RA           12.2175
        Dec           7.0394
        Distance   1.098e+08  # method: V
        Radius     2.395e+04
        AbsMag        -19.13
        Axis    [  0.9827  -0.1796  -0.0442]
        Angle     91.7674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4180"
}

Galaxy "NGC 4181:MCG 9-20-111:ZWG 269.41:NPM 1"
{
        Type  "S0"
        RA           12.2133
        Dec          52.9039
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.7485  -0.6348   0.1919]
        Angle     98.2150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4181"
}

Galaxy "NGC 4183:UGC 7222:MCG 7-25-51:ZWG 215.53"
{
        Type  "Sc"
        RA           12.2211
        Dec          43.6981
        Distance   6.532e+07  # method: T-F
        Radius     5.036e+04
        AbsMag        -18.71
        Axis    [ -0.7323   0.4864   0.4765]
        Angle     66.4238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4183"
}

Galaxy "NGC 4185:UGC 7225:MCG 5-29-38:ZWG 158.47"
{
        Type  "Sc"
        RA           12.2228
        Dec          28.5103
        Distance   1.899e+08  # method: V
        Radius     7.181e+04
        AbsMag        -20.62
        Axis    [ -0.6556   0.6598  -0.3671]
        Angle     57.5256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4185"
}

Galaxy "NGC 4186:NGC 4192B:UGC 7240:MCG 3-31-81"
{
        Type  "Sb"
        RA           12.2350
        Dec          14.7258
        Distance   3.718e+08  # method: V
        Radius     5.408e+04
        AbsMag        -20.68
        Axis    [  0.7592  -0.4283  -0.4901]
        Angle     62.2860
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4186"
}

Galaxy "NGC 4187:NGC 4187A:UGC 7229:MCG 9-20-117"
{
        Type  "E0"
        RA           12.2247
        Dec          50.7417
        Distance   4.226e+08  # method: V
        Radius     7.991e+04
        AbsMag        -21.36
        Axis    [  0.0235   0.6781  -0.7346]
        Angle     60.5781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4187"
}

Galaxy "NGC 4187B"
{
        Type  "E0"
        RA           12.2244
        Dec          50.7569
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.4403  -0.8893  -0.1234]
        Angle    108.2628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4187B"
}

Galaxy "NGC 4187C:MCG 9-20-118"
{
        Type  "E0"
        RA           12.2239
        Dec          50.7103
        Distance   7.245e+08  # distance uncertain!
        Radius     5.269e+04
        AbsMag        -20.13
        Axis    [ -0.0773   0.7868  -0.6123]
        Angle     73.8828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4187C"
}

Galaxy "NGC 4188:MCG 2-31-23:IRAS 12115-1218"
{
        Type  "Sb"
        RA           12.2353
        Dec         -12.5861
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [  0.3796  -0.2792  -0.8820]
        Angle     74.7012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4188"
}

Galaxy "NGC 4189:IC 3050:UGC 7235:MCG 2-31-54"
{
        Type  "SBc"
        RA           12.2297
        Dec          13.4247
        Distance   1.106e+08  # method: V
        Radius     4.021e+04
        AbsMag        -20.15
        Axis    [  0.7166  -0.2861  -0.6361]
        Angle     37.4156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4189"
}

Galaxy "NGC 4190:UGC 7232:MCG 6-27-30:ZWG 187.24"
{
        Type  "Irr"
        RA           12.2289
        Dec          36.6336
        Distance   2.206e+07  # method: V
        Radius          5455
        AbsMag        -15.75
        Axis    [  0.6923  -0.6967  -0.1881]
        Angle     89.0753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4190"
}

Galaxy "NGC 4191:UGC 7233:MCG 1-31-26:ZWG 41.49"
{
        Type  "S0"
        RA           12.2306
        Dec           7.2008
        Distance   1.347e+08  # method: V
        Radius     2.351e+04
        AbsMag        -19.38
        Axis    [  0.9063  -0.3815  -0.1820]
        Angle    111.4358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4191"
}

Galaxy "M 98:NGC 4192:UGC 7231:MCG 3-31-79"
{
        Type  "SBb"
        RA           12.2297
        Dec          14.8994
        Distance   6.351e+07  # method: T-F
        Radius     9.053e+04
        AbsMag        -20.54
        Axis    [ -0.9564   0.2693   0.1130]
        Angle     41.8387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 98"
}

Galaxy "NGC 4192A:UGC 7223:MCG 3-31-76:VCC 81"
{
        Type  "Sc"
        RA           12.2239
        Dec          14.7722
        Distance   1.088e+08  # method: V
        Radius     2.057e+04
        AbsMag        -16.92
        Axis    [  0.6302  -0.3699  -0.6826]
        Angle     53.7689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4192A"
}

Galaxy "NGC 4193:IC 3051:UGC 7234:MCG 2-31-53"
{
        Type  "SBc"
        RA           12.2314
        Dec          13.1728
        Distance    1.05e+08  # method: T-F
        Radius     3.359e+04
        AbsMag        -19.34
        Axis    [  0.8604  -0.2053  -0.4664]
        Angle     23.4314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4193"
}

Galaxy "NGC 4194:UGC 7241:MCG 9-20-119:MK 201"
{
        Type  "Irr"
        RA           12.2358
        Dec          54.5264
        Distance   1.213e+08  # method: V
        Radius     4.764e+04
        AbsMag        -19.85
        Axis    [ -0.5474   0.8223   0.1557]
        Angle     63.3913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4194"
}

Galaxy "NGC 4195:UGC 7244:MCG 10-18-10:ZWG 292.83"
{
        Type  "SBc"
        RA           12.2383
        Dec          59.6156
        Distance   2.226e+08  # distance uncertain!
        Radius     5.179e+04
        AbsMag        -19.07
        Axis    [  0.4248   0.9030  -0.0641]
        Angle     21.6666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4195"
}

Galaxy "NGC 4196:UGC 7245:MCG 5-29-40:ZWG 158.50"
{
        Type  "S0"
        RA           12.2414
        Dec          28.4236
        Distance   1.934e+08  # method: V
        Radius     4.501e+04
        AbsMag        -20.16
        Axis    [  0.8606  -0.4581  -0.2226]
        Angle     54.2930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4196"
}

Galaxy "NGC 4197:UGC 7247:MCG 1-31-29:ZWG 41.52"
{
        Type  "Sc"
        RA           12.2439
        Dec           5.8061
        Distance    1.09e+08  # method: V
        Radius      5.39e+04
        AbsMag        -19.12
        Axis    [  0.9955  -0.0702   0.0643]
        Angle     77.8797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4197"
}

Galaxy "NGC 4198:IC 778:UGC 7249:MCG 9-20-123"
{
        Type  "Sa"
        RA           12.2392
        Dec          56.0117
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [ -0.1569   0.8365   0.5250]
        Angle     34.1665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4198"
}

Galaxy "NGC 4199-1:UGC 7253:MCG 10-18-11:ZWG 292.84"
{
        Type  "S0"
        RA           12.2467
        Dec          59.9064
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.4132  -0.9100  -0.0333]
        Angle    104.5998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4199-1"
}

Galaxy "NGC 4199-2:UGC 7253:MCG 10-18-11:ZWG 292.84"
{
        Type  "E0"
        RA           12.2475
        Dec          59.9083
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.3888  -0.9197  -0.0535]
        Angle    104.7395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4199-2"
}

Galaxy "NGC 4200:UGC 7251:MCG 2-31-57:ZWG 69.96"
{
        Type  "S0"
        RA           12.2456
        Dec          12.1808
        Distance   1.213e+08  # method: V
        Radius     2.646e+04
        AbsMag        -18.85
        Axis    [  0.7156  -0.1851  -0.6735]
        Angle     21.3460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4200"
}

Galaxy "NGC 4201:MCG 2-31-24:IRAS 12120-1118"
{
        Type  "S0"
        RA           12.2447
        Dec         -11.5833
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.3602  -0.2844  -0.8885]
        Angle     77.1845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4201"
}

Galaxy "NGC 4202:UGC 7337:MCG 0-31-46:ZWG 13.121"
{
        Type  "Sc"
        RA           12.3022
        Dec          -1.0639
        Distance   2.742e+08  # method: V
        Radius     4.786e+04
        AbsMag        -20.12
        Axis    [ -0.4402  -0.0205  -0.8977]
        Angle     32.8366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4202"
}

Galaxy "NGC 4203:UGC 7256:MCG 6-27-40:ZWG 187.29"
{
        Type  "S0"
        RA           12.2514
        Dec          33.1975
        Distance   4.937e+07  # method: S
        Radius     2.513e+04
        AbsMag         -19.2
        Axis    [  0.7199  -0.6816  -0.1308]
        Angle    102.8424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4203"
}

Galaxy "NGC 4204:UGC 7261:MCG 4-29-51:ZWG 128.60"
{
        Type  "Irr"
        RA           12.2539
        Dec          20.6589
        Distance   5.273e+07  # method: V
        Radius     2.761e+04
        AbsMag        -17.14
        Axis    [  0.8163  -0.5128  -0.2660]
        Angle     80.7839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4204"
}

Galaxy "NGC 4205:UGC 7258:MCG 11-15-38:ZWG 315.27"
{
        Type  "S0"
        RA           12.2486
        Dec          63.7822
        Distance   7.167e+07  # method: V
        Radius     1.772e+04
        AbsMag        -17.81
        Axis    [  0.7509  -0.3653   0.5502]
        Angle     96.2030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4205"
}

Galaxy "NGC 4206:IC 3064:UGC 7260:MCG 2-31-66"
{
        Type  "Sc"
        RA           12.2544
        Dec          13.0228
        Distance   7.615e+07  # method: T-F
        Radius     7.088e+04
        AbsMag        -19.04
        Axis    [  0.9901  -0.1069   0.0911]
        Angle    114.3961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4206"
}

Galaxy "NGC 4207:UGC 7268:MCG 2-31-69:ZWG 69.107"
{
        Type  "Sc"
        RA           12.2583
        Dec           9.5856
        Distance   4.227e+07  # method: V
        Radius          9836
        AbsMag        -16.96
        Axis    [ -0.5455   0.1903  -0.8162]
        Angle     17.8186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4207"
}

Galaxy "NGC 4208:NGC 4212:UGC 7275:MCG 2-31-70"
{
        Type  "Sc"
        RA           12.2608
        Dec          13.9019
        Distance   1.114e+07  # method: V
        Radius          5187
        AbsMag        -15.87
        Axis    [  0.8412  -0.3296  -0.4286]
        Angle     43.0396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4208"
}

Galaxy "NGC 4210:UGC 7264:MCG 11-15-39:ZWG 315.28"
{
        Type  "SBb"
        RA           12.2542
        Dec          65.9861
        Distance   1.193e+08  # method: V
        Radius     3.471e+04
        AbsMag        -19.52
        Axis    [  0.6345   0.4926   0.5957]
        Angle     24.7831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4210"
}

Galaxy "NGC 4211:NGC 4211A:UGC 7277:MCG 5-29-42"
{
        Type  "Sa"
        RA           12.2597
        Dec          28.1775
        Distance   3.122e+08  # method: V
        Radius     5.448e+04
        AbsMag         -20.5
        Axis    [  0.7308   0.1669  -0.6619]
        Angle     14.3198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4211"
}

Galaxy "NGC 4211B:UGC 7277:MCG 5-29-43:ZWG 158.53"
{
        Type  "Sa"
        RA           12.2603
        Dec          28.1694
        Distance   3.152e+08  # method: V
        Radius     1.834e+04
        AbsMag        -19.73
        Axis    [  0.5577  -0.7871  -0.2636]
        Angle    118.8983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4211B"
}

Galaxy "NGC 4213:UGC 7276:MCG 4-29-54:ZWG 128.65"
{
        Type  "E0"
        RA           12.2603
        Dec          23.9819
        Distance   3.166e+08  # method: V
        Radius     7.828e+04
        AbsMag        -21.43
        Axis    [  0.5493  -0.7786  -0.3034]
        Angle    121.9805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4213"
}

Galaxy "NGC 4214:NGC 4228:UGC 7278:MCG 6-27-42"
{
        Type  "Irr"
        RA           12.2606
        Dec          36.3275
        Distance   2.487e+07  # method: V
        Radius     2.894e+04
        AbsMag        -19.21
        Axis    [ -0.4214   0.7645  -0.4879]
        Angle     39.3486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4214"
}

Galaxy "NGC 4215:UGC 7281:MCG 1-31-31:ZWG 41.55"
{
        Type  "Sa"
        RA           12.2650
        Dec           6.4008
        Distance   1.096e+08  # method: V
        Radius     2.869e+04
        AbsMag        -20.33
        Axis    [ -0.9723   0.1933  -0.1313]
        Angle     60.8558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4215"
}

Galaxy "NGC 4216:UGC 7284:MCG 2-31-72:ZWG 69.112"
{
        Type  "SBb"
        RA           12.2650
        Dec          13.1478
        Distance   6.659e+07  # method: T-F
        Radius     7.845e+04
        AbsMag        -20.45
        Axis    [  0.9865  -0.1281   0.1016]
        Angle     95.3493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4216"
}

Galaxy "NGC 4217:UGC 7282:MCG 8-22-87:ZWG 243.53"
{
        Type  "Sb"
        RA           12.2639
        Dec          47.0900
        Distance   7.447e+07  # method: T-F
        Radius     5.633e+04
        AbsMag        -19.69
        Axis    [  0.8097  -0.2144   0.5463]
        Angle     73.5362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4217"
}

Galaxy "NGC 4218:UGC 7283:MCG 8-22-88:ZWG 243.54"
{
        Type  "Sa"
        RA           12.2628
        Dec          48.1317
        Distance   4.254e+07  # method: V
        Radius          7424
        AbsMag        -17.18
        Axis    [ -0.4468   0.8479   0.2854]
        Angle     37.5464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4218"
}

Galaxy "NGC 4219:ESO 267-37:MCG 7-25-5:AM 1213-430"
{
        Type  "Sc"
        RA           12.2742
        Dec         -43.3225
        Distance   8.358e+07  # method: T-F
        Radius     4.498e+04
        AbsMag        -19.34
        Axis    [  0.8023   0.0212  -0.5966]
        Angle     91.3919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4219"
}

Galaxy "NGC 4219A:ESO 267-38:MCG 7-25-6:DCL 13"
{
        Type  "SBc"
        RA           12.2997
        Dec         -43.5406
        Distance   2.682e+08  # method: T-F
        Radius     5.071e+04
        AbsMag        -20.17
        Axis    [  0.7740  -0.0489  -0.6313]
        Angle    102.6928
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4219A"
}

Galaxy "NGC 4220:UGC 7290:MCG 8-22-89:ZWG 243.55"
{
        Type  "Sa"
        RA           12.2697
        Dec          47.8831
        Distance   5.364e+07  # method: V
        Radius     3.042e+04
        AbsMag        -18.88
        Axis    [ -0.4640   0.6740   0.5748]
        Angle     42.9417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4220"
}

Galaxy "NGC 4221:UGC 7288:MCG 11-15-40:ZWG 315.29"
{
        Type  "SBa"
        RA           12.2667
        Dec          66.2314
        Distance   1.335e+08  # method: V
        Radius     4.273e+04
        AbsMag        -19.66
        Axis    [  0.6819  -0.6497   0.3359]
        Angle     85.1115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4221"
}

Galaxy "NGC 4222:UGC 7291:MCG 2-31-75:ZWG 69.119"
{
        Type  "Sc"
        RA           12.2728
        Dec          13.3069
        Distance   2.514e+07  # method: V
        Radius     1.134e+04
        AbsMag        -15.53
        Axis    [  0.9697  -0.0927   0.2260]
        Angle     59.4230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4222"
}

Galaxy "NGC 4223:IC 3102:UGC 7319:MCG 1-31-38"
{
        Type  "Sa"
        RA           12.2903
        Dec           6.6894
        Distance   1.166e+08  # method: V
        Radius      4.24e+04
        AbsMag        -19.77
        Axis    [ -0.5470   0.1296  -0.8271]
        Angle     25.5406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4223"
}

Galaxy "NGC 4224:UGC 7292:MCG 1-31-34:ZWG 41.60"
{
        Type  "Sa"
        RA           12.2758
        Dec           7.4622
        Distance   1.332e+08  # method: V
        Radius     4.844e+04
        AbsMag        -20.16
        Axis    [  0.9594  -0.2363  -0.1538]
        Angle     57.5190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4224"
}

Galaxy "NGC 4225:MCG 2-31-27:NPM 1:IRAS 12140-1203"
{
        Type  "Sa"
        RA           12.2772
        Dec         -12.3269
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.6635  -0.3032  -0.6840]
        Angle     75.0350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4225"
}

Galaxy "NGC 4226:UGC 7297:MCG 8-22-90:ZWG 243.57"
{
        Type  "Sa"
        RA           12.2739
        Dec          47.0256
        Distance   3.374e+08  # method: V
        Radius     4.907e+04
        AbsMag        -20.67
        Axis    [ -0.2180   0.7515   0.6226]
        Angle     29.0479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4226"
}

Galaxy "NGC 4227:UGC 7296:MCG 6-27-43:ZWG 187.33"
{
        Type  "SBa"
        RA           12.2758
        Dec          33.5222
        Distance   3.041e+08  # method: V
        Radius     6.634e+04
        AbsMag        -21.15
        Axis    [  0.9349  -0.3441   0.0868]
        Angle     42.9490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4227"
}

Galaxy "NGC 4229:UGC 7299:MCG 6-27-44:ZWG 187.34"
{
        Type  "Sa"
        RA           12.2772
        Dec          33.5611
        Distance   3.191e+08  # method: V
        Radius     5.105e+04
        AbsMag        -20.75
        Axis    [  0.8331  -0.5531   0.0096]
        Angle     99.7909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4229"
}

Galaxy "NGC 4231:UGC 7304:MCG 8-22-94:ZWG 243.60"
{
        Type  "Sa"
        RA           12.2800
        Dec          47.4581
        Distance   3.454e+08  # method: V
        Radius     6.029e+04
        AbsMag        -20.62
        Axis    [  0.7020  -0.7093  -0.0636]
        Angle     76.8116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4231"
}

Galaxy "NGC 4232:UGC 7303:MCG 8-22-93:ZWG 243.59"
{
        Type  "SBb"
        RA           12.2803
        Dec          47.4389
        Distance   3.365e+08  # method: V
        Radius     6.363e+04
        AbsMag        -20.57
        Axis    [ -0.5805   0.7802   0.2332]
        Angle     48.9452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4232"
}

Galaxy "NGC 4233:UGC 7311:MCG 1-31-37:ZWG 41.63"
{
        Type  "S0"
        RA           12.2853
        Dec           7.6242
        Distance   1.105e+08  # method: S
        Radius     3.858e+04
        AbsMag        -19.65
        Axis    [ -0.9508   0.2467  -0.1873]
        Angle     61.4144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4233"
}

Galaxy "NGC 4234:UGC 7309:MCG 1-31-35:ZWG 41.61"
{
        Type  "Irr"
        RA           12.2858
        Dec           3.6833
        Distance   1.077e+08  # method: V
        Radius     2.036e+04
        AbsMag        -19.19
        Axis    [  0.6250  -0.6667  -0.4061]
        Angle    132.6954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4234"
}

Galaxy "NGC 4235:IC 3098:UGC 7310:MCG 1-31-36"
{
        Type  "Sa"
        RA           12.2858
        Dec           7.1908
        Distance   1.243e+08  # method: V
        Radius     7.591e+04
        AbsMag         -20.3
        Axis    [  0.9917  -0.0992   0.0823]
        Angle     66.0413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4235"
}

Galaxy "NGC 4236-1:UGC 7306:MCG 12-12-4:ZWG 335.8"
{
        Type  "Irr"
        RA           12.2786
        Dec          69.4636
        Distance   1.857e+07  # method: T-F
        Radius     5.916e+04
        AbsMag        -18.07
        Axis    [ -0.4523   0.7168   0.5306]
        Angle     74.3797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4236-1"
}

Galaxy "NGC 4236-2:ZW 446"
{
        Type  "Irr"
        RA           12.2786
        Dec          69.4600
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [ -0.3463   0.8719   0.3463]
        Angle     64.1998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4236-2"
}

Galaxy "NGC 4237:UGC 7315:MCG 3-31-91:ZWG 98.130"
{
        Type  "SBc"
        RA           12.2864
        Dec          15.3233
        Distance   5.377e+07  # method: V
        Radius     1.642e+04
        AbsMag        -18.48
        Axis    [  0.2733  -0.0255  -0.9616]
        Angle     22.4548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4237"
}

Galaxy "NGC 4238:UGC 7308:MCG 11-15-41:ZWG 315.31"
{
        Type  "Sc"
        RA           12.2822
        Dec          63.4106
        Distance   1.311e+08  # method: V
        Radius     3.431e+04
        AbsMag        -18.82
        Axis    [  0.7326  -0.2859   0.6177]
        Angle     93.4148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4238"
}

Galaxy "NGC 4239:UGC 7316:MCG 3-31-92:ZWG 98.129"
{
        Type  "E0"
        RA           12.2872
        Dec          16.5317
        Distance   5.626e+07  # method: V
        Radius     1.146e+04
        AbsMag        -17.58
        Axis    [ -0.0234   0.0975  -0.9950]
        Angle     73.5669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4239"
}

Galaxy "NGC 4240:NGC 4243:MCG 2-31-29"
{
        Type  "E0"
        RA           12.2900
        Dec          -9.9517
        Distance   1.906e+08  # distance uncertain!
        Radius     3.603e+04
        AbsMag        -20.13
        Axis    [  0.6322  -0.6084  -0.4797]
        Angle    142.3941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4240"
}

Galaxy "NGC 4241:IC 3115:UGC 7333:MCG 1-31-40"
{
        Type  "SBc"
        RA           12.2997
        Dec           6.6542
        Distance   4.856e+07  # method: V
        Radius     1.201e+04
        AbsMag        -17.06
        Axis    [ -0.3599   0.1696  -0.9175]
        Angle     46.9995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4241"
}

Galaxy "NGC 4242:UGC 7323:MCG 8-22-98:ZWG 243.61"
{
        Type  "SBc"
        RA           12.2917
        Dec          45.6192
        Distance   3.321e+07  # method: V
        Radius     2.511e+04
        AbsMag        -18.54
        Axis    [  0.7867  -0.6095   0.0975]
        Angle     85.3888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4242"
}

Galaxy "NGC 4244:UGC 7322:MCG 6-27-45:ZWG 187.35"
{
        Type  "Sc"
        RA           12.2914
        Dec          37.8078
        Distance   2.197e+07  # method: T-F
        Radius     5.305e+04
        AbsMag        -18.44
        Axis    [  0.8481  -0.1428   0.5102]
        Angle     75.8734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4244"
}

Galaxy "NGC 4245:UGC 7328:MCG 5-29-49:ZWG 158.59"
{
        Type  "SBa"
        RA           12.2933
        Dec          29.6075
        Distance   5.314e+07  # method: V
        Radius     2.241e+04
        AbsMag        -18.76
        Axis    [ -0.6667   0.6669  -0.3328]
        Angle     56.2805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4245"
}

Galaxy "NGC 4246:IC 3113:UGC 7334:MCG 1-31-41"
{
        Type  "Sc"
        RA           12.2994
        Dec           7.1856
        Distance   2.799e+08  # method: T-F
        Radius     9.364e+04
        AbsMag        -21.27
        Axis    [  0.8145  -0.2909  -0.5020]
        Angle     35.8033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4246"
}

Galaxy "NGC 4247:MCG 1-31-42:ZWG 41.71:VCC 265"
{
        Type  "SBb"
        RA           12.2992
        Dec           7.2744
        Distance   1.893e+08  # method: V
        Radius     2.203e+04
        AbsMag        -18.62
        Axis    [  0.6965  -0.4671  -0.5446]
        Angle     80.7560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4247"
}

Galaxy "NGC 4248:UGC 7335:MCG 8-22-99:ZWG 244.1"
{
        Type  "SBb"
        RA           12.2972
        Dec          47.4092
        Distance   3.148e+07  # method: V
        Radius     1.328e+04
        AbsMag        -16.72
        Axis    [  0.2860   0.3683   0.8846]
        Angle     30.7892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4248"
}

Galaxy "NGC 4249:MCG 1-31-39:ZWG 41.68:VCC 266"
{
        Type  "Sa"
        RA           12.2997
        Dec           5.5992
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.6193  -0.6776  -0.3966]
        Angle    131.6677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4249"
}

Galaxy "NGC 4250:UGC 7329:MCG 12-12-5:ZWG 335.9"
{
        Type  "SBa"
        RA           12.2903
        Dec          70.8028
        Distance   9.563e+07  # method: V
        Radius     3.755e+04
        AbsMag        -19.53
        Axis    [ -0.2737   0.9548   0.1157]
        Angle     68.0302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4250"
}

Galaxy "NGC 4251:UGC 7338:MCG 5-29-50:ZWG 158.60"
{
        Type  "S0"
        RA           12.3022
        Dec          28.1753
        Distance   6.389e+07  # method: S
        Radius     3.345e+04
        AbsMag        -19.86
        Axis    [  0.8344   0.0829   0.5449]
        Angle     17.4748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4251"
}

Galaxy "NGC 4252:UGC 7343:MCG 1-31-45:ZWG 41.76"
{
        Type  "Sb"
        RA           12.3083
        Dec           5.5600
        Distance    5.45e+07  # method: V
        Radius      1.03e+04
        AbsMag        -16.21
        Axis    [  0.9924  -0.1201   0.0255]
        Angle     65.8261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4252"
}

Galaxy "NGC 4253:UGC 7344:MCG 5-29-51:MK 766"
{
        Type  "SBa"
        RA           12.3072
        Dec          29.8131
        Distance   1.858e+08  # method: V
        Radius     2.432e+04
        AbsMag        -19.98
        Axis    [  0.7402  -0.5650  -0.3645]
        Angle     63.8176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4253"
}

Galaxy "M 99:NGC 4254:UGC 7345:MCG 3-31-99"
{
        Type  "Sc"
        RA           12.3136
        Dec          14.4175
        Distance   1.238e+08  # method: V
        Radius      9.54e+04
        AbsMag        -22.49
        Axis    [  0.7162  -0.4937  -0.4933]
        Angle     73.6487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 99"
}

Galaxy "NGC 4255:UGC 7348:MCG 1-31-47:ZWG 42.4"
{
        Type  "S0"
        RA           12.3156
        Dec           4.7864
        Distance   9.228e+07  # method: V
        Radius     1.745e+04
        AbsMag        -18.56
        Axis    [ -0.1587  -0.2005  -0.9668]
        Angle     10.6378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4255"
}

Galaxy "NGC 4256:UGC 7351:MCG 11-15-45:ZWG 315.32"
{
        Type  "Sb"
        RA           12.3117
        Dec          65.8983
        Distance   1.214e+08  # method: V
        Radius     7.943e+04
        AbsMag        -19.95
        Axis    [  0.6818  -0.2002   0.7036]
        Angle     96.2086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4256"
}

Galaxy "NGC 4257:MCG 1-31-49:ZWG 42.6:VCC 323"
{
        Type  "Sb"
        RA           12.3183
        Dec           5.7261
        Distance   2.226e+08  # distance uncertain!
        Radius     4.855e+04
        AbsMag        -19.07
        Axis    [  0.9598  -0.2250  -0.1677]
        Angle     36.3935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4257"
}

Galaxy "M 106:NGC 4258:UGC 7353:MCG 8-22-104"
{
        Type  "SBc"
        RA           12.3158
        Dec          47.3069
        Distance   2.374e+07  # method: S
        Radius     6.422e+04
        AbsMag         -20.2
        Axis    [ -0.5702   0.6724   0.4721]
        Angle     48.3827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 106"
}

Galaxy "NGC 4259:UGC 7359:MCG 1-31-51:ZWG 42.12"
{
        Type  "S0"
        RA           12.3228
        Dec           5.3769
        Distance   1.281e+08  # method: V
        Radius      2.05e+04
        AbsMag        -18.67
        Axis    [ -0.9629   0.1112  -0.2459]
        Angle     30.2269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4259"
}

Galaxy "NGC 4260:UGC 7361:MCG 1-31-54:ZWG 42.15"
{
        Type  "SBa"
        RA           12.3228
        Dec           6.0983
        Distance    1.04e+08  # method: V
        Radius     4.083e+04
        AbsMag        -19.82
        Axis    [  0.9188  -0.2882  -0.2698]
        Angle     58.2043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4260"
}

Galaxy "NGC 4261:UGC 7360:MCG 1-31-52:ZWG 42.13"
{
        Type  "E2"
        RA           12.3231
        Dec           5.8244
        Distance   1.031e+08  # method: S
        Radius     6.151e+04
        AbsMag         -21.1
        Axis    [ -0.3781   0.3938  -0.8379]
        Angle     91.9362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4261"
}

Galaxy "NGC 4262:UGC 7365:MCG 3-31-101:ZWG 99.14"
{
        Type  "S0"
        RA           12.3250
        Dec          14.8778
        Distance   7.629e+07  # method: V
        Radius     1.997e+04
        AbsMag        -19.34
        Axis    [ -0.0917   0.1148  -0.9891]
        Angle     44.0736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4262"
}

Galaxy "NGC 4263:NGC 4265:MCG 2-32-1:IRAS 12171-1156"
{
        Type  "Sb"
        RA           12.3283
        Dec         -12.2256
        Distance   1.017e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.3856  -0.2052  -0.8996]
        Angle     36.6939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4263"
}

Galaxy "NGC 4264:UGC 7364:MCG 1-32-1:ZWG 42.20"
{
        Type  "SBa"
        RA           12.3264
        Dec           5.8469
        Distance   1.354e+08  # method: V
        Radius     1.773e+04
        AbsMag        -19.19
        Axis    [ -0.2291   0.0575  -0.9717]
        Angle     40.6698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4264"
}

Galaxy "NGC 4266:UGC 7368:MCG 1-32-2:ZWG 42.21"
{
        Type  "SBa"
        RA           12.3283
        Dec           5.5381
        Distance   1.768e+08  # distance uncertain!
        Radius     4.628e+04
        AbsMag        -19.07
        Axis    [  0.9857  -0.1421   0.0908]
        Angle     38.0409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4266"
}

Galaxy "NGC 4267:UGC 7373:MCG 2-32-4:ZWG 70.13"
{
        Type  "S0"
        RA           12.3292
        Dec          12.7983
        Distance   6.016e+07  # method: V
        Radius     2.625e+04
        AbsMag        -19.53
        Axis    [  0.6909  -0.5639  -0.4524]
        Angle     93.3765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4267"
}

Galaxy "NGC 4268:UGC 7371:MCG 1-32-4:ZWG 42.23"
{
        Type  "SBa"
        RA           12.3297
        Dec           5.2842
        Distance   1.229e+08  # method: V
        Radius     2.503e+04
        AbsMag        -19.68
        Axis    [  0.9474  -0.2566  -0.1914]
        Angle     67.2368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4268"
}

Galaxy "NGC 4269:UGC 7372:MCG 1-32-5:ZWG 42.24"
{
        Type  "Sa"
        RA           12.3303
        Dec           6.0153
        Distance    1.31e+08  # method: V
        Radius     2.476e+04
        AbsMag        -19.22
        Axis    [ -0.6576   0.1798  -0.7316]
        Angle     34.3882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4269"
}

Galaxy "NGC 4270:UGC 7376:MCG 1-32-7:ZWG 42.26"
{
        Type  "S0"
        RA           12.3303
        Dec           5.4633
        Distance   1.276e+08  # method: V
        Radius     3.711e+04
        AbsMag        -19.86
        Axis    [  0.2083  -0.2137  -0.9544]
        Angle     15.0644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4270"
}

Galaxy "NGC 4271:UGC 7375:MCG 10-18-25:ZWG 293.10"
{
        Type  "S0"
        RA           12.3256
        Dec          56.7372
        Distance   2.224e+08  # method: V
        Radius     4.853e+04
        AbsMag        -20.67
        Axis    [  0.7717  -0.6245   0.1202]
        Angle     54.5380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4271"
}

Galaxy "NGC 4272:UGC 7378:MCG 5-29-59:ZWG 158.72"
{
        Type  "E0"
        RA           12.3297
        Dec          30.3389
        Distance   3.956e+08  # method: V
        Radius     9.782e+04
        AbsMag        -21.32
        Axis    [  0.0504   0.1719  -0.9838]
        Angle     61.4718
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4272"
}

Galaxy "NGC 4273:UGC 7380:MCG 1-32-8:ZWG 42.28"
{
        Type  "SBc"
        RA           12.3322
        Dec           5.3436
        Distance   1.234e+08  # method: V
        Radius      4.13e+04
        AbsMag        -20.49
        Axis    [  0.9021  -0.3746  -0.2144]
        Angle    107.3556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4273"
}

Galaxy "NGC 4274:UGC 7377:MCG 5-29-60:ZWG 158.71"
{
        Type  "SBb"
        RA           12.3306
        Dec          29.6136
        Distance   5.486e+07  # method: V
        Radius     5.426e+04
        AbsMag        -19.83
        Axis    [  0.6302   0.1376   0.7641]
        Angle     20.3142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4274"
}

Galaxy "NGC 4275:UGC 7382:MCG 5-29-58:ZWG 158.73"
{
        Type  "Sb"
        RA           12.3311
        Dec          27.6211
        Distance   1.181e+08  # method: V
        Radius     1.889e+04
        AbsMag        -19.19
        Axis    [  0.6101  -0.4064  -0.6802]
        Angle     46.4969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4275"
}

Galaxy "NGC 4276:UGC 7385:MCG 1-32-10:ZWG 42.32"
{
        Type  "SBc"
        RA           12.3353
        Dec           7.6914
        Distance   1.337e+08  # method: V
        Radius     3.111e+04
        AbsMag        -19.66
        Axis    [  0.7978  -0.5329  -0.2820]
        Angle    118.2817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4276"
}

Galaxy "NGC 4277:MCG 1-32-9:ZWG 42.29:VCC 386"
{
        Type  "SBa"
        RA           12.3342
        Dec           5.3419
        Distance   1.294e+08  # method: V
        Radius      2.07e+04
        AbsMag        -18.69
        Axis    [ -0.5910   0.2111  -0.7785]
        Angle     44.1434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4277"
}

Galaxy "NGC 4278:UGC 7386:MCG 5-29-62:ZWG 158.77"
{
        Type  "E1"
        RA           12.3350
        Dec          29.2803
        Distance   5.241e+07  # method: S
        Radius     2.897e+04
        AbsMag        -19.93
        Axis    [  0.5231  -0.8075  -0.2724]
        Angle    119.8260
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4278"
}

Galaxy "NGC 4279:MCG 2-32-3:NPM 1"
{
        Type  "Sa"
        RA           12.3400
        Dec         -11.6661
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.8325  -0.2851  -0.4751]
        Angle     90.5267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4279"
}

Galaxy "NGC 4281:UGC 7389:MCG 1-32-12:ZWG 42.34"
{
        Type  "Sa"
        RA           12.3392
        Dec           5.3864
        Distance    7.97e+07  # method: S
        Radius     3.477e+04
        AbsMag        -19.64
        Axis    [  0.7253  -0.3016  -0.6188]
        Angle     33.2076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4281"
}

Galaxy "NGC 4282:MCG 1-32-13:ZWG 42.35:VCC 411"
{
        Type  "Sa"
        RA           12.3400
        Dec           5.5733
        Distance   3.126e+08  # method: V
        Radius     5.455e+04
        AbsMag        -19.91
        Axis    [  0.3905  -0.2384  -0.8892]
        Angle     20.1182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4282"
}

Galaxy "NGC 4283:UGC 7390:MCG 5-29-63:ZWG 158.80"
{
        Type  "E0"
        RA           12.3389
        Dec          29.3108
        Distance   5.122e+07  # method: S
        Radius     1.117e+04
        AbsMag        -17.98
        Axis    [  0.5226  -0.8079  -0.2723]
        Angle    119.8470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4283"
}

Galaxy "NGC 4284:UGC 7393:MCG 10-18-26:ZWG 293.11"
{
        Type  "Sc"
        RA           12.3367
        Dec          58.0933
        Distance   2.412e+08  # method: T-F
        Radius      8.77e+04
        AbsMag        -19.94
        Axis    [  0.3935   0.2650   0.8803]
        Angle     38.1572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4284"
}

Galaxy "NGC 4285:MCG 2-32-4"
{
        Type  "Sa"
        RA           12.3442
        Dec         -11.6422
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.8143  -0.2607  -0.5187]
        Angle     74.8338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4285"
}

Galaxy "NGC 4286:IC 3181:UGC 7398:MCG 5-29-65"
{
        Type  "Sa"
        RA           12.3450
        Dec          29.3456
        Distance     4.1e+07  # method: V
        Radius          8944
        AbsMag           -16
        Axis    [ -0.7817   0.6234  -0.0176]
        Angle     37.6074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4286"
}

Galaxy "NGC 4287:MCG 1-32-14:ZWG 42.37:VCC 434"
{
        Type  "Sb"
        RA           12.3467
        Dec           5.6406
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.9827  -0.1188   0.1418]
        Angle     42.3636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4287"
}

Galaxy "NGC 4288:UGC 7399:MCG 8-23-6:DDO 119"
{
        Type  "SBc"
        RA           12.3439
        Dec          46.2944
        Distance   3.379e+07  # method: V
        Radius     1.081e+04
        AbsMag        -16.78
        Axis    [ -0.2175   0.9760   0.0046]
        Angle     23.7969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4288"
}

Galaxy "NGC 4288A:MCG 8-23-7"
{
        Type  "S0"
        RA           12.3444
        Dec          46.2553
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.4752  -0.8687  -0.1399]
        Angle    111.1835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4288A"
}

Galaxy "NGC 4289:UGC 7403:MCG 1-32-15:ZWG 42.38"
{
        Type  "Sc"
        RA           12.3506
        Dec           3.7228
        Distance   1.306e+08  # method: V
        Radius     7.406e+04
        AbsMag        -18.71
        Axis    [  0.9977  -0.0674   0.0030]
        Angle    112.7309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4289"
}

Galaxy "NGC 4290:UGC 7402:MCG 10-18-29:ZWG 293.12"
{
        Type  "SBb"
        RA           12.3464
        Dec          58.0925
        Distance   1.443e+08  # method: V
        Radius     4.618e+04
        AbsMag        -20.43
        Axis    [  0.8238  -0.0657   0.5631]
        Angle     29.1144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4290"
}

Galaxy "NGC 4291:UGC 7397:MCG 13-9-24:ZWG 352.28"
{
        Type  "E0"
        RA           12.3381
        Dec          75.3711
        Distance    8.54e+07  # method: S
        Radius     2.484e+04
        AbsMag        -19.69
        Axis    [  0.4868   0.6925  -0.5325]
        Angle     36.7374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4291"
}

Galaxy "NGC 4292:UGC 7404:MCG 1-32-16:ZWG 42.40"
{
        Type  "S0"
        RA           12.3544
        Dec           4.5961
        Distance   1.177e+08  # method: V
        Radius     2.739e+04
        AbsMag        -19.59
        Axis    [  0.8640  -0.4320  -0.2587]
        Angle    112.4243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4292"
}

Galaxy "NGC 4292A"
{
        Type  "S0"
        RA           12.3544
        Dec           4.6331
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.6618  -0.3353  -0.6705]
        Angle     46.3322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4292A"
}

Galaxy "NGC 4293:UGC 7405:MCG 3-32-6:ZWG 99.23"
{
        Type  "SBa"
        RA           12.3533
        Dec          18.3828
        Distance   5.699e+07  # method: V
        Radius     4.642e+04
        AbsMag        -20.01
        Axis    [  0.9536  -0.2962  -0.0544]
        Angle     41.9970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4293"
}

Galaxy "NGC 4294:UGC 7407:MCG 2-32-9:ZWG 70.24"
{
        Type  "SBc"
        RA           12.3547
        Dec          11.5097
        Distance   6.637e+07  # method: T-F
        Radius     3.089e+04
        AbsMag        -19.04
        Axis    [ -0.9678   0.2408  -0.0731]
        Angle     41.1142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4294"
}

Galaxy "NGC 4295:MCG 5-29-68:ZWG 158.85"
{
        Type  "S0"
        RA           12.3525
        Dec          28.1656
        Distance   4.011e+08  # method: V
        Radius      5.25e+04
        AbsMag        -20.55
        Axis    [ -0.7541   0.6186  -0.2206]
        Angle     53.5605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4295"
}

Galaxy "NGC 4296:UGC 7409:MCG 1-32-17:ZWG 42.41"
{
        Type  "S0"
        RA           12.3578
        Dec           6.6536
        Distance   2.068e+08  # method: V
        Radius      4.21e+04
        AbsMag        -20.21
        Axis    [  0.8997  -0.3795  -0.2159]
        Angle    102.1969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4296"
}

Galaxy "NGC 4297:MCG 1-32-18:ZWG 42.41:VCC 473"
{
        Type  "S0"
        RA           12.3575
        Dec           6.6714
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [ -0.9726   0.1854  -0.1404]
        Angle     54.7046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4297"
}

Galaxy "NGC 4298:UGC 7412:MCG 3-32-7:ZWG 99.24"
{
        Type  "Sc"
        RA           12.3589
        Dec          14.6067
        Distance   6.632e+07  # method: V
        Radius     3.087e+04
        AbsMag        -19.44
        Axis    [ -0.7651   0.3693  -0.5275]
        Angle     30.7337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4298"
}

Galaxy "NGC 4299:UGC 7414:MCG 2-32-10:ZWG 70.25"
{
        Type  "SBc"
        RA           12.3611
        Dec          11.5014
        Distance   2.546e+07  # method: V
        Radius          6295
        AbsMag        -16.56
        Axis    [  0.6931  -0.5800  -0.4279]
        Angle    100.4807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4299"
}

Galaxy "NGC 4300:UGC 7413:MCG 1-32-21:ZWG 42.44"
{
        Type  "Sa"
        RA           12.3614
        Dec           5.3847
        Distance   1.208e+08  # method: V
        Radius     2.635e+04
        AbsMag        -19.04
        Axis    [  0.9579  -0.2449  -0.1500]
        Angle     72.8455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4300"
}

Galaxy "NGC 4301:NGC 4303A:UGC 7439:MCG 1-32-27"
{
        Type  "SBc"
        RA           12.3742
        Dec           4.5658
        Distance    7.37e+07  # method: V
        Radius     1.715e+04
        AbsMag        -18.17
        Axis    [  0.6168  -0.3924  -0.6823]
        Angle     63.0519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4301"
}

Galaxy "NGC 4302:UGC 7418:MCG 3-32-9:ZWG 99.27"
{
        Type  "Sc"
        RA           12.3617
        Dec          14.5983
        Distance   6.487e+07  # method: V
        Radius     5.001e+04
        AbsMag        -18.89
        Axis    [ -0.9682   0.1449   0.2037]
        Angle     65.5368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4302"
}

Galaxy "M 61:NGC 4303:UGC 7420:MCG 1-32-22"
{
        Type  "SBc"
        RA           12.3650
        Dec           4.4728
        Distance   8.648e+07  # method: V
        Radius     8.176e+04
        AbsMag        -22.02
        Axis    [ -0.6064   0.3553  -0.7114]
        Angle     71.1197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 61"
}

Galaxy "NGC 4304:ESO 380-20:MCG 5-29-34:FAIR 310"
{
        Type  "SBc"
        RA           12.3700
        Dec         -33.4847
        Distance    1.33e+08  # method: V
        Radius     5.801e+04
        AbsMag        -20.65
        Axis    [  0.7848  -0.2482  -0.5679]
        Angle    127.1602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4304"
}

Galaxy "NGC 4305:UGC 7432:MCG 2-32-13:ZWG 70.31"
{
        Type  "Sa"
        RA           12.3675
        Dec          12.7408
        Distance   1.002e+08  # method: V
        Radius     3.205e+04
        AbsMag        -19.14
        Axis    [  0.9244  -0.3543  -0.1411]
        Angle     83.0539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4305"
}

Galaxy "NGC 4306:UGC 7433:MCG 2-32-14:ZWG 70.32"
{
        Type  "S0"
        RA           12.3678
        Dec          12.7875
        Distance   9.432e+07  # method: V
        Radius     2.195e+04
        AbsMag        -18.51
        Axis    [ -0.6472   0.3268  -0.6887]
        Angle     36.0865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4306"
}

Galaxy "NGC 4307:UGC 7431:MCG 2-32-12A:ZWG 70.29"
{
        Type  "Sb"
        RA           12.3681
        Dec           9.0419
        Distance   6.469e+07  # method: V
        Radius     3.293e+04
        AbsMag        -18.59
        Axis    [  0.9898  -0.1337   0.0487]
        Angle     90.1421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4307"
}

Galaxy "NGC 4308:UGC 7426:MCG 5-29-69:ZWG 158.88"
{
        Type  "E0"
        RA           12.3656
        Dec          30.0742
        Distance   4.009e+07  # method: V
        Radius          4665
        AbsMag        -16.25
        Axis    [  0.4993  -0.7369  -0.4558]
        Angle     96.3209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4308"
}

Galaxy "NGC 4309:UGC 7435:MCG 1-32-25:ZWG 42.51"
{
        Type  "SBa"
        RA           12.3700
        Dec           7.1447
        Distance   5.513e+07  # method: V
        Radius     1.443e+04
        AbsMag        -17.44
        Axis    [  0.7551  -0.3225  -0.5709]
        Angle     35.5509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4309"
}

Galaxy "NGC 4309A:VCC 538"
{
        Type  "E0"
        RA           12.3706
        Dec           7.1664
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5875  -0.7029  -0.4009]
        Angle    132.4515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4309A"
}

Galaxy "NGC 4310:NGC 4338:UGC 7440:MCG 5-29-74"
{
        Type  "S0"
        RA           12.3739
        Dec          29.2081
        Distance   5.413e+07  # method: V
        Radius     1.575e+04
        AbsMag         -17.8
        Axis    [ -0.8248   0.5650   0.0228]
        Angle     48.1829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4310"
}

Galaxy "NGC 4312:UGC 7442:MCG 3-32-14:ZWG 99.29"
{
        Type  "Sb"
        RA           12.3753
        Dec          15.5381
        Distance   2.147e+07  # method: V
        Radius     1.437e+04
        AbsMag        -16.49
        Axis    [ -0.9634   0.1986   0.1802]
        Angle     56.9800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4312"
}

Galaxy "NGC 4313:UGC 7445:MCG 2-32-16:ZWG 70.34"
{
        Type  "Sb"
        RA           12.3772
        Dec          11.8011
        Distance   8.036e+07  # method: V
        Radius     4.442e+04
        AbsMag        -19.16
        Axis    [ -0.9499   0.1327   0.2830]
        Angle     30.1926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4313"
}

Galaxy "NGC 4314:UGC 7443:MCG 5-29-75:ZWG 158.93"
{
        Type  "SBa"
        RA           12.3753
        Dec          29.8958
        Distance   5.631e+07  # method: V
        Radius      3.44e+04
        AbsMag        -19.78
        Axis    [  0.7164  -0.5094  -0.4768]
        Angle     51.0796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4314"
}

Galaxy "NGC 4316:UGC 7447:MCG 2-32-17:ZWG 70.35"
{
        Type  "Sc"
        RA           12.3783
        Dec           9.3325
        Distance   7.189e+07  # method: V
        Radius     2.614e+04
        AbsMag        -17.92
        Axis    [  0.0822  -0.1395   0.9868]
        Angle     10.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4316"
}

Galaxy "NGC 4318:UGC 7446:MCG 2-32-15:ZWG 42.59"
{
        Type  "E0"
        RA           12.3786
        Dec           8.1992
        Distance   2.399e+08  # distance uncertain!
        Radius     2.442e+04
        AbsMag        -20.13
        Axis    [  0.3538  -0.4525  -0.8186]
        Angle     92.5166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4318"
}

Galaxy "NGC 4319:NGV 4345:UGC 7429:MCG 13-9-25"
{
        Type  "SBb"
        RA           12.3619
        Dec          75.3225
        Distance   7.937e+07  # method: V
        Radius     3.232e+04
        AbsMag        -19.13
        Axis    [ -0.2022   0.9460   0.2535]
        Angle     63.2106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4319"
}

Galaxy "NGC 4320:UGC 7452:MCG 2-32-18:ZWG 70.36"
{
        Type  "Sb"
        RA           12.3825
        Dec          10.5492
        Distance   3.773e+08  # method: V
        Radius     5.487e+04
        AbsMag        -20.52
        Axis    [ -0.8872   0.3436  -0.3078]
        Angle     59.0610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4320"
}

Galaxy "M 100:NGC 4321:UGC 7450:MCG 3-32-15"
{
        Type  "SBc"
        RA           12.3817
        Dec          15.8228
        Distance   8.634e+07  # method: V
        Radius     9.419e+04
        AbsMag        -22.01
        Axis    [  0.8002  -0.5201  -0.2986]
        Angle     89.1020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 100"
}

Galaxy "NGC 4323:MCG 3-32-16:ZWG 99.31:VCC 608"
{
        Type  "S0"
        RA           12.3836
        Dec          15.9053
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.4432  -0.2060  -0.8724]
        Angle     29.1240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4323"
}

Galaxy "NGC 4324:UGC 7451:MCG 1-32-32:ZWG 42.63"
{
        Type  "Sa"
        RA           12.3850
        Dec           5.2500
        Distance   9.092e+07  # method: V
        Radius     3.835e+04
        AbsMag        -19.73
        Axis    [  0.9446  -0.2640  -0.1951]
        Angle     62.2779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4324"
}

Galaxy "NGC 4326:UGC 7454:MCG 1-32-33:ZWG 42.64"
{
        Type  "SBb"
        RA           12.3864
        Dec           6.0725
        Distance   3.382e+08  # method: V
        Radius     6.886e+04
        AbsMag        -20.88
        Axis    [  0.0983  -0.1334  -0.9862]
        Angle     40.6323
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4326"
}

Galaxy "NGC 4328:MCG 3-32-19:ZWG 99.34:VCC 634"
{
        Type  "S0"
        RA           12.3889
        Dec          15.8203
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [  0.6650  -0.3197  -0.6750]
        Angle     32.8913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4328"
}

Galaxy "NGC 4329:MCG 2-32-9"
{
        Type  "E0"
        RA           12.3889
        Dec         -12.5581
        Distance    3.02e+08  # distance uncertain!
        Radius     4.832e+04
        AbsMag        -20.13
        Axis    [  0.3991  -0.4558  -0.7956]
        Angle    117.6584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4329"
}

Galaxy "NGC 4330:UGC 7456:MCG 2-32-20:ZWG 70.39"
{
        Type  "Sc"
        RA           12.3881
        Dec          11.3686
        Distance   8.598e+07  # method: V
        Radius     5.627e+04
        AbsMag           -19
        Axis    [  0.9720  -0.1206   0.2019]
        Angle     56.3656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4330"
}

Galaxy "NGC 4331:UGC 7449:MCG 13-9-26:ZWG 352.31"
{
        Type  "Irr"
        RA           12.3764
        Dec          76.1686
        Distance   7.321e+07  # method: V
        Radius     2.342e+04
        AbsMag        -17.05
        Axis    [  0.7338  -0.3982   0.5505]
        Angle    130.6221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4331"
}

Galaxy "NGC 4332:UGC 7453:MCG 11-15-48:ZWG 315.33"
{
        Type  "SBa"
        RA           12.3794
        Dec          65.8442
        Distance   1.349e+08  # method: V
        Radius     4.119e+04
        AbsMag        -19.98
        Axis    [  0.0014   0.8611   0.5084]
        Angle     36.1340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4332"
}

Galaxy "NGC 4333:MCG 1-32-34:ZWG 42.65:VCC 637"
{
        Type  "SBb"
        RA           12.3894
        Dec           6.0411
        Distance   3.325e+08  # method: V
        Radius     3.869e+04
        AbsMag        -20.54
        Axis    [ -0.6944   0.4000  -0.5982]
        Angle     73.2241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4333"
}

Galaxy "NGC 4334:UGC 7458:MCG 1-32-35:ZWG 42.66"
{
        Type  "SBb"
        RA           12.3900
        Dec           7.4733
        Distance   2.077e+08  # method: V
        Radius     6.645e+04
        AbsMag        -20.12
        Axis    [ -0.8002   0.1515  -0.5803]
        Angle     26.0027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4334"
}

Galaxy "NGC 4335:UGC 7455:MCG 10-18-35:ZWG 293.15"
{
        Type  "E0"
        RA           12.3836
        Dec          58.4444
        Distance   2.149e+08  # method: V
        Radius     5.939e+04
        AbsMag        -20.69
        Axis    [  0.0923   0.7394  -0.6669]
        Angle     55.6171
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4335"
}

Galaxy "NGC 4336:IC 3254:UGC 7462:MCG 3-32-20"
{
        Type  "SBa"
        RA           12.3914
        Dec          19.4269
        Distance   6.551e+07  # method: V
        Radius     1.905e+04
        AbsMag        -17.91
        Axis    [ -0.9160   0.3987  -0.0450]
        Angle     48.1014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4336"
}

Galaxy "NGC 4339:UGC 7461:MCG 1-32-36:ZWG 42.68"
{
        Type  "E0"
        RA           12.3928
        Dec           6.0819
        Distance   5.363e+07  # method: S
        Radius     1.482e+04
        AbsMag        -18.78
        Axis    [  0.5879  -0.6988  -0.4074]
        Angle    133.2496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4339"
}

Galaxy "NGC 4340:UGC 7467:MCG 3-32-21:ZWG 99.36"
{
        Type  "SBa"
        RA           12.3931
        Dec          16.7228
        Distance   5.586e+07  # method: V
        Radius     2.437e+04
        AbsMag        -19.07
        Axis    [  0.4941  -0.1901  -0.8484]
        Angle     23.1019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4340"
}

Galaxy "NGC 4341:IC 3260:UGC 7472:MCG 1-32-42"
{
        Type  "S0"
        RA           12.3981
        Dec           7.1069
        Distance   6.596e+07  # method: V
        Radius     1.631e+04
        AbsMag        -17.33
        Axis    [  0.8977  -0.3224  -0.3002]
        Angle     19.0829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4341"
}

Galaxy "NGC 4342:IC 3256:UGC 7466:MCG 1-32-39"
{
        Type  "S0"
        RA           12.3942
        Dec           7.0544
        Distance   4.757e+07  # method: V
        Radius          8302
        AbsMag        -17.62
        Axis    [ -0.9396   0.2400  -0.2440]
        Angle     55.8678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4342"
}

Galaxy "NGC 4343:UGC 7465:MCG 1-32-38:ZWG 42.70"
{
        Type  "Sb"
        RA           12.3939
        Dec           6.9544
        Distance   6.116e+07  # method: V
        Radius     2.046e+04
        AbsMag        -18.16
        Axis    [ -0.9970   0.0327  -0.0704]
        Angle     19.2222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4343"
}

Galaxy "NGC 4344:UGC 7468:MCG 3-32-22:ZWG 99.37"
{
        Type  "S0"
        RA           12.3936
        Dec          17.5417
        Distance   6.605e+07  # method: V
        Radius     1.633e+04
        AbsMag        -18.13
        Axis    [  0.3632  -0.2900  -0.8854]
        Angle     53.4528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4344"
}

Galaxy "NGC 4346:UGC 7463:MCG 8-23-16:ZWG 244.9"
{
        Type  "S0"
        RA           12.3908
        Dec          46.9939
        Distance   4.671e+07  # method: S
        Radius     2.174e+04
        AbsMag        -18.48
        Axis    [  0.4972   0.1519   0.8542]
        Angle     33.6876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4346"
}

Galaxy "NGC 4348:MCG 0-32-3:ZWG 14.23:KARA 527"
{
        Type  "Sc"
        RA           12.3981
        Dec          -3.4425
        Distance   1.131e+08  # method: T-F
        Radius     5.265e+04
        AbsMag         -19.4
        Axis    [  0.9917  -0.0891  -0.0929]
        Angle     75.7044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4348"
}

Galaxy "NGC 4350:UGC 7473:MCG 3-32-23:ZWG 99.38"
{
        Type  "S0"
        RA           12.3992
        Dec          16.6933
        Distance   7.035e+07  # method: V
        Radius     2.967e+04
        AbsMag        -19.67
        Axis    [  0.9203  -0.3805  -0.0909]
        Angle     86.5643
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4350"
}

Galaxy "NGC 4351:NGC 4354:UGC 7476:MCG 2-32-24"
{
        Type  "SBb"
        RA           12.4003
        Dec          12.2047
        Distance   1.195e+08  # method: V
        Radius     3.476e+04
        AbsMag        -19.82
        Axis    [  0.7061  -0.3722  -0.6024]
        Angle     43.1693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4351"
}

Galaxy "NGC 4352:UGC 7475:MCG 2-32-23:ZWG 70.44"
{
        Type  "S0"
        RA           12.4011
        Dec          11.2178
        Distance   1.103e+08  # method: V
        Radius     3.209e+04
        AbsMag        -19.15
        Axis    [  0.6475  -0.2793  -0.7091]
        Angle     17.3015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4352"
}

Galaxy "NGC 4353:IC 3266:MCG 1-32-43:ZWG 42.77"
{
        Type  "Irr"
        RA           12.4000
        Dec           7.7842
        Distance   6.614e+07  # method: V
        Radius          8658
        AbsMag        -17.33
        Axis    [  0.7312  -0.3697  -0.5733]
        Angle     48.2147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4353"
}

Galaxy "NGC 4356:IC 3273:UGC 7482:MCG 2-32-26"
{
        Type  "Sc"
        RA           12.4039
        Dec           8.5369
        Distance   6.668e+07  # method: V
        Radius     2.716e+04
        AbsMag        -17.55
        Axis    [  0.9886  -0.1129   0.0995]
        Angle     74.5233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4356"
}

Galaxy "NGC 4358:UGC 7479:MCG 10-18-38:ZWG 293.17"
{
        Type  "S0"
        RA           12.4006
        Dec          58.3853
        Distance   2.104e+08  # method: V
        Radius      3.06e+04
        AbsMag        -19.85
        Axis    [ -0.3935   0.9187  -0.0339]
        Angle     63.6603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4358"
}

Galaxy "NGC 4359:UGC 7483:MCG 5-29-79:ZWG 158.99"
{
        Type  "SBc"
        RA           12.4031
        Dec          31.5214
        Distance   6.433e+07  # method: T-F
        Radius     3.275e+04
        AbsMag        -17.77
        Axis    [  0.2413   0.1834   0.9530]
        Angle     29.4669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4359"
}

Galaxy "NGC 4360:NGC 4360A:UGC 7484:MCG 2-32-28"
{
        Type  "E0"
        RA           12.4058
        Dec           9.2931
        Distance    3.26e+08  # method: V
        Radius     7.112e+04
        AbsMag         -21.5
        Axis    [ -0.2723   0.2938  -0.9163]
        Angle     83.4981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4360"
}

Galaxy "NGC 4362:NGC 4364:MCG 10-18-39:ZWG 293.18"
{
        Type  "S0"
        RA           12.4031
        Dec          58.3614
        Distance   2.119e+08  # method: V
        Radius      3.39e+04
        AbsMag        -18.76
        Axis    [  0.7680  -0.3399   0.5428]
        Angle     85.6547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4362"
}

Galaxy "NGC 4363:ZWG 352.32"
{
        Type  "Sb"
        RA           12.3911
        Dec          74.9519
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.3095  -0.9465   0.0913]
        Angle    101.7638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4363"
}

Galaxy "NGC 4365:UGC 7488:MCG 1-32-48:ZWG 42.83"
{
        Type  "E3"
        RA           12.4078
        Dec           7.3175
        Distance   6.659e+07  # method: S
        Radius     6.683e+04
        AbsMag        -20.95
        Axis    [  0.4697  -0.5870  -0.6594]
        Angle    106.4604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4365"
}

Galaxy "NGC 4366:MCG 1-32-50:ZWG 42.87:VCC 745"
{
        Type  "E0"
        RA           12.4131
        Dec           7.3528
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.4214  -0.5358  -0.7317]
        Angle    100.2661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4366"
}

Galaxy "NGC 4368:NGC 4325:MCG 2-32-19:ZWG 70.37"
{
        Type  "E0"
        RA           12.3850
        Dec          10.6217
        Distance   3.677e+08  # method: V
        Radius     5.348e+04
        AbsMag        -20.86
        Axis    [  0.5682  -0.7111  -0.4140]
        Angle    126.9656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4368"
}

Galaxy "NGC 4369:UGC 7489:MCG 7-26-4:MK 439"
{
        Type  "Sa"
        RA           12.4100
        Dec          39.3828
        Distance   5.789e+07  # method: V
        Radius     1.768e+04
        AbsMag        -18.95
        Axis    [ -0.0182   0.5032  -0.8640]
        Angle     36.1909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4369"
}

Galaxy "NGC 4370:UGC 7492:MCG 1-32-51:ZWG 42.89"
{
        Type  "Sa"
        RA           12.4153
        Dec           7.4444
        Distance   5.051e+07  # method: V
        Radius          9550
        AbsMag        -17.15
        Axis    [  0.7889  -0.3406  -0.5116]
        Angle     36.4423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4370"
}

Galaxy "NGC 4371:UGC 7493:MCG 2-32-33:ZWG 70.57"
{
        Type  "SBa"
        RA           12.4153
        Dec          11.7042
        Distance   5.794e+07  # method: V
        Radius     3.371e+04
        AbsMag        -19.35
        Axis    [  0.6788  -0.3113  -0.6651]
        Angle     25.8264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4371"
}

Galaxy "NGC 4373:ESO 322-6:MCG 6-27-25:AM 1222-392"
{
        Type  "S0"
        RA           12.4214
        Dec         -39.7606
        Distance   9.411e+07  # method: T-F
        Radius     4.927e+04
        AbsMag         -20.4
        Axis    [  0.6239  -0.2151  -0.7513]
        Angle    105.8549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4373"
}

Galaxy "NGC 4373A:ESO 322-8:MCG 6-27-26:DCL 41"
{
        Type  "S0"
        RA           12.4269
        Dec         -39.3197
        Distance   1.503e+08  # method: V
        Radius     5.684e+04
        AbsMag        -20.42
        Axis    [ -0.6484  -0.4319  -0.6269]
        Angle     62.0223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4373A"
}

Galaxy "NGC 4373B:ESO 322-10:MCG 6-27-27A:DCL 45"
{
        Type  "SBc"
        RA           12.4453
        Dec         -39.1344
        Distance   2.125e+08  # distance uncertain!
        Radius     4.637e+04
        AbsMag        -19.07
        Axis    [ -0.8047  -0.2263  -0.5489]
        Angle     85.9656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4373B"
}

Galaxy "M 84:NGC 4374:UGC 7494:MCG 2-32-34"
{
        Type  "E1"
        RA           12.4175
        Dec          12.8869
        Distance    5.99e+07  # method: S
        Radius     5.663e+04
        AbsMag        -21.12
        Axis    [ -0.1814   0.2221  -0.9580]
        Angle     78.0043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 84"
}

Galaxy "NGC 4375:UGC 7496:MCG 5-29-80:ZWG 158.100"
{
        Type  "SBb"
        RA           12.4167
        Dec          28.5586
        Distance   4.232e+08  # method: V
        Radius     8.617e+04
        AbsMag        -21.77
        Axis    [  0.7627  -0.6364  -0.1150]
        Angle    109.4983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4375"
}

Galaxy "NGC 4376:UGC 7498:MCG 1-32-53:ZWG 42.93"
{
        Type  "Irr"
        RA           12.4217
        Dec           5.7411
        Distance   6.682e+07  # method: V
        Radius     1.361e+04
        AbsMag        -17.86
        Axis    [ -0.8267   0.2570  -0.5005]
        Angle     50.2324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4376"
}

Galaxy "NGC 4377-1:UGC 7501:MCG 3-32-25:ZWG 99.41"
{
        Type  "S0"
        RA           12.4200
        Dec          14.7622
        Distance   7.611e+07  # method: V
        Radius     1.882e+04
        AbsMag        -19.14
        Axis    [ -0.7880   0.4760  -0.3905]
        Angle     68.9086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4377-1"
}

Galaxy "NGC 4377-2:UGC 7501:MCG 3-32-25:ZWG 99.41"
{
        Type  "E0"
        RA           12.4194
        Dec          14.7619
        Distance   1.148e+09  # distance uncertain!
        Radius      1.67e+04
        AbsMag        -20.13
        Axis    [  0.5620  -0.7440  -0.3613]
        Angle    128.4596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4377-2"
}

Galaxy "NGC 4377-3:UGC 7501:MCG 3-32-25:ZWG 99.41"
{
        Type  "E0"
        RA           12.4203
        Dec          14.7647
        Distance   1.259e+09  # distance uncertain!
        Radius     1.831e+04
        AbsMag        -20.13
        Axis    [  0.5620  -0.7441  -0.3613]
        Angle    128.4648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4377-3"
}

Galaxy "NGC 4378:UGC 7497:MCG 1-32-52:ZWG 42.92"
{
        Type  "Sa"
        RA           12.4217
        Dec           4.9253
        Distance   1.309e+08  # method: V
        Radius      5.52e+04
        AbsMag        -20.42
        Axis    [ -0.6157   0.3888  -0.6854]
        Angle     75.8138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4378"
}

Galaxy "NGC 4379:UGC 7502:MCG 3-32-26:ZWG 99.42"
{
        Type  "S0"
        RA           12.4206
        Dec          15.6078
        Distance   4.628e+07  # method: S
        Radius     1.346e+04
        AbsMag        -18.16
        Axis    [  0.2421  -0.1370  -0.9605]
        Angle     33.6547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4379"
}

Galaxy "NGC 4380:UGC 7503:MCG 2-32-37:ZWG 70.61"
{
        Type  "Sb"
        RA           12.4228
        Dec          10.0167
        Distance   7.312e+07  # method: T-F
        Radius     3.722e+04
        AbsMag        -19.05
        Axis    [ -0.8902   0.2784  -0.3606]
        Angle     41.7869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4380"
}

Galaxy "NGC 4381:NGC 4357:UGC 7478:MCG 8-23-17"
{
        Type  "Sc"
        RA           12.3997
        Dec          48.7800
        Distance   1.957e+08  # method: V
        Radius     1.053e+05
        AbsMag        -20.69
        Axis    [  0.6971  -0.1096   0.7085]
        Angle     51.2245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4381"
}

Galaxy "M 85:NGC 4382:UGC 7508:MCG 3-32-29"
{
        Type  "Sa"
        RA           12.4231
        Dec          18.1908
        Distance   6.018e+07  # method: S
        Radius     6.214e+04
        AbsMag        -21.33
        Axis    [  0.8340  -0.5297  -0.1544]
        Angle    111.1588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 85"
}

Galaxy "NGC 4383:UGC 7507:MCG 3-32-30:MK 769"
{
        Type  "Sa"
        RA           12.4236
        Dec          16.4700
        Distance   9.183e+07  # method: V
        Radius     2.671e+04
        AbsMag        -19.55
        Axis    [  0.9333  -0.3540  -0.0601]
        Angle     86.4179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4383"
}

Galaxy "NGC 4384:UGC 7506:MCG 9-20-168:MK 207"
{
        Type  "Sa"
        RA           12.4197
        Dec          54.5061
        Distance   1.215e+08  # method: V
        Radius     2.296e+04
        AbsMag        -19.25
        Axis    [  0.9164  -0.1739   0.3606]
        Angle     26.0004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4384"
}

Galaxy "NGC 4385:UGC 7515:MCG 0-32-9:MK 52"
{
        Type  "SBa"
        RA           12.4283
        Dec           0.5725
        Distance   1.127e+08  # method: V
        Radius     3.442e+04
        AbsMag        -19.79
        Axis    [  0.6333  -0.3412  -0.6947]
        Angle     45.1721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4385"
}

Galaxy "NGC 4386:UGC 7491:MCG 13-9-27:ZWG 352.33"
{
        Type  "S0"
        RA           12.4075
        Dec          75.5294
        Distance   8.819e+07  # method: S
        Radius     3.207e+04
        AbsMag        -19.46
        Axis    [ -0.0893   0.6934   0.7150]
        Angle     56.3222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4386"
}

Galaxy "NGC 4387:UGC 7517:MCG 2-32-39:ZWG 70.65"
{
        Type  "E0"
        RA           12.4281
        Dec          12.8103
        Distance   6.973e+07  # method: S
        Radius     1.724e+04
        AbsMag        -18.65
        Axis    [ -0.2217   0.2705  -0.9369]
        Angle     79.2018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4387"
}

Galaxy "NGC 4388:UGC 7520:MCG 2-32-41:ZWG 70.68"
{
        Type  "Sb"
        RA           12.4294
        Dec          12.6619
        Distance   6.514e+07  # method: T-F
        Radius     5.306e+04
        AbsMag         -19.7
        Axis    [  0.9368  -0.2119   0.2783]
        Angle     23.1892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4388"
}

Galaxy "NGC 4389:UGC 7514:MCG 8-23-28:ZWG 244.14"
{
        Type  "SBc"
        RA           12.4264
        Dec          45.6850
        Distance   4.227e+07  # method: V
        Radius     1.598e+04
        AbsMag        -17.76
        Axis    [  0.4892   0.2720   0.8286]
        Angle     24.6025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4389"
}

Galaxy "NGC 4390:IC 3320:UGC 7519:MCG 2-32-40"
{
        Type  "SBc"
        RA           12.4306
        Dec          10.4589
        Distance   6.496e+07  # method: V
        Radius     1.512e+04
        AbsMag         -18.1
        Axis    [  0.4322  -0.2838  -0.8560]
        Angle     37.7957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4390"
}

Galaxy "NGC 4391:UGC 7511:MCG 11-15-53:ZWG 315.37"
{
        Type  "S0"
        RA           12.4217
        Dec          64.9336
        Distance   7.824e+07  # method: S
        Radius     1.252e+04
        AbsMag         -18.2
        Axis    [  0.3696  -0.9292   0.0067]
        Angle    105.0784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4391"
}

Galaxy "NGC 4392:MCG 8-23-23:ZWG 244.12:ZW 35"
{
        Type  "E0"
        RA           12.4217
        Dec          45.8475
        Distance    3.02e+08  # distance uncertain!
        Radius     3.075e+04
        AbsMag        -20.13
        Axis    [  0.4648  -0.5607  -0.6852]
        Angle     56.8996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4392"
}

Galaxy "NGC 4393:UGC 7521:MCG 5-29-83:ZWG 158.104"
{
        Type  "SBc"
        RA           12.4308
        Dec          27.5619
        Distance   4.729e+07  # method: V
        Radius     2.201e+04
        AbsMag        -17.41
        Axis    [  0.6921  -0.6880  -0.2184]
        Angle    105.2085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4393"
}

Galaxy "NGC 4394:UGC 7523:MCG 3-32-35:ZWG 99.47"
{
        Type  "SBb"
        RA           12.4319
        Dec          18.2142
        Distance    5.59e+07  # method: V
        Radius     2.764e+04
        AbsMag        -19.47
        Axis    [ -0.3505   0.3650  -0.8625]
        Angle     54.5391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4394"
}

Galaxy "NGC 4395:UGC 7524:MCG 6-27-53:ZWG 187.42"
{
        Type  "Irr"
        RA           12.4300
        Dec          33.5467
        Distance    2.65e+07  # method: V
        Radius     5.088e+04
        AbsMag        -18.94
        Axis    [ -0.4861   0.7052  -0.5162]
        Angle     40.7288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4395"
}

Galaxy "NGC 4396:UGC 7526:MCG 3-32-34:ZWG 99.49"
{
        Type  "Sc"
        RA           12.4331
        Dec          15.6711
        Distance   8.743e+06  # method: V
        Radius          4196
        AbsMag        -14.04
        Axis    [ -0.8249   0.2361   0.5137]
        Angle     12.5226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4396"
}

Galaxy "NGC 4402:UGC 7528:MCG 2-32-44:ZWG 70.71"
{
        Type  "Sb"
        RA           12.4353
        Dec          13.1131
        Distance   2.541e+07  # method: V
        Radius     1.442e+04
        AbsMag        -16.86
        Axis    [  0.9482  -0.2219   0.2273]
        Angle     24.9455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4402"
}

Galaxy "NGC 4403:MCG 1-32-8:IRAS 12236-0724"
{
        Type  "Sb"
        RA           12.4367
        Dec          -7.6847
        Distance   2.511e+08  # method: V
        Radius     5.844e+04
        AbsMag        -20.63
        Axis    [  0.9657  -0.1392  -0.2193]
        Angle     88.3777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4403"
}

Galaxy "NGC 4404:MCG 1-32-9:NPM 1"
{
        Type  "S0"
        RA           12.4378
        Dec          -7.6803
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [ -0.6249   0.1321  -0.7694]
        Angle     66.8315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4404"
}

Galaxy "NGC 4405:IC 788:UGC 7529:MCG 3-32-36"
{
        Type  "Sa"
        RA           12.4353
        Dec          16.1811
        Distance   9.359e+07  # method: V
        Radius     2.178e+04
        AbsMag        -19.19
        Axis    [  0.8704  -0.4629  -0.1676]
        Angle     96.0606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4405"
}

Galaxy "M 86:NGC 4406:UGC 7532:MCG 2-32-46"
{
        Type  "E3"
        RA           12.4364
        Dec          12.9464
        Distance    5.59e+07  # method: S
        Radius     7.236e+04
        AbsMag        -21.27
        Axis    [ -0.1429   0.1678  -0.9754]
        Angle     76.8199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 86"
}

Galaxy "NGC 4408:ZWG 158.107"
{
        Type  "S0"
        RA           12.4381
        Dec          27.8711
        Distance   3.509e+08  # method: V
        Radius     4.083e+04
        AbsMag        -20.06
        Axis    [  0.8301  -0.5462  -0.1124]
        Angle     84.4162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4408"
}

Galaxy "NGC 4410-1:NGC 4410A:UGC 7535:MCG 2-32-47"
{
        Type  "Sb"
        RA           12.4411
        Dec           9.0197
        Distance    3.43e+08  # method: V
        Radius     2.494e+04
        AbsMag        -20.51
        Axis    [  0.8362  -0.4996  -0.2262]
        Angle    119.0425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4410-1"
}

Galaxy "NGC 4410-2:NGC 4410B:UGC 7535:MCG 2-32-47"
{
        Type  "Sc"
        RA           12.4414
        Dec           9.0189
        Distance   3.569e+08  # method: V
        Radius     2.596e+04
        AbsMag         -20.8
        Axis    [  0.5969  -0.7047  -0.3835]
        Angle    130.7325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4410-2"
}

Galaxy "NGC 4411-2:NGC 4411B:UGC 7546:MCG 2-32-55"
{
        Type  "Irr"
        RA           12.4464
        Dec           8.8844
        Distance   7.257e+07  # method: V
        Radius     2.639e+04
        AbsMag        -18.84
        Axis    [  0.5967  -0.7044  -0.3845]
        Angle    130.8447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4411-2"
}

Galaxy "NGC 4411A:NGC 4411-1:IC 3339:UGC 7537"
{
        Type  "Irr"
        RA           12.4417
        Dec           8.8717
        Distance   7.312e+07  # method: V
        Radius     2.127e+04
        AbsMag        -18.25
        Axis    [  0.6609  -0.5739  -0.4835]
        Angle     99.9676
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4411A"
}

Galaxy "NGC 4412:UGC 7536:MCG 1-32-62:ZWG 42.104"
{
        Type  "SBb"
        RA           12.4433
        Dec           3.9647
        Distance   1.193e+08  # method: V
        Radius     2.429e+04
        AbsMag        -19.62
        Axis    [ -0.3560   0.1083  -0.9282]
        Angle     51.5326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4412"
}

Galaxy "NGC 4413:NGC 4407:UGC 7538:MCG 2-32-49"
{
        Type  "SBb"
        RA           12.4422
        Dec          12.6103
        Distance   1.916e+07  # method: V
        Radius          6410
        AbsMag        -16.14
        Axis    [  0.8653  -0.3941  -0.3096]
        Angle     57.3544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4413"
}

Galaxy "NGC 4414:UGC 7539:MCG 5-29-85:ZWG 158.108"
{
        Type  "Sc"
        RA           12.4408
        Dec          31.2236
        Distance   6.954e+07  # method: T-F
        Radius      4.45e+04
        AbsMag        -20.64
        Axis    [ -0.7054   0.6733  -0.2217]
        Angle     43.1294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4414"
}

Galaxy "NGC 4415:UGC 7540:MCG 2-32-52:ZWG 70.78"
{
        Type  "Sa"
        RA           12.4444
        Dec           8.4361
        Distance   5.246e+07  # method: V
        Radius     1.068e+04
        AbsMag        -17.23
        Axis    [  0.8033  -0.5360  -0.2596]
        Angle    120.7242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4415"
}

Galaxy "NGC 4416:UGC 7541:MCG 1-32-63:MK 1326"
{
        Type  "SBc"
        RA           12.4461
        Dec           7.9189
        Distance   7.792e+07  # method: V
        Radius     1.927e+04
        AbsMag        -18.89
        Axis    [  0.0727  -0.1236  -0.9897]
        Angle     48.9654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4416"
}

Galaxy "NGC 4417:UGC 7542:MCG 2-32-53:ZWG 70.80"
{
        Type  "S0"
        RA           12.4472
        Dec           9.5844
        Distance   5.359e+07  # method: V
        Radius     2.572e+04
        AbsMag        -18.98
        Axis    [  0.9474  -0.2937  -0.1274]
        Angle     65.8535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4417"
}

Galaxy "NGC 4418:NGC 4355:UGC 7545:MCG 0-32-12"
{
        Type  "Sa"
        RA           12.4483
        Dec          -0.8778
        Distance   1.141e+08  # method: V
        Radius     2.489e+04
        AbsMag        -18.62
        Axis    [  0.8802  -0.2944  -0.3722]
        Angle     59.4021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4418"
}

Galaxy "NGC 4419:UGC 7551:MCG 3-32-38:ZWG 99.54"
{
        Type  "SBa"
        RA           12.4489
        Dec          15.0478
        Distance     4.4e+07  # method: S
        Radius     2.112e+04
        AbsMag        -18.55
        Axis    [ -0.9603   0.2690   0.0743]
        Angle     18.7175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4419"
}

Galaxy "NGC 4420:NGC 4409:UGC 7549:MCG 1-32-64"
{
        Type  "SBc"
        RA           12.4494
        Dec           2.4942
        Distance   7.466e+07  # method: T-F
        Radius     2.172e+04
        AbsMag           -19
        Axis    [  0.9425  -0.2863  -0.1725]
        Angle    108.0801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4420"
}

Galaxy "NGC 4421:UGC 7554:MCG 3-32-39:ZWG 99.55"
{
        Type  "SBa"
        RA           12.4506
        Dec          15.4608
        Distance   9.115e+07  # method: V
        Radius     3.579e+04
        AbsMag        -19.83
        Axis    [  0.8449  -0.4922  -0.2097]
        Angle     97.1899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4421"
}

Galaxy "NGC 4422:MCG 1-32-10:NPM 1"
{
        Type  "S0"
        RA           12.4533
        Dec          -5.8303
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.6275  -0.6273  -0.4613]
        Angle    139.3840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4422"
}

Galaxy "NGC 4423:UGC 7556:MCG 1-32-65:ZWG 42.107"
{
        Type  "Irr"
        RA           12.4525
        Dec           5.8803
        Distance   6.541e+07  # method: V
        Radius     2.188e+04
        AbsMag        -17.21
        Axis    [  0.9945  -0.1008   0.0301]
        Angle     96.1051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4423"
}

Galaxy "NGC 4424:UGC 7561:MCG 2-32-58:ZWG 70.90"
{
        Type  "SBa"
        RA           12.4531
        Dec           9.4214
        Distance   3.488e+07  # method: V
        Radius     1.776e+04
        AbsMag        -17.84
        Axis    [  0.7590  -0.3486  -0.5500]
        Angle     23.2574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4424"
}

Galaxy "NGC 4425:UGC 7562:MCG 2-32-59:ZWG 70.91"
{
        Type  "SBa"
        RA           12.4536
        Dec          12.7347
        Distance       1e+08  # method: V
        Radius     4.073e+04
        AbsMag        -19.63
        Axis    [  0.9657  -0.2592  -0.0110]
        Angle     87.3391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4425"
}

Galaxy "NGC 4428-1:MCG 1-32-12:IRAS 12248-0753"
{
        Type  "SBc"
        RA           12.4578
        Dec          -8.1681
        Distance   1.511e+08  # method: V
        Radius     3.737e+04
        AbsMag        -19.83
        Axis    [  0.7485  -0.3066  -0.5880]
        Angle     43.2855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4428-1"
}

Galaxy "NGC 4428-2:MCG 1-32-12"
{
        Type  "Sc"
        RA           12.4583
        Dec          -8.1650
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.6311  -0.6150  -0.4728]
        Angle    140.8041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4428-2"
}

Galaxy "NGC 4429:UGC 7568:MCG 2-32-61:ZWG 70.93"
{
        Type  "Sa"
        RA           12.4572
        Dec          11.1075
        Distance   6.637e+07  # method: V
        Radius     5.598e+04
        AbsMag        -20.44
        Axis    [  0.7412  -0.3430  -0.5771]
        Angle     18.8931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4429"
}

Galaxy "NGC 4430:UGC 7566:MCG 1-32-67:ZWG 42.111"
{
        Type  "SBb"
        RA           12.4572
        Dec           6.2628
        Distance   8.059e+07  # method: V
        Radius     2.696e+04
        AbsMag        -19.36
        Axis    [  0.6672  -0.4789  -0.5705]
        Angle     79.2270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4430"
}

Galaxy "NGC 4431:UGC 7569:MCG 2-32-62:ZWG 70.94"
{
        Type  "S0"
        RA           12.4575
        Dec          12.2906
        Distance   5.101e+07  # method: V
        Radius     1.261e+04
        AbsMag        -17.07
        Axis    [ -0.9045   0.3586  -0.2307]
        Angle     64.6146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4431"
}

Galaxy "NGC 4432:UGC 7570:MCG 1-32-68:ZWG 42.114"
{
        Type  "SBc"
        RA           12.4592
        Dec           6.2333
        Distance   3.053e+08  # method: V
        Radius     3.996e+04
        AbsMag        -20.06
        Axis    [  0.8428  -0.4703  -0.2616]
        Angle    113.9634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4432"
}

Galaxy "NGC 4433:MCG 1-32-13:IRAS 12250-0800"
{
        Type  "SBb"
        RA           12.4606
        Dec          -8.2792
        Distance   1.514e+08  # method: V
        Radius     4.843e+04
        AbsMag        -19.83
        Axis    [  0.9591  -0.1731  -0.2238]
        Angle    111.4258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4433"
}

Galaxy "NGC 4434:UGC 7571:MCG 1-32-69:ZWG 42.115"
{
        Type  "E0"
        RA           12.4600
        Dec           8.1544
        Distance   8.739e+07  # method: S
        Radius     1.779e+04
        AbsMag        -19.24
        Axis    [  0.5759  -0.7136  -0.3989]
        Angle    132.5351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4434"
}

Galaxy "NGC 4435:UGC 7575:MCG 2-32-64:ZWG 70.98"
{
        Type  "S0"
        RA           12.4611
        Dec          13.0797
        Distance    5.01e+07  # method: V
        Radius     2.186e+04
        AbsMag        -19.13
        Axis    [  0.8535  -0.4792  -0.2045]
        Angle    104.4336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4435"
}

Galaxy "NGC 4436:UGC 7573:MCG 2-32-66:ZWG 70.96"
{
        Type  "S0"
        RA           12.4614
        Dec          12.3158
        Distance   7.475e+07  # method: V
        Radius     1.631e+04
        AbsMag         -17.7
        Axis    [ -0.0809  -0.0761  -0.9938]
        Angle     13.3400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4436"
}

Galaxy "NGC 4438:UGC 7574:MCG 2-32-65:ZWG 70.97"
{
        Type  "Sa"
        RA           12.4625
        Dec          13.0086
        Distance   1.762e+07  # method: V
        Radius     2.179e+04
        AbsMag        -17.76
        Axis    [  0.9658  -0.2592  -0.0055]
        Angle     87.3693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4438"
}

Galaxy "NGC 4440:UGC 7581:MCG 2-32-67:ZWG 70.99"
{
        Type  "SBa"
        RA           12.4647
        Dec          12.2933
        Distance   4.811e+07  # method: V
        Radius      1.26e+04
        AbsMag        -18.04
        Axis    [  0.7699  -0.5813  -0.2632]
        Angle    117.7539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4440"
}

Galaxy "NGC 4441:UGC 7572:MCG 11-15-56:ZWG 315.39"
{
        Type  "SBa"
        RA           12.4556
        Dec          64.8022
        Distance   6.215e+07  # method: S
        Radius     2.893e+04
        AbsMag           -18
        Axis    [  0.6512  -0.7095   0.2694]
        Angle    102.1313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4441"
}

Galaxy "NGC 4442:UGC 7583:MCG 2-32-68:ZWG 70.100"
{
        Type  "S0"
        RA           12.4675
        Dec           9.8039
        Distance   3.896e+07  # method: V
        Radius      2.55e+04
        AbsMag        -18.98
        Axis    [  0.9165  -0.3294  -0.2270]
        Angle     28.1435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4442"
}

Galaxy "NGC 4444:ESO 268-10:MCG 7-26-7:DCL 56"
{
        Type  "SBc"
        RA           12.4767
        Dec         -43.2622
        Distance   1.444e+08  # method: V
        Radius      5.25e+04
        AbsMag        -20.23
        Axis    [ -0.2191  -0.1885  -0.9573]
        Angle    102.2893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4444"
}

Galaxy "NGC 4445:IC 793:UGC 7587:MCG 2.32"
{
        Type  "Sb"
        RA           12.4711
        Dec           9.4367
        Distance   3.126e+07  # method: V
        Radius     1.182e+04
        AbsMag        -16.21
        Axis    [  0.5616  -0.2430   0.7909]
        Angle     14.2366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4445"
}

Galaxy "NGC 4446:UGC 7586:MCG 2-32-69:ZWG 70.103"
{
        Type  "Sc"
        RA           12.4683
        Dec          13.9122
        Distance   3.461e+08  # method: V
        Radius     5.536e+04
        AbsMag        -20.63
        Axis    [  0.1837  -0.1459  -0.9721]
        Angle     36.5432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4446"
}

Galaxy "NGC 4447:MCG 2-32-73:ZWG 70.107:VCC 1085"
{
        Type  "S0"
        RA           12.4700
        Dec          13.8997
        Distance   3.374e+08  # method: V
        Radius     4.416e+04
        AbsMag        -20.07
        Axis    [  0.2343  -0.1708  -0.9570]
        Angle     32.9709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4447"
}

Galaxy "NGC 4448:UGC 7591:MCG 5-29-89:ZWG 158.113"
{
        Type  "SBb"
        RA           12.4708
        Dec          28.6214
        Distance   4.417e+07  # method: V
        Radius     2.505e+04
        AbsMag        -18.66
        Axis    [  0.8016  -0.1011   0.5892]
        Angle     25.4950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4448"
}

Galaxy "NGC 4449:UGC 7592:MCG 7-26-9:ZWG 216.5"
{
        Type  "Irr"
        RA           12.4697
        Dec          44.0950
        Distance   1.907e+07  # method: V
        Radius      1.72e+04
        AbsMag        -18.83
        Axis    [  0.8255  -0.5498   0.1276]
        Angle     67.8936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4449"
}

Galaxy "NGC 4450:UGC 7594:MCG 3-32-48:ZWG 99.62"
{
        Type  "Sb"
        RA           12.4747
        Dec          17.0842
        Distance   6.532e+07  # method: T-F
        Radius     5.131e+04
        AbsMag        -20.61
        Axis    [ -0.7840   0.4960  -0.3734]
        Angle     65.8570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4450"
}

Galaxy "NGC 4451:UGC 7600:MCG 2-32-79:ZWG 70.111"
{
        Type  "Sb"
        RA           12.4778
        Dec           9.2589
        Distance   5.413e+07  # method: V
        Radius     1.181e+04
        AbsMag         -17.7
        Axis    [ -0.8840   0.2981  -0.3600]
        Angle     51.4350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4451"
}

Galaxy "NGC 4452:UGC 7601:MCG 2-32-80:ZWG 70.112"
{
        Type  "S0"
        RA           12.4786
        Dec          11.7550
        Distance   2.152e+07  # method: V
        Radius          8450
        AbsMag         -16.2
        Axis    [  0.9829  -0.1588   0.0931]
        Angle     82.8355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4452"
}

Galaxy "NGC 4453:MCG 1-32-73:ZWG 42.121:VCC 1130"
{
        Type  "Sb"
        RA           12.4794
        Dec           6.5122
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [ -0.9747   0.1315  -0.1805]
        Angle     39.6927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4453"
}

Galaxy "NGC 4454:UGC 7606:MCG 0-32-14:ZWG 14.48"
{
        Type  "SBa"
        RA           12.4806
        Dec          -1.9389
        Distance   1.245e+08  # method: V
        Radius     4.164e+04
        AbsMag        -20.11
        Axis    [  0.1234  -0.2186  -0.9680]
        Angle     63.8414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4454"
}

Galaxy "NGC 4455:UGC 7603:MCG 4-30-1:ZWG 129.2"
{
        Type  "SBc"
        RA           12.4789
        Dec          22.8211
        Distance   4.236e+07  # method: T-F
        Radius     1.602e+04
        AbsMag        -17.47
        Axis    [  0.9540  -0.2746   0.1204]
        Angle     99.2727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4455"
}

Galaxy "NGC 4456:ESO 441-30:IRAS 12252-2949"
{
        Type  "Sc"
        RA           12.4644
        Dec         -30.0978
        Distance   2.969e+08  # method: V
        Radius     5.182e+04
        AbsMag         -20.7
        Axis    [ -0.6888  -0.2760  -0.6703]
        Angle     62.3307
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4456"
}

Galaxy "NGC 4457:UGC 7609:MCG 1-32-75:ZWG 42.124"
{
        Type  "SBa"
        RA           12.4828
        Dec           3.5711
        Distance   5.513e+07  # method: V
        Radius     2.085e+04
        AbsMag        -19.44
        Axis    [  0.5478  -0.4312  -0.7169]
        Angle     71.6377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4457"
}

Galaxy "NGC 4458:UGC 7610:MCG 2-32-82:ZWG 70.114"
{
        Type  "E0"
        RA           12.4825
        Dec          13.2422
        Distance   5.616e+07  # method: S
        Radius     1.307e+04
        AbsMag        -18.38
        Axis    [  0.4462  -0.6006  -0.6635]
        Angle     99.1598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4458"
}

Galaxy "NGC 4459:UGC 7614:MCG 2-32-83:ZWG 70.116"
{
        Type  "Sa"
        RA           12.4833
        Dec          13.9786
        Distance   5.266e+07  # method: S
        Radius      2.68e+04
        AbsMag        -19.74
        Axis    [  0.1083  -0.1006  -0.9890]
        Angle     31.1767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4459"
}

Galaxy "NGC 4460:UGC 7611:MCG 8-23-41:ZWG 244.22"
{
        Type  "SBa"
        RA           12.4792
        Dec          44.8644
        Distance   3.129e+07  # method: S
        Radius     1.912e+04
        AbsMag        -17.61
        Axis    [  0.8469  -0.3020   0.4377]
        Angle     81.7831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4460"
}

Galaxy "NGC 4461:NGC 4443:UGC 7613:MCG 2-32-84"
{
        Type  "SBa"
        RA           12.4839
        Dec          13.1844
        Distance   1.015e+08  # method: V
        Radius      5.02e+04
        AbsMag        -20.46
        Axis    [  0.9545  -0.2962  -0.0349]
        Angle    105.5335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4461"
}

Galaxy "NGC 4462:ESO 506-13:MCG 4-30-2:AM 1226-225"
{
        Type  "SBb"
        RA           12.4892
        Dec         -23.1664
        Distance   9.767e+07  # method: V
        Radius     4.404e+04
        AbsMag        -19.58
        Axis    [ -0.3742  -0.4246  -0.8244]
        Angle     37.7013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4462"
}

Galaxy "NGC 4464:UGC 7619:MCG 1-32-78:ZWG 42.128"
{
        Type  "Sb"
        RA           12.4892
        Dec           8.1569
        Distance   7.189e+07  # method: V
        Radius          9411
        AbsMag        -18.12
        Axis    [ -0.7890   0.3780  -0.4844]
        Angle     65.8587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4464"
}

Galaxy "NGC 4465:ZWG 42.127:VCC 1182"
{
        Type  "Sc"
        RA           12.4897
        Dec           8.0261
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.5644  -0.3447  -0.7501]
        Angle     29.7769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4465"
}

Galaxy "NGC 4466:UGC 7626:MCG 1-32-81:ZWG 42.131"
{
        Type  "Sb"
        RA           12.4917
        Dec           7.6969
        Distance   4.951e+07  # method: V
        Radius          7922
        AbsMag        -16.11
        Axis    [  0.9051  -0.4076   0.1208]
        Angle     13.8378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4466"
}

Galaxy "NGC 4467:MCG 1-32-80:ZWG 42.130:ARAK 369"
{
        Type  "E2"
        RA           12.4917
        Dec           7.9928
        Distance   8.181e+07  # method: V
        Radius          4760
        AbsMag           -17
        Axis    [  0.4394  -0.5765  -0.6889]
        Angle    103.3514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4467"
}

Galaxy "NGC 4468:UGC 7628:MCG 2-32-90:ZWG 70.122"
{
        Type  "S0"
        RA           12.4917
        Dec          14.0492
        Distance   5.169e+07  # method: S
        Radius     1.053e+04
        AbsMag         -17.3
        Axis    [  0.6738  -0.4403  -0.5933]
        Angle     52.2258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4468"
}

Galaxy "NGC 4469:UGC 7622:MCG 2-32-89:ZWG 70.121"
{
        Type  "SBa"
        RA           12.4911
        Dec           8.7503
        Distance   4.109e+07  # method: V
        Radius     2.271e+04
        AbsMag         -18.1
        Axis    [  0.9367  -0.3279  -0.1226]
        Angle     25.6957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4469"
}

Galaxy "NGC 4470:NGC 4610:UGC 7627:MCG 1-32-82"
{
        Type  "Sa"
        RA           12.4936
        Dec           7.8239
        Distance   1.211e+08  # method: V
        Radius      2.29e+04
        AbsMag        -19.75
        Axis    [  0.8821  -0.4306  -0.1910]
        Angle    117.6164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4470"
}

Galaxy "M 49:NGC 4472:UGC 7629:MCG 1-32-83"
{
        Type  "E2"
        RA           12.4961
        Dec           8.0000
        Distance   5.314e+07  # method: S
        Radius     7.884e+04
        AbsMag        -21.76
        Axis    [ -0.3568   0.3613  -0.8615]
        Angle     86.8220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 49"
}

Galaxy "NGC 4473:UGC 7631:MCG 2-32-93:ZWG 70.125"
{
        Type  "E5"
        RA           12.4967
        Dec          13.4297
        Distance   5.122e+07  # method: S
        Radius     3.352e+04
        AbsMag        -19.78
        Axis    [  0.1582  -0.2374  -0.9584]
        Angle     77.3360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4473"
}

Galaxy "NGC 4474:UGC 7634:MCG 2-32-94:ZWG 70.127"
{
        Type  "S0"
        RA           12.4981
        Dec          14.0686
        Distance   8.612e+07  # method: V
        Radius     3.006e+04
        AbsMag        -19.61
        Axis    [  0.7499  -0.4058  -0.5224]
        Angle     40.7369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4474"
}

Galaxy "NGC 4475:UGC 7632:MCG 5-30-8:ZWG 159.8"
{
        Type  "SBc"
        RA           12.4964
        Dec          27.2433
        Distance   3.627e+08  # method: T-F
        Radius     8.969e+04
        AbsMag        -20.93
        Axis    [  0.8989  -0.4360   0.0434]
        Angle    109.2528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4475"
}

Galaxy "NGC 4476:UGC 7637:MCG 2-32-96:ZWG 70.128"
{
        Type  "S0"
        RA           12.4997
        Dec          12.3486
        Distance   5.616e+07  # method: S
        Radius      1.47e+04
        AbsMag        -18.18
        Axis    [  0.8459  -0.4712  -0.2496]
        Angle     93.2557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4476"
}

Galaxy "NGC 4477:UGC 7638:MCG 2-32-97:ZWG 70.129"
{
        Type  "S0"
        RA           12.5006
        Dec          13.6369
        Distance   7.565e+07  # method: V
        Radius     4.071e+04
        AbsMag        -20.43
        Axis    [  0.7558  -0.5903  -0.2834]
        Angle    112.2158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4477"
}

Galaxy "NGC 4478:UGC 7645:MCG 2-32-99:ZWG 70.133"
{
        Type  "E2"
        RA           12.5047
        Dec          12.3286
        Distance   5.908e+07  # method: S
        Radius     1.547e+04
        AbsMag        -18.89
        Axis    [ -0.2333   0.2588  -0.9374]
        Angle     78.8680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4478"
}

Galaxy "NGC 4479:UGC 7646:MCG 2-32-100:ZWG 70.134"
{
        Type  "S0"
        RA           12.5050
        Dec          13.5781
        Distance   5.182e+07  # method: V
        Radius     1.206e+04
        AbsMag         -17.5
        Axis    [  0.7951  -0.5294  -0.2959]
        Angle     96.0894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4479"
}

Galaxy "NGC 4480:UGC 7647:MCG 1-32-87:ZWG 42.139"
{
        Type  "SBc"
        RA           12.5072
        Dec           4.2458
        Distance    1.26e+08  # method: V
        Radius     4.031e+04
        AbsMag        -19.83
        Axis    [ -0.9574   0.1940  -0.2138]
        Angle     62.6997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4480"
}

Galaxy "NGC 4481:MCG 11-15-57:ZWG 315.40"
{
        Type  "S0"
        RA           12.4967
        Dec          64.0333
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.3649   0.7184   0.5922]
        Angle     57.6312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4481"
}

Galaxy "NGC 4482:IC 3427:UGC 7640:MCG 2-32-98"
{
        Type  "E0"
        RA           12.5028
        Dec          10.7792
        Distance   9.839e+07  # method: V
        Radius     2.433e+04
        AbsMag         -18.7
        Axis    [ -0.2771   0.2956  -0.9143]
        Angle     81.4610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4482"
}

Galaxy "NGC 4483:UGC 7649:MCG 2-32-103:ZWG 70.136"
{
        Type  "SBa"
        RA           12.5111
        Dec           9.0156
        Distance   5.323e+07  # method: V
        Radius     1.239e+04
        AbsMag        -18.56
        Axis    [  0.8932  -0.3565  -0.2742]
        Angle     51.5755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4483"
}

Galaxy "NGC 4484:MCG 2-32-13:IRAS 12262-1122"
{
        Type  "Sc"
        RA           12.4811
        Dec         -11.6517
        Distance   2.424e+08  # method: V
        Radius     5.288e+04
        AbsMag        -20.06
        Axis    [  0.6345  -0.5974  -0.4904]
        Angle    143.0216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4484"
}

Galaxy "NGC 4485:UGC 7648:MCG 7-26-13:ZWG 216.7"
{
        Type  "Irr"
        RA           12.5086
        Dec          41.7008
        Distance   3.284e+07  # method: V
        Radius     1.146e+04
        AbsMag        -17.71
        Axis    [  0.7808  -0.6217   0.0623]
        Angle     97.7113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4485"
}

Galaxy "M 87:NGC 4486:UGC 7654:MCG 2-32-105"
{
        Type  "E0"
        RA           12.5136
        Dec          12.3906
        Distance   5.241e+07  # method: S
        Radius     6.327e+04
        AbsMag        -21.43
        Axis    [ -0.4188   0.5047  -0.7549]
        Angle     90.4475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 87"
}

Galaxy "NGC 4486A:UGC 7658:MCG 2-32-110:ZWG 70.141"
{
        Type  "E2"
        RA           12.5158
        Dec          12.2711
        Distance   1.738e+08  # distance uncertain!
        Radius     2.022e+04
        AbsMag        -20.13
        Axis    [  0.5524  -0.7300  -0.4024]
        Angle    127.6908
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4486A"
}

Galaxy "NGC 4486B:MCG 2-32-101:UGCA 283:ZW 38"
{
        Type  "E0"
        RA           12.5089
        Dec          12.4906
        Distance   8.299e+07  # method: V
        Radius          7242
        AbsMag        -17.63
        Axis    [  0.5594  -0.7383  -0.3768]
        Angle    130.4487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4486B"
}

Galaxy "NGC 4487:MCG 1-32-21:IRAS 12285-0746"
{
        Type  "SBc"
        RA           12.5178
        Dec          -8.0536
        Distance   6.247e+07  # method: V
        Radius     3.634e+04
        AbsMag        -19.71
        Axis    [  0.5488  -0.3531  -0.7577]
        Angle     60.9906
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4487"
}

Galaxy "NGC 4488:UGC 7653:MCG 2-32-104:ZWG 70.137"
{
        Type  "SBa"
        RA           12.5142
        Dec           8.3597
        Distance   5.984e+07  # method: V
        Radius     3.569e+04
        AbsMag        -18.32
        Axis    [ -0.9758   0.2018  -0.0846]
        Angle     61.9606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4488"
}

Galaxy "NGC 4489:UGC 7655:MCG 3-32-54:ZWG 99.73"
{
        Type  "E0"
        RA           12.5144
        Dec          16.7592
        Distance   5.827e+07  # method: S
        Radius     1.441e+04
        AbsMag        -18.36
        Axis    [ -0.3686   0.5074  -0.7789]
        Angle     85.5011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4489"
}

Galaxy "NGC 4490:UGC 7651:MCG 7-26-14:ZWG 216.8"
{
        Type  "SBc"
        RA           12.5100
        Dec          41.6428
        Distance   3.665e+07  # method: V
        Radius     3.411e+04
        AbsMag        -20.05
        Axis    [ -0.2261   0.6876   0.6900]
        Angle     21.9809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4490"
}

Galaxy "NGC 4491:UGC 7657:MCG 2-32-107:ZWG 70.140"
{
        Type  "SBa"
        RA           12.5158
        Dec          11.4833
        Distance   3.416e+07  # method: V
        Radius          7949
        AbsMag         -16.6
        Axis    [ -0.9228   0.2519  -0.2916]
        Angle     35.1446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4491"
}

Galaxy "NGC 4492:IC 3438:UGC 7656:MCG 1-32-89"
{
        Type  "Sa"
        RA           12.5164
        Dec           8.0781
        Distance   9.509e+07  # method: V
        Radius     2.351e+04
        AbsMag        -19.02
        Axis    [  0.2807  -0.3058  -0.9098]
        Angle     61.8025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4492"
}

Galaxy "NGC 4493-1:MCG 0-32-17:ZWG 14.56:NPM 1"
{
        Type  "E0"
        RA           12.5189
        Dec           0.6142
        Distance   3.631e+08  # distance uncertain!
        Radius     5.281e+04
        AbsMag        -20.13
        Axis    [ -0.4479   0.3697  -0.8141]
        Angle     94.8473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4493-1"
}

Galaxy "NGC 4493-2:MCG 0-32-17:ZWG 14.56:NPM 1"
{
        Type  "E0"
        RA           12.5197
        Dec           0.6067
        Distance   7.586e+08  # distance uncertain!
        Radius     4.414e+04
        AbsMag        -20.13
        Axis    [  0.5879  -0.6786  -0.4403]
        Angle    137.3515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4493-2"
}

Galaxy "NGC 4494:UGC 7662:MCG 4-30-2:ZWG 129.5"
{
        Type  "E1"
        RA           12.5233
        Dec          25.7753
        Distance   5.565e+07  # method: S
        Radius     3.885e+04
        AbsMag        -20.46
        Axis    [ -0.3372   0.6217  -0.7070]
        Angle     84.2620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4494"
}

Galaxy "NGC 4495:UGC 7663:MCG 5-30-12:ZWG 159.9"
{
        Type  "Sb"
        RA           12.5228
        Dec          29.1367
        Distance   2.188e+08  # method: V
        Radius     4.454e+04
        AbsMag        -20.03
        Axis    [ -0.6825   0.7281  -0.0636]
        Angle     16.5440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4495"
}

Galaxy "NGC 4496:NGC 4496A:NGC 4505:UGC 7668"
{
        Type  "SBc"
        RA           12.5275
        Dec           3.9397
        Distance   9.373e+07  # method: V
        Radius     5.317e+04
        AbsMag        -20.39
        Axis    [  0.6036  -0.4184  -0.6787]
        Angle     61.8309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4496"
}

Galaxy "NGC 4496B:ZWG 42.144:KCPG 343B:VV 76"
{
        Type  "Irr"
        RA           12.5278
        Dec           3.9267
        Distance   2.211e+08  # method: V
        Radius     2.573e+04
        AbsMag        -19.66
        Axis    [  0.2113  -0.2592  -0.9424]
        Angle     40.5159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4496B"
}

Galaxy "NGC 4497:IC 3452:UGC 7665:MCG 2-32-113"
{
        Type  "SBa"
        RA           12.5256
        Dec          11.6250
        Distance   7.633e+07  # method: V
        Radius     2.109e+04
        AbsMag        -18.45
        Axis    [  0.9373  -0.3261  -0.1229]
        Angle     49.9922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4497"
}

Galaxy "NGC 4498:UGC 7669:MCG 3-32-56:ZWG 99.75"
{
        Type  "SBc"
        RA           12.5275
        Dec          16.8528
        Distance   5.645e+07  # method: T-F
        Radius     2.381e+04
        AbsMag        -18.59
        Axis    [ -0.9513   0.2800   0.1294]
        Angle     18.4941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4498"
}

Galaxy "NGC 4499:ESO 322-22:MCG 7-26-8:DCL 63"
{
        Type  "SBc"
        RA           12.5344
        Dec         -39.9825
        Distance   1.818e+08  # method: V
        Radius     4.759e+04
        AbsMag        -20.13
        Axis    [  0.1247  -0.2784  -0.9524]
        Angle     82.6226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4499"
}

Galaxy "NGC 4500:UGC 7667:MCG 10-18-62:MK 213"
{
        Type  "SBa"
        RA           12.5228
        Dec          57.9650
        Distance   1.479e+08  # method: V
        Radius     3.441e+04
        AbsMag        -20.08
        Axis    [ -0.0756   0.8679   0.4910]
        Angle     29.7306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4500"
}

Galaxy "M 88:NGC 4501:UGC 7675:MCG 3-32-59"
{
        Type  "Sb"
        RA           12.5331
        Dec          14.4197
        Distance   8.122e+07  # method: T-F
        Radius     8.033e+04
        AbsMag        -21.78
        Axis    [ -0.8646   0.2997  -0.4033]
        Angle     27.7819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 88"
}

Galaxy "NGC 4502:UGC 7677:MCG 3-32-60:ZWG 99.78"
{
        Type  "SBc"
        RA           12.5342
        Dec          16.6881
        Distance   8.793e+07  # method: V
        Radius     1.407e+04
        AbsMag        -17.45
        Axis    [  0.9101  -0.3983  -0.1146]
        Angle     75.2747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4502"
}

Galaxy "NGC 4503:UGC 7680:MCG 2-32-118:ZWG 70.149"
{
        Type  "S0"
        RA           12.5350
        Dec          11.1756
        Distance   7.656e+07  # method: V
        Radius     3.897e+04
        AbsMag        -19.75
        Axis    [  0.9367  -0.3366  -0.0964]
        Angle    103.2105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4503"
}

Galaxy "NGC 4504:MCG 1-32-22:IRAS 12296-0717"
{
        Type  "SBc"
        RA           12.5381
        Dec          -7.5633
        Distance   6.075e+07  # method: V
        Radius     2.827e+04
        AbsMag        -17.45
        Axis    [ -0.7476   0.0501  -0.6622]
        Angle     56.4734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4504"
}

Galaxy "NGC 4506:UGC 7682:MCG 2-32-120:ZWG 70.152"
{
        Type  "SBa"
        RA           12.5361
        Dec          13.4203
        Distance   4.793e+07  # method: V
        Radius     1.115e+04
        AbsMag        -17.14
        Axis    [  0.1356  -0.1572  -0.9782]
        Angle     24.2604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4506"
}

Galaxy "NGC 4507:ESO 322-29:MCG 7-26-11:TOL 97"
{
        Type  "SBb"
        RA           12.5933
        Dec         -39.9092
        Distance   1.713e+08  # method: V
        Radius     3.987e+04
        AbsMag         -20.8
        Axis    [  0.4642  -0.2764  -0.8415]
        Angle    105.1805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4507"
}

Galaxy "NGC 4509:UGC 7704:MCG 5-30-18:MK 773"
{
        Type  "Sb"
        RA           12.5517
        Dec          32.0922
        Distance   5.427e+07  # method: V
        Radius          6315
        AbsMag        -16.91
        Axis    [ -0.7518   0.6538  -0.0861]
        Angle     41.3347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4509"
}

Galaxy "NGC 4510:UGC 7679:MCG 11-15-58:ZWG 315.41"
{
        Type  "E0"
        RA           12.5297
        Dec          64.2339
        Distance   1.289e+08  # method: V
        Radius     2.813e+04
        AbsMag        -18.98
        Axis    [  0.1002   0.8281  -0.5516]
        Angle     58.4451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4510"
}

Galaxy "NGC 4511:MCG 10-18-63:ZWG 293.27:SBS 1229+567"
{
        Type  "Sc"
        RA           12.5353
        Dec          56.4711
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.7939  -0.5016   0.3436]
        Angle    109.7789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4511"
}

Galaxy "NGC 4513:UGC 7683:MCG 11-15-59:ZWG 315.42"
{
        Type  "S0"
        RA           12.5336
        Dec          66.3331
        Distance   1.074e+08  # method: V
        Radius     2.187e+04
        AbsMag        -18.59
        Axis    [  0.7128  -0.5744   0.4025]
        Angle    103.3916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4513"
}

Galaxy "NGC 4514:UGC 7693:MCG 5-30-15:ZWG 159.11"
{
        Type  "Sc"
        RA           12.5450
        Dec          29.7122
        Distance   3.789e+08  # method: V
        Radius     6.614e+04
        AbsMag        -21.23
        Axis    [  0.6786  -0.6274  -0.3820]
        Angle     69.3120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4514"
}

Galaxy "NGC 4515:UGC 7701:MCG 3-32-65:ZWG 99.86"
{
        Type  "S0"
        RA           12.5511
        Dec          16.2656
        Distance   5.685e+07  # method: V
        Radius     1.158e+04
        AbsMag        -17.81
        Axis    [  0.8190  -0.5389  -0.1972]
        Angle    108.8488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4515"
}

Galaxy "NGC 4516:UGC 7703:MCG 3-32-67:ZWG 99.87"
{
        Type  "SBb"
        RA           12.5519
        Dec          14.5747
        Distance   5.785e+07  # method: V
        Radius     1.514e+04
        AbsMag        -17.94
        Axis    [  0.9302  -0.3622  -0.0598]
        Angle    115.0434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4516"
}

Galaxy "NGC 4517:NGC 4437:UGC 7694:MCG 0-32-20"
{
        Type  "Sc"
        RA           12.5458
        Dec           0.1156
        Distance   6.614e+07  # method: V
        Radius      1.01e+05
        AbsMag        -20.33
        Axis    [  0.9648  -0.2597   0.0413]
        Angle     31.5042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4517"
}

Galaxy "NGC 4517A:UGC 7685:MCG 0-32-19:ZWG 14.62"
{
        Type  "Irr"
        RA           12.5411
        Dec           0.3903
        Distance   9.074e+07  # method: T-F
        Radius     5.279e+04
        AbsMag        -19.62
        Axis    [  0.8564  -0.3802  -0.3494]
        Angle     90.8609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4517A"
}

Galaxy "NGC 4518:NGC 4518A:MCG 1-32-95:ZWG 42.150"
{
        Type  "S0"
        RA           12.5531
        Dec           7.8522
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.9812   0.1818  -0.0643]
        Angle     62.8169
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4518"
}

Galaxy "NGC 4518B:MCG 1-32-94:ZWG 42.149:VCC 1480"
{
        Type  "Sb"
        RA           12.5528
        Dec           7.8344
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.9669  -0.2474  -0.0627]
        Angle     78.6329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4518B"
}

Galaxy "NGC 4519:UGC 7709:MCG 2-32-135:ZWG 70.167"
{
        Type  "SBc"
        RA           12.5583
        Dec           8.6550
        Distance   1.255e+08  # method: T-F
        Radius      5.84e+04
        AbsMag        -20.62
        Axis    [ -0.6268   0.2508  -0.7377]
        Angle     46.2810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4519"
}

Galaxy "NGC 4519A:MCG 2-32-134:ZWG 70.165:VCC 1501"
{
        Type  "S0"
        RA           12.5567
        Dec           8.6906
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [  0.9639  -0.2606  -0.0550]
        Angle     67.6589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4519A"
}

Galaxy "NGC 4520:IC 799:NPM 1"
{
        Type  "S0"
        RA           12.5636
        Dec          -7.3747
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.1750  -0.3521  -0.9195]
        Angle     35.1565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4520"
}

Galaxy "NGC 4521:NGC 4512:UGC 7706:MCG 11-15-61"
{
        Type  "Sa"
        RA           12.5464
        Dec          63.9394
        Distance    1.38e+08  # method: V
        Radius     5.019e+04
        AbsMag        -20.03
        Axis    [ -0.5388   0.6190   0.5714]
        Angle     76.0362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4521"
}

Galaxy "NGC 4522:UGC 7711:MCG 2-32-137:ZWG 70.168"
{
        Type  "SBc"
        RA           12.5608
        Dec           9.1742
        Distance    6.22e+07  # method: T-F
        Radius     3.257e+04
        AbsMag         -18.6
        Axis    [  0.9768  -0.2141   0.0002]
        Angle     81.5448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4522"
}

Galaxy "NGC 4523:UGC 7713:MCG 3-32-68:DDO 135"
{
        Type  "Irr"
        RA           12.5633
        Dec          15.1683
        Distance   2.614e+07  # method: V
        Radius          7223
        AbsMag        -15.42
        Axis    [  0.6134  -0.5854  -0.5301]
        Angle     84.8717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4523"
}

Galaxy "NGC 4524:MCG 2-32-14:IRAS 12312-1145"
{
        Type  "Sc"
        RA           12.5650
        Dec         -12.0272
        Distance   2.348e+08  # method: V
        Radius      4.44e+04
        AbsMag        -19.79
        Axis    [  0.5178  -0.3462  -0.7823]
        Angle     55.6327
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4524"
}

Galaxy "NGC 4525:UGC 7714:MCG 5-30-20:ZWG 159.16"
{
        Type  "SBc"
        RA           12.5642
        Dec          30.2775
        Distance   6.365e+07  # method: V
        Radius     2.407e+04
        AbsMag        -18.55
        Axis    [  0.9065  -0.4015   0.1303]
        Angle     62.0940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4525"
}

Galaxy "NGC 4526:NGC 4560:UGC 7718:MCG 1-32-100"
{
        Type  "S0"
        RA           12.5672
        Dec           7.6989
        Distance   5.514e+07  # method: S
        Radius     5.614e+04
        AbsMag        -20.54
        Axis    [  0.0616  -0.7586  -0.6486]
        Angle      6.4084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4526"
}

Galaxy "NGC 4527:UGC 7721:MCG 1-32-101:ZWG 42.156"
{
        Type  "SBc"
        RA           12.5689
        Dec           2.6533
        Distance   9.377e+07  # method: V
        Radius     8.456e+04
        AbsMag        -20.99
        Axis    [  0.9357  -0.2907  -0.2001]
        Angle     48.3924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4527"
}

Galaxy "NGC 4528:UGC 7722:MCG 2-32-140:ZWG 70.172"
{
        Type  "S0"
        RA           12.5683
        Dec          11.3211
        Distance   7.683e+07  # method: V
        Radius     1.788e+04
        AbsMag        -18.96
        Axis    [  0.8953  -0.4194  -0.1502]
        Angle    111.5252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4528"
}

Galaxy "NGC 4529:UGC 7697:MCG 3-32-64:ZWG 99.85"
{
        Type  "Sc"
        RA           12.5475
        Dec          20.1836
        Distance   1.287e+08  # method: V
        Radius     3.744e+04
        AbsMag        -17.98
        Axis    [  0.5848  -0.0812   0.8071]
        Angle     26.8679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4529"
}

Galaxy "NGC 4531:UGC 7729:MCG 2-32-141:ZWG 70.175"
{
        Type  "SBa"
        RA           12.5708
        Dec          13.0758
        Distance    4.96e+07  # method: S
        Radius     2.236e+04
        AbsMag        -18.31
        Axis    [ -0.8409   0.3434  -0.4182]
        Angle     44.5802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4531"
}

Galaxy "NGC 4532:UGC 7726:MCG 1-32-103:ZWG 42.158"
{
        Type  "Irr"
        RA           12.5719
        Dec           6.4672
        Distance   6.736e+07  # method: T-F
        Radius     2.645e+04
        AbsMag        -19.27
        Axis    [ -0.9718   0.1603  -0.1730]
        Angle     49.6532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4532"
}

Galaxy "NGC 4533:UGC 7725:MCG 1-32-102:ZWG 42.157"
{
        Type  "Sc"
        RA           12.5728
        Dec           2.3253
        Distance   9.491e+07  # method: V
        Radius     2.899e+04
        AbsMag        -17.82
        Axis    [ -0.9818  -0.0883   0.1684]
        Angle     48.1669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4533"
}

Galaxy "NGC 4534:UGC 7723:MCG 6-28-10:ZWG 188.8"
{
        Type  "Irr"
        RA           12.5681
        Dec          35.5183
        Distance   4.784e+07  # method: V
        Radius     1.809e+04
        AbsMag        -17.83
        Axis    [  0.5809   0.0205  -0.8137]
        Angle     16.8722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4534"
}

Galaxy "NGC 4535:UGC 7727:MCG 1-32-104:ZWG 42.159"
{
        Type  "SBc"
        RA           12.5722
        Dec           8.1975
        Distance   7.158e+07  # method: T-F
        Radius     7.391e+04
        AbsMag         -21.2
        Axis    [  0.8716  -0.4483  -0.1984]
        Angle    118.1092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4535"
}

Galaxy "NGC 4535A"
{
        Type  "S0"
        RA           12.5703
        Dec           8.2736
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.7881  -0.5261  -0.3195]
        Angle    107.2613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4535A"
}

Galaxy "NGC 4536:UGC 7732:MCG 0-32-23:ZWG 14.68"
{
        Type  "SBc"
        RA           12.5739
        Dec           2.1872
        Distance   5.228e+07  # method: T-F
        Radius     5.779e+04
        AbsMag        -19.92
        Axis    [ -0.7952  -0.1564  -0.5858]
        Angle     21.6216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4536"
}

Galaxy "NGC 4537:NGC 4542:UGC 7746:MCG 9-21-21"
{
        Type  "S0"
        RA           12.5803
        Dec          50.8056
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.8137  -0.4776   0.3312]
        Angle     90.0588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4537"
}

Galaxy "NGC 4538:MCG 1-32-105:ZWG 42.161:ARAK 378"
{
        Type  "Sb"
        RA           12.5778
        Dec           3.3236
        Distance   2.462e+08  # method: V
        Radius     2.507e+04
        AbsMag        -19.19
        Axis    [  0.8362  -0.3747  -0.4005]
        Angle     36.8255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4538"
}

Galaxy "NGC 4539:UGC 7735:MCG 3-32-71:ZWG 99.92"
{
        Type  "SBa"
        RA           12.5761
        Dec          18.2028
        Distance   7.235e+07  # method: V
        Radius     3.472e+04
        AbsMag        -18.83
        Axis    [  0.9341  -0.3559   0.0282]
        Angle     19.9058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4539"
}

Galaxy "NGC 4540:UGC 7742:MCG 3-32-74:ZWG 99.93"
{
        Type  "SBc"
        RA           12.5806
        Dec          15.5511
        Distance   7.248e+07  # method: V
        Radius     2.003e+04
        AbsMag        -19.23
        Axis    [  0.7811  -0.5264  -0.3360]
        Angle     80.3978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4540"
}

Galaxy "NGC 4541:UGC 7749:MCG 0-32-24:ZWG 14.71"
{
        Type  "SBc"
        RA           12.5861
        Dec          -0.2211
        Distance   3.445e+08  # method: T-F
        Radius     8.017e+04
        AbsMag        -21.22
        Axis    [  0.6777  -0.4142  -0.6075]
        Angle     30.3574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4541"
}

Galaxy "NGC 4543:MCG 1-32-109:ZWG 42.167:VCC 1608"
{
        Type  "E3"
        RA           12.5889
        Dec           6.1156
        Distance   2.884e+08  # distance uncertain!
        Radius     3.776e+04
        AbsMag        -20.13
        Axis    [  0.5471  -0.6933  -0.4691]
        Angle    128.3296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4543"
}

Galaxy "NGC 4544:UGC 7756:MCG 1-32-110:ZWG 42.168"
{
        Type  "SBa"
        RA           12.5933
        Dec           3.0356
        Distance   6.745e+07  # method: V
        Radius     1.962e+04
        AbsMag        -17.58
        Axis    [ -0.9999   0.0059  -0.0162]
        Angle     47.3353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4544"
}

Galaxy "NGC 4545:UGC 7747:MCG 11-15-64:ZWG 315.47"
{
        Type  "SBc"
        RA           12.5761
        Dec          63.5247
        Distance   1.523e+08  # method: T-F
        Radius     5.536e+04
        AbsMag        -20.34
        Axis    [  0.7182  -0.6077   0.3390]
        Angle    108.8862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4545"
}

Galaxy "NGC 4546:MCG 1-32-27:UGCA 288"
{
        Type  "S0"
        RA           12.5914
        Dec          -3.7931
        Distance   4.586e+07  # method: S
        Radius     2.201e+04
        AbsMag        -19.44
        Axis    [  0.7283  -0.3683  -0.5778]
        Angle     44.8507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4546"
}

Galaxy "NGC 4547:MCG 10-18-69:ZWG 293.30:NPM 1"
{
        Type  "S0"
        RA           12.5808
        Dec          58.9172
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.8878  -0.0751   0.4541]
        Angle     23.1961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4547"
}

Galaxy "M 91:NGC 4548:UGC 7753:MCG 3-32-75"
{
        Type  "SBb"
        RA           12.5906
        Dec          14.4964
        Distance   6.272e+07  # method: S
        Radius     4.744e+04
        AbsMag        -20.52
        Axis    [ -0.6488   0.3752  -0.6621]
        Angle     47.5515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 91"
}

Galaxy "NGC 4549:MCG 10-18-72"
{
        Type  "S0"
        RA           12.5892
        Dec          58.9494
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.4576   0.1353   0.8788]
        Angle     38.9337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4549"
}

Galaxy "NGC 4550:UGC 7757:MCG 2-32-147:ZWG 70.182"
{
        Type  "S0"
        RA           12.5917
        Dec          12.2208
        Distance   5.169e+07  # method: S
        Radius     2.481e+04
        AbsMag         -18.5
        Axis    [ -0.9807   0.1519   0.1229]
        Angle     63.7895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4550"
}

Galaxy "NGC 4551:UGC 7759:MCG 2-32-148:ZWG 70.183"
{
        Type  "E0"
        RA           12.5939
        Dec          12.2639
        Distance   5.642e+07  # method: S
        Radius     1.477e+04
        AbsMag        -18.19
        Axis    [  0.3090  -0.4611  -0.8318]
        Angle     86.9103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4551"
}

Galaxy "M 89:NGC 4552:UGC 7760:MCG 2-32-149"
{
        Type  "E0"
        RA           12.5942
        Dec          12.5561
        Distance   5.005e+07  # method: S
        Radius     2.548e+04
        AbsMag        -20.03
        Axis    [  0.5505  -0.7438  -0.3790]
        Angle    131.0898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 89"
}

Galaxy "NGC 4553:ESO 322-30:MCG 6-28-6:DCL 76"
{
        Type  "SBa"
        RA           12.6019
        Dec         -39.4392
        Distance   1.544e+08  # method: V
        Radius     4.715e+04
        AbsMag        -20.18
        Axis    [ -0.8449  -0.3127  -0.4340]
        Angle     83.6303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4553"
}

Galaxy "NGC 4555:IC 3545:UGC 7762:MCG 5-30-26"
{
        Type  "E0"
        RA           12.5947
        Dec          26.5239
        Distance   3.162e+08  # method: V
        Radius     8.738e+04
        AbsMag        -21.53
        Axis    [ -0.0463   0.1692  -0.9845]
        Angle     63.3111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4555"
}

Galaxy "NGC 4556:UGC 7765:MCG 5-30-27:ZWG 159.22"
{
        Type  "E0"
        RA           12.5958
        Dec          26.9092
        Distance   3.494e+08  # method: V
        Radius     6.098e+04
        AbsMag        -20.95
        Axis    [  0.3083  -0.4278  -0.8497]
        Angle     69.4078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4556"
}

Galaxy "NGC 4558:MCG 5-30-28:ZWG 159.23:PGC 42019"
{
        Type  "S0"
        RA           12.5978
        Dec          26.9917
        Distance   3.683e+08  # method: V
        Radius     4.286e+04
        AbsMag        -19.76
        Axis    [  0.8150  -0.5704  -0.1016]
        Angle     96.4846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4558"
}

Galaxy "NGC 4559:UGC 7766:MCG 5-30-30:ZWG 159.24"
{
        Type  "SBc"
        RA           12.5992
        Dec          27.9597
        Distance   2.872e+07  # method: T-F
        Radius      4.47e+04
        AbsMag        -19.42
        Axis    [ -0.8451   0.4721   0.2507]
        Angle     36.5623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4559"
}

Galaxy "NGC 4561:IC 3569:UGC 7768:MCG 3-32-76"
{
        Type  "SBc"
        RA           12.6022
        Dec          19.3217
        Distance   7.746e+07  # method: V
        Radius      1.69e+04
        AbsMag        -18.78
        Axis    [  0.7382  -0.5968  -0.3145]
        Angle     90.7770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4561"
}

Galaxy "NGC 4562:NGC 4565A:UGC 7758:MCG 4-30-4"
{
        Type  "SBc"
        RA           12.5928
        Dec          25.8494
        Distance   7.479e+07  # method: V
        Radius     2.611e+04
        AbsMag         -17.4
        Axis    [  0.9301  -0.2725   0.2465]
        Angle     69.3026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4562"
}

Galaxy "NGC 4563:MCG 5-30-33"
{
        Type  "S0"
        RA           12.6033
        Dec          26.9417
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.5796  -0.3264  -0.7467]
        Angle     27.3626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4563"
}

Galaxy "NGC 4564:UGC 7773:MCG 2-32-150:ZWG 70.186"
{
        Type  "E0"
        RA           12.6072
        Dec          11.4397
        Distance   4.891e+07  # method: S
        Radius      2.49e+04
        AbsMag        -18.88
        Axis    [  0.4205  -0.5956  -0.6844]
        Angle     99.9054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4564"
}

Galaxy "NGC 4565:UGC 7772:MCG 4-30-6:ZWG 129.10"
{
        Type  "Sb"
        RA           12.6056
        Dec          25.9878
        Distance   5.694e+07  # method: S
        Radius     1.309e+05
        AbsMag        -20.91
        Axis    [ -0.5885   0.2191   0.7782]
        Angle     34.0986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4565"
}

Galaxy "NGC 4566:UGC 7769:MCG 9-21-24:ZWG 270.12"
{
        Type  "Sc"
        RA           12.6000
        Dec          54.2206
        Distance   2.499e+08  # method: V
        Radius     4.726e+04
        AbsMag        -20.52
        Axis    [  0.8199  -0.3478   0.4547]
        Angle     38.0039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4566"
}

Galaxy "NGC 4567:UGC 7777:MCG 2-32-151:ZWG 70.189"
{
        Type  "Sc"
        RA           12.6089
        Dec          11.2578
        Distance   1.173e+08  # method: V
        Radius      5.29e+04
        AbsMag        -20.68
        Axis    [  0.6115  -0.4201  -0.6705]
        Angle     40.8511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4567"
}

Galaxy "NGC 4568:UGC 7776:MCG 2-32-152:ZWG 70.188"
{
        Type  "Sc"
        RA           12.6094
        Dec          11.2386
        Distance   1.168e+08  # method: V
        Radius     7.817e+04
        AbsMag        -21.07
        Axis    [  0.9311  -0.3474  -0.1109]
        Angle     92.5334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4568"
}

Galaxy "M 90:NGC 4569:UGC 7786:MCG 2-32-155"
{
        Type  "SBb"
        RA           12.6139
        Dec          13.1639
        Distance   3.715e+06  # method: V
        Radius          5133
        AbsMag        -15.08
        Axis    [  0.9340  -0.3481  -0.0807]
        Angle     92.3046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 90"
}

Galaxy "NGC 4570:UGC 7785:MCG 1-32-114:ZWG 42.178"
{
        Type  "S0"
        RA           12.6147
        Dec           7.2469
        Distance   9.332e+07  # method: V
        Radius     5.022e+04
        AbsMag        -20.48
        Axis    [ -0.9968   0.0792   0.0106]
        Angle     44.7472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4570"
}

Galaxy "NGC 4571:IC 3588:UGC 7788:MCG 2-32-156"
{
        Type  "Sc"
        RA           12.6156
        Dec          14.2175
        Distance   2.985e+07  # method: V
        Radius     1.563e+04
        AbsMag        -17.91
        Axis    [  0.9557  -0.2919   0.0366]
        Angle     60.0502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4571"
}

Galaxy "NGC 4572:UGC 7775:MCG 12-12-12:ZWG 352.37"
{
        Type  "S0"
        RA           12.5958
        Dec          74.2461
        Distance    2.03e+08  # distance uncertain!
        Radius     4.428e+04
        AbsMag        -19.07
        Axis    [ -0.4847   0.6273   0.6095]
        Angle     87.5081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4572"
}

Galaxy "NGC 4573:ESO 268-26:MCG 7-26-14:FAIR 455"
{
        Type  "SBa"
        RA           12.6286
        Dec         -43.6214
        Distance   1.472e+08  # method: V
        Radius     5.352e+04
        AbsMag        -19.57
        Axis    [ -0.4624  -0.2469  -0.8516]
        Angle     86.3911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4573"
}

Galaxy "NGC 4574:ESO 380-49:MCG 6-28-7:FAIR 311"
{
        Type  "SBc"
        RA           12.6286
        Dec         -35.5181
        Distance   1.483e+08  # method: T-F
        Radius     3.883e+04
        AbsMag        -19.59
        Axis    [ -0.1382  -0.3267  -0.9350]
        Angle     65.9198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4574"
}

Galaxy "NGC 4575:ESO 322-36:MCG 7-26-15:DCL 85"
{
        Type  "SBc"
        RA           12.6308
        Dec         -40.5375
        Distance   1.157e+08  # method: T-F
        Radius     3.364e+04
        AbsMag        -19.65
        Axis    [ -0.0375  -0.3292  -0.9435]
        Angle     70.8431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4575"
}

Galaxy "NGC 4576:UGC 7792:MCG 1-32-116:ZWG 42.182"
{
        Type  "SBc"
        RA           12.6258
        Dec           4.3675
        Distance   2.581e+08  # method: V
        Radius     4.504e+04
        AbsMag        -20.19
        Axis    [ -0.8456   0.2168  -0.4879]
        Angle     52.1746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4576"
}

Galaxy "NGC 4577:NGC 4591:UGC 7821:MCG 1-32-124"
{
        Type  "Sb"
        RA           12.6533
        Dec           6.0122
        Distance   1.248e+08  # method: V
        Radius     2.905e+04
        AbsMag        -19.11
        Axis    [  0.9097  -0.3536  -0.2177]
        Angle     79.8605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4577"
}

Galaxy "NGC 4578:UGC 7793:MCG 2-32-159:ZWG 70.195"
{
        Type  "S0"
        RA           12.6250
        Dec           9.5556
        Distance   6.046e+07  # method: S
        Radius     2.726e+04
        AbsMag        -19.14
        Axis    [  0.8063  -0.4839  -0.3401]
        Angle     85.9873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4578"
}

Galaxy "M 58:NGC 4579:UGC 7796:MCG 2-32-160"
{
        Type  "SBb"
        RA           12.6286
        Dec          11.8183
        Distance   8.349e+07  # method: V
        Radius     7.286e+04
        AbsMag        -21.64
        Axis    [  0.3739  -0.3430  -0.8617]
        Angle     40.5203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 58"
}

Galaxy "NGC 4580:UGC 7794:MCG 1-32-117:ZWG 42.183"
{
        Type  "SBa"
        RA           12.6300
        Dec           5.3681
        Distance   6.197e+07  # method: V
        Radius     1.893e+04
        AbsMag        -19.09
        Axis    [ -0.8367   0.2760  -0.4730]
        Angle     58.4074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4580"
}

Galaxy "NGC 4581:UGC 7801:MCG 0-32-28:ZWG 14.83"
{
        Type  "E0"
        RA           12.6347
        Dec           1.4783
        Distance   1.193e+08  # method: T-F
        Radius     3.298e+04
        AbsMag        -19.52
        Axis    [ -0.5046   0.4301  -0.7486]
        Angle     96.7318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4581"
}

Galaxy "NGC 4583:MCG 6-28-17:ZWG 188.11"
{
        Type  "SBa"
        RA           12.6344
        Dec          33.4586
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.7297  -0.4240  -0.5365]
        Angle     28.7898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4583"
}

Galaxy "NGC 4584:UGC 7803:MCG 2-32-162:ZWG 70.199"
{
        Type  "SBa"
        RA           12.6381
        Dec          13.1106
        Distance   9.495e+07  # method: V
        Radius     1.933e+04
        AbsMag        -18.62
        Axis    [  0.8535  -0.4888  -0.1804]
        Angle    112.7474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4584"
}

Galaxy "NGC 4585:MCG 5-30-42:ZWG 159.37:IRAS 12357+2912"
{
        Type  "SBb"
        RA           12.6369
        Dec          28.9372
        Distance   3.431e+08  # method: V
        Radius     3.493e+04
        AbsMag        -20.21
        Axis    [  0.7249   0.6884   0.0242]
        Angle      3.5373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4585"
}

Galaxy "NGC 4586:UGC 7804:MCG 1-32-122:ZWG 42.187"
{
        Type  "Sa"
        RA           12.6411
        Dec           4.3186
        Distance   5.124e+07  # method: V
        Radius     2.832e+04
        AbsMag        -18.38
        Axis    [ -0.2374  -0.8619  -0.4481]
        Angle      7.9366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4586"
}

Galaxy "NGC 4587:UGC 7805:MCG 1-32-123:ZWG 42.188"
{
        Type  "S0"
        RA           12.6431
        Dec           2.6578
        Distance   5.595e+07  # method: V
        Radius          8951
        AbsMag        -16.87
        Axis    [  0.9075  -0.3290  -0.2610]
        Angle     69.0360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4587"
}

Galaxy "NGC 4588:UGC 7810:MCG 1-32-124:ZWG 42.189"
{
        Type  "SBc"
        RA           12.6458
        Dec           6.7675
        Distance    2.48e+08  # method: T-F
        Radius      4.69e+04
        AbsMag         -19.5
        Axis    [  0.9592  -0.2752  -0.0640]
        Angle     57.8910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4588"
}

Galaxy "NGC 4589:UGC 7797:MCG 12-12-13:ZWG 352.38"
{
        Type  "E2"
        RA           12.6233
        Dec          74.1919
        Distance   7.169e+07  # method: S
        Radius     3.545e+04
        AbsMag        -20.01
        Axis    [  0.6309  -0.7213  -0.2857]
        Angle     37.5960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4589"
}

Galaxy "NGC 4592:UGC 7819:MCG 0-32-32:ZWG 14.91"
{
        Type  "Irr"
        RA           12.6550
        Dec          -0.5314
        Distance   3.973e+07  # method: T-F
        Radius     3.351e+04
        AbsMag        -18.23
        Axis    [  0.8080  -0.5423  -0.2304]
        Angle     19.5185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4592"
}

Galaxy "NGC 4593:MCG 1-32-32:MK 1330:IRAS 12370-0504"
{
        Type  "SBb"
        RA           12.6608
        Dec          -5.3439
        Distance   1.283e+08  # method: V
        Radius      7.28e+04
        AbsMag        -21.07
        Axis    [ -0.1143  -0.2225  -0.9682]
        Angle     46.1857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4593"
}

Galaxy "M 104:NGC 4594:MCG 2-32-20:UGCA 293"
{
        Type  "Sa"
        RA           12.6664
        Dec         -11.6225
        Distance   3.187e+07  # method: S
        Radius     3.987e+04
        AbsMag        -20.75
        Axis    [  0.4830  -0.3983  -0.7798]
        Angle     42.4703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 104"
}

Galaxy "NGC 4595:UGC 7826:MCG 3-32-81:ZWG 99.106"
{
        Type  "SBb"
        RA           12.6642
        Dec          15.2978
        Distance   4.285e+07  # method: V
        Radius      1.06e+04
        AbsMag        -17.59
        Axis    [  0.1799  -0.2552  -0.9500]
        Angle     18.9788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4595"
}

Galaxy "NGC 4596:UGC 7828:MCG 2-32-170:ZWG 70.206"
{
        Type  "SBa"
        RA           12.6656
        Dec          10.1764
        Distance   9.957e+07  # method: V
        Radius     5.793e+04
        AbsMag        -21.02
        Axis    [ -0.5519   0.1503  -0.8203]
        Angle     36.5533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4596"
}

Galaxy "NGC 4597:MCG 1-32-34:IRAS 12376-0531"
{
        Type  "SBc"
        RA           12.6700
        Dec          -5.8006
        Distance   6.252e+07  # method: V
        Radius     3.728e+04
        AbsMag        -18.71
        Axis    [  0.9018  -0.2831  -0.3265]
        Angle     84.6114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4597"
}

Galaxy "NGC 4598:UGC 7829:MCG 2-32-171:ZWG 70.207"
{
        Type  "S0"
        RA           12.6697
        Dec           8.3833
        Distance   1.036e+08  # method: V
        Radius      2.11e+04
        AbsMag        -18.91
        Axis    [ -0.0609  -0.1494  -0.9869]
        Angle     36.5997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4598"
}

Galaxy "NGC 4599:UGC 7833:MCG 0-32-34:ZWG 14.99"
{
        Type  "Sa"
        RA           12.6739
        Dec           1.1967
        Distance   1.002e+08  # method: V
        Radius     2.478e+04
        AbsMag        -18.84
        Axis    [ -0.9027  -0.0314  -0.4291]
        Angle     34.6406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4599"
}

Galaxy "NGC 4600:UGC 7832:MCG 1-32-128:ZWG 42.198"
{
        Type  "S0"
        RA           12.6728
        Dec           3.1178
        Distance   2.396e+07  # method: S
        Radius          4181
        AbsMag        -15.73
        Axis    [  0.7505  -0.4327  -0.4996]
        Angle     63.9346
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4600"
}

Galaxy "NGC 4601:ESO 322-50:MCG 7-26-26:DCL 118"
{
        Type  "SBa"
        RA           12.6794
        Dec         -40.8936
        Distance   1.598e+08  # method: V
        Radius     3.952e+04
        AbsMag        -18.95
        Axis    [  0.8616   0.0194  -0.5072]
        Angle    105.2389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4601"
}

Galaxy "NGC 4602:MCG 1-32-36:IRAS 12380-0451"
{
        Type  "SBc"
        RA           12.6767
        Dec          -5.1325
        Distance   1.117e+08  # method: T-F
        Radius     5.522e+04
        AbsMag        -20.07
        Axis    [  0.5158  -0.5325  -0.6711]
        Angle     24.1946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4602"
}

Galaxy "NGC 4603:ESO 322-52:MCG 7-26-28:AM 1238-404"
{
        Type  "SBc"
        RA           12.6819
        Dec         -40.9761
        Distance   1.177e+08  # method: T-F
        Radius     5.822e+04
        AbsMag        -19.69
        Axis    [  0.6880  -0.2230  -0.6906]
        Angle    117.2411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4603"
}

Galaxy "NGC 4603A:ESO 322-44:MCG 7-26-20:DCL 105"
{
        Type  "SBc"
        RA           12.6600
        Dec         -40.7397
        Distance   1.295e+08  # method: T-F
        Radius     3.579e+04
        AbsMag        -18.89
        Axis    [  0.3090  -0.3524  -0.8834]
        Angle     55.7918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4603A"
}

Galaxy "NGC 4603B:ESO 322-48:DCL 114"
{
        Type  "SBb"
        RA           12.6747
        Dec         -41.0700
        Distance   1.475e+08  # method: T-F
        Radius     3.004e+04
        AbsMag        -17.78
        Axis    [  0.8319   0.0030  -0.5549]
        Angle     83.2989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4603B"
}

Galaxy "NGC 4603C:ESO 322-49:MCG 7-26-25:DCL 117"
{
        Type  "S0"
        RA           12.6786
        Dec         -40.7639
        Distance   1.393e+08  # method: V
        Radius     3.444e+04
        AbsMag        -19.15
        Axis    [ -0.7495  -0.5402  -0.3827]
        Angle     66.0826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4603C"
}

Galaxy "NGC 4603D:ESO 322-55:MCG 7-26-29:DCL 130"
{
        Type  "SBc"
        RA           12.7019
        Dec         -40.8208
        Distance   1.742e+08  # method: T-F
        Radius     3.801e+04
        AbsMag        -19.54
        Axis    [  0.3162  -0.2883  -0.9038]
        Angle     90.8017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4603D"
}

Galaxy "NGC 4604:MCG 1-32-37:IRAS 12381-0501"
{
        Type  "Irr"
        RA           12.6789
        Dec          -5.3028
        Distance   2.631e+08  # distance uncertain!
        Radius     3.826e+04
        AbsMag        -20.13
        Axis    [ -0.1285  -0.5157  -0.8471]
        Angle     21.7141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4604"
}

Galaxy "NGC 4605:UGC 7831:MCG 10-18-74:ZWG 293.31"
{
        Type  "SBc"
        RA           12.6664
        Dec          61.6083
        Distance   1.228e+07  # method: V
        Radius     1.053e+04
        AbsMag        -17.08
        Axis    [ -0.0314   0.4833   0.8749]
        Angle     45.7941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4605"
}

Galaxy "NGC 4606:UGC 7839:MCG 2-32-174:ZWG 70.213"
{
        Type  "SBa"
        RA           12.6825
        Dec          11.9119
        Distance   8.988e+07  # method: V
        Radius     4.314e+04
        AbsMag         -19.6
        Axis    [  0.9102  -0.3874  -0.1464]
        Angle     83.2129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4606"
}

Galaxy "NGC 4607:UGC 7843:MCG 2-32-176:ZWG 70.216"
{
        Type  "SBb"
        RA           12.6867
        Dec          11.8856
        Distance   1.167e+08  # method: V
        Radius     4.924e+04
        AbsMag        -18.97
        Axis    [  0.9799  -0.1988   0.0189]
        Angle    113.0649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4607"
}

Galaxy "NGC 4608:UGC 7842:MCG 2-32-177:ZWG 70.214"
{
        Type  "S0"
        RA           12.6869
        Dec          10.1556
        Distance   9.717e+07  # method: V
        Radius     4.664e+04
        AbsMag        -20.37
        Axis    [ -0.1635  -0.0305  -0.9861]
        Angle     44.7246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4608"
}

Galaxy "NGC 4611:IC 805:UGC 7849:MCG 2-32-179"
{
        Type  "Sc"
        RA           12.6903
        Dec          13.7297
        Distance   2.916e+08  # method: V
        Radius      5.09e+04
        AbsMag        -19.66
        Axis    [ -0.5474  -0.1055   0.8302]
        Angle     20.5092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4611"
}

Galaxy "NGC 4612:UGC 7850:MCG 1-32-134:ZWG 42.205"
{
        Type  "S0"
        RA           12.6922
        Dec           7.3147
        Distance   9.731e+07  # method: V
        Radius     3.821e+04
        AbsMag        -19.87
        Axis    [ -0.6925   0.1912  -0.6957]
        Angle     43.5343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4612"
}

Galaxy "NGC 4613:MCG 4-30-11:MK 780:ZWG 129.16"
{
        Type  "S0"
        RA           12.6914
        Dec          26.0883
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.5221  -0.8031  -0.2871]
        Angle    123.9437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4613"
}

Galaxy "NGC 4614:UGC 7851:MCG 4-30-12:ZWG 129.15"
{
        Type  "SBa"
        RA           12.6919
        Dec          26.0431
        Distance   2.319e+08  # method: V
        Radius     3.035e+04
        AbsMag        -19.96
        Axis    [ -0.6388   0.6344  -0.4354]
        Angle     66.9413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4614"
}

Galaxy "NGC 4615:UGC 7852:MCG 4-30-13:ZWG 129.18"
{
        Type  "Sc"
        RA           12.6936
        Dec          26.0728
        Distance   2.266e+08  # method: V
        Radius     5.273e+04
        AbsMag        -20.41
        Axis    [ -0.6663   0.4332   0.6069]
        Angle     12.1258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4615"
}

Galaxy "NGC 4616:ESO 322-56:MCG 7-26-30:DCL 134"
{
        Type  "E0"
        RA           12.7044
        Dec         -40.6417
        Distance   1.287e+08  # method: S
        Radius     1.684e+04
        AbsMag        -18.68
        Axis    [  0.6292  -0.4612  -0.6256]
        Angle    163.5221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4616"
}

Galaxy "NGC 4617:UGC 7847:MCG 9-21-28:ZWG 270.13"
{
        Type  "Sb"
        RA           12.6847
        Dec          50.3942
        Distance   2.192e+08  # method: V
        Radius     9.246e+04
        AbsMag        -20.14
        Axis    [ -0.7261   0.4896   0.4827]
        Angle     77.7838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4617"
}

Galaxy "NGC 4618:IC 3667:UGC 7853:MCG 7-26-37"
{
        Type  "Irr"
        RA           12.6925
        Dec          41.1511
        Distance   3.493e+07  # method: V
        Radius     2.134e+04
        AbsMag        -18.95
        Axis    [  0.7442  -0.6679  -0.0069]
        Angle     89.3566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4618"
}

Galaxy "NGC 4619:UGC 7856:MCG 6-28-18:ZWG 188.14"
{
        Type  "SBb"
        RA           12.6956
        Dec          35.0628
        Distance    3.25e+08  # method: V
        Radius     6.146e+04
        AbsMag        -21.49
        Axis    [  0.4895  -0.8422  -0.2260]
        Angle    119.8346
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4619"
}

Galaxy "NGC 4620:UGC 7859:MCG 2-32-182:ZWG 70.224"
{
        Type  "S0"
        RA           12.6997
        Dec          12.9433
        Distance   6.941e+07  # method: S
        Radius     1.817e+04
        AbsMag        -18.44
        Axis    [  0.7294  -0.5519  -0.4042]
        Angle     83.7644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4620"
}

Galaxy "M 59:NGC 4621:UGC 7858:MCG 2-32-183"
{
        Type  "E5"
        RA           12.7006
        Dec          11.6472
        Distance   5.963e+07  # method: S
        Radius     4.683e+04
        AbsMag        -20.61
        Axis    [ -0.4189   0.4541  -0.7863]
        Angle     86.3811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 59"
}

Galaxy "NGC 4622:ESO 322-57:MCG 7-26-31:AM 1239-402"
{
        Type  "Sa"
        RA           12.7103
        Dec         -40.7439
        Distance   2.104e+08  # method: V
        Radius     5.202e+04
        AbsMag        -20.65
        Axis    [ -0.7312  -0.0056  -0.6822]
        Angle    108.1187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4622"
}

Galaxy "NGC 4622A:ESO 322-64:MCG 7-26-35:VV 580"
{
        Type  "S0"
        RA           12.7303
        Dec         -40.7144
        Distance    2.41e+08  # method: V
        Radius     2.103e+04
        AbsMag        -20.14
        Axis    [ -0.2241  -0.2528  -0.9412]
        Angle     89.0248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4622A"
}

Galaxy "NGC 4622B:ESO 322-64A:MCG 7-26-36:VV 580"
{
        Type  "S0"
        RA           12.7306
        Dec         -40.7178
        Distance   2.347e+08  # method: V
        Radius     3.756e+04
        AbsMag        -19.09
        Axis    [  0.4664  -0.2652  -0.8439]
        Angle     88.9677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4622B"
}

Galaxy "NGC 4623:UGC 7862:MCG 1-32-135:ZWG 42.207"
{
        Type  "SBa"
        RA           12.7028
        Dec           7.6764
        Distance   9.817e+07  # method: V
        Radius     3.141e+04
        AbsMag        -19.59
        Axis    [ -0.9932   0.1040   0.0516]
        Angle     61.5008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4623"
}

Galaxy "NGC 4624:NGC 4664:NGC 4665:UGC 7924"
{
        Type  "SBa"
        RA           12.7517
        Dec           3.0553
        Distance   5.051e+07  # method: V
        Radius     2.571e+04
        AbsMag        -19.75
        Axis    [  0.5795  -0.6935  -0.4281]
        Angle    136.2528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4624"
}

Galaxy "NGC 4625:IC 3675:UGC 7861:MCG 7-26-38"
{
        Type  "Irr"
        RA           12.6978
        Dec          41.2736
        Distance   3.787e+07  # method: V
        Radius          8813
        AbsMag        -17.42
        Axis    [ -0.2144   0.7254  -0.6541]
        Angle     25.5420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4625"
}

Galaxy "NGC 4626:MCG 1-32-40:IRAS 12398-0646"
{
        Type  "Sc"
        RA           12.7069
        Dec          -7.0447
        Distance    1.47e+08  # distance uncertain!
        Radius     2.994e+04
        AbsMag        -19.07
        Axis    [  0.9270  -0.2389  -0.2891]
        Angle     77.8254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4626"
}

Galaxy "NGC 4627:UGC 7860:MCG 6-28-19:ZWG 188.15"
{
        Type  "E4"
        RA           12.6997
        Dec          32.5739
        Distance   3.058e+07  # method: S
        Radius          7561
        AbsMag        -16.86
        Axis    [  0.4600  -0.7896  -0.4062]
        Angle    100.4667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4627"
}

Galaxy "NGC 4628:MCG 1-32-41:MK 1333:IRAS 12398-0641"
{
        Type  "Sb"
        RA           12.7069
        Dec          -6.9708
        Distance   1.432e+08  # method: V
        Radius     3.542e+04
        AbsMag        -18.91
        Axis    [  0.9427  -0.2176  -0.2528]
        Angle     70.7210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4628"
}

Galaxy "NGC 4629:UGC 7869:MCG 0-32-37:ZWG 14.109"
{
        Type  "Irr"
        RA           12.7089
        Dec          -1.3508
        Distance   6.591e+07  # method: V
        Radius     1.055e+04
        AbsMag        -17.53
        Axis    [  0.1780  -0.3348  -0.9253]
        Angle     43.6383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4629"
}

Galaxy "NGC 4630:UGC 7871:MCG 1-32-136:ZWG 42.208"
{
        Type  "Irr"
        RA           12.7086
        Dec           3.9586
        Distance   4.843e+07  # method: V
        Radius     1.197e+04
        AbsMag        -17.76
        Axis    [  0.8529  -0.4434  -0.2756]
        Angle    110.3709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4630"
}

Galaxy "NGC 4631:UGC 7865:MCG 6-28-20:ZWG 188.16"
{
        Type  "SBc"
        RA           12.7019
        Dec          32.5417
        Distance   3.946e+07  # method: V
        Radius     8.723e+04
        AbsMag        -20.71
        Axis    [  0.6522  -0.1029   0.7511]
        Angle     45.4031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4631"
}

Galaxy "NGC 4632:UGC 7870:MCG 0-32-38:ZWG 14.110"
{
        Type  "Sc"
        RA           12.7089
        Dec          -0.0806
        Distance   5.916e+07  # method: T-F
        Radius     2.581e+04
        AbsMag        -18.79
        Axis    [  0.8862  -0.3431  -0.3112]
        Angle     54.3702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4632"
}

Galaxy "NGC 4633:IC 3688:UGC 7874:MCG 3-32-85"
{
        Type  "SBc"
        RA           12.7103
        Dec          14.3569
        Distance    2.75e+07  # method: V
        Radius          7999
        AbsMag        -15.73
        Axis    [  0.9280  -0.3657  -0.0713]
        Angle     82.6347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4633"
}

Galaxy "NGC 4634:UGC 7875:MCG 3-32-86:ZWG 99.112"
{
        Type  "SBc"
        RA           12.7111
        Dec          14.2961
        Distance   1.998e+07  # method: V
        Radius          8426
        AbsMag        -15.53
        Axis    [ -0.9715   0.1551   0.1792]
        Angle     41.4862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4634"
}

Galaxy "NGC 4635:UGC 7876:MCG 3-32-87:ZWG 100.3"
{
        Type  "SBc"
        RA           12.7106
        Dec          19.9467
        Distance   5.712e+07  # method: V
        Radius     1.579e+04
        AbsMag        -17.82
        Axis    [ -0.8062   0.4959  -0.3227]
        Angle     57.7784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4635"
}

Galaxy "NGC 4636:UGC 7878:MCG 1-32-137:ZWG 43.2"
{
        Type  "E0"
        RA           12.7136
        Dec           2.6872
        Distance    4.78e+07  # method: S
        Radius     4.102e+04
        AbsMag        -20.43
        Axis    [ -0.3739   0.2629  -0.8894]
        Angle     87.0627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4636"
}

Galaxy "NGC 4637:UGC 7881:MCG 2-32-188:ZWG 71.7"
{
        Type  "S0"
        RA           12.7150
        Dec          11.4381
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.8078  -0.5288  -0.2605]
        Angle     18.5342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4637"
}

Galaxy "NGC 4638:NGC 4667:UGC 7880:MCG 2-32-187"
{
        Type  "S0"
        RA           12.7131
        Dec          11.4425
        Distance    7.07e+07  # method: S
        Radius     2.262e+04
        AbsMag        -19.58
        Axis    [ -0.4889  -0.0188  -0.8721]
        Angle     22.6749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4638"
}

Galaxy "NGC 4639:UGC 7884:MCG 2-32-189:ZWG 70.230"
{
        Type  "SBc"
        RA           12.7144
        Dec          13.2572
        Distance   5.989e+07  # method: V
        Radius     2.526e+04
        AbsMag        -19.12
        Axis    [ -0.3654  -0.0079  -0.9308]
        Angle     24.2403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4639"
}

Galaxy "NGC 4640:NGC 4640A:UGC 7888:MCG 2-32-190"
{
        Type  "SBa"
        RA           12.7158
        Dec          12.2867
        Distance    1.02e+08  # method: V
        Radius     2.076e+04
        AbsMag        -18.27
        Axis    [  0.8762  -0.4312  -0.2152]
        Angle     72.2638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4640"
}

Galaxy "NGC 4640B:NPM 1"
{
        Type  "S0"
        RA           12.7169
        Dec          12.2856
        Distance   5.854e+08  # distance uncertain!
        Radius     1.703e+04
        AbsMag        -19.07
        Axis    [  0.8292  -0.4585  -0.3196]
        Angle     32.3213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4640B"
}

Galaxy "NGC 4641:UGC 7889:MCG 2-32-191:ZWG 71.11"
{
        Type  "S0"
        RA           12.7186
        Dec          12.0514
        Distance   1.057e+08  # method: V
        Radius     1.845e+04
        AbsMag        -18.25
        Axis    [ -0.7558   0.4247  -0.4984]
        Angle     64.2514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4641"
}

Galaxy "NGC 4642:UGC 7893:MCG 0-33-4:ZWG 15.7"
{
        Type  "Sc"
        RA           12.7214
        Dec          -0.6450
        Distance   1.349e+08  # method: V
        Radius     3.728e+04
        AbsMag        -19.28
        Axis    [  0.9713  -0.2033  -0.1237]
        Angle     77.6314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4642"
}

Galaxy "NGC 4643:UGC 7895:MCG 0-33-5:ZWG 15.8"
{
        Type  "SBa"
        RA           12.7222
        Dec           1.9781
        Distance   7.842e+07  # method: V
        Radius     3.536e+04
        AbsMag         -20.2
        Axis    [  0.6894  -0.4832  -0.5396]
        Angle     81.1971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4643"
}

Galaxy "NGC 4644:NGC 4644A:UGC 7887:MCG 9-21-30"
{
        Type  "SBb"
        RA           12.7117
        Dec          55.1453
        Distance   2.231e+08  # method: V
        Radius     5.191e+04
        AbsMag        -19.57
        Axis    [  0.7461  -0.2924   0.5983]
        Angle     77.2782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4644"
}

Galaxy "NGC 4644B:MCG 9-21-32:KCPG 352B"
{
        Type  "Sc"
        RA           12.7144
        Dec          55.1456
        Distance   2.298e+08  # method: V
        Radius     3.008e+04
        AbsMag        -18.44
        Axis    [ -0.2535   0.4153   0.8736]
        Angle     55.5468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4644B"
}

Galaxy "NGC 4645:ESO 322-66:MCG 7-26-37:DCL 168"
{
        Type  "E0"
        RA           12.7358
        Dec         -41.7497
        Distance    9.76e+07  # method: S
        Radius     3.123e+04
        AbsMag        -19.58
        Axis    [  0.2997  -0.3657  -0.8812]
        Angle    142.5648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4645"
}

Galaxy "NGC 4645A:ESO 322-59:MCG 7-26-32:DCL 149"
{
        Type  "S0"
        RA           12.7181
        Dec         -41.3594
        Distance   1.571e+08  # method: V
        Radius     6.396e+04
        AbsMag        -20.81
        Axis    [  0.8083  -0.0392  -0.5875]
        Angle     90.8414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4645A"
}

Galaxy "NGC 4645B:ESO 322-60:MCG 7-26-34:DCL 157"
{
        Type  "S0"
        RA           12.7253
        Dec         -41.3625
        Distance   1.292e+08  # method: V
        Radius     3.572e+04
        AbsMag        -19.99
        Axis    [ -0.7001  -0.4585  -0.5474]
        Angle     68.1350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4645B"
}

Galaxy "NGC 4646:UGC 7892:MCG 9-21-31:ZWG 270.15"
{
        Type  "S0"
        RA           12.7144
        Dec          54.8567
        Distance   2.135e+08  # method: V
        Radius     3.105e+04
        AbsMag        -19.68
        Axis    [  0.6820  -0.7156   0.1508]
        Angle    101.5540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4646"
}

Galaxy "NGC 4647:UGC 7896:MCG 2-33-1:ZWG 71.15"
{
        Type  "SBc"
        RA           12.7256
        Dec          11.5828
        Distance    7.86e+07  # method: V
        Radius     3.315e+04
        AbsMag        -19.81
        Axis    [ -0.3203   0.0225  -0.9471]
        Angle     34.8635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4647"
}

Galaxy "NGC 4648:UGC 7868:MCG 13-9-29:ZWG 352.39"
{
        Type  "E3"
        RA           12.6956
        Dec          74.4222
        Distance   1.311e+08  # method: T-F
        Radius     3.432e+04
        AbsMag        -20.12
        Axis    [  0.5737  -0.7884  -0.2220]
        Angle     41.9259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4648"
}

Galaxy "M 60:NGC 4649:UGC 7898:MCG 2-33-2"
{
        Type  "E2"
        RA           12.7275
        Dec          11.5531
        Distance   5.488e+07  # method: S
        Radius     6.067e+04
        AbsMag        -21.33
        Axis    [  0.0299  -0.1590  -0.9868]
        Angle     76.2155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 60"
}

Galaxy "NGC 4650:ESO 322-67:MCG 7-26-38:AM 1241-402"
{
        Type  "SBa"
        RA           12.7386
        Dec         -40.7319
        Distance   1.463e+08  # method: V
        Radius     6.808e+04
        AbsMag        -20.56
        Axis    [ -0.7077  -0.1227  -0.6957]
        Angle     96.3118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4650"
}

Galaxy "NGC 4650A:ESO 322-69:AM 1242-402:DCL 178"
{
        Type  "Sa"
        RA           12.7469
        Dec         -40.7144
        Distance   1.438e+08  # method: V
        Radius     3.346e+04
        AbsMag        -19.02
        Axis    [ -0.7270  -0.3632  -0.5827]
        Angle     75.1443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4650A"
}

Galaxy "NGC 4651:UGC 7901:MCG 3-33-1:ZWG 100.4"
{
        Type  "Sc"
        RA           12.7283
        Dec          16.3936
        Distance   1.033e+08  # method: T-F
        Radius     6.009e+04
        AbsMag         -21.2
        Axis    [  0.7346  -0.4886  -0.4708]
        Angle     40.6282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4651"
}

Galaxy "NGC 4652:MCG 10-18-78:ZWG 293.35"
{
        Type  "Sb"
        RA           12.7219
        Dec          58.9653
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [  0.7487  -0.2622   0.6088]
        Angle     97.0920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4652"
}

Galaxy "NGC 4653:UGC 7900:MCG 0-33-6:ZWG 15.9"
{
        Type  "SBc"
        RA           12.7308
        Dec          -0.5611
        Distance    1.34e+08  # method: V
        Radius     6.044e+04
        AbsMag        -20.27
        Axis    [  0.7001  -0.5109  -0.4989]
        Angle    100.8561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4653"
}

Galaxy "NGC 4654:UGC 7902:MCG 2-33-4:ZWG 71.19"
{
        Type  "SBc"
        RA           12.7322
        Dec          13.1264
        Distance    6.27e+07  # method: T-F
        Radius     4.559e+04
        AbsMag        -20.32
        Axis    [ -0.6237   0.0572  -0.7795]
        Angle     21.5087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4654"
}

Galaxy "NGC 4655:MCG 7-26-42:ZWG 216.21:NPM 1"
{
        Type  "S0"
        RA           12.7267
        Dec          41.0192
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.4626  -0.8674  -0.1835]
        Angle    117.5966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4655"
}

Galaxy "NGC 4656:UGC 7907:MCG 5-30-66:ZWG 159.65"
{
        Type  "Irr"
        RA           12.7328
        Dec          32.1697
        Distance   4.091e+07  # method: V
        Radius     9.103e+04
        AbsMag        -19.79
        Axis    [  0.9099  -0.2393   0.3388]
        Angle     89.0122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4656"
}

Galaxy "NGC 4657"
{
        Type  "Irr"
        RA           12.7350
        Dec          32.2092
        Distance   1.381e+08  # distance uncertain!
        Radius      2.61e+04
        AbsMag        -20.13
        Axis    [ -0.8261   0.5232   0.2092]
        Angle     45.6552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4657"
}

Galaxy "NGC 4658:MCG 2-33-1:IRAS 12420-0948"
{
        Type  "SBc"
        RA           12.7436
        Dec         -10.0844
        Distance   1.236e+08  # method: V
        Radius     3.775e+04
        AbsMag        -19.59
        Axis    [  0.9419  -0.2078  -0.2639]
        Angle    114.2848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4658"
}

Galaxy "NGC 4659:UGC 7915:MCG 2-33-7:ZWG 71.24"
{
        Type  "Sa"
        RA           12.7414
        Dec          13.4989
        Distance    3.23e+07  # method: V
        Radius          8456
        AbsMag        -16.88
        Axis    [ -0.8508   0.4029  -0.3373]
        Angle     61.6490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4659"
}

Galaxy "NGC 4660:UGC 7914:MCG 2-33-6:ZWG 71.23"
{
        Type  "E0"
        RA           12.7419
        Dec          11.1906
        Distance   4.183e+07  # method: S
        Radius     1.277e+04
        AbsMag        -18.34
        Axis    [  0.0687  -0.2145  -0.9743]
        Angle     77.4464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4660"
}

Galaxy "NGC 4661:NGC 4650B:ESO 322-72:MCG 7-26-40"
{
        Type  "S0"
        RA           12.7539
        Dec         -40.8244
        Distance   1.321e+08  # method: T-F
        Radius     2.306e+04
        AbsMag        -18.54
        Axis    [ -0.2710  -0.5079  -0.8177]
        Angle     53.5218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4661"
}

Galaxy "NGC 4662:UGC 7917:MCG 6-28-25:ZWG 188.18"
{
        Type  "SBc"
        RA           12.7406
        Dec          37.1211
        Distance   3.274e+08  # method: V
        Radius     9.048e+04
        AbsMag        -21.51
        Axis    [  0.7427  -0.6453  -0.1789]
        Angle     61.4683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4662"
}

Galaxy "NGC 4663:IC 811:MCG 2-33-2"
{
        Type  "S0"
        RA           12.7464
        Dec         -10.1981
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.8539   0.0908  -0.5124]
        Angle     70.3321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4663"
}

Galaxy "NGC 4664:NGC 4624:NGC 4665:UGC 7924"
{
        Type  "SBa"
        RA           12.7517
        Dec           3.0553
        Distance   5.051e+07  # method: V
        Radius     2.571e+04
        AbsMag        -19.75
        Axis    [  0.5795  -0.6935  -0.4281]
        Angle    136.2528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4664"
}

Galaxy "NGC 4666:UGC 7926:MCG 0-33-8:ZWG 15.15"
{
        Type  "SBc"
        RA           12.7522
        Dec          -0.4628
        Distance   6.392e+07  # method: T-F
        Radius     4.184e+04
        AbsMag        -19.96
        Axis    [  0.9522  -0.2525  -0.1720]
        Angle     73.3558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4666"
}

Galaxy "NGC 4668:UGC 7931:MCG 0-33-9:ZWG 15.16"
{
        Type  "SBc"
        RA           12.7586
        Dec          -0.5361
        Distance   8.861e+07  # method: V
        Radius     1.804e+04
        AbsMag        -18.57
        Axis    [  0.9059  -0.3462  -0.2440]
        Angle    113.5455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4668"
}

Galaxy "NGC 4669:UGC 7925:MCG 9-21-38:ZWG 270.18"
{
        Type  "Sb"
        RA           12.7461
        Dec          54.8761
        Distance   2.338e+08  # method: V
        Radius      6.12e+04
        AbsMag        -19.78
        Axis    [ -0.6564   0.6310   0.4135]
        Angle     72.4391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4669"
}

Galaxy "NGC 4670:UGC 7930:MCG 5-30-72:ZWG 159.69"
{
        Type  "SBa"
        RA           12.7544
        Dec          27.1258
        Distance    6.12e+07  # method: V
        Radius     1.246e+04
        AbsMag        -18.27
        Axis    [  0.5526  -0.4573  -0.6968]
        Angle     36.3958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4670"
}

Galaxy "NGC 4671:MCG 1-33-4:MK 1334"
{
        Type  "E0"
        RA           12.7631
        Dec          -7.0697
        Distance   2.188e+08  # distance uncertain!
        Radius     4.137e+04
        AbsMag        -20.13
        Axis    [ -0.3502   0.1231  -0.9286]
        Angle     92.8949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4671"
}

Galaxy "NGC 4672:ESO 322-73:MCG 7-26-41:AM 1243-412"
{
        Type  "Sa"
        RA           12.7708
        Dec         -41.7058
        Distance    2.06e+08  # method: T-F
        Radius     6.591e+04
        AbsMag           -20
        Axis    [  0.7465  -0.1029  -0.6574]
        Angle     79.2244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4672"
}

Galaxy "NGC 4673:UGC 7933:MCG 5-30-73:MK 656"
{
        Type  "E1"
        RA           12.7594
        Dec          27.0611
        Distance   3.282e+08  # method: V
        Radius     4.773e+04
        AbsMag        -20.91
        Axis    [ -0.3463   0.6167  -0.7070]
        Angle     80.0511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4673"
}

Galaxy "NGC 4674:MCG 1-33-5"
{
        Type  "SBa"
        RA           12.7675
        Dec          -8.6553
        Distance    1.47e+08  # distance uncertain!
        Radius     3.422e+04
        AbsMag        -19.07
        Axis    [ -0.3738  -0.6483  -0.6633]
        Angle     20.7742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4674"
}

Galaxy "NGC 4675:UGC 7935:MCG 9-21-39:ZWG 270.19"
{
        Type  "SBb"
        RA           12.7586
        Dec          54.7372
        Distance   2.251e+08  # method: V
        Radius     5.237e+04
        AbsMag        -19.09
        Axis    [  0.4567   0.0290   0.8892]
        Angle     44.9719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4675"
}

Galaxy "NGC 4676-1:NGC 4676A:IC 819:UGC 7938"
{
        Type  "SBa"
        RA           12.7694
        Dec          30.7325
        Distance   3.119e+08  # method: V
        Radius     6.351e+04
        AbsMag         -20.5
        Axis    [  0.9000  -0.4260   0.0919]
        Angle    116.6130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4676-1"
}

Galaxy "NGC 4676-2:NGC 4676B:IC 820:UGC 7939"
{
        Type  "Sa"
        RA           12.7697
        Dec          30.7225
        Distance   3.109e+08  # method: V
        Radius     9.948e+04
        AbsMag         -20.2
        Axis    [  0.9142  -0.3870   0.1204]
        Angle    115.1373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4676-2"
}

Galaxy "NGC 4677:ESO 322-78:MCG 7-26-44:DCL 199"
{
        Type  "SBa"
        RA           12.7825
        Dec         -41.5825
        Distance   1.548e+08  # method: V
        Radius     3.603e+04
        AbsMag        -19.58
        Axis    [ -0.7947  -0.3906  -0.4646]
        Angle     78.5681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4677"
}

Galaxy "NGC 4678-1:IC 824-2:MCG 1-33-18"
{
        Type  "Sc"
        RA           12.8283
        Dec          -4.5797
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.6359  -0.4527  -0.6251]
        Angle     43.2812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4678-1"
}

Galaxy "NGC 4678-2:IC 824-1:MCG 1-33-18:IRAS 12471-0418"
{
        Type  "S0"
        RA           12.8281
        Dec          -4.5803
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [  0.2657  -0.4644  -0.8448]
        Angle     34.9000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4678-2"
}

Galaxy "NGC 4679:ESO 322-82:MCG 6-28-18:DCL 209"
{
        Type  "SBc"
        RA           12.7917
        Dec         -39.5711
        Distance   1.691e+08  # method: T-F
        Radius     6.147e+04
        AbsMag        -20.07
        Axis    [  0.8779  -0.0057  -0.4788]
        Angle    117.2172
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4679"
}

Galaxy "NGC 4680:MCG 2-33-7:IRAS 12443-1121"
{
        Type  "S0"
        RA           12.7817
        Dec         -11.6364
        Distance   1.279e+08  # method: V
        Radius     2.791e+04
        AbsMag        -19.27
        Axis    [  0.6771  -0.4233  -0.6020]
        Angle     94.9089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4680"
}

Galaxy "NGC 4681:ESO 268-40:MCG 7-26-46:DCL 207"
{
        Type  "Sb"
        RA           12.7911
        Dec         -43.3347
        Distance   1.621e+08  # method: V
        Radius     3.301e+04
        AbsMag        -19.98
        Axis    [ -0.7204  -0.1273  -0.6818]
        Angle     99.9538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4681"
}

Galaxy "NGC 4682:MCG 2-33-8:IRAS 12446-0947"
{
        Type  "SBc"
        RA           12.7875
        Dec         -10.0639
        Distance   1.207e+08  # method: V
        Radius     4.388e+04
        AbsMag        -19.74
        Axis    [  0.5829  -0.4251  -0.6925]
        Angle     44.9890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4682"
}

Galaxy "NGC 4683:ESO 322-83:MCG 7-26-47:DRCG 56-18"
{
        Type  "S0"
        RA           12.7950
        Dec         -41.5289
        Distance   1.759e+08  # method: V
        Radius     3.327e+04
        AbsMag        -19.86
        Axis    [ -0.3986  -0.3089  -0.8636]
        Angle     78.0725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4683"
}

Galaxy "NGC 4684:UGC 7951:MCG 0-33-11:ZWG 15.19"
{
        Type  "SBa"
        RA           12.7881
        Dec          -2.7269
        Distance     4.4e+07  # method: S
        Radius     1.792e+04
        AbsMag        -18.25
        Axis    [  0.9382  -0.2624  -0.2258]
        Angle     93.4800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4684"
}

Galaxy "NGC 4685:UGC 7954:MCG 3-33-4:ZWG 100.7"
{
        Type  "S0"
        RA           12.7864
        Dec          19.4647
        Distance   3.198e+08  # method: V
        Radius     9.303e+04
        AbsMag        -21.26
        Axis    [ -0.8940   0.3944  -0.2126]
        Angle     40.0477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4685"
}

Galaxy "NGC 4686:UGC 7946:MCG 9-21-44:ZWG 270.21"
{
        Type  "Sa"
        RA           12.7775
        Dec          54.5344
        Distance   2.346e+08  # method: V
        Radius     6.825e+04
        AbsMag        -20.58
        Axis    [  0.8304  -0.4400   0.3419]
        Angle    120.7214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4686"
}

Galaxy "NGC 4687:UGC 7958:MCG 6-28-31:MK 442"
{
        Type  "E1"
        RA           12.7897
        Dec          35.3519
        Distance   4.186e+07  # method: V
        Radius          4262
        AbsMag        -16.34
        Axis    [  0.0567   0.0768  -0.9954]
        Angle     53.4830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4687"
}

Galaxy "NGC 4688:UGC 7961:MCG 1-33-13:ZWG 43.28"
{
        Type  "SBc"
        RA           12.7961
        Dec           4.3358
        Distance   5.953e+07  # method: V
        Radius      2.77e+04
        AbsMag        -18.61
        Axis    [ -0.2505  -0.0643  -0.9660]
        Angle     49.3802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4688"
}

Galaxy "NGC 4689:UGC 7965:MCG 2-33-22:ZWG 71.43"
{
        Type  "Sc"
        RA           12.7958
        Dec          13.7622
        Distance   8.743e+07  # method: V
        Radius     5.468e+04
        AbsMag        -20.64
        Axis    [ -0.7406   0.3893  -0.5477]
        Angle     53.8939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4689"
}

Galaxy "NGC 4690:UGC 7964:MCG 0-33-12:ZWG 15.21"
{
        Type  "S0"
        RA           12.7986
        Dec          -1.6561
        Distance   1.281e+08  # distance uncertain!
        Radius     2.235e+04
        AbsMag        -19.07
        Axis    [ -0.7946   0.0436  -0.6056]
        Angle     48.2591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4690"
}

Galaxy "NGC 4691:MCG 0-33-13:UGCA 299:ZWG 15.23"
{
        Type  "SBa"
        RA           12.8036
        Dec          -3.3325
        Distance   6.532e+07  # method: V
        Radius     2.565e+04
        AbsMag        -19.51
        Axis    [  0.2500  -0.3753  -0.8925]
        Angle     71.7861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4691"
}

Galaxy "NGC 4692:NGC 4702:UGC 7967:MCG 5-30-86"
{
        Type  "E0"
        RA           12.7986
        Dec          27.2222
        Distance   3.227e+08  # method: T-F
        Radius     6.102e+04
        AbsMag        -21.28
        Axis    [  0.4843  -0.8238  -0.2945]
        Angle    125.2845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4692"
}

Galaxy "NGC 4693:UGC 7962:MCG 12-12-18:ZWG 335.23"
{
        Type  "Sc"
        RA           12.7858
        Dec          71.1761
        Distance   7.787e+07  # method: V
        Radius     2.718e+04
        AbsMag        -17.89
        Axis    [  0.6935  -0.3017   0.6542]
        Angle    108.2616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4693"
}

Galaxy "NGC 4694:UGC 7969:MCG 2-33-23:ZWG 71.44"
{
        Type  "S0"
        RA           12.8039
        Dec          10.9839
        Distance   6.763e+07  # method: V
        Radius     3.246e+04
        AbsMag        -19.48
        Axis    [ -0.9574   0.0812  -0.2772]
        Angle     26.3840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4694"
}

Galaxy "NGC 4695:IC 3791:UGC 7966:MCG 9-21-48"
{
        Type  "SBc"
        RA           12.7922
        Dec          54.3744
        Distance   2.306e+08  # method: V
        Radius      3.69e+04
        AbsMag        -19.95
        Axis    [  0.7691  -0.3555   0.5311]
        Angle     41.7990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4695"
}

Galaxy "NGC 4696:ESO 322-91:MCG 7-26-51:AM 1246-410"
{
        Type  "E1"
        RA           12.8136
        Dec         -41.3117
        Distance   1.157e+08  # method: S
        Radius     7.911e+04
        AbsMag        -21.55
        Axis    [ -0.1582  -0.1816  -0.9706]
        Angle    126.5222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696"
}

Galaxy "NGC 4696A:ESO 322-77:MCG 7-26-43:DCL 197"
{
        Type  "SBb"
        RA           12.7819
        Dec         -41.4975
        Distance   1.308e+08  # method: V
        Radius     2.474e+04
        AbsMag        -18.62
        Axis    [ -0.8342  -0.4060  -0.3731]
        Angle     81.4424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696A"
}

Galaxy "NGC 4696B:ESO 322-81:MCG 7-26-45:DCL 205"
{
        Type  "S0"
        RA           12.7892
        Dec         -41.2372
        Distance   1.527e+08  # method: V
        Radius     2.664e+04
        AbsMag        -20.45
        Axis    [  0.6590  -0.2010  -0.7248]
        Angle     99.9751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696B"
}

Galaxy "NGC 4696C:ESO 322-87:MCG 7-26-48:DRCG 56-67"
{
        Type  "Sb"
        RA           12.8006
        Dec         -40.8194
        Distance   1.398e+08  # method: T-F
        Radius     3.659e+04
        AbsMag        -18.66
        Axis    [ -0.5571  -0.6544  -0.5112]
        Angle     51.4415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696C"
}

Galaxy "NGC 4696D:ESO 322-88:MCG 7-26-49:DRCG 56-10"
{
        Type  "S0"
        RA           12.8058
        Dec         -41.7144
        Distance   1.463e+08  # method: V
        Radius     4.044e+04
        AbsMag        -19.46
        Axis    [ -0.4537  -0.6552  -0.6040]
        Angle     49.2005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696D"
}

Galaxy "NGC 4696E:ESO 322-90:MCG 7-26-50:DRCG 56-62"
{
        Type  "S0"
        RA           12.8072
        Dec         -40.9353
        Distance   1.463e+08  # method: V
        Radius     3.831e+04
        AbsMag        -18.86
        Axis    [  0.8765  -0.0051  -0.4814]
        Angle    121.9114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4696E"
}

Galaxy "NGC 4697:MCG 1-33-10:UGCA 300"
{
        Type  "E6"
        RA           12.8097
        Dec          -5.8000
        Distance   3.832e+07  # method: S
        Radius     4.013e+04
        AbsMag        -20.15
        Axis    [  0.2303  -0.4235  -0.8761]
        Angle    103.2994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4697"
}

Galaxy "NGC 4698:UGC 7970:MCG 2-33-24:ZWG 71.45"
{
        Type  "Sb"
        RA           12.8064
        Dec           8.4883
        Distance   1.025e+08  # method: T-F
        Radius     5.964e+04
        AbsMag        -20.99
        Axis    [ -0.9218   0.2675  -0.2805]
        Angle     57.6871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4698"
}

Galaxy "NGC 4699:MCG 1-33-13:UGCA 301:IRAS 12464-0823"
{
        Type  "SBb"
        RA           12.8172
        Dec          -8.6639
        Distance   7.973e+07  # method: V
        Radius     4.407e+04
        AbsMag        -21.54
        Axis    [  0.7016  -0.4218  -0.5743]
        Angle     85.9938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4699"
}

Galaxy "NGC 4700:MCG 2-33-13:IRAS 12465-1108"
{
        Type  "SBc"
        RA           12.8186
        Dec         -11.4117
        Distance   7.869e+07  # method: V
        Radius     3.662e+04
        AbsMag        -19.11
        Axis    [  0.9365  -0.2079  -0.2824]
        Angle     67.5521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4700"
}

Galaxy "NGC 4701:UGC 7975:MCG 1-33-15:ZWG 43.34"
{
        Type  "Sc"
        RA           12.8197
        Dec           3.3889
        Distance   4.757e+07  # method: V
        Radius     1.937e+04
        AbsMag        -18.02
        Axis    [  0.7379  -0.4869  -0.4674]
        Angle     80.6857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4701"
}

Galaxy "NGC 4703:MCG 1-33-15:FGC 1504"
{
        Type  "Sb"
        RA           12.8217
        Dec          -9.1083
        Distance   1.688e+08  # distance uncertain!
        Radius     7.366e+04
        AbsMag        -19.07
        Axis    [ -0.9404  -0.3366   0.0491]
        Angle     46.0270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4703"
}

Galaxy "NGC 4704:UGC 7972:MCG 7-26-54:ZWG 216.31"
{
        Type  "SBc"
        RA           12.8128
        Dec          41.9211
        Distance   3.801e+08  # method: V
        Radius     5.528e+04
        AbsMag        -20.83
        Axis    [  0.5650  -0.1818  -0.8048]
        Angle     21.1187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4704"
}

Galaxy "NGC 4705:MCG 1-33-16:IRAS 12468-0455"
{
        Type  "SBc"
        RA           12.8233
        Dec          -5.1953
        Distance   1.443e+08  # method: T-F
        Radius     6.505e+04
        AbsMag        -19.63
        Axis    [ -0.6457  -0.5781  -0.4989]
        Angle     20.7686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4705"
}

Galaxy "NGC 4706:ESO 323-1:MCG 7-26-55:DRCG 56-44"
{
        Type  "S0"
        RA           12.8317
        Dec         -41.2794
        Distance   1.806e+08  # method: V
        Radius     3.415e+04
        AbsMag        -19.92
        Axis    [  0.8040  -0.0751  -0.5898]
        Angle    102.1455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4706"
}

Galaxy "NGC 4707:UGC 7971:MCG 9-21-50:DDO 150"
{
        Type  "Irr"
        RA           12.8064
        Dec          51.1633
        Distance   2.926e+07  # method: V
        Radius          9364
        AbsMag        -16.16
        Axis    [  0.5757  -0.8152  -0.0639]
        Angle     89.2372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4707"
}

Galaxy "NGC 4708:MCG 2-33-16:IRAS 12470-1049"
{
        Type  "Sb"
        RA           12.8281
        Dec         -11.0936
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.6219  -0.4178  -0.6623]
        Angle     80.4457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4708"
}

Galaxy "NGC 4709:ESO 323-3:MCG 7-26-56:AM 1247-410"
{
        Type  "E1"
        RA           12.8342
        Dec         -41.3825
        Distance   1.152e+08  # method: S
        Radius     3.854e+04
        AbsMag        -20.64
        Axis    [ -0.2039  -0.1612  -0.9656]
        Angle    125.6636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4709"
}

Galaxy "NGC 4710:UGC 7980:MCG 3-33-9:ZWG 100.11"
{
        Type  "Sa"
        RA           12.8272
        Dec          15.1647
        Distance   6.464e+07  # method: V
        Radius     4.607e+04
        AbsMag        -19.58
        Axis    [  0.9648  -0.2515   0.0774]
        Angle     89.2636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4710"
}

Galaxy "NGC 4711:IC 3804:UGC 7973:MCG 6-28-33"
{
        Type  "SBb"
        RA           12.8125
        Dec          35.3328
        Distance   1.952e+08  # method: V
        Radius     3.692e+04
        AbsMag        -19.59
        Axis    [  0.8407  -0.5363   0.0746]
        Angle     76.2426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4711"
}

Galaxy "NGC 4712:UGC 7977:MCG 4-30-21:ZWG 129.25"
{
        Type  "Sc"
        RA           12.8261
        Dec          25.4697
        Distance   2.114e+08  # method: V
        Radius     7.071e+04
        AbsMag        -20.76
        Axis    [ -0.8999   0.3660   0.2371]
        Angle     45.0049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4712"
}

Galaxy "NGC 4713:UGC 7985:MCG 1-33-18:ZWG 43.41"
{
        Type  "SBc"
        RA           12.8325
        Dec           5.3111
        Distance   6.338e+07  # method: T-F
        Radius     2.673e+04
        AbsMag        -19.34
        Axis    [  0.3406  -0.4647  -0.8173]
        Angle     30.4755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4713"
}

Galaxy "NGC 4714:MCG 2-33-18"
{
        Type  "S0"
        RA           12.8386
        Dec         -13.3244
        Distance   1.168e+08  # distance uncertain!
        Radius     2.718e+04
        AbsMag        -19.07
        Axis    [ -0.6977  -0.0473  -0.7148]
        Angle     61.6686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4714"
}

Galaxy "NGC 4715:UGC 7986:MCG 5-30-96:ZWG 159.85"
{
        Type  "Sa"
        RA           12.8325
        Dec          27.8228
        Distance   3.258e+08  # method: V
        Radius     7.583e+04
        AbsMag         -19.6
        Axis    [  0.8228  -0.5648  -0.0640]
        Angle     96.6491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4715"
}

Galaxy "NGC 4716:MCG 1-33-21"
{
        Type  "S0"
        RA           12.8425
        Dec          -9.4508
        Distance   2.184e+08  # method: V
        Radius     3.494e+04
        AbsMag        -19.83
        Axis    [  0.6751  -0.4058  -0.6161]
        Angle     69.6222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4716"
}

Galaxy "NGC 4717:MCG 1-33-23"
{
        Type  "SBa"
        RA           12.8428
        Dec          -9.4628
        Distance   2.195e+08  # method: V
        Radius      4.47e+04
        AbsMag        -19.04
        Axis    [  0.9461  -0.1975  -0.2565]
        Angle    104.3280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4717"
}

Galaxy "NGC 4718:MCG 1-33-20:IRAS 12479-0500"
{
        Type  "SBb"
        RA           12.8422
        Dec          -5.2819
        Distance    2.29e+08  # method: V
        Radius     5.994e+04
        AbsMag        -20.03
        Axis    [  0.6045  -0.5796  -0.5465]
        Angle     26.7809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4718"
}

Galaxy "NGC 4719:UGC 7987:MCG 6-28-35:MK 446"
{
        Type  "SBb"
        RA           12.8356
        Dec          33.1592
        Distance   3.328e+08  # method: V
        Radius     6.777e+04
        AbsMag        -21.04
        Axis    [  0.7613  -0.6450  -0.0657]
        Angle    101.5502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4719"
}

Galaxy "NGC 4720:MCG 1-33-24:IRAS 12481-0352"
{
        Type  "S0"
        RA           12.8450
        Dec          -4.1558
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [ -0.4185  -0.3307  -0.8458]
        Angle     31.1992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4720"
}

Galaxy "NGC 4721:MCG 5-30-97:ZWG 159.86"
{
        Type  "S0"
        RA           12.8386
        Dec          27.3247
        Distance   3.685e+08  # method: V
        Radius     4.287e+04
        AbsMag        -19.76
        Axis    [  0.1661  -0.0478   0.9850]
        Angle     14.2036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4721"
}

Galaxy "NGC 4722:IC 3833:MCG 2-33-31:IRAS 12488-1303"
{
        Type  "Sa"
        RA           12.8589
        Dec         -13.3300
        Distance   7.429e+07  # method: V
        Radius     1.945e+04
        AbsMag        -18.09
        Axis    [  0.8918  -0.2472  -0.3790]
        Angle     83.9026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4722"
}

Galaxy "NGC 4723:MCG 2-33-26"
{
        Type  "Irr"
        RA           12.8508
        Dec         -13.2367
        Distance   3.631e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -20.13
        Axis    [  0.7624  -0.3636  -0.5353]
        Angle     87.7897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4723"
}

Galaxy "NGC 4724:MCG 2-33-22"
{
        Type  "S0"
        RA           12.8481
        Dec         -14.3322
        Distance   1.168e+08  # distance uncertain!
        Radius     1.529e+04
        AbsMag        -19.07
        Axis    [  0.2068  -0.3929  -0.8960]
        Angle     53.2570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4724"
}

Galaxy "NGC 4725:UGC 7989:MCG 4-30-22:ZWG 129.27"
{
        Type  "SBb"
        RA           12.8406
        Dec          25.5000
        Distance    4.32e+07  # method: S
        Radius     6.722e+04
        AbsMag        -20.51
        Axis    [  0.8120  -0.5682  -0.1332]
        Angle     82.3312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4725"
}

Galaxy "NGC 4726"
{
        Type  "S0"
        RA           12.8461
        Dec         -14.2678
        Distance   3.072e+08  # distance uncertain!
        Radius     5.362e+04
        AbsMag        -19.07
        Axis    [  0.8837  -0.3358  -0.3261]
        Angle     41.3067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4726"
}

Galaxy "NGC 4727:MCG 2-33-23:IRAS 12483-1403"
{
        Type  "SBc"
        RA           12.8492
        Dec         -14.3331
        Distance   3.601e+08  # method: V
        Radius     8.381e+04
        AbsMag        -22.51
        Axis    [ -0.4354  -0.1875  -0.8805]
        Angle     55.9586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4727"
}

Galaxy "NGC 4728:NGC 4728A:MCG 5-30-98:ZWG 159.87"
{
        Type  "E1"
        RA           12.8411
        Dec          27.4353
        Distance   3.065e+08  # method: V
        Radius     4.458e+04
        AbsMag        -19.26
        Axis    [  0.0777  -0.1239  -0.9892]
        Angle     60.5250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4728"
}

Galaxy "NGC 4728B:UGC 7992:MCG 5-30-100:KUG 1248+276"
{
        Type  "Sc"
        RA           12.8436
        Dec          27.4253
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.9080  -0.3983   0.1301]
        Angle     80.2837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4728B"
}

Galaxy "NGC 4728C"
{
        Type  "S0"
        RA           12.8433
        Dec          27.4836
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.8566  -0.5159  -0.0093]
        Angle    116.4704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4728C"
}

Galaxy "NGC 4729:ESO 323-16:MCG 7-27-2:DCL 314"
{
        Type  "E0"
        RA           12.8628
        Dec         -41.1322
        Distance   1.634e+08  # method: V
        Radius     3.804e+04
        AbsMag         -20.1
        Axis    [  0.6134  -0.4659  -0.6377]
        Angle    164.2403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4729"
}

Galaxy "NGC 4730:ESO 323-17:MCG 7-27-3:DRCG 56-54"
{
        Type  "S0"
        RA           12.8667
        Dec         -41.1469
        Distance   1.071e+08  # method: V
        Radius     1.558e+04
        AbsMag        -18.88
        Axis    [  0.6266  -0.4509  -0.6357]
        Angle    162.3489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4730"
}

Galaxy "NGC 4731:MCG 1-33-26:UGCA 302:IRAS 12484-0607"
{
        Type  "SBc"
        RA           12.8503
        Dec          -6.3925
        Distance   8.267e+07  # method: V
        Radius     7.936e+04
        AbsMag        -19.82
        Axis    [  0.2912  -0.4305  -0.8543]
        Angle     44.0819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4731"
}

Galaxy "NGC 4731A:MCG 1-33-27"
{
        Type  "Irr"
        RA           12.8536
        Dec          -6.5597
        Distance   1.047e+08  # distance uncertain!
        Radius      1.98e+04
        AbsMag        -20.13
        Axis    [  0.6955  -0.4809  -0.5339]
        Angle    102.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4731A"
}

Galaxy "NGC 4732:UGC 7988:MCG 9-21-53:ZWG 270.26"
{
        Type  "E0"
        RA           12.8353
        Dec          52.8500
        Distance   3.312e+08  # distance uncertain!
        Radius      5.78e+04
        AbsMag        -20.13
        Axis    [  0.3830  -0.9127  -0.1427]
        Angle    107.2617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4732"
}

Galaxy "NGC 4733:UGC 7997:MCG 2-33-28:ZWG 71.54"
{
        Type  "E0"
        RA           12.8517
        Dec          10.9119
        Distance   4.869e+07  # method: S
        Radius     1.558e+04
        AbsMag        -18.17
        Axis    [  0.5288  -0.7506  -0.3962]
        Angle    134.0298
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4733"
}

Galaxy "NGC 4734:UGC 7998:MCG 1-33-19:ZWG 43.45"
{
        Type  "Sc"
        RA           12.8533
        Dec           4.8586
        Distance   3.555e+08  # method: V
        Radius     5.171e+04
        AbsMag        -20.89
        Axis    [ -0.6514   0.1379  -0.7461]
        Angle     48.2384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4734"
}

Galaxy "NGC 4735:MCG 5-30-104:ZWG 159.91:KUG 1248+291"
{
        Type  "SBc"
        RA           12.8503
        Dec          28.9281
        Distance    3.05e+08  # method: V
        Radius     2.662e+04
        AbsMag        -19.45
        Axis    [  0.7952  -0.3513   0.4943]
        Angle     13.2714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4735"
}

Galaxy "M 94:NGC 4736:UGC 7996:MCG 7-26-58"
{
        Type  "Sb"
        RA           12.8481
        Dec          41.1214
        Distance   1.696e+07  # method: S
        Radius     3.552e+04
        AbsMag        -19.68
        Axis    [  0.3003   0.3984  -0.8667]
        Angle     12.8393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 94"
}

Galaxy "NGC 4737:MCG 6-28-36:ZWG 188.25:NPM 1"
{
        Type  "Sb"
        RA           12.8478
        Dec          34.1572
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.8261  -0.5635   0.0092]
        Angle     66.3548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4737"
}

Galaxy "NGC 4738:UGC 7999:MCG 5-30-103:ZWG 159.92"
{
        Type  "Sc"
        RA           12.8522
        Dec          28.7883
        Distance    2.28e+08  # method: V
        Radius     6.964e+04
        AbsMag        -19.52
        Axis    [  0.9208  -0.2500   0.2994]
        Angle     87.4412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4738"
}

Galaxy "NGC 4739:MCG 1-33-29"
{
        Type  "E0"
        RA           12.8603
        Dec          -8.4097
        Distance   1.852e+08  # method: V
        Radius     3.772e+04
        AbsMag        -20.27
        Axis    [ -0.5303   0.2901  -0.7967]
        Angle     98.1890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4739"
}

Galaxy "NGC 4740:IC 3834:MCG 2-33-30"
{
        Type  "Sb"
        RA           12.8589
        Dec         -14.2208
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.4828  -0.4344  -0.7604]
        Angle     47.7595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4740"
}

Galaxy "NGC 4741:UGC 8000:MCG 8-23-98:ZWG 244.45"
{
        Type  "Sc"
        RA           12.8497
        Dec          47.6717
        Distance   4.115e+08  # method: V
        Radius     8.379e+04
        AbsMag         -21.1
        Axis    [ -0.6520   0.6814   0.3325]
        Angle     53.8791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4741"
}

Galaxy "NGC 4742:MCG 2-33-32:UGCA 303:IRAS 12490-1009"
{
        Type  "E4"
        RA           12.8633
        Dec         -10.4547
        Distance   5.052e+07  # method: S
        Radius      1.91e+04
        AbsMag        -18.65
        Axis    [  0.1296  -0.3510  -0.9274]
        Angle    103.3196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4742"
}

Galaxy "NGC 4743:ESO 323-21:MCG 7-27-5:DRCG 56-25"
{
        Type  "S0"
        RA           12.8708
        Dec         -41.3900
        Distance   1.446e+08  # method: V
        Radius     2.945e+04
        AbsMag        -19.83
        Axis    [ -0.8456  -0.4246  -0.3236]
        Angle     82.3896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4743"
}

Galaxy "NGC 4744:ESO 323-22:MCG 7-27-6:DRCG 56-57"
{
        Type  "SBa"
        RA           12.8719
        Dec         -41.0606
        Distance   1.664e+08  # method: V
        Radius     5.082e+04
        AbsMag        -19.94
        Axis    [ -0.3047  -0.4407  -0.8443]
        Angle     62.7028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4744"
}

Galaxy "NGC 4745:NGC 4745A:MCG 5-30-105A:ZWG 159.94"
{
        Type  "S0"
        RA           12.8572
        Dec          27.4217
        Distance   3.407e+08  # method: V
        Radius     3.964e+04
        AbsMag        -18.99
        Axis    [  0.5013  -0.8181  -0.2818]
        Angle    124.8875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4745"
}

Galaxy "NGC 4745B"
{
        Type  "S0"
        RA           12.8561
        Dec          27.4442
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.9252  -0.3624   0.1126]
        Angle    107.5400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4745B"
}

Galaxy "NGC 4746:UGC 8007:MCG 2-33-29:ZWG 71.60"
{
        Type  "Sb"
        RA           12.8653
        Dec          12.0831
        Distance   9.481e+07  # method: V
        Radius     2.896e+04
        AbsMag        -19.62
        Axis    [ -0.5084  -0.5186   0.6874]
        Angle     10.9983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4746"
}

Galaxy "NGC 4747:UGC 8005:MCG 4-30-23:ZWG 129.28"
{
        Type  "SBc"
        RA           12.8625
        Dec          25.7739
        Distance    6.65e+07  # method: V
        Radius     3.192e+04
        AbsMag        -18.65
        Axis    [  0.9139  -0.3938   0.0986]
        Angle     87.1173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4747"
}

Galaxy "NGC 4748:MCG 2-33-34:IRAS 12495-1308"
{
        Type  "Sa"
        RA           12.8700
        Dec         -13.4136
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.5764  -0.4504  -0.6819]
        Angle     97.7975
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4748"
}

Galaxy "NGC 4749:UGC 8006:MCG 12-12-20:ZWG 335.26"
{
        Type  "Sb"
        RA           12.8533
        Dec          71.6350
        Distance   8.195e+07  # method: V
        Radius     2.026e+04
        AbsMag         -17.7
        Axis    [ -0.3845   0.5541   0.7383]
        Angle     79.2203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4749"
}

Galaxy "NGC 4750:UGC 7994:MCG 12-12-19:ZWG 335.25"
{
        Type  "Sa"
        RA           12.8350
        Dec          72.8744
        Distance   7.592e+07  # method: V
        Radius     2.319e+04
        AbsMag        -19.73
        Axis    [  0.0410   0.9937   0.1039]
        Angle     42.0351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4750"
}

Galaxy "NGC 4751:ESO 323-29:MCG 7-27-11:DCL 340"
{
        Type  "S0"
        RA           12.8806
        Dec         -42.6600
        Distance   1.019e+08  # method: V
        Radius     4.447e+04
        AbsMag        -20.27
        Axis    [ -0.8352  -0.4308  -0.3419]
        Angle     82.7900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4751"
}

Galaxy "NGC 4752:ZWG 71.58"
{
        Type  "S0"
        RA           12.8581
        Dec          13.7825
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.9834   0.1815   0.0046]
        Angle     39.4433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4752"
}

Galaxy "NGC 4753:UGC 8009:MCG 0-33-16:ZWG 15.29"
{
        Type  "S0"
        RA           12.8728
        Dec          -1.2000
        Distance   7.681e+07  # method: S
        Radius     6.703e+04
        AbsMag        -20.96
        Axis    [  0.7195  -0.4698  -0.5115]
        Angle     41.8373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4753"
}

Galaxy "NGC 4754:UGC 8010:MCG 2-33-30:ZWG 71.62"
{
        Type  "S0"
        RA           12.8714
        Dec          11.3139
        Distance   5.488e+07  # method: S
        Radius     3.512e+04
        AbsMag        -19.63
        Axis    [  0.8913  -0.4227  -0.1639]
        Angle     94.3715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4754"
}

Galaxy "NGC 4756:MCG 2-33-39:DRCG 25-59"
{
        Type  "S0"
        RA           12.8811
        Dec         -15.4125
        Distance   2.002e+08  # method: V
        Radius     4.951e+04
        AbsMag        -20.54
        Axis    [  0.6175  -0.4081  -0.6724]
        Angle     87.7544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4756"
}

Galaxy "NGC 4757:MCG 2-33-40"
{
        Type  "S0"
        RA           12.8803
        Dec         -10.3108
        Distance   2.226e+08  # distance uncertain!
        Radius     4.855e+04
        AbsMag        -19.07
        Axis    [  0.9017  -0.2888  -0.3217]
        Angle     56.6276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4757"
}

Galaxy "NGC 4758:UGC 8014:MCG 3-33-15:ZWG 100.15"
{
        Type  "Irr"
        RA           12.8786
        Dec          15.8486
        Distance   5.504e+07  # method: T-F
        Radius     2.402e+04
        AbsMag        -17.24
        Axis    [ -0.9291   0.0871   0.3594]
        Angle     47.3834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4758"
}

Galaxy "NGC 4759A:NGC 4776:MCG 1-33-36:HCG 62B"
{
        Type  "S0"
        RA           12.8844
        Dec          -9.1997
        Distance   1.803e+08  # method: V
        Radius     4.982e+04
        AbsMag        -19.71
        Axis    [  0.7394  -0.5008  -0.4500]
        Angle    127.2077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4759A"
}

Galaxy "NGC 4760:MCG 2-33-41"
{
        Type  "E0"
        RA           12.8853
        Dec         -10.4947
        Distance   2.001e+08  # method: T-F
        Radius     5.822e+04
        AbsMag        -21.34
        Axis    [  0.5358  -0.6237  -0.5690]
        Angle    139.7553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4760"
}

Galaxy "NGC 4761:MCG 1-33-39:HCG 62"
{
        Type  "E0"
        RA           12.8858
        Dec          -9.1975
        Distance   2.124e+08  # method: V
        Radius     2.471e+04
        AbsMag        -19.17
        Axis    [ -0.5797   0.3362  -0.7422]
        Angle    101.0150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4761"
}

Galaxy "NGC 4762:UGC 8016:MCG 2-33-33:ZWG 71.65"
{
        Type  "S0"
        RA           12.8819
        Dec          11.2306
        Distance   5.862e+07  # method: V
        Radius     7.417e+04
        AbsMag        -20.17
        Axis    [  0.9759  -0.2029   0.0800]
        Angle     87.1387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4762"
}

Galaxy "NGC 4763:MCG 3-33-13:IRAS 12507-1643"
{
        Type  "SBa"
        RA           12.8908
        Dec         -17.0058
        Distance    1.98e+08  # method: V
        Radius     3.455e+04
        AbsMag        -20.42
        Axis    [ -0.3803  -0.2894  -0.8784]
        Angle     51.4883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4763"
}

Galaxy "NGC 4764:HCG 62"
{
        Type  "E2"
        RA           12.8850
        Dec          -9.2575
        Distance   5.755e+08  # distance uncertain!
        Radius     2.511e+04
        AbsMag        -20.13
        Axis    [ -0.1554  -0.1113  -0.9816]
        Angle     94.0545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4764"
}

Galaxy "NGC 4765:UGC 8018:MCG 1-33-20:ZWG 43.54"
{
        Type  "Sa"
        RA           12.8872
        Dec           4.4631
        Distance   4.743e+07  # method: V
        Radius          7588
        AbsMag        -17.41
        Axis    [  0.5367  -0.4854  -0.6902]
        Angle     50.7671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4765"
}

Galaxy "NGC 4766:MCG 2-33-42"
{
        Type  "S0"
        RA           12.8856
        Dec         -10.3786
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [ -0.7042  -0.5590  -0.4377]
        Angle     27.1192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4766"
}

Galaxy "NGC 4767:ESO 323-36:MCG 6-28-23:DCL 362"
{
        Type  "E0"
        RA           12.8978
        Dec         -39.7144
        Distance    1.07e+08  # method: S
        Radius     4.047e+04
        AbsMag        -20.08
        Axis    [ -0.3021  -0.1123  -0.9466]
        Angle    122.2992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4767"
}

Galaxy "NGC 4767A:ESO 323-31:MCG 7-27-11A:DCL 347"
{
        Type  "Sc"
        RA           12.8836
        Dec         -39.8358
        Distance    4.05e+08  # distance uncertain!
        Radius     4.712e+04
        AbsMag        -19.07
        Axis    [ -0.1653  -0.4938  -0.8537]
        Angle     54.7682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4767A"
}

Galaxy "NGC 4767B:ESO 323-41:MCG 7-27-15:DCL 379"
{
        Type  "SBc"
        RA           12.9122
        Dec         -39.8531
        Distance   1.475e+08  # method: T-F
        Radius     2.789e+04
        AbsMag        -19.48
        Axis    [  0.0065  -0.3433  -0.9392]
        Angle     78.0645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4767B"
}

Galaxy "NGC 4770:MCG 1-33-40"
{
        Type  "Sa"
        RA           12.8922
        Dec          -9.5411
        Distance   1.223e+08  # distance uncertain!
        Radius     2.668e+04
        AbsMag        -19.07
        Axis    [  0.4230  -0.4684  -0.7757]
        Angle     43.0925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4770"
}

Galaxy "NGC 4771:UGC 8020:MCG 0-33-17:ZWG 15.31"
{
        Type  "Sc"
        RA           12.8889
        Dec           1.2700
        Distance   6.623e+07  # method: V
        Radius      3.66e+04
        AbsMag        -18.54
        Axis    [ -0.8817  -0.4362   0.1798]
        Angle     22.3460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4771"
}

Galaxy "NGC 4772:UGC 8021:MCG 0-33-18:ZWG 15.32"
{
        Type  "Sa"
        RA           12.8914
        Dec           2.1686
        Distance   6.188e+07  # method: V
        Radius      3.06e+04
        AbsMag        -19.79
        Axis    [ -0.9278  -0.0429  -0.3705]
        Angle     37.0033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4772"
}

Galaxy "NGC 4773-1:MCG 1-33-41"
{
        Type  "E0"
        RA           12.8931
        Dec          -8.6383
        Distance   3.312e+08  # distance uncertain!
        Radius     6.262e+04
        AbsMag        -20.13
        Axis    [  0.0755  -0.3134  -0.9466]
        Angle     99.2485
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4773-1"
}

Galaxy "NGC 4773-2:MCG 1-33-42"
{
        Type  "E4"
        RA           12.8931
        Dec          -8.6453
        Distance   5.249e+08  # distance uncertain!
        Radius     3.053e+04
        AbsMag        -20.13
        Axis    [  0.5685  -0.6518  -0.5020]
        Angle    145.0742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4773-2"
}

Galaxy "NGC 4774:MCG 6-28-37:ZWG 188.26:ARAK 392"
{
        Type  "S0"
        RA           12.8850
        Dec          36.8189
        Distance   3.887e+08  # method: V
        Radius     3.392e+04
        AbsMag        -20.38
        Axis    [  0.8668  -0.4927   0.0773]
        Angle     26.8334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4774"
}

Galaxy "NGC 4775:MCG 1-33-43:UGCA 306:IRAS 12511-0621"
{
        Type  "Sc"
        RA           12.8958
        Dec          -6.6228
        Distance   8.594e+07  # method: V
        Radius      2.75e+04
        AbsMag         -20.3
        Axis    [  0.2915  -0.4212  -0.8589]
        Angle     83.7832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4775"
}

Galaxy "NGC 4777:MCG 1-33-44"
{
        Type  "Sa"
        RA           12.8994
        Dec          -8.7753
        Distance   1.688e+08  # distance uncertain!
        Radius     4.665e+04
        AbsMag        -19.07
        Axis    [  0.9236  -0.2504  -0.2903]
        Angle    102.7167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4777"
}

Galaxy "NGC 4778:NGC 4759B:MCG 1-33-37:HCG 62A"
{
        Type  "Sa"
        RA           12.8847
        Dec          -9.2039
        Distance   2.122e+08  # method: V
        Radius     5.246e+04
        AbsMag        -20.47
        Axis    [  0.1571  -0.4152  -0.8961]
        Angle     45.2222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4778"
}

Galaxy "NGC 4779:UGC 8022:MCG 2-33-34:MK 781"
{
        Type  "SBc"
        RA           12.8972
        Dec           9.7092
        Distance   1.425e+08  # method: V
        Radius     4.352e+04
        AbsMag         -20.2
        Axis    [  0.5336  -0.5254  -0.6628]
        Angle     63.2019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4779"
}

Galaxy "NGC 4780:MCG 1-33-45:IRAS 12515-0821"
{
        Type  "SBc"
        RA           12.9014
        Dec          -8.6208
        Distance   1.732e+08  # method: V
        Radius     4.534e+04
        AbsMag        -19.52
        Axis    [  0.7401  -0.4683  -0.4826]
        Angle    113.0773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4780"
}

Galaxy "NGC 4780A"
{
        Type  "Sb"
        RA           12.9008
        Dec          -8.6533
        Distance   1.916e+08  # method: V
        Radius     1.951e+04
        AbsMag        -18.24
        Axis    [  0.8983  -0.2841  -0.3352]
        Angle     88.6393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4780A"
}

Galaxy "NGC 4781:MCG 2-33-49:IRAS 12517-1015"
{
        Type  "SBc"
        RA           12.9064
        Dec         -10.5361
        Distance   7.176e+07  # method: V
        Radius     3.548e+04
        AbsMag        -19.91
        Axis    [ -0.3651  -0.5407  -0.7578]
        Angle     28.5849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4781"
}

Galaxy "NGC 4782:MCG 2-33-50:VV 201:C 278"
{
        Type  "E0"
        RA           12.9097
        Dec         -12.5692
        Distance   2.001e+08  # method: T-F
        Radius      5.24e+04
        AbsMag        -21.24
        Axis    [ -0.4877   0.1884  -0.8524]
        Angle     98.5587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4782"
}

Galaxy "NGC 4783:MCG 2-33-51:VV 201:C 278"
{
        Type  "E0"
        RA           12.9100
        Dec         -12.5581
        Distance   2.001e+08  # method: T-F
        Radius     6.695e+04
        AbsMag        -21.24
        Axis    [ -0.0817  -0.1929  -0.9778]
        Angle     98.6668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4783"
}

Galaxy "NGC 4784:MCG 2-33-53"
{
        Type  "S0"
        RA           12.9103
        Dec         -10.6128
        Distance   2.125e+08  # distance uncertain!
        Radius     5.873e+04
        AbsMag        -19.07
        Axis    [  0.4132  -0.8467  -0.3353]
        Angle     19.3223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4784"
}

Galaxy "NGC 4785:ESO 219-4:IRAS 12506-4828"
{
        Type  "Sb"
        RA           12.8908
        Dec         -48.7497
        Distance   1.803e+08  # method: V
        Radius     5.243e+04
        AbsMag        -20.51
        Axis    [  0.2667  -0.3135  -0.9114]
        Angle     78.0967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4785"
}

Galaxy "NGC 4786:MCG 1-33-46"
{
        Type  "E0"
        RA           12.9089
        Dec          -6.8592
        Distance    2.29e+08  # method: T-F
        Radius     5.328e+04
        AbsMag        -21.43
        Axis    [ -0.5573   0.3328  -0.7607]
        Angle     98.2269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4786"
}

Galaxy "NGC 4787:UGC 8026:MCG 5-30-121:ZWG 159.111"
{
        Type  "Sa"
        RA           12.9014
        Dec          27.0683
        Distance   3.583e+08  # method: V
        Radius     5.732e+04
        AbsMag         -19.7
        Axis    [  0.9382  -0.3258   0.1168]
        Angle    116.1073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4787"
}

Galaxy "NGC 4788:MCG 5-30-123:ZWG 160.7:ZWG 159.112"
{
        Type  "SBa"
        RA           12.9044
        Dec          27.3031
        Distance    3.05e+08  # method: V
        Radius     3.549e+04
        AbsMag        -19.45
        Axis    [ -0.7994   0.3212   0.5077]
        Angle     28.0711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4788"
}

Galaxy "NGC 4789:UGC 8028:MCG 5-30-124:ZWG 159.113"
{
        Type  "S0"
        RA           12.9053
        Dec          27.0678
        Distance   3.227e+08  # method: T-F
        Radius     8.919e+04
        AbsMag        -21.88
        Axis    [ -0.7486   0.5959  -0.2906]
        Angle     56.7701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4789"
}

Galaxy "NGC 4789A:UGC 8024:MCG 5-30-120:DDO 154"
{
        Type  "Irr"
        RA           12.9014
        Dec          27.1472
        Distance   2.945e+07  # method: V
        Radius          7709
        AbsMag        -15.88
        Axis    [  0.7986  -0.5889  -0.1243]
        Angle     82.6413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4789A"
}

Galaxy "NGC 4790:MCG 2-33-56:IRAS 12522-0958"
{
        Type  "SBc"
        RA           12.9142
        Dec         -10.2478
        Distance   7.633e+07  # method: V
        Radius     1.665e+04
        AbsMag        -18.75
        Axis    [  0.3604  -0.4507  -0.8167]
        Angle     47.6436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4790"
}

Galaxy "NGC 4791:MCG 1-33-21:ZWG 43.60:NPM 1"
{
        Type  "S0"
        RA           12.9119
        Dec           8.0536
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.6792  -0.5135  -0.5244]
        Angle     54.8306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4791"
}

Galaxy "NGC 4792:NPM 1"
{
        Type  "S0"
        RA           12.9175
        Dec         -12.4967
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.7760  -0.3437  -0.5289]
        Angle     39.6715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4792"
}

Galaxy "NGC 4793:UGC 8033:MCG 5-31-3:ZWG 160.11"
{
        Type  "SBc"
        RA           12.9111
        Dec          28.9381
        Distance   1.244e+08  # method: V
        Radius     5.249e+04
        AbsMag        -20.61
        Axis    [  0.8736  -0.4807   0.0753]
        Angle     67.1522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4793"
}

Galaxy "NGC 4794:MCG 2-33-60"
{
        Type  "SBa"
        RA           12.9194
        Dec         -12.6092
        Distance   1.688e+08  # distance uncertain!
        Radius     4.174e+04
        AbsMag        -19.07
        Axis    [ -0.8986  -0.2533  -0.3584]
        Angle     48.3328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4794"
}

Galaxy "NGC 4795:UGC 8037:MCG 1-33-24:ZWG 43.64"
{
        Type  "SBa"
        RA           12.9172
        Dec           8.0661
        Distance   1.402e+08  # method: V
        Radius     4.689e+04
        AbsMag        -20.07
        Axis    [ -0.2273  -0.2546  -0.9399]
        Angle     28.2547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4795"
}

Galaxy "NGC 4796:NPM 1"
{
        Type  "E0"
        RA           12.9178
        Dec           8.0669
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.1139  -0.3338  -0.9357]
        Angle     82.8222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4796"
}

Galaxy "NGC 4798:NGC 4797:UGC 8038:MCG 5-31-4"
{
        Type  "S0"
        RA           12.9153
        Dec          27.4128
        Distance   3.601e+08  # method: V
        Radius     5.237e+04
        AbsMag        -21.01
        Axis    [  0.8093  -0.5798  -0.0947]
        Angle     87.4525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4798"
}

Galaxy "NGC 4799:UGC 8043:MCG 1-33-25:ZWG 43.66"
{
        Type  "Sc"
        RA           12.9208
        Dec           2.8967
        Distance   1.418e+08  # method: V
        Radius     2.682e+04
        AbsMag        -18.89
        Axis    [  0.6462  -0.5584  -0.5202]
        Angle     30.6753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4799"
}

Galaxy "NGC 4800:UGC 8035:MCG 8-24-4:ZWG 245.5"
{
        Type  "Sb"
        RA           12.9103
        Dec          46.5314
        Distance   4.557e+07  # method: V
        Radius     1.061e+04
        AbsMag        -18.33
        Axis    [  0.7389  -0.6671   0.0953]
        Angle     91.3163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4800"
}

Galaxy "NGC 4801:MCG 9-21-60:ZWG 270.30:NPM 1"
{
        Type  "S0"
        RA           12.9103
        Dec          53.0906
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.2534   0.9539   0.1608]
        Angle     25.8147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4801"
}

Galaxy "NGC 4803:MCG 2-33-36:ZWG 71.73:ZWG 43.69"
{
        Type  "E0"
        RA           12.9258
        Dec           8.2400
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.5141  -0.7313  -0.4481]
        Angle    131.6049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4803"
}

Galaxy "NGC 4804:NGC 4802:MCG 2-33-61:IRAS 12532-1147"
{
        Type  "S0"
        RA           12.9303
        Dec         -12.0547
        Distance   3.762e+07  # method: S
        Radius     1.313e+04
        AbsMag        -17.71
        Axis    [  0.8151  -0.3689  -0.4468]
        Angle    105.7472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4804"
}

Galaxy "NGC 4806:ESO 443-12:MCG 5-31-3:AM 1253-291"
{
        Type  "SBc"
        RA           12.9367
        Dec         -29.5028
        Distance   1.237e+08  # method: V
        Radius     2.159e+04
        AbsMag        -19.49
        Axis    [  0.5047  -0.3653  -0.7822]
        Angle    102.2030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4806"
}

Galaxy "NGC 4807:UGC 8049:MCG 5-31-6:ZWG 160.17"
{
        Type  "S0"
        RA           12.9247
        Dec          27.5211
        Distance   3.227e+08  # method: T-F
        Radius     4.694e+04
        AbsMag        -20.48
        Axis    [  0.7552  -0.6381  -0.1498]
        Angle     97.4920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4807"
}

Galaxy "NGC 4807A"
{
        Type  "E5"
        RA           12.9250
        Dec          27.5439
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [ -0.0616   0.0854  -0.9944]
        Angle     59.6528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4807A"
}

Galaxy "NGC 4808:UGC 8054:MCG 1-33-28:ZWG 43.71"
{
        Type  "Sc"
        RA           12.9300
        Dec           4.3036
        Distance   7.081e+07  # method: T-F
        Radius     2.884e+04
        AbsMag        -19.38
        Axis    [ -0.8168  -0.4493  -0.3620]
        Angle     17.4904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4808"
}

Galaxy "NGC 4809:UGC 8034:MCG 1-33-22:ZWG 43.62"
{
        Type  "Irr"
        RA           12.9139
        Dec           2.6528
        Distance   5.622e+07  # method: V
        Radius      1.39e+04
        AbsMag        -16.58
        Axis    [  0.8566  -0.4255  -0.2919]
        Angle     49.9512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4809"
}

Galaxy "NGC 4810:MCG 1-33-23:ZWG 43.61:VV 313"
{
        Type  "Irr"
        RA           12.9142
        Dec           2.6408
        Distance   5.436e+07  # method: V
        Radius     1.028e+04
        AbsMag        -16.21
        Axis    [ -0.9976  -0.0101  -0.0683]
        Angle     48.6013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4810"
}

Galaxy "NGC 4811:ESO 323-47:MCG 7-27-19:AM 1254-413"
{
        Type  "SBa"
        RA           12.9478
        Dec         -41.7975
        Distance   1.553e+08  # method: V
        Radius     2.937e+04
        AbsMag        -19.39
        Axis    [  0.6292  -0.2458  -0.7373]
        Angle    109.6417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4811"
}

Galaxy "NGC 4812:ESO 323-48:MCG 7-27-18:AM 1254-413"
{
        Type  "S0"
        RA           12.9478
        Dec         -41.8136
        Distance   1.635e+08  # method: V
        Radius     2.853e+04
        AbsMag         -19.3
        Axis    [  0.7611  -0.1111  -0.6391]
        Angle     90.3824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4812"
}

Galaxy "NGC 4813:MCG 1-33-55"
{
        Type  "S0"
        RA           12.9433
        Dec          -6.8181
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.9078  -0.2889  -0.3039]
        Angle     82.6452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4813"
}

Galaxy "NGC 4814:UGC 8051:MCG 10-19-3:ZWG 294.3"
{
        Type  "Sb"
        RA           12.9225
        Dec          58.3444
        Distance   1.202e+08  # method: V
        Radius     5.768e+04
        AbsMag        -20.33
        Axis    [  0.0152   0.8144   0.5801]
        Angle     24.2933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4814"
}

Galaxy "NGC 4816:UGC 8057:MCG 5-31-10:ZWG 160.21"
{
        Type  "S0"
        RA           12.9367
        Dec          27.7453
        Distance   3.227e+08  # method: T-F
        Radius     6.102e+04
        AbsMag        -21.08
        Axis    [  0.5982  -0.5696  -0.5636]
        Angle     40.3702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4816"
}

Galaxy "NGC 4817:NPM 1:DRCG 27-140"
{
        Type  "E0"
        RA           12.9414
        Dec          27.9403
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [  0.4677  -0.8341  -0.2923]
        Angle    126.3217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4817"
}

Galaxy "NGC 4818:MCG 1-33-57:IRAS 12542-0815"
{
        Type  "SBb"
        RA           12.9467
        Dec          -8.5250
        Distance   6.351e+07  # method: V
        Radius     3.972e+04
        AbsMag        -19.35
        Axis    [  0.9541  -0.1912  -0.2304]
        Angle    115.8663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4818"
}

Galaxy "NGC 4819:UGC 8060:MCG 5-31-14:ZWG 160.25"
{
        Type  "SBa"
        RA           12.9411
        Dec          26.9869
        Distance   3.142e+08  # method: V
        Radius     5.484e+04
        AbsMag        -20.82
        Axis    [ -0.8342   0.5305  -0.1505]
        Angle     43.3951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4819"
}

Galaxy "NGC 4820:MCG 2-33-67"
{
        Type  "S0"
        RA           12.9500
        Dec         -13.7189
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.3199  -0.8609  -0.3956]
        Angle     20.7852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4820"
}

Galaxy "NGC 4821:MCG 5-31-15:ZWG 160.24"
{
        Type  "E4"
        RA           12.9414
        Dec          26.9569
        Distance   3.268e+08  # method: V
        Radius     2.377e+04
        AbsMag         -19.5
        Axis    [  0.4663  -0.8227  -0.3252]
        Angle    122.6514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4821"
}

Galaxy "NGC 4822:MCG 2-33-69"
{
        Type  "S0"
        RA           12.9508
        Dec         -10.7622
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.3629  -0.4641  -0.8080]
        Angle     47.0921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4822"
}

Galaxy "NGC 4823"
{
        Type  "Sa"
        RA           12.9569
        Dec         -13.6983
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.9702  -0.2338  -0.0635]
        Angle     66.0207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4823"
}

Galaxy "NGC 4825:MCG 2-33-70"
{
        Type  "S0"
        RA           12.9533
        Dec         -13.6644
        Distance    2.15e+08  # method: V
        Radius     6.254e+04
        AbsMag        -21.19
        Axis    [ -0.6771  -0.2847  -0.6786]
        Angle     44.9426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4825"
}

Galaxy "M 64:NGC 4826:UGC 8062:MCG 4-31-1"
{
        Type  "Sb"
        RA           12.9453
        Dec          21.6831
        Distance    2.44e+07  # method: S
        Radius     3.549e+04
        AbsMag        -20.07
        Axis    [  0.0363  -0.8633  -0.5033]
        Angle      4.6957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 64"
}

Galaxy "NGC 4827:UGC 8065:MCG 5-31-16:ZWG 160.28"
{
        Type  "S0"
        RA           12.9453
        Dec          27.1786
        Distance   3.564e+08  # method: V
        Radius     7.258e+04
        AbsMag        -21.29
        Axis    [  0.6895  -0.6564  -0.3061]
        Angle     73.2046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4827"
}

Galaxy "NGC 4828:MCG 5-31-17:ZWG 160.29:NPM 1"
{
        Type  "S0"
        RA           12.9450
        Dec          28.0208
        Distance   2.901e+08  # method: V
        Radius     2.954e+04
        AbsMag        -19.15
        Axis    [  0.4907  -0.8253  -0.2795]
        Angle    125.4622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4828"
}

Galaxy "NGC 4829:NPM 1"
{
        Type  "E0"
        RA           12.9567
        Dec         -13.7372
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [ -0.0912  -0.1978  -0.9760]
        Angle     99.6594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4829"
}

Galaxy "NGC 4830:ESO 575-37:MCG 3-33-24"
{
        Type  "S0"
        RA           12.9575
        Dec         -19.6911
        Distance   1.262e+08  # method: T-F
        Radius     4.038e+04
        AbsMag        -19.94
        Axis    [ -0.8069  -0.1555  -0.5698]
        Angle     63.9322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4830"
}

Galaxy "NGC 4831:ESO 507-55:MCG 4-31-10"
{
        Type  "S0"
        RA           12.9600
        Dec         -27.2919
        Distance   1.646e+08  # method: V
        Radius     4.069e+04
        AbsMag        -20.11
        Axis    [ -0.9185  -0.2016  -0.3401]
        Angle     79.3090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4831"
}

Galaxy "NGC 4832:ESO 323-51:MCG 6-29-1:DCL 420"
{
        Type  "S0"
        RA           12.9631
        Dec         -39.7619
        Distance   1.783e+08  # method: V
        Radius     4.669e+04
        AbsMag        -21.09
        Axis    [  0.7047  -0.2275  -0.6721]
        Angle    113.7278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4832"
}

Galaxy "NGC 4834:MCG 9-21-67:ZWG 270.34"
{
        Type  "Sc"
        RA           12.9403
        Dec          52.2958
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [  0.2793   0.1118   0.9537]
        Angle     42.5997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4834"
}

Galaxy "NGC 4835:ESO 269-19:AM 1255-455:IRAS 12552-4559"
{
        Type  "SBc"
        RA           12.9686
        Dec         -46.2650
        Distance   9.404e+07  # method: T-F
        Radius     5.471e+04
        AbsMag         -19.9
        Axis    [ -0.6395  -0.6298  -0.4408]
        Angle     64.7337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4835"
}

Galaxy "NGC 4835A:ESO 269-15:FGCE 1010:IRAS 12543-4606"
{
        Type  "Sc"
        RA           12.9536
        Dec         -46.3772
        Distance   1.606e+08  # method: T-F
        Radius     5.841e+04
        AbsMag        -19.36
        Axis    [  0.8749   0.1412  -0.4632]
        Angle    114.4331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4835A"
}

Galaxy "NGC 4836:MCG 2-33-72:NPM 1:IRAS 12549-1228"
{
        Type  "Sc"
        RA           12.9594
        Dec         -12.7436
        Distance   2.482e+08  # method: V
        Radius     5.053e+04
        AbsMag        -20.31
        Axis    [  0.7982  -0.4170  -0.4348]
        Angle    123.5329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4836"
}

Galaxy "NGC 4837-1:UGC 8068:MCG 8-24-11:ZWG 245.6"
{
        Type  "Irr"
        RA           12.9464
        Dec          48.2961
        Distance   4.054e+08  # method: V
        Radius     6.486e+04
        AbsMag        -21.07
        Axis    [  0.7644  -0.3654   0.5311]
        Angle     55.5830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4837-1"
}

Galaxy "NGC 4837-2:UGC 8068:MCG 8-24-12:ZWG 245.6"
{
        Type  "Irr"
        RA           12.9469
        Dec          48.3000
        Distance   2.631e+08  # distance uncertain!
        Radius     3.826e+04
        AbsMag        -20.13
        Axis    [  0.6184  -0.1737   0.7665]
        Angle     42.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4837-2"
}

Galaxy "NGC 4838:MCG 2-33-74:IRAS 12552-1247"
{
        Type  "SBb"
        RA           12.9656
        Dec         -13.0603
        Distance   2.427e+08  # method: V
        Radius     5.648e+04
        AbsMag        -20.56
        Axis    [ -0.6307   0.0123  -0.7760]
        Angle     70.5167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4838"
}

Galaxy "NGC 4839:UGC 8070:MCG 5-31-25:ZWG 160.39"
{
        Type  "E0"
        RA           12.9567
        Dec          27.4975
        Distance   3.227e+08  # method: T-F
        Radius     1.878e+05
        AbsMag        -21.98
        Axis    [  0.3356  -0.6161  -0.7126]
        Angle     77.7662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4839"
}

Galaxy "NGC 4840:MCG 5-31-29:ZWG 160.42:DRCG 27-46"
{
        Type  "E1"
        RA           12.9589
        Dec          27.6106
        Distance    2.81e+08  # method: V
        Radius     2.861e+04
        AbsMag        -19.98
        Axis    [  0.4671  -0.8336  -0.2948]
        Angle    126.6460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4840"
}

Galaxy "NGC 4841-1:NGC 4841A:UGC 8072:MCG 5-31-26"
{
        Type  "E0"
        RA           12.9589
        Dec          28.4764
        Distance   3.208e+08  # method: V
        Radius     7.465e+04
        AbsMag        -20.86
        Axis    [ -0.0678   0.0991  -0.9928]
        Angle     58.6951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4841-1"
}

Galaxy "NGC 4841-2:NGC 4841B:UGC 8073:MCG 5-31-27"
{
        Type  "E0"
        RA           12.9594
        Dec          28.4822
        Distance   3.227e+08  # method: T-F
        Radius     4.694e+04
        AbsMag        -20.98
        Axis    [ -0.1501   0.2470  -0.9573]
        Angle     60.4272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4841-2"
}

Galaxy "NGC 4842-1:NGC 4842A:MCG 5-31-30:ZWG 160.46"
{
        Type  "E0"
        RA           12.9600
        Dec          27.4931
        Distance   3.428e+08  # method: V
        Radius     1.995e+04
        AbsMag        -20.11
        Axis    [  0.4674  -0.8332  -0.2956]
        Angle    126.7117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4842-1"
}

Galaxy "NGC 4842-2:NGC 4842B:MCG 5-31-31:ZWG 160.46"
{
        Type  "E3"
        RA           12.9600
        Dec          27.4844
        Distance   3.513e+08  # method: V
        Radius     1.533e+04
        AbsMag        -19.06
        Axis    [  0.3985  -0.7223  -0.5652]
        Angle     91.2661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4842-2"
}

Galaxy "NGC 4843:MCG 0-33-24:ZWG 15.48"
{
        Type  "Sa"
        RA           12.9667
        Dec          -3.6214
        Distance   2.381e+08  # method: V
        Radius     7.272e+04
        AbsMag        -20.32
        Axis    [  0.8298  -0.5284  -0.1795]
        Angle     30.3904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4843"
}

Galaxy "NGC 4846:UGC 8079:MCG 6-29-2:ZWG 188.32"
{
        Type  "SBc"
        RA           12.9631
        Dec          36.3700
        Distance   2.162e+08  # method: V
        Radius     4.088e+04
        AbsMag        -19.61
        Axis    [  0.8490  -0.4432   0.2879]
        Angle     57.8883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4846"
}

Galaxy "NGC 4847"
{
        Type  "E0"
        RA           12.9744
        Dec         -13.1411
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.4809  -0.5919  -0.6469]
        Angle    135.2187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4847"
}

Galaxy "NGC 4848:UGC 8082:MCG 5-31-39:ZWG 160.55"
{
        Type  "SBc"
        RA           12.9681
        Dec          28.2425
        Distance   3.336e+08  # method: V
        Radius     7.764e+04
        AbsMag        -20.65
        Axis    [ -0.8452   0.3112   0.4345]
        Angle     45.3821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4848"
}

Galaxy "NGC 4849:IC 3935:UGC 8086:MCG 5-31-44"
{
        Type  "S0"
        RA           12.9700
        Dec          26.3964
        Distance   2.772e+08  # method: V
        Radius     7.659e+04
        AbsMag        -20.55
        Axis    [ -0.8027   0.5635  -0.1953]
        Angle     58.9372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4849"
}

Galaxy "NGC 4850:MCG 5-31-40:ZWG 160.63:NPM 1"
{
        Type  "S0"
        RA           12.9725
        Dec          27.9683
        Distance   2.833e+08  # method: V
        Radius     2.884e+04
        AbsMag        -19.29
        Axis    [  0.7826  -0.5965  -0.1782]
        Angle     55.3377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4850"
}

Galaxy "NGC 4851-1:ZWG 160.61:DRCG 27-199"
{
        Type  "S0"
        RA           12.9725
        Dec          28.1478
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.5083  -0.3954   0.7650]
        Angle      8.4712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4851-1"
}

Galaxy "NGC 4851-2:DRCG 27-198"
{
        Type  "S0"
        RA           12.9728
        Dec          28.1519
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.7485  -0.5736  -0.3329]
        Angle     18.4615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4851-2"
}

Galaxy "NGC 4853:UGC 8092:MCG 5-31-48:ZWG 160.68"
{
        Type  "S0"
        RA           12.9764
        Dec          27.5958
        Distance   3.563e+08  # method: V
        Radius     4.146e+04
        AbsMag        -20.79
        Axis    [  0.5673  -0.5880  -0.5766]
        Angle     44.9642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4853"
}

Galaxy "NGC 4854:MCG 5-31-49:ZWG 160.70:DRCG 27-58"
{
        Type  "S0"
        RA           12.9797
        Dec          27.6742
        Distance   3.227e+08  # method: T-F
        Radius     5.633e+04
        AbsMag        -19.98
        Axis    [  0.8114  -0.5747  -0.1064]
        Angle     60.8070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4854"
}

Galaxy "NGC 4855:MCG 2-33-77"
{
        Type  "S0"
        RA           12.9883
        Dec         -13.2306
        Distance   1.281e+08  # distance uncertain!
        Radius     3.167e+04
        AbsMag        -19.07
        Axis    [ -0.7535  -0.0306  -0.6568]
        Angle     64.3983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4855"
}

Galaxy "NGC 4856:MCG 2-33-78:UGCA 313"
{
        Type  "SBa"
        RA           12.9892
        Dec         -15.0422
        Distance   7.583e+07  # method: V
        Radius     4.743e+04
        AbsMag        -20.33
        Axis    [  0.9177  -0.2101  -0.3371]
        Angle     79.4666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4856"
}

Galaxy "NGC 4857:UGC 8077:MCG 12-12-22:ZWG 335.29"
{
        Type  "SBb"
        RA           12.9550
        Dec          70.2031
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.2715   0.2231   0.9362]
        Angle     50.8552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4857"
}

Galaxy "NGC 4858:MCG 5-31-51:ZWG 160.213:DRCG 21-195"
{
        Type  "SBb"
        RA           12.9839
        Dec          28.1153
        Distance   4.405e+08  # method: V
        Radius     3.203e+04
        AbsMag        -19.65
        Axis    [  0.7420  -0.6443  -0.1855]
        Angle     83.2109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4858"
}

Galaxy "NGC 4859:UGC 8097:MCG 5-31-53:ZWG 160.71"
{
        Type  "Sa"
        RA           12.9836
        Dec          26.8156
        Distance   3.318e+08  # method: V
        Radius     6.273e+04
        AbsMag        -20.44
        Axis    [  0.7991  -0.5820  -0.1506]
        Angle     22.7477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4859"
}

Galaxy "NGC 4860:MCG 5-31-54:ZWG 160.215:DRCG 27-194"
{
        Type  "E2"
        RA           12.9844
        Dec          28.1233
        Distance   3.227e+08  # method: T-F
        Radius     4.225e+04
        AbsMag        -20.48
        Axis    [ -0.0904   0.1226  -0.9883]
        Angle     59.0294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4860"
}

Galaxy "NGC 4861:IC 3961:UGC 8098:MCG 6-29-3"
{
        Type  "Irr"
        RA           12.9836
        Dec          34.8619
        Distance   4.929e+07  # method: V
        Radius     3.011e+04
        AbsMag         -16.8
        Axis    [  0.8864  -0.4335   0.1626]
        Angle    104.3381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4861"
}

Galaxy "NGC 4862:IC 3999:MCG 2-33-79"
{
        Type  "SBc"
        RA           12.9917
        Dec         -14.1319
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.7554  -0.0755  -0.6509]
        Angle     61.9076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4862"
}

Galaxy "NGC 4863:MCG 2-33-81"
{
        Type  "Sa"
        RA           12.9950
        Dec         -14.0294
        Distance   2.127e+08  # method: V
        Radius     5.568e+04
        AbsMag        -19.47
        Axis    [  0.9598  -0.1301  -0.2489]
        Angle     90.0967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4863"
}

Galaxy "NGC 4864:MCG 5-31-58:ZWG 160.221:ARAK 397"
{
        Type  "E6"
        RA           12.9869
        Dec          27.9764
        Distance   3.227e+08  # method: T-F
        Radius     3.286e+04
        AbsMag        -20.38
        Axis    [ -0.1168   0.1662  -0.9791]
        Angle     59.5671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4864"
}

Galaxy "NGC 4865:UGC 8100:MCG 5-31-64:ZWG 160.224"
{
        Type  "E3"
        RA           12.9889
        Dec          28.0842
        Distance   2.199e+08  # method: V
        Radius     2.878e+04
        AbsMag        -19.54
        Axis    [  0.0039  -0.0487  -0.9988]
        Angle     58.6256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4865"
}

Galaxy "NGC 4866:UGC 8102:MCG 2-33-45:ZWG 71.92"
{
        Type  "Sa"
        RA           12.9908
        Dec          14.1714
        Distance   1.038e+08  # method: V
        Radius     9.665e+04
        AbsMag        -20.51
        Axis    [  0.8336  -0.3991   0.3819]
        Angle     32.9781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4866"
}

Galaxy "NGC 4867:MCG 5-31-62:ZWG 160.222:DRCG 27-133"
{
        Type  "E3"
        RA           12.9875
        Dec          27.9706
        Distance   3.227e+08  # method: T-F
        Radius     2.347e+04
        AbsMag        -19.48
        Axis    [  0.4604  -0.8324  -0.3083]
        Angle    124.2537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4867"
}

Galaxy "NGC 4868:UGC 8099:MCG 6-29-4:ZWG 189.8"
{
        Type  "Sb"
        RA           12.9858
        Dec          37.3094
        Distance    2.22e+08  # method: V
        Radius     4.844e+04
        AbsMag        -21.16
        Axis    [  0.5180  -0.5388  -0.6643]
        Angle     37.0689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4868"
}

Galaxy "NGC 4869:MCG 5-31-65:ZWG 160.225:DRCG 27-105"
{
        Type  "E3"
        RA           12.9897
        Dec          27.9114
        Distance   3.227e+08  # method: T-F
        Radius     3.755e+04
        AbsMag        -20.18
        Axis    [  0.3160  -0.5949  -0.7391]
        Angle     75.1466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4869"
}

Galaxy "NGC 4870"
{
        Type  "S0"
        RA           12.9881
        Dec          37.0483
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.8928  -0.4199   0.1633]
        Angle    119.9242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4870"
}

Galaxy "NGC 4871:MCG 5-31-66:ZWG 160.227:DRCG 27-131"
{
        Type  "S0"
        RA           12.9917
        Dec          27.9564
        Distance   3.168e+08  # method: V
        Radius     3.226e+04
        AbsMag        -19.74
        Axis    [ -0.8079   0.5722  -0.1411]
        Angle     60.1627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4871"
}

Galaxy "NGC 4872:MCG 5-31-68:ZWG 160.230:DRCG 27-130"
{
        Type  "S0"
        RA           12.9928
        Dec          27.9467
        Distance   3.227e+08  # method: T-F
        Radius     2.347e+04
        AbsMag        -19.58
        Axis    [ -0.9353   0.3211  -0.1484]
        Angle      5.6877
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4872"
}

Galaxy "NGC 4873:MCG 5-31-69:ZWG 160.229:DRCG 27-155"
{
        Type  "S0"
        RA           12.9922
        Dec          27.9833
        Distance    2.71e+08  # method: V
        Radius     3.154e+04
        AbsMag         -19.5
        Axis    [  0.4998  -0.4752  -0.7242]
        Angle     18.2722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4873"
}

Galaxy "NGC 4874:UGC 8103:MCG 5-31-70:ZWG 160.231"
{
        Type  "E0"
        RA           12.9931
        Dec          27.9594
        Distance   3.227e+08  # method: T-F
        Radius     8.919e+04
        AbsMag        -22.08
        Axis    [  0.4626  -0.8368  -0.2930]
        Angle    126.8166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4874"
}

Galaxy "NGC 4875:ZWG 160.232:DRCG 27-104"
{
        Type  "S0"
        RA           12.9939
        Dec          27.9075
        Distance   3.657e+08  # method: V
        Radius     2.128e+04
        AbsMag        -19.55
        Axis    [ -0.3581   0.1651  -0.9190]
        Angle     14.2946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4875"
}

Galaxy "NGC 4876:MCG 5-31-73:ZWG 160.234:ARAK 398"
{
        Type  "E5"
        RA           12.9956
        Dec          27.9122
        Distance   3.227e+08  # method: T-F
        Radius     2.816e+04
        AbsMag        -19.58
        Axis    [  0.4432  -0.8069  -0.3906]
        Angle    112.0508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4876"
}

Galaxy "NGC 4877:MCG 2-33-86:IRAS 12577-1500"
{
        Type  "Sb"
        RA           13.0072
        Dec         -15.2828
        Distance   2.377e+08  # method: V
        Radius     7.607e+04
        AbsMag        -21.11
        Axis    [  0.9099  -0.2299  -0.3452]
        Angle    113.0951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4877"
}

Galaxy "NGC 4878:MCG 1-33-64"
{
        Type  "SBa"
        RA           13.0056
        Dec          -6.1039
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.4422  -0.4707  -0.7635]
        Angle     74.4975
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4878"
}

Galaxy "NGC 4880:UGC 8109:MCG 2-33-47:ZWG 71.94"
{
        Type  "SBa"
        RA           13.0028
        Dec          12.4833
        Distance   8.145e+07  # method: V
        Radius     3.672e+04
        AbsMag        -19.49
        Axis    [ -0.8016   0.3649  -0.4737]
        Angle     56.3475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4880"
}

Galaxy "NGC 4881:UGC 8106:MCG 5-31-75:ZWG 160.238"
{
        Type  "E0"
        RA           12.9992
        Dec          28.2464
        Distance   3.227e+08  # method: T-F
        Radius     4.694e+04
        AbsMag        -20.48
        Axis    [  0.4610  -0.8383  -0.2912]
        Angle    126.7439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4881"
}

Galaxy "NGC 4883:ZWG 160.237:DRCG 27-175"
{
        Type  "S0"
        RA           12.9989
        Dec          28.0342
        Distance   3.765e+08  # method: V
        Radius     2.738e+04
        AbsMag        -19.91
        Axis    [  0.8141  -0.5787  -0.0491]
        Angle     20.6254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4883"
}

Galaxy "NGC 4885:MCG 1-33-65:IRAS 12579-0635"
{
        Type  "S0"
        RA           13.0092
        Dec          -6.8531
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [ -0.5626  -0.0823  -0.8226]
        Angle     54.4049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4885"
}

Galaxy "NGC 4886:NGC 4882:MCG 5-31-76:ZWG 160.239"
{
        Type  "E0"
        RA           13.0011
        Dec          27.9864
        Distance   3.227e+08  # method: T-F
        Radius     2.816e+04
        AbsMag        -20.08
        Axis    [  0.4617  -0.8373  -0.2930]
        Angle    126.8829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4886"
}

Galaxy "NGC 4887:MCG 2-33-87:IRAS 12580-1423"
{
        Type  "Sa"
        RA           13.0108
        Dec         -14.6667
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.8576  -0.1891  -0.4782]
        Angle     55.2849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4887"
}

Galaxy "NGC 4888:MCG 1-33-66:VV 680"
{
        Type  "Sb"
        RA           13.0100
        Dec          -6.0756
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [ -0.3672  -0.6330  -0.6815]
        Angle     23.9156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4888"
}

Galaxy "NGC 4889:NGC 4884:UGC 8110:MCG 5-31-77"
{
        Type  "E0"
        RA           13.0022
        Dec          27.9764
        Distance   3.227e+08  # method: T-F
        Radius     1.314e+05
        AbsMag        -22.48
        Axis    [  0.2608  -0.5053  -0.8226]
        Angle     69.0570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4889"
}

Galaxy "NGC 4890:MCG 1-33-67:IRAS 12580-0420"
{
        Type  "Irr"
        RA           13.0106
        Dec          -4.6039
        Distance   1.995e+08  # distance uncertain!
        Radius     2.612e+04
        AbsMag        -20.13
        Axis    [  0.1918  -0.4192  -0.8874]
        Angle     53.0999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4890"
}

Galaxy "NGC 4892:UGC 8108:MCG 5-31-78:ZWG 160.81"
{
        Type  "S0"
        RA           13.0008
        Dec          26.8981
        Distance   2.793e+08  # method: V
        Radius     5.281e+04
        AbsMag        -19.86
        Axis    [  0.9396  -0.3021   0.1611]
        Angle    106.5235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4892"
}

Galaxy "NGC 4893:IC 4015:UGC 8111:MCG 6-29-8"
{
        Type  "S0"
        RA           12.9997
        Dec          37.1939
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.7527  -0.6584  -0.0005]
        Angle    117.4115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4893"
}

Galaxy "NGC 4894:ZWG 160.247:DRCG 27-122"
{
        Type  "S0"
        RA           13.0044
        Dec          27.9669
        Distance   2.202e+08  # method: V
        Radius     1.601e+04
        AbsMag        -18.15
        Axis    [  0.9292  -0.2736   0.2485]
        Angle     94.4158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4894"
}

Galaxy "NGC 4895:UGC 8113:MCG 5-31-81:ZWG 160.249"
{
        Type  "S0"
        RA           13.0050
        Dec          28.2017
        Distance   3.944e+08  # method: V
        Radius     1.033e+05
        AbsMag        -21.21
        Axis    [ -0.8310   0.3061   0.4644]
        Angle     40.1689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4895"
}

Galaxy "NGC 4895A:ZWG 160.245:RB 167:DRCG 27-207"
{
        Type  "E0"
        RA           13.0025
        Dec          28.1700
        Distance   3.167e+08  # method: V
        Radius     2.764e+04
        AbsMag        -19.34
        Axis    [  0.1360  -0.2873  -0.9481]
        Angle     61.2297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4895A"
}

Galaxy "NGC 4896:UGC 8117:MCG 5-31-84:ZWG 160.87"
{
        Type  "S0"
        RA           13.0083
        Dec          28.3464
        Distance   2.757e+08  # method: V
        Radius      4.01e+04
        AbsMag        -19.73
        Axis    [  0.8437  -0.5366  -0.0136]
        Angle    112.6463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4896"
}

Galaxy "NGC 4897:MCG 2-33-89:UGCA 316:IRAS 12583-1310"
{
        Type  "SBc"
        RA           13.0144
        Dec         -13.4489
        Distance   1.306e+08  # method: V
        Radius     5.129e+04
        AbsMag        -20.11
        Axis    [ -0.6533  -0.0128  -0.7570]
        Angle     68.5476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4897"
}

Galaxy "NGC 4898-1:MCG 5-31-82:ZWG 160.248:DRCG 27-121"
{
        Type  "E0"
        RA           13.0047
        Dec          27.9550
        Distance   3.139e+08  # method: V
        Radius     2.739e+04
        AbsMag        -20.32
        Axis    [  0.1993  -0.4005  -0.8944]
        Angle     64.5314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4898-1"
}

Galaxy "NGC 4898-2:RB 94:DRCG 27-120"
{
        Type  "E0"
        RA           13.0050
        Dec          27.9556
        Distance   2.884e+08  # distance uncertain!
        Radius     1.678e+04
        AbsMag        -20.13
        Axis    [  0.4614  -0.8373  -0.2933]
        Angle    126.9351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4898-2"
}

Galaxy "NGC 4899:MCG 2-33-90:IRAS 12583-1340"
{
        Type  "SBc"
        RA           13.0156
        Dec         -13.9453
        Distance    1.35e+08  # method: V
        Radius     5.105e+04
        AbsMag        -20.18
        Axis    [  0.8568  -0.3080  -0.4135]
        Angle    102.2819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4899"
}

Galaxy "NGC 4900:UGC 8116:MCG 1-33-35:ZWG 43.93"
{
        Type  "SBc"
        RA           13.0108
        Dec           2.5011
        Distance   5.844e+07  # method: V
        Radius      1.87e+04
        AbsMag        -19.27
        Axis    [  0.6741  -0.6290  -0.3873]
        Angle    131.0188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4900"
}

Galaxy "NGC 4901:UGC 8112:MCG 8-24-19:ZWG 245.9"
{
        Type  "S0"
        RA           12.9989
        Dec          47.2061
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.4113  -0.9007  -0.1398]
        Angle    118.2339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4901"
}

Galaxy "NGC 4902:MCG 2-33-92:UGCA 315:IRAS 12583-1414"
{
        Type  "SBb"
        RA           13.0164
        Dec         -14.5139
        Distance   1.335e+08  # method: V
        Radius     5.631e+04
        AbsMag        -21.36
        Axis    [  0.3447  -0.4301  -0.8344]
        Angle     85.3504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4902"
}

Galaxy "NGC 4903:ESO 443-30:MCG 5-31-13:AM 1258-303"
{
        Type  "SBc"
        RA           13.0228
        Dec         -30.9350
        Distance   2.378e+08  # method: V
        Radius     5.535e+04
        AbsMag        -20.61
        Axis    [  0.2953  -0.3650  -0.8829]
        Angle     89.1448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4903"
}

Galaxy "NGC 4904:UGC 8121:MCG 0-33-26:MK 1341"
{
        Type  "SBc"
        RA           13.0161
        Dec          -0.0269
        Distance    6.75e+07  # method: V
        Radius      2.16e+04
        AbsMag        -18.78
        Axis    [  0.8084  -0.4576  -0.3703]
        Angle     98.2262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4904"
}

Galaxy "NGC 4905:ESO 443-31:MCG 5-31-15:AM 1258-303"
{
        Type  "SBa"
        RA           13.0250
        Dec         -30.8675
        Distance   2.539e+08  # method: V
        Radius     6.646e+04
        AbsMag        -20.16
        Axis    [  0.7512  -0.2619  -0.6059]
        Angle    105.9535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4905"
}

Galaxy "NGC 4906:ZWG 160.253:DRCG 27-118"
{
        Type  "E3"
        RA           13.0108
        Dec          27.9239
        Distance   3.227e+08  # method: T-F
        Radius     2.347e+04
        AbsMag        -19.88
        Axis    [  0.4609  -0.8375  -0.2936]
        Angle    127.0067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4906"
}

Galaxy "NGC 4907:MCG 5-31-89:ZWG 160.257:DRCG 27-205"
{
        Type  "SBb"
        RA           13.0133
        Dec          28.1569
        Distance   2.764e+08  # method: V
        Radius     4.423e+04
        AbsMag        -20.24
        Axis    [  0.6364  -0.6983  -0.3276]
        Angle     80.9696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4907"
}

Galaxy "NGC 4908:UGC 8129:MCG 5-31-90:ZWG 160-259"
{
        Type  "E0"
        RA           13.0150
        Dec          28.0069
        Distance   2.355e+08  # method: V
        Radius     3.425e+04
        AbsMag        -20.09
        Axis    [  0.0855  -0.2057  -0.9749]
        Angle     59.8683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4908"
}

Galaxy "NGC 4909:ESO 269-35:MCG 7-27-28:FAIR 462"
{
        Type  "Sa"
        RA           13.0336
        Dec         -42.7717
        Distance   1.794e+08  # method: V
        Radius     4.957e+04
        AbsMag         -20.1
        Axis    [  0.5651  -0.3246  -0.7585]
        Angle    129.6523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4909"
}

Galaxy "NGC 4910:NGC 4845:UGC 8078:MCG 0-33-25"
{
        Type  "Sb"
        RA           12.9667
        Dec           1.5756
        Distance   6.985e+07  # method: V
        Radius     4.978e+04
        AbsMag        -19.55
        Axis    [  0.8869  -0.4508  -0.1011]
        Angle     36.6207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4910"
}

Galaxy "NGC 4911:UGC 8128:MCG 5-31-93:ZWG 160.260"
{
        Type  "SBc"
        RA           13.0156
        Dec          27.7903
        Distance   3.723e+08  # method: V
        Radius     6.498e+04
        AbsMag        -21.69
        Axis    [ -0.2318   0.1777  -0.9564]
        Angle     32.7942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4911"
}

Galaxy "NGC 4911A:DRCG 27-62"
{
        Type  "S0"
        RA           13.0150
        Dec          27.7844
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.8712  -0.4869   0.0627]
        Angle     72.8451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4911A"
}

Galaxy "NGC 4914:UGC 8125:MCG 6-29-14:ZWG 189.13"
{
        Type  "E0"
        RA           13.0117
        Dec          37.3147
        Distance   2.225e+08  # method: V
        Radius     1.133e+05
        AbsMag        -21.67
        Axis    [ -0.2204   0.5777  -0.7860]
        Angle     62.7299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4914"
}

Galaxy "NGC 4915:MCG 1-33-69:UGCA 318"
{
        Type  "E0"
        RA           13.0244
        Dec          -4.5461
        Distance    1.33e+08  # method: T-F
        Radius     3.095e+04
        AbsMag        -19.95
        Axis    [  0.3025  -0.5256  -0.7951]
        Angle    109.6924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4915"
}

Galaxy "NGC 4917:UGC 8130:MCG 8-24-23:ZWG 245.11"
{
        Type  "SBb"
        RA           13.0153
        Dec          47.2225
        Distance   1.851e+08  # distance uncertain!
        Radius     4.039e+04
        AbsMag        -19.07
        Axis    [ -0.6020   0.7788   0.1765]
        Angle     44.4424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4917"
}

Galaxy "NGC 4918"
{
        Type  "Sa"
        RA           13.0306
        Dec          -4.5006
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.7459  -0.4629  -0.4789]
        Angle     51.1023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4918"
}

Galaxy "NGC 4919:UGC 8133:MCG 5-31-97:ZWG 160.94"
{
        Type  "S0"
        RA           13.0214
        Dec          27.8086
        Distance   3.392e+08  # method: V
        Radius     5.426e+04
        AbsMag        -20.08
        Axis    [ -0.8649   0.4804  -0.1455]
        Angle     22.5832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4919"
}

Galaxy "NGC 4920:IC 4134:MCG 2-33-94"
{
        Type  "Irr"
        RA           13.0344
        Dec         -11.3783
        Distance   2.291e+08  # distance uncertain!
        Radius     3.332e+04
        AbsMag        -20.13
        Axis    [ -0.8928   0.0249  -0.4499]
        Angle     68.8735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4920"
}

Galaxy "NGC 4921:UGC 8134:MCG 5-31-98:ZWG 160.95"
{
        Type  "SBb"
        RA           13.0239
        Dec          27.8856
        Distance   2.592e+08  # method: V
        Radius     9.048e+04
        AbsMag         -21.2
        Axis    [ -0.6594   0.6055  -0.4456]
        Angle     53.2248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4921"
}

Galaxy "NGC 4922-1:UGC 8135:MCG 5-31-99:ZWG 160.96"
{
        Type  "E0"
        RA           13.0233
        Dec          29.3078
        Distance   3.328e+08  # method: V
        Radius     6.293e+04
        AbsMag        -20.84
        Axis    [ -0.1118   0.1684  -0.9793]
        Angle     58.1617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4922-1"
}

Galaxy "NGC 4922-2:UGC 8135:MCG 5-31-99:ZWG 160.96"
{
        Type  "S0"
        RA           13.0236
        Dec          29.3131
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.7225  -0.6760  -0.1449]
        Angle    104.3057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4922-2"
}

Galaxy "NGC 4923:MCG 5-31-101:ZWG 160.97:DRCG 27-78"
{
        Type  "S0"
        RA           13.0253
        Dec          27.8469
        Distance   3.227e+08  # method: T-F
        Radius     3.755e+04
        AbsMag        -20.28
        Axis    [  0.4834  -0.8286  -0.2823]
        Angle    126.3183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4923"
}

Galaxy "NGC 4924:MCG 2-33-96:IRAS 12595-1442"
{
        Type  "SBa"
        RA           13.0367
        Dec         -14.9692
        Distance   1.168e+08  # distance uncertain!
        Radius     3.228e+04
        AbsMag        -19.07
        Axis    [  0.5857  -0.4254  -0.6900]
        Angle     75.7402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4924"
}

Galaxy "NGC 4925:MCG 1-33-74"
{
        Type  "S0"
        RA           13.0353
        Dec          -7.7106
        Distance   1.404e+08  # distance uncertain!
        Radius     2.042e+04
        AbsMag        -19.07
        Axis    [ -0.5863  -0.1841  -0.7889]
        Angle     46.8747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4925"
}

Galaxy "NGC 4926:UGC 8142:MCG 5-31-103:ZWG 160.103"
{
        Type  "S0"
        RA           13.0314
        Dec          27.6244
        Distance   3.227e+08  # method: T-F
        Radius     5.163e+04
        AbsMag        -20.98
        Axis    [  0.6051  -0.6757  -0.4211]
        Angle     67.8254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4926"
}

Galaxy "NGC 4926A:MCG 5-31-107:ZWG 160.106:IRAS 12596+2755"
{
        Type  "S0"
        RA           13.0356
        Dec          27.6481
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.8233  -0.5670   0.0272]
        Angle     27.8854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4926A"
}

Galaxy "NGC 4926B:DRCG 27-48"
{
        Type  "S0"
        RA           13.0333
        Dec          27.6536
        Distance   3.868e+08  # distance uncertain!
        Radius     3.375e+04
        AbsMag        -19.07
        Axis    [  0.8719  -0.4872   0.0488]
        Angle     81.9225
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4926B"
}

Galaxy "NGC 4927:MCG 5-31-104:ZWG 160.105:DRCG 27-141"
{
        Type  "S0"
        RA           13.0325
        Dec          28.0061
        Distance   3.549e+08  # method: V
        Radius     3.097e+04
        AbsMag        -20.38
        Axis    [  0.8155  -0.5761  -0.0551]
        Angle    103.0168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4927"
}

Galaxy "NGC 4928:MCG 1-33-75:IRAS 13004-0749"
{
        Type  "Sc"
        RA           13.0500
        Dec          -8.0847
        Distance   9.246e+07  # method: V
        Radius     1.479e+04
        AbsMag        -18.76
        Axis    [  0.5912  -0.4838  -0.6453]
        Angle     87.1074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4928"
}

Galaxy "NGC 4929:MCG 5-31-111:ZWG 160.113:DRCG 27-166"
{
        Type  "E1"
        RA           13.0456
        Dec          28.0453
        Distance   2.992e+08  # method: V
        Radius     3.481e+04
        AbsMag        -20.21
        Axis    [  0.4571  -0.8396  -0.2933]
        Angle    127.2909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4929"
}

Galaxy "NGC 4930:ESO 323-74:MCG 7-27-29:DCL 481"
{
        Type  "SBb"
        RA           13.0681
        Dec         -41.4114
        Distance   1.291e+08  # method: V
        Radius     8.262e+04
        AbsMag        -20.69
        Axis    [  0.5263  -0.3124  -0.7908]
        Angle    115.0744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4930"
}

Galaxy "NGC 4931:UGC 8154:MCG 5-31-114:ZWG 160.118"
{
        Type  "S0"
        RA           13.0503
        Dec          28.0319
        Distance   2.769e+08  # method: V
        Radius     6.443e+04
        AbsMag        -20.24
        Axis    [  0.8414  -0.4184   0.3420]
        Angle     42.6565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4931"
}

Galaxy "NGC 4932:UGC 8150:MCG 9-21-89:ZWG 270.40"
{
        Type  "Sc"
        RA           13.0436
        Dec          50.4392
        Distance   3.292e+08  # method: V
        Radius     7.181e+04
        AbsMag        -20.62
        Axis    [  0.6233  -0.7804   0.0493]
        Angle    116.5980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4932"
}

Galaxy "NGC 4933:NGC 4933A:IC 4176:MCG 2-33-102"
{
        Type  "Sa"
        RA           13.0656
        Dec         -11.4975
        Distance   1.611e+08  # method: V
        Radius     4.686e+04
        AbsMag        -20.47
        Axis    [  0.7306  -0.4075  -0.5478]
        Angle     72.1998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4933"
}

Galaxy "NGC 4933C:MCG 2-33-103"
{
        Type  "Irr"
        RA           13.0669
        Dec         -11.4908
        Distance   1.097e+09  # distance uncertain!
        Radius     7.975e+04
        AbsMag        -20.13
        Axis    [ -0.5199  -0.1499  -0.8410]
        Angle     57.7100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4933C"
}

Galaxy "NGC 4934:UGC 8160:MCG 5-31-115:ZWG 160.120"
{
        Type  "Sa"
        RA           13.0544
        Dec          28.0300
        Distance   2.881e+08  # method: V
        Radius      4.19e+04
        AbsMag        -19.63
        Axis    [  0.3786  -0.1667   0.9104]
        Angle     34.5059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4934"
}

Galaxy "NGC 4935:UGC 8159:MCG 3-33-23:ZWG 100.23"
{
        Type  "SBb"
        RA           13.0558
        Dec          14.3781
        Distance   3.042e+08  # method: V
        Radius     5.309e+04
        AbsMag        -20.85
        Axis    [  0.5348  -0.5705  -0.6233]
        Angle     55.2863
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4935"
}

Galaxy "NGC 4936:ESO 443-47:MCG 5-31-28:AM 1301-301"
{
        Type  "E0"
        RA           13.0714
        Dec         -30.5267
        Distance   1.088e+08  # method: T-F
        Radius     4.271e+04
        AbsMag        -20.91
        Axis    [ -0.6393   0.1547  -0.7533]
        Angle    113.8789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4936"
}

Galaxy "NGC 4938:MCG 9-21-91:ZWG 270.42"
{
        Type  "S0"
        RA           13.0492
        Dec          51.3192
        Distance    3.83e+08  # method: V
        Radius     4.456e+04
        AbsMag        -20.15
        Axis    [  0.6505  -0.7591   0.0246]
        Angle     77.8134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4938"
}

Galaxy "NGC 4939:MCG 2-33-104"
{
        Type  "Sc"
        RA           13.0706
        Dec         -10.3400
        Distance   1.414e+08  # method: T-F
        Radius     1.131e+05
        AbsMag        -21.08
        Axis    [  0.8988  -0.2937  -0.3253]
        Angle    114.6868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4939"
}

Galaxy "NGC 4940:ESO 269-42:IRAS 13021-4658"
{
        Type  "Sa"
        RA           13.0833
        Dec         -47.2369
        Distance   2.441e+08  # method: V
        Radius     3.551e+04
        AbsMag        -21.07
        Axis    [  0.6070  -0.4242  -0.6720]
        Angle    166.4213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4940"
}

Galaxy "NGC 4941:MCG 1-33-77:UGCA 321:IRAS 13016-0516"
{
        Type  "SBb"
        RA           13.0703
        Dec          -5.5514
        Distance   6.474e+07  # method: V
        Radius     3.672e+04
        AbsMag        -19.49
        Axis    [  0.8147  -0.4294  -0.3897]
        Angle    109.4439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4941"
}

Galaxy "NGC 4942:IC 4136:MCG 1-33-78:IRAS 13017-0723"
{
        Type  "SBc"
        RA           13.0719
        Dec          -7.6489
        Distance   9.391e+07  # method: V
        Radius     2.185e+04
        AbsMag         -18.6
        Axis    [ -0.6470  -0.0352  -0.7616]
        Angle     58.2763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4942"
}

Galaxy "NGC 4943:ZWG 160.122"
{
        Type  "S0"
        RA           13.0625
        Dec          28.0836
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.6675  -0.7417  -0.0650]
        Angle      7.3184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4943"
}

Galaxy "NGC 4944:UGC 8167:MCG 5-31-118:ZWG 160.124"
{
        Type  "Sa"
        RA           13.0639
        Dec          28.1853
        Distance   3.275e+08  # method: V
        Radius     7.145e+04
        AbsMag        -21.21
        Axis    [  0.7604  -0.3743   0.5307]
        Angle     34.4817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4944"
}

Galaxy "NGC 4945:ESO 219-24:AM 1302-484:IRAS 13025-4911"
{
        Type  "SBc"
        RA           13.0906
        Dec         -49.4628
        Distance   3.606e+07  # method: V
        Radius     1.038e+05
        AbsMag        -20.91
        Axis    [  0.7424  -0.0576  -0.6674]
        Angle     78.6135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4945"
}

Galaxy "NGC 4945A:ESO 219-28"
{
        Type  "Irr"
        RA           13.1092
        Dec         -49.6917
        Distance   7.253e+07  # method: V
        Radius     2.637e+04
        AbsMag        -18.73
        Axis    [  0.4452  -0.2638  -0.8557]
        Angle     99.6219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4945A"
}

Galaxy "NGC 4946:ESO 269-45:MCG 7-27-30:DCL 489"
{
        Type  "E0"
        RA           13.0914
        Dec         -43.5917
        Distance   1.554e+08  # method: S
        Radius     3.616e+04
        AbsMag        -19.89
        Axis    [ -0.4000  -0.0921  -0.9119]
        Angle    124.3814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4946"
}

Galaxy "NGC 4947:IC 3974:ESO 382-5:MCG 6-29-6"
{
        Type  "SBb"
        RA           13.0889
        Dec         -35.3369
        Distance   1.223e+08  # method: T-F
        Radius      4.27e+04
        AbsMag        -20.17
        Axis    [  0.8294  -0.1550  -0.5367]
        Angle    115.6100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4947"
}

Galaxy "NGC 4947A:ESO 382-4:MCG 6-29-5A"
{
        Type  "Irr"
        RA           13.0722
        Dec         -35.2283
        Distance     1.3e+08  # method: T-F
        Radius     3.215e+04
        AbsMag         -17.9
        Axis    [  0.8512  -0.1124  -0.5126]
        Angle    111.4465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4947A"
}

Galaxy "NGC 4948:IC 4156:MCG 1-33-79"
{
        Type  "SBc"
        RA           13.0819
        Dec          -7.9464
        Distance   7.475e+07  # method: V
        Radius     2.174e+04
        AbsMag         -16.6
        Axis    [ -0.9006  -0.3587  -0.2454]
        Angle     38.1806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4948"
}

Galaxy "NGC 4948A:MCG 1-33-80:DDO 162"
{
        Type  "SBc"
        RA           13.0847
        Dec          -8.1606
        Distance   8.489e+07  # method: V
        Radius     1.852e+04
        AbsMag        -18.08
        Axis    [  0.6916  -0.5087  -0.5127]
        Angle    113.7930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4948A"
}

Galaxy "NGC 4949"
{
        Type  "SBb"
        RA           13.0717
        Dec          29.0292
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6273  -0.4933   0.6026]
        Angle     12.8578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4949"
}

Galaxy "NGC 4950:ESO 269-47:MCG 7-27-31:DCL 490"
{
        Type  "S0"
        RA           13.0933
        Dec         -43.5003
        Distance   1.382e+08  # method: V
        Radius     1.809e+04
        AbsMag        -18.23
        Axis    [  0.7628  -0.2270  -0.6055]
        Angle    138.8524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4950"
}

Galaxy "NGC 4951:MCG 1-33-81:IRAS 13025-0613"
{
        Type  "SBc"
        RA           13.0853
        Dec          -6.4942
        Distance   5.336e+07  # method: T-F
        Radius     2.949e+04
        AbsMag        -18.37
        Axis    [  0.5363  -0.5841  -0.6092]
        Angle     35.8772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4951"
}

Galaxy "NGC 4953-1:ESO 382-8:MCG 6-29-9:VV 671"
{
        Type  "Sa"
        RA           13.1028
        Dec         -37.5861
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [  0.5290  -0.3225  -0.7849]
        Angle    103.8303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4953-1"
}

Galaxy "NGC 4953-2:ESO 382-8A:MCG 6-29-9:VV 671"
{
        Type  "S0"
        RA           13.1022
        Dec         -37.5969
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.4555  -0.3302  -0.8267]
        Angle     89.9513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4953-2"
}

Galaxy "NGC 4955:ESO 443-62:MCG 5-31-34:AM 1303-292"
{
        Type  "E2"
        RA           13.1011
        Dec         -29.7544
        Distance   1.088e+08  # method: T-F
        Radius     3.005e+04
        AbsMag        -19.51
        Axis    [  0.4571  -0.5083  -0.7299]
        Angle    146.0879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4955"
}

Galaxy "NGC 4956:UGC 8177:MCG 6-29-25:ZWG 189.17"
{
        Type  "S0"
        RA           13.0836
        Dec          35.1778
        Distance   2.261e+08  # method: V
        Radius     4.932e+04
        AbsMag         -20.9
        Axis    [  0.4520  -0.8615  -0.2314]
        Angle    123.8066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4956"
}

Galaxy "NGC 4957:UGC 8178:MCG 5-31-124:ZWG 160.130"
{
        Type  "E3"
        RA           13.0867
        Dec          27.5694
        Distance   3.227e+08  # method: T-F
        Radius     5.633e+04
        AbsMag        -20.98
        Axis    [  0.1137  -0.2911  -0.9499]
        Angle     61.3486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4957"
}

Galaxy "NGC 4958:MCG 1-33-84:UGCA 323"
{
        Type  "S0"
        RA           13.0967
        Dec          -8.0200
        Distance    7.04e+07  # method: V
        Radius     3.993e+04
        AbsMag        -19.97
        Axis    [  0.9374  -0.2357  -0.2564]
        Angle    107.5228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4958"
}

Galaxy "NGC 4959:MCG 6-29-29:ZWG 189.18:NPM 1"
{
        Type  "Sa"
        RA           13.0947
        Dec          33.1794
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.4582  -0.8541  -0.2460]
        Angle    124.7404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4959"
}

Galaxy "NGC 4961:NGC 4960:UGC 8185:MCG 5-31-126"
{
        Type  "SBc"
        RA           13.0964
        Dec          27.7342
        Distance   1.272e+08  # method: V
        Radius     2.959e+04
        AbsMag        -19.15
        Axis    [  0.6701  -0.6344  -0.3853]
        Angle     19.9878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4961"
}

Galaxy "NGC 4962:NGC 4952:UGC 8175:MCG 5-31-121"
{
        Type  "E0"
        RA           13.0828
        Dec          29.1225
        Distance    2.76e+08  # method: V
        Radius     7.226e+04
        AbsMag        -21.04
        Axis    [  0.4243  -0.8074  -0.4099]
        Angle    108.1141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4962"
}

Galaxy "NGC 4963:UGC 8190:MCG 7-27-30:ZWG 217.10"
{
        Type  "S0"
        RA           13.0975
        Dec          41.7214
        Distance   3.336e+08  # method: V
        Radius     3.881e+04
        AbsMag        -20.85
        Axis    [  0.4255  -0.8863  -0.1829]
        Angle    121.3878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4963"
}

Galaxy "NGC 4964:UGC 8184:MCG 9-22-7:ZWG 294.11"
{
        Type  "S0"
        RA           13.0900
        Dec          56.3231
        Distance   4.082e+07  # method: V
        Radius          6530
        AbsMag        -16.39
        Axis    [ -0.1678   0.5871   0.7919]
        Angle     34.1188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4964"
}

Galaxy "NGC 4965:ESO 443-70:MCG 5-31-36:UGCA 326"
{
        Type  "SBc"
        RA           13.1192
        Dec         -28.2283
        Distance   1.161e+08  # method: V
        Radius     4.053e+04
        AbsMag        -19.96
        Axis    [ -0.5036  -0.2077  -0.8386]
        Angle     76.5826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4965"
}

Galaxy "NGC 4966:UGC 8194:MCG 5-31-131:ZWG 160.137"
{
        Type  "SBb"
        RA           13.1047
        Dec          29.0628
        Distance     3.3e+08  # method: T-F
        Radius     4.799e+04
        AbsMag        -21.02
        Axis    [ -0.8622   0.3896   0.3237]
        Angle     26.1431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4966"
}

Galaxy "NGC 4967:MCG 9-22-5:ZWG 270.50:ZWG 271.6"
{
        Type  "E0"
        RA           13.0933
        Dec          53.5644
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.0528   0.5535  -0.8312]
        Angle     44.0575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4967"
}

Galaxy "NGC 4968:ESO 508-6:MCG 4-31-30:IRAS 13044-2324"
{
        Type  "S0"
        RA           13.1183
        Dec         -23.6769
        Distance   1.492e+08  # method: V
        Radius     4.124e+04
        AbsMag         -19.5
        Axis    [  0.6811  -0.3501  -0.6431]
        Angle     73.1058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4968"
}

Galaxy "NGC 4969-1:MCG 2-33-55:ZWG 72.4:KCPG 365A"
{
        Type  "S0"
        RA           13.1172
        Dec          13.6367
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.2569  -0.4672  -0.8460]
        Angle     43.8765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4969-1"
}

Galaxy "NGC 4969-2:MCG 2-33-55:ZWG 72.4"
{
        Type  "S0"
        RA           13.1175
        Dec          13.6367
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.5166  -0.7683  -0.3780]
        Angle    133.6636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4969-2"
}

Galaxy "NGC 4970:IC 4196:ESO 508-9:MCG 4-31-33"
{
        Type  "S0"
        RA           13.1258
        Dec         -24.0089
        Distance   1.613e+08  # method: V
        Radius     4.222e+04
        AbsMag        -20.27
        Axis    [ -0.6525  -0.3604  -0.6666]
        Angle     55.4356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4970"
}

Galaxy "NGC 4971:MCG 5-31-134:ZWG 160.140:NPM 1"
{
        Type  "S0"
        RA           13.1150
        Dec          28.5486
        Distance   3.016e+08  # method: V
        Radius     4.387e+04
        AbsMag        -19.63
        Axis    [  0.4723  -0.8361  -0.2792]
        Angle    126.8915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4971"
}

Galaxy "NGC 4972:NGC 4954:UGC 8157:MCG 13-9-44"
{
        Type  "S0"
        RA           13.0386
        Dec          75.4047
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [  0.6307  -0.5260   0.5706]
        Angle     63.9900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4972"
}

Galaxy "NGC 4973:IC 847:MCG 9-22-6:ZWG 270.49"
{
        Type  "E0"
        RA           13.0922
        Dec          53.6856
        Distance   3.312e+08  # distance uncertain!
        Radius     3.372e+04
        AbsMag        -20.13
        Axis    [  0.3493  -0.9311  -0.1051]
        Angle    117.4008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4973"
}

Galaxy "NGC 4974:MCG 9-22-9:ZWG 270.51:ZWG 271.7"
{
        Type  "S0"
        RA           13.0986
        Dec          53.6592
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [  0.0559   0.9938  -0.0958]
        Angle     15.4919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4974"
}

Galaxy "NGC 4975:MCG 1-34-2"
{
        Type  "S0"
        RA           13.1306
        Dec          -5.0175
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.7419  -0.4584  -0.4894]
        Angle     79.9430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4975"
}

Galaxy "NGC 4976:ESO 219-29"
{
        Type  "E4"
        RA           13.1436
        Dec         -49.5058
        Distance   3.471e+07  # method: T-F
        Radius     2.827e+04
        AbsMag        -19.03
        Axis    [ -0.6400   0.0183  -0.7682]
        Angle    128.4682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4976"
}

Galaxy "NGC 4977:UGC 8196:MCG 9-22-10:ZWG 271.9"
{
        Type  "Sb"
        RA           13.1011
        Dec          55.6567
        Distance   3.836e+08  # method: V
        Radius     1.116e+05
        AbsMag        -20.75
        Axis    [  0.3642  -0.9284  -0.0733]
        Angle    116.5871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4977"
}

Galaxy "NGC 4978:UGC 8212:MCG 3-34-2:ZWG 101.4"
{
        Type  "Sa"
        RA           13.1306
        Dec          18.4161
        Distance   3.075e+08  # method: V
        Radius      6.71e+04
        AbsMag        -20.77
        Axis    [ -0.9853   0.1535  -0.0753]
        Angle     25.3418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4978"
}

Galaxy "NGC 4979:IC 4198:UGC 8209:MCG 4-31-7"
{
        Type  "SBa"
        RA           13.1283
        Dec          24.8111
        Distance   2.993e+08  # method: V
        Radius     4.353e+04
        AbsMag        -19.71
        Axis    [  0.5728  -0.6366  -0.5164]
        Angle     22.0066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4979"
}

Galaxy "NGC 4980:ESO 443-75:MCG 5-31-37:AM 1306-282"
{
        Type  "SBa"
        RA           13.1528
        Dec         -28.6417
        Distance    7.86e+07  # method: V
        Radius     1.829e+04
        AbsMag        -18.41
        Axis    [ -0.8851  -0.3328  -0.3254]
        Angle     71.0835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4980"
}

Galaxy "NGC 4981:MCG 1-34-3:IRAS 13062-0630"
{
        Type  "SBc"
        RA           13.1467
        Dec          -6.7775
        Distance   9.083e+07  # method: V
        Radius     3.699e+04
        AbsMag        -20.02
        Axis    [ -0.8709  -0.0186  -0.4911]
        Angle     57.1355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4981"
}

Galaxy "NGC 4983:MCG 5-31-138:ZWG 160.147"
{
        Type  "SBa"
        RA           13.1408
        Dec          28.3208
        Distance   3.123e+08  # method: V
        Radius     4.996e+04
        AbsMag        -20.01
        Axis    [ -0.9116   0.0203  -0.4105]
        Angle      5.7141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4983"
}

Galaxy "NGC 4984:MCG 2-34-4:SZ 6:IRAS 13062-1514"
{
        Type  "SBa"
        RA           13.1492
        Dec         -15.5158
        Distance   6.908e+07  # method: V
        Radius     3.617e+04
        AbsMag        -19.43
        Axis    [  0.7819  -0.3869  -0.4887]
        Angle    110.2494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4984"
}

Galaxy "NGC 4985:UGC 8218:MCG 7-27-32:ZWG 217.12"
{
        Type  "S0"
        RA           13.1367
        Dec          41.6769
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [ -0.2588   0.5943  -0.7615]
        Angle     26.2068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4985"
}

Galaxy "NGC 4986:UGC 8221:MCG 6-29-44:ZWG 189.27"
{
        Type  "SBb"
        RA           13.1400
        Dec          35.2053
        Distance    2.28e+08  # method: V
        Radius     5.636e+04
        AbsMag        -20.22
        Axis    [  0.8244  -0.5205   0.2224]
        Angle     50.0613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4986"
}

Galaxy "NGC 4987:UGC 8216:MCG 9-22-15:ZWG 271.13"
{
        Type  "E0"
        RA           13.1331
        Dec          51.9294
        Distance   2.631e+08  # distance uncertain!
        Radius     4.591e+04
        AbsMag        -20.13
        Axis    [  0.3778  -0.8839  -0.2755]
        Angle     86.6816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4987"
}

Galaxy "NGC 4988:ESO 269-55:MCG 7-27-37:DCL 516"
{
        Type  "Sa"
        RA           13.1650
        Dec         -43.1056
        Distance   1.065e+08  # method: V
        Radius     2.634e+04
        AbsMag        -18.67
        Axis    [  0.7954  -0.0766  -0.6012]
        Angle     96.2584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4988"
}

Galaxy "NGC 4989:MCG 1-34-5"
{
        Type  "S0"
        RA           13.1544
        Dec          -5.3964
        Distance    1.54e+08  # distance uncertain!
        Radius     3.583e+04
        AbsMag        -19.07
        Axis    [ -0.9668  -0.0043  -0.2555]
        Angle     62.0912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4989"
}

Galaxy "NGC 4990:MCG 1-34-4:MK 1344:IRAS 13067-0500"
{
        Type  "S0"
        RA           13.1547
        Dec          -5.2725
        Distance   1.585e+08  # method: V
        Radius     2.305e+04
        AbsMag        -18.53
        Axis    [  0.5744  -0.5094  -0.6408]
        Angle     80.8144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4990"
}

Galaxy "NGC 4991:ZWG 44.13"
{
        Type  "Sb"
        RA           13.1542
        Dec           2.3483
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.4058  -0.5552  -0.7260]
        Angle     42.4683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4991"
}

Galaxy "NGC 4992:UGC 8232:MCG 2-34-1:ZWG 72.6"
{
        Type  "Sa"
        RA           13.1514
        Dec          11.6342
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.8660  -0.4683  -0.1754]
        Angle    109.0535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4992"
}

Galaxy "NGC 4993:NGC 4994:ESO 508-18:MCG 4-31-39"
{
        Type  "S0"
        RA           13.1631
        Dec         -23.3839
        Distance   1.459e+08  # method: V
        Radius     2.759e+04
        AbsMag        -19.85
        Axis    [ -0.8032  -0.0119  -0.5956]
        Angle     83.0961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4993"
}

Galaxy "NGC 4995:MCG 1-34-7:UGCA 329:IRAS 13070-0734"
{
        Type  "SBb"
        RA           13.1611
        Dec          -7.8331
        Distance    9.45e+07  # method: V
        Radius     3.299e+04
        AbsMag        -20.31
        Axis    [  0.1904  -0.4773  -0.8579]
        Angle     50.7039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4995"
}

Galaxy "NGC 4996:UGC 8235:MCG 0-34-9:ZWG 16.11"
{
        Type  "SBa"
        RA           13.1586
        Dec           0.8575
        Distance   2.609e+08  # method: V
        Radius      6.83e+04
        AbsMag        -20.51
        Axis    [  0.6909  -0.5331  -0.4883]
        Angle     88.7536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4996"
}

Galaxy "NGC 4997:MCG 3-34-5"
{
        Type  "S0"
        RA           13.1642
        Dec         -16.5153
        Distance   1.281e+08  # distance uncertain!
        Radius     2.608e+04
        AbsMag        -19.07
        Axis    [  0.1799  -0.4719  -0.8631]
        Angle     54.1806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4997"
}

Galaxy "NGC 4998:MCG 9-22-17:ZWG 271.15:IRAS 13062+5054"
{
        Type  "Sc"
        RA           13.1361
        Dec          50.6644
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.6421  -0.7664  -0.0169]
        Angle     69.8897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4998"
}

Galaxy "NGC 4999:UGC 8236:MCG 0-34-10:ZWG 16.12"
{
        Type  "SBb"
        RA           13.1592
        Dec           1.6725
        Distance   2.708e+08  # method: V
        Radius     9.059e+04
        AbsMag         -21.6
        Axis    [ -0.4219  -0.1448  -0.8950]
        Angle     45.8304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 4999"
}

Galaxy "NGC 5000:UGC 8241:MCG 5-31-144:ZWG 160.152"
{
        Type  "SBc"
        RA           13.1631
        Dec          28.9067
        Distance   2.658e+08  # method: V
        Radius     6.572e+04
        AbsMag        -20.65
        Axis    [  0.7231  -0.6807  -0.1175]
        Angle    120.1257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5000"
}

Galaxy "NGC 5001:UGC 8243:MCG 9-22-22:ZWG 271.20"
{
        Type  "SBa"
        RA           13.1592
        Dec          53.4942
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [ -0.5411   0.5694   0.6188]
        Angle     55.8968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5001"
}

Galaxy "NGC 5002:UGC 8254:MCG 6-29-51:ZWG 189.34"
{
        Type  "Irr"
        RA           13.1772
        Dec          36.6342
        Distance   5.803e+07  # method: V
        Radius     1.435e+04
        AbsMag        -16.85
        Axis    [ -0.7954   0.5893   0.1413]
        Angle     54.5627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5002"
}

Galaxy "NGC 5003:UGC 8228:MCG 7-27-33:ZWG 217.13"
{
        Type  "Sa"
        RA           13.1436
        Dec          43.7372
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7383  -0.6741  -0.0226]
        Angle     46.6088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5003"
}

Galaxy "NGC 5004A:UGC 8260:MCG 5-31-149:ZWG 160.157"
{
        Type  "S0"
        RA           13.1836
        Dec          29.6367
        Distance   3.278e+08  # method: V
        Radius     6.674e+04
        AbsMag        -20.91
        Axis    [ -0.7666   0.6022  -0.2229]
        Angle     52.4806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5004A"
}

Galaxy "NGC 5004C:UGC 8259:MCG 5-31-150:ZWG 160.156"
{
        Type  "SBb"
        RA           13.1836
        Dec          29.5778
        Distance   3.404e+08  # method: V
        Radius     6.932e+04
        AbsMag        -20.09
        Axis    [ -0.8680   0.4882   0.0907]
        Angle     53.3001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5004C"
}

Galaxy "NGC 5005:UGC 8256:MCG 6-29-52:ZWG 189.35"
{
        Type  "SBc"
        RA           13.1822
        Dec          37.0586
        Distance   5.332e+07  # method: V
        Radius     4.498e+04
        AbsMag        -20.47
        Axis    [  0.8198  -0.5076   0.2649]
        Angle     56.2554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5005"
}

Galaxy "NGC 5006:ESO 576-6:MCG 3-34-11"
{
        Type  "S0"
        RA           13.1958
        Dec         -19.2614
        Distance   1.398e+08  # method: V
        Radius     4.068e+04
        AbsMag        -19.86
        Axis    [ -0.8209   0.0334  -0.5701]
        Angle     81.0907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5006"
}

Galaxy "NGC 5007:UGC 8240:MCG 10-19-42:ZWG 294.21"
{
        Type  "S0"
        RA           13.1539
        Dec          62.1753
        Distance   3.832e+08  # method: V
        Radius     5.017e+04
        AbsMag        -21.05
        Axis    [ -0.0706   0.7067   0.7040]
        Angle     32.4240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5007"
}

Galaxy "NGC 5008:IC 4381:UGC 9073:MCG 4-33-42"
{
        Type  "SBc"
        RA           14.1825
        Dec          25.4964
        Distance   4.319e+08  # method: V
        Radius     8.793e+04
        AbsMag        -21.51
        Axis    [ -0.9956   0.0938  -0.0089]
        Angle     28.1442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5008"
}

Galaxy "NGC 5009:UGC 8258:MCG 8-24-61:ZWG 245.25"
{
        Type  "SBb"
        RA           13.1797
        Dec          50.0931
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.7582  -0.5198   0.3936]
        Angle     47.7735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5009"
}

Galaxy "NGC 5010:MCG 3-34-15:SZ 8:IRAS 13097-1531"
{
        Type  "Sa"
        RA           13.2072
        Dec         -15.7975
        Distance   3.041e+08  # method: V
        Radius     5.749e+04
        AbsMag        -20.65
        Axis    [ -0.3469  -0.4951  -0.7966]
        Angle     41.6143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5010"
}

Galaxy "NGC 5011:ESO 269-65:MCG 7-27-42:DCL 528"
{
        Type  "E1"
        RA           13.2142
        Dec         -43.0967
        Distance   1.366e+08  # method: S
        Radius     4.967e+04
        AbsMag        -20.81
        Axis    [ -0.5889   0.0128  -0.8081]
        Angle    122.4336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5011"
}

Galaxy "NGC 5011A:ESO 269-63:MCG 7-27-41:DCL 526"
{
        Type  "SBc"
        RA           13.2025
        Dec         -43.3081
        Distance   1.628e+08  # method: T-F
        Radius     3.788e+04
        AbsMag        -19.09
        Axis    [  0.1639  -0.4332  -0.8863]
        Angle     66.0959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5011A"
}

Galaxy "NGC 5011B:ESO 269-67:DCL 530"
{
        Type  "S0"
        RA           13.2200
        Dec         -43.2467
        Distance   1.628e+08  # method: V
        Radius     1.894e+04
        AbsMag        -18.99
        Axis    [  0.3077  -0.3716  -0.8759]
        Angle     74.8722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5011B"
}

Galaxy "NGC 5011C:ESO 269-68:DCL 531:FAIR 464"
{
        Type  "S0"
        RA           13.2197
        Dec         -43.2658
        Distance   1.581e+08  # method: V
        Radius     2.759e+04
        AbsMag        -19.23
        Axis    [ -0.4726  -0.3773  -0.7964]
        Angle     78.1933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5011C"
}

Galaxy "NGC 5012:UGC 8270:MCG 4-31-12:ZWG 130.16"
{
        Type  "SBc"
        RA           13.1933
        Dec          22.9147
        Distance   1.314e+08  # method: V
        Radius     5.543e+04
        AbsMag        -20.03
        Axis    [  0.8471  -0.5267  -0.0713]
        Angle    108.9096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5012"
}

Galaxy "NGC 5012A:UGC 8290:MCG 4-31-14:ZWG 130.20"
{
        Type  "Irr"
        RA           13.2114
        Dec          22.8300
        Distance   1.293e+08  # method: V
        Radius     2.822e+04
        AbsMag        -18.39
        Axis    [  0.7239  -0.6341  -0.2717]
        Angle     61.4745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5012A"
}

Galaxy "NGC 5013:MCG 1-34-7:ZWG 44.24"
{
        Type  "Sc"
        RA           13.2019
        Dec           3.1994
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [ -0.8503  -0.3070  -0.4274]
        Angle     27.3029
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5013"
}

Galaxy "NGC 5014:UGC 8271:MCG 6-29-55:MK 449"
{
        Type  "Sa"
        RA           13.1919
        Dec          36.2817
        Distance   6.152e+07  # method: V
        Radius     1.432e+04
        AbsMag        -17.78
        Axis    [  0.4745  -0.2109   0.8546]
        Angle     33.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5014"
}

Galaxy "NGC 5015:MCG 1-34-12:IRAS 13097-0404"
{
        Type  "SBa"
        RA           13.2061
        Dec          -4.3369
        Distance   1.574e+08  # method: V
        Radius     4.121e+04
        AbsMag        -20.22
        Axis    [  0.5101  -0.5240  -0.6821]
        Angle     78.9490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5015"
}

Galaxy "NGC 5016:UGC 8279:MCG 4-31-13:ZWG 130.19"
{
        Type  "SBc"
        RA           13.2017
        Dec          24.0950
        Distance   1.307e+08  # method: V
        Radius     3.231e+04
        AbsMag        -19.31
        Axis    [  0.7236  -0.6433  -0.2500]
        Angle     71.4696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5016"
}

Galaxy "NGC 5017:MCG 3-34-16"
{
        Type  "E0"
        RA           13.2150
        Dec         -16.7656
        Distance    1.29e+08  # method: T-F
        Radius     3.378e+04
        AbsMag        -19.39
        Axis    [  0.3569  -0.5420  -0.7608]
        Angle    128.4716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5017"
}

Galaxy "NGC 5018:ESO 576-10:MCG 3-34-17:UGCA 335"
{
        Type  "E3"
        RA           13.2167
        Dec         -19.5194
        Distance    1.29e+08  # method: T-F
        Radius      6.38e+04
        AbsMag        -21.29
        Axis    [ -0.2018  -0.1753  -0.9636]
        Angle    103.1110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5018"
}

Galaxy "NGC 5019:UGC 8288:MCG 1-34-9:ZWG 44.27"
{
        Type  "SBa"
        RA           13.2117
        Dec           4.7292
        Distance    3.04e+08  # method: V
        Radius     3.537e+04
        AbsMag        -20.35
        Axis    [  0.0101  -0.3709  -0.9286]
        Angle     50.0588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5019"
}

Galaxy "NGC 5020:UGC 8289:MCG 2-34-3:ZWG 72.24"
{
        Type  "SBc"
        RA           13.2108
        Dec          12.5997
        Distance   1.657e+08  # method: V
        Radius     7.469e+04
        AbsMag        -20.63
        Axis    [  0.3626  -0.5482  -0.7537]
        Angle     52.8008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5020"
}

Galaxy "NGC 5021:UGC 8284:MCG 8-24-84:ZWG 245.30"
{
        Type  "SBb"
        RA           13.2017
        Dec          46.1964
        Distance   3.824e+08  # method: V
        Radius     8.342e+04
        AbsMag        -21.14
        Axis    [  0.7371  -0.4020   0.5432]
        Angle     49.4304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5021"
}

Galaxy "NGC 5022:MCG 3-34-21:ESO 576-14:FGC 1581"
{
        Type  "Sb"
        RA           13.2250
        Dec         -19.5475
        Distance   1.274e+08  # method: T-F
        Radius     4.632e+04
        AbsMag        -19.26
        Axis    [  0.9479  -0.1112  -0.2987]
        Angle     92.3155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5022"
}

Galaxy "NGC 5023:UGC 8286:MCG 7-27-43:ZWG 217.17"
{
        Type  "Sc"
        RA           13.2031
        Dec          44.0372
        Distance   4.449e+07  # method: T-F
        Radius     3.753e+04
        AbsMag        -17.87
        Axis    [  0.8580  -0.3351   0.3894]
        Angle    101.4890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5023"
}

Galaxy "NGC 5025:UGC 8292:MCG 5-31-155:ZWG 160.162"
{
        Type  "Sb"
        RA           13.2122
        Dec          31.8086
        Distance   2.984e+08  # method: V
        Radius     8.681e+04
        AbsMag        -20.41
        Axis    [  0.8559  -0.3946   0.3342]
        Angle     66.5826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5025"
}

Galaxy "NGC 5026:ESO 269-73:MCG 7-27-48:DCL 540"
{
        Type  "SBa"
        RA           13.2369
        Dec         -42.9614
        Distance   1.723e+08  # method: V
        Radius     8.269e+04
        AbsMag        -21.11
        Axis    [  0.4943  -0.3013  -0.8154]
        Angle     96.1966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5026"
}

Galaxy "NGC 5027:UGC 8297:MCG 1-34-10:ZWG 44.28"
{
        Type  "SBb"
        RA           13.2222
        Dec           6.0619
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.4511  -0.5784  -0.6797]
        Angle     77.0497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5027"
}

Galaxy "NGC 5028:MCG 2-34-11:NPM 1"
{
        Type  "E6"
        RA           13.2292
        Dec         -13.0419
        Distance   1.585e+08  # distance uncertain!
        Radius     3.689e+04
        AbsMag        -20.13
        Axis    [ -0.3393  -0.0337  -0.9401]
        Angle     94.9171
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5028"
}

Galaxy "NGC 5029:UGC 8293:MCG 8-24-87:ZWG 245.32"
{
        Type  "E0"
        RA           13.2103
        Dec          47.0633
        Distance   4.047e+08  # method: V
        Radius     1.001e+05
        AbsMag        -21.37
        Axis    [ -0.1121   0.6084  -0.7857]
        Angle     52.2080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5029"
}

Galaxy "NGC 5030:MCG 3-34-23"
{
        Type  "SBa"
        RA           13.2317
        Dec         -16.4911
        Distance   1.115e+08  # distance uncertain!
        Radius     2.758e+04
        AbsMag        -19.07
        Axis    [  0.8222  -0.3708  -0.4318]
        Angle    126.6239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5030"
}

Galaxy "NGC 5031:MCG 3-34-24"
{
        Type  "Sa"
        RA           13.2342
        Dec         -16.1225
        Distance   1.612e+08  # distance uncertain!
        Radius     3.986e+04
        AbsMag        -19.07
        Axis    [ -0.1540  -0.8858  -0.4377]
        Angle     26.1403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5031"
}

Galaxy "NGC 5032:NGC 5032A:UGC 8300:MCG 5-31-160"
{
        Type  "SBb"
        RA           13.2242
        Dec          27.8011
        Distance   3.022e+08  # method: V
        Radius      9.23e+04
        AbsMag        -21.23
        Axis    [  0.8533  -0.5213   0.0117]
        Angle     97.1917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5032"
}

Galaxy "NGC 5032B:MCG 5-31-159:ZWG 160.165:KCPG 366A"
{
        Type  "SBa"
        RA           13.2236
        Dec          27.7639
        Distance   2.884e+08  # method: V
        Radius     3.776e+04
        AbsMag        -19.53
        Axis    [  0.7343  -0.6566  -0.1724]
        Angle     33.9335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5032B"
}

Galaxy "NGC 5033:UGC 8307:MCG 6-29-62:ZWG 189.43"
{
        Type  "Sc"
        RA           13.2244
        Dec          36.5933
        Distance   5.957e+07  # method: T-F
        Radius     9.271e+04
        AbsMag         -20.6
        Axis    [ -0.8085   0.5004   0.3097]
        Angle     53.3608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5033"
}

Galaxy "NGC 5034:UGC 8295:MCG 12-13-1:ZWG 336.3"
{
        Type  "Sc"
        RA           13.2053
        Dec          70.6497
        Distance   3.964e+08  # method: V
        Radius     5.189e+04
        AbsMag        -21.22
        Axis    [  0.5869  -0.7530   0.2976]
        Angle    105.8939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5034"
}

Galaxy "NGC 5035:MCG 3-34-28:NPM 1"
{
        Type  "SBa"
        RA           13.2469
        Dec         -16.4922
        Distance   1.168e+08  # distance uncertain!
        Radius     2.378e+04
        AbsMag        -19.07
        Axis    [ -0.7259  -0.1092  -0.6790]
        Angle     65.8163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5035"
}

Galaxy "NGC 5036:NPM 1"
{
        Type  "S0"
        RA           13.2450
        Dec          -4.1781
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.4778  -0.5300  -0.7006]
        Angle     60.3865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5036"
}

Galaxy "NGC 5037:MCG 3-34-29:IRAS 13123-1619"
{
        Type  "Sa"
        RA           13.2497
        Dec         -16.5900
        Distance   1.003e+08  # method: V
        Radius     2.918e+04
        AbsMag        -19.34
        Axis    [  0.8698  -0.2895  -0.3996]
        Angle     75.1320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5037"
}

Galaxy "NGC 5038:MCG 3-34-31:IRAS 13123-1541"
{
        Type  "S0"
        RA           13.2506
        Dec         -15.9519
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [  0.5356  -0.7584  -0.3713]
        Angle     29.0275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5038"
}

Galaxy "NGC 5039"
{
        Type  "Sa"
        RA           13.2478
        Dec          -4.1581
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [  0.8623  -0.3886  -0.3248]
        Angle     79.3365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5039"
}

Galaxy "NGC 5040-1:MCG 9-22-31:ZWG 271.24"
{
        Type  "S0"
        RA           13.2256
        Dec          51.2586
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.7455  -0.4581   0.4841]
        Angle     61.2732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5040-1"
}

Galaxy "NGC 5040-2:NPM 1"
{
        Type  "S0"
        RA           13.2250
        Dec          51.2733
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.7401  -0.4454   0.5039]
        Angle     34.2390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5040-2"
}

Galaxy "NGC 5041:UGC 8319:MCG 5-31-162:ZWG 160.168"
{
        Type  "Sc"
        RA           13.2422
        Dec          30.7053
        Distance     3.5e+08  # method: V
        Radius     8.654e+04
        AbsMag        -21.05
        Axis    [ -0.6110   0.5442  -0.5750]
        Angle     37.6620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5041"
}

Galaxy "NGC 5042:ESO 508-31:MCG 4-31-43:UGCA 340"
{
        Type  "SBc"
        RA           13.2583
        Dec         -23.9839
        Distance   5.957e+07  # method: T-F
        Radius     3.639e+04
        AbsMag        -18.81
        Axis    [  0.8080  -0.2838  -0.5163]
        Angle    103.1194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5042"
}

Galaxy "NGC 5044:MCG 3-34-34:UGCA 341"
{
        Type  "E0"
        RA           13.2564
        Dec         -16.3844
        Distance   1.017e+08  # method: S
        Radius     4.439e+04
        AbsMag        -20.67
        Axis    [  0.5437  -0.6288  -0.5558]
        Angle    151.4366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5044"
}

Galaxy "NGC 5046:MCG 3-34-35:NPM 1"
{
        Type  "E0"
        RA           13.2625
        Dec         -16.3267
        Distance   2.754e+08  # distance uncertain!
        Radius     3.205e+04
        AbsMag        -20.13
        Axis    [  0.2584  -0.4972  -0.8282]
        Angle    120.4310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5046"
}

Galaxy "NGC 5047:MCG 3-34-36"
{
        Type  "S0"
        RA           13.2633
        Dec         -16.5183
        Distance   3.008e+08  # method: V
        Radius     1.181e+05
        AbsMag        -21.22
        Axis    [  0.8107  -0.4688  -0.3506]
        Angle     43.2841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5047"
}

Galaxy "NGC 5048:ESO 443-87:MCG 5-31-41:AM 1312-280"
{
        Type  "S0"
        RA           13.2689
        Dec         -28.4111
        Distance   1.088e+08  # method: T-F
        Radius     2.373e+04
        AbsMag        -18.91
        Axis    [  0.6560  -0.3418  -0.6729]
        Angle     84.4557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5048"
}

Galaxy "NGC 5049:MCG 3-34-37:UGCA 343"
{
        Type  "S0"
        RA           13.2664
        Dec         -16.3972
        Distance   1.383e+08  # method: V
        Radius     3.621e+04
        AbsMag        -19.14
        Axis    [ -0.3712  -0.7231  -0.5825]
        Angle     31.9461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5049"
}

Galaxy "NGC 5050:UGC 8329:MCG 1-34-12:ZWG 44.43"
{
        Type  "Sa"
        RA           13.2614
        Dec           2.8792
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.9133  -0.3650  -0.1806]
        Angle     85.3925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5050"
}

Galaxy "NGC 5051:ESO 444-1:MCG 5-31-42:AM 1312-280"
{
        Type  "SBc"
        RA           13.2722
        Dec         -28.2861
        Distance   2.072e+08  # method: T-F
        Radius     4.218e+04
        AbsMag        -20.01
        Axis    [  0.6997  -0.3226  -0.6375]
        Angle     77.9415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5051"
}

Galaxy "NGC 5052:UGC 8330:MCG 5-31-165:ZWG 160.171"
{
        Type  "Sa"
        RA           13.2597
        Dec          29.6758
        Distance   3.171e+08  # method: V
        Radius     5.996e+04
        AbsMag        -20.54
        Axis    [ -0.8420   0.5324  -0.0875]
        Angle     40.7092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5052"
}

Galaxy "NGC 5054:MCG 3-34-39:UGCA 344:IRAS 13142-1622"
{
        Type  "Sc"
        RA           13.2828
        Dec         -16.6347
        Distance   9.282e+07  # method: V
        Radius     6.885e+04
        AbsMag        -20.57
        Axis    [ -0.8940  -0.2198  -0.3905]
        Angle     60.2472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5054"
}

Galaxy "M 63:NGC 5055:UGC 8334:MCG 7-27-54"
{
        Type  "Sc"
        RA           13.2636
        Dec          42.0331
        Distance   3.452e+07  # method: T-F
        Radius     6.326e+04
        AbsMag        -20.82
        Axis    [  0.6155  -0.3248   0.7181]
        Angle     21.5075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 63"
}

Galaxy "NGC 5056:UGC 8337:MCG 5-31-166:ZWG 160.173"
{
        Type  "Sc"
        RA           13.2700
        Dec          30.9494
        Distance   2.121e+08  # method: T-F
        Radius     5.552e+04
        AbsMag        -20.36
        Axis    [  0.8367  -0.5476   0.0083]
        Angle    119.6864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5056"
}

Galaxy "NGC 5057:UGC 8342:MCG 5-31-169:ZWG 160.176"
{
        Type  "S0"
        RA           13.2742
        Dec          31.0319
        Distance   2.751e+08  # method: V
        Radius     5.201e+04
        AbsMag        -20.13
        Axis    [ -0.6279   0.6759  -0.3859]
        Angle     62.6152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5057"
}

Galaxy "NGC 5058:UGC 8345:MCG 2-34-6:MK 786"
{
        Type  "Sc"
        RA           13.2811
        Dec          12.5486
        Distance   5.694e+07  # method: V
        Radius          4969
        AbsMag        -16.61
        Axis    [  0.5028  -0.7718  -0.3893]
        Angle    135.5329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5058"
}

Galaxy "NGC 5059:UGC 8344:ZWG 44.50:FGC 1589"
{
        Type  "Sc"
        RA           13.2828
        Dec           7.8447
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [  0.9690  -0.2429  -0.0449]
        Angle    108.2511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5059"
}

Galaxy "NGC 5060:UGC 8351:MCG 1-34-15:ZWG 44.53"
{
        Type  "SBb"
        RA           13.2878
        Dec           6.0372
        Distance   2.976e+08  # method: V
        Radius     4.762e+04
        AbsMag         -20.7
        Axis    [  0.6685  -0.5742  -0.4727]
        Angle     71.9492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5060"
}

Galaxy "NGC 5061:ESO 508-38:MCG 4-31-48:AM 1315-263"
{
        Type  "E0"
        RA           13.3014
        Dec         -26.8372
        Distance   8.915e+07  # method: T-F
        Radius     4.538e+04
        AbsMag        -20.88
        Axis    [  0.5534  -0.5712  -0.6062]
        Angle    157.3895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5061"
}

Galaxy "NGC 5062-1:ESO 382-35:MCG 6-29-26:IRAS 13155-3511"
{
        Type  "S0"
        RA           13.3064
        Dec         -35.4589
        Distance   1.617e+08  # method: V
        Radius     5.409e+04
        AbsMag        -20.88
        Axis    [ -0.4926  -0.6418  -0.5878]
        Angle     51.1954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5062-1"
}

Galaxy "NGC 5062-2"
{
        Type  "E0"
        RA           13.3053
        Dec         -35.4453
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.5622  -0.5204  -0.6427]
        Angle    162.2077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5062-2"
}

Galaxy "NGC 5063:ESO 382-36:MCG 6-29-27:AM 1315-350"
{
        Type  "Sa"
        RA           13.3069
        Dec         -35.3531
        Distance   1.547e+08  # method: V
        Radius     5.174e+04
        AbsMag        -20.08
        Axis    [ -0.6063  -0.2626  -0.7506]
        Angle     80.2976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5063"
}

Galaxy "NGC 5064:ESO 220-2:AM 1316-473:IRAS 13160-4738"
{
        Type  "Sb"
        RA           13.3167
        Dec         -47.9097
        Distance   1.512e+08  # method: T-F
        Radius     4.179e+04
        AbsMag        -20.43
        Axis    [  0.6286  -0.1997  -0.7516]
        Angle     98.2111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5064"
}

Galaxy "NGC 5065:UGC 8356:MCG 5-31-170:ZWG 160.181"
{
        Type  "SBc"
        RA           13.2917
        Dec          31.0922
        Distance   3.166e+08  # method: T-F
        Radius     5.986e+04
        AbsMag        -20.64
        Axis    [  0.7682  -0.6387   0.0431]
        Angle     35.0646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5065"
}

Galaxy "NGC 5066:NGC 5069:MCG 2-34-20"
{
        Type  "Sa"
        RA           13.3078
        Dec         -10.2339
        Distance   1.612e+08  # distance uncertain!
        Radius     1.641e+04
        AbsMag        -19.07
        Axis    [  0.8168  -0.4213  -0.3943]
        Angle    125.6452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5066"
}

Galaxy "NGC 5068:ESO 576-29:MCG 3-34-46:UGCA 345"
{
        Type  "SBc"
        RA           13.3150
        Dec         -21.0381
        Distance   4.408e+07  # method: V
        Radius      4.68e+04
        AbsMag        -20.15
        Axis    [ -0.1818  -0.3231  -0.9287]
        Angle     73.9646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5068"
}

Galaxy "NGC 5071:ZWG 44.62:NPM 1"
{
        Type  "S0"
        RA           13.3103
        Dec           7.9361
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.7469   0.0462  -0.6634]
        Angle     41.2486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5071"
}

Galaxy "NGC 5072:NGC 5070:MCG 2-34-22"
{
        Type  "S0"
        RA           13.3200
        Dec         -12.5397
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.2197  -0.5041  -0.8352]
        Angle     56.7907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5072"
}

Galaxy "NGC 5073:MCG 2-34-25:UGCA 346:FGC 1594"
{
        Type  "SBc"
        RA           13.3222
        Dec         -14.8464
        Distance   1.383e+08  # method: V
        Radius     6.837e+04
        AbsMag        -19.84
        Axis    [ -0.8435  -0.5344   0.0544]
        Angle     46.8420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5073"
}

Galaxy "NGC 5074:MCG 5-31-172:ZWG 161.1:ZWG 160.183"
{
        Type  "Sb"
        RA           13.3069
        Dec          31.4683
        Distance   2.651e+08  # method: V
        Radius     2.699e+04
        AbsMag        -19.75
        Axis    [  0.6319  -0.7161  -0.2964]
        Angle     63.2424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5074"
}

Galaxy "NGC 5075:ZWG 44.65:NPM 1"
{
        Type  "E0"
        RA           13.3183
        Dec           7.8317
        Distance   3.312e+08  # distance uncertain!
        Radius      2.89e+04
        AbsMag        -20.13
        Axis    [  0.4887  -0.7604  -0.4278]
        Angle    139.3035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5075"
}

Galaxy "NGC 5076:MCG 2-34-26"
{
        Type  "Sa"
        RA           13.3250
        Dec         -12.7406
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.7700  -0.4062  -0.4921]
        Angle     84.8545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5076"
}

Galaxy "NGC 5077:MCG 2-34-27:UGCA 347"
{
        Type  "E3"
        RA           13.3253
        Dec         -12.6567
        Distance    1.29e+08  # method: T-F
        Radius     4.128e+04
        AbsMag        -20.59
        Axis    [  0.5021  -0.6428  -0.5785]
        Angle    145.2800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5077"
}

Galaxy "NGC 5078:ESO 508-48:MCG 4-32-1:AM 1317-270"
{
        Type  "Sa"
        RA           13.3303
        Dec         -27.4097
        Distance   1.113e+08  # method: V
        Radius     6.478e+04
        AbsMag        -20.66
        Axis    [ -0.7557  -0.4244  -0.4987]
        Angle     59.1278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5078"
}

Galaxy "NGC 5079:MCG 2-34-30:IRAS 13169-1226"
{
        Type  "SBc"
        RA           13.3269
        Dec         -12.6997
        Distance    1.44e+08  # method: V
        Radius     3.142e+04
        AbsMag        -20.42
        Axis    [  0.8052  -0.3810  -0.4544]
        Angle     92.5981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5079"
}

Galaxy "NGC 5080:MCG 2-34-7:ZWG 72.46:NPM 1"
{
        Type  "E0"
        RA           13.3219
        Dec           8.4297
        Distance   2.884e+08  # distance uncertain!
        Radius     5.034e+04
        AbsMag        -20.13
        Axis    [ -0.0096  -0.3117  -0.9501]
        Angle     79.0941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5080"
}

Galaxy "NGC 5081:UGC 8366:MCG 5-31-174:ZWG 160.192"
{
        Type  "SBb"
        RA           13.3189
        Dec          28.5064
        Distance   3.366e+08  # method: T-F
        Radius     1.077e+05
        AbsMag        -20.67
        Axis    [  0.5359  -0.4509   0.7138]
        Angle     25.2382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5081"
}

Galaxy "NGC 5082:ESO 269-89:MCG 7-27-53:DCL 562"
{
        Type  "S0"
        RA           13.3442
        Dec         -43.7003
        Distance   1.877e+08  # method: V
        Radius     4.096e+04
        AbsMag           -20
        Axis    [  0.6175  -0.2642  -0.7409]
        Angle    111.3914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5082"
}

Galaxy "NGC 5083:UGC 8367:MCG 7-27-59:ZWG 217.28"
{
        Type  "SBc"
        RA           13.3175
        Dec          39.5894
        Distance   3.334e+08  # method: V
        Radius     6.303e+04
        AbsMag        -20.05
        Axis    [ -0.4020   0.5459  -0.7351]
        Angle     14.4035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5083"
}

Galaxy "NGC 5084:ESO 576-33:MCG 4-32-4"
{
        Type  "S0"
        RA           13.3378
        Dec         -21.8275
        Distance   9.173e+07  # method: V
        Radius     1.241e+05
        AbsMag        -20.74
        Axis    [  0.6979  -0.5426  -0.4674]
        Angle     41.3788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5084"
}

Galaxy "NGC 5085:ESO 508-50:MCG 4-32-5:UGCA 349"
{
        Type  "Sc"
        RA           13.3381
        Dec         -24.4403
        Distance    1.02e+08  # method: V
        Radius     5.193e+04
        AbsMag        -20.08
        Axis    [  0.5444  -0.4427  -0.7125]
        Angle    108.9357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5085"
}

Galaxy "NGC 5087:ESO 576-35:MCG 3-34-50:UGCA 350"
{
        Type  "S0"
        RA           13.3400
        Dec         -20.6108
        Distance   8.915e+07  # method: T-F
        Radius     3.501e+04
        AbsMag        -19.78
        Axis    [  0.7229  -0.4273  -0.5430]
        Angle    124.8156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5087"
}

Galaxy "NGC 5088:MCG 2-34-34:IRAS 13176-1218"
{
        Type  "Sc"
        RA           13.3389
        Dec         -12.5722
        Distance     7.9e+07  # method: V
        Radius     3.103e+04
        AbsMag        -18.52
        Axis    [  0.9531  -0.1579  -0.2583]
        Angle    114.4576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5088"
}

Galaxy "NGC 5089:UGC 8371:MCG 5-31-175:ZWG 160.194"
{
        Type  "SBc"
        RA           13.3275
        Dec          30.2556
        Distance   1.075e+08  # method: V
        Radius     2.659e+04
        AbsMag        -18.39
        Axis    [ -0.1360  -0.2671   0.9540]
        Angle     13.3330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5089"
}

Galaxy "NGC 5090:ESO 270-2:MCG 7-27-54:AM 1318-432"
{
        Type  "E2"
        RA           13.3533
        Dec         -43.7050
        Distance   1.665e+08  # method: T-F
        Radius     6.539e+04
        AbsMag        -21.04
        Axis    [ -0.2493  -0.2016  -0.9472]
        Angle    126.8094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5090"
}

Galaxy "NGC 5090A:ESO 269-84:AM 1316-432:DCL 555"
{
        Type  "S0"
        RA           13.3222
        Dec         -43.6497
        Distance   1.722e+08  # method: V
        Radius     4.259e+04
        AbsMag        -19.61
        Axis    [ -0.6652  -0.5606  -0.4932]
        Angle     68.6127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5090A"
}

Galaxy "NGC 5090B:ESO 269-88:MCG 7-27-52:AM 1317-433"
{
        Type  "SBb"
        RA           13.3381
        Dec         -43.8650
        Distance   2.057e+08  # method: V
        Radius     5.685e+04
        AbsMag           -20
        Axis    [ -0.3940  -0.5490  -0.7371]
        Angle     63.7598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5090B"
}

Galaxy "NGC 5091:ESO 270-4:MCG 7-27-55:AM 1318-432"
{
        Type  "Sb"
        RA           13.3547
        Dec         -43.7203
        Distance   1.744e+08  # method: V
        Radius     4.565e+04
        AbsMag        -19.74
        Axis    [ -0.4561  -0.6562  -0.6011]
        Angle     57.7294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5091"
}

Galaxy "NGC 5092:UGC 8376:MCG 4-31-23:ZWG 130.30"
{
        Type  "E0"
        RA           13.3308
        Dec          23.0000
        Distance   2.754e+08  # distance uncertain!
        Radius     4.006e+04
        AbsMag        -20.13
        Axis    [  0.4453  -0.8315  -0.3322]
        Angle    132.3166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5092"
}

Galaxy "NGC 5093:UGC 8373:MCG 7-27-60:ZWG 217.29"
{
        Type  "Sa"
        RA           13.3269
        Dec          40.3864
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [ -0.6115   0.4675   0.6384]
        Angle     29.5807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5093"
}

Galaxy "NGC 5094:MCG 2-34-37"
{
        Type  "E0"
        RA           13.3461
        Dec         -14.0808
        Distance   2.399e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -20.13
        Axis    [ -0.1429  -0.2368  -0.9610]
        Angle     98.9050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5094"
}

Galaxy "NGC 5095:UGC 8381:MCG 0-34-29:ZWG 16.54"
{
        Type  "Sa"
        RA           13.3433
        Dec          -2.2892
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [ -0.6418  -0.7407  -0.1987]
        Angle     23.0937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5095"
}

Galaxy "NGC 5096:MCG 6-29-76:ZWG 189.51:VV 633"
{
        Type  "Sa"
        RA           13.3356
        Dec          33.0881
        Distance   3.913e+08  # method: V
        Radius     3.984e+04
        AbsMag         -20.5
        Axis    [  0.4356  -0.8646  -0.2504]
        Angle    127.2689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5096"
}

Galaxy "NGC 5097:SZ 37:IRAS 13183-1212"
{
        Type  "E0"
        RA           13.3497
        Dec         -12.4717
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.3091  -0.5539  -0.7731]
        Angle    122.3159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5097"
}

Galaxy "NGC 5098A:MCG 6-29-77:ZWG 189.52"
{
        Type  "E0"
        RA           13.3372
        Dec          33.1433
        Distance   5.254e+08  # method: V
        Radius     5.349e+04
        AbsMag        -20.94
        Axis    [  0.4111  -0.8731  -0.2621]
        Angle    128.0330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5098A"
}

Galaxy "NGC 5098B:MCG 6-29-78:ZWG 189.52"
{
        Type  "S0"
        RA           13.3381
        Dec          33.1450
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.4352  -0.8649  -0.2501]
        Angle    127.2727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5098B"
}

Galaxy "NGC 5099:NPM 1"
{
        Type  "E0"
        RA           13.3553
        Dec         -13.0417
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.5278  -0.6525  -0.5437]
        Angle    150.1932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5099"
}

Galaxy "NGC 5101:ESO 508-58:MCG 4-32-8:UGCA 351"
{
        Type  "SBa"
        RA           13.3628
        Dec         -27.4308
        Distance   9.731e+07  # method: V
        Radius     7.642e+04
        AbsMag        -20.97
        Axis    [ -0.3697  -0.2865  -0.8839]
        Angle     76.3378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5101"
}

Galaxy "NGC 5102:ESO 382-50:MCG 6-29-31:AM 1319-362"
{
        Type  "S0"
        RA           13.3658
        Dec         -36.6317
        Distance   1.304e+07  # method: S
        Radius     1.632e+04
        AbsMag        -17.51
        Axis    [  0.7092  -0.2574  -0.6564]
        Angle     77.5727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5102"
}

Galaxy "NGC 5103:UGC 8388:MCG 7-27-62:ZWG 217.31"
{
        Type  "S0"
        RA           13.3417
        Dec          43.0844
        Distance   6.718e+07  # method: V
        Radius     1.368e+04
        AbsMag        -17.97
        Axis    [ -0.6303   0.7493   0.2033]
        Angle     23.1709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5103"
}

Galaxy "NGC 5104:UGC 8391:MCG 0-34-31:ZWG 16.57"
{
        Type  "Sa"
        RA           13.3561
        Dec           0.3428
        Distance   2.668e+08  # method: V
        Radius     4.656e+04
        AbsMag        -20.06
        Axis    [ -0.9895  -0.1136   0.0895]
        Angle     57.3642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5104"
}

Galaxy "NGC 5105:MCG 2-34-39:IRAS 13191-1256"
{
        Type  "SBc"
        RA           13.3636
        Dec         -13.2072
        Distance   1.455e+08  # method: V
        Radius     4.231e+04
        AbsMag        -20.45
        Axis    [ -0.6474  -0.2137  -0.7316]
        Angle     56.3001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5105"
}

Galaxy "NGC 5106-1:NGC 5100-1:UGC 8389:MCG 2-34-9"
{
        Type  "S0"
        RA           13.3497
        Dec           8.9775
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.8467  -0.4875  -0.2131]
        Angle    120.7350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5106-1"
}

Galaxy "NGC 5106-2:NGC 5100-2:UGC 8389:MCG 2-34-9"
{
        Type  "S0"
        RA           13.3497
        Dec           8.9789
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.8725  -0.4516  -0.1865]
        Angle     98.3008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5106-2"
}

Galaxy "NGC 5107:UGC 8396:MCG 7-28-1:MK 1346"
{
        Type  "SBc"
        RA           13.3567
        Dec          38.5383
        Distance    7.95e+07  # method: T-F
        Radius     1.966e+04
        AbsMag        -18.13
        Axis    [ -0.1982   0.0945   0.9756]
        Angle     33.9034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5107"
}

Galaxy "NGC 5108:ESO 444-20:MCG 5-32-5"
{
        Type  "SBc"
        RA           13.3883
        Dec         -32.3419
        Distance   4.029e+08  # method: V
        Radius     7.031e+04
        AbsMag        -20.46
        Axis    [  0.9041  -0.0464  -0.4248]
        Angle    112.3745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5108"
}

Galaxy "NGC 5111:NGC 5110:MCG 2-34-41:NPM 1"
{
        Type  "S0"
        RA           13.3822
        Dec         -12.9642
        Distance    1.54e+08  # distance uncertain!
        Radius     4.479e+04
        AbsMag        -19.07
        Axis    [ -0.3187  -0.2949  -0.9008]
        Angle     61.8269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5111"
}

Galaxy "NGC 5112:UGC 8403:MCG 7-28-3:ZWG 218.5"
{
        Type  "SBc"
        RA           13.3656
        Dec          38.7353
        Distance   5.377e+07  # method: V
        Radius     3.128e+04
        AbsMag        -18.78
        Axis    [ -0.7392   0.6690   0.0778]
        Angle      9.2862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5112"
}

Galaxy "NGC 5113:NGC 5109:UGC 8393:MCG 10-19-61"
{
        Type  "Sc"
        RA           13.3478
        Dec          57.6422
        Distance   1.026e+08  # method: V
        Radius     2.536e+04
        AbsMag        -18.79
        Axis    [ -0.4003   0.4762   0.7829]
        Angle     57.8024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5113"
}

Galaxy "NGC 5114:ESO 444-24:MCG 5-32-6"
{
        Type  "S0"
        RA           13.4003
        Dec         -32.3439
        Distance   1.765e+08  # method: V
        Radius     4.621e+04
        AbsMag        -20.17
        Axis    [  0.2927  -0.4538  -0.8417]
        Angle     68.4083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5114"
}

Galaxy "NGC 5115:UGC 8408:MCG 2-34-10:ZWG 72.57"
{
        Type  "SBc"
        RA           13.3833
        Dec          13.9511
        Distance   2.881e+08  # method: T-F
        Radius     5.867e+04
        AbsMag        -20.13
        Axis    [  0.5779  -0.7849  -0.2236]
        Angle     25.3993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5115"
}

Galaxy "NGC 5116:UGC 8410:MCG 5-32-9:ZWG 161.36"
{
        Type  "SBc"
        RA           13.3819
        Dec          26.9814
        Distance   1.652e+08  # method: T-F
        Radius     4.806e+04
        AbsMag        -19.92
        Axis    [  0.8804  -0.4532   0.1398]
        Angle     81.3408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5116"
}

Galaxy "NGC 5117:UGC 8411:MCG 5-32-10:ZWG 161.37"
{
        Type  "SBc"
        RA           13.3822
        Dec          28.3156
        Distance   1.198e+08  # method: V
        Radius     3.833e+04
        AbsMag        -18.62
        Axis    [ -0.8775   0.2973   0.3762]
        Angle     36.7517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5117"
}

Galaxy "NGC 5118:IC 4236:UGC 8413:MCG 1-34-19"
{
        Type  "SBc"
        RA           13.3908
        Dec           6.3928
        Distance   3.296e+08  # method: V
        Radius     3.835e+04
        AbsMag        -20.62
        Axis    [  0.0798  -0.4645  -0.8820]
        Angle     50.4649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5118"
}

Galaxy "NGC 5119:MCG 2-34-42"
{
        Type  "S0"
        RA           13.4000
        Dec         -12.2761
        Distance   1.281e+08  # distance uncertain!
        Radius     2.421e+04
        AbsMag        -19.07
        Axis    [  0.9171  -0.2516  -0.3091]
        Angle     97.5015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5119"
}

Galaxy "NGC 5121:ESO 382-57:MCG 6-29-35:AM 1321-372"
{
        Type  "Sa"
        RA           13.4125
        Dec         -37.6825
        Distance   7.996e+07  # method: V
        Radius      2.21e+04
        AbsMag        -20.35
        Axis    [  0.5453  -0.3547  -0.7595]
        Angle    112.9050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5121"
}

Galaxy "NGC 5121A:ESO 382-61:MCG 6-30-1:AM 1322-370"
{
        Type  "SBc"
        RA           13.4256
        Dec         -37.3781
        Distance   7.697e+07  # method: V
        Radius     1.903e+04
        AbsMag        -16.16
        Axis    [ -0.2496  -0.6764  -0.6930]
        Angle     49.5575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5121A"
}

Galaxy "NGC 5122:MCG 2-34-43:SZ 43:PRCB 16"
{
        Type  "S0"
        RA           13.4039
        Dec         -10.6544
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [ -0.2228  -0.8390  -0.4964]
        Angle     27.4031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5122"
}

Galaxy "NGC 5123:UGC 8415:MCG 7-28-5:ZWG 218.6"
{
        Type  "Sc"
        RA           13.3861
        Dec          43.0861
        Distance   3.861e+08  # method: V
        Radius     7.301e+04
        AbsMag        -21.87
        Axis    [ -0.6039   0.7847  -0.1400]
        Angle     53.7133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5123"
}

Galaxy "NGC 5124:IC 4233:ESO 444-27:MCG 5-32-9"
{
        Type  "E6"
        RA           13.4139
        Dec         -30.3081
        Distance   2.053e+08  # method: V
        Radius     6.571e+04
        AbsMag        -20.89
        Axis    [  0.4988  -0.5451  -0.6738]
        Angle    154.7978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5124"
}

Galaxy "NGC 5125:UGC 8421:MCG 2-34-11:ZWG 72.62"
{
        Type  "Sb"
        RA           13.4000
        Dec           9.7103
        Distance   3.301e+08  # method: V
        Radius     8.162e+04
        AbsMag        -21.63
        Axis    [ -0.9017   0.2750  -0.3337]
        Angle     57.4501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5125"
}

Galaxy "NGC 5126:ESO 444-28:MCG 5-32-10"
{
        Type  "Sa"
        RA           13.4147
        Dec         -30.3336
        Distance   2.259e+08  # method: V
        Radius       4.6e+04
        AbsMag         -20.1
        Axis    [  0.7130  -0.3398  -0.6133]
        Angle     66.8278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5126"
}

Galaxy "NGC 5127:UGC 8419:MCG 5-32-13:ZWG 161.42"
{
        Type  "E0"
        RA           13.3958
        Dec          31.5653
        Distance   2.275e+08  # method: V
        Radius     9.267e+04
        AbsMag        -20.72
        Axis    [  0.2502  -0.6305  -0.7348]
        Angle     70.2233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5127"
}

Galaxy "NGC 5128:ESO 270-9:MCG 7-28-1:ARP 153"
{
        Type  "S0"
        RA           13.4247
        Dec         -43.0161
        Distance   1.372e+07  # method: S
        Radius     5.129e+04
        AbsMag        -20.51
        Axis    [  0.5363  -0.3216  -0.7804]
        Angle    115.8250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5128"
}

Galaxy "NGC 5129:UGC 8423:MCG 2-34-12:ZWG 72.65"
{
        Type  "E0"
        RA           13.4028
        Dec          13.9767
        Distance   2.922e+08  # method: T-F
        Radius     7.225e+04
        AbsMag        -21.76
        Axis    [  0.4411  -0.7797  -0.4443]
        Angle    129.1999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5129"
}

Galaxy "NGC 5130:MCG 2-34-44"
{
        Type  "S0"
        RA           13.4075
        Dec         -10.2103
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.7626  -0.4377  -0.4763]
        Angle     84.9320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5130"
}

Galaxy "NGC 5131:UGC 8422:MCG 5-32-14:ZWG 161.43"
{
        Type  "Sa"
        RA           13.3992
        Dec          30.9875
        Distance    3.12e+08  # method: V
        Radius     9.529e+04
        AbsMag         -20.5
        Axis    [  0.7020  -0.3181   0.6372]
        Angle     52.6641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5131"
}

Galaxy "NGC 5132:UGC 8428:MCG 2-34-14:ZWG 72.68"
{
        Type  "SBa"
        RA           13.4078
        Dec          14.0925
        Distance   3.429e+08  # method: V
        Radius     6.484e+04
        AbsMag        -21.01
        Axis    [  0.7137  -0.6174  -0.3306]
        Angle     69.6997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5132"
}

Galaxy "NGC 5133:MCG 1-34-15:IRAS 13222-0346"
{
        Type  "S0"
        RA           13.4144
        Dec          -4.0819
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.6911  -0.5203  -0.5017]
        Angle     86.6797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5133"
}

Galaxy "NGC 5134:ESO 576-52:MCG 3-34-73:IRAS 13225-2052"
{
        Type  "SBb"
        RA           13.4217
        Dec         -21.1347
        Distance   2.718e+07  # method: T-F
        Radius     1.107e+04
        AbsMag         -17.4
        Axis    [ -0.8301  -0.2690  -0.4884]
        Angle     62.6454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5134"
}

Galaxy "NGC 5135:ESO 444-32:MCG 5-32-13:IRAS 13229-2934"
{
        Type  "SBb"
        RA           13.4289
        Dec         -29.8336
        Distance   1.983e+08  # method: V
        Radius       7.5e+04
        AbsMag        -21.12
        Axis    [  0.6658  -0.3564  -0.6555]
        Angle    107.5054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5135"
}

Galaxy "NGC 5136:IC 888:MCG 2-34-15:ZWG 72.70"
{
        Type  "E0"
        RA           13.4142
        Dec          13.7381
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.1576  -0.5201  -0.8394]
        Angle     83.1390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5136"
}

Galaxy "NGC 5137:ZWG 72.71"
{
        Type  "S0"
        RA           13.4144
        Dec          14.0769
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.2733  -0.9324  -0.2366]
        Angle     13.5042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5137"
}

Galaxy "NGC 5140:ESO 382-65:MCG 5-32-16:IRAS 13235-3336"
{
        Type  "S0"
        RA           13.4392
        Dec         -33.8686
        Distance    1.87e+08  # method: V
        Radius      5.71e+04
        AbsMag        -20.99
        Axis    [  0.5648  -0.3815  -0.7317]
        Angle    114.1419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5140"
}

Galaxy "NGC 5141:UGC 8433:MCG 6-30-4:ZWG 190.6"
{
        Type  "S0"
        RA           13.4142
        Dec          36.3789
        Distance   2.463e+08  # method: V
        Radius     4.658e+04
        AbsMag        -20.59
        Axis    [  0.6862  -0.7157  -0.1299]
        Angle     41.5587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5141"
}

Galaxy "NGC 5142:UGC 8435:MCG 6-30-6:MK 452"
{
        Type  "S0"
        RA           13.4169
        Dec          36.3997
        Distance   2.468e+08  # method: V
        Radius     3.589e+04
        AbsMag        -20.19
        Axis    [  0.7506  -0.6606  -0.0096]
        Angle    116.1787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5142"
}

Galaxy "NGC 5143:MCG 6-30-5:ZWG 190.8:ZWG 189.67"
{
        Type  "SBc"
        RA           13.4169
        Dec          36.4375
        Distance    4.05e+08  # distance uncertain!
        Radius     4.123e+04
        AbsMag        -19.07
        Axis    [  0.7013  -0.5871   0.4043]
        Angle     26.5504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5143"
}

Galaxy "NGC 5144A:UGC 8420:MCG 12-13-5:MK 256"
{
        Type  "Sc"
        RA           13.3814
        Dec          70.5147
        Distance   1.444e+08  # method: V
        Radius     2.521e+04
        AbsMag        -19.83
        Axis    [ -0.1514   0.7771   0.6109]
        Angle     45.9523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5144A"
}

Galaxy "NGC 5144B:UGC 8420:MCG 12-13-5:MK 256"
{
        Type  "E0"
        RA           13.3814
        Dec          70.5100
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.2451  -0.9689   0.0334]
        Angle    116.1256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5144B"
}

Galaxy "NGC 5145:UGC 8439:MCG 7-28-9:ZWG 218.10"
{
        Type  "Sb"
        RA           13.4203
        Dec          43.2672
        Distance   6.437e+07  # method: V
        Radius     1.873e+04
        AbsMag        -18.08
        Axis    [  0.5861  -0.7201  -0.3713]
        Angle     33.7401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5145"
}

Galaxy "NGC 5146:MCG 2-34-49:NPM 1"
{
        Type  "S0"
        RA           13.4436
        Dec         -12.3233
        Distance   1.115e+08  # distance uncertain!
        Radius     3.082e+04
        AbsMag        -19.07
        Axis    [  0.7007  -0.4645  -0.5415]
        Angle     95.1387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5146"
}

Galaxy "NGC 5147:UGC 8443:MCG 0-34-33:ZWG 16.69"
{
        Type  "SBc"
        RA           13.4386
        Dec           2.1003
        Distance   6.333e+07  # method: V
        Radius      1.75e+04
        AbsMag        -19.14
        Axis    [ -0.3043  -0.3027  -0.9032]
        Angle     45.9771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5147"
}

Galaxy "NGC 5148:MCG 1-34-21:ZWG 44.86"
{
        Type  "SBc"
        RA           13.4439
        Dec           2.3136
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.5098  -0.7289  -0.4569]
        Angle    141.5803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5148"
}

Galaxy "NGC 5149:UGC 8444:MCG 6-30-10:ZWG 190.10"
{
        Type  "SBc"
        RA           13.4358
        Dec          35.9344
        Distance   2.629e+08  # method: V
        Radius     6.118e+04
        AbsMag        -20.83
        Axis    [ -0.8034   0.4933   0.3336]
        Angle     35.8412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5149"
}

Galaxy "NGC 5150:ESO 444-43:MCG 5-32-23:IRAS 13248-2918"
{
        Type  "SBc"
        RA           13.4600
        Dec         -29.5625
        Distance   2.096e+08  # method: V
        Radius     3.963e+04
        AbsMag        -21.34
        Axis    [ -0.2787  -0.3844  -0.8801]
        Angle     71.4151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5150"
}

Galaxy "NGC 5151:MCG 3-34-32:ZWG 101.48"
{
        Type  "S0"
        RA           13.4444
        Dec          16.8739
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.4749  -0.8005  -0.3656]
        Angle    134.9988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5151"
}

Galaxy "NGC 5152:ESO 444-44:MCG 5-32-24:AM 1325-292"
{
        Type  "SBb"
        RA           13.4642
        Dec         -29.6192
        Distance   2.146e+08  # method: V
        Radius     6.554e+04
        AbsMag        -20.79
        Axis    [ -0.2840  -0.6910  -0.6648]
        Angle     44.7649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5152"
}

Galaxy "NGC 5153:ESO 444-45:MCG 5-32-25"
{
        Type  "E1"
        RA           13.4650
        Dec         -29.6178
        Distance   1.629e+08  # method: T-F
        Radius     4.739e+04
        AbsMag        -20.59
        Axis    [ -0.7164   0.1847  -0.6727]
        Angle    111.7644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5153"
}

Galaxy "NGC 5154:UGC 8447:MCG 6-30-11:ZWG 190.11"
{
        Type  "Sc"
        RA           13.4411
        Dec          36.0106
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.6290  -0.7496  -0.2062]
        Angle     67.0365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5154"
}

Galaxy "NGC 5156:ESO 220-13:IRAS 13256-4839"
{
        Type  "SBb"
        RA           13.4789
        Dec         -48.9167
        Distance   1.452e+08  # method: V
        Radius     5.281e+04
        AbsMag        -20.74
        Axis    [ -0.2445  -0.3598  -0.9004]
        Angle     93.7457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5156"
}

Galaxy "NGC 5157:UGC 8455:MCG 5-32-21:ZWG 161.56"
{
        Type  "SBa"
        RA           13.4544
        Dec          32.0308
        Distance   3.387e+08  # method: V
        Radius     6.403e+04
        AbsMag        -20.78
        Axis    [  0.4591  -0.8691  -0.1838]
        Angle     11.4253
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5157"
}

Galaxy "NGC 5158:UGC 8459:MCG 3-34-38:ZWG 101.54"
{
        Type  "SBb"
        RA           13.4628
        Dec          17.7789
        Distance   3.121e+08  # method: V
        Radius     5.901e+04
        AbsMag         -21.2
        Axis    [ -0.3275  -0.0998  -0.9396]
        Angle     39.9405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5158"
}

Galaxy "NGC 5159:UGC 8460:MCG 1-34-22:ZWG 44.88"
{
        Type  "Sc"
        RA           13.4711
        Dec           2.9836
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [ -0.9607  -0.1846   0.2075]
        Angle     50.0436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5159"
}

Galaxy "NGC 5161:ESO 383-4:MCG 5-32-31:UGCA 359"
{
        Type  "Sc"
        RA           13.4869
        Dec         -33.1744
        Distance   8.154e+07  # method: T-F
        Radius     6.641e+04
        AbsMag        -19.89
        Axis    [  0.3966  -0.4769  -0.7844]
        Angle     62.1416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5161"
}

Galaxy "NGC 5163:UGC 8453:MCG 9-22-62:ZWG 271.40"
{
        Type  "E0"
        RA           13.4483
        Dec          52.7542
        Distance   3.631e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -20.13
        Axis    [  0.3288  -0.9326  -0.1487]
        Angle    112.7049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5163"
}

Galaxy "NGC 5164:UGC 8458:MCG 9-22-63:MK 257"
{
        Type  "SBb"
        RA           13.4531
        Dec          55.4869
        Distance   3.245e+08  # method: V
        Radius      4.72e+04
        AbsMag        -20.49
        Axis    [  0.5640  -0.8245   0.0458]
        Angle     93.8079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5164"
}

Galaxy "NGC 5165:MCG 2-34-16:ZWG 72.78:NPM 1"
{
        Type  "S0"
        RA           13.4775
        Dec          11.3875
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.9697   0.2225  -0.1005]
        Angle     57.3205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5165"
}

Galaxy "NGC 5166:NGC 5166A:UGC 8463:MCG 5-32-26"
{
        Type  "Sb"
        RA           13.4708
        Dec          32.0322
        Distance   2.212e+08  # method: V
        Radius       7.4e+04
        AbsMag        -19.86
        Axis    [  0.7891  -0.3432   0.5095]
        Angle     64.4000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5166"
}

Galaxy "NGC 5166B:MCG 5-32-27:ZWG 161.64"
{
        Type  "Sb"
        RA           13.4758
        Dec          32.0692
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.7115  -0.6871   0.1471]
        Angle     30.1664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5166B"
}

Galaxy "NGC 5167:MCG 2-34-17:ZWG 72.80:IRAS 13261+1258"
{
        Type  "Sc"
        RA           13.4778
        Dec          12.7114
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.4823  -0.7826  -0.3936]
        Angle    137.1037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5167"
}

Galaxy "NGC 5169:UGC 8465:MCG 8-25-4:ZWG 246.2"
{
        Type  "SBc"
        RA           13.4694
        Dec          46.6722
        Distance   1.185e+08  # method: V
        Radius      3.62e+04
        AbsMag         -18.4
        Axis    [  0.4446  -0.1995   0.8732]
        Angle     39.2736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5169"
}

Galaxy "NGC 5170:MCG 3-34-84:UGCA 360:ESO 576-65"
{
        Type  "Sc"
        RA           13.4967
        Dec         -17.9653
        Distance   1.417e+08  # method: T-F
        Radius      1.69e+05
        AbsMag        -21.09
        Axis    [ -0.5069  -0.8529  -0.1247]
        Angle     33.1383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5170"
}

Galaxy "NGC 5171:UGC 8476:MCG 2-34-20:ZWG 72.89"
{
        Type  "S0"
        RA           13.4892
        Dec          11.7353
        Distance   3.206e+08  # method: V
        Radius      5.13e+04
        AbsMag        -21.06
        Axis    [  0.7729  -0.5794  -0.2587]
        Angle    113.5593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5171"
}

Galaxy "NGC 5172:UGC 8477:MCG 3-34-41:ZWG 101.57"
{
        Type  "SBc"
        RA           13.4886
        Dec          17.0517
        Distance   2.092e+08  # method: T-F
        Radius     1.035e+05
        AbsMag        -21.44
        Axis    [  0.4479  -0.8761  -0.1783]
        Angle     21.0360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5172"
}

Galaxy "NGC 5173:UGC 8468:MCG 8-25-5:ZWG 246.3"
{
        Type  "E0"
        RA           13.4736
        Dec          46.5922
        Distance   1.177e+08  # method: V
        Radius     1.712e+04
        AbsMag        -19.59
        Axis    [  0.1118  -0.0865  -0.9900]
        Angle     39.8562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5173"
}

Galaxy "NGC 5174:NGC 5162:UGC 8475:MCG 2-34-18"
{
        Type  "Sc"
        RA           13.4903
        Dec          11.0078
        Distance   3.085e+08  # method: T-F
        Radius     1.212e+05
        AbsMag        -21.68
        Axis    [ -0.9982   0.0576  -0.0148]
        Angle     43.9723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5174"
}

Galaxy "NGC 5176:MCG 2-34-21:ZWG 72.90:NPM 1"
{
        Type  "E0"
        RA           13.4900
        Dec          11.7819
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.4610  -0.7879  -0.4082]
        Angle    138.8286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5176"
}

Galaxy "NGC 5177:MCG 2-34-19:ZWG 72.91"
{
        Type  "S0"
        RA           13.4900
        Dec          11.7967
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.7592  -0.3988   0.5143]
        Angle     25.9599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5177"
}

Galaxy "NGC 5178:UGC 8478:MCG 2-34-22:ZWG 72.93"
{
        Type  "Sa"
        RA           13.4914
        Dec          11.6250
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.4714  -0.7629  -0.4425]
        Angle     30.9778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5178"
}

Galaxy "NGC 5179:MCG 2-34-23:MK 1349:ZWG 72.94"
{
        Type  "S0"
        RA           13.4917
        Dec          11.7464
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.7931  -0.5614  -0.2361]
        Angle     76.6197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5179"
}

Galaxy "NGC 5180:UGC 8479:MCG 3-34-42:ZWG 101.58"
{
        Type  "S0"
        RA           13.4906
        Dec          16.8258
        Distance   3.166e+08  # method: V
        Radius     6.447e+04
        AbsMag        -20.93
        Axis    [  0.7557  -0.6116  -0.2344]
        Angle     98.0907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5180"
}

Galaxy "NGC 5181:MCG 2-34-24:ZWG 72.98:NPM 1"
{
        Type  "S0"
        RA           13.4947
        Dec          13.3044
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.5287  -0.6693  -0.5220]
        Angle     79.0046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5181"
}

Galaxy "NGC 5182:ESO 444-62:MCG 5-32-34:IRAS 13278-2753"
{
        Type  "SBc"
        RA           13.5114
        Dec         -28.1503
        Distance   2.121e+08  # method: V
        Radius     5.862e+04
        AbsMag        -20.87
        Axis    [  0.7510  -0.3355  -0.5687]
        Angle    120.3978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5182"
}

Galaxy "NGC 5183:UGC 8485:MCG 0-34-39:ZWG 16.79"
{
        Type  "Sb"
        RA           13.5017
        Dec          -1.7206
        Distance   2.085e+08  # method: V
        Radius     5.761e+04
        AbsMag        -20.53
        Axis    [ -0.4921  -0.7705  -0.4052]
        Angle     24.6533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5183"
}

Galaxy "NGC 5184:UGC 8487:MCG 0-34-41:ZWG 16.81"
{
        Type  "SBc"
        RA           13.5031
        Dec          -1.6636
        Distance   1.943e+08  # method: V
        Radius     5.653e+04
        AbsMag        -20.37
        Axis    [ -0.7393  -0.3638  -0.5666]
        Angle     35.6008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5184"
}

Galaxy "NGC 5185:UGC 8488:MCG 2-34-25:ZWG 72.104"
{
        Type  "Sb"
        RA           13.5006
        Dec          13.4161
        Distance   4.459e+08  # method: T-F
        Radius     1.167e+05
        AbsMag        -21.28
        Axis    [  0.8511  -0.5225  -0.0514]
        Angle     62.0192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5185"
}

Galaxy "NGC 5186:ZWG 72.103"
{
        Type  "S0"
        RA           13.5008
        Dec          12.1753
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.7222  -0.6135  -0.3194]
        Angle     95.0554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5186"
}

Galaxy "NGC 5187:MCG 5-32-29:ZWG 161.69:KUG 1327+313"
{
        Type  "Sb"
        RA           13.4967
        Dec          31.1300
        Distance   3.357e+08  # method: V
        Radius     6.347e+04
        AbsMag        -20.56
        Axis    [  0.7769  -0.6296  -0.0013]
        Angle     73.6735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5187"
}

Galaxy "NGC 5188:MCG 6-30-7:ESO 383-9:AM 1328-343"
{
        Type  "SBc"
        RA           13.5242
        Dec         -34.7950
        Distance   1.179e+08  # method: V
        Radius     5.143e+04
        AbsMag        -19.89
        Axis    [ -0.0426  -0.6263  -0.7785]
        Angle     51.7156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5188"
}

Galaxy "NGC 5190:UGC 8500:MCG 3-34-43:ZWG 101.60"
{
        Type  "SBb"
        RA           13.5106
        Dec          18.1344
        Distance   1.997e+08  # method: V
        Radius     2.904e+04
        AbsMag        -20.13
        Axis    [ -0.8555   0.3263  -0.4020]
        Angle     44.5533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5190"
}

Galaxy "NGC 5191:MCG 2-34-26:ZWG 73.3:NPM 1"
{
        Type  "Sb"
        RA           13.5131
        Dec          11.2014
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.4175  -0.6539  -0.6310]
        Angle     48.8980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5191"
}

Galaxy "NGC 5192:ZWG 17.1"
{
        Type  "Sa"
        RA           13.5142
        Dec          -1.7789
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.8426  -0.4353  -0.3172]
        Angle     94.9150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5192"
}

Galaxy "NGC 5193:ESO 383-15:MCG 5-32-37:AM 1328-325"
{
        Type  "E0"
        RA           13.5314
        Dec         -33.2347
        Distance    1.11e+08  # method: S
        Radius     2.422e+04
        AbsMag        -20.16
        Axis    [  0.5357  -0.5439  -0.6459]
        Angle    161.7807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5193"
}

Galaxy "NGC 5193A:ESO 383-14:MCG 5-32-36"
{
        Type  "S0"
        RA           13.5303
        Dec         -33.2397
        Distance   1.721e+08  # method: V
        Radius     2.252e+04
        AbsMag        -19.61
        Axis    [  0.7126  -0.3043  -0.6321]
        Angle     77.9702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5193A"
}

Galaxy "M 51:NGC 5194:UGC 8493:MCG 8-25-12"
{
        Type  "Sc"
        RA           13.4978
        Dec          47.1956
        Distance   2.447e+07  # method: NS
        Radius     3.986e+04
        AbsMag        -20.47
        Axis    [  0.7458  -0.6548   0.1229]
        Angle    116.2348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 51"
}

Galaxy "NGC 5195:UGC 8494:MCG 8-25-14:ZWG 246.9"
{
        Type  "SBa"
        RA           13.4997
        Dec          47.2675
        Distance   2.497e+07  # method: S
        Radius     2.143e+04
        AbsMag        -18.92
        Axis    [  0.6995  -0.7059   0.1111]
        Angle     43.2785
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5195"
}

Galaxy "NGC 5196:ZWG 17.2:NPM 1"
{
        Type  "S0"
        RA           13.5219
        Dec          -1.6144
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.0549  -0.4796  -0.8758]
        Angle     59.1249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5196"
}

Galaxy "NGC 5197:ZWG 17.3:NPM 1"
{
        Type  "Sa"
        RA           13.5236
        Dec          -1.6925
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.9423  -0.2433  -0.2298]
        Angle     41.8875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5197"
}

Galaxy "NGC 5198:UGC 8499:MCG 8-25-15:ZWG 246.10"
{
        Type  "E1"
        RA           13.5031
        Dec          46.6708
        Distance   1.613e+08  # method: T-F
        Radius     4.692e+04
        AbsMag        -20.77
        Axis    [  0.3448  -0.9246  -0.1621]
        Angle    124.7577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5198"
}

Galaxy "NGC 5199:UGC 8504:MCG 6-30-24:ZWG 190.16"
{
        Type  "S0"
        RA           13.5117
        Dec          34.8311
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.4130  -0.8785  -0.2401]
        Angle    128.4646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5199"
}

Galaxy "NGC 5201:UGC 8480:MCG 9-22-69:ZWG 271.45"
{
        Type  "S0"
        RA           13.4878
        Dec          53.0817
        Distance   4.063e+08  # method: V
        Radius     1.005e+05
        AbsMag        -21.38
        Axis    [ -0.3920   0.6949   0.6028]
        Angle     30.7108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5201"
}

Galaxy "NGC 5202:ZWG 17.10"
{
        Type  "Sb"
        RA           13.5333
        Dec          -1.6986
        Distance   2.555e+08  # distance uncertain!
        Radius     4.831e+04
        AbsMag        -19.07
        Axis    [  0.9616  -0.2195  -0.1648]
        Angle    115.1943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5202"
}

Galaxy "NGC 5203:MCG 1-35-1"
{
        Type  "S0"
        RA           13.5369
        Dec          -8.7864
        Distance   1.115e+08  # distance uncertain!
        Radius      2.92e+04
        AbsMag        -19.07
        Axis    [  0.3576  -0.6042  -0.7121]
        Angle     51.8553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5203"
}

Galaxy "NGC 5204:UGC 8490:MCG 10-19-78:ZWG 294.39"
{
        Type  "Irr"
        RA           13.4933
        Dec          58.4183
        Distance    2.12e+07  # method: T-F
        Radius     1.542e+04
        AbsMag        -17.36
        Axis    [  0.7053  -0.6727   0.2236]
        Angle    120.3700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5204"
}

Galaxy "NGC 5205:UGC 8501:MCG 11-17-3:ZWG 316.17"
{
        Type  "Sb"
        RA           13.5008
        Dec          62.5125
        Distance   9.323e+07  # method: T-F
        Radius     4.339e+04
        AbsMag        -19.08
        Axis    [ -0.4319   0.7397   0.5160]
        Angle     55.1464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5205"
}

Galaxy "NGC 5206:ESO 220-18"
{
        Type  "S0"
        RA           13.5619
        Dec         -48.1519
        Distance   3.633e+07  # method: V
        Radius     2.008e+04
        AbsMag        -18.63
        Axis    [  0.4421  -0.3369  -0.8313]
        Angle    125.4827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5206"
}

Galaxy "NGC 5207:UGC 8518:MCG 2-35-1:ZWG 73.18"
{
        Type  "Sb"
        RA           13.5369
        Dec          13.8914
        Distance   3.719e+08  # method: T-F
        Radius     9.195e+04
        AbsMag        -20.88
        Axis    [ -0.9633  -0.1373  -0.2308]
        Angle     25.9530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5207"
}

Galaxy "NGC 5208:UGC 8519:MCG 1-35-1:ZWG 45.7"
{
        Type  "S0"
        RA           13.5408
        Dec           7.3169
        Distance   3.195e+08  # method: V
        Radius     7.899e+04
        AbsMag        -20.05
        Axis    [ -0.9772  -0.0959   0.1894]
        Angle     48.1104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5208"
}

Galaxy "NGC 5209:UGC 8522:MCG 1-35-2:ZWG 45.9"
{
        Type  "E0"
        RA           13.5450
        Dec           7.3278
        Distance   2.754e+08  # distance uncertain!
        Radius     4.807e+04
        AbsMag        -20.13
        Axis    [  0.4664  -0.7690  -0.4372]
        Angle    141.3448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5209"
}

Galaxy "NGC 5210:UGC 8523:MCG 1-35-3:ZWG 45.10"
{
        Type  "Sa"
        RA           13.5469
        Dec           7.1700
        Distance   3.241e+08  # method: V
        Radius       6.6e+04
        AbsMag        -20.89
        Axis    [  0.6747  -0.6320  -0.3813]
        Angle    114.3151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5210"
}

Galaxy "NGC 5211:UGC 8530:MCG 0-35-9:ZWG 17.21"
{
        Type  "SBb"
        RA           13.5514
        Dec          -1.0358
        Distance   1.816e+08  # method: V
        Radius     5.547e+04
        AbsMag        -20.13
        Axis    [  0.6905  -0.5590  -0.4591]
        Angle     99.3375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5211"
}

Galaxy "NGC 5212:ZWG 45.14"
{
        Type  "S0"
        RA           13.5489
        Dec           7.2881
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [ -0.0768  -0.5581  -0.8262]
        Angle     34.9078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5212"
}

Galaxy "NGC 5213:UGC 8552:MCG 1-35-8:ZWG 45.28"
{
        Type  "SBb"
        RA           13.5775
        Dec           4.1308
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.4980  -0.1426  -0.8554]
        Angle     48.9958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5213"
}

Galaxy "NGC 5214:UGC 8531:MCG 7-28-30:ZWG 218.21"
{
        Type  "Sc"
        RA           13.5467
        Dec          41.8722
        Distance   3.802e+08  # method: V
        Radius     6.083e+04
        AbsMag        -20.83
        Axis    [ -0.6988   0.6747   0.2374]
        Angle     18.0099
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5214"
}

Galaxy "NGC 5214A:MCG 7-28-29:KCPG 381A:IRAS 13306+4207"
{
        Type  "Sc"
        RA           13.5464
        Dec          41.8650
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.8352  -0.4802   0.2680]
        Angle     97.1526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5214A"
}

Galaxy "NGC 5215A:ESO 383-28:MCG 5-32-40:VV 693"
{
        Type  "S0"
        RA           13.5850
        Dec         -33.4811
        Distance   1.893e+08  # method: V
        Radius     1.652e+04
        AbsMag        -19.62
        Axis    [ -0.1420  -0.4726  -0.8698]
        Angle     68.9198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5215A"
}

Galaxy "NGC 5215B:ESO 383-29:MCG 5-32-41:VV 693"
{
        Type  "S0"
        RA           13.5858
        Dec         -33.4839
        Distance   1.917e+08  # method: V
        Radius     3.345e+04
        AbsMag        -19.95
        Axis    [  0.3374  -0.5110  -0.7906]
        Angle     61.3849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5215B"
}

Galaxy "NGC 5216:UGC 8528:MCG 11-17-4:ZWG 316.19"
{
        Type  "E0"
        RA           13.5353
        Dec          62.7008
        Distance   1.916e+08  # method: T-F
        Radius     5.015e+04
        AbsMag        -20.24
        Axis    [  0.3056  -0.9451  -0.1160]
        Angle     93.4712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5216"
}

Galaxy "NGC 5216A:UGC 8571:MCG 10-19-95:ZWG 294.49"
{
        Type  "S0"
        RA           13.5781
        Dec          61.9931
        Distance   1.463e+08  # method: V
        Radius     2.553e+04
        AbsMag        -19.16
        Axis    [  0.6371  -0.2974   0.7111]
        Angle     82.1237
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5216A"
}

Galaxy "NGC 5217:UGC 8546:MCG 3-35-9:ZWG 102.19"
{
        Type  "E0"
        RA           13.5681
        Dec          17.8572
        Distance   3.779e+08  # method: V
        Radius     8.244e+04
        AbsMag        -21.62
        Axis    [  0.3449  -0.7537  -0.5595]
        Angle    108.2951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5217"
}

Galaxy "NGC 5218:UGC 8529:MCG 11-17-5:ZWG 316.20"
{
        Type  "SBb"
        RA           13.5361
        Dec          62.7681
        Distance   1.319e+08  # method: V
        Radius     3.452e+04
        AbsMag        -19.93
        Axis    [  0.6275  -0.3025   0.7174]
        Angle     33.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5218"
}

Galaxy "NGC 5219:NGC 5244:ESO 270-23:MCG 7-28-7"
{
        Type  "Sb"
        RA           13.6447
        Dec         -45.8547
        Distance   1.252e+08  # method: T-F
        Radius     2.367e+04
        AbsMag        -19.52
        Axis    [  0.6791  -0.2272  -0.6980]
        Angle    118.6144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5219"
}

Galaxy "NGC 5220:ESO 383-36:MCG 5-32-46:IRAS 13330-3311"
{
        Type  "Sa"
        RA           13.5989
        Dec         -33.4544
        Distance   2.014e+08  # method: V
        Radius      7.03e+04
        AbsMag        -20.75
        Axis    [  0.1295  -0.6695  -0.7314]
        Angle     47.7887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5220"
}

Galaxy "NGC 5221:UGC 8559:MCG 2-35-6:ZWG 73.40"
{
        Type  "Sb"
        RA           13.5822
        Dec          13.8325
        Distance   3.299e+08  # method: T-F
        Radius     7.678e+04
        AbsMag        -20.82
        Axis    [  0.3600  -0.9145  -0.1846]
        Angle     21.9883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5221"
}

Galaxy "NGC 5222-1:UGC 8558:MCG 2-35-5:ZWG 73.39"
{
        Type  "E0"
        RA           13.5819
        Dec          13.7411
        Distance   2.291e+08  # distance uncertain!
        Radius     5.332e+04
        AbsMag        -20.13
        Axis    [  0.3533  -0.7417  -0.5701]
        Angle    113.1348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5222-1"
}

Galaxy "NGC 5222-2:UGC 8558:MCG 2-35-5:ZWG 73.39"
{
        Type  "S0"
        RA           13.5825
        Dec          13.7436
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.8203  -0.5507  -0.1543]
        Angle     76.0826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5222-2"
}

Galaxy "NGC 5223:UGC 8553:MCG 6-30-40:ZWG 190.25"
{
        Type  "E0"
        RA           13.5736
        Dec          34.6906
        Distance   3.365e+08  # method: V
        Radius      7.34e+04
        AbsMag        -21.37
        Axis    [ -0.3588   0.6289  -0.6898]
        Angle     64.7710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5223"
}

Galaxy "NGC 5224:MCG 1-35-9:ZWG 45.30:NPM 1"
{
        Type  "S0"
        RA           13.5856
        Dec           6.4817
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.4860  -0.7574  -0.4360]
        Angle    140.7413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5224"
}

Galaxy "NGC 5225:UGC 8540:MCG 9-22-78:ZWG 271.50"
{
        Type  "S0"
        RA           13.5556
        Dec          51.4908
        Distance   2.174e+08  # method: V
        Radius     2.213e+04
        AbsMag        -19.62
        Axis    [  0.3457  -0.9318  -0.1104]
        Angle    123.4304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5225"
}

Galaxy "NGC 5226"
{
        Type  "S0"
        RA           13.5842
        Dec          13.9214
        Distance   4.441e+08  # distance uncertain!
        Radius     1.938e+04
        AbsMag        -19.07
        Axis    [  0.9064  -0.4191  -0.0525]
        Angle     95.4771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5226"
}

Galaxy "NGC 5227:UGC 8566:MCG 0-35-10:ZWG 17.29"
{
        Type  "SBb"
        RA           13.5900
        Dec           1.4106
        Distance   2.513e+08  # method: V
        Radius     6.579e+04
        AbsMag        -20.73
        Axis    [  0.5478  -0.6238  -0.5575]
        Angle     96.9156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5227"
}

Galaxy "NGC 5228:UGC 8556:MCG 6-30-43:ZWG 190.26"
{
        Type  "S0"
        RA           13.5764
        Dec          34.7778
        Distance   3.591e+08  # method: V
        Radius     5.224e+04
        AbsMag        -20.81
        Axis    [  0.6061  -0.7817  -0.1468]
        Angle    115.4267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5228"
}

Galaxy "NGC 5229:UGC 8550:MCG 8-25-19:ZWG 246.13"
{
        Type  "SBc"
        RA           13.5672
        Dec          47.9144
        Distance   2.424e+07  # method: V
        Radius     1.163e+04
        AbsMag        -14.95
        Axis    [ -0.6001   0.3397   0.7243]
        Angle     66.5612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5229"
}

Galaxy "NGC 5230:UGC 8573:MCG 2-35-9:ZWG 73.43"
{
        Type  "SBc"
        RA           13.5922
        Dec          13.6753
        Distance    3.23e+08  # method: V
        Radius     8.926e+04
        AbsMag        -21.98
        Axis    [  0.4683  -0.7928  -0.3902]
        Angle    137.6590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5230"
}

Galaxy "NGC 5231:UGC 8574:MCG 1-35-11:ZWG 45.34"
{
        Type  "SBa"
        RA           13.5967
        Dec           2.9989
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.1659  -0.4567  -0.8740]
        Angle     44.0666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5231"
}

Galaxy "NGC 5232:MCG 1-35-3:IRAS 13335-0814"
{
        Type  "Sa"
        RA           13.6022
        Dec          -8.4978
        Distance   1.281e+08  # distance uncertain!
        Radius     2.794e+04
        AbsMag        -19.07
        Axis    [ -0.1900  -0.3406  -0.9208]
        Angle     68.7235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5232"
}

Galaxy "NGC 5233:UGC 8568:MCG 6-30-47:ZWG 190.29"
{
        Type  "Sb"
        RA           13.5869
        Dec          34.6772
        Distance   3.696e+08  # method: V
        Radius     7.525e+04
        AbsMag        -20.47
        Axis    [  0.7439  -0.5954   0.3036]
        Angle     45.0728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5233"
}

Galaxy "NGC 5234:ESO 220-24"
{
        Type  "S0"
        RA           13.6247
        Dec         -49.8372
        Distance   1.752e+08  # method: V
        Radius     3.312e+04
        AbsMag        -19.65
        Axis    [  0.4554  -0.3023  -0.8374]
        Angle    101.2331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5234"
}

Galaxy "NGC 5235:UGC 8582:MCG 1-35-12:ZWG 45.36"
{
        Type  "SBc"
        RA           13.6003
        Dec           6.5850
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.4168  -0.9021  -0.1116]
        Angle     19.2433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5235"
}

Galaxy "M 83:NGC 5236:ESO 444-81:MCG 5-32-50"
{
        Type  "Sc"
        RA           13.6167
        Dec         -29.8672
        Distance    3.57e+07  # method: V
        Radius     6.698e+04
        AbsMag        -21.99
        Axis    [  0.4273  -0.4519  -0.7831]
        Angle    112.0494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 83"
}

Galaxy "NGC 5237:ESO 270-22:MCG 7-28-5:FAIR 160"
{
        Type  "E0"
        RA           13.6272
        Dec         -42.8478
        Distance   2.541e+07  # method: V
        Radius          7393
        AbsMag        -16.26
        Axis    [ -0.3328  -0.1893  -0.9238]
        Angle    124.0054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5237"
}

Galaxy "NGC 5238-1:UGC 8565:MCG 9-22-82:ZWG 271.52"
{
        Type  "Irr"
        RA           13.5783
        Dec          51.6139
        Distance   1.758e+07  # method: V
        Radius          3835
        AbsMag        -14.36
        Axis    [ -0.5088   0.8538   0.1103]
        Angle     37.9749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5238-1"
}

Galaxy "NGC 5238-2:UGC 8565:MCG 9-22-82:ZWG 271.52"
{
        Type  "Sc"
        RA           13.5786
        Dec          51.6094
        Distance   1.758e+07  # method: V
        Radius          2045
        AbsMag        -13.66
        Axis    [  0.3433  -0.9328  -0.1096]
        Angle    123.6761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5238-2"
}

Galaxy "NGC 5239:UGC 8589:MCG 1-35-15:ZWG 45.40"
{
        Type  "SBc"
        RA           13.6072
        Dec           7.3697
        Distance    1.47e+08  # distance uncertain!
        Radius      3.85e+04
        AbsMag        -19.07
        Axis    [  0.7902  -0.5434  -0.2835]
        Angle    110.5765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5239"
}

Galaxy "NGC 5240:UGC 8587:MCG 6-30-56:ZWG 190.34"
{
        Type  "SBc"
        RA           13.5986
        Dec          35.5883
        Distance   1.115e+08  # method: V
        Radius     3.082e+04
        AbsMag        -18.87
        Axis    [  0.6938  -0.7178  -0.0575]
        Angle     63.0030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5240"
}

Galaxy "NGC 5241:MCG 1-35-6:IRAS 13340-0808"
{
        Type  "Sb"
        RA           13.6108
        Dec          -8.4017
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.7397  -0.5034  -0.4466]
        Angle     68.6056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5241"
}

Galaxy "NGC 5243:UGC 8592:MCG 7-28-36:ZWG 218.27"
{
        Type  "Sc"
        RA           13.6042
        Dec          38.3433
        Distance   1.999e+08  # method: V
        Radius     4.361e+04
        AbsMag        -19.84
        Axis    [ -0.1059  -0.0302   0.9939]
        Angle     37.1077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5243"
}

Galaxy "NGC 5245:ZWG 45.48:NPM 1"
{
        Type  "S0"
        RA           13.6231
        Dec           3.8981
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.6021  -0.7739  -0.1964]
        Angle     33.9723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5245"
}

Galaxy "NGC 5246:UGC 8612:MCG 1-35-17:ZWG 45.50"
{
        Type  "SBb"
        RA           13.6247
        Dec           4.1044
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.5081  -0.6325  -0.5846]
        Angle     71.3550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5246"
}

Galaxy "NGC 5247:ESO 577-14:MCG 3-35-11:UGCA 368"
{
        Type  "SBc"
        RA           13.6339
        Dec         -17.8847
        Distance   7.461e+07  # method: V
        Radius      5.86e+04
        AbsMag         -21.1
        Axis    [  0.5868  -0.5252  -0.6162]
        Angle    123.2537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5247"
}

Galaxy "NGC 5248:UGC 8616:MCG 2-35-15:ZWG 73.54"
{
        Type  "SBc"
        RA           13.6256
        Dec           8.8861
        Distance    6.51e+07  # method: V
        Radius      5.87e+04
        AbsMag         -20.6
        Axis    [ -0.4198  -0.4717  -0.7754]
        Angle     29.6066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5248"
}

Galaxy "NGC 5249:UGC 8618:MCG 3-35-15:ZWG 102.28"
{
        Type  "S0"
        RA           13.6269
        Dec          15.9722
        Distance   3.598e+08  # method: V
        Radius     8.374e+04
        AbsMag        -21.01
        Axis    [ -0.9208   0.3210  -0.2214]
        Angle     52.7672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5249"
}

Galaxy "NGC 5250:UGC 8594:MCG 9-22-85:ZWG 271.53"
{
        Type  "S0"
        RA           13.6019
        Dec          51.2364
        Distance   2.121e+08  # method: V
        Radius     3.084e+04
        AbsMag        -20.06
        Axis    [  0.6891  -0.0068  -0.7246]
        Angle      7.5476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5250"
}

Galaxy "NGC 5251:MCG 5-32-44:ZWG 161.90:KUG 1335+276"
{
        Type  "Sa"
        RA           13.6233
        Dec          27.4192
        Distance   5.152e+08  # method: V
        Radius     5.245e+04
        AbsMag        -21.19
        Axis    [  0.4267  -0.8545  -0.2962]
        Angle    132.3911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5251"
}

Galaxy "NGC 5252:UGC 8622:MCG 1-35-22:ZWG 45.56"
{
        Type  "S0"
        RA           13.6375
        Dec           4.5425
        Distance   3.252e+08  # method: V
        Radius     6.622e+04
        AbsMag        -20.69
        Axis    [  0.8041  -0.5163  -0.2946]
        Angle    113.3628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5252"
}

Galaxy "NGC 5253:ESO 445-4:MCG 5-32-60:UGCA 369"
{
        Type  "S0"
        RA           13.6653
        Dec         -31.6417
        Distance    3.04e+07  # method: V
        Radius     2.211e+04
        AbsMag        -18.85
        Axis    [  0.6959  -0.3394  -0.6329]
        Angle     81.1966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5253"
}

Galaxy "NGC 5254:MCG 2-35-12:IRAS 13369-1114"
{
        Type  "Sc"
        RA           13.6606
        Dec         -11.4942
        Distance   1.159e+08  # method: T-F
        Radius     5.393e+04
        AbsMag        -19.65
        Axis    [ -0.5199  -0.6597  -0.5426]
        Angle     36.5743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5254"
}

Galaxy "NGC 5255:MCG 10-19-98:ZWG 294.51"
{
        Type  "S0"
        RA           13.6214
        Dec          57.1097
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.7919  -0.4526   0.4100]
        Angle    112.2709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5255"
}

Galaxy "NGC 5256:UGC 8632:MCG 8-25-31:MK 266"
{
        Type  "Sb"
        RA           13.6381
        Dec          48.2775
        Distance    3.86e+08  # method: V
        Radius     6.737e+04
        AbsMag        -21.47
        Axis    [  0.5486  -0.8338  -0.0624]
        Angle     93.6004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5256"
}

Galaxy "NGC 5257:UGC 8641:MCG 0-35-15:ZWG 17.55"
{
        Type  "SBb"
        RA           13.6644
        Dec           0.8403
        Distance   3.215e+08  # method: V
        Radius     7.481e+04
        AbsMag        -22.07
        Axis    [ -0.4512  -0.7561  -0.4740]
        Angle     26.1362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5257"
}

Galaxy "NGC 5258:UGC 8645:MCG 0-35-16:ZWG 17.56"
{
        Type  "SBb"
        RA           13.6658
        Dec           0.8317
        Distance   3.197e+08  # method: V
        Radius      6.51e+04
        AbsMag        -22.06
        Axis    [  0.7745  -0.5214  -0.3583]
        Angle    102.6489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5258"
}

Galaxy "NGC 5259-1:MCG 5-32-52:ZWG 161.105:NPM 1"
{
        Type  "E0"
        RA           13.6567
        Dec          30.9911
        Distance   3.802e+08  # distance uncertain!
        Radius     6.083e+04
        AbsMag        -20.13
        Axis    [  0.0007  -0.3122  -0.9500]
        Angle     54.9546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5259-1"
}

Galaxy "NGC 5259-2:MCG 5-32-52:ZWG 161.105"
{
        Type  "S0"
        RA           13.6564
        Dec          30.9925
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.7328  -0.6784  -0.0523]
        Angle     73.1987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5259-2"
}

Galaxy "NGC 5260:ESO 509-92:MCG 4-32-50:AM 1337-233"
{
        Type  "SBc"
        RA           13.6719
        Dec         -23.8583
        Distance   3.083e+08  # method: V
        Radius     7.175e+04
        AbsMag        -21.28
        Axis    [  0.6919  -0.4603  -0.5562]
        Angle    138.3310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5260"
}

Galaxy "NGC 5261:ZWG 45.67:NPM 1"
{
        Type  "S0"
        RA           13.6711
        Dec           5.0769
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.9226  -0.3516  -0.1588]
        Angle     31.3528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5261"
}

Galaxy "NGC 5262:UGC 8606:ZWG 353.22:NPM 1"
{
        Type  "S0"
        RA           13.5939
        Dec          75.0400
        Distance    4.11e+08  # method: V
        Radius     7.174e+04
        AbsMag         -20.3
        Axis    [  0.6285  -0.6717   0.3921]
        Angle    118.1343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5262"
}

Galaxy "NGC 5263:UGC 8648:MCG 5-32-58:ZWG 161.113"
{
        Type  "Sc"
        RA           13.6653
        Dec          28.3997
        Distance   2.303e+08  # method: V
        Radius      5.36e+04
        AbsMag        -20.14
        Axis    [  0.8958  -0.4157   0.1574]
        Angle     98.2715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5263"
}

Galaxy "NGC 5264:ESO 445-12:MCG 5-32-66:UGCA 370"
{
        Type  "Irr"
        RA           13.6933
        Dec         -29.9119
        Distance   3.384e+07  # method: V
        Radius      1.28e+04
        AbsMag        -17.48
        Axis    [  0.5318  -0.4303  -0.7294]
        Angle     83.7185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5264"
}

Galaxy "NGC 5265:MCG 6-30-68:ZWG 190.40:KUG 1337+371"
{
        Type  "SBc"
        RA           13.6692
        Dec          36.8614
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.5860  -0.7802  -0.2188]
        Angle     59.2129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5265"
}

Galaxy "NGC 5266:ESO 220-33:AM 1339-475:IRAS 13399-4755"
{
        Type  "S0"
        RA           13.7169
        Dec         -48.1692
        Distance   1.492e+08  # method: V
        Radius     7.162e+04
        AbsMag         -21.3
        Axis    [ -0.1729  -0.4343  -0.8840]
        Angle     85.6608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5266"
}

Galaxy "NGC 5266A:ESO 220-30:AM 1337-480:IRAS 13375-4805"
{
        Type  "SBc"
        RA           13.6769
        Dec         -48.3422
        Distance    1.39e+08  # method: V
        Radius     6.266e+04
        AbsMag        -20.45
        Axis    [  0.4053  -0.3400  -0.8486]
        Angle    116.2527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5266A"
}

Galaxy "NGC 5267:UGC 8655:MCG 7-28-49:ZWG 218.36"
{
        Type  "SBb"
        RA           13.6778
        Dec          38.7944
        Distance   2.783e+08  # method: V
        Radius     5.667e+04
        AbsMag        -20.36
        Axis    [  0.7953  -0.5000   0.3427]
        Angle     72.8042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5267"
}

Galaxy "NGC 5270:UGC 8673:MCG 1-35-31:ZWG 45.75"
{
        Type  "SBb"
        RA           13.7028
        Dec           4.2625
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.7328  -0.5759  -0.3623]
        Angle    106.6194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5270"
}

Galaxy "NGC 5271:MCG 5-32-65:ZWG 161.120"
{
        Type  "SBa"
        RA           13.6950
        Dec          30.1253
        Distance   5.145e+08  # method: V
        Radius     6.735e+04
        AbsMag        -20.79
        Axis    [ -0.8349   0.5370  -0.1210]
        Angle     45.7521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5271"
}

Galaxy "NGC 5273:UGC 8675:MCG 6-30-72:ZWG 190.41"
{
        Type  "S0"
        RA           13.7022
        Dec          35.6539
        Distance   5.388e+07  # method: S
        Radius     2.194e+04
        AbsMag        -18.59
        Axis    [  0.5988  -0.7886  -0.1395]
        Angle    115.4285
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5273"
}

Galaxy "NGC 5274:MCG 5-32-66:ZWG 161.125"
{
        Type  "E0"
        RA           13.7064
        Dec          29.8478
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.3870  -0.8751  -0.2904]
        Angle    133.1815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5274"
}

Galaxy "NGC 5275:MCG 5-32-67:ZWG 161.124:VV 543"
{
        Type  "S0"
        RA           13.7064
        Dec          29.8253
        Distance    7.37e+07  # method: V
        Radius          7504
        AbsMag        -16.57
        Axis    [  0.4112  -0.8675  -0.2800]
        Angle    132.3343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5275"
}

Galaxy "NGC 5276:UGC 8680:MCG 6-30-74:ZWG 190.43"
{
        Type  "SBb"
        RA           13.7058
        Dec          35.6242
        Distance    2.54e+08  # method: V
        Radius     3.324e+04
        AbsMag        -19.76
        Axis    [ -0.8065   0.3916   0.4430]
        Angle     33.1199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5276"
}

Galaxy "NGC 5277:ZWG 161.129:KUG 1340+302"
{
        Type  "Sc"
        RA           13.7106
        Dec          29.9542
        Distance   5.476e+08  # method: V
        Radius     4.778e+04
        AbsMag        -20.72
        Axis    [ -0.9862   0.1407   0.0868]
        Angle     16.9454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5277"
}

Galaxy "NGC 5278:UGC 8677:MCG 9-22-101:MK 271"
{
        Type  "Sb"
        RA           13.6942
        Dec          55.6706
        Distance   3.476e+08  # method: V
        Radius     6.573e+04
        AbsMag        -21.44
        Axis    [  0.6519  -0.7263   0.2180]
        Angle     68.5544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5278"
}

Galaxy "NGC 5279:UGC 8678:MCG 9-22-102:MK 271A"
{
        Type  "SBa"
        RA           13.6953
        Dec          55.6733
        Distance   3.494e+08  # method: V
        Radius     3.557e+04
        AbsMag        -20.15
        Axis    [  0.7169  -0.6418   0.2724]
        Angle     99.5260
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5279"
}

Galaxy "NGC 5280:MCG 5-32-72:ZWG 161.131:NPM 1"
{
        Type  "E0"
        RA           13.7153
        Dec          29.8692
        Distance   5.051e+08  # method: V
        Radius     5.877e+04
        AbsMag        -21.05
        Axis    [  0.3861  -0.8756  -0.2903]
        Angle    133.2650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5280"
}

Galaxy "NGC 5282:UGC 8687:MCG 5-32-75:ZWG 161.133"
{
        Type  "E0"
        RA           13.7233
        Dec          30.0700
        Distance   5.537e+08  # method: V
        Radius     8.858e+04
        AbsMag        -21.35
        Axis    [  0.0776  -0.4832  -0.8721]
        Angle     60.5962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5282"
}

Galaxy "NGC 5283:UGC 8672:MCG 11-17-7:MK 270"
{
        Type  "S0"
        RA           13.6847
        Dec          67.6731
        Distance   1.258e+08  # method: V
        Radius     2.012e+04
        AbsMag        -18.43
        Axis    [  0.4633  -0.8742   0.1455]
        Angle    123.1038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5283"
}

Galaxy "NGC 5285:ZWG 17.65:NPM 1"
{
        Type  "E0"
        RA           13.7403
        Dec           2.1106
        Distance   3.802e+08  # distance uncertain!
        Radius     4.424e+04
        AbsMag        -20.13
        Axis    [  0.4578  -0.7521  -0.4741]
        Angle    145.2697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5285"
}

Galaxy "NGC 5287:MCG 5-32-79"
{
        Type  "S0"
        RA           13.7478
        Dec          29.7708
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [  0.5498  -0.6385   0.5386]
        Angle     29.9021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5287"
}

Galaxy "NGC 5289:UGC 8699:MCG 7-28-58:ZWG 218.42"
{
        Type  "SBb"
        RA           13.7522
        Dec          41.5036
        Distance    1.35e+08  # method: T-F
        Radius     3.732e+04
        AbsMag        -19.38
        Axis    [  0.4752  -0.3320   0.8148]
        Angle     43.2747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5289"
}

Galaxy "NGC 5290:UGC 8700:MCG 7-28-61:ZWG 218.43"
{
        Type  "Sc"
        RA           13.7553
        Dec          41.7131
        Distance   1.269e+08  # method: T-F
        Radius     6.828e+04
        AbsMag        -20.05
        Axis    [  0.5217  -0.3267   0.7881]
        Angle     49.2031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5290"
}

Galaxy "NGC 5291-1:ESO 445-30:MCG 5-33-6"
{
        Type  "E0"
        RA           13.7900
        Dec         -30.4053
        Distance   2.105e+08  # method: V
        Radius     3.674e+04
        AbsMag        -19.15
        Axis    [ -0.7140   0.1257  -0.6887]
        Angle    109.2954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5291-1"
}

Galaxy "NGC 5291-2:MCG 5-33-5:AM 1344-301"
{
        Type  "S0"
        RA           13.7897
        Dec         -30.4172
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.5097  -0.4600  -0.7270]
        Angle     76.0424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5291-2"
}

Galaxy "NGC 5292:ESO 445-31:MCG 5-33-8:IRAS 13447-3041"
{
        Type  "Sb"
        RA           13.7944
        Dec         -30.9394
        Distance   2.152e+08  # method: V
        Radius     5.633e+04
        AbsMag         -21.3
        Axis    [  0.3169  -0.4628  -0.8279]
        Angle    106.3412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5292"
}

Galaxy "NGC 5293:UGC 8710:MCG 3-35-24:ZWG 102.57"
{
        Type  "Sc"
        RA           13.7811
        Dec          16.2728
        Distance    2.74e+08  # method: V
        Radius     7.173e+04
        AbsMag        -20.82
        Axis    [ -0.3118  -0.4404  -0.8419]
        Angle     30.9850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5293"
}

Galaxy "NGC 5294:ZWG 271.61:ZWG 272.6"
{
        Type  "E0"
        RA           13.7550
        Dec          55.2903
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.2067  -0.0867  -0.9746]
        Angle     31.3991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5294"
}

Galaxy "NGC 5295:MCG 13-10-9:ZWG 353.23:NPM 1"
{
        Type  "S0"
        RA           13.6442
        Dec          79.4594
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.2093  -0.9697   0.1259]
        Angle    118.1960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5295"
}

Galaxy "NGC 5296:MCG 7-28-62:ZWG 218.44:NPM 1"
{
        Type  "Sa"
        RA           13.7717
        Dec          43.8517
        Distance   1.089e+08  # method: V
        Radius     1.426e+04
        AbsMag        -17.32
        Axis    [ -0.7190   0.6578   0.2241]
        Angle     53.6354
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5296"
}

Galaxy "NGC 5297:UGC 8709:MCG 7-28-63:ZWG 218.45"
{
        Type  "SBc"
        RA           13.7731
        Dec          43.8725
        Distance   1.173e+08  # method: V
        Radius     9.556e+04
        AbsMag        -20.38
        Axis    [ -0.4231   0.1886   0.8862]
        Angle     51.3850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5297"
}

Galaxy "NGC 5298:ESO 445-39:MCG 5-33-15"
{
        Type  "SBb"
        RA           13.8100
        Dec         -30.4292
        Distance    2.45e+08  # method: T-F
        Radius     4.988e+04
        AbsMag        -20.48
        Axis    [  0.4613  -0.5086  -0.7270]
        Angle     66.6691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5298"
}

Galaxy "NGC 5300:UGC 8727:MCG 1-35-38:ZWG 45.108"
{
        Type  "SBc"
        RA           13.8042
        Dec           3.9506
        Distance   8.376e+07  # method: T-F
        Radius     4.629e+04
        AbsMag        -19.55
        Axis    [ -0.9413  -0.1623  -0.2959]
        Angle     40.9140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5300"
}

Galaxy "NGC 5301:UGC 8711:MCG 8-25-41:ZWG 246.23"
{
        Type  "SBc"
        RA           13.7733
        Dec          46.1075
        Distance   7.697e+07  # method: V
        Radius     4.478e+04
        AbsMag        -18.86
        Axis    [ -0.4221   0.2065   0.8827]
        Angle     57.4857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5301"
}

Galaxy "NGC 5302:ESO 445-43:MCG 5-33-18"
{
        Type  "SBa"
        RA           13.8136
        Dec         -30.5119
        Distance   1.726e+08  # method: V
        Radius     4.269e+04
        AbsMag        -20.52
        Axis    [ -0.7945  -0.3962  -0.4602]
        Angle     69.6375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5302"
}

Galaxy "NGC 5303:NGC 5303A:UGC 8725:MCG 7-28-67"
{
        Type  "Sc"
        RA           13.7958
        Dec          38.3044
        Distance   7.013e+07  # method: V
        Radius          9179
        AbsMag        -18.56
        Axis    [  0.6268  -0.5422   0.5596]
        Angle     40.2583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5303"
}

Galaxy "NGC 5303B:MCG 7-28-66:ZWG 218.46:KUG 1345+385"
{
        Type  "Sc"
        RA           13.7958
        Dec          38.2594
        Distance   7.375e+07  # method: V
        Radius          7509
        AbsMag        -16.37
        Axis    [  0.3448  -0.4061   0.8463]
        Angle     29.3959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5303B"
}

Galaxy "NGC 5304:ESO 445-52:MCG 5-33-22"
{
        Type  "S0"
        RA           13.8336
        Dec         -30.5786
        Distance   1.867e+08  # method: T-F
        Radius     4.073e+04
        AbsMag        -20.19
        Axis    [ -0.7229  -0.3804  -0.5768]
        Angle     70.0565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5304"
}

Galaxy "NGC 5305:UGC 8729:MCG 6-30-87:ZWG 190.57"
{
        Type  "SBb"
        RA           13.7986
        Dec          37.8261
        Distance   1.612e+08  # distance uncertain!
        Radius     3.517e+04
        AbsMag        -19.07
        Axis    [  0.6907  -0.7226  -0.0265]
        Angle     94.8822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5305"
}

Galaxy "NGC 5306:MCG 1-35-14:VV 135:HCG 67A"
{
        Type  "S0"
        RA           13.8197
        Dec          -7.2233
        Distance   3.416e+08  # method: V
        Radius     6.459e+04
        AbsMag         -21.9
        Axis    [  0.6428  -0.5589  -0.5238]
        Angle    102.9549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5306"
}

Galaxy "NGC 5308:UGC 8722:MCG 10-20-29:ZWG 295.12"
{
        Type  "S0"
        RA           13.7833
        Dec          60.9728
        Distance   9.726e+07  # method: V
        Radius     5.234e+04
        AbsMag        -19.97
        Axis    [  0.6710  -0.3165   0.6705]
        Angle     91.7725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5308"
}

Galaxy "NGC 5311:UGC 8735:MCG 7-28-72:ZWG 218.52"
{
        Type  "Sa"
        RA           13.8153
        Dec          39.9864
        Distance    1.31e+08  # method: V
        Radius     4.953e+04
        AbsMag        -19.62
        Axis    [  0.3130  -0.7272  -0.6110]
        Angle     19.7550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5311"
}

Galaxy "NGC 5312:MCG 6-30-92:ZWG 190.61:NPM 1"
{
        Type  "Sa"
        RA           13.8306
        Dec          33.6222
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.7935  -0.6027   0.0842]
        Angle     89.1946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5312"
}

Galaxy "NGC 5313:UGC 8744:MCG 7-28-74:ZWG 218.54"
{
        Type  "Sb"
        RA           13.8289
        Dec          39.9853
        Distance   1.238e+08  # method: V
        Radius      3.06e+04
        AbsMag           -20
        Axis    [  0.7441  -0.6570   0.1210]
        Angle     83.0542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5313"
}

Galaxy "NGC 5314:MCG 12-13-9:ZWG 336.17"
{
        Type  "S0"
        RA           13.7697
        Dec          70.3397
        Distance   4.368e+08  # method: V
        Radius     6.354e+04
        AbsMag        -20.93
        Axis    [  0.5293  -0.2575   0.8084]
        Angle     61.1451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5314"
}

Galaxy "NGC 5318:UGC 8751:MCG 6-30-96:ZWG 190.63"
{
        Type  "S0"
        RA           13.8431
        Dec          33.7053
        Distance   2.004e+08  # method: V
        Radius     4.371e+04
        AbsMag        -20.54
        Axis    [ -0.8571   0.4312   0.2817]
        Angle     42.4948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5318"
}

Galaxy "NGC 5319:KUG 1348+340"
{
        Type  "S0"
        RA           13.8444
        Dec          33.7617
        Distance   3.868e+08  # distance uncertain!
        Radius     3.375e+04
        AbsMag        -19.07
        Axis    [  0.8033  -0.5210   0.2886]
        Angle     72.6715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5319"
}

Galaxy "NGC 5320:UGC 8749:MCG 7-28-76:ZWG 218.56"
{
        Type  "SBc"
        RA           13.8389
        Dec          41.3661
        Distance   1.186e+08  # method: T-F
        Radius      6.21e+04
        AbsMag         -19.9
        Axis    [  0.7944  -0.5928   0.1324]
        Angle    108.8338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5320"
}

Galaxy "NGC 5321:MCG 6-30-101:ZWG 190.65:NPM 1"
{
        Type  "SBa"
        RA           13.8453
        Dec          33.6331
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4510  -0.7965  -0.4027]
        Angle     43.3965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5321"
}

Galaxy "NGC 5322:UGC 8745:MCG 10-20-35:ZWG 295.17"
{
        Type  "E2"
        RA           13.8206
        Dec          60.1903
        Distance   1.017e+08  # method: S
        Radius     8.877e+04
        AbsMag        -21.37
        Axis    [  0.3515  -0.8116  -0.4666]
        Angle     48.0614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5322"
}

Galaxy "NGC 5323:UGC 8719:MCG 13-10-12:ZWG 353.25"
{
        Type  "Sb"
        RA           13.7600
        Dec          76.8283
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [ -0.2690   0.5664   0.7790]
        Angle     75.2693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5323"
}

Galaxy "NGC 5324:MCG 1-35-16:IRAS 13494-0548"
{
        Type  "Sc"
        RA           13.8681
        Dec          -6.0581
        Distance   1.507e+08  # method: V
        Radius      5.04e+04
        AbsMag        -20.82
        Axis    [  0.6431  -0.6087  -0.4646]
        Angle    136.1997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5324"
}

Galaxy "NGC 5325:NGC 5325A:MCG 7-28-80:ZWG 218.62"
{
        Type  "Sc"
        RA           13.8483
        Dec          38.2747
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [  0.4530  -0.8045  -0.3841]
        Angle     37.6931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5325"
}

Galaxy "NGC 5325B:MCG 7-28-81:MCG 6-30-103"
{
        Type  "S0"
        RA           13.8481
        Dec          38.2403
        Distance   5.098e+08  # distance uncertain!
        Radius     4.449e+04
        AbsMag        -19.07
        Axis    [  0.3742  -0.5074   0.7762]
        Angle     25.7921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5325B"
}

Galaxy "NGC 5326:UGC 8764:MCG 7-28-82:ZWG 218.61"
{
        Type  "Sb"
        RA           13.8472
        Dec          39.5753
        Distance    1.22e+08  # method: V
        Radius     3.905e+04
        AbsMag        -19.96
        Axis    [ -0.5221   0.1599   0.8377]
        Angle     22.6637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5326"
}

Galaxy "NGC 5327:UGC 8768:MCG 0-35-21:ZWG 17.78"
{
        Type  "SBb"
        RA           13.8678
        Dec          -2.2064
        Distance   2.109e+08  # method: V
        Radius     5.827e+04
        AbsMag        -20.25
        Axis    [  0.1250  -0.5963  -0.7929]
        Angle     60.7847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5327"
}

Galaxy "NGC 5328:ESO 445-67:MCG 5-33-28"
{
        Type  "E1"
        RA           13.8814
        Dec         -28.4892
        Distance   1.867e+08  # method: T-F
        Radius     4.887e+04
        AbsMag        -21.09
        Axis    [ -0.0980  -0.3573  -0.9289]
        Angle    117.2881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5328"
}

Galaxy "NGC 5329:UGC 8771:MCG 1-35-44:ZWG 45.121"
{
        Type  "E0"
        RA           13.8694
        Dec           2.3256
        Distance   3.346e+08  # method: V
        Radius     6.327e+04
        AbsMag        -21.66
        Axis    [  0.4437  -0.7590  -0.4765]
        Angle    146.1496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5329"
}

Galaxy "NGC 5330:ESO 445-68:MCG 5-33-28A"
{
        Type  "E0"
        RA           13.8831
        Dec         -28.4706
        Distance    2.33e+08  # method: V
        Radius     2.372e+04
        AbsMag        -19.47
        Axis    [  0.4604  -0.5816  -0.6707]
        Angle    157.2101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5330"
}

Galaxy "NGC 5331-1:UGC 8774:MCG 0-35-22:ZWG 17.82"
{
        Type  "Sc"
        RA           13.8711
        Dec           2.1083
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.6200  -0.6356  -0.4600]
        Angle     74.2155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5331-1"
}

Galaxy "NGC 5331-2:UGC 8774:MCG 0-35-22:ZWG 17.82"
{
        Type  "Sb"
        RA           13.8711
        Dec           2.1011
        Distance   4.613e+08  # method: V
        Radius      7.38e+04
        AbsMag        -21.15
        Axis    [  0.7100  -0.5994  -0.3697]
        Angle    129.5732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5331-2"
}

Galaxy "NGC 5332:UGC 8773:MCG 3-35-30:ZWG 102.70"
{
        Type  "S0"
        RA           13.8686
        Dec          16.9697
        Distance   3.161e+08  # method: V
        Radius     4.137e+04
        AbsMag        -20.93
        Axis    [  0.4319  -0.8205  -0.3744]
        Angle    138.7555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5332"
}

Galaxy "NGC 5333:ESO 221-17"
{
        Type  "S0"
        RA           13.9067
        Dec         -48.5128
        Distance   1.341e+08  # method: V
        Radius     3.707e+04
        AbsMag        -21.17
        Axis    [  0.4346  -0.3495  -0.8300]
        Angle     92.5571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5333"
}

Galaxy "NGC 5334:IC 4338:UGC 8790:MCG 0-35-24"
{
        Type  "SBc"
        RA           13.8817
        Dec          -1.1136
        Distance   7.524e+07  # method: V
        Radius     4.596e+04
        AbsMag        -19.51
        Axis    [  0.7142  -0.5635  -0.4151]
        Angle    107.2909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5334"
}

Galaxy "NGC 5335:UGC 8791:MCG 1-35-46:ZWG 45.129"
{
        Type  "SBb"
        RA           13.8822
        Dec           2.8147
        Distance    2.25e+08  # method: V
        Radius     6.873e+04
        AbsMag        -20.09
        Axis    [  0.3006  -0.7369  -0.6055]
        Angle     45.7837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5335"
}

Galaxy "NGC 5336:UGC 8785:MCG 7-29-3:ZWG 219.11"
{
        Type  "Sc"
        RA           13.8692
        Dec          43.2431
        Distance   1.133e+08  # method: V
        Radius     2.308e+04
        AbsMag         -19.2
        Axis    [  0.5347  -0.7274   0.4302]
        Angle     18.8668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5336"
}

Galaxy "NGC 5337:UGC 8789:MCG 7-29-4:ZWG 219.12"
{
        Type  "S0"
        RA           13.8731
        Dec          39.6881
        Distance   1.097e+08  # method: V
        Radius     2.712e+04
        AbsMag        -19.23
        Axis    [  0.7967  -0.5923   0.1201]
        Angle    106.7810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5337"
}

Galaxy "NGC 5338:UGC 8800:MCG 1-35-48:ZWG 45.132"
{
        Type  "S0"
        RA           13.8906
        Dec           5.2078
        Distance   4.183e+07  # method: S
        Radius     1.217e+04
        AbsMag        -16.74
        Axis    [  0.3776  -0.8894  -0.2576]
        Angle     32.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5338"
}

Galaxy "NGC 5339:MCG 1-35-18:MK 1363:IRAS 13513-0741"
{
        Type  "SBa"
        RA           13.9000
        Dec          -7.9306
        Distance     1.3e+08  # method: V
        Radius     3.215e+04
        AbsMag           -18
        Axis    [  0.3672  -0.6002  -0.7106]
        Angle     88.3375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5339"
}

Galaxy "NGC 5340:MCG 12-13-13:ZWG 336.22:NPM 1"
{
        Type  "S0"
        RA           13.8164
        Dec          72.6544
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.5757  -0.3777   0.7252]
        Angle     59.3924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5340"
}

Galaxy "NGC 5341:UGC 8792:MCG 6-31-2:ZWG 190.69"
{
        Type  "SBc"
        RA           13.8756
        Dec          37.8169
        Distance   1.742e+08  # method: V
        Radius     3.294e+04
        AbsMag        -19.44
        Axis    [ -0.7330   0.3121   0.6045]
        Angle     49.2001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5341"
}

Galaxy "NGC 5342:UGC 8776:MCG 10-20-41:ZWG 295.20"
{
        Type  "S0"
        RA           13.8569
        Dec          59.8639
        Distance   1.051e+08  # method: V
        Radius     1.681e+04
        AbsMag        -18.04
        Axis    [ -0.3091   0.4314   0.8476]
        Angle     53.8521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5342"
}

Galaxy "NGC 5343:MCG 1-35-19"
{
        Type  "S0"
        RA           13.9031
        Dec          -7.5883
        Distance   1.281e+08  # distance uncertain!
        Radius     2.794e+04
        AbsMag        -19.07
        Axis    [  0.5031  -0.5987  -0.6233]
        Angle     88.8130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5343"
}

Galaxy "NGC 5344:ZWG 336.26:NPM 1"
{
        Type  "S0"
        RA           13.8367
        Dec          73.9533
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.5819  -0.4111   0.7017]
        Angle     58.8617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5344"
}

Galaxy "NGC 5345:UGC 8820:MCG 0-35-26:ZWG 17.94"
{
        Type  "Sa"
        RA           13.9039
        Dec          -1.4358
        Distance   1.017e+08  # distance uncertain!
        Radius     2.367e+04
        AbsMag        -19.07
        Axis    [ -0.8422   0.2468  -0.4794]
        Angle     74.0157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5345"
}

Galaxy "NGC 5346:UGC 8804:MCG 7-29-7:ZWG 219.14"
{
        Type  "Sc"
        RA           13.8839
        Dec          39.5808
        Distance    1.55e+08  # method: T-F
        Radius     4.509e+04
        AbsMag        -18.78
        Axis    [ -0.6741   0.3050   0.6727]
        Angle     44.4109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5346"
}

Galaxy "NGC 5347:UGC 8805:MCG 6-31-7:ZWG 191.7"
{
        Type  "SBb"
        RA           13.8883
        Dec          33.4908
        Distance   1.176e+08  # method: V
        Radius     2.736e+04
        AbsMag        -19.38
        Axis    [ -0.7411  -0.1861  -0.6451]
        Angle     12.4267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5347"
}

Galaxy "NGC 5348:UGC 8821:MCG 1-35-51:ZWG 45.137"
{
        Type  "SBc"
        RA           13.9031
        Dec           5.2272
        Distance   6.179e+07  # method: T-F
        Radius     3.145e+04
        AbsMag        -17.19
        Axis    [ -0.8944  -0.1863   0.4067]
        Angle     68.0287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5348"
}

Galaxy "NGC 5349:UGC 8803:MCG 6-31-5:ZWG 190.72"
{
        Type  "SBb"
        RA           13.8869
        Dec          37.8831
        Distance   2.689e+08  # method: V
        Radius     6.648e+04
        AbsMag        -19.68
        Axis    [  0.7073  -0.4740   0.5244]
        Angle     59.4765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5349"
}

Galaxy "NGC 5350:UGC 8810:MCG 7-29-9:MK 1485"
{
        Type  "SBc"
        RA           13.8892
        Dec          40.3639
        Distance   1.129e+08  # method: V
        Radius     5.254e+04
        AbsMag         -20.3
        Axis    [  0.6812  -0.7319   0.0185]
        Angle     85.9561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5350"
}

Galaxy "NGC 5351:UGC 8809:MCG 6-31-8:ZWG 191.8"
{
        Type  "SBb"
        RA           13.8911
        Dec          37.9150
        Distance   2.244e+08  # method: T-F
        Radius     9.464e+04
        AbsMag        -21.19
        Axis    [  0.5601  -0.6558   0.5062]
        Angle     30.6561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5351"
}

Galaxy "NGC 5352:UGC 8812:MCG 6-31-11:ZWG 191.9"
{
        Type  "S0"
        RA           13.8939
        Dec          36.1342
        Distance   3.706e+08  # method: V
        Radius     6.468e+04
        AbsMag        -21.28
        Axis    [  0.5862  -0.7933  -0.1645]
        Angle     68.8737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5352"
}

Galaxy "NGC 5353:UGC 8813:MCG 7-29-10:ZWG 219.18"
{
        Type  "S0"
        RA           13.8906
        Dec          40.2831
        Distance    1.04e+08  # method: V
        Radius     3.328e+04
        AbsMag        -20.42
        Axis    [ -0.5910   0.2586   0.7641]
        Angle     30.4851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5353"
}

Galaxy "NGC 5354:UGC 8814:MCG 7-29-11:ZWG 219.19"
{
        Type  "S0"
        RA           13.8906
        Dec          40.3031
        Distance   1.199e+08  # method: V
        Radius     2.442e+04
        AbsMag        -20.33
        Axis    [  0.4688  -0.8267  -0.3112]
        Angle     57.1300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5354"
}

Galaxy "NGC 5355:UGC 8819:MCG 7-29-12:ZWG 219.20"
{
        Type  "S0"
        RA           13.8958
        Dec          40.3389
        Distance   1.179e+08  # method: V
        Radius     2.057e+04
        AbsMag        -18.79
        Axis    [  0.7446  -0.6591   0.1051]
        Angle     91.6421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5355"
}

Galaxy "NGC 5356:UGC 8831:MCG 1-35-52:ZWG 46.1"
{
        Type  "SBc"
        RA           13.9161
        Dec           5.3333
        Distance   7.457e+07  # method: V
        Radius     3.145e+04
        AbsMag        -17.99
        Axis    [  0.9162  -0.3749  -0.1417]
        Angle    103.8184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5356"
}

Galaxy "NGC 5357:ESO 445-78:MCG 5-33-32"
{
        Type  "E0"
        RA           13.9331
        Dec         -30.3417
        Distance   1.867e+08  # method: T-F
        Radius     4.344e+04
        AbsMag        -20.79
        Axis    [  0.3573  -0.5487  -0.7558]
        Angle    148.8457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5357"
}

Galaxy "NGC 5358:UGC 8826:MCG 7-29-13:ZWG 219.22"
{
        Type  "Sa"
        RA           13.9000
        Dec          40.2778
        Distance   1.187e+08  # method: V
        Radius     1.899e+04
        AbsMag         -18.2
        Axis    [ -0.3056   0.0412   0.9513]
        Angle     42.1835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5358"
}

Galaxy "NGC 5360:IC 958:UGC 8838:MCG 1-36-1"
{
        Type  "SBa"
        RA           13.9272
        Dec           4.9842
        Distance   6.541e+07  # method: V
        Radius     1.522e+04
        AbsMag        -16.91
        Axis    [  0.6964  -0.6764  -0.2398]
        Angle     54.4113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5360"
}

Galaxy "NGC 5361:MCG 7-29-15:ZWG 219.25:KUG 1352+386"
{
        Type  "S0"
        RA           13.9097
        Dec          38.4494
        Distance   2.647e+08  # method: V
        Radius      3.08e+04
        AbsMag        -19.75
        Axis    [  0.7043  -0.6992   0.1229]
        Angle     63.6774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5361"
}

Galaxy "NGC 5362:UGC 8835:MCG 7-29-16:ZWG 219.26"
{
        Type  "Sb"
        RA           13.9147
        Dec          41.3136
        Distance   1.094e+08  # method: V
        Radius     3.502e+04
        AbsMag        -19.43
        Axis    [  0.6381  -0.5508   0.5380]
        Angle     45.9464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5362"
}

Galaxy "NGC 5363:UGC 8847:MCG 1-36-2:ZWG 46.7"
{
        Type  "Sa"
        RA           13.9353
        Dec           5.2539
        Distance   6.383e+07  # method: V
        Radius     3.806e+04
        AbsMag        -20.06
        Axis    [ -0.7880  -0.4474  -0.4230]
        Angle     31.8762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5363"
}

Galaxy "NGC 5364:NGC 5317:UGC 8853:MCG 1-36-3"
{
        Type  "Sc"
        RA           13.9364
        Dec           5.0156
        Distance    6.85e+07  # method: V
        Radius     6.774e+04
        AbsMag        -20.41
        Axis    [  0.7291  -0.5910  -0.3450]
        Angle     96.1825
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5364"
}

Galaxy "NGC 5365:ESO 271-8:MCG 7-29-2"
{
        Type  "S0"
        RA           13.9639
        Dec         -43.9319
        Distance   1.212e+08  # method: V
        Radius     6.697e+04
        AbsMag        -20.45
        Axis    [  0.7266  -0.2156  -0.6524]
        Angle    121.6968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5365"
}

Galaxy "NGC 5365A:ESO 271-6:MCG 7-29-1:PGC 49593"
{
        Type  "SBb"
        RA           13.9442
        Dec         -44.0094
        Distance   1.343e+08  # method: V
        Radius     5.078e+04
        AbsMag        -19.47
        Axis    [  0.1696  -0.7028  -0.6909]
        Angle     51.8997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5365A"
}

Galaxy "NGC 5365B:ESO 271-9:MCG 7-29-3:IRAS 13555-4343"
{
        Type  "Sb"
        RA           13.9775
        Dec         -43.9642
        Distance   1.404e+08  # distance uncertain!
        Radius     3.268e+04
        AbsMag        -19.07
        Axis    [  0.6151  -0.3388  -0.7120]
        Angle     74.6091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5365B"
}

Galaxy "NGC 5366:MCG 0-36-2:ZWG 18.7:KCPG 403A"
{
        Type  "Sa"
        RA           13.9400
        Dec          -0.2475
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [  0.4332  -0.6503  -0.6240]
        Angle     83.6679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5366"
}

Galaxy "NGC 5368:UGC 8834:MCG 9-23-14:ZWG 272.12"
{
        Type  "SBb"
        RA           13.9081
        Dec          54.3308
        Distance   2.146e+08  # method: V
        Radius     2.809e+04
        AbsMag        -20.19
        Axis    [  0.5306  -0.8470   0.0335]
        Angle    116.2189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5368"
}

Galaxy "NGC 5369"
{
        Type  "E0"
        RA           13.9436
        Dec          -5.4697
        Distance   2.631e+08  # distance uncertain!
        Radius     3.443e+04
        AbsMag        -20.13
        Axis    [ -0.2726  -0.2382  -0.9322]
        Angle     87.0409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5369"
}

Galaxy "NGC 5370:UGC 8832:MCG 10-20-44:ZWG 295.22"
{
        Type  "S0"
        RA           13.9025
        Dec          60.6786
        Distance   1.432e+08  # method: V
        Radius     2.291e+04
        AbsMag        -19.11
        Axis    [  0.2807  -0.9591  -0.0361]
        Angle    125.3813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5370"
}

Galaxy "NGC 5371:NGC 5390:UGC 8846:MCG 7-29-20"
{
        Type  "SBc"
        RA           13.9278
        Dec          40.4622
        Distance   1.241e+08  # method: V
        Radius     7.582e+04
        AbsMag         -21.6
        Axis    [  0.6353  -0.7706  -0.0507]
        Angle    118.4774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5371"
}

Galaxy "NGC 5372:UGC 8843:MCG 10-20-46:ZWG 295.24"
{
        Type  "S0"
        RA           13.9125
        Dec          58.6669
        Distance   8.381e+07  # method: V
        Radius          7314
        AbsMag        -18.15
        Axis    [ -0.1460   0.5191   0.8422]
        Angle     28.8194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5372"
}

Galaxy "NGC 5373:ZWG 46.14:NPM 1"
{
        Type  "E0"
        RA           13.9519
        Dec           5.2525
        Distance   3.468e+08  # distance uncertain!
        Radius     2.522e+04
        AbsMag        -20.13
        Axis    [ -0.6393   0.3934  -0.6607]
        Angle     81.6371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5373"
}

Galaxy "NGC 5374:UGC 8874:MCG 1-36-4:ZWG 46.16"
{
        Type  "SBc"
        RA           13.9581
        Dec           6.0969
        Distance   2.068e+08  # method: V
        Radius     4.811e+04
        AbsMag        -20.51
        Axis    [  0.3841  -0.6865  -0.6174]
        Angle     89.5336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5374"
}

Galaxy "NGC 5376:UGC 8852:MCG 10-20-47:ZWG 295.25"
{
        Type  "SBb"
        RA           13.9208
        Dec          59.5069
        Distance   9.944e+07  # method: V
        Radius     3.037e+04
        AbsMag        -19.42
        Axis    [  0.6531  -0.5917   0.4726]
        Angle     64.6351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5376"
}

Galaxy "NGC 5377:UGC 8863:MCG 8-25-52:ZWG 246.27"
{
        Type  "SBa"
        RA           13.9378
        Dec          47.2356
        Distance   8.847e+07  # method: V
        Radius     6.048e+04
        AbsMag        -19.97
        Axis    [  0.7548  -0.6303   0.1815]
        Angle    106.1772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5377"
}

Galaxy "NGC 5378:UGC 8869:MCG 6-31-27:ZWG 191.20"
{
        Type  "SBa"
        RA           13.9472
        Dec          37.7972
        Distance   1.455e+08  # method: V
        Radius     5.714e+04
        AbsMag        -19.85
        Axis    [  0.5227  -0.8345  -0.1740]
        Angle     37.3821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5378"
}

Galaxy "NGC 5379:UGC 8860:MCG 10-20-49:ZWG 295.26"
{
        Type  "SBa"
        RA           13.9261
        Dec          59.7433
        Distance    8.44e+07  # method: V
        Radius       2.7e+04
        AbsMag        -18.16
        Axis    [  0.6839  -0.4325   0.5876]
        Angle     84.8514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5379"
}

Galaxy "NGC 5380:UGC 8870:MCG 6-31-28:ZWG 191.21"
{
        Type  "S0"
        RA           13.9489
        Dec          37.6103
        Distance   1.528e+08  # method: V
        Radius     3.779e+04
        AbsMag        -20.15
        Axis    [  0.3636  -0.9041  -0.2243]
        Angle    132.2761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5380"
}

Galaxy "NGC 5382:UGC 8885:MCG 1-36-7:ZWG 46.22"
{
        Type  "S0"
        RA           13.9706
        Dec           6.2581
        Distance   2.074e+08  # method: V
        Radius     2.715e+04
        AbsMag        -20.52
        Axis    [  0.7292  -0.5977  -0.3332]
        Angle    101.4728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5382"
}

Galaxy "NGC 5383:UGC 8875:MCG 7-29-23:MK 281"
{
        Type  "SBb"
        RA           13.9511
        Dec          41.8461
        Distance     1.1e+08  # method: V
        Radius     5.119e+04
        AbsMag        -20.34
        Axis    [  0.5435  -0.8286  -0.1342]
        Angle     42.2049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5383"
}

Galaxy "NGC 5384:UGC 8886:MCG 1-36-8:ZWG 46.23"
{
        Type  "S0"
        RA           13.9700
        Dec           6.5181
        Distance   2.433e+08  # method: V
        Radius     5.307e+04
        AbsMag        -20.26
        Axis    [  0.7084  -0.6409  -0.2956]
        Angle     69.1649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5384"
}

Galaxy "NGC 5386:UGC 8890:MCG 1-36-10:ZWG 46.24"
{
        Type  "Sa"
        RA           13.9728
        Dec           6.3386
        Distance   2.068e+08  # method: V
        Radius     3.007e+04
        AbsMag        -20.11
        Axis    [  0.7977  -0.5742  -0.1842]
        Angle     71.5461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5386"
}

Galaxy "NGC 5387:UGC 8891:MCG 1-36-11:ZWG 46.26"
{
        Type  "Sc"
        RA           13.9733
        Dec           6.0706
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [  0.9375  -0.3418  -0.0660]
        Angle     96.7310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5387"
}

Galaxy "NGC 5389:UGC 8866:MCG 10-20-51:ZWG 295.27"
{
        Type  "SBa"
        RA           13.9350
        Dec          59.7417
        Distance   8.829e+07  # method: V
        Radius     5.265e+04
        AbsMag        -19.26
        Axis    [  0.7949  -0.5307   0.2940]
        Angle    133.4788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5389"
}

Galaxy "NGC 5392:MCG 0-36-5:ZWG 18.13"
{
        Type  "Sa"
        RA           13.9900
        Dec          -3.2089
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.7165  -0.4444  -0.5377]
        Angle     41.0233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5392"
}

Galaxy "NGC 5393:ESO 445-87:MCG 5-33-35:IRAS 13576-2838"
{
        Type  "Sa"
        RA           14.0089
        Dec         -28.8750
        Distance   2.825e+08  # method: V
        Radius     3.698e+04
        AbsMag        -20.69
        Axis    [ -0.7837  -0.2722  -0.5583]
        Angle     76.4943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5393"
}

Galaxy "NGC 5394:UGC 8898:MCG 6-31-33:ZWG 191.24"
{
        Type  "SBb"
        RA           13.9758
        Dec          37.4536
        Distance   1.641e+08  # method: V
        Radius     4.534e+04
        AbsMag        -19.81
        Axis    [  0.7172  -0.6963  -0.0281]
        Angle    126.3659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5394"
}

Galaxy "NGC 5395:UGC 8900:MCG 6-31-34:ZWG 191.26"
{
        Type  "Sb"
        RA           13.9769
        Dec          37.4253
        Distance   1.668e+08  # method: V
        Radius      6.55e+04
        AbsMag        -21.04
        Axis    [  0.8025  -0.5950   0.0436]
        Angle    124.5100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5395"
}

Galaxy "NGC 5396:NGC 5375:UGC 8865:MCG 5-33-27"
{
        Type  "SBb"
        RA           13.9486
        Dec          29.1642
        Distance   1.181e+08  # method: V
        Radius     5.671e+04
        AbsMag        -19.99
        Axis    [  0.6392  -0.7511  -0.1653]
        Angle    127.5644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5396"
}

Galaxy "NGC 5397:ESO 384-31:MCG 6-31-13:IRAS 13582-3342"
{
        Type  "S0"
        RA           14.0194
        Dec         -33.9456
        Distance   1.986e+08  # method: V
        Radius     4.045e+04
        AbsMag        -20.02
        Axis    [  0.3384  -0.4768  -0.8113]
        Angle     91.3206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5397"
}

Galaxy "NGC 5398:ESO 384-32:MCG 5-33-37:UGCA 379"
{
        Type  "Irr"
        RA           14.0225
        Dec         -33.0631
        Distance   2.831e+07  # method: T-F
        Radius     1.153e+04
        AbsMag        -16.49
        Axis    [ -0.9066  -0.3156  -0.2802]
        Angle     83.0523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5398"
}

Galaxy "NGC 5399:UGC 8912:MCG 6-31-39:ZWG 191.27"
{
        Type  "Sc"
        RA           13.9919
        Dec          34.7733
        Distance   1.749e+08  # method: V
        Radius     3.053e+04
        AbsMag        -18.85
        Axis    [  0.6098  -0.4588   0.6462]
        Angle     52.2032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5399"
}

Galaxy "NGC 5400:MCG 0-36-8:ZWG 18.20"
{
        Type  "S0"
        RA           14.0103
        Dec          -2.8575
        Distance   3.493e+08  # method: V
        Radius      7.62e+04
        AbsMag        -21.05
        Axis    [  0.4159  -0.7206  -0.5547]
        Angle     53.8325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5400"
}

Galaxy "NGC 5401:UGC 8916:MCG 6-31-40:ZWG 191.28"
{
        Type  "Sa"
        RA           13.9953
        Dec          36.2381
        Distance   1.768e+08  # distance uncertain!
        Radius     3.857e+04
        AbsMag        -19.07
        Axis    [  0.6520  -0.4021   0.6429]
        Angle     61.5454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5401"
}

Galaxy "NGC 5402:UGC 8903:MCG 10-20-54:ZWG 295.29"
{
        Type  "S0"
        RA           13.9711
        Dec          59.8144
        Distance   1.417e+08  # method: V
        Radius     2.678e+04
        AbsMag        -18.49
        Axis    [ -0.4489   0.4157   0.7910]
        Angle     69.6742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5402"
}

Galaxy "NGC 5403:UGC 8919:MCG 6-31-41:ZWG 191.29"
{
        Type  "SBb"
        RA           13.9972
        Dec          38.1819
        Distance   1.328e+08  # method: V
        Radius     5.989e+04
        AbsMag        -18.55
        Axis    [ -0.4062   0.0369   0.9130]
        Angle     48.4116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5403"
}

Galaxy "NGC 5405:UGC 8928:MCG 1-36-14:ZWG 46.36"
{
        Type  "Sc"
        RA           14.0192
        Dec           7.7019
        Distance   3.255e+08  # method: V
        Radius     3.787e+04
        AbsMag         -20.5
        Axis    [  0.4383  -0.7837  -0.4400]
        Angle    143.6933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5405"
}

Galaxy "NGC 5406:UGC 8925:MCG 7-29-31:ZWG 219.38"
{
        Type  "SBc"
        RA           14.0056
        Dec          38.9153
        Distance   2.442e+08  # method: V
        Radius     6.748e+04
        AbsMag        -21.27
        Axis    [  0.0511  -0.9312   0.3608]
        Angle     10.0210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5406"
}

Galaxy "NGC 5407:UGC 8930:MCG 7-29-33:ZWG 219.40"
{
        Type  "E0"
        RA           14.0139
        Dec          39.1567
        Distance   2.545e+08  # method: V
        Radius     4.072e+04
        AbsMag        -20.36
        Axis    [  0.0831  -0.5453  -0.8341]
        Angle     51.5257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5407"
}

Galaxy "NGC 5408:MCG 7-29-6:ESO 325-47:TOL 116"
{
        Type  "Irr"
        RA           14.0558
        Dec         -41.3786
        Distance   3.334e+07  # method: V
        Radius          9214
        AbsMag        -17.85
        Axis    [  0.3681  -0.4522  -0.8124]
        Angle     83.0101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5408"
}

Galaxy "NGC 5409:UGC 8938:MCG 2-36-9:ZWG 74.44"
{
        Type  "SBb"
        RA           14.0294
        Dec           9.4906
        Distance   2.717e+08  # method: T-F
        Radius     6.718e+04
        AbsMag         -20.4
        Axis    [  0.6635  -0.6692  -0.3345]
        Angle     77.4754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5409"
}

Galaxy "NGC 5410:UGC 8931:MCG 7-29-34:ZWG 219.41"
{
        Type  "SBa"
        RA           14.0150
        Dec          40.9881
        Distance   1.775e+08  # method: V
        Radius     3.872e+04
        AbsMag        -19.68
        Axis    [  0.6886  -0.6494   0.3226]
        Angle     55.6472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5410"
}

Galaxy "NGC 5411:UGC 8940:MCG 2-36-11:ZWG 74.47"
{
        Type  "S0"
        RA           14.0331
        Dec           8.9378
        Distance   2.768e+08  # method: V
        Radius     5.637e+04
        AbsMag        -20.24
        Axis    [ -0.9029  -0.4088  -0.1327]
        Angle     30.4397
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5411"
}

Galaxy "NGC 5412:UGC 8905:ZWG 336.33:NPM 1"
{
        Type  "S0"
        RA           13.9536
        Dec          73.6172
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.5077  -0.8187   0.2682]
        Angle    109.4187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5412"
}

Galaxy "NGC 5413:UGC 8901:MCG 11-17-12:ZWG 317.12"
{
        Type  "E0"
        RA           13.9647
        Dec          64.9114
        Distance   4.402e+08  # method: V
        Radius     7.043e+04
        AbsMag        -20.85
        Axis    [  0.2845  -0.9486  -0.1384]
        Angle     81.9512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5413"
}

Galaxy "NGC 5414:UGC 8942:MCG 2-36-13:MK 800"
{
        Type  "Irr"
        RA           14.0342
        Dec           9.9294
        Distance   2.055e+08  # method: V
        Radius     2.989e+04
        AbsMag         -20.2
        Axis    [ -0.9435   0.2183  -0.2492]
        Angle     56.6622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5414"
}

Galaxy "NGC 5415:ZWG 336.32:NPM 1"
{
        Type  "S0"
        RA           13.9489
        Dec          70.7550
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.2325   0.2177   0.9479]
        Angle     42.4290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5415"
}

Galaxy "NGC 5416:UGC 8944:MCG 2-36-14:ZWG 74.52"
{
        Type  "Sc"
        RA           14.0364
        Dec           9.4400
        Distance   2.738e+08  # method: T-F
        Radius     5.575e+04
        AbsMag        -20.62
        Axis    [ -0.0294  -0.9333  -0.3578]
        Angle     27.3020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5416"
}

Galaxy "NGC 5417:UGC 8943:MCG 1-36-15:ZWG 46.39"
{
        Type  "Sa"
        RA           14.0369
        Dec           8.0367
        Distance   2.301e+08  # method: V
        Radius      5.02e+04
        AbsMag        -20.44
        Axis    [ -0.3228  -0.9367   0.1356]
        Angle     24.1945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5417"
}

Galaxy "NGC 5418:UGC 8946:MCG 1-36-16:ZWG 46.40"
{
        Type  "SBc"
        RA           14.0381
        Dec           7.6839
        Distance   2.177e+08  # method: V
        Radius     3.483e+04
        AbsMag        -19.72
        Axis    [  0.7858  -0.5813  -0.2110]
        Angle     79.3985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5418"
}

Galaxy "NGC 5419:ESO 384-39:MCG 6-31-19"
{
        Type  "E0"
        RA           14.0606
        Dec         -33.9783
        Distance   1.654e+08  # method: T-F
        Radius     9.864e+04
        AbsMag        -21.62
        Axis    [ -0.0517  -0.3919  -0.9186]
        Angle    125.9457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5419"
}

Galaxy "NGC 5420:MCG 2-36-6:IRAS 14012-1422"
{
        Type  "Sb"
        RA           14.0664
        Dec         -14.6172
        Distance   2.334e+08  # method: V
        Radius     5.772e+04
        AbsMag        -20.37
        Axis    [ -0.7289  -0.6383  -0.2474]
        Angle     45.1164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5420"
}

Galaxy "NGC 5421A:UGC 8941:MCG 6-31-45:MK 665"
{
        Type  "SBa"
        RA           14.0281
        Dec          33.8267
        Distance   3.666e+08  # method: V
        Radius     7.465e+04
        AbsMag        -21.05
        Axis    [ -0.8702   0.4754   0.1298]
        Angle     38.6825
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5421A"
}

Galaxy "NGC 5421B:UGC 8941:MCG 6-31-45:MK 665"
{
        Type  "E0"
        RA           14.0283
        Dec          33.8219
        Distance   3.666e+08  # method: V
        Radius     4.266e+04
        AbsMag        -21.05
        Axis    [  0.3441  -0.9009  -0.2646]
        Angle    135.1315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5421B"
}

Galaxy "NGC 5422:UGC 8935:MCG 9-23-24:ZWG 272.16"
{
        Type  "Sa"
        RA           14.0114
        Dec          55.1647
        Distance   8.634e+07  # method: V
        Radius     4.898e+04
        AbsMag        -19.21
        Axis    [ -0.3182   0.2522   0.9139]
        Angle     64.0983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5422"
}

Galaxy "NGC 5423:UGC 8952:MCG 2-36-17:ZWG 74.59"
{
        Type  "S0"
        RA           14.0467
        Dec           9.3419
        Distance   2.728e+08  # method: V
        Radius     5.951e+04
        AbsMag        -20.61
        Axis    [  0.5578  -0.7544  -0.3460]
        Angle     53.7093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5423"
}

Galaxy "NGC 5424:UGC 8956:MCG 2-36-19:ZWG 74.63"
{
        Type  "S0"
        RA           14.0486
        Dec           9.4211
        Distance   3.067e+08  # method: T-F
        Radius     7.138e+04
        AbsMag        -20.87
        Axis    [ -0.1374  -0.6427  -0.7537]
        Angle     39.4606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5424"
}

Galaxy "NGC 5425:UGC 8933:MCG 8-26-1:ZWG 247.2"
{
        Type  "Sc"
        RA           14.0131
        Dec          48.4431
        Distance   1.003e+08  # method: V
        Radius     2.772e+04
        AbsMag        -18.24
        Axis    [  0.0044  -0.0148   0.9999]
        Angle     47.9640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5425"
}

Galaxy "NGC 5426:MCG 1-36-4:UGCA 380:VV 21"
{
        Type  "Sc"
        RA           14.0567
        Dec          -6.0689
        Distance   1.307e+08  # method: V
        Radius     5.703e+04
        AbsMag        -20.21
        Axis    [ -0.9880  -0.1346  -0.0752]
        Angle     63.3238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5426"
}

Galaxy "NGC 5427:MCG 1-36-3:UGCA 381:VV 21"
{
        Type  "SBc"
        RA           14.0572
        Dec          -6.0308
        Distance   1.321e+08  # method: V
        Radius     5.572e+04
        AbsMag        -20.94
        Axis    [  0.4040  -0.6464  -0.6473]
        Angle     74.0382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5427"
}

Galaxy "NGC 5430:UGC 8937:MCG 10-20-62:MK 799"
{
        Type  "SBb"
        RA           14.0125
        Dec          59.3289
        Distance    1.42e+08  # method: V
        Radius     4.749e+04
        AbsMag        -20.39
        Axis    [  0.6921  -0.6955   0.1930]
        Angle    131.4221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5430"
}

Galaxy "NGC 5431:MCG 2-36-20:ZWG 74.65"
{
        Type  "S0"
        RA           14.0519
        Dec           9.3631
        Distance   2.719e+08  # method: V
        Radius     3.164e+04
        AbsMag         -19.4
        Axis    [  0.5830  -0.6972  -0.4172]
        Angle     79.9967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5431"
}

Galaxy "NGC 5433:UGC 8954:MCG 6-31-50:ZWG 191.38"
{
        Type  "Irr"
        RA           14.0433
        Dec          32.5103
        Distance   2.064e+08  # method: V
        Radius     4.804e+04
        AbsMag        -19.91
        Axis    [  0.8886  -0.4514   0.0817]
        Angle    123.7173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5433"
}

Galaxy "NGC 5434:NGC 5434A:UGC 8965:MCG 2-36-22"
{
        Type  "Sc"
        RA           14.0564
        Dec           9.4478
        Distance   2.217e+08  # method: V
        Radius     4.838e+04
        AbsMag        -20.26
        Axis    [  0.4848  -0.7250  -0.4893]
        Angle    105.5741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5434"
}

Galaxy "NGC 5434B:UGC 8967:MCG 2-36-24:ZWG 74.70"
{
        Type  "Sc"
        RA           14.0575
        Dec           9.4672
        Distance   2.529e+08  # method: T-F
        Radius     5.885e+04
        AbsMag        -19.75
        Axis    [  0.7930  -0.5745   0.2025]
        Angle     54.0620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5434B"
}

Galaxy "NGC 5436:UGC 8971:MCG 2-36-25:ZWG 74.71"
{
        Type  "Sa"
        RA           14.0614
        Dec           9.5739
        Distance   3.113e+08  # method: V
        Radius      4.98e+04
        AbsMag           -20
        Axis    [ -0.4853  -0.8069   0.3367]
        Angle     25.5334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5436"
}

Galaxy "NGC 5437:IC 4365:MCG 2-36-28:ZWG 74.74"
{
        Type  "Sb"
        RA           14.0631
        Dec           9.5236
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.8618  -0.4685  -0.1944]
        Angle    121.8768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5437"
}

Galaxy "NGC 5439:UGC 8947:MCG 8-26-2:ZWG 247.3"
{
        Type  "Sc"
        RA           14.0325
        Dec          46.3114
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.8081  -0.5622   0.1760]
        Angle    121.8328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5439"
}

Galaxy "NGC 5440:UGC 8963:MCG 6-31-52:ZWG 191.40"
{
        Type  "Sa"
        RA           14.0500
        Dec          34.7567
        Distance   1.762e+08  # method: V
        Radius     5.639e+04
        AbsMag        -20.46
        Axis    [  0.7694  -0.6167   0.1662]
        Angle     78.4665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5440"
}

Galaxy "NGC 5441:MCG 6-31-53:KUG 1401+349"
{
        Type  "Sc"
        RA           14.0531
        Dec          34.6844
        Distance   3.868e+08  # distance uncertain!
        Radius     3.375e+04
        AbsMag        -19.07
        Axis    [  0.3636  -0.8979  -0.2481]
        Angle    134.3457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5441"
}

Galaxy "NGC 5442:MCG 1-36-6:VV 691:IRAS 14020-0928"
{
        Type  "Sb"
        RA           14.0786
        Dec          -9.7128
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.8325  -0.5411  -0.1190]
        Angle     45.4500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5442"
}

Galaxy "NGC 5443:UGC 8958:MCG 9-23-26:ZWG 272.20"
{
        Type  "SBb"
        RA           14.0364
        Dec          55.8144
        Distance    9.25e+07  # method: V
        Radius     3.633e+04
        AbsMag        -19.16
        Axis    [  0.7484  -0.5531   0.3659]
        Angle    103.1571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5443"
}

Galaxy "NGC 5444:UGC 8974:MCG 6-31-54:ZWG 191.41"
{
        Type  "E0"
        RA           14.0567
        Dec          35.1325
        Distance   1.885e+08  # method: T-F
        Radius     6.855e+04
        AbsMag        -21.11
        Axis    [  0.1064  -0.6353  -0.7649]
        Angle     60.7738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5444"
}

Galaxy "NGC 5445:UGC 8976:MCG 6-31-55:ZWG 191.42"
{
        Type  "S0"
        RA           14.0586
        Dec          35.0247
        Distance   1.857e+08  # method: V
        Radius     4.051e+04
        AbsMag        -19.78
        Axis    [  0.7922  -0.6046   0.0826]
        Angle    100.4638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5445"
}

Galaxy "NGC 5446:NGC 5438:MCG 2-36-29:ZWG 74.75"
{
        Type  "S0"
        RA           14.0631
        Dec           9.6111
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.4296  -0.7948  -0.4285]
        Angle    143.3077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5446"
}

Galaxy "NGC 5448:UGC 8969:MCG 8-26-3:ZWG 247.4"
{
        Type  "SBa"
        RA           14.0472
        Dec          49.1725
        Distance   9.808e+07  # method: V
        Radius     5.421e+04
        AbsMag        -20.29
        Axis    [  0.3035  -0.2795   0.9109]
        Angle     31.6662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5448"
}

Galaxy "NGC 5452:UGC 8867:MCG 13-10-14:ZWG 353.28"
{
        Type  "SBc"
        RA           13.9067
        Dec          78.2206
        Distance   9.454e+07  # method: V
        Radius      2.75e+04
        AbsMag        -18.41
        Axis    [  0.4291   0.1594   0.8891]
        Angle     39.0516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5452"
}

Galaxy "NGC 5454:UGC 8997:MCG 3-36-42:ZWG 103.64"
{
        Type  "S0"
        RA           14.0792
        Dec          14.3819
        Distance   3.592e+08  # method: V
        Radius     7.837e+04
        AbsMag        -21.11
        Axis    [  0.0154  -0.9590  -0.2831]
        Angle     25.6002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5454"
}

Galaxy "NGC 5456:UGC 9004:MCG 2-36-36:ZWG 74.89"
{
        Type  "S0"
        RA           14.0828
        Dec          11.8717
        Distance   3.352e+08  # method: V
        Radius     5.851e+04
        AbsMag        -21.06
        Axis    [ -0.9243   0.2843  -0.2546]
        Angle     58.4841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5456"
}

Galaxy "M 101:NGC 5457:UGC 8981:MCG 9-23-28"
{
        Type  "Sc"
        RA           14.0533
        Dec          54.3494
        Distance   1.663e+07  # method: V
        Radius     6.964e+04
        AbsMag        -20.33
        Axis    [  0.4753  -0.8797  -0.0156]
        Angle    101.9063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 101"
}

Galaxy "NGC 5459:UGC 9005:MCG 2-36-37:ZWG 74.90"
{
        Type  "S0"
        RA           14.0833
        Dec          13.1325
        Distance   2.497e+08  # method: V
        Radius     3.994e+04
        AbsMag        -19.82
        Axis    [  0.5818  -0.7291  -0.3604]
        Angle    123.6159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5459"
}

Galaxy "NGC 5463:NGC 5463A:UGC 9017:MCG 2-36-40"
{
        Type  "S0"
        RA           14.1028
        Dec           9.3531
        Distance   3.393e+08  # method: V
        Radius     5.923e+04
        AbsMag        -21.29
        Axis    [  0.7859  -0.5980  -0.1575]
        Angle     74.7414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5463"
}

Galaxy "NGC 5463B"
{
        Type  "E3"
        RA           14.1033
        Dec           9.3617
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [ -0.4590   0.0355  -0.8877]
        Angle     69.2805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5463B"
}

Galaxy "NGC 5464:ESO 446-11:MCG 5-33-45:TOL 43"
{
        Type  "Irr"
        RA           14.1178
        Dec         -30.0172
        Distance   1.265e+08  # method: T-F
        Radius     2.391e+04
        AbsMag        -19.64
        Axis    [  0.1158  -0.5844  -0.8031]
        Angle     69.7103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5464"
}

Galaxy "NGC 5468:MCG 1-36-7:UGCA 384:IRAS 14039-0512"
{
        Type  "SBc"
        RA           14.1097
        Dec          -5.4531
        Distance   1.408e+08  # method: V
        Radius     4.916e+04
        AbsMag        -19.98
        Axis    [ -0.1868  -0.4391  -0.8788]
        Angle     71.3604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5468"
}

Galaxy "NGC 5469:ZWG 74.136"
{
        Type  "S0"
        RA           14.2081
        Dec           8.6492
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [ -0.7878  -0.2603  -0.5582]
        Angle     38.1527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5469"
}

Galaxy "NGC 5470:UGC 9020:MCG 1-36-19:ZWG 46.50"
{
        Type  "Sb"
        RA           14.1086
        Dec           6.0292
        Distance   5.826e+07  # method: V
        Radius     2.118e+04
        AbsMag        -16.86
        Axis    [  0.8364  -0.5418   0.0834]
        Angle     60.6611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5470"
}

Galaxy "NGC 5471:MCG 9-23-30:VV 394"
{
        Type  "Irr"
        RA           14.0744
        Dec          54.3975
        Distance   4.366e+08  # distance uncertain!
        Radius      3.81e+04
        AbsMag        -20.13
        Axis    [  0.5787  -0.8069   0.1183]
        Angle     68.7292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5471"
}

Galaxy "NGC 5472:MCG 1-36-8:IRAS 14042-0513"
{
        Type  "Sb"
        RA           14.1150
        Dec          -5.4600
        Distance   1.439e+08  # method: V
        Radius     2.512e+04
        AbsMag        -18.12
        Axis    [  0.8699  -0.4353  -0.2321]
        Angle     80.8336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5472"
}

Galaxy "NGC 5473:UGC 9011:MCG 9-23-31:ZWG 272.22"
{
        Type  "S0"
        RA           14.0786
        Dec          54.8933
        Distance   9.799e+07  # method: V
        Radius     3.135e+04
        AbsMag        -19.99
        Axis    [ -0.4818   0.7953   0.3680]
        Angle     34.4241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5473"
}

Galaxy "NGC 5474:UGC 9013:MCG 9-23-32:ZWG 272.23"
{
        Type  "Sc"
        RA           14.0836
        Dec          53.6628
        Distance   1.835e+07  # method: V
        Radius     1.254e+04
        AbsMag        -17.45
        Axis    [  0.2954  -0.9506  -0.0959]
        Angle    129.3601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5474"
}

Galaxy "NGC 5475:UGC 9016:MCG 9-23-33:ZWG 272.24"
{
        Type  "Sa"
        RA           14.0867
        Dec          55.7422
        Distance   8.335e+07  # method: V
        Radius     2.303e+04
        AbsMag        -18.54
        Axis    [ -0.4729   0.3854   0.7924]
        Angle     64.3077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5475"
}

Galaxy "NGC 5476:MCG 1-36-9:IRAS 14055-0551"
{
        Type  "Irr"
        RA           14.1356
        Dec          -6.0922
        Distance    1.66e+08  # distance uncertain!
        Radius     3.621e+04
        AbsMag        -20.13
        Axis    [ -0.6548  -0.3525  -0.6686]
        Angle     51.2529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5476"
}

Galaxy "NGC 5477:UGC 9018:MCG 9-23-34:DDO 186"
{
        Type  "Irr"
        RA           14.0925
        Dec          54.4608
        Distance   1.943e+07  # method: V
        Radius          4523
        AbsMag        -14.58
        Axis    [  0.6024  -0.7430   0.2917]
        Angle     35.0277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5477"
}

Galaxy "NGC 5478:UGC 9034:MCG 0-36-19:ZWG 18.55"
{
        Type  "SBc"
        RA           14.1356
        Dec          -1.7022
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.6180  -0.6234  -0.4790]
        Angle     95.0179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5478"
}

Galaxy "NGC 5479:MCG 11-17-19:ZWG 317.16:NPM 1"
{
        Type  "S0"
        RA           14.0992
        Dec          65.6911
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.5972  -0.7672   0.2339]
        Angle    117.2068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5479"
}

Galaxy "NGC 5480:UGC 9026:MCG 9-23-35:ZWG 272.27"
{
        Type  "Sc"
        RA           14.1058
        Dec          50.7250
        Distance   8.607e+07  # method: T-F
        Radius     2.003e+04
        AbsMag        -19.11
        Axis    [  0.6948  -0.7125   0.0981]
        Angle    129.7618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5480"
}

Galaxy "NGC 5481:UGC 9029:MCG 9-23-36:ZWG 272.28"
{
        Type  "E0"
        RA           14.1114
        Dec          50.7236
        Distance    9.98e+07  # method: V
        Radius     2.613e+04
        AbsMag        -18.93
        Axis    [  0.1149  -0.3756  -0.9196]
        Angle     35.2577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5481"
}

Galaxy "NGC 5482:UGC 9038:MCG 2-36-43:ZWG 74.115"
{
        Type  "S0"
        RA           14.1417
        Dec           8.9314
        Distance   3.331e+08  # method: V
        Radius     5.814e+04
        AbsMag        -20.95
        Axis    [  0.4819  -0.8479  -0.2209]
        Angle     41.5939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5482"
}

Galaxy "NGC 5483:ESO 271-19:MCG 7-29-8:IRAS 14072-4305"
{
        Type  "SBc"
        RA           14.1736
        Dec         -43.3250
        Distance    9.01e+07  # method: V
        Radius     5.111e+04
        AbsMag        -20.31
        Axis    [  0.4349  -0.4217  -0.7956]
        Angle    135.3865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5483"
}

Galaxy "NGC 5484:ZWG 272.29:NPM 1"
{
        Type  "E2"
        RA           14.1133
        Dec          55.0303
        Distance   4.787e+08  # distance uncertain!
        Radius      5.57e+04
        AbsMag        -20.13
        Axis    [  0.2626  -0.9600  -0.0969]
        Angle    129.6759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5484"
}

Galaxy "NGC 5485:UGC 9033:MCG 9-23-37:ZWG 272.30"
{
        Type  "S0"
        RA           14.1197
        Dec          55.0014
        Distance   8.461e+07  # method: S
        Radius     2.831e+04
        AbsMag        -19.77
        Axis    [ -0.4916   0.8524   0.1782]
        Angle     42.1083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5485"
}

Galaxy "NGC 5486:UGC 9036:MCG 9-23-38:ZWG 272.31"
{
        Type  "Irr"
        RA           14.1233
        Dec          55.1031
        Distance   1.435e+08  # method: T-F
        Radius     3.131e+04
        AbsMag        -19.32
        Axis    [  0.6309  -0.5978   0.4946]
        Angle     56.7278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5486"
}

Galaxy "NGC 5487:MCG 1-36-21:ZWG 46.61:IRAS 14072+0818"
{
        Type  "SBc"
        RA           14.1619
        Dec           8.0694
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.6987  -0.6907  -0.1864]
        Angle     60.7610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5487"
}

Galaxy "NGC 5488:IC 4375:ESO 384-58:MCG 5-33-48"
{
        Type  "SBc"
        RA           14.1339
        Dec         -33.3147
        Distance   2.084e+08  # method: V
        Radius      1.03e+05
        AbsMag        -21.33
        Axis    [  0.7920  -0.2558  -0.5544]
        Angle     96.3363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5488"
}

Galaxy "NGC 5489:ESO 271-21"
{
        Type  "Sa"
        RA           14.2000
        Dec         -46.0889
        Distance   1.439e+08  # method: V
        Radius     3.139e+04
        AbsMag        -20.12
        Axis    [ -0.5354  -0.4904  -0.6876]
        Angle     82.1201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5489"
}

Galaxy "NGC 5490:NGC 5490A:UGC 9058:MCG 3-36-65"
{
        Type  "E0"
        RA           14.1658
        Dec          17.5456
        Distance   2.757e+08  # method: T-F
        Radius     9.624e+04
        AbsMag        -21.63
        Axis    [  0.3650  -0.8380  -0.4056]
        Angle    138.2012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5490"
}

Galaxy "NGC 5490B:MCG 3-36-67:ZWG 103.97:KUG 1407+177"
{
        Type  "Sc"
        RA           14.1675
        Dec          17.5517
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.5974  -0.7589  -0.2593]
        Angle     63.8683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5490B"
}

Galaxy "NGC 5490C:MCG 3-36-69:ZWG 103.100:ARP 79"
{
        Type  "Sc"
        RA           14.1683
        Dec          17.6156
        Distance   2.589e+08  # method: V
        Radius     4.143e+04
        AbsMag         -19.5
        Axis    [  0.3574  -0.8435  -0.4009]
        Angle     43.0951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5490C"
}

Galaxy "NGC 5491A:UGC 9072:MCG 1-36-22:ZWG 46.63"
{
        Type  "Sb"
        RA           14.1825
        Dec           6.3650
        Distance   2.784e+08  # method: V
        Radius     5.668e+04
        AbsMag        -20.76
        Axis    [  0.5097  -0.7826  -0.3576]
        Angle     52.2950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5491A"
}

Galaxy "NGC 5491B:NPM 1"
{
        Type  "E0"
        RA           14.1825
        Dec           6.3722
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [ -0.4816   0.0135  -0.8763]
        Angle     71.6096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5491B"
}

Galaxy "NGC 5492:UGC 9065:MCG 3-36-74:ZWG 103.106"
{
        Type  "Sb"
        RA           14.1764
        Dec          19.6119
        Distance   1.134e+08  # method: V
        Radius      2.64e+04
        AbsMag        -19.01
        Axis    [ -0.6834  -0.2273   0.6937]
        Angle     43.9637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5492"
}

Galaxy "NGC 5493:MCG 1-36-13:UGCA 386"
{
        Type  "S0"
        RA           14.1914
        Dec          -5.0439
        Distance   1.309e+08  # method: V
        Radius     3.236e+04
        AbsMag        -20.62
        Axis    [ -0.3996  -0.4275  -0.8109]
        Angle     57.0963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5493"
}

Galaxy "NGC 5494:ESO 446-25:MCG 5-34-1:IRAS 14094-3024"
{
        Type  "Sc"
        RA           14.2064
        Dec         -30.6447
        Distance   1.329e+08  # method: V
        Radius     4.445e+04
        AbsMag        -20.35
        Axis    [  0.4204  -0.5029  -0.7552]
        Angle    123.4404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5494"
}

Galaxy "NGC 5495:ESO 511-10:MCG 4-34-1:AM 1409-265"
{
        Type  "SBc"
        RA           14.2064
        Dec         -27.1078
        Distance   1.065e+08  # distance uncertain!
        Radius     2.324e+04
        AbsMag        -19.07
        Axis    [  0.4718  -0.5058  -0.7222]
        Angle    107.9551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5495"
}

Galaxy "NGC 5496:UGC 9079:MCG 0-36-26:ZWG 18.74"
{
        Type  "SBc"
        RA           14.1936
        Dec          -1.1583
        Distance   8.272e+07  # method: T-F
        Radius     5.655e+04
        AbsMag        -19.12
        Axis    [ -0.8571  -0.3258   0.3989]
        Angle     66.7512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5496"
}

Galaxy "NGC 5497:UGC 9069:MCG 7-29-48:ZWG 219.54"
{
        Type  "SBb"
        RA           14.1753
        Dec          38.8939
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [  0.6590  -0.7174   0.2262]
        Angle     55.7018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5497"
}

Galaxy "NGC 5498:UGC 9075:MCG 4-33-43:ZWG 132.80"
{
        Type  "S0"
        RA           14.1844
        Dec          25.6978
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.2956  -0.7644  -0.5730]
        Angle     21.0902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5498"
}

Galaxy "NGC 5499:UGC 9074:MCG 6-31-76:ZWG 191.60"
{
        Type  "Sa"
        RA           14.1797
        Dec          35.9136
        Distance   3.902e+08  # method: V
        Radius     5.107e+04
        AbsMag        -20.89
        Axis    [ -0.8695   0.2808   0.4064]
        Angle     25.7954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5499"
}

Galaxy "NGC 5500:UGC 9070:MCG 8-26-8:MK 806"
{
        Type  "E0"
        RA           14.1708
        Dec          48.5467
        Distance   9.223e+07  # method: V
        Radius     1.341e+04
        AbsMag        -17.96
        Axis    [ -0.0443  -0.0236  -0.9987]
        Angle     33.9748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5500"
}

Galaxy "NGC 5501:MCG 0-36-27:ZWG 18.78"
{
        Type  "Sa"
        RA           14.2056
        Dec           1.2728
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.4257  -0.7097  -0.5614]
        Angle     70.1306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5501"
}

Galaxy "NGC 5502:NGC 5503:MCG 10-20-77:NPM 1"
{
        Type  "S0"
        RA           14.1592
        Dec          60.4100
        Distance   3.527e+08  # distance uncertain!
        Radius     1.539e+04
        AbsMag        -19.07
        Axis    [  0.5495  -0.3340   0.7659]
        Angle     68.0550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5502"
}

Galaxy "NGC 5504:NGC 5504A:UGC 9085:MCG 3-36-81"
{
        Type  "SBc"
        RA           14.2042
        Dec          15.8414
        Distance   2.486e+08  # method: V
        Radius       4.7e+04
        AbsMag        -20.61
        Axis    [ -0.5911  -0.3849  -0.7088]
        Angle     32.3394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5504"
}

Galaxy "NGC 5504C:UGC 9086:MCG 3-36-82:ZWG 103.115"
{
        Type  "Irr"
        RA           14.2042
        Dec          15.8797
        Distance   2.484e+08  # method: V
        Radius     3.613e+04
        AbsMag        -19.11
        Axis    [  0.6518  -0.7561   0.0595]
        Angle     48.2536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5504C"
}

Galaxy "NGC 5505:UGC 9092:MCG 2-36-48:ZWG 74.138"
{
        Type  "SBa"
        RA           14.2086
        Dec          13.3047
        Distance   2.045e+08  # method: V
        Radius     2.975e+04
        AbsMag        -20.09
        Axis    [ -0.6944  -0.5851  -0.4188]
        Angle     26.7759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5505"
}

Galaxy "NGC 5506:MCG 0-36-28:UGCA 387:MK 1376"
{
        Type  "Sa"
        RA           14.2206
        Dec          -3.2069
        Distance   9.418e+07  # method: V
        Radius     3.698e+04
        AbsMag         -19.5
        Axis    [  0.3746  -0.9198  -0.1163]
        Angle     37.5137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5506"
}

Galaxy "NGC 5507:MCG 0-36-29:UGCA 388:ZWG 18.82"
{
        Type  "S0"
        RA           14.2219
        Dec          -3.1483
        Distance   9.563e+07  # method: V
        Radius     2.225e+04
        AbsMag        -18.84
        Axis    [  0.6201  -0.6478  -0.4425]
        Angle     74.1103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5507"
}

Galaxy "NGC 5508:UGC 9094:MCG 4-34-2:ZWG 133.9"
{
        Type  "S0"
        RA           14.2081
        Dec          24.6356
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.9767  -0.1653  -0.1370]
        Angle     22.2448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5508"
}

Galaxy "NGC 5509:MCG 4-34-3:ZWG 133.10"
{
        Type  "S0"
        RA           14.2108
        Dec          20.3883
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.2370  -0.8953  -0.3771]
        Angle     34.2220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5509"
}

Galaxy "NGC 5510:ESO 579-3:MCG 3-36-10:NPM 1"
{
        Type  "Irr"
        RA           14.2269
        Dec         -17.9842
        Distance    7.81e+07  # method: V
        Radius      1.59e+04
        AbsMag         -18.3
        Axis    [  0.4452  -0.5738  -0.6874]
        Angle    106.5885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5510"
}

Galaxy "NGC 5511:NGC 5511B:MCG 2-36-50:ZWG 74.141"
{
        Type  "S0"
        RA           14.2181
        Dec           8.6322
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [ -0.9810  -0.1025   0.1646]
        Angle     50.0837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5511"
}

Galaxy "NGC 5511A:MCG 2-36-51:ZWG 74.142:VV 299"
{
        Type  "E0"
        RA           14.2189
        Dec           8.6189
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.3932  -0.8044  -0.4453]
        Angle    146.3149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5511A"
}

Galaxy "NGC 5512:ZWG 163.6:NPM 1"
{
        Type  "E0"
        RA           14.2114
        Dec          30.8556
        Distance    2.06e+08  # method: V
        Radius     1.498e+04
        AbsMag         -18.6
        Axis    [  0.1252  -0.7169  -0.6858]
        Angle     72.8360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5512"
}

Galaxy "NGC 5513:UGC 9099:MCG 4-34-5:ZWG 133.11"
{
        Type  "S0"
        RA           14.2189
        Dec          20.4156
        Distance   2.366e+08  # method: V
        Radius     6.537e+04
        AbsMag         -20.4
        Axis    [ -0.0679  -0.9960   0.0588]
        Angle     22.0823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5513"
}

Galaxy "NGC 5514:UGC 9102:MCG 1-36-23:ZWG 46.66"
{
        Type  "Sb"
        RA           14.2272
        Dec           7.6600
        Distance   3.426e+08  # method: V
        Radius     6.976e+04
        AbsMag        -21.01
        Axis    [  0.0761  -0.9353  -0.3457]
        Angle     32.8443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5514"
}

Galaxy "NGC 5514A:UGC 9102:MCG 1-36-23:ZWG 46.66"
{
        Type  "E0"
        RA           14.2275
        Dec           7.6578
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.3945  -0.8002  -0.4518]
        Angle    146.7655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5514A"
}

Galaxy "NGC 5515:UGC 9096:MCG 7-29-52:ZWG 219.57"
{
        Type  "Sb"
        RA           14.2106
        Dec          39.3100
        Distance   3.524e+08  # method: V
        Radius     6.664e+04
        AbsMag        -21.37
        Axis    [  0.3929  -0.6424   0.6579]
        Angle     30.0377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5515"
}

Galaxy "NGC 5516:ESO 221-34:AM 1412-475"
{
        Type  "S0"
        RA           14.2650
        Dec         -48.1147
        Distance    2.11e+08  # method: V
        Radius     5.524e+04
        AbsMag        -21.05
        Axis    [ -0.8549  -0.3780  -0.3554]
        Angle     96.2517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5516"
}

Galaxy "NGC 5517:UGC 9100:MCG 6-31-79:ZWG 191.63"
{
        Type  "Sa"
        RA           14.2142
        Dec          35.7111
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.4423  -0.8507  -0.2841]
        Angle     11.2638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5517"
}

Galaxy "NGC 5518:MCG 4-34-6:ZWG 133.13:NPM 1"
{
        Type  "S0"
        RA           14.2297
        Dec          20.8489
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.3861  -0.8519  -0.3540]
        Angle    140.7130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5518"
}

Galaxy "NGC 5520:UGC 9097:MCG 8-26-13:ZWG 272.43"
{
        Type  "Sb"
        RA           14.2061
        Dec          50.3486
        Distance   1.444e+08  # method: T-F
        Radius     4.201e+04
        AbsMag        -20.03
        Axis    [  0.6715  -0.6421   0.3699]
        Angle     69.2882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5520"
}

Galaxy "NGC 5521:UGC 9122:MCG 1-36-30:ZWG 46.77"
{
        Type  "S0"
        RA           14.2564
        Dec           4.4086
        Distance   5.686e+08  # method: V
        Radius     4.962e+04
        AbsMag        -21.71
        Axis    [  0.0428  -0.6983  -0.7145]
        Angle     53.2486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5521"
}

Galaxy "NGC 5522:UGC 9116:MCG 3-36-89:ZWG 103.125"
{
        Type  "Sb"
        RA           14.2472
        Dec          15.1467
        Distance   2.179e+08  # method: V
        Radius     5.706e+04
        AbsMag        -19.92
        Axis    [  0.8524  -0.5121   0.1058]
        Angle     75.8841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5522"
}

Galaxy "NGC 5523:UGC 9119:MCG 4-34-8:ZWG 133.18"
{
        Type  "Sc"
        RA           14.2475
        Dec          25.3183
        Distance   7.076e+07  # method: T-F
        Radius     4.837e+04
        AbsMag        -18.78
        Axis    [  0.5505  -0.5897   0.5909]
        Angle     47.0822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5523"
}

Galaxy "NGC 5525:UGC 9124:MCG 3-36-96:ZWG 103.132"
{
        Type  "S0"
        RA           14.2608
        Dec          14.2822
        Distance   2.623e+08  # method: V
        Radius     5.723e+04
        AbsMag        -20.73
        Axis    [  0.7441  -0.6296  -0.2235]
        Angle    103.6095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5525"
}

Galaxy "NGC 5526-1:UGC 9115:MCG 10-20-85:ZWG 295.40"
{
        Type  "Sc"
        RA           14.2314
        Dec          57.7722
        Distance   9.409e+07  # method: V
        Radius     3.148e+04
        AbsMag           -18
        Axis    [ -0.0523   0.1066   0.9929]
        Angle     63.6837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5526-1"
}

Galaxy "NGC 5526-2:UGC 9115:MCG 10-20-84:KCPG 421A"
{
        Type  "Sc"
        RA           14.2303
        Dec          57.7697
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.5819  -0.7813   0.2257]
        Angle     30.9366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5526-2"
}

Galaxy "NGC 5527:MCG 6-31-81:ZWG 191.67:KUG 1412+366"
{
        Type  "Sc"
        RA           14.2408
        Dec          36.4044
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.8012   0.5561  -0.2210]
        Angle     33.1245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5527"
}

Galaxy "NGC 5528:MCG 2-36-60:ZWG 74.153"
{
        Type  "Sb"
        RA           14.2719
        Dec           8.2931
        Distance    2.03e+08  # distance uncertain!
        Radius     4.133e+04
        AbsMag        -19.07
        Axis    [  0.7928  -0.5611  -0.2382]
        Angle    103.5565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5528"
}

Galaxy "NGC 5529:UGC 9127:MCG 6-31-85:ZWG 191.69"
{
        Type  "Sc"
        RA           14.2594
        Dec          36.2269
        Distance   1.981e+08  # method: T-F
        Radius     1.729e+05
        AbsMag        -21.12
        Axis    [  0.1890  -0.3156   0.9299]
        Angle     48.8994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5529"
}

Galaxy "NGC 5530:ESO 272-3:MCG 7-29-13:IRAS 14152-4309"
{
        Type  "SBc"
        RA           14.3075
        Dec         -43.3869
        Distance    6.36e+07  # method: V
        Radius     3.885e+04
        AbsMag        -19.65
        Axis    [ -0.5015  -0.6638  -0.5549]
        Angle     68.4980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5530"
}

Galaxy "NGC 5531:MCG 2-36-61:ZWG 74.155"
{
        Type  "S0"
        RA           14.2786
        Dec          10.8856
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.4046  -0.8098  -0.4249]
        Angle    144.6618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5531"
}

Galaxy "NGC 5532:NGC 5532A:UGC 9137:MCG 2-36-62"
{
        Type  "S0"
        RA           14.2811
        Dec          10.8075
        Distance   3.333e+08  # method: V
        Radius     7.757e+04
        AbsMag        -22.15
        Axis    [  0.4045  -0.8095  -0.4255]
        Angle    144.7116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5532"
}

Galaxy "NGC 5532B"
{
        Type  "S0"
        RA           14.2814
        Dec          10.7986
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.6877  -0.6604  -0.3015]
        Angle     98.4570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5532B"
}

Galaxy "NGC 5533:UGC 9133:MCG 6-31-89:ZWG 191.72"
{
        Type  "Sb"
        RA           14.2686
        Dec          35.3439
        Distance   1.715e+08  # method: T-F
        Radius     7.731e+04
        AbsMag         -20.9
        Axis    [  0.7132  -0.7009   0.0035]
        Angle     99.0936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5533"
}

Galaxy "NGC 5534:MCG 1-36-14:MK 1379:VV 615"
{
        Type  "SBb"
        RA           14.2944
        Dec          -7.4169
        Distance   1.306e+08  # method: V
        Radius      3.23e+04
        AbsMag        -19.91
        Axis    [ -0.7332  -0.3765  -0.5663]
        Angle     51.4811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5534"
}

Galaxy "NGC 5535"
{
        Type  "E0"
        RA           14.2919
        Dec           8.2075
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.3865  -0.8053  -0.4496]
        Angle    147.0894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5535"
}

Galaxy "NGC 5536:UGC 9136:MCG 7-29-57:ZWG 219.64"
{
        Type  "SBa"
        RA           14.2731
        Dec          39.5022
        Distance   2.728e+08  # method: V
        Radius     4.761e+04
        AbsMag        -20.11
        Axis    [ -0.9277   0.3562  -0.1113]
        Angle     16.4511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5536"
}

Galaxy "NGC 5537:MCG 1-36-32:ZWG 46.82:IRAS 14151+0717"
{
        Type  "S0"
        RA           14.2936
        Dec           7.0547
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7583  -0.6005  -0.2536]
        Angle     90.3449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5537"
}

Galaxy "NGC 5538:ZWG 46.83:PGC 91351:FGC 1739"
{
        Type  "Sc"
        RA           14.2950
        Dec           7.4761
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.7884  -0.6148   0.0188]
        Angle     62.3264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5538"
}

Galaxy "NGC 5539:MCG 1-36-33:ZWG 46.84"
{
        Type  "S0"
        RA           14.2936
        Dec           8.1786
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.7083  -0.6296  -0.3192]
        Angle    129.3469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5539"
}

Galaxy "NGC 5540:MCG 10-20-90:ZWG 295.41"
{
        Type  "S0"
        RA           14.2483
        Dec          60.0108
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.5951  -0.7763   0.2078]
        Angle     96.7478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5540"
}

Galaxy "NGC 5541-1:UGC 9139:MCG 7-29-59:ZWG 219.65"
{
        Type  "S0"
        RA           14.2753
        Dec          39.5883
        Distance   3.566e+08  # method: V
        Radius     4.149e+04
        AbsMag        -21.59
        Axis    [  0.6464  -0.7618  -0.0438]
        Angle    117.7511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5541-1"
}

Galaxy "NGC 5541-2:UGC 9139:MCG 7-29-59:ZWG 219.65"
{
        Type  "S0"
        RA           14.2756
        Dec          39.5919
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.3366  -0.1278   0.9329]
        Angle     27.1130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5541-2"
}

Galaxy "NGC 5542:MCG 1-36-34:ZWG 46.85:ARAK 445"
{
        Type  "S0"
        RA           14.2981
        Dec           7.5586
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [ -0.9974   0.0198   0.0693]
        Angle     57.5247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5542"
}

Galaxy "NGC 5543:ZWG 46.88"
{
        Type  "S0"
        RA           14.3011
        Dec           7.6542
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.6331  -0.7319   0.2519]
        Angle     30.3175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5543"
}

Galaxy "NGC 5544:UGC 9142:MCG 6-31-90:ZWG 191.73"
{
        Type  "SBa"
        RA           14.2839
        Dec          36.5711
        Distance   1.478e+08  # method: V
        Radius     2.364e+04
        AbsMag        -19.08
        Axis    [  0.4480  -0.8547  -0.2623]
        Angle     70.7971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5544"
}

Galaxy "NGC 5545:UGC 9143:MCG 6-31-91:VV 210"
{
        Type  "Sc"
        RA           14.2844
        Dec          36.5747
        Distance   1.475e+08  # method: V
        Radius     2.146e+04
        AbsMag        -17.48
        Axis    [  0.7622  -0.5533   0.3361]
        Angle     77.1251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5545"
}

Galaxy "NGC 5546:UGC 9148:MCG 1-36-35:ZWG 46.89"
{
        Type  "E0"
        RA           14.3025
        Dec           7.5639
        Distance   3.429e+08  # method: V
        Radius     6.484e+04
        AbsMag        -21.71
        Axis    [  0.3772  -0.7998  -0.4670]
        Angle    145.0230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5546"
}

Galaxy "NGC 5547:UGC 9095:ZWG 353.31:NPM 1"
{
        Type  "S0"
        RA           14.1625
        Dec          78.6017
        Distance   1.938e+08  # distance uncertain!
        Radius     1.692e+04
        AbsMag        -19.07
        Axis    [  0.5757  -0.5592   0.5966]
        Angle     78.9619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5547"
}

Galaxy "NGC 5548:UGC 9149:MCG 4-34-13:ZWG 133.25"
{
        Type  "Sa"
        RA           14.2997
        Dec          25.1367
        Distance   2.425e+08  # method: V
        Radius     5.291e+04
        AbsMag        -21.16
        Axis    [  0.0169  -0.8808  -0.4733]
        Angle     27.9927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5548"
}

Galaxy "NGC 5549:UGC 9156:MCG 1-36-36:ZWG 47.1"
{
        Type  "S0"
        RA           14.3106
        Dec           7.3769
        Distance   3.602e+08  # method: V
        Radius     8.382e+04
        AbsMag        -21.21
        Axis    [ -0.3554  -0.9306  -0.0873]
        Angle     27.9419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5549"
}

Galaxy "NGC 5550:UGC 9154:MCG 2-36-65:ZWG 75.3"
{
        Type  "Sb"
        RA           14.3078
        Dec          12.8833
        Distance   3.462e+08  # method: V
        Radius     6.042e+04
        AbsMag        -21.03
        Axis    [  0.1756  -0.9032  -0.3916]
        Angle     36.8214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5550"
}

Galaxy "NGC 5551:MCG 1-36-37:ZWG 47.3:IRAS 14164+0540"
{
        Type  "E0"
        RA           14.3150
        Dec           5.4511
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [ -0.2551  -0.3335  -0.9076]
        Angle     76.8959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5551"
}

Galaxy "NGC 5552:NGC 5558:ZWG 47.4"
{
        Type  "S0"
        RA           14.3175
        Dec           7.0322
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.9459  -0.1018   0.3082]
        Angle     63.5811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5552"
}

Galaxy "NGC 5553:UGC 9160:MCG 5-34-17:ZWG 163.24"
{
        Type  "Sa"
        RA           14.3081
        Dec          26.2872
        Distance   2.133e+08  # method: V
        Radius     4.033e+04
        AbsMag        -19.18
        Axis    [  0.6031  -0.5812   0.5464]
        Angle     51.6197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5553"
}

Galaxy "NGC 5554:NGC 5564:ZWG 47.6"
{
        Type  "S0"
        RA           14.3208
        Dec           7.0211
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.7043  -0.6266  -0.3338]
        Angle    119.1199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5554"
}

Galaxy "NGC 5555:ESO 579-15:MCG 3-36-11:IRAS 14160-1854"
{
        Type  "Sb"
        RA           14.3133
        Dec         -19.1392
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [ -0.2983  -0.8444  -0.4451]
        Angle     44.4979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5555"
}

Galaxy "NGC 5556:ESO 446-50:MCG 5-34-9:UGCA 389"
{
        Type  "SBc"
        RA           14.3428
        Dec         -29.2414
        Distance   7.321e+07  # method: V
        Radius     4.365e+04
        AbsMag        -19.35
        Axis    [ -0.7602  -0.3170  -0.5671]
        Angle     77.0923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5556"
}

Galaxy "NGC 5557:UGC 9161:MCG 6-31-93:ZWG 191.74"
{
        Type  "E1"
        RA           14.3069
        Dec          36.4936
        Distance   1.342e+08  # method: T-F
        Radius     4.686e+04
        AbsMag        -21.17
        Axis    [ -0.0141  -0.5317  -0.8468]
        Angle     51.7021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5557"
}

Galaxy "NGC 5559:UGC 9166:MCG 4-34-17:ZWG 133.32"
{
        Type  "SBb"
        RA           14.3200
        Dec          24.7989
        Distance   2.307e+08  # method: T-F
        Radius     4.697e+04
        AbsMag        -19.35
        Axis    [  0.7517  -0.6053   0.2617]
        Angle     64.6986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5559"
}

Galaxy "NGC 5560:UGC 9172:MCG 1-37-1:ZWG 47.10"
{
        Type  "SBb"
        RA           14.3344
        Dec           3.9928
        Distance   8.951e+07  # method: V
        Radius     4.687e+04
        AbsMag        -18.99
        Axis    [ -0.1145  -0.9134   0.3906]
        Angle     32.6236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5560"
}

Galaxy "NGC 5561:ZWG 295.44"
{
        Type  "E0"
        RA           14.2894
        Dec          58.7503
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.2357  -0.9696  -0.0662]
        Angle    131.0026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5561"
}

Galaxy "NGC 5562:UGC 9174:MCG 2-37-2:ZWG 75.11"
{
        Type  "S0"
        RA           14.3364
        Dec          10.2633
        Distance   4.249e+08  # method: V
        Radius     4.326e+04
        AbsMag        -21.17
        Axis    [  0.4000  -0.8092  -0.4304]
        Angle    145.3817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5562"
}

Galaxy "NGC 5563:ZWG 47.11"
{
        Type  "S0"
        RA           14.3369
        Dec           7.0556
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.4604  -0.8229  -0.3328]
        Angle     51.0372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5563"
}

Galaxy "NGC 5566:UGC 9175:MCG 1-37-2:ZWG 47.12"
{
        Type  "SBb"
        RA           14.3389
        Dec           3.9331
        Distance   7.941e+07  # method: V
        Radius     7.623e+04
        AbsMag        -20.43
        Axis    [  0.8259  -0.5263  -0.2023]
        Angle     89.7110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5566"
}

Galaxy "NGC 5567:MCG 6-31-96:ZWG 191.75:NPM 1"
{
        Type  "Sa"
        RA           14.3214
        Dec          35.1383
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.5341  -0.8316  -0.1522]
        Angle     70.1490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5567"
}

Galaxy "NGC 5568:MCG 6-31-98:ZWG 191.77"
{
        Type  "Sc"
        RA           14.3225
        Dec          35.0922
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.4372  -0.8986  -0.0362]
        Angle     35.4922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5568"
}

Galaxy "NGC 5569:UGC 9176:MCG 1-37-3:ZWG 47.13"
{
        Type  "SBc"
        RA           14.3422
        Dec           3.9831
        Distance   9.146e+07  # method: V
        Radius     2.261e+04
        AbsMag        -17.84
        Axis    [  0.1940  -0.6875  -0.6998]
        Angle     79.8496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5569"
}

Galaxy "NGC 5570:NGC 5519:UGC 9111:MCG 1-36-25"
{
        Type  "Sa"
        RA           14.2389
        Dec           7.5156
        Distance   3.774e+08  # method: T-F
        Radius     8.783e+04
        AbsMag        -21.02
        Axis    [  0.4955  -0.7776  -0.3870]
        Angle     56.5005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5570"
}

Galaxy "NGC 5572:UGC 9173:MCG 6-31-99:ZWG 191.79"
{
        Type  "Sb"
        RA           14.3264
        Dec          36.1408
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.8375   0.5366   0.1030]
        Angle     41.4773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5572"
}

Galaxy "NGC 5573:MCG 1-37-5:ZWG 47.16:NPM 1"
{
        Type  "S0"
        RA           14.3447
        Dec           6.9078
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [  0.2760  -0.8324   0.4806]
        Angle     37.2542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5573"
}

Galaxy "NGC 5574:UGC 9181:MCG 1-37-6:ZWG 47.18"
{
        Type  "S0"
        RA           14.3486
        Dec           3.2381
        Distance   7.788e+07  # method: S
        Radius     1.699e+04
        AbsMag        -18.69
        Axis    [  0.4609  -0.7310  -0.5032]
        Angle     72.8149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5574"
}

Galaxy "NGC 5575:NGC 5578:UGC 9184:MCG 1-37-8"
{
        Type  "S0"
        RA           14.3497
        Dec           6.2028
        Distance   3.577e+08  # method: V
        Radius     5.202e+04
        AbsMag         -20.8
        Axis    [ -0.0048  -0.6628  -0.7488]
        Angle     58.1474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5575"
}

Galaxy "NGC 5576:UGC 9183:MCG 1-37-7:ZWG 47.20"
{
        Type  "E3"
        RA           14.3508
        Dec           3.2714
        Distance   8.307e+07  # method: S
        Radius     4.591e+04
        AbsMag        -20.23
        Axis    [ -0.1311  -0.4673  -0.8743]
        Angle     85.3569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5576"
}

Galaxy "NGC 5577:UGC 9187:MCG 1-37-9:ZWG 47.22"
{
        Type  "Sc"
        RA           14.3536
        Dec           3.4364
        Distance   7.801e+07  # method: T-F
        Radius     3.631e+04
        AbsMag        -18.49
        Axis    [  0.7885  -0.6050  -0.1109]
        Angle     68.0848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5577"
}

Galaxy "NGC 5579:UGC 9180:MCG 6-32-2:ZWG 191.80"
{
        Type  "Sc"
        RA           14.3406
        Dec          35.1892
        Distance   1.715e+08  # method: V
        Radius      4.74e+04
        AbsMag         -19.2
        Axis    [ -0.8733   0.4495   0.1878]
        Angle     37.3687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5579"
}

Galaxy "NGC 5581:MCG 4-34-21:ZWG 133.38"
{
        Type  "S0"
        RA           14.3544
        Dec          23.4800
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.8953   0.3070  -0.3229]
        Angle     41.0956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5581"
}

Galaxy "NGC 5582:UGC 9188:MCG 7-29-63:ZWG 220.3"
{
        Type  "E0"
        RA           14.3453
        Dec          39.6939
        Distance   9.278e+07  # method: S
        Radius     3.778e+04
        AbsMag        -19.77
        Axis    [  0.2687  -0.9114  -0.3118]
        Angle    113.7552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5582"
}

Galaxy "NGC 5583:UGC 9196:MCG 2-37-4:ZWG 75.18"
{
        Type  "S0"
        RA           14.3611
        Dec          13.2322
        Distance   2.374e+08  # method: V
        Radius     2.763e+04
        AbsMag        -20.01
        Axis    [  0.3726  -0.8166  -0.4408]
        Angle     55.7313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5583"
}

Galaxy "NGC 5584:UGC 9201:MCG 0-37-1:ZWG 19.8"
{
        Type  "SBc"
        RA           14.3731
        Dec          -0.3881
        Distance   8.548e+07  # method: V
        Radius     4.227e+04
        AbsMag        -19.89
        Axis    [ -0.7631  -0.3398  -0.5497]
        Angle     46.6192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5584"
}

Galaxy "NGC 5585:UGC 9179:MCG 10-20-94:ZWG 295.45"
{
        Type  "SBc"
        RA           14.3297
        Dec          56.7289
        Distance   3.579e+07  # method: T-F
        Radius     3.019e+04
        AbsMag           -19
        Axis    [  0.6583  -0.7186   0.2241]
        Angle    104.8675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5585"
}

Galaxy "NGC 5587:UGC 9202:MCG 2-37-5:ZWG 75.20"
{
        Type  "Sa"
        RA           14.3694
        Dec          13.9175
        Distance   1.148e+08  # method: V
        Radius     4.343e+04
        AbsMag        -18.93
        Axis    [ -0.8419  -0.1952   0.5031]
        Angle     51.3196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5587"
}

Galaxy "NGC 5589:NGC 5588:UGC 9197:MCG 6-32-5"
{
        Type  "SBa"
        RA           14.3567
        Dec          35.2706
        Distance   1.619e+08  # method: V
        Radius      2.59e+04
        AbsMag        -19.28
        Axis    [  0.3344  -0.9095  -0.2470]
        Angle    137.4970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5589"
}

Galaxy "NGC 5590:NGC 5580:UGC 9200:MCG 6-32-6"
{
        Type  "S0"
        RA           14.3606
        Dec          35.2050
        Distance   1.551e+08  # method: V
        Radius     4.061e+04
        AbsMag        -20.09
        Axis    [  0.3343  -0.9094  -0.2475]
        Angle    137.5587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5590"
}

Galaxy "NGC 5591-1:UGC 9207:MCG 2-37-6:MK 809"
{
        Type  "Sc"
        RA           14.3758
        Dec          13.7169
        Distance   3.579e+08  # method: V
        Radius     6.768e+04
        AbsMag         -21.1
        Axis    [  0.6206  -0.7802  -0.0784]
        Angle     54.2059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5591-1"
}

Galaxy "NGC 5591-2:UGC 9207:MCG 2-37-6:MK 809"
{
        Type  "Irr"
        RA           14.3761
        Dec          13.7172
        Distance   3.468e+08  # distance uncertain!
        Radius     5.044e+04
        AbsMag        -20.13
        Axis    [  0.5604  -0.8205  -0.1128]
        Angle     50.1634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5591-2"
}

Galaxy "NGC 5592:ESO 446-58:MCG 5-34-11:AM 1421-282"
{
        Type  "SBc"
        RA           14.3983
        Dec         -28.6883
        Distance    2.14e+08  # method: T-F
        Radius     4.668e+04
        AbsMag        -20.58
        Axis    [  0.0848  -0.6771  -0.7310]
        Angle     63.9418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5592"
}

Galaxy "NGC 5594:IC 4412:MCG 4-34-24:ZWG 133.46"
{
        Type  "S0"
        RA           14.3861
        Dec          26.2664
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.8257  -0.2204   0.5193]
        Angle     27.3901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5594"
}

Galaxy "NGC 5595:MCG 3-37-1:VV 446:VV 530"
{
        Type  "SBc"
        RA           14.4036
        Dec         -16.7225
        Distance   1.222e+08  # method: T-F
        Radius     4.265e+04
        AbsMag        -20.17
        Axis    [  0.5723  -0.5878  -0.5718]
        Angle     81.7801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5595"
}

Galaxy "NGC 5596:UGC 9208:MCG 6-32-10:MK 470"
{
        Type  "S0"
        RA           14.3744
        Dec          37.1228
        Distance   1.514e+08  # method: V
        Radius     2.421e+04
        AbsMag        -18.73
        Axis    [  0.4278  -0.8986   0.0976]
        Angle     32.4237
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5596"
}

Galaxy "NGC 5597:MCG 3-37-2:VV 446:IRAS 14216-1632"
{
        Type  "SBc"
        RA           14.4075
        Dec         -16.7633
        Distance   1.298e+08  # method: V
        Radius     3.964e+04
        AbsMag         -20.3
        Axis    [ -0.1225  -0.5368  -0.8347]
        Angle     78.3563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5597"
}

Galaxy "NGC 5598:UGC 9209:MCG 7-30-4:ZWG 220.7"
{
        Type  "S0"
        RA           14.3744
        Dec          40.3203
        Distance   2.551e+08  # method: V
        Radius     5.937e+04
        AbsMag        -20.37
        Axis    [  0.6392  -0.7676   0.0472]
        Angle     81.2401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5598"
}

Galaxy "NGC 5599:UGC 9218:MCG 1-37-10:ZWG 47.30"
{
        Type  "Sb"
        RA           14.3972
        Dec           6.5756
        Distance   3.178e+08  # method: T-F
        Radius     6.471e+04
        AbsMag        -20.34
        Axis    [ -0.9110  -0.2271   0.3442]
        Angle     55.0905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5599"
}

Galaxy "NGC 5600:UGC 9220:MCG 3-37-13:ZWG 104.15"
{
        Type  "Sc"
        RA           14.3969
        Dec          14.6386
        Distance   1.154e+08  # method: V
        Radius     2.349e+04
        AbsMag        -20.04
        Axis    [  0.3842  -0.8315  -0.4013]
        Angle    144.3896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5600"
}

Galaxy "NGC 5601:MCG 7-30-6:ZWG 220.9:NPM 1"
{
        Type  "S0"
        RA           14.3814
        Dec          40.3100
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.8120  -0.5800   0.0654]
        Angle    131.0668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5601"
}

Galaxy "NGC 5602:UGC 9210:MCG 9-24-2:ZWG 273.4"
{
        Type  "Sa"
        RA           14.3717
        Dec          50.5028
        Distance   1.064e+08  # method: V
        Radius     2.322e+04
        AbsMag        -18.97
        Axis    [ -0.5705   0.4795   0.6668]
        Angle     46.6761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5602"
}

Galaxy "NGC 5603:NGC 5603A:UGC 9217:MCG 7-30-8"
{
        Type  "S0"
        RA           14.3836
        Dec          40.3778
        Distance   2.622e+08  # method: V
        Radius     4.196e+04
        AbsMag        -20.53
        Axis    [  0.3166  -0.9257  -0.2067]
        Angle    136.3855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5603"
}

Galaxy "NGC 5603B:UGC 9216:MCG 7-30-7:ZWG 220.10"
{
        Type  "Sc"
        RA           14.3822
        Dec          40.4169
        Distance    2.58e+08  # method: V
        Radius     7.505e+04
        AbsMag        -19.39
        Axis    [  0.3166  -0.9258  -0.2064]
        Angle    136.3591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5603B"
}

Galaxy "NGC 5604:MCG 0-37-3:ZWG 19.16:IRAS 14221-0259"
{
        Type  "Sa"
        RA           14.4117
        Dec          -3.2119
        Distance   1.358e+08  # method: V
        Radius     3.753e+04
        AbsMag         -19.4
        Axis    [  0.7718  -0.5199  -0.3661]
        Angle    110.0344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5604"
}

Galaxy "NGC 5605:MCG 2-37-3:IRAS 14223-1256"
{
        Type  "SBc"
        RA           14.4186
        Dec         -13.1636
        Distance   1.635e+08  # method: V
        Radius     3.568e+04
        AbsMag         -20.5
        Axis    [  0.0347  -0.6120  -0.7901]
        Angle     76.2131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5605"
}

Galaxy "NGC 5607:IC 1005:UGC 9189:MCG 12-41-1"
{
        Type  "S0"
        RA           14.3239
        Dec          71.5881
        Distance   3.439e+08  # method: V
        Radius     4.502e+04
        AbsMag        -21.11
        Axis    [  0.5179  -0.7997   0.3037]
        Angle     67.8644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5607"
}

Galaxy "NGC 5608:UGC 9219:MCG 7-30-9:ZWG 220.12"
{
        Type  "Irr"
        RA           14.3881
        Dec          41.7756
        Distance   3.728e+07  # method: V
        Radius     1.193e+04
        AbsMag        -16.29
        Axis    [  0.5371  -0.6875   0.4887]
        Angle     42.7097
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5608"
}

Galaxy "NGC 5609"
{
        Type  "S0"
        RA           14.3967
        Dec          34.8428
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.3920  -0.9196  -0.0264]
        Angle     33.6251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5609"
}

Galaxy "NGC 5610:UGC 9230:MCG 4-34-25:ZWG 133.49"
{
        Type  "SBb"
        RA           14.4064
        Dec          24.6144
        Distance   2.227e+08  # method: T-F
        Radius     6.479e+04
        AbsMag        -19.87
        Axis    [  0.2784  -0.7456   0.6055]
        Angle     34.8534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5610"
}

Galaxy "NGC 5611:UGC 9227:MCG 6-32-20:ZWG 192.13"
{
        Type  "S0"
        RA           14.4011
        Dec          33.0478
        Distance   8.231e+07  # method: S
        Radius     1.556e+04
        AbsMag        -18.41
        Axis    [  0.7054  -0.6841   0.1852]
        Angle     69.2600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5611"
}

Galaxy "NGC 5612:ESO 22-1:IRAS 14281-7809"
{
        Type  "Sb"
        RA           14.5669
        Dec         -78.3878
        Distance    1.26e+08  # method: V
        Radius     3.483e+04
        AbsMag        -19.93
        Axis    [  0.0681  -0.3162  -0.9463]
        Angle    111.3156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5612"
}

Galaxy "NGC 5613:UGC 9228:MCG 6-32-21:VV 77"
{
        Type  "SBa"
        RA           14.4014
        Dec          34.8925
        Distance   4.044e+08  # method: V
        Radius     2.941e+04
        AbsMag        -20.27
        Axis    [  0.6061  -0.7864  -0.1194]
        Angle    113.2288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5613"
}

Galaxy "NGC 5614:UGC 9226:MCG 6-32-22:ZWG 192.14"
{
        Type  "Sb"
        RA           14.4019
        Dec          34.8592
        Distance   1.845e+08  # method: V
        Radius     6.439e+04
        AbsMag        -21.26
        Axis    [ -0.6733  -0.6192  -0.4040]
        Angle     13.6210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5614"
}

Galaxy "NGC 5615:MCG 6-32-23:VV 77:ARP 178"
{
        Type  "S0"
        RA           14.4017
        Dec          34.8653
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.3316  -0.9095  -0.2506]
        Angle    138.1089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5615"
}

Galaxy "NGC 5616:UGC 9231:MCG 6-32-26:ZWG 192.15"
{
        Type  "SBc"
        RA           14.4056
        Dec          36.4614
        Distance   3.896e+08  # method: V
        Radius      1.19e+05
        AbsMag        -20.79
        Axis    [ -0.5055   0.0081   0.8628]
        Angle     58.0081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5616"
}

Galaxy "NGC 5618:UGC 9250:MCG 0-37-5:ZWG 19.26"
{
        Type  "SBc"
        RA           14.4531
        Dec          -2.2628
        Distance   3.349e+08  # method: V
        Radius     7.793e+04
        AbsMag        -20.86
        Axis    [  0.6676  -0.6059  -0.4326]
        Angle    121.9086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5618"
}

Galaxy "NGC 5619:NGC 5619A:UGC 9255:MCG 1-37-12"
{
        Type  "Sb"
        RA           14.4550
        Dec           4.8031
        Distance   3.652e+08  # method: T-F
        Radius     1.169e+05
        AbsMag        -21.54
        Axis    [  0.7802  -0.5510  -0.2961]
        Angle    117.6637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5619"
}

Galaxy "NGC 5619C:UGC 9258:MCG 1-37-13:ZWG 47.47"
{
        Type  "Sc"
        RA           14.4581
        Dec           4.7797
        Distance   3.845e+08  # method: V
        Radius     4.474e+04
        AbsMag        -20.26
        Axis    [  0.3984  -0.7876  -0.4700]
        Angle    148.3493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5619C"
}

Galaxy "NGC 5620:MCG 12-14-2:ZWG 337.10"
{
        Type  "S0"
        RA           14.3778
        Dec          69.5953
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.2137  -0.9761   0.0382]
        Angle    129.9764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5620"
}

Galaxy "NGC 5622:UGC 9248:MCG 8-26-32:ZWG 247.28"
{
        Type  "Sb"
        RA           14.4367
        Dec          48.5644
        Distance   2.194e+08  # method: T-F
        Radius     5.425e+04
        AbsMag        -20.14
        Axis    [  0.5701  -0.6620   0.4865]
        Angle     49.0429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5622"
}

Galaxy "NGC 5623:UGC 9260:MCG 6-32-35:ZWG 192.21"
{
        Type  "E0"
        RA           14.4522
        Dec          33.2531
        Distance   1.649e+08  # method: V
        Radius     3.836e+04
        AbsMag        -20.02
        Axis    [  0.2795  -0.9000  -0.3345]
        Angle    124.5171
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5623"
}

Galaxy "NGC 5624:UGC 9256:MCG 9-24-6:ZWG 273.6"
{
        Type  "S0"
        RA           14.4431
        Dec          51.5847
        Distance   9.255e+07  # method: V
        Radius     1.481e+04
        AbsMag        -18.16
        Axis    [  0.6188  -0.7834   0.0576]
        Angle    129.9583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5624"
}

Galaxy "NGC 5625-1:MCG 7-30-13:ZWG 220.17:VV 25"
{
        Type  "Sc"
        RA           14.4506
        Dec          39.9575
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.5836  -0.7973   0.1538]
        Angle     55.0988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5625-1"
}

Galaxy "NGC 5625-2:MCG 7-30-13:ZWG 220.17:VV 25"
{
        Type  "E0"
        RA           14.4500
        Dec          39.9564
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [ -0.0373  -0.5184  -0.8543]
        Angle     46.5484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5625-2"
}

Galaxy "NGC 5626:ESO 447-8:MCG 5-34-15"
{
        Type  "Sa"
        RA           14.4969
        Dec         -29.7494
        Distance   3.207e+08  # method: V
        Radius     5.597e+04
        AbsMag        -20.96
        Axis    [ -0.5510  -0.4264  -0.7174]
        Angle     77.1091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5626"
}

Galaxy "NGC 5627:UGC 9280:MCG 2-37-13:ZWG 75.46"
{
        Type  "S0"
        RA           14.4761
        Dec          11.3783
        Distance   3.634e+08  # method: V
        Radius     8.984e+04
        AbsMag        -20.93
        Axis    [ -0.3545  -0.9227  -0.1517]
        Angle     28.3275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5627"
}

Galaxy "NGC 5628:UGC 9278:MCG 3-37-19:ZWG 104.33"
{
        Type  "E0"
        RA           14.4736
        Dec          17.9250
        Distance    2.65e+08  # method: V
        Radius      4.24e+04
        AbsMag        -19.85
        Axis    [ -0.6316   0.4702  -0.6164]
        Angle     68.1746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5628"
}

Galaxy "NGC 5629:UGC 9281:MCG 4-34-34:ZWG 133.65"
{
        Type  "S0"
        RA           14.4711
        Dec          25.8492
        Distance   2.503e+08  # method: T-F
        Radius     6.552e+04
        AbsMag        -21.32
        Axis    [  0.3499  -0.8802  -0.3208]
        Angle    141.4941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5629"
}

Galaxy "NGC 5630:UGC 9270:MCG 7-30-14:ZWG 220.18"
{
        Type  "Irr"
        RA           14.4600
        Dec          41.2581
        Distance   1.122e+08  # method: T-F
        Radius      3.59e+04
        AbsMag        -19.08
        Axis    [  0.4815  -0.4999   0.7199]
        Angle     51.4131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5630"
}

Galaxy "NGC 5631:UGC 9261:MCG 10-21-2:ZWG 296.5"
{
        Type  "S0"
        RA           14.4425
        Dec          56.5831
        Distance   9.067e+07  # method: S
        Radius     2.242e+04
        AbsMag        -19.82
        Axis    [  0.2582  -0.9633  -0.0734]
        Angle    133.2460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5631"
}

Galaxy "NGC 5633:UGC 9271:MCG 8-26-34:ZWG 247.30"
{
        Type  "Sb"
        RA           14.4578
        Dec          46.1475
        Distance   1.123e+08  # method: V
        Radius     3.429e+04
        AbsMag        -19.68
        Axis    [  0.7296  -0.6774   0.0937]
        Angle    123.2604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5633"
}

Galaxy "NGC 5635:UGC 9283:MCG 5-34-49:ZWG 163.58"
{
        Type  "Sb"
        RA           14.4753
        Dec          27.4092
        Distance   2.044e+08  # method: V
        Radius     6.839e+04
        AbsMag        -20.28
        Axis    [  0.6836  -0.7236   0.0955]
        Angle     66.3904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5635"
}

Galaxy "NGC 5636:UGC 9304:MCG 1-37-17:ZWG 47.62"
{
        Type  "SBa"
        RA           14.4942
        Dec           3.2667
        Distance   8.965e+07  # method: V
        Radius     2.477e+04
        AbsMag        -18.09
        Axis    [  0.5682  -0.6946  -0.4412]
        Angle     93.9009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5636"
}

Galaxy "NGC 5637:UGC 9293:MCG 4-34-37:ZWG 133.69"
{
        Type  "Sc"
        RA           14.4831
        Dec          23.1908
        Distance   2.258e+08  # method: T-F
        Radius     2.955e+04
        AbsMag         -19.6
        Axis    [  0.7641  -0.6312  -0.1336]
        Angle    121.2008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5637"
}

Galaxy "NGC 5638:UGC 9308:MCG 1-37-18:ZWG 47.63"
{
        Type  "E1"
        RA           14.4944
        Dec           3.2333
        Distance   8.579e+07  # method: S
        Radius     3.369e+04
        AbsMag         -19.9
        Axis    [ -0.6046   0.0793  -0.7926]
        Angle     73.2266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5638"
}

Galaxy "NGC 5639:NGC 5639A:UGC 9290:MCG 5-34-51"
{
        Type  "Sc"
        RA           14.4794
        Dec          30.4125
        Distance   1.695e+08  # method: V
        Radius     3.452e+04
        AbsMag        -19.18
        Axis    [  0.4069  -0.9069   0.1092]
        Angle     36.0698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5639"
}

Galaxy "NGC 5639B"
{
        Type  "S0"
        RA           14.4825
        Dec          30.4064
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.7602  -0.5049   0.4089]
        Angle     18.3227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5639B"
}

Galaxy "NGC 5640:ZWG 353.35:NPM 1"
{
        Type  "Sa"
        RA           14.3444
        Dec          80.1236
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [  0.6335  -0.6197   0.4633]
        Angle    124.7423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5640"
}

Galaxy "NGC 5641:UGC 9300:MCG 5-34-55:ZWG 163.63"
{
        Type  "SBb"
        RA           14.4878
        Dec          28.8217
        Distance   2.386e+08  # method: T-F
        Radius      8.33e+04
        AbsMag        -21.02
        Axis    [ -0.8607   0.0621   0.5053]
        Angle     37.6305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5641"
}

Galaxy "NGC 5642:UGC 9301:MCG 5-34-52:ZWG 163.64"
{
        Type  "E0"
        RA           14.4869
        Dec          30.0272
        Distance   2.058e+08  # method: V
        Radius     5.389e+04
        AbsMag         -20.1
        Axis    [ -0.3151  -0.1441  -0.9381]
        Angle     48.6395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5642"
}

Galaxy "NGC 5643:ESO 272-16:MCG 7-30-3:AM 1429-435"
{
        Type  "SBc"
        RA           14.5444
        Dec         -44.1744
        Distance   6.306e+07  # method: V
        Radius     4.311e+04
        AbsMag        -20.53
        Axis    [ -0.7768  -0.2604  -0.5733]
        Angle     98.4871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5643"
}

Galaxy "NGC 5644:UGC 9321:MCG 2-37-16:ZWG 75.57"
{
        Type  "S0"
        RA           14.5069
        Dec          11.9281
        Distance   3.552e+08  # method: V
        Radius     7.232e+04
        AbsMag        -21.38
        Axis    [  0.3789  -0.8234  -0.4225]
        Angle    146.2875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5644"
}

Galaxy "NGC 5645:UGC 9328:MCG 1-37-19:ZWG 47.70"
{
        Type  "SBc"
        RA           14.5108
        Dec           7.2747
        Distance   7.253e+07  # method: V
        Radius     2.743e+04
        AbsMag        -18.83
        Axis    [  0.4123  -0.8366  -0.3607]
        Angle     54.5677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5645"
}

Galaxy "NGC 5646:UGC 9312:MCG 6-32-45:ZWG 192.30"
{
        Type  "SBb"
        RA           14.4925
        Dec          35.4619
        Distance   3.964e+08  # method: V
        Radius     8.648e+04
        AbsMag        -20.42
        Axis    [  0.6388  -0.5616   0.5259]
        Angle     61.7699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5646"
}

Galaxy "NGC 5647:UGC 9329:MCG 2-37-17:ZWG 75.58"
{
        Type  "Sa"
        RA           14.5100
        Dec          11.8772
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.8911  -0.4298  -0.1457]
        Angle    122.4955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5647"
}

Galaxy "NGC 5649:NGC 5648:UGC 9330:MCG 2-37-19"
{
        Type  "Sc"
        RA           14.5089
        Dec          14.0233
        Distance   2.429e+08  # method: V
        Radius     3.887e+04
        AbsMag        -20.26
        Axis    [ -0.9908   0.1354  -0.0037]
        Angle     51.8507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5649"
}

Galaxy "NGC 5652:NGC 5650:UGC 9334:MCG 1-37-20"
{
        Type  "SBc"
        RA           14.5167
        Dec           5.9783
        Distance   3.502e+08  # method: V
        Radius     1.019e+05
        AbsMag        -21.65
        Axis    [ -0.3365  -0.8027  -0.4925]
        Angle     36.3579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5652"
}

Galaxy "NGC 5653:IC 1026:UGC 9318:MCG 5-34-58"
{
        Type  "Sb"
        RA           14.5028
        Dec          31.2153
        Distance     1.7e+08  # method: V
        Radius     4.203e+04
        AbsMag        -20.68
        Axis    [ -0.4237  -0.9015  -0.0881]
        Angle     16.8845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5653"
}

Galaxy "NGC 5654:UGC 9319:MCG 6-32-50:ZWG 192.32"
{
        Type  "SBa"
        RA           14.5003
        Dec          36.3603
        Distance   4.189e+08  # method: V
        Radius      9.14e+04
        AbsMag        -21.54
        Axis    [ -0.8109   0.0021   0.5852]
        Angle     22.2261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5654"
}

Galaxy "NGC 5655:UGC 9333:MCG 2-37-20:ZWG 75.60"
{
        Type  "Sc"
        RA           14.5142
        Dec          13.9692
        Distance    2.46e+08  # method: V
        Radius     3.936e+04
        AbsMag        -20.39
        Axis    [ -0.9693   0.1254  -0.2114]
        Angle     47.3792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5655"
}

Galaxy "NGC 5656:UGC 9332:MCG 6-32-53:ZWG 192.34"
{
        Type  "Sb"
        RA           14.5069
        Dec          35.3214
        Distance   1.524e+08  # method: V
        Radius     4.213e+04
        AbsMag        -20.65
        Axis    [  0.5575  -0.8227  -0.1112]
        Angle     82.5664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5656"
}

Galaxy "NGC 5657:UGC 9335:MCG 5-34-60:MK 814"
{
        Type  "SBb"
        RA           14.5119
        Dec          29.1806
        Distance   1.865e+08  # method: T-F
        Radius     4.881e+04
        AbsMag        -19.59
        Axis    [ -0.8036   0.0681   0.5913]
        Angle     45.4472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5657"
}

Galaxy "NGC 5659:UGC 9342:MCG 4-34-44:ZWG 133.82"
{
        Type  "Sb"
        RA           14.5183
        Dec          25.3550
        Distance   2.134e+08  # method: T-F
        Radius     4.965e+04
        AbsMag        -19.18
        Axis    [  0.8231  -0.5484   0.1475]
        Angle     88.0134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5659"
}

Galaxy "NGC 5660:UGC 9325:MCG 8-26-39:ZWG 247.35"
{
        Type  "SBc"
        RA           14.4967
        Dec          49.6225
        Distance   1.112e+08  # method: V
        Radius     4.367e+04
        AbsMag        -20.26
        Axis    [  0.3402  -0.8972  -0.2815]
        Angle     45.1713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5660"
}

Galaxy "NGC 5661:UGC 9346:MCG 1-37-23:ZWG 47.81"
{
        Type  "SBb"
        RA           14.5325
        Dec           6.2506
        Distance   1.172e+08  # method: V
        Radius     2.558e+04
        AbsMag        -18.58
        Axis    [  0.8079  -0.5456  -0.2226]
        Angle    101.3835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5661"
}

Galaxy "NGC 5663:MCG 3-37-3:NPM 1"
{
        Type  "S0"
        RA           14.5656
        Dec         -16.5806
        Distance    2.44e+08  # distance uncertain!
        Radius     4.969e+04
        AbsMag        -19.07
        Axis    [  0.5592  -0.6009  -0.5711]
        Angle    143.9034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5663"
}

Galaxy "NGC 5664:IC 4455:MCG 2-37-8:IRAS 14309-1424"
{
        Type  "Sa"
        RA           14.5619
        Dec         -14.6194
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.7582  -0.4857  -0.4351]
        Angle     92.7291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5664"
}

Galaxy "NGC 5665:UGC 9352:MCG 1-37-24:ZWG 47.84"
{
        Type  "SBc"
        RA           14.5403
        Dec           8.0792
        Distance   1.107e+08  # method: V
        Radius     3.382e+04
        AbsMag        -19.95
        Axis    [ -0.9045  -0.4224  -0.0589]
        Angle     36.7558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5665"
}

Galaxy "NGC 5665A"
{
        Type  "E0"
        RA           14.5408
        Dec           8.0786
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.3608  -0.8138  -0.4556]
        Angle    149.2385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5665A"
}

Galaxy "NGC 5666:UGC 9360:MCG 2-37-23:ZWG 75.66"
{
        Type  "S0"
        RA           14.5525
        Dec          10.5108
        Distance   1.108e+08  # method: V
        Radius      1.45e+04
        AbsMag        -18.96
        Axis    [ -0.8827  -0.0007  -0.4699]
        Angle     46.9413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5666"
}

Galaxy "NGC 5667:UGC 9344:MCG 10-21-4:ZWG 296.8"
{
        Type  "SBc"
        RA           14.5061
        Dec          59.4703
        Distance   9.468e+07  # method: V
        Radius     2.341e+04
        AbsMag        -19.11
        Axis    [ -0.4313   0.6490   0.6267]
        Angle     45.2373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5667"
}

Galaxy "NGC 5668:UGC 9363:MCG 1-37-28:ZWG 47.90"
{
        Type  "Irr"
        RA           14.5567
        Dec           4.4506
        Distance   8.218e+07  # method: V
        Radius     3.586e+04
        AbsMag        -19.81
        Axis    [  0.3886  -0.7898  -0.4745]
        Angle    149.2576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5668"
}

Galaxy "NGC 5669:UGC 9353:MCG 2-37-21:ZWG 75.64"
{
        Type  "SBc"
        RA           14.5456
        Dec           9.8922
        Distance   7.239e+07  # method: V
        Radius     4.212e+04
        AbsMag        -19.43
        Axis    [  0.5629  -0.7438  -0.3605]
        Angle     82.8690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5669"
}

Galaxy "NGC 5670:ESO 272-19"
{
        Type  "S0"
        RA           14.5933
        Dec         -45.9667
        Distance   1.393e+08  # method: V
        Radius      3.04e+04
        AbsMag        -20.15
        Axis    [  0.1634  -0.5664  -0.8078]
        Angle     78.0718
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5670"
}

Galaxy "NGC 5671:UGC 9297:MCG 12-14-6:ZWG 337.14"
{
        Type  "SBb"
        RA           14.4617
        Dec          69.6947
        Distance   4.106e+08  # method: V
        Radius     1.015e+05
        AbsMag         -21.3
        Axis    [  0.5793  -0.7314   0.3600]
        Angle     94.8821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5671"
}

Galaxy "NGC 5672:IC 1030:UGC 9354:MCG 5-34-68"
{
        Type  "Sb"
        RA           14.5439
        Dec          31.6703
        Distance   1.697e+08  # method: V
        Radius     1.975e+04
        AbsMag        -19.38
        Axis    [  0.6526  -0.7575  -0.0197]
        Angle     81.7556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5672"
}

Galaxy "NGC 5673:UGC 9347:MCG 8-26-41:ZWG 247.39"
{
        Type  "SBc"
        RA           14.5250
        Dec          49.9586
        Distance   1.492e+08  # method: T-F
        Radius     5.209e+04
        AbsMag         -19.7
        Axis    [ -0.0751  -0.0278   0.9968]
        Angle     53.8394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5673"
}

Galaxy "NGC 5674:UGC 9369:MCG 1-37-31:ZWG 47.96"
{
        Type  "SBc"
        RA           14.5644
        Dec           5.4586
        Distance   3.489e+08  # method: V
        Radius     5.581e+04
        AbsMag        -21.45
        Axis    [  0.4610  -0.7370  -0.4943]
        Angle    111.3530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5674"
}

Galaxy "NGC 5675:UGC 9357:MCG 6-32-62:ZWG 192.38"
{
        Type  "SBb"
        RA           14.5442
        Dec          36.3025
        Distance   1.965e+08  # method: V
        Radius     8.003e+04
        AbsMag         -20.1
        Axis    [ -0.2885  -0.2240   0.9309]
        Angle     37.8742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5675"
}

Galaxy "NGC 5676:UGC 9366:MCG 8-26-43:ZWG 248.3"
{
        Type  "Sc"
        RA           14.5461
        Dec          49.4569
        Distance   1.252e+08  # method: T-F
        Radius       7.1e+04
        AbsMag        -21.02
        Axis    [  0.7032  -0.6484   0.2917]
        Angle     91.7573
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5676"
}

Galaxy "NGC 5677:UGC 9378:MCG 4-34-46:ZWG 133.88"
{
        Type  "Sc"
        RA           14.5700
        Dec          25.4683
        Distance   2.281e+08  # method: V
        Radius     2.986e+04
        AbsMag        -19.52
        Axis    [ -0.8209  -0.5216  -0.2327]
        Angle     21.3375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5677"
}

Galaxy "NGC 5678:UGC 9358:MCG 10-21-5:ZWG 296.9"
{
        Type  "SBb"
        RA           14.5347
        Dec          57.9231
        Distance   9.146e+07  # method: V
        Radius      4.39e+04
        AbsMag        -20.04
        Axis    [  0.7300  -0.6536   0.1999]
        Angle    133.7935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5678"
}

Galaxy "NGC 5679:NGC 5679B:UGC 9383:MCG 1-37-35"
{
        Type  "Sb"
        RA           14.5856
        Dec           5.3592
        Distance   4.024e+08  # method: V
        Radius     6.438e+04
        AbsMag        -21.66
        Axis    [ -0.5810  -0.7584  -0.2953]
        Angle     34.2371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5679"
}

Galaxy "NGC 5679A:MCG 1-37-34:VV 458:ARP 274"
{
        Type  "Sc"
        RA           14.5850
        Dec           5.3564
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.6524  -0.7063  -0.2747]
        Angle     75.0261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5679A"
}

Galaxy "NGC 5679C:ARP 274:VV 458"
{
        Type  "E0"
        RA           14.5864
        Dec           5.3544
        Distance    8.71e+08  # distance uncertain!
        Radius     3.801e+04
        AbsMag        -20.13
        Axis    [  0.3256  -0.7929  -0.5150]
        Angle    142.6234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5679C"
}

Galaxy "NGC 5679D:MCG 1-37-36:ARP 274:VV 458"
{
        Type  "S0"
        RA           14.5850
        Dec           5.3567
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.3839  -0.7953  -0.4691]
        Angle    149.1750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5679D"
}

Galaxy "NGC 5680:ZWG 19.68"
{
        Type  "S0"
        RA           14.5956
        Dec          -0.0133
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.6870  -0.6085  -0.3972]
        Angle    115.0909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5680"
}

Galaxy "NGC 5681:UGC 9393:MCG 2-37-25:ZWG 75.83"
{
        Type  "Sb"
        RA           14.5953
        Dec           8.3000
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [  0.6512  -0.6734  -0.3500]
        Angle    127.5921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5681"
}

Galaxy "NGC 5682:UGC 9388:MCG 8-27-2:ZWG 248.8"
{
        Type  "SBb"
        RA           14.5792
        Dec          48.6703
        Distance   1.093e+08  # method: V
        Radius     2.543e+04
        AbsMag        -17.92
        Axis    [  0.0667  -0.1868   0.9801]
        Angle     43.4709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5682"
}

Galaxy "NGC 5683:MCG 8-27-3:MK 474:ZWG 248.9"
{
        Type  "SBa"
        RA           14.5811
        Dec          48.6625
        Distance   4.919e+08  # method: V
        Radius     2.862e+04
        AbsMag        -19.79
        Axis    [ -0.6558   0.6473   0.3885]
        Angle     39.3638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5683"
}

Galaxy "NGC 5684:UGC 9402:MCG 6-32-73:ZWG 192.46"
{
        Type  "S0"
        RA           14.5972
        Dec          36.5436
        Distance   1.924e+08  # method: V
        Radius     4.197e+04
        AbsMag        -20.25
        Axis    [  0.1981  -0.9359  -0.2913]
        Angle     32.0234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5684"
}

Galaxy "NGC 5685:UGC 9403:MCG 5-34-81:ZWG 163.87"
{
        Type  "E0"
        RA           14.6042
        Dec          29.9083
        Distance   4.767e+08  # method: V
        Radius     8.319e+04
        AbsMag        -21.22
        Axis    [  0.3024  -0.9048  -0.2997]
        Angle    142.5845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5685"
}

Galaxy "NGC 5686:MCG 6-32-75:ZWG 192.48:NPM 1"
{
        Type  "Sa"
        RA           14.6006
        Dec          36.5036
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.3093  -0.9203  -0.2397]
        Angle    139.8766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5686"
}

Galaxy "NGC 5687:UGC 9395:MCG 9-24-20:ZWG 273.14"
{
        Type  "S0"
        RA           14.5811
        Dec          54.4767
        Distance   9.108e+07  # method: S
        Radius     3.312e+04
        AbsMag        -19.53
        Axis    [  0.4923  -0.7111   0.5020]
        Angle     33.9937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5687"
}

Galaxy "NGC 5688:ESO 272-22:MCG 7-30-4:AM 1436-444"
{
        Type  "SBc"
        RA           14.6597
        Dec         -45.0186
        Distance   1.371e+08  # method: T-F
        Radius     6.183e+04
        AbsMag        -20.52
        Axis    [ -0.0339  -0.5719  -0.8196]
        Angle     82.7916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5688"
}

Galaxy "NGC 5689:UGC 9399:MCG 8-27-4:ZWG 248.10"
{
        Type  "SBa"
        RA           14.5914
        Dec          48.7417
        Distance   1.034e+08  # method: V
        Radius     4.964e+04
        AbsMag         -19.7
        Axis    [  0.5836  -0.4855   0.6510]
        Angle     66.7727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5689"
}

Galaxy "NGC 5690:UGC 9416:MCG 0-37-19:ZWG 19.72"
{
        Type  "Sc"
        RA           14.6281
        Dec           2.2906
        Distance   7.194e+07  # method: T-F
        Radius     3.557e+04
        AbsMag        -19.02
        Axis    [ -0.6797  -0.6219   0.3888]
        Angle     43.9220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5690"
}

Galaxy "NGC 5691:UGC 9420:MCG 0-37-20:ZWG 19.73"
{
        Type  "SBa"
        RA           14.6314
        Dec          -0.3981
        Distance   9.404e+07  # method: V
        Radius     2.599e+04
        AbsMag           -20
        Axis    [ -0.2318  -0.7691  -0.5956]
        Angle     46.3421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5691"
}

Galaxy "NGC 5692:UGC 9427:MCG 1-37-39:ZWG 47.123"
{
        Type  "S0"
        RA           14.6383
        Dec           3.4100
        Distance   8.535e+07  # method: V
        Radius     1.117e+04
        AbsMag        -18.49
        Axis    [  0.6193  -0.6802  -0.3923]
        Angle     96.9246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5692"
}

Galaxy "NGC 5693:UGC 9406:MCG 8-27-6:ZWG 248.11"
{
        Type  "SBc"
        RA           14.6031
        Dec          48.5853
        Distance   1.089e+08  # method: V
        Radius     2.852e+04
        AbsMag        -18.42
        Axis    [  0.5471  -0.8368  -0.0189]
        Angle    134.2005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5693"
}

Galaxy "NGC 5695:UGC 9421:MCG 6-32-77:MK 686"
{
        Type  "SBa"
        RA           14.6228
        Dec          36.5678
        Distance   1.987e+08  # method: V
        Radius     4.335e+04
        AbsMag        -20.32
        Axis    [ -0.9093   0.1346   0.3938]
        Angle     23.2210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5695"
}

Galaxy "NGC 5696:UGC 9415:MCG 7-30-36:ZWG 220.36"
{
        Type  "Sc"
        RA           14.6158
        Dec          41.8283
        Distance   2.547e+08  # method: V
        Radius     7.408e+04
        AbsMag        -20.66
        Axis    [  0.5841  -0.8117   0.0017]
        Angle     88.8987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5696"
}

Galaxy "NGC 5697:IC 4471:UGC 9407:MCG 7-30-31"
{
        Type  "Sb"
        RA           14.6089
        Dec          41.6853
        Distance   2.517e+08  # method: V
        Radius     4.028e+04
        AbsMag        -19.74
        Axis    [  0.6721  -0.7400   0.0259]
        Angle    112.5031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5697"
}

Galaxy "NGC 5698:UGC 9419:MCG 7-30-38:ZWG 220.37"
{
        Type  "SBb"
        RA           14.6206
        Dec          38.4544
        Distance   1.723e+08  # method: V
        Radius     4.511e+04
        AbsMag        -19.71
        Axis    [  0.6468  -0.7170   0.2600]
        Angle     66.6649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5698"
}

Galaxy "NGC 5699:NGC 5706:MCG 5-35-2:ZWG 164.4"
{
        Type  "E0"
        RA           14.6450
        Dec          30.4658
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.0837  -0.7759  -0.6253]
        Angle     78.1036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5699"
}

Galaxy "NGC 5700:UGC 9423:MCG 8-27-7:ZWG 248.13"
{
        Type  "SBc"
        RA           14.6169
        Dec          48.5453
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7325  -0.6273   0.2645]
        Angle    101.3451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5700"
}

Galaxy "NGC 5701:UGC 9436:MCG 1-37-42:ZWG 47.127"
{
        Type  "SBa"
        RA           14.6531
        Dec           5.3636
        Distance   7.837e+07  # method: V
        Radius     4.901e+04
        AbsMag         -20.1
        Axis    [ -0.0238  -0.6681  -0.7437]
        Angle     70.1340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5701"
}

Galaxy "NGC 5702:UGC 9434:MCG 4-35-2:ZWG 134.7"
{
        Type  "S0"
        RA           14.6486
        Dec          20.5067
        Distance   2.543e+08  # method: V
        Radius     4.068e+04
        AbsMag        -20.06
        Axis    [ -0.9865  -0.1636  -0.0067]
        Angle     31.4205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5702"
}

Galaxy "NGC 5703:NGC 5709:UGC 9435:MCG 5-35-3"
{
        Type  "SBa"
        RA           14.6472
        Dec          30.4425
        Distance    1.76e+08  # method: V
        Radius     4.097e+04
        AbsMag        -19.16
        Axis    [  0.3561  -0.5832   0.7301]
        Angle     47.6840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5703"
}

Galaxy "NGC 5704:NGC 5708:UGC 9430:MCG 7-30-44"
{
        Type  "Irr"
        RA           14.6378
        Dec          40.4578
        Distance   1.294e+08  # method: V
        Radius     3.012e+04
        AbsMag        -19.09
        Axis    [ -0.7005   0.2716   0.6600]
        Angle     59.9801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5704"
}

Galaxy "NGC 5705:UGC 9447:MCG 0-37-21:ZWG 19.76"
{
        Type  "SBc"
        RA           14.6636
        Dec          -0.7183
        Distance   1.134e+08  # method: T-F
        Radius     4.947e+04
        AbsMag         -18.8
        Axis    [  0.3665  -0.8004  -0.4744]
        Angle     62.8794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5705"
}

Galaxy "NGC 5707-1:UGC 9428:MCG 9-24-23:ZWG 273.15"
{
        Type  "Sb"
        RA           14.6250
        Dec          51.5622
        Distance   1.052e+08  # method: V
        Radius     3.825e+04
        AbsMag        -19.14
        Axis    [  0.7868  -0.4885   0.3774]
        Angle    111.3084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5707-1"
}

Galaxy "NGC 5707-2:MCG 9-24-24:NPM 1"
{
        Type  "E0"
        RA           14.6264
        Dec          51.5836
        Distance   7.944e+08  # distance uncertain!
        Radius     3.466e+04
        AbsMag        -20.13
        Axis    [  0.2361  -0.9634  -0.1266]
        Angle    136.9851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5707-2"
}

Galaxy "NGC 5710:UGC 9440:MCG 3-37-32:ZWG 104.60"
{
        Type  "E0"
        RA           14.6544
        Dec          20.0436
        Distance   4.195e+08  # method: V
        Radius     7.322e+04
        AbsMag        -21.55
        Axis    [ -0.5736   0.1843  -0.7981]
        Angle     57.4493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5710"
}

Galaxy "NGC 5711:UGC 9445:MCG 3-37-33:ZWG 104.62"
{
        Type  "SBa"
        RA           14.6561
        Dec          19.9906
        Distance   4.179e+08  # method: V
        Radius     6.078e+04
        AbsMag        -20.54
        Axis    [  0.5394  -0.8332  -0.1220]
        Angle     60.1215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5711"
}

Galaxy "NGC 5712:MCG 13-10-21:ZWG 353.42:ZWG 354.5"
{
        Type  "S0"
        RA           14.4947
        Dec          78.8647
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.1707  -0.9782   0.1180]
        Angle    130.3004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5712"
}

Galaxy "NGC 5713:UGC 9451:MCG 0-37-22:ZWG 19.77"
{
        Type  "SBc"
        RA           14.6697
        Dec          -0.2900
        Distance   7.262e+07  # method: T-F
        Radius     3.063e+04
        AbsMag        -19.94
        Axis    [  0.5678  -0.6792  -0.4651]
        Angle    128.0566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5713"
}

Galaxy "NGC 5714:UGC 9431:MCG 8-27-11:ZWG 248.14"
{
        Type  "Sc"
        RA           14.6367
        Dec          46.6381
        Distance   1.073e+08  # method: V
        Radius     4.993e+04
        AbsMag        -18.48
        Axis    [  0.5992  -0.4256   0.6781]
        Angle     74.5846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5714"
}

Galaxy "NGC 5716:MCG 3-37-4:IRAS 14383-1715"
{
        Type  "SBc"
        RA           14.6847
        Dec         -17.4767
        Distance   1.969e+08  # method: V
        Radius     5.441e+04
        AbsMag         -20.2
        Axis    [  0.0859  -0.7153  -0.6935]
        Angle     67.4726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5716"
}

Galaxy "NGC 5717:MCG 8-27-12:ZWG 248.15:NPM 1"
{
        Type  "S0"
        RA           14.6436
        Dec          46.6636
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.6539  -0.7470   0.1201]
        Angle     99.6131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5717"
}

Galaxy "NGC 5718:UGC 9459:MCG 1-37-47:ZWG 47.137"
{
        Type  "S0"
        RA           14.6783
        Dec           3.4656
        Distance   3.851e+08  # method: V
        Radius     8.402e+04
        AbsMag        -21.16
        Axis    [ -0.3615  -0.7705  -0.5250]
        Angle     41.1457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5718"
}

Galaxy "NGC 5719:UGC 9462:MCG 0-37-24:ZWG 19.79"
{
        Type  "SBb"
        RA           14.6822
        Dec          -0.3178
        Distance   8.911e+07  # method: V
        Radius     4.147e+04
        AbsMag        -18.78
        Axis    [  0.0200  -0.9989  -0.0435]
        Angle     38.3027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5719"
}

Galaxy "NGC 5720:UGC 9439:MCG 9-24-25:ZWG 273.17"
{
        Type  "Sb"
        RA           14.6425
        Dec          50.8153
        Distance   3.577e+08  # method: V
        Radius     1.093e+05
        AbsMag         -20.5
        Axis    [ -0.2477   0.0632   0.9668]
        Angle     24.2930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5720"
}

Galaxy "NGC 5721:MCG 8-27-13:ZWG 248.16"
{
        Type  "S0"
        RA           14.6481
        Dec          46.6744
        Distance   3.217e+08  # distance uncertain!
        Radius     1.404e+04
        AbsMag        -19.07
        Axis    [ -0.3747  -0.0216   0.9269]
        Angle     22.3388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5721"
}

Galaxy "NGC 5722:MCG 8-27-14:ZWG 248.16:NPM 1"
{
        Type  "S0"
        RA           14.6483
        Dec          46.6661
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.2753  -0.9484  -0.1575]
        Angle    137.9637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5722"
}

Galaxy "NGC 5723:MCG 8-27-15:ZWG 248.16:NPM 1"
{
        Type  "S0"
        RA           14.6492
        Dec          46.6900
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.8126  -0.5675   0.1326]
        Angle    133.7490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5723"
}

Galaxy "NGC 5724:MCG 8-27-16"
{
        Type  "E0"
        RA           14.6506
        Dec          46.6922
        Distance   8.318e+08  # distance uncertain!
        Radius      1.21e+04
        AbsMag        -20.13
        Axis    [  0.2498  -0.9538  -0.1671]
        Angle    138.4714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5724"
}

Galaxy "NGC 5725:UGC 9466:MCG 0-37-25:ZWG 19.80"
{
        Type  "SBc"
        RA           14.6828
        Dec           2.1856
        Distance    8.39e+07  # method: V
        Radius     1.464e+04
        AbsMag        -17.65
        Axis    [  0.5902  -0.6940  -0.4123]
        Angle     92.8754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5725"
}

Galaxy "NGC 5726:ESO 580-12:MCG 3-37-6"
{
        Type  "S0"
        RA           14.7153
        Dec         -18.4442
        Distance   1.281e+08  # distance uncertain!
        Radius     2.421e+04
        AbsMag        -19.07
        Axis    [ -0.6550  -0.4936  -0.5721]
        Angle     62.6201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5726"
}

Galaxy "NGC 5727:UGC 9465:MCG 6-32-83:ZWG 192.52"
{
        Type  "Irr"
        RA           14.6739
        Dec          33.9889
        Distance   7.511e+07  # method: V
        Radius     2.513e+04
        AbsMag        -17.51
        Axis    [ -0.3984  -0.4122   0.8194]
        Angle     27.4303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5727"
}

Galaxy "NGC 5728:MCG 3-37-5:IRAS 14396-1702"
{
        Type  "Sb"
        RA           14.7067
        Dec         -17.2522
        Distance   1.368e+08  # method: V
        Radius     6.365e+04
        AbsMag        -20.91
        Axis    [  0.6187  -0.5543  -0.5567]
        Angle    101.4680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5728"
}

Galaxy "NGC 5729:MCG 1-37-12:IRAS 14394-0847"
{
        Type  "Sb"
        RA           14.7017
        Dec          -9.0097
        Distance   9.296e+07  # method: V
        Radius     3.515e+04
        AbsMag        -18.87
        Axis    [ -0.8381  -0.4590   0.2950]
        Angle     65.9328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5729"
}

Galaxy "NGC 5730:UGC 9456:MCG 7-30-46:ZWG 220.44"
{
        Type  "Irr"
        RA           14.6644
        Dec          42.7425
        Distance    1.21e+08  # method: V
        Radius     3.169e+04
        AbsMag        -18.25
        Axis    [  0.5607  -0.4661   0.6844]
        Angle     66.7101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5730"
}

Galaxy "NGC 5731:IC 1045:UGC 9460:MCG 7-30-47"
{
        Type  "Sc"
        RA           14.6692
        Dec          42.7792
        Distance   1.198e+08  # method: V
        Radius     2.787e+04
        AbsMag        -18.72
        Axis    [  0.2230  -0.3454   0.9116]
        Angle     51.9918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5731"
}

Galaxy "NGC 5732:UGC 9467:MCG 7-30-48:ZWG 220.46"
{
        Type  "Sc"
        RA           14.6772
        Dec          38.6381
        Distance   2.187e+08  # method: T-F
        Radius     4.453e+04
        AbsMag        -19.83
        Axis    [  0.7103  -0.6945   0.1143]
        Angle     94.8461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5732"
}

Galaxy "NGC 5733:MCG 0-38-1:ZWG 20.2"
{
        Type  "Sc"
        RA           14.7125
        Dec          -0.3514
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.7795  -0.5507  -0.2985]
        Angle     99.6236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5733"
}

Galaxy "NGC 5734:ESO 580-16:MCG 3-38-3:IRAS 14423-2039"
{
        Type  "S0"
        RA           14.7525
        Dec         -20.8703
        Distance   1.952e+08  # method: V
        Radius      4.26e+04
        AbsMag        -20.09
        Axis    [  0.5122  -0.5808  -0.6328]
        Angle     99.4931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5734"
}

Galaxy "NGC 5735:UGC 9481:MCG 5-35-7:ZWG 164.13"
{
        Type  "SBc"
        RA           14.7092
        Dec          28.7267
        Distance   1.776e+08  # method: V
        Radius       6.2e+04
        AbsMag        -20.18
        Axis    [  0.5474  -0.8144  -0.1926]
        Angle     94.5732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5735"
}

Galaxy "NGC 5736:MCG 2-38-1:ZWG 76.7"
{
        Type  "Sa"
        RA           14.7250
        Dec          11.2031
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.0431  -0.9648  -0.2593]
        Angle     36.5646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5736"
}

Galaxy "NGC 5737:UGC 9488:MCG 3-37-39:ZWG 105.7"
{
        Type  "SBb"
        RA           14.7200
        Dec          18.8806
        Distance   4.401e+08  # method: V
        Radius     8.322e+04
        AbsMag        -21.15
        Axis    [ -0.9638   0.0560   0.2608]
        Angle     48.7672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5737"
}

Galaxy "NGC 5738:MCG 0-38-2:ZWG 20.4"
{
        Type  "S0"
        RA           14.7322
        Dec           1.6036
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.7209  -0.6755  -0.1551]
        Angle     70.1692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5738"
}

Galaxy "NGC 5739:UGC 9486:MCG 7-30-52:ZWG 220.49"
{
        Type  "SBa"
        RA           14.7078
        Dec          41.8431
        Distance   2.591e+08  # method: V
        Radius     8.668e+04
        AbsMag         -21.3
        Axis    [  0.4844  -0.8670  -0.1166]
        Angle    135.8991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5739"
}

Galaxy "NGC 5740:UGC 9493:MCG 0-38-3:ZWG 20.8"
{
        Type  "SBb"
        RA           14.7400
        Dec           1.6800
        Distance   9.853e+07  # method: T-F
        Radius     4.013e+04
        AbsMag         -19.8
        Axis    [ -0.9412  -0.3154   0.1209]
        Angle     51.5979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5740"
}

Galaxy "NGC 5741:MCG 2-38-8:NPM 1"
{
        Type  "E0"
        RA           14.7642
        Dec         -11.9136
        Distance   2.884e+08  # distance uncertain!
        Radius     4.615e+04
        AbsMag        -20.13
        Axis    [  0.3718  -0.7190  -0.5872]
        Angle    158.2505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5741"
}

Galaxy "NGC 5742:MCG 2-38-7:IRAS 14428-1135"
{
        Type  "S0"
        RA           14.7600
        Dec         -11.8097
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.4651  -0.7868  -0.4058]
        Angle     60.1369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5742"
}

Galaxy "NGC 5743:ESO 580-17:MCG 3-38-4:IRAS 14423-2042"
{
        Type  "Sb"
        RA           14.7528
        Dec         -20.9131
        Distance   1.223e+08  # distance uncertain!
        Radius      2.49e+04
        AbsMag        -19.07
        Axis    [  0.0822  -0.8890  -0.4505]
        Angle     51.3944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5743"
}

Galaxy "NGC 5744:ESO 580-23:MCG 3-38-7:IRAS 14438-1818"
{
        Type  "Sb"
        RA           14.7772
        Dec         -18.5133
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [ -0.2836  -0.6980  -0.6575]
        Angle     60.8748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5744"
}

Galaxy "NGC 5745-1:MCG 2-38-4:VV 98:NPM 1"
{
        Type  "Sa"
        RA           14.7503
        Dec         -13.9467
        Distance    1.54e+08  # distance uncertain!
        Radius     3.807e+04
        AbsMag        -19.07
        Axis    [  0.1875  -0.7241  -0.6637]
        Angle     71.5019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5745-1"
}

Galaxy "NGC 5745-2:MCG 2-38-4:VV 98"
{
        Type  "E0"
        RA           14.7503
        Dec         -13.9489
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.3763  -0.7071  -0.5987]
        Angle    158.9246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5745-2"
}

Galaxy "NGC 5745-3:VV 98"
{
        Type  "E0"
        RA           14.7492
        Dec         -13.9650
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.3764  -0.7070  -0.5988]
        Angle    158.9239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5745-3"
}

Galaxy "NGC 5746:UGC 9499:MCG 0-38-5:ZWG 20.12"
{
        Type  "SBb"
        RA           14.7486
        Dec           1.9561
        Distance   1.058e+08  # method: T-F
        Radius     1.139e+05
        AbsMag        -21.25
        Axis    [ -0.7792  -0.3656   0.5091]
        Angle     68.4206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5746"
}

Galaxy "NGC 5747:IC 4493:UGC 9496:MCG 2-38-2"
{
        Type  "Sb"
        RA           14.7389
        Dec          12.1319
        Distance   1.612e+08  # distance uncertain!
        Radius     1.876e+04
        AbsMag        -19.07
        Axis    [  0.3548  -0.8325  -0.4255]
        Angle    148.2779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5747"
}

Galaxy "NGC 5748:ZWG 134.29:NPM 1"
{
        Type  "S0"
        RA           14.7514
        Dec          21.9167
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.9210  -0.2437   0.3041]
        Angle     32.2481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5748"
}

Galaxy "NGC 5750:UGC 9512:MCG 0-38-6:ZWG 20.13"
{
        Type  "SBa"
        RA           14.7694
        Dec          -0.2233
        Distance    8.58e+07  # method: V
        Radius     3.993e+04
        AbsMag         -19.6
        Axis    [  0.5561  -0.7686  -0.3162]
        Angle     66.7492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5750"
}

Galaxy "NGC 5751:UGC 9498:MCG 9-24-33:ZWG 273.24"
{
        Type  "Sc"
        RA           14.7303
        Dec          53.4006
        Distance   1.383e+08  # method: T-F
        Radius     3.016e+04
        AbsMag        -19.24
        Axis    [  0.6505  -0.6873   0.3232]
        Angle     86.7888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5751"
}

Galaxy "NGC 5752:MCG 7-30-60:ZWG 220.52"
{
        Type  "Sb"
        RA           14.7539
        Dec          38.7292
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.1239  -0.4995   0.8574]
        Angle     38.8314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5752"
}

Galaxy "NGC 5753:MCG 7-30-62:ZWG 220.53:NPM 1"
{
        Type  "S0"
        RA           14.7550
        Dec          38.8064
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.9484   0.2968   0.1115]
        Angle     22.1242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5753"
}

Galaxy "NGC 5754:UGC 9505:MCG 7-30-61:ZWG 220.52"
{
        Type  "SBb"
        RA           14.7553
        Dec          38.7328
        Distance   2.115e+08  # method: V
        Radius     6.153e+04
        AbsMag        -20.16
        Axis    [  0.4622  -0.8716  -0.1633]
        Angle    103.6442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5754"
}

Galaxy "NGC 5755:UGC 9507:MCG 7-30-63:ZWG 220.53"
{
        Type  "SBa"
        RA           14.7567
        Dec          38.7803
        Distance   4.418e+08  # method: V
        Radius     8.354e+04
        AbsMag        -21.36
        Axis    [  0.5939  -0.8007  -0.0783]
        Angle    119.8113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5755"
}

Galaxy "NGC 5756:MCG 2-38-12:IRAS 14448-1438"
{
        Type  "SBc"
        RA           14.7925
        Dec         -14.8533
        Distance   9.826e+07  # method: T-F
        Radius     4.001e+04
        AbsMag        -19.29
        Axis    [  0.4899  -0.7070  -0.5100]
        Angle     71.3828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5756"
}

Galaxy "NGC 5757:ESO 580-33:MCG 3-38-14:IRAS 14449-1852"
{
        Type  "SBb"
        RA           14.7961
        Dec         -19.0778
        Distance    1.31e+08  # method: V
        Radius         4e+04
        AbsMag        -20.22
        Axis    [ -0.9001  -0.2443  -0.3608]
        Angle     72.0440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5757"
}

Galaxy "NGC 5758:UGC 9524:MCG 2-38-11:ZWG 76.39"
{
        Type  "S0"
        RA           14.7839
        Dec          13.6678
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.9351  -0.1927  -0.2975]
        Angle     38.4881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5758"
}

Galaxy "NGC 5759:UGC 9525:MCG 2-38-12:ZWG 76.44"
{
        Type  "Irr"
        RA           14.7872
        Dec          13.4561
        Distance   3.312e+08  # distance uncertain!
        Radius     1.445e+04
        AbsMag        -20.13
        Axis    [ -0.6307  -0.7663  -0.1227]
        Angle     30.4635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5759"
}

Galaxy "NGC 5760:UGC 9531:MCG 3-38-15:ZWG 105.28"
{
        Type  "Sa"
        RA           14.7950
        Dec          18.5017
        Distance   2.767e+08  # method: V
        Radius     6.038e+04
        AbsMag        -20.44
        Axis    [  0.3656  -0.9188   0.1490]
        Angle     42.8853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5760"
}

Galaxy "NGC 5761:ESO 580-39:MCG 3-38-18"
{
        Type  "S0"
        RA           14.8189
        Dec         -20.3756
        Distance   1.266e+08  # method: T-F
        Radius     2.578e+04
        AbsMag        -19.54
        Axis    [ -0.2788  -0.5191  -0.8080]
        Angle     82.7220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5761"
}

Galaxy "NGC 5762:UGC 9535:MCG 2-38-14:ZWG 76.63"
{
        Type  "S0"
        RA           14.8117
        Dec          12.4572
        Distance   4.834e+07  # method: V
        Radius     1.055e+04
        AbsMag        -16.85
        Axis    [ -0.7840  -0.3501  -0.5126]
        Angle     38.9160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5762"
}

Galaxy "NGC 5763:ZWG 76.64:NPM 1"
{
        Type  "S0"
        RA           14.8161
        Dec          12.4906
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.3462  -0.8367  -0.4243]
        Angle    148.8593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5763"
}

Galaxy "NGC 5765:NGC 5765A:UGC 9554:MCG 1-38-5"
{
        Type  "Sb"
        RA           14.8475
        Dec           5.1147
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.0125  -0.9996   0.0258]
        Angle     38.3426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5765"
}

Galaxy "NGC 5765B:UGC 9554:MCG 1-38-4:KCPG 437A"
{
        Type  "Sc"
        RA           14.8472
        Dec           5.1197
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.3135  -0.9463   0.0787]
        Angle     44.2792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5765B"
}

Galaxy "NGC 5766:ESO 580-50:MCG 3-38-24:IRAS 14503-2111"
{
        Type  "SBc"
        RA           14.8858
        Dec         -21.3933
        Distance    1.47e+08  # distance uncertain!
        Radius     2.352e+04
        AbsMag        -19.07
        Axis    [ -0.8245  -0.4910  -0.2814]
        Angle     65.2472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5766"
}

Galaxy "NGC 5767:UGC 9549:ZWG 248.22"
{
        Type  "SBb"
        RA           14.8261
        Dec          47.3761
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.6782   0.3090   0.6667]
        Angle     20.0743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5767"
}

Galaxy "NGC 5768:UGC 9564:MCG 0-38-9:ZWG 20.26"
{
        Type  "Sc"
        RA           14.8686
        Dec          -2.5303
        Distance   9.821e+07  # method: V
        Radius     2.571e+04
        AbsMag        -18.89
        Axis    [ -0.4585  -0.6831  -0.5685]
        Angle     49.1675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5768"
}

Galaxy "NGC 5769:MCG 1-38-8:ZWG 48.47:ARAK 462"
{
        Type  "E0"
        RA           14.8781
        Dec           7.9325
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.3259  -0.8243  -0.4629]
        Angle    152.1663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5769"
}

Galaxy "NGC 5770:UGC 9575:MCG 1-38-11:ZWG 48.52"
{
        Type  "S0"
        RA           14.8872
        Dec           3.9608
        Distance   6.186e+07  # method: S
        Radius      1.53e+04
        AbsMag        -18.19
        Axis    [ -0.1942  -0.8231  -0.5337]
        Angle     47.1725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5770"
}

Galaxy "NGC 5771:MCG 5-35-21:ZWG 164.37:NPM 1"
{
        Type  "E0"
        RA           14.8706
        Dec          29.8458
        Distance   3.168e+08  # method: V
        Radius     3.687e+04
        AbsMag        -20.34
        Axis    [ -0.5453   0.2129  -0.8108]
        Angle     47.3479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5771"
}

Galaxy "NGC 5772:UGC 9566:MCG 7-31-1:ZWG 220.60"
{
        Type  "Sb"
        RA           14.8606
        Dec          40.5994
        Distance   2.289e+08  # method: V
        Radius     6.992e+04
        AbsMag        -20.53
        Axis    [  0.6476  -0.7606   0.0455]
        Angle    101.3862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5772"
}

Galaxy "NGC 5773:UGC 9571:MCG 5-35-22:ZWG 164.38"
{
        Type  "Sa"
        RA           14.8750
        Dec          29.8081
        Distance   3.215e+08  # method: V
        Radius     4.208e+04
        AbsMag        -20.57
        Axis    [  0.3022  -0.9063  -0.2954]
        Angle    144.6148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5773"
}

Galaxy "NGC 5774:UGC 9576:MCG 1-38-13:ZWG 48.57"
{
        Type  "SBc"
        RA           14.8950
        Dec           3.5828
        Distance   8.036e+07  # method: V
        Radius     3.507e+04
        AbsMag        -18.96
        Axis    [ -0.8638  -0.4022  -0.3035]
        Angle     44.4986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5774"
}

Galaxy "NGC 5775:UGC 9579:MCG 1-38-14:ZWG 48.60"
{
        Type  "SBc"
        RA           14.8992
        Dec           3.5450
        Distance   8.544e+07  # method: V
        Radius     4.971e+04
        AbsMag        -19.59
        Axis    [ -0.6466  -0.6000   0.4711]
        Angle     48.8674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5775"
}

Galaxy "NGC 5776:MCG 1-38-18:ZWG 48.67:NPM 1"
{
        Type  "S0"
        RA           14.9089
        Dec           2.9669
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.1030  -0.8224  -0.5595]
        Angle     51.6868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5776"
}

Galaxy "NGC 5777:UGC 9568:MCG 10-21-34:ZWG 296.18"
{
        Type  "Sb"
        RA           14.8547
        Dec          58.9778
        Distance   1.004e+08  # method: V
        Radius     4.526e+04
        AbsMag        -18.34
        Axis    [ -0.0719   0.0693   0.9950]
        Angle     67.9893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5777"
}

Galaxy "NGC 5778:NGC 5825:UGC 9590:MCG 3-38-50"
{
        Type  "E0"
        RA           14.9086
        Dec          18.6428
        Distance   3.981e+08  # distance uncertain!
        Radius     6.949e+04
        AbsMag        -20.13
        Axis    [  0.2723  -0.8647  -0.4221]
        Angle    140.4047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5778"
}

Galaxy "NGC 5779:MCG 9-24-48:ZWG 273.31:NPM 1"
{
        Type  "S0"
        RA           14.8692
        Dec          55.9000
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.2303  -0.9697  -0.0812]
        Angle    138.8570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5779"
}

Galaxy "NGC 5780:MCG 5-35-24:ZWG 164.41"
{
        Type  "Sb"
        RA           14.9061
        Dec          28.9400
        Distance   3.239e+08  # method: V
        Radius      4.24e+04
        AbsMag        -20.08
        Axis    [ -0.3657  -0.5178   0.7734]
        Angle     33.6987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5780"
}

Galaxy "NGC 5781:MCG 3-38-28:IRAS 14539-1702"
{
        Type  "SBb"
        RA           14.9447
        Dec         -17.2442
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.6280  -0.5565  -0.5440]
        Angle    105.6871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5781"
}

Galaxy "NGC 5782:UGC 9602:MCG 2-38-22:ZWG 76.99"
{
        Type  "S0"
        RA           14.9319
        Dec          11.8617
        Distance   4.461e+08  # method: V
        Radius     4.542e+04
        AbsMag        -20.98
        Axis    [  0.3355  -0.8377  -0.4308]
        Angle    150.0849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5782"
}

Galaxy "NGC 5783:NGC 5785:UGC 9586:MCG 9-24-50"
{
        Type  "SBc"
        RA           14.8911
        Dec          52.0767
        Distance   1.103e+08  # method: V
        Radius     4.651e+04
        AbsMag        -19.04
        Axis    [  0.6492  -0.7581   0.0621]
        Angle    138.4336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5783"
}

Galaxy "NGC 5784:UGC 9592:MCG 7-31-6:ZWG 221.9"
{
        Type  "S0"
        RA           14.9044
        Dec          42.5586
        Distance   2.533e+08  # method: V
        Radius     6.999e+04
        AbsMag        -21.05
        Axis    [  0.4235  -0.8958  -0.1347]
        Angle    138.8039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5784"
}

Galaxy "NGC 5786:ESO 327-37:MCG 7-31-4:IRAS 14556-4148"
{
        Type  "SBc"
        RA           14.9822
        Dec         -42.0144
        Distance   5.339e+07  # distance uncertain!
        Radius     1.786e+04
        AbsMag        -19.07
        Axis    [  0.2359  -0.5807  -0.7792]
        Angle     84.7914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5786"
}

Galaxy "NGC 5787:UGC 9599:MCG 7-31-8:ZWG 221.13"
{
        Type  "S0"
        RA           14.9208
        Dec          42.5072
        Distance   2.543e+08  # method: V
        Radius     3.699e+04
        AbsMag        -20.36
        Axis    [  0.4803  -0.8700  -0.1117]
        Angle    138.0873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5787"
}

Galaxy "NGC 5788:MCG 9-24-49:ZWG 273.32:NPM 1"
{
        Type  "S0"
        RA           14.8878
        Dec          52.0447
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6056  -0.7809   0.1534]
        Angle    100.5794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5788"
}

Galaxy "NGC 5789:UGC 9615:MCG 5-35-26:ZWG 164.43"
{
        Type  "SBc"
        RA           14.9431
        Dec          30.2333
        Distance   8.884e+07  # method: V
        Radius     1.163e+04
        AbsMag        -18.18
        Axis    [ -0.7110  -0.5362  -0.4550]
        Angle     23.1660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5789"
}

Galaxy "NGC 5790:UGC 9624:MCG 1-38-22:ZWG 48.76"
{
        Type  "Sa"
        RA           14.9597
        Dec           8.2853
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.1544  -0.8035  -0.5749]
        Angle     72.7149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5790"
}

Galaxy "NGC 5791:ESO 581-7:MCG 3-38-35"
{
        Type  "E6"
        RA           14.9794
        Dec         -19.2669
        Distance   1.266e+08  # method: T-F
        Radius     4.604e+04
        AbsMag        -20.24
        Axis    [ -0.7879   0.0732  -0.6115]
        Angle     92.5363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5791"
}

Galaxy "NGC 5792:UGC 9631:MCG 0-38-12:ZWG 20.38"
{
        Type  "SBb"
        RA           14.9728
        Dec          -1.0903
        Distance   8.276e+07  # method: T-F
        Radius     8.186e+04
        AbsMag        -19.92
        Axis    [  0.4803  -0.8771   0.0077]
        Angle     52.4486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5792"
}

Galaxy "NGC 5793:MCG 3-38-38:IRAS 14566-1629"
{
        Type  "Sb"
        RA           14.9900
        Dec         -16.6933
        Distance   1.674e+08  # method: V
        Radius      4.14e+04
        AbsMag        -19.25
        Axis    [ -0.7585  -0.6458   0.0875]
        Angle     60.6380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5793"
}

Galaxy "NGC 5794:UGC 9610:MCG 8-27-32:ZWG 248.27"
{
        Type  "S0"
        RA           14.9314
        Dec          49.7258
        Distance   1.947e+08  # method: V
        Radius     2.831e+04
        AbsMag        -19.48
        Axis    [  0.2443  -0.9604  -0.1337]
        Angle    140.7956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5794"
}

Galaxy "NGC 5795:UGC 9617:MCG 8-27-35:ZWG 248.29"
{
        Type  "Sc"
        RA           14.9386
        Dec          49.3986
        Distance   1.075e+08  # method: V
        Radius     2.502e+04
        AbsMag        -17.89
        Axis    [  0.6920  -0.4890   0.5311]
        Angle     91.2446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5795"
}

Galaxy "NGC 5796:MCG 3-38-39"
{
        Type  "E0"
        RA           14.9900
        Dec         -16.6236
        Distance   1.266e+08  # method: T-F
        Radius     4.604e+04
        AbsMag        -20.34
        Axis    [ -0.2348  -0.4684  -0.8517]
        Angle    105.8439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5796"
}

Galaxy "NGC 5797:UGC 9619:MCG 8-27-36:ZWG 248.30"
{
        Type  "Sa"
        RA           14.9397
        Dec          49.6956
        Distance    1.85e+08  # method: V
        Radius     4.305e+04
        AbsMag        -20.07
        Axis    [  0.3713  -0.6532   0.6598]
        Angle     39.0750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5797"
}

Galaxy "NGC 5798:UGC 9628:MCG 5-35-28:ZWG 164.47"
{
        Type  "Irr"
        RA           14.9603
        Dec          29.9681
        Distance   1.901e+08  # method: T-F
        Radius     3.871e+04
        AbsMag        -20.23
        Axis    [  0.6151  -0.7848  -0.0763]
        Angle     93.5538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5798"
}

Galaxy "NGC 5799:ESO 67-6:FAIR 164:AM 1500-721"
{
        Type  "Sa"
        RA           15.0931
        Dec         -72.4328
        Distance   1.446e+08  # method: V
        Radius     1.893e+04
        AbsMag        -18.93
        Axis    [ -0.6237  -0.4402  -0.6460]
        Angle    116.7722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5799"
}

Galaxy "NGC 5801:NPM 1"
{
        Type  "Sb"
        RA           15.0069
        Dec         -13.9036
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.3903  -0.6884  -0.6114]
        Angle     91.3932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5801"
}

Galaxy "NGC 5802:NPM 1"
{
        Type  "S0"
        RA           15.0081
        Dec         -13.9183
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.0759  -0.8488  -0.5232]
        Angle     59.0381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5802"
}

Galaxy "NGC 5803:NPM 1"
{
        Type  "S0"
        RA           15.0094
        Dec         -13.8939
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.2309  -0.6934  -0.6826]
        Angle     92.1992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5803"
}

Galaxy "NGC 5804:UGC 9627:MCG 8-27-38:ZWG 248.32"
{
        Type  "SBb"
        RA           14.9517
        Dec          49.6686
        Distance   1.904e+08  # method: V
        Radius     3.322e+04
        AbsMag        -19.93
        Axis    [  0.4412  -0.8955  -0.0581]
        Angle    138.7305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5804"
}

Galaxy "NGC 5805"
{
        Type  "E0"
        RA           14.9531
        Dec          49.6286
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.2328  -0.0079  -0.9725]
        Angle     28.4871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5805"
}

Galaxy "NGC 5806:UGC 9645:MCG 0-38-14:ZWG 20.41"
{
        Type  "SBb"
        RA           15.0000
        Dec           1.8908
        Distance   9.196e+07  # method: T-F
        Radius      4.28e+04
        AbsMag        -19.75
        Axis    [ -0.9346  -0.2517   0.2515]
        Angle     60.4489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5806"
}

Galaxy "NGC 5807:MCG 11-18-16:MK 832:ZWG 318.9"
{
        Type  "E0"
        RA           14.9300
        Dec          63.9039
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.1753  -0.9843  -0.0228]
        Angle    138.3942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5807"
}

Galaxy "NGC 5808:NGC 5819:UGC 9609:ZWG 337.23"
{
        Type  "SBc"
        RA           14.9006
        Dec          73.1319
        Distance   3.302e+08  # method: V
        Radius     4.322e+04
        AbsMag        -20.73
        Axis    [  0.1721  -0.9828   0.0671]
        Angle    136.6913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5808"
}

Galaxy "NGC 5809:MCG 2-38-25:IRAS 14581-1358"
{
        Type  "Sa"
        RA           15.0144
        Dec         -14.1653
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.7765  -0.6250  -0.0798]
        Angle     56.4101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5809"
}

Galaxy "NGC 5810:ESO 581-18:MCG 3-38-46:IRAS 14598-1740"
{
        Type  "SBb"
        RA           15.0450
        Dec         -17.8683
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [  0.5298  -0.6058  -0.5935]
        Angle    105.5777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5810"
}

Galaxy "NGC 5811:MCG 0-38-15:ZWG 20.43:KCPG 450"
{
        Type  "Irr"
        RA           15.0075
        Dec           1.6233
        Distance   7.765e+07  # method: V
        Radius     1.129e+04
        AbsMag        -17.18
        Axis    [ -0.0095  -0.8842  -0.4670]
        Angle     52.0377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5811"
}

Galaxy "NGC 5812:MCG 1-38-16:UGCA 398"
{
        Type  "E0"
        RA           15.0153
        Dec          -7.4575
        Distance   8.779e+07  # method: S
        Radius     2.937e+04
        AbsMag        -19.95
        Axis    [ -0.5496  -0.2139  -0.8076]
        Angle     83.0674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5812"
}

Galaxy "NGC 5813:UGC 9655:MCG 0-38-16:ZWG 20.45"
{
        Type  "E1"
        RA           15.0197
        Dec           1.7019
        Distance   1.051e+08  # method: S
        Radius     6.112e+04
        AbsMag        -21.04
        Axis    [ -0.6432  -0.0531  -0.7639]
        Angle     72.0677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5813"
}

Galaxy "NGC 5814:MCG 0-38-17:ZWG 20.46:IRAS 14588+0149"
{
        Type  "Sb"
        RA           15.0225
        Dec           1.6372
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.6486  -0.6717  -0.3578]
        Angle     99.1914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5814"
}

Galaxy "NGC 5815:MCG 3-38-44:IRAS 14576-1638"
{
        Type  "Sb"
        RA           15.0081
        Dec         -16.8339
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6595  -0.5466  -0.5161]
        Angle    103.1741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5815"
}

Galaxy "NGC 5816"
{
        Type  "S0"
        RA           15.0011
        Dec         -16.0936
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.0420  -0.8208  -0.5697]
        Angle     59.8579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5816"
}

Galaxy "NGC 5817:MCG 3-38-41:NPM 1"
{
        Type  "S0"
        RA           14.9944
        Dec         -16.1806
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.5554  -0.5936  -0.5823]
        Angle    123.5856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5817"
}

Galaxy "NGC 5818:UGC 9643:MCG 8-27-46:ZWG 248.39"
{
        Type  "S0"
        RA           14.9828
        Dec          49.8219
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.6350   0.5719   0.5193]
        Angle     37.1420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5818"
}

Galaxy "NGC 5820:UGC 9642:MCG 9-25-1:ZWG 273.38"
{
        Type  "S0"
        RA           14.9775
        Dec          53.8858
        Distance    1.55e+08  # method: V
        Radius      2.93e+05
        AbsMag        -20.08
        Axis    [  0.5514  -0.4009   0.7316]
        Angle     80.4740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5820"
}

Galaxy "NGC 5821:UGC 9648:MCG 9-25-2:ZWG 273.39"
{
        Type  "S0"
        RA           14.9831
        Dec          53.9233
        Distance    1.57e+08  # method: V
        Radius     3.196e+04
        AbsMag        -18.81
        Axis    [ -0.2329   0.1167   0.9655]
        Angle     36.5563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5821"
}

Galaxy "NGC 5826:NGC 5870:UGC 9725:MCG 9-25-16"
{
        Type  "S0"
        RA           15.1092
        Dec          55.4792
        Distance   2.555e+08  # distance uncertain!
        Radius      4.46e+04
        AbsMag        -19.07
        Axis    [  0.5463  -0.8319   0.0972]
        Angle    116.7343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5826"
}

Galaxy "NGC 5827:UGC 9662:MCG 4-35-24:ZWG 134.66"
{
        Type  "S0"
        RA           15.0314
        Dec          25.9642
        Distance   3.058e+08  # method: V
        Radius     4.893e+04
        AbsMag        -21.06
        Axis    [ -0.6909  -0.7083   0.1445]
        Angle     24.7133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5827"
}

Galaxy "NGC 5828:NGC 5828B:UGC 9658:MCG 8-27-51"
{
        Type  "Sc"
        RA           15.0125
        Dec          49.9933
        Distance    1.54e+08  # distance uncertain!
        Radius     1.344e+04
        AbsMag        -19.07
        Axis    [  0.4836  -0.8747   0.0330]
        Angle     89.4597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5828"
}

Galaxy "NGC 5828A:MCG 8-27-52:ZWG 248.43:IRAS 14591+5011"
{
        Type  "Sb"
        RA           15.0125
        Dec          49.9831
        Distance   5.098e+08  # distance uncertain!
        Radius     2.225e+04
        AbsMag        -19.07
        Axis    [  0.4990  -0.7757   0.3864]
        Angle     54.2236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5828A"
}

Galaxy "NGC 5829:UGC 9673:MCG 4-35-27:ZWG 134.70"
{
        Type  "Sc"
        RA           15.0450
        Dec          23.3333
        Distance   2.657e+08  # method: V
        Radius     6.569e+04
        AbsMag        -20.75
        Axis    [  0.4046  -0.8536  -0.3281]
        Angle     96.2038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5829"
}

Galaxy "NGC 5830:UGC 9670:MCG 8-27-56:ZWG 248.47"
{
        Type  "Sb"
        RA           15.0308
        Dec          47.8758
        Distance   3.925e+08  # method: V
        Radius     5.709e+04
        AbsMag         -20.3
        Axis    [ -0.6538   0.4770   0.5874]
        Angle     39.2603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5830"
}

Galaxy "NGC 5831:UGC 9678:MCG 0-38-20:ZWG 20.54"
{
        Type  "E3"
        RA           15.0683
        Dec           1.2200
        Distance    8.86e+07  # method: S
        Radius     2.706e+04
        AbsMag        -19.67
        Axis    [  0.0532  -0.7111  -0.7010]
        Angle    113.8680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5831"
}

Galaxy "NGC 5832:UGC 9649:MCG 12-14-15:ZWG 337.25"
{
        Type  "SBb"
        RA           14.9625
        Dec          71.6814
        Distance   2.184e+07  # method: V
        Radius     1.143e+04
        AbsMag        -16.13
        Axis    [  0.5877  -0.7051   0.3967]
        Angle    104.6971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5832"
}

Galaxy "NGC 5833:ESO 42-3:FAIR 840:IRAS 15066-7240"
{
        Type  "Sc"
        RA           15.1983
        Dec         -72.8589
        Distance   1.347e+08  # method: T-F
        Radius     4.114e+04
        AbsMag        -20.28
        Axis    [ -0.5606  -0.6146  -0.5549]
        Angle    102.7484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5833"
}

Galaxy "NGC 5835:UGC 9674:MCG 8-27-57:ZWG 248.48"
{
        Type  "Sa"
        RA           15.0403
        Dec          48.8781
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.6967   0.5157   0.4987]
        Angle     25.0334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5835"
}

Galaxy "NGC 5836:UGC 9664:MCG 12-14-16:ZWG 337.26"
{
        Type  "SBb"
        RA           14.9919
        Dec          73.8931
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.4774  -0.8278   0.2947]
        Angle     99.1359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5836"
}

Galaxy "NGC 5837:UGC 9686:MCG 2-38-36:ZWG 76.144"
{
        Type  "SBc"
        RA           15.0778
        Dec          12.6339
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.6568  -0.7053  -0.2667]
        Angle    107.9038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5837"
}

Galaxy "NGC 5838:UGC 9692:MCG 0-38-22:ZWG 20.57"
{
        Type  "S0"
        RA           15.0906
        Dec           2.0989
        Distance   7.053e+07  # method: V
        Radius     4.309e+04
        AbsMag        -19.77
        Axis    [  0.7086  -0.6663  -0.2322]
        Angle     85.7933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5838"
}

Galaxy "NGC 5839:UGC 9693:MCG 0-38-23:ZWG 20.58"
{
        Type  "S0"
        RA           15.0908
        Dec           1.6344
        Distance    7.37e+07  # method: S
        Radius     1.393e+04
        AbsMag        -18.07
        Axis    [  0.3531  -0.7602  -0.5454]
        Angle    113.0871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5839"
}

Galaxy "NGC 5842:MCG 4-36-3:ZWG 135.5"
{
        Type  "E0"
        RA           15.0811
        Dec          21.0703
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.2785  -0.8858  -0.3713]
        Angle    150.0805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5842"
}

Galaxy "NGC 5843:ESO 387-4:MCG 6-33-13:IRAS 15043-3608"
{
        Type  "SBb"
        RA           15.1242
        Dec         -36.3283
        Distance   1.889e+08  # method: T-F
        Radius      5.22e+04
        AbsMag        -20.71
        Axis    [  0.1487  -0.6491  -0.7460]
        Angle     82.3533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5843"
}

Galaxy "NGC 5845:UGC 9700:MCG 0-38-24:ZWG 20.59"
{
        Type  "E0"
        RA           15.1000
        Dec           1.6336
        Distance   8.461e+07  # method: S
        Radius          8615
        AbsMag        -18.57
        Axis    [ -0.6869  -0.0037  -0.7267]
        Angle     71.6654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5845"
}

Galaxy "NGC 5846:UGC 9706:MCG 0-38-25:ZWG 20.61"
{
        Type  "E0"
        RA           15.1081
        Dec           1.6053
        Distance   8.118e+07  # method: S
        Radius     4.723e+04
        AbsMag        -20.88
        Axis    [  0.1215  -0.7469  -0.6537]
        Angle    123.3766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5846"
}

Galaxy "NGC 5846A:MCG 0-38-26"
{
        Type  "S0"
        RA           15.1081
        Dec           1.5944
        Distance   1.104e+08  # method: V
        Radius          8025
        AbsMag        -18.85
        Axis    [  0.5704  -0.7273  -0.3817]
        Angle     92.2350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5846A"
}

Galaxy "NGC 5847:MCG 1-38-30:ZWG 48.120:IRAS 15039+0633"
{
        Type  "Sc"
        RA           15.1061
        Dec           6.3797
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.9399  -0.2516   0.2310]
        Angle     53.4908
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5847"
}

Galaxy "NGC 5848:NGC 5841:MCG 0-39-1:ZWG 21.1"
{
        Type  "Sa"
        RA           15.1094
        Dec           2.0050
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.6829  -0.6398   0.3526]
        Angle     48.3693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5848"
}

Galaxy "NGC 5849:MCG 2-38-35:NPM 1"
{
        Type  "S0"
        RA           15.1139
        Dec         -14.5711
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.3804  -0.6644  -0.6433]
        Angle    119.3437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5849"
}

Galaxy "NGC 5850:UGC 9715:MCG 0-39-2:ZWG 21.6"
{
        Type  "SBb"
        RA           15.1186
        Dec           1.5442
        Distance   1.242e+08  # method: V
        Radius      8.13e+04
        AbsMag         -21.3
        Axis    [ -0.7716  -0.4157  -0.4814]
        Angle     50.3220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5850"
}

Galaxy "NGC 5851:UGC 9714:MCG 2-38-44:ZWG 77.8"
{
        Type  "Sc"
        RA           15.1147
        Dec          12.8581
        Distance    3.02e+08  # method: V
        Radius     4.392e+04
        AbsMag        -19.83
        Axis    [  0.7536  -0.6544  -0.0630]
        Angle     88.1207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5851"
}

Galaxy "NGC 5852:MCG 2-38-45:ZWG 77.10:NPM 1"
{
        Type  "S0"
        RA           15.1156
        Dec          12.8475
        Distance   3.128e+08  # method: V
        Radius     5.005e+04
        AbsMag        -20.41
        Axis    [ -0.3901  -0.9049   0.1701]
        Angle     35.1667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5852"
}

Galaxy "NGC 5853:UGC 9707:MCG 7-31-30:ZWG 221.27"
{
        Type  "SBb"
        RA           15.0981
        Dec          39.5228
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [ -0.5809  -0.1005   0.8077]
        Angle     31.6592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5853"
}

Galaxy "NGC 5854:UGC 9726:MCG 1-39-1:ZWG 49.9"
{
        Type  "SBa"
        RA           15.1297
        Dec           2.5686
        Distance   8.698e+07  # method: V
        Radius     3.416e+04
        AbsMag        -19.33
        Axis    [  0.6860  -0.7132  -0.1443]
        Angle     75.3828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5854"
}

Galaxy "NGC 5855:ZWG 49.10:NPM 1"
{
        Type  "E0"
        RA           15.1300
        Dec           3.9847
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.3065  -0.8134  -0.4943]
        Angle    155.5352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5855"
}

Galaxy "NGC 5857:UGC 9724:MCG 3-39-4:ZWG 106.5"
{
        Type  "SBb"
        RA           15.1242
        Dec          19.5983
        Distance   2.198e+08  # method: V
        Radius     3.835e+04
        AbsMag        -20.34
        Axis    [ -0.5507  -0.6642   0.5055]
        Angle     34.8959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5857"
}

Galaxy "NGC 5858:MCG 2-39-2"
{
        Type  "E6"
        RA           15.1469
        Dec         -11.2081
        Distance   1.995e+08  # distance uncertain!
        Radius     4.353e+04
        AbsMag        -20.13
        Axis    [ -0.6135  -0.1780  -0.7694]
        Angle     85.4804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5858"
}

Galaxy "NGC 5859:UGC 9728:MCG 3-39-5:ZWG 106.7"
{
        Type  "SBc"
        RA           15.1261
        Dec          19.5819
        Distance   2.232e+08  # method: V
        Radius     9.741e+04
        AbsMag        -20.88
        Axis    [ -0.3207  -0.5782   0.7502]
        Angle     45.9777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5859"
}

Galaxy "NGC 5860:UGC 9717:MCG 7-31-33:MK 480"
{
        Type  "S0"
        RA           15.1092
        Dec          42.6419
        Distance   2.499e+08  # method: V
        Radius     3.271e+04
        AbsMag        -20.22
        Axis    [  0.5375  -0.8423  -0.0395]
        Angle    109.3795
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5860"
}

Galaxy "NGC 5861:MCG 2-39-3:IRAS 15065-1107"
{
        Type  "SBc"
        RA           15.1544
        Dec         -11.3222
        Distance   1.155e+08  # method: T-F
        Radius     5.038e+04
        AbsMag        -20.44
        Axis    [ -0.8727  -0.4880  -0.0173]
        Angle     60.2507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5861"
}

Galaxy "NGC 5862:ZWG 274.15:NPM 1"
{
        Type  "E0"
        RA           15.1008
        Dec          55.5744
        Distance   5.249e+08  # distance uncertain!
        Radius     3.817e+04
        AbsMag        -20.13
        Axis    [  0.1895  -0.9774  -0.0940]
        Angle    142.1634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5862"
}

Galaxy "NGC 5863:ESO 581-22:MCG 3-39-1:NPM 1"
{
        Type  "SBa"
        RA           15.1800
        Dec         -18.4311
        Distance   2.003e+08  # method: V
        Radius     4.078e+04
        AbsMag        -20.44
        Axis    [  0.3900  -0.6421  -0.6600]
        Angle    118.3374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5863"
}

Galaxy "NGC 5864:UGC 9740:MCG 1-39-2:ZWG 49.15"
{
        Type  "S0"
        RA           15.1592
        Dec           3.0533
        Distance   9.142e+07  # method: V
        Radius     3.723e+04
        AbsMag        -19.34
        Axis    [  0.5875  -0.8022  -0.1059]
        Angle     65.9827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5864"
}

Galaxy "NGC 5865:NGC 5868:UGC 9743:MCG 0-39-7"
{
        Type  "S0"
        RA           15.1636
        Dec           0.5303
        Distance   5.392e+08  # method: V
        Radius     8.627e+04
        AbsMag        -20.99
        Axis    [ -0.9676   0.0550  -0.2464]
        Angle     63.7194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5865"
}

Galaxy "M 102:NGC 5866:UGC 9723:MCG 9-25-17"
{
        Type  "Sa"
        RA           15.1081
        Dec          55.7636
        Distance   5.005e+07  # method: S
        Radius     4.732e+04
        AbsMag        -20.13
        Axis    [  0.1619  -0.2476   0.9552]
        Angle     45.5616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=M 102"
}

Galaxy "NGC 5866A"
{
        Type  "E0"
        RA           15.0878
        Dec          55.8275
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.1896  -0.9776  -0.0918]
        Angle    141.9470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5866A"
}

Galaxy "NGC 5866B:UGC 9769:MCG 9-25-34:ZWG 274.33"
{
        Type  "SBc"
        RA           15.2019
        Dec          55.7853
        Distance   4.159e+07  # method: V
        Radius     1.633e+04
        AbsMag        -15.33
        Axis    [  0.5696  -0.8154   0.1037]
        Angle    123.1637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5866B"
}

Galaxy "NGC 5867"
{
        Type  "E0"
        RA           15.1067
        Dec          55.7317
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.1886  -0.9777  -0.0927]
        Angle    142.2089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5867"
}

Galaxy "NGC 5869:UGC 9742:MCG 0-39-6:ZWG 21.22"
{
        Type  "S0"
        RA           15.1636
        Dec           0.4703
        Distance   8.118e+07  # method: S
        Radius     2.716e+04
        AbsMag        -19.08
        Axis    [ -0.5357  -0.7807  -0.3218]
        Angle     44.8119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5869"
}

Galaxy "NGC 5872:MCG 2-39-5:NPM 1"
{
        Type  "S0"
        RA           15.1819
        Dec         -11.4794
        Distance   1.938e+08  # distance uncertain!
        Radius     4.229e+04
        AbsMag        -19.07
        Axis    [  0.6809  -0.5483  -0.4856]
        Angle    124.7706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5872"
}

Galaxy "NGC 5874:UGC 9736:MCG 9-25-24:ZWG 274.20"
{
        Type  "SBc"
        RA           15.1308
        Dec          54.7528
        Distance   1.454e+08  # method: V
        Radius     4.863e+04
        AbsMag        -20.04
        Axis    [  0.5593  -0.8031   0.2055]
        Angle     90.5925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5874"
}

Galaxy "NGC 5875:UGC 9745:MCG 9-25-27:ZWG 274.27"
{
        Type  "Sb"
        RA           15.1536
        Dec          52.5281
        Distance   1.452e+08  # method: T-F
        Radius     4.858e+04
        AbsMag        -19.94
        Axis    [ -0.1656  -0.0288   0.9858]
        Angle     39.7546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5875"
}

Galaxy "NGC 5875A:UGC 9741:MCG 9-25-26:ZWG 274.23"
{
        Type  "S0"
        RA           15.1425
        Dec          52.2961
        Distance   1.159e+08  # method: V
        Radius          8427
        AbsMag        -18.55
        Axis    [  0.2214  -0.9686  -0.1132]
        Angle    142.9750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5875A"
}

Galaxy "NGC 5876:IC 1111:UGC 9747:MCG 9-25-28"
{
        Type  "SBb"
        RA           15.1586
        Dec          54.5064
        Distance   1.168e+08  # distance uncertain!
        Radius     4.077e+04
        AbsMag        -19.07
        Axis    [  0.6411  -0.7056   0.3017]
        Angle     97.3875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5876"
}

Galaxy "NGC 5878:MCG 2-39-6:UGCA 403:IRAS 15109-1405"
{
        Type  "Sb"
        RA           15.2292
        Dec         -14.2703
        Distance   1.046e+08  # method: T-F
        Radius     5.322e+04
        AbsMag        -20.03
        Axis    [  0.7736  -0.4421  -0.4539]
        Angle    122.1332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5878"
}

Galaxy "NGC 5879:UGC 9753:MCG 10-22-1:ZWG 297.4"
{
        Type  "Sc"
        RA           15.1628
        Dec          57.0006
        Distance   4.893e+07  # method: T-F
        Radius     2.989e+04
        AbsMag        -18.68
        Axis    [  0.7531  -0.6334   0.1779]
        Angle    140.3832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5879"
}

Galaxy "NGC 5880:MCG 2-39-12:NPM 1"
{
        Type  "S0"
        RA           15.2503
        Dec         -14.5783
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.7050  -0.4704  -0.5307]
        Angle     65.7102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5880"
}

Galaxy "NGC 5881:IC 1100:UGC 9729:MCG 11-18-25"
{
        Type  "S0"
        RA           15.1056
        Dec          62.9806
        Distance   2.997e+08  # method: V
        Radius     3.487e+04
        AbsMag        -20.62
        Axis    [  0.4497  -0.8768   0.1701]
        Angle     82.3083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5881"
}

Galaxy "NGC 5883:MCG 2-39-14:NPM 1"
{
        Type  "S0"
        RA           15.2528
        Dec         -14.6164
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.4512  -0.8324  -0.3218]
        Angle     54.1300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5883"
}

Galaxy "NGC 5885:MCG 2-39-13:IRAS 15123-0954"
{
        Type  "SBc"
        RA           15.2511
        Dec         -10.0858
        Distance   9.907e+07  # method: V
        Radius     5.043e+04
        AbsMag        -19.91
        Axis    [  0.1309  -0.7256  -0.6756]
        Angle     92.4025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5885"
}

Galaxy "NGC 5886:ZWG 221.36"
{
        Type  "S0"
        RA           15.2125
        Dec          41.2339
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.5248  -0.7229   0.4495]
        Angle     62.4109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5886"
}

Galaxy "NGC 5887:UGC 9779:MCG 0-39-12:ZWG 21.56"
{
        Type  "Sa"
        RA           15.2453
        Dec           1.1547
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.9581  -0.1936  -0.2112]
        Angle     54.9003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5887"
}

Galaxy "NGC 5888:UGC 9771:MCG 7-31-38:ZWG 221.37"
{
        Type  "SBc"
        RA           15.2186
        Dec          41.2644
        Distance    4.01e+08  # method: V
        Radius     7.583e+04
        AbsMag        -21.25
        Axis    [ -0.6345   0.0636   0.7703]
        Angle     35.4254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5888"
}

Galaxy "NGC 5889"
{
        Type  "SBb"
        RA           15.2208
        Dec          41.3278
        Distance   3.694e+08  # distance uncertain!
        Radius     4.835e+04
        AbsMag        -19.07
        Axis    [  0.7313  -0.6536   0.1952]
        Angle    104.3159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5889"
}

Galaxy "NGC 5890:MCG 3-39-4:NPM 1:IRAS 15150-1724"
{
        Type  "Sa"
        RA           15.2975
        Dec         -17.5886
        Distance   1.168e+08  # distance uncertain!
        Radius     2.208e+04
        AbsMag        -19.07
        Axis    [ -0.0380  -0.7418  -0.6695]
        Angle     76.2523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5890"
}

Galaxy "NGC 5891:MCG 2-39-15:IRAS 15134-1118"
{
        Type  "Sc"
        RA           15.2703
        Dec         -11.4939
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.8618  -0.4999  -0.0865]
        Angle     59.9477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5891"
}

Galaxy "NGC 5892:MCG 2-39-7::NPM 1"
{
        Type  "SBc"
        RA           15.2300
        Dec         -15.4642
        Distance   1.122e+08  # method: V
        Radius     5.875e+04
        AbsMag        -19.98
        Axis    [ -0.3006  -0.6963  -0.6517]
        Angle     68.0652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5892"
}

Galaxy "NGC 5893:UGC 9774:MCG 7-31-42:ZWG 221.41"
{
        Type  "SBb"
        RA           15.2261
        Dec          41.9592
        Distance   2.488e+08  # method: V
        Radius     4.343e+04
        AbsMag        -20.41
        Axis    [  0.4022  -0.9043  -0.1431]
        Angle    112.1448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5893"
}

Galaxy "NGC 5894:UGC 9768:MCG 10-22-4:ZWG 297.6"
{
        Type  "Irr"
        RA           15.1944
        Dec          59.8086
        Distance   1.594e+08  # method: T-F
        Radius     6.956e+04
        AbsMag        -20.14
        Axis    [  0.7886  -0.5549   0.2650]
        Angle    138.8680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5894"
}

Galaxy "NGC 5895:MCG 7-31-43:ZWG 221.42"
{
        Type  "Sc"
        RA           15.2306
        Dec          42.0078
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.8069  -0.5681   0.1622]
        Angle    121.8098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5895"
}

Galaxy "NGC 5896:MCG 7-31-44:ZWG 221.42:NPM 1"
{
        Type  "S0"
        RA           15.2306
        Dec          42.0250
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.5010  -0.8483   0.1714]
        Angle     67.0614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5896"
}

Galaxy "NGC 5898:ESO 514-2:MCG 4-36-6:UGCA 404"
{
        Type  "E0"
        RA           15.3036
        Dec         -24.0975
        Distance   9.494e+07  # method: S
        Radius     3.728e+04
        AbsMag        -19.92
        Axis    [  0.0659  -0.6104  -0.7894]
        Angle    138.6238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5898"
}

Galaxy "NGC 5899:UGC 9789:MCG 7-31-45:ZWG 221.43"
{
        Type  "SBc"
        RA           15.2508
        Dec          42.0497
        Distance   1.211e+08  # method: V
        Radius     5.812e+04
        AbsMag        -20.35
        Axis    [  0.7248  -0.6856   0.0676]
        Angle    122.7210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5899"
}

Galaxy "NGC 5900:UGC 9790:MCG 7-31-46:ZWG 221.44"
{
        Type  "Sb"
        RA           15.2514
        Dec          42.2094
        Distance   1.188e+08  # method: V
        Radius     2.937e+04
        AbsMag        -17.91
        Axis    [  0.0100  -0.3489   0.9371]
        Angle     51.6267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5900"
}

Galaxy "NGC 5902:MCG 8-28-11:ZWG 274.35"
{
        Type  "S0"
        RA           15.2394
        Dec          50.3303
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [  0.2667  -0.9637   0.0093]
        Angle     37.9119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5902"
}

Galaxy "NGC 5903:ESO 514-4:MCG 4-36-8:UGCA 405"
{
        Type  "E2"
        RA           15.3100
        Dec         -24.0683
        Distance   1.105e+08  # method: S
        Radius      4.34e+04
        AbsMag        -20.45
        Axis    [ -0.8483   0.0744  -0.5243]
        Angle     95.9406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5903"
}

Galaxy "NGC 5905:UGC 9797:MCG 9-25-38:ZWG 274.36"
{
        Type  "SBb"
        RA           15.2564
        Dec          55.5178
        Distance   1.568e+08  # method: V
        Radius     9.121e+04
        AbsMag        -20.51
        Axis    [  0.0591  -0.2579   0.9643]
        Angle     32.8026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5905"
}

Galaxy "NGC 5907:UGC 9801:MCG 9-25-40:IRAS 15146+5629"
{
        Type  "Sc"
        RA           15.2647
        Dec          56.3303
        Distance   6.714e+07  # method: T-F
        Radius      1.23e+05
        AbsMag        -20.46
        Axis    [ -0.1775   0.0658   0.9819]
        Angle     69.9261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5907"
}

Galaxy "NGC 5908:UGC 9805:MCG 9-25-41:ZWG 274.39"
{
        Type  "Sb"
        RA           15.2786
        Dec          55.4094
        Distance   1.531e+08  # method: V
        Radius     7.349e+04
        AbsMag        -20.56
        Axis    [ -0.2158   0.0988   0.9714]
        Angle     50.3499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5908"
}

Galaxy "NGC 5909:UGC 9778:MCG 13-11-10:ZWG 354.21"
{
        Type  "Sc"
        RA           15.1908
        Dec          75.3844
        Distance     3.2e+08  # method: V
        Radius      5.12e+04
        AbsMag        -20.16
        Axis    [  0.6144  -0.6049   0.5066]
        Angle    108.7262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5909"
}

Galaxy "NGC 5910-1:MCG 4-36-35:ZWG 135.45:VV 139"
{
        Type  "S0"
        RA           15.3233
        Dec          20.8961
        Distance    5.62e+08  # method: V
        Radius     5.722e+04
        AbsMag        -21.58
        Axis    [  0.2792  -0.8863  -0.3695]
        Angle    151.4321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5910-1"
}

Galaxy "NGC 5910-2:MCG 4-36-35:NPM 1:VV 139"
{
        Type  "E0"
        RA           15.3233
        Dec          20.8914
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [  0.2553  -0.8911  -0.3752]
        Angle    152.5505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5910-2"
}

Galaxy "NGC 5911:MCG 1-39-19:ZWG 49.133:NPM 1"
{
        Type  "Sa"
        RA           15.3383
        Dec           3.5189
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.3072  -0.8115  -0.4971]
        Angle    155.8945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5911"
}

Galaxy "NGC 5912:MCG 13-11-11:ZWG 354.22:KCPG 460B"
{
        Type  "S0"
        RA           15.1944
        Dec          75.3847
        Distance   3.285e+08  # method: V
        Radius     5.734e+04
        AbsMag        -20.22
        Axis    [  0.6173  -0.2978   0.7282]
        Angle     25.0842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5912"
}

Galaxy "NGC 5913:UGC 9818:MCG 0-39-21:ZWG 21.79"
{
        Type  "SBa"
        RA           15.3486
        Dec          -2.5783
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [ -0.8693  -0.3814   0.3143]
        Angle     64.9977
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5913"
}

Galaxy "NGC 5914:NGC 5914A:MCG 7-31-55:ZWG 221.51"
{
        Type  "Sb"
        RA           15.3119
        Dec          41.8653
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.3692  -0.1041   0.9235]
        Angle     48.9820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5914"
}

Galaxy "NGC 5914B1:MCG 7-31-56"
{
        Type  "S0"
        RA           15.3125
        Dec          41.8906
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [ -0.6767   0.1105   0.7279]
        Angle     33.8666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5914B1"
}

Galaxy "NGC 5914B2"
{
        Type  "Sb"
        RA           15.3128
        Dec          41.8867
        Distance   4.241e+08  # distance uncertain!
        Radius     4.318e+04
        AbsMag        -19.07
        Axis    [  0.6730  -0.7388  -0.0365]
        Angle    139.9612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5914B2"
}

Galaxy "NGC 5915:MCG 2-39-19:UGCA 407:IRAS 15187-1254"
{
        Type  "SBb"
        RA           15.3592
        Dec         -13.0917
        Distance   1.117e+08  # method: V
        Radius     2.599e+04
        AbsMag        -19.57
        Axis    [ -0.9370  -0.3452  -0.0542]
        Angle     67.7933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5915"
}

Galaxy "NGC 5916:MCG 2-39-20:IRAS 15188-1259"
{
        Type  "SBa"
        RA           15.3603
        Dec         -13.1692
        Distance    1.47e+08  # distance uncertain!
        Radius     5.988e+04
        AbsMag        -19.07
        Axis    [  0.7575  -0.4977  -0.4225]
        Angle    107.4017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5916"
}

Galaxy "NGC 5916A:MCG 2-39-18"
{
        Type  "SBc"
        RA           15.3536
        Dec         -13.1008
        Distance   1.119e+08  # method: V
        Radius      1.79e+04
        AbsMag        -17.58
        Axis    [ -0.6382  -0.7253   0.2580]
        Angle     61.2028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5916A"
}

Galaxy "NGC 5917:MCG 1-39-2:ARP 254:IRAS 15188-0711"
{
        Type  "Sb"
        RA           15.3589
        Dec          -7.3775
        Distance   1.341e+08  # distance uncertain!
        Radius     3.121e+04
        AbsMag        -19.07
        Axis    [  0.2731  -0.8579  -0.4352]
        Angle     68.5018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5917"
}

Galaxy "NGC 5918:UGC 9817:MCG 8-28-17:ZWG 249.16"
{
        Type  "Sc"
        RA           15.3236
        Dec          45.8803
        Distance   2.375e+08  # method: T-F
        Radius     6.562e+04
        AbsMag        -20.41
        Axis    [  0.5421  -0.6808   0.4926]
        Angle     68.4130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5918"
}

Galaxy "NGC 5919:ZWG 94.144:NPM 1"
{
        Type  "E0"
        RA           15.3600
        Dec           7.7197
        Distance   6.153e+08  # method: V
        Radius     2.685e+04
        AbsMag        -19.48
        Axis    [  0.2759  -0.8372  -0.4722]
        Angle    156.3973
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5919"
}

Galaxy "NGC 5920:UGC 9822:ZWG 49.145:C 318.1"
{
        Type  "S0"
        RA           15.3642
        Dec           7.7089
        Distance   6.016e+08  # method: V
        Radius     9.625e+04
        AbsMag        -21.63
        Axis    [ -0.0021  -0.9976  -0.0691]
        Angle     46.4287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5920"
}

Galaxy "NGC 5921:UGC 9824:MCG 1-39-21:ZWG 49.146"
{
        Type  "SBc"
        RA           15.3656
        Dec           5.0703
        Distance   7.466e+07  # method: V
        Radius     5.212e+04
        AbsMag         -20.3
        Axis    [ -0.6349  -0.6480  -0.4207]
        Angle     46.6354
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5921"
}

Galaxy "NGC 5923:UGC 9823:MCG 7-32-1:ZWG 222.2"
{
        Type  "SBc"
        RA           15.3539
        Dec          41.7264
        Distance   2.571e+08  # method: V
        Radius      6.73e+04
        AbsMag        -20.78
        Axis    [  0.2321  -0.9512  -0.2031]
        Angle    147.4375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5923"
}

Galaxy "NGC 5924:MCG 5-36-15:ZWG 165.43"
{
        Type  "Sa"
        RA           15.3672
        Dec          31.2325
        Distance   4.354e+08  # method: V
        Radius     5.066e+04
        AbsMag        -20.13
        Axis    [  0.7598  -0.6488  -0.0408]
        Angle    124.9665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5924"
}

Galaxy "NGC 5926:MCG 2-39-26:MK 853:ZWG 77.109"
{
        Type  "S0"
        RA           15.3903
        Dec          12.7158
        Distance   2.878e+08  # method: V
        Radius     3.349e+04
        AbsMag        -20.03
        Axis    [  0.1260  -0.9367  -0.3267]
        Angle     58.0679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5926"
}

Galaxy "NGC 5928:UGC 9847:MCG 3-39-27:ZWG 106.42"
{
        Type  "S0"
        RA           15.4339
        Dec          18.0736
        Distance   1.065e+08  # distance uncertain!
        Radius     3.408e+04
        AbsMag        -19.07
        Axis    [ -0.0146  -0.9863  -0.1644]
        Angle     45.6550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5928"
}

Galaxy "NGC 5929:UGC 9851:MCG 7-32-6:ZWG 222.7"
{
        Type  "Sb"
        RA           15.4350
        Dec          41.6711
        Distance   1.202e+08  # method: V
        Radius     1.574e+04
        AbsMag        -18.73
        Axis    [  0.4542  -0.8811  -0.1316]
        Angle    143.7031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5929"
}

Galaxy "NGC 5930:UGC 9852:MCG 7-32-7:ZWG 222.7"
{
        Type  "SBb"
        RA           15.4356
        Dec          41.6758
        Distance   1.256e+08  # method: V
        Radius     1.644e+04
        AbsMag        -19.93
        Axis    [  0.4032  -0.9067  -0.1240]
        Angle    107.1682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5930"
}

Galaxy "NGC 5931:MCG 1-39-23:ZWG 49.180"
{
        Type  "S0"
        RA           15.4914
        Dec           7.5731
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.5756  -0.7800  -0.2457]
        Angle     88.2935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5931"
}

Galaxy "NGC 5932:MCG 8-28-33:ZWG 249.23"
{
        Type  "S0"
        RA           15.4467
        Dec          48.6150
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.2086  -0.9671  -0.1459]
        Angle    147.3960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5932"
}

Galaxy "NGC 5933:MCG 8-28-34:ZWG 249.24:NPM 1"
{
        Type  "S0"
        RA           15.4503
        Dec          48.6139
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.6939  -0.6950   0.1883]
        Angle    114.5066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5933"
}

Galaxy "NGC 5934:UGC 9862:MCG 7-32-11:ZWG 222.11"
{
        Type  "S0"
        RA           15.4700
        Dec          42.9297
        Distance    2.58e+08  # method: V
        Radius     4.878e+04
        AbsMag        -19.79
        Axis    [  0.7102  -0.7039  -0.0065]
        Angle    139.8106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5934"
}

Galaxy "NGC 5935:MCG 7-32-13:ZWG 222.13:ZW 113"
{
        Type  "S0"
        RA           15.4711
        Dec          42.9447
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.6966  -0.7109   0.0973]
        Angle    117.1590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5935"
}

Galaxy "NGC 5936:UGC 9867:MCG 2-39-30:ZWG 78.1"
{
        Type  "SBb"
        RA           15.5000
        Dec          12.9889
        Distance   1.882e+08  # method: V
        Radius     3.833e+04
        AbsMag        -20.71
        Axis    [  0.3146  -0.8389  -0.4442]
        Angle    113.1037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5936"
}

Galaxy "NGC 5937:MCG 0-40-1:ZWG 22.2:IRAS 15281-0239"
{
        Type  "Sb"
        RA           15.5128
        Dec          -2.8292
        Distance   1.323e+08  # method: V
        Radius     3.657e+04
        AbsMag        -19.94
        Axis    [  0.6173  -0.6638  -0.4224]
        Angle    113.5087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5937"
}

Galaxy "NGC 5938:ESO 99-7:AM 1531-664:IRAS 15317-6641"
{
        Type  "SBc"
        RA           15.6072
        Dec         -66.8592
        Distance   1.641e+08  # method: V
        Radius     6.684e+04
        AbsMag        -21.81
        Axis    [ -0.9319  -0.2652  -0.2473]
        Angle    126.5730
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5938"
}

Galaxy "NGC 5939:UGC 9854:MCG 12-15-7:ZWG 338.8"
{
        Type  "Sc"
        RA           15.4125
        Dec          68.7297
        Distance   3.028e+08  # method: V
        Radius     3.964e+04
        AbsMag        -20.94
        Axis    [  0.6016  -0.7324   0.3190]
        Angle    119.0254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5939"
}

Galaxy "NGC 5940:UGC 9876:MCG 1-39-25:ZWG 50.7"
{
        Type  "SBb"
        RA           15.5217
        Dec           7.4575
        Distance   4.693e+08  # method: V
        Radius      5.46e+04
        AbsMag        -21.29
        Axis    [  0.2820  -0.8352  -0.4722]
        Angle    156.4532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5940"
}

Galaxy "NGC 5941:MCG 1-40-3:ZWG 50.11:HCG 76B"
{
        Type  "S0"
        RA           15.5278
        Dec           7.3389
        Distance   4.601e+08  # method: V
        Radius     2.677e+04
        AbsMag        -20.85
        Axis    [  0.2627  -0.8799  -0.3959]
        Angle     76.5438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5941"
}

Galaxy "NGC 5942:MCG 1-40-1:ZWG 50.9:HCG 76"
{
        Type  "S0"
        RA           15.5267
        Dec           7.3122
        Distance     4.9e+08  # method: V
        Radius     2.851e+04
        AbsMag        -20.58
        Axis    [  0.2817  -0.8346  -0.4734]
        Angle    156.5310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5942"
}

Galaxy "NGC 5943:UGC 9870:MCG 7-32-16:ZWG 222.16"
{
        Type  "S0"
        RA           15.4956
        Dec          42.7786
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.2184  -0.9561  -0.1953]
        Angle    148.9443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5943"
}

Galaxy "NGC 5944:MCG 1-40-4:ZWG 50.13:HCG 76A"
{
        Type  "Sc"
        RA           15.5297
        Dec           7.3081
        Distance   4.624e+08  # method: V
        Radius      5.38e+04
        AbsMag        -19.96
        Axis    [  0.0641  -0.9108   0.4078]
        Angle     51.0046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5944"
}

Galaxy "NGC 5945:UGC 9871:MCG 7-32-17:ZWG 222.17"
{
        Type  "SBb"
        RA           15.4956
        Dec          42.9192
        Distance   2.544e+08  # method: V
        Radius     1.073e+05
        AbsMag        -20.66
        Axis    [  0.3766  -0.8353   0.4007]
        Angle     52.1592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5945"
}

Galaxy "NGC 5947:UGC 9877:MCG 7-32-19:ZWG 222.19"
{
        Type  "SBc"
        RA           15.5100
        Dec          42.7175
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.2173  -0.9562  -0.1959]
        Angle    149.1278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5947"
}

Galaxy "NGC 5949:UGC 9866:MCG 11-19-8:ZWG 319.16"
{
        Type  "Sc"
        RA           15.4667
        Dec          64.7631
        Distance   4.988e+07  # method: T-F
        Radius     1.596e+04
        AbsMag        -18.02
        Axis    [  0.0242   0.0594   0.9979]
        Angle     53.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5949"
}

Galaxy "NGC 5950:UGC 9884:MCG 7-32-21:ZWG 222.20"
{
        Type  "Sb"
        RA           15.5250
        Dec          40.4306
        Distance   1.332e+08  # method: T-F
        Radius     2.907e+04
        AbsMag        -18.46
        Axis    [  0.6325  -0.7716   0.0669]
        Angle    107.0515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5950"
}

Galaxy "NGC 5951:UGC 9895:MCG 3-40-3:ZWG 107.3"
{
        Type  "SBc"
        RA           15.5619
        Dec          15.0075
        Distance   9.577e+07  # method: T-F
        Radius     5.014e+04
        AbsMag        -18.74
        Axis    [  0.8394  -0.5203  -0.1570]
        Angle    124.3129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5951"
}

Galaxy "NGC 5952:ZWG 50.30:NPM 1"
{
        Type  "S0"
        RA           15.5822
        Dec           4.9594
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.5427  -0.8019  -0.2500]
        Angle     46.3506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5952"
}

Galaxy "NGC 5953:UGC 9903:MCG 3-40-5:ZWG 107.8"
{
        Type  "Sa"
        RA           15.5756
        Dec          15.1942
        Distance   9.554e+07  # method: V
        Radius     2.223e+04
        AbsMag        -19.43
        Axis    [ -0.9951  -0.0412   0.0896]
        Angle     48.0847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5953"
}

Galaxy "NGC 5954:UGC 9904:MCG 3-40-6:ZWG 107.8"
{
        Type  "SBc"
        RA           15.5761
        Dec          15.2011
        Distance   9.518e+07  # method: V
        Radius     1.523e+04
        AbsMag        -19.43
        Axis    [  0.7289  -0.6423  -0.2369]
        Angle    128.2312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5954"
}

Galaxy "NGC 5955:MCG 1-40-6:ZWG 50.31:NPM 1"
{
        Type  "SBb"
        RA           15.5867
        Dec           5.0633
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [  0.6172  -0.6870  -0.3836]
        Angle    130.1133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5955"
}

Galaxy "NGC 5956:UGC 9908:MCG 2-40-3:ZWG 78.17"
{
        Type  "Sc"
        RA           15.5828
        Dec          11.7503
        Distance   9.255e+07  # method: V
        Radius     2.154e+04
        AbsMag        -19.06
        Axis    [  0.2692  -0.8558  -0.4418]
        Angle    156.0063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5956"
}

Galaxy "NGC 5957:UGC 9915:MCG 2-40-4:ZWG 78.18"
{
        Type  "SBb"
        RA           15.5897
        Dec          12.0478
        Distance   8.924e+07  # method: V
        Radius     3.634e+04
        AbsMag        -19.28
        Axis    [ -0.0607  -0.8413  -0.5372]
        Angle     69.1945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5957"
}

Galaxy "NGC 5958:UGC 9909:MCG 5-37-3:ZWG 166.9"
{
        Type  "Sc"
        RA           15.5803
        Dec          28.6553
        Distance   9.617e+07  # method: V
        Radius     1.399e+04
        AbsMag        -18.95
        Axis    [  0.2404  -0.9194  -0.3115]
        Angle    152.4586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5958"
}

Galaxy "NGC 5959:MCG 3-40-2:NPM 1"
{
        Type  "E0"
        RA           15.6228
        Dec         -16.5961
        Distance   2.884e+08  # distance uncertain!
        Radius      8.39e+04
        AbsMag        -20.13
        Axis    [ -0.8933   0.1583  -0.4207]
        Angle     88.6705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5959"
}

Galaxy "NGC 5960:MCG 1-40-7:ZWG 50.38:NPM 1"
{
        Type  "Sc"
        RA           15.6050
        Dec           5.6658
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.3723  -0.7971  -0.4754]
        Angle     53.8499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5960"
}

Galaxy "NGC 5961:UGC 9918:MCG 5-37-5:ZWG 166.13"
{
        Type  "Sb"
        RA           15.5878
        Dec          30.8642
        Distance   8.766e+07  # method: V
        Radius      1.02e+04
        AbsMag        -17.75
        Axis    [  0.3900  -0.7970   0.4613]
        Angle     58.3790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5961"
}

Galaxy "NGC 5962:UGC 9926:MCG 3-40-11:ZWG 107.12"
{
        Type  "Sc"
        RA           15.6086
        Dec          16.6078
        Distance   9.486e+07  # method: V
        Radius     4.139e+04
        AbsMag        -20.32
        Axis    [ -0.1304  -0.9806  -0.1460]
        Angle     45.4221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5962"
}

Galaxy "NGC 5963:UGC 9906:MCG 9-25-58:ZWG 297.15"
{
        Type  "Sc"
        RA           15.5575
        Dec          56.5600
        Distance    3.23e+07  # method: V
        Radius      1.55e+04
        AbsMag        -16.98
        Axis    [  0.4722  -0.8681   0.1528]
        Angle     93.1086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5963"
}

Galaxy "NGC 5964:IC 4551:UGC 9935:MCG 1-40-8"
{
        Type  "SBc"
        RA           15.6267
        Dec           5.9736
        Distance    7.23e+07  # method: V
        Radius     4.311e+04
        AbsMag        -18.83
        Axis    [ -0.8433  -0.5098  -0.1703]
        Angle     46.7751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5964"
}

Galaxy "NGC 5965-1:UGC 9914:MCG 10-22-20:ZWG 297.16"
{
        Type  "Sb"
        RA           15.5672
        Dec          56.6856
        Distance   1.571e+08  # method: V
        Radius     1.188e+05
        AbsMag        -20.71
        Axis    [  0.7071  -0.5404   0.4560]
        Angle    110.2853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5965-1"
}

Galaxy "NGC 5965-2:NPM 1"
{
        Type  "S0"
        RA           15.5647
        Dec          56.6911
        Distance   3.527e+08  # distance uncertain!
        Radius     1.539e+04
        AbsMag        -19.07
        Axis    [ -0.3078   0.2300   0.9232]
        Angle     36.5138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5965-2"
}

Galaxy "NGC 5966:UGC 9923:MCG 7-32-32:ZWG 222.28"
{
        Type  "E0"
        RA           15.5978
        Dec          39.7692
        Distance   2.093e+08  # method: V
        Radius     5.479e+04
        AbsMag        -20.74
        Axis    [ -0.0441  -0.8571  -0.5133]
        Angle     67.9703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5966"
}

Galaxy "NGC 5967:ESO 42-10:AM 1542-753:IRAS 15421-7531"
{
        Type  "SBc"
        RA           15.8044
        Dec         -75.6731
        Distance    1.29e+08  # method: T-F
        Radius     5.065e+04
        AbsMag        -20.28
        Axis    [ -0.3431  -0.5045  -0.7923]
        Angle    110.2666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5967"
}

Galaxy "NGC 5967A:ESO 42-9:AM 1540-753"
{
        Type  "SBc"
        RA           15.7828
        Dec         -75.7869
        Distance   1.295e+08  # method: T-F
        Radius     3.767e+04
        AbsMag        -19.69
        Axis    [  0.0590  -0.3351  -0.9404]
        Angle    126.3579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5967A"
}

Galaxy "NGC 5968:ESO 450-5:MCG 5-37-1:IRAS 15368-3023"
{
        Type  "SBb"
        RA           15.6658
        Dec         -30.5531
        Distance   2.386e+08  # method: V
        Radius     7.286e+04
        AbsMag        -21.22
        Axis    [  0.4503  -0.5608  -0.6947]
        Angle    148.9519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5968"
}

Galaxy "NGC 5969:MCG 9-25-59:ZWG 297.18:NPM 1"
{
        Type  "S0"
        RA           15.5806
        Dec          56.4514
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.6116  -0.7888   0.0613]
        Angle    147.4652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5969"
}

Galaxy "NGC 5970:UGC 9943:MCG 2-40-6:ZWG 78.34"
{
        Type  "SBc"
        RA           15.6417
        Dec          12.1864
        Distance   9.531e+07  # method: V
        Radius     4.159e+04
        AbsMag        -20.13
        Axis    [  0.1798  -0.9614  -0.2083]
        Angle     60.6861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5970"
}

Galaxy "NGC 5971:UGC 9929:MCG 9-26-2:ZWG 297.19"
{
        Type  "Sa"
        RA           15.5933
        Dec          56.4619
        Distance   1.851e+08  # distance uncertain!
        Radius     4.308e+04
        AbsMag        -19.07
        Axis    [  0.0938  -0.2030   0.9747]
        Angle     55.8216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5971"
}

Galaxy "NGC 5972:UGC 9946:MCG 3-40-16:ZWG 107.18"
{
        Type  "Sa"
        RA           15.6483
        Dec          17.0261
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.5962  -0.7475  -0.2930]
        Angle    134.1800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5972"
}

Galaxy "NGC 5973"
{
        Type  "Sa"
        RA           15.6708
        Dec          -8.6008
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.5742  -0.7772   0.2573]
        Angle     58.5904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5973"
}

Galaxy "NGC 5974:UGC 9952:MCG 5-37-10:ZWG 166.25"
{
        Type  "Sc"
        RA           15.6506
        Dec          31.7597
        Distance   9.115e+07  # method: V
        Radius          7954
        AbsMag        -17.53
        Axis    [  0.1938  -0.8525   0.4856]
        Angle     47.9071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5974"
}

Galaxy "NGC 5975:UGC 9963:MCG 4-37-19:ZWG 136.46"
{
        Type  "Sc"
        RA           15.6661
        Dec          21.4706
        Distance   2.046e+08  # method: V
        Radius     2.975e+04
        AbsMag        -19.09
        Axis    [ -0.6616  -0.2159   0.7182]
        Angle     65.1004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5975"
}

Galaxy "NGC 5976:MCG 10-22-25:ZWG 297.22"
{
        Type  "S0"
        RA           15.6131
        Dec          59.3983
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.3238  -0.4277   0.8439]
        Angle     54.7922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5976"
}

Galaxy "NGC 5976A:UGC 9934:MCG 10-22-23:ZWG 297.20"
{
        Type  "SBb"
        RA           15.6019
        Dec          59.5667
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.1714  -0.9838  -0.0529]
        Angle    147.8732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5976A"
}

Galaxy "NGC 5977:UGC 9967:MCG 3-40-23:ZWG 107.23"
{
        Type  "S0"
        RA           15.6758
        Dec          17.1286
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [ -0.9541  -0.2992  -0.0101]
        Angle     39.9078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5977"
}

Galaxy "NGC 5978:MCG 2-40-2:NPM 1"
{
        Type  "Sa"
        RA           15.7075
        Dec         -13.2339
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.4814  -0.6595  -0.5773]
        Angle    145.1629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5978"
}

Galaxy "NGC 5980:UGC 9974:MCG 3-40-26:ZWG 107.25"
{
        Type  "Sc"
        RA           15.6917
        Dec          15.7875
        Distance   1.913e+08  # method: V
        Radius     5.285e+04
        AbsMag        -20.44
        Axis    [  0.7431  -0.6411  -0.1916]
        Angle    120.7525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5980"
}

Galaxy "NGC 5981:UGC 9948:MCG 10-22-27:ZWG 297.23"
{
        Type  "Sc"
        RA           15.6314
        Dec          59.3914
        Distance   8.195e+07  # method: V
        Radius     3.218e+04
        AbsMag         -18.1
        Axis    [  0.0727  -0.0930   0.9930]
        Angle     73.0133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5981"
}

Galaxy "NGC 5982:UGC 9961:MCG 10-22-29:ZWG 297.24"
{
        Type  "E3"
        RA           15.6444
        Dec          59.3561
        Distance   1.349e+08  # method: T-F
        Radius       5.1e+04
        AbsMag        -21.08
        Axis    [  0.0843  -0.9071  -0.4125]
        Angle     41.8606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5982"
}

Galaxy "NGC 5983:UGC 9983:MCG 1-40-12:ZWG 50.79"
{
        Type  "E0"
        RA           15.7125
        Dec           8.2417
        Distance   3.312e+08  # distance uncertain!
        Radius     4.817e+04
        AbsMag        -20.13
        Axis    [  0.2382  -0.8481  -0.4732]
        Angle    159.3574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5983"
}

Galaxy "NGC 5984:UGC 9987:MCG 2-40-11:ZWG 78.52"
{
        Type  "SBc"
        RA           15.7147
        Dec          14.2322
        Distance   6.863e+07  # method: T-F
        Radius     2.895e+04
        AbsMag        -18.31
        Axis    [ -0.3907  -0.5939   0.7034]
        Angle     57.4659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5984"
}

Galaxy "NGC 5985:UGC 9969:MCG 10-22-30:ZWG 297.25"
{
        Type  "SBb"
        RA           15.6603
        Dec          59.3319
        Distance   1.161e+08  # method: V
        Radius     9.288e+04
        AbsMag        -20.86
        Axis    [  0.6228  -0.7703   0.1370]
        Angle    137.8013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5985"
}

Galaxy "NGC 5987:UGC 9971:MCG 10-22-32:ZWG 297.26"
{
        Type  "Sb"
        RA           15.6656
        Dec          58.0797
        Distance   1.384e+08  # method: V
        Radius     8.457e+04
        AbsMag        -20.44
        Axis    [  0.6353  -0.6040   0.4812]
        Angle     98.4454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5987"
}

Galaxy "NGC 5988:UGC 9998:MCG 2-40-12:ZWG 78.58"
{
        Type  "Sc"
        RA           15.7425
        Dec          10.2931
        Distance   4.858e+08  # method: V
        Radius     8.478e+04
        AbsMag        -20.96
        Axis    [ -0.3487  -0.8652  -0.3603]
        Angle     50.2487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5988"
}

Galaxy "NGC 5989:UGC 9985:MCG 10-22-34:ZWG 297.28"
{
        Type  "Sc"
        RA           15.6922
        Dec          59.7550
        Distance   1.322e+08  # method: V
        Radius     1.731e+04
        AbsMag        -19.34
        Axis    [  0.1652  -0.9849  -0.0516]
        Angle    149.0462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5989"
}

Galaxy "NGC 5990:UGC 10024:MCG 1-40-14:ZWG 50.101"
{
        Type  "Sa"
        RA           15.7711
        Dec           2.4156
        Distance   1.801e+08  # method: V
        Radius     4.192e+04
        AbsMag        -20.51
        Axis    [ -0.2585  -0.9649  -0.0459]
        Angle     50.2844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5990"
}

Galaxy "NGC 5991:MCG 4-37-28:ZWG 136.67:NPM 1"
{
        Type  "S0"
        RA           15.7544
        Dec          24.6311
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.4644  -0.8308  -0.3068]
        Angle     37.6650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5991"
}

Galaxy "NGC 5992:UGC 10003:MCG 7-32-49:MK 489"
{
        Type  "Sb"
        RA           15.7392
        Dec          41.0858
        Distance   4.332e+08  # method: V
        Radius      5.67e+04
        AbsMag        -21.32
        Axis    [ -0.7843   0.3216   0.5305]
        Angle     38.7564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5992"
}

Galaxy "NGC 5993:UGC 10007:MCG 7-32-50:ZWG 222.48"
{
        Type  "SBb"
        RA           15.7408
        Dec          41.1208
        Distance    4.37e+08  # method: V
        Radius     7.627e+04
        AbsMag        -21.63
        Axis    [ -0.3935  -0.6274   0.6720]
        Angle     26.5709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5993"
}

Galaxy "NGC 5994:UGC 10033:MCG 3-40-38:ZWG 107.36"
{
        Type  "SBc"
        RA           15.7814
        Dec          17.8731
        Distance   1.544e+08  # method: V
        Radius          8984
        AbsMag        -17.78
        Axis    [  0.3297  -0.9418   0.0659]
        Angle     62.0754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5994"
}

Galaxy "NGC 5995:MCG 2-40-4:NPM 1:IRAS 15456-1336"
{
        Type  "Sa"
        RA           15.8067
        Dec         -13.7572
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.9660  -0.2579  -0.0161]
        Angle     73.8326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5995"
}

Galaxy "NGC 5996:UGC 10033:MCG 3-40-39:MK 691"
{
        Type  "Sc"
        RA           15.7828
        Dec          17.8839
        Distance   1.551e+08  # method: V
        Radius     3.834e+04
        AbsMag        -20.18
        Axis    [  0.6067  -0.7730  -0.1851]
        Angle    106.5619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5996"
}

Galaxy "NGC 5997:ZWG 50.105:NPM 1"
{
        Type  "E0"
        RA           15.7908
        Dec           8.3217
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [ -0.2426  -0.6712  -0.7004]
        Angle     88.7674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 5997"
}

Galaxy "NGC 6000:ESO 450-20:MCG 5-37-3:IRAS 15467-2914"
{
        Type  "SBc"
        RA           15.8303
        Dec         -29.3869
        Distance   1.017e+08  # method: V
        Radius      2.81e+04
        AbsMag        -19.47
        Axis    [ -0.8773  -0.3792  -0.2943]
        Angle     83.7053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6000"
}

Galaxy "NGC 6001:UGC 10036:MCG 5-37-27:ZWG 166.58"
{
        Type  "Sc"
        RA           15.7958
        Dec          28.6417
        Distance    4.56e+08  # method: V
        Radius     6.632e+04
        AbsMag        -21.33
        Axis    [  0.2208  -0.9236  -0.3134]
        Angle    154.7929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6001"
}

Galaxy "NGC 6003:UGC 10048:MCG 3-40-48:ZWG 107.43"
{
        Type  "S0"
        RA           15.8236
        Dec          19.0325
        Distance   1.891e+08  # method: V
        Radius     2.475e+04
        AbsMag        -19.42
        Axis    [ -0.5051  -0.8012  -0.3207]
        Angle     42.0051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6003"
}

Galaxy "NGC 6004:UGC 10056:MCG 3-40-51:ZWG 107.46"
{
        Type  "SBc"
        RA           15.8394
        Dec          18.9394
        Distance   1.785e+08  # method: V
        Radius     4.673e+04
        AbsMag        -20.39
        Axis    [ -0.2144  -0.8518  -0.4780]
        Angle     57.9904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6004"
}

Galaxy "NGC 6006:MK 862:ZWG 78.93:NPM 1"
{
        Type  "E0"
        RA           15.8839
        Dec          12.0058
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [ -0.8203   0.0760  -0.5669]
        Angle     58.7382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6006"
}

Galaxy "NGC 6007:UGC 10079:MCG 2-40-18:ZWG 78.95"
{
        Type  "SBc"
        RA           15.8897
        Dec          11.9597
        Distance   4.832e+08  # method: V
        Radius     1.195e+05
        AbsMag        -22.05
        Axis    [  0.3164  -0.9042  -0.2870]
        Angle     82.4144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6007"
}

Galaxy "NGC 6008:NGC 6008A:UGC 10076:MCG 4-37-52"
{
        Type  "SBb"
        RA           15.8819
        Dec          21.1011
        Distance   2.254e+08  # method: V
        Radius      4.59e+04
        AbsMag         -20.2
        Axis    [  0.1664  -0.9084  -0.3835]
        Angle     90.8481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6008"
}

Galaxy "NGC 6008B:MCG 4-37-54:ZWG 136.112:ARAK 488"
{
        Type  "S0"
        RA           15.8856
        Dec          21.0758
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.7995  -0.2091   0.5630]
        Angle     51.9614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6008B"
}

Galaxy "NGC 6009:ZWG 78.96"
{
        Type  "S0"
        RA           15.8900
        Dec          12.0583
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.7706  -0.2611   0.5814]
        Angle     67.4379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6009"
}

Galaxy "NGC 6010:UGC 10081:MCG 0-40-13:ZWG 22.48"
{
        Type  "Sa"
        RA           15.9050
        Dec           0.5431
        Distance   9.223e+07  # method: V
        Radius     2.683e+04
        AbsMag        -18.86
        Axis    [  0.1351  -0.9652   0.2239]
        Angle     58.0945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6010"
}

Galaxy "NGC 6011:UGC 10047:MCG 12-15-16:ZWG 338.17"
{
        Type  "Sb"
        RA           15.7756
        Dec          72.1692
        Distance    1.54e+08  # distance uncertain!
        Radius     4.479e+04
        AbsMag        -19.07
        Axis    [  0.4392  -0.3153   0.8412]
        Angle     78.6233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6011"
}

Galaxy "NGC 6012:UGC 10083:MCG 3-40-59:ZWG 107.54"
{
        Type  "SBb"
        RA           15.9036
        Dec          14.6022
        Distance   8.956e+07  # method: V
        Radius     2.735e+04
        AbsMag        -19.49
        Axis    [ -0.9276  -0.2014   0.3147]
        Angle     50.7529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6012"
}

Galaxy "NGC 6013:UGC 10080:MCG 7-33-4:ZWG 223.7"
{
        Type  "SBb"
        RA           15.8811
        Dec          40.6467
        Distance   2.068e+08  # method: V
        Radius     4.212e+04
        AbsMag        -19.61
        Axis    [ -0.6306   0.1072   0.7687]
        Angle     49.6237
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6013"
}

Galaxy "NGC 6014:IC 4586:UGC 10091:MCG 1-41-2"
{
        Type  "S0"
        RA           15.9325
        Dec           5.9317
        Distance   1.177e+08  # method: V
        Radius     2.911e+04
        AbsMag        -19.29
        Axis    [ -0.9866  -0.0074  -0.1632]
        Angle     57.8228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6014"
}

Galaxy "NGC 6015:UGC 10075:MCG 10-23-3:ZWG 298.3"
{
        Type  "Sc"
        RA           15.8569
        Dec          62.3086
        Distance   6.084e+07  # method: T-F
        Radius     4.778e+04
        AbsMag        -19.65
        Axis    [  0.6664  -0.7006   0.2551]
        Angle    130.4432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6015"
}

Galaxy "NGC 6016:UGC 10096:MCG 5-38-1:ZWG 167.4"
{
        Type  "SBc"
        RA           15.9317
        Dec          26.9672
        Distance   2.914e+08  # method: T-F
        Radius     4.238e+04
        AbsMag        -19.65
        Axis    [  0.6350  -0.7651  -0.1067]
        Angle    116.6349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6016"
}

Galaxy "NGC 6017:UGC 10098:MCG 1-41-3:ZWG 51.8"
{
        Type  "S0"
        RA           15.9542
        Dec           5.9989
        Distance   9.715e+07  # method: S
        Radius      1.13e+04
        AbsMag        -18.37
        Axis    [ -0.7772  -0.5654  -0.2763]
        Angle     50.2312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6017"
}

Galaxy "NGC 6018:UGC 10101:MCG 3-41-6:ZWG 108.16"
{
        Type  "Sa"
        RA           15.9581
        Dec          15.8728
        Distance   2.399e+08  # method: V
        Radius     4.885e+04
        AbsMag        -20.03
        Axis    [  0.3980  -0.9169  -0.0306]
        Angle     72.7861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6018"
}

Galaxy "NGC 6019:ZWG 319.31"
{
        Type  "E0"
        RA           15.8692
        Dec          64.8408
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.1170  -0.9930  -0.0149]
        Angle    150.9347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6019"
}

Galaxy "NGC 6020:IC 1148:UGC 10100:MCG 4-38-2"
{
        Type  "E0"
        RA           15.9522
        Dec          22.4050
        Distance   2.401e+08  # method: T-F
        Radius     4.888e+04
        AbsMag        -20.53
        Axis    [ -0.6428  -0.3057  -0.7024]
        Angle     50.8456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6020"
}

Galaxy "NGC 6021:UGC 10102:MCG 3-41-5:ZWG 108.17"
{
        Type  "E0"
        RA           15.9583
        Dec          15.9564
        Distance   2.195e+08  # method: V
        Radius      4.47e+04
        AbsMag        -20.04
        Axis    [ -0.8111   0.0439  -0.5832]
        Angle     54.5128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6021"
}

Galaxy "NGC 6022:MCG 3-41-9:ZWG 108.20"
{
        Type  "SBc"
        RA           15.9631
        Dec          16.2828
        Distance   4.866e+08  # method: V
        Radius     4.954e+04
        AbsMag        -20.37
        Axis    [  0.2579  -0.9421  -0.2144]
        Angle     74.9081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6022"
}

Galaxy "NGC 6023:UGC 10106:MCG 3-41-10:ZWG 108.21"
{
        Type  "E0"
        RA           15.9636
        Dec          16.3106
        Distance   5.095e+08  # method: V
        Radius     1.037e+05
        AbsMag        -21.67
        Axis    [ -0.0956  -0.8043  -0.5865]
        Angle     99.8540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6023"
}

Galaxy "NGC 6024:MCG 11-19-26:ZWG 319.32"
{
        Type  "S0"
        RA           15.8853
        Dec          64.9183
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.3781  -0.7568   0.5332]
        Angle     40.6558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6024"
}

Galaxy "NGC 6027A:UGC 10116:MCG 4-38-6:ZWG 137.10"
{
        Type  "Sa"
        RA           15.9864
        Dec          20.7556
        Distance   1.946e+08  # method: V
        Radius     1.981e+04
        AbsMag        -19.18
        Axis    [  0.2843  -0.9460  -0.1558]
        Angle     74.9980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6027A"
}

Galaxy "NGC 6027B:UGC 10116:MCG 4-38-8:ZWG 137.10"
{
        Type  "Sa"
        RA           15.9861
        Dec          20.7625
        Distance    9.02e+08  # method: V
        Radius     5.248e+04
        AbsMag        -22.11
        Axis    [  0.4218  -0.8717  -0.2497]
        Angle    104.7500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6027B"
}

Galaxy "NGC 6027C:UGC 10116:MCG 4-38-7:ZWG 137.10"
{
        Type  "Sc"
        RA           15.9864
        Dec          20.7478
        Distance    9.02e+08  # method: V
        Radius      6.56e+04
        AbsMag        -21.21
        Axis    [  0.7275  -0.6524  -0.2122]
        Angle    136.9517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6027C"
}

Galaxy "NGC 6027D:UGC 10116:MCG 4-38-9:ZWG 137.10"
{
        Type  "S0"
        RA           15.9869
        Dec          20.7603
        Distance    9.02e+08  # method: V
        Radius     2.624e+04
        AbsMag        -20.91
        Axis    [  0.2156  -0.9005  -0.3777]
        Angle    158.1415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6027D"
}

Galaxy "NGC 6027E:UGC 10116:MCG 4-38-10:ZWG 137.10"
{
        Type  "S0"
        RA           15.9867
        Dec          20.7639
        Distance    9.02e+08  # method: V
        Radius     1.312e+05
        AbsMag        -23.01
        Axis    [  0.2280  -0.9675  -0.1095]
        Angle     67.4604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6027E"
}

Galaxy "NGC 6029:ZWG 79.23:KUG 1559+127"
{
        Type  "E0"
        RA           16.0328
        Dec          12.5747
        Distance   4.366e+08  # distance uncertain!
        Radius     7.619e+04
        AbsMag        -20.13
        Axis    [  0.1806  -0.8713  -0.4562]
        Angle    156.9664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6029"
}

Galaxy "NGC 6030:UGC 10139:MCG 3-41-44:ZWG 108.65"
{
        Type  "S0"
        RA           16.0308
        Dec          17.9575
        Distance   2.058e+08  # method: V
        Radius     3.593e+04
        AbsMag         -20.2
        Axis    [  0.4867  -0.8390  -0.2433]
        Angle    107.6806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6030"
}

Galaxy "NGC 6032:UGC 10148:MCG 4-38-16:ZWG 137.21"
{
        Type  "SBb"
        RA           16.0503
        Dec          20.9558
        Distance   1.408e+08  # method: T-F
        Radius     3.278e+04
        AbsMag        -18.88
        Axis    [  0.7054  -0.6728  -0.2230]
        Angle    138.1194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6032"
}

Galaxy "NGC 6033:UGC 10159:MCG 0-41-3:ZWG 23.11"
{
        Type  "Sc"
        RA           16.0742
        Dec          -2.1203
        Distance   2.555e+08  # distance uncertain!
        Radius     4.088e+04
        AbsMag        -19.07
        Axis    [ -0.1806  -0.8068  -0.5625]
        Angle     79.3083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6033"
}

Galaxy "NGC 6034:MCG 3-41-62:ZWG 108.84:DRCG 34-7"
{
        Type  "E0"
        RA           16.0589
        Dec          17.1986
        Distance   4.646e+08  # method: V
        Radius     6.757e+04
        AbsMag        -21.17
        Axis    [ -0.0200  -0.8463  -0.5324]
        Angle    113.4325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6034"
}

Galaxy "NGC 6035:UGC 10154:MCG 4-38-18:ZWG 137.24"
{
        Type  "SBc"
        RA           16.0567
        Dec          20.8908
        Distance   1.051e+08  # method: V
        Radius     1.376e+04
        AbsMag        -18.24
        Axis    [  0.2087  -0.9023  -0.3773]
        Angle    158.8278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6035"
}

Galaxy "NGC 6036:UGC 10163:MCG 1-41-10:ZWG 51.32"
{
        Type  "Sa"
        RA           16.0750
        Dec           3.8681
        Distance   2.548e+08  # method: V
        Radius     4.077e+04
        AbsMag        -20.36
        Axis    [ -0.5493  -0.6869   0.4758]
        Angle     59.2681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6036"
}

Galaxy "NGC 6037:MCG 1-41-9:ZWG 51.31:NPM 1"
{
        Type  "Sb"
        RA           16.0747
        Dec           3.8156
        Distance   2.681e+08  # method: V
        Radius     2.729e+04
        AbsMag        -19.57
        Axis    [  0.2024  -0.8544  -0.4786]
        Angle    100.1030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6037"
}

Galaxy "NGC 6038:UGC 10149:MCG 6-35-26:ZWG 195.8"
{
        Type  "Sc"
        RA           16.0444
        Dec          37.3594
        Distance   4.286e+08  # method: V
        Radius     6.857e+04
        AbsMag        -21.29
        Axis    [  0.1844  -0.9521  -0.2438]
        Angle    156.2559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6038"
}

Galaxy "NGC 6039:NGC 6042:MCG 3-41-79:ZWG 108.104"
{
        Type  "S0"
        RA           16.0775
        Dec          17.7003
        Distance   4.829e+08  # method: V
        Radius     5.618e+04
        AbsMag        -20.95
        Axis    [  0.1803  -0.9185  -0.3519]
        Angle     89.0988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6039"
}

Galaxy "NGC 6040A:UGC 10165:MCG 3-41-74:ZWG 108.96"
{
        Type  "SBc"
        RA           16.0739
        Dec          17.7500
        Distance    5.62e+08  # method: V
        Radius     1.063e+05
        AbsMag        -21.58
        Axis    [  0.5418  -0.8231  -0.1703]
        Angle    101.6389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6040A"
}

Galaxy "NGC 6040B:UGC 10165:MCG 3-41-73:ZWG 108.96"
{
        Type  "S0"
        RA           16.0739
        Dec          17.7419
        Distance   5.758e+08  # method: V
        Radius       6.7e+04
        AbsMag        -20.73
        Axis    [  0.2113  -0.8909  -0.4021]
        Angle    159.5130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6040B"
}

Galaxy "NGC 6041A:UGC 10170:MCG 3-41-78:ZWG 108.101"
{
        Type  "S0"
        RA           16.0764
        Dec          17.7214
        Distance    4.79e+08  # method: V
        Radius     9.056e+04
        AbsMag        -21.43
        Axis    [  0.3488  -0.8741  -0.3381]
        Angle    113.8745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6041A"
}

Galaxy "NGC 6041B:UGC 10170:MCG 3-41-78:ZWG 108.101"
{
        Type  "S0"
        RA           16.0764
        Dec          17.7172
        Distance   5.152e+08  # method: V
        Radius     2.997e+04
        AbsMag        -19.39
        Axis    [  0.1210  -0.9754  -0.1842]
        Angle     66.3982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6041B"
}

Galaxy "NGC 6043A:MCG 3-41-86:ZWG 108.109:DRCG 34-83"
{
        Type  "S0"
        RA           16.0836
        Dec          17.7758
        Distance   4.506e+08  # method: V
        Radius     4.588e+04
        AbsMag         -20.3
        Axis    [  0.4674  -0.8719  -0.1457]
        Angle     91.0493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6043A"
}

Galaxy "NGC 6043B:MCG 3-41-86:ZWG 108.109"
{
        Type  "E0"
        RA           16.0833
        Dec          17.7733
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.1866  -0.8947  -0.4057]
        Angle    160.8126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6043B"
}

Galaxy "NGC 6044:IC 1172:MCG 3-41-84:ZWG 108.110"
{
        Type  "S0"
        RA           16.0831
        Dec          17.8703
        Distance   4.544e+08  # method: V
        Radius     3.966e+04
        AbsMag        -20.42
        Axis    [  0.2103  -0.8915  -0.4012]
        Angle    159.5824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6044"
}

Galaxy "NGC 6045A:UGC 10177:MCG 3-41-88:ZWG 108.112"
{
        Type  "SBc"
        RA           16.0856
        Dec          17.7581
        Distance    4.57e+08  # method: V
        Radius      8.64e+04
        AbsMag        -20.93
        Axis    [  0.4869  -0.8238   0.2904]
        Angle     73.1565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6045A"
}

Galaxy "NGC 6045B:DRCG 34-81"
{
        Type  "S0"
        RA           16.0861
        Dec          17.7583
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.6865  -0.4104   0.6003]
        Angle     53.8865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6045B"
}

Galaxy "NGC 6046:NGC 6028:UGC 10135:MCG 3-41-43"
{
        Type  "Sa"
        RA           16.0247
        Dec          19.3594
        Distance   2.072e+08  # method: V
        Radius     3.917e+04
        AbsMag        -19.61
        Axis    [  0.3795  -0.8666  -0.3240]
        Angle    118.8696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6046"
}

Galaxy "NGC 6047:MCG 3-41-87:ZWG 108.111:DRCG 34-62"
{
        Type  "E0"
        RA           16.0858
        Dec          17.7297
        Distance   4.327e+08  # method: V
        Radius     6.922e+04
        AbsMag        -20.91
        Axis    [ -0.2282  -0.7542  -0.6157]
        Angle     84.2963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6047"
}

Galaxy "NGC 6048:UGC 10124:MCG 12-15-38:ZWG 338.32"
{
        Type  "E0"
        RA           15.9583
        Dec          70.6889
        Distance   1.585e+08  # distance uncertain!
        Radius     5.072e+04
        AbsMag        -20.13
        Axis    [  0.4614  -0.6938  -0.5529]
        Angle     16.3372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6048"
}

Galaxy "NGC 6050A:IC 1179A:UGC 10186:MCG 3-41-93"
{
        Type  "SBc"
        RA           16.0897
        Dec          17.7572
        Distance   5.707e+08  # method: T-F
        Radius     7.471e+04
        AbsMag        -21.41
        Axis    [ -0.4596  -0.8537   0.2451]
        Angle     43.2454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6050A"
}

Galaxy "NGC 6050B:IC 1179B:UGC 10186:MCG 3-41-92"
{
        Type  "SBc"
        RA           16.0894
        Dec          17.7544
        Distance   4.771e+08  # method: T-F
        Radius     2.776e+04
        AbsMag        -19.73
        Axis    [  0.4298  -0.8555  -0.2887]
        Angle    111.9348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6050B"
}

Galaxy "NGC 6051:UGC 10178:MCG 4-38-21:ZWG 137.30"
{
        Type  "E0"
        RA           16.0822
        Dec          23.9322
        Distance   4.137e+08  # method: T-F
        Radius     9.627e+04
        AbsMag        -21.32
        Axis    [ -0.8212   0.1438  -0.5522]
        Angle     46.8141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6051"
}

Galaxy "NGC 6053:NGC 6057:MCG 3-41-106:NPM 1"
{
        Type  "E0"
        RA           16.0942
        Dec          18.1647
        Distance   4.773e+08  # method: V
        Radius     4.165e+04
        AbsMag        -20.13
        Axis    [ -0.8174   0.0057  -0.5760]
        Angle     51.8379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6053"
}

Galaxy "NGC 6054:IC 1183:MCG 3-41-103:ZWG 108.128"
{
        Type  "S0"
        RA           16.0939
        Dec          17.7675
        Distance    4.59e+08  # method: V
        Radius     5.341e+04
        AbsMag        -20.44
        Axis    [  0.4574  -0.8875  -0.0562]
        Angle     82.4603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6054"
}

Galaxy "NGC 6055:UGC 10191:MCG 3-41-101:ZWG 108.123"
{
        Type  "S0"
        RA           16.0922
        Dec          18.1594
        Distance   5.152e+08  # method: V
        Radius     7.493e+04
        AbsMag        -20.99
        Axis    [  0.5119  -0.8349  -0.2024]
        Angle    104.5146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6055"
}

Galaxy "NGC 6056:IC 1176:MCG 3-41-100:ZWG 108.122"
{
        Type  "SBa"
        RA           16.0919
        Dec          17.9628
        Distance   5.337e+08  # method: V
        Radius     6.986e+04
        AbsMag        -21.07
        Axis    [  0.4721  -0.8719  -0.1300]
        Angle     90.1762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6056"
}

Galaxy "NGC 6060:UGC 10196:MCG 4-38-25:ZWG 137.36"
{
        Type  "SBc"
        RA           16.0978
        Dec          21.4844
        Distance    2.01e+08  # method: T-F
        Radius     5.847e+04
        AbsMag        -19.85
        Axis    [  0.1052  -0.9700   0.2192]
        Angle     54.8924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6060"
}

Galaxy "NGC 6061:UGC 10199:MCG 3-41-118:ZWG 108.145"
{
        Type  "S0"
        RA           16.1044
        Dec          18.2500
        Distance   5.125e+08  # method: V
        Radius     7.455e+04
        AbsMag        -21.38
        Axis    [  0.2451  -0.9293  -0.2764]
        Angle     85.8859
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6061"
}

Galaxy "NGC 6062:UGC 10202:MCG 3-41-125:ZWG 108.148"
{
        Type  "SBc"
        RA           16.1061
        Dec          19.7769
        Distance   5.349e+08  # method: V
        Radius     9.336e+04
        AbsMag        -21.87
        Axis    [  0.5085  -0.8088  -0.2956]
        Angle    135.3392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6062"
}

Galaxy "NGC 6062B:MCG 3-41-122:IRAS 16041+1954"
{
        Type  "Sc"
        RA           16.1053
        Dec          19.7628
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.2056  -0.8990  -0.3866]
        Angle    159.4998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6062B"
}

Galaxy "NGC 6063:UGC 10210:MCG 1-41-12:ZWG 51.45"
{
        Type  "Sc"
        RA           16.1203
        Dec           7.9794
        Distance   1.986e+08  # method: T-F
        Radius      4.91e+04
        AbsMag        -20.02
        Axis    [ -0.7550  -0.4848   0.4415]
        Angle     57.4646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6063"
}

Galaxy "NGC 6064-1:NGC 6052-1:UGC 10182:MCG 4-38-22"
{
        Type  "Sc"
        RA           16.0867
        Dec          20.5419
        Distance   2.178e+08  # method: V
        Radius      2.85e+04
        AbsMag        -19.62
        Axis    [ -0.9357  -0.0988   0.3387]
        Angle     47.2417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6064-1"
}

Galaxy "NGC 6064-2:NGC 6052-2:UGC 10182:MCG 4-38-22"
{
        Type  "Irr"
        RA           16.0869
        Dec          20.5422
        Distance   2.178e+08  # method: V
        Radius     2.534e+04
        AbsMag        -20.02
        Axis    [ -0.6815  -0.2147   0.6996]
        Angle     66.7693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6064-2"
}

Galaxy "NGC 6065:MCG 2-41-8:ZWG 79.51:NPM 1"
{
        Type  "S0"
        RA           16.1228
        Dec          13.8883
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.5165  -0.7815  -0.3501]
        Angle    138.2349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6065"
}

Galaxy "NGC 6066:ZWG 79.54:NPM 1"
{
        Type  "S0"
        RA           16.1264
        Dec          13.9442
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.6691  -0.7247  -0.1647]
        Angle     44.8790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6066"
}

Galaxy "NGC 6068:UGC 10126:MCG 13-11-19:ZWG 354.31"
{
        Type  "SBc"
        RA           15.9236
        Dec          78.9967
        Distance   1.795e+08  # method: V
        Radius      2.61e+04
        AbsMag         -20.5
        Axis    [  0.2315   0.2297   0.9453]
        Angle     45.6928
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6068"
}

Galaxy "NGC 6068A:MCG 13-11-17:ZWG 354.30:ZWG 355.4"
{
        Type  "S0"
        RA           15.9131
        Dec          78.9856
        Distance   1.805e+08  # method: V
        Radius     2.362e+04
        AbsMag        -18.71
        Axis    [ -0.0698   0.3162   0.9461]
        Angle     82.0651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6068A"
}

Galaxy "NGC 6069:MCG 7-33-43:ZWG 223.42"
{
        Type  "S0"
        RA           16.1281
        Dec          38.9314
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.1750  -0.9571  -0.2311]
        Angle    157.0323
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6069"
}

Galaxy "NGC 6070:UGC 10230:MCG 0-41-4:ZWG 23.17"
{
        Type  "Sc"
        RA           16.1661
        Dec           0.7100
        Distance   1.253e+08  # method: T-F
        Radius     6.563e+04
        AbsMag        -20.42
        Axis    [  0.3815  -0.8835  -0.2719]
        Angle     83.2560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6070"
}

Galaxy "NGC 6070A:ZWG 23.18"
{
        Type  "S0"
        RA           16.1692
        Dec           0.7650
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.0085  -0.9566  -0.2912]
        Angle     68.3044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6070A"
}

Galaxy "NGC 6070B"
{
        Type  "E0"
        RA           16.1700
        Dec           0.7836
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.1992  -0.8229  -0.5321]
        Angle    164.8819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6070B"
}

Galaxy "NGC 6071:MCG 12-15-47:ZWG 338.41:NPM 1"
{
        Type  "S0"
        RA           16.0350
        Dec          70.4172
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.1220  -0.9917   0.0398]
        Angle    152.7296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6071"
}

Galaxy "NGC 6073:UGC 10235:MCG 3-41-139:ZWG 108.160"
{
        Type  "Sc"
        RA           16.1694
        Dec          16.7000
        Distance   2.134e+08  # method: T-F
        Radius     4.034e+04
        AbsMag        -19.78
        Axis    [ -0.3301  -0.8565   0.3968]
        Angle     48.1698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6073"
}

Galaxy "NGC 6074-1:MCG 2-41-15:ZWG 79.75"
{
        Type  "S0"
        RA           16.1881
        Dec          14.2586
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.2044  -0.8794  -0.4301]
        Angle    161.1823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6074-1"
}

Galaxy "NGC 6074-2:MCG 2-41-16:ZWG 79.75"
{
        Type  "E0"
        RA           16.1878
        Dec          14.2550
        Distance   9.121e+08  # distance uncertain!
        Radius      7.96e+04
        AbsMag        -20.13
        Axis    [  0.0668  -0.8658  -0.4959]
        Angle    136.2037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6074-2"
}

Galaxy "NGC 6075:IC 4594:MCG 4-38-38:ZWG 137.55"
{
        Type  "S0"
        RA           16.1894
        Dec          23.9650
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.1243  -0.9853  -0.1175]
        Angle     65.7544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6075"
}

Galaxy "NGC 6076-1:UGC 10253:MCG 5-38-23:ZWG 167.34"
{
        Type  "E0"
        RA           16.1867
        Dec          26.8719
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.1636  -0.9279  -0.3349]
        Angle    160.2876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6076-1"
}

Galaxy "NGC 6076-2:UGC 10253:MCG 5-38-23:ZWG 167.34"
{
        Type  "E0"
        RA           16.1869
        Dec          26.8736
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.1636  -0.9279  -0.3349]
        Angle    160.2903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6076-2"
}

Galaxy "NGC 6077:UGC 10254:MCG 5-38-24:ZWG 167.35"
{
        Type  "E0"
        RA           16.1872
        Dec          26.9239
        Distance   4.378e+08  # method: V
        Radius     7.642e+04
        AbsMag        -20.84
        Axis    [ -0.0317  -0.8875  -0.4598]
        Angle    105.4752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6077"
}

Galaxy "NGC 6078:MCG 2-41-17:ZWG 79.76:NPM 1"
{
        Type  "E0"
        RA           16.2014
        Dec          14.2094
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [  0.1797  -0.8828  -0.4339]
        Angle    162.6140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6078"
}

Galaxy "NGC 6079:IC 1200:UGC 10206:MCG 12-15-50"
{
        Type  "E0"
        RA           16.0744
        Dec          69.6661
        Distance   1.906e+08  # distance uncertain!
        Radius      3.88e+04
        AbsMag        -20.13
        Axis    [  0.4926  -0.2693  -0.8275]
        Angle     11.5135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6079"
}

Galaxy "NGC 6080:UGC 10268:MCG 0-41-7:ZWG 23.23"
{
        Type  "Sb"
        RA           16.2161
        Dec           2.1778
        Distance   3.408e+08  # method: V
        Radius     5.947e+04
        AbsMag        -20.89
        Axis    [  0.2382  -0.8477  -0.4740]
        Angle    105.2895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6080"
}

Galaxy "NGC 6081:IC 1202:UGC 10272:MCG 2-41-19"
{
        Type  "S0"
        RA           16.2156
        Dec           9.8678
        Distance   1.688e+08  # distance uncertain!
        Radius      4.42e+04
        AbsMag        -19.07
        Axis    [ -0.2701  -0.8166   0.5101]
        Angle     57.1904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6081"
}

Galaxy "NGC 6083:MCG 2-41-20:ZWG 79.80:NPM 1"
{
        Type  "Sb"
        RA           16.2200
        Dec          14.1861
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.4977  -0.8376  -0.2253]
        Angle    102.8300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6083"
}

Galaxy "NGC 6084:UGC 10291:MCG 3-41-143:ZWG 108.168"
{
        Type  "Sb"
        RA           16.2378
        Dec          17.7581
        Distance   4.151e+08  # method: V
        Radius     6.037e+04
        AbsMag        -20.62
        Axis    [  0.5868  -0.7864  -0.1931]
        Angle    113.1292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6084"
}

Galaxy "NGC 6085:UGC 10269:MCG 5-38-34:ZWG 167.44"
{
        Type  "Sa"
        RA           16.2097
        Dec          29.3656
        Distance   4.592e+08  # method: V
        Radius     1.002e+05
        AbsMag        -21.34
        Axis    [ -0.8824  -0.1616   0.4419]
        Angle     37.9496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6085"
}

Galaxy "NGC 6086:UGC 10270:MCG 5-38-35:ZWG 167.45"
{
        Type  "E0"
        RA           16.2097
        Dec          29.4850
        Distance   4.978e+08  # method: T-F
        Radius     1.231e+05
        AbsMag        -22.02
        Axis    [  0.1268  -0.9333  -0.3361]
        Angle    148.9004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6086"
}

Galaxy "NGC 6088A:MCG 10-23-29:ZWG 298.13:KCPG 485B"
{
        Type  "Sc"
        RA           16.1783
        Dec          57.4661
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.1273  -0.2971   0.9463]
        Angle     57.6186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6088A"
}

Galaxy "NGC 6088B:MCG 10-23-30:ZWG 298.13:KCPG 485A"
{
        Type  "S0"
        RA           16.1789
        Dec          57.4619
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.4754  -0.6291   0.6150]
        Angle     77.4843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6088B"
}

Galaxy "NGC 6089-1:MCG 6-36-1:ZWG 196.4:ZWG 196.91"
{
        Type  "Sa"
        RA           16.2111
        Dec          33.0353
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.4842  -0.8716  -0.0767]
        Angle    108.0642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6089-1"
}

Galaxy "NGC 6089-2:MCG 6-36-1:ZWG 196.4:ZWG 196.91"
{
        Type  "E0"
        RA           16.2114
        Dec          33.0383
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.1522  -0.9464  -0.2850]
        Angle    159.5870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6089-2"
}

Galaxy "NGC 6090:UGC 10267:MCG 9-26-64:MK 496"
{
        Type  "Sb"
        RA           16.1944
        Dec          52.4578
        Distance   3.995e+08  # method: V
        Radius     1.394e+05
        AbsMag        -20.94
        Axis    [  0.6354  -0.7454   0.2017]
        Angle    119.3022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6090"
}

Galaxy "NGC 6091:MCG 12-15-54:ZWG 338.47:NPM 1"
{
        Type  "S0"
        RA           16.1311
        Dec          69.9053
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.4303  -0.5131   0.7427]
        Angle     62.4689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6091"
}

Galaxy "NGC 6094:UGC 10228:MCG 12-15-52:ZWG 338.45"
{
        Type  "S0"
        RA           16.1092
        Dec          72.4950
        Distance   1.938e+08  # distance uncertain!
        Radius     5.075e+04
        AbsMag        -19.07
        Axis    [  0.4345  -0.5506   0.7127]
        Angle     50.3020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6094"
}

Galaxy "NGC 6095:UGC 10265:MCG 10-23-33:ZWG 298.14"
{
        Type  "S0"
        RA           16.1864
        Dec          61.2681
        Distance   4.195e+08  # method: V
        Radius     1.098e+05
        AbsMag        -21.85
        Axis    [  0.2176  -0.7721   0.5971]
        Angle     29.1631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6095"
}

Galaxy "NGC 6096:MCG 5-38-44:ZWG 167.57:NPM 1"
{
        Type  "Sb"
        RA           16.2461
        Dec          26.5594
        Distance   4.473e+08  # method: V
        Radius     5.855e+04
        AbsMag        -20.49
        Axis    [ -0.2140  -0.7045   0.6767]
        Angle     50.9896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6096"
}

Galaxy "NGC 6097:MCG 6-36-7:ZWG 196.11"
{
        Type  "Sa"
        RA           16.2406
        Dec          35.1092
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.4674  -0.3439   0.8144]
        Angle     46.5211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6097"
}

Galaxy "NGC 6098:UGC 10299:MCG 3-41-145:ZWG 108.170"
{
        Type  "E0"
        RA           16.2594
        Dec          19.4617
        Distance   5.607e+08  # method: V
        Radius     8.156e+04
        AbsMag        -21.88
        Axis    [ -0.6934  -0.3400  -0.6353]
        Angle     53.4351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6098"
}

Galaxy "NGC 6099:UGC 10299:MCG 3-41-146:ZWG 108.170"
{
        Type  "E0"
        RA           16.2597
        Dec          19.4539
        Distance   5.743e+08  # method: V
        Radius     1.086e+05
        AbsMag        -21.03
        Axis    [  0.1671  -0.9038  -0.3940]
        Angle    162.2776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6099"
}

Galaxy "NGC 6100:UGC 10307:MCG 0-41-12:ZWG 23.32"
{
        Type  "Sa"
        RA           16.2811
        Dec           0.8411
        Distance    1.54e+08  # distance uncertain!
        Radius     4.031e+04
        AbsMag        -19.07
        Axis    [ -0.3738  -0.9274  -0.0140]
        Angle     56.6019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6100"
}

Galaxy "NGC 6102:UGC 10300:MCG 5-38-47:ZWG 167.60"
{
        Type  "Sc"
        RA           16.2600
        Dec          28.1589
        Distance   3.438e+08  # method: V
        Radius         6e+04
        AbsMag        -20.01
        Axis    [  0.3613  -0.9320  -0.0307]
        Angle     82.7882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6102"
}

Galaxy "NGC 6103:UGC 10302:MCG 5-38-49:ZWG 167.62"
{
        Type  "Sc"
        RA           16.2622
        Dec          31.9639
        Distance   4.278e+08  # method: V
        Radius     4.356e+04
        AbsMag        -21.09
        Axis    [  0.2980  -0.9544   0.0187]
        Angle     74.7867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6103"
}

Galaxy "NGC 6104:UGC 10309:MCG 6-36-11:ZWG 196.20"
{
        Type  "SBa"
        RA           16.2750
        Dec          35.7075
        Distance   3.822e+08  # method: V
        Radius     4.447e+04
        AbsMag        -21.14
        Axis    [  0.3127  -0.9351  -0.1664]
        Angle    108.8192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6104"
}

Galaxy "NGC 6105:MCG 6-36-13:ZWG 196.23:NPM 1"
{
        Type  "SBa"
        RA           16.2858
        Dec          34.8794
        Distance   3.945e+08  # method: V
        Radius     3.443e+04
        AbsMag        -19.71
        Axis    [ -0.2952  -0.7233   0.6243]
        Angle     39.5711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6105"
}

Galaxy "NGC 6106:UGC 10328:MCG 1-41-16:ZWG 52.1"
{
        Type  "Sc"
        RA           16.3131
        Dec           7.4111
        Distance   8.331e+07  # method: T-F
        Radius     2.908e+04
        AbsMag        -19.14
        Axis    [ -0.5534  -0.7619   0.3366]
        Angle     53.8637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6106"
}

Galaxy "NGC 6107:UGC 10311:MCG 6-36-14:ZWG 196.24"
{
        Type  "E0"
        RA           16.2889
        Dec          34.9022
        Distance   4.095e+08  # method: T-F
        Radius     8.934e+04
        AbsMag        -20.69
        Axis    [  0.0470  -0.9392  -0.3402]
        Angle    122.3129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6107"
}

Galaxy "NGC 6108:MCG 6-36-15:ZWG 196.25:KUG 1615+352"
{
        Type  "SBb"
        RA           16.2903
        Dec          35.1358
        Distance   4.155e+08  # method: V
        Radius     6.647e+04
        AbsMag        -20.23
        Axis    [ -0.2755  -0.9596  -0.0567]
        Angle     39.0523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6108"
}

Galaxy "NGC 6109:UGC 10316:MCG 6-36-16:ZWG 196.26"
{
        Type  "S0"
        RA           16.2944
        Dec          35.0042
        Distance   4.095e+08  # method: T-F
        Radius     5.956e+04
        AbsMag        -21.49
        Axis    [  0.1672  -0.9497  -0.2648]
        Angle    159.4448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6109"
}

Galaxy "NGC 6110:ZWG 196.27:KUG 1615+352"
{
        Type  "Sb"
        RA           16.2953
        Dec          35.0875
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.2548  -0.8563   0.4493]
        Angle     60.9127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6110"
}

Galaxy "NGC 6111:MCG 11-20-7:ZWG 320.14"
{
        Type  "E0"
        RA           16.2394
        Dec          63.2614
        Distance   3.802e+08  # distance uncertain!
        Radius     3.871e+04
        AbsMag        -20.13
        Axis    [  0.0975  -0.9940  -0.0489]
        Angle    135.2397
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6111"
}

Galaxy "NGC 6112:MCG 6-36-17:ZWG 196.28:NPM 1"
{
        Type  "E0"
        RA           16.3000
        Dec          35.1108
        Distance   4.246e+08  # method: V
        Radius     6.176e+04
        AbsMag        -20.17
        Axis    [ -0.0471  -0.9148  -0.4012]
        Angle     95.4353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6112"
}

Galaxy "NGC 6113:MCG 2-41-24:ZWG 80.4"
{
        Type  "S0"
        RA           16.3194
        Dec          14.1336
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.5083  -0.6444   0.5713]
        Angle     55.6620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6113"
}

Galaxy "NGC 6114:MCG 6-36-19:ZWG 196.30:KUG 1616+352"
{
        Type  "Sc"
        RA           16.3064
        Dec          35.1744
        Distance   3.961e+08  # method: V
        Radius     6.913e+04
        AbsMag        -20.22
        Axis    [  0.3000  -0.8650   0.4021]
        Angle     64.1681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6114"
}

Galaxy "NGC 6116:UGC 10336:MCG 6-36-21:ZWG 196.32"
{
        Type  "Sb"
        RA           16.3150
        Dec          35.1539
        Distance    4.01e+08  # method: V
        Radius     1.283e+05
        AbsMag        -20.35
        Axis    [  0.6679  -0.7423  -0.0537]
        Angle    131.1537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6116"
}

Galaxy "NGC 6117:NGC 6117A:UGC 10338:MCG 6-36-22"
{
        Type  "Sc"
        RA           16.3217
        Dec          37.0953
        Distance   3.905e+08  # method: V
        Radius     6.816e+04
        AbsMag        -20.89
        Axis    [  0.1619  -0.9552  -0.2476]
        Angle    159.5206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6117"
}

Galaxy "NGC 6117B:MCG 6-36-24:KUG 1617+371"
{
        Type  "Sc"
        RA           16.3225
        Dec          37.0689
        Distance   1.851e+08  # distance uncertain!
        Radius     1.615e+04
        AbsMag        -19.07
        Axis    [  0.0443  -0.7383   0.6730]
        Angle     52.1347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6117B"
}

Galaxy "NGC 6118:UGC 10350:MCG 0-42-2:ZWG 24.8"
{
        Type  "Sc"
        RA           16.3633
        Dec          -2.2836
        Distance   8.603e+07  # method: T-F
        Radius     5.881e+04
        AbsMag         -19.7
        Axis    [  0.4294  -0.8665  -0.2547]
        Angle     85.9895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6118"
}

Galaxy "NGC 6119:MCG 6-36-26:ZWG 196.40:KUG 1617+379"
{
        Type  "Sc"
        RA           16.3283
        Dec          37.8067
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.2938  -0.9470   0.1303]
        Angle     70.4953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6119"
}

Galaxy "NGC 6120:UGC 10343:MCG 6-36-29:ZWG 196.41"
{
        Type  "Irr"
        RA           16.3300
        Dec          37.7742
        Distance   4.176e+08  # method: V
        Radius     6.074e+04
        AbsMag        -21.04
        Axis    [  0.5085  -0.8538  -0.1120]
        Angle    133.1835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6120"
}

Galaxy "NGC 6122:MCG 6-36-32:NPM 1"
{
        Type  "S0"
        RA           16.3358
        Dec          37.7986
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.2877  -0.3048   0.9079]
        Angle     60.6835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6122"
}

Galaxy "NGC 6123:UGC 10333:MCG 10-23-60:ZWG 298.28"
{
        Type  "Sa"
        RA           16.2886
        Dec          61.9392
        Distance   1.811e+08  # method: V
        Radius     2.107e+04
        AbsMag        -19.12
        Axis    [  0.6737  -0.7308   0.1094]
        Angle    155.4710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6123"
}

Galaxy "NGC 6125:NGC 6127:NGC 6128:UGC 10345"
{
        Type  "E0"
        RA           16.3197
        Dec          57.9847
        Distance   2.096e+08  # method: V
        Radius     4.267e+04
        AbsMag        -21.04
        Axis    [  0.1035  -0.9918  -0.0744]
        Angle    157.7295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6125"
}

Galaxy "NGC 6126:UGC 10353:MCG 6-36-35:ZWG 196.46"
{
        Type  "S0"
        RA           16.3575
        Dec          36.3772
        Distance   4.443e+08  # method: V
        Radius     6.462e+04
        AbsMag        -21.07
        Axis    [  0.1600  -0.9539  -0.2538]
        Angle    160.0174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6126"
}

Galaxy "NGC 6129:MCG 6-36-37:ZWG 196.48:NPM 1"
{
        Type  "S0"
        RA           16.3619
        Dec          37.9964
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.1573  -0.9579  -0.2402]
        Angle    159.8937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6129"
}

Galaxy "NGC 6130:UGC 10347:MCG 10-23-66:ZWG 298.30"
{
        Type  "SBc"
        RA           16.3258
        Dec          57.6150
        Distance   2.303e+08  # method: V
        Radius     3.349e+04
        AbsMag        -20.04
        Axis    [  0.4997  -0.8618   0.0876]
        Angle    132.6272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6130"
}

Galaxy "NGC 6131:NGC 6131A:UGC 10356:MCG 7-34-4"
{
        Type  "SBc"
        RA           16.3644
        Dec          38.9367
        Distance   2.353e+08  # method: V
        Radius     3.423e+04
        AbsMag        -20.49
        Axis    [  0.1558  -0.9601  -0.2324]
        Angle    159.8234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6131"
}

Galaxy "NGC 6131B:MCG 7-34-5:KUG 1620+390"
{
        Type  "S0"
        RA           16.3667
        Dec          38.9158
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.5781  -0.8147   0.0456]
        Angle    113.4020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6131B"
}

Galaxy "NGC 6132:IC 4602:UGC 10363:MCG 2-42-2"
{
        Type  "Sb"
        RA           16.3939
        Dec          11.7867
        Distance   2.281e+08  # method: V
        Radius     4.976e+04
        AbsMag        -19.52
        Axis    [ -0.1819  -0.8418   0.5081]
        Angle     59.3466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6132"
}

Galaxy "NGC 6135:MCG 11-20-8:ZWG 320.15"
{
        Type  "S0"
        RA           16.2400
        Dec          64.9833
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.6521  -0.6688   0.3570]
        Angle    123.7265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6135"
}

Galaxy "NGC 6136:MCG 9-27-19:ZWG 276.10"
{
        Type  "Sc"
        RA           16.3497
        Dec          55.9703
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.4887  -0.6045   0.6291]
        Angle     83.6808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6136"
}

Galaxy "NGC 6137:NGC 6137A:UGC 10364:MCG 6-36-39"
{
        Type  "E0"
        RA           16.3842
        Dec          37.9225
        Distance   4.234e+08  # method: V
        Radius      1.17e+05
        AbsMag        -21.47
        Axis    [ -0.7844   0.4138  -0.4620]
        Angle     35.0147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6137"
}

Galaxy "NGC 6137B:MCG 6-36-38:ZWG 196.52"
{
        Type  "Sa"
        RA           16.3831
        Dec          37.9492
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.1557  -0.9580  -0.2408]
        Angle    160.1468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6137B"
}

Galaxy "NGC 6138:NGC 6363:UGC 10827:MCG 7-36-5"
{
        Type  "E0"
        RA           17.3775
        Dec          41.1022
        Distance   2.754e+08  # distance uncertain!
        Radius     4.407e+04
        AbsMag        -20.13
        Axis    [  0.0213  -0.9735  -0.2277]
        Angle    158.8295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6138"
}

Galaxy "NGC 6140:UGC 10359:MCG 11-20-12:ZWG 320.25"
{
        Type  "SBc"
        RA           16.3492
        Dec          65.3900
        Distance   4.136e+07  # method: V
        Radius      3.79e+04
        AbsMag        -18.61
        Axis    [  0.4322  -0.7693   0.4705]
        Angle     71.8990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6140"
}

Galaxy "NGC 6141"
{
        Type  "S0"
        RA           16.3850
        Dec          40.8583
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.1514  -0.9645  -0.2163]
        Angle    159.8701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6141"
}

Galaxy "NGC 6142:UGC 10366:MCG 6-36-41:ZWG 196.56"
{
        Type  "Sb"
        RA           16.3892
        Dec          37.2583
        Distance   1.768e+08  # distance uncertain!
        Radius     5.142e+04
        AbsMag        -19.07
        Axis    [ -0.3422  -0.2155   0.9146]
        Angle     69.9517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6142"
}

Galaxy "NGC 6143:UGC 10358:MCG 9-27-24:ZWG 276.11"
{
        Type  "SBc"
        RA           16.3617
        Dec          55.0864
        Distance   1.281e+08  # distance uncertain!
        Radius     1.863e+04
        AbsMag        -19.07
        Axis    [ -0.5610   0.5544   0.6147]
        Angle     27.3244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6143"
}

Galaxy "NGC 6145:MCG 7-34-21:ZWG 224.17"
{
        Type  "Sc"
        RA           16.4172
        Dec          40.9464
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6315  -0.7713  -0.0790]
        Angle    145.7735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6145"
}

Galaxy "NGC 6146:UGC 10379:MCG 7-34-24:ZWG 224.18"
{
        Type  "E0"
        RA           16.4194
        Dec          40.8925
        Distance    2.86e+08  # method: T-F
        Radius     5.408e+04
        AbsMag        -21.21
        Axis    [ -0.0512  -0.9349  -0.3511]
        Angle     89.1581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6146"
}

Galaxy "NGC 6147:MCG 7-34-23"
{
        Type  "Sb"
        RA           16.4181
        Dec          40.9289
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.4484  -0.8908  -0.0737]
        Angle    124.1022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6147"
}

Galaxy "NGC 6148"
{
        Type  "S0"
        RA           16.4511
        Dec          24.0928
        Distance   5.098e+08  # distance uncertain!
        Radius     4.449e+04
        AbsMag        -19.07
        Axis    [  0.4726  -0.8813  -0.0086]
        Angle     92.3086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6148"
}

Galaxy "NGC 6149:UGC 10391:MCG 3-42-11:ZWG 109.21"
{
        Type  "S0"
        RA           16.4567
        Dec          19.5975
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.4557  -0.8440  -0.2829]
        Angle    127.0793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6149"
}

Galaxy "NGC 6150:NGC 6150A:MCG 7-34-29:ZWG 224.22"
{
        Type  "E0"
        RA           16.4303
        Dec          40.4889
        Distance    4.01e+08  # method: V
        Radius     7.581e+04
        AbsMag        -20.45
        Axis    [ -0.0097  -0.9464  -0.3227]
        Angle    102.5738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6150"
}

Galaxy "NGC 6150B:MCG 7-34-27:IRAS 16240+4035"
{
        Type  "S0"
        RA           16.4289
        Dec          40.4756
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.1354  -0.4408   0.8874]
        Angle     56.2770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6150B"
}

Galaxy "NGC 6154:UGC 10382:MCG 8-30-12:ZWG 251.16"
{
        Type  "SBa"
        RA           16.4250
        Dec          49.8403
        Distance   2.736e+08  # method: V
        Radius     8.356e+04
        AbsMag        -20.92
        Axis    [  0.2893  -0.9509  -0.1102]
        Angle    157.2619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6154"
}

Galaxy "NGC 6155:UGC 10385:MCG 8-30-13:ZWG 251.18"
{
        Type  "Sc"
        RA           16.4356
        Dec          48.3675
        Distance   1.112e+08  # method: V
        Radius     2.102e+04
        AbsMag        -19.56
        Axis    [ -0.1518  -0.5017   0.8516]
        Angle     38.1504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6155"
}

Galaxy "NGC 6156:ESO 137-33:FAIR 329:IRAS 16304-6030"
{
        Type  "SBc"
        RA           16.5811
        Dec         -60.6192
        Distance   1.502e+08  # method: V
        Radius     3.495e+04
        AbsMag        -21.02
        Axis    [  0.3101  -0.3805  -0.8712]
        Angle    150.2968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6156"
}

Galaxy "NGC 6157:MCG 9-27-39:ZWG 276.18:NPM 1"
{
        Type  "S0"
        RA           16.4300
        Dec          55.3611
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.4086  -0.9126  -0.0168]
        Angle    148.2073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6157"
}

Galaxy "NGC 6158:MCG 7-34-41:ZWG 224.31"
{
        Type  "S0"
        RA           16.4611
        Dec          39.3833
        Distance   5.153e+08  # method: T-F
        Radius     6.746e+04
        AbsMag        -21.19
        Axis    [  0.3528  -0.9221   0.1589]
        Angle     78.2701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6158"
}

Galaxy "NGC 6159:UGC 10397:MCG 7-34-38:ZWG 224.29"
{
        Type  "S0"
        RA           16.4569
        Dec          42.6803
        Distance   3.072e+08  # distance uncertain!
        Radius     6.256e+04
        AbsMag        -19.07
        Axis    [ -0.2346  -0.6429   0.7292]
        Angle     37.5180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6159"
}

Galaxy "NGC 6160:UGC 10400:MCG 7-34-42:ZWG 224.32"
{
        Type  "E0"
        RA           16.4614
        Dec          40.9275
        Distance    2.86e+08  # method: T-F
        Radius     7.487e+04
        AbsMag        -20.41
        Axis    [ -0.0224  -0.9456  -0.3246]
        Angle     99.0113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6160"
}

Galaxy "NGC 6161:MCG 6-36-46:ZWG 168.13:HCG 82"
{
        Type  "Sc"
        RA           16.4722
        Dec          32.8103
        Distance   4.593e+08  # method: V
        Radius     6.012e+04
        AbsMag        -20.14
        Axis    [ -0.3580  -0.3398   0.8697]
        Angle     62.8280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6161"
}

Galaxy "NGC 6162:UGC 10403:MCG 6-36-47:ZWG 168.14"
{
        Type  "S0"
        RA           16.4728
        Dec          32.8497
        Distance   5.083e+08  # method: V
        Radius     6.654e+04
        AbsMag        -21.36
        Axis    [  0.4136  -0.8956  -0.1638]
        Angle    123.3249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6162"
}

Galaxy "NGC 6163:MCG 6-36-48:ZWG 168.15:HCG 82B"
{
        Type  "S0"
        RA           16.4742
        Dec          32.8469
        Distance   4.753e+08  # method: V
        Radius     4.147e+04
        AbsMag        -20.42
        Axis    [  0.5212  -0.8519   0.0510]
        Angle    100.3868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6163"
}

Galaxy "NGC 6166:UGC 10409:MCG 7-34-60:ZWG 224.39"
{
        Type  "E0"
        RA           16.4772
        Dec          39.5514
        Distance   5.153e+08  # method: T-F
        Radius     1.424e+05
        AbsMag        -23.09
        Axis    [  0.0497  -0.9580  -0.2826]
        Angle    128.1066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6166"
}

Galaxy "NGC 6166A:MCG 7-34-50"
{
        Type  "S0"
        RA           16.4753
        Dec          39.5211
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.0610  -0.8707   0.4880]
        Angle     49.6688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6166A"
}

Galaxy "NGC 6166B:MCG 7-34-76:ZWG 224.45:KUG 1627+396"
{
        Type  "S0"
        RA           16.4814
        Dec          39.5608
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.4825  -0.8643  -0.1421]
        Angle    147.2291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6166B"
}

Galaxy "NGC 6166C:MCG 7-34-48"
{
        Type  "E0"
        RA           16.4731
        Dec          39.5706
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.1208  -0.9653  -0.2317]
        Angle    161.7366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6166C"
}

Galaxy "NGC 6166D:MCG 7-34-56"
{
        Type  "S0"
        RA           16.4775
        Dec          39.5189
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.3721  -0.9282  -0.0012]
        Angle     96.5500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6166D"
}

Galaxy "NGC 6168:UGC 10434:MCG 3-42-16:ZWG 109.28"
{
        Type  "Irr"
        RA           16.5225
        Dec          20.1850
        Distance   1.167e+08  # method: V
        Radius     2.375e+04
        AbsMag        -18.07
        Axis    [  0.1904  -0.7934   0.5782]
        Angle     70.0016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6168"
}

Galaxy "NGC 6170:NGC 6176:MCG 10-23-76:ZWG 298.38"
{
        Type  "S0"
        RA           16.4600
        Dec          59.5631
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.3317  -0.9173   0.2204]
        Angle     76.0703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6170"
}

Galaxy "NGC 6172:IC 1213:UGC 10352:MCG 0-42-3"
{
        Type  "E0"
        RA           16.3694
        Dec          -1.5142
        Distance   2.295e+08  # method: V
        Radius      2.67e+04
        AbsMag        -20.44
        Axis    [  0.1798  -0.8152  -0.5506]
        Angle    166.9214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6172"
}

Galaxy "NGC 6173:UGC 10421:MCG 7-34-83:ZWG 224.49"
{
        Type  "E0"
        RA           16.4958
        Dec          40.8111
        Distance    2.86e+08  # method: T-F
        Radius     7.903e+04
        AbsMag        -21.51
        Axis    [ -0.5429  -0.5860  -0.6015]
        Angle     35.5429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6173"
}

Galaxy "NGC 6175-1:UGC 10422:MCG 7-34-87:ZWG 224.50"
{
        Type  "S0"
        RA           16.4992
        Dec          40.6303
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.3310  -0.8975   0.2913]
        Angle     71.1282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6175-1"
}

Galaxy "NGC 6175-2:UGC 10422:MCG 7-34-87:ZWG 224.50"
{
        Type  "E0"
        RA           16.4994
        Dec          40.6281
        Distance   3.468e+08  # distance uncertain!
        Radius     3.026e+04
        AbsMag        -20.13
        Axis    [  0.1173  -0.9678  -0.2228]
        Angle    161.9259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6175-2"
}

Galaxy "NGC 6177:UGC 10428:MCG 6-36-49:ZWG 196.72"
{
        Type  "SBb"
        RA           16.5106
        Dec          35.0556
        Distance   4.232e+08  # method: V
        Radius     1.046e+05
        AbsMag        -21.06
        Axis    [  0.5041  -0.8481  -0.1630]
        Angle    141.9658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6177"
}

Galaxy "NGC 6179:ZWG 196.73:NPM 1"
{
        Type  "E0"
        RA           16.5128
        Dec          35.1028
        Distance    6.31e+08  # distance uncertain!
        Radius     3.671e+04
        AbsMag        -20.13
        Axis    [  0.1236  -0.9552  -0.2690]
        Angle    162.7484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6179"
}

Galaxy "NGC 6180:MCG 7-34-95:ZWG 224.58"
{
        Type  "E0"
        RA           16.5092
        Dec          40.5397
        Distance   4.142e+08  # method: V
        Radius     5.422e+04
        AbsMag        -20.42
        Axis    [  0.1002  -0.9667  -0.2356]
        Angle    153.3478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6180"
}

Galaxy "NGC 6181:UGC 10439:MCG 3-42-20:ZWG 109.31"
{
        Type  "SBc"
        RA           16.5389
        Dec          19.8256
        Distance   1.073e+08  # method: T-F
        Radius     3.901e+04
        AbsMag        -20.08
        Axis    [ -0.6629  -0.2597   0.7022]
        Angle     67.1160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6181"
}

Galaxy "NGC 6182:UGC 10424:MCG 9-27-48:ZWG 276.24"
{
        Type  "Sa"
        RA           16.4925
        Dec          55.5178
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.0553  -0.2350   0.9704]
        Angle     68.8506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6182"
}

Galaxy "NGC 6183:ESO 69-8"
{
        Type  "Sa"
        RA           16.6947
        Dec         -69.3725
        Distance   2.235e+08  # method: V
        Radius     5.852e+04
        AbsMag        -21.08
        Axis    [  0.1678  -0.4678  -0.8678]
        Angle     97.2492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6183"
}

Galaxy "NGC 6184:MCG 7-34-109:ZWG 224.70:KUG 1629+406"
{
        Type  "Sb"
        RA           16.5261
        Dec          40.5656
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.0003  -0.7760   0.6307]
        Angle     48.2920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6184"
}

Galaxy "NGC 6185:UGC 10444:MCG 6-36-52:ZWG 196.77"
{
        Type  "Sa"
        RA           16.5547
        Dec          35.3422
        Distance    4.68e+08  # method: V
        Radius     8.168e+04
        AbsMag        -21.38
        Axis    [  0.4887  -0.8509  -0.1928]
        Angle    152.6022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6185"
}

Galaxy "NGC 6186:UGC 10448:MCG 4-39-15:ZWG 138.38"
{
        Type  "SBa"
        RA           16.5736
        Dec          21.5414
        Distance   5.164e+08  # method: V
        Radius     1.127e+05
        AbsMag           -22
        Axis    [  0.2460  -0.9417  -0.2294]
        Angle     96.3382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6186"
}

Galaxy "NGC 6187:MCG 10-23-79:ZWG 298.42:ZWG 299.2"
{
        Type  "S0"
        RA           16.5267
        Dec          57.7072
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.1931  -0.6745   0.7126]
        Angle     43.8222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6187"
}

Galaxy "NGC 6189:NGC 6191:UGC 10442:MCG 10-23-81"
{
        Type  "SBc"
        RA           16.5278
        Dec          59.6267
        Distance   2.504e+08  # method: V
        Radius     6.919e+04
        AbsMag        -21.13
        Axis    [  0.6115  -0.7801   0.1325]
        Angle    142.3501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6189"
}

Galaxy "NGC 6190:UGC 10443:MCG 10-23-82:ZWG 298.44"
{
        Type  "Sc"
        RA           16.5350
        Dec          58.4392
        Distance   1.524e+08  # method: V
        Radius     3.103e+04
        AbsMag        -20.15
        Axis    [  0.2709  -0.9614   0.0488]
        Angle     99.9073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6190"
}

Galaxy "NGC 6194:MCG 6-36-54:ZWG 196.82:KUG 1634+363"
{
        Type  "S0"
        RA           16.6103
        Dec          36.2006
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.0718  -0.9895   0.1253]
        Angle     58.5335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6194"
}

Galaxy "NGC 6195:UGC 10469:MCG 7-34-118:ZWG 224.75"
{
        Type  "Sb"
        RA           16.6089
        Dec          39.0283
        Distance   4.089e+08  # method: V
        Radius     8.921e+04
        AbsMag        -21.59
        Axis    [  0.4107  -0.9106  -0.0460]
        Angle    111.8423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6195"
}

Galaxy "NGC 6196:IC 4615:UGC 10482:MCG 6-36-58"
{
        Type  "S0"
        RA           16.6314
        Dec          36.0731
        Distance   4.281e+08  # method: V
        Radius     1.245e+05
        AbsMag        -21.59
        Axis    [ -0.2143  -0.6709   0.7099]
        Angle     47.2543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6196"
}

Galaxy "NGC 6197:IC 4616:MCG 6-36-59:ZWG 196.89"
{
        Type  "SBa"
        RA           16.6331
        Dec          35.9958
        Distance   2.676e+08  # distance uncertain!
        Radius     5.059e+04
        AbsMag        -19.07
        Axis    [  0.6188  -0.7846   0.0387]
        Angle    117.9814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6197"
}

Galaxy "NGC 6198:UGC 10467:MCG 10-24-3:ZWG 299.7"
{
        Type  "E0"
        RA           16.5917
        Dec          57.4872
        Distance   3.312e+08  # distance uncertain!
        Radius     4.817e+04
        AbsMag        -20.13
        Axis    [  0.0099  -0.9805  -0.1963]
        Angle     72.3110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6198"
}

Galaxy "NGC 6201:ZWG 138.53"
{
        Type  "E0"
        RA           16.6706
        Dec          23.7653
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.0570  -0.9181  -0.3922]
        Angle    146.5431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6201"
}

Galaxy "NGC 6203:MCG 4-39-19:ZWG 138.55:NPM 1"
{
        Type  "S0"
        RA           16.6742
        Dec          23.7753
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.1470  -0.9217  -0.3591]
        Angle    164.8499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6203"
}

Galaxy "NGC 6206:IC 1227:UGC 10506:MCG 10-24-18"
{
        Type  "S0"
        RA           16.6686
        Dec          58.6172
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [  0.1068  -0.9922  -0.0650]
        Angle    162.0896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6206"
}

Galaxy "NGC 6207:UGC 10521:MCG 6-37-7:ZWG 197.7"
{
        Type  "Sc"
        RA           16.7175
        Dec          36.8319
        Distance   3.946e+07  # method: V
        Radius     1.722e+04
        AbsMag        -18.31
        Axis    [  0.6472  -0.7593  -0.0679]
        Angle    137.6391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6207"
}

Galaxy "NGC 6209:ESO 43-8:AM 1649-723:IRAS 16489-7230"
{
        Type  "Sc"
        RA           16.9158
        Dec         -72.5867
        Distance   2.621e+08  # method: T-F
        Radius     7.623e+04
        AbsMag        -21.92
        Axis    [  0.1879  -0.3225  -0.9277]
        Angle    139.3410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6209"
}

Galaxy "NGC 6211:UGC 10516:MCG 10-24-27:ZWG 299.14"
{
        Type  "S0"
        RA           16.6908
        Dec          57.7839
        Distance   1.115e+08  # distance uncertain!
        Radius     2.596e+04
        AbsMag        -19.07
        Axis    [  0.3457  -0.8508   0.3957]
        Angle     69.4900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6211"
}

Galaxy "NGC 6212:MCG 7-34-142:ZWG 224.96"
{
        Type  "E0"
        RA           16.7231
        Dec          39.8072
        Distance   4.154e+08  # method: V
        Radius     3.625e+04
        AbsMag        -20.32
        Axis    [ -0.2231  -0.8870  -0.4042]
        Angle     65.2632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6212"
}

Galaxy "NGC 6213:MCG 10-24-30:ZWG 299.17"
{
        Type  "Sa"
        RA           16.6936
        Dec          57.8150
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.5792  -0.7528   0.3127]
        Angle    113.0664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6213"
}

Galaxy "NGC 6214:UGC 10507:MCG 11-20-24:ZWG 320.36"
{
        Type  "Sc"
        RA           16.6586
        Dec          66.0397
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.2089  -0.4087   0.8885]
        Angle     36.7054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6214"
}

Galaxy "NGC 6215:ESO 137-46:IRAS 16467-5854"
{
        Type  "Sc"
        RA           16.8519
        Dec         -58.9931
        Distance   7.303e+07  # method: V
        Radius     2.337e+04
        AbsMag        -19.95
        Axis    [ -0.3859  -0.5007  -0.7748]
        Angle    123.5872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6215"
}

Galaxy "NGC 6215A:ESO 138-4"
{
        Type  "Sb"
        RA           16.8800
        Dec         -58.9469
        Distance   1.334e+08  # method: V
        Radius     2.911e+04
        AbsMag        -18.86
        Axis    [  0.4089  -0.3908  -0.8247]
        Angle    106.7739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6215A"
}

Galaxy "NGC 6217:UGC 10470:MCG 13-12-8:ZWG 355.14"
{
        Type  "SBc"
        RA           16.5439
        Dec          78.1992
        Distance    6.07e+07  # method: V
        Radius     2.649e+04
        AbsMag        -19.55
        Axis    [  0.3888  -0.0463   0.9201]
        Angle     36.3196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6217"
}

Galaxy "NGC 6219:MCG 2-43-1:ZWG 81.4"
{
        Type  "S0"
        RA           16.7728
        Dec           9.0383
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.1499  -0.8670  -0.4751]
        Angle    167.3192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6219"
}

Galaxy "NGC 6220:UGC 10541:ZWG 25.4:NPM 1"
{
        Type  "Sb"
        RA           16.7869
        Dec          -0.2750
        Distance   1.851e+08  # distance uncertain!
        Radius     4.577e+04
        AbsMag        -19.07
        Axis    [ -0.4979  -0.8295   0.2531]
        Angle     63.5525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6220"
}

Galaxy "NGC 6221:ESO 138-3:AM 1648-590:IRAS 16484-5908"
{
        Type  "SBc"
        RA           16.8794
        Dec         -59.2183
        Distance   6.922e+07  # method: V
        Radius     3.524e+04
        AbsMag        -20.83
        Axis    [  0.3074  -0.3976  -0.8645]
        Angle    133.9693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6221"
}

Galaxy "NGC 6223:UGC 10527:MCG 10-24-40:ZWG 299.21"
{
        Type  "S0"
        RA           16.7178
        Dec          61.5786
        Distance    7.37e+07  # distance uncertain!
        Radius     3.751e+04
        AbsMag        -19.07
        Axis    [  0.3969  -0.8432   0.3625]
        Angle     80.8941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6223"
}

Galaxy "NGC 6224:UGC 10555:MCG 1-43-2:ZWG 53.10"
{
        Type  "S0"
        RA           16.8050
        Dec           6.3122
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.1485  -0.8556  -0.4959]
        Angle    167.8912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6224"
}

Galaxy "NGC 6225:UGC 10556:MCG 1-43-3:ZWG 53.11"
{
        Type  "S0"
        RA           16.8058
        Dec           6.2231
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.7475  -0.5635   0.3516]
        Angle     59.9498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6225"
}

Galaxy "NGC 6226:NGC 6202:UGC 10532:MCG 10-23-43"
{
        Type  "S0"
        RA           16.7231
        Dec          61.9836
        Distance   1.341e+08  # distance uncertain!
        Radius      1.56e+04
        AbsMag        -19.07
        Axis    [  0.5373  -0.7528   0.3803]
        Angle    105.0508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6226"
}

Galaxy "NGC 6228:UGC 10558:MCG 4-40-1:ZWG 139.3"
{
        Type  "Sb"
        RA           16.8006
        Dec          26.2128
        Distance   4.654e+08  # method: V
        Radius     7.446e+04
        AbsMag        -20.67
        Axis    [ -0.1667  -0.8271   0.5367]
        Angle     55.2138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6228"
}

Galaxy "NGC 6230:UGC 10575:MCG 1-43-5:ZWG 53.14"
{
        Type  "E0"
        RA           16.8461
        Dec           4.6044
        Distance   4.243e+08  # method: V
        Radius     4.937e+04
        AbsMag        -20.07
        Axis    [ -0.0435  -0.8301  -0.5559]
        Angle    139.6128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6230"
}

Galaxy "NGC 6232:UGC 10537:MCG 12-16-7:ZWG 339.16"
{
        Type  "SBa"
        RA           16.7219
        Dec          70.6325
        Distance   2.004e+08  # method: V
        Radius     4.372e+04
        AbsMag        -20.54
        Axis    [  0.0876  -0.9954   0.0395]
        Angle    162.2750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6232"
}

Galaxy "NGC 6233:UGC 10573:MCG 4-40-2:ZWG 139.7"
{
        Type  "S0"
        RA           16.8375
        Dec          23.5803
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.4009  -0.8887  -0.2226]
        Angle    121.6841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6233"
}

Galaxy "NGC 6234:MCG 1-43-7:ZWG 53.18:ARAK 508"
{
        Type  "E0"
        RA           16.8658
        Dec           4.3842
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.1209  -0.8501  -0.5126]
        Angle    170.1516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6234"
}

Galaxy "NGC 6236:UGC 10546:MCG 12-16-8:ZWG 339.19"
{
        Type  "SBc"
        RA           16.7428
        Dec          70.7800
        Distance   5.717e+07  # method: V
        Radius     2.411e+04
        AbsMag        -18.62
        Axis    [  0.5578  -0.8120   0.1716]
        Angle    153.8287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6236"
}

Galaxy "NGC 6238:UGC 10563:MCG 10-24-57:ZWG 299.31"
{
        Type  "Sc"
        RA           16.7875
        Dec          62.1475
        Distance   1.768e+08  # distance uncertain!
        Radius     1.543e+04
        AbsMag        -19.07
        Axis    [  0.4978  -0.8629   0.0876]
        Angle    147.6863
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6238"
}

Galaxy "NGC 6239:UGC 10577:MCG 7-35-1:ZWG 225.2"
{
        Type  "SBb"
        RA           16.8347
        Dec          42.7397
        Distance   4.208e+07  # method: V
        Radius     1.469e+04
        AbsMag        -17.65
        Axis    [  0.2070  -0.7336   0.6473]
        Angle     65.5670
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6239"
}

Galaxy "NGC 6240:IC 4625:UGC 10592:MCG 0-43-4"
{
        Type  "E0"
        RA           16.8828
        Dec           2.4031
        Distance   3.319e+08  # method: V
        Radius     1.014e+05
        AbsMag        -21.24
        Axis    [  0.0278  -0.8329  -0.5527]
        Angle    153.7811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6240"
}

Galaxy "NGC 6241:MCG 8-31-7:ZWG 252.5:IRAS 16486+4530"
{
        Type  "Sc"
        RA           16.8364
        Dec          45.4211
        Distance   3.072e+08  # distance uncertain!
        Radius     4.468e+04
        AbsMag        -19.07
        Axis    [  0.2015  -0.9586   0.2010]
        Angle     68.1124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6241"
}

Galaxy "NGC 6243:UGC 10591:MCG 4-40-4:ZWG 139.13"
{
        Type  "Sa"
        RA           16.8739
        Dec          23.3328
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.3905  -0.5343   0.7497]
        Angle     63.4701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6243"
}

Galaxy "NGC 6244:UGC 10568:MCG 10-24-59:ZWG 299.32"
{
        Type  "SBa"
        RA           16.8008
        Dec          62.2006
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [  0.2041  -0.2299   0.9516]
        Angle     83.8690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6244"
}

Galaxy "NGC 6246:UGC 10580:MCG 9-27-98:ZWG 277.5"
{
        Type  "SBb"
        RA           16.8314
        Dec          55.5428
        Distance   2.359e+08  # method: V
        Radius     5.147e+04
        AbsMag           -20
        Axis    [  0.6061  -0.7652   0.2170]
        Angle    125.3113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6246"
}

Galaxy "NGC 6246A:UGC 10584:MCG 9-27-101:ZWG 276.50"
{
        Type  "SBc"
        RA           16.8372
        Dec          55.3847
        Distance   2.383e+08  # method: V
        Radius     6.933e+04
        AbsMag        -20.02
        Axis    [  0.1002  -0.9906  -0.0936]
        Angle    164.4771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6246A"
}

Galaxy "NGC 6247:UGC 10572:ZWG 320.44:KAZ 98"
{
        Type  "Irr"
        RA           16.8053
        Dec          62.9772
        Distance   1.906e+08  # distance uncertain!
        Radius     2.772e+04
        AbsMag        -20.13
        Axis    [  0.6271  -0.6723   0.3933]
        Angle    120.0401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6247"
}

Galaxy "NGC 6248:UGC 10564:MCG 12-16-9:ZWG 339.20"
{
        Type  "SBc"
        RA           16.7728
        Dec          70.3561
        Distance   5.033e+07  # method: V
        Radius     2.269e+04
        AbsMag        -17.14
        Axis    [  0.1841  -0.1091   0.9768]
        Angle     68.9017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6248"
}

Galaxy "NGC 6251:UGC 10501:MCG 14-8-10:ZWG 367.13"
{
        Type  "E0"
        RA           16.5419
        Dec          82.5383
        Distance   3.114e+08  # method: V
        Radius     8.151e+04
        AbsMag           -21
        Axis    [  0.1025  -0.9862   0.1297]
        Angle    123.3648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6251"
}

Galaxy "NGC 6252:MCG 14-8-11:ZWG 367.14:NPM 1"
{
        Type  "S0"
        RA           16.5444
        Dec          82.5772
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.5944  -0.6240   0.5074]
        Angle    123.5012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6252"
}

Galaxy "NGC 6255:UGC 10606:MCG 6-37-14:ZWG 197.18"
{
        Type  "SBc"
        RA           16.9131
        Dec          36.5017
        Distance   1.087e+08  # method: T-F
        Radius     5.693e+04
        AbsMag        -19.11
        Axis    [  0.4112  -0.8512   0.3263]
        Angle     85.0824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6255"
}

Galaxy "NGC 6257:ZWG 225.12"
{
        Type  "S0"
        RA           16.9342
        Dec          39.6461
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.1988  -0.6162   0.7621]
        Angle     75.5709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6257"
}

Galaxy "NGC 6258:UGC 10595:MCG 10-24-73:ZWG 299.35"
{
        Type  "E0"
        RA           16.8747
        Dec          60.5144
        Distance   2.631e+08  # distance uncertain!
        Radius     3.443e+04
        AbsMag        -20.13
        Axis    [  0.0320  -0.9936  -0.1087]
        Angle     95.2153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6258"
}

Galaxy "NGC 6260:MCG 11-20-29:ZWG 320.46:KAZ 434"
{
        Type  "Sc"
        RA           16.8639
        Dec          63.7147
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.0890  -0.9958  -0.0212]
        Angle    164.4789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6260"
}

Galaxy "NGC 6261:UGC 10617:MCG 5-40-6:ZWG 169.13"
{
        Type  "Sa"
        RA           16.9417
        Dec          27.9781
        Distance   4.658e+08  # method: V
        Radius     8.129e+04
        AbsMag        -20.37
        Axis    [  0.3398  -0.9006   0.2712]
        Angle     80.6470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6261"
}

Galaxy "NGC 6262:MCG 10-24-80:ZWG 299.39:IRAS 16578+5710"
{
        Type  "S0"
        RA           16.9783
        Dec          57.0992
        Distance   1.851e+08  # distance uncertain!
        Radius     1.615e+04
        AbsMag        -19.07
        Axis    [  0.4475  -0.8691   0.2109]
        Angle    109.1830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6262"
}

Galaxy "NGC 6263:NGC 6138:UGC 10618:MCG 5-40-8"
{
        Type  "E0"
        RA           16.9453
        Dec          27.8225
        Distance   4.486e+08  # method: V
        Radius     5.872e+04
        AbsMag        -20.59
        Axis    [  0.0940  -0.9392  -0.3302]
        Angle    168.4104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6263"
}

Galaxy "NGC 6264:MCG 5-40-9:ZWG 169.15"
{
        Type  "SBb"
        RA           16.9544
        Dec          27.8494
        Distance   4.599e+08  # method: V
        Radius     4.682e+04
        AbsMag        -20.25
        Axis    [  0.5344  -0.8224  -0.1952]
        Angle    137.7700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6264"
}

Galaxy "NGC 6265:UGC 10624:MCG 5-40-11:ZWG 169.17"
{
        Type  "S0"
        RA           16.9581
        Dec          27.8447
        Distance   4.193e+08  # method: V
        Radius     4.878e+04
        AbsMag        -20.04
        Axis    [  0.4842  -0.8554  -0.1838]
        Angle    131.5508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6265"
}

Galaxy "NGC 6267:UGC 10628:MCG 4-40-9:ZWG 139.25"
{
        Type  "SBc"
        RA           16.9689
        Dec          22.9853
        Distance   1.355e+08  # method: V
        Radius     2.562e+04
        AbsMag        -19.09
        Axis    [  0.3400  -0.9077  -0.2461]
        Angle    122.3745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6267"
}

Galaxy "NGC 6269:UGC 10629:MCG 5-40-12:ZWG 169.19"
{
        Type  "E0"
        RA           16.9661
        Dec          27.8550
        Distance   4.722e+08  # method: V
        Radius     1.373e+05
        AbsMag         -22.4
        Axis    [ -0.1913  -0.8863  -0.4217]
        Angle     94.8169
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6269"
}

Galaxy "NGC 6270"
{
        Type  "S0"
        RA           16.9789
        Dec          27.8589
        Distance    1.54e+08  # distance uncertain!
        Radius     1.568e+04
        AbsMag        -19.07
        Axis    [  0.1473  -0.9519   0.2689]
        Angle     69.5681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6270"
}

Galaxy "NGC 6271:MCG 5-40-16:ZWG 169.21"
{
        Type  "S0"
        RA           16.9806
        Dec          27.9647
        Distance   4.796e+08  # method: V
        Radius      5.58e+04
        AbsMag        -20.24
        Axis    [ -0.7354  -0.2660   0.6232]
        Angle     48.1168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6271"
}

Galaxy "NGC 6272:ZWG 169.22:KUG 1656+280"
{
        Type  "Sb"
        RA           16.9828
        Dec          27.9308
        Distance   4.777e+08  # method: V
        Radius     3.474e+04
        AbsMag        -20.23
        Axis    [ -0.5833  -0.3437   0.7359]
        Angle     55.5764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6272"
}

Galaxy "NGC 6274-1:UGC 10643:MCG 5-40-19:ZWG 169.24"
{
        Type  "Sc"
        RA           16.9889
        Dec          29.9464
        Distance   1.688e+08  # distance uncertain!
        Radius     1.473e+04
        AbsMag        -19.07
        Axis    [  0.4587  -0.8705  -0.1783]
        Angle    133.1506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6274-1"
}

Galaxy "NGC 6274-2:UGC 10643:MCG 5-40-20:ZWG 169.24"
{
        Type  "SBb"
        RA           16.9892
        Dec          29.9408
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.0796  -0.7550   0.6508]
        Angle     69.0469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6274-2"
}

Galaxy "NGC 6275:MK 503:MK 890:ZWG 321.7"
{
        Type  "E0"
        RA           16.9258
        Dec          63.2428
        Distance    3.05e+08  # method: V
        Radius     1.774e+04
        AbsMag        -19.55
        Axis    [  0.0125  -0.9856  -0.1685]
        Angle     45.9792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6275"
}

Galaxy "NGC 6276:IC 1239:MCG 4-40-10:NPM 1"
{
        Type  "S0"
        RA           17.0125
        Dec          23.0444
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.2554  -0.9457   0.2013]
        Angle     55.4123
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6276"
}

Galaxy "NGC 6278:UGC 10656:MCG 4-40-11:ZWG 139.29"
{
        Type  "S0"
        RA           17.0139
        Dec          23.0111
        Distance   1.268e+08  # method: V
        Radius     3.873e+04
        AbsMag        -19.35
        Axis    [ -0.2114  -0.8547   0.4742]
        Angle     57.8213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6278"
}

Galaxy "NGC 6279:UGC 10645:MCG 8-31-17:ZWG 252.13"
{
        Type  "S0"
        RA           16.9836
        Dec          47.2378
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.3755  -0.9234  -0.0797]
        Angle    143.3938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6279"
}

Galaxy "NGC 6280-1:MCG 1-43-8:ZWG 53.26:ARAK 512"
{
        Type  "S0"
        RA           17.0325
        Dec           6.6664
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [ -0.5649  -0.7408   0.3634]
        Angle     62.1014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6280-1"
}

Galaxy "NGC 6280-2:MCG 1-43-8:ZWG 53.26:ARAK 512"
{
        Type  "E0"
        RA           17.0328
        Dec           6.6675
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.1016  -0.8620  -0.4966]
        Angle    171.3618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6280-2"
}

Galaxy "NGC 6282:ZWG 169.29"
{
        Type  "SBc"
        RA           17.0131
        Dec          29.8203
        Distance   4.776e+08  # method: V
        Radius     4.863e+04
        AbsMag        -20.63
        Axis    [  0.3907  -0.9070  -0.1573]
        Angle    122.4314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6282"
}

Galaxy "NGC 6283:UGC 10652:MCG 8-31-18:ZWG 252.14"
{
        Type  "S0"
        RA           16.9906
        Dec          49.9219
        Distance   1.168e+08  # distance uncertain!
        Radius     1.869e+04
        AbsMag        -19.07
        Axis    [  0.0956  -0.9853  -0.1414]
        Angle    166.7073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6283"
}

Galaxy "NGC 6285:MCG 10-24-81:ZWG 299.37:ARP 293"
{
        Type  "Sa"
        RA           16.9731
        Dec          58.9558
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.2531  -0.5795   0.7747]
        Angle     60.7725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6285"
}

Galaxy "NGC 6286:UGC 10647:MCG 10-24-84:ZWG 299.40"
{
        Type  "Sb"
        RA           16.9753
        Dec          58.9375
        Distance   2.527e+08  # method: V
        Radius     4.779e+04
        AbsMag        -20.35
        Axis    [  0.2683  -0.9633   0.0117]
        Angle    132.4898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6286"
}

Galaxy "NGC 6288:MCG 11-21-6:ZWG 320.55:ZWG 321.8"
{
        Type  "S0"
        RA           16.9567
        Dec          68.4575
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.4713  -0.6141   0.6331]
        Angle     85.9276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6288"
}

Galaxy "NGC 6289:MCG 11-21-7:ZWG 320.56:ZWG 321.9"
{
        Type  "S0"
        RA           16.9622
        Dec          68.5142
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.4343  -0.8915   0.1290]
        Angle    147.8094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6289"
}

Galaxy "NGC 6290:UGC 10665:MCG 10-24-88:ZWG 299.43"
{
        Type  "SBa"
        RA           17.0156
        Dec          58.9708
        Distance   5.564e+08  # method: V
        Radius     8.902e+04
        AbsMag        -21.76
        Axis    [  0.2847  -0.9585   0.0139]
        Angle    136.0015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6290"
}

Galaxy "NGC 6291:MCG 10-24-86:ZWG 299.42"
{
        Type  "SBb"
        RA           17.0156
        Dec          58.9378
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.5181  -0.8337   0.1909]
        Angle    125.0673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6291"
}

Galaxy "NGC 6292:UGC 10684:MCG 10-24-93:ZWG 299.47"
{
        Type  "Sc"
        RA           17.0508
        Dec          61.0439
        Distance    1.54e+08  # distance uncertain!
        Radius     3.583e+04
        AbsMag        -19.07
        Axis    [  0.4197  -0.6704   0.6118]
        Angle     81.2805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6292"
}

Galaxy "NGC 6295:UGC 10682:MCG 10-24-92:IRAS 17025+6024"
{
        Type  "S0"
        RA           17.0542
        Dec          60.3378
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.5224  -0.7368   0.4292]
        Angle    102.9818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6295"
}

Galaxy "NGC 6296:UGC 10719:MCG 1-44-2:ZWG 54.3"
{
        Type  "SBc"
        RA           17.1456
        Dec           3.8944
        Distance   3.055e+08  # method: V
        Radius     3.999e+04
        AbsMag        -20.56
        Axis    [ -0.5533  -0.8327   0.0212]
        Angle     63.2681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6296"
}

Galaxy "NGC 6297:NGC 6298:UGC 10690:ZWG 299.50"
{
        Type  "S0"
        RA           17.0600
        Dec          62.0261
        Distance   1.768e+08  # distance uncertain!
        Radius       1.8e+04
        AbsMag        -19.07
        Axis    [  0.3927  -0.8345   0.3864]
        Angle     84.9950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6297"
}

Galaxy "NGC 6299:MCG 10-24-97:ZWG 299.51:NPM 1"
{
        Type  "E0"
        RA           17.0844
        Dec          62.4583
        Distance   3.631e+08  # distance uncertain!
        Radius     3.169e+04
        AbsMag        -20.13
        Axis    [  0.0518  -0.9980  -0.0357]
        Angle    167.6090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6299"
}

Galaxy "NGC 6300:ESO 101-25:VV 734:IRAS 17123-6245"
{
        Type  "SBb"
        RA           17.2831
        Dec         -62.8203
        Distance   5.173e+07  # method: V
        Radius     3.235e+04
        AbsMag         -20.1
        Axis    [ -0.6674  -0.6346  -0.3896]
        Angle    110.1196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6300"
}

Galaxy "NGC 6301:IC 4643:UGC 10723:MCG 7-35-34"
{
        Type  "Sc"
        RA           17.1422
        Dec          42.3392
        Distance    3.79e+08  # method: V
        Radius     9.922e+04
        AbsMag        -21.13
        Axis    [  0.1640  -0.8526   0.4962]
        Angle     65.0620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6301"
}

Galaxy "NGC 6303:UGC 10711:MCG 12-16-17:ZWG 321.13"
{
        Type  "E0"
        RA           17.0839
        Dec          68.8278
        Distance   3.163e+08  # distance uncertain!
        Radius      5.98e+04
        AbsMag        -20.13
        Axis    [  0.0610  -0.9981  -0.0071]
        Angle    107.3786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6303"
}

Galaxy "NGC 6305:ESO 138-19"
{
        Type  "S0"
        RA           17.3000
        Dec         -59.1711
        Distance   1.269e+08  # method: V
        Radius     2.584e+04
        AbsMag        -19.75
        Axis    [ -0.7188  -0.6632  -0.2085]
        Angle    108.9419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6305"
}

Galaxy "NGC 6306:UGC 10724:MCG 10-24-98:ZWG 299.53"
{
        Type  "SBb"
        RA           17.1267
        Dec          60.7292
        Distance   1.354e+08  # method: V
        Radius     1.969e+04
        AbsMag        -18.49
        Axis    [ -0.0355  -0.0721   0.9968]
        Angle     73.5095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6306"
}

Galaxy "NGC 6307:UGC 10727:MCG 10-24-99:ZWG 299.54"
{
        Type  "SBa"
        RA           17.1278
        Dec          60.7506
        Distance   1.432e+08  # method: V
        Radius     2.707e+04
        AbsMag        -19.41
        Axis    [  0.1210  -0.5422   0.8315]
        Angle     43.0133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6307"
}

Galaxy "NGC 6308:UGC 10747:MCG 4-40-21:ZWG 139.43"
{
        Type  "SBc"
        RA           17.1997
        Dec          23.3794
        Distance   3.992e+08  # method: V
        Radius     6.387e+04
        AbsMag        -21.14
        Axis    [ -0.7477  -0.6444   0.1604]
        Angle     44.5513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6308"
}

Galaxy "NGC 6310:UGC 10730:MCG 10-24-100:ZWG 299.55"
{
        Type  "Sb"
        RA           17.1325
        Dec          60.9903
        Distance   1.523e+08  # method: V
        Radius     4.208e+04
        AbsMag        -19.45
        Axis    [  0.6310  -0.6173   0.4699]
        Angle    118.9533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6310"
}

Galaxy "NGC 6311:UGC 10741:MCG 7-35-39:ZWG 225.59"
{
        Type  "E0"
        RA           17.1786
        Dec          41.6511
        Distance   2.884e+08  # distance uncertain!
        Radius     4.615e+04
        AbsMag        -20.13
        Axis    [  0.0632  -0.9745  -0.2152]
        Angle    170.0255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6311"
}

Galaxy "NGC 6312:MCG 7-35-40:ZWG 225.60:NPM 1"
{
        Type  "E0"
        RA           17.1800
        Dec          42.2881
        Distance   4.169e+08  # distance uncertain!
        Radius     4.245e+04
        AbsMag        -20.13
        Axis    [  0.0626  -0.9757  -0.2098]
        Angle    170.0023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6312"
}

Galaxy "NGC 6313:UGC 10742:MCG 8-31-25:ZWG 252.22"
{
        Type  "Sb"
        RA           17.1722
        Dec          48.3317
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.0618  -0.3064   0.9499]
        Angle     71.4983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6313"
}

Galaxy "NGC 6314:UGC 10752:MCG 4-40-22:ZWG 139.44"
{
        Type  "Sa"
        RA           17.2106
        Dec          23.2706
        Distance   3.003e+08  # method: V
        Radius     6.989e+04
        AbsMag        -21.02
        Axis    [ -0.5427  -0.3095   0.7808]
        Angle     71.4475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6314"
}

Galaxy "NGC 6315:MCG 4-40-23:ZWG 139.45"
{
        Type  "SBc"
        RA           17.2128
        Dec          23.2236
        Distance   3.062e+08  # method: V
        Radius     3.563e+04
        AbsMag        -20.66
        Axis    [  0.3290  -0.9150  -0.2334]
        Angle    123.8245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6315"
}

Galaxy "NGC 6317:MCG 11-21-9"
{
        Type  "S0"
        RA           17.1497
        Dec          62.8981
        Distance   3.527e+08  # distance uncertain!
        Radius     6.156e+04
        AbsMag        -19.07
        Axis    [  0.6168  -0.7207   0.3166]
        Angle    128.3462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6317"
}

Galaxy "NGC 6319:UGC 10744:MCG 11-21-10:ZWG 321.15"
{
        Type  "S0"
        RA           17.1622
        Dec          62.9731
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.0730  -0.9969  -0.0287]
        Angle    168.5467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6319"
}

Galaxy "NGC 6320:UGC 10761:MCG 7-35-44:ZWG 225.67"
{
        Type  "Sc"
        RA           17.2153
        Dec          40.2672
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.1935  -0.9269   0.3216]
        Angle     71.9504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6320"
}

Galaxy "NGC 6321:UGC 10768:MCG 3-44-2:ZWG 111.15"
{
        Type  "SBc"
        RA           17.2400
        Dec          20.3136
        Distance   2.816e+08  # method: V
        Radius     4.506e+04
        AbsMag        -20.28
        Axis    [  0.0540  -0.9557  -0.2894]
        Angle    104.7507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6321"
}

Galaxy "NGC 6323:UGC 10764:MCG 7-35-48:ZWG 225.71"
{
        Type  "Sb"
        RA           17.2214
        Dec          43.7822
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.2826  -0.1829   0.9416]
        Angle     69.7645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6323"
}

Galaxy "NGC 6324:UGC 10725:MCG 13-12-16:ZWG 355.25"
{
        Type  "Sc"
        RA           17.0903
        Dec          75.4078
        Distance   2.187e+08  # method: V
        Radius     3.181e+04
        AbsMag        -20.43
        Axis    [  0.5133  -0.7385   0.4372]
        Angle    110.4681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6324"
}

Galaxy "NGC 6327:ZWG 225.74"
{
        Type  "E0"
        RA           17.2339
        Dec          43.6489
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.0575  -0.9785  -0.1983]
        Angle    170.5797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6327"
}

Galaxy "NGC 6328:ESO 102-3:AM 1718-645"
{
        Type  "SBb"
        RA           17.3944
        Dec         -65.0097
        Distance   1.944e+08  # method: V
        Radius     6.785e+04
        AbsMag        -20.68
        Axis    [ -0.8212  -0.5697  -0.0317]
        Angle    123.1037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6328"
}

Galaxy "NGC 6329:UGC 10771:MCG 7-35-51:ZWG 225.77"
{
        Type  "E0"
        RA           17.2375
        Dec          43.6850
        Distance   3.715e+08  # method: V
        Radius     9.726e+04
        AbsMag        -21.38
        Axis    [  0.0572  -0.9785  -0.1980]
        Angle    170.6220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6329"
}

Galaxy "NGC 6330:UGC 10776:MCG 5-41-5:ZWG 170.7"
{
        Type  "SBb"
        RA           17.2622
        Dec          29.4042
        Distance   3.928e+08  # method: V
        Radius      8.57e+04
        AbsMag         -20.3
        Axis    [ -0.3375  -0.4538   0.8247]
        Angle     67.7408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6330"
}

Galaxy "NGC 6331:MCG 13-12-15:ZWG 355.24:DRCG 35-49"
{
        Type  "E0"
        RA           17.0594
        Dec          78.6297
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.3037  -0.9519   0.0405]
        Angle     42.3241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6331"
}

Galaxy "NGC 6332:UGC 10773:MCG 7-35-54:ZWG 225.82"
{
        Type  "Sa"
        RA           17.2506
        Dec          43.6603
        Distance   1.688e+08  # distance uncertain!
        Radius     3.929e+04
        AbsMag        -19.07
        Axis    [  0.5133  -0.8546   0.0789]
        Angle    121.7222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6332"
}

Galaxy "NGC 6336:UGC 10786:MCG 7-35-57:ZWG 225.89"
{
        Type  "SBa"
        RA           17.2711
        Dec          43.8208
        Distance   3.676e+08  # method: V
        Radius     4.812e+04
        AbsMag        -20.76
        Axis    [ -0.5018  -0.2192   0.8368]
        Angle     40.8052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6336"
}

Galaxy "NGC 6338:UGC 10784:MCG 10-24-116:ZWG 299.66"
{
        Type  "S0"
        RA           17.2561
        Dec          57.4114
        Distance   1.065e+08  # distance uncertain!
        Radius     2.324e+04
        AbsMag        -19.07
        Axis    [  0.4743  -0.8801   0.0196]
        Angle    153.4177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6338"
}

Galaxy "NGC 6339:UGC 10790:MCG 7-35-59:ZWG 225.92"
{
        Type  "SBc"
        RA           17.2850
        Dec          40.8450
        Distance    1.21e+08  # method: T-F
        Radius     5.104e+04
        AbsMag        -19.45
        Axis    [  0.5189  -0.8460  -0.1220]
        Angle    151.0722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6339"
}

Galaxy "NGC 6340:UGC 10762:MCG 12-16-23:ZWG 339.31"
{
        Type  "Sa"
        RA           17.1731
        Dec          72.3047
        Distance   5.327e+07  # method: V
        Radius     2.325e+04
        AbsMag        -19.16
        Axis    [  0.3253  -0.8526   0.4090]
        Angle     53.8960
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6340"
}

Galaxy "NGC 6343:MCG 7-35-60:ZWG 225.95"
{
        Type  "E0"
        RA           17.2878
        Dec          41.0528
        Distance   3.163e+08  # distance uncertain!
        Radius      5.06e+04
        AbsMag        -20.13
        Axis    [  0.0551  -0.9738  -0.2204]
        Angle    171.3826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6343"
}

Galaxy "NGC 6345:MCG 10-24-115:ZWG 299.65"
{
        Type  "S0"
        RA           17.2564
        Dec          57.3506
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.6748  -0.7136   0.1881]
        Angle    141.4436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6345"
}

Galaxy "NGC 6346:MCG 10-24-114:ZWG 299.64"
{
        Type  "E0"
        RA           17.2567
        Dec          57.3231
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [ -0.0460  -0.9886  -0.1431]
        Angle     75.7549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6346"
}

Galaxy "NGC 6347:IC 1253:UGC 10807:MCG 3-44-4"
{
        Type  "SBb"
        RA           17.3317
        Dec          16.6606
        Distance   2.778e+08  # method: V
        Radius     4.848e+04
        AbsMag        -20.15
        Axis    [  0.0333  -0.9907   0.1318]
        Angle     75.1958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6347"
}

Galaxy "NGC 6348:MCG 7-35-63:ZWG 225.98:NPM 1"
{
        Type  "Sb"
        RA           17.3058
        Dec          41.6481
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.1004  -0.9511   0.2922]
        Angle     51.8560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6348"
}

Galaxy "NGC 6349:MCG 6-38-16:ZWG 198.36:NPM 1"
{
        Type  "S0"
        RA           17.3183
        Dec          36.0614
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.4856  -0.7912   0.3717]
        Angle     97.3810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6349"
}

Galaxy "NGC 6350:UGC 10800:MCG 7-35-64:ZWG 225.99"
{
        Type  "S0"
        RA           17.3117
        Dec          41.6944
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.0784  -0.9739  -0.2131]
        Angle    170.9951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6350"
}

Galaxy "NGC 6351:MCG 6-38-17"
{
        Type  "Irr"
        RA           17.3194
        Dec          36.0600
        Distance   5.496e+08  # distance uncertain!
        Radius     4.796e+04
        AbsMag        -20.13
        Axis    [  0.2729  -0.9546   0.1198]
        Angle     90.1373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6351"
}

Galaxy "NGC 6358:UGC 10810:MCG 9-28-33:ZWG 277.34"
{
        Type  "S0"
        RA           17.3144
        Dec          52.6158
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.3495  -0.7071   0.6147]
        Angle     80.3817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6358"
}

Galaxy "NGC 6359:UGC 10804:MCG 10-25-1:ZWG 299.72"
{
        Type  "S0"
        RA           17.2981
        Dec          61.7808
        Distance   1.327e+08  # method: V
        Radius     2.509e+04
        AbsMag        -19.45
        Axis    [  0.1601  -0.4902   0.8568]
        Angle     51.0287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6359"
}

Galaxy "NGC 6361:UGC 10815:MCG 10-25-4:ZWG 300.9"
{
        Type  "Sb"
        RA           17.3111
        Dec          60.6081
        Distance   2.026e+08  # method: T-F
        Radius     6.482e+04
        AbsMag        -20.17
        Axis    [  0.6305  -0.7034   0.3282]
        Angle    128.1827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6361"
}

Galaxy "NGC 6364:UGC 10835:MCG 5-41-13:ZWG 170.27"
{
        Type  "S0"
        RA           17.4075
        Dec          29.3911
        Distance   1.404e+08  # distance uncertain!
        Radius     3.064e+04
        AbsMag        -19.07
        Axis    [  0.3713  -0.8881  -0.2710]
        Angle    156.4717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6364"
}

Galaxy "NGC 6365:UGC 10833:MCG 10-25-18:KCPG 511B"
{
        Type  "Irr"
        RA           17.3786
        Dec          62.1733
        Distance   3.704e+08  # method: V
        Radius     5.926e+04
        AbsMag        -20.48
        Axis    [  0.7080  -0.6732   0.2135]
        Angle    148.5816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6365"
}

Galaxy "NGC 6365A:UGC 10832:MCG 10-25-19:ZWG 300.20"
{
        Type  "SBc"
        RA           17.3789
        Dec          62.1658
        Distance   3.564e+08  # method: V
        Radius     5.702e+04
        AbsMag        -20.59
        Axis    [  0.1429  -0.8351   0.5312]
        Angle     41.1517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6365A"
}

Galaxy "NGC 6367:MCG 6-38-20:ZWG 198.41:NPM 1"
{
        Type  "S0"
        RA           17.4189
        Dec          37.7603
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.5660  -0.6220   0.5410]
        Angle     37.8535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6367"
}

Galaxy "NGC 6368:UGC 10856:MCG 2-44-4:ZWG 82.32"
{
        Type  "Sb"
        RA           17.4531
        Dec          11.5431
        Distance   1.103e+08  # method: T-F
        Radius     5.613e+04
        AbsMag        -19.24
        Axis    [  0.6005  -0.7958  -0.0784]
        Angle    110.2015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6368"
}

Galaxy "NGC 6370:UGC 10836:MCG 10-25-20:ZWG 300.21"
{
        Type  "E0"
        RA           17.3903
        Dec          56.9750
        Distance   2.089e+08  # distance uncertain!
        Radius     4.255e+04
        AbsMag        -20.13
        Axis    [  0.0378  -0.9958  -0.0835]
        Angle    171.9441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6370"
}

Galaxy "NGC 6371:MCG 4-41-12:ZWG 140.27"
{
        Type  "S0"
        RA           17.4556
        Dec          26.5050
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.3731  -0.4312   0.8215]
        Angle     73.1625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6371"
}

Galaxy "NGC 6372:UGC 10861:MCG 4-41-13:ZWG 140.28"
{
        Type  "Sc"
        RA           17.4586
        Dec          26.4747
        Distance   2.138e+08  # method: V
        Radius     5.286e+04
        AbsMag        -20.38
        Axis    [  0.1509  -0.9826   0.1082]
        Angle     83.1492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6372"
}

Galaxy "NGC 6373:UGC 10850:MCG 10-25-23:ZWG 300.22"
{
        Type  "SBc"
        RA           17.4022
        Dec          58.9953
        Distance   1.485e+08  # method: V
        Radius     2.808e+04
        AbsMag        -18.99
        Axis    [  0.3251  -0.8934   0.3100]
        Angle     87.0276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6373"
}

Galaxy "NGC 6375:UGC 10875:MCG 3-44-9:ZWG 111.42"
{
        Type  "E0"
        RA           17.4892
        Dec          16.2072
        Distance   2.512e+08  # distance uncertain!
        Radius     5.846e+04
        AbsMag        -20.13
        Axis    [  0.0502  -0.9039  -0.4249]
        Angle    174.9364
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6375"
}

Galaxy "NGC 6376:UGC 10855:MCG 10-25-25:ZWG 300.24"
{
        Type  "Sc"
        RA           17.4219
        Dec          58.8172
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.1616  -0.5126   0.8433]
        Angle     59.2365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6376"
}

Galaxy "NGC 6377:UGC 10855:MCG 10-25-26:ZWG 300.24"
{
        Type  "Sc"
        RA           17.4231
        Dec          58.8228
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.5492  -0.7855   0.2853]
        Angle    121.8459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6377"
}

Galaxy "NGC 6378:UGC 10884:MCG 1-44-9:ZWG 55.1"
{
        Type  "Sc"
        RA           17.5114
        Dec           6.2814
        Distance    3.02e+08  # method: V
        Radius      5.71e+04
        AbsMag        -20.03
        Axis    [  0.4101  -0.7985  -0.4407]
        Angle    147.1705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6378"
}

Galaxy "NGC 6379:UGC 10886:MCG 3-44-10:ZWG 112.2"
{
        Type  "Sc"
        RA           17.5097
        Dec          16.2886
        Distance   2.692e+08  # method: V
        Radius     4.307e+04
        AbsMag        -20.78
        Axis    [  0.1475  -0.9196  -0.3641]
        Angle    134.0223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6379"
}

Galaxy "NGC 6381:UGC 10871:MCG 10-25-38:ZWG 300.34"
{
        Type  "Sc"
        RA           17.4544
        Dec          60.0139
        Distance   1.459e+08  # method: V
        Radius     2.758e+04
        AbsMag        -19.65
        Axis    [  0.3901  -0.9196   0.0472]
        Angle    147.3500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6381"
}

Galaxy "NGC 6382:MCG 9-29-1:ZWG 277.44"
{
        Type  "S0"
        RA           17.4653
        Dec          56.8689
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.2650  -0.8859   0.3808]
        Angle     74.2683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6382"
}

Galaxy "NGC 6384:UGC 10891:MCG 1-45-1:ZWG 55.7"
{
        Type  "SBc"
        RA           17.5400
        Dec           7.0608
        Distance   1.023e+08  # method: T-F
        Radius     9.224e+04
        AbsMag        -21.28
        Axis    [  0.3316  -0.8709  -0.3628]
        Angle    126.4058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6384"
}

Galaxy "NGC 6385:UGC 10877:MCG 10-25-44:ZWG 300.35"
{
        Type  "SBa"
        RA           17.4669
        Dec          57.5219
        Distance   1.506e+08  # method: V
        Radius     2.847e+04
        AbsMag        -19.32
        Axis    [  0.0588  -0.9953  -0.0771]
        Angle    172.7048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6385"
}

Galaxy "NGC 6386:MCG 9-29-4:ZWG 277.45:ZWG 278.2"
{
        Type  "Sc"
        RA           17.4808
        Dec          52.7239
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.0603  -0.9911  -0.1188]
        Angle    172.9227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6386"
}

Galaxy "NGC 6387:ZWG 300.37:ZW 189:IRAS 17275+5735"
{
        Type  "E0"
        RA           17.4731
        Dec          57.5458
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [ -0.0569  -0.9910  -0.1214]
        Angle     78.5019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6387"
}

Galaxy "NGC 6389:UGC 10893:MCG 3-45-1:ZWG 112.5"
{
        Type  "Sc"
        RA           17.5442
        Dec          16.4019
        Distance   1.398e+08  # method: V
        Radius     5.693e+04
        AbsMag        -20.26
        Axis    [ -0.3355  -0.8882   0.3138]
        Angle     63.9552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6389"
}

Galaxy "NGC 6390:UGC 10881:MCG 10-25-47:ZWG 300.40"
{
        Type  "Sc"
        RA           17.4744
        Dec          60.0944
        Distance   1.688e+08  # distance uncertain!
        Radius     3.929e+04
        AbsMag        -19.07
        Axis    [  0.6896  -0.7228   0.0448]
        Angle    164.3562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6390"
}

Galaxy "NGC 6391:MCG 10-25-49:ZWG 300.41"
{
        Type  "S0"
        RA           17.4803
        Dec          58.8508
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.3145  -0.9005   0.3004]
        Angle     87.8450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6391"
}

Galaxy "NGC 6392:ESO 70-12:IRAS 17379-6945"
{
        Type  "Sb"
        RA           17.7250
        Dec         -69.7844
        Distance   1.695e+08  # method: V
        Radius     3.204e+04
        AbsMag        -21.08
        Axis    [  0.0457  -0.3706  -0.9277]
        Angle    177.3329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6392"
}

Galaxy "NGC 6393:MCG 10-25-54:KUG 1729+595"
{
        Type  "S0"
        RA           17.5022
        Dec          59.5319
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.0557  -0.9967  -0.0597]
        Angle    173.1639
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6393"
}

Galaxy "NGC 6394:UGC 10889:MCG 10-25-55:ZWG 300.45"
{
        Type  "SBb"
        RA           17.5058
        Dec          59.6400
        Distance    2.44e+08  # distance uncertain!
        Radius     4.969e+04
        AbsMag        -19.07
        Axis    [  0.6364  -0.7359   0.2311]
        Angle    138.3241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6394"
}

Galaxy "NGC 6395:UGC 10876:MCG 12-16-39:ZWG 339.44"
{
        Type  "Sc"
        RA           17.4419
        Dec          71.0972
        Distance   8.702e+07  # method: T-F
        Radius     3.038e+04
        AbsMag        -19.23
        Axis    [  0.6619  -0.7332   0.1562]
        Angle    165.3227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6395"
}

Galaxy "NGC 6398:ESO 139-18:AM 1738-614"
{
        Type  "SBa"
        RA           17.7119
        Dec         -61.6939
        Distance   1.017e+08  # distance uncertain!
        Radius     2.959e+04
        AbsMag        -19.07
        Axis    [  0.1297  -0.4373  -0.8899]
        Angle    145.3527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6398"
}

Galaxy "NGC 6399:UGC 10896:MCG 10-25-59:ZWG 300.47"
{
        Type  "Sa"
        RA           17.5306
        Dec          59.6156
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.5351  -0.8448  -0.0025]
        Angle    166.6921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6399"
}

Galaxy "NGC 6403:ESO 139-19"
{
        Type  "S0"
        RA           17.7231
        Dec         -61.6819
        Distance   2.303e+08  # method: V
        Radius     1.675e+04
        AbsMag        -19.94
        Axis    [  0.0476  -0.4352  -0.8991]
        Angle    177.1259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6403"
}

Galaxy "NGC 6407:ESO 139-22"
{
        Type  "S0"
        RA           17.7492
        Dec         -60.7397
        Distance     2.1e+08  # method: V
        Radius     6.415e+04
        AbsMag        -21.54
        Axis    [ -0.2824  -0.5951  -0.7524]
        Angle    119.2255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6407"
}

Galaxy "NGC 6408:UGC 10930:MCG 3-45-7:ZWG 112.17"
{
        Type  "SBa"
        RA           17.6464
        Dec          18.8783
        Distance   1.764e+08  # method: V
        Radius     4.105e+04
        AbsMag        -19.96
        Axis    [ -0.4927  -0.8642   0.1018]
        Angle     59.4983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6408"
}

Galaxy "NGC 6409:ZWG 253.20"
{
        Type  "E0"
        RA           17.6097
        Dec          50.7664
        Distance   3.163e+08  # distance uncertain!
        Radius      3.68e+04
        AbsMag        -20.13
        Axis    [ -0.0539  -0.9863  -0.1561]
        Angle    115.6666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6409"
}

Galaxy "NGC 6411:UGC 10916:MCG 10-25-68:ZWG 300.52"
{
        Type  "E0"
        RA           17.5922
        Dec          60.8131
        Distance   1.201e+08  # method: T-F
        Radius     3.494e+04
        AbsMag        -20.03
        Axis    [ -0.0118  -0.9975  -0.0690]
        Angle    104.6452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6411"
}

Galaxy "NGC 6412:UGC 10897:MCG 13-12-26:ZWG 355.34"
{
        Type  "SBc"
        RA           17.4933
        Dec          75.7047
        Distance   5.817e+07  # method: V
        Radius     2.115e+04
        AbsMag        -18.96
        Axis    [  0.3191  -0.8773   0.3586]
        Angle     57.6530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6412"
}

Galaxy "NGC 6414:UGC 10906:MCG 12-16-41:ZWG 340.5"
{
        Type  "S0"
        RA           17.5100
        Dec          74.3767
        Distance   3.527e+08  # distance uncertain!
        Radius      5.13e+04
        AbsMag        -19.07
        Axis    [  0.3288  -0.2859   0.9001]
        Angle     70.7008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6414"
}

Galaxy "NGC 6417:UGC 10945:MCG 4-42-1:ZWG 141.4"
{
        Type  "SBb"
        RA           17.6964
        Dec          23.6717
        Distance    1.48e+08  # method: V
        Radius     3.014e+04
        AbsMag        -19.08
        Axis    [  0.0832  -0.9544  -0.2868]
        Angle    126.6641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6417"
}

Galaxy "NGC 6418:MCG 10-25-74:ZWG 300.54:KAZ 149"
{
        Type  "S0"
        RA           17.6358
        Dec          58.7153
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.1203  -0.2441   0.9623]
        Angle     38.7928
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6418"
}

Galaxy "NGC 6419:UGC 10924:MCG 11-21-12:ZWG 321.24"
{
        Type  "Sa"
        RA           17.6014
        Dec          68.1558
        Distance   2.934e+08  # distance uncertain!
        Radius     5.547e+04
        AbsMag        -19.07
        Axis    [  0.3691  -0.3519   0.8602]
        Angle     93.3263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6419"
}

Galaxy "NGC 6420:MCG 11-21-13:ZWG 321.25"
{
        Type  "S0"
        RA           17.6044
        Dec          68.0525
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.5358  -0.7908   0.2959]
        Angle    130.7590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6420"
}

Galaxy "NGC 6422:MCG 11-21-15:ZWG 321.26"
{
        Type  "S0"
        RA           17.6081
        Dec          68.0583
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.0460  -0.9988   0.0143]
        Angle    174.6173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6422"
}

Galaxy "NGC 6423:MCG 11-21-16:ZWG 321.27:ARAK 524"
{
        Type  "E0"
        RA           17.6147
        Dec          68.1711
        Distance   5.012e+08  # distance uncertain!
        Radius     4.374e+04
        AbsMag        -20.13
        Axis    [  0.1879  -0.9619  -0.1988]
        Angle     10.0459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6423"
}

Galaxy "NGC 6424:UGC 10932:MCG 12-17-1:ZWG 340.11"
{
        Type  "S0"
        RA           17.6033
        Dec          69.9894
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.4448  -0.8043   0.3940]
        Angle    104.8642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6424"
}

Galaxy "NGC 6427:NGC 6431:UGC 10957:MCG 4-42-3"
{
        Type  "S0"
        RA           17.7272
        Dec          25.4939
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [  0.5212  -0.8483  -0.0934]
        Angle    125.7674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6427"
}

Galaxy "NGC 6429:UGC 10960:MCG 4-42-4:ZWG 141.7"
{
        Type  "SBa"
        RA           17.7347
        Dec          25.3508
        Distance    1.47e+08  # distance uncertain!
        Radius      3.85e+04
        AbsMag        -19.07
        Axis    [  0.5460  -0.8208  -0.1675]
        Angle    135.6322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6429"
}

Galaxy "NGC 6430:UGC 10966:MCG 3-45-19:ZWG 112.35"
{
        Type  "Sb"
        RA           17.7539
        Dec          18.1389
        Distance   1.357e+08  # method: V
        Radius     3.749e+04
        AbsMag        -18.49
        Axis    [  0.2123  -0.9252   0.3145]
        Angle     87.4202
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6430"
}

Galaxy "NGC 6433:UGC 10962:MCG 6-39-15:ZWG 199.13"
{
        Type  "Sb"
        RA           17.7322
        Dec          36.8006
        Distance   1.404e+08  # distance uncertain!
        Radius     4.085e+04
        AbsMag        -19.07
        Axis    [ -0.1645  -0.3848   0.9082]
        Angle     82.5296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6433"
}

Galaxy "NGC 6434:UGC 10934:MCG 12-17-2:ZWG 339.53"
{
        Type  "SBc"
        RA           17.6133
        Dec          72.0883
        Distance   9.278e+07  # distance uncertain!
        Radius     3.104e+04
        AbsMag        -19.07
        Axis    [  0.5031  -0.6109   0.6113]
        Angle    100.1434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6434"
}

Galaxy "NGC 6435:UGC 10947:MCG 10-25-80:ZWG 300.58"
{
        Type  "E0"
        RA           17.6697
        Dec          62.6419
        Distance    3.02e+08  # distance uncertain!
        Radius     4.832e+04
        AbsMag        -20.13
        Axis    [  0.0171  -0.9992  -0.0351]
        Angle    170.5287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6435"
}

Galaxy "NGC 6436:UGC 10951:MCG 10-25-82:ZWG 300.60"
{
        Type  "Sc"
        RA           17.6869
        Dec          60.4497
        Distance   2.845e+08  # method: V
        Radius     5.794e+04
        AbsMag           -20
        Axis    [ -0.1053  -0.0355   0.9938]
        Angle     57.9291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6436"
}

Galaxy "NGC 6438:ESO 10-1:AM 1806-852"
{
        Type  "S0"
        RA           18.3708
        Dec         -85.4017
        Distance   1.117e+08  # method: V
        Radius     2.599e+04
        AbsMag        -19.97
        Axis    [ -0.9430  -0.3219  -0.0847]
        Angle    148.4149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6438"
}

Galaxy "NGC 6438A:ESO 10-2:AM 1806-852:IRAS 18061-8525"
{
        Type  "S0"
        RA           18.3758
        Dec         -85.4061
        Distance   1.153e+08  # method: V
        Radius     4.529e+04
        AbsMag        -20.14
        Axis    [ -0.1401  -0.4731  -0.8698]
        Angle    104.1435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6438A"
}

Galaxy "NGC 6442:UGC 10978:MCG 3-45-21:ZWG 112.38"
{
        Type  "E0"
        RA           17.7808
        Dec          20.7617
        Distance   2.631e+08  # distance uncertain!
        Radius     6.887e+04
        AbsMag        -20.13
        Axis    [ -0.5533  -0.7512  -0.3600]
        Angle     72.3251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6442"
}

Galaxy "NGC 6443:UGC 10967:MCG 8-32-18:ZWG 253.33"
{
        Type  "Sb"
        RA           17.7425
        Dec          48.1144
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.2020  -0.6579   0.7255]
        Angle     77.1353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6443"
}

Galaxy "NGC 6446:MCG 6-39-18:ZWG 199.18:ARAK 528"
{
        Type  "Sb"
        RA           17.7686
        Dec          35.5694
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.2885  -0.9296  -0.2295]
        Angle    159.9109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6446"
}

Galaxy "NGC 6447:UGC 10975:MCG 6-39-19:ZWG 199.19"
{
        Type  "SBc"
        RA           17.7714
        Dec          35.5722
        Distance   3.024e+08  # method: V
        Radius     7.038e+04
        AbsMag        -21.14
        Axis    [ -0.1518  -0.6746   0.7224]
        Angle     63.8098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6447"
}

Galaxy "NGC 6449:UGC 10965:MCG 9-29-20:ZWG 278.20"
{
        Type  "Sc"
        RA           17.7294
        Dec          56.8042
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.1210  -0.7802   0.6137]
        Angle     54.1835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6449"
}

Galaxy "NGC 6452:ZWG 112.43"
{
        Type  "S0"
        RA           17.7994
        Dec          20.8375
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.0431  -0.9207  -0.3879]
        Angle    176.7572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6452"
}

Galaxy "NGC 6454:MCG 9-29-26:ZWG 278.24"
{
        Type  "S0"
        RA           17.7489
        Dec          55.7044
        Distance   4.129e+08  # method: V
        Radius     6.006e+04
        AbsMag        -21.01
        Axis    [ -0.2052  -0.2306   0.9512]
        Angle     39.8883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6454"
}

Galaxy "NGC 6456:ZWG 322.4:ZWG 321.34"
{
        Type  "E0"
        RA           17.7086
        Dec          67.5922
        Distance   4.787e+08  # distance uncertain!
        Radius      5.57e+04
        AbsMag        -20.13
        Axis    [  0.0189  -0.9998   0.0029]
        Angle    130.9818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6456"
}

Galaxy "NGC 6457:UGC 10964:MCG 11-21-21:ZWG 321.35"
{
        Type  "S0"
        RA           17.7144
        Dec          66.4761
        Distance    2.44e+08  # distance uncertain!
        Radius     4.259e+04
        AbsMag        -19.07
        Axis    [  0.2629  -0.6033   0.7529]
        Angle     56.1280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6457"
}

Galaxy "NGC 6458:UGC 10994:MCG 3-45-29:ZWG 112.51"
{
        Type  "S0"
        RA           17.8194
        Dec          20.8047
        Distance   1.423e+08  # method: V
        Radius      2.69e+04
        AbsMag         -18.1
        Axis    [ -0.5125  -0.6383   0.5744]
        Angle     61.4353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6458"
}

Galaxy "NGC 6459:ZWG 278.25:MCG 9-29-29"
{
        Type  "S0"
        RA           17.7631
        Dec          55.7769
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4545  -0.8211   0.3454]
        Angle    107.6912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6459"
}

Galaxy "NGC 6460:UGC 10997:MCG 3-45-31:ZWG 112.55"
{
        Type  "Sc"
        RA           17.8250
        Dec          20.7642
        Distance    1.99e+08  # method: T-F
        Radius     5.498e+04
        AbsMag        -19.73
        Axis    [ -0.4436  -0.6026   0.6634]
        Angle     67.1080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6460"
}

Galaxy "NGC 6461:UGC 10954:MCG 12-17-4:ZWG 330.55"
{
        Type  "Sb"
        RA           17.6656
        Dec          74.0339
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [  0.5523  -0.8164   0.1687]
        Angle    163.0957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6461"
}

Galaxy "NGC 6462:MCG 10-25-85:ZWG 300.63:ARAK 529"
{
        Type  "E0"
        RA           17.7467
        Dec          61.9106
        Distance   5.192e+08  # method: V
        Radius     3.021e+04
        AbsMag        -21.01
        Axis    [  0.0144  -0.9991  -0.0406]
        Angle    176.5779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6462"
}

Galaxy "NGC 6463:MCG 11-21-22:ZWG 321.37:ZWG 322.7"
{
        Type  "S0"
        RA           17.7261
        Dec          67.6042
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.0401  -0.9991   0.0100]
        Angle    176.2447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6463"
}

Galaxy "NGC 6464:MCG 10-25-87:ZWG 300.65:KAZ 160"
{
        Type  "Sc"
        RA           17.7631
        Dec          60.8975
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.0399  -0.9980  -0.0487]
        Angle    176.6660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6464"
}

Galaxy "NGC 6466:ZWG 278.30"
{
        Type  "S0"
        RA           17.8022
        Dec          51.3994
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [  0.2708  -0.8180   0.5075]
        Angle     79.7324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6466"
}

Galaxy "NGC 6467:NGC 6468:UGC 11004:MCG 3-45-35"
{
        Type  "S0"
        RA           17.8444
        Dec          17.5383
        Distance   1.347e+08  # method: V
        Radius     5.093e+04
        AbsMag        -18.88
        Axis    [  0.1299  -0.9902  -0.0513]
        Angle     96.5457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6467"
}

Galaxy "NGC 6470:UGC 10974:MCG 11-21-25:ZWG 321.39"
{
        Type  "Sc"
        RA           17.7372
        Dec          67.6192
        Distance   2.555e+08  # distance uncertain!
        Radius     4.831e+04
        AbsMag        -19.07
        Axis    [  0.0399  -0.0196   0.9990]
        Angle     88.5893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6470"
}

Galaxy "NGC 6471-1:UGC 10973:MCG 11-21-23:ZWG 321.38"
{
        Type  "Sc"
        RA           17.7367
        Dec          67.5928
        Distance   2.555e+08  # distance uncertain!
        Radius     5.203e+04
        AbsMag        -19.07
        Axis    [  0.0399  -0.0206   0.9990]
        Angle     87.0812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6471-1"
}

Galaxy "NGC 6471-2:UGC 10973:MCG 11-21-24:ZWG 321.38"
{
        Type  "Sc"
        RA           17.7381
        Dec          67.5908
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.0395  -0.9992   0.0098]
        Angle    176.4095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6471-2"
}

Galaxy "NGC 6472:NPM 1"
{
        Type  "S0"
        RA           17.7342
        Dec          67.6303
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.4546  -0.8887   0.0603]
        Angle    168.1591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6472"
}

Galaxy "NGC 6474:UGC 10989:MCG 10-25-92:ZWG 300.68"
{
        Type  "Sc"
        RA           17.7847
        Dec          57.3014
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.4412  -0.8410   0.3133]
        Angle    109.6540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6474"
}

Galaxy "NGC 6477"
{
        Type  "S0"
        RA           17.7414
        Dec          67.6108
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.3559  -0.7881   0.5021]
        Angle     78.6250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6477"
}

Galaxy "NGC 6478:UGC 10998:MCG 9-29-32:ZWG 278.33"
{
        Type  "Sc"
        RA           17.8106
        Dec          51.1567
        Distance     2.9e+08  # method: T-F
        Radius     3.796e+04
        AbsMag        -20.64
        Axis    [  0.3353  -0.9421   0.0003]
        Angle    137.8910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6478"
}

Galaxy "NGC 6479:UGC 10996:ZWG 278.32:IRAS 17473+5409"
{
        Type  "Sc"
        RA           17.8058
        Dec          54.1497
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.0319  -0.9226   0.3845]
        Angle     53.8743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6479"
}

Galaxy "NGC 6482:UGC 11009:MCG 4-42-8:ZWG 141.17"
{
        Type  "E0"
        RA           17.8633
        Dec          23.0728
        Distance   1.748e+08  # method: V
        Radius     5.338e+04
        AbsMag        -21.34
        Axis    [ -0.2406  -0.8973  -0.3700]
        Angle    114.2226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6482"
}

Galaxy "NGC 6483:ESO 102-20:FAIR 486:AM 1754-634"
{
        Type  "E4"
        RA           17.9917
        Dec         -63.6686
        Distance   1.628e+08  # method: T-F
        Radius     3.789e+04
        AbsMag        -20.49
        Axis    [ -0.8527  -0.2194  -0.4740]
        Angle    136.8084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6483"
}

Galaxy "NGC 6484:UGC 11010:MCG 4-42-7:MK 1118"
{
        Type  "Sb"
        RA           17.8628
        Dec          24.4831
        Distance   1.381e+08  # method: V
        Radius     3.817e+04
        AbsMag        -19.83
        Axis    [  0.0370  -0.9328  -0.3586]
        Angle    177.4550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6484"
}

Galaxy "NGC 6485:UGC 11014:MCG 5-42-4:ZWG 171.9"
{
        Type  "Sc"
        RA           17.8644
        Dec          31.4619
        Distance   2.119e+08  # method: V
        Radius     4.623e+04
        AbsMag        -20.06
        Axis    [  0.1527  -0.9548  -0.2552]
        Angle    148.7233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6485"
}

Galaxy "NGC 6486:MCG 5-42-6:ZWG 171.12:NPM 1"
{
        Type  "S0"
        RA           17.8764
        Dec          29.8186
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.0356  -0.9485  -0.3148]
        Angle    177.6731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6486"
}

Galaxy "NGC 6487:UGC 11022:MCG 5-42-8:ZWG 171.14"
{
        Type  "E0"
        RA           17.8781
        Dec          29.8386
        Distance   3.458e+08  # method: V
        Radius     9.053e+04
        AbsMag        -21.93
        Axis    [  0.0106  -0.9490  -0.3150]
        Angle    178.6364
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6487"
}

Galaxy "NGC 6488:MCG 10-25-98:ZWG 300.76:ARAK 533"
{
        Type  "E0"
        RA           17.8222
        Dec          62.2233
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [ -0.0133  -0.9989  -0.0446]
        Angle    114.6499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6488"
}

Galaxy "NGC 6489:MCG 10-25-99:ZWG 300.79:KAZ 166"
{
        Type  "S0"
        RA           17.8336
        Dec          60.0925
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.3841  -0.9226   0.0358]
        Angle    153.2795
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6489"
}

Galaxy "NGC 6490:UGC 11033:MCG 3-45-38:ZWG 112.68"
{
        Type  "S0"
        RA           17.9083
        Dec          18.3764
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.2524  -0.9628   0.0961]
        Angle     72.8314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6490"
}

Galaxy "NGC 6491:NGC 6493A:UGC 11008:MCG 10-25-103"
{
        Type  "Sb"
        RA           17.8333
        Dec          61.5319
        Distance   2.409e+08  # method: V
        Radius     4.204e+04
        AbsMag        -19.74
        Axis    [  0.5673  -0.8042   0.1772]
        Angle    143.6159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6491"
}

Galaxy "NGC 6492:ESO 102-22:AM 1757-662:IRAS 17576-6625"
{
        Type  "Sc"
        RA           18.0467
        Dec         -66.4306
        Distance   1.943e+08  # method: V
        Radius     7.063e+04
        AbsMag        -21.27
        Axis    [ -0.3715  -0.7169  -0.5899]
        Angle    106.2449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6492"
}

Galaxy "NGC 6493:UGC 11011:MCG 10-25-105:ZWG 300.84"
{
        Type  "SBc"
        RA           17.8394
        Dec          61.5594
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [  0.0353  -0.9984  -0.0431]
        Angle    177.7042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6493"
}

Galaxy "NGC 6495:UGC 11034:MCG 3-45-39:ZWG 112.70"
{
        Type  "E0"
        RA           17.9139
        Dec          18.3275
        Distance    1.82e+08  # distance uncertain!
        Radius     5.294e+04
        AbsMag        -20.13
        Axis    [ -0.2635  -0.8775  -0.4006]
        Angle    116.9051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6495"
}

Galaxy "NGC 6497:NGC 6498:UGC 11020:MCG 10-25-109"
{
        Type  "SBb"
        RA           17.8547
        Dec          59.4711
        Distance   1.399e+08  # method: V
        Radius     2.849e+04
        AbsMag        -18.96
        Axis    [  0.3657  -0.7003   0.6131]
        Angle     85.9773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6497"
}

Galaxy "NGC 6500:UGC 11048:MCG 3-46-3:ZWG 113.8"
{
        Type  "Sb"
        RA           17.9331
        Dec          18.3389
        Distance   1.328e+08  # method: V
        Radius      4.25e+04
        AbsMag        -20.05
        Axis    [  0.2081  -0.9545  -0.2136]
        Angle    118.9222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6500"
}

Galaxy "NGC 6501:UGC 11049:MCG 3-46-4:ZWG 113.9"
{
        Type  "Sa"
        RA           17.9342
        Dec          18.3736
        Distance   1.269e+08  # method: V
        Radius     3.322e+04
        AbsMag        -19.65
        Axis    [  0.0493  -0.9589  -0.2795]
        Angle    119.7275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6501"
}

Galaxy "NGC 6502:ESO 103-2:AM 1759-652"
{
        Type  "S0"
        RA           18.0706
        Dec         -65.4097
        Distance   1.115e+08  # distance uncertain!
        Radius     2.109e+04
        AbsMag        -19.07
        Axis    [ -0.2208  -0.5076  -0.8328]
        Angle    132.7458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6502"
}

Galaxy "NGC 6503:UGC 11012:MCG 12-17-9:ZWG 340.19"
{
        Type  "Sc"
        RA           17.8242
        Dec          70.1436
        Distance     1.7e+07  # method: P
        Radius     1.731e+04
        AbsMag        -17.68
        Axis    [  0.4262  -0.4792   0.7673]
        Angle     91.4301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6503"
}

Galaxy "NGC 6504:UGC 11053:MCG 6-39-27:ZWG 199.29"
{
        Type  "S0"
        RA           17.9347
        Dec          33.2086
        Distance   1.065e+08  # distance uncertain!
        Radius     3.408e+04
        AbsMag        -19.07
        Axis    [  0.3883  -0.8067   0.4455]
        Angle     98.9388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6504"
}

Galaxy "NGC 6505:UGC 11026:MCG 11-22-7:ZWG 322.18"
{
        Type  "S0"
        RA           17.8519
        Dec          65.5314
        Distance   2.802e+08  # distance uncertain!
        Radius     4.483e+04
        AbsMag        -19.07
        Axis    [  0.2109  -0.8785   0.4288]
        Angle     58.0207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6505"
}

Galaxy "NGC 6508:UGC 11023:MCG 12-17-10:ZWG 340.21"
{
        Type  "E0"
        RA           17.8294
        Dec          72.0217
        Distance   2.512e+08  # distance uncertain!
        Radius      4.75e+04
        AbsMag        -20.13
        Axis    [  0.0079  -0.9988   0.0476]
        Angle    177.6070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6508"
}

Galaxy "NGC 6509:UGC 11075:MCG 1-46-2:ZWG 56.6"
{
        Type  "SBc"
        RA           17.9903
        Dec           6.2872
        Distance   7.905e+07  # method: V
        Radius      1.84e+04
        AbsMag        -18.62
        Axis    [ -0.2481  -0.9684  -0.0263]
        Angle     82.5309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6509"
}

Galaxy "NGC 6510:NGC 6511:UGC 11051:MCG 10-25-114"
{
        Type  "SBc"
        RA           17.9108
        Dec          60.8172
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.4736  -0.8762   0.0892]
        Angle    149.9529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6510"
}

Galaxy "NGC 6512:MCG 10-25-115:ZWG 300.93:NPM 1"
{
        Type  "S0"
        RA           17.9139
        Dec          62.6456
        Distance   3.788e+08  # method: V
        Radius     2.754e+04
        AbsMag        -20.42
        Axis    [  0.3311  -0.9304   0.1570]
        Angle    124.3666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6512"
}

Galaxy "NGC 6513:UGC 11078:MCG 4-42-18:ZWG 141.38"
{
        Type  "S0"
        RA           17.9928
        Dec          24.8875
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.2514  -0.9461  -0.2041]
        Angle    129.7428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6513"
}

Galaxy "NGC 6515:UGC 11071:MCG 8-33-3:ZWG 254.4"
{
        Type  "E0"
        RA           17.9569
        Dec          50.7275
        Distance   2.188e+08  # distance uncertain!
        Radius     5.092e+04
        AbsMag        -20.13
        Axis    [ -0.0091  -0.9904  -0.1380]
        Angle    169.5441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6515"
}

Galaxy "NGC 6516:MCG 10-25-118:ZWG 300.94:ZWG 301.1"
{
        Type  "S0"
        RA           17.9211
        Dec          62.6694
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.3016  -0.4901   0.8178]
        Angle     81.3319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6516"
}

Galaxy "NGC 6518:MCG 5-42-24:ZWG 171.41:NPM 1"
{
        Type  "E0"
        RA           17.9953
        Dec          28.8672
        Distance   3.312e+08  # distance uncertain!
        Radius     1.927e+04
        AbsMag        -20.13
        Axis    [  0.0004  -0.9464  -0.3230]
        Angle    179.9476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6518"
}

Galaxy "NGC 6521:UGC 11061:MCG 10-25-119:ZWG 301.2"
{
        Type  "E0"
        RA           17.9300
        Dec          62.6117
        Distance   3.704e+08  # method: V
        Radius      8.62e+04
        AbsMag        -21.88
        Axis    [ -0.1967  -0.9787  -0.0583]
        Angle     19.4575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6521"
}

Galaxy "NGC 6521A:MCG 10-25-121:ZWG 300.98:ZWG 301.4"
{
        Type  "Sc"
        RA           17.9428
        Dec          62.6169
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.5353  -0.6667   0.5186]
        Angle    113.3764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6521A"
}

Galaxy "NGC 6524:UGC 11079:MCG 8-33-5:ZWG 254.6"
{
        Type  "S0"
        RA           17.9872
        Dec          45.8881
        Distance   1.281e+08  # distance uncertain!
        Radius     2.608e+04
        AbsMag        -19.07
        Axis    [ -0.1603  -0.5859   0.7944]
        Angle     53.7398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6524"
}

Galaxy "NGC 6527:UGC 11094:MCG 3-46-9:ZWG 113.14"
{
        Type  "Sa"
        RA           18.0294
        Dec          19.7292
        Distance   2.431e+08  # method: V
        Radius     4.951e+04
        AbsMag        -19.26
        Axis    [ -0.4757  -0.7123   0.5160]
        Angle     63.9100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6527"
}

Galaxy "NGC 6532:UGC 11085:MCG 9-29-45:ZWG 278.42"
{
        Type  "Sc"
        RA           17.9869
        Dec          56.2319
        Distance    2.45e+08  # method: T-F
        Radius     6.414e+04
        AbsMag        -19.68
        Axis    [  0.2913  -0.6820   0.6709]
        Angle     80.7518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6532"
}

Galaxy "NGC 6536:UGC 11077:MCG 11-22-16:ZWG 322.25"
{
        Type  "SBb"
        RA           17.9544
        Dec          64.9378
        Distance    1.47e+08  # distance uncertain!
        Radius     2.566e+04
        AbsMag        -19.07
        Axis    [  0.2005  -0.9166   0.3460]
        Angle     67.0095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6536"
}

Galaxy "NGC 6538:UGC 11062:MCG 12-17-12:ZWG 340.25"
{
        Type  "S0"
        RA           17.9047
        Dec          73.4242
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.5409  -0.7917   0.2841]
        Angle    142.3462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6538"
}

Galaxy "NGC 6542:UGC 11092:MCG 10-25-126:ZWG 300.103"
{
        Type  "Sa"
        RA           17.9942
        Dec          61.3589
        Distance    1.47e+08  # distance uncertain!
        Radius      2.78e+04
        AbsMag        -19.07
        Axis    [  0.4892  -0.6581   0.5723]
        Angle    106.1991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6542"
}

Galaxy "NGC 6545:ESO 103-6"
{
        Type  "E1"
        RA           18.2039
        Dec         -63.7758
        Distance   1.923e+08  # method: V
        Radius     3.077e+04
        AbsMag        -19.65
        Axis    [ -0.9960  -0.0490  -0.0752]
        Angle    130.6542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6545"
}

Galaxy "NGC 6547:UGC 11110:MCG 4-43-1:ZWG 141.48"
{
        Type  "Sa"
        RA           18.0861
        Dec          25.2328
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [ -0.0138  -0.7501   0.6611]
        Angle     83.8967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6547"
}

Galaxy "NGC 6548:UGC 11115:MCG 3-46-13:ZWG 113.20"
{
        Type  "S0"
        RA           18.0997
        Dec          18.5872
        Distance   7.507e+07  # method: S
        Radius     3.166e+04
        AbsMag        -19.11
        Axis    [ -0.0941  -0.9452  -0.3126]
        Angle    120.1466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6548"
}

Galaxy "NGC 6550:NGC 6549:UGC 11114:MCG 3-46-12"
{
        Type  "Sc"
        RA           18.0969
        Dec          18.5378
        Distance   2.935e+08  # method: V
        Radius     5.976e+04
        AbsMag        -19.97
        Axis    [  0.4612  -0.8871  -0.0167]
        Angle    114.9262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6550"
}

Galaxy "NGC 6552:UGC 11096:MCG 11-22-18:ZWG 322.26"
{
        Type  "SBc"
        RA           18.0019
        Dec          66.6153
        Distance   3.527e+08  # method: V
        Radius      5.13e+04
        AbsMag        -20.57
        Axis    [  0.3694  -0.7950   0.4812]
        Angle     87.9990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6552"
}

Galaxy "NGC 6555:UGC 11121:MCG 3-46-15:ZWG 113.22"
{
        Type  "SBc"
        RA           18.1303
        Dec          17.6047
        Distance   9.694e+07  # method: V
        Radius     2.961e+04
        AbsMag        -19.36
        Axis    [ -0.2282  -0.9718   0.0596]
        Angle     78.9154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6555"
}

Galaxy "NGC 6557:ESO 45-1:AM 1814-763"
{
        Type  "S0"
        RA           18.3567
        Dec         -76.5828
        Distance   1.281e+08  # distance uncertain!
        Radius      2.98e+04
        AbsMag        -19.07
        Axis    [ -0.5485  -0.5635  -0.6178]
        Angle    121.9891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6557"
}

Galaxy "NGC 6560:UGC 11117:MCG 8-33-19:ZWG 254.15"
{
        Type  "SBc"
        RA           18.0869
        Dec          46.8817
        Distance   3.154e+08  # method: V
        Radius     5.505e+04
        AbsMag        -20.73
        Axis    [  0.3537  -0.9325   0.0726]
        Angle    124.4256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6560"
}

Galaxy "NGC 6562:MCG 9-29-51:ZWG 279.1:ZWG 278.46"
{
        Type  "E0"
        RA           18.0833
        Dec          56.2636
        Distance   3.312e+08  # distance uncertain!
        Radius     3.372e+04
        AbsMag        -20.13
        Axis    [ -0.0052  -0.9960  -0.0897]
        Angle    181.0976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6562"
}

Galaxy "NGC 6566:MCG 9-30-1:ZWG 279.2:KARA 845"
{
        Type  "E0"
        RA           18.1167
        Dec          52.2606
        Distance   4.787e+08  # distance uncertain!
        Radius     4.177e+04
        AbsMag        -20.13
        Axis    [ -0.0078  -0.9922  -0.1245]
        Angle    181.5064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6566"
}

Galaxy "NGC 6570:UGC 11137:MCG 2-46-8:ZWG 84.22"
{
        Type  "Irr"
        RA           18.1853
        Dec          14.0928
        Distance     9.4e+07  # method: T-F
        Radius     2.598e+04
        AbsMag           -19
        Axis    [  0.3441  -0.8954  -0.2827]
        Angle    133.1715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6570"
}

Galaxy "NGC 6571:MCG 4-43-6:ZWG 142.10"
{
        Type  "S0"
        RA           18.1803
        Dec          21.2392
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.0072  -0.9227  -0.3855]
        Angle    180.7189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6571"
}

Galaxy "NGC 6574:NGC 6610:UGC 11144:MCG 2-46-10"
{
        Type  "SBc"
        RA           18.1975
        Dec          14.9817
        Distance    9.93e+07  # method: V
        Radius     2.166e+04
        AbsMag        -19.62
        Axis    [ -0.5909  -0.5971   0.5424]
        Angle     67.2245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6574"
}

Galaxy "NGC 6575:UGC 11138:MCG 5-43-6:ZWG 172.9"
{
        Type  "E0"
        RA           18.1825
        Dec          31.1161
        Distance   3.122e+08  # method: V
        Radius     8.173e+04
        AbsMag         -20.9
        Axis    [ -0.2036  -0.9364  -0.2859]
        Angle    120.4642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6575"
}

Galaxy "NGC 6576:ZWG 142.14:NPM 1"
{
        Type  "S0"
        RA           18.1964
        Dec          21.4289
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.0057  -0.9233  -0.3840]
        Angle    180.8945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6576"
}

Galaxy "NGC 6577:UGC 11148:MCG 4-43-9:ZWG 142.17"
{
        Type  "E0"
        RA           18.2003
        Dec          21.4639
        Distance   1.906e+08  # distance uncertain!
        Radius     4.157e+04
        AbsMag        -20.13
        Axis    [ -0.0389  -0.9233  -0.3820]
        Angle    176.5468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6577"
}

Galaxy "NGC 6579:UGC 11153:MCG 4-43-11:ZWG 142.22"
{
        Type  "S0"
        RA           18.2086
        Dec          21.4206
        Distance   1.688e+08  # distance uncertain!
        Radius          9822
        AbsMag        -19.07
        Axis    [  0.0045  -0.9233  -0.3841]
        Angle    181.0215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6579"
}

Galaxy "NGC 6580:UGC 11153:MCG 4-43-12:ZWG 142.22"
{
        Type  "E0"
        RA           18.2092
        Dec          21.4258
        Distance   2.291e+08  # distance uncertain!
        Radius     4.332e+04
        AbsMag        -20.13
        Axis    [ -0.6779  -0.6945  -0.2409]
        Angle     64.5403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6580"
}

Galaxy "NGC 6581:IC 1280:MCG 4-43-10:ZWG 142.21"
{
        Type  "E0"
        RA           18.2050
        Dec          25.6628
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [ -0.0186  -0.9368  -0.3493]
        Angle    182.2160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6581"
}

Galaxy "NGC 6582-1:UGC 11146:MCG 8-33-29:ZWG 254.23"
{
        Type  "S0"
        RA           18.1836
        Dec          49.9114
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.0132  -0.9893  -0.1452]
        Angle    181.9065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6582-1"
}

Galaxy "NGC 6582-2:UGC 11146:MCG 8-33-30:ZWG 254.23"
{
        Type  "S0"
        RA           18.1847
        Dec          49.9092
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.0132  -0.9893  -0.1453]
        Angle    181.9206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6582-2"
}

Galaxy "NGC 6585:UGC 11159:MCG 7-37-24:ZWG 227.20"
{
        Type  "Sc"
        RA           18.2058
        Dec          39.6333
        Distance   1.241e+08  # method: V
        Radius     3.429e+04
        AbsMag         -19.2
        Axis    [  0.6004  -0.7869   0.1426]
        Angle    130.0780
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6585"
}

Galaxy "NGC 6586:UGC 11164:MCG 4-43-16:ZWG 142.28"
{
        Type  "S0"
        RA           18.2272
        Dec          21.0908
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.0266  -0.9654   0.2594]
        Angle     86.2268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6586"
}

Galaxy "NGC 6587:UGC 11166:MCG 3-46-20:ZWG 113.31"
{
        Type  "S0"
        RA           18.2306
        Dec          18.8258
        Distance   1.317e+08  # method: V
        Radius     2.491e+04
        AbsMag        -19.43
        Axis    [  0.1944  -0.9197  -0.3410]
        Angle    149.7666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6587"
}

Galaxy "NGC 6591"
{
        Type  "S0"
        RA           18.2342
        Dec          21.0636
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [  0.2215  -0.9271   0.3024]
        Angle     95.4570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6591"
}

Galaxy "NGC 6592:MCG 10-26-18:ZWG 301.16:ZW 771"
{
        Type  "S0"
        RA           18.1639
        Dec          61.4225
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.2196  -0.8189   0.5303]
        Angle     67.7697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6592"
}

Galaxy "NGC 6593:MCG 4-43-18:ZWG 142.30"
{
        Type  "S0"
        RA           18.2342
        Dec          22.2847
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.3689  -0.5554   0.7453]
        Angle     76.0038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6593"
}

Galaxy "NGC 6594:MCG 10-26-19:ZWG 301.17:IRAS 18095+6107"
{
        Type  "S0"
        RA           18.1681
        Dec          61.1336
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.3466  -0.8713   0.3475]
        Angle    100.5560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6594"
}

Galaxy "NGC 6597:MCG 10-26-20:ZWG 301.18:NPM 1"
{
        Type  "E0"
        RA           18.1869
        Dec          61.1811
        Distance   5.012e+08  # distance uncertain!
        Radius     5.832e+04
        AbsMag        -20.13
        Axis    [ -0.0640  -0.9974  -0.0334]
        Angle     83.6691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6597"
}

Galaxy "NGC 6598:UGC 11139:MCG 12-17-18:ZWG 340.37"
{
        Type  "S0"
        RA           18.1486
        Dec          69.0686
        Distance   1.341e+08  # distance uncertain!
        Radius     2.926e+04
        AbsMag        -19.07
        Axis    [  0.3939  -0.9056   0.1573]
        Angle    146.4185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6598"
}

Galaxy "NGC 6600:NGC 6599:UGC 11178:MCG 4-43-19"
{
        Type  "S0"
        RA           18.2617
        Dec          24.9131
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [ -0.0460  -0.9808  -0.1894]
        Angle    112.0517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6600"
}

Galaxy "NGC 6601:MCG 10-26-22:ZWG 301.19"
{
        Type  "S0"
        RA           18.1956
        Dec          61.4531
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.4537  -0.8807   0.1364]
        Angle    143.5502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6601"
}

Galaxy "NGC 6602:UGC 11184:MCG 4-43-21:ZWG 142.35"
{
        Type  "SBa"
        RA           18.2761
        Dec          25.0436
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.3735  -0.8651  -0.3348]
        Angle    165.5683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6602"
}

Galaxy "NGC 6606:UGC 11174:MCG 7-37-25:ZWG 227.21"
{
        Type  "Sb"
        RA           18.2447
        Dec          43.2686
        Distance   1.612e+08  # distance uncertain!
        Radius      2.11e+04
        AbsMag        -19.07
        Axis    [  0.2160  -0.9746   0.0598]
        Angle    112.8614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6606"
}

Galaxy "NGC 6607:MCG 10-26-23:ZWG 301.20"
{
        Type  "Sb"
        RA           18.2039
        Dec          61.3333
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.0144  -0.9988  -0.0462]
        Angle    182.6098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6607"
}

Galaxy "NGC 6608:MCG 10-26-24:FGC 2194"
{
        Type  "Sc"
        RA           18.2081
        Dec          61.2986
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [  0.6697  -0.7102   0.2174]
        Angle    149.3664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6608"
}

Galaxy "NGC 6609:MCG 10-26-25:ZWG 301.21:ZW 773"
{
        Type  "S0"
        RA           18.2092
        Dec          61.3322
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.0141  -0.9988  -0.0462]
        Angle    182.6808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6609"
}

Galaxy "NGC 6612:MCG 6-40-11:ZWG 200.14:ZW 204"
{
        Type  "E0"
        RA           18.2694
        Dec          36.0792
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [ -0.0220  -0.9646  -0.2628]
        Angle    183.1549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6612"
}

Galaxy "NGC 6614:ESO 103-18"
{
        Type  "S0"
        RA           18.4186
        Dec         -63.2483
        Distance   2.041e+08  # method: V
        Radius     4.156e+04
        AbsMag        -20.18
        Axis    [ -0.4178  -0.5969  -0.6849]
        Angle    123.3165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6614"
}

Galaxy "NGC 6615:UGC 11196:MCG 2-46-13:ZWG 84.34"
{
        Type  "SBa"
        RA           18.3092
        Dec          13.2653
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [ -0.5880  -0.5450   0.5977]
        Angle     71.8508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6615"
}

Galaxy "NGC 6616:UGC 11192:MCG 4-43-22:ZWG 142.36"
{
        Type  "Sb"
        RA           18.2947
        Dec          22.2378
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.3545  -0.9350  -0.0102]
        Angle    115.3851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6616"
}

Galaxy "NGC 6617:UGC 11176:MCG 10-26-29:ZWG 301.25"
{
        Type  "Sc"
        RA           18.2339
        Dec          61.3194
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.3941  -0.8623   0.3181]
        Angle    111.4816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6617"
}

Galaxy "NGC 6619:UGC 11200:MCG 4-43-25:ZWG 142.39"
{
        Type  "E0"
        RA           18.3153
        Dec          23.6553
        Distance   2.291e+08  # distance uncertain!
        Radius     3.999e+04
        AbsMag        -20.13
        Axis    [ -0.4258  -0.8564  -0.2921]
        Angle     90.4548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6619"
}

Galaxy "NGC 6621:UGC 11175:MCG 11-22-30:ZWG 322.36"
{
        Type  "Sb"
        RA           18.2153
        Dec          68.3631
        Distance   2.808e+08  # method: V
        Radius     8.576e+04
        AbsMag        -20.67
        Axis    [  0.3079  -0.3815   0.8716]
        Angle     83.2302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6621"
}

Galaxy "NGC 6622:UGC 11175:MCG 11-22-31:ZWG 322.36"
{
        Type  "Sc"
        RA           18.2164
        Dec          68.3542
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.3044  -0.4099   0.8599]
        Angle     79.2806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6622"
}

Galaxy "NGC 6623-1:UGC 11203:MCG 4-43-26:ZWG 142.40"
{
        Type  "E0"
        RA           18.3283
        Dec          23.7094
        Distance   2.146e+08  # method: V
        Radius     4.058e+04
        AbsMag        -19.79
        Axis    [ -0.8380  -0.5336  -0.1141]
        Angle     51.3156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6623-1"
}

Galaxy "NGC 6623-2:MCG 4-43-27:ZWG 142.40"
{
        Type  "E0"
        RA           18.3283
        Dec          23.7019
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [ -0.0303  -0.9304  -0.3652]
        Angle    183.4899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6623-2"
}

Galaxy "NGC 6627:UGC 11212:MCG 3-47-1:ZWG 114.4"
{
        Type  "SBb"
        RA           18.3772
        Dec          15.6983
        Distance   2.338e+08  # method: V
        Radius     4.421e+04
        AbsMag        -19.98
        Axis    [ -0.1178  -0.9603  -0.2527]
        Angle    112.9036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6627"
}

Galaxy "NGC 6628:UGC 11211:MCG 4-43-29:ZWG 142.41"
{
        Type  "S0"
        RA           18.3725
        Dec          23.4775
        Distance   1.612e+08  # distance uncertain!
        Radius     4.455e+04
        AbsMag        -19.07
        Axis    [  0.0673  -0.9958   0.0617]
        Angle     97.5651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6628"
}

Galaxy "NGC 6630:ESO 103-26:IRAS 18278-6319"
{
        Type  "S0"
        RA           18.5428
        Dec         -63.2919
        Distance    1.19e+08  # method: V
        Radius     1.385e+04
        AbsMag        -18.21
        Axis    [  0.0523  -0.4398  -0.8966]
        Angle    150.8420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6630"
}

Galaxy "NGC 6632:UGC 11226:MCG 5-43-18:ZWG 172.32"
{
        Type  "Sc"
        RA           18.4175
        Dec          27.5358
        Distance   2.107e+08  # method: V
        Radius     9.193e+04
        AbsMag        -21.15
        Axis    [ -0.2263  -0.6147   0.7556]
        Angle     78.0863
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6632"
}

Galaxy "NGC 6635:UGC 11239:MCG 2-47-3"
{
        Type  "S0"
        RA           18.4603
        Dec          14.8186
        Distance   2.231e+08  # method: V
        Radius     3.244e+04
        AbsMag        -19.67
        Axis    [  0.0262  -0.9439  -0.3291]
        Angle    135.9569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6635"
}

Galaxy "NGC 6636-1:UGC 11221:MCG 11-22-46:ZWG 322.41"
{
        Type  "Sc"
        RA           18.3672
        Dec          66.6175
        Distance   1.881e+08  # method: V
        Radius     5.746e+04
        AbsMag         -19.6
        Axis    [  0.0521  -0.0514   0.9973]
        Angle     92.3452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6636-1"
}

Galaxy "NGC 6636-2:UGC 11221:MCG 11-22-47:ZWG 322.41"
{
        Type  "Sb"
        RA           18.3678
        Dec          66.6225
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.0070  -1.0000  -0.0006]
        Angle    185.0622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6636-2"
}

Galaxy "NGC 6640:UGC 11247:MCG 6-40-18:ZWG 200.21"
{
        Type  "Sc"
        RA           18.4689
        Dec          34.3025
        Distance    1.47e+08  # distance uncertain!
        Radius     2.352e+04
        AbsMag        -19.07
        Axis    [ -0.2818  -0.6907   0.6660]
        Angle     62.6698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6640"
}

Galaxy "NGC 6641:UGC 11250:MCG 4-43-35:ZWG 142.49"
{
        Type  "S0"
        RA           18.4825
        Dec          22.9033
        Distance   1.826e+08  # method: V
        Radius      2.39e+04
        AbsMag        -19.44
        Axis    [ -0.0987  -0.9903   0.0978]
        Angle     88.4256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6641"
}

Galaxy "NGC 6643:UGC 11218:MCG 12-17-21:ZWG 340.43"
{
        Type  "Sc"
        RA           18.3292
        Dec          74.5683
        Distance   7.828e+07  # method: T-F
        Radius     4.213e+04
        AbsMag         -20.2
        Axis    [  0.5398  -0.8126   0.2197]
        Angle    156.7758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6643"
}

Galaxy "NGC 6646:UGC 11258:MCG 7-38-8:ZWG 228.10"
{
        Type  "Sa"
        RA           18.4939
        Dec          39.8650
        Distance   1.115e+08  # distance uncertain!
        Radius     2.596e+04
        AbsMag        -19.07
        Axis    [  0.1665  -0.9860  -0.0107]
        Angle    120.5937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6646"
}

Galaxy "NGC 6650:ZWG 322.43:ZW 794:NPM 1"
{
        Type  "E0"
        RA           18.4242
        Dec          68.0064
        Distance   3.312e+08  # distance uncertain!
        Radius     1.927e+04
        AbsMag        -20.13
        Axis    [ -0.0215  -0.9997   0.0126]
        Angle    185.8685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6650"
}

Galaxy "NGC 6651:UGC 11236:MCG 12-17-22:ZWG 340.44"
{
        Type  "Sc"
        RA           18.4053
        Dec          71.6022
        Distance   2.583e+08  # method: V
        Radius     6.011e+04
        AbsMag        -20.79
        Axis    [  0.5576  -0.8145   0.1606]
        Angle    163.2410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6651"
}

Galaxy "NGC 6653:ESO 45-13"
{
        Type  "E1"
        RA           18.7439
        Dec         -73.2631
        Distance   2.338e+08  # method: V
        Radius      5.78e+04
        AbsMag        -20.78
        Axis    [ -0.0971  -0.3418  -0.9347]
        Angle    179.3488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6653"
}

Galaxy "NGC 6654:UGC 11238:MCG 12-17-23:ZWG 340.45"
{
        Type  "SBa"
        RA           18.4019
        Dec          73.1828
        Distance   7.964e+07  # method: V
        Radius     3.012e+04
        AbsMag        -19.14
        Axis    [  0.3247  -0.9451   0.0374]
        Angle    187.5830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6654"
}

Galaxy "NGC 6654A:UGC 11332:MCG 12-17-29:ZWG 340.53"
{
        Type  "SBc"
        RA           18.6569
        Dec          73.5808
        Distance   6.741e+07  # method: V
        Radius     2.647e+04
        AbsMag        -18.08
        Axis    [  0.6063  -0.7099   0.3583]
        Angle    144.8797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6654A"
}

Galaxy "NGC 6657:UGC 11271:MCG 6-41-3:ZWG 201.8"
{
        Type  "SBc"
        RA           18.5503
        Dec          34.0608
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [ -0.0853  -0.7873   0.6107]
        Angle     75.0541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6657"
}

Galaxy "NGC 6658:UGC 11274:MCG 4-44-2:ZWG 143.2"
{
        Type  "Sa"
        RA           18.5653
        Dec          22.8881
        Distance    1.79e+08  # method: V
        Radius     4.166e+04
        AbsMag         -19.8
        Axis    [  0.6273  -0.7276  -0.2776]
        Angle    150.7815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6658"
}

Galaxy "NGC 6661:NGC 6660:UGC 11282:MCG 4-44-3"
{
        Type  "Sa"
        RA           18.5767
        Dec          22.9092
        Distance   1.928e+08  # method: V
        Radius     5.048e+04
        AbsMag        -20.66
        Axis    [ -0.2752  -0.7606   0.5881]
        Angle     75.4442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6661"
}

Galaxy "NGC 6662:UGC 11280:MCG 5-44-3:ZWG 173.7"
{
        Type  "SBb"
        RA           18.5697
        Dec          32.0647
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [  0.5444  -0.8245  -0.1543]
        Angle    149.3502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6662"
}

Galaxy "NGC 6663:UGC 11276:MCG 7-38-11:ZWG 228.14"
{
        Type  "Sc"
        RA           18.5592
        Dec          40.0492
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [ -0.2537  -0.8853   0.3898]
        Angle     58.5340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6663"
}

Galaxy "NGC 6665:MCG 5-44-4:ZWG 173.10:IRAS 18325+3040"
{
        Type  "Sc"
        RA           18.5750
        Dec          30.7208
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.4473  -0.8447  -0.2940]
        Angle    167.4674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6665"
}

Galaxy "NGC 6667:NGC 6668:NGC 6678:UGC 11269"
{
        Type  "SBb"
        RA           18.5108
        Dec          67.9867
        Distance   1.135e+08  # method: V
        Radius     3.963e+04
        AbsMag        -18.91
        Axis    [  0.4572  -0.6896   0.5616]
        Angle    104.9663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6667"
}

Galaxy "NGC 6670-1:UGC 11284:MCG 10-26-44:ZWG 301.31"
{
        Type  "S0"
        RA           18.5592
        Dec          59.8878
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.4030  -0.8261   0.3939]
        Angle    110.0001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6670-1"
}

Galaxy "NGC 6670-2:UGC 11284:MCG 10-26-44:ZWG 301.31"
{
        Type  "S0"
        RA           18.5603
        Dec          59.8897
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [  0.4229  -0.7205   0.5496]
        Angle    104.6677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6670-2"
}

Galaxy "NGC 6671:UGC 11299:MCG 4-44-6:ZWG 143.6"
{
        Type  "S0"
        RA           18.6239
        Dec          26.4175
        Distance   1.168e+08  # distance uncertain!
        Radius     2.548e+04
        AbsMag        -19.07
        Axis    [  0.1428  -0.9529  -0.2676]
        Angle    151.4592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6671"
}

Galaxy "NGC 6673:ESO 140-44:FAIR 186:AM 1840-622"
{
        Type  "S0"
        RA           18.7517
        Dec         -62.2969
        Distance   3.544e+07  # method: S
        Radius     1.134e+04
        AbsMag        -17.58
        Axis    [ -0.0126  -0.6186  -0.7856]
        Angle    112.4284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6673"
}

Galaxy "NGC 6674:UGC 11308:MCG 4-44-7:ZWG 143.8"
{
        Type  "SBb"
        RA           18.6425
        Dec          25.3744
        Distance   1.496e+08  # method: V
        Radius     9.138e+04
        AbsMag        -20.31
        Axis    [ -0.1624  -0.7480   0.6436]
        Angle     81.1636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6674"
}

Galaxy "NGC 6675:UGC 11305:MCG 7-38-13:ZWG 228.19"
{
        Type  "Sc"
        RA           18.6239
        Dec          40.0578
        Distance   1.079e+08  # method: V
        Radius     2.824e+04
        AbsMag         -19.3
        Axis    [ -0.0292  -0.8679   0.4959]
        Angle     73.8315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6675"
}

Galaxy "NGC 6676:UGC 11286:MCG 11-22-54:ZWG 322.45"
{
        Type  "Sc"
        RA           18.5525
        Dec          66.9600
        Distance    2.33e+08  # distance uncertain!
        Radius     5.423e+04
        AbsMag        -19.07
        Axis    [  0.3480  -0.3589   0.8661]
        Angle    101.6512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6676"
}

Galaxy "NGC 6677:UGC 11290:MCG 11-22-57:ZWG 323.2"
{
        Type  "Sc"
        RA           18.5597
        Dec          67.1100
        Distance   2.977e+08  # method: V
        Radius     3.897e+04
        AbsMag         -20.4
        Axis    [  0.4772  -0.7267   0.4942]
        Angle    112.6783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6677"
}

Galaxy "NGC 6679:MCG 11-22-56:ZWG 322.46:KAZ 208"
{
        Type  "Sc"
        RA           18.5586
        Dec          67.1472
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.3762  -0.8037   0.4610]
        Angle     98.7542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6679"
}

Galaxy "NGC 6680:ZWG 143.10"
{
        Type  "S0"
        RA           18.6622
        Dec          22.3164
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.1939  -0.9628  -0.1881]
        Angle    132.3772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6680"
}

Galaxy "NGC 6684:ESO 104-16:AM 1843-651"
{
        Type  "S0"
        RA           18.8158
        Dec         -65.1728
        Distance   4.544e+07  # method: S
        Radius      3.04e+04
        AbsMag        -19.42
        Axis    [ -0.1740  -0.5956  -0.7842]
        Angle    120.7265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6684"
}

Galaxy "NGC 6684A:ESO 104-19:AM 1847-645"
{
        Type  "Irr"
        RA           18.8731
        Dec         -64.8314
        Distance   4.417e+07  # method: V
        Radius     1.927e+04
        AbsMag        -17.46
        Axis    [ -0.7890  -0.6143   0.0087]
        Angle    128.5883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6684A"
}

Galaxy "NGC 6685:UGC 11317:MCG 7-38-15:ZWG 228.21"
{
        Type  "S0"
        RA           18.6661
        Dec          39.9822
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.2214  -0.9653  -0.1388]
        Angle    151.9620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6685"
}

Galaxy "NGC 6686:MCG 7-38-17:ZWG 228.22:NPM 1"
{
        Type  "E0"
        RA           18.6683
        Dec          40.1381
        Distance   4.787e+08  # distance uncertain!
        Radius     6.266e+04
        AbsMag        -20.13
        Axis    [ -0.2382  -0.9567  -0.1674]
        Angle    106.7127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6686"
}

Galaxy "NGC 6687:UGC 11309:MCG 10-26-46:ZWG 301.34"
{
        Type  "Sc"
        RA           18.6228
        Dec          59.6431
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.1579  -0.9848   0.0725]
        Angle    128.9495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6687"
}

Galaxy "NGC 6688:UGC 11324:MCG 6-41-15:ZWG 201.27"
{
        Type  "Sa"
        RA           18.6775
        Dec          36.2894
        Distance   1.115e+08  # distance uncertain!
        Radius     2.596e+04
        AbsMag        -19.07
        Axis    [  0.0986  -0.9949   0.0202]
        Angle    112.2252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6688"
}

Galaxy "NGC 6689:NGC 6690:UGC 11300:MCG 12-17-26"
{
        Type  "SBc"
        RA           18.5803
        Dec          70.5242
        Distance   5.635e+07  # method: T-F
        Radius     3.279e+04
        AbsMag        -18.19
        Axis    [  0.1789  -0.1441   0.9733]
        Angle     82.9041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6689"
}

Galaxy "NGC 6691:UGC 11318:MCG 9-30-31:ZWG 279.22"
{
        Type  "SBc"
        RA           18.6533
        Dec          55.6417
        Distance   2.621e+08  # method: V
        Radius     6.099e+04
        AbsMag        -20.92
        Axis    [  0.1261  -0.9920   0.0009]
        Angle    139.9671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6691"
}

Galaxy "NGC 6692:UGC 11330:MCG 6-41-18:ZWG 201.33"
{
        Type  "S0"
        RA           18.6947
        Dec          34.8442
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.0338  -0.9503   0.3096]
        Angle     87.7077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6692"
}

Galaxy "NGC 6695:UGC 11340:MCG 7-38-18:ZWG 228.23"
{
        Type  "SBb"
        RA           18.7117
        Dec          40.3672
        Distance   2.445e+08  # method: V
        Radius     3.912e+04
        AbsMag        -20.07
        Axis    [  0.3816  -0.9060  -0.1829]
        Angle    165.6606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6695"
}

Galaxy "NGC 6696:MCG 10-26-47"
{
        Type  "S0"
        RA           18.6681
        Dec          59.3333
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.6371  -0.7644  -0.0987]
        Angle    181.7902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6696"
}

Galaxy "NGC 6697:UGC 11349:MCG 4-44-14:ZWG 143.21"
{
        Type  "E0"
        RA           18.7539
        Dec          25.5128
        Distance   2.512e+08  # distance uncertain!
        Radius     4.384e+04
        AbsMag        -20.13
        Axis    [ -0.2153  -0.9272  -0.3064]
        Angle    143.3652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6697"
}

Galaxy "NGC 6699:ESO 183-21:AM 1847-572:IRAS 18477-5722"
{
        Type  "SBc"
        RA           18.8669
        Dec         -57.3206
        Distance   1.523e+08  # method: V
        Radius     3.323e+04
        AbsMag        -20.65
        Axis    [ -0.1006  -0.4702  -0.8768]
        Angle    178.4148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6699"
}

Galaxy "NGC 6700:UGC 11351:MCG 5-44-10:ZWG 173.26"
{
        Type  "SBc"
        RA           18.7678
        Dec          32.2794
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [ -0.0307  -0.9455   0.3242]
        Angle     85.2641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6700"
}

Galaxy "NGC 6701:UGC 11348:MCG 10-26-50:ZWG 301.36"
{
        Type  "SBa"
        RA           18.7200
        Dec          60.6531
        Distance   1.761e+08  # method: V
        Radius     3.842e+04
        AbsMag        -20.66
        Axis    [  0.2385  -0.9711  -0.0009]
        Angle    164.0108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6701"
}

Galaxy "NGC 6702:UGC 11354:MCG 8-34-19:ZWG 255.13"
{
        Type  "E0"
        RA           18.7825
        Dec          45.7061
        Distance   1.642e+08  # method: S
        Radius     4.538e+04
        AbsMag        -20.21
        Axis    [ -0.1625  -0.9773  -0.1361]
        Angle    125.9922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6702"
}

Galaxy "NGC 6703:UGC 11356:MCG 8-34-20:ZWG 255.14"
{
        Type  "S0"
        RA           18.7883
        Dec          45.5508
        Distance   8.698e+07  # method: S
        Radius     3.416e+04
        AbsMag        -19.83
        Axis    [  0.1614  -0.9672  -0.1960]
        Angle    184.9320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6703"
}

Galaxy "NGC 6706:ESO 104-24"
{
        Type  "S0"
        RA           18.9475
        Dec         -63.1664
        Distance   1.699e+08  # method: V
        Radius     3.707e+04
        AbsMag        -19.68
        Axis    [ -0.6765  -0.7331  -0.0699]
        Angle    122.0630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6706"
}

Galaxy "NGC 6707:ESO 183-25:AM 1851-535:IRAS 18512-5352"
{
        Type  "SBc"
        RA           18.9225
        Dec         -53.8192
        Distance   1.207e+08  # method: T-F
        Radius     3.687e+04
        AbsMag        -19.54
        Axis    [ -0.7050  -0.6955   0.1387]
        Angle    123.2685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6707"
}

Galaxy "NGC 6708:ESO 183-27:AM 1851-534:IRAS 18515-5347"
{
        Type  "Sb"
        RA           18.9264
        Dec         -53.7233
        Distance   1.142e+08  # method: V
        Radius     1.994e+04
        AbsMag        -19.92
        Axis    [ -0.8641  -0.4459   0.2336]
        Angle    127.4117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6708"
}

Galaxy "NGC 6710:UGC 11364:MCG 4-44-19:ZWG 143.27"
{
        Type  "Sa"
        RA           18.8428
        Dec          26.8386
        Distance   1.997e+08  # method: V
        Radius     4.938e+04
        AbsMag        -19.73
        Axis    [  0.3006  -0.9428  -0.1439]
        Angle    138.3105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6710"
}

Galaxy "NGC 6711:UGC 11361:MCG 8-34-25:ZWG 255.17"
{
        Type  "SBc"
        RA           18.8167
        Dec          47.6575
        Distance   2.061e+08  # method: V
        Radius     3.297e+04
        AbsMag         -20.3
        Axis    [  0.1334  -0.9750   0.1780]
        Angle    103.5175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6711"
}

Galaxy "NGC 6713:UGC 11365:ZWG 201.38:KAZ 497"
{
        Type  "S0"
        RA           18.8456
        Dec          33.9603
        Distance   1.612e+08  # distance uncertain!
        Radius          9380
        AbsMag        -19.07
        Axis    [  0.0312  -0.9799   0.1968]
        Angle     95.5529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6713"
}

Galaxy "NGC 6718:ESO 104-29:FAIR 502:IRAS 18566-6611"
{
        Type  "SBb"
        RA           19.0244
        Dec         -66.1103
        Distance   1.934e+08  # method: V
        Radius     3.939e+04
        AbsMag        -19.67
        Axis    [ -0.8186  -0.5058   0.2720]
        Angle    144.0205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6718"
}

Galaxy "NGC 6719:ESO 72-8:IRAS 18578-6839"
{
        Type  "Sc"
        RA           19.0519
        Dec         -68.5878
        Distance   1.538e+08  # method: T-F
        Radius     3.802e+04
        AbsMag        -19.87
        Axis    [ -0.6415  -0.7343  -0.2217]
        Angle    120.7128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6719"
}

Galaxy "NGC 6721:ESO 141-19"
{
        Type  "E0"
        RA           19.0139
        Dec         -57.7594
        Distance   1.998e+08  # method: T-F
        Radius     4.649e+04
        AbsMag        -20.84
        Axis    [ -0.9900  -0.1233  -0.0682]
        Angle    126.5478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6721"
}

Galaxy "NGC 6722:ESO 104-33"
{
        Type  "Sb"
        RA           19.0611
        Dec         -64.8950
        Distance    2.08e+08  # method: V
        Radius     8.772e+04
        AbsMag        -20.42
        Axis    [ -0.6319  -0.7076   0.3163]
        Angle    149.1244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6722"
}

Galaxy "NGC 6725:ESO 183-36:AM 1857-535"
{
        Type  "S0"
        RA           19.0322
        Dec         -53.8642
        Distance   1.603e+08  # method: V
        Radius      5.13e+04
        AbsMag        -21.06
        Axis    [  0.0201  -0.8138  -0.5809]
        Angle    101.0944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6725"
}

Galaxy "NGC 6730:ESO 72-9"
{
        Type  "E1"
        RA           19.1258
        Dec         -68.9122
        Distance   1.847e+08  # method: V
        Radius     4.835e+04
        AbsMag        -21.46
        Axis    [ -0.3427  -0.3665  -0.8650]
        Angle    170.3567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6730"
}

Galaxy "NGC 6732-1:UGC 11381:MCG 9-31-11:ZWG 280.11"
{
        Type  "E0"
        RA           18.9400
        Dec          52.3775
        Distance   2.754e+08  # distance uncertain!
        Radius     4.807e+04
        AbsMag        -20.13
        Axis    [ -0.1842  -0.9820  -0.0426]
        Angle     93.2955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6732-1"
}

Galaxy "NGC 6732-2:UGC 11381:MCG 9-31-11:ZWG 280.11"
{
        Type  "E0"
        RA           18.9406
        Dec          52.3772
        Distance   5.496e+08  # distance uncertain!
        Radius          7993
        AbsMag        -20.13
        Axis    [ -0.0627  -0.9904  -0.1232]
        Angle    192.1443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6732-2"
}

Galaxy "NGC 6733:ESO 141-25"
{
        Type  "S0"
        RA           19.1028
        Dec         -62.1967
        Distance   2.198e+08  # method: V
        Radius     5.756e+04
        AbsMag        -20.94
        Axis    [ -0.7080  -0.6682  -0.2284]
        Angle    121.8572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6733"
}

Galaxy "NGC 6734:ESO 104-36:AM 1902-653"
{
        Type  "S0"
        RA           19.1206
        Dec         -65.4608
        Distance   1.896e+08  # method: V
        Radius     3.585e+04
        AbsMag        -20.02
        Axis    [ -0.0784  -0.4678  -0.8804]
        Angle    145.0297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6734"
}

Galaxy "NGC 6736:ESO 104-37:AM 1902-653"
{
        Type  "E2"
        RA           19.1247
        Dec         -65.4286
        Distance   2.512e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -20.13
        Axis    [ -0.6748  -0.3340  -0.6581]
        Angle    152.4389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6736"
}

Galaxy "NGC 6739:ESO 141-28:A 1903-61"
{
        Type  "S0"
        RA           19.1300
        Dec         -61.3675
        Distance     1.9e+08  # method: V
        Radius     6.634e+04
        AbsMag        -20.73
        Axis    [ -0.7248  -0.6007   0.3374]
        Angle    145.2580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6739"
}

Galaxy "NGC 6740:UGC 11388:MCG 5-45-1:IRAS 18587+2841"
{
        Type  "Sb"
        RA           19.0139
        Dec          28.7711
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.0869  -0.9661  -0.2431]
        Angle    154.6668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6740"
}

Galaxy "NGC 6744:ESO 104-42:AM 1905-635:IRAS 19050-6354"
{
        Type  "SBc"
        RA           19.1628
        Dec         -63.8567
        Distance    3.61e+07  # method: V
        Radius     1.055e+05
        AbsMag        -21.11
        Axis    [ -0.0550  -0.5446  -0.8369]
        Angle    127.3721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6744"
}

Galaxy "NGC 6744A:ESO 104-38"
{
        Type  "Irr"
        RA           19.1453
        Dec         -63.7300
        Distance   3.631e+08  # distance uncertain!
        Radius     9.506e+04
        AbsMag        -20.13
        Axis    [ -0.5974  -0.7911  -0.1317]
        Angle    119.2820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6744A"
}

Galaxy "NGC 6745-1:UGC 11391:ZWG 229.13:IRAS 19000+4040"
{
        Type  "Irr"
        RA           19.0281
        Dec          40.7458
        Distance   1.994e+08  # method: V
        Radius      3.77e+04
        AbsMag        -19.43
        Axis    [  0.4883  -0.8663  -0.1055]
        Angle    157.4178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6745-1"
}

Galaxy "NGC 6745-2:UGC 11391:ZWG 229.13:IRAS 19000+4040"
{
        Type  "S0"
        RA           19.0281
        Dec          40.7592
        Distance   9.715e+07  # distance uncertain!
        Radius          5652
        AbsMag        -19.07
        Axis    [  0.4530  -0.8573  -0.2447]
        Angle    176.7943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6745-2"
}

Galaxy "NGC 6746:ESO 141-29:IRAS 19058-6202"
{
        Type  "S0"
        RA           19.1728
        Dec         -61.9683
        Distance   1.864e+08  # method: V
        Radius     3.795e+04
        AbsMag        -20.68
        Axis    [ -0.8320  -0.4664   0.3004]
        Angle    140.7716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6746"
}

Galaxy "NGC 6747:ZWG 341.12:NPM 1"
{
        Type  "E0"
        RA           18.9225
        Dec          72.7722
        Distance   3.631e+08  # distance uncertain!
        Radius     2.641e+04
        AbsMag        -20.13
        Axis    [  0.0521  -0.9924   0.1112]
        Angle     67.4032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6747"
}

Galaxy "NGC 6750:UGC 11389:MCG 10-27-6:ZWG 302.8"
{
        Type  "Sc"
        RA           19.0100
        Dec          59.1672
        Distance   1.223e+08  # distance uncertain!
        Radius     1.779e+04
        AbsMag        -19.07
        Axis    [  0.4248  -0.9009  -0.0894]
        Angle    184.0448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6750"
}

Galaxy "NGC 6753:ESO 184-22:AM 1907-570:IRAS 19071-5707"
{
        Type  "Sb"
        RA           19.1897
        Dec         -57.0489
        Distance   1.395e+08  # method: V
        Radius      4.87e+04
        AbsMag        -21.26
        Axis    [ -0.2457  -0.5730  -0.7819]
        Angle    141.5944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6753"
}

Galaxy "NGC 6754:ESO 231-25:AM 1907-504:IRAS 19075-5043"
{
        Type  "SBb"
        RA           19.1903
        Dec         -50.6419
        Distance   1.686e+08  # method: T-F
        Radius     4.414e+04
        AbsMag        -20.67
        Axis    [ -0.4059  -0.8433  -0.3523]
        Angle    111.9690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6754"
}

Galaxy "NGC 6754A:ESO 231-23:IRAS 19048-5107"
{
        Type  "Sb"
        RA           19.1456
        Dec         -51.0464
        Distance   2.392e+08  # method: T-F
        Radius     5.915e+04
        AbsMag        -20.03
        Axis    [ -0.3542  -0.9348  -0.0274]
        Angle    110.8470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6754A"
}

Galaxy "NGC 6757:UGC 11401:MCG 9-31-19:ZWG 280.13"
{
        Type  "SBa"
        RA           19.0850
        Dec          55.7175
        Distance   1.281e+08  # distance uncertain!
        Radius     2.608e+04
        AbsMag        -19.07
        Axis    [  0.2731  -0.9292   0.2491]
        Angle    116.4128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6757"
}

Galaxy "NGC 6758:ESO 184-37:AM 1909-562"
{
        Type  "E0"
        RA           19.2311
        Dec         -56.3094
        Distance    1.48e+08  # method: T-F
        Radius      4.95e+04
        AbsMag        -20.68
        Axis    [ -0.9107  -0.2677  -0.3146]
        Angle    132.3790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6758"
}

Galaxy "NGC 6759:MCG 8-35-2:ZWG 256.6"
{
        Type  "S0"
        RA           19.1158
        Dec          50.3483
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.3219  -0.9441  -0.0710]
        Angle    164.7313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6759"
}

Galaxy "NGC 6761:ESO 231-28:FAIR 858:IRAS 19113-5044"
{
        Type  "SBb"
        RA           19.2511
        Dec         -50.6569
        Distance   2.522e+08  # method: V
        Radius     5.869e+04
        AbsMag        -20.44
        Axis    [ -0.0837  -0.6305  -0.7717]
        Angle    136.7692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6761"
}

Galaxy "NGC 6762:NGC 6763:UGC 11405:ZWG 323.9"
{
        Type  "Sa"
        RA           19.0936
        Dec          63.9342
        Distance    1.54e+08  # distance uncertain!
        Radius     3.359e+04
        AbsMag        -19.07
        Axis    [  0.4456  -0.5985   0.6657]
        Angle    111.2493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6762"
}

Galaxy "NGC 6764:UGC 11407:MCG 8-35-3:ZWG 256.7"
{
        Type  "SBc"
        RA           19.1378
        Dec          50.9331
        Distance   1.314e+08  # method: T-F
        Radius     4.204e+04
        AbsMag        -20.32
        Axis    [  0.3769  -0.9141   0.1496]
        Angle    135.5185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6764"
}

Galaxy "NGC 6768-1:ESO 337-18:MCG 7-39-10"
{
        Type  "E4"
        RA           19.2756
        Dec         -40.2086
        Distance   2.472e+08  # method: V
        Radius     4.315e+04
        AbsMag         -21.2
        Axis    [ -0.4028  -0.5772  -0.7103]
        Angle    163.2423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6768-1"
}

Galaxy "NGC 6768-2:ESO 337-17:MCG 7-39-9"
{
        Type  "S0"
        RA           19.2747
        Dec         -40.2228
        Distance   1.281e+08  # distance uncertain!
        Radius     1.118e+04
        AbsMag        -19.07
        Axis    [  0.0901  -0.6531  -0.7519]
        Angle    140.7417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6768-2"
}

Galaxy "NGC 6769:ESO 141-48:VV 304:AM 1914-603"
{
        Type  "SBb"
        RA           19.3061
        Dec         -60.5008
        Distance   1.724e+08  # method: V
        Radius     5.517e+04
        AbsMag        -21.21
        Axis    [ -0.7641  -0.6389  -0.0898]
        Angle    125.0122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6769"
}

Galaxy "NGC 6770:ESO 141-49:VV 304:AM 1914-603"
{
        Type  "SBb"
        RA           19.3103
        Dec         -60.4961
        Distance   1.734e+08  # method: V
        Radius     5.547e+04
        AbsMag        -20.83
        Axis    [ -0.1300  -0.5744  -0.8082]
        Angle    132.9219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6770"
}

Galaxy "NGC 6771:ESO 141-50:AM 1923-603"
{
        Type  "SBa"
        RA           19.3108
        Dec         -60.5464
        Distance   1.887e+08  # method: V
        Radius     6.313e+04
        AbsMag        -20.31
        Axis    [ -0.5074  -0.8607   0.0416]
        Angle    122.4523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6771"
}

Galaxy "NGC 6776:ESO 104-53:AM 1920-635"
{
        Type  "E0"
        RA           19.4219
        Dec         -63.8600
        Distance   1.421e+08  # method: T-F
        Radius     3.306e+04
        AbsMag        -20.09
        Axis    [ -0.3002  -0.4096  -0.8614]
        Angle    174.3301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6776"
}

Galaxy "NGC 6776A:ESO 104-52:IRAS 19204-6346"
{
        Type  "SBc"
        RA           19.4181
        Dec         -63.6828
        Distance   1.882e+08  # method: T-F
        Radius     3.832e+04
        AbsMag        -19.01
        Axis    [ -0.3713  -0.8951  -0.2468]
        Angle    109.8822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6776A"
}

Galaxy "NGC 6780:ESO 184-62:AM 1918-555:IRAS 19187-5552"
{
        Type  "SBc"
        RA           19.3806
        Dec         -55.7758
        Distance   1.546e+08  # method: V
        Radius     4.271e+04
        AbsMag        -20.08
        Axis    [ -0.8935  -0.3707   0.2536]
        Angle    130.4486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6780"
}

Galaxy "NGC 6782:ESO 142-1:FAIR 57:IRAS 19195-6001"
{
        Type  "SBa"
        RA           19.3992
        Dec         -59.9222
        Distance   1.735e+08  # method: V
        Radius     6.056e+04
        AbsMag        -21.73
        Axis    [ -0.3747  -0.5998  -0.7070]
        Angle    134.2548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6782"
}

Galaxy "NGC 6783:MCG 8-35-7:ZWG 256.13"
{
        Type  "E0"
        RA           19.2797
        Dec          46.0181
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [ -0.0934  -0.9797  -0.1775]
        Angle    195.9449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6783"
}

Galaxy "NGC 6784:ESO 104-55:AM 1921-654"
{
        Type  "S0"
        RA           19.4419
        Dec         -65.6267
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.7997  -0.5155   0.3078]
        Angle    146.7336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6784"
}

Galaxy "NGC 6784A:ESO 104-55A"
{
        Type  "S0"
        RA           19.4431
        Dec         -65.6175
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [ -0.3013  -0.6766  -0.6719]
        Angle    118.0160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6784A"
}

Galaxy "NGC 6786:UGC 11414:ZWG 341.19:VV 414"
{
        Type  "SBc"
        RA           19.1814
        Dec          73.4108
        Distance   3.364e+08  # method: V
        Radius     5.382e+04
        AbsMag        -21.27
        Axis    [  0.3039  -0.9400   0.1549]
        Angle    156.3522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6786"
}

Galaxy "NGC 6787:UGC 11424:MCG 10-27-9:ZWG 302.9"
{
        Type  "SBb"
        RA           19.2694
        Dec          60.4175
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [  0.1960  -0.9316   0.3062]
        Angle    102.0342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6787"
}

Galaxy "NGC 6788:ESO 184-67:AM 1922-550:IRAS 19227-5503"
{
        Type  "Sb"
        RA           19.4469
        Dec         -54.9506
        Distance   1.752e+08  # method: T-F
        Radius     7.391e+04
        AbsMag        -20.75
        Axis    [ -0.3017  -0.8862  -0.3517]
        Angle    109.4419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6788"
}

Galaxy "NGC 6789:UGC 11425:MCG 11-23-1:ZWG 323.11"
{
        Type  "Irr"
        RA           19.2781
        Dec          63.9719
        Distance   1.906e+08  # distance uncertain!
        Radius     3.603e+04
        AbsMag        -20.13
        Axis    [  0.2962  -0.9420   0.1580]
        Angle    141.4474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6789"
}

Galaxy "NGC 6792:UGC 11429:MCG 7-40-2:ZWG 230.5"
{
        Type  "SBb"
        RA           19.3492
        Dec          43.1322
        Distance   2.029e+08  # method: V
        Radius     6.492e+04
        AbsMag        -20.67
        Axis    [  0.3542  -0.9276  -0.1191]
        Angle    163.4129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6792"
}

Galaxy "NGC 6794:ESO 338-5:MCG 7-40-1"
{
        Type  "Sb"
        RA           19.4675
        Dec         -38.9186
        Distance   1.281e+08  # distance uncertain!
        Radius     3.167e+04
        AbsMag        -19.07
        Axis    [ -0.5137  -0.7656  -0.3873]
        Angle    121.9317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6794"
}

Galaxy "NGC 6796:UGC 11432:MCG 10-27-10:ZWG 302.11"
{
        Type  "Sc"
        RA           19.3586
        Dec          61.1450
        Distance    8.92e+07  # method: V
        Radius     2.465e+04
        AbsMag        -18.68
        Axis    [  0.1097  -0.1993   0.9738]
        Angle     99.6906
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6796"
}

Galaxy "NGC 6798:IC 1300:UGC 11434:MCG 9-32-2"
{
        Type  "S0"
        RA           19.4008
        Dec          53.6242
        Distance    1.47e+08  # distance uncertain!
        Radius     3.422e+04
        AbsMag        -19.07
        Axis    [  0.1789  -0.6946   0.6968]
        Angle     87.0272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6798"
}

Galaxy "NGC 6799:ESO 184-78"
{
        Type  "S0"
        RA           19.5378
        Dec         -55.9078
        Distance   2.677e+08  # method: V
        Radius     6.229e+04
        AbsMag        -21.57
        Axis    [ -0.6750  -0.6816  -0.2825]
        Angle    123.0650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6799"
}

Galaxy "NGC 6801:UGC 11443:MCG 9-32-5:ZWG 281.3"
{
        Type  "Sc"
        RA           19.4597
        Dec          54.3725
        Distance   1.913e+08  # method: V
        Radius     3.616e+04
        AbsMag        -19.24
        Axis    [  0.4020  -0.9138   0.0586]
        Angle    155.3212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6801"
}

Galaxy "NGC 6805:ESO 338-14:MCG 6-43-2"
{
        Type  "E1"
        RA           19.6125
        Dec         -37.5539
        Distance   2.512e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -20.13
        Axis    [ -0.9789  -0.1738   0.1070]
        Angle    108.1300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6805"
}

Galaxy "NGC 6806:ESO 338-15:MCG 7-40-3:FAIR 1162"
{
        Type  "SBc"
        RA           19.6178
        Dec         -42.2958
        Distance   2.537e+08  # method: V
        Radius     4.428e+04
        AbsMag        -20.75
        Axis    [ -0.0851  -0.7276  -0.6807]
        Angle    133.7692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6806"
}

Galaxy "NGC 6808:ESO 73-3:IRAS 19385-7045"
{
        Type  "Sa"
        RA           19.7317
        Dec         -70.6322
        Distance   1.547e+08  # method: V
        Radius     3.601e+04
        AbsMag        -20.88
        Axis    [ -0.3275  -0.6351  -0.6996]
        Angle    119.6597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6808"
}

Galaxy "NGC 6810:ESO 142-35:IRAS 19393-5846"
{
        Type  "Sb"
        RA           19.7261
        Dec         -58.6561
        Distance   1.183e+08  # method: T-F
        Radius     2.065e+04
        AbsMag         -20.4
        Axis    [ -0.8424  -0.3887   0.3731]
        Angle    140.4694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6810"
}

Galaxy "NGC 6812:ESO 185-15:AM 1941-552"
{
        Type  "S0"
        RA           19.7564
        Dec         -55.3469
        Distance   1.115e+08  # distance uncertain!
        Radius     1.785e+04
        AbsMag        -19.07
        Axis    [ -0.5679  -0.7947  -0.2143]
        Angle    120.4502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6812"
}

Galaxy "NGC 6814:MCG 2-50-1:IRAS 19399-1026"
{
        Type  "SBc"
        RA           19.7111
        Dec         -10.3244
        Distance   6.156e+07  # method: V
        Radius     2.686e+04
        AbsMag        -19.28
        Axis    [ -0.0295  -0.7881  -0.6148]
        Angle    176.9864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6814"
}

Galaxy "NGC 6816:ESO 460-30:MCG 5-46-6"
{
        Type  "S0"
        RA           19.7339
        Dec         -28.4008
        Distance   1.168e+08  # distance uncertain!
        Radius     2.039e+04
        AbsMag        -19.07
        Axis    [ -0.3500  -0.8982  -0.2659]
        Angle    119.1901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6816"
}

Galaxy "NGC 6817-1:MCG 10-28-5:ZWG 303.4"
{
        Type  "Sc"
        RA           19.6231
        Dec          62.3839
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.1894  -0.9559   0.2244]
        Angle    120.1165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6817-1"
}

Galaxy "NGC 6817-2:NPM 1"
{
        Type  "E0"
        RA           19.6225
        Dec          62.3833
        Distance    6.31e+08  # distance uncertain!
        Radius     1.836e+04
        AbsMag        -20.13
        Axis    [ -0.0925  -0.9950  -0.0363]
        Angle    201.9304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6817-2"
}

Galaxy "NGC 6821:MCG 1-50-2:IRAS 19417-0657"
{
        Type  "SBc"
        RA           19.7400
        Dec          -6.8344
        Distance   5.962e+07  # method: V
        Radius     1.127e+04
        AbsMag        -17.51
        Axis    [ -0.6093  -0.7603   0.2253]
        Angle     97.6431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6821"
}

Galaxy "NGC 6822:IC 4895:MCG 2-50-6:DDO 209"
{
        Type  "Irr"
        RA           19.7489
        Dec         -14.8064
        Distance     1.6e+06  # method: CP
        Radius          3584
        AbsMag        -14.15
        Axis    [ -0.0572  -0.7777  -0.6260]
        Angle    171.1568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6822"
}

Galaxy "NGC 6824:UGC 11470:MCG 9-32-12:ZWG 281.8"
{
        Type  "Sb"
        RA           19.7278
        Dec          56.1089
        Distance   1.444e+08  # method: V
        Radius     3.991e+04
        AbsMag        -20.23
        Axis    [  0.2570  -0.9603   0.1083]
        Angle    145.2924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6824"
}

Galaxy "NGC 6825:ZWG 324.1:ZW 906"
{
        Type  "E0"
        RA           19.6983
        Dec          64.0733
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [ -0.0968  -0.9359   0.3386]
        Angle     31.1246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6825"
}

Galaxy "NGC 6829:UGC 11478:MCG 10-28-10:ZWG 303.9"
{
        Type  "Sb"
        RA           19.7853
        Dec          59.9072
        Distance    2.03e+08  # distance uncertain!
        Radius     4.723e+04
        AbsMag        -19.07
        Axis    [  0.5798  -0.8145   0.0208]
        Angle    172.8303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6829"
}

Galaxy "NGC 6831:UGC 11483:MCG 10-28-11:ZWG 303.11"
{
        Type  "S0"
        RA           19.7992
        Dec          59.8931
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [ -0.0814  -0.9947  -0.0634]
        Angle    203.8666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6831"
}

Galaxy "NGC 6835:MCG 2-50-9:IRAS 19517-1241"
{
        Type  "SBa"
        RA           19.9089
        Dec         -12.5675
        Distance   6.369e+07  # method: V
        Radius     2.223e+04
        AbsMag        -18.05
        Axis    [  0.0232  -0.9975  -0.0664]
        Angle    119.3756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6835"
}

Galaxy "NGC 6836:MCG 2-50-10:IRAS 19518-1249"
{
        Type  "Irr"
        RA           19.9111
        Dec         -12.6883
        Distance   6.406e+07  # method: V
        Radius     1.584e+04
        AbsMag        -17.97
        Axis    [ -0.6923  -0.6838   0.2304]
        Angle    100.5999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6836"
}

Galaxy "NGC 6841:ESO 461-23:MCG 5-47-11"
{
        Type  "E0"
        RA           19.9636
        Dec         -31.8108
        Distance   1.906e+08  # distance uncertain!
        Radius     4.157e+04
        AbsMag        -20.13
        Axis    [ -0.9529  -0.2995   0.0472]
        Angle    107.8479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6841"
}

Galaxy "NGC 6844:ESO 105-21:FAIR 526:IRAS 19581-6522"
{
        Type  "Sb"
        RA           20.0472
        Dec         -65.2289
        Distance    1.42e+08  # method: V
        Radius     2.891e+04
        AbsMag        -19.69
        Axis    [ -0.1110  -0.4873  -0.8662]
        Angle    143.4424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6844"
}

Galaxy "NGC 6845:NGC 6845A:ESO 284-8:AM 1957-471"
{
        Type  "SBb"
        RA           20.0161
        Dec         -47.0700
        Distance   2.819e+08  # method: V
        Radius      9.43e+04
        AbsMag        -20.88
        Axis    [ -0.3503  -0.8883  -0.2969]
        Angle    118.2818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6845"
}

Galaxy "NGC 6845B:ESO 284-8"
{
        Type  "SBb"
        RA           20.0181
        Dec         -47.0594
        Distance   2.999e+08  # method: V
        Radius     4.798e+04
        AbsMag        -19.92
        Axis    [  0.0168  -0.6618  -0.7495]
        Angle    133.6865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6845B"
}

Galaxy "NGC 6845C:ESO 284-8A:A 1957-47A"
{
        Type  "S0"
        RA           20.0156
        Dec         -47.0842
        Distance   3.143e+08  # method: V
        Radius     3.656e+04
        AbsMag        -19.52
        Axis    [ -0.6525  -0.7194   0.2381]
        Angle    129.1818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6845C"
}

Galaxy "NGC 6845D:ESO 284-8B:A 1957-47B"
{
        Type  "Sa"
        RA           20.0147
        Dec         -47.0947
        Distance   3.143e+08  # method: V
        Radius     3.199e+04
        AbsMag        -18.62
        Axis    [ -0.5751  -0.7041   0.4165]
        Angle    141.2318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6845D"
}

Galaxy "NGC 6848:ESO 185-52:AM 1958-561:IRAS 19588-5613"
{
        Type  "Sa"
        RA           20.0461
        Dec         -56.0903
        Distance   1.932e+08  # method: V
        Radius     6.743e+04
        AbsMag        -21.36
        Axis    [ -0.6843  -0.6390   0.3513]
        Angle    143.5270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6848"
}

Galaxy "NGC 6849:ESO 339-32:MCG 7-41-7"
{
        Type  "S0"
        RA           20.1042
        Dec         -40.1983
        Distance   1.999e+08  # method: T-F
        Radius     5.523e+04
        AbsMag        -20.94
        Axis    [ -0.0507  -0.7469  -0.6630]
        Angle    135.1074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6849"
}

Galaxy "NGC 6850:ESO 185-56:AM 1959-545:IRAS 19595-5459"
{
        Type  "SBa"
        RA           20.0581
        Dec         -54.8453
        Distance   2.194e+08  # method: V
        Radius     6.702e+04
        AbsMag        -20.64
        Axis    [ -0.7228  -0.6178   0.3096]
        Angle    138.6949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6850"
}

Galaxy "NGC 6851:ESO 233-21"
{
        Type  "E0"
        RA           20.0594
        Dec         -48.2844
        Distance   1.179e+08  # method: S
        Radius     3.429e+04
        AbsMag        -20.09
        Axis    [ -0.9788  -0.1525   0.1365]
        Angle    119.5015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6851"
}

Galaxy "NGC 6851A:NGC 6861A:ESO 233-25:AM 2002-480"
{
        Type  "Sc"
        RA           20.0967
        Dec         -47.9769
        Distance   1.205e+08  # method: T-F
        Radius     2.279e+04
        AbsMag        -17.94
        Axis    [ -0.2685  -0.8532  -0.4473]
        Angle    120.1720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6851A"
}

Galaxy "NGC 6851B:ESO 233-23:FGCE 1429"
{
        Type  "SBc"
        RA           20.0942
        Dec         -47.9792
        Distance   3.369e+08  # distance uncertain!
        Radius     5.389e+04
        AbsMag        -19.07
        Axis    [ -0.1958  -0.9581  -0.2089]
        Angle    113.7450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6851B"
}

Galaxy "NGC 6854:ESO 185-61:AM 2001-543"
{
        Type  "S0"
        RA           20.0939
        Dec         -54.3750
        Distance   9.715e+07  # distance uncertain!
        Radius     2.826e+04
        AbsMag        -19.07
        Axis    [ -0.7783  -0.4984   0.3819]
        Angle    139.9991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6854"
}

Galaxy "NGC 6855:ESO 185-63:AM 2002-563"
{
        Type  "SBa"
        RA           20.1136
        Dec         -56.3897
        Distance   1.915e+08  # method: V
        Radius     4.179e+04
        AbsMag        -20.04
        Axis    [ -0.8160  -0.5620  -0.1352]
        Angle    129.9276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6855"
}

Galaxy "NGC 6860:ESO 143-9:AM 2004-611:IRAS 20044-6114"
{
        Type  "Sb"
        RA           20.1464
        Dec         -61.0997
        Distance   1.983e+08  # method: V
        Radius     3.749e+04
        AbsMag        -20.22
        Axis    [ -0.2928  -0.6778  -0.6744]
        Angle    126.4737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6860"
}

Galaxy "NGC 6861:IC 4949:ESO 233-32:AM 2006-483"
{
        Type  "S0"
        RA           20.1219
        Dec         -48.3694
        Distance    9.15e+07  # method: S
        Radius     3.993e+04
        AbsMag        -20.14
        Axis    [ -0.7431  -0.6359   0.2085]
        Angle    128.7272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861"
}

Galaxy "NGC 6861B:ESO 233-26"
{
        Type  "S0"
        RA           20.1014
        Dec         -48.4744
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [ -0.3858  -0.9226  -0.0026]
        Angle    121.3188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861B"
}

Galaxy "NGC 6861C:ESO 233-31"
{
        Type  "S0"
        RA           20.1114
        Dec         -48.6492
        Distance   1.074e+08  # method: V
        Radius     1.874e+04
        AbsMag        -17.49
        Axis    [ -0.1321  -0.8085  -0.5735]
        Angle    120.4715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861C"
}

Galaxy "NGC 6861D:ESO 233-34"
{
        Type  "S0"
        RA           20.1386
        Dec         -48.2119
        Distance   1.074e+08  # method: V
        Radius     3.279e+04
        AbsMag        -19.09
        Axis    [ -0.5994  -0.6951   0.3970]
        Angle    140.9185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861D"
}

Galaxy "NGC 6861E:ESO 233-42"
{
        Type  "Sb"
        RA           20.1836
        Dec         -48.6906
        Distance   1.233e+08  # method: T-F
        Radius      2.51e+04
        AbsMag        -17.79
        Axis    [ -0.0408  -0.8813  -0.4709]
        Angle    111.6996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861E"
}

Galaxy "NGC 6861F:ESO 233-43"
{
        Type  "SBc"
        RA           20.1864
        Dec         -48.2756
        Distance   9.898e+07  # method: T-F
        Radius     2.303e+04
        AbsMag        -17.11
        Axis    [ -0.2849  -0.9562  -0.0670]
        Angle    118.7319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6861F"
}

Galaxy "NGC 6862:ESO 186-2:IRAS 20049-5632"
{
        Type  "SBc"
        RA           20.1483
        Dec         -56.3917
        Distance   1.858e+08  # method: V
        Radius     4.323e+04
        AbsMag        -20.28
        Axis    [ -0.8556  -0.4766   0.2021]
        Angle    133.3328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6862"
}

Galaxy "NGC 6865"
{
        Type  "S0"
        RA           20.0989
        Dec          -9.0406
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [ -0.5189  -0.8121   0.2668]
        Angle    106.5618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6865"
}

Galaxy "NGC 6867:ESO 186-6:AM 2006-545:IRAS 20065-5455"
{
        Type  "SBc"
        RA           20.1750
        Dec         -54.7842
        Distance   1.843e+08  # method: T-F
        Radius     5.362e+04
        AbsMag        -19.86
        Axis    [ -0.6424  -0.6687   0.3744]
        Angle    145.4914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6867"
}

Galaxy "NGC 6868:ESO 233-39:AM 2006-483"
{
        Type  "E2"
        RA           20.1650
        Dec         -48.3800
        Distance   8.739e+07  # method: S
        Radius     4.576e+04
        AbsMag        -20.54
        Axis    [ -0.7958  -0.4303  -0.4261]
        Angle    142.6987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6868"
}

Galaxy "NGC 6869:UGC 11506:MCG 11-24-4:ZWG 324.6"
{
        Type  "S0"
        RA           20.0117
        Dec          66.2281
        Distance   1.046e+08  # method: S
        Radius     2.434e+04
        AbsMag        -19.43
        Axis    [  0.2438  -0.9310   0.2716]
        Angle    125.2806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6869"
}

Galaxy "NGC 6870:ESO 233-41:AM 2006-483:IRAS 20065-4826"
{
        Type  "Sb"
        RA           20.1694
        Dec         -48.2867
        Distance   2.268e+08  # method: T-F
        Radius     8.577e+04
        AbsMag        -21.01
        Axis    [ -0.4709  -0.8592  -0.2003]
        Angle    121.7073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6870"
}

Galaxy "NGC 6872:ESO 73-32:VV 297:AM 2011-705"
{
        Type  "SBb"
        RA           20.2825
        Dec         -70.7678
        Distance    2.16e+08  # method: V
        Radius     1.885e+05
        AbsMag         -21.6
        Axis    [ -0.4174  -0.8348  -0.3590]
        Angle    114.5862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6872"
}

Galaxy "NGC 6875:ESO 284-28:AM 2009-461:IRAS 20096-4618"
{
        Type  "S0"
        RA           20.2200
        Dec         -46.1614
        Distance   1.351e+08  # method: V
        Radius     4.717e+04
        AbsMag        -20.09
        Axis    [ -0.1226  -0.7358  -0.6660]
        Angle    132.3650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6875"
}

Galaxy "NGC 6875A:ESO 284-24:IRAS 20084-4617"
{
        Type  "SBc"
        RA           20.1986
        Dec         -46.1431
        Distance   1.023e+08  # method: T-F
        Radius     4.017e+04
        AbsMag        -18.48
        Axis    [ -0.2127  -0.9656  -0.1496]
        Angle    116.2560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6875A"
}

Galaxy "NGC 6876:ESO 73-35:AM 2014-710"
{
        Type  "E3"
        RA           20.3053
        Dec         -70.8583
        Distance   1.277e+08  # method: T-F
        Radius     5.017e+04
        AbsMag        -21.26
        Axis    [ -0.8217  -0.2656  -0.5043]
        Angle    153.2428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6876"
}

Galaxy "NGC 6877:ESO 73-36:AM 2014-710"
{
        Type  "E6"
        RA           20.3097
        Dec         -70.8528
        Distance   1.856e+08  # method: V
        Radius     2.969e+04
        AbsMag        -20.58
        Axis    [ -0.9741  -0.0236   0.2248]
        Angle    139.4969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6877"
}

Galaxy "NGC 6878:ESO 284-31:MCG 7-41-15:IRAS 20104-4440"
{
        Type  "SBb"
        RA           20.2314
        Dec         -44.5267
        Distance   2.572e+08  # method: V
        Radius     5.985e+04
        AbsMag        -21.08
        Axis    [ -0.7268  -0.6834  -0.0692]
        Angle    124.7931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6878"
}

Galaxy "NGC 6878A:ESO 284-29:MCG 7-41-13"
{
        Type  "SBb"
        RA           20.2267
        Dec         -44.8164
        Distance   2.131e+08  # method: T-F
        Radius     5.578e+04
        AbsMag        -20.27
        Axis    [ -0.3290  -0.8940  -0.3042]
        Angle    120.7734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6878A"
}

Galaxy "NGC 6880:ESO 73-37:AM 2013-710:IRAS 20142-7100"
{
        Type  "SBa"
        RA           20.3247
        Dec         -70.8594
        Distance   1.768e+08  # method: V
        Radius     5.142e+04
        AbsMag        -20.47
        Axis    [ -0.3189  -0.6825  -0.6577]
        Angle    117.0075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6880"
}

Galaxy "NGC 6887:ESO 186-27:AM 2013-525:IRAS 20135-5257"
{
        Type  "Sc"
        RA           20.2881
        Dec         -52.7972
        Distance   1.267e+08  # method: T-F
        Radius     5.895e+04
        AbsMag        -20.15
        Axis    [ -0.5329  -0.8455  -0.0327]
        Angle    125.6738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6887"
}

Galaxy "NGC 6889:ESO 186-29:IRAS 20151-5406"
{
        Type  "SBc"
        RA           20.3147
        Dec         -53.9567
        Distance   1.168e+08  # distance uncertain!
        Radius     1.529e+04
        AbsMag        -19.07
        Axis    [ -0.5301  -0.7031  -0.4740]
        Angle    132.0910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6889"
}

Galaxy "NGC 6890:ESO 284-54:MCG 7-41-23:IRAS 20148-4457"
{
        Type  "SBb"
        RA           20.3050
        Dec         -44.8064
        Distance   1.049e+08  # method: V
        Radius     2.442e+04
        AbsMag        -19.54
        Axis    [ -0.8098  -0.5102   0.2895]
        Angle    126.8238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6890"
}

Galaxy "NGC 6893:ESO 234-6:FAIR 537:AM 2017-482"
{
        Type  "S0"
        RA           20.3469
        Dec         -48.2394
        Distance   1.345e+08  # method: V
        Radius     5.086e+04
        AbsMag        -20.38
        Axis    [ -0.1019  -0.6672  -0.7379]
        Angle    139.5367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6893"
}

Galaxy "NGC 6897:MCG 2-52-1:IRAS 20182-1224"
{
        Type  "Sc"
        RA           20.3503
        Dec         -12.2550
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.0002  -0.9147  -0.4042]
        Angle    141.5625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6897"
}

Galaxy "NGC 6898:MCG 2-52-2:IRAS 20183-1231"
{
        Type  "Sa"
        RA           20.3522
        Dec         -12.3589
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.4601  -0.7800   0.4241]
        Angle    114.9269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6898"
}

Galaxy "NGC 6899:ESO 234-22:FAIR 896:IRAS 20207-5035"
{
        Type  "SBc"
        RA           20.4061
        Dec         -50.4336
        Distance   2.188e+08  # method: T-F
        Radius     5.411e+04
        AbsMag        -20.73
        Axis    [ -0.6464  -0.7628   0.0180]
        Angle    128.3763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6899"
}

Galaxy "NGC 6900:MCG 0-52-1:MCG 1-52-1:IRAS 20189-0243"
{
        Type  "Sb"
        RA           20.3597
        Dec          -2.5697
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [ -0.5895  -0.4633   0.6617]
        Angle     99.4942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6900"
}

Galaxy "NGC 6901:IC 5000:UGC 11542:MCG 1-52-2"
{
        Type  "SBb"
        RA           20.3725
        Dec           6.4297
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.1356  -0.9892  -0.0560]
        Angle    134.3026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6901"
}

Galaxy "NGC 6902:IC 4948:ESO 285-8:MCG 7-42-2"
{
        Type  "SBa"
        RA           20.4075
        Dec         -43.6531
        Distance   1.188e+08  # method: V
        Radius     9.674e+04
        AbsMag           -21
        Axis    [ -0.7399  -0.5727   0.3528]
        Angle    130.5672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6902"
}

Galaxy "NGC 6902A1:ESO 285-4:MCG 7-41-32:AM 2019-442"
{
        Type  "Irr"
        RA           20.3833
        Dec         -44.2706
        Distance   1.623e+08  # method: T-F
        Radius     3.068e+04
        AbsMag        -19.08
        Axis    [ -0.3866  -0.7565  -0.5275]
        Angle    136.0168
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6902A1"
}

Galaxy "NGC 6902A2:ESO 285-4A:MCG 7-41-32:AM 2019-442"
{
        Type  "S0"
        RA           20.3828
        Dec         -44.2728
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.1145  -0.6200  -0.7762]
        Angle    157.5482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6902A2"
}

Galaxy "NGC 6902B:ESO 285-5:MCG 7-41-33:AM 2019-442"
{
        Type  "SBc"
        RA           20.3850
        Dec         -43.8689
        Distance   1.271e+08  # method: V
        Radius     2.772e+04
        AbsMag        -18.85
        Axis    [ -0.6727  -0.7253  -0.1465]
        Angle    126.8665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6902B"
}

Galaxy "NGC 6903:ESO 596-29:MCG 3-52-3"
{
        Type  "S0"
        RA           20.3956
        Dec         -19.3258
        Distance   8.081e+07  # distance uncertain!
        Radius     1.763e+04
        AbsMag        -19.07
        Axis    [ -0.2658  -0.7075  -0.6548]
        Angle    192.2356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6903"
}

Galaxy "NGC 6906:UGC 11548:MCG 1-52-3:ZWG 399.6"
{
        Type  "SBc"
        RA           20.3928
        Dec           6.4444
        Distance   2.078e+08  # method: V
        Radius     4.837e+04
        AbsMag        -20.82
        Axis    [  0.1343  -0.9491  -0.2849]
        Angle    148.6439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6906"
}

Galaxy "NGC 6907:ESO 528-3:MCG 4-48-6:UGCA 418"
{
        Type  "SBc"
        RA           20.4183
        Dec         -24.8092
        Distance   1.314e+08  # method: T-F
        Radius     6.497e+04
        AbsMag        -21.12
        Axis    [ -0.2641  -0.8574  -0.4417]
        Angle    140.4684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6907"
}

Galaxy "NGC 6908"
{
        Type  "S0"
        RA           20.4192
        Dec         -24.8028
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.1985  -0.7440  -0.6380]
        Angle    140.5539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6908"
}

Galaxy "NGC 6909:ESO 285-12:AM 2024-471"
{
        Type  "E0"
        RA           20.4606
        Dec         -47.0272
        Distance   1.157e+08  # method: S
        Radius     3.703e+04
        AbsMag        -20.15
        Axis    [ -0.7247  -0.4753  -0.4989]
        Angle    151.5208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6909"
}

Galaxy "NGC 6911:UGC 11540:MCG 11-24-6:ZWG 324.7"
{
        Type  "SBb"
        RA           20.3272
        Dec          66.7289
        Distance   1.072e+08  # method: V
        Radius      2.65e+04
        AbsMag        -17.28
        Axis    [  0.3357  -0.8213   0.4612]
        Angle    114.7886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6911"
}

Galaxy "NGC 6912:ESO 596-38:MCG 3-52-8:IRAS 20240-1846"
{
        Type  "SBc"
        RA           20.4478
        Dec         -18.6175
        Distance   3.103e+08  # method: V
        Radius     6.319e+04
        AbsMag        -20.59
        Axis    [ -0.2894  -0.8889  -0.3552]
        Angle    138.7519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6912"
}

Galaxy "NGC 6915:IRAS 20251-0314"
{
        Type  "Sb"
        RA           20.4628
        Dec          -3.0767
        Distance    8.86e+07  # distance uncertain!
        Radius     1.933e+04
        AbsMag        -19.07
        Axis    [ -0.1628  -0.9860  -0.0353]
        Angle    127.3854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6915"
}

Galaxy "NGC 6916:UGC 11554:MCG 10-29-4:ZWG 304.4"
{
        Type  "SBc"
        RA           20.3925
        Dec          58.3442
        Distance   1.329e+08  # method: V
        Radius      3.48e+04
        AbsMag        -18.15
        Axis    [  0.2722  -0.9197   0.2828]
        Angle    132.1867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6916"
}

Galaxy "NGC 6917:UGC 11563:MCG 1-52-7:ZWG 399.10"
{
        Type  "S0"
        RA           20.4578
        Dec           8.0972
        Distance   1.404e+08  # distance uncertain!
        Radius     2.859e+04
        AbsMag        -19.07
        Axis    [ -0.0131  -0.9587  -0.2842]
        Angle    152.5129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6917"
}

Galaxy "NGC 6918:ESO 234-40:FAIR 345:IRAS 20272-4738"
{
        Type  "SBa"
        RA           20.5128
        Dec         -47.4742
        Distance   7.457e+07  # method: V
        Radius          9761
        AbsMag         -17.3
        Axis    [ -0.7752  -0.3768   0.5070]
        Angle    136.9200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6918"
}

Galaxy "NGC 6919:ESO 285-27:MCG 7-42-11:IRAS 20282-4423"
{
        Type  "SBc"
        RA           20.5272
        Dec         -44.2167
        Distance   2.338e+08  # method: T-F
        Radius     5.442e+04
        AbsMag        -20.68
        Axis    [ -0.7607  -0.5845   0.2822]
        Angle    129.3042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6919"
}

Galaxy "NGC 6920:ESO 26-4:AM 2036-801"
{
        Type  "S0"
        RA           20.7325
        Dec         -80.0003
        Distance   1.251e+08  # method: V
        Radius     3.276e+04
        AbsMag        -20.42
        Axis    [ -0.9226  -0.3651   0.1243]
        Angle    151.9581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6920"
}

Galaxy "NGC 6921:UGC 11570:MCG 4-48-1:IRAS 20264+2533"
{
        Type  "Sa"
        RA           20.4744
        Dec          25.7239
        Distance   1.877e+08  # method: V
        Radius     2.457e+04
        AbsMag         -19.4
        Axis    [  0.0860  -0.7277   0.6805]
        Angle    122.2203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6921"
}

Galaxy "NGC 6922:UGC 11574:MCG 0-52-18:ZWG 373.17"
{
        Type  "Sc"
        RA           20.4978
        Dec          -2.1917
        Distance   2.446e+08  # method: V
        Radius     4.625e+04
        AbsMag        -20.27
        Axis    [ -0.5165  -0.7085   0.4809]
        Angle    104.3230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6922"
}

Galaxy "NGC 6923:IC 5004:ESO 462-29:MCG 5-48-17"
{
        Type  "SBb"
        RA           20.5275
        Dec         -30.8319
        Distance   1.283e+08  # method: T-F
        Radius     4.853e+04
        AbsMag        -20.27
        Axis    [ -0.3202  -0.9357  -0.1481]
        Angle    125.4489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6923"
}

Galaxy "NGC 6924:ESO 528-16:MCG 4-48-14:AM 2030-253"
{
        Type  "S0"
        RA           20.5553
        Dec         -25.4744
        Distance   2.636e+08  # method: V
        Radius     7.667e+04
        AbsMag        -20.94
        Axis    [ -0.7330  -0.5587   0.3880]
        Angle    114.7331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6924"
}

Galaxy "NGC 6925:ESO 463-4:MCG 5-48-22:AM 2031-320"
{
        Type  "Sc"
        RA           20.5722
        Dec         -31.9800
        Distance   1.195e+08  # method: T-F
        Radius     7.651e+04
        AbsMag        -20.72
        Axis    [  0.1742  -0.7612  -0.6246]
        Angle    130.7154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6925"
}

Galaxy "NGC 6926:UGC 11588:MCG 0-52-33:ZWG 373.33"
{
        Type  "SBc"
        RA           20.5514
        Dec          -2.0289
        Distance   2.584e+08  # method: V
        Radius     7.515e+04
        AbsMag        -21.29
        Axis    [  0.0773  -0.8264  -0.5577]
        Angle    172.5056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6926"
}

Galaxy "NGC 6927:MCG 2-52-16:ZWG 424.20:NPM 1"
{
        Type  "S0"
        RA           20.5439
        Dec           9.9169
        Distance   1.814e+08  # method: V
        Radius     1.319e+04
        AbsMag        -17.93
        Axis    [  0.2747  -0.8476  -0.4540]
        Angle    165.7879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6927"
}

Galaxy "NGC 6927A:MCG 2-52-15"
{
        Type  "E5"
        RA           20.5433
        Dec           9.8833
        Distance   1.879e+08  # method: V
        Radius          8197
        AbsMag         -17.3
        Axis    [ -0.3144  -0.8547  -0.4130]
        Angle    190.5450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6927A"
}

Galaxy "NGC 6928:IC 1325:UGC 11589:MCG 2-52-17"
{
        Type  "SBb"
        RA           20.5472
        Dec           9.9275
        Distance   2.027e+08  # method: V
        Radius      6.19e+04
        AbsMag        -20.67
        Axis    [  0.0452  -0.9392   0.3403]
        Angle    125.9501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6928"
}

Galaxy "NGC 6929:MCG 0-52-35:ZWG 373.35:NPM 1"
{
        Type  "Sa"
        RA           20.5558
        Dec          -2.0367
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.3546  -0.9231  -0.1486]
        Angle    132.4700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6929"
}

Galaxy "NGC 6930:IC 1326:UGC 11590:MCG 2-52-18"
{
        Type  "SBb"
        RA           20.5494
        Dec           9.8739
        Distance   1.984e+08  # method: V
        Radius     3.462e+04
        AbsMag        -20.12
        Axis    [  0.2584  -0.8615  -0.4371]
        Angle    164.7797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6930"
}

Galaxy "NGC 6931:MCG 2-52-16:IRAS 20309-1132"
{
        Type  "Sb"
        RA           20.5614
        Dec         -11.3689
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.2896  -0.8803   0.3759]
        Angle    122.8589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6931"
}

Galaxy "NGC 6932:ESO 47-8:AM 2036-734"
{
        Type  "S0"
        RA           20.7022
        Dec         -73.6189
        Distance    1.69e+08  # method: V
        Radius     5.408e+04
        AbsMag        -20.27
        Axis    [ -0.8362  -0.5455  -0.0571]
        Angle    141.4000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6932"
}

Galaxy "NGC 6935:ESO 234-59:FAIR 906:AM 2034-521"
{
        Type  "SBa"
        RA           20.6389
        Dec         -52.1103
        Distance   2.062e+08  # method: V
        Radius     6.297e+04
        AbsMag         -21.2
        Axis    [ -0.2361  -0.5918  -0.7708]
        Angle    153.9607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6935"
}

Galaxy "NGC 6936:ESO 528-22:MCG 4-48-21"
{
        Type  "S0"
        RA           20.5989
        Dec         -25.2800
        Distance   2.505e+08  # method: V
        Radius     6.558e+04
        AbsMag        -20.63
        Axis    [  0.0475  -0.7642  -0.6432]
        Angle    150.2462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6936"
}

Galaxy "NGC 6937:ESO 234-60:FAIR 349:AM 2035-521"
{
        Type  "SBc"
        RA           20.6458
        Dec         -52.1439
        Distance   2.049e+08  # method: V
        Radius      7.45e+04
        AbsMag        -20.49
        Axis    [ -0.5085  -0.6743  -0.5356]
        Angle    139.8296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6937"
}

Galaxy "NGC 6941:MCG 1-52-10:IRAS 20337-0447"
{
        Type  "Sb"
        RA           20.6064
        Dec          -4.6189
        Distance   2.698e+08  # method: V
        Radius     7.847e+04
        AbsMag        -20.99
        Axis    [ -0.3816  -0.8983   0.2177]
        Angle    116.7265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6941"
}

Galaxy "NGC 6942:ESO 186-73:AM 2036-542"
{
        Type  "SBa"
        RA           20.6769
        Dec         -54.3022
        Distance   1.722e+08  # method: V
        Radius     5.261e+04
        AbsMag        -21.01
        Axis    [ -0.8083  -0.5096   0.2949]
        Angle    137.6668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6942"
}

Galaxy "NGC 6943:ESO 74-6"
{
        Type  "SBc"
        RA           20.7425
        Dec         -68.7481
        Distance   1.248e+08  # method: T-F
        Radius     7.258e+04
        AbsMag        -20.91
        Axis    [ -0.7646  -0.6309   0.1316]
        Angle    144.5971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6943"
}

Galaxy "NGC 6944:MCG 1-52-17:ZWG 399.25:NPM 1"
{
        Type  "S0"
        RA           20.6397
        Dec           6.9969
        Distance   1.898e+08  # method: V
        Radius      4.14e+04
        AbsMag        -19.02
        Axis    [  0.1145  -0.9875  -0.1087]
        Angle    140.6546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6944"
}

Galaxy "NGC 6944A:MCG 1-52-16:ZWG 399.24"
{
        Type  "SBc"
        RA           20.6364
        Dec           6.9025
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.1889  -0.9773  -0.0955]
        Angle    136.0162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6944A"
}

Galaxy "NGC 6945:MCG 1-52-15"
{
        Type  "S0"
        RA           20.6500
        Dec          -4.9722
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [ -0.2942  -0.8752   0.3840]
        Angle    119.9042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6945"
}

Galaxy "NGC 6946:UGC 11597:MCG 10-29-6:ZWG 304.6"
{
        Type  "SBc"
        RA           20.5811
        Dec          60.1533
        Distance       2e+07  # method: P
        Radius     3.345e+04
        AbsMag        -19.23
        Axis    [  0.1475  -0.9857   0.0820]
        Angle    160.1032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6946"
}

Galaxy "NGC 6947:ESO 401-3:MCG 5-48-28:AM 2038-323"
{
        Type  "SBb"
        RA           20.6875
        Dec         -32.4864
        Distance   2.441e+08  # method: T-F
        Radius     5.681e+04
        AbsMag        -20.07
        Axis    [ -0.2783  -0.8756  -0.3948]
        Angle    134.5139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6947"
}

Galaxy "NGC 6948:ESO 187-9:AM 2039-533:IRAS 20397-5332"
{
        Type  "Sa"
        RA           20.7244
        Dec         -53.3572
        Distance   2.986e+08  # method: T-F
        Radius     9.554e+04
        AbsMag        -21.01
        Axis    [ -0.6075  -0.7881   0.0995]
        Angle    134.0910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6948"
}

Galaxy "NGC 6949:UGC 11600:MCG 11-25-1:ZWG 325.2"
{
        Type  "S0"
        RA           20.5853
        Dec          64.8033
        Distance   1.185e+08  # method: V
        Radius     2.412e+04
        AbsMag         -18.1
        Axis    [  0.1593  -0.9836  -0.0848]
        Angle    207.6635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6949"
}

Galaxy "NGC 6951:NGC 6952:UGC 11604:MCG 11-25-2"
{
        Type  "SBc"
        RA           20.6206
        Dec          66.1058
        Distance   5.799e+07  # method: V
        Radius     3.289e+04
        AbsMag        -19.45
        Axis    [  0.1973  -0.6428   0.7402]
        Angle     70.7463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6951"
}

Galaxy "NGC 6954:UGC 11618:MCG 0-53-1:ZWG 374.4"
{
        Type  "Sa"
        RA           20.7342
        Dec           3.2094
        Distance   1.689e+08  # method: V
        Radius     2.457e+04
        AbsMag        -19.47
        Axis    [ -0.0820  -0.9928  -0.0874]
        Angle    137.2874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6954"
}

Galaxy "NGC 6955:UGC 11621:ZWG 374.5:NPM 1"
{
        Type  "Sc"
        RA           20.7381
        Dec           2.5953
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [ -0.2196  -0.8926  -0.3937]
        Angle    168.3631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6955"
}

Galaxy "NGC 6956:UGC 11619:MCG 2-53-1:ZWG 425.1"
{
        Type  "SBb"
        RA           20.7314
        Dec          12.5122
        Distance   1.979e+08  # method: V
        Radius     5.468e+04
        AbsMag        -20.71
        Axis    [ -0.2537  -0.8607  -0.4413]
        Angle    204.4277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6956"
}

Galaxy "NGC 6957:ZWG 374.7"
{
        Type  "Sc"
        RA           20.7464
        Dec           2.5806
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [ -0.5125  -0.5533   0.6566]
        Angle    100.3835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6957"
}

Galaxy "NGC 6958:ESO 341-15:MCG 6-45-17:IRAS 20455-3810"
{
        Type  "S0"
        RA           20.8117
        Dec         -37.9978
        Distance    1.17e+08  # method: T-F
        Radius     4.255e+04
        AbsMag        -20.47
        Axis    [ -0.6502  -0.7597   0.0079]
        Angle    128.3100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6958"
}

Galaxy "NGC 6959:ZWG 374.13"
{
        Type  "S0"
        RA           20.7853
        Dec           0.4303
        Distance   1.539e+08  # method: V
        Radius     1.343e+04
        AbsMag        -18.57
        Axis    [ -0.0047  -0.9872  -0.1591]
        Angle    140.9955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6959"
}

Galaxy "NGC 6961:ZWG 374.14:NPM 1"
{
        Type  "E0"
        RA           20.7861
        Dec           0.3639
        Distance    1.59e+08  # method: V
        Radius     1.388e+04
        AbsMag        -18.84
        Axis    [ -0.7655  -0.6361   0.0974]
        Angle     99.8817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6961"
}

Galaxy "NGC 6962:UGC 11628:MCG 0-53-3:ZWG 374.15"
{
        Type  "SBb"
        RA           20.7883
        Dec           0.3219
        Distance    1.78e+08  # method: V
        Radius     7.507e+04
        AbsMag        -20.68
        Axis    [ -0.2428  -0.9657  -0.0921]
        Angle    135.1872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6962"
}

Galaxy "NGC 6964:UGC 11629:MCG 0-53-5:ZWG 374.17"
{
        Type  "E0"
        RA           20.7900
        Dec           0.3014
        Distance   1.605e+08  # method: V
        Radius     3.967e+04
        AbsMag        -19.56
        Axis    [ -0.8252  -0.4249   0.3722]
        Angle     81.5371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6964"
}

Galaxy "NGC 6965:IC 5058:MCG 0-53-4:ZWG 374.16"
{
        Type  "S0"
        RA           20.7889
        Dec           0.4842
        Distance   1.841e+08  # method: V
        Radius     1.606e+04
        AbsMag        -18.76
        Axis    [ -0.1436  -0.9810  -0.1304]
        Angle    138.8488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6965"
}

Galaxy "NGC 6967:UGC 11630:MCG 0-53-6:ZWG 374.18"
{
        Type  "Sa"
        RA           20.7928
        Dec           0.4122
        Distance    1.54e+08  # method: V
        Radius     2.016e+04
        AbsMag        -18.97
        Axis    [ -0.2799  -0.9435   0.1774]
        Angle    122.4040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6967"
}

Galaxy "NGC 6968:MCG 2-53-6:NPM 1:IRAS 20458-0829"
{
        Type  "S0"
        RA           20.8089
        Dec          -8.3597
        Distance    1.54e+08  # distance uncertain!
        Radius     3.359e+04
        AbsMag        -19.07
        Axis    [ -0.5100  -0.7363   0.4448]
        Angle    113.6054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6968"
}

Galaxy "NGC 6969:UGC 11633:MCG 1-53-1:ZWG 400.2"
{
        Type  "Sa"
        RA           20.8075
        Dec           7.7403
        Distance   1.682e+08  # method: V
        Radius     2.691e+04
        AbsMag        -18.56
        Axis    [  0.2941  -0.8711  -0.3933]
        Angle    157.9080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6969"
}

Galaxy "NGC 6970:ESO 235-8:AM 2048-485:IRAS 20486-4857"
{
        Type  "SBa"
        RA           20.8692
        Dec         -48.7781
        Distance   1.718e+08  # method: T-F
        Radius     2.499e+04
        AbsMag        -20.41
        Axis    [ -0.6698  -0.7249   0.1610]
        Angle    134.5213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6970"
}

Galaxy "NGC 6971:UGC 11637:MCG 1-53-2:ZWG 400.3"
{
        Type  "Sb"
        RA           20.8231
        Dec           5.9953
        Distance   2.353e+08  # method: V
        Radius     3.764e+04
        AbsMag        -19.69
        Axis    [ -0.2002  -0.9627  -0.1821]
        Angle    146.0085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6971"
}

Galaxy "NGC 6972:UGC 11640:MCG 2-53-4:ZWG 425.11"
{
        Type  "Sa"
        RA           20.8328
        Dec           9.8997
        Distance   1.882e+08  # method: V
        Radius     3.011e+04
        AbsMag        -19.71
        Axis    [ -0.1815  -0.7889   0.5872]
        Angle    118.4236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6972"
}

Galaxy "NGC 6976:NGC 6975:MCG 1-53-15:NPM 1"
{
        Type  "Sc"
        RA           20.8736
        Dec          -5.7714
        Distance   2.627e+08  # method: V
        Radius     3.057e+04
        AbsMag        -19.73
        Axis    [ -0.1139  -0.8234  -0.5560]
        Angle    179.6228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6976"
}

Galaxy "NGC 6977:MCG 1-53-16:HCG 88B:NPM 1"
{
        Type  "SBb"
        RA           20.8747
        Dec          -5.7458
        Distance   2.594e+08  # method: V
        Radius     4.905e+04
        AbsMag         -20.4
        Axis    [ -0.4863  -0.6270   0.6086]
        Angle    113.5538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6977"
}

Galaxy "NGC 6978:MCG 1-53-17:HCG 88A:IRAS 20499-0554"
{
        Type  "Sb"
        RA           20.8764
        Dec          -5.7111
        Distance   2.575e+08  # method: V
        Radius     5.618e+04
        AbsMag        -20.39
        Axis    [ -0.2733  -0.8789   0.3909]
        Angle    124.3423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6978"
}

Galaxy "NGC 6982:ESO 235-19:IRAS 20537-5203"
{
        Type  "SBa"
        RA           20.9550
        Dec         -51.8628
        Distance   2.086e+08  # method: V
        Radius     3.034e+04
        AbsMag        -19.73
        Axis    [ -0.5528  -0.7602  -0.3413]
        Angle    133.6233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6982"
}

Galaxy "NGC 6983:ESO 286-14:MCG 7-43-4:IRAS 20533-4410"
{
        Type  "Sb"
        RA           20.9453
        Dec         -43.9861
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [ -0.7453  -0.5724   0.3418]
        Angle    133.5343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6983"
}

Galaxy "NGC 6984:ESO 235-20:AM 2054-520:IRAS 20543-5203"
{
        Type  "SBc"
        RA           20.9650
        Dec         -51.8708
        Distance   1.517e+08  # method: T-F
        Radius     3.972e+04
        AbsMag        -20.14
        Axis    [ -0.6692  -0.7415  -0.0498]
        Angle    133.3583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6984"
}

Galaxy "NGC 6985-1:MCG 2-53-1:VV 546:IRAS 20422-1117"
{
        Type  "Sa"
        RA           20.7508
        Dec         -11.1042
        Distance   1.851e+08  # distance uncertain!
        Radius     4.039e+04
        AbsMag        -19.07
        Axis    [ -0.2389  -0.9699   0.0466]
        Angle    127.4875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6985-1"
}

Galaxy "NGC 6985-2:MCG 2-53-1:VV 546"
{
        Type  "S0"
        RA           20.7503
        Dec         -11.1081
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.0377  -0.9040  -0.4259]
        Angle    149.7041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6985-2"
}

Galaxy "NGC 6986:ESO 598-7:MCG 3-53-11:NPM 1"
{
        Type  "S0"
        RA           20.9417
        Dec         -18.5661
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [ -0.0043  -0.8081  -0.5890]
        Angle    157.0896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6986"
}

Galaxy "NGC 6987:ESO 235-21:IRAS 20546-4849"
{
        Type  "E0"
        RA           20.9694
        Dec         -48.6300
        Distance   2.443e+08  # method: T-F
        Radius     4.975e+04
        AbsMag        -20.87
        Axis    [ -0.8664  -0.4078  -0.2882]
        Angle    143.1929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6987"
}

Galaxy "NGC 6988:ZWG 425.20:NPM 1"
{
        Type  "S0"
        RA           20.9300
        Dec          10.5083
        Distance   1.851e+08  # distance uncertain!
        Radius     1.346e+04
        AbsMag        -19.07
        Axis    [ -0.2781  -0.8470  -0.4530]
        Angle    205.6103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6988"
}

Galaxy "NGC 6990:ESO 187-43:IRAS 20562-5545"
{
        Type  "Sa"
        RA           20.9992
        Dec         -55.5619
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [ -0.0556  -0.6517  -0.7564]
        Angle    127.7607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6990"
}

Galaxy "NGC 6993:ESO 529-11:MCG 4-49-7:IRAS 20509-2539"
{
        Type  "Sc"
        RA           20.8983
        Dec         -25.4722
        Distance   2.617e+08  # method: V
        Radius     4.568e+04
        AbsMag        -20.72
        Axis    [ -0.6191  -0.7843   0.0408]
        Angle    125.4861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6993"
}

Galaxy "NGC 6998:ESO 464-14:A 2058-28"
{
        Type  "E0"
        RA           21.0269
        Dec         -28.0317
        Distance   5.177e+08  # method: V
        Radius     4.517e+04
        AbsMag         -20.8
        Axis    [ -0.3673  -0.6308  -0.6835]
        Angle    194.6310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6998"
}

Galaxy "NGC 6999:ESO 464-15"
{
        Type  "S0"
        RA           21.0331
        Dec         -28.0589
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.6552  -0.4173   0.6297]
        Angle    126.5667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 6999"
}

Galaxy "NGC 7001:UGC 11663:MCG 0-53-16:ZWG 374.37"
{
        Type  "Sb"
        RA           21.0186
        Dec          -0.1947
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [ -0.4931  -0.6277   0.6023]
        Angle    107.1597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7001"
}

Galaxy "NGC 7002:ESO 235-43"
{
        Type  "E1"
        RA           21.0625
        Dec         -49.0292
        Distance   3.261e+08  # method: T-F
        Radius     7.114e+04
        AbsMag         -21.6
        Axis    [ -0.4064  -0.4926  -0.7695]
        Angle    185.3423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7002"
}

Galaxy "NGC 7003:UGC 11662:MCG 3-53-8:ZWG 448.27"
{
        Type  "Sc"
        RA           21.0117
        Dec          17.8047
        Distance    2.27e+08  # method: V
        Radius     3.632e+04
        AbsMag        -20.41
        Axis    [ -0.2037  -0.9166   0.3439]
        Angle    116.5094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7003"
}

Galaxy "NGC 7004:ESO 235-46:FAIR 938"
{
        Type  "SBa"
        RA           21.0672
        Dec         -49.1142
        Distance   3.186e+08  # method: V
        Radius     6.023e+04
        AbsMag        -20.95
        Axis    [ -0.4444  -0.8701  -0.2130]
        Angle    129.8617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7004"
}

Galaxy "NGC 7007:ESO 187-48"
{
        Type  "S0"
        RA           21.0908
        Dec         -52.5519
        Distance   1.255e+08  # method: V
        Radius     3.651e+04
        AbsMag        -20.03
        Axis    [ -0.1374  -0.6432  -0.7533]
        Angle    139.7145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7007"
}

Galaxy "NGC 7010:IC 5082:MCG 2-53-24:NPM 1"
{
        Type  "E0"
        RA           21.0775
        Dec         -12.3378
        Distance   3.715e+08  # method: V
        Radius     1.027e+05
        AbsMag        -21.28
        Axis    [ -0.5131  -0.7317  -0.4486]
        Angle    174.3137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7010"
}

Galaxy "NGC 7012:ESO 286-51:AM 2103-450"
{
        Type  "E0"
        RA           21.1125
        Dec         -44.8144
        Distance   3.886e+08  # method: V
        Radius     1.356e+05
        AbsMag        -21.68
        Axis    [ -0.9244  -0.3716  -0.0863]
        Angle    133.3000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7012"
}

Galaxy "NGC 7013:UGC 11670:MCG 5-49-1:ZWG 491.2"
{
        Type  "Sa"
        RA           21.0592
        Dec          29.8969
        Distance   2.274e+07  # method: V
        Radius     1.323e+04
        AbsMag        -16.82
        Axis    [  0.0209  -0.6602   0.7508]
        Angle    118.8743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7013"
}

Galaxy "NGC 7014:ESO 286-57"
{
        Type  "E0"
        RA           21.1311
        Dec         -47.1786
        Distance   2.443e+08  # method: T-F
        Radius     6.041e+04
        AbsMag        -21.07
        Axis    [ -0.9529  -0.3013   0.0347]
        Angle    129.5766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7014"
}

Galaxy "NGC 7015:UGC 11674:MCG 2-53-12:ZWG 425.40"
{
        Type  "Sc"
        RA           21.0936
        Dec          11.4136
        Distance   2.074e+08  # method: V
        Radius     5.431e+04
        AbsMag        -20.82
        Axis    [ -0.4801  -0.6316   0.6087]
        Angle     94.0962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7015"
}

Galaxy "NGC 7016:ESO 529-25:MCG 4-49-13:AM 2104-254"
{
        Type  "E0"
        RA           21.1211
        Dec         -25.4686
        Distance    3.02e+08  # distance uncertain!
        Radius     3.514e+04
        AbsMag        -20.13
        Axis    [ -0.3757  -0.6436  -0.6668]
        Angle    196.0297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7016"
}

Galaxy "NGC 7017:ESO 529-26:MCG 4-49-14:AM 2104-254"
{
        Type  "S0"
        RA           21.1222
        Dec         -25.4875
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [ -0.5625  -0.8221  -0.0876]
        Angle    133.0082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7017"
}

Galaxy "NGC 7018:ESO 529-27:MCG 4-49-15:VV 764"
{
        Type  "E0"
        RA           21.1236
        Dec         -25.4292
        Distance   2.754e+08  # distance uncertain!
        Radius     5.208e+04
        AbsMag        -20.13
        Axis    [ -0.7660  -0.5953  -0.2426]
        Angle    141.1468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7018"
}

Galaxy "NGC 7019:ESO 529-22:AM 2103-243:IRAS 21035-2436"
{
        Type  "SBb"
        RA           21.1069
        Dec         -24.4128
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [ -0.4697  -0.7779   0.4173]
        Angle    132.1732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7019"
}

Galaxy "NGC 7020:NGC 7021:ESO 107-13"
{
        Type  "S0"
        RA           21.1886
        Dec         -64.0253
        Distance   1.303e+08  # method: V
        Radius     6.635e+04
        AbsMag        -20.31
        Axis    [ -0.7004  -0.5459   0.4598]
        Angle    162.9491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7020"
}

Galaxy "NGC 7022:ESO 235-65:FAIR 952"
{
        Type  "S0"
        RA           21.1597
        Dec         -49.3036
        Distance    1.01e+08  # method: V
        Radius     2.204e+04
        AbsMag        -18.45
        Axis    [ -0.2769  -0.6784  -0.6805]
        Angle    146.1293
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7022"
}

Galaxy "NGC 7025:UGC 11681:MCG 3-54-1:ZWG 449.3"
{
        Type  "Sa"
        RA           21.1297
        Dec          16.3358
        Distance   2.115e+08  # method: V
        Radius     5.845e+04
        AbsMag        -20.26
        Axis    [  0.0532  -0.9627  -0.2652]
        Angle    166.3436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7025"
}

Galaxy "NGC 7029:ESO 235-72:AM 2112-483"
{
        Type  "E6"
        RA           21.1975
        Dec         -49.2836
        Distance   1.252e+08  # method: S
        Radius     4.551e+04
        AbsMag        -20.52
        Axis    [ -0.7985  -0.4426  -0.4081]
        Angle    153.1616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7029"
}

Galaxy "NGC 7030:ESO 598-28:MCG 4-50-3:IRAS 21083-2041"
{
        Type  "SBb"
        RA           21.1869
        Dec         -20.4867
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.4137  -0.8878  -0.2017]
        Angle    139.8314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7030"
}

Galaxy "NGC 7032:ESO 74-26:IRAS 21109-6829"
{
        Type  "Sc"
        RA           21.2561
        Dec         -68.2875
        Distance   1.422e+08  # method: V
        Radius     2.275e+04
        AbsMag         -19.6
        Axis    [ -0.8274  -0.4831  -0.2865]
        Angle    143.1112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7032"
}

Galaxy "NGC 7033:MCG 2-54-2:ZWG 426.6:NPM 1"
{
        Type  "S0"
        RA           21.1600
        Dec          15.1253
        Distance   3.965e+08  # method: V
        Radius     4.614e+04
        AbsMag        -20.22
        Axis    [  0.0698  -0.9396  -0.3350]
        Angle    171.7902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7033"
}

Galaxy "NGC 7034:UGC 11687:MCG 2-54-3:ZWG 426.7"
{
        Type  "E0"
        RA           21.1606
        Dec          15.1511
        Distance   3.896e+08  # method: V
        Radius     5.666e+04
        AbsMag        -20.39
        Axis    [ -0.6220  -0.7754   0.1090]
        Angle    104.7670
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7034"
}

Galaxy "NGC 7035:ESO 530-15"
{
        Type  "S0"
        RA           21.1792
        Dec         -23.1353
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [ -0.5029  -0.8583   0.1019]
        Angle    129.8313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7035"
}

Galaxy "NGC 7035A:ESO 530-15A"
{
        Type  "S0"
        RA           21.1797
        Dec         -23.1372
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.0733  -0.7765  -0.6258]
        Angle    160.5089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7035A"
}

Galaxy "NGC 7038:ESO 286-79:FAIR 960:AM 2111-472"
{
        Type  "SBc"
        RA           21.2519
        Dec         -47.2203
        Distance   2.227e+08  # method: T-F
        Radius     1.004e+05
        AbsMag        -21.47
        Axis    [ -0.5866  -0.7642   0.2681]
        Angle    141.6105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7038"
}

Galaxy "NGC 7038A:ESO 235-80"
{
        Type  "SBc"
        RA           21.2542
        Dec         -47.6128
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.2454  -0.7722  -0.5861]
        Angle    136.2067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7038A"
}

Galaxy "NGC 7040:UGC 11701:MCG 1-54-4:ZWG 401.8"
{
        Type  "S0"
        RA           21.2211
        Dec           8.8650
        Distance   2.628e+08  # method: V
        Radius     3.441e+04
        AbsMag        -19.63
        Axis    [ -0.4774  -0.7304   0.4885]
        Angle    102.0869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7040"
}

Galaxy "NGC 7041:ESO 235-82:AM 2113-483"
{
        Type  "S0"
        RA           21.2756
        Dec         -48.3631
        Distance   8.384e+07  # method: S
        Radius      4.39e+04
        AbsMag        -19.95
        Axis    [ -0.4709  -0.8789  -0.0766]
        Angle    133.2367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7041"
}

Galaxy "NGC 7041A:ESO 235-84:IRAS 21144-4836"
{
        Type  "SBc"
        RA           21.2992
        Dec         -48.4022
        Distance   3.009e+08  # method: V
        Radius     7.002e+04
        AbsMag        -20.12
        Axis    [ -0.4071  -0.6440  -0.6477]
        Angle    154.7167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7041A"
}

Galaxy "NGC 7041B"
{
        Type  "S0"
        RA           21.2969
        Dec         -48.3906
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [ -0.5300  -0.8216  -0.2100]
        Angle    134.5379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7041B"
}

Galaxy "NGC 7042:UGC 11702:MCG 2-54-13:ZWG 426.23"
{
        Type  "Sb"
        RA           21.2292
        Dec          13.5750
        Distance   2.164e+08  # method: V
        Radius     6.295e+04
        AbsMag        -21.31
        Axis    [ -0.4308  -0.8044   0.4090]
        Angle    104.1053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7042"
}

Galaxy "NGC 7043:UGC 11704:MCG 2-54-14:ZWG 426.24"
{
        Type  "SBa"
        RA           21.2344
        Dec          13.6264
        Distance   2.095e+08  # method: V
        Radius     3.961e+04
        AbsMag        -19.34
        Axis    [ -0.3041  -0.8435   0.4428]
        Angle    112.4879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7043"
}

Galaxy "NGC 7046:UGC 11708:MCG 0-54-9:ZWG 375.20"
{
        Type  "SBc"
        RA           21.2489
        Dec           2.8344
        Distance   1.745e+08  # method: V
        Radius     4.823e+04
        AbsMag        -19.74
        Axis    [ -0.3368  -0.9034   0.2652]
        Angle    123.6245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7046"
}

Galaxy "NGC 7047:UGC 11712:MCG 0-54-10:ZWG 375.23"
{
        Type  "SBb"
        RA           21.2742
        Dec          -0.8264
        Distance   2.472e+08  # method: V
        Radius     4.314e+04
        AbsMag         -20.2
        Axis    [ -0.2458  -0.9394   0.2388]
        Angle    130.0362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7047"
}

Galaxy "NGC 7049:ESO 236-1:AM 2115-484:IRAS 21156-4846"
{
        Type  "S0"
        RA           21.3167
        Dec         -48.5614
        Distance    9.76e+07  # method: S
        Radius     6.388e+04
        AbsMag        -20.78
        Axis    [ -0.4857  -0.7898  -0.3745]
        Angle    137.0115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7049"
}

Galaxy "NGC 7051:MCG 2-54-4:IRAS 21171-0859"
{
        Type  "Sa"
        RA           21.3308
        Dec          -8.7825
        Distance   1.089e+08  # method: V
        Radius     2.217e+04
        AbsMag        -18.72
        Axis    [ -0.5332  -0.6024   0.5940]
        Angle    115.8138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7051"
}

Galaxy "NGC 7052:UGC 11718:MCG 4-50-6:ZWG 471.5"
{
        Type  "E0"
        RA           21.3092
        Dec          26.4472
        Distance   2.095e+08  # method: V
        Radius     6.399e+04
        AbsMag        -20.44
        Axis    [ -0.4179  -0.9015  -0.1130]
        Angle    157.6765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7052"
}

Galaxy "NGC 7053:UGC 11727:MCG 4-50-9:ZWG 471.8"
{
        Type  "E0"
        RA           21.3519
        Dec          23.0853
        Distance   1.996e+08  # method: V
        Radius     4.064e+04
        AbsMag        -19.83
        Axis    [ -0.3729  -0.8916  -0.2568]
        Angle    190.8898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7053"
}

Galaxy "NGC 7056:IC 1382:UGC 11734:MCG 3-54-8"
{
        Type  "SBc"
        RA           21.3686
        Dec          18.6656
        Distance   2.295e+08  # method: V
        Radius     3.339e+04
        AbsMag        -20.34
        Axis    [ -0.2206  -0.9662  -0.1336]
        Angle    159.2983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7056"
}

Galaxy "NGC 7057:ESO 287-17:MCG 7-44-4:AM 2121-424"
{
        Type  "S0"
        RA           21.4161
        Dec         -42.4603
        Distance   2.231e+08  # method: V
        Radius     4.543e+04
        AbsMag        -20.47
        Axis    [ -0.6983  -0.5709   0.4319]
        Angle    139.2070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7057"
}

Galaxy "NGC 7059:ESO 145-5:IRAS 21236-6013"
{
        Type  "SBc"
        RA           21.4558
        Dec         -60.0147
        Distance   1.381e+08  # method: T-F
        Radius     6.627e+04
        AbsMag        -20.63
        Axis    [ -0.6472  -0.7621  -0.0156]
        Angle    139.0655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7059"
}

Galaxy "NGC 7060:ESO 287-22:MCG 7-44-6:AM 2122-423"
{
        Type  "SBa"
        RA           21.4314
        Dec         -42.4108
        Distance   2.084e+08  # method: V
        Radius     6.063e+04
        AbsMag        -20.33
        Axis    [ -0.6184  -0.7568   0.2117]
        Angle    138.2222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7060"
}

Galaxy "NGC 7061:ESO 236-13:AM 2123-491"
{
        Type  "E0"
        RA           21.4572
        Dec         -49.0633
        Distance   2.291e+08  # distance uncertain!
        Radius     3.999e+04
        AbsMag        -20.13
        Axis    [ -0.9555  -0.2618   0.1358]
        Angle    130.1585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7061"
}

Galaxy "NGC 7064:ESO 188-9:IRAS 21255-5259"
{
        Type  "SBc"
        RA           21.4842
        Dec         -52.7672
        Distance   4.671e+07  # method: T-F
        Radius     2.581e+04
        AbsMag        -17.88
        Axis    [ -0.3826  -0.9229   0.0419]
        Angle    137.0623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7064"
}

Galaxy "NGC 7065:MCG 1-54-17:NPM 1"
{
        Type  "SBb"
        RA           21.4450
        Dec          -6.9947
        Distance   3.223e+08  # method: V
        Radius     5.156e+04
        AbsMag        -20.47
        Axis    [ -0.2090  -0.8737  -0.4393]
        Angle    168.9964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7065"
}

Galaxy "NGC 7065A:MCG 1-54-18:NPM 1:IRAS 21242-0714"
{
        Type  "SBc"
        RA           21.4492
        Dec          -7.0211
        Distance    3.21e+08  # method: V
        Radius     4.668e+04
        AbsMag        -20.56
        Axis    [ -0.2077  -0.8109  -0.5472]
        Angle    184.7198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7065A"
}

Galaxy "NGC 7066:UGC 11741:MCG 2-54-25:ZWG 426.54"
{
        Type  "Sb"
        RA           21.4369
        Dec          14.1831
        Distance   2.182e+08  # method: V
        Radius     2.856e+04
        AbsMag        -19.13
        Axis    [ -0.3221  -0.8482  -0.4204]
        Angle    211.4697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7066"
}

Galaxy "NGC 7068:MCG 2-54-27:ZWG 426.55:KAZ 520"
{
        Type  "S0"
        RA           21.4422
        Dec          12.1844
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.1708  -0.6408   0.7485]
        Angle    125.3904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7068"
}

Galaxy "NGC 7069:UGC 11747:MCG 0-54-19:ZWG 375.40"
{
        Type  "S0"
        RA           21.4681
        Dec          -1.6464
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [ -0.0316  -0.9014  -0.4318]
        Angle    166.8668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7069"
}

Galaxy "NGC 7070:ESO 287-28:MCG 7-44-16:AM 2127-431"
{
        Type  "SBc"
        RA           21.5069
        Dec         -43.0867
        Distance   9.898e+07  # method: V
        Radius     3.455e+04
        AbsMag        -19.61
        Axis    [ -0.3527  -0.7108  -0.6086]
        Angle    152.7796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7070"
}

Galaxy "NGC 7070A:ESO 287-34:MCG 7-44-21:AM 2128-34"
{
        Type  "Sa"
        RA           21.5297
        Dec         -42.8469
        Distance    9.88e+07  # method: V
        Radius     2.443e+04
        AbsMag        -19.11
        Axis    [ -0.8049  -0.3335   0.4908]
        Angle    129.9758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7070A"
}

Galaxy "NGC 7072:ESO 287-31:MCG 7-44-18:IRAS 21273-4322"
{
        Type  "SBc"
        RA           21.5103
        Dec         -43.1525
        Distance   2.137e+08  # method: V
        Radius     2.797e+04
        AbsMag        -19.78
        Axis    [ -0.6547  -0.7502  -0.0925]
        Angle    138.0999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7072"
}

Galaxy "NGC 7072A:ESO 287-29:MCG 7-44-17"
{
        Type  "SBc"
        RA           21.5069
        Dec         -43.2022
        Distance   1.612e+08  # distance uncertain!
        Radius     1.876e+04
        AbsMag        -19.07
        Axis    [ -0.7113  -0.6681   0.2186]
        Angle    137.0838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7072A"
}

Galaxy "NGC 7073:MCG 2-54-10:MK 899:IRAS 21267-1142"
{
        Type  "Sc"
        RA           21.4906
        Dec         -11.4886
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.1917  -0.7770  -0.5996]
        Angle    185.2937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7073"
}

Galaxy "NGC 7074:ZWG 401.27:ZW 133:PGC 66854"
{
        Type  "E0"
        RA           21.4939
        Dec           6.6822
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [ -0.6543  -0.7550   0.0441]
        Angle    121.1138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7074"
}

Galaxy "NGC 7075:ESO 343-4:MCG 7-44-20:AM 2128-385"
{
        Type  "E0"
        RA           21.5256
        Dec         -38.6181
        Distance   2.629e+08  # method: T-F
        Radius     4.589e+04
        AbsMag        -20.73
        Axis    [ -0.9098  -0.4149  -0.0114]
        Angle    132.3003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7075"
}

Galaxy "NGC 7077:UGC 11755:MCG 0-54-28:MK 900"
{
        Type  "E0"
        RA           21.4997
        Dec           2.4147
        Distance   3.719e+07  # method: V
        Radius          4327
        AbsMag        -16.28
        Axis    [ -0.4968  -0.8002  -0.3360]
        Angle    179.5791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7077"
}

Galaxy "NGC 7079:ESO 287-36:MCG 7-44-22:AM 2129-441"
{
        Type  "S0"
        RA           21.5431
        Dec         -44.0675
        Distance   1.113e+08  # method: V
        Radius     3.238e+04
        AbsMag        -20.16
        Axis    [ -0.5361  -0.8366  -0.1123]
        Angle    137.3387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7079"
}

Galaxy "NGC 7080:UGC 11756:MCG 4-50-12:ZWG 471.11"
{
        Type  "SBb"
        RA           21.5003
        Dec          26.7183
        Distance   2.055e+08  # method: V
        Radius     5.381e+04
        AbsMag         -20.8
        Axis    [ -0.2211  -0.9661  -0.1336]
        Angle    169.3563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7080"
}

Galaxy "NGC 7081:UGC 11759:MCG 0-54-30:ZWG 375.49"
{
        Type  "Sb"
        RA           21.5233
        Dec           2.4911
        Distance   1.337e+08  # method: V
        Radius     2.528e+04
        AbsMag        -19.46
        Axis    [ -0.3571  -0.7916  -0.4959]
        Angle    207.7389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7081"
}

Galaxy "NGC 7083:ESO 107-36:IRAS 21318-6407"
{
        Type  "Sc"
        RA           21.5956
        Dec         -63.9033
        Distance   9.703e+07  # method: T-F
        Radius     5.504e+04
        AbsMag        -20.47
        Axis    [ -0.2644  -0.6131  -0.7444]
        Angle    134.0275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7083"
}

Galaxy "NGC 7085:MCG 1-55-1:ZWG 402.2:KARA 919"
{
        Type  "Sb"
        RA           21.5403
        Dec           6.5817
        Distance    2.44e+08  # distance uncertain!
        Radius     4.259e+04
        AbsMag        -19.07
        Axis    [ -0.2587  -0.7666   0.5877]
        Angle    123.4410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7085"
}

Galaxy "NGC 7087:ESO 343-8:MCG 7-44-25:AM 2131-410"
{
        Type  "Sb"
        RA           21.5758
        Dec         -40.8183
        Distance   2.205e+08  # method: V
        Radius     3.527e+04
        AbsMag        -20.45
        Axis    [ -0.3073  -0.8436  -0.4404]
        Angle    139.9013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7087"
}

Galaxy "NGC 7090:ESO 188-12:AM 2133-544:IRAS 21329-5446"
{
        Type  "SBc"
        RA           21.6075
        Dec         -54.5550
        Distance   3.194e+07  # method: T-F
        Radius     3.391e+04
        AbsMag        -18.55
        Axis    [ -0.4770  -0.8219   0.3112]
        Angle    154.5312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7090"
}

Galaxy "NGC 7091:IC 5114:MCG 6-47-7:ESO 403-8"
{
        Type  "SBc"
        RA           21.5686
        Dec         -36.6539
        Distance   1.069e+08  # method: V
        Radius     3.265e+04
        AbsMag        -19.18
        Axis    [ -0.5948  -0.7844  -0.1760]
        Angle    140.8364
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7091"
}

Galaxy "NGC 7095:ESO 27-1:FAIR 353:IRAS 21457-8145"
{
        Type  "Sc"
        RA           21.8733
        Dec         -81.5314
        Distance   3.497e+07  # method: T-F
        Radius     2.035e+04
        AbsMag        -18.05
        Axis    [ -0.3993  -0.4083  -0.8209]
        Angle    140.8578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7095"
}

Galaxy "NGC 7096:IC 5121:ESO 107-46:AM 2137-640"
{
        Type  "Sa"
        RA           21.6886
        Dec         -63.9083
        Distance   1.276e+08  # method: V
        Radius     3.341e+04
        AbsMag        -20.16
        Axis    [ -0.8877  -0.4262   0.1741]
        Angle    145.2967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7096"
}

Galaxy "NGC 7097:ESO 287-48:MCG 7-44-29:AM 2137-424"
{
        Type  "E5"
        RA           21.6700
        Dec         -42.5392
        Distance   1.055e+08  # method: S
        Radius     2.763e+04
        AbsMag        -19.95
        Axis    [ -0.5706  -0.5232  -0.6330]
        Angle    180.6179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7097"
}

Galaxy "NGC 7097A:ESO 287-49:MCG 7-44-30"
{
        Type  "E0"
        RA           21.6769
        Dec         -42.4803
        Distance   1.089e+08  # method: V
        Radius          9504
        AbsMag        -17.52
        Axis    [ -0.9348  -0.3221   0.1497]
        Angle    128.3225
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7097A"
}

Galaxy "NGC 7098:ESO 48-5:IRAS 21393-7520"
{
        Type  "SBa"
        RA           21.7378
        Dec         -75.1108
        Distance   1.065e+08  # method: V
        Radius     6.193e+04
        AbsMag        -20.37
        Axis    [ -0.7334  -0.6248  -0.2679]
        Angle    138.5053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7098"
}

Galaxy "NGC 7101:MCG 1-55-7:ZWG 402.12:NPM 1"
{
        Type  "E0"
        RA           21.6594
        Dec           8.8772
        Distance   2.754e+08  # distance uncertain!
        Radius     2.003e+04
        AbsMag        -20.13
        Axis    [ -0.3800  -0.8102  -0.4462]
        Angle    212.7568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7101"
}

Galaxy "NGC 7102:UGC 11786:MCG 1-55-8:ZWG 402.13"
{
        Type  "SBb"
        RA           21.6622
        Dec           6.2858
        Distance   2.045e+08  # method: V
        Radius      4.76e+04
        AbsMag        -20.29
        Axis    [ -0.2526  -0.7282   0.6371]
        Angle    125.2689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7102"
}

Galaxy "NGC 7103:ESO 531-15:NPM 1:AM 2137-225"
{
        Type  "E1"
        RA           21.6642
        Dec         -22.4733
        Distance   3.981e+08  # distance uncertain!
        Radius     8.107e+04
        AbsMag        -20.13
        Axis    [ -0.7015  -0.6407  -0.3121]
        Angle    158.9279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7103"
}

Galaxy "NGC 7104:ESO 531-18:NPM 1:AM 2137-225"
{
        Type  "E0"
        RA           21.6675
        Dec         -22.4244
        Distance   3.163e+08  # distance uncertain!
        Radius      3.22e+04
        AbsMag        -20.13
        Axis    [ -0.6583  -0.6501  -0.3793]
        Angle    166.7038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7104"
}

Galaxy "NGC 7105:MCG 2-55-1"
{
        Type  "S0"
        RA           21.6947
        Dec         -10.6350
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [ -0.3286  -0.8373   0.4370]
        Angle    135.8072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7105"
}

Galaxy "NGC 7106:ESO 188-17:AM 2139-525"
{
        Type  "SBc"
        RA           21.7100
        Dec         -52.6992
        Distance   1.638e+08  # method: T-F
        Radius     4.049e+04
        AbsMag         -19.6
        Axis    [ -0.5930  -0.7945  -0.1307]
        Angle    138.7089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7106"
}

Galaxy "NGC 7107:ESO 287-52:AM 2139-450:IRAS 21392-4501"
{
        Type  "Irr"
        RA           21.7072
        Dec         -44.7919
        Distance   9.087e+07  # method: V
        Radius     2.776e+04
        AbsMag        -19.02
        Axis    [ -0.6996  -0.6626   0.2674]
        Angle    140.7605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7107"
}

Galaxy "NGC 7108:NGC 7111:MCG 1-55-2"
{
        Type  "E0"
        RA           21.6981
        Dec          -6.7086
        Distance   3.631e+08  # distance uncertain!
        Radius     7.394e+04
        AbsMag        -20.13
        Axis    [ -0.5435  -0.7472  -0.3824]
        Angle    180.8995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7108"
}

Galaxy "NGC 7109:ESO 403-15:MCG 6-47-11:VV 376"
{
        Type  "E0"
        RA           21.6994
        Dec         -34.4461
        Distance   2.631e+08  # distance uncertain!
        Radius     2.678e+04
        AbsMag        -20.13
        Axis    [ -0.4511  -0.5676  -0.6887]
        Angle    194.7971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7109"
}

Galaxy "NGC 7110:ESO 403-16:MCG 6-47-12"
{
        Type  "SBb"
        RA           21.7033
        Dec         -34.1628
        Distance   2.634e+08  # method: T-F
        Radius     4.981e+04
        AbsMag        -20.24
        Axis    [ -0.3709  -0.9247  -0.0854]
        Angle    139.1160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7110"
}

Galaxy "NGC 7113:NGC 7112:MCG 2-55-9:ZWG 427.16"
{
        Type  "E0"
        RA           21.7072
        Dec          12.5692
        Distance   3.802e+08  # distance uncertain!
        Radius     7.742e+04
        AbsMag        -20.13
        Axis    [ -0.3766  -0.8254  -0.4205]
        Angle    214.5679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7113"
}

Galaxy "NGC 7115:ESO 531-25:MCG 4-51-11:VV 800"
{
        Type  "Sb"
        RA           21.7275
        Dec         -25.3511
        Distance   1.602e+08  # method: T-F
        Radius     3.962e+04
        AbsMag        -19.96
        Axis    [ -0.1189  -0.9891  -0.0870]
        Angle    139.8330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7115"
}

Galaxy "NGC 7116:UGC 11796:MCG 5-51-1:ZWG 493.5"
{
        Type  "Sc"
        RA           21.7111
        Dec          28.9467
        Distance   1.462e+08  # method: V
        Radius     2.339e+04
        AbsMag        -18.96
        Axis    [  0.1534  -0.9226   0.3538]
        Angle    143.3796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7116"
}

Galaxy "NGC 7117:ESO 236-40:AM 2142-483"
{
        Type  "S0"
        RA           21.7631
        Dec         -48.4211
        Distance    2.99e+08  # method: T-F
        Radius     6.088e+04
        AbsMag        -21.11
        Axis    [ -0.3245  -0.7731  -0.5449]
        Angle    140.3443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7117"
}

Galaxy "NGC 7118:ESO 236-45:AM 2142-483"
{
        Type  "S0"
        RA           21.7692
        Dec         -48.3533
        Distance    2.99e+08  # method: T-F
        Radius     6.088e+04
        AbsMag        -21.31
        Axis    [ -0.5467  -0.7277  -0.4142]
        Angle    145.7621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7118"
}

Galaxy "NGC 7119-1:NGC 7119A:ESO 288-2:AM 2143-464"
{
        Type  "SBc"
        RA           21.7708
        Dec         -46.5156
        Distance   4.383e+08  # method: V
        Radius      7.65e+04
        AbsMag        -22.04
        Axis    [ -0.7287  -0.6268   0.2757]
        Angle    141.4221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7119-1"
}

Galaxy "NGC 7119-2:NGC 7119B:ESO 288-1:AM 2143-464"
{
        Type  "Sc"
        RA           21.7706
        Dec         -46.5197
        Distance   4.253e+08  # method: V
        Radius     3.711e+04
        AbsMag        -21.88
        Axis    [ -0.2554  -0.7867  -0.5621]
        Angle    139.0147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7119-2"
}

Galaxy "NGC 7120:MCG 1-55-6:IRAS 21419-0645"
{
        Type  "Sb"
        RA           21.7425
        Dec          -6.5231
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.3033  -0.8086   0.5041]
        Angle    134.9784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7120"
}

Galaxy "NGC 7121:MCG 1-55-8:IRAS 21422-0351"
{
        Type  "Sc"
        RA           21.7478
        Dec          -3.6197
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [ -0.0066  -0.8741  -0.4856]
        Angle    169.4118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7121"
}

Galaxy "NGC 7123:ESO 75-27"
{
        Type  "Sa"
        RA           21.8461
        Dec         -70.3339
        Distance   1.649e+08  # method: V
        Radius     7.197e+04
        AbsMag        -20.92
        Axis    [ -0.6878  -0.6250   0.3691]
        Angle    167.0243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7123"
}

Galaxy "NGC 7124:ESO 237-2:ESO 236-49:AM 2144-504"
{
        Type  "SBc"
        RA           21.8014
        Dec         -50.5656
        Distance   2.116e+08  # method: T-F
        Radius     8.619e+04
        AbsMag        -20.86
        Axis    [ -0.5820  -0.6939   0.4240]
        Angle    155.9899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7124"
}

Galaxy "NGC 7125:ESO 145-17:AM 2145-605:IRAS 21456-6056"
{
        Type  "SBc"
        RA           21.8211
        Dec         -60.7125
        Distance   1.321e+08  # method: V
        Radius     5.762e+04
        AbsMag        -20.54
        Axis    [ -0.7665  -0.6373   0.0790]
        Angle    144.9068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7125"
}

Galaxy "NGC 7126:ESO 145-18:AM 2145-605:IRAS 21456-6050"
{
        Type  "Sc"
        RA           21.8217
        Dec         -60.6094
        Distance    1.35e+08  # method: T-F
        Radius     5.498e+04
        AbsMag        -20.18
        Axis    [ -0.5581  -0.8053  -0.1998]
        Angle    136.2207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7126"
}

Galaxy "NGC 7130:IC 5135:ESO 403-32:MCG 6-47-15"
{
        Type  "Sa"
        RA           21.8053
        Dec         -34.9528
        Distance   2.072e+08  # method: V
        Radius     4.821e+04
        AbsMag        -21.01
        Axis    [ -0.7633  -0.6454   0.0281]
        Angle    137.2935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7130"
}

Galaxy "NGC 7131:MCG 2-55-2:NPM 1"
{
        Type  "S0"
        RA           21.7933
        Dec         -13.1822
        Distance    2.03e+08  # distance uncertain!
        Radius     5.019e+04
        AbsMag        -19.07
        Axis    [ -0.3744  -0.8801   0.2918]
        Angle    136.7509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7131"
}

Galaxy "NGC 7132:MCG 2-55-13:ZWG 427.24"
{
        Type  "Sc"
        RA           21.7878
        Dec          10.2414
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.1958  -0.9237   0.3293]
        Angle    133.5557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7132"
}

Galaxy "NGC 7135:ESO 403-35:MCG 6-48-1:AM 2146-350"
{
        Type  "S0"
        RA           21.8294
        Dec         -34.8761
        Distance    8.15e+07  # method: V
        Radius     2.489e+04
        AbsMag        -19.29
        Axis    [ -0.5088  -0.7631  -0.3985]
        Angle    153.7334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7135"
}

Galaxy "NGC 7137:UGC 11815:MCG 4-51-5:ZWG 472.8"
{
        Type  "SBc"
        RA           21.8036
        Dec          22.1597
        Distance   6.179e+07  # method: V
        Radius     1.438e+04
        AbsMag        -18.29
        Axis    [ -0.1640  -0.9615  -0.2203]
        Angle    180.5165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7137"
}

Galaxy "NGC 7138:UGC 11817:MCG 2-55-14:ZWG 427.25"
{
        Type  "SBa"
        RA           21.8169
        Dec          12.5139
        Distance   3.658e+08  # method: V
        Radius     6.384e+04
        AbsMag        -20.15
        Axis    [ -0.1577  -0.5535   0.8178]
        Angle    130.2281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7138"
}

Galaxy "NGC 7140:NGC 7141:ESO 189-7:FAIR 354"
{
        Type  "SBc"
        RA           21.8708
        Dec         -55.5697
        Distance   1.265e+08  # method: V
        Radius     7.542e+04
        AbsMag        -20.44
        Axis    [ -0.3943  -0.6563  -0.6432]
        Angle    146.2524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7140"
}

Galaxy "NGC 7144:ESO 237-11"
{
        Type  "E0"
        RA           21.8783
        Dec         -48.2547
        Distance   8.006e+07  # method: S
        Radius     4.309e+04
        AbsMag        -20.05
        Axis    [ -0.4814  -0.4721  -0.7385]
        Angle    188.8704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7144"
}

Galaxy "NGC 7145:ESO 237-13"
{
        Type  "E0"
        RA           21.8889
        Dec         -47.8825
        Distance   7.646e+07  # method: S
        Radius      2.78e+04
        AbsMag        -19.75
        Axis    [ -0.8619  -0.1219   0.4921]
        Angle    124.3159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7145"
}

Galaxy "NGC 7146:MCG 0-55-24:ZWG 376.44"
{
        Type  "SBb"
        RA           21.8631
        Dec           3.0172
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.1722  -0.9840   0.0453]
        Angle    147.4593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7146"
}

Galaxy "NGC 7147:MCG 0-55-25:ZWG 376.45:NPM 1"
{
        Type  "SBa"
        RA           21.8661
        Dec           3.0722
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.2139  -0.8429  -0.4936]
        Angle    194.2165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7147"
}

Galaxy "NGC 7149:UGC 11835:MCG 0-55-26:ZWG 376.47"
{
        Type  "E0"
        RA           21.8697
        Dec           3.3017
        Distance   2.399e+08  # distance uncertain!
        Radius     4.536e+04
        AbsMag        -20.13
        Axis    [ -0.4906  -0.7918  -0.3638]
        Angle    192.6383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7149"
}

Galaxy "NGC 7151:ESO 237-15"
{
        Type  "SBc"
        RA           21.9178
        Dec         -50.6581
        Distance   9.563e+07  # method: T-F
        Radius     4.034e+04
        AbsMag        -18.83
        Axis    [ -0.4593  -0.8816  -0.1089]
        Angle    138.4640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7151"
}

Galaxy "NGC 7152:ESO 466-13:MCG 5-51-20"
{
        Type  "SBb"
        RA           21.8997
        Dec         -29.2892
        Distance   2.658e+08  # method: T-F
        Radius     4.639e+04
        AbsMag        -20.16
        Axis    [ -0.1477  -0.8313  -0.5359]
        Angle    150.9789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7152"
}

Galaxy "NGC 7153:ESO 466-16:MCG 5-51-22"
{
        Type  "Sb"
        RA           21.9097
        Dec         -29.0639
        Distance   3.048e+08  # method: V
        Radius     8.423e+04
        AbsMag        -20.55
        Axis    [ -0.1293  -0.9898  -0.0595]
        Angle    140.9060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7153"
}

Galaxy "NGC 7154:ESO 404-8:MCG 6-48-5:IRAS 21523-3503"
{
        Type  "Irr"
        RA           21.9225
        Dec         -34.8139
        Distance   8.938e+07  # method: T-F
        Radius      2.86e+04
        AbsMag        -19.29
        Axis    [ -0.6641  -0.7449   0.0650]
        Angle    139.8043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7154"
}

Galaxy "NGC 7155:IC 5143:ESO 237-16:FAIR 991"
{
        Type  "S0"
        RA           21.9358
        Dec         -49.5219
        Distance   7.547e+07  # method: V
        Radius     2.525e+04
        AbsMag        -18.62
        Axis    [ -0.3630  -0.5972  -0.7153]
        Angle    162.5333
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7155"
}

Galaxy "NGC 7156:UGC 11843:MCG 0-55-29:ZWG 376.53"
{
        Type  "SBc"
        RA           21.9092
        Dec           2.9422
        Distance   1.653e+08  # method: V
        Radius     4.086e+04
        AbsMag        -20.32
        Axis    [ -0.3685  -0.9220   0.1189]
        Angle    139.4586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7156"
}

Galaxy "NGC 7157:ESO 532-3:MCG 4-51-15:AM 2154-253"
{
        Type  "SBa"
        RA           21.9489
        Dec         -25.3508
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.0628  -0.7999  -0.5968]
        Angle    154.8683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7157"
}

Galaxy "NGC 7159:ZWG 428.3"
{
        Type  "E0"
        RA           21.9403
        Dec          13.5631
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [ -0.6337  -0.5914   0.4987]
        Angle     84.3544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7159"
}

Galaxy "NGC 7162:ESO 288-26:MCG 7-45-3:AM 2156-433"
{
        Type  "Sc"
        RA           21.9939
        Dec         -43.3044
        Distance   9.364e+07  # method: V
        Radius     3.813e+04
        AbsMag        -18.99
        Axis    [ -0.1347  -0.7882  -0.6004]
        Angle    137.6693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7162"
}

Galaxy "NGC 7162A:ESO 288-28:MCG 7-45-5:AM 2157-432"
{
        Type  "Irr"
        RA           22.0097
        Dec         -43.1417
        Distance   1.227e+08  # method: T-F
        Radius     4.639e+04
        AbsMag        -19.58
        Axis    [ -0.6513  -0.7229  -0.2307]
        Angle    146.9307
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7162A"
}

Galaxy "NGC 7163:ESO 466-30:MCG 5-51-35:IRAS 21564-3207"
{
        Type  "SBb"
        RA           21.9889
        Dec         -31.8836
        Distance   9.871e+07  # method: T-F
        Radius     2.728e+04
        AbsMag         -18.7
        Axis    [ -0.4947  -0.8589   0.1329]
        Angle    142.4038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7163"
}

Galaxy "NGC 7164-1:ZWG 377.6:NPM 1"
{
        Type  "Sa"
        RA           21.9397
        Dec           1.3644
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.3333  -0.8844   0.3266]
        Angle    133.0515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7164-1"
}

Galaxy "NGC 7164-2:ZWG 377.6"
{
        Type  "S0"
        RA           21.9400
        Dec           1.3628
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.2534  -0.9610   0.1107]
        Angle    144.0409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7164-2"
}

Galaxy "NGC 7165:MCG 3-56-2:IRAS 21567-1645"
{
        Type  "Sb"
        RA           21.9906
        Dec         -16.5128
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.5086  -0.8424  -0.1780]
        Angle    152.6244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7165"
}

Galaxy "NGC 7166:ESO 288-27:MCG 7-45-4:AM 2157-433"
{
        Type  "S0"
        RA           22.0089
        Dec         -43.3900
        Distance   9.993e+07  # method: V
        Radius     3.488e+04
        AbsMag        -19.63
        Axis    [ -0.1640  -0.8015  -0.5751]
        Angle    138.2363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7166"
}

Galaxy "NGC 7167:ESO 532-9:MCG 4-52-1:AM 2157-245"
{
        Type  "SBc"
        RA           22.0083
        Dec         -24.6331
        Distance   1.034e+08  # method: V
        Radius     2.557e+04
        AbsMag        -19.61
        Axis    [ -0.5905  -0.6525   0.4750]
        Angle    134.3913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7167"
}

Galaxy "NGC 7168:ESO 237-26:AM 2158-515"
{
        Type  "E3"
        RA           22.0353
        Dec         -51.7433
        Distance   1.141e+08  # method: S
        Radius     3.154e+04
        AbsMag        -19.82
        Axis    [ -0.8450  -0.4113  -0.3417]
        Angle    157.6536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7168"
}

Galaxy "NGC 7169:ESO 237-28"
{
        Type  "S0"
        RA           22.0467
        Dec         -47.6975
        Distance    4.47e+08  # method: V
        Radius     6.501e+04
        AbsMag        -21.18
        Axis    [ -0.5156  -0.8519  -0.0914]
        Angle    141.6433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7169"
}

Galaxy "NGC 7170:AM 2148-554:AM 2148-554"
{
        Type  "S0"
        RA           22.0239
        Dec          -5.4322
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.3878  -0.6174   0.6844]
        Angle    128.8944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7170"
}

Galaxy "NGC 7171:MCG 2-56-5:IRAS 21583-1330"
{
        Type  "SBb"
        RA           22.0169
        Dec         -13.2697
        Distance   1.621e+08  # method: T-F
        Radius     6.129e+04
        AbsMag        -20.48
        Axis    [ -0.3805  -0.8395   0.3879]
        Angle    138.9742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7171"
}

Galaxy "NGC 7172:ESO 466-38:MCG 5-52-7:HCG 90A"
{
        Type  "Sa"
        RA           22.0336
        Dec         -31.8700
        Distance    1.05e+08  # method: V
        Radius     3.664e+04
        AbsMag        -19.84
        Axis    [ -0.4717  -0.8713   0.1354]
        Angle    143.3439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7172"
}

Galaxy "NGC 7173:ESO 466-39:MCG 5-52-8:UGCA 422"
{
        Type  "E0"
        RA           22.0342
        Dec         -31.9731
        Distance   1.022e+08  # method: S
        Radius     1.784e+04
        AbsMag        -19.58
        Axis    [ -0.8855  -0.3674   0.2846]
        Angle    121.7137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7173"
}

Galaxy "NGC 7174:ESO 466-40:MCG 5-52-10:VV 698"
{
        Type  "Sb"
        RA           22.0347
        Dec         -31.9925
        Distance   1.137e+08  # method: V
        Radius     3.802e+04
        AbsMag        -18.81
        Axis    [ -0.4345  -0.9000   0.0350]
        Angle    143.4992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7174"
}

Galaxy "NGC 7176:ESO 466-41:MCG 5-52-11:UGCA 423"
{
        Type  "E0"
        RA           22.0356
        Dec         -31.9906
        Distance   1.435e+08  # method: T-F
        Radius     1.669e+04
        AbsMag        -20.72
        Axis    [ -0.4868  -0.5699  -0.6620]
        Angle    197.2259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7176"
}

Galaxy "NGC 7177:UGC 11872:MCG 3-56-3:ZWG 451.2"
{
        Type  "SBb"
        RA           22.0114
        Dec          17.7372
        Distance   3.687e+07  # method: V
        Radius     1.716e+04
        AbsMag        -18.27
        Axis    [ -0.1122  -0.9770   0.1816]
        Angle    145.8939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7177"
}

Galaxy "NGC 7178:ESO 404-22:MCG 6-48-16"
{
        Type  "SBb"
        RA           22.0403
        Dec         -35.7908
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.4961  -0.5481   0.6734]
        Angle    157.7930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7178"
}

Galaxy "NGC 7179:ESO 108-11"
{
        Type  "SBc"
        RA           22.0803
        Dec         -64.0469
        Distance   1.703e+08  # method: T-F
        Radius     4.953e+04
        AbsMag        -20.29
        Axis    [ -0.4776  -0.8009  -0.3611]
        Angle    131.6955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7179"
}

Galaxy "NGC 7180:ESO 601-6:MCG 4-52-8"
{
        Type  "S0"
        RA           22.0383
        Dec         -20.5478
        Distance   5.827e+07  # method: S
        Radius     1.271e+04
        AbsMag        -17.66
        Axis    [ -0.2578  -0.9616  -0.0946]
        Angle    146.8910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7180"
}

Galaxy "NGC 7181:ZWG 377.14:NPM 1"
{
        Type  "S0"
        RA           22.0286
        Dec          -1.9600
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [ -0.3902  -0.9139   0.1122]
        Angle    141.6391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7181"
}

Galaxy "NGC 7182:MCG 0-56-6:ZWG 377.15:NPM 1"
{
        Type  "Sa"
        RA           22.0308
        Dec          -2.1961
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.1047  -0.9944  -0.0127]
        Angle    151.5001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7182"
}

Galaxy "NGC 7183:ESO 601-8:MCG 3-56-4:IRAS 21596-1909"
{
        Type  "Sa"
        RA           22.0392
        Dec         -18.9156
        Distance   1.052e+08  # method: V
        Radius     5.814e+04
        AbsMag        -19.64
        Axis    [ -0.1568  -0.9874   0.0227]
        Angle    146.2505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7183"
}

Galaxy "NGC 7184:ESO 601-9:MCG 4-52-9:UGCA 425"
{
        Type  "SBc"
        RA           22.0442
        Dec         -20.8125
        Distance   1.295e+08  # method: T-F
        Radius     1.111e+05
        AbsMag        -21.19
        Axis    [ -0.0726  -0.9929  -0.0942]
        Angle    145.2777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7184"
}

Galaxy "NGC 7185:ESO 601-10:MCG 4-52-11"
{
        Type  "S0"
        RA           22.0489
        Dec         -20.4714
        Distance   6.538e+07  # method: S
        Radius     2.187e+04
        AbsMag        -18.31
        Axis    [ -0.1907  -0.8275  -0.5280]
        Angle    164.3245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7185"
}

Galaxy "NGC 7187:ESO 404-24:MCG 6-48-18:AM 2159-330"
{
        Type  "S0"
        RA           22.0456
        Dec         -32.8033
        Distance   1.089e+08  # method: V
        Radius      2.06e+04
        AbsMag        -19.22
        Axis    [ -0.7026  -0.3795   0.6019]
        Angle    128.5723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7187"
}

Galaxy "NGC 7188:ESO 601-11:MCG 4-52-12"
{
        Type  "SBc"
        RA           22.0581
        Dec         -20.3175
        Distance   6.618e+07  # method: V
        Radius      1.54e+04
        AbsMag        -17.54
        Axis    [ -0.2050  -0.9322  -0.2983]
        Angle    151.7430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7188"
}

Galaxy "NGC 7189:UGC 11882:MCG 0-56-7:ZWG 377.17"
{
        Type  "SBb"
        RA           22.0542
        Dec           0.5714
        Distance    3.98e+08  # method: V
        Radius     5.788e+04
        AbsMag        -21.13
        Axis    [ -0.3254  -0.8934   0.3097]
        Angle    136.1367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7189"
}

Galaxy "NGC 7190:UGC 11885:ZWG 428.19:NPM 1"
{
        Type  "Sa"
        RA           22.0517
        Dec          11.1997
        Distance   3.941e+08  # method: V
        Radius     5.159e+04
        AbsMag        -20.61
        Axis    [ -0.0602  -0.9978  -0.0292]
        Angle    158.0044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7190"
}

Galaxy "NGC 7191:ESO 108-13:IRAS 22031-6452"
{
        Type  "SBc"
        RA           22.1142
        Dec         -64.6336
        Distance   1.316e+08  # method: T-F
        Radius     3.061e+04
        AbsMag        -19.23
        Axis    [ -0.6543  -0.6725   0.3459]
        Angle    162.7673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7191"
}

Galaxy "NGC 7192:ESO 108-12"
{
        Type  "E0"
        RA           22.1136
        Dec         -64.3161
        Distance   1.234e+08  # method: S
        Radius     3.411e+04
        AbsMag        -20.69
        Axis    [ -0.6827  -0.3503  -0.6413]
        Angle    171.5655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7192"
}

Galaxy "NGC 7194:UGC 11888:MCG 2-56-8:ZWG 428.24"
{
        Type  "E0"
        RA           22.0583
        Dec          12.6369
        Distance   3.533e+08  # method: V
        Radius     5.653e+04
        AbsMag        -20.87
        Axis    [ -0.4602  -0.8271  -0.3227]
        Angle    201.2710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7194"
}

Galaxy "NGC 7195:MCG 2-56-9:ZWG 428.22:NPM 1"
{
        Type  "S0"
        RA           22.0583
        Dec          12.6614
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.2075  -0.9764   0.0596]
        Angle    150.9610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7195"
}

Galaxy "NGC 7196:ESO 237-36:AM 2202-502:IRAS 22026-5021"
{
        Type  "E0"
        RA           22.0983
        Dec         -50.1192
        Distance    1.47e+08  # method: S
        Radius     5.347e+04
        AbsMag        -20.87
        Axis    [ -0.7864  -0.4404  -0.4330]
        Angle    164.3792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7196"
}

Galaxy "NGC 7197:UGC 11887:MCG 7-45-5:ZWG 530.3"
{
        Type  "Sa"
        RA           22.0492
        Dec          41.0594
        Distance    1.54e+08  # distance uncertain!
        Radius     3.583e+04
        AbsMag        -19.07
        Axis    [  0.1705  -0.9040   0.3921]
        Angle    142.6948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7197"
}

Galaxy "NGC 7198:MCG 0-56-8:ZWG 377.23:NPM 1"
{
        Type  "S0"
        RA           22.0872
        Dec          -0.6478
        Distance   1.768e+08  # distance uncertain!
        Radius     3.857e+04
        AbsMag        -19.07
        Axis    [ -0.0798  -0.8512  -0.5187]
        Angle    182.0900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7198"
}

Galaxy "NGC 7199:ESO 108-14"
{
        Type  "SBa"
        RA           22.1417
        Dec         -64.7061
        Distance   1.281e+08  # distance uncertain!
        Radius     2.049e+04
        AbsMag        -19.07
        Axis    [ -0.5318  -0.6308  -0.5650]
        Angle    141.9517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7199"
}

Galaxy "NGC 7200:ESO 237-37"
{
        Type  "E0"
        RA           22.1192
        Dec         -49.9956
        Distance   1.136e+08  # method: S
        Radius     1.983e+04
        AbsMag        -18.91
        Axis    [ -0.6956  -0.4544  -0.5565]
        Angle    173.4386
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7200"
}

Galaxy "NGC 7201:ESO 467-4:MCG 5-52-26:IRAS 22036-3130"
{
        Type  "Sa"
        RA           22.1089
        Dec         -31.2639
        Distance   1.882e+08  # method: V
        Radius      4.38e+04
        AbsMag        -20.01
        Axis    [ -0.3804  -0.8286   0.4107]
        Angle    152.1149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7201"
}

Galaxy "NGC 7203:ESO 467-7:MCG 5-52-27"
{
        Type  "SBa"
        RA           22.1119
        Dec         -31.1633
        Distance   1.115e+08  # distance uncertain!
        Radius     2.596e+04
        AbsMag        -19.07
        Axis    [ -0.4115  -0.9054  -0.1048]
        Angle    145.4611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7203"
}

Galaxy "NGC 7204-1:ESO 467-8:MCG 5-52-29:VV 685"
{
        Type  "Sa"
        RA           22.1147
        Dec         -31.0500
        Distance   1.057e+08  # method: V
        Radius     2.461e+04
        AbsMag        -18.05
        Axis    [ -0.4236  -0.9028   0.0736]
        Angle    144.6513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7204-1"
}

Galaxy "NGC 7204-2:ESO 467-8A:MCG 5-52-29:VV 685"
{
        Type  "SBb"
        RA           22.1153
        Dec         -31.0536
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.4231  -0.9056  -0.0315]
        Angle    144.8669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7204-2"
}

Galaxy "NGC 7205:ESO 146-9:AM 2205-574"
{
        Type  "Sc"
        RA           22.1425
        Dec         -57.4425
        Distance   7.026e+07  # method: T-F
        Radius     4.088e+04
        AbsMag        -20.07
        Axis    [ -0.5741  -0.8045  -0.1524]
        Angle    140.6970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7205"
}

Galaxy "NGC 7205A:ESO 146-7:IRAS 22041-5742"
{
        Type  "SBc"
        RA           22.1256
        Dec         -57.4642
        Distance   3.159e+08  # method: V
        Radius     5.514e+04
        AbsMag        -20.43
        Axis    [ -0.6669  -0.6912  -0.2784]
        Angle    144.1038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7205A"
}

Galaxy "NGC 7206:UGC 11904:MCG 3-56-7:ZWG 451.6"
{
        Type  "S0"
        RA           22.0944
        Dec          16.7853
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [ -0.2082  -0.7842   0.5845]
        Angle    122.6095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7206"
}

Galaxy "NGC 7207"
{
        Type  "S0"
        RA           22.0958
        Dec          16.7678
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.0806  -0.9685   0.2357]
        Angle    151.9798
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7207"
}

Galaxy "NGC 7208:ESO 467-10:MCG 5-52-32:AM 2205-291"
{
        Type  "S0"
        RA           22.1400
        Dec         -29.0514
        Distance   1.223e+08  # distance uncertain!
        Radius     1.601e+04
        AbsMag        -19.07
        Axis    [ -0.5592  -0.6819   0.4715]
        Angle    141.8784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7208"
}

Galaxy "NGC 7211:NPM 1"
{
        Type  "S0"
        RA           22.1058
        Dec          -8.0894
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.2357  -0.9189  -0.3163]
        Angle    164.2572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7211"
}

Galaxy "NGC 7212:UGC 11910:MCG 2-56-11:ZWG 428.32"
{
        Type  "Sb"
        RA           22.1172
        Dec          10.2347
        Distance   3.376e+08  # method: V
        Radius     5.893e+04
        AbsMag        -20.17
        Axis    [  0.0172  -0.9597  -0.2806]
        Angle    171.8517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7212"
}

Galaxy "NGC 7213:ESO 288-43:AM 2206-472:IRAS 22061-4724"
{
        Type  "Sa"
        RA           22.1544
        Dec         -47.1669
        Distance   7.189e+07  # method: V
        Radius     3.241e+04
        AbsMag        -20.72
        Axis    [ -0.8164  -0.5357   0.2156]
        Angle    141.2469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7213"
}

Galaxy "NGC 7214:ESO 467-12:MCG 5-52-34:VV 700"
{
        Type  "SBc"
        RA           22.1519
        Dec         -27.8097
        Distance   2.283e+08  # method: T-F
        Radius     7.304e+04
        AbsMag        -21.02
        Axis    [ -0.5050  -0.8446   0.1780]
        Angle    143.3280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7214"
}

Galaxy "NGC 7215:ZWG 377.31"
{
        Type  "S0"
        RA           22.1428
        Dec           0.5122
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.0705  -0.9855   0.1545]
        Angle    150.3779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7215"
}

Galaxy "NGC 7216:ESO 76-3"
{
        Type  "S0"
        RA           22.2100
        Dec         -68.6619
        Distance    1.53e+08  # method: V
        Radius     3.783e+04
        AbsMag        -19.86
        Axis    [ -0.7656  -0.5705   0.2972]
        Angle    159.0796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7216"
}

Galaxy "NGC 7217:UGC 11914:MCG 5-52-1:ZWG 494.2"
{
        Type  "Sb"
        RA           22.1311
        Dec          31.3594
        Distance   2.877e+07  # method: V
        Radius     1.674e+04
        AbsMag        -18.73
        Axis    [ -0.1433  -0.9838   0.1077]
        Angle    153.4489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7217"
}

Galaxy "NGC 7218:MCG 3-56-8:IRAS 22074-1654"
{
        Type  "SBc"
        RA           22.1697
        Dec         -16.6606
        Distance   1.013e+08  # method: T-F
        Radius     3.832e+04
        AbsMag        -19.76
        Axis    [ -0.0860  -0.8994  -0.4287]
        Angle    157.1578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7218"
}

Galaxy "NGC 7219:ESO 108-19:FAIR 1002:IRAS 22094-6505"
{
        Type  "SBa"
        RA           22.2189
        Dec         -64.8489
        Distance   1.432e+08  # method: T-F
        Radius     3.539e+04
        AbsMag        -19.91
        Axis    [ -0.4691  -0.6868  -0.5551]
        Angle    136.0631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7219"
}

Galaxy "NGC 7220:ESO 532-28:MCG 4-52-20"
{
        Type  "S0"
        RA           22.1917
        Dec         -22.9531
        Distance   2.262e+08  # method: V
        Radius     2.961e+04
        AbsMag        -19.71
        Axis    [ -0.2421  -0.7521  -0.6129]
        Angle    174.3242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7220"
}

Galaxy "NGC 7221:ESO 467-18:MCG 5-52-43:AM 2208-304"
{
        Type  "SBc"
        RA           22.1875
        Dec         -30.5633
        Distance   1.943e+08  # method: T-F
        Radius     5.651e+04
        AbsMag        -20.97
        Axis    [ -0.3159  -0.7359  -0.5989]
        Angle    168.2082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7221"
}

Galaxy "NGC 7222:UGC 11934:MCG 0-56-12:ZWG 377.35"
{
        Type  "SBb"
        RA           22.1808
        Dec           2.1064
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.4279  -0.7643  -0.4824]
        Angle    212.6954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7222"
}

Galaxy "NGC 7223:UGC 11931:MCG 7-45-18:ZWG 530.13"
{
        Type  "SBc"
        RA           22.1692
        Dec          41.0172
        Distance   1.971e+08  # method: V
        Radius     4.013e+04
        AbsMag        -20.51
        Axis    [ -0.0240  -0.8413   0.5400]
        Angle    115.2933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7223"
}

Galaxy "NGC 7224:UGC 11940:MCG 4-52-4:ZWG 473.6"
{
        Type  "E0"
        RA           22.1931
        Dec          25.8650
        Distance   2.884e+08  # distance uncertain!
        Radius     6.712e+04
        AbsMag        -20.13
        Axis    [ -0.5010  -0.8541   0.1398]
        Angle    127.8955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7224"
}

Galaxy "NGC 7225:ESO 532-33:MCG 4-52-23:AM 2210-262"
{
        Type  "Sa"
        RA           22.2186
        Dec         -26.1483
        Distance   2.085e+08  # method: V
        Radius     6.064e+04
        AbsMag        -20.83
        Axis    [ -0.4493  -0.7068   0.5464]
        Angle    148.4754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7225"
}

Galaxy "NGC 7227:UGC 11942:MCG 6-48-15:ZWG 513.12"
{
        Type  "S0"
        RA           22.1919
        Dec          38.7208
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.2075  -0.9108  -0.3569]
        Angle    202.2798
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7227"
}

Galaxy "NGC 7228:UGC 11945:MCG 6-48-16:ZWG 513.13"
{
        Type  "SBa"
        RA           22.1967
        Dec          38.6989
        Distance   2.837e+08  # method: V
        Radius     8.664e+04
        AbsMag           -20
        Axis    [  0.0659  -0.7289   0.6814]
        Angle    120.8650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7228"
}

Galaxy "NGC 7229:ESO 467-24:MCG 5-52-51:IRAS 22112-2937"
{
        Type  "SBc"
        RA           22.2342
        Dec         -29.3833
        Distance    1.82e+08  # method: V
        Radius     4.765e+04
        AbsMag        -20.53
        Axis    [ -0.6398  -0.5334   0.5533]
        Angle    135.2582
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7229"
}

Galaxy "NGC 7230:MCG 3-56-12:IRAS 22114-1719"
{
        Type  "SBc"
        RA           22.2369
        Dec         -17.0744
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.4716  -0.6599  -0.5849]
        Angle    203.7178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7230"
}

Galaxy "NGC 7231:UGC 11951:ZWG 530.17:IRAS 22104+4504"
{
        Type  "SBa"
        RA           22.2083
        Dec          45.3286
        Distance   3.697e+07  # method: V
        Radius     1.022e+04
        AbsMag        -16.37
        Axis    [  0.2969  -0.9246   0.2387]
        Angle    161.6223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7231"
}

Galaxy "NGC 7232:ESO 289-7:AM 2212-460"
{
        Type  "SBa"
        RA           22.2603
        Dec         -45.8503
        Distance   8.666e+07  # method: V
        Radius     3.277e+04
        AbsMag        -19.22
        Axis    [ -0.4936  -0.8595   0.1329]
        Angle    148.0411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7232"
}

Galaxy "NGC 7232A:ESO 289-3:IRAS 22105-4608"
{
        Type  "SBb"
        RA           22.2281
        Dec         -45.8936
        Distance   9.717e+07  # method: V
        Radius     2.968e+04
        AbsMag        -18.37
        Axis    [ -0.3842  -0.8852   0.2624]
        Angle    154.6159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7232A"
}

Galaxy "NGC 7232B:ESO 289-9"
{
        Type  "Irr"
        RA           22.2644
        Dec         -45.7806
        Distance   8.281e+07  # method: V
        Radius     1.927e+04
        AbsMag        -18.42
        Axis    [ -0.4130  -0.5703  -0.7101]
        Angle    174.0570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7232B"
}

Galaxy "NGC 7233:ESO 289-8:AM 2212-460:IRAS 22127-4605"
{
        Type  "SBa"
        RA           22.2636
        Dec         -45.8464
        Distance   7.674e+07  # method: V
        Radius     1.897e+04
        AbsMag        -18.76
        Axis    [ -0.7195  -0.6024   0.3456]
        Angle    146.0475
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7233"
}

Galaxy "NGC 7236:UGC 11958:MCG 2-56-23:ZWG 428.58"
{
        Type  "S0"
        RA           22.2458
        Dec          13.8464
        Distance   2.925e+08  # method: T-F
        Radius     2.552e+04
        AbsMag        -20.16
        Axis    [ -0.4057  -0.8174  -0.4089]
        Angle    218.6082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7236"
}

Galaxy "NGC 7237:UGC 11958:MCG 2-56-24:ZWG 428.58"
{
        Type  "S0"
        RA           22.2461
        Dec          13.8408
        Distance   2.925e+08  # method: T-F
        Radius     2.552e+04
        AbsMag        -19.86
        Axis    [ -0.4058  -0.8174  -0.4090]
        Angle    218.6082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7237"
}

Galaxy "NGC 7239:NPM 1"
{
        Type  "S0"
        RA           22.2503
        Dec          -5.0528
        Distance   3.072e+08  # distance uncertain!
        Radius     4.915e+04
        AbsMag        -19.07
        Axis    [ -0.2676  -0.9635  -0.0103]
        Angle    152.6678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7239"
}

Galaxy "NGC 7240:MCG 6-48-24:ZWG 513.22:ZWG 514.2"
{
        Type  "S0"
        RA           22.2561
        Dec          37.2806
        Distance   2.576e+08  # method: V
        Radius     2.248e+04
        AbsMag        -19.19
        Axis    [ -0.3339  -0.9096  -0.2471]
        Angle    228.4661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7240"
}

Galaxy "NGC 7241:UGC 11968:MCG 3-56-20:ZWG 451.24"
{
        Type  "SBc"
        RA           22.2636
        Dec          19.2314
        Distance   4.965e+07  # method: V
        Radius     2.455e+04
        AbsMag        -17.41
        Axis    [  0.1777  -0.9210  -0.3467]
        Angle    180.2921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7241"
}

Galaxy "NGC 7242:UGC 11969:MCG 6-48-25:ZWG 513.23"
{
        Type  "E0"
        RA           22.2608
        Dec          37.2978
        Distance   2.488e+08  # method: V
        Radius     8.324e+04
        AbsMag        -20.51
        Axis    [ -0.3776  -0.9175  -0.1248]
        Angle    201.9052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7242"
}

Galaxy "NGC 7244:MCG 3-56-21:MK 303:ZWG 451.25"
{
        Type  "Sc"
        RA           22.2739
        Dec          16.4717
        Distance   3.271e+08  # method: V
        Radius      3.33e+04
        AbsMag        -20.41
        Axis    [ -0.1499  -0.5951   0.7896]
        Angle    125.2512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7244"
}

Galaxy "NGC 7246:IC 5198:MCG 3-56-14:IRAS 22150-1549"
{
        Type  "Sa"
        RA           22.2950
        Dec         -15.5700
        Distance   2.555e+08  # distance uncertain!
        Radius     5.575e+04
        AbsMag        -19.07
        Axis    [ -0.3815  -0.6338   0.6729]
        Angle    144.4310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7246"
}

Galaxy "NGC 7247:ESO 533-8:MCG 4-52-32:IRAS 22149-2358"
{
        Type  "SBb"
        RA           22.2947
        Dec         -23.7306
        Distance   1.453e+08  # method: T-F
        Radius     2.958e+04
        AbsMag        -19.84
        Axis    [ -0.1408  -0.7800  -0.6097]
        Angle    164.4347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7247"
}

Galaxy "NGC 7248:UGC 11972:MCG 7-45-22:ZWG 530.19"
{
        Type  "S0"
        RA           22.2811
        Dec          40.5053
        Distance   1.739e+08  # method: V
        Radius     4.553e+04
        AbsMag        -20.13
        Axis    [  0.1451  -0.8319   0.5356]
        Angle    135.4223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7248"
}

Galaxy "NGC 7249:ESO 190-1"
{
        Type  "S0"
        RA           22.3417
        Dec         -55.1247
        Distance   5.362e+08  # method: V
        Radius     8.579e+04
        AbsMag        -21.68
        Axis    [ -0.7485  -0.5582   0.3579]
        Angle    152.0790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7249"
}

Galaxy "NGC 7250:UGC 11980:MCG 7-45-24:MK 907"
{
        Type  "Irr"
        RA           22.3047
        Dec          40.5631
        Distance   3.941e+07  # method: V
        Radius          9745
        AbsMag        -17.21
        Axis    [  0.1301  -0.7004   0.7017]
        Angle    126.5448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7250"
}

Galaxy "NGC 7251:MCG 3-57-2:IRAS 22177-1601"
{
        Type  "Sa"
        RA           22.3408
        Dec         -15.7731
        Distance   2.055e+08  # method: V
        Radius     5.678e+04
        AbsMag         -20.4
        Axis    [ -0.3055  -0.7413  -0.5976]
        Angle    189.0280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7251"
}

Galaxy "NGC 7252:ESO 533-15:MCG 4-52-36:ARP 226"
{
        Type  "S0"
        RA           22.3456
        Dec         -24.6783
        Distance    2.02e+08  # method: V
        Radius     6.171e+04
        AbsMag        -21.86
        Axis    [ -0.6062  -0.7457   0.2765]
        Angle    140.0014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7252"
}

Galaxy "NGC 7253-1:NGC 7253A:UGC 11984:MCG 5-52-10"
{
        Type  "SBc"
        RA           22.3242
        Dec          29.3969
        Distance   2.468e+08  # method: T-F
        Radius     6.103e+04
        AbsMag        -19.99
        Axis    [  0.0769  -0.9077   0.4125]
        Angle    145.1383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7253-1"
}

Galaxy "NGC 7253-2:NGC 7253B:UGC 11985:MCG 5-52-11"
{
        Type  "Sc"
        RA           22.3250
        Dec          29.3878
        Distance   1.452e+08  # method: T-F
        Radius      3.38e+04
        AbsMag        -18.24
        Axis    [  0.2152  -0.9732   0.0814]
        Angle    166.7991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7253-2"
}

Galaxy "NGC 7255:MCG 3-57-6:IRAS 22204-1547"
{
        Type  "Sa"
        RA           22.3856
        Dec         -15.5411
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [ -0.2367  -0.8738   0.4247]
        Angle    152.6980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7255"
}

Galaxy "NGC 7256:NGC 7254:ESO 602-13:KAZ 537"
{
        Type  "SBb"
        RA           22.3767
        Dec         -21.7347
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [ -0.3759  -0.8449   0.3806]
        Angle    148.8958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7256"
}

Galaxy "NGC 7257:NGC 7260:MCG 1-57-3"
{
        Type  "SBc"
        RA           22.3767
        Dec          -4.1208
        Distance   2.472e+08  # method: T-F
        Radius      6.83e+04
        AbsMag         -20.7
        Axis    [ -0.2437  -0.9093  -0.3374]
        Angle    172.6910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7257"
}

Galaxy "NGC 7258:ESO 467-49:MCG 5-52-68:IRAS 22201-2836"
{
        Type  "Sb"
        RA           22.3828
        Dec         -28.3453
        Distance   1.752e+08  # method: T-F
        Radius     3.567e+04
        AbsMag        -19.75
        Axis    [ -0.4231  -0.7461   0.5141]
        Angle    153.3944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7258"
}

Galaxy "NGC 7259:ESO 467-50:MCG 5-52-69:AM 2220-291"
{
        Type  "Sb"
        RA           22.3847
        Dec         -28.9544
        Distance   6.483e+07  # method: V
        Radius     1.037e+04
        AbsMag        -17.59
        Axis    [ -0.4975  -0.8090  -0.3130]
        Angle    158.3194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7259"
}

Galaxy "NGC 7262:ESO 405-17"
{
        Type  "S0"
        RA           22.3911
        Dec         -32.3647
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.6839  -0.7281   0.0469]
        Angle    145.3443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7262"
}

Galaxy "NGC 7263-1:MCG 6-49-4:ZWG 514.12:ZW 97"
{
        Type  "Sa"
        RA           22.3625
        Dec          36.3497
        Distance   2.657e+08  # method: V
        Radius     3.092e+04
        AbsMag        -18.95
        Axis    [ -0.1285  -0.9917  -0.0094]
        Angle    174.9060
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7263-1"
}

Galaxy "NGC 7263-2:MCG 6-49-4:ZWG 514.12:ZW 97"
{
        Type  "E0"
        RA           22.3628
        Dec          36.3525
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.3717  -0.8963  -0.2419]
        Angle    230.0206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7263-2"
}

Galaxy "NGC 7264:UGC 12001:MCG 6-49-5:ZWG 514.14"
{
        Type  "Sb"
        RA           22.3703
        Dec          36.3869
        Distance   2.605e+08  # method: T-F
        Radius     8.336e+04
        AbsMag        -19.91
        Axis    [  0.3642  -0.9313  -0.0115]
        Angle    176.2253
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7264"
}

Galaxy "NGC 7265:UGC 12004:MCG 6-49-6:ZWG 514.15"
{
        Type  "S0"
        RA           22.3742
        Dec          36.2103
        Distance   2.087e+08  # method: V
        Radius     7.287e+04
        AbsMag        -20.73
        Axis    [ -0.0727  -0.6912   0.7190]
        Angle    105.0713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7265"
}

Galaxy "NGC 7266:MCG 1-57-6:MK 910:IRAS 22213-0419"
{
        Type  "Sa"
        RA           22.3997
        Dec          -4.0731
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.3968  -0.9079   0.1350]
        Angle    146.7359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7266"
}

Galaxy "NGC 7267:ESO 405-18:MCG 6-49-3:IRAS 22214-3356"
{
        Type  "SBa"
        RA           22.4058
        Dec         -33.6933
        Distance   1.393e+08  # method: V
        Radius     3.243e+04
        AbsMag        -20.25
        Axis    [ -0.3812  -0.6798  -0.6265]
        Angle    174.0584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7267"
}

Galaxy "NGC 7268:ESO 467-57:MCG 5-53-1:AM 2222-312"
{
        Type  "S0"
        RA           22.4278
        Dec         -31.2011
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [ -0.4420  -0.8969   0.0155]
        Angle    148.5746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7268"
}

Galaxy "NGC 7268A:ESO 467-57A:MCG 5-53-2:PGC 68839"
{
        Type  "E0"
        RA           22.4283
        Dec         -31.2003
        Distance   4.366e+08  # distance uncertain!
        Radius     6.984e+04
        AbsMag        -20.13
        Axis    [ -0.8328  -0.5380  -0.1300]
        Angle    152.2286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7268A"
}

Galaxy "NGC 7269:MCG 2-57-5:IRAS 22231-1325"
{
        Type  "Sb"
        RA           22.4294
        Dec         -13.1669
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.4482  -0.7397   0.5020]
        Angle    138.4688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7269"
}

Galaxy "NGC 7270:UGC 12019:MCG 5-52-15:ZWG 494.21"
{
        Type  "Sc"
        RA           22.3964
        Dec          32.4031
        Distance   4.168e+08  # method: T-F
        Radius     5.456e+04
        AbsMag        -20.63
        Axis    [ -0.0015  -0.9766   0.2150]
        Angle    153.6640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7270"
}

Galaxy "NGC 7271:MCG 5-52-16:ZWG 494.22:NPM 1"
{
        Type  "S0"
        RA           22.3992
        Dec          32.3675
        Distance   4.441e+08  # distance uncertain!
        Radius     4.521e+04
        AbsMag        -19.07
        Axis    [  0.1259  -0.8951   0.4277]
        Angle    147.1528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7271"
}

Galaxy "NGC 7272:UGC 12028:MCG 3-57-3:ZWG 452.8"
{
        Type  "SBa"
        RA           22.4086
        Dec          16.5886
        Distance   4.478e+08  # method: V
        Radius     5.862e+04
        AbsMag        -20.99
        Axis    [ -0.2621  -0.9411  -0.2138]
        Angle    183.6662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7272"
}

Galaxy "NGC 7273:MCG 6-49-12:ZWG 514.24:NPM 1"
{
        Type  "S0"
        RA           22.4025
        Dec          36.2003
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.0811  -0.9178  -0.3886]
        Angle    209.9989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7273"
}

Galaxy "NGC 7274:UGC 12026:MCG 6-49-13:ZWG 514.26"
{
        Type  "E0"
        RA           22.4031
        Dec          36.1264
        Distance   2.499e+08  # method: V
        Radius     5.453e+04
        AbsMag        -20.12
        Axis    [ -0.3762  -0.8941  -0.2432]
        Angle    230.3739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7274"
}

Galaxy "NGC 7275:UGC 12025:MCG 5-52-19:ZWG 494.25"
{
        Type  "Sa"
        RA           22.4047
        Dec          32.4469
        Distance   2.817e+08  # method: V
        Radius     3.688e+04
        AbsMag        -19.58
        Axis    [  0.3163  -0.9308  -0.1833]
        Angle    181.9471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7275"
}

Galaxy "NGC 7276:MCG 6-49-14:ZWG 514.25:NPM 1"
{
        Type  "E0"
        RA           22.4039
        Dec          36.0881
        Distance   3.312e+08  # distance uncertain!
        Radius     4.335e+04
        AbsMag        -20.13
        Axis    [ -0.3764  -0.8939  -0.2435]
        Angle    230.3686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7276"
}

Galaxy "NGC 7277:ESO 467-59:MCG 5-53-4:IRAS 22233-3123"
{
        Type  "Sb"
        RA           22.4361
        Dec         -31.1458
        Distance   1.716e+08  # method: V
        Radius     3.744e+04
        AbsMag         -19.5
        Axis    [ -0.4199  -0.8183   0.3925]
        Angle    153.4209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7277"
}

Galaxy "NGC 7278:ESO 146-27"
{
        Type  "SBc"
        RA           22.4728
        Dec         -60.1694
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.3540  -0.6354  -0.6862]
        Angle    142.2137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7278"
}

Galaxy "NGC 7279:ESO 405-21:MCG 6-49-5:IRAS 22243-3523"
{
        Type  "SBc"
        RA           22.4533
        Dec         -35.1400
        Distance   3.991e+08  # method: V
        Radius     6.966e+04
        AbsMag        -21.14
        Axis    [ -0.5058  -0.8504  -0.1448]
        Angle    149.8740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7279"
}

Galaxy "NGC 7280:UGC 12035:MCG 3-57-5:ZWG 452.11"
{
        Type  "SBa"
        RA           22.4408
        Dec          16.1483
        Distance   7.933e+07  # method: S
        Radius     2.423e+04
        AbsMag        -18.93
        Axis    [ -0.1632  -0.9844   0.0652]
        Angle    158.8145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7280"
}

Galaxy "NGC 7282:UGC 12034:MCG 7-46-7:ZWG 531.6"
{
        Type  "SBb"
        RA           22.4314
        Dec          40.3156
        Distance   1.926e+08  # method: V
        Radius     7.004e+04
        AbsMag        -18.96
        Axis    [  0.2327  -0.9192  -0.3176]
        Angle    200.8170
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7282"
}

Galaxy "NGC 7283:MCG 3-57-12:ZWG 452.17:NPM 1"
{
        Type  "Sb"
        RA           22.4756
        Dec          17.4708
        Distance   3.143e+08  # method: V
        Radius     4.114e+04
        AbsMag        -19.62
        Axis    [  0.0856  -0.8966  -0.4345]
        Angle    188.8850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7283"
}

Galaxy "NGC 7284:ESO 533-31:MCG 4-53-4:VV 74"
{
        Type  "S0"
        RA           22.4764
        Dec         -24.8444
        Distance   1.922e+08  # method: V
        Radius     6.428e+04
        AbsMag        -20.85
        Axis    [ -0.5337  -0.7293   0.4281]
        Angle    143.6244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7284"
}

Galaxy "NGC 7285:ESO 533-32:MCG 4-53-5:VV 74"
{
        Type  "SBa"
        RA           22.4769
        Dec         -24.8406
        Distance   1.808e+08  # method: V
        Radius     5.523e+04
        AbsMag        -20.92
        Axis    [ -0.5251  -0.8379   0.1490]
        Angle    146.7982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7285"
}

Galaxy "NGC 7286:UGC 12043:MCG 5-53-2:ZWG 495.2"
{
        Type  "Sa"
        RA           22.4639
        Dec          29.0967
        Distance   7.937e+07  # method: T-F
        Radius     1.847e+04
        AbsMag        -18.43
        Axis    [  0.1088  -0.9542   0.2786]
        Angle    155.7489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7286"
}

Galaxy "NGC 7287A:ESO 602-20A"
{
        Type  "S0"
        RA           22.4800
        Dec         -22.2022
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.4797  -0.5885   0.6509]
        Angle    143.3615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7287A"
}

Galaxy "NGC 7288:MCG 1-57-13:MK 912:IRAS 22256-0308"
{
        Type  "Sa"
        RA           22.4706
        Dec          -2.8847
        Distance    2.02e+08  # method: V
        Radius     6.757e+04
        AbsMag        -20.06
        Axis    [ -0.2998  -0.9392   0.1676]
        Angle    149.4203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7288"
}

Galaxy "NGC 7289:ESO 405-23:MCG 6-49-6"
{
        Type  "S0"
        RA           22.4889
        Dec         -35.4719
        Distance   3.712e+08  # method: V
        Radius     7.019e+04
        AbsMag        -21.08
        Axis    [ -0.6074  -0.4870   0.6276]
        Angle    145.3069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7289"
}

Galaxy "NGC 7290:UGC 12045:MCG 3-57-9:ZWG 452.14"
{
        Type  "Sc"
        RA           22.4739
        Dec          17.1478
        Distance   1.933e+08  # method: T-F
        Radius     4.497e+04
        AbsMag        -20.06
        Axis    [ -0.1505  -0.6965   0.7016]
        Angle    127.4208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7290"
}

Galaxy "NGC 7291:UGC 12047:MCG 3-57-8:ZWG 452.15"
{
        Type  "S0"
        RA           22.4747
        Dec          16.7836
        Distance   1.688e+08  # distance uncertain!
        Radius      4.42e+04
        AbsMag        -19.07
        Axis    [ -0.3525  -0.9281  -0.1196]
        Angle    175.4290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7291"
}

Galaxy "NGC 7292:UGC 12048:MCG 5-53-3:ZWG 495.3"
{
        Type  "Irr"
        RA           22.4736
        Dec          30.2931
        Distance   3.013e+07  # method: V
        Radius          9201
        AbsMag        -16.83
        Axis    [ -0.0994  -0.9271   0.3615]
        Angle    138.0068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7292"
}

Galaxy "NGC 7294:IC 5225:ESO 533-44:MCG 4-53-9"
{
        Type  "S0"
        RA           22.5353
        Dec         -25.3981
        Distance   4.465e+08  # method: V
        Radius     1.299e+05
        AbsMag        -22.18
        Axis    [ -0.3432  -0.8972  -0.2780]
        Angle    156.1895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7294"
}

Galaxy "NGC 7297:ESO 345-18:MCG 6-49-7:IRAS 22282-3804"
{
        Type  "Sc"
        RA           22.5194
        Dec         -37.8269
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.6092  -0.6946   0.3826]
        Angle    149.0195
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7297"
}

Galaxy "NGC 7298:MCG 2-57-10:MK 1124:IRAS 22281-1426"
{
        Type  "Sc"
        RA           22.5139
        Dec         -14.1886
        Distance   2.131e+08  # method: V
        Radius     4.029e+04
        AbsMag        -19.68
        Axis    [ -0.2993  -0.7737  -0.5584]
        Angle    185.5286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7298"
}

Galaxy "NGC 7299:ESO 345-19:MCG 6-49-8:AM 2228-380"
{
        Type  "SBc"
        RA           22.5258
        Dec         -37.8097
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [ -0.5313  -0.5265  -0.6637]
        Angle    193.9491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7299"
}

Galaxy "NGC 7300:MCG 2-57-11"
{
        Type  "SBb"
        RA           22.5164
        Dec         -14.0031
        Distance   2.263e+08  # method: T-F
        Radius     6.911e+04
        AbsMag        -20.51
        Axis    [ -0.3312  -0.6571   0.6772]
        Angle    149.2409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7300"
}

Galaxy "NGC 7301:ESO 602-23:MCG 3-57-15:VV 372"
{
        Type  "SBb"
        RA           22.5094
        Dec         -17.5736
        Distance   3.121e+08  # method: V
        Radius     4.539e+04
        AbsMag         -20.8
        Axis    [ -0.0986  -0.8013  -0.5901]
        Angle    167.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7301"
}

Galaxy "NGC 7302:IC 5228:MCG 2-57-13"
{
        Type  "S0"
        RA           22.5397
        Dec         -14.1208
        Distance   7.752e+07  # method: S
        Radius      2.03e+04
        AbsMag        -18.58
        Axis    [ -0.3713  -0.9126   0.1715]
        Angle    149.6371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7302"
}

Galaxy "NGC 7303:UGC 12065:MCG 5-53-4:ZWG 495.5"
{
        Type  "Sc"
        RA           22.5258
        Dec          30.9567
        Distance   1.532e+08  # method: V
        Radius     3.341e+04
        AbsMag        -19.76
        Axis    [ -0.0743  -0.9016   0.4261]
        Angle    135.1555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7303"
}

Galaxy "NGC 7305:MCG 2-57-3:ZWG 429.7:NPM 1"
{
        Type  "S0"
        RA           22.5369
        Dec          11.7128
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.2294  -0.8930  -0.3871]
        Angle    196.8573
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7305"
}

Galaxy "NGC 7306:ESO 468-11:MCG 5-53-14:VV 832"
{
        Type  "Sb"
        RA           22.5544
        Dec         -27.2458
        Distance   1.675e+08  # method: T-F
        Radius     4.141e+04
        AbsMag        -20.05
        Axis    [ -0.2849  -0.9475  -0.1452]
        Angle    151.2976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7306"
}

Galaxy "NGC 7307:ESO 345-26:MCG 7-46-3:IRAS 22309-4111"
{
        Type  "SBc"
        RA           22.5644
        Dec         -40.9347
        Distance   1.157e+08  # method: T-F
        Radius     5.721e+04
        AbsMag        -19.85
        Axis    [ -0.1459  -0.8133  -0.5632]
        Angle    140.8553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7307"
}

Galaxy "NGC 7308:IC 1448:MCG 2-57-17"
{
        Type  "S0"
        RA           22.5756
        Dec         -12.9336
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [ -0.4688  -0.7010   0.5375]
        Angle    137.3050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7308"
}

Galaxy "NGC 7309:MCG 2-57-16:IRAS 22317-1036"
{
        Type  "SBc"
        RA           22.5722
        Dec         -10.3561
        Distance    1.66e+08  # method: V
        Radius     4.828e+04
        AbsMag        -20.33
        Axis    [ -0.3781  -0.8514  -0.3636]
        Angle    175.9009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7309"
}

Galaxy "NGC 7310:ESO 533-49:MCG 4-53-15:KAZ 544"
{
        Type  "SBc"
        RA           22.5767
        Dec         -22.4850
        Distance   4.247e+08  # method: V
        Radius     5.559e+04
        AbsMag        -20.87
        Axis    [ -0.4036  -0.8358  -0.3722]
        Angle    165.7069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7310"
}

Galaxy "NGC 7311:UGC 12080:MCG 1-57-9:ZWG 404.22"
{
        Type  "Sb"
        RA           22.5683
        Dec           5.5700
        Distance   1.892e+08  # method: V
        Radius     4.402e+04
        AbsMag        -20.42
        Axis    [ -0.0156  -0.8862  -0.4631]
        Angle    182.5759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7311"
}

Galaxy "NGC 7312:UGC 12083:MCG 1-57-10:ZWG 404.23"
{
        Type  "SBb"
        RA           22.5761
        Dec           5.8175
        Distance   3.592e+08  # method: V
        Radius     7.836e+04
        AbsMag        -20.91
        Axis    [ -0.1377  -0.9845   0.1084]
        Angle    157.3788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7312"
}

Galaxy "NGC 7313:ESO 533-52"
{
        Type  "SBb"
        RA           22.5922
        Dec         -26.1019
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.5075  -0.5107   0.6940]
        Angle    144.4333
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7313"
}

Galaxy "NGC 7314:ESO 533-53:MCG 4-53-18:ARP 14"
{
        Type  "SBc"
        RA           22.5958
        Dec         -26.0503
        Distance   7.121e+07  # method: T-F
        Radius     4.764e+04
        AbsMag        -20.09
        Axis    [ -0.1216  -0.7974  -0.5910]
        Angle    158.7306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7314"
}

Galaxy "NGC 7315:UGC 12097:MCG 6-49-37:ZWG 514.59"
{
        Type  "S0"
        RA           22.5919
        Dec          34.8039
        Distance   2.622e+08  # method: V
        Radius     6.102e+04
        AbsMag        -20.83
        Axis    [ -0.3741  -0.8894  -0.2627]
        Angle    231.1215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7315"
}

Galaxy "NGC 7316:UGC 12098:MCG 3-57-20:MK 307"
{
        Type  "Sc"
        RA           22.5989
        Dec          20.3222
        Distance   2.362e+08  # method: V
        Radius      3.78e+04
        AbsMag         -20.7
        Axis    [ -0.2051  -0.9771  -0.0566]
        Angle    172.6280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7316"
}

Galaxy "NGC 7317:MCG 6-49-38:ZWG 514.60:VV 288"
{
        Type  "E4"
        RA           22.5975
        Dec          33.9453
        Distance   2.869e+08  # method: V
        Radius     1.669e+04
        AbsMag        -20.12
        Axis    [ -0.4021  -0.8788  -0.2571]
        Angle    231.6073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7317"
}

Galaxy "NGC 7318-1:NGC 7318A:UGC 12099:MCG 6-49-39"
{
        Type  "E2"
        RA           22.5989
        Dec          33.9661
        Distance   2.877e+08  # method: V
        Radius     5.021e+04
        AbsMag        -20.33
        Axis    [ -0.4057  -0.8833  -0.2350]
        Angle    227.2249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7318-1"
}

Galaxy "NGC 7318-2:NGC 7318B:UGC 12100:MCG 6-49-40"
{
        Type  "SBc"
        RA           22.5994
        Dec          33.9667
        Distance   2.463e+08  # method: V
        Radius     5.732e+04
        AbsMag        -20.39
        Axis    [ -0.0088  -0.9664   0.2569]
        Angle    152.9174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7318-2"
}

Galaxy "NGC 7319:UGC 12102:MCG 6-49-41:ZWG 514.64"
{
        Type  "SBc"
        RA           22.6008
        Dec          33.9764
        Distance   2.857e+08  # method: V
        Radius     5.818e+04
        AbsMag        -20.61
        Axis    [ -0.0740  -0.9953  -0.0619]
        Angle    182.7729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7319"
}

Galaxy "NGC 7320:UGC 12101:MCG 6-49-42:ZWG 514.63"
{
        Type  "Sc"
        RA           22.6008
        Dec          33.9483
        Distance   6.483e+07  # method: T-F
        Radius     2.074e+04
        AbsMag        -18.29
        Axis    [  0.0900  -0.8477   0.5228]
        Angle    141.1894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7320"
}

Galaxy "NGC 7320A"
{
        Type  "S0"
        RA           22.6089
        Dec          33.7961
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.1248  -0.9852  -0.1177]
        Angle    185.0271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7320A"
}

Galaxy "NGC 7320B:ZWG 514.72"
{
        Type  "S0"
        RA           22.6244
        Dec          33.9233
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.2276  -0.9702  -0.0827]
        Angle    181.6613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7320B"
}

Galaxy "NGC 7320C:MCG 6-49-43:NPM 1"
{
        Type  "SBa"
        RA           22.6056
        Dec          33.9856
        Distance    2.57e+08  # method: V
        Radius     2.243e+04
        AbsMag        -17.58
        Axis    [ -0.0146  -0.6505   0.7594]
        Angle    116.3690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7320C"
}

Galaxy "NGC 7321:UGC 12103:MCG 3-57-21:ZWG 452.31"
{
        Type  "SBb"
        RA           22.6075
        Dec          21.6219
        Distance   3.082e+08  # method: V
        Radius     7.173e+04
        AbsMag        -21.08
        Axis    [ -0.0539  -0.9218  -0.3840]
        Angle    199.1803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7321"
}

Galaxy "NGC 7322:NGC 7334:ESO 405-33:MCG 6-49-10"
{
        Type  "Sa"
        RA           22.6308
        Dec         -37.2314
        Distance   5.138e+08  # method: V
        Radius     6.725e+04
        AbsMag        -21.49
        Axis    [ -0.6009  -0.7555   0.2613]
        Angle    149.5889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7322"
}

Galaxy "NGC 7323:UGC 12108:MCG 3-57-25:ZWG 452.34"
{
        Type  "Sb"
        RA           22.6147
        Dec          19.1444
        Distance   2.381e+08  # method: V
        Radius     4.847e+04
        AbsMag        -20.42
        Axis    [ -0.2117  -0.6510   0.7289]
        Angle    115.9504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7323"
}

Galaxy "NGC 7324:MCG 3-57-26:ZWG 452.36:KCPG 569B"
{
        Type  "S0"
        RA           22.6169
        Dec          19.1467
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [ -0.2220  -0.6661   0.7121]
        Angle    115.6789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7324"
}

Galaxy "NGC 7328:UGC 12118:MCG 2-57-7:ZWG 429.15"
{
        Type  "Sb"
        RA           22.6247
        Dec          10.5317
        Distance   1.118e+08  # method: V
        Radius     3.252e+04
        AbsMag        -18.57
        Axis    [  0.0092  -0.9835   0.1809]
        Angle    159.5935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7328"
}

Galaxy "NGC 7329:ESO 109-12:AM 2236-664:IRAS 22369-6644"
{
        Type  "SBc"
        RA           22.6733
        Dec         -66.4792
        Distance   1.465e+08  # method: T-F
        Radius     7.882e+04
        AbsMag        -20.86
        Axis    [ -0.8106  -0.5728   0.1221]
        Angle    152.9371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7329"
}

Galaxy "NGC 7330:UGC 12111:MCG 6-49-46:ZWG 514.67"
{
        Type  "E0"
        RA           22.6156
        Dec          38.5481
        Distance    2.27e+08  # method: V
        Radius     4.623e+04
        AbsMag        -20.91
        Axis    [ -0.3870  -0.8947  -0.2232]
        Angle    233.6181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7330"
}

Galaxy "NGC 7331:UGC 12113:MCG 6-49-45:ZWG 514.68"
{
        Type  "Sc"
        RA           22.6181
        Dec          34.4203
        Distance    4.28e+07  # method: S
        Radius     6.349e+04
        AbsMag        -20.29
        Axis    [  0.0923  -0.6084   0.7882]
        Angle    131.3490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7331"
}

Galaxy "NGC 7332:UGC 12115:MCG 4-53-8:ZWG 474.12"
{
        Type  "S0"
        RA           22.6233
        Dec          23.7981
        Distance   7.507e+07  # method: S
        Radius     4.476e+04
        AbsMag        -19.81
        Axis    [  0.0871  -0.6993   0.7095]
        Angle    147.3393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7332"
}

Galaxy "NGC 7335:UGC 12116:MCG 6-49-47:ZWG 514.69"
{
        Type  "Sa"
        RA           22.6219
        Dec          34.4483
        Distance    2.72e+08  # method: V
        Radius     4.747e+04
        AbsMag        -19.91
        Axis    [  0.0797  -0.7533   0.6528]
        Angle    133.5257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7335"
}

Galaxy "NGC 7336:MCG 6-49-49:NPM 1"
{
        Type  "S0"
        RA           22.6225
        Dec          34.4822
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.0900  -0.8158   0.5713]
        Angle    138.4176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7336"
}

Galaxy "NGC 7337:UGC 12120:MCG 6-49-50:ZWG 514.71"
{
        Type  "SBb"
        RA           22.6239
        Dec          34.3739
        Distance   2.984e+08  # method: V
        Radius     4.341e+04
        AbsMag        -19.41
        Axis    [ -0.0786  -0.6450   0.7601]
        Angle    105.4509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7337"
}

Galaxy "NGC 7339:UGC 12122:MCG 4-53-9:ZWG 474.13"
{
        Type  "SBc"
        RA           22.6297
        Dec          23.7864
        Distance   9.382e+07  # method: T-F
        Radius     3.821e+04
        AbsMag        -19.19
        Axis    [  0.1853  -0.9499   0.2516]
        Angle    162.9059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7339"
}

Galaxy "NGC 7340:MCG 6-49-52:ZWG 514.75:NPM 1"
{
        Type  "E0"
        RA           22.6289
        Dec          34.4106
        Distance   2.758e+08  # method: V
        Radius      3.61e+04
        AbsMag        -19.74
        Axis    [ -0.4005  -0.7933   0.4586]
        Angle     89.3049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7340"
}

Galaxy "NGC 7341:ESO 534-11:MCG 4-53-27"
{
        Type  "SBb"
        RA           22.6514
        Dec         -22.6664
        Distance   1.838e+08  # method: V
        Radius     6.417e+04
        AbsMag        -20.45
        Axis    [ -0.3236  -0.9319   0.1640]
        Angle    153.2026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7341"
}

Galaxy "NGC 7342:UGC 12126:MCG 6-49-54:ZWG 514.76"
{
        Type  "SBa"
        RA           22.6369
        Dec          35.4986
        Distance   3.516e+08  # method: V
        Radius     6.648e+04
        AbsMag        -20.26
        Axis    [ -0.3758  -0.8902  -0.2574]
        Angle    231.8952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7342"
}

Galaxy "NGC 7343:UGC 12129:MCG 6-49-59:ZWG 514.82"
{
        Type  "SBc"
        RA           22.6436
        Dec          34.0717
        Distance    2.62e+08  # method: V
        Radius     3.811e+04
        AbsMag        -20.22
        Axis    [ -0.0870  -0.7571   0.6475]
        Angle    113.9751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7343"
}

Galaxy "NGC 7344:MCG 1-57-20"
{
        Type  "Sb"
        RA           22.6600
        Dec          -4.1589
        Distance   3.202e+08  # method: V
        Radius     6.986e+04
        AbsMag        -20.46
        Axis    [ -0.1029  -0.8845  -0.4550]
        Angle    176.0325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7344"
}

Galaxy "NGC 7345:UGC 12130:MCG 6-49-64:ZWG 514.83"
{
        Type  "Sa"
        RA           22.6456
        Dec          35.5406
        Distance   3.393e+08  # method: V
        Radius     5.923e+04
        AbsMag        -19.89
        Axis    [  0.3412  -0.9243  -0.1712]
        Angle    185.4989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7345"
}

Galaxy "NGC 7346:ZWG 429.17:NPM 1"
{
        Type  "E0"
        RA           22.6597
        Dec          11.0839
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [ -0.5632  -0.8093  -0.1671]
        Angle    183.7807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7346"
}

Galaxy "NGC 7347:UGC 12136:MCG 2-57-9:ZWG 429.19"
{
        Type  "Sc"
        RA           22.6656
        Dec          11.0278
        Distance    8.53e+07  # method: V
        Radius     1.861e+04
        AbsMag        -17.49
        Axis    [  0.0650  -0.8254   0.5608]
        Angle    158.4973
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7347"
}

Galaxy "NGC 7348:UGC 12142:MCG 2-57-10:ZWG 429.20"
{
        Type  "SBc"
        RA           22.6767
        Dec          11.9061
        Distance   3.152e+08  # method: V
        Radius     5.043e+04
        AbsMag        -20.23
        Axis    [ -0.0227  -0.9032  -0.4286]
        Angle    188.8245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7348"
}

Galaxy "NGC 7349:ESO 603-4:MCG 4-53-29"
{
        Type  "SBb"
        RA           22.6872
        Dec         -21.7967
        Distance   1.959e+08  # method: V
        Radius     2.849e+04
        AbsMag        -18.79
        Axis    [ -0.3853  -0.5977   0.7031]
        Angle    154.4633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7349"
}

Galaxy "NGC 7351:MCG 1-57-22"
{
        Type  "S0"
        RA           22.6906
        Dec          -4.4442
        Distance   1.281e+08  # distance uncertain!
        Radius     3.353e+04
        AbsMag        -19.07
        Axis    [ -0.2747  -0.5477   0.7903]
        Angle    142.4417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7351"
}

Galaxy "NGC 7353:KUG 2239+116:NPM 1"
{
        Type  "S0"
        RA           22.7033
        Dec          11.8772
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [ -0.1968  -0.8523  -0.4847]
        Angle    206.1092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7353"
}

Galaxy "NGC 7355:ESO 406-6"
{
        Type  "Sb"
        RA           22.7250
        Dec         -36.8653
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.3126  -0.9020  -0.2979]
        Angle    148.9585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7355"
}

Galaxy "NGC 7356:UGC 12159:MCG 5-53-10:ZWG 495.14"
{
        Type  "Sc"
        RA           22.7006
        Dec          30.7094
        Distance   4.968e+08  # method: T-F
        Radius     7.948e+04
        AbsMag        -21.01
        Axis    [  0.1178  -0.9872   0.1079]
        Angle    169.3699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7356"
}

Galaxy "NGC 7357:UGC 12162:MCG 5-53-11:ZWG 495.16"
{
        Type  "Sb"
        RA           22.7064
        Dec          30.1719
        Distance   3.164e+08  # method: V
        Radius     6.903e+04
        AbsMag        -19.73
        Axis    [  0.0831  -0.8945   0.4393]
        Angle    149.2885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7357"
}

Galaxy "NGC 7358:ESO 109-18"
{
        Type  "S0"
        RA           22.7600
        Dec         -65.1217
        Distance   1.464e+08  # method: V
        Radius     4.045e+04
        AbsMag        -19.56
        Axis    [ -0.5616  -0.5219   0.6420]
        Angle    193.8294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7358"
}

Galaxy "NGC 7359:ESO 534-22:MCG 4-53-34"
{
        Type  "S0"
        RA           22.7464
        Dec         -23.6881
        Distance   1.378e+08  # method: V
        Radius     4.809e+04
        AbsMag        -19.63
        Axis    [ -0.1511  -0.9776  -0.1465]
        Angle    153.2332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7359"
}

Galaxy "NGC 7360:UGC 12167:MCG 1-58-1:ZWG 404.36"
{
        Type  "S0"
        RA           22.7261
        Dec           4.1519
        Distance   1.961e+08  # method: V
        Radius     1.996e+04
        AbsMag        -19.29
        Axis    [ -0.2203  -0.7267   0.6507]
        Angle    140.3854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7360"
}

Galaxy "NGC 7361:IC 5237:ESO 468-23:MCG 5-53-27"
{
        Type  "Sc"
        RA           22.7047
        Dec         -30.0575
        Distance   7.117e+07  # method: T-F
        Radius     4.037e+04
        AbsMag        -18.69
        Axis    [ -0.0612  -0.8198  -0.5693]
        Angle    148.3741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7361"
}

Galaxy "NGC 7362:UGC 12171:MCG 1-58-2:ZWG 405.3"
{
        Type  "E0"
        RA           22.7303
        Dec           8.7058
        Distance   1.995e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -20.13
        Axis    [ -0.5764  -0.5368   0.6161]
        Angle     91.6891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7362"
}

Galaxy "NGC 7363:MCG 6-49-78:ZWG 514.102:IRAS 22409+3344"
{
        Type  "SBc"
        RA           22.7217
        Dec          33.9986
        Distance   2.338e+07  # method: V
        Radius          3740
        AbsMag        -14.78
        Axis    [ -0.1119  -0.9766   0.1835]
        Angle    157.2878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7363"
}

Galaxy "NGC 7364:UGC 12174:MCG 0-58-1:ZWG 379.2"
{
        Type  "Sa"
        RA           22.7400
        Dec          -0.1625
        Distance   2.039e+08  # method: V
        Radius     5.338e+04
        AbsMag        -20.38
        Axis    [ -0.2199  -0.9739  -0.0565]
        Angle    163.8832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7364"
}

Galaxy "NGC 7365:ESO 603-10:MCG 3-58-1:NPM 1"
{
        Type  "S0"
        RA           22.7528
        Dec         -19.9517
        Distance    1.25e+08  # method: V
        Radius     2.728e+04
        AbsMag        -18.92
        Axis    [ -0.3272  -0.8733  -0.3610]
        Angle    165.7702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7365"
}

Galaxy "NGC 7366:MCG 2-58-4:NPM 1"
{
        Type  "S0"
        RA           22.7406
        Dec          10.7819
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.4650  -0.7811  -0.4168]
        Angle    221.3722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7366"
}

Galaxy "NGC 7367:UGC 12175:MCG 0-58-2:ZWG 379.3"
{
        Type  "Sb"
        RA           22.7428
        Dec           3.6464
        Distance   3.116e+08  # method: V
        Radius     7.252e+04
        AbsMag         -20.2
        Axis    [ -0.0330  -0.8604   0.5085]
        Angle    157.8696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7367"
}

Galaxy "NGC 7368:ESO 345-49:MCG 7-46-10:IRAS 22426-3936"
{
        Type  "SBb"
        RA           22.7586
        Dec         -39.3419
        Distance   1.193e+08  # method: T-F
        Radius     5.033e+04
        AbsMag        -19.62
        Axis    [ -0.3533  -0.8232   0.4445]
        Angle    168.1419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7368"
}

Galaxy "NGC 7369:MCG 6-49-80:ZWG 514.104:ZWG 515.2"
{
        Type  "Sc"
        RA           22.7367
        Dec          34.3517
        Distance   2.838e+08  # method: V
        Radius     5.779e+04
        AbsMag           -20
        Axis    [ -0.0750  -0.9713  -0.2256]
        Angle    202.3826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7369"
}

Galaxy "NGC 7370:NPM 1"
{
        Type  "S0"
        RA           22.7603
        Dec          11.0583
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [ -0.0608  -0.8469   0.5283]
        Angle    150.3705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7370"
}

Galaxy "NGC 7371:MCG 2-58-1:NPM 1"
{
        Type  "SBa"
        RA           22.7675
        Dec         -11.0006
        Distance   1.056e+08  # method: V
        Radius     3.072e+04
        AbsMag        -20.05
        Axis    [ -0.5179  -0.6687  -0.5334]
        Angle    210.0154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7371"
}

Galaxy "NGC 7372:MCG 2-58-5:ZWG 430.4:KUG 2243+108"
{
        Type  "Sc"
        RA           22.7628
        Dec          11.1314
        Distance     5.1e+08  # method: V
        Radius     7.418e+04
        AbsMag        -21.47
        Axis    [ -0.3764  -0.9258   0.0360]
        Angle    161.1135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7372"
}

Galaxy "NGC 7373:ZWG 379.4"
{
        Type  "S0"
        RA           22.7719
        Dec           3.2100
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.0080  -0.9050  -0.4253]
        Angle    177.2858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7373"
}

Galaxy "NGC 7374:NGC 7374A:MCG 2-58-7:ZWG 430.6"
{
        Type  "Sc"
        RA           22.7669
        Dec          10.8536
        Distance   3.052e+08  # method: V
        Radius     3.996e+04
        AbsMag        -20.06
        Axis    [ -0.2776  -0.9460   0.1676]
        Angle    154.0133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7374"
}

Galaxy "NGC 7375:MCG 3-58-3:ZWG 453.7:NPM 1"
{
        Type  "Sa"
        RA           22.7756
        Dec          21.0842
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [ -0.1534  -0.9871  -0.0468]
        Angle    174.8941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7375"
}

Galaxy "NGC 7376:ZWG 379.6:KUG 2244+033"
{
        Type  "Sa"
        RA           22.7881
        Dec           3.6453
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.3039  -0.7781   0.5497]
        Angle    137.1488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7376"
}

Galaxy "NGC 7377:ESO 534-26:MCG 4-53-38:IRAS 22451-2234"
{
        Type  "SBa"
        RA           22.7964
        Dec         -22.3114
        Distance   1.364e+08  # method: V
        Radius      5.95e+04
        AbsMag        -21.21
        Axis    [ -0.5918  -0.7901   0.1600]
        Angle    148.6633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7377"
}

Galaxy "NGC 7378:MCG 2-58-5"
{
        Type  "SBb"
        RA           22.7964
        Dec         -11.8167
        Distance   1.007e+08  # method: V
        Radius     2.197e+04
        AbsMag        -18.95
        Axis    [ -0.3392  -0.5425   0.7685]
        Angle    145.3680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7378"
}

Galaxy "NGC 7379:UGC 12187:MCG 7-46-18:ZWG 531.13"
{
        Type  "SBa"
        RA           22.7922
        Dec          40.2392
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.0113  -0.9897   0.1424]
        Angle    167.8748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7379"
}

Galaxy "NGC 7381:ESO 603-17:MCG 3-58-7A"
{
        Type  "Sc"
        RA           22.8356
        Dec         -19.7247
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.4973  -0.7815   0.3767]
        Angle    147.3649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7381"
}

Galaxy "NGC 7382:ESO 406-15:MCG 6-50-5:IRAS 22476-3707"
{
        Type  "Sa"
        RA           22.8397
        Dec         -36.8569
        Distance   5.134e+08  # method: V
        Radius     8.961e+04
        AbsMag        -21.38
        Axis    [ -0.4114  -0.8672   0.2807]
        Angle    158.3963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7382"
}

Galaxy "NGC 7383:MCG 2-58-14:ZWG 430.12:NPM 1"
{
        Type  "S0"
        RA           22.8264
        Dec          11.5569
        Distance   3.514e+08  # method: V
        Radius     4.088e+04
        AbsMag        -20.06
        Axis    [ -0.3163  -0.6006   0.7343]
        Angle    114.0508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7383"
}

Galaxy "NGC 7385:UGC 12207:MCG 2-58-17:ZWG 430.15"
{
        Type  "E0"
        RA           22.8317
        Dec          11.6081
        Distance   3.129e+08  # method: T-F
        Radius     5.917e+04
        AbsMag        -21.71
        Axis    [ -0.5564  -0.8029  -0.2140]
        Angle    195.3227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7385"
}

Galaxy "NGC 7386:UGC 12209:MCG 2-58-18:ZWG 430.16"
{
        Type  "S0"
        RA           22.8339
        Dec          11.6981
        Distance   3.121e+08  # method: V
        Radius      8.17e+04
        AbsMag         -21.4
        Axis    [ -0.1713  -0.7574   0.6300]
        Angle    138.0817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7386"
}

Galaxy "NGC 7387:MCG 2-58-22:ZWG 430.19:NPM 1"
{
        Type  "S0"
        RA           22.8381
        Dec          11.6372
        Distance   2.978e+08  # method: V
        Radius     3.032e+04
        AbsMag         -19.5
        Axis    [ -0.0927  -0.9832  -0.1575]
        Angle    176.2299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7387"
}

Galaxy "NGC 7389:MCG 2-58-19:ZWG 430.18:NPM 1"
{
        Type  "S0"
        RA           22.8378
        Dec          11.5667
        Distance   3.425e+08  # method: V
        Radius     6.974e+04
        AbsMag        -20.31
        Axis    [ -0.1902  -0.7902   0.5826]
        Angle    138.4069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7389"
}

Galaxy "NGC 7390:MCG 2-58-20:ZWG 430.20"
{
        Type  "S0"
        RA           22.8386
        Dec          11.5311
        Distance   3.355e+08  # method: V
        Radius      4.88e+04
        AbsMag        -19.76
        Axis    [ -0.2058  -0.5787   0.7891]
        Angle    126.5094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7390"
}

Galaxy "NGC 7391:UGC 12211:MCG 0-58-6:ZWG 379.8"
{
        Type  "E0"
        RA           22.8433
        Dec          -1.5447
        Distance   2.123e+08  # method: T-F
        Radius     5.249e+04
        AbsMag        -20.87
        Axis    [ -0.6730  -0.7349  -0.0836]
        Angle    165.9738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7391"
}

Galaxy "NGC 7392:ESO 603-22:MCG 4-53-40"
{
        Type  "SBc"
        RA           22.8633
        Dec         -20.6086
        Distance   1.558e+08  # method: T-F
        Radius     4.985e+04
        AbsMag        -20.79
        Axis    [ -0.4570  -0.7994   0.3901]
        Angle    150.3225
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7392"
}

Galaxy "NGC 7393:MCG 1-58-2:VV 68:ARP 15"
{
        Type  "SBc"
        RA           22.8606
        Dec          -5.5572
        Distance   1.546e+08  # method: V
        Radius     4.496e+04
        AbsMag        -19.78
        Axis    [ -0.1968  -0.9693   0.1475]
        Angle    158.6426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7393"
}

Galaxy "NGC 7395:UGC 12216:MCG 6-50-6:ZWG 515.8"
{
        Type  "S0"
        RA           22.8506
        Dec          37.0883
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.1766  -0.9179   0.3554]
        Angle    133.2904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7395"
}

Galaxy "NGC 7396:UGC 12220:MCG 0-58-7:ZWG 379.10"
{
        Type  "Sa"
        RA           22.8728
        Dec           1.0922
        Distance   2.088e+08  # method: V
        Radius     7.288e+04
        AbsMag        -20.23
        Axis    [ -0.2883  -0.9230   0.2547]
        Angle    152.5111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7396"
}

Galaxy "NGC 7397:MCG 0-58-8:ZWG 379.11"
{
        Type  "SBa"
        RA           22.8794
        Dec           1.1325
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.3097  -0.6736   0.6710]
        Angle    135.0251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7397"
}

Galaxy "NGC 7398:UGC 12225:MCG 0-58-9:ZWG 379.12"
{
        Type  "Sa"
        RA           22.8803
        Dec           1.2017
        Distance   4.552e+08  # method: V
        Radius     7.944e+04
        AbsMag        -21.12
        Axis    [ -0.2651  -0.9638   0.0275]
        Angle    162.6038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7398"
}

Galaxy "NGC 7399:MCG 2-58-6"
{
        Type  "Sa"
        RA           22.8775
        Dec          -9.2675
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.2615  -0.7288   0.6328]
        Angle    153.5227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7399"
}

Galaxy "NGC 7400:ESO 290-22:AM 2251-453:IRAS 22514-4536"
{
        Type  "Sc"
        RA           22.9056
        Dec         -45.3472
        Distance   1.366e+08  # method: T-F
        Radius     5.365e+04
        AbsMag        -19.51
        Axis    [ -0.1151  -0.8064  -0.5801]
        Angle    134.1585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7400"
}

Galaxy "NGC 7401"
{
        Type  "Sa"
        RA           22.8828
        Dec           1.1425
        Distance   3.072e+08  # distance uncertain!
        Radius     4.468e+04
        AbsMag        -19.07
        Axis    [ -0.2305  -0.9670   0.1087]
        Angle    159.8373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7401"
}

Galaxy "NGC 7402:MCG 0-58-10:ZWG 379.13:NPM 1"
{
        Type  "S0"
        RA           22.8844
        Dec           1.1450
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.2673  -0.9477  -0.1742]
        Angle    173.0012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7402"
}

Galaxy "NGC 7404:IC 5260:ESO 346-10:MCG 7-47-1"
{
        Type  "S0"
        RA           22.9050
        Dec         -39.3147
        Distance   7.647e+07  # method: V
        Radius     1.668e+04
        AbsMag        -18.05
        Axis    [ -0.2602  -0.7399  -0.6204]
        Angle    155.3004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7404"
}

Galaxy "NGC 7406:MCG 1-58-3"
{
        Type  "S0"
        RA           22.8989
        Dec          -6.5789
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.2498  -0.9680   0.0254]
        Angle    160.9865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7406"
}

Galaxy "NGC 7407:UGC 12230:MCG 5-54-2:ZWG 496.5"
{
        Type  "Sc"
        RA           22.8892
        Dec          32.1297
        Distance   3.035e+08  # method: T-F
        Radius     8.828e+04
        AbsMag        -20.84
        Axis    [  0.0902  -0.7441   0.6620]
        Angle    139.9247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7407"
}

Galaxy "NGC 7408:ESO 109-26:IRAS 22527-6357"
{
        Type  "SBc"
        RA           22.9322
        Dec         -63.6953
        Distance   1.432e+08  # method: T-F
        Radius     3.332e+04
        AbsMag        -19.91
        Axis    [ -0.7105  -0.3554   0.6074]
        Angle    167.7087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7408"
}

Galaxy "NGC 7409:ZWG 453.18:NPM 1"
{
        Type  "S0"
        RA           22.8967
        Dec          20.2108
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [ -0.1214  -0.7023   0.7014]
        Angle    129.4566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7409"
}

Galaxy "NGC 7410:ESO 346-12:MCG 7-47-2:IRAS 22522-3955"
{
        Type  "SBa"
        RA           22.9167
        Dec         -39.6622
        Distance   6.795e+07  # method: V
        Radius     5.139e+04
        AbsMag        -20.29
        Axis    [ -0.2990  -0.9186  -0.2585]
        Angle    147.8807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7410"
}

Galaxy "NGC 7411:UGC 12241:MCG 3-58-10:ZWG 453.20"
{
        Type  "E0"
        RA           22.9094
        Dec          20.2367
        Distance   2.939e+08  # method: V
        Radius     3.847e+04
        AbsMag        -20.37
        Axis    [ -0.4778  -0.8076  -0.3455]
        Angle    228.6324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7411"
}

Galaxy "NGC 7412:ESO 290-24:MCG 7-47-4:AM 2252-425"
{
        Type  "SBb"
        RA           22.9294
        Dec         -42.6414
        Distance   3.026e+07  # method: T-F
        Radius     1.672e+04
        AbsMag        -17.94
        Axis    [ -0.6345  -0.7693  -0.0752]
        Angle    153.3277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7412"
}

Galaxy "NGC 7412A:ESO 290-28:FGCE 1793"
{
        Type  "SBc"
        RA           22.9519
        Dec         -42.8050
        Distance   3.135e+07  # method: V
        Radius     1.596e+04
        AbsMag        -15.41
        Axis    [ -0.3363  -0.9299   0.1493]
        Angle    157.4836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7412A"
}

Galaxy "NGC 7413:MCG 2-58-35:ZWG 430.29:NPM 1"
{
        Type  "S0"
        RA           22.9175
        Dec          13.2211
        Distance   4.254e+08  # method: V
        Radius     6.188e+04
        AbsMag        -20.48
        Axis    [ -0.1972  -0.9756   0.0969]
        Angle    163.3688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7413"
}

Galaxy "NGC 7414:NPM 1:PGC 94273"
{
        Type  "S0"
        RA           22.9233
        Dec          13.2489
        Distance   4.869e+08  # distance uncertain!
        Radius     2.833e+04
        AbsMag        -19.07
        Axis    [ -0.1012  -0.5988   0.7945]
        Angle    139.4175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7414"
}

Galaxy "NGC 7415-1:UGC 12244:MCG 3-58-11:ZWG 453.23"
{
        Type  "Sb"
        RA           22.9142
        Dec          20.2622
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.1571  -0.8358   0.5260]
        Angle    161.5409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7415-1"
}

Galaxy "NGC 7415-2:UGC 12244:MCG 3-58-12:ZWG 453.23"
{
        Type  "S0"
        RA           22.9147
        Dec          20.2619
        Distance   5.259e+08  # method: V
        Radius     3.824e+04
        AbsMag        -20.54
        Axis    [ -0.0771  -0.9613   0.2647]
        Angle    157.1692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7415-2"
}

Galaxy "NGC 7416:MCG 1-58-4"
{
        Type  "SBb"
        RA           22.9281
        Dec          -5.4950
        Distance   1.135e+08  # method: V
        Radius     5.284e+04
        AbsMag        -19.51
        Axis    [ -0.0674  -0.9135   0.4012]
        Angle    163.1350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7416"
}

Galaxy "NGC 7417:ESO 109-28"
{
        Type  "SBb"
        RA           22.9636
        Dec         -65.0383
        Distance   1.395e+08  # method: V
        Radius     4.869e+04
        AbsMag        -19.95
        Axis    [ -0.4312  -0.5963  -0.6771]
        Angle    143.3313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7417"
}

Galaxy "NGC 7418:ESO 406-25:MCG 6-50-13:IRAS 22538-3717"
{
        Type  "SBc"
        RA           22.9431
        Dec         -37.0289
        Distance   6.777e+07  # method: T-F
        Radius      3.45e+04
        AbsMag        -19.89
        Axis    [ -0.6237  -0.6207   0.4751]
        Angle    151.2820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7418"
}

Galaxy "NGC 7418A:ESO 406-27:MCG 6-50-11B"
{
        Type  "Sc"
        RA           22.9447
        Dec         -36.7728
        Distance   8.331e+07  # method: V
        Radius     4.241e+04
        AbsMag        -18.24
        Axis    [ -0.4826  -0.8748   0.0435]
        Angle    154.1946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7418A"
}

Galaxy "NGC 7420:MCG 5-54-18:ZWG 496.23:KARA 998"
{
        Type  "Sc"
        RA           22.9256
        Dec          29.8056
        Distance   4.136e+08  # method: V
        Radius     4.813e+04
        AbsMag        -20.42
        Axis    [ -0.0937  -0.9882  -0.1214]
        Angle    189.5522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7420"
}

Galaxy "NGC 7421:ESO 346-17:MCG 6-50-15:AM 2254-373"
{
        Type  "SBc"
        RA           22.9483
        Dec         -37.3450
        Distance   7.112e+07  # method: V
        Radius     2.069e+04
        AbsMag        -19.19
        Axis    [ -0.7615  -0.6426  -0.0846]
        Angle    155.7274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7421"
}

Galaxy "NGC 7422:UGC 12254:MCG 1-58-13:ZWG 405.15"
{
        Type  "Sb"
        RA           22.9367
        Dec           3.9269
        Distance   2.021e+08  # method: V
        Radius      2.94e+04
        AbsMag        -19.66
        Axis    [ -0.3545  -0.7767   0.5206]
        Angle    135.5950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7422"
}

Galaxy "NGC 7424:ESO 346-19:MCG 7-47-8:IRAS 22544-4120"
{
        Type  "SBc"
        RA           22.9550
        Dec         -41.0708
        Distance   3.153e+07  # method: V
        Radius     4.356e+04
        AbsMag        -19.02
        Axis    [ -0.7321  -0.6683   0.1318]
        Angle    150.8721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7424"
}

Galaxy "NGC 7425:MCG 2-58-13"
{
        Type  "SBa"
        RA           22.9542
        Dec         -10.9500
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.3411  -0.9324  -0.1194]
        Angle    164.7304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7425"
}

Galaxy "NGC 7426:UGC 12256:MCG 6-50-12:ZWG 515.12"
{
        Type  "E0"
        RA           22.9342
        Dec          36.3622
        Distance   2.282e+08  # method: V
        Radius     5.642e+04
        AbsMag        -20.82
        Axis    [ -0.4268  -0.9028   0.0523]
        Angle    171.7082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7426"
}

Galaxy "NGC 7427:MCG 1-58-16:MK 521:ZWG 405.18"
{
        Type  "S0"
        RA           22.9525
        Dec           8.5061
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [ -0.4930  -0.7595  -0.4243]
        Angle    221.9068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7427"
}

Galaxy "NGC 7428:UGC 12262:MCG 0-58-14:ZWG 379.16"
{
        Type  "SBa"
        RA           22.9553
        Dec          -1.0492
        Distance   1.233e+08  # method: V
        Radius     4.303e+04
        AbsMag        -19.39
        Axis    [ -0.2542  -0.6717   0.6958]
        Angle    143.9122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7428"
}

Galaxy "NGC 7430:MCG 1-58-17:ZWG 405.19:ARAK 571"
{
        Type  "S0"
        RA           22.9581
        Dec           8.7944
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.0871  -0.9941  -0.0639]
        Angle    171.4022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7430"
}

Galaxy "NGC 7431:NPM 1"
{
        Type  "E0"
        RA           22.9606
        Dec          26.1644
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.5013  -0.8561   0.1260]
        Angle    150.3961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7431"
}

Galaxy "NGC 7432:UGC 12268:MCG 2-58-40:ZWG 430.33"
{
        Type  "E0"
        RA           22.9672
        Dec          13.1344
        Distance   2.631e+08  # distance uncertain!
        Radius     6.121e+04
        AbsMag        -20.13
        Axis    [ -0.5633  -0.8067  -0.1786]
        Angle    193.9352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7432"
}

Galaxy "NGC 7433:MCG 4-54-3:ZWG 475.6:VV 84"
{
        Type  "S0"
        RA           22.9642
        Dec          26.1622
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.1838  -0.9717  -0.1487]
        Angle    183.3254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7433"
}

Galaxy "NGC 7434:MCG 0-58-16:ZWG 379.17:NPM 1"
{
        Type  "S0"
        RA           22.9725
        Dec          -1.1833
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [ -0.1666  -0.9837  -0.0673]
        Angle    166.9648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7434"
}

Galaxy "NGC 7435:UGC 12267:MCG 4-54-4:ZWG 475.7"
{
        Type  "SBa"
        RA           22.9650
        Dec          26.1389
        Distance   3.223e+08  # method: V
        Radius     5.625e+04
        AbsMag        -19.77
        Axis    [ -0.0191  -0.9070   0.4206]
        Angle    149.5971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7435"
}

Galaxy "NGC 7436:NGC 7436A:UGC 12269:MCG 4-54-6"
{
        Type  "E0"
        RA           22.9656
        Dec          26.1497
        Distance    3.19e+08  # method: V
        Radius      9.28e+04
        AbsMag        -21.05
        Axis    [ -0.4646  -0.8310  -0.3058]
        Angle    231.9433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7436"
}

Galaxy "NGC 7436B:VV 84"
{
        Type  "S0"
        RA           22.9656
        Dec          26.1497
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.1385  -0.9566   0.2565]
        Angle    165.8683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7436B"
}

Galaxy "NGC 7437:UGC 12270:MCG 2-58-41:ZWG 430.34"
{
        Type  "Sc"
        RA           22.9694
        Dec          14.3086
        Distance   7.973e+07  # method: V
        Radius     2.087e+04
        AbsMag        -17.94
        Axis    [ -0.4787  -0.7864  -0.3904]
        Angle    225.0966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7437"
}

Galaxy "NGC 7439:UGC 12273:MCG 5-54-21:ZWG 496.27"
{
        Type  "S0"
        RA           22.9692
        Dec          29.2289
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.0041  -0.7783   0.6279]
        Angle    135.5294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7439"
}

Galaxy "NGC 7440:UGC 12276:MCG 6-50-14:MK 924"
{
        Type  "SBa"
        RA           22.9756
        Dec          35.8031
        Distance   2.425e+08  # method: V
        Radius     4.939e+04
        AbsMag        -19.96
        Axis    [ -0.0772  -0.9856   0.1503]
        Angle    166.6568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7440"
}

Galaxy "NGC 7441:IC 1458:MCG 1-58-7"
{
        Type  "Sc"
        RA           22.9447
        Dec          -7.3797
        Distance   1.861e+08  # method: V
        Radius     3.518e+04
        AbsMag        -19.28
        Axis    [ -0.3309  -0.7472   0.5764]
        Angle    146.6738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7441"
}

Galaxy "NGC 7442:UGC 12286:MCG 2-58-45:ZWG 430.42"
{
        Type  "Sc"
        RA           22.9906
        Dec          15.5483
        Distance   3.133e+08  # method: V
        Radius     5.012e+04
        AbsMag        -20.71
        Axis    [ -0.4772  -0.7911  -0.3826]
        Angle    225.9200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7442"
}

Galaxy "NGC 7443:MCG 2-58-15"
{
        Type  "Sa"
        RA           23.0022
        Dec         -12.8078
        Distance    1.42e+08  # method: V
        Radius     2.891e+04
        AbsMag        -19.39
        Axis    [ -0.1265  -0.9469  -0.2957]
        Angle    164.5919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7443"
}

Galaxy "NGC 7444:MCG 2-58-16"
{
        Type  "S0"
        RA           23.0022
        Dec         -12.8342
        Distance   1.281e+08  # method: V
        Radius     3.166e+04
        AbsMag        -19.07
        Axis    [ -0.0565  -0.8236  -0.5644]
        Angle    169.0930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7444"
}

Galaxy "NGC 7445:MCG 6-50-15:ZWG 515.16:NPM 1"
{
        Type  "S0"
        RA           22.9894
        Dec          39.1081
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.2790  -0.9364   0.2131]
        Angle    172.5334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7445"
}

Galaxy "NGC 7446:ZWG 515.17:NPM 1"
{
        Type  "E0"
        RA           22.9911
        Dec          39.0833
        Distance   3.802e+08  # distance uncertain!
        Radius     4.424e+04
        AbsMag        -20.13
        Axis    [ -0.4198  -0.8816  -0.2155]
        Angle    237.9335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7446"
}

Galaxy "NGC 7448:UGC 12294:MCG 3-58-18:ZWG 453.42"
{
        Type  "Sc"
        RA           23.0008
        Dec          15.9800
        Distance   9.368e+07  # method: T-F
        Radius     3.543e+04
        AbsMag        -20.09
        Axis    [ -0.0581  -0.6288   0.7754]
        Angle    141.9816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7448"
}

Galaxy "NGC 7449:UGC 12292:MCG 6-50-16:ZWG 515.18"
{
        Type  "E0"
        RA           22.9936
        Dec          39.1458
        Distance   3.631e+08  # distance uncertain!
        Radius     5.281e+04
        AbsMag        -20.13
        Axis    [ -0.3746  -0.8802   0.2914]
        Angle    120.7733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7449"
}

Galaxy "NGC 7450:MCG 2-58-19:MK 1126"
{
        Type  "Sa"
        RA           23.0131
        Dec         -12.9178
        Distance    1.29e+08  # method: V
        Radius     3.376e+04
        AbsMag        -18.88
        Axis    [ -0.5475  -0.6459  -0.5321]
        Angle    210.3702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7450"
}

Galaxy "NGC 7451:UGC 12299:MCG 1-58-20:ZWG 405.22"
{
        Type  "SBc"
        RA           23.0111
        Dec           8.4675
        Distance   2.865e+08  # method: V
        Radius     4.167e+04
        AbsMag        -19.82
        Axis    [ -0.0982  -0.9951  -0.0063]
        Angle    169.6485
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7451"
}

Galaxy "NGC 7452"
{
        Type  "S0"
        RA           23.0131
        Dec           6.7458
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.2381  -0.9228  -0.3029]
        Angle    187.1144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7452"
}

Galaxy "NGC 7454:UGC 12305:MCG 3-58-20:ZWG 453.45"
{
        Type  "E4"
        RA           23.0183
        Dec          16.3892
        Distance   7.788e+07  # method: S
        Radius     2.492e+04
        AbsMag        -19.09
        Axis    [ -0.5474  -0.7125   0.4390]
        Angle    107.9582
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7454"
}

Galaxy "NGC 7455:MK 523:ZWG 405.21:KUG 2258+070"
{
        Type  "Sa"
        RA           23.0111
        Dec           7.3033
        Distance   3.188e+08  # method: V
        Radius     2.782e+04
        AbsMag        -19.65
        Axis    [ -0.2130  -0.5927   0.7767]
        Angle    133.6776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7455"
}

Galaxy "NGC 7456:ESO 346-26:MCG 7-47-11:IRAS 22594-3950"
{
        Type  "Sc"
        RA           23.0361
        Dec         -39.5692
        Distance   5.962e+07  # method: T-F
        Radius     4.769e+04
        AbsMag        -18.91
        Axis    [ -0.2320  -0.8728  -0.4294]
        Angle    146.4194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7456"
}

Galaxy "NGC 7457:UGC 12306:MCG 5-54-26:ZWG 496.32"
{
        Type  "S0"
        RA           23.0164
        Dec          30.1447
        Distance    4.32e+07  # method: S
        Radius     2.701e+04
        AbsMag        -18.61
        Axis    [  0.0434  -0.8655   0.4990]
        Angle    147.3210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7457"
}

Galaxy "NGC 7458:UGC 12309:MCG 0-58-20:ZWG 379.22"
{
        Type  "E0"
        RA           23.0244
        Dec           1.7533
        Distance   2.092e+08  # method: V
        Radius      4.26e+04
        AbsMag        -20.44
        Axis    [ -0.5756  -0.7311  -0.3664]
        Angle    209.3185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7458"
}

Galaxy "NGC 7459-1:UGC 12302:MCG 1-58-21"
{
        Type  "S0"
        RA           23.0164
        Dec           6.7494
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.5042  -0.7476  -0.4323]
        Angle    221.4621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7459-1"
}

Galaxy "NGC 7459-2:UGC 12302:MCG 1-58-21"
{
        Type  "Irr"
        RA           23.0167
        Dec           6.7508
        Distance   6.026e+08  # distance uncertain!
        Radius     7.012e+04
        AbsMag        -20.13
        Axis    [ -0.1145  -0.9933   0.0155]
        Angle    168.1560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7459-2"
}

Galaxy "NGC 7460:UGC 12312:MCG 0-58-21:ZWG 379.23"
{
        Type  "Sb"
        RA           23.0283
        Dec           2.2636
        Distance   1.285e+08  # method: V
        Radius     2.803e+04
        AbsMag        -19.38
        Axis    [ -0.2649  -0.9271  -0.2652]
        Angle    181.2093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7460"
}

Galaxy "NGC 7461:UGC 12314:MCG 2-58-56:ZWG 430.51"
{
        Type  "S0"
        RA           23.0300
        Dec          15.5825
        Distance   1.775e+08  # method: V
        Radius     2.323e+04
        AbsMag        -19.18
        Axis    [ -0.2280  -0.7661   0.6009]
        Angle    131.0500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7461"
}

Galaxy "NGC 7462:ESO 346-28:MCG 7-47-13:IRAS 23000-4105"
{
        Type  "SBc"
        RA           23.0461
        Dec         -40.8356
        Distance   4.449e+07  # method: T-F
        Radius     2.782e+04
        AbsMag        -18.47
        Axis    [ -0.2960  -0.9549   0.0257]
        Angle    154.0932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7462"
}

Galaxy "NGC 7463:UGC 12316:MCG 3-58-22:ZWG 453.48"
{
        Type  "SBb"
        RA           23.0308
        Dec          15.9819
        Distance   9.414e+07  # method: V
        Radius      3.56e+04
        AbsMag         -18.6
        Axis    [  0.1297  -0.9680   0.2147]
        Angle    168.3247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7463"
}

Galaxy "NGC 7464:UGC 12315:MCG 3-58-23:ZWG 453.49"
{
        Type  "E1"
        RA           23.0314
        Dec          15.9744
        Distance   6.532e+07  # method: V
        Radius          4750
        AbsMag        -17.21
        Axis    [ -0.5028  -0.7815  -0.3693]
        Angle    227.6158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7464"
}

Galaxy "NGC 7465:UGC 12317:MCG 3-58-24:MK 313"
{
        Type  "S0"
        RA           23.0333
        Dec          15.9653
        Distance   7.275e+07  # method: V
        Radius     2.328e+04
        AbsMag        -18.44
        Axis    [ -0.2491  -0.9511  -0.1825]
        Angle    187.3049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7465"
}

Galaxy "NGC 7466:IC 5281:UGC 12319:MCG 4-54-17"
{
        Type  "Sb"
        RA           23.0342
        Dec          27.0531
        Distance   2.998e+08  # method: T-F
        Radius      6.54e+04
        AbsMag        -20.42
        Axis    [  0.1498  -0.9426  -0.2984]
        Angle    192.1093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7466"
}

Galaxy "NGC 7467:MCG 2-58-57:ZWG 430.53:NPM 1"
{
        Type  "E0"
        RA           23.0408
        Dec          15.5547
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [ -0.5491  -0.8119  -0.1983]
        Angle    201.1489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7467"
}

Galaxy "NGC 7468:UGC 12329:MK 314:ZWG 453.52"
{
        Type  "E1"
        RA           23.0497
        Dec          16.6044
        Distance   7.891e+07  # method: V
        Radius     1.033e+04
        AbsMag        -17.82
        Axis    [ -0.5365  -0.8111  -0.2330]
        Angle    208.1182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7468"
}

Galaxy "NGC 7468A:UGC 12342:MCG 3-58-30:ZWG 453.61"
{
        Type  "SBa"
        RA           23.0814
        Dec          16.6789
        Distance   3.767e+08  # method: V
        Radius     7.122e+04
        AbsMag        -20.31
        Axis    [ -0.0042  -0.7699   0.6382]
        Angle    151.3988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7468A"
}

Galaxy "NGC 7469:UGC 12332:MCG 1-58-25:ZWG 405.26"
{
        Type  "SBa"
        RA           23.0542
        Dec           8.8739
        Distance   2.055e+08  # method: V
        Radius     4.184e+04
        AbsMag         -21.1
        Axis    [ -0.2552  -0.8646   0.4329]
        Angle    145.6199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7469"
}

Galaxy "NGC 7470:ESO 239-9:IRAS 23023-5023"
{
        Type  "Sc"
        RA           23.0869
        Dec         -50.1117
        Distance   1.579e+08  # method: V
        Radius     3.215e+04
        AbsMag        -19.12
        Axis    [ -0.6522  -0.7579   0.0182]
        Angle    153.6867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7470"
}

Galaxy "NGC 7472:NGC 7482:MCG 0-58-29:ZWG 379.31"
{
        Type  "E0"
        RA           23.0939
        Dec           3.0589
        Distance    3.02e+08  # distance uncertain!
        Radius     2.636e+04
        AbsMag        -20.13
        Axis    [ -0.6234  -0.7531  -0.2105]
        Angle    191.0964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7472"
}

Galaxy "NGC 7473:UGC 12335:MCG 5-54-30:ZWG 496.38"
{
        Type  "S0"
        RA           23.0658
        Dec          30.1600
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.0974  -0.9858  -0.1369]
        Angle    188.5740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7473"
}

Galaxy "NGC 7474:MCG 3-58-26:ZWG 453.58:NPM 1"
{
        Type  "S0"
        RA           23.0678
        Dec          20.0678
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.4712  -0.8080  -0.3537]
        Angle    228.9299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7474"
}

Galaxy "NGC 7475-1:UGC 12337:MCG 3-58-27:ZWG 453.59"
{
        Type  "E0"
        RA           23.0694
        Dec          20.0792
        Distance   3.631e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -20.13
        Axis    [ -0.5410  -0.8378  -0.0736]
        Angle    185.4909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7475-1"
}

Galaxy "NGC 7475-2:UGC 12337:MCG 3-58-28:ZWG 453.59"
{
        Type  "E0"
        RA           23.0697
        Dec          20.0844
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [ -0.4945  -0.7987  -0.3429]
        Angle    230.0008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7475-2"
}

Galaxy "NGC 7476:ESO 290-45:MCG 7-47-15:IRAS 23023-4322"
{
        Type  "SBb"
        RA           23.0867
        Dec         -43.0981
        Distance    1.23e+08  # method: V
        Radius     2.505e+04
        AbsMag        -19.28
        Axis    [ -0.5578  -0.4135   0.7196]
        Angle    160.3738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7476"
}

Galaxy "NGC 7477"
{
        Type  "S0"
        RA           23.0778
        Dec           3.1183
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.1851  -0.8856  -0.4261]
        Angle    189.4751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7477"
}

Galaxy "NGC 7478:KUG 2302+023"
{
        Type  "Sa"
        RA           23.0822
        Dec           2.5775
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.2138  -0.8227  -0.5267]
        Angle    198.6437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7478"
}

Galaxy "NGC 7479:UGC 12343:MCG 2-58-60:ZWG 430.58"
{
        Type  "SBc"
        RA           23.0822
        Dec          12.3222
        Distance   9.155e+07  # method: V
        Radius     5.326e+04
        AbsMag        -20.64
        Axis    [ -0.2240  -0.9215  -0.3172]
        Angle    194.2720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7479"
}

Galaxy "NGC 7480:NGC 7480A:UGC 12349:MCG 0-58-27"
{
        Type  "Sa"
        RA           23.0869
        Dec           2.5494
        Distance   1.967e+08  # method: V
        Radius     3.719e+04
        AbsMag         -18.9
        Axis    [  0.0002  -0.9447   0.3280]
        Angle    165.2964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7480"
}

Galaxy "NGC 7480B:KUG 2302+022"
{
        Type  "Sb"
        RA           23.0836
        Dec           2.5406
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.1787  -0.6695   0.7210]
        Angle    148.2016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7480B"
}

Galaxy "NGC 7483:UGC 12353:MCG 0-58-30:ZWG 379.32"
{
        Type  "SBa"
        RA           23.0967
        Dec           3.5453
        Distance   2.075e+08  # method: V
        Radius     4.829e+04
        AbsMag        -20.02
        Axis    [ -0.2843  -0.9041   0.3189]
        Angle    152.8837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7483"
}

Galaxy "NGC 7484:ESO 407-6:MCG 6-50-26"
{
        Type  "E0"
        RA           23.1178
        Dec         -36.2728
        Distance   1.117e+08  # method: V
        Radius     2.923e+04
        AbsMag        -20.47
        Axis    [ -0.8199  -0.5097  -0.2606]
        Angle    170.1004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7484"
}

Galaxy "NGC 7485:UGC 12360:MCG 6-50-22:ZWG 515.24"
{
        Type  "S0"
        RA           23.1011
        Dec          34.1081
        Distance   2.538e+08  # method: V
        Radius     4.429e+04
        AbsMag        -20.25
        Axis    [  0.0947  -0.7868   0.6099]
        Angle    142.5097
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7485"
}

Galaxy "NGC 7487:UGC 12368:MCG 5-54-35:ZWG 496.43"
{
        Type  "S0"
        RA           23.1139
        Dec          28.1794
        Distance   1.938e+08  # distance uncertain!
        Radius     5.639e+04
        AbsMag        -19.07
        Axis    [ -0.2224  -0.8424   0.4908]
        Angle    126.6254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7487"
}

Galaxy "NGC 7488:MCG 0-59-1:ZWG 380.1:ARAK 576"
{
        Type  "S0"
        RA           23.1300
        Dec           0.9411
        Distance   1.938e+08  # distance uncertain!
        Radius     1.692e+04
        AbsMag        -19.07
        Axis    [ -0.3353  -0.8718  -0.3572]
        Angle    190.5926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7488"
}

Galaxy "NGC 7489:UGC 12378:MCG 4-54-28:ZWG 475.38"
{
        Type  "Sc"
        RA           23.1256
        Dec          22.9978
        Distance   2.627e+08  # method: T-F
        Radius     8.024e+04
        AbsMag        -20.43
        Axis    [ -0.0178  -0.6421   0.7664]
        Angle    137.0186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7489"
}

Galaxy "NGC 7490:UGC 12379:MCG 5-54-36:ZWG 496.44"
{
        Type  "Sc"
        RA           23.1236
        Dec          32.3756
        Distance   2.669e+08  # method: V
        Radius     1.048e+05
        AbsMag        -21.26
        Axis    [ -0.3129  -0.9498  -0.0032]
        Angle    183.9703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7490"
}

Galaxy "NGC 7491:MCG 1-59-2:IRAS 23054-0614"
{
        Type  "Sc"
        RA           23.1350
        Dec          -5.9664
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [ -0.3214  -0.5679   0.7577]
        Angle    140.3893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7491"
}

Galaxy "NGC 7494:ESO 535-5:MCG 4-54-7"
{
        Type  "E1"
        RA           23.1494
        Dec         -24.3692
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [ -0.8186  -0.5725  -0.0461]
        Angle    158.6729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7494"
}

Galaxy "NGC 7495:UGC 12391:MCG 2-59-3:ZWG 431.6"
{
        Type  "Sc"
        RA           23.1492
        Dec          12.0481
        Distance   2.052e+08  # method: V
        Radius     5.371e+04
        AbsMag        -20.29
        Axis    [ -0.3013  -0.8477  -0.4366]
        Angle    210.3736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7495"
}

Galaxy "NGC 7496:ESO 291-1:MCG 7-47-20:VV 771"
{
        Type  "SBb"
        RA           23.1628
        Dec         -43.4275
        Distance   6.401e+07  # method: V
        Radius     3.072e+04
        AbsMag        -19.56
        Axis    [ -0.5194  -0.5673  -0.6391]
        Angle    178.5433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7496"
}

Galaxy "NGC 7496A:ESO 291-7:AM 2309-440:KDWG 274"
{
        Type  "Irr"
        RA           23.2064
        Dec         -43.7786
        Distance   2.884e+08  # distance uncertain!
        Radius     5.873e+04
        AbsMag        -20.13
        Axis    [ -0.5328  -0.8451   0.0430]
        Angle    156.1061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7496A"
}

Galaxy "NGC 7496B:ESO 291-7:AM 2309-440"
{
        Type  "S0"
        RA           23.2058
        Dec         -43.7775
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.5507  -0.7113   0.4369]
        Angle    164.0942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7496B"
}

Galaxy "NGC 7497:UGC 12392:MCG 3-59-2:ZWG 454.3"
{
        Type  "SBc"
        RA           23.1508
        Dec          18.1775
        Distance   7.117e+07  # method: T-F
        Radius     4.554e+04
        AbsMag        -18.69
        Axis    [  0.0481  -0.9889  -0.1405]
        Angle    181.5211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7497"
}

Galaxy "NGC 7498:ESO 535-6:MCG 4-54-8"
{
        Type  "Sb"
        RA           23.1656
        Dec         -24.4244
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.3374  -0.5250   0.7813]
        Angle    165.9286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7498"
}

Galaxy "NGC 7499:UGC 12397:MCG 1-59-5:ZWG 406.7"
{
        Type  "S0"
        RA           23.1728
        Dec           7.5811
        Distance   5.141e+08  # method: V
        Radius     8.973e+04
        AbsMag        -21.99
        Axis    [ -0.1143  -0.8838  -0.4536]
        Angle    192.5473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7499"
}

Galaxy "NGC 7500:UGC 12399:MCG 2-59-4:ZWG 431.8"
{
        Type  "S0"
        RA           23.1747
        Dec          11.0128
        Distance   1.768e+08  # distance uncertain!
        Radius       5.4e+04
        AbsMag        -19.07
        Axis    [ -0.1188  -0.8777   0.4642]
        Angle    153.8163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7500"
}

Galaxy "NGC 7501:MCG 1-59-7:ZWG 406.8:NPM 1"
{
        Type  "E1"
        RA           23.1750
        Dec           7.5894
        Distance   5.596e+08  # method: V
        Radius      4.07e+04
        AbsMag        -21.57
        Axis    [ -0.5401  -0.7326  -0.4142]
        Angle    224.4021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7501"
}

Galaxy "NGC 7503:MCG 1-59-8:ZWG 406.12:NPM 1"
{
        Type  "E2"
        RA           23.1783
        Dec           7.5681
        Distance   5.837e+08  # method: V
        Radius     6.792e+04
        AbsMag        -21.86
        Axis    [ -0.5405  -0.7323  -0.4142]
        Angle    224.4159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7503"
}

Galaxy "NGC 7505:ZWG 431.9"
{
        Type  "S0"
        RA           23.1833
        Dec          13.6314
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.0746  -0.9211   0.3822]
        Angle    165.8951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7505"
}

Galaxy "NGC 7506:UGC 12406:MCG 0-59-5:ZWG 380.6"
{
        Type  "Sa"
        RA           23.1947
        Dec          -2.1597
        Distance   1.605e+08  # method: V
        Radius      3.97e+04
        AbsMag        -19.46
        Axis    [ -0.3059  -0.9140   0.2663]
        Angle    157.3322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7506"
}

Galaxy "NGC 7507:ESO 469-19:MCG 5-54-22:AM 2309-284"
{
        Type  "E0"
        RA           23.2019
        Dec         -28.5386
        Distance   8.155e+07  # method: S
        Radius     3.321e+04
        AbsMag        -20.59
        Axis    [ -0.6081  -0.5358  -0.5858]
        Angle    203.6667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7507"
}

Galaxy "NGC 7508:UGC 12408:MCG 2-59-5:ZWG 431.11"
{
        Type  "S0"
        RA           23.1969
        Dec          12.9411
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [  0.0021  -0.6861   0.7275]
        Angle    156.4430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7508"
}

Galaxy "NGC 7509:MCG 2-59-6:ZWG 431.13:NPM 1"
{
        Type  "E0"
        RA           23.2058
        Dec          14.6097
        Distance   3.163e+08  # distance uncertain!
        Radius      5.06e+04
        AbsMag        -20.13
        Axis    [ -0.5244  -0.7654  -0.3729]
        Angle    228.3856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7509"
}

Galaxy "NGC 7511:UGC 12412:MCG 2-59-7:ZWG 431.12"
{
        Type  "S0"
        RA           23.2072
        Dec          13.7269
        Distance   2.064e+08  # method: V
        Radius     3.303e+04
        AbsMag        -19.11
        Axis    [ -0.0572  -0.8447   0.5321]
        Angle    154.2537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7511"
}

Galaxy "NGC 7512:UGC 12414:MCG 5-54-46:ZWG 496.54"
{
        Type  "E0"
        RA           23.2056
        Dec          31.1256
        Distance    2.95e+08  # method: V
        Radius     6.435e+04
        AbsMag        -21.08
        Axis    [ -0.4789  -0.8688  -0.1256]
        Angle    210.9242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7512"
}

Galaxy "NGC 7513:ESO 469-22:MCG 5-54-23:UGCA 437"
{
        Type  "SBb"
        RA           23.2203
        Dec         -28.3581
        Distance   6.714e+07  # method: T-F
        Radius     3.125e+04
        AbsMag        -18.87
        Axis    [ -0.5240  -0.8068   0.2729]
        Angle    156.3924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7513"
}

Galaxy "NGC 7514:UGC 12415:MCG 6-50-26:ZWG 515.27"
{
        Type  "Sc"
        RA           23.2069
        Dec          34.8811
        Distance    2.25e+08  # method: T-F
        Radius     4.582e+04
        AbsMag        -20.59
        Axis    [  0.0275  -0.8702   0.4920]
        Angle    144.6821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7514"
}

Galaxy "NGC 7515:UGC 12418:MCG 2-59-8:ZWG 431.15"
{
        Type  "Sc"
        RA           23.2133
        Dec          12.6797
        Distance   1.865e+08  # method: V
        Radius     4.611e+04
        AbsMag        -20.59
        Axis    [ -0.3800  -0.8554  -0.3520]
        Angle    208.3482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7515"
}

Galaxy "NGC 7516:UGC 12420:MCG 3-59-10:ZWG 454.6"
{
        Type  "S0"
        RA           23.2142
        Dec          20.2489
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [ -0.3241  -0.9013   0.2873]
        Angle    147.8383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7516"
}

Galaxy "NGC 7517:MCG 0-59-8:ZWG 380.10:NPM 1"
{
        Type  "E0"
        RA           23.2203
        Dec          -2.1000
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [ -0.6509  -0.5606   0.5119]
        Angle    112.9469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7517"
}

Galaxy "NGC 7518:UGC 12422:MCG 1-59-12:MK 527"
{
        Type  "Sa"
        RA           23.2200
        Dec           6.3217
        Distance   1.439e+08  # method: V
        Radius     2.931e+04
        AbsMag        -19.02
        Axis    [ -0.2741  -0.8528   0.4446]
        Angle    147.9468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7518"
}

Galaxy "NGC 7519:UGC 12424:MCG 2-59-9:ZWG 431.16"
{
        Type  "Sb"
        RA           23.2197
        Dec          10.7717
        Distance   4.656e+08  # method: V
        Radius     8.803e+04
        AbsMag        -20.97
        Axis    [ -0.2875  -0.6626   0.6916]
        Angle    125.0715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7519"
}

Galaxy "NGC 7520:IC 5290:ESO 535-8:MCG 4-54-14"
{
        Type  "Sa"
        RA           23.2147
        Dec         -23.4689
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [ -0.4242  -0.9024  -0.0754]
        Angle    161.7424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7520"
}

Galaxy "NGC 7521:MCG 0-59-9:ZWG 380.11:ARAK 578"
{
        Type  "S0"
        RA           23.2264
        Dec          -1.7306
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [ -0.3665  -0.5926   0.7173]
        Angle    130.9086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7521"
}

Galaxy "NGC 7523:ZWG 431.18:KUG 2311+137"
{
        Type  "S0"
        RA           23.2261
        Dec          13.9867
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [  0.1517  -0.8467  -0.5101]
        Angle    184.8408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7523"
}

Galaxy "NGC 7524:MCG 0-59-10"
{
        Type  "Sa"
        RA           23.2294
        Dec          -1.7306
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [ -0.1479  -0.6002   0.7861]
        Angle    158.2132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7524"
}

Galaxy "NGC 7525-1:MK 316:ZWG 431.19:NPM 1"
{
        Type  "E0"
        RA           23.2278
        Dec          14.0214
        Distance   5.394e+08  # method: V
        Radius     4.707e+04
        AbsMag        -20.99
        Axis    [ -0.5283  -0.7613  -0.3758]
        Angle    228.2574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7525-1"
}

Galaxy "NGC 7525-2:MK 316:ZWG 431.19"
{
        Type  "S0"
        RA           23.2278
        Dec          14.0242
        Distance   5.394e+08  # method: V
        Radius     3.138e+04
        AbsMag        -19.89
        Axis    [ -0.0387  -0.8957  -0.4429]
        Angle    195.0521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7525-2"
}

Galaxy "NGC 7527:UGC 12428:MCG 4-54-31:ZWG 475.45"
{
        Type  "E0"
        RA           23.2281
        Dec          24.9028
        Distance   2.754e+08  # distance uncertain!
        Radius     5.208e+04
        AbsMag        -20.13
        Axis    [ -0.4397  -0.7223   0.5338]
        Angle     97.5666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7527"
}

Galaxy "NGC 7528"
{
        Type  "E0"
        RA           23.2389
        Dec          10.2311
        Distance   5.755e+08  # distance uncertain!
        Radius     3.348e+04
        AbsMag        -20.13
        Axis    [ -0.5580  -0.7570  -0.3400]
        Angle    218.8236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7528"
}

Galaxy "NGC 7529:UGC 12431:MCG 1-59-14:ZWG 406.24"
{
        Type  "Sc"
        RA           23.2342
        Dec           8.9922
        Distance   1.894e+08  # method: V
        Radius     2.479e+04
        AbsMag        -19.22
        Axis    [ -0.3971  -0.9170   0.0367]
        Angle    168.5814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7529"
}

Galaxy "NGC 7530:MCG 1-59-4:NPM 1"
{
        Type  "Sa"
        RA           23.2364
        Dec          -2.7789
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.2566  -0.8727   0.4154]
        Angle    156.1878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7530"
}

Galaxy "NGC 7531:ESO 291-10:MCG 7-47-25:IRAS 23120-4352"
{
        Type  "Sc"
        RA           23.2467
        Dec         -43.5989
        Distance   6.664e+07  # method: T-F
        Radius     4.361e+04
        AbsMag        -19.45
        Axis    [ -0.2961  -0.8155  -0.4972]
        Angle    148.0357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7531"
}

Galaxy "NGC 7532:MCG 1-59-5:MK 529:IRAS 23117-0300"
{
        Type  "SBa"
        RA           23.2394
        Dec          -2.7278
        Distance   1.446e+08  # method: V
        Radius     2.945e+04
        AbsMag        -18.53
        Axis    [ -0.2184  -0.7342   0.6428]
        Angle    153.7429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7532"
}

Galaxy "NGC 7533:ZWG 380.13:NPM 1"
{
        Type  "Sa"
        RA           23.2394
        Dec          -2.0333
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.1799  -0.8249   0.5360]
        Angle    158.3585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7533"
}

Galaxy "NGC 7534:MCG 1-59-6"
{
        Type  "Irr"
        RA           23.2406
        Dec          -2.6994
        Distance   2.754e+08  # distance uncertain!
        Radius     4.006e+04
        AbsMag        -20.13
        Axis    [ -0.2462  -0.8534  -0.4595]
        Angle    189.3394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7534"
}

Galaxy "NGC 7535:UGC 12438:MCG 2-59-10:ZWG 431.23"
{
        Type  "Sc"
        RA           23.2367
        Dec          13.5822
        Distance   1.924e+08  # method: V
        Radius     4.197e+04
        AbsMag        -19.55
        Axis    [ -0.5082  -0.7689  -0.3879]
        Angle    226.9487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7535"
}

Galaxy "NGC 7536:UGC 12437:MCG 2-59-11:ZWG 431.22"
{
        Type  "SBc"
        RA           23.2369
        Dec          13.4267
        Distance   2.053e+08  # method: T-F
        Radius     5.675e+04
        AbsMag        -19.89
        Axis    [  0.0162  -0.9964  -0.0828]
        Angle    177.7032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7536"
}

Galaxy "NGC 7537:UGC 12442:MCG 1-59-16:ZWG 406.28"
{
        Type  "Sc"
        RA           23.2428
        Dec           4.4989
        Distance   1.434e+08  # method: T-F
        Radius     4.379e+04
        AbsMag        -19.41
        Axis    [  0.0272  -0.9937   0.1086]
        Angle    169.9861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7537"
}

Galaxy "NGC 7539:UGC 12443:MCG 4-54-35:ZWG 475.48"
{
        Type  "S0"
        RA           23.2414
        Dec          23.6847
        Distance   2.584e+08  # method: V
        Radius     5.638e+04
        AbsMag        -20.89
        Axis    [ -0.1473  -0.7074   0.6913]
        Angle    123.5520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7539"
}

Galaxy "NGC 7540-1:ZWG 454.10"
{
        Type  "E0"
        RA           23.2433
        Dec          15.9503
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [ -0.5185  -0.6767   0.5228]
        Angle    103.9295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7540-1"
}

Galaxy "NGC 7540-2"
{
        Type  "E0"
        RA           23.2436
        Dec          15.9528
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [ -0.5244  -0.7698  -0.3639]
        Angle    229.4059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7540-2"
}

Galaxy "NGC 7541:NGC 7581:UGC 12447:MCG 1-59-17"
{
        Type  "SBc"
        RA           23.2453
        Dec           4.5344
        Distance   1.388e+08  # method: T-F
        Radius     7.066e+04
        AbsMag        -20.74
        Axis    [ -0.0632  -0.9532   0.2956]
        Angle    165.1153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7541"
}

Galaxy "NGC 7542:ZWG 431.25"
{
        Type  "S0"
        RA           23.2447
        Dec          10.6433
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.1816  -0.9020   0.3916]
        Angle    154.2126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7542"
}

Galaxy "NGC 7543:UGC 12450:MCG 5-54-52:ZWG 496.65"
{
        Type  "Sc"
        RA           23.2428
        Dec          28.3278
        Distance   2.986e+08  # method: V
        Radius     4.777e+04
        AbsMag        -20.81
        Axis    [ -0.1448  -0.8450   0.5148]
        Angle    133.8713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7543"
}

Galaxy "NGC 7544:NPM 1"
{
        Type  "S0"
        RA           23.2489
        Dec          -2.1989
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [ -0.0216  -0.9965  -0.0812]
        Angle    169.4676
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7544"
}

Galaxy "NGC 7545:ESO 347-4:MCG 7-47-26:AM 2312-384"
{
        Type  "SBb"
        RA           23.2589
        Dec         -38.5350
        Distance   8.358e+07  # method: V
        Radius     1.337e+04
        AbsMag        -18.24
        Axis    [ -0.5682  -0.8226   0.0201]
        Angle    157.2590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7545"
}

Galaxy "NGC 7546:MCG 1-59-7"
{
        Type  "SBc"
        RA           23.2514
        Dec          -2.3256
        Distance   3.544e+08  # method: V
        Radius      5.67e+04
        AbsMag        -19.28
        Axis    [ -0.3108  -0.8092  -0.4986]
        Angle    197.6982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7546"
}

Galaxy "NGC 7547:UGC 12453:MCG 3-59-13:ZWG 454.11"
{
        Type  "SBa"
        RA           23.2508
        Dec          18.9736
        Distance   2.025e+08  # method: V
        Radius      3.24e+04
        AbsMag        -19.36
        Axis    [ -0.0040  -0.9643   0.2647]
        Angle    165.6217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7547"
}

Galaxy "NGC 7548:UGC 12455:MCG 4-54-36:ZWG 475.50"
{
        Type  "S0"
        RA           23.2531
        Dec          25.2819
        Distance   3.464e+08  # method: V
        Radius     5.542e+04
        AbsMag        -20.73
        Axis    [ -0.1945  -0.9232  -0.3315]
        Angle    210.9046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7548"
}

Galaxy "NGC 7549:UGC 12457:MCG 3-59-14:ZWG 454.13"
{
        Type  "SBc"
        RA           23.2547
        Dec          19.0414
        Distance   1.964e+08  # method: V
        Radius     7.999e+04
        AbsMag           -20
        Axis    [  0.1328  -0.8759  -0.4639]
        Angle    191.0530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7549"
}

Galaxy "NGC 7550:UGC 12456:MCG 3-59-15:ZWG 454.12"
{
        Type  "S0"
        RA           23.2544
        Dec          18.9608
        Distance   2.152e+08  # method: V
        Radius     4.382e+04
        AbsMag         -20.9
        Axis    [ -0.2171  -0.6584   0.7207]
        Angle    118.7978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7550"
}

Galaxy "NGC 7551"
{
        Type  "S0"
        RA           23.2561
        Dec          15.9408
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [ -0.1468  -0.7667   0.6250]
        Angle    140.0641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7551"
}

Galaxy "NGC 7552:IC 5294:ESO 291-12:MCG 7-47-28"
{
        Type  "SBb"
        RA           23.2694
        Dec         -42.5847
        Distance   6.125e+07  # method: V
        Radius     3.029e+04
        AbsMag        -19.97
        Axis    [ -0.4315  -0.6443  -0.6314]
        Angle    168.5302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7552"
}

Galaxy "NGC 7553:ZWG 454.15:HCG 93:NPM 1"
{
        Type  "S0"
        RA           23.2592
        Dec          19.0486
        Distance    2.16e+08  # method: V
        Radius     1.257e+04
        AbsMag         -18.7
        Axis    [ -0.4939  -0.7934  -0.3558]
        Angle    230.1000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7553"
}

Galaxy "NGC 7554:ZW 99:NPM 1"
{
        Type  "E0"
        RA           23.2614
        Dec          -2.3781
        Distance   5.249e+08  # distance uncertain!
        Radius     3.053e+04
        AbsMag        -20.13
        Axis    [ -0.5720  -0.6762  -0.4642]
        Angle    219.4671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7554"
}

Galaxy "NGC 7556:MCG 1-59-9"
{
        Type  "S0"
        RA           23.2622
        Dec          -2.3814
        Distance   1.168e+08  # distance uncertain!
        Radius     4.247e+04
        AbsMag        -19.07
        Axis    [ -0.3021  -0.8509   0.4298]
        Angle    153.1435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7556"
}

Galaxy "NGC 7556A"
{
        Type  "E0"
        RA           23.2619
        Dec          -2.3858
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [ -0.6417  -0.7115  -0.2865]
        Angle    198.5776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7556A"
}

Galaxy "NGC 7557:MCG 1-59-21:ZWG 406.35:NPM 1"
{
        Type  "S0"
        RA           23.2608
        Dec           6.7089
        Distance   1.525e+08  # method: V
        Radius     1.331e+04
        AbsMag        -18.15
        Axis    [ -0.5296  -0.7341  -0.4250]
        Angle    223.3068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7557"
}

Galaxy "NGC 7558:MCG 3-59-16:HCG 93:NPM 1"
{
        Type  "S0"
        RA           23.2606
        Dec          18.9203
        Distance   3.831e+08  # method: V
        Radius     2.229e+04
        AbsMag        -19.45
        Axis    [ -0.4945  -0.7927  -0.3565]
        Angle    230.0436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7558"
}

Galaxy "NGC 7559-1:NGC 7559A:UGC 12463:MCG 2-59-14"
{
        Type  "S0"
        RA           23.2628
        Dec          13.2903
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [ -0.2816  -0.9595  -0.0041]
        Angle    174.8533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7559-1"
}

Galaxy "NGC 7559-2:NGC 7559B:MCG 2-59-13:ZWG 431.28"
{
        Type  "S0"
        RA           23.2628
        Dec          13.2969
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.1659  -0.9570  -0.2381]
        Angle    188.9224
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7559-2"
}

Galaxy "NGC 7562:UGC 12464:MCG 1-59-24:ZWG 406.39"
{
        Type  "E2"
        RA           23.2658
        Dec           6.6872
        Distance   1.868e+08  # method: S
        Radius     5.978e+04
        AbsMag        -21.19
        Axis    [ -0.6457  -0.7619   0.0504]
        Angle    161.7075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7562"
}

Galaxy "NGC 7562A:UGC 12467:MCG 1-59-25:PGC 70881"
{
        Type  "Irr"
        RA           23.2669
        Dec           6.6531
        Distance   4.366e+08  # distance uncertain!
        Radius     9.524e+04
        AbsMag        -20.13
        Axis    [  0.0579  -0.8396  -0.5400]
        Angle    183.5027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7562A"
}

Galaxy "NGC 7563:UGC 12465:MCG 2-59-15:ZWG 431.29"
{
        Type  "SBa"
        RA           23.2653
        Dec          13.1967
        Distance   1.793e+08  # method: V
        Radius     4.955e+04
        AbsMag         -19.8
        Axis    [ -0.0706  -0.7277   0.6823]
        Angle    149.1267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7563"
}

Galaxy "NGC 7566:MCG 1-59-10"
{
        Type  "Sa"
        RA           23.2769
        Dec          -2.3303
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.2204  -0.8971   0.3829]
        Angle    159.3083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7566"
}

Galaxy "NGC 7567:UGC 12468:MCG 3-59-19:ZWG 454.16"
{
        Type  "Sc"
        RA           23.2694
        Dec          15.8511
        Distance   1.803e+08  # method: V
        Radius      2.36e+04
        AbsMag        -18.21
        Axis    [  0.1376  -0.9861   0.0933]
        Angle    174.5314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7567"
}

Galaxy "NGC 7569:UGC 12472:MCG 1-59-26:ZWG 406.41"
{
        Type  "S0"
        RA           23.2789
        Dec           8.9067
        Distance   2.787e+08  # method: V
        Radius     4.053e+04
        AbsMag        -20.36
        Axis    [ -0.2468  -0.9564   0.1559]
        Angle    164.3644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7569"
}

Galaxy "NGC 7570:UGC 12473:MCG 2-59-18:ZWG 431.32"
{
        Type  "SBa"
        RA           23.2789
        Dec          13.4833
        Distance   1.966e+08  # method: V
        Radius     4.575e+04
        AbsMag           -20
        Axis    [ -0.0952  -0.9527  -0.2888]
        Angle    189.6150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7570"
}

Galaxy "NGC 7571:NGC 7597:MCG 3-59-32:ZWG 454.32"
{
        Type  "S0"
        RA           23.3083
        Dec          18.6883
        Distance   4.846e+08  # method: V
        Radius     7.048e+04
        AbsMag        -20.76
        Axis    [ -0.5001  -0.7891  -0.3568]
        Angle    230.3372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7571"
}

Galaxy "NGC 7572:MCG 3-59-23:ZWG 454.21"
{
        Type  "Sa"
        RA           23.2806
        Dec          18.4833
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.0759  -0.6663   0.7418]
        Angle    158.3868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7572"
}

Galaxy "NGC 7573:ESO 604-8:MCG 4-54-17:NPM 1"
{
        Type  "SBc"
        RA           23.2739
        Dec         -22.1539
        Distance   3.481e+08  # method: V
        Radius     6.583e+04
        AbsMag        -21.24
        Axis    [ -0.5229  -0.8027  -0.2867]
        Angle    172.6243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7573"
}

Galaxy "NGC 7574:NGC 7568:UGC 12469:ZWG 475.58"
{
        Type  "S0"
        RA           23.2733
        Dec          24.4972
        Distance   4.088e+08  # method: T-F
        Radius     5.351e+04
        AbsMag        -20.99
        Axis    [ -0.0841  -0.9081   0.4102]
        Angle    151.5802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7574"
}

Galaxy "NGC 7575:MCG 1-59-28:ZWG 406.44:IRAS 23148+0523"
{
        Type  "S0"
        RA           23.2889
        Dec           5.6614
        Distance   4.391e+08  # method: V
        Radius     3.193e+04
        AbsMag        -20.85
        Axis    [ -0.2102  -0.9309   0.2987]
        Angle    159.5368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7575"
}

Galaxy "NGC 7576:MCG 1-59-12:IRAS 23148-0500"
{
        Type  "Sa"
        RA           23.2894
        Dec          -4.7278
        Distance   1.457e+08  # method: V
        Radius     2.755e+04
        AbsMag        -19.45
        Axis    [ -0.3095  -0.6197   0.7212]
        Angle    143.1640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7576"
}

Galaxy "NGC 7577"
{
        Type  "S0"
        RA           23.2881
        Dec           7.3658
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.2168  -0.9630  -0.1602]
        Angle    180.9535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7577"
}

Galaxy "NGC 7578-1:NGC 7578A:UGC 12477:MCG 3-59-24"
{
        Type  "S0"
        RA           23.2864
        Dec          18.7014
        Distance   5.263e+08  # method: V
        Radius     6.124e+04
        AbsMag        -21.14
        Axis    [ -0.4978  -0.7903  -0.3572]
        Angle    230.1525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7578-1"
}

Galaxy "NGC 7578-2:NGC 7578B:UGC 12478:MCG 3-59-25"
{
        Type  "E1"
        RA           23.2869
        Dec          18.7083
        Distance   5.301e+08  # method: V
        Radius     3.084e+04
        AbsMag        -21.15
        Axis    [ -0.5206  -0.7804  -0.3463]
        Angle    231.2163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7578-2"
}

Galaxy "NGC 7579:MCG 1-59-31:ZWG 406.46:NPM 1"
{
        Type  "E0"
        RA           23.2939
        Dec           9.4339
        Distance   5.414e+08  # method: V
        Radius     3.937e+04
        AbsMag           -21
        Axis    [ -0.5658  -0.7502  -0.3421]
        Angle    218.8881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7579"
}

Galaxy "NGC 7580:UGC 12481:MCG 2-59-19:MK 318"
{
        Type  "S0"
        RA           23.2933
        Dec          14.0014
        Distance   1.848e+08  # method: V
        Radius     2.151e+04
        AbsMag        -19.47
        Axis    [ -0.2285  -0.9596  -0.1640]
        Angle    186.7495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7580"
}

Galaxy "NGC 7582:ESO 291-16:MCG 7-47-29:AM 2315-423"
{
        Type  "SBb"
        RA           23.3064
        Dec         -42.3697
        Distance   6.043e+07  # method: V
        Radius     4.395e+04
        AbsMag        -20.04
        Axis    [ -0.4893  -0.5965   0.6363]
        Angle    172.2705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7582"
}

Galaxy "NGC 7583:NGC 7605:MCG 1-59-34:ZWG 406.47"
{
        Type  "S0"
        RA           23.2978
        Dec           7.3794
        Distance   5.549e+08  # method: V
        Radius      5.65e+04
        AbsMag        -21.05
        Axis    [ -0.5317  -0.7353  -0.4202]
        Angle    223.9683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7583"
}

Galaxy "NGC 7584:MCG 1-59-35:ZWG 406.49:ARAK 580"
{
        Type  "S0"
        RA           23.2981
        Dec           9.4336
        Distance   5.686e+08  # method: V
        Radius     3.308e+04
        AbsMag        -20.81
        Axis    [ -0.5262  -0.7454  -0.4092]
        Angle    225.1351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7584"
}

Galaxy "NGC 7585:MCG 1-59-15:ARP 223"
{
        Type  "Sa"
        RA           23.3003
        Dec          -4.6503
        Distance   1.401e+08  # method: V
        Radius     4.687e+04
        AbsMag        -20.86
        Axis    [ -0.4905  -0.8356   0.2474]
        Angle    152.6079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7585"
}

Galaxy "NGC 7586:NPM 1"
{
        Type  "S0"
        RA           23.2986
        Dec           8.5844
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.2446  -0.6895   0.6817]
        Angle    135.2434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7586"
}

Galaxy "NGC 7587:UGC 12484:MCG 1-59-37:ZWG 406.52"
{
        Type  "SBb"
        RA           23.2997
        Dec           9.6803
        Distance   3.877e+08  # method: V
        Radius     6.766e+04
        AbsMag        -20.47
        Axis    [  0.0322  -0.8800   0.4740]
        Angle    165.9990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7587"
}

Galaxy "NGC 7588:MCG 3-59-31:ZWG 454.30:ARAK 581"
{
        Type  "S0"
        RA           23.2992
        Dec          18.7528
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [ -0.1403  -0.9569   0.2544]
        Angle    161.7764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7588"
}

Galaxy "NGC 7589:MCG 0-59-19:ZWG 380.24:NPM 1"
{
        Type  "Sa"
        RA           23.3042
        Dec           0.2617
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.2794  -0.9225   0.2662]
        Angle    159.5569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7589"
}

Galaxy "NGC 7590:ESO 347-33:MCG 7-47-30:IRAS 23161-4230"
{
        Type  "Sc"
        RA           23.3150
        Dec         -42.2392
        Distance   9.314e+07  # method: T-F
        Radius     3.522e+04
        AbsMag        -20.18
        Axis    [ -0.3647  -0.8726  -0.3249]
        Angle    151.4234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7590"
}

Galaxy "NGC 7591:UGC 12486:MCG 1-59-38:ZWG 406.53"
{
        Type  "SBc"
        RA           23.3044
        Dec           6.5861
        Distance   2.448e+08  # method: T-F
        Radius     6.765e+04
        AbsMag        -20.58
        Axis    [ -0.1003  -0.7781   0.6201]
        Angle    156.0970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7591"
}

Galaxy "NGC 7592:MCG 1-59-17:MK 928:VV 731"
{
        Type  "Sa"
        RA           23.3061
        Dec          -4.4164
        Distance   3.154e+08  # method: V
        Radius     5.046e+04
        AbsMag        -20.53
        Axis    [ -0.4197  -0.8996  -0.1204]
        Angle    174.1318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7592"
}

Galaxy "NGC 7593:UGC 12483:MCG 2-59-20:ZWG 431.35"
{
        Type  "Sc"
        RA           23.2989
        Dec          11.3489
        Distance   1.856e+08  # method: T-F
        Radius       2.7e+04
        AbsMag        -19.48
        Axis    [ -0.1608  -0.9418   0.2950]
        Angle    160.3924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7593"
}

Galaxy "NGC 7594:IC 1478:UGC 12485:MCG 2-59-23"
{
        Type  "Sb"
        RA           23.3036
        Dec          10.2978
        Distance   4.385e+08  # method: T-F
        Radius     8.928e+04
        AbsMag        -21.04
        Axis    [ -0.1681  -0.9414  -0.2924]
        Angle    189.7367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7594"
}

Galaxy "NGC 7595"
{
        Type  "E0"
        RA           23.3083
        Dec           9.9322
        Distance   5.249e+08  # distance uncertain!
        Radius     3.817e+04
        AbsMag        -20.13
        Axis    [ -0.5477  -0.7366  -0.3968]
        Angle    226.7017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7595"
}

Galaxy "NGC 7596:IC 1477:MCG 1-59-11:IRAS 23145-0711"
{
        Type  "S0"
        RA           23.2867
        Dec          -6.9117
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.1924  -0.9339  -0.3013]
        Angle    174.7080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7596"
}

Galaxy "NGC 7597:NGC 7571:MCG 3-59-32:ZWG 454.32"
{
        Type  "S0"
        RA           23.3083
        Dec          18.6883
        Distance   4.846e+08  # method: V
        Radius     7.048e+04
        AbsMag        -20.76
        Axis    [ -0.5001  -0.7891  -0.3568]
        Angle    230.3372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7597"
}

Galaxy "NGC 7598:MCG 3-59-33:ZWG 454.33:ARAK 582"
{
        Type  "Irr"
        RA           23.3092
        Dec          18.7497
        Distance   5.249e+08  # distance uncertain!
        Radius      2.29e+04
        AbsMag        -20.13
        Axis    [ -0.1382  -0.9313   0.3371]
        Angle    156.8184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7598"
}

Galaxy "NGC 7599:IC 5308:ESO 347-34:MCG 7-47-33"
{
        Type  "SBc"
        RA           23.3222
        Dec         -42.2581
        Distance   7.031e+07  # method: T-F
        Radius     4.499e+04
        AbsMag        -19.47
        Axis    [ -0.3796  -0.9150  -0.1370]
        Angle    153.3722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7599"
}

Galaxy "NGC 7600:MCG 1-59-19"
{
        Type  "S0"
        RA           23.3147
        Dec          -7.5800
        Distance   1.429e+08  # method: V
        Radius     5.195e+04
        AbsMag        -20.31
        Axis    [ -0.1817  -0.9833   0.0071]
        Angle    167.3921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7600"
}

Galaxy "NGC 7601:UGC 12487:MCG 1-59-39:ZWG 406.56"
{
        Type  "SBc"
        RA           23.3131
        Dec           9.2336
        Distance   3.485e+08  # method: V
        Radius     5.576e+04
        AbsMag        -20.54
        Axis    [ -0.3348  -0.9198   0.2044]
        Angle    159.1895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7601"
}

Galaxy "NGC 7602:MCG 3-59-34:ZWG 454.34:NPM 1"
{
        Type  "Sa"
        RA           23.3119
        Dec          18.6989
        Distance     5.1e+08  # method: V
        Radius     4.451e+04
        AbsMag        -20.67
        Axis    [ -0.5004  -0.7889  -0.3566]
        Angle    230.3744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7602"
}

Galaxy "NGC 7603:UGC 12493:MCG 0-59-21:MK 530"
{
        Type  "Sb"
        RA           23.3156
        Dec           0.2442
        Distance   3.847e+08  # method: V
        Radius     8.952e+04
        AbsMag        -21.26
        Axis    [ -0.2374  -0.6402   0.7306]
        Angle    145.1360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7603"
}

Galaxy "NGC 7604:MCG 1-59-33:ZWG 406.48"
{
        Type  "S0"
        RA           23.2975
        Dec           7.4300
        Distance    1.55e+08  # method: V
        Radius          6764
        AbsMag        -17.88
        Axis    [ -0.2370  -0.9558   0.1737]
        Angle    163.9897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7604"
}

Galaxy "NGC 7606:MCG 2-59-12:IRAS 23164-0845"
{
        Type  "Sb"
        RA           23.3178
        Dec          -8.4864
        Distance   1.154e+08  # method: T-F
        Radius     9.062e+04
        AbsMag        -21.14
        Axis    [ -0.2104  -0.7607   0.6141]
        Angle    162.0065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7606"
}

Galaxy "NGC 7608:UGC 12500:MCG 1-59-44:ZWG 406.62"
{
        Type  "Sc"
        RA           23.3208
        Dec           8.3503
        Distance   1.427e+08  # method: V
        Radius     3.114e+04
        AbsMag        -18.21
        Axis    [  0.0551  -0.9207  -0.3865]
        Angle    181.9434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7608"
}

Galaxy "NGC 7609:MCG 1-59-47:ZWG 406.65:VV 20"
{
        Type  "S0"
        RA           23.3250
        Dec           9.5086
        Distance   5.221e+08  # method: V
        Radius     9.872e+04
        AbsMag        -20.92
        Axis    [ -0.3343  -0.8071   0.4867]
        Angle    139.3790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7609"
}

Galaxy "NGC 7610:NGC 7616:UGC 12511:MCG 2-59-25"
{
        Type  "SBc"
        RA           23.3281
        Dec          10.1844
        Distance   1.447e+08  # method: V
        Radius     5.263e+04
        AbsMag        -19.83
        Axis    [ -0.2645  -0.9487  -0.1731]
        Angle    185.4861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7610"
}

Galaxy "NGC 7611:UGC 12509:MCG 1-59-49:ZWG 406.66"
{
        Type  "SBa"
        RA           23.3267
        Dec           8.0636
        Distance   1.345e+08  # method: V
        Radius     2.935e+04
        AbsMag        -19.58
        Axis    [ -0.1102  -0.8111   0.5744]
        Angle    155.2107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7611"
}

Galaxy "NGC 7612:UGC 12512:MCG 1-59-50:ZWG 406.68"
{
        Type  "S0"
        RA           23.3289
        Dec           8.5769
        Distance   1.291e+08  # method: V
        Radius     3.004e+04
        AbsMag        -19.29
        Axis    [ -0.0707  -0.8549  -0.5140]
        Angle    194.3726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7612"
}

Galaxy "NGC 7615:MCG 1-59-51:ZWG 406.70"
{
        Type  "Sb"
        RA           23.3317
        Dec           8.3994
        Distance   1.863e+08  # method: V
        Radius     2.439e+04
        AbsMag        -18.58
        Axis    [ -0.0946  -0.7402   0.6656]
        Angle    153.6816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7615"
}

Galaxy "NGC 7617:MCG 1-59-51A:ZWG 406.72:NPM 1"
{
        Type  "S0"
        RA           23.3356
        Dec           8.1661
        Distance    1.55e+08  # method: T-F
        Radius     2.028e+04
        AbsMag        -18.58
        Axis    [ -0.2897  -0.9360  -0.2001]
        Angle    186.3632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7617"
}

Galaxy "NGC 7618:UGC 12516:MCG 7-47-13:ZWG 532.14"
{
        Type  "E0"
        RA           23.3297
        Dec          42.8528
        Distance   2.241e+08  # method: V
        Radius     3.911e+04
        AbsMag        -20.08
        Axis    [ -0.4336  -0.8864  -0.1620]
        Angle    238.8307
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7618"
}

Galaxy "NGC 7619:UGC 12523:MCG 1-59-52:ZWG 406.73"
{
        Type  "E0"
        RA           23.3372
        Dec           8.2069
        Distance   1.728e+08  # method: S
        Radius     6.282e+04
        AbsMag        -21.52
        Axis    [ -0.6030  -0.7629  -0.2332]
        Angle    203.5611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7619"
}

Galaxy "NGC 7620:UGC 12520:MK 321:ZWG 476.8"
{
        Type  "Sc"
        RA           23.3347
        Dec          24.2208
        Distance   4.186e+08  # method: V
        Radius     6.698e+04
        AbsMag        -21.94
        Axis    [ -0.4846  -0.8129  -0.3231]
        Angle    233.5272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7620"
}

Galaxy "NGC 7621:MCG 1-59-55:ZWG 406.74"
{
        Type  "S0"
        RA           23.3400
        Dec           8.3667
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.0282  -0.5700   0.8211]
        Angle    159.7801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7621"
}

Galaxy "NGC 7622:ESO 148-8:AM 2318-622"
{
        Type  "S0"
        RA           23.3606
        Dec         -62.1175
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.5412  -0.8309  -0.1295]
        Angle    147.1151
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7622"
}

Galaxy "NGC 7623:UGC 12526:MCG 1-59-56:ZWG 406.75"
{
        Type  "S0"
        RA           23.3414
        Dec           8.3964
        Distance   1.514e+08  # method: V
        Radius     2.863e+04
        AbsMag        -19.53
        Axis    [ -0.2050  -0.6597   0.7230]
        Angle    137.9636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7623"
}

Galaxy "NGC 7624:UGC 12527:MCG 4-55-4:MK 323"
{
        Type  "SBc"
        RA           23.3394
        Dec          27.3147
        Distance   2.219e+08  # method: T-F
        Radius     3.228e+04
        AbsMag        -20.36
        Axis    [ -0.1026  -0.9656  -0.2389]
        Angle    201.4280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7624"
}

Galaxy "NGC 7625:UGC 12529:MCG 3-59-38:ZWG 454.43"
{
        Type  "Sa"
        RA           23.3417
        Dec          17.2267
        Distance   5.749e+07  # method: V
        Radius     1.338e+04
        AbsMag        -18.43
        Axis    [ -0.3221  -0.9458  -0.0424]
        Angle    181.4964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7625"
}

Galaxy "NGC 7626:UGC 12531:MCG 1-59-57:ZWG 406.76"
{
        Type  "E0"
        RA           23.3450
        Dec           8.2169
        Distance    1.55e+08  # method: T-F
        Radius      5.86e+04
        AbsMag        -21.18
        Axis    [ -0.5729  -0.7400  -0.3523]
        Angle    219.4378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7626"
}

Galaxy "NGC 7627:NGC 7641:UGC 12556:MCG 2-59-29"
{
        Type  "Sa"
        RA           23.3750
        Dec          11.8936
        Distance   3.398e+08  # method: V
        Radius     8.402e+04
        AbsMag        -20.19
        Axis    [  0.0180  -0.8379   0.5456]
        Angle    163.4557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7627"
}

Galaxy "NGC 7628:UGC 12534:MCG 4-55-5:ZWG 476.14"
{
        Type  "E0"
        RA           23.3486
        Dec          25.8986
        Distance    1.74e+08  # method: V
        Radius     2.785e+04
        AbsMag        -19.84
        Axis    [ -0.4942  -0.8297   0.2594]
        Angle    136.7741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7628"
}

Galaxy "NGC 7629:MCG 0-59-31:ZWG 380.40:NPM 1"
{
        Type  "S0"
        RA           23.3553
        Dec           1.4036
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.2887  -0.5367   0.7929]
        Angle    130.8771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7629"
}

Galaxy "NGC 7630:UGC 12540:MCG 2-59-27:ZWG 431.44"
{
        Type  "S0"
        RA           23.3544
        Dec          11.3975
        Distance   5.514e+08  # method: V
        Radius     8.822e+04
        AbsMag        -20.84
        Axis    [ -0.0321  -0.6780   0.7343]
        Angle    155.3940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7630"
}

Galaxy "NGC 7631:UGC 12539:MCG 1-59-60:ZWG 406.83"
{
        Type  "Sb"
        RA           23.3572
        Dec           8.2175
        Distance   1.902e+08  # method: T-F
        Radius     4.702e+04
        AbsMag        -19.93
        Axis    [ -0.0676  -0.9924   0.1030]
        Angle    171.2272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7631"
}

Galaxy "NGC 7632:IC 5313:ESO 291-21:MCG 7-47-35"
{
        Type  "S0"
        RA           23.3667
        Dec         -42.4803
        Distance   5.993e+07  # method: V
        Radius     2.092e+04
        AbsMag        -18.22
        Axis    [ -0.5376  -0.8311   0.1426]
        Angle    159.5642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7632"
}

Galaxy "NGC 7633:ESO 77-15"
{
        Type  "SBa"
        RA           23.3842
        Dec         -67.6536
        Distance   1.652e+08  # method: V
        Radius     5.527e+04
        AbsMag        -20.02
        Axis    [ -0.8226  -0.3416   0.4547]
        Angle    161.5337
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7633"
}

Galaxy "NGC 7634:UGC 12542:MCG 1-59-62:ZWG 406.85"
{
        Type  "S0"
        RA           23.3614
        Dec           8.8875
        Distance   1.298e+08  # method: V
        Radius     2.265e+04
        AbsMag         -19.4
        Axis    [ -0.2852  -0.9357   0.2079]
        Angle    161.6493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7634"
}

Galaxy "NGC 7636:ESO 470-2:MCG 5-55-5"
{
        Type  "S0"
        RA           23.3758
        Dec         -29.2808
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [ -0.4229  -0.8226  -0.3801]
        Angle    167.2394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7636"
}

Galaxy "NGC 7637:ESO 12-1:AM 2322-821:IRAS 23226-8211"
{
        Type  "Sc"
        RA           23.4411
        Dec         -81.9111
        Distance   1.634e+08  # method: V
        Radius     4.992e+04
        AbsMag         -20.3
        Axis    [ -0.8013  -0.3860  -0.4570]
        Angle    149.3451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7637"
}

Galaxy "NGC 7638:IC 1483:MCG 2-59-30:ZWG 431.46"
{
        Type  "S0"
        RA           23.3758
        Dec          11.3294
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.5289  -0.7503  -0.3966]
        Angle    226.8217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7638"
}

Galaxy "NGC 7639:IC 1485:MCG 2-59-32:ZWG 431.50"
{
        Type  "S0"
        RA           23.3800
        Dec          11.3733
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [ -0.2907  -0.8635   0.4122]
        Angle    147.6129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7639"
}

Galaxy "NGC 7640:UGC 12554:MCG 7-48-2:ZWG 532.17"
{
        Type  "SBc"
        RA           23.3683
        Dec          40.8450
        Distance    3.13e+07  # method: T-F
        Radius      4.78e+04
        AbsMag        -18.11
        Axis    [  0.2829  -0.5907   0.7557]
        Angle    153.9021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7640"
}

Galaxy "NGC 7642:UGC 12560:MCG 0-59-35:ZWG 380.48"
{
        Type  "Sa"
        RA           23.3814
        Dec           1.4428
        Distance   3.895e+08  # method: V
        Radius     3.399e+04
        AbsMag        -20.78
        Axis    [ -0.3157  -0.5617   0.7647]
        Angle    129.4591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7642"
}

Galaxy "NGC 7643:NGC 7644:UGC 12563:MCG 2-59-33"
{
        Type  "S0"
        RA           23.3806
        Dec          11.9886
        Distance   1.595e+08  # method: V
        Radius     3.247e+04
        AbsMag        -19.35
        Axis    [ -0.0819  -0.9812  -0.1748]
        Angle    183.4698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7643"
}

Galaxy "NGC 7645:ESO 470-3:MCG 5-55-7"
{
        Type  "SBc"
        RA           23.3964
        Dec         -29.3881
        Distance   2.979e+08  # method: V
        Radius     6.498e+04
        AbsMag           -21
        Axis    [ -0.5241  -0.4949   0.6932]
        Angle    149.7112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7645"
}

Galaxy "NGC 7646:IC 5318:MCG 2-59-15:IRAS 23215-1208"
{
        Type  "Sc"
        RA           23.4017
        Dec         -11.8603
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [ -0.3849  -0.7643   0.5174]
        Angle    153.2734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7646"
}

Galaxy "NGC 7647:UGC 12576:MCG 3-59-55:ZWG 454.63"
{
        Type  "E0"
        RA           23.3992
        Dec          16.7778
        Distance    3.02e+08  # distance uncertain!
        Radius      6.15e+04
        AbsMag        -20.13
        Axis    [ -0.5544  -0.7854  -0.2754]
        Angle    220.2940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7647"
}

Galaxy "NGC 7648:IC 1486:UGC 12575:MCG 1-59-72"
{
        Type  "S0"
        RA           23.3983
        Dec           9.6683
        Distance    1.45e+08  # method: V
        Radius     3.374e+04
        AbsMag        -19.44
        Axis    [ -0.1926  -0.9708   0.1429]
        Angle    168.3361
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7648"
}

Galaxy "NGC 7649:IC 1487:UGC 12579:MCG 2-59-35"
{
        Type  "E0"
        RA           23.4056
        Dec          14.6469
        Distance   5.508e+08  # method: V
        Radius     1.041e+05
        AbsMag        -21.24
        Axis    [ -0.5958  -0.8007   0.0628]
        Angle    166.7772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7649"
}

Galaxy "NGC 7650:ESO 148-10:AM 2322-580:IRAS 23225-5803"
{
        Type  "SBc"
        RA           23.4222
        Dec         -57.7911
        Distance   1.459e+08  # method: V
        Radius      2.97e+04
        AbsMag        -20.05
        Axis    [ -0.7711  -0.5204   0.3670]
        Angle    159.8912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7650"
}

Galaxy "NGC 7651-1:MCG 2-59-36:ZWG 431.55"
{
        Type  "S0"
        RA           23.4069
        Dec          13.9722
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.1938  -0.9107  -0.3649]
        Angle    200.3117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7651-1"
}

Galaxy "NGC 7651-2:MCG 2-59-36:ZWG 431.55"
{
        Type  "S0"
        RA           23.4069
        Dec          13.9672
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.0631  -0.9420  -0.3296]
        Angle    191.7583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7651-2"
}

Galaxy "NGC 7652:ESO 148-11:AM 2322-580"
{
        Type  "Sa"
        RA           23.4269
        Dec         -57.8875
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.6920  -0.6849   0.2280]
        Angle    161.2604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7652"
}

Galaxy "NGC 7653:UGC 12586:MCG 2-59-38:ZWG 431.58"
{
        Type  "Sb"
        RA           23.4136
        Dec          15.2756
        Distance   1.771e+08  # method: V
        Radius     4.122e+04
        AbsMag        -20.27
        Axis    [ -0.3797  -0.8169   0.4341]
        Angle    135.6901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7653"
}

Galaxy "NGC 7655:ESO 77-18:AM 2325-680"
{
        Type  "S0"
        RA           23.4458
        Dec         -68.0275
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [ -0.8044  -0.5894  -0.0742]
        Angle    153.3836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7655"
}

Galaxy "NGC 7656:ESO 605-5:MCG 3-59-8:VV 669"
{
        Type  "S0"
        RA           23.4086
        Dec         -19.0592
        Distance   3.307e+08  # method: V
        Radius     5.771e+04
        AbsMag        -20.63
        Axis    [ -0.5932  -0.7769  -0.2110]
        Angle    174.4016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7656"
}

Galaxy "NGC 7657:ESO 148-12"
{
        Type  "SBc"
        RA           23.4464
        Dec         -57.8053
        Distance   1.348e+08  # method: V
        Radius     2.745e+04
        AbsMag        -18.38
        Axis    [ -0.5446  -0.7989   0.2551]
        Angle    166.8149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7657"
}

Galaxy "NGC 7658-1:NGC 7658A:ESO 347-15:MCG 7-48-2"
{
        Type  "S0"
        RA           23.4400
        Dec         -39.2158
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.4274  -0.7400   0.5194]
        Angle    173.4257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7658-1"
}

Galaxy "NGC 7658-2:NGC 7658B:ESO 347-16:MCG 7-48-3"
{
        Type  "S0"
        RA           23.4400
        Dec         -39.2269
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.4527  -0.7683   0.4526]
        Angle    169.7680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7658-2"
}

Galaxy "NGC 7659:UGC 12595:MCG 2-59-40:ZWG 431.64"
{
        Type  "Sa"
        RA           23.4319
        Dec          14.2097
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.0023  -0.9313   0.3642]
        Angle    166.0875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7659"
}

Galaxy "NGC 7660:UGC 12594:MCG 4-55-12:ZWG 476.35"
{
        Type  "E0"
        RA           23.4300
        Dec          27.0297
        Distance   2.427e+08  # method: V
        Radius     4.942e+04
        AbsMag        -20.66
        Axis    [ -0.5181  -0.8478  -0.1134]
        Angle    207.6656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7660"
}

Galaxy "NGC 7661:ESO 110-11"
{
        Type  "SBc"
        RA           23.4539
        Dec         -65.2717
        Distance   1.334e+08  # method: T-F
        Radius     3.492e+04
        AbsMag        -18.96
        Axis    [ -0.5987  -0.6480  -0.4707]
        Angle    146.4272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7661"
}

Galaxy "NGC 7664:UGC 12598:MCG 4-55-13:ZWG 476.38"
{
        Type  "Sc"
        RA           23.4442
        Dec          25.0803
        Distance   1.966e+08  # method: T-F
        Radius     7.435e+04
        AbsMag         -20.5
        Axis    [ -0.0317  -0.9794   0.1996]
        Angle    170.7400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7664"
}

Galaxy "NGC 7665:MCG 2-59-19:IRAS 23246-0939"
{
        Type  "Irr"
        RA           23.4539
        Dec          -9.3864
        Distance   2.089e+08  # distance uncertain!
        Radius     2.127e+04
        AbsMag        -20.13
        Axis    [ -0.5864  -0.6403  -0.4961]
        Angle    215.0396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7665"
}

Galaxy "NGC 7667:UGC 12578:MCG 0-59-38:ZWG 380.50"
{
        Type  "Irr"
        RA           23.4064
        Dec          -0.1086
        Distance    1.06e+08  # method: V
        Radius     2.468e+04
        AbsMag        -17.86
        Axis    [ -0.3169  -0.9155   0.2478]
        Angle    160.5574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7667"
}

Galaxy "NGC 7671:UGC 12602:MCG 2-59-44:ZWG 431.69"
{
        Type  "S0"
        RA           23.4553
        Dec          12.4678
        Distance   1.708e+08  # method: V
        Radius     3.478e+04
        AbsMag         -19.8
        Axis    [ -0.1240  -0.8208   0.5576]
        Angle    152.0978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7671"
}

Galaxy "NGC 7672:MCG 2-59-45:ZWG 431.70:KAZ 568"
{
        Type  "Sb"
        RA           23.4586
        Dec          12.3850
        Distance   1.703e+08  # method: V
        Radius     1.982e+04
        AbsMag        -18.89
        Axis    [ -0.2463  -0.9411  -0.2317]
        Angle    192.3664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7672"
}

Galaxy "NGC 7673:UGC 12607:MCG 4-55-14:MK 325"
{
        Type  "Sc"
        RA           23.4614
        Dec          23.5892
        Distance   1.385e+08  # method: V
        Radius     2.618e+04
        AbsMag        -19.94
        Axis    [ -0.3361  -0.9411  -0.0381]
        Angle    187.5357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7673"
}

Galaxy "NGC 7674:UGC 12608:MCG 1-59-80:MK 533"
{
        Type  "SBc"
        RA           23.4656
        Dec           8.7786
        Distance   3.808e+08  # method: V
        Radius     6.092e+04
        AbsMag        -21.44
        Axis    [ -0.3704  -0.7269   0.5783]
        Angle    130.3971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7674"
}

Galaxy "NGC 7674A:MCG 1-59-81:ZWG 406.114:HCG 96"
{
        Type  "S0"
        RA           23.4661
        Dec           8.7828
        Distance   3.777e+08  # method: V
        Radius     1.648e+04
        AbsMag        -20.12
        Axis    [ -0.2143  -0.9528  -0.2151]
        Angle    187.1226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7674A"
}

Galaxy "NGC 7675:MCG 1-59-83:HCG 96B:NPM 1"
{
        Type  "S0"
        RA           23.4681
        Dec           8.7692
        Distance   3.741e+08  # method: V
        Radius     3.264e+04
        AbsMag         -19.1
        Axis    [ -0.2031  -0.9217  -0.3306]
        Angle    193.2120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7675"
}

Galaxy "NGC 7676:ESO 148-16:AM 2326-595"
{
        Type  "S0"
        RA           23.4836
        Dec         -59.7167
        Distance   1.505e+08  # method: V
        Radius     3.502e+04
        AbsMag        -20.62
        Axis    [ -0.6840  -0.7272   0.0577]
        Angle    156.9580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7676"
}

Galaxy "NGC 7677:UGC 12610:MCG 4-55-15:MK 326"
{
        Type  "SBc"
        RA           23.4683
        Dec          23.5314
        Distance   2.029e+08  # method: T-F
        Radius     4.721e+04
        AbsMag        -20.07
        Axis    [ -0.0865  -0.9715  -0.2209]
        Angle    196.8565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7677"
}

Galaxy "NGC 7678:UGC 12614:MCG 4-55-17:ZWG 476.45"
{
        Type  "SBc"
        RA           23.4742
        Dec          22.4211
        Distance   1.423e+08  # method: V
        Radius     5.174e+04
        AbsMag         -20.7
        Axis    [ -0.1259  -0.8893  -0.4396]
        Angle    211.6655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7678"
}

Galaxy "NGC 7679:UGC 12618:MCG 0-59-46:MK 534"
{
        Type  "S0"
        RA           23.4794
        Dec           3.5108
        Distance   2.164e+08  # method: V
        Radius     5.352e+04
        AbsMag        -20.61
        Axis    [ -0.1865  -0.9647   0.1859]
        Angle    167.7667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7679"
}

Galaxy "NGC 7680-1:UGC 12616:MCG 5-55-23:ZWG 497.25"
{
        Type  "S0"
        RA           23.4764
        Dec          32.4156
        Distance   2.147e+08  # method: V
        Radius     5.933e+04
        AbsMag        -20.59
        Axis    [ -0.4689  -0.8412  -0.2694]
        Angle    239.1481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7680-1"
}

Galaxy "NGC 7680-2:NPM 1:ZW 151"
{
        Type  "E0"
        RA           23.4753
        Dec          32.4228
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [ -0.4925  -0.8320  -0.2555]
        Angle    239.9281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7680-2"
}

Galaxy "NGC 7681:UGC 12620:MCG 3-59-63:ZWG 454.74"
{
        Type  "S0"
        RA           23.4817
        Dec          17.3094
        Distance   2.956e+08  # method: V
        Radius      7.74e+04
        AbsMag        -19.99
        Axis    [ -0.2861  -0.9438  -0.1655]
        Angle    193.6005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7681"
}

Galaxy "NGC 7682:UGC 12622:MCG 0-59-47:ZWG 380.62"
{
        Type  "SBb"
        RA           23.4842
        Dec           3.5339
        Distance   2.157e+08  # method: V
        Radius     3.765e+04
        AbsMag           -20
        Axis    [ -0.4114  -0.6853   0.6009]
        Angle    130.2989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7682"
}

Galaxy "NGC 7683:UGC 12623:MCG 2-59-48:ZWG 431.74"
{
        Type  "S0"
        RA           23.4842
        Dec          11.4453
        Distance   1.168e+08  # distance uncertain!
        Radius     3.228e+04
        AbsMag        -19.07
        Axis    [ -0.0797  -0.8094   0.5818]
        Angle    156.2479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7683"
}

Galaxy "NGC 7684:UGC 12637:MCG 0-59-50:ZWG 380.65"
{
        Type  "Sa"
        RA           23.5089
        Dec           0.0814
        Distance   2.163e+08  # method: V
        Radius     4.718e+04
        AbsMag        -19.41
        Axis    [ -0.0124  -0.9214  -0.3885]
        Angle    177.8213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7684"
}

Galaxy "NGC 7685:UGC 12638:MCG 1-59-87:ZWG 406.121"
{
        Type  "SBc"
        RA           23.5092
        Dec           3.9017
        Distance   2.393e+08  # method: V
        Radius     6.614e+04
        AbsMag        -20.43
        Axis    [ -0.2734  -0.6096   0.7441]
        Angle    134.5152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7685"
}

Galaxy "NGC 7687:MCG 0-59-51:ZWG 380.66:NPM 1"
{
        Type  "S0"
        RA           23.5150
        Dec           3.5472
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.3460  -0.9369   0.0499]
        Angle    171.3595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7687"
}

Galaxy "NGC 7688:ZWG 455.4:ZWG 454.80:KAZ 340"
{
        Type  "S0"
        RA           23.5181
        Dec          21.4119
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.1820  -0.9576   0.2232]
        Angle    165.6746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7688"
}

Galaxy "NGC 7689:ESO 192-7:IRAS 23305-5422"
{
        Type  "SBc"
        RA           23.5544
        Dec         -54.0942
        Distance    9.01e+07  # method: T-F
        Radius     3.669e+04
        AbsMag        -20.01
        Axis    [ -0.6826  -0.5628   0.4663]
        Angle    165.5974
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7689"
}

Galaxy "NGC 7690:ESO 240-6:FAIR 1049:IRAS 23303-5158"
{
        Type  "Sb"
        RA           23.5506
        Dec         -51.6983
        Distance   9.137e+07  # method: T-F
        Radius     2.791e+04
        AbsMag        -19.24
        Axis    [ -0.5436  -0.7005   0.4624]
        Angle    174.4865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7690"
}

Galaxy "NGC 7691:UGC 12654:MCG 3-60-1:ZWG 455.9"
{
        Type  "SBc"
        RA           23.5400
        Dec          15.8489
        Distance   1.679e+08  # method: V
        Radius     5.129e+04
        AbsMag        -19.76
        Axis    [ -0.1553  -0.6193   0.7696]
        Angle    129.7059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7691"
}

Galaxy "NGC 7692:MCG 1-60-3:IRAS 23302-0552"
{
        Type  "Irr"
        RA           23.5461
        Dec          -5.5961
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [ -0.4428  -0.8653   0.2350]
        Angle    159.6020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7692"
}

Galaxy "NGC 7693:MCG 0-60-3:ZWG 381.6:NPM 1"
{
        Type  "Sa"
        RA           23.5528
        Dec          -1.2914
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.2682  -0.6881   0.6742]
        Angle    148.2880
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7693"
}

Galaxy "NGC 7694:MCG 1-60-4"
{
        Type  "Irr"
        RA           23.5544
        Dec          -2.7036
        Distance   8.739e+07  # method: V
        Radius     2.034e+04
        AbsMag        -18.14
        Axis    [ -0.2600  -0.9557   0.1382]
        Angle    168.4607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7694"
}

Galaxy "NGC 7695:MK 931:NPM 1:IRAS 23306-0259"
{
        Type  "S0"
        RA           23.5539
        Dec          -2.7197
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [ -0.2205  -0.9694   0.1081]
        Angle    169.9146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7695"
}

Galaxy "NGC 7696:MCG 1-60-4:ZWG 407.10"
{
        Type  "S0"
        RA           23.5639
        Dec           4.8714
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.1360  -0.9605   0.2426]
        Angle    168.7452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7696"
}

Galaxy "NGC 7697:IC 5333:ESO 110-12:AM 2332-654"
{
        Type  "Sb"
        RA           23.5811
        Dec         -65.3961
        Distance    1.17e+08  # method: T-F
        Radius     2.723e+04
        AbsMag        -18.47
        Axis    [ -0.5220  -0.8442   0.1217]
        Angle    160.6278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7697"
}

Galaxy "NGC 7698:UGC 12668:MCG 4-55-29:ZWG 476.69"
{
        Type  "S0"
        RA           23.5669
        Dec          24.9453
        Distance    3.03e+08  # method: V
        Radius     4.407e+04
        AbsMag        -20.44
        Axis    [ -0.1112  -0.6849   0.7201]
        Angle    125.3411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7698"
}

Galaxy "NGC 7699"
{
        Type  "Sa"
        RA           23.5742
        Dec          -2.9000
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [ -0.2251  -0.9122   0.3423]
        Angle    164.7304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7699"
}

Galaxy "NGC 7700:MCG 1-60-6"
{
        Type  "Sa"
        RA           23.5750
        Dec          -2.9533
        Distance   2.211e+08  # method: V
        Radius     4.181e+04
        AbsMag        -19.46
        Axis    [ -0.3407  -0.6808   0.6484]
        Angle    143.8196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7700"
}

Galaxy "NGC 7701:MCG 1-60-7"
{
        Type  "Sb"
        RA           23.5753
        Dec          -2.8550
        Distance   1.768e+08  # distance uncertain!
        Radius     4.114e+04
        AbsMag        -19.07
        Axis    [ -0.0794  -0.7154   0.6942]
        Angle    171.0226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7701"
}

Galaxy "NGC 7702:ESO 192-9"
{
        Type  "S0"
        RA           23.5911
        Dec         -56.0119
        Distance   1.338e+08  # method: V
        Radius     4.086e+04
        AbsMag        -19.96
        Axis    [ -0.6691  -0.6635   0.3349]
        Angle    165.8453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7702"
}

Galaxy "NGC 7703:UGC 12676:MCG 3-60-4:ZWG 455.16"
{
        Type  "S0"
        RA           23.5794
        Dec          16.0758
        Distance   1.688e+08  # distance uncertain!
        Radius     5.402e+04
        AbsMag        -19.07
        Axis    [  0.0967  -0.7578   0.6453]
        Angle    167.2396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7703"
}

Galaxy "NGC 7704:UGC 12684:MCG 1-60-5:ZWG 407.14"
{
        Type  "S0"
        RA           23.5833
        Dec           4.8981
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [ -0.3755  -0.9268  -0.0088]
        Angle    176.2593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7704"
}

Galaxy "NGC 7705:ZWG 407.13:NPM 1"
{
        Type  "S0"
        RA           23.5839
        Dec           4.8044
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.3629  -0.8867  -0.2865]
        Angle    194.5229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7705"
}

Galaxy "NGC 7706:UGC 12686:MCG 1-60-6:ZWG 407.15"
{
        Type  "S0"
        RA           23.5861
        Dec           4.9647
        Distance    1.54e+08  # distance uncertain!
        Radius     2.687e+04
        AbsMag        -19.07
        Axis    [ -0.3706  -0.8423   0.3913]
        Angle    150.9872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7706"
}

Galaxy "NGC 7707:UGC 12683:MCG 7-48-12:ZWG 533.14"
{
        Type  "S0"
        RA           23.5808
        Dec          44.3047
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.1146  -0.9916  -0.0604]
        Angle    205.4845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7707"
}

Galaxy "NGC 7709:MCG 3-60-2:IRAS 23328-1658"
{
        Type  "S0"
        RA           23.5908
        Dec         -16.7056
        Distance   6.501e+07  # method: V
        Radius     2.175e+04
        AbsMag         -17.8
        Axis    [ -0.1602  -0.9804  -0.1147]
        Angle    167.3198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7709"
}

Galaxy "NGC 7710:MCG 1-60-10"
{
        Type  "S0"
        RA           23.5961
        Dec          -2.8808
        Distance    1.02e+08  # method: V
        Radius     1.781e+04
        AbsMag        -17.58
        Axis    [ -0.1714  -0.8172   0.5503]
        Angle    164.0689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7710"
}

Galaxy "NGC 7711:UGC 12691:MCG 2-60-4:ZWG 432.7"
{
        Type  "S0"
        RA           23.5942
        Dec          15.3017
        Distance   1.677e+08  # method: V
        Radius     6.344e+04
        AbsMag        -20.46
        Axis    [ -0.0702  -0.9686   0.2383]
        Angle    170.3879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7711"
}

Galaxy "NGC 7712:UGC 12694:MCG 4-55-30:ZWG 476.73"
{
        Type  "E0"
        RA           23.5975
        Dec          23.6183
        Distance   1.239e+08  # method: V
        Radius     1.621e+04
        AbsMag         -19.1
        Axis    [ -0.5061  -0.8112   0.2928]
        Angle    137.5245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7712"
}

Galaxy "NGC 7713:ESO 347-28:MCG 6-51-13:AM 2333-381"
{
        Type  "SBc"
        RA           23.6042
        Dec         -37.9389
        Distance   4.154e+07  # method: T-F
        Radius     2.719e+04
        AbsMag        -18.92
        Axis    [ -0.4013  -0.5558   0.7280]
        Angle    179.2148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7713"
}

Galaxy "NGC 7713A:ESO 347-30:MCG 6-51-10:AM 2334-375"
{
        Type  "SBc"
        RA           23.6189
        Dec         -37.7150
        Distance   1.232e+08  # method: V
        Radius     3.226e+04
        AbsMag        -19.69
        Axis    [ -0.6595  -0.7480   0.0754]
        Angle    160.5673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7713A"
}

Galaxy "NGC 7714:UGC 12699:MCG 0-60-17:MK 538"
{
        Type  "SBb"
        RA           23.6039
        Dec           2.1547
        Distance   1.106e+08  # method: V
        Radius     3.057e+04
        AbsMag        -19.65
        Axis    [ -0.3369  -0.9376   0.0855]
        Angle    170.6899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7714"
}

Galaxy "NGC 7715:UGC 12700:MCG 0-60-18:ZWG 381.12"
{
        Type  "Irr"
        RA           23.6058
        Dec           2.1564
        Distance   1.097e+08  # method: V
        Radius     4.309e+04
        AbsMag        -17.93
        Axis    [  0.0355  -0.9977   0.0571]
        Angle    175.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7715"
}

Galaxy "NGC 7716:UGC 12702:MCG 0-60-19:ZWG 381.13"
{
        Type  "SBb"
        RA           23.6086
        Dec           0.2975
        Distance   1.001e+08  # method: V
        Radius     3.202e+04
        AbsMag        -19.63
        Axis    [ -0.3846  -0.8851  -0.2622]
        Angle    189.4871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7716"
}

Galaxy "NGC 7717:MCG 3-60-8"
{
        Type  "SBa"
        RA           23.6286
        Dec         -15.1186
        Distance    1.37e+08  # method: V
        Radius     2.789e+04
        AbsMag        -19.42
        Axis    [ -0.4384  -0.7476  -0.4989]
        Angle    192.4916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7717"
}

Galaxy "NGC 7718:UGC 12712:MCG 4-55-34:ZWG 476.82"
{
        Type  "S0"
        RA           23.6344
        Dec          25.7197
        Distance   4.129e+08  # method: V
        Radius     5.405e+04
        AbsMag        -20.41
        Axis    [ -0.0467  -0.7806   0.6233]
        Angle    142.3947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7718"
}

Galaxy "NGC 7719-1:ESO 536-12:IRAS 23354-2315"
{
        Type  "Sb"
        RA           23.6339
        Dec         -22.9747
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.3893  -0.7181  -0.5769]
        Angle    184.7813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7719-1"
}

Galaxy "NGC 7719-2"
{
        Type  "S0"
        RA           23.6339
        Dec         -22.9778
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [ -0.3272  -0.5605   0.7608]
        Angle    167.0684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7719-2"
}

Galaxy "NGC 7720-1:UGC 12716:MCG 4-55-36:ZWG 476.91"
{
        Type  "E0"
        RA           23.6414
        Dec          27.0311
        Distance   3.795e+08  # method: V
        Radius     8.831e+04
        AbsMag        -21.93
        Axis    [ -0.5334  -0.8246  -0.1887]
        Angle    224.1425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7720-1"
}

Galaxy "NGC 7720-2:UGC 12716:MCG 4-55-36:ZWG 476.91"
{
        Type  "E0"
        RA           23.6414
        Dec          27.0347
        Distance   3.795e+08  # method: V
        Radius     1.104e+04
        AbsMag        -19.83
        Axis    [ -0.5289  -0.7987  -0.2870]
        Angle    238.7712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7720-2"
}

Galaxy "NGC 7721:MCG 1-60-17:IRAS 23362-0647"
{
        Type  "Sc"
        RA           23.6467
        Dec          -6.5178
        Distance   8.322e+07  # method: T-F
        Radius     3.389e+04
        AbsMag        -19.73
        Axis    [ -0.1361  -0.8865  -0.4422]
        Angle    179.1799
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7721"
}

Galaxy "NGC 7722:UGC 12718:MCG 3-60-17:ZWG 455.35"
{
        Type  "Sa"
        RA           23.6444
        Dec          15.9547
        Distance   1.668e+08  # method: V
        Radius     4.125e+04
        AbsMag        -20.04
        Axis    [ -0.2302  -0.7654   0.6010]
        Angle    136.9054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7722"
}

Galaxy "NGC 7723:MCG 2-60-5:IRAS 23363-1314"
{
        Type  "SBb"
        RA           23.6492
        Dec         -12.9611
        Distance   9.636e+07  # method: T-F
        Radius     4.905e+04
        AbsMag        -20.35
        Axis    [ -0.3462  -0.9033  -0.2535]
        Angle    176.5297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7723"
}

Galaxy "NGC 7724:MCG 2-60-6"
{
        Type  "Sb"
        RA           23.6519
        Dec         -12.2242
        Distance   6.075e+07  # method: V
        Radius     1.325e+04
        AbsMag        -17.05
        Axis    [ -0.3607  -0.8906  -0.2770]
        Angle    178.4976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7724"
}

Galaxy "NGC 7725:MCG 1-60-18:IRAS 23367-0448"
{
        Type  "S0"
        RA           23.6539
        Dec          -4.5389
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.4773  -0.7789   0.4068]
        Angle    149.5591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7725"
}

Galaxy "NGC 7726:UGC 12721:MCG 4-55-40:ZWG 476.98"
{
        Type  "S0"
        RA           23.6531
        Dec          27.1150
        Distance   3.127e+08  # method: T-F
        Radius     6.822e+04
        AbsMag        -19.91
        Axis    [  0.0772  -0.9964  -0.0344]
        Angle    188.2581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7726"
}

Galaxy "NGC 7727:MCG 2-60-8:VV 67:ARP 222"
{
        Type  "SBa"
        RA           23.6647
        Dec         -12.2928
        Distance   6.695e+07  # method: V
        Radius     4.577e+04
        AbsMag        -19.96
        Axis    [ -0.4160  -0.8712  -0.2609]
        Angle    179.8041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7727"
}

Galaxy "NGC 7728:UGC 12727:MCG 4-55-41:ZWG 476.103"
{
        Type  "E0"
        RA           23.6667
        Dec          27.1333
        Distance    4.13e+08  # method: V
        Radius     6.007e+04
        AbsMag        -21.31
        Axis    [ -0.5182  -0.8511   0.0840]
        Angle    176.3891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7728"
}

Galaxy "NGC 7729:UGC 12730:MCG 5-55-46:ZWG 497.47"
{
        Type  "SBa"
        RA           23.6758
        Dec          29.1881
        Distance   3.053e+08  # method: T-F
        Radius     7.992e+04
        AbsMag        -20.46
        Axis    [  0.0908  -0.8830  -0.4605]
        Angle    206.4075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7729"
}

Galaxy "NGC 7730:ESO 606-2:MCG 4-55-22:IRAS 23381-2047"
{
        Type  "S0"
        RA           23.6792
        Dec         -20.5089
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [ -0.5708  -0.6854   0.4521]
        Angle    151.2353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7730"
}

Galaxy "NGC 7731:UGC 12737:MCG 0-60-34:ZWG 381.25"
{
        Type  "SBa"
        RA           23.6914
        Dec           3.7406
        Distance   1.146e+08  # method: V
        Radius     2.333e+04
        AbsMag        -18.63
        Axis    [ -0.3603  -0.9082   0.2132]
        Angle    164.8706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7731"
}

Galaxy "NGC 7732:UGC 12738:MCG 0-60-35:ZWG 381.26"
{
        Type  "Sc"
        RA           23.6928
        Dec           3.7250
        Distance   1.166e+08  # method: V
        Radius     3.392e+04
        AbsMag        -18.47
        Axis    [ -0.0478  -0.9667   0.2513]
        Angle    173.4292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7732"
}

Galaxy "NGC 7733:ESO 110-22:ESO 78-1:AM 2339-661"
{
        Type  "SBb"
        RA           23.7089
        Dec         -65.9561
        Distance    4.57e+08  # method: V
        Radius     8.641e+04
        AbsMag        -21.33
        Axis    [ -0.7539  -0.6103   0.2432]
        Angle    164.1855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7733"
}

Galaxy "NGC 7734:ESO 110-23:ESO 78-2:AM 2339-661"
{
        Type  "SBb"
        RA           23.7119
        Dec         -65.9442
        Distance    4.74e+08  # method: V
        Radius     9.651e+04
        AbsMag        -21.91
        Axis    [ -0.8477  -0.4276   0.3138]
        Angle    160.6665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7734"
}

Galaxy "NGC 7735:UGC 12744:MCG 4-55-46:ZWG 476.115"
{
        Type  "E0"
        RA           23.7047
        Dec          26.2322
        Distance    3.02e+08  # distance uncertain!
        Radius     5.711e+04
        AbsMag        -20.13
        Axis    [ -0.5152  -0.8432   0.1539]
        Angle    163.9810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7735"
}

Galaxy "NGC 7736:ESO 606-5:MCG 3-60-10:NPM 1"
{
        Type  "S0"
        RA           23.7069
        Dec         -19.4525
        Distance   1.895e+08  # method: V
        Radius     4.685e+04
        AbsMag        -19.72
        Axis    [ -0.4562  -0.6917  -0.5599]
        Angle    194.3036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7736"
}

Galaxy "NGC 7737:UGC 12745:MCG 4-55-48:ZWG 476.118"
{
        Type  "Sa"
        RA           23.7128
        Dec          27.0525
        Distance   3.309e+08  # method: V
        Radius     4.331e+04
        AbsMag        -20.23
        Axis    [  0.0780  -0.7811   0.6196]
        Angle    155.0802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7737"
}

Galaxy "NGC 7738:UGC 12757:MCG 0-60-38:ZWG 381.33"
{
        Type  "SBb"
        RA           23.7339
        Dec           0.5175
        Distance   2.906e+08  # method: V
        Radius     8.453e+04
        AbsMag        -20.75
        Axis    [ -0.3639  -0.9264   0.0965]
        Angle    171.5078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7738"
}

Galaxy "NGC 7739:ZWG 381.38:NPM 1"
{
        Type  "E2"
        RA           23.7417
        Dec           0.3211
        Distance   3.631e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -20.13
        Axis    [ -0.6949  -0.7087   0.1223]
        Angle    160.8174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7739"
}

Galaxy "NGC 7740:ZWG 476.123"
{
        Type  "S0"
        RA           23.7256
        Dec          27.3125
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.0160  -0.8323   0.5542]
        Angle    150.2263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7740"
}

Galaxy "NGC 7741:UGC 12754:MCG 4-55-50:ZWG 476.125"
{
        Type  "SBc"
        RA           23.7317
        Dec          26.0753
        Distance   5.939e+07  # method: T-F
        Radius     3.887e+04
        AbsMag         -19.6
        Axis    [ -0.0101  -0.6707   0.7417]
        Angle    137.0450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7741"
}

Galaxy "NGC 7742:UGC 12760:MCG 2-60-10:ZWG 432.23"
{
        Type  "Sb"
        RA           23.7375
        Dec          10.7669
        Distance   5.876e+07  # method: V
        Radius     1.453e+04
        AbsMag        -18.88
        Axis    [ -0.5675  -0.7260  -0.3885]
        Angle    229.3195
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7742"
}

Galaxy "NGC 7743:UGC 12759:MCG 2-60-11:ZWG 432.22"
{
        Type  "SBa"
        RA           23.7392
        Dec           9.9339
        Distance   6.752e+07  # method: S
        Radius      2.75e+04
        AbsMag        -19.28
        Axis    [ -0.3773  -0.9204   0.1024]
        Angle    172.8662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7743"
}

Galaxy "NGC 7744:IC 5348:ESO 292-17:MCG 7-48-17"
{
        Type  "S0"
        RA           23.7497
        Dec         -42.9100
        Distance   1.284e+08  # method: V
        Radius     4.108e+04
        AbsMag        -20.07
        Axis    [ -0.7189  -0.6504   0.2454]
        Angle    159.3976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7744"
}

Galaxy "NGC 7745:MCG 4-56-4:NPM 1"
{
        Type  "E0"
        RA           23.7458
        Dec          25.9094
        Distance   3.802e+08  # distance uncertain!
        Radius     3.871e+04
        AbsMag        -20.13
        Axis    [ -0.5433  -0.7873  -0.2916]
        Angle    239.1275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7745"
}

Galaxy "NGC 7746:UGC 12768:MCG 0-60-43:ZWG 381.40"
{
        Type  "S0"
        RA           23.7553
        Dec          -1.6844
        Distance   2.957e+08  # method: V
        Radius     6.022e+04
        AbsMag        -20.59
        Axis    [ -0.3313  -0.6825   0.6515]
        Angle    144.7512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7746"
}

Galaxy "NGC 7747:UGC 12772:MCG 4-56-5:ZWG 477.3"
{
        Type  "SBb"
        RA           23.7589
        Dec          27.3606
        Distance   4.239e+08  # method: T-F
        Radius     9.249e+04
        AbsMag        -21.17
        Axis    [  0.0989  -0.9667  -0.2361]
        Angle    197.3559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7747"
}

Galaxy "NGC 7749:ESO 471-9:MCG 5-56-3"
{
        Type  "S0"
        RA           23.7631
        Dec         -29.5178
        Distance   4.558e+08  # method: V
        Radius     1.061e+05
        AbsMag        -21.93
        Axis    [ -0.4633  -0.8034  -0.3740]
        Angle    171.5091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7749"
}

Galaxy "NGC 7750:UGC 12777:MCG 1-60-34:ZWG 381.43"
{
        Type  "SBc"
        RA           23.7769
        Dec           3.7997
        Distance   1.412e+08  # method: T-F
        Radius     3.287e+04
        AbsMag        -19.68
        Axis    [ -0.1198  -0.6139   0.7802]
        Angle    155.6604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7750"
}

Galaxy "NGC 7751:UGC 12778:MCG 1-60-35:ZWG 407.57"
{
        Type  "S0"
        RA           23.7828
        Dec           6.8619
        Distance   1.315e+08  # method: V
        Radius     1.913e+04
        AbsMag        -19.13
        Axis    [ -0.5827  -0.7037  -0.4065]
        Angle    227.2685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7751"
}

Galaxy "NGC 7752:UGC 12779:MCG 5-56-4:MK 1134"
{
        Type  "S0"
        RA           23.7828
        Dec          29.4594
        Distance   2.141e+08  # method: V
        Radius     2.803e+04
        AbsMag        -19.09
        Axis    [  0.0251  -0.9280   0.3717]
        Angle    165.9190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7752"
}

Galaxy "NGC 7753:UGC 12780:MCG 5-56-5:ZWG 498.10"
{
        Type  "SBc"
        RA           23.7844
        Dec          29.4839
        Distance   2.191e+08  # method: V
        Radius     1.052e+05
        AbsMag        -21.14
        Axis    [ -0.0692  -0.9932  -0.0937]
        Angle    196.6970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7753"
}

Galaxy "NGC 7754:MCG 3-60-21:IRAS 23466-1652"
{
        Type  "Sa"
        RA           23.8197
        Dec         -16.6006
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.3284  -0.8058   0.4927]
        Angle    167.0222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7754"
}

Galaxy "NGC 7754A"
{
        Type  "S0"
        RA           23.8183
        Dec         -16.5792
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.3435  -0.9212   0.1825]
        Angle    169.2516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7754A"
}

Galaxy "NGC 7755:ESO 471-20:MCG 5-56-14:UGCA 443"
{
        Type  "SBc"
        RA           23.7975
        Dec         -30.5236
        Distance   9.812e+07  # method: T-F
        Radius     5.423e+04
        AbsMag        -19.99
        Axis    [ -0.4773  -0.7618  -0.4380]
        Angle    174.1426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7755"
}

Galaxy "NGC 7757:UGC 12788:MCG 1-60-37:ZWG 407.59"
{
        Type  "Sc"
        RA           23.8125
        Dec           4.1714
        Distance   1.177e+08  # method: V
        Radius     4.108e+04
        AbsMag        -19.69
        Axis    [ -0.2886  -0.8782   0.3814]
        Angle    160.7787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7757"
}

Galaxy "NGC 7758:ESO 606-10:NPM 1"
{
        Type  "S0"
        RA           23.8153
        Dec         -22.0242
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.4995  -0.7715   0.3941]
        Angle    161.1002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7758"
}

Galaxy "NGC 7759:MCG 3-60-18"
{
        Type  "S0"
        RA           23.8150
        Dec         -16.5408
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [ -0.4118  -0.7071   0.5748]
        Angle    157.9461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7759"
}

Galaxy "NGC 7759A:MCG 3-60-19"
{
        Type  "S0"
        RA           23.8156
        Dec         -16.5406
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.2402  -0.9650   0.1048]
        Angle    171.2409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7759A"
}

Galaxy "NGC 7760:UGC 12794:MCG 5-56-8:ZWG 498.14"
{
        Type  "E0"
        RA           23.8197
        Dec          30.9831
        Distance   2.231e+08  # method: V
        Radius      2.92e+04
        AbsMag        -19.58
        Axis    [ -0.5322  -0.8061  -0.2586]
        Angle    242.5455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7760"
}

Galaxy "NGC 7761:IC 5361:MCG 2-60-20:NPM 1"
{
        Type  "S0"
        RA           23.8578
        Dec         -13.3811
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [ -0.6347  -0.5951  -0.4930]
        Angle    214.7156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7761"
}

Galaxy "NGC 7763:NPM 1"
{
        Type  "S0"
        RA           23.8375
        Dec         -16.5897
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.3104  -0.6094   0.7296]
        Angle    162.6072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7763"
}

Galaxy "NGC 7764:ESO 293-4:MCG 7-48-27:VV 715"
{
        Type  "Irr"
        RA           23.8481
        Dec         -40.7300
        Distance   6.646e+07  # method: V
        Radius     1.933e+04
        AbsMag        -18.64
        Axis    [ -0.5902  -0.5397   0.6003]
        Angle    162.6800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7764"
}

Galaxy "NGC 7764A1:ESO 293-8:MCG 7-1-1:AM 2350-410"
{
        Type  "Irr"
        RA           23.8889
        Dec         -40.8042
        Distance   5.496e+08  # distance uncertain!
        Radius     5.595e+04
        AbsMag        -20.13
        Axis    [ -0.3896  -0.9205  -0.0304]
        Angle    162.3353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7764A1"
}

Galaxy "NGC 7764A2:ESO 293-8:MCG 7-1-1:AM 2350-410"
{
        Type  "Sc"
        RA           23.8897
        Dec         -40.8069
        Distance   4.015e+08  # method: V
        Radius     7.591e+04
        AbsMag        -20.35
        Axis    [ -0.5392  -0.8421  -0.0116]
        Angle    163.5588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7764A2"
}

Galaxy "NGC 7764A3:ESO 293-8:MCG 7-1-1:AM 2350-410"
{
        Type  "E0"
        RA           23.8906
        Dec         -40.8161
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [ -0.6877  -0.4299  -0.5850]
        Angle    197.8632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7764A3"
}

Galaxy "NGC 7765:MCG 4-56-15:ZWG 477.15"
{
        Type  "SBa"
        RA           23.8478
        Dec          27.1658
        Distance   3.259e+08  # method: V
        Radius     3.318e+04
        AbsMag         -19.5
        Axis    [ -0.5260  -0.7974  -0.2956]
        Angle    239.8776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7765"
}

Galaxy "NGC 7766:MCG 4-56-17:ZWG 477.18:NPM 1"
{
        Type  "E0"
        RA           23.8486
        Dec          27.1269
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [ -0.5437  -0.8376  -0.0539]
        Angle    205.6042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7766"
}

Galaxy "NGC 7767:UGC 12805:MCG 4-56-16:ZWG 477.17"
{
        Type  "Sa"
        RA           23.8489
        Dec          27.0867
        Distance    4.64e+08  # method: T-F
        Radius     6.749e+04
        AbsMag        -21.37
        Axis    [  0.2228  -0.7683   0.6001]
        Angle    171.2380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7767"
}

Galaxy "NGC 7768:UGC 12806:MCG 4-56-18:ZWG 477.19"
{
        Type  "E0"
        RA           23.8494
        Dec          27.1478
        Distance   2.675e+08  # method: T-F
        Radius     6.224e+04
        AbsMag        -21.27
        Axis    [ -0.5346  -0.8447   0.0266]
        Angle    191.3130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7768"
}

Galaxy "NGC 7769:UGC 12808:MCG 3-60-30:ZWG 455.54"
{
        Type  "Sb"
        RA           23.8511
        Dec          20.1506
        Distance   1.753e+08  # method: V
        Radius      8.16e+04
        AbsMag        -20.85
        Axis    [ -0.1618  -0.6758   0.7191]
        Angle    127.8628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7769"
}

Galaxy "NGC 7770:UGC 12813:MCG 3-60-34:ZWG 455.57"
{
        Type  "Sa"
        RA           23.8561
        Dec          20.0969
        Distance   1.775e+08  # method: V
        Radius     1.807e+04
        AbsMag        -19.18
        Axis    [ -0.1097  -0.9208  -0.3742]
        Angle    205.4315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7770"
}

Galaxy "NGC 7771:UGC 12815:MCG 3-60-35:ZWG 455.58"
{
        Type  "SBa"
        RA           23.8567
        Dec          20.1122
        Distance   1.786e+08  # method: V
        Radius     6.233e+04
        AbsMag        -20.69
        Axis    [ -0.0218  -0.9995   0.0250]
        Angle    185.3306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7771"
}

Galaxy "NGC 7773:UGC 12820:MCG 5-56-15:ZWG 498.22"
{
        Type  "SBc"
        RA           23.8694
        Dec          31.2769
        Distance   3.697e+08  # method: V
        Radius     6.452e+04
        AbsMag        -20.97
        Axis    [ -0.5127  -0.8148  -0.2707]
        Angle    242.3873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7773"
}

Galaxy "NGC 7774:UGC 12819:MCG 2-60-22:ZWG 432.37"
{
        Type  "E0"
        RA           23.8694
        Dec          11.4703
        Distance   2.788e+08  # method: V
        Radius     4.055e+04
        AbsMag        -20.46
        Axis    [ -0.6210  -0.7662   0.1649]
        Angle    161.4301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7774"
}

Galaxy "NGC 7775:UGC 12821:MCG 5-56-16:ZWG 498.24"
{
        Type  "SBc"
        RA           23.8733
        Dec          28.7725
        Distance   2.909e+08  # method: V
        Radius     3.808e+04
        AbsMag        -20.75
        Axis    [ -0.2986  -0.9180  -0.2609]
        Angle    219.1108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7775"
}

Galaxy "NGC 7776:IC 1514:MCG 2-60-22"
{
        Type  "Sa"
        RA           23.9044
        Dec         -13.5864
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.1957  -0.7080   0.6786]
        Angle    174.5585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7776"
}

Galaxy "NGC 7777:UGC 12829:MCG 5-56-18:ZWG 498.26"
{
        Type  "S0"
        RA           23.8867
        Dec          28.2839
        Distance   2.997e+08  # method: V
        Radius     5.231e+04
        AbsMag        -20.42
        Axis    [ -0.1070  -0.9884  -0.1076]
        Angle    198.7234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7777"
}

Galaxy "NGC 7778:UGC 12827:MCG 1-60-43:ZWG 407.69"
{
        Type  "E0"
        RA           23.8886
        Dec           7.8706
        Distance   2.212e+08  # method: V
        Radius     3.217e+04
        AbsMag        -20.46
        Axis    [ -0.6118  -0.6895  -0.3876]
        Angle    229.8446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7778"
}

Galaxy "NGC 7779:UGC 12831:MCG 1-60-45:ZWG 407.70"
{
        Type  "Sa"
        RA           23.8906
        Dec           7.8761
        Distance   2.149e+08  # method: V
        Radius     4.376e+04
        AbsMag        -20.39
        Axis    [ -0.3160  -0.8485  -0.4246]
        Angle    206.8883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7779"
}

Galaxy "NGC 7780:UGC 12833:MCG 1-60-46:ZWG 407.71"
{
        Type  "SBb"
        RA           23.8922
        Dec           8.1183
        Distance   2.174e+08  # method: V
        Radius     2.846e+04
        AbsMag        -19.32
        Axis    [ -0.1644  -0.8482  -0.5035]
        Angle    200.6872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7780"
}

Galaxy "NGC 7781:MCG 1-60-47:ZWG 407.72"
{
        Type  "S0"
        RA           23.8958
        Dec           7.8608
        Distance   2.278e+08  # method: V
        Radius     2.651e+04
        AbsMag        -19.12
        Axis    [  0.0091  -0.8946  -0.4468]
        Angle    187.6414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7781"
}

Galaxy "NGC 7782:UGC 12834:MCG 1-60-48:ZWG 407.73"
{
        Type  "Sb"
        RA           23.8981
        Dec           7.9706
        Distance   3.773e+08  # method: T-F
        Radius     1.207e+05
        AbsMag        -22.22
        Axis    [ -0.1840  -0.8371  -0.5151]
        Angle    202.5114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7782"
}

Galaxy "NGC 7783-1:NGC 7783A:UGC 12837:MCG 0-60-58"
{
        Type  "S0"
        RA           23.9028
        Dec           0.3833
        Distance   3.385e+08  # method: V
        Radius       6.4e+04
        AbsMag        -21.08
        Axis    [ -0.1794  -0.9429   0.2806]
        Angle    172.2920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7783-1"
}

Galaxy "NGC 7783-2:NGC 7783B:UGC 12837:MCG 0-60-59"
{
        Type  "S0"
        RA           23.9033
        Dec           0.3775
        Distance   3.438e+08  # method: V
        Radius       3.5e+04
        AbsMag        -19.71
        Axis    [ -0.2430  -0.6354   0.7330]
        Angle    147.5110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7783-2"
}

Galaxy "NGC 7783C:HCG 98"
{
        Type  "S0"
        RA           23.9036
        Dec           0.3569
        Distance   3.868e+08  # distance uncertain!
        Radius     1.125e+04
        AbsMag        -19.07
        Axis    [ -0.6110  -0.6631  -0.4324]
        Angle    223.9914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7783C"
}

Galaxy "NGC 7783D:MCG 0-60-60:HCG 98:ARP 323"
{
        Type  "Sa"
        RA           23.9028
        Dec           0.3942
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [ -0.6108  -0.6633  -0.4323]
        Angle    224.0100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7783D"
}

Galaxy "NGC 7784:MCG 4-1-1:ZWG 477.29:ZWG 478.1"
{
        Type  "E0"
        RA           23.9203
        Dec          21.7628
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [ -0.5749  -0.7565  -0.3118]
        Angle    238.3481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7784"
}

Galaxy "NGC 7785:UGC 12841:MCG 1-60-49:ZWG 407.75"
{
        Type  "E5"
        RA           23.9217
        Dec           5.9161
        Distance   1.949e+08  # method: T-F
        Radius     7.085e+04
        AbsMag        -21.28
        Axis    [ -0.5847  -0.6597   0.4722]
        Angle    126.0670
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7785"
}

Galaxy "NGC 7786:UGC 12842:MCG 3-60-38:ZWG 455.65"
{
        Type  "S0"
        RA           23.9225
        Dec          21.5886
        Distance   1.784e+08  # method: V
        Radius     2.595e+04
        AbsMag        -19.59
        Axis    [ -0.1889  -0.8653  -0.4642]
        Angle    217.3024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7786"
}

Galaxy "NGC 7787:UGC 12849:MCG 0-1-5:ZWG 382.3"
{
        Type  "Sa"
        RA           23.9353
        Dec           0.5497
        Distance   2.861e+08  # method: V
        Radius     7.489e+04
        AbsMag        -19.41
        Axis    [ -0.0635  -0.9454   0.3197]
        Angle    176.4030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7787"
}

Galaxy "NGC 7792:MCG 3-1-6:ZWG 456.7"
{
        Type  "Sb"
        RA           23.9675
        Dec          16.5019
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.2884  -0.8456  -0.4492]
        Angle    217.5538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7792"
}

Galaxy "NGC 7793:ESO 349-12:MCG 6-1-9:AM 2355-325"
{
        Type  "Sc"
        RA           23.9636
        Dec         -32.5917
        Distance   2.039e+07  # method: T-F
        Radius     2.757e+04
        AbsMag        -19.28
        Axis    [ -0.5700  -0.7881   0.2324]
        Angle    165.6552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7793"
}

Galaxy "NGC 7794:UGC 12872:MCG 2-1-4:ZWG 433.10"
{
        Type  "Sc"
        RA           23.9761
        Dec          10.7283
        Distance   2.232e+08  # method: V
        Radius     4.219e+04
        AbsMag        -20.58
        Axis    [ -0.2897  -0.8207  -0.4925]
        Angle    213.1132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7794"
}

Galaxy "NGC 7796:ESO 149-7:AM 2356-554"
{
        Type  "E0"
        RA           23.9831
        Dec         -55.4581
        Distance   1.627e+08  # method: S
        Radius     5.207e+04
        AbsMag        -20.99
        Axis    [ -0.7320  -0.1101   0.6723]
        Angle    140.9213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7796"
}

Galaxy "NGC 7797:UGC 12877:MCG 0-1-11:ZWG 382.10"
{
        Type  "Sc"
        RA           23.9828
        Dec           3.6342
        Distance   3.839e+08  # method: V
        Radius     5.584e+04
        AbsMag        -20.75
        Axis    [ -0.4449  -0.8066  -0.3893]
        Angle    208.5909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7797"
}

Galaxy "NGC 7798:UGC 12884:MCG 3-1-10:MK 332"
{
        Type  "Sc"
        RA           23.9903
        Dec          20.7500
        Distance    9.35e+07  # method: V
        Radius     1.904e+04
        AbsMag        -19.29
        Axis    [ -0.3956  -0.9162  -0.0636]
        Angle    197.1503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7798"
}

Galaxy "NGC 7800:UGC 12885:MCG 2-1-7:ZWG 433.12"
{
        Type  "Irr"
        RA           23.9936
        Dec          14.8075
        Distance   6.319e+07  # method: V
        Radius     2.114e+04
        AbsMag        -18.24
        Axis    [ -0.2337  -0.9565  -0.1746]
        Angle    196.3193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7800"
}

Galaxy "NGC 7802:UGC 12902:MCG 1-1-8:ZWG 408.7"
{
        Type  "S0"
        RA            0.0167
        Dec           6.2417
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.1973   0.9735   0.1158]
        Angle    173.1620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7802"
}

Galaxy "NGC 7803:UGC 12906:MCG 2-1-11:ZWG 433.13"
{
        Type  "Sa"
        RA            0.0222
        Dec          13.1114
        Distance    2.27e+08  # method: V
        Radius     3.302e+04
        AbsMag        -20.11
        Axis    [  0.1669   0.9727  -0.1612]
        Angle    181.6621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7803"
}

Galaxy "NGC 7805:UGC 12908:MCG 5-1-24:ZWG 498.64"
{
        Type  "S0"
        RA            0.0239
        Dec          31.4336
        Distance   2.053e+08  # method: V
        Radius     3.582e+04
        AbsMag        -19.79
        Axis    [  0.1561   0.9815   0.1112]
        Angle    155.5414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7805"
}

Galaxy "NGC 7806:UGC 12911:MCG 5-1-25:ZWG 499.37"
{
        Type  "Sb"
        RA            0.0250
        Dec          31.4419
        Distance   2.015e+08  # method: V
        Radius     3.224e+04
        AbsMag        -19.65
        Axis    [  0.1581   0.9410   0.2991]
        Angle    142.1756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7806"
}

Galaxy "NGC 7807:ESO 538-15"
{
        Type  "SBb"
        RA            0.0072
        Dec         -18.8419
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.4405   0.8261   0.3516]
        Angle    178.4205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7807"
}

Galaxy "NGC 7808:MCG 2-1-13:NPM 1:IRAS 00009-1101"
{
        Type  "S0"
        RA            0.0589
        Dec         -10.7442
        Distance   3.889e+08  # method: V
        Radius     7.353e+04
        AbsMag        -20.88
        Axis    [  0.6497   0.5960   0.4719]
        Angle    142.4416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7808"
}

Galaxy "NGC 7809:MCG 0-1-19:ZWG 382.18:ZW 126"
{
        Type  "Irr"
        RA            0.0358
        Dec           2.9406
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [  0.3831   0.8952  -0.2278]
        Angle    190.8223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7809"
}

Galaxy "NGC 7810:UGC 12919:MCG 2-1-15:ZWG 433.18"
{
        Type  "S0"
        RA            0.0386
        Dec          12.9717
        Distance   2.347e+08  # method: V
        Radius     4.096e+04
        AbsMag        -20.19
        Axis    [  0.2752   0.9537  -0.1212]
        Angle    181.0682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7810"
}

Galaxy "NGC 7811:MCG 0-1-20:MK 543:ZWG 382.19"
{
        Type  "Irr"
        RA            0.0406
        Dec           3.3519
        Distance   3.306e+08  # method: V
        Radius     1.923e+04
        AbsMag        -19.93
        Axis    [  0.6176   0.6692   0.4132]
        Angle    133.1566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7811"
}

Galaxy "NGC 7812:ESO 349-21:MCG 6-1-16:IRAS 00003-3431"
{
        Type  "Sb"
        RA            0.0483
        Dec         -34.2358
        Distance   2.977e+08  # method: V
        Radius     4.763e+04
        AbsMag         -20.9
        Axis    [  0.4914   0.6183  -0.6134]
        Angle    191.5014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7812"
}

Galaxy "NGC 7813:IC 5384:MCG 2-1-16:MK 936"
{
        Type  "Sb"
        RA            0.0692
        Dec         -11.9839
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.1884   0.6750  -0.7134]
        Angle    185.8533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7813"
}

Galaxy "NGC 7814:UGC 8:MCG 3-1-20:ZWG 456.24"
{
        Type  "Sb"
        RA            0.0539
        Dec          16.1453
        Distance     4.3e+07  # method: S
        Radius      3.44e+04
        AbsMag           -19
        Axis    [ -0.0020   0.8361  -0.5485]
        Angle    192.7418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7814"
}

Galaxy "NGC 7816:UGC 16:MCG 1-1-18:ZWG 408.18"
{
        Type  "Sc"
        RA            0.0636
        Dec           7.4783
        Distance   2.213e+08  # method: V
        Radius     5.472e+04
        AbsMag        -20.46
        Axis    [  0.2675   0.6169  -0.7402]
        Angle    227.7852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7816"
}

Galaxy "NGC 7817:UGC 19:MCG 3-1-21:ZWG 456.28"
{
        Type  "Sc"
        RA            0.0661
        Dec          20.7506
        Distance    9.35e+07  # method: T-F
        Radius      4.76e+04
        AbsMag        -19.69
        Axis    [ -0.0682   0.9817   0.1778]
        Angle    165.9196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7817"
}

Galaxy "NGC 7818:UGC 21:MCG 1-1-19:ZWG 408.19"
{
        Type  "Sc"
        RA            0.0692
        Dec           7.3792
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.6103   0.6875   0.3935]
        Angle    130.3460
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7818"
}

Galaxy "NGC 7819:UGC 26:MCG 5-1-29:ZWG 498.72"
{
        Type  "SBb"
        RA            0.0733
        Dec          31.4725
        Distance   2.102e+08  # method: V
        Radius     4.585e+04
        AbsMag        -19.84
        Axis    [  0.1292   0.9367  -0.3253]
        Angle    194.4968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7819"
}

Galaxy "NGC 7820:UGC 28:MCG 1-1-22:ZWG 408.21"
{
        Type  "Sa"
        RA            0.0750
        Dec           5.1997
        Distance   1.228e+08  # method: V
        Radius     2.322e+04
        AbsMag        -18.98
        Axis    [  0.0820   0.6573  -0.7491]
        Angle    197.9207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7820"
}

Galaxy "NGC 7821:MCG 3-1-19:IRAS 00027-1645"
{
        Type  "Sc"
        RA            0.0878
        Dec         -16.4764
        Distance   3.216e+08  # method: V
        Radius     6.549e+04
        AbsMag        -20.97
        Axis    [  0.2587   0.8906  -0.3741]
        Angle    184.5183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7821"
}

Galaxy "NGC 7823:ESO 111-12:IRAS 00022-6220"
{
        Type  "SBc"
        RA            0.0792
        Dec         -62.0611
        Distance   1.017e+08  # distance uncertain!
        Radius     1.628e+04
        AbsMag        -19.07
        Axis    [  0.7262   0.4983   0.4735]
        Angle    196.7984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7823"
}

Galaxy "NGC 7824:UGC 34:MCG 1-1-25:ZWG 408.25"
{
        Type  "Sb"
        RA            0.0850
        Dec           6.9206
        Distance   2.619e+08  # method: V
        Radius     6.095e+04
        AbsMag        -20.22
        Axis    [  0.2441   0.7622  -0.5995]
        Angle    208.2775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7824"
}

Galaxy "NGC 7825:UGC 37:MCG 1-1-28:ZWG 408.28"
{
        Type  "SBb"
        RA            0.0850
        Dec           5.2031
        Distance   2.391e+08  # method: V
        Radius     3.477e+04
        AbsMag        -19.92
        Axis    [  0.1334   0.8227  -0.5526]
        Angle    193.6198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7825"
}

Galaxy "NGC 7827:UGC 38:MCG 1-1-27:ZWG 408.24"
{
        Type  "S0"
        RA            0.0908
        Dec           5.2219
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.3450   0.9247   0.1608]
        Angle    168.0837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7827"
}

Galaxy "NGC 7828:MCG 2-1-25:VV 272:ARP 144"
{
        Type  "S0"
        RA            0.1075
        Dec         -13.4158
        Distance   2.414e+08  # method: V
        Radius      3.51e+04
        AbsMag        -19.45
        Axis    [  0.2803   0.7555  -0.5921]
        Angle    190.1816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7828"
}

Galaxy "NGC 7829:MCG 2-1-24:VV 272:ARP 144"
{
        Type  "S0"
        RA            0.1081
        Dec         -13.4211
        Distance   2.473e+08  # method: V
        Radius     3.957e+04
        AbsMag         -19.5
        Axis    [  0.3656   0.7769  -0.5127]
        Angle    194.7558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7829"
}

Galaxy "NGC 7831:IC 1530:UGC 60:MCG 5-1-32"
{
        Type  "Sb"
        RA            0.1219
        Dec          32.6092
        Distance   2.372e+08  # method: T-F
        Radius     5.175e+04
        AbsMag        -20.71
        Axis    [ -0.2164   0.9450   0.2452]
        Angle    158.8113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7831"
}

Galaxy "NGC 7832:IC 5386:MCG 1-1-33"
{
        Type  "E0"
        RA            0.1078
        Dec          -3.7167
        Distance   2.399e+08  # distance uncertain!
        Radius      6.63e+04
        AbsMag        -20.13
        Axis    [  0.7051   0.6569   0.2672]
        Angle    152.0418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7832"
}

Galaxy "NGC 7834:UGC 49:MCG 1-1-30:ZWG 408.30"
{
        Type  "Sc"
        RA            0.1103
        Dec           8.3689
        Distance   2.208e+08  # method: V
        Radius     3.532e+04
        AbsMag        -19.05
        Axis    [  0.3003   0.8800   0.3680]
        Angle    155.9416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7834"
}

Galaxy "NGC 7835:MCG 1-1-31"
{
        Type  "S0"
        RA            0.1128
        Dec           8.4272
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.1194   0.6824  -0.7212]
        Angle    205.5264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7835"
}

Galaxy "NGC 7836:UGC 65:MK 336:ZWG 499.51"
{
        Type  "Irr"
        RA            0.1336
        Dec          33.0714
        Distance   3.626e+08  # method: T-F
        Radius     4.746e+04
        AbsMag        -20.83
        Axis    [ -0.0742   0.8611  -0.5030]
        Angle    198.5263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7836"
}

Galaxy "NGC 7837:MCG 1-1-35:ZWG 408.34:ARP 246"
{
        Type  "S0"
        RA            0.1142
        Dec           8.3519
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.1753   0.6257  -0.7601]
        Angle    217.1802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7837"
}

Galaxy "NGC 7838:MCG 1-1-36:ZWG 408.34:ARP 246"
{
        Type  "S0"
        RA            0.1147
        Dec           8.3519
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.0986   0.9686  -0.2284]
        Angle    181.3406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7838"
}

Galaxy "NGC 7840"
{
        Type  "S0"
        RA            0.1189
        Dec           8.3847
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.2655   0.8474  -0.4599]
        Angle    200.3468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=NGC 7840"
}

Galaxy "IC 2:MCG 2-1-31:IRAS 00084-1306"
{
        Type  "S0"
        RA            0.1833
        Dec         -12.8222
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.1426   0.7834  -0.6049]
        Angle    177.8062
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2"
}

Galaxy "IC 3:MCG 0-1-38:ZWG 382.32:NPM 1"
{
        Type  "S0"
        RA            0.2017
        Dec          -0.4147
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.2302   0.9686   0.0937]
        Angle    175.1349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3"
}

Galaxy "IC 4:UGC 123:MCG 3-1-29:ZWG 456.40"
{
        Type  "Sc"
        RA            0.2242
        Dec          17.4858
        Distance   2.106e+08  # method: V
        Radius     3.063e+04
        AbsMag        -19.95
        Axis    [  0.4026   0.8407   0.3621]
        Angle    138.2193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4"
}

Galaxy "IC 5:MCG 2-1-47:NPM 1:IRAS 00148-0951"
{
        Type  "E0"
        RA            0.2928
        Dec          -9.5428
        Distance   3.163e+08  # distance uncertain!
        Radius      4.14e+04
        AbsMag        -20.13
        Axis    [  0.7099   0.5894   0.3856]
        Angle    144.2282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5"
}

Galaxy "IC 6:MCG 1-1-75"
{
        Type  "E0"
        RA            0.3150
        Dec          -3.2761
        Distance   2.754e+08  # distance uncertain!
        Radius     3.205e+04
        AbsMag        -20.13
        Axis    [  0.6789   0.6021   0.4203]
        Angle    134.5964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 6"
}

Galaxy "IC 7:ZWG 433.43:KARA 14"
{
        Type  "E0"
        RA            0.3147
        Dec          10.5953
        Distance   3.163e+08  # distance uncertain!
        Radius      3.22e+04
        AbsMag        -20.13
        Axis    [  0.6472   0.6732   0.3577]
        Angle    125.3905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 7"
}

Galaxy "IC 8:MCG 1-1-76"
{
        Type  "Sc"
        RA            0.3172
        Dec          -3.2219
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.2074   0.8348  -0.5100]
        Angle    187.6231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 8"
}

Galaxy "IC 9:MCG 2-2-1:IRAS 00171-1423"
{
        Type  "Sb"
        RA            0.3289
        Dec         -14.1214
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.4319   0.7458  -0.5072]
        Angle    196.3186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 9"
}

Galaxy "IC 10:UGC 192:MCG 10-1-1:IRAS 00177+5900"
{
        Type  "Irr"
        RA            0.3400
        Dec          59.2925
        Distance   7.944e+07  # distance uncertain!
        Radius     7.395e+04
        AbsMag        -20.13
        Axis    [ -0.1261   0.9024  -0.4121]
        Angle    209.5895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 10"
}

Galaxy "IC 12:MCG 1-2-3:IRAS 00177-0255"
{
        Type  "Sb"
        RA            0.3375
        Dec          -2.6533
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.1729   0.8867   0.4288]
        Angle    171.8422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 12"
}

Galaxy "IC 13:UGC 195:MCG 1-2-3:ZWG 409.2"
{
        Type  "Sc"
        RA            0.3389
        Dec           7.7006
        Distance   2.232e+08  # method: T-F
        Radius     4.544e+04
        AbsMag        -19.38
        Axis    [  0.0057   0.6733  -0.7393]
        Angle    189.4175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 13"
}

Galaxy "IC 15:IRAS 00253-0020"
{
        Type  "E0"
        RA            0.4658
        Dec          -0.0614
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.6869   0.6074   0.3991]
        Angle    131.5144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 15"
}

Galaxy "IC 16:MCG 2-2-17:IRAS 00255-1322"
{
        Type  "S0"
        RA            0.4686
        Dec         -13.0942
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.3972   0.9093   0.1243]
        Angle    176.7059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 16"
}

Galaxy "IC 17:MCG 0-2-44:ZWG 383.25:ARAK 10"
{
        Type  "Sc"
        RA            0.4747
        Dec           2.6486
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.6623   0.6352   0.3974]
        Angle    130.7823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 17"
}

Galaxy "IC 18:MCG 2-2-23:VV 234:ARP 100"
{
        Type  "SBb"
        RA            0.4764
        Dec         -11.5864
        Distance   2.555e+08  # distance uncertain!
        Radius     4.088e+04
        AbsMag        -19.07
        Axis    [  0.3286   0.8444   0.4231]
        Angle    172.0761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 18"
}

Galaxy "IC 19:MCG 2-2-24:MK 949:NPM 1"
{
        Type  "E0"
        RA            0.4775
        Dec         -11.6403
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [  0.7625   0.5940   0.2564]
        Angle    155.0051
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 19"
}

Galaxy "IC 20:MCG 2-2-21:NPM 1"
{
        Type  "S0"
        RA            0.4775
        Dec         -13.0097
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.6940   0.5562   0.4571]
        Angle    141.8717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 20"
}

Galaxy "IC 21:MCG 0-2-53"
{
        Type  "S0"
        RA            0.4861
        Dec          -0.1636
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.4106   0.7620   0.5008]
        Angle    150.0092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 21"
}

Galaxy "IC 22:MCG 2-2-27"
{
        Type  "S0"
        RA            0.4925
        Dec          -9.0803
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.2680   0.9470   0.1770]
        Angle    175.4589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 22"
}

Galaxy "IC 23:MCG 2-2-32:NPM 1"
{
        Type  "E0"
        RA            0.5139
        Dec         -12.7197
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.7142   0.5390   0.4465]
        Angle    140.1316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 23"
}

Galaxy "IC 25:MCG 0-2-64:MK 952:ZWG 383.33"
{
        Type  "S0"
        RA            0.5200
        Dec          -0.4075
        Distance   2.482e+08  # method: V
        Radius     3.611e+04
        AbsMag        -19.01
        Axis    [  0.5340   0.8258   0.1812]
        Angle    161.0442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 25"
}

Galaxy "IC 27:NPM 1"
{
        Type  "S0"
        RA            0.5517
        Dec         -13.3711
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [  0.7016   0.5492   0.4540]
        Angle    141.7714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 27"
}

Galaxy "IC 28:NPM 1"
{
        Type  "S0"
        RA            0.5522
        Dec         -13.4558
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.5457   0.8116  -0.2086]
        Angle    185.8735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 28"
}

Galaxy "IC 29:MCG 0-2-72:ZWG 383.36:NPM 1"
{
        Type  "E0"
        RA            0.5694
        Dec          -2.1769
        Distance   5.755e+08  # distance uncertain!
        Radius     5.859e+04
        AbsMag        -20.13
        Axis    [  0.7010   0.5887   0.4026]
        Angle    132.3776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 29"
}

Galaxy "IC 30:MCG 0-2-74"
{
        Type  "S0"
        RA            0.5706
        Dec          -2.0847
        Distance    4.65e+08  # distance uncertain!
        Radius     4.734e+04
        AbsMag        -19.07
        Axis    [  0.3060   0.8793   0.3650]
        Angle    164.2322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 30"
}

Galaxy "IC 31:UGC 340:MCG 2-2-21:ZWG 434.23"
{
        Type  "Sa"
        RA            0.5733
        Dec          12.2686
        Distance   4.158e+08  # method: V
        Radius     9.675e+04
        AbsMag        -20.23
        Axis    [ -0.0888   0.9786  -0.1859]
        Angle    169.0496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 31"
}

Galaxy "IC 32:MCG 0-2-80:NPM 1"
{
        Type  "S0"
        RA            0.5836
        Dec          -2.1411
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.6834   0.6032   0.4113]
        Angle    133.4913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 32"
}

Galaxy "IC 33:MCG 0-2-82"
{
        Type  "S0"
        RA            0.5847
        Dec          -2.1378
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.3733   0.7726   0.5136]
        Angle    154.8513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 33"
}

Galaxy "IC 34:UGC 351:MCG 1-2-32:ZWG 409.44"
{
        Type  "SBa"
        RA            0.5933
        Dec           9.1250
        Distance   2.247e+08  # method: V
        Radius     7.843e+04
        AbsMag        -20.59
        Axis    [ -0.0222   0.7179  -0.6958]
        Angle    183.9430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 34"
}

Galaxy "IC 35:UGC 374:MCG 2-2-24:ZWG 434.26"
{
        Type  "Sc"
        RA            0.6275
        Dec          10.3575
        Distance   1.925e+08  # method: V
        Radius       2.8e+04
        AbsMag        -19.05
        Axis    [  0.3912   0.8929   0.2228]
        Angle    153.1869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 35"
}

Galaxy "IC 36:NPM 1:IRAS 00353-1542"
{
        Type  "E0"
        RA            0.6303
        Dec         -15.4408
        Distance   4.366e+08  # distance uncertain!
        Radius      3.81e+04
        AbsMag        -20.13
        Axis    [  0.7289   0.5167   0.4491]
        Angle    141.5609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 36"
}

Galaxy "IC 37:MCG 3-2-29"
{
        Type  "SBb"
        RA            0.6428
        Dec         -15.3586
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [  0.2034   0.5660  -0.7989]
        Angle    184.0996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 37"
}

Galaxy "IC 38:MCG 3-2-30:IRAS 00361-1541"
{
        Type  "Sb"
        RA            0.6439
        Dec         -15.4192
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.5273   0.8333  -0.1662]
        Angle    182.4566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 38"
}

Galaxy "IC 40:UGC 413:MCG 0-2-106:ZWG 383.56"
{
        Type  "Sc"
        RA            0.6558
        Dec           2.4561
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.2459   0.8684   0.4305]
        Angle    160.8148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 40"
}

Galaxy "IC 41"
{
        Type  "Irr"
        RA            0.6611
        Dec         -14.1739
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.7131   0.5375   0.4501]
        Angle    141.8380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 41"
}

Galaxy "IC 42:MCG 3-2-36"
{
        Type  "SBc"
        RA            0.6847
        Dec         -15.4283
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.4078   0.8976   0.1675]
        Angle    175.0577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 42"
}

Galaxy "IC 43:UGC 448:MCG 5-2-40:ZWG 500.72"
{
        Type  "Sc"
        RA            0.7061
        Dec          29.6419
        Distance   2.061e+08  # method: V
        Radius     4.797e+04
        AbsMag           -20
        Axis    [  0.1985   0.9023  -0.3826]
        Angle    193.2518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 43"
}

Galaxy "IC 46:ZWG 479.63:KARA 32:NPM 1"
{
        Type  "E0"
        RA            0.7158
        Dec          27.2539
        Distance   2.253e+08  # method: V
        Radius     1.966e+04
        AbsMag         -19.5
        Axis    [  0.5293   0.8229  -0.2066]
        Angle    180.6331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 46"
}

Galaxy "IC 47:NPM 1"
{
        Type  "S0"
        RA            0.7150
        Dec         -13.7403
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.3862   0.8705  -0.3052]
        Angle    180.7857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 47"
}

Galaxy "IC 48:IC 1577:MCG 1-3-1:IRAS 00410-0827"
{
        Type  "S0"
        RA            0.7261
        Dec          -8.1856
        Distance   2.588e+08  # method: V
        Radius     3.765e+04
        AbsMag         -20.4
        Axis    [  0.5006   0.8079   0.3109]
        Angle    161.4994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 48"
}

Galaxy "IC 49:UGC 468:MCG 0-3-3:ZWG 384.3"
{
        Type  "Sc"
        RA            0.7322
        Dec           1.8506
        Distance   1.915e+08  # method: V
        Radius     4.179e+04
        AbsMag        -19.64
        Axis    [  0.4557   0.8513  -0.2601]
        Angle    183.3569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 49"
}

Galaxy "IC 50:MCG 2-3-10"
{
        Type  "E0"
        RA            0.7681
        Dec          -9.5033
        Distance   3.631e+08  # distance uncertain!
        Radius     3.697e+04
        AbsMag        -20.13
        Axis    [  0.7324   0.5363   0.4195]
        Angle    136.5806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 50"
}

Galaxy "IC 51:MCG 2-3-11:ARP 230:IRAS 00438-1342"
{
        Type  "S0"
        RA            0.7733
        Dec         -13.4414
        Distance   1.223e+08  # distance uncertain!
        Radius      2.49e+04
        AbsMag        -19.07
        Axis    [  0.6421   0.7223   0.2569]
        Angle    161.8484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 51"
}

Galaxy "IC 52:UGC 494:MCG 1-3-5:ZWG 410.7"
{
        Type  "S0"
        RA            0.8064
        Dec           4.0919
        Distance   7.366e+07  # method: V
        Radius     1.071e+04
        AbsMag        -16.47
        Axis    [  0.1282   0.9538  -0.2717]
        Angle    172.1564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 52"
}

Galaxy "IC 53:UGC 516:MCG 2-3-5:ZWG 435.11"
{
        Type  "S0"
        RA            0.8444
        Dec          10.6008
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [  0.6787   0.6466   0.3484]
        Angle    122.7498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 53"
}

Galaxy "IC 55:MCG 1-3-6:ZWG 410.13:NPM 1"
{
        Type  "S0"
        RA            0.8617
        Dec           7.7192
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.0162   0.5850  -0.8109]
        Angle    189.1343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 55"
}

Galaxy "IC 56:MCG 2-3-30:KAZ 3"
{
        Type  "Sc"
        RA            0.8583
        Dec         -12.8444
        Distance   2.617e+08  # method: V
        Radius     2.665e+04
        AbsMag        -19.02
        Axis    [  0.5536   0.7137   0.4290]
        Angle    157.1466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 56"
}

Galaxy "IC 56A:KAZ 4:NPM 1"
{
        Type  "Irr"
        RA            0.8642
        Dec         -12.7669
        Distance   5.553e+08  # method: V
        Radius     3.231e+04
        AbsMag        -19.86
        Axis    [  0.3593   0.6762  -0.6432]
        Angle    192.9302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 56A"
}

Galaxy "IC 57:UGC 559:MCG 2-3-10:ZWG 435.19"
{
        Type  "S0"
        RA            0.9133
        Dec          11.8417
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.6821   0.6472   0.3404]
        Angle    121.3929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 57"
}

Galaxy "IC 58:MCG 2-3-41:NPM 1"
{
        Type  "E0"
        RA            0.9172
        Dec         -13.6775
        Distance   4.169e+08  # distance uncertain!
        Radius     4.851e+04
        AbsMag        -20.13
        Axis    [  0.7404   0.5665  -0.3618]
        Angle    201.9788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 58"
}

Galaxy "IC 60:MCG 2-3-49:NPM 1"
{
        Type  "S0"
        RA            0.9344
        Dec         -13.3575
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.5549   0.8318   0.0150]
        Angle    172.1077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 60"
}

Galaxy "IC 61:UGC 589:MCG 1-3-9:ZWG 410.19"
{
        Type  "E0"
        RA            0.9519
        Dec           7.5072
        Distance   3.312e+08  # distance uncertain!
        Radius      5.78e+04
        AbsMag        -20.13
        Axis    [  0.3891   0.5839  -0.7125]
        Angle    241.1163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 61"
}

Galaxy "IC 62:UGC 606:MCG 2-3-21:ZWG 435.29"
{
        Type  "S0"
        RA            0.9789
        Dec          11.8083
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.3214   0.8974   0.3022]
        Angle    148.6689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 62"
}

Galaxy "IC 64:UGC 613:MCG 4-3-31:ZWG 480.30"
{
        Type  "S0"
        RA            0.9900
        Dec          27.0594
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.0189   0.8052  -0.5927]
        Angle    194.9104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 64"
}

Galaxy "IC 65:UGC 625:MCG 8-3-5:ZWG 551.4"
{
        Type  "SBc"
        RA            1.0153
        Dec          47.6817
        Distance   9.545e+07  # method: T-F
        Radius     4.165e+04
        AbsMag        -18.83
        Axis    [ -0.3561   0.7239  -0.5909]
        Angle    189.3451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 65"
}

Galaxy "IC 66:UGC 623:MCG 5-3-33:ZWG 501.59"
{
        Type  "Sa"
        RA            1.0089
        Dec          30.7967
        Distance   2.903e+08  # method: T-F
        Radius     5.066e+04
        AbsMag        -19.85
        Axis    [ -0.1312   0.8850  -0.4467]
        Angle    176.9245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 66"
}

Galaxy "IC 69:MCG 5-3-41:ZWG 501.66"
{
        Type  "Sc"
        RA            1.0231
        Dec          31.0411
        Distance   2.139e+08  # method: V
        Radius       2.8e+04
        AbsMag        -19.48
        Axis    [  0.3122   0.9469  -0.0774]
        Angle    155.1491
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 69"
}

Galaxy "IC 70:NPM 1"
{
        Type  "S0"
        RA            1.0175
        Dec           0.0514
        Distance    5.59e+08  # distance uncertain!
        Radius     2.439e+04
        AbsMag        -19.07
        Axis    [  0.2264   0.7641  -0.6040]
        Angle    187.8020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 70"
}

Galaxy "IC 73:ZWG 410.29:UM 84"
{
        Type  "S0"
        RA            1.0814
        Dec           4.7672
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.0801   0.6858  -0.7234]
        Angle    187.9471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 73"
}

Galaxy "IC 74:ZWG 410.30:KARA 43:NPM 1"
{
        Type  "E0"
        RA            1.0986
        Dec           4.0908
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.7486   0.6173   0.2418]
        Angle    133.7815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 74"
}

Galaxy "IC 75:UGC 684:MCG 2-3-35:ZWG 435.43"
{
        Type  "Sb"
        RA            1.1197
        Dec          10.8372
        Distance   5.439e+08  # method: V
        Radius     1.028e+05
        AbsMag        -21.41
        Axis    [  0.4075   0.8814   0.2388]
        Angle    147.0571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 75"
}

Galaxy "IC 76:MCG 1-4-1:MK 973:IRAS 01056-0449"
{
        Type  "S0"
        RA            1.1364
        Dec          -4.5544
        Distance    4.05e+08  # distance uncertain!
        Radius     5.301e+04
        AbsMag        -19.07
        Axis    [  0.1903   0.8617  -0.4704]
        Angle    172.4226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 76"
}

Galaxy "IC 77:DRCG 4-66"
{
        Type  "S0"
        RA            1.1453
        Dec         -15.4208
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.5435   0.8020  -0.2480]
        Angle    178.1479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 77"
}

Galaxy "IC 78:MCG 3-4-10:NPM 1:DRCG 4-22"
{
        Type  "Sa"
        RA            1.1464
        Dec         -15.8447
        Distance   1.612e+08  # distance uncertain!
        Radius     3.986e+04
        AbsMag        -19.07
        Axis    [  0.2387   0.7822  -0.5755]
        Angle    171.0991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 78"
}

Galaxy "IC 79:MCG 3-4-11:DRCG 4-16"
{
        Type  "S0"
        RA            1.1469
        Dec         -15.9483
        Distance   5.545e+08  # method: V
        Radius     7.258e+04
        AbsMag        -20.95
        Axis    [  0.3460   0.6033  -0.7186]
        Angle    192.3082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 79"
}

Galaxy "IC 80A:MCG 3-4-8:DRCG 8-61"
{
        Type  "S0"
        RA            1.1475
        Dec         -15.4064
        Distance   6.853e+08  # method: V
        Radius     4.984e+04
        AbsMag        -21.61
        Axis    [  0.4528   0.8907   0.0405]
        Angle    170.5406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 80A"
}

Galaxy "IC 80B:MCG 3-4-9:DRCG 8-62"
{
        Type  "S0"
        RA            1.1469
        Dec         -15.4036
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.7585   0.4959   0.4229]
        Angle    140.5855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 80B"
}

Galaxy "IC 81:MCG 0-4-15:ZWG 385.10"
{
        Type  "Sc"
        RA            1.1561
        Dec          -1.6950
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.4338   0.7464  -0.5047]
        Angle    193.4838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 81"
}

Galaxy "IC 82:MCG 3-4-13:DRCG 4-10"
{
        Type  "Sb"
        RA            1.1514
        Dec         -16.0003
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.5558   0.7218  -0.4124]
        Angle    186.7907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 82"
}

Galaxy "IC 83:MCG 0-4-21:ZWG 385.15"
{
        Type  "S0"
        RA            1.1747
        Dec           1.6892
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.2399   0.9044  -0.3527]
        Angle    172.5949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 83"
}

Galaxy "IC 84:MCG 0-4-29:ZWG 385.21:NPM 1"
{
        Type  "S0"
        RA            1.1903
        Dec           1.6408
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.3747   0.8293   0.4145]
        Angle    152.4629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 84"
}

Galaxy "IC 86:IRAS 01110-1630"
{
        Type  "S0"
        RA            1.2244
        Dec         -16.2411
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.2308   0.7438  -0.6273]
        Angle    170.8586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 86"
}

Galaxy "IC 87:MCG 0-4-48:ZWG 385.38"
{
        Type  "SBa"
        RA            1.2375
        Dec           0.7658
        Distance   5.679e+08  # method: V
        Radius     4.956e+04
        AbsMag         -20.8
        Axis    [  0.5164   0.7444   0.4232]
        Angle    143.7117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 87"
}

Galaxy "IC 88"
{
        Type  "S0"
        RA            1.2419
        Dec           0.7917
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.7389   0.5656   0.3661]
        Angle    127.5450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 88"
}

Galaxy "IC 90:MCG 1-4-23:NPM 1"
{
        Type  "E0"
        RA            1.2750
        Dec          -7.9767
        Distance   2.884e+08  # distance uncertain!
        Radius     3.776e+04
        AbsMag        -20.13
        Axis    [  0.5833   0.5498  -0.5979]
        Angle    216.8006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 90"
}

Galaxy "IC 91:NPM 1"
{
        Type  "S0"
        RA            1.3108
        Dec           2.5542
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.2108   0.9769   0.0350]
        Angle    160.4621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 91"
}

Galaxy "IC 93:IC 1671:MCG 3-4-43:IRAS 01165-1719"
{
        Type  "Sb"
        RA            1.3172
        Dec         -17.0611
        Distance   2.573e+08  # method: V
        Radius     4.864e+04
        AbsMag        -20.48
        Axis    [  0.1597   0.5647  -0.8097]
        Angle    172.5635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 93"
}

Galaxy "IC 95:NPM 1"
{
        Type  "E0"
        RA            1.3214
        Dec         -12.5736
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.7853   0.4773   0.3944]
        Angle    136.3963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 95"
}

Galaxy "IC 96:MCG 5-4-23:ZWG 502.35:KCPG 30A"
{
        Type  "Sc"
        RA            1.3425
        Dec          29.6164
        Distance   1.865e+08  # method: V
        Radius     2.171e+04
        AbsMag        -18.99
        Axis    [  0.0878   0.9862   0.1401]
        Angle    143.3667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 96"
}

Galaxy "IC 98:MCG 2-4-27:NPM 1"
{
        Type  "E0"
        RA            1.3483
        Dec         -12.6042
        Distance    6.31e+08  # distance uncertain!
        Radius     6.424e+04
        AbsMag        -20.13
        Axis    [  0.7876   0.4749   0.3926]
        Angle    136.3071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 98"
}

Galaxy "IC 99:MCG 2-4-34"
{
        Type  "Sc"
        RA            1.3742
        Dec         -12.9525
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.7744   0.4897   0.4006]
        Angle    137.6631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 99"
}

Galaxy "IC 100:MCG 1-4-30:NPM 1"
{
        Type  "S0"
        RA            1.3814
        Dec          -4.6425
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.4002   0.8566  -0.3258]
        Angle    173.1952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 100"
}

Galaxy "IC 101:UGC 949:MCG 2-4-36:ZWG 436.39"
{
        Type  "Sb"
        RA            1.4022
        Dec           9.9306
        Distance   9.486e+07  # method: V
        Radius     1.932e+04
        AbsMag        -17.52
        Axis    [  0.0423   0.8630  -0.5034]
        Angle    170.1626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 101"
}

Galaxy "IC 102:UGC 954:ZWG 436.40"
{
        Type  "Sa"
        RA            1.4072
        Dec           9.8872
        Distance   6.395e+08  # method: V
        Radius     8.371e+04
        AbsMag        -20.86
        Axis    [  0.0587   0.9728  -0.2241]
        Angle    160.2462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 102"
}

Galaxy "IC 103:UGC 963:MCG 0-4-117:ZWG 385.107"
{
        Type  "S0"
        RA            1.4100
        Dec           2.0447
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.1828   0.8461  -0.5006]
        Angle    173.3417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 103"
}

Galaxy "IC 105:ZWG 385.109"
{
        Type  "S0"
        RA            1.4128
        Dec           2.0750
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.3486   0.9190   0.1843]
        Angle    155.5118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 105"
}

Galaxy "IC 107:IC 1700:UGC 986:MCG 2-4-41"
{
        Type  "E0"
        RA            1.4233
        Dec          14.8647
        Distance   2.742e+08  # method: V
        Radius     3.988e+04
        AbsMag        -20.72
        Axis    [  0.7286   0.6773   0.1016]
        Angle    132.1770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 107"
}

Galaxy "IC 108:MCG 2-4-41"
{
        Type  "Sa"
        RA            1.4108
        Dec         -12.6356
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.2313   0.8363   0.4971]
        Angle    176.9210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 108"
}

Galaxy "IC 109:UGC 980:MCG 0-4-128:ZWG 385.117"
{
        Type  "S0"
        RA            1.4200
        Dec           2.0675
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.4127   0.8508  -0.3252]
        Angle    174.2116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 109"
}

Galaxy "IC 112:UGC 1008:MCG 2-4-47:ZWG 436.49"
{
        Type  "Irr"
        RA            1.4339
        Dec          11.4431
        Distance   2.475e+08  # method: V
        Radius      2.88e+04
        AbsMag           -20
        Axis    [  0.0654   0.8576  -0.5101]
        Angle    172.7101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 112"
}

Galaxy "IC 113"
{
        Type  "E0"
        RA            1.4403
        Dec          19.1919
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.7333   0.6227   0.2731]
        Angle    111.5042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 113"
}

Galaxy "IC 114:UGC 1015:MCG 2-4-48:ZWG 436.50"
{
        Type  "S0"
        RA            1.4394
        Dec           9.9103
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.0057   0.7544  -0.6564]
        Angle    177.1170
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 114"
}

Galaxy "IC 115:MCG 3-4-39:ZWG 459.54"
{
        Type  "S0"
        RA            1.4483
        Dec          19.2144
        Distance   5.772e+08  # method: V
        Radius     4.198e+04
        AbsMag        -21.04
        Axis    [  0.7139   0.6379   0.2890]
        Angle    112.2745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 115"
}

Galaxy "IC 116:MCG 1-4-49"
{
        Type  "Sc"
        RA            1.4472
        Dec          -4.9822
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.2841   0.7853  -0.5500]
        Angle    178.1215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 116"
}

Galaxy "IC 118:MCG 1-4-53:NPM 1"
{
        Type  "E0"
        RA            1.4600
        Dec          -4.9969
        Distance   5.755e+08  # distance uncertain!
        Radius     4.185e+04
        AbsMag        -20.13
        Axis    [  0.7860   0.5016   0.3615]
        Angle    129.8217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 118"
}

Galaxy "IC 119:UGC 1047:MCG 0-4-157:ZWG 385.149"
{
        Type  "SBa"
        RA            1.4650
        Dec          -2.0400
        Distance   2.571e+08  # method: V
        Radius     4.862e+04
        AbsMag        -19.48
        Axis    [  0.2654   0.9558  -0.1261]
        Angle    162.2235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 119"
}

Galaxy "IC 120:ZWG 385.152:DRCG 7-3"
{
        Type  "S0"
        RA            1.4700
        Dec          -1.9150
        Distance   2.084e+08  # method: V
        Radius     2.728e+04
        AbsMag        -18.73
        Axis    [ -0.0008   0.8231  -0.5679]
        Angle    159.5034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 120"
}

Galaxy "IC 121:UGC 1053:MCG 0-4-159:ZWG 385.154"
{
        Type  "Sc"
        RA            1.4725
        Dec           2.5128
        Distance   4.208e+08  # method: T-F
        Radius     5.508e+04
        AbsMag        -21.15
        Axis    [  0.2188   0.8978  -0.3823]
        Angle    168.4686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 121"
}

Galaxy "IC 122:NPM 1"
{
        Type  "S0"
        RA            1.4703
        Dec         -14.8389
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.3597   0.8265   0.4330]
        Angle    170.2006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 122"
}

Galaxy "IC 123:MCG 0-4-161:ZWG 385.157:ARAK 49"
{
        Type  "S0"
        RA            1.4808
        Dec           2.4469
        Distance   4.021e+08  # method: V
        Radius      2.34e+04
        AbsMag        -20.35
        Axis    [  0.4696   0.8629   0.1870]
        Angle    150.9664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 123"
}

Galaxy "IC 125:MCG 2-4-60:NPM 1"
{
        Type  "S0"
        RA            1.4883
        Dec         -13.2794
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.7845   0.4790   0.3938]
        Angle    137.4355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 125"
}

Galaxy "IC 126:UGC 1071:ZWG 385.162"
{
        Type  "S0"
        RA            1.4964
        Dec          -1.9833
        Distance   2.449e+08  # method: V
        Radius     3.205e+04
        AbsMag        -19.18
        Axis    [  0.7670   0.5307   0.3606]
        Angle    128.3440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 126"
}

Galaxy "IC 127:MCG 1-4-57"
{
        Type  "Sb"
        RA            1.4964
        Dec          -6.9797
        Distance   1.688e+08  # distance uncertain!
        Radius     3.929e+04
        AbsMag        -19.07
        Axis    [  0.0841   0.8587  -0.5055]
        Angle    159.9235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 127"
}

Galaxy "IC 128:MCG 2-4-63"
{
        Type  "SBc"
        RA            1.5231
        Dec         -12.6244
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.2593   0.5662  -0.7824]
        Angle    190.8972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 128"
}

Galaxy "IC 129:MCG 2-5-1:NPM 1"
{
        Type  "Sa"
        RA            1.5253
        Dec         -12.6539
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.4779   0.8784  -0.0067]
        Angle    164.8552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 129"
}

Galaxy "IC 130:MCG 3-5-1:NPM 1"
{
        Type  "S0"
        RA            1.5244
        Dec         -15.5911
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.7907   0.4656   0.3975]
        Angle    139.1614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 130"
}

Galaxy "IC 138:UGC 1106:MCG 0-5-3:ZWG 386.5"
{
        Type  "Sc"
        RA            1.5506
        Dec          -0.6897
        Distance   1.941e+08  # method: V
        Radius     3.105e+04
        AbsMag        -19.17
        Axis    [  0.4816   0.8430   0.2395]
        Angle    151.3328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 138"
}

Galaxy "IC 141:MCG 3-5-4:IRAS 01304-1504"
{
        Type  "SBc"
        RA            1.5475
        Dec         -14.8147
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.5536   0.6814   0.4788]
        Angle    156.3876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 141"
}

Galaxy "IC 144:MCG 2-5-28:NPM 1"
{
        Type  "E0"
        RA            1.6278
        Dec         -13.3142
        Distance   5.249e+08  # distance uncertain!
        Radius     5.344e+04
        AbsMag        -20.13
        Axis    [  0.8113   0.4483   0.3753]
        Angle    135.7397
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 144"
}

Galaxy "IC 145:MCG 0-5-20:ZWG 386.22"
{
        Type  "S0"
        RA            1.6439
        Dec           0.7414
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.0313   0.5702  -0.8209]
        Angle    184.1472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 145"
}

Galaxy "IC 147:MCG 3-5-13:IRAS 01375-1506"
{
        Type  "Sc"
        RA            1.6664
        Dec         -14.8628
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.5023   0.8594  -0.0953]
        Angle    165.3732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 147"
}

Galaxy "IC 148:UGC 1195:MCG 2-5-11:ZWG 437-10"
{
        Type  "Irr"
        RA            1.7072
        Dec          13.9767
        Distance   2.193e+07  # method: V
        Radius     1.116e+04
        AbsMag        -15.24
        Axis    [  0.1128   0.9829   0.1458]
        Angle    149.3061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 148"
}

Galaxy "IC 149:MCG 3-5-15:IRAS 01400-1633"
{
        Type  "S0"
        RA            1.7069
        Dec         -16.3000
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.2627   0.9505  -0.1661]
        Angle    161.4611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 149"
}

Galaxy "IC 150:UGC 1202:MCG 1-5-26:ZWG 412.20"
{
        Type  "Sb"
        RA            1.7158
        Dec           4.1992
        Distance   2.393e+08  # method: V
        Radius      3.48e+04
        AbsMag        -19.43
        Axis    [  0.0770   0.7741  -0.6284]
        Angle    171.6543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 150"
}

Galaxy "IC 152:ZWG 437.16"
{
        Type  "Irr"
        RA            1.7336
        Dec          13.0744
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.0419   0.8517  -0.5223]
        Angle    169.0478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 152"
}

Galaxy "IC 154:UGC 1229:MCG 2-5-23:ZWG 437.21"
{
        Type  "Sb"
        RA            1.7544
        Dec          10.6497
        Distance   1.768e+08  # distance uncertain!
        Radius     3.857e+04
        AbsMag        -19.07
        Axis    [  0.0087   0.9996   0.0267]
        Angle    151.7706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 154"
}

Galaxy "IC 156:UGC 1231:MCG 2-5-25:ZWG 437.22"
{
        Type  "S0"
        RA            1.7581
        Dec          10.5533
        Distance   2.244e+08  # method: V
        Radius     4.895e+04
        AbsMag        -19.29
        Axis    [  0.4100   0.9031  -0.1274]
        Angle    155.5797
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 156"
}

Galaxy "IC 158:NPM 1"
{
        Type  "E0"
        RA            1.7647
        Dec          -6.9353
        Distance   5.755e+08  # distance uncertain!
        Radius     4.185e+04
        AbsMag        -20.13
        Axis    [  0.5665   0.5595  -0.6050]
        Angle    209.1687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 158"
}

Galaxy "IC 159:MCG 2-5-42:IRAS 01439-0853"
{
        Type  "Sb"
        RA            1.7736
        Dec          -8.6367
        Distance   1.651e+08  # method: V
        Radius     3.601e+04
        AbsMag        -19.52
        Axis    [  0.3864   0.8977   0.2118]
        Angle    159.5838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 159"
}

Galaxy "IC 160:MCG 2-5-44:NPM 1"
{
        Type  "S0"
        RA            1.7747
        Dec         -13.2472
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.4352   0.8701  -0.2314]
        Angle    164.6208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 160"
}

Galaxy "IC 161:UGC 1266:MCG 2-5-36:ZWG 437.33"
{
        Type  "S0"
        RA            1.8119
        Dec          10.5083
        Distance   2.227e+08  # method: V
        Radius     2.591e+04
        AbsMag        -19.47
        Axis    [  0.3923   0.9176  -0.0646]
        Angle    151.7064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 161"
}

Galaxy "IC 162:UGC 1267:MCG 2-5-38:MK 1007"
{
        Type  "S0"
        RA            1.8147
        Dec          10.5222
        Distance   2.196e+08  # method: V
        Radius     4.471e+04
        AbsMag        -19.34
        Axis    [  0.7703   0.5607   0.3038]
        Angle    116.6227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 162"
}

Galaxy "IC 163:UGC 1276:MCG 3-5-18:ZWG 460.28"
{
        Type  "Irr"
        RA            1.8208
        Dec          20.7106
        Distance   1.196e+08  # method: T-F
        Radius     3.132e+04
        AbsMag        -19.12
        Axis    [  0.0715   0.9656  -0.2501]
        Angle    155.8180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 163"
}

Galaxy "IC 164:MCG 1-5-37"
{
        Type  "E0"
        RA            1.8189
        Dec          -3.9044
        Distance   2.291e+08  # distance uncertain!
        Radius     4.665e+04
        AbsMag        -20.13
        Axis    [  0.8141   0.4744   0.3350]
        Angle    127.2824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 164"
}

Galaxy "IC 167:UGC 1313:MCG 4-5-21:ZWG 482.25"
{
        Type  "SBc"
        RA            1.8522
        Dec          21.9125
        Distance   1.116e+08  # method: T-F
        Radius     4.383e+04
        AbsMag        -19.07
        Axis    [  0.1666   0.9487  -0.2688]
        Angle    158.4047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 167"
}

Galaxy "IC 168:MCG 2-5-58"
{
        Type  "Sb"
        RA            1.8408
        Dec          -8.5236
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.1938   0.9101  -0.3662]
        Angle    157.7211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 168"
}

Galaxy "IC 169:NPM 1"
{
        Type  "S0"
        RA            1.8442
        Dec         -12.6792
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [  0.4347   0.8802  -0.1905]
        Angle    162.7109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 169"
}

Galaxy "IC 170:MCG 2-5-66:NPM 1"
{
        Type  "E0"
        RA            1.8658
        Dec          -8.5172
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.7519   0.5829  -0.3080]
        Angle    179.4043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 170"
}

Galaxy "IC 171:UGC 1388:MCG 6-5-50:ZWG 522.64"
{
        Type  "S0"
        RA            1.9194
        Dec          35.2819
        Distance   2.277e+08  # method: V
        Radius     4.637e+04
        AbsMag        -20.82
        Axis    [ -0.0177   0.8806  -0.4735]
        Angle    177.6585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 171"
}

Galaxy "IC 172:MCG 0-5-49:ZWG 386.56:ARAK 63"
{
        Type  "S0"
        RA            1.9150
        Dec           0.8117
        Distance   3.577e+08  # method: V
        Radius     2.081e+04
        AbsMag         -20.3
        Axis    [  0.4047   0.8717  -0.2763]
        Angle    162.4988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 172"
}

Galaxy "IC 173:UGC 1402:MCG 0-6-1:ZWG 387.1"
{
        Type  "SBc"
        RA            1.9325
        Dec           1.2847
        Distance   6.177e+08  # method: V
        Radius     8.085e+04
        AbsMag        -21.49
        Axis    [  0.3680   0.8363  -0.4063]
        Angle    168.8685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 173"
}

Galaxy "IC 174:UGC 1409:MCG 1-6-8:ZWG 413.4"
{
        Type  "S0"
        RA            1.9378
        Dec           3.7625
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.2658   0.9005  -0.3440]
        Angle    161.3594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 174"
}

Galaxy "IC 175:ZWG 387.3"
{
        Type  "E0"
        RA            1.9383
        Dec           1.3325
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.8158   0.4872   0.3117]
        Angle    122.4546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 175"
}

Galaxy "IC 176:UGC 1426:MCG 0-6-4:ZWG 387.5"
{
        Type  "Sc"
        RA            1.9481
        Dec          -2.0189
        Distance   2.141e+08  # method: T-F
        Radius     5.918e+04
        AbsMag        -19.29
        Axis    [  0.0684   0.9676  -0.2429]
        Angle    151.7577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 176"
}

Galaxy "IC 177:ZWG 387.7"
{
        Type  "S0"
        RA            1.9500
        Dec          -0.0892
        Distance   6.011e+08  # method: V
        Radius     3.497e+04
        AbsMag        -20.93
        Axis    [  0.5345   0.7524   0.3850]
        Angle    142.9312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 177"
}

Galaxy "IC 178:UGC 1456:MCG 6-5-70:ZWG 522.94"
{
        Type  "Sb"
        RA            1.9817
        Dec          36.6750
        Distance   2.084e+08  # method: V
        Radius     3.941e+04
        AbsMag        -19.93
        Axis    [ -0.1241   0.7747  -0.6201]
        Angle    193.2184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 178"
}

Galaxy "IC 179:UGC 1475:MCG 6-5-75:ZWG 522.101"
{
        Type  "E0"
        RA            2.0031
        Dec          38.0214
        Distance    1.79e+08  # method: V
        Radius     4.166e+04
        AbsMag         -20.3
        Axis    [  0.4048   0.8391  -0.3634]
        Angle    180.4120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 179"
}

Galaxy "IC 180:MCG 4-5-31:ZWG 482.39:NPM 1"
{
        Type  "Sb"
        RA            2.0000
        Dec          23.6050
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.2244   0.7995   0.5572]
        Angle    135.4441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 180"
}

Galaxy "IC 181:MCG 4-5-30:ZWG 482.39:NPM 1"
{
        Type  "E0"
        RA            2.0006
        Dec          23.6592
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [  0.7741   0.5893   0.2315]
        Angle    104.3035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 181"
}

Galaxy "IC 182:UGC 1473:MCG 1-6-26:ZWG 413.22"
{
        Type  "SBb"
        RA            1.9975
        Dec           7.4122
        Distance   2.011e+08  # method: V
        Radius     2.633e+04
        AbsMag        -19.65
        Axis    [  0.4300   0.8772   0.2137]
        Angle    142.7647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 182"
}

Galaxy "IC 183:MCG 1-6-15"
{
        Type  "S0"
        RA            1.9925
        Dec          -5.3472
        Distance   1.698e+08  # method: V
        Radius      3.21e+04
        AbsMag        -18.68
        Axis    [  0.1777   0.9441  -0.2779]
        Angle    154.2857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 183"
}

Galaxy "IC 184:MCG 1-6-21"
{
        Type  "Sa"
        RA            1.9975
        Dec          -6.8406
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.0155   0.5466  -0.8372]
        Angle    169.0879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 184"
}

Galaxy "IC 185:MCG 0-6-19"
{
        Type  "S0"
        RA            2.0017
        Dec          -1.5278
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.2200   0.9493  -0.2247]
        Angle    154.7378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 185"
}

Galaxy "IC 186-1:IC 186A:MCG 0-6-20:ZWG 387.23"
{
        Type  "S0"
        RA            2.0064
        Dec          -1.5533
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.4884   0.8335   0.2584]
        Angle    148.1275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 186-1"
}

Galaxy "IC 186-2:IC 186B:MCG 0-6-21:ZWG 387.23"
{
        Type  "S0"
        RA            2.0069
        Dec          -1.5506
        Distance   2.555e+08  # distance uncertain!
        Radius     1.115e+04
        AbsMag        -19.07
        Axis    [  0.8096   0.4867   0.3281]
        Angle    125.4649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 186-2"
}

Galaxy "IC 187-1:UGC 1507:MCG 4-5-37:ZWG 482.48"
{
        Type  "SBa"
        RA            2.0250
        Dec          26.4811
        Distance   2.592e+08  # method: T-F
        Radius      7.54e+04
        AbsMag         -20.7
        Axis    [  0.0052   1.0000  -0.0078]
        Angle    142.6494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 187-1"
}

Galaxy "IC 187-2:UGC 1507:MCG 4-5-37:ZWG 482.48"
{
        Type  "S0"
        RA            2.0258
        Dec          26.4847
        Distance   1.223e+08  # distance uncertain!
        Radius     1.245e+04
        AbsMag        -19.07
        Axis    [  0.1545   0.9499   0.2718]
        Angle    134.5681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 187-2"
}

Galaxy "IC 189:MCG 4-5-39:ZWG 482.51:IRAS 01590+2318"
{
        Type  "SBc"
        RA            2.0311
        Dec          23.5511
        Distance   5.475e+08  # method: V
        Radius     5.574e+04
        AbsMag        -21.32
        Axis    [  0.1184   0.7952  -0.5947]
        Angle    191.0381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 189"
}

Galaxy "IC 190:MCG 4-5-40:ZWG 482.52:NPM 1"
{
        Type  "E0"
        RA            2.0353
        Dec          23.5503
        Distance   2.042e+08  # method: V
        Radius     2.376e+04
        AbsMag        -18.78
        Axis    [  0.5177   0.7685  -0.3760]
        Angle    179.0793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 190"
}

Galaxy "IC 192:UGC 1530:MCG 3-6-25:ZWG 461.32"
{
        Type  "S0"
        RA            2.0422
        Dec          16.0142
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.0799   0.7361  -0.6721]
        Angle    189.0963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 192"
}

Galaxy "IC 193:UGC 1529:MCG 2-6-16:ZWG 438.17"
{
        Type  "Sc"
        RA            2.0419
        Dec          11.0931
        Distance   1.983e+08  # method: V
        Radius     4.904e+04
        AbsMag        -19.62
        Axis    [  0.1439   0.6714  -0.7270]
        Angle    200.1108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 193"
}

Galaxy "IC 194:UGC 1542:MCG 0-6-26:ZWG 387.30"
{
        Type  "Sb"
        RA            2.0514
        Dec           2.6139
        Distance   2.772e+08  # method: V
        Radius     6.047e+04
        AbsMag        -19.35
        Axis    [  0.1932   0.8731   0.4476]
        Angle    158.4895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 194"
}

Galaxy "IC 195:UGC 1555:MCG 2-6-17:ZWG 438.19"
{
        Type  "S0"
        RA            2.0622
        Dec          14.7092
        Distance   1.531e+08  # method: V
        Radius      3.34e+04
        AbsMag        -19.26
        Axis    [ -0.0574   0.8761  -0.4788]
        Angle    157.1183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 195"
}

Galaxy "IC 196:UGC 1556:MCG 2-6-18:ZWG 438.20"
{
        Type  "SBb"
        RA            2.0636
        Dec          14.7392
        Distance    1.48e+08  # method: V
        Radius     6.025e+04
        AbsMag        -19.48
        Axis    [  0.3348   0.8085   0.4840]
        Angle    137.7069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 196"
}

Galaxy "IC 197:UGC 1564:MCG 0-6-27:ZWG 387.31"
{
        Type  "SBc"
        RA            2.0678
        Dec           2.7867
        Distance   2.747e+08  # method: V
        Radius     3.995e+04
        AbsMag        -20.23
        Axis    [  0.3251   0.9444   0.0501]
        Angle    149.7086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 197"
}

Galaxy "IC 198:UGC 1592:MCG 1-6-40:ZWG 413.40"
{
        Type  "S0"
        RA            2.1008
        Dec           9.2961
        Distance   3.599e+08  # method: T-F
        Radius     5.758e+04
        AbsMag        -20.51
        Axis    [  0.3338   0.9300   0.1537]
        Angle    143.7586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 198"
}

Galaxy "IC 199:IC 1778:UGC 1594:MCG 1-6-41"
{
        Type  "Sb"
        RA            2.1053
        Dec           9.2272
        Distance   4.056e+08  # method: V
        Radius     8.258e+04
        AbsMag        -20.47
        Axis    [  0.3819   0.8738   0.3011]
        Angle    141.0310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 199"
}

Galaxy "IC 200:UGC 1577:MCG 5-6-2:ZWG 503.85"
{
        Type  "SBb"
        RA            2.0906
        Dec          31.1756
        Distance   2.278e+08  # method: V
        Radius     6.957e+04
        AbsMag        -20.42
        Axis    [  0.1588   0.9687  -0.1906]
        Angle    148.8754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 200"
}

Galaxy "IC 201:NPM 1"
{
        Type  "S0"
        RA            2.1208
        Dec           9.1156
        Distance   4.869e+08  # distance uncertain!
        Radius     4.249e+04
        AbsMag        -19.07
        Axis    [  0.8002   0.5239   0.2920]
        Angle    116.0252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 201"
}

Galaxy "IC 202:UGC 1610:MCG 1-6-43:ZWG 413.44"
{
        Type  "Sb"
        RA            2.1244
        Dec           9.1686
        Distance   4.002e+08  # method: V
        Radius     8.149e+04
        AbsMag        -20.24
        Axis    [ -0.1242   0.8469  -0.5171]
        Angle    150.1369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 202"
}

Galaxy "IC 203:NPM 1"
{
        Type  "S0"
        RA            2.1247
        Dec           9.1231
        Distance   5.098e+08  # distance uncertain!
        Radius     4.449e+04
        AbsMag        -19.07
        Axis    [  0.4426   0.8522   0.2791]
        Angle    138.7750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 203"
}

Galaxy "IC 204:ZWG 387.39:NPM 1"
{
        Type  "E0"
        RA            2.1242
        Dec          -1.4297
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.3589   0.5400  -0.7613]
        Angle    222.2350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 204"
}

Galaxy "IC 205:UGC 1613:MCG 0-6-34:ZWG 387.38"
{
        Type  "SBa"
        RA            2.1242
        Dec          -2.0919
        Distance   3.651e+08  # method: V
        Radius     4.779e+04
        AbsMag        -20.54
        Axis    [  0.8200   0.4732   0.3220]
        Angle    125.3721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 205"
}

Galaxy "IC 206:MCG 1-6-53:KUG 0207-072"
{
        Type  "S0"
        RA            2.1583
        Dec          -6.9689
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.1183   0.7740  -0.6220]
        Angle    157.7807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 206"
}

Galaxy "IC 207:MCG 1-6-54:IRAS 02071-0709"
{
        Type  "Sa"
        RA            2.1608
        Dec          -6.9225
        Distance   1.938e+08  # distance uncertain!
        Radius     6.202e+04
        AbsMag        -19.07
        Axis    [  0.0961   0.9507  -0.2948]
        Angle    148.7795
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 207"
}

Galaxy "IC 208:UGC 1635:MCG 1-6-44:ZWG 413.45"
{
        Type  "Sc"
        RA            2.1408
        Dec           6.3947
        Distance   1.442e+08  # method: V
        Radius     2.726e+04
        AbsMag        -18.93
        Axis    [  0.8071   0.5094   0.2985]
        Angle    118.1755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 208"
}

Galaxy "IC 209:MCG 1-6-51:IRAS 02064-0717"
{
        Type  "Sc"
        RA            2.1494
        Dec          -7.0592
        Distance   1.281e+08  # distance uncertain!
        Radius     3.167e+04
        AbsMag        -19.07
        Axis    [  0.5501   0.8334  -0.0526]
        Angle    154.7919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 209"
}

Galaxy "IC 210:MCG 2-6-32:KUG 0206-099B:IRAS 02070-0954"
{
        Type  "Sc"
        RA            2.1578
        Dec          -9.6797
        Distance   1.281e+08  # distance uncertain!
        Radius     4.284e+04
        AbsMag        -19.07
        Axis    [  0.2798   0.9592  -0.0401]
        Angle    154.6998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 210"
}

Galaxy "IC 211:UGC 1678:MCG 1-6-53:ZWG 413.57"
{
        Type  "Sc"
        RA            2.1856
        Dec           3.8519
        Distance   1.356e+08  # method: V
        Radius     4.537e+04
        AbsMag        -19.39
        Axis    [  0.5250   0.8478   0.0749]
        Angle    144.3539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 211"
}

Galaxy "IC 212:ZWG 461.62:NPM 1"
{
        Type  "Sc"
        RA            2.2272
        Dec          16.5944
        Distance   4.908e+08  # method: V
        Radius     6.425e+04
        AbsMag        -20.49
        Axis    [  0.3272   0.9160  -0.2321]
        Angle    152.2786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 212"
}

Galaxy "IC 213:UGC 1719:MCG 3-6-46:ZWG 461.67"
{
        Type  "SBb"
        RA            2.2344
        Dec          16.4561
        Distance   3.608e+08  # method: V
        Radius      9.97e+04
        AbsMag        -20.42
        Axis    [  0.0997   0.7610  -0.6411]
        Angle    184.2293
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 213"
}

Galaxy "IC 214:UGC 1720:MCG 1-6-57:MK 1027"
{
        Type  "Irr"
        RA            2.2347
        Dec           5.1761
        Distance   3.986e+08  # method: V
        Radius     4.058e+04
        AbsMag        -20.84
        Axis    [  0.1641   0.6556  -0.7370]
        Angle    192.3315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 214"
}

Galaxy "IC 215:MCG 1-6-76:IRAS 02116-0702"
{
        Type  "Sb"
        RA            2.2358
        Dec          -6.8061
        Distance   2.802e+08  # distance uncertain!
        Radius     4.483e+04
        AbsMag        -19.07
        Axis    [  0.2065   0.9653  -0.1599]
        Angle    150.9755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 215"
}

Galaxy "IC 216:ZWG 387.61"
{
        Type  "E0"
        RA            2.2653
        Dec          -2.0147
        Distance   3.981e+08  # distance uncertain!
        Radius     1.737e+04
        AbsMag        -20.13
        Axis    [  0.8510   0.5055   0.1426]
        Angle    133.2350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 216"
}

Galaxy "IC 217:IC 1787:MCG 2-6-46:IRAS 02137-1209"
{
        Type  "Sc"
        RA            2.2694
        Dec         -11.9256
        Distance   7.484e+07  # method: V
        Radius     2.395e+04
        AbsMag         -17.5
        Axis    [  0.2866   0.9380   0.1950]
        Angle    159.5635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 217"
}

Galaxy "IC 218:MCG 0-6-61:ZWG 387.66:KCPG 62B"
{
        Type  "Sc"
        RA            2.2853
        Dec           1.2825
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.1354   0.9855  -0.1019]
        Angle    147.6404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 218"
}

Galaxy "IC 219:MCG 1-6-88"
{
        Type  "E0"
        RA            2.3106
        Dec          -6.9031
        Distance   2.631e+08  # distance uncertain!
        Radius     3.826e+04
        AbsMag        -20.13
        Axis    [  0.8662   0.4713   0.1664]
        Angle    135.7194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 219"
}

Galaxy "IC 220:MCG 2-6-57:IRAS 02167-1300"
{
        Type  "Sc"
        RA            2.3197
        Dec         -12.7814
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.3767   0.9041   0.2017]
        Angle    158.2534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 220"
}

Galaxy "IC 221:UGC 1835:MCG 5-6-34:ZWG 504.68"
{
        Type  "Sc"
        RA            2.3778
        Dec          28.2569
        Distance   2.638e+08  # method: T-F
        Radius     6.139e+04
        AbsMag        -20.74
        Axis    [  0.4468   0.8034   0.3936]
        Angle    115.7734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 221"
}

Galaxy "IC 222:MCG 2-7-4:ZWG 439.3"
{
        Type  "Sc"
        RA            2.3797
        Dec          11.6386
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.4279   0.8544   0.2949]
        Angle    135.1448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 222"
}

Galaxy "IC 223:ESO 545-8:MCG 4-6-31:IRAS 02197-2058"
{
        Type  "Irr"
        RA            2.3669
        Dec         -20.7458
        Distance   6.256e+07  # method: V
        Radius     1.092e+04
        AbsMag        -17.41
        Axis    [  0.2371   0.6172  -0.7502]
        Angle    163.1283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 223"
}

Galaxy "IC 224:MCG 2-7-5"
{
        Type  "S0"
        RA            2.4125
        Dec         -12.5639
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.3724   0.6855  -0.6256]
        Angle    172.2532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 224"
}

Galaxy "IC 225:UGC 1907:MCG 0-7-13:MK 1038"
{
        Type  "E0"
        RA            2.4411
        Dec           1.1608
        Distance   5.771e+07  # method: V
        Radius          8394
        AbsMag        -16.94
        Axis    [  0.3371   0.5650  -0.7531]
        Angle    217.7970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 225"
}

Galaxy "IC 226:UGC 1922:MCG 5-6-46"
{
        Type  "S0"
        RA            2.4625
        Dec          28.2089
        Distance   4.831e+08  # method: V
        Radius     1.194e+05
        AbsMag        -21.25
        Axis    [  0.0839   0.8009  -0.5930]
        Angle    189.0205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 226"
}

Galaxy "IC 227:UGC 1932:MCG 5-6-48:ZWG 504.87"
{
        Type  "E0"
        RA            2.4675
        Dec          28.1756
        Distance   4.366e+08  # distance uncertain!
        Radius     8.254e+04
        AbsMag        -20.13
        Axis    [  0.6412   0.7438  -0.1887]
        Angle    137.8502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 227"
}

Galaxy "IC 230:MCG 2-7-16"
{
        Type  "E0"
        RA            2.4797
        Dec         -10.8317
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.7575   0.5421  -0.3638]
        Angle    174.1974
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 230"
}

Galaxy "IC 231:UGC 1978:MCG 0-7-25:ZWG 388.26"
{
        Type  "S0"
        RA            2.4989
        Dec           1.1794
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.1479   0.6491  -0.7462]
        Angle    182.4574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 231"
}

Galaxy "IC 232:UGC 1994:MCG 0-7-28:ZWG 388.30"
{
        Type  "E0"
        RA            2.5197
        Dec           1.2661
        Distance   2.772e+08  # method: V
        Radius     5.242e+04
        AbsMag        -20.45
        Axis    [  0.4063   0.5885  -0.6990]
        Angle    209.3379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 232"
}

Galaxy "IC 233:ZWG 388.36:KCPG 69B:IRAS 02290+235"
{
        Type  "Sc"
        RA            2.5278
        Dec           2.8106
        Distance    2.03e+08  # distance uncertain!
        Radius     1.181e+04
        AbsMag        -19.07
        Axis    [  0.3461   0.8431  -0.4117]
        Angle    158.5353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 233"
}

Galaxy "IC 234:MK 1045:ZWG 388.34:KUG 0229-003"
{
        Type  "S0"
        RA            2.5269
        Dec          -0.1394
        Distance   2.617e+08  # method: V
        Radius     2.284e+04
        AbsMag        -19.22
        Axis    [ -0.0222   0.7334  -0.6795]
        Angle    152.6198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 234"
}

Galaxy "IC 235:UGC 2016:MK 368:ZWG 462.22"
{
        Type  "Irr"
        RA            2.5472
        Dec          20.6414
        Distance   3.844e+08  # method: V
        Radius     2.236e+04
        AbsMag        -20.36
        Axis    [  0.5128   0.7395   0.4361]
        Angle    119.5915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 235"
}

Galaxy "IC 236:NPM 1"
{
        Type  "S0"
        RA            2.5486
        Dec          -0.1308
        Distance   4.869e+08  # distance uncertain!
        Radius     4.249e+04
        AbsMag        -19.07
        Axis    [  0.4342   0.8528   0.2900]
        Angle    145.0143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 236"
}

Galaxy "IC 237:MCG 0-7-42:ZWG 388.50"
{
        Type  "S0"
        RA            2.5586
        Dec           1.1397
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.8492   0.4440   0.2858]
        Angle    120.6442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 237"
}

Galaxy "IC 238:UGC 2070:MCG 2-7-16:ZWG 439.18"
{
        Type  "S0"
        RA            2.5894
        Dec          12.8383
        Distance   2.615e+08  # method: V
        Radius     4.564e+04
        AbsMag        -20.62
        Axis    [  0.3537   0.8944   0.2738]
        Angle    135.2954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 238"
}

Galaxy "IC 239:UGC 2080:MCG 6-6-65:ZWG 523.71"
{
        Type  "SBa"
        RA            2.6075
        Dec          38.9689
        Distance   3.171e+07  # method: V
        Radius     2.122e+04
        AbsMag        -18.04
        Axis    [  0.5754   0.7433   0.3412]
        Angle     96.4324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 239"
}

Galaxy "IC 241:UGC 2115:MCG 0-7-58:ZWG 388.71"
{
        Type  "S0"
        RA            2.6317
        Dec           2.3278
        Distance   3.035e+08  # method: V
        Radius     4.856e+04
        AbsMag        -20.44
        Axis    [  0.0953   0.7161  -0.6915]
        Angle    167.0390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 241"
}

Galaxy "IC 243:MCG 1-7-26:NPM 1"
{
        Type  "SBa"
        RA            2.6422
        Dec          -6.9017
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.5664   0.7994   0.2003]
        Angle    146.0565
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 243"
}

Galaxy "IC 244:MCG 0-7-74:ZWG 388.88:KUG 0236+025"
{
        Type  "Sc"
        RA            2.6567
        Dec           2.7275
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.4909   0.7562   0.4327]
        Angle    140.6074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 244"
}

Galaxy "IC 245:MCG 3-7-46:IRAS 02365-1431"
{
        Type  "S0"
        RA            2.6483
        Dec         -14.3061
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [  0.3898   0.8650   0.3159]
        Angle    160.3581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 245"
}

Galaxy "IC 246:MCG 0-7-78:ZWG 388.93:NPM 1"
{
        Type  "S0"
        RA            2.6744
        Dec           2.4792
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4134   0.9071  -0.0790]
        Angle    143.5424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 246"
}

Galaxy "IC 247:MCG 2-7-52:NPM 1"
{
        Type  "Sc"
        RA            2.6689
        Dec         -11.7333
        Distance   3.748e+08  # method: V
        Radius     6.542e+04
        AbsMag         -20.5
        Axis    [  0.6774   0.7352   0.0259]
        Angle    149.1192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 247"
}

Galaxy "IC 248:UGC 2170:MCG 3-7-44:ZWG 462.43"
{
        Type  "Sa"
        RA            2.6903
        Dec          17.8119
        Distance   3.985e+08  # method: V
        Radius     5.216e+04
        AbsMag        -21.03
        Axis    [  0.0215   0.7908  -0.6117]
        Angle    168.7434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 248"
}

Galaxy "IC 250:MCG 2-7-64"
{
        Type  "SBb"
        RA            2.6817
        Dec         -13.3136
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.3836   0.7015  -0.6006]
        Angle    165.8027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 250"
}

Galaxy "IC 251:MCG 3-7-54:NPM 1"
{
        Type  "S0"
        RA            2.6869
        Dec         -14.9581
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.8769   0.3684   0.3087]
        Angle    134.3843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 251"
}

Galaxy "IC 252-1"
{
        Type  "S0"
        RA            2.6958
        Dec         -14.8478
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.5625   0.7762   0.2848]
        Angle    153.8142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 252-1"
}

Galaxy "IC 252-2"
{
        Type  "S0"
        RA            2.6958
        Dec         -14.8453
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.5919   0.8041   0.0559]
        Angle    151.5629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 252-2"
}

Galaxy "IC 253:MCG 3-7-58:NPM 1"
{
        Type  "E0"
        RA            2.7014
        Dec         -15.0472
        Distance   3.312e+08  # distance uncertain!
        Radius     4.335e+04
        AbsMag        -20.13
        Axis    [  0.4556   0.4657  -0.7587]
        Angle    205.8704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 253"
}

Galaxy "IC 254"
{
        Type  "S0"
        RA            2.7011
        Dec         -15.1072
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.5285   0.7776  -0.3408]
        Angle    157.0005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 254"
}

Galaxy "IC 255:MCG 3-8-8:ZWG 463.12"
{
        Type  "SBc"
        RA            2.7842
        Dec          16.2889
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.2638   0.9494   0.1706]
        Angle    132.9740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 255"
}

Galaxy "IC 256:ZW 280"
{
        Type  "E0"
        RA            2.8278
        Dec          46.9544
        Distance   1.318e+09  # distance uncertain!
        Radius     9.588e+04
        AbsMag        -20.13
        Axis    [  0.7373   0.6746   0.0360]
        Angle     86.6080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 256"
}

Galaxy "IC 257:UGC 2298:MCG 8-6-11:ZWG 554.8"
{
        Type  "S0"
        RA            2.8292
        Dec          46.9756
        Distance    8.86e+07  # distance uncertain!
        Radius     1.804e+04
        AbsMag        -19.07
        Axis    [ -0.2641   0.8105  -0.5229]
        Angle    174.9154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 257"
}

Galaxy "IC 258:UGC 2306:ZWG 539.107:KCPG 79B"
{
        Type  "SBa"
        RA            2.8292
        Dec          41.0519
        Distance   2.714e+08  # method: V
        Radius     3.947e+04
        AbsMag           -19
        Axis    [  0.3554   0.7593   0.5451]
        Angle    105.7218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 258"
}

Galaxy "IC 259:ZWG 539.106:NPM 1:KCPG 79A"
{
        Type  "S0"
        RA            2.8278
        Dec          41.0556
        Distance   2.355e+08  # method: V
        Radius     2.398e+04
        AbsMag        -18.99
        Axis    [  0.5421   0.7304   0.4155]
        Angle     94.5836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 259"
}

Galaxy "IC 260:UGC 2325:MCG 8-6-14:ZWG 554.11"
{
        Type  "E0"
        RA            2.8500
        Dec          46.9550
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [  0.0966   0.8394  -0.5349]
        Angle    222.3353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 260"
}

Galaxy "IC 262:UGC 2335:MCG 7-6-80:ZWG 539.114"
{
        Type  "S0"
        RA            2.8619
        Dec          42.8283
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [  0.3125   0.9465  -0.0807]
        Angle    122.7313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 262"
}

Galaxy "IC 263:ZWG 389.27"
{
        Type  "S0"
        RA            2.8275
        Dec          -0.0697
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.5737   0.6847   0.4494]
        Angle    138.8066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 263"
}

Galaxy "IC 264:MK 1401:NPM 1"
{
        Type  "E0"
        RA            2.8131
        Dec          -0.1086
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.8502   0.5235  -0.0560]
        Angle    138.4178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 264"
}

Galaxy "IC 265:MCG 7-7-6:ZWG 540.9:ZWG 539.127"
{
        Type  "E0"
        RA            2.9119
        Dec          41.6558
        Distance   5.012e+08  # distance uncertain!
        Radius     5.103e+04
        AbsMag        -20.13
        Axis    [  0.8078   0.5756   0.1271]
        Angle     83.7100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 265"
}

Galaxy "IC 266:MCG 7-7-10:ZWG 539.130:ZWG 540.12"
{
        Type  "S0"
        RA            2.9178
        Dec          42.2639
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.1488   0.9082  -0.3913]
        Angle    154.9103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 266"
}

Galaxy "IC 267:UGC 2368:MCG 2-8-28:ZWG 440.28"
{
        Type  "SBb"
        RA            2.8972
        Dec          12.8492
        Distance   1.521e+08  # method: V
        Radius     3.539e+04
        AbsMag        -19.54
        Axis    [ -0.1074   0.7284  -0.6767]
        Angle    158.0409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 267"
}

Galaxy "IC 268:MCG 2-8-24"
{
        Type  "SBa"
        RA            2.9239
        Dec         -14.1033
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.5018   0.8466  -0.1777]
        Angle    148.7373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 268"
}

Galaxy "IC 269:MCG 2-8-23:NPM 1"
{
        Type  "S0"
        RA            2.9239
        Dec         -14.0664
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.0783   0.8402  -0.5366]
        Angle    135.2272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 269"
}

Galaxy "IC 270:MCG 2-8-28:NPM 1"
{
        Type  "S0"
        RA            2.9289
        Dec         -14.2075
        Distance   1.281e+08  # distance uncertain!
        Radius     3.167e+04
        AbsMag        -19.07
        Axis    [  0.6086   0.6993  -0.3749]
        Angle    158.7970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 270"
}

Galaxy "IC 271:MCG 2-8-29"
{
        Type  "S0"
        RA            2.9331
        Dec         -12.0083
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.3382   0.7564  -0.5599]
        Angle    155.3988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 271"
}

Galaxy "IC 272:MCG 2-8-30:IRAS 02537-1423"
{
        Type  "Sc"
        RA            2.9350
        Dec         -14.1869
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.1078   0.5245  -0.8445]
        Angle    168.7280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 272"
}

Galaxy "IC 273:UGC 2425:MCG 0-8-52:ZWG 389.52"
{
        Type  "SBa"
        RA            2.9528
        Dec           2.7761
        Distance   1.362e+08  # method: V
        Radius     2.971e+04
        AbsMag         -18.8
        Axis    [  0.3472   0.8976   0.2715]
        Angle    141.6003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 273"
}

Galaxy "IC 275-1:ZW 309"
{
        Type  "E0"
        RA            3.0153
        Dec          44.3503
        Distance       1e+09  # distance uncertain!
        Radius     4.364e+04
        AbsMag        -20.13
        Axis    [  0.8091   0.5767   0.1132]
        Angle     80.7864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 275-1"
}

Galaxy "IC 275-2:ZW 309"
{
        Type  "E0"
        RA            3.0153
        Dec          44.3461
        Distance   1.097e+09  # distance uncertain!
        Radius      3.19e+04
        AbsMag        -20.13
        Axis    [  0.8091   0.5767   0.1132]
        Angle     80.7897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 275-2"
}

Galaxy "IC 275-3:ZW 309:NPM 1"
{
        Type  "E0"
        RA            3.0161
        Dec          44.3506
        Distance   7.245e+08  # distance uncertain!
        Radius     2.107e+04
        AbsMag        -20.13
        Axis    [  0.8092   0.5766   0.1132]
        Angle     80.7801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 275-3"
}

Galaxy "IC 276:MCG 3-8-54"
{
        Type  "S0"
        RA            2.9781
        Dec         -15.7033
        Distance   1.282e+08  # method: V
        Radius     3.731e+04
        AbsMag        -18.87
        Axis    [  0.3418   0.9397  -0.0141]
        Angle    147.5843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 276"
}

Galaxy "IC 277:UGC 2460:MCG 0-8-64:MK 602"
{
        Type  "SBc"
        RA            2.9972
        Dec           2.7711
        Distance   1.199e+08  # method: V
        Radius     2.266e+04
        AbsMag        -18.93
        Axis    [  0.5567   0.8135   0.1683]
        Angle    135.1496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 277"
}

Galaxy "IC 278:UGC 2481:MCG 6-7-32:ZWG 524.44"
{
        Type  "E0"
        RA            3.0250
        Dec          37.7664
        Distance    3.02e+08  # distance uncertain!
        Radius     4.832e+04
        AbsMag        -20.13
        Axis    [  0.8311   0.5386   0.1383]
        Angle     86.1211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 278"
}

Galaxy "IC 279:ZWG 463.45"
{
        Type  "Sc"
        RA            3.0200
        Dec          16.2092
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.5861   0.6768   0.4455]
        Angle    119.8069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 279"
}

Galaxy "IC 283:MCG 0-8-76:ZWG 389.69:KUG 0301-003"
{
        Type  "S0"
        RA            3.0639
        Dec          -0.2044
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.5291   0.7935   0.3007]
        Angle    138.8220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 283"
}

Galaxy "IC 284:UGC 2531:MCG 7-7-23:ZWG 540.37"
{
        Type  "Irr"
        RA            3.1025
        Dec          42.3717
        Distance   1.157e+08  # method: V
        Radius     6.395e+04
        AbsMag        -20.15
        Axis    [  0.1664   0.8193   0.5486]
        Angle    114.6920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 284"
}

Galaxy "IC 285:MCG 2-8-44"
{
        Type  "Sb"
        RA            3.0683
        Dec         -12.0150
        Distance   1.759e+08  # method: V
        Radius     2.815e+04
        AbsMag        -18.16
        Axis    [  0.0915   0.8810  -0.4641]
        Angle    133.8930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 285"
}

Galaxy "IC 287:NPM 1"
{
        Type  "S0"
        RA            3.0825
        Dec         -12.0700
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.5528   0.7500   0.3632]
        Angle    151.3258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 287"
}

Galaxy "IC 288:UGC 2544:MCG 7-7-27:ZWG 540.43"
{
        Type  "S0"
        RA            3.1256
        Dec          42.3878
        Distance   2.232e+08  # method: V
        Radius     3.246e+04
        AbsMag        -19.08
        Axis    [  0.0223   0.9455   0.3249]
        Angle    117.1385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 288"
}

Galaxy "IC 290:IC 1884:UGC 2561:ZWG 540.47"
{
        Type  "Sb"
        RA            3.1617
        Dec          40.9750
        Distance   2.654e+08  # method: V
        Radius     4.246e+04
        AbsMag        -18.95
        Axis    [ -0.3955   0.8461  -0.3574]
        Angle    142.2651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 290"
}

Galaxy "IC 291:MCG 2-9-1:IRAS 03050-1246"
{
        Type  "Sa"
        RA            3.1239
        Dec         -12.5869
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.3838   0.8673  -0.3171]
        Angle    144.0227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 291"
}

Galaxy "IC 292:IC 1887:UGC 2567:MCG 7-7-30"
{
        Type  "Irr"
        RA            3.1700
        Dec          40.7658
        Distance   1.292e+08  # method: V
        Radius     2.254e+04
        AbsMag        -18.79
        Axis    [  0.0692   0.9960  -0.0557]
        Angle    124.5119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 292"
}

Galaxy "IC 293:IC 1888:MCG 7-7-31:ZWG 540.53"
{
        Type  "S0"
        RA            3.1822
        Dec          41.1378
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.0584   0.9803  -0.1889]
        Angle    132.6043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 293"
}

Galaxy "IC 294:IC 295:IC 296:IC 1889"
{
        Type  "SBa"
        RA            3.1842
        Dec          40.6217
        Distance   2.196e+08  # method: V
        Radius     6.708e+04
        AbsMag        -18.94
        Axis    [ -0.0357   0.9165  -0.3985]
        Angle    153.4566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 294"
}

Galaxy "IC 298:MCG 0-9-15:ZWG 390.16:ARP 147"
{
        Type  "Irr"
        RA            3.1883
        Dec           1.3158
        Distance   4.289e+08  # method: V
        Radius     4.991e+04
        AbsMag        -19.79
        Axis    [  0.3374   0.7316  -0.5924]
        Angle    164.2802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 298"
}

Galaxy "IC 298A:MCG 0-9-16:UGCA 57:IRAS 03087+0107"
{
        Type  "Irr"
        RA            3.1886
        Dec           1.3133
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [  0.3995   0.7871   0.4701]
        Angle    147.2606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 298A"
}

Galaxy "IC 299:NPM 1"
{
        Type  "E0"
        RA            3.1839
        Dec         -13.1092
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.9178   0.3048   0.2543]
        Angle    130.3927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 299"
}

Galaxy "IC 300"
{
        Type  "S0"
        RA            3.2375
        Dec          42.4150
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8205   0.5532   0.1443]
        Angle     81.2210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 300"
}

Galaxy "IC 301:UGC 2606:MCG 7-7-36:ZWG 540.63"
{
        Type  "E0"
        RA            3.2464
        Dec          42.2231
        Distance   3.031e+08  # method: V
        Radius     3.526e+04
        AbsMag        -20.14
        Axis    [  0.8395   0.5312   0.1146]
        Angle     80.9352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 301"
}

Galaxy "IC 302:UGC 2595:MCG 1-9-2:ZWG 416.4"
{
        Type  "SBc"
        RA            3.2142
        Dec           4.7064
        Distance    2.59e+08  # method: V
        Radius      6.78e+04
        AbsMag         -20.9
        Axis    [  0.6806   0.7004   0.2152]
        Angle    127.6913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 302"
}

Galaxy "IC 303:NPM 1"
{
        Type  "E0"
        RA            3.2111
        Dec         -11.6894
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [  0.9150   0.4035   0.0032]
        Angle    139.7534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 303"
}

Galaxy "IC 304:UGC 2609:MCG 6-8-5:ZWG 525.10"
{
        Type  "Sb"
        RA            3.2503
        Dec          37.8819
        Distance   2.709e+08  # method: T-F
        Radius     4.334e+04
        AbsMag         -19.9
        Axis    [  0.3551   0.8752   0.3285]
        Angle    107.2288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 304"
}

Galaxy "IC 305:MCG 6-8-6:ZWG 525.12:NPM 1"
{
        Type  "E0"
        RA            3.2508
        Dec          37.8606
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [  0.6759   0.7179  -0.1666]
        Angle    112.8829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 305"
}

Galaxy "IC 306:MCG 2-9-15"
{
        Type  "SBc"
        RA            3.2167
        Dec         -11.7158
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.4700   0.8451  -0.2549]
        Angle    144.2067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 306"
}

Galaxy "IC 307:UGC 2600:MCG 0-9-27:ZWG 390.28"
{
        Type  "Sa"
        RA            3.2292
        Dec          -0.2411
        Distance    1.54e+08  # distance uncertain!
        Radius     3.807e+04
        AbsMag        -19.07
        Axis    [  0.3444   0.9288  -0.1364]
        Angle    137.0082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 307"
}

Galaxy "IC 308:UGC 2619"
{
        Type  "S0"
        RA            3.2708
        Dec          41.1814
        Distance   2.778e+08  # method: V
        Radius     4.848e+04
        AbsMag        -19.25
        Axis    [  0.8277   0.5416   0.1472]
        Angle     82.0494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 308"
}

Galaxy "IC 309:MCG 7-7-43:ZWG 540.72"
{
        Type  "S0"
        RA            3.2683
        Dec          40.8047
        Distance   1.845e+08  # method: V
        Radius     2.415e+04
        AbsMag        -18.96
        Axis    [  0.8285   0.5399   0.1484]
        Angle     82.3879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 309"
}

Galaxy "IC 310:UGC 2624:MCG 7-7-45:ZWG 540.75"
{
        Type  "S0"
        RA            3.2786
        Dec          41.3247
        Distance   2.617e+08  # method: T-F
        Radius     4.187e+04
        AbsMag        -20.52
        Axis    [  0.8280   0.5412   0.1465]
        Angle     81.8757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 310"
}

Galaxy "IC 311:UGC 2625:ZWG 540.76"
{
        Type  "S0"
        RA            3.2794
        Dec          40.0042
        Distance   1.854e+08  # method: V
        Radius     2.427e+04
        AbsMag        -18.37
        Axis    [ -0.0240   0.9411  -0.3372]
        Angle    144.4435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 311"
}

Galaxy "IC 312:UGC 2644:MCG 7-7-51:ZWG 540.86"
{
        Type  "E0"
        RA            3.3022
        Dec          41.7544
        Distance   2.119e+08  # method: V
        Radius     3.082e+04
        AbsMag        -19.26
        Axis    [  0.3200   0.8317  -0.4536]
        Angle    174.0842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 312"
}

Galaxy "IC 313:UGC 2682:MCG 7-7-73:ZWG 540.111"
{
        Type  "E0"
        RA            3.3492
        Dec          41.8942
        Distance   1.937e+08  # method: V
        Radius     2.535e+04
        AbsMag        -18.77
        Axis    [  0.8504   0.5139   0.1124]
        Angle     80.5435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 313"
}

Galaxy "IC 315:ZWG 416.6:NPM 1"
{
        Type  "S0"
        RA            3.3192
        Dec           4.0392
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.4164   0.8856   0.2057]
        Angle    134.5267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 315"
}

Galaxy "IC 316-1:MCG 7-7-74:ZWG 540.112"
{
        Type  "S0"
        RA            3.3553
        Dec          41.9286
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [ -0.3413   0.9211  -0.1876]
        Angle    132.0158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 316-1"
}

Galaxy "IC 316-2:UGC 2688:ZWG 540.112:IRAS 03179+4145"
{
        Type  "Sc"
        RA            3.3553
        Dec          41.9319
        Distance   1.287e+08  # method: V
        Radius      2.62e+04
        AbsMag        -18.08
        Axis    [  0.0659   0.9953   0.0704]
        Angle    117.1608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 316-2"
}

Galaxy "IC 317:MCG 2-9-26:IRAS 03165-1255"
{
        Type  "SBa"
        RA            3.3153
        Dec         -12.7397
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.6954   0.7170   0.0493]
        Angle    143.0431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 317"
}

Galaxy "IC 318:MCG 3-9-23:IRAS 03183-1444"
{
        Type  "Sc"
        RA            3.3453
        Dec         -14.5681
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.1080   0.7437  -0.6598]
        Angle    136.6419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 318"
}

Galaxy "IC 320:UGC 2732:MCG 7-8-7:ZWG 541.6"
{
        Type  "SBb"
        RA            3.4331
        Dec          40.7892
        Distance    3.09e+08  # method: V
        Radius     5.393e+04
        AbsMag        -19.78
        Axis    [  0.4747   0.8797  -0.0294]
        Angle    108.2571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 320"
}

Galaxy "IC 321:MCG 3-9-35:NPM 1"
{
        Type  "S0"
        RA            3.4081
        Dec         -14.9858
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.9209   0.2998   0.2493]
        Angle    132.2925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 321"
}

Galaxy "IC 322:ZWG 390.89:ZWG 416.8"
{
        Type  "E0"
        RA            3.4333
        Dec           3.6803
        Distance    4.09e+08  # method: V
        Radius     5.353e+04
        AbsMag        -20.29
        Axis    [  0.9197   0.3350   0.2048]
        Angle    114.2057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 322"
}

Galaxy "IC 325:NPM 1"
{
        Type  "Sb"
        RA            3.5133
        Dec          -7.0464
        Distance   4.241e+08  # distance uncertain!
        Radius     4.934e+04
        AbsMag        -19.07
        Axis    [  0.9213   0.3135   0.2302]
        Angle    124.5683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 325"
}

Galaxy "IC 326:MCG 3-9-49:NPM 1"
{
        Type  "S0"
        RA            3.5100
        Dec         -14.4250
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.3869   0.7362  -0.5552]
        Angle    147.9355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 326"
}

Galaxy "IC 327:MCG 3-9-50"
{
        Type  "Sc"
        RA            3.5194
        Dec         -14.6922
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [  0.5522   0.8276  -0.1002]
        Angle    141.5777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 327"
}

Galaxy "IC 328:MCG 3-9-51:IRAS 03288-1448"
{
        Type  "Sc"
        RA            3.5197
        Dec         -14.6378
        Distance   1.938e+08  # distance uncertain!
        Radius      1.41e+04
        AbsMag        -19.07
        Axis    [  0.7553   0.6123   0.2334]
        Angle    142.3087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 328"
}

Galaxy "IC 329:MCG 0-10-1:ZWG 391.2:NPM 1"
{
        Type  "S0"
        RA            3.5336
        Dec           0.2800
        Distance   3.167e+08  # method: V
        Radius     4.146e+04
        AbsMag        -19.74
        Axis    [  0.3794   0.9239  -0.0491]
        Angle    132.4486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 329"
}

Galaxy "IC 330:UGC 2779:MCG 0-10-2:ZWG 391.4"
{
        Type  "Sb"
        RA            3.5353
        Dec           0.3533
        Distance   4.063e+08  # method: V
        Radius     7.092e+04
        AbsMag        -20.38
        Axis    [  0.1964   0.9731  -0.1205]
        Angle    130.1932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 330"
}

Galaxy "IC 331:MCG 0-10-3:ZWG 391.5:IRAS 03296+0005"
{
        Type  "S0"
        RA            3.5386
        Dec           0.2828
        Distance   3.048e+08  # method: V
        Radius      3.99e+04
        AbsMag        -20.15
        Axis    [  0.9169   0.3340   0.2182]
        Angle    117.6378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 331"
}

Galaxy "IC 332:MCG 0-10-4:ZWG 391.6:KARA 129"
{
        Type  "Sa"
        RA            3.5436
        Dec           1.3831
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.5062   0.8559   0.1061]
        Angle    132.0127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 332"
}

Galaxy "IC 334:UGC 2824:MCG 13-3-7:ZWG 346.6"
{
        Type  "Irr"
        RA            3.7547
        Dec          76.6375
        Distance   1.118e+08  # method: V
        Radius     4.065e+04
        AbsMag        -20.17
        Axis    [  0.0620   0.9927   0.1038]
        Angle     89.8001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 334"
}

Galaxy "IC 335:IC 1963:ESO 358-26:MCG 6-8-31"
{
        Type  "S0"
        RA            3.5919
        Dec         -34.4467
        Distance   7.053e+07  # method: V
        Radius     2.667e+04
        AbsMag        -18.57
        Axis    [  0.4443   0.8436  -0.3017]
        Angle    141.0560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 335"
}

Galaxy "IC 337:MCG 1-10-9:UGCA 80"
{
        Type  "Irr"
        RA            3.6058
        Dec          -6.7150
        Distance   1.329e+08  # method: V
        Radius     3.092e+04
        AbsMag        -17.55
        Axis    [  0.0214   0.5932  -0.8048]
        Angle    155.8288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 337"
}

Galaxy "IC 338:MCG 0-10-7:ZWG 391.18"
{
        Type  "S0"
        RA            3.6272
        Dec           3.1183
        Distance   2.546e+08  # method: V
        Radius     2.962e+04
        AbsMag        -19.56
        Axis    [  0.0546   0.6022  -0.7964]
        Angle    179.1512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 338"
}

Galaxy "IC 340:MCG 2-10-5"
{
        Type  "S0"
        RA            3.6578
        Dec         -13.1150
        Distance   1.822e+08  # method: V
        Radius     3.976e+04
        AbsMag        -19.24
        Axis    [  0.3483   0.8816  -0.3185]
        Angle    134.4654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 340"
}

Galaxy "IC 342:UGC 2847:MCG 11-5-3:ZWG 305.2"
{
        Type  "SBc"
        RA            3.7800
        Dec          68.0956
        Distance     8.1e+06  # method: P
        Radius     2.521e+04
        AbsMag        -17.87
        Axis    [ -0.0904   0.9145  -0.3944]
        Angle    196.1656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 342"
}

Galaxy "IC 343:ESO 548-66:MCG 3-10-29"
{
        Type  "SBa"
        RA            3.6686
        Dec         -18.4439
        Distance   7.887e+07  # method: V
        Radius     1.835e+04
        AbsMag        -17.82
        Axis    [  0.3037   0.7615  -0.5726]
        Angle    138.5070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 343"
}

Galaxy "IC 344:MCG 1-10-20"
{
        Type  "SBc"
        RA            3.6914
        Dec          -4.6656
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.4812   0.8724   0.0851]
        Angle    134.8104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 344"
}

Galaxy "IC 345:ESO 548-74:MCG 3-10-32:NPM 1"
{
        Type  "Sa"
        RA            3.6858
        Dec         -18.3144
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.7915   0.6098  -0.0412]
        Angle    144.0390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 345"
}

Galaxy "IC 347:MCG 1-10-24:IRAS 03399-0427"
{
        Type  "S0"
        RA            3.7089
        Dec          -4.2986
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [  0.2975   0.7425  -0.6002]
        Angle    148.8658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 347"
}

Galaxy "IC 350:MCG 2-10-10"
{
        Type  "Sb"
        RA            3.7433
        Dec         -11.8008
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.0227   0.5303  -0.8475]
        Angle    157.2082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 350"
}

Galaxy "IC 352"
{
        Type  "E0"
        RA            3.7936
        Dec          -8.7317
        Distance   5.496e+08  # distance uncertain!
        Radius     4.796e+04
        AbsMag        -20.13
        Axis    [  0.5123   0.5154  -0.6870]
        Angle    180.9756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 352"
}

Galaxy "IC 355:MCG 3-10-10:ZWG 465.10:IRAS 03509+1949"
{
        Type  "Sc"
        RA            3.8961
        Dec          19.9742
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.9200   0.3553   0.1654]
        Angle     97.9276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 355"
}

Galaxy "IC 356:UGC 2953:MCG 12-4-11:ZWG 327.15"
{
        Type  "Sb"
        RA            4.1294
        Dec          69.8119
        Distance   3.701e+07  # method: V
        Radius     3.176e+04
        AbsMag        -18.87
        Axis    [ -0.2159   0.9699  -0.1129]
        Angle    126.7526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 356"
}

Galaxy "IC 357:UGC 2941:MCG 4-10-16:ZWG 487.16"
{
        Type  "SBb"
        RA            4.0619
        Dec          22.1597
        Distance   2.782e+08  # method: V
        Radius     4.856e+04
        AbsMag        -20.45
        Axis    [ -0.1014   0.6904  -0.7163]
        Angle    176.7829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 357"
}

Galaxy "IC 358:UGC 2940:MCG 3-11-6:ZWG 466.9"
{
        Type  "S0"
        RA            4.0617
        Dec          19.8956
        Distance   3.013e+08  # method: V
        Radius     4.382e+04
        AbsMag        -19.73
        Axis    [  0.2387   0.9706   0.0304]
        Angle    116.5138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 358"
}

Galaxy "IC 359:UGC 2980:MCG 5-10-9:ZWG 508.8"
{
        Type  "S0"
        RA            4.2078
        Dec          27.7031
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [  0.9319   0.3361   0.1364]
        Angle     89.4363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 359"
}

Galaxy "IC 362:MCG 2-11-31:NPM 1"
{
        Type  "E0"
        RA            4.2783
        Dec         -12.1997
        Distance   2.399e+08  # distance uncertain!
        Radius     5.932e+04
        AbsMag        -20.13
        Axis    [  0.9689   0.1971   0.1498]
        Angle    127.3171
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 362"
}

Galaxy "IC 363:ZWG 392.19"
{
        Type  "E0"
        RA            4.3153
        Dec           3.0322
        Distance   4.169e+08  # distance uncertain!
        Radius     1.213e+04
        AbsMag        -20.13
        Axis    [  0.9647   0.2239   0.1386]
        Angle    112.3246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 363"
}

Galaxy "IC 364:ZWG 392.20:NPM 1"
{
        Type  "E0"
        RA            4.3183
        Dec           3.1894
        Distance   3.163e+08  # distance uncertain!
        Radius      1.84e+04
        AbsMag        -20.13
        Axis    [  0.7221   0.5266  -0.4486]
        Angle    144.1212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 364"
}

Galaxy "IC 365:MCG 1-11-17:ZWG 392.21:IRAS 04166+0313"
{
        Type  "Sa"
        RA            4.3206
        Dec           3.3489
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.6215   0.7639   0.1740]
        Angle    122.9513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 365"
}

Galaxy "IC 366:ZWG 393.2:NPM 1"
{
        Type  "E0"
        RA            4.3281
        Dec           2.3603
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.9543   0.2987   0.0110]
        Angle    116.8508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 366"
}

Galaxy "IC 367:MCG 2-12-1"
{
        Type  "S0"
        RA            4.3447
        Dec         -14.7806
        Distance   1.612e+08  # distance uncertain!
        Radius     3.283e+04
        AbsMag        -19.07
        Axis    [  0.1238   0.6730  -0.7292]
        Angle    131.4711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 367"
}

Galaxy "IC 368:MCG 2-12-9:NPM 1"
{
        Type  "S0"
        RA            4.3783
        Dec         -12.6147
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.0533   0.4851  -0.8729]
        Angle    169.0045
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 368"
}

Galaxy "IC 369:MCG 2-12-10:NPM 1"
{
        Type  "S0"
        RA            4.3911
        Dec         -11.7894
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.9652   0.2064   0.1607]
        Angle    126.9993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 369"
}

Galaxy "IC 370:MCG 2-12-11"
{
        Type  "SBc"
        RA            4.4003
        Dec          -9.3953
        Distance   4.394e+08  # method: V
        Radius     8.948e+04
        AbsMag        -20.85
        Axis    [  0.1498   0.6052  -0.7818]
        Angle    150.8359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 370"
}

Galaxy "IC 372"
{
        Type  "S0"
        RA            4.5011
        Dec          -5.0100
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.5160   0.8390   0.1724]
        Angle    129.4265
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 372"
}

Galaxy "IC 373:MCG 1-12-13:NPM 1"
{
        Type  "S0"
        RA            4.5117
        Dec          -4.8697
        Distance    2.03e+08  # distance uncertain!
        Radius     4.133e+04
        AbsMag        -19.07
        Axis    [  0.3747   0.8025  -0.4643]
        Angle    127.4970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 373"
}

Galaxy "IC 374:MCG 3-12-1:ZWG 467.1:ARAK 107"
{
        Type  "S0"
        RA            4.5422
        Dec          16.6350
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.2341   0.9504  -0.2050]
        Angle    114.3132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 374"
}

Galaxy "IC 375"
{
        Type  "Sb"
        RA            4.5175
        Dec         -12.9736
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.6947   0.7178  -0.0468]
        Angle    131.1524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 375"
}

Galaxy "IC 376"
{
        Type  "S0"
        RA            4.5203
        Dec         -12.4331
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.6389   0.7491  -0.1752]
        Angle    129.5003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 376"
}

Galaxy "IC 377:MCG 2-12-31"
{
        Type  "S0"
        RA            4.5211
        Dec         -12.4550
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.9701   0.1910   0.1495]
        Angle    127.4142
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 377"
}

Galaxy "IC 378:NPM 1"
{
        Type  "E0"
        RA            4.5242
        Dec         -12.2992
        Distance   4.571e+08  # distance uncertain!
        Radius     3.989e+04
        AbsMag        -20.13
        Axis    [  0.7715   0.4142  -0.4830]
        Angle    151.3389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 378"
}

Galaxy "IC 379:MCG 1-12-21:NPM 1"
{
        Type  "SBb"
        RA            4.5306
        Dec          -7.2378
        Distance   3.369e+08  # distance uncertain!
        Radius     5.879e+04
        AbsMag        -19.07
        Axis    [  0.7497   0.6020   0.2748]
        Angle    132.5332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 379"
}

Galaxy "IC 380:MCG 2-12-34:DRCG 10-75"
{
        Type  "SBc"
        RA            4.5281
        Dec         -12.9272
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.4991   0.8028  -0.3263]
        Angle    126.9770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 380"
}

Galaxy "IC 381:UGC 3130:MCG 13-4-7:ZWG 347.6"
{
        Type  "SBc"
        RA            4.7411
        Dec          75.6397
        Distance   1.113e+08  # method: T-F
        Radius     3.887e+04
        AbsMag        -19.57
        Axis    [ -0.4878   0.8015  -0.3460]
        Angle    174.7546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 381"
}

Galaxy "IC 382:MCG 2-12-49:IRAS 04355-0937"
{
        Type  "Sc"
        RA            4.6319
        Dec          -9.5197
        Distance   1.768e+08  # method: T-F
        Radius     5.913e+04
        AbsMag        -20.17
        Axis    [ -0.0900   0.5230  -0.8475]
        Angle    143.7312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 382"
}

Galaxy "IC 383"
{
        Type  "E0"
        RA            4.6494
        Dec           9.8925
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.9751   0.1952   0.1052]
        Angle    104.9469
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 383"
}

Galaxy "IC 384"
{
        Type  "E0"
        RA            4.6550
        Dec          -7.8389
        Distance   4.366e+08  # distance uncertain!
        Radius      3.81e+04
        AbsMag        -20.13
        Axis    [  0.1811   0.4954  -0.8496]
        Angle    191.1226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 384"
}

Galaxy "IC 385:NPM 1"
{
        Type  "S0"
        RA            4.6586
        Dec          -7.0969
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.2200   0.8419  -0.4928]
        Angle    119.0764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 385"
}

Galaxy "IC 387:MCG 1-12-44:IRAS 04393-0710"
{
        Type  "SBc"
        RA            4.6956
        Dec          -7.0864
        Distance   2.754e+08  # method: T-F
        Radius     6.408e+04
        AbsMag        -20.83
        Axis    [  0.5738   0.7419  -0.3469]
        Angle    126.6526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 387"
}

Galaxy "IC 388-1:NPM 1"
{
        Type  "E0"
        RA            4.6978
        Dec          -7.3042
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.9810   0.1553   0.1167]
        Angle    121.6858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 388-1"
}

Galaxy "IC 388-2:NPM 1"
{
        Type  "E0"
        RA            4.6983
        Dec          -7.3058
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.9810   0.1552   0.1167]
        Angle    121.6867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 388-2"
}

Galaxy "IC 389:MCG 1-12-45:NPM 1"
{
        Type  "S0"
        RA            4.6997
        Dec          -7.3108
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.7182   0.6830  -0.1329]
        Angle    125.7033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 389"
}

Galaxy "IC 390:MCG 1-12-46:NPM 1"
{
        Type  "Sa"
        RA            4.7008
        Dec          -7.2058
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [  0.5382   0.8381   0.0890]
        Angle    126.2488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 390"
}

Galaxy "IC 391:UGC 3190:MCG 13-4-11:ZWG 347.9"
{
        Type  "Sc"
        RA            4.9561
        Dec          78.1897
        Distance   6.859e+07  # method: V
        Radius     1.097e+04
        AbsMag        -18.61
        Axis    [  0.8997   0.4352   0.0332]
        Angle     38.4567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 391"
}

Galaxy "IC 392:UGC 3158:MCG 1-13-1:ZWG 420.2"
{
        Type  "S0"
        RA            4.7736
        Dec           3.5056
        Distance   1.909e+08  # method: V
        Radius     2.777e+04
        AbsMag        -19.94
        Axis    [ -0.0387   0.6167  -0.7862]
        Angle    155.7998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 392"
}

Galaxy "IC 393:MCG 3-13-12:NPM 1"
{
        Type  "E0"
        RA            4.7975
        Dec         -15.5253
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [  0.9849   0.1306   0.1137]
        Angle    129.6399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 393"
}

Galaxy "IC 396:UGC 3203:MCG 11-7-2:ZWG 306.7"
{
        Type  "S0"
        RA            4.9661
        Dec          68.3231
        Distance   3.774e+07  # method: V
        Radius     1.153e+04
        AbsMag        -17.22
        Axis    [ -0.0534   0.9986   0.0060]
        Angle    100.6976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 396"
}

Galaxy "IC 398:MCG 1-13-40:IRAS 04558-0751"
{
        Type  "SBc"
        RA            4.9700
        Dec          -7.7808
        Distance   2.555e+08  # distance uncertain!
        Radius     4.831e+04
        AbsMag        -19.07
        Axis    [  0.5921   0.7647   0.2541]
        Angle    132.4947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 398"
}

Galaxy "IC 399:MK 1090"
{
        Type  "Irr"
        RA            5.0289
        Dec          -4.2883
        Distance   1.798e+08  # method: V
        Radius     1.569e+04
        AbsMag        -17.71
        Axis    [  0.5168   0.7848  -0.3422]
        Angle    118.7544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 399"
}

Galaxy "IC 400"
{
        Type  "S0"
        RA            5.0625
        Dec         -15.8194
        Distance   3.369e+08  # distance uncertain!
        Radius     4.899e+04
        AbsMag        -19.07
        Axis    [  0.1463   0.8660  -0.4782]
        Angle    105.1146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 400"
}

Galaxy "IC 401:MCG 2-13-40:MK 1092:IRAS 05019-1008"
{
        Type  "SBb"
        RA            5.0719
        Dec         -10.0756
        Distance   1.482e+08  # method: V
        Radius     3.665e+04
        AbsMag        -19.99
        Axis    [  0.5171   0.8538  -0.0600]
        Angle    119.2504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 401"
}

Galaxy "IC 402:MCG 2-13-43:UGCA 99:IRAS 05038-0910"
{
        Type  "Sc"
        RA            5.1039
        Dec          -9.1072
        Distance   1.507e+08  # method: V
        Radius     5.042e+04
        AbsMag        -18.92
        Axis    [  0.0697   0.6299  -0.7736]
        Angle    131.6223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 402"
}

Galaxy "IC 404:ZWG 446.1"
{
        Type  "S0"
        RA            5.2219
        Dec           9.7547
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.8470   0.4298   0.3129]
        Angle    111.9840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 404"
}

Galaxy "IC 407:MCG 3-14-13:IRAS 05154-1534"
{
        Type  "Sc"
        RA            5.2950
        Dec         -15.5233
        Distance    1.61e+08  # method: T-F
        Radius     5.153e+04
        AbsMag        -18.57
        Axis    [ -0.2108   0.5453  -0.8113]
        Angle    106.7445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 407"
}

Galaxy "IC 408:IC 2121:ESO 486-53:AM 0517-250"
{
        Type  "S0"
        RA            5.3289
        Dec         -25.0644
        Distance   4.695e+08  # method: V
        Radius     1.297e+05
        AbsMag        -21.99
        Axis    [  0.0192   0.4723  -0.8812]
        Angle    126.5761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 408"
}

Galaxy "IC 409:MCG 1-14-24:ZWG 421.26"
{
        Type  "S0"
        RA            5.3258
        Dec           3.3172
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.7673   0.6362   0.0801]
        Angle    112.8366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 409"
}

Galaxy "IC 411:ESO 486-56:MCG 4-13-11"
{
        Type  "S0"
        RA            5.3383
        Dec         -25.3244
        Distance   4.335e+08  # method: V
        Radius     7.566e+04
        AbsMag        -21.52
        Axis    [  0.3166   0.5387  -0.7808]
        Angle    132.3340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 411"
}

Galaxy "IC 412:IC 2123:UGC 3298:MCG 1-14-34"
{
        Type  "Sb"
        RA            5.3656
        Dec           3.4864
        Distance   1.955e+08  # method: V
        Radius     3.697e+04
        AbsMag        -19.29
        Axis    [  0.7097   0.5939   0.3790]
        Angle    125.1605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 412"
}

Galaxy "IC 413:IC 2124:UGC 3299:MCG 1-14-35"
{
        Type  "S0"
        RA            5.3661
        Dec           3.4822
        Distance   1.965e+08  # method: V
        Radius     2.572e+04
        AbsMag         -19.1
        Axis    [ -0.0341   0.6396  -0.7679]
        Angle    142.3181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 413"
}

Galaxy "IC 414:MCG 1-14-33:ZWG 421.40:IRAS 05192+0317"
{
        Type  "S0"
        RA            5.3653
        Dec           3.3431
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [  0.0473   0.7526  -0.6567]
        Angle    121.2612
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 414"
}

Galaxy "IC 415"
{
        Type  "S0"
        RA            5.3558
        Dec         -15.5422
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.1500   0.6028  -0.7837]
        Angle    127.3223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 415"
}

Galaxy "IC 416:MCG 3-14-14:IRAS 05217-1718"
{
        Type  "SBc"
        RA            5.3989
        Dec         -17.2603
        Distance    1.47e+08  # method: T-F
        Radius     2.994e+04
        AbsMag        -18.57
        Axis    [  0.5998   0.7627  -0.2420]
        Angle    118.8161
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 416"
}

Galaxy "IC 421:MCG 1-15-1:UGCA 111:NPM 1"
{
        Type  "SBc"
        RA            5.5356
        Dec          -7.9178
        Distance   1.491e+08  # method: T-F
        Radius     7.156e+04
        AbsMag         -18.3
        Axis    [  0.8560   0.4972  -0.1415]
        Angle    120.2545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 421"
}

Galaxy "IC 422:IC 2131:MCG 3-15-1:IRAS 05301-1715"
{
        Type  "E0"
        RA            5.5383
        Dec         -17.2239
        Distance   2.754e+08  # distance uncertain!
        Radius     2.804e+04
        AbsMag        -20.13
        Axis    [  0.9978   0.0495   0.0444]
        Angle    130.7592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 422"
}

Galaxy "IC 433:MCG 2-15-8"
{
        Type  "S0"
        RA            5.6753
        Dec         -11.6653
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [  0.9970   0.0632   0.0437]
        Angle    125.2693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 433"
}

Galaxy "IC 437:NPM 1:IRAS 05493-1234"
{
        Type  "S0"
        RA            5.8603
        Dec         -12.5644
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.7685   0.6005   0.2206]
        Angle    131.7352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 437"
}

Galaxy "IC 438:ESO 555-9:MCG 3-15-25:UGCA 115"
{
        Type  "SBc"
        RA            5.8833
        Dec         -17.8758
        Distance   1.332e+08  # method: T-F
        Radius     5.426e+04
        AbsMag        -20.35
        Axis    [  0.8345   0.5178  -0.1884]
        Angle    123.8572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 438"
}

Galaxy "IC 440:UGC 3427:MCG 13-5-21:ZWG 348.16"
{
        Type  "Sb"
        RA            6.3203
        Dec          80.0683
        Distance   1.958e+08  # method: V
        Radius     4.556e+04
        AbsMag        -19.69
        Axis    [  0.2254   0.6285   0.7444]
        Angle     65.4243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 440"
}

Galaxy "IC 441:MCG 2-16-1"
{
        Type  "SBc"
        RA            6.0450
        Dec         -12.4997
        Distance   1.039e+08  # method: V
        Radius     2.116e+04
        AbsMag        -17.62
        Axis    [  0.8696   0.4548  -0.1921]
        Angle    119.8642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 441"
}

Galaxy "IC 442:UGC 3470:MCG 14-4-3:ZWG 362.22"
{
        Type  "S0"
        RA            6.6031
        Dec          82.9689
        Distance   1.927e+08  # method: V
        Radius     2.522e+04
        AbsMag        -19.46
        Axis    [  0.9571  -0.2581   0.1321]
        Angle     32.0147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 442"
}

Galaxy "IC 445:UGC 3497:MCG 11-9-1:ZWG 308.33"
{
        Type  "S0"
        RA            6.6225
        Dec          67.8600
        Distance   2.366e+08  # method: V
        Radius     4.129e+04
        AbsMag         -20.1
        Axis    [  0.7139   0.2458   0.6557]
        Angle     61.5321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 445"
}

Galaxy "IC 449:UGC 3515:MCG 12-7-14:ZWG 330.12"
{
        Type  "E0"
        RA            6.7611
        Dec          71.3436
        Distance   1.738e+08  # distance uncertain!
        Radius     4.297e+04
        AbsMag        -20.13
        Axis    [  0.5208   0.7791  -0.3491]
        Angle     69.5063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 449"
}

Galaxy "IC 450:UGC 3547:MCG 12-7-18:MK 6"
{
        Type  "Sa"
        RA            6.8700
        Dec          74.4275
        Distance   2.637e+08  # method: V
        Radius     3.068e+04
        AbsMag        -19.74
        Axis    [ -0.3003   0.9531  -0.0361]
        Angle    109.1363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 450"
}

Galaxy "IC 451:UGC 3550:MCG 12-7-19:ZWG 330.18"
{
        Type  "Sb"
        RA            6.8808
        Dec          74.4800
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.2169   0.9493  -0.2277]
        Angle    133.0112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 451"
}

Galaxy "IC 454:UGC 3570:MCG 2-18-2:IRAS 06482+1258"
{
        Type  "SBb"
        RA            6.8517
        Dec          12.9225
        Distance   1.846e+08  # method: V
        Radius     3.222e+04
        AbsMag        -19.46
        Axis    [ -0.1172   0.7688  -0.6287]
        Angle    101.5507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 454"
}

Galaxy "IC 455:UGC 3815:MCG 14-4-33:ZWG 362.44"
{
        Type  "S0"
        RA            7.5825
        Dec          85.5378
        Distance   8.453e+07  # method: V
        Radius     1.352e+04
        AbsMag        -17.77
        Axis    [ -0.0672   0.8763   0.4771]
        Angle     71.0885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 455"
}

Galaxy "IC 456:ESO 427-24:MCG 5-17-2"
{
        Type  "S0"
        RA            7.0047
        Dec         -30.1631
        Distance   8.461e+07  # distance uncertain!
        Radius     2.584e+04
        AbsMag        -19.07
        Axis    [  0.3905   0.5003  -0.7728]
        Angle    104.8385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 456"
}

Galaxy "IC 458:UGC 3713:MCG 8-13-85:ZWG 234.81"
{
        Type  "S0"
        RA            7.1758
        Dec          50.1197
        Distance   3.035e+08  # method: V
        Radius     3.973e+04
        AbsMag        -20.34
        Axis    [ -0.5109   0.7889  -0.3416]
        Angle    122.7598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 458"
}

Galaxy "IC 459:ZWG 234.82:NPM 1"
{
        Type  "E0"
        RA            7.1772
        Dec          50.1778
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.9588  -0.2811  -0.0405]
        Angle     65.4328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 459"
}

Galaxy "IC 460:MCG 8-13-89:ZWG 234.84"
{
        Type  "S0"
        RA            7.1789
        Dec          50.2022
        Distance   2.895e+08  # method: V
        Radius     1.684e+04
        AbsMag        -19.34
        Axis    [ -0.2799   0.8691  -0.4079]
        Angle    123.7303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 460"
}

Galaxy "IC 461:MCG 8-13-88:ZWG 234.83"
{
        Type  "S0"
        RA            7.1792
        Dec          50.0814
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.2095   0.9709   0.1159]
        Angle     70.2621
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 461"
}

Galaxy "IC 463"
{
        Type  "S0"
        RA            7.1833
        Dec          50.1194
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.2185   0.9757  -0.0149]
        Angle     71.6571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 463"
}

Galaxy "IC 464:MCG 8-13-92:ZWG 234.87:PGC 20332"
{
        Type  "E0"
        RA            7.1844
        Dec          50.1361
        Distance   2.261e+08  # method: V
        Radius     2.631e+04
        AbsMag         -19.4
        Axis    [  0.8564   0.3288  -0.3982]
        Angle     66.6616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 464"
}

Galaxy "IC 467:UGC 3834:MCG 13-6-7:ZWG 348.35"
{
        Type  "SBc"
        RA            7.5047
        Dec          79.8725
        Distance   1.351e+08  # method: T-F
        Radius     6.093e+04
        AbsMag        -20.09
        Axis    [ -0.1352   0.7971   0.5885]
        Angle     78.2467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 467"
}

Galaxy "IC 469:UGC 3994:MCG 14-4-38:ZWG 362.47"
{
        Type  "SBb"
        RA            7.9331
        Dec          85.1586
        Distance   9.346e+07  # method: V
        Radius      2.99e+04
        AbsMag        -18.79
        Axis    [ -0.1774   0.8090   0.5604]
        Angle     79.0169
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 469"
}

Galaxy "IC 471:UGC 3982:MCG 8-14-35:ZWG 235.33"
{
        Type  "E0"
        RA            7.7267
        Dec          49.6681
        Distance    2.55e+08  # method: V
        Radius     2.225e+04
        AbsMag        -19.87
        Axis    [  0.9169  -0.3948  -0.0586]
        Angle     68.3128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 471"
}

Galaxy "IC 472:UGC 3985:MCG 8-14-36:ZWG 235.34"
{
        Type  "SBb"
        RA            7.7306
        Dec          49.6133
        Distance   2.623e+08  # method: V
        Radius     6.105e+04
        AbsMag        -20.23
        Axis    [ -0.4100   0.8376  -0.3609]
        Angle    117.4547
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 472"
}

Galaxy "IC 474:MCG 4-19-1:ZWG 148.12"
{
        Type  "S0"
        RA            7.7686
        Dec          26.5044
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.2030   0.9541  -0.2201]
        Angle     71.5414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 474"
}

Galaxy "IC 475:MCG 5-19-5:ZWG 148.17:ARAK 140"
{
        Type  "S0"
        RA            7.7858
        Dec          30.4889
        Distance       2e+08  # method: V
        Radius     2.327e+04
        AbsMag        -18.64
        Axis    [ -0.2179   0.8489  -0.4816]
        Angle     92.1118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 475"
}

Galaxy "IC 476:MCG 5-19-6:ZWG 148.18"
{
        Type  "SBa"
        RA            7.7878
        Dec          26.9508
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.3508   0.9000  -0.2587]
        Angle     68.1680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 476"
}

Galaxy "IC 477:MCG 4-19-6:ZWG 118.16:NPM 1"
{
        Type  "S0"
        RA            7.8683
        Dec          23.4836
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.9533  -0.2857  -0.0977]
        Angle     92.9893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 477"
}

Galaxy "IC 478:ZWG 148.55"
{
        Type  "S0"
        RA            7.8947
        Dec          26.4922
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.8835   0.2901   0.3679]
        Angle     93.6877
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 478"
}

Galaxy "IC 479:MCG 5-19-20:ZWG 148.58"
{
        Type  "SBc"
        RA            7.9061
        Dec          27.0072
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.2661   0.7325  -0.6266]
        Angle    123.5039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 479"
}

Galaxy "IC 480:UGC 4096:ZWG 148.62:IRAS 07523+2652"
{
        Type  "Sc"
        RA            7.9231
        Dec          26.7422
        Distance    2.18e+08  # method: V
        Radius     5.391e+04
        AbsMag        -19.02
        Axis    [ -0.6753   0.6463  -0.3554]
        Angle     92.6567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 480"
}

Galaxy "IC 481:UGC 4130:MCG 4-19-13:ZWG 118.31"
{
        Type  "Sc"
        RA            7.9839
        Dec          24.1603
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7718   0.3912   0.5013]
        Angle    110.6753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 481"
}

Galaxy "IC 482:MCG 4-19-16:ZWG 118.35:IRAS 07567+2529"
{
        Type  "S0"
        RA            7.9964
        Dec          25.3561
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.3626   0.7659  -0.5310]
        Angle     96.2660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 482"
}

Galaxy "IC 484:ZWG 148.84"
{
        Type  "Sa"
        RA            8.0003
        Dec          26.6658
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.7843   0.5885   0.1964]
        Angle     72.6544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 484"
}

Galaxy "IC 485:UGC 4156:ZWG 148.88:IRAS 07572+2650"
{
        Type  "Sa"
        RA            8.0053
        Dec          26.7017
        Distance   3.864e+08  # method: V
        Radius     6.744e+04
        AbsMag        -19.97
        Axis    [ -0.5511   0.7636  -0.3365]
        Angle     83.8951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 485"
}

Galaxy "IC 486:UGC 4155:MCG 4-19-18:ZWG 148.87"
{
        Type  "SBa"
        RA            8.0058
        Dec          26.6133
        Distance   3.737e+08  # method: V
        Radius     4.892e+04
        AbsMag         -20.7
        Axis    [ -0.0955   0.8002  -0.5921]
        Angle     94.3068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 486"
}

Galaxy "IC 490:ZWG 118.55"
{
        Type  "S0"
        RA            8.0556
        Dec          25.8111
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.4661   0.7521  -0.4660]
        Angle     71.1378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 490"
}

Galaxy "IC 491:ZWG 148.106"
{
        Type  "S0"
        RA            8.0653
        Dec          26.5194
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.1273   0.9803  -0.1509]
        Angle     63.0349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 491"
}

Galaxy "IC 492:UGC 4212:MCG 4-19-24:ZWG 118.59"
{
        Type  "SBc"
        RA            8.0939
        Dec          26.1675
        Distance   2.426e+08  # method: V
        Radius     3.881e+04
        AbsMag        -19.86
        Axis    [  0.0131   0.7469  -0.6648]
        Angle    101.7153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 492"
}

Galaxy "IC 493:MCG 4-19-26:ZWG 118.64"
{
        Type  "S0"
        RA            8.1242
        Dec          25.1336
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.9874   0.1572   0.0175]
        Angle     80.2059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 493"
}

Galaxy "IC 494:UGC 4224:MCG 0-21-4:ZWG 3.10"
{
        Type  "S0"
        RA            8.1067
        Dec           1.0367
        Distance    1.47e+08  # distance uncertain!
        Radius      2.78e+04
        AbsMag        -19.07
        Axis    [  0.8095   0.5786  -0.0995]
        Angle     83.5155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 494"
}

Galaxy "IC 495:ZWG 59.47:NPM 1"
{
        Type  "E0"
        RA            8.1386
        Dec           9.0144
        Distance   3.631e+08  # distance uncertain!
        Radius     2.112e+04
        AbsMag        -20.13
        Axis    [  0.9397  -0.2997  -0.1646]
        Angle    107.8445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 495"
}

Galaxy "IC 496:IC 2229:MCG 4-19-28:IRAS 08067+2601"
{
        Type  "Sc"
        RA            8.1619
        Dec          25.8811
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.1510   0.8961  -0.4173]
        Angle     68.7063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 496"
}

Galaxy "IC 497:MCG 4-20-1:ZWG 118.67:ZWG 119.2"
{
        Type  "S0"
        RA            8.1683
        Dec          24.9222
        Distance       2e+08  # method: V
        Radius     2.327e+04
        AbsMag        -18.74
        Axis    [  0.8727   0.2455   0.4221]
        Angle    105.0126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 497"
}

Galaxy "IC 498:UGC 4255:MCG 1-21-15:ZWG 31.59"
{
        Type  "S0"
        RA            8.1583
        Dec           5.2806
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [  0.8524   0.2980  -0.4297]
        Angle     88.4611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 498"
}

Galaxy "IC 499:UGC 4463:MCG 14-4-54:ZWG 363.46"
{
        Type  "Sa"
        RA            8.7547
        Dec          85.7406
        Distance   8.458e+07  # method: V
        Radius     2.583e+04
        AbsMag        -18.17
        Axis    [  0.0206   0.6897   0.7238]
        Angle     66.8921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 499"
}

Galaxy "IC 500:MCG 3-21-7:CGMW 1-2344"
{
        Type  "E0"
        RA            8.2108
        Dec         -16.0511
        Distance   1.738e+08  # distance uncertain!
        Radius     3.286e+04
        AbsMag        -20.13
        Axis    [  0.8206  -0.0468  -0.5695]
        Angle    125.2498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 500"
}

Galaxy "IC 501-1:ZWG 119.42:NPM 1"
{
        Type  "E0"
        RA            8.3131
        Dec          24.5378
        Distance   3.509e+08  # method: V
        Radius     1.021e+04
        AbsMag        -19.56
        Axis    [  0.9133  -0.3803  -0.1461]
        Angle     94.0967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 501-1"
}

Galaxy "IC 501-2:ZWG 119.42"
{
        Type  "E0"
        RA            8.3131
        Dec          24.5372
        Distance   4.366e+08  # distance uncertain!
        Radius      1.27e+04
        AbsMag        -20.13
        Axis    [  0.9133  -0.3803  -0.1461]
        Angle     94.0972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 501-2"
}

Galaxy "IC 502:ZWG 60.2:KARA 245:NPM 1"
{
        Type  "E0"
        RA            8.3675
        Dec           8.7531
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.9270  -0.3283  -0.1812]
        Angle    108.8415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 502"
}

Galaxy "IC 503:UGC 4366:MCG 1-22-4:ZWG 32.6"
{
        Type  "SBa"
        RA            8.3694
        Dec           3.2686
        Distance   1.987e+08  # method: V
        Radius      3.18e+04
        AbsMag        -20.02
        Axis    [  0.2802   0.5140  -0.8108]
        Angle     94.3361
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 503"
}

Galaxy "IC 504:UGC 4372:MCG 1-22-5:ZWG 32.8"
{
        Type  "S0"
        RA            8.3781
        Dec           4.2619
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [ -0.1260   0.6447  -0.7540]
        Angle     85.1047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 504"
}

Galaxy "IC 505:UGC 4382:MCG 1-22-8:ZWG 32.15"
{
        Type  "S0"
        RA            8.3892
        Dec           4.3731
        Distance   1.851e+08  # distance uncertain!
        Radius     3.231e+04
        AbsMag        -19.07
        Axis    [ -0.1144   0.6159  -0.7795]
        Angle     91.8727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 505"
}

Galaxy "IC 506:MCG 1-22-9:ZWG 32.16:NPM 1"
{
        Type  "E0"
        RA            8.3917
        Dec           4.3003
        Distance    3.02e+08  # distance uncertain!
        Radius     2.636e+04
        AbsMag        -20.13
        Axis    [  0.9293  -0.3160  -0.1909]
        Angle    113.0550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 506"
}

Galaxy "IC 508:MCG 4-20-63:ZWG 119.111:KUG 0825+252"
{
        Type  "S0"
        RA            8.4728
        Dec          25.1244
        Distance    1.05e+08  # method: V
        Radius     1.069e+04
        AbsMag        -17.64
        Axis    [  0.6925   0.5550  -0.4608]
        Angle     66.8765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 508"
}

Galaxy "IC 509:UGC 4456:MCG 4-20-66:ZWG 119.121"
{
        Type  "Sc"
        RA            8.5342
        Dec          24.0103
        Distance    2.59e+08  # method: V
        Radius     4.521e+04
        AbsMag         -20.9
        Axis    [  0.9800  -0.1903   0.0579]
        Angle     94.1758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 509"
}

Galaxy "IC 510:UGC 4460:MCG 0-22-15:ZWG 4.46"
{
        Type  "SBc"
        RA            8.5361
        Dec          -2.1622
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [ -0.1941   0.5419  -0.8178]
        Angle     93.1462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 510"
}

Galaxy "IC 511:UGC 4510:MCG 12-9-3:ZWG 331.55"
{
        Type  "Sa"
        RA            8.6803
        Dec          73.4867
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.4654   0.8666   0.1797]
        Angle     97.2489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 511"
}

Galaxy "IC 512:UGC 4646:MCG 14-5-2:ZWG 363.49"
{
        Type  "Sc"
        RA            9.0636
        Dec          85.5017
        Distance   7.253e+07  # method: V
        Radius     1.899e+04
        AbsMag        -18.73
        Axis    [  0.5872  -0.4185   0.6929]
        Angle     74.8313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 512"
}

Galaxy "IC 513:MCG 2-22-19:NPM 1"
{
        Type  "S0"
        RA            8.5514
        Dec         -12.3550
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [  0.9034   0.3339  -0.2690]
        Angle     97.6086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 513"
}

Galaxy "IC 514:ZWG 4.66"
{
        Type  "S0"
        RA            8.5894
        Dec          -2.0469
        Distance    2.03e+08  # distance uncertain!
        Radius          8856
        AbsMag        -19.07
        Axis    [ -0.4520   0.4760  -0.7544]
        Angle    103.0796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 514"
}

Galaxy "IC 515:UGC 4488:ZWG 4.68:NPM 1"
{
        Type  "S0"
        RA            8.5919
        Dec          -1.9006
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.9454   0.3196  -0.0632]
        Angle     96.0843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 515"
}

Galaxy "IC 516:ZWG 4.75"
{
        Type  "S0"
        RA            8.5972
        Dec          -1.8711
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.7362   0.5253  -0.4266]
        Angle     74.6787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 516"
}

Galaxy "IC 517:ZWG 4.82"
{
        Type  "S0"
        RA            8.6061
        Dec          -2.0556
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.9814   0.1541  -0.1142]
        Angle    102.4466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 517"
}

Galaxy "IC 519:ZWG 32.51:NPM 1"
{
        Type  "E0"
        RA            8.6761
        Dec           2.6119
        Distance   3.468e+08  # distance uncertain!
        Radius     2.017e+04
        AbsMag        -20.13
        Axis    [  0.9140  -0.3441  -0.2148]
        Angle    115.5597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 519"
}

Galaxy "IC 520:UGC 4630:MCG 12-9-26:ZWG 331.73"
{
        Type  "SBb"
        RA            8.8950
        Dec          73.4908
        Distance    1.62e+08  # method: V
        Radius     3.533e+04
        AbsMag        -20.88
        Axis    [  0.7350  -0.4686   0.4902]
        Angle     67.9226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 520"
}

Galaxy "IC 521:MCG 1-23-2:ZWG 33.4"
{
        Type  "S0"
        RA            8.7789
        Dec           2.5383
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.5175   0.6619  -0.5422]
        Angle     63.3999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 521"
}

Galaxy "IC 522:UGC 4654:MCG 10-13-31:ZWG 288.10"
{
        Type  "S0"
        RA            8.9094
        Dec          57.1667
        Distance   1.281e+08  # distance uncertain!
        Radius     1.863e+04
        AbsMag        -19.07
        Axis    [ -0.2998   0.9036  -0.3060]
        Angle    106.6892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 522"
}

Galaxy "IC 523:UGC 4652:MCG 2-23-9:ZWG 61.18"
{
        Type  "Sb"
        RA            8.8864
        Dec           9.1483
        Distance   4.102e+08  # method: V
        Radius     5.369e+04
        AbsMag           -21
        Axis    [  0.4130   0.5819  -0.7006]
        Angle     69.8430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 523"
}

Galaxy "IC 524:ESO 564-1:NPM 1"
{
        Type  "S0"
        RA            8.9700
        Dec         -19.1914
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.9596   0.2305  -0.1615]
        Angle    114.4232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 524"
}

Galaxy "IC 525:UGC 4735:MCG 0-23-19:ZWG 5.46"
{
        Type  "Sa"
        RA            9.0228
        Dec          -1.8531
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.9293   0.3425   0.1385]
        Angle    108.1413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 525"
}

Galaxy "IC 526:MCG 2-23-22:ZWG 61.46:NPM 1"
{
        Type  "S0"
        RA            9.0444
        Dec          10.8422
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.9178   0.3963  -0.0266]
        Angle     74.1831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 526"
}

Galaxy "IC 527:UGC 4810:MCG 6-20-39:ZWG 180.49"
{
        Type  "SBc"
        RA            9.1614
        Dec          37.6019
        Distance    3.22e+08  # method: V
        Radius     5.619e+04
        AbsMag        -20.67
        Axis    [  0.8449   0.5246  -0.1046]
        Angle     50.2746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 527"
}

Galaxy "IC 528:UGC 4811:MCG 3-24-1:MK 1225"
{
        Type  "Sb"
        RA            9.1561
        Dec          15.7958
        Distance   1.841e+08  # method: V
        Radius     4.017e+04
        AbsMag        -18.86
        Axis    [ -0.5155   0.6475  -0.5613]
        Angle     82.7496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 528"
}

Galaxy "IC 529:UGC 4888:MCG 12-9-35:ZWG 332.38"
{
        Type  "Sc"
        RA            9.3089
        Dec          73.7597
        Distance   1.369e+08  # method: T-F
        Radius     6.571e+04
        AbsMag        -21.11
        Axis    [ -0.4375   0.8714   0.2219]
        Angle     91.4769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 529"
}

Galaxy "IC 530:UGC 4880:MCG 2-24-3:ZWG 62.10"
{
        Type  "Sb"
        RA            9.2547
        Dec          11.8861
        Distance   2.384e+08  # method: V
        Radius     6.242e+04
        AbsMag        -20.22
        Axis    [  0.5303   0.8309  -0.1684]
        Angle     48.2197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 530"
}

Galaxy "IC 531:UGC 4923:MCG 0-24-6:ZWG 6.28"
{
        Type  "SBb"
        RA            9.2972
        Dec          -0.2781
        Distance   2.498e+08  # method: T-F
        Radius     6.176e+04
        AbsMag        -19.72
        Axis    [  0.8206   0.5631  -0.0974]
        Angle     66.5610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 531"
}

Galaxy "IC 533"
{
        Type  "S0"
        RA            9.3397
        Dec          -3.9914
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [ -0.5823   0.4820  -0.6547]
        Angle     62.3002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 533"
}

Galaxy "IC 534:UGC 4968:ZWG 34.33"
{
        Type  "Sb"
        RA            9.3542
        Dec           3.1503
        Distance   2.005e+08  # method: T-F
        Radius     4.956e+04
        AbsMag        -18.94
        Axis    [ -0.6463   0.6145  -0.4524]
        Angle     52.9694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 534"
}

Galaxy "IC 535:ZWG 6.34:NPM 1"
{
        Type  "E0"
        RA            9.3711
        Dec          -1.0400
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.8719  -0.4069  -0.2724]
        Angle    121.4121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 535"
}

Galaxy "IC 536:UGC 5006:MCG 4-22-45:ZWG 121.84"
{
        Type  "Sa"
        RA            9.4111
        Dec          25.1103
        Distance   3.831e+08  # method: V
        Radius     6.686e+04
        AbsMag        -20.05
        Axis    [  0.8434   0.3153   0.4350]
        Angle     91.1881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 536"
}

Galaxy "IC 537:MCG 2-24-20:NPM 1:IRAS 09229-1210"
{
        Type  "Sa"
        RA            9.4228
        Dec         -12.3911
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [ -0.3852   0.3878  -0.8374]
        Angle    115.6312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 537"
}

Galaxy "IC 539:UGC 5054:MCG 0-24-17:ZWG 6.47"
{
        Type  "Sc"
        RA            9.4856
        Dec          -2.5489
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [ -0.2376   0.4630  -0.8539]
        Angle    100.2332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 539"
}

Galaxy "IC 540:UGC 5064:MCG 1-24-25:ZWG 34.54"
{
        Type  "Sc"
        RA            9.5028
        Dec           7.9014
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.7377   0.4831  -0.4715]
        Angle     73.8255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 540"
}

Galaxy "IC 542:MCG 2-24-31:IRAS 09286-1257"
{
        Type  "SBa"
        RA            9.5183
        Dec         -13.1811
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [  0.4760   0.5864  -0.6554]
        Angle     52.0644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 542"
}

Galaxy "IC 544:MCG 4-23-12:ZWG 122.25:KCPG 207A"
{
        Type  "Sc"
        RA            9.5981
        Dec          24.8928
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.8869   0.2603   0.3816]
        Angle     86.8585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 544"
}

Galaxy "IC 545:MCG 4-23-13:ZWG 122.27:ARAK 205"
{
        Type  "Sb"
        RA            9.6014
        Dec          24.9475
        Distance   2.907e+08  # method: V
        Radius     2.114e+04
        AbsMag        -19.55
        Axis    [  0.9710  -0.2253   0.0804]
        Angle     95.8190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 545"
}

Galaxy "IC 546:MCG 3-25-7"
{
        Type  "Sa"
        RA            9.5806
        Dec         -16.3844
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.3916   0.3458  -0.8527]
        Angle     69.8352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 546"
}

Galaxy "IC 548:ZWG 63.24"
{
        Type  "S0"
        RA            9.6386
        Dec           9.4461
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.7561   0.4687  -0.4567]
        Angle     78.2938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 548"
}

Galaxy "IC 549:MCG 1-25-10:ZWG 35.27"
{
        Type  "S0"
        RA            9.6786
        Dec           3.9589
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.9994   0.0142   0.0304]
        Angle    108.7818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 549"
}

Galaxy "IC 550:MCG 1-25-14"
{
        Type  "S0"
        RA            9.6744
        Dec          -6.9458
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.9641   0.1344  -0.2291]
        Angle     94.4222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 550"
}

Galaxy "IC 551:UGC 5168:MCG 1-25-12:ZWG 35.29"
{
        Type  "S0"
        RA            9.6833
        Dec           6.9367
        Distance   4.029e+08  # method: V
        Radius     4.688e+04
        AbsMag        -20.96
        Axis    [ -0.3718   0.5507  -0.7473]
        Angle    100.0888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 551"
}

Galaxy "IC 552:UGC 5171:MCG 2-25-17:ZWG 63.38"
{
        Type  "S0"
        RA            9.6878
        Dec          10.6472
        Distance   2.774e+08  # method: V
        Radius     4.035e+04
        AbsMag        -20.25
        Axis    [  0.9955  -0.0269   0.0904]
        Angle    106.9668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 552"
}

Galaxy "IC 553:MCG 1-25-16"
{
        Type  "Sa"
        RA            9.6792
        Dec          -5.4353
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [ -0.0309   0.4328  -0.9009]
        Angle     73.2919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 553"
}

Galaxy "IC 554:IC 555:UGC 5178:MCG 2-25-20"
{
        Type  "S0"
        RA            9.6992
        Dec          12.2964
        Distance   3.191e+08  # method: V
        Radius     6.033e+04
        AbsMag        -20.65
        Axis    [  0.9717   0.1734   0.1605]
        Angle     93.3231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 554"
}

Galaxy "IC 557:MCG 2-25-27:ZWG 63.55:ARAK 213"
{
        Type  "Sb"
        RA            9.7339
        Dec          10.9886
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.9697   0.2414  -0.0373]
        Angle     73.1125
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 557"
}

Galaxy "IC 558:MCG 5-23-33:ZWG 152.63:NPM 1"
{
        Type  "E0"
        RA            9.7500
        Dec          29.4528
        Distance    4.35e+08  # method: V
        Radius     5.062e+04
        AbsMag        -20.53
        Axis    [  0.7813  -0.5917  -0.1986]
        Angle     98.0902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 558"
}

Galaxy "IC 559:MCG 2-25-29:ZWG 63.57"
{
        Type  "S0"
        RA            9.7453
        Dec           9.6158
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.5767   0.5150  -0.6342]
        Angle     52.9701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 559"
}

Galaxy "IC 560:UGC 5223:MCG 0-25-13:ZWG 7.30"
{
        Type  "Sa"
        RA            9.7647
        Dec          -0.2683
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.9885   0.1514   0.0016]
        Angle    100.8691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 560"
}

Galaxy "IC 561:MCG 1-25-19:ZWG 35.49"
{
        Type  "Sb"
        RA            9.7661
        Dec           3.1450
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.9897  -0.0562  -0.1320]
        Angle    100.3314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 561"
}

Galaxy "IC 562:MCG 1-25-36:IRAS 09435-0344"
{
        Type  "Sc"
        RA            9.7678
        Dec          -3.9719
        Distance   2.325e+08  # method: V
        Radius     4.397e+04
        AbsMag        -19.26
        Axis    [ -0.6659   0.4737  -0.5764]
        Angle     50.5396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 562"
}

Galaxy "IC 563:MCG 1-25-22:ZWG 35.53:ARP 303"
{
        Type  "SBb"
        RA            9.7722
        Dec           3.0461
        Distance   2.909e+08  # method: V
        Radius     3.808e+04
        AbsMag        -19.95
        Axis    [  0.2330   0.7090  -0.6656]
        Angle     44.1351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 563"
}

Galaxy "IC 564:UGC 5230:MCG 1-25-23:ZWG 35.54"
{
        Type  "Sc"
        RA            9.7725
        Dec           3.0711
        Distance   2.878e+08  # method: V
        Radius     7.117e+04
        AbsMag        -20.63
        Axis    [  0.8058   0.5916  -0.0237]
        Angle     55.1671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 564"
}

Galaxy "IC 565:UGC 5248:MCG 3-25-28:ZWG 92.52"
{
        Type  "Sc"
        RA            9.7972
        Dec          15.8514
        Distance   2.791e+08  # method: V
        Radius     6.494e+04
        AbsMag        -19.56
        Axis    [  0.8316   0.4635   0.3059]
        Angle     68.1430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 565"
}

Galaxy "IC 566:ZWG 7.44:NPM 1"
{
        Type  "E0"
        RA            9.8322
        Dec          -0.2308
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.7188  -0.2335  -0.6548]
        Angle    106.7214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 566"
}

Galaxy "IC 568:UGC 5285:MCG 3-25-31:ZWG 92.57"
{
        Type  "SBb"
        RA            9.8522
        Dec          15.7306
        Distance   4.091e+08  # method: V
        Radius     1.012e+05
        AbsMag        -20.89
        Axis    [  0.9969   0.0537  -0.0578]
        Angle     77.8642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 568"
}

Galaxy "IC 569:MCG 2-25-48:ZWG 63.86:KARA 378"
{
        Type  "E0"
        RA            9.8578
        Dec          10.9206
        Distance   3.631e+08  # distance uncertain!
        Radius     2.112e+04
        AbsMag        -20.13
        Axis    [ -0.1349   0.5504  -0.8239]
        Angle    118.9010
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 569"
}

Galaxy "IC 570:MCG 3-25-32:ZWG 92.60:NPM 1"
{
        Type  "Sc"
        RA            9.8639
        Dec          15.7561
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.8230  -0.5163  -0.2367]
        Angle    108.9604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 570"
}

Galaxy "IC 571:MCG 3-25-35:ZWG 92.63"
{
        Type  "S0"
        RA            9.8753
        Dec          15.7753
        Distance   3.217e+08  # distance uncertain!
        Radius     4.679e+04
        AbsMag        -19.07
        Axis    [  0.9893  -0.0837   0.1197]
        Angle    105.6213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 571"
}

Galaxy "IC 572:MCG 3-25-36:ZWG 92.64:ARAK 220"
{
        Type  "E0"
        RA            9.8756
        Dec          15.8275
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.8044  -0.5369  -0.2545]
        Angle    109.7078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 572"
}

Galaxy "IC 574:MCG 1-25-56:NPM 1"
{
        Type  "S0"
        RA            9.9075
        Dec          -6.9528
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [  0.9702  -0.1532  -0.1877]
        Angle    117.5544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 574"
}

Galaxy "IC 575:MCG 1-25-58:VV 111:ARP 292"
{
        Type  "Sa"
        RA            9.9089
        Dec          -6.8572
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [ -0.2388   0.4188  -0.8761]
        Angle     69.2977
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 575"
}

Galaxy "IC 576:MK 1240:ZWG 63.104:NPM 1"
{
        Type  "E0"
        RA            9.9186
        Dec          11.0400
        Distance   3.981e+08  # distance uncertain!
        Radius     1.737e+04
        AbsMag        -20.13
        Axis    [  0.8105  -0.5183  -0.2728]
        Angle    113.8186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 576"
}

Galaxy "IC 577:UGC 5334:MCG 2-26-1:ZWG 64.2"
{
        Type  "Sc"
        RA            9.9344
        Dec          10.4989
        Distance   4.227e+08  # method: V
        Radius     3.689e+04
        AbsMag        -20.96
        Axis    [  0.8272  -0.4983  -0.2597]
        Angle    113.5412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 577"
}

Galaxy "IC 578:UGC 5337:MCG 2-26-2:ZWG 64.4"
{
        Type  "SBa"
        RA            9.9378
        Dec          10.4864
        Distance   4.198e+08  # method: V
        Radius     7.328e+04
        AbsMag        -20.75
        Axis    [  0.8275   0.5579  -0.0626]
        Angle     49.2495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 578"
}

Galaxy "IC 579:MCG 2-26-5:IRAS 09542-1332"
{
        Type  "Sb"
        RA            9.9442
        Dec         -13.7744
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.4394   0.3800  -0.8139]
        Angle     49.2012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 579"
}

Galaxy "IC 581:UGC 5352:MCG 3-26-8:ZWG 93.10"
{
        Type  "SBb"
        RA            9.9697
        Dec          15.9475
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.4154   0.7943  -0.4434]
        Angle     47.5016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 581"
}

Galaxy "IC 582:UGC 5362:MCG 3-26-11:ZWG 93.16"
{
        Type  "Sc"
        RA            9.9833
        Dec          17.8169
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.8084  -0.5397  -0.2351]
        Angle    108.0384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 582"
}

Galaxy "IC 583:UGC 5363:MCG 3-26-12:ZWG 93.17"
{
        Type  "Sc"
        RA            9.9847
        Dec          17.8211
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.1273   0.9912   0.0368]
        Angle     34.8679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 583"
}

Galaxy "IC 584:MCG 2-26-10:ZWG 64.15:ARAK 226"
{
        Type  "E0"
        RA            9.9847
        Dec          10.3611
        Distance    2.62e+08  # method: V
        Radius     1.524e+04
        AbsMag        -18.92
        Axis    [  0.8062  -0.5219  -0.2787]
        Angle    114.7318
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 584"
}

Galaxy "IC 585:UGC 5371:MCG 2-26-14:ZWG 64.22"
{
        Type  "S0"
        RA            9.9956
        Dec          12.9892
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.1628   0.6979  -0.6975]
        Angle     52.9341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 585"
}

Galaxy "IC 586:MCG 1-26-4:NPM 1"
{
        Type  "S0"
        RA            9.9972
        Dec          -6.9222
        Distance   1.612e+08  # distance uncertain!
        Radius     1.407e+04
        AbsMag        -19.07
        Axis    [  0.8475  -0.4235  -0.3199]
        Angle    127.9948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 586"
}

Galaxy "IC 587:UGC 5411:MCG 0-26-12:ZWG 8.28"
{
        Type  "Sc"
        RA           10.0514
        Dec          -2.3997
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [  0.2740   0.5717  -0.7733]
        Angle     43.9648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 587"
}

Galaxy "IC 588:UGC 5399:MCG 1-26-10:ZWG 36.23"
{
        Type  "SBa"
        RA           10.0353
        Dec           3.0583
        Distance   3.338e+08  # method: V
        Radius     3.398e+04
        AbsMag        -20.35
        Axis    [ -0.5472   0.4951  -0.6749]
        Angle     70.7938
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 588"
}

Galaxy "IC 589:NPM 1"
{
        Type  "S0"
        RA           10.0731
        Dec          -5.6783
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.9842  -0.0546  -0.1685]
        Angle    109.3508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 589"
}

Galaxy "IC 590-1:UGC 5443:MCG 0-26-18:ZWG 8.37"
{
        Type  "S0"
        RA           10.0969
        Dec           0.6331
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.0635   0.3675  -0.9278]
        Angle     77.9598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 590-1"
}

Galaxy "IC 590-2:UGC 5443:MCG 0-26-18:ZWG 8.37"
{
        Type  "S0"
        RA           10.0972
        Dec           0.6317
        Distance   1.688e+08  # distance uncertain!
        Radius     1.473e+04
        AbsMag        -19.07
        Axis    [ -0.7269   0.3846  -0.5690]
        Angle     81.7478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 590-2"
}

Galaxy "IC 591:UGC 5458:MCG 2-26-25:ZWG 64.69"
{
        Type  "S0"
        RA           10.1242
        Dec          12.2742
        Distance   1.434e+08  # method: V
        Radius     2.086e+04
        AbsMag        -19.12
        Axis    [ -0.5544   0.5706  -0.6058]
        Angle     84.0445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 591"
}

Galaxy "IC 592:UGC 5465:MCG 0-26-20:ZWG 8.45"
{
        Type  "Sc"
        RA           10.1328
        Dec          -2.4989
        Distance   2.895e+08  # method: V
        Radius     3.369e+04
        AbsMag        -20.64
        Axis    [  0.9082  -0.1389  -0.3948]
        Angle     97.5765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 592"
}

Galaxy "IC 593:UGC 5469:MCG 0-26-21:ZWG 8.47"
{
        Type  "S0"
        RA           10.1383
        Dec          -2.5267
        Distance   2.907e+08  # method: V
        Radius      2.96e+04
        AbsMag        -20.35
        Axis    [  0.5907   0.1359  -0.7954]
        Angle     73.7321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 593"
}

Galaxy "IC 594:UGC 5472:MCG 0-26-23:ZWG 8.49"
{
        Type  "SBc"
        RA           10.1419
        Dec          -0.6661
        Distance    3.07e+08  # method: V
        Radius     4.912e+04
        AbsMag        -20.27
        Axis    [ -0.1891   0.5798  -0.7925]
        Angle     45.2103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 594"
}

Galaxy "IC 595:ZWG 64.81:NPM 1"
{
        Type  "E0"
        RA           10.1606
        Dec          11.0008
        Distance   3.468e+08  # distance uncertain!
        Radius     2.522e+04
        AbsMag        -20.13
        Axis    [ -0.1789   0.5535  -0.8134]
        Angle    116.7468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 595"
}

Galaxy "IC 596:MCG 2-26-30:ZWG 64.84:IRAS 10079+1016"
{
        Type  "S0"
        RA           10.1753
        Dec          10.0417
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.9819   0.1257   0.1414]
        Angle     96.8226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 596"
}

Galaxy "IC 597:NPM 1"
{
        Type  "S0"
        RA           10.1697
        Dec          -6.8986
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [ -0.7521   0.2837  -0.5948]
        Angle     69.4827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 597"
}

Galaxy "IC 598:UGC 5502:MCG 7-21-16:ZWG 211.17"
{
        Type  "Sa"
        RA           10.2133
        Dec          43.1456
        Distance    1.13e+08  # method: V
        Radius     2.301e+04
        AbsMag         -18.8
        Axis    [  0.8883  -0.0960   0.4491]
        Angle     96.8305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 598"
}

Galaxy "IC 599:MCG 1-26-32"
{
        Type  "Sc"
        RA           10.2200
        Dec          -5.6289
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.9342   0.3561   0.0223]
        Angle     82.6241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 599"
}

Galaxy "IC 600:MCG 0-26-34:UGCA 209:ZWG 8.85"
{
        Type  "Irr"
        RA           10.2861
        Dec          -3.4972
        Distance   7.502e+07  # method: V
        Radius     2.619e+04
        AbsMag        -18.71
        Axis    [  0.9842   0.0969  -0.1481]
        Angle     91.2898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 600"
}

Galaxy "IC 601:MCG 1-26-33:ZWG 36.87:NPM 1"
{
        Type  "Sc"
        RA           10.3042
        Dec           7.0392
        Distance   1.817e+08  # method: V
        Radius      1.85e+04
        AbsMag        -18.93
        Axis    [  0.9640   0.2546   0.0765]
        Angle     74.7614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 601"
}

Galaxy "IC 602:UGC 5561:MCG 1-26-34:ZWG 36.89"
{
        Type  "Sc"
        RA           10.3053
        Dec           7.0492
        Distance    1.85e+08  # method: V
        Radius     2.152e+04
        AbsMag        -20.07
        Axis    [ -0.6703   0.4782  -0.5675]
        Angle     84.3056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 602"
}

Galaxy "IC 603:MCG 1-26-41:DRCG 19-6"
{
        Type  "Sa"
        RA           10.3236
        Dec          -5.6561
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [ -0.4760   0.3782  -0.7939]
        Angle     75.2834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 603"
}

Galaxy "IC 605:UGC 5606:MCG 0-27-3:ZWG 9.10"
{
        Type  "Sc"
        RA           10.3733
        Dec           1.1989
        Distance   3.098e+08  # method: V
        Radius     2.704e+04
        AbsMag        -20.29
        Axis    [  0.9503  -0.2141  -0.2260]
        Angle    105.8129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 605"
}

Galaxy "IC 607:UGC 5628:MCG 3-27-18:ZWG 94.30"
{
        Type  "SBc"
        RA           10.4022
        Dec          16.7417
        Distance   2.672e+08  # method: V
        Radius     5.052e+04
        AbsMag        -19.97
        Axis    [  0.3337   0.5908  -0.7346]
        Angle     42.2120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 607"
}

Galaxy "IC 608:MCG 1-27-8"
{
        Type  "S0"
        RA           10.4058
        Dec          -6.0394
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.2486   0.4214  -0.8722]
        Angle     44.2805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 608"
}

Galaxy "IC 609:UGC 5641:MCG 0-27-9:ZWG 9.26"
{
        Type  "SBc"
        RA           10.4264
        Dec          -2.2142
        Distance    1.47e+08  # distance uncertain!
        Radius     3.208e+04
        AbsMag        -19.07
        Axis    [  0.9872   0.0932  -0.1296]
        Angle     89.1601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 609"
}

Galaxy "IC 610:IC 611:UGC 5653:MCG 3-27-34"
{
        Type  "Sc"
        RA           10.4411
        Dec          20.2269
        Distance   1.938e+08  # distance uncertain!
        Radius     5.075e+04
        AbsMag        -19.07
        Axis    [  0.9207   0.1978   0.3364]
        Angle     84.9024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 610"
}

Galaxy "IC 612:MCG 2-27-19:ZWG 65.39"
{
        Type  "S0"
        RA           10.4514
        Dec          11.0547
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.9940  -0.0739   0.0805]
        Angle    109.2461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 612"
}

Galaxy "IC 613:MCG 2-27-18:ZWG 65.38:NPM 1"
{
        Type  "E0"
        RA           10.4519
        Dec          11.0114
        Distance   4.169e+08  # distance uncertain!
        Radius     4.851e+04
        AbsMag        -20.13
        Axis    [  0.7636  -0.5713  -0.3009]
        Angle    116.9295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 613"
}

Galaxy "IC 614:MCG 0-27-15:ZWG 9.39"
{
        Type  "Irr"
        RA           10.4475
        Dec          -3.4647
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.9848   0.0698  -0.1590]
        Angle     90.9403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 614"
}

Galaxy "IC 615:UGC 5665:MCG 2-27-20:ZWG 65.41"
{
        Type  "S0"
        RA           10.4558
        Dec          11.0806
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.6963   0.6451  -0.3147]
        Angle     42.4321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 615"
}

Galaxy "IC 616-1:UGC 5730:MCG 3-27-60:ZWG 94.87"
{
        Type  "Sc"
        RA           10.5464
        Dec          15.8606
        Distance   2.767e+08  # method: V
        Radius     4.024e+04
        AbsMag        -20.24
        Axis    [  0.7625  -0.5877  -0.2706]
        Angle    113.0381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 616-1"
}

Galaxy "IC 616-2:NPM 1"
{
        Type  "E0"
        RA           10.5464
        Dec          15.8453
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.7434  -0.6044  -0.2865]
        Angle    113.8850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 616-2"
}

Galaxy "IC 619:ZWG 65.56:MCG 2-17-25"
{
        Type  "Sc"
        RA           10.5639
        Dec          12.8783
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.9495  -0.3067  -0.0666]
        Angle    108.5745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 619"
}

Galaxy "IC 620:ZWG 65.55:IRAS 10308+1207"
{
        Type  "S0"
        RA           10.5592
        Dec          11.8708
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.8502   0.3867  -0.3574]
        Angle     41.1544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 620"
}

Galaxy "IC 621:ZWG 37.74:NPM 1"
{
        Type  "E0"
        RA           10.5558
        Dec           2.6167
        Distance    3.02e+08  # distance uncertain!
        Radius     1.757e+04
        AbsMag        -20.13
        Axis    [  0.3651  -0.0064  -0.9309]
        Angle     96.0180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 621"
}

Galaxy "IC 623:UGC 5748:MCG 1-27-17:ZWG 37.85"
{
        Type  "Sb"
        RA           10.5892
        Dec           3.5583
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [ -0.6888   0.4664  -0.5550]
        Angle     51.9991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 623"
}

Galaxy "IC 624:MCG 1-27-26"
{
        Type  "Sa"
        RA           10.6042
        Dec          -8.3342
        Distance   2.444e+08  # method: V
        Radius     9.599e+04
        AbsMag        -20.27
        Axis    [  0.9485   0.3127  -0.0509]
        Angle     75.8996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 624"
}

Galaxy "IC 625:MCG 4-26-1:ESO 501-80"
{
        Type  "S0"
        RA           10.7103
        Dec         -23.9350
        Distance   4.911e+07  # method: T-F
        Radius     1.643e+04
        AbsMag        -17.19
        Axis    [  0.2280   0.2660  -0.9366]
        Angle     33.1762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 625"
}

Galaxy "IC 626:MCG 1-27-28"
{
        Type  "S0"
        RA           10.6158
        Dec          -7.0239
        Distance    2.03e+08  # distance uncertain!
        Radius     3.543e+04
        AbsMag        -19.07
        Axis    [ -0.2476   0.3158  -0.9159]
        Angle     76.1055
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 626"
}

Galaxy "IC 627:MCG 0-27-32:ZWG 9.87:NPM 1"
{
        Type  "S0"
        RA           10.6219
        Dec          -3.3572
        Distance   2.226e+08  # distance uncertain!
        Radius     1.942e+04
        AbsMag        -19.07
        Axis    [  0.7932  -0.4983  -0.3501]
        Angle    127.8712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 627"
}

Galaxy "IC 628:UGC 5780:MCG 1-27-22:ZWG 37.96"
{
        Type  "Sb"
        RA           10.6267
        Dec           5.6033
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.0621   0.4009  -0.9140]
        Angle     55.2038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 628"
}

Galaxy "IC 630:MCG 1-27-29:MK 1259"
{
        Type  "S0"
        RA           10.6425
        Dec          -7.1706
        Distance   1.138e+08  # method: V
        Radius     3.477e+04
        AbsMag        -19.21
        Axis    [ -0.1194   0.2831  -0.9516]
        Angle     69.7833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 630"
}

Galaxy "IC 631:NPM 1"
{
        Type  "E0"
        RA           10.6494
        Dec          -7.0517
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [  0.7798  -0.5012  -0.3750]
        Angle    131.9452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 631"
}

Galaxy "IC 632:UGC 5792:MCG 0-27-35:ZWG 9.92"
{
        Type  "Sa"
        RA           10.6531
        Dec          -0.4097
        Distance   2.706e+08  # method: V
        Radius     3.543e+04
        AbsMag        -19.79
        Axis    [  0.9611  -0.0738  -0.2663]
        Angle     89.1884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 632"
}

Galaxy "IC 633:UGC 5796:MCG 0-27-37:ZWG 9.94"
{
        Type  "S0"
        RA           10.6567
        Dec          -0.3886
        Distance   2.673e+08  # method: V
        Radius     2.332e+04
        AbsMag        -19.77
        Axis    [  0.4019   0.4274  -0.8099]
        Angle     38.3757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 633"
}

Galaxy "IC 634:UGC 5811:ZWG 37.111"
{
        Type  "Irr"
        RA           10.6817
        Dec           5.9919
        Distance   3.468e+08  # distance uncertain!
        Radius     6.052e+04
        AbsMag        -20.13
        Axis    [ -0.0490   0.7999  -0.5982]
        Angle     25.9572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 634"
}

Galaxy "IC 635:UGC 5821:MCG 3-27-69:ZWG 94.102"
{
        Type  "S0"
        RA           10.6958
        Dec          15.6433
        Distance    3.14e+08  # method: V
        Radius     7.307e+04
        AbsMag        -19.82
        Axis    [  0.9639   0.0941   0.2493]
        Angle    107.7461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 635"
}

Galaxy "IC 636:UGC 5824:MCG 1-27-28:ZWG 37.121"
{
        Type  "SBc"
        RA           10.6972
        Dec           4.3308
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.9810   0.1131  -0.1574]
        Angle     67.8386
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 636"
}

Galaxy "IC 637:ZWG 94.107:NPM 1"
{
        Type  "S0"
        RA           10.7058
        Dec          15.3603
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.9941  -0.0891   0.0623]
        Angle     94.1680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 637"
}

Galaxy "IC 638:MK 632:ZWG 94.117:ZWG 95.4"
{
        Type  "S0"
        RA           10.7300
        Dec          15.8956
        Distance   5.558e+08  # method: V
        Radius      4.85e+04
        AbsMag        -20.76
        Axis    [  0.9854  -0.0204   0.1689]
        Angle    105.0568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 638"
}

Galaxy "IC 639:MCG 3-28-7:ZWG 95.16"
{
        Type  "S0"
        RA           10.7644
        Dec          16.9294
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.9784  -0.0025   0.2067]
        Angle    110.6986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 639"
}

Galaxy "IC 642:UGC 5905:MCG 3-28-10:ZWG 95.22"
{
        Type  "E0"
        RA           10.8019
        Dec          18.1886
        Distance   2.833e+08  # method: V
        Radius     5.357e+04
        AbsMag        -20.89
        Axis    [  0.7128  -0.6398  -0.2874]
        Angle    113.9292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 642"
}

Galaxy "IC 643:ZWG 66.30"
{
        Type  "S0"
        RA           10.8242
        Dec          12.2011
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.9330   0.3584  -0.0318]
        Angle     40.6330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 643"
}

Galaxy "IC 645"
{
        Type  "S0"
        RA           10.8358
        Dec          -6.0431
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.4589   0.0716  -0.8856]
        Angle     65.0732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 645"
}

Galaxy "IC 646:MCG 9-18-39:ZWG 267.19:NPM 1"
{
        Type  "Sa"
        RA           10.8597
        Dec          55.4664
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.0450   0.8381   0.5436]
        Angle     43.9867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 646"
}

Galaxy "IC 647:NPM 1"
{
        Type  "E0"
        RA           10.8428
        Dec         -12.8539
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.3747  -0.1403  -0.9165]
        Angle    110.2622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 647"
}

Galaxy "IC 648-1:MCG 2-28-17:ZWG 66.40"
{
        Type  "S0"
        RA           10.8500
        Dec          12.2878
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.0489   0.5946  -0.8026]
        Angle     38.0912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 648-1"
}

Galaxy "IC 648-2:MCG 2-28-17:ZWG 66.40"
{
        Type  "E0"
        RA           10.8500
        Dec          12.2900
        Distance    3.02e+08  # distance uncertain!
        Radius     3.514e+04
        AbsMag        -20.13
        Axis    [  0.7237  -0.6141  -0.3148]
        Angle    118.4950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 648-2"
}

Galaxy "IC 649-1:MCG 0-28-19:ZWG 10.34:KCPG 252A"
{
        Type  "Sb"
        RA           10.8478
        Dec           1.1653
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.6443   0.4111  -0.6448]
        Angle     79.2923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 649-1"
}

Galaxy "IC 649-2:MCG 0-28-19:ZWG 10.34:KCPG 252B"
{
        Type  "Sc"
        RA           10.8478
        Dec           1.1619
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.7662  -0.5410  -0.3467]
        Angle    125.6197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 649-2"
}

Galaxy "IC 650"
{
        Type  "Irr"
        RA           10.8444
        Dec         -13.4417
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [  0.9503  -0.1534  -0.2710]
        Angle    118.7618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 650"
}

Galaxy "IC 651:UGC 5956:MCG 0-28-20:ZWG 10.35"
{
        Type  "Irr"
        RA           10.8494
        Dec          -2.1503
        Distance   2.184e+08  # method: V
        Radius     2.541e+04
        AbsMag        -21.43
        Axis    [  0.7718  -0.5245  -0.3596]
        Angle    128.0798
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 651"
}

Galaxy "IC 653:UGC 5985:MCG 0-28-22:ZWG 10.39"
{
        Type  "Sa"
        RA           10.8683
        Dec          -0.5611
        Distance    2.67e+08  # method: V
        Radius     7.378e+04
        AbsMag        -20.56
        Axis    [  0.9479   0.0905  -0.3054]
        Angle     64.1128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 653"
}

Galaxy "IC 654:MCG 2-28-18"
{
        Type  "Sa"
        RA           10.8972
        Dec         -11.7256
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.1946   0.2402  -0.9510]
        Angle     45.2924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 654"
}

Galaxy "IC 655:ZWG 10.42"
{
        Type  "S0"
        RA           10.9061
        Dec          -0.3656
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.9687   0.2448   0.0410]
        Angle     70.1969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 655"
}

Galaxy "IC 656"
{
        Type  "E0"
        RA           10.9189
        Dec          17.6117
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.7031  -0.6472  -0.2946]
        Angle    115.1703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 656"
}

Galaxy "IC 657:MCG 1-28-9:NPM 1"
{
        Type  "Sa"
        RA           10.9647
        Dec          -4.9042
        Distance   3.217e+08  # distance uncertain!
        Radius     5.615e+04
        AbsMag        -19.07
        Axis    [ -0.8053   0.2456  -0.5396]
        Angle     61.2682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 657"
}

Galaxy "IC 658:MCG 2-28-33:ZWG 66.75:NPM 1"
{
        Type  "E0"
        RA           10.9711
        Dec           8.2422
        Distance   2.631e+08  # distance uncertain!
        Radius     2.678e+04
        AbsMag        -20.13
        Axis    [  0.5635  -0.3184  -0.7623]
        Angle     94.7618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 658"
}

Galaxy "IC 659:MCG 1-28-10:NPM 1"
{
        Type  "E0"
        RA           10.9675
        Dec          -6.2600
        Distance   3.981e+08  # distance uncertain!
        Radius     8.107e+04
        AbsMag        -20.13
        Axis    [ -0.1831   0.3009  -0.9359]
        Angle    109.0030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 659"
}

Galaxy "IC 660:ZWG 10.48:NPM 1:DRCG 21-17"
{
        Type  "E0"
        RA           10.9739
        Dec           1.3833
        Distance   4.169e+08  # distance uncertain!
        Radius     5.457e+04
        AbsMag        -20.13
        Axis    [  0.6266  -0.4015  -0.6679]
        Angle    106.9526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 660"
}

Galaxy "IC 661:ZWG 10.50:DRCG 21-45"
{
        Type  "S0"
        RA           10.9808
        Dec           1.6511
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.7535  -0.5551  -0.3522]
        Angle    125.9887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 661"
}

Galaxy "IC 662:ZWG 10.56:NPM 1:DRCG 21-34"
{
        Type  "E0"
        RA           10.9889
        Dec           1.5994
        Distance   3.981e+08  # distance uncertain!
        Radius     5.212e+04
        AbsMag        -20.13
        Axis    [  0.3583  -0.1046  -0.9277]
        Angle     95.1836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 662"
}

Galaxy "IC 663:ZWG 66.87:DRCG 22-36"
{
        Type  "S0"
        RA           11.0103
        Dec          10.4372
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.6474   0.5118  -0.5647]
        Angle     81.0741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 663"
}

Galaxy "IC 664:MCG 2-28-42:ZWG 66.91:DRCG 22-45"
{
        Type  "S0"
        RA           11.0125
        Dec          10.5531
        Distance   4.744e+08  # method: V
        Radius      8.97e+04
        AbsMag        -21.41
        Axis    [  0.9519  -0.1616  -0.2602]
        Angle     75.3504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 664"
}

Galaxy "IC 665:NPM 1"
{
        Type  "S0"
        RA           11.0081
        Dec         -13.8661
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.3776   0.1797  -0.9084]
        Angle     48.9334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 665"
}

Galaxy "IC 666:MK 1276:ZWG 66.97:DRCG 22-35"
{
        Type  "E0"
        RA           11.0206
        Dec          10.4808
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [ -0.2226   0.4979  -0.8382]
        Angle    103.8609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 666"
}

Galaxy "IC 667:ZWG 95.111:NPM 1"
{
        Type  "E0"
        RA           11.1100
        Dec          15.0892
        Distance   3.802e+08  # distance uncertain!
        Radius     1.659e+04
        AbsMag        -20.13
        Axis    [  0.6915  -0.6507  -0.3137]
        Angle    118.2895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 667"
}

Galaxy "IC 668:MCG 3-28-59:ZWG 95.112"
{
        Type  "Sb"
        RA           11.1108
        Dec          15.0411
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.8222   0.2654  -0.5035]
        Angle     33.7386
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 668"
}

Galaxy "IC 669:UGC 6174:MCG 1-28-40:ZWG 38.132"
{
        Type  "S0"
        RA           11.1211
        Dec           6.3031
        Distance   4.146e+08  # method: V
        Radius     7.237e+04
        AbsMag        -21.12
        Axis    [ -0.7281   0.4271  -0.5361]
        Angle     64.7936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 669"
}

Galaxy "IC 670:UGC 6178:MCG 1-28-41:ZWG 38.134"
{
        Type  "S0"
        RA           11.1244
        Dec           6.7144
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.8521  -0.1955  -0.4856]
        Angle     72.8515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 670"
}

Galaxy "IC 671:UGC 6180:MCG 0-28-31:ZWG 10.79"
{
        Type  "Sb"
        RA           11.1253
        Dec           0.7833
        Distance   1.612e+08  # distance uncertain!
        Radius     3.048e+04
        AbsMag        -19.07
        Axis    [  0.8342  -0.3660  -0.4125]
        Angle    104.0569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 671"
}

Galaxy "IC 672:MCG 2-29-2"
{
        Type  "S0"
        RA           11.1342
        Dec         -12.4842
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [ -0.7235   0.1310  -0.6778]
        Angle     52.0783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 672"
}

Galaxy "IC 673:UGC 6200:MCG 0-29-3:ZWG 11.9"
{
        Type  "Sb"
        RA           11.1569
        Dec          -0.0978
        Distance    1.91e+08  # method: V
        Radius     4.723e+04
        AbsMag        -19.54
        Axis    [ -0.8412   0.2838  -0.4603]
        Angle     59.1305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 673"
}

Galaxy "IC 674:UGC 6221:MCG 7-23-27:ZWG 213.31"
{
        Type  "Sb"
        RA           11.1850
        Dec          43.6331
        Distance   3.527e+08  # method: V
        Radius     8.721e+04
        AbsMag        -20.87
        Axis    [ -0.1660   0.8811   0.4428]
        Angle     35.1429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 674"
}

Galaxy "IC 676:UGC 6245:MCG 2-29-9:MK 731"
{
        Type  "SBa"
        RA           11.2108
        Dec           9.0561
        Distance   7.982e+07  # method: V
        Radius     2.438e+04
        AbsMag        -18.84
        Axis    [  0.9711  -0.2227  -0.0864]
        Angle    102.1685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 676"
}

Galaxy "IC 677:UGC 6262:MCG 2-29-13:ZWG 67.38"
{
        Type  "Sc"
        RA           11.2322
        Dec          12.3017
        Distance   2.024e+08  # method: T-F
        Radius     4.416e+04
        AbsMag        -20.26
        Axis    [  0.9999  -0.0129  -0.0089]
        Angle     67.1430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 677"
}

Galaxy "IC 678:MCG 1-29-21:ZWG 39.83:NPM 1"
{
        Type  "E0"
        RA           11.2350
        Dec           6.5778
        Distance   5.975e+07  # method: V
        Radius          6083
        AbsMag        -16.41
        Axis    [ -0.1680   0.3800  -0.9096]
        Angle     97.9216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 678"
}

Galaxy "IC 679:NPM 1"
{
        Type  "S0"
        RA           11.2767
        Dec         -13.9714
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.0718   0.0914  -0.9932]
        Angle     55.1098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 679"
}

Galaxy "IC 680:MCG 0-29-12:ZWG 11.47:IRAS 11153-0140"
{
        Type  "Sa"
        RA           11.2983
        Dec          -1.9467
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.7577   0.2952  -0.5821]
        Angle     64.5480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 680"
}

Galaxy "IC 681:MCG 2-29-17"
{
        Type  "Sc"
        RA           11.3086
        Dec         -12.1403
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.9730  -0.0141  -0.2305]
        Angle    100.7826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 681"
}

Galaxy "IC 683:ZWG 39.138:NPM 1"
{
        Type  "E0"
        RA           11.3586
        Dec           2.7522
        Distance   3.468e+08  # distance uncertain!
        Radius     4.035e+04
        AbsMag        -20.13
        Axis    [  0.6976  -0.6082  -0.3786]
        Angle    128.5054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 683"
}

Galaxy "IC 685"
{
        Type  "E0"
        RA           11.3683
        Dec          17.7542
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [ -0.2739   0.5869  -0.7620]
        Angle    101.1704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 685"
}

Galaxy "IC 686:ZWG 39.158"
{
        Type  "S0"
        RA           11.3847
        Dec           5.6442
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.9830  -0.1236  -0.1355]
        Angle     83.9084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 686"
}

Galaxy "IC 687:MCG 8-21-32:ZWG 242.33:NPM 1"
{
        Type  "S0"
        RA           11.4047
        Dec          47.8481
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.5583  -0.8215  -0.1159]
        Angle    100.2055
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 687"
}

Galaxy "IC 688:IRAS 11211-0931"
{
        Type  "S0"
        RA           11.3944
        Dec          -9.7958
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.1529   0.1236  -0.9805]
        Angle     32.8161
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 688"
}

Galaxy "IC 690:NPM 1"
{
        Type  "S0"
        RA           11.4056
        Dec          -8.3414
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.9129   0.0848  -0.3992]
        Angle     61.1248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 690"
}

Galaxy "IC 691:UGC 6447:MCG 10-16-139:MK 169"
{
        Type  "Irr"
        RA           11.4456
        Dec          59.1556
        Distance    6.12e+07  # method: V
        Radius          5341
        AbsMag        -17.17
        Axis    [ -0.3487   0.9322   0.0973]
        Angle     58.1708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 691"
}

Galaxy "IC 692:UGC 6438:MCG 2-29-27:ZWG 67.73"
{
        Type  "S0"
        RA           11.4314
        Dec           9.9875
        Distance   6.836e+07  # method: V
        Radius          6960
        AbsMag        -17.31
        Axis    [ -0.1781   0.3972  -0.9003]
        Angle     40.5854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 692"
}

Galaxy "IC 693:MCG 1-29-22:IRAS 11242-0443"
{
        Type  "Sb"
        RA           11.4467
        Dec          -5.0044
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.5706   0.0171  -0.8210]
        Angle     44.1647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 693"
}

Galaxy "IC 694:MCG 10-17-2A:ARP 299:VV 118"
{
        Type  "S0"
        RA           11.4742
        Dec          58.5786
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.4910  -0.8703  -0.0380]
        Angle     95.8266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 694"
}

Galaxy "IC 695"
{
        Type  "S0"
        RA           11.4661
        Dec         -11.7153
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.8377   0.1308  -0.5302]
        Angle     35.1549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 695"
}

Galaxy "IC 696:UGC 6477:MCG 2-29-34:ZWG 67.86"
{
        Type  "Irr"
        RA           11.4775
        Dec           9.0992
        Distance   3.003e+08  # method: V
        Radius     4.368e+04
        AbsMag        -20.42
        Axis    [ -0.3270   0.4082  -0.8523]
        Angle     66.3949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 696"
}

Galaxy "IC 697:ZWG 11.106:NPM 1"
{
        Type  "S0"
        RA           11.4761
        Dec          -1.6289
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.5281   0.2707  -0.8049]
        Angle     37.7327
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 697"
}

Galaxy "IC 698:UGC 6482:MCG 2-29-35:ZWG 67.88"
{
        Type  "S0"
        RA           11.4842
        Dec           9.1125
        Distance   3.031e+08  # method: V
        Radius     4.409e+04
        AbsMag        -20.44
        Axis    [ -0.7266   0.4501  -0.5192]
        Angle     42.4952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 698"
}

Galaxy "IC 699:UGC 6485:MCG 2-29-36:ZWG 67.89"
{
        Type  "Sb"
        RA           11.4850
        Dec           8.9892
        Distance   2.975e+08  # method: V
        Radius     5.192e+04
        AbsMag         -20.2
        Axis    [  0.9959  -0.0195   0.0884]
        Angle    100.7015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 699"
}

Galaxy "IC 700:UGC 6487:MCG 4-27-47:ZWG 126.67"
{
        Type  "Sa"
        RA           11.4875
        Dec          20.5828
        Distance   7.869e+07  # method: V
        Radius     1.144e+04
        AbsMag        -17.61
        Axis    [  0.9952  -0.0943  -0.0257]
        Angle     52.4437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 700"
}

Galaxy "IC 701:UGC 6503:MCG 4-27-51:ZWG 126.74"
{
        Type  "Irr"
        RA           11.5167
        Dec          20.4697
        Distance   2.929e+08  # method: V
        Radius     2.556e+04
        AbsMag        -20.07
        Axis    [  0.3227   0.2356  -0.9167]
        Angle     38.6076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 701"
}

Galaxy "IC 702"
{
        Type  "S0"
        RA           11.5150
        Dec          -4.9222
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [ -0.4143   0.1932  -0.8894]
        Angle     36.8118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 702"
}

Galaxy "IC 705:MCG 8-21-49:ZWG 268.50:NPM 1"
{
        Type  "E0"
        RA           11.5489
        Dec          50.2422
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [  0.5653  -0.7728  -0.2884]
        Angle     78.8163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 705"
}

Galaxy "IC 706:MCG 2-30-4"
{
        Type  "Sa"
        RA           11.5533
        Dec         -13.3381
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [  0.2103   0.0746  -0.9748]
        Angle     15.2418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 706"
}

Galaxy "IC 707:UGC 6543:MCG 4-27-64:ZWG 126.91"
{
        Type  "Sc"
        RA           11.5622
        Dec          21.3800
        Distance   3.124e+08  # method: V
        Radius     2.272e+04
        AbsMag        -20.51
        Axis    [  0.8850  -0.4432  -0.1428]
        Angle     93.1962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 707"
}

Galaxy "IC 708:UGC 6549:MCG 8-21-56:ZWG 242.48"
{
        Type  "E0"
        RA           11.5664
        Dec          49.0622
        Distance   4.438e+08  # method: V
        Radius     9.037e+04
        AbsMag        -21.67
        Axis    [ -0.1110   0.8238  -0.5559]
        Angle     92.7002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 708"
}

Galaxy "IC 709:MCG 8-21-57:ZWG 242.49:NPM 1"
{
        Type  "E0"
        RA           11.5706
        Dec          49.0436
        Distance   4.419e+08  # method: V
        Radius     3.856e+04
        AbsMag        -20.66
        Axis    [  0.5122  -0.8488  -0.1308]
        Angle    101.7467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 709"
}

Galaxy "IC 710:ZWG 126.98"
{
        Type  "S0"
        RA           11.5742
        Dec          25.8761
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.9451  -0.3055   0.1156]
        Angle    109.3375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 710"
}

Galaxy "IC 711:MCG 8-21-62:ZWG 242.53"
{
        Type  "E0"
        RA           11.5794
        Dec          48.9561
        Distance   4.499e+08  # method: V
        Radius     3.272e+04
        AbsMag         -20.6
        Axis    [  0.5118  -0.8490  -0.1315]
        Angle    101.8884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 711"
}

Galaxy "IC 712:MCG 8-21-63:ZWG 242.54"
{
        Type  "E0"
        RA           11.5803
        Dec          49.0778
        Distance   4.645e+08  # method: V
        Radius     7.431e+04
        AbsMag        -20.97
        Axis    [  0.4463   0.1048  -0.8887]
        Angle     48.6275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 712"
}

Galaxy "IC 715-1"
{
        Type  "S0"
        RA           11.6150
        Dec          -8.3756
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.7543   0.1647  -0.6356]
        Angle     60.8113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 715-1"
}

Galaxy "IC 715-2"
{
        Type  "E0"
        RA           11.6150
        Dec          -8.3789
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.3715  -0.2866  -0.8831]
        Angle    106.1568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 715-2"
}

Galaxy "IC 716:UGC 6612:MCG 0-30-18:ZWG 12.47"
{
        Type  "Sc"
        RA           11.6508
        Dec          -0.2056
        Distance   2.621e+08  # method: V
        Radius       6.1e+04
        AbsMag        -19.72
        Axis    [ -0.9620   0.2239  -0.1566]
        Angle     19.2713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 716"
}

Galaxy "IC 718:UGC 6626:MCG 2-30-7:ZWG 68.18"
{
        Type  "Irr"
        RA           11.6644
        Dec           8.8744
        Distance   1.055e+08  # method: V
        Radius     1.841e+04
        AbsMag        -18.05
        Axis    [  0.9858  -0.1675  -0.0091]
        Angle    108.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 718"
}

Galaxy "IC 719:UGC 6633:MCG 2-30-8:ZWG 68.21"
{
        Type  "S0"
        RA           11.6717
        Dec           9.0097
        Distance    9.98e+07  # method: V
        Radius     1.887e+04
        AbsMag        -18.63
        Axis    [  0.9995  -0.0301   0.0042]
        Angle     60.9202
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 719"
}

Galaxy "IC 720:MCG 2-30-16:ZWG 68.35:KCPG 298A"
{
        Type  "Sc"
        RA           11.7061
        Dec           8.7672
        Distance   3.047e+08  # method: V
        Radius     4.875e+04
        AbsMag        -20.15
        Axis    [  0.9651  -0.2545  -0.0617]
        Angle    112.8095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 720"
}

Galaxy "IC 721:MCG 1-30-26:IRAS 11399-0803"
{
        Type  "Sc"
        RA           11.7078
        Dec          -8.3403
        Distance   3.218e+08  # method: V
        Radius     6.084e+04
        AbsMag        -19.87
        Axis    [ -0.0923   0.0463  -0.9947]
        Angle     13.2161
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 721"
}

Galaxy "IC 722:MCG 2-30-19:ZWG 68.39"
{
        Type  "Sc"
        RA           11.7119
        Dec           8.9744
        Distance   3.117e+08  # method: V
        Radius     4.987e+04
        AbsMag         -20.2
        Axis    [  0.8738  -0.1888  -0.4481]
        Angle     53.1278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 722"
}

Galaxy "IC 723:MCG 1-30-27:MK 1305:NPM 1"
{
        Type  "Irr"
        RA           11.7158
        Dec          -8.3319
        Distance    3.02e+08  # distance uncertain!
        Radius     3.075e+04
        AbsMag        -20.13
        Axis    [  0.8662  -0.3638  -0.3425]
        Angle    122.3539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 723"
}

Galaxy "IC 724:UGC 6695:MCG 2-30-22:ZWG 68.45"
{
        Type  "Sa"
        RA           11.7261
        Dec           8.9425
        Distance   2.859e+08  # method: V
        Radius     9.565e+04
        AbsMag        -21.11
        Axis    [  0.9898  -0.0784  -0.1187]
        Angle     53.4544
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 724"
}

Galaxy "IC 725:ZWG 12.65"
{
        Type  "E0"
        RA           11.7247
        Dec          -1.6683
        Distance   3.631e+08  # distance uncertain!
        Radius     2.641e+04
        AbsMag        -20.13
        Axis    [  0.6718  -0.6132  -0.4154]
        Angle    133.7437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 725"
}

Galaxy "IC 726"
{
        Type  "S0"
        RA           11.7292
        Dec          33.3928
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.8795  -0.4670   0.0909]
        Angle    107.8870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 726"
}

Galaxy "IC 727:UGC 6715:MCG 2-30-25:ZWG 68.50"
{
        Type  "Sb"
        RA           11.7411
        Dec          10.7833
        Distance   2.928e+08  # method: V
        Radius     6.813e+04
        AbsMag        -19.77
        Axis    [ -0.9708   0.2206   0.0937]
        Angle     49.1983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 727"
}

Galaxy "IC 728:UGC 6720:MCG 0-30-21:ZWG 12.71"
{
        Type  "SBb"
        RA           11.7472
        Dec          -1.6014
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [  0.9039  -0.1018  -0.4155]
        Angle     53.8289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 728"
}

Galaxy "IC 729:ZWG 186.37"
{
        Type  "S0"
        RA           11.7550
        Dec          33.3358
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.9319  -0.2873   0.2213]
        Angle    109.4617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 729"
}

Galaxy "IC 731:MCG 8-21-96:ZWG 242.79:ZWG 243.3"
{
        Type  "S0"
        RA           11.7550
        Dec          49.5703
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.8604   0.0196   0.5092]
        Angle     35.1864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 731"
}

Galaxy "IC 732-1:MCG 4-28-50:ZWG 127.51"
{
        Type  "Sa"
        RA           11.7664
        Dec          20.4389
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [ -0.6137   0.6246  -0.4831]
        Angle     35.2828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 732-1"
}

Galaxy "IC 732-2:MCG 4-28-50:ZWG 127.51:IRAS 11434+2042"
{
        Type  "Irr"
        RA           11.7664
        Dec          20.4478
        Distance   3.446e+08  # method: V
        Radius     2.005e+04
        AbsMag        -19.62
        Axis    [ -0.7979   0.5536  -0.2387]
        Angle     46.4207
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 732-2"
}

Galaxy "IC 733"
{
        Type  "S0"
        RA           11.7661
        Dec          -8.1558
        Distance   1.213e+08  # method: V
        Radius     1.235e+04
        AbsMag        -17.15
        Axis    [  0.8259  -0.0026  -0.5638]
        Angle     31.2239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 733"
}

Galaxy "IC 734-1:MCG 1-30-31"
{
        Type  "E0"
        RA           11.7675
        Dec          -8.2708
        Distance   3.981e+08  # distance uncertain!
        Radius     5.791e+04
        AbsMag        -20.13
        Axis    [  0.6803  -0.5821  -0.4453]
        Angle    138.4505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 734-1"
}

Galaxy "IC 734-2:MCG 1-30-31"
{
        Type  "S0"
        RA           11.7675
        Dec          -8.2653
        Distance   2.791e+08  # method: V
        Radius     1.623e+04
        AbsMag        -19.06
        Axis    [  0.6984  -0.5667  -0.4372]
        Angle    137.1229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 734-2"
}

Galaxy "IC 735:UGC 6775:MCG 2-30-38:ZWG 68.69"
{
        Type  "Sc"
        RA           11.8033
        Dec          13.2089
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.5228   0.1853  -0.8321]
        Angle     22.0656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 735"
}

Galaxy "IC 736:MCG 2-30-37:ZWG 68.68:HCG 59B"
{
        Type  "S0"
        RA           11.8056
        Dec          12.7172
        Distance   1.923e+08  # method: V
        Radius     1.399e+04
        AbsMag        -18.25
        Axis    [  0.6506  -0.6793  -0.3396]
        Angle    123.8746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 736"
}

Galaxy "IC 737:MCG 2-30-39:ZWG 68.70:HCG 59A"
{
        Type  "S0"
        RA           11.8075
        Dec          12.7272
        Distance   2.017e+08  # method: V
        Radius      1.76e+04
        AbsMag        -19.26
        Axis    [  0.3406  -0.0007  -0.9402]
        Angle     43.5919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 737"
}

Galaxy "IC 738"
{
        Type  "Irr"
        RA           11.8150
        Dec          -4.6819
        Distance   2.884e+08  # distance uncertain!
        Radius     3.356e+04
        AbsMag        -20.13
        Axis    [  0.4132  -0.0500  -0.9093]
        Angle     33.0599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 738"
}

Galaxy "IC 739:UGC 6830:MCG 4-28-72:ZWG 127.77"
{
        Type  "SBb"
        RA           11.8586
        Dec          23.8628
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.5849   0.6319  -0.5085]
        Angle     47.2808
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 739"
}

Galaxy "IC 741:MCG 1-30-37"
{
        Type  "Sa"
        RA           11.8419
        Dec          -4.8364
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.7117   0.0736  -0.6986]
        Angle     30.1523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 741"
}

Galaxy "IC 742:UGC 6822:MCG 4-28-68:ZWG 127.73"
{
        Type  "SBb"
        RA           11.8506
        Dec          20.7997
        Distance   3.055e+08  # method: V
        Radius     5.331e+04
        AbsMag        -20.16
        Axis    [  0.7840  -0.5959  -0.1738]
        Angle    113.6687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 742"
}

Galaxy "IC 743:MCG 2-30-37:IRAS 11508-1259"
{
        Type  "Sc"
        RA           11.8894
        Dec         -13.2647
        Distance    2.33e+08  # distance uncertain!
        Radius     4.067e+04
        AbsMag        -19.07
        Axis    [ -0.8166  -0.0884  -0.5703]
        Angle     41.6686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 743"
}

Galaxy "IC 744:ZWG 127.102:NPM 1"
{
        Type  "S0"
        RA           11.9011
        Dec          23.1928
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [  0.9227   0.0459   0.3828]
        Angle     34.4704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 744"
}

Galaxy "IC 745:UGC 6877:MCG 0-30-34:MK 1308"
{
        Type  "S0"
        RA           11.9033
        Dec           0.1369
        Distance   5.963e+07  # method: S
        Radius          6071
        AbsMag        -17.41
        Axis    [  0.6702  -0.6210  -0.4065]
        Angle    132.4078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 745"
}

Galaxy "IC 746:UGC 6898:MCG 4-28-96:ZWG 127.106"
{
        Type  "Sc"
        RA           11.9264
        Dec          25.8889
        Distance   2.414e+08  # method: V
        Radius     3.862e+04
        AbsMag        -19.75
        Axis    [ -0.8924   0.4265   0.1477]
        Angle     59.4694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 746"
}

Galaxy "IC 747:NPM 1"
{
        Type  "E0"
        RA           11.9511
        Dec          -8.2917
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.4858  -0.4527  -0.7477]
        Angle    115.5021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 747"
}

Galaxy "IC 748:MCG 1-31-6:ZWG 41.11:ARAK 336"
{
        Type  "E0"
        RA           11.9572
        Dec           7.4614
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [  0.2988  -0.2708  -0.9151]
        Angle     87.4390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 748"
}

Galaxy "IC 749:UGC 6962:MCG 7-25-8:ZWG 215.9"
{
        Type  "SBc"
        RA           11.9758
        Dec          42.7333
        Distance   4.621e+07  # method: V
        Radius     1.546e+04
        AbsMag        -17.86
        Axis    [ -0.3350   0.8379  -0.4310]
        Angle     50.0731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 749"
}

Galaxy "IC 750:UGC 6973:MCG 7-25-10:ZWG 215.12"
{
        Type  "Sb"
        RA           11.9811
        Dec          42.7228
        Distance   4.245e+07  # method: V
        Radius     1.605e+04
        AbsMag        -17.77
        Axis    [  0.8860  -0.3002   0.3533]
        Angle     70.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 750"
}

Galaxy "IC 751:UGC 6972:MCG 7-25-11:ZWG 215.11"
{
        Type  "Sb"
        RA           11.9811
        Dec          42.5700
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.8738  -0.2037   0.4415]
        Angle     89.0915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 751"
}

Galaxy "IC 752:ZWG 215.14:KUG 1156+428"
{
        Type  "S0"
        RA           11.9875
        Dec          42.5669
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.7582  -0.6496   0.0568]
        Angle    107.1642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 752"
}

Galaxy "IC 753:UGC 6979:MCG 0-31-12:ZWG 13.23"
{
        Type  "S0"
        RA           11.9867
        Dec          -0.5236
        Distance   1.768e+08  # distance uncertain!
        Radius     1.028e+04
        AbsMag        -19.07
        Axis    [  0.8517  -0.3442  -0.3953]
        Angle     92.8530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 753"
}

Galaxy "IC 754:UGC 6984:MCG 0-31-13:ZWG 13.25"
{
        Type  "E0"
        RA           11.9897
        Dec          -1.6544
        Distance   2.399e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -20.13
        Axis    [  0.5940  -0.5827  -0.5546]
        Angle    123.7703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 754"
}

Galaxy "IC 756:UGC 7026:MCG 1-31-15:ZWG 41.29"
{
        Type  "Sc"
        RA           12.0492
        Dec           4.8450
        Distance   3.054e+08  # method: T-F
        Radius     7.995e+04
        AbsMag        -20.56
        Axis    [  0.6900  -0.0554  -0.7217]
        Angle     16.6235
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 756"
}

Galaxy "IC 758:UGC 7056:MCG 11-15-14:ZWG 315.9"
{
        Type  "SBc"
        RA           12.0697
        Dec          62.5056
        Distance    6.36e+07  # method: V
        Radius     1.758e+04
        AbsMag        -17.35
        Axis    [  0.6579  -0.7185   0.2257]
        Angle     96.2594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 758"
}

Galaxy "IC 760:ESO 440-52:MCG 5-29-10"
{
        Type  "S0"
        RA           12.0981
        Dec         -29.2928
        Distance   1.159e+08  # method: V
        Radius     2.865e+04
        AbsMag        -19.35
        Axis    [ -0.7113  -0.3487  -0.6103]
        Angle     50.6382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 760"
}

Galaxy "IC 761:MCG 2-31-14:NPM 1"
{
        Type  "S0"
        RA           12.0981
        Dec         -12.6728
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.4491  -0.2553  -0.8562]
        Angle     24.0922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 761"
}

Galaxy "IC 762:MCG 4-29-34:ZWG 128.37:KUG 1205+260"
{
        Type  "S0"
        RA           12.1364
        Dec          25.7564
        Distance   3.461e+08  # method: T-F
        Radius     3.524e+04
        AbsMag        -20.03
        Axis    [ -0.7293   0.6451  -0.2278]
        Angle     33.7423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 762"
}

Galaxy "IC 763:MCG 4-29-35:ZWG 128.38:NPM 1"
{
        Type  "S0"
        RA           12.1375
        Dec          25.8119
        Distance   3.342e+08  # method: V
        Radius     4.374e+04
        AbsMag        -19.75
        Axis    [  0.9015  -0.0324   0.4315]
        Angle     31.3843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 763"
}

Galaxy "IC 764:ESO 441-13:MCG 5-29-25:UGCA 273"
{
        Type  "SBc"
        RA           12.1706
        Dec         -29.7369
        Distance   1.067e+08  # method: T-F
        Radius     7.448e+04
        AbsMag        -19.67
        Axis    [ -0.8940  -0.3027  -0.3304]
        Angle     72.7980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 764"
}

Galaxy "IC 766:MCG 2-31-20"
{
        Type  "Sa"
        RA           12.1814
        Dec         -12.6547
        Distance   2.105e+08  # method: V
        Radius     3.979e+04
        AbsMag        -19.15
        Axis    [ -0.9651  -0.1866  -0.1837]
        Angle     53.9144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 766"
}

Galaxy "IC 767:MCG 2-31-42:MK 760:ZWG 69.73"
{
        Type  "E0"
        RA           12.1839
        Dec          12.1042
        Distance   9.459e+07  # method: V
        Radius          9630
        AbsMag        -17.51
        Axis    [  0.3479  -0.3872  -0.8538]
        Angle     85.8727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 767"
}

Galaxy "IC 768:UGC 7192:MCG 2-31-44:ZWG 69.75"
{
        Type  "Sc"
        RA           12.1964
        Dec          12.1431
        Distance   1.971e+08  # method: V
        Radius     4.014e+04
        AbsMag        -19.51
        Axis    [ -0.0557   0.1956  -0.9791]
        Angle     12.8743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 768"
}

Galaxy "IC 769:UGC 7209:MCG 2-31-47:ZWG 69.83"
{
        Type  "SBc"
        RA           12.2089
        Dec          12.1233
        Distance   1.156e+08  # method: V
        Radius     4.202e+04
        AbsMag        -19.55
        Axis    [  0.8738  -0.3901  -0.2903]
        Angle     74.2622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 769"
}

Galaxy "IC 770:NPM 1"
{
        Type  "E0"
        RA           12.2172
        Dec          -4.5528
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.6293  -0.6323  -0.4519]
        Angle    138.5692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 770"
}

Galaxy "IC 771:MCG 2-31-67:ZWG 69.105:VCC 142"
{
        Type  "SBc"
        RA           12.2536
        Dec          13.1844
        Distance   2.807e+08  # method: V
        Radius      2.45e+04
        AbsMag        -19.97
        Axis    [  0.9003  -0.4188  -0.1189]
        Angle    114.9157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 771"
}

Galaxy "IC 772:IC 3067:ZWG 128.61:NPM 1"
{
        Type  "S0"
        RA           12.2542
        Dec          23.9589
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.9497  -0.0205  -0.3123]
        Angle     15.0692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 772"
}

Galaxy "IC 773:MCG 1-31-44:ZWG 41.73:VCC 271"
{
        Type  "SBa"
        RA           12.3022
        Dec           6.1394
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.8061  -0.5228  -0.2774]
        Angle    121.3452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 773"
}

Galaxy "IC 774:NPM 1"
{
        Type  "E0"
        RA           12.3142
        Dec          -6.7658
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [  0.6239  -0.6269  -0.4666]
        Angle    140.5303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 774"
}

Galaxy "IC 775:UGC 7350:MCG 2-31-87:ZWG 70.4"
{
        Type  "S0"
        RA           12.3147
        Dec          12.9131
        Distance   3.638e+08  # method: V
        Radius     6.349e+04
        AbsMag        -20.84
        Axis    [  0.8541  -0.4682  -0.2265]
        Angle     99.3132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 775"
}

Galaxy "IC 776:UGC 7352:MCG 2-31-88:ZWG 70.5"
{
        Type  "SBc"
        RA           12.3172
        Dec           8.8569
        Distance   1.268e+08  # method: V
        Radius      3.32e+04
        AbsMag        -18.85
        Axis    [  0.7828  -0.2592  -0.5657]
        Angle     19.3089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 776"
}

Galaxy "IC 777:UGC 7363:MCG 5-29-52:ZWG 158.64"
{
        Type  "SBb"
        RA           12.3231
        Dec          28.3094
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [ -0.7588   0.6362  -0.1396]
        Angle     37.0022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 777"
}

Galaxy "IC 779:UGC 7369:MCG 5-29-53:ZWG 158.66"
{
        Type  "SBc"
        RA           12.3272
        Dec          29.8828
        Distance   2.781e+07  # method: V
        Radius          3641
        AbsMag        -14.45
        Axis    [  0.5449  -0.7991  -0.2541]
        Angle    118.6534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 779"
}

Galaxy "IC 780:UGC 7381:MCG 4-29-64:ZWG 128.77"
{
        Type  "S0"
        RA           12.3328
        Dec          25.7719
        Distance   3.193e+08  # method: V
        Radius     5.108e+04
        AbsMag        -20.75
        Axis    [  0.8475  -0.5274  -0.0601]
        Angle    106.4533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 780"
}

Galaxy "IC 781:MCG 3-32-2:ZWG 99.17:VCC 389"
{
        Type  "Sa"
        RA           12.3342
        Dec          14.9614
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [  0.7761  -0.4911  -0.3956]
        Angle     76.0472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 781"
}

Galaxy "IC 782:MCG 1-32-20:ZWG 42.43:VCC 486"
{
        Type  "SBa"
        RA           12.3600
        Dec           5.7664
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.8208  -0.3628  -0.4411]
        Angle     60.6937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 782"
}

Galaxy "IC 783:UGC 7415:MCG 3-32-8:ZWG 99.25"
{
        Type  "SBa"
        RA           12.3606
        Dec          15.7447
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [ -0.6877   0.3964  -0.6082]
        Angle     34.2750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 783"
}

Galaxy "IC 783A:MCG 3-32-13:VCC 545"
{
        Type  "S0"
        RA           12.3719
        Dec          15.7333
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.5860  -0.7342  -0.3429]
        Angle    126.4811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 783A"
}

Galaxy "IC 784:MCG 1-32-6:IRAS 12199-0422"
{
        Type  "Sc"
        RA           12.3750
        Dec          -4.6528
        Distance   1.853e+08  # method: T-F
        Radius      5.12e+04
        AbsMag        -19.87
        Axis    [  0.1670  -0.3830  -0.9085]
        Angle     19.4631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 784"
}

Galaxy "IC 785:MCG 2-32-7:NPM 1:IRAS 12204-1256"
{
        Type  "Sc"
        RA           12.3839
        Dec         -13.2231
        Distance   2.183e+08  # method: V
        Radius     2.857e+04
        AbsMag        -19.43
        Axis    [  0.8755  -0.1898  -0.4444]
        Angle     58.1584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 785"
}

Galaxy "IC 786:MCG 2-32-8:NPM 1"
{
        Type  "S0"
        RA           12.3861
        Dec         -13.2042
        Distance   2.148e+08  # method: V
        Radius     3.124e+04
        AbsMag        -19.69
        Axis    [ -0.7212   0.2162  -0.6581]
        Angle     87.3325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 786"
}

Galaxy "IC 787:MCG 3-32-31:ZWG 99.43:VCC 799"
{
        Type  "Sa"
        RA           12.4236
        Dec          16.1236
        Distance   4.324e+08  # method: V
        Radius     6.917e+04
        AbsMag        -20.51
        Axis    [  0.9614  -0.2744   0.0190]
        Angle    114.2576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 787"
}

Galaxy "IC 789:UGC 7533:MCG 1-32-61:ZWG 42.102"
{
        Type  "S0"
        RA           12.4389
        Dec           7.4603
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.7508   0.0937  -0.6538]
        Angle     22.7177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 789"
}

Galaxy "IC 790:MCG 2-32-51:ZWG 70.75:VCC 919"
{
        Type  "E0"
        RA           12.4431
        Dec           9.0358
        Distance   3.459e+08  # method: V
        Radius     3.018e+04
        AbsMag        -19.53
        Axis    [  0.1541  -0.2367  -0.9593]
        Angle     81.8683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 790"
}

Galaxy "IC 791:UGC 7555:MCG 4-29-71:ZWG 128.89"
{
        Type  "SBa"
        RA           12.4497
        Dec          22.6400
        Distance   3.234e+08  # method: V
        Radius     5.174e+04
        AbsMag        -20.88
        Axis    [  0.5574  -0.7728  -0.3034]
        Angle    123.4653
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 791"
}

Galaxy "IC 792:UGC 7558:MCG 3-32-40:ZWG 99.56"
{
        Type  "Sb"
        RA           12.4522
        Dec          16.3250
        Distance   2.963e+08  # method: V
        Radius     6.896e+04
        AbsMag        -20.09
        Axis    [  0.9591  -0.2811   0.0330]
        Angle     55.3778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 792"
}

Galaxy "IC 794:UGC 7585:MCG 2-32-70:ZWG 70.102"
{
        Type  "E0"
        RA           12.4689
        Dec          12.0939
        Distance   9.581e+07  # method: V
        Radius     1.812e+04
        AbsMag        -18.14
        Axis    [  0.0212  -0.0618  -0.9979]
        Angle     76.2943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 794"
}

Galaxy "IC 795:ZWG 128.91:ZWG 129.1"
{
        Type  "S0"
        RA           12.4753
        Dec          23.3053
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.9090   0.4068   0.0914]
        Angle     51.0299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 795"
}

Galaxy "IC 796:UGC 7623:MCG 3-32-51:ZWG 99.68"
{
        Type  "Sa"
        RA           12.4906
        Dec          16.4047
        Distance   8.476e+07  # method: V
        Radius     1.603e+04
        AbsMag        -17.87
        Axis    [ -0.9315   0.3388  -0.1325]
        Angle     30.7732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 796"
}

Galaxy "IC 797:UGC 7676:MCG 3-32-58:ZWG 99.77"
{
        Type  "SBc"
        RA           12.5317
        Dec          15.1236
        Distance   1.094e+08  # method: V
        Radius     2.068e+04
        AbsMag        -18.63
        Axis    [  0.2283  -0.1759  -0.9576]
        Angle     23.5853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 797"
}

Galaxy "IC 798:ZWG 99.83:VCC 1440:NPM 1"
{
        Type  "E0"
        RA           12.5425
        Dec          15.4158
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.5477  -0.7547  -0.3612]
        Angle    129.1007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 798"
}

Galaxy "IC 800:UGC 7716:MCG 3-32-69:ZWG 99.90"
{
        Type  "SBc"
        RA           12.5656
        Dec          15.3544
        Distance     1.2e+08  # method: V
        Radius     2.793e+04
        AbsMag        -18.73
        Axis    [ -0.7508   0.4182  -0.5112]
        Angle     49.5431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 800"
}

Galaxy "IC 801:UGC 7717:MCG 9-21-17:ZWG 270.9"
{
        Type  "Sa"
        RA           12.5622
        Dec          52.2547
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.7668  -0.6347   0.0960]
        Angle     57.4193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 801"
}

Galaxy "IC 803:MCG 3-32-80:ZWG 99.105:VV 564"
{
        Type  "Irr"
        RA           12.6600
        Dec          16.5889
        Distance   5.249e+08  # distance uncertain!
        Radius     6.107e+04
        AbsMag        -20.13
        Axis    [ -0.7595   0.0628   0.6475]
        Angle     20.9042
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 803"
}

Galaxy "IC 804"
{
        Type  "S0"
        RA           12.6875
        Dec          -5.0092
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.5340  -0.4036  -0.7429]
        Angle     46.9483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 804"
}

Galaxy "IC 806:MCG 3-32-19:NPM 1"
{
        Type  "Sb"
        RA           12.7022
        Dec         -17.3497
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.4357  -0.0867  -0.8959]
        Angle     69.7497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 806"
}

Galaxy "IC 807:MCG 3-32-20:NPM 1"
{
        Type  "S0"
        RA           12.7033
        Dec         -17.4036
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.6206  -0.5794  -0.5283]
        Angle    147.5745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 807"
}

Galaxy "IC 809:IC 3672:UGC 7863:MCG 2-32-184"
{
        Type  "E0"
        RA           12.7022
        Dec          11.7542
        Distance   2.564e+07  # method: V
        Radius          3729
        AbsMag        -15.28
        Axis    [  0.5417  -0.7462  -0.3869]
        Angle    132.3888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 809"
}

Galaxy "IC 810:UGC 7864:MCG 2-32-185:ZWG 70.226"
{
        Type  "Sa"
        RA           12.7022
        Dec          12.5967
        Distance   8.743e+06  # method: V
        Radius          2035
        AbsMag        -12.84
        Axis    [ -0.9808   0.1525   0.1215]
        Angle     51.3296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 810"
}

Galaxy "IC 812"
{
        Type  "E0"
        RA           12.7472
        Dec          -4.4344
        Distance   2.884e+08  # distance uncertain!
        Radius     3.356e+04
        AbsMag        -20.13
        Axis    [ -0.1655  -0.0439  -0.9852]
        Angle     89.7576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 812"
}

Galaxy "IC 813:UGC 7928:MCG 4-30-19:ZWG 129.22"
{
        Type  "Sc"
        RA           12.7531
        Dec          23.0358
        Distance   3.292e+08  # method: V
        Radius      4.31e+04
        AbsMag        -20.62
        Axis    [  0.6942  -0.6395  -0.3303]
        Angle     85.7072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 813"
}

Galaxy "IC 814:NPM 1"
{
        Type  "S0"
        RA           12.7594
        Dec          -8.0917
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.9789  -0.0464  -0.1991]
        Angle     65.0143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 814"
}

Galaxy "IC 815:MCG 2-33-15:ZWG 71.35:VCC 2038"
{
        Type  "E0"
        RA           12.7728
        Dec          11.8767
        Distance   3.312e+08  # distance uncertain!
        Radius     2.408e+04
        AbsMag        -20.13
        Axis    [  0.5342  -0.7509  -0.3883]
        Angle    132.8866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 815"
}

Galaxy "IC 816:UGC 7944:MCG 2-33-19:ZWG 71.38"
{
        Type  "SBa"
        RA           12.7794
        Dec           9.8511
        Distance   3.333e+08  # method: V
        Radius     4.363e+04
        AbsMag        -20.25
        Axis    [  0.7679  -0.5249  -0.3671]
        Angle     87.7830
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 816"
}

Galaxy "IC 817:IC 3764:MCG 2-33-20:ZWG 71.39"
{
        Type  "S0"
        RA           12.7822
        Dec           9.8578
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.7885  -0.5589  -0.2566]
        Angle    121.6134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 817"
}

Galaxy "IC 818:MCG 5-30-78:ZWG 159.73"
{
        Type  "Sb"
        RA           12.7789
        Dec          29.7353
        Distance   2.238e+08  # method: V
        Radius      2.93e+04
        AbsMag        -18.78
        Axis    [  0.8974  -0.2515   0.3625]
        Angle     73.7187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 818"
}

Galaxy "IC 821:UGC 7957:MCG 5-30-83:ZWG 159.76"
{
        Type  "SBc"
        RA           12.7906
        Dec          29.7878
        Distance   3.169e+08  # method: V
        Radius      5.07e+04
        AbsMag        -20.34
        Axis    [  0.4997  -0.8249  -0.2644]
        Angle    123.1615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 821"
}

Galaxy "IC 822:MCG 5-30-85:NPM 1"
{
        Type  "S0"
        RA           12.7958
        Dec          30.0778
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.4981  -0.8264  -0.2625]
        Angle    123.0812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 822"
}

Galaxy "IC 825"
{
        Type  "S0"
        RA           12.8386
        Dec          -5.3631
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.5876  -0.4630  -0.6635]
        Angle     41.5497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 825"
}

Galaxy "IC 826:MCG 5-30-106:ZWG 159.95"
{
        Type  "SBb"
        RA           12.8553
        Dec          31.0592
        Distance   3.264e+08  # method: V
        Radius     2.848e+04
        AbsMag         -20.1
        Axis    [  0.4889  -0.8337  -0.2568]
        Angle    123.2272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 826"
}

Galaxy "IC 827:UGC 8008:MCG 3-33-14:ZWG 100.14"
{
        Type  "S0"
        RA           12.8653
        Dec          16.2831
        Distance   3.089e+08  # method: V
        Radius     4.044e+04
        AbsMag        -19.68
        Axis    [  0.5614  -0.5933  -0.5769]
        Angle     16.0991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 827"
}

Galaxy "IC 828"
{
        Type  "S0"
        RA           12.8708
        Dec          -8.1328
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.8482  -0.3345  -0.4106]
        Angle     34.5137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 828"
}

Galaxy "IC 829:MCG 2-33-37:NPM 1:DRCG 25-45"
{
        Type  "Sa"
        RA           12.8742
        Dec         -15.5181
        Distance   1.768e+08  # distance uncertain!
        Radius       1.8e+04
        AbsMag        -19.07
        Axis    [ -0.3391  -0.1625  -0.9266]
        Angle     66.2956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 829"
}

Galaxy "IC 830:UGC 8003:MCG 9-21-55:ZWG 270.28"
{
        Type  "S0"
        RA           12.8544
        Dec          53.6958
        Distance    2.28e+08  # method: V
        Radius     2.652e+04
        AbsMag        -19.82
        Axis    [ -0.5758   0.7206   0.3863]
        Angle     56.6068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 830"
}

Galaxy "IC 831:MCG 5-30-113:ZWG 159.100"
{
        Type  "S0"
        RA           12.8786
        Dec          26.4711
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.8251  -0.4032   0.3959]
        Angle     23.6667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 831"
}

Galaxy "IC 832:MCG 5-30-119:ZWG 159.105:NPM 1"
{
        Type  "E0"
        RA           12.8997
        Dec          26.4444
        Distance   3.297e+08  # method: V
        Radius     2.397e+04
        AbsMag        -20.12
        Axis    [  0.4770  -0.8256  -0.3014]
        Angle    126.6262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 832"
}

Galaxy "IC 833"
{
        Type  "E0"
        RA           12.9439
        Dec          -6.7333
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.0172  -0.2728  -0.9619]
        Angle     95.2936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 833"
}

Galaxy "IC 834:MCG 5-31-11:ZWG 160.22:NPM 1"
{
        Type  "E0"
        RA           12.9383
        Dec          26.3594
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.1628  -0.3226  -0.9324]
        Angle     64.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 834"
}

Galaxy "IC 835:MCG 5-31-21:ZWG 160.32:KUG 1254+267"
{
        Type  "SBb"
        RA           12.9478
        Dec          26.4869
        Distance   3.634e+08  # method: V
        Radius     3.171e+04
        AbsMag        -20.23
        Axis    [  0.4955  -0.8188  -0.2900]
        Angle    126.1782
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 835"
}

Galaxy "IC 836:UGC 8059:MCG 11-16-7:ZWG 316.6"
{
        Type  "S0"
        RA           12.9317
        Dec          63.6117
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.5506  -0.1156   0.8267]
        Angle     79.4027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 836"
}

Galaxy "IC 837:MCG 5-31-28:ZWG 160.41:IRAS 12551+2646"
{
        Type  "Sa"
        RA           12.9586
        Dec          26.5111
        Distance   3.395e+08  # method: V
        Radius     4.444e+04
        AbsMag        -19.59
        Axis    [  0.9475  -0.2857   0.1436]
        Angle    114.0457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 837"
}

Galaxy "IC 838:NGC 4849A:MCG 5-31-43:DFOT 198"
{
        Type  "SBa"
        RA           12.9703
        Dec          26.4261
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.4935  -0.8197  -0.2909]
        Angle    126.4203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 838"
}

Galaxy "IC 839:ZWG 160.57:DRCG 27-200:DFOT 201"
{
        Type  "S0"
        RA           12.9708
        Dec          28.1264
        Distance   3.476e+08  # method: V
        Radius     3.034e+04
        AbsMag        -19.34
        Axis    [  0.8400  -0.4882   0.2369]
        Angle     26.1339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 839"
}

Galaxy "IC 840:UGC 8090:MCG 2-33-40:ZWG 71.86"
{
        Type  "SBa"
        RA           12.9783
        Dec          10.6167
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.7761  -0.5419  -0.3226]
        Angle     92.3011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 840"
}

Galaxy "IC 841:MCG 4-31-2:ZWG 130.3:IRAS 12573+2204"
{
        Type  "S0"
        RA           12.9964
        Dec          21.8133
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.8798   0.1720   0.4431]
        Angle     31.3076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 841"
}

Galaxy "IC 842:UGC 8118:MCG 5-31-87:ZWG 160.88"
{
        Type  "SBc"
        RA           13.0108
        Dec          29.0186
        Distance   3.385e+08  # method: T-F
        Radius     5.909e+04
        AbsMag        -20.38
        Axis    [  0.8659  -0.4895   0.1033]
        Angle     61.0316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 842"
}

Galaxy "IC 843:UGC 8137:MCG 5-31-100:ZWG 160.99"
{
        Type  "S0"
        RA           13.0258
        Dec          29.1306
        Distance   3.493e+08  # method: V
        Radius     5.589e+04
        AbsMag        -20.45
        Axis    [ -0.8528   0.4106   0.3227]
        Angle     14.0184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 843"
}

Galaxy "IC 844:ESO 443-40:MCG 5-31-24"
{
        Type  "S0"
        RA           13.0550
        Dec         -30.5208
        Distance    1.46e+08  # method: V
        Radius     3.397e+04
        AbsMag        -19.55
        Axis    [  0.1940  -0.6096  -0.7686]
        Angle     39.4592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 844"
}

Galaxy "IC 845:MCG 2-33-53:ZWG 71.107"
{
        Type  "S0"
        RA           13.0825
        Dec          12.0786
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.5242  -0.7588  -0.3866]
        Angle    134.1231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 845"
}

Galaxy "IC 846:ZWG 130.7"
{
        Type  "E0"
        RA           13.0892
        Dec          23.0956
        Distance   4.715e+08  # method: V
        Radius     7.544e+04
        AbsMag         -20.3
        Axis    [  0.4691  -0.8204  -0.3270]
        Angle    130.0012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 846"
}

Galaxy "IC 848:MCG 3-33-31:ZWG 101.2"
{
        Type  "Sb"
        RA           13.1169
        Dec          16.0067
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.8632   0.3966  -0.3123]
        Angle     56.0958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 848"
}

Galaxy "IC 849:UGC 8202:MCG 0-34-2:ZWG 16.3"
{
        Type  "Sc"
        RA           13.1272
        Dec          -0.9425
        Distance   2.602e+08  # method: V
        Radius     6.055e+04
        AbsMag        -20.71
        Axis    [ -0.6091  -0.0320  -0.7924]
        Angle     50.3079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 849"
}

Galaxy "IC 850:MCG 0-34-3:ZWG 16.4:IRAS 13052-0036"
{
        Type  "Sc"
        RA           13.1306
        Dec          -0.8681
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.9244  -0.3754  -0.0675]
        Angle     49.2759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 850"
}

Galaxy "IC 851:UGC 8219:MCG 4-31-9:ZWG 130.11"
{
        Type  "Sb"
        RA           13.1428
        Dec          21.0500
        Distance   1.312e+08  # method: V
        Radius     1.909e+04
        AbsMag        -18.12
        Axis    [ -0.9377   0.1836   0.2949]
        Angle     33.9917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 851"
}

Galaxy "IC 852:UGC 8213:MCG 10-19-35:ZWG 294.18"
{
        Type  "S0"
        RA           13.1267
        Dec          60.1578
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.6265  -0.7584   0.1798]
        Angle     98.0476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 852"
}

Galaxy "IC 853:IC 4205:UGC 8230:MCG 9-22-19"
{
        Type  "SBb"
        RA           13.1447
        Dec          52.7744
        Distance   3.313e+08  # method: V
        Radius      7.71e+04
        AbsMag        -20.53
        Axis    [  0.6713  -0.7328   0.1115]
        Angle     85.2194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 853"
}

Galaxy "IC 854:MCG 4-31-11:ZWG 130.14:KUG 1307+248"
{
        Type  "SBc"
        RA           13.1636
        Dec          24.5775
        Distance    3.34e+08  # method: V
        Radius     3.886e+04
        AbsMag        -20.05
        Axis    [ -0.7201   0.2710  -0.6388]
        Angle     22.3305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 854"
}

Galaxy "IC 855"
{
        Type  "E0"
        RA           13.1767
        Dec          -4.4853
        Distance   2.884e+08  # distance uncertain!
        Radius     4.615e+04
        AbsMag        -20.13
        Axis    [  0.5309  -0.6897  -0.4924]
        Angle    144.5636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 855"
}

Galaxy "IC 856:ZWG 130.15"
{
        Type  "S0"
        RA           13.1781
        Dec          20.5369
        Distance   1.962e+08  # method: V
        Radius     2.854e+04
        AbsMag         -18.7
        Axis    [  0.8934  -0.3115   0.3236]
        Angle     62.2214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 856"
}

Galaxy "IC 857:UGC 8310:MCG 3-34-6:ZWG 101.10"
{
        Type  "SBb"
        RA           13.2306
        Dec          17.0758
        Distance   3.197e+08  # method: V
        Radius     4.185e+04
        AbsMag        -20.26
        Axis    [  0.0485  -0.4505  -0.8915]
        Angle     27.3699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 857"
}

Galaxy "IC 858:UGC 8321:MCG 3-34-7:ZWG 101.11"
{
        Type  "S0"
        RA           13.2475
        Dec          17.2272
        Distance   3.352e+08  # method: V
        Radius     6.826e+04
        AbsMag        -20.56
        Axis    [  0.2873  -0.5584  -0.7782]
        Angle     32.8615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 858"
}

Galaxy "IC 859:MCG 3-34-8:ZWG 101.12:ARAK 408"
{
        Type  "S0"
        RA           13.2492
        Dec          17.2258
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.4936  -0.7924  -0.3585]
        Angle    133.1245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 859"
}

Galaxy "IC 860:MCG 4-31-15:ZWG 130.23"
{
        Type  "S0"
        RA           13.2508
        Dec          24.6183
        Distance   1.872e+08  # method: V
        Radius     2.179e+04
        AbsMag        -18.39
        Axis    [  0.8236  -0.5619  -0.0775]
        Angle    107.5277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 860"
}

Galaxy "IC 861:UGC 8326:MCG 6-29-68:ZWG 189.46"
{
        Type  "Sa"
        RA           13.2519
        Dec          34.3283
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.7852  -0.6118   0.0955]
        Angle     39.8828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 861"
}

Galaxy "IC 862:ZWG 101.18:KARA 578"
{
        Type  "E0"
        RA           13.2708
        Dec          20.0475
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.4603  -0.8156  -0.3505]
        Angle    133.0958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 862"
}

Galaxy "IC 863:MCG 3-34-43:IRAS 13145-1659"
{
        Type  "SBa"
        RA           13.2867
        Dec         -17.2547
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.5860  -0.4532  -0.6717]
        Angle     90.1780
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 863"
}

Galaxy "IC 864"
{
        Type  "S0"
        RA           13.2856
        Dec          20.6925
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9004  -0.4351  -0.0034]
        Angle     98.8647
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 864"
}

Galaxy "IC 865:NPM 1"
{
        Type  "Sa"
        RA           13.2931
        Dec          -5.8333
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.7246  -0.4790  -0.4954]
        Angle     75.9608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 865"
}

Galaxy "IC 866:UGC 8354:MCG 4-31-19:ZWG 130.27"
{
        Type  "SBb"
        RA           13.2878
        Dec          20.6914
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.9241  -0.3684   0.1017]
        Angle     87.5704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 866"
}

Galaxy "IC 867:UGC 8353:MCG 4-31-20:ZWG 130.26"
{
        Type  "SBc"
        RA           13.2886
        Dec          20.6375
        Distance   3.238e+08  # method: V
        Radius     6.593e+04
        AbsMag        -19.78
        Axis    [  0.7691  -0.6082  -0.1966]
        Angle     91.2424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 867"
}

Galaxy "IC 868-1:MCG 4-31-21:ZWG 130.28"
{
        Type  "S0"
        RA           13.2911
        Dec          20.6122
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.4797  -0.8101  -0.3371]
        Angle    131.9962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 868-1"
}

Galaxy "IC 868-2:NPM 1"
{
        Type  "S0"
        RA           13.2917
        Dec          20.6208
        Distance   5.098e+08  # distance uncertain!
        Radius     2.225e+04
        AbsMag        -19.07
        Axis    [  0.3112  -0.6009   0.7363]
        Angle     18.1088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 868-2"
}

Galaxy "IC 870:MCG 4-31-22:ZWG 130.29"
{
        Type  "Sc"
        RA           13.2917
        Dec          20.5997
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.8241  -0.5557  -0.1099]
        Angle     74.6853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 870"
}

Galaxy "IC 871:UGC 8358:MCG 1-34-16:ZWG 44.58"
{
        Type  "Sb"
        RA           13.2994
        Dec           4.4042
        Distance   1.688e+08  # distance uncertain!
        Radius     4.174e+04
        AbsMag        -19.07
        Axis    [  0.7683  -0.5535  -0.3214]
        Angle     50.8804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 871"
}

Galaxy "IC 872:UGC 8361:ZWG 44.60:IRAS 13157+0635"
{
        Type  "Sb"
        RA           13.3050
        Dec           6.3361
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.9721  -0.1784   0.1523]
        Angle     36.9334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 872"
}

Galaxy "IC 873:ZWG 44.59:NPM 1"
{
        Type  "E0"
        RA           13.3044
        Dec           4.4650
        Distance   3.468e+08  # distance uncertain!
        Radius     2.017e+04
        AbsMag        -20.13
        Axis    [  0.4982  -0.7429  -0.4472]
        Angle    140.8574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 873"
}

Galaxy "IC 874:ESO 508-42:MCG 4-31-50"
{
        Type  "S0"
        RA           13.3167
        Dec         -27.6283
        Distance   1.179e+08  # method: V
        Radius     2.057e+04
        AbsMag        -19.29
        Axis    [  0.6715  -0.3989  -0.6245]
        Angle    123.5429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 874"
}

Galaxy "IC 875:UGC 8355:MCG 10-19-59:MK 249"
{
        Type  "S0"
        RA           13.2853
        Dec          57.5400
        Distance   1.327e+08  # method: V
        Radius     2.703e+04
        AbsMag        -19.25
        Axis    [ -0.3764   0.6998   0.6071]
        Angle     41.8037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 875"
}

Galaxy "IC 876:MCG 1-34-17:ZWG 44.61:IRAS 13160+0445"
{
        Type  "SBa"
        RA           13.3094
        Dec           4.4861
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6999  -0.6044  -0.3807]
        Angle    119.8252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 876"
}

Galaxy "IC 879:IC 4222:ESO 508-47:MCG 4-31-52"
{
        Type  "SBb"
        RA           13.3278
        Dec         -27.4292
        Distance   1.024e+08  # method: V
        Radius     2.085e+04
        AbsMag        -18.48
        Axis    [  0.3334  -0.4236  -0.8422]
        Angle     95.0762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 879"
}

Galaxy "IC 881:UGC 8375:MCG 3-34-16:ZWG 101.25"
{
        Type  "Sa"
        RA           13.3322
        Dec          15.8503
        Distance   3.277e+08  # method: V
        Radius     7.625e+04
        AbsMag        -20.31
        Axis    [  0.9487  -0.3160   0.0124]
        Angle    107.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 881"
}

Galaxy "IC 882:MCG 3-34-17:ZWG 101.27"
{
        Type  "S0"
        RA           13.3353
        Dec          15.8981
        Distance   3.251e+08  # method: V
        Radius     3.782e+04
        AbsMag        -20.09
        Axis    [  0.6666  -0.6351  -0.3903]
        Angle     64.8787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 882"
}

Galaxy "IC 883:UGC 8387:ZWG 189.54:ZW 56"
{
        Type  "Irr"
        RA           13.3431
        Dec          34.1386
        Distance   3.228e+08  # method: V
        Radius     6.573e+04
        AbsMag        -20.48
        Axis    [ -0.7401   0.3591   0.5686]
        Angle     25.1713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 883"
}

Galaxy "IC 885:MCG 4-32-8:ZWG 131.5"
{
        Type  "E0"
        RA           13.3753
        Dec          21.3167
        Distance   3.163e+08  # distance uncertain!
        Radius      3.68e+04
        AbsMag        -20.13
        Axis    [  0.4460  -0.8262  -0.3443]
        Angle    133.4841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 885"
}

Galaxy "IC 886:NPM 1"
{
        Type  "E0"
        RA           13.3992
        Dec          -4.3947
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.5073  -0.7018  -0.5001]
        Angle    145.9882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 886"
}

Galaxy "IC 889:ZWG 72.74"
{
        Type  "E0"
        RA           13.4436
        Dec          11.8700
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.4655  -0.7861  -0.4065]
        Angle    138.3981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 889"
}

Galaxy "IC 890"
{
        Type  "S0"
        RA           13.4736
        Dec         -16.0919
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.7676  -0.5746  -0.2840]
        Angle     41.8121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 890"
}

Galaxy "IC 891:MCG 0-34-40:ZWG 16.80:NPM 1"
{
        Type  "S0"
        RA           13.4997
        Dec           0.3058
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.5081  -0.7213  -0.4706]
        Angle    142.9273
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 891"
}

Galaxy "IC 892:UGC 8512:MCG 0-35-1:ZWG 17.5"
{
        Type  "S0"
        RA           13.5292
        Dec          -2.7125
        Distance   2.969e+08  # method: V
        Radius     6.476e+04
        AbsMag         -20.7
        Axis    [  0.7888  -0.4855  -0.3769]
        Angle    109.8111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 892"
}

Galaxy "IC 893:UGC 8513:MCG 0-35-2:ZWG 17.6"
{
        Type  "Sb"
        RA           13.5297
        Dec          -2.6114
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.8866  -0.4198  -0.1940]
        Angle     65.8632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 893"
}

Galaxy "IC 894:MCG 3-35-2:ZWG 102.6:KARA 591"
{
        Type  "Sc"
        RA           13.5344
        Dec          17.0494
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.7944  -0.5964   0.1153]
        Angle     43.8338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 894"
}

Galaxy "IC 896:UGC 8545:MCG 1-35-7:ZWG 45.27"
{
        Type  "E0"
        RA           13.5694
        Dec           4.8689
        Distance   3.163e+08  # distance uncertain!
        Radius      5.52e+04
        AbsMag        -20.13
        Axis    [  0.3461  -0.6898  -0.6360]
        Angle    117.1959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 896"
}

Galaxy "IC 897:ZWG 102.20"
{
        Type  "S0"
        RA           13.5719
        Dec          17.8481
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8744  -0.4823   0.0528]
        Angle     70.9383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 897"
}

Galaxy "IC 898:ZWG 73.32"
{
        Type  "S0"
        RA           13.5692
        Dec          13.2800
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.9611   0.2392  -0.1383]
        Angle     52.9429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 898"
}

Galaxy "IC 899:NPM 1"
{
        Type  "E0"
        RA           13.5831
        Dec          -8.0911
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.4948  -0.6910  -0.5269]
        Angle    149.0398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 899"
}

Galaxy "IC 900:UGC 8555:MCG 2-35-4:ZWG 73.37"
{
        Type  "Sc"
        RA           13.5783
        Dec           9.3369
        Distance    3.54e+08  # method: T-F
        Radius     8.239e+04
        AbsMag        -21.58
        Axis    [  0.7892  -0.5519  -0.2695]
        Angle     95.8282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 900"
}

Galaxy "IC 901:MCG 2-35-11:ZWG 73.45"
{
        Type  "Sb"
        RA           13.5950
        Dec          13.3303
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.2449  -0.5295  -0.8122]
        Angle     27.3642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 901"
}

Galaxy "IC 902:UGC 8593:MCG 8-25-24:ZWG 246.17"
{
        Type  "Sb"
        RA           13.6003
        Dec          49.9606
        Distance   1.768e+08  # distance uncertain!
        Radius     5.657e+04
        AbsMag        -19.07
        Axis    [ -0.5310   0.3337   0.7789]
        Angle     64.8015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 902"
}

Galaxy "IC 903:UGC 8625:MCG 0-35-13:ZWG 17.45"
{
        Type  "Sb"
        RA           13.6406
        Dec          -0.2275
        Distance   1.844e+08  # method: V
        Radius     5.096e+04
        AbsMag        -19.36
        Axis    [ -0.9961  -0.0610   0.0645]
        Angle     64.9934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 903"
}

Galaxy "IC 904:UGC 8628:MCG 0-35-14:ZWG 17.47"
{
        Type  "Sa"
        RA           13.6422
        Dec           0.5406
        Distance   3.188e+08  # method: V
        Radius     5.565e+04
        AbsMag        -20.15
        Axis    [ -0.7734  -0.4150  -0.4792]
        Angle     33.2986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 904"
}

Galaxy "IC 905:MCG 4-32-20:ZWG 131.19:NPM 1"
{
        Type  "E0"
        RA           13.6672
        Dec          23.1433
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.4116  -0.8467  -0.3371]
        Angle    135.4686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 905"
}

Galaxy "IC 906:MCG 4-32-21:ZWG 131.20"
{
        Type  "Sc"
        RA           13.6694
        Dec          23.3408
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [ -0.6947  -0.0564   0.7170]
        Angle     43.7412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 906"
}

Galaxy "IC 907:UGC 8643:MCG 9-22-90:ZWG 271.55"
{
        Type  "SBb"
        RA           13.6561
        Dec          51.0514
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [  0.8357  -0.4084   0.3672]
        Angle    115.0820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 907"
}

Galaxy "IC 908:MCG 1-35-9"
{
        Type  "SBa"
        RA           13.6886
        Dec          -4.3444
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.5805  -0.5891  -0.5621]
        Angle     71.3448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 908"
}

Galaxy "IC 909:UGC 8661:MCG 4-32-23:ZWG 131.22"
{
        Type  "SBa"
        RA           13.6808
        Dec          24.4731
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.4299  -0.8449  -0.3183]
        Angle    134.0873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 909"
}

Galaxy "IC 910:MCG 4-32-25:ZWG 131.24:WAS 79"
{
        Type  "S0"
        RA           13.6853
        Dec          23.2814
        Distance   3.798e+08  # method: V
        Radius     2.762e+04
        AbsMag        -20.13
        Axis    [  0.5115  -0.7446  -0.4288]
        Angle     48.3092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 910"
}

Galaxy "IC 911:UGC 8665:MCG 4-32-27:ZWG 131.26"
{
        Type  "S0"
        RA           13.6903
        Dec          23.2481
        Distance    2.03e+08  # distance uncertain!
        Radius     1.181e+04
        AbsMag        -19.07
        Axis    [  0.4326  -0.8401  -0.3272]
        Angle    134.6522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 911"
}

Galaxy "IC 912:UGC 8665:MCG 4-32-28:ZWG 131.26"
{
        Type  "S0"
        RA           13.6914
        Dec          23.2453
        Distance   1.612e+08  # distance uncertain!
        Radius     1.641e+04
        AbsMag        -19.07
        Axis    [  0.5195  -0.7826  -0.3430]
        Angle     36.2750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 912"
}

Galaxy "IC 913:UGC 8664:MCG 4-32-29:ZWG 131.25"
{
        Type  "SBb"
        RA           13.6914
        Dec          23.1669
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.5597  -0.7507  -0.3510]
        Angle     46.5640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 913"
}

Galaxy "IC 914:MCG 4-32-30:ZWG 131.27"
{
        Type  "Sc"
        RA           13.6944
        Dec          23.1900
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.6682  -0.7143  -0.2083]
        Angle    126.1328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 914"
}

Galaxy "IC 915:NPM 1:IRAS 13407-1704"
{
        Type  "E0"
        RA           13.7242
        Dec         -17.3322
        Distance   3.631e+08  # distance uncertain!
        Radius     2.641e+04
        AbsMag        -20.13
        Axis    [  0.4949  -0.6463  -0.5808]
        Angle    154.4482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 915"
}

Galaxy "IC 916:MCG 4-32-31:ZWG 131.28:NPM 1"
{
        Type  "E0"
        RA           13.7106
        Dec          24.4656
        Distance   4.169e+08  # distance uncertain!
        Radius     4.245e+04
        AbsMag        -20.13
        Axis    [  0.4033  -0.8540  -0.3286]
        Angle    135.3509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 916"
}

Galaxy "IC 919"
{
        Type  "E0"
        RA           13.7156
        Dec          55.6033
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.2906  -0.9525  -0.0914]
        Angle    124.5056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 919"
}

Galaxy "IC 920:MCG 2-35-15"
{
        Type  "E0"
        RA           13.7567
        Dec         -12.5742
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.4839  -0.6746  -0.5574]
        Angle    152.3041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 920"
}

Galaxy "IC 921"
{
        Type  "E0"
        RA           13.7189
        Dec          55.6506
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.2902  -0.9526  -0.0910]
        Angle    124.5338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 921"
}

Galaxy "IC 922"
{
        Type  "E0"
        RA           13.7206
        Dec          55.6028
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.2902  -0.9526  -0.0914]
        Angle    124.5686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 922"
}

Galaxy "IC 923"
{
        Type  "S0"
        RA           13.7211
        Dec          55.6153
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.4029  -0.1570   0.9017]
        Angle     46.7015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 923"
}

Galaxy "IC 924"
{
        Type  "S0"
        RA           13.7603
        Dec         -12.4553
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.2918  -0.6937  -0.6585]
        Angle     46.7407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 924"
}

Galaxy "IC 925"
{
        Type  "E0"
        RA           13.7219
        Dec          55.5978
        Distance   1.097e+09  # distance uncertain!
        Radius     1.595e+04
        AbsMag        -20.13
        Axis    [  0.2901  -0.9526  -0.0914]
        Angle    124.5875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 925"
}

Galaxy "IC 926"
{
        Type  "S0"
        RA           13.7275
        Dec          55.6311
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.5097  -0.2772   0.8145]
        Angle     43.1031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 926"
}

Galaxy "IC 927:NPM 1"
{
        Type  "Sa"
        RA           13.7644
        Dec         -12.4639
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.3205  -0.6448  -0.6940]
        Angle     53.2124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 927"
}

Galaxy "IC 928"
{
        Type  "E0"
        RA           13.7292
        Dec          55.6336
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.2894  -0.9528  -0.0911]
        Angle    124.6679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 928"
}

Galaxy "IC 929"
{
        Type  "E0"
        RA           13.7292
        Dec          55.6461
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2894  -0.9529  -0.0910]
        Angle    124.6642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 929"
}

Galaxy "IC 930"
{
        Type  "E0"
        RA           13.7311
        Dec          55.6561
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.2892  -0.9529  -0.0910]
        Angle    124.6858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 930"
}

Galaxy "IC 931"
{
        Type  "E0"
        RA           13.7303
        Dec          55.6233
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.2894  -0.9529  -0.0912]
        Angle    124.6848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 931"
}

Galaxy "IC 932"
{
        Type  "E0"
        RA           13.7308
        Dec          55.6464
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2893  -0.9529  -0.0910]
        Angle    124.6851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 932"
}

Galaxy "IC 933:UGC 8697:MCG 4-32-36:ZWG 131.35"
{
        Type  "S0"
        RA           13.7544
        Dec          23.2192
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.9265   0.2973  -0.2305]
        Angle     35.4783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 933"
}

Galaxy "IC 934:IC 936"
{
        Type  "S0"
        RA           13.7342
        Dec          55.6497
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.5942  -0.3813   0.7082]
        Angle     49.6122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 934"
}

Galaxy "IC 937"
{
        Type  "E0"
        RA           13.7414
        Dec          55.6294
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2885  -0.9531  -0.0912]
        Angle    124.8227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 937"
}

Galaxy "IC 938"
{
        Type  "S0"
        RA           13.7419
        Dec          55.6269
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.4783   0.5896   0.6509]
        Angle     48.4201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 938"
}

Galaxy "IC 939:MCG 1-35-36:ZWG 45.103:NPM 1"
{
        Type  "S0"
        RA           13.7953
        Dec           3.4119
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [  0.4708  -0.7521  -0.4612]
        Angle    143.7040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 939"
}

Galaxy "IC 940:ZWG 45.104"
{
        Type  "S0"
        RA           13.7992
        Dec           3.4503
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.5758  -0.8063  -0.1354]
        Angle     24.4693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 940"
}

Galaxy "IC 941:MCG 4-33-7:ZWG 132.16:NPM 1"
{
        Type  "S0"
        RA           13.8097
        Dec          24.0156
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.2992  -0.9265   0.2282]
        Angle     13.4775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 941"
}

Galaxy "IC 942:MCG 10-20-31:ZWG 295.13:NPM 1"
{
        Type  "S0"
        RA           13.7947
        Dec          56.6219
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6450  -0.7518   0.1366]
        Angle    126.5473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 942"
}

Galaxy "IC 943:MCG 1-35-41:ZWG 45.115"
{
        Type  "S0"
        RA           13.8422
        Dec           3.1942
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.4663  -0.7532  -0.4639]
        Angle    144.1540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 943"
}

Galaxy "IC 944:UGC 8766:MCG 2-35-19:ZWG 73.85"
{
        Type  "Sa"
        RA           13.8583
        Dec          14.0917
        Distance   3.287e+08  # method: V
        Radius     7.648e+04
        AbsMag        -20.52
        Axis    [  0.2586  -0.8502   0.4585]
        Angle     25.5406
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 944"
}

Galaxy "IC 945:UGC 8732:MCG 12-13-10:ZWG 336.18"
{
        Type  "Sb"
        RA           13.7853
        Dec          72.0700
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.3629   0.3539   0.8620]
        Angle     29.8985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 945"
}

Galaxy "IC 946:UGC 8772:MCG 2-35-21:ZWG 73.89"
{
        Type  "Sa"
        RA           13.8689
        Dec          14.1164
        Distance   3.219e+08  # method: V
        Radius     4.213e+04
        AbsMag        -20.47
        Axis    [ -0.1054  -0.5207  -0.8472]
        Angle     41.5746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 946"
}

Galaxy "IC 947:UGC 8784:MCG 0-35-23:ZWG 17.85"
{
        Type  "S0"
        RA           13.8764
        Dec           0.8181
        Distance   2.139e+08  # method: V
        Radius     5.289e+04
        AbsMag        -20.18
        Axis    [  0.5984  -0.6419  -0.4794]
        Angle     69.5699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 947"
}

Galaxy "IC 948:UGC 8779:MCG 2-35-23:ZWG 73.92"
{
        Type  "E0"
        RA           13.8739
        Dec          14.0911
        Distance    3.25e+08  # method: V
        Radius     6.145e+04
        AbsMag        -20.79
        Axis    [ -0.4856   0.2433  -0.8397]
        Angle     68.4244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 948"
}

Galaxy "IC 949:UGC 8777:MCG 4-33-15:ZWG 132.26"
{
        Type  "Irr"
        RA           13.8711
        Dec          22.5219
        Distance    3.89e+08  # method: V
        Radius     6.224e+04
        AbsMag        -20.08
        Axis    [ -0.7148  -0.2135   0.6660]
        Angle     29.3585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 949"
}

Galaxy "IC 950-1:UGC 8780:MCG 3-35-32:ZWG 102.73"
{
        Type  "S0"
        RA           13.8739
        Dec          14.4917
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.7472  -0.6296  -0.2128]
        Angle     79.2448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 950-1"
}

Galaxy "IC 950-2:UGC 8780:MCG 3-35-32:ZWG 102.73"
{
        Type  "S0"
        RA           13.8736
        Dec          14.4894
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.1042  -0.9934  -0.0480]
        Angle     21.7144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 950-2"
}

Galaxy "IC 951:UGC 8775:MCG 9-23-12:ZWG 272.11"
{
        Type  "SBc"
        RA           13.8631
        Dec          50.9778
        Distance   1.896e+08  # method: V
        Radius     3.309e+04
        AbsMag        -19.62
        Axis    [  0.3229  -0.9392  -0.1167]
        Angle    127.3275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 951"
}

Galaxy "IC 952:UGC 8808:MCG 1-35-49:ZWG 45.133"
{
        Type  "SBc"
        RA           13.8947
        Dec           3.3775
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [  0.5330  -0.8459  -0.0209]
        Angle     34.1214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 952"
}

Galaxy "IC 954:UGC 8765:MCG 12-13-18:ZWG 336.24"
{
        Type  "Irr"
        RA           13.8322
        Dec          71.1647
        Distance    4.68e+08  # method: V
        Radius     7.488e+04
        AbsMag        -21.28
        Axis    [  0.5349  -0.2790   0.7976]
        Angle     59.0855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 954"
}

Galaxy "IC 956-1:ZWG 132.42"
{
        Type  "E0"
        RA           13.9111
        Dec          20.7197
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.3943  -0.8464  -0.3579]
        Angle    138.7813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 956-1"
}

Galaxy "IC 956-2:ZWG 132.42"
{
        Type  "S0"
        RA           13.9111
        Dec          20.7164
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.4628  -0.7930  -0.3962]
        Angle     44.7232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 956-2"
}

Galaxy "IC 959:UGC 8848:MCG 2-36-1:ZWG 74.7"
{
        Type  "Sa"
        RA           13.9342
        Dec          13.5064
        Distance    3.23e+08  # method: V
        Radius     7.985e+04
        AbsMag        -20.88
        Axis    [  0.8093  -0.5518  -0.2011]
        Angle    120.6024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 959"
}

Galaxy "IC 960-1:UGC 8849:MCG 3-36-3:ZWG 103.13"
{
        Type  "Sb"
        RA           13.9331
        Dec          17.4994
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.8176  -0.5623  -0.1240]
        Angle     99.2167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 960-1"
}

Galaxy "IC 960-2:UGC 8849:MCG 3-36-4:ZWG 103.13"
{
        Type  "Sa"
        RA           13.9333
        Dec          17.5117
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.9099  -0.4099   0.0639]
        Angle     92.7215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 960-2"
}

Galaxy "IC 961:MCG 4-33-31:MK 664:ZWG 132.52"
{
        Type  "Sb"
        RA           13.9294
        Dec          25.8400
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.4018  -0.8607  -0.3127]
        Angle    136.0306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 961"
}

Galaxy "IC 962:UGC 8868:MCG 2-36-3:ZWG 74.15"
{
        Type  "S0"
        RA           13.9536
        Dec          12.0214
        Distance   2.923e+08  # method: V
        Radius     3.401e+04
        AbsMag        -20.66
        Axis    [  0.4354  -0.8015  -0.4099]
        Angle    141.4388
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 962"
}

Galaxy "IC 963:MCG 3-36-9:ZWG 103.23:KUG 1355+176"
{
        Type  "S0"
        RA           13.9569
        Dec          17.4083
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.9615   0.2617  -0.0839]
        Angle     50.0099
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 963"
}

Galaxy "IC 964:MCG 3-36-10:ZWG 103.24:ARAK 433"
{
        Type  "E0"
        RA           13.9614
        Dec          17.5092
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.3980  -0.8346  -0.3808]
        Angle    140.5242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 964"
}

Galaxy "IC 965:MCG 3-36-11:ZWG 103.26:NPM 1"
{
        Type  "S0"
        RA           13.9631
        Dec          17.5111
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.6010  -0.7236  -0.3394]
        Angle     79.2009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 965"
}

Galaxy "IC 966:UGC 8884:MCG 1-36-6:ZWG 46.21"
{
        Type  "S0"
        RA           13.9706
        Dec           5.4075
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [ -0.8587   0.1371  -0.4938]
        Angle     56.2609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 966"
}

Galaxy "IC 967:MCG 3-36-15:ZWG 103.31:KUG 1355+147"
{
        Type  "S0"
        RA           13.9728
        Dec          14.4575
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.8195  -0.5503  -0.1597]
        Angle    102.1319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 967"
}

Galaxy "IC 968-1:MCG 0-36-7:ZWG 18.19:NPM 1"
{
        Type  "S0"
        RA           14.0100
        Dec          -2.9086
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.5952  -0.6336  -0.4942]
        Angle     73.2759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 968-1"
}

Galaxy "IC 968-2:MCG 0-36-7:ZWG 18.19:NPM 1"
{
        Type  "S0"
        RA           14.0103
        Dec          -2.9058
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.7991  -0.4854  -0.3548]
        Angle    119.4078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 968-2"
}

Galaxy "IC 969:NPM 1"
{
        Type  "S0"
        RA           14.0294
        Dec          -4.1797
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [ -0.9881  -0.0207  -0.1527]
        Angle     65.3670
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 969"
}

Galaxy "IC 970:UGC 8949:MCG 3-36-28:ZWG 103.49"
{
        Type  "SBa"
        RA           14.0428
        Dec          14.5525
        Distance   1.906e+08  # method: V
        Radius     2.773e+04
        AbsMag        -19.03
        Axis    [  0.8346  -0.5500   0.0311]
        Angle     70.8918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 970"
}

Galaxy "IC 971:MCG 2-36-5:IRAS 14012-0954"
{
        Type  "SBc"
        RA           14.0644
        Dec         -10.1397
        Distance   1.624e+08  # method: V
        Radius     5.434e+04
        AbsMag        -19.99
        Axis    [ -0.5461  -0.6505  -0.5278]
        Angle     41.6339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 971"
}

Galaxy "IC 975:MCG 3-36-48:ZWG 103.72:NPM 1"
{
        Type  "E0"
        RA           14.1189
        Dec          15.3186
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.3747  -0.8263  -0.4205]
        Angle    138.6801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 975"
}

Galaxy "IC 976:UGC 9040:MCG 0-36-20:ZWG 18.59"
{
        Type  "Sa"
        RA           14.1453
        Dec          -1.1622
        Distance     8.1e+07  # method: V
        Radius     1.767e+04
        AbsMag        -17.97
        Axis    [ -0.9856  -0.1339   0.1033]
        Angle     63.3779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 976"
}

Galaxy "IC 977:ZWG 18.58:KCPG 417A"
{
        Type  "Sb"
        RA           14.1450
        Dec          -3.0025
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.5572  -0.3488  -0.7535]
        Angle     52.0199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 977"
}

Galaxy "IC 978:MCG 0-36-21:ZWG 18.60:NPM 1"
{
        Type  "Sc"
        RA           14.1494
        Dec          -2.9736
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.7959  -0.5109  -0.3249]
        Angle     89.6657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 978"
}

Galaxy "IC 979:UGC 9053:MCG 3-36-61:ZWG 103.90"
{
        Type  "SBb"
        RA           14.1589
        Dec          14.8317
        Distance   3.614e+08  # method: V
        Radius     5.256e+04
        AbsMag        -20.72
        Axis    [ -0.9808   0.1923  -0.0328]
        Angle     52.2109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 979"
}

Galaxy "IC 980:NPM 1"
{
        Type  "E0"
        RA           14.1728
        Dec          -7.3419
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.4298  -0.7216  -0.5428]
        Angle    152.5452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 980"
}

Galaxy "IC 981"
{
        Type  "S0"
        RA           14.1744
        Dec          -4.1719
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [  0.6077  -0.7006  -0.3739]
        Angle     57.4344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 981"
}

Galaxy "IC 982:UGC 9059:MCG 3-36-66:ZWG 103.96"
{
        Type  "S0"
        RA           14.1664
        Dec          17.6967
        Distance   2.397e+08  # method: V
        Radius     3.486e+04
        AbsMag        -20.03
        Axis    [  0.4002  -0.8360  -0.3753]
        Angle    141.2136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 982"
}

Galaxy "IC 983:UGC 9061:MCG 3-36-68:ZWG 103.98"
{
        Type  "SBb"
        RA           14.1678
        Dec          17.7344
        Distance   2.574e+08  # method: V
        Radius      1.46e+05
        AbsMag        -21.98
        Axis    [ -0.6003  -0.7473  -0.2849]
        Angle     21.3579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 983"
}

Galaxy "IC 984:UGC 9062:MCG 3-36-70:ZWG 103.99"
{
        Type  "Sb"
        RA           14.1686
        Dec          18.3642
        Distance   2.422e+08  # method: V
        Radius     6.694e+04
        AbsMag        -19.95
        Axis    [  0.8703  -0.4908   0.0406]
        Angle     89.6864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 984"
}

Galaxy "IC 985:MCG 0-36-24:ZWG 18.72"
{
        Type  "Sb"
        RA           14.1925
        Dec          -3.2197
        Distance   1.851e+08  # distance uncertain!
        Radius     1.346e+04
        AbsMag        -19.07
        Axis    [  0.6047  -0.6451  -0.4672]
        Angle     76.0819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 985"
}

Galaxy "IC 986:MCG 0-36-25:ZWG 18.73:NPM 1"
{
        Type  "E0"
        RA           14.1906
        Dec           1.2869
        Distance   3.468e+08  # distance uncertain!
        Radius     3.026e+04
        AbsMag        -20.13
        Axis    [  0.4118  -0.7674  -0.4915]
        Angle    149.0398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 986"
}

Galaxy "IC 987:MCG 3-36-78:ZWG 103.112:KUG 1409+194"
{
        Type  "S0"
        RA           14.1919
        Dec          19.1719
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.5821  -0.8093   0.0784]
        Angle     42.2996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 987"
}

Galaxy "IC 988:MCG 1-36-26:ZWG 46.71:NPM 1"
{
        Type  "S0"
        RA           14.2422
        Dec           3.1908
        Distance   3.771e+08  # method: V
        Radius     2.742e+04
        AbsMag        -20.21
        Axis    [  0.4785  -0.7019  -0.5277]
        Angle     82.8739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 988"
}

Galaxy "IC 989:UGC 9114:MCG 1-36-27:ZWG 46.72"
{
        Type  "E0"
        RA           14.2475
        Dec           3.1311
        Distance   3.538e+08  # method: V
        Radius      6.69e+04
        AbsMag        -21.18
        Axis    [  0.1122  -0.6368  -0.7628]
        Angle    103.1166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 989"
}

Galaxy "IC 990:MCG 7-29-56:ZWG 219.63:NPM 1"
{
        Type  "S0"
        RA           14.2636
        Dec          39.7983
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6604  -0.7483   0.0625]
        Angle     79.0749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 990"
}

Galaxy "IC 991:MCG 2-36-19:IRAS 14151-1338"
{
        Type  "Sc"
        RA           14.2967
        Dec         -13.8731
        Distance   2.218e+08  # method: V
        Radius     4.839e+04
        AbsMag        -20.36
        Axis    [ -0.2106  -0.7368  -0.6424]
        Angle     48.6693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 991"
}

Galaxy "IC 992:UGC 9147:MCG 0-36-33:ZWG 18.114"
{
        Type  "Sc"
        RA           14.3039
        Dec           0.8906
        Distance   3.643e+08  # method: V
        Radius     6.887e+04
        AbsMag        -20.64
        Axis    [ -0.6569  -0.6512  -0.3800]
        Angle     35.6486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 992"
}

Galaxy "IC 993:MCG 2-36-63:ZWG 74.160:ZWG 75.1"
{
        Type  "S0"
        RA           14.3050
        Dec          11.2164
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [ -0.9978  -0.0417  -0.0523]
        Angle     43.9930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 993"
}

Galaxy "IC 994:UGC 9153:MCG 2-36-64:ZWG 74.161"
{
        Type  "Sa"
        RA           14.3061
        Dec          11.1953
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [  0.8498  -0.5011  -0.1636]
        Angle    110.1719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 994"
}

Galaxy "IC 995:UGC 9145:MCG 10-20-91:ZWG 295.42"
{
        Type  "SBc"
        RA           14.2753
        Dec          57.8100
        Distance   1.466e+08  # method: V
        Radius     3.411e+04
        AbsMag        -18.66
        Axis    [ -0.2019   0.2159   0.9553]
        Angle     59.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 995"
}

Galaxy "IC 996:UGC 9152:MCG 10-20-92:ZWG 295.43"
{
        Type  "Sc"
        RA           14.2892
        Dec          57.6300
        Distance   1.432e+08  # method: V
        Radius     2.917e+04
        AbsMag        -18.41
        Axis    [ -0.2965   0.2456   0.9229]
        Angle     67.1512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 996"
}

Galaxy "IC 997-1:MCG 1-37-1:IRAS 14173-0413"
{
        Type  "S0"
        RA           14.3331
        Dec          -4.4522
        Distance   1.341e+08  # distance uncertain!
        Radius     2.731e+04
        AbsMag        -19.07
        Axis    [  0.7684  -0.5201  -0.3728]
        Angle    101.5769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 997-1"
}

Galaxy "IC 997-2:MCG 1-37-1"
{
        Type  "S0"
        RA           14.3333
        Dec          -4.4528
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.4281  -0.7351  -0.5257]
        Angle    150.8562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 997-2"
}

Galaxy "IC 998"
{
        Type  "S0"
        RA           14.3386
        Dec          -4.4161
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.8093  -0.5780  -0.1044]
        Angle     62.1974
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 998"
}

Galaxy "IC 999:UGC 9168:MCG 3-37-1:ZWG 104.3"
{
        Type  "S0"
        RA           14.3256
        Dec          17.8758
        Distance   2.703e+08  # method: V
        Radius     3.145e+04
        AbsMag        -20.19
        Axis    [ -0.8442  -0.3939   0.3636]
        Angle     29.3513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 999"
}

Galaxy "IC 1000:UGC 9170:MCG 3-37-3:ZWG 104.4"
{
        Type  "S0"
        RA           14.3278
        Dec          17.8550
        Distance   2.652e+08  # method: V
        Radius     3.472e+04
        AbsMag        -20.25
        Axis    [  0.7590  -0.6294  -0.1665]
        Angle    103.7147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1000"
}

Galaxy "IC 1001:ZWG 47.14"
{
        Type  "S0"
        RA           14.3442
        Dec           5.4278
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.3921  -0.9033  -0.1740]
        Angle     40.7263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1001"
}

Galaxy "IC 1002:ZWG 47.15"
{
        Type  "S0"
        RA           14.3450
        Dec           5.4858
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.4342  -0.8876  -0.1539]
        Angle     41.9367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1002"
}

Galaxy "IC 1003:UGC 9190:ZWG 47.24:MK 1381"
{
        Type  "E0"
        RA           14.3581
        Dec           5.0731
        Distance   3.791e+08  # method: V
        Radius     7.168e+04
        AbsMag        -20.03
        Axis    [  0.2264  -0.7292  -0.6457]
        Angle    118.2034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1003"
}

Galaxy "IC 1004-1"
{
        Type  "E0"
        RA           14.3469
        Dec          17.6628
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.3589  -0.8497  -0.3863]
        Angle    144.0528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1004-1"
}

Galaxy "IC 1004-2"
{
        Type  "E0"
        RA           14.3469
        Dec          17.6650
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.2173  -0.7817  -0.5846]
        Angle    107.0616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1004-2"
}

Galaxy "IC 1006:MCG 4-34-23:ZWG 133.45:NPM 1"
{
        Type  "S0"
        RA           14.3831
        Dec          23.7947
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.4774  -0.8785  -0.0186]
        Angle     41.8791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1006"
}

Galaxy "IC 1007:ZWG 47.34:ZW 412"
{
        Type  "E0"
        RA           14.4100
        Dec           4.5594
        Distance   3.468e+08  # distance uncertain!
        Radius     2.017e+04
        AbsMag        -20.13
        Axis    [  0.3819  -0.7922  -0.4760]
        Angle    149.4630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1007"
}

Galaxy "IC 1008A:IC 4414A:MCG 5-34-27:ZWG 163.35"
{
        Type  "Irr"
        RA           14.3950
        Dec          28.3472
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.6713  -0.7251  -0.1538]
        Angle    130.1358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1008A"
}

Galaxy "IC 1008B:IC 4414B"
{
        Type  "E0"
        RA           14.3950
        Dec          28.3464
        Distance    6.31e+08  # distance uncertain!
        Radius     1.836e+04
        AbsMag        -20.13
        Axis    [  0.3262  -0.8932  -0.3094]
        Angle    140.8674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1008B"
}

Galaxy "IC 1009:ZWG 75-30"
{
        Type  "S0"
        RA           14.4381
        Dec          12.3533
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6252  -0.7443  -0.2347]
        Angle     69.5410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1009"
}

Galaxy "IC 1010:UGC 9254:MCG 0-37-6:ZWG 19.28"
{
        Type  "SBb"
        RA           14.4556
        Dec           1.0258
        Distance   3.596e+08  # method: V
        Radius     9.937e+04
        AbsMag        -21.01
        Axis    [  0.1046  -0.6641  -0.7403]
        Angle     79.0869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1010"
}

Galaxy "IC 1011:MCG 0-37-8:ZWG 19.36:ARAK 451"
{
        Type  "E0"
        RA           14.4678
        Dec           1.0069
        Distance   3.507e+08  # method: V
        Radius      2.04e+04
        AbsMag        -20.76
        Axis    [ -0.2916  -0.3417  -0.8934]
        Angle     80.9572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1011"
}

Galaxy "IC 1012:IC 4431:UGC 9257:MCG 5-34-43"
{
        Type  "Sc"
        RA           14.4525
        Dec          30.9483
        Distance   1.943e+08  # method: V
        Radius      3.39e+04
        AbsMag        -19.27
        Axis    [  0.3043  -0.9452   0.1183]
        Angle     29.6184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1012"
}

Galaxy "IC 1013:MCG 4-34-30:ZWG 133.60"
{
        Type  "S0"
        RA           14.4639
        Dec          25.8386
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.5459  -0.7835   0.2968]
        Angle     44.9800
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1013"
}

Galaxy "IC 1014:UGC 9275:MCG 2-37-12:ZWG 75.45"
{
        Type  "Irr"
        RA           14.4717
        Dec          13.7806
        Distance   6.863e+07  # method: V
        Radius     2.695e+04
        AbsMag        -18.01
        Axis    [  0.2598  -0.8616  -0.4360]
        Angle     48.0028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1014"
}

Galaxy "IC 1015:MCG 3-37-18:ZWG 104.31:ZW 90"
{
        Type  "S0"
        RA           14.4719
        Dec          15.4203
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.7236  -0.6596  -0.2034]
        Angle     98.0868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1015"
}

Galaxy "IC 1016:IC 4424:NGC 5619B:MCG 1-37-14"
{
        Type  "S0"
        RA           14.4589
        Dec           4.8214
        Distance   3.742e+08  # method: V
        Radius     4.899e+04
        AbsMag         -20.7
        Axis    [  0.0083  -0.9844   0.1759]
        Angle     32.9909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1016"
}

Galaxy "IC 1017:UGC 9276:MCG 4-34-32:ZWG 133.62"
{
        Type  "S0"
        RA           14.4686
        Dec          25.8683
        Distance   2.071e+08  # method: V
        Radius     3.012e+04
        AbsMag        -19.21
        Axis    [ -0.3758  -0.6803   0.6293]
        Angle     24.4220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1017"
}

Galaxy "IC 1018:ZWG 133.63"
{
        Type  "E0"
        RA           14.4700
        Dec          25.8300
        Distance   4.787e+08  # distance uncertain!
        Radius     4.873e+04
        AbsMag        -20.13
        Axis    [  0.0031  -0.6480  -0.7617]
        Angle     70.2958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1018"
}

Galaxy "IC 1019:MCG 4-34-33:ZWG 133.64"
{
        Type  "S0"
        RA           14.4703
        Dec          25.9472
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [ -0.9469  -0.3074  -0.0946]
        Angle     21.6701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1019"
}

Galaxy "IC 1020:UGC 9289:MCG 4-34-35:ZWG 133.68"
{
        Type  "S0"
        RA           14.4803
        Dec          26.0328
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [ -0.7801   0.0297   0.6249]
        Angle     64.7601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1020"
}

Galaxy "IC 1021:UGC 9296:MCG 4-34-38:ZWG 133.71"
{
        Type  "SBa"
        RA           14.4881
        Dec          20.6550
        Distance   4.113e+08  # method: V
        Radius      6.58e+04
        AbsMag         -20.2
        Axis    [ -0.5820  -0.7681  -0.2671]
        Angle     23.2175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1021"
}

Galaxy "IC 1022:UGC 9311:ZWG 47.66"
{
        Type  "Sb"
        RA           14.5003
        Dec           3.7728
        Distance   8.834e+07  # method: V
        Radius     1.413e+04
        AbsMag        -16.96
        Axis    [ -0.8900  -0.3271   0.3177]
        Angle     52.5993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1022"
}

Galaxy "IC 1024:UGC 9341:MCG 1-37-22:ZWG 47.76"
{
        Type  "S0"
        RA           14.5242
        Dec           3.0078
        Distance   7.647e+07  # method: V
        Radius     1.779e+04
        AbsMag        -17.95
        Axis    [  0.8152  -0.5256  -0.2434]
        Angle     99.4532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1024"
}

Galaxy "IC 1025:ZWG 47.78"
{
        Type  "S0"
        RA           14.5244
        Dec           7.0631
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.6522  -0.7367  -0.1787]
        Angle     31.9772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1025"
}

Galaxy "IC 1027:UGC 9331:MCG 9-24-9:ZWG 273.8"
{
        Type  "S0"
        RA           14.4967
        Dec          53.9656
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [ -0.4971   0.8637   0.0827]
        Angle     36.8841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1027"
}

Galaxy "IC 1028:UGC 9368:MCG 7-30-25:ZWG 220.28"
{
        Type  "Sc"
        RA           14.5544
        Dec          41.6508
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.7226  -0.6893   0.0525]
        Angle    118.0340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1028"
}

Galaxy "IC 1029:UGC 9361:MCG 8-26-42:ZWG 248.2"
{
        Type  "Sb"
        RA           14.5408
        Dec          49.9044
        Distance   1.443e+08  # method: T-F
        Radius     5.456e+04
        AbsMag        -19.53
        Axis    [ -0.2943   0.1021   0.9502]
        Angle     62.6154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1029"
}

Galaxy "IC 1031:ZWG 248.5:NPM 1"
{
        Type  "S0"
        RA           14.5731
        Dec          48.0381
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [  0.6304  -0.7635   0.1402]
        Angle     90.0951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1031"
}

Galaxy "IC 1032:ZWG 248.6:ZW 91:NPM 1"
{
        Type  "E0"
        RA           14.5775
        Dec          47.9686
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.1355  -0.8028  -0.5807]
        Angle     55.1009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1032"
}

Galaxy "IC 1033:ZWG 248.7"
{
        Type  "E0"
        RA           14.5781
        Dec          47.9378
        Distance   3.802e+08  # distance uncertain!
        Radius     6.083e+04
        AbsMag        -20.13
        Axis    [  0.2516  -0.9551  -0.1566]
        Angle    137.2768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1033"
}

Galaxy "IC 1034:ZWG 104.49:NPM 1:IRAS 14348+1452"
{
        Type  "S0"
        RA           14.6203
        Dec          14.6658
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.7622  -0.6108  -0.2145]
        Angle    118.8532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1034"
}

Galaxy "IC 1035:MCG 2-37-28:ZWG 75.97"
{
        Type  "S0"
        RA           14.6361
        Dec           9.3367
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.3709  -0.8162  -0.4431]
        Angle    148.2704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1035"
}

Galaxy "IC 1036:ZWG 104.56"
{
        Type  "S0"
        RA           14.6394
        Dec          18.1114
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.7537  -0.6555  -0.0473]
        Angle     84.1421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1036"
}

Galaxy "IC 1037:MCG 3-37-28:ZWG 104.57:NPM 1"
{
        Type  "S0"
        RA           14.6403
        Dec          18.1844
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.0600  -0.9939  -0.0929]
        Angle     32.4210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1037"
}

Galaxy "IC 1038:ZWG 75.104:NPM 1"
{
        Type  "S0"
        RA           14.6575
        Dec          11.9289
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.6610  -0.6826  -0.3118]
        Angle    127.1068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1038"
}

Galaxy "IC 1039:ZWG 47.133:NPM 1"
{
        Type  "S0"
        RA           14.6747
        Dec           3.4333
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.6745  -0.6736  -0.3021]
        Angle     83.7448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1039"
}

Galaxy "IC 1040:ZWG 75.106:KUG 1437+096"
{
        Type  "S0"
        RA           14.6728
        Dec           9.4775
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.3668  -0.8181  -0.4428]
        Angle    148.5400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1040"
}

Galaxy "IC 1041:MCG 1-37-45:ZWG 47.134"
{
        Type  "Sb"
        RA           14.6769
        Dec           3.3772
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.9819  -0.1375   0.1302]
        Angle     58.1077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1041"
}

Galaxy "IC 1042:UGC 9457:MCG 1-37-46:ZWG 47.135"
{
        Type  "S0"
        RA           14.6772
        Dec           3.4697
        Distance   3.693e+08  # method: V
        Radius     5.909e+04
        AbsMag        -20.67
        Axis    [  0.3776  -0.7895  -0.4839]
        Angle    150.5578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1042"
}

Galaxy "IC 1043:NPM 1"
{
        Type  "S0"
        RA           14.6786
        Dec           3.3747
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.7649  -0.5672  -0.3052]
        Angle    111.2698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1043"
}

Galaxy "IC 1044:MCG 2-37-29:ZWG 75.111"
{
        Type  "S0"
        RA           14.6911
        Dec           9.4317
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.7321  -0.6143  -0.2944]
        Angle    129.1374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1044"
}

Galaxy "IC 1046:MCG 12-14-11:ZWG 337.17"
{
        Type  "Sc"
        RA           14.6314
        Dec          69.0144
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.5466  -0.4337   0.7164]
        Angle     69.4785
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1046"
}

Galaxy "IC 1047:MCG 3-37-38:ZWG 105.4:ZWG 104.71"
{
        Type  "Sb"
        RA           14.7053
        Dec          19.1919
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.5845  -0.7597  -0.2848]
        Angle    135.2891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1047"
}

Galaxy "IC 1048:UGC 9483:MCG 1-37-51:ZWG 48.4"
{
        Type  "S0"
        RA           14.7158
        Dec           4.8908
        Distance   1.023e+08  # method: T-F
        Radius     3.273e+04
        AbsMag        -18.68
        Axis    [ -0.8409  -0.3435   0.4182]
        Angle     56.4336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1048"
}

Galaxy "IC 1049:UGC 9461:MCG 10-21-21:ZWG 296.16"
{
        Type  "SBa"
        RA           14.6592
        Dec          62.0031
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.5500  -0.7825   0.2919]
        Angle     73.8563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1049"
}

Galaxy "IC 1050:MCG 3-38-2:ZWG 105.11:NPM 1"
{
        Type  "Sb"
        RA           14.7353
        Dec          18.0133
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6911  -0.7001  -0.1797]
        Angle     97.6470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1050"
}

Galaxy "IC 1051:ZWG 105.12:NPM 1"
{
        Type  "E0"
        RA           14.7364
        Dec          19.0206
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.1064  -0.7730  -0.6254]
        Angle     97.3675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1051"
}

Galaxy "IC 1052:UGC 9494:MCG 4-35-7:ZWG 134.25"
{
        Type  "SBc"
        RA           14.7372
        Dec          20.6147
        Distance   4.234e+08  # method: V
        Radius     6.774e+04
        AbsMag        -20.27
        Axis    [  0.8300  -0.5577   0.0082]
        Angle     99.2268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1052"
}

Galaxy "IC 1053:MCG 3-38-8:ZWG 105.20"
{
        Type  "S0"
        RA           14.7619
        Dec          16.9469
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.6670  -0.7158  -0.2067]
        Angle     96.2865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1053"
}

Galaxy "IC 1054:UGC 9514:ZWG 20.14:NPM 1"
{
        Type  "S0"
        RA           14.7753
        Dec           1.2753
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.7109  -0.6007  -0.3657]
        Angle    116.0327
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1054"
}

Galaxy "IC 1055:MCG 2-38-11:IRAS 14446-1330"
{
        Type  "Sb"
        RA           14.7903
        Dec         -13.7161
        Distance    1.42e+08  # method: V
        Radius      4.13e+04
        AbsMag        -19.59
        Axis    [  0.8209  -0.3972  -0.4103]
        Angle    114.8272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1055"
}

Galaxy "IC 1056:IC 1057:UGC 9516:MCG 8-27-23"
{
        Type  "Sb"
        RA           14.7633
        Dec          50.3933
        Distance   1.869e+08  # method: V
        Radius     4.892e+04
        AbsMag        -19.69
        Axis    [  0.5938  -0.8003   0.0827]
        Angle    107.8542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1056"
}

Galaxy "IC 1058:UGC 9538:MCG 3-38-29:ZWG 105.35"
{
        Type  "Sc"
        RA           14.8200
        Dec          17.0214
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.0333  -0.8504   0.5251]
        Angle     37.2614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1058"
}

Galaxy "IC 1059:ZWG 20.24:NPM 1"
{
        Type  "E0"
        RA           14.8450
        Dec          -0.8753
        Distance   3.468e+08  # distance uncertain!
        Radius     4.035e+04
        AbsMag        -20.13
        Axis    [  0.3455  -0.7806  -0.5209]
        Angle    154.8561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1059"
}

Galaxy "IC 1060:MCG 1-38-4:NPM 1:IRAS 14491-0701"
{
        Type  "Sa"
        RA           14.8631
        Dec          -7.2319
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [  0.1393  -0.8665  -0.4793]
        Angle     54.9950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1060"
}

Galaxy "IC 1061"
{
        Type  "E0"
        RA           14.8539
        Dec          18.7575
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.3058  -0.8704  -0.3858]
        Angle    148.5232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1061"
}

Galaxy "IC 1062:MCG 3-38-41:ZWG 105.47:NPM 1"
{
        Type  "S0"
        RA           14.8547
        Dec          18.6875
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.1398  -0.9783  -0.1529]
        Angle     39.3916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1062"
}

Galaxy "IC 1063:IC 1064:UGC 9565:MCG 1-38-7"
{
        Type  "SBb"
        RA           14.8694
        Dec           4.6814
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.9565  -0.2591   0.1338]
        Angle     51.2315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1063"
}

Galaxy "IC 1065:UGC 9553:MCG 11-18-8:ZWG 318.4"
{
        Type  "S0"
        RA           14.8225
        Dec          63.2708
        Distance   5.657e+08  # method: V
        Radius     8.228e+04
        AbsMag         -21.7
        Axis    [  0.0871   0.2552   0.9630]
        Angle     21.9258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1065"
}

Galaxy "IC 1066:UGC 9573:MCG 1-38-9:ZWG 48.49"
{
        Type  "Sc"
        RA           14.8839
        Dec           3.2961
        Distance   8.095e+07  # method: V
        Radius     1.413e+04
        AbsMag        -17.77
        Axis    [  0.4448  -0.8225  -0.3543]
        Angle     66.1101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1066"
}

Galaxy "IC 1067:UGC 9574:MCG 1-38-10:ZWG 48.50"
{
        Type  "SBb"
        RA           14.8847
        Dec           3.3317
        Distance   8.077e+07  # method: V
        Radius      2.35e+04
        AbsMag        -18.67
        Axis    [ -0.4825  -0.6837  -0.5474]
        Angle     44.8313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1067"
}

Galaxy "IC 1068:MCG 1-38-12:ZWG 48.56:NPM 1"
{
        Type  "S0"
        RA           14.8922
        Dec           3.0778
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.6157  -0.7739  -0.1482]
        Angle     38.4542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1068"
}

Galaxy "IC 1069:UGC 9563:MCG 9-24-44:ZWG 273.29"
{
        Type  "S0"
        RA           14.8461
        Dec          54.4117
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [  0.6239  -0.7462   0.2322]
        Angle     95.9743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1069"
}

Galaxy "IC 1070:ZWG 48.59:NPM 1"
{
        Type  "S0"
        RA           14.8975
        Dec           3.4853
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.5682  -0.8215   0.0467]
        Angle     37.8566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1070"
}

Galaxy "IC 1071:UGC 9582:MCG 1-38-15:ZWG 48.62"
{
        Type  "S0"
        RA           14.9033
        Dec           4.7506
        Distance   3.854e+08  # method: V
        Radius     5.606e+04
        AbsMag        -21.16
        Axis    [ -0.9083  -0.2885  -0.3029]
        Angle     46.1357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1071"
}

Galaxy "IC 1072:MCG 1-38-16:ZWG 48.64:NPM 1"
{
        Type  "E0"
        RA           14.9036
        Dec           4.8422
        Distance   3.312e+08  # distance uncertain!
        Radius     2.408e+04
        AbsMag        -20.13
        Axis    [ -0.7083   0.1554  -0.6886]
        Angle     70.4585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1072"
}

Galaxy "IC 1073:ZWG 48.63"
{
        Type  "E0"
        RA           14.9039
        Dec           4.7944
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [ -0.7085   0.1551  -0.6884]
        Angle     70.4999
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1073"
}

Galaxy "IC 1074:UGC 9572:MCG 9-24-47:ZWG 273.30"
{
        Type  "Sc"
        RA           14.8658
        Dec          51.2650
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.2516  -0.3227   0.9125]
        Angle     50.7439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1074"
}

Galaxy "IC 1075:UGC 9593:MCG 3-38-53:ZWG 105.69"
{
        Type  "SBb"
        RA           14.9136
        Dec          18.1058
        Distance   2.852e+08  # method: V
        Radius     4.977e+04
        AbsMag        -19.91
        Axis    [ -0.9122  -0.2303   0.3388]
        Angle     39.7741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1075"
}

Galaxy "IC 1076:UGC 9595:MCG 3-38-55:MK 479"
{
        Type  "Sc"
        RA           14.9164
        Dec          18.0375
        Distance   2.834e+08  # method: V
        Radius     4.122e+04
        AbsMag        -20.49
        Axis    [  0.7620  -0.6195  -0.1885]
        Angle    124.7881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1076"
}

Galaxy "IC 1077:ESO 581-2:MCG 3-38-30:IRAS 14545-1900"
{
        Type  "SBc"
        RA           14.9558
        Dec         -19.2147
        Distance   1.065e+08  # distance uncertain!
        Radius     2.169e+04
        AbsMag        -19.07
        Axis    [  0.4490  -0.6144  -0.6488]
        Angle    110.3736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1077"
}

Galaxy "IC 1078:UGC 9608:MCG 2-38-25:ZWG 76.102"
{
        Type  "Sa"
        RA           14.9414
        Dec           9.3542
        Distance   3.983e+08  # method: V
        Radius     5.793e+04
        AbsMag        -20.83
        Axis    [  0.5351  -0.7497  -0.3893]
        Angle    139.7814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1078"
}

Galaxy "IC 1079:UGC 9611:MCG 2-38-26:ZWG 76.103"
{
        Type  "E0"
        RA           14.9433
        Dec           9.3694
        Distance   2.754e+08  # distance uncertain!
        Radius     7.211e+04
        AbsMag        -20.13
        Axis    [ -0.0889  -0.6395  -0.7637]
        Angle     88.6624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1079"
}

Galaxy "IC 1080:MCG 1-38-10:NPM 1"
{
        Type  "S0"
        RA           14.9664
        Dec          -6.7228
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.6056  -0.6375  -0.4764]
        Angle    106.1266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1080"
}

Galaxy "IC 1081:ESO 581-9:MCG 3-38-36"
{
        Type  "SBa"
        RA           14.9819
        Dec         -19.2392
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [ -0.7345  -0.6780   0.0294]
        Angle     60.5869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1081"
}

Galaxy "IC 1082:ZWG 48.87:NPM 1"
{
        Type  "S0"
        RA           14.9811
        Dec           7.0078
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.5187  -0.7491  -0.4121]
        Angle    104.7894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1082"
}

Galaxy "IC 1083:MCG 12-14-14:ZWG 337.24"
{
        Type  "Sc"
        RA           14.9258
        Dec          68.4086
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.5330  -0.4229   0.7328]
        Angle     74.4393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1083"
}

Galaxy "IC 1084:MCG 1-38-17"
{
        Type  "E0"
        RA           15.0206
        Dec          -7.4756
        Distance    1.07e+08  # method: V
        Radius          9338
        AbsMag        -17.38
        Axis    [ -0.8013   0.1953  -0.5655]
        Angle     82.6600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1084"
}

Galaxy "IC 1085:MCG 3-38-74:ZWG 105.98:NPM 1"
{
        Type  "S0"
        RA           15.0453
        Dec          17.2531
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.5462  -0.7806  -0.3038]
        Angle    110.1870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1085"
}

Galaxy "IC 1086:MCG 3-38-77:ZWG 105.101:NPM 1"
{
        Type  "S0"
        RA           15.0581
        Dec          17.1150
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.8900  -0.1027   0.4443]
        Angle     53.3793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1086"
}

Galaxy "IC 1087:MCG 1-38-31:ZWG 49.2:NPM 1"
{
        Type  "S0"
        RA           15.1119
        Dec           3.7772
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.4583  -0.8838  -0.0944]
        Angle     57.3681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1087"
}

Galaxy "IC 1089:ZWG 49.7:NPM 1"
{
        Type  "S0"
        RA           15.1236
        Dec           7.1172
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [ -0.8035  -0.5514  -0.2241]
        Angle     40.7997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1089"
}

Galaxy "IC 1091:MCG 2-39-1:IRAS 15055-1057"
{
        Type  "SBb"
        RA           15.1369
        Dec         -11.1406
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.4799  -0.7370  -0.4759]
        Angle     54.8707
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1091"
}

Galaxy "IC 1092:ZWG 77.15:NPM 1"
{
        Type  "S0"
        RA           15.1267
        Dec           9.3589
        Distance   1.938e+08  # distance uncertain!
        Radius      1.41e+04
        AbsMag        -19.07
        Axis    [  0.4440  -0.8549  -0.2682]
        Angle     68.9317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1092"
}

Galaxy "IC 1093:UGC 9727:MCG 3-39-2:ZWG 106.6"
{
        Type  "SBc"
        RA           15.1264
        Dec          14.5486
        Distance   6.136e+08  # method: V
        Radius     8.925e+04
        AbsMag        -21.57
        Axis    [ -0.3900  -0.8380  -0.3817]
        Angle     37.9238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1093"
}

Galaxy "IC 1094-1:MCG 3-39-6:ZWG 106.8:ZW 453"
{
        Type  "E0"
        RA           15.1283
        Dec          14.6283
        Distance   1.148e+09  # distance uncertain!
        Radius      5.01e+04
        AbsMag        -20.13
        Axis    [  0.2871  -0.8612  -0.4194]
        Angle    152.3592
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1094-1"
}

Galaxy "IC 1094-2:MCG 3-39-6:ZWG 106.8:ZW 453"
{
        Type  "E0"
        RA           15.1283
        Dec          14.6278
        Distance   1.381e+09  # distance uncertain!
        Radius     4.016e+04
        AbsMag        -20.13
        Axis    [  0.2871  -0.8612  -0.4194]
        Angle    152.3594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1094-2"
}

Galaxy "IC 1094-3:MCG 3-39-6:ZWG 106.8:ZW 453"
{
        Type  "E0"
        RA           15.1283
        Dec          14.6225
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.2871  -0.8612  -0.4195]
        Angle    152.3609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1094-3"
}

Galaxy "IC 1095-1:MCG 2-39-3:ZWG 77.19:ZW 454"
{
        Type  "Sb"
        RA           15.1431
        Dec          13.6703
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [  0.1211  -0.9025  -0.4132]
        Angle     56.8671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1095-1"
}

Galaxy "IC 1095-2:MCG 2-39-2:ZWG 77.19:ZW 454"
{
        Type  "E0"
        RA           15.1425
        Dec          13.6753
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.2875  -0.8576  -0.4265]
        Angle    152.7648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1095-2"
}

Galaxy "IC 1096:MCG 3-39-8:ZWG 106.10"
{
        Type  "S0"
        RA           15.1392
        Dec          19.1919
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.5457  -0.8375  -0.0269]
        Angle     67.5089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1096"
}

Galaxy "IC 1097:UGC 9735:MCG 3-39-10:ZWG 106.12"
{
        Type  "Sb"
        RA           15.1419
        Dec          19.1844
        Distance   2.857e+08  # method: V
        Radius     4.571e+04
        AbsMag        -20.01
        Axis    [  0.6964  -0.7177   0.0050]
        Angle     82.8466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1097"
}

Galaxy "IC 1099:UGC 9731:MCG 9-25-21:ZWG 297.3"
{
        Type  "SBc"
        RA           15.1150
        Dec          56.5086
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.4702   0.6597   0.5862]
        Angle     26.1292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1099"
}

Galaxy "IC 1101:UGC 9752:ZWG 49.23"
{
        Type  "S0"
        RA           15.1822
        Dec           5.7456
        Distance   1.067e+09  # method: V
        Radius     1.862e+05
        AbsMag        -22.57
        Axis    [  0.6973  -0.6519  -0.2980]
        Angle    107.5376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1101"
}

Galaxy "IC 1102:UGC 9754:MCG 1-39-0:MK 1395"
{
        Type  "Sb"
        RA           15.1844
        Dec           4.2939
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.6655  -0.6692  -0.3306]
        Angle    106.5888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1102"
}

Galaxy "IC 1103:NPM 1"
{
        Type  "E0"
        RA           15.1931
        Dec          19.2083
        Distance   7.586e+08  # distance uncertain!
        Radius     5.517e+04
        AbsMag        -20.13
        Axis    [  0.2570  -0.8788  -0.4022]
        Angle    147.3000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1103"
}

Galaxy "IC 1105:MCG 1-39-7:ZWG 49.53:NPM 1"
{
        Type  "S0"
        RA           15.2203
        Dec           4.2881
        Distance   5.035e+08  # method: V
        Radius      6.59e+04
        AbsMag        -21.04
        Axis    [  0.1935  -0.9787  -0.0681]
        Angle     49.2962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1105"
}

Galaxy "IC 1106:ZWG 49.66"
{
        Type  "S0"
        RA           15.2322
        Dec           4.7103
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.7206  -0.6446  -0.2555]
        Angle     99.4441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1106"
}

Galaxy "IC 1107:ZWG 49.68:NPM 1"
{
        Type  "E0"
        RA           15.2358
        Dec           4.7147
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.2940  -0.8199  -0.4912]
        Angle    156.1944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1107"
}

Galaxy "IC 1109:ZWG 49.94:NPM 1"
{
        Type  "E0"
        RA           15.2842
        Dec           5.2567
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.2880  -0.8238  -0.4882]
        Angle    156.4422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1109"
}

Galaxy "IC 1110:UGC 9773:MCG 11-19-1:ZWG 318.22"
{
        Type  "Sa"
        RA           15.2014
        Dec          67.3622
        Distance   1.598e+08  # method: V
        Radius     3.253e+04
        AbsMag        -18.55
        Axis    [  0.5921  -0.4510   0.6678]
        Angle     92.4952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1110"
}

Galaxy "IC 1112:ZWG 49.107:PGC 93492"
{
        Type  "S0"
        RA           15.2964
        Dec           7.2186
        Distance   4.663e+08  # method: V
        Radius     6.782e+04
        AbsMag        -20.78
        Axis    [ -0.8956  -0.4449   0.0059]
        Angle     44.2862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1112"
}

Galaxy "IC 1113:MCG 2-39-12:ZWG 77.66"
{
        Type  "S0"
        RA           15.3042
        Dec          12.4886
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.4825  -0.7444  -0.4615]
        Angle     42.5409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1113"
}

Galaxy "IC 1116:MCG 2-39-17:ZWG 77.85:DRCG 33-36"
{
        Type  "S0"
        RA           15.3653
        Dec           8.4239
        Distance   5.331e+08  # method: V
        Radius     9.304e+04
        AbsMag        -21.77
        Axis    [ -0.9698  -0.1038   0.2205]
        Angle     57.8082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1116"
}

Galaxy "IC 1117:ZWG 106.37:NPM 1"
{
        Type  "S0"
        RA           15.4061
        Dec          15.4892
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [ -0.3235  -0.7915   0.5186]
        Angle     42.2137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1117"
}

Galaxy "IC 1118:IC 4543:MCG 2-39-29:ZWG 77.122"
{
        Type  "S0"
        RA           15.4164
        Dec          13.4456
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [  0.3049  -0.9407  -0.1489]
        Angle     59.8471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1118"
}

Galaxy "IC 1119-1:MCG 0-39-25:ZWG 21.93:VV 745"
{
        Type  "S0"
        RA           15.4289
        Dec          -3.6586
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.7578  -0.6389  -0.1320]
        Angle     50.9315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1119-1"
}

Galaxy "IC 1119-2:MCG 0-39-25:ZWG 21.93:VV 745"
{
        Type  "E0"
        RA           15.4289
        Dec          -3.6533
        Distance   4.972e+08  # method: V
        Radius     2.169e+04
        AbsMag        -19.42
        Axis    [  0.2860  -0.7839  -0.5511]
        Angle    160.1543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1119-2"
}

Galaxy "IC 1120-1"
{
        Type  "S0"
        RA           15.4361
        Dec          18.8719
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.6216  -0.7741  -0.1196]
        Angle     92.4009
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1120-1"
}

Galaxy "IC 1120-2"
{
        Type  "E0"
        RA           15.4364
        Dec          18.8750
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.2482  -0.8860  -0.3916]
        Angle    154.1821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1120-2"
}

Galaxy "IC 1121:ZWG 49.166:NPM 1"
{
        Type  "E0"
        RA           15.4622
        Dec           6.8044
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.2666  -0.8357  -0.4801]
        Angle    157.5319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1121"
}

Galaxy "IC 1122"
{
        Type  "E0"
        RA           15.4897
        Dec           7.6175
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [ -0.0726  -0.7270  -0.6828]
        Angle    101.5959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1122"
}

Galaxy "IC 1124:UGC 9869:MCG 4-37-1:ZWG 136.5"
{
        Type  "Sc"
        RA           15.5000
        Dec          23.6383
        Distance   2.435e+08  # method: V
        Radius     2.834e+04
        AbsMag        -19.77
        Axis    [  0.4960  -0.8661   0.0615]
        Angle     69.2949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1124"
}

Galaxy "IC 1125:UGC 9888:MCG 0-40-3:ZWG 22.12"
{
        Type  "Irr"
        RA           15.5514
        Dec          -1.6283
        Distance   1.337e+08  # method: V
        Radius     3.305e+04
        AbsMag        -18.86
        Axis    [ -0.7923  -0.6038   0.0873]
        Angle     52.2786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1125"
}

Galaxy "IC 1127:IC 4553:UGC 9913:MCG 4-37-5"
{
        Type  "Irr"
        RA           15.5825
        Dec          23.5025
        Distance   2.521e+08  # method: V
        Radius       6.6e+04
        AbsMag        -20.44
        Axis    [ -0.8148  -0.3782  -0.4394]
        Angle     35.1609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1127"
}

Galaxy "IC 1128:UGC 9939:MCG 0-40-4:ZWG 22.18"
{
        Type  "S0"
        RA           15.6311
        Dec          -1.7347
        Distance   2.802e+08  # distance uncertain!
        Radius     4.483e+04
        AbsMag        -19.07
        Axis    [  0.5360  -0.6968  -0.4766]
        Angle    141.1771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1128"
}

Galaxy "IC 1129:UGC 9899:MCG 11-19-10:ZWG 319.19"
{
        Type  "Sc"
        RA           15.5333
        Dec          68.2467
        Distance   2.974e+08  # method: V
        Radius     4.758e+04
        AbsMag           -21
        Axis    [ -0.1567   0.6907   0.7059]
        Angle     34.5997
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1129"
}

Galaxy "IC 1130:MCG 3-40-14:ZWG 107.15"
{
        Type  "Sc"
        RA           15.6289
        Dec          17.2444
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.6341  -0.7378  -0.2316]
        Angle    117.4345
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1130"
}

Galaxy "IC 1131:MCG 2-40-8:ZWG 78.36:NPM 1"
{
        Type  "E1"
        RA           15.6475
        Dec          12.0811
        Distance   3.163e+08  # distance uncertain!
        Radius      3.22e+04
        AbsMag        -20.13
        Axis    [ -0.7457  -0.0223  -0.6659]
        Angle     59.3840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1131"
}

Galaxy "IC 1132:UGC 9965:MCG 4-37-20:ZWG 136.49"
{
        Type  "Sc"
        RA           15.6683
        Dec          20.6803
        Distance   2.107e+08  # method: V
        Radius     3.678e+04
        AbsMag        -19.75
        Axis    [  0.4096  -0.8598  -0.3048]
        Angle    109.2904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1132"
}

Galaxy "IC 1133:UGC 9973:MCG 3-40-25:ZWG 107.24"
{
        Type  "Sc"
        RA           15.6867
        Dec          15.5733
        Distance   1.546e+08  # method: T-F
        Radius     2.698e+04
        AbsMag        -18.58
        Axis    [ -0.2424  -0.7705   0.5895]
        Angle     48.8842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1133"
}

Galaxy "IC 1134-1:MCG 3-40-34:ZWG 107.32:NPM 1"
{
        Type  "S0"
        RA           15.7494
        Dec          16.9628
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.6179  -0.7296  -0.2930]
        Angle    138.8994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1134-1"
}

Galaxy "IC 1134-2:MCG 3-40-34:ZWG 107.32"
{
        Type  "E0"
        RA           15.7497
        Dec          16.9592
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.2207  -0.8854  -0.4091]
        Angle    157.7026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1134-2"
}

Galaxy "IC 1135:MCG 3-40-36:ZWG 107.34"
{
        Type  "S0"
        RA           15.7594
        Dec          17.7000
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.6007  -0.7911   0.1150]
        Angle     78.1824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1135"
}

Galaxy "IC 1136:ZWG 22.37:NPM 1"
{
        Type  "E0"
        RA           15.7928
        Dec          -1.5447
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.2431  -0.8037  -0.5432]
        Angle    162.3842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1136"
}

Galaxy "IC 1137:IRAS 15461+0844"
{
        Type  "E0"
        RA           15.8089
        Dec           8.5881
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.2276  -0.8518  -0.4719]
        Angle    160.1325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1137"
}

Galaxy "IC 1138:UGC 10038:ZWG 136.82"
{
        Type  "Sa"
        RA           15.8042
        Dec          26.2061
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.7471  -0.6574   0.0986]
        Angle    102.1494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1138"
}

Galaxy "IC 1139:ZWG 366.17:NPM 1"
{
        Type  "S0"
        RA           15.4906
        Dec          82.5844
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.6352  -0.5627   0.5290]
        Angle    126.6047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1139"
}

Galaxy "IC 1141:UGC 10051:MCG 2-40-14:MK 861"
{
        Type  "SBc"
        RA           15.8297
        Dec          12.3992
        Distance   2.068e+08  # method: V
        Radius     2.105e+04
        AbsMag        -19.31
        Axis    [  0.2430  -0.8644  -0.4402]
        Angle    158.1430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1141"
}

Galaxy "IC 1142:UGC 10055:MCG 3-40-50:ZWG 107.45"
{
        Type  "Sc"
        RA           15.8403
        Dec          18.1400
        Distance   6.385e+08  # method: V
        Radius       1.3e+05
        AbsMag        -21.66
        Axis    [ -0.7907  -0.6078   0.0735]
        Angle     37.9331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1142"
}

Galaxy "IC 1143:UGC 9932:MCG 14-7-22:ZWG 366.18"
{
        Type  "E0"
        RA           15.5153
        Dec          82.4564
        Distance    2.89e+08  # method: V
        Radius     3.783e+04
        AbsMag        -19.74
        Axis    [  0.0897  -0.9864   0.1377]
        Angle    144.1302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1143"
}

Galaxy "IC 1144:UGC 10069:MCG 7-33-1:MK 491"
{
        Type  "S0"
        RA           15.8558
        Dec          43.4183
        Distance   5.504e+08  # method: V
        Radius     8.005e+04
        AbsMag        -21.54
        Axis    [  0.3515  -0.8343   0.4247]
        Angle     57.2436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1144"
}

Galaxy "IC 1145:UGC 10032:MCG 12-15-15:ZWG 338.15"
{
        Type  "Sc"
        RA           15.7356
        Dec          72.4308
        Distance   2.125e+08  # distance uncertain!
        Radius     4.637e+04
        AbsMag        -19.07
        Axis    [ -0.1080   0.3038   0.9466]
        Angle     68.8282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1145"
}

Galaxy "IC 1146:MCG 12-15-19:ZWG 338.21:NPM 1"
{
        Type  "S0"
        RA           15.8061
        Dec          69.3861
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.4565  -0.6773   0.5769]
        Angle     56.1656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1146"
}

Galaxy "IC 1147:MCG 12-15-27:ZWG 338.27"
{
        Type  "S0"
        RA           15.8364
        Dec          69.5600
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.1341  -0.9904   0.0330]
        Angle    150.0425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1147"
}

Galaxy "IC 1149:UGC 10108:MCG 2-41-1:ZWG 79.15"
{
        Type  "Sc"
        RA           15.9686
        Dec          12.0697
        Distance   2.173e+08  # method: V
        Radius     3.792e+04
        AbsMag        -20.42
        Axis    [ -0.9578  -0.2841   0.0434]
        Angle     47.2011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1149"
}

Galaxy "IC 1151:UGC 10113:MCG 3-41-15:ZWG 108.28"
{
        Type  "SBc"
        RA           15.9756
        Dec          17.4408
        Distance    1.03e+08  # method: V
        Radius     3.594e+04
        AbsMag           -19
        Axis    [  0.7025  -0.7007  -0.1247]
        Angle    110.3512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1151"
}

Galaxy "IC 1152:UGC 10103:MCG 8-29-24:ZWG 250.25"
{
        Type  "E0"
        RA           15.9453
        Dec          48.0947
        Distance   2.689e+08  # method: V
        Radius     4.693e+04
        AbsMag        -20.48
        Axis    [  0.1472  -0.9763  -0.1587]
        Angle    154.1488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1152"
}

Galaxy "IC 1153:UGC 10107:MCG 8-29-26:ZWG 250.26"
{
        Type  "S0"
        RA           15.9508
        Dec          48.1686
        Distance   5.881e+07  # method: S
        Radius     1.026e+04
        AbsMag        -17.68
        Axis    [ -0.8913  -0.0617   0.4493]
        Angle     15.7910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1153"
}

Galaxy "IC 1154:UGC 10088:MCG 12-15-35:ZWG 338.29"
{
        Type  "E0"
        RA           15.8744
        Dec          70.3756
        Distance   2.884e+08  # distance uncertain!
        Radius     4.195e+04
        AbsMag        -20.13
        Axis    [  0.5287  -0.3938  -0.7519]
        Angle     13.2144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1154"
}

Galaxy "IC 1155:MCG 3-41-23:ZWG 108.42:KUG 1558+158"
{
        Type  "SBc"
        RA           16.0097
        Dec          15.6858
        Distance   4.054e+08  # method: T-F
        Radius     4.717e+04
        AbsMag        -20.37
        Axis    [  0.4213  -0.8289  -0.3681]
        Angle    139.2402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1155"
}

Galaxy "IC 1156:MCG 3-41-25:ZWG 108.44:NPM 1"
{
        Type  "E0"
        RA           16.0103
        Dec          19.7239
        Distance   4.337e+08  # method: V
        Radius     6.308e+04
        AbsMag        -20.72
        Axis    [  0.1909  -0.9008  -0.3901]
        Angle    159.7152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1156"
}

Galaxy "IC 1157:MCG 3-41-31:ZWG 108.47:KUG 1558+156"
{
        Type  "SBa"
        RA           16.0156
        Dec          15.5267
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.4127  -0.7886   0.4557]
        Angle     47.4138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1157"
}

Galaxy "IC 1158:UGC 10133:MCG 0-41-2:ZWG 23.8"
{
        Type  "SBc"
        RA           16.0261
        Dec           1.7075
        Distance   9.255e+07  # method: V
        Radius     3.365e+04
        AbsMag        -18.46
        Axis    [ -0.6694  -0.7429   0.0089]
        Angle     51.8816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1158"
}

Galaxy "IC 1159"
{
        Type  "S0"
        RA           16.0169
        Dec          15.4197
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.4504  -0.8556  -0.2552]
        Angle    100.1124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1159"
}

Galaxy "IC 1160:MCG 3-41-32:ZWG 108.51:KUG 1558+156"
{
        Type  "SBa"
        RA           16.0172
        Dec          15.4950
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.4129  -0.7888   0.4553]
        Angle     47.4461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1160"
}

Galaxy "IC 1161:MCG 3-41-36:ZWG 108.54:NPM 1"
{
        Type  "E0"
        RA           16.0211
        Dec          15.6458
        Distance   4.963e+08  # method: V
        Radius     5.774e+04
        AbsMag        -20.81
        Axis    [  0.1958  -0.8854  -0.4215]
        Angle    160.6108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1161"
}

Galaxy "IC 1162:MCG 3-41-34:ZWG 108.56:VV 452"
{
        Type  "SBc"
        RA           16.0211
        Dec          17.6775
        Distance   6.082e+08  # method: V
        Radius     6.192e+04
        AbsMag        -21.05
        Axis    [  0.5651  -0.7644  -0.3103]
        Angle    142.5383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1162"
}

Galaxy "IC 1163:MCG 3-41-39:ZWG 108.60"
{
        Type  "E0"
        RA           16.0250
        Dec          15.5044
        Distance   4.805e+08  # method: V
        Radius     4.892e+04
        AbsMag        -20.84
        Axis    [  0.1956  -0.8849  -0.4226]
        Angle    160.6760
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1163"
}

Galaxy "IC 1165:IC 1165A:MCG 3-41-48:ZWG 108.67"
{
        Type  "S0"
        RA           16.0353
        Dec          15.6964
        Distance   6.795e+08  # method: V
        Radius     7.906e+04
        AbsMag        -21.09
        Axis    [ -0.7766  -0.4613   0.4290]
        Angle     47.9234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1165"
}

Galaxy "IC 1165B:MCG 3-41-49:ZWG 108.67:VV 90"
{
        Type  "E0"
        RA           16.0356
        Dec          15.6928
        Distance   4.632e+08  # method: V
        Radius     2.695e+04
        AbsMag        -19.76
        Axis    [  0.1414  -0.8792  -0.4550]
        Angle    147.4984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1165B"
}

Galaxy "IC 1166-1:MK 867:ZWG 137.18:KUG 1600+264"
{
        Type  "S0"
        RA           16.0356
        Dec          26.3250
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.6180  -0.3283   0.7144]
        Angle     50.4307
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1166-1"
}

Galaxy "IC 1166-2:MK 867:ZWG 137.18"
{
        Type  "S0"
        RA           16.0358
        Dec          26.3292
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.2027  -0.9205  -0.3339]
        Angle    157.7526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1166-2"
}

Galaxy "IC 1167:MCG 3-41-65"
{
        Type  "S0"
        RA           16.0644
        Dec          14.9461
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.2159  -0.8798  -0.4235]
        Angle    159.8882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1167"
}

Galaxy "IC 1168:IC 1168A:MCG 3-41-66:ZWG 108.90"
{
        Type  "E0"
        RA           16.0653
        Dec          14.9031
        Distance   4.366e+08  # distance uncertain!
        Radius     4.445e+04
        AbsMag        -20.13
        Axis    [  0.1925  -0.8833  -0.4275]
        Angle    161.1806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1168"
}

Galaxy "IC 1168B"
{
        Type  "S0"
        RA           16.0656
        Dec          14.8942
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.2485  -0.9670   0.0554]
        Angle     63.6833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1168B"
}

Galaxy "IC 1169:UGC 10161:MCG 2-41-4:ZWG 79.33"
{
        Type  "Sb"
        RA           16.0703
        Dec          13.7442
        Distance   1.592e+08  # method: V
        Radius     2.316e+04
        AbsMag        -19.24
        Axis    [  0.6001  -0.7396  -0.3047]
        Angle    130.0852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1169"
}

Galaxy "IC 1170:ZWG 108.101:DRCG 34-66"
{
        Type  "S0"
        RA           16.0753
        Dec          17.7214
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.2899  -0.9537   0.0804]
        Angle     65.3424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1170"
}

Galaxy "IC 1173:UGC 10180:MCG 3-41-89:ZWG 108.113"
{
        Type  "SBc"
        RA           16.0867
        Dec          17.4225
        Distance    5.61e+08  # method: T-F
        Radius     7.344e+04
        AbsMag        -20.88
        Axis    [  0.4754  -0.8686  -0.1399]
        Angle     90.8501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1173"
}

Galaxy "IC 1174:UGC 10185:MCG 3-41-91:ZWG 108.116"
{
        Type  "Sa"
        RA           16.0906
        Dec          15.0253
        Distance   2.168e+08  # method: V
        Radius     3.153e+04
        AbsMag        -19.61
        Axis    [  0.3186  -0.8886  -0.3300]
        Angle     99.8959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1174"
}

Galaxy "IC 1177:DRCG 34-143"
{
        Type  "Sa"
        RA           16.0886
        Dec          18.3153
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.5015  -0.8008  -0.3275]
        Angle    145.7430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1177"
}

Galaxy "IC 1178:UGC 10188:MCG 3-41-97:ZWG 108.120"
{
        Type  "S0"
        RA           16.0925
        Dec          17.6019
        Distance   4.647e+08  # method: V
        Radius     6.759e+04
        AbsMag        -20.57
        Axis    [  0.2926  -0.8814  -0.3707]
        Angle    116.3579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1178"
}

Galaxy "IC 1181:UGC 10189:MCG 3-41-98:ZWG 108.120"
{
        Type  "SBa"
        RA           16.0925
        Dec          17.5936
        Distance   4.814e+08  # method: V
        Radius     5.601e+04
        AbsMag        -19.94
        Axis    [  0.4268  -0.9037  -0.0328]
        Angle     78.5180
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1181"
}

Galaxy "IC 1182:UGC 10192:MCG 3-41-104:MK 298"
{
        Type  "Sa"
        RA           16.0933
        Dec          17.8028
        Distance   4.688e+08  # method: V
        Radius     6.819e+04
        AbsMag        -20.59
        Axis    [  0.3496  -0.9363   0.0343]
        Angle     70.4137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1182"
}

Galaxy "IC 1185:MCG 3-41-110:ZWG 108.134:NPM 1"
{
        Type  "Sb"
        RA           16.0956
        Dec          17.7172
        Distance    4.75e+08  # method: V
        Radius     5.527e+04
        AbsMag        -20.72
        Axis    [  0.6097  -0.7364  -0.2934]
        Angle    140.9985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1185"
}

Galaxy "IC 1186:MCG 3-41-111:ZWG 108.133:DRCG 34-19"
{
        Type  "SBb"
        RA           16.0956
        Dec          17.3622
        Distance   5.045e+08  # method: V
        Radius      5.87e+04
        AbsMag        -20.55
        Axis    [  0.6097  -0.7352  -0.2963]
        Angle    140.9041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1186"
}

Galaxy "IC 1187:MCG 12-15-40:ZWG 338.34:NPM 1"
{
        Type  "S0"
        RA           15.9861
        Dec          70.5575
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.5167  -0.5540   0.6528]
        Angle     81.8909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1187"
}

Galaxy "IC 1188:DRCG 34-28"
{
        Type  "Sa"
        RA           16.1019
        Dec          17.4603
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.6724  -0.6898  -0.2684]
        Angle    138.3590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1188"
}

Galaxy "IC 1189:MCG 3-41-119:MK 300:ZWG 108.144"
{
        Type  "SBa"
        RA           16.1039
        Dec          18.1825
        Distance   5.331e+08  # method: V
        Radius     5.427e+04
        AbsMag        -20.67
        Axis    [ -0.8145  -0.1713   0.5543]
        Angle     58.8733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1189"
}

Galaxy "IC 1190:UGC 10195:MCG 3-41-113:ZWG 108.136"
{
        Type  "SBb"
        RA           16.0978
        Dec          18.2206
        Distance   5.783e+08  # method: T-F
        Radius     1.093e+05
        AbsMag        -20.64
        Axis    [ -0.0097  -0.8260   0.5636]
        Angle     56.4789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1190"
}

Galaxy "IC 1191:DRCG 34-133"
{
        Type  "S0"
        RA           16.1078
        Dec          18.2689
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [ -0.5333  -0.3331   0.7776]
        Angle     76.5033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1191"
}

Galaxy "IC 1192:DRCG 34-74"
{
        Type  "Sb"
        RA           16.1092
        Dec          17.7761
        Distance   5.273e+08  # method: V
        Radius     4.602e+04
        AbsMag        -20.24
        Axis    [  0.0461  -0.8705   0.4899]
        Angle     56.5204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1192"
}

Galaxy "IC 1193:DRCG 34-56"
{
        Type  "Sa"
        RA           16.1089
        Dec          17.7139
        Distance   5.484e+08  # method: V
        Radius     5.583e+04
        AbsMag        -20.73
        Axis    [  0.5444  -0.7800  -0.3087]
        Angle    138.6818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1193"
}

Galaxy "IC 1194:DRCG 34-73"
{
        Type  "Sa"
        RA           16.1106
        Dec          17.7833
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.2077  -0.8917  -0.4021]
        Angle    159.8681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1194"
}

Galaxy "IC 1195:MCG 3-41-126:ZWG 108.151:DRCG 34-3"
{
        Type  "SBc"
        RA           16.1111
        Dec          17.1919
        Distance   5.463e+08  # method: V
        Radius     4.767e+04
        AbsMag        -20.52
        Axis    [  0.5600  -0.7743  -0.2946]
        Angle    132.8021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1195"
}

Galaxy "IC 1196:UGC 10218:MCG 2-41-9:ZWG 79.55"
{
        Type  "Sa"
        RA           16.1328
        Dec          10.7800
        Distance   2.257e+08  # method: V
        Radius     3.611e+04
        AbsMag         -19.5
        Axis    [  0.6393  -0.6947  -0.3297]
        Angle    134.7715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1196"
}

Galaxy "IC 1197:UGC 10219:MCG 1-41-13:ZWG 51.52"
{
        Type  "Sc"
        RA           16.1381
        Dec           7.5392
        Distance   6.659e+07  # method: V
        Radius     2.809e+04
        AbsMag        -17.15
        Axis    [  0.6482  -0.7613   0.0129]
        Angle     85.6342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1197"
}

Galaxy "IC 1198:MCG 2-41-11:MK 871:ZWG 79.59"
{
        Type  "Sc"
        RA           16.1433
        Dec          12.3306
        Distance   4.639e+08  # method: V
        Radius     4.048e+04
        AbsMag        -20.76
        Axis    [  0.0365  -0.9891   0.1427]
        Angle     56.6153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1198"
}

Galaxy "IC 1199:UGC 10242:MCG 2-41-13:ZWG 79.70"
{
        Type  "Sc"
        RA           16.1761
        Dec          10.0400
        Distance     4.8e+08  # method: V
        Radius     9.075e+04
        AbsMag        -21.34
        Axis    [ -0.6171  -0.5259   0.5853]
        Angle     61.5228
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1199"
}

Galaxy "IC 1201:UGC 10221:MCG 12-15-51:ZWG 338.44"
{
        Type  "Sb"
        RA           16.0947
        Dec          69.5939
        Distance   3.072e+08  # distance uncertain!
        Radius     5.362e+04
        AbsMag        -19.07
        Axis    [  0.3832  -0.2681   0.8839]
        Angle     83.2102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1201"
}

Galaxy "IC 1204:MCG 12-15-53:ZWG 338.46:IRAS 16073+7003"
{
        Type  "S0"
        RA           16.1208
        Dec          69.9317
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.5779  -0.6935   0.4302]
        Angle    108.4448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1204"
}

Galaxy "IC 1205:MCG 2-41-22:ZWG 79.84:NPM 1"
{
        Type  "Sb"
        RA           16.2375
        Dec           9.5375
        Distance   1.688e+08  # distance uncertain!
        Radius     1.228e+04
        AbsMag        -19.07
        Axis    [  0.2048  -0.8606  -0.4663]
        Angle    162.3922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1205"
}

Galaxy "IC 1206:UGC 10293:MCG 2-41-23:ZWG 79.87"
{
        Type  "Sb"
        RA           16.2536
        Dec          11.2972
        Distance   4.626e+08  # method: V
        Radius     7.401e+04
        AbsMag        -21.06
        Axis    [  0.6307  -0.7010  -0.3328]
        Angle    136.7379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1206"
}

Galaxy "IC 1208:ZWG 196.16"
{
        Type  "Sa"
        RA           16.2631
        Dec          36.5275
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.4578  -0.6598   0.5959]
        Angle     79.5487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1208"
}

Galaxy "IC 1209:UGC 10329:MCG 3-41-149:ZWG 108.174"
{
        Type  "S0"
        RA           16.3108
        Dec          15.5589
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.5166  -0.7870  -0.3373]
        Angle    140.4030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1209"
}

Galaxy "IC 1210:UGC 10304:MCG 10-23-48:ZWG 298.21"
{
        Type  "Sb"
        RA           16.2417
        Dec          62.5361
        Distance   1.318e+08  # method: V
        Radius     3.068e+04
        AbsMag        -18.23
        Axis    [ -0.1497   0.1154   0.9820]
        Angle     68.1098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1210"
}

Galaxy "IC 1211:UGC 10314:MCG 9-27-9:ZWG 276.7"
{
        Type  "E0"
        RA           16.2808
        Dec          53.0061
        Distance   2.556e+08  # method: V
        Radius     3.717e+04
        AbsMag        -20.77
        Axis    [  0.0749  -0.9819  -0.1737]
        Angle    116.4064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1211"
}

Galaxy "IC 1212:ZWG 320.16:NPM 1"
{
        Type  "E0"
        RA           16.2583
        Dec          64.2253
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.0962  -0.9952  -0.0203]
        Angle    156.2838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1212"
}

Galaxy "IC 1214:UGC 10323:MCG 11-20-9:ZWG 320.19"
{
        Type  "Sa"
        RA           16.2697
        Dec          65.9686
        Distance   2.125e+08  # distance uncertain!
        Radius     4.328e+04
        AbsMag        -19.07
        Axis    [  0.6373  -0.7447   0.1981]
        Angle    144.8742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1214"
}

Galaxy "IC 1215:UGC 10315:MCG 11-20-9A:ZWG 338.49"
{
        Type  "SBa"
        RA           16.2597
        Dec          68.3972
        Distance   3.287e+08  # method: V
        Radius     5.259e+04
        AbsMag        -20.92
        Axis    [  0.5346  -0.8322   0.1470]
        Angle    150.3317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1215"
}

Galaxy "IC 1216:UGC 10326:MCG 11-20-10:ZWG 338.50"
{
        Type  "Sc"
        RA           16.2653
        Dec          68.3494
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [  0.3457  -0.9299   0.1255]
        Angle    124.8415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1216"
}

Galaxy "IC 1218:MCG 11-20-11:ZWG 320.22:KAZ 69"
{
        Type  "S0"
        RA           16.2769
        Dec          68.2031
        Distance   5.028e+07  # method: V
        Radius          8045
        AbsMag        -16.04
        Axis    [  0.6492  -0.6003   0.4671]
        Angle    119.1473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1218"
}

Galaxy "IC 1219:UGC 10371:MCG 3-42-5:ZWG 109.12"
{
        Type  "S0"
        RA           16.4075
        Dec          19.4836
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.1452  -0.8609   0.4877]
        Angle     54.5468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1219"
}

Galaxy "IC 1220:MCG 1-42-5:ZWG 52.30"
{
        Type  "E0"
        RA           16.4939
        Dec           8.4506
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [  0.1565  -0.8634  -0.4797]
        Angle    166.3016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1220"
}

Galaxy "IC 1221:UGC 10458:MCG 8-30-30:ZWG 251.30"
{
        Type  "Sc"
        RA           16.5781
        Dec          46.3917
        Distance   2.473e+08  # method: V
        Radius     4.675e+04
        AbsMag         -19.9
        Axis    [  0.4040  -0.9071  -0.1185]
        Angle    156.9436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1221"
}

Galaxy "IC 1222:UGC 10461:MCG 8-30-32:ZWG 251.31"
{
        Type  "SBc"
        RA           16.5858
        Dec          46.2136
        Distance   4.186e+08  # method: V
        Radius     1.035e+05
        AbsMag        -21.34
        Axis    [  0.3970  -0.9175   0.0246]
        Angle    108.6829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1222"
}

Galaxy "IC 1223:MCG 8-30-33:ZWG 251.32:NPM 1"
{
        Type  "SBa"
        RA           16.5950
        Dec          49.2211
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.4365  -0.8988  -0.0413]
        Angle    139.8807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1223"
}

Galaxy "IC 1224:MCG 3-42-27:ZWG 110.3:NPM 1"
{
        Type  "E0"
        RA           16.7156
        Dec          19.2550
        Distance   4.169e+08  # distance uncertain!
        Radius     4.851e+04
        AbsMag        -20.13
        Axis    [ -0.2778  -0.8030  -0.5272]
        Angle     88.0342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1224"
}

Galaxy "IC 1225:UGC 10494:MCG 11-20-22:ZWG 320.34"
{
        Type  "SBb"
        RA           16.6144
        Dec          67.6292
        Distance    2.44e+08  # distance uncertain!
        Radius     4.969e+04
        AbsMag        -19.07
        Axis    [  0.6034  -0.5909   0.5355]
        Angle    110.6614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1225"
}

Galaxy "IC 1226:ZWG 251.38"
{
        Type  "S0"
        RA           16.6850
        Dec          46.0039
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.4331  -0.9008  -0.0324]
        Angle    128.6248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1226"
}

Galaxy "IC 1228:UGC 10524:MCG 11-20-26:ZWG 320.38"
{
        Type  "SBb"
        RA           16.7017
        Dec          65.5856
        Distance   3.456e+08  # method: V
        Radius     8.043e+04
        AbsMag        -20.93
        Axis    [  0.2737  -0.9587   0.0768]
        Angle    123.8190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1228"
}

Galaxy "IC 1229:MCG 9-27-72"
{
        Type  "SBa"
        RA           16.7494
        Dec          51.3081
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.3221  -0.9080   0.2679]
        Angle     76.0817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1229"
}

Galaxy "IC 1230:UGC 10538:MCG 9-27-73:ZWG 276.41"
{
        Type  "S0"
        RA           16.7503
        Dec          51.2600
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.1108  -0.9854  -0.1290]
        Angle    163.5736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1230"
}

Galaxy "IC 1231:UGC 10560:MCG 10-24-56:ZWG 299.29"
{
        Type  "Sc"
        RA           16.7831
        Dec          58.4228
        Distance   2.314e+08  # method: T-F
        Radius     7.403e+04
        AbsMag        -20.65
        Axis    [ -0.0017  -0.1865   0.9824]
        Angle     59.2589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1231"
}

Galaxy "IC 1235:MK 1109:ZWG 320.47"
{
        Type  "S0"
        RA           16.8675
        Dec          63.1161
        Distance   1.234e+08  # method: V
        Radius     1.436e+04
        AbsMag        -17.99
        Axis    [  0.5162  -0.8487   0.1150]
        Angle    145.7571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1235"
}

Galaxy "IC 1236:UGC 10633:MCG 3-43-10:ZWG 110.19"
{
        Type  "SBc"
        RA           16.9747
        Dec          20.0408
        Distance   2.739e+08  # method: V
        Radius     3.984e+04
        AbsMag        -20.42
        Axis    [  0.2423  -0.9368  -0.2523]
        Angle    108.7210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1236"
}

Galaxy "IC 1237:UGC 10621:MCG 9-28-10:ZWG 277.16"
{
        Type  "SBc"
        RA           16.9375
        Dec          55.0269
        Distance   5.317e+08  # method: T-F
        Radius     1.469e+05
        AbsMag        -21.66
        Axis    [  0.5665  -0.8218   0.0616]
        Angle    144.5157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1237"
}

Galaxy "IC 1241:UGC 10670:ZWG 321.11:KAZ 445"
{
        Type  "S0"
        RA           17.0244
        Dec          63.6911
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [ -0.0447  -0.0739   0.9963]
        Angle     30.9923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1241"
}

Galaxy "IC 1242:UGC 10718:MCG 1-44-1:ZWG 54.2"
{
        Type  "Sb"
        RA           17.1450
        Dec           4.0497
        Distance   3.062e+08  # method: V
        Radius     4.008e+04
        AbsMag        -20.06
        Axis    [ -0.4744  -0.8662   0.1571]
        Angle     64.0366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1242"
}

Galaxy "IC 1244:UGC 10739:MCG 6-38-3:ZWG 198.15"
{
        Type  "S0"
        RA           17.1758
        Dec          36.3039
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.0926  -0.9616  -0.2582]
        Angle    169.5634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1244"
}

Galaxy "IC 1245:UGC 10755:MCG 6-38-7:ZWG 198.22"
{
        Type  "S0"
        RA           17.2100
        Dec          38.0203
        Distance   1.851e+08  # distance uncertain!
        Radius     4.577e+04
        AbsMag        -19.07
        Axis    [  0.0646  -0.7892   0.6107]
        Angle     63.6485
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1245"
}

Galaxy "IC 1248:UGC 10756:MCG 10-24-106:ZWG 299.59"
{
        Type  "SBc"
        RA           17.1942
        Dec          59.9950
        Distance   2.266e+08  # method: V
        Radius     2.967e+04
        AbsMag        -19.81
        Axis    [  0.2979  -0.9541   0.0297]
        Angle    138.6396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1248"
}

Galaxy "IC 1249:ZWG 198.26"
{
        Type  "E0"
        RA           17.2483
        Dec          35.5206
        Distance   3.312e+08  # distance uncertain!
        Radius      2.89e+04
        AbsMag        -20.13
        Axis    [  0.0619  -0.9617  -0.2671]
        Angle    171.2383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1249"
}

Galaxy "IC 1250:NPM 1"
{
        Type  "S0"
        RA           17.2414
        Dec          57.4172
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.5186  -0.8107   0.2717]
        Angle    115.8003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1250"
}

Galaxy "IC 1251:UGC 10757:MCG 12-16-21:ZWG 339.29"
{
        Type  "Sc"
        RA           17.1700
        Dec          72.4097
        Distance    1.47e+08  # distance uncertain!
        Radius     3.208e+04
        AbsMag        -19.07
        Axis    [  0.4746  -0.7939   0.3801]
        Angle    108.7264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1251"
}

Galaxy "IC 1252:IC 4649:UGC 10788:ZWG 299.68"
{
        Type  "Sb"
        RA           17.2639
        Dec          57.3669
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [  0.1888  -0.3147   0.9302]
        Angle     85.9775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1252"
}

Galaxy "IC 1254:UGC 10769:MCG 12-16-24:ZWG 339.32"
{
        Type  "SBb"
        RA           17.1925
        Dec          72.4017
        Distance    2.03e+08  # distance uncertain!
        Radius     4.723e+04
        AbsMag        -19.07
        Axis    [  0.5938  -0.7640   0.2522]
        Angle    147.3841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1254"
}

Galaxy "IC 1255:UGC 10826:MCG 2-44-3:ZWG 82.23"
{
        Type  "Sc"
        RA           17.3847
        Dec          12.6961
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.5211  -0.7874  -0.3294]
        Angle    137.0108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1255"
}

Galaxy "IC 1256:UGC 10829:MCG 4-41-7:ZWG 140.17"
{
        Type  "Sb"
        RA           17.3964
        Dec          26.4864
        Distance   2.131e+08  # method: V
        Radius      4.96e+04
        AbsMag        -19.78
        Axis    [  0.0793  -0.9893   0.1223]
        Angle     77.0360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1256"
}

Galaxy "IC 1258:UGC 10867:MCG 10-25-35:ZWG 300.29"
{
        Type  "Sa"
        RA           17.4547
        Dec          58.4853
        Distance   3.574e+08  # method: V
        Radius     4.678e+04
        AbsMag         -20.8
        Axis    [  0.3487  -0.9207   0.1754]
        Angle    109.7501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1258"
}

Galaxy "IC 1259-1:UGC 10869:MCG 10-25-37A:ZWG 300.30"
{
        Type  "S0"
        RA           17.4567
        Dec          58.5167
        Distance   3.422e+08  # method: V
        Radius     3.981e+04
        AbsMag         -19.2
        Axis    [  0.2443  -0.5492   0.7992]
        Angle     69.5351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1259-1"
}

Galaxy "IC 1259-2:UGC 10869:MCG 10-25-37:ZWG 300.30"
{
        Type  "S0"
        RA           17.4572
        Dec          58.5164
        Distance   3.652e+08  # method: V
        Radius     1.593e+04
        AbsMag        -20.95
        Axis    [  0.0589  -0.9959  -0.0684]
        Angle    172.5692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1259-2"
}

Galaxy "IC 1260:MCG 10-25-40:ZWG 300.32:NPM 1"
{
        Type  "E0"
        RA           17.4586
        Dec          58.4764
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.0327  -0.9970  -0.0705]
        Angle    172.7968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1260"
}

Galaxy "IC 1261-1:MCG 12-16-32A:ZWG 339.39:KCPG 514A"
{
        Type  "S0"
        RA           17.3889
        Dec          71.2639
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.3338  -0.8866   0.3201]
        Angle     87.2096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1261-1"
}

Galaxy "IC 1261-2:MCG 12-16-32B:ZWG 339.39:NPM 1"
{
        Type  "E0"
        RA           17.3906
        Dec          71.2633
        Distance   5.496e+08  # distance uncertain!
        Radius     7.194e+04
        AbsMag        -20.13
        Axis    [  0.0393  -0.9986   0.0347]
        Angle    144.5069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1261-2"
}

Galaxy "IC 1262:UGC 10900:MCG 7-36-20:ZWG 226.25"
{
        Type  "E0"
        RA           17.5506
        Dec          43.7597
        Distance    3.02e+08  # distance uncertain!
        Radius     5.271e+04
        AbsMag        -20.13
        Axis    [ -0.1513  -0.9603  -0.2344]
        Angle     91.6752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1262"
}

Galaxy "IC 1263:UGC 10902:MCG 7-36-21:ZWG 226.26"
{
        Type  "SBa"
        RA           17.5519
        Dec          43.8217
        Distance   1.768e+08  # distance uncertain!
        Radius     4.114e+04
        AbsMag        -19.07
        Axis    [ -0.2298  -0.2799   0.9321]
        Angle     66.9540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1263"
}

Galaxy "IC 1264:UGC 10904:MCG 7-36-22:ZWG 226.27"
{
        Type  "S0"
        RA           17.5544
        Dec          43.6289
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [  0.1953  -0.9739  -0.1158]
        Angle    131.8770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1264"
}

Galaxy "IC 1265:UGC 10917:MCG 7-36-27:ZWG 226.32"
{
        Type  "Sb"
        RA           17.6108
        Dec          42.0889
        Distance   9.577e+07  # method: V
        Radius     2.786e+04
        AbsMag        -18.64
        Axis    [  0.4107  -0.8640   0.2913]
        Angle     99.4631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1265"
}

Galaxy "IC 1267:UGC 10937:MCG 10-25-77:ZWG 300.56"
{
        Type  "SBb"
        RA           17.6458
        Dec          59.3725
        Distance   4.194e+08  # method: V
        Radius      9.15e+04
        AbsMag        -21.35
        Axis    [  0.4416  -0.8920   0.0964]
        Angle    141.0521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1267"
}

Galaxy "IC 1268:MCG 3-45-36:ZWG 112.57:NPM 1"
{
        Type  "Sc"
        RA           17.8442
        Dec          17.2100
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.2147  -0.9584   0.1882]
        Angle     72.2823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1268"
}

Galaxy "IC 1269:UGC 11013:MCG 4-42-9:ZWG 141.20"
{
        Type  "Sc"
        RA           17.8681
        Dec          21.5689
        Distance   2.742e+08  # method: V
        Radius     6.779e+04
        AbsMag        -21.02
        Axis    [ -0.2780  -0.9283   0.2470]
        Angle     66.7636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1269"
}

Galaxy "IC 1277:UGC 11135:MCG 5-43-5:ZWG 172.8"
{
        Type  "Sc"
        RA           18.1742
        Dec          31.0033
        Distance   3.168e+08  # method: V
        Radius      5.53e+04
        AbsMag        -20.24
        Axis    [  0.2988  -0.9315  -0.2076]
        Angle    146.4632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1277"
}

Galaxy "IC 1279:UGC 11143:MCG 6-40-9:ZWG 200.9"
{
        Type  "Sb"
        RA           18.1875
        Dec          36.0075
        Distance    1.54e+08  # distance uncertain!
        Radius     5.822e+04
        AbsMag        -19.07
        Axis    [ -0.0827  -0.4571   0.8856]
        Angle     89.2020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1279"
}

Galaxy "IC 1281:ZWG 200.10:NPM 1"
{
        Type  "S0"
        RA           18.1939
        Dec          35.9978
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.4496  -0.8632  -0.2297]
        Angle    164.8605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1281"
}

Galaxy "IC 1286:UGC 11191:MCG 9-30-10:ZWG 279.7"
{
        Type  "Sb"
        RA           18.2706
        Dec          55.5900
        Distance   2.472e+08  # method: V
        Radius     5.034e+04
        AbsMag         -19.7
        Axis    [  0.4735  -0.7666   0.4338]
        Angle    112.0104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1286"
}

Galaxy "IC 1288:UGC 11256:MCG 7-38-7:ZWG 228.9"
{
        Type  "SBa"
        RA           18.4894
        Dec          39.7139
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.4116  -0.8841  -0.2214]
        Angle    171.2693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1288"
}

Galaxy "IC 1289:MCG 7-38-9:ZWG 228.11"
{
        Type  "S0"
        RA           18.5006
        Dec          39.9647
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.0125  -0.6380   0.7700]
        Angle     80.5670
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1289"
}

Galaxy "IC 1291:UGC 11283:MCG 8-34-4:ZWG 255.6"
{
        Type  "Irr"
        RA           18.5644
        Dec          49.2786
        Distance   8.417e+07  # method: V
        Radius     2.204e+04
        AbsMag        -18.46
        Axis    [  0.2793  -0.9600  -0.0214]
        Angle    145.2876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1291"
}

Galaxy "IC 1296:UGC 11374:MCG 6-41-22:ZWG 201.40"
{
        Type  "SBc"
        RA           18.8883
        Dec          33.0664
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.1156  -0.9904   0.0753]
        Angle    111.0036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1296"
}

Galaxy "IC 1301:IC 4867:UGC 11437:MCG 8-35-10"
{
        Type  "Sa"
        RA           19.4419
        Dec          50.1258
        Distance    1.54e+08  # distance uncertain!
        Radius     2.687e+04
        AbsMag        -19.07
        Axis    [  0.3827  -0.9167  -0.1153]
        Angle    174.4076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1301"
}

Galaxy "IC 1302:MCG 6-43-2:IRAS 19290+3540"
{
        Type  "SBc"
        RA           19.5144
        Dec          35.7850
        Distance   2.026e+08  # method: V
        Radius     2.652e+04
        AbsMag        -19.87
        Axis    [  0.3686  -0.9289  -0.0358]
        Angle    146.2000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1302"
}

Galaxy "IC 1303:UGC 11452:MCG 6-43-4:IRAS 19296+3546"
{
        Type  "Sc"
        RA           19.5250
        Dec          35.8758
        Distance    1.94e+08  # method: V
        Radius     3.669e+04
        AbsMag        -19.27
        Axis    [  0.1007  -0.9377   0.3325]
        Angle    104.8500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1303"
}

Galaxy "IC 1309"
{
        Type  "SBc"
        RA           20.0503
        Dec         -17.2325
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.1380  -0.8628  -0.4863]
        Angle    144.9977
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1309"
}

Galaxy "IC 1313:MCG 3-51-8:NPM 1"
{
        Type  "SBb"
        RA           20.3119
        Dec         -16.9461
        Distance   1.333e+08  # method: V
        Radius     4.071e+04
        AbsMag        -18.16
        Axis    [ -0.2332  -0.8179  -0.5260]
        Angle    157.9206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1313"
}

Galaxy "IC 1317:UGC 11546:MCG 0-52-4:ZWG 373.5"
{
        Type  "E0"
        RA           20.3875
        Dec           0.6647
        Distance   1.668e+08  # method: V
        Radius     1.698e+04
        AbsMag        -18.94
        Axis    [ -0.5724  -0.7806  -0.2510]
        Angle    134.9740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1317"
}

Galaxy "IC 1319:ESO 596-37:MCG 3-52-7:IRAS 20231-1840"
{
        Type  "Sc"
        RA           20.4336
        Dec         -18.5042
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.0219  -0.8147  -0.5795]
        Angle    152.5314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1319"
}

Galaxy "IC 1320:UGC 11560:MCG 0-52-9:ZWG 373.8"
{
        Type  "Sb"
        RA           20.4403
        Dec           2.9094
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [ -0.1396  -0.9890   0.0484]
        Angle    124.9434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1320"
}

Galaxy "IC 1321:ESO 596-43:MCG 3-52-11"
{
        Type  "Sc"
        RA           20.4697
        Dec         -18.2919
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.3914  -0.9133  -0.1131]
        Angle    125.7178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1321"
}

Galaxy "IC 1322:NPM 1:IRAS 20273-1523"
{
        Type  "SBa"
        RA           20.5022
        Dec         -15.2278
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.2540  -0.9583   0.1309]
        Angle    122.9169
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1322"
}

Galaxy "IC 1324:MCG 2-52-12:NPM 1"
{
        Type  "Sa"
        RA           20.5367
        Dec          -9.0556
        Distance   2.646e+08  # method: V
        Radius     5.774e+04
        AbsMag        -20.15
        Axis    [ -0.2976  -0.8537  -0.4273]
        Angle    157.5279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1324"
}

Galaxy "IC 1327:ZWG 373.38:KARA 881"
{
        Type  "Sa"
        RA           20.5947
        Dec          -0.0053
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.6182  -0.5255   0.5845]
        Angle     94.3648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1327"
}

Galaxy "IC 1328:ESO 597-28:MCG 3-52-23:IRAS 20390-1948"
{
        Type  "Sc"
        RA           20.6992
        Dec         -19.6331
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.1093  -0.9415  -0.3188]
        Angle    135.7209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1328"
}

Galaxy "IC 1330:MCG 2-53-2:IRAS 20434-1412"
{
        Type  "Sc"
        RA           20.7706
        Dec         -14.0228
        Distance   3.603e+08  # method: T-F
        Radius     6.288e+04
        AbsMag        -20.42
        Axis    [ -0.2342  -0.9215   0.3100]
        Angle    127.8702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1330"
}

Galaxy "IC 1331:MCG 2-53-5"
{
        Type  "Sa"
        RA           20.7967
        Dec          -9.9956
        Distance   1.768e+08  # distance uncertain!
        Radius     4.628e+04
        AbsMag        -19.07
        Axis    [ -0.0864  -0.9937   0.0707]
        Angle    130.0177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1331"
}

Galaxy "IC 1332:MCG 2-53-11:NPM 1"
{
        Type  "Sb"
        RA           20.8642
        Dec         -13.7111
        Distance    1.54e+08  # distance uncertain!
        Radius     2.015e+04
        AbsMag        -19.07
        Axis    [ -0.2542  -0.9476  -0.1936]
        Angle    136.7574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1332"
}

Galaxy "IC 1333:IC 1334:MCG 3-53-8:NPM 1"
{
        Type  "Sa"
        RA           20.8714
        Dec         -16.2858
        Distance   3.551e+08  # method: V
        Radius     7.746e+04
        AbsMag        -20.68
        Axis    [ -0.2030  -0.9683  -0.1455]
        Angle    133.6445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1333"
}

Galaxy "IC 1335:NPM 1"
{
        Type  "E0"
        RA           20.8850
        Dec         -16.3350
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [ -0.3380  -0.7054  -0.6230]
        Angle    198.0066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1335"
}

Galaxy "IC 1336:ESO 598-1:MCG 3-53-9"
{
        Type  "Sb"
        RA           20.9181
        Dec         -18.0386
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.1341  -0.8982  -0.4187]
        Angle    146.5775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1336"
}

Galaxy "IC 1337:MCG 3-53-12:IRAS 20540-1646"
{
        Type  "Sb"
        RA           20.9478
        Dec         -16.5850
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [ -0.5882  -0.4619   0.6638]
        Angle    118.8086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1337"
}

Galaxy "IC 1338:NPM 1:IRAS 20541-1641"
{
        Type  "SBa"
        RA           20.9492
        Dec         -16.4922
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.1127  -0.9209  -0.3732]
        Angle    144.4072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1338"
}

Galaxy "IC 1339:ESO 598-8:MCG 3-53-13:IRAS 20550-1808"
{
        Type  "SBb"
        RA           20.9653
        Dec         -17.9422
        Distance   3.706e+08  # method: V
        Radius     7.546e+04
        AbsMag        -21.08
        Axis    [ -0.1867  -0.9450  -0.2685]
        Angle    138.9731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1339"
}

Galaxy "IC 1341:MCG 2-53-16:NPM 1"
{
        Type  "S0"
        RA           21.0044
        Dec         -13.9758
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.2494  -0.9618  -0.1133]
        Angle    135.2509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1341"
}

Galaxy "IC 1342:MCG 3-53-17:IRAS 20576-1441"
{
        Type  "Sc"
        RA           21.0069
        Dec         -14.4950
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [ -0.1336  -0.9909  -0.0128]
        Angle    133.0299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1342"
}

Galaxy "IC 1343:NPM 1"
{
        Type  "S0"
        RA           21.0167
        Dec         -15.4036
        Distance   2.934e+08  # distance uncertain!
        Radius     4.267e+04
        AbsMag        -19.07
        Axis    [ -0.4578  -0.5315   0.7127]
        Angle    132.1790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1343"
}

Galaxy "IC 1344:MCG 2-53-18"
{
        Type  "S0"
        RA           21.0211
        Dec         -13.3803
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [ -0.0506  -0.9752  -0.2155]
        Angle    138.4721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1344"
}

Galaxy "IC 1345:NPM 1"
{
        Type  "E0"
        RA           21.0228
        Dec         -13.3975
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [ -0.3499  -0.7178  -0.6019]
        Angle    199.8632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1345"
}

Galaxy "IC 1346:MCG 2-53-19"
{
        Type  "SBb"
        RA           21.0269
        Dec         -13.9603
        Distance   2.676e+08  # distance uncertain!
        Radius      4.67e+04
        AbsMag        -19.07
        Axis    [ -0.2922  -0.9425   0.1625]
        Angle    129.3645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1346"
}

Galaxy "IC 1347:MCG 2-53-20:NPM 1"
{
        Type  "S0"
        RA           21.0289
        Dec         -13.3128
        Distance   3.827e+08  # method: V
        Radius     4.453e+04
        AbsMag        -20.05
        Axis    [ -0.1209  -0.8463  -0.5187]
        Angle    162.8028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1347"
}

Galaxy "IC 1348:NPM 1"
{
        Type  "S0"
        RA           21.0286
        Dec         -13.3569
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.4114  -0.7254   0.5519]
        Angle    127.6693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1348"
}

Galaxy "IC 1349:NPM 1"
{
        Type  "S0"
        RA           21.0306
        Dec         -13.2650
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.0955  -0.9588  -0.2676]
        Angle    141.4968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1349"
}

Galaxy "IC 1350:IC 1354:MCG 2-53-21:NPM 1"
{
        Type  "S0"
        RA           21.0311
        Dec         -13.8522
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.4753  -0.5658   0.6738]
        Angle    126.7894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1350"
}

Galaxy "IC 1351:NPM 1"
{
        Type  "S0"
        RA           21.0311
        Dec         -13.2014
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.0741  -0.8809  -0.4675]
        Angle    148.7394
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1351"
}

Galaxy "IC 1352"
{
        Type  "S0"
        RA           21.0317
        Dec         -13.3844
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.1444  -0.8386  -0.5253]
        Angle    149.5113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1352"
}

Galaxy "IC 1353"
{
        Type  "S0"
        RA           21.0322
        Dec         -13.2725
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.3505  -0.9365   0.0120]
        Angle    130.8777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1353"
}

Galaxy "IC 1355:NPM 1"
{
        Type  "E0"
        RA           21.0328
        Dec         -13.1725
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [ -0.3508  -0.7188  -0.6003]
        Angle    200.0050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1355"
}

Galaxy "IC 1356:MCG 3-53-22"
{
        Type  "E0"
        RA           21.0481
        Dec         -15.8119
        Distance   5.755e+08  # distance uncertain!
        Radius     9.207e+04
        AbsMag        -20.13
        Axis    [ -0.8647  -0.3216   0.3859]
        Angle     95.5165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1356"
}

Galaxy "IC 1357:NPM 1"
{
        Type  "Sa"
        RA           21.0992
        Dec         -10.7158
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [ -0.0657  -0.9372  -0.3426]
        Angle    148.0110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1357"
}

Galaxy "IC 1358"
{
        Type  "S0"
        RA           21.1081
        Dec         -16.2036
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.1028  -0.9433  -0.3156]
        Angle    142.7638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1358"
}

Galaxy "IC 1359:UGC 11684:MCG 2-54-1:ZWG 426.4"
{
        Type  "S0"
        RA           21.1453
        Dec          12.4839
        Distance   1.948e+08  # method: V
        Radius       3.4e+04
        AbsMag        -18.98
        Axis    [ -0.1731  -0.5532   0.8148]
        Angle    126.8288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1359"
}

Galaxy "IC 1360:ZWG 401.3"
{
        Type  "S0"
        RA           21.1806
        Dec           5.0717
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.1401  -0.9100  -0.3902]
        Angle    162.3818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1360"
}

Galaxy "IC 1361:UGC 11692:MCG 1-54-2:ZWG 401.5"
{
        Type  "S0"
        RA           21.1914
        Dec           5.0547
        Distance   1.676e+08  # method: V
        Radius     2.193e+04
        AbsMag        -18.45
        Axis    [ -0.0733  -0.9671  -0.2437]
        Angle    155.9600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1361"
}

Galaxy "IC 1362:ZWG 375.7:KARA 898:NPM 1"
{
        Type  "E0"
        RA           21.1978
        Dec           2.3294
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [ -0.3444  -0.7952  -0.4991]
        Angle    206.5831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1362"
}

Galaxy "IC 1364:MCG 0-54-6:ZWG 375.13:ZW 107"
{
        Type  "E0"
        RA           21.2233
        Dec           2.7703
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [ -0.7264  -0.6753   0.1274]
        Angle    105.7515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1364"
}

Galaxy "IC 1365:MCG 0-54-7:ZWG 375.15:ZW 108"
{
        Type  "E0"
        RA           21.2322
        Dec           2.5653
        Distance    3.02e+08  # distance uncertain!
        Radius     4.832e+04
        AbsMag        -20.13
        Axis    [ -0.5350  -0.8016  -0.2669]
        Angle    161.0894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1365"
}

Galaxy "IC 1366:ZWG 375.17:NPM 1"
{
        Type  "S0"
        RA           21.2353
        Dec           1.7767
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.1028  -0.8737  -0.4755]
        Angle    167.5275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1366"
}

Galaxy "IC 1367:ZWG 375.19:NPM 1"
{
        Type  "S0"
        RA           21.2358
        Dec           2.9944
        Distance    2.03e+08  # distance uncertain!
        Radius          8856
        AbsMag        -19.07
        Axis    [ -0.3419  -0.7994   0.4940]
        Angle    118.2187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1367"
}

Galaxy "IC 1368:UGC 11703:MCG 0-54-8:ZWG 375.18"
{
        Type  "Sa"
        RA           21.2367
        Dec           2.1783
        Distance   1.636e+08  # method: V
        Radius     2.856e+04
        AbsMag         -19.2
        Axis    [  0.1059  -0.9776  -0.1821]
        Angle    148.6462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1368"
}

Galaxy "IC 1370:ZWG 375.21:ZW 111"
{
        Type  "Irr"
        RA           21.2539
        Dec           2.1922
        Distance   3.163e+08  # distance uncertain!
        Radius      7.36e+04
        AbsMag        -20.13
        Axis    [ -0.1228  -0.8512   0.5103]
        Angle    133.1135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1370"
}

Galaxy "IC 1371:MCG 1-54-13:NPM 1"
{
        Type  "S0"
        RA           21.3375
        Dec          -4.8761
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.1226  -0.8639  -0.4885]
        Angle    172.7000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1371"
}

Galaxy "IC 1372"
{
        Type  "S0"
        RA           21.3381
        Dec          -5.6047
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.3154  -0.7961   0.5164]
        Angle    128.8283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1372"
}

Galaxy "IC 1373:MCG 0-54-13:ZWG 375.29:NPM 1"
{
        Type  "S0"
        RA           21.3436
        Dec           1.0931
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [ -0.3406  -0.7908  -0.5086]
        Angle    205.7756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1373"
}

Galaxy "IC 1374:ZWG 375.31:KARA 908:NPM 1"
{
        Type  "S0"
        RA           21.3506
        Dec           1.7136
        Distance   3.217e+08  # distance uncertain!
        Radius     1.404e+04
        AbsMag        -19.07
        Axis    [ -0.2341  -0.9684   0.0859]
        Angle    135.9032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1374"
}

Galaxy "IC 1375:ZWG 401.15:NPM 1"
{
        Type  "E0"
        RA           21.3497
        Dec           3.9858
        Distance    3.02e+08  # distance uncertain!
        Radius     4.393e+04
        AbsMag        -20.13
        Axis    [ -0.7286  -0.6549   0.2006]
        Angle    101.2378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1375"
}

Galaxy "IC 1377:MCG 1-54-9:ZWG 401.21:KARA 915"
{
        Type  "Sc"
        RA           21.4239
        Dec           4.3142
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.4472  -0.8568   0.2566]
        Angle    119.9671
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1377"
}

Galaxy "IC 1379:ZWG 375.34"
{
        Type  "E0"
        RA           21.4336
        Dec           3.0972
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [ -0.3682  -0.7908  -0.4890]
        Angle    208.7353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1379"
}

Galaxy "IC 1380:ZWG 375.35:NPM 1"
{
        Type  "E0"
        RA           21.4528
        Dec           2.7181
        Distance   3.981e+08  # distance uncertain!
        Radius     1.737e+04
        AbsMag        -20.13
        Axis    [ -0.3709  -0.7882  -0.4910]
        Angle    208.7474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1380"
}

Galaxy "IC 1381:MCG 0-54-16:ZWG 375.36:NPM 1"
{
        Type  "SBa"
        RA           21.4592
        Dec          -1.1881
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.1421  -0.9751  -0.1701]
        Angle    150.4221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1381"
}

Galaxy "IC 1383:ZWG 375.37"
{
        Type  "S0"
        RA           21.4608
        Dec          -1.1022
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.2718  -0.8012   0.5331]
        Angle    129.1563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1383"
}

Galaxy "IC 1384:MCG 0-54-17:ZWG 375.39"
{
        Type  "Irr"
        RA           21.4647
        Dec          -1.3686
        Distance   5.496e+08  # distance uncertain!
        Radius     5.595e+04
        AbsMag        -20.13
        Axis    [ -0.0297  -0.8314  -0.5549]
        Angle    180.9777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1384"
}

Galaxy "IC 1385:MCG 0-54-22:ZWG 375.42"
{
        Type  "SBa"
        RA           21.4808
        Dec          -1.0697
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.3597  -0.7754  -0.5191]
        Angle    205.9889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1385"
}

Galaxy "IC 1386:ESO 599-16:MCG 4-50-30"
{
        Type  "S0"
        RA           21.4936
        Dec         -21.1956
        Distance    4.71e+08  # method: V
        Radius     1.028e+05
        AbsMag         -21.7
        Axis    [ -0.5587  -0.7588   0.3348]
        Angle    129.1558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1386"
}

Galaxy "IC 1387:MCG 0-54-26:ZWG 375.45:ARAK 547"
{
        Type  "E0"
        RA           21.4928
        Dec          -1.3506
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [ -0.4057  -0.7711  -0.4908]
        Angle    202.9090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1387"
}

Galaxy "IC 1388:MCG 0-54-27:ZWG 375.46:ARAK 548"
{
        Type  "S0"
        RA           21.4978
        Dec          -0.6308
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [ -0.2566  -0.8289   0.4971]
        Angle    130.0695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1388"
}

Galaxy "IC 1389:ESO 599-18:MCG 3-55-1"
{
        Type  "S0"
        RA           21.5356
        Dec         -18.0192
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.5054  -0.8197   0.2696]
        Angle    130.6205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1389"
}

Galaxy "IC 1390:MCG 0-55-4:ZWG 376.5"
{
        Type  "SBc"
        RA           21.5400
        Dec          -1.8619
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.5196  -0.6127   0.5955]
        Angle    109.9582
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1390"
}

Galaxy "IC 1391:MCG 0-55-7:ZWG 376.10"
{
        Type  "E0"
        RA           21.5833
        Dec          -0.5114
        Distance   4.787e+08  # distance uncertain!
        Radius     1.392e+04
        AbsMag        -20.13
        Axis    [ -0.3911  -0.7672  -0.5085]
        Angle    208.5250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1391"
}

Galaxy "IC 1392:UGC 11772:MCG 6-47-3:ZWG 512.6"
{
        Type  "S0"
        RA           21.5922
        Dec          35.3986
        Distance   1.851e+08  # method: V
        Radius     2.962e+04
        AbsMag        -20.77
        Axis    [  0.0851  -0.9913   0.1004]
        Angle    154.1637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1392"
}

Galaxy "IC 1393:ESO 531-20:MCG 4-51-8:NPM 1"
{
        Type  "S0"
        RA           21.6706
        Dec         -22.4111
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.5253  -0.5087   0.6821]
        Angle    134.8962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1393"
}

Galaxy "IC 1394:MCG 2-55-6:ZWG 427.11:NPM 1"
{
        Type  "E0"
        RA           21.6700
        Dec          14.6336
        Distance   3.802e+08  # distance uncertain!
        Radius      5.53e+04
        AbsMag        -20.13
        Axis    [ -0.6469  -0.5235   0.5546]
        Angle     75.7857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1394"
}

Galaxy "IC 1395:ZWG 402.15:NPM 1"
{
        Type  "E0"
        RA           21.6947
        Dec           4.1050
        Distance   4.169e+08  # distance uncertain!
        Radius     1.819e+04
        AbsMag        -20.13
        Axis    [ -0.3939  -0.7860  -0.4765]
        Angle    211.2004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1395"
}

Galaxy "IC 1397:NPM 1"
{
        Type  "S0"
        RA           21.7339
        Dec          -4.8844
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.0830  -0.8223  -0.5629]
        Angle    168.5570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1397"
}

Galaxy "IC 1398:MCG 1-55-9:ZWG 402.17"
{
        Type  "Sc"
        RA           21.7642
        Dec           9.4756
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.0182  -0.9949   0.0990]
        Angle    147.9791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1398"
}

Galaxy "IC 1399:ZWG 402.19:NPM 1"
{
        Type  "E0"
        RA           21.7689
        Dec           4.4028
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [ -0.4011  -0.7845  -0.4729]
        Angle    211.9102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1399"
}

Galaxy "IC 1401:UGC 11810:MCG 0-55-15:ZWG 376.31"
{
        Type  "Sc"
        RA           21.7831
        Dec           1.7114
        Distance   2.758e+08  # method: T-F
        Radius      7.22e+04
        AbsMag        -20.24
        Axis    [ -0.2304  -0.5703   0.7885]
        Angle    137.1885
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1401"
}

Galaxy "IC 1403:NPM 1"
{
        Type  "S0"
        RA           21.8414
        Dec          -2.7156
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [ -0.3436  -0.6652   0.6629]
        Angle    129.0309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1403"
}

Galaxy "IC 1404"
{
        Type  "E0"
        RA           21.8489
        Dec          -9.2661
        Distance   3.468e+08  # distance uncertain!
        Radius     4.035e+04
        AbsMag        -20.13
        Axis    [ -0.4355  -0.7102  -0.5531]
        Angle    206.7648
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1404"
}

Galaxy "IC 1405:UGC 11826:MCG 0-55-20:ZWG 376.37"
{
        Type  "SBb"
        RA           21.8469
        Dec           2.0214
        Distance   3.201e+08  # method: V
        Radius     4.191e+04
        AbsMag        -20.16
        Axis    [ -0.3703  -0.8859   0.2792]
        Angle    131.0496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1405"
}

Galaxy "IC 1406:ZWG 376.38:NPM 1"
{
        Type  "E0"
        RA           21.8511
        Dec           1.9875
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [ -0.4148  -0.7692  -0.4860]
        Angle    211.5688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1406"
}

Galaxy "IC 1407-1:ZWG 376.48:ZW 152"
{
        Type  "E0"
        RA           21.8731
        Dec           3.4267
        Distance   3.631e+08  # distance uncertain!
        Radius     2.112e+04
        AbsMag        -20.13
        Axis    [ -0.4141  -0.7755  -0.4765]
        Angle    212.3356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1407-1"
}

Galaxy "IC 1407-2:ZWG 376.48:ZW 152"
{
        Type  "E0"
        RA           21.8728
        Dec           3.4286
        Distance   1.148e+09  # distance uncertain!
        Radius      3.34e+04
        AbsMag        -20.13
        Axis    [ -0.4141  -0.7755  -0.4765]
        Angle    212.3342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1407-2"
}

Galaxy "IC 1408:MCG 2-55-7:NPM 1"
{
        Type  "S0"
        RA           21.8856
        Dec         -13.3464
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.0519  -0.9334  -0.3550]
        Angle    153.5276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1408"
}

Galaxy "IC 1409"
{
        Type  "S0"
        RA           21.8886
        Dec          -7.4997
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.0947  -0.8892  -0.4477]
        Angle    166.9834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1409"
}

Galaxy "IC 1410:NPM 1"
{
        Type  "E0"
        RA           21.9339
        Dec          -2.8997
        Distance   5.249e+08  # distance uncertain!
        Radius     3.817e+04
        AbsMag        -20.13
        Axis    [ -0.7432  -0.6381   0.2014]
        Angle    114.8395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1410"
}

Galaxy "IC 1411:UGC 11850:MCG 0-56-1:ZWG 377.1"
{
        Type  "E0"
        RA           21.9333
        Dec          -1.5167
        Distance   3.481e+08  # method: V
        Radius     4.557e+04
        AbsMag        -20.94
        Axis    [ -0.5313  -0.7672  -0.3592]
        Angle    187.1517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1411"
}

Galaxy "IC 1412:MCG 3-56-1:IRAS 21555-1724"
{
        Type  "SBa"
        RA           21.9717
        Dec         -17.1767
        Distance   2.373e+08  # method: V
        Radius     3.106e+04
        AbsMag        -19.91
        Axis    [ -0.2912  -0.9387   0.1844]
        Angle    143.5862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1412"
}

Galaxy "IC 1413-1"
{
        Type  "S0"
        RA           21.9736
        Dec          -3.1247
        Distance   4.241e+08  # distance uncertain!
        Radius     5.551e+04
        AbsMag        -19.07
        Axis    [  0.1063  -0.9744  -0.1980]
        Angle    153.7529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1413-1"
}

Galaxy "IC 1413-2"
{
        Type  "S0"
        RA           21.9739
        Dec          -3.1017
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.0103  -0.9996   0.0279]
        Angle    150.1189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1413-2"
}

Galaxy "IC 1414:MCG 1-56-5:ZWG 403.8:ZW 157"
{
        Type  "S0"
        RA           21.9717
        Dec           8.4239
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [ -0.3911  -0.8034  -0.4489]
        Angle    213.8631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1414"
}

Galaxy "IC 1417:MCG 2-56-3:IRAS 21576-1323"
{
        Type  "Sb"
        RA           22.0058
        Dec         -13.1469
        Distance   1.688e+08  # distance uncertain!
        Radius     3.192e+04
        AbsMag        -19.07
        Axis    [ -0.1916  -0.9349   0.2987]
        Angle    146.3373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1417"
}

Galaxy "IC 1418:MCG 1-56-9:ZWG 403.16"
{
        Type  "S0"
        RA           22.0331
        Dec           4.3847
        Distance   3.615e+08  # method: V
        Radius     4.732e+04
        AbsMag        -20.12
        Axis    [ -0.1119  -0.8436  -0.5252]
        Angle    192.5093
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1418"
}

Galaxy "IC 1419:NPM 1"
{
        Type  "S0"
        RA           22.0494
        Dec          -9.9206
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.3408  -0.5932   0.7294]
        Angle    140.5145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1419"
}

Galaxy "IC 1420:UGC 11880:MCG 3-56-5:ZWG 451.4"
{
        Type  "SBa"
        RA           22.0419
        Dec          19.7500
        Distance   5.894e+07  # method: V
        Radius     1.029e+04
        AbsMag        -17.08
        Axis    [ -0.0988  -0.9818   0.1622]
        Angle    148.0127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1420"
}

Galaxy "IC 1421:MCG 2-56-9:NPM 1"
{
        Type  "E0"
        RA           22.0508
        Dec          -9.9778
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [ -0.6585  -0.7126  -0.2421]
        Angle    164.9385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1421"
}

Galaxy "IC 1422:ZWG 377.16:NPM 1"
{
        Type  "S0"
        RA           22.0500
        Dec           2.5994
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.2112  -0.8295   0.5171]
        Angle    137.2599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1422"
}

Galaxy "IC 1423:UGC 11883:MCG 1-56-10:ZWG 403.18"
{
        Type  "SBb"
        RA           22.0533
        Dec           4.2981
        Distance   3.548e+08  # method: V
        Radius      5.16e+04
        AbsMag        -20.38
        Axis    [ -0.0182  -0.9578  -0.2869]
        Angle    166.9710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1423"
}

Galaxy "IC 1425:ZWG 377.18:NPM 1"
{
        Type  "S0"
        RA           22.0567
        Dec           2.5953
        Distance   1.768e+08  # distance uncertain!
        Radius     1.286e+04
        AbsMag        -19.07
        Axis    [ -0.3607  -0.9180   0.1650]
        Angle    139.8750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1425"
}

Galaxy "IC 1427:UGC 11889:MCG 2-56-10:ZWG 428.25"
{
        Type  "E0"
        RA           22.0597
        Dec          15.1072
        Distance   3.981e+08  # distance uncertain!
        Radius     5.791e+04
        AbsMag        -20.13
        Axis    [ -0.5827  -0.8084   0.0839]
        Angle    131.0329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1427"
}

Galaxy "IC 1428:ZWG 377.21"
{
        Type  "S0"
        RA           22.0742
        Dec           2.6311
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.0610  -0.9825  -0.1763]
        Angle    160.7849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1428"
}

Galaxy "IC 1430"
{
        Type  "E0"
        RA           22.1247
        Dec         -13.5808
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.4727  -0.6744  -0.5673]
        Angle    206.5114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1430"
}

Galaxy "IC 1431:MCG 2-56-15"
{
        Type  "Sa"
        RA           22.1275
        Dec         -13.5133
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.5832  -0.6322   0.5100]
        Angle    124.3331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1431"
}

Galaxy "IC 1432:NPM 1"
{
        Type  "S0"
        RA           22.1675
        Dec           3.6900
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [ -0.0810  -0.8796  -0.4688]
        Angle    183.3836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1432"
}

Galaxy "IC 1433:MCG 2-56-21:VV 390:NPM 1"
{
        Type  "Irr"
        RA           22.2028
        Dec         -12.7650
        Distance   4.787e+08  # distance uncertain!
        Radius     4.873e+04
        AbsMag        -20.13
        Axis    [ -0.4426  -0.8607   0.2517]
        Angle    140.3034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1433"
}

Galaxy "IC 1435:ESO 601-30:MCG 4-52-25:AM 2210-222"
{
        Type  "Sc"
        RA           22.2239
        Dec         -22.0964
        Distance   1.281e+08  # distance uncertain!
        Radius     1.863e+04
        AbsMag        -19.07
        Axis    [ -0.1626  -0.8053  -0.5701]
        Angle    164.6416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1435"
}

Galaxy "IC 1436:MCG 2-56-24:NPM 1"
{
        Type  "S0"
        RA           22.2308
        Dec         -10.1914
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.4405  -0.8832  -0.1608]
        Angle    157.8122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1436"
}

Galaxy "IC 1437:UGC 11965:MCG 0-56-16:ZWG 377.42"
{
        Type  "Sa"
        RA           22.2622
        Dec           2.0658
        Distance    3.88e+08  # method: V
        Radius     6.208e+04
        AbsMag        -20.78
        Axis    [ -0.4260  -0.9025  -0.0633]
        Angle    156.7585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1437"
}

Galaxy "IC 1438:ESO 602-1:MCG 4-52-29:IRAS 22137-2140"
{
        Type  "SBa"
        RA           22.2747
        Dec         -21.4308
        Distance   1.046e+08  # method: V
        Radius      3.65e+04
        AbsMag        -19.93
        Axis    [ -0.3082  -0.7291  -0.6110]
        Angle    182.5680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1438"
}

Galaxy "IC 1439:ESO 602-2:MCG 4-52-30"
{
        Type  "SBa"
        RA           22.2778
        Dec         -21.4856
        Distance   4.225e+08  # method: V
        Radius     7.988e+04
        AbsMag        -20.86
        Axis    [ -0.3074  -0.8637  -0.3994]
        Angle    161.4574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1439"
}

Galaxy "IC 1440:MCG 3-56-13"
{
        Type  "E0"
        RA           22.2758
        Dec         -16.0164
        Distance   4.366e+08  # distance uncertain!
        Radius     7.619e+04
        AbsMag        -20.13
        Axis    [ -0.7440  -0.6542  -0.1359]
        Angle    154.0458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1440"
}

Galaxy "IC 1441:MCG 6-48-23:ZWG 513.21:ZWG 514.1"
{
        Type  "SBa"
        RA           22.2553
        Dec          37.3008
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.2162  -0.9535  -0.2101]
        Angle    189.6772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1441"
}

Galaxy "IC 1443:ESO 602-5:MCG 4-52-33"
{
        Type  "E2"
        RA           22.3175
        Dec         -20.9400
        Distance   1.738e+08  # distance uncertain!
        Radius     2.022e+04
        AbsMag        -20.13
        Axis    [ -0.6500  -0.6444  -0.4029]
        Angle    181.0256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1443"
}

Galaxy "IC 1444:ZWG 404.5:NPM 1"
{
        Type  "E0"
        RA           22.3731
        Dec           5.1397
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [ -0.4630  -0.7621  -0.4527]
        Angle    216.9926
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1444"
}

Galaxy "IC 1445:ESO 602-19:MCG 3-57-7"
{
        Type  "S0"
        RA           22.4250
        Dec         -17.2436
        Distance   1.039e+08  # method: V
        Radius     2.417e+04
        AbsMag        -18.91
        Axis    [ -0.5016  -0.8647  -0.0267]
        Angle    151.1862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1445"
}

Galaxy "IC 1446:NPM 1"
{
        Type  "S0"
        RA           22.4844
        Dec          -1.1842
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [ -0.0508  -0.8926  -0.4479]
        Angle    175.3087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1446"
}

Galaxy "IC 1447:MCG 1-57-14:IRAS 22273-0522"
{
        Type  "Sb"
        RA           22.4997
        Dec          -5.1194
        Distance   1.186e+08  # method: V
        Radius     2.588e+04
        AbsMag         -19.2
        Axis    [ -0.2603  -0.9198   0.2935]
        Angle    148.5373
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1447"
}

Galaxy "IC 1449"
{
        Type  "S0"
        RA           22.5853
        Dec          -8.7656
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.3642  -0.8939  -0.2612]
        Angle    169.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1449"
}

Galaxy "IC 1451:MCG 2-58-2"
{
        Type  "Sc"
        RA           22.7686
        Dec         -10.3703
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [ -0.5168  -0.6721  -0.5303]
        Angle    210.3699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1451"
}

Galaxy "IC 1452:NGC 7374B:MCG 2-58-6:ZWG 430.5"
{
        Type  "S0"
        RA           22.7664
        Dec          10.8681
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.1281  -0.6921   0.7104]
        Angle    140.7312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1452"
}

Galaxy "IC 1453:MCG 2-58-4"
{
        Type  "SBb"
        RA           22.7817
        Dec         -13.4494
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.5205  -0.6046   0.6030]
        Angle    131.9699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1453"
}

Galaxy "IC 1455:UGC 12232:MCG 0-58-11:ZWG 379.14"
{
        Type  "SBa"
        RA           22.8961
        Dec           1.3725
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [ -0.2029  -0.9239  -0.3244]
        Angle    180.5570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1455"
}

Galaxy "IC 1456"
{
        Type  "S0"
        RA           22.9217
        Dec         -12.7319
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.1895  -0.8863   0.4226]
        Angle    160.8213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1456"
}

Galaxy "IC 1459:IC 5265:ESO 406-30:MCG 6-50-16"
{
        Type  "E3"
        RA           22.9528
        Dec         -36.4625
        Distance   9.538e+07  # method: S
        Radius     7.213e+04
        AbsMag        -21.33
        Axis    [ -0.7616  -0.5199  -0.3869]
        Angle    177.4400
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1459"
}

Galaxy "IC 1460:MCG 1-58-15:MK 923:ZWG 405.17"
{
        Type  "E2"
        RA           22.9511
        Dec           4.6775
        Distance   3.146e+08  # method: V
        Radius     2.288e+04
        AbsMag        -19.52
        Axis    [ -0.5242  -0.7304  -0.4379]
        Angle    221.1673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1460"
}

Galaxy "IC 1461:ZWG 430.36:MK 311:KUG 2256+149"
{
        Type  "S0"
        RA           22.9761
        Dec          15.1733
        Distance   4.003e+08  # method: V
        Radius     3.493e+04
        AbsMag        -20.34
        Axis    [ -0.1671  -0.7967   0.5808]
        Angle    138.3577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1461"
}

Galaxy "IC 1464-1:IC 1464A:MCG 2-58-20:NPM 1"
{
        Type  "S0"
        RA           23.0531
        Dec          -8.9886
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.1893  -0.8674  -0.4602]
        Angle    177.6440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1464-1"
}

Galaxy "IC 1464-2:IC 1464B:MCG 2-58-21:NPM 1"
{
        Type  "S0"
        RA           23.0533
        Dec          -8.9922
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [ -0.2657  -0.9366  -0.2282]
        Angle    170.1509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1464-2"
}

Galaxy "IC 1466"
{
        Type  "S0"
        RA           23.0608
        Dec          -2.7756
        Distance   1.612e+08  # distance uncertain!
        Radius     1.172e+04
        AbsMag        -19.07
        Axis    [ -0.4121  -0.7941   0.4468]
        Angle    142.2632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1466"
}

Galaxy "IC 1467:MCG 1-58-17:IRAS 23022-0329"
{
        Type  "Sc"
        RA           23.0803
        Dec          -3.2311
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.0374  -0.8541  -0.5188]
        Angle    177.5465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1467"
}

Galaxy "IC 1468:MCG 1-58-19"
{
        Type  "Sa"
        RA           23.0853
        Dec          -3.2053
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.2062  -0.7008   0.6829]
        Angle    153.4156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1468"
}

Galaxy "IC 1469"
{
        Type  "E0"
        RA           23.1078
        Dec         -13.5364
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [ -0.7658  -0.6430   0.0026]
        Angle    156.7158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1469"
}

Galaxy "IC 1471:MCG 2-59-3"
{
        Type  "S0"
        RA           23.1458
        Dec         -12.6392
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.2908  -0.6214   0.7275]
        Angle    155.6991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1471"
}

Galaxy "IC 1472:MCG 3-59-4:ZWG 454.2:NPM 1"
{
        Type  "Sa"
        RA           23.1517
        Dec          17.2597
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [ -0.0324  -0.9971  -0.0694]
        Angle    178.7003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1472"
}

Galaxy "IC 1473:UGC 12404:MCG 5-54-43:ZWG 496.52"
{
        Type  "S0"
        RA           23.1847
        Dec          29.6431
        Distance   1.626e+07  # method: V
        Radius          4967
        AbsMag        -14.59
        Axis    [  0.0578  -0.5990   0.7986]
        Angle    135.7854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1473"
}

Galaxy "IC 1474:UGC 12417:MCG 1-59-11:ZWG 406.18"
{
        Type  "Sc"
        RA           23.2142
        Dec           5.8058
        Distance   1.995e+08  # method: T-F
        Radius     3.192e+04
        AbsMag        -19.13
        Axis    [ -0.1266  -0.7490   0.6503]
        Angle    152.7116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1474"
}

Galaxy "IC 1476:MCG 5-54-51:ZWG 496.60:NPM 1"
{
        Type  "S0"
        RA           23.2378
        Dec          30.5519
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.4523  -0.8452  -0.2847]
        Angle    235.8341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1476"
}

Galaxy "IC 1479:MCG 2-59-10:NPM 1"
{
        Type  "S0"
        RA           23.3128
        Dec         -10.3986
        Distance   4.317e+08  # method: V
        Radius     6.906e+04
        AbsMag        -20.91
        Axis    [ -0.4607  -0.7799  -0.4238]
        Angle    191.9915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1479"
}

Galaxy "IC 1481:UGC 12505:ZWG 406.64:IRAS 23168+0537"
{
        Type  "S0"
        RA           23.3236
        Dec           5.9058
        Distance   2.608e+08  # method: V
        Radius     3.035e+04
        AbsMag        -20.01
        Axis    [ -0.3862  -0.9000  -0.2021]
        Angle    187.2058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1481"
}

Galaxy "IC 1482:MCG 0-59-29:ZWG 380.37:NPM 1"
{
        Type  "E0"
        RA           23.3469
        Dec           1.7394
        Distance   4.169e+08  # distance uncertain!
        Radius     3.638e+04
        AbsMag        -20.13
        Axis    [ -0.6690  -0.6813   0.2970]
        Angle    133.4739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1482"
}

Galaxy "IC 1484:NPM 1"
{
        Type  "S0"
        RA           23.3775
        Dec          11.3850
        Distance   7.717e+08  # distance uncertain!
        Radius     4.489e+04
        AbsMag        -19.07
        Axis    [ -0.0860  -0.9806  -0.1759]
        Angle    183.1117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1484"
}

Galaxy "IC 1488"
{
        Type  "S0"
        RA           23.4272
        Dec          15.3539
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.0688  -0.6128   0.7873]
        Angle    163.1290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1488"
}

Galaxy "IC 1489:MCG 2-59-16:IRAS 23239-1247"
{
        Type  "S0"
        RA           23.4422
        Dec         -12.5164
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [ -0.2348  -0.9111  -0.3388]
        Angle    173.7086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1489"
}

Galaxy "IC 1491:MCG 3-59-10"
{
        Type  "S0"
        RA           23.4900
        Dec         -16.3161
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [ -0.3489  -0.6327   0.6913]
        Angle    156.6758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1491"
}

Galaxy "IC 1492:MCG 1-59-28:NPM 1"
{
        Type  "Sa"
        RA           23.5100
        Dec          -3.0394
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [ -0.3835  -0.8836  -0.2686]
        Angle    185.6987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1492"
}

Galaxy "IC 1494:NPM 1"
{
        Type  "S0"
        RA           23.5128
        Dec         -12.7242
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [ -0.2514  -0.8676   0.4289]
        Angle    165.7669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1494"
}

Galaxy "IC 1495:IC 5327:MCG 2-59-24:IRAS 23281-1345"
{
        Type  "Sb"
        RA           23.5131
        Dec         -13.4853
        Distance   2.734e+08  # method: V
        Radius     5.568e+04
        AbsMag        -20.52
        Axis    [ -0.3574  -0.5539   0.7520]
        Angle    148.2387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1495"
}

Galaxy "IC 1496:MCG 1-59-29:NPM 1"
{
        Type  "Sa"
        RA           23.5147
        Dec          -2.9339
        Distance   2.178e+08  # method: V
        Radius     5.385e+04
        AbsMag        -19.82
        Axis    [ -0.4409  -0.8903   0.1139]
        Angle    165.0694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1496"
}

Galaxy "IC 1498:MCG 1-60-2"
{
        Type  "Sa"
        RA           23.5314
        Dec          -5.0064
        Distance   2.182e+08  # method: V
        Radius     6.029e+04
        AbsMag        -19.53
        Axis    [ -0.0675  -0.8789  -0.4722]
        Angle    177.0878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1498"
}

Galaxy "IC 1500:ZWG 407.6"
{
        Type  "S0"
        RA           23.5525
        Dec           4.5525
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [ -0.1781  -0.8714  -0.4571]
        Angle    194.4575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1500"
}

Galaxy "IC 1501:MCG 1-60-9:IRAS 23320-0325"
{
        Type  "SBc"
        RA           23.5778
        Dec          -3.1536
        Distance   2.179e+08  # method: V
        Radius     5.071e+04
        AbsMag        -19.52
        Axis    [ -0.1846  -0.8106   0.5558]
        Angle    162.9257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1501"
}

Galaxy "IC 1502:UGC 12706:UGC 12105:MCG 13-1-2"
{
        Type  "Sa"
        RA           23.6056
        Dec          75.6475
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.5125  -0.8571  -0.0513]
        Angle    212.7434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1502"
}

Galaxy "IC 1503:UGC 12715:MCG 1-60-16:ZWG 407.31"
{
        Type  "Irr"
        RA           23.6408
        Dec           4.8014
        Distance    2.62e+08  # method: V
        Radius     3.429e+04
        AbsMag        -20.12
        Axis    [ -0.1245  -0.9921  -0.0161]
        Angle    177.3499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1503"
}

Galaxy "IC 1504:UGC 12734:MCG 1-60-20:ZWG 407.41"
{
        Type  "Sb"
        RA           23.6886
        Dec           4.0183
        Distance   2.695e+08  # method: V
        Radius     6.662e+04
        AbsMag        -20.18
        Axis    [ -0.0409  -0.9712   0.2348]
        Angle    173.7776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1504"
}

Galaxy "IC 1505:MCG 1-60-20:NPM 1"
{
        Type  "E0"
        RA           23.6936
        Dec          -3.5647
        Distance   3.163e+08  # distance uncertain!
        Radius      4.14e+04
        AbsMag        -20.13
        Axis    [ -0.6219  -0.5501   0.5573]
        Angle    118.0438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1505"
}

Galaxy "IC 1506:MCG 1-60-29:ZWG 407.52:NPM 1"
{
        Type  "S0"
        RA           23.7467
        Dec           4.7361
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.1843  -0.8197   0.5423]
        Angle    158.6696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1506"
}

Galaxy "IC 1507:UGC 12770:MCG 0-60-44:ZWG 381.41"
{
        Type  "Sa"
        RA           23.7592
        Dec           1.6892
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.1118  -0.8289   0.5481]
        Angle    166.9788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1507"
}

Galaxy "IC 1508:UGC 12773:MCG 2-60-16:ZWG 432.28"
{
        Type  "Irr"
        RA           23.7653
        Dec          12.0611
        Distance   1.769e+08  # method: V
        Radius     5.147e+04
        AbsMag        -19.77
        Axis    [  0.0478  -0.6342   0.7717]
        Angle    166.8783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1508"
}

Galaxy "IC 1509:MCG 3-60-14"
{
        Type  "Sc"
        RA           23.7878
        Dec         -15.3072
        Distance   3.217e+08  # distance uncertain!
        Radius      6.55e+04
        AbsMag        -19.07
        Axis    [ -0.0634  -0.8853  -0.4607]
        Angle    166.1603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1509"
}

Galaxy "IC 1510-1:MCG 0-60-53:ZWG 381.53:VV 641"
{
        Type  "S0"
        RA           23.8422
        Dec           2.0747
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.3427  -0.6759   0.6525]
        Angle    139.1089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1510-1"
}

Galaxy "IC 1510-2:MCG 0-60-53:ZWG 381.53:VV 641"
{
        Type  "S0"
        RA           23.8425
        Dec           2.0722
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.2979  -0.9543   0.0248]
        Angle    177.5300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1510-2"
}

Galaxy "IC 1513:UGC 12832:MCG 2-60-24:ZWG 432.39"
{
        Type  "Sc"
        RA           23.8914
        Dec          11.3178
        Distance   2.727e+08  # method: V
        Radius     3.966e+04
        AbsMag        -19.51
        Axis    [  0.0160  -0.9391   0.3434]
        Angle    175.5048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1513"
}

Galaxy "IC 1515:UGC 12848:MCG 0-1-4:ZWG 382.2"
{
        Type  "SBb"
        RA           23.9344
        Dec          -0.9886
        Distance   2.887e+08  # method: V
        Radius     5.039e+04
        AbsMag        -20.23
        Axis    [ -0.4022  -0.8152  -0.4167]
        Angle    201.7868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1515"
}

Galaxy "IC 1516:UGC 12852:MCG 0-1-6:ZWG 382.4"
{
        Type  "Sc"
        RA           23.9353
        Dec          -0.9169
        Distance   3.161e+08  # method: V
        Radius     8.276e+04
        AbsMag        -21.03
        Axis    [ -0.4966  -0.8678  -0.0173]
        Angle    179.6765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1516"
}

Galaxy "IC 1517:MCG 0-1-8:ZWG 382.6"
{
        Type  "E0"
        RA           23.9383
        Dec          -0.3056
        Distance   3.163e+08  # distance uncertain!
        Radius      3.68e+04
        AbsMag        -20.13
        Axis    [ -0.6359  -0.6440  -0.4252]
        Angle    225.0772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1517"
}

Galaxy "IC 1518:ZWG 433.5:NPM 1:KCPG 599A"
{
        Type  "S0"
        RA           23.9517
        Dec          12.4656
        Distance   2.802e+08  # distance uncertain!
        Radius     1.223e+04
        AbsMag        -19.07
        Axis    [ -0.2169  -0.9689   0.1189]
        Angle    178.4292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1518"
}

Galaxy "IC 1519:ZWG 433.6:NPM 1:KCPG 599B"
{
        Type  "S0"
        RA           23.9522
        Dec          12.4581
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.3479  -0.8121  -0.4685]
        Angle    218.5553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1519"
}

Galaxy "IC 1520:MCG 2-1-7:ARP 50:VV 25"
{
        Type  "Sc"
        RA           23.9650
        Dec         -14.0389
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [ -0.4202  -0.5488   0.7226]
        Angle    144.4777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1520"
}

Galaxy "IC 1521"
{
        Type  "E0"
        RA           23.9831
        Dec          -7.1461
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [ -0.7254  -0.6342   0.2677]
        Angle    149.3894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1521"
}

Galaxy "IC 1522:MCG 0-1-12:ZWG 382.11"
{
        Type  "Sc"
        RA           23.9842
        Dec           1.7203
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.0680  -0.8873  -0.4561]
        Angle    185.8436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1522"
}

Galaxy "IC 1523:IC 5368:NPM 1"
{
        Type  "E0"
        RA           23.9850
        Dec           6.8736
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [ -0.6388  -0.6976  -0.3245]
        Angle    223.0316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1523"
}

Galaxy "IC 1524:IC 1490:MCG 1-1-12:IRAS 23566-0424"
{
        Type  "SBc"
        RA           23.9861
        Dec          -4.1269
        Distance    2.03e+08  # distance uncertain!
        Radius     5.019e+04
        AbsMag        -19.07
        Axis    [ -0.1936  -0.9745   0.1134]
        Angle    176.4724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1524"
}

Galaxy "IC 1525:UGC 12883:MCG 8-1-16:ZWG 548.20"
{
        Type  "SBb"
        RA           23.9875
        Dec          46.8894
        Distance   2.154e+08  # method: V
        Radius     5.951e+04
        AbsMag         -20.9
        Axis    [ -0.0623  -0.9660  -0.2509]
        Angle    227.4007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1525"
}

Galaxy "IC 1526:ZWG 433.15:KUG 2358+110"
{
        Type  "Sc"
        RA            0.0253
        Dec          11.3467
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [  0.1437   0.8550  -0.4983]
        Angle    197.5965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1526"
}

Galaxy "IC 1527:MCG 1-1-12:ZWG 408.12:NPM 1"
{
        Type  "Sb"
        RA            0.0392
        Dec           4.0903
        Distance   2.555e+08  # distance uncertain!
        Radius     4.831e+04
        AbsMag        -19.07
        Axis    [  0.1499   0.7593  -0.6333]
        Angle    198.3642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1527"
}

Galaxy "IC 1528:MCG 1-1-28:IRAS 00025-0722"
{
        Type  "SBb"
        RA            0.0847
        Dec          -7.1181
        Distance   1.571e+08  # method: V
        Radius     5.486e+04
        AbsMag        -19.91
        Axis    [  0.2502   0.9662  -0.0623]
        Angle    182.6081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1528"
}

Galaxy "IC 1529:MCG 2-1-19:NPM 1"
{
        Type  "S0"
        RA            0.0869
        Dec         -11.5022
        Distance   2.975e+08  # method: V
        Radius     5.192e+04
        AbsMag         -20.2
        Axis    [  0.5015   0.6931   0.5178]
        Angle    154.7806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1529"
}

Galaxy "IC 1531:ESO 349-35:MCG 5-1-38"
{
        Type  "S0"
        RA            0.1597
        Dec         -32.2767
        Distance   3.356e+08  # method: V
        Radius     8.786e+04
        AbsMag        -21.56
        Axis    [  0.5618   0.6122  -0.5564]
        Angle    197.6849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1531"
}

Galaxy "IC 1532:ESO 78-17"
{
        Type  "SBc"
        RA            0.1647
        Dec         -64.3711
        Distance   9.717e+07  # method: T-F
        Radius     2.261e+04
        AbsMag        -17.57
        Axis    [  0.5958   0.8015  -0.0509]
        Angle    199.3669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1532"
}

Galaxy "IC 1534:UGC 125:MCG 8-1-28:ZWG 549.25"
{
        Type  "S0"
        RA            0.2292
        Dec          48.1519
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.1686   0.9834  -0.0678]
        Angle    161.6801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1534"
}

Galaxy "IC 1535:UGC 131:MCG 8-1-30:ZWG 549.26"
{
        Type  "Sb"
        RA            0.2325
        Dec          48.1575
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [ -0.3600   0.5981  -0.7161]
        Angle    202.1192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1535"
}

Galaxy "IC 1536:MCG 8-1-32:MK 939:ZWG 549.28"
{
        Type  "S0"
        RA            0.2383
        Dec          48.1439
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.1601   0.7284  -0.6661]
        Angle    228.7289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1536"
}

Galaxy "IC 1540:UGC 186:MCG 4-1-50:ZWG 478.54"
{
        Type  "SBb"
        RA            0.3300
        Dec          23.7725
        Distance   2.911e+08  # method: T-F
        Radius      3.81e+04
        AbsMag        -19.85
        Axis    [  0.0486   0.9492   0.3108]
        Angle    153.3611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1540"
}

Galaxy "IC 1541:ZWG 478.55:NPM 1"
{
        Type  "S0"
        RA            0.3339
        Dec          22.0006
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.0119   0.9584   0.2851]
        Angle    158.1841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1541"
}

Galaxy "IC 1542:MCG 4-2-1:ZWG 479.1"
{
        Type  "S0"
        RA            0.3447
        Dec          22.5928
        Distance    3.18e+08  # method: V
        Radius     3.238e+04
        AbsMag        -19.94
        Axis    [  0.1836   0.9757  -0.1193]
        Angle    172.6942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1542"
}

Galaxy "IC 1543:UGC 198:MCG 4-2-2:ZWG 479.2"
{
        Type  "Sc"
        RA            0.3486
        Dec          21.8656
        Distance   2.396e+08  # method: V
        Radius     2.439e+04
        AbsMag        -20.03
        Axis    [  0.5955   0.7398   0.3132]
        Angle    118.9146
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1543"
}

Galaxy "IC 1544:UGC 204:MCG 4-2-6:ZWG 479.7"
{
        Type  "SBc"
        RA            0.3547
        Dec          23.0908
        Distance    2.39e+08  # method: T-F
        Radius     4.171e+04
        AbsMag        -19.72
        Axis    [  0.0445   0.7834  -0.6199]
        Angle    206.0615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1544"
}

Galaxy "IC 1545:NPM 1"
{
        Type  "E0"
        RA            0.3556
        Dec          21.9839
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [  0.6180   0.7275   0.2982]
        Angle    117.8660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1545"
}

Galaxy "IC 1546:NGC 85B:MCG 4-2-8:ZWG 479.10"
{
        Type  "Sc"
        RA            0.3581
        Dec          22.5064
        Distance   2.915e+08  # method: T-F
        Radius     3.815e+04
        AbsMag        -19.16
        Axis    [ -0.1043   0.8601  -0.4993]
        Angle    184.2044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1546"
}

Galaxy "IC 1548:ZWG 479.14:NPM 1"
{
        Type  "S0"
        RA            0.3653
        Dec          22.0069
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.2285   0.9581  -0.1727]
        Angle    177.0822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1548"
}

Galaxy "IC 1549:UGC 218:MCG 1-2-5:ZWG 409.8"
{
        Type  "S0"
        RA            0.3803
        Dec           6.9647
        Distance    5.35e+08  # method: V
        Radius     6.225e+04
        AbsMag        -21.37
        Axis    [  0.6424   0.6637   0.3831]
        Angle    128.4476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1549"
}

Galaxy "IC 1550:MCG 6-2-2:ZWG 519.8"
{
        Type  "S0"
        RA            0.4075
        Dec          38.1853
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.0940   0.7663  -0.6355]
        Angle    213.8049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1550"
}

Galaxy "IC 1551:UGC 268:MCG 1-2-13:ZWG 409.16"
{
        Type  "Sb"
        RA            0.4597
        Dec           8.8775
        Distance   5.753e+08  # method: V
        Radius     2.092e+05
        AbsMag        -21.73
        Axis    [  0.1798   0.8918   0.4152]
        Angle    158.7456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1551"
}

Galaxy "IC 1552:UGC 297:MCG 3-2-15:ZWG 457.18"
{
        Type  "Sc"
        RA            0.4953
        Dec          21.4764
        Distance   3.126e+08  # method: T-F
        Radius     4.092e+04
        AbsMag        -19.51
        Axis    [ -0.1723   0.8579  -0.4841]
        Angle    176.5646
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1552"
}

Galaxy "IC 1553:ESO 473-26:MCG 4-2-17:IRAS 00301-2553"
{
        Type  "S0"
        RA            0.5444
        Dec         -25.6089
        Distance    1.54e+08  # distance uncertain!
        Radius     2.687e+04
        AbsMag        -19.07
        Axis    [  0.2427   0.8761   0.4166]
        Angle    191.6139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1553"
}

Galaxy "IC 1555:ESO 410-21:MCG 5-2-19:AM 0032-301"
{
        Type  "Sc"
        RA            0.5756
        Dec         -30.0175
        Distance   8.689e+07  # method: T-F
        Radius     1.643e+04
        AbsMag        -17.73
        Axis    [  0.5153   0.6956  -0.5006]
        Angle    188.3454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1555"
}

Galaxy "IC 1557:MCG 1-2-37:NPM 1"
{
        Type  "S0"
        RA            0.5928
        Dec          -2.8758
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.1366   0.8117  -0.5679]
        Angle    180.7633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1557"
}

Galaxy "IC 1558:ESO 474-2:MCG 4-2-24:UGCA 8"
{
        Type  "Irr"
        RA            0.5964
        Dec         -25.3744
        Distance   4.208e+07  # method: T-F
        Radius      2.02e+04
        AbsMag        -17.75
        Axis    [  0.4332   0.6027  -0.6701]
        Angle    192.4085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1558"
}

Galaxy "IC 1559:MCG 4-2-34:MK 341:ZWG 479.44"
{
        Type  "Sa"
        RA            0.6144
        Dec          23.9850
        Distance    1.95e+08  # method: V
        Radius     1.135e+04
        AbsMag        -18.98
        Axis    [  0.2814   0.8769   0.3896]
        Angle    135.8098
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1559"
}

Galaxy "IC 1561:ESO 474-8:MCG 4-2-29:AM 0036-243"
{
        Type  "SBb"
        RA            0.6422
        Dec         -24.3403
        Distance    1.64e+08  # method: V
        Radius     2.863e+04
        AbsMag        -18.61
        Axis    [  0.3703   0.8865  -0.2775]
        Angle    179.3459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1561"
}

Galaxy "IC 1562:ESO 474-9:MCG 4-2-30:AM 0036-243"
{
        Type  "SBc"
        RA            0.6425
        Dec         -24.2739
        Distance   1.526e+08  # method: V
        Radius     3.551e+04
        AbsMag        -19.75
        Axis    [  0.4624   0.4317  -0.7744]
        Angle    212.5007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1562"
}

Galaxy "IC 1563:NGC 191A:MCG 2-2-76:ARP 127"
{
        Type  "S0"
        RA            0.6500
        Dec          -9.0150
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.4162   0.6758  -0.6083]
        Angle    202.7564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1563"
}

Galaxy "IC 1564:UGC 399:MCG 1-2-44:ZWG 409.53"
{
        Type  "SBc"
        RA            0.6514
        Dec           6.0211
        Distance   2.234e+08  # method: V
        Radius     3.249e+04
        AbsMag        -19.38
        Axis    [  0.1852   0.9703  -0.1555]
        Angle    172.6779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1564"
}

Galaxy "IC 1565:IC 1567:UGC 410:MCG 1-2-47"
{
        Type  "E0"
        RA            0.6572
        Dec           6.7342
        Distance   4.898e+08  # method: V
        Radius     7.124e+04
        AbsMag        -21.48
        Axis    [  0.6902   0.6272   0.3609]
        Angle    125.6424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1565"
}

Galaxy "IC 1566:DRCG 2-36:NPM 1"
{
        Type  "Sa"
        RA            0.6592
        Dec           6.8156
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.3457   0.8090  -0.4754]
        Angle    198.0275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1566"
}

Galaxy "IC 1567:IC 1565:UGC 410:MCG 1-2-47"
{
        Type  "E0"
        RA            0.6572
        Dec           6.7342
        Distance   4.898e+08  # method: V
        Radius     7.124e+04
        AbsMag        -21.48
        Axis    [  0.6902   0.6272   0.3609]
        Angle    125.6424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1567"
}

Galaxy "IC 1568:MCG 1-2-52:ZWG 409.61:NPM 1"
{
        Type  "S0"
        RA            0.6653
        Dec           6.8492
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.6708   0.6419   0.3715]
        Angle    126.6082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1568"
}

Galaxy "IC 1569:MCG 1-2-53:DRCG 2-24"
{
        Type  "S0"
        RA            0.6744
        Dec           6.7197
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.6720   0.6406   0.3717]
        Angle    126.6387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1569"
}

Galaxy "IC 1570:DRCG 2-23"
{
        Type  "S0"
        RA            0.6761
        Dec           6.7533
        Distance   5.339e+08  # distance uncertain!
        Radius     3.106e+04
        AbsMag        -19.07
        Axis    [  0.0255   0.5703  -0.8210]
        Angle    195.6367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1570"
}

Galaxy "IC 1571:UGC 432:MCG 0-2-121:ZWG 383.66"
{
        Type  "Sb"
        RA            0.6769
        Dec          -0.3303
        Distance   2.494e+08  # method: V
        Radius     5.442e+04
        AbsMag        -19.82
        Axis    [  0.4599   0.8725   0.1651]
        Angle    162.5204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1571"
}

Galaxy "IC 1573:ESO 474-13:MCG 4-2-36:FGCE 73"
{
        Type  "Sc"
        RA            0.7028
        Dec         -23.5922
        Distance    4.65e+08  # distance uncertain!
        Radius     8.116e+04
        AbsMag        -19.07
        Axis    [  0.2224   0.9738  -0.0480]
        Angle    179.0595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1573"
}

Galaxy "IC 1574:ESO 474-18:MCG 4-2-43:UGCA 9"
{
        Type  "Irr"
        RA            0.7178
        Dec         -22.2461
        Distance   2.631e+08  # distance uncertain!
        Radius     8.034e+04
        AbsMag        -20.13
        Axis    [  0.1961   0.5351  -0.8217]
        Angle    172.9411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1574"
}

Galaxy "IC 1575A:MCG 1-3-2:VV 642:ARP 231"
{
        Type  "Irr"
        RA            0.7258
        Dec          -4.1167
        Distance   2.754e+08  # distance uncertain!
        Radius     4.807e+04
        AbsMag        -20.13
        Axis    [  0.5126   0.8473   0.1392]
        Angle    164.6811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1575A"
}

Galaxy "IC 1575B:MCG 1-3-3:VV 642:ARP 231"
{
        Type  "Irr"
        RA            0.7258
        Dec          -4.1194
        Distance   2.188e+08  # distance uncertain!
        Radius     4.773e+04
        AbsMag        -20.13
        Axis    [  0.3929   0.8758   0.2803]
        Angle    163.4807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1575B"
}

Galaxy "IC 1576:ESO 474-20:MCG 4-2-45"
{
        Type  "Sc"
        RA            0.7369
        Dec         -25.1092
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [  0.3712   0.6717  -0.6411]
        Angle    182.2328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1576"
}

Galaxy "IC 1578:ESO 474-21:MCG 4-3-1:IRAS 00419-2521"
{
        Type  "Sc"
        RA            0.7403
        Dec         -25.0764
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.3371   0.8567   0.3904]
        Angle    184.9089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1578"
}

Galaxy "IC 1579:ESO 474-22:MCG 5-3-2"
{
        Type  "SBc"
        RA            0.7589
        Dec         -26.5644
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.4720   0.7312   0.4925]
        Angle    176.4806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1579"
}

Galaxy "IC 1581:ESO 474-23"
{
        Type  "Sc"
        RA            0.7628
        Dec         -25.9194
        Distance   3.694e+08  # distance uncertain!
        Radius     4.835e+04
        AbsMag        -19.07
        Axis    [  0.2620   0.9530   0.1521]
        Angle    184.5323
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1581"
}

Galaxy "IC 1582:ESO 474-24:MCG 4-3-3"
{
        Type  "Sc"
        RA            0.7711
        Dec         -24.2797
        Distance   3.217e+08  # distance uncertain!
        Radius     5.147e+04
        AbsMag        -19.07
        Axis    [  0.2945   0.9430   0.1548]
        Angle    182.7040
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1582"
}

Galaxy "IC 1583:MCG 4-3-1:ZWG 480.4:ARAK 13"
{
        Type  "S0"
        RA            0.7861
        Dec          23.0744
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.1950   0.9205   0.3387]
        Angle    143.2792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1583"
}

Galaxy "IC 1584:UGC 489:MCG 5-3-4:ZWG 501.14"
{
        Type  "SBa"
        RA            0.7883
        Dec          27.8283
        Distance   2.018e+08  # method: V
        Radius     4.695e+04
        AbsMag        -18.66
        Axis    [  0.2690   0.9374  -0.2213]
        Angle    174.7292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1584"
}

Galaxy "IC 1585:MCG 4-3-2:ZWG 480.5:NPM 1"
{
        Type  "E0"
        RA            0.7872
        Dec          23.0542
        Distance   4.571e+08  # distance uncertain!
        Radius     5.319e+04
        AbsMag        -20.13
        Axis    [  0.5188   0.7960  -0.3117]
        Angle    197.5288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1585"
}

Galaxy "IC 1586:MK 347:ZWG 480.6:ZW 12"
{
        Type  "E0"
        RA            0.7989
        Dec          22.3733
        Distance   2.492e+08  # method: V
        Radius     1.087e+04
        AbsMag        -19.52
        Axis    [  0.6611   0.6952   0.2822]
        Angle    114.0428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1586"
}

Galaxy "IC 1587:ESO 474-31:MCG 4-3-15"
{
        Type  "S0"
        RA            0.8119
        Dec         -23.5617
        Distance   2.802e+08  # distance uncertain!
        Radius     5.705e+04
        AbsMag        -19.07
        Axis    [  0.2971   0.9246   0.2386]
        Angle    183.1280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1587"
}

Galaxy "IC 1588:ESO 474-33"
{
        Type  "S0"
        RA            0.8492
        Dec         -23.5586
        Distance    4.05e+08  # distance uncertain!
        Radius     4.123e+04
        AbsMag        -19.07
        Axis    [  0.2662   0.6463  -0.7152]
        Angle    174.0694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1588"
}

Galaxy "IC 1592:UGC 543:ZWG 410.15"
{
        Type  "S0"
        RA            0.8908
        Dec           5.7697
        Distance   2.202e+08  # method: V
        Radius     3.202e+04
        AbsMag        -19.05
        Axis    [  0.1367   0.6560  -0.7422]
        Angle    200.6261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1592"
}

Galaxy "IC 1594:ESO 195-12:AM 0051-475"
{
        Type  "SBb"
        RA            0.8958
        Dec         -47.6478
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.4533   0.7134  -0.5345]
        Angle    166.8860
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1594"
}

Galaxy "IC 1595:ESO 243-8:FGCE 102"
{
        Type  "Sb"
        RA            0.8964
        Dec         -45.1864
        Distance   2.877e+08  # method: T-F
        Radius     6.277e+04
        AbsMag        -19.33
        Axis    [  0.3339   0.8579   0.3905]
        Angle    206.2301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1595"
}

Galaxy "IC 1596:UGC 550:MCG 3-3-7:ZWG 458.9"
{
        Type  "Sc"
        RA            0.9117
        Dec          21.5231
        Distance   1.068e+08  # method: V
        Radius     2.797e+04
        AbsMag        -17.78
        Axis    [ -0.0926   0.8987  -0.4287]
        Angle    173.2524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1596"
}

Galaxy "IC 1597:ESO 112-10"
{
        Type  "Sb"
        RA            0.8922
        Dec         -58.1072
        Distance   2.436e+08  # method: T-F
        Radius     6.024e+04
        AbsMag        -19.37
        Axis    [  0.4379   0.6251  -0.6461]
        Angle    150.8415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1597"
}

Galaxy "IC 1598:UGC 553:MCG 1-3-7:MK 962"
{
        Type  "Sa"
        RA            0.9114
        Dec           5.7742
        Distance   1.868e+08  # method: V
        Radius     2.717e+04
        AbsMag        -18.79
        Axis    [  0.2546   0.8207   0.5114]
        Angle    154.4726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1598"
}

Galaxy "IC 1599:ESO 474-42:MCG 4-3-30"
{
        Type  "Sc"
        RA            0.9089
        Dec         -23.4944
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.2104   0.9118  -0.3526]
        Angle    168.1937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1599"
}

Galaxy "IC 1600:ESO 474-43:MCG 4-3-31"
{
        Type  "Sb"
        RA            0.9178
        Dec         -23.5244
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.4229   0.8803  -0.2151]
        Angle    177.2352
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1600"
}

Galaxy "IC 1601:ESO 474-44:MCG 4-3-32:AM 0053-242"
{
        Type  "Sb"
        RA            0.9261
        Dec         -24.1533
        Distance   1.522e+08  # method: V
        Radius     1.992e+04
        AbsMag        -18.84
        Axis    [  0.3582   0.8168  -0.4523]
        Angle    175.0221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1601"
}

Galaxy "IC 1602:MCG 2-3-47:NPM 1"
{
        Type  "E0"
        RA            0.9308
        Dec          -9.9853
        Distance   3.981e+08  # distance uncertain!
        Radius     4.054e+04
        AbsMag        -20.13
        Axis    [  0.4709   0.4493  -0.7592]
        Angle    235.2053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1602"
}

Galaxy "IC 1603:ESO 243-14"
{
        Type  "Sc"
        RA            0.9497
        Dec         -45.4128
        Distance   3.159e+08  # method: T-F
        Radius     5.974e+04
        AbsMag        -20.33
        Axis    [  0.6077   0.6834  -0.4045]
        Angle    181.2165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1603"
}

Galaxy "IC 1605:ESO 195-19:FAIR 671:AM 0055-491"
{
        Type  "SBc"
        RA            0.9603
        Dec         -48.9028
        Distance   2.996e+08  # method: V
        Radius     6.972e+04
        AbsMag        -21.12
        Axis    [  0.6420   0.4760  -0.6010]
        Angle    187.2205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1605"
}

Galaxy "IC 1607:UGC 611:MCG 0-3-47:ZWG 384.51"
{
        Type  "S0"
        RA            0.9800
        Dec           0.5872
        Distance   2.304e+08  # method: V
        Radius     3.016e+04
        AbsMag        -19.74
        Axis    [  0.7152   0.5861   0.3807]
        Angle    129.1922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1607"
}

Galaxy "IC 1608:ESO 351-27:MCG 6-3-13"
{
        Type  "Sa"
        RA            0.9900
        Dec         -34.3297
        Distance   1.457e+08  # method: V
        Radius     4.239e+04
        AbsMag        -19.55
        Axis    [  0.3002   0.5133  -0.8040]
        Angle    168.3663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1608"
}

Galaxy "IC 1609:ESO 295-26:MCG 7-3-4"
{
        Type  "S0"
        RA            0.9961
        Dec         -40.3336
        Distance   1.115e+08  # distance uncertain!
        Radius     2.271e+04
        AbsMag        -19.07
        Axis    [  0.7735   0.3883   0.5009]
        Angle    160.7667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1609"
}

Galaxy "IC 1610:MCG 3-3-20"
{
        Type  "Sa"
        RA            1.0283
        Dec         -15.5678
        Distance   1.223e+08  # distance uncertain!
        Radius      2.49e+04
        AbsMag        -19.07
        Axis    [  0.4494   0.7981  -0.4013]
        Angle    181.5923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1610"
}

Galaxy "IC 1613:UGC 668:MCG 0-3-70:DDO 8"
{
        Type  "Irr"
        RA            1.0797
        Dec           2.1186
        Distance     2.4e+06  # method: CP
        Radius          5794
        AbsMag        -14.43
        Axis    [  0.5516   0.8318   0.0616]
        Angle    158.7019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1613"
}

Galaxy "IC 1614:NPM 1"
{
        Type  "E0"
        RA            1.0850
        Dec          33.1903
        Distance   1.148e+09  # distance uncertain!
        Radius      5.01e+04
        AbsMag        -20.13
        Axis    [  0.6518   0.7264   0.2177]
        Angle    104.5640
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1614"
}

Galaxy "IC 1615:ESO 195-27:IRAS 01019-5124"
{
        Type  "Sc"
        RA            1.0683
        Dec         -51.1328
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [  0.5047   0.5827  -0.6370]
        Angle    167.2278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1615"
}

Galaxy "IC 1616:ESO 412-4:MCG 5-3-22:AM 0102-274"
{
        Type  "SBc"
        RA            1.0822
        Dec         -27.4289
        Distance   2.433e+08  # method: V
        Radius     5.661e+04
        AbsMag        -21.06
        Axis    [  0.6252   0.6225   0.4707]
        Angle    165.3549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1616"
}

Galaxy "IC 1617:ESO 195-28:AM 0102-511:IRAS 01020-5117"
{
        Type  "Sa"
        RA            1.0711
        Dec         -51.0325
        Distance   1.768e+08  # distance uncertain!
        Radius       3.6e+04
        AbsMag        -19.07
        Axis    [  0.5361   0.6710  -0.5121]
        Angle    170.5840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1617"
}

Galaxy "IC 1618:UGC 671:ZWG 501.78:NPM 1"
{
        Type  "S0"
        RA            1.0986
        Dec          32.4128
        Distance   2.001e+08  # method: V
        Radius     3.492e+04
        AbsMag        -18.24
        Axis    [ -0.1918   0.7305  -0.6554]
        Angle    190.1522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1618"
}

Galaxy "IC 1619:MCG 5-3-54:ZWG 501.83:ARAK 25"
{
        Type  "S0"
        RA            1.1228
        Dec          33.0669
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.0752   0.9532  -0.2929]
        Angle    172.1001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1619"
}

Galaxy "IC 1620:UGC 681:MCG 2-3-34:ZWG 435.42"
{
        Type  "SBc"
        RA            1.1206
        Dec          13.9550
        Distance   5.021e+08  # method: V
        Radius     7.303e+04
        AbsMag        -21.74
        Axis    [  0.2500   0.9407  -0.2292]
        Angle    169.2431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1620"
}

Galaxy "IC 1621:ESO 243-28:DRCG 41-41"
{
        Type  "Sc"
        RA            1.1061
        Dec         -46.7253
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.4155   0.7841   0.4609]
        Angle    203.6790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1621"
}

Galaxy "IC 1622:ESO 541-22:MCG 3-4-1"
{
        Type  "S0"
        RA            1.1267
        Dec         -17.5386
        Distance   1.768e+08  # distance uncertain!
        Radius       1.8e+04
        AbsMag        -19.07
        Axis    [  0.2887   0.5577  -0.7782]
        Angle    189.5507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1622"
}

Galaxy "IC 1623-1:IC 1623A:ESO 541-23:MCG 3-4-3"
{
        Type  "Irr"
        RA            1.1294
        Dec         -17.5067
        Distance   2.754e+08  # distance uncertain!
        Radius     3.606e+04
        AbsMag        -20.13
        Axis    [  0.5480   0.7309   0.4067]
        Angle    162.8921
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1623-1"
}

Galaxy "IC 1623B:IC 1623-2:ESO 541-23:MCG 3-4-4"
{
        Type  "S0"
        RA            1.1300
        Dec         -17.5067
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.6017   0.6932   0.3968]
        Angle    159.5969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1623B"
}

Galaxy "IC 1625:ESO 243-33:AM 0105-471:DRCG 41-29"
{
        Type  "S0"
        RA            1.1283
        Dec         -46.9083
        Distance   3.394e+08  # method: T-F
        Radius     7.899e+04
        AbsMag        -22.09
        Axis    [  0.6290   0.6268   0.4599]
        Angle    187.5068
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1625"
}

Galaxy "IC 1627:ESO 243-34:DRCG 40-19:IRAS 01059-4621"
{
        Type  "SBb"
        RA            1.1361
        Dec         -46.0939
        Distance   2.916e+08  # method: T-F
        Radius      1.06e+05
        AbsMag        -21.06
        Axis    [  0.3836   0.6981  -0.6046]
        Angle    157.6231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1627"
}

Galaxy "IC 1628:ESO 412-7:MCG 5-3-27:AM 0106-285"
{
        Type  "S0"
        RA            1.1464
        Dec         -28.5822
        Distance   1.065e+08  # distance uncertain!
        Radius     1.704e+04
        AbsMag        -19.07
        Axis    [  0.7750   0.4340   0.4594]
        Angle    151.0045
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1628"
}

Galaxy "IC 1629:ZWG 385.9:NPM 1"
{
        Type  "E0"
        RA            1.1550
        Dec           2.5681
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.7493   0.6622   0.0043]
        Angle    156.7137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1629"
}

Galaxy "IC 1630:ESO 243-36:AM 0106-470:DRCG 41-39"
{
        Type  "Sb"
        RA            1.1378
        Dec         -46.7542
        Distance   3.323e+08  # method: T-F
        Radius     7.249e+04
        AbsMag        -19.84
        Axis    [  0.4140   0.9091  -0.0465]
        Angle    184.2129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1630"
}

Galaxy "IC 1631:ESO 243-40:AM 0106-464:DRCG 40-5"
{
        Type  "Sb"
        RA            1.1456
        Dec         -46.4753
        Distance    1.47e+08  # distance uncertain!
        Radius     1.925e+04
        AbsMag        -19.07
        Axis    [  0.6779   0.7129  -0.1795]
        Angle    183.7730
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1631"
}

Galaxy "IC 1632:DRCG 5-52"
{
        Type  "E0"
        RA            1.1786
        Dec          17.6833
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.7123   0.6390   0.2904]
        Angle    114.4268
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1632"
}

Galaxy "IC 1633:ESO 243-46:FAIR 683:AM 0107-461"
{
        Type  "E1"
        RA            1.1653
        Dec         -45.9314
        Distance   3.186e+08  # method: V
        Radius     1.205e+05
        AbsMag        -22.55
        Axis    [  0.9116   0.3342  -0.2393]
        Angle    195.9795
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1633"
}

Galaxy "IC 1634:UGC 740:MCG 3-4-8:ZWG 459.14"
{
        Type  "E0"
        RA            1.1842
        Dec          17.6625
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.7129   0.6384   0.2902]
        Angle    114.4025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1634"
}

Galaxy "IC 1635:UGC 739:MCG 3-4-9:ZWG 459.13"
{
        Type  "E0"
        RA            1.1842
        Dec          17.6517
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.7129   0.6383   0.2903]
        Angle    114.4102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1635"
}

Galaxy "IC 1636:ZWG 501.125:ZWG 502.1:NPM 1"
{
        Type  "S0"
        RA            1.1936
        Dec          33.3550
        Distance    2.33e+08  # distance uncertain!
        Radius     1.017e+04
        AbsMag        -19.07
        Axis    [  0.0670   0.9758  -0.2082]
        Angle    163.3186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1636"
}

Galaxy "IC 1637:ESO 412-10:MCG 5-4-3:AM 0108-304"
{
        Type  "SBc"
        RA            1.1836
        Dec         -30.4386
        Distance   2.588e+08  # method: T-F
        Radius       6.4e+04
        AbsMag           -21
        Axis    [  0.6224   0.7413  -0.2512]
        Angle    180.5940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1637"
}

Galaxy "IC 1638:MCG 5-3-82:ZWG 501.129:ZWG 502.5"
{
        Type  "S0"
        RA            1.2058
        Dec          33.3650
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.6416   0.7308   0.2332]
        Angle    104.0749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1638"
}

Galaxy "IC 1639:UGC 750:MCG 0-4-31:MK 562"
{
        Type  "Irr"
        RA            1.1961
        Dec          -0.6639
        Distance   2.302e+08  # method: V
        Radius     3.013e+04
        AbsMag        -20.14
        Axis    [  0.4874   0.8108  -0.3240]
        Angle    180.7455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1639"
}

Galaxy "IC 1640:ZWG 385.24"
{
        Type  "E0"
        RA            1.1975
        Dec          -0.6306
        Distance   4.169e+08  # distance uncertain!
        Radius     1.213e+04
        AbsMag        -20.13
        Axis    [  0.7557   0.5455   0.3624]
        Angle    127.7790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1640"
}

Galaxy "IC 1642:IC 1645:MCG 2-4-8:ZWG 436.9"
{
        Type  "S0"
        RA            1.2075
        Dec          15.7506
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.7002   0.6420   0.3124]
        Angle    116.5256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1642"
}

Galaxy "IC 1643:MCG 0-4-33:ZWG 385.25:NPM 1"
{
        Type  "S0"
        RA            1.2022
        Dec          -0.4097
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.7377   0.5631   0.3723]
        Angle    128.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1643"
}

Galaxy "IC 1646:MCG 2-4-9:ZWG 436.10"
{
        Type  "SBc"
        RA            1.2119
        Dec          15.7069
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.7007   0.6414   0.3124]
        Angle    116.5266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1646"
}

Galaxy "IC 1647:MCG 6-3-24:ZWG 520.27"
{
        Type  "Sc"
        RA            1.2206
        Dec          38.8853
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.0166   0.9731   0.2300]
        Angle    137.7514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1647"
}

Galaxy "IC 1648:ZWG 501.131:ZWG 502.7:NPM 1"
{
        Type  "S0"
        RA            1.2283
        Dec          33.2181
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.0305   0.8772  -0.4792]
        Angle    189.3114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1648"
}

Galaxy "IC 1649:ESO 151-30"
{
        Type  "Sc"
        RA            1.1972
        Dec         -55.8567
        Distance   2.449e+08  # method: T-F
        Radius     6.055e+04
        AbsMag        -19.68
        Axis    [  0.4380   0.6936  -0.5719]
        Angle    153.9086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1649"
}

Galaxy "IC 1650:ESO 195-34:AM 0110-503:IRAS 01101-5039"
{
        Type  "SBb"
        RA            1.2050
        Dec         -50.4019
        Distance   3.244e+08  # method: V
        Radius     6.135e+04
        AbsMag        -20.59
        Axis    [  0.6431   0.7656  -0.0174]
        Angle    186.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1650"
}

Galaxy "IC 1652:UGC 792:MCG 5-4-3:ZWG 502.9"
{
        Type  "Sa"
        RA            1.2489
        Dec          31.9478
        Distance   2.234e+08  # method: V
        Radius     3.575e+04
        AbsMag        -19.68
        Axis    [ -0.2692   0.6496  -0.7110]
        Angle    184.2649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1652"
}

Galaxy "IC 1654:UGC 798:MCG 5-4-4:ZWG 502.11"
{
        Type  "SBa"
        RA            1.2531
        Dec          30.1953
        Distance   2.087e+08  # method: V
        Radius     3.946e+04
        AbsMag        -19.73
        Axis    [  0.4175   0.9064   0.0645]
        Angle    137.1728
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1654"
}

Galaxy "IC 1657:IC 1663:ESO 352-24:MCG 6-3-30"
{
        Type  "SBc"
        RA            1.2350
        Dec         -32.6506
        Distance   1.692e+08  # method: T-F
        Radius     5.905e+04
        AbsMag        -20.37
        Axis    [  0.2042   0.5566  -0.8053]
        Angle    153.6353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1657"
}

Galaxy "IC 1659:UGC 812:MCG 5-4-8:ZWG 502.17"
{
        Type  "E0"
        RA            1.2683
        Dec          30.3483
        Distance   2.399e+08  # distance uncertain!
        Radius     4.187e+04
        AbsMag        -20.13
        Axis    [  0.6522   0.7518   0.0972]
        Angle    119.4263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1659"
}

Galaxy "IC 1666:UGC 857:MCG 5-4-19:ZWG 502.30"
{
        Type  "Sc"
        RA            1.3314
        Dec          32.4667
        Distance   2.084e+08  # method: V
        Radius     3.335e+04
        AbsMag        -19.73
        Axis    [  0.3240   0.9371  -0.1302]
        Angle    154.7020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1666"
}

Galaxy "IC 1667:MCG 3-4-39"
{
        Type  "S0"
        RA            1.3117
        Dec         -17.0503
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.6644   0.7418  -0.0910]
        Angle    172.6457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1667"
}

Galaxy "IC 1668:ZWG 502.24:KUG 0116+329"
{
        Type  "S0"
        RA            1.3147
        Dec          33.1722
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.6536   0.7205   0.2317]
        Angle    103.2705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1668"
}

Galaxy "IC 1669:ZWG 502.32"
{
        Type  "S0"
        RA            1.3350
        Dec          33.1839
        Distance   2.031e+08  # method: T-F
        Radius     2.954e+04
        AbsMag        -18.37
        Axis    [ -0.0309   0.8307   0.5559]
        Angle    142.0019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1669"
}

Galaxy "IC 1670-1:IC 1670A:MCG 3-4-40:VV 779"
{
        Type  "Sc"
        RA            1.3133
        Dec         -16.8036
        Distance   1.612e+08  # distance uncertain!
        Radius     4.455e+04
        AbsMag        -19.07
        Axis    [  0.1329   0.8470  -0.5147]
        Angle    159.2338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1670-1"
}

Galaxy "IC 1670-2:IC 1670B:MCG 3-4-41:VV 779"
{
        Type  "S0"
        RA            1.3144
        Dec         -16.8031
        Distance   2.592e+08  # method: V
        Radius     5.277e+04
        AbsMag         -19.9
        Axis    [  0.2458   0.9316  -0.2679]
        Angle    165.9720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1670-2"
}

Galaxy "IC 1672:UGC 872:MCG 5-4-24:ZWG 502.36"
{
        Type  "Sb"
        RA            1.3439
        Dec          29.6989
        Distance   3.089e+08  # method: V
        Radius     5.841e+04
        AbsMag        -20.98
        Axis    [  0.0492   0.8432  -0.5354]
        Angle    192.7993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1672"
}

Galaxy "IC 1673:ZWG 502.38:NPM 1"
{
        Type  "E0"
        RA            1.3461
        Dec          33.0456
        Distance   3.631e+08  # distance uncertain!
        Radius     1.584e+04
        AbsMag        -20.13
        Axis    [  0.6791   0.7029   0.2117]
        Angle    102.4262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1673"
}

Galaxy "IC 1675:UGC 879:MCG 6-4-4:ZWG 521.5"
{
        Type  "S0"
        RA            1.3500
        Dec          34.2489
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.0754   0.9971  -0.0054]
        Angle    149.0306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1675"
}

Galaxy "IC 1676:ZWG 502.41:NPM 1"
{
        Type  "S0"
        RA            1.3494
        Dec          30.2600
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.3742   0.8144   0.4435]
        Angle    118.2568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1676"
}

Galaxy "IC 1677:MCG 5-4-25:ZWG 502.42:VV 600"
{
        Type  "S0"
        RA            1.3519
        Dec          33.2156
        Distance   2.328e+08  # method: V
        Radius     3.048e+04
        AbsMag        -19.27
        Axis    [ -0.0652   0.9116  -0.4058]
        Angle    173.9522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1677"
}

Galaxy "IC 1678:ZWG 411.28"
{
        Type  "E0"
        RA            1.3506
        Dec           5.5603
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.7574   0.5626   0.3314]
        Angle    122.2442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1678"
}

Galaxy "IC 1679:MCG 5-4-27:ZWG 502.48"
{
        Type  "S0"
        RA            1.3622
        Dec          33.4928
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.2545   0.9668   0.0210]
        Angle    141.9466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1679"
}

Galaxy "IC 1680:MCG 5-4-28:ZWG 502.49"
{
        Type  "Sa"
        RA            1.3642
        Dec          33.2819
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.1057   0.9710  -0.2145]
        Angle    161.6669
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1680"
}

Galaxy "IC 1681:UGC 894:MCG 0-4-97:ZWG 385.80"
{
        Type  "S0"
        RA            1.3558
        Dec           0.0906
        Distance    1.62e+08  # method: V
        Radius     2.355e+04
        AbsMag        -18.68
        Axis    [  0.2260   0.9241  -0.3080]
        Angle    167.1480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1681"
}

Galaxy "IC 1682:UGC 912:MCG 5-4-32:ZWG 502.53"
{
        Type  "S0"
        RA            1.3703
        Dec          33.2597
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.1098   0.8895  -0.4435]
        Angle    174.8767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1682"
}

Galaxy "IC 1683:UGC 916:MCG 6-4-8:MK 987"
{
        Type  "Sc"
        RA            1.3775
        Dec          34.4372
        Distance   2.051e+08  # method: V
        Radius     3.878e+04
        AbsMag        -19.79
        Axis    [ -0.2228   0.6409  -0.7346]
        Angle    197.2390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1683"
}

Galaxy "IC 1684"
{
        Type  "S0"
        RA            1.3814
        Dec          33.4131
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.1092   0.8931  -0.4364]
        Angle    174.2498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1684"
}

Galaxy "IC 1685"
{
        Type  "S0"
        RA            1.3850
        Dec          33.1908
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.3203   0.9163   0.2403]
        Angle    126.5033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1685"
}

Galaxy "IC 1687:MCG 5-4-39:ZWG 502.61"
{
        Type  "E0"
        RA            1.3886
        Dec          33.2769
        Distance   2.086e+08  # method: V
        Radius     1.517e+04
        AbsMag        -19.33
        Axis    [  0.6777   0.7107   0.1886]
        Angle    104.0283
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1687"
}

Galaxy "IC 1688"
{
        Type  "E0"
        RA            1.3911
        Dec          33.0828
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.6073   0.7939  -0.0308]
        Angle    132.1687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1688"
}

Galaxy "IC 1689:MCG 5-4-46:ZWG 502.70:PRCB 3"
{
        Type  "S0"
        RA            1.3967
        Dec          33.0550
        Distance   1.944e+08  # method: V
        Radius     2.545e+04
        AbsMag        -19.08
        Axis    [ -0.1551   0.7227  -0.6735]
        Angle    195.6038
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1689"
}

Galaxy "IC 1690:ZWG 502.71:NPM 1"
{
        Type  "S0"
        RA            1.3969
        Dec          33.1569
        Distance    1.93e+08  # method: V
        Radius     1.404e+04
        AbsMag        -18.46
        Axis    [ -0.0715   0.8625  -0.5010]
        Angle    182.4399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1690"
}

Galaxy "IC 1691"
{
        Type  "S0"
        RA            1.4069
        Dec          33.4067
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.0700   0.9231  -0.3782]
        Angle    176.4993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1691"
}

Galaxy "IC 1692:ZWG 502.76"
{
        Type  "E0"
        RA            1.4108
        Dec          33.2353
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.3494   0.8139  -0.4643]
        Angle    214.0795
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1692"
}

Galaxy "IC 1693:DRCG 7-20:ZH 32"
{
        Type  "S0"
        RA            1.4006
        Dec          -1.6569
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.0403   0.6623  -0.7482]
        Angle    173.3786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1693"
}

Galaxy "IC 1694:ZWG 385.111"
{
        Type  "S0"
        RA            1.4131
        Dec           1.6078
        Distance    2.03e+08  # distance uncertain!
        Radius     1.771e+04
        AbsMag        -19.07
        Axis    [  0.4200   0.7742   0.4735]
        Angle    147.8328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1694"
}

Galaxy "IC 1695:UGC 977:MCG 1-4-55:ZWG 411.54"
{
        Type  "E0"
        RA            1.4186
        Dec           8.6992
        Distance   6.432e+08  # method: V
        Radius     6.549e+04
        AbsMag        -21.47
        Axis    [  0.7570   0.5719   0.3161]
        Angle    119.4675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1695"
}

Galaxy "IC 1696:UGC 973:MCG 0-4-122:ZWG 385.113"
{
        Type  "E0"
        RA            1.4144
        Dec          -1.6172
        Distance   2.476e+08  # method: V
        Radius     3.241e+04
        AbsMag         -19.8
        Axis    [  0.7870   0.5507   0.2780]
        Angle    132.7714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1696"
}

Galaxy "IC 1697:UGC 976:MCG 0-4-125:ZWG 385.116"
{
        Type  "S0"
        RA            1.4172
        Dec           0.4450
        Distance   3.803e+08  # method: V
        Radius     4.978e+04
        AbsMag        -20.73
        Axis    [  0.2955   0.8658  -0.4037]
        Angle    173.3393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1697"
}

Galaxy "IC 1698:UGC 983:MCG 2-4-40:ZWG 436.45"
{
        Type  "S0"
        RA            1.4228
        Dec          14.8383
        Distance   2.841e+08  # method: V
        Radius     5.371e+04
        AbsMag         -20.2
        Axis    [ -0.0541   0.8985  -0.4356]
        Angle    164.3644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1698"
}

Galaxy "IC 1701:UGC 1002:MCG 3-4-35:ZWG 459.50"
{
        Type  "E0"
        RA            1.4306
        Dec          18.1850
        Distance   4.169e+08  # distance uncertain!
        Radius     7.276e+04
        AbsMag        -20.13
        Axis    [  0.5722   0.7574  -0.3145]
        Angle    183.3111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1701"
}

Galaxy "IC 1702:UGC 1005:MCG 3-4-36:ZWG 459.51"
{
        Type  "Sc"
        RA            1.4322
        Dec          16.6011
        Distance   1.769e+08  # method: V
        Radius     3.087e+04
        AbsMag        -19.37
        Axis    [  0.0889   0.6735  -0.7338]
        Angle    208.4501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1702"
}

Galaxy "IC 1704:UGC 1027:MCG 2-4-52:ZWG 436.54"
{
        Type  "Sc"
        RA            1.4525
        Dec          14.7758
        Distance   2.739e+08  # method: V
        Radius     4.383e+04
        AbsMag        -20.52
        Axis    [  0.0561   0.6891  -0.7225]
        Angle    197.9039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1704"
}

Galaxy "IC 1705:MCG 1-4-48"
{
        Type  "E0"
        RA            1.4456
        Dec          -3.5017
        Distance   2.754e+08  # distance uncertain!
        Radius     3.606e+04
        AbsMag        -20.13
        Axis    [  0.7864   0.5191   0.3348]
        Angle    130.2624
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1705"
}

Galaxy "IC 1706-1:ZWG 436.57"
{
        Type  "E0"
        RA            1.4583
        Dec          14.8192
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.7464   0.5988   0.2904]
        Angle    114.6183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1706-1"
}

Galaxy "IC 1706-2:ZWG 436.57"
{
        Type  "E0"
        RA            1.4586
        Dec          14.8194
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.7464   0.5988   0.2904]
        Angle    114.6163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1706-2"
}

Galaxy "IC 1711:UGC 1082:MCG 3-4-52:ZWG 459.73"
{
        Type  "Sb"
        RA            1.5153
        Dec          17.1889
        Distance   1.136e+08  # method: V
        Radius     4.295e+04
        AbsMag        -18.21
        Axis    [ -0.0076   0.9723   0.2338]
        Angle    151.7939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1711"
}

Galaxy "IC 1714"
{
        Type  "SBa"
        RA            1.5481
        Dec         -13.0247
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.7891   0.4753   0.3890]
        Angle    136.9762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1714"
}

Galaxy "IC 1715:UGC 1115:MCG 2-5-2:ZWG 437.3"
{
        Type  "Irr"
        RA            1.5594
        Dec          12.5856
        Distance   1.757e+08  # method: V
        Radius     1.789e+04
        AbsMag        -19.06
        Axis    [  0.2557   0.9126  -0.3191]
        Angle    167.6644
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1715"
}

Galaxy "IC 1718:ZWG 503.2:ZWG 502.122:KUG 0135+331"
{
        Type  "E0"
        RA            1.6406
        Dec          33.3653
        Distance   3.631e+08  # distance uncertain!
        Radius     3.169e+04
        AbsMag        -20.13
        Axis    [  0.3792   0.8193  -0.4300]
        Angle    201.8890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1718"
}

Galaxy "IC 1719:ESO 353-27:MCG 6-4-59"
{
        Type  "S0"
        RA            1.6264
        Dec         -33.9242
        Distance   2.516e+08  # method: V
        Radius     5.856e+04
        AbsMag        -20.64
        Axis    [  0.3244   0.4113  -0.8518]
        Angle    180.5582
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1719"
}

Galaxy "IC 1720:ESO 413-19:MCG 5-5-8:IRAS 01380-2909"
{
        Type  "Sc"
        RA            1.6725
        Dec         -28.9139
        Distance   1.168e+08  # distance uncertain!
        Radius     2.548e+04
        AbsMag        -19.07
        Axis    [  0.3448   0.5044  -0.7916]
        Angle    179.8280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1720"
}

Galaxy "IC 1721:UGC 1187:MCG 1-5-19:ZWG 412.15"
{
        Type  "S0"
        RA            1.6900
        Dec           8.5261
        Distance   1.815e+08  # method: V
        Radius      2.64e+04
        AbsMag        -19.53
        Axis    [  0.1735   0.9490  -0.2631]
        Angle    159.6962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1721"
}

Galaxy "IC 1722:ESO 353-34:MCG 6-4-67"
{
        Type  "SBc"
        RA            1.7172
        Dec         -34.1881
        Distance   1.751e+08  # method: V
        Radius      3.82e+04
        AbsMag        -18.95
        Axis    [  0.4577   0.8867   0.0656]
        Angle    175.6322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1722"
}

Galaxy "IC 1723:UGC 1205:MCG 1-5-28:ZWG 412.22"
{
        Type  "Sb"
        RA            1.7206
        Dec           8.8889
        Distance   2.374e+08  # method: V
        Radius      1.14e+05
        AbsMag        -20.41
        Axis    [  0.1375   0.9345   0.3282]
        Angle    153.4167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1723"
}

Galaxy "IC 1724:ESO 353-35:MCG 6-4-68"
{
        Type  "Sa"
        RA            1.7192
        Dec         -34.2422
        Distance    1.63e+08  # method: V
        Radius     3.082e+04
        AbsMag        -19.39
        Axis    [  0.3764   0.7408  -0.5563]
        Angle    160.8943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1724"
}

Galaxy "IC 1725:ZWG 460.22:ZWG 482.9"
{
        Type  "Sc"
        RA            1.7531
        Dec          21.7767
        Distance    2.44e+08  # distance uncertain!
        Radius     1.065e+04
        AbsMag        -19.07
        Axis    [  0.7361   0.6218   0.2672]
        Angle    108.1985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1725"
}

Galaxy "IC 1726:ZWG 412.25:UM 135:NPM 1"
{
        Type  "E0"
        RA            1.7553
        Dec           4.6192
        Distance   2.361e+08  # method: V
        Radius      1.03e+04
        AbsMag         -19.7
        Axis    [  0.7950   0.5920   0.1323]
        Angle    134.1417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1726"
}

Galaxy "IC 1727:UGC 1249:MCG 4-5-9:ZWG 482.14"
{
        Type  "Irr"
        RA            1.7917
        Dec          27.3325
        Distance    8.71e+07  # distance uncertain!
        Radius     7.221e+04
        AbsMag        -20.13
        Axis    [ -0.1613   0.7805  -0.6040]
        Angle    175.1652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1727"
}

Galaxy "IC 1728:ESO 353-47:MCG 6-5-2:IRAS 01455-3350"
{
        Type  "SBc"
        RA            1.7956
        Dec         -33.6017
        Distance   3.865e+08  # method: V
        Radius     7.308e+04
        AbsMag        -21.27
        Axis    [  0.5670   0.6933   0.4448]
        Angle    177.1031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1728"
}

Galaxy "IC 1729:ESO 477-4:MCG 5-5-14:AM 0145-270"
{
        Type  "S0"
        RA            1.7986
        Dec         -26.8919
        Distance   5.703e+07  # method: V
        Radius     1.327e+04
        AbsMag        -17.71
        Axis    [  0.3109   0.6148  -0.7248]
        Angle    167.7536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1729"
}

Galaxy "IC 1730:MCG 4-5-15A:ZWG 482.20:NPM 1"
{
        Type  "S0"
        RA            1.8325
        Dec          22.0128
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.2194   0.9752  -0.0304]
        Angle    145.9061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1730"
}

Galaxy "IC 1731:UGC 1291:MCG 4-5-18:ZWG 482.21"
{
        Type  "SBc"
        RA            1.8367
        Dec          27.1961
        Distance   1.766e+08  # method: T-F
        Radius     3.853e+04
        AbsMag        -19.57
        Axis    [ -0.0070   0.8368  -0.5475]
        Angle    180.3723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1731"
}

Galaxy "IC 1732:UGC 1307:MCG 6-5-16:ZWG 522.21"
{
        Type  "S0"
        RA            1.8467
        Dec          35.9331
        Distance   2.102e+08  # method: V
        Radius     4.586e+04
        AbsMag        -19.05
        Axis    [ -0.1187   0.9884   0.0944]
        Angle    140.0597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1732"
}

Galaxy "IC 1733:UGC 1301:MCG 5-5-16:ZWG 503.32"
{
        Type  "E0"
        RA            1.8450
        Dec          33.0822
        Distance   2.512e+08  # distance uncertain!
        Radius     4.384e+04
        AbsMag        -20.13
        Axis    [  0.6099   0.7853  -0.1064]
        Angle    134.9470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1733"
}

Galaxy "IC 1734:ESO 353-48:MCG 6-5-3:IRAS 01470-3259"
{
        Type  "SBc"
        RA            1.8211
        Dec         -32.7433
        Distance    2.16e+08  # method: V
        Radius     5.026e+04
        AbsMag         -20.7
        Axis    [  0.7482   0.6240   0.2254]
        Angle    168.4462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1734"
}

Galaxy "IC 1735:ZW 63"
{
        Type  "S0"
        RA            1.8475
        Dec          33.0919
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.1133   0.8086  -0.5773]
        Angle    183.1243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1735"
}

Galaxy "IC 1736:UGC 1309:MCG 3-5-20:ZWG 460.32"
{
        Type  "Sc"
        RA            1.8481
        Dec          18.3025
        Distance   2.214e+08  # method: V
        Radius     3.542e+04
        AbsMag        -19.26
        Axis    [ -0.0526   0.9014  -0.4298]
        Angle    160.0383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1736"
}

Galaxy "IC 1738:MCG 2-5-61"
{
        Type  "SBb"
        RA            1.8519
        Dec          -9.7931
        Distance   6.705e+07  # method: V
        Radius          8776
        AbsMag        -16.26
        Axis    [  0.5234   0.8267  -0.2063]
        Angle    164.5070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1738"
}

Galaxy "IC 1739:ESO 354-1:MCG 6-5-7:IRAS 01483-3418"
{
        Type  "Sb"
        RA            1.8414
        Dec         -34.0556
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [  0.5670   0.7553  -0.3286]
        Angle    170.3091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1739"
}

Galaxy "IC 1741:MCG 3-5-23:NPM 1"
{
        Type  "Sa"
        RA            1.8656
        Dec         -16.7875
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.1302   0.5480  -0.8263]
        Angle    168.1552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1741"
}

Galaxy "IC 1742:MCG 4-5-23:ZWG 482.28:KARA 67"
{
        Type  "Sc"
        RA            1.8872
        Dec          22.7211
        Distance   4.302e+08  # method: V
        Radius     5.006e+04
        AbsMag         -20.5
        Axis    [  0.2883   0.9343   0.2095]
        Angle    135.2989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1742"
}

Galaxy "IC 1745:NPM 1"
{
        Type  "S0"
        RA            1.8831
        Dec         -16.6692
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.3235   0.7410  -0.5885]
        Angle    168.4738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1745"
}

Galaxy "IC 1746:UGC 1371:MCG 1-5-43:ZWG 412.42"
{
        Type  "S0"
        RA            1.9067
        Dec           4.8036
        Distance    2.03e+08  # distance uncertain!
        Radius     4.133e+04
        AbsMag        -19.07
        Axis    [  0.1268   0.9606  -0.2475]
        Angle    154.4362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1746"
}

Galaxy "IC 1748:UGC 1403:MCG 3-6-2:ZWG 460.52"
{
        Type  "SBc"
        RA            1.9356
        Dec          17.6411
        Distance   5.013e+08  # method: V
        Radius     7.292e+04
        AbsMag        -21.33
        Axis    [  0.1153   0.8469  -0.5191]
        Angle    174.4446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1748"
}

Galaxy "IC 1749:UGC 1407:MCG 1-6-1:ZWG 413.3"
{
        Type  "S0"
        RA            1.9364
        Dec           6.7456
        Distance   2.188e+08  # method: V
        Radius     2.864e+04
        AbsMag        -19.53
        Axis    [  0.1747   0.7283  -0.6626]
        Angle    185.4329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1749"
}

Galaxy "IC 1750:UGC 1412:ZWG 413.7"
{
        Type  "Sa"
        RA            1.9383
        Dec           4.0764
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.0991   0.9947   0.0256]
        Angle    151.8832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1750"
}

Galaxy "IC 1752:MCG 5-5-32:ZW 118:NPM 1"
{
        Type  "E0"
        RA            1.9542
        Dec          28.6142
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.4686   0.7962  -0.3827]
        Angle    182.9657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1752"
}

Galaxy "IC 1753:MCG 5-5-33:ZWG 503.61:ARAK 68"
{
        Type  "E0"
        RA            1.9553
        Dec          28.5894
        Distance   4.498e+08  # method: V
        Radius     2.617e+04
        AbsMag         -20.7
        Axis    [  0.7554   0.6196   0.2132]
        Angle    100.8489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1753"
}

Galaxy "IC 1754:UGC 1424:ZWG 413.11:NPM 1"
{
        Type  "E0"
        RA            1.9469
        Dec           4.0261
        Distance   3.802e+08  # distance uncertain!
        Radius     4.424e+04
        AbsMag        -20.13
        Axis    [  0.8120   0.4989   0.3029]
        Angle    120.2196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1754"
}

Galaxy "IC 1755:UGC 1428:MCG 2-6-5:ZWG 438.7"
{
        Type  "Sa"
        RA            1.9525
        Dec          14.5497
        Distance   3.468e+08  # method: V
        Radius     7.061e+04
        AbsMag        -20.33
        Axis    [ -0.1958   0.7309  -0.6538]
        Angle    158.7539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1755"
}

Galaxy "IC 1756:UGC 1429:MCG 0-6-5:ZWG 387.8"
{
        Type  "Sc"
        RA            1.9514
        Dec          -0.4683
        Distance   2.887e+08  # method: V
        Radius      5.88e+04
        AbsMag        -19.33
        Axis    [ -0.0885   0.7131  -0.6954]
        Angle    152.5064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1756"
}

Galaxy "IC 1757"
{
        Type  "Irr"
        RA            1.9531
        Dec          -0.4736
        Distance   6.919e+08  # distance uncertain!
        Radius     6.038e+04
        AbsMag        -20.13
        Axis    [  0.2303   0.9727   0.0298]
        Angle    153.5551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1757"
}

Galaxy "IC 1758"
{
        Type  "S0"
        RA            1.9478
        Dec         -16.5417
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.3632   0.9227   0.1296]
        Angle    163.5241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1758"
}

Galaxy "IC 1759:IC 1760:ESO 354-18:MCG 6-5-16"
{
        Type  "Sc"
        RA            1.9653
        Dec         -32.9872
        Distance    1.65e+08  # method: V
        Radius       3.6e+04
        AbsMag        -19.72
        Axis    [  0.3956   0.3742  -0.8387]
        Angle    194.5250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1759"
}

Galaxy "IC 1761:ZWG 387.19:NPM 1:KCPG 49B"
{
        Type  "Sa"
        RA            1.9811
        Dec           0.5689
        Distance    3.02e+08  # method: V
        Radius     3.953e+04
        AbsMag        -19.53
        Axis    [  0.3855   0.9139   0.1268]
        Angle    150.6416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1761"
}

Galaxy "IC 1762:ESO 354-17:MCG 6-5-15:IRAS 01555-3329"
{
        Type  "SBc"
        RA            1.9633
        Dec         -33.2397
        Distance   2.306e+08  # method: T-F
        Radius     6.038e+04
        AbsMag        -19.85
        Axis    [  0.3882   0.9141   0.1172]
        Angle    175.1645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1762"
}

Galaxy "IC 1763:ESO 414-20:MCG 5-5-25"
{
        Type  "Sc"
        RA            1.9864
        Dec         -27.8114
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [  0.6943   0.6953   0.1855]
        Angle    165.5552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1763"
}

Galaxy "IC 1764:UGC 1486:MCG 4-5-33:ZWG 482.44"
{
        Type  "SBb"
        RA            2.0064
        Dec          24.5797
        Distance   2.159e+08  # method: V
        Radius     3.769e+04
        AbsMag         -19.9
        Axis    [ -0.0963   0.6743  -0.7321]
        Angle    194.3059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1764"
}

Galaxy "IC 1767:MCG 2-6-12"
{
        Type  "Sa"
        RA            1.9997
        Dec         -11.0786
        Distance   2.259e+08  # method: V
        Radius     5.914e+04
        AbsMag         -19.7
        Axis    [  0.3178   0.9394  -0.1283]
        Angle    157.3749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1767"
}

Galaxy "IC 1768:MCG 4-5-26:ESO 477-21"
{
        Type  "S0"
        RA            2.0136
        Dec         -25.0264
        Distance   1.341e+08  # distance uncertain!
        Radius     1.365e+04
        AbsMag        -19.07
        Axis    [  0.8393   0.3862   0.3826]
        Angle    145.3340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1768"
}

Galaxy "IC 1769:ESO 414-21"
{
        Type  "Sc"
        RA            2.0150
        Dec         -31.9206
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.3807   0.9098  -0.1653]
        Angle    163.0929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1769"
}

Galaxy "IC 1770:UGC 1522:MCG 2-6-13:ZWG 438.15"
{
        Type  "S0"
        RA            2.0372
        Dec           9.9808
        Distance   1.959e+08  # method: V
        Radius      2.85e+04
        AbsMag        -18.99
        Axis    [  0.3782   0.9246  -0.0461]
        Angle    148.1066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1770"
}

Galaxy "IC 1771:MCG 2-6-14:ZWG 438.16:KCPG 51A"
{
        Type  "S0"
        RA            2.0375
        Dec           9.9686
        Distance   2.081e+08  # method: V
        Radius     1.513e+04
        AbsMag        -18.72
        Axis    [  0.7912   0.5362   0.2940]
        Angle    115.7859
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1771"
}

Galaxy "IC 1772:MCG 1-6-33"
{
        Type  "E0"
        RA            2.0450
        Dec           7.7456
        Distance   2.884e+08  # distance uncertain!
        Radius     2.937e+04
        AbsMag        -20.13
        Axis    [  0.8136   0.5065   0.2855]
        Angle    116.6900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1772"
}

Galaxy "IC 1774:UGC 1559:MCG 2-6-20:ZWG 438.21"
{
        Type  "SBc"
        RA            2.0664
        Dec          15.3178
        Distance   1.521e+08  # method: V
        Radius      3.54e+04
        AbsMag        -18.64
        Axis    [  0.1262   0.7986  -0.5885]
        Angle    179.3550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1774"
}

Galaxy "IC 1775:MCG 2-6-23"
{
        Type  "SBc"
        RA            2.0881
        Dec          13.5056
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [  0.7882   0.5478   0.2806]
        Angle    112.6057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1775"
}

Galaxy "IC 1776:UGC 1579:MCG 1-6-38:ZWG 413.37"
{
        Type  "SBc"
        RA            2.0875
        Dec           6.1056
        Distance   1.421e+08  # method: V
        Radius     2.686e+04
        AbsMag        -19.19
        Axis    [  0.1729   0.6747  -0.7176]
        Angle    192.3158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1776"
}

Galaxy "IC 1777:MCG 2-6-29:ZWG 438.27:NPM 1"
{
        Type  "S0"
        RA            2.1022
        Dec          15.2100
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.7856   0.5544   0.2746]
        Angle    111.1331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1777"
}

Galaxy "IC 1779:ZWG 387.35:NPM 1"
{
        Type  "E0"
        RA            2.1069
        Dec           3.7064
        Distance   4.214e+08  # method: V
        Radius     2.452e+04
        AbsMag        -20.76
        Axis    [  0.6537   0.6524  -0.3834]
        Angle    179.5376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1779"
}

Galaxy "IC 1780:MCG 2-6-32:ZWG 438.29"
{
        Type  "S0"
        RA            2.1142
        Dec          14.7222
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.2952   0.8342   0.4659]
        Angle    139.8091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1780"
}

Galaxy "IC 1781:ZWG 387.37:KUG 0204-007"
{
        Type  "S0"
        RA            2.1144
        Dec          -0.5181
        Distance   5.785e+08  # method: V
        Radius     3.366e+04
        AbsMag        -20.94
        Axis    [  0.8168   0.4811   0.3186]
        Angle    124.0918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1781"
}

Galaxy "IC 1783:ESO 354-46:MCG 6-5-37:IRAS 02079-3310"
{
        Type  "Sb"
        RA            2.1683
        Dec         -32.9397
        Distance   1.883e+08  # method: T-F
        Radius     5.477e+04
        AbsMag        -20.61
        Axis    [  0.4982   0.7567   0.4232]
        Angle    180.6062
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1783"
}

Galaxy "IC 1784:UGC 1744:MCG 5-6-19:ZWG 504.41"
{
        Type  "Sb"
        RA            2.2700
        Dec          32.6492
        Distance   3.125e+08  # method: T-F
        Radius     6.364e+04
        AbsMag        -20.81
        Axis    [  0.0021   0.9859  -0.1676]
        Angle    144.3532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1784"
}

Galaxy "IC 1785:MCG 5-6-21:ZWG 504.44:NPM 1"
{
        Type  "S0"
        RA            2.2725
        Dec          32.6669
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [ -0.1898   0.8197  -0.5405]
        Angle    167.9766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1785"
}

Galaxy "IC 1786:ZWG 413.67"
{
        Type  "S0"
        RA            2.2681
        Dec           5.1461
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.0082   0.6855  -0.7280]
        Angle    168.7893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1786"
}

Galaxy "IC 1788:ESO 415-15:MCG 5-6-11:IRAS 02136-3125"
{
        Type  "SBc"
        RA            2.2639
        Dec         -31.2011
        Distance   1.969e+08  # method: T-F
        Radius     7.447e+04
        AbsMag         -21.4
        Axis    [  0.5261   0.8187   0.2301]
        Angle    172.1530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1788"
}

Galaxy "IC 1789:UGC 1763:MCG 5-6-24:ZWG 504.49"
{
        Type  "Sa"
        RA            2.2975
        Dec          32.3956
        Distance   2.176e+08  # method: T-F
        Radius     6.964e+04
        AbsMag        -19.42
        Axis    [  0.0007   0.9068   0.4215]
        Angle    134.1214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1789"
}

Galaxy "IC 1790:UGC 1762:MCG 2-6-55:ZWG 438.50"
{
        Type  "Sc"
        RA            2.2936
        Dec          12.5092
        Distance   1.514e+08  # method: V
        Radius     2.202e+04
        AbsMag        -17.73
        Axis    [  0.1157   0.9931   0.0183]
        Angle    143.4495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1790"
}

Galaxy "IC 1791:UGC 1764:MCG 2-6-56:ZWG 438.51"
{
        Type  "S0"
        RA            2.2947
        Dec          12.4703
        Distance   1.583e+08  # method: V
        Radius     2.303e+04
        AbsMag        -19.03
        Axis    [  0.8085   0.5214   0.2729]
        Angle    112.2809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1791"
}

Galaxy "IC 1792:UGC 1781:MCG 6-6-15:ZWG 523.18"
{
        Type  "Sb"
        RA            2.3169
        Dec          34.4617
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.2576   0.9356   0.2416]
        Angle    121.7709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1792"
}

Galaxy "IC 1793:UGC 1816:MCG 5-6-27:ZWG 504.62"
{
        Type  "Sb"
        RA            2.3589
        Dec          32.5442
        Distance   3.914e+08  # method: T-F
        Radius     8.538e+04
        AbsMag         -20.6
        Axis    [  0.0846   0.9425   0.3235]
        Angle    129.0415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1793"
}

Galaxy "IC 1794:MCG 3-7-3:ZWG 462.4:NPM 1"
{
        Type  "Sa"
        RA            2.3583
        Dec          15.7622
        Distance   1.697e+08  # method: V
        Radius     2.222e+04
        AbsMag        -18.38
        Axis    [  0.2554   0.8810  -0.3983]
        Angle    161.1870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1794"
}

Galaxy "IC 1796:ESO 298-38:MCG 7-6-1"
{
        Type  "S0"
        RA            2.3797
        Dec         -41.3708
        Distance   2.225e+08  # method: V
        Radius      3.56e+04
        AbsMag        -19.97
        Axis    [  0.7283   0.6068  -0.3184]
        Angle    172.1345
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1796"
}

Galaxy "IC 1797:UGC 1880:MCG 3-7-10:ZWG 462.10"
{
        Type  "SBc"
        RA            2.4242
        Dec          20.3956
        Distance   1.657e+08  # method: V
        Radius     1.687e+04
        AbsMag        -18.13
        Axis    [ -0.1711   0.8281  -0.5339]
        Angle    154.1031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1797"
}

Galaxy "IC 1798"
{
        Type  "E0"
        RA            2.4375
        Dec          13.4308
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.8357   0.4911   0.2456]
        Angle    109.9263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1798"
}

Galaxy "IC 1799:UGC 1943:MCG 8-5-12:ZWG 553.14"
{
        Type  "S0"
        RA            2.4792
        Dec          45.9711
        Distance   2.187e+08  # method: V
        Radius     3.499e+04
        AbsMag        -19.43
        Axis    [  0.0103   0.9373   0.3483]
        Angle    119.2014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1799"
}

Galaxy "IC 1801:UGC 1936:MCG 3-7-16:ZWG 462.15"
{
        Type  "SBb"
        RA            2.4700
        Dec          19.5831
        Distance   1.714e+08  # method: V
        Radius     3.988e+04
        AbsMag           -19
        Axis    [  0.1962   0.9522   0.2343]
        Angle    135.2113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1801"
}

Galaxy "IC 1802:MCG 4-6-57:ZWG 483.67:NPM 1"
{
        Type  "S0"
        RA            2.4869
        Dec          23.0833
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [  0.2259   0.8731  -0.4321]
        Angle    165.0269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1802"
}

Galaxy "IC 1803"
{
        Type  "E0"
        RA            2.4881
        Dec          23.1408
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.8199   0.5319   0.2118]
        Angle    101.5981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1803"
}

Galaxy "IC 1804-1:MCG 4-6-60:ZWG 783.68:NPM 1"
{
        Type  "E0"
        RA            2.4983
        Dec          23.0972
        Distance   3.312e+08  # distance uncertain!
        Radius     3.853e+04
        AbsMag        -20.13
        Axis    [  0.8209   0.5305   0.2115]
        Angle    101.5717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1804-1"
}

Galaxy "IC 1804-2:MCG 4-6-58"
{
        Type  "E0"
        RA            2.4969
        Dec          23.1086
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.8207   0.5307   0.2115]
        Angle    101.5707
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1804-2"
}

Galaxy "IC 1806:NPM 1"
{
        Type  "E0"
        RA            2.4928
        Dec          22.9439
        Distance   5.755e+08  # distance uncertain!
        Radius     5.859e+04
        AbsMag        -20.13
        Axis    [  0.3996   0.7478  -0.5303]
        Angle    195.9309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1806"
}

Galaxy "IC 1807:MCG 4-6-62:ZWG 483.71:NPM 1"
{
        Type  "E0"
        RA            2.5083
        Dec          22.9503
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.8221   0.5286   0.2115]
        Angle    101.6321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1807"
}

Galaxy "IC 1809:UGC 1996:MCG 4-7-4:ZWG 484.2"
{
        Type  "SBb"
        RA            2.5278
        Dec          22.9175
        Distance    2.42e+08  # method: V
        Radius     3.168e+04
        AbsMag        -19.45
        Axis    [  0.1243   0.8556  -0.5024]
        Angle    168.4404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1809"
}

Galaxy "IC 1810:ESO 246-18:MCG 7-6-9"
{
        Type  "SBb"
        RA            2.4906
        Dec         -43.0767
        Distance   2.389e+08  # method: V
        Radius     4.517e+04
        AbsMag        -20.12
        Axis    [  0.5862   0.5418  -0.6023]
        Angle    169.0994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1810"
}

Galaxy "IC 1811:ESO 355-20:MCG 6-6-8:AM 0228-342"
{
        Type  "SBb"
        RA            2.5106
        Dec         -34.2647
        Distance   2.091e+08  # method: V
        Radius     3.953e+04
        AbsMag        -19.73
        Axis    [  0.6738   0.6455   0.3595]
        Angle    169.9305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1811"
}

Galaxy "IC 1812:ESO 246-19:MCG 7-6-8:AM 0227-430"
{
        Type  "E0"
        RA            2.4919
        Dec         -42.8114
        Distance   2.273e+08  # method: V
        Radius     6.612e+04
        AbsMag        -21.02
        Axis    [  0.9409   0.2913   0.1728]
        Angle    165.3897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1812"
}

Galaxy "IC 1813:ESO 355-22:MCG 6-6-9:AM 0228-342"
{
        Type  "Sa"
        RA            2.5136
        Dec         -34.2217
        Distance   1.938e+08  # method: V
        Radius     3.382e+04
        AbsMag        -19.67
        Axis    [  0.5651   0.6972  -0.4411]
        Angle    163.0691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1813"
}

Galaxy "IC 1815:UGC 2047:MCG 5-7-14:ZWG 505.13"
{
        Type  "S0"
        RA            2.5719
        Dec          32.4300
        Distance    1.54e+08  # distance uncertain!
        Radius     3.135e+04
        AbsMag        -19.07
        Axis    [  0.0123   0.8456  -0.5337]
        Angle    176.3689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1815"
}

Galaxy "IC 1816:ESO 355-25:MCG 6-6-11:FAIR 1090"
{
        Type  "SBb"
        RA            2.5308
        Dec         -36.6722
        Distance   2.269e+08  # method: V
        Radius      4.62e+04
        AbsMag        -20.31
        Axis    [  0.3420   0.3805  -0.8592]
        Angle    178.5686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1816"
}

Galaxy "IC 1817-1:MCG 2-7-14:ZWG 439.16:KCPG 70A"
{
        Type  "Irr"
        RA            2.5636
        Dec          11.2033
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [  0.3990   0.8077   0.4340]
        Angle    136.4517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1817-1"
}

Galaxy "IC 1817-2:MCG 2-7-15:ZWG 439.16:KCPG 70B"
{
        Type  "Sc"
        RA            2.5639
        Dec          11.2028
        Distance   4.241e+08  # distance uncertain!
        Radius     4.318e+04
        AbsMag        -19.07
        Axis    [ -0.0335   0.7028  -0.7106]
        Angle    170.4116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1817-2"
}

Galaxy "IC 1818:NPM 1"
{
        Type  "E0"
        RA            2.5686
        Dec         -11.0403
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.8782   0.3728   0.2997]
        Angle    130.3849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1818"
}

Galaxy "IC 1819:ZWG 414.23:KARA 110:NPM 1"
{
        Type  "S0"
        RA            2.5947
        Dec           4.0522
        Distance   1.851e+08  # distance uncertain!
        Radius     4.308e+04
        AbsMag        -19.07
        Axis    [  0.3220   0.9184   0.2300]
        Angle    143.4203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1819"
}

Galaxy "IC 1820:ZWG 414.24"
{
        Type  "S0"
        RA            2.5978
        Dec           6.0408
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [  0.2335   0.9702  -0.0644]
        Angle    142.4010
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1820"
}

Galaxy "IC 1821-1:ZWG 439.20:NPM 1"
{
        Type  "S0"
        RA            2.6069
        Dec          13.7806
        Distance   2.226e+08  # distance uncertain!
        Radius     1.942e+04
        AbsMag        -19.07
        Axis    [  0.2667   0.9265  -0.2653]
        Angle    147.3104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1821-1"
}

Galaxy "IC 1821-2:ZWG 439.20"
{
        Type  "S0"
        RA            2.6072
        Dec          13.7797
        Distance    6.13e+08  # distance uncertain!
        Radius     2.675e+04
        AbsMag        -19.07
        Axis    [  0.4988   0.7235   0.4772]
        Angle    128.0675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1821-2"
}

Galaxy "IC 1823:UGC 2125:MCG 5-7-24:ZWG 505.27"
{
        Type  "SBc"
        RA            2.6433
        Dec          32.0703
        Distance   2.253e+08  # method: V
        Radius     6.881e+04
        AbsMag         -19.7
        Axis    [  0.4364   0.8783  -0.1954]
        Angle    138.2988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1823"
}

Galaxy "IC 1825:UGC 2138:ZWG 414.31:KARA 115"
{
        Type  "Sc"
        RA            2.6486
        Dec           9.0969
        Distance   2.217e+08  # method: V
        Radius     3.869e+04
        AbsMag        -19.46
        Axis    [  0.5069   0.7880   0.3494]
        Angle    132.6221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1825"
}

Galaxy "IC 1826:IC 1830:ESO 416-6:MCG 5-7-12"
{
        Type  "SBa"
        RA            2.6508
        Dec         -27.4431
        Distance   1.804e+08  # method: T-F
        Radius      4.46e+04
        AbsMag        -20.01
        Axis    [  0.4418   0.5658  -0.6962]
        Angle    171.5066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1826"
}

Galaxy "IC 1827:UGC 2152:MCG 0-7-75:ZWG 388.89"
{
        Type  "Sa"
        RA            2.6628
        Dec           1.5583
        Distance   2.571e+08  # method: V
        Radius     4.114e+04
        AbsMag        -19.88
        Axis    [ -0.1374   0.7193  -0.6810]
        Angle    143.1686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1827"
}

Galaxy "IC 1829:ZWG 439.26"
{
        Type  "E0"
        RA            2.6756
        Dec          14.2981
        Distance   4.571e+08  # distance uncertain!
        Radius     5.319e+04
        AbsMag        -20.13
        Axis    [  0.8534   0.4679   0.2296]
        Angle    107.9599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1829"
}

Galaxy "IC 1832:MCG 3-7-45:ZWG 462.44:NPM 1"
{
        Type  "S0"
        RA            2.6992
        Dec          19.0306
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.5665   0.8087   0.1583]
        Angle    123.0292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1832"
}

Galaxy "IC 1833:ESO 416-7:MCG 5-7-13"
{
        Type  "S0"
        RA            2.6939
        Dec         -28.1717
        Distance   2.155e+08  # method: V
        Radius       4.7e+04
        AbsMag           -20
        Axis    [  0.5683   0.8182  -0.0873]
        Angle    158.7278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1833"
}

Galaxy "IC 1834:UGC 2189:MCG 0-7-85:ZWG 388.99"
{
        Type  "Sb"
        RA            2.7133
        Dec           3.0839
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.2019   0.6596  -0.7240]
        Angle    185.5356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1834"
}

Galaxy "IC 1835-1:ZWG 439.27:ZWG 440.1:Z 0241.1"
{
        Type  "S0"
        RA            2.7303
        Dec          14.8894
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.8405   0.4843   0.2429]
        Angle    107.8789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1835-1"
}

Galaxy "IC 1835-2:ZWG 439.27:ZWG 440.1:Z 0241.1"
{
        Type  "E0"
        RA            2.7300
        Dec          14.8869
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.8217   0.5690   0.0316]
        Angle    120.1822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1835-2"
}

Galaxy "IC 1836:MCG 0-7-87:ZWG 388.102"
{
        Type  "S0"
        RA            2.7231
        Dec           3.1050
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.8588   0.4349   0.2707]
        Angle    118.2011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1836"
}

Galaxy "IC 1838-1:MCG 3-8-2:ZWG 463.5"
{
        Type  "Sc"
        RA            2.7453
        Dec          19.4550
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.4519   0.7375   0.5018]
        Angle    124.6814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1838-1"
}

Galaxy "IC 1838-2:MCG 3-8-2:ZWG 463.5"
{
        Type  "S0"
        RA            2.7453
        Dec          19.4589
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.3968   0.7524   0.5257]
        Angle    128.4708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1838-2"
}

Galaxy "IC 1839:UGC 2220:MCG 2-8-1:ZWG 440.2"
{
        Type  "Sc"
        RA            2.7453
        Dec          15.2394
        Distance    3.42e+08  # method: T-F
        Radius     4.974e+04
        AbsMag           -20
        Axis    [  0.1307   0.9492  -0.2863]
        Angle    143.7099
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1839"
}

Galaxy "IC 1841:ZWG 463.7"
{
        Type  "SBb"
        RA            2.7600
        Dec          18.9292
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.4034   0.9141   0.0408]
        Angle    130.5806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1841"
}

Galaxy "IC 1842:ZWG 440.3:KARA 117"
{
        Type  "S0"
        RA            2.7564
        Dec          11.4589
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.2519   0.8974   0.3623]
        Angle    140.1025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1842"
}

Galaxy "IC 1843:UGC 2228:MCG 0-8-4:ZWG 389.4"
{
        Type  "SBb"
        RA            2.7567
        Dec           2.8806
        Distance   2.977e+08  # method: V
        Radius     4.762e+04
        AbsMag         -20.7
        Axis    [  0.4061   0.9051  -0.1261]
        Angle    143.2568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1843"
}

Galaxy "IC 1844:MCG 0-8-7:ZWG 389.6"
{
        Type  "Sa"
        RA            2.7636
        Dec           3.2306
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.1286   0.9231  -0.3624]
        Angle    143.8678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1844"
}

Galaxy "IC 1845:MCG 5-7-18:ESO 416-15:AM 0243-281"
{
        Type  "Sb"
        RA            2.7603
        Dec         -27.9608
        Distance   1.341e+08  # distance uncertain!
        Radius     2.731e+04
        AbsMag        -19.07
        Axis    [  0.3966   0.6990  -0.5951]
        Angle    154.9064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1845"
}

Galaxy "IC 1847:ZWG 440.10:NPM 1"
{
        Type  "S0"
        RA            2.7981
        Dec          14.5056
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.1322   0.8071  -0.5754]
        Angle    166.2925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1847"
}

Galaxy "IC 1849:MCG 1-8-2:ZWG 415.9:KARA 118"
{
        Type  "E0"
        RA            2.7956
        Dec           9.3567
        Distance   4.169e+08  # distance uncertain!
        Radius     5.457e+04
        AbsMag        -20.13
        Axis    [  0.6539   0.6570  -0.3753]
        Angle    163.3958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1849"
}

Galaxy "IC 1853:MCG 2-8-6:IRAS 02457-1410"
{
        Type  "Sb"
        RA            2.8011
        Dec         -13.9933
        Distance   1.798e+08  # method: V
        Radius     2.877e+04
        AbsMag        -18.71
        Axis    [  0.3103   0.9046  -0.2924]
        Angle    145.9483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1853"
}

Galaxy "IC 1854:MK 372:ZWG 463.20:NPM 1"
{
        Type  "S0"
        RA            2.8222
        Dec          19.3044
        Distance   4.115e+08  # method: V
        Radius     3.591e+04
        AbsMag         -20.5
        Axis    [  0.0353   0.7235  -0.6894]
        Angle    185.7776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1854"
}

Galaxy "IC 1855"
{
        Type  "E0"
        RA            2.8178
        Dec          13.4428
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.8659   0.4474   0.2236]
        Angle    107.9917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1855"
}

Galaxy "IC 1856:UGC 2291:MCG 0-8-21:ZWG 389.21"
{
        Type  "SBb"
        RA            2.8139
        Dec          -0.7672
        Distance    2.84e+08  # method: V
        Radius     4.544e+04
        AbsMag         -20.3
        Axis    [  0.4112   0.9111  -0.0298]
        Angle    142.4787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1856"
}

Galaxy "IC 1857:UGC 2312:MCG 2-8-13:ZWG 440.16"
{
        Type  "Sc"
        RA            2.8272
        Dec          14.6200
        Distance    4.01e+08  # method: V
        Radius     5.832e+04
        AbsMag        -20.35
        Axis    [ -0.0655   0.7637  -0.6422]
        Angle    160.2942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1857"
}

Galaxy "IC 1858:ESO 416-29:MCG 5-7-33:DRCG 42-18"
{
        Type  "Sa"
        RA            2.8189
        Dec         -31.2894
        Distance   2.657e+08  # method: V
        Radius     6.569e+04
        AbsMag        -20.45
        Axis    [  0.0768   0.4659  -0.8815]
        Angle    137.9165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1858"
}

Galaxy "IC 1859:ESO 416-28:MCG 5-7-32:DRCG 42-29"
{
        Type  "Sc"
        RA            2.8175
        Dec         -31.1725
        Distance   1.806e+08  # method: T-F
        Radius     3.152e+04
        AbsMag        -19.42
        Axis    [  0.6865   0.6905   0.2280]
        Angle    163.9940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1859"
}

Galaxy "IC 1860:ESO 416-31:MCG 5-7-35:AM 0247-312"
{
        Type  "E4"
        RA            2.8258
        Dec         -31.1897
        Distance   3.077e+08  # method: V
        Radius     9.847e+04
        AbsMag        -21.47
        Axis    [  0.9189   0.2899   0.2675]
        Angle    149.4242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1860"
}

Galaxy "IC 1861:UGC 2357:MCG 4-7-28:ZWG 484.23"
{
        Type  "S0"
        RA            2.8853
        Dec          25.4903
        Distance   2.943e+08  # method: V
        Radius     5.137e+04
        AbsMag        -20.38
        Axis    [ -0.0567   0.7940  -0.6053]
        Angle    169.8771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1861"
}

Galaxy "IC 1862:ESO 356-15:MCG 6-7-10:FGCE 272"
{
        Type  "Sc"
        RA            2.8661
        Dec         -33.3400
        Distance   2.531e+08  # method: T-F
        Radius     1.104e+05
        AbsMag        -19.95
        Axis    [  0.4407   0.8132   0.3802]
        Angle    182.1752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1862"
}

Galaxy "IC 1863:MCG 1-8-15:ZWG 415.24:NPM 1"
{
        Type  "E0"
        RA            2.9139
        Dec           8.7850
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.8799   0.4161   0.2296]
        Angle    111.6173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1863"
}

Galaxy "IC 1864:ESO 356-17:MCG 6-7-11:AM 0251-342"
{
        Type  "E0"
        RA            2.8942
        Dec         -34.1981
        Distance   1.964e+08  # method: V
        Radius     3.427e+04
        AbsMag         -21.1
        Axis    [  0.9147   0.3501  -0.2019]
        Angle    170.0774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1864"
}

Galaxy "IC 1865:UGC 2391:MCG 1-8-17:ZWG 415.26"
{
        Type  "Sc"
        RA            2.9222
        Dec           8.8281
        Distance   3.532e+08  # method: V
        Radius     7.706e+04
        AbsMag        -20.37
        Axis    [  0.3555   0.8849  -0.3009]
        Angle    145.8256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1865"
}

Galaxy "IC 1866:MCG 3-8-44:NPM 1"
{
        Type  "S0"
        RA            2.9144
        Dec         -15.6528
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.4724   0.8144  -0.3371]
        Angle    151.2012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1866"
}

Galaxy "IC 1867:UGC 2400:MCG 1-8-19:ZWG 415.29"
{
        Type  "S0"
        RA            2.9311
        Dec           9.3122
        Distance   1.938e+08  # distance uncertain!
        Radius     4.229e+04
        AbsMag        -19.07
        Axis    [  0.6204   0.7258   0.2972]
        Angle    126.2284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1867"
}

Galaxy "IC 1868:NPM 1"
{
        Type  "S0"
        RA            2.9347
        Dec           9.3794
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.4407   0.8852  -0.1488]
        Angle    139.2483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1868"
}

Galaxy "IC 1869:ZWG 415.44:DRCG 9-21"
{
        Type  "S0"
        RA            2.9697
        Dec           5.8367
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.0261   0.8858  -0.4633]
        Angle    141.6444
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1869"
}

Galaxy "IC 1870:MCG 1-8-20:UGCA 46:KUG 0255-025"
{
        Type  "Irr"
        RA            2.9647
        Dec          -2.3467
        Distance   6.048e+07  # method: V
        Radius     2.463e+04
        AbsMag        -17.54
        Axis    [  0.1648   0.7801  -0.6036]
        Angle    153.1861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1870"
}

Galaxy "IC 1873-1:MCG 1-8-39:ZWG 415.57:VV 383"
{
        Type  "S0"
        RA            3.0644
        Dec           9.6139
        Distance   4.066e+08  # method: V
        Radius     6.505e+04
        AbsMag        -19.98
        Axis    [  0.5112   0.8151   0.2728]
        Angle    129.7143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1873-1"
}

Galaxy "IC 1873-2:MCG 1-8-39:ZWG 415.57:VV 383"
{
        Type  "E0"
        RA            3.0644
        Dec           9.6103
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.8895   0.4017   0.2179]
        Angle    110.2408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1873-2"
}

Galaxy "IC 1874:MCG 6-7-39:ZWG 524.50:NPM 1"
{
        Type  "SBa"
        RA            3.1058
        Dec          36.0150
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.0973   0.9616  -0.2566]
        Angle    138.5536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1874"
}

Galaxy "IC 1875:ESO 300-6:MCG 7-7-2:AM 0302-393"
{
        Type  "S0"
        RA            3.0656
        Dec         -39.4408
        Distance   2.701e+08  # method: V
        Radius       5.5e+04
        AbsMag        -21.09
        Axis    [  0.8042   0.4953   0.3285]
        Angle    166.2673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1875"
}

Galaxy "IC 1876:ESO 417-13:MCG 5-8-13:HARO 17"
{
        Type  "S0"
        RA            3.0756
        Dec         -27.4600
        Distance   2.894e+08  # method: V
        Radius     4.631e+04
        AbsMag        -20.44
        Axis    [  0.8131   0.4825   0.3256]
        Angle    152.9781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1876"
}

Galaxy "IC 1877:ESO 199-11"
{
        Type  "Sb"
        RA            3.0525
        Dec         -50.5114
        Distance   3.868e+08  # distance uncertain!
        Radius       4.5e+04
        AbsMag        -19.07
        Axis    [  0.2958   0.5195  -0.8016]
        Angle    128.7672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1877"
}

Galaxy "IC 1878-1:ESO 199-13:FAIR 734:AM 0302-521"
{
        Type  "SBb"
        RA            3.0611
        Dec         -52.1078
        Distance   3.217e+08  # distance uncertain!
        Radius     5.615e+04
        AbsMag        -19.07
        Axis    [  0.2776   0.2801  -0.9189]
        Angle    153.0088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1878-1"
}

Galaxy "IC 1878-2:ESO 199-13:FAIR 735:AM 0302-521"
{
        Type  "Sa"
        RA            3.0619
        Dec         -52.1017
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.6994   0.7115  -0.0679]
        Angle    171.6628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1878-2"
}

Galaxy "IC 1879:ESO 199-14:FAIR 736:AM 0302-522"
{
        Type  "S0"
        RA            3.0644
        Dec         -52.1178
        Distance   5.893e+08  # method: V
        Radius     1.028e+05
        AbsMag        -20.38
        Axis    [  0.3620   0.6424  -0.6755]
        Angle    129.9387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1879"
}

Galaxy "IC 1880:MCG 2-8-49:NPM 1"
{
        Type  "S0"
        RA            3.1078
        Dec          -9.7306
        Distance   4.553e+08  # method: V
        Radius     1.059e+05
        AbsMag        -21.72
        Axis    [  0.6285   0.7595   0.1676]
        Angle    143.4057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1880"
}

Galaxy "IC 1882:UGC 2551:MCG 0-9-2:ZWG 390.3"
{
        Type  "Sc"
        RA            3.1303
        Dec           3.1472
        Distance   3.167e+08  # method: V
        Radius     4.145e+04
        AbsMag        -19.84
        Axis    [  0.5107   0.8018   0.3105]
        Angle    135.9312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1882"
}

Galaxy "IC 1885:ESO 357-3"
{
        Type  "Sc"
        RA            3.1111
        Dec         -32.8642
        Distance   2.269e+08  # method: T-F
        Radius      4.62e+04
        AbsMag        -19.31
        Axis    [  0.2708   0.6635  -0.6975]
        Angle    139.4854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1885"
}

Galaxy "IC 1886:MCG 1-9-1"
{
        Type  "S0"
        RA            3.1342
        Dec          -4.4000
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.6366   0.6460   0.4212]
        Angle    139.4927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1886"
}

Galaxy "IC 1890:MCG 3-9-4:ZWG 464.5:NPM 1"
{
        Type  "S0"
        RA            3.1661
        Dec          19.2086
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.8680   0.4505   0.2088]
        Angle    101.8690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1890"
}

Galaxy "IC 1891"
{
        Type  "S0"
        RA            3.1700
        Dec          19.6067
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.4191   0.9022   0.1019]
        Angle    123.9440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1891"
}

Galaxy "IC 1892:ESO 480-36:MCG 4-8-30:UGCA 55"
{
        Type  "SBa"
        RA            3.1408
        Dec         -23.0556
        Distance   1.236e+08  # method: V
        Radius     3.416e+04
        AbsMag        -19.09
        Axis    [  0.6366   0.7006   0.3222]
        Angle    158.1841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1892"
}

Galaxy "IC 1893"
{
        Type  "S0"
        RA            3.1711
        Dec          19.6169
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.2968   0.9480   0.1152]
        Angle    126.1593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1893"
}

Galaxy "IC 1894:ZWG 464.6:NPM 1"
{
        Type  "S0"
        RA            3.1736
        Dec          19.6072
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.3804   0.7717   0.5097]
        Angle    128.4654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1894"
}

Galaxy "IC 1895:ESO 481-1:MCG 4-8-33:AM 0307-252"
{
        Type  "SBa"
        RA            3.1600
        Dec         -25.2533
        Distance   1.661e+08  # method: V
        Radius     3.624e+04
        AbsMag        -19.43
        Axis    [  0.2720   0.5361  -0.7991]
        Angle    161.7854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1895"
}

Galaxy "IC 1896:ESO 155-4"
{
        Type  "Sb"
        RA            3.1311
        Dec         -54.2139
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.6750   0.7114   0.1957]
        Angle    185.4108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1896"
}

Galaxy "IC 1897:MCG 2-9-9:NPM 1:IRAS 03083-1059"
{
        Type  "SBa"
        RA            3.1792
        Dec         -10.7956
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.9046   0.3359   0.2624]
        Angle    129.0539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1897"
}

Galaxy "IC 1898:ESO 481-2:MCG 4-8-36:UGCA 56"
{
        Type  "SBc"
        RA            3.1722
        Dec         -22.4039
        Distance   7.565e+07  # method: T-F
        Radius     3.961e+04
        AbsMag        -18.23
        Axis    [  0.3193   0.9379  -0.1353]
        Angle    143.8932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1898"
}

Galaxy "IC 1899:ESO 481-8:MCG 4-8-41:IRAS 03100-2529"
{
        Type  "Sa"
        RA            3.2036
        Dec         -25.3050
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.0466   0.5577  -0.8287]
        Angle    133.7003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1899"
}

Galaxy "IC 1900:MCG 6-8-7:ZWG 525.13:NPM 1"
{
        Type  "S0"
        RA            3.2653
        Dec          37.1547
        Distance   2.125e+08  # distance uncertain!
        Radius     1.546e+04
        AbsMag        -19.07
        Axis    [  0.1660   0.9451  -0.2816]
        Angle    138.4206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1900"
}

Galaxy "IC 1901:MCG 6-8-8:ZWG 525.14:NPM 1"
{
        Type  "S0"
        RA            3.2672
        Dec          37.1131
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [ -0.4151   0.6703  -0.6151]
        Angle    159.4184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1901"
}

Galaxy "IC 1902:ZWG 525.15:NPM 1"
{
        Type  "Sa"
        RA            3.2700
        Dec          37.1781
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.8388   0.5206   0.1591]
        Angle     85.4976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1902"
}

Galaxy "IC 1903-1:ESO 199-24"
{
        Type  "S0"
        RA            3.2189
        Dec         -50.5619
        Distance   4.241e+08  # distance uncertain!
        Radius     3.701e+04
        AbsMag        -19.07
        Axis    [  0.3689   0.5468  -0.7516]
        Angle    135.0850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1903-1"
}

Galaxy "IC 1903-2:ESO 199-24"
{
        Type  "S0"
        RA            3.2200
        Dec         -50.5781
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.6355   0.7210   0.2762]
        Angle    186.6245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1903-2"
}

Galaxy "IC 1904:ESO 417-22:MCG 5-8-24:AM 0312-305"
{
        Type  "SBb"
        RA            3.2500
        Dec         -30.7083
        Distance   2.041e+08  # method: V
        Radius     4.156e+04
        AbsMag        -19.58
        Axis    [  0.4104   0.7642  -0.4975]
        Angle    143.9415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1904"
}

Galaxy "IC 1906:ESO 357-11:MCG 6-8-1:IRAS 03141-3432"
{
        Type  "SBc"
        RA            3.2681
        Dec         -34.3600
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.5209   0.8444  -0.1255]
        Angle    153.1823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1906"
}

Galaxy "IC 1908-1:ESO 155-13:AM 0313-545:IRAS 03137-5500"
{
        Type  "SBb"
        RA            3.2514
        Dec         -54.8192
        Distance   3.681e+08  # method: V
        Radius      6.96e+04
        AbsMag        -20.66
        Axis    [  0.8021   0.5945  -0.0562]
        Angle    174.1183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1908-1"
}

Galaxy "IC 1908-2:ESO 155-13A:AM 0313-545"
{
        Type  "S0"
        RA            3.2514
        Dec         -54.8219
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.3612   0.3470  -0.8656]
        Angle    147.1384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1908-2"
}

Galaxy "IC 1909:ESO 357-14:MCG 6-8-3"
{
        Type  "SBb"
        RA            3.2889
        Dec         -33.6903
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [  0.6082   0.7841  -0.1236]
        Angle    154.8776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1909"
}

Galaxy "IC 1912:ESO 200-1:IRAS 03151-5050"
{
        Type  "S0"
        RA            3.2786
        Dec         -50.6550
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.5539   0.7897   0.2637]
        Angle    189.7420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1912"
}

Galaxy "IC 1913:ESO 357-16:MCG 5-8-27:AM 0317-323"
{
        Type  "SBb"
        RA            3.3261
        Dec         -32.4650
        Distance   8.385e+07  # method: T-F
        Radius     2.317e+04
        AbsMag        -17.65
        Axis    [  0.1328   0.6511  -0.7473]
        Angle    124.8379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1913"
}

Galaxy "IC 1914:ESO 200-3:IRAS 03179-4946"
{
        Type  "SBc"
        RA            3.3236
        Dec         -49.5992
        Distance   7.076e+07  # method: T-F
        Radius     3.499e+04
        AbsMag        -18.38
        Axis    [  0.5813   0.6629  -0.4719]
        Angle    151.4785
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1914"
}

Galaxy "IC 1915:ESO 200-5"
{
        Type  "SBa"
        RA            3.3308
        Dec         -50.6919
        Distance   3.694e+08  # distance uncertain!
        Radius     3.223e+04
        AbsMag        -19.07
        Axis    [  0.7812   0.4971  -0.3777]
        Angle    167.7379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1915"
}

Galaxy "IC 1916:ESO 200-8:AM 0318-491"
{
        Type  "SBa"
        RA            3.3378
        Dec         -49.0417
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.7722   0.4845  -0.4111]
        Angle    167.6658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1916"
}

Galaxy "IC 1917:ESO 155-"
{
        Type  "E0"
        RA            3.3700
        Dec         -53.1856
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.9406   0.1704   0.2937]
        Angle    167.4129
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1917"
}

Galaxy "IC 1918:ZWG 416.9:NPM 1"
{
        Type  "S0"
        RA            3.4381
        Dec           4.5417
        Distance    2.03e+08  # distance uncertain!
        Radius     1.181e+04
        AbsMag        -19.07
        Axis    [ -0.0660   0.6781  -0.7320]
        Angle    152.5173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1918"
}

Galaxy "IC 1919:ESO 358-1:MCG 6-8-15:AM 0324-330"
{
        Type  "S0"
        RA            3.4339
        Dec         -32.8947
        Distance   5.963e+07  # method: S
        Radius     1.127e+04
        AbsMag        -17.51
        Axis    [  0.6676   0.6440  -0.3737]
        Angle    155.5509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1919"
}

Galaxy "IC 1920:DRCG 44-152"
{
        Type  "SBa"
        RA            3.4067
        Dec         -52.7136
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [  0.3639   0.3087  -0.8788]
        Angle    156.6651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1920"
}

Galaxy "IC 1922:ESO 200-13"
{
        Type  "S0"
        RA            3.4119
        Dec         -50.7403
        Distance   5.098e+08  # distance uncertain!
        Radius     2.966e+04
        AbsMag        -19.07
        Axis    [  0.7088   0.7028  -0.0598]
        Angle    168.5673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1922"
}

Galaxy "IC 1923"
{
        Type  "Sa"
        RA            3.4147
        Dec         -50.5556
        Distance   6.721e+08  # distance uncertain!
        Radius     4.888e+04
        AbsMag        -19.07
        Axis    [  0.5836   0.7014  -0.4093]
        Angle    150.9886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1923"
}

Galaxy "IC 1924:ESO 200-17"
{
        Type  "S0"
        RA            3.4186
        Dec         -51.7033
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [  0.7098   0.6333  -0.3083]
        Angle    161.5815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1924"
}

Galaxy "IC 1925:IC 1929:ESO 200-21"
{
        Type  "Sb"
        RA            3.4236
        Dec         -51.2667
        Distance   5.977e+08  # method: V
        Radius     6.955e+04
        AbsMag        -21.41
        Axis    [  0.4635   0.3858  -0.7977]
        Angle    157.4781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1925"
}

Galaxy "IC 1926:ESO 200-20"
{
        Type  "S0"
        RA            3.4217
        Dec         -51.7011
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.6175   0.7155  -0.3267]
        Angle    155.3301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1926"
}

Galaxy "IC 1928:ESO 548-20:MCG 4-9-13"
{
        Type  "Sb"
        RA            3.4581
        Dec         -21.5597
        Distance   1.869e+08  # method: V
        Radius      4.35e+04
        AbsMag        -19.69
        Axis    [  0.4660   0.8634   0.1933]
        Angle    154.7481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1928"
}

Galaxy "IC 1930"
{
        Type  "E0"
        RA            3.4794
        Dec           4.3839
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.9218   0.3320   0.2002]
        Angle    113.4020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1930"
}

Galaxy "IC 1931:MCG 0-9-87:ZWG 390.94"
{
        Type  "E0"
        RA            3.4825
        Dec           1.7506
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.9242   0.3225   0.2047]
        Angle    115.8225
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1931"
}

Galaxy "IC 1932:ESO 200-22:FAIR 747"
{
        Type  "S0"
        RA            3.4317
        Dec         -51.3428
        Distance   5.386e+08  # method: V
        Radius     5.484e+04
        AbsMag        -20.69
        Axis    [  0.8666   0.4649   0.1815]
        Angle    174.2764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1932"
}

Galaxy "IC 1933:ESO 155-25:IRAS 03242-5257"
{
        Type  "SBc"
        RA            3.4275
        Dec         -52.7847
        Distance   7.325e+07  # method: T-F
        Radius     2.344e+04
        AbsMag        -18.76
        Axis    [  0.7086   0.6916  -0.1398]
        Angle    166.6315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1933"
}

Galaxy "IC 1934:UGC 2769"
{
        Type  "S0"
        RA            3.5203
        Dec          42.7928
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.2827   0.8645  -0.4155]
        Angle    147.8651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1934"
}

Galaxy "IC 1935:ESO 200-23"
{
        Type  "Sc"
        RA            3.4369
        Dec         -50.0106
        Distance   2.477e+08  # method: V
        Radius     3.962e+04
        AbsMag         -19.9
        Axis    [  0.7392   0.6336  -0.2282]
        Angle    163.6959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1935"
}

Galaxy "IC 1936:ESO 200-24"
{
        Type  "S0"
        RA            3.4408
        Dec         -51.3231
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.3012   0.4941  -0.8156]
        Angle    127.1370
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1936"
}

Galaxy "IC 1937:ESO 200-25"
{
        Type  "S0"
        RA            3.4464
        Dec         -48.7028
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.7202   0.6848  -0.1109]
        Angle    165.2356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1937"
}

Galaxy "IC 1938:ESO 155-32:DRCG 45-21"
{
        Type  "Sb"
        RA            3.4528
        Dec         -53.0100
        Distance   4.095e+08  # method: V
        Radius     4.765e+04
        AbsMag        -19.99
        Axis    [  0.8018   0.5145   0.3039]
        Angle    180.7401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1938"
}

Galaxy "IC 1940:ESO 200-26:DRCG 45-178"
{
        Type  "SBb"
        RA            3.4617
        Dec         -52.1394
        Distance   6.146e+08  # method: V
        Radius     8.046e+04
        AbsMag        -21.58
        Axis    [  0.9390   0.1920   0.2854]
        Angle    167.2234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1940"
}

Galaxy "IC 1942:ESO 155-34:DRCG 45-62"
{
        Type  "E0"
        RA            3.4650
        Dec         -52.6756
        Distance   4.169e+08  # distance uncertain!
        Radius     4.245e+04
        AbsMag        -20.13
        Axis    [  0.9658   0.1758   0.1907]
        Angle    168.7563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1942"
}

Galaxy "IC 1944:ESO 200-28"
{
        Type  "S0"
        RA            3.4942
        Dec         -47.9964
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.8335   0.5119   0.2081]
        Angle    172.4972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1944"
}

Galaxy "IC 1945:ESO 155-38:DRCG 45-72"
{
        Type  "S0"
        RA            3.4878
        Dec         -52.6269
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.4067   0.6252  -0.6661]
        Angle    130.9310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1945"
}

Galaxy "IC 1946:ESO 155-39:DRCG 45-71"
{
        Type  "SBa"
        RA            3.4894
        Dec         -52.6194
        Distance   5.162e+08  # method: V
        Radius     6.757e+04
        AbsMag         -20.7
        Axis    [  0.6761   0.7102  -0.1961]
        Angle    162.6412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1946"
}

Galaxy "IC 1947:ESO 200-30"
{
        Type  "E0"
        RA            3.5089
        Dec         -50.3389
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.6012   0.1869  -0.7770]
        Angle    192.2811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1947"
}

Galaxy "IC 1948:ESO 200-32:FAIR 748:AM 0329-480"
{
        Type  "Sc"
        RA            3.5136
        Dec         -47.9644
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.8511   0.4296   0.3019]
        Angle    171.8090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1948"
}

Galaxy "IC 1949:ESO 200-33:FAIR 749:AM 0329-480"
{
        Type  "Sc"
        RA            3.5144
        Dec         -47.9797
        Distance    3.01e+08  # method: V
        Radius     4.816e+04
        AbsMag        -21.03
        Axis    [  0.8519   0.5180   0.0771]
        Angle    169.9241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1949"
}

Galaxy "IC 1950:ESO 200-35:IRAS 03295-5036"
{
        Type  "Sc"
        RA            3.5178
        Dec         -50.4328
        Distance   5.141e+08  # method: V
        Radius     1.047e+05
        AbsMag        -20.99
        Axis    [  0.2899   0.4953  -0.8189]
        Angle    126.3320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1950"
}

Galaxy "IC 1951:ESO 155-43:DRCG 45-1"
{
        Type  "Sc"
        RA            3.5156
        Dec         -53.1261
        Distance    5.59e+08  # distance uncertain!
        Radius     4.065e+04
        AbsMag        -19.07
        Axis    [  0.6698   0.7307  -0.1320]
        Angle    165.3242
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1951"
}

Galaxy "IC 1952:ESO 482-8:MCG 4-9-25:IRAS 03312-2352"
{
        Type  "SBc"
        RA            3.5572
        Dec         -23.7128
        Distance   7.384e+07  # method: V
        Radius     2.792e+04
        AbsMag        -18.17
        Axis    [  0.1059   0.7144  -0.6916]
        Angle    126.4426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1952"
}

Galaxy "IC 1953:ESO 548-38:MCG 4-9-26:UGCA 78"
{
        Type  "SBc"
        RA            3.5614
        Dec         -21.4783
        Distance   7.778e+07  # method: T-F
        Radius     3.281e+04
        AbsMag        -19.59
        Axis    [  0.4082   0.6639  -0.6266]
        Angle    151.0816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1953"
}

Galaxy "IC 1954:ESO 200-36:IRAS 03300-5204"
{
        Type  "SBb"
        RA            3.5253
        Dec         -51.9042
        Distance   4.829e+07  # method: T-F
        Radius     2.107e+04
        AbsMag        -18.65
        Axis    [  0.6905   0.6843  -0.2346]
        Angle    161.2531
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1954"
}

Galaxy "IC 1955:ESO 155-45"
{
        Type  "Sc"
        RA            3.5233
        Dec         -57.2419
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.8570   0.4251   0.2912]
        Angle    181.1848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1955"
}

Galaxy "IC 1956:UGC 2795:MCG 1-10-1:ZWG 417.1"
{
        Type  "SBc"
        RA            3.5925
        Dec           5.0672
        Distance   2.829e+08  # method: V
        Radius     6.582e+04
        AbsMag        -19.29
        Axis    [  0.2791   0.9155   0.2899]
        Angle    136.1529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1956"
}

Galaxy "IC 1957:ESO 155-48:FGCE 332:DRCG 45-124"
{
        Type  "Sc"
        RA            3.5369
        Dec         -52.4569
        Distance   4.241e+08  # distance uncertain!
        Radius     5.551e+04
        AbsMag        -19.07
        Axis    [  0.5805   0.8132   0.0416]
        Angle    174.0884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1957"
}

Galaxy "IC 1958:ESO 200-38"
{
        Type  "S0"
        RA            3.5461
        Dec         -51.4411
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.7379   0.5332  -0.4138]
        Angle    162.5133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1958"
}

Galaxy "IC 1959:ESO 200-39:IRAS 03317-5934"
{
        Type  "Irr"
        RA            3.5533
        Dec         -50.4122
        Distance   3.737e+07  # method: T-F
        Radius     1.576e+04
        AbsMag        -17.09
        Axis    [  0.3038   0.5470  -0.7801]
        Angle    124.0277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1959"
}

Galaxy "IC 1960:ESO 155-50"
{
        Type  "Sb"
        RA            3.5422
        Dec         -57.2069
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [  0.5152   0.6588  -0.5482]
        Angle    139.6403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1960"
}

Galaxy "IC 1961:ESO 200-41:AM 0332-490:IRAS 03320-4907"
{
        Type  "Sc"
        RA            3.5592
        Dec         -48.9508
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.7884   0.6060   0.1058]
        Angle    172.2523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1961"
}

Galaxy "IC 1962:ESO 548-50:MCG 4-9-31"
{
        Type  "SBc"
        RA            3.5936
        Dec         -21.2919
        Distance   6.088e+07  # method: T-F
        Radius     2.391e+04
        AbsMag        -16.65
        Axis    [  0.4639   0.7906   0.3997]
        Angle    166.8131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1962"
}

Galaxy "IC 1964:ESO 155-52"
{
        Type  "S0"
        RA            3.5583
        Dec         -53.1728
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.7013   0.6093  -0.3702]
        Angle    159.2766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1964"
}

Galaxy "IC 1965:ESO 155-51"
{
        Type  "SBc"
        RA            3.5528
        Dec         -56.5539
        Distance   7.576e+08  # method: V
        Radius     1.102e+05
        AbsMag        -21.23
        Axis    [  0.6975   0.4282  -0.5746]
        Angle    164.1083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1965"
}

Galaxy "IC 1966:ESO 200-42"
{
        Type  "S0"
        RA            3.5675
        Dec         -51.3222
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.5143   0.5646  -0.6456]
        Angle    144.8775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1966"
}

Galaxy "IC 1967:MCG 0-10-8:ZWG 391.20:IRAS 03351+0306"
{
        Type  "S0"
        RA            3.6297
        Dec           3.2703
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.3876   0.9217   0.0115]
        Angle    129.8470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1967"
}

Galaxy "IC 1968:ESO 200-43"
{
        Type  "S0"
        RA            3.5769
        Dec         -50.6514
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.6553   0.6038  -0.4538]
        Angle    155.1516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1968"
}

Galaxy "IC 1969:ESO 249-5:AM 0334-452"
{
        Type  "Sb"
        RA            3.6036
        Dec         -45.1792
        Distance   2.802e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -19.07
        Axis    [  0.5280   0.8492   0.0044]
        Angle    163.8053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1969"
}

Galaxy "IC 1970:ESO 249-7:MCG 7-8-3:AM 0334-440"
{
        Type  "Sb"
        RA            3.6086
        Dec         -43.9567
        Distance       8e+07  # method: T-F
        Radius     3.607e+04
        AbsMag        -19.05
        Axis    [  0.4675   0.8437  -0.2639]
        Angle    145.0276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1970"
}

Galaxy "IC 1971:ESO 156-1:FAIR 388"
{
        Type  "S0"
        RA            3.5992
        Dec         -52.6500
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.2119   0.3160  -0.9248]
        Angle    131.4925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1971"
}

Galaxy "IC 1972:ESO 200-48"
{
        Type  "S0"
        RA            3.6058
        Dec         -51.9678
        Distance    4.05e+08  # distance uncertain!
        Radius     4.712e+04
        AbsMag        -19.07
        Axis    [  0.2813   0.4899  -0.8251]
        Angle    122.2833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1972"
}

Galaxy "IC 1973:ESO 200-49"
{
        Type  "S0"
        RA            3.6056
        Dec         -51.9939
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [  0.6798   0.7051   0.2019]
        Angle    182.0091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1973"
}

Galaxy "IC 1974:ESO 200-50"
{
        Type  "S0"
        RA            3.6117
        Dec         -49.5503
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [  0.2593   0.4265  -0.8665]
        Angle    129.9836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1974"
}

Galaxy "IC 1975:NPM 1"
{
        Type  "Irr"
        RA            3.6508
        Dec         -15.4997
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [  0.9340   0.2743   0.2291]
        Angle    132.1636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1975"
}

Galaxy "IC 1976:ESO 200-51"
{
        Type  "S0"
        RA            3.6189
        Dec         -47.4378
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.5167   0.5309  -0.6717]
        Angle    149.3226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1976"
}

Galaxy "IC 1977:UGC 2815:MCG 3-10-5:ZWG 465.7"
{
        Type  "SBb"
        RA            3.6792
        Dec          17.7408
        Distance   4.433e+08  # method: V
        Radius     9.026e+04
        AbsMag        -21.27
        Axis    [ -0.2016   0.6372  -0.7439]
        Angle    165.0696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1977"
}

Galaxy "IC 1978:ESO 200-52"
{
        Type  "Sb"
        RA            3.6181
        Dec         -50.1511
        Distance   4.741e+08  # method: V
        Radius     7.585e+04
        AbsMag        -20.11
        Axis    [  0.5575   0.7968   0.2329]
        Angle    186.2755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1978"
}

Galaxy "IC 1980:ESO 117-2"
{
        Type  "Sb"
        RA            3.6161
        Dec         -57.9736
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.7263   0.6785   0.1106]
        Angle    182.3213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1980"
}

Galaxy "IC 1982:ESO 117-4"
{
        Type  "Sb"
        RA            3.6283
        Dec         -57.7764
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.9474   0.1678   0.2726]
        Angle    172.4516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1982"
}

Galaxy "IC 1984:ESO 249-12"
{
        Type  "Sc"
        RA            3.6639
        Dec         -47.0764
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.3227   0.5803  -0.7477]
        Angle    127.5715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1984"
}

Galaxy "IC 1986:ESO 249-13:AM 0338-453"
{
        Type  "Irr"
        RA            3.6764
        Dec         -45.3558
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [  0.5363   0.5166  -0.6674]
        Angle    152.5126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1986"
}

Galaxy "IC 1987-1:ESO 156-4"
{
        Type  "E0"
        RA            3.6697
        Dec         -55.0592
        Distance   5.249e+08  # distance uncertain!
        Radius     3.817e+04
        AbsMag        -20.13
        Axis    [  0.9534   0.1471   0.2634]
        Angle    169.0311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1987-1"
}

Galaxy "IC 1987-2:ESO 156-4"
{
        Type  "E0"
        RA            3.6692
        Dec         -55.0547
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.9534   0.1472   0.2634]
        Angle    169.0271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1987-2"
}

Galaxy "IC 1987-3:ESO 156-4"
{
        Type  "E0"
        RA            3.6700
        Dec         -55.0561
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.9534   0.1471   0.2634]
        Angle    169.0280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1987-3"
}

Galaxy "IC 1987-4:ESO 156-4"
{
        Type  "E0"
        RA            3.6700
        Dec         -55.0533
        Distance   7.944e+08  # distance uncertain!
        Radius     2.311e+04
        AbsMag        -20.13
        Axis    [  0.9534   0.1471   0.2634]
        Angle    169.0254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1987-4"
}

Galaxy "IC 1989:ESO 200-55"
{
        Type  "S0"
        RA            3.6983
        Dec         -50.9578
        Distance   5.019e+08  # method: V
        Radius      8.03e+04
        AbsMag        -21.34
        Axis    [  0.4875   0.4663  -0.7382]
        Angle    148.4339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1989"
}

Galaxy "IC 1991:ESO 200-56"
{
        Type  "S0"
        RA            3.7461
        Dec         -51.5239
        Distance   3.694e+08  # distance uncertain!
        Radius      3.76e+04
        AbsMag        -19.07
        Axis    [  0.6980   0.7156  -0.0277]
        Angle    168.2193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1991"
}

Galaxy "IC 1993:ESO 358-65:MCG 6-9-32:AM 0345-335"
{
        Type  "SBb"
        RA            3.7844
        Dec         -33.7106
        Distance   3.973e+07  # method: V
        Radius     1.445e+04
        AbsMag        -18.03
        Axis    [  0.8182   0.5423  -0.1906]
        Angle    155.4311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1993"
}

Galaxy "IC 1994:ESO 200-58"
{
        Type  "S0"
        RA            3.7653
        Dec         -51.6433
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.6300   0.7384   0.2405]
        Angle    185.5617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1994"
}

Galaxy "IC 1996:ESO 156-10"
{
        Type  "S0"
        RA            3.7519
        Dec         -57.3244
        Distance    4.05e+08  # distance uncertain!
        Radius     4.712e+04
        AbsMag        -19.07
        Axis    [  0.5280   0.6864  -0.5001]
        Angle    139.4773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1996"
}

Galaxy "IC 1997:ESO 117-7:IRAS 03437-5918"
{
        Type  "Sa"
        RA            3.7475
        Dec         -59.1375
        Distance    1.47e+08  # distance uncertain!
        Radius     2.566e+04
        AbsMag        -19.07
        Axis    [  0.7096   0.6258  -0.3238]
        Angle    160.5094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1997"
}

Galaxy "IC 1998:ZWG 391.39:NPM 1"
{
        Type  "E0"
        RA            3.8586
        Dec           1.1903
        Distance   4.169e+08  # distance uncertain!
        Radius     5.457e+04
        AbsMag        -20.13
        Axis    [  0.9448   0.2757   0.1769]
        Angle    115.2260
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1998"
}

Galaxy "IC 1999:ESO 156-14:AM 0346-570"
{
        Type  "S0"
        RA            3.7953
        Dec         -56.9519
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.8619   0.4334   0.2632]
        Angle    180.4820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 1999"
}

Galaxy "IC 2000:ESO 201-3:IRAS 03476-4900"
{
        Type  "SBc"
        RA            3.8186
        Dec         -48.8583
        Distance   6.315e+07  # method: T-F
        Radius     3.766e+04
        AbsMag        -18.33
        Axis    [  0.4916   0.8065  -0.3283]
        Angle    141.9724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2000"
}

Galaxy "IC 2004:ESO 201-6"
{
        Type  "Sa"
        RA            3.8625
        Dec         -49.4192
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.8245   0.5539  -0.1158]
        Angle    165.1708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2004"
}

Galaxy "IC 2005:ZWG 526.15"
{
        Type  "S0"
        RA            3.9608
        Dec          36.7875
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.2969   0.7237   0.6229]
        Angle    116.6887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2005"
}

Galaxy "IC 2006:ESO 359-7:MCG 6-9-37:AM 0352-360"
{
        Type  "S0"
        RA            3.9078
        Dec         -35.9672
        Distance   6.783e+07  # method: S
        Radius     1.875e+04
        AbsMag        -19.39
        Axis    [  0.8444   0.5352  -0.0234]
        Angle    156.1362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2006"
}

Galaxy "IC 2007:IC 2008:ESO 419-11:MCG 5-10-5"
{
        Type  "Sc"
        RA            3.9228
        Dec         -28.1589
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [  0.6813   0.7248  -0.1019]
        Angle    146.8439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2007"
}

Galaxy "IC 2009:ESO 201-8"
{
        Type  "Irr"
        RA            3.8928
        Dec         -48.9911
        Distance   6.922e+07  # method: V
        Radius     1.812e+04
        AbsMag        -17.03
        Axis    [  0.7817   0.6050  -0.1514]
        Angle    162.5135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2009"
}

Galaxy "IC 2010:ESO 117-11:AM 0351-600:IRAS 03510-6004"
{
        Type  "Sa"
        RA            3.8661
        Dec         -59.9292
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [  0.6883   0.6588  -0.3037]
        Angle    159.0402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2010"
}

Galaxy "IC 2012:ESO 117-13"
{
        Type  "S0"
        RA            3.8819
        Dec         -58.6492
        Distance   3.868e+08  # distance uncertain!
        Radius     3.375e+04
        AbsMag        -19.07
        Axis    [  0.8127   0.5446   0.2072]
        Angle    183.9423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2012"
}

Galaxy "IC 2014:ESO 156-20"
{
        Type  "SBc"
        RA            3.9225
        Dec         -56.7467
        Distance   4.657e+08  # method: V
        Radius     7.451e+04
        AbsMag        -20.27
        Axis    [  0.7363   0.6674   0.1113]
        Angle    179.9832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2014"
}

Galaxy "IC 2015:ESO 302-22"
{
        Type  "Sc"
        RA            3.9697
        Dec         -40.3892
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.8338   0.4780   0.2763]
        Angle    164.9126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2015"
}

Galaxy "IC 2016:ZWG 466.6"
{
        Type  "S0"
        RA            4.0331
        Dec          20.2406
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.5289   0.7012   0.4781]
        Angle    118.2000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2016"
}

Galaxy "IC 2017:ESO 117-15:AM 0355-593:IRAS 03557-5932"
{
        Type  "S0"
        RA            3.9439
        Dec         -59.3944
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.8171   0.5703   0.0846]
        Angle    179.9410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2017"
}

Galaxy "IC 2018:ESO 156-21"
{
        Type  "SBc"
        RA            3.9650
        Dec         -52.7806
        Distance   4.581e+08  # method: V
        Radius     5.331e+04
        AbsMag        -20.04
        Axis    [  0.4269   0.4097  -0.8062]
        Angle    143.9436
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2018"
}

Galaxy "IC 2019-1:UGC 2930:MCG 1-11-7:ZWG 418.7"
{
        Type  "S0"
        RA            4.0314
        Dec           5.6392
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4797   0.8719   0.0981]
        Angle    124.0003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2019-1"
}

Galaxy "IC 2019-2:UGC 2930:MCG 1-11-7:ZWG 418.7"
{
        Type  "S0"
        RA            4.0311
        Dec           5.6361
        Distance    2.44e+08  # distance uncertain!
        Radius     1.065e+04
        AbsMag        -19.07
        Axis    [  0.6360   0.7420   0.2120]
        Angle    123.2613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2019-2"
}

Galaxy "IC 2020:ESO 156-22"
{
        Type  "Sc"
        RA            3.9814
        Dec         -54.0583
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8679   0.4299   0.2487]
        Angle    176.9128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2020"
}

Galaxy "IC 2021:ESO 156-24"
{
        Type  "Sc"
        RA            3.9897
        Dec         -52.6567
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.5263   0.5059  -0.6835]
        Angle    143.8578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2021"
}

Galaxy "IC 2022:ESO 117-17:FAIR 19"
{
        Type  "S0"
        RA            3.9778
        Dec         -59.0442
        Distance   3.527e+08  # distance uncertain!
        Radius     5.643e+04
        AbsMag        -19.07
        Axis    [  0.6008   0.7711   0.2108]
        Angle    193.7623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2022"
}

Galaxy "IC 2023:ESO 156-25"
{
        Type  "S0"
        RA            3.9944
        Dec         -52.6803
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.8534   0.4571   0.2506]
        Angle    176.3991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2023"
}

Galaxy "IC 2024:ESO 156-26:IRAS 03588-5330"
{
        Type  "SBc"
        RA            4.0011
        Dec         -53.3719
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [  0.6441   0.7643   0.0316]
        Angle    171.7486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2024"
}

Galaxy "IC 2025:ESO 156-28"
{
        Type  "Sb"
        RA            4.0061
        Dec         -53.0650
        Distance   5.869e+08  # method: V
        Radius      9.39e+04
        AbsMag        -20.18
        Axis    [  0.4082   0.6695  -0.6206]
        Angle    124.0154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2025"
}

Galaxy "IC 2027:UGC 2957:MCG 6-9-19"
{
        Type  "E0"
        RA            4.1108
        Dec          37.1158
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.9257   0.3658   0.0961]
        Angle     80.6563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2027"
}

Galaxy "IC 2028:ESO 156-32"
{
        Type  "Sc"
        RA            4.0217
        Dec         -52.7075
        Distance   4.406e+08  # method: V
        Radius     5.126e+04
        AbsMag        -20.65
        Axis    [  0.8254   0.5294  -0.1963]
        Angle    164.8309
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2028"
}

Galaxy "IC 2029:ESO 156-33"
{
        Type  "SBc"
        RA            4.0214
        Dec         -52.8008
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [  0.1433   0.2581  -0.9554]
        Angle    128.1480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2029"
}

Galaxy "IC 2031:NPM 1"
{
        Type  "E0"
        RA            4.1039
        Dec          -5.6519
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.9594   0.2279   0.1662]
        Angle    121.1452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2031"
}

Galaxy "IC 2032:ESO 156-42:AM 0405-552"
{
        Type  "Irr"
        RA            4.1175
        Dec         -55.3231
        Distance   4.707e+07  # method: V
        Radius          9584
        AbsMag           -16
        Axis    [  0.7077   0.5873  -0.3927]
        Angle    154.6073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2032"
}

Galaxy "IC 2033:ESO 156-43"
{
        Type  "SBa"
        RA            4.1206
        Dec         -53.6811
        Distance   6.357e+08  # method: V
        Radius      1.11e+05
        AbsMag        -21.45
        Axis    [  0.4724   0.4945  -0.7296]
        Angle    137.4505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2033"
}

Galaxy "IC 2034:ESO 117-22:FGCE 375"
{
        Type  "Sc"
        RA            4.1100
        Dec         -57.9617
        Distance   3.217e+08  # distance uncertain!
        Radius     5.615e+04
        AbsMag        -19.07
        Axis    [  0.4493   0.6425  -0.6207]
        Angle    124.6502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2034"
}

Galaxy "IC 2035:ESO 250-7:AM 0407-453"
{
        Type  "S0"
        RA            4.1503
        Dec         -45.5172
        Distance   6.324e+07  # method: V
        Radius     1.104e+04
        AbsMag        -18.94
        Axis    [  0.7034   0.5385  -0.4640]
        Angle    153.3277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2035"
}

Galaxy "IC 2036:ESO 303-1:MCG 7-9-10"
{
        Type  "SBc"
        RA            4.1653
        Dec         -39.6886
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [  0.7168   0.5472  -0.4321]
        Angle    152.4958
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2036"
}

Galaxy "IC 2037:ESO 118-1:IRAS 04073-5852"
{
        Type  "Sb"
        RA            4.1386
        Dec         -58.7511
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [  0.5330   0.7220  -0.4413]
        Angle    137.3922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2037"
}

Galaxy "IC 2038:ESO 157-1:AM 0407-560"
{
        Type  "Sc"
        RA            4.1483
        Dec         -55.9925
        Distance   3.094e+07  # method: V
        Radius          8100
        AbsMag        -14.68
        Axis    [  0.2840   0.4604  -0.8410]
        Angle    113.6650
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2038"
}

Galaxy "IC 2039:ESO 157-2:AM 0407-560"
{
        Type  "S0"
        RA            4.1506
        Dec         -56.0111
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.5175   0.3456  -0.7828]
        Angle    153.7905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2039"
}

Galaxy "IC 2040:ESO 359-30:AM 0411-324:IRAS 04110-3240"
{
        Type  "S0"
        RA            4.2164
        Dec         -32.5539
        Distance   5.966e+07  # method: V
        Radius     1.215e+04
        AbsMag        -17.71
        Axis    [  0.6554   0.7171  -0.2369]
        Angle    143.4691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2040"
}

Galaxy "IC 2041:ESO 359-28"
{
        Type  "S0"
        RA            4.2094
        Dec         -32.8175
        Distance   5.418e+07  # method: V
        Radius          8668
        AbsMag         -16.5
        Axis    [  0.2992   0.5799  -0.7578]
        Angle    135.2867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2041"
}

Galaxy "IC 2043:ESO 157-4:IRAS 04098-5348"
{
        Type  "Sb"
        RA            4.1858
        Dec         -53.6864
        Distance   5.317e+08  # method: V
        Radius     1.083e+05
        AbsMag        -20.66
        Axis    [  0.6037   0.7882   0.1194]
        Angle    178.6579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2043"
}

Galaxy "IC 2044:ESO 157-6"
{
        Type  "SBa"
        RA            4.1872
        Dec         -54.5322
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.8492   0.4759  -0.2289]
        Angle    165.6175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2044"
}

Galaxy "IC 2045:MCG 2-11-27:NPM 1"
{
        Type  "E0"
        RA            4.2433
        Dec         -13.1750
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [  0.5319   0.4693  -0.7049]
        Angle    174.6365
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2045"
}

Galaxy "IC 2046:ESO 157-7"
{
        Type  "SBc"
        RA            4.1900
        Dec         -54.6731
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6216   0.5059  -0.5981]
        Angle    148.4043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2046"
}

Galaxy "IC 2049:ESO 118-9:AM 0411-584"
{
        Type  "SBc"
        RA            4.2011
        Dec         -58.5575
        Distance   4.825e+07  # method: V
        Radius          7017
        AbsMag        -16.25
        Axis    [  0.2801   0.1558  -0.9472]
        Angle    163.5714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2049"
}

Galaxy "IC 2050:ESO 157-11:FAIR 405"
{
        Type  "SBb"
        RA            4.2322
        Dec         -53.4758
        Distance    5.59e+08  # method: V
        Radius     8.944e+04
        AbsMag        -21.47
        Axis    [  0.8522   0.5220   0.0364]
        Angle    171.0742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2050"
}

Galaxy "IC 2051:ESO 4-7:AM 0358-835:IRAS 03583-8358"
{
        Type  "SBc"
        RA            3.8667
        Dec         -83.8319
        Distance    9.45e+07  # method: T-F
        Radius     3.573e+04
        AbsMag        -20.01
        Axis    [  0.8374   0.4267  -0.3417]
        Angle    179.6551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2051"
}

Galaxy "IC 2052:ESO 157-13"
{
        Type  "Sc"
        RA            4.2494
        Dec         -54.3364
        Distance   5.131e+08  # method: V
        Radius     6.717e+04
        AbsMag        -20.58
        Axis    [  0.2226   0.3129  -0.9233]
        Angle    126.5734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2052"
}

Galaxy "IC 2054:ESO 15-7"
{
        Type  "S0"
        RA            4.1239
        Dec         -78.2536
        Distance    4.05e+08  # distance uncertain!
        Radius     2.945e+04
        AbsMag        -19.07
        Axis    [  0.8925   0.4112   0.1856]
        Angle    199.9629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2054"
}

Galaxy "IC 2056:ESO 118-16:IRAS 04155-6019"
{
        Type  "SBc"
        RA            4.2733
        Dec         -60.2064
        Distance   8.344e+07  # method: T-F
        Radius     2.306e+04
        AbsMag        -19.54
        Axis    [  0.9030   0.4062   0.1400]
        Angle    179.6203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2056"
}

Galaxy "IC 2057:ZWG 419.2:KARA 148:IRAS 04192+0355"
{
        Type  "S0"
        RA            4.3656
        Dec           4.0481
        Distance   3.328e+08  # method: V
        Radius     3.388e+04
        AbsMag        -19.84
        Axis    [  0.8198   0.4767   0.3173]
        Angle    119.1833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2057"
}

Galaxy "IC 2058:ESO 157-18:FGCE 387:AM 0416-560"
{
        Type  "Sc"
        RA            4.2983
        Dec         -55.9308
        Distance   7.407e+07  # method: T-F
        Radius     3.124e+04
        AbsMag        -17.88
        Axis    [  0.6156   0.7841   0.0792]
        Angle    177.3069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2058"
}

Galaxy "IC 2059:ESO 420-17:MCG 5-11-7"
{
        Type  "S0"
        RA            4.3406
        Dec         -31.7244
        Distance   1.248e+08  # method: V
        Radius     2.359e+04
        AbsMag        -19.01
        Axis    [ -0.0192   0.4336  -0.9009]
        Angle    120.9891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2059"
}

Galaxy "IC 2060:ESO 157-19"
{
        Type  "S0"
        RA            4.2981
        Dec         -56.6161
        Distance    3.02e+08  # method: V
        Radius     6.588e+04
        AbsMag        -20.53
        Axis    [  0.3886   0.2939  -0.8733]
        Angle    147.5619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2060"
}

Galaxy "IC 2063:MCG 3-12-5"
{
        Type  "S0"
        RA            4.3778
        Dec         -15.6611
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.6858   0.6341   0.3571]
        Angle    147.5413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2063"
}

Galaxy "IC 2064:NPM 1"
{
        Type  "E0"
        RA            4.3906
        Dec         -15.6853
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.9731   0.1736   0.1516]
        Angle    130.3267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2064"
}

Galaxy "IC 2065:ESO 157-21:IRAS 04204-5602"
{
        Type  "Sa"
        RA            4.3578
        Dec         -55.9328
        Distance   1.768e+08  # distance uncertain!
        Radius     3.085e+04
        AbsMag        -19.07
        Axis    [  0.6940   0.7166  -0.0699]
        Angle    165.8065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2065"
}

Galaxy "IC 2066:ESO 157-25:FAIR 770"
{
        Type  "SBc"
        RA            4.3922
        Dec         -54.7333
        Distance   5.066e+08  # method: V
        Radius     5.894e+04
        AbsMag        -20.66
        Axis    [  0.5035   0.3627  -0.7842]
        Angle    149.4195
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2066"
}

Galaxy "IC 2068:ESO 303-17:MCG 7-10-4:FAIR 408"
{
        Type  "Sa"
        RA            4.4433
        Dec         -42.0936
        Distance   2.136e+08  # method: V
        Radius     3.729e+04
        AbsMag        -19.78
        Axis    [  0.2571   0.3983  -0.8805]
        Angle    140.8097
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2068"
}

Galaxy "IC 2070:ESO 118-23:AM 0423-580:IRAS 04236-5805"
{
        Type  "SBc"
        RA            4.4097
        Dec         -57.9811
        Distance   3.186e+08  # method: V
        Radius     6.488e+04
        AbsMag        -20.45
        Axis    [  0.7137   0.5060  -0.4843]
        Angle    153.4109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2070"
}

Galaxy "IC 2071:ESO 157-28"
{
        Type  "S0"
        RA            4.4372
        Dec         -53.1514
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.7294   0.4749  -0.4924]
        Angle    154.8196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2071"
}

Galaxy "IC 2073:ESO 157-29:IRAS 04253-5317"
{
        Type  "SBc"
        RA            4.4425
        Dec         -53.1883
        Distance   1.784e+08  # method: V
        Radius     3.114e+04
        AbsMag        -19.19
        Axis    [  0.7112   0.6832  -0.1658]
        Angle    157.8630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2073"
}

Galaxy "IC 2079:ESO 157-33:DRCG 47-62"
{
        Type  "SBb"
        RA            4.4750
        Dec         -53.7381
        Distance   4.901e+08  # method: V
        Radius     8.554e+04
        AbsMag        -21.08
        Axis    [  0.4300   0.5490  -0.7167]
        Angle    125.1519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2079"
}

Galaxy "IC 2080:IRAS 04294-0051"
{
        Type  "S0"
        RA            4.5311
        Dec          -5.7569
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.8180   0.4858   0.3081]
        Angle    129.5246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2080"
}

Galaxy "IC 2081:ESO 157-34:DRCG 47-81"
{
        Type  "S0"
        RA            4.4833
        Dec         -53.6136
        Distance   5.764e+08  # method: V
        Radius     1.006e+05
        AbsMag        -21.74
        Axis    [  0.6754   0.5042  -0.5381]
        Angle    149.5121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2081"
}

Galaxy "IC 2082:ESO 157-35:AM 0427-535:DRCG 47-45"
{
        Type  "S0"
        RA            4.4853
        Dec         -53.8278
        Distance   5.332e+08  # method: V
        Radius     1.008e+05
        AbsMag        -21.87
        Axis    [  0.4232   0.3946  -0.8156]
        Angle    138.5843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2082"
}

Galaxy "IC 2083:ESO 157-37:FAIR 774:DRCG 47-16"
{
        Type  "SBa"
        RA            4.5122
        Dec         -53.9808
        Distance   5.866e+08  # method: V
        Radius     9.386e+04
        AbsMag        -21.37
        Axis    [  0.4594   0.4496  -0.7660]
        Angle    135.4881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2083"
}

Galaxy "IC 2085:ESO 157-38:DRCG 47-1:IRAS 04303-5430"
{
        Type  "S0"
        RA            4.5233
        Dec         -54.4161
        Distance   5.092e+07  # method: T-F
        Radius     1.703e+04
        AbsMag        -16.87
        Axis    [  0.4137   0.6404  -0.6470]
        Angle    118.1157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2085"
}

Galaxy "IC 2086:ESO 157-40:DRCG 47-75"
{
        Type  "E0"
        RA            4.5256
        Dec         -53.6475
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.9812   0.0962   0.1673]
        Angle    167.3275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2086"
}

Galaxy "IC 2089:ESO 32-15"
{
        Type  "Irr"
        RA            4.5472
        Dec         -75.5403
        Distance   3.631e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -20.13
        Axis    [  0.9105   0.3875   0.1442]
        Angle    195.1765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2089"
}

Galaxy "IC 2094"
{
        Type  "S0"
        RA            4.8067
        Dec          -5.3525
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.3865   0.8989  -0.2065]
        Angle    116.3415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2094"
}

Galaxy "IC 2095:MCG 1-13-14:FGC 506"
{
        Type  "Sc"
        RA            4.8125
        Dec          -5.1250
        Distance   3.217e+08  # distance uncertain!
        Radius      6.55e+04
        AbsMag        -19.07
        Axis    [  0.3962   0.9105   0.1184]
        Angle    123.2021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2095"
}

Galaxy "IC 2097"
{
        Type  "Irr"
        RA            4.8397
        Dec          -5.0808
        Distance   5.012e+08  # distance uncertain!
        Radius     8.748e+04
        AbsMag        -20.13
        Axis    [  0.0962   0.8387  -0.5359]
        Angle    113.8351
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2097"
}

Galaxy "IC 2098:MCG 1-13-18:FGC 509:IRAS 04482-0530"
{
        Type  "Sc"
        RA            4.8456
        Dec          -5.4183
        Distance   1.263e+08  # method: V
        Radius     3.858e+04
        AbsMag        -18.44
        Axis    [  0.1623   0.9475  -0.2755]
        Angle    109.3534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2098"
}

Galaxy "IC 2099:MCG 1-1-19:IRAS 04484-0458"
{
        Type  "S0"
        RA            4.8475
        Dec          -4.8919
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.0158   0.7485  -0.6630]
        Angle    117.9802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2099"
}

Galaxy "IC 2101:MCG 1-13-24:IRAS 04492-0618"
{
        Type  "Sc"
        RA            4.8617
        Dec          -6.2306
        Distance   2.036e+08  # method: T-F
        Radius     5.035e+04
        AbsMag        -19.48
        Axis    [ -0.1296   0.7204  -0.6814]
        Angle    111.8691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2101"
}

Galaxy "IC 2102:MCG 1-13-27"
{
        Type  "Sc"
        RA            4.8653
        Dec          -4.9522
        Distance   1.634e+08  # method: V
        Radius     2.853e+04
        AbsMag         -18.2
        Axis    [  0.1250   0.6507  -0.7490]
        Angle    140.1438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2102"
}

Galaxy "IC 2103:ESO 32-18"
{
        Type  "Sc"
        RA            4.6631
        Dec         -76.8367
        Distance   2.153e+08  # method: T-F
        Radius     5.636e+04
        AbsMag         -19.4
        Axis    [  0.6281   0.5940  -0.5026]
        Angle    141.3239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2103"
}

Galaxy "IC 2104:MCG 3-13-34:IRAS 04540-1552"
{
        Type  "SBc"
        RA            4.9383
        Dec         -15.7978
        Distance   3.061e+08  # method: T-F
        Radius     1.113e+05
        AbsMag        -21.06
        Axis    [  0.3263   0.7949  -0.5115]
        Angle    117.7316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2104"
}

Galaxy "IC 2106:ESO 422-12:MCG 5-12-11:IRAS 04545-2834"
{
        Type  "SBb"
        RA            4.9425
        Dec         -28.5039
        Distance   2.372e+08  # method: T-F
        Radius     5.865e+04
        AbsMag        -20.51
        Axis    [  0.0773   0.4863  -0.8704]
        Angle    127.0611
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2106"
}

Galaxy "IC 2112:ZWG 420.27"
{
        Type  "S0"
        RA            5.0083
        Dec           4.3864
        Distance   4.839e+08  # method: V
        Radius     3.519e+04
        AbsMag        -20.86
        Axis    [  0.5733   0.7876   0.2260]
        Angle    118.5560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2112"
}

Galaxy "IC 2119:ESO 553-5:MCG 3-13-73"
{
        Type  "Sb"
        RA            5.1139
        Dec         -20.3458
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [  0.7003   0.6861  -0.1974]
        Angle    128.3267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2119"
}

Galaxy "IC 2122:ESO 362-14:MCG 6-12-17:AM 0517-370"
{
        Type  "S0"
        RA            5.3169
        Dec         -37.0892
        Distance   2.123e+08  # method: V
        Radius     4.632e+04
        AbsMag        -20.27
        Axis    [  0.7912   0.4431  -0.4214]
        Angle    143.8983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2122"
}

Galaxy "IC 2125:ESO 487-8"
{
        Type  "S0"
        RA            5.4078
        Dec         -27.0158
        Distance   1.612e+08  # distance uncertain!
        Radius     2.345e+04
        AbsMag        -19.07
        Axis    [  0.3361   0.5529  -0.7625]
        Angle    128.0522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2125"
}

Galaxy "IC 2130:ESO 487-19:MCG 4-14-2"
{
        Type  "SBc"
        RA            5.5306
        Dec         -23.1456
        Distance   8.729e+07  # method: T-F
        Radius     2.285e+04
        AbsMag        -18.34
        Axis    [  0.4103   0.7078  -0.5751]
        Angle    114.4935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2130"
}

Galaxy "IC 2132:MCG 2-15-2:IRAS 05301-1357"
{
        Type  "Sa"
        RA            5.5411
        Dec         -13.9267
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [ -0.1974   0.4568  -0.8674]
        Angle    128.3594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2132"
}

Galaxy "IC 2135:IC 2136:ESO 363-7:MCG 6-13-4"
{
        Type  "Sc"
        RA            5.5536
        Dec         -36.3994
        Distance   1.584e+08  # method: T-F
        Radius      6.45e+04
        AbsMag        -20.13
        Axis    [  0.3368   0.7402  -0.5820]
        Angle    103.9678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2135"
}

Galaxy "IC 2138:IC 2137:ESO 487-27:MCG 4-14-6"
{
        Type  "Sb"
        RA            5.5725
        Dec         -23.5333
        Distance   1.281e+08  # distance uncertain!
        Radius     2.235e+04
        AbsMag        -19.07
        Axis    [  0.5701   0.6418  -0.5129]
        Angle    122.0395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2138"
}

Galaxy "IC 2142:ESO 16-7"
{
        Type  "S0"
        RA            5.5522
        Dec         -78.0194
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.8248   0.5154  -0.2327]
        Angle    176.6817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2142"
}

Galaxy "IC 2143:ESO 554-34:MCG 3-15-13:IRAS 05447-1844"
{
        Type  "SBb"
        RA            5.7811
        Dec         -18.7258
        Distance   1.386e+08  # method: T-F
        Radius     4.031e+04
        AbsMag        -19.74
        Axis    [  0.3846   0.7763  -0.4995]
        Angle    106.0995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2143"
}

Galaxy "IC 2150:ESO 306-32:MCG 6-13-16:IRAS 05496-3819"
{
        Type  "Sc"
        RA            5.8550
        Dec         -38.3211
        Distance   1.463e+08  # method: T-F
        Radius     5.532e+04
        AbsMag        -19.66
        Axis    [  0.5388   0.7106  -0.4524]
        Angle    114.6182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2150"
}

Galaxy "IC 2151:ESO 555-8:MCG 3-15-24:IRAS 05504-1747"
{
        Type  "SBc"
        RA            5.8767
        Dec         -17.7875
        Distance   1.047e+08  # method: T-F
        Radius     2.285e+04
        AbsMag        -18.33
        Axis    [  0.4456   0.6882  -0.5725]
        Angle    112.1989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2151"
}

Galaxy "IC 2152:ESO 488-47:MCG 4-15-1:AM 0555-231"
{
        Type  "SBa"
        RA            5.9647
        Dec         -23.1806
        Distance   1.017e+08  # distance uncertain!
        Radius     2.515e+04
        AbsMag        -19.07
        Axis    [  0.7746   0.5686  -0.2769]
        Angle    123.5852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2152"
}

Galaxy "IC 2153:ESO 364-22:AM 0558-335:IRAS 05582-3355"
{
        Type  "Irr"
        RA            6.0011
        Dec         -33.9194
        Distance   1.319e+08  # method: V
        Radius      2.11e+04
        AbsMag        -18.83
        Axis    [  0.7156   0.5149  -0.4720]
        Angle    128.3983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2153"
}

Galaxy "IC 2158:ESO 425-7:MCG 5-15-4:IRAS 06033-2751"
{
        Type  "SBb"
        RA            6.0881
        Dec         -27.8569
        Distance   8.081e+07  # distance uncertain!
        Radius     1.998e+04
        AbsMag        -19.07
        Axis    [  0.4722   0.5123  -0.7173]
        Angle    123.2510
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2158"
}

Galaxy "IC 2160:ESO 33-32:IRAS 05576-7655"
{
        Type  "SBc"
        RA            5.9244
        Dec         -76.9203
        Distance    1.83e+08  # method: T-F
        Radius     5.589e+04
        AbsMag        -19.94
        Axis    [  0.5793   0.3360  -0.7427]
        Angle    128.8563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2160"
}

Galaxy "IC 2163:ESO 556-9:MCG 4-15-21:UGCA 125"
{
        Type  "SBc"
        RA            6.2744
        Dec         -21.3764
        Distance   1.266e+08  # method: V
        Radius     5.523e+04
        AbsMag        -20.54
        Axis    [  0.4068   0.7366  -0.5404]
        Angle    100.4843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2163"
}

Galaxy "IC 2164:ESO 34-5:FAIR 248:AM 0608-752"
{
        Type  "Sb"
        RA            6.1144
        Dec         -75.3650
        Distance   4.913e+08  # method: V
        Radius      7.86e+04
        AbsMag        -21.29
        Axis    [  0.4181   0.0684  -0.9058]
        Angle    147.6645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2164"
}

Galaxy "IC 2166:UGC 3463:MCG 10-10-1:ZWG 284.14"
{
        Type  "SBc"
        RA            6.4486
        Dec          59.0797
        Distance    1.23e+08  # method: V
        Radius     5.369e+04
        AbsMag        -19.68
        Axis    [ -0.1077   0.9799  -0.1680]
        Angle    100.3606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2166"
}

Galaxy "IC 2174:UGC 3666:MCG 13-6-2:ZWG 348.30"
{
        Type  "SBa"
        RA            7.1514
        Dec          75.3536
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.4888   0.6739   0.5540]
        Angle     51.5983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2174"
}

Galaxy "IC 2176:MCG 5-17-11:ZWG 146.25:NPM 1"
{
        Type  "S0"
        RA            7.1253
        Dec          32.4703
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.7844   0.3757   0.4936]
        Angle     96.1326
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2176"
}

Galaxy "IC 2178:ZWG 146.26:NPM 1"
{
        Type  "S0"
        RA            7.1269
        Dec          32.5131
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.1946   0.9078  -0.3716]
        Angle     91.4209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2178"
}

Galaxy "IC 2179:UGC 3750:MCG 11-9-38A:ZWG 309.25"
{
        Type  "E1"
        RA            7.2589
        Dec          64.9261
        Distance   1.983e+08  # method: V
        Radius     3.172e+04
        AbsMag        -20.42
        Axis    [  0.9269  -0.3752  -0.0054]
        Angle     51.8508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2179"
}

Galaxy "IC 2180:UGC 3727:ZWG 116.27"
{
        Type  "Sb"
        RA            7.1886
        Dec          26.3708
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [  0.9260   0.1911   0.3255]
        Angle     94.7709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2180"
}

Galaxy "IC 2181:UGC 3744:MCG 3-19-5:ZWG 86.8"
{
        Type  "Sb"
        RA            7.2194
        Dec          18.9964
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.1800   0.8040  -0.5667]
        Angle     95.5052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2181"
}

Galaxy "IC 2182"
{
        Type  "S0"
        RA            7.2364
        Dec          18.9450
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.9828  -0.1733  -0.0641]
        Angle     95.6435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2182"
}

Galaxy "IC 2184:UGC 3852:MCG 12-7-41:MK 8"
{
        Type  "Sc"
        RA            7.4900
        Dec          72.1286
        Distance   1.639e+08  # method: V
        Radius     1.907e+04
        AbsMag        -19.41
        Axis    [  0.8087  -0.1855   0.5582]
        Angle     57.0970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2184"
}

Galaxy "IC 2185:MCG 5-18-8:ZWG 177.4:ZWG 147.15"
{
        Type  "Sc"
        RA            7.3878
        Dec          32.4947
        Distance   2.114e+08  # method: V
        Radius     1.845e+04
        AbsMag        -18.96
        Axis    [ -0.1366   0.8715  -0.4710]
        Angle     95.8914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2185"
}

Galaxy "IC 2187:MCG 4-18-10:ZWG 117.25"
{
        Type  "S0"
        RA            7.3786
        Dec          21.4828
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.9769  -0.2021  -0.0699]
        Angle     93.4953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2187"
}

Galaxy "IC 2188:IC 2186:MCG 4-18-11:ZWG 117.26"
{
        Type  "S0"
        RA            7.3786
        Dec          21.5136
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.1508   0.8595  -0.4883]
        Angle     83.6796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2188"
}

Galaxy "IC 2190:UGC 3880:MCG 6-17-13:ZWG 177.26"
{
        Type  "SBc"
        RA            7.4983
        Dec          37.4517
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.8167   0.4013   0.4148]
        Angle     80.2546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2190"
}

Galaxy "IC 2191:MCG 4-18-24:ZWG 117.47:NPM 1"
{
        Type  "S0"
        RA            7.5047
        Dec          24.3283
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.9598   0.1109   0.2578]
        Angle     94.9101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2191"
}

Galaxy "IC 2192"
{
        Type  "E0"
        RA            7.5553
        Dec          31.5533
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.9538  -0.2866  -0.0904]
        Angle     84.5776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2192"
}

Galaxy "IC 2193:UGC 3902:MCG 5-18-18:ZWG 147.37"
{
        Type  "Sb"
        RA            7.5564
        Dec          31.4833
        Distance   2.343e+08  # method: V
        Radius     5.112e+04
        AbsMag        -19.78
        Axis    [  0.3379   0.9238  -0.1800]
        Angle     69.6836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2193"
}

Galaxy "IC 2194:MCG 5-18-20:ZWG 147.39"
{
        Type  "S0"
        RA            7.5611
        Dec          31.3344
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.5446   0.7345   0.4049]
        Angle     78.0838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2194"
}

Galaxy "IC 2196:UGC 3910:MCG 5-18-21:ZWG 147.40"
{
        Type  "E0"
        RA            7.5692
        Dec          31.4061
        Distance   2.217e+08  # method: V
        Radius     4.514e+04
        AbsMag        -20.36
        Axis    [  0.1154   0.7166  -0.6878]
        Angle    135.4574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2196"
}

Galaxy "IC 2197-1"
{
        Type  "S0"
        RA            7.5717
        Dec          31.3372
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.9624  -0.2642  -0.0631]
        Angle     84.6075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2197-1"
}

Galaxy "IC 2197-2"
{
        Type  "E0"
        RA            7.5719
        Dec          31.3383
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.9530  -0.2887  -0.0916]
        Angle     84.8396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2197-2"
}

Galaxy "IC 2198:ZWG 117.54"
{
        Type  "E0"
        RA            7.5697
        Dec          23.9664
        Distance   3.631e+08  # distance uncertain!
        Radius     2.112e+04
        AbsMag        -20.13
        Axis    [  0.9588  -0.2645  -0.1031]
        Angle     91.8804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2198"
}

Galaxy "IC 2199:UGC 3915:MCG 5-18-22:ZWG 147.42"
{
        Type  "SBc"
        RA            7.5819
        Dec          31.2758
        Distance   2.188e+08  # method: V
        Radius     3.501e+04
        AbsMag        -20.33
        Axis    [  0.8317   0.4414   0.3368]
        Angle     81.5883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2199"
}

Galaxy "IC 2200:ESO 123-12:AM 0727-621:IRAS 07276-6214"
{
        Type  "Sb"
        RA            7.4714
        Dec         -62.3528
        Distance    1.47e+08  # method: V
        Radius     2.566e+04
        AbsMag        -19.27
        Axis    [  0.7545   0.3591  -0.5493]
        Angle    136.4734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2200"
}

Galaxy "IC 2200A:ESO 123-11:AM 0727-621"
{
        Type  "S0"
        RA            7.4683
        Dec         -62.3631
        Distance   1.527e+08  # method: V
        Radius     2.887e+04
        AbsMag        -19.65
        Axis    [  0.8553   0.3255  -0.4031]
        Angle    151.1487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2200A"
}

Galaxy "IC 2201:UGC 3926:MCG 6-17-20:ZWG 177.36"
{
        Type  "Sa"
        RA            7.6044
        Dec          33.1231
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.3247   0.8757   0.3575]
        Angle     72.2910
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2201"
}

Galaxy "IC 2202:ESO 88-16:AM 0727-672:IRAS 07278-6728"
{
        Type  "Sc"
        RA            7.4650
        Dec         -67.5744
        Distance   1.563e+08  # method: T-F
        Radius     4.546e+04
        AbsMag         -19.8
        Axis    [ -0.0336  -0.0575  -0.9978]
        Angle     95.8484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2202"
}

Galaxy "IC 2203:UGC 3958:MCG 6-17-25:ZWG 177.42"
{
        Type  "SBc"
        RA            7.6758
        Dec          34.2300
        Distance   2.119e+08  # method: V
        Radius     3.698e+04
        AbsMag        -19.76
        Axis    [ -0.2225   0.7942  -0.5654]
        Angle    119.0982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2203"
}

Galaxy "IC 2204:UGC 3965:MCG 6-17-26:ZWG 177.43"
{
        Type  "SBb"
        RA            7.6883
        Dec          34.2314
        Distance   2.183e+08  # method: V
        Radius     3.492e+04
        AbsMag        -18.93
        Axis    [  0.8309   0.5496  -0.0869]
        Angle     67.2325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2204"
}

Galaxy "IC 2205:ZWG 148.15:NPM 1"
{
        Type  "S0"
        RA            7.7817
        Dec          26.8728
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.8066   0.5795   0.1162]
        Angle     72.9482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2205"
}

Galaxy "IC 2207:UGC 4040:MCG 6-17-29:ZWG 177.49"
{
        Type  "Sc"
        RA            7.8306
        Dec          33.9625
        Distance   2.245e+08  # method: V
        Radius     6.531e+04
        AbsMag        -18.99
        Axis    [ -0.3770   0.9256  -0.0327]
        Angle     73.7328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2207"
}

Galaxy "IC 2208:MCG 5-19-19:ZWG 148.53"
{
        Type  "S0"
        RA            7.8686
        Dec          27.4842
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.9418   0.2673   0.2039]
        Angle     82.4767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2208"
}

Galaxy "IC 2209:UGC 4093:MCG 10-12-17:MK 13"
{
        Type  "SBb"
        RA            7.9372
        Dec          60.3039
        Distance   6.822e+07  # method: V
        Radius     1.091e+04
        AbsMag         -17.3
        Axis    [ -0.1762   0.9419  -0.2862]
        Angle    104.8655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2209"
}

Galaxy "IC 2211:UGC 4119:MCG 5-19-23:ZWG 178.10"
{
        Type  "Sa"
        RA            7.9625
        Dec          32.5586
        Distance   2.507e+08  # method: V
        Radius     2.916e+04
        AbsMag        -19.53
        Axis    [ -0.3033   0.8722  -0.3837]
        Angle     85.2900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2211"
}

Galaxy "IC 2212:MCG 5-19-24:ZWG 178.13:NPM 1"
{
        Type  "S0"
        RA            7.9825
        Dec          32.6128
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.9372  -0.3391  -0.0824]
        Angle     84.9448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2212"
}

Galaxy "IC 2213:MCG 5-19-25:ZWG 148.76:NPM 1"
{
        Type  "Sb"
        RA            7.9850
        Dec          27.4644
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.8876   0.4597  -0.0306]
        Angle     70.6292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2213"
}

Galaxy "IC 2214:UGC 4143:MCG 6-18-7:ZWG 178.16"
{
        Type  "SBb"
        RA            7.9981
        Dec          33.2903
        Distance   2.747e+08  # method: V
        Radius     3.196e+04
        AbsMag        -20.13
        Axis    [  0.8792   0.4371  -0.1895]
        Angle     66.4266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2214"
}

Galaxy "IC 2217:UGC 4160:MCG 5-19-31:ZWG 148.91"
{
        Type  "S0"
        RA            8.0136
        Dec          27.5003
        Distance   2.444e+08  # method: V
        Radius     2.133e+04
        AbsMag        -19.97
        Axis    [  0.5291   0.8134  -0.2418]
        Angle     64.9666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2217"
}

Galaxy "IC 2218-1:ZWG 118.48"
{
        Type  "S0"
        RA            8.0272
        Dec          24.4319
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.8231   0.3932   0.4098]
        Angle     95.6176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2218-1"
}

Galaxy "IC 2218-2:NPM 1"
{
        Type  "S0"
        RA            8.0267
        Dec          24.4394
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.3650   0.9133  -0.1807]
        Angle     63.5996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2218-2"
}

Galaxy "IC 2219:UGC 4180:MCG 5-19-35:ZWG 148.100"
{
        Type  "Sc"
        RA            8.0433
        Dec          27.4372
        Distance   2.435e+08  # method: T-F
        Radius     4.604e+04
        AbsMag        -19.96
        Axis    [ -0.5466   0.6784  -0.4908]
        Angle    106.1194
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2219"
}

Galaxy "IC 2221"
{
        Type  "E0"
        RA            8.0856
        Dec          37.4506
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.9103  -0.4007  -0.1040]
        Angle     81.2677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2221"
}

Galaxy "IC 2222:ZWG 178.24"
{
        Type  "SBc"
        RA            8.0872
        Dec          37.4725
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.1401   0.9636  -0.2278]
        Angle     72.7982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2222"
}

Galaxy "IC 2224:NPM 1"
{
        Type  "E0"
        RA            8.0972
        Dec          37.4597
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.9093  -0.4027  -0.1045]
        Angle     81.3167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2224"
}

Galaxy "IC 2225:MCG 6-18-12:ZWG 178.26"
{
        Type  "SBa"
        RA            8.0911
        Dec          35.9469
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [  0.4904   0.8196  -0.2963]
        Angle     63.8821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2225"
}

Galaxy "IC 2226:UGC 4220:MCG 2-21-16:ZWG 59.44"
{
        Type  "Sb"
        RA            8.1031
        Dec          12.5442
        Distance   5.016e+08  # method: V
        Radius     6.566e+04
        AbsMag        -21.73
        Axis    [ -0.1636   0.6751  -0.7194]
        Angle    100.5435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2226"
}

Galaxy "IC 2227:ZWG 178.28"
{
        Type  "S0"
        RA            8.1186
        Dec          36.2333
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.9225  -0.3777  -0.0789]
        Angle     82.2554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2227"
}

Galaxy "IC 2230:ZWG 119.7:NPM 1"
{
        Type  "E0"
        RA            8.1822
        Dec          25.6853
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [  0.0201   0.6868  -0.7266]
        Angle    135.3162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2230"
}

Galaxy "IC 2231:UGC 4265:MCG 1-21-18:ZWG 31.66"
{
        Type  "E0"
        RA            8.1836
        Dec           5.0875
        Distance    3.02e+08  # distance uncertain!
        Radius     4.393e+04
        AbsMag        -20.13
        Axis    [  0.9402  -0.2929  -0.1742]
        Angle    111.6737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2231"
}

Galaxy "IC 2233:UGC 4278:MCG 8-15-52:ZWG 236.36"
{
        Type  "SBc"
        RA            8.2331
        Dec          45.7397
        Distance   3.212e+07  # method: V
        Radius     2.149e+04
        AbsMag        -16.97
        Axis    [ -0.7090   0.6825  -0.1776]
        Angle    103.6656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2233"
}

Galaxy "IC 2234:NPM 1"
{
        Type  "E0"
        RA            8.2308
        Dec          35.4933
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.9022  -0.4155  -0.1155]
        Angle     83.7625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2234"
}

Galaxy "IC 2239:MCG 4-20-6:ZWG 119.15:IRAS 08111+2401"
{
        Type  "S0"
        RA            8.2350
        Dec          23.8664
        Distance   2.836e+08  # method: V
        Radius     4.125e+04
        AbsMag         -19.8
        Axis    [ -0.3771   0.7125  -0.5917]
        Angle    107.1488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2239"
}

Galaxy "IC 2247:UGC 4299:MCG 4-20-8:ZWG 119.20"
{
        Type  "Sc"
        RA            8.2664
        Dec          23.1997
        Distance   2.242e+08  # method: T-F
        Radius     5.869e+04
        AbsMag        -20.19
        Axis    [ -0.5907   0.7552  -0.2840]
        Angle     75.3225
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2247"
}

Galaxy "IC 2248:MCG 4-20-9:ZWG 119.21:ARAK 156"
{
        Type  "S0"
        RA            8.2678
        Dec          23.1344
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [  0.9727   0.0321   0.2297]
        Angle     97.2630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2248"
}

Galaxy "IC 2249:KUG 0813+246"
{
        Type  "S0"
        RA            8.2761
        Dec          24.4931
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9284  -0.3517  -0.1200]
        Angle     93.5815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2249"
}

Galaxy "IC 2250"
{
        Type  "Irr"
        RA            8.2756
        Dec          23.6325
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.9294  -0.3482  -0.1222]
        Angle     94.3617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2250"
}

Galaxy "IC 2253:MCG 4-20-11:ZWG 119.24"
{
        Type  "E0"
        RA            8.2758
        Dec          21.4103
        Distance   2.248e+08  # method: V
        Radius     2.289e+04
        AbsMag        -19.19
        Axis    [ -0.0427   0.6717  -0.7396]
        Angle    140.3755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2253"
}

Galaxy "IC 2254:ZWG 119.25"
{
        Type  "S0"
        RA            8.2792
        Dec          24.7803
        Distance   3.482e+08  # method: V
        Radius     1.519e+04
        AbsMag        -19.94
        Axis    [  0.0280   0.8572  -0.5142]
        Angle     73.9313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2254"
}

Galaxy "IC 2256:MCG 4-20-12:ZWG 119.26:KUG 0813+243"
{
        Type  "Sc"
        RA            8.2817
        Dec          24.1767
        Distance   1.036e+08  # method: V
        Radius     1.054e+04
        AbsMag        -17.21
        Axis    [  0.8909   0.2748   0.3617]
        Angle     96.1152
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2256"
}

Galaxy "IC 2267:UGC 4315:MCG 4-20-16:ZWG 119.36"
{
        Type  "SBc"
        RA            8.3003
        Dec          24.7361
        Distance    1.03e+08  # method: V
        Radius     3.146e+04
        AbsMag         -17.5
        Axis    [ -0.6171   0.7366  -0.2768]
        Angle     77.5317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2267"
}

Galaxy "IC 2268:ZWG 119.37:KUG 0815+249"
{
        Type  "E0"
        RA            8.3017
        Dec          24.7961
        Distance   4.366e+08  # distance uncertain!
        Radius      1.27e+04
        AbsMag        -20.13
        Axis    [  0.9137  -0.3797  -0.1449]
        Angle     93.8111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2268"
}

Galaxy "IC 2269:ZWG 119.38"
{
        Type  "S0"
        RA            8.3022
        Dec          23.0472
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.7203   0.5355   0.4410]
        Angle     89.6579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2269"
}

Galaxy "IC 2271:ZWG 119.39:NPM 1:KUG 0815+246"
{
        Type  "E0"
        RA            8.3053
        Dec          24.5275
        Distance   3.802e+08  # distance uncertain!
        Radius     1.659e+04
        AbsMag        -20.13
        Axis    [  0.1839   0.6116  -0.7695]
        Angle    117.7208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2271"
}

Galaxy "IC 2282:MCG 4-20-20:ZWG 119.49:KUG 0816+249"
{
        Type  "Sb"
        RA            8.3208
        Dec          24.7931
        Distance   2.208e+08  # method: V
        Radius     3.211e+04
        AbsMag        -19.45
        Axis    [  0.9815  -0.0405   0.1872]
        Angle     94.7724
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2282"
}

Galaxy "IC 2288:MCG 4-20-23:ZWG 119.52:ARAK 158"
{
        Type  "Sc"
        RA            8.3228
        Dec          23.7472
        Distance   3.135e+08  # method: T-F
        Radius     2.736e+04
        AbsMag        -19.31
        Axis    [  0.6336   0.7730  -0.0321]
        Angle     61.8880
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2288"
}

Galaxy "IC 2290:ZWG 88.59:ZWG 89.1:KARA 241"
{
        Type  "E0"
        RA            8.3208
        Dec          19.3136
        Distance   2.677e+08  # method: V
        Radius     1.558e+04
        AbsMag        -19.27
        Axis    [  0.0721   0.6178  -0.7830]
        Angle    128.6876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2290"
}

Galaxy "IC 2293:MCG 4-20-24:ZWG 119.54"
{
        Type  "Sb"
        RA            8.3256
        Dec          21.3944
        Distance   1.932e+08  # method: V
        Radius     2.529e+04
        AbsMag        -18.76
        Axis    [  0.0711   0.7738  -0.6294]
        Angle     80.8423
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2293"
}

Galaxy "IC 2307:ZWG 89.4"
{
        Type  "S0"
        RA            8.3450
        Dec          19.4408
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.4817   0.6813  -0.5512]
        Angle     93.7771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2307"
}

Galaxy "IC 2308:UGC 4355:MCG 3-22-1:ZWG 89.6"
{
        Type  "Sc"
        RA            8.3458
        Dec          19.3617
        Distance   2.701e+08  # method: V
        Radius     2.357e+04
        AbsMag        -18.99
        Axis    [  0.4005   0.8761  -0.2684]
        Angle     60.5210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2308"
}

Galaxy "IC 2309:ZWG 89.3"
{
        Type  "S0"
        RA            8.3453
        Dec          18.3972
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.8455   0.3510   0.4023]
        Angle    107.7873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2309"
}

Galaxy "IC 2311:ESO 495-2:MCG 4-20-7:CGMW 2-3182"
{
        Type  "E0"
        RA            8.3125
        Dec         -25.3700
        Distance   7.611e+07  # method: S
        Radius     1.439e+04
        AbsMag        -19.34
        Axis    [  0.9486  -0.2200  -0.2275]
        Angle    140.7610
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2311"
}

Galaxy "IC 2312-1"
{
        Type  "S0"
        RA            8.3481
        Dec          18.5083
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9307  -0.3383  -0.1394]
        Angle     99.3149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2312-1"
}

Galaxy "IC 2312-2"
{
        Type  "E0"
        RA            8.3481
        Dec          18.5122
        Distance    8.71e+08  # distance uncertain!
        Radius     1.267e+04
        AbsMag        -20.13
        Axis    [  0.9184  -0.3614  -0.1611]
        Angle     99.7622
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2312-2"
}

Galaxy "IC 2327:UGC 4356:MCG 1-22-2:ZWG 32.4"
{
        Type  "Sa"
        RA            8.3578
        Dec           3.1689
        Distance    1.33e+08  # method: V
        Radius     2.707e+04
        AbsMag        -19.05
        Axis    [ -0.6360   0.4778  -0.6060]
        Angle     86.1793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2327"
}

Galaxy "IC 2329:UGC 4365:MCG 3-22-5:ZWG 89.8"
{
        Type  "Irr"
        RA            8.3719
        Dec          19.4156
        Distance   1.048e+08  # method: V
        Radius     3.202e+04
        AbsMag        -17.73
        Axis    [ -0.2145   0.9698  -0.1159]
        Angle     58.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2329"
}

Galaxy "IC 2335"
{
        Type  "E0"
        RA            8.3853
        Dec          19.4075
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [ -0.0656   0.6605  -0.7480]
        Angle    140.6092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2335"
}

Galaxy "IC 2337:ZWG 89.10"
{
        Type  "S0"
        RA            8.3889
        Dec          18.5356
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.7750   0.5909   0.2241]
        Angle     75.9803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2337"
}

Galaxy "IC 2338:UGC 4383:MCG 4-20-44:ZWG 119.80"
{
        Type  "SBc"
        RA            8.3922
        Dec          21.3378
        Distance   2.515e+08  # method: V
        Radius     1.829e+04
        AbsMag        -19.74
        Axis    [  0.9867  -0.0373   0.1583]
        Angle     97.3721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2338"
}

Galaxy "IC 2339:UGC 4383:MCG 4-20-45:ZWG 119.80"
{
        Type  "SBc"
        RA            8.3928
        Dec          21.3475
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [  0.7677   0.6402  -0.0279]
        Angle     65.4553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2339"
}

Galaxy "IC 2340:MCG 3-22-6:ZWG 89.11"
{
        Type  "S0"
        RA            8.3917
        Dec          18.7494
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.3957   0.6669  -0.6314]
        Angle    107.2696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2340"
}

Galaxy "IC 2341:UGC 4384:MCG 4-20-46:ZWG 119.81"
{
        Type  "S0"
        RA            8.3947
        Dec          21.4350
        Distance   2.299e+08  # method: V
        Radius     4.347e+04
        AbsMag        -19.54
        Axis    [  0.9206   0.1911   0.3404]
        Angle    103.4213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2341"
}

Galaxy "IC 2348:MCG 4-20-49:ZWG 119.85:NPM 1"
{
        Type  "S0"
        RA            8.4056
        Dec          20.5339
        Distance   4.435e+08  # method: T-F
        Radius     4.515e+04
        AbsMag        -19.97
        Axis    [  0.4291   0.8428  -0.3248]
        Angle     60.9127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2348"
}

Galaxy "IC 2361:UGC 4394:MCG 5-20-12:ZWG 149.23"
{
        Type  "SBb"
        RA            8.4289
        Dec          27.8747
        Distance   1.042e+08  # method: V
        Radius     1.668e+04
        AbsMag        -17.62
        Axis    [  0.5023   0.8646   0.0131]
        Angle     57.8904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2361"
}

Galaxy "IC 2363:MCG 3-22-11:ZWG 89.23:IRAS 08228+1936"
{
        Type  "SBc"
        RA            8.4292
        Dec          19.4486
        Distance   3.557e+08  # method: V
        Radius     4.138e+04
        AbsMag        -20.29
        Axis    [  0.9246  -0.3534  -0.1422]
        Angle     98.7788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2363"
}

Galaxy "IC 2365:IC 2366:UGC 4402:MCG 5-20-14"
{
        Type  "S0"
        RA            8.4383
        Dec          27.8406
        Distance   2.851e+08  # method: V
        Radius     4.561e+04
        AbsMag        -20.01
        Axis    [  0.9393   0.3189  -0.1268]
        Angle     68.2190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2365"
}

Galaxy "IC 2367:MCG 3-22-1:ESO 562-5:PGC 23580"
{
        Type  "SBb"
        RA            8.4028
        Dec         -18.7758
        Distance    7.37e+07  # distance uncertain!
        Radius     2.787e+04
        AbsMag        -19.07
        Axis    [  0.8204   0.3513  -0.4512]
        Angle     98.2548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2367"
}

Galaxy "IC 2373:UGC 4409:MCG 4-20-54:ZWG 119.100"
{
        Type  "SBc"
        RA            8.4469
        Dec          20.3647
        Distance   3.507e+08  # method: V
        Radius      4.59e+04
        AbsMag        -20.06
        Axis    [  0.9224  -0.3597  -0.1409]
        Angle     98.0232
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2373"
}

Galaxy "IC 2374:ZWG 149.27"
{
        Type  "SBb"
        RA            8.4728
        Dec          30.4431
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.9747  -0.1202   0.1887]
        Angle     90.4581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2374"
}

Galaxy "IC 2375:MCG 2-22-14:IRAS 08240-1308"
{
        Type  "SBb"
        RA            8.4386
        Dec         -13.3031
        Distance   2.789e+08  # method: V
        Radius     7.706e+04
        AbsMag        -20.16
        Axis    [  0.5296   0.7860  -0.3190]
        Angle     65.4579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2375"
}

Galaxy "IC 2376:MCG 5-20-16:ZWG 149.29"
{
        Type  "S0"
        RA            8.4739
        Dec          30.4075
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.6544   0.7561  -0.0115]
        Angle     58.0334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2376"
}

Galaxy "IC 2377:MCG 2-22-15"
{
        Type  "SBa"
        RA            8.4406
        Dec         -13.3069
        Distance   1.688e+08  # distance uncertain!
        Radius     1.719e+04
        AbsMag        -19.07
        Axis    [  0.9051   0.3746  -0.2012]
        Angle    100.1550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2377"
}

Galaxy "IC 2378:MCG 5-20-18:ZWG 149.31"
{
        Type  "S0"
        RA            8.4753
        Dec          30.4311
        Distance   6.813e+08  # method: V
        Radius     7.928e+04
        AbsMag         -21.3
        Axis    [  0.9060  -0.4077  -0.1141]
        Angle     89.1585
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2378"
}

Galaxy "IC 2379:MCG 2-22-16"
{
        Type  "Sa"
        RA            8.4408
        Dec         -13.2933
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [ -0.1442   0.4773  -0.8668]
        Angle     85.2959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2379"
}

Galaxy "IC 2380:MCG 5-20-19:ZWG 149.32:NPM 1"
{
        Type  "Sa"
        RA            8.4786
        Dec          30.4050
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.9058  -0.4080  -0.1144]
        Angle     89.1980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2380"
}

Galaxy "IC 2382:MCG 4-20-64:ZWG 119.114:ARAK 164"
{
        Type  "S0"
        RA            8.4794
        Dec          22.0533
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [ -0.5143   0.6814  -0.5207]
        Angle     95.0126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2382"
}

Galaxy "IC 2383:ZWG 149.38"
{
        Type  "E0"
        RA            8.4947
        Dec          30.6881
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.8900  -0.4338  -0.1404]
        Angle     89.4104
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2383"
}

Galaxy "IC 2384:MCG 6-19-9:ZWG 179.11:NPM 1"
{
        Type  "SBa"
        RA            8.5731
        Dec          32.4353
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.8948  -0.4319  -0.1126]
        Angle     87.8990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2384"
}

Galaxy "IC 2385:MCG 6-19-10:ZWG 179.13:KUG 0831+374"
{
        Type  "Sb"
        RA            8.5861
        Dec          37.2658
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.9612   0.0770   0.2648]
        Angle     76.4249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2385"
}

Galaxy "IC 2387:UGC 4511:MCG 5-21-3:ZWG 150.13"
{
        Type  "SBc"
        RA            8.6425
        Dec          30.7983
        Distance   3.378e+08  # method: T-F
        Radius     5.405e+04
        AbsMag        -20.28
        Axis    [  0.8959   0.2396   0.3740]
        Angle     85.9957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2387"
}

Galaxy "IC 2388:ZWG 89.63"
{
        Type  "S0"
        RA            8.6656
        Dec          19.6447
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.4739   0.7017  -0.5320]
        Angle     86.1174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2388"
}

Galaxy "IC 2389:UGC 4576:MCG 12-9-11:ZWG 331.64"
{
        Type  "SBb"
        RA            8.7994
        Dec          73.5386
        Distance   1.102e+08  # method: V
        Radius     2.243e+04
        AbsMag        -18.64
        Axis    [ -0.4438   0.7870   0.4287]
        Angle     90.3742
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2389"
}

Galaxy "IC 2390:ZWG 89.67:NPM 1"
{
        Type  "S0"
        RA            8.6975
        Dec          19.7031
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.9707   0.2351   0.0506]
        Angle     79.9164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2390"
}

Galaxy "IC 2392:MCG 3-23-1:ZWG 90.2:IRAS 08416+1828"
{
        Type  "S0"
        RA            8.7417
        Dec          18.2861
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.9961  -0.0720   0.0501]
        Angle     95.7189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2392"
}

Galaxy "IC 2393:UGC 4589:MCG 5-21-7:ZWG 150.27"
{
        Type  "E0"
        RA            8.7803
        Dec          28.1708
        Distance   2.968e+08  # method: V
        Radius     5.611e+04
        AbsMag        -20.49
        Axis    [  0.8899  -0.3124  -0.3323]
        Angle     85.3118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2393"
}

Galaxy "IC 2394:UGC 4595:MCG 5-21-9:ZWG 150.31"
{
        Type  "SBb"
        RA            8.7850
        Dec          28.2364
        Distance   2.998e+08  # method: V
        Radius     6.541e+04
        AbsMag        -19.92
        Axis    [  0.1170   0.9712  -0.2077]
        Angle     54.6082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2394"
}

Galaxy "IC 2398:MCG 3-23-3:ZWG 90.6:ARAK 177"
{
        Type  "S0"
        RA            8.7789
        Dec          17.7553
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.9748   0.0938   0.2023]
        Angle     99.4200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2398"
}

Galaxy "IC 2400:MCG 6-20-2:ZWG 179.32:ZWG 180.6"
{
        Type  "Sc"
        RA            8.7997
        Dec          38.0689
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.1003   0.9948   0.0195]
        Angle     57.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2400"
}

Galaxy "IC 2401:UGC 4600:MCG 6-20-5:ZWG 179.34"
{
        Type  "S0"
        RA            8.8028
        Dec          37.7558
        Distance   2.555e+08  # distance uncertain!
        Radius      4.46e+04
        AbsMag        -19.07
        Axis    [  0.1859   0.9704  -0.1540]
        Angle     55.0118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2401"
}

Galaxy "IC 2402:MCG 5-21-10:ZWG 150.33:NPM 1"
{
        Type  "Sa"
        RA            8.7997
        Dec          31.7861
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.8779  -0.4621  -0.1256]
        Angle     89.6922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2402"
}

Galaxy "IC 2403:IRAS 08438-1510"
{
        Type  "S0"
        RA            8.7692
        Dec         -15.3567
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [  0.1217   0.5269  -0.8412]
        Angle     69.5781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2403"
}

Galaxy "IC 2404:ZWG 150.34"
{
        Type  "S0"
        RA            8.8028
        Dec          29.4914
        Distance   3.736e+08  # method: V
        Radius     2.173e+04
        AbsMag        -19.79
        Axis    [  0.4128   0.7957  -0.4433]
        Angle     58.7768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2404"
}

Galaxy "IC 2405:MCG 6-20-6:ZWG 180.11:ARAK 181"
{
        Type  "Sc"
        RA            8.8117
        Dec          37.2183
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.9329  -0.0313   0.3587]
        Angle     90.1359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2405"
}

Galaxy "IC 2406:UGC 4606:MCG 3-23-5:ZWG 90.11"
{
        Type  "Sa"
        RA            8.8011
        Dec          17.7022
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [ -0.5421   0.6278  -0.5586]
        Angle     95.5721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2406"
}

Galaxy "IC 2407:UGC 4607:MCG 3-23-6:ZWG 90.12"
{
        Type  "Sc"
        RA            8.8025
        Dec          17.6117
        Distance   2.915e+08  # method: V
        Radius     5.088e+04
        AbsMag        -19.56
        Axis    [  0.3399   0.9276   0.1549]
        Angle     53.7731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2407"
}

Galaxy "IC 2409:UGC 4608:MCG 3-23-8:ZWG 90.15"
{
        Type  "SBa"
        RA            8.8067
        Dec          18.3303
        Distance   2.984e+08  # method: V
        Radius     4.341e+04
        AbsMag        -20.41
        Axis    [ -0.3954   0.6750  -0.6229]
        Angle     96.6515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2409"
}

Galaxy "IC 2411:NGC 2667B:MCG 3-23-9:ZWG 90.18"
{
        Type  "S0"
        RA            8.8083
        Dec          19.0436
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.7710   0.5610   0.3013]
        Angle     74.9899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2411"
}

Galaxy "IC 2414:ZWG 90.20:MCG 3-23-9:NPM 1"
{
        Type  "E0"
        RA            8.8306
        Dec          18.7931
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.8842  -0.4272  -0.1892]
        Angle    101.6246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2414"
}

Galaxy "IC 2418"
{
        Type  "E0"
        RA            8.8569
        Dec          17.9447
        Distance    6.31e+08  # distance uncertain!
        Radius     1.836e+04
        AbsMag        -20.13
        Axis    [  0.8835  -0.4269  -0.1928]
        Angle    102.4994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2418"
}

Galaxy "IC 2420:ZWG 33.14"
{
        Type  "E0"
        RA            8.8592
        Dec           3.1011
        Distance    3.02e+08  # distance uncertain!
        Radius     2.636e+04
        AbsMag        -20.13
        Axis    [  0.9020  -0.3671  -0.2270]
        Angle    115.7701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2420"
}

Galaxy "IC 2421:UGC 4658:MCG 6-20-13:ZWG 180.19"
{
        Type  "Sc"
        RA            8.9058
        Dec          32.6806
        Distance   2.087e+08  # method: V
        Radius     6.071e+04
        AbsMag        -20.03
        Axis    [ -0.2373   0.8224  -0.5171]
        Angle     85.5370
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2421"
}

Galaxy "IC 2422:MCG 3-23-16:ZWG 90.34:NPM 1"
{
        Type  "E0"
        RA            8.9067
        Dec          20.2253
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.8761  -0.4433  -0.1897]
        Angle    100.7339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2422"
}

Galaxy "IC 2423:UGC 4667:MCG 3-23-17:ZWG 90.35"
{
        Type  "SBb"
        RA            8.9131
        Dec          20.2203
        Distance    4.24e+08  # method: V
        Radius     6.167e+04
        AbsMag        -20.97
        Axis    [ -0.0129   0.7305  -0.6828]
        Angle     77.8984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2423"
}

Galaxy "IC 2426:MCG 1-23-14:ZWG 33.33:NPM 1"
{
        Type  "S0"
        RA            8.9750
        Dec           2.9261
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.1818   0.7307  -0.6580]
        Angle     58.1604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2426"
}

Galaxy "IC 2427:ZWG 180.28:NPM 1"
{
        Type  "E0"
        RA            9.0169
        Dec          37.8761
        Distance   5.249e+08  # distance uncertain!
        Radius     3.053e+04
        AbsMag        -20.13
        Axis    [  0.5307   0.4027  -0.7458]
        Angle     77.5861
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2427"
}

Galaxy "IC 2428:UGC 4747:MCG 5-22-1:ZWG 151.4"
{
        Type  "Sc"
        RA            9.0539
        Dec          30.5908
        Distance    2.06e+08  # method: V
        Radius     5.693e+04
        AbsMag         -19.4
        Axis    [  0.4250   0.7909   0.4402]
        Angle     57.1557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2428"
}

Galaxy "IC 2429:MCG 5-22-3:ZWG 151.6:NPM 1"
{
        Type  "Sb"
        RA            9.0617
        Dec          29.2967
        Distance   1.474e+08  # method: V
        Radius          8576
        AbsMag        -18.08
        Axis    [ -0.5114   0.7574  -0.4059]
        Angle     83.5949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2429"
}

Galaxy "IC 2430:UGC 4755:MCG 5-22-5:ZWG 151.8"
{
        Type  "Sa"
        RA            9.0728
        Dec          27.9525
        Distance   1.462e+08  # method: V
        Radius     2.339e+04
        AbsMag        -18.86
        Axis    [  0.9221   0.3484   0.1686]
        Angle     66.7500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2430"
}

Galaxy "IC 2431:UGC 4756:MCG 3-23-30:MK 1224"
{
        Type  "Sc"
        RA            9.0761
        Dec          14.5953
        Distance     6.9e+08  # method: V
        Radius     5.018e+04
        AbsMag        -22.03
        Axis    [  0.9032   0.2582  -0.3428]
        Angle     71.1190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2431"
}

Galaxy "IC 2432:ZWG 33.56:NPM 1"
{
        Type  "S0"
        RA            9.0775
        Dec           5.5125
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [ -0.2782   0.7265  -0.6283]
        Angle     59.1908
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2432"
}

Galaxy "IC 2433:MCG 4-22-10:ZWG 121.16"
{
        Type  "Sc"
        RA            9.0911
        Dec          22.6019
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.1069   0.9260  -0.3619]
        Angle     54.3862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2433"
}

Galaxy "IC 2434:UGC 4785:MCG 6-20-25:ZWG 180.35"
{
        Type  "SBa"
        RA            9.1208
        Dec          37.2156
        Distance   3.341e+08  # method: V
        Radius      7.29e+04
        AbsMag        -20.65
        Axis    [  0.9061   0.0824   0.4151]
        Angle     87.2581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2434"
}

Galaxy "IC 2435:UGC 4782:MCG 4-22-14:ZWG 121.19"
{
        Type  "E0"
        RA            9.1136
        Dec          26.2758
        Distance   3.163e+08  # distance uncertain!
        Radius      3.68e+04
        AbsMag        -20.13
        Axis    [  0.2623   0.5159  -0.8155]
        Angle     98.1899
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2435"
}

Galaxy "IC 2437:ESO 564-21:MCG 3-23-20:NPM 1"
{
        Type  "S0"
        RA            9.0925
        Dec         -19.2072
        Distance   1.281e+08  # distance uncertain!
        Radius     3.353e+04
        AbsMag        -19.07
        Axis    [  0.0935   0.3978  -0.9127]
        Angle     75.4160
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2437"
}

Galaxy "IC 2439:MCG 6-20-32:ZWG 180.43:NPM 1"
{
        Type  "Sa"
        RA            9.1439
        Dec          32.5933
        Distance   2.054e+08  # method: V
        Radius     2.987e+04
        AbsMag         -19.2
        Axis    [  0.7643   0.3701   0.5281]
        Angle     85.3630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2439"
}

Galaxy "IC 2441-1:MCG 4-22-20:ZWG 121.30:VV 707"
{
        Type  "E0"
        RA            9.1669
        Dec          22.8550
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.4675   0.3158  -0.8256]
        Angle     89.4264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2441-1"
}

Galaxy "IC 2441-2:MCG 4-22-20:ZWG 121.30:VV 707"
{
        Type  "E0"
        RA            9.1672
        Dec          22.8517
        Distance   3.802e+08  # distance uncertain!
        Radius     2.212e+04
        AbsMag        -20.13
        Axis    [  0.1756   0.5375  -0.8248]
        Angle    104.6837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2441-2"
}

Galaxy "IC 2442:MCG 4-22-21:ZWG 121.31:NPM 1"
{
        Type  "E0"
        RA            9.1681
        Dec          22.8389
        Distance   3.631e+08  # distance uncertain!
        Radius     2.641e+04
        AbsMag        -20.13
        Axis    [  0.8502  -0.4887  -0.1961]
        Angle     99.8527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2442"
}

Galaxy "IC 2443:MCG 5-22-11:ZWG 151.19:NPM 1"
{
        Type  "S0"
        RA            9.1917
        Dec          28.8269
        Distance   4.758e+08  # method: V
        Radius     4.844e+04
        AbsMag        -20.62
        Axis    [ -0.2805   0.7502  -0.5987]
        Angle     98.8760
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2443"
}

Galaxy "IC 2444:MCG 5-22-12:ZWG 151.22:NPM 1"
{
        Type  "SBa"
        RA            9.2139
        Dec          30.2128
        Distance   3.071e+08  # method: V
        Radius      2.68e+04
        AbsMag        -19.87
        Axis    [  0.8463  -0.5110  -0.1504]
        Angle     93.4417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2444"
}

Galaxy "IC 2445:UGC 4854:MCG 5-22-13:ZWG 151.24"
{
        Type  "SBb"
        RA            9.2200
        Dec          31.8075
        Distance   9.699e+07  # method: V
        Radius     1.129e+04
        AbsMag        -17.27
        Axis    [  0.9684   0.0177   0.2489]
        Angle     83.1954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2445"
}

Galaxy "IC 2446:UGC 4855:MCG 5-22-15:ZWG 151.25"
{
        Type  "Sa"
        RA            9.2253
        Dec          28.9514
        Distance   3.708e+08  # method: V
        Radius      7.55e+04
        AbsMag        -20.48
        Axis    [ -0.4816   0.8117  -0.3304]
        Angle     70.3673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2446"
}

Galaxy "IC 2449:UGC 4856:MCG 5-22-17:ZWG 151.026"
{
        Type  "Sb"
        RA            9.2256
        Dec          30.0003
        Distance   3.157e+08  # method: V
        Radius     7.806e+04
        AbsMag        -19.83
        Axis    [  0.4212   0.7857   0.4530]
        Angle     55.1511
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2449"
}

Galaxy "IC 2450:UGC 4902:MCG 4-22-29:ZWG 121.49"
{
        Type  "S0"
        RA            9.2847
        Dec          25.4278
        Distance   8.132e+07  # method: V
        Radius     1.774e+04
        AbsMag        -18.18
        Axis    [ -0.4872   0.7462  -0.4536]
        Angle     78.3813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2450"
}

Galaxy "IC 2451:ZWG 121.45:NPM 1"
{
        Type  "E0"
        RA            9.2631
        Dec          23.4969
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.8407  -0.5037  -0.1987]
        Angle     99.8332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2451"
}

Galaxy "IC 2452:ZWG 121.47:NPM 1"
{
        Type  "S0"
        RA            9.2658
        Dec          23.4728
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [ -0.2963   0.8472  -0.4410]
        Angle     61.5737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2452"
}

Galaxy "IC 2453:MK 1229:ZWG 121.46:NPM 1"
{
        Type  "S0"
        RA            9.2650
        Dec          20.9294
        Distance   4.184e+08  # method: V
        Radius     3.042e+04
        AbsMag        -20.14
        Axis    [  0.8858   0.4507  -0.1106]
        Angle     58.9822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2453"
}

Galaxy "IC 2454:UGC 4886:MCG 3-24-19:ZWG 91.38"
{
        Type  "Sa"
        RA            9.2669
        Dec          17.8214
        Distance   4.034e+08  # method: V
        Radius     5.281e+04
        AbsMag        -20.86
        Axis    [  0.9874  -0.0517   0.1497]
        Angle    102.8177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2454"
}

Galaxy "IC 2456:NPM 1"
{
        Type  "S0"
        RA            9.2900
        Dec          34.6747
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.8661   0.4865   0.1149]
        Angle     52.8389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2456"
}

Galaxy "IC 2457"
{
        Type  "S0"
        RA            9.2844
        Dec          20.0936
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.9393   0.3402  -0.0450]
        Angle     64.9446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2457"
}

Galaxy "IC 2458:NGC 2820A:MK 108:MCG 11-12-5"
{
        Type  "Sa"
        RA            9.3583
        Dec          64.2383
        Distance   7.402e+07  # method: V
        Radius          5383
        AbsMag        -16.38
        Axis    [  0.7036   0.0012   0.7106]
        Angle     80.8277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2458"
}

Galaxy "IC 2459:NPM 1"
{
        Type  "E0"
        RA            9.3164
        Dec          34.8628
        Distance   1.161e+08  # method: V
        Radius          6755
        AbsMag        -17.06
        Axis    [  0.4338   0.4285  -0.7926]
        Angle     80.8409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2459"
}

Galaxy "IC 2461:UGC 4943:MCG 6-21-19:ZWG 181.25"
{
        Type  "Sb"
        RA            9.3328
        Dec          37.1908
        Distance   1.128e+08  # method: V
        Radius     3.775e+04
        AbsMag        -17.79
        Axis    [ -0.6018   0.7961   0.0630]
        Angle     67.1190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2461"
}

Galaxy "IC 2462"
{
        Type  "S0"
        RA            9.3822
        Dec          22.6861
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.9364   0.3304   0.1186]
        Angle     66.8840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2462"
}

Galaxy "IC 2463:ZWG 121.66:NPM 1"
{
        Type  "E0"
        RA            9.3833
        Dec          22.6192
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.8323  -0.5141  -0.2074]
        Angle    101.2641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2463"
}

Galaxy "IC 2464:MCG 4-22-36:ZWG 121.70"
{
        Type  "S0"
        RA            9.3894
        Dec          22.6303
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.9675  -0.2484   0.0474]
        Angle     98.4419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2464"
}

Galaxy "IC 2465"
{
        Type  "S0"
        RA            9.3919
        Dec          24.4461
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.6837   0.7088  -0.1740]
        Angle     47.9554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2465"
}

Galaxy "IC 2466:MCG 4-22-44:ZWG 121.76"
{
        Type  "S0"
        RA            9.3956
        Dec          24.5181
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.9744  -0.1886   0.1221]
        Angle     97.9858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2466"
}

Galaxy "IC 2467:MCG 7-20-5:ZWG 210.6"
{
        Type  "S0"
        RA            9.4144
        Dec          38.3517
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.8044  -0.5810  -0.1243]
        Angle     88.3008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2467"
}

Galaxy "IC 2468:MCG 7-20-7:NPM 1"
{
        Type  "S0"
        RA            9.4144
        Dec          38.3522
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.8044  -0.5810  -0.1243]
        Angle     88.3003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2468"
}

Galaxy "IC 2469:ESO 433-17:MCG 5-22-8:UGCA 163"
{
        Type  "SBb"
        RA            9.3836
        Dec         -32.4497
        Distance    7.76e+07  # method: T-F
        Radius     5.305e+04
        AbsMag        -20.58
        Axis    [  0.8415   0.4887  -0.2302]
        Angle     99.6594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2469"
}

Galaxy "IC 2470:ZWG 121.88"
{
        Type  "S0"
        RA            9.4281
        Dec          23.3614
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.8438  -0.5034  -0.1862]
        Angle    100.3222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2470"
}

Galaxy "IC 2471:MCG 1-24-15"
{
        Type  "S0"
        RA            9.4200
        Dec          -6.8300
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [ -0.2123   0.4707  -0.8564]
        Angle     73.1725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2471"
}

Galaxy "IC 2472:ZWG 121.93"
{
        Type  "S0"
        RA            9.4425
        Dec          21.3850
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.9826  -0.0252   0.1840]
        Angle     97.9313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2472"
}

Galaxy "IC 2473:UGC 5038:MCG 5-22-47:ZWG 151.82"
{
        Type  "SBc"
        RA            9.4564
        Dec          30.4414
        Distance   3.772e+08  # method: V
        Radius     8.777e+04
        AbsMag        -20.92
        Axis    [  0.9877  -0.1479   0.0514]
        Angle     80.3454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2473"
}

Galaxy "IC 2474:MCG 4-22-57"
{
        Type  "Sc"
        RA            9.4531
        Dec          23.0342
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.3735   0.9215  -0.1067]
        Angle     43.3080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2474"
}

Galaxy "IC 2475:MCG 5-22-49:ZWG 152.6:ZWG 151.87"
{
        Type  "Sb"
        RA            9.4650
        Dec          29.7922
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [ -0.0191   0.9636   0.2665]
        Angle     46.1343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2475"
}

Galaxy "IC 2476:UGC 5043:MCG 5-23-1:ZWG 151.86"
{
        Type  "S0"
        RA            9.4644
        Dec          29.9858
        Distance   3.752e+08  # method: V
        Radius     6.548e+04
        AbsMag         -21.1
        Axis    [  0.9929  -0.0738   0.0929]
        Angle     78.8059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2476"
}

Galaxy "IC 2478:MCG 5-23-3:ZWG 151.88:ZWG 152.7"
{
        Type  "E0"
        RA            9.4667
        Dec          30.0375
        Distance   4.787e+08  # distance uncertain!
        Radius     4.873e+04
        AbsMag        -20.13
        Axis    [  0.8065  -0.5615  -0.1853]
        Angle     95.7014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2478"
}

Galaxy "IC 2479:MCG 5-23-2:ZWG 151.89:ZWG 152.8"
{
        Type  "SBb"
        RA            9.4678
        Dec          29.9911
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.5417   0.7557  -0.3682]
        Angle     78.6384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2479"
}

Galaxy "IC 2480:ZWG 151.94:ZWG 152.13:NPM 1"
{
        Type  "Sa"
        RA            9.4714
        Dec          29.7064
        Distance   3.795e+08  # method: V
        Radius     4.416e+04
        AbsMag        -19.93
        Axis    [ -0.5219   0.7270  -0.4462]
        Angle     90.5986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2480"
}

Galaxy "IC 2481:UGC 5040A:MCG 1-24-22:ZWG 34.47"
{
        Type  "Sb"
        RA            9.4578
        Dec           3.9292
        Distance    2.78e+08  # method: T-F
        Radius     3.639e+04
        AbsMag        -20.15
        Axis    [ -0.4278   0.5390  -0.7256]
        Angle     83.1136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2481"
}

Galaxy "IC 2482:MCG 2-24-25:NPM 1"
{
        Type  "E0"
        RA            9.4497
        Dec         -12.1083
        Distance   1.097e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -20.13
        Axis    [ -0.0259   0.3252  -0.9453]
        Angle    127.0660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2482"
}

Galaxy "IC 2483:ZWG 152.17"
{
        Type  "S0"
        RA            9.4903
        Dec          30.9944
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.3769   0.7892  -0.4848]
        Angle     50.2179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2483"
}

Galaxy "IC 2486:UGC 5062:MCG 5-23-6:ZWG 152.20"
{
        Type  "SBc"
        RA            9.5047
        Dec          26.6411
        Distance   6.341e+08  # method: V
        Radius       8.3e+04
        AbsMag        -21.44
        Axis    [  0.0254   0.7104  -0.7033]
        Angle     74.1560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2486"
}

Galaxy "IC 2487:UGC 5059:MCG 3-24-61:ZWG 91.98"
{
        Type  "Sb"
        RA            9.5025
        Dec          20.0900
        Distance   2.096e+08  # method: V
        Radius     5.182e+04
        AbsMag        -19.84
        Axis    [ -0.7508   0.6011  -0.2738]
        Angle     71.0362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2487"
}

Galaxy "IC 2490:UGC 5087:MCG 5-23-10:ZWG 152.26"
{
        Type  "Sc"
        RA            9.5508
        Dec          29.9286
        Distance   3.447e+08  # method: V
        Radius     7.521e+04
        AbsMag        -20.62
        Axis    [ -0.5268   0.7168  -0.4569]
        Angle     95.3675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2490"
}

Galaxy "IC 2491:UGC 5104:MCG 6-21-53:ZWG 181.62"
{
        Type  "S0"
        RA            9.5872
        Dec          34.7322
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [  0.8020   0.5622  -0.2019]
        Angle     45.7174
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2491"
}

Galaxy "IC 2492:ESO 315-13"
{
        Type  "Sb"
        RA            9.5539
        Dec         -37.8667
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.8352   0.3145  -0.4512]
        Angle    102.8893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2492"
}

Galaxy "IC 2493:MCG 6-21-56:ZWG 181.65:NPM 1"
{
        Type  "S0"
        RA            9.6047
        Dec          37.3644
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.9331  -0.1619   0.3210]
        Angle     95.9159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2493"
}

Galaxy "IC 2495:MCG 5-23-23:ZWG 152.42"
{
        Type  "Sb"
        RA            9.6353
        Dec          28.0581
        Distance   4.702e+08  # method: V
        Radius     5.471e+04
        AbsMag        -20.99
        Axis    [  0.9680  -0.2490  -0.0320]
        Angle     84.5319
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2495"
}

Galaxy "IC 2496:ZWG 181.73:KUG 0935+349"
{
        Type  "Sc"
        RA            9.6456
        Dec          34.7267
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.9882  -0.0980   0.1173]
        Angle     73.4959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2496"
}

Galaxy "IC 2497:NPM 1:IRAS 09380+3457"
{
        Type  "S0"
        RA            9.6844
        Dec          34.7336
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.0516   0.9927  -0.1093]
        Angle     44.3519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2497"
}

Galaxy "IC 2498:ZWG 152.49"
{
        Type  "Sb"
        RA            9.6892
        Dec          28.1144
        Distance   4.595e+08  # method: V
        Radius      4.01e+04
        AbsMag        -20.44
        Axis    [  0.9218   0.1486   0.3580]
        Angle     87.9417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2498"
}

Galaxy "IC 2499"
{
        Type  "Irr"
        RA            9.6900
        Dec          27.8958
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [ -0.1090   0.9446  -0.3097]
        Angle     47.4420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2499"
}

Galaxy "IC 2500:MCG 6-21-74:ZWG 181.83:ZWG 182.1"
{
        Type  "Sb"
        RA            9.7064
        Dec          36.3492
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.7083   0.6967  -0.1133]
        Angle     78.5617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2500"
}

Galaxy "IC 2502:MCG 6-22-2"
{
        Type  "S0"
        RA            9.7208
        Dec          35.1606
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.7851  -0.6009  -0.1498]
        Angle     92.9769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2502"
}

Galaxy "IC 2503:KUG 0940+354"
{
        Type  "S0"
        RA            9.7208
        Dec          35.2064
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.1562   0.9861  -0.0574]
        Angle     42.3179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2503"
}

Galaxy "IC 2505:MCG 5-23-34:ZWG 152.64:NPM 1"
{
        Type  "Sb"
        RA            9.7517
        Dec          27.2692
        Distance   4.618e+08  # method: V
        Radius     6.717e+04
        AbsMag        -20.15
        Axis    [ -0.1235   0.7188  -0.6841]
        Angle     80.5689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2505"
}

Galaxy "IC 2506:MCG 5-23-35:ZWG 152.65:NPM 1"
{
        Type  "Sb"
        RA            9.7533
        Dec          27.2525
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.0776   0.7745  -0.6278]
        Angle     56.7832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2506"
}

Galaxy "IC 2507:ESO 434-31:MCG 5-23-9:AM 0942-313"
{
        Type  "Irr"
        RA            9.7425
        Dec         -31.7906
        Distance   7.022e+07  # method: V
        Radius     1.736e+04
        AbsMag        -18.36
        Axis    [  0.8560   0.2687  -0.4416]
        Angle     98.5504
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2507"
}

Galaxy "IC 2508:ZWG 182.17:NPM 1"
{
        Type  "E0"
        RA            9.7853
        Dec          33.5086
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.7842  -0.5625  -0.2618]
        Angle     89.2989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2508"
}

Galaxy "IC 2510:ESO 373-29:MCG 5-23-17:AM 0945-323"
{
        Type  "SBb"
        RA            9.7953
        Dec         -32.8378
        Distance   1.218e+08  # method: T-F
        Radius     2.302e+04
        AbsMag        -19.56
        Axis    [ -0.2955   0.1228  -0.9474]
        Angle     76.7389
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2510"
}

Galaxy "IC 2511:IC 2512:MCG 5-23-18:ESO 374-49"
{
        Type  "SBb"
        RA            9.8233
        Dec         -32.8392
        Distance   1.079e+08  # method: T-F
        Radius     4.551e+04
        AbsMag         -19.6
        Axis    [  0.8535   0.4465  -0.2684]
        Angle     94.4091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2511"
}

Galaxy "IC 2513:IC 2514:MCG 5-23-19:ESO 374-50"
{
        Type  "Sb"
        RA            9.8333
        Dec         -32.8839
        Distance   9.715e+07  # distance uncertain!
        Radius     4.239e+04
        AbsMag        -19.07
        Axis    [  0.7812   0.4598  -0.4224]
        Angle     75.4317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2513"
}

Galaxy "IC 2515:UGC 5321:MCG 6-22-27:ZWG 182.33"
{
        Type  "Sb"
        RA            9.9108
        Dec          37.4083
        Distance   2.764e+08  # method: V
        Radius     4.423e+04
        AbsMag        -19.44
        Axis    [ -0.7965   0.6039  -0.0302]
        Angle     83.0734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2515"
}

Galaxy "IC 2516:MCG 6-22-28:ZWG 182.34:NPM 1"
{
        Type  "Sa"
        RA            9.9133
        Dec          37.6875
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.9600  -0.2564   0.1128]
        Angle     77.8799
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2516"
}

Galaxy "IC 2517:ESO 374-6"
{
        Type  "S0"
        RA            9.8806
        Dec         -33.7419
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.3230   0.0934  -0.9418]
        Angle     97.5682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2517"
}

Galaxy "IC 2518:ZWG 182.40:NPM 1"
{
        Type  "E0"
        RA            9.9328
        Dec          37.1561
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.5108   0.2579  -0.8201]
        Angle     69.6695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2518"
}

Galaxy "IC 2519:ZWG 182.39"
{
        Type  "E0"
        RA            9.9328
        Dec          34.0364
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.5015   0.2363  -0.8323]
        Angle     72.2473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2519"
}

Galaxy "IC 2520:UGC 5335:MCG 5-24-3:ZWG 153.4"
{
        Type  "Irr"
        RA            9.9389
        Dec          27.2275
        Distance   6.881e+07  # method: V
        Radius          7006
        AbsMag        -17.22
        Axis    [  0.5878   0.4776  -0.6530]
        Angle     51.0330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2520"
}

Galaxy "IC 2521:MCG 6-22-35:ZWG 182.45:NPM 1"
{
        Type  "SBc"
        RA            9.9542
        Dec          33.9769
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.7663  -0.6212  -0.1637]
        Angle     95.6004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2521"
}

Galaxy "IC 2522:ESO 374-10:MCG 5-24-4:UGCA 189"
{
        Type  "SBc"
        RA            9.9189
        Dec         -33.1369
        Distance    7.71e+07  # method: T-F
        Radius      3.14e+04
        AbsMag        -19.27
        Axis    [ -0.5100   0.0928  -0.8552]
        Angle     94.8725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2522"
}

Galaxy "IC 2523:ESO 374-11:MCG 5-24-5:AM 0952-325"
{
        Type  "SBc"
        RA            9.9192
        Dec         -33.2111
        Distance   1.206e+08  # method: T-F
        Radius     2.281e+04
        AbsMag        -19.24
        Axis    [  0.9071   0.1459  -0.3949]
        Angle    115.3901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2523"
}

Galaxy "IC 2524:MCG 6-22-39:MK 411:ZWG 182.47"
{
        Type  "Sa"
        RA            9.9589
        Dec          33.6203
        Distance   7.914e+07  # method: V
        Radius          6906
        AbsMag        -17.02
        Axis    [  0.9498   0.3125  -0.0179]
        Angle     47.8950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2524"
}

Galaxy "IC 2525:ZWG 182.52:NPM 1"
{
        Type  "E0"
        RA            9.9733
        Dec          37.1025
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [  0.7335  -0.6574  -0.1728]
        Angle     93.9629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2525"
}

Galaxy "IC 2526:ESO 435-12:MCG 5-24-8"
{
        Type  "S0"
        RA            9.9506
        Dec         -32.2569
        Distance   1.115e+08  # distance uncertain!
        Radius     3.407e+04
        AbsMag        -19.07
        Axis    [  0.8106   0.3291  -0.4845]
        Angle     84.3959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2526"
}

Galaxy "IC 2527:ZWG 182.55:NPM 1"
{
        Type  "Sc"
        RA           10.0017
        Dec          38.1728
        Distance    2.44e+08  # distance uncertain!
        Radius     1.065e+04
        AbsMag        -19.07
        Axis    [  0.7465  -0.6495  -0.1443]
        Angle     92.9414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2527"
}

Galaxy "IC 2530:MCG 6-22-53:ZWG 182.59:NPM 1"
{
        Type  "S0"
        RA           10.0253
        Dec          37.2044
        Distance   3.108e+08  # method: V
        Radius     2.712e+04
        AbsMag         -19.6
        Axis    [  0.7478  -0.6468  -0.1500]
        Angle     93.8209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2530"
}

Galaxy "IC 2531:ESO 435-25:MCG 5-24-15:UGCA 191"
{
        Type  "Sc"
        RA            9.9986
        Dec         -29.6178
        Distance   1.546e+08  # method: T-F
        Radius     1.552e+05
        AbsMag        -20.28
        Axis    [  0.7248   0.4537  -0.5185]
        Angle     61.3763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2531"
}

Galaxy "IC 2532:ESO 374-16:MCG 6-22-7:AM 0957-335"
{
        Type  "SBa"
        RA           10.0014
        Dec         -34.2283
        Distance    1.45e+08  # method: V
        Radius     2.952e+04
        AbsMag        -19.34
        Axis    [  0.8404   0.0831  -0.5356]
        Angle    111.3787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2532"
}

Galaxy "IC 2533:ESO 435-27:MCG 5-24-17"
{
        Type  "S0"
        RA           10.0086
        Dec         -31.2450
        Distance   8.081e+07  # distance uncertain!
        Radius     2.115e+04
        AbsMag        -19.07
        Axis    [  0.9633   0.0377  -0.2659]
        Angle    133.0041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2533"
}

Galaxy "IC 2534:ESO 374-19:MCG 6-22-11:AM 0959-335"
{
        Type  "Sa"
        RA           10.0247
        Dec         -34.1125
        Distance   1.017e+08  # distance uncertain!
        Radius      1.48e+04
        AbsMag        -19.07
        Axis    [  0.4892   0.1588  -0.8576]
        Angle     81.0459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2534"
}

Galaxy "IC 2535:MCG 6-22-65:ZWG 182.70:NPM 1"
{
        Type  "Sb"
        RA           10.0753
        Dec          38.0067
        Distance   3.267e+08  # method: V
        Radius     3.801e+04
        AbsMag         -20.4
        Axis    [  0.6364   0.7035  -0.3165]
        Angle     38.5953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2535"
}

Galaxy "IC 2536:ESO 374-26:IRAS 10012-3342"
{
        Type  "SBc"
        RA           10.0583
        Dec         -33.9503
        Distance   1.289e+08  # method: T-F
        Radius     3.562e+04
        AbsMag        -18.38
        Axis    [  0.8438   0.4119  -0.3441]
        Angle     87.4886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2536"
}

Galaxy "IC 2537:ESO 499-39:MCG 4-24-15:UGCA 197"
{
        Type  "SBc"
        RA           10.0642
        Dec         -27.5714
        Distance   1.408e+08  # method: T-F
        Radius     5.121e+04
        AbsMag        -20.38
        Axis    [  0.9115   0.0751  -0.4043]
        Angle    112.0470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2537"
}

Galaxy "IC 2538:ESO 374-27:MCG 6-22-15:IRAS 10017-3434"
{
        Type  "SBc"
        RA           10.0656
        Dec         -34.8072
        Distance   3.937e+08  # method: T-F
        Radius     8.589e+04
        AbsMag        -20.81
        Axis    [  0.9558   0.1718  -0.2385]
        Angle    131.3778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2538"
}

Galaxy "IC 2539:ESO 435-34:MCG 5-24-20:AM 1002-310"
{
        Type  "Sc"
        RA           10.0711
        Dec         -31.3625
        Distance   1.331e+08  # method: T-F
        Radius     3.679e+04
        AbsMag        -19.05
        Axis    [  0.9046   0.3460  -0.2489]
        Angle    104.8136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2539"
}

Galaxy "IC 2540:MCG 5-24-14:ZWG 153.18:NPM 1"
{
        Type  "S0"
        RA           10.1128
        Dec          31.4761
        Distance   3.083e+08  # method: V
        Radius     4.484e+04
        AbsMag        -19.78
        Axis    [  0.9307  -0.3496   0.1078]
        Angle     97.1891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2540"
}

Galaxy "IC 2541:MCG 3-26-17"
{
        Type  "Sc"
        RA           10.0967
        Dec         -17.4350
        Distance   2.411e+08  # method: V
        Radius     4.559e+04
        AbsMag        -19.94
        Axis    [  0.9765   0.1953  -0.0914]
        Angle    116.7970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2541"
}

Galaxy "IC 2542:MCG 6-22-76:ZWG 182.76:KARA 399"
{
        Type  "SBc"
        RA           10.1306
        Dec          34.3153
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.3855   0.7677  -0.5119]
        Angle    100.4966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2542"
}

Galaxy "IC 2543-1:ZWG 182.77"
{
        Type  "S0"
        RA           10.1397
        Dec          37.8408
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [ -0.3647   0.9309   0.0191]
        Angle     49.1870
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2543-1"
}

Galaxy "IC 2543-2:ZWG 182.77"
{
        Type  "E0"
        RA           10.1397
        Dec          37.8442
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.7134  -0.6789  -0.1738]
        Angle     94.7843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2543-2"
}

Galaxy "IC 2544:ZWG 182.78:KUG 1005+335"
{
        Type  "SBc"
        RA           10.1414
        Dec          33.3461
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.7501  -0.6382  -0.1732]
        Angle     97.4919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2544"
}

Galaxy "IC 2546:ESO 374-36"
{
        Type  "S0"
        RA           10.1181
        Dec         -33.2619
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.3626   0.0922  -0.9274]
        Angle     88.5561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2546"
}

Galaxy "IC 2547:ZWG 182.80:ZWG 183.1"
{
        Type  "S0"
        RA           10.1678
        Dec          36.5031
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [ -0.2294   0.9665  -0.1150]
        Angle     45.4343
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2547"
}

Galaxy "IC 2548:ESO 374-37:MCG 6-23-1:AM 1005-345"
{
        Type  "SBb"
        RA           10.1317
        Dec         -35.2297
        Distance   2.261e+08  # method: V
        Radius     6.248e+04
        AbsMag         -20.3
        Axis    [  0.6080  -0.0233  -0.7936]
        Angle    111.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2548"
}

Galaxy "IC 2549:ZWG 183.2:ZWG 182.81:NPM 1"
{
        Type  "S0"
        RA           10.1694
        Dec          36.4653
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.6430   0.7439  -0.1824]
        Angle     36.1256
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2549"
}

Galaxy "IC 2550:UGC 5484:MCG 5-24-23:ZWG 153.27"
{
        Type  "SBb"
        RA           10.1742
        Dec          27.9558
        Distance   2.299e+08  # method: V
        Radius     3.343e+04
        AbsMag        -19.74
        Axis    [ -0.1511   0.7615  -0.6303]
        Angle     61.5299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2550"
}

Galaxy "IC 2551:UGC 5488:MCG 4-24-16:MK 717"
{
        Type  "S0"
        RA           10.1778
        Dec          24.4147
        Distance   3.011e+08  # method: V
        Radius      4.38e+04
        AbsMag        -20.63
        Axis    [  0.9800  -0.1536  -0.1264]
        Angle     74.0625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2551"
}

Galaxy "IC 2552:ESO 374-40:MCG 6-23-7"
{
        Type  "S0"
        RA           10.1794
        Dec         -34.8444
        Distance   1.543e+08  # method: V
        Radius     3.591e+04
        AbsMag        -20.17
        Axis    [  0.3112   0.0069  -0.9503]
        Angle    109.9629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2552"
}

Galaxy "IC 2554A:ESO 92-12:IRAS 10075-6647"
{
        Type  "SBc"
        RA           10.1472
        Dec         -67.0317
        Distance   6.881e+07  # method: V
        Radius     3.002e+04
        AbsMag        -19.12
        Axis    [ -0.4718  -0.3656  -0.8023]
        Angle     94.1764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2554A"
}

Galaxy "IC 2554B:ESO 92-12A"
{
        Type  "SBc"
        RA           10.1475
        Dec         -67.0214
        Distance   1.341e+08  # distance uncertain!
        Radius     3.901e+04
        AbsMag        -19.07
        Axis    [ -0.4278  -0.3063  -0.8504]
        Angle     98.6193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2554B"
}

Galaxy "IC 2556:ESO 374-42:MCG 6-23-12:AM 1010-342"
{
        Type  "SBc"
        RA           10.2103
        Dec         -34.7283
        Distance   1.527e+08  # method: T-F
        Radius     4.442e+04
        AbsMag        -19.05
        Axis    [  0.2367   0.1381  -0.9617]
        Angle     68.4313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2556"
}

Galaxy "IC 2557:MCG 6-23-3:ZWG 183.7:ARAK 235"
{
        Type  "S0"
        RA           10.2681
        Dec          38.1083
        Distance   3.527e+08  # distance uncertain!
        Radius     1.539e+04
        AbsMag        -19.07
        Axis    [  0.5912   0.7902  -0.1613]
        Angle     34.6721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2557"
}

Galaxy "IC 2558:ESO 375-1:MCG 6-23-18:IRAS 10125-3405"
{
        Type  "Irr"
        RA           10.2456
        Dec         -34.3369
        Distance   1.304e+08  # method: V
        Radius     2.275e+04
        AbsMag        -18.51
        Axis    [  0.9321   0.1247  -0.3402]
        Angle    122.4368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2558"
}

Galaxy "IC 2559:ESO 375-2:MCG 6-23-19:IRAS 10125-3348"
{
        Type  "SBb"
        RA           10.2458
        Dec         -34.0586
        Distance   1.567e+08  # method: T-F
        Radius     3.876e+04
        AbsMag        -19.01
        Axis    [  0.9222   0.2300  -0.3109]
        Angle    114.3551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2559"
}

Galaxy "IC 2560:ESO 375-4:MCG 5-25-1:IRAS 10140-3318"
{
        Type  "SBb"
        RA           10.2717
        Dec         -33.5633
        Distance   1.365e+08  # method: T-F
        Radius     6.154e+04
        AbsMag        -20.61
        Axis    [  0.8104   0.0942  -0.5783]
        Angle    102.3338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2560"
}

Galaxy "IC 2561:UGC 5567:MCG 6-23-7:ZWG 183.13"
{
        Type  "Sb"
        RA           10.3189
        Dec          34.6744
        Distance   2.169e+08  # method: V
        Radius     2.839e+04
        AbsMag        -19.21
        Axis    [  0.9530  -0.1596   0.2576]
        Angle     87.9866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2561"
}

Galaxy "IC 2562:MCG 3-26-53:ZWG 93.89"
{
        Type  "Sc"
        RA           10.3150
        Dec          16.1550
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.6548   0.5807  -0.4837]
        Angle     76.4853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2562"
}

Galaxy "IC 2563:ESO 436-9"
{
        Type  "SBc"
        RA           10.3142
        Dec         -32.5967
        Distance    7.52e+07  # method: V
        Radius     1.203e+04
        AbsMag        -16.21
        Axis    [  0.2671   0.1542  -0.9513]
        Angle     63.0472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2563"
}

Galaxy "IC 2564:NPM 1"
{
        Type  "E0"
        RA           10.3575
        Dec          36.4525
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [  0.6963  -0.6931  -0.1864]
        Angle     97.5874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2564"
}

Galaxy "IC 2565:ZWG 154.4:ZW 24"
{
        Type  "S0"
        RA           10.3547
        Dec          27.9300
        Distance   6.935e+08  # method: V
        Radius     4.035e+04
        AbsMag        -21.44
        Axis    [  0.8305   0.5567   0.0189]
        Angle     37.7144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2565"
}

Galaxy "IC 2565A:ZWG 154.4:ZW 24"
{
        Type  "E0"
        RA           10.3547
        Dec          27.9289
        Distance   1.259e+09  # distance uncertain!
        Radius     3.662e+04
        AbsMag        -20.13
        Axis    [  0.7271  -0.6479  -0.2271]
        Angle    103.6359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2565A"
}

Galaxy "IC 2566:MCG 6-23-8:ZWG 183.18:NPM 1"
{
        Type  "S0"
        RA           10.3719
        Dec          36.5833
        Distance   3.651e+08  # method: V
        Radius     4.248e+04
        AbsMag        -20.24
        Axis    [  0.9315  -0.2736   0.2396]
        Angle     96.5108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2566"
}

Galaxy "IC 2567:MCG 4-25-10:ZWG 124.13"
{
        Type  "S0"
        RA           10.3658
        Dec          24.6553
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [  0.9432  -0.3283   0.0512]
        Angle    101.8814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2567"
}

Galaxy "IC 2568:UGC 5603:MCG 6-23-9:ZWG 183.19"
{
        Type  "SBa"
        RA           10.3750
        Dec          36.5997
        Distance   3.764e+08  # method: V
        Radius      6.57e+04
        AbsMag        -20.31
        Axis    [  0.4115   0.9029   0.1244]
        Angle     33.0615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2568"
}

Galaxy "IC 2569:NPM 1"
{
        Type  "E0"
        RA           10.3814
        Dec          24.6069
        Distance   4.169e+08  # distance uncertain!
        Radius     1.819e+04
        AbsMag        -20.13
        Axis    [  0.7348  -0.6333  -0.2428]
        Angle    106.2620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2569"
}

Galaxy "IC 2570:ESO 375-11"
{
        Type  "SBc"
        RA           10.3594
        Dec         -33.6233
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [ -0.5268   0.0382  -0.8491]
        Angle     86.0637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2570"
}

Galaxy "IC 2572:UGC 5636:MCG 5-25-8:ZWG 154.11"
{
        Type  "Sa"
        RA           10.4186
        Dec          28.0942
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.9841  -0.0785   0.1590]
        Angle     78.2645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2572"
}

Galaxy "IC 2573:ESO 375-17"
{
        Type  "SBc"
        RA           10.3917
        Dec         -35.4564
        Distance   2.023e+08  # method: V
        Radius     4.413e+04
        AbsMag        -18.56
        Axis    [  0.9300   0.3099  -0.1978]
        Angle    125.0007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2573"
}

Galaxy "IC 2574:UGC 5666:MCG 12-10-38:DDO 81"
{
        Type  "Irr"
        RA           10.4728
        Dec          68.4167
        Distance   1.536e+07  # method: T-F
        Radius     2.948e+04
        AbsMag        -17.56
        Axis    [  0.6531  -0.0406   0.7562]
        Angle     73.3238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2574"
}

Galaxy "IC 2575:ESO 436-17"
{
        Type  "S0"
        RA           10.4233
        Dec         -32.6361
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.0338   0.0731  -0.9967]
        Angle     80.6864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2575"
}

Galaxy "IC 2576:ESO 375-23:MCG 5-25-3:AM 1023-323"
{
        Type  "Sc"
        RA           10.4328
        Dec         -32.9036
        Distance   4.375e+08  # method: V
        Radius     5.091e+04
        AbsMag        -20.84
        Axis    [  0.7202  -0.0702  -0.6902]
        Angle    113.3575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2576"
}

Galaxy "IC 2577:MCG 6-23-18:ZWG 183.26:KARA 418"
{
        Type  "Sb"
        RA           10.4669
        Dec          32.7633
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [  0.4184   0.8282  -0.3729]
        Angle     33.6986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2577"
}

Galaxy "IC 2578:ESO 375-29:IRAS 10250-3337"
{
        Type  "Sc"
        RA           10.4561
        Dec         -33.8783
        Distance   1.387e+08  # method: T-F
        Radius     3.026e+04
        AbsMag        -18.14
        Axis    [ -0.4355  -0.0517  -0.8987]
        Angle     44.9335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2578"
}

Galaxy "IC 2580:ESO 436-25:MCG 5-25-4:IRAS 10260-3115"
{
        Type  "SBc"
        RA           10.4714
        Dec         -31.5178
        Distance   1.563e+08  # method: V
        Radius     4.319e+04
        AbsMag         -20.2
        Axis    [ -0.3345   0.1254  -0.9340]
        Angle    103.2410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2580"
}

Galaxy "IC 2582:ESO 436-28:MCG 5-25-6:IRAS 10268-3005"
{
        Type  "SBc"
        RA           10.4864
        Dec         -30.3428
        Distance   2.053e+08  # method: V
        Radius      4.18e+04
        AbsMag        -20.29
        Axis    [  0.8452  -0.1728  -0.5057]
        Angle    129.5476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2582"
}

Galaxy "IC 2583:MCG 4-25-27:ZWG 124.32:ARAK 247"
{
        Type  "E0"
        RA           10.5194
        Dec          26.0547
        Distance   4.787e+08  # distance uncertain!
        Radius      5.57e+04
        AbsMag        -20.13
        Axis    [  0.2691   0.3018  -0.9146]
        Angle     78.7822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2583"
}

Galaxy "IC 2584:ESO 375-43:MCG 6-23-37"
{
        Type  "S0"
        RA           10.4975
        Dec         -34.9117
        Distance   1.294e+08  # method: V
        Radius     2.824e+04
        AbsMag        -19.39
        Axis    [ -0.2789  -0.0144  -0.9602]
        Angle     42.5284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2584"
}

Galaxy "IC 2586:ESO 436-30:MCG 5-25-8"
{
        Type  "E4"
        RA           10.5172
        Dec         -28.7169
        Distance   1.807e+08  # method: V
        Radius     2.365e+04
        AbsMag        -20.12
        Axis    [  0.3845  -0.1325  -0.9136]
        Angle    126.9418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2586"
}

Galaxy "IC 2587:ESO 375-51:MCG 6-23-47:IRAS 10287-3418"
{
        Type  "S0"
        RA           10.5164
        Dec         -34.5628
        Distance   1.097e+08  # method: V
        Radius      3.19e+04
        AbsMag        -19.33
        Axis    [  0.8622  -0.0089  -0.5065]
        Angle    118.5994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2587"
}

Galaxy "IC 2588:ESO 436-33:MCG 5-25-9:AM 1029-300"
{
        Type  "SBa"
        RA           10.5306
        Dec         -30.3839
        Distance   1.743e+08  # method: V
        Radius     3.549e+04
        AbsMag        -20.04
        Axis    [ -0.2190   0.1013  -0.9705]
        Angle     94.5078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2588"
}

Galaxy "IC 2589:ESO 501-4:IRAS 10299-2346"
{
        Type  "Sc"
        RA           10.5389
        Dec         -24.0372
        Distance   1.828e+08  # method: V
        Radius     2.393e+04
        AbsMag        -19.44
        Axis    [  0.9464  -0.0018  -0.3231]
        Angle    117.9080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2589"
}

Galaxy "IC 2590:UGC 5756:MCG 5-25-24:ZWG 154.30"
{
        Type  "S0"
        RA           10.6044
        Dec          26.9628
        Distance   3.017e+08  # method: V
        Radius     4.827e+04
        AbsMag        -19.93
        Axis    [  0.7260  -0.6511  -0.2213]
        Angle    105.5472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2590"
}

Galaxy "IC 2591:UGC 5763:MCG 6-23-22:ZWG 183.31"
{
        Type  "SBc"
        RA           10.6106
        Dec          35.0533
        Distance     3.2e+08  # method: V
        Radius     5.584e+04
        AbsMag        -20.26
        Axis    [ -0.2427   0.9394  -0.2422]
        Angle     41.7707
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2591"
}

Galaxy "IC 2593:NPM 1"
{
        Type  "S0"
        RA           10.6042
        Dec         -12.7253
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.4640   0.1076  -0.8793]
        Angle     68.3304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2593"
}

Galaxy "IC 2594:ESO 501-28:MCG 4-25-28"
{
        Type  "S0"
        RA           10.6011
        Dec         -24.3228
        Distance   1.774e+08  # method: V
        Radius     3.612e+04
        AbsMag        -20.28
        Axis    [  0.8185  -0.3964  -0.4159]
        Angle    144.1981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2594"
}

Galaxy "IC 2596:ESO 38-2:FAIR 283:IRAS 10329-7258"
{
        Type  "SBb"
        RA           10.5700
        Dec         -73.2400
        Distance   1.598e+08  # method: V
        Radius     2.789e+04
        AbsMag        -18.85
        Axis    [ -0.5137  -0.3241  -0.7944]
        Angle    114.1678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2596"
}

Galaxy "IC 2597:ESO 501-58:MCG 4-25-51:HCG 48A"
{
        Type  "E0"
        RA           10.6297
        Dec         -27.0808
        Distance   1.512e+08  # method: V
        Radius     3.299e+04
        AbsMag        -20.33
        Axis    [  0.7930  -0.3970  -0.4621]
        Angle    146.1599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2597"
}

Galaxy "IC 2598:ZWG 154.37"
{
        Type  "Sa"
        RA           10.6617
        Dec          26.7275
        Distance   2.776e+08  # method: V
        Radius     1.615e+04
        AbsMag        -19.55
        Axis    [ -0.5364   0.7879  -0.3024]
        Angle     49.6773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2598"
}

Galaxy "IC 2600:MCG 12-10-75:ZWG 333.52"
{
        Type  "S0"
        RA           10.7772
        Dec          72.3206
        Distance   3.217e+08  # distance uncertain!
        Radius     2.807e+04
        AbsMag        -19.07
        Axis    [ -0.0800   0.9272   0.3659]
        Angle     55.4662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2600"
}

Galaxy "IC 2601:MCG 12-10-78:ZWG 333.53:NPM 1"
{
        Type  "E0"
        RA           10.7869
        Dec          72.3236
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [  0.4364  -0.8986   0.0452]
        Angle     81.3468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2601"
}

Galaxy "IC 2604:UGC 5927:MCG 6-24-16:ZWG 184.17"
{
        Type  "Irr"
        RA           10.8236
        Dec          32.7725
        Distance   8.874e+07  # method: V
        Radius     1.549e+04
        AbsMag        -17.37
        Axis    [  0.9707  -0.2386  -0.0287]
        Angle     65.1253
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2604"
}

Galaxy "IC 2606:MCG 6-24-21:ZWG 184.25"
{
        Type  "Sa"
        RA           10.8381
        Dec          37.9564
        Distance   3.616e+08  # method: V
        Radius     4.208e+04
        AbsMag        -20.32
        Axis    [ -0.2097   0.9302   0.3012]
        Angle     35.5633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2606"
}

Galaxy "IC 2607:MCG 6-24-23:ZWG 184.26"
{
        Type  "SBb"
        RA           10.8383
        Dec          37.9942
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.9658   0.1228   0.2286]
        Angle     44.1428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2607"
}

Galaxy "IC 2608:ZWG 184.22:KUG 1047+330"
{
        Type  "S0"
        RA           10.8375
        Dec          32.7689
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.2393   0.9319   0.2724]
        Angle     32.9731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2608"
}

Galaxy "IC 2612:MCG 6-24-33:NPM 1"
{
        Type  "S0"
        RA           10.8936
        Dec          32.7683
        Distance   4.441e+08  # distance uncertain!
        Radius     2.583e+04
        AbsMag        -19.07
        Axis    [  0.6683   0.5380  -0.5137]
        Angle     31.3241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2612"
}

Galaxy "IC 2614"
{
        Type  "E0"
        RA           11.0258
        Dec          38.8039
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6173  -0.7638  -0.1887]
        Angle    102.0027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2614"
}

Galaxy "IC 2615:ZWG 184.44:NPM 1"
{
        Type  "Sa"
        RA           11.0339
        Dec          37.9456
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [  0.6423  -0.7465  -0.1735]
        Angle    102.0579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2615"
}

Galaxy "IC 2616:MCG 7-23-12:ZWG 213.18"
{
        Type  "S0"
        RA           11.0347
        Dec          38.7872
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.9189   0.3940  -0.0187]
        Angle     29.4929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2616"
}

Galaxy "IC 2617:MCG 7-23-11:ZWG 213.19"
{
        Type  "S0"
        RA           11.0353
        Dec          38.6644
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.7844   0.6133  -0.0928]
        Angle     26.4900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2617"
}

Galaxy "IC 2619:ZWG 184.45"
{
        Type  "E0"
        RA           11.0375
        Dec          37.9664
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.6197  -0.7605  -0.1938]
        Angle    102.6297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2619"
}

Galaxy "IC 2620:MCG 7-23-14:ZWG 213.20:NPM 1"
{
        Type  "S0"
        RA           11.0397
        Dec          38.5056
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.1635   0.7873  -0.5945]
        Angle     58.5576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2620"
}

Galaxy "IC 2623:ESO 569-33:MCG 3-28-34:NPM 1"
{
        Type  "E0"
        RA           11.0639
        Dec         -20.0931
        Distance   2.021e+08  # method: T-F
        Radius     2.352e+04
        AbsMag        -19.56
        Axis    [  0.4086  -0.2192  -0.8860]
        Angle    118.4755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2623"
}

Galaxy "IC 2626:ZWG 155.75"
{
        Type  "S0"
        RA           11.1508
        Dec          26.9044
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.9291   0.0641   0.3643]
        Angle     68.7761
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2626"
}

Galaxy "IC 2627:ESO 502-21:MCG 4-27-2:UGCA 227"
{
        Type  "SBc"
        RA           11.1647
        Dec         -23.7267
        Distance   1.098e+08  # method: V
        Radius     4.151e+04
        AbsMag        -20.03
        Axis    [  0.5972  -0.1089  -0.7947]
        Angle     89.0673
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2627"
}

Galaxy "IC 2628:ZWG 67.30:NPM 1"
{
        Type  "E0"
        RA           11.1936
        Dec          12.1225
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [ -0.2809   0.5437  -0.7909]
        Angle    105.1787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2628"
}

Galaxy "IC 2629"
{
        Type  "S0"
        RA           11.2100
        Dec          12.1044
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9997  -0.0251   0.0019]
        Angle     71.9709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2629"
}

Galaxy "IC 2632:NPM 1"
{
        Type  "E0"
        RA           11.2181
        Dec          11.6739
        Distance   1.202e+09  # distance uncertain!
        Radius     5.246e+04
        AbsMag        -20.13
        Axis    [  0.6901  -0.6423  -0.3336]
        Angle    121.4017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2632"
}

Galaxy "IC 2633"
{
        Type  "S0"
        RA           11.2194
        Dec          11.6014
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.9867  -0.1623  -0.0006]
        Angle    101.0026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2633"
}

Galaxy "IC 2634:MCG 2-29-10:ZWG 67.35"
{
        Type  "Sb"
        RA           11.2244
        Dec          10.4858
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.0963   0.3734  -0.9227]
        Angle     39.3191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2634"
}

Galaxy "IC 2636:NPM 1"
{
        Type  "S0"
        RA           11.2261
        Dec          11.4564
        Distance    6.13e+08  # distance uncertain!
        Radius     3.566e+04
        AbsMag        -19.07
        Axis    [  0.9140   0.1550  -0.3750]
        Angle     37.3555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2636"
}

Galaxy "IC 2637:UGC 6259:MCG 2-29-11:MK 732"
{
        Type  "E0"
        RA           11.2303
        Dec           9.5867
        Distance   4.129e+08  # method: V
        Radius     4.805e+04
        AbsMag        -21.61
        Axis    [  0.6941  -0.6327  -0.3433]
        Angle    122.9289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2637"
}

Galaxy "IC 2638:UGC 6261:MCG 2-29-12:ZWG 67.37"
{
        Type  "SBa"
        RA           11.2308
        Dec          10.5633
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.6378   0.3972  -0.6599]
        Angle     26.6691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2638"
}

Galaxy "IC 2639:NPM 1"
{
        Type  "E0"
        RA           11.2319
        Dec           9.6433
        Distance   9.121e+08  # distance uncertain!
        Radius     5.306e+04
        AbsMag        -20.13
        Axis    [  0.6938  -0.6331  -0.3432]
        Angle    122.9006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2639"
}

Galaxy "IC 2640"
{
        Type  "E0"
        RA           11.2347
        Dec          10.9972
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.0675   0.2040  -0.9766]
        Angle     86.6694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2640"
}

Galaxy "IC 2644"
{
        Type  "S0"
        RA           11.2414
        Dec          10.7689
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8044   0.2706  -0.5288]
        Angle     30.6374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2644"
}

Galaxy "IC 2645:ZWG 67.39"
{
        Type  "S0"
        RA           11.2417
        Dec          11.8867
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.8745   0.4637  -0.1421]
        Angle     24.5820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2645"
}

Galaxy "IC 2646"
{
        Type  "E0"
        RA           11.2436
        Dec          12.5286
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.6854  -0.6487  -0.3308]
        Angle    120.9903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2646"
}

Galaxy "IC 2648:ZWG 67.41:NPM 1"
{
        Type  "Sb"
        RA           11.2458
        Dec          10.2253
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.7109  -0.6219  -0.3283]
        Angle    121.5863
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2648"
}

Galaxy "IC 2649-1:MCG 2-29-15:ZWG 67.42:NPM 1"
{
        Type  "S0"
        RA           11.2461
        Dec          11.1281
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.7088  -0.6266  -0.3241]
        Angle    120.9777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2649-1"
}

Galaxy "IC 2649-2:MCG 2-29-15:ZWG 67.42"
{
        Type  "E0"
        RA           11.2464
        Dec          11.1289
        Distance   3.312e+08  # distance uncertain!
        Radius     1.445e+04
        AbsMag        -20.13
        Axis    [  0.6887  -0.6418  -0.3372]
        Angle    121.9711
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2649-2"
}

Galaxy "IC 2650"
{
        Type  "Irr"
        RA           11.2478
        Dec          13.8528
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.7018  -0.6408  -0.3112]
        Angle    119.1603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2650"
}

Galaxy "IC 2651"
{
        Type  "S0"
        RA           11.2478
        Dec          12.2397
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8215   0.2851  -0.4939]
        Angle     29.8411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2651"
}

Galaxy "IC 2652:NPM 1"
{
        Type  "E0"
        RA           11.2478
        Dec          12.4486
        Distance   9.121e+08  # distance uncertain!
        Radius     6.633e+04
        AbsMag        -20.13
        Axis    [  0.6852  -0.6487  -0.3313]
        Angle    121.0741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2652"
}

Galaxy "IC 2654"
{
        Type  "S0"
        RA           11.2506
        Dec          12.5000
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.6053   0.0998  -0.7897]
        Angle     42.7820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2654"
}

Galaxy "IC 2655"
{
        Type  "E0"
        RA           11.2514
        Dec          12.1644
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6856  -0.6475  -0.3327]
        Angle    121.2939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2655"
}

Galaxy "IC 2656"
{
        Type  "S0"
        RA           11.2514
        Dec          12.3789
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.2513   0.7936  -0.5541]
        Angle     20.8856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2656"
}

Galaxy "IC 2657"
{
        Type  "E0"
        RA           11.2522
        Dec          13.6947
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.6815  -0.6553  -0.3258]
        Angle    120.2537
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2657"
}

Galaxy "IC 2660"
{
        Type  "E0"
        RA           11.2578
        Dec          12.4367
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [ -0.2363   0.5031  -0.8313]
        Angle    100.0652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2660"
}

Galaxy "IC 2661:ZWG 67.43"
{
        Type  "S0"
        RA           11.2581
        Dec          13.6089
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.6949   0.7176   0.0470]
        Angle     18.8564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2661"
}

Galaxy "IC 2665"
{
        Type  "S0"
        RA           11.2611
        Dec          11.7239
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.6905   0.7130   0.1218]
        Angle     18.6807
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2665"
}

Galaxy "IC 2666:MCG 2-29-16:ZWG 67.44"
{
        Type  "S0"
        RA           11.2619
        Dec          13.7822
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [  0.9288  -0.3613  -0.0828]
        Angle    110.7100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2666"
}

Galaxy "IC 2667"
{
        Type  "E0"
        RA           11.2622
        Dec          12.1169
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.6847  -0.6481  -0.3334]
        Angle    121.4015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2667"
}

Galaxy "IC 2668:MCG 2-29-15:IRAS 11130-1353"
{
        Type  "Sa"
        RA           11.2589
        Dec         -14.1714
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.4292   0.1369  -0.8928]
        Angle     57.0940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2668"
}

Galaxy "IC 2670"
{
        Type  "S0"
        RA           11.2664
        Dec          11.7831
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.3820   0.4960  -0.7798]
        Angle     51.9173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2670"
}

Galaxy "IC 2673:UGC 6288:MCG 2-29-17:ZWG 67.45"
{
        Type  "Sc"
        RA           11.2678
        Dec          10.1622
        Distance   2.827e+08  # method: V
        Radius     4.112e+04
        AbsMag        -19.59
        Axis    [  0.8943  -0.2972  -0.3346]
        Angle     82.9357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2673"
}

Galaxy "IC 2674:UGC 6290:ZWG 67.46:KARA 474"
{
        Type  "Sc"
        RA           11.2689
        Dec          11.0483
        Distance    3.36e+08  # method: T-F
        Radius     5.375e+04
        AbsMag        -19.96
        Axis    [  0.9824  -0.1756  -0.0630]
        Angle     91.8026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2674"
}

Galaxy "IC 2676"
{
        Type  "S0"
        RA           11.2717
        Dec           9.8217
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.8193   0.4210  -0.3893]
        Angle     64.7696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2676"
}

Galaxy "IC 2678"
{
        Type  "S0"
        RA           11.2725
        Dec          11.9486
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.0202   0.8022  -0.5967]
        Angle     18.7694
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2678"
}

Galaxy "IC 2679"
{
        Type  "E0"
        RA           11.2731
        Dec          12.0153
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.6839  -0.6485  -0.3343]
        Angle    121.5461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2679"
}

Galaxy "IC 2680:ZWG 67.47"
{
        Type  "Sa"
        RA           11.2736
        Dec           9.8067
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.6449   0.5794  -0.4984]
        Angle     30.8970
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2680"
}

Galaxy "IC 2683"
{
        Type  "S0"
        RA           11.2817
        Dec          12.0992
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.6760   0.1407  -0.7233]
        Angle     37.5317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2683"
}

Galaxy "IC 2684:ZWG 67.49"
{
        Type  "E0"
        RA           11.2836
        Dec          13.0997
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.6800  -0.6549  -0.3298]
        Angle    120.8803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2684"
}

Galaxy "IC 2689"
{
        Type  "S0"
        RA           11.2886
        Dec          12.9608
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9665   0.1231   0.2253]
        Angle     69.0363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2689"
}

Galaxy "IC 2690"
{
        Type  "S0"
        RA           11.2886
        Dec          12.9606
        Distance   3.694e+08  # distance uncertain!
        Radius     3.223e+04
        AbsMag        -19.07
        Axis    [  0.9976  -0.0021   0.0693]
        Angle     72.0332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2690"
}

Galaxy "IC 2692:NPM 1"
{
        Type  "E0"
        RA           11.2925
        Dec          10.7686
        Distance       1e+09  # distance uncertain!
        Radius     4.364e+04
        AbsMag        -20.13
        Axis    [  0.3170  -0.0879  -0.9443]
        Angle     84.6956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2692"
}

Galaxy "IC 2694-1:ZWG 67.50"
{
        Type  "S0"
        RA           11.2939
        Dec          13.3761
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.8403   0.2783  -0.4652]
        Angle     28.9851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2694-1"
}

Galaxy "IC 2694-2:ZWG 67.50"
{
        Type  "E0"
        RA           11.2942
        Dec          13.3758
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.6782  -0.6571  -0.3290]
        Angle    120.7674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2694-2"
}

Galaxy "IC 2695"
{
        Type  "E0"
        RA           11.2967
        Dec          13.7275
        Distance    6.31e+08  # distance uncertain!
        Radius     3.671e+04
        AbsMag        -20.13
        Axis    [  0.5903  -0.4608  -0.6628]
        Angle     94.7569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2695"
}

Galaxy "IC 2698:ZWG 67.51"
{
        Type  "Irr"
        RA           11.2975
        Dec          11.8853
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [  0.9113  -0.3914  -0.1275]
        Angle    112.1531
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2698"
}

Galaxy "IC 2700"
{
        Type  "E0"
        RA           11.2983
        Dec          12.0547
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.0649   0.2033  -0.9770]
        Angle     85.2608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2700"
}

Galaxy "IC 2701"
{
        Type  "S0"
        RA           11.2989
        Dec          11.1178
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.7381   0.0705  -0.6710]
        Angle     40.6339
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2701"
}

Galaxy "IC 2702:NPM 1"
{
        Type  "E0"
        RA           11.2992
        Dec           9.4131
        Distance   1.097e+09  # distance uncertain!
        Radius      3.19e+04
        AbsMag        -20.13
        Axis    [  0.6879  -0.6374  -0.3471]
        Angle    123.5090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2702"
}

Galaxy "IC 2703:MCG 3-29-26:ZWG 96.25:NPM 1"
{
        Type  "E0"
        RA           11.3014
        Dec          17.6500
        Distance   4.571e+08  # distance uncertain!
        Radius     3.989e+04
        AbsMag        -20.13
        Axis    [  0.6655  -0.6794  -0.3090]
        Angle    117.9479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2703"
}

Galaxy "IC 2704:ZWG 67.52:KARA 475"
{
        Type  "S0"
        RA           11.3008
        Dec          12.4536
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.9512   0.0807  -0.2979]
        Angle     40.6414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2704"
}

Galaxy "IC 2707"
{
        Type  "E0"
        RA           11.3083
        Dec           9.4742
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [ -0.3155   0.5286  -0.7881]
        Angle    106.0382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2707"
}

Galaxy "IC 2708:ZWG 67.53:NPM 1"
{
        Type  "E0"
        RA           11.3094
        Dec          12.7117
        Distance   3.312e+08  # distance uncertain!
        Radius     2.408e+04
        AbsMag        -20.13
        Axis    [  0.6785  -0.6550  -0.3326]
        Angle    121.3257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2708"
}

Galaxy "IC 2712:NPM 1"
{
        Type  "E0"
        RA           11.3144
        Dec           9.6272
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.6859  -0.6397  -0.3468]
        Angle    123.4645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2712"
}

Galaxy "IC 2713:NPM 1"
{
        Type  "E0"
        RA           11.3194
        Dec          12.1653
        Distance   8.318e+08  # distance uncertain!
        Radius      3.63e+04
        AbsMag        -20.13
        Axis    [  0.6790  -0.6530  -0.3356]
        Angle    121.7666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2713"
}

Galaxy "IC 2716"
{
        Type  "S0"
        RA           11.3211
        Dec          11.6986
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9509   0.2978  -0.0845]
        Angle     29.8230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2716"
}

Galaxy "IC 2718:ZWG 67.55"
{
        Type  "S0"
        RA           11.3222
        Dec          12.0225
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.8253   0.4340  -0.3613]
        Angle     23.0463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2718"
}

Galaxy "IC 2720:ZWG 67.56:NPM 1"
{
        Type  "E0"
        RA           11.3264
        Dec          12.0769
        Distance   3.981e+08  # distance uncertain!
        Radius     4.054e+04
        AbsMag        -20.13
        Axis    [  0.5846  -0.4585  -0.6693]
        Angle     96.2898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2720"
}

Galaxy "IC 2722"
{
        Type  "E0"
        RA           11.3286
        Dec          13.9636
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.3252  -0.0872  -0.9416]
        Angle     81.5230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2722"
}

Galaxy "IC 2723"
{
        Type  "E0"
        RA           11.3297
        Dec          12.0331
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.6783  -0.6531  -0.3366]
        Angle    121.9281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2723"
}

Galaxy "IC 2724:NPM 1"
{
        Type  "E0"
        RA           11.3300
        Dec          10.7172
        Distance   8.318e+08  # distance uncertain!
        Radius      2.42e+04
        AbsMag        -20.13
        Axis    [  0.6817  -0.6465  -0.3426]
        Angle    122.8248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2724"
}

Galaxy "IC 2725:NPM 1"
{
        Type  "E0"
        RA           11.3325
        Dec          13.4297
        Distance   1.148e+09  # distance uncertain!
        Radius      6.68e+04
        AbsMag        -20.13
        Axis    [  0.6743  -0.6605  -0.3302]
        Angle    121.0031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2725"
}

Galaxy "IC 2727"
{
        Type  "E0"
        RA           11.3333
        Dec          12.0331
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [  0.6780  -0.6534  -0.3367]
        Angle    121.9533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2727"
}

Galaxy "IC 2729"
{
        Type  "S0"
        RA           11.3350
        Dec          13.4092
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.9119   0.3703  -0.1769]
        Angle     65.8574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2729"
}

Galaxy "IC 2732"
{
        Type  "E0"
        RA           11.3367
        Dec          12.4039
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.6767  -0.6556  -0.3352]
        Angle    121.7255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2732"
}

Galaxy "IC 2734"
{
        Type  "S0"
        RA           11.3397
        Dec          12.4431
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.9932  -0.0796   0.0848]
        Angle    101.5802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2734"
}

Galaxy "IC 2735:UGC 6364:MCG 6-25-48:ZWG 185.41"
{
        Type  "Sb"
        RA           11.3508
        Dec          34.3444
        Distance   5.094e+08  # method: V
        Radius     7.409e+04
        AbsMag        -20.57
        Axis    [  0.2727   0.5117   0.8147]
        Angle     36.9844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2735"
}

Galaxy "IC 2738:MCG 6-25-49:ZWG 185.42:NPM 1"
{
        Type  "Sa"
        RA           11.3564
        Dec          34.3572
        Distance   4.859e+08  # method: V
        Radius     4.947e+04
        AbsMag        -20.27
        Axis    [  0.6245  -0.7542  -0.2031]
        Angle    107.1554
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2738"
}

Galaxy "IC 2739"
{
        Type  "E0"
        RA           11.3533
        Dec          11.9144
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6763  -0.6544  -0.3381]
        Angle    122.1734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2739"
}

Galaxy "IC 2740"
{
        Type  "S0"
        RA           11.3547
        Dec           8.7517
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9232  -0.1757  -0.3418]
        Angle     67.4720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2740"
}

Galaxy "IC 2741"
{
        Type  "S0"
        RA           11.3547
        Dec           9.1531
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.7031  -0.6254  -0.3383]
        Angle    123.0264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2741"
}

Galaxy "IC 2742"
{
        Type  "S0"
        RA           11.3550
        Dec          10.4464
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.9997   0.0066   0.0221]
        Angle     67.5182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2742"
}

Galaxy "IC 2744:MCG 6-25-52:ZWG 185.45"
{
        Type  "S0"
        RA           11.3617
        Dec          34.3628
        Distance   4.931e+08  # method: V
        Radius     3.586e+04
        AbsMag         -20.4
        Axis    [  0.6239  -0.7546  -0.2032]
        Angle    107.2005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2744"
}

Galaxy "IC 2745:ZWG 67.59"
{
        Type  "S0"
        RA           11.3586
        Dec          13.4269
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.9932   0.0435  -0.1077]
        Angle     46.2246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2745"
}

Galaxy "IC 2746"
{
        Type  "E0"
        RA           11.3600
        Dec          11.7367
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [ -0.2492   0.4929  -0.8337]
        Angle     99.2158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2746"
}

Galaxy "IC 2748:NPM 1"
{
        Type  "E0"
        RA           11.3622
        Dec           8.8056
        Distance   9.121e+08  # distance uncertain!
        Radius     5.306e+04
        AbsMag        -20.13
        Axis    [  0.5056  -0.3526  -0.7874]
        Angle     93.2221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2748"
}

Galaxy "IC 2749:ZWG 67.60"
{
        Type  "Sc"
        RA           11.3625
        Dec           8.5750
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [  0.7915   0.1945  -0.5795]
        Angle     31.0658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2749"
}

Galaxy "IC 2750"
{
        Type  "S0"
        RA           11.3639
        Dec           9.6583
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9999   0.0067   0.0097]
        Angle     67.6364
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2750"
}

Galaxy "IC 2751:MCG 6-25-54:ZWG 185.47"
{
        Type  "S0"
        RA           11.3686
        Dec          34.3664
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.8356  -0.5488   0.0236]
        Angle    104.1121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2751"
}

Galaxy "IC 2752"
{
        Type  "S0"
        RA           11.3672
        Dec          14.1244
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.5822   0.6278   0.5166]
        Angle     20.9041
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2752"
}

Galaxy "IC 2753"
{
        Type  "E0"
        RA           11.3664
        Dec           9.8778
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.6803  -0.6451  -0.3480]
        Angle    123.6449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2753"
}

Galaxy "IC 2754"
{
        Type  "S0"
        RA           11.3672
        Dec          14.1439
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9555   0.2474  -0.1604]
        Angle     29.8099
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2754"
}

Galaxy "IC 2756"
{
        Type  "S0"
        RA           11.3669
        Dec           9.9600
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.6981   0.4844  -0.5272]
        Angle     20.4154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2756"
}

Galaxy "IC 2757:ZWG 67.62"
{
        Type  "Sa"
        RA           11.3672
        Dec           8.3939
        Distance   1.938e+08  # distance uncertain!
        Radius      1.41e+04
        AbsMag        -19.07
        Axis    [  0.8207   0.0253  -0.5708]
        Angle     42.0208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2757"
}

Galaxy "IC 2758:ZWG 39.148:NPM 1"
{
        Type  "S0"
        RA           11.3675
        Dec           7.8139
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.9996  -0.0251   0.0101]
        Angle     82.5942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2758"
}

Galaxy "IC 2759:MCG 4-27-27:ZWG 126.41:HCG 51"
{
        Type  "E0"
        RA           11.3703
        Dec          24.3172
        Distance   3.629e+08  # method: V
        Radius     2.111e+04
        AbsMag        -20.13
        Axis    [  0.6378  -0.7185  -0.2775]
        Angle    114.1435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2759"
}

Galaxy "IC 2760"
{
        Type  "S0"
        RA           11.3700
        Dec          12.6658
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.2061   0.3755  -0.9036]
        Angle     32.1338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2760"
}

Galaxy "IC 2761"
{
        Type  "E0"
        RA           11.3714
        Dec          14.1772
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6685  -0.6674  -0.3283]
        Angle    120.7802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2761"
}

Galaxy "IC 2762:ZWG 67.63"
{
        Type  "S0"
        RA           11.3714
        Dec          12.7225
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.8477   0.5295  -0.0336]
        Angle     31.4069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2762"
}

Galaxy "IC 2763:UGC 6387:MCG 2-29-21:ZWG 67.64"
{
        Type  "Sc"
        RA           11.3717
        Dec          13.0653
        Distance   8.671e+07  # method: V
        Radius     1.766e+04
        AbsMag        -17.52
        Axis    [  0.7100   0.5431   0.4482]
        Angle     22.8866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2763"
}

Galaxy "IC 2764:ESO 439-8:MCG 5-27-12"
{
        Type  "Sa"
        RA           11.4511
        Dec         -28.9806
        Distance   8.906e+07  # method: V
        Radius     2.202e+04
        AbsMag        -19.08
        Axis    [  0.8692  -0.2447  -0.4296]
        Angle    136.9821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2764"
}

Galaxy "IC 2765"
{
        Type  "E0"
        RA           11.3731
        Dec          14.1989
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6683  -0.6676  -0.3282]
        Angle    120.7777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2765"
}

Galaxy "IC 2766"
{
        Type  "S0"
        RA           11.3731
        Dec          12.9039
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.8629   0.4826   0.1499]
        Angle     31.8078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2766"
}

Galaxy "IC 2767"
{
        Type  "S0"
        RA           11.3731
        Dec          13.0775
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [  0.8086   0.4330   0.3984]
        Angle     27.4691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2767"
}

Galaxy "IC 2768"
{
        Type  "S0"
        RA           11.3731
        Dec          12.5289
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.9165  -0.1450  -0.3727]
        Angle     57.1517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2768"
}

Galaxy "IC 2769:ZWG 67.65:NPM 1"
{
        Type  "E0"
        RA           11.3736
        Dec          14.1964
        Distance   3.981e+08  # distance uncertain!
        Radius     1.737e+04
        AbsMag        -20.13
        Axis    [ -0.2982   0.5636  -0.7704]
        Angle    103.1772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2769"
}

Galaxy "IC 2770:NPM 1"
{
        Type  "E0"
        RA           11.3733
        Dec           9.2211
        Distance   8.318e+08  # distance uncertain!
        Radius      2.42e+04
        AbsMag        -20.13
        Axis    [  0.6812  -0.6423  -0.3512]
        Angle    124.1390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2770"
}

Galaxy "IC 2771"
{
        Type  "E0"
        RA           11.3744
        Dec          12.5194
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6727  -0.6592  -0.3362]
        Angle    121.9137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2771"
}

Galaxy "IC 2775"
{
        Type  "E0"
        RA           11.3775
        Dec          12.5122
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6724  -0.6594  -0.3363]
        Angle    121.9401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2775"
}

Galaxy "IC 2776:MCG 2-29-22:ZWG 67.67"
{
        Type  "Sc"
        RA           11.3778
        Dec          13.3308
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.8489   0.4397  -0.2934]
        Angle     60.7046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2776"
}

Galaxy "IC 2777:ZWG 67.66"
{
        Type  "E0"
        RA           11.3778
        Dec          12.0256
        Distance   4.169e+08  # distance uncertain!
        Radius     4.851e+04
        AbsMag        -20.13
        Axis    [ -0.1464   0.3991  -0.9051]
        Angle     92.1288
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2777"
}

Galaxy "IC 2779:NPM 1"
{
        Type  "S0"
        RA           11.3789
        Dec          13.3458
        Distance    6.13e+08  # distance uncertain!
        Radius     2.675e+04
        AbsMag        -19.07
        Axis    [  0.9472  -0.3163  -0.0527]
        Angle    110.8865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2779"
}

Galaxy "IC 2780-1"
{
        Type  "E0"
        RA           11.3800
        Dec          10.1494
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.6783  -0.6476  -0.3473]
        Angle    123.5532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2780-1"
}

Galaxy "IC 2780-2"
{
        Type  "Irr"
        RA           11.3800
        Dec          10.1522
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.9825  -0.1858  -0.0150]
        Angle    106.5827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2780-2"
}

Galaxy "IC 2781:NPM 1"
{
        Type  "S0"
        RA           11.3806
        Dec          12.3453
        Distance   6.721e+08  # distance uncertain!
        Radius     2.933e+04
        AbsMag        -19.07
        Axis    [ -0.6656   0.5047  -0.5497]
        Angle     60.5693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2781"
}

Galaxy "IC 2782:UGC 6395:MCG 2-29-23:ZWG 67.68"
{
        Type  "Irr"
        RA           11.3819
        Dec          13.4414
        Distance   3.312e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -20.13
        Axis    [  0.8960  -0.4239  -0.1324]
        Angle    112.1259
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2782"
}

Galaxy "IC 2783:NPM 1"
{
        Type  "S0"
        RA           11.3814
        Dec           8.8844
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [ -0.8743   0.3728  -0.3110]
        Angle     56.7558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2783"
}

Galaxy "IC 2784:NPM 1"
{
        Type  "S0"
        RA           11.3864
        Dec          13.1183
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.9886  -0.1287  -0.0783]
        Angle     72.1424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2784"
}

Galaxy "IC 2785:NPM 1"
{
        Type  "S0"
        RA           11.3875
        Dec          13.3917
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.6417   0.5369  -0.5476]
        Angle     79.2387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2785"
}

Galaxy "IC 2786:MCG 2-29-24:ZWG 67.69"
{
        Type  "S0"
        RA           11.3881
        Dec          13.3928
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.1749   0.9835  -0.0455]
        Angle     14.3560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2786"
}

Galaxy "IC 2787:UGC 6401:ZWG 67.70"
{
        Type  "Sc"
        RA           11.3886
        Dec          13.6297
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.6888  -0.6514  -0.3182]
        Angle    120.2955
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2787"
}

Galaxy "IC 2788-1"
{
        Type  "S0"
        RA           11.3906
        Dec          12.7006
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.9811  -0.1933  -0.0029]
        Angle    101.1456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2788-1"
}

Galaxy "IC 2788-2"
{
        Type  "S0"
        RA           11.3908
        Dec          12.6981
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.9476  -0.3141  -0.0589]
        Angle    111.1457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2788-2"
}

Galaxy "IC 2790"
{
        Type  "E0"
        RA           11.3928
        Dec           9.5547
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [  0.6785  -0.6455  -0.3505]
        Angle    124.0438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2790"
}

Galaxy "IC 2791"
{
        Type  "S0"
        RA           11.3936
        Dec          12.8964
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.8889   0.4169  -0.1901]
        Angle     50.9175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2791"
}

Galaxy "IC 2792"
{
        Type  "S0"
        RA           11.3947
        Dec          11.4042
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8864   0.1434  -0.4401]
        Angle     32.8518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2792"
}

Galaxy "IC 2793-1"
{
        Type  "E0"
        RA           11.3964
        Dec           9.4511
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.6784  -0.6453  -0.3512]
        Angle    124.1386
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2793-1"
}

Galaxy "IC 2793-2"
{
        Type  "S0"
        RA           11.3964
        Dec           9.4483
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8652   0.1287  -0.4847]
        Angle     33.8295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2793-2"
}

Galaxy "IC 2795:NPM 1"
{
        Type  "E0"
        RA           11.4011
        Dec          12.1356
        Distance   1.318e+09  # distance uncertain!
        Radius     5.753e+04
        AbsMag        -20.13
        Axis    [  0.5095  -0.3662  -0.7787]
        Angle     90.1293
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2795"
}

Galaxy "IC 2796-1"
{
        Type  "S0"
        RA           11.4022
        Dec           9.3458
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9140  -0.2978  -0.2755]
        Angle     86.4381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2796-1"
}

Galaxy "IC 2796-2"
{
        Type  "S0"
        RA           11.4022
        Dec           9.3433
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9961  -0.0727   0.0496]
        Angle    102.0803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2796-2"
}

Galaxy "IC 2797:NPM 1"
{
        Type  "S0"
        RA           11.4058
        Dec          11.7064
        Distance    5.59e+08  # distance uncertain!
        Radius     3.252e+04
        AbsMag        -19.07
        Axis    [ -0.4029   0.4767  -0.7813]
        Angle     50.3685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2797"
}

Galaxy "IC 2798:FGC 1242"
{
        Type  "Sc"
        RA           11.4067
        Dec          12.4158
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [ -0.9684   0.2495   0.0009]
        Angle     64.1769
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2798"
}

Galaxy "IC 2799:NPM 1"
{
        Type  "SBa"
        RA           11.4072
        Dec          13.8494
        Distance   6.419e+08  # distance uncertain!
        Radius     2.801e+04
        AbsMag        -19.07
        Axis    [ -0.6668   0.5223  -0.5315]
        Angle     60.0198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2799"
}

Galaxy "IC 2800"
{
        Type  "S0"
        RA           11.4075
        Dec          12.2089
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8493   0.3943  -0.3510]
        Angle     22.3230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2800"
}

Galaxy "IC 2801"
{
        Type  "Irr"
        RA           11.4081
        Dec          10.1836
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.7201   0.1202  -0.6833]
        Angle     34.4548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2801"
}

Galaxy "IC 2802"
{
        Type  "E0"
        RA           11.4083
        Dec          12.2089
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6702  -0.6603  -0.3390]
        Angle    122.3616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2802"
}

Galaxy "IC 2803"
{
        Type  "S0"
        RA           11.4097
        Dec           9.8500
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9909   0.0895   0.1002]
        Angle     58.2025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2803"
}

Galaxy "IC 2804:MCG 2-29-26:ZWG 67.72:IRAS 11223+1329"
{
        Type  "Sc"
        RA           11.4153
        Dec          13.2228
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.9874  -0.0037   0.1583]
        Angle    100.8781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2804"
}

Galaxy "IC 2807"
{
        Type  "S0"
        RA           11.4214
        Dec          11.5297
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.9858  -0.1163  -0.1215]
        Angle     67.9080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2807"
}

Galaxy "IC 2810:IC 2810A:UGC 6436:MCG 3-29-43"
{
        Type  "SBa"
        RA           11.4289
        Dec          14.6767
        Distance   4.793e+08  # method: V
        Radius     9.062e+04
        AbsMag        -20.64
        Axis    [  0.9893  -0.1459  -0.0021]
        Angle     81.3521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2810"
}

Galaxy "IC 2810B:MCG 3-29-44"
{
        Type  "S0"
        RA           11.4303
        Dec          14.6686
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [  0.9866  -0.1574  -0.0438]
        Angle     76.5857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2810B"
}

Galaxy "IC 2811"
{
        Type  "S0"
        RA           11.4289
        Dec           9.1703
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.8316   0.1466  -0.5357]
        Angle     31.6819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2811"
}

Galaxy "IC 2812"
{
        Type  "S0"
        RA           11.4319
        Dec          11.5303
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9932  -0.1148   0.0199]
        Angle     91.7641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2812"
}

Galaxy "IC 2813:NPM 1"
{
        Type  "E0"
        RA           11.4350
        Dec          11.2561
        Distance   9.551e+08  # distance uncertain!
        Radius     4.167e+04
        AbsMag        -20.13
        Axis    [  0.6701  -0.6575  -0.3445]
        Angle    123.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2813"
}

Galaxy "IC 2814"
{
        Type  "E0"
        RA           11.4356
        Dec           9.6617
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5480  -0.4329  -0.7158]
        Angle     96.4383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2814"
}

Galaxy "IC 2815"
{
        Type  "S0"
        RA           11.4378
        Dec          12.8036
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.4711   0.4886  -0.7344]
        Angle     21.0329
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2815"
}

Galaxy "IC 2816"
{
        Type  "S0"
        RA           11.4383
        Dec          10.6364
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.9791  -0.2031  -0.0048]
        Angle    111.4792
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2816"
}

Galaxy "IC 2818:NPM 1"
{
        Type  "S0"
        RA           11.4406
        Dec          12.9217
        Distance    7.37e+08  # distance uncertain!
        Radius     3.216e+04
        AbsMag        -19.07
        Axis    [  0.6898   0.0871  -0.7188]
        Angle     36.0046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2818"
}

Galaxy "IC 2819:ZWG 67.74"
{
        Type  "S0"
        RA           11.4408
        Dec          13.8447
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.9961   0.0549  -0.0694]
        Angle     43.0726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2819"
}

Galaxy "IC 2820:NPM 1"
{
        Type  "S0"
        RA           11.4406
        Dec          10.2389
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.9836  -0.1719  -0.0552]
        Angle     92.1893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2820"
}

Galaxy "IC 2821"
{
        Type  "E0"
        RA           11.4428
        Dec          13.9625
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.6621  -0.6719  -0.3320]
        Angle    121.4403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2821"
}

Galaxy "IC 2822:UGC 6449:ZWG 67.75"
{
        Type  "SBc"
        RA           11.4428
        Dec          11.4397
        Distance   1.607e+08  # method: V
        Radius     3.506e+04
        AbsMag        -18.66
        Axis    [  0.0027   0.6315  -0.7754]
        Angle     19.8629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2822"
}

Galaxy "IC 2823:ZWG 67.76"
{
        Type  "S0"
        RA           11.4456
        Dec          12.8478
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.9870  -0.1580   0.0310]
        Angle    101.3250
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2823"
}

Galaxy "IC 2826:ZWG 67.77"
{
        Type  "E0"
        RA           11.4517
        Dec          13.2386
        Distance   3.631e+08  # distance uncertain!
        Radius     3.169e+04
        AbsMag        -20.13
        Axis    [  0.6632  -0.6689  -0.3358]
        Angle    121.9842
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2826"
}

Galaxy "IC 2828:MCG 2-29-28:ZWG 67.78"
{
        Type  "S0"
        RA           11.4531
        Dec           8.7322
        Distance   6.197e+07  # method: V
        Radius          8112
        AbsMag        -16.89
        Axis    [  0.9154  -0.1945  -0.3524]
        Angle     66.6868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2828"
}

Galaxy "IC 2829:ZWG 67.79:NPM 1"
{
        Type  "S0"
        RA           11.4539
        Dec          10.3228
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [  0.9627  -0.2656  -0.0524]
        Angle    111.8192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2829"
}

Galaxy "IC 2830:ZWG 39.185"
{
        Type  "E0"
        RA           11.4558
        Dec           7.8142
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.6767  -0.6416  -0.3611]
        Angle    125.6478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2830"
}

Galaxy "IC 2834"
{
        Type  "E0"
        RA           11.4586
        Dec          13.5706
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6616  -0.6711  -0.3345]
        Angle    121.8145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2834"
}

Galaxy "IC 2835:NPM 1"
{
        Type  "S0"
        RA           11.4586
        Dec          12.1433
        Distance   7.038e+08  # distance uncertain!
        Radius     4.094e+04
        AbsMag        -19.07
        Axis    [ -0.6540   0.5369  -0.5330]
        Angle     36.3291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2835"
}

Galaxy "IC 2837"
{
        Type  "E0"
        RA           11.4614
        Dec          10.3131
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.6699  -0.6548  -0.3500]
        Angle    124.0030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2837"
}

Galaxy "IC 2838:NPM 1"
{
        Type  "E0"
        RA           11.4625
        Dec          14.0117
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6600  -0.6737  -0.3326]
        Angle    121.5513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2838"
}

Galaxy "IC 2839"
{
        Type  "S0"
        RA           11.4625
        Dec          10.8197
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9934  -0.0963   0.0630]
        Angle    106.9240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2839"
}

Galaxy "IC 2840"
{
        Type  "E0"
        RA           11.4631
        Dec          13.4261
        Distance   1.097e+09  # distance uncertain!
        Radius      6.38e+04
        AbsMag        -20.13
        Axis    [  0.6615  -0.6707  -0.3354]
        Angle    121.9422
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2840"
}

Galaxy "IC 2842"
{
        Type  "S0"
        RA           11.4631
        Dec           9.6519
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.9999  -0.0162   0.0054]
        Angle     67.6483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2842"
}

Galaxy "IC 2843:ZWG 67.81"
{
        Type  "E0"
        RA           11.4661
        Dec          13.1839
        Distance   4.169e+08  # distance uncertain!
        Radius     1.819e+04
        AbsMag        -20.13
        Axis    [  0.6619  -0.6697  -0.3367]
        Angle    122.1245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2843"
}

Galaxy "IC 2844"
{
        Type  "S0"
        RA           11.4661
        Dec          11.4533
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.1250   0.4764  -0.8703]
        Angle     29.2613
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2844"
}

Galaxy "IC 2845:NPM 1"
{
        Type  "S0"
        RA           11.4667
        Dec          12.5303
        Distance   7.717e+08  # distance uncertain!
        Radius     4.489e+04
        AbsMag        -19.07
        Axis    [  0.7299  -0.0756  -0.6793]
        Angle     46.5058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2845"
}

Galaxy "IC 2846:MCG 2-29-29:ZWG 67.80:NPM 1"
{
        Type  "S0"
        RA           11.4667
        Dec          11.1586
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.0851   0.2771  -0.9571]
        Angle     41.7258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2846"
}

Galaxy "IC 2847"
{
        Type  "S0"
        RA           11.4675
        Dec          13.9294
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.9775  -0.2109   0.0031]
        Angle    101.0828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2847"
}

Galaxy "IC 2848"
{
        Type  "E0"
        RA           11.4703
        Dec          13.0308
        Distance   1.381e+09  # distance uncertain!
        Radius     6.024e+04
        AbsMag        -20.13
        Axis    [  0.6619  -0.6693  -0.3376]
        Angle    122.2559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2848"
}

Galaxy "IC 2850:MCG 2-29-30:ZWG 67.82:IRAS 11256+0920"
{
        Type  "S0"
        RA           11.4703
        Dec           9.0628
        Distance    3.01e+08  # method: V
        Radius     3.065e+04
        AbsMag        -19.53
        Axis    [ -0.6742   0.6847  -0.2770]
        Angle     18.1066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2850"
}

Galaxy "IC 2851"
{
        Type  "S0"
        RA           11.4706
        Dec          11.3942
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9839  -0.1271  -0.1254]
        Angle     67.9951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2851"
}

Galaxy "IC 2852:NPM 1"
{
        Type  "S0"
        RA           11.4706
        Dec           9.8011
        Distance    6.13e+08  # distance uncertain!
        Radius     3.566e+04
        AbsMag        -19.07
        Axis    [  0.2321   0.4659  -0.8539]
        Angle     21.8357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2852"
}

Galaxy "IC 2853:UGC 6470:MCG 2-29-31:ZWG 67.83"
{
        Type  "SBb"
        RA           11.4706
        Dec           9.1478
        Distance   3.016e+08  # method: V
        Radius     4.386e+04
        AbsMag        -20.23
        Axis    [  0.9798  -0.1988  -0.0201]
        Angle    111.9081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2853"
}

Galaxy "IC 2855"
{
        Type  "Irr"
        RA           11.4733
        Dec           9.6878
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6905  -0.6378  -0.3411]
        Angle    123.4626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2855"
}

Galaxy "IC 2856:MCG 2-29-33:IRAS 11257-1236"
{
        Type  "Sb"
        RA           11.4711
        Dec         -12.8906
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [  0.9451   0.0148  -0.3265]
        Angle     77.5704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2856"
}

Galaxy "IC 2857:UGC 6475:MCG 2-29-33:ZWG 67.85"
{
        Type  "Sc"
        RA           11.4753
        Dec           9.1039
        Distance   3.022e+08  # method: V
        Radius     7.912e+04
        AbsMag        -19.53
        Axis    [ -0.9684   0.2494   0.0085]
        Angle     49.5763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2857"
}

Galaxy "IC 2858"
{
        Type  "E0"
        RA           11.4767
        Dec          13.6614
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [  0.0529   0.1920  -0.9800]
        Angle     82.4201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2858"
}

Galaxy "IC 2860"
{
        Type  "E0"
        RA           11.4789
        Dec          14.0414
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6583  -0.6751  -0.3331]
        Angle    121.6512
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2860"
}

Galaxy "IC 2861:MCG 7-24-11:ZWG 214.9:NPM 1"
{
        Type  "E0"
        RA           11.4828
        Dec          38.8519
        Distance   4.571e+08  # distance uncertain!
        Radius     5.319e+04
        AbsMag        -20.13
        Axis    [  0.3646   0.0847  -0.9273]
        Angle     57.9702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2861"
}

Galaxy "IC 2862:NPM 1"
{
        Type  "S0"
        RA           11.4786
        Dec          10.1278
        Distance   6.419e+08  # distance uncertain!
        Radius     2.801e+04
        AbsMag        -19.07
        Axis    [  0.9292  -0.2240  -0.2940]
        Angle     71.1664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2862"
}

Galaxy "IC 2864:NPM 1"
{
        Type  "S0"
        RA           11.4831
        Dec          12.3681
        Distance    7.37e+08  # distance uncertain!
        Radius     4.287e+04
        AbsMag        -19.07
        Axis    [ -0.8030   0.4592  -0.3799]
        Angle     53.6813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2864"
}

Galaxy "IC 2867:ZWG 67.87"
{
        Type  "E0"
        RA           11.4833
        Dec           9.0900
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.3664  -0.2102  -0.9064]
        Angle     87.1328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2867"
}

Galaxy "IC 2870:UGC 6486"
{
        Type  "Irr"
        RA           11.4867
        Dec          11.8650
        Distance   1.618e+08  # method: V
        Radius      3.06e+04
        AbsMag        -17.98
        Axis    [  0.8778  -0.4487  -0.1679]
        Angle    113.8006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2870"
}

Galaxy "IC 2871:MCG 2-29-37:ZWG 67.90"
{
        Type  "Sb"
        RA           11.4889
        Dec           8.6025
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.6446  -0.0560  -0.7625]
        Angle     47.3322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2871"
}

Galaxy "IC 2873:MCG 2-29-38:ZWG 67.91"
{
        Type  "S0"
        RA           11.4908
        Dec          13.2200
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.9640  -0.2648  -0.0254]
        Angle    108.1866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2873"
}

Galaxy "IC 2874"
{
        Type  "Irr"
        RA           11.4908
        Dec          10.6278
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [  0.8977  -0.2928  -0.3291]
        Angle     77.4383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2874"
}

Galaxy "IC 2876"
{
        Type  "S0"
        RA           11.4925
        Dec           9.0161
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.9284   0.3117  -0.2025]
        Angle     59.6164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2876"
}

Galaxy "IC 2877:ZWG 67.92"
{
        Type  "E0"
        RA           11.4936
        Dec          12.8536
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.6601  -0.6702  -0.3393]
        Angle    122.5409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2877"
}

Galaxy "IC 2878"
{
        Type  "S0"
        RA           11.4939
        Dec           9.9675
        Distance   3.694e+08  # distance uncertain!
        Radius      1.88e+04
        AbsMag        -19.07
        Axis    [  0.0271   0.4241  -0.9052]
        Angle     26.5657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2878"
}

Galaxy "IC 2879"
{
        Type  "S0"
        RA           11.4956
        Dec           9.0136
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.7376   0.4351  -0.5163]
        Angle     57.3330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2879"
}

Galaxy "IC 2881"
{
        Type  "E0"
        RA           11.4983
        Dec          12.5114
        Distance    8.71e+08  # distance uncertain!
        Radius     3.801e+04
        AbsMag        -20.13
        Axis    [  0.3403  -0.1655  -0.9256]
        Angle     82.8825
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2881"
}

Galaxy "IC 2883:NPM 1"
{
        Type  "E0"
        RA           11.5042
        Dec          10.9114
        Distance   1.202e+09  # distance uncertain!
        Radius     3.498e+04
        AbsMag        -20.13
        Axis    [  0.6642  -0.6611  -0.3489]
        Angle    123.9020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2883"
}

Galaxy "IC 2886"
{
        Type  "E0"
        RA           11.5067
        Dec          11.5631
        Distance   1.097e+09  # distance uncertain!
        Radius      3.19e+04
        AbsMag        -20.13
        Axis    [  0.6622  -0.6646  -0.3460]
        Angle    123.4874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2886"
}

Galaxy "IC 2887:NGC 3705A:ZWG 67.94:FGC 153A"
{
        Type  "S0"
        RA           11.5081
        Dec           9.3883
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.7394   0.6237   0.2537]
        Angle     17.7443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2887"
}

Galaxy "IC 2889:MCG 2-29-38"
{
        Type  "SBc"
        RA           11.5078
        Dec         -13.0917
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [ -0.6629   0.1303  -0.7373]
        Angle     63.3347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2889"
}

Galaxy "IC 2891"
{
        Type  "SBa"
        RA           11.5133
        Dec          12.6775
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.6792  -0.6565  -0.3281]
        Angle    121.7953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2891"
}

Galaxy "IC 2892"
{
        Type  "S0"
        RA           11.5136
        Dec          10.5881
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.3063   0.6955  -0.6499]
        Angle     17.6120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2892"
}

Galaxy "IC 2893-1:ZWG 67.95"
{
        Type  "S0"
        RA           11.5147
        Dec          13.3919
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.6772  -0.6603  -0.3246]
        Angle    121.3459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2893-1"
}

Galaxy "IC 2893-2:ZWG 67.95"
{
        Type  "S0"
        RA           11.5147
        Dec          13.3900
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.9766  -0.2150  -0.0056]
        Angle    101.3368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2893-2"
}

Galaxy "IC 2894:ZWG 67.96"
{
        Type  "S0"
        RA           11.5158
        Dec          13.2350
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.9779  -0.0637  -0.1993]
        Angle     48.7855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2894"
}

Galaxy "IC 2896:NPM 1"
{
        Type  "S0"
        RA           11.5203
        Dec          12.3506
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [ -0.6856   0.4912  -0.5373]
        Angle     59.1574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2896"
}

Galaxy "IC 2898"
{
        Type  "S0"
        RA           11.5222
        Dec          13.3356
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.4264   0.5066  -0.7493]
        Angle     39.7362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2898"
}

Galaxy "IC 2900:NPM 1"
{
        Type  "E0"
        RA           11.5247
        Dec          13.1678
        Distance   1.318e+09  # distance uncertain!
        Radius     5.753e+04
        AbsMag        -20.13
        Axis    [ -0.0390   0.2755  -0.9605]
        Angle     84.7211
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2900"
}

Galaxy "IC 2901:NPM 1"
{
        Type  "S0"
        RA           11.5256
        Dec          12.7003
        Distance   8.081e+08  # distance uncertain!
        Radius     4.701e+04
        AbsMag        -19.07
        Axis    [  0.1834   0.2580  -0.9486]
        Angle     37.1350
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2901"
}

Galaxy "IC 2903"
{
        Type  "S0"
        RA           11.5278
        Dec          12.6422
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9835  -0.1439  -0.1094]
        Angle     67.7012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2903"
}

Galaxy "IC 2909"
{
        Type  "E0"
        RA           11.5306
        Dec          11.4703
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6601  -0.6660  -0.3474]
        Angle    123.7181
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2909"
}

Galaxy "IC 2910:MCG 1-30-1:NPM 1"
{
        Type  "Sa"
        RA           11.5317
        Dec          -9.7247
        Distance   1.688e+08  # distance uncertain!
        Radius     4.174e+04
        AbsMag        -19.07
        Axis    [ -0.2750   0.1192  -0.9540]
        Angle     54.9433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2910"
}

Galaxy "IC 2912"
{
        Type  "S0"
        RA           11.5353
        Dec          11.7103
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8952   0.2860   0.3418]
        Angle     30.8223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2912"
}

Galaxy "IC 2913:ESO 439-16:MCG 5-27-16:IRAS 11293-3008"
{
        Type  "Sa"
        RA           11.5308
        Dec         -30.4106
        Distance     9.5e+07  # method: V
        Radius     1.105e+04
        AbsMag        -18.52
        Axis    [  0.7463  -0.4335  -0.5052]
        Angle    151.5957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2913"
}

Galaxy "IC 2914:ZWG 68.1:KUG 1129+137"
{
        Type  "S0"
        RA           11.5367
        Dec          13.4919
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.9726  -0.2320   0.0115]
        Angle    111.1664
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2914"
}

Galaxy "IC 2917"
{
        Type  "S0"
        RA           11.5386
        Dec          10.9458
        Distance   6.721e+08  # distance uncertain!
        Radius     1.466e+04
        AbsMag        -19.07
        Axis    [  0.9208  -0.2242  -0.3193]
        Angle     66.4914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2917"
}

Galaxy "IC 2919-1:KUG 1129+144:KUG 1129+144"
{
        Type  "Irr"
        RA           11.5431
        Dec          14.1903
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.8882  -0.2838  -0.3613]
        Angle     67.2199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2919-1"
}

Galaxy "IC 2919-2"
{
        Type  "E0"
        RA           11.5431
        Dec          14.1922
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6515  -0.6808  -0.3347]
        Angle    122.0233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2919-2"
}

Galaxy "IC 2921:NPM 1"
{
        Type  "S0"
        RA           11.5469
        Dec          10.2969
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [ -0.3980   0.4640  -0.7914]
        Angle     33.7572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2921"
}

Galaxy "IC 2923"
{
        Type  "E0"
        RA           11.5481
        Dec          13.1639
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.6539  -0.6759  -0.3399]
        Angle    122.7311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2923"
}

Galaxy "IC 2925:ZWG 185.82:ZWG 186.1:NPM 1"
{
        Type  "S0"
        RA           11.5536
        Dec          34.2656
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.9339  -0.2517   0.2538]
        Angle     95.3945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2925"
}

Galaxy "IC 2928:UGC 6540:MCG 6-25-86:ZWG 185.87"
{
        Type  "Sc"
        RA           11.5581
        Dec          34.3161
        Distance   3.778e+08  # method: V
        Radius     6.044e+04
        AbsMag        -20.82
        Axis    [ -0.3369   0.7749  -0.5347]
        Angle     48.0620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2928"
}

Galaxy "IC 2929"
{
        Type  "Irr"
        RA           11.5586
        Dec          12.1367
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.6762  -0.6573  -0.3327]
        Angle    122.4629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2929"
}

Galaxy "IC 2930:ZWG 68.2"
{
        Type  "S0"
        RA           11.5622
        Dec          10.0886
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.9937  -0.0375  -0.1054]
        Angle     53.2542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2930"
}

Galaxy "IC 2933:UGC 6550:MCG 6-26-4:ZWG 185.89"
{
        Type  "SBb"
        RA           11.5700
        Dec          34.3128
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [  0.9342  -0.2121   0.2870]
        Angle    104.0831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2933"
}

Galaxy "IC 2934:MCG 2-30-2:ZWG 68.4:KARA 486"
{
        Type  "Sc"
        RA           11.5719
        Dec          13.3214
        Distance    4.05e+08  # distance uncertain!
        Radius     2.945e+04
        AbsMag        -19.07
        Axis    [ -0.7379   0.4887  -0.4656]
        Angle     54.9976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2934"
}

Galaxy "IC 2936"
{
        Type  "E0"
        RA           11.5822
        Dec          13.0086
        Distance   4.366e+08  # distance uncertain!
        Radius      1.27e+04
        AbsMag        -20.13
        Axis    [  0.6509  -0.6777  -0.3420]
        Angle    123.0811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2936"
}

Galaxy "IC 2938-1:ZWG 68.7"
{
        Type  "S0"
        RA           11.5933
        Dec          13.6800
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.6688  -0.6680  -0.3263]
        Angle    121.7282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2938-1"
}

Galaxy "IC 2938-2:ZWG 68.7"
{
        Type  "S0"
        RA           11.5933
        Dec          13.6747
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.9766  -0.2133  -0.0285]
        Angle     91.7390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2938-2"
}

Galaxy "IC 2938-3:ZWG 68.7"
{
        Type  "E0"
        RA           11.5931
        Dec          13.6808
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.6480  -0.6820  -0.3391]
        Angle    122.7239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2938-3"
}

Galaxy "IC 2941:MCG 2-30-3:ZWG 68.9"
{
        Type  "S0"
        RA           11.6028
        Dec          10.0558
        Distance   2.972e+08  # method: V
        Radius     3.891e+04
        AbsMag           -20
        Axis    [  0.6316  -0.2353  -0.7387]
        Angle     62.9950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2941"
}

Galaxy "IC 2942"
{
        Type  "E0"
        RA           11.6033
        Dec          11.8153
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.3626  -0.2292  -0.9033]
        Angle     84.2462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2942"
}

Galaxy "IC 2943:MK 41:ZWG 268.62:KUG 1133+551"
{
        Type  "Sa"
        RA           11.6117
        Dec          54.8458
        Distance   2.702e+08  # method: V
        Radius     1.572e+04
        AbsMag        -19.39
        Axis    [  0.5000  -0.8634  -0.0676]
        Angle     99.1019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2943"
}

Galaxy "IC 2945:UGC 6585:MCG 2-30-4:ZWG 68.11"
{
        Type  "E0"
        RA           11.6178
        Dec          12.9269
        Distance   3.163e+08  # distance uncertain!
        Radius       4.6e+04
        AbsMag        -20.13
        Axis    [  0.6476  -0.6800  -0.3437]
        Angle    123.3936
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2945"
}

Galaxy "IC 2946:ZWG 186.13:NPM 1"
{
        Type  "SBa"
        RA           11.6247
        Dec          32.2531
        Distance   2.226e+08  # distance uncertain!
        Radius     1.618e+04
        AbsMag        -19.07
        Axis    [ -0.7204   0.6674  -0.1886]
        Angle     69.9095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2946"
}

Galaxy "IC 2947:MCG 5-28-2:ZWG 156.102:ZWG 157.3"
{
        Type  "Irr"
        RA           11.6253
        Dec          31.3617
        Distance   5.896e+08  # method: V
        Radius     6.003e+04
        AbsMag        -21.59
        Axis    [  0.8269  -0.5574  -0.0748]
        Angle     95.9015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2947"
}

Galaxy "IC 2950:MK 638:ZWG 186.26:NPM 1"
{
        Type  "Sc"
        RA           11.6936
        Dec          37.9925
        Distance   3.111e+08  # method: V
        Radius     2.715e+04
        AbsMag           -20
        Axis    [  0.7987  -0.6007   0.0346]
        Angle    105.6496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2950"
}

Galaxy "IC 2951:UGC 6688:MCG 3-30-61:ZWG 97.82"
{
        Type  "Sa"
        RA           11.7233
        Dec          19.7497
        Distance   2.917e+08  # method: V
        Radius      5.94e+04
        AbsMag        -20.26
        Axis    [  0.9893  -0.0195  -0.1449]
        Angle     33.2141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2951"
}

Galaxy "IC 2952:MCG 6-26-24:ZWG 186.31:KUG 1141+336"
{
        Type  "S0"
        RA           11.7381
        Dec          33.3511
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [ -0.6058   0.7281  -0.3207]
        Angle     67.0868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2952"
}

Galaxy "IC 2955:MCG 3-30-96:ZWG 97.128:ARAK 318"
{
        Type  "E0"
        RA           11.7514
        Dec          19.6228
        Distance   3.021e+08  # method: V
        Radius     3.954e+04
        AbsMag        -19.73
        Axis    [  0.6147  -0.7235  -0.3141]
        Angle    120.1937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2955"
}

Galaxy "IC 2956:UGC 6729:MCG 5-28-27:ZWG 157.30"
{
        Type  "SBc"
        RA           11.7547
        Dec          26.7667
        Distance   4.234e+08  # method: V
        Radius     7.389e+04
        AbsMag        -20.87
        Axis    [  0.9555  -0.2285  -0.1866]
        Angle     44.2811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2956"
}

Galaxy "IC 2957:MCG 5-28-28:ZWG 157.31"
{
        Type  "S0"
        RA           11.7603
        Dec          31.2994
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.9372  -0.3113   0.1572]
        Angle     86.2058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2957"
}

Galaxy "IC 2958:MCG 6-26-30"
{
        Type  "SBa"
        RA           11.7617
        Dec          33.1542
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.8290  -0.5591   0.0118]
        Angle    107.5726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2958"
}

Galaxy "IC 2960:ZWG 186.44"
{
        Type  "S0"
        RA           11.7719
        Dec          35.0042
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.9826   0.1655   0.0842]
        Angle     23.7593
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2960"
}

Galaxy "IC 2961:MK 748:ZWG 157.34:NPM 1"
{
        Type  "S0"
        RA           11.7969
        Dec          31.3453
        Distance   3.867e+08  # method: V
        Radius     1.125e+04
        AbsMag        -19.67
        Axis    [  0.9266  -0.3452   0.1491]
        Angle    100.1750
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2961"
}

Galaxy "IC 2967:MCG 5-28-38:ZWG 157.42"
{
        Type  "E0"
        RA           11.8486
        Dec          30.8511
        Distance   3.179e+08  # method: V
        Radius     4.161e+04
        AbsMag        -20.14
        Axis    [  0.5677  -0.7457  -0.3487]
        Angle    102.9064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2967"
}

Galaxy "IC 2968:ZWG 127.85:NPM 1"
{
        Type  "Sa"
        RA           11.8750
        Dec          20.6258
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.9902  -0.0855  -0.1105]
        Angle     33.0415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2968"
}

Galaxy "IC 2969:MCG 1-30-40:IRAS 11499-0335"
{
        Type  "Sc"
        RA           11.8753
        Dec          -3.8731
        Distance   1.341e+08  # distance uncertain!
        Radius     2.536e+04
        AbsMag        -19.07
        Axis    [  0.3341  -0.0823  -0.9389]
        Angle     39.9802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2969"
}

Galaxy "IC 2971:ZWG 157.49:NPM 1"
{
        Type  "S0"
        RA           11.8908
        Dec          30.6975
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [ -0.6633   0.6981  -0.2697]
        Angle     53.6379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2971"
}

Galaxy "IC 2973:UGC 6872:MCG 6-26-52:ZWG 186.65"
{
        Type  "SBc"
        RA           11.8972
        Dec          33.3658
        Distance   1.577e+08  # method: V
        Radius     3.211e+04
        AbsMag        -19.02
        Axis    [ -0.3162   0.9465  -0.0639]
        Angle     20.9683
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2973"
}

Galaxy "IC 2974:MCG 1-30-45:IRAS 11512-0453"
{
        Type  "Sc"
        RA           11.8967
        Dec          -5.1683
        Distance   2.592e+08  # method: T-F
        Radius     8.293e+04
        AbsMag         -20.6
        Axis    [  0.6976  -0.0399  -0.7154]
        Angle     12.1811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2974"
}

Galaxy "IC 2977:ESO 379-9:MCG 6-26-14:AM 1152-372"
{
        Type  "Irr"
        RA           11.9206
        Dec         -37.6961
        Distance     1.5e+08  # method: V
        Radius     3.492e+04
        AbsMag        -20.11
        Axis    [ -0.1904  -0.2657  -0.9451]
        Angle     57.2981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2977"
}

Galaxy "IC 2978:UGC 6915:MCG 5-28-51:ZWG 157.57"
{
        Type  "SBc"
        RA           11.9397
        Dec          32.0386
        Distance   1.588e+08  # method: V
        Radius      2.54e+04
        AbsMag        -18.14
        Axis    [ -0.4181   0.7456   0.5189]
        Angle     24.1878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2978"
}

Galaxy "IC 2979:UGC 6925:MCG 5-28-54:ZWG 157.59"
{
        Type  "S0"
        RA           11.9483
        Dec          32.1586
        Distance   1.541e+08  # method: V
        Radius     2.017e+04
        AbsMag        -18.87
        Axis    [ -0.5046   0.7262  -0.4669]
        Angle     71.2338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2979"
}

Galaxy "IC 2980:ESO 39-5"
{
        Type  "E3"
        RA           11.9583
        Dec         -73.6850
        Distance   3.844e+08  # method: V
        Radius     6.709e+04
        AbsMag        -21.96
        Axis    [  0.4259  -0.2393  -0.8726]
        Angle    174.9048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2980"
}

Galaxy "IC 2981:MCG 5-28-48:ZWG 157.56:KUG 1153+324"
{
        Type  "SBa"
        RA           11.9283
        Dec          32.1900
        Distance   1.682e+08  # method: V
        Radius          9783
        AbsMag        -18.66
        Axis    [  0.8432  -0.5371   0.0226]
        Angle    109.1561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2981"
}

Galaxy "IC 2982:NGC 4004B:MCG 5-28-59:ZWG 157.63"
{
        Type  "S0"
        RA           11.9642
        Dec          27.8683
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.9851  -0.1008  -0.1390]
        Angle     28.1930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2982"
}

Galaxy "IC 2984:MCG 5-28-68:ZWG 157.73:KUG 1156+309"
{
        Type  "Sb"
        RA           11.9853
        Dec          30.6975
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.9793  -0.1941   0.0571]
        Angle     37.1086
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2984"
}

Galaxy "IC 2985:UGC 6981:MCG 5-28-69:ZWG 157.74"
{
        Type  "SBa"
        RA           11.9867
        Dec          30.7311
        Distance   1.634e+08  # method: V
        Radius     2.376e+04
        AbsMag         -18.4
        Axis    [ -0.6834   0.7300   0.0081]
        Angle     33.5929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2985"
}

Galaxy "IC 2986:MCG 5-28-72:ZWG 157.79:NPM 1"
{
        Type  "S0"
        RA           11.9969
        Dec          30.8450
        Distance    1.55e+08  # method: V
        Radius     1.578e+04
        AbsMag        -18.48
        Axis    [  0.7879  -0.6130  -0.0589]
        Angle    110.2312
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2986"
}

Galaxy "IC 2987:MK 44:ZWG 215.18:KUG 1200+390"
{
        Type  "S0"
        RA           12.0567
        Dec          38.8133
        Distance   3.245e+08  # method: V
        Radius      2.36e+04
        AbsMag        -19.59
        Axis    [  0.9240  -0.3294   0.1941]
        Angle     51.6140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2987"
}

Galaxy "IC 2990:MCG 2-31-22:ZWG 69.42"
{
        Type  "S0"
        RA           12.0772
        Dec          11.0500
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [  0.9788  -0.2046  -0.0109]
        Angle     98.2363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2990"
}

Galaxy "IC 2991:MCG 2-31-25:ZWG 69.45"
{
        Type  "Sc"
        RA           12.0867
        Dec          10.6400
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.9903  -0.1323   0.0413]
        Angle     73.3839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2991"
}

Galaxy "IC 2992:MCG 5-29-8:ZWG 158.14:MK 757"
{
        Type  "Sa"
        RA           12.0875
        Dec          30.8553
        Distance   3.914e+07  # method: V
        Radius          3416
        AbsMag         -15.4
        Axis    [  0.7955  -0.6040  -0.0481]
        Angle    110.8172
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2992"
}

Galaxy "IC 2993"
{
        Type  "E0"
        RA           12.0939
        Dec          32.8222
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.5338  -0.8092  -0.2454]
        Angle    115.6439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2993"
}

Galaxy "IC 2994:ZWG 69.47"
{
        Type  "S0"
        RA           12.0908
        Dec          12.7031
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.6739  -0.1890  -0.7143]
        Angle     33.7977
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2994"
}

Galaxy "IC 2995:ESO 440-50:MCG 5-29-8:UGCA 268"
{
        Type  "SBc"
        RA           12.0964
        Dec         -27.9417
        Distance   6.976e+07  # method: T-F
        Radius     3.044e+04
        AbsMag        -18.65
        Axis    [ -0.1350  -0.3724  -0.9182]
        Angle     34.8653
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2995"
}

Galaxy "IC 2996:ESO 440-51:MCG 5-29-9:IRAS 12032-2941"
{
        Type  "Sc"
        RA           12.0967
        Dec         -29.9719
        Distance   9.468e+07  # method: T-F
        Radius     2.203e+04
        AbsMag        -18.01
        Axis    [  0.9274   0.0710  -0.3673]
        Angle     97.7813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2996"
}

Galaxy "IC 2999:ZWG 158.17:KUG 1203+316"
{
        Type  "S0"
        RA           12.0992
        Dec          31.3483
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.9162  -0.1658   0.3647]
        Angle     66.6777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 2999"
}

Galaxy "IC 3001:MCG 6-27-7:ZWG 187.6"
{
        Type  "S0"
        RA           12.1044
        Dec          33.5261
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.8952  -0.1233   0.4284]
        Angle     44.5368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3001"
}

Galaxy "IC 3002:MCG 6-27-10:ZWG 187.8"
{
        Type  "Sc"
        RA           12.1178
        Dec          33.3825
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.5524  -0.8022  -0.2266]
        Angle    114.8747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3002"
}

Galaxy "IC 3003:MCG 6-27-13:ZWG 187.11:NPM 1"
{
        Type  "S0"
        RA           12.1256
        Dec          32.8133
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.4458   0.7596  -0.4735]
        Angle     33.0915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3003"
}

Galaxy "IC 3004:MCG 2-31-30:ZWG 69.54"
{
        Type  "S0"
        RA           12.1194
        Dec          13.2475
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.7917  -0.5655  -0.2311]
        Angle    118.1884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3004"
}

Galaxy "IC 3005:ESO 441-2:MCG 5-29-18:AM 1204-294"
{
        Type  "SBc"
        RA           12.1206
        Dec         -30.0261
        Distance   1.006e+08  # method: T-F
        Radius     3.364e+04
        AbsMag        -18.64
        Axis    [ -0.8296  -0.4283  -0.3583]
        Angle     55.3733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3005"
}

Galaxy "IC 3007:ZWG 158.27:NPM 1"
{
        Type  "E0"
        RA           12.1250
        Dec          31.3486
        Distance   3.235e+08  # method: V
        Radius     1.412e+04
        AbsMag        -19.28
        Axis    [  0.3598  -0.2854  -0.8883]
        Angle     63.7014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3007"
}

Galaxy "IC 3008:MCG 2-31-31:ZWG 69.55"
{
        Type  "Sb"
        RA           12.1308
        Dec          13.5781
        Distance   3.316e+08  # method: V
        Radius      4.34e+04
        AbsMag        -20.04
        Axis    [  0.9642  -0.2628  -0.0362]
        Angle     89.3301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3008"
}

Galaxy "IC 3010:ESO 441-6:MCG 5-29-20:AM 1205-300"
{
        Type  "SBa"
        RA           12.1325
        Dec         -30.3394
        Distance   1.045e+08  # method: V
        Radius     2.887e+04
        AbsMag        -19.33
        Axis    [  0.2172  -0.2338  -0.9477]
        Angle    101.6058
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3010"
}

Galaxy "IC 3012:ZWG 69.61:NPM 1"
{
        Type  "S0"
        RA           12.1397
        Dec          11.1769
        Distance   4.552e+08  # method: V
        Radius      3.31e+04
        AbsMag        -20.62
        Axis    [  0.9738  -0.2220  -0.0486]
        Angle     78.5208
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3012"
}

Galaxy "IC 3013:MCG 2-31-37:ZWG 69.60"
{
        Type  "S0"
        RA           12.1403
        Dec          10.0167
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [  0.8681  -0.4593  -0.1881]
        Angle    116.6703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3013"
}

Galaxy "IC 3014:UGC 7119:MCG 7-25-28A:ZWG 215.31"
{
        Type  "SBc"
        RA           12.1433
        Dec          38.8319
        Distance   2.982e+08  # method: V
        Radius     5.204e+04
        AbsMag         -20.4
        Axis    [  0.9328  -0.3471   0.0972]
        Angle     42.7220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3014"
}

Galaxy "IC 3015:ESO 441-9:MCG 5-29-23:AM 1206-311"
{
        Type  "Sc"
        RA           12.1500
        Dec         -31.5194
        Distance   1.062e+08  # method: V
        Radius     4.481e+04
        AbsMag        -19.46
        Axis    [ -0.8419  -0.3841  -0.3790]
        Angle     62.9909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3015"
}

Galaxy "IC 3016:ZWG 69.63:VCC 7"
{
        Type  "SBc"
        RA           12.1550
        Dec          11.4297
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.6194  -0.6978  -0.3597]
        Angle    127.2275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3016"
}

Galaxy "IC 3017"
{
        Type  "S0"
        RA           12.1561
        Dec          13.6186
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.8472  -0.4276  -0.3154]
        Angle     78.0248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3017"
}

Galaxy "IC 3018:ZWG 69.64:VCC 10:KUG 1206+138"
{
        Type  "S0"
        RA           12.1567
        Dec          13.5756
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.9619   0.2725  -0.0197]
        Angle     61.7264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3018"
}

Galaxy "IC 3019:UGC 7136:MCG 2-31-38:ZWG 69.65"
{
        Type  "E0"
        RA           12.1561
        Dec          13.9922
        Distance   9.667e+07  # method: V
        Radius     1.968e+04
        AbsMag        -18.26
        Axis    [ -0.0460   0.1361  -0.9896]
        Angle     77.1015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3019"
}

Galaxy "IC 3020:NPM 1"
{
        Type  "S0"
        RA           12.1575
        Dec          14.2250
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.3397   0.3096  -0.8881]
        Angle     26.7390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3020"
}

Galaxy "IC 3021:UGC 7149:ZWG 69.67:VCC 15"
{
        Type  "Irr"
        RA           12.1650
        Dec          13.0497
        Distance     1.3e+08  # method: V
        Radius     1.701e+04
        AbsMag         -18.2
        Axis    [  0.9059  -0.4080  -0.1137]
        Angle    114.5028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3021"
}

Galaxy "IC 3022:MCG 7-25-39:ZWG 215.41"
{
        Type  "S0"
        RA           12.1672
        Dec          38.7406
        Distance   2.931e+08  # method: V
        Radius     1.236e+05
        AbsMag        -20.27
        Axis    [  0.8992  -0.2695   0.3448]
        Angle     87.9073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3022"
}

Galaxy "IC 3023:UGC 7150:MCG 3-31-51:VCC 17"
{
        Type  "Irr"
        RA           12.1669
        Dec          14.3669
        Distance   5.228e+07  # method: V
        Radius          9884
        AbsMag        -15.82
        Axis    [ -0.8653   0.4051  -0.2951]
        Angle     29.1942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3023"
}

Galaxy "IC 3024:UGC 7161:MCG 2-31-39:ZWG 69.68"
{
        Type  "Sc"
        RA           12.1700
        Dec          12.3256
        Distance   4.116e+08  # method: V
        Radius     5.987e+04
        AbsMag         -20.4
        Axis    [ -0.9471   0.2998  -0.1147]
        Angle     53.9918
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3024"
}

Galaxy "IC 3025:MCG 2-31-40:ZWG 69.69:VCC 21"
{
        Type  "Sa"
        RA           12.1731
        Dec          10.1886
        Distance   3.819e+07  # method: V
        Radius          3888
        AbsMag        -15.24
        Axis    [  0.6717  -0.1810  -0.7184]
        Angle     26.8545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3025"
}

Galaxy "IC 3028:ZWG 69.70:VCC 24:NPM 1"
{
        Type  "S0"
        RA           12.1764
        Dec          11.7614
        Distance    7.33e+07  # method: V
        Radius          6396
        AbsMag        -16.66
        Axis    [ -0.9615   0.2712  -0.0449]
        Angle     36.6226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3028"
}

Galaxy "IC 3029:UGC 7171:MCG 2-31-41:ZWG 69.71"
{
        Type  "SBc"
        RA           12.1781
        Dec          13.3314
        Distance   3.237e+08  # method: V
        Radius     6.592e+04
        AbsMag        -20.18
        Axis    [  0.9839  -0.1664   0.0653]
        Angle     85.6487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3029"
}

Galaxy "IC 3031:FGC 164A"
{
        Type  "S0"
        RA           12.1844
        Dec          13.3081
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.9838  -0.0868   0.1567]
        Angle     82.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3031"
}

Galaxy "IC 3032:MCG 3-31-59:ZWG 98.83:VCC 33"
{
        Type  "E0"
        RA           12.1853
        Dec          14.2753
        Distance   6.442e+07  # method: V
        Radius          9369
        AbsMag        -16.68
        Axis    [  0.5871  -0.7267  -0.3567]
        Angle    126.8708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3032"
}

Galaxy "IC 3033:UGC 7181:MCG 2-31-43:ZWG 69.74"
{
        Type  "SBc"
        RA           12.1861
        Dec          13.5881
        Distance   2.691e+07  # method: V
        Radius          4305
        AbsMag        -14.88
        Axis    [  0.9134  -0.3942  -0.1020]
        Angle    112.2882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3033"
}

Galaxy "IC 3034"
{
        Type  "S0"
        RA           12.1964
        Dec          14.2014
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [ -0.9511   0.3088   0.0111]
        Angle     36.6702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3034"
}

Galaxy "IC 3036:UGC 7200:ZWG 69.77:VCC 48"
{
        Type  "Irr"
        RA           12.2042
        Dec          12.4886
        Distance   2.512e+08  # distance uncertain!
        Radius     5.846e+04
        AbsMag        -20.13
        Axis    [ -0.7832   0.4590  -0.4195]
        Angle     70.8434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3036"
}

Galaxy "IC 3037:ZWG 69.80:VCC 51"
{
        Type  "Sb"
        RA           12.2056
        Dec           9.9858
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.8241  -0.4128  -0.3878]
        Angle     75.3856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3037"
}

Galaxy "IC 3038:ZWG 69.82:VCC 57"
{
        Type  "Sb"
        RA           12.2089
        Dec          11.3533
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.5064  -0.1446  -0.8501]
        Angle     26.1405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3038"
}

Galaxy "IC 3039:MCG 2-31-48:ZWG 69.84:VCC 59"
{
        Type  "Sc"
        RA           12.2089
        Dec          12.3100
        Distance   3.321e+08  # method: V
        Radius      4.83e+04
        AbsMag        -19.84
        Axis    [  0.9827  -0.1818   0.0355]
        Angle     98.6302
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3039"
}

Galaxy "IC 3040:MCG 2-31-49:ZWG 69.86:VCC 60"
{
        Type  "Irr"
        RA           12.2094
        Dec          11.0742
        Distance   2.205e+08  # method: V
        Radius     2.245e+04
        AbsMag        -18.95
        Axis    [  0.8185  -0.5282  -0.2260]
        Angle    118.3844
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3040"
}

Galaxy "IC 3041"
{
        Type  "S0"
        RA           12.2117
        Dec          12.7631
        Distance   5.339e+08  # distance uncertain!
        Radius     4.659e+04
        AbsMag        -19.07
        Axis    [  0.9812  -0.1920   0.0216]
        Angle     62.5831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3041"
}

Galaxy "IC 3043"
{
        Type  "S0"
        RA           12.2131
        Dec          10.0100
        Distance   3.694e+08  # distance uncertain!
        Radius      3.76e+04
        AbsMag        -19.07
        Axis    [ -0.9824   0.1863   0.0139]
        Angle     56.3917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3043"
}

Galaxy "IC 3044:UGC 7216:MCG 2-31-51:ZWG 69.89"
{
        Type  "SBc"
        RA           12.2133
        Dec          13.9761
        Distance   6.614e+06  # method: V
        Radius          1924
        AbsMag        -12.43
        Axis    [  0.9741  -0.2201  -0.0519]
        Angle     45.6287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3044"
}

Galaxy "IC 3046:UGC 7220:MCG 2-31-52:ZWG 69.90"
{
        Type  "Sc"
        RA           12.2186
        Dec          12.9186
        Distance   3.818e+08  # method: V
        Radius     7.218e+04
        AbsMag        -20.04
        Axis    [ -0.8695   0.2344   0.4347]
        Angle     20.6317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3046"
}

Galaxy "IC 3047"
{
        Type  "S0"
        RA           12.2206
        Dec          12.9972
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.9459  -0.2976  -0.1290]
        Angle     69.2399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3047"
}

Galaxy "IC 3049-1:UGC 7227:ZWG 98.105:VCC 83"
{
        Type  "S0"
        RA           12.2258
        Dec          14.4828
        Distance   1.254e+08  # method: V
        Radius     1.095e+04
        AbsMag        -17.42
        Axis    [  0.8985  -0.4187  -0.1318]
        Angle    104.7985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3049-1"
}

Galaxy "IC 3049-2:UGC 7227:ZWG 98.105:VCC 83"
{
        Type  "S0"
        RA           12.2261
        Dec          14.4792
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.6645   0.3914  -0.6366]
        Angle     28.1706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3049-2"
}

Galaxy "IC 3052:VCC 93"
{
        Type  "E0"
        RA           12.2300
        Dec          12.6903
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [  0.1793  -0.1835  -0.9665]
        Angle     78.5855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3052"
}

Galaxy "IC 3053:ZWG 98.109:VCC 95"
{
        Type  "Sb"
        RA           12.2311
        Dec          14.2225
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.9461  -0.3211  -0.0437]
        Angle    108.6869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3053"
}

Galaxy "IC 3054:VCC 109"
{
        Type  "E0"
        RA           12.2372
        Dec          13.5422
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [ -0.3683   0.5082  -0.7785]
        Angle     91.4991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3054"
}

Galaxy "IC 3055:VCC 113"
{
        Type  "Sa"
        RA           12.2394
        Dec          12.0917
        Distance   5.339e+08  # distance uncertain!
        Radius     3.106e+04
        AbsMag        -19.07
        Axis    [  0.6689  -0.3256  -0.6683]
        Angle     45.8405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3055"
}

Galaxy "IC 3058"
{
        Type  "Irr"
        RA           12.2464
        Dec          14.0953
        Distance   6.919e+08  # distance uncertain!
        Radius     7.044e+04
        AbsMag        -20.13
        Axis    [ -0.2944   0.2627  -0.9189]
        Angle     17.2322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3058"
}

Galaxy "IC 3059:UGC 7254:MCG 2-31-62:DDO 115"
{
        Type  "Irr"
        RA           12.2486
        Dec          13.4608
        Distance   2.682e+07  # method: V
        Radius          6241
        AbsMag        -15.17
        Axis    [  0.8377  -0.5135  -0.1860]
        Angle    116.8026
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3059"
}

Galaxy "IC 3060:MCG 2-31-61:ZWG 69.99:VCC 129"
{
        Type  "Sb"
        RA           12.2506
        Dec          12.5478
        Distance   1.851e+08  # distance uncertain!
        Radius     2.423e+04
        AbsMag        -19.07
        Axis    [  0.9342  -0.3483  -0.0767]
        Angle    114.1814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3060"
}

Galaxy "IC 3061:UGC 7255:MCG 2-31-63:ZWG 69.101"
{
        Type  "SBc"
        RA           12.2511
        Dec          14.0289
        Distance   1.197e+08  # method: V
        Radius     3.831e+04
        AbsMag        -18.42
        Axis    [ -0.4848   0.1931   0.8530]
        Angle     16.6110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3061"
}

Galaxy "IC 3062:MCG 2-31-65:ZWG 69.103:VCC 134"
{
        Type  "Sc"
        RA           12.2514
        Dec          13.5944
        Distance   3.713e+08  # method: V
        Radius      4.86e+04
        AbsMag        -20.58
        Axis    [  0.9325  -0.3527  -0.0778]
        Angle    108.1109
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3062"
}

Galaxy "IC 3063:UGC 7259:MCG 2-31-64:ZWG 69.102"
{
        Type  "Sa"
        RA           12.2517
        Dec          12.0161
        Distance   1.228e+08  # method: V
        Radius     1.786e+04
        AbsMag        -18.08
        Axis    [  0.9186  -0.3665  -0.1475]
        Angle     95.0463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3063"
}

Galaxy "IC 3065:MCG 3-31-82:ZWG 98.114:VCC 140"
{
        Type  "Sa"
        RA           12.2533
        Dec          14.4336
        Distance   6.338e+07  # method: V
        Radius     1.014e+04
        AbsMag        -16.94
        Axis    [  0.8757  -0.4633  -0.1363]
        Angle    115.2689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3065"
}

Galaxy "IC 3066:UGC 7262:MCG 2-31-68:ZWG 69.106"
{
        Type  "Sc"
        RA           12.2544
        Dec          13.4736
        Distance   3.189e+07  # method: V
        Radius          4638
        AbsMag        -14.45
        Axis    [ -0.8621   0.1730   0.4762]
        Angle     27.8247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3066"
}

Galaxy "IC 3068"
{
        Type  "Sc"
        RA           12.2564
        Dec          11.5111
        Distance   5.339e+08  # distance uncertain!
        Radius     4.659e+04
        AbsMag        -19.07
        Axis    [  0.9397  -0.2981  -0.1676]
        Angle     64.7407
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3068"
}

Galaxy "IC 3069"
{
        Type  "S0"
        RA           12.2553
        Dec          10.1608
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.7757  -0.1448  -0.6143]
        Angle     11.0884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3069"
}

Galaxy "IC 3073:UGC 7274:ZWG 69.109:VCC 155"
{
        Type  "Irr"
        RA           12.2597
        Dec          13.6197
        Distance   3.468e+08  # distance uncertain!
        Radius     5.044e+04
        AbsMag        -20.13
        Axis    [  0.8077  -0.2851  -0.5160]
        Angle     33.6708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3073"
}

Galaxy "IC 3074:UGC 7279:MCG 2-31-71:ZWG 69.111"
{
        Type  "SBc"
        RA           12.2628
        Dec          10.6986
        Distance   1.049e+08  # method: V
        Radius     3.508e+04
        AbsMag        -17.94
        Axis    [ -0.9692   0.1101   0.2205]
        Angle     47.5011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3074"
}

Galaxy "IC 3075:MCG 4-29-56:ZWG 128.66:NPM 1"
{
        Type  "Sc"
        RA           12.2653
        Dec          23.5961
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.9493  -0.3136   0.0217]
        Angle     53.3121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3075"
}

Galaxy "IC 3077:UGC 7285:MCG 3-31-85:ZWG 98.118"
{
        Type  "Sc"
        RA           12.2656
        Dec          14.4328
        Distance   7.869e+07  # method: V
        Radius      1.03e+04
        AbsMag        -17.11
        Axis    [  0.8525  -0.4972  -0.1616]
        Angle    116.0189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3077"
}

Galaxy "IC 3078:MCG 2-31-73:MK 764:ZWG 69.114"
{
        Type  "Sb"
        RA           12.2667
        Dec          12.6878
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.6049  -0.7119  -0.3568]
        Angle    127.3493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3078"
}

Galaxy "IC 3079:ZWG 69.116:VCC 177"
{
        Type  "SBa"
        RA           12.2678
        Dec          11.5350
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.8459  -0.4962  -0.1957]
        Angle    117.2882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3079"
}

Galaxy "IC 3080:ZWG 69.115:VCC 176:NPM 1"
{
        Type  "SBa"
        RA           12.2672
        Dec          14.1900
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.8233  -0.5339  -0.1926]
        Angle    117.0888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3080"
}

Galaxy "IC 3081:MCG 2-31-74:ZWG 69.117:VCC 178"
{
        Type  "Sa"
        RA           12.2692
        Dec          12.6911
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.7183  -0.2994  -0.6280]
        Angle     37.2172
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3081"
}

Galaxy "IC 3082"
{
        Type  "S0"
        RA           12.2700
        Dec          23.8419
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.9627  -0.2105   0.1697]
        Angle    105.1606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3082"
}

Galaxy "IC 3084:MCG 4-29-57:ZWG 128.67:NPM 1"
{
        Type  "S0"
        RA           12.2731
        Dec          23.9183
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.2632   0.4565  -0.8499]
        Angle     25.2642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3084"
}

Galaxy "IC 3089:MCG 4-29-58:ZWG 128.68:NPM 1"
{
        Type  "S0"
        RA           12.2747
        Dec          23.8283
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.8906  -0.4306  -0.1460]
        Angle     64.0217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3089"
}

Galaxy "IC 3091:MCG 2-31-77:ZWG 69.121:VCC 193"
{
        Type  "Sa"
        RA           12.2747
        Dec          14.0125
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [ -0.8191   0.3776  -0.4318]
        Angle     18.1878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3091"
}

Galaxy "IC 3092"
{
        Type  "S0"
        RA           12.2756
        Dec          10.0464
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [ -0.9130   0.2994  -0.2771]
        Angle     48.2212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3092"
}

Galaxy "IC 3093:ZWG 98.126:VCC 206:KUG 1214+145"
{
        Type  "Sc"
        RA           12.2783
        Dec          14.2783
        Distance   3.363e+08  # method: V
        Radius     1.956e+04
        AbsMag        -19.87
        Axis    [  0.8646  -0.4796  -0.1500]
        Angle    115.7371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3093"
}

Galaxy "IC 3094:UGC 7305:MCG 2-31-78:ZWG 69.123"
{
        Type  "S0"
        RA           12.2819
        Dec          13.6256
        Distance   7.746e+06  # method: V
        Radius         563.3
        AbsMag        -12.28
        Axis    [  0.6009  -0.7176  -0.3521]
        Angle    126.9377
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3094"
}

Galaxy "IC 3095:MCG 4-29-59:ZWG 128.69:KAZ 381"
{
        Type  "Sc"
        RA           12.2819
        Dec          23.9581
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8924  -0.0704   0.4457]
        Angle     26.6310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3095"
}

Galaxy "IC 3096:MCG 3-31-90:ZWG 98.128:VCC 209"
{
        Type  "S0"
        RA           12.2811
        Dec          14.5153
        Distance    2.33e+08  # distance uncertain!
        Radius     4.067e+04
        AbsMag        -19.07
        Axis    [  0.9819  -0.1308   0.1373]
        Angle     17.9950
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3096"
}

Galaxy "IC 3097:ZWG 69.124:VCC 216"
{
        Type  "E0"
        RA           12.2836
        Dec           9.4075
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.5486  -0.6588  -0.5147]
        Angle    116.7809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3097"
}

Galaxy "IC 3099:UGC 7313:MCG 2-31-79:ZWG 69.126"
{
        Type  "Sc"
        RA           12.2858
        Dec          12.4533
        Distance   1.115e+08  # method: V
        Radius     3.082e+04
        AbsMag        -17.87
        Axis    [ -0.9729   0.1285   0.1921]
        Angle     59.4376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3099"
}

Galaxy "IC 3100:UGC 7312:ZWG 69.125:VCC 218"
{
        Type  "E0"
        RA           12.2847
        Dec          12.2894
        Distance   4.258e+07  # method: V
        Radius          9290
        AbsMag        -15.78
        Axis    [  0.4133  -0.5015  -0.7600]
        Angle     92.0913
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3100"
}

Galaxy "IC 3101:ZWG 69.128:VCC 230"
{
        Type  "E0"
        RA           12.2886
        Dec          11.9433
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.5453  -0.6720  -0.5011]
        Angle    115.0676
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3101"
}

Galaxy "IC 3104:ESO 20-4:AM 1215-793"
{
        Type  "Irr"
        RA           12.3128
        Dec         -79.7308
        Distance   2.392e+07  # method: V
        Radius     1.287e+04
        AbsMag        -15.73
        Axis    [  0.4892   0.0108  -0.8721]
        Angle    117.8721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3104"
}

Galaxy "IC 3105:UGC 7326:MCG 2-31-80:ZWG 69.130"
{
        Type  "Irr"
        RA           12.2925
        Dec          12.3861
        Distance   7.656e+06  # method: V
        Radius          2116
        AbsMag        -12.25
        Axis    [  0.9787  -0.2038   0.0236]
        Angle     86.8360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3105"
}

Galaxy "IC 3107:UGC 7330:MCG 2-31-82:ZWG 69.133"
{
        Type  "Sc"
        RA           12.2964
        Dec          10.8447
        Distance   3.453e+08  # method: V
        Radius     7.031e+04
        AbsMag        -20.92
        Axis    [ -0.6735   0.2688  -0.6886]
        Angle     26.5505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3107"
}

Galaxy "IC 3108:MCG 2-31-81:ZWG 69.131:VCC 249"
{
        Type  "Sa"
        RA           12.2950
        Dec          13.3794
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.7924  -0.2716  -0.5462]
        Angle     28.5384
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3108"
}

Galaxy "IC 3109:MCG 2-31-81:ZWG 69.131:VCC 251"
{
        Type  "Sc"
        RA           12.2956
        Dec          13.1711
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.6007  -0.7162  -0.3551]
        Angle    127.2989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3109"
}

Galaxy "IC 3110:NPM 1"
{
        Type  "S0"
        RA           12.2956
        Dec          37.4003
        Distance   4.869e+08  # distance uncertain!
        Radius     3.895e+04
        AbsMag        -19.07
        Axis    [  0.8545  -0.5194   0.0101]
        Angle     66.8680
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3110"
}

Galaxy "IC 3111:ZWG 69.132:VCC 259:NPM 1"
{
        Type  "Sb"
        RA           12.2972
        Dec           8.4308
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.9126  -0.3548  -0.2031]
        Angle     91.2405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3111"
}

Galaxy "IC 3112:MCG 4-29-61:ZWG 128.71"
{
        Type  "S0"
        RA           12.2967
        Dec          26.0308
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.8735   0.4864   0.0210]
        Angle     57.2212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3112"
}

Galaxy "IC 3116:KUG 1215+253"
{
        Type  "S0"
        RA           12.2992
        Dec          25.0761
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.8170  -0.5648  -0.1164]
        Angle    104.0506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3116"
}

Galaxy "IC 3118:UGC 7339:MCG 2-31-83:ZWG 69.135"
{
        Type  "Irr"
        RA           12.3031
        Dec           9.5003
        Distance   2.884e+08  # distance uncertain!
        Radius     6.293e+04
        AbsMag        -20.13
        Axis    [ -0.9431   0.2736  -0.1890]
        Angle     57.2765
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3118"
}

Galaxy "IC 3119:ZWG 128.72:NPM 1:KUG 1215+249"
{
        Type  "S0"
        RA           12.3022
        Dec          24.6889
        Distance   2.802e+08  # distance uncertain!
        Radius     1.223e+04
        AbsMag        -19.07
        Axis    [  0.5655  -0.7733  -0.2867]
        Angle    121.0898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3119"
}

Galaxy "IC 3120:ZWG 69.137:VCC 281:KUG 1215+140"
{
        Type  "Sa"
        RA           12.3042
        Dec          13.7483
        Distance   2.637e+07  # method: V
        Radius          1534
        AbsMag        -13.94
        Axis    [  0.5983  -0.7197  -0.3521]
        Angle    127.0419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3120"
}

Galaxy "IC 3121:ZW 178"
{
        Type  "Irr"
        RA           12.3047
        Dec          13.2572
        Distance       1e+09  # distance uncertain!
        Radius     8.727e+04
        AbsMag        -20.13
        Axis    [ -0.7592   0.3295  -0.5613]
        Angle     19.6167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3121"
}

Galaxy "IC 3122:UGC 7341:MCG 4-29-62:ZWG 128.73"
{
        Type  "Sb"
        RA           12.3058
        Dec          25.2172
        Distance   2.967e+08  # method: T-F
        Radius     6.042e+04
        AbsMag        -20.09
        Axis    [ -0.7920   0.5829  -0.1815]
        Angle     37.9027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3122"
}

Galaxy "IC 3126"
{
        Type  "Sc"
        RA           12.3103
        Dec          13.8142
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.5975  -0.7205  -0.3519]
        Angle    127.0528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3126"
}

Galaxy "IC 3127:MCG 2-31-84:ZWG 69.138:ZWG 70.1"
{
        Type  "Sc"
        RA           12.3097
        Dec          11.8700
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [ -0.7308   0.4767  -0.4886]
        Angle     73.7414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3127"
}

Galaxy "IC 3128-1:MCG 2-31-85:ZWG 69.139:ZWG 70.2"
{
        Type  "Sc"
        RA           12.3114
        Dec          11.7314
        Distance   5.415e+08  # method: V
        Radius     4.726e+04
        AbsMag         -21.2
        Axis    [ -0.8361   0.3980  -0.3774]
        Angle     61.0681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3128-1"
}

Galaxy "IC 3128-2:MCG 2-31-86:ZWG 69.139:ZWG 70.2"
{
        Type  "E0"
        RA           12.3119
        Dec          11.7264
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.5815  -0.7222  -0.3746]
        Angle    129.3467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3128-2"
}

Galaxy "IC 3131:IC 3132:MCG 1-31-46:ZWG 42.3"
{
        Type  "Sa"
        RA           12.3139
        Dec           7.8614
        Distance   1.851e+08  # distance uncertain!
        Radius     3.769e+04
        AbsMag        -19.07
        Axis    [  0.6125  -0.6903  -0.3851]
        Angle    130.4576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3131"
}

Galaxy "IC 3134:ZWG 70.3:VCC 313:NPM 1"
{
        Type  "Sa"
        RA           12.3156
        Dec           8.9622
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [ -0.9601   0.2449  -0.1349]
        Angle     61.7529
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3134"
}

Galaxy "IC 3135:KUG 1216+277"
{
        Type  "Irr"
        RA           12.3147
        Dec          27.4919
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [ -0.3838   0.5952  -0.7060]
        Angle     25.8887
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3135"
}

Galaxy "IC 3136:UGC 7349:MCG 1-31-48:ZWG 42.5"
{
        Type  "SBc"
        RA           12.3158
        Dec           6.1836
        Distance   2.688e+08  # method: V
        Radius     3.518e+04
        AbsMag        -19.58
        Axis    [  0.9785  -0.1946  -0.0687]
        Angle     82.0584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3136"
}

Galaxy "IC 3137:UGC 7347:FGC 1407"
{
        Type  "Sc"
        RA           12.3150
        Dec          12.4694
        Distance   3.048e+08  # method: V
        Radius     4.876e+04
        AbsMag        -18.55
        Axis    [  0.9799  -0.1057   0.1693]
        Angle     71.0538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3137"
}

Galaxy "IC 3138-1"
{
        Type  "S0"
        RA           12.3156
        Dec          12.4453
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.8415  -0.3873  -0.3766]
        Angle     58.5569
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3138-1"
}

Galaxy "IC 3138-2"
{
        Type  "S0"
        RA           12.3156
        Dec          12.4422
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [ -0.9273   0.3312  -0.1743]
        Angle     62.1803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3138-2"
}

Galaxy "IC 3141:ZWG 128.74"
{
        Type  "S0"
        RA           12.3161
        Dec          24.1864
        Distance   5.748e+08  # method: T-F
        Radius     7.524e+04
        AbsMag        -20.73
        Axis    [  0.9522  -0.2573   0.1648]
        Angle     79.6605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3141"
}

Galaxy "IC 3142-1:UGC 7355:MCG 2-31-89:ZWG 70.6"
{
        Type  "E0"
        RA           12.3169
        Dec          13.9817
        Distance    6.31e+08  # distance uncertain!
        Radius     4.589e+04
        AbsMag        -20.13
        Axis    [  0.5747  -0.7337  -0.3625]
        Angle    128.0821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3142-1"
}

Galaxy "IC 3142-2:UGC 7355:MCG 2-31-90:ZWG 70.6"
{
        Type  "SBa"
        RA           12.3181
        Dec          13.9806
        Distance   5.391e+06  # method: V
        Radius         548.8
        AbsMag        -10.79
        Axis    [ -0.7278   0.3517  -0.5887]
        Angle     26.2754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3142-2"
}

Galaxy "IC 3143:ZWG 158.62:KUG 1216+275"
{
        Type  "S0"
        RA           12.3181
        Dec          27.2981
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.7068   0.6356  -0.3106]
        Angle     39.5074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3143"
}

Galaxy "IC 3144:NPM 1:KUG 1216+255"
{
        Type  "S0"
        RA           12.3192
        Dec          25.2975
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.5617  -0.7773  -0.2834]
        Angle    120.9239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3144"
}

Galaxy "IC 3146:KUG 1216+259"
{
        Type  "S0"
        RA           12.3200
        Dec          25.7147
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.5602  -0.7793  -0.2807]
        Angle    120.7147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3146"
}

Galaxy "IC 3147-1:MCG 2-31-91:ZWG 70.7:VCC 337"
{
        Type  "S0"
        RA           12.3214
        Dec          12.0167
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.6012  -0.7121  -0.3625]
        Angle    128.1472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3147-1"
}

Galaxy "IC 3147-2:MCG 2-31-92:ZWG 70.7:VCC 337"
{
        Type  "S0"
        RA           12.3217
        Dec          12.0183
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8049  -0.3699  -0.4640]
        Angle     49.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3147-2"
}

Galaxy "IC 3148:MCG 1-31-55:ZWG 42.16:VCC 343"
{
        Type  "SBc"
        RA           12.3225
        Dec           7.8706
        Distance   1.276e+08  # method: V
        Radius     1.299e+04
        AbsMag        -17.76
        Axis    [  0.6116  -0.6909  -0.3854]
        Angle    130.5144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3148"
}

Galaxy "IC 3149:MCG 2-31-93:ZWG 70.9:VCC 348"
{
        Type  "SBa"
        RA           12.3233
        Dec          12.3014
        Distance   3.831e+08  # method: V
        Radius     4.457e+04
        AbsMag        -20.25
        Axis    [  0.7952  -0.5594  -0.2339]
        Angle    119.1105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3149"
}

Galaxy "IC 3150:ZWG 42.17:VCC 352:NPM 1"
{
        Type  "S0"
        RA           12.3244
        Dec           7.7989
        Distance   3.446e+08  # method: V
        Radius     2.005e+04
        AbsMag        -19.82
        Axis    [  0.9307  -0.3016  -0.2072]
        Angle     70.6355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3150"
}

Galaxy "IC 3151:MCG 2-32-2:ZWG 70.10:VCC 356"
{
        Type  "SBa"
        RA           12.3256
        Dec           9.4147
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.6297   0.1628  -0.7596]
        Angle     18.6747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3151"
}

Galaxy "IC 3152:ESO 506-1:MCG 4-29-18"
{
        Type  "S0"
        RA           12.3264
        Dec         -26.1447
        Distance    1.66e+08  # method: V
        Radius     4.345e+04
        AbsMag        -20.13
        Axis    [  0.6645  -0.2447  -0.7061]
        Angle     87.3479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3152"
}

Galaxy "IC 3153:ZWG 42.19:VCC 359:NPM 1"
{
        Type  "Sc"
        RA           12.3267
        Dec           5.3983
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.6170  -0.6784  -0.3988]
        Angle    131.9721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3153"
}

Galaxy "IC 3154:NPM 1"
{
        Type  "E0"
        RA           12.3258
        Dec          25.5864
        Distance   5.755e+08  # distance uncertain!
        Radius     3.348e+04
        AbsMag        -20.13
        Axis    [  0.1512  -0.0627  -0.9865]
        Angle     64.8784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3154"
}

Galaxy "IC 3155:MCG 1-32-3:ZWG 42.22:VCC 366"
{
        Type  "S0"
        RA           12.3292
        Dec           6.0064
        Distance   1.191e+08  # method: V
        Radius     2.078e+04
        AbsMag        -17.61
        Axis    [  0.9349  -0.2942  -0.1983]
        Angle     80.7662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3155"
}

Galaxy "IC 3156:MCG 2-32-3:ZWG 70.11:VCC 363"
{
        Type  "SBa"
        RA           12.3289
        Dec           9.1486
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.7648  -0.4788  -0.4311]
        Angle     84.7556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3156"
}

Galaxy "IC 3157:ZWG 70.12:VCC 374"
{
        Type  "Sa"
        RA           12.3297
        Dec          12.4222
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [  0.3177  -0.0686  -0.9457]
        Angle     12.1778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3157"
}

Galaxy "IC 3159"
{
        Type  "SBa"
        RA           12.3314
        Dec          11.6744
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [  0.9112  -0.3754  -0.1695]
        Angle     90.5951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3159"
}

Galaxy "IC 3165:UGC 7384:MCG 5-29-61:ZWG 158.76"
{
        Type  "SBb"
        RA           12.3344
        Dec          27.9750
        Distance   3.898e+08  # method: V
        Radius     1.077e+05
        AbsMag        -20.79
        Axis    [  0.8923  -0.4498   0.0389]
        Angle    108.0456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3165"
}

Galaxy "IC 3167:ZWG 70.17:VCC 407"
{
        Type  "S0"
        RA           12.3383
        Dec           9.5453
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.8120  -0.2912  -0.5057]
        Angle     27.8358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3167"
}

Galaxy "IC 3168:MCG 5-29-64:ZWG 158.79:KUG 1217+281"
{
        Type  "SBa"
        RA           12.3383
        Dec          27.9197
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.9016  -0.4311  -0.0356]
        Angle     63.3187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3168"
}

Galaxy "IC 3169"
{
        Type  "E0"
        RA           12.3392
        Dec          25.5994
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [ -0.0650   0.2677  -0.9613]
        Angle     67.4131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3169"
}

Galaxy "IC 3170:MCG 2-32-7:ZWG 70.18:VCC 417"
{
        Type  "Sc"
        RA           12.3406
        Dec           9.4244
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [  0.6060  -0.7002  -0.3776]
        Angle    129.7580
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3170"
}

Galaxy "IC 3171:MCG 4-29-65:ZWG 128.78:NPM 1"
{
        Type  "E0"
        RA           12.3400
        Dec          25.5611
        Distance   3.287e+08  # method: V
        Radius     3.824e+04
        AbsMag        -20.32
        Axis    [  0.4303  -0.5536  -0.7130]
        Angle     79.9240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3171"
}

Galaxy "IC 3172"
{
        Type  "E0"
        RA           12.3400
        Dec          27.8192
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.5268  -0.7957  -0.2990]
        Angle    118.2456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3172"
}

Galaxy "IC 3173:ZWG 70.21:VCC 420:NPM 1"
{
        Type  "Sa"
        RA           12.3417
        Dec          11.3414
        Distance   2.226e+08  # distance uncertain!
        Radius          9711
        AbsMag        -19.07
        Axis    [  0.6324  -0.2981  -0.7150]
        Angle     34.5442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3173"
}

Galaxy "IC 3174:ZWG 70.20:VCC 419:NPM 1"
{
        Type  "Sb"
        RA           12.3414
        Dec          10.2456
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.8122   0.2428  -0.5304]
        Angle     24.8893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3174"
}

Galaxy "IC 3175:ZWG 70.19:VCC 424"
{
        Type  "Sb"
        RA           12.3425
        Dec           9.8539
        Distance   2.824e+08  # method: V
        Radius     2.053e+04
        AbsMag        -19.39
        Axis    [  0.9613  -0.2572  -0.0985]
        Angle     64.3065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3175"
}

Galaxy "IC 3176"
{
        Type  "S0"
        RA           12.3417
        Dec          25.5153
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.8687   0.4790   0.1262]
        Angle     42.3205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3176"
}

Galaxy "IC 3179:KUG 1218+264"
{
        Type  "E0"
        RA           12.3436
        Dec          26.1653
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5334  -0.7938  -0.2920]
        Angle    121.5522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3179"
}

Galaxy "IC 3184-1:ZWG 128.79:KUG 1218+251"
{
        Type  "S0"
        RA           12.3461
        Dec          24.9156
        Distance   3.063e+08  # method: T-F
        Radius     2.673e+04
        AbsMag        -19.06
        Axis    [  0.9326  -0.3580   0.0462]
        Angle     68.5976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3184-1"
}

Galaxy "IC 3184-2:ZWG 128.79"
{
        Type  "S0"
        RA           12.3464
        Dec          24.9175
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [  0.7608  -0.1306  -0.6357]
        Angle     18.6980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3184-2"
}

Galaxy "IC 3185:ZWG 128.81:KUG 1218+257"
{
        Type  "S0"
        RA           12.3478
        Dec          25.4294
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.8202  -0.0374   0.5708]
        Angle     23.3815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3185"
}

Galaxy "IC 3186:MCG 4-29-66:ZWG 128.80"
{
        Type  "Sb"
        RA           12.3486
        Dec          24.6692
        Distance   3.464e+08  # method: V
        Radius     3.023e+04
        AbsMag        -19.33
        Axis    [ -0.7877   0.5675  -0.2396]
        Angle     59.5983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3186"
}

Galaxy "IC 3187:ZWG 70.23:VCC 443"
{
        Type  "Sc"
        RA           12.3483
        Dec          11.1614
        Distance   2.555e+08  # distance uncertain!
        Radius      2.23e+04
        AbsMag        -19.07
        Axis    [  0.7878  -0.2782  -0.5495]
        Angle     22.7667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3187"
}

Galaxy "IC 3188:MCG 2-32-8:ZWG 70.22:VCC 442"
{
        Type  "Sc"
        RA           12.3486
        Dec          11.0086
        Distance   2.597e+08  # method: V
        Radius     2.266e+04
        AbsMag        -19.31
        Axis    [  0.8518  -0.3992  -0.3392]
        Angle     67.4589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3188"
}

Galaxy "IC 3189"
{
        Type  "Sc"
        RA           12.3489
        Dec          25.4264
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.8361  -0.2241  -0.5008]
        Angle     22.1672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3189"
}

Galaxy "IC 3192:VCC 452"
{
        Type  "E0"
        RA           12.3511
        Dec          11.7539
        Distance   5.012e+08  # distance uncertain!
        Radius     4.374e+04
        AbsMag        -20.13
        Axis    [  0.5774  -0.7248  -0.3758]
        Angle    129.6331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3192"
}

Galaxy "IC 3193:MCG 5-29-67:ZWG 158.84"
{
        Type  "Sc"
        RA           12.3503
        Dec          27.8986
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.6925   0.5115   0.5088]
        Angle     26.4519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3193"
}

Galaxy "IC 3194"
{
        Type  "E0"
        RA           12.3525
        Dec          25.1336
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.3215   0.6171  -0.7182]
        Angle     86.1091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3194"
}

Galaxy "IC 3195"
{
        Type  "E0"
        RA           12.3547
        Dec          25.8081
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.5336  -0.7928  -0.2945]
        Angle    121.8446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3195"
}

Galaxy "IC 3196"
{
        Type  "S0"
        RA           12.3572
        Dec          11.7578
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.6015  -0.3339  -0.7258]
        Angle     42.7012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3196"
}

Galaxy "IC 3199:UGC 7417:ZWG 70.26:VCC 500"
{
        Type  "SBa"
        RA           12.3625
        Dec          10.5961
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.8849   0.3469  -0.3107]
        Angle     59.1821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3199"
}

Galaxy "IC 3200"
{
        Type  "E0"
        RA           12.3603
        Dec          26.7608
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.5239  -0.7774  -0.3480]
        Angle    113.5103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3200"
}

Galaxy "IC 3201:NPM 1"
{
        Type  "E0"
        RA           12.3611
        Dec          25.7261
        Distance   8.318e+08  # distance uncertain!
        Radius      3.63e+04
        AbsMag        -20.13
        Axis    [  0.5332  -0.7928  -0.2951]
        Angle    121.9468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3201"
}

Galaxy "IC 3202:NPM 1"
{
        Type  "E0"
        RA           12.3622
        Dec          27.0575
        Distance   1.047e+09  # distance uncertain!
        Radius     4.569e+04
        AbsMag        -20.13
        Axis    [  0.5284  -0.7990  -0.2869]
        Angle    121.2503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3202"
}

Galaxy "IC 3203:UGC 7419:MCG 4-29-67:ZWG 128.82"
{
        Type  "Sb"
        RA           12.3625
        Dec          25.8842
        Distance   4.513e+08  # method: T-F
        Radius     9.846e+04
        AbsMag         -20.1
        Axis    [ -0.7442   0.3089   0.5922]
        Angle     39.9978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3203"
}

Galaxy "IC 3204:KUG 1219+245"
{
        Type  "S0"
        RA           12.3639
        Dec          24.2489
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [  0.0888   0.3458  -0.9341]
        Angle     14.0723
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3204"
}

Galaxy "IC 3205:ZWG 158.86:NPM 1"
{
        Type  "E0"
        RA           12.3639
        Dec          26.3414
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.5308  -0.7958  -0.2914]
        Angle    121.6450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3205"
}

Galaxy "IC 3206:ZWG 158.87:KUG 1219+266"
{
        Type  "S0"
        RA           12.3642
        Dec          26.3642
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.1654   0.9599   0.2261]
        Angle      6.0247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3206"
}

Galaxy "IC 3207"
{
        Type  "S0"
        RA           12.3644
        Dec          24.3544
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.8261  -0.0765   0.5583]
        Angle     29.0663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3207"
}

Galaxy "IC 3208:UGC 7421:VCC 512"
{
        Type  "Irr"
        RA           12.3653
        Dec          11.9669
        Distance   2.202e+07  # method: V
        Radius          3843
        AbsMag        -13.85
        Axis    [  0.9525  -0.2777  -0.1249]
        Angle     44.4015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3208"
}

Galaxy "IC 3209:ZWG 70.30:VCC 527"
{
        Type  "Sc"
        RA           12.3683
        Dec          11.7547
        Distance   3.551e+08  # method: V
        Radius     4.131e+04
        AbsMag        -19.98
        Axis    [ -0.9767   0.1550   0.1484]
        Angle     46.5011
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3209"
}

Galaxy "IC 3210:MCG 5-29-70:ZWG 158.89"
{
        Type  "Sa"
        RA           12.3667
        Dec          28.4311
        Distance   3.837e+08  # method: V
        Radius     2.233e+04
        AbsMag        -19.85
        Axis    [  0.8329  -0.4013  -0.3811]
        Angle     36.6088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3210"
}

Galaxy "IC 3211:NGC 4307A:UGC 7430:MCG 2-23-12"
{
        Type  "Irr"
        RA           12.3686
        Dec           8.9906
        Distance   2.856e+08  # method: V
        Radius     3.323e+04
        AbsMag        -19.81
        Axis    [  0.6042  -0.6998  -0.3810]
        Angle    130.2110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3211"
}

Galaxy "IC 3212:MCG 5-29-71:ZWG 158.91"
{
        Type  "Sc"
        RA           12.3675
        Dec          28.1858
        Distance   3.576e+08  # method: V
        Radius       2.6e+04
        AbsMag         -19.5
        Axis    [  0.5470  -0.7937  -0.2660]
        Angle    119.8868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3212"
}

Galaxy "IC 3213:ZWG 128.83"
{
        Type  "S0"
        RA           12.3686
        Dec          23.8689
        Distance   2.676e+08  # distance uncertain!
        Radius      4.67e+04
        AbsMag        -19.07
        Axis    [  0.8986  -0.4388   0.0004]
        Angle    113.5487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3213"
}

Galaxy "IC 3215:UGC 7434:MCG 4-29-68:ZWG 128.84"
{
        Type  "Irr"
        RA           12.3694
        Dec          26.0517
        Distance   5.943e+07  # method: V
        Radius     1.556e+04
        AbsMag         -15.9
        Axis    [  0.7668  -0.0414   0.6405]
        Angle     28.9178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3215"
}

Galaxy "IC 3216"
{
        Type  "E0"
        RA           12.3697
        Dec          25.2867
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5339  -0.7913  -0.2980]
        Angle    122.2599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3216"
}

Galaxy "IC 3217-1"
{
        Type  "S0"
        RA           12.3703
        Dec          26.3858
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8666  -0.4986  -0.0211]
        Angle    108.3786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3217-1"
}

Galaxy "IC 3217-2"
{
        Type  "S0"
        RA           12.3703
        Dec          26.3881
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9408  -0.2607   0.2165]
        Angle     70.4494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3217-2"
}

Galaxy "IC 3218:MCG 1-32-26:ZWG 42.52:VCC 542"
{
        Type  "E0"
        RA           12.3719
        Dec           6.9272
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.5880  -0.7018  -0.4022]
        Angle    132.6021
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3218"
}

Galaxy "IC 3219"
{
        Type  "S0"
        RA           12.3708
        Dec          25.9511
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.9610  -0.1876   0.2034]
        Angle    111.8552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3219"
}

Galaxy "IC 3220:VCC 546"
{
        Type  "E0"
        RA           12.3725
        Dec          10.6011
        Distance   5.012e+08  # distance uncertain!
        Radius      7.29e+04
        AbsMag        -20.13
        Axis    [  0.5696  -0.7102  -0.4138]
        Angle    126.8866
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3220"
}

Galaxy "IC 3221"
{
        Type  "S0"
        RA           12.3722
        Dec          25.2833
        Distance    4.65e+08  # distance uncertain!
        Radius     2.029e+04
        AbsMag        -19.07
        Axis    [ -0.6664   0.4886   0.5631]
        Angle     20.8701
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3221"
}

Galaxy "IC 3222:UGC 7437:MCG 5-29-73:IRAS 12198+2906"
{
        Type  "SBc"
        RA           12.3719
        Dec          28.8314
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.8648  -0.5019  -0.0121]
        Angle     96.1751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3222"
}

Galaxy "IC 3224:VCC 562:ZW 183:A 1220+12"
{
        Type  "Irr"
        RA           12.3767
        Dec          12.1583
        Distance   3.031e+07  # method: V
        Radius          1763
        AbsMag        -13.44
        Axis    [  0.7261  -0.4072  -0.5541]
        Angle     53.5777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3224"
}

Galaxy "IC 3225:UGC 7441:MCG 1-32-28:ZWG 42.54"
{
        Type  "Irr"
        RA           12.3775
        Dec           6.6764
        Distance   1.225e+08  # method: V
        Radius     3.207e+04
        AbsMag        -18.47
        Axis    [  0.9746  -0.2116  -0.0727]
        Angle     74.1982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3225"
}

Galaxy "IC 3227:KAZ 385:NPM 1:KUG 1220+243"
{
        Type  "S0"
        RA           12.3764
        Dec          24.0858
        Distance   5.098e+08  # distance uncertain!
        Radius     2.966e+04
        AbsMag        -19.07
        Axis    [  0.9193  -0.3920   0.0366]
        Angle    113.6947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3227"
}

Galaxy "IC 3228"
{
        Type  "S0"
        RA           12.3775
        Dec          24.3300
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.7302   0.4043   0.5508]
        Angle     26.2327
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3228"
}

Galaxy "IC 3229:UGC 7448:MCG 1-32-30:ZWG 42.61"
{
        Type  "Sc"
        RA           12.3811
        Dec           6.6800
        Distance   8.503e+07  # method: V
        Radius     1.237e+04
        AbsMag        -16.88
        Axis    [  0.9798  -0.1945  -0.0457]
        Angle     67.0642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3229"
}

Galaxy "IC 3230:KUG 1220+280:KUG 1220+280"
{
        Type  "S0"
        RA           12.3775
        Dec          27.7467
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [  0.8964  -0.2960  -0.3300]
        Angle     25.5278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3230"
}

Galaxy "IC 3231"
{
        Type  "S0"
        RA           12.3786
        Dec          24.8206
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8107  -0.5599  -0.1711]
        Angle     90.3055
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3231"
}

Galaxy "IC 3233:KUG 1220+128"
{
        Type  "S0"
        RA           12.3817
        Dec          12.5664
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.9709  -0.2361   0.0393]
        Angle     24.1089
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3233"
}

Galaxy "IC 3234"
{
        Type  "E0"
        RA           12.3811
        Dec          28.1128
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5228  -0.8049  -0.2807]
        Angle    120.8721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3234"
}

Galaxy "IC 3235"
{
        Type  "S0"
        RA           12.3825
        Dec          13.5453
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [ -0.7024   0.3142  -0.6387]
        Angle     27.2796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3235"
}

Galaxy "IC 3236"
{
        Type  "S0"
        RA           12.3833
        Dec          10.1017
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [ -0.1528   0.0529  -0.9868]
        Angle     38.0943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3236"
}

Galaxy "IC 3237"
{
        Type  "S0"
        RA           12.3828
        Dec          28.4939
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.8850  -0.4574  -0.0866]
        Angle     58.7655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3237"
}

Galaxy "IC 3238:MCG 3-32-17:ZWG 99.32:VCC 617"
{
        Type  "S0"
        RA           12.3850
        Dec          14.4589
        Distance   2.226e+08  # distance uncertain!
        Radius     1.295e+04
        AbsMag        -19.07
        Axis    [  0.5883  -0.7286  -0.3507]
        Angle    127.2840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3238"
}

Galaxy "IC 3239:ZWG 70.38:VCC 620"
{
        Type  "Irr"
        RA           12.3858
        Dec          11.7258
        Distance   4.861e+07  # method: V
        Radius          5656
        AbsMag        -15.47
        Axis    [ -0.9696   0.2367  -0.0615]
        Angle     40.9864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3239"
}

Galaxy "IC 3240"
{
        Type  "E0"
        RA           12.3853
        Dec          10.3619
        Distance   7.944e+08  # distance uncertain!
        Radius     5.777e+04
        AbsMag        -20.13
        Axis    [  0.2642  -0.3468  -0.9000]
        Angle     84.5115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3240"
}

Galaxy "IC 3241:NPM 1"
{
        Type  "E0"
        RA           12.3856
        Dec          26.9058
        Distance       1e+09  # distance uncertain!
        Radius     5.818e+04
        AbsMag        -20.13
        Axis    [  0.5208  -0.7798  -0.3474]
        Angle    113.6454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3241"
}

Galaxy "IC 3242"
{
        Type  "E0"
        RA           12.3861
        Dec          26.2494
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [ -0.3168   0.6250  -0.7134]
        Angle     85.1889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3242"
}

Galaxy "IC 3243:ZWG 158.95"
{
        Type  "S0"
        RA           12.3864
        Dec          27.7656
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.9153  -0.4025   0.0154]
        Angle     59.5963
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3243"
}

Galaxy "IC 3244:MCG 3-32-18:ZWG 99.33:VCC 627"
{
        Type  "Sc"
        RA           12.3867
        Dec          14.3892
        Distance   5.982e+08  # method: V
        Radius      6.96e+04
        AbsMag        -21.22
        Axis    [  0.8089  -0.3599  -0.4650]
        Angle     38.6868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3244"
}

Galaxy "IC 3246"
{
        Type  "E0"
        RA           12.3881
        Dec          13.0517
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.5701  -0.7336  -0.3699]
        Angle    129.1771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3246"
}

Galaxy "IC 3247:UGC 7459:MCG 5-29-77:ZWG 158.96"
{
        Type  "Sc"
        RA           12.3872
        Dec          28.8931
        Distance   2.676e+08  # distance uncertain!
        Radius     8.562e+04
        AbsMag        -19.07
        Axis    [ -0.8855   0.3173   0.3393]
        Angle     66.2731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3247"
}

Galaxy "IC 3249"
{
        Type  "E0"
        RA           12.3881
        Dec          25.4444
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.5245  -0.7730  -0.3569]
        Angle    114.5084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3249"
}

Galaxy "IC 3253:ESO 380-24:MCG 6-27-21:IRAS 12211-3420"
{
        Type  "Sc"
        RA           12.3958
        Dec         -34.6214
        Distance   2.657e+08  # method: T-F
        Radius     1.043e+05
        AbsMag        -21.75
        Axis    [  0.8573  -0.0539  -0.5120]
        Angle    102.3046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3253"
}

Galaxy "IC 3255:ZWG 70.40:VCC 649:ZW 185"
{
        Type  "Sc"
        RA           12.3928
        Dec           9.6489
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.0876  -0.0974  -0.9914]
        Angle     33.6753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3255"
}

Galaxy "IC 3258:UGC 7470:MCG 2-32-21:ZWG 70.42"
{
        Type  "Irr"
        RA           12.3956
        Dec          12.4786
        Distance    1.82e+08  # distance uncertain!
        Radius     4.235e+04
        AbsMag        -20.13
        Axis    [  0.1138  -0.0838  -0.9900]
        Angle     37.0607
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3258"
}

Galaxy "IC 3259:UGC 7469:MCG 1-32-40:ZWG 42.72"
{
        Type  "Irr"
        RA           12.3967
        Dec           7.1864
        Distance   7.964e+07  # method: V
        Radius     1.969e+04
        AbsMag        -17.74
        Axis    [  0.9338  -0.3230  -0.1541]
        Angle    100.6408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3259"
}

Galaxy "IC 3261:VCC 679"
{
        Type  "Sa"
        RA           12.3978
        Dec          11.4808
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.8157  -0.3000  -0.4946]
        Angle     16.3004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3261"
}

Galaxy "IC 3262:ZWG 158.97"
{
        Type  "Sb"
        RA           12.3967
        Dec          27.3944
        Distance   3.459e+08  # method: V
        Radius     4.025e+04
        AbsMag        -19.83
        Axis    [ -0.8329   0.5534   0.0096]
        Angle     41.8088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3262"
}

Galaxy "IC 3263:MCG 5-29-78:ZWG 158.98"
{
        Type  "S0"
        RA           12.3972
        Dec          28.1986
        Distance   3.657e+08  # method: V
        Radius     3.723e+04
        AbsMag        -20.15
        Axis    [  0.2109   0.1032  -0.9720]
        Angle     27.7077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3263"
}

Galaxy "IC 3264"
{
        Type  "E0"
        RA           12.3975
        Dec          25.5569
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5301  -0.7942  -0.2970]
        Angle    122.3698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3264"
}

Galaxy "IC 3267:UGC 7474:MCG 1-32-44:ZWG 42.79"
{
        Type  "Sc"
        RA           12.4014
        Dec           7.0406
        Distance   7.121e+07  # method: V
        Radius     1.243e+04
        AbsMag         -17.6
        Axis    [  0.6057  -0.6919  -0.3929]
        Angle    131.5564
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3267"
}

Galaxy "IC 3268:UGC 7477:MCG 1-32-45:ZWG 42.80"
{
        Type  "Sc"
        RA           12.4019
        Dec           6.6069
        Distance    4.82e+07  # method: V
        Radius          6309
        AbsMag        -16.65
        Axis    [  0.6687  -0.4859  -0.5628]
        Angle     82.4729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3268"
}

Galaxy "IC 3269"
{
        Type  "S0"
        RA           12.4011
        Dec          27.4347
        Distance   5.339e+08  # distance uncertain!
        Radius     3.882e+04
        AbsMag        -19.07
        Axis    [ -0.8194   0.5616  -0.1149]
        Angle     64.0796
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3269"
}

Galaxy "IC 3270"
{
        Type  "SBa"
        RA           12.4014
        Dec          27.5775
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8000  -0.5162  -0.3059]
        Angle     56.6697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3270"
}

Galaxy "IC 3271:UGC 7481:MCG 1-32-47:ZWG 42.82"
{
        Type  "Sc"
        RA           12.4036
        Dec           7.9525
        Distance   3.419e+08  # method: V
        Radius     4.973e+04
        AbsMag         -20.6
        Axis    [  0.6033  -0.6968  -0.3880]
        Angle    131.0551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3271"
}

Galaxy "IC 3272"
{
        Type  "S0"
        RA           12.4025
        Dec          23.2850
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [ -0.8021   0.5409  -0.2530]
        Angle     37.5920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3272"
}

Galaxy "IC 3274:NGC 4360B:MCG 2-32-27:ZWG 70.60"
{
        Type  "E0"
        RA           12.4039
        Dec           9.2672
        Distance   3.238e+08  # method: V
        Radius     2.355e+04
        AbsMag        -19.68
        Axis    [  0.5787  -0.7157  -0.3910]
        Angle    131.4731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3274"
}

Galaxy "IC 3275"
{
        Type  "S0"
        RA           12.4053
        Dec          10.4464
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.8149  -0.3631  -0.4517]
        Angle     44.1210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3275"
}

Galaxy "IC 3276"
{
        Type  "E0"
        RA           12.4039
        Dec          25.8183
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.2617  -0.2748  -0.9252]
        Angle     66.9578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3276"
}

Galaxy "IC 3277"
{
        Type  "S0"
        RA           12.4042
        Dec          25.5636
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [ -0.7666   0.5835  -0.2681]
        Angle     48.3635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3277"
}

Galaxy "IC 3278:KUG 1221+276"
{
        Type  "S0"
        RA           12.4042
        Dec          27.4222
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.8261  -0.5614  -0.0487]
        Angle    113.6425
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3278"
}

Galaxy "IC 3280:MCG 2-32-30:ZWG 70.54:VCC 729"
{
        Type  "Sc"
        RA           12.4072
        Dec          13.2333
        Distance   3.609e+08  # method: V
        Radius     4.724e+04
        AbsMag        -20.32
        Axis    [  0.8440  -0.5051  -0.1803]
        Angle    117.1875
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3280"
}

Galaxy "IC 3283"
{
        Type  "S0"
        RA           12.4078
        Dec          27.2117
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9001  -0.4354  -0.0154]
        Angle     68.7054
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3283"
}

Galaxy "IC 3284:ZWG 70.55:VCC 736"
{
        Type  "SBa"
        RA           12.4103
        Dec          10.8386
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.5954  -0.7120  -0.3722]
        Angle    129.4835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3284"
}

Galaxy "IC 3286"
{
        Type  "E0"
        RA           12.4094
        Dec          23.7478
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.4165  -0.5551  -0.7200]
        Angle     81.6660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3286"
}

Galaxy "IC 3287"
{
        Type  "S0"
        RA           12.4103
        Dec          24.5947
        Distance   8.461e+08  # distance uncertain!
        Radius     2.461e+04
        AbsMag        -19.07
        Axis    [  0.5550  -0.7796  -0.2901]
        Angle    122.1074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3287"
}

Galaxy "IC 3288"
{
        Type  "E0"
        RA           12.4108
        Dec          24.9492
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.0077   0.1235  -0.9923]
        Angle     65.3654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3288"
}

Galaxy "IC 3289:ESO 506-7:MCG 4-29-23:AM 1222-254"
{
        Type  "S0"
        RA           12.4158
        Dec         -26.0303
        Distance   1.651e+08  # method: V
        Radius     2.401e+04
        AbsMag        -19.42
        Axis    [  0.6597  -0.5135  -0.5488]
        Angle    151.6079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3289"
}

Galaxy "IC 3290:ESO 322-4:MCG 6-27-24:AM 1222-392"
{
        Type  "SBa"
        RA           12.4189
        Dec         -39.7758
        Distance   1.644e+08  # method: V
        Radius     4.782e+04
        AbsMag        -20.51
        Axis    [  0.6334  -0.2064  -0.7458]
        Angle    104.4566
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3290"
}

Galaxy "IC 3291:NPM 1"
{
        Type  "E0"
        RA           12.4133
        Dec          12.0192
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.3865  -0.5042  -0.7723]
        Angle     91.6209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3291"
}

Galaxy "IC 3292:ZWG 99.39:VCC 751:NPM 1"
{
        Type  "Sa"
        RA           12.4133
        Dec          18.1956
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.8231  -0.5472  -0.1520]
        Angle    116.2404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3292"
}

Galaxy "IC 3293"
{
        Type  "Irr"
        RA           12.4147
        Dec          17.4325
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.7623  -0.4360  -0.4784]
        Angle     50.7179
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3293"
}

Galaxy "IC 3296:ZWG 128.86:KARA 529:NPM 1"
{
        Type  "E0"
        RA           12.4158
        Dec          24.3833
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [  0.2378  -0.2516  -0.9382]
        Angle     67.7391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3296"
}

Galaxy "IC 3298:MCG 3-32-24:ZWG 99.40:VCC 768"
{
        Type  "SBc"
        RA           12.4175
        Dec          17.0153
        Distance   1.254e+08  # method: V
        Radius     2.007e+04
        AbsMag        -17.72
        Axis    [ -0.9500   0.2437   0.1952]
        Angle     46.7752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3298"
}

Galaxy "IC 3299:NPM 1"
{
        Type  "S0"
        RA           12.4175
        Dec          27.3750
        Distance   8.461e+08  # distance uncertain!
        Radius     4.923e+04
        AbsMag        -19.07
        Axis    [  0.9203  -0.3834   0.0777]
        Angle     73.9778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3299"
}

Galaxy "IC 3300:UGC 7495:MCG 4-29-70:ZWG 128.87"
{
        Type  "Sc"
        RA           12.4178
        Dec          25.9567
        Distance   3.154e+08  # method: V
        Radius     4.588e+04
        AbsMag        -19.63
        Axis    [  0.8851  -0.1649   0.4352]
        Angle     39.0806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3300"
}

Galaxy "IC 3301:IC 3307:VCC 790"
{
        Type  "E0"
        RA           12.4214
        Dec          14.1719
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [  0.5635  -0.7412  -0.3646]
        Angle    128.8073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3301"
}

Galaxy "IC 3302"
{
        Type  "E0"
        RA           12.4194
        Dec          25.8786
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.5268  -0.7970  -0.2955]
        Angle    122.4013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3302"
}

Galaxy "IC 3303:UGC 7500:MCG 2-32-35:ZWG 70.60"
{
        Type  "E0"
        RA           12.4208
        Dec          12.7150
        Distance   5.074e+06  # method: V
        Radius         737.9
        AbsMag        -11.26
        Axis    [  0.3142  -0.4156  -0.8535]
        Angle     85.0147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3303"
}

Galaxy "IC 3304"
{
        Type  "Irr"
        RA           12.4197
        Dec          25.4236
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5513  -0.7841  -0.2851]
        Angle    121.7688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3304"
}

Galaxy "IC 3305:UGC 7499:MCG 2-32-36:ZWG 70.59"
{
        Type  "S0"
        RA           12.4206
        Dec          11.8497
        Distance   1.155e+08  # method: V
        Radius     2.016e+04
        AbsMag        -17.65
        Axis    [  0.9712  -0.2381  -0.0014]
        Angle     70.2117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3305"
}

Galaxy "IC 3306"
{
        Type  "S0"
        RA           12.4200
        Dec          27.4028
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.7570   0.5843   0.2925]
        Angle     22.9987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3306"
}

Galaxy "IC 3308:UGC 7505:MCG 5-29-81:ZWG 158.101"
{
        Type  "Sc"
        RA           12.4217
        Dec          26.7158
        Distance   2.809e+07  # method: V
        Radius          5719
        AbsMag        -14.27
        Axis    [  0.8660  -0.1200   0.4855]
        Angle     56.5397
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3308"
}

Galaxy "IC 3309:UGC 7509:MCG 5-29-82:ZWG 158.102"
{
        Type  "Sc"
        RA           12.4222
        Dec          28.3814
        Distance   2.174e+08  # method: V
        Radius     4.427e+04
        AbsMag        -18.82
        Axis    [  0.6566  -0.3907  -0.6451]
        Angle     38.4003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3309"
}

Galaxy "IC 3311:UGC 7510:MCG 2-32-38:ZWG 70.63"
{
        Type  "Irr"
        RA           12.4258
        Dec          12.2603
        Distance   8.199e+06  # method: V
        Radius          2027
        AbsMag         -12.3
        Axis    [ -0.8315   0.0654   0.5517]
        Angle     24.9820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3311"
}

Galaxy "IC 3312"
{
        Type  "S0"
        RA           12.4247
        Dec          23.5814
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [ -0.7812   0.5515  -0.2924]
        Angle     48.3966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3312"
}

Galaxy "IC 3313:MCG 3-32-33:ZWG 99.46:VCC 817"
{
        Type  "Sa"
        RA           12.4267
        Dec          15.8297
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.5803  -0.7382  -0.3441]
        Angle    126.8710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3313"
}

Galaxy "IC 3314:NPM 1"
{
        Type  "E0"
        RA           12.4253
        Dec          23.5917
        Distance   9.121e+08  # distance uncertain!
        Radius     5.306e+04
        AbsMag        -20.13
        Axis    [  0.4974  -0.7094  -0.4993]
        Angle    101.0924
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3314"
}

Galaxy "IC 3315:VCC 823"
{
        Type  "E0"
        RA           12.4275
        Dec          12.3133
        Distance   5.012e+08  # distance uncertain!
        Radius     4.374e+04
        AbsMag        -20.13
        Axis    [  0.1698  -0.2358  -0.9569]
        Angle     78.7986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3315"
}

Galaxy "IC 3316:KUG 1223+264"
{
        Type  "S0"
        RA           12.4267
        Dec          26.1642
        Distance   5.339e+08  # distance uncertain!
        Radius     3.882e+04
        AbsMag        -19.07
        Axis    [  0.7417  -0.4284  -0.5161]
        Angle     40.0347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3316"
}

Galaxy "IC 3317"
{
        Type  "E0"
        RA           12.4272
        Dec          25.3433
        Distance   1.097e+09  # distance uncertain!
        Radius     4.785e+04
        AbsMag        -20.13
        Axis    [  0.4768  -0.6785  -0.5588]
        Angle     92.9274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3317"
}

Galaxy "IC 3321"
{
        Type  "S0"
        RA           12.4294
        Dec          26.0819
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.9137  -0.4030   0.0517]
        Angle    103.9700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3321"
}

Galaxy "IC 3322:UGC 7518:MCG 1-32-57:ZWG 42.98"
{
        Type  "SBc"
        RA           12.4317
        Dec           7.5547
        Distance   6.927e+07  # method: V
        Radius     2.317e+04
        AbsMag        -17.43
        Axis    [ -0.9807   0.0341   0.1925]
        Angle     42.8122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3322"
}

Galaxy "IC 3322A:UGC 7513:MCG 1-32-54:ZWG 42.95"
{
        Type  "SBc"
        RA           12.4283
        Dec           7.2169
        Distance   9.187e+07  # method: T-F
        Radius     4.543e+04
        AbsMag        -18.45
        Axis    [ -0.9746   0.0139   0.2233]
        Angle     44.1708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3322A"
}

Galaxy "IC 3325"
{
        Type  "S0"
        RA           12.4308
        Dec          23.8958
        Distance   4.241e+08  # distance uncertain!
        Radius     4.318e+04
        AbsMag        -19.07
        Axis    [  0.8513  -0.5143  -0.1042]
        Angle     94.6449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3325"
}

Galaxy "IC 3326"
{
        Type  "Irr"
        RA           12.4311
        Dec          23.7683
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [ -0.8006   0.5488  -0.2404]
        Angle     57.9476
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3326"
}

Galaxy "IC 3327:ZWG 99.48:VCC 864"
{
        Type  "SBa"
        RA           12.4339
        Dec          14.8803
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.5822  -0.7339  -0.3499]
        Angle    127.4437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3327"
}

Galaxy "IC 3328:MCG 2-32-42:ZWG 70.69:VCC 856"
{
        Type  "E0"
        RA           12.4328
        Dec          10.0539
        Distance   6.039e+07  # method: V
        Radius          6148
        AbsMag        -16.64
        Axis    [  0.5737  -0.7215  -0.3877]
        Angle    131.2383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3328"
}

Galaxy "IC 3330:UGC 7527:MCG 5-29-84:ZWG 158.105"
{
        Type  "SBb"
        RA           12.4322
        Dec          30.8431
        Distance   3.216e+08  # method: V
        Radius     5.145e+04
        AbsMag        -19.97
        Axis    [  0.8330  -0.0012   0.5532]
        Angle     17.9316
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3330"
}

Galaxy "IC 3331:MCG 2-32-43:ZWG 70.70:VCC 870"
{
        Type  "Sa"
        RA           12.4347
        Dec          11.8125
        Distance   6.459e+08  # method: V
        Radius     7.515e+04
        AbsMag        -21.18
        Axis    [  0.9271  -0.3384  -0.1612]
        Angle     67.2517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3331"
}

Galaxy "IC 3332"
{
        Type  "E0"
        RA           12.4347
        Dec          25.2794
        Distance   1.097e+09  # distance uncertain!
        Radius     4.785e+04
        AbsMag        -20.13
        Axis    [ -0.2228   0.4669  -0.8558]
        Angle     74.0699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3332"
}

Galaxy "IC 3334"
{
        Type  "E0"
        RA           12.4358
        Dec          28.4658
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.5160  -0.8097  -0.2795]
        Angle    121.2053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3334"
}

Galaxy "IC 3335"
{
        Type  "E0"
        RA           12.4386
        Dec          26.1297
        Distance   1.381e+09  # distance uncertain!
        Radius     4.016e+04
        AbsMag        -20.13
        Axis    [  0.5240  -0.7992  -0.2943]
        Angle    122.4462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3335"
}

Galaxy "IC 3336:ZWG 158.106"
{
        Type  "Sa"
        RA           12.4386
        Dec          26.8383
        Distance   3.274e+08  # method: V
        Radius     2.381e+04
        AbsMag        -19.51
        Axis    [  0.9293  -0.2574   0.2650]
        Angle     40.5944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3336"
}

Galaxy "IC 3337:KUG 1223+255"
{
        Type  "S0"
        RA           12.4392
        Dec          25.3108
        Distance   6.721e+08  # distance uncertain!
        Radius     4.888e+04
        AbsMag        -19.07
        Axis    [  0.5498  -0.7847  -0.2863]
        Angle    122.0030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3337"
}

Galaxy "IC 3338"
{
        Type  "S0"
        RA           12.4394
        Dec          25.8858
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.9281  -0.3672   0.0611]
        Angle     59.1270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3338"
}

Galaxy "IC 3340:MCG 3-32-37:ZWG 99.52:VCC 918"
{
        Type  "SBb"
        RA           12.4422
        Dec          16.8442
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.9113  -0.3997  -0.0990]
        Angle     89.8571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3340"
}

Galaxy "IC 3341:KUG 1223+280"
{
        Type  "S0"
        RA           12.4397
        Dec          27.7461
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.7757  -0.3441  -0.5290]
        Angle     28.7188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3341"
}

Galaxy "IC 3344:MCG 2-32-50:ZWG 70.77:VCC 917"
{
        Type  "E0"
        RA           12.4422
        Dec          13.5794
        Distance   7.697e+07  # method: V
        Radius          7836
        AbsMag        -16.26
        Axis    [  0.4400  -0.5831  -0.6830]
        Angle     96.9501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3344"
}

Galaxy "IC 3345"
{
        Type  "E0"
        RA           12.4425
        Dec          24.3689
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5297  -0.7914  -0.3053]
        Angle    123.4095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3345"
}

Galaxy "IC 3346:VCC 936"
{
        Type  "E0"
        RA           12.4456
        Dec          11.3797
        Distance   4.787e+08  # distance uncertain!
        Radius     4.177e+04
        AbsMag        -20.13
        Axis    [ -0.2229   0.2487  -0.9426]
        Angle     79.8966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3346"
}

Galaxy "IC 3347:VCC 931"
{
        Type  "S0"
        RA           12.4456
        Dec          10.9186
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [ -0.9253   0.2741  -0.2622]
        Angle     42.3101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3347"
}

Galaxy "IC 3348"
{
        Type  "E0"
        RA           12.4439
        Dec          25.6242
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [  0.5252  -0.7972  -0.2976]
        Angle    122.7601
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3348"
}

Galaxy "IC 3349:ZWG 70.81:VCC 940"
{
        Type  "E0"
        RA           12.4464
        Dec          12.4539
        Distance   8.557e+07  # method: V
        Radius      1.12e+04
        AbsMag        -17.19
        Axis    [  0.3833  -0.5102  -0.7699]
        Angle     91.3255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3349"
}

Galaxy "IC 3353:KUG 1224+281"
{
        Type  "S0"
        RA           12.4458
        Dec          27.9119
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.6481  -0.0165   0.7614]
        Angle     30.2496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3353"
}

Galaxy "IC 3355:UGC 7548:MCG 2-32-56:DDO 124"
{
        Type  "Irr"
        RA           12.4472
        Dec          13.1772
        Distance   2.197e+07  # method: V
        Radius          3515
        AbsMag        -13.94
        Axis    [ -0.9489   0.2986  -0.1016]
        Angle     58.0156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3355"
}

Galaxy "IC 3356:UGC 7547:ZWG 70.84:VCC 950"
{
        Type  "Irr"
        RA           12.4472
        Dec          11.5583
        Distance   6.469e+07  # method: V
        Radius     1.411e+04
        AbsMag        -16.39
        Axis    [  0.7085  -0.3476  -0.6141]
        Angle     30.9712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3356"
}

Galaxy "IC 3357:ZWG 70.83:VCC 946"
{
        Type  "S0"
        RA           12.4475
        Dec           9.7775
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [ -0.9867   0.1152   0.1144]
        Angle     56.1929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3357"
}

Galaxy "IC 3358:UGC 7550:MCG 2-32-57:ZWG 70.86"
{
        Type  "E0"
        RA           12.4483
        Dec          11.6633
        Distance   1.083e+08  # method: V
        Radius      1.89e+04
        AbsMag         -18.3
        Axis    [ -0.0654   0.0505  -0.9966]
        Angle     76.7541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3358"
}

Galaxy "IC 3359:NPM 1:KUG 1224+237"
{
        Type  "S0"
        RA           12.4475
        Dec          23.4986
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.9023  -0.4175  -0.1076]
        Angle     54.5153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3359"
}

Galaxy "IC 3361:VCC 949"
{
        Type  "E0"
        RA           12.4483
        Dec          10.6653
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [ -0.0698   0.0462  -0.9965]
        Angle     77.6492
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3361"
}

Galaxy "IC 3362:NPM 1"
{
        Type  "S0"
        RA           12.4483
        Dec          26.6906
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.5442  -0.7917  -0.2776]
        Angle    121.3903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3362"
}

Galaxy "IC 3363:ZWG 70.88:VCC 965"
{
        Type  "E0"
        RA           12.4508
        Dec          12.5611
        Distance   5.056e+07  # method: V
        Radius          9559
        AbsMag        -15.65
        Axis    [ -0.1130   0.1204  -0.9863]
        Angle     76.4583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3363"
}

Galaxy "IC 3364"
{
        Type  "S0"
        RA           12.4511
        Dec          25.5633
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.9599  -0.2674   0.0840]
        Angle     24.4311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3364"
}

Galaxy "IC 3365:UGC 7563:MCG 3-32-41:ZWG 99.57"
{
        Type  "Irr"
        RA           12.4531
        Dec          15.8969
        Distance   1.209e+08  # method: V
        Radius      2.99e+04
        AbsMag        -18.64
        Axis    [  0.9530  -0.3017  -0.0270]
        Angle     42.3666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3365"
}

Galaxy "IC 3366"
{
        Type  "S0"
        RA           12.4533
        Dec           9.4100
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.8446   0.3389  -0.4145]
        Angle     56.2454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3366"
}

Galaxy "IC 3367:ZWG 158.109:NPM 1"
{
        Type  "E0"
        RA           12.4528
        Dec          26.9578
        Distance   4.571e+08  # distance uncertain!
        Radius     5.984e+04
        AbsMag        -20.13
        Axis    [  0.5197  -0.8038  -0.2894]
        Angle    122.1456
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3367"
}

Galaxy "IC 3368:VCC 994"
{
        Type  "E0"
        RA           12.4556
        Dec          16.4272
        Distance   5.496e+08  # distance uncertain!
        Radius     5.595e+04
        AbsMag        -20.13
        Axis    [ -0.1285   0.1869  -0.9739]
        Angle     73.7587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3368"
}

Galaxy "IC 3369:MCG 3-32-43:ZWG 99.58:VCC 990"
{
        Type  "E0"
        RA           12.4544
        Dec          16.0247
        Distance   3.631e+08  # distance uncertain!
        Radius     3.169e+04
        AbsMag        -20.13
        Axis    [ -0.1304   0.1845  -0.9741]
        Angle     74.1018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3369"
}

Galaxy "IC 3370:ESO 322-14:MCG 6-27-29:AM 1224-390"
{
        Type  "E2"
        RA           12.4603
        Dec         -39.3378
        Distance   8.739e+07  # method: S
        Radius     2.669e+04
        AbsMag        -20.24
        Axis    [  0.3869  -0.3762  -0.8419]
        Angle    143.0649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3370"
}

Galaxy "IC 3371:UGC 7565:MCG 2-32-60:ZWG 70.92"
{
        Type  "Sc"
        RA           12.4561
        Dec          10.8667
        Distance   5.694e+07  # method: V
        Radius     1.491e+04
        AbsMag        -15.81
        Axis    [  0.9750  -0.1365   0.1752]
        Angle     60.3424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3371"
}

Galaxy "IC 3373"
{
        Type  "S0"
        RA           12.4575
        Dec          25.4531
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.9209  -0.3266  -0.2126]
        Angle     24.9481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3373"
}

Galaxy "IC 3374:ZWG 70.95:VCC 1021"
{
        Type  "S0"
        RA           12.4592
        Dec          10.0039
        Distance   5.427e+07  # method: V
        Radius          5525
        AbsMag        -15.81
        Axis    [  0.8464  -0.4483  -0.2876]
        Angle     88.9430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3374"
}

Galaxy "IC 3376:UGC 7578:MCG 5-29-87:ZWG 158.112"
{
        Type  "SBa"
        RA           12.4639
        Dec          26.9936
        Distance   3.375e+08  # method: V
        Radius     8.345e+04
        AbsMag        -20.87
        Axis    [  0.8173  -0.5123  -0.2637]
        Angle     56.2654
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3376"
}

Galaxy "IC 3377:NPM 1"
{
        Type  "E0"
        RA           12.4642
        Dec          24.9428
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [ -0.1603   0.3614  -0.9185]
        Angle     69.8125
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3377"
}

Galaxy "IC 3378"
{
        Type  "E0"
        RA           12.4669
        Dec          17.2961
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [ -0.3844   0.5475  -0.7433]
        Angle     88.4148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3378"
}

Galaxy "IC 3379:ZWG 99.60:VCC 1066"
{
        Type  "S0"
        RA           12.4678
        Dec          17.3058
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.9295  -0.3629  -0.0662]
        Angle     74.5942
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3379"
}

Galaxy "IC 3380:NPM 1"
{
        Type  "E0"
        RA           12.4681
        Dec          26.6733
        Distance   9.551e+08  # distance uncertain!
        Radius     4.167e+04
        AbsMag        -20.13
        Axis    [  0.5192  -0.8034  -0.2915]
        Angle    122.4359
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3380"
}

Galaxy "IC 3381:UGC 7589:MCG 2-32-74:ZWG 70.106"
{
        Type  "E0"
        RA           12.4706
        Dec          11.7894
        Distance   4.421e+07  # method: V
        Radius          7717
        AbsMag        -16.26
        Axis    [  0.0196  -0.0628  -0.9978]
        Angle     76.5691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3381"
}

Galaxy "IC 3382:UGC 7588:VCC 1064"
{
        Type  "Sc"
        RA           12.4703
        Dec          13.5711
        Distance   2.883e+08  # method: V
        Radius     3.774e+04
        AbsMag        -18.03
        Axis    [ -0.9331   0.1223   0.3381]
        Angle     36.8480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3382"
}

Galaxy "IC 3383:MCG 2-32-75:ZWG 70.105:VCC 1075"
{
        Type  "Sa"
        RA           12.4700
        Dec          10.2975
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [  0.8689  -0.4260  -0.2520]
        Angle     87.8340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3383"
}

Galaxy "IC 3384:KUG 1225+253"
{
        Type  "Irr"
        RA           12.4700
        Dec          25.0914
        Distance   6.608e+08  # distance uncertain!
        Radius     4.805e+04
        AbsMag        -20.13
        Axis    [ -0.8025   0.5015   0.3232]
        Angle     22.4137
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3384"
}

Galaxy "IC 3385"
{
        Type  "Irr"
        RA           12.4708
        Dec          25.4319
        Distance   1.381e+09  # distance uncertain!
        Radius     1.004e+05
        AbsMag        -20.13
        Axis    [ -0.6056   0.5794  -0.5455]
        Angle     43.3533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3385"
}

Galaxy "IC 3386:VCC 1101"
{
        Type  "E0"
        RA           12.4733
        Dec          13.1953
        Distance   5.496e+08  # distance uncertain!
        Radius     4.796e+04
        AbsMag        -20.13
        Axis    [  0.0943  -0.1487  -0.9844]
        Angle     76.0833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3386"
}

Galaxy "IC 3387:KUG 1225+282"
{
        Type  "E0"
        RA           12.4717
        Dec          27.9958
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.5141  -0.8096  -0.2832]
        Angle    121.7865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3387"
}

Galaxy "IC 3388:ZWG 70.109:VCC 1104"
{
        Type  "E0"
        RA           12.4744
        Dec          12.8236
        Distance   9.948e+07  # method: V
        Radius          8681
        AbsMag        -16.92
        Axis    [  0.3260  -0.4466  -0.8332]
        Angle     86.2588
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3388"
}

Galaxy "IC 3389"
{
        Type  "E0"
        RA           12.4731
        Dec          27.8450
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5145  -0.8090  -0.2842]
        Angle    121.8772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3389"
}

Galaxy "IC 3390"
{
        Type  "SBa"
        RA           12.4744
        Dec          24.8089
        Distance   5.339e+08  # distance uncertain!
        Radius     3.882e+04
        AbsMag        -19.07
        Axis    [  0.4943  -0.2097  -0.8437]
        Angle     27.4432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3390"
}

Galaxy "IC 3391:UGC 7595:MCG 3-32-47:ZWG 99.63"
{
        Type  "Sc"
        RA           12.4742
        Dec          18.4153
        Distance   9.128e+07  # method: V
        Radius      1.46e+04
        AbsMag        -18.03
        Axis    [  0.8030  -0.4643  -0.3736]
        Angle     55.7727
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3391"
}

Galaxy "IC 3392:UGC 7602:MCG 3-32-49:ZWG 99.65"
{
        Type  "Sb"
        RA           12.4786
        Dec          14.9992
        Distance   9.087e+07  # method: V
        Radius      3.04e+04
        AbsMag        -18.92
        Axis    [  0.9463  -0.3201  -0.0454]
        Angle     74.5412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3392"
}

Galaxy "IC 3393:MCG 2-32-81:ZWG 70.113:VCC 1122"
{
        Type  "Sa"
        RA           12.4781
        Dec          12.9164
        Distance    3.28e+07  # method: V
        Radius          6201
        AbsMag        -15.11
        Axis    [ -0.9685   0.1563   0.1937]
        Angle     21.0222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3393"
}

Galaxy "IC 3394:MCG 5-30-3:NPM 1"
{
        Type  "S0"
        RA           12.4781
        Dec          26.7989
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [  0.5409  -0.7940  -0.2776]
        Angle    121.6112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3394"
}

Galaxy "IC 3395"
{
        Type  "S0"
        RA           12.4789
        Dec          25.0350
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.9221  -0.3845   0.0429]
        Angle     69.3106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3395"
}

Galaxy "IC 3396"
{
        Type  "E0"
        RA           12.4792
        Dec          25.0497
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.5237  -0.7966  -0.3019]
        Angle    123.3852
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3396"
}

Galaxy "IC 3397"
{
        Type  "S0"
        RA           12.4794
        Dec          25.7317
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.8310   0.5409  -0.1301]
        Angle     56.4623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3397"
}

Galaxy "IC 3401:NPM 1"
{
        Type  "E0"
        RA           12.4828
        Dec          26.4606
        Distance   1.381e+09  # distance uncertain!
        Radius     6.024e+04
        AbsMag        -20.13
        Axis    [  0.5185  -0.8033  -0.2932]
        Angle    122.6834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3401"
}

Galaxy "IC 3402:UGC 7616:ZWG 158.115:ZWG 159.6"
{
        Type  "Sc"
        RA           12.4831
        Dec          28.8625
        Distance    3.76e+08  # method: V
        Radius     4.922e+04
        AbsMag        -19.51
        Axis    [  0.9499  -0.2135   0.2282]
        Angle    110.0945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3402"
}

Galaxy "IC 3403:ZWG 129.3:KUG 1226+249"
{
        Type  "S0"
        RA           12.4836
        Dec          24.6328
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.8674  -0.4453  -0.2223]
        Angle     45.5530
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3403"
}

Galaxy "IC 3405:NPM 1"
{
        Type  "S0"
        RA           12.4831
        Dec          37.7306
        Distance    5.59e+08  # distance uncertain!
        Radius     5.692e+04
        AbsMag        -19.07
        Axis    [  0.9035  -0.3127   0.2931]
        Angle     98.6056
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3405"
}

Galaxy "IC 3406:MCG 5-30-4:ZWG 159.4"
{
        Type  "Sc"
        RA           12.4839
        Dec          27.6406
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.9207  -0.3829  -0.0754]
        Angle     34.4341
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3406"
}

Galaxy "IC 3407:UGC 7615:MCG 5-30-5:ZWG 159.5"
{
        Type  "SBb"
        RA           12.4842
        Dec          27.7783
        Distance   3.299e+08  # method: V
        Radius     4.318e+04
        AbsMag        -20.32
        Axis    [ -0.7959   0.6023  -0.0615]
        Angle     31.3462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3407"
}

Galaxy "IC 3409:MCG 3-32-50"
{
        Type  "S0"
        RA           12.4892
        Dec          14.7883
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [ -0.7065   0.2686  -0.6548]
        Angle     20.5880
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3409"
}

Galaxy "IC 3410:ZWG 99.67"
{
        Type  "E0"
        RA           12.4850
        Dec          19.0050
        Distance   4.571e+08  # distance uncertain!
        Radius      1.33e+04
        AbsMag        -20.13
        Axis    [  0.5427  -0.7686  -0.3386]
        Angle    126.6609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3410"
}

Galaxy "IC 3411"
{
        Type  "S0"
        RA           12.4867
        Dec          24.5839
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [ -0.9072   0.4123   0.0839]
        Angle     61.0306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3411"
}

Galaxy "IC 3412:ZWG 70.119:VCC 1179"
{
        Type  "S0"
        RA           12.4894
        Dec           9.9878
        Distance   4.956e+07  # method: V
        Radius          5046
        AbsMag        -15.61
        Axis    [ -0.9662   0.2174  -0.1382]
        Angle     45.1557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3412"
}

Galaxy "IC 3413:UGC 7620:MCG 2-32-88:ZWG 70.120"
{
        Type  "E0"
        RA           12.4894
        Dec          11.4336
        Distance    6.02e+07  # method: V
        Radius          8756
        AbsMag        -16.73
        Axis    [ -0.3690   0.4282  -0.8249]
        Angle     86.6046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3413"
}

Galaxy "IC 3414:UGC 7621:MCG 1-32-79:ZWG 42.129"
{
        Type  "Irr"
        RA           12.4911
        Dec           6.7700
        Distance   3.937e+07  # method: V
        Radius          8588
        AbsMag        -16.61
        Axis    [  0.8864  -0.3787  -0.2662]
        Angle     82.8204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3414"
}

Galaxy "IC 3416-1:MCG 2-32-91:ZWG 70.124:VCC 1200"
{
        Type  "S0"
        RA           12.4931
        Dec          10.7939
        Distance   9.287e+06  # method: V
        Radius          1216
        AbsMag        -11.77
        Axis    [  0.8746  -0.3597  -0.3251]
        Angle     25.9474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3416-1"
}

Galaxy "IC 3416-2:MCG 2-32-91:ZWG 70.124:VCC 1200"
{
        Type  "S0"
        RA           12.4928
        Dec          10.7919
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.2596  -0.2803  -0.9241]
        Angle     13.1236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3416-2"
}

Galaxy "IC 3418:UGC 7630:MCG 2-32-92:DDO 130"
{
        Type  "Irr"
        RA           12.4950
        Dec          11.4008
        Distance   2.631e+08  # distance uncertain!
        Radius     5.739e+04
        AbsMag        -20.13
        Axis    [  0.8489  -0.4324  -0.3040]
        Angle     73.4447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3418"
}

Galaxy "IC 3419:VCC 1222"
{
        Type  "S0"
        RA           12.4956
        Dec          15.0242
        Distance   4.241e+08  # distance uncertain!
        Radius     3.701e+04
        AbsMag        -19.07
        Axis    [  0.9319  -0.3583  -0.0560]
        Angle    109.7719
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3419"
}

Galaxy "IC 3421:MCG 5-30-7"
{
        Type  "S0"
        RA           12.4939
        Dec          26.2311
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.8443  -0.5241  -0.1118]
        Angle     81.8543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3421"
}

Galaxy "IC 3422"
{
        Type  "E0"
        RA           12.4983
        Dec          14.6883
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.5543  -0.7485  -0.3640]
        Angle    129.1402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3422"
}

Galaxy "IC 3424"
{
        Type  "S0"
        RA           12.4958
        Dec          24.4083
        Distance   4.869e+08  # distance uncertain!
        Radius     1.416e+04
        AbsMag        -19.07
        Axis    [  0.9751  -0.2154   0.0526]
        Angle     14.6988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3424"
}

Galaxy "IC 3425:UGC 7633:MCG 2-32-95:ZWG 70.126"
{
        Type  "S0"
        RA           12.4989
        Dec          10.6156
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [  0.9456  -0.3088  -0.1021]
        Angle     79.9293
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3425"
}

Galaxy "IC 3429"
{
        Type  "S0"
        RA           12.5019
        Dec          23.5456
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.5493  -0.7803  -0.2991]
        Angle    123.4659
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3429"
}

Galaxy "IC 3430:UGC 7643:ZWG 70.132:VCC 1273"
{
        Type  "S0"
        RA           12.5047
        Dec           9.0844
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.2002  -0.4175  -0.8863]
        Angle      7.1392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3430"
}

Galaxy "IC 3431"
{
        Type  "S0"
        RA           12.5067
        Dec          11.6142
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8452  -0.4874  -0.2193]
        Angle    108.2403
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3431"
}

Galaxy "IC 3432:MCG 2-32-102:ZWG 70.135:VCC 1293"
{
        Type  "Sc"
        RA           12.5075
        Dec          14.1606
        Distance   2.872e+08  # method: V
        Radius     2.506e+04
        AbsMag        -19.42
        Axis    [  0.8407  -0.4422  -0.3127]
        Angle     64.1226
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3432"
}

Galaxy "IC 3433:VCC 1294"
{
        Type  "E0"
        RA           12.5078
        Dec          17.3094
        Distance   6.026e+08  # distance uncertain!
        Radius     6.135e+04
        AbsMag        -20.13
        Axis    [  0.2759  -0.3829  -0.8816]
        Angle     78.0513
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3433"
}

Galaxy "IC 3434:ZWG 99.70:KUG 1227+190"
{
        Type  "S0"
        RA           12.5075
        Dec          18.8094
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.9259  -0.3733  -0.0576]
        Angle     64.6901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3434"
}

Galaxy "IC 3435:UGC 7650:MCG 3-32-53:ZWG 99.72"
{
        Type  "Sa"
        RA           12.5108
        Dec          15.1297
        Distance   2.802e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -19.07
        Axis    [ -0.8392   0.0987   0.5347]
        Angle     31.3937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3435"
}

Galaxy "IC 3436:MCG 3-32-52:ZWG 99.71:KARA 531"
{
        Type  "S0"
        RA           12.5081
        Dec          19.6736
        Distance   1.851e+08  # distance uncertain!
        Radius     1.077e+04
        AbsMag        -19.07
        Axis    [ -0.8817   0.4305  -0.1930]
        Angle     20.8682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3436"
}

Galaxy "IC 3437:ZWG 70.138:VCC 1308"
{
        Type  "E0"
        RA           12.5125
        Dec          11.3428
        Distance   9.536e+07  # method: V
        Radius     1.248e+04
        AbsMag        -17.13
        Axis    [  0.3723  -0.5138  -0.7730]
        Angle     92.4392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3437"
}

Galaxy "IC 3439"
{
        Type  "E0"
        RA           12.5164
        Dec          25.5614
        Distance    8.71e+08  # distance uncertain!
        Radius     6.334e+04
        AbsMag        -20.13
        Axis    [  0.4995  -0.7580  -0.4195]
        Angle    107.8361
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3439"
}

Galaxy "IC 3440"
{
        Type  "E0"
        RA           12.5181
        Dec          12.0294
        Distance   8.318e+08  # distance uncertain!
        Radius      3.63e+04
        AbsMag        -20.13
        Axis    [  0.5597  -0.7366  -0.3796]
        Angle    130.7791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3440"
}

Galaxy "IC 3441:MCG 5-30-10"
{
        Type  "S0"
        RA           12.5178
        Dec          28.8536
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.6900   0.6523  -0.3137]
        Angle     28.6848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3441"
}

Galaxy "IC 3442:MCG 2-32-111:ZWG 70.144:VCC 1355"
{
        Type  "E0"
        RA           12.5222
        Dec          14.1144
        Distance   2.958e+08  # method: V
        Radius     3.872e+04
        AbsMag        -20.19
        Axis    [  0.5535  -0.7471  -0.3680]
        Angle    129.6518
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3442"
}

Galaxy "IC 3443:MCG 2-32-112:ZWG 70.143:VCC 1348"
{
        Type  "S0"
        RA           12.5208
        Dec          12.3322
        Distance   1.176e+08  # method: V
        Radius          6842
        AbsMag        -16.98
        Axis    [  0.5804  -0.7267  -0.3675]
        Angle    129.5133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3443"
}

Galaxy "IC 3445:VCC 1353"
{
        Type  "E0"
        RA           12.5219
        Dec          12.7378
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [  0.5291  -0.7079  -0.4679]
        Angle    119.5390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3445"
}

Galaxy "IC 3446:ZWG 70.142:VCC 1356"
{
        Type  "Irr"
        RA           12.5231
        Dec          11.4925
        Distance   7.139e+07  # method: V
        Radius          6230
        AbsMag         -16.4
        Axis    [  0.9359  -0.3420  -0.0842]
        Angle    115.1415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3446"
}

Galaxy "IC 3447"
{
        Type  "S0"
        RA           12.5214
        Dec          10.6800
        Distance   5.098e+08  # distance uncertain!
        Radius     2.225e+04
        AbsMag        -19.07
        Axis    [  0.5846  -0.7184  -0.3770]
        Angle    130.4162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3447"
}

Galaxy "IC 3448:VCC 1358:KUG 1228+174"
{
        Type  "Sa"
        RA           12.5231
        Dec          17.2061
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [  0.7427  -0.3752  -0.5547]
        Angle     27.2991
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3448"
}

Galaxy "IC 3449:NPM 1:KUG 1228+261"
{
        Type  "S0"
        RA           12.5228
        Dec          25.9144
        Distance    5.59e+08  # distance uncertain!
        Radius     1.626e+04
        AbsMag        -19.07
        Axis    [ -0.8135   0.5784   0.0596]
        Angle     20.9121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3449"
}

Galaxy "IC 3450:KUG 1228+270"
{
        Type  "S0"
        RA           12.5233
        Dec          26.7964
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.8668   0.4985   0.0110]
        Angle     55.7313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3450"
}

Galaxy "IC 3451:MCG 5-30-11:NPM 1"
{
        Type  "S0"
        RA           12.5233
        Dec          28.8556
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.7879  -0.6118  -0.0702]
        Angle    114.5725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3451"
}

Galaxy "IC 3453:UGC 7666:MCG 3-32-57:MK 1328"
{
        Type  "Irr"
        RA           12.5269
        Dec          14.8594
        Distance   1.304e+08  # method: V
        Radius     1.896e+04
        AbsMag        -17.61
        Axis    [ -0.9469   0.1194   0.2985]
        Angle     54.0163
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3453"
}

Galaxy "IC 3454:UGC 7670:MCG 5-30-13:ZWG 159.10"
{
        Type  "Sb"
        RA           12.5272
        Dec          27.4964
        Distance   3.304e+08  # method: V
        Radius     5.766e+04
        AbsMag        -19.33
        Axis    [  0.9404  -0.2001   0.2748]
        Angle     92.8939
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3454"
}

Galaxy "IC 3455"
{
        Type  "S0"
        RA           12.5289
        Dec          25.7853
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.9078  -0.4176   0.0397]
        Angle    114.5498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3455"
}

Galaxy "IC 3457:UGC 7672:MCG 2-32-114:ZWG 70.146"
{
        Type  "E3"
        RA           12.5308
        Dec          12.6572
        Distance    3.02e+08  # distance uncertain!
        Radius     5.271e+04
        AbsMag        -20.13
        Axis    [ -0.1962   0.2071  -0.9584]
        Angle     77.2079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3457"
}

Galaxy "IC 3458"
{
        Type  "E0"
        RA           12.5289
        Dec          28.1472
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5079  -0.8135  -0.2834]
        Angle    122.2515
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3458"
}

Galaxy "IC 3459:UGC 7674:MCG 2-32-115:ZWG 70.147"
{
        Type  "Irr"
        RA           12.5319
        Dec          12.1747
        Distance   3.163e+08  # distance uncertain!
        Radius      5.06e+04
        AbsMag        -20.13
        Axis    [ -0.7613   0.3595  -0.5397]
        Angle     48.5153
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3459"
}

Galaxy "IC 3460:KUG 1229+276"
{
        Type  "Sc"
        RA           12.5306
        Dec          27.3872
        Distance   3.527e+08  # distance uncertain!
        Radius     4.617e+04
        AbsMag        -19.07
        Axis    [ -0.2324   0.3450   0.9094]
        Angle     16.6730
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3460"
}

Galaxy "IC 3461:MCG 2-32-116:ZWG 70.148:VCC 1407"
{
        Type  "S0"
        RA           12.5339
        Dec          11.8897
        Distance   7.099e+07  # method: V
        Radius          7227
        AbsMag        -16.59
        Axis    [  0.7907  -0.5636  -0.2390]
        Angle    120.0867
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3461"
}

Galaxy "IC 3462:VCC 1417"
{
        Type  "E0"
        RA           12.5358
        Dec          15.3011
        Distance   5.755e+08  # distance uncertain!
        Radius     5.022e+04
        AbsMag        -20.13
        Axis    [  0.4416  -0.6163  -0.6520]
        Angle     97.7931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3462"
}

Galaxy "IC 3465:VCC 1420"
{
        Type  "E0"
        RA           12.5367
        Dec          12.0614
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [  0.1786  -0.2826  -0.9425]
        Angle     79.5856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3465"
}

Galaxy "IC 3466:MCG 2-32-117:ZWG 70.150:VCC 1411"
{
        Type  "S0"
        RA           12.5347
        Dec          11.8175
        Distance   5.549e+07  # method: V
        Radius          4843
        AbsMag        -15.45
        Axis    [  0.7202  -0.4122  -0.5580]
        Angle     42.0712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3466"
}

Galaxy "IC 3467:UGC 7686:MCG 2-32-121:ZWG 70.154"
{
        Type  "Sc"
        RA           12.5400
        Dec          11.7875
        Distance   3.572e+08  # method: V
        Radius     5.714e+04
        AbsMag         -19.6
        Axis    [  0.9447  -0.1724   0.2789]
        Angle     44.5154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3467"
}

Galaxy "IC 3468:UGC 7681:MCG 2-32-119:ZWG 70.151"
{
        Type  "E0"
        RA           12.5372
        Dec          10.2519
        Distance   7.697e+07  # method: V
        Radius     1.343e+04
        AbsMag        -18.06
        Axis    [ -0.4186   0.4661  -0.7795]
        Angle     89.9301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3468"
}

Galaxy "IC 3469"
{
        Type  "E0"
        RA           12.5364
        Dec          25.8028
        Distance   1.097e+09  # distance uncertain!
        Radius     1.595e+04
        AbsMag        -20.13
        Axis    [  0.5154  -0.8033  -0.2984]
        Angle    123.5215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3469"
}

Galaxy "IC 3470:MCG 2-32-122:ZWG 70.153:VCC 1431"
{
        Type  "S0"
        RA           12.5397
        Dec          11.2633
        Distance   1.073e+08  # method: V
        Radius          9361
        AbsMag        -18.19
        Axis    [  0.5813  -0.7225  -0.3743]
        Angle    130.2393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3470"
}

Galaxy "IC 3471:MCG 3-32-63:ZWG 99.80:VCC 1427"
{
        Type  "S0"
        RA           12.5394
        Dec          16.0183
        Distance   8.381e+06  # method: V
        Radius         975.1
        AbsMag        -11.55
        Axis    [  0.9285  -0.3685  -0.0463]
        Angle    114.8984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3471"
}

Galaxy "IC 3472:KUG 1229+250"
{
        Type  "Irr"
        RA           12.5383
        Dec          24.7283
        Distance   1.097e+09  # distance uncertain!
        Radius     4.785e+04
        AbsMag        -20.13
        Axis    [  0.5418  -0.7880  -0.2924]
        Angle    123.1985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3472"
}

Galaxy "IC 3473:UGC 7684:MCG 3-32-62:ZWG 99.81"
{
        Type  "Sc"
        RA           12.5386
        Dec          18.2444
        Distance   5.114e+07  # method: V
        Radius          8926
        AbsMag        -15.98
        Axis    [  0.8637  -0.4712  -0.1790]
        Angle     81.2978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3473"
}

Galaxy "IC 3474:UGC 7687:MCG 1-32-91:ZWG 42.145"
{
        Type  "Sc"
        RA           12.5433
        Dec           2.6625
        Distance   9.382e+07  # method: V
        Radius     3.002e+04
        AbsMag        -17.49
        Axis    [  0.9929  -0.1186   0.0058]
        Angle     78.0264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3474"
}

Galaxy "IC 3475:UGC 7692:MCG 2-32-123:DDO 132"
{
        Type  "E0"
        RA           12.5444
        Dec          12.7694
        Distance   1.316e+08  # method: V
        Radius     3.254e+04
        AbsMag        -18.93
        Axis    [  0.2107  -0.3228  -0.9227]
        Angle     80.1210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3475"
}

Galaxy "IC 3476:UGC 7695:MCG 2-32-125:ZWG 70.157"
{
        Type  "Irr"
        RA           12.5447
        Dec          14.0500
        Distance   6.705e+06  # method: V
        Radius          1950
        AbsMag        -13.46
        Axis    [  0.8489  -0.4726  -0.2366]
        Angle     87.7840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3476"
}

Galaxy "IC 3478:UGC 7696:MCG 2-32-126:ZWG 70.158"
{
        Type  "S0"
        RA           12.5456
        Dec          14.1961
        Distance   9.948e+07  # method: V
        Radius     1.592e+04
        AbsMag        -18.02
        Axis    [  0.1426  -0.1627  -0.9763]
        Angle     46.7087
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3478"
}

Galaxy "IC 3479:KUG 1230+256"
{
        Type  "E0"
        RA           12.5447
        Dec          25.4061
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5159  -0.8020  -0.3011]
        Angle    123.8031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3479"
}

Galaxy "IC 3481:MCG 2-32-127:ZWG 70.159:VV 43"
{
        Type  "S0"
        RA           12.5478
        Dec          11.4047
        Distance   3.357e+08  # method: V
        Radius     3.906e+04
        AbsMag        -20.06
        Axis    [  0.7926  -0.4799  -0.3761]
        Angle     76.0758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3481"
}

Galaxy "IC 3481A:MCG 2-32-128:VV 43:ARP 175"
{
        Type  "E0"
        RA           12.5489
        Dec          11.3906
        Distance   3.456e+08  # method: V
        Radius     1.005e+04
        AbsMag        -20.73
        Axis    [  0.5583  -0.7353  -0.3842]
        Angle    131.3783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3481A"
}

Galaxy "IC 3482"
{
        Type  "S0"
        RA           12.5503
        Dec          27.8306
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.9268  -0.2990   0.2273]
        Angle     71.6754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3482"
}

Galaxy "IC 3483:MCG 2-32-129:ZWG 70.160:VV 43"
{
        Type  "SBb"
        RA           12.5528
        Dec          11.3469
        Distance   2.052e+07  # method: V
        Radius          1492
        AbsMag        -13.49
        Axis    [  0.8244  -0.5236  -0.2151]
        Angle    118.9954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3483"
}

Galaxy "IC 3484:MCG 3-32-66:ZWG 99.88:VCC 1476"
{
        Type  "Sc"
        RA           12.5514
        Dec          17.4031
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [  0.7946  -0.5786  -0.1842]
        Angle    117.9631
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3484"
}

Galaxy "IC 3486:MCG 2-32-131:ZWG 70.164:VCC 1491"
{
        Type  "E0"
        RA           12.5539
        Dec          12.8572
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.4369  -0.6062  -0.6646]
        Angle     99.7708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3486"
}

Galaxy "IC 3487:MCG 2-32-133:ZWG 70.161:VCC 1488"
{
        Type  "E6"
        RA           12.5536
        Dec           9.3969
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.2108  -0.3355  -0.9181]
        Angle     83.9248
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3487"
}

Galaxy "IC 3488:MCG 5-30-19:ZWG 159.14:NPM 1"
{
        Type  "S0"
        RA           12.5522
        Dec          26.3497
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.7442  -0.6537  -0.1371]
        Angle    116.2453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3488"
}

Galaxy "IC 3489:MCG 2-32-130:ZWG 70.163:VCC 1490"
{
        Type  "Sc"
        RA           12.5536
        Dec          12.2469
        Distance   3.708e+08  # method: V
        Radius     3.236e+04
        AbsMag        -20.08
        Axis    [  0.5773  -0.7283  -0.3691]
        Angle    129.8155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3489"
}

Galaxy "IC 3490:ZWG 70.162:VCC 1489"
{
        Type  "E0"
        RA           12.5536
        Dec          10.9283
        Distance   1.839e+07  # method: V
        Radius          1605
        AbsMag        -12.26
        Axis    [  0.4138  -0.5727  -0.7077]
        Angle     98.3523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3490"
}

Galaxy "IC 3491:KUG 1230+273"
{
        Type  "S0"
        RA           12.5525
        Dec          27.0947
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [  0.9370  -0.3217   0.1365]
        Angle    103.8641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3491"
}

Galaxy "IC 3492:MCG 2-32-132:VCC 1499:ARAK 376"
{
        Type  "S0"
        RA           12.5553
        Dec          12.8539
        Distance   1.938e+08  # distance uncertain!
        Radius     1.973e+04
        AbsMag        -19.07
        Axis    [  0.8821  -0.4050  -0.2406]
        Angle     61.7215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3492"
}

Galaxy "IC 3494:NPM 1"
{
        Type  "E0"
        RA           12.5536
        Dec          27.5847
        Distance   1.148e+09  # distance uncertain!
        Radius      3.34e+04
        AbsMag        -20.13
        Axis    [  0.5074  -0.8123  -0.2875]
        Angle    122.7715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3494"
}

Galaxy "IC 3498:KUG 1230+270"
{
        Type  "Sb"
        RA           12.5581
        Dec          26.7386
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.9281  -0.2937   0.2288]
        Angle     66.6222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3498"
}

Galaxy "IC 3499:UGC 7712:MCG 2-32-138:ZWG 70.169"
{
        Type  "Sa"
        RA           12.5625
        Dec          10.9956
        Distance   7.026e+07  # method: V
        Radius     1.431e+04
        AbsMag        -17.47
        Axis    [ -0.9955  -0.0562  -0.0761]
        Angle     10.8834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3499"
}

Galaxy "IC 3500:ZWG 70.171:VCC 1526"
{
        Type  "SBc"
        RA           12.5636
        Dec          13.9628
        Distance   2.937e+08  # method: V
        Radius     2.563e+04
        AbsMag        -19.67
        Axis    [  0.5746  -0.3667  -0.7317]
        Angle     29.3057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3500"
}

Galaxy "IC 3501:MCG 2-32-139:ZWG 70.170:VCC 1528"
{
        Type  "E0"
        RA           12.5642
        Dec          13.3225
        Distance    3.02e+08  # distance uncertain!
        Radius     3.075e+04
        AbsMag        -20.13
        Axis    [  0.5515  -0.7458  -0.3738]
        Angle    130.4274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3501"
}

Galaxy "IC 3502"
{
        Type  "Irr"
        RA           12.5617
        Dec          26.6178
        Distance   1.097e+09  # distance uncertain!
        Radius      3.19e+04
        AbsMag        -20.13
        Axis    [  0.9047  -0.4236   0.0459]
        Angle    109.7543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3502"
}

Galaxy "IC 3505:MCG 3-32-70:ZWG 99.91:VCC 1542"
{
        Type  "SBc"
        RA           12.5694
        Dec          15.9686
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.9484   0.3153  -0.0326]
        Angle     60.2073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3505"
}

Galaxy "IC 3506:VCC 1539"
{
        Type  "E0"
        RA           12.5683
        Dec          12.7417
        Distance   4.571e+08  # distance uncertain!
        Radius     3.989e+04
        AbsMag        -20.13
        Axis    [  0.2292  -0.3538  -0.9068]
        Angle     81.1429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3506"
}

Galaxy "IC 3507:NPM 1"
{
        Type  "E0"
        RA           12.5678
        Dec          25.3633
        Distance   1.202e+09  # distance uncertain!
        Radius     3.498e+04
        AbsMag        -20.13
        Axis    [  0.5137  -0.8031  -0.3018]
        Angle    124.0383
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3507"
}

Galaxy "IC 3508:MCG 5-30-21:ZWG 159.17:NPM 1"
{
        Type  "S0"
        RA           12.5683
        Dec          26.6714
        Distance   3.679e+08  # method: V
        Radius     4.816e+04
        AbsMag        -20.06
        Axis    [  0.5323  -0.7987  -0.2805]
        Angle    122.5132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3508"
}

Galaxy "IC 3509:ZWG 70.174:VCC 1545:NPM 1"
{
        Type  "E0"
        RA           12.5697
        Dec          12.0494
        Distance   3.312e+08  # distance uncertain!
        Radius     4.335e+04
        AbsMag        -20.13
        Axis    [  0.2473  -0.3784  -0.8920]
        Angle     82.8812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3509"
}

Galaxy "IC 3510:UGC 7728:MCG 2-32-142:ZWG 70.173"
{
        Type  "S0"
        RA           12.5708
        Dec          11.0717
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.8829  -0.4418  -0.1589]
        Angle    116.9561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3510"
}

Galaxy "IC 3515"
{
        Type  "S0"
        RA           12.5711
        Dec          27.8619
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.9228  -0.2974   0.2448]
        Angle     66.9577
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3515"
}

Galaxy "IC 3516:UGC 7724:MCG 5-30-22:FGC 1460"
{
        Type  "Sc"
        RA           12.5714
        Dec          27.4528
        Distance   3.235e+08  # method: V
        Radius     6.587e+04
        AbsMag        -19.48
        Axis    [  0.8235  -0.1405   0.5496]
        Angle     51.7374
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3516"
}

Galaxy "IC 3517:UGC 7733:MCG 2-32-143:ZWG 70.176"
{
        Type  "Irr"
        RA           12.5750
        Dec           9.1550
        Distance   3.452e+07  # method: V
        Radius          5523
        AbsMag        -15.52
        Axis    [  0.8861  -0.4174  -0.2014]
        Angle    102.4143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3517"
}

Galaxy "IC 3518:UGC 7734:ZWG 70.177:VCC 1567"
{
        Type  "Irr"
        RA           12.5753
        Dec           9.6239
        Distance    3.02e+08  # distance uncertain!
        Radius     5.271e+04
        AbsMag        -20.13
        Axis    [  0.8790  -0.4005  -0.2588]
        Angle     72.4815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3518"
}

Galaxy "IC 3519:VCC 1577"
{
        Type  "E0"
        RA           12.5772
        Dec          15.6025
        Distance   5.012e+08  # distance uncertain!
        Radius     4.374e+04
        AbsMag        -20.13
        Axis    [  0.5181  -0.7262  -0.4519]
        Angle    118.1428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3519"
}

Galaxy "IC 3520:ZWG 70.178:VCC 1569"
{
        Type  "Sc"
        RA           12.5753
        Dec          13.5033
        Distance   5.078e+07  # method: V
        Radius          7386
        AbsMag        -15.96
        Axis    [  0.7941  -0.4636  -0.3930]
        Angle     60.0879
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3520"
}

Galaxy "IC 3521:UGC 7736:MCG 1-32-106:ZWG 42.162"
{
        Type  "Irr"
        RA           12.5775
        Dec           7.1597
        Distance   4.195e+07  # method: V
        Radius          8542
        AbsMag        -16.45
        Axis    [  0.8710  -0.4143  -0.2639]
        Angle     91.5313
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3521"
}

Galaxy "IC 3522:UGC 7737:MCG 3-32-72:DDO 136"
{
        Type  "Irr"
        RA           12.5792
        Dec          15.2211
        Distance   4.458e+07  # method: V
        Radius          9725
        AbsMag        -15.48
        Axis    [  0.8775  -0.4041  -0.2584]
        Angle     20.6349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3522"
}

Galaxy "IC 3523"
{
        Type  "Sb"
        RA           12.5775
        Dec          14.0161
        Distance    6.13e+08  # distance uncertain!
        Radius     4.458e+04
        AbsMag        -19.07
        Axis    [  0.5702  -0.7387  -0.3595]
        Angle    129.0590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3523"
}

Galaxy "IC 3525"
{
        Type  "E0"
        RA           12.5794
        Dec          10.1756
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [  0.5585  -0.7311  -0.3919]
        Angle    132.2944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3525"
}

Galaxy "IC 3528:MCG 3-32-74A:ZWG 99.95:VCC 1593"
{
        Type  "SBb"
        RA           12.5819
        Dec          15.5661
        Distance   6.378e+08  # method: V
        Radius     3.711e+04
        AbsMag        -21.06
        Axis    [  0.5654  -0.7466  -0.3505]
        Angle    128.2763
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3528"
}

Galaxy "IC 3530:MCG 3-32-73:ZWG 99.94:KUG 1232+180"
{
        Type  "S0"
        RA           12.5803
        Dec          17.8136
        Distance    2.03e+08  # distance uncertain!
        Radius     4.133e+04
        AbsMag        -19.07
        Axis    [ -0.7333   0.4783  -0.4832]
        Angle     54.2962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3530"
}

Galaxy "IC 3531"
{
        Type  "E0"
        RA           12.5822
        Dec          26.6267
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5079  -0.8096  -0.2941]
        Angle    123.5276
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3531"
}

Galaxy "IC 3533:MK 774:ZWG 129.7:KARA 537"
{
        Type  "S0"
        RA           12.5836
        Dec          25.7803
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.8580  -0.5047  -0.0953]
        Angle     75.2143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3533"
}

Galaxy "IC 3534"
{
        Type  "E0"
        RA           12.5811
        Dec          14.9783
        Distance   5.755e+08  # distance uncertain!
        Radius     3.348e+04
        AbsMag        -20.13
        Axis    [  0.5450  -0.7549  -0.3648]
        Angle    129.6572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3534"
}

Galaxy "IC 3536:MCG 5-30-24:KUG 1232+268"
{
        Type  "Sc"
        RA           12.5867
        Dec          26.5333
        Distance   4.241e+08  # distance uncertain!
        Radius     5.551e+04
        AbsMag        -19.07
        Axis    [ -0.8690   0.3908   0.3034]
        Angle     43.4528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3536"
}

Galaxy "IC 3540:MCG 2-32-146:ZWG 70.180:ARAK 379"
{
        Type  "Sa"
        RA           12.5908
        Dec          12.7508
        Distance   4.775e+07  # method: V
        Radius          4861
        AbsMag        -15.93
        Axis    [  0.6187  -0.4906  -0.6136]
        Angle     63.1983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3540"
}

Galaxy "IC 3542:ZWG 70.181:VCC 1633"
{
        Type  "SBb"
        RA           12.5947
        Dec          11.6667
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.8122   0.3992  -0.4254]
        Angle     61.6923
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3542"
}

Galaxy "IC 3543:NGC 4565:UGC 7764:FGC 1466"
{
        Type  "Sc"
        RA           12.5947
        Dec          26.2867
        Distance   5.694e+07  # method: S
        Radius          7454
        AbsMag        -14.71
        Axis    [ -0.6811   0.2414   0.6913]
        Angle     38.1057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3543"
}

Galaxy "IC 3546:NGC 4565B:MCG 4-30-5:ZWG 129.9"
{
        Type  "Sc"
        RA           12.5947
        Dec          26.2225
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.8258   0.5548   0.1013]
        Angle     20.4398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3546"
}

Galaxy "IC 3548:VCC 1647"
{
        Type  "E0"
        RA           12.5989
        Dec          10.9358
        Distance   5.496e+08  # distance uncertain!
        Radius     4.796e+04
        AbsMag        -20.13
        Axis    [  0.0432  -0.1390  -0.9893]
        Angle     77.2934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3548"
}

Galaxy "IC 3556:MCG 5-30-29:ZWG 159.25:KUG 1233+272"
{
        Type  "S0"
        RA           12.5994
        Dec          26.9656
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.8865   0.4487   0.1133]
        Angle     55.6008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3556"
}

Galaxy "IC 3557:MCG 3-32-77:NPM 1"
{
        Type  "E0"
        RA           12.6022
        Dec          16.6417
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [  0.5380  -0.7642  -0.3557]
        Angle    128.9317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3557"
}

Galaxy "IC 3558-1"
{
        Type  "S0"
        RA           12.6006
        Dec          11.8494
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8138  -0.4202  -0.4015]
        Angle     27.3606
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3558-1"
}

Galaxy "IC 3558-2"
{
        Type  "E0"
        RA           12.6006
        Dec          11.8522
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5518  -0.7407  -0.3832]
        Angle    131.5285
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3558-2"
}

Galaxy "IC 3559:MCG 5-30-31"
{
        Type  "S0"
        RA           12.6008
        Dec          26.9878
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.9083  -0.2796   0.3113]
        Angle     50.5985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3559"
}

Galaxy "IC 3560:NPM 1"
{
        Type  "S0"
        RA           12.6008
        Dec          27.0789
        Distance    5.59e+08  # distance uncertain!
        Radius     4.065e+04
        AbsMag        -19.07
        Axis    [  0.8928  -0.4468  -0.0574]
        Angle     45.0063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3560"
}

Galaxy "IC 3561:MCG 5-30-32:ZWG 159.26:NPM 1"
{
        Type  "S0"
        RA           12.6011
        Dec          26.9000
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.8499  -0.2096   0.4834]
        Angle     40.1424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3561"
}

Galaxy "IC 3562:ZWG 70.185:VCC 1654"
{
        Type  "Irr"
        RA           12.6028
        Dec           9.9228
        Distance   1.076e+08  # method: V
        Radius     1.252e+04
        AbsMag        -17.29
        Axis    [  0.9534  -0.2927  -0.0727]
        Angle     74.9706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3562"
}

Galaxy "IC 3565"
{
        Type  "E0"
        RA           12.6033
        Dec          26.7561
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.5054  -0.8114  -0.2937]
        Angle    123.6604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3565"
}

Galaxy "IC 3567:ZWG 70.187:VCC 1660:NPM 1"
{
        Type  "Sc"
        RA           12.6061
        Dec          13.6031
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.7691  -0.5924  -0.2400]
        Angle    120.4988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3567"
}

Galaxy "IC 3571"
{
        Type  "Irr"
        RA           12.6053
        Dec          26.0842
        Distance   1.097e+09  # distance uncertain!
        Radius     4.785e+04
        AbsMag        -20.13
        Axis    [  0.5307  -0.7981  -0.2852]
        Angle    123.1440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3571"
}

Galaxy "IC 3573:NPM 1"
{
        Type  "S0"
        RA           12.6075
        Dec          11.7597
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [ -0.6179   0.2456  -0.7469]
        Angle     38.6187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3573"
}

Galaxy "IC 3574:VCC 1665:NPM 1"
{
        Type  "E0"
        RA           12.6075
        Dec          12.4056
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [ -0.0380  -0.0266  -0.9989]
        Angle     75.0424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3574"
}

Galaxy "IC 3575:VCC 1674"
{
        Type  "E0"
        RA           12.6089
        Dec          13.7472
        Distance       1e+09  # distance uncertain!
        Radius     8.727e+04
        AbsMag        -20.13
        Axis    [  0.5457  -0.7505  -0.3727]
        Angle    130.5553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3575"
}

Galaxy "IC 3576:UGC 7781:MCG 1-32-112:DDO 138"
{
        Type  "Irr"
        RA           12.6103
        Dec           6.6214
        Distance   6.369e+07  # method: V
        Radius     2.131e+04
        AbsMag        -17.65
        Axis    [  0.6840  -0.5581  -0.4699]
        Angle     99.2030
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3576"
}

Galaxy "IC 3578:UGC 7782:MCG 2-32-153:ZWG 70.190"
{
        Type  "Sc"
        RA           12.6108
        Dec          11.1014
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.9954   0.0469   0.0833]
        Angle     20.6205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3578"
}

Galaxy "IC 3580"
{
        Type  "E0"
        RA           12.6081
        Dec          18.2997
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5325  -0.7725  -0.3460]
        Angle    128.0937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3580"
}

Galaxy "IC 3581:MCG 4-30-9:ZWG 129.12:ARAK 381"
{
        Type  "Sa"
        RA           12.6106
        Dec          24.4289
        Distance   3.268e+08  # method: V
        Radius     4.278e+04
        AbsMag         -19.5
        Axis    [  0.9240  -0.3727   0.0857]
        Angle     64.2882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3581"
}

Galaxy "IC 3582"
{
        Type  "E0"
        RA           12.6100
        Dec          26.2347
        Distance   9.551e+08  # distance uncertain!
        Radius     2.778e+04
        AbsMag        -20.13
        Axis    [  0.5065  -0.8094  -0.2972]
        Angle    123.9868
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3582"
}

Galaxy "IC 3583:UGC 7784:MCG 2-32-154:ZWG 70.191"
{
        Type  "Irr"
        RA           12.6119
        Dec          13.2592
        Distance   6.501e+07  # method: V
        Radius      2.08e+04
        AbsMag         -17.6
        Axis    [  0.9291  -0.3620  -0.0758]
        Angle    115.4007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3583"
}

Galaxy "IC 3585:UGC 7783:MCG 5-30-35:ZWG 159.28"
{
        Type  "S0"
        RA           12.6108
        Dec          26.8306
        Distance   3.486e+08  # method: V
        Radius     5.578e+04
        AbsMag        -20.34
        Axis    [ -0.2626   0.3592  -0.8955]
        Angle     25.8528
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3585"
}

Galaxy "IC 3586:MCG 2-32-157:ZWG 70.193:VCC 1695"
{
        Type  "E0"
        RA           12.6150
        Dec          12.5203
        Distance   2.884e+08  # distance uncertain!
        Radius     4.615e+04
        AbsMag        -20.13
        Axis    [  0.1708  -0.2957  -0.9399]
        Angle     79.0255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3586"
}

Galaxy "IC 3587:UGC 7787:MCG 5-30-36:FGC 1474"
{
        Type  "Sc"
        RA           12.6133
        Dec          27.5497
        Distance   3.449e+08  # method: V
        Radius     7.022e+04
        AbsMag        -18.92
        Axis    [ -0.2084   0.1623   0.9645]
        Angle     29.5946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3587"
}

Galaxy "IC 3590"
{
        Type  "S0"
        RA           12.6139
        Dec          27.2781
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [ -0.4383   0.2077   0.8745]
        Angle     31.9872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3590"
}

Galaxy "IC 3591:UGC 7790:MCG 1-32-115:ZWG 42.179"
{
        Type  "Irr"
        RA           12.6172
        Dec           6.9261
        Distance   8.906e+07  # method: V
        Radius     1.554e+04
        AbsMag        -18.08
        Axis    [  0.9019  -0.3606  -0.2378]
        Angle     68.8596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3591"
}

Galaxy "IC 3592:NGC 4559A:UGC 7789:MCG 5-30-38"
{
        Type  "Sa"
        RA           12.6147
        Dec          27.8625
        Distance   3.528e+08  # method: V
        Radius     5.132e+04
        AbsMag        -19.97
        Axis    [ -0.6931   0.6474   0.3170]
        Angle     12.1788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3592"
}

Galaxy "IC 3593:NGC 4559B:MCG 5-30-39:MK 776"
{
        Type  "SBb"
        RA           12.6147
        Dec          27.7486
        Distance    3.61e+08  # method: V
        Radius     2.625e+04
        AbsMag        -19.82
        Axis    [  0.8703  -0.4925   0.0074]
        Angle    109.8784
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3593"
}

Galaxy "IC 3595-1"
{
        Type  "S0"
        RA           12.6183
        Dec          23.7869
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.9324  -0.3594   0.0376]
        Angle     20.1362
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3595-1"
}

Galaxy "IC 3595-2"
{
        Type  "S0"
        RA           12.6183
        Dec          23.7803
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.9489  -0.2002   0.2441]
        Angle     88.3987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3595-2"
}

Galaxy "IC 3597:KUG 1234+241"
{
        Type  "S0"
        RA           12.6233
        Dec          23.8636
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.5362  -0.7890  -0.3001]
        Angle    124.4004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3597"
}

Galaxy "IC 3598:UGC 7791:MCG 5-30-40:ZWG 159.33"
{
        Type  "Sb"
        RA           12.6225
        Dec          28.2089
        Distance   3.602e+08  # method: V
        Radius     7.334e+04
        AbsMag        -20.42
        Axis    [ -0.7115   0.3550   0.6065]
        Angle     31.9282
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3598"
}

Galaxy "IC 3599:ZWG 159.34:NPM 1:KUG 1235+269"
{
        Type  "Sb"
        RA           12.6281
        Dec          26.7081
        Distance   3.047e+08  # method: V
        Radius     1.329e+04
        AbsMag        -19.15
        Axis    [ -0.7288   0.5806  -0.3629]
        Angle     26.9502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3599"
}

Galaxy "IC 3600:MCG 5-30-41:MK 650:ZWG 159.35"
{
        Type  "S0"
        RA           12.6281
        Dec          27.1294
        Distance   2.239e+08  # method: V
        Radius     1.628e+04
        AbsMag        -18.28
        Axis    [  0.7849  -0.6130  -0.0908]
        Angle    115.7428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3600"
}

Galaxy "IC 3601"
{
        Type  "S0"
        RA           12.6314
        Dec          15.2247
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.8304   0.3758  -0.4113]
        Angle     44.0561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3601"
}

Galaxy "IC 3602:ZWG 70.198:VCC 1743"
{
        Type  "E0"
        RA           12.6350
        Dec          10.0819
        Distance   3.981e+08  # distance uncertain!
        Radius     5.212e+04
        AbsMag        -20.13
        Axis    [ -0.2210   0.1782  -0.9589]
        Angle     78.4619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3602"
}

Galaxy "IC 3603:NPM 1"
{
        Type  "E0"
        RA           12.6378
        Dec          15.5703
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [ -0.4129   0.5252  -0.7441]
        Angle     87.2959
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3603"
}

Galaxy "IC 3604"
{
        Type  "Sa"
        RA           12.6389
        Dec          11.7306
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.8746   0.3580  -0.3269]
        Angle     58.6737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3604"
}

Galaxy "IC 3605:KUG 1235+198"
{
        Type  "Irr"
        RA           12.6389
        Dec          19.5411
        Distance   6.026e+08  # distance uncertain!
        Radius     3.506e+04
        AbsMag        -20.13
        Axis    [  0.9166  -0.3989  -0.0269]
        Angle    105.2660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3605"
}

Galaxy "IC 3606"
{
        Type  "E0"
        RA           12.6403
        Dec          12.6103
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5457  -0.7468  -0.3801]
        Angle    131.4286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3606"
}

Galaxy "IC 3607:VCC 1762"
{
        Type  "E0"
        RA           12.6422
        Dec          10.3761
        Distance   6.608e+08  # distance uncertain!
        Radius     4.805e+04
        AbsMag        -20.13
        Axis    [ -0.2285   0.1895  -0.9549]
        Angle     78.3417
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3607"
}

Galaxy "IC 3608:UGC 7808:ZWG 70.201:VCC 1768"
{
        Type  "Sb"
        RA           12.6436
        Dec          10.4758
        Distance   3.442e+08  # method: V
        Radius     1.552e+05
        AbsMag        -20.52
        Axis    [  0.8029  -0.2838   0.5243]
        Angle     23.9477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3608"
}

Galaxy "IC 3609:ZWG 99.101:VCC 1765"
{
        Type  "Sb"
        RA           12.6428
        Dec          14.3531
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.5627  -0.7444  -0.3596]
        Angle    129.4076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3609"
}

Galaxy "IC 3610"
{
        Type  "E0"
        RA           12.6464
        Dec          26.8728
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5007  -0.8142  -0.2938]
        Angle    124.0079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3610"
}

Galaxy "IC 3611:UGC 7817:MCG 2-32-164:ZWG 70.202"
{
        Type  "S0"
        RA           12.6511
        Dec          13.3642
        Distance   1.384e+08  # method: V
        Radius     2.819e+04
        AbsMag        -19.14
        Axis    [ -0.8339   0.2141  -0.5087]
        Angle     25.8199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3611"
}

Galaxy "IC 3612:IC 3616:UGC 7814:ZWG 99.102"
{
        Type  "S0"
        RA           12.6511
        Dec          14.7317
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [  0.9108  -0.3933  -0.1258]
        Angle     65.7579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3612"
}

Galaxy "IC 3613"
{
        Type  "S0"
        RA           12.6511
        Dec          13.7586
        Distance   6.419e+08  # distance uncertain!
        Radius     4.668e+04
        AbsMag        -19.07
        Axis    [ -0.9718   0.2356   0.0059]
        Angle     49.9871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3613"
}

Galaxy "IC 3615:UGC 7815:MCG 3-32-79:ZWG 99.104"
{
        Type  "Sc"
        RA           12.6503
        Dec          18.2008
        Distance   3.734e+08  # method: V
        Radius     5.974e+04
        AbsMag        -19.79
        Axis    [  0.9645  -0.2538   0.0736]
        Angle    104.6465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3615"
}

Galaxy "IC 3617:UGC 7822:MCG 1-32-127:DDO 140"
{
        Type  "Irr"
        RA           12.6569
        Dec           7.9664
        Distance    1.09e+08  # method: V
        Radius     2.219e+04
        AbsMag        -18.22
        Axis    [  0.8721  -0.3935  -0.2909]
        Angle     52.3649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3617"
}

Galaxy "IC 3618:ZWG 159.41:NPM 1"
{
        Type  "S0"
        RA           12.6547
        Dec          26.6783
        Distance   3.081e+08  # method: V
        Radius     1.344e+04
        AbsMag        -18.98
        Axis    [  0.5238  -0.8037  -0.2824]
        Angle    123.3173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3618"
}

Galaxy "IC 3620:ZWG 159.44"
{
        Type  "S0"
        RA           12.6547
        Dec          27.9083
        Distance   3.094e+08  # method: V
        Radius       2.7e+04
        AbsMag        -19.29
        Axis    [ -0.8658   0.2699   0.4213]
        Angle     61.0756
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3620"
}

Galaxy "IC 3621:NPM 1"
{
        Type  "E0"
        RA           12.6592
        Dec          15.5031
        Distance   6.608e+08  # distance uncertain!
        Radius     3.844e+04
        AbsMag        -20.13
        Axis    [  0.5356  -0.7620  -0.3639]
        Angle    130.0187
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3621"
}

Galaxy "IC 3622"
{
        Type  "Sc"
        RA           12.6589
        Dec          15.4322
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.5580  -0.7507  -0.3536]
        Angle    128.9774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3622"
}

Galaxy "IC 3623:MCG 5-30-50:ZWG 159.46:NPM 1"
{
        Type  "E0"
        RA           12.6575
        Dec          27.1028
        Distance   3.284e+08  # method: V
        Radius     5.254e+04
        AbsMag        -20.01
        Axis    [  0.4370  -0.6894  -0.5778]
        Angle     89.6254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3623"
}

Galaxy "IC 3624"
{
        Type  "E0"
        RA           12.6594
        Dec          11.9819
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5455  -0.7448  -0.3843]
        Angle    131.9245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3624"
}

Galaxy "IC 3625:ZWG 70.203:VCC 1799:NPM 1"
{
        Type  "E0"
        RA           12.6592
        Dec          10.9683
        Distance   4.169e+08  # distance uncertain!
        Radius     1.213e+04
        AbsMag        -20.13
        Axis    [  0.5483  -0.7398  -0.3900]
        Angle    132.4766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3625"
}

Galaxy "IC 3625A:MCG 2-32-165:ARAK 384"
{
        Type  "S0"
        RA           12.6592
        Dec          10.9672
        Distance    2.44e+08  # distance uncertain!
        Radius     1.065e+04
        AbsMag        -19.07
        Axis    [  0.5700  -0.7285  -0.3800]
        Angle    131.3221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3625A"
}

Galaxy "IC 3625B:MCG 2-32-166:VCC 1803"
{
        Type  "E0"
        RA           12.6603
        Dec          10.9761
        Distance   7.944e+08  # distance uncertain!
        Radius     4.622e+04
        AbsMag        -20.13
        Axis    [  0.5481  -0.7399  -0.3900]
        Angle    132.4811
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3625B"
}

Galaxy "IC 3626:ZWG 129.14:KUG 1237+259"
{
        Type  "S0"
        RA           12.6586
        Dec          25.6767
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.8493  -0.5253  -0.0522]
        Angle    105.4687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3626"
}

Galaxy "IC 3627:NPM 1:IRAS 12370+2746"
{
        Type  "S0"
        RA           12.6586
        Dec          27.4978
        Distance   4.869e+08  # distance uncertain!
        Radius     2.833e+04
        AbsMag        -19.07
        Axis    [  0.9125  -0.3867   0.1333]
        Angle     35.6166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3627"
}

Galaxy "IC 3629:ZWG 70.205:VCC 1808"
{
        Type  "Sc"
        RA           12.6628
        Dec          13.5331
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.9160  -0.3858  -0.1102]
        Angle     40.5080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3629"
}

Galaxy "IC 3629A:MCG 2-32-167"
{
        Type  "S0"
        RA           12.6636
        Dec          13.5486
        Distance    4.05e+08  # distance uncertain!
        Radius     4.123e+04
        AbsMag        -19.07
        Axis    [  0.9433  -0.3283  -0.0491]
        Angle    115.2964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3629A"
}

Galaxy "IC 3629B:MCG 2-32-168:VCC 1806"
{
        Type  "Sb"
        RA           12.6617
        Dec          13.6064
        Distance   4.869e+08  # distance uncertain!
        Radius     2.833e+04
        AbsMag        -19.07
        Axis    [  0.5628  -0.7418  -0.3646]
        Angle    129.9505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3629B"
}

Galaxy "IC 3631:UGC 7825:MCG 2-32-169:ZWG 70.204"
{
        Type  "Sa"
        RA           12.6631
        Dec          12.9744
        Distance   1.412e+08  # method: V
        Radius     1.643e+04
        AbsMag        -19.08
        Axis    [  0.6717  -0.4422  -0.5944]
        Angle     31.6706
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3631"
}

Galaxy "IC 3632"
{
        Type  "S0"
        RA           12.6664
        Dec          26.6822
        Distance   6.721e+08  # distance uncertain!
        Radius     2.933e+04
        AbsMag        -19.07
        Axis    [  0.8346  -0.4485  -0.3197]
        Angle     26.8012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3632"
}

Galaxy "IC 3633:ZWG 70.208:VCC 1826:NPM 1"
{
        Type  "E0"
        RA           12.6697
        Dec           9.8967
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [ -0.1436   0.0661  -0.9874]
        Angle     77.1353
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3633"
}

Galaxy "IC 3634:VCC 1825"
{
        Type  "E0"
        RA           12.6697
        Dec           9.8472
        Distance   5.012e+08  # distance uncertain!
        Radius     4.374e+04
        AbsMag        -20.13
        Axis    [  0.5502  -0.7349  -0.3966]
        Angle    133.1747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3634"
}

Galaxy "IC 3635:UGC 7830:ZWG 70.209:VCC 1828"
{
        Type  "Sc"
        RA           12.6703
        Dec          12.8753
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [ -0.7902   0.4127  -0.4530]
        Angle     60.0478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3635"
}

Galaxy "IC 3637:ZWG 99.107:VCC 1836"
{
        Type  "S0"
        RA           12.6719
        Dec          14.7150
        Distance   1.938e+08  # distance uncertain!
        Radius     6.202e+04
        AbsMag        -19.07
        Axis    [  0.9324  -0.3567  -0.0586]
        Angle     97.4368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3637"
}

Galaxy "IC 3638:MCG 2-32-172:ZWG 70.210:VCC 1830"
{
        Type  "Sc"
        RA           12.6711
        Dec          10.5186
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.2039  -0.0495  -0.9777]
        Angle     33.9015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3638"
}

Galaxy "IC 3639:ESO 381-8:MCG 6-28-11:FAIR 312"
{
        Type  "SBc"
        RA           12.6811
        Dec         -36.7558
        Distance   1.631e+08  # method: V
        Radius     2.846e+04
        AbsMag        -20.49
        Axis    [  0.6426  -0.4673  -0.6072]
        Angle    159.1869
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3639"
}

Galaxy "IC 3640"
{
        Type  "S0"
        RA           12.6736
        Dec          26.5244
        Distance   3.091e+08  # method: V
        Radius     1.798e+04
        AbsMag        -19.38
        Axis    [  0.9028  -0.4266   0.0541]
        Angle     75.4810
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3640"
}

Galaxy "IC 3641"
{
        Type  "S0"
        RA           12.6739
        Dec          26.5217
        Distance   6.721e+08  # distance uncertain!
        Radius     2.444e+04
        AbsMag        -19.07
        Axis    [ -0.8963   0.4143   0.1580]
        Angle     55.4336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3641"
}

Galaxy "IC 3642"
{
        Type  "E0"
        RA           12.6736
        Dec          26.7317
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [  0.4985  -0.8151  -0.2953]
        Angle    124.3357
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3642"
}

Galaxy "IC 3643"
{
        Type  "SBa"
        RA           12.6778
        Dec          12.4067
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.4509  -0.4007  -0.7975]
        Angle     42.8049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3643"
}

Galaxy "IC 3644:MCG 5-30-52:KUG 1238+267"
{
        Type  "Sb"
        RA           12.6767
        Dec          26.5047
        Distance   2.934e+08  # distance uncertain!
        Radius      3.84e+04
        AbsMag        -19.07
        Axis    [  0.9487  -0.2480   0.1962]
        Angle    103.1229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3644"
}

Galaxy "IC 3646:MCG 5-38-53:ZWG 159.49:KUG 1238+268"
{
        Type  "S0"
        RA           12.6772
        Dec          26.5256
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.8899  -0.3206   0.3245]
        Angle     26.9127
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3646"
}

Galaxy "IC 3647:UGC 7834:MCG 2-32-173:ZWG 70.211"
{
        Type  "Irr"
        RA           12.6814
        Dec          10.4764
        Distance   2.631e+08  # distance uncertain!
        Radius     6.121e+04
        AbsMag        -20.13
        Axis    [ -0.8573   0.1570  -0.4903]
        Angle     29.3182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3647"
}

Galaxy "IC 3649"
{
        Type  "E0"
        RA           12.6803
        Dec          21.1044
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.5165  -0.7898  -0.3308]
        Angle    127.2533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3649"
}

Galaxy "IC 3651:UGC 7835:MCG 5-30-54:ZWG 159.50"
{
        Type  "S0"
        RA           12.6811
        Dec          26.7286
        Distance   2.274e+08  # method: V
        Radius     3.307e+04
        AbsMag        -19.92
        Axis    [  0.5210  -0.8054  -0.2827]
        Angle    123.5409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3651"
}

Galaxy "IC 3652:UGC 7838:MCG 2-32-175:ZWG 70.212"
{
        Type  "E0"
        RA           12.6828
        Dec          11.1842
        Distance   2.631e+08  # distance uncertain!
        Radius     3.061e+04
        AbsMag        -20.13
        Axis    [  0.5453  -0.7423  -0.3895]
        Angle    132.5445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3652"
}

Galaxy "IC 3653:MCG 2-32-178:ZWG 70.215:VCC 1871"
{
        Type  "E0"
        RA           12.6875
        Dec          11.3878
        Distance   4.802e+07  # method: S
        Radius          3492
        AbsMag        -16.04
        Axis    [  0.5442  -0.7436  -0.3885]
        Angle    132.4709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3653"
}

Galaxy "IC 3654:NPM 1:KUG 1238+228"
{
        Type  "E0"
        RA           12.6867
        Dec          22.5900
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.5110  -0.7970  -0.3218]
        Angle    126.5474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3654"
}

Galaxy "IC 3655:NPM 1"
{
        Type  "E0"
        RA           12.6872
        Dec          20.6667
        Distance   9.121e+08  # distance uncertain!
        Radius     2.653e+04
        AbsMag        -20.13
        Axis    [  0.5171  -0.7882  -0.3337]
        Angle    127.5411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3655"
}

Galaxy "IC 3656:KUG 1238+228"
{
        Type  "S0"
        RA           12.6869
        Dec          22.5947
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.9007  -0.3466   0.2618]
        Angle     26.4238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3656"
}

Galaxy "IC 3658:ZWG 99.110:VCC 1876"
{
        Type  "E0"
        RA           12.6889
        Dec          14.7011
        Distance   3.312e+08  # distance uncertain!
        Radius     6.262e+04
        AbsMag        -20.13
        Axis    [  0.2357  -0.3953  -0.8878]
        Angle     80.0626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3658"
}

Galaxy "IC 3659:KUG 1238+232"
{
        Type  "S0"
        RA           12.6908
        Dec          22.9308
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.9085  -0.4178   0.0059]
        Angle     35.5095
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3659"
}

Galaxy "IC 3661"
{
        Type  "S0"
        RA           12.6931
        Dec          22.4950
        Distance   4.441e+08  # distance uncertain!
        Radius     3.875e+04
        AbsMag        -19.07
        Axis    [  0.3864  -0.0862   0.9183]
        Angle     26.7819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3661"
}

Galaxy "IC 3662:MCG 4-30-14:ZWG 129.17:KUG 1239+236"
{
        Type  "S0"
        RA           12.6933
        Dec          23.4253
        Distance   4.034e+08  # method: V
        Radius     4.107e+04
        AbsMag        -20.36
        Axis    [  0.5307  -0.7910  -0.3046]
        Angle    125.2505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3662"
}

Galaxy "IC 3663:ZWG 70.217:VCC 1886"
{
        Type  "E0"
        RA           12.6942
        Dec          12.2475
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [ -0.4729   0.5452  -0.6922]
        Angle     92.6387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3663"
}

Galaxy "IC 3665:UGC 7855:MCG 2-32-180:ZWG 70.220"
{
        Type  "Irr"
        RA           12.6961
        Dec          11.4881
        Distance   3.312e+08  # distance uncertain!
        Radius     4.335e+04
        AbsMag        -20.13
        Axis    [  0.7458  -0.4689  -0.4732]
        Angle     49.5494
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3665"
}

Galaxy "IC 3670"
{
        Type  "E0"
        RA           12.6986
        Dec          11.7733
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.5326  -0.7371  -0.4161]
        Angle    128.6413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3670"
}

Galaxy "IC 3671:MCG 4-30-15:ZWG 129.19:KUG 1239+237"
{
        Type  "SBc"
        RA           12.6975
        Dec          23.5103
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.5300  -0.7916  -0.3041]
        Angle    125.2468
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3671"
}

Galaxy "IC 3677:NPM 1"
{
        Type  "E0"
        RA           12.7031
        Dec          20.8856
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5149  -0.7901  -0.3327]
        Angle    127.5687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3677"
}

Galaxy "IC 3678"
{
        Type  "S0"
        RA           12.7033
        Dec          20.8803
        Distance    4.65e+08  # distance uncertain!
        Radius     1.353e+04
        AbsMag        -19.07
        Axis    [  0.5376  -0.7796  -0.3211]
        Angle    126.5929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3678"
}

Galaxy "IC 3683:NPM 1"
{
        Type  "S0"
        RA           12.7056
        Dec          20.8719
        Distance    5.59e+08  # distance uncertain!
        Radius     2.439e+04
        AbsMag        -19.07
        Axis    [  0.8311  -0.5039  -0.2354]
        Angle     57.3380
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3683"
}

Galaxy "IC 3684:VCC 1921"
{
        Type  "Sa"
        RA           12.7072
        Dec          11.7394
        Distance   3.369e+08  # distance uncertain!
        Radius     5.389e+04
        AbsMag        -19.07
        Axis    [  0.9553  -0.2927  -0.0424]
        Angle    101.2576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3684"
}

Galaxy "IC 3686:MCG 2-32-186:ZWG 71.1:ZWG 70.227"
{
        Type  "Sc"
        RA           12.7100
        Dec          10.5650
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [ -0.9822   0.1871  -0.0143]
        Angle     56.0900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3686"
}

Galaxy "IC 3687:UGC 7866:MCG 7-26-39:DDO 141"
{
        Type  "Irr"
        RA           12.7042
        Dec          38.5036
        Distance   2.704e+07  # method: V
        Radius          9834
        AbsMag        -15.89
        Axis    [  0.8320  -0.5450   0.1035]
        Angle    106.4702
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3687"
}

Galaxy "IC 3689"
{
        Type  "E0"
        RA           12.7103
        Dec          20.8503
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.5142  -0.7903  -0.3331]
        Angle    127.6510
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3689"
}

Galaxy "IC 3690:UGC 7879:ZWG 71.4:VCC 1940"
{
        Type  "Sb"
        RA           12.7136
        Dec          10.3578
        Distance   3.596e+08  # method: V
        Radius     5.754e+04
        AbsMag        -20.11
        Axis    [  0.9750  -0.2220  -0.0114]
        Angle    108.9996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3690"
}

Galaxy "IC 3691"
{
        Type  "Irr"
        RA           12.7136
        Dec          22.7728
        Distance    8.71e+08  # distance uncertain!
        Radius     7.601e+04
        AbsMag        -20.13
        Axis    [  0.5307  -0.7891  -0.3093]
        Angle    125.7527
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3691"
}

Galaxy "IC 3692:UGC 7885:MCG 4-30-16:ZWG 129.20"
{
        Type  "SBa"
        RA           12.7147
        Dec          20.9894
        Distance   3.098e+08  # method: V
        Radius     4.055e+04
        AbsMag        -20.19
        Axis    [  0.4894  -0.3852  -0.7824]
        Angle     30.1688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3692"
}

Galaxy "IC 3693:ZWG 71.5:VCC 1948"
{
        Type  "E0"
        RA           12.7161
        Dec          10.6814
        Distance   3.802e+08  # distance uncertain!
        Radius     3.318e+04
        AbsMag        -20.13
        Axis    [  0.1879  -0.3538  -0.9163]
        Angle     82.2641
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3693"
}

Galaxy "IC 3694:MCG 2-32-192:ZWG 71.10:VV 505"
{
        Type  "Sc"
        RA           12.7186
        Dec          11.2114
        Distance   3.965e+08  # method: V
        Radius      3.46e+04
        AbsMag        -20.52
        Axis    [  0.8474  -0.4675  -0.2515]
        Angle     88.7419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3694"
}

Galaxy "IC 3696"
{
        Type  "E0"
        RA           12.7192
        Dec          19.9281
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5162  -0.7865  -0.3390]
        Angle    128.2048
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3696"
}

Galaxy "IC 3697:MCG 7-26-41:NPM 1"
{
        Type  "S0"
        RA           12.7161
        Dec          39.8461
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [  0.6857  -0.7272  -0.0325]
        Angle    114.6116
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3697"
}

Galaxy "IC 3698:MCG 2-32-193:ZWG 71.12:VCC 1961"
{
        Type  "Sc"
        RA           12.7214
        Dec          11.2111
        Distance     3.9e+08  # method: V
        Radius     2.836e+04
        AbsMag        -20.19
        Axis    [  0.5631  -0.7335  -0.3807]
        Angle    131.6781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3698"
}

Galaxy "IC 3701-1:VCC 1971"
{
        Type  "E0"
        RA           12.7250
        Dec          11.0469
        Distance   7.245e+08  # distance uncertain!
        Radius     4.215e+04
        AbsMag        -20.13
        Axis    [  0.5413  -0.7441  -0.3916]
        Angle    132.9525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3701-1"
}

Galaxy "IC 3701-2:VCC 1971"
{
        Type  "E0"
        RA           12.7253
        Dec          11.0494
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5413  -0.7441  -0.3916]
        Angle    132.9533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3701-2"
}

Galaxy "IC 3702:ZWG 71.14:VCC 1969"
{
        Type  "SBc"
        RA           12.7244
        Dec          10.8736
        Distance    4.06e+08  # method: V
        Radius     1.771e+04
        AbsMag        -20.18
        Axis    [  0.8239  -0.4715  -0.3144]
        Angle     74.6203
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3702"
}

Galaxy "IC 3704:UGC 7899:MCG 2-33-3:ZWG 71.17"
{
        Type  "Sc"
        RA           12.7292
        Dec          10.7697
        Distance   4.083e+08  # method: V
        Radius     7.127e+04
        AbsMag        -20.69
        Axis    [  0.9696  -0.2390   0.0529]
        Angle     72.3729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3704"
}

Galaxy "IC 3705-1"
{
        Type  "E0"
        RA           12.7281
        Dec          19.3267
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.5172  -0.7842  -0.3429]
        Angle    128.5935
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3705-1"
}

Galaxy "IC 3705-2"
{
        Type  "E0"
        RA           12.7281
        Dec          19.3231
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.5172  -0.7842  -0.3429]
        Angle    128.5954
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3705-2"
}

Galaxy "IC 3709:ZWG 71.20:VCC 1988"
{
        Type  "Sc"
        RA           12.7344
        Dec           9.0636
        Distance   6.641e+08  # method: V
        Radius     6.761e+04
        AbsMag        -21.54
        Axis    [  0.8548  -0.4760  -0.2066]
        Angle    118.9294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3709"
}

Galaxy "IC 3710:UGC 7906:VCC 1992"
{
        Type  "Irr"
        RA           12.7358
        Dec          12.1144
        Distance   6.016e+07  # method: V
        Radius          9625
        AbsMag        -16.03
        Axis    [ -0.8868   0.3083  -0.3442]
        Angle     48.0210
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3710"
}

Galaxy "IC 3711:VCC 1991"
{
        Type  "E0"
        RA           12.7358
        Dec          11.1767
        Distance   4.571e+08  # distance uncertain!
        Radius     4.654e+04
        AbsMag        -20.13
        Axis    [  0.3433  -0.5401  -0.7684]
        Angle     93.1726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3711"
}

Galaxy "IC 3713:MCG 7-26-46:ZWG 216.23:NPM 1"
{
        Type  "S0"
        RA           12.7342
        Dec          41.1694
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [ -0.2214   0.7178  -0.6601]
        Angle     25.0745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3713"
}

Galaxy "IC 3714:MCG 2-33-5:ZWG 71.22:VCC 1997"
{
        Type  "SBb"
        RA           12.7397
        Dec          10.1889
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.8636   0.2253  -0.4509]
        Angle     39.7029
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3714"
}

Galaxy "IC 3715"
{
        Type  "S0"
        RA           12.7392
        Dec          20.0239
        Distance   6.721e+08  # distance uncertain!
        Radius     2.933e+04
        AbsMag        -19.07
        Axis    [  0.5367  -0.7777  -0.3275]
        Angle    127.3320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3715"
}

Galaxy "IC 3717:MCG 7-26-47"
{
        Type  "S0"
        RA           12.7397
        Dec          39.5222
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [ -0.7248   0.4660   0.5074]
        Angle     53.2392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3717"
}

Galaxy "IC 3718:UGC 7920:MCG 2-33-8:ZWG 71.26"
{
        Type  "Sc"
        RA           12.7458
        Dec          12.3508
        Distance   5.282e+07  # method: V
        Radius     2.074e+04
        AbsMag        -17.35
        Axis    [  0.9260  -0.3755  -0.0382]
        Angle     43.6349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3718"
}

Galaxy "IC 3719:ZWG 43.16:VCC 2007"
{
        Type  "S0"
        RA           12.7464
        Dec           8.1067
        Distance    9.88e+07  # method: V
        Radius          5748
        AbsMag        -17.01
        Axis    [  0.7297  -0.4863  -0.4807]
        Angle     29.5446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3719"
}

Galaxy "IC 3720:UGC 7919:DDO 145:VCC 2008"
{
        Type  "E0"
        RA           12.7464
        Dec          12.0647
        Distance   3.468e+08  # distance uncertain!
        Radius     6.557e+04
        AbsMag        -20.13
        Axis    [ -0.1435   0.0651  -0.9875]
        Angle     74.6821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3720"
}

Galaxy "IC 3721:IC 3725:UGC 7923:MCG 3-33-2"
{
        Type  "S0"
        RA           12.7481
        Dec          18.7553
        Distance   3.132e+08  # method: V
        Radius       4.1e+04
        AbsMag        -20.91
        Axis    [ -0.8966   0.1684   0.4095]
        Angle     22.3660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3721"
}

Galaxy "IC 3723:MCG 7-26-48:MK 441:ZWG 216.24"
{
        Type  "S0"
        RA           12.7417
        Dec          40.7372
        Distance   2.546e+08  # method: V
        Radius     1.111e+04
        AbsMag        -18.56
        Axis    [  0.9143  -0.3269   0.2393]
        Angle     21.7061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3723"
}

Galaxy "IC 3724:ZWG 71.27:VCC 2009"
{
        Type  "Sc"
        RA           12.7481
        Dec          10.2819
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.7930  -0.4634  -0.3955]
        Angle     49.8007
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3724"
}

Galaxy "IC 3726:UGC 7921:MCG 7-26-49:ZWG 216.25"
{
        Type  "Sc"
        RA           12.7450
        Dec          40.6789
        Distance     2.4e+08  # method: V
        Radius     5.236e+04
        AbsMag        -18.83
        Axis    [  0.1484   0.1280   0.9806]
        Angle     42.4193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3726"
}

Galaxy "IC 3727-1:UGC 7927:MCG 2-33-9:ZWG 71.28"
{
        Type  "Sc"
        RA           12.7514
        Dec          10.9006
        Distance   1.155e+08  # method: V
        Radius     1.679e+04
        AbsMag        -18.34
        Axis    [ -0.7629   0.3593  -0.5375]
        Angle     56.4603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3727-1"
}

Galaxy "IC 3727-2:UGC 7927:MCG 2-33-9:ZWG 71.28"
{
        Type  "E0"
        RA           12.7511
        Dec          10.9000
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.5391  -0.7448  -0.3932]
        Angle    133.2382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3727-2"
}

Galaxy "IC 3728"
{
        Type  "E0"
        RA           12.7508
        Dec          20.9739
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.5098  -0.7931  -0.3333]
        Angle    127.9490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3728"
}

Galaxy "IC 3729:MCG 7-26-50:NPM 1"
{
        Type  "S0"
        RA           12.7481
        Dec          39.3517
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [  0.8239  -0.5595   0.0909]
        Angle     70.5306
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3729"
}

Galaxy "IC 3730:MCG 4-30-18:ZWG 129.21:ARAK 386"
{
        Type  "Sc"
        RA           12.7517
        Dec          21.1700
        Distance   3.174e+08  # method: V
        Radius     1.385e+04
        AbsMag        -19.54
        Axis    [  0.5319  -0.7838  -0.3205]
        Angle    126.8775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3730"
}

Galaxy "IC 3731:NPM 1"
{
        Type  "E0"
        RA           12.7514
        Dec          12.4469
        Distance   6.919e+08  # distance uncertain!
        Radius     5.032e+04
        AbsMag        -20.13
        Axis    [ -0.0122  -0.1063  -0.9943]
        Angle     74.6111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3731"
}

Galaxy "IC 3732:VCC 2015"
{
        Type  "E0"
        RA           12.7531
        Dec          10.3242
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.4092  -0.6140  -0.6749]
        Angle    102.6049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3732"
}

Galaxy "IC 3734"
{
        Type  "E0"
        RA           12.7525
        Dec          23.0389
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.5030  -0.8027  -0.3204]
        Angle    126.9184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3734"
}

Galaxy "IC 3735:MCG 2-33-10:ZWG 71.31:VCC 2019"
{
        Type  "S0"
        RA           12.7556
        Dec          13.6931
        Distance   1.001e+08  # method: V
        Radius      1.31e+04
        AbsMag        -17.63
        Axis    [ -0.9348   0.2970  -0.1949]
        Angle     47.6434
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3735"
}

Galaxy "IC 3736:MCG 4-30-20:ZWG 129.23:KUG 1242+218"
{
        Type  "Sc"
        RA           12.7550
        Dec          21.5358
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.8830   0.4474  -0.1420]
        Angle     49.6840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3736"
}

Galaxy "IC 3740:ZWG 129.24:NPM 1:KUG 1243+210"
{
        Type  "S0"
        RA           12.7583
        Dec          20.8164
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.9075  -0.4195  -0.0225]
        Angle    106.8998
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3740"
}

Galaxy "IC 3742:UGC 7932:MCG 2-33-11:ZWG 71.32"
{
        Type  "SBc"
        RA           12.7586
        Dec          13.3319
        Distance   5.799e+07  # method: V
        Radius     1.434e+04
        AbsMag        -17.45
        Axis    [  0.8914  -0.4220  -0.1656]
        Angle     71.7003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3742"
}

Galaxy "IC 3744:NPM 1"
{
        Type  "E0"
        RA           12.7614
        Dec          19.5008
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [ -0.3535   0.4773  -0.8045]
        Angle     78.5968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3744"
}

Galaxy "IC 3745:MCG 3-33-3:ZWG 100.6:NPM 1"
{
        Type  "S0"
        RA           12.7622
        Dec          19.1778
        Distance   1.851e+08  # distance uncertain!
        Radius     1.885e+04
        AbsMag        -19.07
        Axis    [  0.5369  -0.7750  -0.3334]
        Angle    127.9521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3745"
}

Galaxy "IC 3746:ZWG 188.19:NPM 1"
{
        Type  "E0"
        RA           12.7586
        Dec          37.8239
        Distance   5.012e+08  # distance uncertain!
        Radius     1.458e+04
        AbsMag        -20.13
        Axis    [  0.4486  -0.8658  -0.2218]
        Angle    119.9301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3746"
}

Galaxy "IC 3751:NPM 1"
{
        Type  "E0"
        RA           12.7625
        Dec          37.8236
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4482  -0.8660  -0.2218]
        Angle    119.9714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3751"
}

Galaxy "IC 3754:UGC 7937:MCG 2-33-13:ZWG 71.34"
{
        Type  "SBb"
        RA           12.7708
        Dec           8.3492
        Distance   3.077e+08  # method: V
        Radius     5.371e+04
        AbsMag        -20.37
        Axis    [ -0.7724  -0.1387  -0.6198]
        Angle     18.8254
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3754"
}

Galaxy "IC 3756"
{
        Type  "S0"
        RA           12.7694
        Dec          11.9153
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8810  -0.4386  -0.1773]
        Angle     97.4349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3756"
}

Galaxy "IC 3758:ZWG 216.26:NPM 1"
{
        Type  "E0"
        RA           12.7664
        Dec          40.7753
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [  0.4357  -0.8774  -0.2008]
        Angle    118.7085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3758"
}

Galaxy "IC 3759"
{
        Type  "S0"
        RA           12.7714
        Dec          20.7833
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.9213   0.2318   0.3122]
        Angle     46.5429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3759"
}

Galaxy "IC 3760:MCG 2-33-14:NPM 1"
{
        Type  "S0"
        RA           12.7717
        Dec          11.8739
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [  0.4067  -0.4288  -0.8067]
        Angle     27.9219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3760"
}

Galaxy "IC 3761:NPM 1"
{
        Type  "E0"
        RA           12.7742
        Dec          20.2897
        Distance   1.202e+09  # distance uncertain!
        Radius     5.246e+04
        AbsMag        -20.13
        Axis    [  0.3123  -0.5192  -0.7955]
        Angle     80.2532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3761"
}

Galaxy "IC 3762"
{
        Type  "E0"
        RA           12.7769
        Dec          22.2469
        Distance   1.097e+09  # distance uncertain!
        Radius      3.19e+04
        AbsMag        -20.13
        Axis    [  0.4318  -0.6976  -0.5718]
        Angle     97.2636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3762"
}

Galaxy "IC 3763:KUG 1244+222"
{
        Type  "S0"
        RA           12.7792
        Dec          21.9850
        Distance   5.339e+08  # distance uncertain!
        Radius     3.106e+04
        AbsMag        -19.07
        Axis    [  0.5266  -0.7892  -0.3160]
        Angle    126.7257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3763"
}

Galaxy "IC 3766:NPM 1"
{
        Type  "E0"
        RA           12.7814
        Dec          19.1111
        Distance   1.047e+09  # distance uncertain!
        Radius     3.046e+04
        AbsMag        -20.13
        Axis    [  0.5125  -0.7861  -0.3455]
        Angle    129.1713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3766"
}

Galaxy "IC 3767:VCC 2045"
{
        Type  "E0"
        RA           12.7819
        Dec          10.1819
        Distance   6.026e+08  # distance uncertain!
        Radius     5.259e+04
        AbsMag        -20.13
        Axis    [  0.2133  -0.4039  -0.8896]
        Angle     84.6092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3767"
}

Galaxy "IC 3771:NPM 1"
{
        Type  "E0"
        RA           12.7811
        Dec          39.1736
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [  0.3861  -0.6135  -0.6888]
        Angle     64.7737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3771"
}

Galaxy "IC 3772:MCG 6-28-28:ZWG 188.20"
{
        Type  "SBa"
        RA           12.7822
        Dec          36.5311
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.8674  -0.4471   0.2185]
        Angle     41.9257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3772"
}

Galaxy "IC 3773:UGC 7952:MCG 2-33-21:ZWG 71.40"
{
        Type  "E0"
        RA           12.7875
        Dec          10.2033
        Distance   6.406e+07  # method: V
        Radius      1.77e+04
        AbsMag        -17.56
        Axis    [  0.4901  -0.7015  -0.5174]
        Angle    119.4190
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3773"
}

Galaxy "IC 3774:UGC 7947:MCG 6-28-29"
{
        Type  "S0"
        RA           12.7836
        Dec          36.2881
        Distance   4.241e+08  # distance uncertain!
        Radius     5.551e+04
        AbsMag        -19.07
        Axis    [  0.3954   0.0802   0.9150]
        Angle     18.5213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3774"
}

Galaxy "IC 3775:UGC 7953:VCC 2049"
{
        Type  "Sc"
        RA           12.7878
        Dec          11.7603
        Distance    4.05e+08  # distance uncertain!
        Radius     5.301e+04
        AbsMag        -19.07
        Axis    [  0.9447  -0.3277  -0.0110]
        Angle     61.6369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3775"
}

Galaxy "IC 3776:KUG 1244+227"
{
        Type  "S0"
        RA           12.7867
        Dec          22.4842
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [  0.8687  -0.4894  -0.0762]
        Angle     86.3779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3776"
}

Galaxy "IC 3778:ZWG 216.28:NPM 1"
{
        Type  "E0"
        RA           12.7836
        Dec          40.5969
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.4339  -0.8088  -0.3969]
        Angle     89.2757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3778"
}

Galaxy "IC 3779:ZWG 71.41:VCC 2050"
{
        Type  "E0"
        RA           12.7889
        Dec          12.1661
        Distance   4.169e+08  # distance uncertain!
        Radius     4.245e+04
        AbsMag        -20.13
        Axis    [ -0.1054   0.0018  -0.9944]
        Angle     74.1516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3779"
}

Galaxy "IC 3783:MCG 7-26-52:ZWG 216.29"
{
        Type  "S0"
        RA           12.7908
        Dec          40.5664
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.1148   0.4891  -0.8646]
        Angle     16.1767
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3783"
}

Galaxy "IC 3784:NPM 1:KUG 1245+196"
{
        Type  "S0"
        RA           12.7972
        Dec          19.3847
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [  0.9006  -0.4314  -0.0527]
        Angle     71.1643
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3784"
}

Galaxy "IC 3785"
{
        Type  "S0"
        RA           12.7978
        Dec          19.2750
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.5330  -0.7775  -0.3338]
        Angle    128.2131
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3785"
}

Galaxy "IC 3786:NPM 1"
{
        Type  "S0"
        RA           12.7933
        Dec          39.0464
        Distance   4.441e+08  # distance uncertain!
        Radius     2.583e+04
        AbsMag        -19.07
        Axis    [ -0.6624   0.7388  -0.1242]
        Angle     55.1886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3786"
}

Galaxy "IC 3788:MCG 3-33-5"
{
        Type  "S0"
        RA           12.8019
        Dec          18.8681
        Distance   6.721e+08  # distance uncertain!
        Radius     4.888e+04
        AbsMag        -19.07
        Axis    [  0.5338  -0.7758  -0.3364]
        Angle    128.4496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3788"
}

Galaxy "IC 3789"
{
        Type  "S0"
        RA           12.8019
        Dec          20.1942
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.7885  -0.5942  -0.1587]
        Angle    118.4589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3789"
}

Galaxy "IC 3793"
{
        Type  "S0"
        RA           12.8031
        Dec          19.1517
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.9037  -0.3649   0.2238]
        Angle     37.1230
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3793"
}

Galaxy "IC 3795:MCG 7-26-53:ZWG 216.30"
{
        Type  "S0"
        RA           12.8014
        Dec          40.7189
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.9027  -0.2996   0.3089]
        Angle    113.4005
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3795"
}

Galaxy "IC 3799:MCG 2-33-11:FGC 1502"
{
        Type  "Sc"
        RA           12.8164
        Dec         -14.3986
        Distance   1.822e+08  # method: V
        Radius      6.36e+04
        AbsMag        -19.33
        Axis    [  0.9695  -0.0921  -0.2272]
        Angle     83.6480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3799"
}

Galaxy "IC 3800"
{
        Type  "E0"
        RA           12.8075
        Dec          36.5750
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [  0.4489  -0.8632  -0.2312]
        Angle    121.0061
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3800"
}

Galaxy "IC 3806:UGC 7974:MCG 3-33-6:ZWG 100.8"
{
        Type  "Sa"
        RA           12.8153
        Dec          14.9072
        Distance   1.577e+08  # method: V
        Radius     3.212e+04
        AbsMag        -18.72
        Axis    [ -0.9715   0.2142   0.1011]
        Angle     61.6175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3806"
}

Galaxy "IC 3808:MCG 7-26-55:ZWG 216.32:MK 445"
{
        Type  "Sc"
        RA           12.8161
        Dec          40.5958
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.7249   0.5765   0.3771]
        Angle     48.6033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3808"
}

Galaxy "IC 3809:NPM 1"
{
        Type  "E0"
        RA           12.8178
        Dec          36.4894
        Distance   7.245e+08  # distance uncertain!
        Radius     5.269e+04
        AbsMag        -20.13
        Axis    [ -0.2738   0.6941  -0.6658]
        Angle     75.2717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3809"
}

Galaxy "IC 3812:MCG 1-33-19:IRAS 12472-0626"
{
        Type  "S0"
        RA           12.8314
        Dec          -6.7172
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.9341  -0.2528  -0.2520]
        Angle    114.4725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3812"
}

Galaxy "IC 3813:ESO 507-19:MCG 4-30-24:AM 1247-253"
{
        Type  "S0"
        RA           12.8339
        Dec         -25.9200
        Distance   1.592e+08  # method: V
        Radius     3.011e+04
        AbsMag        -19.74
        Axis    [ -0.8475  -0.0970  -0.5219]
        Angle     79.2829
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3813"
}

Galaxy "IC 3814"
{
        Type  "Sb"
        RA           12.8256
        Dec          20.0500
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [ -0.3221   0.1094  -0.9404]
        Angle     27.3234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3814"
}

Galaxy "IC 3815:KUG 1247+195"
{
        Type  "S0"
        RA           12.8272
        Dec          19.2747
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [ -0.9517   0.2773   0.1319]
        Angle     44.3150
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3815"
}

Galaxy "IC 3816:MCG 6-28-34:NPM 1"
{
        Type  "E0"
        RA           12.8244
        Dec          37.2308
        Distance   5.755e+08  # distance uncertain!
        Radius     4.185e+04
        AbsMag        -20.13
        Axis    [  0.4447  -0.8665  -0.2268]
        Angle    120.8916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3816"
}

Galaxy "IC 3817"
{
        Type  "Irr"
        RA           12.8286
        Dec          22.8317
        Distance    8.71e+08  # distance uncertain!
        Radius     3.801e+04
        AbsMag        -20.13
        Axis    [  0.8336  -0.5339  -0.1418]
        Angle     77.2487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3817"
}

Galaxy "IC 3818"
{
        Type  "S0"
        RA           12.8294
        Dec          21.7519
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.9355   0.3319   0.1211]
        Angle     62.2332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3818"
}

Galaxy "IC 3819:NPM 1"
{
        Type  "E0"
        RA           12.8378
        Dec         -14.3800
        Distance   6.608e+08  # distance uncertain!
        Radius     2.883e+04
        AbsMag        -20.13
        Axis    [  0.0496  -0.2854  -0.9571]
        Angle    104.2091
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3819"
}

Galaxy "IC 3820"
{
        Type  "E0"
        RA           12.8275
        Dec          37.1172
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.4448  -0.8662  -0.2276]
        Angle    120.9745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3820"
}

Galaxy "IC 3822:MCG 2-33-19"
{
        Type  "Sc"
        RA           12.8394
        Dec         -14.3225
        Distance   3.072e+08  # distance uncertain!
        Radius     5.362e+04
        AbsMag        -19.07
        Axis    [  0.9670  -0.1056  -0.2317]
        Angle     80.7402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3822"
}

Galaxy "IC 3824:NPM 1"
{
        Type  "E0"
        RA           12.8417
        Dec         -14.4253
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.5839  -0.6174  -0.5271]
        Angle    148.1144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3824"
}

Galaxy "IC 3825"
{
        Type  "S0"
        RA           12.8436
        Dec         -14.5197
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8570  -0.3269  -0.3982]
        Angle    119.4725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3825"
}

Galaxy "IC 3826:MCG 1-33-25"
{
        Type  "S0"
        RA           12.8442
        Dec          -9.0308
        Distance   1.978e+08  # method: V
        Radius     5.466e+04
        AbsMag        -19.71
        Axis    [ -0.9829  -0.0667  -0.1717]
        Angle     67.0674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3826"
}

Galaxy "IC 3827:IC 3838:MCG 2-33-21:IRAS 12482-1413"
{
        Type  "Sc"
        RA           12.8475
        Dec         -14.4917
        Distance   1.404e+08  # distance uncertain!
        Radius     1.634e+04
        AbsMag        -19.07
        Axis    [  0.4701  -0.4244  -0.7739]
        Angle     88.7317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3827"
}

Galaxy "IC 3828:NPM 1"
{
        Type  "S0"
        RA           12.8389
        Dec          37.9494
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8211  -0.5665   0.0694]
        Angle     66.2693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3828"
}

Galaxy "IC 3829:ESO 442-24:MCG 5-30-10:AM 1248-273"
{
        Type  "Sc"
        RA           12.8589
        Dec         -27.7831
        Distance   1.212e+08  # method: T-F
        Radius     3.349e+04
        AbsMag        -18.75
        Axis    [ -0.1943  -0.3843  -0.9025]
        Angle     55.7204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3829"
}

Galaxy "IC 3831:MCG 2-33-27"
{
        Type  "S0"
        RA           12.8550
        Dec         -14.5733
        Distance   1.223e+08  # distance uncertain!
        Radius      2.49e+04
        AbsMag        -19.07
        Axis    [ -0.7659  -0.1208  -0.6315]
        Angle     57.0744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3831"
}

Galaxy "IC 3832:MCG 7-26-57"
{
        Type  "Sc"
        RA           12.8469
        Dec          39.8100
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.4563  -0.8684  -0.1940]
        Angle    119.3976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3832"
}

Galaxy "IC 3835"
{
        Type  "S0"
        RA           12.8486
        Dec          40.1867
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.6825  -0.1578   0.7137]
        Angle     24.2342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3835"
}

Galaxy "IC 3836"
{
        Type  "S0"
        RA           12.8508
        Dec          40.1839
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.6508  -0.1699   0.7400]
        Angle     39.8716
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3836"
}

Galaxy "IC 3837"
{
        Type  "S0"
        RA           12.8592
        Dec          19.7231
        Distance   5.854e+08  # distance uncertain!
        Radius     2.554e+04
        AbsMag        -19.07
        Axis    [  0.8934  -0.3806   0.2387]
        Angle     37.6348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3837"
}

Galaxy "IC 3842:NPM 1"
{
        Type  "E0"
        RA           12.8597
        Dec          40.3719
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.4286  -0.8800  -0.2047]
        Angle    119.8986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3842"
}

Galaxy "IC 3843"
{
        Type  "S0"
        RA           12.8608
        Dec          39.0008
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.8496  -0.5116   0.1286]
        Angle    117.5393
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3843"
}

Galaxy "IC 3844:MCG 7-26-59:NPM 1"
{
        Type  "Sc"
        RA           12.8683
        Dec          39.8186
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.8019  -0.5916   0.0830]
        Angle     86.4906
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3844"
}

Galaxy "IC 3847:NPM 1:KUG 1250+223"
{
        Type  "S0"
        RA           12.8758
        Dec          22.0653
        Distance   8.081e+08  # distance uncertain!
        Radius     3.526e+04
        AbsMag        -19.07
        Axis    [ -0.7093   0.2706  -0.6509]
        Angle     18.0133
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3847"
}

Galaxy "IC 3848-1"
{
        Type  "S0"
        RA           12.8778
        Dec          21.4147
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.5186  -0.7920  -0.3221]
        Angle    127.8850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3848-1"
}

Galaxy "IC 3848-2"
{
        Type  "S0"
        RA           12.8778
        Dec          21.4167
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.8455  -0.5332  -0.0271]
        Angle     21.7458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3848-2"
}

Galaxy "IC 3850:MCG 7-27-1"
{
        Type  "S0"
        RA           12.8775
        Dec          40.1031
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [  0.7478  -0.6624  -0.0452]
        Angle     71.3360
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3850"
}

Galaxy "IC 3852:UGC 8019:MCG 6-28-38:KUG 1250+360"
{
        Type  "SBc"
        RA           12.8842
        Dec          35.7731
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.8589  -0.4568   0.2315]
        Angle     58.3290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3852"
}

Galaxy "IC 3853"
{
        Type  "E0"
        RA           12.8861
        Dec          38.8294
        Distance    8.71e+08  # distance uncertain!
        Radius     5.068e+04
        AbsMag        -20.13
        Axis    [  0.4324  -0.8754  -0.2161]
        Angle    120.8483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3853"
}

Galaxy "IC 3854-1:NPM 1"
{
        Type  "S0"
        RA           12.8867
        Dec          40.8489
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [  0.8657  -0.4569   0.2045]
        Angle    109.4495
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3854-1"
}

Galaxy "IC 3854-2:NPM 1"
{
        Type  "E0"
        RA           12.8872
        Dec          40.8486
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.4241  -0.8829  -0.2015]
        Angle    119.9956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3854-2"
}

Galaxy "IC 3855:NPM 1"
{
        Type  "S0"
        RA           12.8894
        Dec          36.7864
        Distance    4.65e+08  # distance uncertain!
        Radius     3.381e+04
        AbsMag        -19.07
        Axis    [  0.4922  -0.0810   0.8667]
        Angle     24.5178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3855"
}

Galaxy "IC 3856"
{
        Type  "S0"
        RA           12.8958
        Dec          20.0933
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [ -0.4462  -0.0678   0.8924]
        Angle     20.3699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3856"
}

Galaxy "IC 3857"
{
        Type  "E0"
        RA           12.8989
        Dec          19.6069
        Distance    8.71e+08  # distance uncertain!
        Radius     3.801e+04
        AbsMag        -20.13
        Axis    [  0.0900  -0.2450  -0.9653]
        Angle     69.1065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3857"
}

Galaxy "IC 3859"
{
        Type  "S0"
        RA           12.9053
        Dec          -9.1172
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [ -0.9735  -0.2106  -0.0894]
        Angle     54.9832
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3859"
}

Galaxy "IC 3861"
{
        Type  "E0"
        RA           12.8972
        Dec          38.2825
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.0535   0.1044  -0.9931]
        Angle     50.4215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3861"
}

Galaxy "IC 3862:UGC 8023:MCG 6-28-39:VV 266"
{
        Type  "Irr"
        RA           12.8981
        Dec          36.0867
        Distance   3.631e+08  # distance uncertain!
        Radius     6.866e+04
        AbsMag        -20.13
        Axis    [ -0.7754   0.5405   0.3264]
        Angle     42.9596
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3862"
}

Galaxy "IC 3863"
{
        Type  "S0"
        RA           12.8981
        Dec          38.4808
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.7156  -0.2378   0.6568]
        Angle     42.5743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3863"
}

Galaxy "IC 3864"
{
        Type  "S0"
        RA           12.9033
        Dec          18.9514
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.5344  -0.5237  -0.6634]
        Angle     22.9079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3864"
}

Galaxy "IC 3865"
{
        Type  "E0"
        RA           12.9039
        Dec          18.8686
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.5008  -0.7917  -0.3499]
        Angle    130.3700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3865"
}

Galaxy "IC 3866-1"
{
        Type  "S0"
        RA           12.9042
        Dec          22.3642
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.5130  -0.7979  -0.3165]
        Angle    127.6739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3866-1"
}

Galaxy "IC 3866-2"
{
        Type  "S0"
        RA           12.9042
        Dec          22.3597
        Distance   5.339e+08  # distance uncertain!
        Radius     3.882e+04
        AbsMag        -19.07
        Axis    [ -0.8360   0.1499   0.5279]
        Angle     15.9280
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3866-2"
}

Galaxy "IC 3867:NPM 1"
{
        Type  "S0"
        RA           12.9053
        Dec          18.9422
        Distance    4.05e+08  # distance uncertain!
        Radius     2.945e+04
        AbsMag        -19.07
        Axis    [  0.6422  -0.5764  -0.5053]
        Angle     19.8487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3867"
}

Galaxy "IC 3868"
{
        Type  "S0"
        RA           12.9056
        Dec          18.9906
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.7988  -0.5409  -0.2634]
        Angle     58.9616
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3868"
}

Galaxy "IC 3869"
{
        Type  "S0"
        RA           12.9058
        Dec          18.9717
        Distance   7.038e+08  # distance uncertain!
        Radius     3.071e+04
        AbsMag        -19.07
        Axis    [  0.7987  -0.5409  -0.2637]
        Angle     58.9681
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3869"
}

Galaxy "IC 3870"
{
        Type  "E0"
        RA           12.9058
        Dec          22.3811
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4897  -0.8079  -0.3279]
        Angle    128.6477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3870"
}

Galaxy "IC 3871"
{
        Type  "E0"
        RA           12.9069
        Dec          18.9289
        Distance   5.012e+08  # distance uncertain!
        Radius     2.916e+04
        AbsMag        -20.13
        Axis    [  0.5003  -0.7921  -0.3496]
        Angle    130.3668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3871"
}

Galaxy "IC 3872"
{
        Type  "E0"
        RA           12.9083
        Dec          18.9628
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.5001  -0.7923  -0.3494]
        Angle    130.3620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3872"
}

Galaxy "IC 3873"
{
        Type  "S0"
        RA           12.9086
        Dec          18.8825
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.2361  -0.0780  -0.9686]
        Angle     22.3446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3873"
}

Galaxy "IC 3874:NPM 1"
{
        Type  "E0"
        RA           12.9094
        Dec          18.9575
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.5000  -0.7924  -0.3495]
        Angle    130.3745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3874"
}

Galaxy "IC 3875"
{
        Type  "E0"
        RA           12.9103
        Dec          22.0358
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4904  -0.8066  -0.3302]
        Angle    128.8575
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3875"
}

Galaxy "IC 3876"
{
        Type  "S0"
        RA           12.9133
        Dec          19.0153
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.5222  -0.7828  -0.3384]
        Angle    129.3483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3876"
}

Galaxy "IC 3877:UGC 8036:MCG 3-33-16:ZWG 100.17"
{
        Type  "SBc"
        RA           12.9133
        Dec          19.1764
        Distance   7.987e+07  # method: T-F
        Radius     4.298e+04
        AbsMag        -18.24
        Axis    [  0.9518  -0.2792   0.1272]
        Angle     87.5336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3877"
}

Galaxy "IC 3879:MCG 7-27-2"
{
        Type  "S0"
        RA           12.9089
        Dec          38.6286
        Distance   4.241e+08  # distance uncertain!
        Radius     4.318e+04
        AbsMag        -19.07
        Axis    [  0.7728  -0.6338   0.0337]
        Angle    111.5857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3879"
}

Galaxy "IC 3880:NPM 1"
{
        Type  "E0"
        RA           12.9131
        Dec          22.5028
        Distance   1.259e+09  # distance uncertain!
        Radius     5.494e+04
        AbsMag        -20.13
        Axis    [ -0.3749   0.5336  -0.7581]
        Angle     77.6114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3880"
}

Galaxy "IC 3881"
{
        Type  "E0"
        RA           12.9150
        Dec          19.1178
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.4989  -0.7934  -0.3486]
        Angle    130.3435
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3881"
}

Galaxy "IC 3882"
{
        Type  "E0"
        RA           12.9147
        Dec          22.5750
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [ -0.3248   0.4479  -0.8330]
        Angle     72.6267
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3882"
}

Galaxy "IC 3883:MCG 1-33-49:IRAS 12526-0750"
{
        Type  "Sc"
        RA           12.9203
        Dec          -8.1203
        Distance    1.47e+08  # distance uncertain!
        Radius     1.925e+04
        AbsMag        -19.07
        Axis    [  0.9203  -0.2643  -0.2884]
        Angle    106.0110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3883"
}

Galaxy "IC 3884:NPM 1"
{
        Type  "E0"
        RA           12.9158
        Dec          19.6817
        Distance       1e+09  # distance uncertain!
        Radius     5.818e+04
        AbsMag        -20.13
        Axis    [  0.4971  -0.7961  -0.3451]
        Angle    130.0700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3884"
}

Galaxy "IC 3885"
{
        Type  "S0"
        RA           12.9117
        Dec          37.1544
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.4608  -0.8612  -0.2144]
        Angle    121.1851
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3885"
}

Galaxy "IC 3886"
{
        Type  "S0"
        RA           12.9167
        Dec          19.0114
        Distance   1.065e+09  # distance uncertain!
        Radius     3.099e+04
        AbsMag        -19.07
        Axis    [  0.5219  -0.7830  -0.3385]
        Angle    129.3794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3886"
}

Galaxy "IC 3888:MCG 7-27-3:NPM 1"
{
        Type  "S0"
        RA           12.9128
        Dec          39.5719
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.8291  -0.2515   0.4993]
        Angle     78.6630
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3888"
}

Galaxy "IC 3890"
{
        Type  "S0"
        RA           12.9139
        Dec          37.1853
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.8898  -0.4035   0.2131]
        Angle    105.0429
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3890"
}

Galaxy "IC 3891"
{
        Type  "S0"
        RA           12.9161
        Dec          36.0525
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [  0.8915  -0.4481   0.0663]
        Angle     17.1369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3891"
}

Galaxy "IC 3892:UGC 8044:MCG 7-27-5:ZWG 217.2"
{
        Type  "Sb"
        RA           12.9183
        Dec          39.2231
        Distance   2.246e+08  # method: V
        Radius     4.247e+04
        AbsMag        -18.79
        Axis    [ -0.7868   0.5668   0.2442]
        Angle     60.5295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3892"
}

Galaxy "IC 3893"
{
        Type  "S0"
        RA           12.9186
        Dec          38.6244
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8368  -0.4359   0.3311]
        Angle     49.7949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3893"
}

Galaxy "IC 3895:MCG 7-27-6:ZWG 217.3:KCPG 360B"
{
        Type  "Sb"
        RA           12.9192
        Dec          39.2036
        Distance   3.424e+08  # method: V
        Radius     3.984e+04
        AbsMag        -19.61
        Axis    [  0.4520  -0.8694  -0.1995]
        Angle    120.4239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3895"
}

Galaxy "IC 3896:ESO 219-12"
{
        Type  "E0"
        RA           12.9450
        Dec         -50.3472
        Distance   1.023e+08  # method: T-F
        Radius     3.721e+04
        AbsMag        -20.18
        Axis    [  0.5515  -0.4067  -0.7283]
        Angle    165.9509
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3896"
}

Galaxy "IC 3896A:ESO 219-8:IRAS 12526-4948"
{
        Type  "SBc"
        RA           12.9250
        Dec         -50.0711
        Distance   1.217e+08  # method: V
        Radius     4.072e+04
        AbsMag        -19.36
        Axis    [  0.6133  -0.2221  -0.7580]
        Angle    125.5449
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3896A"
}

Galaxy "IC 3897:NPM 1"
{
        Type  "S0"
        RA           12.9219
        Dec          39.6731
        Distance    4.05e+08  # distance uncertain!
        Radius     1.767e+04
        AbsMag        -19.07
        Axis    [  0.7920  -0.6065   0.0704]
        Angle    101.9094
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3897"
}

Galaxy "IC 3898:NPM 1"
{
        Type  "E0"
        RA           12.9231
        Dec          37.5833
        Distance   9.551e+08  # distance uncertain!
        Radius     2.778e+04
        AbsMag        -20.13
        Axis    [ -0.2729   0.6995  -0.6604]
        Angle     73.4251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3898"
}

Galaxy "IC 3899:NPM 1"
{
        Type  "S0"
        RA           12.9278
        Dec          20.6369
        Distance   6.721e+08  # distance uncertain!
        Radius      3.91e+04
        AbsMag        -19.07
        Axis    [  0.8880  -0.4582  -0.0384]
        Angle     71.9118
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3899"
}

Galaxy "IC 3900:MCG 5-31-9:ZWG 160.19"
{
        Type  "S0"
        RA           12.9281
        Dec          27.2514
        Distance   3.372e+08  # method: V
        Radius     3.433e+04
        AbsMag        -20.07
        Axis    [ -0.8070   0.5689  -0.1582]
        Angle     60.7993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3900"
}

Galaxy "IC 3904:MCG 6-28-43:ZWG 189.1:ZWG 188.29"
{
        Type  "SBc"
        RA           12.9292
        Dec          36.2933
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.8091  -0.5866  -0.0347]
        Angle     45.0053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3904"
}

Galaxy "IC 3905"
{
        Type  "S0"
        RA           12.9356
        Dec          19.8528
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.2301  -0.4443  -0.8658]
        Angle     16.0656
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3905"
}

Galaxy "IC 3907"
{
        Type  "S0"
        RA           12.9383
        Dec          18.7842
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.9026  -0.4274  -0.0525]
        Angle    116.9002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3907"
}

Galaxy "IC 3908:MCG 1-33-56:IRAS 12540-0717"
{
        Type  "Sc"
        RA           12.9444
        Dec          -7.5606
        Distance   7.384e+07  # method: V
        Radius     1.933e+04
        AbsMag        -17.27
        Axis    [ -0.9843  -0.1081  -0.1394]
        Angle     60.6905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3908"
}

Galaxy "IC 3909"
{
        Type  "E0"
        RA           12.9339
        Dec          40.3853
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.3704  -0.6461  -0.6673]
        Angle     64.5508
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3909"
}

Galaxy "IC 3911-1"
{
        Type  "E0"
        RA           12.9358
        Dec          35.6369
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.4402  -0.8654  -0.2394]
        Angle    122.7695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3911-1"
}

Galaxy "IC 3911-2"
{
        Type  "E0"
        RA           12.9358
        Dec          35.6389
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4402  -0.8654  -0.2394]
        Angle    122.7686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3911-2"
}

Galaxy "IC 3913:MCG 5-31-12:ZWG 160.26:KUG 1254+275"
{
        Type  "Sc"
        RA           12.9411
        Dec          27.2908
        Distance   3.536e+08  # method: V
        Radius       3.6e+04
        AbsMag        -19.78
        Axis    [  0.7224  -0.6775  -0.1381]
        Angle    118.9729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3913"
}

Galaxy "IC 3914"
{
        Type  "E0"
        RA           12.9394
        Dec          36.3606
        Distance   7.586e+08  # distance uncertain!
        Radius     2.207e+04
        AbsMag        -20.13
        Axis    [  0.4371  -0.8684  -0.2343]
        Angle    122.4900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3914"
}

Galaxy "IC 3916:UGC 8063:MCG 7-27-8:ZWG 217.4"
{
        Type  "S0"
        RA           12.9419
        Dec          38.6142
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.6113   0.7810   0.1275]
        Angle     18.7597
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3916"
}

Galaxy "IC 3918:ZWG 130.2:KARA 560:KUG 1254+226"
{
        Type  "Sc"
        RA           12.9481
        Dec          22.3733
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8947  -0.4462  -0.0219]
        Angle    117.0214
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3918"
}

Galaxy "IC 3919:NPM 1"
{
        Type  "E0"
        RA           12.9467
        Dec          38.5886
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [ -0.0346   0.2721  -0.9617]
        Angle     51.6526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3919"
}

Galaxy "IC 3920:NPM 1"
{
        Type  "S0"
        RA           12.9472
        Dec          39.9592
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [  0.8802  -0.4203   0.2204]
        Angle    110.7332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3920"
}

Galaxy "IC 3921"
{
        Type  "S0"
        RA           12.9489
        Dec          38.6400
        Distance   3.694e+08  # distance uncertain!
        Radius     2.686e+04
        AbsMag        -19.07
        Axis    [  0.7801  -0.3308   0.5311]
        Angle     44.1257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3921"
}

Galaxy "IC 3922:IRAS 12546+3844"
{
        Type  "S0"
        RA           12.9492
        Dec          38.4786
        Distance   3.072e+08  # distance uncertain!
        Radius     4.468e+04
        AbsMag        -19.07
        Axis    [  0.4808  -0.0836   0.8729]
        Angle     46.6636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3922"
}

Galaxy "IC 3924"
{
        Type  "E0"
        RA           12.9567
        Dec          18.7817
        Distance   1.097e+09  # distance uncertain!
        Radius     1.595e+04
        AbsMag        -20.13
        Axis    [  0.4958  -0.7941  -0.3517]
        Angle    130.8787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3924"
}

Galaxy "IC 3927:ESO 507-58:MCG 4-31-12:AM 1255-223"
{
        Type  "S0"
        RA           12.9694
        Dec         -22.8761
        Distance   2.294e+08  # method: V
        Radius     3.669e+04
        AbsMag        -20.64
        Axis    [ -0.7566  -0.0385  -0.6527]
        Angle     78.7707
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3927"
}

Galaxy "IC 3928"
{
        Type  "E0"
        RA           12.9550
        Dec          40.4417
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [ -0.2091   0.6549  -0.7262]
        Angle     65.0264
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3928"
}

Galaxy "IC 3929:NPM 1"
{
        Type  "S0"
        RA           12.9614
        Dec          20.3975
        Distance   4.441e+08  # distance uncertain!
        Radius     2.583e+04
        AbsMag        -19.07
        Axis    [  0.5133  -0.7919  -0.3308]
        Angle    129.1154
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3929"
}

Galaxy "IC 3930"
{
        Type  "S0"
        RA           12.9561
        Dec          38.7647
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.8708  -0.4574   0.1802]
        Angle    109.5446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3930"
}

Galaxy "IC 3931"
{
        Type  "E0"
        RA           12.9658
        Dec          19.6172
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [  0.4765  -0.7819  -0.4020]
        Angle    122.6424
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3931"
}

Galaxy "IC 3934"
{
        Type  "S0"
        RA           12.9714
        Dec          18.8250
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.5169  -0.7851  -0.3411]
        Angle    129.9479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3934"
}

Galaxy "IC 3937"
{
        Type  "E0"
        RA           12.9733
        Dec          18.8183
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.4940  -0.7951  -0.3519]
        Angle    131.0079
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3937"
}

Galaxy "IC 3940:NPM 1:KUG 1255+361"
{
        Type  "E0"
        RA           12.9711
        Dec          35.8394
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [ -0.1385   0.3937  -0.9087]
        Angle     56.7516
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3940"
}

Galaxy "IC 3941:NPM 1"
{
        Type  "E0"
        RA           12.9703
        Dec          39.7733
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [  0.4207  -0.8825  -0.2101]
        Angle    121.3568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3941"
}

Galaxy "IC 3943:ZWG 160.69:DRCG 27-197"
{
        Type  "Sa"
        RA           12.9767
        Dec          28.1133
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.8973  -0.3780   0.2278]
        Angle     69.4843
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3943"
}

Galaxy "IC 3944"
{
        Type  "S0"
        RA           12.9789
        Dec          23.7811
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.8747  -0.4844   0.0167]
        Angle     57.3440
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3944"
}

Galaxy "IC 3945"
{
        Type  "S0"
        RA           12.9747
        Dec          39.9356
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.8771  -0.4193   0.2342]
        Angle    106.1740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3945"
}

Galaxy "IC 3946:MCG 5-31-50:ZWG 160.210:DRCG 27-91"
{
        Type  "S0"
        RA           12.9803
        Dec          27.8097
        Distance   2.838e+08  # method: V
        Radius     2.889e+04
        AbsMag         -19.5
        Axis    [  0.8445  -0.5352   0.0167]
        Angle     37.4455
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3946"
}

Galaxy "IC 3947:ZWG 160.211:NPM 1:DRCG 27-72"
{
        Type  "S0"
        RA           12.9811
        Dec          27.7856
        Distance   2.638e+08  # method: V
        Radius     1.151e+04
        AbsMag        -19.14
        Axis    [  0.7643  -0.5824  -0.2770]
        Angle     23.3872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3947"
}

Galaxy "IC 3948"
{
        Type  "E0"
        RA           12.9828
        Dec          24.0614
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4766  -0.8193  -0.3186]
        Angle    128.5490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3948"
}

Galaxy "IC 3949:UGC 8096:MCG 5-31-52:ZWG 160.212"
{
        Type  "S0"
        RA           12.9822
        Dec          27.8331
        Distance   3.495e+08  # method: V
        Radius     5.084e+04
        AbsMag        -20.05
        Axis    [  0.8023  -0.2460   0.5439]
        Angle     53.5826
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3949"
}

Galaxy "IC 3950:NPM 1"
{
        Type  "S0"
        RA           12.9850
        Dec          18.7361
        Distance   5.098e+08  # distance uncertain!
        Radius     2.966e+04
        AbsMag        -19.07
        Axis    [ -0.8070   0.3945  -0.4394]
        Angle     42.8717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3950"
}

Galaxy "IC 3951:NPM 1"
{
        Type  "S0"
        RA           12.9861
        Dec          18.7647
        Distance   5.339e+08  # distance uncertain!
        Radius     3.882e+04
        AbsMag        -19.07
        Axis    [ -0.9598   0.2154   0.1801]
        Angle     38.9848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3951"
}

Galaxy "IC 3952"
{
        Type  "E0"
        RA           12.9811
        Dec          38.8697
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4233  -0.8797  -0.2168]
        Angle    121.8557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3952"
}

Galaxy "IC 3953"
{
        Type  "E0"
        RA           12.9858
        Dec          23.0872
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4795  -0.8152  -0.3250]
        Angle    129.0432
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3953"
}

Galaxy "IC 3954"
{
        Type  "S0"
        RA           12.9867
        Dec          19.2725
        Distance   5.339e+08  # distance uncertain!
        Radius     3.106e+04
        AbsMag        -19.07
        Axis    [  0.8173  -0.5692  -0.0897]
        Angle     27.6096
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3954"
}

Galaxy "IC 3955:ZWG 160.216:DRCG 27-160"
{
        Type  "S0"
        RA           12.9850
        Dec          27.9961
        Distance   3.585e+08  # method: V
        Radius     2.085e+04
        AbsMag         -19.8
        Axis    [  0.8760  -0.4799   0.0490]
        Angle     87.5940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3955"
}

Galaxy "IC 3956:NPM 1"
{
        Type  "E0"
        RA           12.9822
        Dec          37.3986
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.4290  -0.8742  -0.2274]
        Angle    122.4945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3956"
}

Galaxy "IC 3957:MCG 5-31-60:ZWG 160.218:DRCG 27-70"
{
        Type  "E0"
        RA           12.9853
        Dec          27.7667
        Distance   3.227e+08  # method: T-F
        Radius     1.878e+04
        AbsMag        -19.38
        Axis    [  0.4640  -0.8356  -0.2942]
        Angle    126.8301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3957"
}

Galaxy "IC 3958"
{
        Type  "E0"
        RA           12.9864
        Dec          24.0222
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4764  -0.8194  -0.3189]
        Angle    128.6015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3958"
}

Galaxy "IC 3959:MCG 5-31-59:ZWG 160.217:DRCG 27-69"
{
        Type  "E0"
        RA           12.9856
        Dec          27.7836
        Distance   3.227e+08  # method: T-F
        Radius     2.347e+04
        AbsMag        -19.78
        Axis    [  0.4639  -0.8356  -0.2941]
        Angle    126.8249
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3959"
}

Galaxy "IC 3960:MCG 5-31-55:ZWG 160.219:DRCG 27-109"
{
        Type  "S0"
        RA           12.9856
        Dec          27.8547
        Distance   3.109e+08  # method: V
        Radius     1.809e+04
        AbsMag         -19.2
        Axis    [  0.4872  -0.8267  -0.2815]
        Angle    125.9292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3960"
}

Galaxy "IC 3960A:MCG 5-31-56"
{
        Type  "S0"
        RA           12.9858
        Dec          27.8669
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.7961  -0.5814  -0.1681]
        Angle     38.0438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3960A"
}

Galaxy "IC 3963:MCG 5-31-61:ZWG 160.220:DRCG 27-68"
{
        Type  "S0"
        RA           12.9869
        Dec          27.7739
        Distance   3.184e+08  # method: V
        Radius     3.242e+04
        AbsMag        -19.25
        Axis    [  0.8412  -0.4404   0.3135]
        Angle     34.2705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3963"
}

Galaxy "IC 3965"
{
        Type  "E0"
        RA           12.9894
        Dec          18.8431
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [ -0.3844   0.4549  -0.8033]
        Angle     76.4483
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3965"
}

Galaxy "IC 3966:MCG 6-29-7:KUG 1256+361"
{
        Type  "Sc"
        RA           12.9869
        Dec          35.8542
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [  0.7762  -0.6305   0.0042]
        Angle    114.3737
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3966"
}

Galaxy "IC 3967:MCG 6-29-5:ZWG 189.7:NPM 1"
{
        Type  "S0"
        RA           12.9867
        Dec          36.1297
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.8530  -0.4970   0.1591]
        Angle     82.6688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3967"
}

Galaxy "IC 3968:RB 14:DRCG 27-157"
{
        Type  "S0"
        RA           12.9903
        Dec          27.9725
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.8731  -0.4830   0.0664]
        Angle     72.6889
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3968"
}

Galaxy "IC 3971:NPM 1:KUG 1257+231"
{
        Type  "S0"
        RA           12.9919
        Dec          22.8453
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.7140  -0.5886  -0.3791]
        Angle     29.8071
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3971"
}

Galaxy "IC 3973:ZWG 160.228:DRCG 27-103"
{
        Type  "S0"
        RA           12.9917
        Dec          27.8850
        Distance   2.252e+08  # method: V
        Radius     1.638e+04
        AbsMag         -18.8
        Axis    [ -0.8647   0.5022  -0.0106]
        Angle     42.5107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3973"
}

Galaxy "IC 3975:MCG 7-27-9"
{
        Type  "S0"
        RA           12.9875
        Dec          38.8831
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.8260  -0.5480   0.1321]
        Angle     88.2278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3975"
}

Galaxy "IC 3976:ZWG 160.226:DRCG 27-88"
{
        Type  "E0"
        RA           12.9914
        Dec          27.8500
        Distance   3.225e+08  # method: V
        Radius     2.345e+04
        AbsMag        -19.27
        Axis    [ -0.3217   0.5351  -0.7811]
        Angle     70.9857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3976"
}

Galaxy "IC 3978"
{
        Type  "E0"
        RA           12.9936
        Dec          19.6219
        Distance   1.097e+09  # distance uncertain!
        Radius     1.595e+04
        AbsMag        -20.13
        Axis    [  0.4895  -0.7999  -0.3473]
        Angle    130.7930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3978"
}

Galaxy "IC 3980"
{
        Type  "S0"
        RA           12.9883
        Dec          39.1511
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [  0.8157  -0.5681   0.1096]
        Angle     47.6752
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3980"
}

Galaxy "IC 3985:NPM 1"
{
        Type  "E0"
        RA           12.9953
        Dec          19.5917
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.2810  -0.5475  -0.7882]
        Angle     81.4222
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3985"
}

Galaxy "IC 3986:ESO 443-32:MCG 5-31-16:AM 1258-320"
{
        Type  "S0"
        RA           13.0256
        Dec         -32.2914
        Distance   2.214e+08  # method: V
        Radius     5.152e+04
        AbsMag        -20.86
        Axis    [ -0.4582  -0.2778  -0.8443]
        Angle     73.3000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3986"
}

Galaxy "IC 3987:NPM 1"
{
        Type  "E0"
        RA           12.9903
        Dec          38.7339
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.4230  -0.8796  -0.2179]
        Angle    122.0122
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3987"
}

Galaxy "IC 3990:MCG 5-31-71:ZWG 160.77"
{
        Type  "Sa"
        RA           12.9942
        Dec          28.8950
        Distance   2.935e+08  # method: V
        Radius     5.123e+04
        AbsMag        -19.47
        Axis    [  0.9095  -0.3844   0.1579]
        Angle     92.0206
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3990"
}

Galaxy "IC 3991:MCG 5-31-72:ZWG 160.78"
{
        Type  "S0"
        RA           12.9942
        Dec          28.9258
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.8671  -0.4404   0.2330]
        Angle     48.9802
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3991"
}

Galaxy "IC 3993:NPM 1"
{
        Type  "E0"
        RA           12.9917
        Dec          40.6022
        Distance   5.012e+08  # distance uncertain!
        Radius     2.187e+04
        AbsMag        -20.13
        Axis    [  0.4153  -0.8864  -0.2043]
        Angle    121.2442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3993"
}

Galaxy "IC 3994"
{
        Type  "S0"
        RA           12.9972
        Dec          22.7161
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.5027  -0.8045  -0.3164]
        Angle    128.3605
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3994"
}

Galaxy "IC 3997"
{
        Type  "E0"
        RA           12.9936
        Dec          36.6950
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.4275  -0.8590  -0.2816]
        Angle    114.2599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3997"
}

Galaxy "IC 3998:ZWG 160.236:DRCG 27-152"
{
        Type  "S0"
        RA           12.9961
        Dec          27.9728
        Distance   4.374e+08  # method: V
        Radius      5.09e+04
        AbsMag        -20.04
        Axis    [  0.8358  -0.5482  -0.0289]
        Angle    107.6017
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 3998"
}

Galaxy "IC 4000"
{
        Type  "E0"
        RA           12.9933
        Dec          39.5878
        Distance    6.31e+08  # distance uncertain!
        Radius     1.836e+04
        AbsMag        -20.13
        Axis    [  0.4193  -0.8828  -0.2117]
        Angle    121.6858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4000"
}

Galaxy "IC 4001"
{
        Type  "S0"
        RA           12.9936
        Dec          38.8697
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.8440  -0.5103   0.1654]
        Angle     93.9824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4001"
}

Galaxy "IC 4002:NPM 1:KUG 1257+370"
{
        Type  "E0"
        RA           12.9944
        Dec          36.7644
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.3093  -0.5459  -0.7787]
        Angle     61.6651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4002"
}

Galaxy "IC 4003:MCG 7-27-10:ZWG 217.5:NPM 1"
{
        Type  "S0"
        RA           12.9942
        Dec          38.8161
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.4465  -0.8713  -0.2034]
        Angle    121.3884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4003"
}

Galaxy "IC 4004:MCG 7-27-11:ZWG 217.5"
{
        Type  "S0"
        RA           12.9950
        Dec          38.8111
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4465  -0.8714  -0.2034]
        Angle    121.3994
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4004"
}

Galaxy "IC 4007-1"
{
        Type  "S0"
        RA           13.0019
        Dec          19.9647
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [ -0.9604   0.2773   0.0269]
        Angle     33.1686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4007-1"
}

Galaxy "IC 4007-2"
{
        Type  "S0"
        RA           13.0017
        Dec          19.9628
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.8839  -0.4651  -0.0501]
        Angle     77.3488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4007-2"
}

Galaxy "IC 4010:NPM 1"
{
        Type  "S0"
        RA           12.9981
        Dec          37.8594
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8318  -0.4576   0.3141]
        Angle     50.1902
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4010"
}

Galaxy "IC 4011:ZWG 160.242:DRCG 27-150"
{
        Type  "E0"
        RA           13.0017
        Dec          28.0031
        Distance   3.227e+08  # method: T-F
        Radius     2.347e+04
        AbsMag        -18.78
        Axis    [  0.4616  -0.8374  -0.2929]
        Angle    126.8806
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4011"
}

Galaxy "IC 4012:ZWG 160.244:DRCG 27-174"
{
        Type  "E0"
        RA           13.0022
        Dec          28.0783
        Distance   3.227e+08  # method: T-F
        Radius     1.408e+04
        AbsMag        -18.98
        Axis    [ -0.1659   0.2509  -0.9537]
        Angle     60.6057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4012"
}

Galaxy "IC 4014"
{
        Type  "E0"
        RA           13.0036
        Dec          22.4992
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.4795  -0.8134  -0.3292]
        Angle    129.4897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4014"
}

Galaxy "IC 4016:NGC 4893A:UGC 8111:MCG 6-29-9"
{
        Type  "S0"
        RA           12.9997
        Dec          37.1872
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.7956   0.5616   0.2274]
        Angle     54.1363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4016"
}

Galaxy "IC 4017"
{
        Type  "S0"
        RA           13.0042
        Dec          22.5556
        Distance   3.694e+08  # distance uncertain!
        Radius     1.074e+04
        AbsMag        -19.07
        Axis    [  0.7837  -0.6178   0.0648]
        Angle     17.8299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4017"
}

Galaxy "IC 4018"
{
        Type  "E0"
        RA           12.9992
        Dec          40.4889
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.4151  -0.8863  -0.2052]
        Angle    121.3736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4018"
}

Galaxy "IC 4020"
{
        Type  "S0"
        RA           13.0008
        Dec          38.6097
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [  0.6130  -0.1561   0.7745]
        Angle     52.6201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4020"
}

Galaxy "IC 4021:MCG 5-31-80:ZWG 160.246:ARAK 399"
{
        Type  "E0"
        RA           13.0039
        Dec          28.0406
        Distance   3.227e+08  # method: T-F
        Radius     1.878e+04
        AbsMag        -19.08
        Axis    [  0.4612  -0.8376  -0.2927]
        Angle    126.8850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4021"
}

Galaxy "IC 4023"
{
        Type  "E0"
        RA           13.0072
        Dec          19.0967
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4897  -0.7982  -0.3509]
        Angle    131.1715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4023"
}

Galaxy "IC 4025"
{
        Type  "E0"
        RA           13.0072
        Dec          19.0972
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.4897  -0.7982  -0.3509]
        Angle    131.1712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4025"
}

Galaxy "IC 4026:ZWG 160.250:DRCG 27-170"
{
        Type  "S0"
        RA           13.0061
        Dec          28.0464
        Distance   3.808e+08  # method: V
        Radius     1.661e+04
        AbsMag        -19.74
        Axis    [  0.4846  -0.8285  -0.2806]
        Angle    126.0442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4026"
}

Galaxy "IC 4027"
{
        Type  "S0"
        RA           13.0036
        Dec          37.1408
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.4604   0.3277   0.8250]
        Angle     31.6697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4027"
}

Galaxy "IC 4028:UGC 8115:MCG 6-29-12:ZWG 189.11"
{
        Type  "SBc"
        RA           13.0044
        Dec          36.2531
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [ -0.5183   0.6695  -0.5321]
        Angle     31.5012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4028"
}

Galaxy "IC 4029"
{
        Type  "S0"
        RA           13.0039
        Dec          38.7597
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.5137  -0.1400   0.8465]
        Angle     33.7239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4029"
}

Galaxy "IC 4030:RB 99:DRCG 27-119"
{
        Type  "S0"
        RA           13.0078
        Dec          27.9550
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.7788  -0.6200  -0.0953]
        Angle    108.3369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4030"
}

Galaxy "IC 4031"
{
        Type  "E0"
        RA           13.0042
        Dec          39.1450
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4200  -0.8817  -0.2151]
        Angle    121.9893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4031"
}

Galaxy "IC 4032:MCG 5-31-83:ZWG 160.85"
{
        Type  "S0"
        RA           13.0069
        Dec          28.8678
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.7703   0.5830  -0.2582]
        Angle     43.9375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4032"
}

Galaxy "IC 4033:RB 100:DRCG 27-147"
{
        Type  "S0"
        RA           13.0078
        Dec          27.9722
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [  0.7821  -0.4363   0.4450]
        Angle     25.3523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4033"
}

Galaxy "IC 4034"
{
        Type  "E0"
        RA           13.0053
        Dec          37.0458
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.4282  -0.8739  -0.2302]
        Angle    122.8916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4034"
}

Galaxy "IC 4035"
{
        Type  "S0"
        RA           13.0044
        Dec          40.2994
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.8364  -0.5013   0.2216]
        Angle     79.7138
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4035"
}

Galaxy "IC 4037"
{
        Type  "E0"
        RA           13.0053
        Dec          39.0022
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.2122  -0.2883  -0.9338]
        Angle     51.1835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4037"
}

Galaxy "IC 4038:NPM 1"
{
        Type  "S0"
        RA           13.0058
        Dec          37.0397
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [ -0.7509   0.6604   0.0114]
        Angle     52.5452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4038"
}

Galaxy "IC 4039:NPM 1"
{
        Type  "E0"
        RA           13.0108
        Dec          21.6922
        Distance    6.31e+08  # distance uncertain!
        Radius     1.836e+04
        AbsMag        -20.13
        Axis    [  0.4814  -0.8102  -0.3345]
        Angle    129.9438
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4039"
}

Galaxy "IC 4040:MCG 5-31-85:ZWG 160.252:IRAS 12582+2819"
{
        Type  "SBc"
        RA           13.0106
        Dec          28.0567
        Distance    3.66e+08  # method: V
        Radius     5.323e+04
        AbsMag        -19.75
        Axis    [ -0.8147   0.2752   0.5104]
        Angle     41.3838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4040"
}

Galaxy "IC 4041:MCG 5-31-86:ZWG 160.254:PGC 44802"
{
        Type  "E0"
        RA           13.0111
        Dec          27.9969
        Distance   3.303e+08  # method: V
        Radius     1.922e+04
        AbsMag        -19.63
        Axis    [  0.4232  -0.7798  -0.4613]
        Angle    102.6049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4041"
}

Galaxy "IC 4042:ZWG 160.255:DRCG 27-144"
{
        Type  "S0"
        RA           13.0117
        Dec          27.9717
        Distance    2.98e+08  # method: V
        Radius     2.167e+04
        AbsMag         -19.5
        Axis    [  0.4843  -0.8285  -0.2812]
        Angle    126.1311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4042"
}

Galaxy "IC 4042A:RB 113:DRCG 27-116"
{
        Type  "S0"
        RA           13.0117
        Dec          27.9633
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.4843  -0.8285  -0.2812]
        Angle    126.1348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4042A"
}

Galaxy "IC 4043:UGC 8123"
{
        Type  "Irr"
        RA           13.0094
        Dec          37.0708
        Distance   6.919e+08  # distance uncertain!
        Radius     9.057e+04
        AbsMag        -20.13
        Axis    [ -0.7540   0.4309   0.4957]
        Angle     49.3703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4043"
}

Galaxy "IC 4044:RB 119:DRCG 27-117"
{
        Type  "Sa"
        RA           13.0131
        Dec          27.9217
        Distance   3.868e+08  # distance uncertain!
        Radius     1.688e+04
        AbsMag        -19.07
        Axis    [  0.8113  -0.5785  -0.0841]
        Angle     72.9672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4044"
}

Galaxy "IC 4045:MCG 5-31-88:ZWG 160.256:DRCG 27-168"
{
        Type  "E4"
        RA           13.0133
        Dec          28.0903
        Distance   3.227e+08  # method: T-F
        Radius     3.755e+04
        AbsMag        -20.08
        Axis    [  0.0010  -0.0540  -0.9985]
        Angle     58.4917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4045"
}

Galaxy "IC 4047:MCG 3-33-21:ZWG 100.21:NPM 1"
{
        Type  "Sb"
        RA           13.0158
        Dec          19.6875
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.5100  -0.7916  -0.3367]
        Angle    129.9336
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4047"
}

Galaxy "IC 4048"
{
        Type  "S0"
        RA           13.0106
        Dec          39.8306
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.8395  -0.5290   0.1244]
        Angle    118.8212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4048"
}

Galaxy "IC 4049:UGC 8124:MCG 6-29-13:ZWG 189.12"
{
        Type  "S0"
        RA           13.0117
        Dec          36.3458
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.4544  -0.8627  -0.2218]
        Angle    122.5743
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4049"
}

Galaxy "IC 4051:MCG 5-31-92:ZWG 160-258:DRCG 27-167"
{
        Type  "E5"
        RA           13.0142
        Dec          28.0428
        Distance   3.227e+08  # method: T-F
        Radius     4.225e+04
        AbsMag        -20.38
        Axis    [  0.3818  -0.7137  -0.5872]
        Angle     88.3589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4051"
}

Galaxy "IC 4056:UGC 8126:MCG 7-27-12:VV 418"
{
        Type  "SBc"
        RA           13.0122
        Dec          39.7544
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [  0.8167  -0.5742  -0.0572]
        Angle     27.7387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4056"
}

Galaxy "IC 4058"
{
        Type  "S0"
        RA           13.0192
        Dec          19.4939
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.5247  -0.5873  -0.6163]
        Angle     22.9984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4058"
}

Galaxy "IC 4059"
{
        Type  "E0"
        RA           13.0208
        Dec          19.2731
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4878  -0.7997  -0.3501]
        Angle    131.2064
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4059"
}

Galaxy "IC 4060:MCG 7-27-13"
{
        Type  "S0"
        RA           13.0144
        Dec          40.5844
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.6106   0.7918   0.0153]
        Angle     23.9858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4060"
}

Galaxy "IC 4061-1"
{
        Type  "E0"
        RA           13.0158
        Dec          39.5833
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.2777  -0.4448  -0.8515]
        Angle     54.3657
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4061-1"
}

Galaxy "IC 4061-2"
{
        Type  "E0"
        RA           13.0161
        Dec          39.5836
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4172  -0.8838  -0.2120]
        Angle    121.9356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4061-2"
}

Galaxy "IC 4062:MCG 7-27-14"
{
        Type  "SBa"
        RA           13.0161
        Dec          39.8586
        Distance   2.125e+08  # distance uncertain!
        Radius     1.237e+04
        AbsMag        -19.07
        Axis    [  0.4404  -0.8762  -0.1959]
        Angle    121.2121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4062"
}

Galaxy "IC 4063"
{
        Type  "E0"
        RA           13.0183
        Dec          39.2450
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4183  -0.8826  -0.2145]
        Angle    122.1012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4063"
}

Galaxy "IC 4064:UGC 8131:MCG 7-27-15:ZWG 217.6"
{
        Type  "S0"
        RA           13.0183
        Dec          39.8417
        Distance    4.94e+08  # method: V
        Radius      1.15e+05
        AbsMag         -21.2
        Axis    [  0.7509  -0.6603   0.0132]
        Angle     90.4854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4064"
}

Galaxy "IC 4065:MCG 7-27-16"
{
        Type  "S0"
        RA           13.0194
        Dec          39.7444
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.7805   0.5850   0.2202]
        Angle     61.2439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4065"
}

Galaxy "IC 4067"
{
        Type  "S0"
        RA           13.0222
        Dec          39.9408
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.4395  -0.8767  -0.1954]
        Angle    121.2463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4067"
}

Galaxy "IC 4068:MCG 7-27-17"
{
        Type  "S0"
        RA           13.0222
        Dec          39.8989
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.8096  -0.5735   0.1255]
        Angle     48.0372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4068"
}

Galaxy "IC 4069"
{
        Type  "S0"
        RA           13.0233
        Dec          36.1125
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.8933  -0.4176   0.1659]
        Angle    115.1405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4069"
}

Galaxy "IC 4070"
{
        Type  "E0"
        RA           13.0286
        Dec          19.3017
        Distance   3.163e+08  # distance uncertain!
        Radius      1.84e+04
        AbsMag        -20.13
        Axis    [  0.3831  -0.6863  -0.6182]
        Angle     97.3774
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4070"
}

Galaxy "IC 4071:MCG 1-33-73:IRAS 12594-0720"
{
        Type  "S0"
        RA           13.0344
        Dec          -7.6031
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [  0.8632  -0.3680  -0.3456]
        Angle    116.0623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4071"
}

Galaxy "IC 4073:MCG 7-27-18:NPM 1"
{
        Type  "S0"
        RA           13.0236
        Dec          39.9147
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.5541   0.3684   0.7465]
        Angle     42.2332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4073"
}

Galaxy "IC 4074"
{
        Type  "S0"
        RA           13.0300
        Dec          19.0086
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [  0.5105  -0.7892  -0.3415]
        Angle    130.3768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4074"
}

Galaxy "IC 4075"
{
        Type  "E0"
        RA           13.0300
        Dec          19.9647
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.0754  -0.2698  -0.9600]
        Angle     68.4836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4075"
}

Galaxy "IC 4076:NPM 1"
{
        Type  "E0"
        RA           13.0300
        Dec          23.3897
        Distance   9.551e+08  # distance uncertain!
        Radius     4.167e+04
        AbsMag        -20.13
        Axis    [  0.4741  -0.8187  -0.3239]
        Angle    129.3100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4076"
}

Galaxy "IC 4077:NPM 1:KUG 1259+376"
{
        Type  "E0"
        RA           13.0261
        Dec          37.3867
        Distance   5.755e+08  # distance uncertain!
        Radius     2.511e+04
        AbsMag        -20.13
        Axis    [  0.3706  -0.7106  -0.5981]
        Angle     74.0572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4077"
}

Galaxy "IC 4079"
{
        Type  "E0"
        RA           13.0322
        Dec          19.2483
        Distance   1.097e+09  # distance uncertain!
        Radius     1.595e+04
        AbsMag        -20.13
        Axis    [  0.4867  -0.8002  -0.3505]
        Angle    131.3201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4079"
}

Galaxy "IC 4080-1"
{
        Type  "S0"
        RA           13.0325
        Dec          19.2531
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.5096  -0.7904  -0.3399]
        Angle    130.2845
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4080-1"
}

Galaxy "IC 4080-2"
{
        Type  "S0"
        RA           13.0328
        Dec          19.2558
        Distance   6.721e+08  # distance uncertain!
        Radius          9775
        AbsMag        -19.07
        Axis    [  0.5095  -0.7905  -0.3399]
        Angle    130.2857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4080-2"
}

Galaxy "IC 4081:NPM 1"
{
        Type  "E0"
        RA           13.0319
        Dec          22.7717
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [ -0.3089   0.3877  -0.8685]
        Angle     69.1310
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4081"
}

Galaxy "IC 4082"
{
        Type  "E0"
        RA           13.0275
        Dec          37.3408
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.1948  -0.2918  -0.9364]
        Angle     52.6196
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4082"
}

Galaxy "IC 4083"
{
        Type  "S0"
        RA           13.0272
        Dec          38.1422
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.7522  -0.6589  -0.0031]
        Angle     97.6399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4083"
}

Galaxy "IC 4085:NPM 1"
{
        Type  "E0"
        RA           13.0272
        Dec          39.7033
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [ -0.1094   0.4239  -0.8991]
        Angle     53.5200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4085"
}

Galaxy "IC 4086:UGC 8141:MCG 6-29-17:ZWG 189.14"
{
        Type  "Sc"
        RA           13.0286
        Dec          36.6478
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.6613  -0.7421  -0.1093]
        Angle    106.6292
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4086"
}

Galaxy "IC 4087"
{
        Type  "S0"
        RA           13.0333
        Dec          19.9942
        Distance   3.369e+08  # distance uncertain!
        Radius      1.96e+04
        AbsMag        -19.07
        Axis    [  0.7979  -0.5838  -0.1504]
        Angle    119.4308
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4087"
}

Galaxy "IC 4088:UGC 8140:MCG 5-31-102:ZWG 160.102"
{
        Type  "Sb"
        RA           13.0286
        Dec          29.0442
        Distance   3.448e+08  # method: T-F
        Radius     7.522e+04
        AbsMag        -20.42
        Axis    [  0.7576  -0.3522   0.5495]
        Angle     34.6583
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4088"
}

Galaxy "IC 4089"
{
        Type  "S0"
        RA           13.0336
        Dec          19.5028
        Distance   4.241e+08  # distance uncertain!
        Radius     1.234e+04
        AbsMag        -19.07
        Axis    [  0.5087  -0.7917  -0.3383]
        Angle    130.1777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4089"
}

Galaxy "IC 4091"
{
        Type  "S0"
        RA           13.0367
        Dec          19.8928
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.8294   0.0203   0.5583]
        Angle     22.2663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4091"
}

Galaxy "IC 4094-1:NPM 1"
{
        Type  "S0"
        RA           13.0328
        Dec          37.7953
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.7199   0.6915   0.0604]
        Angle     32.4586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4094-1"
}

Galaxy "IC 4094-2"
{
        Type  "S0"
        RA           13.0331
        Dec          37.7889
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [ -0.7899   0.5638   0.2411]
        Angle     54.0541
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4094-2"
}

Galaxy "IC 4095:NPM 1"
{
        Type  "S0"
        RA           13.0389
        Dec          19.1003
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.9165  -0.4000  -0.0005]
        Angle     92.3076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4095"
}

Galaxy "IC 4096:NPM 1"
{
        Type  "E0"
        RA           13.0378
        Dec          24.0114
        Distance   1.047e+09  # distance uncertain!
        Radius     3.046e+04
        AbsMag        -20.13
        Axis    [  0.4713  -0.8219  -0.3200]
        Angle    129.0890
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4096"
}

Galaxy "IC 4098"
{
        Type  "Irr"
        RA           13.0344
        Dec          37.9800
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.5992  -0.2148   0.7712]
        Angle     20.5713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4098"
}

Galaxy "IC 4099:NPM 1"
{
        Type  "E0"
        RA           13.0397
        Dec          24.0297
        Distance   9.121e+08  # distance uncertain!
        Radius     2.653e+04
        AbsMag        -20.13
        Axis    [  0.4710  -0.8220  -0.3199]
        Angle    129.0987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4099"
}

Galaxy "IC 4100:UGC 8144:MCG 7-27-19:ZWG 217.7"
{
        Type  "Sc"
        RA           13.0344
        Dec          40.4086
        Distance   1.938e+08  # distance uncertain!
        Radius     3.947e+04
        AbsMag        -19.07
        Axis    [  0.8298  -0.2549  -0.4965]
        Angle      9.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4100"
}

Galaxy "IC 4102"
{
        Type  "E0"
        RA           13.0383
        Dec          36.1519
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2998  -0.5512  -0.7787]
        Angle     62.2946
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4102"
}

Galaxy "IC 4103:MCG 6-29-19"
{
        Type  "S0"
        RA           13.0386
        Dec          38.0164
        Distance   4.241e+08  # distance uncertain!
        Radius     4.934e+04
        AbsMag        -19.07
        Axis    [  0.8211  -0.5465   0.1646]
        Angle     43.4608
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4103"
}

Galaxy "IC 4104"
{
        Type  "E0"
        RA           13.0383
        Dec          38.5922
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4190  -0.8811  -0.2194]
        Angle    122.5914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4104"
}

Galaxy "IC 4105"
{
        Type  "E0"
        RA           13.0383
        Dec          38.2711
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4203  -0.8799  -0.2217]
        Angle    122.7261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4105"
}

Galaxy "IC 4106:MCG 5-31-109:ZWG 160.112:DRCG 27-188"
{
        Type  "SBa"
        RA           13.0439
        Dec          28.1139
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.7569   0.5736  -0.3130]
        Angle     44.4871
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4106"
}

Galaxy "IC 4107"
{
        Type  "E0"
        RA           13.0447
        Dec          21.9978
        Distance   1.738e+09  # distance uncertain!
        Radius     1.769e+05
        AbsMag        -20.13
        Axis    [  0.4770  -0.8133  -0.3332]
        Angle    130.1084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4107"
}

Galaxy "IC 4108:MCG 7-27-20:NPM 1"
{
        Type  "S0"
        RA           13.0419
        Dec          38.4789
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [ -0.3967   0.4452   0.8028]
        Angle     19.5947
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4108"
}

Galaxy "IC 4110"
{
        Type  "E0"
        RA           13.0494
        Dec          19.2275
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4850  -0.8009  -0.3510]
        Angle    131.4839
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4110"
}

Galaxy "IC 4111:MCG 5-31-113:ZWG 160.116:DRCG 27-165"
{
        Type  "S0"
        RA           13.0489
        Dec          28.0706
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.8548   0.3488   0.3843]
        Angle     18.6141
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4111"
}

Galaxy "IC 4113"
{
        Type  "E0"
        RA           13.0508
        Dec          20.4736
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4811  -0.8067  -0.3431]
        Angle    130.8944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4113"
}

Galaxy "IC 4114"
{
        Type  "S0"
        RA           13.0450
        Dec          40.1047
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.8539  -0.4026   0.3299]
        Angle     83.3251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4114"
}

Galaxy "IC 4115:MCG 6-29-20:KUG 1300+374"
{
        Type  "S0"
        RA           13.0469
        Dec          37.2222
        Distance   1.688e+08  # distance uncertain!
        Radius          9822
        AbsMag        -19.07
        Axis    [  0.4478  -0.8677  -0.2159]
        Angle    122.5932
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4115"
}

Galaxy "IC 4118:MCG 7-27-21:NPM 1"
{
        Type  "S0"
        RA           13.0475
        Dec          38.2936
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.4870   0.0093   0.8734]
        Angle      9.9277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4118"
}

Galaxy "IC 4119"
{
        Type  "S0"
        RA           13.0542
        Dec          19.2325
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.8879  -0.4561  -0.0595]
        Angle     95.6113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4119"
}

Galaxy "IC 4122:ZWG 100.24"
{
        Type  "E0"
        RA           13.0567
        Dec          20.1967
        Distance   4.169e+08  # distance uncertain!
        Radius     1.819e+04
        AbsMag        -20.13
        Axis    [  0.4814  -0.8057  -0.3450]
        Angle    131.0804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4122"
}

Galaxy "IC 4123:MCG 7-27-23"
{
        Type  "S0"
        RA           13.0514
        Dec          38.3150
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [  0.4431  -0.8720  -0.2079]
        Angle    122.2044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4123"
}

Galaxy "IC 4125:NPM 1"
{
        Type  "E0"
        RA           13.0594
        Dec          18.8039
        Distance    6.31e+08  # distance uncertain!
        Radius     4.589e+04
        AbsMag        -20.13
        Axis    [  0.2113  -0.4756  -0.8539]
        Angle     77.1102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4125"
}

Galaxy "IC 4127:MCG 6-29-22"
{
        Type  "S0"
        RA           13.0547
        Dec          38.0461
        Distance   3.868e+08  # distance uncertain!
        Radius     2.813e+04
        AbsMag        -19.07
        Axis    [  0.8180  -0.5595   0.1336]
        Angle     67.6161
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4127"
}

Galaxy "IC 4128-1:NPM 1"
{
        Type  "S0"
        RA           13.0614
        Dec          20.2172
        Distance    4.05e+08  # distance uncertain!
        Radius     2.945e+04
        AbsMag        -19.07
        Axis    [  0.7787  -0.5842  -0.2288]
        Angle     38.9855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4128-1"
}

Galaxy "IC 4128-2"
{
        Type  "E0"
        RA           13.0611
        Dec          20.2208
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [ -0.4464   0.5778  -0.6833]
        Angle     82.6165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4128-2"
}

Galaxy "IC 4129"
{
        Type  "E0"
        RA           13.0619
        Dec          18.8767
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.4235  -0.7383  -0.5249]
        Angle    108.5836
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4129"
}

Galaxy "IC 4130:MCG 3-33-24:PGC 97416"
{
        Type  "S0"
        RA           13.0628
        Dec          19.2711
        Distance   6.721e+08  # distance uncertain!
        Radius     9.775e+04
        AbsMag        -19.07
        Axis    [  0.8021  -0.5606  -0.2056]
        Angle     49.8944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4130"
}

Galaxy "IC 4131"
{
        Type  "Irr"
        RA           13.0569
        Dec          38.9511
        Distance    6.31e+08  # distance uncertain!
        Radius     5.507e+04
        AbsMag        -20.13
        Axis    [ -0.7231   0.6879   0.0629]
        Angle     42.3036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4131"
}

Galaxy "IC 4133:MCG 5-31-117:ZWG 160.123"
{
        Type  "E0"
        RA           13.0639
        Dec          27.9875
        Distance   2.989e+08  # method: V
        Radius     1.304e+04
        AbsMag        -19.41
        Axis    [  0.4555  -0.8403  -0.2940]
        Angle    127.4971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4133"
}

Galaxy "IC 4135:UGC 8163"
{
        Type  "S0"
        RA           13.0603
        Dec          40.2486
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [  0.7365  -0.6763  -0.0155]
        Angle     77.8794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4135"
}

Galaxy "IC 4137:NPM 1"
{
        Type  "E0"
        RA           13.0664
        Dec          22.7406
        Distance   7.586e+08  # distance uncertain!
        Radius      3.31e+04
        AbsMag        -20.13
        Axis    [  0.4725  -0.8177  -0.3289]
        Angle    129.9561
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4137"
}

Galaxy "IC 4138"
{
        Type  "S0"
        RA           13.0672
        Dec          20.6653
        Distance   3.694e+08  # distance uncertain!
        Radius     1.612e+04
        AbsMag        -19.07
        Axis    [ -0.8881   0.4296  -0.1633]
        Angle     53.3553
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4138"
}

Galaxy "IC 4139:NPM 1"
{
        Type  "E0"
        RA           13.0678
        Dec          19.2956
        Distance   7.944e+08  # distance uncertain!
        Radius     3.466e+04
        AbsMag        -20.13
        Axis    [  0.4830  -0.8022  -0.3510]
        Angle    131.6148
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4139"
}

Galaxy "IC 4140"
{
        Type  "E0"
        RA           13.0683
        Dec          20.0964
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4805  -0.8059  -0.3459]
        Angle    131.2340
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4140"
}

Galaxy "IC 4141:MCG 3-33-27"
{
        Type  "S0"
        RA           13.0686
        Dec          19.2106
        Distance   5.339e+08  # distance uncertain!
        Radius     5.435e+04
        AbsMag        -19.07
        Axis    [  0.7314  -0.6487  -0.2106]
        Angle    121.7828
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4141"
}

Galaxy "IC 4144:UGC 8169:MCG 6-29-23"
{
        Type  "Sb"
        RA           13.0639
        Dec          36.9425
        Distance   3.527e+08  # distance uncertain!
        Radius     5.643e+04
        AbsMag        -19.07
        Axis    [  0.9172  -0.3184   0.2396]
        Angle    117.2865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4144"
}

Galaxy "IC 4145"
{
        Type  "S0"
        RA           13.0636
        Dec          38.2864
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.5269   0.3549   0.7723]
        Angle     35.2733
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4145"
}

Galaxy "IC 4146"
{
        Type  "E0"
        RA           13.0694
        Dec          19.2781
        Distance   6.026e+08  # distance uncertain!
        Radius     1.753e+04
        AbsMag        -20.13
        Axis    [  0.4829  -0.8022  -0.3512]
        Angle    131.6381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4146"
}

Galaxy "IC 4147"
{
        Type  "Irr"
        RA           13.0692
        Dec          20.2503
        Distance   1.381e+09  # distance uncertain!
        Radius     1.205e+05
        AbsMag        -20.13
        Axis    [ -0.9435   0.3272   0.0521]
        Angle     52.7013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4147"
}

Galaxy "IC 4148"
{
        Type  "E0"
        RA           13.0694
        Dec          19.2592
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2701  -0.5561  -0.7860]
        Angle     81.9144
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4148"
}

Galaxy "IC 4149:MCG 4-31-4:ZWG 130.5:ZW 228"
{
        Type  "SBa"
        RA           13.0694
        Dec          22.2900
        Distance   3.325e+08  # method: V
        Radius     3.869e+04
        AbsMag        -19.54
        Axis    [  0.8140  -0.5803   0.0262]
        Angle     28.1549
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4149"
}

Galaxy "IC 4151"
{
        Type  "Irr"
        RA           13.0664
        Dec          36.8572
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.7895  -0.6129   0.0321]
        Angle    108.1188
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4151"
}

Galaxy "IC 4152"
{
        Type  "E0"
        RA           13.0661
        Dec          38.1992
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.4179  -0.8808  -0.2226]
        Angle    123.0560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4152"
}

Galaxy "IC 4154"
{
        Type  "E0"
        RA           13.0744
        Dec          23.5750
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4690  -0.8218  -0.3236]
        Angle    129.6385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4154"
}

Galaxy "IC 4158:NPM 1"
{
        Type  "S0"
        RA           13.0733
        Dec          36.4806
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.3912   0.2977   0.8708]
        Angle     24.5854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4158"
}

Galaxy "IC 4159"
{
        Type  "Irr"
        RA           13.0792
        Dec          22.2417
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4960  -0.8067  -0.3214]
        Angle    129.3296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4159"
}

Galaxy "IC 4160:NPM 1"
{
        Type  "S0"
        RA           13.0800
        Dec          22.8931
        Distance    6.13e+08  # distance uncertain!
        Radius     3.566e+04
        AbsMag        -19.07
        Axis    [  0.8826  -0.4695  -0.0229]
        Angle    102.8705
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4160"
}

Galaxy "IC 4161"
{
        Type  "S0"
        RA           13.0764
        Dec          39.9775
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.3050  -0.0346   0.9517]
        Angle     44.8461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4161"
}

Galaxy "IC 4162"
{
        Type  "E0"
        RA           13.0842
        Dec          20.5544
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.4775  -0.8088  -0.3433]
        Angle    131.1579
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4162"
}

Galaxy "IC 4163:NPM 1"
{
        Type  "Irr"
        RA           13.0853
        Dec          20.7711
        Distance   7.245e+08  # distance uncertain!
        Radius     4.215e+04
        AbsMag        -20.13
        Axis    [  0.7785  -0.5985  -0.1893]
        Angle    100.1448
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4163"
}

Galaxy "IC 4164"
{
        Type  "S0"
        RA           13.0872
        Dec          20.5469
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.8065   0.0077   0.5912]
        Angle     22.6185
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4164"
}

Galaxy "IC 4165:MCG 7-27-25"
{
        Type  "Sc"
        RA           13.0825
        Dec          39.9247
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.4340  -0.8793  -0.1963]
        Angle    121.9106
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4165"
}

Galaxy "IC 4166:UGC 8180:MCG 5-31-122:ZWG 160.133"
{
        Type  "SBb"
        RA           13.0883
        Dec          31.4419
        Distance   5.031e+08  # method: V
        Radius     6.586e+04
        AbsMag        -20.84
        Axis    [  0.8459  -0.5327   0.0255]
        Angle    118.3499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4166"
}

Galaxy "IC 4167:NPM 1"
{
        Type  "E0"
        RA           13.0917
        Dec          21.9106
        Distance   1.097e+09  # distance uncertain!
        Radius     4.785e+04
        AbsMag        -20.13
        Axis    [ -0.4195   0.5559  -0.7176]
        Angle     78.5342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4167"
}

Galaxy "IC 4168:MCG 7-27-29"
{
        Type  "S0"
        RA           13.0861
        Dec          40.0497
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.7997  -0.5865   0.1285]
        Angle     48.6120
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4168"
}

Galaxy "IC 4169"
{
        Type  "E0"
        RA           13.0867
        Dec          38.7736
        Distance   5.496e+08  # distance uncertain!
        Radius     1.599e+04
        AbsMag        -20.13
        Axis    [  0.4138  -0.8837  -0.2186]
        Angle    123.0396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4169"
}

Galaxy "IC 4170-1:ZW 234"
{
        Type  "E0"
        RA           13.0931
        Dec          21.1347
        Distance   1.259e+09  # distance uncertain!
        Radius     3.662e+04
        AbsMag        -20.13
        Axis    [  0.4748  -0.8118  -0.3398]
        Angle    130.9626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4170-1"
}

Galaxy "IC 4170-2:ZW 234"
{
        Type  "E0"
        RA           13.0928
        Dec          21.1358
        Distance    1.82e+09  # distance uncertain!
        Radius     2.647e+04
        AbsMag        -20.13
        Axis    [  0.4749  -0.8118  -0.3398]
        Angle    130.9595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4170-2"
}

Galaxy "IC 4171:UGC 8182:MCG 6-29-26:KUG 1302+363"
{
        Type  "Sc"
        RA           13.0883
        Dec          36.1025
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [  0.8140  -0.4996   0.2963]
        Angle     34.9059
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4171"
}

Galaxy "IC 4172:KUG 1304+231"
{
        Type  "S0"
        RA           13.1092
        Dec          22.8506
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.7258  -0.6217  -0.2945]
        Angle     61.1768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4172"
}

Galaxy "IC 4173:NGC 4933B:MCG 2-33-101:ARP 176"
{
        Type  "E0"
        RA           13.0650
        Dec         -11.5050
        Distance   1.636e+08  # method: V
        Radius     1.428e+04
        AbsMag         -18.3
        Axis    [  0.1905  -0.4343  -0.8804]
        Angle    109.0121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4173"
}

Galaxy "IC 4175"
{
        Type  "S0"
        RA           13.0964
        Dec          20.3742
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [ -0.4470  -0.0382  -0.8937]
        Angle     21.0546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4175"
}

Galaxy "IC 4177:MCG 2-33-107"
{
        Type  "Sc"
        RA           13.1081
        Dec         -13.5711
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [  0.5022  -0.5193  -0.6915]
        Angle     44.9524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4177"
}

Galaxy "IC 4178:UGC 8187:MCG 6-29-30"
{
        Type  "Irr"
        RA           13.0947
        Dec          36.0175
        Distance   6.374e+07  # method: V
        Radius      1.02e+04
        AbsMag        -15.75
        Axis    [ -0.1457   0.1383   0.9796]
        Angle     24.4687
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4178"
}

Galaxy "IC 4180:ESO 508-5:MCG 4-31-29:IRAS 13042-2338"
{
        Type  "SBa"
        RA           13.1156
        Dec         -23.9172
        Distance    1.47e+08  # method: V
        Radius     1.924e+04
        AbsMag        -19.67
        Axis    [ -0.8093  -0.0770  -0.5823]
        Angle     78.1139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4180"
}

Galaxy "IC 4181"
{
        Type  "S0"
        RA           13.1017
        Dec          21.4939
        Distance   3.694e+08  # distance uncertain!
        Radius     2.149e+04
        AbsMag        -19.07
        Axis    [  0.4960  -0.8044  -0.3269]
        Angle    129.8744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4181"
}

Galaxy "IC 4182:UGC 8188:MCG 6-29-31:ZWG 189.20"
{
        Type  "Irr"
        RA           13.0969
        Dec          37.6064
        Distance    2.46e+07  # method: V
        Radius     1.717e+04
        AbsMag        -17.69
        Axis    [  0.6537  -0.6214  -0.4319]
        Angle     31.5296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4182"
}

Galaxy "IC 4183:NPM 1"
{
        Type  "E0"
        RA           13.1031
        Dec          21.5047
        Distance   9.551e+08  # distance uncertain!
        Radius     4.167e+04
        AbsMag        -20.13
        Axis    [  0.4727  -0.8140  -0.3376]
        Angle    130.8790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4183"
}

Galaxy "IC 4184:NPM 1"
{
        Type  "S0"
        RA           13.0975
        Dec          38.8378
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.8639  -0.4037  -0.3012]
        Angle      9.1039
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4184"
}

Galaxy "IC 4185-1:NPM 1"
{
        Type  "S0"
        RA           13.1033
        Dec          21.7697
        Distance   4.241e+08  # distance uncertain!
        Radius     3.701e+04
        AbsMag        -19.07
        Axis    [ -0.8362   0.0870   0.5415]
        Angle     27.0755
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4185-1"
}

Galaxy "IC 4185-2"
{
        Type  "E0"
        RA           13.1033
        Dec          21.7758
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.4718  -0.8152  -0.3359]
        Angle    130.7535
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4185-2"
}

Galaxy "IC 4187:MCG 6-29-32"
{
        Type  "S0"
        RA           13.0997
        Dec          36.2983
        Distance   3.217e+08  # distance uncertain!
        Radius     1.404e+04
        AbsMag        -19.07
        Axis    [  0.4463  -0.8666  -0.2234]
        Angle    123.5244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4187"
}

Galaxy "IC 4188:MCG 6-29-33:KUG 1303+365"
{
        Type  "Sc"
        RA           13.1006
        Dec          36.3272
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.8241  -0.4841   0.2940]
        Angle     48.6619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4188"
}

Galaxy "IC 4189:UGC 8191:MCG 6-29-34:ZWG 189.21"
{
        Type  "Sc"
        RA           13.1008
        Dec          35.9800
        Distance   2.286e+08  # method: V
        Radius     4.322e+04
        AbsMag        -20.03
        Axis    [  0.7777  -0.6286   0.0089]
        Angle    118.3731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4189"
}

Galaxy "IC 4193:ZWG 217.11"
{
        Type  "E0"
        RA           13.1017
        Dec          39.4233
        Distance   4.571e+08  # distance uncertain!
        Radius     3.324e+04
        AbsMag        -20.13
        Axis    [  0.3813  -0.7787  -0.4982]
        Angle     80.6957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4193"
}

Galaxy "IC 4197:ESO 508-13:MCG 4-31-36"
{
        Type  "S0"
        RA           13.1344
        Dec         -23.7969
        Distance   1.494e+08  # method: V
        Radius     3.042e+04
        AbsMag         -19.8
        Axis    [ -0.8450  -0.1803  -0.5035]
        Angle     70.6404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4197"
}

Galaxy "IC 4200:ESO 219-33"
{
        Type  "S0"
        RA           13.1594
        Dec         -51.9686
        Distance   1.885e+08  # method: V
        Radius     4.113e+04
        AbsMag        -19.91
        Axis    [ -0.6499  -0.3624  -0.6680]
        Angle     90.9856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4200"
}

Galaxy "IC 4201:MCG 6-29-42"
{
        Type  "S0"
        RA           13.1308
        Dec          35.8339
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.4451  -0.8662  -0.2273]
        Angle    124.0391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4201"
}

Galaxy "IC 4202:UGC 8220:MCG 4-31-8:ZWG 130.12"
{
        Type  "Sc"
        RA           13.1419
        Dec          24.7008
        Distance   3.353e+08  # method: V
        Radius     8.291e+04
        AbsMag        -19.86
        Axis    [ -0.6432   0.0494   0.7641]
        Angle     39.1760
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4202"
}

Galaxy "IC 4204:UGC 8224:FGC 1566"
{
        Type  "SBc"
        RA           13.1392
        Dec          39.4608
        Distance    2.44e+08  # distance uncertain!
        Radius     4.614e+04
        AbsMag        -19.07
        Axis    [  0.8475  -0.3008   0.4375]
        Angle     85.9709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4204"
}

Galaxy "IC 4207"
{
        Type  "E0"
        RA           13.1575
        Dec          37.8228
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.4108  -0.8832  -0.2263]
        Angle    124.1989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4207"
}

Galaxy "IC 4209:MCG 1-34-9:IRAS 13077-0654"
{
        Type  "SBc"
        RA           13.1728
        Dec          -7.1708
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [  0.2904  -0.7521  -0.5916]
        Angle     26.7710
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4209"
}

Galaxy "IC 4210:NGC 5004B:MCG 5-31-148:ZWG 160.155"
{
        Type  "SBb"
        RA           13.1797
        Dec          29.7092
        Distance   3.003e+08  # method: V
        Radius     3.495e+04
        AbsMag        -19.52
        Axis    [  0.8200  -0.5719  -0.0231]
        Angle    118.9794
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4210"
}

Galaxy "IC 4212:MCG 1-34-11:UGCA 333"
{
        Type  "SBc"
        RA           13.2006
        Dec          -6.9936
        Distance   8.159e+07  # method: V
        Radius     3.679e+04
        AbsMag        -16.09
        Axis    [  0.5874  -0.5030  -0.6340]
        Angle     81.1299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4212"
}

Galaxy "IC 4213:UGC 8280:MCG 6-29-57:ZWG 189.39"
{
        Type  "Sc"
        RA           13.2031
        Dec          35.6714
        Distance   4.748e+07  # method: V
        Radius     1.726e+04
        AbsMag        -16.81
        Axis    [ -0.7886   0.2835   0.5457]
        Angle     66.5363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4213"
}

Galaxy "IC 4214:ESO 444-5:MCG 5-31-43:IRAS 13149-3150"
{
        Type  "SBb"
        RA           13.2950
        Dec         -32.1014
        Distance   1.162e+08  # method: V
        Radius      4.73e+04
        AbsMag        -20.66
        Axis    [  0.8152  -0.2452  -0.5247]
        Angle    128.3927
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4214"
}

Galaxy "IC 4215:UGC 8336:MCG 4-31-17:ZWG 130.24"
{
        Type  "Sb"
        RA           13.2711
        Dec          25.4047
        Distance   1.833e+08  # method: V
        Radius     3.999e+04
        AbsMag        -18.75
        Axis    [  0.9038  -0.3153   0.2893]
        Angle     78.3846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4215"
}

Galaxy "IC 4216:MCG 2-34-13:IRAS 13144-1030"
{
        Type  "Sc"
        RA           13.2836
        Dec         -10.7697
        Distance   1.421e+08  # method: V
        Radius     3.927e+04
        AbsMag           -19
        Axis    [  0.7845  -0.4202  -0.4560]
        Angle     66.9696
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4216"
}

Galaxy "IC 4217:MCG 2-34-14"
{
        Type  "Sc"
        RA           13.2869
        Dec         -13.1556
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.8291  -0.3602  -0.4277]
        Angle    105.4799
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4217"
}

Galaxy "IC 4218:UGC 8348:MCG 0-34-22:ZWG 16.39"
{
        Type  "S0"
        RA           13.2842
        Dec          -2.2619
        Distance   2.776e+08  # method: V
        Radius     5.248e+04
        AbsMag        -20.15
        Axis    [ -0.9379  -0.2914   0.1880]
        Angle     47.9135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4218"
}

Galaxy "IC 4219:ESO 444-6:MCG 5-31-44:IRAS 13157-3122"
{
        Type  "SBb"
        RA           13.3081
        Dec         -31.6311
        Distance    1.78e+08  # method: V
        Radius     2.848e+04
        AbsMag        -20.18
        Axis    [  0.6997  -0.4064  -0.5875]
        Angle    142.9113
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4219"
}

Galaxy "IC 4220:MCG 2-34-17"
{
        Type  "S0"
        RA           13.2983
        Dec         -13.6056
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.1636  -0.4040  -0.9000]
        Angle     54.5155
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4220"
}

Galaxy "IC 4221:MCG 2-34-21:IRAS 13158-1420"
{
        Type  "SBc"
        RA           13.3083
        Dec         -14.6094
        Distance   1.456e+08  # method: V
        Radius     2.752e+04
        AbsMag        -19.65
        Axis    [ -0.9125  -0.1293  -0.3882]
        Angle     64.1957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4221"
}

Galaxy "IC 4223:ZWG 44.64"
{
        Type  "S0"
        RA           13.3153
        Dec           7.7953
        Distance   2.226e+08  # distance uncertain!
        Radius     1.942e+04
        AbsMag        -19.07
        Axis    [ -0.9964   0.0379  -0.0758]
        Angle     45.2930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4223"
}

Galaxy "IC 4224:MCG 0-34-27:ZWG 16.51"
{
        Type  "Sc"
        RA           13.3178
        Dec          -2.5158
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.0320  -0.5433  -0.8389]
        Angle     39.2027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4224"
}

Galaxy "IC 4225:UGC 8378:MCG 5-31-177:ZWG 160.198"
{
        Type  "Sa"
        RA           13.3333
        Dec          31.9819
        Distance   2.573e+08  # method: V
        Radius     3.742e+04
        AbsMag        -19.28
        Axis    [ -0.4326   0.0733   0.8986]
        Angle     30.1300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4225"
}

Galaxy "IC 4226:MCG 5-32-2:ZWG 160.205:ZWG 161.23"
{
        Type  "S0"
        RA           13.3417
        Dec          32.0044
        Distance   2.565e+08  # method: V
        Radius     1.492e+04
        AbsMag        -19.48
        Axis    [ -0.7982   0.4303  -0.4216]
        Angle     16.5421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4226"
}

Galaxy "IC 4227:ZWG 161.25:DFOT 450"
{
        Type  "S0"
        RA           13.3481
        Dec          32.1911
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [  0.7714  -0.5636   0.2957]
        Angle     37.2748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4227"
}

Galaxy "IC 4228:MCG 4-32-1:ZWG 131.2"
{
        Type  "Sc"
        RA           13.3594
        Dec          25.5156
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.7872  -0.6159  -0.0308]
        Angle     50.3645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4228"
}

Galaxy "IC 4229:UGC 8404:MCG 0-34-32:ZWG 16.62"
{
        Type  "SBb"
        RA           13.3739
        Dec          -2.4181
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [ -0.2181  -0.3727  -0.9020]
        Angle     47.0804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4229"
}

Galaxy "IC 4230:UGC 8402:MCG 5-32-8:ZWG 161.32"
{
        Type  "Sa"
        RA           13.3664
        Dec          26.7339
        Distance   3.389e+08  # method: V
        Radius     4.929e+04
        AbsMag        -19.78
        Axis    [  0.9441  -0.3099   0.1125]
        Angle    120.2470
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4230"
}

Galaxy "IC 4231:ESO 508-60:MCG 4-32-9"
{
        Type  "Sc"
        RA           13.3869
        Dec         -26.3003
        Distance   1.053e+08  # method: T-F
        Radius     2.604e+04
        AbsMag        -18.24
        Axis    [  0.8797  -0.1842  -0.4383]
        Angle     84.1478
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4231"
}

Galaxy "IC 4232:ESO 508-61:MCG 4-32-10:IRAS 13206-2550"
{
        Type  "Sc"
        RA           13.3894
        Dec         -26.1092
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.8949  -0.1544  -0.4186]
        Angle    115.7841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4232"
}

Galaxy "IC 4234:MCG 5-32-11:ZWG 161.38"
{
        Type  "SBb"
        RA           13.3833
        Dec          27.1167
        Distance   4.807e+08  # method: V
        Radius     4.894e+04
        AbsMag        -20.94
        Axis    [  0.7581  -0.6408  -0.1210]
        Angle     94.2251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4234"
}

Galaxy "IC 4235:NPM 1"
{
        Type  "S0"
        RA           13.3978
        Dec         -12.7428
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [  0.7157  -0.5839  -0.3832]
        Angle     41.1855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4235"
}

Galaxy "IC 4237:ESO 576-48:MCG 3-34-68:IRAS 13218-2052"
{
        Type  "SBb"
        RA           13.4089
        Dec         -21.1369
        Distance   1.536e+08  # method: T-F
        Radius     5.586e+04
        AbsMag        -20.06
        Axis    [ -0.6785  -0.3698  -0.6347]
        Angle     55.2854
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4237"
}

Galaxy "IC 4238"
{
        Type  "S0"
        RA           13.3997
        Dec          30.9325
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [  0.9010  -0.3860   0.1981]
        Angle     98.3570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4238"
}

Galaxy "IC 4239:MCG 5-32-15:ZWG 161.45"
{
        Type  "SBa"
        RA           13.4069
        Dec          30.9592
        Distance    6.71e+08  # method: V
        Radius     7.807e+04
        AbsMag        -21.27
        Axis    [ -0.8358   0.3096   0.4534]
        Angle     27.6031
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4239"
}

Galaxy "IC 4240"
{
        Type  "S0"
        RA           13.4075
        Dec          30.9778
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [  0.8347  -0.5461   0.0708]
        Angle     86.1269
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4240"
}

Galaxy "IC 4241:MCG 5-32-16:ZWG 161.46"
{
        Type  "E0"
        RA           13.4128
        Dec          26.7386
        Distance   4.366e+08  # distance uncertain!
        Radius     3.175e+04
        AbsMag        -20.13
        Axis    [  0.4254  -0.8509  -0.3082]
        Angle    131.4809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4241"
}

Galaxy "IC 4242"
{
        Type  "S0"
        RA           13.4114
        Dec          31.0261
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.7775  -0.1825   0.6019]
        Angle      7.6618
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4242"
}

Galaxy "IC 4243:ESO 509-1:DRCG 28-13"
{
        Type  "S0"
        RA           13.4308
        Dec         -27.6267
        Distance   5.613e+08  # method: V
        Radius     5.715e+04
        AbsMag        -20.98
        Axis    [  0.7229  -0.4058  -0.5592]
        Angle    137.8371
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4243"
}

Galaxy "IC 4244:ZWG 161.47:NPM 1"
{
        Type  "S0"
        RA           13.4156
        Dec          26.4639
        Distance    2.44e+08  # distance uncertain!
        Radius     1.065e+04
        AbsMag        -19.07
        Axis    [  0.6606  -0.7235  -0.2005]
        Angle     31.8823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4244"
}

Galaxy "IC 4245:ESO 509-2:MCG 4-32-12:AM 1323-262"
{
        Type  "Sa"
        RA           13.4331
        Dec         -26.6775
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [ -0.0998  -0.5679  -0.8170]
        Angle     51.1367
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4245"
}

Galaxy "IC 4246:ESO 509-2:MCG 4-32-13:AM 1323-262"
{
        Type  "S0"
        RA           13.4333
        Dec         -26.6778
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.6599  -0.4124  -0.6281]
        Angle     59.1100
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4246"
}

Galaxy "IC 4247:ESO 444-34:MCG 5-32-17"
{
        Type  "Sc"
        RA           13.4456
        Dec         -30.3619
        Distance    2.51e+07  # method: V
        Radius          4745
        AbsMag        -15.03
        Axis    [ -0.7914  -0.4895  -0.3663]
        Angle     62.0335
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4247"
}

Galaxy "IC 4248:ESO 444-35:MCG 5-32-18:TOL 34"
{
        Type  "Sb"
        RA           13.4464
        Dec         -29.8808
        Distance   1.999e+08  # method: V
        Radius     3.198e+04
        AbsMag        -20.04
        Axis    [ -0.0973  -0.4322  -0.8965]
        Angle     70.2012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4248"
}

Galaxy "IC 4249:ESO 444-39:MCG 5-32-20:TOL 35"
{
        Type  "Sb"
        RA           13.4517
        Dec         -27.9567
        Distance   9.504e+07  # method: V
        Radius     1.935e+04
        AbsMag        -17.82
        Axis    [ -0.0348  -0.7351  -0.6770]
        Angle     40.3965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4249"
}

Galaxy "IC 4250-1:ZWG 161.49:KUG 1323+267"
{
        Type  "S0"
        RA           13.4358
        Dec          26.4772
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.6068  -0.7156  -0.3460]
        Angle     38.7692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4250-1"
}

Galaxy "IC 4250-2:ZWG 161.49"
{
        Type  "S0"
        RA           13.4356
        Dec          26.4728
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [  0.6497  -0.5106   0.5632]
        Angle     32.3047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4250-2"
}

Galaxy "IC 4251:ESO 444-41:MCG 5-32-21"
{
        Type  "S0"
        RA           13.4567
        Dec         -29.4444
        Distance   2.125e+08  # method: V
        Radius     2.472e+04
        AbsMag        -19.07
        Axis    [ -0.6332  -0.2871  -0.7188]
        Angle     72.1290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4251"
}

Galaxy "IC 4252:ESO 509-13:MCG 4-32-18:DRCG 28-65"
{
        Type  "S0"
        RA           13.4578
        Dec         -27.3244
        Distance   6.282e+08  # method: V
        Radius     1.188e+05
        AbsMag        -22.32
        Axis    [ -0.5991  -0.4676  -0.6500]
        Angle     56.5213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4252"
}

Galaxy "IC 4253:ESO 444-42:MCG 5-32-22"
{
        Type  "SBc"
        RA           13.4589
        Dec         -27.8728
        Distance    4.74e+08  # method: V
        Radius     9.652e+04
        AbsMag        -21.01
        Axis    [ -0.5817  -0.5620  -0.5880]
        Angle     51.4550
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4253"
}

Galaxy "IC 4254:ESO 509-17:AM 1324-265:DRCG 28-75"
{
        Type  "Sc"
        RA           13.4625
        Dec         -27.2219
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.7332  -0.3963  -0.5526]
        Angle    136.3024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4254"
}

Galaxy "IC 4255:ESO 509-20:MCG 4-32-20:DRCG 28-52"
{
        Type  "E0"
        RA           13.4667
        Dec         -27.3539
        Distance   4.737e+08  # method: V
        Radius     6.201e+04
        AbsMag        -21.61
        Axis    [  0.3417  -0.5157  -0.7857]
        Angle    139.1372
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4255"
}

Galaxy "IC 4256:ZWG 161.54"
{
        Type  "Sb"
        RA           13.4508
        Dec          30.9764
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [  0.8248  -0.5582   0.0901]
        Angle     76.6246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4256"
}

Galaxy "IC 4258:MCG 5-32-22:ZWG 161.57:NPM 1"
{
        Type  "E0"
        RA           13.4647
        Dec          28.5086
        Distance   5.169e+08  # method: V
        Radius     5.263e+04
        AbsMag         -20.8
        Axis    [  0.3691  -0.8137  -0.4490]
        Angle    106.0571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4258"
}

Galaxy "IC 4259:ESO 444-51"
{
        Type  "S0"
        RA           13.4911
        Dec         -30.1342
        Distance   6.557e+08  # method: V
        Radius     9.537e+04
        AbsMag        -21.42
        Axis    [ -0.8527  -0.3691  -0.3698]
        Angle     70.6557
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4259"
}

Galaxy "IC 4260:ESO 444-52"
{
        Type  "Sb"
        RA           13.4944
        Dec         -28.2661
        Distance   2.802e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -19.07
        Axis    [  0.3498  -0.7374  -0.5778]
        Angle     37.9734
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4260"
}

Galaxy "IC 4261:ESO 444-54:MCG 5-32-32"
{
        Type  "S0"
        RA           13.4964
        Dec         -28.0064
        Distance   1.688e+08  # distance uncertain!
        Radius     2.455e+04
        AbsMag        -19.07
        Axis    [ -0.5165  -0.3763  -0.7692]
        Angle     65.2746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4261"
}

Galaxy "IC 4262:ESO 444-58"
{
        Type  "Sb"
        RA           13.5064
        Dec         -28.2706
        Distance   4.881e+08  # method: V
        Radius     8.519e+04
        AbsMag        -20.28
        Axis    [  0.7146  -0.3946  -0.5776]
        Angle     60.4957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4262"
}

Galaxy "IC 4263:UGC 8470:MCG 8-25-7:ZWG 246.4"
{
        Type  "SBc"
        RA           13.4758
        Dec          46.9269
        Distance   2.868e+07  # method: V
        Radius          7924
        AbsMag        -14.52
        Axis    [  0.3192  -0.0869   0.9437]
        Angle     52.9018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4263"
}

Galaxy "IC 4264:ESO 444-57:MCG 5-32-33"
{
        Type  "Sc"
        RA           13.5047
        Dec         -27.9286
        Distance   1.713e+08  # method: T-F
        Radius     4.235e+04
        AbsMag         -18.6
        Axis    [  0.0921  -0.7832  -0.6149]
        Angle     38.1074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4264"
}

Galaxy "IC 4265:ESO 509-34"
{
        Type  "S0"
        RA           13.5061
        Dec         -25.7656
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.9361  -0.1764  -0.3042]
        Angle     81.0024
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4265"
}

Galaxy "IC 4266"
{
        Type  "S0"
        RA           13.4847
        Dec          37.6117
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.7571  -0.6531   0.0152]
        Angle    111.8507
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4266"
}

Galaxy "IC 4267:ESO 509-35:MCG 4-32-24"
{
        Type  "Sc"
        RA           13.5100
        Dec         -26.2561
        Distance   1.877e+08  # method: T-F
        Radius     3.549e+04
        AbsMag         -18.6
        Axis    [ -0.6538  -0.5832  -0.4822]
        Angle     50.1748
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4267"
}

Galaxy "IC 4268:NPM 1"
{
        Type  "E0"
        RA           13.4867
        Dec          37.6611
        Distance   7.245e+08  # distance uncertain!
        Radius     2.107e+04
        AbsMag        -20.13
        Axis    [  0.3809  -0.8954  -0.2307]
        Angle    127.8431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4268"
}

Galaxy "IC 4269:MCG 6-30-14:NPM 1"
{
        Type  "S0"
        RA           13.4889
        Dec          37.6236
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [  0.5850  -0.7939  -0.1658]
        Angle     11.2022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4269"
}

Galaxy "IC 4270:ESO 509-37:MCG 4-32-27"
{
        Type  "Sc"
        RA           13.5136
        Dec         -25.3336
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.5458  -0.5780  -0.6066]
        Angle    155.6770
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4270"
}

Galaxy "IC 4271-1:MCG 6-30-15:ZWG 190.12:VV 355"
{
        Type  "S0"
        RA           13.4892
        Dec          37.4136
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [  0.7575  -0.6527   0.0125]
        Angle    112.8776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4271-1"
}

Galaxy "IC 4271-2:MCG 6-30-15:ZWG 190.12:VV 355"
{
        Type  "E0"
        RA           13.4892
        Dec          37.4097
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [  0.3815  -0.8946  -0.2326]
        Angle    127.9663
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4271-2"
}

Galaxy "IC 4272:ESO 444-63:IRAS 13284-2941"
{
        Type  "Sc"
        RA           13.5211
        Dec         -29.9567
        Distance   2.802e+08  # distance uncertain!
        Radius     4.075e+04
        AbsMag        -19.07
        Axis    [ -0.3366  -0.8481  -0.4092]
        Angle     39.3878
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4272"
}

Galaxy "IC 4273:ESO 444-65:MCG 5-32-35"
{
        Type  "S0"
        RA           13.5247
        Dec         -28.8939
        Distance   5.996e+08  # method: V
        Radius     6.976e+04
        AbsMag        -21.12
        Axis    [  0.6063  -0.3999  -0.6874]
        Angle    107.6124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4273"
}

Galaxy "IC 4275:ESO 444-67:MCG 5-32-38:IRAS 13290-2928"
{
        Type  "SBc"
        RA           13.5308
        Dec         -29.7322
        Distance   1.735e+08  # method: T-F
        Radius     2.272e+04
        AbsMag        -19.43
        Axis    [  0.7513  -0.3006  -0.5875]
        Angle    106.3502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4275"
}

Galaxy "IC 4276:ESO 444-68:IRAS 13292-2753"
{
        Type  "Sc"
        RA           13.5350
        Dec         -28.1564
        Distance   4.249e+08  # method: V
        Radius     8.651e+04
        AbsMag        -20.17
        Axis    [  0.7684  -0.3834  -0.5124]
        Angle     57.3500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4276"
}

Galaxy "IC 4277"
{
        Type  "S0"
        RA           13.5044
        Dec          47.3144
        Distance   4.241e+08  # distance uncertain!
        Radius     5.551e+04
        AbsMag        -19.07
        Axis    [  0.4558  -0.1586   0.8758]
        Angle     58.1286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4277"
}

Galaxy "IC 4278"
{
        Type  "Irr"
        RA           13.5075
        Dec          47.2469
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [ -0.6682   0.6701   0.3232]
        Angle     50.9953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4278"
}

Galaxy "IC 4279:ESO 509-47:MCG 4-32-32"
{
        Type  "Sc"
        RA           13.5417
        Dec         -27.1275
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [  0.6641  -0.3850  -0.6408]
        Angle     77.6886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4279"
}

Galaxy "IC 4280:ESO 509-54:MCG 4-32-36:AM 1330-235"
{
        Type  "Sc"
        RA           13.5481
        Dec         -24.2069
        Distance   2.363e+08  # method: V
        Radius      3.78e+04
        AbsMag         -20.8
        Axis    [  0.4332  -0.4661  -0.7714]
        Angle     95.5358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4280"
}

Galaxy "IC 4281:ESO 509-49:MCG 4-32-33:VV 631"
{
        Type  "S0"
        RA           13.5439
        Dec         -27.1692
        Distance    5.54e+08  # method: V
        Radius     1.128e+05
        AbsMag        -21.65
        Axis    [  0.0645  -0.5031  -0.8618]
        Angle     64.1984
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4281"
}

Galaxy "IC 4282"
{
        Type  "E0"
        RA           13.5219
        Dec          47.1839
        Distance   1.381e+09  # distance uncertain!
        Radius     6.024e+04
        AbsMag        -20.13
        Axis    [  0.3411  -0.9266  -0.1582]
        Angle    124.8043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4282"
}

Galaxy "IC 4283:ZWG 161.78"
{
        Type  "SBb"
        RA           13.5361
        Dec          28.3889
        Distance   4.125e+08  # method: V
        Radius         3e+04
        AbsMag        -20.11
        Axis    [  0.7515  -0.6596  -0.0088]
        Angle     52.0294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4283"
}

Galaxy "IC 4284"
{
        Type  "E0"
        RA           13.5253
        Dec          46.7947
        Distance    8.71e+08  # distance uncertain!
        Radius     2.534e+04
        AbsMag        -20.13
        Axis    [  0.3424  -0.9256  -0.1613]
        Angle    124.9766
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4284"
}

Galaxy "IC 4285"
{
        Type  "S0"
        RA           13.5292
        Dec          46.8219
        Distance   6.721e+08  # distance uncertain!
        Radius     1.955e+04
        AbsMag        -19.07
        Axis    [  0.6123  -0.3906   0.6874]
        Angle     38.0023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4285"
}

Galaxy "IC 4286:ESO 509-58"
{
        Type  "S0"
        RA           13.5597
        Dec         -27.6319
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.5432  -0.5666  -0.6196]
        Angle    157.0525
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4286"
}

Galaxy "IC 4287-1:ZWG 131.10"
{
        Type  "S0"
        RA           13.5439
        Dec          25.4414
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.9269   0.2713   0.2593]
        Angle     40.9526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4287-1"
}

Galaxy "IC 4287-2:ZWG 131.10"
{
        Type  "E0"
        RA           13.5442
        Dec          25.4403
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.4167  -0.8512  -0.3193]
        Angle    133.3205
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4287-2"
}

Galaxy "IC 4288:ESO 509-61:MCG 4-32-39"
{
        Type  "Sc"
        RA           13.5750
        Dec         -27.3044
        Distance   4.886e+08  # method: V
        Radius     8.527e+04
        AbsMag        -21.08
        Axis    [ -0.2163  -0.5929  -0.7757]
        Angle     51.6883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4288"
}

Galaxy "IC 4289:ESO 509-67:MCG 4-32-41"
{
        Type  "S0"
        RA           13.5797
        Dec         -27.1267
        Distance   4.836e+08  # method: V
        Radius     7.034e+04
        AbsMag        -21.56
        Axis    [  0.7147  -0.3962  -0.5764]
        Angle    130.0033
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4289"
}

Galaxy "IC 4290:ESO 444-74:MCG 5-32-44"
{
        Type  "SBb"
        RA           13.5886
        Dec         -28.0219
        Distance    2.33e+08  # method: V
        Radius     5.423e+04
        AbsMag        -20.07
        Axis    [ -0.0628  -0.4271  -0.9020]
        Angle     76.9523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4290"
}

Galaxy "IC 4292:ESO 509-76:IRAS 13329-2725"
{
        Type  "S0"
        RA           13.5961
        Dec         -27.6750
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [  0.5769  -0.4376  -0.6897]
        Angle    115.5349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4292"
}

Galaxy "IC 4293:ESO 509-77:MCG 4-32-44"
{
        Type  "S0"
        RA           13.6006
        Dec         -25.8822
        Distance   2.214e+08  # method: V
        Radius     4.831e+04
        AbsMag        -20.66
        Axis    [ -0.9379  -0.2077  -0.2778]
        Angle     79.9311
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4293"
}

Galaxy "IC 4294:ESO 444-79"
{
        Type  "Sb"
        RA           13.6086
        Dec         -28.7814
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.7541  -0.3071  -0.5805]
        Angle    100.5164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4294"
}

Galaxy "IC 4295:ESO 444-80:MCG 5-32-49"
{
        Type  "Sc"
        RA           13.6094
        Dec         -29.0889
        Distance   2.151e+08  # method: V
        Radius     3.128e+04
        AbsMag           -19
        Axis    [ -0.2455  -0.6663  -0.7041]
        Angle     48.1697
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4295"
}

Galaxy "IC 4296:ESO 383-39:MCG 6-30-16:AM 1333-334"
{
        Type  "E0"
        RA           13.6106
        Dec         -33.9658
        Distance   1.504e+08  # method: T-F
        Radius     6.126e+04
        AbsMag        -21.72
        Axis    [  0.5278  -0.5430  -0.6531]
        Angle    162.4548
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4296"
}

Galaxy "IC 4297:UGC 8570:MCG 5-32-40:ZWG 161.82"
{
        Type  "SBa"
        RA           13.5886
        Dec          26.4253
        Distance    3.46e+08  # method: V
        Radius     4.529e+04
        AbsMag        -19.83
        Axis    [  0.7699  -0.6382   0.0035]
        Angle     57.2909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4297"
}

Galaxy "IC 4298:ESO 509-80:MCG 4-32-45:AM 1333-261"
{
        Type  "Sc"
        RA           13.6094
        Dec         -26.5542
        Distance     3.2e+08  # method: T-F
        Radius      6.98e+04
        AbsMag        -20.76
        Axis    [ -0.9365  -0.3000  -0.1817]
        Angle     78.1473
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4298"
}

Galaxy "IC 4299:ESO 383-42:MCG 6-30-17"
{
        Type  "SBa"
        RA           13.6131
        Dec         -34.0658
        Distance   1.947e+08  # method: V
        Radius     5.379e+04
        AbsMag        -20.18
        Axis    [  0.5381  -0.3999  -0.7420]
        Angle     77.6466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4299"
}

Galaxy "IC 4300:MCG 6-30-48"
{
        Type  "E0"
        RA           13.5903
        Dec          33.4197
        Distance   5.755e+08  # distance uncertain!
        Radius     1.674e+04
        AbsMag        -20.13
        Axis    [  0.3862  -0.8841  -0.2631]
        Angle    130.5864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4300"
}

Galaxy "IC 4301:UGC 8579:MCG 6-30-50"
{
        Type  "Sc"
        RA           13.5931
        Dec          33.3744
        Distance   3.072e+08  # distance uncertain!
        Radius     4.021e+04
        AbsMag        -19.07
        Axis    [ -0.2315  -0.0580   0.9711]
        Angle     38.6421
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4301"
}

Galaxy "IC 4302:UGC 8580:MCG 6-30-51:FGC 1641"
{
        Type  "Sc"
        RA           13.5931
        Dec          33.4794
        Distance   3.072e+08  # distance uncertain!
        Radius     5.809e+04
        AbsMag        -19.07
        Axis    [ -0.1245  -0.0935   0.9878]
        Angle     40.6368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4302"
}

Galaxy "IC 4303:ESO 444-83:MCG 5-32-51"
{
        Type  "SBc"
        RA           13.6217
        Dec         -28.6578
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [  0.4960  -0.4615  -0.7356]
        Angle     71.4846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4303"
}

Galaxy "IC 4304:UGC 8586:MCG 6-30-55:ZWG 190.32"
{
        Type  "Sb"
        RA           13.5992
        Dec          33.4297
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [  0.8476  -0.4800   0.2261]
        Angle     83.3197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4304"
}

Galaxy "IC 4305:MCG 6-30-54:ZWG 190.33"
{
        Type  "E5"
        RA           13.5994
        Dec          33.4744
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [ -0.3819   0.6401  -0.6667]
        Angle     66.9379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4305"
}

Galaxy "IC 4306:MCG 6-30-58:ZWG 190.35"
{
        Type  "S0"
        RA           13.6053
        Dec          33.4242
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [  0.6985  -0.5290   0.4820]
        Angle     41.3804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4306"
}

Galaxy "IC 4307:MCG 5-32-43:ZWG 161.88:NPM 1"
{
        Type  "S0"
        RA           13.6100
        Dec          27.2428
        Distance   4.969e+08  # method: V
        Radius     5.059e+04
        AbsMag        -20.81
        Axis    [  0.4285  -0.8532  -0.2973]
        Angle    132.3255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4307"
}

Galaxy "IC 4309:ESO 444-91"
{
        Type  "Sc"
        RA           13.6472
        Dec         -29.6631
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.4731  -0.4072  -0.7812]
        Angle     67.4990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4309"
}

Galaxy "IC 4310:ESO 509-88:MCG 4-32-47:AM 1336-253"
{
        Type  "S0"
        RA           13.6492
        Dec         -25.8456
        Distance   1.231e+08  # method: V
        Radius     3.938e+04
        AbsMag        -19.58
        Axis    [  0.5221  -0.5290  -0.6690]
        Angle     57.8975
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4310"
}

Galaxy "IC 4311:ESO 220-27:IRAS 13370-5047"
{
        Type  "Sc"
        RA           13.6689
        Dec         -51.0364
        Distance   1.928e+08  # method: V
        Radius     2.805e+04
        AbsMag        -19.76
        Axis    [ -0.6631  -0.3859  -0.6414]
        Angle     91.4301
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4311"
}

Galaxy "IC 4312:ESO 220-29:IRAS 13373-5049"
{
        Type  "S0"
        RA           13.6750
        Dec         -51.0714
        Distance   1.908e+08  # method: V
        Radius     2.498e+04
        AbsMag        -20.44
        Axis    [  0.5132  -0.2911  -0.8074]
        Angle    123.2003
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4312"
}

Galaxy "IC 4313:MCG 5-32-46:ZWG 161.94:NPM 1"
{
        Type  "E0"
        RA           13.6389
        Dec          26.7603
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.4033  -0.8604  -0.3115]
        Angle    133.7167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4313"
}

Galaxy "IC 4314:MCG 5-32-47:ZWG 161.96:NPM 1"
{
        Type  "E0"
        RA           13.6403
        Dec          26.7431
        Distance   4.061e+08  # method: V
        Radius     3.544e+04
        AbsMag        -20.68
        Axis    [  0.4032  -0.8604  -0.3116]
        Angle    133.7375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4314"
}

Galaxy "IC 4315:ESO 509-91:MCG 4-32-49:AM 1337-251"
{
        Type  "SBc"
        RA           13.6675
        Dec         -25.4750
        Distance   1.837e+08  # method: T-F
        Radius     4.274e+04
        AbsMag        -18.75
        Axis    [ -0.5540  -0.8118  -0.1848]
        Angle     42.4762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4315"
}

Galaxy "IC 4316:ESO 445-6:MCG 5-32-62:TOL 37"
{
        Type  "Irr"
        RA           13.6717
        Dec         -28.8919
        Distance   4.285e+07  # method: V
        Radius          6233
        AbsMag        -15.59
        Axis    [  0.5393  -0.4274  -0.7256]
        Angle     96.3465
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4316"
}

Galaxy "IC 4317:NPM 1"
{
        Type  "S0"
        RA           13.6958
        Dec          27.1064
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.6863  -0.7071  -0.1701]
        Angle    109.8649
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4317"
}

Galaxy "IC 4318:ESO 445-17:MCG 5-32-69:IRAS 13405-2842"
{
        Type  "Sc"
        RA           13.7228
        Dec         -28.9686
        Distance    4.16e+08  # method: V
        Radius     6.656e+04
        AbsMag        -20.93
        Axis    [  0.4030  -0.4708  -0.7848]
        Angle    113.5162
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4318"
}

Galaxy "IC 4319:ESO 445-19:MCG 5-32-71:IRAS 13406-2933"
{
        Type  "Sc"
        RA           13.7239
        Dec         -29.8033
        Distance   2.055e+08  # method: T-F
        Radius     4.483e+04
        AbsMag         -19.7
        Axis    [  0.5321  -0.5059  -0.6789]
        Angle     60.5703
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4319"
}

Galaxy "IC 4320:ESO 509-101:MCG 4-32-53:AM 1341-265"
{
        Type  "S0"
        RA           13.7342
        Dec         -27.2317
        Distance   3.212e+08  # method: V
        Radius     4.204e+04
        AbsMag        -20.67
        Axis    [  0.5239  -0.5773  -0.6263]
        Angle    157.5758
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4320"
}

Galaxy "IC 4321:ESO 445-22:MCG 5-32-73"
{
        Type  "Sb"
        RA           13.7419
        Dec         -30.1397
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.6192  -0.4047  -0.6729]
        Angle    113.5415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4321"
}

Galaxy "IC 4322:ZWG 131.30:NPM 1"
{
        Type  "E0"
        RA           13.7289
        Dec          25.3928
        Distance   3.818e+08  # method: V
        Radius     5.552e+04
        AbsMag        -19.94
        Axis    [  0.3988  -0.8585  -0.3224]
        Angle    135.1595
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4322"
}

Galaxy "IC 4323:ESO 445-24"
{
        Type  "S0"
        RA           13.7517
        Dec         -28.6517
        Distance   3.217e+08  # distance uncertain!
        Radius     7.018e+04
        AbsMag        -19.07
        Axis    [  0.7534  -0.4151  -0.5100]
        Angle     59.5279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4323"
}

Galaxy "IC 4324:ESO 445-25:MCG 5-32-75:AM 1342-295"
{
        Type  "Sc"
        RA           13.7575
        Dec         -30.2272
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [ -0.5742  -0.4630  -0.6752]
        Angle     63.8408
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4324"
}

Galaxy "IC 4325:ESO 445-32:MCG 5-33-7:IRAS 13448-2911"
{
        Type  "SBc"
        RA           13.7942
        Dec         -29.4344
        Distance   1.842e+08  # method: V
        Radius     2.947e+04
        AbsMag        -18.96
        Axis    [ -0.0081  -0.7106  -0.7036]
        Angle     48.4699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4325"
}

Galaxy "IC 4326:ESO 445-38:MCG 5-33-12:IRAS 13454-2922"
{
        Type  "S0"
        RA           13.8058
        Dec         -29.6264
        Distance   2.172e+08  # method: V
        Radius     2.527e+04
        AbsMag        -19.62
        Axis    [ -0.8407  -0.0891  -0.5342]
        Angle     88.3412
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4326"
}

Galaxy "IC 4327:ESO 445-41:MCG 5-33-16:IRAS 13458-2958"
{
        Type  "SBc"
        RA           13.8119
        Dec         -30.2181
        Distance    2.14e+08  # method: T-F
        Radius     3.112e+04
        AbsMag        -19.58
        Axis    [  0.5432  -0.4471  -0.7107]
        Angle     78.6589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4327"
}

Galaxy "IC 4328:ESO 445-45"
{
        Type  "Sb"
        RA           13.8172
        Dec         -29.9372
        Distance   2.184e+08  # method: V
        Radius     2.859e+04
        AbsMag        -19.23
        Axis    [ -0.8916  -0.1546  -0.4257]
        Angle     85.3773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4328"
}

Galaxy "IC 4329:ESO 445-46:MCG 5-33-19:AM 1346-300"
{
        Type  "S0"
        RA           13.8181
        Dec         -30.2961
        Distance    2.17e+08  # method: V
        Radius      1.01e+05
        AbsMag        -22.01
        Axis    [  0.4242  -0.4786  -0.7688]
        Angle     79.2965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4329"
}

Galaxy "IC 4329A:ESO 445-50:MCG 5-33-21:IRAS 13464-3003"
{
        Type  "Sa"
        RA           13.8219
        Dec         -30.3100
        Distance    2.29e+08  # method: V
        Radius     4.664e+04
        AbsMag        -20.33
        Axis    [  0.7439  -0.3443  -0.5728]
        Angle     76.5981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4329A"
}

Galaxy "IC 4330:ESO 445-27:MCG 5-33-3"
{
        Type  "SBc"
        RA           13.7872
        Dec         -28.3319
        Distance   5.328e+08  # method: V
        Radius     9.299e+04
        AbsMag        -21.27
        Axis    [  0.0873  -0.6091  -0.7883]
        Angle     57.0012
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4330"
}

Galaxy "IC 4331"
{
        Type  "E0"
        RA           13.8233
        Dec          25.1542
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.2883  -0.7840  -0.5498]
        Angle     98.8458
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4331"
}

Galaxy "IC 4332:MCG 4-33-8:ZWG 132.18"
{
        Type  "S0"
        RA           13.8311
        Dec          25.1900
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [  0.4132  -0.8541  -0.3158]
        Angle    135.2900
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4332"
}

Galaxy "IC 4333:ESO 8-5:IRAS 13574-8402"
{
        Type  "S0"
        RA           14.0886
        Dec         -84.2731
        Distance   2.226e+08  # distance uncertain!
        Radius     5.179e+04
        AbsMag        -19.07
        Axis    [  0.1632  -0.2736  -0.9479]
        Angle     92.4721
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4333"
}

Galaxy "IC 4334:MCG 5-33-8:ZWG 162.14"
{
        Type  "S0"
        RA           13.8300
        Dec          29.6939
        Distance   5.364e+08  # method: V
        Radius     3.901e+04
        AbsMag        -20.68
        Axis    [  0.3999  -0.8718  -0.2829]
        Angle    133.6534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4334"
}

Galaxy "IC 4336:UGC 8761:MCG 7-28-77:ZWG 218.59"
{
        Type  "SBb"
        RA           13.8453
        Dec          39.7069
        Distance   1.851e+08  # distance uncertain!
        Radius     3.769e+04
        AbsMag        -19.07
        Axis    [ -0.6174   0.2340   0.7511]
        Angle     50.6405
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4336"
}

Galaxy "IC 4337:ZWG 102.71:NPM 1"
{
        Type  "S0"
        RA           13.8719
        Dec          14.2725
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.4521  -0.8798   0.1466]
        Angle     28.3521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4337"
}

Galaxy "IC 4339:IC 4341:MCG 6-31-10:ZWG 191.11"
{
        Type  "Sc"
        RA           13.8928
        Dec          37.5219
        Distance    1.15e+08  # method: V
        Radius     1.171e+04
        AbsMag        -17.94
        Axis    [  0.3690  -0.9020  -0.2243]
        Angle    131.6820
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4339"
}

Galaxy "IC 4340:MCG 6-31-9:ZWG 191.10"
{
        Type  "S0"
        RA           13.8925
        Dec          37.3867
        Distance     3.5e+08  # method: V
        Radius      5.09e+04
        AbsMag        -20.15
        Axis    [  0.6906  -0.7232   0.0000]
        Angle     80.7944
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4340"
}

Galaxy "IC 4342:MCG 4-33-21:ZWG 132.39"
{
        Type  "Sc"
        RA           13.9061
        Dec          25.1525
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.8215  -0.5601   0.1069]
        Angle     75.0934
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4342"
}

Galaxy "IC 4343:MCG 4-33-24:ZWG 132.44"
{
        Type  "S0"
        RA           13.9153
        Dec          25.1225
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.3260  -0.8682   0.3742]
        Angle     22.5395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4343"
}

Galaxy "IC 4344:MCG 4-33-26:ZWG 132.45"
{
        Type  "SBa"
        RA           13.9200
        Dec          25.0214
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.7423  -0.6687   0.0442]
        Angle     59.2772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4344"
}

Galaxy "IC 4345:MCG 4-33-25:ZWG 132.46:HCG 69B"
{
        Type  "E0"
        RA           13.9203
        Dec          25.0517
        Distance   5.249e+08  # distance uncertain!
        Radius      6.87e+04
        AbsMag        -20.13
        Axis    [  0.3811  -0.8645  -0.3276]
        Angle    137.1906
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4345"
}

Galaxy "IC 4346:MCG 4-33-29:ZWG 132.49:KUG 1353+253"
{
        Type  "S0"
        RA           13.9278
        Dec          25.1528
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [  0.7597  -0.6379  -0.1259]
        Angle    124.9995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4346"
}

Galaxy "IC 4348:MCG 4-33-30:ZWG 132.50:NPM 1"
{
        Type  "E0"
        RA           13.9292
        Dec          25.2036
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [  0.3798  -0.8655  -0.3267]
        Angle    137.2213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4348"
}

Galaxy "IC 4349:MCG 4-33-32:ZWG 132.51"
{
        Type  "Sc"
        RA           13.9294
        Dec          25.1519
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.3494  -0.5834   0.7332]
        Angle     19.8749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4349"
}

Galaxy "IC 4350:ESO 510-22:MCG 4-33-19:AM 1354-250"
{
        Type  "SBa"
        RA           13.9536
        Dec         -25.2458
        Distance   2.909e+08  # method: V
        Radius     6.769e+04
        AbsMag        -21.05
        Axis    [ -0.6508  -0.5235  -0.5500]
        Angle     57.5420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4350"
}

Galaxy "IC 4351:ESO 445-84:MCG 5-33-34:UGCA 376"
{
        Type  "Sb"
        RA           13.9647
        Dec         -29.3156
        Distance   1.158e+08  # method: T-F
        Radius      9.94e+04
        AbsMag        -20.15
        Axis    [  0.8836  -0.1631  -0.4390]
        Angle     95.6514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4351"
}

Galaxy "IC 4352:ESO 384-22:MCG 6-31-7:IRAS 13554-3416"
{
        Type  "Sb"
        RA           13.9736
        Dec         -34.5175
        Distance   2.437e+08  # method: V
        Radius     6.379e+04
        AbsMag        -20.77
        Axis    [  0.1738  -0.6324  -0.7549]
        Angle     58.4740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4352"
}

Galaxy "IC 4354:MCG 2-36-1:IRAS 13558-1221"
{
        Type  "Sb"
        RA           13.9750
        Dec         -12.6050
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.0051  -0.9644  -0.2644]
        Angle     33.2330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4354"
}

Galaxy "IC 4355:MCG 5-33-30:ZWG 162.37:IRAS 13557+2839"
{
        Type  "Sa"
        RA           13.9683
        Dec          28.4222
        Distance   3.747e+08  # method: V
        Radius     2.725e+04
        AbsMag         -19.9
        Axis    [  0.7802  -0.6208  -0.0766]
        Angle    125.0485
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4355"
}

Galaxy "IC 4356:NPM 1"
{
        Type  "E0"
        RA           13.9792
        Dec          37.4911
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.3366  -0.9115  -0.2363]
        Angle    133.3427
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4356"
}

Galaxy "IC 4357:UGC 8926:MCG 5-33-40:ZWG 162.47"
{
        Type  "Sc"
        RA           14.0119
        Dec          31.8942
        Distance   2.074e+08  # method: V
        Radius     3.318e+04
        AbsMag        -19.22
        Axis    [  0.7054  -0.6974   0.1267]
        Angle     57.3821
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4357"
}

Galaxy "IC 4358:MCG 2-36-4"
{
        Type  "Sc"
        RA           14.0594
        Dec         -10.1506
        Distance    1.61e+08  # method: V
        Radius     3.044e+04
        AbsMag        -18.47
        Axis    [ -0.1339  -0.9909  -0.0099]
        Angle     32.3562
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4358"
}

Galaxy "IC 4359:ESO 271-15:IRAS 14022-4501"
{
        Type  "Sc"
        RA           14.0897
        Dec         -45.2700
        Distance   1.223e+08  # distance uncertain!
        Radius     1.957e+04
        AbsMag        -19.07
        Axis    [  0.5546  -0.3515  -0.7542]
        Angle    131.0682
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4359"
}

Galaxy "IC 4360"
{
        Type  "SBa"
        RA           14.0725
        Dec         -11.4244
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.7374  -0.4961  -0.4584]
        Angle     90.1462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4360"
}

Galaxy "IC 4361:MCG 2-36-7"
{
        Type  "S0"
        RA           14.0686
        Dec          -9.7678
        Distance   2.934e+08  # distance uncertain!
        Radius     2.987e+04
        AbsMag        -19.07
        Axis    [ -0.9567  -0.2906   0.0145]
        Angle     62.0754
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4361"
}

Galaxy "IC 4362:ESO 325-50:MCG 7-29-7:IRAS 14022-4134"
{
        Type  "SBc"
        RA           14.0894
        Dec         -41.8192
        Distance   8.186e+07  # method: T-F
        Radius     2.024e+04
        AbsMag         -18.6
        Axis    [ -0.6918  -0.5997  -0.4022]
        Angle     72.0461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4362"
}

Galaxy "IC 4363"
{
        Type  "SBa"
        RA           14.0700
        Dec          -9.6414
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.6709  -0.5530  -0.4940]
        Angle    123.3556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4363"
}

Galaxy "IC 4364:MCG 2-36-9"
{
        Type  "Sc"
        RA           14.0719
        Dec          -9.9928
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.2141  -0.6034  -0.7682]
        Angle     77.4903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4364"
}

Galaxy "IC 4366:ESO 384-45:MCG 5-33-42:IRAS 14022-3331"
{
        Type  "SBc"
        RA           14.0864
        Dec         -33.7608
        Distance   2.199e+08  # method: V
        Radius     5.118e+04
        AbsMag        -20.84
        Axis    [ -0.6522  -0.3348  -0.6801]
        Angle     80.1660
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4366"
}

Galaxy "IC 4367:ESO 325-51:MCG 6-31-21:IRAS 14025-3857"
{
        Type  "SBc"
        RA           14.0933
        Dec         -39.2031
        Distance   1.966e+08  # method: V
        Radius     5.146e+04
        AbsMag         -20.9
        Axis    [  0.5478  -0.4167  -0.7255]
        Angle    136.3590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4367"
}

Galaxy "IC 4368:NPM 1"
{
        Type  "E0"
        RA           14.0794
        Dec          -9.9617
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [  0.2766  -0.6443  -0.7130]
        Angle    129.3589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4368"
}

Galaxy "IC 4369:MCG 6-31-58:HCG 70:KUG 1401+335"
{
        Type  "Sc"
        RA           14.0681
        Dec          33.3214
        Distance   8.752e+08  # method: V
        Radius     5.092e+04
        AbsMag        -20.94
        Axis    [  0.6699  -0.7362  -0.0962]
        Angle    107.4289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4369"
}

Galaxy "IC 4370:MCG 6-31-60:ZWG 191.46:HCG 70"
{
        Type  "S0"
        RA           14.0692
        Dec          33.3467
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.3152  -0.9247   0.2135]
        Angle     20.1985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4370"
}

Galaxy "IC 4371:MCG 6-31-61:ZWG 191.45:HCG 70B"
{
        Type  "SBa"
        RA           14.0694
        Dec          33.3081
        Distance   3.806e+08  # method: V
        Radius     4.982e+04
        AbsMag        -20.23
        Axis    [  0.6948  -0.7184  -0.0332]
        Angle     85.1314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4371"
}

Galaxy "IC 4372"
{
        Type  "S0"
        RA           14.0961
        Dec         -10.8997
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.5924  -0.7019  -0.3954]
        Angle     51.7700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4372"
}

Galaxy "IC 4373:ZWG 132.75:NPM 1"
{
        Type  "E0"
        RA           14.0953
        Dec          25.2319
        Distance   4.571e+08  # distance uncertain!
        Radius     2.659e+04
        AbsMag        -20.13
        Axis    [  0.3636  -0.8716  -0.3287]
        Angle    138.8715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4373"
}

Galaxy "IC 4374:ESO 510-69:MCG 4-33-46:AM 1404-264"
{
        Type  "S0"
        RA           14.1247
        Dec         -27.0181
        Distance   3.066e+08  # method: V
        Radius     7.136e+04
        AbsMag        -21.27
        Axis    [ -0.3248  -0.5089  -0.7972]
        Angle     68.3949
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4374"
}

Galaxy "IC 4377:ESO 41-4"
{
        Type  "Sa"
        RA           14.2828
        Dec         -75.6464
        Distance   1.115e+08  # distance uncertain!
        Radius     2.758e+04
        AbsMag        -19.07
        Axis    [ -0.1345  -0.5015  -0.8547]
        Angle     90.3886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4377"
}

Galaxy "IC 4378:ESO 384-64:MCG 6-31-27:VV 743"
{
        Type  "S0"
        RA           14.2025
        Dec         -34.2650
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.8108  -0.4143  -0.4135]
        Angle     76.2698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4378"
}

Galaxy "IC 4379:ESO 384-65:MCG 6-31-28:VV 743"
{
        Type  "Sc"
        RA           14.2028
        Dec         -34.2711
        Distance   2.676e+08  # distance uncertain!
        Radius      4.67e+04
        AbsMag        -19.07
        Axis    [  0.2566  -0.7976  -0.5459]
        Angle     47.8496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4379"
}

Galaxy "IC 4380:MCG 6-31-75:ZWG 191.59:KUG 1407+377"
{
        Type  "Sc"
        RA           14.1672
        Dec          37.5506
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [  0.3444  -0.9110  -0.2271]
        Angle    134.7274
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4380"
}

Galaxy "IC 4382:ZWG 132.79:ZWG 133.2:HCG 71B"
{
        Type  "Sb"
        RA           14.1839
        Dec          25.5192
        Distance   4.247e+08  # method: V
        Radius     3.706e+04
        AbsMag        -19.97
        Axis    [  0.9181  -0.3944   0.0403]
        Angle    122.2876
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4382"
}

Galaxy "IC 4383:NGC 5504B:MCG 3-36-79:ZWG 103.113"
{
        Type  "S0"
        RA           14.2033
        Dec          15.8689
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [  0.3033  -0.9403  -0.1544]
        Angle     32.4538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4383"
}

Galaxy "IC 4384:UGC 9082:MCG 5-33-54:ZWG 163.3"
{
        Type  "Sa"
        RA           14.1986
        Dec          27.1144
        Distance   4.807e+08  # method: V
        Radius     6.292e+04
        AbsMag        -20.84
        Axis    [ -0.8368   0.4326  -0.3357]
        Angle     42.0768
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4384"
}

Galaxy "IC 4386:ESO 271-25:MCG 7-29-11:AM 1411-434"
{
        Type  "SBc"
        RA           14.2506
        Dec         -43.9614
        Distance   9.454e+07  # method: V
        Radius     4.125e+04
        AbsMag        -19.61
        Axis    [ -0.7091  -0.5550  -0.4350]
        Angle     77.9328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4386"
}

Galaxy "IC 4387:ESO 271-24:MCG 7-29-10"
{
        Type  "Irr"
        RA           14.2503
        Dec         -43.9903
        Distance   3.312e+08  # distance uncertain!
        Radius     5.298e+04
        AbsMag        -20.13
        Axis    [  0.1503  -0.4673  -0.8712]
        Angle     94.5231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4387"
}

Galaxy "IC 4388:ESO 446-38:MCG 5-34-3:AM 1413-313"
{
        Type  "Sb"
        RA           14.2675
        Dec         -31.7533
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [  0.1404  -0.4980  -0.8557]
        Angle    104.1081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4388"
}

Galaxy "IC 4389:ESO 326-16"
{
        Type  "Sc"
        RA           14.2794
        Dec         -40.5531
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.1208  -0.4899  -0.8634]
        Angle     87.5909
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4389"
}

Galaxy "IC 4390:ESO 271-28:MCG 7-29-12:FAIR 327"
{
        Type  "SBc"
        RA           14.2831
        Dec         -44.9783
        Distance   1.045e+08  # method: V
        Radius     2.735e+04
        AbsMag        -18.73
        Axis    [  0.7485  -0.1713  -0.6407]
        Angle    108.1538
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4390"
}

Galaxy "IC 4391:ESO 446-41:MCG 5-34-5:AM 1413-312"
{
        Type  "Sb"
        RA           14.2742
        Dec         -31.6850
        Distance   1.612e+08  # distance uncertain!
        Radius      2.11e+04
        AbsMag        -19.07
        Axis    [  0.3082  -0.5129  -0.8012]
        Angle     96.7409
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4391"
}

Galaxy "IC 4393:ESO 446-44:MCG 5-34-6:FGCE 1141"
{
        Type  "Sc"
        RA           14.2969
        Dec         -31.3483
        Distance   1.633e+08  # method: T-F
        Radius     5.699e+04
        AbsMag         -18.9
        Axis    [  0.4819  -0.7005  -0.5264]
        Angle     52.0685
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4393"
}

Galaxy "IC 4395:UGC 9141:MCG 5-34-7:MK 673"
{
        Type  "Sb"
        RA           14.2889
        Dec          26.8575
        Distance   5.054e+08  # method: V
        Radius     7.351e+04
        AbsMag        -21.05
        Axis    [  0.5351  -0.8025  -0.2639]
        Angle    111.9441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4395"
}

Galaxy "IC 4396:MCG 5-34-8:ZWG 163.16"
{
        Type  "Sb"
        RA           14.2917
        Dec          28.8000
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [  0.6702  -0.7304  -0.1314]
        Angle    104.0943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4396"
}

Galaxy "IC 4397:UGC 9150:MCG 5-34-12:ZWG 163.18"
{
        Type  "Sc"
        RA           14.2994
        Dec          26.4128
        Distance   2.093e+08  # method: V
        Radius     3.348e+04
        AbsMag        -19.84
        Axis    [ -0.9206   0.3655  -0.1375]
        Angle     40.6672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4397"
}

Galaxy "IC 4398:MCG 5-34-13:ZWG 163.20"
{
        Type  "SBb"
        RA           14.3008
        Dec          28.8661
        Distance    5.84e+08  # method: V
        Radius     4.247e+04
        AbsMag        -20.96
        Axis    [  0.3579  -0.8857  -0.2957]
        Angle    138.8111
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4398"
}

Galaxy "IC 4399:UGC 9157:MCG 5-34-14:ZWG 163.22"
{
        Type  "Sb"
        RA           14.3067
        Dec          26.3861
        Distance   5.023e+08  # method: V
        Radius     8.036e+04
        AbsMag        -20.64
        Axis    [ -0.9147  -0.2810   0.2904]
        Angle     21.5862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4399"
}

Galaxy "IC 4401:MCG 1-36-15"
{
        Type  "SBa"
        RA           14.3236
        Dec          -4.4900
        Distance   2.226e+08  # distance uncertain!
        Radius     4.532e+04
        AbsMag        -19.07
        Axis    [  0.8383  -0.4516  -0.3056]
        Angle     99.8740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4401"
}

Galaxy "IC 4402:ESO 272-5:IRAS 14179-4604"
{
        Type  "Sb"
        RA           14.3533
        Dec         -46.2983
        Distance   6.981e+07  # method: T-F
        Radius     4.264e+04
        AbsMag        -19.55
        Axis    [ -0.4365  -0.8185  -0.3735]
        Angle     62.8066
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4402"
}

Galaxy "IC 4403:UGC 9158:MCG 5-34-16:ZWG 163.23"
{
        Type  "SBb"
        RA           14.3044
        Dec          31.6539
        Distance   2.025e+08  # method: V
        Radius     3.239e+04
        AbsMag        -19.06
        Axis    [ -0.3742  -0.3720   0.8495]
        Angle     26.4693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4403"
}

Galaxy "IC 4405:MCG 5-34-19:ZWG 163.28:KCPG 423A"
{
        Type  "Sb"
        RA           14.3211
        Dec          26.2983
        Distance   5.073e+08  # method: V
        Radius      6.64e+04
        AbsMag        -21.16
        Axis    [ -0.2339  -0.9709   0.0516]
        Angle     18.8220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4405"
}

Galaxy "IC 4408:UGC 9191:MCG 5-34-24:ZWG 163.31"
{
        Type  "Sb"
        RA           14.3536
        Dec          29.9939
        Distance   4.242e+08  # method: V
        Radius      6.17e+04
        AbsMag        -20.57
        Axis    [ -0.3135  -0.4120   0.8556]
        Angle     29.6074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4408"
}

Galaxy "IC 4409:MCG 5-34-26:ZWG 163.33:IRAS 14193+3148"
{
        Type  "Sc"
        RA           14.3592
        Dec          31.5856
        Distance   4.752e+08  # method: V
        Radius     5.529e+04
        AbsMag        -20.62
        Axis    [  0.7967  -0.5944   0.1088]
        Angle     94.1471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4409"
}

Galaxy "IC 4410:MCG 3-37-9:ZWG 104.9"
{
        Type  "Sb"
        RA           14.3706
        Dec          17.3978
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.7414  -0.6696  -0.0438]
        Angle     72.4914
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4410"
}

Galaxy "IC 4413:MCG 6-32-15:NPM 1"
{
        Type  "E0"
        RA           14.3825
        Dec          37.5281
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [  0.3006  -0.9233  -0.2391]
        Angle    137.8519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4413"
}

Galaxy "IC 4415:DRCG 29-36"
{
        Type  "S0"
        RA           14.4072
        Dec          16.6400
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [ -0.7136  -0.6146   0.3362]
        Angle     27.0307
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4415"
}

Galaxy "IC 4416:MCG 5-34-31:ZWG 163.39:NPM 1"
{
        Type  "E0"
        RA           14.4047
        Dec          29.6361
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.3217  -0.8981  -0.2998]
        Angle    140.5517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4416"
}

Galaxy "IC 4417:MCG 3-37-14:ZWG 104.17:NPM 1"
{
        Type  "S0"
        RA           14.4147
        Dec          17.0383
        Distance    2.33e+08  # distance uncertain!
        Radius     2.712e+04
        AbsMag        -19.07
        Axis    [ -0.8984   0.1084  -0.4255]
        Angle     41.5848
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4417"
}

Galaxy "IC 4418:ZWG 133.52:NPM 1"
{
        Type  "E0"
        RA           14.4242
        Dec          25.5269
        Distance   3.631e+08  # distance uncertain!
        Radius     3.169e+04
        AbsMag        -20.13
        Axis    [ -0.0420  -0.5834  -0.8111]
        Angle     66.0431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4418"
}

Galaxy "IC 4419:DRCG 29-35"
{
        Type  "E0"
        RA           14.4317
        Dec          16.6319
        Distance   7.586e+08  # distance uncertain!
        Radius     4.414e+04
        AbsMag        -20.13
        Axis    [  0.3529  -0.8482  -0.3949]
        Angle    145.2121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4419"
}

Galaxy "IC 4420:MCG 4-34-27:ZWG 133.53:KUG 1423+256"
{
        Type  "SBc"
        RA           14.4275
        Dec          25.3789
        Distance   2.064e+08  # method: T-F
        Radius     2.102e+04
        AbsMag        -18.61
        Axis    [  0.6820  -0.7114  -0.1700]
        Angle    119.9271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4420"
}

Galaxy "IC 4421:ESO 385-27:MCG 6-32-6"
{
        Type  "E0"
        RA           14.4753
        Dec         -37.5836
        Distance   1.634e+08  # method: T-F
        Radius     2.615e+04
        AbsMag         -20.1
        Axis    [ -0.7722   0.0407  -0.6341]
        Angle    111.8135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4421"
}

Galaxy "IC 4422:MCG 5-34-39:ZWG 163.48"
{
        Type  "E0"
        RA           14.4331
        Dec          30.4739
        Distance   4.166e+08  # method: V
        Radius     4.848e+04
        AbsMag        -20.33
        Axis    [ -0.0117  -0.6154  -0.7881]
        Angle     62.1241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4422"
}

Galaxy "IC 4423:UGC 9247:MCG 4-34-28:ZWG 133.55"
{
        Type  "Sc"
        RA           14.4381
        Dec          26.2456
        Distance   4.199e+08  # method: V
        Radius     6.718e+04
        AbsMag        -20.25
        Axis    [  0.6252  -0.7794   0.0413]
        Angle     58.0715
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4423"
}

Galaxy "IC 4425:ZWG 163.49:KUG 1424+274"
{
        Type  "Sb"
        RA           14.4456
        Dec          27.1897
        Distance   4.193e+08  # method: V
        Radius     3.659e+04
        AbsMag        -20.35
        Axis    [  0.3488  -0.8843  -0.3103]
        Angle    140.8261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4425"
}

Galaxy "IC 4426:MCG 3-37-16:ZWG 104.28:NPM 1"
{
        Type  "E0"
        RA           14.4547
        Dec          16.8317
        Distance   6.829e+08  # method: V
        Radius     4.966e+04
        AbsMag         -21.3
        Axis    [  0.3501  -0.8499  -0.3939]
        Angle    145.3571
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4426"
}

Galaxy "IC 4427:MCG 5-34-41:ZWG 163.50:IRAS 14247+2705"
{
        Type  "Sb"
        RA           14.4497
        Dec          26.8639
        Distance    4.15e+08  # method: V
        Radius     4.828e+04
        AbsMag        -20.12
        Axis    [ -0.0151  -0.6536   0.7567]
        Angle     31.2147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4427"
}

Galaxy "IC 4428:DRCG 29-12"
{
        Type  "S0"
        RA           14.4569
        Dec          16.1908
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [  0.6721  -0.7108  -0.2074]
        Angle     84.1539
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4428"
}

Galaxy "IC 4429:MCG 3-37-17:ZWG 104.29:NPM 1"
{
        Type  "E0"
        RA           14.4603
        Dec          16.9003
        Distance   6.895e+08  # method: V
        Radius      7.02e+04
        AbsMag        -21.53
        Axis    [  0.3494  -0.8504  -0.3935]
        Angle    145.3850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4429"
}

Galaxy "IC 4430:MCG 5-34-14:ESO 385-30"
{
        Type  "S0"
        RA           14.4886
        Dec         -33.4550
        Distance   8.461e+07  # distance uncertain!
        Radius     2.831e+04
        AbsMag        -19.07
        Axis    [  0.6739  -0.3723  -0.6382]
        Angle    114.1725
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4430"
}

Galaxy "IC 4432:ESO 326-25"
{
        Type  "S0"
        RA           14.4803
        Dec         -39.5519
        Distance    4.05e+08  # distance uncertain!
        Radius     6.479e+04
        AbsMag        -19.07
        Axis    [  0.6514  -0.4333  -0.6228]
        Angle     70.7482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4432"
}

Galaxy "IC 4433:KUG 1425+164:DRCG 29-10"
{
        Type  "Sc"
        RA           14.4647
        Dec          16.1953
        Distance   3.527e+08  # distance uncertain!
        Radius     1.539e+04
        AbsMag        -19.07
        Axis    [  0.7308  -0.6412  -0.2339]
        Angle    128.6686
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4433"
}

Galaxy "IC 4434:ZWG 104.30:ZWG 104.30:NPM 1"
{
        Type  "S0"
        RA           14.4650
        Dec          16.2078
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.7133  -0.6568  -0.2446]
        Angle    129.3262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4434"
}

Galaxy "IC 4435:MCG 6-32-37:ZWG 192.22:NPM 1"
{
        Type  "S0"
        RA           14.4567
        Dec          37.4719
        Distance    2.33e+08  # distance uncertain!
        Radius     2.373e+04
        AbsMag        -19.07
        Axis    [  0.5178  -0.8426  -0.1479]
        Angle     87.8132
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4435"
}

Galaxy "IC 4436:MCG 5-34-45:ZWG 163.54"
{
        Type  "E0"
        RA           14.4661
        Dec          26.5042
        Distance     4.5e+08  # method: V
        Radius     6.545e+04
        AbsMag         -20.8
        Axis    [  0.3245  -0.8887  -0.3240]
        Angle    142.2043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4436"
}

Galaxy "IC 4438:MCG 3-37-20:ZWG 104.34:DRCG 29-86"
{
        Type  "Sc"
        RA           14.4761
        Dec          17.3342
        Distance   4.441e+08  # distance uncertain!
        Radius     3.229e+04
        AbsMag        -19.07
        Axis    [  0.3048  -0.8430  -0.4433]
        Angle     53.8558
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4438"
}

Galaxy "IC 4439:ZWG 104.35:DRCG 29-67"
{
        Type  "Sc"
        RA           14.4778
        Dec          17.0247
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.5379  -0.8237  -0.1793]
        Angle     56.5411
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4439"
}

Galaxy "IC 4440:MCG 3-37-22:ZWG 104.37:DRCG 29-79"
{
        Type  "S0"
        RA           14.4831
        Dec          17.3208
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.5927  -0.7481  -0.2985]
        Angle    134.1183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4440"
}

Galaxy "IC 4441:IC 4444:ESO 272-14:MCG 7-30-2"
{
        Type  "SBc"
        RA           14.5272
        Dec         -43.4183
        Distance   9.758e+07  # method: V
        Radius     2.129e+04
        AbsMag        -20.18
        Axis    [ -0.1568  -0.4613  -0.8733]
        Angle     99.3818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4441"
}

Galaxy "IC 4442:UGC 9287:MCG 5-34-50:ZWG 163.60"
{
        Type  "SBa"
        RA           14.4792
        Dec          28.9647
        Distance   2.432e+08  # method: T-F
        Radius     3.538e+04
        AbsMag        -18.96
        Axis    [  0.7289  -0.6787  -0.0899]
        Angle    116.6184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4442"
}

Galaxy "IC 4443:DRCG 29-8"
{
        Type  "Sc"
        RA           14.4881
        Dec          16.1814
        Distance   3.217e+08  # distance uncertain!
        Radius     4.211e+04
        AbsMag        -19.07
        Axis    [  0.7118  -0.6604  -0.2391]
        Angle    119.1589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4443"
}

Galaxy "IC 4445:ESO 272-15:IRAS 14285-4548"
{
        Type  "Sc"
        RA           14.5317
        Dec         -46.0353
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.7193  -0.6544  -0.2331]
        Angle     80.3816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4445"
}

Galaxy "IC 4446:MCG 6-32-44"
{
        Type  "Sc"
        RA           14.4836
        Dec          37.4636
        Distance   3.369e+08  # distance uncertain!
        Radius     4.409e+04
        AbsMag        -19.07
        Axis    [  0.2326  -0.5762   0.7835]
        Angle     34.2679
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4446"
}

Galaxy "IC 4447:UGC 9306:MCG 5-34-56:ZWG 163.66"
{
        Type  "SBa"
        RA           14.4881
        Dec          30.8325
        Distance   2.024e+08  # method: V
        Radius     3.532e+04
        AbsMag        -19.36
        Axis    [ -0.8916   0.3641   0.2691]
        Angle     48.4338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4447"
}

Galaxy "IC 4448:ESO 22-2:AM 1434-783:IRAS 14343-7835"
{
        Type  "SBc"
        RA           14.6742
        Dec         -78.8092
        Distance   2.128e+08  # method: V
        Radius     3.095e+04
        AbsMag        -20.17
        Axis    [ -0.8176  -0.3897  -0.4239]
        Angle    129.8356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4448"
}

Galaxy "IC 4449"
{
        Type  "S0"
        RA           14.5225
        Dec          15.2406
        Distance   4.241e+08  # distance uncertain!
        Radius     3.084e+04
        AbsMag        -19.07
        Axis    [  0.2244  -0.9599  -0.1681]
        Angle     36.8442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4449"
}

Galaxy "IC 4450:UGC 9349:MCG 5-34-65:ZWG 163.73"
{
        Type  "Sc"
        RA           14.5367
        Dec          28.5572
        Distance   4.209e+08  # method: V
        Radius     7.347e+04
        AbsMag        -20.35
        Axis    [  0.7487  -0.6573   0.0861]
        Angle     83.3567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4450"
}

Galaxy "IC 4451:ESO 385-46:MCG 6-32-10"
{
        Type  "E0"
        RA           14.5769
        Dec         -36.2861
        Distance   1.585e+08  # method: T-F
        Radius     4.149e+04
        AbsMag        -20.73
        Axis    [ -0.2222  -0.3653  -0.9040]
        Angle    123.3328
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4451"
}

Galaxy "IC 4452:ZWG 163.76:KARA 633"
{
        Type  "Sa"
        RA           14.5408
        Dec          27.4272
        Distance   2.034e+08  # method: V
        Radius      1.48e+04
        AbsMag        -18.97
        Axis    [  0.3392  -0.8882  -0.3098]
        Angle    141.7414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4452"
}

Galaxy "IC 4453:ESO 512-4:MCG 4-34-20"
{
        Type  "S0"
        RA           14.5744
        Dec         -27.5181
        Distance   1.721e+08  # method: V
        Radius     5.507e+04
        AbsMag        -20.41
        Axis    [ -0.8537  -0.5054  -0.1259]
        Angle     71.5036
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4453"
}

Galaxy "IC 4454:NPM 1"
{
        Type  "S0"
        RA           14.5544
        Dec          17.7122
        Distance   6.419e+08  # distance uncertain!
        Radius     4.668e+04
        AbsMag        -19.07
        Axis    [  0.7541  -0.6239  -0.2052]
        Angle    128.3324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4454"
}

Galaxy "IC 4456"
{
        Type  "S0"
        RA           14.5692
        Dec          16.1842
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.5697  -0.6257   0.5328]
        Angle     32.1416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4456"
}

Galaxy "IC 4457"
{
        Type  "E0"
        RA           14.5744
        Dec          18.2244
        Distance   6.026e+08  # distance uncertain!
        Radius     2.629e+04
        AbsMag        -20.13
        Axis    [  0.0432  -0.6966  -0.7161]
        Angle     85.8270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4457"
}

Galaxy "IC 4459:MCG 5-34-74:ZWG 163.83"
{
        Type  "Sb"
        RA           14.5756
        Dec          30.9739
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.8054  -0.5927  -0.0069]
        Angle    120.1199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4459"
}

Galaxy "IC 4460:MCG 5-34-75:ZWG 163.84"
{
        Type  "Sa"
        RA           14.5767
        Dec          30.2792
        Distance   3.072e+08  # distance uncertain!
        Radius     2.234e+04
        AbsMag        -19.07
        Axis    [ -0.8847   0.2535   0.3911]
        Angle     46.4332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4460"
}

Galaxy "IC 4461:UGC 9384:MCG 5-34-77:ZWG 163.85"
{
        Type  "Sb"
        RA           14.5836
        Dec          26.5442
        Distance    2.33e+08  # distance uncertain!
        Radius     4.406e+04
        AbsMag        -19.07
        Axis    [  0.7001  -0.7133  -0.0344]
        Angle     85.8872
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4461"
}

Galaxy "IC 4462:UGC 9384:MCG 5-34-78:ZWG 163.85"
{
        Type  "S0"
        RA           14.5844
        Dec          26.5414
        Distance   4.869e+08  # distance uncertain!
        Radius     2.125e+04
        AbsMag        -19.07
        Axis    [  0.3374  -0.8864  -0.3171]
        Angle    142.4505
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4462"
}

Galaxy "IC 4463:ZWG 104.46"
{
        Type  "E0"
        RA           14.5969
        Dec          16.0194
        Distance   3.631e+08  # distance uncertain!
        Radius     2.112e+04
        AbsMag        -20.13
        Axis    [  0.3377  -0.8512  -0.4018]
        Angle    146.9636
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4463"
}

Galaxy "IC 4464:ESO 385-50:MCG 6-32-11"
{
        Type  "S0"
        RA           14.6300
        Dec         -36.8786
        Distance   2.082e+08  # method: V
        Radius     4.846e+04
        AbsMag        -21.23
        Axis    [  0.4199  -0.5690  -0.7071]
        Angle     74.3334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4464"
}

Galaxy "IC 4465"
{
        Type  "S0"
        RA           14.5975
        Dec          15.5731
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.6453  -0.7171   0.2633]
        Angle     54.5487
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4465"
}

Galaxy "IC 4466:ZWG 104.48"
{
        Type  "Sa"
        RA           14.6131
        Dec          18.3431
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [  0.5327  -0.7813  -0.3253]
        Angle    126.6637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4466"
}

Galaxy "IC 4467:NPM 1"
{
        Type  "E0"
        RA           14.6147
        Dec          18.3711
        Distance   7.245e+08  # distance uncertain!
        Radius     4.215e+04
        AbsMag        -20.13
        Axis    [  0.3304  -0.8616  -0.3853]
        Angle    146.3457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4467"
}

Galaxy "IC 4468:ESO 580-6:MCG 4-35-1:AM 1435-220"
{
        Type  "SBc"
        RA           14.6406
        Dec         -22.3672
        Distance    1.22e+08  # method: T-F
        Radius     3.905e+04
        AbsMag        -19.06
        Axis    [ -0.7940  -0.6072   0.0289]
        Angle     64.5387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4468"
}

Galaxy "IC 4469:UGC 9414:MCG 3-37-26:ZWG 104.51"
{
        Type  "Sc"
        RA           14.6222
        Dec          18.2489
        Distance   2.736e+08  # method: V
        Radius     6.367e+04
        AbsMag        -19.02
        Axis    [  0.2177  -0.6790   0.7011]
        Angle     43.8325
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4469"
}

Galaxy "IC 4470:MCG 13-10-19:ZWG 354.3:ZWG 353.40"
{
        Type  "S0"
        RA           14.4728
        Dec          78.8861
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.5002  -0.1943   0.8438]
        Angle     97.3874
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4470"
}

Galaxy "IC 4472:ESO 272-23:MCG 7-30-5:AM 1436-440"
{
        Type  "Sc"
        RA           14.6694
        Dec         -44.3156
        Distance    1.09e+08  # method: T-F
        Radius     3.488e+04
        AbsMag        -18.72
        Axis    [  0.7974  -0.1092  -0.5935]
        Angle    110.2824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4472"
}

Galaxy "IC 4473-1:MCG 3-37-27:ZWG 104.52:VV 732"
{
        Type  "S0"
        RA           14.6317
        Dec          15.8636
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.7551  -0.6194  -0.2150]
        Angle    123.3642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4473-1"
}

Galaxy "IC 4473-2:MCG 3-37-27:ZWG 104.52:VV 732"
{
        Type  "S0"
        RA           14.6317
        Dec          15.8608
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.4818  -0.8651   0.1394]
        Angle     45.3780
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4473-2"
}

Galaxy "IC 4474"
{
        Type  "SBa"
        RA           14.6394
        Dec          23.4289
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.6080  -0.7773  -0.1617]
        Angle     82.2442
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4474"
}

Galaxy "IC 4475:MCG 4-35-1:ZWG 134.6:NPM 1"
{
        Type  "S0"
        RA           14.6397
        Dec          23.3342
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.9001   0.3918  -0.1904]
        Angle     49.0816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4475"
}

Galaxy "IC 4476:NPM 1"
{
        Type  "E0"
        RA           14.6642
        Dec         -16.2447
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [ -0.7816   0.1662  -0.6012]
        Angle     92.2985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4476"
}

Galaxy "IC 4477:ZWG 164.3"
{
        Type  "SBb"
        RA           14.6431
        Dec          28.4589
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.7200  -0.6857  -0.1066]
        Angle    120.9072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4477"
}

Galaxy "IC 4478:ZWG 104.59:NPM 1"
{
        Type  "E0"
        RA           14.6533
        Dec          15.8781
        Distance   3.468e+08  # distance uncertain!
        Radius     3.026e+04
        AbsMag        -20.13
        Axis    [  0.2583  -0.8284  -0.4970]
        Angle    127.3354
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4478"
}

Galaxy "IC 4479:UGC 9433:MCG 5-35-1:ZWG 164.5"
{
        Type  "Sc"
        RA           14.6458
        Dec          28.5058
        Distance   6.244e+08  # method: V
        Radius     1.181e+05
        AbsMag        -21.91
        Axis    [  0.3266  -0.8953  -0.3028]
        Angle    142.5299
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4479"
}

Galaxy "IC 4480:MCG 3-37-34:ZWG 104.63"
{
        Type  "E0"
        RA           14.6625
        Dec          18.4922
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [  0.3254  -0.8636  -0.3851]
        Angle    146.7634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4480"
}

Galaxy "IC 4481"
{
        Type  "S0"
        RA           14.6694
        Dec          16.1417
        Distance   4.241e+08  # distance uncertain!
        Radius      1.85e+04
        AbsMag        -19.07
        Axis    [  0.3703  -0.8925  -0.2575]
        Angle     51.1391
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4481"
}

Galaxy "IC 4482:ZWG 104.64"
{
        Type  "E0"
        RA           14.6700
        Dec          18.9436
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [  0.2994  -0.8589  -0.4155]
        Angle    138.9271
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4482"
}

Galaxy "IC 4483:UGC 9455:MCG 3-37-35:ZWG 104.66"
{
        Type  "Sb"
        RA           14.6719
        Dec          16.6850
        Distance   4.161e+08  # method: V
        Radius     9.079e+04
        AbsMag        -20.63
        Axis    [  0.8196  -0.5675  -0.0786]
        Angle    101.2178
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4483"
}

Galaxy "IC 4484:ESO 41-9:FGCE 1187:IRAS 14427-7305"
{
        Type  "Sc"
        RA           14.7956
        Dec         -73.3069
        Distance   1.633e+08  # method: T-F
        Radius     6.176e+04
        AbsMag         -18.8
        Axis    [ -0.4675  -0.7653  -0.4424]
        Angle     90.3590
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4484"
}

Galaxy "IC 4485:ZWG 164.10:NPM 1"
{
        Type  "Sb"
        RA           14.6753
        Dec          28.6694
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [  0.6954  -0.7052  -0.1383]
        Angle    131.6488
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4485"
}

Galaxy "IC 4486:ZWG 104.68:ZWG 105.1"
{
        Type  "S0"
        RA           14.6944
        Dec          18.5575
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.7909  -0.4189   0.4461]
        Angle     33.7982
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4486"
}

Galaxy "IC 4487:MCG 3-37-37:ZWG 105.3:ZWG 104.70"
{
        Type  "Sc"
        RA           14.6978
        Dec          18.5769
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.3453  -0.8589  -0.3783]
        Angle    145.9296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4487"
}

Galaxy "IC 4488"
{
        Type  "E0"
        RA           14.7144
        Dec          18.6206
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [  0.3065  -0.8622  -0.4033]
        Angle    142.9006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4488"
}

Galaxy "IC 4489"
{
        Type  "E0"
        RA           14.7211
        Dec          18.5286
        Distance   6.919e+08  # distance uncertain!
        Radius     3.019e+04
        AbsMag        -20.13
        Axis    [ -0.0726  -0.6285  -0.7744]
        Angle     76.3219
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4489"
}

Galaxy "IC 4492:MCG 6-32-88:ZWG 192.54:ARAK 455"
{
        Type  "E0"
        RA           14.7092
        Dec          37.4528
        Distance   3.468e+08  # distance uncertain!
        Radius     1.513e+04
        AbsMag        -20.13
        Axis    [  0.2722  -0.9314  -0.2418]
        Angle    141.5741
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4492"
}

Galaxy "IC 4494:MCG 3-38-4:ZWG 105.14"
{
        Type  "S0"
        RA           14.7408
        Dec          15.4811
        Distance   2.125e+08  # distance uncertain!
        Radius     1.855e+04
        AbsMag        -19.07
        Axis    [ -0.9882  -0.0982   0.1175]
        Angle     41.8892
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4494"
}

Galaxy "IC 4495:ZWG 134.27"
{
        Type  "S0"
        RA           14.7372
        Dec          23.5586
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.7024  -0.6963  -0.1476]
        Angle    111.2244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4495"
}

Galaxy "IC 4496:MCG 6-32-90:ZWG 192.56:NPM 1"
{
        Type  "S0"
        RA           14.7317
        Dec          33.4072
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.5495  -0.8230  -0.1443]
        Angle     98.8295
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4496"
}

Galaxy "IC 4497:MCG 5-35-9:ZWG 164.15:NPM 1"
{
        Type  "E0"
        RA           14.7389
        Dec          28.5511
        Distance   1.759e+08  # method: V
        Radius      1.28e+04
        AbsMag        -18.56
        Axis    [  0.2934  -0.9039  -0.3113]
        Angle    144.4200
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4497"
}

Galaxy "IC 4498:MCG 5-35-10:ZWG 164.16"
{
        Type  "S0"
        RA           14.7500
        Dec          26.3000
        Distance     4.3e+08  # method: V
        Radius     3.127e+04
        AbsMag         -20.2
        Axis    [  0.3223  -0.8905  -0.3211]
        Angle    144.2279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4498"
}

Galaxy "IC 4500:MCG 6-32-91:ZWG 192.57:ARAK 457"
{
        Type  "E0"
        RA           14.7431
        Dec          37.4828
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.0652  -0.7874  -0.6130]
        Angle     67.3975
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4500"
}

Galaxy "IC 4501:ESO 580-25:MCG 4-35-9:IRAS 14445-2211"
{
        Type  "S0"
        RA           14.7903
        Dec         -22.4058
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [  0.2814  -0.6486  -0.7072]
        Angle     84.5241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4501"
}

Galaxy "IC 4502"
{
        Type  "S0"
        RA           14.7542
        Dec          37.2997
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.3757  -0.6660   0.6444]
        Angle     43.0540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4502"
}

Galaxy "IC 4503:MCG 3-38-10:ZWG 105.23"
{
        Type  "S0"
        RA           14.7775
        Dec          16.1464
        Distance   1.938e+08  # distance uncertain!
        Radius     2.255e+04
        AbsMag        -19.07
        Axis    [  0.7819  -0.5897  -0.2023]
        Angle    128.1620
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4503"
}

Galaxy "IC 4504:ZWG 164.23:NPM 1"
{
        Type  "S0"
        RA           14.7767
        Dec          31.6997
        Distance   4.602e+08  # method: V
        Radius     2.008e+04
        AbsMag        -20.35
        Axis    [  0.3892  -0.9164   0.0934]
        Angle     42.4315
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4504"
}

Galaxy "IC 4505:UGC 9520:MCG 6-32-99:ZWG 192.61"
{
        Type  "S0"
        RA           14.7758
        Dec          33.4092
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.8753   0.4795   0.0624]
        Angle     42.7197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4505"
}

Galaxy "IC 4506:ZWG 192.62:NPM 1"
{
        Type  "S0"
        RA           14.7775
        Dec          33.4017
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [  0.3020  -0.9154  -0.2660]
        Angle    142.6428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4506"
}

Galaxy "IC 4507:MCG 3-38-16:ZWG 105.27"
{
        Type  "S0"
        RA           14.7950
        Dec          18.4558
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [ -0.8845  -0.1669   0.4356]
        Angle     44.2237
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4507"
}

Galaxy "IC 4508-1:ZWG 164.25:NPM 1"
{
        Type  "Sa"
        RA           14.7972
        Dec          31.7653
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [  0.3044  -0.9107  -0.2792]
        Angle    143.2759
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4508-1"
}

Galaxy "IC 4508-2:ZWG 164.25"
{
        Type  "E0"
        RA           14.7975
        Dec          31.7681
        Distance   6.919e+08  # distance uncertain!
        Radius     2.013e+04
        AbsMag        -20.13
        Axis    [  0.2798  -0.9162  -0.2870]
        Angle    144.1275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4508-2"
}

Galaxy "IC 4509:UGC 9536:MCG 5-35-16:ZWG 164.29"
{
        Type  "Sb"
        RA           14.8075
        Dec          31.7914
        Distance   1.381e+08  # method: V
        Radius     1.808e+04
        AbsMag        -18.33
        Axis    [  0.7953  -0.5559   0.2419]
        Angle     91.7609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4509"
}

Galaxy "IC 4512"
{
        Type  "E0"
        RA           14.8317
        Dec          27.7003
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.2869  -0.9034  -0.3187]
        Angle    145.6464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4512"
}

Galaxy "IC 4514:UGC 9557:MCG 5-35-19:ZWG 164.34"
{
        Type  "SBb"
        RA           14.8486
        Dec          27.5786
        Distance   4.179e+08  # method: V
        Radius     5.471e+04
        AbsMag        -20.34
        Axis    [ -0.4171  -0.8989  -0.1338]
        Angle     23.3428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4514"
}

Galaxy "IC 4515:MCG 6-33-3:ZWG 193.5:NPM 1"
{
        Type  "S0"
        RA           14.8517
        Dec          37.4953
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [  0.5513  -0.8343   0.0018]
        Angle     76.3615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4515"
}

Galaxy "IC 4516:UGC 9587:MCG 3-38-49:ZWG 105.64"
{
        Type  "E0"
        RA           14.9064
        Dec          16.3558
        Distance   6.281e+08  # method: V
        Radius     9.135e+04
        AbsMag        -22.02
        Axis    [ -0.6706   0.2521  -0.6977]
        Angle     60.7197
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4516"
}

Galaxy "IC 4517:ZWG 134.50"
{
        Type  "Sb"
        RA           14.9097
        Dec          23.6431
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.7518  -0.1618   0.6393]
        Angle     47.5050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4517"
}

Galaxy "IC 4518-1:ESO 273-12:MCG 7-31-1:VV 780"
{
        Type  "Sc"
        RA           14.9614
        Dec         -43.1314
        Distance   2.125e+08  # distance uncertain!
        Radius     2.782e+04
        AbsMag        -19.07
        Axis    [ -0.5406  -0.7697  -0.3396]
        Angle     70.7917
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4518-1"
}

Galaxy "IC 4518-2:ESO 273-12A:MCG 7-31-2:VV 780"
{
        Type  "Sc"
        RA           14.9614
        Dec         -43.1236
        Distance   5.339e+08  # distance uncertain!
        Radius     1.009e+05
        AbsMag        -19.07
        Axis    [ -0.2943  -0.8990  -0.3244]
        Angle     61.5812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4518-2"
}

Galaxy "IC 4518-3:ESO 273-12:MCG 7-31-3:VV 780"
{
        Type  "Sc"
        RA           14.9625
        Dec         -43.1311
        Distance    1.54e+08  # distance uncertain!
        Radius     4.927e+04
        AbsMag        -19.07
        Axis    [ -0.2452  -0.8410  -0.4822]
        Angle     63.3289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4518-3"
}

Galaxy "IC 4519:MCG 6-33-7:ZWG 193.9:NPM 1"
{
        Type  "SBa"
        RA           14.9122
        Dec          37.4131
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.3255  -0.4494   0.8319]
        Angle     27.6658
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4519"
}

Galaxy "IC 4520:MCG 6-33-8:ZWG 193.10:IRAS 14530+3355"
{
        Type  "Sb"
        RA           14.9186
        Dec          33.7244
        Distance   3.527e+08  # distance uncertain!
        Radius     2.052e+04
        AbsMag        -19.07
        Axis    [  0.2886  -0.9201  -0.2649]
        Angle    144.1220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4520"
}

Galaxy "IC 4521:MCG 4-35-22:ZWG 134.62"
{
        Type  "Sc"
        RA           14.9908
        Dec          25.5833
        Distance   2.555e+08  # distance uncertain!
        Radius     1.858e+04
        AbsMag        -19.07
        Axis    [  0.2792  -0.9518   0.1269]
        Angle     41.6523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4521"
}

Galaxy "IC 4522:ESO 42-2:AM 1505-754:IRAS 15056-7540"
{
        Type  "Sb"
        RA           15.1914
        Dec         -75.8589
        Distance   1.328e+08  # method: V
        Radius     3.862e+04
        AbsMag        -19.55
        Axis    [ -0.3980  -0.7094  -0.5817]
        Angle     91.5862
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4522"
}

Galaxy "IC 4523:ESO 273-15:MCG 7-31-5:IRAS 15018-4318"
{
        Type  "SBc"
        RA           15.0861
        Dec         -43.5097
        Distance   2.231e+08  # method: V
        Radius     6.489e+04
        AbsMag        -20.27
        Axis    [  0.6018  -0.3568  -0.7145]
        Angle    134.3822
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4523"
}

Galaxy "IC 4524:ZWG 134.68:IRAS 14599+2547"
{
        Type  "Sc"
        RA           15.0350
        Dec          25.6006
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.2971  -0.8960  -0.3299]
        Angle    147.3619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4524"
}

Galaxy "IC 4525:MCG 4-35-25:ZWG 134.69"
{
        Type  "SBc"
        RA           15.0400
        Dec          25.6378
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [  0.2965  -0.8963  -0.3297]
        Angle    147.4045
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4525"
}

Galaxy "IC 4526:UGC 9673:MCG 4-35-26:ZWG 134.70"
{
        Type  "S0"
        RA           15.0439
        Dec          23.3511
        Distance   4.441e+08  # distance uncertain!
        Radius     2.583e+04
        AbsMag        -19.07
        Axis    [  0.6067  -0.7616  -0.2280]
        Angle    125.9413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4526"
}

Galaxy "IC 4527:ESO 328-15:MCG 7-31-6:IRAS 15023-4215"
{
        Type  "SBc"
        RA           15.0947
        Dec         -42.4489
        Distance   2.106e+08  # method: T-F
        Radius     3.983e+04
        AbsMag        -20.35
        Axis    [  0.3717  -0.5132  -0.7736]
        Angle     95.1215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4527"
}

Galaxy "IC 4528:MCG 8-27-55:ZWG 248.46"
{
        Type  "S0"
        RA           15.0258
        Dec          49.1131
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.5938   0.3786   0.7099]
        Angle     31.0251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4528"
}

Galaxy "IC 4529:ESO 273-19:MCG 7-31-7:IRAS 15031-4302"
{
        Type  "Sc"
        RA           15.1069
        Dec         -43.2333
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [  0.5290  -0.4211  -0.7367]
        Angle    145.3105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4529"
}

Galaxy "IC 4530:UGC 9679:MCG 4-36-1:ZWG 135.2"
{
        Type  "S0"
        RA           15.0625
        Dec          26.1000
        Distance   4.312e+08  # method: V
        Radius     6.271e+04
        AbsMag        -20.31
        Axis    [  0.8562  -0.5147   0.0441]
        Angle    114.0164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4530"
}

Galaxy "IC 4531:ZWG 135.3:NPM 1"
{
        Type  "E0"
        RA           15.0739
        Dec          23.4156
        Distance   5.249e+08  # distance uncertain!
        Radius     6.107e+04
        AbsMag        -20.13
        Axis    [  0.2482  -0.8887  -0.3855]
        Angle    140.4431
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4531"
}

Galaxy "IC 4532:ZWG 135.6"
{
        Type  "S0"
        RA           15.0814
        Dec          23.2564
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.4193  -0.8946   0.1547]
        Angle     51.2567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4532"
}

Galaxy "IC 4533:UGC 9687:MCG 5-36-4:ZWG 165.10"
{
        Type  "Sa"
        RA           15.0750
        Dec          27.7933
        Distance   4.631e+08  # method: V
        Radius     6.735e+04
        AbsMag        -20.96
        Axis    [ -0.9355  -0.0070   0.3531]
        Angle     35.4272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4533"
}

Galaxy "IC 4534:UGC 9713:MCG 4-36-13:ZWG 135.14"
{
        Type  "S0"
        RA           15.1114
        Dec          23.6417
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [ -0.8819  -0.1323   0.4525]
        Angle     40.5258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4534"
}

Galaxy "IC 4535:IRAS 15069+3745"
{
        Type  "S0"
        RA           15.1447
        Dec          37.5703
        Distance   4.241e+08  # distance uncertain!
        Radius     2.467e+04
        AbsMag        -19.07
        Axis    [ -0.6683   0.0845   0.7391]
        Angle     45.8560
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4535"
}

Galaxy "IC 4536:ESO 581-24:MCG 3-39-2:UGCA 401"
{
        Type  "Irr"
        RA           15.2214
        Dec         -18.1375
        Distance   1.115e+08  # method: V
        Radius     3.569e+04
        AbsMag        -18.97
        Axis    [  0.5247  -0.6007  -0.6031]
        Angle    131.3114
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4536"
}

Galaxy "IC 4537:ZWG 21.70:NPM 1"
{
        Type  "E0"
        RA           15.2922
        Dec           2.0478
        Distance   3.802e+08  # distance uncertain!
        Radius     1.659e+04
        AbsMag        -20.13
        Axis    [  0.1604  -0.7785  -0.6068]
        Angle    133.5666
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4537"
}

Galaxy "IC 4538:ESO 514-10:MCG 4-36-13:UGCA 406"
{
        Type  "SBc"
        RA           15.3531
        Dec         -23.6583
        Distance   1.041e+08  # method: T-F
        Radius     3.935e+04
        AbsMag        -19.82
        Axis    [  0.4031  -0.6183  -0.6747]
        Angle    113.0642
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4538"
}

Galaxy "IC 4539:MCG 6-34-3"
{
        Type  "SBa"
        RA           15.3086
        Dec          32.3928
        Distance   3.868e+08  # distance uncertain!
        Radius      2.25e+04
        AbsMag        -19.07
        Axis    [  0.2571  -0.9252  -0.2791]
        Angle    148.7402
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4539"
}

Galaxy "IC 4541:ESO 68-6:IRAS 15249-7025"
{
        Type  "Sb"
        RA           15.4986
        Dec         -70.5839
        Distance    1.47e+08  # distance uncertain!
        Radius     4.919e+04
        AbsMag        -19.07
        Axis    [ -0.6426  -0.7333  -0.2221]
        Angle    106.0628
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4541"
}

Galaxy "IC 4542:IC 4542A:MCG 6-34-6:ZWG 194.2"
{
        Type  "SBa"
        RA           15.3681
        Dec          33.1486
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.0817  -0.8547   0.5126]
        Angle     32.9348
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4542"
}

Galaxy "IC 4542B:MCG 6-34-7"
{
        Type  "S0"
        RA           15.3683
        Dec          33.1469
        Distance   3.217e+08  # distance uncertain!
        Radius     1.404e+04
        AbsMag        -19.07
        Axis    [ -0.6220  -0.0340   0.7823]
        Angle     59.2055
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4542B"
}

Galaxy "IC 4545:ESO 22-11:IRAS 15328-8127"
{
        Type  "SBc"
        RA           15.6911
        Dec         -81.6264
        Distance   1.341e+08  # distance uncertain!
        Radius     3.706e+04
        AbsMag        -19.07
        Axis    [ -0.7406  -0.6098  -0.2823]
        Angle    124.6379
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4545"
}

Galaxy "IC 4546:MCG 5-36-31:ZWG 165.57"
{
        Type  "SBc"
        RA           15.4494
        Dec          28.8519
        Distance   4.772e+08  # method: V
        Radius     4.858e+04
        AbsMag        -20.63
        Axis    [ -0.1491  -0.9701   0.1915]
        Angle     33.4956
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4546"
}

Galaxy "IC 4547:ZWG 165.58:NPM 1"
{
        Type  "S0"
        RA           15.4542
        Dec          28.7894
        Distance    4.69e+08  # method: V
        Radius     4.775e+04
        AbsMag        -20.49
        Axis    [ -0.9571  -0.2895  -0.0096]
        Angle     27.5919
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4547"
}

Galaxy "IC 4548:NPM 1"
{
        Type  "E0"
        RA           15.4564
        Dec          28.8503
        Distance   7.245e+08  # distance uncertain!
        Radius     3.161e+04
        AbsMag        -20.13
        Axis    [  0.2267  -0.9217  -0.3148]
        Angle    152.0189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4548"
}

Galaxy "IC 4549:MCG 6-34-11:ZWG 194.7:IRAS 15272+3259"
{
        Type  "Sc"
        RA           15.4872
        Dec          32.8258
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.3799  -0.7854   0.4888]
        Angle     55.6891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4549"
}

Galaxy "IC 4554:NPM 1"
{
        Type  "S0"
        RA           15.5844
        Dec          23.4797
        Distance    4.65e+08  # distance uncertain!
        Radius     2.029e+04
        AbsMag        -19.07
        Axis    [ -0.5297  -0.7800   0.3332]
        Angle     33.7781
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4554"
}

Galaxy "IC 4555:ESO 22-12:AM 1541-780:IRAS 15411-7801"
{
        Type  "SBc"
        RA           15.8039
        Dec         -78.1794
        Distance   1.047e+08  # method: T-F
        Radius     2.894e+04
        AbsMag        -19.03
        Axis    [  0.0141  -0.4882  -0.8726]
        Angle     89.8147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4555"
}

Galaxy "IC 4556:MCG 4-37-7:ZWG 136.21:NPM 1"
{
        Type  "E0"
        RA           15.5894
        Dec          25.2978
        Distance   3.312e+08  # distance uncertain!
        Radius     3.853e+04
        AbsMag        -20.13
        Axis    [ -0.7430   0.3574  -0.5659]
        Angle     50.5115
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4556"
}

Galaxy "IC 4557:ZWG 222.26"
{
        Type  "S0"
        RA           15.5767
        Dec          39.7294
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [ -0.3341  -0.7405   0.5831]
        Angle     25.6793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4557"
}

Galaxy "IC 4558:ZWG 136.24"
{
        Type  "S0"
        RA           15.5961
        Dec          25.3453
        Distance   2.555e+08  # distance uncertain!
        Radius     1.115e+04
        AbsMag        -19.07
        Axis    [ -0.8530  -0.2097   0.4779]
        Angle     39.8386
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4558"
}

Galaxy "IC 4559:MCG 4-37-8:ZWG 136.26:ARAK 480"
{
        Type  "E0"
        RA           15.5981
        Dec          25.3417
        Distance   3.981e+08  # distance uncertain!
        Radius     2.316e+04
        AbsMag        -20.13
        Axis    [ -0.0753  -0.8046  -0.5891]
        Angle     84.1221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4559"
}

Galaxy "IC 4560:NPM 1"
{
        Type  "S0"
        RA           15.5983
        Dec          39.8147
        Distance    4.65e+08  # distance uncertain!
        Radius     2.705e+04
        AbsMag        -19.07
        Axis    [  0.3287  -0.7740   0.5411]
        Angle     52.5050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4560"
}

Galaxy "IC 4561:MCG 4-37-11:ZWG 136.30"
{
        Type  "S0"
        RA           15.6131
        Dec          25.4164
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.3459  -0.6966   0.6286]
        Angle     39.8653
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4561"
}

Galaxy "IC 4562:UGC 9928:MCG 7-32-34:ZWG 222.30"
{
        Type  "E0"
        RA           15.5992
        Dec          43.4931
        Distance   2.623e+08  # method: V
        Radius     4.578e+04
        AbsMag        -20.83
        Axis    [  0.1832  -0.9632  -0.1966]
        Angle    150.6542
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4562"
}

Galaxy "IC 4562A:ZWG 222.31:ZW 118:NPM 1"
{
        Type  "E0"
        RA           15.6006
        Dec          43.5039
        Distance   2.596e+08  # method: V
        Radius     1.133e+04
        AbsMag         -19.1
        Axis    [  0.1830  -0.9633  -0.1965]
        Angle    150.6690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4562A"
}

Galaxy "IC 4563:MCG 7-32-33:ZWG 222.29"
{
        Type  "S0"
        RA           15.6008
        Dec          39.8317
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.5697   0.0015   0.8218]
        Angle     47.6904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4563"
}

Galaxy "IC 4564:UGC 9930:MCG 7-32-36:ZWG 222.33"
{
        Type  "Sc"
        RA           15.6072
        Dec          43.5186
        Distance   2.607e+08  # method: V
        Radius     4.929e+04
        AbsMag        -20.11
        Axis    [  0.6003  -0.7154   0.3575]
        Angle     83.1551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4564"
}

Galaxy "IC 4565:UGC 9931:MCG 7-32-37:ZWG 222.34"
{
        Type  "Sc"
        RA           15.6097
        Dec          43.4253
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [  0.6514  -0.7586  -0.0148]
        Angle    135.8791
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4565"
}

Galaxy "IC 4566:UGC 9933:MCG 7-32-38:ZWG 222.35"
{
        Type  "Sb"
        RA           15.6117
        Dec          43.5397
        Distance    2.57e+08  # method: V
        Radius      5.98e+04
        AbsMag        -20.38
        Axis    [ -0.6008   0.1049   0.7925]
        Angle     40.1183
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4566"
}

Galaxy "IC 4567:UGC 9940:MCG 7-32-40:ZWG 222.37"
{
        Type  "Sc"
        RA           15.6203
        Dec          43.2978
        Distance   2.634e+08  # method: V
        Radius     5.363e+04
        AbsMag        -21.04
        Axis    [  0.0162  -0.8082   0.5887]
        Angle     32.4992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4567"
}

Galaxy "IC 4568:ZWG 166.28"
{
        Type  "Sb"
        RA           15.6686
        Dec          28.1519
        Distance   4.299e+08  # method: V
        Radius     3.751e+04
        AbsMag         -20.3
        Axis    [  0.6496  -0.7569  -0.0723]
        Angle    110.7981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4568"
}

Galaxy "IC 4569:MCG 5-37-13:ZWG 166.32:NPM 1"
{
        Type  "S0"
        RA           15.6800
        Dec          28.2925
        Distance     4.5e+08  # method: V
        Radius      5.89e+04
        AbsMag         -20.8
        Axis    [ -0.3763  -0.8216   0.4281]
        Angle     33.7413
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4569"
}

Galaxy "IC 4570:UGC 9975:MCG 5-37-14:ZWG 166.35"
{
        Type  "Sc"
        RA           15.6894
        Dec          28.2292
        Distance    4.41e+08  # method: V
        Radius     5.772e+04
        AbsMag        -20.65
        Axis    [  0.2678  -0.9247  -0.2706]
        Angle     85.6387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4570"
}

Galaxy "IC 4571:ESO 99-11:IRAS 15440-6710"
{
        Type  "SBb"
        RA           15.8142
        Dec         -67.3236
        Distance   1.017e+08  # distance uncertain!
        Radius     2.071e+04
        AbsMag        -19.07
        Axis    [ -0.6519  -0.7039  -0.2822]
        Angle    103.4284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4571"
}

Galaxy "IC 4572:MCG 5-37-16:ZWG 166.37"
{
        Type  "SBa"
        RA           15.6983
        Dec          28.1336
        Distance   2.125e+08  # distance uncertain!
        Radius     3.091e+04
        AbsMag        -19.07
        Axis    [  0.4017  -0.9126  -0.0764]
        Angle     76.8496
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4572"
}

Galaxy "IC 4573:ZWG 136.57"
{
        Type  "S0"
        RA           15.7033
        Dec          23.8003
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.3549  -0.7191   0.5975]
        Angle     41.2773
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4573"
}

Galaxy "IC 4574:ZWG 166.38"
{
        Type  "Sa"
        RA           15.6997
        Dec          28.2400
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [  0.7444  -0.6664  -0.0424]
        Angle    119.3668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4574"
}

Galaxy "IC 4575:ZWG 136.58:NPM 1"
{
        Type  "Sa"
        RA           15.7053
        Dec          23.8081
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [  0.1393  -0.9487  -0.2838]
        Angle     65.7418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4575"
}

Galaxy "IC 4576:ZWG 136.59:NPM 1"
{
        Type  "S0"
        RA           15.7097
        Dec          23.6706
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [  0.4751  -0.8771  -0.0703]
        Angle     81.1598
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4576"
}

Galaxy "IC 4577:ZWG 136.61:NPM 1"
{
        Type  "E0"
        RA           15.7125
        Dec          23.7931
        Distance   3.981e+08  # distance uncertain!
        Radius     4.633e+04
        AbsMag        -20.13
        Axis    [  0.2126  -0.9099  -0.3563]
        Angle    155.8462
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4577"
}

Galaxy "IC 4578:ESO 42-13:AM 1547-744:IRAS 15471-7440"
{
        Type  "SBb"
        RA           15.8864
        Dec         -74.8256
        Distance   1.168e+08  # distance uncertain!
        Radius     2.039e+04
        AbsMag        -19.07
        Axis    [ -0.6233  -0.6653  -0.4110]
        Angle    108.1604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4578"
}

Galaxy "IC 4579:ZWG 136.63:NPM 1"
{
        Type  "S0"
        RA           15.7142
        Dec          23.7736
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.3843  -0.9104  -0.1533]
        Angle     79.5977
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4579"
}

Galaxy "IC 4580:ZWG 166.41"
{
        Type  "SBa"
        RA           15.7206
        Dec          28.3564
        Distance   4.383e+08  # method: V
        Radius     3.825e+04
        AbsMag        -20.24
        Axis    [ -0.6151  -0.1492   0.7742]
        Angle     61.7165
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4580"
}

Galaxy "IC 4581:MCG 5-37-19:ZWG 166.46"
{
        Type  "SBc"
        RA           15.7336
        Dec          28.2767
        Distance   4.567e+08  # method: V
        Radius     5.978e+04
        AbsMag        -20.63
        Axis    [  0.4507  -0.8552  -0.2560]
        Angle    146.1688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4581"
}

Galaxy "IC 4582:UGC 10021:MCG 5-37-20:ZWG 166.52"
{
        Type  "SBc"
        RA           15.7608
        Dec          28.0886
        Distance    1.02e+08  # method: V
        Radius     1.928e+04
        AbsMag        -17.57
        Axis    [ -0.5499  -0.1777   0.8161]
        Angle     69.7841
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4582"
}

Galaxy "IC 4583:MCG 4-37-32:ZWG 136.74"
{
        Type  "S0"
        RA           15.7725
        Dec          23.8089
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [  0.7202  -0.6938  -0.0019]
        Angle    104.3344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4583"
}

Galaxy "IC 4584:ESO 100-4:AM 1555-661:IRAS 15554-6614"
{
        Type  "Sc"
        RA           16.0033
        Dec         -66.3825
        Distance   2.125e+08  # distance uncertain!
        Radius     5.564e+04
        AbsMag        -19.07
        Axis    [ -0.4426  -0.4688  -0.7644]
        Angle    116.9347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4584"
}

Galaxy "IC 4585:ESO 100-5:AM 1555-661:IRAS 15555-6610"
{
        Type  "SBb"
        RA           16.0047
        Dec         -66.3225
        Distance   1.685e+08  # method: V
        Radius     6.371e+04
        AbsMag        -20.56
        Axis    [  0.1236  -0.5342  -0.8363]
        Angle     89.0270
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4585"
}

Galaxy "IC 4587:ZWG 137.12:NPM 1"
{
        Type  "E0"
        RA           15.9975
        Dec          25.9411
        Distance    5.98e+08  # method: V
        Radius     3.479e+04
        AbsMag        -21.02
        Axis    [  0.1824  -0.9221  -0.3413]
        Angle    158.4220
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4587"
}

Galaxy "IC 4588"
{
        Type  "E0"
        RA           16.0844
        Dec          23.9167
        Distance   5.496e+08  # distance uncertain!
        Radius     2.398e+04
        AbsMag        -20.13
        Axis    [  0.1775  -0.9168  -0.3578]
        Angle    159.7052
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4588"
}

Galaxy "IC 4590:MCG 5-38-18:ZWG 167.29"
{
        Type  "E0"
        RA           16.1392
        Dec          28.4786
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [  0.1655  -0.9322  -0.3217]
        Angle    159.5082
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4590"
}

Galaxy "IC 4595:ESO 69-2:IRAS 16153-7001"
{
        Type  "Sc"
        RA           16.3453
        Dec         -70.1425
        Distance   1.665e+08  # method: T-F
        Radius     6.539e+04
        AbsMag        -20.84
        Axis    [  0.0211  -0.6498  -0.7598]
        Angle     81.8243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4595"
}

Galaxy "IC 4596:ESO 516-9:MCG 4-38-5"
{
        Type  "SBb"
        RA           16.2675
        Dec         -22.6247
        Distance   2.676e+08  # distance uncertain!
        Radius     5.838e+04
        AbsMag        -19.07
        Axis    [  0.3958  -0.7951  -0.4596]
        Angle     83.8346
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4596"
}

Galaxy "IC 4597:ESO 380-2:IRAS 16144-3414"
{
        Type  "Sa"
        RA           16.2942
        Dec         -34.3661
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [ -0.6232  -0.6005  -0.5010]
        Angle     88.2591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4597"
}

Galaxy "IC 4598:ESO 451-18:IRAS 16150-3119"
{
        Type  "Sc"
        RA           16.3036
        Dec         -31.4414
        Distance   1.858e+08  # method: T-F
        Radius     4.053e+04
        AbsMag        -18.78
        Axis    [ -0.7447  -0.5878   0.3161]
        Angle    100.1080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4598"
}

Galaxy "IC 4600:ESO 516-10"
{
        Type  "Sa"
        RA           16.2681
        Dec         -22.7831
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [  0.2278  -0.6908  -0.6862]
        Angle    168.3257
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4600"
}

Galaxy "IC 4607-1"
{
        Type  "E0"
        RA           16.5042
        Dec          24.5744
        Distance   5.496e+08  # distance uncertain!
        Radius     3.197e+04
        AbsMag        -20.13
        Axis    [  0.1375  -0.9248  -0.3549]
        Angle    164.0284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4607-1"
}

Galaxy "IC 4607-2"
{
        Type  "S0"
        RA           16.5044
        Dec          24.5711
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.2456  -0.9413   0.2314]
        Angle     67.8077
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4607-2"
}

Galaxy "IC 4608:ESO 43-4:AM 1639-772:IRAS 16396-7723"
{
        Type  "Irr"
        RA           16.7817
        Dec         -77.4892
        Distance   1.347e+08  # method: V
        Radius     1.764e+04
        AbsMag        -18.88
        Axis    [ -0.4361  -0.3951  -0.8085]
        Angle    133.3217
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4608"
}

Galaxy "IC 4609:MCG 4-39-14:ZWG 138.37:NPM 1"
{
        Type  "S0"
        RA           16.5503
        Dec          22.7981
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.1596  -0.9168  -0.3661]
        Angle    163.6532
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4609"
}

Galaxy "IC 4610:KUG 1632+393"
{
        Type  "S0"
        RA           16.5608
        Dec          39.2575
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [  0.6447  -0.7570   0.1067]
        Angle    116.6813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4610"
}

Galaxy "IC 4611:MCG 7-34-112"
{
        Type  "E0"
        RA           16.5617
        Dec          39.1856
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [  0.1142  -0.9652  -0.2351]
        Angle    162.8356
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4611"
}

Galaxy "IC 4612:MCG 7-34-113:ZWG 224.72:ZW 157"
{
        Type  "S0"
        RA           16.5636
        Dec          39.2633
        Distance   4.371e+08  # method: V
        Radius     3.814e+04
        AbsMag        -20.44
        Axis    [  0.1394  -0.9630  -0.2306]
        Angle    162.1522
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4612"
}

Galaxy "IC 4614:MCG 6-36-57:ZWG 196.87"
{
        Type  "Sa"
        RA           16.6297
        Dec          36.1147
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [  0.2527  -0.9658   0.0588]
        Angle     77.5175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4614"
}

Galaxy "IC 4617"
{
        Type  "Sb"
        RA           16.7022
        Dec          36.6842
        Distance   3.369e+08  # distance uncertain!
        Radius     5.879e+04
        AbsMag        -19.07
        Axis    [  0.6506  -0.7587   0.0339]
        Angle    123.2655
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4617"
}

Galaxy "IC 4618:ESO 43-9:IRAS 16506-7654"
{
        Type  "SBc"
        RA           16.9639
        Dec         -76.9925
        Distance   1.386e+08  # method: V
        Radius     3.427e+04
        AbsMag        -20.44
        Axis    [ -0.7000  -0.4911  -0.5185]
        Angle    124.4905
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4618"
}

Galaxy "IC 4619:ZWG 110.5"
{
        Type  "S0"
        RA           16.7364
        Dec          17.7589
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [  0.1466  -0.9014  -0.4074]
        Angle    166.0837
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4619"
}

Galaxy "IC 4620:MCG 3-43-4:ZWG 110.10"
{
        Type  "SBb"
        RA           16.8083
        Dec          19.3056
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [  0.0723  -0.9898   0.1232]
        Angle     67.4617
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4620"
}

Galaxy "IC 4621:UGC 10576:MCG 1-43-4:ZWG 53.15"
{
        Type  "Sb"
        RA           16.8475
        Dec           8.7842
        Distance   4.299e+08  # method: V
        Radius     5.627e+04
        AbsMag         -20.8
        Axis    [ -0.4262  -0.9038  -0.0387]
        Angle     59.3567
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4621"
}

Galaxy "IC 4623:MCG 4-40-3:ZWG 139.8"
{
        Type  "Sc"
        RA           16.8514
        Dec          22.5275
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [  0.0617  -0.7998   0.5971]
        Angle     69.0201
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4623"
}

Galaxy "IC 4624:ZWG 110.13"
{
        Type  "E0"
        RA           16.8592
        Dec          17.4489
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [  0.1111  -0.9039  -0.4130]
        Angle    168.5720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4624"
}

Galaxy "IC 4627:IRAS 16514-0733"
{
        Type  "Irr"
        RA           16.9022
        Dec          -7.6358
        Distance   4.366e+08  # distance uncertain!
        Radius      5.08e+04
        AbsMag        -20.13
        Axis    [  0.4093  -0.8553  -0.3176]
        Angle     95.0990
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4627"
}

Galaxy "IC 4630:UGC 10607:MCG 4-40-7:MK 1111"
{
        Type  "S0"
        RA           16.9192
        Dec          26.6633
        Distance     4.7e+08  # method: V
        Radius     5.468e+04
        AbsMag        -21.09
        Axis    [  0.5255  -0.8155  -0.2426]
        Angle    145.8376
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4630"
}

Galaxy "IC 4633:ESO 44-3:FAIR 841:AM 1705-773"
{
        Type  "Sc"
        RA           17.2297
        Dec         -77.5358
        Distance   1.652e+08  # method: T-F
        Radius     9.609e+04
        AbsMag        -19.82
        Axis    [ -0.8411  -0.4731  -0.2623]
        Angle    131.0911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4633"
}

Galaxy "IC 4635:ESO 44-5:IRAS 17080-7725"
{
        Type  "SBb"
        RA           17.2611
        Dec         -77.4892
        Distance   1.146e+08  # method: T-F
        Radius     4.999e+04
        AbsMag        -17.93
        Axis    [ -0.6935  -0.7187   0.0502]
        Angle    136.4281
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4635"
}

Galaxy "IC 4638:MCG 6-37-21:ZWG 197.26:NPM 1"
{
        Type  "SBc"
        RA           17.0203
        Dec          33.5139
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.1076  -0.9537  -0.2810]
        Angle    167.9023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4638"
}

Galaxy "IC 4639:NPM 1"
{
        Type  "E0"
        RA           17.0483
        Dec          22.9306
        Distance   6.919e+08  # distance uncertain!
        Radius     4.025e+04
        AbsMag        -20.13
        Axis    [ -0.9484   0.0181  -0.3166]
        Angle     44.5692
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4639"
}

Galaxy "IC 4640:ESO 24-1"
{
        Type  "SBc"
        RA           17.3992
        Dec         -80.0633
        Distance    1.47e+08  # distance uncertain!
        Radius     1.925e+04
        AbsMag        -19.07
        Axis    [ -0.5869  -0.3968  -0.7058]
        Angle    134.9286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4640"
}

Galaxy "IC 4641:ESO 24-2:AM 1715-800"
{
        Type  "Sc"
        RA           17.4028
        Dec         -80.1472
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [  0.0850  -0.2835  -0.9552]
        Angle    178.1930
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4641"
}

Galaxy "IC 4644:ESO 44-11:FGCE 1280:IRAS 17182-7353"
{
        Type  "Sb"
        RA           17.4097
        Dec         -73.9386
        Distance    2.03e+08  # distance uncertain!
        Radius     5.609e+04
        AbsMag        -19.07
        Axis    [ -0.5861  -0.8024  -0.1122]
        Angle    116.4437
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4644"
}

Galaxy "IC 4645:ZWG 225.80"
{
        Type  "E0"
        RA           17.2453
        Dec          43.1042
        Distance   4.787e+08  # distance uncertain!
        Radius     2.785e+04
        AbsMag        -20.13
        Axis    [  0.0570  -0.9775  -0.2029]
        Angle    170.7506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4645"
}

Galaxy "IC 4646:ESO 138-23:IRAS 17194-5957"
{
        Type  "Sc"
        RA           17.3981
        Dec         -60.0003
        Distance    1.05e+08  # method: T-F
        Radius     4.275e+04
        AbsMag        -19.94
        Axis    [  0.3141  -0.3943  -0.8637]
        Angle    129.0463
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4646"
}

Galaxy "IC 4647:ESO 24-5"
{
        Type  "S0"
        RA           17.4344
        Dec         -80.1950
        Distance    1.54e+08  # distance uncertain!
        Radius     3.583e+04
        AbsMag        -19.07
        Axis    [  0.2266  -0.2501  -0.9413]
        Angle    118.1392
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4647"
}

Galaxy "IC 4652:ESO 138-25:IRAS 17220-5941"
{
        Type  "Sb"
        RA           17.4406
        Dec         -59.7283
        Distance    1.47e+08  # distance uncertain!
        Radius     1.711e+04
        AbsMag        -19.07
        Axis    [  0.2772  -0.4446  -0.8517]
        Angle    117.7140
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4652"
}

Galaxy "IC 4653:ESO 138-28:AM 1722-605:IRAS 17225-6050"
{
        Type  "SBa"
        RA           17.4519
        Dec         -60.8792
        Distance   8.675e+07  # method: V
        Radius     1.388e+04
        AbsMag        -18.92
        Axis    [ -0.0975  -0.6331  -0.7679]
        Angle    106.5745
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4653"
}

Galaxy "IC 4654:ESO 44-15:IRAS 17306-7420"
{
        Type  "SBc"
        RA           17.6186
        Dec         -74.3811
        Distance   1.281e+08  # distance uncertain!
        Radius      2.98e+04
        AbsMag        -19.07
        Axis    [ -0.6262  -0.5701  -0.5318]
        Angle    119.5684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4654"
}

Galaxy "IC 4656:ESO 102-10:IRAS 17329-6341"
{
        Type  "Sc"
        RA           17.6289
        Dec         -63.7297
        Distance   1.766e+08  # method: T-F
        Radius     5.909e+04
        AbsMag        -19.97
        Axis    [ -0.3469  -0.8413  -0.4146]
        Angle     95.7452
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4656"
}

Galaxy "IC 4660:UGC 10848:MCG 13-12-23:ZWG 355.32"
{
        Type  "S0"
        RA           17.3625
        Dec          75.8486
        Distance   5.463e+07  # method: V
        Radius     1.033e+04
        AbsMag        -16.72
        Axis    [  0.0980   0.0755   0.9923]
        Angle     84.4236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4660"
}

Galaxy "IC 4661:ESO 44-21:IRAS 17447-7401"
{
        Type  "Sc"
        RA           17.8506
        Dec         -74.0328
        Distance   8.081e+07  # distance uncertain!
        Radius      1.88e+04
        AbsMag        -19.07
        Axis    [ -0.0988  -0.4328  -0.8960]
        Angle    128.5008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4661"
}

Galaxy "IC 4662:ESO 102-14:IRAS 17422-6437:PK 328-17.1"
{
        Type  "Irr"
        RA           17.7856
        Dec         -64.6419
        Distance   1.459e+07  # method: V
        Radius          6789
        AbsMag        -16.55
        Axis    [ -0.5997  -0.6825  -0.4178]
        Angle    110.9366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4662"
}

Galaxy "IC 4662A:ESO 102-16:IRAS 17465-6456"
{
        Type  "SBc"
        RA           17.8600
        Dec         -64.9594
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.1101  -0.5929  -0.7977]
        Angle    112.0555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4662A"
}

Galaxy "IC 4664:ESO 102-15:IRAS 17442-6314"
{
        Type  "SBb"
        RA           17.8161
        Dec         -63.2539
        Distance   1.811e+08  # method: T-F
        Radius      4.74e+04
        AbsMag        -20.12
        Axis    [ -0.6384  -0.7012  -0.3173]
        Angle    110.8704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4664"
}

Galaxy "IC 4669:UGC 10992:ZWG 300.69:IRAS 17466+6127"
{
        Type  "SBb"
        RA           17.7867
        Dec          61.4339
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [  0.4673  -0.7191   0.5144]
        Angle    101.2985
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4669"
}

Galaxy "IC 4672:ESO 102-21"
{
        Type  "Sc"
        RA           18.0372
        Dec         -62.8322
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.0641  -0.6506  -0.7567]
        Angle    105.5517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4672"
}

Galaxy "IC 4674:ESO 140-1:IRAS 18035-6224"
{
        Type  "SBc"
        RA           18.1369
        Dec         -62.3950
        Distance   1.314e+08  # method: T-F
        Radius     2.103e+04
        AbsMag        -18.13
        Axis    [ -0.4154  -0.8141  -0.4058]
        Angle    102.9074
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4674"
}

Galaxy "IC 4676:ZWG 84.13"
{
        Type  "S0"
        RA           18.0481
        Dec          11.8231
        Distance   2.802e+08  # distance uncertain!
        Radius     1.223e+04
        AbsMag        -19.07
        Axis    [  0.0184  -0.8879  -0.4597]
        Angle    179.0764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4676"
}

Galaxy "IC 4679:ESO 182-5:IRAS 18071-5615"
{
        Type  "SBc"
        RA           18.1900
        Dec         -56.2536
        Distance   1.462e+08  # method: T-F
        Radius     4.678e+04
        AbsMag        -19.76
        Axis    [ -0.4717  -0.8298  -0.2983]
        Angle    103.8894
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4679"
}

Galaxy "IC 4680:ESO 103-9:AM 1808-643"
{
        Type  "SBb"
        RA           18.2247
        Dec         -64.4761
        Distance   1.965e+08  # method: T-F
        Radius     4.859e+04
        AbsMag           -20
        Axis    [ -0.3729  -0.7413  -0.5581]
        Angle    106.3634
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4680"
}

Galaxy "IC 4682:ESO 71-5:FAIR 493:IRAS 18105-7135"
{
        Type  "SBc"
        RA           18.2736
        Dec         -71.5819
        Distance   1.688e+08  # method: T-F
        Radius     5.646e+04
        AbsMag        -20.27
        Axis    [ -0.8444  -0.5272  -0.0949]
        Angle    130.8637
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4682"
}

Galaxy "IC 4686:ESO 140-9:FAIR 44"
{
        Type  "S0"
        RA           18.2272
        Dec         -57.7322
        Distance   2.235e+08  # method: V
        Radius      1.95e+04
        AbsMag        -19.48
        Axis    [ -0.7994  -0.5380  -0.2674]
        Angle    118.1840
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4686"
}

Galaxy "IC 4687:ESO 140-10:FAIR 45:AM 1809-574"
{
        Type  "Sb"
        RA           18.2275
        Dec         -57.7256
        Distance   2.343e+08  # method: V
        Radius     3.067e+04
        AbsMag        -19.98
        Axis    [ -0.1910  -0.7042  -0.6838]
        Angle    109.9349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4687"
}

Galaxy "IC 4688:UGC 11125:MCG 2-46-6:ZWG 84.18"
{
        Type  "Sc"
        RA           18.1364
        Dec          11.7119
        Distance   1.612e+08  # distance uncertain!
        Radius     3.517e+04
        AbsMag        -19.07
        Axis    [ -0.6480  -0.5410   0.5361]
        Angle     68.8712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4688"
}

Galaxy "IC 4689:ESO 140-11:FAIR 46:AM 1809-574"
{
        Type  "Sa"
        RA           18.2278
        Dec         -57.7483
        Distance   2.376e+08  # method: V
        Radius      3.11e+04
        AbsMag        -19.21
        Axis    [ -0.6578  -0.7477   0.0910]
        Angle    119.6260
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4689"
}

Galaxy "IC 4691:ZWG 84.19"
{
        Type  "S0"
        RA           18.1458
        Dec          11.8289
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.6876  -0.4594   0.5623]
        Angle     68.8912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4691"
}

Galaxy "IC 4692:ESO 140-13:IRAS 18104-5842"
{
        Type  "SBc"
        RA           18.2472
        Dec         -58.6942
        Distance   1.909e+08  # method: T-F
        Radius     4.997e+04
        AbsMag        -19.54
        Axis    [  0.2502  -0.4601  -0.8519]
        Angle    123.1813
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4692"
}

Galaxy "IC 4694:ESO 140-14"
{
        Type  "SBc"
        RA           18.2575
        Dec         -58.2083
        Distance   1.058e+08  # method: T-F
        Radius      3.54e+04
        AbsMag        -18.75
        Axis    [  0.1636  -0.5739  -0.8024]
        Angle    110.0779
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4694"
}

Galaxy "IC 4696:ESO 103-13:AM 1815-644:IRAS 18153-6445"
{
        Type  "Sc"
        RA           18.3383
        Dec         -64.7328
        Distance   1.934e+08  # method: T-F
        Radius     6.751e+04
        AbsMag        -20.36
        Axis    [ -0.3624  -0.7876  -0.4983]
        Angle    103.8320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4696"
}

Galaxy "IC 4697:MCG 4-43-13:ZWG 142.23"
{
        Type  "S0"
        RA           18.2075
        Dec          25.4272
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.6497  -0.7088  -0.2748]
        Angle    153.6034
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4697"
}

Galaxy "IC 4698:ESO 103-15:AM 1816-632:IRAS 18161-6322"
{
        Type  "Sc"
        RA           18.3500
        Dec         -63.3475
        Distance   1.978e+08  # method: T-F
        Radius      3.74e+04
        AbsMag        -18.61
        Axis    [  0.0282  -0.7146  -0.6990]
        Angle     95.1088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4698"
}

Galaxy "IC 4702:ESO 140-20"
{
        Type  "SBa"
        RA           18.3842
        Dec         -59.2389
        Distance   1.341e+08  # distance uncertain!
        Radius     2.926e+04
        AbsMag        -19.07
        Axis    [ -0.8293  -0.5572   0.0436]
        Angle    123.7623
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4702"
}

Galaxy "IC 4704:ESO 71-11:AM 1822-714"
{
        Type  "S0"
        RA           18.4647
        Dec         -71.6092
        Distance   1.668e+08  # method: V
        Radius     3.639e+04
        AbsMag        -20.44
        Axis    [ -0.9177  -0.3910   0.0700]
        Angle    138.6704
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4704"
}

Galaxy "IC 4705:ESO 71-12:AM 1822-714:IRAS 18222-7143"
{
        Type  "SBa"
        RA           18.4694
        Dec         -71.6931
        Distance   1.336e+08  # method: V
        Radius     2.332e+04
        AbsMag        -19.26
        Axis    [ -0.2850  -0.5569  -0.7801]
        Angle    120.2732
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4705"
}

Galaxy "IC 4708:ZWG 301.24"
{
        Type  "E0"
        RA           18.2294
        Dec          61.1569
        Distance   4.169e+08  # distance uncertain!
        Radius     1.819e+04
        AbsMag        -20.13
        Axis    [ -0.0132  -0.9988  -0.0471]
        Angle    183.0895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4708"
}

Galaxy "IC 4709:ESO 182-14:IRAS 18200-5623"
{
        Type  "Sb"
        RA           18.4053
        Dec         -56.3686
        Distance   1.612e+08  # distance uncertain!
        Radius     2.579e+04
        AbsMag        -19.07
        Axis    [  0.1952  -0.5090  -0.8384]
        Angle    125.2786
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4709"
}

Galaxy "IC 4710:ESO 103-22:AM 1823-670:IRAS 18235-6700"
{
        Type  "Irr"
        RA           18.4772
        Dec         -66.9831
        Distance   3.316e+07  # method: V
        Radius     1.736e+04
        AbsMag        -17.53
        Axis    [  0.0518  -0.4307  -0.9010]
        Angle    138.9888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4710"
}

Galaxy "IC 4712:ESO 71-14:FAIR 497:AM 1830-714"
{
        Type  "Sc"
        RA           18.5183
        Dec         -71.6939
        Distance   1.892e+08  # method: T-F
        Radius      6.33e+04
        AbsMag        -20.72
        Axis    [ -0.3440  -0.6481  -0.6794]
        Angle    111.8085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4712"
}

Galaxy "IC 4713:ESO 103-23:IRAS 18247-6715"
{
        Type  "Irr"
        RA           18.4994
        Dec         -67.2244
        Distance   2.509e+08  # method: V
        Radius     4.014e+04
        AbsMag        -20.13
        Axis    [ -0.7269  -0.5417  -0.4221]
        Angle    124.9586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4713"
}

Galaxy "IC 4714:ESO 103-24"
{
        Type  "Sc"
        RA           18.5153
        Dec         -66.6528
        Distance   1.697e+08  # method: T-F
        Radius     3.208e+04
        AbsMag        -18.48
        Axis    [ -0.6847  -0.6608   0.3074]
        Angle    149.2961
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4714"
}

Galaxy "IC 4716:ESO 183-1"
{
        Type  "SBa"
        RA           18.5458
        Dec         -56.9619
        Distance   3.369e+08  # distance uncertain!
        Radius      2.94e+04
        AbsMag        -19.07
        Axis    [ -0.5881  -0.7129  -0.3821]
        Angle    113.6080
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4716"
}

Galaxy "IC 4717:ESO 140-24:IRAS 18289-5800"
{
        Type  "Sb"
        RA           18.5547
        Dec         -57.9750
        Distance   1.741e+08  # method: T-F
        Radius     4.051e+04
        AbsMag        -19.44
        Axis    [ -0.3332  -0.9210  -0.2020]
        Angle    102.1953
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4717"
}

Galaxy "IC 4718:ESO 140-26"
{
        Type  "Sb"
        RA           18.5639
        Dec         -60.1286
        Distance   1.696e+08  # method: V
        Radius     3.207e+04
        AbsMag        -19.78
        Axis    [ -0.6248  -0.7655  -0.1540]
        Angle    114.3884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4718"
}

Galaxy "IC 4719:ESO 183-2:IRAS 18289-5646"
{
        Type  "Irr"
        RA           18.5531
        Dec         -56.7328
        Distance    1.82e+08  # distance uncertain!
        Radius     3.706e+04
        AbsMag        -20.13
        Axis    [ -0.7164  -0.6548  -0.2408]
        Angle    116.0787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4719"
}

Galaxy "IC 4720:ESO 140-25:AM 1830-583:IRAS 18291-5826"
{
        Type  "SBc"
        RA           18.5589
        Dec         -58.4047
        Distance   6.718e+07  # method: T-F
        Radius      2.54e+04
        AbsMag        -17.97
        Axis    [ -0.7088  -0.6575   0.2554]
        Angle    133.5790
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4720"
}

Galaxy "IC 4721:ESO 140-27:AM 1830-583"
{
        Type  "SBc"
        RA           18.5733
        Dec         -58.4972
        Distance   7.751e+07  # method: T-F
        Radius     5.862e+04
        AbsMag        -19.38
        Axis    [ -0.6411  -0.7509   0.1588]
        Angle    125.8464
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4721"
}

Galaxy "IC 4721A"
{
        Type  "E0"
        RA           18.5739
        Dec         -58.5336
        Distance   2.754e+08  # distance uncertain!
        Radius     2.003e+04
        AbsMag        -20.13
        Axis    [ -0.0749  -0.4597  -0.8849]
        Angle    180.6020
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4721A"
}

Galaxy "IC 4722:ESO 140-28:AM 1830-574:IRAS 18302-5749"
{
        Type  "Sc"
        RA           18.5753
        Dec         -57.7933
        Distance   1.456e+08  # method: T-F
        Radius     3.388e+04
        AbsMag        -19.55
        Axis    [ -0.3156  -0.6465  -0.6946]
        Angle    122.3182
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4722"
}

Galaxy "IC 4723:ESO 103-27:AM 1831-671:IRAS 18311-6325"
{
        Type  "S0"
        RA           18.5989
        Dec         -63.3767
        Distance   1.851e+08  # distance uncertain!
        Radius     1.615e+04
        AbsMag        -19.07
        Axis    [ -0.0672  -0.4238  -0.9032]
        Angle    177.5395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4723"
}

Galaxy "IC 4724:ESO 71-19"
{
        Type  "S0"
        RA           18.6444
        Dec         -70.1256
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.7966  -0.5902   0.1307]
        Angle    138.8517
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4724"
}

Galaxy "IC 4726:ESO 103-32:AM 1832-625"
{
        Type  "S0"
        RA           18.6161
        Dec         -62.8542
        Distance   2.024e+08  # method: V
        Radius     2.649e+04
        AbsMag        -19.26
        Axis    [ -0.1452  -0.4960  -0.8561]
        Angle    143.8589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4726"
}

Galaxy "IC 4727:ESO 103-33"
{
        Type  "S0"
        RA           18.6319
        Dec         -62.7003
        Distance   1.987e+08  # method: V
        Radius     3.179e+04
        AbsMag        -19.82
        Axis    [ -0.0714  -0.4291  -0.9004]
        Angle    177.6175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4727"
}

Galaxy "IC 4728:ESO 103-34:IRAS 18333-6234"
{
        Type  "SBb"
        RA           18.6325
        Dec         -62.5308
        Distance   2.114e+08  # method: V
        Radius     6.149e+04
        AbsMag        -19.76
        Axis    [ -0.7326  -0.6108   0.3005]
        Angle    142.6865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4728"
}

Galaxy "IC 4729:ESO 103-40:FAIR 333:IRAS 18347-6728"
{
        Type  "SBc"
        RA           18.6656
        Dec         -67.4261
        Distance   1.996e+08  # method: V
        Radius     4.644e+04
        AbsMag        -20.53
        Axis    [ -0.8983  -0.4390  -0.0187]
        Angle    132.1019
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4729"
}

Galaxy "IC 4730:ESO 103-38:IRAS 18339-6323"
{
        Type  "SBa"
        RA           18.6472
        Dec         -63.3503
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.7698  -0.6277   0.1156]
        Angle    130.6043
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4730"
}

Galaxy "IC 4731:ESO 103-37"
{
        Type  "SBa"
        RA           18.6450
        Dec         -62.9433
        Distance   7.717e+07  # distance uncertain!
        Radius     1.684e+04
        AbsMag        -19.07
        Axis    [ -0.4474  -0.7741  -0.4479]
        Angle    109.4675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4731"
}

Galaxy "IC 4734:ESO 140-33:AM 1834-573:IRAS 18341-5732"
{
        Type  "SBb"
        RA           18.6403
        Dec         -57.4906
        Distance   1.977e+08  # method: T-F
        Radius     3.738e+04
        AbsMag        -19.71
        Axis    [ -0.5562  -0.7401  -0.3779]
        Angle    112.9193
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4734"
}

Galaxy "IC 4735:ESO 103-41:IRAS 18350-6300"
{
        Type  "Sa"
        RA           18.6639
        Dec         -62.9558
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.2650  -0.5370  -0.8009]
        Angle    135.6212
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4735"
}

Galaxy "IC 4736:ESO 140-34"
{
        Type  "SBc"
        RA           18.6442
        Dec         -57.8931
        Distance    1.27e+08  # method: T-F
        Radius     1.847e+04
        AbsMag        -18.35
        Axis    [ -0.8047  -0.5032  -0.3150]
        Angle    122.8272
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4736"
}

Galaxy "IC 4737:ESO 103-42:IRAS 18352-6238"
{
        Type  "SBa"
        RA           18.6661
        Dec         -62.5972
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.7615  -0.5204  -0.3865]
        Angle    125.3466
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4737"
}

Galaxy "IC 4738:ESO 140-35:AM 1835-615"
{
        Type  "Sc"
        RA           18.6742
        Dec         -61.9017
        Distance    2.44e+08  # distance uncertain!
        Radius     4.259e+04
        AbsMag        -19.07
        Axis    [ -0.7617  -0.6382   0.1115]
        Angle    128.9447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4738"
}

Galaxy "IC 4739:ESO 140-36:AM 1836-615"
{
        Type  "Sc"
        RA           18.6808
        Dec         -61.9011
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.5903  -0.6108  -0.5277]
        Angle    122.4834
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4739"
}

Galaxy "IC 4740:ESO 71-20"
{
        Type  "SBc"
        RA           18.7167
        Dec         -68.3600
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.0837  -0.3841  -0.9195]
        Angle    177.0729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4740"
}

Galaxy "IC 4741:ESO 103-47:FAIR 179:AM 1836-635"
{
        Type  "Sb"
        RA           18.6953
        Dec         -63.9475
        Distance   2.232e+08  # method: V
        Radius     4.545e+04
        AbsMag        -20.38
        Axis    [ -0.1571  -0.5950  -0.7882]
        Angle    121.1006
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4741"
}

Galaxy "IC 4742:ESO 103-48:FAIR 180:AM 1837-635"
{
        Type  "E1"
        RA           18.6978
        Dec         -63.8617
        Distance   2.164e+08  # method: V
        Radius      5.35e+04
        AbsMag        -21.01
        Axis    [ -0.2474  -0.4126  -0.8767]
        Angle    171.9275
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4742"
}

Galaxy "IC 4743:ESO 140-37"
{
        Type  "S0"
        RA           18.6914
        Dec         -61.7719
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.5530  -0.7673  -0.3247]
        Angle    112.5672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4743"
}

Galaxy "IC 4744:ESO 103-50:AM 1837-631:IRAS 18371-6316"
{
        Type  "Irr"
        RA           18.6986
        Dec         -63.2233
        Distance   3.981e+08  # distance uncertain!
        Radius     3.474e+04
        AbsMag        -20.13
        Axis    [ -0.4861  -0.7604  -0.4307]
        Angle    111.3979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4744"
}

Galaxy "IC 4745:ESO 103-52:IRAS 18376-6459"
{
        Type  "Sb"
        RA           18.7097
        Dec         -64.9431
        Distance   2.133e+08  # method: V
        Radius     6.824e+04
        AbsMag        -20.18
        Axis    [ -0.7649  -0.5584   0.3211]
        Angle    147.2521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4745"
}

Galaxy "IC 4746:ESO 45-14"
{
        Type  "Irr"
        RA           18.7653
        Dec         -72.6711
        Distance   5.496e+08  # distance uncertain!
        Radius     3.997e+04
        AbsMag        -20.13
        Axis    [ -0.0908  -0.3492  -0.9326]
        Angle    176.5912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4746"
}

Galaxy "IC 4747:ESO 45-15:IRAS 18398-7240"
{
        Type  "S0"
        RA           18.7658
        Dec         -72.6297
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.3231  -0.8335  -0.4482]
        Angle    100.5433
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4747"
}

Galaxy "IC 4748:ESO 103-53:FAIR 181"
{
        Type  "S0"
        RA           18.7125
        Dec         -64.0722
        Distance   2.096e+08  # method: V
        Radius     2.438e+04
        AbsMag        -19.74
        Axis    [ -0.0822  -0.4182  -0.9046]
        Angle    177.5177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4748"
}

Galaxy "IC 4749:ESO 103-54"
{
        Type  "S0"
        RA           18.7136
        Dec         -63.2089
        Distance   1.981e+08  # method: V
        Radius     2.017e+04
        AbsMag        -19.62
        Axis    [ -0.0822  -0.4250  -0.9015]
        Angle    177.6081
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4749"
}

Galaxy "IC 4750:ESO 103-55:DRCG 51-54"
{
        Type  "Sa"
        RA           18.7172
        Dec         -62.9711
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.5788  -0.8019  -0.1481]
        Angle    115.0294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4750"
}

Galaxy "IC 4751:ESO 140-40:FAIR 183:AM 1838-620"
{
        Type  "S0"
        RA           18.7219
        Dec         -62.1117
        Distance   2.161e+08  # method: V
        Radius     3.143e+04
        AbsMag        -20.01
        Axis    [  0.0809  -0.4771  -0.8751]
        Angle    134.8992
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4751"
}

Galaxy "IC 4752:ESO 103-57"
{
        Type  "S0"
        RA           18.7297
        Dec         -64.0817
        Distance   2.676e+08  # distance uncertain!
        Radius     2.724e+04
        AbsMag        -19.07
        Axis    [ -0.0845  -0.4181  -0.9045]
        Angle    177.5229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4752"
}

Galaxy "IC 4753:ESO 140-41:FAIR 184:AM 1838-620"
{
        Type  "E0"
        RA           18.7258
        Dec         -62.1078
        Distance   1.686e+08  # method: V
        Radius     1.716e+04
        AbsMag        -19.47
        Axis    [ -0.1339  -0.4310  -0.8924]
        Angle    178.2667
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4753"
}

Galaxy "IC 4754:ESO 140-42:FAIR 185"
{
        Type  "SBb"
        RA           18.7333
        Dec         -61.9892
        Distance   2.229e+08  # method: V
        Radius     4.215e+04
        AbsMag        -19.77
        Axis    [ -0.8503  -0.4412  -0.2870]
        Angle    127.0764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4754"
}

Galaxy "IC 4755:ESO 103-58:DRCG 51-2:IRAS 18402-6344"
{
        Type  "Sb"
        RA           18.7500
        Dec         -63.6917
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [ -0.4212  -0.8782  -0.2265]
        Angle    107.4545
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4755"
}

Galaxy "IC 4757:ESO 183-9:AM 1839-571:IRAS 18396-5713"
{
        Type  "Sa"
        RA           18.7322
        Dec         -57.1675
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.2205  -0.7781  -0.5882]
        Angle    107.6158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4757"
}

Galaxy "IC 4758:ESO 103-62:IRAS 18413-6548"
{
        Type  "Sc"
        RA           18.7717
        Dec         -65.7567
        Distance    1.47e+08  # distance uncertain!
        Radius     2.352e+04
        AbsMag        -19.07
        Axis    [ -0.8772  -0.4723  -0.0866]
        Angle    129.2925
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4758"
}

Galaxy "IC 4759:ESO 103-60:AM 1840-630:DRCG 51-47"
{
        Type  "Irr"
        RA           18.7614
        Dec         -63.0864
        Distance   4.169e+08  # distance uncertain!
        Radius     5.457e+04
        AbsMag        -20.13
        Axis    [  0.0303  -0.5044  -0.8629]
        Angle    129.8857
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4759"
}

Galaxy "IC 4760:ESO 103-61:DRCG 51-53"
{
        Type  "S0"
        RA           18.7625
        Dec         -62.9581
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.0885  -0.4268  -0.9000]
        Angle    177.6589
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4760"
}

Galaxy "IC 4761:ESO 183-10:AM 1839-525"
{
        Type  "SBc"
        RA           18.7319
        Dec         -52.8533
        Distance   1.281e+08  # distance uncertain!
        Radius      2.98e+04
        AbsMag        -19.07
        Axis    [ -0.7453  -0.6157  -0.2557]
        Angle    117.0945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4761"
}

Galaxy "IC 4763:UGC 11288:MCG 11-22-55:ZWG 322.46"
{
        Type  "E0"
        RA           18.5583
        Dec          67.1369
        Distance   2.291e+08  # distance uncertain!
        Radius     1.333e+04
        AbsMag        -20.13
        Axis    [ -0.0222  -0.9993   0.0317]
        Angle     97.7453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4763"
}

Galaxy "IC 4764:ESO 104-4:DRCG 51-8"
{
        Type  "Sa"
        RA           18.7853
        Dec         -63.4844
        Distance   1.754e+08  # method: V
        Radius     3.317e+04
        AbsMag        -18.95
        Axis    [ -0.5635  -0.8254   0.0337]
        Angle    121.8783
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4764"
}

Galaxy "IC 4765:ESO 104-6:FAIR 187:DRCG 51-19"
{
        Type  "E0"
        RA           18.7883
        Dec         -63.3311
        Distance   2.102e+08  # method: V
        Radius      1.07e+05
        AbsMag        -21.75
        Axis    [ -0.8716  -0.2446  -0.4248]
        Angle    138.5731
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4765"
}

Galaxy "IC 4766:ESO 104-9:DRCG 51-25"
{
        Type  "Sa"
        RA           18.7931
        Dec         -63.2922
        Distance   2.251e+08  # method: V
        Radius     3.929e+04
        AbsMag        -19.99
        Axis    [ -0.5585  -0.8166  -0.1461]
        Angle    114.9102
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4766"
}

Galaxy "IC 4767:ESO 104-10:AM 1842-632:DRCG 51-12"
{
        Type  "Sa"
        RA           18.7947
        Dec         -63.4053
        Distance   1.618e+08  # method: V
        Radius     3.529e+04
        AbsMag        -19.08
        Axis    [ -0.0085  -0.6636  -0.7481]
        Angle    104.9186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4767"
}

Galaxy "IC 4769:ESO 104-11:FAIR 188:AM 1843-631"
{
        Type  "SBc"
        RA           18.7956
        Dec         -63.1572
        Distance    1.91e+08  # method: T-F
        Radius     5.279e+04
        AbsMag        -19.74
        Axis    [ -0.7680  -0.6345  -0.0867]
        Angle    123.8076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4769"
}

Galaxy "IC 4770:ESO 104-13:DRCG 51-10"
{
        Type  "Sa"
        RA           18.8028
        Dec         -63.3836
        Distance    2.27e+08  # method: V
        Radius     2.641e+04
        AbsMag        -18.71
        Axis    [ -0.4445  -0.6262  -0.6406]
        Angle    122.8747
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4770"
}

Galaxy "IC 4771:ESO 104-15:DRCG 51-24"
{
        Type  "Sc"
        RA           18.8064
        Dec         -63.2478
        Distance   2.179e+08  # method: V
        Radius     3.485e+04
        AbsMag        -18.92
        Axis    [ -0.7758  -0.5402   0.3259]
        Angle    145.2718
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4771"
}

Galaxy "IC 4772:MCG 7-38-14:ZWG 228.20:NPM 1"
{
        Type  "E0"
        RA           18.6656
        Dec          40.0269
        Distance   3.312e+08  # distance uncertain!
        Radius     1.927e+04
        AbsMag        -20.13
        Axis    [ -0.0521  -0.9720  -0.2292]
        Angle    188.0001
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4772"
}

Galaxy "IC 4773:ESO 72-2"
{
        Type  "SBc"
        RA           18.8558
        Dec         -69.9261
        Distance   1.612e+08  # distance uncertain!
        Radius     3.752e+04
        AbsMag        -19.07
        Axis    [ -0.7809  -0.6238  -0.0318]
        Angle    130.9454
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4773"
}

Galaxy "IC 4774:ESO 141-5:FAIR 52:IRAS 18438-5759"
{
        Type  "SBc"
        RA           18.8028
        Dec         -57.9356
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.8013  -0.5029  -0.3240]
        Angle    124.2156
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4774"
}

Galaxy "IC 4775:ESO 183-14"
{
        Type  "Sb"
        RA           18.8072
        Dec         -57.1836
        Distance   1.735e+08  # method: T-F
        Radius     4.037e+04
        AbsMag        -18.93
        Axis    [  0.2141  -0.6466  -0.7322]
        Angle     99.6252
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4775"
}

Galaxy "IC 4777:ESO 183-13:FAIR 334"
{
        Type  "SBa"
        RA           18.8031
        Dec         -53.1469
        Distance   2.492e+08  # method: V
        Radius     3.262e+04
        AbsMag        -19.82
        Axis    [ -0.7915  -0.5995  -0.1185]
        Angle    117.8164
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4777"
}

Galaxy "IC 4778:ESO 141-6:IRAS 18454-6146"
{
        Type  "SBa"
        RA           18.8333
        Dec         -61.7192
        Distance   1.404e+08  # distance uncertain!
        Radius     2.451e+04
        AbsMag        -19.07
        Axis    [ -0.2196  -0.5895  -0.7774]
        Angle    128.1358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4778"
}

Galaxy "IC 4779:ESO 104-17:DRCG 51-49"
{
        Type  "Sb"
        RA           18.8417
        Dec         -63.0131
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.8383  -0.4766  -0.2648]
        Angle    127.0236
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4779"
}

Galaxy "IC 4780:ESO 141-7:IRAS 18455-5918"
{
        Type  "S0"
        RA           18.8322
        Dec         -59.2536
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.6598  -0.6520  -0.3736]
        Angle    119.5263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4780"
}

Galaxy "IC 4781:ESO 104-18"
{
        Type  "Sa"
        RA           18.8603
        Dec         -62.7928
        Distance    2.33e+08  # distance uncertain!
        Radius     3.051e+04
        AbsMag        -19.07
        Axis    [  0.1189  -0.4851  -0.8664]
        Angle    125.4287
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4781"
}

Galaxy "IC 4782:ESO 183-18:AM 1846-553"
{
        Type  "Sc"
        RA           18.8483
        Dec         -55.4911
        Distance   1.851e+08  # distance uncertain!
        Radius     3.769e+04
        AbsMag        -19.07
        Axis    [ -0.3621  -0.9260  -0.1069]
        Angle    107.1286
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4782"
}

Galaxy "IC 4783:ESO 141-8:AM 1847-585:IRAS 18473-5852"
{
        Type  "Sc"
        RA           18.8592
        Dec         -58.8133
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [  0.0024  -0.4799  -0.8773]
        Angle    156.0536
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4783"
}

Galaxy "IC 4784:ESO 104-20:AM 1848-631:IRAS 18479-6319"
{
        Type  "S0"
        RA           18.8800
        Dec         -63.2594
        Distance   2.198e+08  # method: V
        Radius     4.476e+04
        AbsMag        -20.44
        Axis    [ -0.6381  -0.6116  -0.4677]
        Angle    123.2445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4784"
}

Galaxy "IC 4785:ESO 141-9:IRAS 18484-5918"
{
        Type  "SBb"
        RA           18.8819
        Dec         -59.2550
        Distance   1.619e+08  # method: T-F
        Radius       7.3e+04
        AbsMag        -20.48
        Axis    [ -0.7067  -0.7021   0.0872]
        Angle    125.3951
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4785"
}

Galaxy "IC 4786:ESO 183-24"
{
        Type  "S0"
        RA           18.8789
        Dec         -56.6950
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [ -0.6651  -0.6264   0.4065]
        Angle    147.0428
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4786"
}

Galaxy "IC 4787:ESO 72-4:AM 1850-684"
{
        Type  "Irr"
        RA           18.9342
        Dec         -68.6825
        Distance   2.884e+08  # distance uncertain!
        Radius     5.454e+04
        AbsMag        -20.13
        Axis    [ -0.9274  -0.3464   0.1414]
        Angle    138.7764
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4787"
}

Galaxy "IC 4788:ESO 104-21:FGCE 1333"
{
        Type  "Sc"
        RA           18.9111
        Dec         -63.4525
        Distance   3.369e+08  # distance uncertain!
        Radius     7.839e+04
        AbsMag        -19.07
        Axis    [  0.1915  -0.5880  -0.7859]
        Angle     98.4940
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4788"
}

Galaxy "IC 4789:ESO 72-5:AM 1851-683:IRAS 18509-6838"
{
        Type  "Sc"
        RA           18.9383
        Dec         -68.5672
        Distance     1.7e+08  # method: T-F
        Radius     3.709e+04
        AbsMag        -19.58
        Axis    [ -0.7871  -0.5482   0.2828]
        Angle    148.2804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4789"
}

Galaxy "IC 4790:ESO 104-23:IRAS 18516-6459"
{
        Type  "Sc"
        RA           18.9422
        Dec         -64.9283
        Distance   1.934e+08  # method: T-F
        Radius     3.375e+04
        AbsMag        -19.86
        Axis    [ -0.3457  -0.6823  -0.6441]
        Angle    115.9092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4790"
}

Galaxy "IC 4791"
{
        Type  "E0"
        RA           18.8169
        Dec          19.3317
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [ -0.0783  -0.9134  -0.3994]
        Angle    188.3404
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4791"
}

Galaxy "IC 4792:ESO 183-26:IRAS 18514-5628"
{
        Type  "S0"
        RA           18.9283
        Dec         -56.4039
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.6268  -0.7255   0.2842]
        Angle    134.7501
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4792"
}

Galaxy "IC 4793:ESO 141-12:IRAS 18523-6127"
{
        Type  "Sc"
        RA           18.9486
        Dec         -61.3997
        Distance   1.688e+08  # distance uncertain!
        Radius     2.947e+04
        AbsMag        -19.07
        Axis    [ -0.6349  -0.7697  -0.0671]
        Angle    119.8177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4793"
}

Galaxy "IC 4794:ESO 141-13"
{
        Type  "S0"
        RA           18.9525
        Dec         -62.0903
        Distance   1.404e+08  # distance uncertain!
        Radius     1.838e+04
        AbsMag        -19.07
        Axis    [ -0.0666  -0.6056  -0.7930]
        Angle    119.2134
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4794"
}

Galaxy "IC 4795:ESO 141-14"
{
        Type  "S0"
        RA           18.9544
        Dec         -61.6089
        Distance   3.072e+08  # distance uncertain!
        Radius     4.915e+04
        AbsMag        -19.07
        Axis    [ -0.2350  -0.8939  -0.3819]
        Angle    100.5381
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4795"
}

Galaxy "IC 4796:ESO 183-28:AM 1852-542"
{
        Type  "S0"
        RA           18.9408
        Dec         -54.2133
        Distance   1.354e+08  # method: V
        Radius      3.15e+04
        AbsMag        -19.79
        Axis    [ -0.7664  -0.6394   0.0621]
        Angle    121.6291
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4796"
}

Galaxy "IC 4797:ESO 183-29:AM 1852-542"
{
        Type  "E0"
        RA           18.9414
        Dec         -54.3047
        Distance    9.15e+07  # method: S
        Radius     2.795e+04
        AbsMag        -19.94
        Axis    [ -0.9725  -0.1758  -0.1530]
        Angle    124.6482
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4797"
}

Galaxy "IC 4798:ESO 141-15:IRAS 18536-6211"
{
        Type  "S0"
        RA           18.9725
        Dec         -62.1178
        Distance   2.042e+08  # method: V
        Radius     4.454e+04
        AbsMag        -20.78
        Axis    [ -0.6390  -0.7394  -0.2121]
        Angle    118.0976
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4798"
}

Galaxy "IC 4799:ESO 104-27:FAIR 335:AM 1854-640"
{
        Type  "SBb"
        RA           18.9822
        Dec         -63.9306
        Distance   5.436e+07  # method: T-F
        Radius     1.186e+04
        AbsMag        -17.11
        Axis    [ -0.1853  -0.5655  -0.8037]
        Angle    129.1632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4799"
}

Galaxy "IC 4800:ESO 104-25:AM 1854-631"
{
        Type  "SBa"
        RA           18.9786
        Dec         -63.1392
        Distance   2.061e+08  # method: V
        Radius     5.395e+04
        AbsMag         -20.9
        Axis    [ -0.8027  -0.5510   0.2282]
        Angle    138.0067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4800"
}

Galaxy "IC 4801:ESO 104-28"
{
        Type  "Sa"
        RA           18.9939
        Dec         -64.6747
        Distance   1.994e+08  # method: V
        Radius     5.221e+04
        AbsMag        -20.33
        Axis    [ -0.5658  -0.7308  -0.3818]
        Angle    116.5519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4801"
}

Galaxy "IC 4803-1:ESO 141-17:AM 1856-620"
{
        Type  "SBc"
        RA           19.0142
        Dec         -62.0611
        Distance   2.934e+08  # distance uncertain!
        Radius     5.121e+04
        AbsMag        -19.07
        Axis    [  0.1264  -0.5683  -0.8131]
        Angle    110.0503
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4803-1"
}

Galaxy "IC 4803-2:ESO 141-17A:AM 1856-620"
{
        Type  "S0"
        RA           19.0150
        Dec         -62.0608
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.7058  -0.7024   0.0922]
        Angle    128.6853
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4803-2"
}

Galaxy "IC 4803-3:ESO 141-17B:AM 1856-620"
{
        Type  "S0"
        RA           19.0108
        Dec         -62.0650
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [  0.1000  -0.5202  -0.8482]
        Angle    121.5018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4803-3"
}

Galaxy "IC 4804:ESO 141-18"
{
        Type  "Sc"
        RA           19.0186
        Dec         -61.8331
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.8924  -0.4510   0.0139]
        Angle    128.9678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4804"
}

Galaxy "IC 4805:ESO 104-30:IRAS 18573-6307"
{
        Type  "S0"
        RA           19.0336
        Dec         -63.0475
        Distance    2.03e+08  # distance uncertain!
        Radius     3.838e+04
        AbsMag        -19.07
        Axis    [  0.0461  -0.6374  -0.7691]
        Angle    105.9251
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4805"
}

Galaxy "IC 4806:ESO 141-20:FAIR 503:FAIR 853"
{
        Type  "Sb"
        RA           19.0250
        Dec         -57.5325
        Distance   1.875e+08  # method: T-F
        Radius     6.274e+04
        AbsMag         -20.6
        Axis    [  0.1948  -0.5964  -0.7787]
        Angle    107.4546
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4806"
}

Galaxy "IC 4807:ESO 183-37:AM 1858-565:IRAS 18580-5700"
{
        Type  "SBc"
        RA           19.0381
        Dec         -56.9300
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [  0.0684  -0.5558  -0.8285]
        Angle    128.8467
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4807"
}

Galaxy "IC 4808:ESO 282-3:IRAS 18574-4523"
{
        Type  "Sc"
        RA           19.0186
        Dec         -45.3142
        Distance    1.89e+08  # method: T-F
        Radius     5.496e+04
        AbsMag        -20.81
        Axis    [ -0.0526  -0.8264  -0.5607]
        Angle    110.3290
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4808"
}

Galaxy "IC 4809:ESO 141-22"
{
        Type  "E0"
        RA           19.0681
        Dec         -62.1942
        Distance   3.631e+08  # distance uncertain!
        Radius     5.281e+04
        AbsMag        -20.13
        Axis    [ -0.2473  -0.4261  -0.8702]
        Angle    174.6216
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4809"
}

Galaxy "IC 4810:ESO 184-2:FGCE 1342"
{
        Type  "SBc"
        RA           19.0500
        Dec         -56.1603
        Distance   1.393e+08  # method: T-F
        Radius     7.089e+04
        AbsMag        -19.35
        Axis    [ -0.5284  -0.8281   0.1871]
        Angle    126.6651
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4810"
}

Galaxy "IC 4811:ESO 104-34:IRAS 19006-6712"
{
        Type  "S0"
        RA           19.0956
        Dec         -67.1342
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.0113  -0.4333  -0.9012]
        Angle    146.0414
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4811"
}

Galaxy "IC 4813:ESO 104-35"
{
        Type  "E0"
        RA           19.0947
        Dec         -66.5228
        Distance   2.754e+08  # distance uncertain!
        Radius     5.609e+04
        AbsMag        -20.13
        Axis    [ -0.4121  -0.3784  -0.8288]
        Angle    166.3966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4813"
}

Galaxy "IC 4814:ESO 141-23:IRAS 19006-5839"
{
        Type  "S0"
        RA           19.0831
        Dec         -58.5797
        Distance   1.493e+08  # method: T-F
        Radius     2.388e+04
        AbsMag           -19
        Axis    [ -0.4689  -0.8489  -0.2441]
        Angle    111.4827
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4814"
}

Galaxy "IC 4815:ESO 141-26"
{
        Type  "S0"
        RA           19.1139
        Dec         -61.7011
        Distance   1.612e+08  # distance uncertain!
        Radius     1.876e+04
        AbsMag        -19.07
        Axis    [ -0.8729  -0.4524   0.1827]
        Angle    133.9937
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4815"
}

Galaxy "IC 4816"
{
        Type  "S0"
        RA           19.0289
        Dec         -13.1472
        Distance   5.339e+08  # distance uncertain!
        Radius     1.553e+04
        AbsMag        -19.07
        Axis    [  0.0185  -0.9595  -0.2809]
        Angle    114.6028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4816"
}

Galaxy "IC 4817:ESO 184-10:AM 1902-561"
{
        Type  "SBc"
        RA           19.1033
        Dec         -56.1592
        Distance   1.639e+08  # method: T-F
        Radius     3.815e+04
        AbsMag        -19.01
        Axis    [  0.1457  -0.6236  -0.7680]
        Angle    110.9029
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4817"
}

Galaxy "IC 4818:ESO 184-9"
{
        Type  "SBa"
        RA           19.1006
        Dec         -55.1361
        Distance   2.555e+08  # distance uncertain!
        Radius     5.575e+04
        AbsMag        -19.07
        Axis    [ -0.2440  -0.9342  -0.2604]
        Angle    103.6524
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4818"
}

Galaxy "IC 4819:ESO 141-27:FGCE 1346:IRAS 19027-5932"
{
        Type  "Sc"
        RA           19.1186
        Dec         -59.4672
        Distance   9.128e+07  # method: T-F
        Radius      3.85e+04
        AbsMag        -18.13
        Axis    [ -0.5094  -0.8554   0.0933]
        Angle    123.2652
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4819"
}

Galaxy "IC 4820:ESO 104-39:AM 1904-633"
{
        Type  "SBc"
        RA           19.1536
        Dec         -63.4656
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [ -0.7253  -0.6464  -0.2371]
        Angle    123.4289
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4820"
}

Galaxy "IC 4821:ESO 184-17:IRAS 19054-5505"
{
        Type  "Sc"
        RA           19.1589
        Dec         -55.0164
        Distance   1.158e+08  # method: T-F
        Radius     3.031e+04
        AbsMag        -19.15
        Axis    [  0.1659  -0.5763  -0.8002]
        Angle    118.4459
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4821"
}

Galaxy "IC 4822:ESO 45-19"
{
        Type  "S0"
        RA           19.2458
        Dec         -72.4411
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.4888  -0.7354  -0.4693]
        Angle    114.2896
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4822"
}

Galaxy "IC 4823-1:ESO 104-45:AM 1907-640"
{
        Type  "S0"
        RA           19.2044
        Dec         -63.9758
        Distance   5.006e+08  # method: V
        Radius     8.009e+04
        AbsMag        -21.23
        Axis    [ -0.1315  -0.5452  -0.8279]
        Angle    131.9587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4823-1"
}

Galaxy "IC 4823-2:ESO 104-45A:AM 1907-640"
{
        Type  "S0"
        RA           19.2039
        Dec         -63.9836
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.0034  -0.4647  -0.8855]
        Angle    143.9907
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4823-2"
}

Galaxy "IC 4824:ESO 141-33:AM 1908-621"
{
        Type  "Irr"
        RA           19.2206
        Dec         -62.0886
        Distance   4.104e+07  # method: V
        Radius     1.015e+04
        AbsMag         -13.7
        Axis    [ -0.6470  -0.7220  -0.2452]
        Angle    120.1587
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4824"
}

Galaxy "IC 4825:ESO 45-20"
{
        Type  "S0"
        RA           19.2875
        Dec         -72.7489
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.0237  -0.4092  -0.9122]
        Angle    137.1229
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4825"
}

Galaxy "IC 4826:ESO 184-27"
{
        Type  "Sb"
        RA           19.2058
        Dec         -57.2025
        Distance   1.688e+08  # distance uncertain!
        Radius     3.438e+04
        AbsMag        -19.07
        Axis    [ -0.2302  -0.7184  -0.6564]
        Angle    117.8973
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4826"
}

Galaxy "IC 4827:ESO 141-34:IRAS 19088-6056"
{
        Type  "Sb"
        RA           19.2225
        Dec         -60.8594
        Distance   1.877e+08  # method: T-F
        Radius     7.643e+04
        AbsMag         -20.5
        Axis    [ -0.6146  -0.7045   0.3549]
        Angle    148.5789
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4827"
}

Galaxy "IC 4828:ESO 141-36:AM 1909-621"
{
        Type  "S0"
        RA           19.2278
        Dec         -62.0822
        Distance   1.753e+08  # method: V
        Radius     2.805e+04
        AbsMag        -18.85
        Axis    [ -0.3854  -0.7834  -0.4875]
        Angle    112.1972
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4828"
}

Galaxy "IC 4829:ESO 184-31"
{
        Type  "Sb"
        RA           19.2092
        Dec         -56.5400
        Distance   1.851e+08  # distance uncertain!
        Radius     5.116e+04
        AbsMag        -19.07
        Axis    [  0.1195  -0.7227  -0.6808]
        Angle    101.5479
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4829"
}

Galaxy "IC 4830:ESO 141-37:IRAS 19094-5922"
{
        Type  "SBc"
        RA           19.2300
        Dec         -59.2944
        Distance   2.214e+08  # method: T-F
        Radius     5.474e+04
        AbsMag        -21.16
        Axis    [ -0.1921  -0.5933  -0.7817]
        Angle    133.1736
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4830"
}

Galaxy "IC 4831:ESO 141-38:AM 1910-622:IRAS 19101-6221"
{
        Type  "Sb"
        RA           19.2456
        Dec         -62.2719
        Distance   1.736e+08  # method: T-F
        Radius     8.837e+04
        AbsMag        -21.13
        Axis    [ -0.5237  -0.8503  -0.0519]
        Angle    119.1943
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4831"
}

Galaxy "IC 4832:ESO 184-39:IRAS 19098-5641"
{
        Type  "Sb"
        RA           19.2342
        Dec         -56.6097
        Distance   1.538e+08  # method: V
        Radius      4.92e+04
        AbsMag        -19.57
        Axis    [ -0.5762  -0.7814   0.2394]
        Angle    132.6881
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4832"
}

Galaxy "IC 4833:ESO 141-40:AM 1911-622:IRAS 19111-6225"
{
        Type  "Irr"
        RA           19.2614
        Dec         -62.3292
        Distance   1.612e+08  # method: V
        Radius     1.641e+04
        AbsMag        -18.77
        Axis    [ -0.6812  -0.6583  -0.3204]
        Angle    122.9294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4833"
}

Galaxy "IC 4834:ESO 104-47:IRAS 19117-6405"
{
        Type  "S0"
        RA           19.2753
        Dec         -64.0064
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.6854  -0.7279  -0.0176]
        Angle    126.4184
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4834"
}

Galaxy "IC 4835:ESO 141-41"
{
        Type  "S0"
        RA           19.2575
        Dec         -58.2375
        Distance   1.851e+08  # distance uncertain!
        Radius     2.154e+04
        AbsMag        -19.07
        Axis    [ -0.8630  -0.4412   0.2461]
        Angle    133.3981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4835"
}

Galaxy "IC 4836:ESO 141-43:IRAS 19118-6017"
{
        Type  "SBc"
        RA           19.2717
        Dec         -60.2000
        Distance    2.08e+08  # method: V
        Radius     4.538e+04
        AbsMag        -20.72
        Axis    [ -0.1613  -0.4969  -0.8527]
        Angle    154.7540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4836"
}

Galaxy "IC 4837:ESO 184-46:AM 1911-544:IRAS 19112-5444"
{
        Type  "SBc"
        RA           19.2539
        Dec         -54.6619
        Distance   1.181e+08  # method: V
        Radius     3.606e+04
        AbsMag        -19.79
        Axis    [  0.0926  -0.6001  -0.7946]
        Angle    122.6213
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4837"
}

Galaxy "IC 4837A:ESO 184-47:FAIR 859:AM 1911-541"
{
        Type  "Sb"
        RA           19.2542
        Dec         -54.1331
        Distance   1.779e+08  # method: V
        Radius     1.061e+05
        AbsMag        -21.08
        Axis    [ -0.5867  -0.7074   0.3942]
        Angle    144.3901
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4837A"
}

Galaxy "IC 4838:ESO 141-45:AM 1912-614:IRAS 19122-6142"
{
        Type  "Irr"
        RA           19.2794
        Dec         -61.6139
        Distance   1.938e+08  # method: V
        Radius     3.663e+04
        AbsMag        -19.67
        Axis    [ -0.3292  -0.8083  -0.4882]
        Angle    109.8072
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4838"
}

Galaxy "IC 4839:ESO 184-48:AM 1911-544:IRAS 19114-5443"
{
        Type  "SBc"
        RA           19.2592
        Dec         -54.6264
        Distance   4.308e+07  # method: T-F
        Radius     1.379e+04
        AbsMag         -17.4
        Axis    [ -0.8256  -0.5519   0.1177]
        Angle    125.7481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4839"
}

Galaxy "IC 4840:ESO 184-49:IRAS 19116-5617"
{
        Type  "SBa"
        RA           19.2642
        Dec         -56.2086
        Distance    1.54e+08  # distance uncertain!
        Radius     2.463e+04
        AbsMag        -19.07
        Axis    [ -0.7522  -0.6588   0.0105]
        Angle    123.5819
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4840"
}

Galaxy "IC 4841:ESO 72-14"
{
        Type  "Sc"
        RA           19.3450
        Dec         -72.2264
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.8305  -0.5510  -0.0821]
        Angle    134.6645
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4841"
}

Galaxy "IC 4842:ESO 141-52"
{
        Type  "E0"
        RA           19.3233
        Dec         -60.6442
        Distance    1.84e+08  # method: V
        Radius     4.014e+04
        AbsMag        -20.36
        Axis    [ -0.3235  -0.4338  -0.8409]
        Angle    172.2835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4842"
}

Galaxy "IC 4843:ESO 141-53:IRAS 19149-5924"
{
        Type  "SBa"
        RA           19.3225
        Dec         -59.3092
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [ -0.3541  -0.9193  -0.1716]
        Angle    109.9627
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4843"
}

Galaxy "IC 4844:ESO 184-54"
{
        Type  "SBb"
        RA           19.3172
        Dec         -56.0269
        Distance   1.807e+08  # method: T-F
        Radius     3.679e+04
        AbsMag        -19.72
        Axis    [ -0.8400  -0.4769   0.2586]
        Angle    132.2209
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4844"
}

Galaxy "IC 4845:ESO 141-54:IRAS 19159-6028"
{
        Type  "SBb"
        RA           19.3394
        Dec         -60.3889
        Distance   1.764e+08  # method: V
        Radius     3.848e+04
        AbsMag        -21.26
        Axis    [ -0.5906  -0.7091  -0.3852]
        Angle    120.6500
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4845"
}

Galaxy "IC 4847:ESO 104-49:FAIR 337"
{
        Type  "S0"
        RA           19.3919
        Dec         -65.5064
        Distance   1.928e+08  # method: V
        Radius     2.524e+04
        AbsMag        -18.86
        Axis    [ -0.8409  -0.5034   0.1988]
        Angle    139.5633
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4847"
}

Galaxy "IC 4848:ESO 184-61:AM 1918-565:IRAS 19188-5652"
{
        Type  "S0"
        RA           19.3817
        Dec         -56.7806
        Distance    2.03e+08  # distance uncertain!
        Radius     2.066e+04
        AbsMag        -19.07
        Axis    [ -0.2080  -0.6432  -0.7369]
        Angle    129.5804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4848"
}

Galaxy "IC 4849:ESO 104-54:IRAS 19209-6301"
{
        Type  "S0"
        RA           19.4264
        Dec         -62.9328
        Distance   1.688e+08  # distance uncertain!
        Radius     2.701e+04
        AbsMag        -19.07
        Axis    [ -0.6529  -0.7542  -0.0694]
        Angle    124.2278
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4849"
}

Galaxy "IC 4851:ESO 142-3"
{
        Type  "SBb"
        RA           19.4247
        Dec         -57.6708
        Distance    1.47e+08  # distance uncertain!
        Radius     3.422e+04
        AbsMag        -19.07
        Axis    [  0.0606  -0.6352  -0.7700]
        Angle    114.9684
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4851"
}

Galaxy "IC 4852:ESO 142-6:AM 1922-602:IRAS 19220-6026"
{
        Type  "SBc"
        RA           19.4403
        Dec         -60.3361
        Distance   2.033e+08  # method: V
        Radius     4.436e+04
        AbsMag        -20.37
        Axis    [ -0.9033  -0.2928   0.3136]
        Angle    136.5149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4852"
}

Galaxy "IC 4853:ESO 72-16:IRAS 19253-7110"
{
        Type  "S0"
        RA           19.5131
        Dec         -71.0703
        Distance    2.03e+08  # distance uncertain!
        Radius     3.247e+04
        AbsMag        -19.07
        Axis    [ -0.6967  -0.6421   0.3198]
        Angle    157.4443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4853"
}

Galaxy "IC 4854:IC 4855:ESO 142-7:FAIR 58"
{
        Type  "Sc"
        RA           19.4558
        Dec         -59.3150
        Distance   1.223e+08  # distance uncertain!
        Radius     2.312e+04
        AbsMag        -19.07
        Axis    [ -0.2977  -0.5350  -0.7907]
        Angle    148.0401
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4854"
}

Galaxy "IC 4856:ESO 184-69"
{
        Type  "Irr"
        RA           19.4583
        Dec         -54.9086
        Distance   1.421e+08  # method: V
        Radius     2.687e+04
        AbsMag         -18.7
        Axis    [ -0.1082  -0.7330  -0.6716]
        Angle    116.4804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4856"
}

Galaxy "IC 4857:IC 4858:ESO 142-12:AM 1924-585"
{
        Type  "SBc"
        RA           19.4775
        Dec         -58.7681
        Distance   1.788e+08  # method: T-F
        Radius     4.682e+04
        AbsMag        -19.89
        Axis    [ -0.2323  -0.6571  -0.7171]
        Angle    126.1599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4857"
}

Galaxy "IC 4859:ESO 104-58:IRAS 19258-6625"
{
        Type  "SBa"
        RA           19.5128
        Dec         -66.3136
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.2336  -0.6467  -0.7261]
        Angle    118.5920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4859"
}

Galaxy "IC 4860:ESO 105-1:AM 1926-672:IRAS 19263-6728"
{
        Type  "SBc"
        RA           19.5242
        Dec         -67.3681
        Distance   2.179e+08  # method: V
        Radius     3.169e+04
        AbsMag        -19.42
        Axis    [ -0.8807  -0.4733   0.0205]
        Angle    135.4387
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4860"
}

Galaxy "IC 4861:ESO 142-15"
{
        Type  "Sc"
        RA           19.4878
        Dec         -57.5761
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [ -0.0123  -0.7510  -0.6602]
        Angle    106.9661
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4861"
}

Galaxy "IC 4862:ESO 105-3:AM 1926-672:IRAS 19266-6726"
{
        Type  "SBc"
        RA           19.5278
        Dec         -67.3228
        Distance   2.352e+08  # method: T-F
        Radius      4.79e+04
        AbsMag        -19.69
        Axis    [  0.0993  -0.5404  -0.8355]
        Angle    107.6004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4862"
}

Galaxy "IC 4864:ESO 25-13:AM 1932-774"
{
        Type  "SBa"
        RA           19.6683
        Dec         -77.5572
        Distance    2.03e+08  # distance uncertain!
        Radius     4.428e+04
        AbsMag        -19.07
        Axis    [ -0.7136  -0.6135   0.3383]
        Angle    167.9008
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4864"
}

Galaxy "IC 4866:ESO 142-21:IRAS 19301-6115"
{
        Type  "Sb"
        RA           19.5761
        Dec         -61.1458
        Distance   1.873e+08  # method: V
        Radius     4.087e+04
        AbsMag         -19.9
        Axis    [ -0.8532  -0.4562   0.2529]
        Angle    137.6632
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4866"
}

Galaxy "IC 4869:ESO 142-25:AM 1931-610:IRAS 19316-6108"
{
        Type  "Irr"
        RA           19.6006
        Dec         -61.0281
        Distance   7.833e+07  # method: V
        Radius     1.253e+04
        AbsMag         -18.3
        Axis    [ -0.6492  -0.5504  -0.5249]
        Angle    134.4143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4869"
}

Galaxy "IC 4870:ESO 105-11:AM 1932-655:IRAS 19327-6555"
{
        Type  "Irr"
        RA           19.6269
        Dec         -65.8111
        Distance   3.796e+07  # method: V
        Radius          8834
        AbsMag        -15.83
        Axis    [ -0.7687  -0.6359   0.0695]
        Angle    134.6331
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4870"
}

Galaxy "IC 4871:IC 4872:ESO 142-24:FGCE 1382"
{
        Type  "SBc"
        RA           19.5950
        Dec         -57.5189
        Distance   1.153e+08  # method: T-F
        Radius     5.869e+04
        AbsMag        -18.74
        Axis    [  0.1847  -0.6327  -0.7520]
        Angle    105.1159
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4871"
}

Galaxy "IC 4873:ESO 283-8:IRAS 19313-4614"
{
        Type  "Sc"
        RA           19.5817
        Dec         -46.1361
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.1066  -0.7083  -0.6978]
        Angle    132.1027
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4873"
}

Galaxy "IC 4874:ESO 283-11"
{
        Type  "Sc"
        RA           19.6058
        Dec         -47.2658
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.3190  -0.8191  -0.4768]
        Angle    119.3708
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4874"
}

Galaxy "IC 4875:ESO 232-12"
{
        Type  "Irr"
        RA           19.6272
        Dec         -52.0753
        Distance   2.754e+08  # distance uncertain!
        Radius     2.804e+04
        AbsMag        -20.13
        Axis    [ -0.4327  -0.8098  -0.3963]
        Angle    118.2050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4875"
}

Galaxy "IC 4876:ESO 185-4:AM 1933-525:IRAS 19338-5257"
{
        Type  "SBc"
        RA           19.6283
        Dec         -52.8431
        Distance    2.48e+08  # method: T-F
        Radius     4.689e+04
        AbsMag         -20.1
        Axis    [ -0.7303  -0.6815  -0.0462]
        Angle    122.9983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4876"
}

Galaxy "IC 4877:ESO 232-14:IRAS 19341-5206"
{
        Type  "S0"
        RA           19.6319
        Dec         -51.9914
        Distance   1.768e+08  # distance uncertain!
        Radius     3.343e+04
        AbsMag        -19.07
        Axis    [ -0.2710  -0.9488  -0.1622]
        Angle    110.7712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4877"
}

Galaxy "IC 4878:ESO 142-29:IRAS 19346-5820"
{
        Type  "S0"
        RA           19.6469
        Dec         -58.2272
        Distance   2.226e+08  # distance uncertain!
        Radius     4.855e+04
        AbsMag        -19.07
        Axis    [ -0.1172  -0.8138  -0.5692]
        Angle    107.1025
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4878"
}

Galaxy "IC 4879:ESO 232-16:AM 1935-522:IRAS 19357-5229"
{
        Type  "S0"
        RA           19.6600
        Dec         -52.3689
        Distance   1.688e+08  # distance uncertain!
        Radius      2.21e+04
        AbsMag        -19.07
        Axis    [ -0.4196  -0.8590  -0.2933]
        Angle    115.5472
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4879"
}

Galaxy "IC 4880:ESO 185-10"
{
        Type  "SBa"
        RA           19.6750
        Dec         -56.4097
        Distance    1.54e+08  # distance uncertain!
        Radius     3.807e+04
        AbsMag        -19.07
        Axis    [ -0.4953  -0.8657   0.0717]
        Angle    124.4053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4880"
}

Galaxy "IC 4881:ESO 185-8:IRAS 19363-5558"
{
        Type  "SBc"
        RA           19.6739
        Dec         -55.8575
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.7549  -0.5925   0.2811]
        Angle    135.9198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4881"
}

Galaxy "IC 4882:ESO 185-9:FAIR 519:IRAS 19363-5518"
{
        Type  "SBb"
        RA           19.6731
        Dec         -55.1964
        Distance   1.768e+08  # distance uncertain!
        Radius     2.571e+04
        AbsMag        -19.07
        Axis    [ -0.8631  -0.4178   0.2837]
        Angle    132.4712
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4882"
}

Galaxy "IC 4883:ESO 185-11:IRAS 19379-5539"
{
        Type  "SBb"
        RA           19.7000
        Dec         -55.5453
        Distance   2.129e+08  # method: T-F
        Radius     4.335e+04
        AbsMag        -19.47
        Axis    [ -0.6713  -0.6397   0.3743]
        Angle    143.7439
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4883"
}

Galaxy "IC 4884:ESO 142-33"
{
        Type  "S0"
        RA           19.7114
        Dec         -58.1286
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.6606  -0.6427   0.3879]
        Angle    148.4920
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4884"
}

Galaxy "IC 4885:ESO 142-36"
{
        Type  "Sc"
        RA           19.7308
        Dec         -60.6514
        Distance   1.283e+08  # method: T-F
        Radius     3.547e+04
        AbsMag        -18.37
        Axis    [ -0.4865  -0.8726   0.0441]
        Angle    125.2788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4885"
}

Galaxy "IC 4886:ESO 232-18:AM 1939-515:AM 1941-515"
{
        Type  "Sb"
        RA           19.7206
        Dec         -51.8072
        Distance    1.47e+08  # distance uncertain!
        Radius     2.994e+04
        AbsMag        -19.07
        Axis    [ -0.5827  -0.8094  -0.0723]
        Angle    120.5147
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4886"
}

Galaxy "IC 4887:ESO 73-9"
{
        Type  "SBa"
        RA           19.8058
        Dec         -69.5869
        Distance    1.47e+08  # distance uncertain!
        Radius     2.139e+04
        AbsMag        -19.07
        Axis    [ -0.7529  -0.5608  -0.3445]
        Angle    131.9803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4887"
}

Galaxy "IC 4888:ESO 185-12"
{
        Type  "S0"
        RA           19.7478
        Dec         -54.4564
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [ -0.6286  -0.7276  -0.2748]
        Angle    122.9772
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4888"
}

Galaxy "IC 4889:IC 4891:ESO 185-14:AM 1941-542"
{
        Type  "E5"
        RA           19.7542
        Dec         -54.3436
        Distance   9.538e+07  # method: S
        Radius     3.052e+04
        AbsMag        -20.23
        Axis    [ -0.2264  -0.4803  -0.8474]
        Angle    182.7757
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4889"
}

Galaxy "IC 4890:ESO 185-16:AM 1941-564"
{
        Type  "SBb"
        RA           19.7597
        Dec         -56.5447
        Distance   1.851e+08  # distance uncertain!
        Radius     2.962e+04
        AbsMag        -19.07
        Axis    [ -0.5928  -0.6564  -0.4666]
        Angle    128.8801
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4890"
}

Galaxy "IC 4892:ESO 73-11"
{
        Type  "Sc"
        RA           19.8253
        Dec         -70.2278
        Distance   1.592e+08  # method: T-F
        Radius     3.704e+04
        AbsMag        -18.04
        Axis    [  0.0902  -0.5721  -0.8152]
        Angle     99.4996
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4892"
}

Galaxy "IC 4893:ESO 46-4"
{
        Type  "E0"
        RA           19.8422
        Dec         -72.5100
        Distance   6.026e+08  # distance uncertain!
        Radius     4.382e+04
        AbsMag        -20.13
        Axis    [ -0.2385  -0.3395  -0.9098]
        Angle    178.5798
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4893"
}

Galaxy "IC 4894:ESO 232-25:AM 1943-515:IRAS 19431-5158"
{
        Type  "SBb"
        RA           19.7828
        Dec         -51.8467
        Distance   1.768e+08  # distance uncertain!
        Radius     2.314e+04
        AbsMag        -19.07
        Axis    [ -0.7878  -0.4500   0.4206]
        Angle    137.8191
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4894"
}

Galaxy "IC 4896:ESO 142-45"
{
        Type  "Sb"
        RA           19.8181
        Dec         -58.9814
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.0662  -0.5702  -0.8188]
        Angle    134.6241
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4896"
}

Galaxy "IC 4897:ESO 233-1"
{
        Type  "SBb"
        RA           19.8219
        Dec         -51.8678
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [ -0.6843  -0.7289  -0.0202]
        Angle    123.7451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4897"
}

Galaxy "IC 4899:ESO 73-15"
{
        Type  "S0"
        RA           19.9072
        Dec         -70.5897
        Distance   1.908e+08  # method: V
        Radius     2.775e+04
        AbsMag        -19.34
        Axis    [ -0.1522  -0.4949  -0.8555]
        Angle    132.4121
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4899"
}

Galaxy "IC 4900-1:ESO 233-2:AM 1946-512"
{
        Type  "S0"
        RA           19.8394
        Dec         -51.3458
        Distance   3.694e+08  # distance uncertain!
        Radius      3.76e+04
        AbsMag        -19.07
        Axis    [ -0.6267  -0.5956   0.5025]
        Angle    152.1239
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4900-1"
}

Galaxy "IC 4900-2:ESO 233-2A:AM 1946-512"
{
        Type  "S0"
        RA           19.8397
        Dec         -51.3408
        Distance   5.339e+08  # distance uncertain!
        Radius     2.329e+04
        AbsMag        -19.07
        Axis    [ -0.5838  -0.7679  -0.2638]
        Angle    122.1117
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4900-2"
}

Galaxy "IC 4901:ESO 142-50:AM 1950-585:IRAS 19501-5850"
{
        Type  "Sc"
        RA           19.9064
        Dec         -58.7133
        Distance   7.683e+07  # method: T-F
        Radius     4.246e+04
        AbsMag        -19.56
        Axis    [ -0.7843  -0.6203   0.0058]
        Angle    129.6833
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4901"
}

Galaxy "IC 4902:ESO 185-24"
{
        Type  "S0"
        RA           19.9067
        Dec         -56.3794
        Distance   3.527e+08  # distance uncertain!
        Radius     3.591e+04
        AbsMag        -19.07
        Axis    [ -0.0355  -0.6764  -0.7357]
        Angle    119.9676
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4902"
}

Galaxy "IC 4903:ESO 73-16"
{
        Type  "Sb"
        RA           19.9703
        Dec         -70.4533
        Distance    2.33e+08  # distance uncertain!
        Radius     4.745e+04
        AbsMag        -19.07
        Axis    [ -0.6936  -0.5930   0.4089]
        Angle    166.2922
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4903"
}

Galaxy "IC 4904:ESO 73-17"
{
        Type  "S0"
        RA           19.9775
        Dec         -70.1844
        Distance   1.938e+08  # distance uncertain!
        Radius     2.819e+04
        AbsMag        -19.07
        Axis    [ -0.5835  -0.5675  -0.5809]
        Angle    132.7334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4904"
}

Galaxy "IC 4905:ESO 142-55"
{
        Type  "S0"
        RA           19.9350
        Dec         -61.2208
        Distance   3.217e+08  # distance uncertain!
        Radius      6.55e+04
        AbsMag        -19.07
        Axis    [ -0.5105  -0.8557   0.0847]
        Angle    129.8441
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4905"
}

Galaxy "IC 4906:ESO 142-57:FAIR 64:AM 1952-603"
{
        Type  "S0"
        RA           19.9464
        Dec         -60.4686
        Distance   1.669e+08  # method: V
        Radius     3.885e+04
        AbsMag        -20.55
        Axis    [ -0.4813  -0.7633  -0.4309]
        Angle    121.3746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4906"
}

Galaxy "IC 4907:ESO 185-28"
{
        Type  "S0"
        RA           19.9369
        Dec         -52.4536
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [ -0.0645  -0.5669  -0.8213]
        Angle    149.6675
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4907"
}

Galaxy "IC 4908:ESO 185-30:FAIR 522"
{
        Type  "S0"
        RA           19.9489
        Dec         -55.7911
        Distance   2.379e+08  # method: V
        Radius     2.076e+04
        AbsMag        -19.31
        Axis    [ -0.2389  -0.4729  -0.8481]
        Angle    180.1698
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4908"
}

Galaxy "IC 4909:ESO 233-8:FAIR 875"
{
        Type  "Sc"
        RA           19.9458
        Dec         -50.0553
        Distance   3.615e+08  # method: V
        Radius     4.733e+04
        AbsMag        -20.62
        Axis    [ -0.4348  -0.8711  -0.2282]
        Angle    118.5112
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4909"
}

Galaxy "IC 4910:ESO 185-33"
{
        Type  "SBa"
        RA           19.9631
        Dec         -56.8633
        Distance   2.802e+08  # distance uncertain!
        Radius     2.038e+04
        AbsMag        -19.07
        Axis    [ -0.8170  -0.5762  -0.0221]
        Angle    128.9971
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4910"
}

Galaxy "IC 4911:ESO 233-9"
{
        Type  "S0"
        RA           19.9614
        Dec         -51.9864
        Distance   3.527e+08  # distance uncertain!
        Radius     3.078e+04
        AbsMag        -19.07
        Axis    [ -0.8378  -0.5416   0.0685]
        Angle    126.7399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4911"
}

Galaxy "IC 4912:ESO 25-16"
{
        Type  "Sc"
        RA           20.1136
        Dec         -77.3575
        Distance   2.225e+08  # method: T-F
        Radius      3.56e+04
        AbsMag        -18.67
        Axis    [ -0.3541  -0.6839  -0.6379]
        Angle    111.1690
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4912"
}

Galaxy "IC 4913:ESO 399-5:MCG 6-43-13"
{
        Type  "S0"
        RA           19.9464
        Dec         -37.3286
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [ -0.6492  -0.7412   0.1704]
        Angle    119.6780
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4913"
}

Galaxy "IC 4914:ESO 233-11"
{
        Type  "S0"
        RA           19.9656
        Dec         -50.1311
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [ -0.0613  -0.5823  -0.8106]
        Angle    150.7366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4914"
}

Galaxy "IC 4915:ESO 185-38:FAIR 876:AM 1954-524"
{
        Type  "S0"
        RA           19.9753
        Dec         -52.6425
        Distance   6.926e+08  # method: V
        Radius     1.007e+05
        AbsMag        -21.83
        Axis    [ -0.6740  -0.7222  -0.1554]
        Angle    124.6215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4915"
}

Galaxy "IC 4916:ESO 233-13"
{
        Type  "Sb"
        RA           19.9719
        Dec         -50.2719
        Distance   2.184e+08  # method: V
        Radius     2.224e+04
        AbsMag        -19.73
        Axis    [ -0.0708  -0.6213  -0.7803]
        Angle    141.8090
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4916"
}

Galaxy "IC 4917-1:ESO 233-15"
{
        Type  "S0"
        RA           19.9817
        Dec         -52.2731
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [ -0.1085  -0.5550  -0.8248]
        Angle    156.5751
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4917-1"
}

Galaxy "IC 4917-2:AM 1955-522"
{
        Type  "S0"
        RA           19.9800
        Dec         -52.2764
        Distance   3.369e+08  # distance uncertain!
        Radius      2.45e+04
        AbsMag        -19.07
        Axis    [ -0.5996  -0.7890   0.1337]
        Angle    128.5625
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4917-2"
}

Galaxy "IC 4918:ESO 233-16"
{
        Type  "S0"
        RA           19.9869
        Dec         -52.2750
        Distance   3.527e+08  # distance uncertain!
        Radius     2.565e+04
        AbsMag        -19.07
        Axis    [ -0.6513  -0.7568  -0.0557]
        Angle    124.4369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4918"
}

Galaxy "IC 4919:ESO 185-43:AM 1956-553"
{
        Type  "SBc"
        RA           20.0025
        Dec         -55.3739
        Distance   2.125e+08  # distance uncertain!
        Radius     4.637e+04
        AbsMag        -19.07
        Axis    [ -0.1609  -0.7433  -0.6494]
        Angle    120.2931
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4919"
}

Galaxy "IC 4920:ESO 185-44"
{
        Type  "S0"
        RA           20.0022
        Dec         -53.3842
        Distance   4.441e+08  # distance uncertain!
        Radius     3.875e+04
        AbsMag        -19.07
        Axis    [ -0.2104  -0.7692  -0.6034]
        Angle    121.4070
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4920"
}

Galaxy "IC 4921:ESO 73-20:IRAS 19583-6758"
{
        Type  "S0"
        RA           20.0553
        Dec         -67.8258
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.7765  -0.6238   0.0890]
        Angle    138.9945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4921"
}

Galaxy "IC 4923:ESO 185-45:FAIR 880"
{
        Type  "S0"
        RA           20.0158
        Dec         -52.6319
        Distance   2.984e+08  # method: V
        Radius      4.34e+04
        AbsMag        -20.31
        Axis    [ -0.7027  -0.6111  -0.3645]
        Angle    131.4399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4923"
}

Galaxy "IC 4925:ESO 185-46:FAIR 525"
{
        Type  "S0"
        RA           20.0192
        Dec         -52.8667
        Distance    4.05e+08  # distance uncertain!
        Radius     5.301e+04
        AbsMag        -19.07
        Axis    [ -0.5745  -0.6828   0.4514]
        Angle    151.7809
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4925"
}

Galaxy "IC 4926:ESO 339-18:MCG 6-44-5"
{
        Type  "E0"
        RA           20.0033
        Dec         -38.5781
        Distance   2.443e+08  # method: V
        Radius     4.263e+04
        AbsMag        -20.67
        Axis    [ -0.5038  -0.5789  -0.6411]
        Angle    163.6873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4926"
}

Galaxy "IC 4927:ESO 185-48"
{
        Type  "Sb"
        RA           20.0303
        Dec         -53.9183
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [ -0.6435  -0.6351   0.4272]
        Angle    148.0912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4927"
}

Galaxy "IC 4928:ESO 46-6:IRAS 20034-7727"
{
        Type  "S0"
        RA           20.1697
        Dec         -77.3092
        Distance   4.241e+08  # distance uncertain!
        Radius     4.318e+04
        AbsMag        -19.07
        Axis    [ -0.2096  -0.6524  -0.7283]
        Angle    105.0293
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4928"
}

Galaxy "IC 4929:ESO 73-22:IRAS 20011-7149"
{
        Type  "Sb"
        RA           20.1117
        Dec         -71.6811
        Distance   1.698e+08  # method: T-F
        Radius     3.457e+04
        AbsMag        -19.28
        Axis    [ -0.1237  -0.6574  -0.7434]
        Angle    106.4594
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4929"
}

Galaxy "IC 4931:ESO 339-23:MCG 6-44-8"
{
        Type  "E0"
        RA           20.0139
        Dec         -38.5750
        Distance    2.61e+08  # method: V
        Radius      9.11e+04
        AbsMag        -21.62
        Axis    [ -0.9207  -0.3667  -0.1334]
        Angle    120.3893
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4931"
}

Galaxy "IC 4932:ESO 185-49:FAIR 881"
{
        Type  "Sa"
        RA           20.0375
        Dec         -52.8467
        Distance   6.336e+08  # method: V
        Radius     7.373e+04
        AbsMag        -20.94
        Axis    [ -0.0377  -0.6151  -0.7875]
        Angle    135.9366
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4932"
}

Galaxy "IC 4933:ESO 185-55:FAIR 338:AM 1959-550"
{
        Type  "SBc"
        RA           20.0578
        Dec         -54.9800
        Distance   2.653e+08  # method: T-F
        Radius     7.331e+04
        AbsMag        -21.55
        Axis    [ -0.1359  -0.5333  -0.8349]
        Angle    157.7886
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4933"
}

Galaxy "IC 4934:ESO 73-23:FGCE 1430"
{
        Type  "Sc"
        RA           20.1206
        Dec         -69.4803
        Distance   1.742e+08  # method: T-F
        Radius     4.054e+04
        AbsMag        -18.74
        Axis    [ -0.1703  -0.7388  -0.6520]
        Angle    105.6729
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4934"
}

Galaxy "IC 4935:ESO 143-3:AM 2000-574"
{
        Type  "SBa"
        RA           20.0761
        Dec         -57.5986
        Distance   2.028e+08  # method: V
        Radius     5.014e+04
        AbsMag        -19.97
        Axis    [ -0.6147  -0.6159   0.4927]
        Angle    161.2083
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4935"
}

Galaxy "IC 4936:ESO 143-6:AM 2001-613"
{
        Type  "SBc"
        RA           20.0978
        Dec         -61.4283
        Distance   1.343e+08  # method: T-F
        Radius     2.929e+04
        AbsMag        -18.47
        Axis    [ -0.0850  -0.6067  -0.7904]
        Angle    125.5965
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4936"
}

Galaxy "IC 4937:ESO 185-60:IRAS 20012-5623"
{
        Type  "Sb"
        RA           20.0881
        Dec         -56.2561
        Distance    2.03e+08  # distance uncertain!
        Radius     5.609e+04
        AbsMag        -19.07
        Axis    [  0.1430  -0.6537  -0.7431]
        Angle    109.1576
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4937"
}

Galaxy "IC 4938:ESO 143-7:FAIR 66:AM 2001-602"
{
        Type  "SBb"
        RA           20.1031
        Dec         -60.2111
        Distance   1.634e+08  # method: V
        Radius      3.09e+04
        AbsMag         -20.1
        Axis    [ -0.3435  -0.5796  -0.7390]
        Angle    142.0803
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4938"
}

Galaxy "IC 4939:ESO 143-8"
{
        Type  "Sc"
        RA           20.1197
        Dec         -60.7383
        Distance   1.815e+08  # method: T-F
        Radius     3.431e+04
        AbsMag        -18.63
        Axis    [ -0.7225  -0.6059   0.3329]
        Angle    146.6044
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4939"
}

Galaxy "IC 4941:ESO 185-66:AM 2002-524"
{
        Type  "SBc"
        RA           20.1161
        Dec         -53.6528
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.0807  -0.5677  -0.8193]
        Angle    147.9130
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4941"
}

Galaxy "IC 4942:ESO 185-65:AM 2002-524"
{
        Type  "SBb"
        RA           20.1136
        Dec         -52.6103
        Distance   3.868e+08  # distance uncertain!
        Radius     3.938e+04
        AbsMag        -19.07
        Axis    [ -0.6985  -0.7027   0.1351]
        Angle    129.9952
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4942"
}

Galaxy "IC 4943:ESO 233-28"
{
        Type  "E0"
        RA           20.1078
        Dec         -48.3758
        Distance   1.022e+08  # method: S
        Radius     2.081e+04
        AbsMag        -18.88
        Axis    [ -0.5227  -0.5074  -0.6850]
        Angle    165.3204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4943"
}

Galaxy "IC 4944:ESO 185-67:AM 2006-524:IRAS 20032-5435"
{
        Type  "Sa"
        RA           20.1192
        Dec         -54.4467
        Distance   2.552e+08  # method: V
        Radius     3.711e+04
        AbsMag        -19.87
        Axis    [  0.0284  -0.6496  -0.7598]
        Angle    122.4446
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4944"
}

Galaxy "IC 4945:NGC 6876A:ESO 73-25"
{
        Type  "Sb"
        RA           20.1881
        Dec         -71.0128
        Distance   2.008e+08  # method: T-F
        Radius     3.505e+04
        AbsMag        -19.15
        Axis    [ -0.6725  -0.6009   0.4320]
        Angle    170.9499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4945"
}

Galaxy "IC 4946:ESO 285-7:MCG 7-42-1:A 2020-44"
{
        Type  "SBa"
        RA           20.3994
        Dec         -43.9953
        Distance    1.25e+08  # method: V
        Radius     4.363e+04
        AbsMag        -20.32
        Axis    [ -0.3191  -0.9063  -0.2771]
        Angle    122.1088
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4946"
}

Galaxy "IC 4947:ESO 185-69:AM 2011-620"
{
        Type  "E0"
        RA           20.1253
        Dec         -53.1428
        Distance   6.312e+08  # method: V
        Radius     7.344e+04
        AbsMag        -21.33
        Axis    [ -0.7955  -0.3986  -0.4563]
        Angle    145.1689
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4947"
}

Galaxy "IC 4950:ESO 185-70"
{
        Type  "SBc"
        RA           20.1408
        Dec         -56.1619
        Distance   1.933e+08  # method: T-F
        Radius     3.654e+04
        AbsMag        -18.66
        Axis    [ -0.1614  -0.8203  -0.5487]
        Angle    113.4846
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4950"
}

Galaxy "IC 4951:ESO 143-10"
{
        Type  "SBc"
        RA           20.1586
        Dec         -61.8503
        Distance   2.922e+07  # method: T-F
        Radius     1.147e+04
        AbsMag        -15.76
        Axis    [ -0.6038  -0.6409   0.4740]
        Angle    166.2735
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4951"
}

Galaxy "IC 4952:ESO 186-1"
{
        Type  "Sa"
        RA           20.1436
        Dec         -55.4533
        Distance   1.894e+08  # method: V
        Radius     3.582e+04
        AbsMag        -19.82
        Axis    [ -0.0184  -0.6464  -0.7628]
        Angle    124.9489
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4952"
}

Galaxy "IC 4953:ESO 105-27"
{
        Type  "S0"
        RA           20.1667
        Dec         -62.7919
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.5542  -0.7021  -0.4471]
        Angle    126.7498
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4953"
}

Galaxy "IC 4956:ESO 284-23:A 2011-45:IRAS 20079-4544"
{
        Type  "E0"
        RA           20.1919
        Dec         -45.5931
        Distance   2.276e+08  # method: V
        Radius     5.627e+04
        AbsMag        -20.92
        Axis    [ -0.3732  -0.5376  -0.7561]
        Angle    178.3818
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4956"
}

Galaxy "IC 4957:ESO 186-3:AM 2005-555:IRAS 20056-5551"
{
        Type  "SBb"
        RA           20.1597
        Dec         -55.7089
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.0538  -0.5789  -0.8136]
        Angle    138.8987
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4957"
}

Galaxy "IC 4958:ESO 46-7"
{
        Type  "S0"
        RA           20.2597
        Dec         -72.7114
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.2825  -0.3406  -0.8968]
        Angle    175.5173
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4958"
}

Galaxy "IC 4960:ESO 73-28"
{
        Type  "S0"
        RA           20.2567
        Dec         -70.5369
        Distance   1.553e+08  # method: V
        Radius     2.484e+04
        AbsMag        -18.89
        Axis    [ -0.6790  -0.6349   0.3687]
        Angle    163.3884
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4960"
}

Galaxy "IC 4961:ESO 186-8"
{
        Type  "SBc"
        RA           20.1911
        Dec         -53.1256
        Distance   2.009e+08  # method: T-F
        Radius     4.383e+04
        AbsMag        -18.85
        Axis    [ -0.4432  -0.8883  -0.1205]
        Angle    121.3305
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4961"
}

Galaxy "IC 4962:ESO 73-30"
{
        Type  "S0"
        RA           20.2783
        Dec         -71.1300
        Distance   3.694e+08  # distance uncertain!
        Radius     5.909e+04
        AbsMag        -19.07
        Axis    [ -0.6251  -0.7159   0.3109]
        Angle    159.9964
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4962"
}

Galaxy "IC 4963:ESO 186-10:IRAS 20081-5523"
{
        Type  "Sa"
        RA           20.2014
        Dec         -55.2456
        Distance   1.989e+08  # method: V
        Radius     2.892e+04
        AbsMag        -19.63
        Axis    [ -0.7138  -0.5913   0.3752]
        Angle    143.7237
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4963"
}

Galaxy "IC 4964:ESO 46-8:AM 2011-740"
{
        Type  "Sc"
        RA           20.2897
        Dec         -73.8853
        Distance   1.213e+08  # method: T-F
        Radius     2.293e+04
        AbsMag        -17.85
        Axis    [ -0.7986  -0.5210   0.3014]
        Angle    157.1665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4964"
}

Galaxy "IC 4965:ESO 186-11:AM 2008-565"
{
        Type  "S0"
        RA           20.2075
        Dec         -56.8261
        Distance   7.423e+08  # method: V
        Radius      1.08e+05
        AbsMag        -22.19
        Axis    [ -0.2719  -0.4618  -0.8443]
        Angle    180.2382
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4965"
}

Galaxy "IC 4967:ESO 73-29"
{
        Type  "E0"
        RA           20.2731
        Dec         -70.5642
        Distance   1.804e+08  # method: V
        Radius     1.837e+04
        AbsMag        -18.91
        Axis    [ -0.8649  -0.2480  -0.4364]
        Angle    150.5330
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4967"
}

Galaxy "IC 4968:ESO 106-1"
{
        Type  "SBa"
        RA           20.2472
        Dec         -64.7983
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.4451  -0.6213  -0.6448]
        Angle    132.4873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4968"
}

Galaxy "IC 4969:ESO 186-13"
{
        Type  "Sa"
        RA           20.2156
        Dec         -53.9206
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.2717  -0.4829  -0.8324]
        Angle    181.1108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4969"
}

Galaxy "IC 4970:ESO 73-33:VV 297:AM 2011-705"
{
        Type  "S0"
        RA           20.2825
        Dec         -70.7494
        Distance    2.12e+08  # method: V
        Radius     2.158e+04
        AbsMag        -19.46
        Axis    [ -0.0416  -0.6000  -0.7990]
        Angle    107.7979
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4970"
}

Galaxy "IC 4971:ESO 73-31"
{
        Type  "S0"
        RA           20.2842
        Dec         -70.6203
        Distance   3.527e+08  # distance uncertain!
        Radius     4.104e+04
        AbsMag        -19.07
        Axis    [ -0.0594  -0.5664  -0.8220]
        Angle    113.5911
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4971"
}

Galaxy "IC 4972:ESO 73-34"
{
        Type  "Sc"
        RA           20.2953
        Dec         -70.9136
        Distance   1.625e+08  # method: V
        Radius     2.836e+04
        AbsMag        -18.09
        Axis    [ -0.0618  -0.6889  -0.7222]
        Angle    100.9192
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4972"
}

Galaxy "IC 4973:ESO 143-15"
{
        Type  "S0"
        RA           20.2428
        Dec         -58.3717
        Distance   3.072e+08  # distance uncertain!
        Radius     3.128e+04
        AbsMag        -19.07
        Axis    [ -0.7328  -0.6700  -0.1187]
        Angle    129.6662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4973"
}

Galaxy "IC 4974-1:ESO 143-16:FAIR 68"
{
        Type  "S0"
        RA           20.2572
        Dec         -61.8572
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [ -0.2800  -0.4237  -0.8614]
        Angle    178.7849
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4974-1"
}

Galaxy "IC 4974-2:ESO 143-16:FAIR 69"
{
        Type  "S0"
        RA           20.2575
        Dec         -61.8628
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [ -0.7988  -0.5863  -0.1347]
        Angle    132.5665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4974-2"
}

Galaxy "IC 4975:ESO 186-17:FAIR 535"
{
        Type  "S0"
        RA           20.2339
        Dec         -52.7222
        Distance   4.203e+08  # method: V
        Radius     6.724e+04
        AbsMag        -21.25
        Axis    [ -0.1621  -0.5467  -0.8215]
        Angle    160.7334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4975"
}

Galaxy "IC 4976:ESO 143-17:FAIR 70"
{
        Type  "Sa"
        RA           20.2614
        Dec         -61.8750
        Distance   2.802e+08  # distance uncertain!
        Radius     3.668e+04
        AbsMag        -19.07
        Axis    [ -0.4339  -0.8023  -0.4100]
        Angle    120.0126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4976"
}

Galaxy "IC 4978:ESO 186-18"
{
        Type  "S0"
        RA           20.2436
        Dec         -54.4217
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.5007  -0.8501  -0.1633]
        Angle    122.8674
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4978"
}

Galaxy "IC 4979:ESO 186-19"
{
        Type  "SBc"
        RA           20.2447
        Dec         -53.4586
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.1435  -0.5768  -0.8042]
        Angle    150.1746
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4979"
}

Galaxy "IC 4980:ESO 143-18:AM 2011-580:IRAS 20114-5803"
{
        Type  "SBa"
        RA           20.2578
        Dec         -57.9125
        Distance   2.008e+08  # method: V
        Radius     4.381e+04
        AbsMag        -19.75
        Axis    [ -0.6574  -0.7484   0.0881]
        Angle    132.5824
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4980"
}

Galaxy "IC 4981:ESO 73-38:AM 2013-710"
{
        Type  "Irr"
        RA           20.3275
        Dec         -70.8483
        Distance   1.689e+08  # method: V
        Radius     2.456e+04
        AbsMag        -19.17
        Axis    [ -0.6681  -0.7251   0.1668]
        Angle    146.3599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4981"
}

Galaxy "IC 4982:ESO 73-39"
{
        Type  "Irr"
        RA           20.3392
        Dec         -71.0069
        Distance   3.802e+08  # distance uncertain!
        Radius     3.871e+04
        AbsMag        -20.13
        Axis    [ -0.4070  -0.7285  -0.5511]
        Angle    117.4426
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4982"
}

Galaxy "IC 4983:ESO 233-48:AM 2012-521:IRAS 20123-5214"
{
        Type  "SBc"
        RA           20.2681
        Dec         -52.0872
        Distance    1.54e+08  # distance uncertain!
        Radius     2.239e+04
        AbsMag        -19.07
        Axis    [ -0.4495  -0.6267  -0.6366]
        Angle    144.5603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4983"
}

Galaxy "IC 4984:ESO 186-23"
{
        Type  "Sb"
        RA           20.2714
        Dec         -52.7033
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.6548  -0.7548   0.0384]
        Angle    128.5897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4984"
}

Galaxy "IC 4985:ESO 73-40"
{
        Type  "S0"
        RA           20.3456
        Dec         -70.9867
        Distance    1.99e+08  # method: V
        Radius     2.316e+04
        AbsMag        -19.03
        Axis    [ -0.6246  -0.5976  -0.5027]
        Angle    131.9941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4985"
}

Galaxy "IC 4986:ESO 186-26"
{
        Type  "SBc"
        RA           20.2864
        Dec         -55.0358
        Distance   1.145e+08  # method: T-F
        Radius     3.331e+04
        AbsMag        -18.53
        Axis    [ -0.1094  -0.7148  -0.6907]
        Angle    122.9497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4986"
}

Galaxy "IC 4987:ESO 233-52:FAIR 891:AM 2013-522"
{
        Type  "SBc"
        RA           20.2886
        Dec         -52.2794
        Distance   5.606e+08  # method: V
        Radius     8.153e+04
        AbsMag        -20.98
        Axis    [ -0.4934  -0.6986  -0.5182]
        Angle    134.0551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4987"
}

Galaxy "IC 4989:ESO 143-19"
{
        Type  "Sc"
        RA           20.3231
        Dec         -58.5517
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.6147  -0.6987   0.3661]
        Angle    150.6234
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4989"
}

Galaxy "IC 4990:ESO 106-3:AM 2016-670"
{
        Type  "SBc"
        RA           20.3569
        Dec         -66.8906
        Distance   2.934e+08  # distance uncertain!
        Radius     3.414e+04
        AbsMag        -19.07
        Axis    [ -0.2292  -0.6492  -0.7253]
        Angle    120.9296
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4990"
}

Galaxy "IC 4992:ESO 73-42:FGCE 1459:IRAS 20180-7143"
{
        Type  "SBc"
        RA           20.3908
        Dec         -71.5653
        Distance   1.533e+08  # method: T-F
        Radius     5.128e+04
        AbsMag        -18.86
        Axis    [ -0.3517  -0.8518  -0.3882]
        Angle    110.6418
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4992"
}

Galaxy "IC 4993:ESO 106-4"
{
        Type  "Irr"
        RA           20.3656
        Dec         -66.9853
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [ -0.2949  -0.3836  -0.8752]
        Angle    177.2450
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4993"
}

Galaxy "IC 4994:ESO 186-33"
{
        Type  "S0"
        RA           20.3289
        Dec         -53.4469
        Distance   1.281e+08  # distance uncertain!
        Radius     1.304e+04
        AbsMag        -19.07
        Axis    [ -0.2856  -0.4846  -0.8268]
        Angle    181.4481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4994"
}

Galaxy "IC 4995:ESO 186-34:FAIR 341:IRAS 20162-5246"
{
        Type  "S0"
        RA           20.3331
        Dec         -52.6217
        Distance   2.072e+08  # method: V
        Radius     2.712e+04
        AbsMag        -19.71
        Axis    [ -0.7687  -0.5571   0.3143]
        Angle    136.5860
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4995"
}

Galaxy "IC 4998:IC 5018:ESO 340-20:MCG 6-44-30"
{
        Type  "SBc"
        RA           20.3694
        Dec         -38.3086
        Distance   2.934e+08  # method: V
        Radius     6.827e+04
        AbsMag        -20.77
        Axis    [ -0.6334  -0.7720  -0.0530]
        Angle    123.9540
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4998"
}

Galaxy "IC 4999:ESO 527-21:MCG 4-48-4:AM 2020-261"
{
        Type  "SBc"
        RA           20.3989
        Dec         -26.0147
        Distance   1.141e+08  # method: T-F
        Radius     2.987e+04
        AbsMag        -19.22
        Axis    [ -0.4208  -0.9067  -0.0276]
        Angle    122.3717
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 4999"
}

Galaxy "IC 5001:ESO 186-42:AM 2022-545"
{
        Type  "SBa"
        RA           20.4389
        Dec         -54.7744
        Distance    2.33e+08  # distance uncertain!
        Radius     3.728e+04
        AbsMag        -19.07
        Axis    [ -0.0290  -0.6497  -0.7597]
        Angle    126.8720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5001"
}

Galaxy "IC 5002:ESO 186-44:AM 2022-545"
{
        Type  "S0"
        RA           20.4444
        Dec         -54.7992
        Distance   2.034e+08  # method: V
        Radius      3.55e+04
        AbsMag        -19.77
        Axis    [ -0.6392  -0.7439  -0.1951]
        Angle    128.4814
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5002"
}

Galaxy "IC 5005:ESO 528-4:MCG 4-48-7:AM 2022-255"
{
        Type  "SBc"
        RA           20.4222
        Dec         -25.8289
        Distance   1.292e+08  # method: V
        Radius     3.569e+04
        AbsMag        -19.39
        Axis    [ -0.4350  -0.8375  -0.3306]
        Angle    134.4519
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5005"
}

Galaxy "IC 5008:ESO 47-1"
{
        Type  "SBc"
        RA           20.5456
        Dec         -72.6944
        Distance   1.633e+08  # method: V
        Radius     2.613e+04
        AbsMag           -18
        Axis    [ -0.5647  -0.7786  -0.2737]
        Angle    124.4157
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5008"
}

Galaxy "IC 5009:ESO 74-1"
{
        Type  "SBa"
        RA           20.5428
        Dec         -72.1675
        Distance   1.612e+08  # distance uncertain!
        Radius     2.814e+04
        AbsMag        -19.07
        Axis    [ -0.6623  -0.7161  -0.2202]
        Angle    130.2777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5009"
}

Galaxy "IC 5010:ESO 106-6"
{
        Type  "Sb"
        RA           20.5072
        Dec         -66.0975
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [ -0.0519  -0.5722  -0.8185]
        Angle    120.3032
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5010"
}

Galaxy "IC 5011:MCG 6-45-4:ESO 400-29:AM 2025-361"
{
        Type  "S0"
        RA           20.4758
        Dec         -36.0272
        Distance   9.486e+07  # method: V
        Radius     3.311e+04
        AbsMag        -19.62
        Axis    [ -0.0597  -0.7856  -0.6159]
        Angle    137.4244
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5011"
}

Galaxy "IC 5012:ESO 186-53"
{
        Type  "SBc"
        RA           20.4922
        Dec         -56.7433
        Distance    2.44e+08  # distance uncertain!
        Radius     3.904e+04
        AbsMag        -19.07
        Axis    [ -0.4502  -0.8338  -0.3195]
        Angle    123.1968
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5012"
}

Galaxy "IC 5013:MCG 6-45-3:ESO 400-30:AM 2025-361"
{
        Type  "E0"
        RA           20.4761
        Dec         -36.0425
        Distance   3.468e+08  # distance uncertain!
        Radius      3.53e+04
        AbsMag        -20.13
        Axis    [ -0.9367  -0.1541   0.3144]
        Angle    108.3410
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5013"
}

Galaxy "IC 5014:ESO 47-2:AM 2029-733:IRAS 20296-7337"
{
        Type  "S0"
        RA           20.5875
        Dec         -73.4525
        Distance   1.612e+08  # distance uncertain!
        Radius     1.172e+04
        AbsMag        -19.07
        Axis    [ -0.3234  -0.3314  -0.8863]
        Angle    175.0520
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5014"
}

Galaxy "IC 5016:ESO 47-3"
{
        Type  "SBa"
        RA           20.5936
        Dec         -72.9114
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.3241  -0.3355  -0.8845]
        Angle    175.2322
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5016"
}

Galaxy "IC 5017:ESO 143-29:FAIR 72"
{
        Type  "S0"
        RA           20.5342
        Dec         -57.5872
        Distance   3.368e+08  # method: V
        Radius     4.898e+04
        AbsMag        -20.07
        Axis    [ -0.1107  -0.6112  -0.7837]
        Angle    134.0015
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5017"
}

Galaxy "IC 5020:ESO 400-34:MCG 6-45-6:AM 2027-333"
{
        Type  "Sb"
        RA           20.5106
        Dec         -33.4856
        Distance    1.31e+08  # method: T-F
        Radius     5.524e+04
        AbsMag        -20.02
        Axis    [ -0.6796  -0.6096   0.4081]
        Angle    125.3788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5020"
}

Galaxy "IC 5021:ESO 186-61:AM 2029-544"
{
        Type  "Irr"
        RA           20.5594
        Dec         -54.5214
        Distance   3.468e+08  # distance uncertain!
        Radius     4.035e+04
        AbsMag        -20.13
        Axis    [ -0.1412  -0.5861  -0.7978]
        Angle    146.1461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5021"
}

Galaxy "IC 5022:ESO 47-5"
{
        Type  "SBa"
        RA           20.6850
        Dec         -76.4497
        Distance   2.676e+08  # distance uncertain!
        Radius     3.503e+04
        AbsMag        -19.07
        Axis    [ -0.8507  -0.4991   0.1648]
        Angle    151.5231
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5022"
}

Galaxy "IC 5023:ESO 106-8:IRAS 20335-6721"
{
        Type  "Sa"
        RA           20.6361
        Dec         -67.1844
        Distance   1.784e+08  # method: T-F
        Radius     3.633e+04
        AbsMag        -19.49
        Axis    [ -0.6495  -0.7566   0.0758]
        Angle    139.4304
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5023"
}

Galaxy "IC 5024:ESO 74-3"
{
        Type  "SBc"
        RA           20.6692
        Dec         -71.1083
        Distance    2.03e+08  # distance uncertain!
        Radius     2.657e+04
        AbsMag        -19.07
        Axis    [ -0.8575  -0.4632  -0.2241]
        Angle    140.3980
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5024"
}

Galaxy "IC 5025:ESO 47-10:FGCE 1510:IRAS 20389-7709"
{
        Type  "Sc"
        RA           20.7497
        Dec         -76.9844
        Distance   3.006e+08  # method: T-F
        Radius     6.558e+04
        AbsMag        -19.42
        Axis    [ -0.5881  -0.8087   0.0128]
        Angle    139.0762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5025"
}

Galaxy "IC 5026:ESO 26-6:FGCE 1519"
{
        Type  "Sc"
        RA           20.8075
        Dec         -78.0689
        Distance   1.302e+08  # method: T-F
        Radius     4.357e+04
        AbsMag        -17.51
        Axis    [ -0.5071  -0.8322  -0.2242]
        Angle    122.1983
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5026"
}

Galaxy "IC 5027:ESO 186-74:FAIR 554"
{
        Type  "S0"
        RA           20.6856
        Dec         -55.4725
        Distance    2.44e+08  # distance uncertain!
        Radius     1.775e+04
        AbsMag        -19.07
        Axis    [ -0.3307  -0.4638  -0.8219]
        Angle    181.3474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5027"
}

Galaxy "IC 5028:ESO 106-10:AM 2038-654"
{
        Type  "Irr"
        RA           20.7228
        Dec         -65.6469
        Distance   3.802e+08  # distance uncertain!
        Radius     6.636e+04
        AbsMag        -20.13
        Axis    [ -0.2172  -0.4898  -0.8444]
        Angle    148.4714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5028"
}

Galaxy "IC 5029:IC 5003:IC 5039:IC 5046"
{
        Type  "Sc"
        RA           20.7206
        Dec         -29.8519
        Distance   1.195e+08  # method: T-F
        Radius     3.651e+04
        AbsMag        -19.52
        Axis    [ -0.4431  -0.7090   0.5486]
        Angle    141.2835
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5029"
}

Galaxy "IC 5030:IC 5007:IC 5041:IC 5047"
{
        Type  "SBc"
        RA           20.7261
        Dec         -29.7031
        Distance   1.185e+08  # method: T-F
        Radius      2.93e+04
        AbsMag         -19.6
        Axis    [ -0.2055  -0.8231  -0.5295]
        Angle    145.2451
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5030"
}

Galaxy "IC 5031:ESO 74-8A:AM 2040-674"
{
        Type  "S0"
        RA           20.7556
        Dec         -67.5392
        Distance   1.065e+08  # distance uncertain!
        Radius     1.085e+04
        AbsMag        -19.07
        Axis    [ -0.3582  -0.6607  -0.6596]
        Angle    125.9563
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5031"
}

Galaxy "IC 5032:ESO 74-8:AM 2040-674:IRAS 20407-6743"
{
        Type  "S0"
        RA           20.7561
        Dec         -67.5514
        Distance   4.652e+08  # method: V
        Radius     4.737e+04
        AbsMag        -22.27
        Axis    [ -0.7778  -0.5343   0.3310]
        Angle    153.7856
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5032"
}

Galaxy "IC 5033:ESO 144-1"
{
        Type  "S0"
        RA           20.7319
        Dec         -57.3344
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.3530  -0.7834  -0.5116]
        Angle    125.3128
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5033"
}

Galaxy "IC 5034:ESO 187-10"
{
        Type  "Sc"
        RA           20.7281
        Dec         -57.0300
        Distance   4.875e+08  # method: V
        Radius     1.064e+05
        AbsMag        -21.17
        Axis    [ -0.1922  -0.7248  -0.6616]
        Angle    125.2297
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5034"
}

Galaxy "IC 5035:ESO 187-11"
{
        Type  "Sb"
        RA           20.7372
        Dec         -57.1275
        Distance   3.217e+08  # distance uncertain!
        Radius     3.275e+04
        AbsMag        -19.07
        Axis    [ -0.6449  -0.7393   0.1938]
        Angle    139.9966
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5035"
}

Galaxy "IC 5036:ESO 144-2"
{
        Type  "Sc"
        RA           20.7436
        Dec         -57.6264
        Distance   3.868e+08  # distance uncertain!
        Radius       4.5e+04
        AbsMag        -19.07
        Axis    [ -0.6012  -0.7891   0.1261]
        Angle    137.2753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5036"
}

Galaxy "IC 5037:ESO 144-3"
{
        Type  "Sc"
        RA           20.7608
        Dec         -58.4497
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.5564  -0.7043   0.4409]
        Angle    161.7332
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5037"
}

Galaxy "IC 5038:ESO 106-12:AM 2042-651:IRAS 20424-6512"
{
        Type  "Sc"
        RA           20.7808
        Dec         -65.0167
        Distance   1.322e+08  # method: T-F
        Radius     2.692e+04
        AbsMag        -19.64
        Axis    [ -0.5683  -0.7686  -0.2938]
        Angle    127.7063
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5038"
}

Galaxy "IC 5040:ESO 47-14:IRAS 20461-7652"
{
        Type  "Irr"
        RA           20.8719
        Dec         -76.6864
        Distance   3.802e+08  # distance uncertain!
        Radius     4.424e+04
        AbsMag        -20.13
        Axis    [ -0.2883  -0.4616  -0.8389]
        Angle    135.6776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5040"
}

Galaxy "IC 5042:ESO 106-13:IRAS 20434-6515"
{
        Type  "Sc"
        RA           20.7961
        Dec         -65.0836
        Distance    1.87e+08  # method: V
        Radius     3.264e+04
        AbsMag        -20.49
        Axis    [ -0.4619  -0.6660  -0.5857]
        Angle    131.0204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5042"
}

Galaxy "IC 5043:ESO 187-14"
{
        Type  "S0"
        RA           20.7772
        Dec         -56.9836
        Distance    4.05e+08  # distance uncertain!
        Radius     3.534e+04
        AbsMag        -19.07
        Axis    [ -0.1981  -0.7096  -0.6762]
        Angle    127.3615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5043"
}

Galaxy "IC 5044:ESO 74-10:AM 2045-720"
{
        Type  "E0"
        RA           20.8447
        Dec         -71.8989
        Distance   4.366e+08  # distance uncertain!
        Radius      3.81e+04
        AbsMag        -20.13
        Axis    [ -0.9004  -0.2286  -0.3702]
        Angle    151.5713
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5044"
}

Galaxy "IC 5045:ESO 74-11:AM 2045-720"
{
        Type  "Sb"
        RA           20.8472
        Dec         -71.9097
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.6434  -0.6906  -0.3303]
        Angle    130.3076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5045"
}

Galaxy "IC 5048:ESO 74-12"
{
        Type  "SBc"
        RA           20.8611
        Dec         -71.8006
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.2514  -0.4503  -0.8567]
        Angle    145.7629
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5048"
}

Galaxy "IC 5049-1:ESO 341-14:MCG 6-45-14:AM 2044-383"
{
        Type  "E0"
        RA           20.7897
        Dec         -38.4131
        Distance   3.631e+08  # distance uncertain!
        Radius     4.225e+04
        AbsMag        -20.13
        Axis    [ -0.9305  -0.1755   0.3214]
        Angle    112.3584
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5049-1"
}

Galaxy "IC 5049-2:ESO 341-14A:MCG 6-45-15:AM 2044-383"
{
        Type  "E0"
        RA           20.7897
        Dec         -38.4181
        Distance   2.884e+08  # distance uncertain!
        Radius     4.195e+04
        AbsMag        -20.13
        Axis    [ -0.3477  -0.5709  -0.7437]
        Angle    189.9619
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5049-2"
}

Galaxy "IC 5050:MCG 1-53-5:IRAS 20426-0548"
{
        Type  "Sb"
        RA           20.7542
        Dec          -5.6231
        Distance    1.54e+08  # distance uncertain!
        Radius     2.911e+04
        AbsMag        -19.07
        Axis    [ -0.2394  -0.9657  -0.1007]
        Angle    133.4055
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5050"
}

Galaxy "IC 5051:ESO 74-14:IRAS 20473-7158"
{
        Type  "Sc"
        RA           20.8728
        Dec         -71.7889
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.5180  -0.6232  -0.5859]
        Angle    130.2490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5051"
}

Galaxy "IC 5052:ESO 74-15:AM 2047-692:IRAS 20473-6923"
{
        Type  "SBc"
        RA           20.8686
        Dec         -69.2053
        Distance   3.678e+07  # method: T-F
        Radius     3.157e+04
        AbsMag        -18.96
        Axis    [ -0.5975  -0.7459   0.2943]
        Angle    158.7600
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5052"
}

Galaxy "IC 5053:ESO 74-18:AM 2048-711:IRAS 20485-7119"
{
        Type  "Sa"
        RA           20.8933
        Dec         -71.1417
        Distance   1.877e+08  # method: V
        Radius     4.368e+04
        AbsMag         -20.1
        Axis    [ -0.4668  -0.7713  -0.4327]
        Angle    120.7445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5053"
}

Galaxy "IC 5054:ESO 74-19:AM 2048-711:IRAS 20489-7112"
{
        Type  "SBa"
        RA           20.8958
        Dec         -71.0247
        Distance   2.743e+08  # method: T-F
        Radius      7.98e+04
        AbsMag        -20.72
        Axis    [ -0.0650  -0.6697  -0.7398]
        Angle    103.2243
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5054"
}

Galaxy "IC 5055:ESO 74-17"
{
        Type  "S0"
        RA           20.8825
        Dec         -68.4447
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.3013  -0.6247  -0.7204]
        Angle    126.6461
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5055"
}

Galaxy "IC 5059:ESO 144-6"
{
        Type  "Sb"
        RA           20.8536
        Dec         -57.6886
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.2141  -0.6470  -0.7319]
        Angle    135.0552
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5059"
}

Galaxy "IC 5060:ESO 74-21"
{
        Type  "Sc"
        RA           20.9128
        Dec         -71.6372
        Distance   2.676e+08  # distance uncertain!
        Radius     3.892e+04
        AbsMag        -19.07
        Axis    [ -0.4771  -0.8643  -0.1591]
        Angle    125.2049
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5060"
}

Galaxy "IC 5063:ESO 187-23:AM 2048-571:IRAS 20481-5715"
{
        Type  "Sa"
        RA           20.8672
        Dec         -57.0694
        Distance   1.477e+08  # method: V
        Radius     4.511e+04
        AbsMag        -20.38
        Axis    [ -0.7366  -0.6745   0.0495]
        Angle    135.9521
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5063"
}

Galaxy "IC 5064:ESO 187-28:IRAS 20487-5725"
{
        Type  "SBa"
        RA           20.8772
        Dec         -57.2325
        Distance   1.465e+08  # method: V
        Radius     2.131e+04
        AbsMag        -18.96
        Axis    [ -0.5217  -0.7214  -0.4555]
        Angle    133.3948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5064"
}

Galaxy "IC 5065:ESO 463-30:MCG 5-49-4:AM 2048-300"
{
        Type  "S0"
        RA           20.8625
        Dec         -29.8472
        Distance   4.334e+08  # method: V
        Radius     6.935e+04
        AbsMag        -21.02
        Axis    [ -0.7147  -0.5943   0.3688]
        Angle    122.0233
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5065"
}

Galaxy "IC 5066:ESO 47-18:IRAS 20519-7320"
{
        Type  "S0"
        RA           20.9508
        Dec         -73.1475
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.3680  -0.3291  -0.8696]
        Angle    174.9105
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5066"
}

Galaxy "IC 5069:ESO 74-22:IRAS 20551-7200"
{
        Type  "Sb"
        RA           21.0028
        Dec         -71.8106
        Distance    1.47e+08  # distance uncertain!
        Radius     1.925e+04
        AbsMag        -19.07
        Axis    [ -0.3742  -0.3384  -0.8634]
        Angle    175.3993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5069"
}

Galaxy "IC 5071:ESO 47-19:AM 2056-725:IRAS 20562-7250"
{
        Type  "SBc"
        RA           21.0219
        Dec         -72.6431
        Distance    1.26e+08  # method: T-F
        Radius      6.23e+04
        AbsMag        -19.63
        Axis    [ -0.1832  -0.7067  -0.6834]
        Angle    107.0014
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5071"
}

Galaxy "IC 5072:ESO 47-20"
{
        Type  "S0"
        RA           21.0322
        Dec         -72.9881
        Distance   2.802e+08  # distance uncertain!
        Radius      3.26e+04
        AbsMag        -19.07
        Axis    [ -0.7233  -0.6884  -0.0536]
        Angle    139.5078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5072"
}

Galaxy "IC 5073:ESO 47-21:FAIR 579:AM 2059-730"
{
        Type  "SBc"
        RA           21.0553
        Dec         -72.6878
        Distance   5.321e+08  # method: V
        Radius     9.287e+04
        AbsMag        -21.16
        Axis    [ -0.4277  -0.4927  -0.7578]
        Angle    142.3358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5073"
}

Galaxy "IC 5074:ESO 107-1:IRAS 20569-6320"
{
        Type  "S0"
        RA           21.0167
        Dec         -63.1533
        Distance   1.768e+08  # distance uncertain!
        Radius     2.057e+04
        AbsMag        -19.07
        Axis    [ -0.8110  -0.4060   0.4213]
        Angle    151.0903
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5074"
}

Galaxy "IC 5075:ESO 74-23:IRAS 20595-7204"
{
        Type  "Sb"
        RA           21.0769
        Dec         -71.8681
        Distance   1.768e+08  # distance uncertain!
        Radius     2.828e+04
        AbsMag        -19.07
        Axis    [ -0.7080  -0.6318   0.3156]
        Angle    161.1419
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5075"
}

Galaxy "IC 5077:ESO 47-23"
{
        Type  "S0"
        RA           21.1483
        Dec         -73.6406
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.3919  -0.3226  -0.8616]
        Angle    174.5805
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5077"
}

Galaxy "IC 5078:MCG 3-53-21:UGCA 419:IRAS 20597-1701"
{
        Type  "Sc"
        RA           21.0419
        Dec         -16.8183
        Distance   8.571e+07  # method: T-F
        Radius     5.111e+04
        AbsMag         -18.5
        Axis    [ -0.0430  -0.9940   0.1004]
        Angle    133.4227
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5078"
}

Galaxy "IC 5080:ZWG 448.31:NPM 1"
{
        Type  "E0"
        RA           21.0425
        Dec          19.2142
        Distance   4.169e+08  # distance uncertain!
        Radius     3.032e+04
        AbsMag        -20.13
        Axis    [ -0.4054  -0.8837  -0.2339]
        Angle    170.9139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5080"
}

Galaxy "IC 5081:ZWG 448.32"
{
        Type  "S0"
        RA           21.0503
        Dec          19.1892
        Distance   2.676e+08  # distance uncertain!
        Radius     1.168e+04
        AbsMag        -19.07
        Axis    [ -0.0510  -0.9966   0.0643]
        Angle    139.1390
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5081"
}

Galaxy "IC 5083:ZWG 425.38"
{
        Type  "E0"
        RA           21.0642
        Dec          11.7639
        Distance   3.802e+08  # distance uncertain!
        Radius     2.765e+04
        AbsMag        -20.13
        Axis    [ -0.3124  -0.8434  -0.4371]
        Angle    208.5486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5083"
}

Galaxy "IC 5084:ESO 107-7:AM 2105-632:IRAS 21051-6329"
{
        Type  "SBb"
        RA           21.1539
        Dec         -63.2897
        Distance   1.356e+08  # method: V
        Radius     3.156e+04
        AbsMag        -20.29
        Axis    [ -0.7720  -0.5894   0.2379]
        Angle    147.1053
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5084"
}

Galaxy "IC 5085:ESO 47-25"
{
        Type  "S0"
        RA           21.2242
        Dec         -74.1031
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.4011  -0.3180  -0.8591]
        Angle    174.3347
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5085"
}

Galaxy "IC 5086:ESO 464-25:MCG 5-50-2:AM 2105-295"
{
        Type  "S0"
        RA           21.1422
        Dec         -29.7689
        Distance   2.586e+08  # method: V
        Radius     4.889e+04
        AbsMag         -20.8
        Axis    [ -0.3654  -0.6248  -0.6900]
        Angle    192.4294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5086"
}

Galaxy "IC 5087:ESO 47-26:IRAS 21092-7358"
{
        Type  "SBb"
        RA           21.2392
        Dec         -73.7736
        Distance   2.125e+08  # distance uncertain!
        Radius     2.164e+04
        AbsMag        -19.07
        Axis    [ -0.7615  -0.6462  -0.0502]
        Angle    141.8344
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5087"
}

Galaxy "IC 5088:ESO 530-10:NPM 1:AM 2106-230"
{
        Type  "Sa"
        RA           21.1572
        Dec         -22.8781
        Distance   5.042e+08  # method: V
        Radius       8.8e+04
        AbsMag        -21.45
        Axis    [ -0.2101  -0.7199  -0.6615]
        Angle    179.3626
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5088"
}

Galaxy "IC 5089:NPM 1"
{
        Type  "S0"
        RA           21.1817
        Dec          -3.8622
        Distance   3.827e+08  # method: V
        Radius     3.897e+04
        AbsMag        -19.35
        Axis    [  0.0487  -0.9452  -0.3228]
        Angle    151.1457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5089"
}

Galaxy "IC 5090:UGC 11691:MCG 0-54-3:ZWG 375.6"
{
        Type  "Sa"
        RA           21.1917
        Dec          -2.0319
        Distance   4.093e+08  # method: V
        Radius     7.144e+04
        AbsMag        -21.09
        Axis    [  0.0919  -0.9212  -0.3781]
        Angle    155.3615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5090"
}

Galaxy "IC 5091:ESO 74-27:AM 2112-705"
{
        Type  "Sc"
        RA           21.2936
        Dec         -70.6528
        Distance   3.217e+08  # distance uncertain!
        Radius     2.339e+04
        AbsMag        -19.07
        Axis    [ -0.2902  -0.4795  -0.8282]
        Angle    144.0534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5091"
}

Galaxy "IC 5092:ESO 107-17:IRAS 21121-6440"
{
        Type  "SBc"
        RA           21.2706
        Dec         -64.4650
        Distance   1.226e+08  # method: T-F
        Radius      5.17e+04
        AbsMag        -20.17
        Axis    [ -0.3229  -0.5442  -0.7743]
        Angle    145.1499
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5092"
}

Galaxy "IC 5093:ESO 75-1"
{
        Type  "S0"
        RA           21.3128
        Dec         -70.6222
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.7150  -0.6796   0.1640]
        Angle    150.3245
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5093"
}

Galaxy "IC 5094:ESO 107-18"
{
        Type  "SBc"
        RA           21.2969
        Dec         -66.4278
        Distance   4.545e+08  # method: V
        Radius     6.611e+04
        AbsMag        -21.22
        Axis    [ -0.7729  -0.5436   0.3273]
        Angle    154.3981
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5094"
}

Galaxy "IC 5095:ESO 145-2"
{
        Type  "Sc"
        RA           21.2894
        Dec         -59.9475
        Distance   2.555e+08  # distance uncertain!
        Radius     3.345e+04
        AbsMag        -19.07
        Axis    [ -0.5138  -0.8201  -0.2519]
        Angle    130.5327
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5095"
}

Galaxy "IC 5096:ESO 107-19:FGCE 1588:IRAS 21143-6358"
{
        Type  "Sc"
        RA           21.3058
        Dec         -63.7608
        Distance    1.74e+08  # method: T-F
        Radius       8.1e+04
        AbsMag        -20.34
        Axis    [ -0.5654  -0.7294   0.3850]
        Angle    164.7338
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5096"
}

Galaxy "IC 5099:ESO 75-3:IRAS 21172-7111"
{
        Type  "S0"
        RA           21.3636
        Dec         -70.9828
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.2785  -0.5790  -0.7663]
        Angle    127.9614
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5099"
}

Galaxy "IC 5100:ESO 107-24:IRAS 21175-6608"
{
        Type  "SBc"
        RA           21.3619
        Dec         -65.9331
        Distance   2.886e+08  # method: T-F
        Radius     7.976e+04
        AbsMag        -20.13
        Axis    [ -0.5413  -0.8267   0.1531]
        Angle    147.1714
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5100"
}

Galaxy "IC 5101:ESO 107-25:IRAS 21177-6602"
{
        Type  "SBc"
        RA           21.3653
        Dec         -65.8358
        Distance   2.297e+08  # method: V
        Radius     4.344e+04
        AbsMag        -20.24
        Axis    [ -0.2458  -0.5465  -0.8006]
        Angle    139.0073
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5101"
}

Galaxy "IC 5102:ESO 47-30"
{
        Type  "S0"
        RA           21.4369
        Dec         -73.3100
        Distance   1.938e+08  # distance uncertain!
        Radius     2.537e+04
        AbsMag        -19.07
        Axis    [ -0.8724  -0.4794   0.0948]
        Angle    148.6581
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5102"
}

Galaxy "IC 5103:ESO 47-31"
{
        Type  "SBc"
        RA           21.4869
        Dec         -74.0694
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [ -0.4994  -0.6160  -0.6093]
        Angle    130.1817
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5103"
}

Galaxy "IC 5104:UGC 11731:MCG 3-54-7:ZWG 449.18"
{
        Type  "SBb"
        RA           21.3581
        Dec          21.2414
        Distance   2.107e+08  # method: V
        Radius     4.903e+04
        AbsMag        -19.75
        Axis    [ -0.0445  -0.5518   0.8328]
        Angle    131.0603
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5104"
}

Galaxy "IC 5105:ESO 342-39:MCG 7-44-1"
{
        Type  "E0"
        RA           21.4058
        Dec         -40.5383
        Distance   2.352e+08  # method: V
        Radius     6.498e+04
        AbsMag        -21.69
        Axis    [ -0.6458  -0.5392  -0.5406]
        Angle    169.4294
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5105"
}

Galaxy "IC 5105A:ESO 342-43:MCG 7-44-5:AM 2122-402"
{
        Type  "SBc"
        RA           21.4250
        Dec         -40.2744
        Distance    1.89e+08  # method: T-F
        Radius     5.774e+04
        AbsMag        -20.31
        Axis    [ -0.5263  -0.8452   0.0929]
        Angle    136.7480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5105A"
}

Galaxy "IC 5105B:ESO 342-46:MCG 7-44-8:AM 2122-410"
{
        Type  "SBb"
        RA           21.4333
        Dec         -40.8350
        Distance   9.133e+07  # method: T-F
        Radius     1.727e+04
        AbsMag        -18.54
        Axis    [ -0.3256  -0.9236  -0.2023]
        Angle    133.5677
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5105B"
}

Galaxy "IC 5106:ESO 75-9"
{
        Type  "S0"
        RA           21.4769
        Dec         -70.8347
        Distance    1.71e+08  # method: V
        Radius     3.481e+04
        AbsMag         -19.8
        Axis    [ -0.8076  -0.5165   0.2846]
        Angle    155.6672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5106"
}

Galaxy "IC 5107:ESO 107-29"
{
        Type  "S0"
        RA           21.4706
        Dec         -65.7353
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.1927  -0.6545  -0.7311]
        Angle    122.2023
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5107"
}

Galaxy "IC 5108:ESO 48-25"
{
        Type  "SBc"
        RA           21.5475
        Dec         -72.6592
        Distance   2.226e+08  # distance uncertain!
        Radius     3.884e+04
        AbsMag        -19.07
        Axis    [ -0.6490  -0.7607   0.0132]
        Angle    143.0385
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5108"
}

Galaxy "IC 5109:ESO 48-1"
{
        Type  "E0"
        RA           21.5617
        Dec         -74.1117
        Distance    3.02e+08  # distance uncertain!
        Radius     3.953e+04
        AbsMag        -20.13
        Axis    [ -0.9057   0.0145   0.4236]
        Angle    144.8776
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5109"
}

Galaxy "IC 5110:ESO 145-7:AM 2126-601"
{
        Type  "SBa"
        RA           21.5119
        Dec         -60.0019
        Distance   3.925e+08  # method: V
        Radius     7.993e+04
        AbsMag         -21.3
        Axis    [ -0.5830  -0.6529  -0.4836]
        Angle    141.4334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5110"
}

Galaxy "IC 5111:MCG 0-54-21:ZWG 375.41:KARA 917"
{
        Type  "S0"
        RA           21.4694
        Dec           2.4744
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.2037  -0.9016  -0.3815]
        Angle    174.0221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5111"
}

Galaxy "IC 5115:ZWG 426.60"
{
        Type  "S0"
        RA           21.5158
        Dec          11.7636
        Distance   2.934e+08  # distance uncertain!
        Radius     1.707e+04
        AbsMag        -19.07
        Axis    [ -0.2134  -0.9715   0.1031]
        Angle    138.4850
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5115"
}

Galaxy "IC 5116:ESO 75-18:IRAS 21325-7112"
{
        Type  "Sb"
        RA           21.6181
        Dec         -70.9831
        Distance    1.69e+08  # method: V
        Radius     3.932e+04
        AbsMag        -19.67
        Axis    [ -0.4206  -0.5433  -0.7266]
        Angle    139.0639
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5116"
}

Galaxy "IC 5118:ESO 75-20"
{
        Type  "Sc"
        RA           21.7036
        Dec         -71.3822
        Distance   2.676e+08  # distance uncertain!
        Radius     4.281e+04
        AbsMag        -19.07
        Axis    [ -0.4439  -0.8133  -0.3762]
        Angle    122.3744
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5118"
}

Galaxy "IC 5119:UGC 11766:ZWG 472.1"
{
        Type  "Sa"
        RA           21.5653
        Dec          21.8375
        Distance   2.261e+08  # method: V
        Radius     2.959e+04
        AbsMag         -18.8
        Axis    [  0.0633  -0.7065   0.7049]
        Angle    137.3110
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5119"
}

Galaxy "IC 5120:NGC 7096A:ESO 107-41:IRAS 21348-6434"
{
        Type  "SBc"
        RA           21.6467
        Dec         -64.3503
        Distance   1.374e+08  # method: T-F
        Radius     3.997e+04
        AbsMag        -18.92
        Axis    [ -0.5791  -0.8124   0.0675]
        Angle    143.5358
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5120"
}

Galaxy "IC 5122:ESO 531-14:AM 2137-225:NPM 1"
{
        Type  "S0"
        RA           21.6625
        Dec         -22.4061
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.1912  -0.9294  -0.3157]
        Angle    146.2543
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5122"
}

Galaxy "IC 5123:ESO 48-6:IRAS 21402-7239"
{
        Type  "SBc"
        RA           21.7469
        Dec         -72.4206
        Distance   1.688e+08  # distance uncertain!
        Radius     3.683e+04
        AbsMag        -19.07
        Axis    [ -0.3230  -0.7094  -0.6264]
        Angle    117.3904
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5123"
}

Galaxy "IC 5124:ESO 531-16:AM 2137-225"
{
        Type  "Sa"
        RA           21.6653
        Dec         -22.4267
        Distance    4.05e+08  # distance uncertain!
        Radius     2.356e+04
        AbsMag        -19.07
        Axis    [ -0.2773  -0.8544   0.4395]
        Angle    146.4047
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5124"
}

Galaxy "IC 5125:ESO 188-16:IRAS 21384-5300"
{
        Type  "Sc"
        RA           21.6972
        Dec         -52.7733
        Distance   1.404e+08  # distance uncertain!
        Radius      1.43e+04
        AbsMag        -19.07
        Axis    [ -0.4504  -0.4593  -0.7657]
        Angle    184.1067
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5125"
}

Galaxy "IC 5126"
{
        Type  "Sb"
        RA           21.6744
        Dec          -6.3458
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [ -0.3908  -0.7412  -0.5458]
        Angle    205.2076
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5126"
}

Galaxy "IC 5128:ESO 343-22:MCG 7-44-35:IRAS 21401-3911"
{
        Type  "Sa"
        RA           21.7197
        Dec         -38.9681
        Distance   2.043e+08  # method: V
        Radius     3.268e+04
        AbsMag        -19.88
        Axis    [ -0.6243  -0.6921   0.3622]
        Angle    141.3349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5128"
}

Galaxy "IC 5129:ESO 108-3:FAIR 980"
{
        Type  "Sc"
        RA           21.7961
        Dec         -65.3875
        Distance    2.44e+08  # distance uncertain!
        Radius     2.484e+04
        AbsMag        -19.07
        Axis    [ -0.3582  -0.4977  -0.7899]
        Angle    152.8314
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5129"
}

Galaxy "IC 5130:ESO 48-8:IRAS 21456-7413"
{
        Type  "Sc"
        RA           21.8400
        Dec         -73.9975
        Distance   3.551e+08  # method: T-F
        Radius     9.813e+04
        AbsMag        -20.68
        Axis    [ -0.6655  -0.7398   0.0994]
        Angle    150.3484
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5130"
}

Galaxy "IC 5131:ESO 403-27:MCG 6-47-14:AM 2144-350"
{
        Type  "S0"
        RA           21.7903
        Dec         -34.8844
        Distance   1.095e+08  # method: V
        Radius     1.593e+04
        AbsMag        -19.33
        Axis    [ -0.4460  -0.5721  -0.6883]
        Angle    192.8678
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5131"
}

Galaxy "IC 5138:ESO 75-34"
{
        Type  "Sb"
        RA           21.8892
        Dec         -68.9528
        Distance   1.341e+08  # distance uncertain!
        Radius     1.755e+04
        AbsMag        -19.07
        Axis    [ -0.7588  -0.6090   0.2308]
        Angle    154.9069
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5138"
}

Galaxy "IC 5139:ESO 466-11:MCG 5-51-17:IRAS 21474-3113"
{
        Type  "S0"
        RA           21.8403
        Dec         -30.9950
        Distance   2.309e+08  # method: V
        Radius     7.051e+04
        AbsMag        -20.95
        Axis    [ -0.1803  -0.8641  -0.4699]
        Angle    146.6369
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5139"
}

Galaxy "IC 5140:ESO 75-37:FGCE 1664"
{
        Type  "SBc"
        RA           21.9042
        Dec         -67.3311
        Distance    1.58e+08  # method: T-F
        Radius     4.596e+04
        AbsMag        -18.23
        Axis    [ -0.5713  -0.7492   0.3352]
        Angle    166.5916
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5140"
}

Galaxy "IC 5141:ESO 145-22:AM 2149-594:IRAS 21496-5943"
{
        Type  "Sc"
        RA           21.8881
        Dec         -59.4931
        Distance   1.814e+08  # method: T-F
        Radius     4.485e+04
        AbsMag        -20.23
        Axis    [ -0.4989  -0.6442  -0.5797]
        Angle    144.7004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5141"
}

Galaxy "IC 5142:ESO 108-6"
{
        Type  "Sc"
        RA           21.9222
        Dec         -65.5103
        Distance   3.161e+08  # method: T-F
        Radius     7.356e+04
        AbsMag        -20.43
        Axis    [ -0.6159  -0.7611  -0.2034]
        Angle    137.3815
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5142"
}

Galaxy "IC 5144:MCG 2-55-27:ZWG 427.39:NPM 1"
{
        Type  "SBa"
        RA           21.9025
        Dec          15.0372
        Distance    2.44e+08  # distance uncertain!
        Radius      2.13e+04
        AbsMag        -19.07
        Axis    [ -0.1008  -0.8773  -0.4692]
        Angle    200.8858
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5144"
}

Galaxy "IC 5145:UGC 11844:MCG 2-55-28:ZWG 427.41"
{
        Type  "Sb"
        RA           21.9061
        Dec          15.1564
        Distance   3.183e+08  # method: V
        Radius     7.408e+04
        AbsMag        -20.55
        Axis    [ -0.1804  -0.6175   0.7656]
        Angle    122.2726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5145"
}

Galaxy "IC 5147:ESO 108-9"
{
        Type  "SBc"
        RA           21.9906
        Dec         -65.4497
        Distance     2.9e+08  # method: T-F
        Radius     5.061e+04
        AbsMag        -19.64
        Axis    [ -0.4342  -0.7228  -0.5377]
        Angle    130.9602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5147"
}

Galaxy "IC 5149:ESO 466-27:MCG 5-51-33:AM 2155-273"
{
        Type  "Sa"
        RA           21.9828
        Dec         -27.4144
        Distance   2.929e+08  # method: T-F
        Radius     5.112e+04
        AbsMag        -20.27
        Axis    [ -0.1583  -0.9003  -0.4055]
        Angle    147.3223
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5149"
}

Galaxy "IC 5151:ZWG 403.11"
{
        Type  "E0"
        RA           21.9811
        Dec           3.7628
        Distance   4.169e+08  # distance uncertain!
        Radius     2.425e+04
        AbsMag        -20.13
        Axis    [ -0.4561  -0.7818  -0.4252]
        Angle    205.5474
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5151"
}

Galaxy "IC 5152:ESO 237-27:AM 2159-513:IRAS 21594-5132"
{
        Type  "Irr"
        RA           22.0447
        Dec         -51.2961
        Distance   5.755e+07  # distance uncertain!
        Radius     4.185e+04
        AbsMag        -20.13
        Axis    [ -0.6661  -0.7436   0.0582]
        Angle    144.2493
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5152"
}

Galaxy "IC 5154:ESO 108-10:AM 2200-662:IRAS 22006-6621"
{
        Type  "Irr"
        RA           22.0747
        Dec         -66.1142
        Distance   3.468e+08  # distance uncertain!
        Radius     2.522e+04
        AbsMag        -20.13
        Axis    [ -0.7031  -0.4072   0.5829]
        Angle    171.5514
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5154"
}

Galaxy "IC 5156:ESO 404-25:MCG 6-48-19:IRAS 22003-3404"
{
        Type  "SBb"
        RA           22.0539
        Dec         -33.8369
        Distance   1.415e+08  # method: T-F
        Radius     4.528e+04
        AbsMag        -20.19
        Axis    [ -0.4463  -0.5545   0.7024]
        Angle    162.1363
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5156"
}

Galaxy "IC 5157:ESO 404-26:MCG 6-48-20"
{
        Type  "E0"
        RA           22.0575
        Dec         -34.9414
        Distance   1.898e+08  # method: V
        Radius     3.589e+04
        AbsMag        -20.82
        Axis    [ -0.4921  -0.5508  -0.6742]
        Angle    195.8635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5157"
}

Galaxy "IC 5158:ESO 75-55:PRCC 67"
{
        Type  "Irr"
        RA           22.1067
        Dec         -67.5175
        Distance   3.802e+08  # distance uncertain!
        Radius     4.977e+04
        AbsMag        -20.13
        Axis    [ -0.6401  -0.6688  -0.3782]
        Angle    139.1709
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5158"
}

Galaxy "IC 5160:UGC 11884:ZWG 428.18:NPM 1"
{
        Type  "S0"
        RA           22.0511
        Dec          10.9253
        Distance   2.555e+08  # distance uncertain!
        Radius     4.088e+04
        AbsMag        -19.07
        Axis    [ -0.0991  -0.9279  -0.3594]
        Angle    182.5688
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5160"
}

Galaxy "IC 5161:ZWG 403.22:NPM 1"
{
        Type  "S0"
        RA           22.0939
        Dec           9.6406
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [  0.0525  -0.8925  -0.4480]
        Angle    180.9399
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5161"
}

Galaxy "IC 5162:ESO 189-25:AM 2204-525"
{
        Type  "S0"
        RA           22.1339
        Dec         -52.7136
        Distance   2.226e+08  # distance uncertain!
        Radius     2.913e+04
        AbsMag        -19.07
        Axis    [ -0.5386  -0.8098   0.2328]
        Angle    152.0762
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5162"
}

Galaxy "IC 5165:ESO 108-15"
{
        Type  "SBb"
        RA           22.1683
        Dec         -64.5783
        Distance   1.938e+08  # distance uncertain!
        Radius     3.665e+04
        AbsMag        -19.07
        Axis    [ -0.4302  -0.8302  -0.3545]
        Angle    129.1176
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5165"
}

Galaxy "IC 5168:ESO 467-11:MCG 5-52-33"
{
        Type  "SBc"
        RA           22.1458
        Dec         -27.8567
        Distance   2.201e+08  # method: T-F
        Radius     4.162e+04
        AbsMag        -18.65
        Axis    [ -0.3172  -0.7743   0.5476]
        Angle    159.1263
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5168"
}

Galaxy "IC 5169:ESO 404-36:MCG 6-48-25:IRAS 22072-3620"
{
        Type  "SBa"
        RA           22.1694
        Dec         -36.0889
        Distance   1.251e+08  # method: V
        Radius     3.456e+04
        AbsMag        -19.12
        Axis    [ -0.1059  -0.8766  -0.4695]
        Angle    139.4477
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5169"
}

Galaxy "IC 5170:ESO 237-46:ESO 288-51:AM 2209-472"
{
        Type  "SBa"
        RA           22.2081
        Dec         -47.2214
        Distance   7.638e+07  # method: T-F
        Radius         2e+04
        AbsMag        -18.45
        Axis    [ -0.2960  -0.8159  -0.4968]
        Angle    139.7247
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5170"
}

Galaxy "IC 5171:ESO 288-46:A 2207-46:IRAS 22078-4619"
{
        Type  "SBc"
        RA           22.1822
        Dec         -46.0819
        Distance   1.124e+08  # method: V
        Radius      5.07e+04
        AbsMag        -19.29
        Axis    [ -0.4349  -0.6915   0.5768]
        Angle    173.5221
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5171"
}

Galaxy "IC 5172:ZWG 428.39"
{
        Type  "S0"
        RA           22.1653
        Dec          12.8178
        Distance   2.802e+08  # distance uncertain!
        Radius      1.63e+04
        AbsMag        -19.07
        Axis    [ -0.0537  -0.9827   0.1775]
        Angle    150.7665
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5172"
}

Galaxy "IC 5173:ESO 76-8:AM 2210-693"
{
        Type  "SBc"
        RA           22.2456
        Dec         -69.3658
        Distance    2.33e+08  # distance uncertain!
        Radius     4.745e+04
        AbsMag        -19.07
        Axis    [ -0.5005  -0.8604  -0.0958]
        Angle    137.0586
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5173"
}

Galaxy "IC 5173A:ESO 76-8A:AM 2210-693"
{
        Type  "Sc"
        RA           22.2439
        Dec         -69.3675
        Distance   3.072e+08  # distance uncertain!
        Radius      1.34e+04
        AbsMag        -19.07
        Axis    [ -0.7192  -0.6541  -0.2345]
        Angle    142.0556
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5173A"
}

Galaxy "IC 5174:ESO 344-13:MCG 6-48-28:AM 2209-382"
{
        Type  "SBb"
        RA           22.2122
        Dec         -38.1717
        Distance   4.933e+08  # method: V
        Radius     1.507e+05
        AbsMag         -20.9
        Axis    [ -0.1685  -0.7361  -0.6555]
        Angle    151.4430
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5174"
}

Galaxy "IC 5175:ESO 344-14:MCG 6-48-29:AM 2209-382"
{
        Type  "Sb"
        RA           22.2133
        Dec         -38.1272
        Distance   4.749e+08  # method: V
        Radius      9.67e+04
        AbsMag        -20.82
        Axis    [ -0.4065  -0.9065   0.1139]
        Angle    146.7995
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5175"
}

Galaxy "IC 5176:ESO 108-20:FGCE 1717:AM 2211-670"
{
        Type  "SBc"
        RA           22.2486
        Dec         -66.8500
        Distance   1.029e+08  # method: T-F
        Radius     6.584e+04
        AbsMag        -18.99
        Axis    [ -0.3072  -0.8400  -0.4473]
        Angle    119.5672
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5176"
}

Galaxy "IC 5177:UGC 11939:MCG 2-56-15:ZWG 428.42"
{
        Type  "SBb"
        RA           22.1928
        Dec          11.7953
        Distance   3.504e+08  # method: V
        Radius     8.154e+04
        AbsMag        -20.36
        Axis    [  0.0320  -0.9420  -0.3341]
        Angle    177.0145
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5177"
}

Galaxy "IC 5178:ESO 532-31:MCG 4-52-22"
{
        Type  "SBa"
        RA           22.2092
        Dec         -22.9544
        Distance   2.272e+08  # method: V
        Radius     3.635e+04
        AbsMag        -19.51
        Axis    [ -0.4939  -0.8690   0.0282]
        Angle    145.7480
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5178"
}

Galaxy "IC 5179:IC 5183:IC 5184:ESO 405-5"
{
        Type  "Sc"
        RA           22.2692
        Dec         -36.8447
        Distance   1.408e+08  # method: T-F
        Radius     4.913e+04
        AbsMag        -20.87
        Axis    [ -0.3806  -0.8967  -0.2261]
        Angle    145.8375
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5179"
}

Galaxy "IC 5180:UGC 11938:MCG 6-48-12:ZWG 513.11"
{
        Type  "E0"
        RA           22.1867
        Dec          38.9267
        Distance   2.884e+08  # distance uncertain!
        Radius     4.195e+04
        AbsMag        -20.13
        Axis    [ -0.3887  -0.8996   0.1991]
        Angle    118.6108
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5180"
}

Galaxy "IC 5181:ESO 289-1:AM 2210-461"
{
        Type  "S0"
        RA           22.2225
        Dec         -46.0181
        Distance   8.077e+07  # method: V
        Radius     2.937e+04
        AbsMag        -19.47
        Axis    [ -0.4222  -0.9031  -0.0779]
        Angle    142.5170
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5181"
}

Galaxy "IC 5182:ESO 108-22"
{
        Type  "Irr"
        RA           22.2681
        Dec         -65.4547
        Distance   3.981e+08  # distance uncertain!
        Radius     4.054e+04
        AbsMag        -20.13
        Axis    [ -0.7365  -0.5678   0.3678]
        Angle    161.2523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5182"
}

Galaxy "IC 5185:ESO 108-24:IRAS 22140-6606"
{
        Type  "S0"
        RA           22.2953
        Dec         -65.8575
        Distance    2.03e+08  # distance uncertain!
        Radius     1.476e+04
        AbsMag        -19.07
        Axis    [ -0.7547  -0.5985  -0.2687]
        Angle    145.5574
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5185"
}

Galaxy "IC 5186:ESO 405-7:MCG 6-49-1:IRAS 22158-3703"
{
        Type  "SBb"
        RA           22.3128
        Dec         -36.8017
        Distance   2.115e+08  # method: V
        Radius     5.537e+04
        AbsMag        -21.46
        Axis    [ -0.5920  -0.7881   0.1686]
        Angle    145.7101
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5186"
}

Galaxy "IC 5187:ESO 146-16"
{
        Type  "S0"
        RA           22.3050
        Dec         -59.6072
        Distance   1.851e+08  # distance uncertain!
        Radius     1.346e+04
        AbsMag        -19.07
        Axis    [ -0.5230  -0.3965  -0.7544]
        Angle    181.4497
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5187"
}

Galaxy "IC 5188:ESO 146-17:AM 2215-595"
{
        Type  "SBc"
        RA           22.3072
        Dec         -59.6406
        Distance   2.008e+08  # method: V
        Radius     3.797e+04
        AbsMag        -20.15
        Axis    [ -0.7372  -0.6111  -0.2884]
        Angle    147.8018
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5188"
}

Galaxy "IC 5190:ESO 146-18"
{
        Type  "SBc"
        RA           22.3167
        Dec         -59.8828
        Distance   1.938e+08  # distance uncertain!
        Radius     3.383e+04
        AbsMag        -19.07
        Axis    [ -0.7104  -0.5954   0.3752]
        Angle    158.4695
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5190"
}

Galaxy "IC 5191:UGC 11963:MCG 6-48-21:ZWG 513.20"
{
        Type  "Sa"
        RA           22.2506
        Dec          37.3003
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [  0.3731  -0.9258   0.0602]
        Angle    172.1570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5191"
}

Galaxy "IC 5192:MCG 6-48-22"
{
        Type  "S0"
        RA           22.2539
        Dec          37.2708
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.3338  -0.9097  -0.2472]
        Angle    228.4378
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5192"
}

Galaxy "IC 5193:MCG 6-48-26:NPM 1"
{
        Type  "E0"
        RA           22.2619
        Dec          37.2433
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [ -0.3593  -0.9028  -0.2362]
        Angle    229.2416
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5193"
}

Galaxy "IC 5195:ZWG 513.23:ZWG 514.3:ZW 90"
{
        Type  "E0"
        RA           22.2614
        Dec          37.3028
        Distance   6.608e+08  # distance uncertain!
        Radius     2.883e+04
        AbsMag        -20.13
        Axis    [ -0.3590  -0.9031  -0.2357]
        Angle    229.2568
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5195"
}

Galaxy "IC 5196:ESO 108-25:IRAS 22165-6539"
{
        Type  "Sc"
        RA           22.3364
        Dec         -65.4047
        Distance   2.555e+08  # distance uncertain!
        Radius     4.831e+04
        AbsMag        -19.07
        Axis    [ -0.5181  -0.8457   0.1284]
        Angle    151.9578
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5196"
}

Galaxy "IC 5197:ESO 146-19"
{
        Type  "SBb"
        RA           22.3303
        Dec         -60.1364
        Distance   2.125e+08  # distance uncertain!
        Radius       3.4e+04
        AbsMag        -19.07
        Axis    [ -0.4123  -0.7698  -0.4872]
        Angle    134.3085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5197"
}

Galaxy "IC 5199:ESO 344-20:MCG 6-49-2:IRAS 22166-3747"
{
        Type  "Sb"
        RA           22.3256
        Dec         -37.5342
        Distance   2.397e+08  # method: T-F
        Radius      5.23e+04
        AbsMag        -19.33
        Axis    [ -0.3678  -0.7135   0.5964]
        Angle    170.7000
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5199"
}

Galaxy "IC 5200:ESO 108-26"
{
        Type  "Sc"
        RA           22.3708
        Dec         -65.7664
        Distance   3.369e+08  # distance uncertain!
        Radius      3.43e+04
        AbsMag        -19.07
        Axis    [ -0.7423  -0.6162   0.2632]
        Angle    157.2551
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5200"
}

Galaxy "IC 5201:ESO 289-18:IRAS 22179-4617"
{
        Type  "SBc"
        RA           22.3492
        Dec         -46.0347
        Distance   4.367e+07  # method: T-F
        Radius     5.399e+04
        AbsMag        -19.13
        Axis    [ -0.3387  -0.8355  -0.4327]
        Angle    142.0175
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5201"
}

Galaxy "IC 5202:ESO 108-27"
{
        Type  "SBc"
        RA           22.3819
        Dec         -65.8025
        Distance   1.851e+08  # distance uncertain!
        Radius       3.5e+04
        AbsMag        -19.07
        Axis    [ -0.6953  -0.6570   0.2913]
        Angle    160.3300
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5202"
}

Galaxy "IC 5203:ESO 146-20:AM 2219-600:IRAS 22192-6001"
{
        Type  "SBc"
        RA           22.3761
        Dec         -59.7733
        Distance   2.087e+08  # method: V
        Radius     3.946e+04
        AbsMag        -19.33
        Axis    [ -0.5055  -0.7623  -0.4043]
        Angle    138.7065
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5203"
}

Galaxy "IC 5205:ESO 146-21"
{
        Type  "S0"
        RA           22.3797
        Dec         -59.7867
        Distance   3.369e+08  # distance uncertain!
        Radius     3.919e+04
        AbsMag        -19.07
        Axis    [ -0.2724  -0.6594  -0.7007]
        Angle    135.7740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5205"
}

Galaxy "IC 5206:ESO 108-28"
{
        Type  "SBc"
        RA           22.4011
        Dec         -66.8578
        Distance    2.44e+08  # distance uncertain!
        Radius     3.194e+04
        AbsMag        -19.07
        Axis    [ -0.4868  -0.6282  -0.6070]
        Angle    139.4303
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5206"
}

Galaxy "IC 5207:ESO 146-22"
{
        Type  "SBc"
        RA           22.3914
        Dec         -60.5656
        Distance   3.026e+08  # method: V
        Radius     6.602e+04
        AbsMag        -19.64
        Axis    [ -0.3135  -0.6262  -0.7139]
        Angle    140.4989
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5207"
}

Galaxy "IC 5208:ESO 108-29"
{
        Type  "Sa"
        RA           22.4094
        Dec         -65.2275
        Distance   1.938e+08  # distance uncertain!
        Radius     4.511e+04
        AbsMag        -19.07
        Axis    [ -0.4389  -0.8875  -0.1402]
        Angle    135.4967
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5208"
}

Galaxy "IC 5209:ESO 345-4:AM 2220-381"
{
        Type  "S0"
        RA           22.3858
        Dec         -37.9936
        Distance   2.802e+08  # distance uncertain!
        Radius     2.445e+04
        AbsMag        -19.07
        Axis    [ -0.7122  -0.6377   0.2934]
        Angle    142.4526
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5209"
}

Galaxy "IC 5210:ESO 602-12:MCG 3-57-4"
{
        Type  "S0"
        RA           22.3753
        Dec         -18.8692
        Distance   1.341e+08  # distance uncertain!
        Radius     2.341e+04
        AbsMag        -19.07
        Axis    [ -0.3384  -0.7186  -0.6075]
        Angle    189.1266
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5210"
}

Galaxy "IC 5211:ESO 602-14:MCG 3-57-5"
{
        Type  "Sb"
        RA           22.3783
        Dec         -18.8797
        Distance   3.212e+08  # method: V
        Radius     4.671e+04
        AbsMag        -20.27
        Axis    [ -0.4325  -0.6266   0.6483]
        Angle    143.7609
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5211"
}

Galaxy "IC 5212:ESO 345-6:AM 2220-381"
{
        Type  "Sc"
        RA           22.3917
        Dec         -38.0378
        Distance    3.65e+08  # method: V
        Radius     5.839e+04
        AbsMag        -20.64
        Axis    [ -0.4179  -0.8310  -0.3671]
        Angle    150.9177
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5212"
}

Galaxy "IC 5213:ESO 146-23"
{
        Type  "S0"
        RA           22.4178
        Dec         -60.4761
        Distance   3.072e+08  # distance uncertain!
        Radius     2.681e+04
        AbsMag        -19.07
        Axis    [ -0.4068  -0.5408  -0.7362]
        Angle    155.4638
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5213"
}

Galaxy "IC 5214:MCG 5-52-67:ESO 467-47:IRAS 22199-2736"
{
        Type  "Sc"
        RA           22.3786
        Dec         -27.3556
        Distance    2.33e+08  # distance uncertain!
        Radius      3.39e+04
        AbsMag        -19.07
        Axis    [ -0.1064  -0.9827  -0.1518]
        Angle    146.1078
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5214"
}

Galaxy "IC 5215:ESO 109-3"
{
        Type  "S0"
        RA           22.4494
        Dec         -65.9828
        Distance   2.934e+08  # distance uncertain!
        Radius      2.56e+04
        AbsMag        -19.07
        Axis    [ -0.4910  -0.5315  -0.6902]
        Angle    150.6166
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5215"
}

Galaxy "IC 5218:ESO 146-26:IRAS 22248-6038"
{
        Type  "SBc"
        RA           22.4681
        Dec         -60.3947
        Distance   2.226e+08  # distance uncertain!
        Radius     4.208e+04
        AbsMag        -19.07
        Axis    [ -0.3573  -0.7735  -0.5234]
        Angle    131.7882
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5218"
}

Galaxy "IC 5219:ESO 109-4:AM 2225-660"
{
        Type  "S0"
        RA           22.4789
        Dec         -65.8936
        Distance   3.217e+08  # distance uncertain!
        Radius     3.743e+04
        AbsMag        -19.07
        Axis    [ -0.4743  -0.6522  -0.5913]
        Angle    138.3941
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5219"
}

Galaxy "IC 5220:ESO 146-25"
{
        Type  "Sc"
        RA           22.4672
        Dec         -59.7228
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.5508  -0.8049   0.2207]
        Angle    157.0929
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5220"
}

Galaxy "IC 5221:ESO 109-5:AM 2225-660"
{
        Type  "E0"
        RA           22.4825
        Dec         -65.9042
        Distance   5.249e+08  # distance uncertain!
        Radius     3.817e+04
        AbsMag        -20.13
        Axis    [ -0.5537  -0.3356  -0.7621]
        Angle    180.3635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5221"
}

Galaxy "IC 5222:ESO 109-6:FAIR 193:AM 2226-655"
{
        Type  "SBc"
        RA           22.4983
        Dec         -65.6614
        Distance   1.386e+08  # method: V
        Radius     3.831e+04
        AbsMag        -19.64
        Axis    [ -0.7697  -0.6384  -0.0049]
        Angle    148.7103
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5222"
}

Galaxy "IC 5223:UGC 12055:ZWG 404.19:NPM 1"
{
        Type  "Sc"
        RA           22.4956
        Dec           7.9892
        Distance   2.555e+08  # distance uncertain!
        Radius     3.717e+04
        AbsMag        -19.07
        Axis    [  0.1266  -0.8399  -0.5278]
        Angle    179.6420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5223"
}

Galaxy "IC 5224:ESO 289-31"
{
        Type  "Sb"
        RA           22.5083
        Dec         -45.9958
        Distance   7.221e+07  # method: V
        Radius     1.575e+04
        AbsMag        -17.33
        Axis    [ -0.4628  -0.6078   0.6453]
        Angle    176.7602
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5224"
}

Galaxy "IC 5225:NGC 7294:ESO 533-44:MCG 4-53-9"
{
        Type  "S0"
        RA           22.5353
        Dec         -25.3981
        Distance   4.465e+08  # method: V
        Radius     1.299e+05
        AbsMag        -22.18
        Axis    [ -0.3432  -0.8972  -0.2780]
        Angle    156.1895
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5225"
}

Galaxy "IC 5226:ESO 533-45:MCG 4-53-10:IRAS 22297-2555"
{
        Type  "SBc"
        RA           22.5417
        Dec         -25.6622
        Distance   2.475e+08  # method: V
        Radius      9.36e+04
        AbsMag           -20
        Axis    [ -0.4226  -0.7016  -0.5737]
        Angle    182.4046
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5226"
}

Galaxy "IC 5227:ESO 109-8:AM 2230-645:IRAS 22306-6457"
{
        Type  "SBb"
        RA           22.5675
        Dec         -64.6978
        Distance   1.433e+08  # method: V
        Radius     2.918e+04
        AbsMag        -19.21
        Axis    [ -0.6946  -0.3334   0.6374]
        Angle    169.9969
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5227"
}

Galaxy "IC 5229:ESO 147-1"
{
        Type  "Sc"
        RA           22.5806
        Dec         -61.3811
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.5541  -0.3769  -0.7423]
        Angle    180.6957
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5229"
}

Galaxy "IC 5230:ESO 147-2:IRAS 22323-6148"
{
        Type  "S0"
        RA           22.5944
        Dec         -61.5472
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.4499  -0.8178  -0.3588]
        Angle    134.8443
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5230"
}

Galaxy "IC 5231:MCG 4-53-4:MK 913:ZWG 474.7"
{
        Type  "E0"
        RA           22.5667
        Dec          23.3392
        Distance   4.366e+08  # distance uncertain!
        Radius     6.349e+04
        AbsMag        -20.13
        Axis    [ -0.5036  -0.8636  -0.0254]
        Angle    167.6471
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5231"
}

Galaxy "IC 5232:ESO 76-20"
{
        Type  "S0"
        RA           22.6272
        Dec         -68.8714
        Distance   2.555e+08  # distance uncertain!
        Radius     2.602e+04
        AbsMag        -19.07
        Axis    [ -0.3379  -0.6627  -0.6683]
        Angle    127.1572
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5232"
}

Galaxy "IC 5233:UGC 12106:MCG 4-53-7:ZWG 474.10"
{
        Type  "Sc"
        RA           22.6092
        Dec          25.7636
        Distance    3.19e+08  # method: V
        Radius      4.64e+04
        AbsMag        -20.25
        Axis    [ -0.1212  -0.9443  -0.3059]
        Angle    201.0865
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5233"
}

Galaxy "IC 5234:ESO 109-11"
{
        Type  "Sa"
        RA           22.6697
        Dec         -65.8247
        Distance    2.44e+08  # distance uncertain!
        Radius     3.549e+04
        AbsMag        -19.07
        Axis    [ -0.6553  -0.5995   0.4596]
        Angle    173.5753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5234"
}

Galaxy "IC 5235:ESO 109-13"
{
        Type  "Sa"
        RA           22.6903
        Dec         -66.5803
        Distance   1.065e+08  # distance uncertain!
        Radius          7747
        AbsMag        -19.07
        Axis    [ -0.8270  -0.5610  -0.0364]
        Angle    150.0604
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5235"
}

Galaxy "IC 5236:ESO 109-14"
{
        Type  "S0"
        RA           22.6917
        Dec         -66.6178
        Distance   2.555e+08  # distance uncertain!
        Radius     2.973e+04
        AbsMag        -19.07
        Axis    [ -0.6298  -0.7493  -0.2049]
        Angle    142.0317
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5236"
}

Galaxy "IC 5238:ESO 147-4:AM 2238-610"
{
        Type  "S0"
        RA           22.6914
        Dec         -60.7578
        Distance   3.072e+08  # distance uncertain!
        Radius     3.575e+04
        AbsMag        -19.07
        Axis    [ -0.5218  -0.8308  -0.1936]
        Angle    141.0523
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5238"
}

Galaxy "IC 5240:ESO 290-2:AM 2238-450:IRAS 22388-4501"
{
        Type  "SBa"
        RA           22.6978
        Dec         -44.7669
        Distance   7.008e+07  # method: V
        Radius     2.854e+04
        AbsMag        -19.06
        Axis    [ -0.6299  -0.7650   0.1340]
        Angle    150.8873
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5240"
}

Galaxy "IC 5241:UGC 12152:MCG 0-57-8:ZWG 378.16"
{
        Type  "SBc"
        RA           22.6939
        Dec           2.6397
        Distance   3.536e+08  # method: V
        Radius     5.143e+04
        AbsMag        -20.47
        Axis    [ -0.2536  -0.8867  -0.3865]
        Angle    187.4897
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5241"
}

Galaxy "IC 5242:UGC 12148:MCG 4-53-10:ZWG 474.20"
{
        Type  "Sb"
        RA           22.6875
        Dec          23.4069
        Distance   3.085e+08  # method: V
        Radius     3.589e+04
        AbsMag        -20.18
        Axis    [ -0.4223  -0.8405  -0.3394]
        Angle    227.0355
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5242"
}

Galaxy "IC 5243:UGC 12153:MCG 4-53-11:ZWG 474.21"
{
        Type  "Sc"
        RA           22.6900
        Dec          23.3756
        Distance   3.083e+08  # method: V
        Radius     3.139e+04
        AbsMag        -20.28
        Axis    [ -0.2014  -0.9503  -0.2374]
        Angle    195.2136
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5243"
}

Galaxy "IC 5244:ESO 109-15"
{
        Type  "Sb"
        RA           22.7369
        Dec         -64.0431
        Distance   1.507e+08  # method: V
        Radius     6.576e+04
        AbsMag        -19.62
        Axis    [ -0.5236  -0.5504   0.6504]
        Angle    198.5700
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5244"
}

Galaxy "IC 5245:ESO 109-16"
{
        Type  "Sa"
        RA           22.7489
        Dec         -65.3575
        Distance   2.226e+08  # distance uncertain!
        Radius      2.59e+04
        AbsMag        -19.07
        Axis    [ -0.4758  -0.4915  -0.7294]
        Angle    156.6255
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5245"
}

Galaxy "IC 5246:ESO 109-19:AM 2243-650"
{
        Type  "S0"
        RA           22.7775
        Dec         -64.8978
        Distance   1.851e+08  # distance uncertain!
        Radius     2.692e+04
        AbsMag        -19.07
        Axis    [ -0.7140  -0.4988   0.4912]
        Angle    168.9324
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5246"
}

Galaxy "IC 5247:ESO 109-20"
{
        Type  "S0"
        RA           22.7803
        Dec         -65.2736
        Distance   2.125e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -19.07
        Axis    [ -0.6167  -0.7205   0.3170]
        Angle    166.8531
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5247"
}

Galaxy "IC 5249:ESO 109-21:FGCE 1777:AM 2244-651"
{
        Type  "SBc"
        RA           22.7850
        Dec         -64.8306
        Distance   1.258e+08  # method: T-F
        Radius     6.589e+04
        AbsMag        -18.63
        Axis    [ -0.2756  -0.8144  -0.5108]
        Angle    121.2891
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5249"
}

Galaxy "IC 5250A:ESO 109-22:FAIR 197"
{
        Type  "S0"
        RA           22.7881
        Dec         -65.0606
        Distance   1.537e+08  # method: V
        Radius      6.93e+04
        AbsMag        -21.27
        Axis    [ -0.5308  -0.4215  -0.7353]
        Angle    167.6740
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5250A"
}

Galaxy "IC 5250B:ESO 109-22A"
{
        Type  "S0"
        RA           22.7892
        Dec         -65.0586
        Distance   5.854e+07  # distance uncertain!
        Radius     2.554e+04
        AbsMag        -19.07
        Axis    [ -0.5301  -0.4227  -0.7351]
        Angle    167.4945
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5250B"
}

Galaxy "IC 5252:ESO 76-25:IRAS 22446-6910"
{
        Type  "SBc"
        RA           22.8022
        Dec         -68.9028
        Distance   1.682e+08  # method: V
        Radius     2.936e+04
        AbsMag        -19.76
        Axis    [ -0.7028  -0.3573   0.6152]
        Angle    175.5831
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5252"
}

Galaxy "IC 5253:UGC 12180:ZWG 474.27"
{
        Type  "Sa"
        RA           22.7581
        Dec          21.8081
        Distance   3.174e+08  # method: T-F
        Radius     4.154e+04
        AbsMag        -19.44
        Axis    [  0.0345  -0.6617   0.7490]
        Angle    144.6124
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5253"
}

Galaxy "IC 5254:ZWG 453.5:KUG 2243+208"
{
        Type  "Sc"
        RA           22.7667
        Dec          21.1256
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.0412  -0.9876   0.1517]
        Angle    162.4050
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5254"
}

Galaxy "IC 5256:ESO 76-28:FAIR 611"
{
        Type  "SBc"
        RA           22.8292
        Dec         -68.6903
        Distance   3.873e+07  # method: V
        Radius          6197
        AbsMag        -15.77
        Axis    [ -0.4545  -0.7077  -0.5409]
        Angle    131.6447
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5256"
}

Galaxy "IC 5257:ESO 76-29:FAIR 199:IRAS 22489-6741"
{
        Type  "Sc"
        RA           22.8711
        Dec         -67.4192
        Distance   5.317e+08  # method: V
        Radius     5.413e+04
        AbsMag        -20.86
        Axis    [ -0.4619  -0.6527  -0.6005]
        Angle    136.8415
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5257"
}

Galaxy "IC 5258:UGC 12217:MCG 4-53-17:ZWG 474.33"
{
        Type  "S0"
        RA           22.8586
        Dec          23.0811
        Distance   3.355e+08  # method: V
        Radius     5.855e+04
        AbsMag        -20.96
        Axis    [ -0.1555  -0.9471   0.2807]
        Angle    150.7308
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5258"
}

Galaxy "IC 5261:ESO 603-26:MCG 4-54-1:IRAS 22517-2037"
{
        Type  "SBc"
        RA           22.9069
        Dec         -20.3633
        Distance   1.377e+08  # method: V
        Radius     3.004e+04
        AbsMag        -19.23
        Axis    [ -0.5443  -0.8200  -0.1773]
        Angle    164.1013
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5261"
}

Galaxy "IC 5262-1:ESO 406-20:MCG 6-50-9:IRAS 22525-3409"
{
        Type  "Sa"
        RA           22.9222
        Dec         -33.8881
        Distance   3.782e+08  # method: V
        Radius     7.151e+04
        AbsMag        -21.02
        Axis    [ -0.5434  -0.7223   0.4277]
        Angle    154.4753
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5262-1"
}

Galaxy "IC 5262-2:MCG 6-50-10:AM 2252-340"
{
        Type  "S0"
        RA           22.9228
        Dec         -33.8947
        Distance    2.33e+08  # distance uncertain!
        Radius     1.695e+04
        AbsMag        -19.07
        Axis    [ -0.3628  -0.6812  -0.6358]
        Angle    173.6215
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5262-2"
}

Galaxy "IC 5263:ESO 76-32:IRAS 22548-6919"
{
        Type  "SBa"
        RA           22.9703
        Dec         -69.0517
        Distance   1.746e+08  # method: V
        Radius     3.556e+04
        AbsMag        -19.44
        Axis    [ -0.5796  -0.6698   0.4642]
        Angle    185.1691
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5263"
}

Galaxy "IC 5264:ESO 406-29:MCG 6-50-14:IRAS 22540-3649"
{
        Type  "Sb"
        RA           22.9478
        Dec         -36.5544
        Distance   1.919e+08  # method: T-F
        Radius     6.698e+04
        AbsMag        -20.35
        Axis    [ -0.2732  -0.9582   0.0848]
        Angle    155.7599
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5264"
}

Galaxy "IC 5266:ESO 109-29:IRAS 22552-6523"
{
        Type  "Sb"
        RA           22.9725
        Dec         -65.1292
        Distance   1.392e+08  # method: V
        Radius      3.24e+04
        AbsMag        -18.45
        Axis    [ -0.4102  -0.8360  -0.3644]
        Angle    131.0308
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5266"
}

Galaxy "IC 5267:ESO 290-29:MCG 7-47-7:AM 2254-434"
{
        Type  "Sa"
        RA           22.9536
        Dec         -43.3958
        Distance    1.03e+08  # method: T-F
        Radius     7.791e+04
        AbsMag         -21.1
        Axis    [ -0.6657  -0.5801   0.4695]
        Angle    153.4490
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5267"
}

Galaxy "IC 5267A:ESO 290-26:MCG 7-47-5"
{
        Type  "SBc"
        RA           22.9322
        Dec         -43.4342
        Distance   5.771e+07  # method: V
        Radius     1.847e+04
        AbsMag        -17.44
        Axis    [ -0.4581  -0.5431   0.7037]
        Angle    177.0123
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5267A"
}

Galaxy "IC 5267B:ESO 290-27:MCG 7-47-6"
{
        Type  "S0"
        RA           22.9492
        Dec         -43.7603
        Distance    6.41e+07  # method: V
        Radius     1.678e+04
        AbsMag        -18.67
        Axis    [ -0.5244  -0.8185   0.2349]
        Angle    157.4004
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5267B"
}

Galaxy "IC 5269:ESO 406-32:MCG 6-50-17"
{
        Type  "S0"
        RA           22.9619
        Dec         -36.0267
        Distance   8.269e+07  # method: S
        Radius     2.044e+04
        AbsMag        -18.62
        Axis    [ -0.3849  -0.8951  -0.2249]
        Angle    153.3693
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5269"
}

Galaxy "IC 5269A:ESO 406-23:MCG 6-50-11A"
{
        Type  "Irr"
        RA           22.9319
        Dec         -36.3478
        Distance   1.367e+08  # method: T-F
        Radius     2.585e+04
        AbsMag        -18.91
        Axis    [ -0.4562  -0.8012  -0.3872]
        Angle    159.3158
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5269A"
}

Galaxy "IC 5269B:ESO 406-26:MCG 6-50-12"
{
        Type  "SBc"
        RA           22.9433
        Dec         -36.2500
        Distance   9.137e+07  # method: T-F
        Radius     5.316e+04
        AbsMag        -18.84
        Axis    [ -0.2892  -0.9360   0.2008]
        Angle    159.6993
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5269B"
}

Galaxy "IC 5269C:ESO 406-41:MCG 6-50-23:AM 2258-353"
{
        Type  "SBc"
        RA           23.0133
        Dec         -35.3697
        Distance   6.908e+07  # method: V
        Radius      2.11e+04
        AbsMag        -17.43
        Axis    [ -0.3951  -0.9147  -0.0853]
        Angle    154.2816
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5269C"
}

Galaxy "IC 5270:ESO 406-33:MCG 6-50-18:IRAS 22551-3607"
{
        Type  "SBc"
        RA           22.9653
        Dec         -35.8578
        Distance   6.315e+07  # method: T-F
        Radius     2.939e+04
        AbsMag        -18.43
        Axis    [ -0.2957  -0.9197   0.2584]
        Angle    162.0864
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5270"
}

Galaxy "IC 5271:ESO 406-34:MCG 6-50-19:IRAS 22552-3400"
{
        Type  "Sb"
        RA           22.9669
        Dec         -33.7422
        Distance   8.829e+07  # method: T-F
        Radius     3.339e+04
        AbsMag        -20.56
        Axis    [ -0.4044  -0.7562   0.5145]
        Angle    165.4149
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5271"
}

Galaxy "IC 5272:ESO 109-30:FAIR 200"
{
        Type  "Irr"
        RA           22.9919
        Dec         -65.1928
        Distance    1.51e+08  # method: V
        Radius     2.636e+04
        AbsMag        -18.53
        Axis    [ -0.5976  -0.6619  -0.4525]
        Angle    144.1859
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5272"
}

Galaxy "IC 5273:ESO 346-22:MCG 6-50-20:IRAS 22566-3758"
{
        Type  "SBc"
        RA           22.9906
        Dec         -37.7053
        Distance   6.709e+07  # method: T-F
        Radius     2.537e+04
        AbsMag        -19.67
        Axis    [ -0.5122  -0.8330  -0.2093]
        Angle    155.7777
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5273"
}

Galaxy "IC 5274:UGC 12275:ZWG 453.34:NPM 1"
{
        Type  "S0"
        RA           22.9742
        Dec          18.9192
        Distance    2.03e+08  # distance uncertain!
        Radius     2.362e+04
        AbsMag        -19.07
        Axis    [ -0.4653  -0.8074  -0.3626]
        Angle    227.5037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5274"
}

Galaxy "IC 5276:ZWG 453.35"
{
        Type  "Sa"
        RA           22.9775
        Dec          18.8200
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [  0.0394  -0.9860  -0.1621]
        Angle    181.1720
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5276"
}

Galaxy "IC 5277:ESO 109-31"
{
        Type  "E0"
        RA           23.0331
        Dec         -65.1981
        Distance   3.981e+08  # distance uncertain!
        Radius     2.895e+04
        AbsMag        -20.13
        Axis    [ -0.6122  -0.3231  -0.7217]
        Angle    180.8342
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5277"
}

Galaxy "IC 5278:MCG 1-58-14"
{
        Type  "Irr"
        RA           23.0042
        Dec          -8.1786
        Distance   5.012e+08  # distance uncertain!
        Radius     8.748e+04
        AbsMag        -20.13
        Axis    [ -0.1473  -0.9800   0.1341]
        Angle    161.7262
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5278"
}

Galaxy "IC 5279:ESO 77-1:AM 2259-692:IRAS 22597-6928"
{
        Type  "Sa"
        RA           23.0506
        Dec         -69.2100
        Distance   1.712e+08  # method: V
        Radius     3.237e+04
        AbsMag         -19.3
        Axis    [ -0.5754  -0.6547  -0.4902]
        Angle    139.9749
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5279"
}

Galaxy "IC 5280:ESO 109-33"
{
        Type  "Sb"
        RA           23.0639
        Dec         -65.2075
        Distance   2.226e+08  # distance uncertain!
        Radius     4.532e+04
        AbsMag        -19.07
        Axis    [ -0.3426  -0.7158  -0.6084]
        Angle    129.0888
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5280"
}

Galaxy "IC 5282:UGC 12325:MCG 4-54-19:ZWG 475.24"
{
        Type  "Irr"
        RA           23.0467
        Dec          21.8744
        Distance   3.245e+08  # method: T-F
        Radius     6.608e+04
        AbsMag        -19.99
        Axis    [  0.0046  -0.6083   0.7937]
        Angle    141.1084
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5282"
}

Galaxy "IC 5283:MCG 1-58-26:ZWG 405.27:ARP 298"
{
        Type  "Sc"
        RA           23.0547
        Dec           8.8939
        Distance   2.055e+08  # method: V
        Radius     2.092e+04
        AbsMag           -19
        Axis    [ -0.1669  -0.8310   0.5306]
        Angle    147.8107
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5283"
}

Galaxy "IC 5284:UGC 12364:MCG 3-58-34:ZWG 453.70"
{
        Type  "Sa"
        RA           23.1128
        Dec          19.1214
        Distance   1.604e+08  # method: V
        Radius     2.333e+04
        AbsMag        -18.56
        Axis    [  0.1345  -0.7772   0.6148]
        Angle    162.7143
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5284"
}

Galaxy "IC 5285:UGC 12365:MCG 4-54-26:ZWG 475.36"
{
        Type  "S0"
        RA           23.1161
        Dec          22.9369
        Distance   2.633e+08  # method: V
        Radius     6.128e+04
        AbsMag        -20.83
        Axis    [ -0.1602  -0.9547   0.2506]
        Angle    157.2699
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5285"
}

Galaxy "IC 5286:ESO 77-5"
{
        Type  "Sc"
        RA           23.1656
        Dec         -68.2533
        Distance   3.694e+08  # distance uncertain!
        Radius     4.835e+04
        AbsMag        -19.07
        Axis    [ -0.5787  -0.7681   0.2741]
        Angle    169.2238
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5286"
}

Galaxy "IC 5287:UGC 12393:MCG 0-59-3:ZWG 380.3"
{
        Type  "SBb"
        RA           23.1556
        Dec           0.7569
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.4664  -0.7426   0.4807]
        Angle    133.8279
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5287"
}

Galaxy "IC 5288:ESO 77-6:AM 2308-682:IRAS 23085-6821"
{
        Type  "S0"
        RA           23.1956
        Dec         -68.0942
        Distance   1.938e+08  # distance uncertain!
        Radius     3.101e+04
        AbsMag        -19.07
        Axis    [ -0.7515  -0.6199  -0.2259]
        Angle    148.9838
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5288"
}

Galaxy "IC 5289:ESO 407-8:MCG 5-54-20:AM 2308-324"
{
        Type  "Irr"
        RA           23.1881
        Dec         -32.4514
        Distance   2.512e+08  # distance uncertain!
        Radius     4.019e+04
        AbsMag        -20.13
        Axis    [ -0.4353  -0.7761  -0.4562]
        Angle    167.1186
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5289"
}

Galaxy "IC 5291:ZWG 406.22:KUG 2311+089"
{
        Type  "E0"
        RA           23.2275
        Dec           9.2417
        Distance   4.787e+08  # distance uncertain!
        Radius     2.089e+04
        AbsMag        -20.13
        Axis    [ -0.5413  -0.7378  -0.4033]
        Angle    225.6986
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5291"
}

Galaxy "IC 5292:ZWG 431.20:KUG 2311+134"
{
        Type  "S0"
        RA           23.2297
        Dec          13.6869
        Distance   2.676e+08  # distance uncertain!
        Radius     2.335e+04
        AbsMag        -19.07
        Axis    [ -0.5072  -0.7698  -0.3875]
        Angle    226.9486
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5292"
}

Galaxy "IC 5293:ZWG 475.49:NPM 1"
{
        Type  "S0"
        RA           23.2456
        Dec          25.1411
        Distance   2.555e+08  # distance uncertain!
        Radius     1.487e+04
        AbsMag        -19.07
        Axis    [  0.0161  -0.6081   0.7937]
        Angle    137.6218
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5293"
}

Galaxy "IC 5295:ZWG 475.52:NPM 1"
{
        Type  "E0"
        RA           23.2581
        Dec          25.1211
        Distance   3.524e+08  # method: V
        Radius     3.588e+04
        AbsMag        -19.47
        Axis    [ -0.4971  -0.8116  -0.3070]
        Angle    234.2204
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5295"
}

Galaxy "IC 5296:UGC 12460:MCG 4-54-37:ZWG 475.54"
{
        Type  "SBb"
        RA           23.2619
        Dec          25.0942
        Distance   3.613e+08  # method: T-F
        Radius     4.729e+04
        AbsMag        -19.82
        Axis    [ -0.0867  -0.9543  -0.2860]
        Angle    201.1277
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5296"
}

Galaxy "IC 5297:ZWG 475.55:NPM 1"
{
        Type  "E0"
        RA           23.2661
        Dec          25.0258
        Distance   4.571e+08  # distance uncertain!
        Radius     1.995e+04
        AbsMag        -20.13
        Axis    [ -0.4983  -0.8107  -0.3074]
        Angle    234.2481
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5297"
}

Galaxy "IC 5298:MCG 4-54-38:ZWG 475.56:IRAS 23135+2516"
{
        Type  "S0"
        RA           23.2667
        Dec          25.5572
        Distance    3.56e+08  # method: V
        Radius     3.624e+04
        AbsMag        -20.19
        Axis    [ -0.2257  -0.9294   0.2920]
        Angle    151.9912
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5298"
}

Galaxy "IC 5299"
{
        Type  "S0"
        RA           23.2719
        Dec          20.8558
        Distance   3.072e+08  # distance uncertain!
        Radius     1.787e+04
        AbsMag        -19.07
        Axis    [ -0.1636  -0.9036  -0.3959]
        Angle    208.6320
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5299"
}

Galaxy "IC 5300:ZWG 454.18"
{
        Type  "S0"
        RA           23.2761
        Dec          20.8286
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [ -0.0733  -0.8671   0.4927]
        Angle    149.8085
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5300"
}

Galaxy "IC 5301:ESO 77-12"
{
        Type  "S0"
        RA           23.3161
        Dec         -69.5625
        Distance   2.555e+08  # distance uncertain!
        Radius     5.203e+04
        AbsMag        -19.07
        Axis    [ -0.6840  -0.7270   0.0604]
        Angle    155.2022
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5301"
}

Galaxy "IC 5302:ESO 110-9"
{
        Type  "S0"
        RA           23.3267
        Dec         -64.5689
        Distance   2.125e+08  # distance uncertain!
        Radius      3.71e+04
        AbsMag        -19.07
        Axis    [ -0.3953  -0.8199  -0.4141]
        Angle    131.4037
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5302"
}

Galaxy "IC 5304:MCG 2-59-11:NPM 1"
{
        Type  "S0"
        RA           23.3144
        Dec         -10.2589
        Distance   1.612e+08  # distance uncertain!
        Radius     3.283e+04
        AbsMag        -19.07
        Axis    [ -0.2562  -0.8401  -0.4781]
        Angle    182.4793
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5304"
}

Galaxy "IC 5305:MCG 2-59-21:ZWG 431.37:NPM 1"
{
        Type  "S0"
        RA           23.3017
        Dec          10.3003
        Distance    2.44e+08  # distance uncertain!
        Radius      1.42e+04
        AbsMag        -19.07
        Axis    [ -0.2513  -0.7959   0.5508]
        Angle    141.3119
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5305"
}

Galaxy "IC 5306:MCG 2-59-22:ZWG 431.36"
{
        Type  "Sb"
        RA           23.3031
        Dec          10.2458
        Distance   2.802e+08  # distance uncertain!
        Radius     2.853e+04
        AbsMag        -19.07
        Axis    [ -0.0594  -0.9919   0.1122]
        Angle    170.6261
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5306"
}

Galaxy "IC 5307:NPM 1"
{
        Type  "E0"
        RA           23.3058
        Dec          10.2364
        Distance   9.121e+08  # distance uncertain!
        Radius     5.306e+04
        AbsMag        -20.13
        Axis    [ -0.6157  -0.7854  -0.0633]
        Angle    180.6396
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5307"
}

Galaxy "IC 5309:UGC 12498:MCG 1-59-42:ZWG 406.61"
{
        Type  "Sb"
        RA           23.3197
        Dec           8.1100
        Distance   1.827e+08  # method: T-F
        Radius      3.72e+04
        AbsMag        -19.24
        Axis    [ -0.0479  -0.9317  -0.3600]
        Angle    185.7258
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5309"
}

Galaxy "IC 5310:ESO 605-1:NPM 1"
{
        Type  "E0"
        RA           23.3464
        Dec         -22.1489
        Distance   5.012e+08  # distance uncertain!
        Radius     3.645e+04
        AbsMag        -20.13
        Axis    [ -0.6148  -0.5639  -0.5514]
        Angle    208.1778
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5310"
}

Galaxy "IC 5312:MCG 3-59-41:ZWG 454.47:KAZ 329"
{
        Type  "Sb"
        RA           23.3494
        Dec          19.3186
        Distance    2.33e+08  # distance uncertain!
        Radius     1.356e+04
        AbsMag        -19.07
        Axis    [ -0.1954  -0.9492   0.2465]
        Angle    160.8075
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5312"
}

Galaxy "IC 5314:MCG 3-59-42:ZWG 454.48"
{
        Type  "E0"
        RA           23.3522
        Dec          19.3119
        Distance   4.787e+08  # distance uncertain!
        Radius     3.481e+04
        AbsMag        -20.13
        Axis    [ -0.5253  -0.7796  -0.3410]
        Angle    232.0988
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5314"
}

Galaxy "IC 5315:UGC 12541:MCG 4-55-6:ZWG 476.16"
{
        Type  "E0"
        RA           23.3550
        Dec          25.3858
        Distance   1.855e+08  # method: V
        Radius     1.889e+04
        AbsMag        -19.17
        Axis    [ -0.4757  -0.7969   0.3724]
        Angle    119.7739
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5315"
}

Galaxy "IC 5316:NPM 1"
{
        Type  "E0"
        RA           23.3650
        Dec          21.2031
        Distance    6.31e+08  # distance uncertain!
        Radius     2.753e+04
        AbsMag        -20.13
        Axis    [ -0.5207  -0.7877  -0.3292]
        Angle    233.2002
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5316"
}

Galaxy "IC 5317:ZWG 454.58"
{
        Type  "S0"
        RA           23.3911
        Dec          21.1633
        Distance   2.226e+08  # distance uncertain!
        Radius     3.237e+04
        AbsMag        -19.07
        Axis    [ -0.1434  -0.9354  -0.3233]
        Angle    202.9615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5317"
}

Galaxy "IC 5319:NPM 1"
{
        Type  "E0"
        RA           23.4133
        Dec          13.9969
        Distance   5.755e+08  # distance uncertain!
        Radius     2.511e+04
        AbsMag        -20.13
        Axis    [ -0.5473  -0.7504  -0.3706]
        Angle    229.7615
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5319"
}

Galaxy "IC 5320:ESO 77-21:AM 2325-680"
{
        Type  "S0"
        RA           23.4725
        Dec         -67.7600
        Distance    2.33e+08  # distance uncertain!
        Radius     2.034e+04
        AbsMag        -19.07
        Axis    [ -0.8218  -0.3906   0.4148]
        Angle    162.7847
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5320"
}

Galaxy "IC 5321:ESO 605-7:MCG 3-59-9:IRAS 23237-1813"
{
        Type  "Sa"
        RA           23.4389
        Dec         -17.9567
        Distance   1.601e+08  # method: T-F
        Radius     3.027e+04
        AbsMag        -19.45
        Axis    [ -0.3597  -0.8998  -0.2470]
        Angle    170.6398
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5321"
}

Galaxy "IC 5322:ESO 77-22:AM 2325-680:IRAS 23255-6802"
{
        Type  "S0"
        RA           23.4750
        Dec         -67.7606
        Distance   2.226e+08  # distance uncertain!
        Radius     2.266e+04
        AbsMag        -19.07
        Axis    [ -0.7987  -0.6017   0.0044]
        Angle    154.9933
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5322"
}

Galaxy "IC 5323:ESO 77-19:AM 2325-680"
{
        Type  "SBa"
        RA           23.4603
        Dec         -67.8153
        Distance    1.75e+08  # method: V
        Radius     4.073e+04
        AbsMag        -19.65
        Axis    [ -0.7037  -0.3829   0.5985]
        Angle    175.8199
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5323"
}

Galaxy "IC 5324:ESO 77-20:AM 2325-680"
{
        Type  "S0"
        RA           23.4714
        Dec         -67.8211
        Distance   1.341e+08  # distance uncertain!
        Radius     2.146e+04
        AbsMag        -19.07
        Axis    [ -0.7675  -0.4823  -0.4224]
        Angle    156.1787
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5324"
}

Galaxy "IC 5325:ESO 347-18:MCG 7-48-4:AM 2325-413"
{
        Type  "SBc"
        RA           23.4786
        Dec         -41.3336
        Distance   5.703e+07  # method: V
        Radius     2.323e+04
        AbsMag        -19.41
        Axis    [ -0.5404  -0.6159  -0.5733]
        Angle    175.5126
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5325"
}

Galaxy "IC 5326:ESO 470-11:MCG 5-55-15"
{
        Type  "Sc"
        RA           23.4931
        Dec         -28.8314
        Distance    2.03e+08  # distance uncertain!
        Radius     2.952e+04
        AbsMag        -19.07
        Axis    [ -0.3856  -0.8380   0.3861]
        Angle    166.5771
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5326"
}

Galaxy "IC 5328:ESO 291-29:AM 2330-451"
{
        Type  "E4"
        RA           23.5544
        Dec         -45.0156
        Distance   1.234e+08  # method: S
        Radius     4.309e+04
        AbsMag        -20.59
        Axis    [ -0.8252  -0.4374  -0.3574]
        Angle    176.9139
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5328"
}

Galaxy "IC 5328A:ESO 291-28:AM 2330-451"
{
        Type  "SBa"
        RA           23.5536
        Dec         -45.0247
        Distance   1.773e+08  # method: V
        Radius     1.289e+04
        AbsMag        -18.98
        Axis    [ -0.4823  -0.6315   0.6072]
        Angle    177.5135
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5328A"
}

Galaxy "IC 5328B:ESO 291-30"
{
        Type  "SBc"
        RA           23.5661
        Dec         -45.2089
        Distance   1.465e+08  # method: T-F
        Radius     3.622e+04
        AbsMag        -18.26
        Axis    [ -0.4140  -0.5628   0.7154]
        Angle    188.2962
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5328B"
}

Galaxy "IC 5329:UGC 12660:MCG 3-60-2:ZWG 455.11"
{
        Type  "Sc"
        RA           23.5525
        Dec          21.2369
        Distance   2.426e+08  # method: V
        Radius     5.999e+04
        AbsMag        -18.86
        Axis    [  0.1854  -0.9056   0.3816]
        Angle    173.8534
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5329"
}

Galaxy "IC 5331:UGC 12662:MCG 3-60-3:ZWG 455.13"
{
        Type  "Sb"
        RA           23.5567
        Dec          21.1300
        Distance   2.459e+08  # method: V
        Radius     3.576e+04
        AbsMag        -19.29
        Axis    [  0.0856  -0.9181  -0.3870]
        Angle    195.1321
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5331"
}

Galaxy "IC 5332:ESO 408-9:MCG 6-51-12"
{
        Type  "SBc"
        RA           23.5742
        Dec         -36.1014
        Distance   1.989e+07  # method: V
        Radius     2.574e+04
        AbsMag        -17.82
        Axis    [ -0.6411  -0.4265   0.6380]
        Angle    145.7198
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5332"
}

Galaxy "IC 5334:MCG 1-60-8"
{
        Type  "Sb"
        RA           23.5767
        Dec          -4.5339
        Distance   8.449e+07  # method: V
        Radius     2.212e+04
        AbsMag        -17.97
        Axis    [ -0.1424  -0.8575   0.4943]
        Angle    167.8635
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5334"
}

Galaxy "IC 5335:ESO 77-25:AM 2332-674:IRAS 23329-6740"
{
        Type  "S0"
        RA           23.5964
        Dec         -67.3964
        Distance   2.226e+08  # distance uncertain!
        Radius     3.561e+04
        AbsMag        -19.07
        Axis    [ -0.6748  -0.5875   0.4466]
        Angle    177.2855
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5335"
}

Galaxy "IC 5336-1"
{
        Type  "S0"
        RA           23.6050
        Dec          21.0994
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.1410  -0.9791  -0.1465]
        Angle    193.0445
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5336-1"
}

Galaxy "IC 5336-2"
{
        Type  "S0"
        RA           23.6056
        Dec          21.0967
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.1054  -0.8675   0.4862]
        Angle    152.1246
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5336-2"
}

Galaxy "IC 5337:MCG 3-60-12:ZWG 455.25:KUG 2333+208"
{
        Type  "Sc"
        RA           23.6069
        Dec          21.1503
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.1472  -0.8458  -0.5128]
        Angle    193.9804
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5337"
}

Galaxy "IC 5338:UGC 12703:MCG 3-60-13:ZWG 455.26"
{
        Type  "E0"
        RA           23.6083
        Dec          21.1453
        Distance   7.378e+08  # method: V
        Radius     1.073e+05
        AbsMag        -21.77
        Axis    [ -0.5619  -0.8121  -0.1577]
        Angle    211.4559
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5338"
}

Galaxy "IC 5339:ESO 77-26"
{
        Type  "S0"
        RA           23.6347
        Dec         -68.4417
        Distance   5.541e+08  # method: V
        Radius     8.059e+04
        AbsMag        -21.55
        Axis    [ -0.8877  -0.3856   0.2515]
        Angle    158.4533
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5339"
}

Galaxy "IC 5341:MCG 4-55-35:ZWG 476.87:NPM 1"
{
        Type  "S0"
        RA           23.6406
        Dec          26.9856
        Distance   2.934e+08  # distance uncertain!
        Radius      1.28e+04
        AbsMag        -19.07
        Axis    [ -0.5057  -0.8086  -0.3006]
        Angle    237.8555
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5341"
}

Galaxy "IC 5342:MCG 4-55-39:ZWG 476.94:NPM 1"
{
        Type  "E0"
        RA           23.6439
        Dec          27.0119
        Distance   4.001e+08  # method: V
        Radius     1.746e+04
        AbsMag        -19.84
        Axis    [ -0.5292  -0.7985  -0.2871]
        Angle    238.7823
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5342"
}

Galaxy "IC 5343:ESO 536-15:MCG 4-55-19"
{
        Type  "Irr"
        RA           23.6561
        Dec         -22.4972
        Distance   3.802e+08  # distance uncertain!
        Radius     4.424e+04
        AbsMag        -20.13
        Axis    [ -0.3736  -0.7274  -0.5756]
        Angle    183.8240
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5343"
}

Galaxy "IC 5345:ESO 536-16:MCG 4-55-20:IRAS 23369-2241"
{
        Type  "Sc"
        RA           23.6589
        Dec         -22.4133
        Distance   1.688e+08  # distance uncertain!
        Radius     1.964e+04
        AbsMag        -19.07
        Axis    [ -0.4681  -0.6077   0.6415]
        Angle    153.4948
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5345"
}

Galaxy "IC 5346:ZWG 476.110:NPM 1"
{
        Type  "E0"
        RA           23.6850
        Dec          24.9503
        Distance   4.366e+08  # distance uncertain!
        Radius      2.54e+04
        AbsMag        -20.13
        Axis    [ -0.5243  -0.8380   0.1510]
        Angle    163.5395
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5346"
}

Galaxy "IC 5347:ZWG 476.113:NPM 1"
{
        Type  "E0"
        RA           23.6933
        Dec          24.8864
        Distance   4.366e+08  # distance uncertain!
        Radius     1.905e+04
        AbsMag        -20.13
        Axis    [ -0.4730  -0.7961   0.3775]
        Angle    126.6726
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5347"
}

Galaxy "IC 5349:ESO 471-11:MCG 5-56-5:DRCG 54-80"
{
        Type  "S0"
        RA           23.7728
        Dec         -28.0050
        Distance   3.287e+08  # method: V
        Radius     4.302e+04
        AbsMag        -19.82
        Axis    [ -0.1684  -0.9003  -0.4014]
        Angle    158.4788
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5349"
}

Galaxy "IC 5350:ESO 471-14:MCG 5-56-9:DRCG 54-77"
{
        Type  "S0"
        RA           23.7872
        Dec         -27.9581
        Distance    3.54e+08  # method: T-F
        Radius     4.634e+04
        AbsMag        -20.78
        Axis    [ -0.6503  -0.5219  -0.5520]
        Angle    204.6057
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5350"
}

Galaxy "IC 5351:MCG 1-60-32:HCG 97:"
{
        Type  "S0"
        RA           23.7883
        Dec          -2.3139
        Distance   2.666e+08  # method: V
        Radius     1.939e+04
        AbsMag        -19.86
        Axis    [ -0.2850  -0.5404   0.7917]
        Angle    138.5883
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5351"
}

Galaxy "IC 5352:HCG 97:"
{
        Type  "E0"
        RA           23.7886
        Dec          -2.2811
        Distance   7.245e+08  # distance uncertain!
        Radius     3.161e+04
        AbsMag        -20.13
        Axis    [ -0.6252  -0.6438  -0.4412]
        Angle    222.8915
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5352"
}

Galaxy "IC 5353:ESO 471-17:MCG 5-56-10:AM 2344-282"
{
        Type  "S0"
        RA           23.7911
        Dec         -28.1089
        Distance   3.576e+08  # method: V
        Radius     7.802e+04
        AbsMag         -21.4
        Axis    [ -0.4918  -0.6841   0.5386]
        Angle    162.1035
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5353"
}

Galaxy "IC 5354-1:ESO 471-16:MCG 5-56-11:DRCG 54-58"
{
        Type  "E0"
        RA           23.7911
        Dec         -28.1358
        Distance   3.573e+08  # method: V
        Radius     3.118e+04
        AbsMag         -20.2
        Axis    [ -0.8430  -0.5347  -0.0581]
        Angle    168.3457
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5354-1"
}

Galaxy "IC 5354-2:DRCG 54-57"
{
        Type  "Sa"
        RA           23.7914
        Dec         -28.1336
        Distance   3.369e+08  # distance uncertain!
        Radius      1.47e+04
        AbsMag        -19.07
        Axis    [ -0.4837  -0.8446  -0.2298]
        Angle    169.6978
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5354-2"
}

Galaxy "IC 5355:UGC 12781:MCG 5-56-6:ZWG 498.11"
{
        Type  "SBc"
        RA           23.7875
        Dec          32.7825
        Distance   2.058e+08  # method: T-F
        Radius     2.994e+04
        AbsMag         -19.6
        Axis    [ -0.0504  -0.9178  -0.3937]
        Angle    217.4662
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5355"
}

Galaxy "IC 5356:MCG 1-60-34:HCG 97:"
{
        Type  "Sa"
        RA           23.7897
        Dec          -2.3511
        Distance   2.556e+08  # method: V
        Radius     2.602e+04
        AbsMag        -19.47
        Axis    [ -0.2467  -0.9252  -0.2883]
        Angle    184.8167
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5356"
}

Galaxy "IC 5357:MCG 1-60-33:HCG 97A:"
{
        Type  "S0"
        RA           23.7897
        Dec          -2.3006
        Distance       3e+08  # method: V
        Radius     3.927e+04
        AbsMag        -20.82
        Axis    [ -0.2170  -0.7284   0.6499]
        Angle    158.6453
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5357"
}

Galaxy "IC 5358-1:ESO 471-19:MCG 5-56-13:DRCG 54-42"
{
        Type  "E0"
        RA           23.7958
        Dec         -28.1414
        Distance   3.793e+08  # method: V
        Radius     1.434e+05
        AbsMag        -21.83
        Axis    [ -0.8073  -0.4382   0.3953]
        Angle    138.5898
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5358-1"
}

Galaxy "IC 5358-2:DRCG 54-43"
{
        Type  "S0"
        RA           23.7953
        Dec         -28.1436
        Distance   2.676e+08  # distance uncertain!
        Radius     1.557e+04
        AbsMag        -19.07
        Axis    [ -0.4305  -0.8986   0.0846]
        Angle    166.7189
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5358-2"
}

Galaxy "IC 5359:MCG 1-60-36:HCG 97B:FGC 2535"
{
        Type  "Sc"
        RA           23.7936
        Dec          -2.3172
        Distance   2.984e+08  # method: V
        Radius     4.774e+04
        AbsMag        -19.31
        Axis    [ -0.0249  -0.8269   0.5617]
        Angle    177.3928
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5359"
}

Galaxy "IC 5362:IC 5363:ESO 471-26:MCG 5-56-23"
{
        Type  "S0"
        RA           23.8600
        Dec         -28.3653
        Distance    3.54e+08  # method: T-F
        Radius     6.693e+04
        AbsMag        -21.38
        Axis    [ -0.6580  -0.5156  -0.5489]
        Angle    204.6092
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5362"
}

Galaxy "IC 5364-1:ESO 471-47A:MCG 5-1-8:AM 2353-291"
{
        Type  "Sa"
        RA           23.9403
        Dec         -29.0236
        Distance    1.47e+08  # distance uncertain!
        Radius     1.497e+04
        AbsMag        -19.07
        Axis    [ -0.6666  -0.5075  -0.5460]
        Angle    204.4591
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5364-1"
}

Galaxy "IC 5364-2:ESO 471-47:MCG 5-1-7:AM 2353-291"
{
        Type  "S0"
        RA           23.9400
        Dec         -29.0236
        Distance    4.05e+08  # distance uncertain!
        Radius     4.123e+04
        AbsMag        -19.07
        Axis    [ -0.4572  -0.7355   0.5000]
        Angle    168.0368
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5364-2"
}

Galaxy "IC 5367:NPM 1"
{
        Type  "S0"
        RA           23.9772
        Dec          22.4497
        Distance   4.869e+08  # distance uncertain!
        Radius     3.541e+04
        AbsMag        -19.07
        Axis    [ -0.1129  -0.9826  -0.1477]
        Angle    197.6775
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5367"
}

Galaxy "IC 5369:ZWG 499.27:ZWG 498.55"
{
        Type  "S0"
        RA           23.9972
        Dec          32.7025
        Distance   4.426e+08  # method: V
        Radius     6.437e+04
        AbsMag        -20.46
        Axis    [  0.0625  -0.9843   0.1652]
        Angle    183.9028
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5369"
}

Galaxy "IC 5370:MCG 5-1-18:ZWG 499.28:ZWG 498.56"
{
        Type  "Sa"
        RA            0.0025
        Dec          32.7389
        Distance   2.125e+08  # distance uncertain!
        Radius     2.473e+04
        AbsMag        -19.07
        Axis    [  0.1733   0.9159  -0.3621]
        Angle    203.5016
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5370"
}

Galaxy "IC 5371:ZWG 499.30:ZWG 498.58:KAZ 234"
{
        Type  "S0"
        RA            0.0039
        Dec          32.8322
        Distance   2.934e+08  # distance uncertain!
        Radius     2.134e+04
        AbsMag        -19.07
        Axis    [  0.5201   0.8138   0.2591]
        Angle    115.4502
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5371"
}

Galaxy "IC 5372:NPM 1"
{
        Type  "S0"
        RA            0.0044
        Dec          32.7931
        Distance   2.676e+08  # distance uncertain!
        Radius     1.946e+04
        AbsMag        -19.07
        Axis    [  0.5203   0.8136   0.2593]
        Angle    115.4668
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5372"
}

Galaxy "IC 5373:MCG 5-1-19:ZWG 498.59:ZWG 499.31"
{
        Type  "Sb"
        RA            0.0081
        Dec          32.7819
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [ -0.2333   0.7342  -0.6376]
        Angle    193.7570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5373"
}

Galaxy "IC 5374:MCG 1-1-10:ZWG 408.8:KCPG 601A"
{
        Type  "Sc"
        RA            0.0178
        Dec           4.5000
        Distance   3.886e+08  # method: V
        Radius     3.957e+04
        AbsMag        -20.08
        Axis    [  0.4105   0.8384   0.3585]
        Angle    154.8420
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5374"
}

Galaxy "IC 5375:MCG 1-1-9:ZWG 408.9:KCPG 601B"
{
        Type  "Sc"
        RA            0.0178
        Dec           4.5419
        Distance    3.95e+08  # method: V
        Radius     5.745e+04
        AbsMag        -20.32
        Axis    [ -0.0198   0.8358   0.5487]
        Angle    176.0570
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5375"
}

Galaxy "IC 5376:UGC 12909:MCG 6-1-7:ZWG 517.13"
{
        Type  "Sb"
        RA            0.0219
        Dec          34.5258
        Distance   2.546e+08  # method: T-F
        Radius     7.406e+04
        AbsMag        -19.86
        Axis    [ -0.1744   0.8411   0.5120]
        Angle    151.7738
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5376"
}

Galaxy "IC 5377:UGC 12918:MCG 3-1-13:ZWG 456.17"
{
        Type  "Irr"
        RA            0.0347
        Dec          16.5906
        Distance   3.185e+07  # method: V
        Radius          4632
        AbsMag        -14.65
        Axis    [  0.0414   0.6180  -0.7851]
        Angle    213.7349
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5377"
}

Galaxy "IC 5378-1:UGC 1:MCG 3-1-15:ZWG 456.18"
{
        Type  "E0"
        RA            0.0436
        Dec          16.6442
        Distance   2.884e+08  # distance uncertain!
        Radius     4.615e+04
        AbsMag        -20.13
        Axis    [  0.6032   0.7231   0.3365]
        Angle    123.6506
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5378-1"
}

Galaxy "IC 5378-2:UGC 1:MCG 3-1-16:ZWG 456.18"
{
        Type  "SBc"
        RA            0.0436
        Dec          16.6517
        Distance    2.44e+08  # distance uncertain!
        Radius     5.679e+04
        AbsMag        -19.07
        Axis    [  0.1803   0.6238  -0.7605]
        Angle    233.8284
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5378-2"
}

Galaxy "IC 5379:MCG 3-1-17:ZWG 456.20:KUG 0000+163"
{
        Type  "Sc"
        RA            0.0444
        Dec          16.6008
        Distance   3.217e+08  # distance uncertain!
        Radius     1.872e+04
        AbsMag        -19.07
        Axis    [  0.0843   0.9956  -0.0409]
        Angle    174.1334
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5379"
}

Galaxy "IC 5380:ESO 78-11"
{
        Type  "Sb"
        RA            0.0469
        Dec         -66.1867
        Distance   2.676e+08  # distance uncertain!
        Radius     3.113e+04
        AbsMag        -19.07
        Axis    [  0.6735   0.5631  -0.4790]
        Angle    180.0812
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5380"
}

Galaxy "IC 5381:UGC 7:MCG 3-1-19:ZWG 456.23"
{
        Type  "Sb"
        RA            0.0531
        Dec          15.9653
        Distance    4.93e+08  # method: V
        Radius     9.321e+04
        AbsMag           -21
        Axis    [ -0.0852   0.9906   0.1071]
        Angle    171.0123
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5381"
}

Galaxy "IC 5382:ESO 78-13"
{
        Type  "Sc"
        RA            0.0572
        Dec         -65.1967
        Distance    2.44e+08  # distance uncertain!
        Radius     2.839e+04
        AbsMag        -19.07
        Axis    [  0.6123   0.4824   0.6264]
        Angle    199.7722
        InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=IC 5382"
}

# Milky Way
Galaxy "Milky Way"
{
        Type  "SBc"
        RA           17.7500
        Dec         -28.9300
        Distance   2.772e+04
        Radius         5e+04
        AbsMag         -20.5
        Axis    [  0.8660   0.4910   0.0910]
        Angle    176.0000
}

Galaxy "LMC:ESO 56-115"
{
        Type  "Irr"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=LMC"
        RA            5.3930
        Dec         -69.7561
        Distance     1.7e+05  # method: CPN
        Radius     1.596e+04
        AbsMag        -17.68
        Axis    [  0.1665   0.0257  -0.9857]
        Angle    148.7330
}

Galaxy "SMC:NGC 292"
{
        Type  "Irr"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=SMC"
        RA            0.8773
        Dec         -72.8003
        Distance     2.1e+05  # method: CN
        Radius          9659
        AbsMag        -16.34
        Axis    [  0.7544   0.6385   0.1526]
        Angle    205.8079
}

Galaxy "Sculptor:ESO 351-30"
{
        Type  "E0"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Sculptor"
        RA            1.0026
        Dec         -33.7092
        Distance     2.6e+05  # method: P
        Radius          1505
        AbsMag        -9.008
        Axis    [  0.8345   0.4152  -0.3623]
        Angle    201.9973
}

Galaxy "Fornax:ESO 356-4"
{
        Type  "E4"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Fornax"
        RA            2.6665
        Dec         -34.4492
        Distance     4.5e+05  # method: P
        Radius          1111
        AbsMag        -11.66
        Axis    [  0.9205   0.3593  -0.1536]
        Angle    170.5154
}

Galaxy "WLM:MCG 3-1-15"
{
        Type  "Irr"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=WLM"
        RA            0.0325
        Dec         -15.4503
        Distance       3e+06  # method: P
        Radius          5010
        AbsMag        -13.79
        Axis    [  0.1825   0.8321   0.5237]
        Angle    185.1302
}

Galaxy "Leo I:UGC 5470"
{
        Type  "E3"
        InfoURL  "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Leo I"
        RA           10.1410
        Dec          12.3075
        Distance     8.2e+05  # method: P
        Radius          1165
        AbsMag        -10.82
        Axis    [  0.5065  -0.0028  -0.8623]
        Angle     89.2096
}

